/**
 * @license
 * Copyright 2019 The Emscripten Authors
 * SPDX-License-Identifier: MIT
 */

// wasm2js.js - enough of a polyfill for the WebAssembly object so that we can load
// wasm2js code that way.

// Emit "var WebAssembly" if definitely using wasm2js. Otherwise, in MAYBE_WASM2JS
// mode, we can't use a "var" since it would prevent normal wasm from working.
/** @suppress{duplicate, const} */
var
WebAssembly = {
  // Note that we do not use closure quoting (this['buffer'], etc.) on these
  // functions, as they are just meant for internal use. In other words, this is
  // not a fully general polyfill.
  Memory: function(opts) {
    this.buffer = new ArrayBuffer(opts['initial'] * 65536);
  },

  Module: function(binary) {
    // TODO: use the binary and info somehow - right now the wasm2js output is embedded in
    // the main JS
  },

  Instance: function(module, info) {
    // TODO: use the module and info somehow - right now the wasm2js output is embedded in
    // the main JS
    // This will be replaced by the actual wasm2js code.
    this.exports = (
// EMSCRIPTEN_START_ASM
function instantiate(xb){function c(d){d.set=function(a,b){this[a]=b};d.get=function(a){return this[a]};return d}var e;var f=new ArrayBuffer(16);var g=new Int32Array(f);var h=new Float32Array(f);var i=new Float64Array(f);function j(k){return g[k]}function l(k,m){g[k]=m}function n(){return i[0]}function o(m){i[0]=m}function p(m){h[2]=m}function q(){return h[2]}function vb(wb){var r=wb.a;var s=r.buffer;r.grow=tb;var t=new Int8Array(s);var u=new Int16Array(s);var v=new Int32Array(s);var w=new Uint8Array(s);var x=new Uint16Array(s);var y=new Uint32Array(s);var z=new Float32Array(s);var A=new Float64Array(s);var B=Math.imul;var C=Math.fround;var D=Math.abs;var E=Math.clz32;var F=Math.min;var G=Math.max;var H=Math.floor;var I=Math.ceil;var J=Math.trunc;var K=Math.sqrt;var L=wb.abort;var M=NaN;var N=Infinity;var O=wb.b;var P=wb.c;var Q=wb.d;var R=wb.e;var S=wb.f;var T=wb.g;var U=wb.h;var V=wb.i;var W=wb.j;var X=wb.k;var Y=wb.l;var Z=wb.m;var _=wb.n;var $=wb.o;var aa=wb.p;var ba=wb.q;var ca=wb.r;var da=wb.s;var ea=wb.t;var fa=wb.u;var ga=wb.v;var ha=wb.w;var ia=wb.x;var ja=wb.y;var ka=wb.z;var la=wb.A;var ma=wb.B;var na=wb.C;var oa=wb.D;var pa=wb.E;var qa=wb.F;var ra=wb.G;var sa=wb.H;var ta=wb.I;var ua=wb.J;var va=wb.K;var wa=wb.L;var xa=wb.M;var ya=wb.N;var za=wb.O;var Aa=wb.P;var Ba=wb.Q;var Ca=wb.R;var Da=wb.S;var Ea=wb.T;var Fa=wb.U;var Ga=wb.V;var Ha=wb.W;var Ia=wb.X;var Ja=wb.Y;var Ka=wb.Z;var La=wb._;var Ma=wb.$;var Na=wb.aa;var Oa=wb.ba;var Pa=wb.ca;var Qa=wb.da;var Ra=wb.ea;var Sa=wb.fa;var Ta=wb.ga;var Ua=wb.ha;var Va=wb.ia;var Wa=wb.ja;var Xa=wb.ka;var Ya=wb.la;var Za=wb.ma;var _a=wb.na;var $a=wb.oa;var ab=wb.pa;var bb=wb.qa;var cb=wb.ra;var db=wb.sa;var eb=wb.ta;var fb=wb.ua;var gb=wb.va;var hb=wb.wa;var ib=wb.xa;var jb=5702096;var kb=0;var lb=0;var mb=0;
// EMSCRIPTEN_START_FUNCS
function Baa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,A=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,M=0,N=0,Q=0,R=0,T=0,V=0,W=0,X=0,Y=0,Z=C(0),_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=C(0),ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=C(0),La=0;$=jb-32|0;jb=$;ma=a+24604|0;f=ma;a:{if(!v[f+16>>2]){break a}g=v[f+20>>2];if(g>>>0>4|!(1<<g&22)){break a}f=v[f+28>>2];if(f>>>0>4){break a}e=23>>>f&1}if(!e){g=$+16|0;sL(g,5157,9025,207);f=jb-160|0;jb=f;e=Ub(f+120|0,13762);v[113382]=0;U(6,f+104|0,1,13354);i=v[113382];v[113382]=0;b:{c:{d:{e:{f:{if((i|0)!=1){v[113382]=0;U(3,f+136|0,e|0,f+104|0);i=v[113382];v[113382]=0;if((i|0)==1){break f}v[113382]=0;fa(2086,f+88|0,g|0,1,9612,f+136|0);g=v[113382];v[113382]=0;if((g|0)==1){break e}yb(f+136|0);yb(f+104|0);break b}a=P()|0;O()|0;break c}a=P()|0;O()|0;break d}a=P()|0;O()|0;yb(f+136|0)}yb(f+104|0)}yb(e);S(a|0);L()}yb(e);jb=f+160|0}f=v[a+480208>>2];g:{if(!b|f&512){break g}ua=a+8204|0;va=a+1074332|0;wa=a+393352|0;ia=a+12|0;na=a+1304392|0;q=v[a+1074380>>2];while(1){h:{if(q){break h}Q=a;e=f|512;i:{if(f&256){break i}q=0;s=jb-32|0;jb=s;V=jb-16|0;jb=V;A=a;g=A;e=g+1074392|0;f=v[e>>2]+1|0;v[e>>2]=f;j:{k:{if(wl(g)>>>0>f>>>0){break k}j=g+1074984|0;n=g+1074312|0;i=g+1304360|0;l=g+484344|0;k=g+484360|0;m=g+1074438|0;p=g+1074424|0;I=g+480210|0;while(1){h=0;l:{if(!v[g+1074396>>2]){break l}h=0;if(!(w[I|0]&8)){break l}h=v[g+480180>>2]==1}m:{if(v[g+480180>>2]!=2|(w[I|0]&8?0:v[g+1074428>>2])){break m}f=0;if(!x[g+480188>>1]){break m}while(1){v[(g+B(f,896)|0)+1075788>>2]=0;f=f+1|0;if(f>>>0<x[g+480188>>1]){continue}break}}v[g+1074400>>2]=0;v[g+1074392>>2]=0;v[g+1074396>>2]=0;v[g+1074424>>2]=v[g+1074428>>2];e=x[g+1074440>>1];u[g+1074438>>1]=e;n:{o:{p:{if(!(w[g+480208|0]&32)){f=g;q:{if(oc(Vb(k))>>>0>e>>>0){e=x[rc(Vb(k),x[m>>1])>>1];break q}e=65535}u[f+1074436>>1]=e;r:{if(Ae(l)>>>0<=(e&65535)>>>0){break r}if(qh(Zb(l,x[g+1074436>>1]))){break r}u[g+1074436>>1]=65534}if(x[g+1074436>>1]>=Ae(l)>>>0){while(1){s:{t:{u:{v:{if(x[g+1074436>>1]!=65535){f=x[m>>1];if(oc(Vb(k))>>>0>f>>>0){break v}}e=x[Vb(k)+28>>1];if(e){break t}f=x[m>>1];if(oc(Vb(k))>>>0<f>>>0){break u}f=x[m>>1];if(!f){break u}while(1){e=f;f=e-1|0;if(!f){break u}if(x[rc(Vb(k),f)>>1]!=65535){continue}break}break t}f=x[m>>1]+1|0;u[m>>1]=f;break s}e=0}u[g+1074438>>1]=e;v[g+480208>>2]=v[g+480208>>2]&-524289;w:{if(oc(Vb(k))>>>0<=(e&65535)>>>0){break w}while(1){if(x[rc(Vb(k),x[m>>1])>>1]!=65534){break w}f=x[m>>1]+1|0;u[m>>1]=f;if(oc(Vb(k))>>>0>(f&65535)>>>0){continue}break}}f=x[m>>1];x:{if(oc(Vb(k))>>>0<=f>>>0){break x}if(!pp(Vb(k),x[m>>1])){break x}f=x[m>>1];break s}tk(i,1);break p}e=g;y:{if(oc(Vb(k))>>>0>(f&65535)>>>0){f=x[rc(Vb(k),x[m>>1])>>1];break y}f=65535}u[e+1074436>>1]=f;z:{if(Ae(l)>>>0<=(f&65535)>>>0){break z}if(qh(Zb(l,x[g+1074436>>1]))){break z}u[g+1074436>>1]=65534}if(x[g+1074436>>1]>=Ae(l)>>>0){continue}break}}u[g+1074440>>1]=x[g+1074438>>1]}e=0;if(!jg(l,x[g+1074436>>1])){break j}if(y[g+1074424>>2]>=y[Zb(l,x[g+1074436>>1])+12>>2]){v[p>>2]=0}o=(w[g+480208|0]&32)>>>5&v[g+480272>>2]!=-1;if(h){f=i+12|0;if(id(f)){f=-1}else{f=v[pj(f)>>2]}f=(f|0)==v[p>>2]}else{f=1}if(o|!f){break n}if(!NM(i,x[m>>1],v[p>>2],1)){break n}f=v[g+480272>>2];if(f){if((f|0)>0){v[g+480272>>2]=f-1}tk(i,1);QK(i,x[m>>1],v[p>>2]);break n}if(!(w[I|0]&64)){break o}if(!MM(i,m,p,1)){u[g+1074438>>1]=0;u[g+1074440>>1]=0;v[g+1074424>>2]=0;v[g+1074428>>2]=0;f=w[k+16|0];if((f|0)>=(Mh(k)-1|0)){op(k,0);tk(i,1);break j}op(k,w[k+16|0]+1&255);tk(i,1)}f=0;while(1){mn((g+B(f,896)|0)+1074984|0,7,g,f&65535,1024);f=f+1|0;if((f|0)!=256){continue}break}kL(g);v[g+1074416>>2]=v[g+480196>>2];v[g+1074420>>2]=v[g+480204>>2];v[g+1074444>>2]=v[g+480200>>2];u[g+1074440>>1]=x[g+1074438>>1];v[g+1074428>>2]=v[g+1074424>>2];e=i;o=oc(Vb(k));f=x[g+1074438>>1];if(o>>>0>f>>>0){Ia=g,Ja=x[rc(Vb(k),x[g+1074438>>1])>>1],u[Ia+1074436>>1]=Ja;f=x[g+1074438>>1]}QK(e,f&65535,v[g+1074424>>2]);if(jg(l,x[g+1074436>>1])){break n}}e=0;break j}tk(i,1);break j}f=v[g+1074424>>2]+1|0;v[g+1074428>>2]=f;A:{if(f>>>0<y[Zb(l,x[g+1074436>>1])+12>>2]){break A}if(!(w[g+480208|0]&32)){u[g+1074440>>1]=x[g+1074438>>1]+1}v[g+1074428>>2]=0;f=V+8|0;Fb(f,n,63);if(!Cb(f)){break A}f=v[g+1074432>>2];v[g+1074432>>2]=0;v[g+1074428>>2]=f}e=Bf(Zb(l,x[g+1074436>>1]),v[g+1074424>>2],0);f=x[g+480188>>1];if(f){F=(g+B(f,896)|0)+1074984|0;f=j;while(1){o=V+8|0;Fb(o,n,82);B:{if(!Cb(o)|w[f+827|0]!=1){break B}o=w[e+3|0];if((o|0)!=2&(o|0)!=3){break B}Ia=f,Ja=eg(g,w[f+822|0],v[f+768>>2],v[f+704>>2]),v[Ia+700>>2]=Ja}o=V+8|0;Fb(o,n,91);C:{if(!Cb(o)){break C}if(Wf(e)){break C}if(!Wf(f+810|0)|w[f+813|0]!=19){break C}o=w[f+815|0];if((o&240)!=208|y[g+1074416>>2]>(o&15)>>>0){break C}Ia=f,Ja=eg(g,w[f+810|0],v[f+768>>2],0),v[Ia+700>>2]=Ja}o=V+8|0;Fb(o,n,92);D:{if(!Cb(o)){break D}Fb(V,n,5);if(Cb(V)|v[g+1074416>>2]!=1|w[f+813|0]!=17){break D}v[g+1074420>>2]=B(w[f+815|0],1e4)}o=w[e|0]|w[e+1|0]<<8|(w[e+2|0]<<16|w[e+3|0]<<24);t[f+810|0]=o;t[f+811|0]=o>>>8;t[f+812|0]=o>>>16;t[f+813|0]=o>>>24;o=w[e+4|0]|w[e+5|0]<<8;t[f+814|0]=o;t[f+815|0]=o>>>8;o=v[f+676>>2];v[f+20>>2]=v[f+672>>2];v[f+24>>2]=o;v[f+88>>2]=v[f+88>>2]&-393217;o=V+8|0;Fb(o,n,21);if(!Cb(o)){t[f+851|0]=0}v[f+884>>2]=0;t[f+827|0]=0;e=e+6|0;f=f+896|0;if((F|0)!=(f|0)){continue}break}}f=g;o=g+1074412|0;E:{F:{e=g+484344|0;if(In(e,x[g+1074436>>1])){if(tM(Zb(e,x[f+1074436>>1]))){break F}}v[f+1074408>>2]=v[f+480216>>2];f=v[f+480220>>2];break E}Ia=f+1074408|0,Ja=v[Zb(e,x[f+1074436>>1])+16>>2],v[Ia>>2]=Ja;f=v[Zb(e,x[f+1074436>>1])+20>>2]}v[o>>2]=f;if(!h){break k}f=v[g+1074416>>2]+1|0;v[g+1074392>>2]=f;if(wl(g)>>>0<=f>>>0){continue}break}}if(!v[g+1074416>>2]){v[g+1074416>>2]=1}e=v[g+480208>>2];f=g;G:{H:{if(v[g+1074392>>2]){v[g+480208>>2]=e&-4097;if(v[g+480180>>2]&1048580|(w[g+480210|0]&32?0:v[g+480180>>2]==1)){break G}if(y[g+1074392>>2]>=wl(g)>>>0|y[g+1074392>>2]%(v[g+1074400>>2]+v[g+1074416>>2]>>>0)){break G}e=v[g+480208>>2];break H}e=e&-528385}v[f+480208>>2]=e|4096}J=0;E=jb-32|0;jb=E;H=g+1074312|0;I=-1;R=65535;I:{if(!x[g+480188>>1]){o=-1;break I}ea=g+1075821|0;X=g+1304392|0;ga=g+1074376|0;aa=g+480209|0;ha=g+480210|0;o=-1;while(1){r=g+B(J,896)|0;k=r+1075799|0;i=w[k|0];n=r+1075797|0;l=w[n|0];p=r+1075798|0;N=w[p|0];ba=r+1075796|0;m=w[ba|0];_=r+1075795|0;h=w[_|0];f=v[g+1074392>>2];e=v[g+1074400>>2];G=v[g+1074416>>2];W=r+1075794|0;j=Is(W);F=r+1075856|0;t[F|0]=v[g+480208>>2]>>>12&1|w[F|0]&254;Y=(f>>>0)%(e+G>>>0)|0;f=w[W|0];if((f|0)==252){f=w[_|0];e=sy(W);G=Gs(W);J:{if((f-1&255)>>>0>249){break J}f=v[(g+B(f,160)|0)+906140>>2];if(!f){break J}nb[v[v[f>>2]+44>>2]](f,e,C(C(G>>>0)*C(.0010010009864345193)))}f=w[W|0]}K:{if(z[r+1075868>>2]==C(0)|l?(f&255)!=251:0){break K}f=v[g+480208>>2]&4096;L:{if(!f){e=w[r+1075878|0];break L}e=w[_|0];t[r+1075878|0]=e}if((e-1&255)>>>0>249){break K}e=(g+B(e&255,160)|0)+906140|0;if(!v[e>>2]){break K}M:{if(!f){f=x[r+1075876>>1];break M}f=Ds(w[ba|0],w[p|0]);u[r+1075876>>1]=f;Z=C(C(Ds(w[n|0],w[k|0])>>>0)*C(.0010010009864345193));z[r+1075872>>2]=Z;k=v[e>>2];Ia=r+1075868|0,Ka=C(C(Z-C(nb[v[v[k>>2]+48>>2]](k,f)))/C(wl(g)>>>0)),z[Ia>>2]=Ka}k=v[g+1074392>>2];n=wl(g);e=v[e>>2];p=f;f=(n|0)==(k+1|0);nb[v[v[e>>2]+(f?44:100)>>2]](e,p,z[(f?r+1075872|0:r+1075868|0)>>2])}n=r+1074984|0;N:{O:{P:{Q:{R:{if(!nM(w[W|0])){if(w[aa|0]&16){break R}break Q}f=jb-16|0;jb=f;u[f+12>>1]=0;v[f+8>>2]=0;Oh(f+8|0);e=x[f+12>>1];t[n+814|0]=e;t[n+815|0]=e>>>8;e=v[f+8>>2];t[n+810|0]=e;t[n+811|0]=e>>>8;t[n+812|0]=e>>>16;t[n+813|0]=e>>>24;jb=f+16|0;h=0;m=0;N=0;l=0;i=0;j=0;if(!(w[aa|0]&16)){break Q}e=0;break O}if(!h){h=0;break P}v[r+1075768>>2]=0;break P}fM(g,n)}f=l;if((f|0)==33){f=E+24|0;Fb(f,H,30);e=i>>>4|0;my(g,J&65535,e+(i&15)|0,Cb(f));l=33;break O}e=0;if((l-19&255)>>>0>1){break O}S:{if(!(!(v[g+480180>>2]&16777250)|i)){i=w[r+1075837|0];break S}t[r+1075837|0]=i}k=i&240;if((k|0)==208){f=i&15;if(!f){if(v[g+480180>>2]&16777248){e=1;break O}if(v[g+480180>>2]!=2){break O}break N}T:{if(f>>>0<v[g+1074400>>2]+v[g+1074416>>2]>>>0){break T}e=E+24|0;Fb(e,H,14);if(!Cb(e)){break T}if(!h){break N}t[r+1075809|0]=h;break N}e=f;break O}if(!(w[aa|0]&16)){break O}U:{if(!(!((k|0)==96&(f|0)==19)&((k|0)!=176|(f|0)!=20))){f=E+24|0;Fb(f,H,77);if(Ia=Cb(f),Ja=0,La=v[(g+(J<<5)|0)+480280>>2]&1024,La?Ia:Ja){break O}f=g;k=n;G=0;T=jb-16|0;jb=T;M=i&15;V:{W:{if(M){p=w[k+861|0];X:{if(p){p=p-1|0;t[k+861|0]=p;if(p&255){break X}p=T+8|0;Fb(p,f+1074312|0,16);if(!Cb(p)){p=-1;if(v[f+480180>>2]!=2){break V}}v[k+804>>2]=v[f+1074424>>2]+1;break W}p=T+8|0;Fb(p,f+1074312|0,17);if(!(Cb(p)|v[f+480180>>2]&3|!x[f+480188>>1])){p=f+1074984|0;while(1){if(w[p+861|0]?(k|0)!=(p|0):0){break W}p=p+896|0;G=G+1|0;if(x[f+480188>>1]>(G&65535)>>>0){continue}break}}t[k+861|0]=M}p=v[k+804>>2];v[f+1074432>>2]=p;break V}v[k+804>>2]=v[f+1074424>>2]}p=-1}jb=T+16|0;f=p;Y:{if((f|0)==-1){f=o;break Y}Z:{if((I|0)!=-1){k=E+24|0;Fb(k,H,68);I=Cb(k)?f:I;break Z}I=-1}k=E+24|0;Fb(k,H,103);R=Cb(k)?-1:R}if(!x[g+480188>>1]|v[g+480180>>2]!=2){break U}p=r+1075845|0;o=r+1075788|0;k=0;while(1){G=g+B(k,896)|0;v[G+1075788>>2]=v[o>>2];t[G+1075845|0]=w[p|0];k=k+1|0;if(k>>>0<x[g+480188>>1]){continue}break}break U}if((k|0)!=224|(v[g+1074396>>2]?v[g+480180>>2]&16777250:0)){break O}f=i&15;if(f?0:v[g+480180>>2]&2){break O}v[g+1074396>>2]=f+1;break O}o=f}M=l;f=e;e=v[g+480180>>2]==16&(l|0)==19&(i&240)==208;K=e?0:f;_:{if(!K|w[W|0]!=255|w[ba|0]!=2){break _}f=E+24|0;Fb(f,H,74);if(!Cb(f)){break _}t[ba|0]=0}f=v[g+1074392>>2];k=E+24|0;Fb(k,H,72);$:{if(Cb(k)){T=0;if(K>>>0>=y[g+1074416>>2]){break $}}k=E+24|0;Fb(k,H,88);T=(K|0)==(Y|0)|(f|0)==(K|0);if(!(!Cb(k)|!K)){break $}T=(f|0)==(K|0)}f=E+24|0;Fb(f,H,44);if(Cb(f)){t[F|0]=w[F|0]&254|(K|0)==(Y|0)}da=i&15;k=e?da|144:i;f=E+24|0;Fb(f,H,66);j=(!K|Cb(f)^-1)&j;aa:{ba:{if(!(v[g+1074392>>2]|(!(w[ha|0]&32)|!h))){v[r+1075644>>2]=0;if(T){break ba}if(!Kh(n)){break aa}t[r+1075809|0]=h;if(x[g+480190>>1]<h>>>0){break aa}f=g+B(h,104)|0;v[r+1075672>>2]=x[f+484410>>1];v[r+1075752>>2]=t[f+484417|0];break aa}if(!T){break aa}}i=w[W|0];if(h){t[r+1075809|0]=h}ca:{da:{if(!Xd(i)){break da}f=E+24|0;Fb(f,H,67);if(!Cb(f)){break da}e=v[r+1075756>>2];ea:{if(!h|j){break ea}fa:{if(x[g+480192>>1]){f=65535;if(x[g+480192>>1]<h>>>0){break fa}p=v[(g+(h<<2)|0)+900380>>2];if(!p){break fa}f=x[_c(p+236|0,i-1|0)>>1];break fa}f=h}f=f&65535;if(f>>>0>x[g+480190>>1]){break ea}e=t[yp(g,f)+36|0]}i=(e+i|0)-12>>>0>119?0:i;break ca}if(!(v[g+480180>>2]&25165856)|!x[g+480192>>1]){break ca}f=i;if(f){f=Xd(f)}else{f=1}if(!f){break ca}e=h;if(!e){e=w[r+1075810|0]}if(!e|(v[(g+(e<<2)|0)+900380>>2]?x[g+480192>>1]>=e>>>0:0)){break ca}i=0;h=0}if(!((M|0)!=25|k)){f=E+24|0;Fb(f,H,55);f=Cb(f);h=f?0:h;i=f?0:i}e=E+24|0;Fb(e,H,65);f=(h|0)!=0;p=!i;e=Cb(e);Y=1;ga:{if(v[g+480180>>2]&16777248){break ga}F=E+24|0;Fb(F,H,107);if(Cb(F)){break ga}F=E+16|0;Fb(F,H,85);Y=0;if(!Cb(F)){break ga}if(Kh(n)){break ga}Y=1;F=v[r+1075088>>2];if(!F){break ga}Y=Be(F)^1}F=f&p;G=e&f;ha:{ia:{ja:{ka:{la:{ma:{if(!(v[g+480180>>2]&1048580)){break ma}na:{if((i|0)!=255){break na}if(!(!((m|0)==1|h)&(M|0)!=13)){f=E+24|0;Fb(f,H,55);if(Cb(f)){break na}}f=v[r+1075640>>2];if(t[f+60|0]&1?f:0){break na}v[r+1075672>>2]=0;f=r+1075072|0;v[f>>2]=v[f>>2]|2097152;oa:{if(!(v[g+480208>>2]&4096)){break oa}e=E+24|0;Fb(e,H,86);if(!Cb(e)){break oa}v[f>>2]=v[f>>2]|4096}h=0;i=0;f=0;e=0;p=0;F=1;if(G){break ia}break ha}f=E+24|0;Fb(f,H,59);if(!Cb(f)|v[g+480208>>2]&4096){break ma}pa:{if(!i){i=w[r+1075803|0]-w[r+1075756|0]|0;break pa}if(i>>>0>250){Y=0;G=1;i=0;break pa}qa:{if(h){break qa}f=E+24|0;Fb(f,H,98);if(!Cb(f)){break qa}h=0;break pa}Y=1;G=1}f=i;j=0;break la}f=0;p=0;if(!F){break ka}}e=E+24|0;Fb(e,H,65);if(!Cb(e)){break ja}i=f;p=1}e=i;f=p;F=1;if(G){break ia}break ha}i=f;f=1;F=G}ra:{sa:{if(!x[g+480192>>1]){if(x[g+480190>>1]<h>>>0){break ra}e=(g+B(h,104)|0)+484380|0;break sa}e=v[r+1075088>>2];if(!e){break ra}}ta:{if(u[e+34>>1]<0){break ta}if(v[g+480180>>2]==2){if(!Be(e)){break ta}}v[r+1075672>>2]=x[e+30>>1]}if(!F){break ra}$s(n,x[e+28>>1],g)}e=i;p=f}f=E+24|0;Fb(f,H,71);if(!(!Cb(f)|!h)){t[r+1075843|0]=32}ua:{if(!x[g+480192>>1]){break ua}f=E+24|0;Fb(f,H,100);if(!Cb(f)|!h){break ua}if(Xd(e&255)){break ua}f=v[g+480208>>2];va:{if(j){if(f&8){break va}break ua}if(!(f&4)){break ua}}zl(n);v[r+1075680>>2]=65536;f=r+1075072|0;v[f>>2]=v[f>>2]|2097152}if(p){f=E+24|0;Fb(f,H,11);wa:{if(!Cb(f)&v[g+480180>>2]!=268435456){break wa}f=E+24|0;Fb(f,H,87);i=0;if(Cb(f)){i=Kh(n)^1}xa:{if(x[g+480192>>1]){if(x[g+480192>>1]<h>>>0){break wa}if(v[r+1075640>>2]!=v[(g+(h<<2)|0)+900380>>2]|i){break xa}break wa}if((v[r+1075088>>2]!=((g+B(h,104)|0)+484380|0)|i)!=1|h>>>0>3999){break wa}}e=w[r+1075803|0]}ya:{if(!x[g+480192>>1]|!(v[g+480180>>2]&1048588)){break ya}zl(n);t[r+1075822|0]=0;v[r+1075764>>2]=0;v[r+1075680>>2]=65536;f=r+1075072|0;v[f>>2]=v[f>>2]&-2101249|2097152;i=E+24|0;Fb(i,H,86);if(!Cb(i)){break ya}v[f>>2]=v[f>>2]&-2049}h=Y?h:0}p=e&255;za:{if(p>>>0<251){break za}f=E+24|0;Fb(f,H,50);Aa:{if(!Cb(f)|!h){break Aa}if(x[g+480192>>1]){if(x[g+480192>>1]<h>>>0){break Aa}f=(g+(h<<2)|0)+900380|0;if(!v[f>>2]){break Aa}i=r+1075805|0;if(!Xd(w[i|0])){break Aa}f=x[_c(v[f>>2]+236|0,w[i|0]-1|0)>>1]}else{f=h}f=f&65535;if(!f|f>>>0>x[g+480190>>1]){break Aa}f=g+B(f,104)|0;if(u[f+484414>>1]<0){break Aa}v[r+1075672>>2]=x[f+484410>>1]}f=E+24|0;Fb(f,H,100);if(Ia=Cb(f),Ja=0,La=v[g+480208>>2]&4,La?Ia:Ja){break za}h=0}Ba:{if(!Xd(p)){break Ba}t[r+1075808|0]=e;t[r+1075805|0]=e;if(!j){iM(g,J&65535,h,p,0)}e=r+1075780|0;f=u[e>>1];if(f){v[r+1075676>>2]=(f&32767)-1;if((f|0)<0){f=r+1075072|0;v[f>>2]=v[f>>2]|256}u[e>>1]=0}f=r+1075801|0;e=w[f|0];if(e){t[r+1075842|0]=e-1;t[f|0]=0}f=r+1075802|0;e=w[f|0];if(!e){break Ba}t[r+1075841|0]=e-1;t[f|0]=0}Ca:{Da:{Ea:{Fa:{Ga:{if(h){f=r+1075088|0;i=v[f>>2];gp(g,n,h,j,1,1);e=v[f>>2];Ha:{if(!e|!(w[e+35|0]&2)){break Ha}if(!qd(X)){break Ha}Hy(v[X>>2],J&65535,v[f>>2]+68|0)}Ia:{Ja:{if(v[g+480180>>2]==1){if(!j){break Ja}e=E+24|0;Fb(e,H,85);if(!Cb(e)){break Ja}break Ia}e=E+24|0;Fb(e,H,50);if(!Cb(e)){break Ja}if(!Xd(p)){break Ia}}t[r+1075809|0]=0}e=E+24|0;Fb(e,H,42);if(Cb(e)){if(!Xd(p)|(i|0)==v[f>>2]){break Fa}break Ga}if(!(!(v[g+480180>>2]&16777248)|(i|0)==v[f>>2])){e=0;if(Xd(p)){break Ea}}e=E+24|0;Fb(e,H,107);Ka:{if(!Cb(e)|(i|0)==v[f>>2]){break Ka}La:{if(!j){if(Xd(p)){break La}}f=r+1075060|0;if(y[f>>2]>=y[n+4>>2]){break Ka}v[f>>2]=0;break Fa}j=0}f=E+24|0;Fb(f,H,85);if(!Cb(f)){break Fa}if(!Kh(n)){break Ga}break Fa}if(!p){e=j;break Ca}f=0;F=r+1075809|0;Ma:{if(!w[F|0]){break Ma}if(!Xd(p)){break Ma}gp(g,n,w[F|0],j,!(v[r+1075088>>2]?1:v[r+1075640>>2]),!(v[g+480180>>2]&1048580));t[F|0]=0;f=1}e=j;break Da}v[n>>2]=0;v[n+4>>2]=0}e=j}f=0;if(!p){break Ca}}i=r+1075088|0;j=v[i>>2];Na:{if(!j|!(w[j+35|0]&2)){break Na}if(!qd(X)){break Na}if(!f){if(jM(v[X>>2],J&65535)){break Na}}Hy(v[X>>2],J&65535,v[i>>2]+68|0)}f=J&65535;Es(g,n,p,e,!(v[g+480180>>2]&1048580),0,f);if(!(!e|(!(v[g+480180>>2]&1048580)|!h))){i=r+1075072|0;v[i>>2]=v[i>>2]|2097152;zl(n);t[r+1075822|0]=0;v[r+1075764>>2]=0}if(!(v[r+1075072>>2]&512)){break Ca}if(!qd(X)){break Ca}if(p>>>0<=253){if((p|0)!=253){break Ca}i=E+24|0;Fb(i,H,99);if(Cb(i)){break Ca}}uk(v[X>>2],f)}Oa:{Pa:{switch(m-1|0){case 0:N=N>>>0<64?N:64;v[r+1075672>>2]=N<<2;f=r+1075072|0;v[f>>2]=v[f>>2]|2097152;break Oa;case 1:break Pa;default:break Oa}}Al(g,n,N,6)}if(x[g+480192>>1]){NK(g,J&65535)}j=e}f=E+24|0;Fb(f,H,77);if(Ia=Cb(f),Ja=0,La=v[(g+(J<<5)|0)+480280>>2]&1024,La?Ia:Ja){break N}f=v[g+1074392>>2];e=E+24|0;Fb(e,H,75);Qa:{Ra:{Sa:{h=f>>>0>=K>>>0;Ta:{if(!Cb(e)|!K){break Ta}e=v[g+1074392>>2];if(!e){break Sa}h=1;if((e|0)!=(K|0)){break Ta}h=!w[_|0]&(m|0)!=11}f=m;if(!h|f>>>0<3){break Sa}if((f|0)==11){f=E+24|0;ry(f,g,W,K);e=w[jc(f)|0];Zm(g,n,v[f>>2]);if(e){break Qa}h=11;break Ra}e=E+24|0;Fb(e,H,62);Ua:{if(!(!Cb(e)|N)){N=0;h=0;Va:{switch(f-8|0){case 0:break Ua;case 1:break Va;default:break Ra}}if(w[aa|0]&16){break Ra}v[r+1075676>>2]=0;break Ra}e=E+24|0;Fb(e,H,41);if(Cb(e)){break Ua}if(N){t[r+1075838|0]=N;break Ua}N=w[r+1075838|0]}h=m;Wa:{switch(f-3|0){case 0:case 1:Xa:{Ya:{if(N){break Ya}e=E+24|0;Fb(e,H,41);if(!Cb(e)){break Ya}N=w[r+1075838|0];if(N){break Xa}N=0;break Sa}t[r+1075838|0]=N}an(g,n,((f|0)==3?N<<4:N)&255);break Sa;case 2:if((K|0)!=v[g+1074392>>2]){f=E+24|0;Fb(f,H,41);h=5;if(Cb(f)){break Ra}}f=E+24|0;Fb(f,H,41);ep(g,n,N,Cb(f));h=5;break Ra;case 3:if((K|0)!=v[g+1074392>>2]){f=E+24|0;Fb(f,H,41);h=6;if(Cb(f)){break Ra}}f=E+24|0;Fb(f,H,41);dp(g,n,N,Cb(f));h=6;break Ra;case 4:f=E+24|0;Fb(f,H,53);if(Cb(f)){t[r+1075827|0]=N&15;h=7;break Ra}qk(n,N<<4);h=7;break Ra;case 5:qk(n,N);h=8;break Ra;case 6:f=E+24|0;Fb(f,H,62);ly(g,n,N,Cb(f)^1);h=9;break Ra;case 7:f=E+24|0;Fb(f,H,62);ly(g,n,N<<4&240,Cb(f)^1);h=10;break Ra;case 9:h=12;f=E+24|0;Fb(f,H,12);eM(g,J&65535,N<<2&252,Cb(f));break Ra;case 10:f=E+24|0;Fb(f,H,12);dM(g,J&65535,N<<2&252,Cb(f));h=13;break Ra;case 12:break Wa;default:break Ra}}h=15;if(!T){break Ra}f=v[r+1075088>>2];if(!f|N>>>0>9){break Ra}Za:{if(!N){e=v[r+1075648>>2];break Za}e=v[(f+(N<<2)|0)- -64>>2];v[r+1075648>>2]=e}fp(g,n,e);break Ra}h=m}_a:{$a:{ab:{bb:{cb:{db:{eb:{fb:{gb:{hb:{ib:{jb:{kb:{lb:{mb:{nb:{ob:{pb:{qb:{rb:{sb:{tb:{ub:{vb:{wb:{switch(M-1|0){case 12:if(!(w[g+480209|0]&16)){break Qa}f=g+B(J,896)|0;v[f+1075672>>2]=k>>>0<64?k<<2:256;f=f+1075072|0;v[f>>2]=v[f>>2]|2097152;break Qa;case 1:if(!k&(v[g+480180>>2]&1)){break vb}eM(g,J&65535,k,0);break Qa;case 2:if(!k&(v[g+480180>>2]&1)){break vb}dM(g,J&65535,k,0);break Qa;case 10:if(!k&v[g+480180>>2]==1){break vb}an(g,n,k);break Qa;case 3:Zm(g,n,k);break Qa;case 5:if(!(!k&v[g+480180>>2]==1)){an(g,n,k)}Zm(g,n,0);break Qa;case 4:qk(n,k);break Qa;case 6:if(!(!k&v[g+480180>>2]==1)){an(g,n,k)}qk(n,0);break Qa;case 15:if(!(w[g+480209|0]&16)){break Qa}break _a;case 16:f=E+24|0;Fb(f,H,5);if(Cb(f)){if(!(w[g+480209|0]&16)){break Qa}if(k){break _a}break Qa}k=hp(g,x[g+1074436>>1],v[g+1074424>>2],J&65535,0);xb:{if(!(v[g+480180>>2]&16777250)){break xb}if(k){t[(g+B(J,896)|0)+1075839|0]=k;break xb}k=w[(g+B(J,896)|0)+1075839|0]}v[E+24>>2]=B(k,1e4);tc(E+24|0,B(v[v[g+8>>2]+24>>2],1e4));e=jb-16|0;jb=e;h=v[E+24>>2];v[e+8>>2]=h;f=g;i=v[g+8>>2];yb:{if(h>>>0>=(v[g+480180>>2]&16392?1e4:32e4)>>>0){h=v[f+480208>>2];Fb(e,f+1074312|0,92);if((Cb(e)|0)==((h&4096)>>>12|0)){break yb}v[e>>2]=B(v[i+24>>2],1e4);Ia=f+1074420|0,Ja=v[Lb(e+8|0,e)>>2],v[Ia>>2]=Ja;break yb}if(w[f+480209|0]&16){break yb}j=f+1074420|0;h=(h>>>0)/1e4|0;m=B(h&15,1e4);v[j>>2]=v[j>>2]+((h&240)==16?m:0-m|0);h=v[i+20>>2];i=v[i+24>>2];Fb(e,f+1074312|0,8);Vn(j,B(h,1e4),Cb(e)?255e4:B(i,1e4))}jb=e+16|0;break Qa;case 9:if(!T|(v[g+480180>>2]==4?j:0)){break Qa}t[E+24|0]=0;f=hp(g,x[g+1074436>>1],v[g+1074424>>2],J&65535,E+24|0);e=g;i=n;if(!w[E+24|0]){j=(g+B(J,896)|0)+1075648|0;h=f<<8;zb:{if(h){v[j>>2]=h;break zb}h=v[j>>2]}f=(w[(g+B(J,896)|0)+1075840|0]<<16)+h|0}fp(e,i,f);break Qa;case 40:if(!T){break Qa}e=qma(v[(g+B(J,896)|0)+1075060>>2],0,k,0);f=mb;j=f>>>8|0;fp(g,n,dd((f&255)<<24|e>>>8,j));break Qa;case 0:if(v[g+1074392>>2]){break Qa}f=g+B(J,896)|0;Ab:{if(w[f+1075803|0]?v[f+1075684>>2]:0){break Ab}f=v[f+1075640>>2];if(f){if(zi(f)){break Ab}}f=E+24|0;Fb(f,H,13);if(Cb(f)){break Ab}if(v[g+480180>>2]&16777248){break Qa}}if(!k){k=0;if(v[g+480180>>2]&5){break Qa}t[(g+B(J,896)|0)+1075811|0]=1;break Qa}f=g+B(J,896)|0;t[f+1075812|0]=k;t[f+1075811|0]=1;break Qa;case 14:if(v[g+480180>>2]&1048580){k=k&240?k:x[(g+B(J,896)|0)+1075784>>1]&240|k;if(!(k&15)){k=x[(g+B(J,896)|0)+1075784>>1]&15|k}k=k|256}f=E+24|0;Fb(f,H,23);if(Cb(f)){Bb:{if(!k){e=x[(g+B(J,896)|0)+1075784>>1];break Bb}e=k&255;u[(g+B(J,896)|0)+1075784>>1]=e}ky(g,J&65535,e<<16>>16,(h&255)==15?N+1|0:0);break Qa}Cb:{if(k){u[(g+B(J,896)|0)+1075784>>1]=k&255;break Cb}k=u[(g+B(J,896)|0)+1075784>>1]}ky(g,J&65535,k,(h&255)==15?N+1|0:0);break Qa;case 39:break bb;case 38:break cb;case 34:case 35:case 36:case 37:break db;case 13:break eb;case 11:break fb;case 29:break gb;case 26:break hb;case 21:break ib;case 20:break jb;case 27:break kb;case 24:break lb;case 19:break mb;case 18:break nb;case 25:break ob;case 7:break pb;case 28:break qb;case 8:break rb;case 23:break sb;case 22:break tb;case 17:break wb;default:break Qa}}if(!(w[g+480209|0]&16)){break Qa}f=E+24|0;Fb(f,H,22);Db:{Eb:{if(Cb(f)){if(!k){k=0;break Eb}if(w[g+480208|0]&4){break Eb}f=k&240?k-16|0:k;k=f-((f&15)!=0)|0;t[(g+B(J,896)|0)+1075844|0]=k;break Eb}f=E+24|0;Fb(f,H,71);if(!Cb(f)){break Db}}f=(g+B(J,896)|0)+1075843|0;t[f|0]=w[f|0]|128}f=g+B(J,896)|0;t[f+1075811|0]=18;if(k){break ub}}k=0;break Qa}t[f+1075844|0]=k;break Qa}if(!(w[g+480209|0]&16)){break Qa}k=k<<!(v[g+480180>>2]&59593760);if(k>>>0<=128){v[g+1074444>>2]=k<<1;break Qa}if(v[g+480180>>2]&16777250){break Qa}v[g+1074444>>2]=256;break Qa}f=E+24|0;Fb(f,H,9);if(Cb(f)){cM(g,k,(g+B(J,896)|0)+1075821|0);break Qa}cM(g,k,ea);break Qa}if(!(w[g+480209|0]&16)){break Qa}Al(g,n,k,8);break Qa}ly(g,n,k,1);break Qa}vM(n,k);break Qa}wM(g,n,k);break Qa}f=k;i=f&15;e=g;h=J&65535;m=e+B(h,896)|0;j=m+1074984|0;Fb:{Gb:{switch(f>>>4|0){case 0:if(!x[e+480188>>1]){break Fb}i=(f&1)<<14;f=0;while(1){h=(e+B(f,896)|0)+1075072|0;v[h>>2]=(i|v[h>>2]&-16385)^16384;f=f+1|0;if(f>>>0<x[e+480188>>1]){continue}break};break Fb;case 1:if(!(v[e+480180>>2]&1048580?1:i)){break Fb}WL(e,j,i);break Fb;case 2:if(!(v[e+480180>>2]&1048580?1:i)){break Fb}UL(e,j,i);break Fb;case 3:f=m+1075072|0;v[f>>2]=v[f>>2]&-1048577|((i|0)!=0)<<20;break Fb;case 4:t[m+1075826|0]=f&7;break Fb;case 5:if(!(w[e+480209|0]&16)){break Fb}if(v[e+480180>>2]&69206025){f=e+B(h,896)|0;j=f+1075752|0;v[j>>2]=i<<28>>24;i=f+1075684|0;if(!v[i>>2]){break Fb}if(!Wf(f+1075794|0)){break Fb}f=e+B(h,896)|0;Ia=i,Ja=eg(e,w[f+1075803|0],v[j>>2],v[f+1075688>>2]),v[Ia>>2]=Ja;break Fb}m=v[e+480180>>2];j=Wf((e+B(h,896)|0)+1075794|0);if((m|0)==16){if(!j){break Fb}f=e+B(h,896)|0;j=v[f+1075088>>2];if(!j){break Fb}t[j+37|0]=i;v[f+1075752>>2]=i;f=f+1075684|0;if(!v[f>>2]){break Fb}j=f;f=e+B(h,896)|0;Ia=j,Ja=eg(e,w[f+1075803|0],i,v[f+1075688>>2]),v[Ia>>2]=Ja;break Fb}if(!j){break Fb}i=e+B(h,896)|0;f=f<<28>>24^-128;v[i+1075752>>2]=f;h=i+1075684|0;if(!v[h>>2]){break Fb}Ia=h,Ja=eg(e,w[i+1075803|0],f,v[i+1075688>>2]),v[Ia>>2]=Ja;break Fb;case 7:t[m+1075829|0]=f&7;break Fb;case 8:if(!(w[e+480209|0]&16)){break Fb}Al(e,j,i,4);break Fb;case 9:ky(e,h,i,0);break Fb;case 10:if(!(v[e+480180>>2]&1048580?1:i)){break Fb}ep(e,j,i,0);break Fb;case 11:if(!(v[e+480180>>2]&1048580?1:i)){break Fb}dp(e,j,i,0);break Fb;case 12:my(e,h,i,0);break Fb;case 15:break Gb;default:break Fb}}if(v[e+480180>>2]==1){t[(e+B(h,896)|0)+1075850|0]=i;if(!(w[e+480209|0]&16)){break Fb}fM(e,j);break Fb}t[(e+B(h,896)|0)+1075848|0]=i}break Qa}e=E+24|0;Fb(e,H,78);f=g;h=J&65535;if(!(!Cb(e)|k)){k=w[(g+B(J,896)|0)+1075812|0]}bM(f,h,k);break Qa}f=E+24|0;Fb(f,H,55);if(Cb(f)){if(v[g+1074392>>2]!=(k|0)){break Qa}f=v[(g+B(J,896)|0)+1075640>>2];if(t[f+60|0]&1?f:0){break $a}if(!(!(w[ba|0]?1:w[_|0])|k)){f=(g+B(J,896)|0)+1075072|0;v[f>>2]=v[f>>2]|4096;break $a}f=g+B(J,896)|0;v[f+1075672>>2]=0;f=f+1075072|0;v[f>>2]=v[f>>2]|2097152;break $a}if(w[g+480209|0]&16){break $a}break Qa}f=(k&240)-16>>>4|0;if(f>>>0>9){break Qa}if(!(1<<f&880)){if(!f){break ab}if((f|0)!=1){break Qa}aM(g,n,k&15);break Qa}f=E+24|0;Fb(f,H,58);if(Cb(f)){break Qa}bM(g,J&65535,k);break Qa}if(!(w[g+480209|0]&16)|k>>>0>64){break Qa}f=g+B(J,896)|0;v[f+1075744>>2]=k;f=f+1075072|0;v[f>>2]=v[f>>2]|2097152;break Qa}i=g;f=n;e=k;Hb:{if(e){t[f+836|0]=e;break Hb}e=w[f+836|0]}m=e&255;h=f;l=e&240;j=e&15;Ib:{Jb:{if(!(!l|(j|0)!=15)){if(!(w[i+480209|0]&16)){break Ib}e=m>>>4|0;break Jb}p=v[i+480208>>2]&4096;if(!(!j|(l|0)!=240)){if(!p){break Ib}e=0-j|0;break Jb}if(p){break Ib}if(j){e=0-j|0;if(!(v[i+480180>>2]&25690144)|!l){break Jb}break Ib}if((e&255)>>>0<16){break Ib}e=m>>>4|0}Ia=h,Ja=Yb(e+v[f+760>>2]|0,0,64),v[Ia+760>>2]=Ja}break Qa}uM(n,k);break Qa}if(!(w[g+480209|0]&16)){break Qa}f=g+B(J,896)|0;v[f+1075712>>2]=k;e=E+24|0;Fb(e,H,60);if(Ia=0,Ja=Cb(e),La=w[f+1075708|0]&4,La?Ia:Ja){break Qa}f=g+B(J,896)|0;v[f+1075736>>2]=k;v[f+1075724>>2]=k;break Qa}v[g+1074432>>2]=0;R=hp(g,x[g+1074436>>1],v[g+1074424>>2],J&65535,0);I=v[g+480180>>2]&5?(I|0)!=-1?0:I:I;break Qa}f=xM(g,ga,J&65535,k);if((f|0)==-1){break Qa}R=w[g+480208|0]&32?x[g+1074438>>1]:R;I=f;break Qa}f=n;i=k;e=g;if(w[e+480209|0]&16){h=i&240;if(h){t[f+869|0]=h>>>4}i=i&15;if(i){t[f+870|0]=i}t[f+868|0]=w[f+869|0]}m=(l|0)==35|(l|0)==37;l=(l-37&255)>>>0<2;p=f;Kb:{Lb:{if(v[e+480180>>2]==32768){j=w[f+869|0];h=16;if((j|0)==16){break Lb}h=j;if(w[e+480209|0]&16){break Lb}break Kb}if(w[e+480209|0]&16){break Kb}i=w[f+868|0]-1|0;t[f+868|0]=i;if(i&255){break Kb}h=w[f+869|0]}t[p+868|0]=h;i=w[f+870|0];i=m?i:0-i|0;Mb:{if(tj(f)){v[f+876>>2]=v[f+876>>2]+B(i,v[v[v[f+656>>2]+44>>2]+36>>2]);break Mb}Ia=f,Ja=eg(e,zs(e,v[f+700>>2],0,v[f+704>>2])+i|0,0,v[f+704>>2]),v[Ia+700>>2]=Ja}if(!l){break Kb}v[f>>2]=0;v[f+4>>2]=0}break Qa}sM(E,n,k);break Qa}if(v[g+1074392>>2]|da>>>0>1|k>>>0>47){break Qa}f=(k&240)==16;h=f?0:J;e=(f?x[g+480188>>1]-1|0:J)&65535;if((h&65535)>>>0>e>>>0){break Qa}f=((da|0)==1)<<26;while(1){i=h&65535;j=(g+(i<<5)|0)+480280|0;v[j>>2]=f|v[j>>2]&-67108865;i=(g+B(i,896)|0)+1075072|0;v[i>>2]=f|v[i>>2]&-67108865;h=h+1|0;if(e>>>0>=(h&65535)>>>0){continue}break}break Qa}$L(g,n,k&15);break Qa}$m(g,n);break Qa}yM(g,ga,k)}f=E+24|0;Fb(f,H,78);if(!(!Cb(f)|!k)){f=k&255;t[n+860|0]=f;t[n+832|0]=f;t[n+831|0]=f;t[n+829|0]=f;t[n+828|0]=f;u[n+800>>1]=f;t[n+846|0]=f>>>4;t[n+847|0]=f<<2&60}f=w[_|0];if(!f){break N}t[r+1075810|0]=f}J=J+1|0;if(J>>>0<x[g+480188>>1]){continue}break}}Nb:{if(!(w[g+480209|0]&16)){break Nb}Ob:{if(!((I|0)!=-1|(R&65535)!=65535)){if((o|0)==-1){break Nb}break Ob}Pb:{if((o|0)==-1){break Pb}f=E+24|0;Fb(f,H,68);if(Cb(f)){break Pb}f=E+16|0;Fb(f,H,103);if(Ia=Cb(f),Ja=0,La=(R&65535)!=65535,La?Ia:Ja){break Pb}f=E+8|0;Fb(f,H,49);if(!Cb(f)|(R&65535)==65535){break Ob}}v[g+480208>>2]=v[g+480208>>2]|524288;h=(R&65535)!=65535?R:x[g+1074438>>1]+1|0;f=g+484360|0;if(oc(Vb(f))>>>0<=(h&65535)>>>0){h=x[Vb(f)+28>>1]}e=(I|0)==-1?0:I;Qb:{if(x[g+1074438>>1]==(h&65535)){break Qb}f=E+24|0;Fb(f,H,26);if(Cb(f)){break Qb}f=E+16|0;Fb(f,H,68);if(Cb(f)|v[g+480180>>2]==1|!x[g+480188>>1]){break Qb}f=0;while(1){t[(g+B(f,896)|0)+1075845|0]=0;f=f+1|0;if(f>>>0<x[g+480188>>1]){continue}break}}v[g+1074428>>2]=e;if(w[g+480208|0]&32){break Nb}u[g+1074440>>1]=h;break Nb}u[g+1074440>>1]=x[g+1074438>>1];v[g+1074428>>2]=o;Rb:{if(!v[g+1074396>>2]){break Rb}if(v[g+480180>>2]==32){f=E+24|0;Fb(f,H,103);if(Cb(f)){break Rb}}if(v[g+480180>>2]==2){break Rb}v[g+1074428>>2]=v[g+1074428>>2]+1}if(y[Zb(g+484344|0,x[g+1074436>>1])+12>>2]<=o>>>0){v[g+1074428>>2]=0;u[g+1074440>>1]=x[g+1074440>>1]+1}h=x[g+1074438>>1];f=jb-16|0;jb=f;e=f+8|0;j=g+1304360|0;i=j+12|0;IN(e,i);KM(f,i);Sb:{if(!Xs(e,f)|(o|0)==-1){break Sb}while(1){g=jb-16|0;jb=g;e=f+8|0;v[g+8>>2]=v[e+4>>2];k=v[JM(g+8|0)>>2];jb=g+16|0;g=v[k>>2];Ay(j,h,g,0);k=v[e+4>>2];v[f>>2]=v[e>>2];v[f+4>>2]=k;JM(e+4|0);KM(f,i);if(!Xs(e,f)){break Sb}if((g|0)!=(o|0)){continue}break}}jb=f+16|0}jb=E+32|0;e=1}jb=V+16|0;Tb:{if(!e|!v[A+1074420>>2]){break Tb}f=gL(A,A+1074376|0);v[A+1074380>>2]=f;v[A+1074404>>2]=f;e=Ed(x[A+480188>>1],1,31);H=A+1074332|0;Ub:{if(w[H+37|0]){f=v[A+24628>>2];if((f|0)>=129){f=((B(f-128|0,e+4|0)|0)/16|0)+128|0}I=B(v[A+480228>>2],f)>>>6|0;break Ub}I=v[A+480228>>2]}I=w[H+37|0]?(I<<7>>>0)/w[(e>>>1|0)+26e3|0]|0:I;u[A+480212>>1]=0;T=A+1304392|0;G=A+1074312|0;N=A+480210|0;R=A+480209|0;K=0;while(1){o=A+B(K,896)|0;F=o+1075072|0;Vb:{if(!(v[F>>2]&4096)|(v[o+1075008>>2]|(v[o+1075004>>2]|v[o+1075680>>2]))){break Vb}f=s+24|0;Fb(f,G,64);if(Cb(f)){break Vb}v[o+1075060>>2]=0;f=o+1075076|0;v[f>>2]=0;v[f+4>>2]=0}g=x[A+480188>>1];e=v[F>>2];Wb:{if(v[o+1075060>>2]|g>>>0>K>>>0?e&1024:1){if(g>>>0>K>>>0){WK(A,K&65535)}u[o+1075846>>1]=0;break Wb}i=0;W=o+1075704|0;v[W>>2]=0;M=o+1075664|0;v[M>>2]=0;p=o+1074992|0;f=p;v[f>>2]=0;v[f+4>>2]=0;v[o+1075084>>2]=0;v[s+20>>2]=1065353216;u[s+18>>1]=0;q=0;E=o+1075684|0;q=v[E>>2]?v[o+1075060>>2]!=0:q;f=o+1074984|0;V=o+1075640|0;J=v[V>>2];Xb:{Yb:{Zb:{if(g>>>0<=K>>>0){break Zb}if(w[(A+(K<<5)|0)+480288|0]){break Yb}if(!J){break Zb}i=w[J+34|0]!=0}if((i|q)!=1){break Xb}}v[s+8>>2]=v[o+1075672>>2];v[s+4>>2]=v[o+1075748>>2];i=s+24|0;Fb(i,G,28);e=f;g=s+8|0;i=Cb(i)?s+4|0:g;h=jb-16|0;jb=h;j=h+8|0;k=A+1074312|0;Fb(j,k,28);_b:{if(Cb(j)){v[i>>2]=v[i>>2]+u[e+788>>1];Yd(i,0,64);break _b}j=h+8|0;Fb(j,k,1);k=Cb(j);j=u[e+788>>1];if(k){v[i>>2]=j+v[i>>2];Yd(i,0,256);break _b}v[e+688>>2]=j+v[e+688>>2];Yd(e+688|0,0,256);v[i>>2]=v[e+688>>2];u[e+788>>1]=0}jb=h+16|0;i=jb-16|0;jb=i;h=i+8|0;j=A+1074312|0;Fb(h,j,28);$b:{ac:{if(!Cb(h)){Fb(i,j,1);if(!Cb(i)){break ac}}v[e+684>>2]=v[e+692>>2]+u[e+790>>1];Yd(e+684|0,0,256);break $b}v[e+692>>2]=v[e+692>>2]+u[e+790>>1];Yd(e+692|0,0,256);u[e+790>>1]=0;v[e+684>>2]=v[e+692>>2]}jb=i+16|0;e=g;l=jb-16|0;jb=l;i=A;bc:{if(!(w[f+90|0]&4)|(v[i+480208>>2]&2101248)==2101248){break bc}h=f;cc:{if(v[e>>2]<=0){j=l+8|0;Fb(j,i+1074312|0,21);if(!Cb(j)){break cc}}j=5;if(!(v[i+480180>>2]&5)){j=l+8|0;Fb(j,i+1074312|0,21);j=Cb(j)?5:6}k=Rx(i,w[h+845|0],w[h+840|0]);dc:{if((w[h+845|0]&3)!=1){break dc}m=l+8|0;Fb(m,i+1074312|0,89);if(!Cb(m)){break dc}k=w[h+839|0];n=w[h+840|0];m=n<<2&124;k=(!(w[h+90|0]&2)|w[i+480209|0]&16?k:w[h+843|0]+k|0)&32?m^127:m;k=n&32?0-k|0:k}m=e;if(v[i+480180>>2]!=131072){e=v[e>>2]+((B(w[h+847|0],k)|0)/(1<<j)|0)|0}else{e=v[e>>2];e=((B(w[h+847|0],B(e,64-k|0))|0)/-8192|0)+e|0}v[m>>2]=e}if(!(v[i+480180>>2]&16777248)|w[i+480208|0]&4?w[i+480209|0]&16:0){break bc}e=l+8|0;Fb(e,i+1074312|0,21);e=Cb(e);j=h;i=w[h+846|0];h=w[h+840|0];t[j+840|0]=(e?i<<2:h)+(e?h:i)}jb=l+16|0;k=K&65535;m=k;e=g;r=jb-16|0;jb=r;h=r+8|0;i=A;j=i+1074312|0;Fb(h,j,71);ec:{if(Cb(h)){h=(i+B(m,896)|0)+1075843|0;l=t[h|0];if((l|0)>=0){break ec}if(!(w[i+480209|0]&16|w[(i+B(m,896)|0)+1075811|0]!=18)){j=l&-33;t[h|0]=j;fc:{gc:{if((j|0)!=-64){j=l&223;if((j|0)!=128){break gc}l=w[(i+B(m,896)|0)+1075844|0]>>>4|-64;break fc}l=w[(i+B(m,896)|0)+1075844|0]&15|-128;break fc}l=j-1|0}t[h|0]=l;h=(i+B(m,896)|0)+1075072|0;v[h>>2]=v[h>>2]|2097152}if((l&224)!=128){break ec}v[e>>2]=0;break ec}if(w[(i+B(m,896)|0)+1075811|0]!=18){break ec}h=r+8|0;Fb(h,j,22);hc:{if(Cb(h)){n=i+B(m,896)|0;h=n+1075843|0;j=w[h|0];l=j<<24>>24;if(!((l|0)>=0|!v[n+1075060>>2])){ic:{jc:{if((j|0)!=192){if((j|0)!=128){break jc}l=w[(i+B(m,896)|0)+1075844|0]>>>4|-64;break ic}l=w[(i+B(m,896)|0)+1075844|0]&15|-128;break ic}l=l-1|0}t[h|0]=l}if((l&192)!=128){break hc}v[e>>2]=0;break hc}h=w[(i+B(m,896)|0)+1075844|0];j=h>>>4|0;n=j+(h&15)|0;if(!(w[i+480208|0]&4?0:v[i+480180>>2]&16777248)){n=n+2|0;j=j+1|0}h=(i+B(m,896)|0)+1075843|0;l=w[h|0];if(!(v[i+480180>>2]&4)){ca=j;j=(l&255)>>>0<n>>>0?l:0;if(ca>>>0<=(j&255)>>>0){v[e>>2]=0}t[h|0]=j+1;break hc}kc:{if(w[i+480209|0]&16){l=l&255?l-1|0:0;break kc}t[h|0]=l+1}if(((l&255)>>>0)%(n>>>0)>>>0<j>>>0){break hc}v[e>>2]=0}h=(i+B(m,896)|0)+1075072|0;v[h>>2]=v[h>>2]|2097152}h=i+B(m,896)|0;lc:{if(w[h+1075811|0]!=18){break lc}l=h+1075640|0;h=v[l>>2];if(!h|!w[h+34|0]|w[h+15|0]&2){break lc}h=i+B(m,896)|0;if(v[h+1075072>>2]&134218752){break lc}j=h+1075805|0;if(!Xd(w[j|0])){break lc}l=v[l>>2];h=v[(i+B(w[l+34|0],160)|0)+906140>>2];if(!h){break lc}n=nb[v[v[h>>2]+96>>2]](h,w[j|0],m)|0;e=v[e>>2];if(!(!n|e)){nb[v[v[h>>2]+88>>2]](h,l,w[j|0]+255|0,0,m);break lc}if(n|!e){break lc}nb[v[v[h>>2]+88>>2]](h,l,w[j|0],x[(i+B(m,896)|0)+1075672>>1],m)}jb=r+16|0;Yd(g,0,256);e=v[s+8>>2]<<6;v[s+8>>2]=e;mc:{nc:{if(J){e=s+24|0;Fb(e,G,31);if(Cb(e)){qs(A,f)}r=s+8|0;m=r;h=jb-16|0;jb=h;oc:{if(!Qx(A,f,0)){break oc}g=f;j=v[g+656>>2];e=h+8|0;i=i+1074312|0;Fb(e,i,31);pc:{if(Cb(e)){e=v[g+728>>2];if(e){break pc}break oc}e=v[g+728>>2]}n=h+8|0;Fb(n,i,31);l=j+48|0;X=e-Cb(n)|0;e=tp(l,X,256,64);n=w[j+65|0];qc:{if((n|0)==255){break qc}g=v[g+732>>2];if((g|0)==-1){break qc}n=w[Pb(l,n)+2|0];j=x[Pb(l,w[j+65|0])>>1];l=h+8|0;Fb(l,i,94);i=n<<2;e=(j|0)==(X|0)?i:e;if(Cb(l)){e=g+(e-i<<1)|0;break qc}if(!n){e=0;break qc}e=(B(e,g)|0)/(i|0)|0}Ia=m,Ja=(B(v[m>>2],Yb(e,0,512))|0)/256|0,v[Ia>>2]=Ja}jb=h+16|0;VK(f,r);i=jb-16|0;jb=i;e=A;rc:{if(!Qx(e,f,1)){break rc}g=f;h=v[g+656>>2];j=i+8|0;m=e+1074312|0;Fb(j,m,31);sc:{if(Cb(j)){e=v[g+740>>2];if(e){break sc}break rc}e=v[g+740>>2]}j=i+8|0;Fb(j,m,31);h=tp(h+68|0,e-Cb(j)|0,64,64)-32|0;e=v[g+684>>2];Ia=g,Ja=Yb(((B(h,(e|0)>127?256-e|0:e)|0)/32|0)+e|0,0,256),v[Ia+684>>2]=Ja}jb=i+16|0;g=v[f+656>>2];i=t[g+26|0];tc:{if(!i){break tc}e=f;h=w[e+819|0];if(!h){break tc}Ia=e,Ja=Yb(v[e+684>>2]+((B(i,h+(w[g+27|0]^-1)|0)|0)/2|0)|0,0,256),v[Ia+684>>2]=Ja}e=v[s+8>>2];break nc}if(!(w[F+1|0]&16)){break nc}v[o+1075680>>2]=0;v[s+8>>2]=0;break mc}if(!e){break mc}if(w[F+3|0]&8){v[M>>2]=0;break mc}e=v[s+8>>2];if(w[H+36|0]){g=B(v[s+4>>2],v[o+1075744>>2]);e=e<<8;Ia=M,Ja=zc(rma(qma(g,g>>31,e,e>>31),mb,1048576,0),mb),v[Ia>>2]=Ja;break mc}g=B(v[s+4>>2],v[o+1075744>>2]);e=B(e,v[A+1074444>>2]);Ia=M,Ja=zc(rma(qma(g,g>>31,e,e>>31),mb,1048576,0),mb),v[Ia>>2]=Ja}v[W>>2]=v[s+8>>2];uc:{if(v[A+480180>>2]==2|v[E>>2]>=v[A+480260>>2]){break uc}if(ap(A)){break uc}v[E>>2]=v[A+480260>>2]}e=s+24|0;Fb(e,G,73);if(Cb(e)){Yb(v[E>>2],1,31999)}e=v[E>>2];v[s+12>>2]=e;vc:{if((v[F>>2]&1572864)!=1572864){break vc}if(w[N|0]&32){if(!Is(o+1075794|0)|w[R|0]&16){break vc}e=v[s+12>>2]}g=o+1075696|0;wc:{if(v[g>>2]==(e|0)){e=v[o+1075700>>2];break wc}v[g>>2]=e;h=e;e=o+1075752|0;g=o+1075688|0;e=eg(A,zs(A,h,v[e>>2],v[g>>2]),v[e>>2],v[g>>2]);v[o+1075700>>2]=e}v[s+12>>2]=e}m=jb-16|0;jb=m;h=A;e=k;n=h+B(e,896)|0;i=v[n+1075640>>2];xc:{if(!i){break xc}g=w[i+34|0];if(!g|w[i+15|0]&2|(!v[(h+B(g,160)|0)+906140>>2]|v[(h+B(e,896)|0)+1075072>>2]&134218752)){break xc}j=h+B(e,896)|0;X=j+1075797|0;r=w[X|0];g=0;k=j+1075805|0;if(Xd(w[k|0])){g=w[ec(i+108|0,w[k|0]-1|0)|0]}l=j+1075794|0;yc:{zc:{if((r|0)==1){k=0;Ac:{Bc:{switch((y[h+1074392>>2]%3|0)-1|0){case 0:k=w[(h+B(e,896)|0)+1075812|0]>>>4|0;break Ac;case 1:break Bc;default:break Ac}}k=w[(h+B(e,896)|0)+1075812|0]&15}i=h+B(e,896)|0;t[i+1075807|0]=g;if(w[i+1075806|0]==(g+k|0)){break yc}if(!(w[h+480209|0]&16)){break zc}if(!Wf(l)){break zc}break yc}k=0;if(w[l|0]|!w[(h+B(e,896)|0)+1075806|0]){break yc}}i=h+B(e,896)|0;yl(h,e,w[i+1075807|0]+k|0,x[i+1075672>>1])}j=(h+B(e,896)|0)+1075806|0;i=w[j|0];Cc:{if(!i){if(!(w[h+480209|0]&16)|(r|0)!=1){break Cc}if(Wf(l)){break Cc}i=g;if(!Xd(g)){break Cc}}yl(h,e,(i&255)+255|0,0)}t[j|0]=w[X|0]==1?w[(h+B(e,896)|0)+1075807|0]+k|0:0}Dc:{if(w[n+1075811|0]!=1){break Dc}if(tj(n+1074984|0)){g=0;Ec:{Fc:{switch((y[h+1074392>>2]%3|0)-1|0){case 0:g=w[(h+B(e,896)|0)+1075812|0]>>>4|0;break Ec;case 1:break Fc;default:break Ec}}g=w[(h+B(e,896)|0)+1075812|0]&15}u[s+18>>1]=g;e=(h+B(e,896)|0)+1075856|0;t[e|0]=w[e|0]|12;break Dc}if(!(!(w[h+480209|0]&16)|v[h+480180>>2]!=1048576)){g=h+B(e,896)|0;i=eg(h,w[g+1075803|0],v[g+1075752>>2],v[g+1075688>>2]);v[s+12>>2]=i;v[g+1075684>>2]=i}g=m+8|0;j=h+1074312|0;Fb(g,j,13);if(Cb(g)){g=w[(h+B(e,896)|0)+1075812|0];if(!g){break Dc}e=65536;Gc:{switch(((y[h+1074392>>2]%(v[h+1074400>>2]+v[h+1074416>>2]>>>0)>>>0)%3|0)-1|0){case 1:g=g<<4;case 0:e=v[((g&240)<<2)+30544>>2];break;default:break Gc}}j=ap(h);g=v[s+12>>2];h=g;g=g>>31;i=s;if(j){g=qma(h,g,e,e>>31)+32768|0;e=mb;e=rma(g,g>>>0<32768?e+1|0:e,65536,0)}else{j=(e|0)/2|0;l=j>>31;g=g<<16|h>>>16;k=h<<16;j=j+k|0;h=g+l|0;e=rma(j,j>>>0<k>>>0?h+1|0:h,e,e>>31)}g=mb;Ia=i,Ja=zc(e,g),v[Ia+12>>2]=Ja;break Dc}g=m+8|0;Fb(g,j,51);if(Cb(g)){if(w[h+480209|0]&16){break Dc}Hc:{Ic:{g=v[h+1074416>>2];g=g-(y[h+1074392>>2]%(g>>>0)|0)|0;if((g|0)>16){break Ic}if((g|0)==16){break Dc}k=0;Jc:{switch((g|0)%3|0){case 0:break Dc;case 2:break Ic;case 1:break Jc;default:break Hc}}k=w[(h+B(e,896)|0)+1075812|0]>>>4|0;break Hc}k=w[(h+B(e,896)|0)+1075812|0]&15}e=h+B(e,896)|0;g=e+1075752|0;e=e+1075688|0;i=zs(h,v[s+12>>2],v[g>>2],v[e>>2])+k|0;g=eg(h,i,v[g>>2],v[e>>2]);v[s+12>>2]=g;if(i>>>0<109){break Dc}v[m+8>>2]=g;Ia=m,Ja=eg(h,109,0,v[e>>2]),v[Ia+4>>2]=Ja;Ia=s,Ja=v[Vc(m+8|0,m+4|0)>>2],v[Ia+12>>2]=Ja;break Dc}g=v[h+1074392>>2];if(v[h+480180>>2]!=1){k=w[(h+B(e,896)|0)+1075803|0]}else{i=h+B(e,896)|0;k=zs(h,v[s+12>>2],v[i+1075752>>2],v[i+1075688>>2])}Kc:{Lc:{switch((((v[h+480180>>2]&67633152?g+2|0:g)>>>0)%3|0)-1|0){case 0:k=(w[(h+B(e,896)|0)+1075812|0]>>>4|0)+k|0;break Kc;case 1:break Lc;default:break Kc}}k=(w[(h+B(e,896)|0)+1075812|0]&15)+k|0}if(!(v[h+480180>>2]&67633408|w[(h+B(e,896)|0)+1075803|0]!=(k&255))){g=m+8|0;Fb(g,j,82);if(!Cb(g)){break Dc}}i=s;n=h;if(w[h+480210|0]&32){l=k&255;if((l|0)==85){v[s+12>>2]=2147483647;break Dc}k=l>>>0>85?k-37|0:k}g=h+B(e,896)|0;Ia=i,Ja=eg(n,k&255,v[g+1075752>>2],v[g+1075688>>2]),v[Ia+12>>2]=Ja;if(v[h+480180>>2]&71827712){v[g+1075684>>2]=v[s+12>>2];break Dc}g=m+8|0;Fb(g,j,82);if(!Cb(g)){break Dc}t[(h+B(e,896)|0)+1075806|0]=k}jb=m+16|0;if(!(!(w[N|0]&33)|v[s+12>>2]==2147483647)){Mc:{if(v[A+480180>>2]==2){e=452;g=3424;break Mc}g=B(v[o+1075752>>2]>>>4&15,24)+26256|0;e=x[g+22>>1]>>>1|0;e=e>>>0>452?e:452;g=x[g>>1]<<1}Yd(s+12|0,e,g);Yd(E,e,g)}UK(A,f);e=v[F>>2]}Nc:{if(!(e&256)|w[R|0]&64){break Nc}e=s+24|0;Fb(e,G,37);if(!Cb(e)){break Nc}v[o+1075668>>2]=128}k=K&65535;WK(A,k);Oc:{if(!q){break Oc}e=TK(A,f,s+12|0);if((e|0)<0|!(w[F+1|0]&2)){break Oc}if(!qd(T)){break Oc}np(v[T>>2],k,e>>>2&255,1)}Pc:{if(w[o+1075796|0]!=8){break Pc}Qc:{Rc:{e=w[o+1075797|0];switch(e-5|0){case 1:break Pc;case 0:case 2:break Qc;default:break Rc}}if((e|0)!=26){break Pc}}if(v[A+480180>>2]==4){if(w[R|0]&16){break Pc}e=o+1075823|0;t[e|0]=w[e|0]+w[o+1075827|0];break Pc}if(!(v[A+480180>>2]&16777248)){break Pc}qk(f,w[o+1075798|0]);SK(A,k,s+12|0,s+20|0)}SK(A,k,s+12|0,s+20|0);if(q){v[s+8>>2]=0;h=A;i=s+12|0;r=jb-16|0;jb=r;l=v[f+104>>2];Sc:{if(!l|!w[l+40|0]){break Sc}e=f;X=tj(e);j=ap(h);m=r+8|0;Fb(m,h+1074312|0,21);g=j?31568:30544;q=j?30544:31568;if(!(X|!Cb(m)|v[h+480180>>2]==1048576)){if(!w[l+41|0]){break Sc}n=w[e+838|0];v[r+4>>2]=v[e+780>>2]+w[l+39|0];Si(r+4|0,w[l+40|0]<<8);m=v[r+4>>2];v[e+780>>2]=m;m=(m|0)/256|0;v[r+4>>2]=m;t[e+838|0]=w[e+838|0]+w[l+41|0];Tc:{Uc:{switch(w[l+38|0]-1|0){case 3:e=PK(_m(h))+-64|0;m=v[r+4>>2];break Tc;case 2:e=64-(n+1>>>1|0)|0;break Tc;case 1:e=(n+1>>>1|0)+-64|0;break Tc;case 0:e=(n>>>1^-1)&64;break Tc;default:break Uc}}e=t[n+26848|0]}Si(i,8388607);l=v[i>>2]<<8;v[i>>2]=l;n=B(e,m);h=(n|0)/64|0;e=h>>31;m=e^e+h;e=m>>>2|0;h=i;Vc:{if((n|0)<=-64){e=v[(e<<2)+g>>2];g=zc(rma(qma(e,e>>31,l,l>>31),mb,65536,0),mb);e=v[i>>2];q=g-e|0;m=m&3;g=q;if(!m){break Vc}g=v[(m<<2)+(j?30480:30416)>>2];g=zc(rma(qma(g,g>>31,e,e>>31),mb,65536,0),mb)+q|0;e=v[i>>2];g=g-e|0;break Vc}e=v[q+(e<<2)>>2];g=zc(rma(qma(e,e>>31,l,l>>31),mb,65536,0),mb);e=v[i>>2];q=g-e|0;m=m&3;g=q;if(!m){break Vc}g=v[(m<<2)+(j?30416:30480)>>2];g=zc(rma(qma(g,g>>31,e,e>>31),mb,65536,0),mb)+q|0;e=v[i>>2];g=g-e|0}v[h>>2]=(e+g|0)/256;v[s+8>>2]=g&255;break Sc}Wc:{if(!(w[l+39|0]|v[h+480180>>2]&16777248)){v[e+780>>2]=w[l+40|0]<<8;break Wc}Xc:{Yc:{if(v[h+480180>>2]&16777248){n=v[e+780>>2];m=e+780|0;j=w[l+39|0]<<1;break Yc}if(w[e+89|0]&8){break Xc}n=((w[l+40|0]<<8&65280)>>>0)/w[l+39|0]|0;m=e+780|0;j=v[e+780>>2]}v[m>>2]=j+n}Si(e+780|0,w[l+40|0]<<8)}j=w[e+838|0]+w[l+41|0]|0;t[e+838|0]=j;j=j<<24>>24;Zc:{_c:{switch(w[l+38|0]-1|0){case 3:t[e+838|0]=j+1;m=t[(j&63)+26784|0];break Zc;case 2:m=(64-(j>>>1|0)&127)+-64|0;break Zc;case 1:m=((j>>>1|0)- -64&127)+-64|0;break Zc;case 0:m=(j|0)>=0?-64:64;break Zc;default:break _c}}j=w[e+838|0];m=0-t[j+26848|0]|0;if(v[h+480180>>2]!=1048576){break Zc}m=(64-t[(j+-64&255)+26848|0]|0)/2<<16>>16}j=m;m=B(j,v[e+780>>2]);n=(m|0)/256|0;if(X){z[s+20>>2]=C(C(C(j|0)*C(1220703143189894e-20))*C(w[l+40|0]))+z[s+20>>2];t[e+872|0]=w[e+872|0]|8;break Sc}if(v[h+480180>>2]!=4){$c:{if((m|0)<=-256){n=0-n|0;e=0-m>>>16|0;h=(e<<2)+g|0;break $c}g=q;e=(m|0)/65536|0;h=g+(e<<2)|0}j=v[i>>2];g=v[((e<<2)+g|0)+4>>2];e=v[h>>2];e=((B(g-e|0,(n|0)/4&63)|0)/64|0)+e|0;e=zc(rma(qma(j,j>>31,e,e>>31),mb,256,0),mb);v[i>>2]=e;v[s+8>>2]=e&255;v[i>>2]=v[i>>2]/256;break Sc}v[i>>2]=v[i>>2]+((m|0)/16384|0)}jb=r+16|0;if(v[s+12>>2]<=v[A+480260>>2]){e=s+24|0;Fb(e,G,81);if(Cb(e)){v[o+1075060>>2]=0}v[s+12>>2]=v[A+480260>>2]}g=tj(f);ad:{if(!g){break ad}e=o+1075856|0;i=w[e|0];if(!(v[A+1074392>>2]|!(i&4)?i&8:1)){break ad}_N(f,z[s+20>>2],u[s+18>>1],A);h=e;e=w[e|0];t[h|0]=(e&8?-9:-5)&e}bd:{if((v[F>>2]&134219264)!=512){break bd}if(!qd(T)){break bd}e=s+24|0;Fb(e,G,99);if(!(!(Cb(e)|!(w[F+1|0]&16))&v[A+480180>>2]!=2)){if(!(w[F+1|0]&8?v[A+480180>>2]==2:0)){if(g){g=v[E>>2]}else{g=OL(A,v[s+12>>2],v[o+1075688>>2],v[s+8>>2])}e=qma(g,0,261625,0)+66904|0;g=mb;e=dd(tma(e,e>>>0<66904?g+1|0:g,133808,0),mb);e=qma(v[A+480240>>2],0,e,0)+32768|0;j=mb;j=e>>>0<32768?j+1|0:j;h=dd((j&65535)<<16|e>>>16,j>>>16|0);g=v[F>>2];e=1;cd:{if(g&2048){break cd}e=0;if(!(g&4096)){break cd}e=!v[o+1075680>>2]}g=e;m=v[T>>2];e=s+24|0;Fb(e,G,95);n=Cb(e);q=jb-16|0;jb=q;i=k;l=vk(m,i);dd:{if((l|0)==255){break dd}if(qj(m)){break dd}ed:{if(h>>>0>6208431){j=7;e=1023;break ed}j=7;fd:{if(h>>>0>3104215){break fd}j=6;if(h>>>0>1552107){break fd}j=5;if(h>>>0>776053){break fd}j=4;if(h>>>0>388026){break fd}j=3;if(h>>>0>194013){break fd}j=2;if(h>>>0>97006){break fd}j=h>>>0>48503}e=qma(1<<20-j,0,h,0)+24858e3|0;h=mb;e=dd(tma(e,e>>>0<24858e3?h+1|0:h,49716e3,0),mb)}if(n){u[q+14>>1]=(i&3)+e;u[q+12>>1]=1023;e=x[Af(q+14|0,q+12|0)>>1]}i=Ss(l);h=m+4|0;Ia=ec(h,l),Ja=(j<<10|e)>>>8|(g?0:32),t[Ia|0]=Ja;jh(v[m>>2],i|160,e&255);jh(v[m>>2],i|176,w[ec(h,l)|0]);t[m+530|0]=1}jb=q+16|0}h=v[T>>2];e=qma(B(v[o+1075748>>2],B(v[o+1075744>>2],v[W>>2])),0,63,0)+33554432|0;g=mb;g=e>>>0<33554432?g+1|0:g;np(h,k,dd((g&67108863)<<6|e>>>26,g>>>26|0)&255,0);e=o+1075668|0;j=e;i=v[e>>2];g=0;e=v[T>>2];h=vk(e,k);gd:{if((h|0)==255){break gd}if(qj(e)){break gd}g=w[ec(Gi(e+314|0,h),10)|0];m=v[e>>2];e=g&-49;e=(i|0)<171?e|16:e;e=((i|0)>84?e|32:e)&255;jh(m,Ss(h)|192,e);g=(e>>>5&1)+(e<<27>>31)|0}v[j>>2]=(g<<7)+128}hd:{e=v[V>>2];if(!e|(w[e+60|0]&7)!=1){break hd}e=e+48|0;if(id(e)){break hd}if(y[RK(f,0)+4>>2]<x[pj(e)>>1]){break hd}if(w[pj(e)+2|0]){break hd}yi(v[T>>2],k,1);e=s+24|0;Fb(e,G,109);e=Cb(e);g=v[F>>2];v[F>>2]=(e?g:g&-4609)|4096;v[o+1075680>>2]=0;break bd}e=s+24|0;Fb(e,G,99);if(!Cb(e)|!(w[F+1|0]&16)|v[o+1075680>>2]){break bd}yi(v[T>>2],k,1);v[F>>2]=v[F>>2]&-513}i=qma(Sx(A,f,v[s+12>>2],v[s+8>>2]),mb,v[A+480240>>2],0);g=mb;h=rma(i,g,65536,0);j=mb;e=p;i=i+65535|0;g=i>>>0<65535?g+1|0:g;g=!g&i>>>0<131071;v[e>>2]=g?1:h;v[e+4>>2]=g?0:j}id:{if(!J){break id}e=s+24|0;Fb(e,G,31);if(Cb(e)){break id}qs(A,f)}g=v[F>>2];e=g&-65537;m=o+1075004|0;l=o+1075008|0;v[F>>2]=v[m>>2]|(v[l>>2]|v[M>>2])?(e|g<<7&65536)^65536:e;g=o+1075656|0;v[g>>2]=0;v[g+4>>2]=0;j=o+1075846|0;i=w[j|0];e=i-4|0;t[j|0]=e>>>0>i>>>0?0:e;k=o+1075847|0;i=w[k|0];e=i-4|0;t[k|0]=e>>>0>i>>>0?0:e;jd:{kd:{ld:{md:{nd:{od:{e=o+1075088|0;i=v[e>>2];pd:{if(!i){break pd}if(!Be(i)|!v[o+1075060>>2]){break pd}if(Kh(f)){break od}}i=o+1075e3|0;v[i>>2]=0;break nd}i=o+1075e3|0;e=v[v[e>>2]+20>>2];v[i>>2]=e;if(e){break md}}if(!oj(f)|w[F+1|0]&24){break ld}}n=v[M>>2];q=v[o+1075668>>2];e=(B(n,256-q|0)|0)/16384|0;h=e>>>0<127?e:127;e=t[j|0];if((e|0)<0){t[j|0]=h;r=h}else{r=e}e=h>>>1|0;if((r&255)>>>0<e>>>0){t[j|0]=e}e=(B(n,q)|0)/16384|0;e=e>>>0<127?e:127;q=e>>>1|0;j=q;h=t[k|0];if((h|0)<0){t[k|0]=e}else{e=h}if((e&255)>>>0<j>>>0){break kd}break jd}if(w[j|0]>=129){t[j|0]=0}q=0;if(w[k|0]<129){break jd}}t[k|0]=q}qd:{rd:{if(v[i>>2]){e=o+1075660|0;sd:{if(y[A+24624>>2]>=2){v[s+24>>2]=v[o+1075668>>2];Yd(s+24|0,0,256);j=B(v[M>>2],I)>>>(w[H+37|0]?7:8)|0;i=e;td:{ud:{vd:{switch(v[H+32>>2]){case 0:if(!(w[A+24616|0]&16)){break ud}case 1:h=v[s+24>>2];if((h|0)<=127){v[g>>2]=j>>>1;h=(B(h,j)|0)/256|0;break td}v[g>>2]=(B(j,256-h|0)|0)/256;h=j>>>1|0;break td;case 3:break vd;default:break ud}}Si(s+24|0,255);h=g;k=v[s+24>>2];if((k|0)<=0){m=65536}else{m=x[(0-k<<1)+33104>>1]}v[h>>2]=B(m,j)>>>16;h=B(j,x[(k<<1)+32592>>1])>>>16|0;break td}h=v[s+24>>2];v[g>>2]=(B(j,256-h|0)|0)/256;h=(B(h,j)|0)/256|0}v[i>>2]=h;break sd}i=B(v[M>>2],I)>>>8|0;v[g>>2]=i;v[e>>2]=i}h=o+1075800|0;j=h;wd:{xd:{i=v[V>>2];if(!i){break xd}if(!Nn(w[i+14|0])){break xd}i=w[v[V>>2]+14|0];break wd}if(Nn(w[A+480268|0])){i=w[A+480268|0];break wd}i=w[A+24648|0];i=w[N|0]&128?v[A+24668>>2]?-1:i:i}t[j|0]=i;if(!(w[F+2|0]&2|(v[p>>2]!=0|v[p+4>>2]!=1)|(v[o+1075764>>2]|(i&255)==255))){t[h|0]=0}h=g;i=v[g>>2];g=1<<v[H+28>>2];v[h>>2]=(i|0)/(g|0);g=v[e>>2]/(g|0)|0;v[e>>2]=g;i=v[F>>2];if(!(!(i&256)|v[A+24624>>2]!=2)){v[e>>2]=0-g}if(i&128){e=v[p>>2];g=0-(v[p+4>>2]+((e|0)!=0)|0)|0;v[p>>2]=0-e;v[p+4>>2]=g}j=A;n=0;m=jb-16|0;jb=m;h=f;v[f+28>>2]=0;v[f+32>>2]=0;k=f;yd:{zd:{g=v[f+88>>2];if(!(g&65536)){f=v[h+676>>2];e=v[h+672>>2];break zd}e=v[h+20>>2];i=v[h+672>>2];Ad:{if((e|0)!=(i|0)){f=v[h+24>>2];q=v[h+676>>2];break Ad}f=v[h+24>>2];q=v[h+676>>2];if((f|0)==(q|0)){break zd}}g=j+24604|0;i=(f|0)<(q|0)|(e|0)<(i|0);Bd:{if(i){e=cO(g);break Bd}e=bO(g)}Fb(m,j+1074312|0,4);if(!(!Cb(m)|!(v[j+480180>>2]&4))){f=v[j+24620>>2];f=qma(f,f>>31,5,0)+500|0;g=mb;e=zc(rma(f,f>>>0<500?g+1|0:g,1e3,0),mb)}g=v[h+656>>2];Cd:{if(!g){f=e;break Cd}f=e;if(!i){break Cd}g=x[g+12>>1];if(g){f=(B(g,v[j+24620>>2])>>>0)/1e5|0}n=(g|0)!=0}l=f?f:1;i=v[h+676>>2];f=v[h+24>>2];g=i-f<<12;q=v[h+672>>2];p=v[h+20>>2];M=q-p<<12;if(!(w[h+90|0]&32|(!(i|q)|(!(f|p)|n)))){v[m+12>>2]=v[j+1074380>>2];Yd(m+12|0,e,2048);q=v[h+672>>2];l=v[m+12>>2];i=v[h+676>>2]}g=(g|0)/(l|0)|0;v[h+32>>2]=g;j=(M|0)/(l|0)|0;v[h+28>>2]=j;f=((B(g,l)|0)/-4096|0)+i|0;v[h+24>>2]=f;e=((B(j,l)|0)/-4096|0)+q|0;v[h+20>>2]=e;if(g|j){v[h+100>>2]=l;g=v[h+88>>2];break yd}v[h+24>>2]=i;v[h+20>>2]=q;f=i;e=q;g=v[h+88>>2]&-65537;break yd}v[h+24>>2]=f;v[h+20>>2]=e;g=g&-65537}v[k+88>>2]=g&-2097153;v[h+40>>2]=f<<12;v[h+36>>2]=e<<12;jb=m+16|0;if(!(w[F+1|0]&2)){break rd}break qd}v[m>>2]=0;v[l>>2]=0;v[o+1075060>>2]=0;if(v[o+1075080>>2]){break rd}if(!v[o+1075076>>2]){break qd}}f=x[A+480212>>1];u[A+480212>>1]=f+1;u[(A+(f<<1)|0)+1074466>>1]=K}v[o+1075652>>2]=v[F>>2]}K=K+1|0;if((K|0)!=256){continue}break}q=1;if(y[A+24608>>2]>x[A+480212>>1]){break Tb}g=A+1074466|0;e=g+(v[A+24608>>2]<<1)|0;i=g+(x[A+480212>>1]<<1)|0;h=jb-16|0;jb=h;v[h+8>>2]=A;A=h+8|0;j=A;f=g;k=e-g|0;if((k|0)>=3){k=k>>1;m=(k-2|0)/2|0;while(1){Ox(f,j,k,f+(m<<1)|0);l=(m|0)>0;m=m-1|0;if(l){continue}break}}if((e|0)!=(i|0)){j=e-g>>1;f=e;while(1){if(Uo(A,x[f>>1],x[g>>1])){LK(f,g);Ox(g,A,j,g)}f=f+2|0;if((i|0)!=(f|0)){continue}break}}f=e-g|0;if((f|0)>=3){f=f>>>1|0;while(1){e=e-2|0;LK(g,e);i=f-1|0;Ox(g,A,i,g);j=f>>>0>2;f=i;if(j){continue}break}}jb=h+16|0}jb=s+32|0;if(q){f=v[a+480208>>2];break h}e=v[a+480208>>2]|512;if(w[a+1304512|0]){break i}f=0;e=a;g=v[e+24620>>2];g=zc(rma(qma(g,g>>31,100,0),mb,1e3,0),mb);Dd:{if(!g){break Dd}i=g>>>0<1048576?g:1048576;v[e+1074380>>2]=i;A=x[e+480212>>1];if(!A){break Dd}h=e+1074376|0;while(1){e=h+B(x[(h+(f<<1)|0)+90>>1],896)|0;j=e+1280|0;v[j>>2]=0;v[j+4>>2]=0;v[e+708>>2]=i;j=v[e+632>>2]<<12;v[e+648>>2]=j;k=v[e+628>>2]<<12;v[e+644>>2]=k;v[e+696>>2]=v[e+696>>2]|65536;v[e+636>>2]=(0-k|0)/(i|0);v[e+640>>2]=(0-j|0)/(i|0);f=f+1|0;if((A|0)!=(f|0)){continue}break}}f=v[a+480208>>2];e=f|256;if(g){break i}e=f|512}f=e;v[Q+480208>>2]=f}if(f&512){Ia=a+1074392|0,Ja=wl(a),v[Ia>>2]=Ja;break g}v[$+16>>2]=512;f=v[a+1074380>>2];v[$+12>>2]=3;v[$+24>>2]=b;v[$+20>>2]=f;v[$+8>>2]=$+16;f=v[$+12>>2];v[$>>2]=v[$+8>>2];v[$+4>>2]=f;A=wS($);if(v[a+24632>>2]){f=a;g=d;e=0;h=jb-16|0;jb=h;i=A;j=i<<2;while(1){v[h>>2]=0;k=(f+(e<<11)|0)+16396|0;OJ(k,j+k|0,h);e=e+1|0;if((e|0)!=4){continue}break}e=0;while(1){v[h+(e<<2)>>2]=(f+(e<<11)|0)+16396;e=e+1|0;if((e|0)!=4){continue}break}nb[v[v[g>>2]+8>>2]](g,h,v[f+24632>>2],i);jb=h+16|0}I=a;K=0;e=jb-112|0;jb=e;s=A;if(s){T=I+12|0;M=I+24592|0;Q=I+24588|0;on(T,s,M,Q);if(y[I+24624>>2]>=3){on(I+8204|0,s,I+24600|0,I+24596|0)}u[e+30>>1]=0;f=e+8|0;la=I+1074312|0;Fb(f,la,33);f=Cb(f);p=x[I+480212>>1];if(p){xa=f?2:1;ya=I+24648|0;r=I+24596|0;za=I+24600|0;Aa=I+8204|0;E=I+397460|0;H=I+397456|0;J=I+393352|0;oa=I+1074376|0;while(1){m=oa+(K<<1)|0;f=B(x[m+90>>1],896);g=f+oa|0;X=g;Ed:{Fd:{if(v[g+624>>2]){break Fd}i=f+I|0;if(v[i+1075080>>2]){break Fd}if(!v[i+1075076>>2]){break Ed}}k=f+I|0;f=w[k+1075800|0]+1|0;if((f&255)>>>0<=5){f=v[(f<<24>>24<<2)+24472>>2]}else{f=0}R=k+1075072|0;h=v[R>>2];l=f|h&1|h>>>5&2;n=h>>>12&8;i=g+608|0;j=r;Gd:{if(!(!(h&16777216)&w[I+24612|0]>>>5)){q=T;g=Q;f=M;if(!(h&8388608)){break Gd}}g=s;f=J;if(!v[f+4116>>2]){on(f+8|0,g,f+4104|0,f+4108|0)}v[f+4116>>2]=1;q=f+8|0;h=v[R>>2];g=E;f=H}p=g;g=h>>>8&y[I+24624>>2]>2;ga=g?j:p;da=g?za:f;f=g?Aa:q;ea=xl(I,x[m+90>>1],2,1);Hd:{if((ea-1&255)>>>0>249){break Hd}h=v[(I+B(ea,160)|0)+906140>>2];if(!h){break Hd}g=v[h+24>>2];if(!g){break Hd}ga=h+36|0;da=h+40|0;if(!(t[h+28|0]&1)){on(g,s,da,ga);v[h+28>>2]=v[h+28>>2]|1}f=g}ha=0;j=e+8|0;v[j>>2]=0;v[j+4>>2]=0;v[j+8>>2]=0;v[j+12>>2]=0;g=i;if(v[g+16>>2]){uC(j,g);h=v[g+12>>2];q=h;m=v[g+8>>2];h=h>>31;g=h;m=m+g|0;h=g+q|0;h=m>>>0<g>>>0?h+1|0:h;g=g^h;v[j+12>>2]=g>>>0>8191?2:16384/(g+1>>>0)|0}Ba=l|n;pa=k+1075809|0;Ca=k+1075792|0;Da=k+1075680|0;Ea=k+1075016|0;Fa=k+1075012|0;Ga=k+1075660|0;Ha=k+1075656|0;W=k+1074992|0;Y=k+1075080|0;_=k+1075076|0;qa=k+1075008|0;ra=k+1075004|0;ja=k+1075088|0;ba=k+1075068|0;V=k+1075060|0;ka=k+1075064|0;aa=k+1075084|0;N=j;q=s;while(1){Id:{g=v[aa>>2];G=g?g>>>0<q>>>0?g:q:q;v[e+68>>2]=G;F=v[ka>>2];g=v[R>>2];n=v[W+4>>2];j=v[W>>2];v[e+56>>2]=j;v[e+60>>2]=n;Jd:{Kd:{if(!G|!(j|n)){break Kd}o=v[V>>2];if(!o){break Kd}h=v[e+8>>2];if(!h){break Kd}v[X+624>>2]=h;h=v[i+4>>2];m=h;k=v[i>>2];Ld:{Md:{p=F&g<<30>>31;ca=h;Nd:{if((p|0)>(h|0)){if((n|0)<0){v[e+104>>2]=0;g=p;v[e+108>>2]=g<<1;k=pg(e+104|0,i);h=mb;m=h;v[i>>2]=k;v[i+4>>2]=h;if(!(h>>>0<v[V>>2]+g>>>1>>>0&(g|0)<=(h|0))){h=i;k=0;v[h>>2]=k;v[h+4>>2]=g;m=g}g=j;h=0-(((g|0)!=0)+n|0)|0;l=0-g|0;v[e+56>>2]=l;v[e+60>>2]=h;v[W>>2]=l;v[W+4>>2]=h;g=v[R>>2];Od:{if(g&4){o=g&-129;v[R>>2]=o;break Od}o=g|128;v[R>>2]=o;g=v[V>>2]-1|0;m=g;v[i>>2]=k;v[i+4>>2]=g;v[W>>2]=j;v[W+4>>2]=n}Pd:{if(!(o&2)){o=v[V>>2];break Pd}o=v[V>>2];if(m>>>0<o>>>0){break Ld}}h=i;v[h>>2]=0;v[h+4>>2]=o;break Kd}if((m|0)>0|(m|0)>=0){break Nd}g=0;m=g;v[i>>2]=k;v[i+4>>2]=g;break Nd}if(o>>>0<=ca>>>0){break Md}}l=j;h=n;break Ld}if(!(g&2)){break Kd}if(g&4){Qd:{if(!j&(n|0)<=0|(n|0)<0){l=j;h=n;break Qd}l=0-j|0;v[e+56>>2]=l;h=0-(((j|0)!=0)+n|0)|0;v[e+60>>2]=h;v[W>>2]=l;v[W+4>>2]=h}v[R>>2]=g|128;j=1-((k|0)!=0)|0;k=0-k|0;n=(o<<1)-(j+ca|0)|0;j=n;m=j;g=i;v[g>>2]=k;v[g+4>>2]=j;if(j>>>0<o>>>0&j>>>0>F>>>0){break Ld}v[e+104>>2]=xa;j=o-v[Lb(V,e+104|0)>>2]|0;k=v[i>>2];m=j;v[i>>2]=k;v[g+4>>2]=j;break Ld}Rd:{if((n|0)>0|(n|0)>=0){l=j;h=n;break Rd}l=0-j|0;v[e+56>>2]=l;h=0-(((j|0)!=0)+n|0)|0;v[e+60>>2]=h;v[W>>2]=l;v[W+4>>2]=h}v[e+104>>2]=0;v[e+108>>2]=p-o;Sb(i,e+104|0);v[R>>2]=v[R>>2]|8192;k=v[i>>2];m=v[i+4>>2]}v[e+48>>2]=k;g=m;v[e+52>>2]=g;Sd:{if((g|0)<(p|0)){if((m|0)<0){break Kd}if((h|0)>0|(h|0)>=0){break Sd}break Kd}if((m|0)<0){break Kd}}if(g>>>0>=y[V>>2]){break Kd}v[e+44>>2]=G;tc(e+68|0,v[e+20>>2]);Ia=e,Ja=Pu(e+56|0,v[e+68>>2]-1|0),v[Ia+32>>2]=Ja;v[e+36>>2]=mb;j=h>>31;g=j;n=g;j=g+l|0;h=g+h|0;h=j>>>0<g>>>0?h+1|0:h;o=j;m=v[e+48>>2];k=m+v[e+32>>2]|0;j=v[e+36>>2]+v[e+52>>2]|0;j=k>>>0<m>>>0?j+1|0:j;m=v[ka>>2];F=m+16|0;ca=v[e+52>>2];k=ca;ca=m;l=v[e+48>>2];m=k;ca=ca>>>0>k>>>0;if(!(!ca&k>>>0<F>>>0)){v[R>>2]=v[R>>2]&-8193}n=n^o;o=g^h;h=j;Td:{Ud:{Vd:{if(!v[e+12>>2]){m=v[e+60>>2];break Vd}g=v[e+16>>2];if(g>>>0<=m>>>0){h=e;Wd:{if(v[e+60>>2]<0){v[e+96>>2]=l;v[e+100>>2]=k;v[e+104>>2]=0;v[e+108>>2]=g;Ia=e,Ja=pg(e+96|0,e+104|0),v[Ia+80>>2]=Ja;v[e+84>>2]=mb;v[e+72>>2]=1;v[e+76>>2]=0;Ia=e,Ja=pg(e+80|0,e+72|0),v[Ia+88>>2]=Ja;v[e+92>>2]=mb;g=cm(e+88|0,n,o);break Wd}g=v[ba>>2];v[e+104>>2]=l;v[e+108>>2]=k;v[e+96>>2]=0;v[e+100>>2]=g;Ia=e,Ja=pg(e+96|0,e+104|0),v[Ia+80>>2]=Ja;v[e+84>>2]=mb;v[e+72>>2]=1;v[e+76>>2]=0;Ia=e,Ja=pg(e+80|0,e+72|0),v[Ia+88>>2]=Ja;v[e+92>>2]=mb;g=cm(e+88|0,n,o)}v[h+44>>2]=g+1;v[X+624>>2]=v[e+12>>2];break Td}if(!(ca|!(w[R+1|0]&32)|m>>>0>=F>>>0)){v[e+104>>2]=l;v[e+108>>2]=k;v[e+96>>2]=0;v[e+100>>2]=p+16;Ia=e,Ja=pg(e+96|0,e+104|0),v[Ia+80>>2]=Ja;v[e+84>>2]=mb;v[e+72>>2]=1;v[e+76>>2]=0;Ia=e,Ja=pg(e+80|0,e+72|0),v[Ia+88>>2]=Ja;v[e+92>>2]=mb;Ia=e,Ja=cm(e+88|0,n,o)+1|0,v[Ia+44>>2]=Ja;Ia=X,Ja=v[e+12>>2]+B(v[ba>>2]-p|0,Wn(v[ja>>2]))|0,v[Ia+624>>2]=Ja;break Td}m=v[e+60>>2];if(!v[e+56>>2]&(m|0)<=0|(m|0)<0){break Vd}if(G>>>0<2|g>>>0>h>>>0){break Ud}v[e+104>>2]=l;v[e+108>>2]=k;v[e+96>>2]=0;v[e+100>>2]=g;Ia=e,Ja=pg(e+96|0,e+104|0),v[Ia+80>>2]=Ja;v[e+84>>2]=mb;v[e+72>>2]=1;v[e+76>>2]=0;Ia=e,Ja=pg(e+80|0,e+72|0),v[Ia+88>>2]=Ja;v[e+92>>2]=mb;Ia=e,Ja=cm(e+88|0,n,o)+1|0,v[Ia+44>>2]=Ja;break Td}if((m|0)>0|(m|0)>=0){break Ud}if((h|0)>=(p|0)){break Td}v[e+96>>2]=l;v[e+100>>2]=k;v[e+104>>2]=0;v[e+108>>2]=p;Ia=e,Ja=pg(e+96|0,e+104|0),v[Ia+80>>2]=Ja;v[e+84>>2]=mb;v[e+72>>2]=1;v[e+76>>2]=0;Ia=e,Ja=pg(e+80|0,e+72|0),v[Ia+88>>2]=Ja;v[e+92>>2]=mb;Ia=e,Ja=cm(e+88|0,n,o)+1|0,v[Ia+44>>2]=Ja;break Td}j=v[V>>2];if((j|0)>(h|0)){break Td}v[e+104>>2]=l;v[e+108>>2]=k;v[e+96>>2]=0;v[e+100>>2]=j;Ia=e,Ja=pg(e+96|0,e+104|0),v[Ia+80>>2]=Ja;v[e+84>>2]=mb;v[e+72>>2]=1;v[e+76>>2]=0;Ia=e,Ja=pg(e+80|0,e+72|0),v[Ia+88>>2]=Ja;v[e+92>>2]=mb;Ia=e,Ja=cm(e+88|0,n,o)+1|0,v[Ia+44>>2]=Ja}Vn(e+44|0,1,v[e+68>>2]);h=v[e+44>>2];if((h|0)>0){break Jd}}v[X+624>>2]=0;v[V>>2]=0;v[i>>2]=0;v[i+4>>2]=0;v[aa>>2]=0;n=0;h=i;g=v[h+96>>2];p=v[h+92>>2];if(g|p){if(q){while(1){i=(n<<3)+f|0;p=p-(((-2147483648-p>>>31|0)-1&255)+p>>8)|0;v[i>>2]=p+v[i>>2];g=g-(((-2147483648-g>>>31|0)-1&255)+g>>8)|0;v[i+4>>2]=g+v[i+4>>2];n=n+1|0;if((n|0)!=(q|0)){continue}break}}v[h+96>>2]=g;v[h+92>>2]=p}v[da>>2]=v[da>>2]+v[_>>2];v[ga>>2]=v[ga>>2]+v[Y>>2];v[Y>>2]=0;v[_>>2]=0;v[R>>2]=v[R>>2]&-129;j=x[e+30>>1];break Id}Xd:{Yd:{j=x[e+30>>1];if(j>>>0<y[I+24608>>2]){o=4;if(v[aa>>2]){break Yd}o=0;if(v[qa>>2]|v[ra>>2]){break Yd}}Ia=e,Ja=qma(v[W>>2],v[W+4>>2],h,h>>31),v[Ia+104>>2]=Ja;v[e+108>>2]=mb;Sb(i,e+104|0);ha=0;v[Y>>2]=0;v[_>>2]=0;f=(h<<3)+f|0;break Xd}g=(h<<3)+f|0;k=g-8|0;v[_>>2]=0-v[k>>2];m=g-4|0;v[Y>>2]=0-v[m>>2];nb[v[((o|Ba)<<2)+72592>>2]](i,ya,f,h);v[_>>2]=v[_>>2]+v[k>>2];v[Y>>2]=v[Y>>2]+v[m>>2];ha=1;f=g}g=v[aa>>2];Zd:{if(!g){break Zd}if(g>>>0<=h>>>0){v[aa>>2]=0;v[ra>>2]=v[Ha>>2];v[qa>>2]=v[Ga>>2];v[Fa>>2]=0;v[Ea>>2]=0;if(v[Da>>2]|!(w[R+1|0]&16)){break Zd}v[V>>2]=0;v[X+624>>2]=0;break Zd}v[aa>>2]=g-h}G=0;p=0;g=v[i+4>>2];p=g>>>0>=y[ba>>2]?(w[R|0]&2)>>>1|0:p;m=g;g=v[V>>2];G=m>>>0<g>>>0|(!g|w[R|0]&2)?G:!x[Ca>>1];q=q-h|0;g=e+104|0;Fb(g,la,85);_d:{$d:{ae:{be:{if(!Cb(g)){break be}g=w[pa|0];if(!g|g>>>0>x[I+480190>>1]){break be}g=I+B(w[pa|0],104)|0;h=g+484380|0;k=v[ja>>2];if((h|0)==(k|0)|(p|G)!=1){break ae}v[ja>>2]=h;v[X+624>>2]=v[g+484400>>2];h=x[g+484414>>1];v[R>>2]=h|v[R>>2]&-768;m=h<<30>>31;h=v[g+484388>>2];v[V>>2]=m&h;g=v[g+484384>>2];v[ka>>2]=g;v[ba>>2]=h;v[i+4>>2]=g;uC(N,i);if(!v[X+624>>2]){break Id}if((q|0)>0){continue}break Id}if(p){break $d}break _d}if(!p|(h|0)!=(k|0)){break _d}}g=e+104|0;Fb(g,la,83);if(!Cb(g)|v[ka>>2]){break _d}v[i>>2]=v[i>>2];v[i+4>>2]=0;g=v[v[ja>>2]+8>>2];v[V>>2]=g;v[ba>>2]=g}if((q|0)>0){continue}}break}v[X+624>>2]=v[e+8>>2];u[e+30>>1]=j+ha;ce:{if(!ha|!ea|ea>>>0>250){break ce}f=v[(I+B(ea,160)|0)+906140>>2];if(!f){break ce}nb[v[v[f>>2]+144>>2]](f)}p=x[I+480212>>1]}K=K+1|0;if(p>>>0>K>>>0){continue}break}}Ia=I,Ja=x[Ri(I+480214|0,e+30|0)>>1],u[Ia+480214>>1]=Ja}jb=e+112|0;if(qd(na)){f=ia;q=A;e=(B(v[a+480232>>2],v[a+480236>>2])>>>0)/48|0;I=jb-16|0;jb=I;r=v[na>>2];de:{if(!w[r+530|0]){break de}g=qma(e,0,6169,0);e=mb;j=e>>>16|0;M=dd((e&65535)<<16|g>>>16,j);if(!q){break de}while(1){e=v[r>>2];i=v[e>>2];g=v[e+4>>2];if((i|0)<=(g|0)){j=e+14|0;k=e+12|0;while(1){v[e+8>>2]=v[e+12>>2];g=e;m=k;l=j;K=0;n=0;F=0;i=jb-16|0;jb=i;while(1){p=g+B(F,44)|0;ee:{if(!w[p+56|0]){u[i+12>>1]=0;u[i+14>>1]=0;break ee}s=v[p+32>>2];h=x[s+3840>>1];if(h&3){s=(x[p+36>>1]>>>7&7)>>>(w[s+3844|0]^1)>>>(h&1)<<x[p+38>>1];h=h&4?0-s|0:s}else{h=0}s=i;o=v[p+52>>2];fe:{if(o){E=x[o+32>>1];Q=x[p+48>>1];o=Rf(v[p+16>>2],v[p+40>>2],h<<16>>16,0,u[p+46>>1]);G=v[p+40>>2];T=v[p+20>>2];if(!E){if(!Q){h=h<<16>>16;o=Rf(T,G,h,o,0);o=Rf(v[p+24>>2],v[p+40>>2],h,o,0);h=Rf(v[p+28>>2],v[p+40>>2],h,o,0);break fe}h=h<<16>>16;G=Rf(T,G,h,0,0);G=Rf(v[p+24>>2],v[p+40>>2],h,G,0);h=Rf(v[p+28>>2],v[p+40>>2],h,G,0)+o|0;break fe}if(!Q){h=h<<16>>16;o=Rf(T,G,h,o,0);G=Rf(v[p+24>>2],v[p+40>>2],h,0,0);h=Rf(v[p+28>>2],v[p+40>>2],h,G,0)+o|0;break fe}h=h<<16>>16;G=Rf(T,G,h,0,0);h=(Rf(v[p+24>>2],v[p+40>>2],h,G,0)+o|0)+Rf(v[p+28>>2],v[p+40>>2],h,0,0)|0;break fe}Q=x[p+48>>1];h=h<<16>>16;o=Rf(v[p+16>>2],v[p+40>>2],h,0,u[p+46>>1]);G=v[p+40>>2];T=v[p+20>>2];if(!Q){h=Rf(T,G,h,o,0);break fe}h=Rf(T,G,h,0,0)+o|0}u[s+14>>1]=w[p+57|0]?h:0;u[i+12>>1]=w[p+58|0]?h:0}K=u[i+12>>1]+K|0;n=u[i+14>>1]+n|0;F=F+1|0;if((F|0)!=18){continue}break}h=(n|0)<32767?n:32767;u[m>>1]=(h|0)>-32768?h:-32768;h=(K|0)<32767?K:32767;u[l>>1]=(h|0)>-32768?h:-32768;u[g+3832>>1]=x[g+3832>>1]+1;h=(x[g+3834>>1]+1>>>0)%13440|0;u[g+3834>>1]=h;h=h>>>0<6720?h:13440-h|0;u[g+3836>>1]=(h&65280)>>>8;if(!w[g+3843|0]){u[g+3836>>1]=(h&64512)>>>10}h=x[g+3838>>1]+1|0;u[g+3838>>1]=h;if((h&65535)>>>0>=1024){u[g+3838>>1]=0;u[g+3840>>1]=x[g+3840>>1]+1&7}jb=i+16|0;i=v[e>>2];g=v[e+4>>2]-i|0;v[e+4>>2]=g;if((g|0)>=(i|0)){continue}break}}h=i-g|0;u[I+14>>1]=(B(u[e+12>>1],g)+B(h,u[e+8>>1])|0)/(i|0);u[I+12>>1]=(B(u[e+14>>1],g)+B(h,u[e+10>>1])|0)/(i|0);v[e+4>>2]=g+49716;v[f>>2]=v[f>>2]+B(M,u[I+14>>1]);v[f+4>>2]=v[f+4>>2]+B(M,u[I+12>>1]);f=f+8|0;q=q-1|0;if(q){continue}break}}jb=I+16|0}g=ia;f=A;q=wa;e=v[q+4116>>2];if(e|v[q+4120>>2]){if(!e){on(q+8|0,f,q+4104|0,q+4108|0)}h=v[q>>2];j=v[q+4184>>2];e=B(h,j)>>>4|0;e=e>>>0<32767?e:32767;u[q+4202>>1]=e;u[q+4200>>1]=e;k=v[q+54052>>2];e=B(k,h)>>>4|0;e=e>>>0<65536?e:65536;i=e+127>>>3|0;u[q+54050>>1]=i;e=e+255>>>4|0;u[q+54048>>1]=e;u[q+54046>>1]=e;u[q+54044>>1]=i;e=g;i=q+8|0;m=i;j=(j|0)>(k|0)?j:k;h=36-h>>>1|0;h=16-(h>>>0>8?h:8)|0;k=16-(B((j|0)<32768?j:32768,h>>>0>16?0:h)>>15)|0;j=0;h=f;if(f){while(1){l=j<<3;n=l+e|0;v[n>>2]=v[n>>2]+B(k,v[l+m>>2]>>4);l=l|4;n=l+e|0;v[n>>2]=v[n>>2]+B(k,v[l+m>>2]>>4);j=j+1|0;if((h|0)!=(j|0)){continue}break}}j=i;h=0;e=q;m=v[e+4144>>2];k=v[e+4140>>2];if(f){n=u[e+4188>>1];while(1){l=(h<<3)+j|0;s=v[l>>2]>>12;k=(B(n,s-k|0)>>15)+s|0;v[l>>2]=k;p=l;l=v[l+4>>2]>>12;m=(B(n,l-m|0)>>15)+l|0;v[p+4>>2]=m;h=h+1|0;if((f|0)!=(h|0)){continue}break}}s=q+4172|0;v[e+4144>>2]=m;v[e+4140>>2]=k;ge:{if(!f){m=v[s>>2];break ge}e=s;m=x[e+22>>1];k=x[e+20>>1];l=v[e+4>>2];h=f;if(f){p=u[e+26>>1];T=u[e+18>>1];I=u[e+24>>1];M=u[e+16>>1];n=v[e>>2]-1|0;o=e+32928|0;while(1){F=Pc(v[j>>2]);G=Pc(v[j+4>>2]);k=Pc((k<<16>>16)-F|0);m=Pc((m<<16>>16)-G|0);k=Rc(Pc((B(k,M)|0)/65536<<1)+F|0);m=Rc(Pc((B(m,T)|0)/65536<<1)+G|0);G=o+(l<<2)|0;F=u[G+2>>1];Q=u[G>>1];G=Rc(((B(Q,I)|0)/-65536|0)+k|0);l=l+1&127;r=o+(l<<2)|0;E=Rc(((B(p,F)|0)/-65536|0)+m|0);u[r+2>>1]=E;u[r>>1]=G;n=n+1&8191;r=e+(n<<2)|0;Ia=r,Ja=Rc(Q+((B(G,I)|0)/65536|0)|0),u[Ia+160>>1]=Ja;Ia=r,Ja=Rc(F+((B(p,E)|0)/65536|0)|0),u[Ia+162>>1]=Ja;j=j+8|0;h=h-1|0;if(h){continue}break}}I=q+53996|0;u[e+22>>1]=m;u[e+20>>1]=k;v[e+4>>2]=l;j=v[q+4180>>2];E=q+37612|0;e=i;h=f;while(1){k=j&4095;o=E+(k<<2)|0;m=e;k=4096-k|0;Q=j-v[q+53996>>2]&4095;j=4096-Q|0;j=j>>>0>k>>>0?k:j;j=h>>>0>j>>>0?j:h;p=j>>>0<64?j:64;j=p;l=0;G=jb-32|0;jb=G;k=s;n=v[k>>2];while(1){v[G+(l<<2)>>2]=n+(v[(k+(l<<4)|0)+32>>2]^-1);l=l+1|0;if((l|0)!=7){continue}break}l=u[k+28>>1]/8|0;if(j){T=l<<16>>16;while(1){K=0;F=0;l=0;while(1){n=G+(l<<2)|0;M=v[n>>2]+1&8191;v[n>>2]=M;J=F;F=k+(M<<2)|0;M=u[F+160>>1];n=k+(l<<4)|0;r=u[F+162>>1];F=(J+B(M,u[n+44>>1])|0)+B(r,u[n+46>>1])|0;K=(B(M,u[n+40>>1])+K|0)+B(r,u[n+42>>1])|0;l=l+1|0;if((l|0)!=4){continue}break}n=0;l=4;r=Rc((K|0)/32768|0);H=Rc((F|0)/32768|0);K=0;while(1){F=G+(l<<2)|0;M=v[F>>2]+1&8191;v[F>>2]=M;M=k+(M<<2)|0;J=u[M+160>>1];F=k+(l<<4)|0;M=u[M+162>>1];K=(B(J,u[F+44>>1])+K|0)+B(M,u[F+46>>1])|0;n=(B(J,u[F+40>>1])+n|0)+B(M,u[F+42>>1])|0;l=l+1|0;if((l|0)!=7){continue}break}l=Rc(r+((n|0)/32768|0)|0);u[o>>1]=l;v[m>>2]=B(l,T);l=Rc(H+((K|0)/32768|0)|0);u[o+2>>1]=l;v[m+4>>2]=B(l,T);m=m+8|0;o=o+4|0;j=j-1|0;if(j){continue}break}}jb=G+32|0;o=E+(Q<<2)|0;m=e;j=I;K=v[j+4>>2];n=K&2047;l=p;if(l){k=j+8256|0;F=j- -64|0;G=j+24640|0;T=j+16448|0;while(1){H=u[(k+((K+754&2047)<<2)|0)+2>>1];J=u[k+((K+1206&2047)<<2)>>1];Q=u[(F+((K+1602&2047)<<2)|0)+2>>1];r=u[F+((K+1750&2047)<<2)>>1];N=G+((K+22&2047)<<2)|0;M=u[N+2>>1];N=u[N>>1];V=G+((K+502&2047)<<2)|0;R=u[V+2>>1];W=u[o>>1];X=u[o+2>>1];V=u[V>>1];Y=Pc(u[j+32>>1]-V|0);_=u[j+24>>1];aa=Pc(u[j+34>>1]-R|0);ba=u[j+26>>1];ga=Pc(u[j+36>>1]-N|0);da=u[j+28>>1];ea=Pc(u[j+38>>1]-M|0);ha=u[j+30>>1];Ia=j,Ja=Rc(Pc((B(Y,_)|0)/65536<<1)+V|0),u[Ia+32>>1]=Ja;Ia=j,Ja=Rc(Pc((B(aa,ba)|0)/65536<<1)+R|0),u[Ia+34>>1]=Ja;Ia=j,Ja=Rc(Pc((B(ga,da)|0)/65536<<1)+N|0),u[Ia+36>>1]=Ja;Ia=j,Ja=Rc(Pc((B(ea,ha)|0)/65536<<1)+M|0),u[Ia+38>>1]=Ja;M=Pc((B(u[j+32>>1],u[j+16>>1])|0)/32768|0);R=Pc((B(u[j+38>>1],u[j+22>>1])|0)/32768|0);N=Pc(M+((W|0)/4<<16>>16)|0);R=Pc(R+((X|0)/4<<16>>16)|0);V=Pc(N+((B(r,u[j+8>>1])|0)/-65536|0)|0);M=n<<2;W=M+F|0;X=Pc(R+((B(Q,u[j+10>>1])|0)/-65536|0)|0);u[W+2>>1]=X;u[W>>1]=V;r=Pc(r+((B(V,u[j+8>>1])|0)/65536|0)|0);V=M+T|0;Q=Pc(Q+((B(X,u[j+10>>1])|0)/65536|0)|0);u[V+2>>1]=Q;u[V>>1]=r;N=Pc(r+N|0);R=Pc(R+Q|0);Q=T+((K+426&2047)<<2)|0;V=u[Q+2>>1];W=u[Q>>1];Q=T+((K+682&2047)<<2)|0;K=u[Q+2>>1];X=u[Q>>1];Q=Pc((B(K,u[j+42>>1])+B(X,u[j+40>>1])|0)/32768|0);r=Pc((B(V,u[j+46>>1])+B(W,u[j+44>>1])|0)/32768|0);X=Pc(Pc(N+X|0)-Q|0);K=Pc(Pc(K+R|0)-r|0);N=Pc(Pc(N+W|0)-Q|0);R=Pc(Pc(R+V|0)-r|0);Q=Pc(Q+((B(J,u[j+8>>1])|0)/-65536|0)|0);r=Pc(r+((B(H,u[j+10>>1])|0)/-65536|0)|0);V=u[j+8>>1];W=u[j+10>>1];Y=k+M|0;u[Y+2>>1]=r;u[Y>>1]=Q;ca=J;J=(B(V,Q)|0)/65536|0;Q=Pc(ca+J|0);M=G+M|0;r=(B(r,W)|0)/65536|0;H=Pc(r+H|0);u[M+2>>1]=H;u[M>>1]=Q;M=Pc(Q+X|0);Q=u[j+48>>1];H=Pc(H+K|0);v[m>>2]=(v[m>>2]+B(M,Q)|0)+B(H,u[j+50>>1]);M=Pc(Pc(J)+N|0);Q=u[j+52>>1];r=Pc(Pc(r)+R|0);v[m+4>>2]=(v[m+4>>2]+B(M,Q)|0)+B(r,u[j+54>>1]);m=m+8|0;o=o+4|0;K=n+1|0;n=K&2047;l=l-1|0;if(l){continue}break}}v[j+4>>2]=n;j=p+v[q+4180>>2]&4095;v[q+4180>>2]=j;m=p+v[q+4172>>2]&8191;v[q+4172>>2]=m;e=(p<<3)+e|0;h=h-p|0;if(h){continue}break}}v[q+4172>>2]=m&8191;e=i;i=0;j=0;n=q;l=v[n+4160>>2];K=v[n+4156>>2];h=f;if(f){m=v[n+4164>>2];k=v[n+4168>>2];while(1){i=v[e>>2];j=v[e+4>>2];k=k-j|0;k=(((k|0)/1024|0)-k|0)+l|0;v[g+4>>2]=k+v[g+4>>2];m=m-i|0;m=(((m|0)/1024|0)-m|0)+K|0;v[g>>2]=m+v[g>>2];l=k+((k|0)/-512|0)|0;K=m+((m|0)/-512|0)|0;g=g+8|0;e=e+8|0;k=j;m=i;h=h-1|0;if(h){continue}break}}v[n+4168>>2]=j;v[n+4164>>2]=i;v[n+4160>>2]=l;v[n+4156>>2]=K;g=v[q+4124>>2];he:{if(v[q+4116>>2]){break he}e=v[q+4120>>2];if(e>>>0>f>>>0){g=e-f|0;break he}zI(q);g=0}f=g;v[q+4116>>2]=0;v[q+4120>>2]=f}if(v[a+946300>>2]){l=0;p=0;h=A;i=h<<2;k=a;j=x[k+480214>>1]!=0;f=k+1074332|0;Z=z[f>>2];sa=z[f+4>>2];while(1){m=(k+B(l,160)|0)+906300|0;f=v[m>>2];ie:{if(!f|!v[f+24>>2]){break ie}if(!vh(f+44|0)){break ie}f=v[m>>2];if(!(nb[v[v[f>>2]+108>>2]](f)|0)){nb[v[v[f>>2]+104>>2]](f,1);nb[v[v[f>>2]+116>>2]](f)}g=f+44|0;e=Jd(g,0);g=Jd(g,1);je:{if(t[f+28|0]&1){Ty(v[f+24>>2],e,g,h,Z);break je}q=f+40|0;if(v[f+36>>2]?1:v[q>>2]){on(v[f+24>>2],h,q,f+36|0);Ty(v[f+24>>2],e,g,h,Z);break je}Qb(e,0,i);Qb(g,0,i)}v[f+28>>2]=v[f+28>>2]&-2;if(Ou(m)){break ie}j=!(w[f+28|0]&4)|j}l=l+1|0;if((l|0)!=250){continue}break}n=k+12|0;m=k+12300|0;q=k+14348|0;Ty(n,m,q,h,Z);f=k+1074464|0;M=w[f|0];t[f|0]=0;f=m;g=q;while(1){s=(k+B(p,160)|0)+906300|0;e=v[s>>2];ke:{if(!e|!v[e+24>>2]){break ke}if(!vh(e+44|0)){break ke}o=v[s>>2];le:{if(Ou(s)){break le}e=v[s>>2];if(nb[v[v[e>>2]+140>>2]](e)|w[v[s>>2]+28|0]&2){break le}l=0;if(!p){break ke}while(1){if((Hj((k+B(l,160)|0)+906300|0)|0)==(p|0)){break le}l=l+1|0;if((l|0)!=(p|0)){continue}break}break ke}e=o+44|0;F=Jd(e,0);T=Jd(e,1);I=v[s>>2];G=(f|0)==(F|0);f=G?m:f;e=f;g=G?q:g;i=g;me:{if(!(w[s+28|0]|w[s+29|0]<<8|(w[s+30|0]<<16|w[s+31|0]<<24))){break me}e=f;l=Hj(s);i=g;if(l>>>0<=p>>>0){break me}i=g;if(l>>>0>249){break me}l=v[(k+B(l,160)|0)+906300>>2];i=g;if(!l){break me}if(!(w[I+28|0]&4)){nb[v[v[l>>2]+144>>2]](l)}l=l+44|0;i=g;if(!vh(l)){break me}e=Jd(l,0);i=Jd(l,1)}ne:{if(!Ou(s)){break ne}oe:{if(G){break oe}l=0;if(!h){break oe}while(1){G=l<<2;Q=G+F|0;r=Q;Z=z[Q>>2];Q=f+G|0;z[r>>2]=Z+z[Q>>2];r=G+T|0;G=g+G|0;z[r>>2]=z[r>>2]+z[G>>2];v[Q>>2]=0;v[G>>2]=0;l=l+1|0;if((h|0)!=(l|0)){continue}break}}g=i;f=e;if(!(j&1)){break ne}f=v[s>>2];if(f){nb[v[v[f>>2]+144>>2]](f)}f=e;l=Hj(s);if(l>>>0>249|l>>>0<=p>>>0){break ne}while(1){g=l&255;f=(k+B(g,160)|0)+906300|0;l=Hj(f);f=v[f>>2];if(f){nb[v[v[f>>2]+144>>2]](f)}if(g>>>0<l>>>0&l>>>0<=249){continue}break}g=i;f=e}pe:{qe:{if(!((w[s+24|0]&2)>>>1|0)){if(!tC(s)|!(w[I+28|0]&4)){break qe}}l=0;if(!h){break pe}while(1){s=l<<2;o=s+e|0;z[o>>2]=z[o>>2]+z[s+F>>2];o=i+s|0;z[o>>2]=z[o>>2]+z[s+T>>2];l=l+1|0;if((h|0)!=(l|0)){continue}break}break pe}if(M){nb[v[v[o>>2]+124>>2]](o)}nb[v[v[o>>2]+60>>2]](o,e,i,h);v[I+32>>2]=h+v[I+32>>2];if(!tC(s)){break pe}if((nb[v[v[o>>2]+152>>2]](o)|0)<=0|y[I+32>>2]<v[k+24620>>2]<<2>>>0){break pe}l=0;re:{if(!h){break re}while(1){se:{s=l<<2;Z=z[s+e>>2];if(Z>=C(1.1920928955078125e-7)|Z<=C(-1.1920928955078125e-7)){break se}Z=z[i+s>>2];if(Z>=C(1.1920928955078125e-7)|!(Z>C(-1.1920928955078125e-7))){break se}l=l+1|0;if((h|0)!=(l|0)){continue}break re}break}v[I+32>>2]=0;break pe}v[I+28>>2]=v[I+28>>2]|4}v[I+28>>2]=v[I+28>>2]&-3}p=p+1|0;if((p|0)!=250){continue}break}e=0;if(h){while(1){i=n;Z=C(z[f>>2]*sa);te:{if(C(D(Z))<C(2147483648)){j=~~Z;break te}j=-2147483648}v[i>>2]=j;i=n;Z=C(z[g>>2]*sa);ue:{if(C(D(Z))<C(2147483648)){j=~~Z;break ue}j=-2147483648}v[i+4>>2]=j;n=n+8|0;g=g+4|0;f=f+4|0;e=e+1|0;if((h|0)!=(e|0)){continue}break}}}if(v[a+24624>>2]==1){f=ia;e=0;g=A;if(g){while(1){i=f+(e<<3)|0;v[f+(e<<2)>>2]=(v[i+4>>2]+v[i>>2]|0)/2;e=e+1|0;if((g|0)!=(e|0)){continue}break}}}if(w[va+36|0]){i=A;k=jb-16|0;jb=k;ve:{we:{f=a;xe:{if(!v[f+1074376>>2]){g=f+1074448|0;v[g>>2]=0;v[g+4>>2]=0;v[f+1074456>>2]=v[f+1074444>>2];break xe}h=v[f+1074456>>2];e=v[f+1074444>>2];ye:{if((h|0)==(e|0)){q=v[f+1074448>>2];break ye}v[f+1074456>>2]=e;g=f+24604|0;j=f+1074448|0;ze:{if((e|0)>(h|0)){q=cO(g);break ze}q=bO(g)}v[j>>2]=q;v[f+1074452>>2]=q}g=f+1074448|0;if((q|0)>0){break we}}h=0;break ve}j=(v[f+1074456>>2]<<12)-v[f+1074460>>2]|0;h=(j|0)/(q|0)|0;if(v[f+1074372>>2]!=2){break ve}v[k+12>>2]=50;e=f+1074452|0;v[k+8>>2]=1e4/(v[e>>2]+1|0);m=h>>31;l=m+h^m;m=v[yf(k+12|0,k+8|0)>>2];if((l|0)<=(m|0)){break ve}l=v[e>>2];q=v[g>>2];while(1){q=l+q|0;h=(j|0)/(q|0)|0;e=h>>31;if((m|0)<(e^e+h)){continue}break}v[g>>2]=q}Ae:{Be:{switch(v[f+24624>>2]-1|0){case 0:if((i|0)<=0){break Ae}e=v[f+1074444>>2];l=e<<12;j=e;n=e>>31;q=f+12|0;e=0;while(1){Ce:{if(v[g>>2]>0){m=v[f+1074460>>2]+h|0;v[f+1074460>>2]=m;s=v[q>>2];Ia=q,Ja=zc(rma(qma(s,s>>31,m,m>>31),mb,1048576,0),mb),v[Ia>>2]=Ja;v[f+1074448>>2]=v[f+1074448>>2]-1;break Ce}m=v[q>>2];Ia=q,Ja=zc(rma(qma(m,m>>31,j,n),mb,256,0),mb),v[Ia>>2]=Ja;v[f+1074460>>2]=l}q=q+4|0;e=e+1|0;if((i|0)!=(e|0)){continue}break};break Ae;case 1:if((i|0)<=0){break Ae}e=v[f+1074444>>2];n=e<<12;j=e;m=e>>31;q=f+12|0;e=0;while(1){De:{if(v[g>>2]>0){l=v[f+1074460>>2]+h|0;v[f+1074460>>2]=l;s=v[q>>2];Ia=q,Ja=zc(rma(qma(s,s>>31,l,l>>31),mb,1048576,0),mb),v[Ia>>2]=Ja;l=v[f+1074460>>2];p=l;s=l>>31;l=v[q+4>>2];Ia=q,Ja=zc(rma(qma(p,s,l,l>>31),mb,1048576,0),mb),v[Ia+4>>2]=Ja;v[f+1074448>>2]=v[f+1074448>>2]-1;break De}l=v[q>>2];Ia=q,Ja=zc(rma(qma(l,l>>31,j,m),mb,256,0),mb),v[Ia>>2]=Ja;l=v[q+4>>2];Ia=q,Ja=zc(rma(qma(l,l>>31,j,m),mb,256,0),mb),v[Ia+4>>2]=Ja;v[f+1074460>>2]=n}q=q+8|0;e=e+1|0;if((i|0)!=(e|0)){continue}break};break Ae;case 3:break Be;default:break Ae}}if((i|0)<=0){break Ae}e=v[f+1074444>>2];n=e<<12;j=e;m=e>>31;q=f+12|0;e=f+8204|0;K=0;while(1){Ee:{if(v[g>>2]>0){l=v[f+1074460>>2]+h|0;v[f+1074460>>2]=l;s=v[q>>2];Ia=q,Ja=zc(rma(qma(s,s>>31,l,l>>31),mb,1048576,0),mb),v[Ia>>2]=Ja;l=v[f+1074460>>2];p=l;s=l>>31;l=v[q+4>>2];Ia=q,Ja=zc(rma(qma(p,s,l,l>>31),mb,1048576,0),mb),v[Ia+4>>2]=Ja;l=v[f+1074460>>2];p=l;s=l>>31;l=v[e>>2];Ia=e,Ja=zc(rma(qma(p,s,l,l>>31),mb,1048576,0),mb),v[Ia>>2]=Ja;l=v[f+1074460>>2];p=l;s=l>>31;l=v[e+4>>2];Ia=e,Ja=zc(rma(qma(p,s,l,l>>31),mb,1048576,0),mb),v[Ia+4>>2]=Ja;v[f+1074448>>2]=v[f+1074448>>2]-1;break Ee}l=v[q>>2];Ia=q,Ja=zc(rma(qma(l,l>>31,j,m),mb,256,0),mb),v[Ia>>2]=Ja;l=v[q+4>>2];Ia=q,Ja=zc(rma(qma(l,l>>31,j,m),mb,256,0),mb),v[Ia+4>>2]=Ja;l=v[e>>2];Ia=e,Ja=zc(rma(qma(l,l>>31,j,m),mb,256,0),mb),v[Ia>>2]=Ja;l=v[e+4>>2];Ia=e,Ja=zc(rma(qma(l,l>>31,j,m),mb,256,0),mb),v[Ia+4>>2]=Ja;v[f+1074460>>2]=n}e=e+8|0;q=q+8|0;K=K+1|0;if((i|0)!=(K|0)){continue}break}}jb=k+16|0}if(v[ma>>2]!=128){g=a+12|0;i=a+8204|0;f=A;e=v[a+24604>>2];h=v[a+24624>>2];Fe:{if((e|0)==128|h>>>0<2){break Fe}MK(g,f,e);if(h>>>0<4){break Fe}MK(i,f,e)}}i=c;h=ia;f=v[a+24624>>2];if((f|0)==4){f=ia;g=ua;e=A-1|0;if((e|0)>=0){while(1){j=f+(e<<4)|0;k=e<<3;m=k|4;v[j+12>>2]=v[m+g>>2];v[j+8>>2]=v[g+k>>2];v[j+4>>2]=v[f+m>>2];v[j>>2]=v[f+k>>2];j=(e|0)>0;e=e-1|0;if(j){continue}break}}f=v[a+24624>>2]}nb[v[v[c>>2]+8>>2]](i,h,f,A);q=v[a+1074380>>2]-A|0;v[a+1074380>>2]=q;v[a+1074376>>2]=A+v[a+1074376>>2];ta=A+ta|0;f=v[a+480208>>2];if(f&512){break g}b=b-A|0;if(b){continue}break}}jb=$+32|0;return ta|0}function Ska(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,z=0,A=0,C=0,D=0;d=jb-608|0;jb=d;Ic(b);g=jb-16|0;jb=g;k=g+8|0;h=d+416|0;$p(k,h);j=Hb(k);e=b;k=mc(e,$b(g,k));if((j|0)==(k|0)){_b(e,Hb(g+8|0))}jb=g+16|0;e=(j|0)==(k|0);if(!e){xR(h)}a:{b:{c:{if(!e){break c}if(!aS(d+416|0)){break c}if(!Rb(b,dd($R(d+416|0),mb))){break c}if(!c){f=1;break c}Id(a,32);t[d+415|0]=0;k=bd(d+400|0);d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{v:{w:{x:{y:{z:{A:{B:{C:{D:{E:{F:{G:{H:{if(v[d+416>>2]==778924148){v[113382]=0;R(583,a|0,16777216);e=v[113382];v[113382]=0;if((e|0)==1){break b}v[113382]=0;e=T(225,b|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break b}v[113382]=0;Q(226,b|0,e-4|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break b}v[113382]=0;r=T(397,b|0)|0;e=v[113382];v[113382]=0;if((e|0)!=1){break H}break b}I:{J:{K:{L:{M:{e=w[d+456|0]|w[d+457|0]<<8;N:{if(e>>>0<2185|e>>>0>4095){break N}v[113382]=0;e=T(225,b|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break b}v[113382]=0;Q(226,b|0,e-4|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break b}v[113382]=0;r=T(397,b|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break b}if(r>>>0<256){break N}v[113382]=0;e=T(225,b|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break b}if(e>>>0<=r>>>0){break N}v[113382]=0;e=Q(226,b|0,r|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break b}if(!e){break N}v[113382]=0;e=Q(584,b|0,10439)|0;f=v[113382];v[113382]=0;if((f|0)==1){break b}if(!e){break N}v[113382]=0;R(583,a|0,16777216);e=v[113382];v[113382]=0;if((e|0)==1){break b}if((w[d+456|0]|w[d+457|0]<<8)>>>0>=4096){v[113382]=0;b=Q(585,d+224|0,12528)|0;c=v[113382];v[113382]=0;if((c|0)==1){break G}v[113382]=0;R(586,a|0,b|0);a=v[113382];v[113382]=0;if((a|0)!=1){yb(b);f=0;break d}f=P()|0;O()|0;yb(b);break a}if((w[d+456|0]|w[d+457|0]<<8)>>>0<2194){break N}v[113382]=0;e=Q(585,d+224|0,12080)|0;f=v[113382];v[113382]=0;if((f|0)==1){break M}v[113382]=0;R(586,a|0,e|0);f=v[113382];v[113382]=0;if((f|0)==1){break L}yb(e)}if(v[a+480180>>2]!=32){break H}if(((w[d+456|0]|w[d+457|0]<<8)&61440)!=20480){break I}e=(w[d+456|0]|w[d+457|0]<<8)&4095;f=e<<16;if(v[d+476>>2]!=1414548815){break K}t[d+415|0]=1;break J}f=P()|0;O()|0;break a}f=P()|0;O()|0;yb(e);break a}if(e>>>0<297){break J}f=w[d+476|0]|w[d+477|0]<<8|f}v[a+1074308>>2]=f;break H}if(!((w[d+458|0]|w[d+459|0]<<8)!=2184&(w[d+456|0]|w[d+457|0]<<8)!=2184)){t[d+415|0]=1;v[a+1074308>>2]=18284544;break H}if(!((w[d+456|0]|w[d+457|0]<<8)!=535|(w[d+458|0]|w[d+459|0]<<8)!=512|(w[d+476|0]|w[d+477|0]<<8|(w[d+478|0]<<16|w[d+479|0]<<24)))){v[113382]=0;e=W(587,d+480|0,255,64)|0;f=v[113382];v[113382]=0;if((f|0)==1){break b}O:{if(e){v[a+1074308>>2]=18219008;v[113382]=0;e=Q(2,d+224|0,10502)|0;f=v[113382];v[113382]=0;if((f|0)!=1){break O}f=P()|0;O()|0;break a}v[a+1074308>>2]=18284544;v[113382]=0;e=Q(2,d+224|0,12901)|0;f=v[113382];v[113382]=0;if((f|0)==1){break F}}Gb(k,e);yb(e);t[d+415|0]=1;break H}if(!((w[d+456|0]|w[d+457|0]<<8)!=532|(w[d+458|0]|w[d+459|0]<<8)!=514|(w[d+476|0]|w[d+477|0]<<8|(w[d+478|0]<<16|w[d+479|0]<<24)))){v[a+1074308>>2]=17367040;v[113382]=0;e=Q(2,d+224|0,10406)|0;f=v[113382];v[113382]=0;if((f|0)!=1){Gb(k,e);yb(e);t[d+415|0]=1;break H}f=P()|0;O()|0;break a}if((w[d+456|0]|w[d+457|0]<<8)!=768|(w[d+458|0]|w[d+459|0]<<8)!=768|(w[d+476|0]|w[d+477|0]<<8|(w[d+478|0]<<16|w[d+479|0]<<24)|(w[d+448|0]|w[d+449|0]<<8)!=256)){break H}if(w[d+469|0]|w[d+468|0]!=128){break H}v[a+1074308>>2]=18285088;t[d+415|0]=1}v[a+480208>>2]=v[a+480208>>2]&-17|(w[d+460|0]|w[d+461|0]<<8)<<1&16;v[a+480208>>2]=v[a+480208>>2]&-5|(w[d+460|0]|w[d+461|0]<<8)>>>2&4;v[a+480208>>2]=v[a+480208>>2]&-9|(w[d+460|0]|w[d+461|0]<<8)>>>2&8;v[a+480208>>2]=v[a+480208>>2]&-32769|(w[d+460|0]|w[d+461|0]<<8)<<3&32768;v[113382]=0;U(588,d+328|0,3,d+416|4);e=v[113382];v[113382]=0;if((e|0)==1){break E}v[113382]=0;R(356,d+224|0,d+328|0);e=v[113382];v[113382]=0;if((e|0)==1){break E}e=d+224|0;Gb(a+1304400|0,e);yb(e);if(!(!(w[d+462|0]&4)|(y[a+1074308>>2]<18285314?v[a+1074308>>2]:0))){v[a+480216>>2]=w[d+446|0];v[a+480220>>2]=w[d+447|0]}e=w[d+464|0];v[a+480200>>2]=e>>>0>128?256:e<<1;if(w[d+466|0]){v[a+480196>>2]=w[d+466|0]}t[d+224|0]=31;e=w[d+467|0];v[113382]=0;t[d+328|0]=e;e=Q(410,d+224|0,d+328|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break e}v[a+480204>>2]=B(w[e|0],1e4);e=w[d+465|0];v[113382]=0;t[d+224|0]=e;t[d+328|0]=128;e=Q(415,d+224|0,d+328|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break f}v[a+480228>>2]=w[e|0];f=0;while(1){j=(d+416|0)+f|0;g=j- -64|0;P:{if(w[g|0]==255){break P}v[113382]=0;h=(f<<5)+a|0;e=h+480280|0;Z(387,e|0);i=v[113382];v[113382]=0;if((i|0)==1){break D}C=h+480286|0,D=Ed(w[j+128|0],0,64),u[C>>1]=D;if(t[g|0]<0){v[e>>2]=v[e>>2]|1024}g=w[g|0]&127;if(g>>>0<=64){u[h+480284>>1]=g<<2;break P}if((g|0)!=100){break P}v[e>>2]=v[e>>2]|256}f=f+1|0;if((f|0)!=64){continue}break}v[113382]=0;Q(226,b|0,192)|0;e=v[113382];v[113382]=0;if((e|0)==1){break b}Q:{if(!(v[a+480180>>2]!=16777216|(w[d+456|0]|w[d+457|0]<<8)>>>0<2187|(w[d+456|0]|w[d+457|0]<<8)>>>0>2189)){f=0;v[113382]=0;e=T(323,b|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break C}if(e){break d}v[113382]=0;e=T(397,b|0)|0;g=v[113382];v[113382]=0;R:{if((g|0)==1){break R}if(e>>>0>x[v[18619]+12>>1]){break d}g=Vb(a+484360|0);v[113382]=0;e=ea(589,g|0,b|0,e|0,65535,65535)|0;g=v[113382];v[113382]=0;if((g|0)==1){break R}if(!e){break d}break Q}f=P()|0;O()|0;break a}e=Vb(a+484360|0);f=w[d+448|0]|w[d+449|0]<<8;v[113382]=0;ea(544,e|0,b|0,f|0,255,254)|0;e=v[113382];v[113382]=0;if((e|0)==1){break b}}q=Np(d+384|0);p=Np(d+368|0);m=Np(d+352|0);e=w[d+450|0]|w[d+451|0]<<8;f=0;v[113382]=0;e=W(590,b|0,q|0,e|0)|0;g=v[113382];v[113382]=0;S:{if((g|0)==1){break S}if(!e){break A}e=w[d+452|0]|w[d+453|0]<<8;v[113382]=0;e=W(590,b|0,p|0,e|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break S}if(!e){break A}e=w[d+454|0]|w[d+455|0]<<8;v[113382]=0;e=W(590,b|0,m|0,e|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break S}if(!e){break A}v[d+348>>2]=-1;C=d,D=ac(q),v[C+224>>2]=D;C=d,D=bc(q),v[C+328>>2]=D;if(!Jb(d+224|0,d+328|0)){break B}while(1){e=v[d+224>>2];e=w[e|0]|w[e+1|0]<<8|(w[e+2|0]<<16|w[e+3|0]<<24);if(!(!e|e>>>0>=y[d+348>>2])){v[d+348>>2]=e}e=d+224|0;Ie(e);if(Jb(e,d+328|0)){continue}break}break B}f=P()|0;O()|0;break g}f=P()|0;O()|0;break a}f=P()|0;O()|0;break a}f=P()|0;O()|0;break a}f=P()|0;O()|0;break a}f=P()|0;O()|0;break a}C=d,D=ac(p),v[C+224>>2]=D;C=d,D=bc(p),v[C+328>>2]=D;if(Jb(d+224|0,d+328|0)){while(1){e=v[d+224>>2];e=w[e|0]|w[e+1|0]<<8|(w[e+2|0]<<16|w[e+3|0]<<24);if(!(!e|e>>>0>=y[d+348>>2])){v[d+348>>2]=e}e=d+224|0;Ie(e);if(Jb(e,d+328|0)){continue}break}}C=d,D=ac(m),v[C+224>>2]=D;C=d,D=bc(m),v[C+328>>2]=D;if(Jb(d+224|0,d+328|0)){while(1){e=v[d+224>>2];e=w[e|0]|w[e+1|0]<<8|(w[e+2|0]<<16|w[e+3|0]<<24);if(!(!e|e>>>0>=y[d+348>>2])){v[d+348>>2]=e}e=d+224|0;Ie(e);if(Jb(e,d+328|0)){continue}break}}T:{U:{V:{W:{X:{Y:{Z:{_:{$:{aa:{ba:{ca:{da:{ea:{if(t[d+462|0]&1){e=w[d+472|0]|w[d+473|0]<<8|(w[d+474|0]<<16|w[d+475|0]<<24);v[113382]=0;v[d+224>>2]=e;e=Q(297,d+348|0,d+224|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break ea}v[d+348>>2]=v[e>>2]}f=0;e=w[d+456|0]|w[d+457|0]<<8;fa:{if((w[d+458|0]|w[d+459|0]<<8)!=532|(e?(e|0)!=532:0)|(w[d+447|0]|w[d+446|0])){break fa}if(w[d+460|0]&192|(w[d+469|0]|(w[d+476|0]|w[d+477|0]<<8|(w[d+478|0]<<16|w[d+479|0]<<24)))){break fa}ga:{if(!(w[d+452|0]|w[d+453|0]<<8)|(w[d+450|0]|w[d+451|0]<<8)){break ga}if((v[b+8>>2]+(Kb(p)<<2)|0)+2>>>0>y[d+348>>2]){break ga}if(w[d+452|0]|w[d+453|0]<<8){e=0;while(1){v[113382]=0;f=T(397,b|0)|0;g=v[113382];v[113382]=0;ha:{if((g|0)!=1){if(!f){break ha}mg(b,((e&65535)<<2)+4|0);break ga}f=P()|0;O()|0;break g}e=e+1|0;if((e&65535)>>>0<(w[d+452|0]|w[d+453|0]<<8)>>>0){continue}break}}v[113382]=0;e=Q(2,d+224|0,10646)|0;f=v[113382];v[113382]=0;if((f|0)==1){break ca}Gb(k,e);yb(e)}f=1;if(w[d+456|0]|w[d+457|0]<<8){break fa}v[113382]=0;e=Q(2,d+224|0,11402)|0;g=v[113382];v[113382]=0;if((g|0)==1){break ba}Gb(k,e);yb(e)}ia:{if(w[d+462|0]&2){v[113382]=0;e=T(323,b|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break aa}v[113382]=0;g=e<<3;h=Q(228,b|0,g|0)|0;j=v[113382];v[113382]=0;if((j|0)==1){break aa}if(!(!h|y[d+348>>2]<g+v[b+8>>2]>>>0)){v[113382]=0;g=a+1304500|0;R(591,g|0,e|0);h=v[113382];v[113382]=0;if((h|0)==1){break aa}C=d,D=ac(g),v[C+328>>2]=D;C=d,D=bc(g),v[C+312>>2]=D;if(Jb(d+328|0,d+312|0)){while(1){g=v[d+328>>2];v[113382]=0;Q(592,b|0,d+224|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break $}v[113382]=0;R(593,d+224|0,g|0);g=v[113382];v[113382]=0;if((g|0)==1){break $}g=d+328|0;v[g>>2]=v[g>>2]+48;if(Jb(g,d+312|0)){continue}break}}if(!(!e&f)){break ia}if(w[d+462|0]&4){v[113382]=0;e=Q(2,d+224|0,11435)|0;f=v[113382];v[113382]=0;if((f|0)!=1){Gb(k,e);yb(e);break ia}f=P()|0;O()|0;break g}v[113382]=0;e=Q(2,d+224|0,10680)|0;f=v[113382];v[113382]=0;if((f|0)!=1){Gb(k,e);yb(e);break ia}f=P()|0;O()|0;break g}mg(b,2);break ia}if(!f|(w[d+462|0]|w[d+463|0]<<8)>>>0>1){break ia}v[113382]=0;e=T(323,b|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break da}if(!e){v[113382]=0;e=Q(2,d+224|0,10646)|0;f=v[113382];v[113382]=0;if((f|0)!=1){Gb(k,e);yb(e);break ia}f=P()|0;O()|0;break g}mg(b,2)}ja:{if(!(w[d+462|0]&8?1:w[d+460|0]&128)){break ja}v[113382]=0;e=a+901404|0;f=Q(594,b|0,e|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break h}if(!f){break ja}v[113382]=0;Z(595,e|0);e=v[113382];v[113382]=0;if((e|0)==1){break h}}if((w[d+456|0]|w[d+457|0]<<8)>>>0<=531){v[113382]=0;Z(596,a+901404|0);e=v[113382];v[113382]=0;if((e|0)==1){break h}}v[113382]=0;s=T(244,d+328|0)|0;e=v[113382];v[113382]=0;ka:{la:{ma:{na:{oa:{pa:{if((e|0)!=1){v[113382]=0;e=Q(580,b|0,9805)|0;f=v[113382];v[113382]=0;if((f|0)==1){break pa}if(e){v[113382]=0;e=T(397,b|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break oa}v[113382]=0;U(307,d+224|0,b|0,e|0);e=v[113382];v[113382]=0;if((e|0)==1){break oa}e=d+224|0;Qd(s,e);Bb(e)}u[a+480188>>1]=1;v[113382]=0;e=Q(580,b|0,9810)|0;f=v[113382];v[113382]=0;if((f|0)==1){break pa}if(e){v[113382]=0;e=T(397,b|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break na}v[113382]=0;U(307,d+224|0,b|0,e|0);e=v[113382];v[113382]=0;if((e|0)==1){break na}v[113382]=0;e=T(225,d+224|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break ma}v[113382]=0;u[d+312>>1]=(e>>>0)/20;e=Q(438,23860,d+312|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break ma}e=x[e>>1];u[a+480188>>1]=e;if(e){f=0;while(1){v[113382]=0;W(597,d+224|0,((f<<5)+a|0)+480289|0,20)|0;g=v[113382];v[113382]=0;if((g|0)==1){break ma}f=f+1|0;if((e|0)!=(f|0)){continue}break}}Bb(d+224|0)}if(y[b+8>>2]>y[d+348>>2]){break la}e=v[d+348>>2]-v[b+8>>2]|0;break ka}f=P()|0;O()|0;break g}f=P()|0;O()|0;break i}f=P()|0;O()|0;break i}f=P()|0;O()|0;break i}f=P()|0;O()|0;Bb(d+224|0);break i}v[113382]=0;e=T(296,b|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break _}}v[113382]=0;U(307,d+312|0,b|0,e|0);e=v[113382];v[113382]=0;if((e|0)==1){break _}v[113382]=0;z=Q(598,a|0,d+312|0)|0;e=v[113382];v[113382]=0;qa:{ra:{if((e|0)==1){break ra}if(!(t[d+462|0]&1)|!(w[d+470|0]|w[d+471|0]<<8)){break qa}e=w[d+472|0]|w[d+473|0]<<8|(w[d+474|0]<<16|w[d+475|0]<<24);v[113382]=0;e=Q(226,b|0,e|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break ra}if(!e){break qa}e=w[d+470|0]|w[d+471|0]<<8;v[113382]=0;aa(547,a+1304424|0,b|0,e|0,4)|0;e=v[113382];v[113382]=0;if((e|0)!=1){break qa}}f=P()|0;O()|0;break j}f=0;u[a+480192>>1]=0;if(w[d+460|0]&4){e=w[d+450|0]|w[d+451|0]<<8;v[113382]=0;u[d+224>>1]=e;u[d+208>>1]=255;e=Q(438,d+224|0,d+208|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break Z}u[a+480192>>1]=x[e>>1]}if(x[a+480192>>1]){while(1){e=Pb(q,f);sa:{if(!(w[e|0]|w[e+1|0]<<8|(w[e+2|0]<<16|w[e+3|0]<<24))){break sa}e=Pb(q,f);e=w[e|0]|w[e+1|0]<<8|(w[e+2|0]<<16|w[e+3|0]<<24);v[113382]=0;e=Q(226,b|0,e|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break Y}if(!e){break sa}v[113382]=0;e=Q(228,b|0,554)|0;g=v[113382];v[113382]=0;if((g|0)==1){break Y}if(!e){break sa}v[113382]=0;e=W(411,a|0,f+1&65535,0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break X}if(!e){break sa}g=w[d+458|0]|w[d+459|0]<<8;v[113382]=0;aa(599,a|0,b|0,e|0,g|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break X}t[e+33|0]=w[d+469|0]}f=f+1|0;if(f>>>0<x[a+480192>>1]){continue}break}}v[d+308>>2]=0;if(w[d+452|0]|w[d+453|0]<<8){e=Pb(p,(w[d+452|0]|w[d+453|0]<<8)-1|0);v[d+308>>2]=(w[e|0]|w[e+1|0]<<8|(w[e+2|0]<<16|w[e+3|0]<<24))+80}e=w[d+452|0]|w[d+453|0]<<8;v[113382]=0;u[d+224>>1]=e;u[d+208>>1]=3999;e=Q(438,d+224|0,d+208|0)|0;f=v[113382];v[113382]=0;ta:{if((f|0)!=1){u[a+480190>>1]=x[e>>1];f=0;if(x[a+480190>>1]){break ta}g=0;break T}f=P()|0;O()|0;break j}j=c&2;n=d+244|0;g=0;while(1){e=Pb(p,f);ua:{if(!(w[e|0]|w[e+1|0]<<8|(w[e+2|0]<<16|w[e+3|0]<<24))){break ua}e=Pb(p,f);e=w[e|0]|w[e+1|0]<<8|(w[e+2|0]<<16|w[e+3|0]<<24);v[113382]=0;e=Q(226,b|0,e|0)|0;h=v[113382];v[113382]=0;va:{wa:{xa:{ya:{za:{Aa:{Ba:{if((h|0)==1){break Ba}if(!e){break ua}v[113382]=0;e=Q(600,b|0,d+224|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break Ba}if(!e){break ua}v[113382]=0;i=f+1|0;e=B(i,104)+a|0;h=e+484380|0;o=Q(601,d+224|0,h|0)|0;l=v[113382];v[113382]=0;if((l|0)==1){break Aa}v[113382]=0;U(588,d+192|0,3,n|0);l=v[113382];v[113382]=0;if((l|0)==1){break za}v[113382]=0;R(356,d+208|0,d+192|0);l=v[113382];v[113382]=0;if((l|0)==1){break za}v[113382]=0;Q(335,((i<<5)+a|0)+946304|0,d+208|0)|0;l=v[113382];v[113382]=0;if((l|0)==1){break ya}yb(d+208|0);v[113382]=0;o=Q(226,b|0,o|0)|0;l=v[113382];v[113382]=0;if((l|0)==1){break Aa}if(!o){break ua}e=x[e+484414>>1];if(!(e&512)){break xa}v[113382]=0;e=Q(602,b|0,d+208|0)|0;i=v[113382];v[113382]=0;if((i|0)!=1){if(!e){break wa}v[113382]=0;v[d+16>>2]=v[d+216>>2];e=v[d+212>>2];v[d+8>>2]=v[d+208>>2];v[d+12>>2]=e;U(603,h|0,1,d+8|0);e=v[113382];v[113382]=0;if((e|0)!=1){break wa}}f=P()|0;O()|0;break j}f=P()|0;O()|0;break j}f=P()|0;O()|0;break j}f=P()|0;O()|0;break j}f=P()|0;O()|0;yb(d+208|0);break j}if(!(e&16384)){e=w[d+456|0]|w[d+457|0]<<8;v[113382]=0;U(604,d+208|0,d+224|0,e|0);e=v[113382];v[113382]=0;if((e|0)==1){break U}Ca:{if(j){e=0;v[113382]=0;W(362,d+208|0,h|0,b|0)|0;i=v[113382];v[113382]=0;if((i|0)!=1){break Ca}break U}e=1;i=w[d+211|0];if(i>>>0>18){break Ca}i=1<<i;Da:{if(!(i&126991)){if(i&396800){break Da}break Ca}if(!w[d+208|0]){break Ca}}e=v[h>>2];v[113382]=0;i=Q(605,d+208|0,e|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break U}e=0;v[113382]=0;Q(304,b|0,i|0)|0;i=v[113382];v[113382]=0;if((i|0)==1){break U}}if(w[d+211|0]!=1){break va}g=v[h>>2]!=0|g;break va}v[113382]=0;Q(606,b|0,d+188|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break V}e=v[d+188>>2];if(!(!j|!e)){e=Xb(d+208|0);v[113382]=0;W(442,b|0,e|0,v[d+188>>2])|0;h=v[113382];v[113382]=0;Ea:{Fa:{Ga:{Ha:{Ia:{Ja:{Ka:{La:{Ma:{if((h|0)!=1){v[113382]=0;h=Q(2,d+160|0,12450)|0;o=v[113382];v[113382]=0;if((o|0)==1){break Ma}v[113382]=0;R(189,d+176|0,h|0);o=v[113382];v[113382]=0;if((o|0)==1){break La}v[113382]=0;v[d+156>>2]=i;U(13,d+144|0,0,e|0);i=v[113382];v[113382]=0;if((i|0)==1){break Ka}v[113382]=0;X(607,d+192|0,d+176|0,d+156|0,d+144|0);i=v[113382];v[113382]=0;if((i|0)==1){break Ja}v[113382]=0;U(608,a|0,2,d+192|0);i=v[113382];v[113382]=0;if((i|0)==1){break Ia}yb(d+192|0);yb(d+144|0);Ib(d+176|0);yb(h);yb(e);break wa}f=P()|0;O()|0;break Ea}f=P()|0;O()|0;break Ea}f=P()|0;O()|0;break Fa}f=P()|0;O()|0;break Ga}f=P()|0;O()|0;break Ha}f=P()|0;O()|0;yb(d+192|0)}yb(d+144|0)}Ib(d+176|0)}yb(h)}yb(e);break j}v[113382]=0;Q(304,b|0,e|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break V}}e=0}h=v[b+8>>2];v[113382]=0;v[d+208>>2]=h;h=Q(609,d+308|0,d+208|0)|0;i=v[113382];v[113382]=0;if((i|0)==1){break W}v[d+308>>2]=v[h>>2];A=(e|0)!=0}f=f+1|0;if(f>>>0<x[a+480190>>1]){continue}break}break T}f=P()|0;O()|0;break g}f=P()|0;O()|0;break g}f=P()|0;O()|0;break g}f=P()|0;O()|0;break g}f=P()|0;O()|0;break g}f=P()|0;O()|0;break g}f=P()|0;O()|0;break i}f=P()|0;O()|0;break j}f=P()|0;O()|0;break j}f=P()|0;O()|0;break j}f=P()|0;O()|0;break j}f=P()|0;O()|0;break j}f=P()|0;O()|0;break j}u[d+224>>1]=1;e=x[a+480190>>1];v[113382]=0;u[d+208>>1]=e;e=Q(408,d+224|0,d+208|0)|0;f=v[113382];v[113382]=0;Na:{Oa:{Pa:{Qa:{Ra:{Sa:{Ta:{Ua:{Va:{Wa:{Xa:{Ya:{if((f|0)!=1){u[a+480190>>1]=x[e>>1];Za:{if(!(g&1)|(w[d+456|0]|w[d+457|0]<<8)!=516|(w[d+462|0]|w[d+463|0]<<8|(w[d+458|0]|w[d+459|0]<<8)!=512)){break Za}if(w[d+476|0]|w[d+477|0]<<8|(w[d+478|0]<<16|w[d+479|0]<<24)|((w[d+460|0]|w[d+461|0]<<8)&65527)!=21|(w[d+464|0]!=128|w[d+465|0]!=48)){break Za}if(w[d+469|0]|w[d+468|0]!=128|(w[d+470|0]|w[d+471|0]<<8)){break Za}g=d+544|0;e=d+480|0;f=1;while(1){f=(w[e|0]&127)==32&f;e=e+1|0;if((g|0)!=(e|0)){continue}break}g=d+608|0;e=d+544|0;while(1){f=w[e|0]==64&f;e=e+1|0;if((g|0)!=(e|0)){continue}break}e=20;while(1){f=!w[(d+e|0)+420|0]&f;e=e+1|0;if(e>>>0<26){continue}break}if(!f){break Za}v[113382]=0;e=Q(2,d+224|0,5948)|0;f=v[113382];v[113382]=0;if((f|0)==1){break Oa}Gb(k,e);yb(e)}v[a+480260>>2]=0;v[a+480264>>2]=2147483647;C=d,D=Kb(m),u[C+224>>1]=D;e=v[a+8>>2];v[113382]=0;e=Q(438,d+224|0,e+10|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break Ya}e=x[e>>1];u[d+188>>1]=e;if((Kb(m)|0)!=(e|0)){v[113382]=0;R(470,d+208|0,12226);e=v[113382];v[113382]=0;if((e|0)==1){break Xa}e=Kb(m);v[113382]=0;v[d+192>>2]=e;X(610,d+128|0,d+208|0,d+192|0,d+188|0);e=v[113382];v[113382]=0;if((e|0)==1){break Wa}v[113382]=0;e=Q(611,d+224|0,d+128|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break Va}v[113382]=0;R(586,a|0,e|0);f=v[113382];v[113382]=0;if((f|0)==1){break Ua}yb(e);yb(d+128|0);Ib(d+208|0)}if(c&1){break Ra}u[d+188>>1]=0;break Qa}f=P()|0;O()|0;break j}f=P()|0;O()|0;break j}f=P()|0;O()|0;break j}f=P()|0;O()|0;break Sa}f=P()|0;O()|0;break Ta}f=P()|0;O()|0;yb(e)}yb(d+128|0)}Ib(d+208|0);break j}if(!x[d+188>>1]){break Qa}e=0;while(1){c=Pb(m,e);_a:{if(!(w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24))){break _a}c=Pb(m,e);c=w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24);v[113382]=0;c=Q(226,b|0,c|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break Pa}if(!c){break _a}v[113382]=0;c=T(323,b|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break k}v[113382]=0;h=T(323,b|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break l}if((h-1&65535)>>>0>1023){break _a}v[113382]=0;f=Q(304,b|0,4)|0;g=v[113382];v[113382]=0;if((g|0)==1){break l}if(!f){break _a}v[113382]=0;U(307,d+224|0,b|0,c|0);c=v[113382];v[113382]=0;if((c|0)==1){break m}c=0;f=x[a+480188>>1];v[113382]=0;g=Q(612,d+208|0,f|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break o}while(1){$a:{v[113382]=0;f=Q(228,d+224|0,1)|0;j=v[113382];v[113382]=0;ab:{bb:{if((j|0)!=1){if(!f){break $a}v[113382]=0;f=T(409,d+224|0)|0;j=v[113382];v[113382]=0;if((j|0)==1){break p}j=f<<24>>24;if(j){break bb}c=c+1|0;break ab}break p}cb:{f=j&127;i=f?f-1|0:0;f=i&65535;if(wc(g)>>>0>f>>>0){break cb}v[113382]=0;t[d+192|0]=0;U(613,g|0,f+1|0,d+192|0);n=v[113382];v[113382]=0;if((n|0)!=1){break cb}break p}if((j|0)<0){v[113382]=0;j=T(409,d+224|0)|0;n=v[113382];v[113382]=0;if((n|0)==1){break p}C=uc(g,f),D=j,t[C|0]=D}if(!(!(w[uc(g,f)|0]&15)|f>>>0<x[a+480188>>1])){u[a+480188>>1]=i+1}if(t[uc(g,f)|0]&1){v[113382]=0;Q(304,d+224|0,1)|0;j=v[113382];v[113382]=0;if((j|0)==1){break p}}if(w[uc(g,f)|0]&2){v[113382]=0;Q(304,d+224|0,1)|0;j=v[113382];v[113382]=0;if((j|0)==1){break p}}if(w[uc(g,f)|0]&4){v[113382]=0;Q(304,d+224|0,1)|0;j=v[113382];v[113382]=0;if((j|0)==1){break p}}if(!(w[uc(g,f)|0]&8)){break ab}v[113382]=0;Q(304,d+224|0,2)|0;f=v[113382];v[113382]=0;if((f|0)==1){break p}}if(c>>>0<h>>>0){continue}}break}c=v[b+8>>2];v[113382]=0;v[d+192>>2]=c;c=Q(609,d+308|0,d+192|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break p}v[d+308>>2]=v[c>>2];$d(g);Bb(d+224|0)}e=e+1|0;if(e>>>0<x[d+188>>1]){continue}break}}db:{eb:{c=v[d+308>>2];if(!c){break eb}v[113382]=0;Q(226,b|0,c|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break q}if(!A){break eb}while(1){fb:{v[113382]=0;c=Q(228,b|0,4)|0;e=v[113382];v[113382]=0;if((e|0)==1){break fb}if(!c){break eb}v[113382]=0;c=Q(580,b|0,9784)|0;e=v[113382];v[113382]=0;if((e|0)==1){break fb}gb:{if(!c){v[113382]=0;c=Q(580,b|0,9789)|0;e=v[113382];v[113382]=0;if((e|0)==1){break fb}if(!c){break gb}}v[113382]=0;c=T(397,b|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break db}mg(b,8);if(c&-2139062144){break gb}if(c&1616928864){break eb}}v[113382]=0;c=T(323,b|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break fb}v[113382]=0;Q(304,b|0,c|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){continue}}break}f=P()|0;O()|0;break j}v[113382]=0;c=Q(614,a|0,b|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break q}c=c|w[d+415|0];t[d+415|0]=c;if(!(!c|z)){Ht(a+1074312|0);v[a+1074372>>2]=0}v[113382]=0;X(615,a|0,b|0,0,d+415|0);c=v[113382];v[113382]=0;if((c|0)==1){break q}v[113382]=0;n=a+484344|0;R(363,n|0,x[d+188>>1]);c=v[113382];v[113382]=0;if((c|0)==1){break q}f=0;u[d+156>>1]=0;if(!x[d+188>>1]){break Na}while(1){hb:{ib:{c=Pb(m,f&65535);jb:{if(w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24)){c=Pb(m,x[d+156>>1]);c=w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24);v[113382]=0;c=Q(226,b|0,c|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break jb}if(c){break ib}}v[113382]=0;c=W(364,n|0,x[d+156>>1],64)|0;e=v[113382];v[113382]=0;if((e|0)==1){break jb}if(!c){v[113382]=0;R(470,d+208|0,11667);c=v[113382];v[113382]=0;kb:{lb:{mb:{nb:{ob:{if((c|0)!=1){v[113382]=0;U(616,d+112|0,d+208|0,d+156|0);c=v[113382];v[113382]=0;if((c|0)==1){break ob}v[113382]=0;c=Q(611,d+224|0,d+112|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break nb}v[113382]=0;R(586,a|0,c|0);e=v[113382];v[113382]=0;if((e|0)==1){break mb}yb(c);yb(d+112|0);Ib(d+208|0);break Na}f=P()|0;O()|0;break j}f=P()|0;O()|0;break kb}f=P()|0;O()|0;break lb}f=P()|0;O()|0;yb(c)}yb(d+112|0)}Ib(d+208|0);break j}c=Zb(n,x[d+156>>1]);v[113382]=0;R(617,c|0,s|0);c=v[113382];v[113382]=0;if((c|0)!=1){break hb}}f=P()|0;O()|0;break j}v[113382]=0;c=T(323,b|0)|0;e=v[113382];v[113382]=0;pb:{qb:{if((e|0)!=1){v[113382]=0;o=T(323,b|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break qb}v[113382]=0;e=Q(304,b|0,4)|0;f=v[113382];v[113382]=0;if((f|0)==1){break qb}if(!e){break hb}v[113382]=0;e=W(364,n|0,x[d+156>>1],o|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break qb}if(e){break pb}break hb}f=P()|0;O()|0;break j}f=P()|0;O()|0;break j}v[113382]=0;U(307,d+224|0,b|0,c|0);c=v[113382];v[113382]=0;if((c|0)!=1){c=Zb(n,x[d+156>>1]);v[113382]=0;R(617,c|0,s|0);c=v[113382];v[113382]=0;rb:{if((c|0)!=1){c=x[a+480188>>1];v[113382]=0;i=Q(612,d+208|0,c|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){c=x[a+480188>>1];e=d+176|0;oh(e);v[113382]=0;j=W(618,d+192|0,c|0,e|0)|0;c=v[113382];v[113382]=0;sb:{if((c|0)!=1){C=d,D=ac(Zb(n,x[d+156>>1])),v[C+144>>2]=D;l=0;tb:{if(!o){break tb}while(1){v[113382]=0;c=Q(228,d+224|0,1)|0;e=v[113382];v[113382]=0;ub:{if((e|0)!=1){vb:{if(!c){break tb}v[113382]=0;c=T(409,d+224|0)|0;e=v[113382];v[113382]=0;wb:{if((e|0)!=1){c=c<<24>>24;if(c){break wb}WR(d+144|0,x[a+480188>>1]);l=l+1|0;break ub}break vb}xb:{e=c&127;h=e?e-1&65535:0;if(wc(i)>>>0>h>>>0){break xb}v[113382]=0;t[d+176|0]=0;e=h+1|0;U(613,i|0,e|0,d+176|0);f=v[113382];v[113382]=0;if((f|0)==1){break vb}f=d+176|0;oh(f);v[113382]=0;U(619,j|0,e|0,f|0);e=v[113382];v[113382]=0;if((e|0)!=1){break xb}break vb}if((c|0)<0){v[113382]=0;c=T(409,d+224|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break vb}C=uc(i,h),D=c,t[C|0]=D}e=d+176|0;oh(e);if(h>>>0<x[a+480188>>1]){e=Lc(d+144|0,h)}if(w[uc(i,h)|0]&16){C=e,D=w[Lc(j,h)|0],t[C|0]=D}if(w[uc(i,h)|0]&32){C=e,D=w[Lc(j,h)+1|0],t[C+1|0]=D}if(w[uc(i,h)|0]&64){C=e,D=w[Lc(j,h)+2|0],t[C+2|0]=D;C=e,D=w[Lc(j,h)+4|0],t[C+4|0]=D}if(t[uc(i,h)|0]<0){C=e,D=w[Lc(j,h)+3|0],t[C+3|0]=D;C=e,D=w[Lc(j,h)+5|0],t[C+5|0]=D}if(t[uc(i,h)|0]&1){v[113382]=0;c=T(409,d+224|0)|0;f=v[113382];v[113382]=0;g=e;yb:{zb:{if((f|0)!=1){c=c+(((c^-1)&128)>>>7|0)|0;if(!(v[a+480180>>2]&16777216)){break zb}f=c;break yb}break vb}f=253;if((c-121&255)>>>0<132){break yb}f=(c&255)==253?0:c}t[g|0]=f;C=Lc(j,h),D=f,t[C|0]=D}if(w[uc(i,h)|0]&2){v[113382]=0;c=T(409,d+224|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break vb}t[e+1|0]=c;C=Lc(j,h),D=c,t[C+1|0]=D}if(w[uc(i,h)|0]&4){v[113382]=0;c=T(409,d+224|0)|0;f=v[113382];v[113382]=0;Ab:{Bb:{if((f|0)!=1){if(c>>>0>64){break Bb}t[e+4|0]=c;t[e+2|0]=1;break Ab}break vb}if(!(c>>>0>192|c<<24>>24>=0)){t[e+2|0]=2;t[e+4|0]=c^128;break Ab}if(c>>>0<=74){t[e+2|0]=5;t[e+4|0]=c-65;break Ab}if(c>>>0<=84){t[e+2|0]=6;t[e+4|0]=c-75;break Ab}if(c>>>0<=94){t[e+2|0]=3;t[e+4|0]=c-85;break Ab}if(c>>>0<=104){t[e+2|0]=4;t[e+4|0]=c-95;break Ab}if(c>>>0<=114){t[e+2|0]=13;t[e+4|0]=c-105;break Ab}if(c>>>0<=124){t[e+2|0]=12;t[e+4|0]=c-115;break Ab}f=c+63|0;if((f&255)>>>0<=9){t[e+4|0]=f;t[e+2|0]=11;break Ab}f=c+53|0;g=f&255;if(g>>>0<=9){t[e+4|0]=f;t[e+2|0]=8;if(!g|!v[a+1074308>>2]|y[a+1074308>>2]>18285140){break Ab}t[e+2|0]=7;break Ab}c=c+33|0;if((c&255)>>>0>9){break Ab}t[e+4|0]=c;t[e+2|0]=15}c=w[e+2|0];C=Lc(j,h),D=c,t[C+2|0]=D;c=w[e+4|0];C=Lc(j,h),D=c,t[C+4|0]=D}if(!(w[uc(i,h)|0]&8)){break ub}v[113382]=0;R(433,d+104|0,d+224|0);c=v[113382];v[113382]=0;if((c|0)!=1){Cb:{c=d+104|0;f=Zc(c);t[e+3|0]=w[c|0];t[e+5|0]=w[f|0];v[113382]=0;R(620,e|0,1);c=v[113382];v[113382]=0;if((c|0)==1){break Cb}c=w[e+3|0];C=Lc(j,h),D=c,t[C+3|0]=D;c=w[e+5|0];C=Lc(j,h),D=c,t[C+5|0]=D;break ub}}}}f=P()|0;O()|0;Ml(j);break sb}if(l>>>0<o>>>0){continue}break}}Ml(j);$d(i);Bb(d+224|0);break hb}f=P()|0;O()|0}$d(i);break rb}f=P()|0;O()|0;break rb}f=P()|0;O()|0}Bb(d+224|0);break j}f=P()|0;O()|0;break j}f=x[d+156>>1]+1|0;u[d+156>>1]=f;if(x[d+188>>1]>(f&65535)>>>0){continue}break}break Na}f=P()|0;O()|0;break j}f=P()|0;O()|0;break j}f=P()|0;O()|0;break j}c=a+1074308|0;Db:{Eb:{if(!v[a+1074308>>2]){Fb:{if((w[d+456|0]|w[d+457|0]<<8)==2184){v[c>>2]=18284544;e=18284544;break Fb}e=v[c>>2]}if(!e){break Eb}}if(!Sc(k)){break Eb}v[113382]=0;e=Q(2,d+208|0,13545)|0;f=v[113382];v[113382]=0;Gb:{Hb:{Ib:{Jb:{Kb:{Lb:{if((f|0)!=1){v[113382]=0;R(212,d+192|0,c|0);f=v[113382];v[113382]=0;if((f|0)==1){break Lb}v[113382]=0;U(3,d+224|0,e|0,d+192|0);f=v[113382];v[113382]=0;if((f|0)==1){break Kb}f=d+224|0;Gb(k,f);yb(f);yb(d+192|0);yb(e);if(v[d+476>>2]==1414548815|((w[d+456|0]|w[d+457|0]<<8)&61440)!=20480){break Gb}v[113382]=0;c=Q(2,d+224|0,12913)|0;e=v[113382];v[113382]=0;if((e|0)==1){break Ib}v[113382]=0;Q(162,k|0,c|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break Hb}yb(c);break Db}f=P()|0;O()|0;break j}f=P()|0;O()|0;break Jb}f=P()|0;O()|0;yb(d+192|0)}yb(e);break j}f=P()|0;O()|0;break j}f=P()|0;O()|0;yb(c);break j}if(!qD(c)){break Db}v[113382]=0;c=Q(2,d+224|0,13149)|0;e=v[113382];v[113382]=0;Mb:{if((e|0)!=1){v[113382]=0;Q(162,k|0,c|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break Mb}yb(c);break Db}f=P()|0;O()|0;break j}f=P()|0;O()|0;yb(c);break j}Nb:{switch((w[d+456|0]|w[d+457|0]<<8)>>>12|0){case 0:if(z){v[113382]=0;c=Q(2,d+224|0,4614)|0;e=v[113382];v[113382]=0;if((e|0)!=1){Gb(k,c);yb(c);break Db}f=P()|0;O()|0;break j}Ob:{if((w[d+456|0]|w[d+457|0]<<8)!=532|(w[d+458|0]|w[d+459|0]<<8)!=512|(w[d+462|0]|w[d+463|0]<<8|(w[d+460|0]|w[d+461|0]<<8)!=9)){break Ob}if(w[d+447|0]|w[d+446|0]|(w[d+450|0]|w[d+451|0]<<8|((w[d+454|0]|w[d+455|0]<<8)+1|0)!=(w[d+448|0]|w[d+449|0]<<8))){break Ob}if(w[d+464|0]!=128|w[d+465|0]!=100|(w[d+466|0]!=1|w[d+468|0]!=128)){break Ob}if(w[d+469|0]|(w[d+470|0]|w[d+471|0]<<8)|(w[d+472|0]|w[d+473|0]<<8|(w[d+474|0]<<16|w[d+475|0]<<24)|(w[d+476|0]|w[d+477|0]<<8|(w[d+478|0]<<16|w[d+479|0]<<24)))){break Ob}v[113382]=0;c=Q(2,d+224|0,5929)|0;e=v[113382];v[113382]=0;if((e|0)!=1){Gb(k,c);yb(c);break Db}f=P()|0;O()|0;break j}Pb:{if((w[d+456|0]|w[d+457|0]<<8)!=532|(w[d+458|0]|w[d+459|0]<<8)!=512|(w[d+447|0]|w[d+446|0])){break Pb}if(w[d+476|0]|w[d+477|0]<<8|(w[d+478|0]<<16|w[d+479|0]<<24)){break Pb}v[c>>2]=16777381;v[113382]=0;c=Q(2,d+224|0,10583)|0;e=v[113382];v[113382]=0;if((e|0)!=1){Gb(k,c);yb(c);t[d+415|0]=1;break Db}f=P()|0;O()|0;break j}if(!((w[d+456|0]|w[d+457|0]<<8)!=532|(w[d+458|0]|w[d+459|0]<<8)!=532|v[d+476>>2]!=1229080643)){v[113382]=0;c=Q(2,d+224|0,4666)|0;e=v[113382];v[113382]=0;if((e|0)!=1){Gb(k,c);yb(c);v[113382]=0;Q(440,a+1074312|0,38)|0;c=v[113382];v[113382]=0;if((c|0)==1){break q}break Db}f=P()|0;O()|0;break j}Qb:{if((w[d+456|0]|w[d+457|0]<<8)!=532|(w[d+458|0]|w[d+459|0]<<8)!=532|(w[d+469|0]|(w[d+462|0]|w[d+463|0]<<8)>>>0>1)){break Qb}if(!x[a+480190>>1]|(w[d+476|0]|w[d+477|0]<<8|(w[d+478|0]<<16|w[d+479|0]<<24)|((w[d+460|0]|w[d+461|0]<<8)&4294)!=4)){break Qb}v[113382]=0;c=Q(121,d+224|0,9481)|0;e=v[113382];v[113382]=0;Rb:{Sb:{if((e|0)!=1){v[113382]=0;e=Q(621,a+484527|0,c|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break Sb}yb(c);if(!e){break Qb}v[113382]=0;c=Q(2,d+224|0,4692)|0;e=v[113382];v[113382]=0;if((e|0)==1){break Rb}Gb(k,c);yb(c);break Db}f=P()|0;O()|0;break j}f=P()|0;O()|0;yb(c);break j}f=P()|0;O()|0;break j}Tb:{if(w[d+456|0]|w[d+457|0]<<8){break Tb}if(!Sc(k)){break Tb}v[113382]=0;c=Q(2,d+224|0,5715)|0;e=v[113382];v[113382]=0;if((e|0)!=1){Gb(k,c);yb(c);break Db}f=P()|0;O()|0;break j}if((w[d+458|0]|w[d+459|0]<<8)>>>0>767){break Db}if(!Sc(k)){break Db}Ub:{Vb:{Wb:{Xb:{Yb:{Zb:{_b:{if((w[d+458|0]|w[d+459|0]<<8)>>>0>=533){v[113382]=0;c=Q(2,d+224|0,10616)|0;e=v[113382];v[113382]=0;if((e|0)!=1){Gb(k,c);break _b}f=P()|0;O()|0;break j}if((w[d+456|0]|w[d+457|0]<<8)>>>0>=533){v[113382]=0;c=Q(2,d+88|0,11515)|0;e=v[113382];v[113382]=0;$b:{ac:{bc:{if((e|0)!=1){v[113382]=0;R(189,d+208|0,c|0);e=v[113382];v[113382]=0;if((e|0)==1){break bc}e=w[d+456|0]|w[d+457|0]<<8;v[113382]=0;v[d+192>>2]=e-532;U(215,d+224|0,d+208|0,d+192|0);e=v[113382];v[113382]=0;if((e|0)==1){break ac}e=d+224|0;Gb(k,e);yb(e);Ib(d+208|0);break _b}f=P()|0;O()|0;break j}f=P()|0;O()|0;break $b}f=P()|0;O()|0;Ib(d+208|0)}yb(c);break j}v[113382]=0;c=Q(2,d+72|0,11174)|0;e=v[113382];v[113382]=0;if((e|0)==1){break Zb}v[113382]=0;R(189,d+208|0,c|0);e=v[113382];v[113382]=0;if((e|0)==1){break Yb}v[d+176>>2]=w[d+457|0]&15;e=w[d+456|0];v[113382]=0;v[d+144>>2]=e;R(622,d+192|0,d+144|0);e=v[113382];v[113382]=0;if((e|0)==1){break Xb}v[113382]=0;X(607,d+224|0,d+208|0,d+176|0,d+192|0);e=v[113382];v[113382]=0;if((e|0)==1){break Wb}e=d+224|0;Gb(k,e);yb(e);yb(d+192|0);Ib(d+208|0)}yb(c);c=a+1304500|0;if(!id(c)|!(w[d+476|0]|w[d+477|0]<<8|(w[d+478|0]<<16|w[d+479|0]<<24))){break Db}e=w[d+456|0]|w[d+457|0]<<8;f=w[d+476|0]|w[d+477|0]<<8|(w[d+478|0]<<16|w[d+479|0]<<24);v[113382]=0;e=Q(623,e|0,f|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break t}f=Vp(d+224|0);v[f+44>>2]=e;v[113382]=0;R(624,c|0,f|0);c=v[113382];v[113382]=0;if((c|0)!=1){break Db}f=P()|0;O()|0;break j}f=P()|0;O()|0;break j}f=P()|0;O()|0;break Ub}f=P()|0;O()|0;break Vb}f=P()|0;O()|0;yb(d+192|0)}Ib(d+208|0)}yb(c);break j;case 1:c=w[d+456|0]|w[d+457|0]<<8;e=w[d+476|0]|w[d+477|0]<<8|(w[d+478|0]<<16|w[d+479|0]<<24);v[113382]=0;U(625,d+224|0,c|0,e|0);c=v[113382];v[113382]=0;cc:{if((c|0)!=1){c=d+224|0;Gb(k,c);yb(c);if((w[d+456|0]|w[d+457|0]<<8)>>>0>=6092){break cc}v[113382]=0;Q(440,a+1074312|0,7)|0;c=v[113382];v[113382]=0;if((c|0)!=1){break cc}break q}f=P()|0;O()|0;break j}c=w[d+456|0]|w[d+457|0]<<8;if((VR(4096)|0)<=(c|0)){break Db}v[113382]=0;Q(440,a+1074312|0,38)|0;c=v[113382];v[113382]=0;if((c|0)==1){break q}break Db;case 4:v[113382]=0;c=Q(2,d+56|0,11238)|0;e=v[113382];v[113382]=0;dc:{ec:{fc:{gc:{hc:{if((e|0)!=1){v[113382]=0;R(189,d+208|0,c|0);e=v[113382];v[113382]=0;if((e|0)==1){break hc}v[d+176>>2]=w[d+457|0]&15;e=w[d+456|0];v[113382]=0;v[d+144>>2]=e;R(622,d+192|0,d+144|0);e=v[113382];v[113382]=0;if((e|0)==1){break gc}v[113382]=0;X(607,d+224|0,d+208|0,d+176|0,d+192|0);e=v[113382];v[113382]=0;if((e|0)==1){break fc}e=d+224|0;Gb(k,e);yb(e);yb(d+192|0);Ib(d+208|0);yb(c);break Db}f=P()|0;O()|0;break j}f=P()|0;O()|0;break dc}f=P()|0;O()|0;break ec}f=P()|0;O()|0;yb(d+192|0)}Ib(d+208|0)}yb(c);break j;case 6:v[113382]=0;c=Q(2,d+224|0,4614)|0;e=v[113382];v[113382]=0;if((e|0)!=1){Gb(k,c);yb(c);break Db}f=P()|0;O()|0;break j;case 7:if(!((w[d+456|0]|w[d+457|0]<<8)!=32767|(w[d+458|0]|w[d+459|0]<<8)!=533)){v[113382]=0;c=Q(2,d+224|0,1549)|0;e=v[113382];v[113382]=0;if((e|0)!=1){Gb(k,c);yb(c);break Db}f=P()|0;O()|0;break j}v[113382]=0;c=Q(2,d+40|0,10788)|0;e=v[113382];v[113382]=0;ic:{jc:{kc:{if((e|0)!=1){v[113382]=0;R(189,d+208|0,c|0);e=v[113382];v[113382]=0;if((e|0)==1){break kc}v[d+192>>2]=w[d+457|0]&15;v[d+176>>2]=(w[d+456|0]|w[d+457|0]<<8)>>>4&15;e=w[d+456|0]|w[d+457|0]<<8;v[113382]=0;v[d+144>>2]=e&15;fa(209,d+224|0,d+208|0,d+192|0,d+176|0,d+144|0);e=v[113382];v[113382]=0;if((e|0)==1){break jc}e=d+224|0;Gb(k,e);yb(e);Ib(d+208|0);yb(c);break Db}f=P()|0;O()|0;break j}f=P()|0;O()|0;break ic}f=P()|0;O()|0;Ib(d+208|0)}yb(c);break j;case 13:break Nb;default:break Db}}v[113382]=0;c=Q(2,d+224|0,2516)|0;e=v[113382];v[113382]=0;if((e|0)==1){break s}Gb(k,c);yb(c)}lc:{if(v[a+480180>>2]!=16777216|(w[d+456|0]|w[d+457|0]<<8)>>>0<2186){break lc}v[113382]=0;c=Q(226,b|0,r|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break q}if(!c){break lc}c=w[d+456|0]|w[d+457|0]<<8;v[113382]=0;U(626,a|0,b|0,c|0);b=v[113382];v[113382]=0;if((b|0)==1){break q}}c=v[a+480180>>2];mc:{if((c|0)==16777216){v[113382]=0;Q(2,d+224|0,9767)|0;b=v[113382];v[113382]=0;if((b|0)!=1){break mc}f=P()|0;O()|0;break j}v[113382]=0;b=Q(2,d+24|0,11174)|0;e=v[113382];v[113382]=0;if((e|0)==1){break z}v[113382]=0;R(189,d+208|0,b|0);e=v[113382];v[113382]=0;if((e|0)==1){break y}v[d+176>>2]=w[d+459|0];e=w[d+458|0];v[113382]=0;v[d+144>>2]=e;R(622,d+192|0,d+144|0);e=v[113382];v[113382]=0;if((e|0)==1){break x}v[113382]=0;X(607,d+224|0,d+208|0,d+176|0,d+192|0);e=v[113382];v[113382]=0;if((e|0)==1){break w}}b=d+224|0;Gb(a+1304436|0,b);yb(b);if((c|0)!=16777216){yb(d+192|0);Ib(d+208|0);yb(d+24|0)}nc:{if(v[a+480180>>2]==16777216){v[113382]=0;Q(2,d+224|0,6212)|0;b=v[113382];v[113382]=0;if((b|0)!=1){break nc}break r}v[113382]=0;Q(2,d+224|0,2520)|0;b=v[113382];v[113382]=0;if((b|0)==1){break r}}b=d+224|0;Gb(a+1304448|0,b);yb(b);Gb(a+1304460|0,k);v[a+1304496>>2]=v[a+1074308>>2]?7:4;Bb(d+312|0);Bb(s);f=1}Ji(m);Ji(p);Ji(q);break d}f=P()|0;O()|0;break j}f=P()|0;O()|0;break u}f=P()|0;O()|0;break v}f=P()|0;O()|0;yb(d+192|0)}Ib(d+208|0)}yb(b);break j}f=P()|0;O()|0;break j}f=P()|0;O()|0;break j}f=P()|0;O()|0;break j}f=P()|0;O()|0;break j}f=P()|0;O()|0;$d(g);break n}f=P()|0;O()|0}Bb(d+224|0);break j}f=P()|0;O()|0;break j}f=P()|0;O()|0;break j}f=P()|0;O()|0}Bb(d+312|0)}Bb(s);break g}f=P()|0;O()|0}Ji(m);Ji(p);Ji(q);break a}f=P()|0;O()|0;break a}f=P()|0;O()|0;break a}yb(k)}jb=d+608|0;return f|0}f=P()|0;O()|0}yb(k);S(f|0);L()}function $ia(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,z=0,A=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;e=jb-1584|0;jb=e;Ic(b);a:{b:{if(!Hf(b,e+1576|0)){break b}if(!AQ(e+1576|0)){break b}if(!c){f=1;break b}d=w[e+1576|3];t[e+1575|0]=d;v[e+1568>>2]=-1;v[e+1564>>2]=1048576;if(d>>>0>=5){d=Df(b);v[e+1568>>2]=d;if(!Rb(b,d)){break b}v[e+208>>2]=134217727;J=e,K=v[Lb(e+208|0,e+1568|0)>>2]<<5,v[J+1564>>2]=K}D=tq(e+1552|0);d=e+1576|4;g=w[d|0]|w[d+1|0]<<8|(w[d+2|0]<<16|w[d+3|0]<<24);v[113382]=0;v[e+208>>2]=g;g=Q(297,e+1564|0,e+208|0)|0;f=v[113382];v[113382]=0;c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{v:{w:{x:{y:{if((f|0)==1){break y}g=v[g>>2];v[113382]=0;R(793,D|0,g|0);g=v[113382];v[113382]=0;if((g|0)==1){break y}d=w[d|0]|w[d+1|0]<<8|(w[d+2|0]<<16|w[d+3|0]<<24);f=0;v[113382]=0;d=W(794,b|0,D|0,d|0)|0;g=v[113382];v[113382]=0;z:{if((g|0)==1){break z}if(!d){break u}if(w[e+1575|0]>=5){v[113382]=0;Q(226,b|0,v[e+1568>>2]+12|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break z}}v[113382]=0;R(403,a|0,0);d=v[113382];v[113382]=0;if((d|0)==1){break z}v[113382]=0;Z(437,a|0);d=v[113382];v[113382]=0;if((d|0)==1){break z}v[113382]=0;R(795,e+1528|0,D|0);g=v[113382];v[113382]=0;d=a;A:{B:{C:{D:{if((g|0)==1){break D}v[113382]=0;k=W(796,e+1536|0,e+1528|0,0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break D}v[113382]=0;W(559,k|0,a+1304400|0,-1)|0;g=v[113382];v[113382]=0;if((g|0)==1){break C}v[113382]=0;W(559,k|0,a+1304424|0,-1)|0;g=v[113382];v[113382]=0;if((g|0)==1){break C}v[113382]=0;g=Q(797,k|0,e+1104|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break e}if(!g|!w[e+1104|0]|t[e+1104|0]<0){break v}g=e+1113|0;if((w[g|0]|w[g+1|0]<<8)>>>0>255){break v}h=e+1115|0;if((w[h|0]|w[h+1|0]<<8)>>>0>3999){break v}f=e+1104|0;u[a+480188>>1]=w[f|0];j=a+484360|0;f=f|3;Ne(Vb(j),w[f|0]|w[f+1|0]<<8);u[a+480192>>1]=w[g|0]|w[g+1|0]<<8;u[a+480190>>1]=w[h|0]|w[h+1|0]<<8;g=e+1117|0;if(w[g|0]){break B}g=6;break A}d=P()|0;O()|0;break c}d=P()|0;O()|0;break d}g=w[g|0]}v[d+480196>>2]=g;d=a;g=e+1118|0;if(w[g|0]){g=w[g|0]}else{g=125}v[d+480204>>2]=B(g,1e4);p=e+1119|0;E:{if(t[p+1|0]&1){v[113382]=0;R(583,a|0,32);d=v[113382];v[113382]=0;if((d|0)!=1){break E}break e}if(w[p|0]&2){v[113382]=0;R(583,a|0,2);d=v[113382];v[113382]=0;if((d|0)==1){break e}break E}if(w[p|0]&128){v[113382]=0;R(583,a|0,1);d=v[113382];v[113382]=0;if((d|0)==1){break e}break E}if(w[p|0]&8){v[113382]=0;R(583,a|0,16);d=v[113382];v[113382]=0;if((d|0)==1){break e}break E}v[113382]=0;R(583,a|0,4);d=v[113382];v[113382]=0;if((d|0)==1){break e}}v[a+480208>>2]=v[a+480208>>2]|16777216;if(t[p|0]&1){v[a+480208>>2]=v[a+480208>>2]|16}if(!(!(w[p|0]&16)|v[a+480180>>2]!=2)){v[a+480208>>2]=v[a+480208>>2]|65536}if(!(!(w[p|0]&4)|v[a+480180>>2]!=2)){v[a+480208>>2]=v[a+480208>>2]|2}if(!(w[p+1|0]&8|v[a+480180>>2]!=32)){v[a+480208>>2]=v[a+480208>>2]|4}if(!(w[p+1|0]&4|v[a+480180>>2]!=32)){v[a+480208>>2]=v[a+480208>>2]|8}if(w[p+2|0]&32){v[a+480208>>2]=v[a+480208>>2]|32768}if(w[p+2|0]&8){v[113382]=0;W(439,a+1074312|0,5,1)|0;d=v[113382];v[113382]=0;if((d|0)==1){break e}}F:{d=v[a+480180>>2];G:{if((d|0)!=2){if((d|0)!=32){break G}d=w[e+1123|0];v[113382]=0;t[e+208|0]=d;t[e+136|0]=128;d=Q(415,e+208|0,e+136|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break x}v[a+480200>>2]=w[d|0]<<1;break G}d=w[e+1123|0];v[113382]=0;t[e+208|0]=d;t[e+136|0]=64;d=Q(415,e+208|0,e+136|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break F}v[a+480200>>2]=w[d|0]<<2}G=a+480188|0;f=e+1125|0;g=t[f|0];d=a;if(t[f|0]<0){g=g+52|0}else{F=xw(+(g|0)*.15500000000000003);H:{if(F<4294967296&F>=0){g=~~F>>>0;break H}g=0}g=g+51|0}v[d+480228>>2]=g;v[113382]=0;u[e+208>>1]=64;d=Q(438,G|0,e+208|0)|0;g=v[113382];v[113382]=0;if((g|0)!=1){I:{g=x[d>>1];if(g){f=0;while(1){d=v[a+480180>>2];if((d|0)==32){d=w[(e+f|0)+1126|0];v[113382]=0;t[e+208|0]=d;t[e+136|0]=64;d=Q(415,e+208|0,e+136|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break I}u[((f<<5)+a|0)+480286>>1]=w[d|0];d=v[a+480180>>2]}J:{if((d|0)==4){break J}d=(e+f|0)+1190|0;if(w[d|0]==127){v[((f<<5)+a|0)+480280>>2]=256;break J}if(w[d|0]==255){u[((f<<5)+a|0)+480284>>1]=256;break J}u[((f<<5)+a|0)+480284>>1]=w[d|0]}f=f+1|0;if((g|0)!=(f|0)){continue}break}}h=0;f=0;while(1){f=w[(e+i|0)+1254|0]!=0|f;i=i+1|0;if((i|0)!=16){continue}break}while(1){f=w[((h<<1)+e|0)+1271|0]!=0|f;h=h+1|0;if((h|0)!=128){continue}break}if(f&1){f=0;while(1){K:{d=(e+f|0)+1254|0;if(w[d|0]){v[113382]=0;R(470,e+136|0,1425);g=v[113382];v[113382]=0;L:{M:{N:{O:{P:{if((g|0)!=1){d=w[d|0];v[113382]=0;v[e+160>>2]=d-1;R(798,e+1088|0,e+160|0);d=v[113382];v[113382]=0;if((d|0)==1){break P}v[113382]=0;U(472,e+208|0,e+136|0,e+1088|0);d=v[113382];v[113382]=0;if((d|0)==1){break O}v[113382]=0;R(473,e+1072|0,((f<<5)+a|0)+901692|0);d=v[113382];v[113382]=0;if((d|0)==1){break N}v[113382]=0;Q(431,e+1072|0,e+208|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break N}yb(e+208|0);yb(e+1088|0);Ib(e+136|0);break K}d=P()|0;O()|0;break d}d=P()|0;O()|0;break L}d=P()|0;O()|0;break M}d=P()|0;O()|0;yb(e+208|0)}yb(e+1088|0)}Ib(e+136|0);break d}v[113382]=0;g=Q(121,e+208|0,17540)|0;d=v[113382];v[113382]=0;Q:{if((d|0)!=1){v[113382]=0;R(473,e+136|0,((f<<5)+a|0)+901692|0);d=v[113382];v[113382]=0;if((d|0)==1){break Q}v[113382]=0;Q(431,e+136|0,g|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break Q}yb(g);break K}d=P()|0;O()|0;break d}d=P()|0;O()|0;yb(g);break d}f=f+1|0;if((f|0)!=16){continue}break}f=0;while(1){d=(e+1104|0)+(f<<1)|0;g=d;R:{if(w[d+167|0]){v[113382]=0;R(470,e+136|0,11004);h=v[113382];v[113382]=0;S:{T:{U:{V:{W:{X:{Y:{if((h|0)!=1){g=w[g+167|0];v[113382]=0;v[e+112>>2]=g-1;R(798,e+1088|0,e+112|0);g=v[113382];v[113382]=0;if((g|0)==1){break Y}d=w[d+166|0];v[113382]=0;t[e+1056|0]=d;R(799,e+1072|0,e+1056|0);d=v[113382];v[113382]=0;if((d|0)==1){break X}v[113382]=0;X(800,e+208|0,e+136|0,e+1088|0,e+1072|0);d=v[113382];v[113382]=0;if((d|0)==1){break W}v[113382]=0;R(473,e+160|0,((f<<5)+a|0)+902204|0);d=v[113382];v[113382]=0;if((d|0)==1){break V}v[113382]=0;Q(431,e+160|0,e+208|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break V}yb(e+208|0);yb(e+1072|0);yb(e+1088|0);Ib(e+136|0);break R}d=P()|0;O()|0;break d}d=P()|0;O()|0;break S}d=P()|0;O()|0;break T}d=P()|0;O()|0;break U}d=P()|0;O()|0;yb(e+208|0)}yb(e+1072|0)}yb(e+1088|0)}Ib(e+136|0);break d}v[113382]=0;g=Q(121,e+208|0,17540)|0;d=v[113382];v[113382]=0;Z:{if((d|0)!=1){v[113382]=0;R(473,e+136|0,((f<<5)+a|0)+902204|0);d=v[113382];v[113382]=0;if((d|0)==1){break Z}v[113382]=0;Q(431,e+136|0,g|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break Z}yb(g);break R}d=P()|0;O()|0;break d}d=P()|0;O()|0;yb(g);break d}f=f+1|0;if((f|0)!=128){continue}break}}d=Vb(j);g=e+1104|1;g=w[g|0]|w[g+1|0]<<8;v[113382]=0;ea(544,d|0,k|0,g|0,255,254)|0;d=v[113382];v[113382]=0;_:{$:{aa:{ba:{ca:{da:{if((d|0)!=1){d=e+1104|0;q=d|5;g=w[q|0]|w[q+1|0]<<8;d=w[d|0];v[113382]=0;U(307,e+1088|0,k|0,B(d,g)<<1);d=v[113382];v[113382]=0;if((d|0)==1){break da}d=w[q|0]|w[q+1|0]<<8;v[113382]=0;U(307,e+1072|0,k|0,d<<1);d=v[113382];v[113382]=0;if((d|0)==1){break ca}d=e+1104|7;d=w[d|0]|w[d+1|0]<<8;v[113382]=0;C=Q(361,e+1056|0,d|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break ba}J=e,K=ac(C),v[J+136>>2]=K;J=e,K=bc(C),v[J+160>>2]=K;if(Jb(e+136|0,e+160|0)){while(1){d=v[e+136>>2];v[113382]=0;g=T(397,k|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break aa}v[113382]=0;U(307,e+208|0,k|0,g|0);g=v[113382];v[113382]=0;if((g|0)==1){break $}g=d;d=e+208|0;Qd(g,d);Bb(d);d=e+136|0;Xf(d);if(Jb(d,e+160|0)){continue}break}}d=v[a+480180>>2];j=1;o=c&1;if(!o){break _}g=w[q|0]|w[q+1|0]<<8;v[113382]=0;R(363,a+484344|0,g|0);g=v[113382];v[113382]=0;if((g|0)!=1){break _}d=P()|0;O()|0;break h}d=P()|0;O()|0;break d}d=P()|0;O()|0;break d}d=P()|0;O()|0;break f}d=P()|0;O()|0;break g}d=P()|0;O()|0;break h}d=P()|0;O()|0;break h}E=a+484344|0;ea:{fa:{ga:{ha:{ia:{ja:{if(w[q|0]|w[q+1|0]<<8){m=(d|0)==16?14:(d|0)==32?1:13;while(1){v[113382]=0;d=T(323,e+1072|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break ea}v[e+136>>2]=d;ka:{if(!o){break ka}v[113382]=0;d=W(364,E|0,n&65535,d|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break ea}if(!d){break ka}r=0;if(!w[e+1104|0]){break ka}while(1){v[113382]=0;d=T(323,e+1088|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break fa}la:{if(jd(C)>>>0<=d>>>0){break la}l=sc(C,d);Ic(l);d=Zb(E,n);v[113382]=0;f=W(432,d|0,0,r&65535)|0;d=v[113382];v[113382]=0;if((d|0)==1){break i}g=0;if(!v[e+136>>2]){break la}while(1){v[113382]=0;z=T(409,l|0)|0;d=v[113382];v[113382]=0;ma:{na:{if((d|0)!=1){if(!z){break la}oh(e+208|0);i=0;s=z&15;if(s){break na}break ma}d=P()|0;O()|0;break h}while(1){oa:{v[113382]=0;Q(801,l|0,e+160|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break oa}pa:{qa:{ra:{sa:{ta:{ua:{va:{wa:{xa:{ya:{za:{Aa:{Ba:{Ca:{Da:{Ea:{Fa:{Ga:{Ha:{Ia:{Ja:{d=w[e+160|0];switch(d-1|0){case 2:case 3:case 4:case 7:case 8:case 9:case 11:case 12:case 13:case 16:case 18:case 21:case 22:case 23:case 24:case 25:case 27:case 32:break ra;case 33:break va;case 30:case 31:break wa;case 29:break xa;case 28:break ya;case 26:break za;case 19:case 20:break Aa;case 17:break Ba;case 15:break Ca;case 14:break Da;case 10:break Ea;case 6:break Fa;case 5:break Ga;case 1:break Ha;case 0:break Ia;default:break Ja}}switch(d-48|0){case 4:break sa;case 1:case 2:break ta;case 0:break ua;default:break ra}}d=w[e+161|0];Ka:{if(d>>>0<=119){t[e+208|0]=d+m;break Ka}La:{switch(d-254|0){case 1:t[e+208|0]=255;break Ka;case 0:t[e+208|0]=254;break Ka;default:break La}}t[e+208|0]=253}v[113382]=0;d=T(573,e+208|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break oa}j=d&j;break pa}t[e+209|0]=w[e+161|0]+1;break pa}Ma:{if(w[e+210|0]){break Ma}d=v[a+480180>>2];if((d|0)!=32){if((d|0)!=4){break Ma}d=w[e+161|0];if(d&15){break Ma}t[e+210|0]=11;t[e+212|0]=d>>>4;break pa}h=0;d=w[e+161|0];while(1){if((d|0)==w[h+26064|0]){t[e+212|0]=h;t[e+210|0]=11;break pa}h=h+1|0;if((h|0)!=10){continue}break}}t[e+211|0]=4;t[e+213|0]=w[e+161|0];break pa}d=w[e+161|0];if(!(w[e+210|0]|d>>>0>9|v[a+480180>>2]!=32)){t[e+212|0]=d;t[e+210|0]=8;break pa}t[e+213|0]=d;t[e+211|0]=5;break pa}if(w[e+210|0]){h=w[e+161|0];break qa}d=v[a+480180>>2];A=(d|0)!=32;h=w[e+161|0];if(!(A|(h|0)!=255)){t[e+212|0]=64;t[e+210|0]=2;break pa}Na:{if(!A){if(h&3){break qa}break Na}if(h&15|(d|0)!=4){break qa}}t[e+210|0]=2;t[e+212|0]=(h&252)>>>2;break pa}d=w[e+161|0];if(!(w[e+210|0]|d>>>0>64|v[a+480180>>2]==1)){t[e+212|0]=d;t[e+210|0]=1;break pa}t[e+213|0]=d;t[e+211|0]=13;break pa}t[e+211|0]=14;d=w[e+161|0];t[e+213|0]=d;if(v[a+480180>>2]==32){break pa}t[e+213|0]=B((d&240)>>>4|0,10)+(d&15);break pa}d=w[e+161|0];t[e+213|0]=d;if(d>>>0<=31){t[e+211|0]=16;break pa}t[e+211|0]=17;break pa}h=w[e+161|0];if(h>>>0>=16){t[e+212|0]=h>>>4;t[e+210|0]=(d|0)==20?3:5;break pa}t[e+212|0]=h;t[e+210|0]=(d|0)==20?4:6;break pa}d=w[e+161|0];if(d>>>0>=16){t[e+210|0]=10;t[e+212|0]=d>>>4;break pa}t[e+212|0]=d;t[e+210|0]=9;break pa}t[e+211|0]=28;t[e+213|0]=w[e+161|0]|16;break pa}t[e+211|0]=28;t[e+213|0]=w[e+161|0]|32;break pa}t[e+212|0]=w[e+161|0];t[e+210|0]=w[d+24032|0];break pa}t[e+213|0]=w[e+161|0];d=w[e+211|0];t[e+211|0]=(d|0)==4?6:(d|0)==5?7:11;break pa}d=w[e+161|0];t[e+212|0]=(d>>>0)%10;if(d>>>0<=9){t[e+210|0]=5;break pa}if(d>>>0<=19){t[e+210|0]=6;break pa}if(d>>>0<=29){t[e+210|0]=3;break pa}if(d>>>0>39){break pa}t[e+210|0]=4;break pa}t[e+212|0]=w[e+161|0];t[e+210|0]=w[d+24032|0];break pa}d=w[e+161|0]+33|0;if((d&255)>>>0>9){break pa}t[e+212|0]=d;t[e+210|0]=15;break pa}if(d>>>0>55){break pa}t[e+213|0]=w[e+161|0];t[e+211|0]=w[d+24032|0];break pa}t[e+213|0]=h;t[e+211|0]=9}i=i+1|0;if(s>>>0>(i&255)>>>0){continue}break ma}break}d=P()|0;O()|0;break h}v[113382]=0;v[e+160>>2]=(z>>>4|0)+g;d=Q(297,e+160|0,e+136|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break ja}d=v[d>>2];if(d>>>0>g>>>0){while(1){h=v[e+208>>2];t[f|0]=h;t[f+1|0]=h>>>8;t[f+2|0]=h>>>16;t[f+3|0]=h>>>24;h=x[e+212>>1];t[f+4|0]=h;t[f+5|0]=h>>>8;f=B(w[e+1104|0],6)+f|0;g=g+1|0;if((d|0)!=(g|0)){continue}break}g=d}if(y[e+136>>2]>g>>>0){continue}break}}r=r+1|0;if(w[e+1104|0]>(r&65535)>>>0){continue}break}}n=n+1|0;if(n>>>0<(w[q|0]|w[q+1|0]<<8)>>>0){continue}break}}if(!((j^1)&1|x[a+480188>>1]!=4|v[a+480180>>2]!=1)){v[a+480208>>2]=v[a+480208>>2]|8454144}if(v[a+480180>>2]!=4){break ia}i=0;break ha}d=P()|0;O()|0;break h}i=!((w[p|0]|w[p+1|0]<<8|(w[p+2|0]<<16|w[p+3|0]<<24))&512);d=0;if(v[a+480180>>2]!=4){break ga}}d=x[a+480192>>1]}v[113382]=0;q=Q(802,e+1040|0,d|0)|0;d=v[113382];v[113382]=0;g=1;if((d|0)!=1){Oa:{Pa:{Qa:{if(x[a+480192>>1]){d=1;while(1){Ra:{Sa:{Ta:{if(!i){v[113382]=0;h=W(411,a|0,d&65535,0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break Ta}if(h){break Sa}}while(1){v[113382]=0;g=T(409,k|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break k}if(g){continue}break}if(w[e+1575|0]>=5){while(1){v[113382]=0;g=T(409,k|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){d=P()|0;O()|0;break j}if(g){continue}break}}v[113382]=0;Q(304,k|0,826)|0;g=v[113382];v[113382]=0;if((g|0)!=1){break Ra}}d=P()|0;O()|0;break j}f=Xb(e+136|0);v[113382]=0;W(559,k|0,f|0,-1)|0;j=v[113382];v[113382]=0;if((j|0)==1){break Qa}v[113382]=0;Q(335,h+492|0,f|0)|0;j=v[113382];v[113382]=0;if((j|0)==1){break Qa}Ua:{if(w[e+1575|0]<5){break Ua}v[113382]=0;W(559,k|0,f|0,-1)|0;j=v[113382];v[113382]=0;if((j|0)==1){break Qa}v[113382]=0;Q(335,h+524|0,f|0)|0;j=v[113382];v[113382]=0;if((j|0)!=1){break Ua}break Qa}v[113382]=0;j=Q(803,k|0,e+208|0)|0;n=v[113382];v[113382]=0;if((n|0)==1){break Qa}if(!j){break Pa}j=v[a+480180>>2];v[113382]=0;U(804,e+208|0,h|0,j|0);h=v[113382];v[113382]=0;if((h|0)==1){break Qa}if(v[a+480180>>2]==4){g=Pb(q,g-1|0);h=x[e+1010>>1]|x[e+1012>>1]<<16;t[g|0]=h;t[g+1|0]=h>>>8;t[g+2|0]=h>>>16;t[g+3|0]=h>>>24}yb(f)}d=d+1|0;g=d&65535;if(g>>>0<=x[a+480192>>1]){continue}break}}if(!i){break Oa}u[a+480192>>1]=0;break Oa}d=P()|0;O()|0;yb(f);break j}yb(f)}d=x[a+480190>>1];v[113382]=0;z=Q(805,e+192|0,d|0)|0;d=v[113382];v[113382]=0;r=1;if((d|0)!=1){r=w[e+1575|0]<=4?!(t[p|0]&1):r;s=c&2;c=0;Va:{if(!x[a+480190>>1]){break Va}i=1;g=1;while(1){d=c;n=Xb(e+176|0);v[113382]=0;W(559,k|0,n|0,-1)|0;c=v[113382];v[113382]=0;Wa:{Xa:{Ya:{Za:{_a:{if((c|0)==1){break _a}v[113382]=0;Q(335,((i<<5)+a|0)+946304|0,n|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break _a}o=B(i,104);j=o+a|0;if(w[e+1575|0]<5){break Za}v[113382]=0;W(559,k|0,n|0,-1)|0;c=v[113382];v[113382]=0;if((c|0)==1){break _a}v[113382]=0;Q(336,j+484423|0,n|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){break Za}}d=P()|0;O()|0;break Ya}v[113382]=0;c=Q(806,k|0,e+208|0)|0;f=v[113382];v[113382]=0;$a:{ab:{bb:{cb:{db:{eb:{fb:{if((f|0)==1){break fb}if(!c){break eb}c=v[a+480180>>2];v[113382]=0;f=j+484380|0;X(807,e+208|0,f|0,c|0,r|0);c=v[113382];v[113382]=0;if((c|0)==1){break fb}h=0;gb:{if(((w[e+228|0]|w[e+229|0]<<8)&61440)!=28672|w[e+1575|0]<5){break gb}v[113382]=0;h=T(808,k|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){break gb}d=P()|0;O()|0;break Ya}if(!s){break Xa}A=w[e+228|0]|w[e+229|0]<<8;l=A&61440;if(!(l|(w[e+243|0]|w[e+244|0]<<8|(w[e+245|0]<<16|w[e+246|0]<<24)))){c=w[e+228|0]|w[e+229|0]<<8;c=Yc(e+136|0,c&1?16:8,c&1024?3:1,0,0);v[113382]=0;W(362,c|0,f|0,b|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){break Xa}d=P()|0;O()|0;break Ya}c=w[e+243|0]|w[e+244|0]<<8|(w[e+245|0]<<16|w[e+246|0]<<24);if(!((c|0)>=0|(c+i|0)<=0)){h=a+484380|0;l=B((w[e+243|0]|w[e+244|0]<<8|(w[e+245|0]<<16|w[e+246|0]<<24))+i|0,104);c=h+l|0;tc(f,v[c>>2]);h=h+o|0;i=x[h+34>>1]&-2|u[c+34>>1]&1;u[h+34>>1]=i;u[h+34>>1]=i&65471|x[c+34>>1]&64;if(!Be(c)){break Xa}v[113382]=0;c=T(422,f|0)|0;h=v[113382];v[113382]=0;if((h|0)!=1){if(!c){break Xa}c=v[j+484400>>2];v[113382]=0;c=T(423,c|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break a}h=v[(a+l|0)+484400>>2];v[113382]=0;h=T(809,h|0)|0;i=v[113382];v[113382]=0;if((i|0)==1){break a}lc(c,h,zj(f));break Xa}d=P()|0;O()|0;break Ya}if((w[e+243|0]|w[e+244|0]<<8|(w[e+245|0]<<16|w[e+246|0]<<24))<=0){break Xa}if(t[e+228|0]&1){c=j+484414|0;u[c>>1]=x[c>>1]|1}if(w[e+229|0]&4){c=j+484414|0;u[c>>1]=x[c>>1]|64}c=w[e+243|0]|w[e+244|0]<<8|(w[e+245|0]<<16|w[e+246|0]<<24);v[113382]=0;U(307,e+160|0,b|0,c|0);o=v[113382];v[113382]=0;hb:{ib:{I=e;jb:{kb:{if((o|0)!=1){o=te(f);H=(l|0)==16384;if(!H&(l|0)!=8192){break ib}v[113382]=0;m=T(225,e+160|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break hb}v[e+136>>2]=m;c=v[e+136>>2];m=4/(o>>>0)|0;if(c>>>0>4294967295/(m>>>0)>>>0){break kb}m=B(c,m);break jb}d=P()|0;O()|0;break Ya}m=-1}v[I+136>>2]=m;tc(f,m);if(!H){if((l|0)!=8192){break ib}v[113382]=0;c=T(422,f|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break ab}if(!c){break cb}if(t[e+228|0]&1){c=v[j+484400>>2];f=v[f>>2];v[113382]=0;X(810,e+160|0,c|0,f|0,o|0);f=v[113382];v[113382]=0;c=d;if((f|0)!=1){break bb}break ab}c=v[j+484400>>2];f=v[f>>2];v[113382]=0;X(811,e+160|0,c|0,f|0,o|0);f=v[113382];v[113382]=0;c=d;if((f|0)==1){break ab}break bb}v[113382]=0;c=T(422,f|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break ab}if(!c){break cb}if(t[e+228|0]&1){c=v[j+484400>>2];f=v[f>>2];v[113382]=0;X(812,e+160|0,c|0,f|0,o|0);f=v[113382];v[113382]=0;c=d;if((f|0)==1){break ab}break bb}c=v[j+484400>>2];f=v[f>>2];v[113382]=0;X(813,e+160|0,c|0,f|0,o|0);f=v[113382];v[113382]=0;c=d;if((f|0)==1){break ab}break bb}if((A&45056)==12288){c=yQ(e+136|0,e+160|0,w[e+247|0]|w[e+248|0]<<8,h);f=Bz(z,i-1|0);Qd(f,c);v[f+16>>2]=v[c+16>>2];Bb(c);break cb}if((l|0)!=32768){c=1;if((l|0)!=4096){break bb}c=e+160|0;h=af(e+136|0,c);v[113382]=0;Q(814,e+128|0,c|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){lb:{if(!w[e+133|0]){break lb}c=x[e+130>>1]<<1;if((c&65535)>>>0>(w[e+247|0]|w[e+248|0]<<8)>>>0){break lb}c=(w[e+247|0]|w[e+248|0]<<8)-c|0;t[e+247|0]=c;t[e+248|0]=c>>>8;v[113382]=0;Q(226,e+160|0,x[e+128>>1])|0;c=v[113382];v[113382]=0;if((c|0)==1){break db}v[113382]=0;c=T(296,e+160|0)|0;i=v[113382];v[113382]=0;if((i|0)==1){break db}v[113382]=0;U(307,e+112|0,e+160|0,c|0);c=v[113382];v[113382]=0;if((c|0)==1){break db}c=e+112|0;Qd(h,c);Bb(c)}v[113382]=0;c=g&65535;i=ea(815,a|0,c|0,h|0,1,1)|0;l=v[113382];v[113382]=0;if((l|0)==1){break db}mb:{if(!i){v[113382]=0;i=aa(816,a|0,c|0,h|0,1)|0;c=v[113382];v[113382]=0;if((c|0)==1){break db}c=1;if(!i){break mb}}nb:{if(!(w[e+247|0]|w[e+248|0]<<8)){break nb}c=w[e+247|0]|w[e+248|0]<<8;if(zj(f)>>>0<=c>>>0){break nb}c=w[e+247|0]|w[e+248|0]<<8;i=Wn(f);j=j+484400|0;l=v[j>>2];v[113382]=0;l=T(423,l|0)|0;o=v[113382];v[113382]=0;if((o|0)==1){break a}j=v[j>>2];v[113382]=0;j=T(423,j|0)|0;o=v[113382];v[113382]=0;if((o|0)==1){break a}_i(l,j+(w[e+247|0]|w[e+248|0]<<8)|0,zj(f)-(w[e+247|0]|w[e+248|0]<<8)|0);v[f>>2]=v[f>>2]-((c>>>0)/(i>>>0)|0)}c=v[e+216>>2];v[e+108>>2]=c;v[e+12>>2]=c;if(y[f>>2]>(w[e+12|0]|w[e+13|0]<<8|(w[e+14|0]<<16|w[e+15|0]<<24))>>>0){v[f>>2]=w[e+12|0]|w[e+13|0]<<8|(w[e+14|0]<<16|w[e+15|0]<<24)}c=d}Bb(h);break bb}break db}v[113382]=0;c=Q(602,e+160|0,e+136|0)|0;h=v[113382];v[113382]=0;if((h|0)!=1){if(!c){break cb}v[113382]=0;v[e+24>>2]=v[e+144>>2];c=v[e+140>>2];v[e+16>>2]=v[e+136>>2];v[e+20>>2]=c;U(603,f|0,1,e+16|0);c=v[113382];v[113382]=0;if((c|0)!=1){break cb}}d=P()|0;O()|0;break $a}d=P()|0;O()|0;break $a}d=P()|0;O()|0;break Ya}yb(n);c=d;break Va}d=P()|0;O()|0;Bb(h);break $a}c=d}Bb(e+160|0);break Wa}d=P()|0;O()|0}Bb(e+160|0)}yb(n);break l}c=d}yb(n);g=g+1|0;i=g&65535;if(i>>>0<=x[a+480190>>1]){continue}break}}if(!(!s|!x[a+480190>>1])){h=1;r=1;while(1){b=Bz(z,h-1|0);v[113382]=0;d=T(303,b|0)|0;g=v[113382];v[113382]=0;ob:{pb:{qb:{if((g|0)!=1){if(!d){break ob}g=x[b+18>>1];d=g+r&65535;rb:{sb:{g=(g|0)!=0&(d|0)!=0&d>>>0<=x[a+480190>>1]&x[b+16>>1]!=0;if(!g){v[113382]=0;T(225,b|0)|0;d=v[113382];v[113382]=0;if((d|0)!=1){break sb}break m}d=Bz(z,d-1|0);f=x[b+16>>1];Ic(d);i=x[b+16>>1];v[113382]=0;i=Q(228,d|0,i|0)|0;j=v[113382];v[113382]=0;if((j|0)==1){break m}if(!i){break ob}v[113382]=0;v[e+136>>2]=0;v[e+160>>2]=0;U(817,e+208|0,d|0,f|0);f=v[113382];v[113382]=0;tb:{if((f|0)!=1){v[113382]=0;f=T(426,e+208|0)|0;i=v[113382];v[113382]=0;if((i|0)==1){break tb}v[113382]=0;f=T(818,f|0)|0;i=v[113382];v[113382]=0;if((i|0)==1){break tb}i=v[e+208>>2];v[113382]=0;i=T(819,i|0)|0;j=v[113382];v[113382]=0;if((j|0)==1){break tb}v[113382]=0;n=ea(820,f|0,i|0,e+136|0,e+160|0,0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break tb}v[113382]=0;Q(304,d|0,v[e+136>>2])|0;d=v[113382];v[113382]=0;if((d|0)==1){break tb}Cc(e+208|0);break rb}d=P()|0;O()|0;break l}d=P()|0;O()|0;Cc(e+208|0);break l}Ic(b);n=0;v[e+136>>2]=0;v[e+160>>2]=0}v[113382]=0;R(821,e+208|0,b|0);d=v[113382];v[113382]=0;ub:{vb:{if((d|0)!=1){v[113382]=0;d=T(426,e+208|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break ub}j=v[e+208>>2];if(!g){v[113382]=0;g=T(818,d|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break qb}v[113382]=0;f=T(819,j|0)|0;i=v[113382];v[113382]=0;if((i|0)==1){break qb}v[113382]=0;n=ea(820,g|0,f|0,e+136|0,e+160|0,0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break qb}v[113382]=0;Q(304,b|0,v[e+136>>2])|0;g=v[113382];v[113382]=0;if((g|0)==1){break qb}g=v[e+136>>2];j=j-g|0;d=d+g|0}if(n){break vb}c=1;break pb}d=P()|0;O()|0;break l}v[113382]=0;f=B(h,104)+a|0;g=f+484380|0;T(422,g|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break qb}h=f+484400|0;o=f+484414|0;i=0;f=v[e+160>>2];while(1){wb:{if(y[g>>2]<=i>>>0|(!j|(f|0)!=1?f:0)){break wb}if(!Be(g)){break wb}v[113382]=0;v[e+112>>2]=0;v[e+176>>2]=0;f=T(818,d|0)|0;l=v[113382];v[113382]=0;if((l|0)==1){break qb}v[113382]=0;l=T(819,j|0)|0;m=v[113382];v[113382]=0;if((m|0)==1){break qb}v[113382]=0;f=ka(822,n|0,f|0,l|0,e+112|0,e+128|0,e+176|0)|0;l=v[113382];v[113382]=0;if((l|0)==1){break qb}v[113382]=0;v[e+136>>2]=f;Q(304,b|0,f|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break qb}f=v[g>>2];v[113382]=0;l=v[e+136>>2];f=T(823,f-i|0)|0;m=v[113382];v[113382]=0;if((m|0)==1){break qb}Si(e+176|0,f);xb:{if(v[e+176>>2]<=0){break xb}if(v[e+112>>2]!=(te(g)|0)){break xb}f=0;if(v[e+112>>2]<=0){break xb}while(1){yb:{if(t[o|0]&1){m=v[h>>2];s=te(g);A=v[v[e+128>>2]+(f<<2)>>2];v[113382]=0;fa(824,m+(B(i,s)<<1)|0,A|0,v[e+112>>2],v[e+176>>2],f|0);m=v[113382];v[113382]=0;if((m|0)!=1){break yb}break qb}m=v[h>>2];s=te(g);A=v[v[e+128>>2]+(f<<2)>>2];v[113382]=0;fa(825,m+B(i,s)|0,A|0,v[e+112>>2],v[e+176>>2],f|0);m=v[113382];v[113382]=0;if((m|0)==1){break qb}}f=f+1|0;if((f|0)<v[e+112>>2]){continue}break}}v[113382]=0;m=v[e+176>>2];f=T(826,n|0)|0;s=v[113382];v[113382]=0;if((s|0)==1){break qb}j=j-l|0;d=d+l|0;v[e+160>>2]=f;i=i+m|0;continue}break}v[113382]=0;Z(827,n|0);b=v[113382];v[113382]=0;if((b|0)!=1){break pb}break qb}break qb}d=P()|0;O()|0;break l}d=P()|0;O()|0;Cc(e+208|0);break l}Cc(e+208|0)}r=r+1|0;h=r&65535;if(h>>>0<=x[a+480190>>1]){continue}break}}zb:{if(v[a+480180>>2]!=4){break zb}f=0;while(1){if(x[a+480192>>1]<=f>>>0){break zb}b=w[Pb(q,f)|0];d=w[Pb(q,f)+1|0];g=w[Pb(q,f)+2|0];h=w[Pb(q,f)+3|0];v[113382]=0;f=f+1|0;ma(828,a|0,f&65535,b|0,d|0,g|0,h|0);b=v[113382];v[113382]=0;if((b|0)!=1){continue}break}d=P()|0;O()|0;break l}Ab:{Bb:{Cb:{Db:{if(!(w[p+2|0]&16)){break Db}v[113382]=0;b=Q(228,k|0,1)|0;d=v[113382];v[113382]=0;if((d|0)==1){break n}if(!b){break Db}f=0;v[113382]=0;b=T(409,k|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break o}if(!(!(b&1)|!x[G>>1])){while(1){v[113382]=0;b=T(397,k|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break Cb}t[((f<<5)+a|0)+480288|0]=b;f=f+1|0;if(f>>>0<x[a+480188>>1]){continue}break}}while(1){v[113382]=0;b=Q(228,k|0,1)|0;d=v[113382];v[113382]=0;Eb:{if((d|0)!=1){if(!b){break Db}v[113382]=0;b=T(409,k|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break Bb}if(!b){break Db}v[113382]=0;d=T(397,k|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break Ab}v[113382]=0;U(307,e+208|0,k|0,d|0);d=v[113382];v[113382]=0;if((d|0)==1){break Ab}if(b>>>0>250){break Eb}v[113382]=0;R(628,e+208|0,(B(b,160)+a|0)+906140|0);b=v[113382];v[113382]=0;if((b|0)!=1){break Eb}d=P()|0;O()|0;Bb(e+208|0);break l}d=P()|0;O()|0;break l}Bb(e+208|0);continue}}j=a+901404|0;n=a+1074308|0;i=bd(e+112|0);g=0;b=0;Fb:{Gb:{while(1){v[113382]=0;d=Q(228,k|0,8)|0;f=v[113382];v[113382]=0;if((f|0)==1){break Fb}if(!d){break Gb}v[113382]=0;d=T(397,k|0)|0;f=v[113382];v[113382]=0;Hb:{Ib:{Jb:{Kb:{Lb:{Mb:{Nb:{Ob:{Pb:{Qb:{Rb:{Sb:{Tb:{Ub:{Vb:{Wb:{Xb:{if((f|0)!=1){v[113382]=0;f=T(397,k|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break Xb}v[113382]=0;U(307,e+136|0,k|0,f|0);f=v[113382];v[113382]=0;if((f|0)==1){break Wb}if((d|0)<=1397900629){if((d|0)==1229211981){break Ub}if((d|0)!=1229476432){break Ib}v[113382]=0;d=T(409,e+136|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break r}v[a+480216>>2]=d;v[113382]=0;d=T(409,e+136|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break r}v[a+480220>>2]=d;break Ib}if((d|0)==1397900630){break Vb}if((d|0)!=1414548815){break Ib}v[113382]=0;d=Q(580,e+136|0,9805)|0;f=v[113382];v[113382]=0;if((f|0)==1){break r}if(!d){break Sb}v[113382]=0;d=T(397,e+136|0)|0;f=v[113382];v[113382]=0;if((f|0)!=1){v[113382]=0;U(307,e+160|0,e+136|0,d|0);d=v[113382];v[113382]=0;if((d|0)!=1){break Tb}}d=P()|0;O()|0;break q}d=P()|0;O()|0;break p}d=P()|0;O()|0;break p}d=P()|0;O()|0;break p}Yb:{Zb:{_b:{d=v[a+480180>>2];switch(d-2|0){case 1:break Ib;case 0:break Jb;case 2:break Zb;default:break _b}}if((d|0)==16){break Yb}if((d|0)!=32){break Ib}v[113382]=0;g=T(323,e+136|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break r}v[113382]=0;b=T(323,e+136|0)|0;d=v[113382];v[113382]=0;if((d|0)!=1){break Ib}break r}v[113382]=0;v[e+208>>2]=32;d=T(225,e+136|0)|0;f=v[113382];v[113382]=0;$b:{if((f|0)==1){break $b}v[113382]=0;v[e+160>>2]=d;d=Q(33,e+208|0,e+160|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break $b}d=v[d>>2];v[113382]=0;aa(829,e+136|0,i|0,4,d|0)|0;d=v[113382];v[113382]=0;if((d|0)!=1){break Ib}}d=P()|0;O()|0;break q}v[113382]=0;d=T(409,e+136|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break Hb}v[113382]=0;f=Q(2,e+96|0,11071)|0;h=v[113382];v[113382]=0;ac:{bc:{cc:{if((h|0)!=1){v[113382]=0;R(189,e+160|0,f|0);h=v[113382];v[113382]=0;if((h|0)==1){break cc}v[113382]=0;v[e+176>>2]=d>>>4;v[e+128>>2]=d&15;X(497,e+208|0,e+160|0,e+176|0,e+128|0);d=v[113382];v[113382]=0;if((d|0)==1){break bc}d=e+208|0;Gb(i,d);yb(d);Ib(e+160|0);yb(f);break Ib}d=P()|0;O()|0;break q}d=P()|0;O()|0;break ac}d=P()|0;O()|0;Ib(e+160|0)}yb(f);break q}v[113382]=0;Q(594,e+136|0,j|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break r}v[113382]=0;Z(595,j|0);d=v[113382];v[113382]=0;if((d|0)==1){break r}break Ib}v[113382]=0;d=T(225,e+160|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break Rb}u[e+208>>1]=d>>>5;d=Ae(E);v[113382]=0;u[e+176>>1]=d;d=Q(438,e+208|0,e+176|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break Rb}d=x[d>>1];if(d){h=0;while(1){v[113382]=0;W(830,e+160|0,e+208|0,32)|0;f=v[113382];v[113382]=0;if((f|0)==1){break Rb}f=Zb(E,h);v[113382]=0;Q(831,f|0,e+208|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break Rb}h=h+1|0;if((d|0)!=(h|0)){continue}break}}Bb(e+160|0)}v[113382]=0;d=Q(580,e+136|0,9810)|0;f=v[113382];v[113382]=0;if((f|0)==1){break r}if(!d){break Pb}v[113382]=0;d=T(397,e+136|0)|0;f=v[113382];v[113382]=0;if((f|0)!=1){v[113382]=0;U(307,e+208|0,e+136|0,d|0);d=v[113382];v[113382]=0;if((d|0)!=1){break Qb}}d=P()|0;O()|0;break q}d=P()|0;O()|0;Bb(e+160|0);break q}v[113382]=0;d=T(225,e+208|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break Ob}u[e+160>>1]=(d>>>0)/20;d=x[a+480188>>1];v[113382]=0;u[e+176>>1]=d;d=Q(438,e+160|0,e+176|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break Ob}d=x[d>>1];if(d){f=0;while(1){v[113382]=0;W(597,e+208|0,((f<<5)+a|0)+480289|0,20)|0;h=v[113382];v[113382]=0;if((h|0)==1){break Ob}f=f+1|0;if((d|0)!=(f|0)){continue}break}}Bb(e+208|0)}v[113382]=0;Q(614,a|0,e+136|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break r}v[113382]=0;X(615,a|0,e+136|0,1,0);d=v[113382];v[113382]=0;if((d|0)==1){break r}if((g-2186&65535)>>>0<=117){v[a+480180>>2]=16777216;v[113382]=0;U(626,a|0,e+136|0,g&65535);d=v[113382];v[113382]=0;if((d|0)==1){break r}}if(!v[n>>2]){break Ib}v[113382]=0;f=Q(2,e+160|0,13545)|0;d=v[113382];v[113382]=0;if((d|0)==1){break Nb}v[113382]=0;R(212,e+176|0,n|0);d=v[113382];v[113382]=0;if((d|0)==1){break Mb}v[113382]=0;U(3,e+208|0,f|0,e+176|0);d=v[113382];v[113382]=0;if((d|0)==1){break Lb}d=e+208|0;Gb(i,d);yb(d);yb(e+176|0);yb(f);break Ib}d=P()|0;O()|0;Bb(e+208|0);break q}d=P()|0;O()|0;break q}d=P()|0;O()|0;break Kb}d=P()|0;O()|0;yb(e+176|0)}yb(f);break q}v[113382]=0;g=T(323,e+136|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break r}}Bb(e+136|0);continue}break}d=P()|0;O()|0;break q}dc:{ec:{fc:{gc:{hc:{ic:{jc:{if(v[a+480180>>2]!=32){break jc}d=g&65535;if(d>>>0<256){break jc}if(d>>>0<532){break ic}}kc:{if(v[a+480180>>2]!=2){break kc}d=g&65535;if(d>>>0<12544){break kc}if(d>>>0<12820){break ic}}if(v[a+480180>>2]!=2){break hc}d=g&65535;if(d>>>0<4864|d>>>0>4895){break hc}}v[113382]=0;Z(596,j|0);d=v[113382];v[113382]=0;if((d|0)==1){break gc}}if(!(t[p+2|0]&1)){break dc}if(!(v[a+1074308>>2]|!x[a+480192>>1])){f=1;while(1){d=v[(((f&65535)<<2)+a|0)+900380>>2];if(d){v[113382]=0;g=Q(340,d|0,2)|0;h=v[113382];v[113382]=0;if((h|0)==1){break fc}h=v[a+480180>>2];v[113382]=0;U(832,g|0,4,h|0);g=v[113382];v[113382]=0;if((g|0)==1){break ec}t[d+19|0]=w[d+19|0]+3>>>2}f=f+1|0;if(x[a+480192>>1]>=(f&65535)>>>0){continue}break}}if(y[a+1074308>>2]<18350080){v[113382]=0;d=a+1074312|0;Q(440,d|0,27)|0;g=v[113382];v[113382]=0;if((g|0)==1){break gc}v[113382]=0;Q(440,d|0,57)|0;d=v[113382];v[113382]=0;if((d|0)==1){break gc}}if(y[a+1074308>>2]<19070976){v[113382]=0;Q(440,a+1074312|0,73)|0;d=v[113382];v[113382]=0;if((d|0)==1){break gc}}if(y[a+1074308>>2]>=19267584){break dc}v[113382]=0;Q(440,a+1074312|0,50)|0;d=v[113382];v[113382]=0;if((d|0)!=1){break dc}}d=P()|0;O()|0;break p}d=P()|0;O()|0;break p}d=P()|0;O()|0;break p}lc:{mc:{nc:{oc:{pc:{qc:{rc:{sc:{tc:{uc:{vc:{wc:{xc:{yc:{zc:{Ac:{Bc:{Cc:{if(Sc(i)){v[113382]=0;g=Q(2,e+80|0,11507)|0;d=v[113382];v[113382]=0;Dc:{Ec:{Fc:{if((d|0)!=1){v[113382]=0;R(189,e+136|0,g|0);d=v[113382];v[113382]=0;if((d|0)==1){break Fc}v[113382]=0;U(500,e+208|0,e+136|0,e+1575|0);d=v[113382];v[113382]=0;if((d|0)==1){break Ec}break Cc}d=P()|0;O()|0;break p}d=P()|0;O()|0;break Dc}d=P()|0;O()|0;Ib(e+136|0)}yb(g);break p}v[113382]=0;g=Q(2,e- -64|0,13252)|0;d=v[113382];v[113382]=0;if((d|0)==1){break Bc}v[113382]=0;R(189,e+136|0,g|0);d=v[113382];v[113382]=0;if((d|0)==1){break Ac}v[113382]=0;X(407,e+208|0,e+136|0,e+1575|0,i|0);d=v[113382];v[113382]=0;if((d|0)==1){break zc}}d=e+208|0;Gb(i,d);yb(d);Ib(e+136|0);yb(g);v[113382]=0;g=Q(2,e+48|0,11499)|0;d=v[113382];v[113382]=0;if((d|0)==1){break wc}v[113382]=0;R(189,e+136|0,g|0);d=v[113382];v[113382]=0;if((d|0)==1){break vc}v[113382]=0;U(500,e+208|0,e+136|0,e+1575|0);d=v[113382];v[113382]=0;if((d|0)==1){break uc}d=e+208|0;Gb(a+1304436|0,d);yb(d);Ib(e+136|0);yb(g);v[113382]=0;d=Q(2,d|0,10676)|0;g=v[113382];v[113382]=0;if((g|0)==1){break sc}Gb(a+1304448|0,d);yb(d);d=v[a+480180>>2];if((d|0)>15){break xc}switch(d-1|0){case 1:break oc;case 3:break pc;case 0:break qc;default:break w}}d=P()|0;O()|0;break p}d=P()|0;O()|0;break yc}d=P()|0;O()|0;Ib(e+136|0)}yb(g);break p}if((d|0)==16){break rc}if((d|0)==32){break nc}if((d|0)!=16777216){break w}v[113382]=0;b=Q(2,e+208|0,6212)|0;d=v[113382];v[113382]=0;if((d|0)==1){break mc}Gb(a+1304484|0,b);yb(b);v[113382]=0;b=Q(2,e+208|0,9767)|0;d=v[113382];v[113382]=0;if((d|0)==1){break lc}Gb(a+1304472|0,b);yb(b);break w}d=P()|0;O()|0;break p}d=P()|0;O()|0;break tc}d=P()|0;O()|0;Ib(e+136|0)}yb(g);break p}d=P()|0;O()|0;break p}v[113382]=0;b=Q(2,e+208|0,6217)|0;d=v[113382];v[113382]=0;Gc:{if((d|0)!=1){Gb(a+1304484|0,b);yb(b);v[113382]=0;b=Q(2,e+208|0,4653)|0;d=v[113382];v[113382]=0;if((d|0)==1){break Gc}Gb(a+1304472|0,b);yb(b);break w}d=P()|0;O()|0;break p}d=P()|0;O()|0;break p}v[113382]=0;b=Q(2,e+208|0,8287)|0;d=v[113382];v[113382]=0;Hc:{if((d|0)!=1){Gb(a+1304484|0,b);yb(b);v[113382]=0;b=Q(2,e+208|0,10112)|0;d=v[113382];v[113382]=0;if((d|0)==1){break Hc}Gb(a+1304472|0,b);yb(b);break w}d=P()|0;O()|0;break p}d=P()|0;O()|0;break p}v[113382]=0;b=Q(2,e+208|0,6190)|0;d=v[113382];v[113382]=0;Ic:{if((d|0)!=1){Gb(a+1304484|0,b);yb(b);v[113382]=0;b=Q(2,e+208|0,11272)|0;d=v[113382];v[113382]=0;if((d|0)==1){break Ic}Gb(a+1304472|0,b);yb(b);break w}d=P()|0;O()|0;break p}d=P()|0;O()|0;break p}v[113382]=0;b=Q(2,e+208|0,6562)|0;d=v[113382];v[113382]=0;Jc:{if((d|0)!=1){Gb(a+1304484|0,b);yb(b);v[113382]=0;b=Q(2,e+208|0,10836)|0;d=v[113382];v[113382]=0;if((d|0)==1){break Jc}Gb(a+1304472|0,b);yb(b);break w}d=P()|0;O()|0;break p}d=P()|0;O()|0;break p}v[113382]=0;d=Q(2,e+208|0,2520)|0;g=v[113382];v[113382]=0;Kc:{Lc:{Mc:{Nc:{Oc:{Pc:{Qc:{if((g|0)!=1){Gb(a+1304484|0,d);yb(d);if(!(b&65535)){break Kc}v[113382]=0;g=Q(2,e+32|0,11174)|0;d=v[113382];v[113382]=0;if((d|0)==1){break Qc}v[113382]=0;R(189,e+136|0,g|0);d=v[113382];v[113382]=0;if((d|0)==1){break Pc}v[113382]=0;v[e+176>>2]=(b&65280)>>>8;v[e+128>>2]=b&255;R(622,e+160|0,e+128|0);b=v[113382];v[113382]=0;if((b|0)==1){break Oc}v[113382]=0;X(607,e+208|0,e+136|0,e+176|0,e+160|0);b=v[113382];v[113382]=0;if((b|0)==1){break Nc}b=e+208|0;Gb(a+1304472|0,b);yb(b);yb(e+160|0);Ib(e+136|0);yb(g);break w}d=P()|0;O()|0;break p}d=P()|0;O()|0;break p}d=P()|0;O()|0;break Lc}d=P()|0;O()|0;break Mc}d=P()|0;O()|0;yb(e+160|0)}Ib(e+136|0)}yb(g);break p}v[113382]=0;b=Q(2,e+208|0,4813)|0;d=v[113382];v[113382]=0;if((d|0)!=1){Gb(a+1304472|0,b);yb(b);break w}d=P()|0;O()|0;break p}d=P()|0;O()|0;break p}d=P()|0;O()|0;break p}d=P()|0;O()|0;break p}d=P()|0;O()|0;break l}d=P()|0;O()|0;break l}d=P()|0;O()|0;break l}d=P()|0;O()|0;break j}d=P()|0;O()|0;break h}d=P()|0;O()|0;break h}d=P()|0;O()|0;break h}d=P()|0;O()|0;break d}d=P()|0;O()|0;break d}d=P()|0;O()|0;break d}d=P()|0;O()|0;break c}d=P()|0;O()|0;break c}d=P()|0;O()|0;break d}Gb(a+1304460|0,i);Rc:{if(v[a+1074308>>2]){v[a+1304496>>2]=7;break Rc}if(v[a+480180>>2]==1){v[a+1304496>>2]=2;break Rc}v[a+1304496>>2]=4}f=1;if(c&1){v[113382]=0;b=Q(2,e+208|0,12662)|0;c=v[113382];v[113382]=0;if((c|0)==1){break t}v[113382]=0;U(608,a|0,2,b|0);a=v[113382];v[113382]=0;if((a|0)==1){break s}yb(b)}yb(i);wQ(z);vQ(q);cd(C);Bb(e+1072|0);Bb(e+1088|0)}Bb(k)}$d(D);break b}d=P()|0;O()|0;break p}d=P()|0;O()|0;yb(b);break p}d=P()|0;O()|0}Bb(e+136|0)}yb(i);break l}d=P()|0;O()|0;break l}d=P()|0;O()|0;break l}d=P()|0;O()|0}wQ(z);break j}d=P()|0;O()|0}vQ(q);break h}d=P()|0;O()|0}cd(C)}Bb(e+1072|0)}Bb(e+1088|0);break d}d=P()|0;O()|0}Bb(k)}$d(D);S(d|0);L()}jb=e+1584|0;return f|0}V(0)|0;O()|0;Ab();L()}function sja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,z=0,A=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,M=0,N=0,Y=0,_=0,$=0,ba=0,ca=0,da=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0;d=jb-928|0;jb=d;Ic(b);a:{b:{if(!WQ(b,d+872|0)){break b}if(!YQ(d+872|0)){break b}if(!Rb(b,dd(XQ(d+872|0),mb))){break b}if(!c){f=1;break b}Id(a,8);vi(a);g=w[d+872|3]-48|0;t[d+871|0]=g;e=w[d+880|0]|w[d+881|0]<<8|(w[d+882|0]<<16|w[d+883|0]<<24);Nc(b,e<<24|e<<8&16711680|(e>>>8&65280|e>>>24));td(d+848|0,b,504);v[113382]=0;Q(735,b|0,d+560|0)|0;e=v[113382];v[113382]=0;c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{if((e|0)!=1){if(w[d+560|0]&128|w[d+843|0]>63){break c}Qb(d+480|0,0,80);p:{if(!(w[d+904|0]|w[d+905|0]<<8|(w[d+906|0]<<16|w[d+907|0]<<24))){break p}e=w[d+904|0]|w[d+905|0]<<8|(w[d+906|0]<<16|w[d+907|0]<<24);v[113382]=0;e=Q(226,b|0,e<<8&16711680|e<<24|(e>>>8&65280|e>>>24))|0;j=v[113382];v[113382]=0;if((j|0)!=1){if(!e){break p}v[113382]=0;Q(736,b|0,d+480|0)|0;e=v[113382];v[113382]=0;if((e|0)!=1){break p}}f=P()|0;O()|0;break f}v[113382]=0;U(737,d+472|0,b|0,g&255);e=v[113382];v[113382]=0;if((e|0)!=1){e=d+472|0;N=Cf(e);e=x[e>>1];if((e-1&65535)>>>0>126){break c}u[a+480188>>1]=e;e=jb-16|0;jb=e;F=d+456|0;j=F;v[j>>2]=0;v[j+4>>2]=0;v[113382]=0;v[e+12>>2]=0;W(778,j+8|0,e+12|0,e+8|0)|0;j=v[113382];v[113382]=0;q:{if((j|0)!=1){jb=e+16|0;break q}break a}r:{if(w[d+896|0]|w[d+897|0]<<8|(w[d+898|0]<<16|w[d+899|0]<<24)){e=w[d+896|0]|w[d+897|0]<<8|(w[d+898|0]<<16|w[d+899|0]<<24);v[113382]=0;Q(226,b|0,e<<8&16711680|e<<24|(e>>>8&65280|e>>>24))|0;e=v[113382];v[113382]=0;if((e|0)!=1){e=w[d+843|0];v[113382]=0;W(738,b|0,F|0,e|0)|0;e=v[113382];v[113382]=0;if((e|0)!=1){break r}}f=P()|0;O()|0;break g}if(w[d+843|0]){break d}}e=w[d+843|0];u[a+480192>>1]=e;u[a+480190>>1]=e;f=1;Y=1;if((g&255)>>>0>=2){Y=t[d+824|0]>=0;e=x[a+480192>>1]}if(e&65535){G=c&2;H=!Y;e=d+88|0;q=e|2;K=e|7;I=e|6;r=e|5;A=e|4;l=d+48|4;o=1;m=1;while(1){v[113382]=0;D=m&65535;e=W(411,a|0,o&65535,D|0)|0;g=v[113382];v[113382]=0;s:{t:{if((g|0)!=1){if(!e){break e}i=v[((f<<2)+a|0)+900380>>2];v[113382]=0;u[d+52>>1]=0;v[d+48>>2]=0;p=T(244,d+168|0)|0;e=v[113382];v[113382]=0;u:{v:{w:{x:{if((e|0)!=1){g=f-1|0;e=Pb(F,g);y:{if(!(w[e|0]|w[e+1|0]<<8|(w[e+2|0]<<16|w[e+3|0]<<24))){break y}e=Pb(F,g);e=w[e|0]|w[e+1|0]<<8|(w[e+2|0]<<16|w[e+3|0]<<24);v[113382]=0;e=Q(226,b|0,e<<8&16711680|e<<24|(e>>>8&65280|e>>>24))|0;g=v[113382];v[113382]=0;if((g|0)==1){break h}if(!e){break y}v[113382]=0;Q(739,b|0,d+48|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break h}e=w[d+48|0]|w[d+49|0]<<8|(w[d+50|0]<<16|w[d+51|0]<<24);v[113382]=0;U(307,d+88|0,b|0,e<<8&16711680|e<<24|(e>>>8&65280|e>>>24));e=v[113382];v[113382]=0;if((e|0)==1){break h}e=d+88|0;Qd(p,e);Bb(e)}g=w[l+1|0]&15;n=(w[l|0]|w[l+1|0]<<8)&128;if(!n){break x}v[113382]=0;R(740,i|0,0);e=v[113382];v[113382]=0;ca=1;if((e|0)!=1){break w}break h}f=P()|0;O()|0;break g}if(g>>>0>=7){break w}e=w[g+23910|0];if(!g){g=e;break t}u[a+480190>>1]=(x[a+480190>>1]+e|0)-1;g=i+108|0;h=i+236|0;E=e-2|0;j=4;while(1){k=j-4|0;f=E<<3;s=k+(f+23968|0)|0;k=w[k+(f+23920|0)|0]+m|0;z=B(j,12);f=0;while(1){C=f+z|0;na=_c(h,C),oa=k,u[na>>1]=oa;C=ec(g,C);t[C|0]=w[C|0]+w[s|0];f=f+1|0;if((f|0)!=12){continue}break}k=1;j=j+1|0;if((j|0)!=10){continue}break}g=e;break v}e=1;if((g|0)!=7){g=1;break t}k=0;v[113382]=0;R(741,i|0,-24);e=v[113382];v[113382]=0;g=1;if((e|0)==1){break u}e=1}E=1;break s}break h}f=P()|0;O()|0;break g}k=0;if(n|H){break s}k=i+108|0;j=7;while(1){h=B(j,12);s=B(j,-12)+72|0;f=0;while(1){z=ec(k,f+h|0);t[z|0]=s+w[z|0];f=f+1|0;if((f|0)!=12){continue}break}j=j+1|0;if((j|0)!=10){continue}break}k=0}v[113382]=0;Q(742,d+848|0,d+88|0)|0;f=v[113382];v[113382]=0;z:{if((f|0)!=1){if(!(!w[A|0]|w[A|0]>16)){t[i+31|0]=w[A|0];E=1}if(!(!w[r|0]|w[r|0]>128)){t[i+30|0]=w[r|0]}h=0;i=0;if(!g){break z}A:{while(1){B:{v[113382]=0;f=B(h+D|0,104)+a|0;R(453,f+484380|0,8);j=v[113382];v[113382]=0;if((j|0)==1){break B}j=w[I|0];v[113382]=0;t[d+424|0]=j;t[d+152|0]=64;j=Q(415,d+424|0,d+152|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break A}u[f+484410>>1]=w[j|0]<<2;t[f+484416|0]=w[K|0];i=i+1|0;h=i&65535;if(h>>>0<g>>>0){continue}break z}break}break h}break h}break h}C:{if(n|!G){break C}n=Yc(d+424|0,8,1,1,0);f=w[q|0]|w[q+1|0]<<8;j=f;i=w[d+88|0]|w[d+89|0]<<8;h=f;v[113382]=0;f=T(225,p|0)|0;s=v[113382];v[113382]=0;if((s|0)==1){break h}if(w[l+1|0]&16){mA(n);f=f>>>1|0}if(w[l+1|0]&32){aC(n);f=f>>>1|0}if(w[l+1|0]&64){Zl(n,2)}f=k?(f>>>0)/((-1<<g^-1)>>>0)|0:f;if(!g){break C}i=(i<<8|i>>>8)&65535;k=i+((h<<8|h>>>8)&65535)|0;s=j<<8|j>>>8;h=0;j=0;while(1){h=B(h+D|0,104)+a|0;z=h+484380|0;v[z>>2]=f;v[113382]=0;W(362,n|0,z|0,p|0)|0;z=v[113382];v[113382]=0;if((z|0)==1){break h}i=i<<1;k=k<<1;if((s&65535)>>>0>=2){v[h+484388>>2]=k;v[h+484384>>2]=i;h=h+484414|0;u[h>>1]=x[h>>1]|2}f=f<<1;j=j+1|0;h=j&65535;if(h>>>0<g>>>0){continue}break}}Bb(p);m=e+m|0;o=o+1|0;f=o&65535;if(f>>>0<=x[a+480192>>1]){continue}break}}e=d+480|4;D:{if(!(w[e|0]|w[e+1|0]<<8|(w[e+2|0]<<16|w[e+3|0]<<24))|!(w[d+488|0]|w[d+489|0]<<8)){break D}e=w[e|0]|w[e+1|0]<<8|(w[e+2|0]<<16|w[e+3|0]<<24);v[113382]=0;e=Q(226,b|0,e<<8&16711680|e<<24|(e>>>8&65280|e>>>24))|0;g=v[113382];v[113382]=0;if((g|0)==1){break i}if(!e){break D}e=w[d+488|0]|w[d+489|0]<<8;u[d+168>>1]=e<<8|e>>>8;e=w[d+843|0];v[113382]=0;u[d+88>>1]=e;e=Q(438,d+168|0,d+88|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break j}o=x[e>>1];if(!o){break D}e=d+168|0;l=e|5;m=e|3;j=e|1;g=d+96|0;p=d+88|4;e=w[d+490|0]|w[d+491|0]<<8;k=(e<<8|e>>>8)&65535;q=k>>>0<19;i=0;while(1){v[113382]=0;W(743,b|0,d+168|0,k|0)|0;e=v[113382];v[113382]=0;E:{F:{G:{if((e|0)!=1){i=i+1|0;e=v[((i<<2)+a|0)+900380>>2];if(!w[d+168|0]){break E}n=Fp(d+88|0,0,64);Fp(p,w[d+168|0]-1&65535,64);r=w[d+168|0];Fp(g,r+(w[j|0]?64/w[j|0]|0:0)|0,0);v[113382]=0;v[d+452>>2]=3;v[d+448>>2]=n;f=v[d+452>>2];v[d+8>>2]=v[d+448>>2];v[d+12>>2]=f;f=e+48|0;R(744,f|0,d+8|0);h=v[113382];v[113382]=0;if((h|0)==1){break G}if(w[d+168|0]!=1){break F}na=d,oa=ac(f),v[na+88>>2]=oa;Hd(d+440|0,d+88|0);v[113382]=0;Q(745,f|0,v[d+440>>2])|0;f=v[113382];v[113382]=0;if((f|0)!=1){break F}f=P()|0;O()|0;break g}f=P()|0;O()|0;break g}f=P()|0;O()|0;break g}v[e>>2]=w[j|0]?w[j|0]<<9:32767;E=1;t[e+60|0]=w[e+60|0]|1}H:{if(q){break H}v[e+4>>2]=w[d+186|0]+1>>>1;if(k>>>0<21){break H}u[e+28>>1]=w[d+188|0]|w[d+189|0]<<8}e=B(x[_c(e+236|0,61)>>1],104)+a|0;t[e+484417|0]=w[m|0]<<4;I:{J:{if(k>>>0>=15){f=w[d+178|0]|w[d+179|0]<<8|(w[d+180|0]<<16|w[d+181|0]<<24);v[e+484384>>2]=f<<24|f<<8&16711680|(f>>>8&65280|f>>>24);f=w[d+182|0]|w[d+183|0]<<8|(w[d+184|0]<<16|w[d+185|0]<<24);h=f<<24|f<<8&16711680|(f>>>8&65280|f>>>24);f=w[d+178|0]|w[d+179|0]<<8|(w[d+180|0]<<16|w[d+181|0]<<24);v[e+484388>>2]=h+(f<<8&16711680|f<<24|(f>>>8&65280|f>>>24));break J}if(k>>>0<6){break I}}f=e+484414|0;u[f>>1]=x[f>>1]&65533|w[l|0]<<1&2;u[f>>1]=x[f>>1]&65531|w[l|0]>>>1&4;if(!(w[l|0]&4)){break I}u[e+484412>>1]=0}if((i|0)!=(o|0)){continue}break}}if(!(w[d+500|0]|w[d+501|0]<<8|(w[d+502|0]<<16|w[d+503|0]<<24))|!(w[d+504|0]|w[d+505|0]<<8)){break k}e=w[d+500|0]|w[d+501|0]<<8|(w[d+502|0]<<16|w[d+503|0]<<24);v[113382]=0;e=Q(226,b|0,e<<8&16711680|e<<24|(e>>>8&65280|e>>>24))|0;g=v[113382];v[113382]=0;if((g|0)==1){break i}if(!e){break k}e=w[d+504|0]|w[d+505|0]<<8;u[d+168>>1]=e<<8|e>>>8;e=w[d+843|0];v[113382]=0;u[d+88>>1]=e;e=Q(438,d+168|0,d+88|0)|0;g=v[113382];v[113382]=0;if((g|0)!=1){k=x[e>>1];if(!k){break k}e=w[d+506|0]|w[d+507|0]<<8;i=(e<<8|e>>>8)&65535;e=0;K:while(1){L:{v[113382]=0;W(746,b|0,d+168|0,i|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break l}v[113382]=0;U(747,d+48|0,2,d+168|0);g=v[113382];v[113382]=0;if((g|0)==1){break m}v[113382]=0;R(356,d+88|0,d+48|0);g=v[113382];v[113382]=0;if((g|0)==1){break m}e=e+1|0;j=((e<<2)+a|0)+900380|0;g=v[j>>2];v[113382]=0;Q(335,g+492|0,d+88|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break n}g=d+88|0;yb(g);f=v[j>>2];v[113382]=0;R(748,g|0,f|0);g=v[113382];v[113382]=0;if((g|0)==1){break o}g=d+88|0;na=d,oa=rn(g),v[na+48>>2]=oa;na=d,oa=Ii(g),v[na+424>>2]=oa;while(1){v[113382]=0;g=Q(749,d+48|0,d+424|0)|0;f=v[113382];v[113382]=0;M:{if((f|0)!=1){if(g){break M}Dp(d+88|0);if((e|0)!=(k|0)){continue K}break k}break L}v[113382]=0;g=T(750,d+48|0)|0;f=v[113382];v[113382]=0;if((f|0)!=1){f=(x[g>>1]<<5)+a|0;l=f+946328|0;g=v[j>>2];h=v[g+520>>2];v[l>>2]=v[g+516>>2];v[l+4>>2]=h;h=v[g+512>>2];l=f+946320|0;v[l>>2]=v[g+508>>2];v[l+4>>2]=h;h=v[g+504>>2];l=f+946312|0;v[l>>2]=v[g+500>>2];v[l+4>>2]=h;l=v[g+496>>2];f=f+946304|0;v[f>>2]=v[g+492>>2];v[f+4>>2]=l;wt(d+48|0);continue}break}}break}f=P()|0;O()|0;Dp(d+88|0);break g}f=P()|0;O()|0;break g}f=P()|0;O()|0;break f}f=P()|0;O()|0;break f}f=P()|0;O()|0;break g}f=P()|0;O()|0;yb(d+88|0);break g}f=P()|0;O()|0;break g}f=P()|0;O()|0;break g}j=0;v[113382]=0;Z(596,a+901404|0);e=v[113382];v[113382]=0;if((e|0)==1){break i}e=a+901692|0;g=w[1447]|w[1448]<<8|(w[1449]<<16|w[1450]<<24);t[e|0]=g;t[e+1|0]=g>>>8;t[e+2|0]=g>>>16;t[e+3|0]=g>>>24;t[a+901696|0]=w[1451];Ic(b);K=a+484360|0;N:{O:{P:{Q:{R:{S:{T:{if(!w[N|0]){break T}da=c&1;r=a+484344|0;A=a+1304424|0;z=a+1304400|0;c=d+168|0;ga=c|1;i=c|4;c=d+72|0;p=c|4;D=c|2;ha=c|3;q=d+560|2;I=0;while(1){v[113382]=0;X(751,b|0,d+872|0,d+480|0,d+560|0);c=v[113382];v[113382]=0;U:{V:{W:{X:{Y:{Z:{_:{$:{aa:{if((c|0)==1){break aa}c=I&255;if(c){v[113382]=0;e=T(446,K|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break aa}if((e|0)==255){break e}}l=Di(K,c);g=jb-16|0;jb=g;f=g+8|0;c=jb-16|0;jb=c;v[113382]=0;n=d+424|0;e=n;T(779,e+4|0)|0;k=v[113382];v[113382]=0;ba:{if((k|0)!=1){v[113382]=0;v[c+12>>2]=0;W(780,e+8|0,c+12|0,f|0)|0;f=v[113382];v[113382]=0;if((f|0)!=1){break ba}break a}break a}na=e,oa=jc(e),v[na>>2]=oa;jb=c+16|0;jb=g+16|0;Hn(l);o=w[d+871|0];if(o>>>0>1){break _}c=w[q|0]|w[q+1|0]<<8;if(((c<<8|c>>>8)&65535)>>>0>256|x[a+480188>>1]>16){break Y}e=d+168|0;TQ(e,d+560|0);c=w[q|0]|w[q+1|0]<<8;v[113382]=0;ea(752,l|0,e|0,(c<<8|c>>>8)&65535,65535,65535)|0;c=v[113382];v[113382]=0;if((c|0)==1){break Z}na=d,oa=ac(l),v[na+168>>2]=oa;na=d,oa=bc(l),v[na+88>>2]=oa;if(Jb(d+168|0,d+88|0)){break $}break W}f=P()|0;O()|0;break g}while(1){c=d+168|0;e=v[c>>2];u[e>>1]=x[e>>1]+j;re(c);if(Jb(c,d+88|0)){continue}break}break W}TQ(d+168|0,d+560|0);if(!(w[d+180|0]|w[d+181|0]<<8)){break Y}c=w[d+180|0]|w[d+181|0]<<8;if(((c<<8|c>>>8)&65535)>>>0>64|x[a+480188>>1]>64){break Y}m=w[d+188|0]|w[d+189|0]<<8|(w[d+190|0]<<16|w[d+191|0]<<24);if(!(w[d+192|0]|w[d+193|0]<<8)){k=32;break X}c=w[d+192|0]|w[d+193|0]<<8;v[113382]=0;u[d+88>>1]=c<<8|c>>>8;u[d+48>>1]=800;c=Q(438,d+88|0,d+48|0)|0;e=v[113382];v[113382]=0;if((e|0)!=1){c=x[c>>1];v[113382]=0;k=qg(711,((c<<5)+50>>>0)/100|0,0);c=v[113382];v[113382]=0;if((c|0)!=1){break X}}f=P()|0;O()|0;break N}f=P()|0;O()|0;break N}st(n);break e}c=w[d+176|0]|w[d+177|0]<<8|(w[d+178|0]<<16|w[d+179|0]<<24);v[113382]=0;c=Q(226,b|0,c<<8&16711680|c<<24|(c>>>8&65280|c>>>24))|0;e=v[113382];v[113382]=0;ca:{if((e|0)==1){break ca}f=0;da:{if(!(c&x[a+480188>>1]!=0)){break da}ea:{while(1){fa:{v[113382]=0;c=T(409,b|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break fa}v[113382]=0;t[d+88|0]=c;t[d+48|0]=64;c=Q(415,d+88|0,d+48|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break ea}u[((f<<5)+a|0)+480286>>1]=w[c|0];f=f+1|0;if(f>>>0<x[a+480188>>1]){continue}break da}break}f=P()|0;O()|0;break N}f=P()|0;O()|0;break N}ga:{ha:{if(!(w[d+184|0]|w[d+185|0]<<8|(w[d+186|0]<<16|w[d+187|0]<<24))){break ha}c=w[d+184|0]|w[d+185|0]<<8|(w[d+186|0]<<16|w[d+187|0]<<24);v[113382]=0;c=Q(226,b|0,c<<8&16711680|c<<24|(c>>>8&65280|c>>>24))|0;e=v[113382];v[113382]=0;if((e|0)==1){break ca}if(!c){break ha}f=0;if(!x[a+480188>>1]){break ga}while(1){ia:{v[113382]=0;c=T(753,b|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break ia}na=((f<<5)+a|0)+480284|0,oa=(Yb(c,-16,16)<<3)+128|0,u[na>>1]=oa;f=f+1|0;if(f>>>0<x[a+480188>>1]){continue}break ga}break}f=P()|0;O()|0;break N}v[113382]=0;R(405,a|0,1);c=v[113382];v[113382]=0;if((c|0)==1){break ca}}e=jb-16|0;jb=e;c=d+152|0;v[c>>2]=0;v[c+4>>2]=0;v[113382]=0;v[e+12>>2]=0;W(781,c+8|0,e+12|0,e+8|0)|0;g=v[113382];v[113382]=0;ja:{if((g|0)!=1){jb=e+16|0;break ja}break a}e=w[i|0]|w[i+1|0]<<8|(w[i+2|0]<<16|w[i+3|0]<<24);v[113382]=0;e=Q(226,b|0,e<<8&16711680|e<<24|(e>>>8&65280|e>>>24))|0;g=v[113382];v[113382]=0;ka:{la:{ma:{na:{oa:{pa:{qa:{if((g|0)==1){break qa}ra:{if(!e){break ra}e=w[q|0]|w[q+1|0]<<8;v[113382]=0;e=Q(228,b|0,((e<<8|e>>>8)&65535)<<1)|0;g=v[113382];v[113382]=0;if((g|0)==1){break qa}if(!e){break ra}e=w[q|0]|w[q+1|0]<<8;v[113382]=0;e=W(754,b|0,c|0,(e<<8|e>>>8)&65535)|0;g=v[113382];v[113382]=0;if((g|0)==1){break qa}if(!e){break ra}na=d,oa=ac(c),v[na+144>>2]=oa;na=d,oa=bc(c),v[na+136>>2]=oa;if(Jb(d+144|0,d+136|0)){while(1){e=w[d+182|0]|w[d+183|0]<<8;f=(e<<8|e>>>8)&65535;e=v[d+144>>2];e=w[e|0]|w[e+1|0]<<8;g=(e<<8|e>>>8)&65535;sa:{if(f>>>0<g>>>0){break sa}e=w[d+168|0]|w[d+169|0]<<8|(w[d+170|0]<<16|w[d+171|0]<<24);v[113382]=0;Q(226,b|0,(e<<8&16711680|e<<24|(e>>>8&65280|e>>>24))+(g<<2)|0)|0;e=v[113382];v[113382]=0;ta:{ua:{va:{if((e|0)==1){break va}v[113382]=0;e=T(455,b|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break va}v[113382]=0;e=Q(226,b|0,e|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break va}if(!e){break sa}v[113382]=0;e=Q(228,b|0,42)|0;g=v[113382];v[113382]=0;if((g|0)==1){break va}if(!e){break sa}v[113382]=0;Q(755,b|0,d+88|0)|0;e=v[113382];v[113382]=0;wa:{if((e|0)!=1){if(id(l)){break wa}v[113382]=0;R(756,l|0,65534);e=v[113382];v[113382]=0;if((e|0)!=1){break wa}}f=P()|0;O()|0;break ka}e=w[d+128|0]|w[d+129|0]<<8;v[113382]=0;e=(e<<8|e>>>8)&65535;v[d+84>>2]=e;e=Q(228,b|0,e|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break ua}if(!e){v[113382]=0;e=T(296,b|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break ua}tc(d+84|0,e)}tc(d+84|0,65534);g=oc(l);v[113382]=0;R(757,l|0,g+v[d+84>>2]|0);e=v[113382];v[113382]=0;if((e|0)==1){break la}h=0;if(!v[d+84>>2]){break ta}while(1){xa:{v[113382]=0;e=T(445,b|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break xa}e=e<<16>>16;if((e|0)>=0){v[113382]=0;R(756,l|0,e+j&65535);e=v[113382];v[113382]=0;if((e|0)==1){break xa}}h=h+1|0;if(h>>>0<y[d+84>>2]){continue}break ta}break}f=P()|0;O()|0;break ka}f=P()|0;O()|0;break ka}f=P()|0;O()|0;break ka}if(w[d+88|0]){v[113382]=0;R(758,d- -64|0,d+88|0);e=v[113382];v[113382]=0;ya:{if((e|0)!=1){v[113382]=0;R(759,d+72|0,d- -64|0);e=v[113382];v[113382]=0;if((e|0)!=1){break ya}}f=P()|0;O()|0;break ka}v[113382]=0;U(13,d+48|0,2,d+72|0);e=v[113382];v[113382]=0;if((e|0)==1){break na}v[113382]=0;R(447,l|0,d+48|0);e=v[113382];v[113382]=0;if((e|0)==1){break oa}yb(d+48|0);yb(d+72|0)}if(!(w[d+120|0]|w[d+121|0]<<8|(w[d+122|0]<<16|w[d+123|0]<<24))){break sa}e=w[d+120|0]|w[d+121|0]<<8|(w[d+122|0]<<16|w[d+123|0]<<24);v[113382]=0;e=Q(226,b|0,e<<8&16711680|e<<24|(e>>>8&65280|e>>>24))|0;f=v[113382];v[113382]=0;if((f|0)==1){break la}if(!e){break sa}while(1){za:{v[113382]=0;e=Q(760,b|0,d+72|0)|0;f=v[113382];v[113382]=0;Aa:{Ba:{if((f|0)!=1){if(!e){break sa}e=w[ha|0];v[113382]=0;U(307,d+48|0,b|0,e|0);e=v[113382];v[113382]=0;if((e|0)==1){break Ba}e=w[d+72|0]|w[d+73|0]<<8;v[113382]=0;e=T(761,g+((e<<8|e>>>8)&65535)|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break pa}u[d+64>>1]=e;if((w[d+72|0]|w[d+73|0]<<8)==65535){break za}e=x[d+64>>1];if(oc(l)>>>0>e>>>0){break Aa}Bb(d+48|0);break sa}f=P()|0;O()|0;break ka}f=P()|0;O()|0;break ka}Ca:{if(w[D|0]==1){e=65535}else{if(w[D|0]!=2){break Ca}v[113382]=0;e=T(445,d+48|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break pa}v[113382]=0;f=Q(762,n|0,d- -64|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break pa}u[f>>1]=e;e=65534}na=rc(l,x[d+64>>1]),oa=e,u[na>>1]=oa}Bb(d+48|0);continue}break}Bb(d+48|0)}e=d+144|0;re(e);if(Jb(e,d+136|0)){continue}break}}e=k>>>(m>>>25&1)|0;Kz(c);break V}Kz(c);break U}f=P()|0;O()|0;break ka}f=P()|0;O()|0;Bb(d+48|0);break ka}f=P()|0;O()|0;yb(d+48|0);break ma}f=P()|0;O()|0}yb(d+72|0);break ka}f=P()|0;O()|0}Kz(c);break N}f=P()|0;O()|0;break N}v[113382]=0;R(405,a|0,1);c=v[113382];v[113382]=0;Da:{if((c|0)!=1){f=0;e=32;if(!x[a+480188>>1]){break V}while(1){c=w[(d+f|0)+826|0];v[113382]=0;t[d+168|0]=c;t[d+88|0]=64;c=Q(415,d+168|0,d+88|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break Da}u[((f<<5)+a|0)+480286>>1]=w[c|0];f=f+1|0;if(f>>>0<x[a+480188>>1]){continue}break}break V}f=P()|0;O()|0;break N}f=P()|0;O()|0;break N}f=w[d+823|0];c=w[d+820|0]|w[d+821|0]<<8;$=w[d+823|0]&64;C=w[d+824|0]&32;s=(w[d+824|0]&31)+1|0;na=a,oa=RQ((c<<8|c>>>8)&65535,$>>>6|0,C>>>5|0,s),v[na+480204>>2]=oa;na=a,oa=Ed(w[d+825|0],1,32),v[na+480196>>2]=oa;if(C){v[a+480216>>2]=s;v[a+480220>>2]=s<<2}Ea:{Fa:{if(w[d+842|0]){c=w[d+842|0];v[113382]=0;t[d+168|0]=c;t[d+88|0]=64;c=Q(415,d+168|0,d+88|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break Fa}v[a+480200>>2]=w[c|0]<<2}v[a+480228>>2]=e;v[a+480232>>2]=e;v[a+480208>>2]=v[a+480208>>2]&-3|(w[d+823|0]>>>4^-1)&2;Ga:{Ha:{Ia:{Ja:{Ka:{La:{Ma:{Na:{Oa:{Pa:{Qa:{Ra:{if(!(w[d+524|0]|w[d+525|0]<<8|(w[d+526|0]<<16|w[d+527|0]<<24))){break Ra}c=w[d+524|0]|w[d+525|0]<<8|(w[d+526|0]<<16|w[d+527|0]<<24);v[113382]=0;c=Q(226,b|0,c<<8&16711680|c<<24|(c>>>8&65280|c>>>24))|0;e=v[113382];v[113382]=0;if((e|0)==1){break Qa}if(!c){break Ra}c=w[d+528|0]|w[d+529|0]<<8|(w[d+530|0]<<16|w[d+531|0]<<24);v[113382]=0;W(442,b|0,z|0,c<<8&16711680|c<<24|(c>>>8&65280|c>>>24))|0;c=v[113382];v[113382]=0;if((c|0)==1){break Qa}if(w[N|0]<2){break Ra}v[113382]=0;U(13,d+168|0,2,z|0);c=v[113382];v[113382]=0;if((c|0)==1){break Pa}v[113382]=0;R(447,l|0,d+168|0);c=v[113382];v[113382]=0;if((c|0)==1){break Oa}yb(d+168|0)}c=w[d+496|0]|w[d+497|0]<<8|(w[d+498|0]<<16|w[d+499|0]<<24);Sa:{if((c<<24|c<<8&16711680|(c>>>8&65280|c>>>24))>>>0<2){break Sa}c=w[d+492|0]|w[d+493|0]<<8|(w[d+494|0]<<16|w[d+495|0]<<24);v[113382]=0;c=Q(226,b|0,c<<8&16711680|c<<24|(c>>>8&65280|c>>>24))|0;e=v[113382];v[113382]=0;if((e|0)==1){break Qa}if(!c){break Sa}c=w[d+496|0]|w[d+497|0]<<8|(w[d+498|0]<<16|w[d+499|0]<<24);v[113382]=0;aa(547,A|0,b|0,(c<<8&16711680|c<<24|(c>>>8&65280|c>>>24))-1|0,4)|0;c=v[113382];v[113382]=0;if((c|0)==1){break Qa}}if(!(w[d+536|0]|w[d+537|0]<<8|(w[d+538|0]<<16|w[d+539|0]<<24))){break Ea}c=w[d+536|0]|w[d+537|0]<<8|(w[d+538|0]<<16|w[d+539|0]<<24);v[113382]=0;c=Q(226,b|0,c<<8&16711680|c<<24|(c>>>8&65280|c>>>24))|0;e=v[113382];v[113382]=0;if((e|0)==1){break Qa}if(!c){break Ea}v[113382]=0;c=Q(228,b|0,12)|0;e=v[113382];v[113382]=0;if((e|0)==1){break Qa}if(!c){break Ea}v[113382]=0;Q(304,b|0,6)|0;c=v[113382];v[113382]=0;if((c|0)==1){break Qa}v[113382]=0;c=T(445,b|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break Qa}if((c|0)!=1){break Ea}v[113382]=0;c=T(455,b|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break Ma}if(!c){break Ea}v[113382]=0;e=Q(228,b|0,c|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break Ma}if(e){break Na}break Ea}f=P()|0;O()|0;break N}f=P()|0;O()|0;break N}f=P()|0;O()|0;yb(d+168|0);break N}rd(d+168|0,A);v[113382]=0;aa(547,A|0,b|0,c|0,4)|0;c=v[113382];v[113382]=0;if((c|0)==1){break Ha}if(!Sc(d+168|0)){v[113382]=0;c=W(763,d+48|0,2,13)|0;e=v[113382];v[113382]=0;if((e|0)==1){break La}v[113382]=0;U(764,d+88|0,d+168|0,c|0);e=v[113382];v[113382]=0;if((e|0)==1){break Ka}v[113382]=0;U(765,d+32|0,d+88|0,A|0);e=v[113382];v[113382]=0;if((e|0)==1){break Ja}e=d+32|0;Gb(A,e);yb(e);yb(d+88|0);yb(c)}yb(d+168|0);break Ea}f=P()|0;O()|0;break N}f=P()|0;O()|0;break Ga}f=P()|0;O()|0;break Ia}f=P()|0;O()|0;yb(d+88|0)}yb(c);break Ga}f=P()|0;O()|0}yb(d+168|0);break N}f=P()|0;O()|0;break N}Ta:{if(!(w[d+548|0]|w[d+549|0]<<8|(w[d+550|0]<<16|w[d+551|0]<<24))|o>>>0<2){break Ta}k=0;if(!x[a+480188>>1]){break Ta}while(1){c=w[d+548|0]|w[d+549|0]<<8|(w[d+550|0]<<16|w[d+551|0]<<24);v[113382]=0;c=Q(226,b|0,(c<<8&16711680|c<<24|(c>>>8&65280|c>>>24))+(k<<2)|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break O}Ua:{if(!c){break Ua}v[113382]=0;c=T(455,b|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break O}v[113382]=0;c=Q(226,b|0,c|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break O}e=0;g=0;if(!c){break Ua}while(1){Va:{v[113382]=0;c=Q(228,b|0,8)|0;h=v[113382];v[113382]=0;Wa:{Xa:{Ya:{if((h|0)!=1){if(!c){break Va}v[113382]=0;Q(766,b|0,d+168|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break Ya}if(!(w[d+168|0]|w[d+169|0]<<8|(w[d+170|0]<<16|w[d+171|0]<<24))){break Va}c=(w[d+168|0]|w[d+169|0]<<8|(w[d+170|0]<<16|w[d+171|0]<<24))&-225;switch((c<<24|c<<8&16711680|(c>>>8&65280|c>>>24))-1|0){case 1:break Wa;case 0:break Xa;default:continue}}f=P()|0;O()|0;break N}f=P()|0;O()|0;break N}c=w[i|0]|w[i+1|0]<<8|(w[i+2|0]<<16|w[i+3|0]<<24);e=c<<24|c<<8&16711680|(c>>>8&65280|c>>>24);continue}c=w[i|0]|w[i+1|0]<<8|(w[i+2|0]<<16|w[i+3|0]<<24);g=c<<24|c<<8&16711680|(c>>>8&65280|c>>>24);continue}break}if(!e|!g){break Ua}v[113382]=0;c=Q(226,b|0,e|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break P}if(!c){break Ua}v[113382]=0;W(597,b|0,((k<<5)+a|0)+480289|0,g|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break P}}k=k+1|0;if(k>>>0<x[a+480188>>1]){continue}break}}c=w[d+560|0]|w[d+561|0]<<8;v[113382]=0;o=c<<8|c>>>8;R(363,r|0,o+j&65535);e=v[113382];v[113382]=0;Za:{if((e|0)==1){break Za}_a:{if(c){ia=f&16;ja=j&65535;c=o&65535;ka=c>>>0>1?c:1;g=0;while(1){$a:{if(!da){break $a}c=w[d+888|0]|w[d+889|0]<<8|(w[d+890|0]<<16|w[d+891|0]<<24);v[113382]=0;c=Q(226,b|0,(c<<8&16711680|c<<24|(c>>>8&65280|c>>>24))+(g<<2)|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break _a}if(!c){break $a}v[113382]=0;c=T(455,b|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break _a}v[113382]=0;c=Q(226,b|0,c|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break _a}if(!c){break $a}e=Xb(d+152|0);v[113382]=0;G=T(244,d+88|0)|0;c=v[113382];v[113382]=0;ab:{bb:{if((c|0)!=1){f=w[d+871|0];if(f){break bb}v[113382]=0;Q(767,b|0,d+168|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break R}u[d+64>>1]=w[d+168|0];H=w[ga|0]+1|0;c=48;break ab}f=P()|0;O()|0;break Q}k=t[d+822|0];v[113382]=0;Q(768,b|0,d+72|0)|0;c=v[113382];v[113382]=0;cb:{db:{if((c|0)!=1){c=w[d+72|0]|w[d+73|0]<<8;u[d+64>>1]=c<<8|c>>>8;c=w[D|0]|w[D+1|0]<<8;H=((c<<8|c>>>8)&65535)+1|0;if(!(w[p|0]|w[p+1|0]<<8|(w[p+2|0]<<16|w[p+3|0]<<24))){break cb}h=v[b+8>>2];c=w[p|0]|w[p+1|0]<<8|(w[p+2|0]<<16|w[p+3|0]<<24);v[113382]=0;Q(226,b|0,c<<8&16711680|c<<24|(c>>>8&65280|c>>>24))|0;c=v[113382];v[113382]=0;if((c|0)==1){break R}v[113382]=0;Q(769,b|0,d+168|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break R}c=w[i|0]|w[i+1|0]<<8|(w[i+2|0]<<16|w[i+3|0]<<24);v[113382]=0;c=Q(226,b|0,c<<8&16711680|c<<24|(c>>>8&65280|c>>>24))|0;m=v[113382];v[113382]=0;if((m|0)==1){break R}if(!c){break db}c=w[d+176|0]|w[d+177|0]<<8|(w[d+178|0]<<16|w[d+179|0]<<24);v[113382]=0;W(442,b|0,e|0,c<<8&16711680|c<<24|(c>>>8&65280|c>>>24))|0;c=v[113382];v[113382]=0;if((c|0)!=1){break db}break R}break R}eb:{if(!(w[d+184|0]|w[d+185|0]<<8|(w[d+186|0]<<16|w[d+187|0]<<24))){break eb}c=w[d+184|0]|w[d+185|0]<<8|(w[d+186|0]<<16|w[d+187|0]<<24);v[113382]=0;c=Q(226,b|0,c<<8&16711680|c<<24|(c>>>8&65280|c>>>24))|0;m=v[113382];v[113382]=0;if((m|0)==1){break R}if(!c){break eb}v[113382]=0;c=T(455,b|0)|0;m=v[113382];v[113382]=0;if((m|0)==1){break R}v[113382]=0;c=Q(226,b|0,c|0)|0;m=v[113382];v[113382]=0;if((m|0)==1){break R}if(!c){break eb}v[113382]=0;U(307,d+48|0,b|0,B(x[d+64>>1],H)|0);c=v[113382];v[113382]=0;if((c|0)==1){break R}c=d+48|0;Qd(G,c);Bb(c)}v[113382]=0;Q(226,b|0,h|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break R}}c=k+(f>>>0<3?48:24)|0}v[113382]=0;f=g+ja|0;k=W(364,r|0,f&65535,H|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break R}if(k){ba=Zb(r,f);v[113382]=0;Q(457,ba|0,e|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break R}sg(d- -64|0,x[a+480188>>1]);m=0;while(1){v[113382]=0;f=W(432,ba|0,m|0,0)|0;k=v[113382];v[113382]=0;fb:{gb:{if((k|0)!=1){k=0;if(x[d+64>>1]){break gb}break fb}break R}while(1){hb:{if(!w[d+871|0]){v[113382]=0;R(770,d+168|0,b|0);h=v[113382];v[113382]=0;if((h|0)!=1){h=d+168|0;J=Zc(h);_=Cf(h);h=w[h|0];t[f+1|0]=h>>>3&16|w[J|0]>>>4|h>>>1&32;t[f+3|0]=w[J|0]&15;t[f+5|0]=w[_|0];h=h&63;h=h?h+c|0:0;break hb}break R}v[113382]=0;R(557,d+168|0,b|0);h=v[113382];v[113382]=0;ib:{jb:{if((h|0)!=1){h=d+168|0;J=Zc(h);_=Cf(h);la=Ph(h);v[113382]=0;M=T(409,G|0)|0;ma=v[113382];v[113382]=0;if((ma|0)==1){break R}t[f+4|0]=M;M=w[h|0];h=M&127;if(!h){break jb}h=c+h|0;break ib}break R}h=0;if((M|0)!=128){break ib}t[f|0]=254}t[f+1|0]=w[J|0]&63;t[f+3|0]=w[_|0];t[f+5|0]=w[la|0]}if(h-1>>>0<=119){t[f|0]=h}v[113382]=0;fa(771,f|0,($|0)!=0|0,(C|0)!=0|0,s|0,(ia|0)!=0|0);J=v[113382];v[113382]=0;if((J|0)!=1){E=(h|0)>84&Y|E;f=f+6|0;k=k+1|0;if(x[d+64>>1]<=(k&65535)>>>0){break fb}continue}break}break R}m=m+1|0;if((H|0)!=(m|0)){continue}break}}Bb(G);yb(e)}g=g+1|0;if((ka|0)!=(g|0)){continue}break}}na=d,oa=rn(n),v[na+88>>2]=oa;na=d,oa=Ii(n),v[na+48>>2]=oa;kb:{while(1){v[113382]=0;c=Q(772,d+88|0,d+48|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break S}lb:{mb:{nb:{ob:{pb:{qb:{if(!c){if(!(w[d+480|0]|w[d+481|0]<<8|(w[d+482|0]<<16|w[d+483|0]<<24))){break qb}c=w[d+480|0]|w[d+481|0]<<8|(w[d+482|0]<<16|w[d+483|0]<<24);v[113382]=0;c=Q(226,b|0,c<<8&16711680|c<<24|(c>>>8&65280|c>>>24))|0;e=v[113382];v[113382]=0;if((e|0)==1){break Za}if(!c){break qb}j=j+o|0;break U}v[113382]=0;c=T(773,d+88|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break pb}e=x[c>>1];if(!e){f=0;break ob}v[113382]=0;e=Q(509,l|0,e-1&65535)|0;g=v[113382];v[113382]=0;if((g|0)==1){break lb}f=x[c>>1];if(!e){break ob}v[113382]=0;f=Q(774,l|0,f-1&65535)|0;e=v[113382];v[113382]=0;if((e|0)!=1){break nb}break lb}st(n);break T}f=P()|0;O()|0;break N}if(x[c+2>>1]==((f&65535)+1|0)){break mb}v[113382]=0;f=W(775,r|0,1,0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break lb}if((f|0)==65535){break mb}na=rc(l,x[c>>1]),oa=f,u[na>>1]=oa}e=Zb(r,f);c=x[c+2>>1];v[113382]=0;c=T(776,c|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break kb}v[113382]=0;c=W(459,d+168|0,12,c|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break kb}c=Cn(Me(c,v[Zb(r,f)+12>>2]-1|0));v[113382]=0;Q(460,e|0,c|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break kb}o=(o&65535)>>>0>f>>>0?o:f+1|0}v[113382]=0;T(777,d+88|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){continue}break S}break}f=P()|0;O()|0;break N}f=P()|0;O()|0;break N}f=P()|0;O()|0;break N}f=P()|0;O()|0;break N}st(n);I=I+1|0;if(w[N|0]>(I&255)>>>0){continue}break}}v[113382]=0;R(449,K|0,0);b=v[113382];v[113382]=0;if((b|0)!=1){if(!(E&1)){i=x[a+480192>>1];if(i){f=1;while(1){b=(((f&65535)<<2)+a|0)+900380|0;c=v[b>>2];if(c){Wb(vt(c));i=x[a+480192>>1]}v[b>>2]=0;f=f+1|0;if((f&65535)>>>0<=(i&65535)>>>0){continue}break}}u[a+480192>>1]=0}rb:{sb:{tb:{ub:{vb:{wb:{xb:{if(ca){v[113382]=0;b=Q(2,d+168|0,12403)|0;c=v[113382];v[113382]=0;if((c|0)==1){break xb}v[113382]=0;U(608,a|0,2,b|0);c=v[113382];v[113382]=0;if((c|0)==1){break wb}yb(b)}i=17540;switch(w[d+871|0]){case 3:break sb;case 2:break tb;case 1:break ub;case 0:break vb;default:break rb}}f=P()|0;O()|0;break g}f=P()|0;O()|0;yb(b);break g}i=x[a+480188>>1]>4?13333:13319;break rb}i=13265;break rb}i=13234;break rb}i=13207}v[113382]=0;b=Q(2,d+16|0,13283)|0;c=v[113382];v[113382]=0;yb:{zb:{Ab:{Bb:{Cb:{if((c|0)!=1){v[113382]=0;R(189,d+88|0,b|0);c=v[113382];v[113382]=0;if((c|0)==1){break Cb}v[113382]=0;U(500,d+168|0,d+88|0,d+871|0);c=v[113382];v[113382]=0;if((c|0)==1){break Bb}c=d+168|0;Gb(a+1304436|0,c);yb(c);Ib(d+88|0);yb(b);v[113382]=0;b=Q(2,c|0,8632)|0;c=v[113382];v[113382]=0;if((c|0)==1){break zb}Gb(a+1304448|0,b);yb(b);v[113382]=0;Q(208,a+1304460|0,i|0)|0;b=v[113382];v[113382]=0;f=1;if((b|0)==1){break yb}v[a+1304496>>2]=2;break d}f=P()|0;O()|0;break g}f=P()|0;O()|0;break Ab}f=P()|0;O()|0;Ib(d+88|0)}yb(b);break g}f=P()|0;O()|0;break g}f=P()|0;O()|0;break g}f=P()|0;O()|0;break g}f=P()|0;O()|0;break N}f=P()|0;O()|0;Bb(G)}yb(e);break N}f=P()|0;O()|0;break N}f=P()|0;O()|0}st(n);break g}f=P()|0;O()|0;break g}f=P()|0;O()|0;break g}f=P()|0;O()|0;Bb(p)}OQ(F)}Bb(d+848|0);S(f|0);L()}f=0}OQ(F)}Bb(d+848|0)}jb=d+928|0;return f|0}V(0)|0;O()|0;Ab();L()}function Hs(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,z=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,M=0,N=0,Y=0,_=0,$=0,ba=0,ca=0,da=0,fa=0,ga=0,ha=0,ia=0,ka=0,la=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Ba=0,Ca=0,Da=0;h=jb-176|0;jb=h;j=jb-16|0;jb=j;v[a>>2]=0;v[a+4>>2]=0;v[113382]=0;v[j+12>>2]=0;W(1335,a+8|0,j+12|0,j+8|0)|0;e=v[113382];v[113382]=0;a:{b:{if((e|0)!=1){jb=j+16|0;break b}break a}p=h+144|0;t[p+26|0]=0;u[p+24>>1]=0;v[p+16>>2]=0;v[p+20>>2]=-1;v[p+8>>2]=-1;v[p+12>>2]=-1;v[p>>2]=0;v[p+4>>2]=0;$=v[d+16>>2];ga=w[d+6|0];la=b+484360|0;if(ga>>>0>=Mh(la)>>>0){ga=w[la+16|0]}na=a;F=Di(la,ga);v[113382]=0;r=Q(1295,h+104|0,b|0)|0;a=v[113382];v[113382]=0;c:{if((a|0)!=1){g=v[r+4>>2];v[113382]=0;ca=W(1296,h+72|0,b|0,ga|0)|0;a=v[113382];v[113382]=0;d:{if((a|0)!=1){e:{f:{f=x[d+4>>1];g:{if(f>>>0>=oc(F)>>>0){break g}while(1){v[113382]=0;e=Q(509,F|0,f&65535)|0;a=v[113382];v[113382]=0;if((a|0)==1){break f}if(e){break g}v[d>>2]=0;f=f+1|0;u[d+4>>1]=f;if(oc(F)>>>0>(f&65535)>>>0){continue}break}}a=v[d>>2];v[g+52>>2]=a;v[g+48>>2]=a;v[p+16>>2]=a;u[g+64>>1]=f;u[g+62>>1]=f;u[p+24>>1]=f;Y=h- -64|0;Uf(Y);ra=It(h+56|0);h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{sa=c&7;va=(sa|0)!=7;s:{if(va){break s}v[113382]=0;W(1297,Y|0,1,1)|0;a=v[113382];v[113382]=0;if((a|0)==1){break r}v[113382]=0;W(1297,Y|0,2,1)|0;a=v[113382];v[113382]=0;if((a|0)==1){break r}v[113382]=0;W(1297,Y|0,3,1)|0;a=v[113382];v[113382]=0;if((a|0)==1){break r}v[113382]=0;W(1297,Y|0,28,1)|0;a=v[113382];v[113382]=0;if((a|0)==1){break r}v[113382]=0;W(1297,Y|0,35,1)|0;a=v[113382];v[113382]=0;if((a|0)==1){break r}v[113382]=0;W(1297,Y|0,37,1)|0;a=v[113382];v[113382]=0;if((a|0)==1){break r}v[113382]=0;W(1297,Y|0,36,1)|0;a=v[113382];v[113382]=0;if((a|0)==1){break r}v[113382]=0;W(1297,Y|0,38,1)|0;a=v[113382];v[113382]=0;if((a|0)==1){break r}v[113382]=0;W(1298,ra|0,12,1)|0;a=v[113382];v[113382]=0;if((a|0)==1){break r}v[113382]=0;W(1298,ra|0,13,1)|0;a=v[113382];v[113382]=0;if((a|0)==1){break r}if(($|0)!=2){break s}a=x[d+12>>1];if(oc(F)>>>0<=a>>>0){break s}o=x[rc(F,a)>>1];v[113382]=0;n=b+484344|0;e=Q(398,n|0,o|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break h}if(!e){break s}a=Zb(n,o);j=v[d+8>>2];v[113382]=0;e=Q(1299,a|0,j|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break h}if(!e){break s}e=0;a=Zb(n,o);v[113382]=0;f=W(432,a|0,j|0,0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break i}if(!x[b+480188>>1]){break s}n=r+20|0;while(1){t:{u:{v:{switch(w[f|0]-253|0){case 0:if(x[b+480192>>1]){break u}break;case 1:case 2:break u;default:break v}}v[113382]=0;j=T(516,f|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break j}if(!j){break t}if(Is(f)){break t}}za=Qc(n,e),Ba=-1,v[za+16>>2]=Ba}f=f+6|0;e=e+1|0;if(e>>>0<x[b+480188>>1]){continue}break}}fa=g- -64|0;I=g+48|0;da=g+68|0;xa=g+44|0;ta=r+8|0;ha=c&1;q=r+20|0;D=b+1074312|0;M=b+484344|0;ya=($|0)!=3;wa=($|0)!=2;o=0;while(1){v[g+48>>2]=v[g+52>>2];a=x[g+64>>1];u[g+62>>1]=a;v[113382]=0;e=Q(509,F|0,a|0)|0;a=v[113382];v[113382]=0;w:{if((a|0)!=1){x:{if(!e){break x}if(y[g+48>>2]<y[Zb(M,x[rc(F,x[g+62>>1])>>1])+12>>2]){break x}v[I>>2]=0;Fb(h,D,63);if(Cb(h)){a=v[g+56>>2];v[g+56>>2]=0;v[g+48>>2]=a}a=x[g+64>>1]+1|0;u[g+62>>1]=a;u[g+64>>1]=a}if(!(A[r+32>>3]>=A[d+8>>3])|ya){break w}break l}a=P()|0;O()|0;break e}e=x[g+62>>1];a=g;y:{if(oc(F)>>>0>e>>>0){e=x[rc(F,x[g+62>>1])>>1];break y}e=65535}u[a+60>>1]=e;v[113382]=0;e=Q(398,M|0,e&65535)|0;a=v[113382];v[113382]=0;if((a|0)==1){break n}if(!(x[g+60>>1]==65535|wa|e)&x[g+62>>1]==x[d+12>>1]){break l}z:{if(x[g+60>>1]<Ae(M)>>>0){break z}while(1){a=g;n=a;A:{B:{if(x[a+60>>1]!=65535){e=x[g+62>>1];if(oc(F)>>>0>e>>>0){break B}}if(x[F+28>>1]==x[g+62>>1]){break z}e=x[F+28>>1];break A}e=x[g+62>>1]+1|0}u[n+62>>1]=e;a=g;C:{if(oc(F)>>>0>(e&65535)>>>0){e=x[rc(F,x[g+62>>1])>>1];break C}e=65535}u[a+60>>1]=e;u[g+64>>1]=x[g+62>>1];v[113382]=0;e=Q(398,M|0,e&65535)|0;a=v[113382];v[113382]=0;if((a|0)==1){break m}D:{if(e){break D}a=x[g+62>>1];v[113382]=0;e=aa(1300,ca|0,a|0,0,1)|0;a=v[113382];v[113382]=0;if((a|0)==1){break m}if(!e){break D}if($>>>0<=1){a=x[g+62>>1];v[p+8>>2]=0;u[p+20>>1]=a;if(!$){break z}}v[113382]=0;e=aa(1301,ca|0,fa|0,I|0,1)|0;a=v[113382];v[113382]=0;if((a|0)==1){break n}if(!e){break z}A[p>>3]=A[r+32>>3];v[113382]=0;R(1302,na|0,p|0);a=v[113382];v[113382]=0;if((a|0)==1){break n}v[p+16>>2]=v[I>>2];u[p+24>>1]=x[fa>>1];v[113382]=0;Z(1303,r|0);a=v[113382];v[113382]=0;if((a|0)==1){break n}a=x[g+64>>1];u[g+62>>1]=a;za=g,Ba=x[rc(F,a)>>1],u[za+60>>1]=Ba;v[g+52>>2]=v[g+48>>2];break z}if(x[g+60>>1]>=Ae(M)>>>0){continue}break}}if(x[fa>>1]==65535){break k}a=x[g+60>>1];v[113382]=0;e=Q(398,M|0,a|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break n}if(!e){if(x[F+28>>1]==x[g+62>>1]){if(!$){break k}v[113382]=0;e=aa(1301,ca|0,fa|0,I|0,1)|0;a=v[113382];v[113382]=0;if((a|0)==1){break n}if(!e){break k}A[p>>3]=A[r+32>>3];v[113382]=0;R(1302,na|0,p|0);a=v[113382];v[113382]=0;if((a|0)==1){break n}v[p+16>>2]=v[I>>2];u[p+24>>1]=x[fa>>1];v[113382]=0;Z(1303,r|0);a=v[113382];v[113382]=0;if((a|0)==1){break n}v[g+52>>2]=v[g+48>>2];continue}u[g+64>>1]=x[g+62>>1]+1;continue}if(y[g+48>>2]>=y[Zb(M,x[g+60>>1])+12>>2]){v[I>>2]=0}e=x[g+62>>1];if(!((e|0)!=x[d+12>>1]|wa)&v[I>>2]==v[d+8>>2]){break l}a=v[I>>2];v[113382]=0;e=aa(1300,ca|0,e|0,a|0,1)|0;a=v[113382];v[113382]=0;if((a|0)==1){break n}if(e){if($>>>0<=1){u[p+20>>1]=x[g+62>>1];v[p+8>>2]=v[g+48>>2];if(!$){break k}}v[113382]=0;e=aa(1301,ca|0,fa|0,I|0,1)|0;a=v[113382];v[113382]=0;if((a|0)==1){break n}if(!e){break k}A[p>>3]=A[r+32>>3];v[113382]=0;R(1302,na|0,p|0);a=v[113382];v[113382]=0;if((a|0)==1){break n}v[p+16>>2]=v[I>>2];u[p+24>>1]=x[fa>>1];v[113382]=0;Z(1303,r|0);a=v[113382];v[113382]=0;if((a|0)==1){break n}v[g+52>>2]=v[g+48>>2];continue}u[p+22>>1]=x[g+62>>1];a=v[g+48>>2];v[p+12>>2]=a;v[g+52>>2]=a+1;E:{F:{if(a>>>0>=y[Zb(M,x[g+60>>1])+12>>2]){v[I>>2]=0;break F}if(v[I>>2]){break E}}f=0;if(!x[b+480188>>1]){break E}while(1){H=A[r+32>>3];za=Qc(q,f),Ca=H,A[za>>3]=Ca;a=v[g>>2];za=Qc(q,f),Ba=a,v[za+8>>2]=Ba;f=f+1|0;if(f>>>0<x[b+480188>>1]){continue}break}}e=Zb(M,x[g+60>>1]);a=v[g+48>>2];v[113382]=0;f=W(432,e|0,a|0,0)|0;a=v[113382];v[113382]=0;G:{H:{I:{if((a|0)!=1){e=0;_=0;N=0;if(!x[b+480188>>1]){break H}while(1){J:{Fb(h,D,77);K:{if(za=Cb(h),Ba=0,Da=v[((e<<5)+b|0)+480280>>2]&1024,Da?za:Ba){break K}v[113382]=0;j=T(1304,f|0)|0;a=v[113382];v[113382]=0;L:{M:{N:{if((a|0)==1){break N}if(j){O:{if(!ha){break O}a=w[f+1|0];if(a-251>>>0<5|!a){break O}v[113382]=0;n=T(1305,f|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break N}v[113382]=0;j=T(1306,f|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break J}u[h+48>>1]=j;t[h|0]=w[f+1|0];u[h+2>>1]=x[h+48>>1];v[113382]=0;j=Q(1307,ta|0,h|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break J}u[j>>1]=n}it((B(e,896)+g|0)+1418|0);break K}n=B(e,896)+g|0;j=n+1422|0;a=w[f+4|0]|w[f+5|0]<<8;t[j|0]=a;t[j+1|0]=a>>>8;j=n+1418|0;a=w[f|0]|w[f+1|0]<<8|(w[f+2|0]<<16|w[f+3|0]<<24);t[j|0]=a;t[j+1|0]=a>>>8;t[j+2|0]=a>>>16;t[j+3|0]=a>>>24;P:{switch(w[f+3|0]-16|0){case 0:a=w[f+5|0];v[113382]=0;U(1308,b|0,g|0,a|0);a=v[113382];v[113382]=0;if((a|0)==1){break N}break K;case 3:break L;case 4:break M;case 1:break P;default:break K}}Fb(h,D,5);if(!Cb(h)){break K}a=w[f+5|0];if(!a){break K}v[113382]=0;U(1308,b|0,g|0,a|0);a=v[113382];v[113382]=0;if((a|0)!=1){break K}}a=P()|0;O()|0;break e}j=w[f+5|0];a=j&240;if((a|0)==96){N=(j&15)+N|0;break K}if((a|0)!=224|_){break K}a=w[f+5|0]&15;if(v[b+480180>>2]&2){_=0;if(!a){break K}}_=a+1|0;break K}a=w[f+5|0];if((a&240)!=224){break K}_=(a&15)+1|0}f=f+6|0;e=e+1|0;if(e>>>0<x[b+480188>>1]){continue}break I}break}a=P()|0;O()|0;break e}a=P()|0;O()|0;break e}e=N;if(_){break G}}_=1;N=e}G=B(v[g+40>>2]+N|0,_);e=0;Q:{if(!x[b+480188>>1]){j=0;oa=0;pa=0;ia=0;ka=0;break Q}ba=G-1|0;n=G-_|0;ua=B(n,1e4);ka=0;ia=0;pa=0;oa=0;j=0;R:{while(1){S:{i=0;k=B(e,896)+g|0;l=k+1418|0;T:{if(w[l|0]){break T}a=l;if(w[a+1|0]|w[a+2|0]){break T}i=!w[a+3|0]}U:{if(i){break U}Fb(h,D,77);if(za=Cb(h),Ba=0,Da=v[((e<<5)+b|0)+480280>>2]&1024,Da?za:Ba){break U}f=w[k+1423|0];qa=k+1421|0;s=w[qa|0];J=w[l|0];z=k+1419|0;a=w[z|0];if(a){t[k+1429|0]=0;t[k+1433|0]=a;za=Qc(q,e),Ba=255,t[za+21|0]=Ba}v[113382]=0;i=T(516,l|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break S}if(i){t[k+1429|0]=J}v[113382]=0;i=T(516,l|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break S}E=k+608|0;V:{W:{X:{Y:{Z:{_:{if(!(w[z|0]?1:i)){break _}a=k+1433|0;K=w[a|0];if(x[b+480192>>1]){if(x[b+480192>>1]<K>>>0){break _}i=v[((w[a|0]<<2)+b|0)+900380>>2];if(!i){break _}$:{if(!(t[i+15|0]&1)){break $}a=v[i+8>>2];v[113382]=0;U(1309,E|0,a|0,b|0);a=v[113382];v[113382]=0;if((a|0)!=1){break $}a=P()|0;O()|0;break e}if(!Xd(J)){break _}K=x[_c(i+236|0,J-1|0)>>1]}if(!K|x[b+480190>>1]<K>>>0){break _}a=B(K,104)+b|0;if(!(w[a+484414|0]&32)){break _}a=x[a+484408>>1];v[113382]=0;U(1309,E|0,a|0,b|0);a=v[113382];v[113382]=0;if((a|0)==1){break Z}}aa:{ba:{ca:{z=k+1420|0;a=w[z|0];switch(a-1|0){case 1:break X;case 2:case 3:break ba;case 0:break ca;default:break aa}}a=w[k+1422|0];za=Qc(q,e),Ba=a,t[za+21|0]=Ba;break X}a=w[k+1422|0];if(!a){break X}t[k+1462|0]=a;break X}if((a|0)==11){break Y}break X}a=P()|0;O()|0;break e}if(!w[k+1422|0]){break X}ry(h,b,l,0);a=jc(h);v[k+1384>>2]=v[h>>2];if(!w[a|0]){break X}s=0;break W}da:{switch(s-12|0){case 0:l=v[g+48>>2];a=x[g+60>>1];v[113382]=0;l=ea(1310,b|0,a|0,l|0,e&65535,0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break S}v[g+56>>2]=0;u[g+64>>1]=l;if(!(v[b+480180>>2]&5?0:pa)){v[g+52>>2]=0}ia=1;if(!ha){ka=1;break U}v[k+1412>>2]=0;t[k+1469|0]=0;ka=1;break V;case 2:v[113382]=0;l=aa(1311,b|0,g|0,e&65535,f|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break R}if((l|0)==-1){s=14;break W}v[g+52>>2]=l;if(!ka){u[g+64>>1]=x[g+62>>1]+1}pa=1;if(!ha){break U}v[k+1412>>2]=0;t[k+1469|0]=0;break V;case 5:Fb(h,D,5);s=17;if(Cb(h)){break W}l=v[g+48>>2];a=x[g+60>>1];v[113382]=0;l=ea(1310,b|0,a|0,l|0,e&65535,0)|0;a=v[113382];v[113382]=0;ea:{fa:{if((a|0)!=1){a=B(l,1e4);if(!ha|!(v[b+480180>>2]&16777250)){break ea}if(a>>>0<1e4){break fa}t[k+1463|0]=(a>>>0)/1e4;break ea}a=P()|0;O()|0;break e}a=B(w[k+1463|0],1e4)}l=(a>>>0)/1e4|0;ga:{if(a>>>0>319999){break ga}a=B(ua,l&15);i=v[g+44>>2];if((l&240)==16){a=a+i|0;break ga}a=i-a|0;a=a>>>0>i>>>0?0:a}v[g+44>>2]=a;l=v[v[b+8>>2]+20>>2];a=v[v[b+8>>2]+24>>2];Fb(h,D,8);Vn(xa,B(l,1e4),Cb(h)?255e4:B(a,1e4));break W;case 8:s=20;ha:{switch((f&240)-144>>>4|0){case 0:if(f>>>0>145){break W}v[k+696>>2]=v[k+696>>2]&-257|((f|0)==145)<<8;break W;case 1:t[k+1464|0]=f&15;break W;case 2:i=e;a=e;if(v[b+480180>>2]==2){i=x[b+480188>>1]-1|0;a=0}if(!(f&15)){ia=0;j=1;l=i&65535;if(l>>>0<(a&65535)>>>0){break W}while(1){H=A[r+32>>3];i=a&65535;za=Qc(q,i),Ca=H,A[za>>3]=Ca;j=v[g>>2];za=Qc(q,i),Ba=j,v[za+8>>2]=Ba;j=v[g+48>>2];za=Qc(q,i),Ba=j,v[za+12>>2]=Ba;v[(B(i,896)+g|0)+1412>>2]=v[g+48>>2];j=1;a=a+1|0;if(l>>>0>=(a&65535)>>>0){continue}break}break W}Fb(h,D,16);if(!(Cb(h)|v[b+480180>>2]==2)){ia=0;oa=1;break W}oa=1;ia=0;i=i&65535;if(i>>>0<(a&65535)>>>0){break W}l=v[I>>2]+1|0;while(1){v[(B(a&65535,896)+g|0)+1412>>2]=l;a=a+1|0;if(i>>>0>=(a&65535)>>>0){continue}break};break W;case 6:break ha;default:break W}}t[k+1472|0]=f&15;break W;case 7:s=19;a=f&240;if((a|0)!=240){if((a|0)!=96){break W}if(f&15){za=g,Ba=v[Qc(q,e)+12>>2],v[za+56>>2]=Ba;oa=1;break W}H=A[r+32>>3];za=Qc(q,e),Ca=H,A[za>>3]=Ca;a=v[g>>2];za=Qc(q,e),Ba=a,v[za+8>>2]=Ba;a=v[g+48>>2];za=Qc(q,e),Ba=a,v[za+12>>2]=Ba;v[k+1412>>2]=v[g+48>>2];j=1;break W}t[k+1472|0]=f&15;break W;case 1:case 3:case 4:case 6:break W;default:break da}}if((s|0)!=28){break W}if((f&240)==160){Fb(h,D,58);s=28;if(Cb(h)){break W}t[k+1464|0]=f&15;break W}s=28}if(!ha){break U}ia:{ja:{ka:{la:{ma:{na:{oa:{switch(s-2|0){case 0:if(!f){break V}Fb(h,D,90);if(!Cb(h)){t[k+1440|0]=f}t[k+1439|0]=f;break V;case 1:if(!f){break V}Fb(h,D,90);if(!Cb(h)){t[k+1439|0]=f}t[k+1440|0]=f;break V;case 2:if(!f){break V}v[k+1384>>2]=f;break V;case 8:if(!f){break V}v[k+1272>>2]=f<<8;break V;case 4:case 9:if(!f){break V}t[k+1437|0]=f;break V;case 11:za=Qc(q,e),Ba=f,t[za+21|0]=Ba;break V;case 21:a=f<<(!(v[b+480180>>2]&59593760)&f<<24>>24>=0)&255;if(a>>>0<=128){v[da>>2]=a<<1;break V}if(v[b+480180>>2]&16777250){break V}v[da>>2]=256;break V;case 22:Fb(h,D,9);pa:{if(Cb(h)){a=k+1445|0;if(f){t[a|0]=f;break pa}f=w[a|0];break pa}if(f){t[g+1445|0]=f;break pa}f=w[g+1445|0]}a=da;i=f&240;l=f&15;qa:{if(!(!i|(l|0)!=15)){m=v[da>>2]+(i>>>4<<!(v[b+480180>>2]&59593760)<<1)|0;break qa}m=v[da>>2]-(l<<(v[b+480180>>2]&59593760?1:2))|0;if(!(!l|(i|0)!=240)){break qa}m=v[da>>2]+B(n,(f>>>3&30)<<!(v[b+480180>>2]&59593760))|0;if(i){break qa}m=v[da>>2]-B(n,l<<(v[b+480180>>2]&59593760?1:2))|0}v[a>>2]=m;Yd(da,0,256);break V;case 19:if(f>>>0>64){break V}v[k+1368>>2]=f;break V;case 20:a=k+1444|0;ra:{if(f){t[a|0]=f;break ra}f=w[a|0]}i=k+1368|0;J=v[i>>2];a=f;l=a&240;f=a&15;sa:{if(!(!l|(f|0)!=15)){v[h>>2]=J+(a>>>4|0);break sa}if(!(!f|(l|0)!=240)){v[h>>2]=J-f;break sa}if(f){v[h>>2]=J-B(f,n);break sa}v[h>>2]=J+B(n,a>>>4|0)}Yd(h,0,64);v[i>>2]=v[h>>2];break V;case 7:Al(b,E,f,8);break V;case 25:break ia;case 6:break ja;case 24:break ka;case 3:break la;case 5:break ma;case 18:break na;case 17:break oa;default:break V}}if(!x[b+480188>>1]|f>>>0>15){break na}i=(f&1)<<14;a=0;while(1){l=B(a,896)+g|0;v[l+696>>2]=(i|v[l+696>>2]&-16385)^16384;a=a+1|0;if(a>>>0<x[b+480188>>1]){continue}break}}if((f&240)!=128){break V}Al(b,E,f&15,4);break V}if(f){t[k+1437|0]=f}f=0}qk(E,f);break V}wM(b,E,f);break V}vM(E,f);break V}uM(E,f)}ta:{ua:{switch(w[z|0]-2|0){case 0:Al(b,E,w[k+1422|0],6);break ta;case 5:Fb(h,D,53);a=Cb(h);l=w[k+1422|0];if(a){t[k+1451|0]=l&15;break ta}qk(E,l<<4);break ta;case 6:break ua;default:break ta}}qk(E,w[k+1422|0])}va:{wa:{xa:{ya:{a=w[qa|0];switch(a-5|0){case 3:break wa;case 0:case 2:break xa;case 1:break U;default:break ya}}switch(a-26|0){case 1:break va;case 0:break xa;default:break U}}za:{if(v[b+480180>>2]&16777248){a=G;if(!(w[b+480208|0]&4)){break za}}a=n}z=w[k+1451|0];Fb(h,D,21);i=Cb(h);l=k+1447|0;a=B(a,z);t[l|0]=w[l|0]+(i?a<<2:a);break U}Aa:{if(v[b+480180>>2]&16777248){a=G;if(!(w[b+480208|0]&4)){break Aa}}a=n}z=w[k+1454|0];Fb(h,D,21);i=Cb(h);l=k+1448|0;a=B(a,z);t[l|0]=w[l|0]+(i?a<<2:a);break U}a=k+1449|0;t[a|0]=w[a|0]+B(ba,w[k+1457|0]);v[113382]=0;R(1312,b|0,E|0);a=v[113382];v[113382]=0;if((a|0)==1){break S}}e=e+1|0;if(e>>>0<x[b+480188>>1]){continue}break Q}break}a=P()|0;O()|0;break e}a=P()|0;O()|0;break e}if(v[b+480180>>2]==4&v[g+40>>2]==65535){break k}v[g+32>>2]=v[b+480216>>2];if(tM(Zb(M,x[g+60>>1]))){za=g,Ba=v[Zb(M,x[g+60>>1])+16>>2],v[za+32>>2]=Ba}v[113382]=0;n=Q(1313,b|0,g|0)|0;a=v[113382];v[113382]=0;Ba:{Ca:{if((a|0)!=1){a=B(n,G);A[r+32>>3]=+(a>>>0)/+y[b+24620>>2]+A[r+32>>3];v[g>>2]=a+v[g>>2];if(!(!x[b+480188>>1]|va)){s=0;ua=(o|0)!=0&(o|0)!=(n|0);qa=_-1|0;while(1){Da:{if(v[Qc(q,s)+16>>2]==-1){break Da}K=1;Ea:{Fa:{m=B(s,896)+g|0;E=m+1421|0;switch(w[E|0]-4|0){case 0:case 2:break Ea;default:break Fa}}K=w[m+1420|0]==11}if(w[m+1419|0]){v[m+1268>>2]=0}k=m+1423|0;ba=w[k|0];v[113382]=0;J=m+1418|0;i=T(516,J|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break p}z=m+608|0;e=ba&15;l=0;Ga:{if(!i){break Ga}Ha:{Ia:{Ja:{if(!K){break Ja}if(!w[Qc(q,s)+20|0]){break Ja}a=v[m+1308>>2];v[113382]=0;i=ko(1314,b,z,a,0);l=mb;a=v[113382];v[113382]=0;if((a|0)==1){break Ia}v[m+616>>2]=i;v[m+620>>2]=l}t[m+1432|0]=w[m+1429|0];f=m+1300|0;i=v[f>>2];a=w[m+1433|0];if(!a){break Ha}v[113382]=0;ma(1315,b|0,z|0,a|0,K|0,1,1);a=v[113382];v[113382]=0;if((a|0)!=1){break Ha}break o}a=P()|0;O()|0;break e}a=w[J|0];v[113382]=0;ja(1316,b|0,z|0,a|0,K|0,1,0,65535);a=v[113382];v[113382]=0;if((a|0)==1){break o}ba=ba>>>4|0;za=Qc(q,s),Ba=1,t[za+20|0]=Ba;a=w[E|0];Ka:{if(!((w[k|0]&240)!=208|(a-19&255)>>>0>1)){l=e;if(e>>>0<G>>>0){break Ka}}l=(a|0)==33?G>>>0>ba>>>0?ba:0:0}l=!(v[b+480180>>2]&16777250)|(!l|_>>>0<2)?l:B(v[g+40>>2]+N|0,qa)+l|0;if(!K){za=Qc(q,s),Ba=0,v[za+16>>2]=Ba}a=w[E|0];La:{Ma:{if((a|0)==9){break Ma}Na:{if((a|0)!=19){if((a|0)!=20|(ba|0)!=8){break Na}break Ma}if((ba|0)==8){break Ma}}if(w[m+1420|0]!=2){break La}}v[f>>2]=i}Oa:{Pa:{switch(a-39|0){default:if((a|0)!=10){break Oa}t[h|0]=0;i=v[g+48>>2];a=x[g+60>>1];v[113382]=0;a=ea(1310,b|0,a|0,i|0,s&65535,h|0)|0;i=v[113382];v[113382]=0;if((i|0)!=1){if(!w[h|0]){a=a<<8;if(!a){a=v[m+1272>>2]}a=(w[m+1464|0]<<16)+a|0}v[113382]=0;U(1317,b|0,z|0,a|0);a=v[113382];v[113382]=0;if((a|0)!=1){break Ga}}a=P()|0;O()|0;break e;case 2:i=v[m+684>>2];a=w[k|0];v[113382]=0;i=qma(i,0,a,0);f=mb;a=f>>>8|0;i=qg(711,(f&255)<<24|i>>>8,a);a=v[113382];v[113382]=0;if((a|0)==1){break o}v[113382]=0;U(1317,b|0,z|0,i|0);a=v[113382];v[113382]=0;if((a|0)==1){break o}break Ga;case 1:break Oa;case 0:break Pa}}if(!v[m+712>>2]){break Oa}v[113382]=0;X(1318,r|0,s&65535,o|0,-1);a=v[113382];v[113382]=0;if((a|0)==1){break o}a=w[k|0];v[113382]=0;U(1319,g|0,z|0,a|0);a=v[113382];v[113382]=0;if((a|0)==1){break o}l=v[g+40>>2]-1|0;break Ga}if(w[m+1420|0]!=15){break Ga}a=v[m+712>>2];if(!a){break Ga}i=w[m+1422|0];if(i>>>0>9){break Ga}Qa:{if(!i){a=v[m+1272>>2];break Qa}a=v[(a+(i<<2)|0)- -64>>2];v[m+1272>>2]=a}v[113382]=0;U(1317,b|0,z|0,a|0);a=v[113382];v[113382]=0;if((a|0)!=1){break Ga}a=P()|0;O()|0;break e}Ra:{Sa:{Ta:{Ua:{Va:{Wa:{Xa:{Ya:{Za:{_a:{switch(w[J|0]-253|0){case 0:if(x[b+480192>>1]){break Za}break;case 1:case 2:break Za;default:break _a}}i=w[E|0];if((i-19&255)>>>0<=1){if((w[k|0]&240)!=192){a=j;break Xa}a=j;if(e>>>0<G>>>0){break Za}break Xa}f=i&255;if((f|0)==33&(e|0)!=0&e+l>>>0<G>>>0){break Za}a=j;if((f|0)!=25){break Ya}}i=w[E|0];a=1}if((i&255)==13){break Wa}}if(w[m+1420|0]==1){v[m+1296>>2]=w[m+1422|0]<<2}if((!v[m+712>>2]|a)&1){break Va}e=0;if((i&255)>>>0>42){break Ta}break Ua}v[m+1296>>2]=w[k|0]<<2;i=13;if(!((!v[m+712>>2]|a)&1)){break Ua}}if(!(a&1)){break Sa}break Ra}Fb(h,Y,i&255);e=1;if(Cb(h)){break Ta}e=a;if(w[E|0]!=19){break Ta}i=w[k|0]&240;if((i|0)!=32){e=a;if((i|0)!=16){break Ta}}e=1}a=m+1420|0;if(w[a|0]<16){Pj(h,ra,w[a|0]);if((Cb(h)|e)&1){break Ra}break Sa}if(e&1){break Ra}}if(ua){v[113382]=0;X(1318,r|0,s&65535,o|0,-1);a=v[113382];v[113382]=0;if((a|0)==1){break p}}$a:{ab:{bb:{a=w[E|0];if(a-6>>>0>=2){cb:{switch(a-19|0){case 1:break ab;case 0:break bb;default:break cb}}if((a|0)!=11){break $a}}if(!G|!w[k|0]&v[b+480180>>2]==1){break $a}a=m+1480|0;e=0;while(1){t[a|0]=!e|w[a|0]&254;an(b,z,w[k|0]);e=e+1|0;if((G|0)!=(e|0)){continue}break}break $a}e=w[k|0];if(!(e&15)){if(!(v[b+480180>>2]&1048580)){break $a}e=w[k|0]}a=m+1480|0;t[a|0]=w[a|0]|1;a=e&240;if((a|0)!=176){if((a|0)!=160){break $a}ep(b,z,e&15,0);break $a}dp(b,z,e&15,0);break $a}db:{eb:{fb:{a=w[k|0];switch(a-158|0){case 1:break eb;case 0:break fb;default:break db}}v[113382]=0;X(1318,r|0,s&65535,o|0,-1);a=v[113382];v[113382]=0;if((a|0)==1){break p}v[m+696>>2]=v[m+696>>2]&-129;break $a}v[113382]=0;X(1318,r|0,s&65535,o|0,-1);a=v[113382];v[113382]=0;if((a|0)==1){break p}v[m+696>>2]=v[m+696>>2]|128;if(!v[m+684>>2]|v[z+4>>2]){break $a}v[113382]=0;e=T(516,J|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break p}if(!(w[m+696|0]&2?e:1)){break $a}a=v[m+684>>2]-1|0;e=z;v[e>>2]=-1;v[e+4>>2]=a;break $a}if((a&240)!=112|a>>>0<115){break $a}v[113382]=0;U(1320,z|0,a|0,b|0);a=v[113382];v[113382]=0;if((a|0)==1){break p}}e=m+1480|0;t[e|0]=w[e|0]|1;gb:{hb:{ib:{jb:{a=m+1420|0;switch(w[a|0]-3|0){case 0:case 1:break hb;case 3:break ib;case 2:break jb;default:break gb}}a=w[m+1422|0];Fb(h,D,41);ep(b,z,a,Cb(h));break gb}a=w[m+1422|0];Fb(h,D,41);dp(b,z,a,Cb(h));break gb}f=w[m+1422|0];kb:{if(f){break kb}Fb(h,D,41);f=0;if(!Cb(h)){break kb}f=w[m+1462|0];if(!f){break gb}}if(!G){break gb}a=w[a|0]==3?f<<4:f;f=0;while(1){t[e|0]=!f|w[e|0]&254;an(b,z,a&255);f=f+1|0;if((G|0)!=(f|0)){continue}break}}if(K){e=v[Qc(q,s)+16>>2];a=Qc(q,s);v[a+16>>2]=v[a+16>>2]+G;v[113382]=0;X(1318,r|0,s&65535,n|0,(e+l|0)+1|0);a=v[113382];v[113382]=0;if((a|0)!=1){break Da}a=P()|0;O()|0;break e}a=Qc(q,s);v[a+16>>2]=v[a+16>>2]+(G-l|0);break Da}v[113382]=0;Z(1321,z|0);a=v[113382];v[113382]=0;if((a|0)==1){break p}za=Qc(q,s),Ba=0,v[za+16>>2]=Ba}s=s+1|0;if(s>>>0<x[b+480188>>1]){continue}break}}if(!oa){break Ba}Fb(h,D,68);if(za=Cb(h),Ba=0,Da=ka|pa,Da?za:Ba){break Ba}a=h+48|0;Fb(a,D,49);if(Cb(a)&ka){break Ba}a=h+40|0;Fb(a,D,103);o=n;if(Cb(a)&ia){continue}f=0;o=jb-16|0;jb=o;j=o+8|0;N=jb-16|0;jb=N;v[113382]=0;a=h;T(1338,a+4|0)|0;e=v[113382];v[113382]=0;lb:{if((e|0)!=1){v[113382]=0;v[N+12>>2]=0;W(1339,a+8|0,N+12|0,j|0)|0;e=v[113382];v[113382]=0;if((e|0)!=1){break lb}break a}break a}za=a,Ba=jc(a),v[za>>2]=Ba;jb=N+16|0;jb=o+16|0;e=h;if(!x[b+480188>>1]){break Ca}while(1){mb:{a=B(f,896)+g|0;o=w[a+1423|0];a=w[a+1421|0];nb:{if(!(!((a|0)!=20|o>>>0<177)&o>>>0<192)){if(o>>>0<97|o>>>0>111|(a|0)!=19){break nb}}H=A[Qc(q,f)>>3];v[113382]=0;A[h+48>>3]=H;j=Q(1322,e|0,h+48|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break mb}if(!v[j>>2]){v[113382]=0;j=Q(1322,e|0,h+48|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break mb}v[j>>2]=1}v[113382]=0;j=Q(1322,e|0,h+48|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break mb}a=v[j>>2];v[113382]=0;o=Q(1323,a|0,(o&15)+1|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break mb}v[113382]=0;j=Q(1322,e|0,h+48|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break mb}v[j>>2]=o}f=f+1|0;if(f>>>0<x[b+480188>>1]){continue}break Ca}break}break q}a=P()|0;O()|0;break e}za=h,Ba=rn(e),v[za+40>>2]=Ba;za=h,Ba=Ii(e),v[za+32>>2]=Ba;while(1){v[113382]=0;j=Q(1324,h+40|0,h+32|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break q}if(!j){ob:{if(v[b+480180>>2]!=32){break ob}f=0;if(!x[b+480188>>1]){break ob}while(1){a=B(f,896)+g|0;if(!(w[a+1421|0]!=20|(w[a+1423|0]+79&255)>>>0>14)){H=A[r+32>>3];za=Qc(q,f),Ca=H,A[za>>3]=Ca;a=v[g>>2];za=Qc(q,f),Ba=a,v[za+8>>2]=Ba}f=f+1|0;if(f>>>0<x[b+480188>>1]){continue}break}}kM(e);break Ba}v[113382]=0;j=T(1325,h+40|0)|0;a=v[113382];v[113382]=0;pb:{qb:{if((a|0)!=1){o=zb(j);H=A[r+32>>3];A[r+32>>3]=(H-A[j>>3])*+(v[o>>2]-1|0)+H;f=0;if(x[b+480188>>1]){break qb}break pb}break q}while(1){if(A[Qc(q,f)>>3]!=A[j>>3]){f=f+1|0;if(f>>>0<x[b+480188>>1]){continue}break pb}break}j=v[g>>2];a=Qc(q,f);v[g>>2]=v[g>>2]+B(v[o>>2]-1|0,j-v[a+8>>2]|0);a=h+48|0;Fb(a,D,16);if(!Cb(a)&v[b+480180>>2]!=2){break pb}H=A[r+32>>3];za=Qc(q,f),Ca=H,A[za>>3]=Ca;a=v[g>>2];za=Qc(q,f),Ba=a,v[za+8>>2]=Ba;a=v[g+48>>2];za=Qc(q,f),Ba=a+1|0,v[za+12>>2]=Ba}v[113382]=0;T(1326,h+40|0)|0;a=v[113382];v[113382]=0;if((a|0)!=1){continue}break}break q}o=n;continue}}a=P()|0;O()|0;break e}a=P()|0;O()|0;kM(e);break e}a=P()|0;O()|0;break e}a=P()|0;O()|0;break e}a=P()|0;O()|0;break e}a=P()|0;O()|0;break e}t[p+26|0]=1}rb:{sb:{if(!(!x[b+480188>>1]|(sa|0)!=7)){a=0;while(1){if(v[Qc(q,a)+16>>2]!=-1){v[113382]=0;X(1318,r|0,a&65535,o|0,-1);d=v[113382];v[113382]=0;if((d|0)==1){break sb}}a=a+1|0;if(a>>>0<x[b+480188>>1]){continue}break}}if(w[p+26|0]){u[p+20>>1]=x[g+62>>1];v[p+8>>2]=v[g+48>>2]}A[p>>3]=A[r+32>>3];v[113382]=0;R(1302,na|0,p|0);a=v[113382];v[113382]=0;if((a|0)==1){break rb}tb:{ub:{if(!ha){break ub}vb:{if($?w[p+26|0]:1){a=b+1074376|0;rM(a,g);qy(a);a=0;v[b+1074400>>2]=0;t[b+1074464|0]=1;d=b+1074392|0;v[d>>2]=-2;v[d+4>>2]=0;v[b+1074428>>2]=v[b+1074424>>2];o=b+1304392|0;if(qd(o)){d=v[o>>2];v[113382]=0;Z(1327,d|0);d=v[113382];v[113382]=0;if((d|0)==1){break rb}}wb:{if(x[b+480188>>1]){g=(sa|0)==7;while(1){n=B(a,896)+b|0;d=w[n+1075805|0];if(d){t[n+1075808|0]=d}if(!(g|w[Qc(q,a)+21|0]==255)){d=Qc(q,a);v[113382]=0;t[h|0]=64;e=Q(415,d+21|0,h|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break wb}v[n+1075672>>2]=w[e|0]<<2}xb:{j=n+1075088|0;d=v[j>>2];if(!d|!(w[d+35|0]&2)){break xb}if(!qd(o)){break xb}e=v[o>>2];d=v[j>>2];v[113382]=0;j=e;e=a&65535;U(1328,j|0,e|0,d+68|0);d=v[113382];v[113382]=0;if((d|0)!=1){d=v[o>>2];v[113382]=0;U(1329,d|0,e|0,1);d=v[113382];v[113382]=0;if((d|0)!=1){break xb}}a=P()|0;O()|0;break e}v[n+1075e3>>2]=0;a=a+1|0;if(a>>>0<x[b+480188>>1]){continue}break}}d=nz(h);za=h,Ba=rn(ta),v[za+40>>2]=Ba;za=h,Ba=Ii(ta),v[za+32>>2]=Ba;yb:{while(1){zb:{v[113382]=0;e=Q(1330,h+40|0,h+32|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break zb}if(!e){o=250;a=d;e=a;Ab:{while(1){n=1;if(v[e>>2]){break Ab}e=e+4|0;o=o-32|0;if(o>>>0>31){continue}break}n=(v[a+28>>2]&67108863)!=0}if(!n){break vb}a=0;while(1){e=h+48|0;Fb(e,d,a);Bb:{if(!Cb(e)){break Bb}j=v[(B(a,160)+b|0)+906300>>2];e=v[v[j>>2]+172>>2];v[113382]=0;Z(e|0,j|0);e=v[113382];v[113382]=0;if((e|0)!=1){break Bb}a=P()|0;O()|0;break e}a=a+1|0;if((a|0)!=250){continue}break}break vb}v[113382]=0;g=T(1331,h+40|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break yb}e=w[g|0]-1&255;n=v[(B(e,160)+b|0)+906300>>2];if(n){a=h+48|0;Fb(a,d,e);if(!Cb(a)){v[113382]=0;W(1332,d|0,e|0,1)|0;a=v[113382];v[113382]=0;if((a|0)==1){break tb}a=v[v[n>>2]+168>>2];v[113382]=0;R(a|0,n|0,-1);a=v[113382];v[113382]=0;if((a|0)==1){break tb}}j=x[g+2>>1];e=v[v[n>>2]+44>>2];a=x[g+4>>1];v[113382]=0;Aa(e|0,n|0,j|0,C(C(C(a>>>0)*C(.0010010009864345193))));a=v[113382];v[113382]=0;if((a|0)==1){break tb}}v[113382]=0;T(1333,h+40|0)|0;a=v[113382];v[113382]=0;if((a|0)!=1){continue}}break}a=P()|0;O()|0;break e}a=P()|0;O()|0;break e}a=P()|0;O()|0;break e}if((c|0)==3){break vb}v[b+1074416>>2]=v[b+480196>>2];v[b+1074420>>2]=v[b+480204>>2];v[b+1074444>>2]=v[b+480200>>2]}if(w[la+16|0]==(ga|0)){break ub}v[113382]=0;R(449,la|0,ga|0);a=v[113382];v[113382]=0;if((a|0)==1){break rb}}if(c&9){v[113382]=0;R(1334,b+1304360|0,ca|0);a=v[113382];v[113382]=0;if((a|0)==1){break rb}}cp(ca);qM(r);jb=h+176|0;return}a=P()|0;O()|0;break e}a=P()|0;O()|0;break e}a=P()|0;O()|0;break e}a=P()|0;O()|0;break e}a=P()|0;O()|0;break e}a=P()|0;O()|0;break e}a=P()|0;O()|0}cp(ca);break d}a=P()|0;O()|0}qM(r);break c}a=P()|0;O()|0}Il(na);S(a|0);L()}V(0)|0;O()|0;Ab();L()}function oia(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,z=0,A=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;e=jb-1728|0;jb=e;Ic(b);h=jb-16|0;jb=h;g=h+8|0;i=e+1600|0;LP(g,i);k=Hb(g);f=b;g=mc(f,$b(h,g));if((k|0)==(g|0)){_b(f,Hb(h+8|0))}jb=h+16|0;f=(g|0)==(k|0);if(!f){MP(i)}a:{if(!f){break a}if(!RP(e+1600|0)){break a}if(!Rb(b,dd(256,0))){break a}b:{if(!c){break b}Id(a,1048576);vi(a);d=Ub(e+1584|0,11090);v[113382]=0;R(189,e+1328|0,d|0);f=v[113382];v[113382]=0;c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{if((f|0)!=1){q=e+1608|0;v[e+160>>2]=w[q+1|0];f=w[q|0];v[113382]=0;v[e+24>>2]=f;R(622,e+88|0,e+24|0);f=v[113382];v[113382]=0;if((f|0)==1){break q}v[113382]=0;X(607,e+240|0,e+1328|0,e+160|0,e+88|0);f=v[113382];v[113382]=0;if((f|0)==1){break p}f=e+240|0;Gb(a+1304436|0,f);yb(f);h=e+88|0;yb(h);g=e+1328|0;Ib(g);yb(d);d=Ub(f,10924);Gb(a+1304448|0,d);yb(d);Cg(h,2,e+1610|0);Ec(g,h);v[113382]=0;U(13,f|0,7,g|0);d=v[113382];v[113382]=0;if((d|0)==1){break k}d=e+240|0;Gb(a+1304460|0,d);yb(d);f=e+1328|0;yb(f);v[a+1304496>>2]=7;Zt(f,2,e+1642|0);Ec(d,f);Gb(a+1304400|0,d);yb(d);d=e+1712|0;u[a+480188>>1]=w[d|0]|w[d+1|0]<<8;d=Ed(w[e+1716|0],1,31);v[a+480204>>2]=125e4;v[a+480208>>2]=32792;v[a+480196>>2]=d;A=e+1722|0;u[a+480192>>1]=w[A|0]|w[A+1|0]<<8;C=e+1724|0;u[a+480190>>1]=w[C|0]|w[C+1|0]<<8;d=Ed(w[e+1717|0],1,32);v[a+480216>>2]=d;v[a+480228>>2]=96;v[a+480232>>2]=48;v[a+480220>>2]=d<<2;uu(b,f);E=a+484360|0;n=e+1706|0;fq(Vb(E),f,w[n|0]|w[n+1|0]<<8,65535,65535);d=e+1708|0;Ne(Vb(E),w[d|0]|w[d+1|0]<<8);z=og(b);td(e+1312|0,b,z?274:0);v[113382]=0;d=T(397,b|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break m}v[113382]=0;U(307,e+1296|0,b|0,d|0);d=v[113382];v[113382]=0;if((d|0)==1){break m}D=x[a+480188>>1];if(z){u[a+480188>>1]=D+8}F=c&1;if(!F){break l}d=e+1710|0;d=w[d|0]|w[d+1|0]<<8;v[113382]=0;R(363,a+484344|0,d|0);d=v[113382];v[113382]=0;if((d|0)!=1){break l}break f}g=P()|0;O()|0;break n}g=P()|0;O()|0;break o}g=P()|0;O()|0;yb(e+88|0)}Ib(e+1328|0)}yb(d);break c}g=P()|0;O()|0;break d}p=a+484344|0;r=e+1718|0;k=e+1710|0;if(!(w[k|0]|w[k+1|0]<<8)){break g}f=0;while(1){v[113382]=0;d=T(323,b|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break h}v[113382]=0;v[e+160>>2]=d;d=T(397,b|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break i}v[113382]=0;U(307,e+240|0,b|0,d+1&-2);d=v[113382];v[113382]=0;if((d|0)==1){break i}tc(e+160|0,1024);d=v[e+160>>2];r:{if(!d|!F){break r}v[113382]=0;d=W(364,p|0,f&65535,d|0)|0;h=v[113382];v[113382]=0;s:{if((h|0)!=1){if(!d){break r}i=0;if(t[r|0]&1){h=0;while(1){v[113382]=0;d=Q(228,e+240|0,1)|0;g=v[113382];v[113382]=0;t:{if((g|0)!=1){if(!d){break r}v[113382]=0;d=T(409,e+240|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break j}o=0;if((d|0)!=255){break t}v[113382]=0;o=T(409,e+240|0)|0;d=v[113382];v[113382]=0;if((d|0)!=1){v[113382]=0;d=T(409,e+240|0)|0;g=v[113382];v[113382]=0;if((g|0)!=1){break t}}break j}break j}u:{if(!(d&127)){break u}g=Zb(p,f);v[113382]=0;g=W(432,g|0,h|0,i&65535)|0;j=v[113382];v[113382]=0;if((j|0)==1){break j}t[e+88|0]=0;t[e+89|0]=0;t[e+90|0]=0;t[e+91|0]=0;t[e+91|0]=0;t[e+92|0]=0;t[e+93|0]=0;t[e+94|0]=0;if(d&1){v[113382]=0;j=T(409,e+240|0)|0;l=v[113382];v[113382]=0;if((l|0)==1){break j}t[e+88|0]=j}if(d&2){v[113382]=0;j=T(409,e+240|0)|0;l=v[113382];v[113382]=0;if((l|0)==1){break j}t[e+89|0]=j}if(d&4){v[113382]=0;j=T(409,e+240|0)|0;l=v[113382];v[113382]=0;if((l|0)==1){break j}t[e+90|0]=j}if(d&8){v[113382]=0;j=T(409,e+240|0)|0;l=v[113382];v[113382]=0;if((l|0)==1){break j}t[e+91|0]=j}if(d&16){v[113382]=0;j=T(409,e+240|0)|0;l=v[113382];v[113382]=0;if((l|0)==1){break j}t[e+92|0]=j}if(d&32){v[113382]=0;j=T(409,e+240|0)|0;l=v[113382];v[113382]=0;if((l|0)==1){break j}t[e+93|0]=j}if(d&64){v[113382]=0;d=T(409,e+240|0)|0;j=v[113382];v[113382]=0;if((j|0)==1){break j}t[e+94|0]=d}v[113382]=0;d=Q(858,g|0,e+88|0)|0;j=v[113382];v[113382]=0;if((j|0)==1){break j}v[113382]=0;v[e+24>>2]=o;v[e+224>>2]=v[e+160>>2]+(h^-1);l=Q(297,e+24|0,e+224|0)|0;j=v[113382];v[113382]=0;if((j|0)==1){break j}m=d|m;j=0;d=g;G=v[l>>2];if(!G){break u}while(1){d=B(x[a+480188>>1],6)+d|0;l=w[g|0]|w[g+1|0]<<8|(w[g+2|0]<<16|w[g+3|0]<<24);t[d|0]=l;t[d+1|0]=l>>>8;t[d+2|0]=l>>>16;t[d+3|0]=l>>>24;l=w[g+4|0]|w[g+5|0]<<8;t[d+4|0]=l;t[d+5|0]=l>>>8;j=j+1|0;if((G|0)!=(j|0)){continue}break}}h=(h+o|0)+1|0;d=v[e+160>>2];if(h>>>0>=d>>>0){while(1){i=i+1|0;h=h-d|0;if(d>>>0<=h>>>0){continue}break}}if(D>>>0>(i&65535)>>>0){continue}break}break r}g=0;if(v[e+160>>2]){break s}break r}break j}while(1){d=Zb(p,f);v[113382]=0;h=Q(458,d|0,g|0)|0;d=v[113382];v[113382]=0;v:{w:{if((d|0)!=1){d=0;if(D){break w}break v}break j}while(1){x:{v[113382]=0;Q(859,e+240|0,e+88|0)|0;i=v[113382];v[113382]=0;if((i|0)==1){break x}v[113382]=0;i=Q(858,h+B(d,6)|0,e+88|0)|0;o=v[113382];v[113382]=0;if((o|0)==1){break x}m=i|m;d=d+1|0;if((D|0)!=(d|0)){continue}break v}break}break j}g=g+1|0;if(g>>>0<y[e+160>>2]){continue}break}}Bb(e+240|0);f=f+1|0;if(f>>>0<(w[k|0]|w[k+1|0]<<8)>>>0){continue}break}break g}g=P()|0;O()|0;yb(e+1328|0);break c}g=P()|0;O()|0;Bb(e+240|0);break e}g=P()|0;O()|0;break e}g=P()|0;O()|0;break e}d=e+1714|0;f=w[d+1|0]<<8;if(!((w[d|0]|f)>>>0<=1|(f|w[d|0])>>>0>4999)){y:{if(m&1){f=w[d|0]|w[d+1|0]<<8;d=0;v[113382]=0;h=qg(416,((f>>>1|0)+11025e5>>>0)/(f>>>0)|0,0);f=v[113382];v[113382]=0;if((f|0)==1){break f}break y}s=2646e7/+(B(B(v[a+480216>>2],v[a+480196>>2]),w[d|0]|w[d+1|0]<<8)>>>0);z:{if(s<4294967296&s>=0){h=~~s>>>0;break z}h=0}d=2}v[a+480224>>2]=d;v[a+480204>>2]=h}d=x[a+480188>>1];v[113382]=0;t[e+240|0]=0;l=W(860,e+1280|0,d|0,e+240|0)|0;d=v[113382];v[113382]=0;if((d|0)!=1){h=a+1304412|0;g=a+1304424|0;o=e+240|3;F=0;A:{B:{C:{D:{E:{while(1){v[113382]=0;d=Q(228,e+1296|0,8)|0;f=v[113382];v[113382]=0;F:{if((f|0)!=1){if(d){break F}if(x[a+480188>>1]){d=0;while(1){f=t[uc(l,d)|0];G:{if((f|0)<=(d|0)|(f|0)>=x[a+480188>>1]){break G}g=((f<<5)+a|0)+480288|0;f=w[g|0];if(!f){break G}h=((d<<5)+a|0)+480288|0;i=w[h|0];if(!i){t[h|0]=f;break G}h=(B(i-1&255,160)+a|0)+906300|0;if((Hj(h)|0)!=255){while(1){h=(B(Hj(h),160)+a|0)+906300|0;if((Hj(h)|0)!=255){continue}break}}f=h+28|0;h=w[g|0]-1&255;h=h>>>0<250?h+128|0:0;t[f|0]=h;t[f+1|0]=h>>>8;t[f+2|0]=h>>>16;t[f+3|0]=h>>>24}d=d+1|0;if(d>>>0<x[a+480188>>1]){continue}break}}v[e+232>>2]=0;v[e+236>>2]=0;v[e+224>>2]=0;v[e+228>>2]=0;v[e+216>>2]=0;v[e+220>>2]=0;v[e+208>>2]=0;v[e+212>>2]=0;H:{I:{J:{K:{L:{M:{if(z){v[113382]=0;Q(861,e+1312|0,e+240|0)|0;d=v[113382];v[113382]=0;N:{if((d|0)!=1){h=0;while(1){d=x[a+480192>>1];v[113382]=0;d=Q(862,a|0,d+1&65535)|0;f=v[113382];v[113382]=0;O:{P:{Q:{R:{S:{T:{U:{if((f|0)!=1){f=h<<1;g=f+(e+224|0)|0;u[g>>1]=d;j=f+(e+208|0)|0;f=e+f|0;i=f+242|0;u[j>>1]=w[i|0]|w[i+1|0]<<8;if((d|0)==65535){break P}f=w[f+242|0]|w[f+243|0]<<8;v[113382]=0;d=W(411,a|0,d|0,f+1&65535)|0;f=v[113382];v[113382]=0;if((f|0)==1){break U}if(!d){break O}v[113382]=0;R(470,e+160|0,11658);f=v[113382];v[113382]=0;if((f|0)==1){break T}v[113382]=0;v[e+24>>2]=h+1;U(863,e+88|0,e+160|0,e+24|0);f=v[113382];v[113382]=0;if((f|0)==1){break S}v[113382]=0;Q(335,d+492|0,e+88|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break R}yb(e+88|0);Ib(e+160|0);break O}g=P()|0;O()|0;break A}g=P()|0;O()|0;break A}g=P()|0;O()|0;break A}g=P()|0;O()|0;break Q}g=P()|0;O()|0;yb(e+88|0)}Ib(e+160|0);break A}u[g>>1]=0}h=h+1|0;if((h|0)!=8){continue}break}break N}g=P()|0;O()|0;break A}f=w[e+240|0]|w[e+241|0]<<8;d=0;v[113382]=0;j=Q(361,e+160|0,f|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break H}if(w[e+240|0]|w[e+241|0]<<8){while(1){v[113382]=0;f=T(323,b|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break J}v[113382]=0;U(307,e+88|0,b|0,f<<5);f=v[113382];v[113382]=0;if((f|0)==1){break K}f=e+88|0;Qd(sc(j,d),f);Bb(f);d=d+1|0;if(d>>>0<(w[e+240|0]|w[e+241|0]<<8)>>>0){continue}break}}d=w[k|0]|w[k+1|0]<<8;o=0;v[113382]=0;m=W(864,e+88|0,d|0,24104)|0;d=v[113382];v[113382]=0;if((d|0)==1){break L}if(w[n|0]|w[n+1|0]<<8){while(1){h=e+o|0;V:{if(w[h+258|0]>=(w[e+240|0]|w[e+241|0]<<8)>>>0){break V}if(x[rc(Vb(E),o)>>1]>=(w[k|0]|w[k+1|0]<<8)>>>0){break V}f=x[rc(Vb(E),o)>>1];W:{if(x[rc(m,f)>>1]==65535){d=w[h+258|0];H=rc(m,f),I=d,u[H>>1]=I;break W}if(x[rc(m,f)>>1]==w[h+258|0]){break W}v[113382]=0;d=W(865,p|0,f|0,0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break M}if((d|0)==65535){break W}H=rc(Vb(E),o),I=d,u[H>>1]=I;f=d}v[113382]=0;d=Q(398,p|0,f|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break M}if(!d){break V}z=sc(j,w[h+258|0]);Ic(z);v[113382]=0;d=T(225,z|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break M}if(!v[Zb(p,f)+12>>2]){break V}G=d>>>5|0;i=0;while(1){d=Zb(p,f);h=x[a+480188>>1];v[113382]=0;d=W(432,d|0,i|0,h-8&65535)|0;h=v[113382];v[113382]=0;if((h|0)==1){break M}h=0;while(1){oh(e+24|0);g=x[e+28>>1];t[d+4|0]=g;t[d+5|0]=g>>>8;g=v[e+24>>2];t[d|0]=g;t[d+1|0]=g>>>8;t[d+2|0]=g>>>16;t[d+3|0]=g>>>24;X:{if(i>>>0>=G>>>0){break X}v[113382]=0;Q(866,z|0,e+24|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break M}if(t[e+24|0]>=0){break X}t[d|0]=61;t[d+1|0]=w[(e+224|0)+(h<<1)|0];g=w[e+24|0]&31;t[e+72|0]=g;if(g){We(e+72|0,15);t[d+3|0]=20;t[d+5|0]=w[e+72|0]|208}t[d+2|0]=1;t[d+4|0]=w[e+25|0]+3>>>2}d=d+6|0;h=h+1|0;if((h|0)!=8){continue}break}i=i+1|0;if(i>>>0<y[Zb(p,f)+12>>2]){continue}break}}o=o+1|0;if(o>>>0<(w[n|0]|w[n+1|0]<<8)>>>0){continue}break}}nf(m);cd(j)}if(!(!(w[r|0]&2)|!(w[k|0]|w[k+1|0]<<8))){j=0;d=w[r|0]|w[r+1|0]<<8|(w[r+2|0]<<16|w[r+3|0]<<24);d=(((d&8?x[a+480188>>1]:D)&65535)+((w[q|0]|w[q+1|0]<<8)>>>0>591?F:0)|0)+(d>>>4&1)|0;while(1){h=0;Y:{if(!d){break Y}while(1){Z:{v[113382]=0;f=Q(228,b|0,4)|0;g=v[113382];v[113382]=0;if((g|0)==1){break Z}if(!f){break Y}f=w[q|0]|w[q+1|0]<<8;v[113382]=0;R(867,f|0,b|0);f=v[113382];v[113382]=0;if((f|0)==1){break Z}h=h+1|0;if((d|0)!=(h|0)){continue}break Y}break}g=P()|0;O()|0;break A}j=j+1|0;if(j>>>0<(w[k|0]|w[k+1|0]<<8)>>>0){continue}break}}v[113382]=0;p=Q(361,e+192|0,255)|0;d=v[113382];v[113382]=0;_:{$:{aa:{ba:{ca:{da:{if((d|0)!=1){d=e+88|0;E=d|7;D=d|1;j=d|4;o=d|2;z=d|3;f=0;while(1){d=f;v[113382]=0;Q(868,b|0,e+160|0)|0;f=v[113382];v[113382]=0;ea:{fa:{ga:{ha:{if((f|0)!=1){v[113382]=0;f=T(397,b|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break ha}h=w[q|0]|w[q+1|0]<<8;v[113382]=0;f=(f|0)==32?428:f;h=h>>>0>513?f?f+4|0:f:f;U(307,e+240|0,b|0,h|0);f=v[113382];v[113382]=0;if((f|0)==1){break ga}f=d+1|0;g=e+240|0;k=af(e+24|0,Qd(sc(p,d),g));Bb(g);if(d>>>0>=(w[A|0]|w[A+1|0]<<8)>>>0){break ea}v[113382]=0;d=f&65535;i=W(411,a|0,d|0,d|0)|0;d=v[113382];v[113382]=0;if((d|0)!=1){break fa}g=P()|0;O()|0;break $}g=P()|0;O()|0;break _}g=P()|0;O()|0;break _}g=P()|0;O()|0;break _}if(!i){break ea}v[113382]=0;U(355,e+88|0,2,e+160|0);d=v[113382];v[113382]=0;ia:{ja:{ka:{if((d|0)==1){break ka}v[113382]=0;R(356,e+240|0,e+88|0);d=v[113382];v[113382]=0;if((d|0)==1){break ka}v[113382]=0;Q(335,i+492|0,e+240|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break ja}yb(e+240|0);if(!h){break ea}v[113382]=0;Q(869,k|0,e+240|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break ba}m=0;if((w[q|0]|w[q+1|0]<<8)>>>0<513){break ia}v[113382]=0;m=T(323,k|0)|0;d=v[113382];v[113382]=0;if((d|0)!=1){break ia}g=P()|0;O()|0;break $}g=P()|0;O()|0;break $}g=P()|0;O()|0;yb(e+240|0);break $}g=3;la:{if((w[q|0]|w[q+1|0]<<8)>>>0<514){break la}v[113382]=0;g=T(397,k|0)|0;d=v[113382];v[113382]=0;if((d|0)!=1){break la}g=P()|0;O()|0;break $}v[i>>2]=w[e+342|0]|w[e+343|0]<<8;t[i+16|0]=w[((w[e+344|0]|w[e+345|0]<<8)&3)+24106|0];t[i+17|0]=w[(w[e+345|0]&3)+24106|0];t[i+18|0]=w[((w[e+344|0]|w[e+345|0]<<8)>>>12&3)+24110|0];r=0;ma:{na:{oa:{pa:{while(1){qa:{if(!(g&1)){break qa}v[113382]=0;Q(870,k|0,e+88|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break pa}v[113382]=0;h=Q(340,i|0,w[r+24114|0])|0;d=v[113382];v[113382]=0;if((d|0)==1){break oa}d=h;if((r|0)!=3){n=w[h+12|0]&-17}else{n=w[h+12|0]&-17|w[e+88|0]<<4&16}t[d+12|0]=n;t[h+12|0]=w[h+12|0]&254|t[e+88|0]&1;t[h+12|0]=w[h+12|0]&251|w[e+88|0]<<1&4;t[h+12|0]=w[h+12|0]&253|w[e+88|0]>>>1&2;d=w[D|0];v[113382]=0;t[e+72|0]=d;t[e+56|0]=16;d=Q(415,e+72|0,e+56|0)|0;n=v[113382];v[113382]=0;if((n|0)==1){break na}d=w[d|0];v[113382]=0;R(477,h|0,d|0);d=v[113382];v[113382]=0;if((d|0)==1){break na}d=w[o|0];t[h+15|0]=d;t[h+16|0]=d;t[h+13|0]=w[z|0];t[h+14|0]=w[j|0];d=0;if(!Kb(h)){break qa}while(1){n=(e+88|0)+(d<<2)|0;F=w[n+8|0]|w[n+9|0]<<8;H=Pb(h,d),I=F,u[H>>1]=I;n=Ed(w[n+10|0]|w[n+11|0]<<8,0,64);H=Pb(h,d),I=n,t[H+2|0]=I;d=d+1|0;if(Kb(h)>>>0>d>>>0){continue}break}}g=g>>>1|0;r=r+1|0;if((r|0)!=4){continue}break}if(!(t[i+60|0]&1|w[i+16|0]==3)){v[i>>2]=32767}v[113382]=0;U(871,i|0,127,1);d=v[113382];v[113382]=0;if((d|0)==1){break da}v[113382]=0;U(872,i|0,0,1);d=v[113382];v[113382]=0;if((d|0)==1){break da}if(!m){break ea}v[113382]=0;Q(873,k|0,e+88|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break aa}if(!(m&2)){break ma}d=w[o|0]|w[o+1|0]<<8;v[113382]=0;d=ib(874,a|0,+(d>>>0))|0;h=v[113382];v[113382]=0;if((h|0)==1){break aa}v[113382]=0;U(871,i|0,d|0,1);d=v[113382];v[113382]=0;if((d|0)==1){break aa}d=w[j|0];v[113382]=0;U(872,i|0,d|0,1);d=v[113382];v[113382]=0;if((d|0)!=1){break ma}break aa}g=P()|0;O()|0;break $}g=P()|0;O()|0;break $}g=P()|0;O()|0;break $}t[i+25|0]=w[D|0]==1;if(!(m&4)){break ea}t[i+31|0]=w[E|0]+1;t[i+34|0]=w[e+96|0]+1;if(t[e+96|0]<0){t[i+30|0]=w[e+103|0]+1}if(w[e+100|0]){d=0;g=i+108|0;while(1){h=d+1|0;v[e+72>>2]=h+t[e+100|0];PP(e+72|0);m=v[e+72>>2];H=ec(g,d),I=m,t[H|0]=I;d=h;if(d>>>0<128){continue}break}}v[113382]=0;R(740,i|0,0);d=v[113382];v[113382]=0;if((d|0)==1){break aa}}Bb(k);if((f|0)!=255){continue}break}q=nz(e+88|0);g=e+24|4;r=nz(e+160|0);h=0;ra:{sa:{while(1){v[113382]=0;Q(868,b|0,e+240|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break ra}v[113382]=0;d=T(397,b|0)|0;f=v[113382];v[113382]=0;ta:{ua:{va:{wa:{xa:{ya:{za:{Aa:{if((f|0)!=1){v[113382]=0;U(307,e+72|0,b|0,d|0);f=v[113382];v[113382]=0;if((f|0)==1){break Aa}if((w[C|0]|w[C+1|0]<<8)>>>0>h>>>0){v[113382]=0;U(355,e+56|0,2,e+240|0);f=v[113382];v[113382]=0;if((f|0)==1){break ta}v[113382]=0;R(356,e+24|0,e+56|0);f=v[113382];v[113382]=0;if((f|0)==1){break ta}v[113382]=0;Q(335,((h<<5)+a|0)+946336|0,e+24|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break za}yb(e+24|0)}if(!d|(w[C|0]|w[C+1|0]<<8)>>>0<=h>>>0){break ua}v[113382]=0;d=B(h+1|0,104)+a|0;f=d+484380|0;R(453,f|0,32);i=v[113382];v[113382]=0;if((i|0)==1){break ya}v[113382]=0;Q(875,e+72|0,e+24|0)|0;i=v[113382];v[113382]=0;if((i|0)==1){break xa}v[f>>2]=w[e+24|0]|w[e+25|0]<<8|(w[e+26|0]<<16|w[e+27|0]<<24);v[d+484404>>2]=w[g|0]|w[g+1|0]<<8|(w[g+2|0]<<16|w[g+3|0]<<24);if(w[e+32|0]>=2){i=d+484414|0;u[i>>1]=x[i>>1]|1;v[f>>2]=v[f>>2]>>>1}if(w[e+33|0]>=2){i=d+484414|0;u[i>>1]=x[i>>1]|64;v[f>>2]=v[f>>2]>>>1}m=2;Ba:{if(w[e+35|0]!=1){m=6;if(w[e+35|0]!=2){break Ba}}f=d+484414|0;u[f>>1]=x[f>>1]|m}v[d+484384>>2]=w[e+36|0]|w[e+37|0]<<8|(w[e+38|0]<<16|w[e+39|0]<<24);v[d+484388>>2]=w[e+40|0]|w[e+41|0]<<8|(w[e+42|0]<<16|w[e+43|0]<<24);u[d+484410>>1]=(w[e+44|0]|w[e+45|0]<<8)>>>7;if(w[e+46|0]!=128){break wa}f=d+484414|0;i=x[f>>1]|256;u[f>>1]=i;break va}g=P()|0;O()|0;break _}g=P()|0;O()|0;break _}g=P()|0;O()|0;yb(e+24|0);break sa}g=P()|0;O()|0;break sa}g=P()|0;O()|0;break sa}u[d+484408>>1]=t[e+46|0]+128;i=x[d+484414>>1]}f=d+484414|0;u[f>>1]=i|32;t[d+484416|0]=w[e+47|0];if(w[e+34|0]&2){d=e+56|0;Fb(d,r,h);ce(d,1)}if(w[e+34|0]&5){u[f>>1]=x[f>>1]|16384}if(!(w[e+34|0]&8)){break ua}d=e+56|0;Fb(d,q,h);ce(d,1);d=0;while(1){f=d<<1;Ca:{if(x[f+(e+208|0)>>1]!=(h|0)){break Ca}f=v[((x[f+(e+224|0)>>1]<<2)+a|0)+900380>>2];if(!f){break Ca}t[f+14|0]=0}d=d+1|0;if((d|0)!=8){continue}break}}Bb(e+72|0);h=h+1|0;if((h|0)==256){break ca}continue}break}g=P()|0;O()|0}Bb(e+72|0);break _}g=P()|0;O()|0;break _}g=P()|0;O()|0;break A}g=P()|0;O()|0;break $}Da:{if(!(w[A|0]|w[A+1|0]<<8)){break Da}g=0;Ea:{Fa:{while(1){Ga:{d=sc(p,g);v[113382]=0;d=T(225,d|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break Ga}Ha:{if(!d){g=g+1|0;break Ha}d=sc(p,g);Ic(d);v[113382]=0;Q(869,d|0,e+240|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break Fa}d=jb-16|0;jb=d;f=e+24|0;v[f>>2]=0;v[f+4>>2]=0;v[113382]=0;v[d+12>>2]=0;W(884,f+8|0,d+12|0,d+8|0)|0;h=v[113382];v[113382]=0;Ia:{if((h|0)!=1){jb=d+16|0;break Ia}V(0)|0;O()|0;Ab();L()}d=w[e+240|0]|w[e+241|0]<<8;v[113382]=0;W(876,b|0,f|0,d|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break Ea}g=g+1|0;h=v[((g<<2)+a|0)+900380>>2];if(!(!h|w[h+34|0])){v[h+4>>2]=32;v[113382]=0;R(740,h|0,0);d=v[113382];v[113382]=0;if((d|0)==1){break Ea}o=h+108|0;C=h+236|0;d=0;while(1){i=d+e|0;Ja:{if(w[i+242|0]>=(w[e+240|0]|w[e+241|0]<<8)>>>0){break Ja}m=Vk(f,w[i+242|0]);i=w[m|0];k=i+1|0;n=d+12|0;H=_c(C,n),I=k,u[H>>1]=I;if(i>>>0>=x[a+480190>>1]){break Ja}i=B(k,104)+a|0;t[i+484418|0]=w[e+338|0]&3;t[i+484419|0]=w[e+339|0];t[i+484420|0]=w[e+340|0];t[i+484421|0]=w[e+341|0];u[i+484412>>1]=w[m+1|0]<<1;t[i+484417|0]=w[m+2|0];i=e+72|0;k=k-1|0;Fb(i,q,k);if(Cb(i)){t[h+14|0]=0}i=e+72|0;Fb(i,r,k);if(!Cb(i)){break Ja}H=ec(o,n),I=61,t[H|0]=I}d=d+1|0;if((d|0)!=96){continue}break}}OP(f)}if((w[A|0]|w[A+1|0]<<8)>>>0>g>>>0){continue}break Da}break}g=P()|0;O()|0;break _}g=P()|0;O()|0;break _}g=P()|0;O()|0;OP(f);break _}Ka:{La:{Ma:{Na:{Oa:{Pa:{Qa:{Ra:{Sa:{Ta:{Ua:{Va:{if(!(!(c&2)|!x[a+480190>>1])){h=0;while(1){h=h+1|0;d=B(h,104)+a|0;c=d+484416|0;f=t[c|0];g=d+484417|0;i=t[g|0];v[113382]=0;k=d+484380|0;ra(877,k|0,+((+(i|0)*.0078125-+(f-49|0))*.08333333333333333));f=v[113382];v[113382]=0;if((f|0)==1){break Ka}t[g|0]=0;t[c|0]=0;c=x[d+484414>>1];Wa:{if(!(c&16384)){c=Yc(e+240|0,c&1?16:8,c&64?3:1,0,12);v[113382]=0;W(362,c|0,k|0,b|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){break Wa}g=P()|0;O()|0;break _}v[113382]=0;f=T(397,b|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break Va}v[113382]=0;Q(304,b|0,12)|0;c=v[113382];v[113382]=0;if((c|0)==1){break Va}c=Xb(e+240|0);v[113382]=0;W(442,b|0,c|0,f|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break Ua}v[113382]=0;Q(336,d+484423|0,c|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break Ua}v[113382]=0;d=Q(2,e+8|0,12450)|0;f=v[113382];v[113382]=0;if((f|0)==1){break Ta}v[113382]=0;R(189,e+72|0,d|0);f=v[113382];v[113382]=0;if((f|0)==1){break Sa}v[e+4>>2]=h;f=_z(a);v[113382]=0;U(13,e+56|0,f|0,c|0);f=v[113382];v[113382]=0;if((f|0)==1){break Ra}v[113382]=0;X(607,e+24|0,e+72|0,e+4|0,e+56|0);f=v[113382];v[113382]=0;if((f|0)==1){break Qa}v[113382]=0;U(608,a|0,2,e+24|0);f=v[113382];v[113382]=0;if((f|0)==1){break Pa}yb(e+24|0);yb(e+56|0);Ib(e+72|0);yb(d);yb(c)}if(x[a+480190>>1]>h>>>0){continue}break}}cd(p);sq(l);Bb(e+1296|0);Bb(e+1312|0);break b}g=P()|0;O()|0;break _}g=P()|0;O()|0;break La}g=P()|0;O()|0;break La}g=P()|0;O()|0;break Ma}g=P()|0;O()|0;break Na}g=P()|0;O()|0;break Oa}g=P()|0;O()|0;yb(e+24|0)}yb(e+56|0)}Ib(e+72|0)}yb(d)}yb(c);break _}g=P()|0;O()|0;break _}g=P()|0;O()|0;break $}g=P()|0;O()|0}Bb(k)}cd(p);break A}g=P()|0;O()|0;nf(m);break I}g=P()|0;O()|0;break I}g=P()|0;O()|0;break I}g=P()|0;O()|0}cd(j);break A}g=P()|0;O()|0;break A}g=P()|0;O()|0;break A}v[113382]=0;f=T(397,e+1296|0)|0;i=v[113382];v[113382]=0;d=a;Xa:{Ya:{Za:{_a:{$a:{ab:{bb:{cb:{db:{eb:{fb:{gb:{hb:{ib:{jb:{if((i|0)!=1){v[113382]=0;i=T(397,e+1296|0)|0;j=v[113382];v[113382]=0;if((j|0)==1){break jb}v[113382]=0;U(307,e+88|0,e+1296|0,i|0);i=v[113382];v[113382]=0;if((i|0)==1){break jb}if((f|0)<=844387157){if((f|0)==4674381){break $a}if((f|0)==5068115){break _a}if(m&1|(f|0)!=726487106){break Ya}v[a+480224>>2]=2;v[113382]=0;s=+la(878,e+88|0);f=v[113382];v[113382]=0;if((f|0)==1){break Xa}if(s<=1e-8){break Ya}s=2646e7/(s*+(B(v[a+480216>>2],v[a+480196>>2])>>>0));if(!(s<4294967296&s>=0)){break ib}f=~~s>>>0;break hb}if((f|0)<=1314144591){if((f|0)==844387158){break Za}if((f|0)!=1280004692){break Ya}i=0;if(!x[a+480188>>1]){break Ya}while(1){v[113382]=0;d=Q(228,e+88|0,1)|0;f=v[113382];v[113382]=0;if((f|0)==1){break D}if(!d){break Ya}d=Xb(e+240|0);v[113382]=0;W(559,e+88|0,d|0,-1)|0;f=v[113382];v[113382]=0;if((f|0)==1){break fb}f=Tb(d);j=Db(d);v[113382]=0;X(428,e+24|0,3,f|0,j|0);f=v[113382];v[113382]=0;if((f|0)==1){break eb}v[113382]=0;R(356,e+160|0,e+24|0);f=v[113382];v[113382]=0;if((f|0)==1){break eb}v[113382]=0;Q(344,((i<<5)+a|0)+480289|0,e+160|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break db}yb(e+160|0);yb(d);i=i+1|0;if(i>>>0<x[a+480188>>1]){continue}break}break Ya}if((f|0)==1397445204){break gb}if((f|0)!=1314144592){break Ya}d=0;if(!(w[k|0]|w[k+1|0]<<8)){break Ya}while(1){v[113382]=0;f=Q(228,e+88|0,1)|0;i=v[113382];v[113382]=0;if((i|0)==1){break bb}if(!f){break Ya}v[113382]=0;f=Q(879,p|0,d&65535)|0;i=v[113382];v[113382]=0;if((i|0)==1){break bb}if(!f){break Ya}f=Xb(e+240|0);v[113382]=0;W(559,e+88|0,f|0,-1)|0;i=v[113382];v[113382]=0;if((i|0)==1){break ab}i=Zb(p,d);v[113382]=0;Q(457,i|0,f|0)|0;i=v[113382];v[113382]=0;if((i|0)==1){break ab}yb(f);d=d+1|0;if(d>>>0<(w[k|0]|w[k+1|0]<<8)>>>0){continue}break}break Ya}g=P()|0;O()|0;break A}g=P()|0;O()|0;break A}f=0}v[d+480204>>2]=f;break Ya}v[113382]=0;d=T(323,e+88|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break C}d=d>>>0<256?48:d>>>8|0;v[a+480228>>2]=d;v[a+480232>>2]=d>>>1;d=0;if(!x[a+480188>>1]){break Ya}while(1){v[113382]=0;f=Q(880,e+88|0,e+240|0)|0;i=v[113382];v[113382]=0;if((i|0)==1){break E}if(f){u[((d<<5)+a|0)+480286>>1]=(w[e+240|0]|w[e+241|0]<<8)>>>10;f=w[o|0];H=uc(l,d),I=f,t[H|0]=I}d=d+1|0;if(d>>>0<x[a+480188>>1]){continue}break}break Ya}g=P()|0;O()|0;break cb}g=P()|0;O()|0;break cb}g=P()|0;O()|0;yb(e+160|0)}yb(d);break B}g=P()|0;O()|0;break B}g=P()|0;O()|0;yb(f);break B}v[113382]=0;Q(304,e+88|0,1)|0;d=v[113382];v[113382]=0;if((d|0)==1){break C}v[113382]=0;d=T(296,e+88|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break C}v[113382]=0;aa(547,g|0,e+88|0,d|0,2)|0;d=v[113382];v[113382]=0;if((d|0)!=1){break Ya}break C}v[113382]=0;Q(881,e+88|0,e+24|0)|0;d=v[113382];v[113382]=0;kb:{if((d|0)!=1){d=Xb(e+240|0);v[113382]=0;W(559,e+88|0,d|0,-1)|0;f=v[113382];v[113382]=0;if((f|0)==1){break kb}if(Jt(d,8568)){v[113382]=0;U(13,e+160|0,7,d|0);f=v[113382];v[113382]=0;if((f|0)==1){break kb}f=e+160|0;Gb(h,f);yb(f)}yb(d);break Ya}g=P()|0;O()|0;break B}g=P()|0;O()|0;yb(d);break B}v[113382]=0;F=T(397,e+88|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break C}}Bb(e+88|0);continue}break}g=P()|0;O()|0;break B}g=P()|0;O()|0;break B}g=P()|0;O()|0;break B}g=P()|0;O()|0}Bb(e+88|0)}sq(l);break e}g=P()|0;O()|0;break e}g=P()|0;O()|0}Bb(e+1296|0)}Bb(e+1312|0)}S(g|0);L()}d=1}jb=e+1728|0;return d|0}function _0(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=C(0),p=0,q=0,r=0,s=C(0),A=0,D=C(0),E=0,F=0,G=0,H=0,I=0,J=C(0),K=C(0),M=0,N=0,O=0,P=0,Q=C(0),R=C(0),S=0,T=0,U=0,V=0,W=0,X=C(0),Y=C(0),Z=0,_=0,$=0,aa=C(0),ba=C(0),ca=0,da=C(0),ea=0,fa=0,ga=0,ha=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0;ea=jb-16|0;jb=ea;a:{if(v[a+1420>>2]>=0){v[f>>2]=0;e=b;f=0;b=0;d=a;b:{c:{d:{g=v[a+1420>>2];if((g|0)<=0){break d}while(1){v[(d+B(f,20)|0)+1436>>2]=0;f=f+1|0;if((g|0)!=(f|0)){continue}break}if((g|0)<=3){break d}b=c;break c}if((c|0)<4){break b}a=c-3|0;e:{while(1){f:{h=b+e|0;if(w[h|0]!=79|(w[h|0]|w[h+1|0]<<8|(w[h+2|0]<<16|w[h+3|0]<<24))!=(w[79712]|w[79713]<<8|(w[79714]<<16|w[79715]<<24))){break f}n=b+26|0;if((n|0)>=(a|0)){break e}p=b+27|0;j=e+n|0;c=w[j|0];if((a|0)<=(p+c|0)){break e}i=c+27|0;f=0;if(c){while(1){i=w[e+(f+p|0)|0]+i|0;f=f+1|0;if((c|0)!=(f|0)){continue}break}}f=0;c=0;while(1){p=22;f=Fw(f,w[e+(b+c|0)|0]);c=c+1|0;if((c|0)!=22){continue}break}while(1){f=Fw(f,0);p=p+1|0;if((p|0)!=26){continue}break}v[d+1420>>2]=g+1;c=d+B(g,20)|0;v[c+1432>>2]=f;v[c+1428>>2]=i-26;v[c+1424>>2]=w[h+22|0]|w[h+23|0]<<8|(w[h+24|0]<<16|w[h+25|0]<<24);f=w[e+(n+w[j|0]|0)|0]==255?-1:w[h+6|0]|w[h+7|0]<<8|(w[h+8|0]<<16|w[h+9|0]<<24);v[c+1436>>2]=n;v[c+1440>>2]=f;g=v[d+1420>>2];if((g|0)!=4){break f}b=a;g=4;break c}b=b+1|0;if((a|0)!=(b|0)){continue}break}b=a}if((g|0)<=0){break b}}a=0;while(1){h=d+B(a,20)|0;j=h+1432|0;c=v[j>>2];f=0;n=v[h+1436>>2];i=b-n|0;l=h+1428|0;p=v[l>>2];i=(i|0)<(p|0)?i:p;if((i|0)>0){while(1){c=Fw(c,w[e+(f+n|0)|0]);k=f+1|0;f=k;if((i|0)!=(k|0)){continue}break}}f=p-i|0;v[l>>2]=f;v[j>>2]=c;g:{if(!f){f=c;c=h+1424|0;if((f|0)==v[c>>2]){v[d+1380>>2]=-1;v[d+992>>2]=0;v[d+1420>>2]=-1;a=v[(d+B(a,20)|0)+1440>>2];v[d+1060>>2]=a;v[d+1064>>2]=(a|0)!=-1;b=i+n|0;break b}f=g-1|0;v[d+1420>>2]=f;f=d+B(f,20)|0;v[c+16>>2]=v[f+1440>>2];g=f+1432|0;h=v[g+4>>2];v[c+8>>2]=v[g>>2];v[c+12>>2]=h;f=f+1424|0;g=v[f+4>>2];v[c>>2]=v[f>>2];v[c+4>>2]=g;g=v[d+1420>>2];break g}a=a+1|0}if((a|0)<(g|0)){continue}break}}break a}v[a+100>>2]=0;v[a+32>>2]=b;v[a+40>>2]=b+c;if(!HG(a)){v[f>>2]=0;b=0;break a}ha=jb-16|0;jb=ha;h=ea+4|0;p=h;n=a;c=n;v[c+1504>>2]=0;v[c+1508>>2]=0;h:{if(v[c+96>>2]){break h}g=c;i:{j:{k:{if(v[c+1380>>2]!=-1){break k}l=xe(g);if(v[g+96>>2]){break i}if((l|0)!=79){break j}if((xe(g)|0)!=103){break j}if((xe(g)|0)!=103){break j}if((xe(g)|0)!=83){break j}if(!CG(g)){break i}if(!(t[g+1375|0]&1)){break k}t[g+1376|0]=0;v[g+1384>>2]=0;cc(g,32);break i}j=Cw(g);break i}cc(g,30)}if(!j){break h}if(ic(c,1)){cc(c,35);break h}j=ha;l:{m:{if(!(v[c+84>>2]!=v[c+92>>2]?v[c+80>>2]:0)){g=ic(c,nl(v[c+408>>2]-1|0));if((g|0)==-1|(g|0)>=v[c+408>>2]){break h}v[ha+12>>2]=g;l=c+B(g,6)|0;if(!w[l+412|0]){i=v[c+112>>2];g=i>>1;break m}i=v[c+116>>2];g=i>>1;k=ic(c,1);I=ic(c,1);if(k|!w[l+412|0]){break m}v[p>>2]=i-v[c+112>>2]>>2;k=v[c+112>>2]+i>>2;break l}ia(2707,9203,3152,6814);L()}v[p>>2]=0;k=g}v[j+8>>2]=k;n:{if(!(!w[l+412|0]|I)){g=B(i,3);v[ea+8>>2]=g-v[c+112>>2]>>2;i=g+v[c+112>>2]>>2;break n}v[ea+8>>2]=g}v[ha+4>>2]=i;i=1}if(i){o:{$=v[h>>2];oa=v[ea+8>>2];na=v[ha+4>>2];qa=h;p=0;S=jb-2368|0;jb=S;q=v[n+404>>2];pa=n+B(v[ha+12>>2],6)|0;E=w[pa+413|0];W=q+B(E,40)|0;fa=W;Z=v[(n+(w[pa+412|0]<<2)|0)+104>>2];p:{i=v[n+4>>2];q:{if((i|0)>0){while(1){c=w[(v[fa+4>>2]+B(p,3)|0)+2|0];P=(S+1344|0)+(p<<2)|0;v[P>>2]=0;g=w[(c+W|0)+9|0];if(!x[(n+(g<<1)|0)+132>>1]){cc(n,21);c=0;break q}h=v[n+260>>2];r:{s:{if(ic(n,1)){c=2;l=v[(n+(p<<2)|0)+996>>2];j=h+B(g,1596)|0;F=v[(w[j+1588|0]<<2)+47516>>2];g=nl(F)-1|0;za=l,Aa=ic(n,g),u[za>>1]=Aa;za=l,Aa=ic(n,g),u[za+2>>1]=Aa;i=0;if(w[j|0]){while(1){O=w[(i+j|0)+1|0];h=O+j|0;k=w[h+33|0];g=0;r=w[h+49|0];t:{if(!r){break t}h=v[n+124>>2]+B(w[h+65|0],2096)|0;if(v[n+1396>>2]<=9){ek(n)}m=v[n+1392>>2];g=u[(h+((m&1023)<<1)|0)+36>>1];u:{if((g|0)>=0){A=m;m=w[g+v[h+8>>2]|0];v[n+1392>>2]=A>>>m;T=v[n+1396>>2]-m|0;m=(T|0)<0;v[n+1396>>2]=m?0:T;g=m?-1:g;break u}g=ml(n,h)}if(!w[h+23|0]){break t}g=v[v[h+2088>>2]+(g<<2)>>2]}if(k){M=-1<<r^-1;h=c+k|0;while(1){m=0;k=u[((j+(O<<4)|0)+((g&M)<<1)|0)+82>>1];v:{if((k|0)<0){break v}k=v[n+124>>2]+B(k&65535,2096)|0;if(v[n+1396>>2]<=9){ek(n)}T=v[n+1392>>2];m=u[(k+((T&1023)<<1)|0)+36>>1];w:{if((m|0)>=0){A=T;T=w[m+v[k+8>>2]|0];v[n+1392>>2]=A>>>T;I=v[n+1396>>2]-T|0;T=(I|0)<0;v[n+1396>>2]=T?0:I;m=T?-1:m;break w}m=ml(n,k)}if(!w[k+23|0]){break v}m=v[v[k+2088>>2]+(m<<2)>>2]}g=g>>r;u[l+(c<<1)>>1]=m;c=c+1|0;if((h|0)!=(c|0)){continue}break}c=h}i=i+1|0;if(i>>>0<w[j|0]){continue}break}}if(v[n+1396>>2]!=-1){break s}}v[P>>2]=1;break r}u[S+320>>1]=257;h=j+1592|0;c=v[j+1592>>2];if((c|0)>=3){g=2;while(1){c=j+338|0;i=g<<1;m=i+j|0;T=w[m+1088|0];r=T<<1;k=x[c+r>>1];P=w[m+1089|0];O=P<<1;M=u[l+r>>1];m=u[O+l>>1]-M|0;r=m>>31;c=(B(x[c+i>>1]-k|0,r^m+r)|0)/(x[c+O>>1]-k|0)|0;m=M+((m|0)<0?0-c|0:c)|0;r=i+l|0;i=x[r>>1];x:{y:{if(i){c=S+320|0;t[c+P|0]=1;t[c+T|0]=1;t[c+g|0]=1;c=i<<16>>16;k=F-m|0;if((c|0)>=((k|0)<(m|0)?k:m)<<1){if((k|0)>(m|0)){break x}m=F+(i^-1)|0;break y}if(c&1){m=m-(c+1>>>1|0)|0;break y}m=(c>>1)+m|0;break y}t[(S+320|0)+g|0]=0}u[r>>1]=m}c=v[h>>2];g=g+1|0;if((c|0)>(g|0)){continue}break}}m=0;if((c|0)<=0){break r}while(1){if(!w[(S+320|0)+m|0]){u[l+(m<<1)>>1]=65535;c=v[h>>2]}m=m+1|0;if((m|0)<(c|0)){continue}break}}i=v[n+4>>2];p=p+1|0;if((i|0)>(p|0)){continue}break}}z:{A:{c=v[n+80>>2];if(!(v[n+84>>2]!=v[n+92>>2]?c:0)){lc(S+320|0,S+1344|0,i<<2);h=x[W>>1];if(h){p=v[fa+4>>2];m=0;while(1){j=p+B(m,3)|0;g=w[j+1|0];k=S+1344|0;j=k+(w[j|0]<<2)|0;if(!(v[(g<<2)+k>>2]?v[j>>2]:0)){v[(S+1344|0)+(g<<2)>>2]=0;v[j>>2]=0}m=m+1|0;if((h|0)!=(m|0)){continue}break}}T=Z>>1;la=q+B(E,40)|0;if(w[la+8|0]){c=0;while(1){B:{if((i|0)<=0){g=0;break B}j=v[fa+4>>2];m=0;g=0;while(1){if(w[(j+B(m,3)|0)+2|0]==(c|0)){l=g+S|0;h=m<<2;C:{if(v[h+(S+1344|0)>>2]){p=1;h=0;break C}p=0;h=v[(h+n|0)+800>>2]}t[l|0]=p;v[(S+256|0)+(g<<2)>>2]=h;g=g+1|0}m=m+1|0;if((m|0)!=(i|0)){continue}break}}ga=S+256|0;E=S;H=jb-16|0;jb=H;h=n;I=v[h+4>>2];m=v[h+396>>2];l=w[(c+la|0)+24|0];U=m+B(l,24)|0;j=v[U+4>>2];p=T;ma=x[(h+(l<<1)|0)+268>>1];i=p<<((ma|0)==2);k=i>>>0>j>>>0?j:i;j=v[U>>2];A=(k-(i>>>0>j>>>0?j:i)>>>0)/y[U+8>>2]|0;F=A<<2;i=B(I,F+4|0);V=v[v[h+124>>2]+B(w[U+13|0],2096)>>2];va=v[h+92>>2];D:{if(v[h+80>>2]){i=Hm(h,i);I=v[h+4>>2];break D}i=kd(i)}j=0;if((I|0)>0){k=(I<<2)+i|0;while(1){v[(j<<2)+i>>2]=k;k=k+F|0;j=j+1|0;if((I|0)!=(j|0)){continue}break}}F=i;E:{F:{G:{if((g|0)>0){i=p<<2;j=0;while(1){if(!w[j+E|0]){Qb(v[ga+(j<<2)>>2],0,i)}j=j+1|0;if((j|0)!=(g|0)){continue}break}if((g|0)==1|(ma|0)!=2){break G}j=0;if((g|0)<=0){break F}while(1){if(!w[j+E|0]){break F}j=j+1|0;if((j|0)!=(g|0)){continue}break}break E}j=0;if((ma|0)==2){break F}}ra=m+B(l,24)|0;wa=ra;xa=(A|0)<=0;I=0;while(1){if(!xa){i=0;sa=(g|0)<=0;ya=sa|(I|0)!=0;p=0;while(1){j=0;if(!ya){while(1){if(!w[j+E|0]){l=v[h+124>>2]+B(w[U+13|0],2096)|0;if(v[h+1396>>2]<=9){ek(h)}m=v[h+1392>>2];k=u[(l+((m&1023)<<1)|0)+36>>1];H:{if((k|0)>=0){q=m;m=w[k+v[l+8>>2]|0];v[h+1392>>2]=q>>>m;r=v[h+1396>>2]-m|0;m=(r|0)<0;v[h+1396>>2]=m?0:r;k=m?-1:k;break H}k=ml(h,l)}k=w[l+23|0]?v[v[l+2088>>2]+(k<<2)>>2]:k;if((k|0)==-1){break E}v[v[F+(j<<2)>>2]+(i<<2)>>2]=v[v[ra+16>>2]+(k<<2)>>2]}j=j+1|0;if((j|0)!=(g|0)){continue}break}}I:{if((V|0)<=0){break I}k=0;if((p|0)>=(A|0)){break I}while(1){j=0;if(!sa){while(1){J:{if(w[j+E|0]){break J}m=j<<2;l=u[(v[wa+20>>2]+(w[v[v[m+F>>2]+(i<<2)>>2]+k|0]<<4)|0)+(I<<1)>>1];if((l|0)<0){break J}P=h;l=v[h+124>>2]+B(l&65535,2096)|0;ca=v[m+ga>>2];_=v[U+8>>2];m=v[U>>2]+B(_,p)|0;K:{L:{M:{if(ma){N=0;O=1;if((_|0)<=0){break K}while(1){ja=ca+(m<<2)|0;M=_-N|0;r=0;o=C(0);G=zG(P,l);N:{if((G|0)<0){break N}q=l;r=v[l>>2];M=(r|0)<(M|0)?r:M;ka=B(r,G);O:{P:{if(w[l+22|0]){G=0;if((M|0)>0){break P}break O}G=0;if((M|0)<=0){break O}while(1){r=ja+(G<<2)|0;z[r>>2]=z[r>>2]+z[v[q+28>>2]+(G+ka<<2)>>2];r=1;G=G+1|0;if((M|0)!=(G|0)){continue}break}break N}while(1){r=ja+(G<<2)|0;o=C(z[v[q+28>>2]+(G+ka<<2)>>2]+o);z[r>>2]=z[r>>2]+o;o=C(z[q+12>>2]+o);r=1;G=G+1|0;if((M|0)!=(G|0)){continue}break}break N}r=1}if(!r){break M}r=v[l>>2];m=r+m|0;N=r+N|0;if((_|0)>(N|0)){continue}break}break K}N=0;q=(_|0)/v[l>>2]|0;if((q|0)<=0){break L}ja=ca+(m<<2)|0;while(1){ka=ja+(N<<2)|0;G=_-(m+N|0)|0;M=q;r=0;o=C(0);ta=zG(P,l);Q:{if((ta|0)<0){break Q}r=1;O=l;ca=v[l>>2];ua=(G|0)>(ca|0)?ca:G;if((ua|0)<=0){break Q}ca=B(ca,ta);G=0;while(1){r=ka+(B(G,M)<<2)|0;D=C(z[v[O+28>>2]+(G+ca<<2)>>2]+o);z[r>>2]=z[r>>2]+D;o=w[O+22|0]?D:o;r=1;G=G+1|0;if((ua|0)!=(G|0)){continue}break}}if(!r){break M}N=N+1|0;if((q|0)!=(N|0)){continue}break}break L}O=0;break K}O=1}if(!O){break E}}j=j+1|0;if((j|0)!=(g|0)){continue}break}}p=p+1|0;k=k+1|0;if((V|0)<=(k|0)){break I}if((p|0)<(A|0)){continue}break}}i=i+1|0;if((p|0)<(A|0)){continue}break}}I=I+1|0;if((I|0)!=8){continue}break}break E}if((g|0)==(j|0)){break E}m=m+B(l,24)|0;r=m;P=(g|0)!=2;E=(A|0)<=0;O=(g|0)<3;k=0;while(1){R:{if(!P){j=0;I=0;if(E){break R}while(1){i=v[U>>2]+B(v[U+8>>2],j)|0;v[H+12>>2]=i&1;v[H+8>>2]=i>>1;if(!k){l=v[h+124>>2]+B(w[U+13|0],2096)|0;if(v[h+1396>>2]<=9){ek(h)}q=v[h+1392>>2];i=u[(l+((q&1023)<<1)|0)+36>>1];S:{if((i|0)>=0){M=q;q=w[i+v[l+8>>2]|0];v[h+1392>>2]=M>>>q;M=v[h+1396>>2]-q|0;q=(M|0)<0;v[h+1396>>2]=q?0:M;i=q?-1:i;break S}i=ml(h,l)}i=w[l+23|0]?v[v[l+2088>>2]+(i<<2)>>2]:i;if((i|0)==-1){break E}v[v[F>>2]+(I<<2)>>2]=v[v[m+16>>2]+(i<<2)>>2]}T:{if((V|0)<=0){break T}i=0;if((j|0)>=(A|0)){break T}while(1){l=v[U+8>>2];q=u[(v[r+20>>2]+(w[v[v[F>>2]+(I<<2)>>2]+i|0]<<4)|0)+(k<<1)>>1];U:{if((q|0)>=0){if(BG(h,v[h+124>>2]+B(q&65535,2096)|0,ga,2,H+12|0,H+8|0,p,l)){break U}break E}l=v[U>>2]+(l+B(j,l)|0)|0;v[H+8>>2]=l>>1;v[H+12>>2]=l&1}j=j+1|0;i=i+1|0;if((V|0)<=(i|0)){break T}if((j|0)<(A|0)){continue}break}}I=I+1|0;if((j|0)<(A|0)){continue}break}break R}if(O){break R}j=0;I=0;if(E){break R}while(1){l=v[U>>2]+B(v[U+8>>2],j)|0;i=(l|0)/(g|0)|0;v[H+12>>2]=l-B(g,i);v[H+8>>2]=i;if(!k){l=v[h+124>>2]+B(w[U+13|0],2096)|0;if(v[h+1396>>2]<=9){ek(h)}q=v[h+1392>>2];i=u[(l+((q&1023)<<1)|0)+36>>1];V:{if((i|0)>=0){M=q;q=w[i+v[l+8>>2]|0];v[h+1392>>2]=M>>>q;M=v[h+1396>>2]-q|0;q=(M|0)<0;v[h+1396>>2]=q?0:M;i=q?-1:i;break V}i=ml(h,l)}i=w[l+23|0]?v[v[l+2088>>2]+(i<<2)>>2]:i;if((i|0)==-1){break E}v[v[F>>2]+(I<<2)>>2]=v[v[m+16>>2]+(i<<2)>>2]}W:{if((V|0)<=0){break W}i=0;if((j|0)>=(A|0)){break W}while(1){l=v[U+8>>2];q=u[(v[r+20>>2]+(w[v[v[F>>2]+(I<<2)>>2]+i|0]<<4)|0)+(k<<1)>>1];X:{if((q|0)>=0){if(BG(h,v[h+124>>2]+B(q&65535,2096)|0,ga,g,H+12|0,H+8|0,p,l)){break X}break E}l=v[U>>2]+(l+B(j,l)|0)|0;q=(l|0)/(g|0)|0;v[H+8>>2]=q;v[H+12>>2]=l-B(g,q)}j=j+1|0;i=i+1|0;if((V|0)<=(i|0)){break W}if((j|0)<(A|0)){continue}break}}I=I+1|0;if((j|0)<(A|0)){continue}break}}k=k+1|0;if((k|0)!=8){continue}break}}if(!v[h+80>>2]){Wb(F)}v[h+92>>2]=va;jb=H+16|0;c=c+1|0;if(c>>>0<w[la+8|0]){i=v[n+4>>2];continue}break}c=v[n+80>>2]}if(!(v[n+84>>2]!=v[n+92>>2]?c:0)){i=x[W>>1];if(i){h=(T|0)>1?T:1;g=n+800|0;while(1){c=i;i=c-1|0;if((Z|0)>=2){p=v[fa+4>>2]+B(i,3)|0;j=v[g+(w[p+1|0]<<2)>>2];p=v[g+(w[p|0]<<2)>>2];m=0;while(1){l=m<<2;k=l+j|0;s=z[k>>2];l=l+p|0;o=z[l>>2];Y:{if(!(o<=C(0))){if(!(s<=C(0))){D=C(o-s);break Y}D=o;o=C(s+o);break Y}if(!(s<=C(0))){D=C(s+o);break Y}D=o;o=C(o-s)}z[l>>2]=o;z[k>>2]=D;m=m+1|0;if((h|0)!=(m|0)){continue}break}}if((c|0)>1){continue}break}}m=0;if(v[n+4>>2]<=0){break z}U=T<<2;while(1){g=m<<2;h=g+n|0;c=h;Z:{if(v[g+(S+320|0)>>2]){Qb(v[c+800>>2],0,U);break Z}g=Z;i=v[c+800>>2];P=v[h+996>>2];p=1;c=n;h=w[(W+w[(v[W+4>>2]+B(m,3)|0)+2|0]|0)+9|0];_:{if(!x[(c+(h<<1)|0)+132>>1]){cc(c,21);break _}r=g>>1;F=v[c+260>>2]+B(h,1596)|0;c=B(w[F+1588|0],u[P>>1]);g=0;k=v[F+1592>>2];if((k|0)>=2){G=F+1592|0;H=F+1588|0;while(1){h=w[(p+F|0)+838|0]<<1;j=u[h+P>>1];if((j|0)>=0){j=B(w[H|0],j&65535);h=x[(h+F|0)+338>>1];if((h|0)!=(g|0)){l=i;k=g;O=j-c|0;E=h-g|0;q=(O|0)/(E|0)|0;M=(h|0)>(r|0)?r:h;$:{if((M|0)<=(g|0)){break $}g=l+(k<<2)|0;z[g>>2]=z[g>>2]*z[((c&255)<<2)+47536>>2];g=k+1|0;if((M|0)<=(g|0)){break $}k=O>>31;A=k+O^k;O=q>>31;O=A-B(E,O+q^O)|0;k=k|1;I=0;while(1){A=l+(g<<2)|0;N=A;o=z[A>>2];I=I+O|0;A=(I|0)<(E|0);c=(c+q|0)+(A?0:k)|0;z[N>>2]=o*z[((c&255)<<2)+47536>>2];I=I-(A?0:E)|0;g=g+1|0;if((M|0)!=(g|0)){continue}break}}k=v[G>>2];g=h}c=j}p=p+1|0;if((k|0)>(p|0)){continue}break}}if((g|0)<(r|0)){o=z[(c<<2)+47536>>2];while(1){c=i+(g<<2)|0;z[c>>2]=z[c>>2]*o;g=g+1|0;if((r|0)!=(g|0)){continue}break}}}}m=m+1|0;c=v[n+4>>2];if((m|0)<(c|0)){continue}break}break A}ia(2707,9203,3335,2120);L()}ia(2707,9203,3302,2120);L()}m=0;if((c|0)<=0){break z}while(1){fa=w[pa+412|0];F=Z;V=F>>1;g=V<<2;r=n;ma=v[n+92>>2];p=v[(n+(m<<2)|0)+800>>2];c=V<<2;W=p+c|0;aa:{if(v[n+80>>2]){l=Hm(r,g);break aa}l=kd(g)}h=(l+c|0)-8|0;k=v[(r+(fa<<2)|0)+1068>>2];ba:{if(F>>>0<2){g=k;break ba}c=p;g=k;while(1){z[h+4>>2]=C(z[g>>2]*z[c>>2])-C(z[g+4>>2]*z[c+8>>2]);z[h>>2]=C(z[g>>2]*z[c+8>>2])+C(z[g+4>>2]*z[c>>2]);g=g+8|0;h=h-8|0;c=c+16|0;if((W|0)!=(c|0)){continue}break}}if(h>>>0>=l>>>0){c=((V<<2)+p|0)-12|0;while(1){z[h+4>>2]=C(z[g+4>>2]*z[c>>2])-C(z[g>>2]*z[c+8>>2]);z[h>>2]=C(z[g>>2]*C(-z[c>>2]))-C(z[g+4>>2]*z[c+8>>2]);c=c-16|0;g=g+8|0;h=h-8|0;if(l>>>0<=h>>>0){continue}break}}ga=F>>2;if((F|0)>=16){c=ga<<2;h=c+l|0;j=c+p|0;g=(k+(V<<2)|0)-32|0;i=p;c=l;while(1){o=z[c>>2];D=z[h>>2];s=z[c+4>>2];J=z[h+4>>2];z[j+4>>2]=s+J;z[j>>2]=z[c>>2]+z[h>>2];s=C(J-s);o=C(D-o);z[i+4>>2]=C(z[g+16>>2]*s)-C(z[g+20>>2]*o);z[i>>2]=C(z[g+20>>2]*s)+C(z[g+16>>2]*o);o=z[c+8>>2];D=z[h+8>>2];s=z[c+12>>2];J=z[h+12>>2];z[j+12>>2]=s+J;z[j+8>>2]=z[c+8>>2]+z[h+8>>2];s=C(J-s);o=C(D-o);z[i+12>>2]=C(z[g>>2]*s)-C(z[g+4>>2]*o);z[i+8>>2]=C(z[g+4>>2]*s)+C(z[g>>2]*o);c=c+16|0;h=h+16|0;i=i+16|0;j=j+16|0;g=g-32|0;if(k>>>0<=g>>>0){continue}break}}E=nl(F);g=F>>4;j=V-1|0;c=F>>3;h=0-c|0;AG(g,p,j,h,k);AG(g,p,j-ga|0,h,k);_=F>>5;g=0-g|0;Co(_,p,j,g,k,16);Co(_,p,j-c|0,g,k,16);Co(_,p,j-(c<<1)|0,g,k,16);Co(_,p,j+B(c,-3)|0,g,k,16);i=2;if((E|0)>=10){i=E-4>>>1|0;h=2;while(1){c=h;h=c+1|0;q=2<<c;if((q|0)>0){P=8<<c;O=F>>c+4;g=0;c=F>>c+2;M=0-(c>>1)|0;while(1){Co(O,p,j-B(c,g)|0,M,k,P);g=g+1|0;if((q|0)!=(g|0)){continue}break}}if((h|0)!=(i|0)){continue}break}}la=E-7|0;if((la|0)>(i|0)){while(1){c=i;i=c+1|0;g=F>>c+6;if((g|0)>0){O=2<<c;M=8<<c;ca=M<<2;I=F>>c+2;U=0-(I>>1)|0;h=k;c=j;while(1){G=p;H=c;A=U;E=h;q=M;N=I;P=O;if((P|0)>0){ja=E+B(q,12)|0;o=z[ja>>2];ka=E+(q<<3)|0;D=z[ka>>2];q=E+(q<<2)|0;s=z[q>>2];J=z[ja+4>>2];Q=z[ka+4>>2];X=z[q+4>>2];Y=z[E+4>>2];da=z[E>>2];E=G+(H<<2)|0;G=E+(A<<2)|0;q=0-N<<2;while(1){H=G-4|0;R=z[H>>2];aa=z[G>>2];ba=z[E>>2];z[E>>2]=aa+ba;A=E-4|0;K=z[A>>2];z[A>>2]=z[H>>2]+K;K=C(K-R);R=C(ba-aa);z[H>>2]=C(K*da)+C(R*Y);z[G>>2]=C(R*da)-C(K*Y);H=G-12|0;aa=z[H>>2];A=E-8|0;K=z[A>>2];N=A;A=G-8|0;ba=z[A>>2];z[N>>2]=ba+K;N=E-12|0;R=z[N>>2];z[N>>2]=z[H>>2]+R;R=C(R-aa);K=C(K-ba);z[H>>2]=C(R*s)+C(K*X);z[A>>2]=C(K*s)-C(R*X);H=G-20|0;aa=z[H>>2];A=E-16|0;K=z[A>>2];N=A;A=G-16|0;ba=z[A>>2];z[N>>2]=ba+K;N=E-20|0;R=z[N>>2];z[N>>2]=z[H>>2]+R;R=C(R-aa);K=C(K-ba);z[H>>2]=C(R*D)+C(K*Q);z[A>>2]=C(K*D)-C(R*Q);H=G-28|0;aa=z[H>>2];A=E-24|0;K=z[A>>2];N=A;A=G-24|0;ba=z[A>>2];z[N>>2]=ba+K;N=E-28|0;R=z[N>>2];z[N>>2]=z[H>>2]+R;R=C(R-aa);K=C(K-ba);z[H>>2]=C(R*o)+C(K*J);z[A>>2]=C(K*o)-C(R*J);G=q+G|0;E=q+E|0;H=P>>>0>1;P=P-1|0;if(H){continue}break}}c=c-8|0;h=(ca<<2)+h|0;E=g>>>0>1;g=g-1|0;if(E){continue}break}}if((i|0)!=(la|0)){continue}break}}c=p;g=F;if((0-(_<<4)|0)<0){c=c+(j<<2)|0;h=c-(_<<6)|0;o=z[k+(g>>3<<2)>>2];da=C(-o);while(1){g=c-32|0;Q=z[g>>2];X=z[c>>2];z[c>>2]=Q+X;i=c-4|0;D=z[i>>2];k=i;i=c-36|0;Y=z[i>>2];z[k>>2]=Y+D;j=c-8|0;s=z[j>>2];k=j;j=c-40|0;K=z[j>>2];z[k>>2]=K+s;k=c-12|0;J=z[k>>2];q=k;k=c-44|0;R=z[k>>2];z[q>>2]=R+J;z[g>>2]=X-Q;z[i>>2]=D-Y;i=c-16|0;D=z[i>>2];q=i;i=c-48|0;aa=z[i>>2];z[q>>2]=aa+D;J=C(J-R);s=C(s-K);z[j>>2]=C(J+s)*o;z[k>>2]=C(J-s)*o;j=c-28|0;s=z[j>>2];k=c-60|0;J=z[k>>2];E=c-24|0;Q=z[E>>2];q=c-56|0;X=z[q>>2];P=c-20|0;Y=z[P>>2];A=P;P=c-52|0;K=z[P>>2];z[A>>2]=K+Y;z[E>>2]=X+Q;z[j>>2]=J+s;z[i>>2]=Y-K;z[P>>2]=aa-D;D=C(s-J);s=C(Q-X);z[q>>2]=C(D-s)*o;z[k>>2]=C(D+s)*da;yG(c);yG(g);c=c+-64|0;if(h>>>0<c>>>0){continue}break}}k=V-4|0;g=(l+(ga<<2)|0)-16|0;if(l>>>0<=g>>>0){h=l+(k<<2)|0;c=v[(r+(fa<<2)|0)+1100>>2];while(1){i=(x[c>>1]<<2)+p|0;z[h+12>>2]=z[i>>2];z[h+8>>2]=z[i+4>>2];z[g+12>>2]=z[i+8>>2];z[g+8>>2]=z[i+12>>2];i=(x[c+2>>1]<<2)+p|0;z[h+4>>2]=z[i>>2];z[h>>2]=z[i+4>>2];z[g+4>>2]=z[i+8>>2];z[g>>2]=z[i+12>>2];c=c+4|0;h=h-16|0;g=g-16|0;if(l>>>0<=g>>>0){continue}break}}h=l+(V<<2)|0;i=h-16|0;if(l>>>0<i>>>0){c=v[(r+(fa<<2)|0)+1084>>2];j=h;g=l;while(1){o=z[c+4>>2];E=j-4|0;D=z[E>>2];s=z[g+4>>2];J=C(D+s);Q=z[c>>2];X=z[g>>2];q=j-8|0;Y=z[q>>2];da=C(X-Y);K=C(C(o*J)-C(Q*da));D=C(s-D);z[g+4>>2]=K+D;o=C(C(Q*J)+C(o*da));s=C(Y+X);z[g>>2]=o+s;z[E>>2]=K-D;z[q>>2]=s-o;o=z[c+12>>2];j=j-12|0;D=z[j>>2];s=z[g+12>>2];J=C(D+s);Q=z[c+8>>2];X=z[g+8>>2];Y=z[i>>2];da=C(X-Y);K=C(C(o*J)-C(Q*da));D=C(s-D);z[g+12>>2]=K+D;o=C(C(Q*J)+C(o*da));s=C(Y+X);z[g+8>>2]=o+s;z[i>>2]=s-o;z[j>>2]=K-D;c=c+16|0;g=g+16|0;j=i;i=i-16|0;if(g>>>0<i>>>0){continue}break}}i=h-32|0;if(l>>>0<=i>>>0){g=v[(r+(fa<<2)|0)+1076>>2]+(V<<2)|0;c=(k<<2)+p|0;j=((F<<2)+p|0)-16|0;while(1){o=z[g-4>>2];D=z[h-8>>2];s=z[g-8>>2];J=z[h-4>>2];Q=C(C(o*D)-C(s*J));z[p>>2]=Q;z[c+12>>2]=-Q;o=C(C(s*C(-D))-C(J*o));z[W>>2]=o;z[j+12>>2]=o;o=z[g-12>>2];D=z[h-16>>2];s=z[g-16>>2];J=z[h-12>>2];Q=C(C(o*D)-C(s*J));z[p+4>>2]=Q;z[c+8>>2]=-Q;o=C(C(s*C(-D))-C(J*o));z[W+4>>2]=o;z[j+8>>2]=o;o=z[g-20>>2];D=z[h-24>>2];s=z[g-24>>2];J=z[h-20>>2];Q=C(C(o*D)-C(s*J));z[p+8>>2]=Q;z[c+4>>2]=-Q;o=C(C(s*C(-D))-C(J*o));z[W+8>>2]=o;z[j+4>>2]=o;o=z[g-28>>2];D=z[i>>2];g=g-32|0;s=z[g>>2];J=z[h-28>>2];Q=C(C(o*D)-C(s*J));z[p+12>>2]=Q;z[c>>2]=-Q;o=C(C(s*C(-D))-C(J*o));z[W+12>>2]=o;z[j>>2]=o;j=j-16|0;c=c-16|0;W=W+16|0;p=p+16|0;h=i;i=h-32|0;if(l>>>0<=i>>>0){continue}break}}if(!v[r+80>>2]){Wb(l)}v[r+92>>2]=ma;m=m+1|0;if((m|0)<v[n+4>>2]){continue}break}}EG(n);ca:{if(w[n+1377|0]){v[n+1060>>2]=0-T;t[n+1377|0]=0;v[n+1064>>2]=1;v[n+1412>>2]=Z-na;break ca}c=v[n+1412>>2];if(!c){break ca}g=oa-$|0;if((g|0)<=(c|0)){v[n+1412>>2]=c-g;v[qa>>2]=oa;$=oa;break ca}$=c+$|0;v[qa>>2]=$;v[n+1412>>2]=0}c=v[n+1064>>2];da:{ea:{fa:{if(v[n+1388>>2]==v[n+1404>>2]){ga:{if(!c|!(w[n+1375|0]&4)){break ga}c=v[n+1408>>2];g=v[n+1060>>2];if(c>>>0>=g+(na-$|0)>>>0){break ga}g=c-g|0;c=(c>>>0<g>>>0?0:g)+$|0;c=(c|0)>(na|0)?na:c;v[ea+12>>2]=c;v[n+1060>>2]=c+v[n+1060>>2];break da}v[n+1064>>2]=1;v[n+1060>>2]=v[n+1408>>2]+($-T|0);break fa}if(!c){break ea}}v[n+1060>>2]=v[n+1060>>2]+(oa-$|0)}if(v[n+84>>2]!=v[n+92>>2]?v[n+80>>2]:0){break p}v[ea+12>>2]=na}c=1}jb=S+2368|0;break o}ia(2707,9203,3451,2120);L()}}else{c=0}jb=ha+16|0;if(!c){ha:{ia:{ja:{c=v[a+100>>2];switch(c-32|0){case 0:break ia;case 3:break ja;default:break ha}}v[a+100>>2]=0;while(1){if(za=0,Aa=(Mg(a)|0)!=-1,Ba=v[a+96>>2],Ba?za:Aa){continue}break}v[f>>2]=0;b=v[a+32>>2]-b|0;break a}if(v[a+992>>2]){break ha}v[a+100>>2]=0;while(1){if(za=0,Aa=(Mg(a)|0)!=-1,Ba=v[a+96>>2],Ba?za:Aa){continue}break}v[f>>2]=0;b=v[a+32>>2]-b|0;break a}v[a+1420>>2]=0;v[a+992>>2]=0;v[a+1504>>2]=0;v[a+1508>>2]=0;v[a+1412>>2]=0;v[a+1416>>2]=0;t[a+1377|0]=0;v[a+1064>>2]=0;v[a+100>>2]=c;v[f>>2]=0;b=1;break a}p=ea;l=v[p+12>>2];F=v[p+4>>2];k=F;g=v[p+8>>2];i=0;ka:{la:{c=a;j=v[c+992>>2];ma:{if(!j){h=v[c+4>>2];j=0;break ma}Z=j<<1;na:{if((Z|0)==v[c+112>>2]){h=n+1092|0}else{h=0;if((Z|0)!=v[n+116>>2]){break na}h=n+1096|0}h=v[h>>2]}n=h;if(!n){break la}h=v[c+4>>2];if((h|0)>0){Z=(j|0)<=0;while(1){if(!Z){m=c+(i<<2)|0;S=m;h=0;while(1){$=v[m+800>>2]+(h+k<<2)|0;r=h<<2;z[$>>2]=C(z[n+(j+(h^-1)<<2)>>2]*z[r+v[S+928>>2]>>2])+C(z[n+r>>2]*z[$>>2]);h=h+1|0;if((j|0)!=(h|0)){continue}break}h=v[c+4>>2]}i=i+1|0;if((i|0)<(h|0)){continue}break}}j=v[c+992>>2]}Z=l-g|0;v[c+992>>2]=Z;if((h|0)>0){i=0;while(1){if((g|0)<(l|0)){m=c+(i<<2)|0;S=m;h=0;n=g;while(1){z[v[S+928>>2]+(h<<2)>>2]=z[v[m+800>>2]+(n<<2)>>2];h=h+1|0;n=g+h|0;if((h|0)!=(Z|0)){continue}break}h=v[c+4>>2]}i=i+1|0;if((i|0)<(h|0)){continue}break}}if(!j){break la}h=c;i=v[c+1416>>2];c=((g|0)>(l|0)?l:g)-k|0;v[h+1416>>2]=i+c;break ka}c=0}g=c;v[p+12>>2]=c;h=v[a+4>>2];if((h|0)>0){c=0;while(1){i=(c<<2)+a|0;v[i+864>>2]=v[i+800>>2]+(F<<2);c=c+1|0;if((h|0)!=(c|0)){continue}break}}if(d){v[d>>2]=h}v[f>>2]=g;v[e>>2]=a+864;b=v[a+32>>2]-b|0}jb=ea+16|0;return b|0}function zg(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=C(0),m=0,n=0,o=0,p=0,q=0,r=0,s=0,D=0;d=jb-2928|0;jb=d;a:{b:{c:{d:{e:{if(Qu(c)){tc(b,268435456);o=v[c+8>>2];j=d+2904|0;f=j;v[f>>2]=0;v[f+4>>2]=0;Oi(f+8|0);v[d+2900>>2]=0;f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{f=d;p:{q:{r:{s:{if(w[a+3|0]-4>>>0<=4){v[113382]=0;e=T(296,c|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break m}v[d+2900>>2]=e;break s}e=w[a+3|0];if(e>>>0>18){break s}e=1<<e;t:{if(!(e&126991)){if(e&396800){break t}break s}if(!w[a|0]){break s}}e=v[b>>2];v[113382]=0;e=Q(605,a|0,e|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break r}v[113382]=0;U(817,d+736|0,c|0,e|0);e=v[113382];v[113382]=0;if((e|0)==1){break r}h=d+736|0;e=h;g=v[e+4>>2];v[j>>2]=v[e>>2];v[j+4>>2]=g;g=j+8|0;AM(g);e=e+8|0;Fl(g,e);v[g>>2]=v[e>>2];v[g+4>>2]=v[e+4>>2];i=v[zb(e)>>2];s=zb(g),D=i,v[s>>2]=D;s=zb(e),D=0,v[s>>2]=D;v[e>>2]=0;v[e+4>>2]=0;Cc(h);e=0;v[113382]=0;g=T(426,j|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break m}v[d+2900>>2]=v[j>>2];if(!g){break f}}e=w[a+3|0];if(e>>>0>18){break o}h=1<<e;u:{if(!(h&126991)){e=0;if(h&396800){break u}break o}e=!w[a|0]}if(e|y[b>>2]<262145){break o}e=v[d+2900>>2];h=w[a+3|0];v[113382]=0;v[d+720>>2]=((h|0)==11)<<4;h=Q(33,d+720|0,d+2900|0)|0;i=v[113382];v[113382]=0;if((i|0)!=1){v[d+736>>2]=e-v[h>>2];e=w[a+3|0];if(e>>>0>16){break q}v:{if(!(1<<e&126991)){if((e|0)==11){break v}break q}if(!(w[a|0]&7)){break q}}e=v[d+736>>2];if(e>>>0<=2147483647){e=e<<1;break p}e=-1;break p}a=P()|0;O()|0;break a}a=P()|0;O()|0;break a}e=0;v[113382]=0;h=T(1223,a|0)|0;i=v[113382];v[113382]=0;w:{x:{if((i|0)!=1){y:{z:{switch(w[a+3|0]){case 0:case 1:case 2:case 3:case 12:case 13:case 14:case 15:case 16:e=w[a|0];break y;case 9:e=16;break y;case 11:e=4;break y;case 10:case 17:case 18:break z;default:break y}}e=8}h=B(e,h)>>>3|0;e=h-1|0;i=v[d+736>>2];if(e>>>0>-1-i>>>0){break x}e=e+i|0;break w}a=P()|0;O()|0;break a}e=-1}e=(e>>>0)/(h>>>0)|0}v[f+736>>2]=e;tc(b,e);break n}f=d;A:{B:{C:{D:{if(!(w[a+3|0]==4|w[a+3|0]==5|(w[a+3|0]==8|w[a+3|0]==7))){if(w[a+3|0]!=6){break n}e=0;if(y[d+2900>>2]<10){break f}v[113382]=0;Q(304,c|0,4)|0;e=v[113382];v[113382]=0;if((e|0)==1){break m}v[113382]=0;e=T(397,c|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break D}v[d+720>>2]=e;e=v[d+2900>>2];v[113382]=0;v[d+2896>>2]=e;e=Q(297,d+720|0,d+2896|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break C}v[d+736>>2]=v[e>>2];mg(c,8);e=v[d+736>>2];if(e>>>0>50529027){break B}e=B(e,85);break A}v[113382]=0;v[d+736>>2]=v[d+2900>>2];e=T(1223,a|0)|0;h=v[113382];v[113382]=0;f=d;E:{F:{if((h|0)!=1){h=v[d+736>>2];e=8/(e>>>0)|0;if(h>>>0>4294967295/(e>>>0)>>>0){break F}e=B(e,h);break E}a=P()|0;O()|0;break a}e=-1}v[f+736>>2]=e;tc(b,e);break n}a=P()|0;O()|0;break a}a=P()|0;O()|0;break a}e=-1}v[f+736>>2]=e;tc(b,(e>>>0)/(w[a|0]>>>3>>>0)|0)}if(!v[b>>2]){e=0;break f}u[b+34>>1]=x[b+34>>1]&65534|w[a|0]>15;u[b+34>>1]=x[b+34>>1]&65471|(w[a+1|0]!=1)<<6;v[113382]=0;f=T(422,b|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break e}if(!f){e=0;v[b>>2]=0;break f}f=Yc(d+736|0,8,1,0,11);v[113382]=0;f=Q(1224,a|0,f|0)|0;e=v[113382];v[113382]=0;G:{H:{I:{J:{K:{if((e|0)!=1){if(!f){break G}e=0;v[113382]=0;a=Q(1225,c|0,d+736|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break H}if(!a){break g}a=v[b>>2];v[113382]=0;v[d+720>>2]=a+1>>>1;a=T(296,c|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break K}tc(d+720|0,a);v[113382]=0;a=T(818,g|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break J}e=v[d+720>>2];if(e){break I}e=16;break g}a=P()|0;O()|0;break a}a=P()|0;O()|0;break a}a=P()|0;O()|0;break a}a=a+16|0;b=v[b+20>>2];g=0;while(1){f=d+736|0;g=w[f|w[a|0]&15]+g|0;t[b|0]=g;g=w[f|w[a|0]>>>4]+(g&255)|0;t[b+1|0]=g;a=a+1|0;b=b+2|0;e=e-1|0;if(e){continue}break}e=v[d+720>>2]+16|0;break g}a=P()|0;O()|0;break a}if(!(w[a+3|0]!=4&w[a+3|0]!=5)){a=w[a+3|0];v[113382]=0;a=aa(1226,d+1808|0,c|0,b|0,(a|0)==5|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break e}Bb(a);e=v[c+8>>2]-o|0;break g}if(!(w[a+3|0]!=6|w[a+1|0]!=1)){v[113382]=0;Q(304,c|0,4)|0;a=v[113382];v[113382]=0;if((a|0)==1){break e}v[113382]=0;a=T(397,c|0)|0;f=v[113382];v[113382]=0;L:{M:{N:{if((f|0)!=1){v[113382]=0;v[d+720>>2]=a;f=T(409,c|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break N}v[113382]=0;U(1227,d+736|0,c|0,a|0);a=v[113382];v[113382]=0;if((a|0)==1){break L}a=d+736|0;tc(d+720|0,v[a>>2]);v[113382]=0;e=v[d+720>>2];a=T(426,a|0)|0;g=v[113382];v[113382]=0;if((g|0)!=1){g=v[d+736>>2];h=v[b+20>>2];b=zj(b);v[113382]=0;fa(1228,a|0,g|0,h|0,b|0,f<<24>>24);a=v[113382];v[113382]=0;if((a|0)!=1){break M}}a=P()|0;O()|0;Cc(d+736|0);break a}a=P()|0;O()|0;break a}a=P()|0;O()|0;break a}e=e+9|0;Cc(d+736|0);break g}a=P()|0;O()|0;break a}if(!(w[a+3|0]!=9|w[a+1|0]!=1|w[a|0]!=16)){a=v[d+2900>>2];f=x[Bl(d+1800|0)>>1];v[113382]=0;e=aa(1229,b|0,g|0,a|0,f|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break e}break g}if(w[a+3|0]!=8|w[a+1|0]!=1|w[a|0]>16){break l}e=0;v[113382]=0;f=Q(228,c|0,8)|0;g=v[113382];v[113382]=0;if((g|0)==1){break e}if(!f){break g}v[113382]=0;f=T(397,c|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break e}v[d+2900>>2]=f;if(f>>>0<4){break g}v[113382]=0;U(307,d+720|0,c|0,f|0);f=v[113382];v[113382]=0;if((f|0)==1){break b}e=d+720|0;f=lm(d+736|0,e);Bb(e);v[113382]=0;i=T(1230,f|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break d}if(!v[b>>2]){break i}h=w[a|0];a=0;p=(h|0)!=16;g=0;while(1){O:{if(p){break O}v[113382]=0;q=Q(230,f|0,8)|0;e=v[113382];v[113382]=0;if((e|0)!=1){break O}a=V(72108)|0;break j}v[113382]=0;r=Q(230,f|0,1)|0;e=v[113382];v[113382]=0;if((e|0)==1){break k}v[113382]=0;e=Q(230,f|0,1)|0;k=v[113382];v[113382]=0;if((k|0)==1){break k}P:{Q:{R:{if(!e){e=8;while(1){v[113382]=0;k=Q(230,f|0,1)|0;n=v[113382];v[113382]=0;if((n|0)==1){break P}if(k){break R}e=e+16|0;continue}}v[113382]=0;e=Q(230,f|0,3)|0;k=v[113382];v[113382]=0;if((k|0)!=1){break Q}break k}v[113382]=0;k=Q(230,f|0,4)|0;n=v[113382];v[113382]=0;if((n|0)==1){break k}e=e+k|0}g=(g&255)+(((r?-1:0)^e)&255)|0;S:{if((h|0)!=16){t[v[b+20>>2]+a|0]=g;break S}u[v[b+20>>2]+(a<<1)>>1]=q&255|g<<8}a=a+1|0;if(a>>>0<y[b>>2]){continue}break i}break}a=V(72108)|0;break j}a=P()|0;O()|0;break a}T:{U:{V:{W:{X:{if(!(w[a+3|0]!=7|w[a+1|0]!=1|w[a|0]>16)){e=0;if(y[d+2900>>2]<5){break g}a=v[b+20>>2];v[113382]=0;a=T(423,a|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break X}v[113382]=0;a=T(1231,a|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break e}b=zj(b);v[113382]=0;e=W(1232,c|0,a|0,b|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break e}break g}if(!(w[a|0]!=8|w[a+1|0]!=1)){Y:{Z:{_:{$:{aa:{a=w[a+3|0];switch(a|0){case 2:break Z;case 1:break _;case 0:break $;default:break aa}}e=0;switch(a-10|0){case 0:break Y;case 2:break Z;default:break g}}v[113382]=0;e=W(1233,b|0,g|0,v[d+2900>>2])|0;a=v[113382];v[113382]=0;if((a|0)==1){break e}break g}v[113382]=0;e=W(1234,b|0,g|0,v[d+2900>>2])|0;a=v[113382];v[113382]=0;if((a|0)==1){break e}break g}a=v[d+2900>>2];f=w[wy(d+712|0)|0];v[113382]=0;e=aa(1235,b|0,g|0,a|0,f|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break e}break g}v[113382]=0;e=W(1236,b|0,g|0,v[d+2900>>2])|0;a=v[113382];v[113382]=0;if((a|0)==1){break e}break g}if(!(w[a|0]!=8|w[a+1|0]!=3)){ba:{ca:{da:{ea:{f=w[a+3|0];switch(f|0){case 2:break ba;case 1:break da;case 0:break ea;default:break ca}}v[113382]=0;e=W(1237,b|0,g|0,v[d+2900>>2])|0;a=v[113382];v[113382]=0;if((a|0)==1){break e}break g}v[113382]=0;e=W(1238,b|0,g|0,v[d+2900>>2])|0;a=v[113382];v[113382]=0;if((a|0)==1){break e}break g}e=0;if((f|0)!=12){break g}}f=v[d+2900>>2];e=w[wy(d+704|0)|0];v[113382]=0;e=aa(1239,b|0,g|0,f|0,e|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break e}if(w[a+3|0]!=12){break g}f=v[b>>2]<<1;if((f|0)<=0){break g}a=v[b+20>>2];b=f+a|0;while(1){t[a+1|0]=w[a+1|0]+w[a|0];a=a+2|0;if(b>>>0>a>>>0){continue}break}break g}if(!(w[a|0]!=8|w[a+1|0]!=2)){e=0;fa:{switch(w[a+3|0]){case 0:v[113382]=0;e=W(1240,b|0,g|0,v[d+2900>>2])|0;a=v[113382];v[113382]=0;if((a|0)==1){break e}break g;case 1:v[113382]=0;e=W(1241,b|0,g|0,v[d+2900>>2])|0;a=v[113382];v[113382]=0;if((a|0)==1){break e}break g;case 2:break fa;default:break g}}a=v[d+2900>>2];f=w[wy(d+696|0)|0];v[113382]=0;e=aa(1242,b|0,g|0,a|0,f|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break e}break g}if(!(w[a+2|0]|(w[a|0]!=16|w[a+1|0]!=1))){ga:{ha:{ia:{ja:{a=w[a+3|0];switch(a|0){case 2:break ga;case 1:break ia;case 0:break ja;default:break ha}}v[113382]=0;e=W(1243,b|0,g|0,v[d+2900>>2])|0;a=v[113382];v[113382]=0;if((a|0)==1){break e}break g}v[113382]=0;e=W(1244,b|0,g|0,v[d+2900>>2])|0;a=v[113382];v[113382]=0;if((a|0)==1){break e}break g}e=0;if((a|0)!=12){break g}}a=v[d+2900>>2];f=x[Bl(d+688|0)>>1];v[113382]=0;e=aa(1245,b|0,g|0,a|0,f|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break e}break g}if(!(w[a|0]!=16|w[a+1|0]!=1|w[a+2|0]!=1)){e=0;ka:{switch(w[a+3|0]){case 0:v[113382]=0;e=W(1246,b|0,g|0,v[d+2900>>2])|0;a=v[113382];v[113382]=0;if((a|0)==1){break e}break g;case 1:v[113382]=0;e=W(1247,b|0,g|0,v[d+2900>>2])|0;a=v[113382];v[113382]=0;if((a|0)==1){break e}break g;case 2:break ka;default:break g}}a=v[d+2900>>2];f=x[Bl(d+680|0)>>1];v[113382]=0;e=aa(1248,b|0,g|0,a|0,f|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break e}break g}if(!(w[a+2|0]|(w[a|0]!=16|w[a+1|0]!=3))){la:{ma:{na:{oa:{f=w[a+3|0];switch(f|0){case 2:break la;case 1:break na;case 0:break oa;default:break ma}}v[113382]=0;e=W(1249,b|0,g|0,v[d+2900>>2])|0;a=v[113382];v[113382]=0;if((a|0)==1){break e}break g}v[113382]=0;e=W(1250,b|0,g|0,v[d+2900>>2])|0;a=v[113382];v[113382]=0;if((a|0)==1){break e}break g}e=0;if((f|0)!=12){break g}}f=v[d+2900>>2];e=x[Bl(d+672|0)>>1];v[113382]=0;e=aa(1251,b|0,g|0,f|0,e|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break e}if(w[a+3|0]!=12){break g}f=v[b>>2];if(f<<1<=0){break g}a=v[b+20>>2];b=a+(f<<2)|0;while(1){u[a+2>>1]=x[a+2>>1]+x[a>>1];a=a+4|0;if(b>>>0>a>>>0){continue}break}break g}if(!(w[a|0]!=16|w[a+1|0]!=3|w[a+2|0]!=1)){e=0;pa:{switch(w[a+3|0]){case 0:v[113382]=0;e=W(1252,b|0,g|0,v[d+2900>>2])|0;a=v[113382];v[113382]=0;if((a|0)==1){break e}break g;case 1:v[113382]=0;e=W(1253,b|0,g|0,v[d+2900>>2])|0;a=v[113382];v[113382]=0;if((a|0)==1){break e}break g;case 2:break pa;default:break g}}a=v[d+2900>>2];f=x[Bl(d+664|0)>>1];v[113382]=0;e=aa(1254,b|0,g|0,a|0,f|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break e}break g}if(!(w[a+2|0]|(w[a|0]!=16|w[a+1|0]!=2))){e=0;qa:{switch(w[a+3|0]){case 0:v[113382]=0;e=W(1255,b|0,g|0,v[d+2900>>2])|0;a=v[113382];v[113382]=0;if((a|0)==1){break e}break g;case 1:v[113382]=0;e=W(1256,b|0,g|0,v[d+2900>>2])|0;a=v[113382];v[113382]=0;if((a|0)==1){break e}break g;case 2:break qa;default:break g}}a=v[d+2900>>2];f=x[Bl(d+656|0)>>1];v[113382]=0;e=aa(1257,b|0,g|0,a|0,f|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break e}break g}if(!(w[a|0]!=16|w[a+1|0]!=2|w[a+2|0]!=1)){e=0;ra:{switch(w[a+3|0]){case 0:v[113382]=0;e=W(1258,b|0,g|0,v[d+2900>>2])|0;a=v[113382];v[113382]=0;if((a|0)==1){break e}break g;case 1:v[113382]=0;e=W(1259,b|0,g|0,v[d+2900>>2])|0;a=v[113382];v[113382]=0;if((a|0)==1){break e}break g;case 2:break ra;default:break g}}a=v[d+2900>>2];f=x[Bl(d+648|0)>>1];v[113382]=0;e=aa(1260,b|0,g|0,a|0,f|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break e}break g}if(!(w[a+3|0]|(w[a|0]!=24|w[a+1|0]!=1))){f=v[d+2900>>2];if(!w[a+2|0]){v[113382]=0;u[d>>1]=x[d+640>>1];e=aa(1261,b|0,g|0,f|0,d|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break e}break g}v[113382]=0;u[d+2>>1]=x[d+632>>1];e=aa(1262,b|0,g|0,f|0,d+2|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break e}break g}if(!(w[a+3|0]|(w[a|0]!=24|w[a+1|0]!=2))){f=v[d+2900>>2];if(!w[a+2|0]){v[113382]=0;u[d+4>>1]=x[d+624>>1];e=aa(1263,b|0,g|0,f|0,d+4|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break e}break g}v[113382]=0;u[d+6>>1]=x[d+616>>1];e=aa(1264,b|0,g|0,f|0,d+6|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break e}break g}if(!(w[a+3|0]|(w[a|0]!=32|w[a+1|0]!=1))){f=v[d+2900>>2];if(!w[a+2|0]){v[113382]=0;u[d+8>>1]=x[d+608>>1];e=aa(1265,b|0,g|0,f|0,d+8|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break e}break g}v[113382]=0;u[d+10>>1]=x[d+600>>1];e=aa(1266,b|0,g|0,f|0,d+10|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break e}break g}if(!(w[a+3|0]|(w[a|0]!=32|w[a+1|0]!=2))){f=v[d+2900>>2];if(!w[a+2|0]){v[113382]=0;u[d+12>>1]=x[d+592>>1];e=aa(1267,b|0,g|0,f|0,d+12|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break e}break g}v[113382]=0;u[d+14>>1]=x[d+584>>1];e=aa(1268,b|0,g|0,f|0,d+14|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break e}break g}if(!(w[a+3|0]|(w[a|0]!=64|w[a+1|0]!=1))){f=v[d+2900>>2];if(!w[a+2|0]){v[113382]=0;u[d+16>>1]=x[d+576>>1];e=aa(1269,b|0,g|0,f|0,d+16|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break e}break g}v[113382]=0;u[d+18>>1]=x[d+568>>1];e=aa(1270,b|0,g|0,f|0,d+18|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break e}break g}if(!(w[a+3|0]|(w[a|0]!=64|w[a+1|0]!=2))){f=v[d+2900>>2];if(!w[a+2|0]){v[113382]=0;u[d+20>>1]=x[d+560>>1];e=aa(1271,b|0,g|0,f|0,d+20|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break e}break g}v[113382]=0;u[d+22>>1]=x[d+552>>1];e=aa(1272,b|0,g|0,f|0,d+22|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break e}break g}if(!(w[a|0]!=32|w[a+1|0]!=1|w[a+3|0]!=3)){f=v[d+2900>>2];if(!w[a+2|0]){v[113382]=0;u[d+24>>1]=x[d+544>>1];e=aa(1273,b|0,g|0,f|0,d+24|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break e}break g}v[113382]=0;u[d+26>>1]=x[d+536>>1];e=aa(1274,b|0,g|0,f|0,d+26|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break e}break g}if(!(w[a|0]!=32|w[a+1|0]!=2|w[a+3|0]!=3)){f=v[d+2900>>2];if(!w[a+2|0]){v[113382]=0;u[d+28>>1]=x[d+528>>1];e=aa(1275,b|0,g|0,f|0,d+28|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break e}break g}v[113382]=0;u[d+30>>1]=x[d+520>>1];e=aa(1276,b|0,g|0,f|0,d+30|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break e}break g}if(!(w[a|0]!=64|w[a+1|0]!=1|w[a+3|0]!=3)){f=v[d+2900>>2];if(!w[a+2|0]){v[113382]=0;u[d+32>>1]=x[d+512>>1];e=aa(1277,b|0,g|0,f|0,d+32|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break e}break g}v[113382]=0;u[d+34>>1]=x[d+504>>1];e=aa(1278,b|0,g|0,f|0,d+34|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break e}break g}if(!(w[a|0]!=64|w[a+1|0]!=2|w[a+3|0]!=3)){f=v[d+2900>>2];if(!w[a+2|0]){v[113382]=0;u[d+36>>1]=x[d+496>>1];e=aa(1279,b|0,g|0,f|0,d+36|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break e}break g}v[113382]=0;u[d+38>>1]=x[d+488>>1];e=aa(1280,b|0,g|0,f|0,d+38|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break e}break g}if(!(w[a+1|0]!=1&w[a+1|0]!=2|w[a|0]!=24|w[a+3|0]!=16)){v[d+736>>2]=-2147483648;f=v[d+2900>>2];sa:{if(!w[a+2|0]){v[113382]=0;v[d+48>>2]=v[d+480>>2];v[d+476>>2]=0;a=v[d+476>>2];v[d+40>>2]=v[d+472>>2];v[d+44>>2]=a;e=ea(1281,b|0,g|0,f|0,d+736|0,d+40|0)|0;a=v[113382];v[113382]=0;if((a|0)!=1){break sa}break T}v[113382]=0;v[d- -64>>2]=v[d+464>>2];v[d+460>>2]=0;a=v[d+460>>2];v[d+56>>2]=v[d+456>>2];v[d+60>>2]=a;e=ea(1282,b|0,g|0,f|0,d+736|0,d+56|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break T}}if(!e){break g}a=v[d+736>>2];if((a|0)==-2147483648){break g}f=x[b+32>>1];v[113382]=0;f=qma(f,0,a,0)+1073741824|0;a=mb;a=f>>>0<1073741824?a+1|0:a;a=qg(711,(a&2147483647)<<1|f>>>31,a>>>31|0);f=v[113382];v[113382]=0;if((f|0)==1){break T}s=b,D=Ed(a,1,64),u[s+32>>1]=D;u[b+34>>1]=x[b+34>>1]|8192;break g}if(!(w[a+1|0]!=1&w[a+1|0]!=2|w[a|0]!=32|w[a+3|0]!=16)){v[d+736>>2]=-2147483648;f=v[d+2900>>2];ta:{if(!w[a+2|0]){v[113382]=0;v[d+80>>2]=v[d+448>>2];v[d+444>>2]=0;a=v[d+444>>2];v[d+72>>2]=v[d+440>>2];v[d+76>>2]=a;e=ea(1283,b|0,g|0,f|0,d+736|0,d+72|0)|0;a=v[113382];v[113382]=0;if((a|0)!=1){break ta}break U}v[113382]=0;v[d+96>>2]=v[d+432>>2];v[d+428>>2]=0;a=v[d+428>>2];v[d+88>>2]=v[d+424>>2];v[d+92>>2]=a;e=ea(1284,b|0,g|0,f|0,d+736|0,d+88|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break U}}if(!e){break g}a=v[d+736>>2];if((a|0)==-2147483648){break g}f=x[b+32>>1];v[113382]=0;a=qma(f,0,a,0)+1073741824|0;f=mb;f=a>>>0<1073741824?f+1|0:f;a=qg(711,(f&2147483647)<<1|a>>>31,f>>>31|0);f=v[113382];v[113382]=0;if((f|0)==1){break U}s=b,D=Ed(a,1,64),u[s+32>>1]=D;u[b+34>>1]=x[b+34>>1]|8192;break g}if(!(w[a+1|0]!=1&w[a+1|0]!=2|w[a|0]!=32|w[a+3|0]!=15)){v[d+736>>2]=1065353216;f=v[d+2900>>2];ua:{if(!w[a+2|0]){v[113382]=0;v[d+412>>2]=0;v[d+416>>2]=1065353216;a=v[d+420>>2];v[d+112>>2]=v[d+416>>2];v[d+116>>2]=a;a=v[d+412>>2];v[d+104>>2]=v[d+408>>2];v[d+108>>2]=a;e=ea(1285,b|0,g|0,f|0,d+736|0,d+104|0)|0;a=v[113382];v[113382]=0;if((a|0)!=1){break ua}break V}v[113382]=0;v[d+396>>2]=0;v[d+400>>2]=1065353216;a=v[d+404>>2];v[d+128>>2]=v[d+400>>2];v[d+132>>2]=a;a=v[d+396>>2];v[d+120>>2]=v[d+392>>2];v[d+124>>2]=a;e=ea(1286,b|0,g|0,f|0,d+736|0,d+120|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break V}}if(!e){break g}l=z[d+736>>2];if(l==C(1)){break g}l=dn(C(l*C(x[b+32>>1])),C(1),C(64));v[113382]=0;a=gb(1287,C(l))|0;f=v[113382];v[113382]=0;if((f|0)==1){break V}u[b+32>>1]=a;u[b+34>>1]=x[b+34>>1]|8192;break g}if(!(w[a+1|0]!=1&w[a+1|0]!=2|w[a|0]!=64|w[a+3|0]!=15)){v[d+736>>2]=0;v[d+740>>2]=1072693248;f=v[d+2900>>2];va:{if(!w[a+2|0]){v[113382]=0;v[d+376>>2]=0;v[d+380>>2]=1072693248;v[d+368>>2]=0;v[d+372>>2]=0;v[d+144>>2]=0;v[d+148>>2]=0;v[d+152>>2]=0;v[d+156>>2]=1072693248;a=v[d+388>>2];v[d+160>>2]=v[d+384>>2];v[d+164>>2]=a;a=v[d+364>>2];v[d+136>>2]=v[d+360>>2];v[d+140>>2]=a;e=ea(1288,b|0,g|0,f|0,d+736|0,d+136|0)|0;a=v[113382];v[113382]=0;if((a|0)!=1){break va}break W}v[113382]=0;v[d+344>>2]=0;v[d+348>>2]=1072693248;v[d+336>>2]=0;v[d+340>>2]=0;v[d+176>>2]=0;v[d+180>>2]=0;v[d+184>>2]=0;v[d+188>>2]=1072693248;a=v[d+356>>2];v[d+192>>2]=v[d+352>>2];v[d+196>>2]=a;a=v[d+332>>2];v[d+168>>2]=v[d+328>>2];v[d+172>>2]=a;e=ea(1289,b|0,g|0,f|0,d+736|0,d+168|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break W}}if(!e){break g}m=A[d+736>>3];if(m==1){break g}m=ty(m*+x[b+32>>1],1,64);v[113382]=0;a=Ba(1290,+m)|0;f=v[113382];v[113382]=0;if((f|0)==1){break W}u[b+32>>1]=a;u[b+34>>1]=x[b+34>>1]|8192;break g}if(!(w[a|0]!=32|w[a+1|0]!=1|w[a+3|0]!=13)){f=v[d+2900>>2];if(!w[a+2|0]){v[113382]=0;v[d+320>>2]=939524096;a=v[d+324>>2];v[d+200>>2]=v[d+320>>2];v[d+204>>2]=a;e=aa(1291,b|0,g|0,f|0,d+200|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break e}break g}v[113382]=0;v[d+312>>2]=939524096;a=v[d+316>>2];v[d+208>>2]=v[d+312>>2];v[d+212>>2]=a;e=aa(1292,b|0,g|0,f|0,d+208|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break e}break g}if(!(w[a|0]!=32|w[a+1|0]!=2|w[a+3|0]!=13)){f=v[d+2900>>2];if(!w[a+2|0]){v[113382]=0;v[d+304>>2]=939524096;a=v[d+308>>2];v[d+216>>2]=v[d+304>>2];v[d+220>>2]=a;e=aa(1293,b|0,g|0,f|0,d+216|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break e}break g}v[113382]=0;v[d+296>>2]=939524096;a=v[d+300>>2];v[d+224>>2]=v[d+296>>2];v[d+228>>2]=a;e=aa(1294,b|0,g|0,f|0,d+224|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break e}break g}if(!(w[a|0]!=32|w[a+1|0]!=1|w[a+3|0]!=14)){f=v[d+2900>>2];if(!w[a+2|0]){v[113382]=0;v[d+288>>2]=872415232;a=v[d+292>>2];v[d+232>>2]=v[d+288>>2];v[d+236>>2]=a;e=aa(1291,b|0,g|0,f|0,d+232|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break e}break g}v[113382]=0;v[d+280>>2]=872415232;a=v[d+284>>2];v[d+240>>2]=v[d+280>>2];v[d+244>>2]=a;e=aa(1292,b|0,g|0,f|0,d+240|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break e}break g}e=0;if(w[a|0]!=32|w[a+1|0]!=2|w[a+3|0]!=14){break g}f=v[d+2900>>2];if(!w[a+2|0]){v[113382]=0;v[d+272>>2]=872415232;a=v[d+276>>2];v[d+248>>2]=v[d+272>>2];v[d+252>>2]=a;e=aa(1293,b|0,g|0,f|0,d+248|0)|0;a=v[113382];v[113382]=0;if((a|0)!=1){break g}break e}v[113382]=0;v[d+264>>2]=872415232;a=v[d+268>>2];v[d+256>>2]=v[d+264>>2];v[d+260>>2]=a;e=aa(1294,b|0,g|0,f|0,d+256|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break e}break g}V(0)|0;O()|0;Ab();L()}a=P()|0;O()|0;break a}a=P()|0;O()|0;break a}a=P()|0;O()|0;break a}a=P()|0;O()|0;break a}a=V(72108)|0}if((O()|0)!=(ga(72108)|0)){break c}_(a|0)|0;v[113382]=0;Y(20);a=v[113382];v[113382]=0;if((a|0)==1){break h}}e=i+4|0;Bb(f);break g}a=P()|0;O()|0;break c}v[113382]=0;Q(226,c|0,e+o|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break e}}Cc(j)}jb=d+2928|0;return e|0}a=P()|0;O()|0;break a}a=P()|0;O()|0}Bb(f);break a}a=P()|0;O()|0}Cc(j);S(a|0);L()}function uT(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,y=0,z=0,A=0,C=0,D=0,E=0,F=0,G=0,H=0;d=jb-336|0;jb=d;Ic(b);a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{v:{w:{x:{y:{z:{A:{B:{C:{D:{E:{F:{if(!Hf(b,d+328|0)){break F}if(!JA(d+328|0)){break F}if(!c){p=1;break F}q=Nk(d+312|0,b);v[113382]=0;U(434,d+296|0,q|0,1);b=v[113382];v[113382]=0;G:{H:{I:{J:{K:{L:{M:{N:{if((b|0)!=1){v[113382]=0;U(435,d+160|0,d+296|0,1229866575);b=v[113382];v[113382]=0;if((b|0)==1){break L}v[113382]=0;p=Q(436,d+160|0,d+280|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break N}Bb(d+160|0);if(!p){break G}v[113382]=0;R(403,a|0,524288);b=v[113382];v[113382]=0;if((b|0)==1){break c}v[113382]=0;Z(437,a|0);b=v[113382];v[113382]=0;if((b|0)!=1){break M}break c}b=P()|0;O()|0;break a}b=P()|0;O()|0;Bb(d+160|0);break b}v[a+480208>>2]=12;b=w[d+288|0]|w[d+289|0]<<8;G=a,H=Ed((b<<8|b>>>8)&65535,1,127),u[G+480188>>1]=H;b=w[d+280|0]|w[d+281|0]<<8;v[113382]=0;u[d+160>>1]=b<<8|b>>>8;u[d+248>>1]=255;b=Q(438,d+160|0,d+248|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break d}u[a+480192>>1]=x[b>>1];b=d+280|2;b=w[b|0]|w[b+1|0]<<8;v[113382]=0;u[d+160>>1]=b<<8|b>>>8;u[d+248>>1]=3999;b=Q(438,d+160|0,d+248|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break e}u[a+480190>>1]=x[b>>1];v[113382]=0;b=a+1074312|0;W(439,b|0,6,1)|0;e=v[113382];v[113382]=0;if((e|0)==1){break c}v[113382]=0;Q(440,b|0,21)|0;e=v[113382];v[113382]=0;if((e|0)==1){break c}v[113382]=0;Q(440,b|0,13)|0;b=v[113382];v[113382]=0;if((b|0)==1){break c}v[113382]=0;b=Q(2,d+160|0,5306)|0;e=v[113382];v[113382]=0;if((e|0)==1){break f}Gb(a+1304436|0,b);yb(b);v[113382]=0;b=Q(2,d+160|0,6405)|0;e=v[113382];v[113382]=0;if((e|0)==1){break g}Gb(a+1304448|0,b);yb(b);v[113382]=0;e=Q(2,d+264|0,11196)|0;b=v[113382];v[113382]=0;if((b|0)==1){break h}v[113382]=0;R(189,d+248|0,e|0);b=v[113382];v[113382]=0;if((b|0)==1){break j}v[113382]=0;R(441,d+232|0,d+328|4);b=v[113382];v[113382]=0;if((b|0)==1){break l}v[113382]=0;R(441,d+216|0,d+328|5);b=v[113382];v[113382]=0;if((b|0)==1){break n}v[113382]=0;X(192,d+160|0,d+248|0,d+232|0,d+216|0);b=v[113382];v[113382]=0;if((b|0)==1){break o}b=d+160|0;Gb(a+1304460|0,b);yb(b);yb(d+216|0);yb(d+232|0);b=d+248|0;Ib(b);yb(e);v[a+1304496>>2]=2;v[113382]=0;U(435,b|0,d+296|0,1312902469);b=v[113382];v[113382]=0;if((b|0)==1){break p}v[113382]=0;b=T(225,d+248|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break r}v[113382]=0;f=a+1304400|0;W(442,d+248|0,f|0,b|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break r}v[113382]=0;U(435,d+232|0,d+296|0,1397706311);b=v[113382];v[113382]=0;if((b|0)==1){break s}b=a+484360|0;Hn(Vb(b));O:{e=d+280|4;j=w[e|0]|w[e+1|0]<<8;P:{if(!j){break P}e=0;j=(j<<8|j>>>8)&65535;while(1){v[113382]=0;g=Q(228,d+232|0,46)|0;k=v[113382];v[113382]=0;Q:{if((k|0)!=1){if(!g){break P}v[113382]=0;W(443,d+232|0,d+160|0,44)|0;g=v[113382];v[113382]=0;if((g|0)!=1){if(!Sc(f)){break Q}v[113382]=0;Q(444,f|0,d+160|0)|0;g=v[113382];v[113382]=0;if((g|0)!=1){break Q}}b=P()|0;O()|0;break t}b=P()|0;O()|0;break t}v[113382]=0;g=T(445,d+232|0)|0;k=v[113382];v[113382]=0;if((k|0)==1){break O}if(!id(Vb(b))){v[113382]=0;k=T(446,b|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break O}if((k|0)==255){break P}}k=Vb(b);v[113382]=0;U(6,d+216|0,2,d+160|0);h=v[113382];v[113382]=0;if((h|0)==1){break u}v[113382]=0;R(447,k|0,d+216|0);k=v[113382];v[113382]=0;if((k|0)==1){break v}yb(d+216|0);k=Vb(b);v[113382]=0;ea(448,k|0,d+232|0,g|0,65535,65535)|0;g=v[113382];v[113382]=0;if((g|0)==1){break O}e=e+1|0;if(j>>>0>(e&65535)>>>0){continue}break}}v[113382]=0;R(449,b|0,0);b=v[113382];v[113382]=0;if((b|0)==1){break w}v[113382]=0;U(435,d+216|0,d+296|0,1229869908);b=v[113382];v[113382]=0;if((b|0)==1){break x}v[113382]=0;b=T(450,d+216|0)|0;e=v[113382];v[113382]=0;R:{S:{T:{U:{V:{W:{X:{Y:{if((e|0)==1){break Y}Z:{_:{$:{aa:{ba:{ca:{if(!b){break ca}if(x[a+480192>>1]){j=1;while(1){v[113382]=0;Q(451,d+216|0,d+160|0)|0;b=v[113382];v[113382]=0;da:{ea:{fa:{if((b|0)!=1){b=w[d+190|0]|w[d+191|0]<<8;v[113382]=0;b=W(411,a|0,j&65535,(b<<8|b>>>8)&65535)|0;e=v[113382];v[113382]=0;if((e|0)==1){break fa}if(!b){break da}e=w[d+190|0]|w[d+191|0]<<8;if(((e<<8|e>>>8)&65535)>>>0>3999){break da}v[113382]=0;U(452,d+48|0,2,d+160|0);e=v[113382];v[113382]=0;if((e|0)!=1){v[113382]=0;R(356,d+96|0,d+48|0);e=v[113382];v[113382]=0;if((e|0)!=1){break ea}}b=P()|0;O()|0;break X}b=P()|0;O()|0;break X}b=P()|0;O()|0;break X}v[113382]=0;Q(335,b+492|0,d+96|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break ba}yb(d+96|0);v[113382]=0;U(452,d+48|0,2,d+160|0);e=v[113382];v[113382]=0;if((e|0)==1){break aa}v[113382]=0;R(356,d+96|0,d+48|0);e=v[113382];v[113382]=0;if((e|0)==1){break aa}e=w[d+190|0]|w[d+191|0]<<8;v[113382]=0;Q(335,((((e<<8|e>>>8)&65535)<<5)+a|0)+946304|0,d+96|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break $}yb(d+96|0);v[b>>2]=0;e=w[d+206|0]|w[d+207|0]<<8;v[b+8>>2]=(e<<8|e>>>8)+128&65535;tc(b+8|0,256);t[b+15|0]=w[b+15|0]|1;b=w[d+190|0]|w[d+191|0]<<8;v[113382]=0;b=B((b<<8|b>>>8)&65535,104)+a|0;R(453,b+484380|0,0);e=v[113382];v[113382]=0;if((e|0)==1){break _}e=w[d+192|0]|w[d+193|0]<<8;v[113382]=0;u[d+96>>1]=e<<8|e>>>8;u[d+48>>1]=64;e=Q(438,d+96|0,d+48|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break Z}u[b+484410>>1]=x[e>>1]<<2;e=w[d+194|0]|w[d+195|0]<<8|(w[d+196|0]<<16|w[d+197|0]<<24);v[b+484404>>2]=e<<24|e<<8&16711680|(e>>>8&65280|e>>>24);if(!(w[d+202|0]|w[d+203|0]<<8|(w[d+204|0]<<16|w[d+205|0]<<24))|!(w[d+209|0]&3)){break da}e=w[d+198|0]|w[d+199|0]<<8|(w[d+200|0]<<16|w[d+201|0]<<24);g=e<<24|e<<8&16711680|(e>>>8&65280|e>>>24);v[b+484384>>2]=g;e=w[d+202|0]|w[d+203|0]<<8|(w[d+204|0]<<16|w[d+205|0]<<24);f=b+484414|0;u[f>>1]=x[f>>1]|2;v[b+484388>>2]=g+(e<<8&16711680|e<<24|(e>>>8&65280|e>>>24));if(!(w[d+209|0]&2)){break da}u[f>>1]=x[f>>1]|4}j=j+1|0;if(x[a+480192>>1]>=(j&65535)>>>0){continue}break}}v[113382]=0;U(435,d+144|0,d+296|0,1447382614);b=v[113382];v[113382]=0;if((b|0)==1){break Y}v[113382]=0;b=v[d+156>>2];v[d+32>>2]=v[d+152>>2];v[d+36>>2]=b;b=v[d+148>>2];v[d+24>>2]=v[d+144>>2];v[d+28>>2]=b;X(454,d+24|0,0,a|0,0);b=v[113382];v[113382]=0;if((b|0)==1){break Y}v[113382]=0;U(435,d+128|0,d+296|0,1346719318);b=v[113382];v[113382]=0;if((b|0)==1){break Y}v[113382]=0;b=v[d+140>>2];v[d+16>>2]=v[d+136>>2];v[d+20>>2]=b;b=v[d+132>>2];v[d+8>>2]=v[d+128>>2];v[d+12>>2]=b;X(454,d+8|0,1,a|0,w[d+332|0]>2|0);b=v[113382];v[113382]=0;if((b|0)==1){break Y}if(!x[a+480192>>1]){break ca}b=1;while(1){e=v[(((b&65535)<<2)+a|0)+900380>>2];if(!(!e|t[e+60|0]&1)){v[e>>2]=32767}b=b+1|0;if(x[a+480192>>1]>=(b&65535)>>>0){continue}break}}Bb(d+216|0);v[113382]=0;U(435,d+160|0,d+296|0,1346458708);b=v[113382];v[113382]=0;if((b|0)==1){break W}v[113382]=0;b=T(303,d+160|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break V}if(!b|!(c&1)){break K}v[113382]=0;U(435,d+216|0,d+296|0,1347305805);b=v[113382];v[113382]=0;if((b|0)==1){break U}v[113382]=0;Q(304,d+216|0,1)|0;b=v[113382];v[113382]=0;if((b|0)==1){break T}g=d+280|6;b=w[g|0]|w[g+1|0]<<8;j=0;v[113382]=0;k=a+484344|0;R(363,k|0,(b<<8|b>>>8)&65535);b=v[113382];v[113382]=0;if((b|0)==1){break T}b=jb-16|0;jb=b;e=d+112|0;v[e>>2]=0;v[e+4>>2]=0;v[113382]=0;v[b+12>>2]=0;W(483,e+8|0,b+12|0,b+8|0)|0;f=v[113382];v[113382]=0;ga:{if((f|0)!=1){jb=b+16|0;break ga}V(0)|0;O()|0;Ab();L()}if(w[g|0]|w[g+1|0]<<8){break S}b=0;break R}b=P()|0;O()|0;yb(d+96|0);break X}b=P()|0;O()|0;break X}b=P()|0;O()|0;yb(d+96|0);break X}b=P()|0;O()|0;break X}b=P()|0;O()|0;break X}b=P()|0;O()|0}Bb(d+216|0);break t}b=P()|0;O()|0;break t}b=P()|0;O()|0;break y}b=P()|0;O()|0;break y}b=P()|0;O()|0;break z}b=d+48|0;z=b|5;A=b|3;C=b|4;D=b|2;E=b|1;b=0;while(1){v[113382]=0;y=T(445,d+160|0)|0;f=v[113382];v[113382]=0;ha:{ia:{ja:{ka:{la:{if((f|0)!=1){v[113382]=0;f=T(455,d+160|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break la}v[113382]=0;U(307,d+96|0,d+160|0,f|0);f=v[113382];v[113382]=0;if((f|0)==1){break ka}v[113382]=0;f=W(364,k|0,j&65535,y|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break ja}if(!f){break ha}o=Xb(d+80|0);v[113382]=0;W(456,d+216|0,o|0,-1)|0;f=v[113382];v[113382]=0;if((f|0)!=1){f=Zb(k,j);v[113382]=0;Q(457,f|0,o|0)|0;f=v[113382];v[113382]=0;if((f|0)!=1){break ia}}break C}b=P()|0;O()|0;break A}b=P()|0;O()|0;break A}b=P()|0;O()|0;break A}b=P()|0;O()|0;break B}f=Zb(k,j);v[113382]=0;m=Q(458,f|0,0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break C}DA(e);n=0;ma:{while(1){v[113382]=0;f=Q(228,d+96|0,1)|0;h=v[113382];v[113382]=0;na:{oa:{pa:{if((h|0)!=1){if(!f){break ma}v[113382]=0;h=T(409,d+96|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break C}if(h){break oa}G=d,H=ac(e),v[G+72>>2]=H;G=d,H=bc(e),v[G+64>>2]=H;if(Jb(d+72|0,d- -64|0)){break pa}break na}break C}while(1){qa:{f=v[d+72>>2];h=Zb(k,j);m=w[f+1|0];f=w[f|0];v[113382]=0;f=W(459,d+48|0,f|0,m|0)|0;m=v[113382];v[113382]=0;if((m|0)==1){break qa}f=Me(f,n);v[113382]=0;Q(460,h|0,f|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break qa}f=d+72|0;re(f);if(Jb(f,d- -64|0)){continue}break na}break}break C}oh(d+48|0);r=x[a+480188>>1];v[113382]=0;f=T(409,d+96|0)|0;i=v[113382];v[113382]=0;ra:{sa:{if((i|0)!=1){s=h-1|0;ta:{if(!(f&1)){break ta}v[113382]=0;i=T(409,d+96|0)|0;l=v[113382];v[113382]=0;if((l|0)==1){break C}l=h>>>0>r>>>0?d+48|0:B(s,6)+m|0;if((i|0)!=31){if((i-1&255)>>>0>252){break ta}i=(B(i>>>4|0,12)+(i&15)|0)+13|0}else{i=255}t[l|0]=i}if(!(f&2)){break ra}v[113382]=0;i=T(409,d+96|0)|0;l=v[113382];v[113382]=0;if((l|0)!=1){break sa}}break C}t[(h>>>0>r>>>0?E:(B(s,6)+m|0)+1|0)|0]=i}if(!(f&60)){continue}t[d+47|0]=0;t[d+46|0]=0;t[d+45|0]=0;t[d+44|0]=0;if(f&4){v[113382]=0;i=T(409,d+96|0)|0;l=v[113382];v[113382]=0;if((l|0)==1){break C}t[d+46|0]=i}if(f&8){v[113382]=0;i=T(409,d+96|0)|0;l=v[113382];v[113382]=0;if((l|0)==1){break C}t[d+44|0]=i}if(f&16){v[113382]=0;i=T(409,d+96|0)|0;l=v[113382];v[113382]=0;if((l|0)==1){break C}t[d+47|0]=i}if(f&32){v[113382]=0;f=T(409,d+96|0)|0;i=v[113382];v[113382]=0;if((i|0)==1){break C}t[d+45|0]=f}CA(d+47|0,d+45|0);CA(d+46|0,d+44|0);f=w[d+46|0];if(!(w[d+47|0]==13|f?(f|0)!=13:0)){Rg(d+47|0,d+46|0);Rg(d+45|0,d+44|0)}v[113382]=0;fa(461,d- -64|0,d+47|0,d+45|0,d+46|0,d+44|0);f=v[113382];v[113382]=0;ua:{if((f|0)==1){break ua}v[113382]=0;f=Q(462,w[d+64|0],w[d+65|0])|0;i=v[113382];v[113382]=0;if((i|0)==1){break ua}va:{if(!f){break va}G=d,H=ac(e),v[G+72>>2]=H;Hd(d+40|0,d+72|0);v[113382]=0;W(463,e|0,v[d+40>>2],d- -64|0)|0;f=v[113382];v[113382]=0;if((f|0)!=1){break va}break C}f=B(s,6)+m|0;h=h>>>0>r>>>0;t[(h?D:f+2|0)|0]=w[d+47|0];t[(h?C:f+4|0)|0]=w[d+45|0];i=w[d+46|0];t[(h?A:f+3|0)|0]=i;t[(h?z:f+5|0)|0]=w[d+44|0];if((i|0)==40){F=1;continue}if((i|0)!=31){continue}b=1;continue}break C}DA(e);n=n+1|0;if(y>>>0<=n>>>0){break ma}f=Zb(k,j);v[113382]=0;m=Q(458,f|0,n|0)|0;f=v[113382];v[113382]=0;if((f|0)!=1){continue}break}break C}yb(o)}Bb(d+96|0);j=j+1|0;f=w[g|0]|w[g+1|0]<<8;if(j>>>0<((f<<8|f>>>8)&65535)>>>0){continue}break}}kT(e);j=b;Bb(d+216|0);if(!(c&4)){break I}e=0;if(!F){break J}f=x[a+480188>>1];if(!f){e=1;break J}b=0;while(1){e=1;g=(b<<5)+a|0;t[g+480288|0]=1;g=g+480280|0;v[g>>2]=v[g>>2]|67108864;b=b+1|0;if((f|0)!=(b|0)){continue}break}break J}b=P()|0;O()|0;break t}b=P()|0;O()|0;break b}j=0;e=0;if(!(c&4)){break H}}v[113382]=0;v[d+96>>2]=-1778364416;v[d+100>>2]=-16756736;U(435,d+216|0,d+296|0,1146310725);b=v[113382];v[113382]=0;wa:{xa:{ya:{za:{Aa:{Ba:{if((b|0)!=1){v[113382]=0;b=T(450,d+216|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break ya}if(!b){break Aa}v[113382]=0;g=T(445,d+216|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break ya}if(g){break Ba}f=e;break za}b=P()|0;O()|0;break y}b=0;f=e;while(1){v[113382]=0;k=T(409,d+216|0)|0;h=v[113382];v[113382]=0;Ca:{Da:{if((h|0)!=1){if(x[a+480188>>1]<=b>>>0){break Ca}if(!e){break Da}h=((b<<5)+a|0)+480280|0;v[h>>2]=v[h>>2]&-67108865|((k|0)!=0)<<26;break Ca}break ya}if(k){break Ca}f=1;t[((b<<5)+a|0)+480288|0]=1}b=b+1|0;if((g|0)!=(b|0)){continue}break}break za}Bb(d+216|0);if(!e){break I}break wa}v[113382]=0;Q(464,d+216|0,d+96|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){break xa}}b=P()|0;O()|0;Bb(d+216|0);break y}Bb(d+216|0);if(!(f&1)){break I}}v[113382]=0;Z(465,a+906300|0);b=v[113382];v[113382]=0;Ea:{Fa:{Ga:{Ha:{Ia:{Ja:{if((b|0)==1){break Ja}b=a+906316|0;v[b>>2]=810369604;v[b+4>>2]=1869112133;t[a+906324|0]=16;t[a+906325|0]=0;t[a+906326|0]=10;t[a+906327|0]=0;b=a+906328|0;t[b|0]=0;t[b+1|0]=0;t[b+2|0]=0;t[b+3|0]=0;v[113382]=0;v[d+216>>2]=0;b=a+906332|0;U(466,b|0,b+16|0,d+216|0);b=v[113382];v[113382]=0;if((b|0)==1){break Ia}v[113382]=0;e=Q(121,d+216|0,5536)|0;b=v[113382];v[113382]=0;if((b|0)==1){break Ha}v[113382]=0;Q(467,a+906348|0,e|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break Ga}yb(e);v[113382]=0;e=Q(121,d+216|0,5520)|0;b=v[113382];v[113382]=0;if((b|0)==1){break Fa}v[113382]=0;Q(468,a+906380|0,e|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break Ea}yb(e);v[113382]=0;b=a+906304|0;R(469,b|0,8);e=v[113382];v[113382]=0;if((e|0)==1){break Ja}iT(d+216|0,w[d+97|0],w[d+99|0],w[d+101|0],w[d+103|0]);e=v[d+220>>2];b=v[b>>2];f=v[d+216>>2];t[b|0]=f;t[b+1|0]=f>>>8;t[b+2|0]=f>>>16;t[b+3|0]=f>>>24;t[b+4|0]=e;t[b+5|0]=e>>>8;t[b+6|0]=e>>>16;t[b+7|0]=e>>>24;break I}b=P()|0;O()|0;break y}b=P()|0;O()|0;break y}b=P()|0;O()|0;break y}b=P()|0;O()|0;yb(e);break y}b=P()|0;O()|0;break y}b=P()|0;O()|0;yb(e);break y}if(!j){break H}b=0;Ka:{La:{Ma:{Na:{Oa:{Pa:{Qa:{Ra:{Sa:{Ta:{Ua:{Va:{Wa:{Xa:{Ya:{Za:{_a:{$a:{ab:{bb:{cb:{db:{eb:{while(1){fb:{v[113382]=0;v[d+80>>2]=B(b,127)>>>5;R(470,d+96|0,11600);e=v[113382];v[113382]=0;if((e|0)==1){break fb}v[113382]=0;R(471,d+48|0,d+80|0);e=v[113382];v[113382]=0;if((e|0)==1){break eb}v[113382]=0;U(472,d+216|0,d+96|0,d+48|0);e=v[113382];v[113382]=0;if((e|0)==1){break db}v[113382]=0;e=(b<<5)+a|0;R(473,d+112|0,e+902204|0);f=v[113382];v[113382]=0;if((f|0)==1){break cb}v[113382]=0;Q(431,d+112|0,d+216|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break cb}yb(d+216|0);yb(d+48|0);f=d+96|0;Ib(f);v[113382]=0;R(470,f|0,11582);f=v[113382];v[113382]=0;if((f|0)==1){break $a}v[113382]=0;R(471,d+48|0,d+80|0);f=v[113382];v[113382]=0;if((f|0)==1){break _a}v[113382]=0;U(472,d+216|0,d+96|0,d+48|0);f=v[113382];v[113382]=0;if((f|0)==1){break Za}v[113382]=0;R(473,d+112|0,e+903228|0);f=v[113382];v[113382]=0;if((f|0)==1){break Ya}v[113382]=0;Q(431,d+112|0,d+216|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break Ya}yb(d+216|0);yb(d+48|0);f=d+96|0;Ib(f);v[113382]=0;R(470,f|0,11564);f=v[113382];v[113382]=0;if((f|0)==1){break Va}v[113382]=0;R(471,d+48|0,d+80|0);f=v[113382];v[113382]=0;if((f|0)==1){break Ua}v[113382]=0;U(472,d+216|0,d+96|0,d+48|0);f=v[113382];v[113382]=0;if((f|0)==1){break Ta}v[113382]=0;R(473,d+112|0,e+904252|0);f=v[113382];v[113382]=0;if((f|0)==1){break Sa}v[113382]=0;Q(431,d+112|0,d+216|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break Sa}yb(d+216|0);yb(d+48|0);f=d+96|0;Ib(f);v[113382]=0;R(470,f|0,11555);f=v[113382];v[113382]=0;if((f|0)==1){break Pa}v[113382]=0;R(471,d+48|0,d+80|0);f=v[113382];v[113382]=0;if((f|0)==1){break Oa}v[113382]=0;U(472,d+216|0,d+96|0,d+48|0);f=v[113382];v[113382]=0;if((f|0)==1){break Na}v[113382]=0;R(473,d+112|0,e+905276|0);e=v[113382];v[113382]=0;if((e|0)==1){break Ma}v[113382]=0;Q(431,d+112|0,d+216|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break Ma}yb(d+216|0);yb(d+48|0);Ib(d+96|0);b=b+1|0;if((b|0)!=32){continue}break H}break}b=P()|0;O()|0;break y}b=P()|0;O()|0;break ab}b=P()|0;O()|0;break bb}b=P()|0;O()|0;yb(d+216|0)}yb(d+48|0)}Ib(d+96|0);break y}b=P()|0;O()|0;break y}b=P()|0;O()|0;break Wa}b=P()|0;O()|0;break Xa}b=P()|0;O()|0;yb(d+216|0)}yb(d+48|0)}Ib(d+96|0);break y}b=P()|0;O()|0;break y}b=P()|0;O()|0;break Qa}b=P()|0;O()|0;break Ra}b=P()|0;O()|0;yb(d+216|0)}yb(d+48|0)}Ib(d+96|0);break y}b=P()|0;O()|0;break y}b=P()|0;O()|0;break Ka}b=P()|0;O()|0;break La}b=P()|0;O()|0;yb(d+216|0)}yb(d+48|0)}Ib(d+96|0);break y}v[113382]=0;U(435,d+216|0,d+296|0,1397575756);b=v[113382];v[113382]=0;if((b|0)==1){break D}v[113382]=0;b=T(303,d+216|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break E}if(!(!x[a+480190>>1]|(!b|!(c&2)))){e=1;c=1;while(1){v[113382]=0;b=T(455,d+216|0)|0;f=v[113382];v[113382]=0;gb:{if((f|0)!=1){v[113382]=0;f=T(455,d+216|0)|0;j=v[113382];v[113382]=0;if((j|0)==1){break E}if(!(b&7)){break gb}e=(B(e,104)+a|0)+484380|0;v[e>>2]=f;b=Yc(d+96|0,b&4?32:b&2?16:8,1,1,0);v[113382]=0;W(362,b|0,e|0,d+216|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){break gb}break E}break E}c=c+1|0;e=c&65535;if(e>>>0<=x[a+480190>>1]){continue}break}}Bb(d+216|0);Bb(d+160|0);Bb(d+232|0);Bb(d+248|0)}AA(d+296|0);Bb(q)}jb=d+336|0;return p|0}b=P()|0;O()|0;Bb(d+216|0);break y}b=P()|0;O()|0;break y}b=P()|0;O()|0;yb(o)}Bb(d+96|0)}kT(e)}Bb(d+216|0)}Bb(d+160|0);break t}b=P()|0;O()|0;break t}b=P()|0;O()|0;break t}b=P()|0;O()|0;yb(d+216|0);break t}b=P()|0;O()|0}Bb(d+232|0);break q}b=P()|0;O()|0;break q}b=P()|0;O()|0}Bb(d+248|0);break b}b=P()|0;O()|0;break b}b=P()|0;O()|0;yb(d+216|0);break m}b=P()|0;O()|0}yb(d+232|0);break k}b=P()|0;O()|0}Ib(d+248|0);break i}b=P()|0;O()|0}yb(e);break b}b=P()|0;O()|0;break b}b=P()|0;O()|0;break b}b=P()|0;O()|0;break b}b=P()|0;O()|0;break b}b=P()|0;O()|0;break b}b=P()|0;O()|0}AA(d+296|0)}Bb(q);S(b|0);L()}function Eha(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,y=0;d=jb-320|0;jb=d;Ic(b);a:{if(!Ot(b,d+304|0)){break a}if(!pP(d+304|0)){break a}q=Nk(d+288|0,b);m=iz(d+272|0);b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{if(!c){v[113382]=0;X(915,d|0,q|0,1,1413891155);b=v[113382];v[113382]=0;if((b|0)==1){break r}break t}v[113382]=0;U(916,d|0,q|0,1);b=v[113382];v[113382]=0;if((b|0)==1){break s}}b=m;if(v[b>>2]){Cd(b);gP(b);xp(b);Ff(zb(b),v[b>>2],Ye(b));s=zb(b),y=0,v[s>>2]=y;v[b>>2]=0;v[b+4>>2]=0}Fl(m,d);v[m>>2]=v[d>>2];v[m+4>>2]=v[d+4>>2];b=v[zb(d)>>2];s=zb(m),y=b,v[s>>2]=y;s=zb(d),y=0,v[s>>2]=y;v[d>>2]=0;v[d+4>>2]=0;Hl(d);v[113382]=0;U(917,d|0,m|0,1413891155);b=v[113382];v[113382]=0;u:{v:{if((b|0)!=1){v[113382]=0;e=Q(918,d|0,10044)|0;b=v[113382];v[113382]=0;if((b|0)==1){break v}Bb(d);if(!e){break b}if(c){break u}break b}e=P()|0;O()|0;break c}e=P()|0;O()|0;Bb(d);break c}v[113382]=0;R(403,a|0,4194304);b=v[113382];v[113382]=0;if((b|0)==1){break d}v[a+480208>>2]=12;v[113382]=0;U(917,d+256|0,m|0,1280592212);b=v[113382];v[113382]=0;if((b|0)==1){break e}v[113382]=0;b=T(225,d+256|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break g}v[113382]=0;W(641,d+256|0,a+1304400|0,b|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break g}n=a+484360|0;Hn(Vb(n));b=jb-16|0;jb=b;k=d+240|0;e=k;v[e>>2]=0;v[e+4>>2]=0;v[113382]=0;v[b+12>>2]=0;W(938,e+8|0,b+12|0,b+8|0)|0;e=v[113382];v[113382]=0;w:{if((e|0)!=1){jb=b+16|0;break w}V(0)|0;O()|0;Ab();L()}v[113382]=0;t[d+239|0]=0;U(919,d+224|0,m|0,1196314451);b=v[113382];v[113382]=0;if((b|0)==1){break i}b=d+224|0;s=d,y=ac(b),v[s+216>>2]=y;s=d,y=bc(b),v[s+208>>2]=y;x:{y:{z:{A:{B:{C:{if(!Jb(d+216|0,d+208|0)){break C}j=d+12|0;f=d+24|0;o=d+44|0;D:{while(1){b=d+192|0;e=Nk(b,v[d+216>>2]);v[113382]=0;b=Q(920,b|0,d+176|0)|0;i=v[113382];v[113382]=0;E:{if((i|0)!=1){if(w[d+185|0]==1?b:0){break E}Bb(d+192|0);e=0;break B}e=P()|0;O()|0;break k}s=a,y=Ed(w[d+186|0],x[a+480188>>1],127),u[s+480188>>1]=y;v[113382]=0;l=T(921,d|0)|0;b=v[113382];v[113382]=0;F:{G:{H:{I:{J:{K:{if((b|0)!=1){v[113382]=0;U(922,d+160|0,1,d+176|0);b=v[113382];v[113382]=0;if((b|0)==1){break K}v[113382]=0;R(356,d+120|0,d+160|0);b=v[113382];v[113382]=0;if((b|0)==1){break K}v[113382]=0;R(923,d+152|0,o|0);b=v[113382];v[113382]=0;if((b|0)==1){break J}v[113382]=0;Q(431,d+152|0,d+120|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break J}yb(d+120|0);if(id(Vb(n))){break H}v[113382]=0;b=T(446,n|0)|0;i=v[113382];v[113382]=0;if((i|0)==1){break I}if((b|0)!=255){break H}b=2;break G}e=P()|0;O()|0;break k}e=P()|0;O()|0;break l}e=P()|0;O()|0;yb(d+120|0);break l}e=P()|0;O()|0;break l}b=Vb(n);v[113382]=0;U(6,d+120|0,4,o|0);i=v[113382];v[113382]=0;L:{M:{N:{O:{P:{if((i|0)!=1){v[113382]=0;R(447,b|0,d+120|0);b=v[113382];v[113382]=0;if((b|0)==1){break P}yb(d+120|0);v[113382]=0;U(916,d+160|0,e|0,1);b=v[113382];v[113382]=0;if((b|0)==1){break O}b=d+160|0;s=d,y=ac(b),v[s+144>>2]=y;s=d,y=bc(b),v[s+136>>2]=y;if(Jb(d+144|0,d+136|0)){break N}break M}e=P()|0;O()|0;break l}e=P()|0;O()|0;yb(d+120|0);break l}e=P()|0;O()|0;break l}while(1){Q:{e=v[d+144>>2];b=af(d+120|0,zb(e));i=w[e+4|0]|w[e+5|0]<<8|(w[e+6|0]<<16|w[e+7|0]<<24);v[d+152>>2]=w[e|0]|w[e+1|0]<<8|(w[e+2|0]<<16|w[e+3|0]<<24);v[d+156>>2]=i;R:{e=w[d+152|0]|w[d+153|0]<<8|(w[d+154|0]<<16|w[d+155|0]<<24);if((e|0)!=1212960847){if((e|0)!=1312903248){break R}e=0;if(!x[a+480188>>1]){break R}while(1){S:{v[113382]=0;i=Q(228,b|0,2)|0;h=v[113382];v[113382]=0;if((h|0)==1){break S}if(!i){break R}v[113382]=0;R(433,d+96|0,b|0);i=v[113382];v[113382]=0;T:{U:{V:{W:{if((i|0)!=1){i=d+96|0;h=Zc(i);switch(w[i|0]){case 4:break U;case 2:break V;case 0:break W;default:break T}}break Q}i=w[h|0];s=uc(d,e),y=i^128,t[s|0]=y;i=d+104|0;_d(i,f,e);ce(i,0);break T}s=uc(d,e),y=128,t[s|0]=y;i=d+104|0;_d(i,f,e);ce(i,1);break T}s=uc(d,e),y=128,t[s|0]=y;i=d+104|0;_d(i,f,e);ce(i,0)}e=e+1|0;if(e>>>0<x[a+480188>>1]){continue}break R}break}break Q}if(hz(d+152|0)>>>0<9){break R}h=0;v[113382]=0;Q(304,b|0,2)|0;e=v[113382];v[113382]=0;i=65535;if((e|0)==1){break Q}while(1){v[113382]=0;e=Q(228,b|0,1)|0;g=v[113382];v[113382]=0;X:{Y:{Z:{_:{$:{aa:{ba:{ca:{da:{if((g|0)!=1){if(!e){break R}v[113382]=0;e=T(409,b|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break Q}switch(e|0){case 0:break R;case 14:break Y;case 13:break Z;case 12:break $;case 8:break aa;case 7:break ba;case 4:break ca;case 1:break da;default:break _}}break Q}if(x[d+36>>1]==65535){e=Vb(n);v[113382]=0;e=T(507,e|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break Q}u[d+36>>1]=e}e=Vb(n);v[113382]=0;e=T(507,e|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break Q}v[113382]=0;u[d+38>>1]=e;e=Q(924,b|0,d+239|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break Q}ea:{fa:{switch(e-254|0){case 1:v[113382]=0;e=da(925)|0;g=v[113382];v[113382]=0;if((g|0)!=1){break ea}break Q;case 0:break fa;default:break ea}}v[113382]=0;e=da(926)|0;g=v[113382];v[113382]=0;if((g|0)==1){break Q}}g=Vb(n);v[113382]=0;R(756,g|0,e|0);e=v[113382];v[113382]=0;if((e|0)==1){break Q}i=(i&65535)==65535?h:i;break X}v[113382]=0;e=T(323,b|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break Q}if(e>>>0>=(i&65535)>>>0){u[d+40>>1]=e-i}Ne(Vb(n),x[d+40>>1]);break X}v[113382]=0;e=T(409,b|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break Q}t[d+43|0]=e;break X}v[113382]=0;e=T(409,b|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break Q}t[d+42|0]=e;break X}v[113382]=0;e=Q(881,b|0,d+104|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break Q}if(w[d+104|0]|!e|(w[d+106|0]|w[d+105|0]!=255)){break _}if(w[d+107|0]|w[d+108|0]!=1){break _}if(!w[d+109|0]){break X}}Bb(b);b=1;break L}v[113382]=0;R(770,d+112|0,b|0);e=v[113382];v[113382]=0;ga:{ha:{ia:{ja:{if((e|0)!=1){e=d+112|0;g=Zc(e);p=Cf(e);if(w[e|0]>=wc(d)>>>0){break X}switch(w[p|0]){case 4:break ha;case 2:break ia;case 0:break ja;default:break ga}}break Q}g=w[g|0];s=uc(d,w[e|0]),y=g^128,t[s|0]=y;g=d+104|0;_d(g,f,w[e|0]);ce(g,0);break ga}s=uc(d,w[e|0]),y=128,t[s|0]=y;g=d+104|0;_d(g,f,w[e|0]);ce(g,1);break ga}s=uc(d,w[e|0]),y=128,t[s|0]=y;g=d+104|0;_d(g,f,w[e|0]);ce(g,0)}ka:{if(r){break ka}r=0;if(!wk(k)){break X}if(w[uc(nP(k),w[e|0])|0]!=w[uc(d,w[e|0])|0]){break ka}g=d+104|0;_d(g,nP(k)+24|0,w[e|0]);g=Cb(g);p=d+96|0;_d(p,f,w[e|0]);if((Cb(p)|0)==(g|0)){break X}}r=1;break X}v[113382]=0;R(433,d+104|0,b|0);e=v[113382];v[113382]=0;if((e|0)==1){break Q}e=d+104|0;g=Zc(e);p=w[e|0];if(wc(j)>>>0<=p>>>0){break X}g=w[g|0];s=uc(j,w[e|0]),y=(g>>>2|0)+1|0,t[s|0]=y}h=h+1|0;continue}}Bb(b);b=d+144|0;Kk(b);if(Jb(b,d+136|0)){continue}break M}break}e=P()|0;O()|0;Bb(b);break F}b=0;if(x[d+36>>1]==65535|x[d+38>>1]==65535){break L}b=Vb(n);v[113382]=0;Z(927,b|0);b=v[113382];v[113382]=0;if((b|0)!=1){b=0;v[113382]=0;R(928,k|0,l|0);e=v[113382];v[113382]=0;if((e|0)!=1){break L}}e=P()|0;O()|0;break F}Hl(d+160|0)}gz(l);Bb(d+192|0);if(b){break D}b=d+216|0;Xf(b);if(Jb(b,d+208|0)){continue}break C}break}Hl(d+160|0);break l}e=0;if((b|0)!=2){break B}}e=0;v[113382]=0;R(449,n|0,0);b=v[113382];v[113382]=0;if((b|0)==1){break q}if(id(k)){break B}if(c&2){v[113382]=0;U(919,d+192|0,m|0,1347244868);b=v[113382];v[113382]=0;if((b|0)==1){break x}b=d+192|0;s=d,y=ac(b),v[s+176>>2]=y;s=d,y=bc(b),v[s+152>>2]=y;f=w[d+239|0];if(Jb(d+176|0,d+152|0)){e=a+480190|0;i=d+13|0;l=d+17|0;while(1){b=v[d+176>>2];la:{ma:{na:{oa:{pa:{if(!f){v[113382]=0;h=Q(929,b|0,d|0)|0;j=v[113382];v[113382]=0;if((j|0)==1){break pa}if(!h){break la}h=w[d+52|0]|w[d+53|0]<<8;u[d+104>>1]=h+1;if(h>>>0>3998){break na}v[113382]=0;h=Q(408,e|0,d+104|0)|0;j=v[113382];v[113382]=0;if((j|0)==1){break pa}u[a+480190>>1]=x[h>>1];v[113382]=0;R(930,d|0,(B(x[d+104>>1],104)+a|0)+484380|0);h=v[113382];v[113382]=0;if((h|0)==1){break pa}v[113382]=0;U(931,d+160|0,1,i|0);h=v[113382];v[113382]=0;qa:{ra:{if((h|0)==1){break ra}v[113382]=0;R(356,d+120|0,d+160|0);h=v[113382];v[113382]=0;if((h|0)==1){break ra}v[113382]=0;Q(335,((x[d+104>>1]<<5)+a|0)+946304|0,d+120|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break qa}yb(d+120|0);break na}e=P()|0;O()|0;break ma}e=P()|0;O()|0;yb(d+120|0);break ma}v[113382]=0;h=Q(932,b|0,d|0)|0;j=v[113382];v[113382]=0;if((j|0)==1){break oa}if(!h){break la}h=w[d+56|0]|w[d+57|0]<<8;u[d+104>>1]=h+1;if(h>>>0>3998){break na}v[113382]=0;h=Q(408,e|0,d+104|0)|0;j=v[113382];v[113382]=0;if((j|0)==1){break oa}u[a+480190>>1]=x[h>>1];v[113382]=0;R(933,d|0,(B(x[d+104>>1],104)+a|0)+484380|0);h=v[113382];v[113382]=0;if((h|0)==1){break oa}v[113382]=0;U(931,d+160|0,1,l|0);h=v[113382];v[113382]=0;sa:{ta:{if((h|0)==1){break ta}v[113382]=0;R(356,d+120|0,d+160|0);h=v[113382];v[113382]=0;if((h|0)==1){break ta}v[113382]=0;Q(335,((x[d+104>>1]<<5)+a|0)+946304|0,d+120|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break sa}yb(d+120|0);break na}e=P()|0;O()|0;break ma}e=P()|0;O()|0;yb(d+120|0);break ma}e=P()|0;O()|0;break ma}e=P()|0;O()|0;break ma}if((x[d+104>>1]-1&65535)>>>0>3998){break la}h=Yc(d,8,1,0,2);v[113382]=0;W(362,h|0,(B(x[d+104>>1],104)+a|0)+484380|0,b|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){break la}e=P()|0;O()|0}cd(d+192|0);break j}b=d+176|0;Xf(b);if(Jb(b,d+152|0)){continue}break}}cd(d+192|0)}b=0;s=a,y=w[Gl(k,0)+43|0],v[s+480196>>2]=y;s=a,y=B(w[Gl(k,0)+42|0],1e4),v[s+480204>>2]=y;Ne(Vb(n),x[Gl(k,0)+40>>1]);if(x[a+480188>>1]){while(1){v[113382]=0;e=(b<<5)+a|0;f=e+480280|0;Z(387,f|0);i=v[113382];v[113382]=0;if((i|0)==1){break y}s=e+480286|0,y=w[uc(Gl(k,0)+12|0,b)|0],u[s>>1]=y;s=e+480284|0,y=w[uc(Gl(k,0),b)|0],u[s>>1]=y;_d(d,Gl(k,0)+24|0,b);e=Cb(d);v[f>>2]=v[f>>2]&-257|(e?256:0);b=b+1|0;if(b>>>0<x[a+480188>>1]){continue}break}}ua:{if(w[d+239|0]){v[113382]=0;Q(2,d|0,13163)|0;b=v[113382];v[113382]=0;if((b|0)!=1){break ua}break m}v[113382]=0;Q(2,d|0,13036)|0;b=v[113382];v[113382]=0;if((b|0)==1){break m}}Gb(a+1304436|0,d);yb(d);v[113382]=0;b=Q(2,d|0,6225)|0;f=v[113382];v[113382]=0;e=1;if((f|0)==1){break z}Gb(a+1304448|0,b);yb(b);v[a+1304496>>2]=4;if(!(c&1)|!x[a+480188>>1]){break B}v[113382]=0;U(919,d+192|0,m|0,1146045008);b=v[113382];v[113382]=0;if((b|0)==1){break n}b=jd(d+192|0);v[113382]=0;h=a+484344|0;R(363,h|0,b&65535);b=v[113382];v[113382]=0;if((b|0)==1){break p}b=d+192|0;s=d,y=ac(b),v[s+120>>2]=y;s=d,y=bc(b),v[s+160>>2]=y;if(Jb(d+120|0,d+160|0)){while(1){l=v[d+120>>2];v[113382]=0;b=T(225,l|0)|0;c=v[113382];v[113382]=0;va:{wa:{xa:{if((c|0)==1){break xa}v[113382]=0;c=T(397,l|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break xa}if((b|0)!=(c|0)){break va}v[113382]=0;b=Q(934,l|0,8)|0;c=v[113382];v[113382]=0;if((c|0)==1){break xa}if(b){break wa}break va}e=P()|0;O()|0;break o}v[113382]=0;o=Q(924,l|0,d+239|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){v[113382]=0;j=T(323,l|0)|0;b=v[113382];v[113382]=0;ya:{if((b|0)==1){break ya}v[113382]=0;b=W(364,h|0,o|0,j|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break ya}if(!b|!j){break va}i=0;while(1){za:{b=Zb(h,o);v[113382]=0;c=Q(458,b|0,i|0)|0;b=v[113382];v[113382]=0;Aa:{Ba:{Ca:{if((b|0)!=1){v[113382]=0;b=T(323,l|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break Ca}if(b>>>0<3){break Aa}v[113382]=0;U(307,d|0,l|0,b-2|0);b=v[113382];v[113382]=0;if((b|0)!=1){break Ba}e=P()|0;O()|0;break o}e=P()|0;O()|0;break o}e=P()|0;O()|0;break o}while(1){v[113382]=0;b=Q(228,d|0,3)|0;e=v[113382];v[113382]=0;if((e|0)==1){break za}if(b){v[113382]=0;R(433,d+176|0,d|0);b=v[113382];v[113382]=0;Da:{Ea:{Fa:{Ga:{if((b|0)!=1){b=d+176|0;f=b;b=Zc(b);u[d+152>>1]=x[a+480188>>1]-1;b=w[b|0];v[113382]=0;u[d+104>>1]=b;b=Q(438,d+152|0,d+104|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break za}e=x[b>>1];b=t[f|0];if((b|0)>=0){break Da}v[113382]=0;b=T(409,d|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break za}if(w[d+239|0]){break Fa}if((b|0)!=255){break Ga}b=254;break Ea}break za}if(b>>>0>128){break Ea}b=(B(b>>>4|0,12)+(b&15)|0)+13|0;break Ea}b=b>>>0<85?b+36|0:b}t[c+B(e,6)|0]=b;b=w[f|0]}if(b&64){v[113382]=0;b=T(409,d|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break za}t[(c+B(e,6)|0)+1|0]=b+1;b=w[f|0]}if(b&32){v[113382]=0;b=T(409,d|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break za}t[d+152|0]=b;b=c+B(e,6)|0;t[b+2|0]=1;v[113382]=0;t[d+104|0]=127;g=Q(415,d+152|0,d+104|0)|0;p=v[113382];v[113382]=0;if((p|0)==1){break za}t[b+4|0]=w[g|0]+1>>>1;b=w[f|0]}if(!(b&16)){continue}v[113382]=0;R(433,d+152|0,d|0);b=v[113382];v[113382]=0;if((b|0)==1){break za}b=c+B(e,6)|0;g=d+152|0;f=w[Zc(g)|0];t[b+5|0]=f;Ha:{switch(w[g|0]-1|0){case 0:t[(c+B(e,6)|0)+3|0]=11;if(!w[d+239|0]){t[b+5|0]=f<<3|15;continue}t[b+5|0]=f<<4|15;continue;case 1:t[(c+B(e,6)|0)+3|0]=11;if(w[d+239|0]){t[b+5|0]=f<<4;continue}t[b+5|0]=f<<3&240;continue;case 2:t[(c+B(e,6)|0)+3|0]=11;if(w[d+239|0]){t[b+5|0]=f|240;continue}t[b+5|0]=f>>>1|240;continue;case 3:t[(c+B(e,6)|0)+3|0]=11;if(w[d+239|0]){t[b+5|0]=f&15;continue}if(f>>>0<=1){t[b+5|0]=f|240;continue}t[b+5|0]=f>>>1&15;continue;case 10:t[(c+B(e,6)|0)+3|0]=2;s=b,y=ft(f,w[d+239|0])|240,t[s+5|0]=y;continue;case 11:t[(c+B(e,6)|0)+3|0]=2;s=b,y=ft(f,w[d+239|0]),t[s+5|0]=y;continue;case 12:t[(c+B(e,6)|0)+3|0]=3;s=b,y=ft(f,w[d+239|0])|240,t[s+5|0]=y;continue;case 13:t[(c+B(e,6)|0)+3|0]=3;s=b,y=ft(f,w[d+239|0]),t[s+5|0]=y;continue;case 14:t[(c+B(e,6)|0)+3|0]=4;if(w[d+239|0]){continue}t[b+5|0]=(f&252)>>>2;continue;case 16:t[(c+B(e,6)|0)+3|0]=20;t[b+5|0]=f&1|16;continue;case 15:t[(c+B(e,6)|0)+3|0]=6;t[b+5|0]=f&240;continue;case 17:t[(c+B(e,6)|0)+3|0]=6;t[b+5|0]=(f&240)>>>4;continue;case 18:t[(c+B(e,6)|0)+3|0]=20;continue;case 20:t[(c+B(e,6)|0)+3|0]=5;continue;case 21:t[(c+B(e,6)|0)+3|0]=20;t[b+5|0]=f&15|48;continue;case 22:t[(c+B(e,6)|0)+3|0]=7;t[b+5|0]=f|240;continue;case 23:t[(c+B(e,6)|0)+3|0]=7;continue;case 30:t[(c+B(e,6)|0)+3|0]=8;continue;case 31:t[(c+B(e,6)|0)+3|0]=20;t[b+5|0]=f&15|64;continue;case 40:t[(c+B(e,6)|0)+3|0]=10;v[113382]=0;e=T(409,d|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break za}t[b+5|0]=e;v[113382]=0;Q(304,d|0,1)|0;b=v[113382];v[113382]=0;if((b|0)!=1){continue}break za;case 41:t[(c+B(e,6)|0)+3|0]=15;continue;case 42:t[(c+B(e,6)|0)+3|0]=20;t[b+5|0]=f&15|192;continue;case 43:t[(c+B(e,6)|0)+3|0]=20;t[b+5|0]=f&15|208;continue;case 50:t[(c+B(e,6)|0)+3|0]=12;t[b+5|0]=(f&254)>>>1;v[113382]=0;Q(304,d|0,1)|0;b=v[113382];v[113382]=0;if((b|0)!=1){continue}break za;case 51:t[(c+B(e,6)|0)+3|0]=14;t[b+5|0]=0;continue;case 52:t[(c+B(e,6)|0)+3|0]=20;t[b+5|0]=f&15|176;continue;case 53:t[(c+B(e,6)|0)+3|0]=20;t[b+5|0]=f&15|224;continue;case 60:t[(c+B(e,6)|0)+3|0]=16;continue;case 61:t[(c+B(e,6)|0)+3|0]=17;continue;case 70:t[(c+B(e,6)|0)+3|0]=1;continue;case 71:t[(c+B(e,6)|0)+3|0]=20;t[b+5|0]=f&15|32;continue;case 72:t[(c+B(e,6)|0)+3|0]=20;t[b+5|0]=f&15|128;continue;default:break Ha}}t[(c+B(e,6)|0)+3|0]=0;continue}break}Bb(d)}i=i+1|0;if((j|0)!=(i|0)){continue}break va}break}e=P()|0;O()|0;Bb(d);break o}e=P()|0;O()|0;break o}e=P()|0;O()|0;break o}b=d+120|0;Xf(b);if(Jb(b,d+160|0)){continue}break}}Ia:{if(wk(k)>>>0<2){break Ia}if(!wk(k)){break Ia}i=0;while(1){b=Di(n,i&255);c=Gl(k,i);e=x[rc(b,x[c+36>>1])>>1];v[113382]=0;e=Q(398,h|0,e|0)|0;f=v[113382];v[113382]=0;Ja:{Ka:{if((f|0)!=1){if(!e){break Ja}e=x[c+36>>1];v[113382]=0;e=Q(774,b|0,e|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){break Ka}}e=P()|0;O()|0;break o}if(!(!r|!x[a+480188>>1])){l=c+24|0;b=0;while(1){_d(d,l,b);j=Cb(d);f=Zb(h,e);La:{if(j){v[113382]=0;j=W(459,d|0,20,145)|0;o=v[113382];v[113382]=0;if((o|0)!=1){j=Rh(Bn(Me(j,0),b&65535));v[113382]=0;Q(460,f|0,j|0)|0;f=v[113382];v[113382]=0;if((f|0)!=1){break La}}e=P()|0;O()|0;break o}j=w[uc(c,b)|0];v[113382]=0;j=W(459,d|0,9,j|0)|0;o=v[113382];v[113382]=0;if((o|0)!=1){j=Rh(Bn(Me(j,0),b&65535));v[113382]=0;Q(460,f|0,j|0)|0;f=v[113382];v[113382]=0;if((f|0)!=1){break La}}e=P()|0;O()|0;break o}b=b+1|0;if(b>>>0<x[a+480188>>1]){continue}break}}b=Zb(h,e);f=w[c+43|0];v[113382]=0;f=W(459,d|0,16,f|0)|0;l=v[113382];v[113382]=0;if((l|0)==1){break A}f=Rh(Me(f,0));v[113382]=0;Q(460,b|0,f|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break A}b=Zb(h,e);c=w[c+42|0];v[113382]=0;c=W(459,d|0,17,c|0)|0;e=v[113382];v[113382]=0;if((e|0)!=1){c=Rh(Me(c,0));v[113382]=0;Q(460,b|0,c|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){break Ja}}e=P()|0;O()|0;break o}i=i+1|0;if(wk(k)>>>0>i>>>0){continue}break}}cd(d+192|0);e=1}cd(d+224|0);mP(k);Bb(d+256|0);break b}e=P()|0;O()|0;break o}e=P()|0;O()|0;break j}e=P()|0;O()|0;break j}e=P()|0;O()|0;break j}e=P()|0;O()|0;break c}e=P()|0;O()|0;break c}e=P()|0;O()|0;break j}e=P()|0;O()|0}cd(d+192|0);break j}e=P()|0;O()|0;break j}e=P()|0;O()|0;break j}gz(l)}Bb(d+192|0)}cd(d+224|0);break h}e=P()|0;O()|0}mP(k);break f}e=P()|0;O()|0}Bb(d+256|0);break c}e=P()|0;O()|0;break c}e=P()|0;O()|0}Hl(m);Bb(q);S(e|0);L()}Hl(m);Bb(q)}jb=d+320|0;return e|0}function Z0(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,A=0,E=C(0),F=0,G=0,I=0,J=0,K=C(0),M=0,N=0,O=0,P=0,Q=0,R=C(0);s=jb-1520|0;jb=s;f=s+8|0;g=Qb(f,0,1512);if(e){h=v[e+4>>2];v[g+80>>2]=v[e>>2];v[g+84>>2]=h;e=h&-8;v[g+92>>2]=e;v[g+84>>2]=e}v[g+96>>2]=0;v[g+100>>2]=0;v[g+1420>>2]=-1;v[g+124>>2]=0;v[g+32>>2]=0;t[s+56|0]=1;v[s+48>>2]=a+b;v[s+40>>2]=a;b=0;p=jb-1024|0;jb=p;t[f+1377|0]=1;a:{if(!Fr(f)){break a}e=w[f+1375|0];if(!(e&2)){cc(f,34);break a}if(e&4){cc(f,34);break a}if(e&1){cc(f,34);break a}if(v[f+1116>>2]!=1){cc(f,34);break a}e=w[f+1120|0];if((e|0)!=30){b:{if((e|0)!=64){break b}if(!Ew(f,p+1018|0,6)|w[p+1018|0]!=102|(w[p+1019|0]!=105|w[p+1020|0]!=115)){break b}if(w[p+1021|0]!=104|w[p+1022|0]!=101|w[p+1023|0]!=97){break b}if((xe(f)|0)!=100){break b}if(xe(f)){break b}cc(f,38);break a}cc(f,34);break a}if((xe(f)|0)!=1){cc(f,34);break a}if(!Ew(f,p+1018|0,6)){cc(f,10);break a}if(!Dw(p+1018|0)){cc(f,34);break a}if(ii(f)){cc(f,34);break a}e=xe(f);v[f+4>>2]=e;if(!e){cc(f,34);break a}if(e>>>0>=17){cc(f,5);break a}e=ii(f);v[f>>2]=e;if(!e){cc(f,34);break a}ii(f);ii(f);ii(f);e=xe(f);h=e>>>4|0;v[f+116>>2]=1<<h;g=e&15;v[f+112>>2]=1<<g;if(g-6>>>0>=8){cc(f,20);break a}if((e<<24)-1610612736>>24<0){cc(f,20);break a}if(g>>>0>h>>>0){cc(f,20);break a}if(!(xe(f)&1)){cc(f,34);break a}if(!Fr(f)){break a}if(!Cw(f)){break a}if(!Bw(f)){break a}c:{d:{if((Mg(f)|0)==3){while(1){P=(p+1018|0)+b|0,Q=Mg(f),t[P|0]=Q;b=b+1|0;if((b|0)!=6){continue}break}if(!Dw(p+1018|0)){cc(f,20);break c}g=Aw(f);e=Nd(f,g+1|0);v[f+20>>2]=e;if(e){b=0;if((g|0)>0){while(1){e=Mg(f);t[v[f+20>>2]+b|0]=e;b=b+1|0;if((g|0)!=(b|0)){continue}break}e=v[f+20>>2]}t[e+g|0]=0;b=Aw(f);v[f+28>>2]=0;v[f+24>>2]=b;e:{f:{if((b|0)<=0){break f}b=Nd(f,b<<2);v[f+28>>2]=b;if(!b){cc(f,3);break c}if(v[f+24>>2]<=0){break f}while(1){g=Aw(f);b=Nd(f,g+1|0);h=j<<2;v[h+v[f+28>>2]>>2]=b;e=v[h+v[f+28>>2]>>2];if(!e){break e}b=0;if((g|0)>0){while(1){e=Mg(f);t[v[h+v[f+28>>2]>>2]+b|0]=e;b=b+1|0;if((g|0)!=(b|0)){continue}break}e=v[h+v[f+28>>2]>>2]}t[e+g|0]=0;j=j+1|0;if((j|0)<v[f+24>>2]){continue}break}}if(!(Mg(f)&1)){cc(f,20);break c}GG(f,w[f+1376|0]);t[f+1376|0]=0;while(1){b=Bw(f);GG(f,b);t[f+1376|0]=0;if(b){continue}break}b=0;if(!Cw(f)){break a}if(!HG(f)){if(v[f+100>>2]!=21){break a}v[f+100>>2]=20;break a}e=0;while(1){g=e<<24;h=0;while(1){g=g>>31&79764919^g<<1;h=h+1|0;if((h|0)!=8){continue}break}v[(e<<2)+452176>>2]=g;e=e+1|0;if((e|0)!=256){continue}break}if((Mg(f)|0)==5){while(1){P=(p+1018|0)+b|0,Q=Mg(f),t[P|0]=Q;b=b+1|0;if((b|0)!=6){continue}break}if(!Dw(p+1018|0)){cc(f,20);break c}b=ic(f,8)+1|0;v[f+120>>2]=b;b=Nd(f,B(b,2096));v[f+124>>2]=b;if(!b){cc(f,3);break c}Qb(b,0,B(v[f+120>>2],2096));g:{h:{i:{if(v[f+120>>2]>0){while(1){b=v[f+124>>2];if((ic(f,8)&255)!=66){cc(f,20);break c}if((ic(f,8)&255)!=67){cc(f,20);break c}if((ic(f,8)&255)!=86){cc(f,20);break c}g=b+B(F,2096)|0;P=g,Q=ic(f,8)&255|ic(f,8)<<8,v[P>>2]=Q;P=g,Q=ic(f,8)&255|(ic(f,8)<<8&65280|ic(f,8)<<16),v[P+4>>2]=Q;b=0;o=g+4|0;h=ic(f,1);if(!h){b=ic(f,1)}t[g+23|0]=b;if(!(v[g>>2]|!v[o>>2])){cc(f,20);break c}e=v[o>>2];j:{if(b&255){e=Hm(f,e);break j}e=Nd(f,e);v[g+8>>2]=e}if(!e){cc(f,3);break c}k:{if(!h){b=0;i=0;j=v[o>>2];if((j|0)<=0){break k}while(1){l:{m:{if(w[g+23|0]){if(!ic(f,1)){break m}}h=ic(f,5)+1|0;t[b+e|0]=h;if((h&255)!=32){i=i+1|0;break l}cc(f,20);break c}t[b+e|0]=255}b=b+1|0;j=v[o>>2];if((b|0)<(j|0)){continue}break}break k}h=ic(f,5);i=0;b=0;j=v[o>>2];if((j|0)<=0){break k}while(1){m=ic(f,nl(j-b|0));h=h+1|0;if((h|0)>=32){cc(f,20);break c}j=b+m|0;if((j|0)>v[o>>2]){cc(f,20);break c}Qb(b+e|0,h,m);b=j;j=v[o>>2];if((b|0)<(j|0)){continue}break}}n:{o:{if(w[g+23|0]){if(j>>2>(i|0)){break o}b=g;h=f;if(v[f+16>>2]<(j|0)){v[f+16>>2]=j;j=v[o>>2]}m=b;b=Nd(h,j);v[m+8>>2]=b;if(!b){cc(f,3);break c}lc(b,e,v[o>>2]);hi(f,e,v[o>>2]);e=v[g+8>>2];t[g+23|0]=0}h=0;b=0;j=0;i=v[o>>2];if((i|0)>0){while(1){j=((w[b+e|0]-11&255)>>>0<244)+j|0;b=b+1|0;if((i|0)!=(b|0)){continue}break}}v[g+2092>>2]=j;b=Nd(f,i<<2);v[g+32>>2]=b;if(b){j=g+2092|0;break n}cc(f,3);break c}v[g+2092>>2]=i;j=g+2092|0;p:{if(!i){h=0;break p}b=Nd(f,i);v[g+8>>2]=b;if(!b){cc(f,3);break c}b=Hm(f,v[j>>2]<<2);v[g+32>>2]=b;if(!b){cc(f,3);break c}h=Hm(f,v[j>>2]<<2);if(h){break p}cc(f,3);break c}b=v[o>>2]+(v[j>>2]<<3)|0;if(b>>>0<=y[f+16>>2]){break n}v[f+16>>2]=b}m=g;l=e;n=v[o>>2];q=h;k=0;b=jb-128|0;jb=b;A=Qb(b,0,128);q:{r:{s:{t:{u:{v:{w:{x:{if((n|0)<=0){break x}while(1){if(w[l+k|0]!=255){break x}k=k+1|0;if((n|0)!=(k|0)){continue}break}break w}if((k|0)!=(n|0)){break v}}i=1;if(!v[m+2092>>2]){break u}ia(11882,9203,1103,3800);L()}b=l+k|0;i=w[b|0];if(i>>>0>=32){break t}xG(m,0,k,0,i,q);i=w[b|0];if(i){b=1;while(1){v[A+(b<<2)>>2]=1<<32-b;r=(b|0)==(i|0);b=b+1|0;if(!r){continue}break}}J=1;r=k+1|0;if((n|0)<=(r|0)){i=1;break u}while(1){M=l+r|0;k=w[M|0];y:{if((k|0)==255){break y}if(k>>>0>31){break s}i=0;b=k;if(!b){break u}while(1){N=A+(b<<2)|0;G=v[N>>2];if(!G){G=(b|0)>1;b=b-1|0;if(G){continue}break u}break}v[N>>2]=0;xG(m,ll(G),r,J,k,q);J=J+1|0;k=w[M|0];if(k>>>0<=b>>>0){break y}while(1){i=A+(k<<2)|0;if(v[i>>2]){break r}v[i>>2]=G+(1<<32-k);k=k-1|0;if((k|0)>(b|0)){continue}break}}i=1;r=r+1|0;if((n|0)!=(r|0)){continue}break}}jb=A+128|0;break q}ia(10963,9203,1104,3800);L()}ia(10956,9203,1118,3800);L()}ia(11926,9203,1133,3800);L()}if(!i){if(w[g+23|0]){hi(f,h,0)}cc(f,20);break c}b=v[j>>2];if(b){b=Nd(f,(b<<2)+4|0);v[g+2084>>2]=b;if(!b){cc(f,3);break c}b=Nd(f,(v[j>>2]<<2)+4|0);v[g+2088>>2]=b;if(!b){cc(f,3);break c}v[g+2088>>2]=b+4;v[b>>2]=-1;l=e;k=h;m=0;n=0;z:{b=g;if(w[b+23|0]){n=v[b+2092>>2];if((n|0)<=0){break z}while(1){i=m<<2;P=i+v[b+2084>>2]|0,Q=ll(v[i+v[b+32>>2]>>2]),v[P>>2]=Q;m=m+1|0;n=v[b+2092>>2];if((m|0)<(n|0)){continue}break}break z}if(v[b+4>>2]>0){while(1){if(wG(b,w[l+m|0])){P=v[b+2084>>2]+(n<<2)|0,Q=ll(v[v[b+32>>2]+(m<<2)>>2]),v[P>>2]=Q;n=n+1|0}m=m+1|0;if((m|0)<v[b+4>>2]){continue}break}}if(v[b+2092>>2]==(n|0)){break z}ia(3741,9203,1200,6075);L()}jG(v[b+2084>>2],n,2269);v[v[b+2084>>2]+(v[b+2092>>2]<<2)>>2]=-1;A:{n=w[b+23|0];G=v[b+(n?2092:4)>>2];if((G|0)<=0){break A}i=0;while(1){B:{m=i;q=b;if(n&255){m=v[k+(i<<2)>>2]}M=w[l+m|0];C:{if(!wG(q,M)){break C}N=i<<2;q=ll(v[N+v[b+32>>2]>>2]);A=v[b+2084>>2];m=0;n=v[b+2092>>2];if((n|0)>=2){while(1){r=n>>>1|0;O=r+m|0;J=q>>>0<y[A+(O<<2)>>2];m=J?m:O;n=J?r:n-r|0;if((n|0)>1){continue}break}}n=m<<2;if((q|0)!=v[n+A>>2]){break B}if(w[b+23|0]){v[n+v[b+2088>>2]>>2]=v[k+N>>2];t[v[b+8>>2]+m|0]=M;break C}v[n+v[b+2088>>2]>>2]=i}i=i+1|0;if((G|0)==(i|0)){break A}n=w[b+23|0];continue}break}ia(8219,9203,1230,6075);L()}}if(w[g+23|0]){hi(f,h,v[j>>2]<<2);hi(f,v[g+32>>2],v[j>>2]<<2);hi(f,e,v[o>>2]);v[g+32>>2]=0}b=g;Qb(b+36|0,255,2048);e=v[b+(w[b+23|0]?2092:4)>>2];if((e|0)>0){m=e>>>0<32767?e:32767;i=v[b+8>>2];e=0;while(1){D:{if(w[e+i|0]>10){break D}E:{if(w[b+23|0]){h=ll(v[v[b+2084>>2]+(e<<2)>>2]);break E}h=v[v[b+32>>2]+(e<<2)>>2]}if(h>>>0>1023){break D}while(1){u[(b+(h<<1)|0)+36>>1]=e;i=v[b+8>>2];h=(1<<w[i+e|0])+h|0;if(h>>>0<1024){continue}break}}e=e+1|0;if((m|0)!=(e|0)){continue}break}}b=ic(f,4);t[g+21|0]=b;b=b&255;if(b>>>0>=3){cc(f,20);break c}if(b){P=g,R=FG(ic(f,32)),z[P+12>>2]=R;P=g,R=FG(ic(f,32)),z[P+16>>2]=R;P=g,Q=ic(f,4)+1|0,t[P+20|0]=Q;P=g,Q=ic(f,1),t[P+22|0]=Q;h=v[g>>2];i=v[o>>2];F:{if(w[g+21|0]==1){I=H(xw(+C(C(Bo(+C(i|0)))/C(h|0))));G:{if(D(I)<2147483648){b=~~I;break G}b=-2147483648}e=b;I=H(rw(+C(C(b|0)+C(1)),h));H:{if(D(I)<2147483648){b=~~I;break H}b=-2147483648}b=e+((b|0)<=(i|0))|0;E=C(b|0);if(rw(+C(E+C(1)),h)<=+(i|0)){b=-1}else{I=H(rw(+E,h));I:{if(D(I)<2147483648){e=~~I;break I}e=-2147483648}b=(e|0)>(i|0)?-1:b}if((b|0)>=0){break F}cc(f,20);break c}b=B(h,i)}v[g+24>>2]=b;if(!b){cc(f,20);break c}e=Hm(f,b<<1);if(!e){break i}b=0;h=v[g+24>>2];if((h|0)>0){while(1){h=ic(f,w[g+20|0]);if((h|0)==-1){hi(f,e,v[g+24>>2]<<1);cc(f,20);break c}u[e+(b<<1)>>1]=h;b=b+1|0;h=v[g+24>>2];if((b|0)<(h|0)){continue}break}}J:{if(w[g+21|0]==1){i=w[g+23|0];K:{if(i){b=v[j>>2];if(b){break K}break J}b=v[o>>2]}b=Nd(f,B(v[g>>2],b)<<2);v[g+28>>2]=b;if(!b){hi(f,e,v[g+24>>2]<<1);cc(f,3);break c}q=v[(i?j:o)>>2];if((q|0)>0){o=g+2088|0;E=C(0);m=0;while(1){j=m;j=i?v[v[o>>2]+(j<<2)>>2]:j;b=1;k=0;L:{h=v[g>>2];if((h|0)<=0){break L}while(1){K=C(C(z[g+12>>2]+E)+C(z[g+16>>2]*C(x[e+(((j>>>0)/(b>>>0)>>>0)%y[g+24>>2]<<1)>>1])));z[v[g+28>>2]+(B(h,m)+k<<2)>>2]=K;E=w[g+22|0]?K:E;h=v[g>>2];k=k+1|0;if((h|0)<=(k|0)){break L}l=v[g+24>>2];qma(l,0,b,0);if(mb){hi(f,e,l<<1);cc(f,20);break c}else{b=B(b,l);continue}}}m=m+1|0;if((q|0)!=(m|0)){continue}break}}t[g+21|0]=2;h=v[g+24>>2];break J}b=Nd(f,h<<2);v[g+28>>2]=b;h=v[g+24>>2];if(!b){break h}if((h|0)<=0){break J}E=C(z[g+12>>2]+C(z[g+16>>2]*C(x[e>>1])));z[b>>2]=E;b=1;h=v[g+24>>2];if((h|0)<=1){break J}K=C(0);while(1){K=w[g+22|0]?E:K;E=C(C(z[g+12>>2]+K)+C(z[g+16>>2]*C(x[e+(b<<1)>>1])));z[v[g+28>>2]+(b<<2)>>2]=E;b=b+1|0;h=v[g+24>>2];if((b|0)<(h|0)){continue}break}}hi(f,e,h<<1)}F=F+1|0;if((F|0)<v[f+120>>2]){continue}break}}M:{e=ic(f,6)+1&255;if(!e){break M}b=0;while(1){if(!ic(f,16)){b=b+1|0;if((e|0)!=(b|0)){continue}break M}break}cc(f,20);break c}b=ic(f,6)+1|0;v[f+128>>2]=b;b=Nd(f,B(b,1596));v[f+260>>2]=b;if(!b){break g}m=0;if(v[f+128>>2]<=0){break d}F=0;N:while(1){b=ic(f,16);u[((m<<1)+f|0)+132>>1]=b;b=b&65535;if(b>>>0>=2){cc(f,20);break c}if(!b){e=v[f+260>>2]+B(m,1596)|0;P=e,Q=ic(f,8),t[P|0]=Q;P=e,Q=ic(f,16),u[P+2>>1]=Q;P=e,Q=ic(f,16),u[P+4>>1]=Q;P=e,Q=ic(f,6),t[P+6|0]=Q;P=e,Q=ic(f,8),t[P+7|0]=Q;b=(ic(f,4)&255)+1|0;t[e+8|0]=b;if((b|0)==(b&255)){g=e+9|0;b=0;while(1){P=b+g|0,Q=ic(f,8),t[P|0]=Q;b=b+1|0;if(b>>>0<w[e+8|0]){continue}break}}cc(f,4);break c}l=v[f+260>>2]+B(m,1596)|0;g=ic(f,5);t[l|0]=g;b=-1;j=0;e=0;if(g&255){while(1){g=ic(f,4);t[(e+l|0)+1|0]=g;g=g&255;b=(b|0)<(g|0)?g:b;e=e+1|0;if(e>>>0<w[l|0]){continue}break}while(1){g=j+l|0;P=g,Q=ic(f,3)+1|0,t[P+33|0]=Q;e=ic(f,2);t[g+49|0]=e;O:{if(e&255){e=ic(f,8);t[g+65|0]=e;if(v[f+120>>2]<=(e&255)){cc(f,20);break c}if(w[g+49|0]==31){break O}}e=0;while(1){P:{h=ic(f,8)-1|0;u[((l+(j<<4)|0)+(e<<1)|0)+82>>1]=h;if(v[f+120>>2]<=h<<16>>16){break P}e=e+1|0;if((e|0)<1<<w[g+49|0]){continue}break O}break}cc(f,20);break c}e=(b|0)!=(j|0);j=j+1|0;if(e){continue}break}}k=2;P=l,Q=ic(f,2)+1|0,t[P+1588|0]=Q;b=ic(f,4);v[l+1592>>2]=2;h=0;u[l+338>>1]=0;t[l+1589|0]=b;u[l+340>>1]=1<<b;j=l+1592|0;i=w[l|0];Q:{if(i){b=l+1589|0;while(1){e=0;g=l+w[(h+l|0)+1|0]|0;if(w[g+33|0]){while(1){i=ic(f,w[b|0]);u[(l+(v[j>>2]<<1)|0)+338>>1]=i;k=v[j>>2]+1|0;v[j>>2]=k;e=e+1|0;if(e>>>0<w[g+33|0]){continue}break}i=w[l|0]}h=h+1|0;if(h>>>0<(i&255)>>>0){continue}break}if((k|0)<=0){break Q}}e=0;while(1){b=x[(l+(e<<1)|0)+338>>1];g=(p+16|0)+(e<<2)|0;u[g+2>>1]=e;u[g>>1]=b;e=e+1|0;k=v[j>>2];if((e|0)<(k|0)){continue}break}}h=l+338|0;jG(p+16|0,k,2268);e=0;k=v[j>>2];b=k-1|0;b=(b|0)>0?b:0;while(1){if((b|0)==(e|0)){e=0;R:{if((k|0)<=0){break R}while(1){t[(e+l|0)+838|0]=w[((p+16|0)+(e<<2)|0)+2|0];e=e+1|0;k=v[j>>2];if((e|0)<(k|0)){continue}break}e=2;if((k|0)<=2){break R}while(1){v[p+12>>2]=0;v[p+8>>2]=0;b=h;i=0;g=e;if((g|0)>0){q=b+(g<<1)|0;n=-1;o=65536;while(1){A=b+(i<<1)|0;k=x[A>>1];if(!((n|0)>=(k|0)|x[q>>1]<=k>>>0)){v[p+12>>2]=i;k=x[A>>1];n=k}if(!((k|0)>=(o|0)|x[q>>1]>=k>>>0)){v[p+8>>2]=i;o=x[A>>1]}i=i+1|0;if((g|0)!=(i|0)){continue}break}}b=l+(e<<1)|0;t[b+1088|0]=v[p+12>>2];t[b+1089|0]=v[p+8>>2];e=e+1|0;k=v[j>>2];if((e|0)<(k|0)){continue}break}}F=(k|0)>(F|0)?k:F;m=m+1|0;if((m|0)<v[f+128>>2]){continue N}m=F<<1;break d}g=p+16|0;q=x[g+(e<<2)>>1];e=e+1|0;if((q|0)!=x[g+(e<<2)>>1]){continue}break}break}cc(f,20);break c}cc(f,3);break c}hi(f,e,h<<1);cc(f,3);break c}cc(f,3);break c}cc(f,20);break c}cc(f,3);break c}cc(f,3);break c}cc(f,20);break c}b=ic(f,6)+1|0;v[f+264>>2]=b;b=Nd(f,B(b,24));v[f+396>>2]=b;if(!b){cc(f,3);break c}j=0;Qb(b,0,B(v[f+264>>2],24));S:{if(v[f+264>>2]>0){while(1){b=v[f+396>>2];e=ic(f,16);u[((j<<1)+f|0)+268>>1]=e;if((e&65535)>>>0>=3){cc(f,20);break c}l=b+B(j,24)|0;P=l,Q=ic(f,24),v[P>>2]=Q;b=ic(f,24);v[l+4>>2]=b;if(b>>>0<y[l>>2]){cc(f,20);break c}P=l,Q=ic(f,24)+1|0,v[P+8>>2]=Q;P=l,Q=ic(f,6)+1|0,t[P+12|0]=Q;b=ic(f,8);t[l+13|0]=b;T:{U:{if(v[f+120>>2]>(b&255)){b=0;if(w[l+12|0]){break U}e=0;break T}cc(f,20);break c}while(1){g=(p+16|0)+b|0;e=ic(f,3);if(ic(f,1)){h=ic(f,5)}else{h=0}t[g|0]=e+(h<<3);b=b+1|0;e=w[l+12|0];if(b>>>0<e>>>0){continue}break}}b=Nd(f,e<<4);v[l+20>>2]=b;if(!b){break S}if(w[l+12|0]){h=0;while(1){e=w[(p+16|0)+h|0];b=0;while(1){V:{if(e>>>b&1){g=ic(f,8);k=b<<1;i=h<<4;u[k+(i+v[l+20>>2]|0)>>1]=g;if(v[f+120>>2]>u[k+(i+v[l+20>>2]|0)>>1]){break V}cc(f,20);break c}u[(v[l+20>>2]+(h<<4)|0)+(b<<1)>>1]=65535}b=b+1|0;if((b|0)!=8){continue}break}h=h+1|0;if(h>>>0<w[l+12|0]){continue}break}}b=Nd(f,v[(v[f+124>>2]+B(w[l+13|0],2096)|0)+4>>2]<<2);v[l+16>>2]=b;if(!b){cc(f,3);break c}i=0;Qb(b,0,v[(v[f+124>>2]+B(w[l+13|0],2096)|0)+4>>2]<<2);b=v[f+124>>2];e=w[l+13|0];if(v[(b+B(e,2096)|0)+4>>2]>0){while(1){g=v[B(e,2096)+b>>2];b=Nd(f,g);h=i<<2;v[h+v[l+16>>2]>>2]=b;W:{e=v[h+v[l+16>>2]>>2];if(e){if((g|0)<=0){break W}b=g-1|0;t[e+b|0]=(i>>>0)%w[l+12|0];e=i;if((g|0)==1){break W}while(1){g=b-1|0;k=w[l+12|0];e=(e|0)/(k|0)|0;t[g+v[h+v[l+16>>2]>>2]|0]=(e|0)%(k|0);k=(b|0)>1;b=g;if(k){continue}break}break W}cc(f,3);break c}i=i+1|0;b=v[f+124>>2];e=w[l+13|0];if((i|0)<v[(b+B(e,2096)|0)+4>>2]){continue}break}}j=j+1|0;if((j|0)<v[f+264>>2]){continue}break}}b=ic(f,6)+1|0;v[f+400>>2]=b;b=Nd(f,B(b,40));v[f+404>>2]=b;if(!b){cc(f,3);break c}h=0;Qb(b,0,B(v[f+400>>2],40));if(v[f+400>>2]>0){while(1){b=v[f+404>>2];if(ic(f,16)){cc(f,20);break c}g=b+B(h,40)|0;b=Nd(f,B(v[f+4>>2],3));v[g+4>>2]=b;if(!b){cc(f,3);break c}b=g;if(ic(f,1)){e=ic(f,4)+1|0}else{e=1}t[b+8|0]=e;X:{if(ic(f,1)){b=ic(f,8)+1|0;u[g>>1]=b;Y:{e=v[f+4>>2];b=b&65535;if((e|0)>=(b|0)){i=0;if(b){break Y}break X}cc(f,20);break c}while(1){e=ic(f,nl(e-1|0));b=B(i,3);t[b+v[g+4>>2]|0]=e;e=ic(f,nl(v[f+4>>2]-1|0));t[(b+v[g+4>>2]|0)+1|0]=e;e=v[f+4>>2];b=b+v[g+4>>2]|0;j=w[b|0];if((e|0)<=(j|0)){cc(f,20);break c}b=w[b+1|0];if((b|0)>=(e|0)){cc(f,20);break c}if((b|0)!=(j|0)){i=i+1|0;if(i>>>0>=x[g>>1]){break X}continue}break}cc(f,20);break c}u[g>>1]=0}if(ic(f,2)){cc(f,20);break c}j=v[f+4>>2];Z:{_:{b=w[g+8|0];if(b>>>0<=1){e=0;if((j|0)>0){while(1){t[(v[g+4>>2]+B(e,3)|0)+2|0]=0;e=e+1|0;if((e|0)<v[f+4>>2]){continue}break}b=w[g+8|0]}if(!(b&255)){break Z}break _}e=0;if((j|0)<=0){break _}while(1){$:{b=ic(f,4);j=B(e,3);t[(j+v[g+4>>2]|0)+2|0]=b;if(w[(j+v[g+4>>2]|0)+2|0]>=w[g+8|0]){break $}e=e+1|0;if((e|0)<v[f+4>>2]){continue}break _}break}cc(f,20);break c}b=0;while(1){ic(f,8);j=b+g|0;e=j;P=e,Q=ic(f,8),t[P+9|0]=Q;j=ic(f,8);t[e+24|0]=j;if(v[f+128>>2]<=w[e+9|0]){cc(f,20);break c}if(v[f+264>>2]>(j&255)){b=b+1|0;if(b>>>0>=w[g+8|0]){break Z}continue}break}cc(f,20);break c}h=h+1|0;if((h|0)<v[f+400>>2]){continue}break}}b=ic(f,6);v[f+408>>2]=b+1;aa:{if(b>>>0>=2147483647){break aa}e=0;while(1){b=B(e,6)+f|0;P=b,Q=ic(f,1),t[P+412|0]=Q;P=b,Q=ic(f,16),u[P+414>>1]=Q;P=b,Q=ic(f,16),u[P+416>>1]=Q;g=ic(f,8);t[b+413|0]=g;if(x[b+414>>1]){cc(f,20);break c}if(x[b+416>>1]){cc(f,20);break c}if(v[f+400>>2]>(g&255)){e=e+1|0;if((e|0)>=v[f+408>>2]){break aa}continue}break}cc(f,20);break c}EG(f);b=0;v[f+992>>2]=0;if(v[f+4>>2]>0){while(1){e=(b<<2)+f|0;P=e,Q=Nd(f,v[f+116>>2]<<2),v[P+800>>2]=Q;P=e,Q=Nd(f,v[f+116>>2]<<1&2147483646),v[P+928>>2]=Q;g=Nd(f,m);v[e+996>>2]=g;h=v[e+800>>2];if(g?!h|!v[e+928>>2]:1){cc(f,3);break c}Qb(h,0,v[f+116>>2]<<2);b=b+1|0;if((b|0)<v[f+4>>2]){continue}break}}b=0;if(!DG(f,0,v[f+112>>2])){break a}if(!DG(f,1,v[f+116>>2])){break a}v[f+104>>2]=v[f+112>>2];h=v[f+116>>2];v[f+108>>2]=h;g=(h|0)/2|0;n=f;j=h<<1&2147483646;m=j;l=v[f+264>>2];if((l|0)<=0){e=4}else{q=v[f+396>>2];k=0;i=0;while(1){h=q+B(i,24)|0;o=v[h+4>>2];e=g>>>0>o>>>0?o:g;o=v[h>>2];h=(e-(g>>>0>o>>>0?o:g)>>>0)/y[h+8>>2]|0;k=(h|0)>(k|0)?h:k;i=i+1|0;if((l|0)!=(i|0)){continue}break}e=(k<<2)+4|0}e=B(e,v[f+4>>2]);e=e>>>0<j>>>0?m:e;v[n+12>>2]=e;ba:{ca:{if(!v[f+80>>2]){break ca}g=v[f+92>>2];if((g|0)!=v[f+84>>2]){break ba}if(g>>>0>=(e+v[f+88>>2]|0)+1512>>>0){break ca}cc(f,3);break a}if(v[f+1380>>2]==-1){v[f+52>>2]=w[f+48|0]?0:v[f+32>>2]-v[f+36>>2]|0;b=1;break a}v[f+52>>2]=0;b=1;break a}ia(3568,9203,4196,5003);L()}cc(f,3)}b=0}jb=p+1024|0;da:{ea:{if(!b){v[d>>2]=v[s+104>>2]?1:v[s+108>>2];break ea}b=Nd(s+8|0,1512);if(b){P=c,Q=v[lc(b,s+8|0,1512)+32>>2]-a|0,v[P>>2]=Q;v[d>>2]=0;break da}}IG(s+8|0);b=0}jb=s+1520|0;return b|0}function sla(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,z=0,A=0,C=0,D=0,E=0,F=0;e=jb-288|0;jb=e;Ic(b);g=jb-16|0;jb=g;h=g+8|0;l=e+264|0;Lt(h,l);f=b;j=Hb(h);h=mc(b,$b(g,h));if((j|0)==(h|0)){_b(f,Hb(g+8|0))}jb=g+16|0;f=(h|0)==(j|0);if(!f){uS(l)}a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{if(!f){break u}if(!yS(e+264|0)){break u}if(!c){d=1;break u}Id(a,1024);vi(a);v[a+480208>>2]=v[a+480208>>2]|12;ig(a+1074312|0,21);if(w[e+280|0]|w[e+281|0]<<8){d=w[e+280|0]|w[e+281|0]<<8;v[a+480204>>2]=B((d<<8|d>>>8)&65535,1e4)}if(w[e+278|0]|w[e+279|0]<<8){d=w[e+278|0]|w[e+279|0]<<8;v[a+480196>>2]=(d<<8|d>>>8)&65535}if(!w[e+274|0]){mj(a,1)}d=e+264|4;d=w[d|0]|w[d+1|0]<<8|(w[d+2|0]<<16|w[d+3|0]<<24);bu(b,a+1304400|0,(d<<24|d<<8&16711680|(d>>>8&65280|d>>>24))-14|0);b=Nk(e+160|0,b);v[113382]=0;U(542,e+248|0,b|0,1);d=v[113382];v[113382]=0;v:{w:{x:{y:{z:{A:{B:{C:{D:{E:{F:{G:{H:{I:{J:{K:{L:{M:{if((d|0)!=1){Bb(b);v[113382]=0;U(543,e+160|0,e+248|0,1395544366);b=v[113382];v[113382]=0;if((b|0)==1){break E}v[113382]=0;b=T(450,e+160|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break L}if(!b){break F}v[113382]=0;b=T(445,e+160|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break L}v[113382]=0;d=T(445,e+160|0)|0;f=v[113382];v[113382]=0;N:{if((f|0)==1){break N}v[113382]=0;Q(304,e+160|0,4)|0;f=v[113382];v[113382]=0;if((f|0)==1){break N}f=a+484360|0;g=Vb(f);v[113382]=0;ea(544,g|0,e+160|0,b|0,65535,65535)|0;b=v[113382];v[113382]=0;if((b|0)!=1){break M}}break L}d=P()|0;O()|0;Bb(b);break a}Ne(Vb(f),d);b=e+160|0;Bb(b);v[113382]=0;U(543,b|0,e+248|0,1346458708);b=v[113382];v[113382]=0;if((b|0)==1){break K}v[113382]=0;b=T(450,e+160|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break J}if(!b){break H}v[113382]=0;b=T(445,e+160|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break J}u[a+480188>>1]=b;if((b-1&65535)>>>0>31){break H}v[113382]=0;b=T(445,e+160|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break J}v[113382]=0;o=a+484344|0;R(363,o|0,b|0);b=v[113382];v[113382]=0;if((b|0)==1){break J}v[113382]=0;l=T(455,e+160|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break J}switch(l-841887796|0){case 0:case 2:break G;case 1:break H;default:break I}}d=P()|0;O()|0;Bb(e+160|0);break b}d=P()|0;O()|0;break b}d=P()|0;O()|0;Bb(e+160|0);break b}if(!l){break G}}Bb(e+160|0);break A}Bb(e+160|0);v[113382]=0;U(543,e+232|0,e+248|0,1398157625);b=v[113382];v[113382]=0;if((b|0)==1){break D}v[113382]=0;b=T(450,e+232|0)|0;d=v[113382];v[113382]=0;O:{if((d|0)==1){break O}if(!b){break B}v[113382]=0;Q(304,e+232|0,2)|0;b=v[113382];v[113382]=0;if((b|0)==1){break O}v[113382]=0;d=T(455,e+232|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break c}b=a;f=b;q=(+(d>>>0)*2.3283064365386963e-10+ +(y[b+480204>>2]/1e4>>>0))*1e4;P:{if(q<4294967296&q>=0){b=~~q>>>0;break P}b=0}v[f+480204>>2]=b;v[113382]=0;Q(545,e+232|0,e+160|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break c}b=0;while(1){if(x[a+480188>>1]<=b>>>0){break C}d=(e+160|0)+(b<<1)|0;d=w[d|0]|w[d+1|0]<<8;v[113382]=0;v[e+96>>2]=(d<<8|d>>>8)&65535;v[e+80>>2]=180;d=Q(420,e+96|0,e+80|0)|0;f=v[113382];v[113382]=0;Q:{if((f|0)==1){break Q}d=v[d>>2];v[113382]=0;d=d-90|0;f=d>>31;d=qg(416,rma(d<<7|45,f<<7|d>>>25,90,0),mb);f=v[113382];v[113382]=0;if((f|0)==1){break Q}u[((b<<5)+a|0)+480284>>1]=d+128;b=b+1|0;if((b|0)!=32){continue}break C}break}break c}break c}Bb(e+160|0);break A}d=P()|0;O()|0;break b}d=P()|0;O()|0;break b}v[113382]=0;Q(304,e+232|0,16)|0;b=v[113382];v[113382]=0;if((b|0)==1){break c}v[113382]=0;b=Q(228,e+232|0,2)|0;d=v[113382];v[113382]=0;if((d|0)==1){break c}if(b){v[113382]=0;b=T(445,e+232|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break c}v[113382]=0;u[e+96>>1]=b;u[e+80>>1]=256;b=Q(438,e+96|0,e+80|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break c}v[a+480200>>2]=x[b>>1]}v[113382]=0;Q(304,e+232|0,128)|0;b=v[113382];v[113382]=0;if((b|0)==1){break c}v[113382]=0;b=Q(545,e+232|0,e+96|0)|0;d=v[113382];v[113382]=0;R:{if((d|0)!=1){if(!b){break B}b=0;while(1){if(x[a+480188>>1]<=b>>>0){break R}d=(e+96|0)+(b<<1)|0;d=w[d|0]|w[d+1|0]<<8;v[113382]=0;v[e+80>>2]=(d<<8|d>>>8)&65535;v[e+56>>2]=128;d=Q(420,e+80|0,e+56|0)|0;f=v[113382];v[113382]=0;if((f|0)!=1){u[((b<<5)+a|0)+480286>>1]=v[d>>2]/2&255;b=b+1|0;if((b|0)!=32){continue}break R}break}break c}break c}v[a+480228>>2]=v[a+480228>>2]<<1}Bb(e+232|0);v[113382]=0;U(543,e+160|0,e+248|0,1413830740);b=v[113382];v[113382]=0;S:{T:{if((b|0)!=1){v[113382]=0;b=T(450,e+160|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break d}if(!b){break S}v[113382]=0;Q(546,e+160|0,e+96|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break d}if((w[e+106|0]|w[e+107|0]<<8)!=65535){break T}v[113382]=0;Q(304,e+160|0,1)|0;b=v[113382];v[113382]=0;if((b|0)!=1){break T}break d}d=P()|0;O()|0;break b}v[113382]=0;b=T(296,e+160|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break d}v[113382]=0;aa(547,a+1304424|0,e+160|0,b|0,2)|0;b=v[113382];v[113382]=0;if((b|0)==1){break d}}Bb(e+160|0);v[113382]=0;U(543,e+96|0,e+248|0,1229869908);b=v[113382];v[113382]=0;if((b|0)==1){break e}v[113382]=0;b=T(450,e+96|0)|0;d=v[113382];v[113382]=0;if((d|0)!=1){if(b){v[113382]=0;b=T(445,e+96|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break g}U:{d=b<<16>>16;f=d&32767;if(f>>>0>3999){break U}v[113382]=0;b=Q(228,e+96|0,B(f,(d>>>14&2)+50|0)|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break y}if(!b){break U}u[a+480190>>1]=f;g=a+480190|0;if(!f){break z}h=e+178|0;b=1;j=(d|0)>=0;V:{W:{while(1){X:{d=b;Y:{Z:{_:{if(!j){v[113382]=0;d=T(445,e+96|0)|0;i=v[113382];v[113382]=0;if((i|0)==1){break _}d=d+1|0}v[113382]=0;u[e+56>>1]=d;Q(548,e+96|0,e+160|0)|0;d=v[113382];v[113382]=0;if((d|0)!=1){if((x[e+56>>1]-1&65535)>>>0>3998){break Y}v[113382]=0;d=Q(408,g|0,e+56|0)|0;i=v[113382];v[113382]=0;if((i|0)!=1){break Z}}d=P()|0;O()|0;break f}d=P()|0;O()|0;break f}u[a+480190>>1]=x[d>>1];i=x[e+56>>1];d=w[e+282|0]|w[e+283|0]<<8|(w[e+284|0]<<16|w[e+285|0]<<24);v[113382]=0;X(549,e+160|0,(B(i,104)+a|0)+484380|0,d<<8&16711680|d<<24|(d>>>8&65280|d>>>24),l|0);d=v[113382];v[113382]=0;if((d|0)==1){break X}v[113382]=0;U(550,e+80|0,2,h|0);d=v[113382];v[113382]=0;if((d|0)==1){break W}v[113382]=0;R(356,e+232|0,e+80|0);d=v[113382];v[113382]=0;if((d|0)==1){break W}v[113382]=0;Q(335,((x[e+56>>1]<<5)+a|0)+946304|0,e+232|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break V}yb(e+232|0)}d=b&65535;b=b+1|0;if(d>>>0<f>>>0){continue}break z}break}d=P()|0;O()|0;break f}d=P()|0;O()|0;break f}d=P()|0;O()|0;yb(e+232|0);break f}Bb(e+96|0);break A}break w}d=P()|0;O()|0;break f}d=0;break v}v[113382]=0;b=T(445,e+96|0)|0;d=v[113382];v[113382]=0;if((d|0)!=1){break x}}d=P()|0;O()|0;break f}if((b|0)==4){b=x[g>>1];v[113382]=0;u[e+160>>1]=b;u[e+232>>1]=255;b=Q(438,e+160|0,e+232|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break h}u[a+480192>>1]=x[b>>1];v[113382]=0;U(543,e+232|0,e+248|0,1229278806);b=v[113382];v[113382]=0;if((b|0)==1){break i}b=e+80|0;g=b|4;h=b|3;j=b|5;i=b|7;while(1){v[113382]=0;b=Q(228,e+96|0,15)|0;d=v[113382];v[113382]=0;$:{if((d|0)!=1){aa:{if(b){v[113382]=0;Q(551,e+96|0,e+80|0)|0;b=v[113382];v[113382]=0;ba:{if((b|0)!=1){b=w[e+80|0]|w[e+81|0]<<8;if(x[a+480192>>1]<=((b<<8|b>>>8)&65535)>>>0){continue}b=w[e+80|0]|w[e+81|0]<<8;b=B((b<<8|b>>>8)&65535,104)+a|0;t[b+484524|0]=w[e+88|0];d=w[i|0];t[b+484523|0]=255;t[b+484525|0]=d;b=w[e+80|0]|w[e+81|0]<<8;d=w[e+80|0]|w[e+81|0]<<8;v[113382]=0;d=W(411,a|0,(b<<8|b>>>8)+1&65535,(d<<8|d>>>8)+1&65535)|0;b=v[113382];v[113382]=0;if((b|0)==1){break aa}if(!d){continue}b=w[j|0]|w[j+1|0]<<8;v[113382]=0;u[e+160>>1]=b<<8|b>>>8;u[e+56>>1]=4095;b=Q(438,e+160|0,e+56|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break aa}v[d>>2]=x[b>>1];if(w[h|0]==255){continue}b=w[h|0];v[113382]=0;b=Q(226,e+232|0,B(b,34)+2|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break aa}if(!b){continue}v[113382]=0;Q(552,e+232|0,e+160|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break aa}t[d+60|0]=w[d+60|0]|1;b=w[e+160|0]|w[e+161|0]<<8;v[e+56>>2]=(b<<8|b>>>8)&65535;v[113382]=0;v[e+76>>2]=3;v[e+64>>2]=240;v[e+60>>2]=16;v[e+72>>2]=e+56;b=v[e+76>>2];v[e+8>>2]=v[e+72>>2];v[e+12>>2]=b;b=T(553,e+8|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break aa}v[113382]=0;f=d+48|0;R(477,f|0,b|0);b=v[113382];v[113382]=0;if((b|0)==1){break aa}b=0;if(Kb(f)){break ba}break $}break aa}while(1){ca:{t[e+56|0]=64;n=(e+160|0)+(b<<1)|0;m=w[n+2|0];v[113382]=0;t[e+48|0]=m;m=Q(415,e+56|0,e+48|0)|0;k=v[113382];v[113382]=0;if((k|0)==1){break ca}m=w[m|0];E=Pb(f,b),F=m,t[E+2|0]=F;n=w[n+3|0];E=Pb(f,b),F=n,u[E>>1]=F;b=b+1|0;if(Kb(f)>>>0>b>>>0){continue}break $}break}break aa}Bb(e+232|0);break w}}d=P()|0;O()|0;Bb(e+232|0);break f}if(w[g|0]!=255){t[d+60|0]=w[d+60|0]|4;b=w[g|0];t[d+63|0]=b;t[d- -64|0]=b}if(id(f)){continue}t[d+60|0]=w[d+60|0]|2;b=Kb(f)-1|0;t[d+61|0]=b;t[d+62|0]=b;continue}}}b=e+96|0;Bb(b);v[113382]=0;U(554,b|0,e+248|0,1145131092);b=v[113382];v[113382]=0;if((b|0)==1){break j}b=e+96|0;E=e,F=ac(b),v[E+48>>2]=F;E=e,F=bc(b),v[E+40>>2]=F;if(Jb(e+48|0,e+40|0)){z=c&1;n=e+232|4;m=(l|0)!=841887798;A=(l|0)!=841887796;while(1){h=v[e+48>>2];v[113382]=0;Q(304,h|0,4)|0;b=v[113382];v[113382]=0;da:{ea:{fa:{if((b|0)!=1){v[113382]=0;f=T(445,h|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break l}v[113382]=0;j=T(445,h|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break m}j=m?j:(j>>>0)/y[a+480196>>2]|0;if(!z|f>>>0>255){break da}v[113382]=0;b=W(364,o|0,f|0,j|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break m}if(!b){break da}if(m){break ea}v[113382]=0;Q(304,h|0,4)|0;b=v[113382];v[113382]=0;if((b|0)==1){break m}i=0;if(!x[a+480188>>1]){break da}while(1){v[113382]=0;b=T(445,h|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break fa}v[113382]=0;U(307,e+160|0,h|0,b+(b&1)&65535);b=v[113382];v[113382]=0;if((b|0)==1){break n}v[e+232>>2]=0;v[e+236>>2]=0;g=0;ga:{while(1){v[113382]=0;b=Q(228,e+160|0,6)|0;d=v[113382];v[113382]=0;if((d|0)==1){break o}if(!(b&y[e+232>>2]<j>>>0)){break ga}b=Zb(o,f);v[113382]=0;b=W(432,b|0,v[e+232>>2],i&65535)|0;d=v[113382];v[113382]=0;ha:{ia:{if((d|0)!=1){v[113382]=0;R(555,e+56|0,e+160|0);d=v[113382];v[113382]=0;if((d|0)==1){break o}d=e+56|0;k=Zc(d);r=Cf(d);C=Ph(d);p=jc(d);D=d+5|0;d=t[d|0];if((d-1&255)>>>0>95){break ia}t[b|0]=d+13;if(!v[e+236>>2]){break ha}t[b+3|0]=19;v[113382]=0;v[e+80>>2]=15;d=Q(420,n|0,e+80|0)|0;s=v[113382];v[113382]=0;if((s|0)==1){break o}t[b+5|0]=w[d|0]|208;break ha}break o}if((d|0)>=0){break ha}if(v[e+236>>2]){t[b+3|0]=19;v[113382]=0;v[e+80>>2]=15;d=Q(420,n|0,e+80|0)|0;s=v[113382];v[113382]=0;if((s|0)!=1){t[b+5|0]=w[d|0]|192;break ha}break o}t[b|0]=254}if(w[k|0]){t[b+2|0]=1;v[113382]=0;t[e+80|0]=64;d=Q(415,k|0,e+80|0)|0;k=v[113382];v[113382]=0;if((k|0)==1){break o}t[b+4|0]=w[d|0]}d=w[r|0];if(d){t[b+1|0]=d}d=w[C|0];if(d|w[p|0]){t[b+3|0]=d;t[b+5|0]=w[p|0];v[113382]=0;Z(537,b|0);b=v[113382];v[113382]=0;if((b|0)==1){break o}}b=w[D|0];if(b&128){v[113382]=0;d=T(409,e+160|0)|0;k=v[113382];v[113382]=0;if((k|0)==1){break o}b=d|b<<8&32512}d=v[a+480196>>2];v[113382]=0;g=b+g|0;U(556,e+80|0,g|0,d|0);b=v[113382];v[113382]=0;if((b|0)!=1){b=v[e+84>>2];v[e+232>>2]=v[e+80>>2];v[e+236>>2]=b;continue}break}break o}Bb(e+160|0);i=i+1|0;if(x[a+480188>>1]>(i&65535)>>>0){continue}break}break da}d=P()|0;O()|0;break k}d=P()|0;O()|0;break k}b=Zb(o,f);v[113382]=0;b=W(432,b|0,0,0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break s}i=0;if(!j){break da}while(1){d=0;ja:{if(!x[a+480188>>1]){break ja}while(1){ka:{v[113382]=0;R(557,e+160|0,h|0);f=v[113382];v[113382]=0;if((f|0)==1){break ka}la:{if(!A){v[e+232>>2]=v[e+160>>2];f=e+232|0;k=Zc(f);p=Cf(f);r=Ph(f);f=t[f|0];if((f|0)>0){t[b|0]=(B((f&240)>>>4|0,12)+(f&15)|0)+12}g=b;f=w[k|0];if(f>>>0>=4){t[b+2|0]=1;t[b+4|0]=(f>>>2|0)-1;f=w[k|0]}t[g+1|0]=f<<4&48|w[p|0]>>>4;t[b+3|0]=w[p|0]&15;t[b+5|0]=w[r|0];break la}v[113382]=0;f=v[e+160>>2];v[e+36>>2]=f;v[e+20>>2]=f;R(558,e+20|0,b|0);f=v[113382];v[113382]=0;if((f|0)==1){break ka}f=ec(e+160|0,0);t[b+1|0]=w[b+1|0]|w[f|0]&48}v[113382]=0;Z(537,b|0);f=v[113382];v[113382]=0;if((f|0)==1){break ka}f=w[b+3|0];ma:{if(f>>>0>11){break ma}f=1<<f;na:{if(!(f&2240)){if(!(f&12)){break ma}if(!w[b+5|0]){break na}break ma}f=w[b+5|0];g=f&240;if(g){t[b+5|0]=g;break ma}if(f){break ma}}t[b+3|0]=0}b=b+6|0;d=d+1|0;if(x[a+480188>>1]>(d&65535)>>>0){continue}break ja}break}d=P()|0;O()|0;break k}i=i+1|0;if((i|0)!=(j|0)){continue}break}}b=e+48|0;Xf(b);if(Jb(b,e+40|0)){continue}break}}cd(e+96|0);v[113382]=0;U(543,e+160|0,e+248|0,1346458702);b=v[113382];v[113382]=0;if((b|0)==1){d=P()|0;O()|0;break b}v[113382]=0;b=T(450,e+160|0)|0;d=v[113382];v[113382]=0;oa:{pa:{qa:{ra:{sa:{ta:{ua:{va:{wa:{xa:{ya:{za:{Aa:{Ba:{if((d|0)!=1){if(b){f=Xb(e+96|0);b=0;Ca:{while(1){Da:{v[113382]=0;d=Q(228,e+160|0,1)|0;g=v[113382];v[113382]=0;if((g|0)==1){break Da}if(!d){break Ca}if(Ae(o)>>>0<=b>>>0){break Ca}v[113382]=0;W(559,e+160|0,f|0,32)|0;d=v[113382];v[113382]=0;if((d|0)==1){break Da}d=Zb(o,b);v[113382]=0;Q(457,d|0,f|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break Da}b=b+1|0;continue}break}d=P()|0;O()|0;yb(f);break Ba}yb(f)}b=e+160|0;Bb(b);v[113382]=0;U(543,b|0,e+248|0,1414679374);b=v[113382];v[113382]=0;if((b|0)==1){break Aa}v[113382]=0;b=T(450,e+160|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break wa}if(!b){break xa}f=Xb(e+96|0);b=0;while(1){v[113382]=0;d=Q(228,e+160|0,1)|0;g=v[113382];v[113382]=0;if((g|0)==1){break za}if(!d|x[a+480188>>1]<=b>>>0){break ya}v[113382]=0;W(559,e+160|0,f|0,32)|0;d=v[113382];v[113382]=0;if((d|0)==1){break za}v[113382]=0;Q(344,((b<<5)+a|0)+480289|0,f|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break za}b=b+1|0;continue}}d=P()|0;O()|0}Bb(e+160|0);break b}d=P()|0;O()|0;break b}d=P()|0;O()|0;yb(f);break va}yb(f)}b=e+160|0;Bb(b);v[113382]=0;U(554,b|0,e+248|0,1145129300);b=v[113382];v[113382]=0;if((b|0)==1){break ua}b=e+160|0;E=e,F=ac(b),v[E+96>>2]=F;E=e,F=bc(b),v[E+232>>2]=F;if(Jb(e+96|0,e+232|0)){d=c&2;while(1){b=v[e+96>>2];v[113382]=0;c=T(445,b|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break p}if(!(!d|c>>>0>=x[a+480190>>1])){c=B(c,104)+a|0;f=x[c+484518>>1];f=Yc(e+80|0,f&1?16:8,f&64?2:1,1,0);v[113382]=0;W(362,f|0,c+484484|0,b|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break p}}b=e+96|0;Xf(b);if(Jb(b,e+232|0)){continue}break}}cd(e+160|0);b=bd(e+96|0);if((l|0)!=841887798){break sa}v[113382]=0;c=Q(2,e+160|0,5500)|0;d=v[113382];v[113382]=0;if((d|0)==1){break ta}Gb(b,c);yb(c);break ra}d=P()|0;O()|0}Bb(e+160|0);break b}d=P()|0;O()|0;break b}d=P()|0;O()|0;break q}v[113382]=0;U(543,e+160|0,e+248|0,1447383635);c=v[113382];v[113382]=0;Ea:{Fa:{Ga:{Ha:{Ia:{Ja:{Ka:{if((c|0)!=1){v[113382]=0;c=T(450,e+160|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break qa}if(!c){break Fa}v[113382]=0;d=T(455,e+160|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break Ka}v[113382]=0;c=Q(2,e+24|0,11152)|0;f=v[113382];v[113382]=0;if((f|0)==1){break Ja}v[113382]=0;R(189,e+80|0,c|0);f=v[113382];v[113382]=0;if((f|0)==1){break Ia}v[113382]=0;v[e+56>>2]=d>>>4;v[e+48>>2]=d&15;X(560,e+232|0,e+80|0,e+56|0,e+48|0);d=v[113382];v[113382]=0;if((d|0)==1){break Ha}d=e+232|0;Gb(b,d);yb(d);Ib(e+80|0);break Ea}d=P()|0;O()|0;break q}d=P()|0;O()|0;break r}d=P()|0;O()|0;break r}d=P()|0;O()|0;break Ga}d=P()|0;O()|0;Ib(e+80|0)}yb(c);break r}v[113382]=0;c=Q(2,e+232|0,4797)|0;d=v[113382];v[113382]=0;if((d|0)==1){break t}Gb(b,c)}yb(c);Bb(e+160|0)}v[113382]=0;c=Q(2,e+160|0,4797)|0;d=v[113382];v[113382]=0;if((d|0)==1){break pa}Gb(a+1304436|0,c);yb(c);v[113382]=0;c=Q(2,e+160|0,6221)|0;d=v[113382];v[113382]=0;if((d|0)==1){break oa}Gb(a+1304448|0,c);yb(c);Gb(a+1304460|0,b);v[a+1304496>>2]=2;yb(b);d=1;break v}d=P()|0;O()|0;break r}d=P()|0;O()|0;break q}d=P()|0;O()|0;break q}kA(e+248|0)}jb=e+288|0;return d|0}d=P()|0;O()|0;break r}d=P()|0;O()|0;break k}Bb(e+160|0)}yb(b);break b}d=P()|0;O()|0;cd(e+160|0);break b}d=P()|0;O()|0;Bb(e+160|0);break k}d=P()|0;O()|0;break k}d=P()|0;O()|0;break k}d=P()|0;O()|0}cd(e+96|0);break b}d=P()|0;O()|0;break b}d=P()|0;O()|0;break f}d=P()|0;O()|0;break f}d=P()|0;O()|0}Bb(e+96|0);break b}d=P()|0;O()|0;break b}d=P()|0;O()|0;Bb(e+160|0);break b}d=P()|0;O()|0;Bb(e+232|0)}kA(e+248|0)}S(d|0);L()}function VF(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,u=0,x=0,z=0,A=0,D=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,O=0;x=jb-48|0;jb=x;a:{if(c>>>0<=2){c=c<<2;I=v[c+54700>>2];H=v[c+54688>>2];while(1){c=v[b+4>>2];b:{if(c>>>0<y[b+104>>2]){v[b+4>>2]=c+1;c=w[c|0];break b}c=Xc(b)}if(jl(c)){continue}break}m=1;c:{d:{switch(c-43|0){case 0:case 2:break d;default:break c}}m=(c|0)==45?-1:1;c=v[b+4>>2];if(c>>>0<y[b+104>>2]){v[b+4>>2]=c+1;c=w[c|0];break c}c=Xc(b)}e:{f:{while(1){if(t[f+1459|0]==(c|32)){g:{if(f>>>0>6){break g}c=v[b+4>>2];if(c>>>0<y[b+104>>2]){v[b+4>>2]=c+1;c=w[c|0];break g}c=Xc(b)}f=f+1|0;if((f|0)!=8){continue}break f}break}if((f|0)!=3){if((f|0)==8){break f}if(!d|f>>>0<4){break e}if((f|0)==8){break f}}c=v[b+104>>2];if(c){v[b+4>>2]=v[b+4>>2]-1}if(!d|f>>>0<4){break f}while(1){if(c){v[b+4>>2]=v[b+4>>2]-1}f=f-1|0;if(f>>>0>3){continue}break}}b=x;h=jb-16|0;jb=h;g=(p(C(C(m|0)*C(N))),j(2));c=g&2147483647;h:{if(c-8388608>>>0<=2130706431){d=c;c=c>>>7|0;m=d<<25;d=c+1065353216|0;break h}m=g<<25;d=g>>>7|2147418112;if(c>>>0>=2139095040){break h}m=0;d=0;if(!c){break h}d=c;c=E(c);ef(h,d,0,0,0,c+81|0);i=v[h>>2];l=v[h+4>>2];m=v[h+8>>2];d=v[h+12>>2]^65536|16265-c<<16}v[b>>2]=i;v[b+4>>2]=l;v[b+8>>2]=m;v[b+12>>2]=g&-2147483648|d;jb=h+16|0;i=v[x+8>>2];l=v[x+12>>2];h=v[x>>2];g=v[x+4>>2];break a}i:{j:{k:{if(f){break k}f=0;while(1){if(t[f+6071|0]!=(c|32)){break k}l:{if(f>>>0>1){break l}c=v[b+4>>2];if(c>>>0<y[b+104>>2]){v[b+4>>2]=c+1;c=w[c|0];break l}c=Xc(b)}f=f+1|0;if((f|0)!=3){continue}break}break j}m:{switch(f|0){case 0:n:{if((c|0)!=48){break n}f=v[b+4>>2];o:{if(f>>>0<y[b+104>>2]){v[b+4>>2]=f+1;f=w[f|0];break o}f=Xc(b)}if((f&-33)==88){f=jb-432|0;jb=f;c=b;A=v[b+104>>2];b=v[b+4>>2];p:{if(A>>>0>b>>>0){v[c+4>>2]=b+1;b=w[b|0];break p}b=Xc(c)}q:{r:{while(1){if((b|0)!=48){s:{if((b|0)!=46){break q}b=v[c+4>>2];if(b>>>0>=y[c+104>>2]){break s}v[c+4>>2]=b+1;b=w[b|0];break r}}else{b=v[c+4>>2];if(b>>>0<y[c+104>>2]){J=1;v[c+4>>2]=b+1;b=w[b|0]}else{J=1;b=Xc(c)}continue}break}b=Xc(c)}G=1;if((b|0)!=48){break q}while(1){b=i;i=b-1|0;l=l-!b|0;b=v[c+4>>2];t:{if(b>>>0<y[c+104>>2]){v[c+4>>2]=b+1;b=w[b|0];break t}b=Xc(c)}if((b|0)==48){continue}break}J=1}A=1073676288;u:{while(1){v:{o=b|32;w:{x:{D=b-48|0;if(D>>>0<10){break x}if((b|0)!=46&o-97>>>0>=6){break u}if((b|0)!=46){break x}if(G){break v}G=1;i=h;l=g;break w}b=(b|0)>57?o-87|0:D;y:{if((g|0)<=0&h>>>0<=7|(g|0)<0){k=b+(k<<4)|0;break y}if(!g&h>>>0<=28){wg(f+48|0,b);pd(f+32|0,r,z,F,A,0,0,0,1073414144);r=v[f+32>>2];z=v[f+36>>2];F=v[f+40>>2];A=v[f+44>>2];pd(f+16|0,r,z,F,A,v[f+48>>2],v[f+52>>2],v[f+56>>2],v[f+60>>2]);bg(f,q,e,s,u,v[f+16>>2],v[f+20>>2],v[f+24>>2],v[f+28>>2]);s=v[f+8>>2];u=v[f+12>>2];q=v[f>>2];e=v[f+4>>2];break y}if(!b|n){break y}pd(f+80|0,r,z,F,A,0,0,0,1073610752);bg(f- -64|0,q,e,s,u,v[f+80>>2],v[f+84>>2],v[f+88>>2],v[f+92>>2]);s=v[f+72>>2];u=v[f+76>>2];n=1;q=v[f+64>>2];e=v[f+68>>2]}b=h+1|0;g=b?g:g+1|0;h=b;J=1}b=v[c+4>>2];if(b>>>0<y[c+104>>2]){v[c+4>>2]=b+1;b=w[b|0]}else{b=Xc(c)}continue}break}b=46}z:{A:{B:{if(!J){if(!v[c+104>>2]){if(d){break A}break B}b=v[c+4>>2];v[c+4>>2]=b-1;if(!d){break B}v[c+4>>2]=b-2;if(!G){break A}v[c+4>>2]=b-3;break A}if((g|0)<=0&h>>>0<=7|(g|0)<0){F=h;A=g;while(1){k=k<<4;n=A;A=F+1|0;n=A?n:n+1|0;F=A;A=n;if((F|0)!=8|n){continue}break}}C:{D:{E:{if((b&-33)==80){F=UF(c,d);b=mb;A=b;if(F|(b|0)!=-2147483648){break C}if(d){if(v[c+104>>2]){break E}break D}q=0;e=0;Ch(c,0,0);c=0;b=0;break z}if(!v[c+104>>2]){break D}}v[c+4>>2]=v[c+4>>2]-1}F=0;A=0}if(!k){ei(f+112|0,+(m|0)*0);q=v[f+112>>2];e=v[f+116>>2];c=v[f+124>>2];b=v[f+120>>2];break z}b=G?i:h;c=(G?l:g)<<2|b>>>30;b=F+(b<<2)|0;c=c+A|0;c=b>>>0<F>>>0?c+1|0:c;h=b-32|0;g=c-(b>>>0<32)|0;b=g;if(h>>>0>0-I>>>0&(b|0)>=0|(b|0)>0){v[113305]=68;wg(f+160|0,m);pd(f+144|0,v[f+160>>2],v[f+164>>2],v[f+168>>2],v[f+172>>2],-1,-1,-1,2147418111);pd(f+128|0,v[f+144>>2],v[f+148>>2],v[f+152>>2],v[f+156>>2],-1,-1,-1,2147418111);q=v[f+128>>2];e=v[f+132>>2];c=v[f+140>>2];b=v[f+136>>2];break z}b=I-226|0;c=b;b=b>>31;if(c>>>0<=h>>>0&(g|0)>=(b|0)|(b|0)<(g|0)){if((k|0)>=0){while(1){bg(f+416|0,q,e,s,u,0,0,0,-1073807360);c=lw(q,e,s,u,1073610752);b=(c|0)<0;bg(f+400|0,q,e,s,u,b?q:v[f+416>>2],b?e:v[f+420>>2],b?s:v[f+424>>2],b?u:v[f+428>>2]);b=h;h=b-1|0;g=g-!b|0;s=v[f+408>>2];u=v[f+412>>2];q=v[f+400>>2];e=v[f+404>>2];k=k<<1|(c|0)>=0;if((k|0)>=0){continue}break}}b=h;c=I;d=(b-c|0)+32|0;c=g-((c>>31)+(b>>>0<c>>>0)|0)|0;c=d>>>0<32?c+1|0:c;b=d;c=b>>>0<H>>>0&(c|0)<=0|(c|0)<0?(b|0)>0?b:0:H;F:{if((c|0)>=113){wg(f+384|0,m);i=v[f+392>>2];l=v[f+396>>2];r=v[f+384>>2];z=v[f+388>>2];g=0;b=0;break F}ei(f+352|0,Zh(1,144-c|0));wg(f+336|0,m);r=v[f+336>>2];z=v[f+340>>2];i=v[f+344>>2];l=v[f+348>>2];ZF(f+368|0,v[f+352>>2],v[f+356>>2],v[f+360>>2],v[f+364>>2],r,z,i,l);K=v[f+376>>2];L=v[f+380>>2];g=v[f+372>>2];b=v[f+368>>2]}c=!(k&1)&((il(q,e,s,u,0,0,0,0)|0)!=0&(c|0)<32);Em(f+320|0,c+k|0);pd(f+304|0,r,z,i,l,v[f+320>>2],v[f+324>>2],v[f+328>>2],v[f+332>>2]);d=b;bg(f+272|0,v[f+304>>2],v[f+308>>2],v[f+312>>2],v[f+316>>2],b,g,K,L);b=c;pd(f+288|0,b?0:q,b?0:e,b?0:s,b?0:u,r,z,i,l);bg(f+256|0,v[f+288>>2],v[f+292>>2],v[f+296>>2],v[f+300>>2],v[f+272>>2],v[f+276>>2],v[f+280>>2],v[f+284>>2]);kw(f+240|0,v[f+256>>2],v[f+260>>2],v[f+264>>2],v[f+268>>2],d,g,K,L);b=v[f+240>>2];c=v[f+244>>2];d=v[f+248>>2];i=v[f+252>>2];if(!il(b,c,d,i,0,0,0,0)){v[113305]=68}YF(f+224|0,b,c,d,i,h);q=v[f+224>>2];e=v[f+228>>2];c=v[f+236>>2];b=v[f+232>>2];break z}v[113305]=68;wg(f+208|0,m);pd(f+192|0,v[f+208>>2],v[f+212>>2],v[f+216>>2],v[f+220>>2],0,0,0,65536);pd(f+176|0,v[f+192>>2],v[f+196>>2],v[f+200>>2],v[f+204>>2],0,0,0,65536);q=v[f+176>>2];e=v[f+180>>2];c=v[f+188>>2];b=v[f+184>>2];break z}Ch(c,0,0)}ei(f+96|0,+(m|0)*0);q=v[f+96>>2];e=v[f+100>>2];c=v[f+108>>2];b=v[f+104>>2]}v[x+16>>2]=q;v[x+20>>2]=e;v[x+24>>2]=b;v[x+28>>2]=c;jb=f+432|0;i=v[x+24>>2];l=v[x+28>>2];h=v[x+16>>2];g=v[x+20>>2];break a}if(!v[b+104>>2]){break n}v[b+4>>2]=v[b+4>>2]-1}k=b;q=m;m=0;f=0;e=jb-8976|0;jb=e;J=H+I|0;O=0-J|0;G:{H:{while(1){if((c|0)!=48){I:{if((c|0)!=46){break G}b=v[k+4>>2];if(b>>>0>=y[k+104>>2]){break I}v[k+4>>2]=b+1;c=w[b|0];break H}}else{b=v[k+4>>2];if(b>>>0<y[k+104>>2]){m=1;v[k+4>>2]=b+1;c=w[b|0]}else{m=1;c=Xc(k)}continue}break}c=Xc(k)}o=1;if((c|0)!=48){break G}while(1){b=i;i=b-1|0;l=l-!b|0;b=v[k+4>>2];J:{if(b>>>0<y[k+104>>2]){v[k+4>>2]=b+1;c=w[b|0];break J}c=Xc(k)}if((c|0)==48){continue}break}m=1}v[e+784>>2]=0;K:{L:{b=(c|0)==46;n=c-48|0;M:{N:{O:{P:{if(!(!b&n>>>0>9)){while(1){Q:{if(b&1){if(!o){i=h;l=g;o=1;break Q}b=!m;break P}b=h+1|0;g=b?g:g+1|0;h=b;if((f|0)<=2044){G=(c|0)==48?G:h;b=(e+784|0)+(f<<2)|0;m=b;if(D){n=(B(v[b>>2],10)+c|0)-48|0}v[m>>2]=n;m=1;c=D+1|0;b=(c|0)==9;D=b?0:c;f=b+f|0;break Q}if((c|0)==48){break Q}v[e+8960>>2]=v[e+8960>>2]|1;G=18396}b=v[k+4>>2];R:{if(b>>>0<y[k+104>>2]){v[k+4>>2]=b+1;c=w[b|0];break R}c=Xc(k)}b=(c|0)==46;n=c-48|0;if(b|n>>>0<10){continue}break}}i=o?i:h;l=o?l:g;if(!(!m|(c&-33)!=69)){r=UF(k,d);b=mb;z=b;S:{if(r|(b|0)!=-2147483648){break S}if(!d){break M}r=0;z=0;if(!v[k+104>>2]){break S}v[k+4>>2]=v[k+4>>2]-1}if(!m){break N}n=l+z|0;b=i+r|0;n=b>>>0<r>>>0?n+1|0:n;i=b;l=n;break L}b=!m;if((c|0)<0){break O}}if(!v[k+104>>2]){break O}v[k+4>>2]=v[k+4>>2]-1}if(!b){break L}}v[113305]=28}h=0;g=0;Ch(k,0,0);c=0;b=0;break K}b=v[e+784>>2];if(!b){ei(e,+(q|0)*0);h=v[e>>2];g=v[e+4>>2];c=v[e+12>>2];b=v[e+8>>2];break K}if(!((h|0)!=(i|0)|(g|0)!=(l|0)|(h>>>0>9&(g|0)>=0|(g|0)>0)|(b>>>H|0?(H|0)<=30:0))){wg(e+48|0,q);Em(e+32|0,b);pd(e+16|0,v[e+48>>2],v[e+52>>2],v[e+56>>2],v[e+60>>2],v[e+32>>2],v[e+36>>2],v[e+40>>2],v[e+44>>2]);h=v[e+16>>2];g=v[e+20>>2];c=v[e+28>>2];b=v[e+24>>2];break K}if(i>>>0>(I|0)/-2>>>0&(l|0)>=0|(l|0)>0){v[113305]=68;wg(e+96|0,q);pd(e+80|0,v[e+96>>2],v[e+100>>2],v[e+104>>2],v[e+108>>2],-1,-1,-1,2147418111);pd(e- -64|0,v[e+80>>2],v[e+84>>2],v[e+88>>2],v[e+92>>2],-1,-1,-1,2147418111);h=v[e+64>>2];g=v[e+68>>2];c=v[e+76>>2];b=v[e+72>>2];break K}b=I-226|0;c=i>>>0<b>>>0;b=b>>31;if(c&(l|0)<=(b|0)|(b|0)>(l|0)){v[113305]=68;wg(e+144|0,q);pd(e+128|0,v[e+144>>2],v[e+148>>2],v[e+152>>2],v[e+156>>2],0,0,0,65536);pd(e+112|0,v[e+128>>2],v[e+132>>2],v[e+136>>2],v[e+140>>2],0,0,0,65536);h=v[e+112>>2];g=v[e+116>>2];c=v[e+124>>2];b=v[e+120>>2];break K}if(D){if((D|0)<=8){b=(e+784|0)+(f<<2)|0;k=v[b>>2];while(1){k=B(k,10);D=D+1|0;if((D|0)!=9){continue}break}v[b>>2]=k}f=f+1|0}T:{o=i;if((G|0)>(i|0)|(G|0)>=9|(i|0)>17){break T}if((o|0)==9){wg(e+192|0,q);Em(e+176|0,v[e+784>>2]);pd(e+160|0,v[e+192>>2],v[e+196>>2],v[e+200>>2],v[e+204>>2],v[e+176>>2],v[e+180>>2],v[e+184>>2],v[e+188>>2]);h=v[e+160>>2];g=v[e+164>>2];c=v[e+172>>2];b=v[e+168>>2];break K}if((o|0)<=8){wg(e+272|0,q);Em(e+256|0,v[e+784>>2]);pd(e+240|0,v[e+272>>2],v[e+276>>2],v[e+280>>2],v[e+284>>2],v[e+256>>2],v[e+260>>2],v[e+264>>2],v[e+268>>2]);wg(e+224|0,v[(0-o<<2)+54688>>2]);WF(e+208|0,v[e+240>>2],v[e+244>>2],v[e+248>>2],v[e+252>>2],v[e+224>>2],v[e+228>>2],v[e+232>>2],v[e+236>>2]);h=v[e+208>>2];g=v[e+212>>2];c=v[e+220>>2];b=v[e+216>>2];break K}b=(B(o,-3)+H|0)+27|0;c=v[e+784>>2];if(c>>>b|0?(b|0)<=30:0){break T}wg(e+352|0,q);Em(e+336|0,c);pd(e+320|0,v[e+352>>2],v[e+356>>2],v[e+360>>2],v[e+364>>2],v[e+336>>2],v[e+340>>2],v[e+344>>2],v[e+348>>2]);wg(e+304|0,v[(o<<2)+54616>>2]);pd(e+288|0,v[e+320>>2],v[e+324>>2],v[e+328>>2],v[e+332>>2],v[e+304>>2],v[e+308>>2],v[e+312>>2],v[e+316>>2]);h=v[e+288>>2];g=v[e+292>>2];c=v[e+300>>2];b=v[e+296>>2];break K}while(1){c=f;f=f-1|0;if(!v[(e+784|0)+(f<<2)>>2]){continue}break}D=0;b=(o|0)%9|0;U:{if(!b){b=0;break U}d=(o|0)>=0?b:b+9|0;V:{if(!c){b=0;c=0;break V}i=v[(0-d<<2)+54688>>2];h=1e9/(i|0)|0;n=0;k=0;b=0;while(1){g=n;l=(e+784|0)+(k<<2)|0;n=v[l>>2];m=(n>>>0)/(i>>>0)|0;g=g+m|0;v[l>>2]=g;g=!g&(b|0)==(k|0);b=g?b+1&2047:b;o=g?o-9|0:o;n=B(h,n-B(i,m)|0);k=k+1|0;if((k|0)!=(c|0)){continue}break}if(!n){break V}v[(e+784|0)+(c<<2)>>2]=n;c=c+1|0}o=(o-d|0)+9|0}while(1){h=(e+784|0)+(b<<2)|0;W:{while(1){if(((o|0)!=36|y[h>>2]>=10384593)&(o|0)>=36){break W}m=c+2047|0;n=0;while(1){l=n;g=m&2047;m=(e+784|0)+(g<<2)|0;d=v[m>>2];n=d>>>3|0;i=d<<29;d=l+i|0;n=d>>>0<i>>>0?n+1|0:n;i=d;l=n;if(!l&i>>>0<1000000001){n=0}else{n=tma(i,l,1e9,0);i=i-qma(n,mb,1e9,0)|0}v[m>>2]=i;c=(g|0)!=(c-1&2047)?c:(b|0)==(g|0)?c:i?c:g;m=g-1|0;if((b|0)!=(g|0)){continue}break}D=D-29|0;if(!n){continue}break}b=b-1&2047;if((c|0)==(b|0)){d=e+784|0;i=d+((c+2046&2047)<<2)|0;c=c-1&2047;v[i>>2]=v[i>>2]|v[d+(c<<2)>>2]}o=o+9|0;v[(e+784|0)+(b<<2)>>2]=n;continue}break}X:{Y:while(1){d=c+1&2047;g=(e+784|0)+((c-1&2047)<<2)|0;while(1){i=(o|0)>45?9:1;Z:{while(1){m=b;k=0;_:{while(1){$:{b=k+m&2047;if((b|0)==(c|0)){break $}b=v[(e+784|0)+(b<<2)>>2];h=v[(k<<2)+54640>>2];if(b>>>0<h>>>0){break $}if(b>>>0>h>>>0){break _}k=k+1|0;if((k|0)!=4){continue}}break}if((o|0)!=36){break _}i=0;l=0;k=0;h=0;g=0;while(1){b=k+m&2047;if((b|0)==(c|0)){c=c+1&2047;v[(e+(c<<2)|0)+780>>2]=0}pd(e+768|0,i,l,h,g,0,0,1342177280,1075633366);Em(e+752|0,v[(e+784|0)+(b<<2)>>2]);bg(e+736|0,v[e+768>>2],v[e+772>>2],v[e+776>>2],v[e+780>>2],v[e+752>>2],v[e+756>>2],v[e+760>>2],v[e+764>>2]);h=v[e+744>>2];g=v[e+748>>2];i=v[e+736>>2];l=v[e+740>>2];k=k+1|0;if((k|0)!=4){continue}break}wg(e+720|0,q);pd(e+704|0,i,l,h,g,v[e+720>>2],v[e+724>>2],v[e+728>>2],v[e+732>>2]);h=v[e+712>>2];g=v[e+716>>2];i=0;l=0;r=v[e+704>>2];z=v[e+708>>2];o=D+113|0;d=o-I|0;n=(d|0)<(H|0);b=n?(d|0)>0?d:0:H;if((b|0)<=112){break Z}break X}D=i+D|0;b=c;if((m|0)==(b|0)){continue}break}l=1e9>>>i|0;n=-1<<i^-1;k=0;b=m;while(1){h=k;f=(e+784|0)+(m<<2)|0;k=v[f>>2];h=h+(k>>>i|0)|0;v[f>>2]=h;h=!h&(b|0)==(m|0);b=h?b+1&2047:b;o=h?o-9|0:o;k=B(l,k&n);m=m+1&2047;if((m|0)!=(c|0)){continue}break}if(!k){continue}if((b|0)!=(d|0)){v[(e+784|0)+(c<<2)>>2]=k;c=d;continue Y}v[g>>2]=v[g>>2]|1;b=d;continue}break}break}ei(e+656|0,Zh(1,225-b|0));ZF(e+688|0,v[e+656>>2],v[e+660>>2],v[e+664>>2],v[e+668>>2],r,z,h,g);F=v[e+696>>2];A=v[e+700>>2];K=v[e+688>>2];L=v[e+692>>2];ei(e+640|0,Zh(1,113-b|0));DD(e+672|0,r,z,h,g,v[e+640>>2],v[e+644>>2],v[e+648>>2],v[e+652>>2]);i=v[e+672>>2];l=v[e+676>>2];s=v[e+680>>2];u=v[e+684>>2];kw(e+624|0,r,z,h,g,i,l,s,u);bg(e+608|0,K,L,F,A,v[e+624>>2],v[e+628>>2],v[e+632>>2],v[e+636>>2]);h=v[e+616>>2];g=v[e+620>>2];r=v[e+608>>2];z=v[e+612>>2]}f=m+4&2047;aa:{if((f|0)==(c|0)){break aa}f=v[(e+784|0)+(f<<2)>>2];ba:{if(f>>>0<=499999999){if(!f&(m+5&2047)==(c|0)){break ba}ei(e+496|0,+(q|0)*.25);bg(e+480|0,i,l,s,u,v[e+496>>2],v[e+500>>2],v[e+504>>2],v[e+508>>2]);s=v[e+488>>2];u=v[e+492>>2];i=v[e+480>>2];l=v[e+484>>2];break ba}if((f|0)!=5e8){ei(e+592|0,+(q|0)*.75);bg(e+576|0,i,l,s,u,v[e+592>>2],v[e+596>>2],v[e+600>>2],v[e+604>>2]);s=v[e+584>>2];u=v[e+588>>2];i=v[e+576>>2];l=v[e+580>>2];break ba}M=+(q|0);if((m+5&2047)==(c|0)){ei(e+528|0,M*.5);bg(e+512|0,i,l,s,u,v[e+528>>2],v[e+532>>2],v[e+536>>2],v[e+540>>2]);s=v[e+520>>2];u=v[e+524>>2];i=v[e+512>>2];l=v[e+516>>2];break ba}ei(e+560|0,M*.75);bg(e+544|0,i,l,s,u,v[e+560>>2],v[e+564>>2],v[e+568>>2],v[e+572>>2]);s=v[e+552>>2];u=v[e+556>>2];i=v[e+544>>2];l=v[e+548>>2]}if((b|0)>111){break aa}DD(e+464|0,i,l,s,u,0,0,0,1073676288);if(il(v[e+464>>2],v[e+468>>2],v[e+472>>2],v[e+476>>2],0,0,0,0)){break aa}bg(e+448|0,i,l,s,u,0,0,0,1073676288);s=v[e+456>>2];u=v[e+460>>2];i=v[e+448>>2];l=v[e+452>>2]}bg(e+432|0,r,z,h,g,i,l,s,u);kw(e+416|0,v[e+432>>2],v[e+436>>2],v[e+440>>2],v[e+444>>2],K,L,F,A);h=v[e+424>>2];g=v[e+428>>2];r=v[e+416>>2];z=v[e+420>>2];ca:{if((-2-J|0)>=(o&2147483647)){break ca}v[e+408>>2]=h;v[e+412>>2]=g&2147483647;v[e+400>>2]=r;v[e+404>>2]=z;pd(e+384|0,r,z,h,g,0,0,0,1073610752);A=v[e+400>>2];F=v[e+404>>2];f=v[e+408>>2];o=v[e+412>>2];c=lw(A,F,f,o,1081081856);m=(c|0)<0;k=m;h=k?h:v[e+392>>2];g=k?g:v[e+396>>2];r=k?r:v[e+384>>2];z=k?z:v[e+388>>2];D=((c|0)>=0)+D|0;if((D+110|0)<=(O|0)){if((((lw(A,F,f,o,1081081856)|0)<0?n:n&(b|0)!=(d|0))|0)!=1){break ca}if(!il(i,l,s,u,0,0,0,0)){break ca}}v[113305]=68}YF(e+368|0,r,z,h,g,D);h=v[e+368>>2];g=v[e+372>>2];c=v[e+380>>2];b=v[e+376>>2]}v[x+32>>2]=h;v[x+36>>2]=g;v[x+40>>2]=b;v[x+44>>2]=c;jb=e+8976|0;i=v[x+40>>2];l=v[x+44>>2];h=v[x+32>>2];g=v[x+36>>2];break a;case 3:break j;default:break m}}if(v[b+104>>2]){v[b+4>>2]=v[b+4>>2]-1}break i}da:{c=v[b+4>>2];ea:{if(c>>>0<y[b+104>>2]){v[b+4>>2]=c+1;c=w[c|0];break ea}c=Xc(b)}if((c|0)==40){f=1;break da}l=2147450880;if(!v[b+104>>2]){break a}v[b+4>>2]=v[b+4>>2]-1;break a}while(1){c=v[b+4>>2];fa:{if(c>>>0<y[b+104>>2]){v[b+4>>2]=c+1;c=w[c|0];break fa}c=Xc(b)}if(!(!(c-48>>>0<10|c-65>>>0<26|(c|0)==95)&c-97>>>0>=26)){f=f+1|0;continue}break}l=2147450880;if((c|0)==41){break a}c=v[b+104>>2];if(c){v[b+4>>2]=v[b+4>>2]-1}if(d){if(!f){break a}while(1){f=f-1|0;if(c){v[b+4>>2]=v[b+4>>2]-1}if(f){continue}break}break a}}v[113305]=28;Ch(b,0,0)}l=0}v[a>>2]=h;v[a+4>>2]=g;v[a+8>>2]=i;v[a+12>>2]=l;jb=x+48|0}function Tja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,y=0,z=0,A=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=jb-336|0;jb=d;Ic(b);a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{if(!ku(b,d+328|0)){break q}if(!kR(d+328|0)){break q}if(!c){m=1;break q}A=Nk(d+312|0,b);v[113382]=0;U(703,d+296|0,A|0,0);b=v[113382];v[113382]=0;r:{s:{t:{u:{v:{w:{x:{y:{z:{A:{B:{C:{D:{E:{F:{if((b|0)!=1){v[113382]=0;U(704,d+280|0,d+296|0,20041);b=v[113382];v[113382]=0;if((b|0)==1){break F}v[113382]=0;b=T(303,d+280|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break w}if(!b){break r}v[113382]=0;b=Q(705,d+280|0,d+184|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break w}if(!b){break r}v[113382]=0;R(403,a|0,16384);b=v[113382];v[113382]=0;if((b|0)==1){break w}v[a+480208>>2]=8;v[113382]=0;b=a+1074312|0;W(439,b|0,9,1)|0;e=v[113382];v[113382]=0;if((e|0)==1){break w}v[113382]=0;Q(440,b|0,21)|0;e=v[113382];v[113382]=0;if((e|0)==1){break w}v[113382]=0;Q(440,b|0,30)|0;b=v[113382];v[113382]=0;if((b|0)==1){break w}v[113382]=0;b=Q(2,d- -64|0,4554)|0;e=v[113382];v[113382]=0;if((e|0)==1){break C}Gb(a+1304436|0,b);yb(b);v[113382]=0;b=Q(2,d- -64|0,6810)|0;e=v[113382];v[113382]=0;if((e|0)==1){break B}Gb(a+1304448|0,b);yb(b);v[113382]=0;e=Q(2,d+168|0,13432)|0;b=v[113382];v[113382]=0;if((b|0)==1){break A}b=w[d+332|0];switch(b-16|0){case 1:break z;case 0:break E;default:break D}}b=P()|0;O()|0;break a}b=P()|0;O()|0;break b}v[113382]=0;Q(2,d+152|0,10769)|0;b=v[113382];v[113382]=0;if((b|0)!=1){break x}break e}if(!b){break y}v[113382]=0;Q(2,d+152|0,17540)|0;b=v[113382];v[113382]=0;if((b|0)==1){break e}break x}b=P()|0;O()|0;break c}b=P()|0;O()|0;break c}b=P()|0;O()|0;break c}v[113382]=0;Q(2,d+152|0,10850)|0;b=v[113382];v[113382]=0;if((b|0)!=1){break x}break e}v[113382]=0;Q(2,d+152|0,9276)|0;b=v[113382];v[113382]=0;if((b|0)==1){break e}}v[113382]=0;U(3,d- -64|0,e|0,d+152|0);b=v[113382];v[113382]=0;if((b|0)==1){break f}b=d- -64|0;Gb(a+1304460|0,b);yb(b);yb(d+152|0);yb(e);v[a+1304496>>2]=4;v[113382]=0;U(355,d+168|0,3,d+184|0);b=v[113382];v[113382]=0;if((b|0)==1){break g}v[113382]=0;R(356,d- -64|0,d+168|0);b=v[113382];v[113382]=0;if((b|0)==1){break g}b=d- -64|0;Gb(a+1304400|0,b);yb(b);v[113382]=0;U(706,d+152|0,3,d+216|0);b=v[113382];v[113382]=0;if((b|0)==1){break h}v[113382]=0;R(356,d+168|0,d+152|0);b=v[113382];v[113382]=0;if((b|0)==1){break h}v[113382]=0;U(13,d- -64|0,4,d+168|0);b=v[113382];v[113382]=0;if((b|0)==1){break i}b=d- -64|0;Gb(a+1304412|0,b);yb(b);yb(d+168|0);v[a+480200>>2]=w[d+240|0]+1;H=a,I=Ed(w[d+241|0],1,255),v[H+480196>>2]=I;H=a,I=B(Ed(w[d+242|0],4,255),1e4),v[H+480204>>2]=I;b=a+484360|0;e=Vb(b);g=w[d+236|0]|w[d+237|0]<<8;v[113382]=0;ea(544,e|0,d+280|0,g|0,65535,65535)|0;e=v[113382];v[113382]=0;if((e|0)==1){break w}Ne(Vb(b),w[d+238|0]|w[d+239|0]<<8);u[a+480188>>1]=0;b=0;while(1){v[113382]=0;e=(b<<5)+a|0;g=e+480280|0;Z(387,g|0);f=v[113382];v[113382]=0;if((f|0)==1){break j}f=b+d|0;h=w[f+243|0]<<1&254;u[e+480284>>1]=(h|0)==254?256:h;G:{if(t[f+243|0]<0){v[g>>2]=v[g>>2]|1024;break G}u[a+480188>>1]=b+1}v[113382]=0;W(707,d+280|0,e+480289|0,8)|0;e=v[113382];v[113382]=0;if((e|0)==1){break j}b=b+1|0;if((b|0)!=32){continue}break}v[113382]=0;U(704,d- -64|0,d+296|0,17741);b=v[113382];v[113382]=0;if((b|0)==1){break k}b=d+280|0;e=d- -64|0;Qd(b,e);Bb(e);v[113382]=0;b=T(225,b|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break w}v[113382]=0;aa(547,a+1304424|0,d+280|0,b|0,0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break w}v[113382]=0;U(704,d- -64|0,d+296|0,21321);b=v[113382];v[113382]=0;if((b|0)==1){break l}b=d+280|0;e=d- -64|0;Qd(b,e);Bb(e);v[113382]=0;b=T(303,b|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break w}H:{if(b){v[113382]=0;U(704,d- -64|0,d+296|0,16723);b=v[113382];v[113382]=0;if((b|0)==1){break m}v[113382]=0;l=T(409,d+280|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break n}I:{if(!l){break I}i=c&2;g=0;while(1){v[113382]=0;e=T(409,d+280|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break n}if(!e){break I}v[113382]=0;b=Q(228,d+280|0,56)|0;f=v[113382];v[113382]=0;if((f|0)==1){break n}if(!b){break I}if(e>>>0>x[a+480190>>1]){u[a+480190>>1]=e}v[113382]=0;b=B(e,104)+a|0;f=b+484380|0;R(453,f|0,0);h=v[113382];v[113382]=0;if((h|0)==1){break n}v[113382]=0;W(511,d+280|0,((e<<5)+a|0)+946304|0,32)|0;e=v[113382];v[113382]=0;if((e|0)==1){break n}v[113382]=0;W(514,d+280|0,b+484423|0,8)|0;e=v[113382];v[113382]=0;if((e|0)==1){break n}J:{if(w[d+332|0]<=15){v[113382]=0;e=T(323,d+280|0)|0;h=v[113382];v[113382]=0;if((h|0)!=1){break J}break n}v[113382]=0;e=T(397,d+280|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break n}}v[b+484404>>2]=e<<1;v[113382]=0;e=T(397,d+280|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break n}v[f>>2]=e;v[113382]=0;h=T(397,d+280|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break n}e=b+484384|0;v[e>>2]=h;v[113382]=0;h=T(397,d+280|0)|0;k=v[113382];v[113382]=0;if((k|0)==1){break n}k=b+484388|0;v[k>>2]=h;if(h){j=b+484414|0;u[j>>1]=x[j>>1]|2;v[k>>2]=h+v[e>>2]}v[113382]=0;h=T(409,d+280|0)|0;j=v[113382];v[113382]=0;if((j|0)==1){break H}if(w[d+332|0]<=15){u[b+484410>>1]=h}v[113382]=0;h=T(409,d+280|0)|0;j=v[113382];v[113382]=0;if((j|0)==1){break n}j=b+484414|0;b=x[j>>1];m=8;if(h&1){b=b|1;u[j>>1]=b;v[f>>2]=v[f>>2]>>>1;v[e>>2]=v[e>>2]>>>1;v[k>>2]=v[k>>2]>>>1;m=16}u[j>>1]=b&65531|h<<1&4;b=Yc(d+168|0,m,1,0,((h&12)!=0)<<3);K:{if(!i){break K}v[113382]=0;W(362,b|0,f|0,d- -64|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){break K}break n}g=g+1|0;if(l>>>0>(g&255)>>>0){continue}break}}Bb(d- -64|0)}v[113382]=0;U(704,d- -64|0,d+296|0,18761);b=v[113382];v[113382]=0;if((b|0)==1){break p}b=d+280|0;e=d- -64|0;Qd(b,e);Bb(e);v[113382]=0;b=T(303,b|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break w}if(b){k=Qz(d+168|0);j=Qz(d+152|0);m=Qz(d+136|0);v[113382]=0;U(704,d+120|0,d+296|0,17750);b=v[113382];v[113382]=0;if((b|0)==1){break o}v[113382]=0;b=v[d+132>>2];v[d+40>>2]=v[d+128>>2];v[d+44>>2]=b;b=v[d+124>>2];v[d+32>>2]=v[d+120>>2];v[d+36>>2]=b;R(708,d+32|0,k|0);b=v[113382];v[113382]=0;if((b|0)==1){break o}v[113382]=0;U(704,d+104|0,d+296|0,17744);b=v[113382];v[113382]=0;if((b|0)==1){break o}v[113382]=0;b=v[d+116>>2];v[d+24>>2]=v[d+112>>2];v[d+28>>2]=b;b=v[d+108>>2];v[d+16>>2]=v[d+104>>2];v[d+20>>2]=b;R(708,d+16|0,j|0);b=v[113382];v[113382]=0;if((b|0)==1){break o}v[113382]=0;U(704,d+88|0,d+296|0,17734);b=v[113382];v[113382]=0;if((b|0)==1){break o}v[113382]=0;b=v[d+100>>2];v[d+8>>2]=v[d+96>>2];v[d+12>>2]=b;b=v[d+92>>2];v[d>>2]=v[d+88>>2];v[d+4>>2]=b;R(708,d|0,m|0);b=v[113382];v[113382]=0;if((b|0)==1){break o}l=0;v[113382]=0;o=T(409,d+280|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break o}if(o){b=d- -64|0;y=b|4;z=b|2;p=b|6;q=b|5;r=b|3;e=b|1;while(1){v[113382]=0;R(433,d+48|0,d+280|0);b=v[113382];v[113382]=0;if((b|0)==1){break o}b=d+48|0;n=Zc(b);L:{M:{N:{if(!w[b|0]){break N}g=w[n|0];v[113382]=0;g=Q(228,d+280|0,B(g,14)+32|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break o}if(!g){break N}b=w[b|0];v[113382]=0;h=W(411,a|0,b|0,0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break o}if(h){break M}}b=w[n|0];v[113382]=0;Q(304,d+280|0,B(b,14)+32|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){break L}break o}v[113382]=0;W(511,d+280|0,h+492|0,32)|0;b=v[113382];v[113382]=0;if((b|0)==1){break o}if(!w[n|0]){break L}C=h+88|0;D=h+68|0;E=h+48|0;F=h+236|0;f=0;b=0;while(1){v[113382]=0;Q(709,d+280|0,d- -64|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break o}g=w[d- -64|0];O:{if(!g|g>>>0>x[a+480190>>1]){break O}g=e;if(w[e|0]>128){t[g|0]=128}if(w[e|0]>=(b&255)>>>0){while(1){g=w[d- -64|0];H=_c(F,b&255),I=g,u[H>>1]=I;b=b+1|0;if(w[e|0]>=(b&255)>>>0){continue}break}}G=w[e|0];b=w[r|0];v[113382]=0;U(710,E|0,b|0,k|0);b=v[113382];v[113382]=0;if((b|0)==1){break o}b=w[q|0];v[113382]=0;U(710,D|0,b|0,j|0);b=v[113382];v[113382]=0;if((b|0)==1){break o}b=w[d+77|0];v[113382]=0;U(710,C|0,b|0,m|0);b=v[113382];v[113382]=0;if((b|0)==1){break o}v[h>>2]=(w[p|0]|w[p+1|0]<<8)+1>>>1;b=w[d- -64|0];P:{if(w[r|0]&64){u[(B(b,104)+a|0)+484410>>1]=w[z|0];break P}g=(B(b,104)+a|0)+484414|0;u[g>>1]=x[g>>1]|32768}g=w[y|0];v[113382]=0;u[d+86>>1]=g<<1;u[d+84>>1]=254;i=Q(438,d+86|0,d+84|0)|0;g=v[113382];v[113382]=0;Q:{if((g|0)!=1){g=B(b,104)+a|0;u[g+484408>>1]=x[i>>1];t[g+484418|0]=w[(w[d+75|0]&3)+23877|0];s=g+484419|0;t[s|0]=w[d+74|0];i=g+484420|0;t[i|0]=w[d+73|0]+3>>>2;t[g+484421|0]=w[d+72|0];b=w[s|0];if(!b){i=255;break Q}i=w[i|0];v[113382]=0;b=qg(711,(((i<<8|b>>>1)&65407)>>>0)/(b>>>0)|0,0);i=v[113382];v[113382]=0;if((i|0)!=1){v[113382]=0;i=T(712,b|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){break Q}}break o}break o}b=G+1|0;t[s|0]=i;if(!(w[q|0]&64)){break O}g=g+484414|0;u[g>>1]=x[g>>1]|32}f=f+1|0;if(w[n|0]>(f&255)>>>0){continue}break}}l=l+1|0;if(o>>>0>(l&255)>>>0){continue}break}}sn(m);sn(j);sn(k)}m=1;j=Pp(d+168|0);if(!(c&1)){break s}v[113382]=0;U(704,d- -64|0,d+296|0,21076);b=v[113382];v[113382]=0;R:{S:{T:{if((b|0)!=1){b=Qd(d+280|0,d- -64|0);v[113382]=0;b=T(303,b|0)|0;c=v[113382];v[113382]=0;U:{V:{W:{X:{Y:{Z:{if((c|0)!=1){Bb(d- -64|0);_:{if(!b){break _}v[113382]=0;c=T(323,d+280|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break Z}v[113382]=0;R(713,j|0,c+1|0);b=v[113382];v[113382]=0;if((b|0)==1){break Z}if(!c){break _}b=1;while(1){v[113382]=0;e=T(323,d+280|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break Y}v[113382]=0;U(307,d- -64|0,d+280|0,e|0);e=v[113382];v[113382]=0;if((e|0)==1){break Y}e=d- -64|0;Qd(sc(j,b),e);g=(b|0)==(c|0);Bb(e);b=b+1|0;if(!g){continue}break}}v[113382]=0;U(704,d- -64|0,d+296|0,16720);b=v[113382];v[113382]=0;if((b|0)==1){break X}b=Qd(d+280|0,d- -64|0);v[113382]=0;b=T(303,b|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break W}Bb(d- -64|0);if(!b){break U}k=0;v[113382]=0;n=T(409,d+280|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break u}if(n){while(1){f=32;$:{if(w[d+332|0]>=16){v[113382]=0;Q(714,d+280|0,d- -64|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break T}b=w[d- -64|0];if(!(b>>>0<=x[a+480188>>1]|b>>>0>32)){u[a+480188>>1]=w[d- -64|0]}f=w[d- -64|0];if(!f){break $}}e=0;while(1){v[113382]=0;b=T(323,d+280|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break S}aa:{if(!b){break aa}b=e&65535;if(b>>>0>31|b>>>0<x[a+480188>>1]){break aa}u[a+480188>>1]=e+1}e=e+1|0;if((e&65535)>>>0<f>>>0){continue}break}}k=k+1|0;if(n>>>0>(k&65535)>>>0){continue}break}}v[113382]=0;Q(226,d+280|0,1)|0;b=v[113382];v[113382]=0;if((b|0)!=1){break V}break u}b=P()|0;O()|0;Bb(d- -64|0);break t}b=P()|0;O()|0;break t}b=P()|0;O()|0;break t}b=P()|0;O()|0;break t}b=P()|0;O()|0;Bb(d- -64|0);break t}v[113382]=0;o=a+484344|0;R(363,o|0,n|0);b=v[113382];v[113382]=0;if((b|0)==1){break u}if(!n){break U}b=d- -64|0;C=b|2;D=b|1;g=0;while(1){p=Xb(d+152|0);k=64;q=32;if(w[d+332|0]>=16){v[113382]=0;Q(714,d+280|0,d- -64|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break v}q=w[d- -64|0];b=w[D|0];v[113382]=0;U(715,d+48|0,3,C|0);c=v[113382];v[113382]=0;if((c|0)==1){break v}v[113382]=0;R(356,d+136|0,d+48|0);c=v[113382];v[113382]=0;if((c|0)==1){break v}c=d+136|0;Gb(p,c);yb(c);k=b+1|0}v[113382]=0;b=W(364,o|0,g&65535,k|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break v}ba:{if(!b){v[113382]=0;Q(304,d+280|0,q<<1)|0;b=v[113382];v[113382]=0;if((b|0)!=1){break ba}break v}b=Zb(o,g);v[113382]=0;Q(457,b|0,p|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break v}l=0;if(!q){break ba}while(1){v[113382]=0;b=T(323,d+280|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break v}ca:{if(!b){break ca}if(jd(j)>>>0<=b>>>0){break ca}r=l&65535;if(r>>>0>=x[a+480188>>1]){break ca}h=sc(j,b);Ic(h);c=0;while(1){v[113382]=0;b=Q(228,h|0,1)|0;e=v[113382];v[113382]=0;da:{ea:{fa:{ga:{ha:{ia:{if((e|0)!=1){if(!b){break ca}b=Zb(o,g);v[113382]=0;b=W(432,b|0,c|0,r|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break v}v[113382]=0;f=T(409,h|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break v}e=f>>>2|0;switch((f&3)-1|0){case 2:break fa;case 1:break ga;case 0:break ha;default:break ia}}break v}c=(c+e|0)+1|0;break da}if(!c){c=0;break da}f=Zb(o,g);v[113382]=0;f=W(432,f|0,c-1|0,r|0)|0;i=v[113382];v[113382]=0;if((i|0)!=1){while(1){i=w[f|0]|w[f+1|0]<<8|(w[f+2|0]<<16|w[f+3|0]<<24);t[b|0]=i;t[b+1|0]=i>>>8;t[b+2|0]=i>>>16;t[b+3|0]=i>>>24;i=w[f+4|0]|w[f+5|0]<<8;t[b+4|0]=i;t[b+5|0]=i>>>8;c=c+1|0;if(k>>>0<=c>>>0){break da}b=B(x[a+480188>>1],6)+b|0;i=e&255;e=e-1|0;if(i){continue}break da}}break v}if(c>>>0<=e>>>0){break ea}f=Zb(o,g);v[113382]=0;e=W(432,f|0,e|0,r|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break R}f=w[e|0]|w[e+1|0]<<8|(w[e+2|0]<<16|w[e+3|0]<<24);t[b|0]=f;t[b+1|0]=f>>>8;t[b+2|0]=f>>>16;t[b+3|0]=f>>>24;e=w[e+4|0]|w[e+5|0]<<8;t[b+4|0]=e;t[b+5|0]=e>>>8;break ea}if(e&1){v[113382]=0;f=T(409,h|0)|0;i=v[113382];v[113382]=0;if((i|0)==1){break R}t[b|0]=f>>>0>120?-1:f}if(e&2){v[113382]=0;f=T(409,h|0)|0;i=v[113382];v[113382]=0;if((i|0)==1){break R}t[b+1|0]=f}f=0;s=0;if(e&4){v[113382]=0;s=T(409,h|0)|0;i=v[113382];v[113382]=0;if((i|0)==1){break v}}y=0;if(e&8){v[113382]=0;f=T(409,h|0)|0;i=v[113382];v[113382]=0;if((i|0)==1){break v}y=f>>>4|0;f=f&15}i=0;z=0;if(e&16){v[113382]=0;z=T(409,h|0)|0;E=v[113382];v[113382]=0;if((E|0)==1){break v}}if(e&32){v[113382]=0;i=T(409,h|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break v}}v[113382]=0;ma(716,b|0,s|0,f|0,y|0,z|0,i|0);b=v[113382];v[113382]=0;if((b|0)==1){break v}}c=c+1|0}if(c>>>0<k>>>0){continue}break}}l=l+1|0;if((l&65535)>>>0<q>>>0){continue}break}}yb(p);g=g+1|0;if((n|0)!=(g|0)){continue}break}}v[113382]=0;U(704,d- -64|0,d+296|0,20048);b=v[113382];v[113382]=0;ja:{ka:{la:{if((b|0)!=1){b=Qd(d+280|0,d- -64|0);v[113382]=0;b=T(303,b|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break la}Bb(d- -64|0);if(!b){break s}a=a+484344|0;if(!Ae(a)){break s}while(1){v[113382]=0;b=Q(228,d+280|0,16)|0;c=v[113382];v[113382]=0;if((c|0)==1){break ka}if(!b){break s}v[113382]=0;W(717,d+280|0,d- -64|0,16)|0;b=v[113382];v[113382]=0;if((b|0)==1){break ja}b=Zb(a,0);v[113382]=0;Q(718,b|0,d- -64|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break ja}if(Ae(a)){continue}break}break s}b=P()|0;O()|0;break t}b=P()|0;O()|0;Bb(d- -64|0);break t}b=P()|0;O()|0;break t}b=P()|0;O()|0;break t}b=P()|0;O()|0;break t}b=P()|0;O()|0;break t}b=P()|0;O()|0;break t}break v}break n}b=P()|0;O()|0;break c}b=P()|0;O()|0;yb(p);break t}b=P()|0;O()|0}cd(j);break c}cd(j)}Bb(d+280|0);Pz(d+296|0);Bb(A)}jb=d+336|0;return m|0}b=P()|0;O()|0;break c}b=P()|0;O()|0;sn(m);sn(j);sn(k);break c}b=P()|0;O()|0;Bb(d- -64|0);break c}b=P()|0;O()|0;break c}b=P()|0;O()|0;break c}b=P()|0;O()|0;break c}b=P()|0;O()|0;break c}b=P()|0;O()|0;yb(d+168|0);break c}b=P()|0;O()|0;break c}b=P()|0;O()|0;break c}b=P()|0;O()|0;yb(d+152|0);break d}b=P()|0;O()|0}yb(e)}Bb(d+280|0)}Pz(d+296|0)}Bb(A);S(b|0);L()}function nga(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,z=0,A=0,C=0,D=0,E=0,F=0,G=0;d=jb-512|0;jb=d;Ic(b);a:{if(!xn(b,d+432|0)){break a}if(!tO(d+432|0)){break a}if(!Rb(b,dd(sO(d+432|0),mb))){break a}b:{if(!c){break b}Id(a,4);vi(a);v[a+1074372>>2]=4;k=bd(d+416|0);c:{d:{e:{f:{i=d+470|0;g:{if(!(md(i,13806,20)|(w[d+492|0]|w[d+493|0]<<8|(w[d+494|0]<<16|w[d+495|0]<<24))!=276)){if((w[d+490|0]|w[d+491|0]<<8)>>>0<260){break g}v[113382]=0;f=W(587,d+449|0,0,20)|0;e=v[113382];v[113382]=0;if((e|0)==1){break d}e=f?1154:34;break e}if(!md(i,13785,20)){e=1;break e}v[113382]=0;U(706,d+400|0,3,i|0);f=v[113382];v[113382]=0;h:{i:{j:{if((f|0)==1){break j}v[113382]=0;R(356,d+56|0,d+400|0);f=v[113382];v[113382]=0;if((f|0)==1){break j}v[113382]=0;U(13,d+128|0,4,d+56|0);f=v[113382];v[113382]=0;if((f|0)==1){break i}f=d+128|0;Gb(k,f);yb(f);yb(d+56|0);if((w[i|0]|w[i+1|0]<<8|(w[i+2|0]<<16|w[i+3|0]<<24))!=1852141647|(w[i+4|0]|w[i+5|0]<<8|(w[i+6|0]<<16|w[i+7|0]<<24))!=542396493){break h}e=1048;break e}e=P()|0;O()|0;break c}e=P()|0;O()|0;yb(d+56|0);break c}if(!md(i,13445,12)){e=16;if((x[d+482>>1]|x[d+484>>1]<<16)==538976288&(x[d+486>>1]|x[d+488>>1]<<16)==538976288){break e}v[a+1074372>>2]=5;break e}if(md(i,7655,20)){break f}}e=48;break e}if(!md(i,24192,15)){v[113382]=0;f=a+1074312|0;Q(440,f|0,54)|0;e=v[113382];v[113382]=0;C=1;if((e|0)==1){break d}v[113382]=0;Q(440,f|0,51)|0;f=v[113382];v[113382]=0;e=16;if((f|0)==1){break d}break e}if(!md(i,24208,14)){v[113382]=0;Q(440,a+1074312|0,57)|0;f=v[113382];v[113382]=0;e=16;if((f|0)!=1){break e}break d}e=md(i,13533,11)?16:256}v[113382]=0;s=d+449|0;U(706,d+56|0,3,s|0);f=v[113382];v[113382]=0;k:{l:{m:{n:{o:{if((f|0)==1){break o}v[113382]=0;R(356,d+128|0,d+56|0);f=v[113382];v[113382]=0;if((f|0)==1){break o}f=d+128|0;Gb(a+1304400|0,f);yb(f);v[a+480260>>2]=1;v[a+480264>>2]=31999;p=a+484360|0;Ne(Vb(p),w[d+498|0]|w[d+499|0]<<8);u[a+480188>>1]=w[d+500|0]|w[d+501|0]<<8;g=w[d+504|0]|w[d+505|0]<<8;v[113382]=0;u[d+128>>1]=g;u[d+56>>1]=255;f=Q(438,f|0,d+56|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break n}u[a+480192>>1]=x[f>>1];if(w[d+508|0]|w[d+509|0]<<8){v[a+480196>>2]=w[d+508|0]|w[d+509|0]<<8}if(w[d+510|0]|w[d+511|0]<<8){f=v[18622];F=a,G=Ed(B(w[d+510|0]|w[d+511|0]<<8,1e4),B(v[f+20>>2],1e4),B(v[f+24>>2],1e4)),v[F+480204>>2]=G}v[a+480208>>2]=0;v[a+480208>>2]=v[a+480208>>2]&-17|(w[d+506|0]|w[d+507|0]<<8)<<4&16;f=(w[d+506|0]|w[d+507|0]<<8)<<3&32768;v[a+480208>>2]=f|v[a+480208>>2]&-32769;g=Vb(p);l=w[d+496|0]|w[d+497|0]<<8;v[113382]=0;ea(544,g|0,b|0,l|0,65535,65535)|0;g=v[113382];v[113382]=0;if((g|0)==1){break d}g=f>>>15|0?(e|0)==34?146:e:e;if(!(g&1024|(w[d+496|0]|w[d+497|0]<<8))){f=Vb(p);v[113382]=0;U(996,f|0,1,0);f=v[113382];v[113382]=0;if((f|0)==1){break d}}f=w[d+492|0]|w[d+493|0]<<8|(w[d+494|0]<<16|w[d+495|0]<<24);v[113382]=0;Q(226,b|0,f+60|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break d}if((w[d+490|0]|w[d+491|0]<<8)>>>0>=260){v[113382]=0;U(997,b|0,d+432|0,a|0);f=v[113382];v[113382]=0;if((f|0)==1){break d}}t[d+399|0]=0;z=c&2;f=jb-16|0;jb=f;l=d+400|0;e=l;v[e>>2]=0;v[e+4>>2]=0;v[113382]=0;v[f+12>>2]=0;W(1019,e+8|0,f+12|0,f+8|0)|0;e=v[113382];v[113382]=0;p:{if((e|0)!=1){jb=f+16|0;break p}V(0)|0;O()|0;Ab();L()}f=-1;if(x[a+480192>>1]){break m}break l}e=P()|0;O()|0;break c}e=P()|0;O()|0;break c}D=d+74|0;E=d+161|0;e=1;m=1;while(1){q:{v[113382]=0;j=T(397,b|0)|0;h=v[113382];v[113382]=0;r:{s:{t:{u:{v:{w:{if((h|0)!=1){mg(b,4);v[113382]=0;W(998,b|0,d+128|0,(j?j:263)|0)|0;j=v[113382];v[113382]=0;if((j|0)==1){break q}x:{if((g|0)==1){if((w[d+128|0]|w[d+129|0]<<8|(w[d+130|0]<<16|w[d+131|0]<<24))==245){v[a+1074308>>2]=16777381;v[113382]=0;g=Q(2,d+56|0,9363)|0;j=v[113382];v[113382]=0;if((j|0)!=1){Gb(k,g);yb(g);g=17;break x}e=P()|0;O()|0;break k}g=16;if((w[d+128|0]|w[d+129|0]<<8|(w[d+130|0]<<16|w[d+131|0]<<24))!=263){break x}v[a+1074308>>2]=16777395;v[113382]=0;g=Q(2,d+56|0,9287)|0;j=v[113382];v[113382]=0;if((j|0)!=1){Gb(k,g);yb(g);g=17;break x}e=P()|0;O()|0;break k}if(w[d+155|0]|w[d+156|0]<<8){break x}if(!(!(g&2)|(w[d+157|0]|w[d+158|0]<<8|(w[d+159|0]<<16|w[d+160|0]<<24))|(w[d+128|0]|w[d+129|0]<<8|(w[d+130|0]<<16|w[d+131|0]<<24))!=263)){g=g|16;break x}if(!(!(g&256)|(w[d+128|0]|w[d+129|0]<<8|(w[d+130|0]<<16|w[d+131|0]<<24))==29)){g=g&-257;break x}if(!(g&160)){break x}g=(w[d+128|0]|w[d+129|0]<<8|(w[d+130|0]<<16|w[d+131|0]<<24))==33?g:0}v[113382]=0;j=W(411,a|0,m&65535,0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break q}if(!j){break r}j=((e<<2)+a|0)+900380|0;e=v[j>>2];v[113382]=0;R(999,d+128|0,e|0);e=v[113382];v[113382]=0;if((e|0)==1){break q}e=w[d+154|0];y:{if((f|0)==-1){f=e;break y}if(!(g&32)|(e|0)==(f|0)){break y}g=g&-161|128}if(!(w[d+155|0]|w[d+156|0]<<8)){break r}e=w[d+369|0];h=w[d+370|0];o=w[d+371|0]|w[d+372|0]<<8;n=w[d+375|0];q=w[d+155|0]|w[d+156|0]<<8;v[113382]=0;U(1e3,d+112|0,a|0,q|0);q=v[113382];v[113382]=0;if((q|0)==1){break w}g=n|(o|(e|h))?g&-4:g;e=12;while(1){h=x[_c(v[j>>2]+236|0,e)>>1];if(oc(d+112|0)>>>0>h>>>0){h=x[rc(d+112|0,x[_c(v[j>>2]+236|0,e)>>1])>>1];F=_c(v[j>>2]+236|0,e),G=h,u[F>>1]=G}e=e+1|0;if((e|0)!=108){continue}break}if((w[d+490|0]|w[d+491|0]<<8)>>>0>259){Kb(l);qO(l);ng(l)}e=w[d+155|0]|w[d+156|0]<<8;v[113382]=0;j=Q(1001,d+96|0,e|0)|0;e=v[113382];v[113382]=0;z:{if((e|0)!=1){e=0;if(w[d+155|0]|w[d+156|0]<<8){break z}break v}e=P()|0;O()|0;break t}A:{B:{C:{D:{while(1){v[113382]=0;Q(1002,b|0,d+56|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break A}v[113382]=0;R(1003,d+40|0,d+56|0);h=v[113382];v[113382]=0;E:{if((h|0)==1){break E}v[113382]=0;R(1004,l|0,d+40|0);h=v[113382];v[113382]=0;if((h|0)==1){break E}h=w[d+56|0]|w[d+57|0]<<8|(w[d+58|0]<<16|w[d+59|0]<<24);F=Pb(j,e),G=h,v[F>>2]=G;o=w[d+73|0];if(oc(d+112|0)>>>0>e>>>0){h=x[rc(d+112|0,e)>>1];v[113382]=0;n=(B(h,104)+a|0)+484380|0;R(1005,d+56|0,n|0);q=v[113382];v[113382]=0;if((q|0)==1){break D}v[113382]=0;R(1006,E|0,n|0);n=v[113382];v[113382]=0;if((n|0)==1){break D}v[113382]=0;U(550,d+24|0,3,D|0);n=v[113382];v[113382]=0;if((n|0)==1){break C}v[113382]=0;R(356,d+40|0,d+24|0);n=v[113382];v[113382]=0;if((n|0)==1){break C}v[113382]=0;Q(335,((h<<5)+a|0)+946304|0,d+40|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break B}yb(d+40|0);g=(w[d+70|0]&3)==3?(g&2)>>>1|0?g|4:g:g}r=o|r;e=e+1|0;if(e>>>0>=(w[d+155|0]|w[d+156|0]<<8)>>>0){break v}continue}break}e=P()|0;O()|0;break u}e=P()|0;O()|0;break u}e=P()|0;O()|0;break u}e=P()|0;O()|0;yb(d+40|0);break u}e=P()|0;O()|0;break u}e=P()|0;O()|0;break k}e=P()|0;O()|0;break k}if((w[d+490|0]|w[d+491|0]<<8)>>>0<260){break s}e=0;if(!(w[d+155|0]|w[d+156|0]<<8)){break s}F:{while(1){G:{o=w[Pb(l,e)+3|0];h=v[Pb(j,e)>>2];v[113382]=0;U(307,d+56|0,b|0,((o|0)==11?(h+1>>>1|0)+16|0:h)|0);h=v[113382];v[113382]=0;if((h|0)==1){break G}if(!(!z|oc(d+112|0)>>>0<=e>>>0)){o=x[rc(d+112|0,e)>>1];h=Pb(l,e);h=w[h|0]|w[h+1|0]<<8|(w[h+2|0]<<16|w[h+3|0]<<24);v[113382]=0;v[d+20>>2]=h;v[d+4>>2]=h;h=aa(1007,(B(o,104)+a|0)+484380|0,d+4|0,d+56|0,d+399|0)|0;o=v[113382];v[113382]=0;if((o|0)==1){break F}A=h^1|A}Bb(d+56|0);e=e+1|0;if(e>>>0<(w[d+155|0]|w[d+156|0]<<8)>>>0){continue}break s}break}e=P()|0;O()|0;break u}e=P()|0;O()|0;Bb(d+56|0)}ze(j)}nf(d+112|0);break k}ze(j);nf(d+112|0)}m=m+1|0;e=m&65535;if(e>>>0<=x[a+480192>>1]){continue}break l}break}e=P()|0;O()|0;break k}H:{I:{J:{K:{L:{M:{N:{O:{P:{Q:{R:{S:{T:{U:{V:{W:{X:{Y:{if(!(!(g&2)|r&255)){v[113382]=0;e=W(587,s|0,0,20)|0;j=v[113382];v[113382]=0;if((j|0)==1){break Y}g=e?g|16:g}Z:{if((w[d+490|0]|w[d+491|0]<<8)>>>0>259){break Z}if(c&3){v[113382]=0;U(997,b|0,d+432|0,a|0);c=v[113382];v[113382]=0;if((c|0)==1){break Y}}if(!z|!x[a+480190>>1]){break Z}c=1;e=1;while(1){j=Pb(l,c-1|0);v[113382]=0;W(362,j|0,(B(c,104)+a|0)+484380|0,b|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break X}e=e+1|0;c=e&65535;if(c>>>0<=x[a+480190>>1]){continue}break}}if(A&1){v[113382]=0;c=Q(2,d+128|0,12662)|0;e=v[113382];v[113382]=0;if((e|0)==1){break W}v[113382]=0;U(608,a|0,2,c|0);e=v[113382];v[113382]=0;if((e|0)==1){break V}yb(c)}v[113382]=0;c=Q(580,b|0,2044)|0;e=v[113382];v[113382]=0;if((e|0)==1){break Y}if(c){v[113382]=0;c=T(397,b|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break Y}v[113382]=0;aa(547,a+1304424|0,b|0,c|0,0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break Y}g=g|16}v[113382]=0;j=Q(580,b|0,10024)|0;c=v[113382];v[113382]=0;if((c|0)==1){break H}if(j){v[113382]=0;c=T(397,b|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break H}v[113382]=0;e=a+901404|0;W(1008,b|0,e|0,c|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break H}v[113382]=0;Z(595,e|0);c=v[113382];v[113382]=0;if((c|0)==1){break H}g=g|16}v[113382]=0;c=Q(580,b|0,9805)|0;e=v[113382];v[113382]=0;if((e|0)==1){break H}if(c){v[113382]=0;c=T(397,b|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break U}u[d+128>>1]=c>>>5;e=a+484344|0;c=Ae(e);v[113382]=0;u[d+56>>1]=c;c=Q(438,d+128|0,d+56|0)|0;m=v[113382];v[113382]=0;if((m|0)==1){break T}m=x[c>>1];if(m){c=0;while(1){v[113382]=0;W(830,b|0,d+128|0,32)|0;h=v[113382];v[113382]=0;if((h|0)==1){break S}h=Zb(e,c);v[113382]=0;Q(831,h|0,d+128|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break S}c=c+1|0;if((m|0)!=(c|0)){continue}break}}g=g|16}v[113382]=0;c=Q(580,b|0,9810)|0;e=v[113382];v[113382]=0;if((e|0)==1){break H}if(c){v[113382]=0;c=T(397,b|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break R}u[d+128>>1]=(c>>>0)/20;c=x[a+480188>>1];v[113382]=0;u[d+56>>1]=c;c=Q(438,d+128|0,d+56|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break Q}c=x[c>>1];if(c){e=0;while(1){v[113382]=0;W(597,b|0,((e<<5)+a|0)+480289|0,20)|0;m=v[113382];v[113382]=0;if((m|0)==1){break M}e=e+1|0;if((c|0)!=(e|0)){continue}break}}g=g|16}v[113382]=0;c=Q(228,b|0,8)|0;e=v[113382];v[113382]=0;if((e|0)==1){break H}if(c){c=v[b+8>>2];v[113382]=0;Q(598,a|0,b|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break L}g=(c|0)==v[b+8>>2]?g:g|16}if(!(g&16)){break N}if(!(g&4)){break O}v[a+1074308>>2]=17367040;v[113382]=0;c=Q(2,d+128|0,10385)|0;e=v[113382];v[113382]=0;if((e|0)==1){break P}Gb(k,c);yb(c);break N}e=P()|0;O()|0;break k}e=P()|0;O()|0;break k}e=P()|0;O()|0;break k}e=P()|0;O()|0;yb(c);break k}e=P()|0;O()|0;break k}e=P()|0;O()|0;break k}e=P()|0;O()|0;break k}e=P()|0;O()|0;break k}e=P()|0;O()|0;break k}e=P()|0;O()|0;break k}if(!(g&2)){break N}v[a+1074308>>2]=18219008;v[113382]=0;c=Q(2,d+128|0,10530)|0;e=v[113382];v[113382]=0;if((e|0)==1){break K}Gb(k,c);yb(c)}_:{if((w[i|0]|w[i+1|0]<<8|(w[i+2|0]<<16|w[i+3|0]<<24))==1852141647&(w[i+4|0]|w[i+5|0]<<8|(w[i+6|0]<<16|w[i+7|0]<<24))==542396493){v[113382]=0;g=W(1009,d+128|0,d+478|0,12)|0;c=v[113382];v[113382]=0;$:{aa:{ba:{if((c|0)!=1){v[113382]=0;U(13,d+56|0,1,g|0);c=v[113382];v[113382]=0;if((c|0)==1){break ba}v[113382]=0;e=T(1010,d+56|0)|0;i=v[113382];v[113382]=0;c=1;if((i|0)==1){break aa}v[a+1074308>>2]=e;yb(d+56|0);v[a+1074372>>2]=y[a+1074308>>2]<19007257?4:5;yb(g);e=a+1074308|0;g=24;break _}e=P()|0;O()|0;break k}e=P()|0;O()|0;break $}e=P()|0;O()|0;yb(d+56|0)}yb(g);break k}if(!(!v[a+1074308>>2]|g&8)){v[a+1074372>>2]=0;Ht(a+1074312|0)}e=a+1074308|0;if(!(g&32)){c=1;break _}v[a+1074372>>2]=5;if(!j){v[113382]=0;Z(596,a+901404|0);c=v[113382];v[113382]=0;if((c|0)==1){break H}}c=0;if((w[d+490|0]|w[d+491|0]<<8)>>>0<260){break _}v[113382]=0;W(439,a+1074312|0,4,1)|0;i=v[113382];v[113382]=0;if((i|0)==1){break H}}ca:{if(!Sc(k)){break ca}if(!(!(g&256)|r&255|f+1>>>0>1)){v[113382]=0;c=Q(2,d+128|0,4566)|0;f=v[113382];v[113382]=0;if((f|0)!=1){Gb(k,c);yb(c);break ca}e=P()|0;O()|0;break k}if(!c){v[113382]=0;c=Q(2,d+128|0,8067)|0;f=v[113382];v[113382]=0;if((f|0)!=1){Gb(k,c);yb(c);break ca}e=P()|0;O()|0;break k}v[113382]=0;c=Q(2,d+128|0,5715)|0;f=v[113382];v[113382]=0;if((f|0)==1){break J}Gb(k,c);yb(c)}t[d+24|0]=0;da:{if(x[a+480192>>1]){v[113382]=0;c=Q(614,a|0,b|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break da}t[d+24|0]=c}v[113382]=0;X(615,a|0,b|0,1,d+24|0);b=v[113382];v[113382]=0;if((b|0)==1){break da}if(!(!w[d+24|0]|y[e>>2]>=18284544)){v[e>>2]=18284544}ea:{fa:{ga:{ha:{ia:{ja:{ka:{la:{ma:{na:{oa:{pa:{qa:{ra:{sa:{b=v[e>>2];if(b>>>0>=18284544){v[113382]=0;b=Q(2,d+56|0,13545)|0;c=v[113382];v[113382]=0;if((c|0)==1){break sa}v[113382]=0;R(1011,d+112|0,e|0);c=v[113382];v[113382]=0;if((c|0)==1){break ra}v[113382]=0;U(3,d+128|0,b|0,d+112|0);c=v[113382];v[113382]=0;if((c|0)==1){break qa}c=d+128|0;Gb(k,c);yb(c);yb(d+112|0);yb(b);b=v[e>>2]}ta:{if(!b|y[e>>2]>=19005954){break ta}v[113382]=0;b=a+484344|0;c=Q(398,b|0,254)|0;f=v[113382];v[113382]=0;if((f|0)==1){break da}if(!c){c=Vb(p);v[113382]=0;R(1012,c|0,254);c=v[113382];v[113382]=0;if((c|0)==1){break da}}v[113382]=0;b=Q(398,b|0,255)|0;c=v[113382];v[113382]=0;if((c|0)==1){break da}if(b){break ta}b=Vb(p);v[113382]=0;c=da(925)|0;f=v[113382];v[113382]=0;if((f|0)==1){break da}v[113382]=0;U(1013,b|0,255,c|0);b=v[113382];v[113382]=0;if((b|0)==1){break da}}v[113382]=0;b=Q(2,d+8|0,11013)|0;c=v[113382];v[113382]=0;if((c|0)==1){break oa}v[113382]=0;R(189,d+56|0,b|0);c=v[113382];v[113382]=0;if((c|0)==1){break na}v[d+96>>2]=w[d+491|0];c=w[d+490|0];v[113382]=0;v[d+40>>2]=c;R(622,d+112|0,d+40|0);c=v[113382];v[113382]=0;if((c|0)==1){break ma}v[113382]=0;X(607,d+128|0,d+56|0,d+96|0,d+112|0);c=v[113382];v[113382]=0;if((c|0)==1){break la}c=a+1304436|0;f=d+128|0;Gb(c,f);yb(f);yb(d+112|0);Ib(d+56|0);yb(b);Gb(a+1304460|0,k);v[a+1304496>>2]=C?7:v[a+1074308>>2]?7:4;if(!w[d+399|0]){break fa}Gb(a+1304472|0,c);v[113382]=0;b=Q(2,d+128|0,11265)|0;f=v[113382];v[113382]=0;if((f|0)==1){break ia}Gb(c,b);yb(b);v[113382]=0;b=Q(2,d+128|0,6189)|0;c=v[113382];v[113382]=0;if((c|0)==1){break ha}Gb(a+1304448|0,b);yb(b);v[113382]=0;c=Q(2,d+128|0,6190)|0;b=v[113382];v[113382]=0;if((b|0)==1){break ga}Gb(a+1304484|0,c);break ea}e=P()|0;O()|0;break k}e=P()|0;O()|0;break pa}e=P()|0;O()|0;yb(d+112|0)}yb(b);break k}e=P()|0;O()|0;break k}e=P()|0;O()|0;break ja}e=P()|0;O()|0;break ka}e=P()|0;O()|0;yb(d+112|0)}Ib(d+56|0)}yb(b);break k}e=P()|0;O()|0;break k}e=P()|0;O()|0;break k}e=P()|0;O()|0;break k}v[113382]=0;c=Q(2,d+128|0,6190)|0;b=v[113382];v[113382]=0;if((b|0)==1){break I}Gb(a+1304448|0,c)}yb(c);rO(l);yb(k);break b}e=P()|0;O()|0;break k}e=P()|0;O()|0;break k}e=P()|0;O()|0;break k}e=P()|0;O()|0;break k}e=P()|0;O()|0;break k}e=P()|0;O()|0;break k}e=P()|0;O()|0}rO(l);break c}e=P()|0;O()|0}yb(k);S(e|0);L()}e=1}jb=d+512|0;return e|0}function Pga(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,z=0,A=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,M=0,N=0,X=0,Y=0,Z=0;e=jb-416|0;jb=e;Ic(b);f=jb-16|0;jb=f;h=f+8|0;j=e+208|0;CO(h,j);k=Hb(h);g=b;h=mc(g,$b(f,h));if((k|0)==(h|0)){_b(g,Hb(f+8|0))}jb=f+16|0;g=(h|0)==(k|0);if(!g){DO(j)}a:{if(!g){break a}if(!IO(e+208|0)){break a}if(!c){d=1;break a}Id(a,134217728);g=Ub(e+192|0,11475);v[113382]=0;R(189,e+144|0,g|0);d=v[113382];v[113382]=0;b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{if((d|0)!=1){v[113382]=0;o=e+208|4;U(966,e+16|0,e+144|0,o|0);d=v[113382];v[113382]=0;if((d|0)==1){break q}d=e+16|0;Gb(a+1304436|0,d);yb(d);Ib(e+144|0);yb(g);d=Ub(d,5148);Gb(a+1304448|0,d);yb(d);v[a+480188>>2]=4;v[a+1304496>>2]=2;d=w[e+344|0]|w[e+345|0]<<8;v[a+480196>>2]=(d<<8|d>>>8)&65535;d=w[e+348|0]|w[e+349|0]<<8;v[a+480260>>2]=56;v[a+480264>>2]=13696;Y=a,Z=HO((d<<8|d>>>8)&65535),v[Y+480204>>2]=Z;En(Vb(a+484360|0),e+216|0,w[e+208|6],65535,65535);r=a+480190|0;d=jb-16|0;jb=d;p=e+176|0;g=p;v[g>>2]=0;v[g+4>>2]=0;v[113382]=0;v[d+12>>2]=0;W(982,g+8|0,d+12|0,d+8|0)|0;g=v[113382];v[113382]=0;r:{if((g|0)!=1){jb=d+16|0;break r}V(0)|0;O()|0;Ab();L()}q=Sl(e+160|0);if(w[e+408|0]|w[e+409|0]<<8){break o}break n}d=P()|0;O()|0;break p}d=P()|0;O()|0;Ib(e+144|0)}yb(g);break d}while(1){v[113382]=0;d=T(445,b|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break i}u[e+120>>1]=d;if((d-1&65535)>>>0>=3999){break c}d=w[e+410|0]|w[e+411|0]<<8;if((w[o|0]|w[o+1|0]<<8)!=512){d=(d<<8|d>>>8)&65535}else{v[113382]=0;d=T(455,b|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break j}d=d-2|0}v[113382]=0;U(307,e+144|0,b|0,d|0);d=v[113382];v[113382]=0;s:{t:{u:{if((d|0)!=1){v[113382]=0;d=Q(408,r|0,e+120|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break u}C=x[d>>1];u[a+480190>>1]=C;v[113382]=0;d=B(x[e+120>>1],104)+a|0;f=d+484380|0;R(453,f|0,1);g=v[113382];v[113382]=0;v:{if((g|0)==1){break v}g=w[o|0]|w[o+1|0]<<8;if(((g<<8|g>>>8)&65535)>>>0>1){break t}v[113382]=0;W(967,e+144|0,d+484423|0,31)|0;g=v[113382];v[113382]=0;if((g|0)==1){break v}v[113382]=0;Q(304,e+144|0,1)|0;g=v[113382];v[113382]=0;if((g|0)==1){break v}v[113382]=0;W(968,e+144|0,((x[e+120>>1]<<5)+a|0)+946304|0,30)|0;g=v[113382];v[113382]=0;if((g|0)!=1){break s}}d=P()|0;O()|0;break f}d=P()|0;O()|0;break e}d=P()|0;O()|0;break f}g=Xb(e+16|0);v[113382]=0;W(559,e+144|0,g|0,257)|0;h=v[113382];v[113382]=0;w:{x:{if((h|0)==1){break x}v[113382]=0;Q(336,d+484423|0,g|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break x}v[113382]=0;Q(304,e+144|0,1)|0;h=v[113382];v[113382]=0;if((h|0)==1){break x}v[113382]=0;W(559,e+144|0,g|0,31)|0;h=v[113382];v[113382]=0;if((h|0)==1){break x}v[113382]=0;Q(335,((x[e+120>>1]<<5)+a|0)+946304|0,g|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break x}if(!(v[e+152>>2]&1)){break w}v[113382]=0;Q(304,e+144|0,1)|0;h=v[113382];v[113382]=0;if((h|0)!=1){break w}}d=P()|0;O()|0;yb(g);break f}yb(g)}v[113382]=0;Q(969,e+144|0,e+16|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break m}v[113382]=0;R(970,e+16|0,f|0);g=v[113382];v[113382]=0;if((g|0)==1){break m}if((w[o|0]|w[o+1|0]<<8)==512){t[d+484417|0]=w[e+34|0]<<3}y:{if(!(w[o|0]|w[o+1|0]<<8)){break y}v[113382]=0;R(350,q|0,C|0);g=v[113382];v[113382]=0;if((g|0)==1){break m}v[113382]=0;R(971,p|0,C|0);g=v[113382];v[113382]=0;if((g|0)==1){break m}g=od(p,x[e+120>>1]-1|0);xc(g);EO(g);dt(g);v[113382]=0;h=T(445,b|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break g}v[113382]=0;f=Q(228,b|0,h<<3)|0;j=v[113382];v[113382]=0;if((j|0)==1){break g}if(!f){Bb(e+144|0);break c}v[113382]=0;R(972,g|0,h|0);f=v[113382];v[113382]=0;if((f|0)==1){break g}f=0;v[e+136>>2]=0;if(!h){if(!(w[d+484414|0]&2)){break y}f=v[d+484384>>2];v[e+128>>2]=f;d=v[d+484388>>2];v[113382]=0;v[e+132>>2]=d-f;R(973,g|0,e+128|0);d=v[113382];v[113382]=0;if((d|0)!=1){break y}d=P()|0;O()|0;break f}while(1){v[113382]=0;d=T(455,b|0)|0;j=v[113382];v[113382]=0;if((j|0)==1){break k}v[113382]=0;v[e+128>>2]=d;d=T(455,b|0)|0;j=v[113382];v[113382]=0;if((j|0)==1){break k}v[113382]=0;v[e+132>>2]=d;R(973,g|0,e+128|0);d=v[113382];v[113382]=0;if((d|0)==1){break k}f=f+1|0;if(h>>>0>(f&65535)>>>0){continue}break}}Bb(e+144|0);m=m+1|0;d=w[e+408|0]|w[e+409|0]<<8;if((m&65535)>>>0<((d<<8|d>>>8)&65535)>>>0){continue}break}}D=128;if(w[o|0]|w[o+1|0]<<8){break l}v[113382]=0;D=T(445,b|0)|0;d=v[113382];v[113382]=0;if((d|0)!=1){break l}d=P()|0;O()|0;break e}d=P()|0;O()|0;break f}d=a+480188|0;E=w[e+208|7];u[e+126>>1]=4;z:{A:{if(w[o|0]|w[o+1|0]<<8){g=v[b+8>>2];B:{if(!D){break B}while(1){v[113382]=0;m=T(445,b|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break A}if((m|0)==65535){break B}v[113382]=0;E=T(445,b|0)|0;m=v[113382];v[113382]=0;if((m|0)==1){break A}v[113382]=0;m=T(445,b|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break A}u[e+126>>1]=m;if(m>>>0>127){break c}v[113382]=0;m=Q(408,d|0,e+126|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break A}u[d>>1]=x[m>>1];v[113382]=0;Q(304,b|0,B(x[e+126>>1],E)<<2)|0;m=v[113382];v[113382]=0;if((m|0)==1){break A}n=n+1|0;if((n&65535)>>>0<D>>>0){continue}break}}v[113382]=0;Q(226,b|0,g|0)|0;m=v[113382];v[113382]=0;if((m|0)==1){break z}}d=x[d>>1];v[113382]=0;G=Q(974,e+144|0,d|0)|0;d=v[113382];v[113382]=0;if((d|0)!=1){C:{if(!D){break C}K=a+484344|0;X=c&1;H=w[e+347|0];g=0;m=0;while(1){D:{if(!(w[o|0]|w[o+1|0]<<8)){f=x[e+126>>1];d=m;break D}v[113382]=0;d=T(445,b|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break h}if((d|0)==65535){break C}v[113382]=0;E=T(445,b|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break h}v[113382]=0;f=T(445,b|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break h}u[e+126>>1]=f}v[113382]=0;h=f&65535;F=E&65535;f=F<<2;h=Q(228,b|0,B(h,f)|0)|0;j=v[113382];v[113382]=0;if((j|0)==1){break h}if(!h){break C}E:{F:{G:{if(!X){break G}v[113382]=0;M=d&65535;d=W(364,K|0,M|0,F|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break h}if(!d){break G}s=0;if(F){break F}break E}v[113382]=0;Q(304,b|0,B(f,x[e+126>>1])|0)|0;d=v[113382];v[113382]=0;if((d|0)!=1){break E}break h}while(1){d=Zb(K,M);v[113382]=0;j=Q(458,d|0,s|0)|0;d=v[113382];v[113382]=0;H:{if((d|0)!=1){f=0;A=0;I:{J:{switch((H&3)-1|0){case 0:A=!(s&3);break I;case 1:A=!(s&1);break I;case 2:break J;default:break I}}A=(s&3)!=3}I=0;if(!x[e+126>>1]){break H}while(1){d=v[G>>2];v[113382]=0;R(557,e+128|0,b|0);h=v[113382];v[113382]=0;if((h|0)==1){break h}h=B(f,9)+d|0;d=e+128|0;k=Zc(d);z=Cf(d);i=Ph(d);l=j+B(f,6)|0;t[l+1|0]=w[d|0];d=w[k|0];t[l|0]=d;i=w[i|0];t[l+5|0]=i;k=l+5|0;if(d){t[l|0]=d+25;t[h+8|0]=0;t[h|0]=0;t[h+1|0]=0;t[h+2|0]=0;t[h+3|0]=0;t[h+4|0]=0;t[h+5|0]=0;t[h+6|0]=0;t[h+7|0]=0;i=w[k|0]}n=i&255;z=w[z|0];K:{if(z>>>0>=240){d=n|(z&15)<<8;if(d){d=HO(d);v[113382]=0;d=Ba(975,+(+(d>>>0)*1e-4))|0;i=v[113382];v[113382]=0;if((i|0)!=1){t[k|0]=d;t[l+3|0]=17;break K}break h}t[l+3|0]=0;break K}J=n>>>4|0;N=n<<4;d=J|N;L:{switch(z|0){case 0:d=j+B(f,6)|0;if(i&255){t[d+3|0]=1;break K}t[d+3|0]=0;break K;case 1:t[(j+B(f,6)|0)+3|0]=2;break K;case 2:t[(j+B(f,6)|0)+3|0]=3;break K;case 3:v[113382]=0;t[e+16|0]=15;d=Q(415,k|0,e+16|0)|0;i=v[113382];v[113382]=0;if((i|0)!=1){t[h|0]=w[d|0]|16;t[h+7|0]=0;t[h+1|0]=0;t[h+2|0]=0;t[(j+B(f,6)|0)+3|0]=0;break K}break h;case 4:v[113382]=0;t[e+16|0]=15;d=Q(415,k|0,e+16|0)|0;i=v[113382];v[113382]=0;if((i|0)!=1){t[h|0]=w[d|0]|32;t[h+7|0]=0;t[h+1|0]=0;t[h+2|0]=0;t[(j+B(f,6)|0)+3|0]=0;break K}break h;case 5:t[h+7|0]=0;t[h+2|0]=0;t[h+1|0]=i;t[h|0]=0;t[(j+B(f,6)|0)+3|0]=0;break K;case 6:t[h+7|0]=0;t[h+2|0]=i;t[h|0]=0;t[h+1|0]=0;t[(j+B(f,6)|0)+3|0]=0;break K;case 7:t[(j+B(f,6)|0)+3|0]=23;g=0;break K;case 8:t[(j+B(f,6)|0)+3|0]=0;g=d;break K;case 9:t[(j+B(f,6)|0)+3|0]=19;v[113382]=0;t[e+16|0]=15;d=Q(415,k|0,e+16|0)|0;i=v[113382];v[113382]=0;if((i|0)!=1){t[k|0]=w[d|0]|16;break K}break h;case 10:t[(j+B(f,6)|0)+3|0]=19;v[113382]=0;t[e+16|0]=15;d=Q(415,k|0,e+16|0)|0;i=v[113382];v[113382]=0;if((i|0)!=1){t[k|0]=w[d|0]|32;break K}break h;case 11:t[h+3|0]=d;t[(j+B(f,6)|0)+3|0]=0;break K;case 12:d=j+B(f,6)|0;t[d+4|0]=i;t[d+2|0]=1;t[h+3|0]=0;t[d+3|0]=0;break K;case 13:z=j+B(f,6)|0;M:{N:{if(n&240){t[(j+B(f,6)|0)+2|0]=4;d=(i&240)>>>4|0;break N}if(!(n&15)){break M}t[(j+B(f,6)|0)+2|0]=3;d=i&15}t[z+4|0]=d}t[h+3|0]=0;t[(j+B(f,6)|0)+3|0]=0;break K;case 14:t[(j+B(f,6)|0)+3|0]=19;t[k|0]=!(i&255);break K;case 15:t[(j+B(f,6)|0)+3|0]=16;t[k|0]=(i&240)>>>4;H=i&15;break K;case 16:t[h+5|0]=0;t[h+4|0]=i;t[(j+B(f,6)|0)+3|0]=0;break K;case 17:t[h+6|0]=n&15?i:0;t[(j+B(f,6)|0)+3|0]=0;break K;case 18:t[(j+B(f,6)|0)+3|0]=14;break K;case 19:t[h+8|0]=0;t[h+7|0]=i;t[h+2|0]=0;t[h|0]=0;t[h+1|0]=0;t[(j+B(f,6)|0)+3|0]=0;break K;case 20:t[(j+B(f,6)|0)+3|0]=12;break K;case 22:O:{d=w[l+1|0];P:{if(!d){break P}if(xc(p)>>>0<d>>>0){break P}d=od(p,w[l+1|0]-1|0);i=w[k|0]-1|0;t[k|0]=i;v[113382]=0;Q(976,e+16|0,0)|0;n=v[113382];v[113382]=0;if((n|0)==1){break h}v[e+120>>2]=9;d=xc(d);v[113382]=0;v[e+12>>2]=d;d=Q(33,e+120|0,e+12|0)|0;n=v[113382];v[113382]=0;if((n|0)==1){break O}if(y[d>>2]<=(i&255)>>>0){break P}d=j+B(f,6)|0;t[d+2|0]=15;t[d+4|0]=w[k|0]}t[(j+B(f,6)|0)+3|0]=0;break K}break h;case 23:d=w[l+1|0];Q:{if(!d){break Q}if(xc(p)>>>0<d>>>0){break Q}d=od(p,w[l+1|0]-1|0);i=w[k|0]-1|0;t[k|0]=i;if(xc(d)>>>0<=(i&255)>>>0){break Q}R:{if(x[od(d,w[k|0])+8>>1]){break R}if(!An(a)){break R}i=x[r>>1]+1|0;u[r>>1]=i;Y=od(d,w[k|0]),Z=i,u[Y+8>>1]=Z}Y=l,Z=w[od(d,w[k|0])+8|0],t[Y+1|0]=Z}t[(j+B(f,6)|0)+3|0]=0;break K;case 24:S:{d=w[l+1|0];T:{if(!d){break T}if(xc(p)>>>0<d>>>0){break T}d=od(p,w[l+1|0]-1|0);i=w[k|0]-1|0;t[k|0]=i;v[113382]=0;Q(976,e+16|0,0)|0;n=v[113382];v[113382]=0;if((n|0)==1){break h}v[e+120>>2]=9;d=xc(d);v[113382]=0;v[e+12>>2]=d;d=Q(33,e+120|0,e+12|0)|0;n=v[113382];v[113382]=0;if((n|0)==1){break S}if(y[d>>2]>(i&255)>>>0){d=j+B(f,6)|0;t[d+2|0]=15;t[d+4|0]=w[k|0]}U:{if(x[rc(q,w[l+1|0]-1|0)>>1]){break U}if(!An(a)){break U}d=x[r>>1]+1|0;u[r>>1]=d;Y=rc(q,w[l+1|0]-1|0),Z=d,u[Y>>1]=Z}Y=l,Z=w[rc(q,w[l+1|0]-1|0)|0],t[Y+1|0]=Z}t[(j+B(f,6)|0)+3|0]=0;break K}break h;case 25:d=w[l+1|0];V:{if(!d){break V}if(xc(p)>>>0<d>>>0){break V}d=od(p,w[l+1|0]-1|0);i=w[k|0]-1|0;t[k|0]=i;if(xc(d)>>>0<=(i&255)>>>0){break V}W:{if(x[od(d,w[k|0])+10>>1]){break W}if(!An(a)){break W}i=x[r>>1]+1|0;u[r>>1]=i;Y=od(d,w[k|0]),Z=i,u[Y+10>>1]=Z}Y=l,Z=w[od(d,w[k|0])+10|0],t[Y+1|0]=Z}t[(j+B(f,6)|0)+3|0]=0;break K;case 29:t[(j+B(f,6)|0)+3|0]=11;t[k|0]=d;if(n&15){t[k|0]=N|15;break K}if((i&255)>>>0<16){break K}t[k|0]=J|240;break K;case 32:if(n&240){t[h+3|0]=J;t[(j+B(f,6)|0)+3|0]=0;break K}t[(j+B(f,6)|0)+3|0]=19;t[k|0]=i&15|192;break K;case 33:t[(j+B(f,6)|0)+3|0]=19;v[113382]=0;t[e+16|0]=15;d=Q(415,k|0,e+16|0)|0;i=v[113382];v[113382]=0;if((i|0)!=1){t[k|0]=w[d|0]|208;break K}break h;case 34:t[(j+B(f,6)|0)+3|0]=19;v[113382]=0;t[e+16|0]=15;d=Q(415,k|0,e+16|0)|0;i=v[113382];v[113382]=0;if((i|0)!=1){t[k|0]=w[d|0]|144;break K}break h;case 73:t[(j+B(f,6)|0)+3|0]=10;break K;case 78:if((i&112|128)==224){t[(j+B(f,6)|0)+3|0]=19;break K}t[(j+B(f,6)|0)+3|0]=0;break K;case 79:d=j+B(f,6)|0;if((i&255)>>>0<=31){t[d+3|0]=16;H=0;break K}t[d+3|0]=17;break K;default:break L}}t[(j+B(f,6)|0)+3|0]=0}n=0;i=w[h+3|0];if(!(w[l+2|0]|!i)){X:{if(i>>>0>=16){t[l+2|0]=5;i=i>>>4|0;break X}t[l+2|0]=6}t[l+4|0]=i;n=1}Y:{if(w[l+3|0]){break Y}d=w[h+1|0];Z:{if(d){t[l+3|0]=2;break Z}d=w[h+2|0];if(d){t[l+3|0]=3;break Z}d=w[h|0];if(d){t[l+3|0]=19;break Z}d=w[h+7|0];if(d){t[l+3|0]=4;t[h+8|0]=d;break Z}d=w[h+4|0];if(d){t[l+3|0]=5;t[h+5|0]=d;break Z}d=w[h+3|0];if(!(!d|n)){t[l+3|0]=11;t[k|0]=d;if(d&15){d=d|-16;break Z}if(!(d&240)){break Y}d=d|15;break Z}d=w[h+6|0];if(d){t[l+3|0]=8;break Z}if(A){t[l+3|0]=20;A=0;d=97;break Z}A=0;if(I){break Y}d=g&255;if(!d){break Y}t[l+3|0]=24;t[k|0]=g;if(g&15){d=g|-16}else{if(!(d&240)){I=1;break Y}d=g|15}I=1}t[k|0]=d}f=f+1|0;if(f>>>0<x[e+126>>1]){continue}break}break H}break h}s=s+1|0;if((F|0)!=(s|0)){continue}break}}m=m+1|0;if((m&65535)>>>0<D>>>0){continue}break}}v[a+480228>>2]=256/x[a+480188>>1];v[113382]=0;R(405,a|0,1);d=v[113382];v[113382]=0;if((d|0)==1){break h}if(w[o|0]|w[o+1|0]<<8){_:{while(1){v[113382]=0;d=Q(228,b|0,2)|0;m=v[113382];v[113382]=0;if((m|0)==1){break h}if(!d){break _}v[113382]=0;d=T(445,b|0)|0;m=v[113382];v[113382]=0;if((m|0)==1){break h}if((d|0)==65535){break _}v[113382]=0;Q(304,b|0,2)|0;d=v[113382];v[113382]=0;if((d|0)==1){break h}v[113382]=0;d=T(455,b|0)|0;m=v[113382];v[113382]=0;if((m|0)!=1){v[113382]=0;Q(304,b|0,d|0)|0;d=v[113382];v[113382]=0;if((d|0)!=1){continue}}break}break h}v[113382]=0;Q(304,b|0,34)|0;d=v[113382];v[113382]=0;if((d|0)==1){break h}}$:{if(!(!(c&2)|!C)){d=1;m=1;while(1){c=(B(d,104)+a|0)+484380|0;aa:{if(!v[c>>2]){break aa}g=Yc(e+16|0,8,1,0,0);v[113382]=0;W(362,g|0,c|0,b|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break $}if(xc(p)>>>0<d>>>0){break aa}d=d-1|0;g=od(p,d);v[113382]=0;R(977,c|0,g|0);g=v[113382];v[113382]=0;ba:{if((g|0)!=1){if(!x[rc(q,d)>>1]){break ba}g=x[rc(q,d)>>1];f=v[c>>2];v[113382]=0;fa(978,c|0,(B(g,104)+a|0)+484380|0,0,f|0,0);g=v[113382];v[113382]=0;if((g|0)!=1){break ba}}break h}d=od(p,d);Y=e,Z=ac(d),v[Y+16>>2]=Z;Y=e,Z=bc(d),v[Y+128>>2]=Z;if(!Jb(e+16|0,e+128|0)){break aa}while(1){d=v[e+16>>2];g=x[d+8>>1];if(g){f=v[d+4>>2];h=v[d>>2];v[113382]=0;fa(978,c|0,(B(g,104)+a|0)+484380|0,h|0,f|0,1);g=v[113382];v[113382]=0;if((g|0)==1){break h}}g=x[d+10>>1];if(g){f=v[d+4>>2];d=v[d>>2];v[113382]=0;fa(978,c|0,(B(g,104)+a|0)+484380|0,d|0,f|0,0);d=v[113382];v[113382]=0;if((d|0)==1){break h}}d=e+16|0;vn(d);if(Jb(d,e+128|0)){continue}break}}m=m+1|0;d=m&65535;if(C>>>0>=d>>>0){continue}break}}bz(G);d=1;break b}break h}d=P()|0;O()|0;break e}d=P()|0;O()|0;break e}d=P()|0;O()|0;break e}d=P()|0;O()|0;break f}d=P()|0;O()|0;break e}d=P()|0;O()|0;break e}d=P()|0;O()|0;bz(G);break e}d=P()|0;O()|0}Bb(e+144|0)}nf(q);FO(p)}S(d|0);L()}d=0}nf(q);FO(p)}jb=e+416|0;return d|0}function Yga(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,y=0,z=0,A=0,C=0,D=0,E=0,F=0;d=jb-304|0;jb=d;Ic(b);a:{b:{c:{d:{e:{f:{g:{h:{if(!gt(b,d+208|0)){break h}if(!SO(d+208|0)){break h}if(!Rb(b,dd(RO(d+208|0),mb))){break h}if(!c){r=1;break h}Id(a,2);v[a+480260>>2]=64;v[a+480264>>2]=32767;k=bd(d+192|0);i:{j:{k:{l:{m:{n:{o:{switch(((w[d+248|0]|w[d+249|0]<<8)&61440)-4096>>>12|0){case 0:p:{if(w[d+270|0]|w[d+271|0]<<8|(w[d+248|0]|w[d+249|0]<<8)!=4896|(w[d+260|0]|w[d+240|0]&15)){break p}if((w[d+246|0]|w[d+247|0]<<8)&65455){break p}q:{if(t[d+259|0]<0){v[a+1074308>>2]=18219008;v[113382]=0;e=Q(2,d+32|0,10455)|0;g=v[113382];v[113382]=0;if((g|0)!=1){break q}f=P()|0;O()|0;break a}v[a+1074308>>2]=16777216;v[113382]=0;e=Q(2,d+32|0,9363)|0;g=v[113382];v[113382]=0;if((g|0)==1){break n}}Gb(k,e);yb(e);v[113382]=0;i=1;W(439,a+1074312|0,81,1)|0;h=v[113382];v[113382]=0;e=1;g=0;if((h|0)!=1){break i}break b}r:{if(w[d+270|0]|w[d+271|0]<<8|(w[d+248|0]|w[d+249|0]<<8)!=4896|(w[d+260|0]|(w[d+246|0]|w[d+247|0]<<8))){break r}if(w[d+261|0]){break r}v[113382]=0;e=Q(2,d+32|0,5486)|0;g=v[113382];v[113382]=0;if((g|0)!=1){Gb(k,e);break j}f=P()|0;O()|0;break a}v[113382]=0;g=Q(2,d+32|0,4782)|0;i=v[113382];v[113382]=0;f=1;if((i|0)!=1){Gb(k,g);yb(g);break k}f=P()|0;O()|0;break a;case 1:v[113382]=0;g=Q(2,d+32|0,3098)|0;i=v[113382];v[113382]=0;e=1;if((i|0)!=1){Gb(k,g);yb(g);break k}f=P()|0;O()|0;break a;case 2:s:{t:{u:{v:{w:{h=w[d+248|0]|w[d+249|0]<<8;x:{if(h>>>0<=12820){v[113382]=0;e=Q(2,d+32|0,4813)|0;g=v[113382];v[113382]=0;if((g|0)!=1){Gb(k,e);break x}f=P()|0;O()|0;break a}v[113382]=0;e=Q(2,d+160|0,11515)|0;g=v[113382];v[113382]=0;if((g|0)==1){break w}v[113382]=0;R(189,d+176|0,e|0);g=v[113382];v[113382]=0;if((g|0)==1){break v}g=w[d+248|0]|w[d+249|0]<<8;v[113382]=0;v[d+144>>2]=g-12820;U(215,d+32|0,d+176|0,d+144|0);g=v[113382];v[113382]=0;if((g|0)==1){break u}g=d+32|0;Gb(k,g);yb(g);Ib(d+176|0)}yb(e);if((w[d+248|0]|w[d+249|0]<<8)>>>0<12807){break l}if(w[d+264|0]|w[d+265|0]<<8|(w[d+266|0]<<16|w[d+267|0]<<24)){break s}break l}f=P()|0;O()|0;break a}f=P()|0;O()|0;break t}f=P()|0;O()|0;Ib(d+176|0)}yb(e);break a}e=w[d+248|0]|w[d+249|0]<<8;g=w[d+264|0]|w[d+265|0]<<8|(w[d+266|0]<<16|w[d+267|0]<<24);v[113382]=0;e=Q(623,e|0,g|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break m}g=Vp(d+32|0);v[g+44>>2]=e;v[113382]=0;R(624,a+1304500|0,g|0);e=v[113382];v[113382]=0;if((e|0)!=1){break l}f=P()|0;O()|0;break a;case 3:if((w[d+248|0]|w[d+249|0]<<8)==16640){v[113382]=0;f=Q(2,d+32|0,4614)|0;g=v[113382];v[113382]=0;e=1;if((g|0)!=1){Gb(k,f);yb(f);v[113382]=0;W(439,a+1074312|0,81,1)|0;h=v[113382];v[113382]=0;f=0;g=0;if((h|0)==1){break b}break i}f=P()|0;O()|0;break a}e=w[d+248|0]|w[d+249|0]<<8;g=w[d+262|0]|w[d+263|0]<<8;v[113382]=0;U(625,d+32|0,e|0,g|0);g=v[113382];v[113382]=0;e=1;if((g|0)!=1){g=d+32|0;Gb(k,g);yb(g);v[a+480260>>2]=1;h=w[d+248|0]|w[d+249|0]<<8;g=1;if((VR(16384)|0)>(h|0)){break i}v[113382]=0;W(439,a+1074312|0,38,1)|0;h=v[113382];v[113382]=0;if((h|0)==1){break b}break i}f=P()|0;O()|0;break a;case 4:h=(w[d+248|0]|w[d+249|0]<<8)&4095;e=h<<16;g=a;if(h>>>0>=297){e=e|(w[d+262|0]|w[d+263|0]<<8)}v[g+1074308>>2]=e;v[113382]=0;e=Q(2,d+176|0,13545)|0;g=v[113382];v[113382]=0;y:{z:{A:{if((g|0)!=1){v[113382]=0;R(212,d+144|0,a+1074308|0);g=v[113382];v[113382]=0;if((g|0)==1){break A}v[113382]=0;U(3,d+32|0,e|0,d+144|0);g=v[113382];v[113382]=0;if((g|0)==1){break z}g=d+32|0;Gb(k,g);yb(g);yb(d+144|0);break j}f=P()|0;O()|0;break a}f=P()|0;O()|0;break y}f=P()|0;O()|0;yb(d+144|0)}yb(e);break a;case 5:v[113382]=0;e=Q(2,d+32|0,4614)|0;g=v[113382];v[113382]=0;if((g|0)!=1){Gb(k,e);yb(e);v[113382]=0;W(439,a+1074312|0,81,1)|0;h=v[113382];v[113382]=0;e=0;g=0;if((h|0)==1){break b}break i}f=P()|0;O()|0;break a;case 6:v[113382]=0;e=Q(2,d+32|0,4640)|0;g=v[113382];v[113382]=0;if((g|0)!=1){Gb(k,e);break j}f=P()|0;O()|0;break a;default:break o}}if((w[d+248|0]|w[d+249|0]<<8)!=51712){break i}v[113382]=0;e=Q(2,d+32|0,5299)|0;g=v[113382];v[113382]=0;if((g|0)!=1){Gb(k,e);break j}f=P()|0;O()|0;break a}f=P()|0;O()|0;break a}f=P()|0;O()|0;break a}v[113382]=0;g=a+1074312|0;W(439,g|0,23,1)|0;e=v[113382];v[113382]=0;if((e|0)==1){break b}v[113382]=0;W(439,g|0,38,1)|0;e=v[113382];v[113382]=0;if((e|0)==1){break b}v[113382]=0;e=1;W(439,g|0,107,1)|0;g=v[113382];v[113382]=0;if((g|0)==1){break b}v[a+480260>>2]=1;g=0;if(h>>>0>12820){break i}}v[113382]=0;g=Q(2,d+128|0,10803)|0;i=v[113382];v[113382]=0;B:{C:{D:{E:{F:{if((i|0)!=1){v[113382]=0;R(189,d+176|0,g|0);i=v[113382];v[113382]=0;if((i|0)==1){break F}v[d+16>>2]=w[d+249|0]&15;i=w[d+248|0];v[113382]=0;v[d>>2]=i;R(622,d+144|0,d|0);i=v[113382];v[113382]=0;if((i|0)==1){break E}v[113382]=0;fa(959,d+32|0,d+176|0,k|0,d+16|0,d+144|0);i=v[113382];v[113382]=0;if((i|0)==1){break D}i=d+32|0;Gb(k,i);yb(i);yb(d+144|0);Ib(d+176|0);yb(g);i=0;g=0;break i}f=P()|0;O()|0;break a}f=P()|0;O()|0;break B}f=P()|0;O()|0;break C}f=P()|0;O()|0;yb(d+144|0)}Ib(d+176|0)}yb(g);break a}yb(e);e=0;g=0}v[113382]=0;h=Q(2,d+32|0,10836)|0;m=v[113382];v[113382]=0;G:{H:{I:{J:{K:{L:{M:{N:{O:{P:{Q:{R:{S:{T:{U:{V:{if((m|0)!=1){Gb(a+1304436|0,h);yb(h);v[113382]=0;h=Q(2,d+32|0,6562)|0;m=v[113382];v[113382]=0;if((m|0)==1){break V}Gb(a+1304448|0,h);yb(h);Gb(a+1304460|0,k);v[a+1304496>>2]=v[a+1074308>>2]?7:4;if(e){v[113382]=0;e=a+1074312|0;Q(440,e|0,77)|0;h=v[113382];v[113382]=0;if((h|0)==1){break b}v[113382]=0;Q(440,e|0,78)|0;h=v[113382];v[113382]=0;if((h|0)==1){break b}v[113382]=0;Q(440,e|0,79)|0;h=v[113382];v[113382]=0;if((h|0)==1){break b}v[113382]=0;Q(440,e|0,80)|0;h=v[113382];v[113382]=0;if((h|0)==1){break b}v[113382]=0;Q(440,e|0,82)|0;h=v[113382];v[113382]=0;if((h|0)==1){break b}v[113382]=0;Q(440,e|0,96)|0;e=v[113382];v[113382]=0;if((e|0)==1){break b}}e=w[d+248|0]|w[d+249|0]<<8;h=e&61440;i=h>>>0<4097|(h|0)==12288&e>>>0<12820?i:1;v[113382]=0;e=a+901404|0;Z(960,e|0);h=v[113382];v[113382]=0;if((h|0)==1){break b}if(!i){v[113382]=0;Z(596,e|0);e=v[113382];v[113382]=0;if((e|0)==1){break b}}v[113382]=0;U(540,d+176|0,1,d+208|0);e=v[113382];v[113382]=0;if((e|0)==1){break U}v[113382]=0;R(356,d+32|0,d+176|0);e=v[113382];v[113382]=0;if((e|0)==1){break U}e=d+32|0;Gb(a+1304400|0,e);yb(e);if(w[d+246|0]&16){v[a+480208>>2]=v[a+480208>>2]|65536}if(t[d+246|0]&1){v[a+480208>>2]=v[a+480208>>2]|131072}if(!(w[d+246|0]&64?0:(w[d+248|0]|w[d+249|0]<<8)!=4864)){v[a+480208>>2]=v[a+480208>>2]|2}e=w[d+257|0];v[a+480196>>2]=e;W:{X:{if(e){if((e|0)!=255){break X}e=0;if(!f){break W}}v[a+480196>>2]=6}e=f}v[a+480204>>2]=B(w[d+258|0],1e4);if(w[d+258|0]<=32){v[a+480204>>2]=e?125e4:32e4}f=w[d+256|0];v[113382]=0;t[d+32|0]=f;t[d+176|0]=64;f=Q(415,d+32|0,d+176|0)|0;i=v[113382];v[113382]=0;if((i|0)==1){break Q}f=w[f|0];v[a+480200>>2]=f<<2;if(!((w[d+248|0]|w[d+249|0]<<8)>>>0>4895|f)){v[a+480200>>2]=256}if((w[d+250|0]|w[d+251|0]<<8)!=1|w[d+259|0]>7){break S}f=w[d+259|0];v[113382]=0;v[d+32>>2]=(f<<4)+16;v[d+176>>2]=127;f=Q(420,d+32|0,d+176|0)|0;i=v[113382];v[113382]=0;if((i|0)==1){break T}v[a+480228>>2]=v[f>>2];break R}f=P()|0;O()|0;break a}f=P()|0;O()|0;break a}f=P()|0;O()|0;break a}f=P()|0;O()|0;break a}if(!(w[d+259|0]!=2&w[d+259|0]!=18)){v[a+480228>>2]=32;break R}if(!(w[d+259|0]&127)){v[a+480228>>2]=48;break R}f=w[d+259|0];v[113382]=0;v[d+32>>2]=f&127;v[d+176>>2]=16;f=Q(515,d+32|0,d+176|0)|0;i=v[113382];v[113382]=0;if((i|0)==1){break P}v[a+480228>>2]=v[f>>2]}l=v[a+1074308>>2]!=0|t[d+259|0]<0;if(!l){f=v[a+480228>>2];v[113382]=0;f=qg(711,tma(f<<3|5,f>>>29|0,11,0),mb);i=v[113382];v[113382]=0;if((i|0)==1){break O}v[a+480228>>2]=f}v[a+480232>>2]=36;if(!(!g|(w[d+248|0]|w[d+249|0]<<8)>>>0>=19763)){v[a+480232>>2]=64}u[a+480188>>1]=4;i=It(d+120|0);f=0;while(1){v[113382]=0;g=(f<<5)+a|0;j=g+480280|0;Z(387,j|0);h=v[113382];v[113382]=0;if((h|0)==1){break N}h=d+f|0;m=w[h+272|0];Y:{if(w[h+272|0]==255){break Y}u[a+480188>>1]=f+1;if(!l){break Y}u[g+480284>>1]=m&8?204:51}if(t[h+272|0]<0){v[j>>2]=1024}if(((m&127)-16&255)>>>0<=13){u[g+480284>>1]=128;g=d+32|0;Pj(g,i,f);ce(g,1)}f=f+1|0;if((f|0)!=32){continue}break}if(!x[a+480188>>1]){u[a+480188>>1]=1}f=Vb(a+484360|0);g=w[d+240|0]|w[d+241|0]<<8;v[113382]=0;ea(544,f|0,b|0,g|0,255,254)|0;f=v[113382];v[113382]=0;if((f|0)==1){break c}p=eq(d+176|0);f=w[d+242|0]|w[d+243|0]<<8;v[113382]=0;W(359,b|0,p|0,f|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break e}m=eq(d+144|0);f=w[d+244|0]|w[d+245|0]<<8;v[113382]=0;W(359,b|0,m|0,f|0)|0;f=v[113382];v[113382]=0;if((f|0)!=1){if(w[d+261|0]==252){f=0;v[113382]=0;Q(961,b|0,d+32|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break g}while(1){h=(d+32|0)+f|0;g=w[h|0];Z:{if(!(g&32)){break Z}l=((f<<5)+a|0)+480284|0;if(e){g=d+16|0;Pj(g,i,f);if(Cb(g)){break Z}g=w[h|0]}u[l>>1]=(((g&15)<<8|8)>>>0)/15}f=f+1|0;if((f|0)!=32){continue}break}}g=w[d+242|0]|w[d+243|0]<<8;f=0;v[113382]=0;u[d+32>>1]=g;u[d+16>>1]=3999;g=Q(438,d+32|0,d+16|0)|0;i=v[113382];v[113382]=0;if((i|0)==1){break M}g=x[g>>1];u[a+480190>>1]=g;if(g){g=c&2;i=d+80|0;while(1){h=rc(p,f);h=w[h|0]|w[h+1|0]<<8;v[113382]=0;h=Q(226,b|0,h<<4)|0;l=v[113382];v[113382]=0;if((l|0)==1){break L}_:{if(!h){break _}v[113382]=0;h=Q(962,b|0,d+32|0)|0;l=v[113382];v[113382]=0;if((l|0)==1){break L}if(!h){break _}v[113382]=0;h=f+1|0;l=(B(h,104)+a|0)+484380|0;U(963,d+32|0,l|0,e|0);j=v[113382];v[113382]=0;if((j|0)==1){break L}v[113382]=0;U(540,d|0,1,i|0);j=v[113382];v[113382]=0;$:{aa:{ba:{if((j|0)==1){break ba}v[113382]=0;R(356,d+16|0,d|0);j=v[113382];v[113382]=0;if((j|0)==1){break ba}v[113382]=0;Q(335,((h<<5)+a|0)+946304|0,d+16|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break aa}yb(d+16|0);if(!(w[d+48|0]|w[d+49|0]<<8|(w[d+50|0]<<16|w[d+51|0]<<24))|(!g|w[d+32|0]>1)){break _}h=w[d+46|0];j=w[d+47|0];n=w[d+45|0];v[113382]=0;h=Q(226,b|0,j<<12|h<<4|n<<20)|0;j=v[113382];v[113382]=0;if((j|0)==1){break $}if(!h){break _}h=w[d+250|0]|w[d+251|0]<<8;v[113382]=0;U(964,d+16|0,d+32|0,(h|0)==1|0);h=v[113382];v[113382]=0;if((h|0)!=1){v[113382]=0;W(362,d+16|0,l|0,b|0)|0;h=v[113382];v[113382]=0;if((h|0)!=1){break _}}f=P()|0;O()|0;break f}f=P()|0;O()|0;break f}f=P()|0;O()|0;yb(d+16|0);break f}f=P()|0;O()|0;break f}f=f+1|0;if(f>>>0<x[a+480190>>1]){continue}break}}r=1;if(!(c&1)){break G}c=w[d+248|0]|w[d+249|0]<<8;e=w[d+244|0]|w[d+245|0]<<8;v[113382]=0;u[d+32>>1]=e;u[d+16>>1]=255;e=Q(438,d+32|0,d+16|0)|0;f=v[113382];v[113382]=0;ca:{da:{if((f|0)!=1){q=x[e>>1];v[113382]=0;i=a+484344|0;R(363,i|0,q|0);e=v[113382];v[113382]=0;if((e|0)==1){break da}s=c>>>0<4896;if(q){break ca}l=0;j=0;break H}f=P()|0;O()|0;break f}f=P()|0;O()|0;break f}c=d+32|0;A=c|5;C=c|3;y=c|4;D=c|2;E=c|1;g=0;j=0;l=0;while(1){v[113382]=0;c=W(364,i|0,g&65535,64)|0;e=v[113382];v[113382]=0;if((e|0)==1){break K}ea:{if(!c){break ea}c=rc(m,g);if(!(w[c|0]|w[c+1|0]<<8)){break ea}c=rc(m,g);c=w[c|0]|w[c+1|0]<<8;v[113382]=0;c=Q(226,b|0,c<<4)|0;e=v[113382];v[113382]=0;if((e|0)==1){break K}if(!c){break ea}v[113382]=0;Q(304,b|0,2)|0;c=v[113382];v[113382]=0;if((c|0)==1){break K}f=0;c=Zb(i,g);v[113382]=0;z=Q(458,c|0,0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break J}while(1){v[113382]=0;n=T(409,b|0)|0;c=v[113382];v[113382]=0;fa:{ga:{if((c|0)!=1){if(n){break ga}if(f>>>0>62){break ea}c=Zb(i,g);v[113382]=0;f=f+1|0;z=Q(458,c|0,f|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){break fa}}f=P()|0;O()|0;break f}F=Oh(d+32|0);e=n&31;c=e>>>0<x[a+480188>>1];h=B(e,6)+z|0;if(n&32){v[113382]=0;R(433,d+16|0,b|0);e=v[113382];v[113382]=0;ha:{ia:{ja:{if((e|0)!=1){e=d+16|0;o=Zc(e);e=w[e|0];if(e>>>0>239){break ja}e=(B(e>>>4|0,12)+(e&15)|0)+13|0;break ia}f=P()|0;O()|0;break f}ka:{switch(e-254|0){case 0:break ia;case 1:break ka;default:break ha}}e=0}t[(c?h:d+32|0)|0]=e}t[(c?h+1|0:E)|0]=w[o|0]}la:{if(!(n&64)){break la}v[113382]=0;e=T(409,b|0)|0;o=v[113382];v[113382]=0;ma:{if((o|0)!=1){o=c?h+2|0:D;t[d+16|0]=e;if(e>>>0>192|e<<24>>24>=0){break ma}t[o|0]=2;t[(c?h+4|0:y)|0]=w[d+16|0]^128;break la}f=P()|0;O()|0;break f}t[o|0]=1;v[113382]=0;t[d|0]=64;e=Q(415,d+16|0,d|0)|0;o=v[113382];v[113382]=0;if((o|0)==1){break I}t[(c?h+4|0:y)|0]=w[e|0]}if(!(n&128)){break fa}v[113382]=0;R(433,d+16|0,b|0);e=v[113382];v[113382]=0;na:{if((e|0)!=1){e=d+16|0;o=Zc(e);n=c?h+3|0:C;t[n|0]=w[e|0];e=c?h+5|0:A;t[e|0]=w[o|0];dz(c?h:F,0);oa:{c=w[n|0];if((c|0)==20){if((w[e|0]&240)!=160){break fa}if((w[d+248|0]|w[d+249|0]<<8)>>>0<4896){break oa}c=w[n|0]}if((c|0)!=31){break fa}c=w[e|0];if(c>>>0<=15){break na}s=0;break fa}t[e|0]=w[e|0]&15^136;break fa}f=P()|0;O()|0;break f}if(c>>>0<=7){j=j+1|0;break fa}l=((c|0)!=8)+l|0}if(f>>>0<64){continue}break}}g=g+1|0;if((q|0)!=(g|0)){continue}break}break H}f=P()|0;O()|0;break f}f=P()|0;O()|0;break a}f=P()|0;O()|0;break a}f=P()|0;O()|0;break a}f=P()|0;O()|0;break a}f=P()|0;O()|0;break f}f=P()|0;O()|0;break f}f=P()|0;O()|0;break f}f=P()|0;O()|0;break f}f=P()|0;O()|0;break f}if(!s){break G}a=x[a+480188>>1];if((a|0)>(j+l|0)|(a|0)<=(l-j|0)){break G}c=Ae(i)-1&65535;a=0;f=0;if(Ae(i)>>>0>c>>>0){while(1){if(qh(Fe(i,a))){b=ac(Fe(i,a));e=bc(Fe(i,a));a=jb-16|0;jb=a;v[a>>2]=e;v[a+8>>2]=b;if(Jb(a+8|0,a)){while(1){e=a+8|0;b=v[e>>2];if(w[b+3|0]==31){t[b+3|0]=20;t[b+5|0]=w[b+5|0]|128}Bj(e);if(Jb(e,a)){continue}break}}jb=a+16|0}f=f+1|0;a=f&65535;if(c>>>0>=a>>>0){continue}break}}}Aj(m);Aj(p);yb(k)}jb=d+304|0;return r|0}f=P()|0;O()|0}Aj(m);break d}f=P()|0;O()|0}Aj(p);break a}f=P()|0;O()|0;break a}f=P()|0;O()|0}yb(k);S(f|0);L()}function b1(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,y=0,A=0,D=0,E=0,F=0,G=0,H=C(0),I=0,J=0,K=0,L=0,M=C(0),N=0,O=0,P=0,Q=0,R=C(0),S=0,T=0,U=C(0),V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=C(0);D=jb-17168|0;jb=D;v[D+17164>>2]=0;a:{b:{c:{if(w[a+6152|0]!=255|(c|0)<5){break c}if(!Eo(a+6152|0,b)){break c}k=Kw(b,v[a+6148>>2])+Do(b)|0;v[D+17164>>2]=k;if((c|0)==(k|0)){k=c;break b}d:{if((k+4|0)<=(c|0)){if(Eo(b,b+k|0)){break d}}v[D+17164>>2]=0;break c}if(k){break b}}g=b;n=Qb(a,0,6668)+6148|0;I=D+17164|0;f=c;e:{if((f|0)>=5){J=f-4|0;while(1){if(OG(g)){y=Kw(g,v[n>>2]);k=y+Do(g)|0;j=0;f:{g:{if(y){break g}l=4;q=h+4|0;while(1){if((J|0)<=((l<<1)+h|0)){break f}y=0;r=g+l|0;h:{if(!Eo(g,r)){break h}s=l-Do(g)|0;F=Do(r)+s|0;if((f|0)<(F+(l+q|0)|0)){break h}if(!Eo(g,r+F|0)){break h}v[n>>2]=s;y=s;k=l}j=!y;if(y){break g}s=l>>>0<2303;l=l+1|0;if(s){continue}break}}if((f|0)<(h+k|0)|j){break f}s=g;l=f-h|0;j=0;o=0;i:{while(1){F=j+s|0;j=(Kw(F,y)+j|0)+Do(F)|0;q=(o|0)!=0;if((l|0)<(j+4|0)){break i}q=0;if(!Eo(s,j+s|0)){break i}o=o+1|0;if((o|0)!=10){continue}break}q=1}if(q){break e}}if(!((f|0)!=(k|0)|h)){h=0;k=f;break e}v[n>>2]=0}g=g+1|0;h=h+1|0;if((J|0)!=(h|0)){continue}break}}k=0;h=f}v[I>>2]=k;o=h;k=v[D+17164>>2];if((h+k|0)<=(c|0)?k:0){break b}v[e>>2]=o;o=0;break a}F=b+o|0;v[a+6152>>2]=w[F|0]|w[F+1|0]<<8|(w[F+2|0]<<16|w[F+3|0]<<24);v[e+4>>2]=o;v[e>>2]=k+o;v[e+8>>2]=w[F+3|0]>191?1:2;ba=e,ca=SG(F),v[ba+12>>2]=ca;v[e+16>>2]=4-(w[F+1|0]>>>1&3);ba=e,ca=Jw(F),v[ba+20>>2]=ca;if(!d){o=Iw(F);break a}QG(D+17152|0,F+4|0,k-4|0);if(!(t[F+1|0]&1)){Od(D+17152|0,16)}j:{if(v[e+16>>2]==3){o=0;r=D+17152|0;k=D+3740|0;h=0;c=F;g=w[c+1|0];b=B((g>>>3&1)+(g>>>4&1)|0,3)+(w[c+2|0]>>>2&3)|0;f=b-((b|0)!=0)|0;l=w[c+3|0]>191?1:2;k:{if(g&8){j=Od(r,9);l=l<<1;h=Od(r,l+7|0);break k}j=Od(r,l|8)>>>l|0}b=B(f,40);I=b+39824|0;q=b+40144|0;s=B(f,23)+39632|0;A=-1;l:{while(1){g=w[c+3|0];f=Od(r,12);u[k+4>>1]=f;b=Od(r,9);u[k+6>>1]=b;if((b&65535)>>>0>288){break l}y=g>>>0>191?h<<4:h;ba=k,ca=Od(r,8),t[ba+10|0]=ca;b=Od(r,w[c+1|0]&8?4:9);t[k+13|0]=22;t[k+14|0]=0;v[k>>2]=s;u[k+8>>1]=b;m:{if(Od(r,1)){b=Od(r,2);t[k+11|0]=b;if(!(b&255)){break l}h=Od(r,1);u[k+18>>1]=65287;t[k+12|0]=h;if(w[k+11|0]==2){b=k;n:{if(!(h&255)){v[k>>2]=I;t[k+18|0]=8;g=39;h=0;break n}v[k>>2]=q;g=30;h=w[c+1|0]&8?8:6}t[b+14|0]=g;t[k+13|0]=h;y=y&3855}b=Od(r,10);ba=k,ca=Od(r,3),t[ba+21|0]=ca;ba=k,ca=Od(r,3),t[ba+22|0]=ca;ba=k,ca=Od(r,3),t[ba+23|0]=ca;h=b<<5;break m}t[k+11|0]=0;t[k+12|0]=0;h=Od(r,15);ba=k,ca=Od(r,4),t[ba+18|0]=ca;b=Od(r,3);t[k+20|0]=255;t[k+19|0]=b}t[k+17|0]=h&31;t[k+15|0]=h>>>10;t[k+16|0]=h>>>5&31;i=(f&65535)+i|0;b=k;o:{if(w[c+1|0]&8){f=Od(r,1);break o}f=x[k+8>>1]>499}t[b+24|0]=f;ba=k,ca=Od(r,1),t[ba+25|0]=ca;b=Od(r,1);t[k+27|0]=y>>>12&15;t[k+26|0]=b;k=k+28|0;h=y<<4;l=l-1|0;if(l){continue}break}A=(v[r+4>>2]+i|0)>(v[r+8>>2]+(j<<3)|0)?-1:j}if(!((A|0)<0|v[D+17156>>2]>v[D+17160>>2])){s=D+17152|0;h=v[s+4>>2];k=v[s+8>>2];c=D+912|0;f=v[a+6144>>2];b=f-A|0;g=(f|0)>(A|0)?A:f;f=lc(c+12|0,(((b|0)>0?b:0)+a|0)+6156|0,g);b=(k-h|0)/8|0;lc(f+g|0,v[s>>2]+(v[s+4>>2]/8|0)|0,b);QG(c,f,b+g|0);k=v[a+6144>>2]>=(A|0);if(k){Y=a+2304|0;o=v[e+8>>2];Z=D+8620|0;_=D+3852|0;b=0;while(1){$=Qb(_,0,4608);s=D+912|0;y=(B(B(b,o),28)+D|0)+3740|0;l=0;r=a;J=r+6152|0;if((o|0)>0){h=s+7548|0;while(1){f=B(l,28)+y|0;L=x[f+4>>1];N=v[s+4>>2];O=(s+B(l,39)|0)+16156|0;q=s;i=h;g=l;n=jb-48|0;jb=n;j=f;S=!w[f+13|0]+(w[f+14|0]!=0)|0;V=w[f+25|0];c=n;A=c+44|0;I=J;p:{if(w[J+1|0]&8){p=w[j+27|0];m=w[x[j+8>>1]+40560|0];g=m&3;t[n+47|0]=g;t[n+46|0]=g;g=m>>>2|0;t[n+45|0]=g;t[n+44|0]=g;g=B(S,28)+40464|0;break p}g=w[I+3|0]>>>4&(g|0)!=0;G=g?12:0;Q=x[j+8>>1]>>>g|0;while(1){E=1;m=3;while(1){g=m;p=w[(g+G|0)+40576|0];t[g+(n+44|0)|0]=((Q|0)/(E|0)|0)%(p|0);E=B(p,E);m=g-1|0;if(g){continue}break}G=G+4|0;Q=Q-E|0;if((Q|0)>=0){continue}break}p=-16;g=(B(S,28)+40464|0)+G|0}E=0;while(1){P=w[g+E|0];if(P){q:{if(p&8){lc(c,O,P);break q}T=w[A+E|0];if(!T){Qb(c,0,P);Qb(O,0,P);break q}m=(p|0)>=0?-1:-1<<T^-1;G=0;while(1){S=Od(q,T);t[G+O|0]=(m|0)==(S|0)?-1:S;t[c+G|0]=S;G=G+1|0;if((P|0)!=(G|0)){continue}break}}p=p<<1;c=c+P|0;O=O+P|0;E=E+1|0;if((E|0)!=4){continue}}break}t[c+2|0]=0;t[c|0]=0;t[c+1|0]=0;m=w[j+14|0];r:{if(m){c=2-V|0;p=w[j+23|0]<<c;q=w[j+22|0]<<c;g=w[j+21|0]<<c;c=w[j+13|0];E=0;while(1){A=n+(c+E|0)|0;t[A|0]=g+w[A|0];t[A+1|0]=q+w[A+1|0];t[A+2|0]=p+w[A+2|0];E=E+3|0;if(m>>>0>E>>>0){continue}break}break r}if(!w[j+24|0]){break r}p=0;while(1){c=n+p|0;t[c+11|0]=w[c+11|0]+w[p+40600|0];p=p+1|0;if((p|0)!=10){continue}break}}M=Hw(C(2048),((((w[I+3|0]&224)==96)<<1)-w[j+10|0]|0)+258|0);p=0;if((m|0)!=(0-w[j+13|0]|0)){c=V+1|0;while(1){ba=i+(p<<2)|0,da=Hw(M,w[n+p|0]<<c),z[ba>>2]=da;p=p+1|0;if(p>>>0<w[j+14|0]+w[j+13|0]>>>0){continue}break}}jb=n+48|0;n=(s+B(l,2304)|0)+2940|0;c=h;S=L+N|0;H=C(0);X=0;I=s;g=v[s+4>>2];q=v[s>>2]+((g|0)/8|0)|0;i=w[q|0]|w[q+1|0]<<8|(w[q+2|0]<<16|w[q+3|0]<<24);i=(i<<24|i<<8&16711680|(i>>>8&65280|i>>>24))<<(g&7);m=g|-8;K=q+4|0;q=f;E=v[f>>2];G=x[f+6>>1];s:{if(!G){G=0;break s}while(1){f=q+X|0;g=w[f+15|0];W=(u[(g<<1)+45024>>1]<<1)+40640|0;O=w[f+18|0];t:{if(g>>>0>=16){L=w[g+45088|0];A=32-L|0;while(1){N=w[E|0]>>>1|0;p=G>>>0>N>>>0?N:G;H=z[c>>2];while(1){j=u[W+(i>>>26&62)>>1];if((j|0)<0){f=5;while(1){i=i<<f;m=f+m|0;g=j&7;f=g;j=u[W+((i>>>32-f|0)-(j<<16>>19)<<1)>>1];if((j|0)<0){continue}break}}P=j&65535;f=P>>>8|0;m=f+m|0;i=i<<f;Q=1;while(1){aa=n;f=P&15;u:{if((f|0)==15){j=i<<L;f=(i>>>A|0)+15|0;m=m+L|0;if((m|0)>=0){while(1){j=w[K|0]<<m|j;i=m>>>0>7;m=m-8|0;K=K+1|0;if(i){continue}break}}U=C(H*C(j>>31|1));i=f;v:{if((f|0)<=128){R=z[(i<<2)+45184>>2];break v}T=i<<3;g=i;i=i>>>0<1024;V=i?T:g;T=V<<1&64;M=C(C((V&63)-T|0)/C(T+(V&-64)|0));R=C(C(C(C(C(C(M*C(.2222222238779068))+C(1.3333333730697632))*M)+C(1))*(i?C(16):C(256)))*z[(V+T>>6<<2)+45184>>2])}U=C(U*R);break u}j=i;U=C(z[(((i>>>27&16|f)^16)<<2)+45120>>2]*H)}z[aa>>2]=U;P=P>>>4|0;n=n+4|0;f=(f|0)!=0;m=f+m|0;i=j<<f;f=Q&1;Q=0;if(f){continue}break}if((m|0)>=0){while(1){i=w[K|0]<<m|i;f=m>>>0>7;m=m-8|0;K=K+1|0;if(f){continue}break}}p=p-1|0;if(p){continue}break}c=c+4|0;E=E+1|0;G=G-N|0;if((G|0)<=0){break t}f=(O|0)>0;O=O-1|0;if(f){continue}break}break t}while(1){p=w[E|0]>>>1|0;Q=p>>>0<G>>>0?p:G;H=z[c>>2];while(1){j=u[W+(i>>>26&62)>>1];if((j|0)<0){f=5;while(1){i=i<<f;m=f+m|0;g=j&7;f=g;j=u[W+((i>>>32-f|0)-(j<<16>>19)<<1)>>1];if((j|0)<0){continue}break}}j=j&65535;f=j>>>8|0;m=f+m|0;i=i<<f;f=1;while(1){g=j&15;z[n>>2]=z[(((g|i>>>27&16)^16)<<2)+45120>>2]*H;j=j>>>4|0;n=n+4|0;g=(g|0)!=0;m=g+m|0;i=i<<g;g=f&1;f=0;if(g){continue}break}if((m|0)>=0){while(1){i=w[K|0]<<m|i;f=m>>>0>7;m=m-8|0;K=K+1|0;if(f){continue}break}}Q=Q-1|0;if(Q){continue}break}c=c+4|0;E=E+1|0;G=G-p|0;if((G|0)<=0){break t}f=(O|0)>0;O=O-1|0;if(f){continue}break}}X=X+1|0;if((G|0)>0){continue}break}}f=1-G|0;while(1){w:{g=w[q+26|0]?45008:44976;j=w[g+(i>>>28|0)|0];if(!(j&8)){j=w[g+((i<<4>>>32-(j&3))+(j>>>3)|0)|0]}g=j&7;m=g+m|0;if((S|0)<((m+(K-v[I>>2]<<3)|0)-24|0)){break w}f=f-1|0;if(!f){f=w[E|0];if(f>>>0<2){break w}E=E+1|0;H=z[c>>2];f=f>>>1|0;c=c+4|0}i=i<<g;if(j&128){z[n>>2]=(i|0)<0?C(-H):H;m=m+1|0;i=i<<1}if(j&64){z[n+4>>2]=(i|0)<0?C(-H):H;m=m+1|0;i=i<<1}f=f-1|0;if(!f){f=w[E|0];if(f>>>0<2){break w}E=E+1|0;H=z[c>>2];f=f>>>1|0;c=c+4|0}if(j&32){z[n+8>>2]=(i|0)<0?C(-H):H;m=m+1|0;i=i<<1}if(j&16){z[n+12>>2]=(i|0)<0?C(-H):H;m=m+1|0;i=i<<1}if((m|0)>=0){while(1){i=w[K|0]<<m|i;g=m>>>0>7;m=m-8|0;K=K+1|0;if(g){continue}break}}n=n+16|0;continue}break}v[I+4>>2]=S;l=l+1|0;if((o|0)!=(l|0)){continue}break}}c=w[r+6155|0];x:{if(c&16){j=0;L=jb-16|0;jb=L;p=s+2940|0;f=p+2304|0;i=y;m=v[i>>2];n=w[i+14|0];A=n+w[i+13|0]|0;I=A;N=L+4|0;v[N+8>>2]=-1;v[N>>2]=-1;v[N+4>>2]=-1;if(A){while(1){c=0;q=j+m|0;g=w[q|0];h=0;y:{if(!g){break y}z:{while(1){l=c<<2;if(z[l+f>>2]!=C(0)|z[(l|4)+f>>2]!=C(0)){break z}c=c+2|0;if(g>>>0>c>>>0){continue}break}h=g;break y}v[N+((j>>>0)%3<<2)>>2]=j;h=w[q|0]}f=((h&255)<<2)+f|0;j=j+1|0;if((I|0)!=(j|0)){continue}break}}if(w[i+13|0]){f=v[L+12>>2];h=v[L+8>>2];c=v[L+4>>2];c=(c|0)<(h|0)?h:c;c=(c|0)<(f|0)?f:c;v[L+12>>2]=c;v[L+8>>2]=c;v[L+4>>2]=c}N=s+16195|0;g=n?3:1;f=A-g|0;j=0;while(1){h=f+j|0;c=h-g|0;if((c|0)<=v[(L+4|0)+(j<<2)>>2]){c=w[J+1|0]<<28>>31&3}else{c=w[c+N|0]}t[h+N|0]=c;j=j+1|0;if((g|0)!=(j|0)){continue}break}I=L+4|0;q=u[i+36>>1]&1;f=0;l=v[i>>2];c=w[l|0];if(c){i=w[J+1|0]&8?7:64;g=l;while(1){h=w[J+3|0]&32;A:{B:{if(v[I+((f>>>0)%3<<2)>>2]>=(f|0)){break B}n=w[f+N|0];if(n>>>0>=i>>>0){break B}R=h?C(1.4142135381698608):C(1);C:{if(w[J+1|0]&8){h=(n<<3)+45712|0;M=z[h>>2];H=z[h+4>>2];break C}M=Hw(C(1),n+1>>>1<<q);h=n&1;H=h?C(1):M;M=h?M:C(1)}h=p;U=C(M*R);M=C(H*R);m=0;if((c|0)>0){while(1){n=h+(m<<2)|0;R=z[n>>2];z[n+2304>>2]=R*M;z[n>>2]=R*U;m=m+1|0;if((m|0)!=(c|0)){continue}break}}break A}if(!h){break A}NG(p,c)}p=(w[g|0]<<2)+p|0;f=f+1|0;g=l+f|0;c=w[g|0];if(c){continue}break}}jb=L+16|0;break x}if((c&224)!=96){break x}NG(s+2940|0,576)}if((o|0)>0){c=s+7708|0;l=0;while(1){h=w[r+6153|0];J=(w[y+12|0]!=0)<<1<<((B((h>>>3&1)+(h>>>4&1)|0,3)+(w[r+6154|0]>>>2&3)|0)==2);q=(s+B(l,2304)|0)+2940|0;m=q;if(w[y+14|0]){g=((s+B(l,2304)|0)+B(J,72)|0)+2940|0;f=c;p=f;K=v[y>>2]+w[y+13|0]|0;A=w[K|0];if(A){h=g;while(1){I=A<<1;n=0;while(1){z[p>>2]=z[h>>2];z[p+4>>2]=z[(A<<2)+h>>2];i=I<<2;z[p+8>>2]=z[i+h>>2];h=h+4|0;p=p+12|0;n=n+1|0;if((n|0)!=(A|0)){continue}break}h=h+i|0;A=w[K+3|0];K=K+3|0;if(A){continue}break}}lc(g,f,p-f|0);i=J-1|0}else{i=31}if((i|0)>0){while(1){h=0;while(1){f=h<<2;g=f+m|0;f=f+45776|0;H=z[f>>2];R=z[g+72>>2];U=z[f+32>>2];f=(17-h<<2)+m|0;M=z[f>>2];z[g+72>>2]=C(H*R)-C(U*M);z[f>>2]=C(U*R)+C(H*M);h=h+1|0;if((h|0)!=8){continue}break}m=m+72|0;h=(i|0)>1;i=i-1|0;if(h){continue}break}}h=q;i=r+B(l,1152)|0;f=w[y+11|0];if(J){MG(h,i,45840,J);i=B(J,36)+i|0;h=B(J,72)+h|0}D:{if((f|0)==2){j=jb-80|0;jb=j;g=32-J|0;if((g|0)>0){n=j|8;J=j|4;while(1){I=lc(j,h,72);f=v[i+20>>2];v[h+16>>2]=v[i+16>>2];v[h+20>>2]=f;f=v[i+12>>2];v[h+8>>2]=v[i+8>>2];v[h+12>>2]=f;f=v[i+4>>2];v[h>>2]=v[i>>2];v[h+4>>2]=f;f=i+24|0;Gw(I,h+24|0,f);Gw(J,h+48|0,f);Gw(n,i,f);h=h+72|0;i=i+36|0;f=g>>>0>1;g=g-1|0;if(f){continue}break}}jb=j+80|0;break D}MG(h,i,B((f|0)==3,72)+45840|0,32-J|0)}g=0;j=q+72|0;while(1){h=1;while(1){f=(h<<2)+j|0;z[f>>2]=-z[f>>2];f=h>>>0<16;h=h+2|0;if(f){continue}break}j=j+144|0;h=g>>>0<30;g=g+2|0;if(h){continue}break}y=y+28|0;l=l+1|0;if((o|0)!=(l|0)){continue}break}}PG(Y,$,18,v[e+8>>2],d,Z);o=v[e+8>>2];d=B(o,1152)+d|0;b=b+1|0;if(b>>>0<(w[F+1|0]&8?2:1)>>>0){continue}break}}b=a;g=D+912|0;d=v[g+8>>2]>>>3|0;c=v[g+4>>2]+7>>>3|0;f=d-c|0;h=(f|0)>511;e=h?511:f;if((f|0)>0){_i(b+6156|0,(g+(h?d-511|0:c)|0)+12|0,e)}v[b+6144>>2]=e;break j}Lw(a);break a}q=D+17152|0;o=0;k=0;y=0;b=D;s=b;h=0;E:{F:{G:{c=F;f=w[c+3|0];g=f>>>6|0;switch(g-1|0){case 2:break E;case 0:break G;default:break F}}h=(f>>>2&12)+4|0;break E}h=32}f=w[c+1|0];H:{if((f&6)==6){l=32;c=47244;break H}if(!(f&8)){l=30;c=47247;break H}f=w[c+2|0]>>>2&3;c=Jw(c)>>>((g|0)!=3)|0;c=c?c:192;if(c>>>0<=55){l=(f|0)==2?12:8;c=47268;break H}l=c>>>0>95?(f|0)!=1?30:27:27;c=47256}t[s+768|0]=l;t[s+769|0]=h>>>0>l>>>0?l:h;h=c;I:{if(!w[b+768|0]){break I}j=47152;while(1){if((o|0)==(y|0)){j=w[h|0]+47152|0;y=w[h+2|0]+y|0;k=w[h+1|0];h=h+3|0}c=o<<1;g=w[Od(q,k)+j|0];t[(c+b|0)+770|0]=g;i=w[b+769|0];if(o>>>0<i>>>0){g=w[Od(q,k)+j|0];i=w[b+769|0]}t[(b+(c|1)|0)+770|0]=i?g:0;g=w[b+768|0];o=o+1|0;if(g>>>0>o>>>0){continue}break}if(!g){k=g<<1;break I}o=0;while(1){c=b+o|0;J:{if(!w[c+770|0]){k=6;break J}k=2;if((w[F+1|0]&6)==6){break J}k=Od(q,2);g=w[b+768|0]}t[c+834|0]=k;k=g<<1&510;o=o+1|0;if(k>>>0>o>>>0){continue}break}}l=b+770|0;F=b+834|0;c=b;h=0;if((k|0)>0){while(1){g=w[l|0];f=g?19>>>w[h+F|0]&3|4:0;l=l+1|0;s=B(g,3)-6|0;y=4;H=C(0);while(1){if(f&y){g=Od(q,6);i=(g|0)/3|0;H=C(z[(s+(g-B(i,3)|0)<<2)+47280>>2]*C(2097152>>>i|0))}z[c>>2]=H;c=c+4|0;g=y>>>0>1;y=y>>>1|0;if(g){continue}break}h=h+1|0;if((k|0)!=(h|0)){continue}break}}o=w[b+769|0];c=w[b+768|0];if(o>>>0<c>>>0){while(1){t[(b+(o<<1)|0)+771|0]=0;o=o+1|0;if(c>>>0>o>>>0){continue}break}}o=0;f=Qb(D+3852|0,0,4608);y=a+2304|0;F=D+8620|0;c=0;K:{while(1){s=((c<<2)+D|0)+3852|0;I=D+17152|0;r=v[e+16>>2]|1;i=0;h=D;l=w[h+768|0];b=576;while(1){L:{if(!(l&255)){l=0;break L}j=s+(B(i,r)<<2)|0;A=0;while(1){k=b;l=w[(h+A|0)+770|0];M:{if(!l){break M}if(l>>>0<=16){if((r|0)<=0){break M}g=(-1<<l-1)+1|0;b=0;while(1){ba=(b<<2)+j|0,da=C(Od(I,l)+g|0),z[ba>>2]=da;b=b+1|0;if((r|0)!=(b|0)){continue}break}break M}l=2<<l-17;b=Od(I,(l-(l>>>3|0)|0)+3|0);if((r|0)<=0){break M}g=l>>>1|0;q=l|1;l=0;while(1){p=b;b=(b>>>0)/(q>>>0)|0;z[(l<<2)+j>>2]=(p-B(q,b)|0)-g|0;l=l+1|0;if((r|0)!=(l|0)){continue}break}}b=18-k|0;j=(k<<2)+j|0;A=A+1|0;l=w[h+768|0];if(A>>>0<l<<1>>>0){continue}break}}i=i+1|0;if((i|0)!=4){continue}break}c=(r<<2)+c|0;if((c|0)==12){g=(o<<2)+D|0;b=f;c=D;h=w[c+769|0];k=f+B(h,72)|0;lc(k+2304|0,k,B(w[c+768|0]-h|0,72));if(w[c+768|0]){l=0;while(1){h=0;while(1){k=(h<<2)+b|0;z[k>>2]=z[k>>2]*z[g>>2];k=k+2304|0;z[k>>2]=z[k>>2]*z[g+12>>2];h=h+1|0;if((h|0)!=12){continue}break}g=g+24|0;b=b+72|0;l=l+1|0;if(l>>>0<w[c+768|0]){continue}break}}PG(y,f,12,v[e+8>>2],d,F);Qb(f,0,4608);d=B(v[e+8>>2],768)+d|0;c=0}if(v[D+17156>>2]<=v[D+17160>>2]){o=o+1|0;if((o|0)==3){break K}continue}break}Lw(a);o=0;break a}k=1}o=B(Iw(a+6152|0),k)}jb=D+17168|0;return o|0}function TG(a,b,c,d,e,f,g){var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,z=0,A=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,M=0,N=0,O=0,P=0;M=jb-144|0;jb=M;k=v[f>>2];N=g&4;K=N?-1:k+((d^-1)+e|0)|0;E=K+1|0;a:{if(!(!(E&K)&d>>>0<=e>>>0)){v[f>>2]=0;v[c>>2]=0;i=-3;break a}F=e+k|0;D=v[c>>2];z=D+b|0;G=v[a+60>>2];s=v[a+40>>2];k=v[a+36>>2];C=v[a+32>>2];m=v[a+56>>2];j=v[a+4>>2];l=b;p=e;r=-1;i=-1;b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{v:{w:{x:{y:{z:{A:{B:{C:{D:{E:{F:{G:{H:{I:{J:{K:{L:{M:{q=v[a>>2];switch(q|0){case 35:break g;case 17:break h;case 21:break i;case 37:break j;case 34:break k;case 42:break o;case 41:break p;case 53:break q;case 52:break r;case 51:break s;case 38:break t;case 27:break u;case 26:break v;case 25:break w;case 24:break x;case 23:break y;case 18:break z;case 16:break A;case 14:break B;case 11:break C;case 9:break D;case 7:break E;case 6:break F;case 3:break G;case 32:break H;case 5:break I;case 2:break K;case 1:break L;case 0:break M;case 36:break d;case 39:break e;case 10:break f;default:break b}}v[a+28>>2]=1;m=0;v[a+8>>2]=0;v[a+12>>2]=0;v[a+16>>2]=1;s=0;k=0;C=0;j=0;if(g&1){break L}break J}i=1;if((D|0)<=0){break c}v[a+8>>2]=w[b|0];l=b+1|0}i=2;if(l>>>0>=z>>>0){break c}h=w[l|0];v[a+12>>2]=h;k=1;l=l+1|0;q=36;i=v[a+8>>2];if(((h|i<<8)>>>0)%31|h&32){break d}h=i&15;if(!N){i=256<<(i>>>4);if(i>>>0>32768|i>>>0>E>>>0){break d}if((h|0)==8){break J}break d}if((h|0)!=8){break d}}h=0;break n}if((D|0)<=0){i=5;break c}O=j+8|0;l=b+1|0;m=w[b|0]<<j|m;h=2;break n}if((D|0)<=0){i=32;break c}l=b+1|0;m=w[b|0]<<j|m;A=k;j=j+8|0;break m}h=1;break n}h=4;break n}h=3;break n}h=7;break n}h=9;break n}h=10;break n}h=11;break n}h=12;break n}h=13;break n}h=14;break n}h=15;break n}h=16;break n}h=17;break n}h=8;break n}h=5;break n}h=6;break n}h=18;break n}n=2;break l}n=1;break l}N:while(1){O:{P:{Q:{R:{S:{T:{U:{V:{W:{X:{Y:{Z:{_:{$:{aa:{ba:{ca:{da:{ea:{fa:{ga:{ha:{ia:{ja:{ka:{la:{ma:{na:{oa:{pa:{qa:{ra:{sa:{ta:{ua:{va:{wa:{xa:{ya:{za:{Aa:{Ba:{Ca:{switch(h|0){case 0:k=A;if(j>>>0>2){break Ba}h=1;continue;case 17:break ja;case 16:break ka;case 15:break la;case 14:break ma;case 13:break na;case 12:break oa;case 11:break pa;case 10:break qa;case 9:break ra;case 8:break ta;case 7:break ua;case 6:break va;case 5:break wa;case 4:break ya;case 3:break za;case 2:break Aa;case 1:break Ca;default:break ia}}i=3;while(1){if(l>>>0>=z>>>0){break c}m=w[l|0]<<j|m;A=l+1|0;l=A;j=j+8|0;if(j>>>0<3){continue}break}l=A;A=k}i=m&7;v[a+20>>2]=i;h=i>>>1|0;v[a+24>>2]=h;j=j-3|0;m=m>>>3|0;if(i>>>0>=2){break sa}O=j;break ha}j=O&-8;m=m>>>(O&7)|0;k=0;h=0;break fa}if(l>>>0<z>>>0){break xa}i=7;break c}while(1){if(l>>>0>=z>>>0){i=6;break c}m=w[l|0]<<j|m;o=j>>>0>4294967287;h=l+1|0;l=h;i=j+8|0;j=i;if(o){continue}break}l=h;j=i;h=1;break fa}t[(a+k|0)+10528|0]=w[l|0];l=l+1|0;h=2;break fa}while(1){if(l>>>0>=z>>>0){i=51;break c}m=w[l|0]<<j|m;o=j>>>0>4294967287;h=l+1|0;l=h;i=j+8|0;j=i;if(o){continue}break}l=h;j=i;break R}if(p>>>0<F>>>0){t[p|0]=C;k=k-1|0;p=p+1|0;break S}r=2;q=52;break d}if(p>>>0<F>>>0){break ga}r=2;q=9;break d}if(l>>>0<z>>>0){h=F-p|0;i=z-l|0;i=h>>>0<i>>>0?h:i;i=i>>>0<k>>>0?i:k;k=k-i|0;p=lc(p,l,i)+i|0;l=i+l|0;break Q}i=38;break c}i=0;k=A;Da:{switch(h-1|0){case 2:break f;case 0:break Da;default:break ea}}v[a+44>>2]=288;v[a+48>>2]=32;i=a+3552|0;v[i>>2]=84215045;v[i+4>>2]=84215045;i=a+3560|0;v[i>>2]=84215045;v[i+4>>2]=84215045;i=a+3568|0;v[i>>2]=84215045;v[i+4>>2]=84215045;i=a+3576|0;v[i>>2]=84215045;v[i+4>>2]=84215045;Qb(a- -64|0,8,144);Qb(a+208|0,9,112);t[a+336|0]=7;t[a+337|0]=7;t[a+338|0]=7;t[a+339|0]=7;t[a+340|0]=7;t[a+341|0]=7;t[a+342|0]=7;t[a+343|0]=7;t[a+328|0]=7;t[a+329|0]=7;t[a+330|0]=7;t[a+331|0]=7;t[a+332|0]=7;t[a+333|0]=7;t[a+334|0]=7;t[a+335|0]=7;t[a+320|0]=7;t[a+321|0]=7;t[a+322|0]=7;t[a+323|0]=7;t[a+324|0]=7;t[a+325|0]=7;t[a+326|0]=7;t[a+327|0]=7;t[a+344|0]=8;t[a+345|0]=8;t[a+346|0]=8;t[a+347|0]=8;t[a+348|0]=8;t[a+349|0]=8;t[a+350|0]=8;t[a+351|0]=8;H=1;break W}while(1){if(l>>>0>=z>>>0){i=11;break c}m=w[l|0]<<j|m;i=l+1|0;l=i;h=j+8|0;j=h;I=t[k+17533|0];if(j>>>0<I>>>0){continue}break}l=i;i=k;j=h;k=1;break Y}while(1){if(l>>>0>=z>>>0){i=14;break c}m=w[l|0]<<j|m;i=l+1|0;l=i;j=j+8|0;if(j>>>0<3){continue}break}l=i;h=1;break X}if(l>>>0>=z>>>0){i=16;break c}m=w[l|0]<<j|m;l=l+1|0;j=j+8|0;if(j>>>0<15){break da}break ca}while(1){if(l>>>0>=z>>>0){i=18;break c}m=w[l|0]<<j|m;i=l+1|0;l=i;j=j+8|0;if(s>>>0>j>>>0){continue}break}P=C-16|0;l=i;h=3;break V}if(l>>>0>=z>>>0){i=23;break c}m=w[l|0]<<j|m;l=l+1|0;j=j+8|0;if(j>>>0<15){break ba}break aa}if(p>>>0>=F>>>0){r=2;q=24;break d}t[p|0]=k;p=p+1|0;n=m;break U}while(1){if(l>>>0>=z>>>0){i=25;break c}m=w[l|0]<<j|m;i=l+1|0;l=i;j=j+8|0;if(s>>>0>j>>>0){continue}break}l=i;h=3;break T}if(l>>>0>=z>>>0){i=26;break c}m=w[l|0]<<j|m;l=l+1|0;j=j+8|0;if(j>>>0<15){break $}break _}while(1){if(l>>>0>=z>>>0){i=27;break c}m=w[l|0]<<j|m;i=l+1|0;l=i;j=j+8|0;if(s>>>0>j>>>0){continue}break}l=i;h=6;break T}if(p>>>0>=F>>>0){r=2;q=53;break d}t[p|0]=w[(G-C&K)+d|0];p=p+1|0;G=G+1|0;break Z}h=2;continue}h=8;continue}while(1){Ea:{Fa:{Ga:{Ha:{Ia:{switch(h|0){case 0:if(k>>>0>3){break Ha}if(!j){j=0;h=3;continue N}if(j>>>0>7){break Fa}h=4;continue N;case 1:t[(a+k|0)+10528|0]=m;j=j-8|0;m=m>>>8|0;break Ea;default:break Ia}}k=k+1|0;break Ga}k=x[a+10528>>1];if((k|0)==(x[a+10530>>1]^65535)){break S}break e}h=0;continue}h=1;continue}h=2;continue}}k=0;break Y}h=1;break V}h=2;break V}h=0;break T}h=1;break T}h=4;break T}h=5;break T}h=7;break T}while(1){Ja:{Ka:{La:{if(!k){if(i>>>0>2){break La}k=i;I=t[i+17533|0];if(I>>>0<=j>>>0){break Ja}h=9;continue N}k=i<<2;v[(k+a|0)+44>>2]=v[k+39488>>2]+((-1<<I^-1)&m);i=i+1|0;j=j-I|0;m=m>>>I|0;break Ka}k=0;Qb(a+7040|0,0,288);h=0;break X}k=0;continue}k=1;continue}}while(1){Ma:{Na:{Oa:{if(!h){if(y[a+52>>2]<=k>>>0){break Oa}if(j>>>0>2){break Ma}h=10;continue N}t[(w[k+39504|0]+a|0)+7040|0]=m&7;k=k+1|0;j=j-3|0;m=m>>>3|0;break Na}v[a+52>>2]=19;H=v[a+24>>2];A=k;break W}h=0;continue}h=1;continue}}h=0}while(1){Pa:{Qa:{Ra:{Sa:{Ta:{Ua:{Va:{Wa:{Xa:{switch(h|0){case 0:k=0;if((H|0)<0){n=m;k=A;break U}J=Qb(M,0,64);h=B(H,3488)+a|0;Qb(h+352|0,0,3200);q=v[a+24>>2];r=v[((q<<2)+a|0)+44>>2];if(r){while(1){i=(w[(h+k|0)- -64|0]<<2)+J|0;v[i>>2]=v[i>>2]+1;k=k+1|0;if((r|0)!=(k|0)){continue}break}}v[J+64>>2]=0;v[J+68>>2]=0;i=0;o=0;k=1;while(1){h=k<<2;k=k+1|0;h=v[h+J>>2];i=h+i<<1;v[(J- -64|0)+(k<<2)>>2]=i;o=h+o|0;if((k|0)!=16){continue}break};if(!((i|0)==65536|o>>>0<=1)){k=A;break g}if(r){r=-1;D=0;E=B(H,3488)+a|0;while(1){q=w[(D+E|0)- -64|0];Ya:{if(!q){break Ya}i=(J- -64|0)+(q<<2)|0;k=v[i>>2];v[i>>2]=k+1;i=0;o=q;while(1){h=i;i=k&1|h<<1;k=k>>>1|0;o=o-1|0;if(o){continue}break}if(q>>>0<=10){if(i>>>0>1023){break Ya}h=1<<q;k=q<<9|D;while(1){u[(E+(i<<1)|0)+352>>1]=k;i=h+i|0;if(i>>>0<1024){continue}break}break Ya}i=E+((i&1023)<<1)|0;k=u[i+352>>1];Za:{if(k){i=r;r=k;break Za}u[i+352>>1]=r;i=r-2|0}k=h>>>8&8388607;if(q>>>0>=12){while(1){k=k>>>1|0;h=(E+((k&1)+(r^-1)<<1)|0)+2400|0;r=u[h>>1];if(!r){u[h>>1]=i;r=i;i=i-2|0}q=q-1|0;if(q>>>0>11){continue}break}}u[(E+((k>>>1&1)+(r^-1)<<1)|0)+2400>>1]=D;r=i}D=D+1|0;q=v[a+24>>2];if(D>>>0<y[((q<<2)+a|0)+44>>2]){continue}break}}k=0;if((q|0)!=2){break Qa}break Ua;case 1:h=u[(((m&1023)<<1)+a|0)+7328>>1];_a:{if((h|0)>=0){if((h&65535)>>>0<512|h>>9>>>0>j>>>0){break _a}break Ta}if(j>>>0<11){break _a}i=10;while(1){h=u[(((m>>>i&1)+(h^-1)<<1)+a|0)+9376>>1];if((h|0)<0){o=i+2|0;i=i+1|0;if(j>>>0>=o>>>0){continue}}break}if((h|0)>=0){break Ta}}h=11;continue N;case 2:i=u[(((m&1023)<<1)+a|0)+7328>>1];if((i|0)>=0){break Wa}h=10;while(1){o=m>>>h|0;h=h+1|0;i=u[(((o&1)+(i^-1)<<1)+a|0)+9376>>1];if((i|0)<0){continue}break};break Va;default:break Xa}}o=t[P+13839|0]+((-1<<s^-1)&m)|0;j=j-s|0;m=m>>>s|0;h=a+k|0;Qb(h+10532|0,(C|0)==16?w[h+10531|0]:0,o);k=k+o|0;break Ua}h=i>>9;i=i&511}j=j-h|0;m=m>>>h|0;C=i;if(i>>>0>15){break Sa}t[(a+k|0)+10532|0]=C;k=k+1|0}h=v[a+48>>2];o=v[a+44>>2];i=h+o|0;if(i>>>0<=k>>>0){break Ra}if(j>>>0>14){break Ta}if((z-l|0)<=1){h=1;continue}m=w[l|0]<<j|m|w[l+1|0]<<j+8;j=j+16|0;l=l+2|0}h=2;continue}if(!((C|0)!=16|k)){k=0;C=16;break h}P=C-16|0;s=t[P+17524|0];if(s>>>0<=j>>>0){break Pa}h=12;continue N}if((i|0)!=(k|0)){break i}A=a+10532|0;lc(a- -64|0,A,o);lc(a+3552|0,o+A|0,h);q=v[a+24>>2];A=k}H=q-1|0;v[a+24>>2]=H;h=0;continue}h=3;continue}}h=2}$a:while(1){ab:{bb:{cb:{db:{eb:{fb:{gb:{hb:{ib:{jb:{kb:{lb:{mb:{nb:{ob:{switch(h|0){case 0:h=u[(((m&1023)<<1)+a|0)+352>>1];pb:{if((h|0)>=0){if((h&65535)>>>0<512|h>>9>>>0>j>>>0){break pb}break ab}if(j>>>0<11){break pb}i=10;while(1){h=u[(((m>>>i&1)+(h^-1)<<1)+a|0)+2400>>1];if((h|0)<0){o=i+2|0;i=i+1|0;if(j>>>0>=o>>>0){continue}}break}if((h|0)>=0){break ab}}h=13;continue N;case 1:i=u[(((m&1023)<<1)+a|0)+352>>1];if((i|0)>=0){break nb}h=10;while(1){k=m>>>h|0;h=h+1|0;i=u[(((k&1)+(i^-1)<<1)+a|0)+2400>>1];if((i|0)<0){continue}break};break mb;case 3:break db;case 4:break eb;case 5:break ib;case 6:break jb;case 2:break ob;default:break kb}}while(1){m=z-l|0;if(!((F-p|0)>1&(m|0)>=4)){if(j>>>0>14){m=n;break ab}if((m|0)<=1){m=n;h=0;continue $a}m=w[l|0]<<j|n|w[l+1|0]<<j+8;j=j+16|0;l=l+2|0;break ab}if(!(j>>>0>14)){n=(w[l|0]|w[l+1|0]<<8)<<j|n;j=j+16|0;l=l+2|0}h=l;k=u[(((n&1023)<<1)+a|0)+352>>1];qb:{if((k|0)<0){l=10;while(1){m=n>>>l|0;l=l+1|0;k=u[(((m&1)+(k^-1)<<1)+a|0)+2400>>1];if((k|0)<0){continue}break}break qb}l=k>>9}j=j-l|0;m=n>>>l|0;if(k&256){l=h;break lb}rb:{if(j>>>0>14){i=j;l=h;break rb}i=j+16|0;m=(w[h|0]|w[h+1|0]<<8)<<j|m;l=h+2|0}h=u[(((m&1023)<<1)+a|0)+352>>1];sb:{if((h|0)<0){n=10;while(1){j=m>>>n|0;n=n+1|0;h=u[(((j&1)+(h^-1)<<1)+a|0)+2400>>1];if((h|0)<0){continue}break}break sb}n=h>>9}t[p|0]=k;j=i-n|0;n=m>>>n|0;if(!(h&256)){t[p+1|0]=h;p=p+2|0;continue}break}p=p+1|0;m=n;k=h;break lb}h=i>>9;i=i&511}k=i;j=j-h|0;m=m>>>h|0;if(k>>>0>255){break lb}h=14;continue N}A=256;o=k&511;i=256;if((o|0)==256){break P}s=0;i=m;h=(o<<2)-1028|0;k=v[h+38976>>2];r=k;if(o-265>>>0>19){break cb}s=v[h+39104>>2];if(s>>>0>j>>>0){h=15;continue N}h=3;continue}if(!k){n=m;k=-1;break gb}k=k-1|0;h=18;continue N}j=j-s|0;n=m>>>s|0;C=((-1<<s^-1)&m)+C|0;break hb}s=u[(((m&1023)<<1)+a|0)+3840>>1];tb:{if((s|0)<0){h=10;while(1){i=m>>>h|0;h=h+1|0;s=u[(((i&1)+(s^-1)<<1)+a|0)+5888>>1];if((s|0)<0){continue}break}i=s;break tb}h=s>>9;i=s&511}o=i<<2;C=v[o+39232>>2];j=j-h|0;m=m>>>h|0;s=0;if(i-4>>>0>25){n=m;break hb}s=v[o+39360>>2];if(s>>>0<=j>>>0){break fb}h=17;continue N}G=p-d|0;if(!(!N|G>>>0>=C>>>0)){m=n;break j}h=(G-C&K)+d|0;if((h>>>0<p>>>0?p:h)+k>>>0>F>>>0){m=n;h=7;continue}if(k>>>0>2){while(1){t[p|0]=w[h|0];t[p+1|0]=w[h+1|0];t[p+2|0]=w[h+2|0];h=h+3|0;p=p+3|0;k=k-3|0;if(k>>>0>2){continue}break}}if(!k){break gb}t[p|0]=w[h|0];if((k|0)!=1){t[p+1|0]=w[h+1|0]}p=k+p|0}h=2;continue}h=6;continue}h=u[(((m&1023)<<1)+a|0)+3840>>1];ub:{if((h|0)>=0){if((h&65535)>>>0<512|h>>9>>>0>j>>>0){break ub}break bb}if(j>>>0<11){break ub}i=10;while(1){h=u[(((m>>>i&1)+(h^-1)<<1)+a|0)+5888>>1];if((h|0)<0){o=i+2|0;i=i+1|0;if(j>>>0>=o>>>0){continue}}break}if((h|0)>=0){break bb}}h=16;continue N}j=j-s|0;i=m>>>s|0;r=((-1<<s^-1)&m)+k|0}k=r;m=i;if(j>>>0>14){break bb}if((z-l|0)<=1){h=4;continue}m=m|w[l|0]<<j|w[l+1|0]<<j+8;j=j+16|0;l=l+2|0}h=5;continue}h=1;continue}}if(!k|!j){break Q}if(j>>>0>7){break R}h=5;continue}j=j-8|0;C=m&255;m=m>>>8|0;h=6;continue}if(k){break O}i=0}A=i;if(t[a+20|0]&1){break m}h=0;continue}h=7;continue}}n=j&-8;vb:{if(!n|b>>>0>=l>>>0){break vb}while(1){n=n-8|0;l=l-1|0;if(l>>>0<=b>>>0){break vb}if(n){continue}break}}if(!n){m=(((n&63)>>>0>=32?0:-1<<n)^-1)&m>>>(j&7);o=0;h=0;k=A;j=0;if(!(g&1)){break k}n=0;break l}ia(3164,9181,2787,3174);L()}while(1){wb:{xb:{yb:{zb:{Ab:{Bb:{switch(n|0){case 0:if(o>>>0>3){k=o;j=h;break k}if(h){break Ab}j=0;k=o;n=1;continue;case 1:break Bb;default:break zb}}if(l>>>0<z>>>0){break xb}i=42;break c}k=o;j=h;if(j>>>0>7){break yb}n=2;continue}while(1){if(l>>>0>=z>>>0){i=41;break c}m=w[l|0]<<j|m;n=j>>>0>4294967287;d=l+1|0;l=d;h=j+8|0;j=h;if(n){continue}break}l=d;o=k}n=m&255;m=m>>>8|0;h=h-8|0;break wb}n=w[l|0];l=l+1|0;o=k;h=j}v[a+16>>2]=v[a+16>>2]<<8|n;o=o+1|0;n=0;continue}}r=0;q=34;break d}q=37;r=-1;break d}q=21;r=-1;break d}q=17;r=-1;break d}q=35;r=-1;break d}q=10;r=-1;break d}q=39;r=-1}v[a>>2]=q;Cb:{if(j>>>0<8|b>>>0>=l>>>0){break Cb}while(1){j=j-8|0;l=l-1|0;if(l>>>0<=b>>>0){break Cb}if(j>>>0>7){continue}break}}i=r;break b}v[a>>2]=i;i=g&2?1:-4}v[a+4>>2]=j;v[a+60>>2]=G;v[a+40>>2]=s;v[a+36>>2]=k;v[a+32>>2]=C;v[a+56>>2]=(((j&63)>>>0>=32?0:-1<<j)^-1)&m;v[c>>2]=l-b;h=p-e|0;v[f>>2]=h;if(!(g&9)|(i|0)<0){break a}b=v[a+28>>2];l=b>>>16|0;m=b&65535;if(h){k=(h>>>0)%5552|0;while(1){j=0;if(k>>>0>7){while(1){o=w[e|0]+m|0;A=o+w[e+1|0]|0;n=A+w[e+2|0]|0;f=n+w[e+3|0]|0;d=f+w[e+4|0]|0;c=d+w[e+5|0]|0;b=c+w[e+6|0]|0;m=b+w[e+7|0]|0;l=m+(b+(c+(d+(f+(n+(A+(l+o|0)|0)|0)|0)|0)|0)|0)|0;e=e+8|0;j=j+8|0;if((j|7)>>>0<k>>>0){continue}break}j=k&8184}if(j>>>0<k>>>0){b=k-j|0;n=e;while(1){m=w[n|0]+m|0;l=m+l|0;n=n+1|0;j=j+1|0;if((k|0)!=(j|0)){continue}break}e=b+e|0}h=h-k|0;l=(l>>>0)%65521|0;m=(m>>>0)%65521|0;k=5552;if(h){continue}break}}b=l<<16|m;v[a+28>>2]=b;if(i){break a}i=0;if(!(g&1)){break a}i=(b|0)==v[a+16>>2]?0:-2}jb=M+144|0;return i}function Y3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;g=jb-32|0;jb=g;a:{b:{c:{d:{e:{f:{if(Pd(b,17540)){Xb(a);break f}if(Pd(b,5974)){b=jb-96|0;jb=b;d=Xb(a);v[113382]=0;Z(206,b- -64|0);a=v[113382];v[113382]=0;g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{if((a|0)!=1){v[113382]=0;v[b+32>>2]=0;R(2087,b+48|0,b+32|0);a=v[113382];v[113382]=0;if((a|0)==1){break p}v[113382]=0;Q(1214,d|0,b+48|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break o}yb(b+48|0);v[113382]=0;Q(1964,d|0,12869)|0;a=v[113382];v[113382]=0;q:{if((a|0)==1){break q}v[113382]=0;v[b+32>>2]=5;R(2087,b+48|0,b+32|0);a=v[113382];v[113382]=0;if((a|0)==1){break n}v[113382]=0;Q(1214,d|0,b+48|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break m}yb(b+48|0);v[113382]=0;Q(1964,d|0,12869)|0;a=v[113382];v[113382]=0;if((a|0)==1){break q}v[113382]=0;v[b+32>>2]=13;R(2087,b+48|0,b+32|0);a=v[113382];v[113382]=0;if((a|0)==1){break l}v[113382]=0;Q(1214,d|0,b+48|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break k}a=b+48|0;yb(a);v[113382]=0;a=Q(121,a|0,17540)|0;f=v[113382];v[113382]=0;if((f|0)==1){break j}f=Db(a);yb(a);if(!f){break i}v[113382]=0;Q(1964,d|0,17540)|0;a=v[113382];v[113382]=0;if((a|0)!=1){break i}}a=P()|0;O()|0;break h}a=P()|0;O()|0;break c}a=P()|0;O()|0;break h}a=P()|0;O()|0;yb(b+48|0);break h}a=P()|0;O()|0;break h}a=P()|0;O()|0;yb(b+48|0);break h}a=P()|0;O()|0;break h}a=P()|0;O()|0;yb(b+48|0);break h}a=P()|0;O()|0;break h}f=ih(b+48|0);r:{s:{t:{u:{v:{w:{x:{y:{z:{A:{B:{C:{D:{if(v[(b- -64|0)+12>>2]){a=v[(b- -64|0)+12>>2];v[113382]=0;v[b+12>>2]=a;R(2087,b+16|0,b+12|0);a=v[113382];v[113382]=0;if((a|0)==1){break D}v[113382]=0;U(2088,b+32|0,5138,b+16|0);a=v[113382];v[113382]=0;if((a|0)==1){break C}v[113382]=0;R(1502,f|0,b+32|0);a=v[113382];v[113382]=0;if((a|0)==1){break B}yb(b+32|0);yb(b+16|0)}if(!w[(b- -64|0)+16|0]){break x}v[113382]=0;c=Q(121,b+32|0,8764)|0;a=v[113382];v[113382]=0;if((a|0)==1){break z}v[113382]=0;R(1502,f|0,c|0);a=v[113382];v[113382]=0;if((a|0)==1){break y}yb(c);break w}a=P()|0;O()|0;break r}a=P()|0;O()|0;break A}a=P()|0;O()|0;yb(b+32|0)}yb(b+16|0);break r}a=P()|0;O()|0;break r}a=P()|0;O()|0;yb(c);break r}if(!w[(b- -64|0)+17|0]){break w}v[113382]=0;c=Q(121,b+32|0,8510)|0;a=v[113382];v[113382]=0;if((a|0)==1){break v}v[113382]=0;R(1502,f|0,c|0);a=v[113382];v[113382]=0;if((a|0)==1){break u}yb(c)}if(w[(b- -64|0)+18|0]){break t}break s}a=P()|0;O()|0;break r}a=P()|0;O()|0;yb(c);break r}v[113382]=0;c=Q(121,b+32|0,7093)|0;a=v[113382];v[113382]=0;E:{if((a|0)!=1){v[113382]=0;R(1502,f|0,c|0);a=v[113382];v[113382]=0;if((a|0)==1){break E}yb(c);break s}a=P()|0;O()|0;break r}a=P()|0;O()|0;yb(c);break r}if(id(f)){break g}v[113382]=0;Q(1964,d|0,12899)|0;a=v[113382];v[113382]=0;if((a|0)!=1){v[113382]=0;c=Q(121,b+16|0,12869)|0;a=v[113382];v[113382]=0;F:{G:{H:{if((a|0)!=1){v[113382]=0;U(2089,b+32|0,f|0,c|0);a=v[113382];v[113382]=0;if((a|0)==1){break H}v[113382]=0;Q(1214,d|0,b+32|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break G}yb(b+32|0);yb(c);break g}a=P()|0;O()|0;break r}a=P()|0;O()|0;break F}a=P()|0;O()|0;yb(b+32|0)}yb(c);break r}a=P()|0;O()|0}gd(f)}bf(b- -64|0);break c}gd(f);bf(b- -64|0);jb=b+96|0;break f}if(Pd(b,4406)){v[g>>2]=0;Xr(a,g);break f}if(Pd(b,4384)){v[g>>2]=5;Xr(a,g);break f}if(Pd(b,6879)){v[g>>2]=13;Xr(a,g);break f}if(Pd(b,6684)){f=jb-16|0;jb=f;b=jb-16|0;jb=b;v[b+12>>2]=17540;Ub(a,v[b+12>>2]);jb=b+16|0;jb=f+16|0;break f}if(Pd(b,7437)){b=Ub(g,17540);f=Db(b);v[113382]=0;Q(121,a|0,(f?11955:11717)|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break e}yb(b);break f}if(Pd(b,3624)){b=jb-48|0;jb=b;mD(b+16|0);v[113382]=0;f=Q(2,b|0,17519)|0;c=v[113382];v[113382]=0;I:{J:{K:{L:{if((c|0)!=1){v[113382]=0;U(221,b+32|0,b+16|0,f|0);c=v[113382];v[113382]=0;if((c|0)==1){break L}v[113382]=0;U(9,a|0,0,b+32|0);a=v[113382];v[113382]=0;if((a|0)==1){break K}yb(b+32|0);yb(f);yb(b+16|0);jb=b+48|0;break f}a=P()|0;O()|0;break I}a=P()|0;O()|0;break J}a=P()|0;O()|0;yb(b+32|0)}yb(f)}yb(b+16|0);break a}if(Pd(b,6002)){b=jb-16|0;jb=b;i=jb-16|0;jb=i;v[i+8>>2]=53;f=b;c=jb-176|0;jb=c;h=bw(c+160|0);M:{N:{O:{P:{Q:{R:{S:{T:{U:{V:{W:{X:{Y:{Z:{_:{$:{d=v[i+8>>2];if(d&1){v[113382]=0;v[c+144>>2]=19469312;R(212,c+96|0,c+144|0);d=v[113382];v[113382]=0;if((d|0)==1){break $}v[113382]=0;R(171,h|0,c+96|0);d=v[113382];v[113382]=0;if((d|0)==1){break _}yb(c+96|0);d=v[i+8>>2]}if(!(d&4)){break Y}v[113382]=0;d=da(213)|0;e=v[113382];v[113382]=0;if((e|0)==1){break X}if(!d){break Z}break Y}a=P()|0;O()|0;break N}a=P()|0;O()|0;yb(c+96|0);break N}v[113382]=0;Z(214,c+96|0);d=v[113382];v[113382]=0;aa:{if((d|0)!=1){v[113382]=0;R(171,h|0,c+96|0);d=v[113382];v[113382]=0;if((d|0)==1){break aa}yb(c+96|0);break Y}a=P()|0;O()|0;break N}a=P()|0;O()|0;yb(c+96|0);break N}ba:{d=v[i+8>>2];if(!(d&8)){break ba}v[113382]=0;d=Q(2,c+128|0,2508)|0;e=v[113382];v[113382]=0;ca:{da:{ea:{fa:{ga:{if((e|0)!=1){v[113382]=0;R(189,c+144|0,d|0);e=v[113382];v[113382]=0;if((e|0)==1){break ga}v[113382]=0;U(215,c+96|0,c+144|0,22884);e=v[113382];v[113382]=0;if((e|0)==1){break fa}v[113382]=0;R(171,h|0,c+96|0);e=v[113382];v[113382]=0;if((e|0)==1){break ea}yb(c+96|0);Ib(c+144|0);yb(d);d=v[i+8>>2];break ba}a=P()|0;O()|0;break N}a=P()|0;O()|0;break ca}a=P()|0;O()|0;break da}a=P()|0;O()|0;yb(c+96|0)}Ib(c+144|0)}yb(d);break N}ha:{if(!(d&16)){break ha}v[113382]=0;Z(206,c+96|0);d=v[113382];v[113382]=0;ia:{ja:{ka:{la:{ma:{na:{oa:{pa:{qa:{ra:{sa:{ta:{ua:{va:{wa:{xa:{ya:{za:{Aa:{Ba:{Ca:{Da:{Ea:{Fa:{Ga:{if((d|0)!=1){v[113382]=0;R(216,c+144|0,c+96|0);d=v[113382];v[113382]=0;if((d|0)==1){break ja}d=c+144|0;e=Sc(d);yb(d);if(!e){v[113382]=0;d=Q(2,c- -64|0,11715)|0;e=v[113382];v[113382]=0;if((e|0)==1){break Ga}v[113382]=0;R(189,c+80|0,d|0);e=v[113382];v[113382]=0;if((e|0)==1){break Fa}v[113382]=0;R(216,c+48|0,c+96|0);e=v[113382];v[113382]=0;if((e|0)==1){break Ea}v[113382]=0;U(217,c+144|0,c+80|0,c+48|0);e=v[113382];v[113382]=0;if((e|0)==1){break Da}v[113382]=0;R(171,h|0,c+144|0);e=v[113382];v[113382]=0;if((e|0)==1){break Ca}yb(c+144|0);yb(c+48|0);Ib(c+80|0);yb(d)}if(!Sc(Xg(c+96|0))){v[113382]=0;d=Q(2,c+32|0,13313)|0;e=v[113382];v[113382]=0;if((e|0)==1){break ya}v[113382]=0;R(189,c+80|0,d|0);e=v[113382];v[113382]=0;if((e|0)==1){break xa}e=Xg(c+96|0);v[113382]=0;U(217,c+144|0,c+80|0,e|0);e=v[113382];v[113382]=0;if((e|0)==1){break wa}v[113382]=0;R(171,h|0,c+144|0);e=v[113382];v[113382]=0;if((e|0)==1){break va}yb(c+144|0);Ib(c+80|0);yb(d)}v[113382]=0;R(218,c+144|0,c+96|0);d=v[113382];v[113382]=0;if((d|0)==1){break sa}d=c+144|0;e=Sc(d);yb(d);if(!e){v[113382]=0;d=Q(2,c+16|0,11715)|0;e=v[113382];v[113382]=0;if((e|0)==1){break ra}v[113382]=0;R(189,c+80|0,d|0);e=v[113382];v[113382]=0;if((e|0)==1){break qa}v[113382]=0;R(218,c+48|0,c+96|0);e=v[113382];v[113382]=0;if((e|0)==1){break pa}v[113382]=0;U(217,c+144|0,c+80|0,c+48|0);e=v[113382];v[113382]=0;if((e|0)==1){break oa}v[113382]=0;R(171,h|0,c+144|0);e=v[113382];v[113382]=0;if((e|0)==1){break na}yb(c+144|0);yb(c+48|0);Ib(c+80|0);yb(d)}bf(c+96|0);d=v[i+8>>2];break ha}a=P()|0;O()|0;break N}a=P()|0;O()|0;break ia}a=P()|0;O()|0;break za}a=P()|0;O()|0;break Aa}a=P()|0;O()|0;break Ba}a=P()|0;O()|0;yb(c+144|0)}yb(c+48|0)}Ib(c+80|0)}yb(d);break ia}a=P()|0;O()|0;break ia}a=P()|0;O()|0;break ta}a=P()|0;O()|0;break ua}a=P()|0;O()|0;yb(c+144|0)}Ib(c+80|0)}yb(d);break ia}a=P()|0;O()|0;break ia}a=P()|0;O()|0;break ia}a=P()|0;O()|0;break ka}a=P()|0;O()|0;break la}a=P()|0;O()|0;break ma}a=P()|0;O()|0;yb(c+144|0)}yb(c+48|0)}Ib(c+80|0)}yb(d);break ia}a=P()|0;O()|0}bf(c+96|0);break N}Ha:{if(!(d&32)){break Ha}v[113382]=0;d=da(213)|0;e=v[113382];v[113382]=0;if((e|0)==1){break X}if(d){break Ha}d=c+96|0;bd(d);v[113382]=0;R(171,h|0,d|0);d=v[113382];v[113382]=0;if((d|0)==1){break O}yb(c+96|0)}if(w[i+8|0]&64){v[113382]=0;Z(219,c+96|0);d=v[113382];v[113382]=0;if((d|0)==1){break W}v[113382]=0;R(171,h|0,c+96|0);d=v[113382];v[113382]=0;if((d|0)==1){break V}yb(c+96|0)}v[113382]=0;d=Q(2,c+96|0,17540)|0;e=v[113382];v[113382]=0;if((e|0)==1){break U}v[113382]=0;U(220,c|0,h|0,d|0);e=v[113382];v[113382]=0;if((e|0)==1){break T}v[113382]=0;e=Q(2,c+144|0,17519)|0;j=v[113382];v[113382]=0;if((j|0)==1){break S}v[113382]=0;U(221,f|0,c|0,e|0);f=v[113382];v[113382]=0;if((f|0)==1){break R}yb(e);yb(c);yb(d);gl(h);jb=c+176|0;break M}a=P()|0;O()|0;break N}a=P()|0;O()|0;break N}a=P()|0;O()|0;yb(c+96|0);break N}a=P()|0;O()|0;break N}a=P()|0;O()|0;break P}a=P()|0;O()|0;break Q}a=P()|0;O()|0;yb(e)}yb(c)}yb(d);break N}a=P()|0;O()|0;yb(c+96|0)}gl(h);S(a|0);L()}jb=i+16|0;v[113382]=0;U(9,a|0,0,b|0);a=v[113382];v[113382]=0;if((a|0)!=1){yb(b);jb=b+16|0;break f}break b}if(Pd(b,6613)){b=jb-48|0;jb=b;Kq(b);v[113382]=0;R(216,b+32|0,b|0);f=v[113382];v[113382]=0;Ia:{Ja:{if((f|0)!=1){v[113382]=0;U(9,a|0,0,b+32|0);a=v[113382];v[113382]=0;if((a|0)==1){break Ja}yb(b+32|0);bf(b);jb=b+48|0;break f}a=P()|0;O()|0;break Ia}a=P()|0;O()|0;yb(b+32|0)}bf(b);break a}if(Pd(b,7400)){b=jb-32|0;jb=b;Kq(b);f=Xg(b);v[113382]=0;U(9,a|0,0,f|0);a=v[113382];v[113382]=0;if((a|0)!=1){bf(b);jb=b+32|0;break f}a=P()|0;O()|0;bf(b);break a}if(Pd(b,6015)){b=jb-48|0;jb=b;Kq(b+16|0);Ka:{if(v[b+28>>2]){f=v[b+28>>2];v[113382]=0;v[b+12>>2]=f;R(2087,a|0,b+12|0);a=v[113382];v[113382]=0;if((a|0)!=1){break Ka}a=P()|0;O()|0;bf(b+16|0);break a}Xb(a)}bf(b+16|0);jb=b+48|0;break f}if(Pd(b,8754)){Kq(g);b=w[g+16|0];v[113382]=0;Q(121,a|0,(b?11717:11955)|0)|0;a=v[113382];v[113382]=0;if((a|0)!=1){bf(g);break f}a=P()|0;O()|0;bf(g);break a}if(Pd(b,6031)){Kq(g);b=w[g+17|0];v[113382]=0;Q(121,a|0,(b?11717:11955)|0)|0;a=v[113382];v[113382]=0;if((a|0)!=1){bf(g);break f}a=P()|0;O()|0;bf(g);break a}if(Pd(b,8201)){Kq(g);b=w[g+18|0];v[113382]=0;Q(121,a|0,(b?11717:11955)|0)|0;a=v[113382];v[113382]=0;if((a|0)!=1){bf(g);break f}a=P()|0;O()|0;bf(g);break a}if(Pd(b,8484)){b=jb-16|0;jb=b;f=jb-32|0;jb=f;c=bd(b);v[113382]=0;Z(206,f|0);d=v[113382];v[113382]=0;La:{Ma:{Na:{if((d|0)!=1){d=Xg(f);v[113382]=0;Q(207,c|0,d|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break Na}bf(f);jb=f+32|0;break La}a=P()|0;O()|0;break Ma}a=P()|0;O()|0;bf(f)}yb(c);break a}v[113382]=0;U(9,a|0,0,b|0);a=v[113382];v[113382]=0;if((a|0)!=1){yb(b);jb=b+16|0;break f}break b}if(Pd(b,4527)){d=jb-16|0;jb=d;b=jb+-64|0;jb=b;c=bd(d);v[113382]=0;f=Q(2,b+16|0,10773)|0;h=v[113382];v[113382]=0;Oa:{Pa:{Qa:{Ra:{Sa:{Ta:{Ua:{if((h|0)!=1){v[113382]=0;R(189,b+32|0,f|0);h=v[113382];v[113382]=0;if((h|0)==1){break Ua}v[113382]=0;v[b+12>>2]=14;v[b+8>>2]=0;v[b+4>>2]=0;fa(209,b+48|0,b+32|0,b+12|0,b+8|0,b+4|0);h=v[113382];v[113382]=0;if((h|0)==1){break Ta}v[113382]=0;Q(162,c|0,b+48|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break Sa}yb(b+48|0);Ib(b+32|0);yb(f);jb=b- -64|0;break Oa}a=P()|0;O()|0;break Pa}a=P()|0;O()|0;break Qa}a=P()|0;O()|0;break Ra}a=P()|0;O()|0;yb(b+48|0)}Ib(b+32|0)}yb(f)}yb(c);break a}v[113382]=0;U(9,a|0,0,d|0);a=v[113382];v[113382]=0;if((a|0)!=1){yb(d);jb=d+16|0;break f}a=P()|0;O()|0;break c}if(Pd(b,3147)){b=jb-16|0;jb=b;yn(b,0,15523);v[113382]=0;U(9,a|0,0,b|0);a=v[113382];v[113382]=0;if((a|0)!=1){yb(b);jb=b+16|0;break f}break b}if(Pd(b,2809)){b=jb-48|0;jb=b;d=Ub(b+16|0,13670);v[113382]=0;R(2090,b|0,2);f=v[113382];v[113382]=0;Va:{Wa:{Xa:{Ya:{if((f|0)!=1){v[113382]=0;U(3,b+32|0,d|0,b|0);f=v[113382];v[113382]=0;if((f|0)==1){break Ya}v[113382]=0;U(9,a|0,0,b+32|0);a=v[113382];v[113382]=0;if((a|0)==1){break Xa}yb(b+32|0);yb(b);yb(d);jb=b+48|0;break f}a=P()|0;O()|0;break Va}a=P()|0;O()|0;break Wa}a=P()|0;O()|0;yb(b+32|0)}yb(b)}break c}if(Pd(b,7423)){b=jb-16|0;jb=b;yn(b,0,13986);v[113382]=0;U(9,a|0,0,b|0);a=v[113382];v[113382]=0;if((a|0)!=1){yb(b);jb=b+16|0;break f}break b}if(Pd(b,6620)){b=jb-16|0;jb=b;Iq(b,0);v[113382]=0;U(9,a|0,0,b|0);a=v[113382];v[113382]=0;if((a|0)!=1){yb(b);jb=b+16|0;break f}break b}if(Pd(b,6595)){b=jb-16|0;jb=b;Iq(b,2);v[113382]=0;U(9,a|0,0,b|0);a=v[113382];v[113382]=0;if((a|0)!=1){yb(b);jb=b+16|0;break f}break b}if(Pd(b,6580)){b=jb-16|0;jb=b;Iq(b,3);v[113382]=0;U(9,a|0,0,b|0);a=v[113382];v[113382]=0;if((a|0)!=1){yb(b);jb=b+16|0;break f}break b}Xb(a)}jb=g+32|0;break d}a=P()|0;O()|0;yb(b);break a}return}yb(d);break a}a=P()|0;O()|0;yb(b)}S(a|0);L()}function HT(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=jb-288|0;jb=e;Ic(b);a:{if(fB(b,13827)){o=Xb(e+272|0);v[113382]=0;f=W(385,b|0,o|0,-1)|0;i=v[113382];v[113382]=0;b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{if((i|0)!=1){if(!f){break b}v[113382]=0;f=Q(401,b|0,e+264|0)|0;i=v[113382];v[113382]=0;u:{if((i|0)==1){break u}if(!f){break b}if(!dB(e+264|0)){break b}d=cB(e+264|0);v[113382]=0;d=qg(402,d,mb);f=v[113382];v[113382]=0;if((f|0)==1){break u}v[113382]=0;f=Q(228,b|0,d|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break u}d=0;if(!f){break b}if(!c){break c}v[113382]=0;R(403,a|0,4096);d=v[113382];v[113382]=0;if((d|0)==1){break u}v[113382]=0;Q(404,a+1304400|0,o|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break u}d=w[e+264|2];u[a+480188>>1]=32;u[a+480192>>1]=d;v[113382]=0;R(405,a|0,1);d=v[113382];v[113382]=0;if((d|0)==1){break u}v[113382]=0;d=Q(2,e+96|0,5486)|0;f=v[113382];v[113382]=0;v:{w:{x:{y:{z:{A:{B:{C:{D:{E:{F:{if((f|0)!=1){Gb(a+1304436|0,d);yb(d);v[113382]=0;d=Q(2,e+96|0,3356)|0;f=v[113382];v[113382]=0;if((f|0)==1){break F}Gb(a+1304448|0,d);yb(d);v[113382]=0;d=Q(2,e+248|0,11218)|0;f=v[113382];v[113382]=0;if((f|0)==1){break E}v[113382]=0;R(189,e+48|0,d|0);f=v[113382];v[113382]=0;if((f|0)==1){break D}t[e+216|0]=w[e+264|1];f=w[e+264|0];v[113382]=0;t[e+8|0]=f;R(406,e+232|0,e+8|0);f=v[113382];v[113382]=0;if((f|0)==1){break C}v[113382]=0;X(407,e+96|0,e+48|0,e+216|0,e+232|0);f=v[113382];v[113382]=0;if((f|0)==1){break B}f=e+96|0;Gb(a+1304460|0,f);yb(f);yb(e+232|0);Ib(e+48|0);yb(d);v[a+1304496>>2]=4;if(w[e+264|0]<2){break w}v[113382]=0;u[e+96>>1]=8192;d=T(323,b|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break y}v[113382]=0;u[e+48>>1]=d;d=Q(408,e+96|0,e+48|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break y}v[a+480204>>2]=B(x[d>>1],1e4)>>>8;v[113382]=0;t[e+96|0]=1;d=T(409,b|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break x}v[113382]=0;t[e+48|0]=d;d=Q(410,e+96|0,e+48|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break x}v[a+480196>>2]=w[d|0];v[113382]=0;Q(304,b|0,3)|0;d=v[113382];v[113382]=0;if((d|0)!=1){v[113382]=0;d=T(323,b|0)|0;f=v[113382];v[113382]=0;if((f|0)!=1){break v}}b=P()|0;O()|0;break d}b=P()|0;O()|0;break d}b=P()|0;O()|0;break d}b=P()|0;O()|0;break d}b=P()|0;O()|0;break z}b=P()|0;O()|0;break A}b=P()|0;O()|0;yb(e+232|0)}Ib(e+48|0)}yb(d);break d}b=P()|0;O()|0;break d}b=P()|0;O()|0;break d}v[113382]=0;t[e+96|0]=32;d=T(409,b|0)|0;f=v[113382];v[113382]=0;G:{H:{if((f|0)==1){break H}v[113382]=0;t[e+48|0]=d;d=Q(410,e+96|0,e+48|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break H}v[a+480204>>2]=B(w[d|0],1e4);v[113382]=0;t[e+96|0]=1;d=T(409,b|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break G}v[113382]=0;t[e+48|0]=d;d=Q(410,e+96|0,e+48|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break G}v[a+480196>>2]=w[d|0];v[113382]=0;d=T(409,b|0)|0;f=v[113382];v[113382]=0;if((f|0)!=1){break v}b=P()|0;O()|0;break d}b=P()|0;O()|0;break d}b=P()|0;O()|0;break d}v[a+480208>>2]=d>>>2&16|12;n=Sl(e+232|0);m=Sl(e+216|0);I:{J:{if(!x[a+480192>>1]){break J}j=1;i=e+80|1;p=e+96|12;while(1){v[113382]=0;f=W(411,a|0,j&65535,0)|0;d=v[113382];v[113382]=0;K:{L:{M:{if((d|0)==1){break M}if(!f){break J}v[113382]=0;d=W(386,b|0,f+492|0,-1)|0;h=v[113382];v[113382]=0;if((h|0)==1){break M}if(!d){break J}v[113382]=0;h=T(409,b|0)|0;d=v[113382];v[113382]=0;N:{O:{P:{Q:{if((d|0)!=1){Qb(e+96|0,0,120);if(!h){break K}if(w[e+264|0]){v[113382]=0;d=Q(412,b|0,e+96|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break Q}if(!d){break K}}if(!w[e+264|0]){v[113382]=0;d=W(231,b|0,p|0,96)|0;g=v[113382];v[113382]=0;if((g|0)==1){break Q}if(!d){break K}}g=f+236|0;d=0;while(1){k=w[(e+96|0)+d|0];l=x[a+480190>>1];r=_c(g,d),s=(k+l|0)+1|0,u[r>>1]=s;d=d+1|0;if((d|0)!=120){continue}break}v[113382]=0;d=f+48|0;U(413,e+8|0,d|0,b|0);g=v[113382];v[113382]=0;if((g|0)==1){break P}v[113382]=0;g=f+68|0;U(413,e+32|0,g|0,b|0);k=v[113382];v[113382]=0;if((k|0)==1){break P}v[113382]=0;k=f+88|0;U(413,e+88|0,k|0,b|0);l=v[113382];v[113382]=0;if((l|0)==1){break P}v[113382]=0;Q(414,b|0,e+80|0)|0;l=v[113382];v[113382]=0;if((l|0)==1){break O}v[f>>2]=(w[i|0]|w[i+1|0]<<8)&4095;l=w[i|0]|w[i+1|0]<<8;f=e+80|0;ju(f,d,0);ju(f,g,1);ju(f,k,2);r=e,s=ac(d),v[r+48>>2]=s;r=e,s=bc(d),v[r+72>>2]=s;if(Jb(e+48|0,e+72|0)){break N}break L}b=P()|0;O()|0;break e}b=P()|0;O()|0;break e}b=P()|0;O()|0;break e}b=P()|0;O()|0;break e}while(1){R:{d=v[e+48>>2];t[e+68|0]=64;f=w[d+2|0];v[113382]=0;t[e+71|0]=((f<<6)- -64>>>0)/127;f=Q(415,e+68|0,e+71|0)|0;q=v[113382];v[113382]=0;if((q|0)==1){break R}t[d+2|0]=w[f|0];d=e+48|0;Ie(d);if(Jb(d,e+72|0)){continue}break L}break}b=P()|0;O()|0;break e}b=P()|0;O()|0;break e}r=e,s=ac(g),v[r+48>>2]=s;r=e,s=bc(g),v[r+72>>2]=s;S:{if(!Jb(e+48|0,e+72|0)){break S}while(1){T:{d=v[e+48>>2];t[e+68|0]=64;f=w[d+2|0];v[113382]=0;t[e+71|0]=((f<<6)+128>>>0)/255;f=Q(415,e+68|0,e+71|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break T}t[d+2|0]=w[f|0];d=e+48|0;Ie(d);if(Jb(d,e+72|0)){continue}break S}break}b=P()|0;O()|0;break e}r=e,s=ac(k),v[r+48>>2]=s;r=e,s=bc(k),v[r+72>>2]=s;U:{if(!Jb(e+48|0,e+72|0)){break U}k=1<<(l>>>12&3);while(1){l=v[e+48>>2];d=t[l+2|0];d=qma(d^-128,d>>31^-1,k,0);g=mb;f=g;V:{if((f|0)>=-1&d>>>0>=4294967292|(f|0)>=0){d=d+4|0;f=d>>>0<4?f+1|0:f;d=((f&7)<<29|d>>>3)&536870911;f=0;break V}f=0-((d>>>0>3)+f|0)|0;d=3-d|0;f=((f&7)<<29|d>>>3)&536870911;d=0-f|0;f=0-((f|0)!=0)|0}v[113382]=0;d=qg(416,d,f);f=v[113382];v[113382]=0;if((f|0)!=1){t[l+2|0]=d^128;d=e+48|0;Ie(d);if(Jb(d,e+72|0)){continue}break U}break}b=P()|0;O()|0;break e}d=x[a+480190>>1]+1|0;u[e+68>>1]=d;W:{X:{Y:{Z:{g=d&65535;if(g>>>0<=3999){f=0;d=0;while(1){v[113382]=0;W(386,b|0,((g<<5)+a|0)+946304|0,-1)|0;g=v[113382];v[113382]=0;if((g|0)==1){break Z}v[113382]=0;Q(417,b|0,e+48|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break Y}v[113382]=0;R(418,e+48|0,(B(x[e+68>>1]+d|0,104)+a|0)+484380|0);d=v[113382];v[113382]=0;if((d|0)==1){break Y}d=w[e+80|0];g=w[e+67|0];v[113382]=0;u[e+72>>1]=d|f<<8&32512|((g&3)!=0)<<15;R(419,m|0,e+72|0);d=v[113382];v[113382]=0;if((d|0)==1){break X}f=f+1|0;d=f&65535;if(h>>>0<=d>>>0){break W}g=x[e+68>>1]+d|0;if(g>>>0<=3999){continue}break}}v[113382]=0;Q(304,b|0,20)|0;d=v[113382];v[113382]=0;if((d|0)!=1){break W}b=P()|0;O()|0;break e}b=P()|0;O()|0;break e}b=P()|0;O()|0;break e}b=P()|0;O()|0;break e}v[113382]=0;R(419,n|0,e+68|0);d=v[113382];v[113382]=0;if((d|0)==1){break f}v[e+48>>2]=3999;d=x[a+480190>>1];v[113382]=0;v[e+72>>2]=d+h;d=Q(420,e+48|0,e+72|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break I}u[a+480190>>1]=v[d>>2]}j=j+1|0;if(x[a+480192>>1]>=(j&65535)>>>0){continue}break}}d=Xb(e+96|0);v[113382]=0;f=W(385,b|0,d|0,-1)|0;i=v[113382];v[113382]=0;_:{$:{aa:{if((i|0)!=1){if(f){v[113382]=0;U(13,e+48|0,6,d|0);f=v[113382];v[113382]=0;if((f|0)==1){break _}f=e+48|0;Gb(a+1304412|0,f);yb(f)}yb(d);f=0;while(1){v[113382]=0;d=(f<<5)+a|0;Z(387,d+480280|0);i=v[113382];v[113382]=0;if((i|0)==1){break aa}v[113382]=0;W(388,b|0,d+480289|0,-1)|0;d=v[113382];v[113382]=0;if((d|0)==1){break aa}f=f+1|0;if((f|0)!=32){continue}break}v[113382]=0;d=Q(421,b|0,e+32|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break n}if(!d){break k}if((w[e+32|0]|w[e+33|0]<<8|(w[e+34|0]<<16|w[e+35|0]<<24))>>>0<12){break o}d=w[e+32|0]|w[e+33|0]<<8|(w[e+34|0]<<16|w[e+35|0]<<24);v[113382]=0;d=Q(228,b|0,d-11|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break n}if(d){break $}break o}break p}b=P()|0;O()|0;break e}v[e+88>>2]=(w[e+32|0]|w[e+33|0]<<8|(w[e+34|0]<<16|w[e+35|0]<<24))-11;j=tq(e+96|0);v[113382]=0;W(391,b|0,j|0,v[e+88>>2])|0;d=v[113382];v[113382]=0;if((d|0)==1){break r}v[113382]=0;v[e+48>>2]=50529027;d=Q(297,e+88|0,e+48|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break s}v[e+80>>2]=B(v[d>>2],85);i=Xb(e+48|0);d=e+32|4;d=w[d|0]|w[d+1|0]<<8|(w[d+2|0]<<16|w[d+3|0]<<24);v[113382]=0;v[e+8>>2]=d;d=Q(297,e+80|0,e+8|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break t}d=v[d>>2];v[113382]=0;R(111,i|0,d|0);d=v[113382];v[113382]=0;if((d|0)==1){break t}if(v[e+88>>2]){f=0;while(1){ba:{h=w[uc(j,f)|0];d=f+1|0;if(!((h|0)!=255|v[e+88>>2]-d>>>0<2)){d=t[uc(j,d)|0];h=w[uc(j,f+2|0)|0];r=e,s=tf(i),v[r+8>>2]=s;Hd(e+24|0,e+8|0);v[113382]=0;aa(392,i|0,v[e+24>>2],h|0,d|0)|0;d=v[113382];v[113382]=0;if((d|0)!=1){d=f+3|0;break ba}break t}v[113382]=0;R(110,i|0,h<<24>>24);f=v[113382];v[113382]=0;if((f|0)!=1){break ba}break t}f=d;if(y[e+88>>2]>d>>>0){continue}break}}v[113382]=0;X(393,e+8|0,4,6,i|0);d=v[113382];v[113382]=0;ca:{if((d|0)!=1){d=e+8|0;Gb(i,d);yb(d);d=Tb(i);v[113382]=0;d=T(394,d|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break ca}f=Db(i);v[113382]=0;ea(395,a+1304424|0,d|0,f|0,74,0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break ca}yb(i);$d(j);break o}break t}break t}break p}b=P()|0;O()|0;break e}b=P()|0;O()|0;break d}b=P()|0;O()|0;break d}b=P()|0;O()|0;yb(i);break q}b=P()|0;O()|0;break q}b=P()|0;O()|0}$d(j);break e}b=P()|0;O()|0;yb(d);break e}d=Vb(a+484360|0);f=e+264|5;f=w[f|0]|w[f+1|0]<<8;v[113382]=0;ea(396,d|0,b|0,f|0,65535,65535)|0;d=v[113382];v[113382]=0;if((d|0)==1){break n}j=c&1;if(j){d=e+264|3;d=w[d|0]|w[d+1|0]<<8;v[113382]=0;R(363,a+484344|0,d|0);d=v[113382];v[113382]=0;if((d|0)==1){break n}}d=e+264|3;da:{if(!(w[d|0]|w[d+1|0]<<8)){break da}i=a+484344|0;f=0;while(1){v[113382]=0;h=Q(228,b|0,4)|0;g=v[113382];v[113382]=0;ea:{if((g|0)!=1){if(h){break ea}break da}b=P()|0;O()|0;break e}v[113382]=0;h=T(397,b|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break h}v[113382]=0;U(307,e+96|0,b|0,h|0);h=v[113382];v[113382]=0;if((h|0)==1){break i}fa:{if(!j){break fa}v[113382]=0;h=T(409,e+96|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break g}v[113382]=0;Q(304,e+96|0,1)|0;g=v[113382];v[113382]=0;if((g|0)==1){break g}v[113382]=0;h=W(364,i|0,f&65535,h+1|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break g}if(!h){break fa}v[113382]=0;W(389,e+96|0,e+48|0,-1)|0;h=v[113382];v[113382]=0;if((h|0)==1){break g}h=Zb(i,f);v[113382]=0;Q(390,h|0,e+48|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break g}h=Zb(i,f);v[113382]=0;U(399,h|0,1,e+96|0);h=v[113382];v[113382]=0;if((h|0)==1){break g}}Bb(e+96|0);f=f+1|0;if(f>>>0<(w[d|0]|w[d+1|0]<<8)>>>0){continue}break}}if(!(c&2)){break k}if(!x[a+480190>>1]){break l}d=0;while(1){if(w[rc(m,d)|0]){c=d+1|0}else{c=d+1|0;f=B(c,104)+a|0;d=Yc(e+96|0,u[f+484414>>1]&1?16:8,1,0,u[rc(m,d)>>1]>=0?0:6);v[113382]=0;W(362,d|0,f+484380|0,b|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break m}}d=c;if(d>>>0<x[a+480190>>1]){continue}break}break l}b=P()|0;O()|0;break e}b=P()|0;O()|0;break e}if(!x[a+480190>>1]){break k}b=0;while(1){c=w[rc(m,b)|0];ga:{if(!c){break ga}c=c-1&65535;if(oc(n)>>>0<=c>>>0){break ga}c=(w[rc(m,b)+1|0]&127)+x[rc(n,c)>>1]&65535;if(c>>>0>x[a+480190>>1]){break ga}f=B(c,104);i=f+a|0;d=i+484380|0;if(!Be(d)){break ga}j=a+484380|0;h=B(b+1|0,104);c=j+h|0;u[c+34>>1]=x[c+34>>1]&65534|u[(f+j|0)+34>>1]&1;v[c>>2]=v[d>>2];v[113382]=0;c=T(422,c|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break j}if(!c){break ga}c=v[(a+h|0)+484400>>2];v[113382]=0;c=T(423,c|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break a}f=v[i+484400>>2];v[113382]=0;f=T(423,f|0)|0;i=v[113382];v[113382]=0;if((i|0)==1){break a}lc(c,f,zj(d))}b=b+1|0;if(b>>>0<x[a+480190>>1]){continue}break}}nf(m);nf(n);break c}b=P()|0;O()|0;break e}b=P()|0;O()|0;break e}b=P()|0;O()|0;break e}b=P()|0;O()|0;Bb(e+96|0);break e}b=P()|0;O()|0}nf(m);nf(n)}yb(o);S(b|0);L()}d=1}yb(o)}jb=e+288|0;return d|0}V(0)|0;O()|0;Ab();L()}function U2(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=jb-48|0;jb=f;d=Ub(f+32|0,7634);e=uf(c,d);yb(d);a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{if(e){jj(a,0,v[b+24>>2]+1304448|0);break k}d=Ub(f+32|0,7031);e=uf(c,d);yb(d);if(e){jj(a,0,v[b+24>>2]+1304436|0);break k}d=Ub(f+32|0,7464);e=uf(c,d);yb(d);if(e){jj(a,0,v[b+24>>2]+1304484|0);break k}d=Ub(f+32|0,7023);e=uf(c,d);yb(d);if(e){jj(a,0,v[b+24>>2]+1304472|0);break k}d=Ub(f+32|0,4517);e=uf(c,d);yb(d);if(e){d=f+32|0;c=d;e=v[v[b+24>>2]+480184>>2];b=73968;l:{while(1){if((e|0)==v[b>>2]){yn(c,0,v[b+8>>2]);break l}b=b+12|0;if((b|0)!=74016){continue}break}bd(c)}v[113382]=0;U(9,a|0,0,d|0);a=v[113382];v[113382]=0;if((a|0)==1){break j}yb(f+32|0);break k}d=Ub(f+32|0,7008);e=uf(c,d);yb(d);if(e){h=f+32|0;j=h;l=v[v[b+24>>2]+480184>>2];c=jb-48|0;jb=c;b=73968;i=jb-16|0;jb=i;m=i+8|0;d=jb-16|0;jb=d;v[113382]=0;g=c+32|0;e=g;T(1490,e+4|0)|0;o=v[113382];v[113382]=0;m:{n:{o:{if((o|0)!=1){v[113382]=0;v[d+12>>2]=0;W(1491,e+8|0,d+12|0,m|0)|0;m=v[113382];v[113382]=0;if((m|0)!=1){break o}break n}break n}t=e,u=jc(e),v[t>>2]=u;jb=d+16|0;break m}V(0)|0;O()|0;Ab();L()}jb=i+16|0;d=bd(j);while(1){if((l|0)==v[b>>2]){e=v[b+4>>2];v[113382]=0;e=Q(2,c+16|0,e|0)|0;i=v[113382];v[113382]=0;p:{q:{r:{s:{t:{u:{if((i|0)!=1){v[113382]=0;U(1489,c|0,g|0,e|0);i=v[113382];v[113382]=0;if((i|0)==1){break s}if(!w[c+4|0]){break p}if(!Sc(d)){v[113382]=0;i=Q(2,c|0,13781)|0;j=v[113382];v[113382]=0;if((j|0)==1){break u}v[113382]=0;Q(162,d|0,i|0)|0;j=v[113382];v[113382]=0;if((j|0)==1){break t}yb(i)}v[113382]=0;Q(162,d|0,e|0)|0;i=v[113382];v[113382]=0;if((i|0)!=1){break p}b=P()|0;O()|0;break r}b=P()|0;O()|0;break q}b=P()|0;O()|0;break r}b=P()|0;O()|0;yb(i);break r}b=P()|0;O()|0}yb(e)}yb(d);HK(g);S(b|0);L()}yb(e)}b=b+12|0;if((b|0)!=74016){continue}break}HK(g);jb=c+48|0;v[113382]=0;U(9,a|0,0,h|0);a=v[113382];v[113382]=0;if((a|0)!=1){yb(f+32|0);break k}c=P()|0;O()|0;yb(f+32|0);break a}d=Ub(f+32|0,4583);e=uf(c,d);yb(d);if(e){jj(a,0,v[b+24>>2]+1304460|0);break k}d=Ub(f+32|0,2106);e=uf(c,d);yb(d);if(e){jj(a,0,v[b+24>>2]+1304412|0);break k}d=Ub(f+32|0,8002);e=uf(c,d);yb(d);if(e){c=f+32|0;zf(c,v[b+24>>2]+1304400|0);v[113382]=0;U(2152,a|0,b|0,c|0);a=v[113382];v[113382]=0;if((a|0)!=1){yb(f+32|0);break k}c=P()|0;O()|0;yb(f+32|0);break a}d=Ub(f+32|0,7407);e=uf(c,d);yb(d);if(e){v:{if(!id(Yw(v[b+24>>2]))){if(v[MH(Yw(v[b+24>>2]))+12>>2]){break v}}Xb(a);break k}p=f+32|0;q=p;b=MH(Yw(v[b+24>>2]));j=jb-192|0;jb=j;lc(j+144|0,b,44);g=v[b+44>>2];if(g){lc(j+44|0,b,44);c=jb-16|0;jb=c;b=uw(v[j+64>>2]+1900|0,v[j+60>>2]+1|0,v[j+56>>2])-uw(1970,1,1)|0;b=qma(b,b>>31,86400,0);d=B(v[j+52>>2],3600);e=d;b=b+d|0;d=mb+(d>>31)|0;d=b>>>0<e>>>0?d+1|0:d;e=b;b=B(v[j+48>>2],60);i=b;e=e+b|0;b=(b>>31)+d|0;b=e>>>0<i>>>0?b+1|0:b;d=v[j+44>>2];i=d;e=d+e|0;d=(d>>31)+b|0;b=nG(c+8|0,e,e>>>0<i>>>0?d+1|0:d);d=v[b+4>>2];b=v[b>>2];jb=c+16|0;v[j+96>>2]=b;v[j+100>>2]=d;d=j+88|0;r=j+96|0;m=r;b=m;e=v[b>>2];i=v[b+4>>2];c=2147483647;n=Md(+(g>>>0)*.054945054945054944);b=-1;w:{if(!(n<0x8000000000000000)){break w}c=-2147483648;b=0;if(!(n>-0x8000000000000000)){break w}if(D(n)<0x8000000000000000){c=D(n)>=1?~~(n>0?F(H(n*2.3283064365386963e-10),4294967295):I((n-+(~~n>>>0>>>0))*2.3283064365386963e-10))>>>0:0;b=~~n>>>0;break w}b=0}k=d;d=c+i|0;e=b+e|0;d=e>>>0<b>>>0?d+1|0:d;b=nG(k,e,d);l=jb-16|0;jb=l;g=v[b>>2];o=v[b+4>>2];v[l+12>>2]=0;v[l+8>>2]=0;v[l+4>>2]=0;b=uw(1970,1,1)+rma(g,o,86400,0)|0;h=b>>31;c=b;d=qma(b,h,1e4,0)+14780|0;b=mb;i=d;b=d>>>0<14780?b+1|0:b;e=b;d=rma(d,b,-14609700,-1);b=c;k=d+b|0;d=h+mb|0;d=b>>>0>k>>>0?d+1|0:d;b=k;k=rma(i,e,365242500,0);b=b+k|0;d=mb+d|0;d=b>>>0<k>>>0?d+1|0:d;k=rma(i,e,-146097e4,-1);b=k+b|0;d=mb+d|0;d=b>>>0<k>>>0?d+1|0:d;k=b;b=rma(i,e,3652425,0);e=mb;s=e;i=k;k=qma(b,e,-365,-1);i=i+k|0;e=mb+d|0;e=i>>>0<k>>>0?e+1|0:e;d=e;if(!((d|0)>0|(d|0)>=0)){d=s-!b|0;b=b-1|0;e=qma(b,d,-365,-1)+c|0;d=h+mb|0;d=c>>>0>e>>>0?d+1|0:d;c=e;e=(b|0)/-4|0;i=e;c=c+e|0;e=(e>>31)+d|0;e=c>>>0<i>>>0?e+1|0:e;d=c;c=(b|0)/100|0;i=c;d=d+c|0;c=(c>>31)+e|0;c=d>>>0<i>>>0?c+1|0:c;e=d;d=(b|0)/-400|0;i=d;e=e+d|0;d=(d>>31)+c|0;d=e>>>0<i>>>0?d+1|0:d;i=e}e=b;c=qma(i,d,100,0)+52|0;b=mb;b=rma(c,c>>>0<52?b+1|0:b,3060,0);c=b+2|0;d=(c|0)/12|0;v[l+12>>2]=e+d;v[l+8>>2]=(c-B(d,12)|0)+1;b=qma(b,mb,306,0)+5|0;d=mb;b=rma(b,b>>>0<5?d+1|0:d,-10,-1)+i|0;v[l+4>>2]=b+1;fG(m);v[m+20>>2]=v[l+12>>2]-1900;v[m+16>>2]=v[l+8>>2]-1;b=v[l+4>>2];t=m,u=sma(rma(g,o,3600,0),mb,24),v[t+8>>2]=u;v[m+12>>2]=b;b=rma(g,o,60,0);c=mb;t=m,u=sma(b,c,60),v[t+4>>2]=u;t=m,u=g-qma(b,c,60,0)|0,v[t>>2]=u;jb=l+16|0;lc(j+144|0,r,44)}i=lc(j,j+144|0,44);c=i;b=jb-112|0;jb=b;d=bd(b+96|0);v[113382]=0;e=Q(2,b+80|0,9479)|0;g=v[113382];v[113382]=0;x:{y:{z:{A:{B:{if((g|0)!=1){g=v[c+20>>2];if(!g){break y}v[113382]=0;v[b+48>>2]=g+1900;R(161,b- -64|0,b+48|0);g=v[113382];v[113382]=0;if((g|0)!=1){v[113382]=0;Q(162,d|0,b- -64|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break B}yb(b- -64|0);if(y[c+16>>2]>11){break y}v[113382]=0;g=Q(2,b+48|0,12897)|0;h=v[113382];v[113382]=0;C:{D:{E:{F:{G:{H:{if((h|0)!=1){h=v[c+16>>2];v[113382]=0;v[b+16>>2]=h+1;R(163,b+32|0,b+16|0);h=v[113382];v[113382]=0;if((h|0)==1){break H}v[113382]=0;U(3,b- -64|0,g|0,b+32|0);h=v[113382];v[113382]=0;if((h|0)==1){break G}v[113382]=0;Q(162,d|0,b- -64|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break F}yb(b- -64|0);yb(b+32|0);yb(g);if(v[c+12>>2]-1>>>0<=30){break C}break y}a=P()|0;O()|0;break A}a=P()|0;O()|0;break D}a=P()|0;O()|0;break E}a=P()|0;O()|0;yb(b- -64|0)}yb(b+32|0)}yb(g);break A}v[113382]=0;g=Q(2,b+48|0,12897)|0;h=v[113382];v[113382]=0;I:{J:{K:{L:{M:{N:{O:{P:{Q:{R:{S:{T:{U:{V:{W:{X:{Y:{Z:{_:{$:{aa:{ba:{ca:{da:{ea:{fa:{if((h|0)!=1){v[113382]=0;R(163,b+32|0,c+12|0);h=v[113382];v[113382]=0;if((h|0)==1){break fa}v[113382]=0;U(3,b- -64|0,g|0,b+32|0);h=v[113382];v[113382]=0;if((h|0)==1){break ea}v[113382]=0;Q(162,d|0,b- -64|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break da}yb(b- -64|0);yb(b+32|0);yb(g);g=v[c+8>>2];h=v[c+4>>2];if(!(v[c>>2]|(g|h))|g>>>0>23|h>>>0>59){break y}v[113382]=0;g=Q(2,b- -64|0,9640)|0;h=v[113382];v[113382]=0;if((h|0)==1){break aa}v[113382]=0;Q(162,d|0,g|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break $}yb(g);if(v[c+32>>2]>0){v[113382]=0;g=Q(2,b- -64|0,11783)|0;h=v[113382];v[113382]=0;if((h|0)==1){break _}Gb(e,g);yb(g)}v[113382]=0;R(163,b+32|0,c+8|0);g=v[113382];v[113382]=0;if((g|0)==1){break Z}v[113382]=0;g=Q(2,b+16|0,10335)|0;h=v[113382];v[113382]=0;if((h|0)==1){break Y}v[113382]=0;U(3,b+48|0,b+32|0,g|0);h=v[113382];v[113382]=0;if((h|0)==1){break X}v[113382]=0;R(163,b|0,c+4|0);h=v[113382];v[113382]=0;if((h|0)==1){break W}v[113382]=0;U(3,b- -64|0,b+48|0,b|0);h=v[113382];v[113382]=0;if((h|0)==1){break V}v[113382]=0;Q(162,d|0,b- -64|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break U}yb(b- -64|0);yb(b);yb(b+48|0);yb(g);yb(b+32|0);if(y[c>>2]<62){break P}v[113382]=0;U(164,q|0,d|0,e|0);c=v[113382];v[113382]=0;if((c|0)==1){break O}break x}a=P()|0;O()|0;break A}a=P()|0;O()|0;break ba}a=P()|0;O()|0;break ca}a=P()|0;O()|0;yb(b- -64|0)}yb(b+32|0)}yb(g);break A}a=P()|0;O()|0;break A}a=P()|0;O()|0;yb(g);break A}a=P()|0;O()|0;break A}a=P()|0;O()|0;break A}a=P()|0;O()|0;break Q}a=P()|0;O()|0;break R}a=P()|0;O()|0;break S}a=P()|0;O()|0;break T}a=P()|0;O()|0;yb(b- -64|0)}yb(b)}yb(b+48|0)}yb(g)}yb(b+32|0);break A}v[113382]=0;g=Q(2,b+48|0,10335)|0;h=v[113382];v[113382]=0;if((h|0)==1){break N}v[113382]=0;R(163,b+32|0,c|0);c=v[113382];v[113382]=0;if((c|0)==1){break M}v[113382]=0;U(3,b- -64|0,g|0,b+32|0);c=v[113382];v[113382]=0;if((c|0)==1){break L}v[113382]=0;Q(162,d|0,b- -64|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break K}yb(b- -64|0);yb(b+32|0);yb(g);v[113382]=0;Q(162,d|0,e|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){break y}}a=P()|0;O()|0;break A}a=P()|0;O()|0;break A}a=P()|0;O()|0;break I}a=P()|0;O()|0;break J}a=P()|0;O()|0;yb(b- -64|0)}yb(b+32|0)}yb(g);break A}a=P()|0;O()|0;break A}a=P()|0;O()|0;break z}a=P()|0;O()|0;yb(b- -64|0)}yb(e)}yb(d);S(a|0);L()}rd(q,d)}yb(e);yb(d);jb=b+112|0;jb=i+192|0;v[113382]=0;U(9,a|0,0,p|0);a=v[113382];v[113382]=0;if((a|0)!=1){yb(f+32|0);break k}c=P()|0;O()|0;yb(f+32|0);break a}d=Ub(f+32|0,8193);e=uf(c,d);yb(d);if(e){c=b;d=f+32|0;gO(d,v[b+24>>2]+1304424|0);ga:{ha:{ia:{if(!Sc(d)){break ia}c=v[c+24>>2];v[113382]=0;c=T(2153,c|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break ga}ja:{switch(c|0){case 0:v[113382]=0;R(2154,f+16|0,b|0);c=v[113382];v[113382]=0;if((c|0)!=1){c=f+16|0;Gb(f+32|0,c);yb(c);break ia}c=P()|0;O()|0;break b;case 1:v[113382]=0;R(2155,f+16|0,b|0);c=v[113382];v[113382]=0;if((c|0)!=1){c=f+16|0;Gb(f+32|0,c);yb(c);break ia}c=P()|0;O()|0;break b;case 2:if(Sc(f+32|0)){v[113382]=0;R(2154,f+16|0,b|0);c=v[113382];v[113382]=0;if((c|0)==1){break i}c=f+16|0;Gb(f+32|0,c);yb(c)}if(!Sc(f+32|0)){break ia}v[113382]=0;R(2155,f+16|0,b|0);c=v[113382];v[113382]=0;if((c|0)!=1){c=f+16|0;Gb(f+32|0,c);yb(c);break ia}c=P()|0;O()|0;break b;case 3:if(Sc(f+32|0)){v[113382]=0;R(2155,f+16|0,b|0);c=v[113382];v[113382]=0;if((c|0)==1){break h}c=f+16|0;Gb(f+32|0,c);yb(c)}if(!Sc(f+32|0)){break ia}v[113382]=0;R(2154,f+16|0,b|0);c=v[113382];v[113382]=0;if((c|0)!=1){c=f+16|0;Gb(f+32|0,c);yb(c);break ia}c=P()|0;O()|0;break b;case 4:v[113382]=0;R(2154,f+16|0,b|0);c=v[113382];v[113382]=0;ka:{la:{if((c|0)!=1){v[113382]=0;R(2155,f|0,b|0);c=v[113382];v[113382]=0;if((c|0)==1){break ka}if(Sc(f+16|0)){break la}v[113382]=0;Q(1214,f+32|0,f+16|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){break la}break d}c=P()|0;O()|0;break b}if(!Sc(f)){v[113382]=0;Q(1214,f+32|0,f|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break d}}yb(f);yb(f+16|0);break ia}c=P()|0;O()|0;break c;case 5:break ja;default:break ia}}v[113382]=0;R(2154,f+16|0,b|0);c=v[113382];v[113382]=0;ma:{if((c|0)!=1){v[113382]=0;R(2155,f|0,b|0);c=v[113382];v[113382]=0;if((c|0)==1){break ha}if(Sc(f)){break ma}v[113382]=0;Q(1214,f+32|0,f|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){break ma}break f}c=P()|0;O()|0;break b}if(!Sc(f+16|0)){v[113382]=0;Q(1214,f+32|0,f+16|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break f}}yb(f);yb(f+16|0)}v[113382]=0;U(2152,a|0,b|0,f+32|0);a=v[113382];v[113382]=0;if((a|0)==1){break ga}yb(f+32|0);break k}c=P()|0;O()|0;break e}c=P()|0;O()|0;break b}d=Ub(f+32|0,1958);e=uf(c,d);yb(d);if(e){c=f+32|0;gO(c,v[b+24>>2]+1304424|0);v[113382]=0;U(2152,a|0,b|0,c|0);a=v[113382];v[113382]=0;if((a|0)!=1){yb(f+32|0);break k}c=P()|0;O()|0;yb(f+32|0);break a}i=c;c=Ub(f+32|0,3559);d=uf(i,c);yb(c);if(d){a=Xb(a);b=b+68|0;t=f,u=ac(b),v[t+32>>2]=u;t=f,u=bc(b),v[t+16>>2]=u;if(!Jb(f+32|0,f+16|0)){break k}c=1;while(1){b=v[f+32>>2];if(!(c&1)){v[113382]=0;Q(1964,a|0,17517)|0;c=v[113382];v[113382]=0;if((c|0)==1){break g}}v[113382]=0;Q(1214,a|0,b|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break g}b=f+32|0;vn(b);c=0;if(Jb(b,f+16|0)){continue}break}break k}Ub(a,17540)}jb=f+48|0;return}c=P()|0;O()|0;yb(f+32|0);break a}c=P()|0;O()|0;break b}c=P()|0;O()|0;break b}c=P()|0;O()|0;yb(a);break a}c=P()|0;O()|0;yb(f)}yb(f+16|0);break b}c=P()|0;O()|0;yb(f)}yb(f+16|0)}yb(f+32|0)}S(c|0);L()}function kd(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;l=jb-16|0;jb=l;a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{if(a>>>0<=244){e=v[114679];h=a>>>0<11?16:a+11&-8;c=h>>>3|0;b=e>>>c|0;if(b&3){d=c+((b^-1)&1)|0;b=d<<3;f=v[b+458764>>2];a=f+8|0;c=v[f+8>>2];b=b+458756|0;l:{if((c|0)==(b|0)){m=458716,n=uma(-2,d)&e,v[m>>2]=n;break l}v[c+12>>2]=b;v[b+8>>2]=c}b=d<<3;v[f+4>>2]=b|3;b=b+f|0;v[b+4>>2]=v[b+4>>2]|1;break a}k=v[114681];if(k>>>0>=h>>>0){break k}if(b){a=2<<c;a=(0-a|a)&b<<c;b=(0-a&a)-1|0;a=b>>>12&16;c=a;b=b>>>a|0;a=b>>>5&8;c=c|a;b=b>>>a|0;a=b>>>2&4;c=c|a;b=b>>>a|0;a=b>>>1&2;c=c|a;b=b>>>a|0;a=b>>>1&1;c=(c|a)+(b>>>a|0)|0;a=c<<3;g=v[a+458764>>2];b=v[g+8>>2];a=a+458756|0;m:{if((b|0)==(a|0)){e=uma(-2,c)&e;v[114679]=e;break m}v[b+12>>2]=a;v[a+8>>2]=b}a=g+8|0;v[g+4>>2]=h|3;d=g+h|0;b=c<<3;f=b-h|0;v[d+4>>2]=f|1;v[b+g>>2]=f;if(k){b=k>>>3|0;c=(b<<3)+458756|0;g=v[114684];b=1<<b;n:{if(!(b&e)){v[114679]=b|e;b=c;break n}b=v[c+8>>2]}v[c+8>>2]=g;v[b+12>>2]=g;v[g+12>>2]=c;v[g+8>>2]=b}v[114684]=d;v[114681]=f;break a}j=v[114680];if(!j){break k}b=(j&0-j)-1|0;a=b>>>12&16;c=a;b=b>>>a|0;a=b>>>5&8;c=c|a;b=b>>>a|0;a=b>>>2&4;c=c|a;b=b>>>a|0;a=b>>>1&2;c=c|a;b=b>>>a|0;a=b>>>1&1;b=v[((c|a)+(b>>>a|0)<<2)+459020>>2];d=(v[b+4>>2]&-8)-h|0;c=b;while(1){o:{a=v[c+16>>2];if(!a){a=v[c+20>>2];if(!a){break o}}c=(v[a+4>>2]&-8)-h|0;f=c>>>0<d>>>0;d=f?c:d;b=f?a:b;c=a;continue}break}i=v[b+24>>2];f=v[b+12>>2];if((f|0)!=(b|0)){a=v[b+8>>2];v[a+12>>2]=f;v[f+8>>2]=a;break b}c=b+20|0;a=v[c>>2];if(!a){a=v[b+16>>2];if(!a){break j}c=b+16|0}while(1){g=c;f=a;c=a+20|0;a=v[c>>2];if(a){continue}c=f+16|0;a=v[f+16>>2];if(a){continue}break}v[g>>2]=0;break b}h=-1;if(a>>>0>4294967231){break k}a=a+11|0;h=a&-8;j=v[114680];if(!j){break k}d=0-h|0;e=0;p:{if(h>>>0<256){break p}e=31;if(h>>>0>16777215){break p}a=a>>>8|0;g=a+1048320>>>16&8;a=a<<g;c=a+520192>>>16&4;a=a<<c;b=a+245760>>>16&2;a=(a<<b>>>15|0)-(b|(c|g))|0;e=(a<<1|h>>>a+21&1)+28|0}c=v[(e<<2)+459020>>2];q:{r:{s:{if(!c){a=0;break s}a=0;b=h<<((e|0)==31?0:25-(e>>>1|0)|0);while(1){t:{g=(v[c+4>>2]&-8)-h|0;if(g>>>0>=d>>>0){break t}f=c;d=g;if(d){break t}d=0;a=c;break r}g=v[c+20>>2];c=v[((b>>>29&4)+c|0)+16>>2];a=g?(g|0)==(c|0)?a:g:a;b=b<<1;if(c){continue}break}}if(!(a|f)){f=0;a=2<<e;a=(0-a|a)&j;if(!a){break k}b=(a&0-a)-1|0;a=b>>>12&16;c=a;b=b>>>a|0;a=b>>>5&8;c=c|a;b=b>>>a|0;a=b>>>2&4;c=c|a;b=b>>>a|0;a=b>>>1&2;c=c|a;b=b>>>a|0;a=b>>>1&1;a=v[((c|a)+(b>>>a|0)<<2)+459020>>2]}if(!a){break q}}while(1){b=(v[a+4>>2]&-8)-h|0;c=b>>>0<d>>>0;d=c?b:d;f=c?a:f;b=v[a+16>>2];if(b){a=b}else{a=v[a+20>>2]}if(a){continue}break}}if(!f|v[114681]-h>>>0<=d>>>0){break k}e=v[f+24>>2];b=v[f+12>>2];if((f|0)!=(b|0)){a=v[f+8>>2];v[a+12>>2]=b;v[b+8>>2]=a;break c}c=f+20|0;a=v[c>>2];if(!a){a=v[f+16>>2];if(!a){break i}c=f+16|0}while(1){g=c;b=a;c=a+20|0;a=v[c>>2];if(a){continue}c=b+16|0;a=v[b+16>>2];if(a){continue}break}v[g>>2]=0;break c}c=v[114681];if(c>>>0>=h>>>0){d=v[114684];b=c-h|0;u:{if(b>>>0>=16){v[114681]=b;a=d+h|0;v[114684]=a;v[a+4>>2]=b|1;v[c+d>>2]=b;v[d+4>>2]=h|3;break u}v[114684]=0;v[114681]=0;v[d+4>>2]=c|3;a=c+d|0;v[a+4>>2]=v[a+4>>2]|1}a=d+8|0;break a}i=v[114682];if(i>>>0>h>>>0){b=i-h|0;v[114682]=b;c=v[114685];a=c+h|0;v[114685]=a;v[a+4>>2]=b|1;v[c+4>>2]=h|3;a=c+8|0;break a}a=0;j=h+47|0;b=j;if(v[114797]){c=v[114799]}else{v[114800]=-1;v[114801]=-1;v[114798]=4096;v[114799]=4096;v[114797]=l+12&-16^1431655768;v[114802]=0;v[114790]=0;c=4096}g=b+c|0;f=0-c|0;c=g&f;if(c>>>0<=h>>>0){break a}d=v[114789];if(d){b=v[114787];e=b+c|0;if(d>>>0<e>>>0|b>>>0>=e>>>0){break a}}if(w[459160]&4){break f}v:{w:{d=v[114685];if(d){a=459164;while(1){b=v[a>>2];if(b>>>0<=d>>>0&d>>>0<b+v[a+4>>2]>>>0){break w}a=v[a+8>>2];if(a){continue}break}}b=Yk(0);if((b|0)==-1){break g}e=c;d=v[114798];a=d-1|0;if(a&b){e=(c-b|0)+(a+b&0-d)|0}if(e>>>0<=h>>>0|e>>>0>2147483646){break g}d=v[114789];if(d){a=v[114787];f=a+e|0;if(d>>>0<f>>>0|a>>>0>=f>>>0){break g}}a=Yk(e);if((b|0)!=(a|0)){break v}break e}e=f&g-i;if(e>>>0>2147483646){break g}b=Yk(e);if((b|0)==(v[a>>2]+v[a+4>>2]|0)){break h}a=b}if(!((a|0)==-1|h+48>>>0<=e>>>0)){b=v[114799];b=b+(j-e|0)&0-b;if(b>>>0>2147483646){b=a;break e}if((Yk(b)|0)!=-1){e=b+e|0;b=a;break e}Yk(0-e|0);break g}b=a;if((a|0)!=-1){break e}break g}f=0;break b}b=0;break c}if((b|0)!=-1){break e}}v[114790]=v[114790]|4}if(c>>>0>2147483646){break d}b=Yk(c);a=Yk(0);if((b|0)==-1|(a|0)==-1|a>>>0<=b>>>0){break d}e=a-b|0;if(e>>>0<=h+40>>>0){break d}}a=v[114787]+e|0;v[114787]=a;if(a>>>0>y[114788]){v[114788]=a}x:{y:{z:{g=v[114685];if(g){a=459164;while(1){d=v[a>>2];c=v[a+4>>2];if((d+c|0)==(b|0)){break z}a=v[a+8>>2];if(a){continue}break}break y}a=v[114683];if(!(a>>>0<=b>>>0?a:0)){v[114683]=b}a=0;v[114792]=e;v[114791]=b;v[114687]=-1;v[114688]=v[114797];v[114794]=0;while(1){d=a<<3;c=d+458756|0;v[d+458764>>2]=c;v[d+458768>>2]=c;a=a+1|0;if((a|0)!=32){continue}break}d=e-40|0;a=b+8&7?-8-b&7:0;c=d-a|0;v[114682]=c;a=a+b|0;v[114685]=a;v[a+4>>2]=c|1;v[(b+d|0)+4>>2]=40;v[114686]=v[114801];break x}if(w[a+12|0]&8|d>>>0>g>>>0|b>>>0<=g>>>0){break y}v[a+4>>2]=c+e;a=g+8&7?-8-g&7:0;c=a+g|0;v[114685]=c;b=v[114682]+e|0;a=b-a|0;v[114682]=a;v[c+4>>2]=a|1;v[(b+g|0)+4>>2]=40;v[114686]=v[114801];break x}if(y[114683]>b>>>0){v[114683]=b}c=b+e|0;a=459164;A:{B:{C:{D:{E:{F:{while(1){if((c|0)!=v[a>>2]){a=v[a+8>>2];if(a){continue}break F}break}if(!(w[a+12|0]&8)){break E}}a=459164;while(1){c=v[a>>2];if(c>>>0<=g>>>0){f=c+v[a+4>>2]|0;if(f>>>0>g>>>0){break D}}a=v[a+8>>2];continue}}v[a>>2]=b;v[a+4>>2]=v[a+4>>2]+e;j=(b+8&7?-8-b&7:0)+b|0;v[j+4>>2]=h|3;e=c+(c+8&7?-8-c&7:0)|0;i=h+j|0;c=e-i|0;if((e|0)==(g|0)){v[114685]=i;a=v[114682]+c|0;v[114682]=a;v[i+4>>2]=a|1;break B}if(v[114684]==(e|0)){v[114684]=i;a=v[114681]+c|0;v[114681]=a;v[i+4>>2]=a|1;v[a+i>>2]=a;break B}a=v[e+4>>2];if((a&3)==1){g=a&-8;G:{if(a>>>0<=255){d=v[e+8>>2];a=a>>>3|0;b=v[e+12>>2];if((b|0)==(d|0)){m=458716,n=v[114679]&uma(-2,a),v[m>>2]=n;break G}v[d+12>>2]=b;v[b+8>>2]=d;break G}h=v[e+24>>2];b=v[e+12>>2];H:{if((e|0)!=(b|0)){a=v[e+8>>2];v[a+12>>2]=b;v[b+8>>2]=a;break H}I:{a=e+20|0;d=v[a>>2];if(d){break I}a=e+16|0;d=v[a>>2];if(d){break I}b=0;break H}while(1){f=a;b=d;a=b+20|0;d=v[a>>2];if(d){continue}a=b+16|0;d=v[b+16>>2];if(d){continue}break}v[f>>2]=0}if(!h){break G}d=v[e+28>>2];a=(d<<2)+459020|0;J:{if(v[a>>2]==(e|0)){v[a>>2]=b;if(b){break J}m=458720,n=v[114680]&uma(-2,d),v[m>>2]=n;break G}v[h+(v[h+16>>2]==(e|0)?16:20)>>2]=b;if(!b){break G}}v[b+24>>2]=h;a=v[e+16>>2];if(a){v[b+16>>2]=a;v[a+24>>2]=b}a=v[e+20>>2];if(!a){break G}v[b+20>>2]=a;v[a+24>>2]=b}e=e+g|0;c=c+g|0}v[e+4>>2]=v[e+4>>2]&-2;v[i+4>>2]=c|1;v[c+i>>2]=c;if(c>>>0<=255){a=c>>>3|0;b=(a<<3)+458756|0;c=v[114679];a=1<<a;K:{if(!(c&a)){v[114679]=a|c;a=b;break K}a=v[b+8>>2]}v[b+8>>2]=i;v[a+12>>2]=i;v[i+12>>2]=b;v[i+8>>2]=a;break B}a=31;if(c>>>0<=16777215){a=c>>>8|0;f=a+1048320>>>16&8;a=a<<f;d=a+520192>>>16&4;a=a<<d;b=a+245760>>>16&2;a=(a<<b>>>15|0)-(b|(d|f))|0;a=(a<<1|c>>>a+21&1)+28|0}v[i+28>>2]=a;v[i+16>>2]=0;v[i+20>>2]=0;f=(a<<2)+459020|0;d=v[114680];b=1<<a;L:{if(!(d&b)){v[114680]=b|d;v[f>>2]=i;v[i+24>>2]=f;break L}a=c<<((a|0)==31?0:25-(a>>>1|0)|0);b=v[f>>2];while(1){d=b;if((v[b+4>>2]&-8)==(c|0)){break C}b=a>>>29|0;a=a<<1;f=d+(b&4)|0;b=v[f+16>>2];if(b){continue}break}v[f+16>>2]=i;v[i+24>>2]=d}v[i+12>>2]=i;v[i+8>>2]=i;break B}d=e-40|0;a=b+8&7?-8-b&7:0;c=d-a|0;v[114682]=c;a=a+b|0;v[114685]=a;v[a+4>>2]=c|1;v[(b+d|0)+4>>2]=40;v[114686]=v[114801];a=(f+(f-39&7?39-f&7:0)|0)-47|0;c=a>>>0<g+16>>>0?g:a;v[c+4>>2]=27;a=v[114794];v[c+16>>2]=v[114793];v[c+20>>2]=a;a=v[114792];v[c+8>>2]=v[114791];v[c+12>>2]=a;v[114793]=c+8;v[114792]=e;v[114791]=b;v[114794]=0;a=c+24|0;while(1){v[a+4>>2]=7;b=a+8|0;a=a+4|0;if(b>>>0<f>>>0){continue}break}if((c|0)==(g|0)){break x}v[c+4>>2]=v[c+4>>2]&-2;f=c-g|0;v[g+4>>2]=f|1;v[c>>2]=f;if(f>>>0<=255){a=f>>>3|0;b=(a<<3)+458756|0;c=v[114679];a=1<<a;M:{if(!(c&a)){v[114679]=a|c;a=b;break M}a=v[b+8>>2]}v[b+8>>2]=g;v[a+12>>2]=g;v[g+12>>2]=b;v[g+8>>2]=a;break x}a=31;v[g+16>>2]=0;v[g+20>>2]=0;if(f>>>0<=16777215){a=f>>>8|0;d=a+1048320>>>16&8;a=a<<d;c=a+520192>>>16&4;a=a<<c;b=a+245760>>>16&2;a=(a<<b>>>15|0)-(b|(c|d))|0;a=(a<<1|f>>>a+21&1)+28|0}v[g+28>>2]=a;d=(a<<2)+459020|0;c=v[114680];b=1<<a;N:{if(!(c&b)){v[114680]=b|c;v[d>>2]=g;v[g+24>>2]=d;break N}a=f<<((a|0)==31?0:25-(a>>>1|0)|0);b=v[d>>2];while(1){c=b;if((f|0)==(v[b+4>>2]&-8)){break A}b=a>>>29|0;a=a<<1;d=c+(b&4)|0;b=v[d+16>>2];if(b){continue}break}v[d+16>>2]=g;v[g+24>>2]=c}v[g+12>>2]=g;v[g+8>>2]=g;break x}a=v[d+8>>2];v[a+12>>2]=i;v[d+8>>2]=i;v[i+24>>2]=0;v[i+12>>2]=d;v[i+8>>2]=a}a=j+8|0;break a}a=v[c+8>>2];v[a+12>>2]=g;v[c+8>>2]=g;v[g+24>>2]=0;v[g+12>>2]=c;v[g+8>>2]=a}a=v[114682];if(a>>>0<=h>>>0){break d}b=a-h|0;v[114682]=b;c=v[114685];a=c+h|0;v[114685]=a;v[a+4>>2]=b|1;v[c+4>>2]=h|3;a=c+8|0;break a}v[113305]=48;a=0;break a}O:{if(!e){break O}c=v[f+28>>2];a=(c<<2)+459020|0;P:{if(v[a>>2]==(f|0)){v[a>>2]=b;if(b){break P}j=uma(-2,c)&j;v[114680]=j;break O}v[e+(v[e+16>>2]==(f|0)?16:20)>>2]=b;if(!b){break O}}v[b+24>>2]=e;a=v[f+16>>2];if(a){v[b+16>>2]=a;v[a+24>>2]=b}a=v[f+20>>2];if(!a){break O}v[b+20>>2]=a;v[a+24>>2]=b}Q:{if(d>>>0<=15){a=d+h|0;v[f+4>>2]=a|3;a=a+f|0;v[a+4>>2]=v[a+4>>2]|1;break Q}v[f+4>>2]=h|3;e=f+h|0;v[e+4>>2]=d|1;v[d+e>>2]=d;if(d>>>0<=255){a=d>>>3|0;b=(a<<3)+458756|0;c=v[114679];a=1<<a;R:{if(!(c&a)){v[114679]=a|c;a=b;break R}a=v[b+8>>2]}v[b+8>>2]=e;v[a+12>>2]=e;v[e+12>>2]=b;v[e+8>>2]=a;break Q}a=31;if(d>>>0<=16777215){a=d>>>8|0;g=a+1048320>>>16&8;a=a<<g;c=a+520192>>>16&4;a=a<<c;b=a+245760>>>16&2;a=(a<<b>>>15|0)-(b|(c|g))|0;a=(a<<1|d>>>a+21&1)+28|0}v[e+28>>2]=a;v[e+16>>2]=0;v[e+20>>2]=0;b=(a<<2)+459020|0;S:{c=1<<a;T:{if(!(c&j)){v[114680]=c|j;v[b>>2]=e;break T}a=d<<((a|0)==31?0:25-(a>>>1|0)|0);h=v[b>>2];while(1){b=h;if((v[b+4>>2]&-8)==(d|0)){break S}c=a>>>29|0;a=a<<1;c=(c&4)+b|0;h=v[c+16>>2];if(h){continue}break}v[c+16>>2]=e}v[e+24>>2]=b;v[e+12>>2]=e;v[e+8>>2]=e;break Q}a=v[b+8>>2];v[a+12>>2]=e;v[b+8>>2]=e;v[e+24>>2]=0;v[e+12>>2]=b;v[e+8>>2]=a}a=f+8|0;break a}U:{if(!i){break U}c=v[b+28>>2];a=(c<<2)+459020|0;V:{if(v[a>>2]==(b|0)){v[a>>2]=f;if(f){break V}m=458720,n=uma(-2,c)&j,v[m>>2]=n;break U}v[i+(v[i+16>>2]==(b|0)?16:20)>>2]=f;if(!f){break U}}v[f+24>>2]=i;a=v[b+16>>2];if(a){v[f+16>>2]=a;v[a+24>>2]=f}a=v[b+20>>2];if(!a){break U}v[f+20>>2]=a;v[a+24>>2]=f}W:{if(d>>>0<=15){a=d+h|0;v[b+4>>2]=a|3;a=a+b|0;v[a+4>>2]=v[a+4>>2]|1;break W}v[b+4>>2]=h|3;f=b+h|0;v[f+4>>2]=d|1;v[d+f>>2]=d;if(k){a=k>>>3|0;c=(a<<3)+458756|0;g=v[114684];a=1<<a;X:{if(!(a&e)){v[114679]=a|e;a=c;break X}a=v[c+8>>2]}v[c+8>>2]=g;v[a+12>>2]=g;v[g+12>>2]=c;v[g+8>>2]=a}v[114684]=f;v[114681]=d}a=b+8|0}jb=l+16|0;return a|0}function Nla(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,y=0,z=0,A=0,C=0,D=0;f=jb+-64|0;jb=f;Ic(a);a:{b:{if(b>>>0<=2){g=f+56|0;C=g,D=le(a),t[C|0]=D;_b(a,2);e=g|2;b=og(a);t[e|0]=b;t[e+1|0]=b>>>8;e=g|4;b=Df(a);t[e|0]=b;t[e+1|0]=b>>>8;t[e+2|0]=b>>>16;t[e+3|0]=b>>>24;break b}Hf(a,f+56|0);if(b>>>0>5){break a}}t[f+56|1]=0}c:{n=d+484344|0;b=f+56|2;s=Ed(w[b|0]|w[b+1|0]<<8,1,1024);m=wx(n,s,0);if((m|0)!=65535){e=Mn(Zb(n,m),0);u[f>>1]=x[d+480188>>1]-1;u[f+40>>1]=w[f+56|0];y=x[Af(f,f+40|0)>>1];g=y+1|0;if(x[d+480188>>1]>(g&65535)>>>0){b=g&65535;while(1){t[e+B(b,6)|0]=254;b=b+1|0;if(b>>>0<x[d+480188>>1]){continue}break}}t[c+13|0]=w[f+56|1]>>>4;b=w[c+12|0];t[f|0]=0;o=Ut(f+40|0,g,f);if(s){b=(b|0)!=0;while(1){d:{e:{f:{if(!w[uc(o,0)|0]){v[113382]=0;g=T(409,a|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break c}h=g<<24>>24;if((h|0)<0){v[113382]=0;g=T(409,a|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break c}C=uc(o,0),D=g,t[C|0]=D}t[f|0]=0;g:{g=h&63;if(!g){break g}v[113382]=0;j=T(409,a|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break c}t[f|0]=j;h:{i:{switch(g-1|0){case 0:t[c+12|0]=0;v[113382]=0;t[f+36|0]=1;e=Q(410,f+36|0,f|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){t[c+14|0]=w[e|0];t[c+15|0]=0;break h}break c;case 1:if(!j){break g}t[c+15|0]=j;t[c+12|0]=1;b=w[c+13|0];if(!b){break h}t[c+14|0]=B(B(b,j),15);break h;case 2:t[c+13|0]=j>>>4;if(j>>>0<16){break f}b=w[c+12|0];j=0;v[f+36>>2]=0;v[f+32>>2]=0;p=0;if(b){break e}break d;case 3:p=0;v[f+36>>2]=0;v[f+32>>2]=0;if(b&1){break e}break d;case 5:if(!j){break g}b=(w[c+12|0]?15:14)+c|0;e=w[b|0];t[b|0]=e>>>0<256-j>>>0?e+j|0:-1;break h;case 6:break i;default:break g}}if(!j){break g}b=(w[c+12|0]?15:14)+c|0;e=w[b|0];t[b|0]=e>>>0>j+1>>>0?e-j|0:1}j=0;v[f+36>>2]=0;v[f+32>>2]=0;break e}j=0;v[f+36>>2]=0;v[f+32>>2]=0;p=0;if(b&1){break e}break d}j=0;e=uc(o,0);t[e|0]=w[e|0]-1;v[f+36>>2]=0;v[f+32>>2]=0;p=0;if(!(b&1)){break d}break e}j=0;t[c+12|0]=0;v[f+36>>2]=0;v[f+32>>2]=0;p=0;if(b&1){break e}break d}e=w[c+13|0];b=w[c+12|0];if(b){p=0;if(!e){break d}}j:{if(b){v[f>>2]=1;b=w[c+15|0];v[113382]=0;v[f+28>>2]=B(b,e)<<1;e=Q(515,f|0,f+28|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break c}e=v[e>>2];break j}e=B(w[c+14|0],30)+30|0}b=255;k:{while(1){h=B(b,e);if(h-1536>>>0<10752){break k}g=b>>>0>1;b=b-1|0;if(g){continue}break}b=0}v[f+36>>2]=b;v[f+32>>2]=(h|0)/48;Yd(f+32|0,32,255);v[113382]=0;v[f>>2]=1;e=Q(515,f|0,f+36|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){t[c+16|0]=v[e>>2];p=1;break d}break c}b=Zb(n,m);v[113382]=0;b=W(432,b|0,l|0,1)|0;e=v[113382];v[113382]=0;if((e|0)==1){break c}if(y){z=l-1|0;i=1;q=1;while(1){l:{if(!w[uc(o,i)|0]){v[113382]=0;k=T(409,a|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break c}if(k&128){v[113382]=0;g=T(409,a|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break c}C=uc(o,i),D=g,t[C|0]=D}A=1;if(k&64){v[113382]=0;g=T(409,a|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break c}t[b+1|0]=g;A=!g}m:{if(!(k&32)){break m}v[113382]=0;g=T(409,a|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break c}t[b|0]=g;if((g-1&255)>>>0<=107){e=Up(g+24|0);t[b|0]=e;C=Lc(c,i),D=e,t[C+1|0]=D;break m}if((g+127&255)>>>0<=107){e=Up((g&127)+24|0);t[b|0]=e;C=Lc(c,i),D=e,t[C|0]=D;t[b|0]=0;break m}if((g|0)!=255){break m}t[b|0]=254}if(!(w[b|0]|!w[b+1|0])){e=w[Lc(c,i)+1|0];t[b+1|0]=0;t[b|0]=e}v[113382]=0;g=T(516,b|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break c}if(g){C=Lc(c,i),D=0,t[C+5|0]=D}t[f+27|0]=0;t[f+26|0]=0;t[f+25|0]=0;t[f+24|0]=0;t[f+23|0]=0;t[f+22|0]=0;if(k&16){t[b+2|0]=1;v[113382]=0;g=T(409,a|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break c}t[b+4|0]=g+2>>>2}n:{if(!(k&8)){break n}v[113382]=0;g=T(409,a|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break c}v[113382]=0;t[f+27|0]=g;g=T(409,a|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break c}t[f+24|0]=g;o:{p:{q:{r:{s:{t:{u:{v:{e=w[f+27|0];switch(e-1|0){case 0:break p;case 9:break q;case 5:case 6:case 7:case 8:break r;case 4:break s;case 3:break t;case 2:break u;case 1:break v;default:break o}}t[b|0]=255;break o}C=b,D=w[Lc(c,i)+1|0],t[C|0]=D;C=Lc(c,i),D=0,t[C+5|0]=D;break o}e=Tt(g,w[c+16|0]);t[f+24|0]=e;w:{if(e){t[f+27|0]=20;t[f+24|0]=e|208;break w}t[f+27|0]=0}if(w[b|0]){break n}C=b,D=w[Lc(c,i)+1|0],t[C|0]=D;C=Lc(c,i),D=0,t[C+5|0]=D;break n}t[f|0]=1;e=Tt(g,w[c+16|0]);v[113382]=0;t[f+28|0]=e;g=Q(410,f|0,f+28|0)|0;e=v[113382];v[113382]=0;if((e|0)!=1){t[f+24|0]=w[g|0];t[f+27|0]=15;C=Lc(c,i),D=0,t[C+5|0]=D;break n}break c}x:{if(!l){break x}if((e|0)==w[Lc(c,i)+4|0]){break x}h=Zb(n,m);v[113382]=0;g=W(459,f|0,20,(w[f+27|0]+122|160)&255)|0;e=v[113382];v[113382]=0;if((e|0)==1){break c}e=Cn(Bn(Me(g,z),q&65535));v[113382]=0;g=Q(460,h|0,e|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break c}if(!g){break x}e=w[f+27|0];C=Lc(c,i),D=e,t[C+4|0]=D}t[f+27|0]=10;if(!w[b|0]){C=b,D=w[Lc(c,i)+1|0],t[C|0]=D}C=Lc(c,i),D=0,t[C+5|0]=D;break n}t[f+27|0]=20;C=f,D=w[Lc(c,i)+5|0]?-98:-97,t[C+24|0]=D;e=w[Lc(c,i)+5|0];C=Lc(c,i),D=e^1,t[C+5|0]=D;break n}t[b|0]=254}t[f+27|0]=0}r=0;g=0;y:{if(!(k&4)){break y}v[113382]=0;g=T(409,a|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break c}v[113382]=0;t[f+26|0]=g;g=T(409,a|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break c}g=g<<24>>24;t[f+23|0]=g;e=f;z:{A:{B:{C:{D:{E:{F:{G:{H:{I:{J:{h=w[f+26|0];switch(h-1|0){case 11:break B;case 10:break C;case 7:case 8:case 9:break D;case 6:break E;case 5:break F;case 3:case 4:break G;case 2:break H;case 1:break I;case 0:break J;default:break A}}e=(g|0)>=0;t[f+26|0]=e?2:3;if(!e){g=0-g|0;t[f+23|0]=g}K:{if((g&255)>>>0<16){break K}v[113382]=0;g=T(516,b|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break c}if(!g){break K}L:{if(w[f+26|0]==2){e=w[b|0];v[113382]=0;v[f>>2]=e+(w[f+23|0]>>>4|0);v[f+28>>2]=120;g=Q(420,f|0,f+28|0)|0;e=v[113382];v[113382]=0;if((e|0)!=1){break L}break c}e=w[b|0];v[113382]=0;v[f>>2]=e-(w[f+23|0]>>>4|0);v[f+28>>2]=1;g=Q(515,f|0,f+28|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break c}}t[b|0]=v[g>>2];t[f+23|0]=w[f+23|0]&15}v[113382]=0;t[f|0]=15;g=Q(415,f|0,f+23|0)|0;e=v[113382];v[113382]=0;if((e|0)!=1){t[f+23|0]=w[g|0]|240;g=0;break y}break c}e=Tt(g&255,w[c+16|0]);t[f+23|0]=e;if(e){t[f+26|0]=20;t[f+23|0]=e|208;g=1;break y}t[f+26|0]=0;g=1;break y}g=1;break z}e=w[c+16|0];v[113382]=0;g=W(517,g&255,e|0,1)|0;e=v[113382];v[113382]=0;if((e|0)==1){break c}t[f+23|0]=g;t[f+26|0]=w[f+26|0]==4?2:3;g=1;break y}if(!w[b|0]){C=b,D=w[Lc(c,i)|0],t[C|0]=D;g=w[f+23|0]}e=w[c+16|0];v[113382]=0;g=W(517,g&255,e|0,0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break c}t[f+26|0]=4;t[f+23|0]=g;g=1;break y}C=b,D=Up((g&255)+25|0),t[C|0]=D;t[f+23|0]=255;t[f+26|0]=4;g=1;break y}M:{if(!l){break M}if((h|0)==w[Lc(c,i)+2|0]){break M}h=Zb(n,m);v[113382]=0;g=W(459,f|0,20,(w[f+26|0]-8|48)&255)|0;e=v[113382];v[113382]=0;if((e|0)==1){break c}e=Cn(Bn(Me(g,z),q&65535));v[113382]=0;g=Q(460,h|0,e|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break c}if(!g){break M}e=w[f+26|0];C=Lc(c,i),D=e,t[C+2|0]=D}t[f+26|0]=5;e=w[c+16|0];v[113382]=0;g=Q(518,w[f+23|0],e|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break c}t[f+23|0]=g;g=1;break y}e=QS(g&255,w[c+16|0]);t[f+26|0]=18;t[f+23|0]=e;g=1;break y}e=Tt(g&255,w[c+16|0]);t[f+23|0]=e;if(e){t[f+26|0]=20;t[f+23|0]=e|192;g=1;break y}t[f+26|0]=0;t[b|0]=254;g=1;break y}g=0}t[e+26|0]=g}N:{if(!(k&2)){break N}v[113382]=0;h=T(409,a|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break c}v[113382]=0;t[f+25|0]=h;k=T(409,a|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break c}t[f+22|0]=k;O:{P:{Q:{R:{S:{T:{U:{h=w[f+25|0];switch(h-1|0){case 9:break P;case 7:case 8:break Q;case 6:break R;case 3:case 4:case 5:break S;case 2:break T;case 0:case 1:break U;default:break O}}e=w[c+16|0];v[113382]=0;h=W(519,k|0,e|0,(h|0)==1|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break c}t[f+25|0]=11;t[f+22|0]=h;r=1;break N}e=QS(k,w[c+16|0]);t[f+25|0]=18;t[f+22|0]=e;r=1;break N}V:{if(!l){break V}if((h|0)==w[Lc(c,i)+3|0]){break V}k=Zb(n,m);v[113382]=0;h=W(459,f|0,20,(w[f+25|0]-4|64)&255)|0;e=v[113382];v[113382]=0;if((e|0)==1){break c}e=Cn(Bn(Me(h,z),q&65535));v[113382]=0;h=Q(460,k|0,e|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break c}if(!h){break V}e=w[f+25|0];C=Lc(c,i),D=e,t[C+3|0]=D}t[f+25|0]=8;e=w[c+16|0];v[113382]=0;h=Q(518,w[f+22|0],e|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break c}t[f+22|0]=h;r=1;break N}t[f+25|0]=9;break N}e=w[c+16|0];v[113382]=0;h=W(519,k|0,e|0,(h|0)==8|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break c}t[f+25|0]=29;t[f+22|0]=h;r=1;break N}t[f+25|0]=27;e=w[c+16|0];v[113382]=0;h=Q(518,k|0,e|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break c}t[f+22|0]=h;r=1;break N}t[f+25|0]=0}if(g){PS(b,l,x[d+480188>>1],w[f+26|0],f+23|0)}if(r){PS(b,l,x[d+480188>>1],w[f+25|0],f+22|0)}W:{if(!A){break W}v[113382]=0;g=T(516,b|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break c}if(!g){break W}e=w[f+26|0];if(!e){t[f+23|0]=255;t[f+26|0]=4;break W}if(w[f+25|0]|(e|0)==4){break W}t[f+22|0]=255;t[f+25|0]=4}X:{if(w[b+2|0]!=1){break X}Y:{if(!w[f+26|0]){t[f+26|0]=13;t[f+23|0]=w[b+4|0];break Y}if(w[f+25|0]){break X}t[f+25|0]=13;t[f+22|0]=w[b+4|0]}t[b+2|0]=0}v[113382]=0;fa(461,f|0,f+26|0,f+23|0,f+25|0,f+22|0);e=v[113382];v[113382]=0;if((e|0)==1){break c}Z:{if(w[b+2|0]){break Z}e=w[f+26|0];if(!e){break Z}t[b+2|0]=e;t[b+4|0]=w[f+23|0]}_:{if(w[f+27|0]){v[113382]=0;fa(461,f|0,f+25|0,f+22|0,f+27|0,f+24|0);e=v[113382];v[113382]=0;if((e|0)==1){break c}$:{if(w[b+2|0]){break $}e=w[f+25|0];if(!e){break $}t[b+2|0]=e;t[b+4|0]=w[f+22|0]}i=f+24|0;g=w[f+27|0];break _}i=f+22|0;g=w[f+25|0];if(!g){break l}}t[b+3|0]=g;t[b+5|0]=w[i|0];break l}e=uc(o,i);t[e|0]=w[e|0]-1}b=b+6|0;q=q+1|0;i=q&65535;if(y>>>0>=i>>>0){continue}break}}aa:{if(!p){break aa}g=Zb(n,m);v[113382]=0;e=W(459,f|0,17,w[f+32|0])|0;b=v[113382];v[113382]=0;if((b|0)==1){break c}b=Rh(Bn(Me(e,l),0));v[113382]=0;Q(460,g|0,b|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break c}g=Zb(n,m);v[113382]=0;e=W(459,f|0,16,w[f+36|0])|0;b=v[113382];v[113382]=0;if((b|0)!=1){b=Rh(Me(e,l));v[113382]=0;Q(460,g|0,b|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){break aa}}break c}ba:{if(!(j&240)){break ba}g=Zb(n,m);v[113382]=0;e=W(459,f|0,20,j>>>4|224)|0;b=v[113382];v[113382]=0;if((b|0)!=1){b=OS(Me(e,l));v[113382]=0;Q(460,g|0,b|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){break ba}}break c}ca:{e=j&15;if(!e){break ca}b=w[c+16|0];g=Zb(n,m);b=Ed((B(b,e)>>>0)/15&255,1,15);v[113382]=0;e=W(459,f|0,20,b|96)|0;b=v[113382];v[113382]=0;if((b|0)!=1){b=OS(Me(e,l));v[113382]=0;Q(460,g|0,b|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){break ca}}break c}b=0;l=l+1|0;if((s|0)!=(l|0)){continue}break}}$d(o)}jb=f- -64|0;return m|0}a=P()|0;O()|0;$d(o);S(a|0);L()}function sU(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;o=sh(b,9784);a:{if(!o){break a}if(!Rb(b,6)){break a}while(1){b:{k=Df(b);c:{if((k|0)==(Ej(9647)|0)){break c}i=w[17528]|w[17529]<<8|(w[17530]<<16|w[17531]<<24);if(!(k&1616928864)|k&-2139062144){break c}if((i|0)!=(k|0)){break b}}mg(b,4);break a}l=1;q=og(b);if(x[a+480192>>1]){while(1){j=v[(((l&65535)<<2)+a|0)+900380>>2];if(j){d:{i=q;m=b;p=k;if((Ej(12853)|0)==(k|0)){_b(m,i);break d}e=p;c=i;d=m;g=0;h=jb-32|0;jb=h;e:{f:{g:{h:{i:{j:{k:{l:{m:{f=j;n:{if(!f){break n}o:{p:{q:{r:{s:{t:{u:{v:{w:{x:{y:{z:{A:{B:{C:{D:{E:{F:{G:{H:{I:{J:{K:{L:{M:{N:{O:{P:{Q:{R:{S:{T:{U:{V:{W:{X:{if((e|0)<=1347628589){if((e|0)<=1297100333){if((e|0)<=1179931727){if((e|0)<=1145263149){if((e|0)==1095062094){break y}if((e|0)==1095126087){break v}if((e|0)!=1129524782|c>>>0>1){break n}if(!Rb(d,c)){break n}r=f,s=fd(d,c),t[r+23|0]=s;g=1;break n}if((e|0)<=1179463213){if((e|0)==1145263150){break N}if((e|0)!=1145979182|c>>>0>1){break n}if(!Rb(d,c)){break n}r=f,s=fd(d,c),t[r+18|0]=s;g=1;break n}if((e|0)==1179463214){break B}if((e|0)!=1179594286|c>>>0>4){break n}if(!Rb(d,c)){break n}r=f,s=Cu(d,c),v[r>>2]=s;g=1;break n}if((e|0)<=1229345325){if((e|0)==1179931728){break o}if((e|0)==1196830254){break X}if((e|0)!=1229341486|c>>>0>1){break n}if(!Rb(d,c)){break n}r=f,s=fd(d,c),t[r+21|0]=s;g=1;break n}if((e|0)<=1296182829){if((e|0)==1229345326){break K}if((e|0)!=1264266798|c>>>0>256){break n}e=f+236|0;td(h+16|0,d,c);c=0;while(1){v[113382]=0;d=T(339,h+16|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break F}r=_c(e,c),s=d,u[r>>1]=s;c=c+1|0;if(c>>>0<128){continue}break}Bb(h+16|0);g=1;break n}if((e|0)==1296182830){break J}if((e|0)!=1296248366|c>>>0>1){break n}if(!Rb(d,c)){break n}r=f,s=fd(d,c),t[r+31|0]=s;g=1;break n}if((e|0)<=1346720333){if((e|0)<=1313692461){if((e|0)==1297100334){break I}if((e|0)==1297110852){break t}if((e|0)!=1298747438|c>>>0>1){break n}if(!Rb(d,c)){break n}r=f,s=fd(d,c),t[r+34|0]=s;g=1;break n}if((e|0)<=1345203757){if((e|0)==1313692462){break G}if((e|0)!=1313751342|c>>>0>1){break n}if(!Rb(d,c)){break n}r=f,s=fd(d,c),t[r+16|0]=s;g=1;break n}if((e|0)==1345203758){break W}if((e|0)!=1346711086){break n}v[h+16>>2]=240;r=h,s=On(d,c),v[r>>2]=s;Fg(f+68|0,v[Lb(h+16|0,h)>>2]);g=1;break n}if((e|0)<=1347179309){if((e|0)<=1346784326){if((e|0)==1346720334){break z}if((e|0)!=1346722606){break n}td(h+16|0,d,c);c=0;v[113382]=0;d=Q(340,f|0,1)|0;e=v[113382];v[113382]=0;if((e|0)==1){break k}if(Kb(d)){while(1){v[113382]=0;e=T(341,h+16|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break k}r=Pb(d,c),s=e,t[r+2|0]=s;c=c+1|0;if(Kb(d)>>>0>c>>>0){continue}break}}Bb(h+16|0);g=1;break n}if((e|0)==1346784327){break w}if((e|0)!=1347175726|c>>>0>1){break n}if(!Rb(d,c)){break n}r=f,s=fd(d,c),t[r+82|0]=s;g=1;break n}if((e|0)<=1347441453){if((e|0)==1347179310){break T}if((e|0)!=1347437358|c>>>0>1){break n}if(!Rb(d,c)){break n}r=f,s=fd(d,c),t[r+27|0]=s;g=1;break n}if((e|0)==1347441454){break H}if((e|0)!=1347443502){break n}td(h+16|0,d,c);c=0;v[113382]=0;d=Q(340,f|0,1)|0;e=v[113382];v[113382]=0;if((e|0)==1){break h}if(Kb(d)){while(1){v[113382]=0;e=T(339,h+16|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break h}r=Pb(d,c),s=e,u[r>>1]=s;c=c+1|0;if(Kb(d)>>>0>c>>>0){continue}break}}Bb(h+16|0);g=1;break n}if((e|0)<=1447374381){if((e|0)<=1349078084){if((e|0)<=1347831111){if((e|0)<=1347634477){if((e|0)==1347628590){break M}if((e|0)!=1347633710|c>>>0>1){break n}if(!Rb(d,c)){break n}r=f,s=fd(d,c),t[r+83|0]=s;g=1;break n}if((e|0)==1347634478){break S}if((e|0)!=1347703884){break n}r=f,s=B(Bu(d,c),1e4)+(y[f+40>>2]%1e4|0)|0,v[r+40>>2]=s;g=1;break n}if((e|0)<=1349076269){if((e|0)==1347831112){break A}if((e|0)!=1347833672|c>>>0>1){break n}if(!Rb(d,c)){break n}r=f,s=fd(d,c),t[r+36|0]=s;g=1;break n}if((e|0)==1349076270){break q}if((e|0)!=1349076315){break n}td(h+16|0,d,c);c=0;v[113382]=0;d=Q(340,f|0,2)|0;e=v[113382];v[113382]=0;if((e|0)==1){break l}if(Kb(d)){while(1){v[113382]=0;e=T(341,h+16|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break l}r=Pb(d,c),s=e,t[r+2|0]=s;c=c+1|0;if(Kb(d)>>>0>c>>>0){continue}break}}Bb(h+16|0);g=1;break n}if((e|0)<=1349079873){if((e|0)==1349078085){break Q}if((e|0)==1349078099){break R}if((e|0)!=1349079131){break n}td(h+16|0,d,c);c=0;v[113382]=0;d=Q(340,f|0,2)|0;e=v[113382];v[113382]=0;if((e|0)==1){break i}if(Kb(d)){while(1){v[113382]=0;e=T(339,h+16|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break i}r=Pb(d,c),s=e,u[r>>1]=s;c=c+1|0;if(Kb(d)>>>0>c>>>0){continue}break}}Bb(h+16|0);g=1;break n}Y:{switch(e-1349079874|0){case 1:case 2:break n;case 3:break O;case 0:break P;default:break Y}}if((e|0)==1378758190){break s}if((e|0)!=1381183022|c>>>0>1){break n}if(!Rb(d,c)){break n}r=f,s=fd(d,c),t[r+24|0]=s;g=1;break n}if((e|0)<=1448226349){if((e|0)<=1447447622){if((e|0)==1447374382){break r}if((e|0)==1447383630){break x}if((e|0)!=1447385902){break n}td(h+16|0,d,c);c=0;v[113382]=0;d=Q(340,f|0,0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break j}if(Kb(d)){while(1){v[113382]=0;e=T(341,h+16|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break j}r=Pb(d,c),s=e,t[r+2|0]=s;c=c+1|0;if(Kb(d)>>>0>c>>>0){continue}break}}Bb(h+16|0);g=1;break n}if((e|0)<=1447842605){if((e|0)==1447447623){break u}if((e|0)!=1447839022|c>>>0>1){break n}if(!Rb(d,c)){break n}r=f,s=fd(d,c),t[r+62|0]=s;g=1;break n}if((e|0)==1447842606){break V}if((e|0)!=1448106798){break n}td(h+16|0,d,c);c=0;v[113382]=0;d=Q(340,f|0,0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break g}if(Kb(d)){while(1){v[113382]=0;e=T(339,h+16|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break g}r=Pb(d,c),s=e,u[r>>1]=s;c=c+1|0;if(Kb(d)>>>0>c>>>0){continue}break}}Bb(h+16|0);g=1;break n}if((e|0)<=1448297773){if((e|0)==1448226350){break C}if((e|0)==1448291886){break L}if((e|0)!=1448297006|c>>>0>1){break n}if(!Rb(d,c)){break n}r=f,s=fd(d,c),t[r+63|0]=s;g=1;break n}if((e|0)<=1718508333){if((e|0)==1448297774){break U}if((e|0)!=1682320942|c>>>0>1){break n}if(!Rb(d,c)){break n}r=f,s=fd(d,c),t[r+15|0]=s;g=1;break n}if((e|0)==1718508334){break D}if((e|0)!=1851469358|c>>>0>32){break n}td(h+16|0,d,c);e=Xb(h);if(c){d=0;while(1){v[113382]=0;g=T(342,h+16|0)|0;n=v[113382];v[113382]=0;if((n|0)==1){break E}v[113382]=0;Q(343,e|0,g|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break E}d=d+1|0;if((c|0)!=(d|0)){continue}break}}v[113382]=0;Q(335,f+492|0,e|0)|0;c=v[113382];v[113382]=0;g=1;if((c|0)==1){break E}yb(e);Bb(h+16|0);break n}if(c>>>0>4){break n}if(!Rb(d,c)){break n}r=f,s=Cu(d,c),v[r+4>>2]=s;g=1;break n}if(c>>>0>4){break n}if(!Rb(d,c)){break n}r=f,s=Cu(d,c),v[r+8>>2]=s;g=1;break n}if(c>>>0>1){break n}if(!Rb(d,c)){break n}r=f,s=fd(d,c),t[r+61|0]=s;g=1;break n}if(c>>>0>1){break n}if(!Rb(d,c)){break n}r=f- -64|0,s=fd(d,c),t[r|0]=s;g=1;break n}if(c>>>0>1){break n}if(!Rb(d,c)){break n}r=f,s=fd(d,c),t[r+81|0]=s;g=1;break n}if(c>>>0>1){break n}if(!Rb(d,c)){break n}r=f,s=fd(d,c),t[r+84|0]=s;g=1;break n}if(c>>>0>1){break n}if(!Rb(d,c)){break n}r=f,s=fd(d,c),t[r+101|0]=s;g=1;break n}if(c>>>0>1){break n}if(!Rb(d,c)){break n}r=f,s=fd(d,c),t[r+102|0]=s;g=1;break n}if(c>>>0>1){break n}if(!Rb(d,c)){break n}r=f,s=fd(d,c),t[r+103|0]=s;g=1;break n}if(c>>>0>1){break n}if(!Rb(d,c)){break n}r=f,s=fd(d,c),t[r+104|0]=s;g=1;break n}if(c>>>0>1){break n}if(!Rb(d,c)){break n}r=f,s=fd(d,c),t[r+17|0]=s;g=1;break n}if(c>>>0>1){break n}if(!Rb(d,c)){break n}r=f,s=fd(d,c),t[r+19|0]=s;g=1;break n}if(c>>>0>1){break n}if(!Rb(d,c)){break n}r=f,s=fd(d,c),t[r+20|0]=s;g=1;break n}if(c>>>0>1){break n}if(!Rb(d,c)){break n}r=f,s=fd(d,c),t[r+22|0]=s;g=1;break n}if(c>>>0>2){break n}if(!Rb(d,c)){break n}r=f,s=WB(d,c),u[r+28>>1]=s;g=1;break n}if(c>>>0>1){break n}if(!Rb(d,c)){break n}r=f,s=fd(d,c),t[r+30|0]=s;g=1;break n}if(c>>>0>1){break n}if(!Rb(d,c)){break n}r=f,s=VB(d,c),t[r+26|0]=s;g=1;break n}if(c>>>0>128){break n}e=f+108|0;td(h+16|0,d,c);c=0;while(1){v[113382]=0;d=T(341,h+16|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break p}r=ec(e,c),s=d,t[r|0]=s;c=c+1|0;if(c>>>0<128){continue}break}Bb(h+16|0);g=1;break n}c=P()|0;O()|0;break f}c=P()|0;O()|0;yb(e);break f}if(c>>>0>32){break n}td(h+16|0,d,c);e=Xb(h);if(c){d=0;while(1){v[113382]=0;g=T(342,h+16|0)|0;n=v[113382];v[113382]=0;if((n|0)==1){break m}v[113382]=0;Q(343,e|0,g|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break m}d=d+1|0;if((c|0)!=(d|0)){continue}break}}v[113382]=0;Q(335,f+524|0,e|0)|0;c=v[113382];v[113382]=0;g=1;if((c|0)!=1){yb(e);Bb(h+16|0);break n}break m}if(c>>>0>2){break n}if(!Rb(d,c)){break n}r=f,s=WB(d,c),u[r+12>>1]=s;g=1;break n}if(c>>>0>1){break n}if(!Rb(d,c)){break n}r=f,s=fd(d,c),t[r+25|0]=s;g=1;break n}if(c>>>0>1){break n}if(!Rb(d,c)){break n}r=f,s=fd(d,c),t[r+35|0]=s;g=1;break n}if(c>>>0>1){break n}if(!Rb(d,c)){break n}r=f,s=fd(d,c),t[r+105|0]=s;g=1;break n}if(c>>>0>1){break n}if(!Rb(d,c)){break n}r=f,s=fd(d,c),t[r+85|0]=s;g=1;break n}if(c>>>0>1){break n}if(!Rb(d,c)){break n}r=f,s=fd(d,c),t[r+65|0]=s;g=1;break n}if(c>>>0>1){break n}if(!Rb(d,c)){break n}r=f,s=fd(d,c),t[r+100|0]=s;g=1;break n}if(c>>>0>1){break n}if(!Rb(d,c)){break n}r=f,s=fd(d,c),t[r+80|0]=s;g=1;break n}if(c>>>0>1){break n}if(!Rb(d,c)){break n}r=f,s=fd(d,c),t[r+60|0]=s;g=1;break n}if(c>>>0>1){break n}if(!Rb(d,c)){break n}r=f,s=VB(d,c),t[r+33|0]=s;g=1;break n}g=1;c=On(d,c);if(!Nn(c)){break n}t[f+14|0]=c;break n}v[h+16>>2]=240;r=h,s=On(d,c),v[r>>2]=s;Fg(f+48|0,v[Lb(h+16|0,h)>>2]);g=1;break n}v[h+16>>2]=240;r=h,s=On(d,c),v[r>>2]=s;Fg(f+88|0,v[Lb(h+16|0,h)>>2]);g=1;break n}c=P()|0;O()|0;break f}c=Bu(d,c);d=v[f+40>>2];v[f+40>>2]=d-((d>>>0)%1e4|0)+(c>>>0)%1e4;g=1}jb=h+32|0;break e}c=P()|0;O()|0;yb(e);break f}c=P()|0;O()|0;break f}c=P()|0;O()|0;break f}c=P()|0;O()|0;break f}c=P()|0;O()|0;break f}c=P()|0;O()|0;break f}c=P()|0;O()|0}Bb(h+16|0);S(c|0);L()}if(!g){_b(m,i);break d}if((Ej(12858)|0)==(p|0)){i=w[j+15|0];t[j+15|0]=0;t[j+100|0]=w[j+100|0]&224|(i>>>5&4|i>>>6&1);t[j+60|0]=i>>>1&2|(i<<1&4|(w[j+60|0]&240|i&1));t[j+80|0]=w[j+80|0]&240|(i>>>4&2|(i>>>2&4|i>>>3&1))}}}l=l+1|0;if(x[a+480192>>1]>=(l&65535)>>>0){continue}break}}if(Rb(b,6)){continue}break}}return o|0}function faa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=jb-736|0;jb=d;Ic(b);a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{v:{w:{x:{y:{z:{A:{if(!Hf(b,d+728|0)){break A}if(!xK(d+728|0)){break A}if(!Gt(b,d+720|0)){break A}if(!wK(d+720|0)){break A}i=1313423693;h=w[d+720|0]|w[d+721|0]<<8|(w[d+722|0]<<16|w[d+723|0]<<24);if((h|0)!=1179012417){i=1414090313;if((h|0)!=538987841){break A}}l=Nk(d+704|0,b);j=Fx(d+688|0);B:{C:{D:{E:{F:{G:{H:{I:{J:{if(!c){v[113382]=0;X(1503,d+128|0,l|0,((h|0)==1179012417?1:2)|0,i|0);b=v[113382];v[113382]=0;if((b|0)!=1){break J}a=P()|0;O()|0;break a}v[113382]=0;U(1504,d+128|0,l|0,((h|0)==1179012417?1:2)|0);b=v[113382];v[113382]=0;if((b|0)==1){break I}}b=j;if(v[b>>2]){Cd(b);tK(b);xp(b);Ff(zb(b),v[b>>2],Ye(b));m=zb(b),n=0,v[m>>2]=n;v[b>>2]=0;v[b+4>>2]=0}b=d+128|0;Fl(j,b);v[j>>2]=v[b>>2];v[j+4>>2]=v[b+4>>2];g=v[zb(b)>>2];m=zb(j),n=g,v[m>>2]=n;m=zb(b),n=0,v[m>>2]=n;v[b>>2]=0;v[b+4>>2]=0;tl(b);v[113382]=0;U(1505,d+672|0,j|0,i|0);b=v[113382];v[113382]=0;if((b|0)!=1){v[113382]=0;b=T(303,d+672|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break D}g=0;if(!b){break B}v[113382]=0;b=Q(1506,d+672|0,d+592|0)|0;i=v[113382];v[113382]=0;if((i|0)==1){break D}if(!b|!w[d+657|0]){break B}b=w[d+657|0];v[113382]=0;g=Q(228,d+672|0,b|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break D}if(!g|!c){break B}v[113382]=0;R(403,a|0,8388608);b=v[113382];v[113382]=0;if((b|0)==1){break D}v[a+480208>>2]=12;v[a+480208>>2]=v[a+480208>>2]&-17|(w[d+656|0]<<4^-1)&16;b=w[d+657|0];v[113382]=0;u[d+128>>1]=b;u[d+496>>1]=127;b=Q(438,d+128|0,d+496|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break H}u[a+480188>>1]=x[b>>1];v[a+480196>>2]=w[d+658|0];v[a+480204>>2]=B(w[d+659|0],1e4);v[a+480200>>2]=w[d+664|0]<<1;v[113382]=0;Q(208,a+1304436|0,((h|0)==1179012417?13002:12968)|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break D}v[113382]=0;b=Q(2,d+128|0,9272)|0;g=v[113382];v[113382]=0;if((g|0)==1){break F}Gb(a+1304448|0,b);yb(b);v[a+1304496>>2]=4;v[113382]=0;U(1507,d+496|0,2,d+592|0);b=v[113382];v[113382]=0;if((b|0)==1){break G}v[113382]=0;R(356,d+128|0,d+496|0);b=v[113382];v[113382]=0;if((b|0)==1){break G}b=d+128|0;Gb(a+1304400|0,b);yb(b);if(!x[a+480188>>1]){break E}b=0;f=(h|0)==1179012417;while(1){v[113382]=0;i=(b<<5)+a|0;e=i+480280|0;Z(387,e|0);g=v[113382];v[113382]=0;K:{L:{M:{N:{O:{if((g|0)!=1){v[113382]=0;g=T(409,d+672|0)|0;k=v[113382];v[113382]=0;if((k|0)==1){break O}if(f){break N}if(g>>>0<129){break M}break L}a=P()|0;O()|0;break b}a=P()|0;O()|0;break b}if(g<<24>>24<0){break L}v[113382]=0;v[d+128>>2]=g<<2;v[d+496>>2]=256;g=Q(420,d+128|0,d+496|0)|0;e=v[113382];v[113382]=0;if((e|0)!=1){u[i+480284>>1]=v[g>>2];break K}a=P()|0;O()|0;break b}u[i+480284>>1]=g<<1;break K}v[e>>2]=1024}b=b+1|0;if(b>>>0<x[a+480188>>1]){continue}break}break E}a=P()|0;O()|0;break a}a=P()|0;O()|0;break a}a=P()|0;O()|0;break b}a=P()|0;O()|0;break b}a=P()|0;O()|0;break b}v[113382]=0;b=Q(1508,j|0,1380209231)|0;g=v[113382];v[113382]=0;if((g|0)!=1){break C}}a=P()|0;O()|0;break b}if(b){v[113382]=0;U(1505,d+128|0,j|0,1380209231);b=v[113382];v[113382]=0;if((b|0)==1){break c}v[113382]=0;b=T(409,d+128|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break d}g=Vb(a+484360|0);v[113382]=0;ea(544,g|0,d+128|0,b+1&255,255,254)|0;b=v[113382];v[113382]=0;if((b|0)==1){break d}Bb(d+128|0)}if(c&1){v[113382]=0;u[d+56>>1]=0;U(1509,d+496|0,j|0,1414807888);b=v[113382];v[113382]=0;if((b|0)==1){break e}b=jd(d+496|0);v[113382]=0;g=a+484344|0;R(363,g|0,b&65535);b=v[113382];v[113382]=0;if((b|0)==1){break h}b=d+496|0;m=d,n=ac(b),v[m+560>>2]=n;m=d,n=bc(b),v[m+80>>2]=n;if(Jb(d+560|0,d+80|0)){i=(h|0)!=1179012417;while(1){b=af(d+128|0,v[d+560>>2]);v[113382]=0;f=T(409,b|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break g}v[113382]=0;u[d+480>>1]=f;f=T(397,b|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break g}v[113382]=0;U(307,d+576|0,b|0,f|0);f=v[113382];v[113382]=0;if((f|0)==1){break g}v[113382]=0;f=v[d+588>>2];v[d+16>>2]=v[d+584>>2];v[d+20>>2]=f;f=v[d+580>>2];v[d+8>>2]=v[d+576>>2];v[d+12>>2]=f;X(1510,d+8|0,x[d+480>>1],i|0,a|0);f=v[113382];v[113382]=0;if((f|0)==1){break g}v[113382]=0;f=Q(408,d+56|0,d+480|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break g}u[d+56>>1]=x[f>>1];Bb(b);b=d+560|0;Xf(b);if(Jb(b,d+80|0)){continue}break}}if(x[d+56>>1]){b=0;while(1){v[113382]=0;i=b&65535;f=Q(398,g|0,i|0)|0;e=v[113382];v[113382]=0;P:{if((e|0)!=1){if(f){break P}v[113382]=0;W(364,g|0,i|0,64)|0;i=v[113382];v[113382]=0;if((i|0)!=1){break P}}a=P()|0;O()|0;break f}b=b+1|0;if(x[d+56>>1]>(b&65535)>>>0){continue}break}}cd(d+496|0)}Q:{if((h|0)==1179012417){v[113382]=0;U(1509,d+80|0,j|0,1414745673);b=v[113382];v[113382]=0;if((b|0)==1){break y}b=d+80|0;m=d,n=ac(b),v[m+112>>2]=n;m=d,n=bc(b),v[m+40>>2]=n;R:{if(Jb(d+112|0,d+40|0)){g=c&2;i=d+504|0;f=d+128|1;while(1){c=af(d+560|0,v[d+112>>2]);v[113382]=0;b=Q(1511,c|0,d+128|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break R}S:{if(!b){break S}b=w[f|0];if((b|0)==255){break S}v[113382]=0;b=W(411,a|0,b+1|0,0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break x}if(!b){break S}h=x[a+480190>>1];v[113382]=0;U(1512,d+128|0,b|0,h|0);b=v[113382];v[113382]=0;if((b|0)==1){break x}b=0;if(!w[d+158|0]){break S}while(1){T:{if(!An(a)){break T}v[113382]=0;h=Q(1513,c|0,d+496|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break w}if(!h){break T}h=x[a+480190>>1]+1|0;u[a+480190>>1]=h;if((w[d+496|0]|w[d+497|0]<<8|(w[d+498|0]<<16|w[d+499|0]<<24))!=1347240275){break T}v[113382]=0;U(540,d+480|0,2,i|0);e=v[113382];v[113382]=0;U:{V:{W:{if((e|0)==1){break W}v[113382]=0;R(356,d+56|0,d+480|0);e=v[113382];v[113382]=0;if((e|0)==1){break W}v[113382]=0;h=h&65535;Q(335,((h<<5)+a|0)+946304|0,d+56|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break V}yb(d+56|0);v[113382]=0;h=(B(h,104)+a|0)+484380|0;U(1514,d+496|0,d+128|0,h|0);e=v[113382];v[113382]=0;if((e|0)==1){break j}if(!g){break U}v[113382]=0;R(1515,d+56|0,d+496|0);e=v[113382];v[113382]=0;if((e|0)!=1){v[113382]=0;W(362,d+56|0,h|0,c|0)|0;h=v[113382];v[113382]=0;if((h|0)!=1){break T}}a=P()|0;O()|0;break i}a=P()|0;O()|0;break i}a=P()|0;O()|0;yb(d+56|0);break i}h=zj(h);v[113382]=0;Q(304,c|0,h|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break j}}b=b+1|0;if(b>>>0<w[d+158|0]){continue}break}}Bb(c);b=d+112|0;Xf(b);if(Jb(b,d+40|0)){continue}break}}cd(d+80|0);break Q}a=P()|0;O()|0;break i}v[113382]=0;U(1509,d+480|0,j|0,1179011410);b=v[113382];v[113382]=0;if((b|0)==1){break v}b=d+480|0;m=d,n=ac(b),v[m+472>>2]=n;m=d,n=bc(b),v[m+464>>2]=n;if(Jb(d+472|0,d+464|0)){h=c&2;g=d+496|4;c=d+72|4;i=d+128|5;while(1){b=d+560|0;f=Nk(b,v[d+472>>2]);v[113382]=0;b=T(397,b|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break u}X:{if((b|0)!=538986817){break X}v[113382]=0;b=Q(1516,d+560|0,d+456|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break t}if(!b|(w[d+456|0]|w[d+457|0]<<8|(w[d+458|0]<<16|w[d+459|0]<<24))!=1414745673){break X}v[113382]=0;b=Q(1517,d+560|0,d+128|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break s}if(!b){break X}b=w[i|0];if((b|0)==255){break X}v[113382]=0;b=W(411,a|0,b+1|0,0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break r}if(!b){break X}e=x[a+480190>>1];v[113382]=0;U(1518,d+128|0,b|0,e|0);b=v[113382];v[113382]=0;if((b|0)==1){break r}v[113382]=0;U(1504,d+496|0,f|0,2);b=v[113382];v[113382]=0;if((b|0)==1){break z}v[113382]=0;U(1509,d+112|0,d+496|0,1179011410);b=v[113382];v[113382]=0;if((b|0)==1){break q}tl(d+496|0);b=d+112|0;m=d,n=ac(b),v[m+104>>2]=n;m=d,n=bc(b),v[m+96>>2]=n;Y:{if(!Jb(d+104|0,d+96|0)){break Y}Z:{while(1){b=af(d+80|0,v[d+104>>2]);v[113382]=0;f=T(397,b|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break p}_:{$:{if((f|0)!=538989377){break $}if(!An(a)){break $}f=w[d+452|0]|w[d+453|0]<<8;e=f-1|0;t[d+452|0]=e;t[d+453|0]=e>>>8;if(!f){Bb(b);break Y}f=x[a+480190>>1]+1|0;u[a+480190>>1]=f;v[113382]=0;e=Q(1516,b|0,d+72|0)|0;k=v[113382];v[113382]=0;if((k|0)==1){break o}if(!e|(w[d+72|0]|w[d+73|0]<<8|(w[d+74|0]<<16|w[d+75|0]<<24))!=1347240275){break Z}e=w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24);v[113382]=0;U(307,d+56|0,b|0,e|0);e=v[113382];v[113382]=0;aa:{ba:{if((e|0)!=1){v[113382]=0;e=Q(1519,d+56|0,d+496|0)|0;k=v[113382];v[113382]=0;if((k|0)==1){break _}if(!e){break aa}v[113382]=0;U(355,d+24|0,2,g|0);e=v[113382];v[113382]=0;if((e|0)!=1){v[113382]=0;R(356,d+40|0,d+24|0);e=v[113382];v[113382]=0;if((e|0)!=1){break ba}}a=P()|0;O()|0;break m}a=P()|0;O()|0;break l}v[113382]=0;f=f&65535;Q(335,((f<<5)+a|0)+946304|0,d+40|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break n}yb(d+40|0);v[113382]=0;f=(B(f,104)+a|0)+484380|0;U(1520,d+496|0,d+128|0,f|0);e=v[113382];v[113382]=0;if((e|0)==1){break _}ca:{if(!h){break ca}e=w[d+496|0]|w[d+497|0]<<8|(w[d+498|0]<<16|w[d+499|0]<<24);v[113382]=0;Q(226,d+56|0,e+4|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break _}v[113382]=0;R(1521,d+40|0,d+496|0);e=v[113382];v[113382]=0;if((e|0)!=1){v[113382]=0;W(362,d+40|0,f|0,d+56|0)|0;f=v[113382];v[113382]=0;if((f|0)!=1){break ca}}a=P()|0;O()|0;break m}Bb(d+56|0);break $}Bb(d+56|0);Bb(b);break Y}Bb(b);b=d+104|0;Xf(b);if(Jb(b,d+96|0)){continue}break Y}break}a=P()|0;O()|0;break m}Bb(b)}cd(d+112|0)}Bb(d+560|0);b=d+472|0;Xf(b);if(Jb(b,d+464|0)){continue}break}}cd(d+480|0)}g=1}Bb(d+672|0);tl(j);Bb(l)}jb=d+736|0;return g|0}a=P()|0;O()|0;break k}a=P()|0;O()|0;break b}a=P()|0;O()|0;break i}a=P()|0;O()|0;break i}a=P()|0;O()|0;break b}a=P()|0;O()|0;break k}a=P()|0;O()|0;break k}a=P()|0;O()|0;break k}a=P()|0;O()|0;break k}a=P()|0;O()|0;tl(d+496|0);break k}a=P()|0;O()|0;break l}a=P()|0;O()|0;break l}a=P()|0;O()|0;yb(d+40|0)}Bb(d+56|0)}Bb(b);cd(d+112|0)}Bb(d+560|0);cd(d+480|0);break b}a=P()|0;O()|0}Bb(c);cd(d+80|0);break b}a=P()|0;O()|0;break f}a=P()|0;O()|0;Bb(b)}cd(d+496|0);break b}a=P()|0;O()|0;break b}a=P()|0;O()|0;Bb(d+128|0);break b}a=P()|0;O()|0}Bb(d+672|0)}tl(j);Bb(l);S(a|0);L()}function laa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,z=0,A=0,C=0,D=0,E=0,F=0,G=0;h=jb-48|0;jb=h;f=a+1074308|0;if(!(v[f>>2]==18284544|y[a+1074308>>2]>=18285126)){ig(a+1074312|0,0)}b=h+32|0;i=a+1074312|0;Fb(b,i,0);if(Cb(b)){q=(v[a+480180>>2]&16777248)!=0}b=h+32|0;Fb(b,i,0);if(Cb(b)){E=v[a+480180>>2]==4}if(y[f>>2]<18874368){a:{if(!x[a+480192>>1]){break a}c=1;while(1){b:{b=v[(((c&65535)<<2)+a|0)+900380>>2];if(!b){break b}v[h+32>>2]=B(w[b+20|0],100)>>>6;v[h+16>>2]=100;F=b,G=v[Lb(h+32|0,h+16|0)>>2],t[F+20|0]=G;c:{d:{if(q){if(y[f>>2]<18350080){e=t[b+26|0];t[b+26|0]=((e>>31|1)+e|0)/2}if(y[f>>2]<18285314){break d}break c}e=t[b+26|0];t[b+26|0]=((e>>31|1)+e|0)/2}Ry(XB(b,2),4,v[a+480180>>2])}e:{if(!w[b+34|0]|(y[f>>2]<18284544|y[f>>2]>=18285136)){break e}if(!zi(b)){break e}Nb(i,2,1)}if(!(w[b+24|0]|(w[b+23|0]|(w[b+19|0]|w[b+20|0])))|y[f>>2]>=18285136){break b}Nb(i,1,1);break a}c=c+1|0;if(x[a+480192>>1]>=(c&65535)>>>0){continue}break}}f:{if(!(v[a+480180>>2]&16777248)){break f}b=1;if(!x[a+480190>>1]|y[f>>2]>=18285314&q){break f}while(1){c=B(b&65535,104)+a|0;e=c+484419|0;if(!(w[e|0]|!(w[c+484421|0]|w[c+484420|0]))){t[e|0]=255}b=b+1|0;if(x[a+480190>>1]>=(b&65535)>>>0){continue}break}}b=a+901404|0;c=b;g=jO(b);if((g|0)!=(b|0)){while(1){b=c;d=b+32|0;while(1){e=w[b|0];g:{h:{if((e-97&255)>>>0<=5){l=e-32|0;break h}l=99;i:{if(e>>>0<=106){if(e-88>>>0<2){break i}if((e|0)==75){break h}break g}if(e-120>>>0<2){break i}if((e|0)==107){break h}break g}l=122}t[b|0]=l}b=b+1|0;if((d|0)!=(b|0)){continue}break}c=c+32|0;if((g|0)!=(c|0)){continue}break}}}j:{if(v[f>>2]==18874368|y[f>>2]>=18874896|(!(v[a+480180>>2]&16777252)|!x[a+480192>>1])){break j}b=1;c=0;while(1){k:{e=v[(((b&65535)<<2)+a|0)+900380>>2];if(!(w[e+31|0]?e:0)){b=b+1|0;if(x[a+480192>>1]>=(b&65535)>>>0){continue}if(c){break k}break j}t[e+33|0]=13;c=1;b=b+1|0;if(x[a+480192>>1]>=(b&65535)>>>0){continue}}break}Nb(i,3,1)}l:{if(!(v[a+480180>>2]&16777248)|(v[f>>2]==19005440|y[f>>2]>=19006226)){break l}b=h+32|0;Fb(b,i,0);if(!Cb(b)){b=h+16|0;Fb(b,i,1);if(!Cb(b)){break l}}if(!x[a+480192>>1]){break l}b=1;while(1){c=v[(((b&65535)<<2)+a|0)+900380>>2];if(!(!c|!w[c+19|0]|!(t[c+80|0]&1))){t[c+19|0]=0}b=b+1|0;if(x[a+480192>>1]>=(b&65535)>>>0){continue}break}}m:{n:{o:{if(y[f>>2]<19007233){e=a+946300|0;b=a+906300|0;while(1){c=jb-16|0;jb=c;l=b+80|0;Zt(c,1,l);g=h+16|0;Ec(g,c);jb=c+16|0;v[113382]=0;X(393,h+32|0,0,7,g|0);c=v[113382];v[113382]=0;if((c|0)==1){break n}yb(h+16|0);v[113382]=0;Q(468,l|0,h+32|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break o}yb(h+32|0);b=b+160|0;if((e|0)!=(b|0)){continue}break}}if(!(v[a+480180>>2]!=4|y[f>>2]<19007257|(v[a+1074372>>2]!=4|y[f>>2]>=19071236))){by(a,5)}if(!(!x[a+480192>>1]|(v[f>>2]==19202048|y[f>>2]>=19202055))){c=1;while(1){l=(((c&65535)<<2)+a|0)+900380|0;b=v[l>>2];p:{if(!b|!w[b+20|0]|!w[b+31|0]){break p}b=b+236|0;e=bt(b);if((b|0)!=(e|0)){while(1){if(x[b>>1]){break p}b=b+2|0;if((e|0)!=(b|0)){continue}break}}t[v[l>>2]+20|0]=0}c=c+1|0;if(x[a+480192>>1]>=(c&65535)>>>0){continue}break}}if(!(!x[a+480192>>1]|y[f>>2]>=19267584)){c=1;while(1){b=v[(((c&65535)<<2)+a|0)+900380>>2];q:{if(!b){break q}e=t[b+26|0];t[b+26|0]=((e>>31|1)+e|0)/2;if(y[f>>2]>=18350080&q){break q}t[b+19|0]=w[b+19|0]+3>>>2}c=c+1|0;if(x[a+480192>>1]>=(c&65535)>>>0){continue}break}}r:{if(!x[a+480192>>1]|y[f>>2]>=19398674){break r}b=1;while(1){c=v[(((b&65535)<<2)+a|0)+900380>>2];if(!(!c|w[c+65|0]==255)){Nb(i,94,1);break r}b=b+1|0;if(x[a+480192>>1]>=(b&65535)>>>0){continue}break}}s:{if(!x[a+480192>>1]|y[f>>2]>=19399428){break s}b=1;while(1){c=v[(((b&65535)<<2)+a|0)+900380>>2];if(!(!c|w[c+36|0]>1)){Nb(i,101,1);break s}b=b+1|0;if(x[a+480192>>1]>=(b&65535)>>>0){continue}break}}b=jb-16|0;jb=b;u[h+12>>1]=0;v[h+8>>2]=a;c=b+8|0;Fb(c,a+1074312|0,0);F=h,G=Cb(c),t[F+14|0]=G;jb=b+16|0;b=v[h+12>>2];v[h>>2]=v[h+8>>2];v[h+4>>2]=b;c=jb-16|0;jb=c;n=a+484344|0;l=Ae(n);b=v[h+4>>2];e=v[h>>2];v[c>>2]=e;v[c+4>>2]=b;v[c+8>>2]=e;v[c+12>>2]=b;b=c;e=jb-32|0;jb=e;D=l-1&65535;t:{if(Ae(n)>>>0>D>>>0){r=v[b>>2];s=v[b+4>>2];while(1){b=z&65535;if(qh(Fe(n,b))){g=ac(Fe(n,b));d=bc(Fe(n,b));b=e;v[b+24>>2]=r;v[b+28>>2]=s;v[b+8>>2]=r;v[b+12>>2]=s;l=b+8|0;m=jb-16|0;jb=m;v[m>>2]=d;v[m+8>>2]=g;if(Jb(m+8|0,m)){while(1){A=m+8|0;d=v[A>>2];C=jb-16|0;jb=C;b=l;o=x[b+4>>1];g=o+1|0;u[b+4>>1]=g;if(x[v[b>>2]+480188>>1]<=(g&65535)>>>0){u[b+4>>1]=0}u:{if(bn(d)){break u}g=v[b>>2];j=v[g+1074308>>2];p=v[g+480180>>2];v:{if((p|0)==2){if(w[d+3|0]!=23|j>>>0>=18415616){break v}We(d+5|0,64);break v}if(p&16777248){w:{if(w[b+6|0]|j>>>0>=18874368?j>>>0>=18285314:0){break w}x:{switch(w[d+3|0]-20|0){case 3:We(d+5|0,128);break w;case 0:break x;default:break w}}g=w[d+5|0];if((g|0)!=208){if((g|0)!=192){break w}t[d|0]=254;t[d+3|0]=0;break w}t[d+3|0]=0}y:{if(j>>>0>=18350080){g=0;if(w[b+6|0]|j>>>0>=18874368){break y}}k=w[d+3|0]-6&255;g=0;if(k>>>0>23){break y}g=8388643>>>k&1}if(j>>>0<18874368){k=w[d+3|0];k=(k|0)==24|(k|0)==22}else{k=0}z:{if(!(k|g)){break z}k=w[d+5|0];g=k&15;if(!g|(g|0)==15){break z}k=k&240;if(!k|(k|0)==240){break z}t[d+5|0]=w[d+3|0]==24?k:g}if(!(!x[v[b>>2]+480192>>1]|((j|0)==19005440|j>>>0>=19005700)|(w[b+6|0]|x[v[b>>2]+480192>>1]>=w[d+1|0]))){t[d+4|0]=0;t[d+2|0]=1}if(w[d+5|0]!=17|j>>>0>=19468802|w[d+3|0]!=18){break v}g=C+8|0;Fb(g,v[b>>2]+1074312|0,22);if(!Cb(g)|v[v[b>>2]+480208>>2]&4){break v}t[d+5|0]=0;break v}if((p|0)!=4){break v}A:{if(!(w[b+6|0]?j>>>0>=18285314:0)&j>>>0<18874368|(w[d+3|0]!=23|j>>>0>=19137026)){break A}if(w[d+5|0]<65){break A}t[d+3|0]=0}if(!(w[d+3|0]!=10|(w[b+6|0]|j>>>0>=18874368?j>>>0>=18415616:0)|w[d+2|0]!=11)){t[d+3|0]=0}B:{if(w[d+2|0]!=11|j>>>0>=18874640|w[d+3|0]!=4){break B}g=w[d+4|0];if(!(g|w[b+6|0])){break B}k=w[d+5|0];if(!k){break B}t[d+2|0]=0;F=d,G=PQ(k+(g<<4)|0),t[F+5|0]=G}if(w[d+5|0]|(w[d+3|0]!=16|j>>>0>=19007241)){break v}t[d+3|0]=0}C:{if(j>>>0>=18874368){break C}g=w[d+3|0];k=w[d+5|0]&240;D:{E:{if((g|0)!=28|(k|0)!=96){b=0}else{if(!w[b+6|0]|(p|0)!=4){break E}b=j>>>0<18350080}if(!(b|(g|0)==20&(k|0)==96)){break D}}if(!o){break D}b=d+B(o,-6)|0;while(1){if(!((w[b+3|0]|8)!=28|(w[b+5|0]&240)!=96)){t[b+3|0]=0}b=b+6|0;if(d>>>0>b>>>0){continue}break}}if(!o|(w[d+5|0]&240)!=224|w[d+3|0]!=20){break C}b=d+B(o,-6)|0;while(1){if(!(w[b+3|0]!=20|(w[b+5|0]&240)!=224)){t[b+3|0]=0}b=b+6|0;if(d>>>0>b>>>0){continue}break}}F:{if(w[d+2|0]!=8|j>>>0>=19333175|(j|0)==19333120){break F}g=w[d+4|0];b=w[d+3|0];if(!(!g|(b|0)!=7)){t[d+3|0]=11;break F}G:{H:{switch(b-5|0){default:if((b|0)!=26){break F}break;case 1:break F;case 2:break G;case 0:break H}}j=w[d+5|0];if(!(j&15)){t[d+2|0]=0;t[d+3|0]=5;t[d+5|0]=j|g&15;break F}I:{switch(b-5|0){case 1:break F;case 0:case 2:break G;default:break I}}if((b|0)!=26){break F}}t[d+2|0]=0}if(w[d+3|0]|((p|0)==16777216|w[d+2|0]!=15)){break u}t[d+2|0]=0;t[d+3|0]=10;t[d+5|0]=w[d+4|0]<<3}jb=C+16|0;Bj(A);if(Jb(A,m)){continue}break}}b=v[l+4>>2];v[e+16>>2]=v[l>>2];v[e+20>>2]=b;jb=m+16|0}z=z+1|0;if((z&65535)>>>0<=D>>>0){continue}break}v[h+32>>2]=r;v[h+36>>2]=s;break t}l=v[b+4>>2];v[h+32>>2]=v[b>>2];v[h+36>>2]=l}jb=e+32|0;jb=c+16|0;J:{K:{if(!q){break K}b=v[f>>2];if(b>>>0>=19267584){break K}Nb(i,8,(b|0)==18284544|b>>>0>18285313);b=35192;while(1){c=v[f>>2];e=v[b+4>>2];Nb(i,v[b>>2],c>>>0>=e>>>0|(c|0)==(e&-65536));b=b+8|0;if((b|0)!=35528){continue}break}break J}if(!E){break J}b=v[f>>2];if(b>>>0>=19267584){break J}Nb(i,8,b>>>0>18285313);b=35544;while(1){Nb(i,v[b>>2],y[f>>2]>=y[b+4>>2]);b=b+8|0;if((b|0)!=35776){continue}break}}L:{if(v[a+480180>>2]&16777248){b=35776;while(1){c=v[f>>2];e=v[b+4>>2];l=e&-65536;if(!(c>>>0>=l>>>0&(c>>>0<=l>>>0|c>>>0>=e>>>0))){ig(i,v[b>>2])}b=b+8|0;if((b|0)!=35824){continue}break}break L}if(v[a+480180>>2]==4){b=35824;while(1){if(y[f>>2]<y[b+4>>2]){ig(i,v[b>>2])}b=b+8|0;if((b|0)!=35880){continue}break}break L}if(v[a+480180>>2]!=2){break L}b=35888;while(1){if(y[f>>2]<y[b+4>>2]){ig(i,v[b>>2])}b=b+8|0;if((b|0)!=35968){continue}break}}if(!(v[a+480180>>2]!=4|y[f>>2]>=18415616)){Nb(i,98,1)}if(!(y[f>>2]<19333159|y[f>>2]>=19333193)){b=0;while(1){c=h+32|0;e=b+77|0;Fb(c,i,e);Nb(i,b+86|0,Cb(c));ig(i,e);b=b+1|0;if((b|0)!=5){continue}break}}c=8;M:{if(y[f>>2]>=18284544){if(y[f>>2]<18284544|y[f>>2]>18874627){break M}c=6;if(v[f>>2]==18874368){break M}}Nb(i,c,1)}N:{if(y[f>>2]<19136512){ig(i,7);break N}if(!(v[a+480180>>2]&16777248)|(y[f>>2]<19136512|y[f>>2]>=19267584)){break N}Nb(i,7,1)}b=h+32|0;Fb(b,i,31);O:{if(!Cb(b)|y[f>>2]<19071234|(!x[a+480192>>1]|y[f>>2]>=19398723)){break O}b=1;while(1){P:{c=v[(((b&65535)<<2)+a|0)+900380>>2];if(!c){break P}e=w[c+65|0];if(!(w[c+60|0]&4)|(e|0)==255|e>>>0<=w[c- -64|0]){break P}Nb(i,97,1);break O}b=b+1|0;if(x[a+480192>>1]>=(b&65535)>>>0){continue}break}}Q:{if(!(v[a+480180>>2]&16777218)|!x[a+480190>>1]){break Q}b=1;while(1){if(!(w[(B(b&65535,104)+a|0)+484415|0]&2)){b=b+1|0;if(x[a+480190>>1]>=(b&65535)>>>0){continue}break Q}break}if(!(!x[a+480192>>1]|v[a+480180>>2]!=16777216|(y[f>>2]<19398688|y[f>>2]>19464277))){Nb(i,109,1)}if(!(v[a+480180>>2]!=2|y[f>>2]>=19464192)){Nb(i,108,1);break Q}if(v[a+480180>>2]==2){break Q}ig(i,108)}jb=h+48|0;return}a=P()|0;O()|0;yb(h+32|0);break m}a=P()|0;O()|0;yb(h+16|0)}S(a|0);L()}function RF(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,x=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=C(0),L=0;d=jb-144|0;jb=d;x=Qb(d,0,144);v[x+76>>2]=-1;v[x+44>>2]=a;v[x+32>>2]=2305;v[x+84>>2]=a;D=c;c=0;k=jb-304|0;jb=k;f=x;e=b;a=w[b|0];a:{if(!a){break a}b:{c:{d:{e:{while(1){f:{g:{if(jl(a&255)){while(1){a=e;e=e+1|0;if(jl(w[a+1|0])){continue}break}Ch(f,0,0);while(1){b=v[f+4>>2];h:{if(b>>>0<y[f+104>>2]){v[f+4>>2]=b+1;b=w[b|0];break h}b=Xc(f)}if(jl(b)){continue}break}e=v[f+4>>2];if(v[f+104>>2]){e=e-1|0;v[f+4>>2]=e}b=e-v[f+8>>2]|0;h=b>>31;e=b;l=m+v[f+124>>2]|0;b=q+v[f+120>>2]|0;l=b>>>0<q>>>0?l+1|0:l;d=b;b=e+b|0;h=h+l|0;q=b;m=b>>>0<d>>>0?h+1|0:h;break g}i:{j:{k:{b=w[e|0];if((b|0)==37){a=w[e+1|0];if((a|0)==42){break k}if((a|0)!=37){break j}}Ch(f,0,0);a=((b|0)==37)+e|0;b=v[f+4>>2];l:{if(b>>>0<y[f+104>>2]){v[f+4>>2]=b+1;b=w[b|0];break l}b=Xc(f)}if((b|0)!=w[a|0]){if(v[f+104>>2]){v[f+4>>2]=v[f+4>>2]-1}if((b|0)>=0){break a}s=0;if(E){break a}break c}b=q+1|0;m=b?m:m+1|0;q=b;break g}n=0;a=e+2|0;break i}if(!(!eh(a)|w[e+2|0]!=36)){a=w[e+1|0]-48|0;b=jb-16|0;v[b+12>>2]=D;a=(a>>>0>1?(a<<2)-4|0:0)+D|0;v[b+8>>2]=a+4;n=v[a>>2];a=e+3|0;break i}n=v[D>>2];D=D+4|0;a=e+1|0}s=0;e=0;if(eh(w[a|0])){while(1){e=(w[a|0]+B(e,10)|0)-48|0;b=w[a+1|0];a=a+1|0;if(eh(b)){continue}break}}d=w[a|0];if((d|0)==109){c=0;s=(n|0)!=0;d=w[a+1|0];o=0;a=a+1|0}b=a;a=b+1|0;i=3;m:{n:{switch(d-65|0){case 39:d=b+2|0;b=w[b+1|0]==104;a=b?d:a;i=b?-2:-1;break m;case 43:d=b+2|0;b=w[b+1|0]==108;a=b?d:a;i=b?3:1;break m;case 51:case 57:i=1;break m;case 11:i=2;break m;case 41:break m;case 0:case 2:case 4:case 5:case 6:case 18:case 23:case 26:case 32:case 34:case 35:case 36:case 37:case 38:case 40:case 45:case 46:case 47:case 50:case 52:case 55:break n;default:break d}}i=0;a=b}b=w[a|0];d=(b&47)==3;F=d?1:i;r=d?b|32:b;o:{if((r|0)==91){break o}p:{if((r|0)!=110){if((r|0)!=99){break p}e=(e|0)>1?e:1;break o}SF(n,F,q,m);break g}Ch(f,0,0);while(1){b=v[f+4>>2];q:{if(b>>>0<y[f+104>>2]){v[f+4>>2]=b+1;b=w[b|0];break q}b=Xc(f)}if(jl(b)){continue}break}b=v[f+4>>2];if(v[f+104>>2]){b=b-1|0;v[f+4>>2]=b}b=b-v[f+8>>2]|0;h=b>>31;j=b;m=m+v[f+124>>2]|0;b=q+v[f+120>>2]|0;m=b>>>0<q>>>0?m+1|0:m;d=b;b=j+b|0;h=h+m|0;q=b;m=b>>>0<d>>>0?h+1|0:h}j=e;g=e>>31;Ch(f,e,g);b=v[f+104>>2];d=v[f+4>>2];r:{if(b>>>0>d>>>0){v[f+4>>2]=d+1;break r}if((Xc(f)|0)<0){break d}b=v[f+104>>2]}if(b){v[f+4>>2]=v[f+4>>2]-1}b=16;s:{t:{u:{v:{w:{x:{y:{switch(r-88|0){default:b=r-65|0;if(b>>>0>6|!(1<<b&113)){break s}case 9:case 13:case 14:case 15:VF(k+8|0,f,F,0);b=v[f+4>>2]-v[f+8>>2]|0;if(v[f+120>>2]==(0-b|0)&v[f+124>>2]==(0-((b>>31)+((b|0)!=0)|0)|0)){break b}if(!n){break s}b=v[k+16>>2];d=v[k+20>>2];h=v[k+8>>2];e=v[k+12>>2];switch(F|0){case 2:break u;case 1:break v;case 0:break w;default:break s};case 3:case 11:case 27:if((r&239)==99){Qb(k+32|0,-1,257);t[k+32|0]=0;if((r|0)!=115){break t}t[k+65|0]=0;t[k+46|0]=0;u[k+42>>1]=0;u[k+44>>1]=0;break t}d=w[a+1|0];h=(d|0)==94;Qb(k+32|0,h,257);t[k+32|0]=0;b=h?a+2|0:a+1|0;z:{A:{B:{a=w[(h?2:1)+a|0];if((a|0)!=45){if((a|0)==93){break B}i=(d|0)!=94;a=b;break z}i=(d|0)!=94;t[k+78|0]=i;break A}i=(d|0)!=94;t[k+126|0]=i}a=b+1|0}while(1){b=w[a|0];C:{if((b|0)!=45){if(!b){break d}if((b|0)!=93){break C}break t}b=45;d=w[a+1|0];if(!d|(d|0)==93){break C}h=a+1|0;a=w[a-1|0];D:{if(d>>>0<=a>>>0){b=d;break D}while(1){a=a+1|0;t[a+(k+32|0)|0]=i;b=w[h|0];if(b>>>0>a>>>0){continue}break}}a=h}t[(b+k|0)+33|0]=i;a=a+1|0;continue};case 23:b=8;break x;case 12:case 29:b=10;break x;case 1:case 2:case 4:case 5:case 6:case 7:case 8:case 10:case 16:case 18:case 19:case 20:case 21:case 22:case 25:case 26:case 28:case 30:case 31:break s;case 0:case 24:case 32:break x;case 17:break y}}b=0}g=f;e=0;h=0;j=0;i=0;I=0;G=jb-16|0;jb=G;E:{F:{G:{H:{I:{J:{if(b>>>0<=36){while(1){d=v[g+4>>2];K:{if(d>>>0<y[g+104>>2]){v[g+4>>2]=d+1;d=w[d|0];break K}d=Xc(g)}if(jl(d)){continue}break}L:{M:{switch(d-43|0){case 0:case 2:break M;default:break L}}I=(d|0)==45?-1:0;d=v[g+4>>2];if(d>>>0<y[g+104>>2]){v[g+4>>2]=d+1;d=w[d|0];break L}d=Xc(g)}N:{if(!(b&-17|(d|0)!=48)){d=v[g+4>>2];O:{if(d>>>0<y[g+104>>2]){v[g+4>>2]=d+1;d=w[d|0];break O}d=Xc(g)}if((d&-33)==88){b=16;d=v[g+4>>2];P:{if(d>>>0<y[g+104>>2]){v[g+4>>2]=d+1;d=w[d|0];break P}d=Xc(g)}if(w[d+54721|0]<16){break I}if(!v[g+104>>2]){break F}v[g+4>>2]=v[g+4>>2]-1;break F}if(b){break N}b=8;break I}b=b?b:10;if(b>>>0>w[d+54721|0]){break N}if(v[g+104>>2]){v[g+4>>2]=v[g+4>>2]-1}Ch(g,0,0);v[113305]=28;b=0;d=0;break E}if((b|0)!=10){break I}j=d-48|0;if(j>>>0<=9){b=0;while(1){b=B(b,10)+j|0;e=b>>>0<429496729;d=v[g+4>>2];Q:{if(d>>>0<y[g+104>>2]){v[g+4>>2]=d+1;d=w[d|0];break Q}d=Xc(g)}j=d-48|0;if(e&j>>>0<=9){continue}break}e=b}if(j>>>0>9){break J}i=qma(e,0,10,0);l=mb;b=j;while(1){d=v[g+4>>2];R:{if(d>>>0<y[g+104>>2]){v[g+4>>2]=d+1;d=w[d|0];break R}d=Xc(g)}j=d-48|0;p=j>>>0>9;h=l;b=b+i|0;h=b>>>0<i>>>0?h+1|0:h;e=b;if((h|0)==429496729&b>>>0>=2576980378|h>>>0>429496729|p){break J}i=qma(e,h,10,0);l=mb;b=j;if((l|0)==-1&i>>>0<=(b^-1)>>>0|(l|0)!=-1){continue}break}b=10;break H}v[113305]=28;b=0;d=0;break E}b=10;if(j>>>0<=9){break H}break G}if(b-1&b){i=w[d+54721|0];if(i>>>0<b>>>0){while(1){j=B(b,j)+i|0;e=j>>>0<119304647;d=v[g+4>>2];S:{if(d>>>0<y[g+104>>2]){v[g+4>>2]=d+1;d=w[d|0];break S}d=Xc(g)}i=w[d+54721|0];if(e&i>>>0<b>>>0){continue}break}e=j}if(b>>>0<=i>>>0){break H}j=b;while(1){l=qma(e,h,j,0);p=mb;i=i&255;if((p|0)==-1&(i^-1)>>>0<l>>>0){break H}h=p;d=i+l|0;h=d>>>0<l>>>0?h+1|0:h;e=d;l=b;d=v[g+4>>2];T:{if(d>>>0<y[g+104>>2]){v[g+4>>2]=d+1;d=w[d|0];break T}d=Xc(g)}i=w[d+54721|0];if(l>>>0<=i>>>0){break H}Qe(G,j,0,0,0,e,h,0,0);if(!(v[G+8>>2]|v[G+12>>2])){continue}break}break H}l=t[(B(b,23)>>>5&7)+54977|0];j=w[d+54721|0];if(j>>>0<b>>>0){while(1){i=i<<l|j;e=i>>>0<134217728;d=v[g+4>>2];U:{if(d>>>0<y[g+104>>2]){v[g+4>>2]=d+1;d=w[d|0];break U}d=Xc(g)}j=w[d+54721|0];if(e&j>>>0<b>>>0){continue}break}e=i}if(b>>>0<=j>>>0){break H}i=l;p=i&31;if((i&63)>>>0>=32){l=0;H=-1>>>p|0}else{H=-1>>>p|0;l=H;H=l|(1<<p)-1<<32-p}if(!l&e>>>0>H>>>0){break H}while(1){p=j&255;j=e;d=i;e=d&31;if((d&63)>>>0>=32){h=j<<e;d=0}else{h=(1<<e)-1&j>>>32-e|h<<e;d=j<<e}e=p|d;p=b;d=v[g+4>>2];V:{if(d>>>0<y[g+104>>2]){v[g+4>>2]=d+1;d=w[d|0];break V}d=Xc(g)}j=w[d+54721|0];if(p>>>0<=j>>>0){break H}if((h|0)==(l|0)&e>>>0<=H>>>0|h>>>0<l>>>0){continue}break}}if(w[d+54721|0]>=b>>>0){break G}while(1){h=v[g+4>>2];W:{if(h>>>0<y[g+104>>2]){v[g+4>>2]=h+1;d=w[h|0];break W}d=Xc(g)}if(w[d+54721|0]<b>>>0){continue}break}v[113305]=68;I=0;e=-1;h=-1}if(v[g+104>>2]){v[g+4>>2]=v[g+4>>2]-1}if(I|1?0:(e|0)==-1&(h|0)==-1){v[113305]=68;b=-2;d=-1;break E}b=I;e=b^e;d=b;b=e-b|0;j=h;h=d>>31;d=(j^h)-((d>>>0>e>>>0)+h|0)|0;break E}Ch(g,0,0);b=0;d=0}jb=G+16|0;h=v[f+4>>2]-v[f+8>>2]|0;e=h;if(v[f+120>>2]==(0-e|0)&v[f+124>>2]==(0-((e>>31)+((e|0)!=0)|0)|0)){break b}if(!(!n|(r|0)!=112)){v[n>>2]=b;break s}SF(n,F,b,d);break s}J=n,K=TF(h,e,b,d),z[J>>2]=K;break s}J=n,L=sw(h,e,b,d),A[J>>3]=L;break s}v[n>>2]=h;v[n+4>>2]=e;v[n+8>>2]=b;v[n+12>>2]=d;break s}d=(r|0)==99;i=d?e+1|0:31;h=(F|0)!=1;X:{if(!h){b=n;if(s){b=kd(i<<2);if(!b){break e}}v[k+296>>2]=0;v[k+300>>2]=0;e=0;c=s;while(1){o=b;Y:{while(1){b=v[f+4>>2];Z:{if(b>>>0<y[f+104>>2]){v[f+4>>2]=b+1;b=w[b|0];break Z}b=Xc(f)}if(!w[(b+k|0)+33|0]){break Y}t[k+27|0]=b;b=xo(k+28|0,k+27|0,1,k+296|0);if((b|0)==-2){continue}if((b|0)==-1){break f}if(o){v[(e<<2)+o>>2]=v[k+28>>2];e=e+1|0}if(!(c&(e|0)==(i|0))){continue}break}i=i<<1|1;b=Qq(o,i<<2);if(b){continue}break f}break}if(k+296|0?v[k+296>>2]:0){break f}c=0;break X}if(s){e=0;b=kd(i);if(!b){break e}while(1){c=b;while(1){b=v[f+4>>2];_:{if(b>>>0<y[f+104>>2]){v[f+4>>2]=b+1;b=w[b|0];break _}b=Xc(f)}if(!w[(b+k|0)+33|0]){o=0;break X}t[c+e|0]=b;e=e+1|0;if((i|0)!=(e|0)){continue}break}o=0;i=i<<1|1;b=Qq(c,i);if(b){continue}break}break d}e=0;if(n){while(1){b=v[f+4>>2];$:{if(b>>>0<y[f+104>>2]){v[f+4>>2]=b+1;b=w[b|0];break $}b=Xc(f)}if(w[(b+k|0)+33|0]){t[e+n|0]=b;e=e+1|0;continue}else{o=0;c=n;break X}}}while(1){b=v[f+4>>2];aa:{if(b>>>0<y[f+104>>2]){v[f+4>>2]=b+1;b=w[b|0];break aa}b=Xc(f)}if(w[(b+k|0)+33|0]){continue}break}c=0;o=0}b=v[f+4>>2];if(v[f+104>>2]){b=b-1|0;v[f+4>>2]=b}i=b-v[f+8>>2]|0;b=i+v[f+120>>2]|0;l=v[f+124>>2]+(i>>31)|0;l=b>>>0<i>>>0?l+1|0:l;if(!(l|b)|((b|0)!=(j|0)|(g|0)!=(l|0))&(r|0)==99){break b}ba:{if(!s){break ba}if(!h){v[n>>2]=o;break ba}v[n>>2]=c}if(d){break s}if(o){v[(e<<2)+o>>2]=0}if(!c){c=0;break s}t[c+e|0]=0}b=v[f+4>>2]-v[f+8>>2]|0;h=b>>31;e=b;m=m+v[f+124>>2]|0;b=q+v[f+120>>2]|0;m=b>>>0<q>>>0?m+1|0:m;d=b;b=e+b|0;m=h+m|0;m=b>>>0<d>>>0?m+1|0:m;q=b;E=((n|0)!=0)+E|0}e=a+1|0;a=w[a+1|0];if(a){continue}break a}break}c=0;break d}c=0;o=0}if(E){break b}}E=-1}if(!s){break a}Wb(c);Wb(o)}jb=k+304|0;jb=x+144|0;return E}function HH(a,b,c,d,e,f,g){var h=0,i=0,j=0,k=0;h=jb-128|0;jb=h;a:{b:{if(g){Fj(h+112|0,f,32);v[113382]=0;W(763,h+96|0,f|0,32)|0;i=v[113382];v[113382]=0;if((i|0)!=1){break b}c=P()|0;O()|0;break a}Xb(h+112|0);Xb(h+96|0)}c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{if(Qr(c)){i=b+24|0;b=v[i>>2];v[113382]=0;b=Q(398,b+484344|0,c&65535)|0;j=v[113382];v[113382]=0;if((j|0)==1){break o}if(b){break n}}v[113382]=0;U(2162,a|0,h+112|0,h+96|0);a=v[113382];v[113382]=0;if((a|0)!=1){break m}}c=P()|0;O()|0;break c}b=Zb(v[i>>2]+484344|0,c);if(!(v[b+12>>2]>(d|0)&(d|0)>=0)){v[113382]=0;U(2162,a|0,h+112|0,h+96|0);a=v[113382];v[113382]=0;if((a|0)!=1){break m}break d}if(!(x[v[i>>2]+480188>>1]>e>>>0&(e|0)>=0)){v[113382]=0;U(2162,a|0,h+112|0,h+96|0);a=v[113382];v[113382]=0;if((a|0)==1){break d}break m}v[113382]=0;c=W(2163,b|0,d|0,e&65535)|0;b=v[113382];v[113382]=0;if((b|0)==1){break l}Ee(h+112|0);Ee(h+96|0);v[113382]=0;b=T(516,c|0)|0;d=v[113382];v[113382]=0;p:{q:{r:{s:{t:{u:{v:{w:{x:{y:{z:{A:{B:{if((d|0)!=1){C:{D:{if(!b){if(!os(c)){break D}}b=v[i>>2];d=w[c+1|0];e=w[c|0];v[113382]=0;X(2164,h- -64|0,b|0,e|0,d|0);d=v[113382];v[113382]=0;b=1;if((d|0)==1){break B}v[113382]=0;U(9,h+80|0,0,h- -64|0);d=v[113382];v[113382]=0;if((d|0)!=1){break C}c=P()|0;O()|0;break y}b=0;v[113382]=0;Q(121,h+80|0,12863)|0;d=v[113382];v[113382]=0;if((d|0)==1){break A}}v[113382]=0;Q(1214,h+112|0,h+80|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break z}yb(h+80|0);if(b){yb(h- -64|0)}v[113382]=0;b=T(516,c|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break e}E:{if(b){v[113382]=0;Q(121,h+80|0,6061)|0;b=v[113382];v[113382]=0;if((b|0)==1){break e}break E}if(os(c)){v[113382]=0;Q(121,h+80|0,6366)|0;b=v[113382];v[113382]=0;if((b|0)!=1){break E}break e}v[113382]=0;Q(121,h+80|0,12863)|0;b=v[113382];v[113382]=0;if((b|0)==1){break e}}v[113382]=0;Q(1214,h+96|0,h+80|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break x}yb(h+80|0);j=f-1|0;if(j>>>0<5){break q}v[113382]=0;b=Q(121,h+80|0,13825)|0;d=v[113382];v[113382]=0;if((d|0)==1){break w}v[113382]=0;Q(1214,h+112|0,b|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break v}yb(b);v[113382]=0;b=Q(121,h+80|0,13825)|0;d=v[113382];v[113382]=0;if((d|0)==1){break u}v[113382]=0;Q(1214,h+96|0,b|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break t}yb(b);b=c+1|0;F:{if(w[c+1|0]){v[113382]=0;R(799,h+80|0,b|0);d=v[113382];v[113382]=0;if((d|0)!=1){break F}break f}v[113382]=0;Q(121,h+80|0,12868)|0;d=v[113382];v[113382]=0;if((d|0)==1){break f}}v[113382]=0;Q(1214,h+112|0,h+80|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break s}yb(h+80|0);G:{if(w[b|0]){v[113382]=0;Q(121,h+80|0,6848)|0;b=v[113382];v[113382]=0;if((b|0)!=1){break G}break g}v[113382]=0;Q(121,h+80|0,12868)|0;b=v[113382];v[113382]=0;if((b|0)==1){break g}}v[113382]=0;Q(1214,h+96|0,h+80|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){break r}c=P()|0;O()|0;yb(h+80|0);break c}c=P()|0;O()|0;break c}c=P()|0;O()|0;break c}c=P()|0;O()|0;break c}c=P()|0;O()|0;yb(h+80|0);if(!b){break c}}yb(h- -64|0);break c}c=P()|0;O()|0;yb(h+80|0);break c}c=P()|0;O()|0;break c}c=P()|0;O()|0;yb(b);break c}c=P()|0;O()|0;break c}c=P()|0;O()|0;yb(b);break c}c=P()|0;O()|0;yb(h+80|0);break c}yb(h+80|0);if(j>>>0<8){break q}v[113382]=0;b=T(1304,c|0)|0;d=v[113382];v[113382]=0;H:{I:{J:{K:{L:{M:{N:{O:{P:{if((d|0)!=1){Q:{if(b){v[113382]=0;b=Q(121,h+48|0,13825)|0;d=v[113382];v[113382]=0;if((d|0)==1){break P}v[113382]=0;e=T(1306,c|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break O}d=0;v[113382]=0;v[h+16>>2]=e&255;R(798,h+32|0,h+16|0);k=v[113382];v[113382]=0;e=1;if((k|0)==1){break O}v[113382]=0;U(137,h+80|0,b|0,h+32|0);b=v[113382];v[113382]=0;if((b|0)!=1){break Q}c=P()|0;O()|0;break K}if(w[c+2|0]){b=v[v[i>>2]+8>>2];d=w[c+2|0];v[113382]=0;b=Q(2165,b|0,d|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break I}v[113382]=0;b=W(763,h+48|0,1,b|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break I}e=0;v[113382]=0;R(799,h+32|0,c+4|0);k=v[113382];v[113382]=0;d=1;if((k|0)==1){break N}v[113382]=0;U(137,h+80|0,b|0,h+32|0);k=v[113382];v[113382]=0;if((k|0)!=1){break Q}c=P()|0;O()|0;yb(h+32|0);break h}e=0;v[113382]=0;Q(121,h+80|0,12867)|0;b=v[113382];v[113382]=0;d=0;if((b|0)==1){break M}}v[113382]=0;Q(1214,h+112|0,h+80|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break L}yb(h+80|0);if(d){yb(h+32|0);yb(h+48|0)}if(e){yb(h+32|0);yb(h+48|0)}v[113382]=0;b=T(1304,c|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break i}R:{if(b){v[113382]=0;Q(121,h+80|0,1974)|0;b=v[113382];v[113382]=0;if((b|0)==1){break i}break R}if(w[c+2|0]){v[113382]=0;Q(121,h+80|0,1970)|0;b=v[113382];v[113382]=0;if((b|0)!=1){break R}break i}v[113382]=0;Q(121,h+80|0,12867)|0;b=v[113382];v[113382]=0;if((b|0)==1){break i}}v[113382]=0;Q(1214,h+96|0,h+80|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){break H}c=P()|0;O()|0;yb(h+80|0);break c}c=P()|0;O()|0;break c}c=P()|0;O()|0;break c}c=P()|0;O()|0;break J}c=P()|0;O()|0;break h}c=P()|0;O()|0;break c}c=P()|0;O()|0;yb(h+80|0);if(d){yb(h+32|0);yb(h+48|0)}if(!e){break c}}yb(h+32|0)}yb(h+48|0);break c}c=P()|0;O()|0;break c}yb(h+80|0);if(j>>>0<12){break q}v[113382]=0;b=Q(121,h+80|0,13825)|0;d=v[113382];v[113382]=0;S:{T:{U:{V:{W:{X:{Y:{Z:{_:{if((d|0)!=1){v[113382]=0;Q(1214,h+112|0,b|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break _}yb(b);v[113382]=0;b=Q(121,h+80|0,13825)|0;d=v[113382];v[113382]=0;if((d|0)==1){break Z}v[113382]=0;Q(1214,h+96|0,b|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break Y}yb(b);v[113382]=0;b=T(1304,c|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break X}$:{if(b){b=0;v[113382]=0;d=T(1305,c|0)|0;e=v[113382];v[113382]=0;if((e|0)!=1){v[113382]=0;v[h+28>>2]=d&4095;R(1025,h+80|0,h+28|0);d=v[113382];v[113382]=0;if((d|0)!=1){break $}}c=P()|0;O()|0;break c}if(w[c+3|0]){b=v[v[i>>2]+8>>2];d=w[c+3|0];v[113382]=0;b=Q(2166,b|0,d|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break W}v[113382]=0;d=W(763,h+16|0,1,b|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break W}v[113382]=0;R(799,h|0,c+5|0);e=v[113382];v[113382]=0;b=1;if((e|0)==1){break V}v[113382]=0;U(137,h+80|0,d|0,h|0);d=v[113382];v[113382]=0;if((d|0)!=1){break $}c=P()|0;O()|0;yb(h);break j}b=0;v[113382]=0;Q(121,h+80|0,12863)|0;d=v[113382];v[113382]=0;if((d|0)==1){break T}}v[113382]=0;Q(1214,h+112|0,h+80|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break U}yb(h+80|0);if(b){yb(h);yb(h+16|0)}v[113382]=0;b=T(1304,c|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break k}aa:{if(b){v[113382]=0;Q(121,h+80|0,7113)|0;b=v[113382];v[113382]=0;if((b|0)==1){break k}break aa}if(w[c+3|0]){v[113382]=0;Q(121,h+80|0,7113)|0;b=v[113382];v[113382]=0;if((b|0)!=1){break aa}break k}v[113382]=0;Q(121,h+80|0,12863)|0;b=v[113382];v[113382]=0;if((b|0)==1){break k}}v[113382]=0;Q(1214,h+96|0,h+80|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){break S}c=P()|0;O()|0;yb(h+80|0);break c}c=P()|0;O()|0;break c}c=P()|0;O()|0;yb(b);break c}c=P()|0;O()|0;break c}c=P()|0;O()|0;yb(b);break c}c=P()|0;O()|0;break c}c=P()|0;O()|0;break c}c=P()|0;O()|0;break j}c=P()|0;O()|0;yb(h+80|0);if(!b){break c}yb(h);break j}c=P()|0;O()|0;break c}yb(h+80|0);if(!f){break p}}ba:{ca:{da:{ea:{if(Db(h+112|0)>>>0>f>>>0){v[113382]=0;X(202,h+80|0,h+112|0,0,f|0);b=v[113382];v[113382]=0;if((b|0)!=1){break ea}c=P()|0;O()|0;break c}if(g){b=Db(h+112|0);v[113382]=0;b=W(763,h+80|0,f-b|0,32)|0;c=v[113382];v[113382]=0;if((c|0)==1){break ca}v[113382]=0;Q(1214,h+112|0,b|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){c=P()|0;O()|0;yb(b);break c}yb(b);if(Db(h+96|0)>>>0>f>>>0){break ba}break da}if(Db(h+96|0)>>>0<=f>>>0){break p}break ba}b=h+80|0;Gb(h+112|0,b);yb(b);if(Db(h+96|0)>>>0>f>>>0){break ba}if(!g){break p}}b=Db(h+96|0);v[113382]=0;b=W(763,h+80|0,f-b|0,32)|0;c=v[113382];v[113382]=0;fa:{if((c|0)!=1){v[113382]=0;Q(1214,h+96|0,b|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break fa}yb(b);break p}c=P()|0;O()|0;break c}c=P()|0;O()|0;yb(b);break c}c=P()|0;O()|0;break c}v[113382]=0;X(202,h+80|0,h+96|0,0,f|0);b=v[113382];v[113382]=0;if((b|0)!=1){b=h+80|0;Gb(h+96|0,b);yb(b);break p}c=P()|0;O()|0;break c}v[113382]=0;U(2162,a|0,h+112|0,h+96|0);a=v[113382];v[113382]=0;if((a|0)==1){break l}}yb(h+96|0);yb(h+112|0);jb=h+128|0;return}c=P()|0;O()|0;break c}c=P()|0;O()|0;break c}yb(h+16|0);break c}c=P()|0;O()|0;break c}yb(b);break c}c=P()|0;O()|0;break c}c=P()|0;O()|0;break c}c=P()|0;O()|0;break c}c=P()|0;O()|0}yb(h+96|0)}yb(h+112|0);S(c|0);L()}function Mha(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,y=0,z=0,A=0,C=0,D=0,E=0,F=0,G=0;d=jb-304|0;jb=d;Ic(b);a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{if(!gt(b,d+208|0)){break j}if(!yP(d+208|0)){break j}if(!Rb(b,dd(xP(d+208|0),mb))){break j}if(!c){n=1;break j}if(!Nc(b,w[d+208|4])){break j}Id(a,268435456);vi(a);v[a+480208>>2]=4;f=d+88|0;h=Ub(f,11315);Gb(a+1304436|0,h);yb(h);h=Ub(f,6370);Gb(a+1304448|0,h);yb(h);v[a+1304496>>2]=4;h=d+16|0;_e(h,d+208|6,48,3);Ec(f,h);Gb(a+1304400|0,f);yb(f);u[a+480188>>1]=w[d+262|0]+1;v[a+480228>>2]=w[d+265|0];v[a+480204>>2]=B(w[d+266|0],1e4);v[a+480196>>2]=w[d+267|0];if(w[d+262|0]){f=0;while(1){u[((f<<5)+a|0)+480284>>1]=B(w[(d+f|0)+268|0],17);f=f+1|0;if(f>>>0<w[d+262|0]){continue}break}}u[a+480190>>1]=w[d+300|0];e=w[d+302|0]|w[d+303|0]<<8;h=jb-16|0;jb=h;k=d+192|0;f=k;v[f>>2]=0;v[f+4>>2]=0;v[113382]=0;v[h+12>>2]=0;W(910,f+8|0,h+12|0,h+8|0)|0;i=v[113382];v[113382]=0;k:{if((i|0)!=1){jb=h+16|0;break k}V(0)|0;O()|0;Ab();L()}l:{if(!e){break l}v[113382]=0;R(908,k|0,e|0);h=v[113382];v[113382]=0;if((h|0)!=1){v[113382]=0;R(909,k|0,e|0);h=v[113382];v[113382]=0;if((h|0)!=1){break l}}a=P()|0;O()|0;uP(f);S(a|0);L()}f=w[d+302|0]|w[d+303|0]<<8;v[113382]=0;W(900,b|0,k|0,f|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break i}r=Np(d+176|0);o=Np(d+160|0);f=w[d+301|0];v[113382]=0;W(590,b|0,r|0,f|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break f}h=w[d+300|0];f=0;v[113382]=0;W(590,b|0,o|0,h|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break f}if(w[d+300|0]){p=c&2;h=d+88|0;q=h|4;l=d+126|0;m=h|6;while(1){v[113382]=0;h=f;f=f+1|0;i=B(f,104)+a|0;j=i+484380|0;R(453,j|0,0);e=v[113382];v[113382]=0;m:{n:{if((e|0)!=1){e=Pb(o,h);if(!(w[e|0]|w[e+1|0]<<8|(w[e+2|0]<<16|w[e+3|0]<<24))){break m}e=Pb(o,h);e=w[e|0]|w[e+1|0]<<8|(w[e+2|0]<<16|w[e+3|0]<<24);v[113382]=0;e=Q(226,b|0,e|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break c}if(!e){break m}v[113382]=0;e=Q(901,b|0,d+88|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break c}if(!e){break m}v[113382]=0;U(355,d+72|0,2,m|0);e=v[113382];v[113382]=0;if((e|0)!=1){v[113382]=0;R(356,d+16|0,d+72|0);e=v[113382];v[113382]=0;if((e|0)!=1){break n}}f=P()|0;O()|0;break b}f=P()|0;O()|0;break b}v[113382]=0;Q(335,((f<<5)+a|0)+946304|0,d+16|0)|0;e=v[113382];v[113382]=0;o:{p:{q:{r:{s:{if((e|0)!=1){yb(d+16|0);v[113382]=0;U(902,d+72|0,2,l|0);e=v[113382];v[113382]=0;if((e|0)==1){break s}v[113382]=0;R(356,d+16|0,d+72|0);e=v[113382];v[113382]=0;if((e|0)==1){break s}v[113382]=0;Q(336,i+484423|0,d+16|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break r}yb(d+16|0);if(w[d+138|0]<=15){e=i+484414|0;u[e>>1]=x[e>>1]|32;u[i+484408>>1]=B(w[d+138|0],17)}e=w[d+139|0];v[113382]=0;t[d+16|0]=e;t[d+72|0]=64;e=Q(415,d+16|0,d+72|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break q}u[i+484412>>1]=w[e|0];v[i+484404>>2]=w[d+141|0]|w[d+142|0]<<8;e=i+484384|0;v[e>>2]=w[d+147|0]|w[d+148|0]<<8|(w[d+149|0]<<16|w[d+150|0]<<24);g=i+484388|0;v[g>>2]=w[d+151|0]|w[d+152|0]<<8|(w[d+153|0]<<16|w[d+154|0]<<24);v[j>>2]=w[d+155|0]|w[d+156|0]<<8|(w[d+157|0]<<16|w[d+158|0]<<24);if(t[d+140|0]&1){break p}n=v[e>>2];e=v[g>>2];break o}f=P()|0;O()|0;yb(d+16|0);break b}f=P()|0;O()|0;break b}f=P()|0;O()|0;yb(d+16|0);break b}f=P()|0;O()|0;break b}n=v[e>>2]>>>1|0;v[e>>2]=n;e=v[g>>2]>>>1|0;v[g>>2]=e;v[j>>2]=v[j>>2]>>>1}t:{if(e>>>0<=n>>>0){break t}e=i+484414|0;u[e>>1]=x[e>>1]|2;if(!(w[d+140|0]&2)){break t}u[e>>1]=x[e>>1]|4}v[113382]=0;Z(903,j|0);e=v[113382];v[113382]=0;if((e|0)==1){break c}if(!p){break m}h=Pb(o,h);h=w[h|0]|w[h+1|0]<<8|(w[h+2|0]<<16|w[h+3|0]<<24);e=w[q|0];v[113382]=0;Q(226,b|0,e+h|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break c}h=Yc(d+16|0,t[d+140|0]&1?16:8,1,0,1);v[113382]=0;W(362,h|0,j|0,b|0)|0;h=v[113382];v[113382]=0;if((h|0)!=1){break m}f=P()|0;O()|0;break b}if(w[d+300|0]>f>>>0){continue}break}}n=1;u:{if(!(c&1)){break u}v[d+68>>2]=0;i=a+484360|0;Hn(Vb(i));F=d,G=ac(k),v[F+64>>2]=G;F=d,G=bc(k),v[F+56>>2]=G;j=a+484344|0;if(Jb(d- -64|0,d+56|0)){c=d+88|0;z=c|5;p=c|4;while(1){h=v[d- -64>>2];c=h;v:{if(w[c+3|0]>=w[d+301|0]|w[c+2|0]>w[d+262|0]){break v}c=Pb(r,w[c+3|0]);c=w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24);v[113382]=0;c=Q(226,b|0,c|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break g}if(!c){break v}v[113382]=0;Q(904,b|0,d+88|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break h}if(!w[p|0]){break v}f=w[h|0]|w[h+1|0]<<8;c=f;t[d+16|0]=w[z|0];e=w[d+262|0];g=w[h+2|0];v[113382]=0;t[d+72|0]=e-g;e=Q(415,d+16|0,d+72|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break d}q=w[e|0];e=w[h|0]|w[h+1|0]<<8;g=w[p|0];v[113382]=0;v[d+52>>2]=e+g;e=Q(905,d+68|0,d+52|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break e}v[d+68>>2]=v[e>>2];v[d+40>>2]=0;v[d+44>>2]=0;v[d+32>>2]=0;v[d+36>>2]=0;v[d+24>>2]=0;v[d+28>>2]=0;v[d+16>>2]=0;v[d+20>>2]=0;if(!w[p|0]){break v}s=c>>>6|0;e=f&63;A=0;while(1){w:{x:{y:{z:{A:{B:{C:{f=e>>>0>63;s=f+s|0;c=s&65535;if(oc(Vb(i))>>>0<=c>>>0){g=Vb(i);v[113382]=0;R(891,g|0,s+1&65535);g=v[113382];v[113382]=0;if((g|0)==1){break C}v[113382]=0;g=W(775,j|0,64,0)|0;l=v[113382];v[113382]=0;if((l|0)==1){break C}F=rc(Vb(i),c),G=g,u[F>>1]=G}l=x[rc(Vb(i),c)>>1];v[113382]=0;c=Q(398,j|0,l|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break A}if(!c){break v}c=Zb(j,l);g=w[h+2|0];v[113382]=0;y=f?0:e;f=W(432,c|0,y|0,g|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break x}m=0;if(q){break B}break y}f=P()|0;O()|0;break b}while(1){v[113382]=0;R(906,d+72|0,b|0);c=v[113382];v[113382]=0;if((c|0)==1){break z}c=d+72|0;g=Zc(c);D=Cf(c);C=Ph(c);E=jc(c);e=0;c=w[c|0];if((c-1&255)>>>0<=142){e=(B((c&240)>>>4|0,12)+(c&15)|0)+13|0;t[(d+16|0)+m|0]=e}t[f|0]=e;c=w[g|0];t[f+2|0]=1;t[f+1|0]=c;c=w[D|0];D:{if((c|0)!=255){t[f+4|0]=c;break D}t[f+2|0]=0}c=w[C|0];E:{if(c>>>0>22){break E}t[f+3|0]=w[c+24128|0];g=w[E|0];t[f+5|0]=g;c=f+5|0;F:{switch(w[C|0]-4|0){case 3:t[c|0]=g&3|64;break E;case 4:t[c|0]=g&3|48;break E;case 7:if(Kb(k)>>>0<=g>>>0){break E}g=c;c=Pb(k,w[c|0]);e=w[c|0]|w[c+1|0]<<8;t[g|0]=e>>>6;c=Zb(j,l);g=x[a+480188>>1];v[113382]=0;c=W(432,c|0,y|0,g-1&65535)|0;g=v[113382];v[113382]=0;if((g|0)!=1){t[c+3|0]=14;t[c+5|0]=e&63;break E}f=P()|0;O()|0;break b;case 8:t[c|0]=v[d+52>>2]>>>6;c=Zb(j,l);e=x[a+480188>>1];v[113382]=0;c=W(432,c|0,y|0,e-1&65535)|0;e=v[113382];v[113382]=0;if((e|0)!=1){t[c+3|0]=14;t[c+5|0]=w[d+52|0]&63;break E}f=P()|0;O()|0;break b;case 10:t[c|0]=g&15|128;break E;case 12:v[113382]=0;t[d+15|0]=15;e=Q(415,c|0,d+15|0)|0;g=v[113382];v[113382]=0;if((g|0)!=1){t[c|0]=w[e|0]|208;break E}f=P()|0;O()|0;break b;case 13:v[113382]=0;t[d+15|0]=15;e=Q(415,c|0,d+15|0)|0;g=v[113382];v[113382]=0;if((g|0)!=1){t[c|0]=w[e|0]|192;break E}f=P()|0;O()|0;break b;case 14:v[113382]=0;t[d+15|0]=15;e=Q(415,c|0,d+15|0)|0;g=v[113382];v[113382]=0;if((g|0)!=1){t[c|0]=w[e|0]|224;break E}f=P()|0;O()|0;break b;case 0:case 16:case 17:if(!(g&15)){break E}e=g&240;if(!e|(e|0)==240){break E}t[c|0]=g|15;break E;case 9:case 18:break F;default:break E}}if(e&255){break E}t[f|0]=w[(d+16|0)+m|0]}f=f+6|0;m=m+1|0;if((q|0)!=(m|0)){continue}break}break y}f=P()|0;O()|0;break b}f=P()|0;O()|0;break b}if(q>>>0>=w[z|0]){break w}c=w[z|0];v[113382]=0;Q(304,b|0,B(c-q|0,5)|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){break w}}f=P()|0;O()|0;break b}e=y+1|0;A=A+1|0;if(A>>>0<w[p|0]){continue}break}}c=d- -64|0;Ie(c);if(Jb(c,d+56|0)){continue}break}}G:{a=v[d+68>>2];b=a&63;if(!b){break G}c=Vb(i);v[113382]=0;a=a>>>6|0;c=Q(509,c|0,a&65535)|0;f=v[113382];v[113382]=0;if((f|0)!=1){if(!c){break G}a=Zb(j,x[rc(Vb(i),a&65535)>>1]);v[113382]=0;aa(907,a|0,b|0,0,1)|0;a=v[113382];v[113382]=0;if((a|0)!=1){break G}}f=P()|0;O()|0;break b}a=Vb(i);F=d,G=ac(a),v[F+88>>2]=G;F=d,G=bc(a),v[F+16>>2]=G;if(!Jb(d+88|0,d+16|0)){break u}e=65535;while(1){a=v[d+88>>2];if(x[a>>1]==65535){H:{if((e&65535)!=65535){break H}v[113382]=0;e=W(775,j|0,64,0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){break H}f=P()|0;O()|0;break b}u[a>>1]=e}a=d+88|0;re(a);if(Jb(a,d+16|0)){continue}break}}Ji(o);Ji(r);wP(k)}jb=d+304|0;return n|0}f=P()|0;O()|0;break a}f=P()|0;O()|0;break b}f=P()|0;O()|0;break b}f=P()|0;O()|0;break b}f=P()|0;O()|0;break b}f=P()|0;O()|0;break b}f=P()|0;O()|0}Ji(o);Ji(r)}wP(k);S(f|0);L()}function Tla(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=jb-240|0;jb=e;Ic(b);a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{if(!vA(b,e+168|0)){break j}if(!WS(e+168|0)){break j}if(!c){d=1;break j}Id(a,131072);f=Ub(e+152|0,11452);v[113382]=0;R(189,e+32|0,f|0);d=v[113382];v[113382]=0;k:{l:{m:{n:{o:{p:{q:{if((d|0)!=1){v[113382]=0;U(500,e+104|0,e+32|0,e+168|4);d=v[113382];v[113382]=0;if((d|0)==1){break q}d=e+104|0;Gb(a+1304436|0,d);yb(d);j=e+32|0;Ib(j);yb(f);f=Ub(d,7105);Gb(a+1304448|0,f);yb(f);v[a+1304496>>2]=4;EA(j,3,e+181|0);Ec(d,j);Gb(a+1304400|0,d);yb(d);f=e+72|0;Dn(f,3,e+211|0);Ec(j,f);v[113382]=0;U(13,d|0,4,j|0);d=v[113382];v[113382]=0;if((d|0)==1){break i}d=e+104|0;Gb(a+1304412|0,d);yb(d);yb(e+32|0);d=Vp(d);m=d,n=Ed(w[e+231|0],1,31),v[m+12>>2]=n;m=d,n=Ed(w[e+232|0],1,12)-1|0,v[m+16>>2]=n;v[d+20>>2]=w[e+233|0];j=a+1304500|0;uA(j);VS(j,d);i=e+72|4;d=jb-16|0;jb=d;j=e+88|0;f=j;v[f>>2]=0;v[f+4>>2]=0;v[113382]=0;v[d+12>>2]=0;W(530,f+8|0,d+12|0,d+8|0)|0;f=v[113382];v[113382]=0;r:{if((f|0)!=1){jb=d+16|0;break r}V(0)|0;O()|0;Ab();L()}while(1){v[113382]=0;d=Q(228,b|0,8)|0;f=v[113382];v[113382]=0;if((f|0)==1){break o}if(!d){break k}v[113382]=0;Q(501,b|0,e+72|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break n}f=w[i|0]|w[i+1|0]<<8|(w[i+2|0]<<16|w[i+3|0]<<24);d=w[e+172|0];s:{if((d|0)==3){g=2;if((w[e+72|0]|w[e+73|0]<<8|(w[e+74|0]<<16|w[e+75|0]<<24))==1431389523){break s}d=w[e+172|0]}if((d&255)==4){g=4;if((w[e+72|0]|w[e+73|0]<<8|(w[e+74|0]<<16|w[e+75|0]<<24))==1431389523){break s}d=w[e+172|0]}g=0;if((d&255)>>>0>7){break s}f=(w[e+72|0]|w[e+73|0]<<8|(w[e+74|0]<<16|w[e+75|0]<<24))==1146113363?-1:f}v[113382]=0;U(307,e+32|0,b|0,f|0);d=v[113382];v[113382]=0;if((d|0)==1){break m}v[113382]=0;W(502,j|0,e+72|0,e+32|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break l}Bb(e+32|0);v[113382]=0;Q(304,b|0,g|0)|0;d=v[113382];v[113382]=0;if((d|0)!=1){continue}break}d=P()|0;O()|0;break b}d=P()|0;O()|0;break p}d=P()|0;O()|0;Ib(e+32|0)}yb(f);break a}d=P()|0;O()|0;break b}d=P()|0;O()|0;break b}d=P()|0;O()|0;break b}d=P()|0;O()|0;Bb(e+32|0);break b}v[113382]=0;b=T(244,e+72|0)|0;d=v[113382];v[113382]=0;t:{u:{v:{if((d|0)!=1){v[113382]=0;U(503,e+32|0,j|0,1431389523);d=v[113382];v[113382]=0;if((d|0)==1){break v}d=e+32|0;Qd(b,d);Bb(d);u[e+70>>1]=0;u[e+68>>1]=65534;if(w[e+172|0]<3){break t}v[113382]=0;d=T(323,b|0)|0;f=v[113382];v[113382]=0;if((f|0)!=1){break u}break d}d=P()|0;O()|0;break b}d=P()|0;O()|0;break c}u[e+70>>1]=d;if(w[e+172|0]<4){break t}v[113382]=0;d=T(323,b|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break d}u[e+68>>1]=w[e+172|0]==4?d?d:-2:d}d=a+484360|0;f=Vb(d);v[113382]=0;g=T(296,b|0)|0;i=v[113382];v[113382]=0;if((i|0)==1){break d}v[113382]=0;ea(396,f|0,b|0,g>>>1|0,65535,65535)|0;f=v[113382];v[113382]=0;if((f|0)==1){break d}f=Vb(d);v[113382]=0;f=T(504,f|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break d}sg(e+70|0,f);f=Vb(d);v[113382]=0;f=T(504,f|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break d}sg(e+68|0,f);v[113382]=0;U(503,e+32|0,j|0,1414807888);f=v[113382];v[113382]=0;w:{x:{y:{z:{A:{B:{C:{D:{if((f|0)!=1){f=e+32|0;Qd(b,f);Bb(f);v[113382]=0;f=T(303,b|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break d}if(!f|!(c&1)){break w}v[113382]=0;Q(505,b|0,e- -64|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break D}f=e- -64|0;m=a,n=Ed(w[f|2],1,32)+1|0,u[m+480188>>1]=n;f=w[f|0]|w[f+1|0]<<8;v[113382]=0;f=Q(361,e|0,f|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break C}m=e,n=ac(f),v[m+16>>2]=n;m=e,n=bc(f),v[m+56>>2]=n;if(Jb(e+16|0,e+56|0)){while(1){i=v[e+16>>2];v[113382]=0;g=w[e+172|0]<3?9:8;Q(304,b|0,g-4|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break B}v[113382]=0;h=T(397,b|0)|0;k=v[113382];v[113382]=0;if((k|0)==1){break A}mg(b,g);v[113382]=0;U(307,e+32|0,b|0,g+h|0);g=v[113382];v[113382]=0;if((g|0)==1){break z}g=e+32|0;Qd(i,g);Bb(g);g=e+16|0;Xf(g);if(Jb(g,e+56|0)){continue}break}}g=x[a+480188>>1];v[113382]=0;g=Q(506,e+32|0,g|0)|0;i=v[113382];v[113382]=0;if((i|0)==1){break y}i=Vb(d);v[113382]=0;h=T(507,i|0)|0;i=v[113382];v[113382]=0;if((i|0)==1){break f}v[113382]=0;i=a+484344|0;R(363,i|0,h|0);h=v[113382];v[113382]=0;if((h|0)==1){break f}h=Vb(d);m=e,n=ac(h),v[m+16>>2]=n;m=e,n=bc(h),v[m+56>>2]=n;if(Jb(e+16|0,e+56|0)){while(1){h=v[e+16>>2];k=x[h>>1];if(jd(f)>>>0>k>>>0){k=sc(f,x[h>>1]);v[113382]=0;k=aa(508,k|0,w[e+172|0],g|0,a|0)|0;l=v[113382];v[113382]=0;if((l|0)==1){break f}u[h>>1]=k}h=e+16|0;re(h);if(Jb(h,e+56|0)){continue}break}}h=Vb(d);v[113382]=0;h=Q(509,h|0,x[e+68>>1])|0;k=v[113382];v[113382]=0;if((k|0)==1){break f}if(!h){break x}if(!x[e+70>>1]){h=x[e+68>>1];k=Vb(d);v[113382]=0;k=T(504,k|0)|0;l=v[113382];v[113382]=0;if((l|0)==1){break f}if(h>>>0>=k>>>0){break x}}d=x[rc(Vb(d),x[e+68>>1])>>1];h=Zb(i,d);v[113382]=0;k=W(459,e+16|0,12,w[e+70|0])|0;l=v[113382];v[113382]=0;if((l|0)!=1){d=Cn(Me(k,v[Zb(i,d)+12>>2]-1|0));v[113382]=0;Q(460,h|0,d|0)|0;d=v[113382];v[113382]=0;if((d|0)!=1){break x}}break f}d=P()|0;O()|0;break c}d=P()|0;O()|0;break c}d=P()|0;O()|0;break c}d=P()|0;O()|0;break e}d=P()|0;O()|0;break e}d=P()|0;O()|0;break e}d=P()|0;O()|0;break e}NS(g);cd(f)}v[113382]=0;U(503,e+32|0,j|0,1196641603);d=v[113382];v[113382]=0;if((d|0)==1){break h}d=e+32|0;Qd(b,d);Bb(d);v[113382]=0;d=T(303,b|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break d}if(d){v[113382]=0;Q(304,b|0,1)|0;d=v[113382];v[113382]=0;if((d|0)==1){break d}v[113382]=0;d=T(296,b|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break d}v[113382]=0;ea(510,a+1304424|0,b|0,d|0,40,0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break d}}v[113382]=0;U(503,e+32|0,j|0,1146113363);d=v[113382];v[113382]=0;if((d|0)==1){break g}v[113382]=0;U(503,e+16|0,j|0,1229999443);d=v[113382];v[113382]=0;E:{F:{if((d|0)!=1){d=e+16|0;Qd(b,d);Bb(d);v[113382]=0;f=T(409,b|0)|0;g=v[113382];v[113382]=0;d=1;G:{if((g|0)!=1){u[a+480190>>1]=f;if(x[a+480190>>1]){i=c&2;c=1;while(1){g=30;H:{I:{J:{if(w[e+172|0]>=2){v[113382]=0;g=T(409,b|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break J}}v[113382]=0;W(511,b|0,((d<<5)+a|0)+946304|0,g|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break J}v[113382]=0;Q(512,b|0,e+16|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break I}v[113382]=0;d=B(d,104)+a|0;g=d+484380|0;R(513,e+16|0,g|0);f=v[113382];v[113382]=0;if((f|0)==1){break I}f=w[e+172|0];if(f>>>0>=8){v[113382]=0;W(514,b|0,d+484423|0,8)|0;f=v[113382];v[113382]=0;if((f|0)==1){break I}f=w[e+172|0]}v[113382]=0;Q(304,b|0,((f&255)>>>0>1?6:2)|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break I}v[113382]=0;f=T(397,e+32|0)|0;h=v[113382];v[113382]=0;if((h|0)!=1){v[113382]=0;U(307,e|0,e+32|0,f|0);f=v[113382];v[113382]=0;if((f|0)!=1){break H}}d=P()|0;O()|0;break F}d=P()|0;O()|0;break F}d=P()|0;O()|0;break F}v[113382]=0;f=T(303,e|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break G}K:{if(!f|!i){break K}d=Yc(e+56|0,u[d+484414>>1]&1?16:8,1,0,(w[e+31|0]&12)==4?7:0);v[113382]=0;W(362,d|0,g|0,e|0)|0;d=v[113382];v[113382]=0;if((d|0)!=1){break K}break G}Bb(e);c=c+1|0;d=c&65535;if(d>>>0<=x[a+480190>>1]){continue}break}}v[113382]=0;Z(437,a|0);c=v[113382];v[113382]=0;d=1;if((c|0)!=1){break E}}d=P()|0;O()|0;break F}d=P()|0;O()|0;Bb(e);break F}d=P()|0;O()|0}Bb(e+32|0);break c}v[a+480204>>2]=12e5;v[a+480208>>2]=24;v[a+480196>>2]=6;v[a+480200>>2]=256;v[a+480228>>2]=48;v[a+480232>>2]=48;Bb(e+32|0);Bb(b);US(j)}jb=e+240|0;return d|0}d=P()|0;O()|0;yb(e+32|0);break a}d=P()|0;O()|0;break c}d=P()|0;O()|0;break c}d=P()|0;O()|0;NS(g)}cd(f);break c}d=P()|0;O()|0}Bb(b)}US(j)}S(d|0);L()}function WF(a,b,c,d,e,f,g,h,i){var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,w=0,x=0,z=0,A=0,B=0,C=0,D=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;k=jb-336|0;jb=k;m=h;o=i&65535;p=d;n=e&65535;s=(e^i)&-2147483648;r=i>>>16&32767;z=e>>>16&32767;a:{b:{if(r-1>>>0<32766&z-1>>>0<=32765){break b}w=e&2147483647;l=w;j=d;if(!(!d&(l|0)==2147418112?!(b|c):l>>>0<2147418112)){I=d;s=e|32768;break a}w=i&2147483647;e=w;d=h;if(!(!d&(e|0)==2147418112?!(f|g):e>>>0<2147418112)){I=h;s=i|32768;b=f;c=g;break a}if(!(b|j|(l^2147418112|c))){if(!(d|f|(e^2147418112|g))){b=0;c=0;s=2147450880;break a}s=s|2147418112;b=0;c=0;break a}if(!(d|f|(e^2147418112|g))){b=0;c=0;break a}if(!(b|j|(c|l))){b=!(d|f|(e|g));I=b?0:I;s=b?2147450880:s;b=0;c=0;break a}if(!(d|f|(e|g))){s=s|2147418112;b=0;c=0;break a}if((l|0)==65535|l>>>0<65535){i=b;d=!(n|p);h=d<<6;j=E(d?b:p)+32|0;b=E(d?c:n);b=h+((b|0)==32?j:b)|0;ef(k+320|0,i,c,p,n,b-15|0);t=16-b|0;p=v[k+328>>2];n=v[k+332>>2];c=v[k+324>>2];b=v[k+320>>2]}if(e>>>0>65535){break b}d=!(m|o);e=d<<6;h=E(d?f:m)+32|0;d=E(d?g:o);d=e+((d|0)==32?h:d)|0;ef(k+304|0,f,g,m,o,d-15|0);t=(d+t|0)-16|0;m=v[k+312>>2];o=v[k+316>>2];f=v[k+304>>2];g=v[k+308>>2]}e=o|65536;D=e;w=m;d=m;j=e<<15|d>>>17;e=d<<15|g>>>17;d=0-e|0;h=j;i=1963258675-(j+((e|0)!=0)|0)|0;Qe(k+288|0,e,j,0,0,d,i,0,0);j=v[k+296>>2];Qe(k+272|0,0-j|0,0-(v[k+300>>2]+((j|0)!=0)|0)|0,0,0,d,i,0,0);d=v[k+280>>2];i=d<<1|v[k+276>>2]>>>31;d=v[k+284>>2]<<1|d>>>31;Qe(k+256|0,i,d,0,0,e,h,0,0);j=d;d=v[k+264>>2];Qe(k+240|0,i,j,0,0,0-d|0,0-(v[k+268>>2]+((d|0)!=0)|0)|0,0,0);i=v[k+248>>2];j=i<<1|v[k+244>>2]>>>31;d=v[k+252>>2]<<1|i>>>31;Qe(k+224|0,j,d,0,0,e,h,0,0);i=d;d=v[k+232>>2];Qe(k+208|0,j,i,0,0,0-d|0,0-(v[k+236>>2]+((d|0)!=0)|0)|0,0,0);d=v[k+216>>2];i=d<<1|v[k+212>>2]>>>31;d=v[k+220>>2]<<1|d>>>31;Qe(k+192|0,i,d,0,0,e,h,0,0);j=d;d=v[k+200>>2];Qe(k+176|0,i,j,0,0,0-d|0,0-(v[k+204>>2]+((d|0)!=0)|0)|0,0,0);d=e;i=v[k+184>>2];e=i<<1|v[k+180>>2]>>>31;l=e-1|0;i=(v[k+188>>2]<<1|i>>>31)-!e|0;Qe(k+160|0,d,h,0,0,l,i,0,0);e=f;Qe(k+144|0,e<<15,g<<15|e>>>17,0,0,l,i,0,0);h=v[k+172>>2];o=v[k+160>>2];e=v[k+152>>2];d=o+e|0;m=v[k+164>>2];j=m+v[k+156>>2]|0;j=d>>>0<e>>>0?j+1|0:j;e=d;d=j;m=(m|0)==(d|0)&o>>>0>e>>>0|d>>>0<m>>>0;j=m+v[k+168>>2]|0;h=j>>>0<m>>>0?h+1|0:h;o=!d&e>>>0>1|(d|0)!=0;m=o+j|0;j=h;h=m;Qe(k+112|0,l,i,0,0,0-h|0,0-(((h|0)!=0)+(h>>>0<o>>>0?j+1|0:j)|0)|0,0,0);Qe(k+128|0,1-e|0,0-((e>>>0>1)+d|0)|0,0,0,l,i,0,0);P=(z-r|0)+t|0;e=v[k+116>>2];A=e;d=v[k+112>>2];j=e<<1|d>>>31;m=d<<1;C=j;e=j;i=v[k+140>>2];F=i;h=v[k+136>>2];j=i<<1|h>>>31;l=h<<1|v[k+132>>2]>>>31;i=l+m|0;d=e+j|0;h=i;d=h>>>0<l>>>0?d+1|0:d;e=d;d=d-(h>>>0<13927)|0;i=h-13927|0;q=d;K=d;l=0;z=l;d=n|65536;L=d;M=p;B=(d&2147483647)<<1|p>>>31;u=qma(q,l,B,0);d=mb;x=d;j=b;r=j<<1;d=c<<1|j>>>31;t=d;j=0;N=j;o=d;l=(e|0)==(q|0)&h>>>0>i>>>0|e>>>0>q>>>0;m=(e|0)==(C|0)&h>>>0<m>>>0|e>>>0<C>>>0;d=v[k+120>>2];h=v[k+124>>2]<<1|d>>>31;e=F>>>31|0;d=e+(d<<1|A>>>31)|0;j=h;j=d>>>0<e>>>0?j+1|0:j;e=d;d=m+d|0;j=d>>>0<e>>>0?j+1|0:j;e=d;d=l+d|0;l=d>>>0<e>>>0?j+1|0:j;e=d;d=d-1|0;G=l-!e|0;C=0;j=qma(o,H,G,C);e=j+u|0;h=mb+x|0;h=e>>>0<j>>>0?h+1|0:h;j=e;A=(h|0)==(x|0)&j>>>0<u>>>0|h>>>0<x>>>0;m=j;j=0;H=j;q=d;S=0;d=p;Q=c>>>31|0;x=Q|d<<1;e=qma(q,j,x,0);d=m+e|0;j=mb+h|0;j=d>>>0<e>>>0?j+1|0:j;p=d;n=j;e=(j|0)==(h|0)&d>>>0<m>>>0|j>>>0<h>>>0;d=e+A|0;l=0;l=d>>>0<e>>>0?1:l;e=qma(B,J,G,C);d=e+d|0;j=mb+l|0;m=d;d=d>>>0<e>>>0?j+1|0:j;l=qma(B,J,q,H);h=mb;u=qma(x,R,G,C);e=u+l|0;j=mb+h|0;j=e>>>0<u>>>0?j+1|0:j;u=e;e=j;j=(h|0)==(j|0)&l>>>0>u>>>0|h>>>0>j>>>0;l=m+e|0;d=d+j|0;h=l;l=h>>>0<e>>>0?d+1|0:d;m=p;e=0;d=m+e|0;j=n+u|0;j=d>>>0<e>>>0?j+1|0:j;e=j;n=(j|0)==(n|0)&d>>>0<m>>>0|j>>>0<n>>>0;h=h+n|0;j=l;A=h;l=h>>>0<n>>>0?j+1|0:j;m=d;n=e;u=i;h=qma(i,0,x,R);e=mb;i=qma(K,z,o,N);d=i+h|0;j=mb+e|0;j=d>>>0<i>>>0?j+1|0:j;i=d;e=(e|0)==(j|0)&h>>>0>d>>>0|e>>>0>j>>>0;h=j;p=A;F=e;O=r&-2;e=qma(q,H,O,0);d=e+d|0;j=mb+j|0;j=d>>>0<e>>>0?j+1|0:j;A=d;e=j;i=(j|0)==(h|0)&d>>>0<i>>>0|h>>>0>j>>>0;d=F+i|0;h=0;h=d>>>0<i>>>0?1:h;j=d;i=d+m|0;d=h+n|0;F=i;h=i;d=h>>>0<j>>>0?d+1|0:d;i=d;h=(d|0)==(n|0)&h>>>0<m>>>0|d>>>0<n>>>0;d=p+h|0;j=l;T=d;m=d>>>0<h>>>0?j+1|0:j;J=qma(B,J,u,U);B=mb;h=qma(G,C,O,V);d=h+J|0;j=mb+B|0;G=d;n=qma(K,z,x,R);l=d+n|0;h=d>>>0<h>>>0?j+1|0:j;d=h+mb|0;d=l>>>0<n>>>0?d+1|0:d;x=l;n=qma(o,N,q,H);j=l+n|0;l=mb+d|0;C=j;l=j>>>0<n>>>0?l+1|0:l;n=l;l=0;p=(d|0)==(n|0)&j>>>0<x>>>0|d>>>0>n>>>0;j=(d|0)==(h|0)&G>>>0>x>>>0|d>>>0<h>>>0;d=j+((h|0)==(B|0)&G>>>0<J>>>0|h>>>0<B>>>0)|0;h=0;d=p+d|0;h=F+n|0;j=(d|l)+i|0;q=h;d=h;j=d>>>0<n>>>0?j+1|0:j;p=j;h=(i|0)==(j|0)&d>>>0<F>>>0|i>>>0>j>>>0;d=h+T|0;j=m;B=d;i=d>>>0<h>>>0?j+1|0:j;H=qma(K,z,O,V);z=mb;h=qma(o,N,u,U);d=h+H|0;j=mb+z|0;j=d>>>0<h>>>0?j+1|0:j;l=j;j=0;h=(l|0)==(z|0)&d>>>0<H>>>0|l>>>0<z>>>0;d=l+A|0;j=(h|j)+e|0;j=d>>>0<l>>>0?j+1|0:j;h=d;d=j;j=(e|0)==(d|0)&h>>>0<A>>>0|d>>>0<e>>>0;l=d+C|0;m=0;n=m+h|0;e=n;l=m>>>0>e>>>0?l+1|0:l;e=(d|0)==(l|0)&e>>>0<h>>>0|d>>>0>l>>>0;d=j+e|0;j=0;j=d>>>0<e>>>0?1:j;e=d;d=q+d|0;j=j+p|0;j=d>>>0<e>>>0?j+1|0:j;e=j;j=(p|0)==(j|0)&d>>>0<q>>>0|j>>>0<p>>>0;h=j+B|0;l=i;l=h>>>0<j>>>0?l+1|0:l;i=l;c:{if((l|0)==131071|l>>>0<131071){j=M;l=L<<1|j>>>31;M=Q|j<<1;L=l|S;Qe(k+80|0,d,e,h,i,f,g,w,D);l=b<<17;b=0;c=v[k+88>>2];n=b-c|0;j=v[k+80>>2];q=(j|0)!=0;o=v[k+84>>2];m=q|(o|0)!=0;p=n-m|0;n=(l-(v[k+92>>2]+(b>>>0<c>>>0)|0)|0)-(m>>>0>n>>>0)|0;m=0-j|0;o=0-(o+q|0)|0;b=P+16382|0;break c}d=(e&1)<<31|d>>>1;j=h<<31|e>>>1;e=j;h=(i&1)<<31|h>>>1;i=i>>>1|0;Qe(k+96|0,d,j,h,i,f,g,w,D);n=0;m=v[k+104>>2];o=n-m|0;j=v[k+96>>2];l=(j|0)!=0;t=v[k+100>>2];r=l|(t|0)!=0;p=o-r|0;n=((b<<16)-(v[k+108>>2]+(m>>>0>n>>>0)|0)|0)-(o>>>0<r>>>0)|0;m=0-j|0;o=0-(l+t|0)|0;r=b;t=c;b=P+16383|0}if((b|0)>=32767){s=s|2147418112;b=0;c=0;break a}d:{if((b|0)>0){c=p;j=n<<1|c>>>31;p=c<<1|o>>>31;n=j;r=h;t=i&65535|b<<16;b=m;j=o<<1|b>>>31;b=b<<1;break d}if((b|0)<=-113){b=0;c=0;break a}kl(k- -64|0,d,e,h,i,1-b|0);ef(k+48|0,r,t,M,L,b+112|0);d=v[k+64>>2];e=v[k+68>>2];r=v[k+72>>2];t=v[k+76>>2];Qe(k+32|0,f,g,w,D,d,e,r,t);c=v[k+40>>2];i=c<<1;c=v[k+44>>2]<<1|c>>>31;n=v[k+36>>2];h=n;b=v[k+56>>2];n=h>>>31|i;i=b-n|0;l=v[k+60>>2]-((b>>>0<n>>>0)+c|0)|0;c=v[k+32>>2];h=h<<1|c>>>31;c=c<<1;m=v[k+52>>2];j=m;b=v[k+48>>2];j=(h|0)==(j|0)&c>>>0>b>>>0|h>>>0>j>>>0;p=i-j|0;n=l-(i>>>0<j>>>0)|0;i=b;b=i-c|0;j=m-((c>>>0>i>>>0)+h|0)|0}Qe(k+16|0,f,g,w,D,3,0,0,0);Qe(k,f,g,w,D,5,0,0,0);i=d;c=e;l=f;f=g;q=r;o=0;h=j+o|0;r=d&1;d=b+r|0;h=d>>>0<b>>>0?h+1|0:h;m=d;g=h;A=(h|0)==(f|0)&d>>>0>l>>>0|f>>>0<h>>>0;d=(h|0)==(o|0)&d>>>0<r>>>0|h>>>0<o>>>0;b=d+p|0;j=n;j=b>>>0<d>>>0?j+1|0:j;l=b;f=j;d=(l|0)==(w|0)&(j|0)==(D|0)?A:(D|0)==(j|0)&l>>>0>w>>>0|j>>>0>D>>>0;b=i+d|0;j=e;j=b>>>0<d>>>0?j+1|0:j;d=b;b=j;e=(j|0)==(c|0)&d>>>0<i>>>0|c>>>0>j>>>0;c=q+e|0;j=t;j=c>>>0<e>>>0?j+1|0:j;e=c;c=j;h=d;p=e;d=v[k+20>>2];i=(d|0)==(g|0)&y[k+16>>2]<m>>>0|d>>>0<g>>>0;d=v[k+28>>2];e=v[k+24>>2];i=j>>>0<2147418112&((e|0)==(l|0)&(d|0)==(f|0)?i:(d|0)==(f|0)&e>>>0<l>>>0|d>>>0<f>>>0);e=h+i|0;d=b;d=e>>>0<i>>>0?d+1|0:d;i=e;j=e;e=d;d=(d|0)==(b|0)&h>>>0>j>>>0|b>>>0>d>>>0;b=p+d|0;j=c;j=b>>>0<d>>>0?j+1|0:j;h=b;d=j;b=v[k+4>>2];g=(b|0)==(g|0)&y[k>>2]<m>>>0|b>>>0<g>>>0;b=v[k+12>>2];c=v[k+8>>2];c=d>>>0<2147418112&((c|0)==(l|0)&(b|0)==(f|0)?g:(b|0)==(f|0)&c>>>0<l>>>0|b>>>0<f>>>0);b=c+i|0;j=e;j=b>>>0<c>>>0?j+1|0:j;c=j;f=(e|0)==(j|0)&b>>>0<i>>>0|e>>>0>j>>>0;e=h+f|0;I=I|e;s=s|(e>>>0<f>>>0?d+1|0:d)}v[a>>2]=b;v[a+4>>2]=c;v[a+8>>2]=I;v[a+12>>2]=s;jb=k+336|0}function cla(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=jb-272|0;jb=e;Ic(b);g=jb-16|0;jb=g;i=g+8|0;h=e+112|0;gS(i,h);j=Hb(i);d=b;i=mc(d,$b(g,i));if((j|0)==(i|0)){_b(d,Hb(g+8|0))}jb=g+16|0;d=(i|0)==(j|0);if(!d){hS(h)}a:{b:{c:{d:{e:{f:{g:{if(!d){break g}if(!kS(e+112|0)){break g}if(!c){f=1;break g}Id(a,v[((w[e+228|0]|w[e+229|0]<<8)<<2)+23664>>2]);v[a+480208>>2]=v[a+480208>>2]|16777216;d=e+16|0;f=Ub(d,9126);Gb(a+1304436|0,f);yb(f);d=Ub(d,6401);Gb(a+1304448|0,d);yb(d);g=Ub(e+80|0,11249);v[113382]=0;R(189,e+96|0,g|0);d=v[113382];v[113382]=0;if((d|0)==1){break c}v[113382]=0;X(382,e+16|0,e+96|0,e+191|0,e+188|0);d=v[113382];v[113382]=0;if((d|0)==1){break d}d=e+16|0;Gb(a+1304460|0,d);yb(d);f=e+96|0;Ib(f);yb(g);Kc(a+1304484|0,((w[e+228|0]|w[e+229|0]<<8)<<2)+23712|0);Kc(a+1304472|0,v[((w[e+228|0]|w[e+229|0]<<8)<<2)+72496>>2]);v[a+1304496>>2]=4;Cg(f,2,e+112|4);Ec(d,f);Gb(a+1304400|0,d);yb(d);Cg(f,2,e+148|0);Ec(d,f);h:{i:{j:{if(Jt(d,5715)){v[113382]=0;U(13,e+96|0,4,e+16|0);d=v[113382];v[113382]=0;if((d|0)==1){break j}d=e+96|0;Gb(a+1304412|0,d);yb(d)}yb(e+16|0);u[a+480188>>1]=32;d=0;k:{while(1){g=(d<<5)+a|0;i=g+480280|0;Dg(i);l:{f=e+d|0;if(w[f+193|0]<=15){v[e+16>>2]=w[f+193|0]<<4|8;v[e+96>>2]=256;r=g+480284|0,s=v[Zd(e+16|0,e+96|0)>>2],u[r>>1]=s;break l}if(w[f+193|0]==16){u[g+480284>>1]=128;v[i>>2]=256;break l}if(w[f+193|0]!=255){break l}u[a+480188>>1]=d;break k}d=d+1|0;if((d|0)!=32){continue}break}d=x[a+480188>>1]}f=0;if(!(d&65535)){break g}v[e+16>>2]=w[e+225|0]<<2;v[e+96>>2]=256;r=a,s=v[Lb(e+16|0,e+96|0)>>2],v[r+480200>>2]=s;v[a+480196>>2]=w[e+226|0];v[a+480204>>2]=B(w[e+227|0],1e4);if(Nc(b,w[e+230|0]|w[e+231|0]<<8|(w[e+232|0]<<16|w[e+233|0]<<24))){Qp(Vb(a+484360|0),b,w[e+234|0]+1|0,255,254)}if(!Nc(b,w[e+240|0]|w[e+241|0]<<8|(w[e+242|0]<<16|w[e+243|0]<<24))){break g}u[a+480190>>1]=w[e+248|0]+1;j=e+48|0;d=1;i=1;while(1){g=jb-16|0;jb=g;f=jb-16|0;jb=f;h=g+8|0;l=e+16|0;fc(h,l,62);jb=f+16|0;k=Hb(h);f=b;h=mc(f,$b(g,h));if((k|0)==(h|0)){_b(f,Hb(g+8|0))}jb=g+16|0;f=(h|0)==(k|0);if(!f){g=jb-16|0;jb=g;Qb(l,0,62);jb=g+16|0}if(f){f=B(d,104)+a|0;g=f+484380|0;sd(g,0);Cg(e,2,e+16|0);h=e+96|0;Ec(h,e);v[113382]=0;Q(335,((d<<5)+a|0)+946304|0,h|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break e}d=e+96|0;yb(d);Jk(e,2,j);Ec(d,e);v[113382]=0;Q(336,f+484423|0,d|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break f}yb(e+96|0);d=f+484404|0;v[d>>2]=w[e+74|0]|w[e+75|0]<<8;m:{if(!Op(a)){break m}h=v[d>>2];d=0;while(1){if((h|0)==x[(d<<1)+23760>>1]){t[f+484417|0]=d<<4;break m}d=d+1|0;if((d|0)!=16){continue}break}}u[f+484412>>1]=64;v[g>>2]=w[e+61|0]|w[e+62|0]<<8|(w[e+63|0]<<16|w[e+64|0]<<24);if(w[e+73|0]&2){d=f+484414|0;u[d>>1]=x[d>>1]|1;v[g>>2]=v[g>>2]>>>1}v[f+484384>>2]=w[e+65|0]|w[e+66|0]<<8|(w[e+67|0]<<16|w[e+68|0]<<24);v[f+484388>>2]=(w[e+69|0]|w[e+70|0]<<8|(w[e+71|0]<<16|w[e+72|0]<<24))-1;if(t[e+73|0]&1){d=f+484414|0;u[d>>1]=x[d>>1]|2}n:{if(w[e+73|0]&4){t[e+96|0]=w[e+76|0];t[e|0]=64;r=f+484410|0,s=w[pc(e+96|0,e)|0]<<2,u[r>>1]=s;break n}d=f+484414|0;u[d>>1]=x[d>>1]|32768}o:{if(!(w[e+73|0]&8)){u[f+484408>>1]=128;break o}d=f+484414|0;u[d>>1]=x[d>>1]|32;m=f+484408|0;if(w[e+77|0]<=15){f=w[e+77|0];v[e>>2]=256;v[e+96>>2]=f<<4|8;f=v[Zd(e+96|0,e)>>2]}else{f=128}u[m>>1]=f;u[d>>1]=x[d>>1]&65279|(w[e+77|0]==16)<<8}i=i+1|0;d=i&65535;if(d>>>0<=x[a+480190>>1]){continue}}break}p:{if(!(c&2)){break p}if(!Nc(b,w[e+244|0]|w[e+245|0]<<8|(w[e+246|0]<<16|w[e+247|0]<<24))|!x[a+480190>>1]){break p}d=1;while(1){f=B(d&65535,104)+a|0;zg(Yc(e+16|0,u[f+484414>>1]&1?16:8,1,0,1),f+484380|0,b);d=d+1|0;if(x[a+480190>>1]>=(d&65535)>>>0){continue}break}}n=a+484344|0;dg(n,w[e+239|0]+1|0);f=Yo(a);d=jb-16|0;jb=d;v[d+12>>2]=0;ss(d+12|0,f);j=v[d+12>>2];jb=d+16|0;Nc(b,w[e+235|0]|w[e+236|0]<<8|(w[e+237|0]<<16|w[e+238|0]<<24));p=c&1;i=0;l=1;while(1){c=og(b);if(c>>>0>=3){td(e+16|0,b,c-2|0);q:{if(!p){break q}v[113382]=0;c=T(303,e+16|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break i}if(!c){break q}v[113382]=0;c=W(364,n|0,i&65535,64)|0;d=v[113382];v[113382]=0;if((d|0)==1){break i}k=0;if(!c){break q}while(1){c=Zb(n,i);v[113382]=0;q=Q(458,c|0,k|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break i}r:{s:while(1){t:{v[113382]=0;c=T(409,e+16|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break t}if(!c){break r}d=c&31;if(d>>>0>=x[a+480188>>1]){break r}f=B(d,6)+q|0;if(c&32){v[113382]=0;R(433,e+96|0,e+16|0);d=v[113382];v[113382]=0;if((d|0)==1){break i}d=e+96|0;g=Zc(d);h=w[d|0];if(h){m=d;d=(h&127)-1|0;t[m|0]=d;t[f|0]=(B((d&240)>>>4|0,12)+(d&15)|0)+13;v[113382]=0;d=T(573,f|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break i}l=d&l}t[f+1|0]=w[g|0]}if(!(c&64)){continue}t[f+2|0]=0;t[f+3|0]=0;g=f+5|0;while(1){v[113382]=0;c=Q(228,e+16|0,2)|0;d=v[113382];v[113382]=0;u:{v:{w:{x:{y:{z:{A:{B:{C:{D:{E:{if((d|0)!=1){if(!c){continue s}o=w[g|0];c=w[f+3|0];v[113382]=0;R(433,e+96|0,e+16|0);d=v[113382];v[113382]=0;if((d|0)==1){break i}d=e+96|0;m=d;h=w[Zc(d)|0];t[g|0]=h;d=w[(w[d|0]&31)+23792|0];t[f+3|0]=d;switch(d-2|0){case 4:case 5:break y;case 18:break z;case 13:break A;case 17:break B;case 11:break C;case 1:break D;case 0:break E;default:break w}}break i}if(h>>>0<224){break u}break v}if(h>>>0>=224){break v}break u}v[113382]=0;t[e|0]=64;d=Q(415,g|0,e|0)|0;h=v[113382];v[113382]=0;if((h|0)!=1){t[g|0]=w[d|0];v[113382]=0;d=Q(574,j|0,1)|0;h=v[113382];v[113382]=0;if((h|0)==1){break i}if(!d){break x}t[f+2|0]=1;t[f+4|0]=w[g|0];t[f+3|0]=c;t[g|0]=o;d=c;break w}break i}F:{switch(((h&240)>>>4|0)-8|0){case 0:t[f+3|0]=2;t[g|0]=h&15|224;break u;case 1:t[f+3|0]=3;t[g|0]=h&15|224;break u;default:break F}}v[113382]=0;d=Q(575,j|0,19)|0;h=v[113382];v[113382]=0;if((h|0)==1){break i}if(d){break x}v[113382]=0;Z(576,f|0);d=v[113382];v[113382]=0;if((d|0)!=1){break x}break i}v[113382]=0;d=Q(575,j|0,15)|0;h=v[113382];v[113382]=0;if((h|0)==1){break i}if(d){break x}v[113382]=0;d=Q(575,j|0,19)|0;h=v[113382];v[113382]=0;if((h|0)==1){break i}if(!d){break x}t[f+3|0]=19;t[g|0]=w[g|0]&15|144;break u}if((h|0)==1){t[g|0]=145;break u}if((h&240)==128){v[113382]=0;d=Q(575,j|0,20)|0;h=v[113382];v[113382]=0;if((h|0)==1){break i}if(d){break x}t[f+3|0]=19;break u}t[f+3|0]=0;break u}d=h&240;if(!d){break u}t[g|0]=d}d=w[f+3|0]}if((d&255)!=20){break u}d=w[g|0];if(w[f+2|0]|(d&240)!=128){break u}t[f+2|0]=2;t[f+4|0]=(((d&15)<<6|8)>>>0)/15;t[f+3|0]=c;t[g|0]=o;break u}t[g|0]=223}if(w[m|0]&32){continue}break}continue}break}break i}k=k+1|0;if((k|0)!=64){continue}break}}Bb(e+16|0)}c=w[e+239|0]>i>>>0;i=i+1|0;if(c){continue}break}break h}f=P()|0;O()|0;yb(e+16|0);break a}f=P()|0;O()|0;Bb(e+16|0);break a}c=a;if(v[a+480180>>2]!=1){d=v[a+480208>>2]&-8454145}else{d=v[a+480208>>2]&-8454145|(x[a+480188>>1]==4?l&1?8454144:0:0)}v[c+480208>>2]=d;f=1;if(!(w[e+253|0]|w[e+254|0]<<8|(w[e+255|0]<<16|w[e+256|0]<<24))){break g}if(!Nc(b,w[e+249|0]|w[e+250|0]<<8|(w[e+251|0]<<16|w[e+252|0]<<24))){break g}Wy(a+1304424|0,b,w[e+253|0]|w[e+254|0]<<8|(w[e+255|0]<<16|w[e+256|0]<<24),4)}jb=e+272|0;return f|0}f=P()|0;O()|0;yb(e+96|0);break a}f=P()|0;O()|0;yb(e+96|0);break a}f=P()|0;O()|0;Ib(e+96|0);break b}f=P()|0;O()|0}yb(g)}S(f|0);L()}function zia(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,y=0,z=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,M=0,N=0,Q=0,V=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0;d=jb-336|0;jb=d;a:{if(!Nc(b,1080)){break a}if(!wn(b,d+332|0)){break a}Id(a,1);m=jQ(d+312|0);if(!iQ(d+332|0,m)){break a}h=x[m+8>>1];f=h;if(!f|f>>>0>127){break a}if(!c){e=1;break a}u[a+480188>>1]=h;s=w[m+12|0];V=w[m+11|0];g=w[m+10|0];K=1;if(!Vd(d+332|0,24088)){K=Vd(d+332|0,24093)}if(w[m+13|0]){Nb(a+1074312|0,5,1);h=x[a+480188>>1]}e=d+332|0;y=Vd(e,12755);f=1;if(!Vd(e,13422)){f=Vd(d+332|0,9607)}I=a+480188|0;E=(h&65535)==8&(V|0)!=0;Nc(b,0);dA(b,a+1304400|0,20);u[a+480190>>1]=31;n=(g|0)!=0;e=1;g=y;while(1){o=B(e,104)+a|0;h=o+484380|0;r=wz(b,d+176|0,h,((e<<5)+a|0)+946304|0,x[a+480188>>1]==4);F=v[h>>2];b:{if(f){t[o+484417|0]=0-(w[d+200|0]<<3);break b}n=F>>>0<65536&n}c:{if(!(!(w[d+198|0]|w[d+199|0]<<8)|(w[d+204|0]|w[d+205|0]<<8))){ca=1;break c}if(w[d+198|0]|w[d+199|0]<<8){break c}X=w[d+201|0]==64|X}h=g&1;g=0;d:{if(!h){break d}h=w[d+198|0]|w[d+199|0]<<8;l=(((h<<8|h>>>8)&65535)<<1)+l|0;if(w[d+200|0]){break d}if(!(w[d+198|0]|w[d+199|0]<<8)){g=1;break d}g=w[d+201|0]==64}M=r+M|0;i=i+F|0;e=e+1|0;if((e|0)!=32){continue}break}e:{f:{g:{h:{i:{j:{k:{l:{F=v[m+4>>2];if(F>>>0>=M>>>0){o=d+176|0;vz(b,o);_b(b,4);z=o|1;e=w[z|0];f=128;k=a+484360|0;En(Vb(k),o|2,128,65535,65535);r=!e&g;h=r?l:0;e=w[o|0];m:{if(e>>>0>128){break m}f=e;if(e){break m}g=128;while(1){e=g-1|0;if(!x[rc(Vb(k),e)>>1]){f=1;g=e;if(e>>>0>1){continue}break m}break}f=g}N=(s|0)!=0;C=gQ(b,Vb(k),f&65535,i,I,h,0);if(!(!r|x[a+480188>>1]!=8)){v[m>>2]=7297;N=1}n:{if(!E){break n}e=Vb(k);ea=d,fa=ac(e),v[ea+160>>2]=fa;ea=d,fa=bc(e),v[ea+144>>2]=fa;if(!Jb(d+160|0,d+144|0)){break n}while(1){g=d+160|0;e=v[g>>2];u[e>>1]=x[e>>1]>>>1;re(g);if(Jb(g,d+144|0)){continue}break}}Ne(Vb(k),w[z|0]);o=f-1&65535;o:{if(o>>>0>=w[z|0]){e=x[I>>1];if(w[z|0]!=120|(e|0)!=4){break o}}Ne(Vb(k),0);e=x[I>>1]}v[a+480260>>2]=56;v[a+480264>>2]=13696;v[a+480204>>2]=125e4;v[a+480196>>2]=6;f=Yb(256/((e&65535)>>>0)|0,32,128);v[a+480208>>2]=0;v[a+480228>>2]=f;mj(a,0);t[d+175|0]=0;D=1;Y=1;if(!(n&1)){p:{if(!C){e=y;break p}r=d+160|5;e=y;n=0;l=0;while(1){g=0;f=0;while(1){i=Oh(d+160|0);nt(b,i);s=iS(i);h=0;q:{r:{s:{t:{u:{k=w[d+163|0];if((k-7&255)>>>0<3){break u}i=w[d+165|0];if((k|0)==14&i>>>0>1){break t}if(!((k|0)==15&(i&255)>>>0>31)){h=s?e:0;if((k|0)!=13){break u}f=f+1|0;if((f&65535)>>>0<2){break r}}h=0;break q}if((k|0)==8){break s}if((k|0)!=14){break r}i=w[d+165|0]}if((i&240)!=128){break r}t[d+144|0]=i<<4;ea=d,fa=w[th(d+175|0,d+144|0)|0],t[ea+175|0]=fa;break r}ea=d,fa=w[th(d+175|0,r)|0],t[ea+175|0]=fa;e=t[d+165|0];if((e|0)>=0){l=1;break q}n=(e|0)!=-92&(e&255)>>>0>143|n}}e=h;D=s&D;g=g+1|0;if((g|0)!=256){continue}break}p=p+1|0;if(C>>>0>(p&65535)>>>0){continue}break}p=0;if((l^-1|n)&1){break p}p=w[d+175|0]>47}Y=e&1}Nc(b,1084);g=x[a+480188>>1];G=a+484344|0;e=C+E|0;f=e&65535;dg(G,f);Z=E?4:g;q=a+1074312|0;v:{w:{x:{y:{z:{if(!f){p=0;break z}r=p^1;Q=c&1;n=Z&65535;k=e&65535;l=0;p=0;while(1){A:{B:{if(E){e=(l&65534)>>>1|0;f=l&1;if(!f){if(!Og(G,e,64)){break A}}e=Bf(Zb(G,e),0,f<<2);break B}if(!Og(G,l&65535,64)){break A}e=Bf(Zb(G,l),0,0)}if(!e|!Q){break A}f=x[a+480188>>1];t[d+144|0]=0;g=d+144|0;H=Ut(d+160|0,f,g);f=x[a+480188>>1];v[113382]=0;t[d+64|0]=0;J=W(847,g|0,f|0,d- -64|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break y}C=0;while(1){i=0;s=0;h=0;if(n){while(1){v[113382]=0;j=B(h,6)+e|0;R(848,b|0,j|0);f=v[113382];v[113382]=0;C:{D:{E:{if((f|0)==1){break E}f=w[j+3|0];F:{G:{H:{if(!f){if(w[j+5|0]){break H}break G}if(!V){break H}I:{switch(f-14|0){case 0:t[j+3|0]=0;t[j+5|0]=0;break H;case 1:break I;default:break H}}if(w[j+5|0]<32){break H}t[j+5|0]=31}vj(j);f=1;J:{K:{L:{g=w[j+3|0];switch(g-14|0){case 2:break F;case 0:break K;case 3:break L;default:break J}}p=w[j+5|0]<100|p;s=1;break G}if(!Y){break G}t[j+5|0]=0;break G}if(!((g|0)!=9|r)){f=w[j+5|0];if((f|0)==164){t[j+3|0]=20;t[j+5|0]=145;break G}v[113382]=0;g=T(849,f<<1)|0;f=v[113382];v[113382]=0;if((f|0)==1){break E}t[j+5|0]=g;break G}if((g|0)!=19){break G}f=w[j+5|0];if(f>>>0>15){break G}f=f&1;g=!f;da=!f;f=_&1;_=(f|0)==(g|0)?_:da;$=((f|0)!=(g|0))+$|0}f=i}if(w[j|0]){break D}if(!w[j+1|0]|E){break C}if(!w[uc(H,h)|0]){break C}if(w[uc(H,h)|0]==w[j+1|0]){break C}g=uc(J,h);i=w[g|0]+1|0;t[g|0]=i;if((i&255)>>>0<4){break C}v[113382]=0;W(439,q|0,85,1)|0;g=v[113382];v[113382]=0;if((g|0)!=1){break C}}e=P()|0;O()|0;$d(J);break x}ea=uc(J,h),fa=0,t[ea|0]=fa}g=w[j+1|0];if(g){ea=uc(H,h),fa=g,t[ea|0]=fa}i=f;h=h+1|0;if((n|0)!=(h|0)){continue}break}}aa=i&s|aa;e=B(x[I>>1],6)+e|0;C=C+1|0;if((C|0)!=64){continue}break}$d(J);$d(H);l=l+1|0;if((k|0)!=(l|0)){continue}}break}Q=k<<8}M:{if((D^-1|ca)&1){break M}N:{if(Vd(d+332|0,12755)){break N}if(Vd(d+332|0,13427)){break N}if(!Vd(d+332|0,9602)){break M}}v[a+480208>>2]=v[a+480208>>2]|2162688;Nb(q,85,1);Nb(q,91,1);Nb(q,92,1);O:{if(w[d+175|0]>47){break O}Nb(q,84,1);if(w[z|0]==127){break O}Nb(q,83,1)}if(!D){break v}break w}if(D){break w}if(y^1|w[z|0]!=127|w[z|0]+1>>>0<o>>>0){break v}v[m>>2]=4626;break v}e=P()|0;O()|0}$d(H);break e}if(($|0)>6|N){break v}v[a+480208>>2]=v[a+480208>>2]|8388608}if((y|N)==1){Nb(q,89,1)}if(K){Nb(q,84,1)}if(c&2){Nc(b,B(Z&65535,Q)+1084|0);g=(y&D^1|X)&1;e=1;while(1){f=B(e,104)+a|0;h=f+484380|0;if(v[h>>2]){i=d+160|0;if(K){c=2}else{c=fQ(b,9799)?11:0}i=Yc(i,8,1,0,c);c=v[b+8>>2]+ZR(i,v[h>>2])|0;if(!g){ea=h,fa=v[Vc(h,f+484388|0)>>2],v[ea>>2]=fa}zg(i,h,b);Nc(b,c)}e=e+1|0;if((e|0)!=32){continue}break}}P:{if((p&y^-1|aa)&1){break P}c=eQ(d+120|0,0);b=v[c+20>>2];v[d+40>>2]=v[c+16>>2];v[d+44>>2]=b;b=v[c+12>>2];v[d+32>>2]=v[c+8>>2];v[d+36>>2]=b;b=v[c+4>>2];v[d+24>>2]=v[c>>2];v[d+28>>2]=b;b=d+160|0;Hs(b,a,0,d+24|0);ba=A[v[b>>2]>>3];Il(b);if(ba<600){break P}Nb(q,5,1);c=dQ(d+96|0,ba);b=v[c+20>>2];v[d+16>>2]=v[c+16>>2];v[d+20>>2]=b;b=v[c+12>>2];v[d+8>>2]=v[c+8>>2];v[d+12>>2]=b;b=v[c+4>>2];v[d>>2]=v[c>>2];v[d+4>>2]=b;c=d+160|0;Hs(c,a,0,d);b=w[v[c>>2]+26|0];Il(c);if(b){ig(q,5);break P}v[m>>2]=13111}c=d+332|0;b=c;e=jc(b);if((b|0)!=(e|0)){while(1){f=w[c|0];t[b|0]=f>>>0>32?f:32;b=b+1|0;c=c+1|0;if((e|0)!=(c|0)){continue}break}}f=Ub(d+80|0,13299);v[113382]=0;R(189,d+144|0,f|0);b=v[113382];v[113382]=0;if((b|0)==1){break l}c=d+332|0;b=jc(c);v[113382]=0;c=W(850,d+48|0,c|0,b|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break k}v[113382]=0;U(13,d- -64|0,1,c|0);b=v[113382];v[113382]=0;if((b|0)==1){break j}v[113382]=0;U(217,d+160|0,d+144|0,d- -64|0);b=v[113382];v[113382]=0;if((b|0)==1){break i}b=d+160|0;Gb(a+1304436|0,b);yb(b);yb(d- -64|0);yb(c);Ib(d+144|0);yb(f);b=Ub(b,8287);Gb(a+1304448|0,b);yb(b);b=v[m>>2];if(b){Kc(a+1304460|0,b)}v[a+1304496>>2]=2}e=F>>>0>=M>>>0;break a}e=P()|0;O()|0;break f}e=P()|0;O()|0;break g}e=P()|0;O()|0;break h}e=P()|0;O()|0;yb(d- -64|0)}yb(c)}Ib(d+144|0)}yb(f)}S(e|0);L()}jb=d+336|0;return e|0}function jU(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,y=0,z=0;e=jb-208|0;jb=e;Ic(b);a:{b:{c:{d:{e:{if(!GB(b,e+160|0)){break e}if(!HB(e+160|0)){break e}if(!c){o=1;break e}Id(a,2048);vi(a);d=Ub(e+128|0,11466);v[113382]=0;R(189,e+144|0,d|0);f=v[113382];v[113382]=0;if((f|0)==1){break c}v[113382]=0;k=e+160|3;U(349,e+48|0,e+144|0,k|0);f=v[113382];v[113382]=0;if((f|0)==1){break d}f=e+48|0;Gb(a+1304436|0,f);yb(f);g=e+144|0;Ib(g);yb(d);d=Ub(f,7109);Gb(a+1304448|0,d);yb(d);v[a+1304496>>2]=4;u[a+480188>>1]=w[e+200|0];u[a+480190>>1]=w[e+196|0];Cg(g,2,e+160|4);Ec(f,g);Gb(a+1304400|0,f);yb(f);if(w[k|0]<=8){u[a+480188>>1]=4;mg(b,1);mj(a,1)}f=w[k|0];f:{if(w[k|0]>=11){f=f>>>0>11?32:16;d=0;g=0;while(1){h=Au(b);g:{if((h|0)==100){v[((d<<5)+a|0)+480280>>2]=256;break g}v[e+48>>2]=(h<<1)+128;v[e+144>>2]=0;v[e+32>>2]=256;y=((d<<5)+a|0)+480284|0,z=v[Ok(e+48|0,e+144|0,e+32|0)>>2],u[y>>1]=z}g=g+1|0;d=g&65535;if(f>>>0>d>>>0){continue}break}break f}if(f>>>0<9){break f}FB(b,e+48|0);d=0;while(1){u[((d<<5)+a|0)+480284>>1]=t[(e+48|0)+d|0]&1?64:192;d=d+1|0;if((d|0)!=16){continue}break}}h:{if(w[k|0]>=13){g=e+48|0;tu(g,b);h=Zc(g);d=a;f=w[g|0];if(f>>>0<=31){t[g|0]=125;f=125}v[d+480204>>2]=B(f,1e4);v[a+480196>>2]=w[h|0];break h}v[a+480196>>2]=6;v[a+480204>>2]=125e4}f=a+484360|0;lg(Vb(f),w[e+197|0]);m=Sl(e+144|0);p=v[b+8>>2];q=w[k|0];i:{j:{k:{l:{if(w[k|0]<14){break l}d=w[e+197|0];v[113382]=0;R(350,m|0,d|0);d=v[113382];v[113382]=0;if((d|0)!=1){break l}a=P()|0;O()|0;break k}m:{n:{o:{p:{q:{r:{s:{t:{u:{if(w[e+197|0]){d=0;while(1){y=rc(Vb(f),d),z=d,u[y>>1]=z;if(w[k|0]>=14){v[113382]=0;g=T(323,b|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break u}y=rc(m,d),z=g,u[y>>1]=z}g=x[a+480188>>1];v[113382]=0;Q(304,b|0,g<<1)|0;g=v[113382];v[113382]=0;if((g|0)==1){break u}d=d+1|0;if(d>>>0<w[e+197|0]){continue}break}}f=0;v:{w:{if(w[k|0]==10){n=v[b+8>>2];f=0;x:{if(!x[a+480190>>1]){break x}g=1;while(1){v[113382]=0;f=Q(351,b|0,e+48|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break w}y:{if(!f){break y}j=w[e+196|0];d=0;h=e+48|0;z:{if(w[h|0]>1){break z}f=h+46|0;if(j>>>0<(w[f|0]|w[f+1|0]<<8|(w[f+2|0]<<16|w[f+3|0]<<24))>>>0){break z}f=h+50|0;if((w[f|0]|w[f+1|0]<<8|(w[f+2|0]<<16|w[f+3|0]<<24))>>>0>1048576|w[h+56|0]>64){break z}j=h+57|0;if((w[j|0]|w[j+1|0]<<8|(w[j+2|0]<<16|w[j+3|0]<<24))>>>0>(w[f|0]|w[f+1|0]<<8|(w[f+2|0]<<16|w[f+3|0]<<24))>>>0){break z}d=h+61|0;d=(w[d|0]|w[d+1|0]<<8|(w[d+2|0]<<16|w[d+3|0]<<24))>>>0<=(w[f|0]|w[f+1|0]<<8|(w[f+2|0]<<16|w[f+3|0]<<24))>>>0}if(d){break y}f=1;break x}g=g+1|0;if(x[a+480190>>1]>=(g&65535)>>>0){continue}break}f=0}v[113382]=0;Q(226,b|0,n|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break v}}d=x[a+480190>>1];v[113382]=0;v[e+48>>2]=0;n=W(352,e+32|0,d|0,e+48|0)|0;g=v[113382];v[113382]=0;d=1;if((g|0)!=1){if(x[a+480190>>1]){j=f?59:65;h=e+48|1;g=1;while(1){A:{if(w[k|0]<=9){v[113382]=0;Q(353,b|0,e+48|0)|0;i=v[113382];v[113382]=0;B:{C:{D:{if((i|0)==1){break D}v[113382]=0;R(354,e+48|0,(B(d,104)+a|0)+484380|0);i=v[113382];v[113382]=0;if((i|0)==1){break D}v[113382]=0;U(355,e|0,2,h|0);i=v[113382];v[113382]=0;if((i|0)==1){break C}v[113382]=0;R(356,e+16|0,e|0);i=v[113382];v[113382]=0;if((i|0)==1){break C}v[113382]=0;Q(335,((d<<5)+a|0)+946304|0,e+16|0)|0;i=v[113382];v[113382]=0;if((i|0)==1){break B}break A}a=P()|0;O()|0;break m}a=P()|0;O()|0;break m}a=P()|0;O()|0;yb(e+16|0);break m}v[113382]=0;W(357,b|0,e+48|0,j|0)|0;i=v[113382];v[113382]=0;if((i|0)==1){break n}v[113382]=0;U(358,e+48|0,(B(d,104)+a|0)+484380|0,f|0);i=v[113382];v[113382]=0;if((i|0)==1){break n}v[113382]=0;U(355,e|0,2,h|0);i=v[113382];v[113382]=0;if((i|0)==1){break o}v[113382]=0;R(356,e+16|0,e|0);i=v[113382];v[113382]=0;if((i|0)==1){break o}v[113382]=0;Q(335,((d<<5)+a|0)+946304|0,e+16|0)|0;i=v[113382];v[113382]=0;if((i|0)==1){break p}}yb(e+16|0);i=w[e+94|0]|w[e+95|0]<<8|(w[e+96|0]<<16|w[e+97|0]<<24);y=Pb(n,d-1|0),z=i,v[y>>2]=z;g=g+1|0;d=g&65535;if(d>>>0<=x[a+480190>>1]){continue}break}}j=eq(e+16|0);f=w[e+198|0]|w[e+199|0]<<8;v[113382]=0;o=W(359,b|0,j|0,f|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break t}if(!o){break i}f=0;E:{if(!id(j)){f=ac(j);d=bc(j);v[113382]=0;f=Q(360,f|0,d|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break E}v[e+48>>2]=f;f=v[e+48>>2];f=w[f|0]|w[f+1|0]<<8}v[113382]=0;d=f;i=Q(361,e|0,d|0)|0;g=v[113382];v[113382]=0;if((g|0)!=1){F:{if(d){g=0;while(1){v[113382]=0;h=T(323,b|0)|0;l=v[113382];v[113382]=0;if((l|0)==1){break s}v[113382]=0;Q(304,b|0,1)|0;l=v[113382];v[113382]=0;if((l|0)==1){break s}if(h){l=w[k|0];v[113382]=0;U(307,e+48|0,b|0,B(h,3)+((l|0)==1?3:0)|0);h=v[113382];v[113382]=0;if((h|0)==1){break F}h=e+48|0;Qd(sc(i,g),h);Bb(h)}g=g+1|0;if((d|0)!=(g|0)){continue}break}}G:{if(!(c&2)){break G}h=1;l=Yc(e+48|0,8,1,0,1);if(!x[a+480190>>1]){break G}g=1;while(1){v[113382]=0;d=Q(228,b|0,1)|0;r=v[113382];v[113382]=0;H:{I:{if((r|0)!=1){if(!d){break G}d=0;if(!x[a+480190>>1]){break H}r=v[b+8>>2];while(1){J:{if(v[Pb(n,d)>>2]!=(h|0)){d=d+1|0;break J}v[113382]=0;Q(226,b|0,r|0)|0;s=v[113382];v[113382]=0;if((s|0)==1){break I}v[113382]=0;d=d+1|0;W(362,l|0,(B(d,104)+a|0)+484380|0,b|0)|0;s=v[113382];v[113382]=0;if((s|0)==1){break I}}if(x[a+480190>>1]>d>>>0){continue}break}break H}a=P()|0;O()|0;break r}a=P()|0;O()|0;break r}g=g+1|0;h=g&65535;if(h>>>0<=x[a+480190>>1]){continue}break}}if(!(c&1)){break j}c=w[e+197|0];h=0;v[113382]=0;l=a+484344|0;R(363,l|0,c|0);c=v[113382];v[113382]=0;K:{if((c|0)!=1){if(!w[e+197|0]){break j}p=p+((q>>>0>13)<<1)|0;while(1){L:{g=64;if(oc(m)>>>0>h>>>0){g=x[rc(m,h)>>1]}v[113382]=0;c=W(364,l|0,h&65535,g&65535)|0;d=v[113382];v[113382]=0;if((d|0)==1){break K}M:{if(c){c=x[a+480188>>1];d=w[k|0];v[113382]=0;Q(226,b|0,p+B(((d>>>0>13)<<1)+(c<<1)|0,h)|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break K}c=eq(e+48|0);d=x[a+480188>>1];v[113382]=0;d=W(359,b|0,c|0,d|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break M}N:{if(!d){break N}d=0;if(!x[a+480188>>1]){break N}while(1){O:{g=rc(c,d);if(!(w[g|0]|w[g+1|0]<<8)){break O}g=rc(c,d);if((w[g|0]|w[g+1|0]<<8)>>>0>(w[e+198|0]|w[e+199|0]<<8)>>>0){break O}g=rc(c,d);g=rc(j,(w[g|0]|w[g+1|0]<<8)-1|0);g=w[g|0]|w[g+1|0]<<8;if(!g|f>>>0<g>>>0){break O}q=Zb(l,h);g=sc(i,g-1&65535);v[113382]=0;U(365,q|0,d&65535,g|0);g=v[113382];v[113382]=0;if((g|0)!=1){break O}break L}d=d+1|0;if(d>>>0<x[a+480188>>1]){continue}break}}Aj(c)}h=h+1|0;if(h>>>0>=w[e+197|0]){break j}continue}}break}a=P()|0;O()|0;Aj(c);break r}a=P()|0;O()|0;break r}a=P()|0;O()|0;break r}a=P()|0;O()|0;break r}a=P()|0;O()|0;break q}a=P()|0;O()|0;break q}a=P()|0;O()|0;break k}a=P()|0;O()|0;break k}a=P()|0;O()|0;break k}a=P()|0;O()|0;break k}a=P()|0;O()|0;break q}a=P()|0;O()|0}cd(i)}Aj(j);break m}a=P()|0;O()|0;yb(e+16|0);break m}a=P()|0;O()|0;break m}a=P()|0;O()|0}ze(n)}nf(m);break a}cd(i)}Aj(j);ze(n);nf(m)}jb=e+208|0;return o|0}a=P()|0;O()|0;Ib(e+144|0);break b}a=P()|0;O()|0}yb(d)}S(a|0);L()}function mha(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=jb-272|0;jb=d;Ic(b);h=jb-16|0;jb=h;i=h+8|0;j=d+120|0;XO(i,j);f=Hb(i);e=b;i=mc(e,$b(h,i));if((f|0)==(i|0)){_b(e,Hb(h+8|0))}jb=h+16|0;e=(f|0)==(i|0);if(!e){YO(j)}a:{b:{c:{d:{e:{if(!e){break e}if(!hP(d+120|0)){break e}if(!c){g=1;break e}Id(a,4194304);e=d+40|0;g=Ub(e,13070);Gb(a+1304436|0,g);yb(g);g=Ub(e,6225);Gb(a+1304448|0,g);yb(g);v[a+1304496>>2]=4;m=a,n=Ed(w[d+198|0]|w[d+199|0]<<8,w[d+200|0]|w[d+201|0]<<8,127),u[m+480188>>1]=n;g=w[d+189|0];v[a+480228>>2]=(g|0)==255?48:g;v[a+480196>>2]=w[d+187|0];v[a+480204>>2]=B(w[d+188|0],1e4);g=d+104|0;_e(g,d+120|4,59,3);Ec(e,g);Gb(a+1304400|0,e);yb(e);f:{if((w[d+202|0]|w[d+203|0]<<8|(w[d+204|0]<<16|w[d+205|0]<<24))>>>0<5){break f}if(!Nc(b,(w[d+202|0]|w[d+203|0]<<8|(w[d+204|0]<<16|w[d+205|0]<<24))-4|0)){break f}if(!sh(b,10102)){break f}Qp(Vb(a+484360|0),b,w[d+192|0]|w[d+193|0]<<8,65535,65535)}g:{if((w[d+206|0]|w[d+207|0]<<8|(w[d+208|0]<<16|w[d+209|0]<<24))>>>0<5){break g}if(!Nc(b,(w[d+206|0]|w[d+207|0]<<8|(w[d+208|0]<<16|w[d+209|0]<<24))-4|0)){break g}if(!sh(b,9758)){break g}g=0;while(1){e=(g<<5)+a|0;Dg(e+480280|0);m=e+480284|0,n=((((le(b)^-1)&15)<<8|8)>>>0)/15|0,u[m>>1]=n;g=g+1|0;if((g|0)!=32){continue}break}}h:{if((w[d+214|0]|w[d+215|0]<<8|(w[d+216|0]<<16|w[d+217|0]<<24))>>>0<5){break h}if(!Nc(b,(w[d+214|0]|w[d+215|0]<<8|(w[d+216|0]<<16|w[d+217|0]<<24))-4|0)){break h}if(!sh(b,10034)){break h}td(d+104|0,b,(w[d+196|0]|w[d+197|0]<<8)<<6);i:{if(!(w[d+196|0]|w[d+197|0]<<8)){break i}g=c&2;h=a+480190|0;i=d+53|0;while(1){v[113382]=0;e=Q(942,d+104|0,d+40|0)|0;j=v[113382];v[113382]=0;if((j|0)==1){break d}if(!e){break i}e=w[d+85|0]|w[d+86|0]<<8;u[d+38>>1]=e;j:{if((e-1&65535)>>>0>3998){break j}if(Be((B(e,104)+a|0)+484380|0)){break j}v[113382]=0;e=Q(408,h|0,d+38|0)|0;j=v[113382];v[113382]=0;if((j|0)==1){break c}u[a+480190>>1]=x[e>>1];v[113382]=0;R(943,d+40|0,(B(x[d+38>>1],104)+a|0)+484380|0);e=v[113382];v[113382]=0;if((e|0)==1){break c}v[113382]=0;U(944,d+8|0,1,i|0);e=v[113382];v[113382]=0;k:{l:{if((e|0)==1){break l}v[113382]=0;R(356,d+24|0,d+8|0);e=v[113382];v[113382]=0;if((e|0)==1){break l}v[113382]=0;Q(335,((x[d+38>>1]<<5)+a|0)+946304|0,d+24|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break k}yb(d+24|0);if(!g){break j}e=w[d+77|0]|w[d+78|0]<<8|(w[d+79|0]<<16|w[d+80|0]<<24);v[113382]=0;Q(226,b|0,e|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break c}v[113382]=0;R(945,d+24|0,d+40|0);e=v[113382];v[113382]=0;if((e|0)!=1){v[113382]=0;W(362,d+24|0,(B(x[d+38>>1],104)+a|0)+484380|0,b|0)|0;e=v[113382];v[113382]=0;if((e|0)!=1){break j}}b=P()|0;O()|0;break b}b=P()|0;O()|0;break b}b=P()|0;O()|0;yb(d+24|0);break b}k=k+1|0;if((k&65535)>>>0<(w[d+196|0]|w[d+197|0]<<8)>>>0){continue}break}}Bb(d+104|0)}g=1;if(!(c&1)){break e}m:{if((w[d+210|0]|w[d+211|0]<<8|(w[d+212|0]<<16|w[d+213|0]<<24))>>>0<5){break m}if(!Nc(b,(w[d+210|0]|w[d+211|0]<<8|(w[d+212|0]<<16|w[d+213|0]<<24))-4|0)){break m}if(!sh(b,9637)){break m}j=a+484344|0;dg(j,w[d+194|0]|w[d+195|0]<<8);if(!(w[d+194|0]|w[d+195|0]<<8)){break m}i=d+24|2;h=0;while(1){if(!Gt(b,d+24|0)){break m}if((w[d+24|0]|w[d+25|0]<<8)>>>0>3){td(d+40|0,b,((w[d+24|0]|w[d+25|0]<<8)+15&131056)-4|0);c=w[i|0];v[113382]=0;c=W(364,j|0,h&65535,c|0)|0;e=v[113382];v[113382]=0;n:{if((e|0)!=1){o:{k=0;if(!c){break n}while(1){v[113382]=0;c=Q(228,d+40|0,1)|0;e=v[113382];v[113382]=0;p:{q:{r:{if((e|0)!=1){if(!c|w[i|0]<=k>>>0){break q}v[113382]=0;e=T(409,d+40|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break o}if(e){break r}k=k+1|0;continue}break o}c=Zb(j,h);u[d+104>>1]=e&31;f=x[a+480188>>1];v[113382]=0;u[d+8>>1]=f-1;f=Q(438,d+104|0,d+8|0)|0;l=v[113382];v[113382]=0;if((l|0)==1){break o}f=x[f>>1];v[113382]=0;c=W(432,c|0,k|0,f|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break o}if(e&128){v[113382]=0;R(433,d+104|0,d+40|0);f=v[113382];v[113382]=0;if((f|0)==1){break o}f=d+104|0;l=Zc(f);t[c|0]=w[f|0]+36;t[c+1|0]=w[l|0]}if(!(e&64)){break p}t[c+2|0]=1;v[113382]=0;f=T(409,d+40|0)|0;l=v[113382];v[113382]=0;s:{if((l|0)!=1){v[113382]=0;t[d+104|0]=f;t[d+8|0]=64;f=Q(415,d+104|0,d+8|0)|0;l=v[113382];v[113382]=0;if((l|0)==1){break s}t[c+4|0]=w[f|0];break p}break o}break o}if(w[i|0]==64){break n}c=Zb(j,h);v[113382]=0;e=W(459,d+104|0,14,0)|0;k=v[113382];v[113382]=0;if((k|0)!=1){e=Rh(Me(e,w[i|0]-1|0));v[113382]=0;Q(460,c|0,e|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){break n}}break o}if(!(e&32)){continue}v[113382]=0;R(433,d+104|0,d+40|0);e=v[113382];v[113382]=0;t:{u:{v:{w:{x:{y:{z:{A:{B:{C:{D:{E:{F:{G:{H:{I:{J:{K:{L:{M:{N:{O:{P:{Q:{R:{S:{T:{U:{V:{W:{X:{Y:{if((e|0)!=1){f=d+104|0;e=w[Zc(f)|0];t[c+5|0]=e;switch(w[f|0]-1|0){case 71:break u;case 70:break v;case 69:break w;case 60:break x;case 59:break y;case 52:break z;case 51:break A;case 50:break B;case 49:break C;case 42:break D;case 41:break E;case 40:break F;case 39:break G;case 30:break H;case 29:break I;case 22:break J;case 21:break K;case 20:break L;case 19:break M;case 16:break N;case 15:break O;case 14:break P;case 13:break Q;case 12:break R;case 11:break S;case 10:break T;case 9:break U;case 3:break V;case 2:break W;case 1:break X;case 0:break Y;default:break t}}break o}t[c+3|0]=11;t[c+5|0]=e<<4|15;continue}t[c+3|0]=11;t[c+5|0]=e<<4;continue}t[c+3|0]=11;t[c+5|0]=e|240;continue}t[c+3|0]=11;t[c+5|0]=e&15;continue}t[c+3|0]=2;t[c+5|0]=e|240;continue}t[c+3|0]=2;continue}t[c+3|0]=3;t[c+5|0]=e|240;continue}t[c+3|0]=3;continue}t[c+3|0]=4;continue}t[c+3|0]=20;t[c+5|0]=e|16;continue}t[c+3|0]=6;t[c+5|0]=e<<4;continue}t[c+3|0]=6;t[c+5|0]=e&15;continue}t[c+3|0]=5;continue}t[c+3|0]=20;t[c+5|0]=e|48;continue}t[c+3|0]=7;t[c+5|0]=e<<4;continue}t[c+3|0]=7;t[c+5|0]=e&15;continue}t[c+3|0]=8;continue}t[c+3|0]=20;t[c+5|0]=e|64;continue}t[c+3|0]=10;v[113382]=0;e=T(409,d+40|0)|0;f=v[113382];v[113382]=0;if((f|0)!=1){t[c+5|0]=e;v[113382]=0;Q(304,d+40|0,1)|0;c=v[113382];v[113382]=0;if((c|0)!=1){continue}}break o}t[c+3|0]=15;t[c+5|0]=e&15;continue}t[c+3|0]=20;t[c+5|0]=e|192;continue}t[c+3|0]=20;t[c+5|0]=e|208;continue}t[c+3|0]=12;continue}t[c+3|0]=14;continue}t[c+3|0]=20;t[c+5|0]=e|176;continue}t[c+3|0]=20;t[c+5|0]=e|224;continue}t[c+3|0]=16;continue}t[c+3|0]=17;continue}t[c+3|0]=1;continue}t[c+3|0]=20;t[c+5|0]=e&15|32;continue}t[c+3|0]=20;t[c+5|0]=e&15|128;continue}t[c+3|0]=0;continue}}}b=P()|0;O()|0;Bb(d+40|0);break a}Bb(d+40|0)}h=h+1|0;if(h>>>0<(w[d+194|0]|w[d+195|0]<<8)>>>0){continue}break}}if(!(w[d+218|0]|w[d+219|0]<<8|(w[d+220|0]<<16|w[d+221|0]<<24))){break e}Nc(b,w[d+218|0]|w[d+219|0]<<8|(w[d+220|0]<<16|w[d+221|0]<<24));Wy(a+1304424|0,b,og(b),4)}jb=d+272|0;return g|0}b=P()|0;O()|0;break b}b=P()|0;O()|0}Bb(d+104|0)}S(b|0);L()}function BV(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;f=jb-1424|0;jb=f;Ic(b);Gq(a);a:{if(!iD(b,f+1408|0)){break a}if(!kD(f+1408|0)){break a}if(!hD(b,f+1392|0)){break a}if(!jD(f+1392|0)){break a}b:{if(!c){break b}A=f+1400|0;c=A;if((w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24))>>>0>Kj(b)>>>0){break a}c=A;s=f+1392|2;if((w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24))+((w[s|0]|w[s+1|0]<<8)<<2)>>>0>Kj(b)>>>0){break a}kv(a);F=f,G=jv(),v[F+40>>2]=G;c=f+40|0;iv(Wg(a)+28|0,c);Fq(c);m=v[Wg(a)+28>>2];c=f+1392|4;pv(m,w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24));Qb(f+1136|0,0,256);c:{d:{e:{f:{if(w[s|0]|w[s+1|0]<<8){k=f+1112|4;l=f+1128|0;z=f+1130|0;u=f+1126|0;h=f+1124|0;while(1){c=A;if(!Nc(b,(w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24))+(B<<2)|0)){break a}if(!Rb(b,4)){break a}j=Df(b);if(!Nc(b,j)){break a}if(!hv(b,f+1112|0)){break a}e=w[h|0]|w[h+1|0]<<8;d=jb-16|0;jb=d;q=f+1096|0;c=q;v[c>>2]=0;v[c+4>>2]=0;v[113382]=0;v[d+12>>2]=0;W(239,c+8|0,d+12|0,d+8|0)|0;i=v[113382];v[113382]=0;g:{if((i|0)!=1){jb=d+16|0;break g}V(0)|0;O()|0;Ab();L()}h:{if(!e){break h}v[113382]=0;R(232,q|0,e|0);d=v[113382];v[113382]=0;if((d|0)!=1){v[113382]=0;R(233,q|0,e|0);d=v[113382];v[113382]=0;if((d|0)!=1){break h}}a=P()|0;O()|0;dD(c);S(a|0);L()}d=0;i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{v:{w:{x:{if(!(w[h|0]|w[h+1|0]<<8)){break x}while(1){y:{c=Vk(q,d);v[113382]=0;c=Q(224,b|0,c|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break y}if(!c){break w}d=d+1|0;if(d>>>0<(w[h|0]|w[h+1|0]<<8)>>>0){continue}break x}break}c=P()|0;O()|0;break c}c=w[h|0]|w[h+1|0]<<8?v[q>>2]:0;d=w[h|0]|w[h+1|0]<<8;v[113382]=0;e=T(225,b|0)|0;i=v[113382];v[113382]=0;if((i|0)==1){break v}g=d<<3;d=j+20|0;if(e>>>0<=g+d>>>0){break w}i=d+((w[h|0]|w[h+1|0]<<8)<<3)|0;if(!(t[u|0]&1)){e=0;if(!(w[h|0]|w[h+1|0]<<8)){break i}while(1){if(!c){break w}if(!go(m,c)){break w}v[113382]=0;d=Q(226,b|0,i|0)|0;j=v[113382];v[113382]=0;if((j|0)==1){break u}if(!d){break w}j=uc(m,w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24));d=c;n=w[d+4|0]|w[d+5|0]<<8|(w[d+6|0]<<16|w[d+7|0]<<24);v[113382]=0;j=W(227,b|0,j|0,n|0)|0;n=v[113382];v[113382]=0;if((n|0)==1){break u}if((j|0)!=(w[d+4|0]|w[d+5|0]<<8|(w[d+6|0]<<16|w[d+7|0]<<24))){break w}c=c+8|0;e=e+1|0;if(e>>>0<(w[h|0]|w[h+1|0]<<8)>>>0){continue}break}break i}z:{if(w[u|0]&4){if(!c){break w}if(!go(m,c)){break w}n=uc(m,w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24));r=(w[c+4|0]|w[c+5|0]<<8|(w[c+6|0]<<16|w[c+7|0]<<24))&-2;if(!r){break w}j=w[z|0]|w[z+1|0]<<8;d=w[l|0]|w[l+1|0]<<8;v[113382]=0;d=Q(226,b|0,d+i|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break t}if(!d){break w}d=w[k|0]|w[k+1|0]<<8|(w[k+2|0]<<16|w[k+3|0]<<24);e=w[l|0]|w[l+1|0]<<8;v[113382]=0;d=Q(228,b|0,d-e|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break t}if(!d){break w}d=w[k|0]|w[k+1|0]<<8|(w[k+2|0]<<16|w[k+3|0]<<24);e=w[l|0]|w[l+1|0]<<8;v[113382]=0;U(229,f+24|0,b|0,d-e|0);d=v[113382];v[113382]=0;if((d|0)==1){break d}d=f+24|0;o=lm(f+40|0,d);Bb(d);y=0;e=0;i=0;if(!(w[h|0]|w[h+1|0]<<8)){break j}while(1){A:{v[113382]=0;d=Q(230,o|0,j+1|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break A}g=j&15;p=x[(g<<1)+22928>>1];B:{C:{if(p>>>0<=d>>>0){v[113382]=0;g=w[g+22976|0];C=Q(230,o|0,g|0)|0;D=v[113382];v[113382]=0;if((D|0)==1){break l}d=C+(d-p<<g)|0;if((d|0)!=(j|0)){j=d&15;break B}v[113382]=0;d=Q(230,o|0,4)|0;g=v[113382];v[113382]=0;if((g|0)==1){break l}if((d|0)==15){v[113382]=0;g=Q(230,o|0,1)|0;d=v[113382];v[113382]=0;if((d|0)==1){break l}d=65535;if(!g){break C}break j}d=d+65520|0}if(d>>>0>65535){break B}}d=d&1?0-(d+1>>>1|0)|0:d>>>1|0;g=e+n|0;p=g;D:{if(w[u|0]&2){y=d+y|0;d=y;break D}d=w[u+1|0]&2?d:d^32768}t[p|0]=d;t[g+1|0]=d>>>8;e=e+2|0}if(e>>>0>=r>>>0){i=i+1|0;if(i>>>0>=(w[h|0]|w[h+1|0]<<8)>>>0){break j}d=(i<<3)+c|0;if(!go(m,d)){break z}r=(w[d+4|0]|w[d+5|0]<<8|(w[d+6|0]<<16|w[d+7|0]<<24))&-2;if(!r){break z}n=uc(m,w[d|0]|w[d+1|0]<<8|(w[d+2|0]<<16|w[d+3|0]<<24));e=0}if((w[h|0]|w[h+1|0]<<8)>>>0>i>>>0){continue}break j}break}c=V(72108)|0;break k}if(!c){break w}if(!go(m,c)){break w}y=uc(m,w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24));r=w[c+4|0]|w[c+5|0]<<8|(w[c+6|0]<<16|w[c+7|0]<<24);j=w[z|0]|w[z+1|0]<<8;if((w[l|0]|w[l+1|0]<<8)>>>0>256){break w}v[113382]=0;d=Q(226,b|0,i|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break s}if(!d){break w}d=w[l|0]|w[l+1|0]<<8;v[113382]=0;d=W(231,b|0,f+1136|0,d|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break s}if(d>>>0<(w[l|0]|w[l+1|0]<<8)>>>0){break w}d=w[k|0]|w[k+1|0]<<8|(w[k+2|0]<<16|w[k+3|0]<<24);e=w[l|0]|w[l+1|0]<<8;v[113382]=0;d=Q(228,b|0,d-e|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break s}if(!d){break w}d=w[k|0]|w[k+1|0]<<8|(w[k+2|0]<<16|w[k+3|0]<<24);e=w[l|0]|w[l+1|0]<<8;v[113382]=0;U(229,f+24|0,b|0,d-e|0);d=v[113382];v[113382]=0;if((d|0)==1){break m}d=f+24|0;o=lm(f+40|0,d);Bb(d);n=0;e=0;i=0;if(!(w[h|0]|w[h+1|0]<<8)){break p}E:{while(1){F:{v[113382]=0;d=Q(230,o|0,j+1|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break F}g=j&7;p=w[g+22960|0];G:{H:{if(p>>>0<=d>>>0){v[113382]=0;g=w[g+22968|0];C=Q(230,o|0,g|0)|0;D=v[113382];v[113382]=0;if((D|0)==1){break r}d=C+(d-p<<g)|0;if((d|0)!=(j|0)){j=d&7;break G}v[113382]=0;d=Q(230,o|0,3)|0;g=v[113382];v[113382]=0;if((g|0)==1){break r}if((d|0)==7){v[113382]=0;g=Q(230,o|0,1)|0;d=v[113382];v[113382]=0;if((d|0)==1){break r}d=255;if(!g){break H}break p}d=d+248|0}if(d>>>0>255){break G}}d=w[(f+1136|0)+d|0];g=d+n|0;p=d;d=(w[u|0]|w[u+1|0]<<8)&2;t[e+y|0]=d?g:p;n=d?g:n;e=e+1|0}if(e>>>0>=r>>>0){i=i+1|0;if(i>>>0>=(w[h|0]|w[h+1|0]<<8)>>>0){break p}d=(i<<3)+c|0;if(!go(m,d)){break E}r=w[d+4|0]|w[d+5|0]<<8|(w[d+6|0]<<16|w[d+7|0]<<24);y=uc(m,w[d|0]|w[d+1|0]<<8|(w[d+2|0]<<16|w[d+3|0]<<24));e=0}if((w[h|0]|w[h+1|0]<<8)>>>0>i>>>0){continue}break p}break}c=V(72108)|0;break q}Bb(f+40|0);break w}Bb(f+40|0)}fv(q);break a}c=P()|0;O()|0;break c}c=P()|0;O()|0;break c}c=P()|0;O()|0;break c}c=P()|0;O()|0;break c}c=V(72108)|0}if((O()|0)!=(ga(72108)|0)){break n}_(c|0)|0;v[113382]=0;Y(20);c=v[113382];v[113382]=0;if((c|0)==1){break o}}Bb(f+40|0);break i}c=P()|0;O()|0}Bb(f+40|0);break c}c=P()|0;O()|0;break c}c=V(72108)|0}if((O()|0)!=(ga(72108)|0)){break e}_(c|0)|0;v[113382]=0;Y(20);c=v[113382];v[113382]=0;if((c|0)==1){break f}}Bb(f+40|0)}fv(q);B=B+1|0;if(B>>>0<(w[s|0]|w[s+1|0]<<8)>>>0){continue}break}}b=f+8|0;Vi(b,m);c=f+16|0;ev(c,b);b=fo(f+40|0,c,0);Qd(Wg(a)+12|0,b);Bb(b);break b}c=P()|0;O()|0}Bb(f+40|0);break c}c=P()|0;O()|0}fv(q);S(c|0);L()}E=1}jb=f+1424|0;return E|0}function _aa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;g=jb-208|0;jb=g;u[a+480212>>1]=0;v[a+480240>>2]=65536;v[a+480244>>2]=65536;xL(a+900380|0);v[113382]=0;Z(1360,a+946304|0);d=v[113382];v[113382]=0;a:{b:{c:{d:{e:{f:{g:{h:{i:{if((d|0)==1){break i}d=a+906300|0;e=d;f=d+4e4|0;v[113382]=0;d=T(1355,g+48|0)|0;h=v[113382];v[113382]=0;j:{k:{l:{m:{n:{o:{p:{if((h|0)!=1){v[113382]=0;U(1371,e|0,f|0,d|0);e=v[113382];v[113382]=0;if((e|0)==1){break p}Ym(d);v[113382]=0;d=T(303,b|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break i}if(!d){break k}e=0;d=jb-16|0;jb=d;h=g+48|0;v[h>>2]=0;v[h+4>>2]=0;v[113382]=0;v[d+12>>2]=0;W(1386,h+8|0,d+12|0,d+8|0)|0;f=v[113382];v[113382]=0;q:{if((f|0)!=1){jb=d+16|0;break q}break a}f=0;if(c&16){break n}v[113382]=0;i=(c|0)!=0;f=W(1372,h|0,b|0,i|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break m}d=4;r:{if(f){break r}v[113382]=0;f=W(1373,h|0,b|0,i|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break m}d=5;if(f){break r}v[113382]=0;f=W(1374,h|0,b|0,i|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break m}d=6;if(f){break r}f=0;v[113382]=0;i=W(1375,h|0,b|0,i|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break m}d=3;if(!i){break n}}if(c){break o}e=1;break c}a=P()|0;O()|0;break d}a=P()|0;O()|0;Ym(d);break d}if(!id(h)){ZP(b,xu(h,0)+12|0)}f=d}if(c&32){break c}d=72976;s:{t:{while(1){j=v[d+8>>2];i=(j>>1)+a|0;e=v[d+4>>2];e=j&1?v[v[i>>2]+e>>2]:e;v[113382]=0;e=W(e|0,i|0,b|0,c|0)|0;i=v[113382];v[113382]=0;if((i|0)!=1){if(e){break s}d=d+12|0;if((d|0)==73432){break t}continue}break}a=V(66716)|0;break l}v[a+480180>>2]=0;v[a+480184>>2]=0}if(!c){break c}if(!(v[a+480184>>2]|!f)){v[a+480184>>2]=f}$x(h);break j}a=V(66716)|0}c=O()|0;$x(h);if((ga(66716)|0)!=(c|0)){break d}_(a|0)|0;v[113382]=0;Y(81);a=v[113382];v[113382]=0;if((a|0)==1){a=P()|0;O()|0;v[113382]=0;Y(20);c=v[113382];v[113382]=0;if((c|0)!=1){break d}V(0)|0;O()|0;Ab()}L()}v[113382]=0;R(403,a|0,0);d=v[113382];v[113382]=0;if((d|0)==1){break i}v[a+1074304>>2]=19469312}d=0;while(1){e=(d<<5)+a|0;sg(e+480286|0,64);f=e+480284|0;if(x[f>>1]>=257){u[f>>1]=128}e=e+480288|0;if(w[e|0]>=251){t[e|0]=0}v[113382]=0;fa(1376,(B(d,896)+a|0)+1074984|0,7,a|0,d&65535,1024);e=v[113382];v[113382]=0;if((e|0)==1){break f}d=d+1|0;if((d|0)!=127){continue}break}if(x[a+480190>>1]){h=a+1304392|0;e=1;while(1){f=B(e&65535,104)+a|0;d=f+484380|0;u:{if(Be(d)){v[113382]=0;U(1209,d|0,a|0,0);d=v[113382];v[113382]=0;if((d|0)!=1){break u}break e}i=f+484414|0;j=x[i>>1];if(j&16384){break u}v[d>>2]=0;v[d+4>>2]=0;v[d+16>>2]=0;v[d+8>>2]=0;v[d+12>>2]=0;u[i>>1]=j&65505}d=f+484412|0;if(x[d>>1]>=65){u[d>>1]=64}v:{if(!(w[f+484415|0]&2)){break v}if(!qj(h)){break v}v[113382]=0;Z(1377,a|0);d=v[113382];v[113382]=0;if((d|0)==1){break e}}e=e+1|0;if(x[a+480190>>1]>=(e&65535)>>>0){continue}break}}d=0;e=0;while(1){w:{f=v[(((d&65535)<<2)+a|0)+900380>>2];if(!f){break w}e=v[a+480180>>2];v[113382]=0;R(1378,f|0,e|0);f=v[113382];v[113382]=0;e=d;if((f|0)!=1){break w}a=P()|0;O()|0;break d}d=d+1|0;if(x[a+480192>>1]>=(d&65535)>>>0){continue}break}u[a+480192>>1]=e;d=a+480204|0;x:{if(y[a+480204>>2]<1e4){v[d>>2]=125e4;break x}tc(d,65535e4)}if(!v[a+480196>>2]){v[a+480196>>2]=6}d=a+480220|0;e=v[a+480216>>2];if(e>>>0>y[a+480220>>2]){v[d>>2]=e}e=a+480216|0;tc(e,65536);tc(d,65536);tc(a+480200|0,256);d=a+480248|0;if(!id(d)){e=v[e>>2];v[113382]=0;U(1379,d|0,e|0,16777216);d=v[113382];v[113382]=0;if((d|0)==1){break g}}v[a+1074416>>2]=v[a+480196>>2];v[a+1074420>>2]=v[a+480204>>2];e=v[a+480220>>2];d=a+1074408|0;v[d>>2]=v[a+480216>>2];v[d+4>>2]=e;v[a+1074444>>2]=v[a+480200>>2];qy(a+1074376|0);v[a+1074440>>2]=-65536;v[a+1074392>>2]=-2;d=a+1074384|0;v[d>>2]=0;v[d+4>>2]=0;v[a+1074380>>2]=0;d=a+1074424|0;v[d>>2]=0;v[d+4>>2]=0;d=a+1074432|0;v[d>>2]=0;v[d+4>>2]=0;d=a+1074396|0;v[d>>2]=0;v[d+4>>2]=0;u[a+480276>>1]=0;v[113382]=0;Z(1380,a|0);d=v[113382];v[113382]=0;if((d|0)==1){break g}v[113382]=0;R(1196,a+1304360|0,1);d=v[113382];v[113382]=0;if((d|0)==1){break g}d=a+484360|0;k=g,l=ac(d),v[k+48>>2]=l;k=g,l=bc(d),v[k+32>>2]=l;if(Jb(g+48|0,g+32|0)){while(1){d=v[g+48>>2];v[113382]=0;Z(1381,d|0);e=v[113382];v[113382]=0;if((e|0)==1){break h}e=x[d+28>>1];if(oc(d)>>>0<=e>>>0){Ne(d,0)}d=g+48|0;My(d);if(Jb(d,g+32|0)){continue}break}}d=jb-16|0;jb=d;f=g+48|0;e=f;v[e>>2]=0;v[e+4>>2]=0;v[113382]=0;v[d+12>>2]=0;W(1388,e+8|0,d+12|0,d+8|0)|0;e=v[113382];v[113382]=0;y:{if((e|0)!=1){jb=d+16|0;break y}break a}z:{A:{B:{C:{D:{E:{F:{G:{H:{if((c&12)==12){d=0;while(1){j=B(d,160)+a|0;h=j+906300|0;c=h+16|0;e=w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24);c=h+20|0;I:{if(!(e|(w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24)))){break I}v[113382]=0;Q(1382,h|0,a|0)|0;c=v[113382];v[113382]=0;J:{if((c|0)!=1){c=v[h>>2];if(!c){break J}e=v[j+906448>>2];h=v[v[c>>2]+56>>2];v[113382]=0;R(h|0,c|0,e|0);c=v[113382];v[113382]=0;if((c|0)!=1){break I}}a=P()|0;O()|0;break z}e=ac(f);i=bc(f);c=jb-32|0;jb=c;v[c+16>>2]=i;v[c+24>>2]=e;v[c+8>>2]=h;K:{if(!Jb(c+24|0,c+16|0)){break K}while(1){e=v[v[c+24>>2]>>2];i=v[c+8>>2];if((w[e+4|0]|w[e+5|0]<<8|(w[e+6|0]<<16|w[e+7|0]<<24))==(w[i+20|0]|w[i+21|0]<<8|(w[i+22|0]<<16|w[i+23|0]<<24))){i=w[e|0]|w[e+1|0]<<8|(w[e+2|0]<<16|w[e+3|0]<<24);e=v[c+8>>2];e=(i|0)==(w[e+16|0]|w[e+17|0]<<8|(w[e+18|0]<<16|w[e+19|0]<<24))}else{e=0}if(e){break K}e=c+24|0;Ie(e);if(Jb(e,c+16|0)){continue}break}}jb=c+32|0;v[g+32>>2]=v[c+24>>2];k=g,l=bc(f),v[k+16>>2]=l;if(Jb(g+32|0,g+16|0)){break I}v[113382]=0;v[g+32>>2]=j+906316;R(1383,f|0,g+32|0);c=v[113382];v[113382]=0;if((c|0)==1){break A}v[113382]=0;c=Q(2,g+16|0,13710)|0;e=v[113382];v[113382]=0;if((e|0)==1){break H}e=oL(h);v[113382]=0;U(6,g|0,0,e|0);e=v[113382];v[113382]=0;if((e|0)==1){break G}v[113382]=0;U(3,g+32|0,c|0,g|0);e=v[113382];v[113382]=0;if((e|0)==1){break F}v[113382]=0;U(608,a|0,2,g+32|0);e=v[113382];v[113382]=0;if((e|0)==1){break E}yb(g+32|0);yb(g);yb(c)}d=d+1|0;if((d|0)!=250){continue}break}}c=v[a+1074372>>2];v[113382]=0;R(1384,a|0,c|0);c=v[113382];v[113382]=0;if((c|0)==1){break B}c=v[a+480180>>2];L:{if(!c){break L}ss(a+8|0,Yo(a));if(!v[a+1074308>>2]){break L}v[113382]=0;Z(1385,a|0);a=v[113382];v[113382]=0;if((a|0)==1){break B}}nL(f);e=(c|0)!=0;break b}a=P()|0;O()|0;break z}a=P()|0;O()|0;break C}a=P()|0;O()|0;break D}a=P()|0;O()|0;yb(g+32|0)}yb(g)}yb(c);break z}a=P()|0;O()|0;break z}a=P()|0;O()|0}nL(f);break d}a=P()|0;O()|0;break d}a=P()|0;O()|0;break d}a=P()|0;O()|0;break d}a=P()|0;O()|0;break d}a=P()|0;O()|0}Bb(b);S(a|0);L()}$x(h)}Bb(b);jb=g+208|0;return e|0}V(0)|0;O()|0;Ab();L()}function H_(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,x=0,y=0,z=0;l=jb-560|0;jb=l;v[l+548>>2]=k;v[l+552>>2]=b;v[l+96>>2]=2373;b=l+96|0;p=Ld(l+136|0,l+144|0,b);k=v[p>>2];v[l+132>>2]=k;v[l+128>>2]=k+400;r=Xb(b);o=sf(l+80|0);m=sf(l- -64|0);n=sf(l+48|0);q=sf(l+32|0);v[113382]=0;na(2385,c|0,d|0,l+120|0,l+116|0,l+112|0,r|0,o|0,m|0,n|0,l+28|0);b=v[113382];v[113382]=0;if((b|0)!=1){a:{v[j>>2]=v[i>>2];s=e&512;u=s>>>9|0;e=0;c=0;while(1){k=c;b:{c:{d:{e:{if((e|0)==4){break e}v[113382]=0;b=Q(2344,a|0,l+552|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break a}if(!b){break e}d=0;c=k;f:{g:{h:{i:{j:{switch(t[(l+120|0)+e|0]){case 1:if((e|0)==3){break c}v[113382]=0;b=T(2346,a|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break a}v[113382]=0;b=W(2386,h|0,8192,b|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break a}if(b){v[113382]=0;U(2387,l+16|0,a|0,0);b=v[113382];v[113382]=0;if((b|0)!=1){b=v[l+16>>2];v[113382]=0;R(112,q|0,b|0);b=v[113382];v[113382]=0;if((b|0)!=1){break i}}break a}v[f>>2]=v[f>>2]|4;a=0;break d;case 3:break h;case 0:break j;case 4:break f;case 2:break g;default:break b}}if((e|0)==3){break c}}while(1){v[113382]=0;b=Q(2344,a|0,l+552|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break a}if(!b){break c}v[113382]=0;b=T(2346,a|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break a}v[113382]=0;b=W(2386,h|0,8192,b|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break a}if(!b){break c}v[113382]=0;U(2387,l+16|0,a|0,0);b=v[113382];v[113382]=0;if((b|0)!=1){b=v[l+16>>2];v[113382]=0;R(112,q|0,b|0);b=v[113382];v[113382]=0;if((b|0)!=1){continue}}break}break a}if((Db(m)|0)==(0-Db(n)|0)){break c}k:{if(Db(m)){if(Db(n)){break k}}if(Db(m)){v[113382]=0;b=T(2346,a|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break a}if((b|0)==v[Tb(m)>>2]){v[113382]=0;T(2348,a|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break a}c=Db(m)>>>0>1?m:k;break b}t[g|0]=1;break c}v[113382]=0;b=T(2346,a|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break a}if((b|0)!=v[Tb(n)>>2]){break c}v[113382]=0;T(2348,a|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break a}t[g|0]=1;c=Db(n)>>>0>1?n:k;break b}v[113382]=0;b=T(2346,a|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break a}if((b|0)==v[Tb(m)>>2]){v[113382]=0;T(2348,a|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break a}c=Db(m)>>>0>1?m:k;break b}v[113382]=0;b=T(2346,a|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break a}if((b|0)==v[Tb(n)>>2]){v[113382]=0;T(2348,a|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break a}t[g|0]=1;c=Db(n)>>>0>1?n:k;break b}v[f>>2]=v[f>>2]|4;a=0;break d}if(!(k|e>>>0<2)){c=0;if(!((e|0)==2&w[l+123|0]!=0|u)){break b}}y=l,z=Bd(o),v[y+8>>2]=z;b=Hd(l+16|0,l+8|0);l:{if(!e|w[(e+l|0)+119|0]>1){break l}m:{while(1){y=l,z=Yj(o),v[y+8>>2]=z;if(!Jb(b,l+8|0)){break m}c=v[v[b>>2]>>2];v[113382]=0;c=W(2386,h|0,8192,c|0)|0;d=v[113382];v[113382]=0;if((d|0)!=1){if(!c){break m}Ie(b);continue}break}break a}y=l,z=Bd(o),v[y+8>>2]=z;b=ut(b,l+8|0);if(Db(q)>>>0>=b>>>0){y=l,z=Yj(q),v[y+8>>2]=z;b=XN(l+8|0,b);c=Yj(q);d=Bd(o);v[113382]=0;b=$E(b,c,d);c=v[113382];v[113382]=0;if((c|0)==1){break a}if(b){break l}}y=l,z=Bd(o),v[y>>2]=z;Hd(l+8|0,l);v[l+16>>2]=v[l+8>>2]}v[l+8>>2]=v[l+16>>2];n:{while(1){y=l,z=Yj(o),v[y>>2]=z;if(!Jb(l+8|0,l)){break n}v[113382]=0;b=Q(2344,a|0,l+552|0)|0;c=v[113382];v[113382]=0;o:{if((c|0)==1){break o}if(!b){break n}v[113382]=0;b=T(2346,a|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break o}if((b|0)!=v[v[l+8>>2]>>2]){break n}v[113382]=0;T(2348,a|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break a}Ie(l+8|0);continue}break}break a}if(!s){break c}y=l,z=Yj(o),v[y>>2]=z;if(!Jb(l+8|0,l)){break c}v[f>>2]=v[f>>2]|4;a=0;break d}p:{while(1){q:{v[113382]=0;b=Q(2344,a|0,l+552|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break q}if(!b){break p}v[113382]=0;c=T(2346,a|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break a}v[113382]=0;b=W(2386,h|0,2048,c|0)|0;x=v[113382];v[113382]=0;if((x|0)==1){break a}r:{if(b){b=v[j>>2];if((b|0)==v[l+548>>2]){v[113382]=0;U(2389,i|0,j|0,l+548|0);b=v[113382];v[113382]=0;if((b|0)==1){break a}b=v[j>>2]}v[j>>2]=b+4;v[b>>2]=c;d=d+1|0;break r}if(!Db(r)|!d|(c|0)!=v[l+112>>2]){break p}c=v[l+132>>2];if((c|0)==v[l+128>>2]){v[113382]=0;U(2380,p|0,l+132|0,l+128|0);b=v[113382];v[113382]=0;if((b|0)==1){break a}c=v[l+132>>2]}v[l+132>>2]=c+4;v[c>>2]=d;d=0}v[113382]=0;T(2348,a|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){continue}}break}break a}c=v[l+132>>2];if(!(!d|(c|0)==v[p>>2])){if(v[l+128>>2]==(c|0)){v[113382]=0;U(2380,p|0,l+132|0,l+128|0);b=v[113382];v[113382]=0;if((b|0)==1){break a}c=v[l+132>>2]}v[l+132>>2]=c+4;v[c>>2]=d}s:{if(v[l+28>>2]<=0){break s}v[113382]=0;b=Q(2345,a|0,l+552|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break a}t:{if(!b){v[113382]=0;b=T(2346,a|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break a}if((b|0)==v[l+116>>2]){break t}}v[f>>2]=v[f>>2]|4;a=0;break d}v[113382]=0;T(2348,a|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break a}while(1){if(v[l+28>>2]<=0){break s}v[113382]=0;b=Q(2345,a|0,l+552|0)|0;c=v[113382];v[113382]=0;u:{if((c|0)==1){break u}v:{if(!b){v[113382]=0;b=T(2346,a|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break u}v[113382]=0;b=W(2386,h|0,2048,b|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break u}if(b){break v}}v[f>>2]=v[f>>2]|4;a=0;break d}if(v[j>>2]==v[l+548>>2]){v[113382]=0;U(2389,i|0,j|0,l+548|0);b=v[113382];v[113382]=0;if((b|0)==1){break u}}v[113382]=0;b=T(2346,a|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break u}c=v[j>>2];v[j>>2]=c+4;v[c>>2]=b;v[113382]=0;v[l+28>>2]=v[l+28>>2]-1;T(2348,a|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){continue}}break}break a}c=k;if(v[i>>2]!=v[j>>2]){break b}v[f>>2]=v[f>>2]|4;a=0;break d}w:{if(!k){break w}c=1;while(1){if(Db(k)>>>0<=c>>>0){break w}v[113382]=0;b=Q(2345,a|0,l+552|0)|0;d=v[113382];v[113382]=0;x:{if((d|0)==1){break x}y:{if(!b){v[113382]=0;b=T(2346,a|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break x}if((b|0)==v[ij(k,c)>>2]){break y}}v[f>>2]=v[f>>2]|4;a=0;break d}v[113382]=0;T(2348,a|0)|0;b=v[113382];v[113382]=0;c=c+1|0;if((b|0)!=1){continue}}break}break a}z:{if(v[p>>2]==v[l+132>>2]){break z}v[l+16>>2]=0;a=v[p>>2];v[113382]=0;De(r,a,v[l+132>>2],l+16|0);a=v[113382];v[113382]=0;if((a|0)!=1){if(!v[l+16>>2]){break z}v[f>>2]=v[f>>2]|4;a=0;break d}break a}a=1}Jc(q);Jc(n);Jc(m);Jc(o);yb(r);Gc(p);jb=l+560|0;return a|0}c=k}e=e+1|0;continue}}}a=P()|0;O()|0;Jc(q);Jc(n);Jc(m);Jc(o);yb(r);Gc(p);S(a|0);L()}
function ala(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,z=0,A=0,C=0;d=jb-1328|0;jb=d;Ic(b);n=jb-16|0;jb=n;k=n+8|0;l=d+752|0;bS(k,l);i=Hb(k);f=b;k=mc(f,$b(n,k));if((i|0)==(k|0)){_b(f,Hb(n+8|0))}jb=n+16|0;f=(i|0)==(k|0);if(!f){cS(l)}a:{b:{c:{if(!f){break c}if(!fS(d+752|0)){break c}if(!Rb(b,dd(eS(d+752|0),mb))){break c}if(!c){e=1;break c}r=It(d+744|0);s=1;d:{while(1){n=(e<<5)+a|0;l=n+480280|0;Dg(l);i=(d+752|0)+(e<<4)|0;u[n+480284>>1]=((w[i+78|0]<<8&65280)>>>0)/255;k=d+480|0;Jk(k,1,i- -64|0);f=d+96|0;Ec(f,k);v[113382]=0;Q(344,n+480289|0,f|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break b}yb(d+96|0);e:{f:{switch(w[i+79|0]){case 0:o=e+1|0;break e;case 1:v[l>>2]=1024;o=h+1|0;break e;case 2:break f;default:break d}}v[l>>2]=1024;f=d+96|0;Pj(f,r,e);ce(f,1)}s=e>>>0<31;h=h+1|0;e=e+1|0;if((e|0)!=32){continue}break}Id(a,33554432);u[a+480188>>1]=o&255;f=d+96|0;e=Ub(f,3098);Gb(a+1304436|0,e);yb(e);e=Ub(f,7101);Gb(a+1304448|0,e);yb(e);v[a+1304496>>2]=4;g:{if(w[d+831|0]){break g}n=1;while(1){if(w[((n<<4)+d|0)+831|0]!=1){break g}e=1;n=n+1|0;if((n|0)!=16){continue}break}while(1){f=((e<<5)+a|0)+480280|0;v[f>>2]=v[f>>2]&-1025;e=e+1|0;if((e|0)!=16){continue}break}}f=d+480|0;Cg(f,1,d+752|0);e=d+96|0;Ec(e,f);Gb(a+1304400|0,e);yb(e);v[a+480208>>2]=v[a+480208>>2]&-17|(w[d+790|0]|w[d+791|0]<<8)<<4&16;v[a+480196>>2]=w[d+800|0];v[a+480204>>2]=B(w[d+801|0],1e4);v[a+480200>>2]=w[d+802|0]<<2;v[a+480228>>2]=w[d+803|0];e=w[d+788|0]|w[d+789|0]<<8;o=0;u[a+480190>>1]=0;u[a+480192>>1]=e;uu(b,f);fq(Vb(a+484360|0),f,w[d+784|0]|w[d+785|0]<<8,65535,255);g=c&1;if(g){dg(a+484344|0,w[d+786|0]|w[d+787|0]<<8)}if(w[d+786|0]|w[d+787|0]<<8){z=a+484344|0;while(1){e=og(b);q=og(b);td(d+96|0,b,e-4|0);h:{if(!g){break h}v[113382]=0;f=W(364,z|0,o&65535,q|0)|0;e=v[113382];v[113382]=0;if((e|0)!=1){i:{if(!f){break h}p=0;k=Oh(d+16|0);if(!q){break h}while(1){j:{v[113382]=0;h=T(409,d+96|0)|0;e=v[113382];v[113382]=0;k:{l:{if((e|0)!=1){if(h){break l}p=p+1|0;break k}break i}e=k;j=h&31;if(j>>>0<x[a+480188>>1]){e=Zb(z,o);v[113382]=0;e=W(432,e|0,p|0,j|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break i}}m:{if(!(h&32)){break m}v[113382]=0;R(433,d+32|0,d+96|0);i=v[113382];v[113382]=0;f=e;n:{o:{if((i|0)!=1){l=d+32|0;i=Zc(l);l=w[l|0];t[e|0]=l;t[e+1|0]=w[i|0];if((l|0)!=160){break o}i=255;break n}break i}if((l|0)!=255){t[e|0]=(B(l>>>4|0,12)+(l&15)|0)+13;v[113382]=0;l=T(577,e|0)|0;i=v[113382];v[113382]=0;if((i|0)!=1){i=0;if(!l){break n}break m}break i}i=0}t[f|0]=i}f=h&192;p:{if(!f){break p}if((f|0)==192){v[113382]=0;R(557,d+32|0,d+96|0);f=v[113382];v[113382]=0;q:{r:{s:{if((f|0)!=1){f=d+32|0;i=f;l=Zc(f);n=Cf(f);h=Ph(f);m=w[f|0];if((m|0)!=12){break s}v[113382]=0;t[d+8|0]=64;i=Q(415,l|0,d+8|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break i}t[e+4|0]=w[i|0];f=1;break r}break i}f=w[n|0];t:{if((f|0)==12){v[113382]=0;t[d+8|0]=64;h=Q(415,h|0,d+8|0)|0;f=v[113382];v[113382]=0;if((f|0)!=1){t[e+4|0]=w[h|0];f=1;break t}break i}if((m|0)==10){t[e+4|0]=(w[l|0]<<6>>>0)/255;f=2;break r}if((f|0)!=10){break q}t[e+4|0]=(w[h|0]<<6>>>0)/255;f=2}n=i;h=l}t[e+2|0]=f;f=w[n|0]}t[e+3|0]=f;t[e+5|0]=w[h|0];break p}v[113382]=0;R(433,d+32|0,d+96|0);f=v[113382];v[113382]=0;if((f|0)==1){break i}i=d+32|0;f=Zc(i);t[e+3|0]=w[i|0];t[e+5|0]=w[f|0]}if(w[e+3|0]){v[113382]=0;Z(578,e|0);f=v[113382];v[113382]=0;if((f|0)==1){break i}}f=d+32|0;Pj(f,r,j);if(!Cb(f)){break k}v[113382]=0;i=T(579,e|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break j}if(!i){break k}t[e+3|0]=0}if(p>>>0<q>>>0){continue}break h}break}}}e=P()|0;O()|0;Bb(d+96|0);break a}Bb(d+96|0);o=o+1|0;if(o>>>0<(w[d+786|0]|w[d+787|0]<<8)>>>0){continue}break}}if(!x[a+480192>>1]){break d}l=c&2;o=1;n=0;while(1){n=n+1|0;i=n&65535;m=fL(a,i,0);h=jb-16|0;jb=h;c=jb-16|0;jb=c;e=h+8|0;k=d+96|0;fc(e,k,384);jb=c+16|0;f=Hb(e);c=b;e=mc(c,$b(h,e));if((f|0)==(e|0)){_b(c,Hb(h+8|0))}jb=h+16|0;e=(e|0)==(f|0);if(!e){c=jb-16|0;jb=c;Qb(k,0,384);jb=c+16|0}if(!(!e|!m)){f=o&65535;g=jb-32|0;jb=g;h=d+96|0;Cg(g,1,h);c=g+16|0;Ec(c,g);v[113382]=0;Q(335,m+492|0,c|0)|0;c=v[113382];v[113382]=0;u:{if((c|0)!=1){yb(g+16|0);v:{if(!(w[h+378|0]|w[h+379|0]<<8)){break v}v[g+16>>2]=120;v[g>>2]=116;if(!v[Lb(g+16|0,g)>>2]){break v}e=m+236|0;k=0;while(1){c=w[(h+k|0)+32|0];A=_c(e,k+12|0),C=c+f|0,u[A>>1]=C;v[g+16>>2]=120;v[g>>2]=116;k=k+1|0;if(k>>>0<y[Lb(g+16|0,g)>>2]){continue}break}}v[m>>2]=w[h+376|0]|w[h+377|0]<<8;fA(h,m+48|0,0);fA(h,m+68|0,1);fA(h,m+88|0,2);c=w[m+100|0];if(c&1){t[m+100|0]=c|16}if(!(v[m>>2]|t[m+60|0]&1)){v[m>>2]=32767}jb=g+32|0;break u}a=P()|0;O()|0;yb(g+16|0);S(a|0);L()}e=0;w:{if(!(w[d+474|0]|w[d+475|0]<<8)){break w}while(1){x:{Rp(b,d+32|0);y:{if((w[d+92|0]|w[d+93|0]<<8|(w[d+94|0]<<16|w[d+95|0]<<24))!=808538953){break y}c=e+o|0;h=c&65535;if(h>>>0>3999){break y}u[a+480190>>1]=c;m=jb-32|0;jb=m;k=B(h,104)+a|0;f=k+484380|0;g=f;sd(f,0);j=d+32|0;uh(m,1,j);c=m+16|0;Ec(c,m);v[113382]=0;Q(336,f+43|0,c|0)|0;c=v[113382];v[113382]=0;z:{if((c|0)!=1){yb(m+16|0);v[g>>2]=w[j+16|0]|w[j+17|0]<<8|(w[j+18|0]<<16|w[j+19|0]<<24);v[g+4>>2]=w[j+20|0]|w[j+21|0]<<8|(w[j+22|0]<<16|w[j+23|0]<<24);v[g+8>>2]=w[j+24|0]|w[j+25|0]<<8|(w[j+26|0]<<16|w[j+27|0]<<24);v[g+24>>2]=w[j+28|0]|w[j+29|0]<<8|(w[j+30|0]<<16|w[j+31|0]<<24);u[g+30>>1]=w[j+32|0]<<2;u[g+28>>1]=w[j+33|0];if(t[j+48|0]&1){u[g+34>>1]=x[g+34>>1]|2}if(w[j+48|0]&2){u[g+34>>1]=x[g+34>>1]|4}if(w[j+48|0]&4){u[g+34>>1]=x[g+34>>1]|1;v[g>>2]=v[g>>2]>>>1;v[g+4>>2]=v[g+4>>2]>>>1;v[g+8>>2]=v[g+8>>2]>>>1}if(w[j+48|0]&8){u[g+34>>1]=x[g+34>>1]|32}jb=m+32|0;break z}a=P()|0;O()|0;yb(m+16|0);S(a|0);L()}c=d+16|0;cC(c,k+484423|0);v[113382]=0;Q(335,((h<<5)+a|0)+946304|0,c|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break x}yb(d+16|0);if(!(w[d+48|0]|w[d+49|0]<<8|(w[d+50|0]<<16|w[d+51|0]<<24))){break y}td(d+16|0,b,w[d+48|0]|w[d+49|0]<<8|(w[d+50|0]<<16|w[d+51|0]<<24));A:{if(!l){break A}c=Yc(d+8|0,u[k+484414>>1]&1?16:8,1,0,0);v[113382]=0;W(362,c|0,f|0,d+16|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){break A}e=P()|0;O()|0;Bb(d+16|0);break a}Bb(d+16|0)}e=e+1|0;if(e>>>0<(w[d+474|0]|w[d+475|0]<<8)>>>0){continue}break w}break}e=P()|0;O()|0;yb(d+16|0);break a}o=(w[d+474|0]|w[d+475|0]<<8)+o|0}if(i>>>0<x[a+480192>>1]){continue}break}}e=!s}jb=d+1328|0;return e&1}e=P()|0;O()|0;yb(d+96|0)}S(e|0);L()}function Es(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=jb-32|0;jb=h;v[h+28>>2]=c;a:{if((c|0)<=0){break a}l=v[b+104>>2];i=v[b+656>>2];if(!(!i|v[a+480180>>2]!=16777216)){p=v[i+44>>2]!=0}b:{if(!(!i|(c|0)>128)){m=x[_c(i+236|0,c-1|0)>>1];c:{if((m-1&65535)>>>0<=3998){l=(B(m,104)+a|0)+484380|0;break c}m=h+16|0;Fb(m,a+1074312|0,43);if(!Cb(m)){break c}if(!oj(b)){break a}}j=w[ec(i+108|0,v[h+28>>2]-1|0)|0];v[h+28>>2]=j;break b}j=c}if(j>>>0>=121){d:{if(!(v[a+480180>>2]&16777248?(j|0)!=255:0)){$m(a,b);if(d){break d}c=h+16|0;Fb(c,a+1074312|0,100);if(!Cb(c)|!(w[a+480208|0]&4)|!w[b+811|0]){break d}v[b+88>>2]=v[b+88>>2]&-6145;break d}if(!x[a+480192>>1]){break d}v[b+88>>2]=v[b+88>>2]|4096}e:{if(v[h+28>>2]!=254){break e}f:{c=v[b+88>>2];if(!(c&512)){break f}c=v[b+88>>2];if(v[a+480180>>2]!=2){break f}v[b+88>>2]=c|2048;break e}v[b+88>>2]=c|2101248;g:{if(v[a+480180>>2]&16777248){if(!x[a+480192>>1]){break g}c=h+16|0;Fb(c,a+1074312|0,50);if(Cb(c)){break g}}v[b+688>>2]=0}c=h+16|0;Fb(c,a+1074312|0,50);if(Cb(c)){v[b+8>>2]=0;v[b+12>>2]=0}v[b+696>>2]=0}c=h+16|0;Fb(c,a+1074312|0,20);if(!Cb(c)){break a}t[b+819|0]=0;t[b+824|0]=0;break a}h:{i:{j:{if(p){if(d){k=w[b+819|0];if(k){break j}}v[b+708>>2]=0}if(d){break i}if(!(!(v[a+480180>>2]&1048588)|!l)){v[b+772>>2]=t[l+36|0];v[b+768>>2]=t[l+37|0]}if(l){d=h+16|0;Fb(d,a+1074312|0,24);j=0;m=1;if(!Cb(d)){break h}v[b+704>>2]=v[l+24>>2];break h}m=0;j=0;break h}m=v[i+44>>2];u[h>>1]=k;u[h+14>>1]=j;v[h+16>>2]=0;m=(v[h+16>>2]+B(u[m+36>>1]+1|0,u[h+14>>1]-u[h>>1]|0)|0)-v[b+876>>2]|0;v[b+708>>2]=m;v[b+876>>2]=0-m}m=(l|0)!=0;j=1;if(Kh(b)){break h}j=h+16|0;k=a+1074312|0;Fb(j,k,54);if(Cb(j)){v[b+700>>2]=0;break a}j=h+16|0;Fb(j,k,39);j=(Cb(j)^-1)&d}k:{if(Op(a)){v[h+28>>2]=v[h+28>>2]+v[b+772>>2];Yd(h+28|0,12,131);break k}PP(h+28|0)}k=h+16|0;n=a+1074312|0;Fb(k,n,34);d=b;l:{if(Cb(k)){c=Up(c);break l}c=v[h+28>>2]}t[d+819|0]=c;t[b+872|0]=w[b+872|0]|8;if(!(v[a+480180>>2]&16777250?0:j)){t[b+825|0]=0}o=eg(a,v[h+28>>2],v[b+768>>2],v[b+704>>2]);t[b+851|0]=0;c=h+16|0;Fb(c,n,48);if(Cb(c)){lM(a,b,i,l)}m:{if(e^1|j){break m}v[b+788>>2]=0;v[b+792>>2]=0;if(!i){break m}c=h+16|0;Fb(c,n,29);if(Cb(c)){t[b+820|0]=w[i+16|0]}if(!(w[i+60|0]&8)){wi(b+724|0)}if(!(w[i+80|0]&8)){wi(b+736|0)}if(!(w[i+100|0]&8)){wi(b+748|0)}if(w[i+20|0]){d=Cs(_m(a));c=w[i+20|0];k=h+16|0;Fb(k,n,28);d=((B(c,d)<<16>>16)/64<<16)+65536>>16;c=b;n:{if(Cb(k)){k=v[b+764>>2];break n}k=(v[b+688>>2]+1|0)/2|0}u[c+788>>1]=(B(k,d)|0)/199}o:{if(!w[i+19|0]){break o}q=b,r=(B(Cs(_m(a)),w[i+19|0])<<16>>16)/32|0,u[q+790>>1]=r;c=h+16|0;Fb(c,n,28);if(Cb(c)|x[b+796>>1]){break o}u[b+796>>1]=x[b+692>>1]+1}k=w[i+23|0];if(k){d=Cs(_m(a));c=w[b+857|0];t[b+818|0]=c+1;u[b+792>>1]=(B(c,(B(k,d+1|0)<<16>>16)/128<<16>>16)+1|0)/128}k=w[i+24|0];if(!k){break m}d=Cs(_m(a));c=w[b+858|0];t[b+817|0]=c+1;u[b+794>>1]=(B(c,(B(k,d+1|0)<<16>>16)/128<<16>>16)+1|0)/128}if(!m){break a}m=0;p:{q:{if(!o){break q}if(!(v[b+700>>2]?j:0)){v[b+700>>2]=o}r:{s:{if(!p){if(!j){c=h+16|0;Fb(c,n,69);if(Cb(c)){break s}Fb(h,n,46);if(Cb(h)|v[a+480180>>2]==1){break s}}v[b+708>>2]=o}if(!j){break s}if(v[b+76>>2]|v[a+480180>>2]&2){break r}}v[b+104>>2]=l;c=v[l>>2];v[b+84>>2]=c;v[b+76>>2]=c;v[b+80>>2]=0;v[b>>2]=0;v[b+4>>2]=0;t:{u:{if(!(v[a+480208>>2]&2097152)){c=h+16|0;Fb(c,n,96);if(!Cb(c)){break u}}if(w[b+811|0]){break u}v[h+16>>2]=v[b+76>>2]-1;q=b,r=v[Lb(b+660|0,h+16|0)>>2],v[q+4>>2]=r;break t}v[b+660>>2]=0}c=x[l+34>>1];k=c&1023;d=k|v[b+88>>2]&-525056;v[b+88>>2]=d;v:{w:{if(c&8){v[b+80>>2]=v[l+12>>2];c=v[l+16>>2];v[b+88>>2]=(k&16?d|4:d&-524295)|2;v[b+84>>2]=c;if(y[b+76>>2]>c>>>0){break w}break v}if(!(k&2)){break v}v[b+80>>2]=v[l+4>>2];c=v[l+8>>2];v[b+84>>2]=c;if(y[b+76>>2]<=c>>>0){break v}}v[b+76>>2]=c}c=h+16|0;Fb(c,n,83);if(!(!Cb(c)|v[b+80>>2])){c=v[l>>2];v[b+84>>2]=c;v[b+76>>2]=c}d=v[b+88>>2];x:{if(!(d&128)){break x}c=v[b+76>>2];if(!c){break x}v[b+88>>2]=d|128;v[b+4>>2]=c-1}y:{if(w[b+842|0]>3){break y}d=h+16|0;Fb(d,n,21);c=b;z:{if(!(Cb(d)|!(v[a+480180>>2]&16777248))){d=16;if(!(v[a+480208>>2]&4)){break z}}d=32;if(v[a+480180>>2]==16){break z}if(v[a+480180>>2]&67633152){break y}d=0}t[c+839|0]=d}c=h+16|0;Fb(c,n,21);if(Cb(c)|w[b+845|0]>3){break r}t[b+840|0]=0}c=v[b>>2];if(y[b+76>>2]<=y[b+4>>2]){d=c;c=v[b+80>>2];v[b>>2]=d;v[b+4>>2]=c}if(!j){break q}m=1;if(!(v[a+480180>>2]&17301536)|(v[b+696>>2]?0:w[b+89|0]&16)){break q}c=1;if(!(w[a+480208|0]&8)){break p}c=1;if(!w[b+811|0]){break p}}if(!(v[b+696>>2]|(!(v[a+480180>>2]&17301536)|!(w[b+89|0]&16)))){zl(b);c=h+16|0;Fb(c,n,21);if(!Cb(c)){t[b+838|0]=0;v[b+780>>2]=0}v[b+696>>2]=65536;v[b+88>>2]=v[b+88>>2]&-4097}if(!(!m|!(w[a+480208|0]&8))){c=1;if(!w[b+811|0]){break p}}if(!(w[b+811|0]?0:v[a+480180>>2]&1048580)){v[b+696>>2]=65536;v[b+88>>2]=v[b+88>>2]&-4097}c=m}d=h+16|0;Fb(d,n,40);A:{B:{if(Cb(d)){if(c){if(!(!(w[a+480208|0]&8)|!w[b+811|0])){v[b+88>>2]=v[b+88>>2]&-4196353;l=1;break A}v[b+88>>2]=v[b+88>>2]&-4194305;l=1;break A}j=v[b+88>>2]&-4196353;break B}j=v[b+88>>2]&-4196353;v[b+88>>2]=j;l=1;if(c){break A}}u[b+862>>1]=65535;v[b+88>>2]=j&-6326273|2097152;c=h+16|0;Fb(c,n,23);C:{if(Cb(c)){break C}Fb(h,n,22);if(Cb(h)){break C}c=h+16|0;Fb(c,n,52);if(Cb(c)){break C}Fb(h,n,71);if(Cb(h)){break C}t[b+859|0]=0;u[b+798>>1]=0}if(e){t[b+838|0]=0;v[b+780>>2]=0}v[b+20>>2]=0;v[b+24>>2]=0;c=v[a+480208>>2]&8192;D:{if(i){E:{F:{if(!eC(i)){if(Iu(i)){break F}c=!(c>>>13|0);if(c){break E}break D}q=b,r=fC(i),t[q+858|0]=r;if(!Iu(i)){break E}}q=b,r=gC(i),t[q+857|0]=r}c=1;d=w[i+25|0];if((d|0)==255){break D}t[b+865|0]=d;break D}v[b+788>>2]=0;v[b+792>>2]=0;c=!c}G:{if(w[b+857|0]>=127){d=h+16|0;Fb(d,n,36);if(!Cb(d)){break G}}l=0;if(!c){break A}if((ip(a,b,1,256)|0)<0|!(w[b+89|0]&2)){break A}c=a+1304392|0;if(!qd(c)|(g|0)==65535){break A}np(v[c>>2],g,w[b+857|0]>>>1|0,1);break A}l=0}c=v[b+88>>2];if(f){c=c&-1025;v[b+88>>2]=c}H:{I:{if(w[a+24618|0]&16?c&1024:0){break I}a=v[b+104>>2];if(!(f?1:!a|!(w[a+35|0]&4))){break I}a=v[b+656>>2];if(!a|!(w[a+15|0]&2)){break H}}if(f){break H}v[b+700>>2]=0}if(l){break a}u[b+136>>1]=0;v[b+132>>2]=4194304;v[b+112>>2]=0;v[b+116>>2]=0}jb=h+32|0}function O_(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,x=0,y=0;l=jb-560|0;jb=l;v[l+548>>2]=k;v[l+552>>2]=b;v[l+104>>2]=2373;b=l+104|0;p=Ld(l+136|0,l+144|0,b);k=v[p>>2];v[l+132>>2]=k;v[l+128>>2]=k+400;r=Xb(b);o=Xb(l+88|0);m=Xb(l+72|0);n=Xb(l+56|0);q=Xb(l+40|0);v[113382]=0;na(2376,c|0,d|0,l+120|0,l+119|0,l+118|0,r|0,o|0,m|0,n|0,l+36|0);b=v[113382];v[113382]=0;if((b|0)!=1){a:{v[j>>2]=v[i>>2];s=e&512;u=s>>>9|0;k=0;c=0;while(1){e=c;b:{c:{d:{e:{if((k|0)==4){break e}v[113382]=0;b=Q(2312,a|0,l+552|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break a}if(!b){break e}d=0;c=e;f:{g:{h:{i:{j:{switch(t[(l+120|0)+k|0]){case 1:if((k|0)==3){break c}v[113382]=0;b=T(2314,a|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break a}if(Lg(h,8192,b)){v[113382]=0;U(2377,l+24|0,a|0,0);b=v[113382];v[113382]=0;if((b|0)!=1){b=t[l+24|0];v[113382]=0;R(110,q|0,b|0);b=v[113382];v[113382]=0;if((b|0)!=1){break i}}break a}v[f>>2]=v[f>>2]|4;a=0;break d;case 3:break h;case 0:break j;case 4:break f;case 2:break g;default:break b}}if((k|0)==3){break c}}while(1){v[113382]=0;b=Q(2312,a|0,l+552|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break a}if(!b){break c}v[113382]=0;b=T(2314,a|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break a}if(!Lg(h,8192,b)){break c}v[113382]=0;U(2377,l+24|0,a|0,0);b=v[113382];v[113382]=0;if((b|0)!=1){b=t[l+24|0];v[113382]=0;R(110,q|0,b|0);b=v[113382];v[113382]=0;if((b|0)!=1){continue}}break}break a}if((Db(m)|0)==(0-Db(n)|0)){break c}k:{if(Db(m)){if(Db(n)){break k}}if(Db(m)){v[113382]=0;b=T(2314,a|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break a}if(w[kc(m,0)|0]==(b&255)){v[113382]=0;T(2316,a|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break a}c=Db(m)>>>0>1?m:e;break b}t[g|0]=1;break c}v[113382]=0;b=T(2314,a|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break a}if(w[kc(n,0)|0]!=(b&255)){break c}v[113382]=0;T(2316,a|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break a}t[g|0]=1;c=Db(n)>>>0>1?n:e;break b}v[113382]=0;b=T(2314,a|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break a}if(w[kc(m,0)|0]==(b&255)){v[113382]=0;T(2316,a|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break a}c=Db(m)>>>0>1?m:e;break b}v[113382]=0;b=T(2314,a|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break a}if(w[kc(n,0)|0]==(b&255)){v[113382]=0;T(2316,a|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break a}t[g|0]=1;c=Db(n)>>>0>1?n:e;break b}v[f>>2]=v[f>>2]|4;a=0;break d}if(!(e|k>>>0<2)){c=0;if(!((k|0)==2&w[l+123|0]!=0|u)){break b}}x=l,y=Bd(o),v[x+16>>2]=y;b=Hd(l+24|0,l+16|0);l:{if(!k|w[(k+l|0)+119|0]>1){break l}while(1){m:{x=l,y=tf(o),v[x+16>>2]=y;if(!Jb(b,l+16|0)){break m}if(!Lg(h,8192,t[v[b>>2]])){break m}xg(b);continue}break}x=l,y=Bd(o),v[x+16>>2]=y;b=dm(b,l+16|0);if(Db(q)>>>0>=b>>>0){x=l,y=tf(q),v[x+16>>2]=y;b=Az(l+16|0,b);c=tf(q);d=Bd(o);v[113382]=0;b=eF(b,c,d);c=v[113382];v[113382]=0;if((c|0)==1){break a}if(b){break l}}x=l,y=Bd(o),v[x+8>>2]=y;Hd(l+16|0,l+8|0);v[l+24>>2]=v[l+16>>2]}v[l+16>>2]=v[l+24>>2];n:{while(1){x=l,y=tf(o),v[x+8>>2]=y;if(!Jb(l+16|0,l+8|0)){break n}v[113382]=0;b=Q(2312,a|0,l+552|0)|0;c=v[113382];v[113382]=0;o:{if((c|0)==1){break o}if(!b){break n}v[113382]=0;b=T(2314,a|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break o}if(w[v[l+16>>2]]!=(b&255)){break n}v[113382]=0;T(2316,a|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break a}xg(l+16|0);continue}break}break a}if(!s){break c}x=l,y=tf(o),v[x+8>>2]=y;if(!Jb(l+16|0,l+8|0)){break c}v[f>>2]=v[f>>2]|4;a=0;break d}p:{while(1){q:{v[113382]=0;b=Q(2312,a|0,l+552|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break q}if(!b){break p}v[113382]=0;c=T(2314,a|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break a}r:{if(Lg(h,2048,c)){b=v[j>>2];if((b|0)==v[l+548>>2]){v[113382]=0;U(2379,i|0,j|0,l+548|0);b=v[113382];v[113382]=0;if((b|0)==1){break a}b=v[j>>2]}v[j>>2]=b+1;t[b|0]=c;d=d+1|0;break r}if(!Db(r)|!d|w[l+118|0]!=(c&255)){break p}c=v[l+132>>2];if((c|0)==v[l+128>>2]){v[113382]=0;U(2380,p|0,l+132|0,l+128|0);b=v[113382];v[113382]=0;if((b|0)==1){break a}c=v[l+132>>2]}v[l+132>>2]=c+4;v[c>>2]=d;d=0}v[113382]=0;T(2316,a|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){continue}}break}break a}c=v[l+132>>2];if(!(!d|(c|0)==v[p>>2])){if(v[l+128>>2]==(c|0)){v[113382]=0;U(2380,p|0,l+132|0,l+128|0);b=v[113382];v[113382]=0;if((b|0)==1){break a}c=v[l+132>>2]}v[l+132>>2]=c+4;v[c>>2]=d}s:{if(v[l+36>>2]<=0){break s}v[113382]=0;b=Q(2313,a|0,l+552|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break a}t:{if(!b){v[113382]=0;b=T(2314,a|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break a}if(w[l+119|0]==(b&255)){break t}}v[f>>2]=v[f>>2]|4;a=0;break d}v[113382]=0;T(2316,a|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break a}while(1){if(v[l+36>>2]<=0){break s}v[113382]=0;b=Q(2313,a|0,l+552|0)|0;c=v[113382];v[113382]=0;u:{if((c|0)==1){break u}v:{if(!b){v[113382]=0;b=T(2314,a|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break u}if(Lg(h,2048,b)){break v}}v[f>>2]=v[f>>2]|4;a=0;break d}if(v[j>>2]==v[l+548>>2]){v[113382]=0;U(2379,i|0,j|0,l+548|0);b=v[113382];v[113382]=0;if((b|0)==1){break u}}v[113382]=0;b=T(2314,a|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break u}c=v[j>>2];v[j>>2]=c+1;t[c|0]=b;v[113382]=0;v[l+36>>2]=v[l+36>>2]-1;T(2316,a|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){continue}}break}break a}c=e;if(v[i>>2]!=v[j>>2]){break b}v[f>>2]=v[f>>2]|4;a=0;break d}w:{if(!e){break w}c=1;while(1){if(Db(e)>>>0<=c>>>0){break w}v[113382]=0;b=Q(2313,a|0,l+552|0)|0;d=v[113382];v[113382]=0;x:{if((d|0)==1){break x}y:{if(!b){v[113382]=0;b=T(2314,a|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break x}if(w[kc(e,c)|0]==(b&255)){break y}}v[f>>2]=v[f>>2]|4;a=0;break d}v[113382]=0;T(2316,a|0)|0;b=v[113382];v[113382]=0;c=c+1|0;if((b|0)!=1){continue}}break}break a}z:{if(v[p>>2]==v[l+132>>2]){break z}v[l+24>>2]=0;a=v[p>>2];v[113382]=0;De(r,a,v[l+132>>2],l+24|0);a=v[113382];v[113382]=0;if((a|0)!=1){if(!v[l+24>>2]){break z}v[f>>2]=v[f>>2]|4;a=0;break d}break a}a=1}yb(q);yb(n);yb(m);yb(o);yb(r);Gc(p);jb=l+560|0;return a|0}c=e}k=k+1|0;continue}}}a=P()|0;O()|0;yb(q);yb(n);yb(m);yb(o);yb(r);Gc(p);S(a|0);L()}function N6(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=C(0),f=C(0),g=C(0),h=C(0),i=C(0),j=C(0),k=0,l=C(0),m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,x=0,y=C(0),A=C(0),B=0,D=0,E=0,F=C(0),G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=C(0),S=0,T=0,U=0,V=0,W=0,X=C(0),Y=0,Z=0,_=0,$=C(0);a:{if(!w[a+5046|0]){break a}j=z[a+4268>>2];KI(a);if(j==z[a+4268>>2]){break a}hx(a)}b:{if(!w[a+5045|0]){break b}p=a+44|0;if(!vh(p)){break b}q=Jd(p,0);x=Jd(p,1);m=ed(p,0);n=ed(p,1);c:{if(!(w[a+4264|0]&2|(!w[a+5044|0]|!d))){z[m>>2]=z[a+5036>>2];z[n>>2]=z[a+5040>>2];t[a+5044|0]=0;x=x+4|0;q=q+4|0;n=n+4|0;m=m+4|0;k=d-1|0;break c}k=d}r=k;d:{if(!r){break d}W=a+4960|0;G=a+4648|0;H=a+4672|0;S=a+4936|0;I=a+4696|0;J=a+4720|0;K=a+4744|0;L=a+4768|0;T=a+4840|0;E=a+4504|0;M=a+4528|0;U=a+4912|0;N=a+4552|0;O=a+4576|0;P=a+4600|0;Q=a+4624|0;V=a+4816|0;s=a+4888|0;u=a+4864|0;while(1){j=z[q>>2];j=C(C(C(z[a+5008>>2]-j)*z[a+4276>>2])+j);z[a+5008>>2]=j;_=Bc(u,v[a+4880>>2]),$=j,z[_>>2]=$;j=z[x>>2];j=C(C(C(z[a+5012>>2]-j)*z[a+4276>>2])+j);z[a+5012>>2]=j;_=Bc(s,v[a+4904>>2]),$=j,z[_>>2]=$;j=gh(u,v[a+4356>>2]);f=gh(u,v[a+4360>>2]);e=gh(u,v[a+4364>>2]);g=gh(u,v[a+4368>>2]);j=C(C(C(j*C(.6800000071525574))+C(C(e+gh(u,v[a+4372>>2]))*C(-.6200000047683716)))+C(C(g+f)*C(-.5)));if(t[a+4264|0]&1){f=j;j=C(z[Bc(V,v[a+4836>>2])>>2]+C(f*C(.6180340051651001)));_=Bc(V,v[a+4832>>2]),$=C(f-C(j*C(.6180340051651001))),z[_>>2]=$}X=z[a+4280>>2];_=a,$=C(gh(u,v[a+4352>>2])+z[a+5020>>2]),z[_+5020>>2]=$;f=C(gh(s,v[a+4376>>2])+z[a+5024>>2]);z[a+5024>>2]=f;e=z[a+5020>>2];g=z[a+4980>>2];i=z[Bc(Q,v[a+4644>>2])>>2];y=z[a+4444>>2];g=C(z[Bc(Q,v[a+4644>>2])>>2]+C(y*C(g-i)));z[a+4980>>2]=g;i=z[a+4272>>2];h=C(e*C(-.7070000171661377));l=C(f*C(.7070000171661377));e=C(h+l);f=C(C(i*e)+C(z[a+4440>>2]*g));_=Bc(Q,v[a+4640>>2]),$=C(e-C(i*f)),z[_>>2]=$;e=z[a+4976>>2];g=z[Bc(P,v[a+4620>>2])>>2];i=z[a+4436>>2];e=C(z[Bc(P,v[a+4620>>2])>>2]+C(i*C(e-g)));z[a+4976>>2]=e;g=z[a+4272>>2];e=C(C(g*f)+C(z[a+4432>>2]*e));_=Bc(P,v[a+4616>>2]),$=C(f-C(g*e)),z[_>>2]=$;y=C(C(f*C(-.15000000596046448))+C(e*C(-.20000000298023224)));if(t[a+4264|0]&1){f=z[a+4972>>2];g=z[Bc(O,v[a+4596>>2])>>2];i=z[a+4428>>2];f=C(z[Bc(O,v[a+4596>>2])>>2]+C(i*C(f-g)));z[a+4972>>2]=f;g=z[a+4272>>2];f=C(C(g*e)+C(z[a+4424>>2]*f));_=Bc(O,v[a+4592>>2]),$=C(e-C(g*f)),z[_>>2]=$;e=z[a+4968>>2];g=z[Bc(N,v[a+4572>>2])>>2];i=z[a+4420>>2];e=C(z[Bc(N,v[a+4572>>2])>>2]+C(i*C(e-g)));z[a+4968>>2]=e;g=z[a+4272>>2];e=C(C(g*f)+C(z[a+4416>>2]*e));_=Bc(N,v[a+4568>>2]),$=C(f-C(g*e)),z[_>>2]=$;y=C(C(C(f*C(.3499999940395355))+y)+C(e*C(-.3799999952316284)))}_=Bc(U,v[a+4928>>2]),$=e,z[_>>2]=$;k=Bc(U,v[a+4932>>2]);f=C(z[a+4496>>2]*z[k>>2]);z[a+5028>>2]=C(C(z[a+5028>>2]-f)*z[a+4500>>2])+f;f=z[a+4964>>2];e=z[Bc(M,v[a+4548>>2])>>2];g=z[a+4412>>2];f=C(z[Bc(M,v[a+4548>>2])>>2]+C(g*C(f-e)));z[a+4964>>2]=f;g=C(z[a+4408>>2]*f);f=z[a+4272>>2];e=z[a+5028>>2];g=C(g+C(f*e));_=Bc(M,v[a+4544>>2]),$=C(e-C(f*g)),z[_>>2]=$;f=z[a+4960>>2];e=z[Bc(E,v[a+4524>>2])>>2];i=z[a+4404>>2];f=C(z[Bc(E,v[a+4524>>2])>>2]+C(i*C(f-e)));z[a+4960>>2]=f;e=z[a+4272>>2];R=C(C(e*g)+C(z[a+4400>>2]*f));_=Bc(E,v[a+4520>>2]),$=C(g-C(e*R)),z[_>>2]=$;z[a+5020>>2]=R;f=gh(s,v[a+4380>>2]);e=gh(s,v[a+4384>>2]);i=gh(s,v[a+4388>>2]);A=gh(s,v[a+4392>>2]);f=C(C(C(f*C(.7070000171661377))+C(C(i+gh(s,v[a+4396>>2]))*C(-.5)))+C(C(A+e)*C(-.6000000238418579)));if(t[a+4264|0]&1){e=f;f=C(z[Bc(T,v[a+4860>>2])>>2]+C(e*C(.6180340051651001)));_=Bc(T,v[a+4856>>2]),$=C(e-C(f*C(.6180340051651001))),z[_>>2]=$}A=z[a+4280>>2];e=z[a+5004>>2];i=z[Bc(L,v[a+4788>>2])>>2];F=z[a+4492>>2];e=C(z[Bc(L,v[a+4788>>2])>>2]+C(F*C(e-i)));z[a+5004>>2]=e;F=z[a+4272>>2];h=C(h-l);i=C(C(F*h)+C(z[a+4488>>2]*e));_=Bc(L,v[a+4784>>2]),$=C(h-C(F*i)),z[_>>2]=$;e=z[a+5e3>>2];h=z[Bc(K,v[a+4764>>2])>>2];l=z[a+4484>>2];e=C(z[Bc(K,v[a+4764>>2])>>2]+C(l*C(e-h)));z[a+5e3>>2]=e;h=z[a+4272>>2];e=C(C(h*i)+C(z[a+4480>>2]*e));_=Bc(K,v[a+4760>>2]),$=C(i-C(h*e)),z[_>>2]=$;i=C(C(e*C(-.20000000298023224))+C(C(g*C(.3799999952316284))+C(i*C(-.15000000596046448))));if(t[a+4264|0]&1){g=z[a+4996>>2];h=z[Bc(J,v[a+4740>>2])>>2];l=z[a+4476>>2];g=C(z[Bc(J,v[a+4740>>2])>>2]+C(l*C(g-h)));z[a+4996>>2]=g;h=z[a+4272>>2];g=C(C(h*e)+C(z[a+4472>>2]*g));_=Bc(J,v[a+4736>>2]),$=C(e-C(h*g)),z[_>>2]=$;e=z[a+4992>>2];h=z[Bc(I,v[a+4716>>2])>>2];l=z[a+4468>>2];e=C(z[Bc(I,v[a+4716>>2])>>2]+C(l*C(e-h)));z[a+4992>>2]=e;h=z[a+4272>>2];e=C(C(h*g)+C(z[a+4464>>2]*e));_=Bc(I,v[a+4712>>2]),$=C(g-C(h*e)),z[_>>2]=$;i=C(C(C(g*C(.3499999940395355))+i)+C(e*C(-.3799999952316284)))}Y=x+4|0;Z=q+4|0;g=C(A*f);_=Bc(S,v[a+4952>>2]),$=e,z[_>>2]=$;k=Bc(S,v[a+4956>>2]);f=C(z[a+4496>>2]*z[k>>2]);z[a+5032>>2]=C(C(z[a+5032>>2]-f)*z[a+4500>>2])+f;f=z[a+4988>>2];e=z[Bc(H,v[a+4692>>2])>>2];h=z[a+4460>>2];f=C(z[Bc(H,v[a+4692>>2])>>2]+C(h*C(f-e)));z[a+4988>>2]=f;e=z[a+4272>>2];h=z[a+5032>>2];f=C(C(z[a+4456>>2]*f)+C(e*h));_=Bc(H,v[a+4688>>2]),$=C(h-C(e*f)),z[_>>2]=$;h=z[a+4284>>2];e=z[a+4984>>2];l=z[Bc(G,v[a+4668>>2])>>2];A=z[a+4452>>2];e=C(z[Bc(G,v[a+4668>>2])>>2]+C(A*C(e-l)));z[a+4984>>2]=e;l=z[a+4272>>2];e=C(C(l*f)+C(z[a+4448>>2]*e));_=Bc(G,v[a+4664>>2]),$=C(f-C(l*e)),z[_>>2]=$;z[a+5024>>2]=e;e=C(e*C(.3799999952316284));j=C(C(h*C(C(C(f-R)*C(.3799999952316284))+y))+C(X*j));f=z[a+4288>>2];k=E;while(1){o=k;B=v[o+16>>2];D=B-1|0;v[o+16>>2]=D;if((B|0)<=0){v[o+16>>2]=D+v[o+12>>2]}D=v[o+20>>2];B=D-1|0;v[o+20>>2]=B;if((D|0)<=0){v[o+20>>2]=B+v[o+12>>2]}k=k+24|0;if((W|0)!=(k|0)){continue}break}f=C(C(f*C(i-e))+g);e:{f:{if(w[a+4264|0]&2){q=Z;k=Y;break f}z[m>>2]=C(z[a+5036>>2]+j)*C(.5);z[n>>2]=C(z[a+5040>>2]+f)*C(.5);z[a+5040>>2]=f;z[a+5036>>2]=j;if((r|0)==1){break e}r=r-1|0;q=q+8|0;n=n+4|0;m=m+4|0;k=x+8|0}x=k;z[m>>2]=j;z[n>>2]=f;n=n+4|0;m=m+4|0;r=r-1|0;if(r){continue}break d}break}t[a+5044|0]=1}pi(a,b,c,ed(p,0),ed(p,1),d)}}function TU(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=jb-160|0;jb=e;Ic(b);Gq(a);a:{if(!Ru(b,e+120|0)){break a}if(!zK(e+120|0)){break a}i=b;f=e+120|0;m=cf(9120);if(m){p=v[i+8>>2];if(Nc(i,w[f+16|0]|w[f+17|0]<<8|(w[f+18|0]<<16|w[f+19|0]<<24))){b:{if(!(w[f+12|0]|w[f+13|0]<<8|(w[f+14|0]<<16|w[f+15|0]<<24))){break b}while(1){if(!Rb(i,4)){break b}c:{if((w[f+4|0]|w[f+5|0]<<8)>>>0>=64){if((Ih(i)|0)<=0){break c}}j=0;d=1;while(1){h=le(i);if(h){q=Ko(h<<24>>24);n=j>>>0>=m>>>0;g=n&d;h=g;d:{if(n){break d}h=g;if(!(d&1)){break d}h=w[j+9120|0]==(q&255)}d=h;j=j+1|0;continue}break}_b(i,4);l=(j|0)==(m|0)?d?1:l:l}o=o+1|0;if(o>>>0<(w[f+12|0]|w[f+13|0]<<8|(w[f+14|0]<<16|w[f+15|0]<<24))>>>0){continue}break}}j=l&1}Nc(i,p)}if(!j){break a}if(!c){k=1;break a}h=jb-16|0;jb=h;i=ih(e+104|0);f=e+120|0;c=f+16|0;d=w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24);v[113382]=0;c=b;d=Q(226,c|0,d|0)|0;g=v[113382];v[113382]=0;e:{f:{g:{h:{if((g|0)!=1){if(!d){break e}d=f+12|0;d=w[d|0]|w[d+1|0]<<8|(w[d+2|0]<<16|w[d+3|0]<<24);v[113382]=0;v[h>>2]=d;d=T(296,c|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break g}v[113382]=0;v[h+12>>2]=(d>>>0)/5;d=Q(297,h|0,h+12|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break g}g=v[d>>2];d=0;v[113382]=0;R(1500,i|0,g|0);j=v[113382];v[113382]=0;if((j|0)==1){break h}if(!g){break e}f=f+4|0;i:{while(1){v[113382]=0;j=Q(228,c|0,5)|0;l=v[113382];v[113382]=0;j:{if((l|0)!=1){if(j){break j}break e}a=P()|0;O()|0;break f}j=w[f|0]|w[f+1|0]<<8;v[113382]=0;U(1501,h|0,c|0,j|0);j=v[113382];v[113382]=0;if((j|0)!=1){v[113382]=0;R(1502,i|0,h|0);j=v[113382];v[113382]=0;if((j|0)==1){break i}yb(h);d=d+1|0;if((g|0)!=(d|0)){continue}break e}break}a=P()|0;O()|0;break f}a=P()|0;O()|0;yb(h);break f}a=P()|0;O()|0;break f}a=P()|0;O()|0;break f}a=P()|0;O()|0}gd(i);S(a|0);L()}jb=h+16|0;c=w[e+152|0]|w[e+153|0]<<8|(w[e+154|0]<<16|w[e+155|0]<<24);v[113382]=0;c=Q(226,b|0,c|0)|0;h=v[113382];v[113382]=0;k:{l:{m:{n:{o:{p:{q:{r:{if((h|0)!=1){if(!c){break k}c=jb-16|0;jb=c;h=e+88|0;d=h;v[d>>2]=0;v[d+4>>2]=0;v[113382]=0;v[c+12>>2]=0;W(311,d+8|0,c+12|0,c+8|0)|0;d=v[113382];v[113382]=0;s:{if((d|0)!=1){jb=c+16|0;break s}V(0)|0;O()|0;Ab();L()}c=w[e+148|0]|w[e+149|0]<<8|(w[e+150|0]<<16|w[e+151|0]<<24);v[113382]=0;v[e+24>>2]=c;c=T(296,b|0)|0;d=v[113382];v[113382]=0;t:{if((d|0)==1){break t}v[113382]=0;v[e+56>>2]=c>>>2;c=Q(297,e+24|0,e+56|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break t}d=v[c>>2];v[113382]=0;R(298,h|0,d|0);c=v[113382];v[113382]=0;if((c|0)==1){break q}c=e+120|4;if(!d){break r}while(1){v[113382]=0;i=Q(228,b|0,4)|0;g=v[113382];v[113382]=0;u:{if((g|0)!=1){if(i){break u}break r}b=P()|0;O()|0;break o}i=w[c|0]|w[c+1|0]<<8;v[113382]=0;i=Q(299,b|0,i|0)|0;g=v[113382];v[113382]=0;v:{if((g|0)!=1){v[e+24>>2]=i;if(xc(e+104|0)>>>0<=i>>>0){break v}v[113382]=0;R(300,h|0,e+24|0);i=v[113382];v[113382]=0;if((i|0)!=1){break v}}b=P()|0;O()|0;break o}k=k+1|0;if((d|0)!=(k|0)){continue}break}break r}b=P()|0;O()|0;break o}b=P()|0;O()|0;break n}d=w[e+144|0]|w[e+145|0]<<8|(w[e+146|0]<<16|w[e+147|0]<<24);k=0;v[113382]=0;d=Q(226,b|0,d|0)|0;i=v[113382];v[113382]=0;if((i|0)!=1){break p}}b=P()|0;O()|0;break o}if(!d){break l}if(!(w[e+140|0]|w[e+141|0]<<8|(w[e+142|0]<<16|w[e+143|0]<<24))){break m}i=e+36|0;w:{x:{y:{z:{A:{B:{while(1){v[113382]=0;d=Q(228,b|0,4)|0;g=v[113382];v[113382]=0;C:{if((g|0)!=1){if(d){break C}break m}b=P()|0;O()|0;break o}d=w[c|0]|w[c+1|0]<<8;v[113382]=0;ma(301,b|0,e+84|0,e+80|0,e+76|0,e+72|0,d|0);d=v[113382];v[113382]=0;if((d|0)==1){break z}D:{E:{if(v[e+76>>2]<=0){break E}d=v[e+84>>2];if((d|0)>=0){break E}d=d^-1;v[e+84>>2]=d;if(Kb(h)>>>0<=d>>>0){break E}if(!Pd(od(e+104|0,v[Pb(h,v[e+84>>2])>>2]),9120)){break E}v[113382]=0;X(302,e+56|0,b|0,v[e+80>>2],v[e+76>>2]);d=v[113382];v[113382]=0;if((d|0)==1){break y}v[113382]=0;d=T(303,e+56|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break x}if(d){if((w[c|0]|w[c+1|0]<<8)>>>0<=39){v[113382]=0;Q(304,e+56|0,8)|0;d=v[113382];v[113382]=0;if((d|0)==1){break x}}if((w[c|0]|w[c+1|0]<<8)>>>0<=59){v[113382]=0;Q(304,e+56|0,16)|0;d=v[113382];v[113382]=0;if((d|0)==1){break x}}v[113382]=0;T(305,e+56|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break x}F:{if((w[c|0]|w[c+1|0]<<8)>>>0>=120){v[113382]=0;T(305,e+56|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break x}v[113382]=0;Q(304,e+56|0,8)|0;break F}if((w[c|0]|w[c+1|0]<<8)>>>0>=100){v[113382]=0;Q(304,e+56|0,4)|0;d=v[113382];v[113382]=0;if((d|0)==1){break x}v[113382]=0;T(305,e+56|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break x}v[113382]=0;Q(304,e+56|0,4)|0;break F}if((w[c|0]|w[c+1|0]<<8)>>>0>=62){v[113382]=0;T(305,e+56|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break x}v[113382]=0;Q(304,e+56|0,4)|0;break F}v[113382]=0;T(305,e+56|0)|0}d=v[113382];v[113382]=0;if((d|0)==1){break x}v[113382]=0;g=T(305,e+56|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break A}v[113382]=0;d=T(306,e+24|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break D}f=v[e+72>>2];G:{if((f|0)<0){break G}if(xc(e+104|0)>>>0<=f>>>0){break G}f=od(e+104|0,v[e+72>>2]);v[113382]=0;U(13,e+8|0,2,f|0);f=v[113382];v[113382]=0;if((f|0)==1){break B}f=e+8|0;Gb(e+24|0,f);yb(f)}v[113382]=0;U(307,e+8|0,e+56|0,g|0);g=v[113382];v[113382]=0;if((g|0)==1){break B}g=e+8|0;Qd(i,g);Bb(g);v[113382]=0;R(308,a|0,d|0);g=v[113382];v[113382]=0;if((g|0)==1){break B}_u(d)}Bb(e+56|0)}k=k+1|0;if(k>>>0<(w[e+140|0]|w[e+141|0]<<8|(w[e+142|0]<<16|w[e+143|0]<<24))>>>0){continue}break m}break}b=P()|0;O()|0;break w}b=P()|0;O()|0;_u(d);break w}b=P()|0;O()|0;break w}b=P()|0;O()|0;break o}b=P()|0;O()|0;break o}b=P()|0;O()|0}Bb(e+56|0)}zC(h)}gd(e+104|0);S(b|0);L()}k=id(a)^1}zC(h)}gd(e+104|0)}jb=e+160|0;return k|0}function gp(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,z=0,A=0,C=0,D=0,E=0;j=jb-16|0;jb=j;g=x[a+480192>>1]>=c>>>0?v[((c<<2)+a|0)+900380>>2]:g;r=v[b+764>>2];h=w[b+824|0];a:{if(!h){i=j+8|0;Fb(i,a+1074312|0,11);if(Cb(i)){break a}}b:{c:{if(!g){break c}if(!Xd(h)){break c}d:{i=g+236|0;h=h-1|0;if(x[_c(i,h)>>1]){break d}k=j+8|0;Fb(k,a+1074312|0,43);if(!Cb(k)){break d}if(zi(g)){break d}v[b+656>>2]=g;break a}if(w[ec(g+108|0,h)|0]>120){break a}h=x[_c(i,h)>>1];k=(h-1&65535)>>>0<3999?(B(h,104)+a|0)+484380|0:0;break b}k=(B(c,104)+a|0)+484380|0;if(!x[a+480192>>1]){break b}if(h>>>0>250){break a}h=j+8|0;Fb(h,a+1074312|0,43);if(Cb(h)){if(g){k=0;if(zi(g)){break b}}t[b+825|0]=0;v[b+656>>2]=0;break a}k=0}h=v[b+656>>2];i=v[b+104>>2];n=(i|0)!=0&(i|0)!=(k|0);i=!n;p=!g|v[a+480180>>2]!=16777216?p:v[g+44>>2]!=0;if(!(i?1:!d|!p|v[b+656>>2]!=(g|0))){break a}q=d^1;e:{if(i|q){break e}i=j+8|0;l=a+1074312|0;Fb(i,l,32);if(!(!Cb(i)|!(w[a+480208|0]&8))){k=v[b+8>>2]|v[b+12>>2]?v[b+104>>2]:k}f:{if(!(g?!(v[a+480180>>2]&1048580)|(g|0)!=(h|0):1)|v[a+480180>>2]==268435456){break f}if(v[a+480180>>2]==1){if(Kh(b)){break f}}i=j+8|0;Fb(i,l,79);if(!Cb(i)){break e}if(!Kh(b)){break e}}o=1}g:{if(!v[b+16>>2]|(!n|(!x[a+480192>>1]|(g|0)!=(h|0)))){break g}i=j+8|0;Fb(i,a+1074312|0,87);if(!Cb(i)){break g}o=Wf(b+810|0)^1|o}h:{i:{j:{k:{if(!(Kh(b)|!(v[a+480180>>2]&16777248))){if(!g){break k}if(!zi(g)){break k}}if((g|0)==(h|0)){break j}}l:{m:{if(!d){break m}h=j+8|0;Fb(h,a+1074312|0,61);if(!Cb(h)){break m}i=v[b+656>>2];if(i){break l}i=0;h=v[b+104>>2];if(h){break h}}m=1;break i}h=v[b+104>>2];break h}m=0}v[b+656>>2]=g;h=k;i=g}n:{if(!e){break n}l=b;o:{p:{q:{if(v[a+480180>>2]&3){if(h){if(Be(h)){break q}}if(!oj(b)){break n}}if(!h){break p}}if(u[h+34>>1]<0){break n}g=x[h+30>>1];break o}g=0;if(!i|!w[i+34|0]){break o}g=b;k=v[b+656>>2];r:{if(k){g=v[k+4>>2]<<2;break r}g=v[g+688>>2]}}v[l+688>>2]=g}if(o){if(!((h|0)!=0&n)){break a}c=j+8|0;Fb(c,a+1074312|0,85);if(Cb(c)){v[b+768>>2]=t[h+37|0]}if(v[a+480180>>2]!=2){break a}if(!Be(h)){break a}v[b+704>>2]=v[h+24>>2];break a}t[b+825|0]=0;s:{if(!i){break s}g=j+8|0;Fb(g,a+1074312|0,29);if(s=0,z=(C=Cb(g),D=1,E=h,E?C:D),A=w[i+34|0]|m,A?s:z){break s}t[b+820|0]=w[i+16|0]}g=i;l=64;k=b;v[b+764>>2]=64;o=h;if(h){l=x[o+32>>1];v[k+764>>2]=l}if(g){v[k+764>>2]=B(v[g+4>>2],l)>>>6}t:{if(!(v[a+480180>>2]&1048580?e:1)){break t}e=j+8|0;Fb(e,a+1074312|0,48);if(Cb(e)){break t}lM(a,b,i,h)}u:{v:{w:{if(!f){break w}f=j+8|0;e=a+1074312|0;Fb(f,e,19);x:{y:{z:{A:{B:{C:{D:{E:{F:{if(Cb(f)){if(v[b+76>>2]){if(!(!c|q)){g=(w[a+480208|0]&8)>>>3|0;if(g){break D}break E}g=0;if(c){break E}break D}g=v[b+88>>2];if(!v[b+696>>2]|m){break F}c=g&2048;break C}g=1;G:{if(!d|!(v[a+480180>>2]&17301536)|(!v[b+76>>2]|w[a+480208|0]&8)){break G}g=0;if(!(w[b+89|0]&16)){break G}g=!v[b+696>>2]}if(!(v[a+480180>>2]&17301536)|(!i|m)){break B}if(!g){break A}g=v[b+88>>2];c=g&6144;break C}v[b+88>>2]=g|2097152;if(!i){break x}break y}if(d){break D}if(!(w[b+89|0]&24)){g=0;break D}g=(w[a+480208|0]&4)>>>2|0}if(!v[b+696>>2]|m){break B}if(!g){break A}g=v[b+88>>2];c=g&2048}v[b+88>>2]=g|2097152;if(!i){break x}if(c){break y}if(!(w[i+60|0]&8)){wi(b+724|0)}if(!(w[i+80|0]&8)){wi(b+736|0)}if(w[i+100|0]&8){break x}wi(b+748|0);break x}if(g){break z}}if(i){if(t[i+60|0]&1){break w}c=j+8|0;Fb(c,e,32);if(Cb(c)){wi(b+724|0);break w}zl(b);break w}g=0;if(!h){break v}break u}v[b+88>>2]=v[b+88>>2]|2097152;if(!i){break x}}zl(b)}c=j+8|0;Fb(c,e,21);if(Cb(c)){break w}t[b+838|0]=0;v[b+780>>2]=0}g=0;if(h){break u}if(!i){break v}g=1;if(zi(i)){break u}}v[b+764>>2]=0;v[b+104>>2]=0;break a}c=b;H:{I:{J:{K:{L:{if(!(!d|!h|v[b+104>>2]!=(h|0))){if(v[b+76>>2]?v[a+480180>>2]&16777250:0){break a}if(v[a+480180>>2]!=4){break L}d=j+8|0;Fb(d,a+1074312|0,40);if(!Cb(d)|w[b+811|0]){break L}d=v[b+88>>2];break K}v[b+88>>2]=v[b+88>>2]&-6145;e=j+8|0;f=a+1074312|0;Fb(e,f,18);c=b;M:{if(s=Cb(e),z=1,A=v[a+480180>>2]&16777248,A?s:z){e=-640;if(!(v[b+104>>2]!=(h|0)|m)){break M}}e=-768}v[c+88>>2]=e&v[b+88>>2];N:{if(!i){break N}t[b+724|0]=w[i+60|0];t[b+736|0]=w[i+80|0];t[b+748|0]=w[i+100|0];O:{if((w[i+100|0]&17)!=17){break O}c=j+8|0;Fb(c,f,36);if(Cb(c)|w[b+857|0]){break O}t[b+857|0]=127}if(Iu(i)){s=b,z=gC(i),t[s+857|0]=z}if(!eC(i)){break N}s=b,z=fC(i),t[s+858|0]=z}if(g){break J}if(!d){break H}break I}d=v[b+88>>2]&-6145}v[c+88>>2]=d&-640;if(!g){break I}}v[b+76>>2]=0;v[b+104>>2]=0;break a}if(v[b+76>>2]){break H}c=j+8|0;d=a+1074312|0;Fb(c,d,54);if(!Cb(c)){Fb(j,d,39);if(!Cb(j)){break H}}v[b+8>>2]=0;v[b+12>>2]=0}P:{if(w[b+810|0]!=255){break P}c=j+8|0;Fb(c,a+1074312|0,100);if(!Cb(c)|(!(v[a+480208>>2]&4)|!n)){break P}c=v[b+104>>2];if(c){v[b+88>>2]=v[b+88>>2]|x[c+34>>1]&1023}v[b+764>>2]=r;v[b+688>>2]=x[h+30>>1];if(!(w[h+34|0]&32)){break a}$s(b,x[h+28>>1],a);break a}v[b+104>>2]=h;v[b+76>>2]=v[h>>2];v[b+80>>2]=v[h+4>>2];v[b+84>>2]=v[h+8>>2];c=j+8|0;d=a+1074312|0;Fb(c,d,83);if(!(!Cb(c)|v[b+80>>2])){v[b+84>>2]=v[h>>2]}v[b+88>>2]=v[b+88>>2]|x[h+34>>1]&1023;c=j+8|0;Fb(c,d,21);if(Cb(c)){t[b+838|0]=0;v[b+780>>2]=0}c=b;Q:{R:{if(p){v[b+704>>2]=v[h+24>>2];t[b+872|0]=w[b+872|0]|8;e=0;break R}if(!(v[a+480180>>2]&5?n|q:1)){break Q}v[b+704>>2]=v[h+24>>2];e=t[h+37|0]}v[c+768>>2]=e}c=b;if(Op(a)){e=t[h+36|0]}else{e=0}v[c+772>>2]=e;c=j+8|0;Fb(c,d,69);if(!(Cb(c)|v[a+480180>>2]==1)){v[b+708>>2]=0}v[b+876>>2]=0;g=v[b+88>>2];if(g&8){v[b+80>>2]=v[h+12>>2];v[b+84>>2]=v[h+16>>2];g=g>>>2&4|g|2;v[b+88>>2]=g}S:{if(!(g&2)){g=v[b+76>>2];break S}g=v[b+76>>2];c=v[b+84>>2];if(g>>>0<=c>>>0){break S}v[b+76>>2]=c;g=c}if(!(v[a+480180>>2]&16777248)|y[b+4>>2]<g>>>0){break a}v[b>>2]=0;v[b+4>>2]=0}jb=j+16|0}function Bka(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,z=0,A=0,C=0,D=0,E=0;e=jb-176|0;jb=e;a:{b:{c:{d:{e:{f:{g:{if(sh(b,9789)){if(d){t[d|0]=1}k=a+1074312|0;Ht(k);n=a+480216|0;o=a+480220|0;p=a+480224|0;l=a+1074372|0;q=a+480200|0;h:{if(!Rb(b,7)){break h}r=a+480228|0;s=a+480232|0;z=a+484360|0;m=a+480268|0;A=a+1304412|0;C=a+480248|0;while(1){f=Df(b);d=og(b);if((f|0)==(w[17528]|w[17529]<<8|(w[17530]<<16|w[17531]<<24))){mg(b,6);break h}if(!(f&1616928864)|f&-2139062144){break h}if(!Rb(b,d)){break h}td(e+160|0,b,d);i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{v:{w:{x:{y:{z:{if((f|0)<=1347243309){if((f|0)<=1146367533){if((f|0)<=1130917458){if((f|0)==1127099950){break x}if((f|0)!=1129797166){break i}v[113382]=0;v[e>>2]=0;U(633,e+160|0,d|0,e|0);d=v[113382];v[113382]=0;if((d|0)==1){break u}v[a+1074304>>2]=v[e>>2];break i}if((f|0)==1130917459){break p}if((f|0)!=1145525806){break i}v[113382]=0;U(633,e+160|0,d|0,q|0);d=v[113382];v[113382]=0;if((d|0)==1){break b}break i}if((f|0)<=1213486400){if((f|0)==1146367534){break z}if((f|0)!=1196316499|d>>>0<3){break i}v[113382]=0;R(634,e+144|0,e+160|0);d=v[113382];v[113382]=0;if((d|0)==1){break n}v[113382]=0;g=W(635,e|0,e+144|0,8)|0;d=v[113382];v[113382]=0;if((d|0)==1){break m}yb(e+144|0);v[113382]=0;f=T(225,e+160|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break l}v[113382]=0;U(636,e|0,C|0,f|0);d=v[113382];v[113382]=0;if((d|0)==1){break l}Mf(g);break i}if((f|0)==1213486401){break q}if((f|0)==1280530262){break t}if((f|0)!=1297303086){break i}Ht(k);h=0;break k}if((f|0)<=1380994349){if((f|0)<=1380340803){if((f|0)==1347243310){break v}if((f|0)!=1347244882){break i}v[113382]=0;U(637,e+160|0,d|0,m|0);d=v[113382];v[113382]=0;if((d|0)==1){break b}if(Nn(w[m|0])){break i}t[m|0]=5;break i}if((f|0)==1380340804){break y}if((f|0)==1380986414){break r}if((f|0)!=1380991534){break i}v[113382]=0;U(633,e+160|0,d|0,n|0);d=v[113382];v[113382]=0;if((d|0)==1){break b}break i}if((f|0)<=1397768493){if((f|0)==1380994350){break j}if((f|0)!=1397052739|d>>>0<3){break i}v[113382]=0;f=T(323,e+160|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break c}if(!f|f>>>0>x[a+480190>>1]){break i}f=B(f,104)+a|0;d=f+484448|0;j=f+484484|0;while(1){v[113382]=0;g=T(397,e+160|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break o}v[d>>2]=g;d=d+4|0;if((j|0)!=(d|0)){continue}break}break i}if((f|0)==1397768494){break s}if((f|0)==1414344238){break w}if((f|0)!=1448301654){break i}v[113382]=0;U(633,e+160|0,d|0,s|0);d=v[113382];v[113382]=0;if((d|0)==1){break b}break i}v[113382]=0;U(633,e+160|0,d|0,e|0);d=v[113382];v[113382]=0;if((d|0)==1){break g}v[a+480204>>2]=B(v[e>>2],1e4)+(y[a+480204>>2]%1e4|0);break i}v[113382]=0;U(633,e+160|0,d|0,e|0);d=v[113382];v[113382]=0;if((d|0)!=1){d=v[a+480204>>2];v[a+480204>>2]=d-((d>>>0)%1e4|0)+y[e>>2]%1e4;break i}d=P()|0;O()|0;break a}if(c){break i}v[113382]=0;u[e>>1]=0;U(638,e+160|0,d|0,e|0);d=v[113382];v[113382]=0;if((d|0)!=1){D=a,E=Ed(x[e>>1],x[a+480188>>1],127),u[D+480188>>1]=E;break i}d=P()|0;O()|0;break a}v[113382]=0;U(639,e+160|0,d|0,p|0);d=v[113382];v[113382]=0;if((d|0)==1){break b}break i}v[113382]=0;U(640,e+160|0,d|0,l|0);d=v[113382];v[113382]=0;if((d|0)==1){break b}break i}d=P()|0;O()|0;break a}v[113382]=0;v[e>>2]=0;U(633,e+160|0,d|0,e|0);d=v[113382];v[113382]=0;if((d|0)==1){break f}d=v[e>>2];if(!d){break i}v[a+1074308>>2]=d;break i}v[113382]=0;U(633,e+160|0,d|0,r|0);d=v[113382];v[113382]=0;if((d|0)!=1){break i}break b}if(v[a+480180>>2]==4){break i}v[113382]=0;U(638,e+160|0,d|0,e|0);d=v[113382];v[113382]=0;if((d|0)!=1){Ne(Vb(z),x[e>>1]);break i}d=P()|0;O()|0;break a}g=Xb(e);v[113382]=0;f=T(225,e+160|0)|0;d=v[113382];v[113382]=0;A:{if((d|0)==1){break A}v[113382]=0;W(641,e+160|0,g|0,f|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break A}v[113382]=0;U(13,e+144|0,0,g|0);d=v[113382];v[113382]=0;if((d|0)==1){break A}d=e+144|0;Gb(A,d);yb(d);yb(g);break i}d=P()|0;O()|0;yb(g);break a}if(d&1|d>>>0>126){break i}u[e>>1]=(d>>>1|0)- -64;v[113382]=0;u[e+144>>1]=127;f=Q(438,e|0,e+144|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break e}j=x[f>>1];if(j>>>0<65){break i}h=64;while(1){v[113382]=0;R(433,e|0,e+160|0);d=v[113382];v[113382]=0;if((d|0)==1){break d}d=Zc(e);f=e;B:{if(w[e|0]==255){break B}d=w[d|0];i=(h<<5)+a|0;g=i+480284|0;u[g>>1]=128;u[i+480286>>1]=d;i=i+480280|0;v[i>>2]=0;v[i>>2]=(w[f|0]&128)<<3;d=w[f|0]&127;t[f|0]=d;if(d>>>0<65){u[g>>1]=d<<2;d=w[f|0]}if((d|0)!=100){break B}v[i>>2]=v[i>>2]|256}h=h+1|0;if((j|0)!=(h|0)){continue}break}break i}d=P()|0;O()|0;break a}d=P()|0;O()|0;break a}d=P()|0;O()|0;yb(e+144|0);break a}d=P()|0;O()|0;Mf(g);break a}C:{D:{E:while(1){v[113382]=0;f=Q(228,e+160|0,1)|0;d=v[113382];v[113382]=0;if((d|0)==1){break D}if(!f|h>>>0>=110){break i}v[113382]=0;g=T(409,e+160|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break C}d=0;while(1){F:{if(!(!(g>>>d&1)|h>>>0>=110)){v[113382]=0;W(439,k|0,h|0,1)|0;f=v[113382];v[113382]=0;if((f|0)==1){break F}}h=h+1|0;d=d+1|0;if((d|0)!=8){continue}continue E}break}break}d=P()|0;O()|0;break a}d=P()|0;O()|0;break a}d=P()|0;O()|0;break a}v[113382]=0;U(633,e+160|0,d|0,o|0);d=v[113382];v[113382]=0;if((d|0)==1){break b}}Bb(e+160|0);if(Rb(b,7)){continue}break}}Vn(a+480204|0,B(v[v[a+8>>2]+20>>2],1e4),B(v[v[a+8>>2]+24>>2],1e4));if(v[a+480224>>2]>=3){v[p>>2]=0}if(v[l>>2]>=6){v[l>>2]=0}tc(q,256);tc(n,65536);tc(o,65536)}jb=e+176|0;return}d=P()|0;O()|0;break a}d=P()|0;O()|0;break a}d=P()|0;O()|0;break a}d=P()|0;O()|0;break a}d=P()|0;O()|0;break a}d=P()|0;O()|0}Bb(e+160|0);S(d|0);L()}function QL(a,b,c,d,e){var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=C(0),q=0,r=0,s=0,y=0,A=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=C(0),M=C(0),N=0,O=0,P=C(0),Q=0;j=jb-48|0;jb=j;i=x[a+480192>>1]?v[(B(b,896)+a|0)+1075640>>2]:i;q=a+1074312|0;f=B(b,896)+a|0;s=f+1075805|0;D=f+1075672|0;E=f+1075772|0;y=f+1075748|0;A=f+1075744|0;F=f+1075704|0;G=f+1075676|0;H=f+1075668|0;I=f+1075648|0;J=f+1075792|0;K=f+1075072|0;k=e&127;L=C(k>>>0);h=f+1075855|0;M=C(w[h|0]);n=255;l=1;while(1){e=w[d+o|0];if(e){f=e-48|0;a:{b:{c:{if((f&255)>>>0<10){break c}if((e-65&255)>>>0<=5){f=e-55|0;break c}d:{e:{f:{switch(e-97|0){case 2:g:{e=xl(a,b,3,0);if((e-1&255)>>>0>249){break g}e=v[(B(e,160)+a|0)+906140>>2];if(!e){break g}e=wv(e,75096,75104);if(!e){break g}f=nb[v[v[e>>2]+184>>2]](e,b)|0;e=(f|0)!=255;f=e?f:0;if(e|!i){break c}break d}if(i){break d}f=0;break c;case 13:f=0;if(!Xd(w[s|0])){break e}f=w[s|0]-1|0;break e;case 21:e=j+8|0;Fb(e,q,28);h:{if(!Cb(e)){Fb(j,q,1);e=0;if(!Cb(j)){break h}}e=u[E>>1]}f=B(v[y>>2],v[A>>2]);e=B(v[a+1074444>>2],e+v[D>>2]|0);f=Yb((zc(rma(qma(f,f>>31,e,e>>31),mb,1048576,0),mb)|0)/2|0,1,127);break e;case 23:v[j+8>>2]=v[G>>2]/2;v[j>>2]=127;f=v[Zd(j+8|0,j)>>2];break e;case 24:v[j+8>>2]=v[H>>2]/2;v[j>>2]=127;f=v[Zd(j+8|0,j)>>2];break e;case 0:f=0;if(!i){break e}e=x[i+28>>1];if(!e){break e}f=e-1>>>7&127;break e;case 1:f=0;if(!i){break e}e=x[i+28>>1];if(!e){break e}f=e-1&127;break e;case 14:f=v[I>>2]>>>8|0;break e;case 7:e=b;if(e>>>0>=x[a+480188>>1]){e=w[J|0]-1|0}f=e&127;break e;case 12:f=w[K|0]>>>7|0;break e;case 15:f=0;if(!i){break e}e=w[i+30|0];if(!e){break e}f=e-1&127;break e;case 25:i:{if(!c|t[h|0]<0){break i}j:{if(g>>>0<3){break j}e=(j+16|0)+g|0;if(w[e-3|0]!=240){break j}if(w[e-2|0]>239){break i}}e=h;p=$o(a,M,L);k:{if(p<C(4294967296)&p>=C(0)){f=~~p>>>0;break k}f=0}t[e|0]=f;n=128;break e}n=(n&255)==255?k:n;f=k;break e;case 18:e=g;l:{if(!e){e=0;break l}while(1){e=e-1|0;if(w[e+(j+16|0)|0]==240){break l}if(e){continue}break}}if(w[(j+16|0)+e|0]!=240|g-e>>>0<5){break a}f=0;e=e+5|0;if((g|0)!=(e|0)){while(1){f=w[(j+16|0)+e|0]+f|0;e=e+1|0;if((g|0)!=(e|0)){continue}break}}f=0-f&127;break e;case 20:break f;default:break a}}e=B(v[y>>2],v[A>>2]);r=e;m=e>>31;e=B(v[a+1074444>>2],v[F>>2]);f=Yb((zc(rma(qma(r,m,e,e>>31),mb,67108864,0),mb)|0)/2|0,1,127)}e=((l^-1)&1)+g|0;t[e+(j+16|0)|0]=f;g=e+1|0;l=1;break b}e=i;m=a;f=0;r=b;m:{if(b>>>0>=256){break m}if(w[e+31|0]==17){e=x[(m+B(r,896)|0)+1075792>>1];f=(e?e-1|0:r)&15;break m}if(!zi(e)){break m}f=w[e+31|0]-1&15}}e=(j+16|0)+g|0;n:{if(l&1){t[e|0]=f;break n}t[e|0]=w[e|0]<<4|f;g=g+1|0}l=(l^-1)&1}}o=o+1|0;if((o|0)!=31){continue}}break}e=((l^-1)&1)+g|0;if(n<<24>>24>=0){t[h|0]=n}o:{if(!e){break o}f=0;l=0;while(1){m=(j+16|0)+l|0;d=t[m|0];p:{q:{r:{if((d|0)==-16){if(e-l>>>0>=4){o=4;if((w[(j+l|0)+17|0]&254)==240){break q}}o=l;s:{while(1){o=o+1|0;if(o>>>0>=e>>>0){break s}if(w[(j+16|0)+o|0]!=247){continue}break}d=o-l|0;o=d+1|0;if(o>>>0>=d>>>0){break q}}t[(j+16|0)+e|0]=247;e=e+1|0;o=e-l|0;break r}if((d|0)>=0){if(f&255){l=l-1|0;t[l+(j+16|0)|0]=f;break p}l=l+1|0;f=0;break p}N=j,O=mO(d&255),v[N+8>>2]=O;v[j>>2]=e-l;o=v[Lb(j+8|0,j)>>2]}if(!o){break o}d=w[m|0];f=d>>>0<240?d:f}h=a;k=b;r=c;i=0;n=jb-32|0;jb=n;d=o;v[n+28>>2]=d;t:{if(!d){break t}g=w[m|0];q=g-250|0;if(!(q>>>0>5|!(1<<q&37))){if(x[h+480188>>1]){g=0;while(1){q=(h+B(g,896)|0)+1075841|0;t[q|0]=127;t[q+1|0]=0;g=g+1|0;if(g>>>0<x[h+480188>>1]){continue}break}}g=w[m|0]}u:{if((g&255)!=240){break u}g=w[m+1|0];if((g&254)!=240){break u}if(d>>>0<4){break t}q=(h+B(k,896)|0)+1074984|0;d=t[m+3|0];v:{w:{x:{y:{z:{A:{m=w[m+2|0];switch(m|0){case 3:break x;case 2:break y;case 1:break z;case 0:break A;default:break w}}if((g|0)==241|(d|0)<0){break w}g=h+B(k,896)|0;i=g+1075841|0;m=i;if(r){d=PL($o(h,C(w[i|0]),C((d&255)>>>0)))}t[m|0]=d;t[g+1075802|0]=0;i=4;d=g+1075072|0;g=ip(h,q,!(v[d>>2]&32768),256);if((g|0)<0|!(w[d+1|0]&2)){break t}d=h+1304392|0;if(!qd(d)){break t}np(v[d>>2],k,g>>>2&255,1);break t}if((g|0)==241|(d|0)<0){break w}i=h+B(k,896)|0;g=i+1075842|0;B:{if(!r){break B}p=$o(h,C(w[g|0]),C((d&255)>>>0));if(p<C(4294967296)&p>=C(0)){d=~~p>>>0;break B}d=0}t[g|0]=d;t[i+1075801|0]=0;ip(h,q,!(v[i+1075072>>2]&32768),256);i=4;break t}if((g|0)==241){break v}i=4;if((d&255)>>>0>31){break t}g=h+B(k,896)|0;t[g+1075849|0]=(d&240)>>>4;ip(h,q,!(v[g+1075072>>2]&32768),256);break t}if((g|0)==241){break v}i=4;g=xl(h,k,3,0);if((d|0)<0|(g-1&255)>>>0>249){break t}g=(h+B(g,160)|0)+906284|0;p=C(C(((d^127)&255)>>>0)*C(.007874015718698502));if(!r){z[g>>2]=p;break t}N=g,P=$o(h,z[g>>2],p),z[N>>2]=P;break t}if(m&128){break v}if((g|0)!=241){break t}}i=4;k=xl(h,k,3,0);if((k-1&255)>>>0>249){break t}k=v[(h+B(k,160)|0)+906140>>2];if(!k|(d|0)<0){break t}g=(g|0)==241?m+128|0:m&127;p=C(C((d&255)>>>0)*C(.007874015718698502));if(!r){nb[v[v[k>>2]+44>>2]](k,g,p);break t}O=k,Q=g,P=$o(h,C(nb[v[v[k>>2]+48>>2]](k,g)),p),N=v[v[k>>2]+44>>2],nb[N](O|0,Q|0,C(P));break t}C:{D:{E:{if(k>>>0<x[h+480188>>1]){g=k+1|0;break E}g=x[(h+B(k,896)|0)+1075792>>1];if(!g){break D}}if(w[(h+B(k,896)|0)+1075075|0]&4|x[h+480188>>1]<(g&65535)>>>0){break D}i=xl(h,k,3,0);if((i-1&255)>>>0>249){break D}i=v[(h+B(i,160)|0)+906140>>2];if(!i){break D}h=w[m|0];if((h|0)!=240){break C}h=n+16|0;fc(h,Eb(m),d);nb[v[v[i>>2]+72>>2]](i,h)|0}i=d;break t}N=n,Q=mO(h),v[N+12>>2]=Q;d=n+12|0;h=v[Lb(d,n+28|0)>>2];v[n+12>>2]=0;lc(d,m,h);nb[v[v[i>>2]+68>>2]](i,v[n+12>>2])|0;i=v[n+28>>2]}jb=n+32|0;l=(i?i:o)+l|0}if(e>>>0>l>>>0){continue}break}}jb=j+48|0}function Uga(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=jb-352|0;jb=d;Nc(b,60);i=15;a:{if(!sh(b,10057)){Nc(b,124);i=31;if(!sh(b,11366)){break a}}Id(a,536870912);u[a+480190>>1]=i;Ic(b);b:{if(x[a+480190>>1]){while(1){e=au(b);v[(d+224|0)+(f<<2)>>2]=e;if(e>>>0>131072){break b}f=f+1|0;if(f>>>0<x[a+480190>>1]){continue}break}}v[a+480260>>2]=56;v[a+480264>>2]=13696;v[a+480196>>2]=6;f=0;u[a+480192>>1]=0;u[a+480188>>1]=4;v[a+480228>>2]=64;mj(a,1);_b(b,4);h=Zp(b);if(h>>>0<178){break a}e=a;p=177693e5/+(h>>>0);c:{if(p<4294967296&p>=0){h=~~p>>>0;break c}h=0}v[e+480204>>2]=h;_b(b,14);d:{e:{f:{if(x[a+480190>>1]){m=d+78|0;l=1;i=0;n=1;while(1){f=d+56|0;cQ(b,f);e=v[((l<<2)+d|0)+220>>2];o=jb-16|0;jb=o;g=(B(l,104)+a|0)+484380|0;sd(g,1);v[g>>2]=e;t[g+37|0]=w[f+24|0]<<4;t[o+15|0]=w[f+25|0];t[o+14|0]=64;q=g,r=w[pc(o+15|0,o+14|0)|0]<<2,u[q+30>>1]=r;e=f+26|0;e=w[e|0]|w[e+1|0]<<8;k=f+28|0;h=v[g>>2];g:{if(!h){break g}j=w[k|0]|w[k+1|0]<<8;k=(e<<8|e>>>8)&65535;v[g+4>>2]=k;e=(((j<<8|j>>>8)&65535)<<1)+k|0;v[g+8>>2]=e;if(h>>>0<=k>>>0){k=h-1|0;v[g+4>>2]=k}if(e>>>0>h>>>0){v[g+8>>2]=h;e=h}if(!(!(e>>>0<4|e>>>0<k>>>0)&e-k>>>0>3)){v[g+4>>2]=0;v[g+8>>2]=0;break g}if(e>>>0<=k>>>0){break g}u[g+34>>1]=x[g+34>>1]|2}jb=o+16|0;while(1){if((w[f|0]-1&255)>>>0<=30){t[f|0]=32;i=i+1|0}f=f+1|0;if((m|0)!=(f|0)){continue}break}if(i>>>0>127){break b}e=d+192|0;Vl(e,3,d+56|0);h=d+208|0;Ec(h,e);v[113382]=0;Q(335,((l<<5)+a|0)+946304|0,h|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break f}yb(d+208|0);n=n+1|0;l=n&65535;if(l>>>0<=x[a+480190>>1]){continue}break}}e=Ub(d+56|0,9942);v[113382]=0;f=a+946336|0;h=Q(965,f|0,e|0)|0;g=v[113382];v[113382]=0;i=1;h:{i:{j:{k:{if((g|0)!=1){if(!h){v[113382]=0;h=Q(121,d+208|0,9953)|0;i=v[113382];v[113382]=0;if((i|0)==1){break k}v[113382]=0;i=Q(965,f|0,h|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break j}yb(h)}yb(e);f=0;if(!vz(b,d+56|0)){break a}if(!PO(d+56|0)){break a}if(c){break h}break d}f=P()|0;O()|0;break i}f=P()|0;O()|0;break i}f=P()|0;O()|0;yb(h)}yb(e);break e}u[d+54>>1]=0;if(w[d+56|0]){while(1){u[d+208>>1]=w[(d+f|0)+58|0]+1;q=d,r=x[Ri(d+54|0,d+208|0)>>1],u[q+54>>1]=r;f=f+1|0;if(f>>>0<w[d+56|0]){continue}break}}e=d+56|1;h=w[e|0];f=w[d+56|0];g=a+484360|0;Ne(Vb(g),f>>>0>h>>>0?w[e|0]:0);En(Vb(g),d+56|2,w[d+56|0],65535,65535);if(x[a+480190>>1]==31){_b(b,4)}l=0;v[d+48>>2]=0;v[d+44>>2]=0;v[d+40>>2]=0;t[d+39|0]=0;k=c&1;if(k){dg(a+484344|0,x[d+54>>1])}if(x[d+54>>1]){h=a+484344|0;while(1){l:{m:{if(k){n=0;if(Og(h,l&65535,64)){break m}}_b(b,1024);break l}while(1){o=Bf(Zb(h,l),n,0);f=0;while(1){g=d+208|0;Ul(g,b);e=o+B(f,6)|0;n:{o:{if(w[ec(g,0)|0]!=255){break o}t[(d+48|0)+f|0]=0;t[(d+40|0)+f|0]=0;p:{if(!i){break p}if(w[ec(d+208|0,1)|0]!=252){break p}q=ec(d+208|0,1),r=254,t[q|0]=r}q:{switch(w[ec(d+208|0,1)|0]-252|0){case 2:t[e+3|0]=13;break n;case 1:break n;case 0:break q;default:break o}}t[e+3|0]=14;t[d+39|0]=9;break n}g=v[d+208>>2];v[d+32>>2]=g;v[d+12>>2]=g;mt(d+12|0,e);g=w[e|0];r:{if(!g){break r}t[(d+40|0)+f|0]=0;t[(d+48|0)+f|0]=g;if(g>>>0>48){break r}t[d+192|0]=8;q=d,r=w[th(d+39|0,d+192|0)|0],t[q+39|0]=r}s:{t:{u:{v:{w:{x:{switch(w[e+3|0]){case 1:t[e+3|0]=1;break n;case 2:g=w[e+5|0];if(g&240){t[e+3|0]=3;t[e+5|0]=g>>>4;break n}g=g&15;if(g){t[e+3|0]=2;t[e+5|0]=g;break n}t[e+5|0]=0;break t;case 3:if(w[(d+40|0)+f|0]){break u}t[e+3|0]=19;t[e+5|0]=0;break n;case 4:if(w[(d+40|0)+f|0]){break u}t[e+3|0]=19;t[e+5|0]=1;break n;case 5:if(!w[e+1|0]){break u}t[e+3|0]=13;t[d+192|0]=63;t[d+31|0]=w[e+5|0]+(x[(B(w[e+1|0],104)+a|0)+484410>>1]>>>2|0);q=e,r=w[pc(d+192|0,d+31|0)|0],t[q+5|0]=r;if(!w[(d+40|0)+f|0]){break w}t[e+2|0]=1;t[e+4|0]=w[e+5|0];t[e+5|0]=0;break t;case 6:g=w[e+1|0];if(!g){break u}t[e+3|0]=13;g=x[(B(g,104)+a|0)+484410>>1]>>>2|0;j=w[e+5|0];g=g>>>0<j>>>0?0:g-j|0;t[e+5|0]=g;if(!w[(d+40|0)+f|0]){break w}t[e+4|0]=g;t[e+2|0]=1;t[e+5|0]=0;break t;case 8:j=w[(d+48|0)+f|0];g=w[e+5|0];m=j+(g>>>4|0)|0;t[(d+44|0)+f|0]=m;t[e+3|0]=2;g=g&15;t[(d+40|0)+f|0]=g;q=e,r=OO(g,j,m&255),t[q+5|0]=r;break w;case 9:t[d+192|0]=8;q=d,r=w[th(d+39|0,d+192|0)|0],t[q+39|0]=r;break t;case 0:break v;case 7:break x;default:break t}}g=w[(d+48|0)+f|0];j=w[e+5|0];m=g-(j>>>4|0)|0;t[(d+44|0)+f|0]=m;t[e+3|0]=3;j=j&15;t[(d+40|0)+f|0]=j;q=e,r=OO(j,m&255,g),t[q+5|0]=r}if(!w[e+3|0]){break s}break n}if(!w[e+5|0]){break s}break t}t[e+5|0]=0}t[e+3|0]=0}j=w[(d+40|0)+f|0];if(!j){break n}m=(d+44|0)+f|0;g=w[m|0];if(g){t[(d+48|0)+f|0]=g;t[e|0]=g;t[e+5|0]=j;t[m|0]=0}t[e+3|0]=4}f=f+1|0;if((f|0)!=4){continue}break}n=n+1|0;if((n|0)!=64){continue}break}}l=l+1|0;if(l>>>0<x[d+54>>1]){continue}break}}y:{z:{A:{B:{C:{D:{if(c&2){i=x[a+480190>>1];if(!i){break C}f=1;while(1){c=(B(f&65535,104)+a|0)+484380|0;if(v[c>>2]){zg(Yc(d+208|0,8,1,0,0),c,b);i=x[a+480190>>1]}f=f+1|0;if((f&65535)>>>0<=(i&65535)>>>0){continue}break}break D}i=x[a+480190>>1]}if((i&65535)!=15){break C}b=Ub(d+16|0,11625);v[113382]=0;R(189,d+192|0,b|0);c=v[113382];v[113382]=0;f=1;if((c|0)==1){break z}v[113382]=0;U(500,d+208|0,d+192|0,d+39|0);c=v[113382];v[113382]=0;if((c|0)!=1){break B}f=P()|0;O()|0;Ib(d+192|0);break y}f=0;v[113382]=0;Q(2,d+208|0,8291)|0;b=v[113382];v[113382]=0;if((b|0)==1){break A}}b=d+208|0;Gb(a+1304436|0,b);yb(b);if(f){Ib(d+192|0);yb(d+16|0)}Kc(a+1304448|0,x[a+480190>>1]==15?1768:10919);v[a+1304496>>2]=2;break d}f=P()|0;O()|0;break e}f=P()|0;O()|0}yb(b);break e}f=P()|0;O()|0;yb(d+208|0)}S(f|0);L()}f=1;break a}f=0}jb=d+352|0;return f|0}function R0(a,b,c,d,e,f){a=a|0;b=+b;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,u=0,x=0,y=0,z=0,A=0,C=0,E=0,F=0,G=0,H=0;m=jb-560|0;jb=m;v[m+44>>2]=0;o(+b);g=j(1)|0;j(0)|0;a:{if((g|0)<0){A=1;C=1782;b=-b;o(+b);g=j(1)|0;j(0)|0;break a}if(e&2048){A=1;C=1785;break a}A=e&1;C=A?1788:1783;F=!A}b:{if((g&2146435072)==2146435072){i=A+3|0;Lf(a,32,c,i,e&-65537);Re(a,C,A);d=f&32;Re(a,b!=b?d?6071:9763:d?7097:10072,3);break b}y=m+16|0;c:{d:{e:{b=oG(b,m+44|0);b=b+b;if(b!=0){g=v[m+44>>2];v[m+44>>2]=g-1;s=f|32;if((s|0)!=97){break e}break c}s=f|32;if((s|0)==97){break c}l=v[m+44>>2];n=(d|0)<0?6:d;break d}l=g-29|0;v[m+44>>2]=l;b=b*268435456;n=(d|0)<0?6:d}q=(l|0)<0?m+48|0:m+336|0;h=q;while(1){d=h;if(b<4294967296&b>=0){g=~~b>>>0}else{g=0}v[d>>2]=g;h=h+4|0;b=(b-+(g>>>0))*1e9;if(b!=0){continue}break}f:{if((l|0)<=0){d=l;g=h;k=q;break f}k=q;d=l;while(1){p=d>>>0<29?d:29;g=h-4|0;g:{if(k>>>0>g>>>0){break g}d=p;i=0;while(1){u=g;G=i;x=v[g>>2];r=d&31;if((d&63)>>>0>=32){i=x<<r;x=0}else{i=(1<<r)-1&x>>>32-r;x=x<<r}r=G+x|0;i=i+H|0;i=r>>>0<x>>>0?i+1|0:i;i=tma(r,i,1e9,0);x=u;u=qma(i,mb,1e9,0);v[x>>2]=r-u;g=g-4|0;if(k>>>0<=g>>>0){continue}break}if(!i){break g}k=k-4|0;v[k>>2]=i}while(1){g=h;if(k>>>0<g>>>0){h=g-4|0;if(!v[h>>2]){continue}}break}d=v[m+44>>2]-p|0;v[m+44>>2]=d;h=g;if((d|0)>0){continue}break}}h=(n+25|0)/9|0;if((d|0)<0){p=h+1|0;E=(s|0)==102;while(1){d=0-d|0;i=d>>>0<9?d:9;h:{if(g>>>0>k>>>0){u=1e9>>>i|0;r=-1<<i^-1;d=0;h=k;while(1){x=d;d=v[h>>2];v[h>>2]=x+(d>>>i|0);d=B(u,d&r);h=h+4|0;if(h>>>0<g>>>0){continue}break}h=v[k>>2];if(!d){break h}v[g>>2]=d;g=g+4|0;break h}h=v[k>>2]}d=i+v[m+44>>2]|0;v[m+44>>2]=d;k=(!h<<2)+k|0;h=E?q:k;g=(p|0)<g-h>>2?h+(p<<2)|0:g;if((d|0)<0){continue}break}}h=0;i:{if(g>>>0<=k>>>0){break i}h=B(q-k>>2,9);d=10;i=v[k>>2];if(i>>>0<10){break i}while(1){h=h+1|0;d=B(d,10);if(i>>>0>=d>>>0){continue}break}}d=(n-((s|0)==102?0:h)|0)-((s|0)==103&(n|0)!=0)|0;if((d|0)<(B(g-q>>2,9)-9|0)){i=((l|0)<0?4:292)+m|0;l=d+9216|0;p=(l|0)/9|0;i=(i+(p<<2)|0)-4048|0;d=10;l=l-B(p,9)|0;if((l|0)<=7){while(1){d=B(d,10);l=l+1|0;if((l|0)!=8){continue}break}}p=v[i>>2];u=(p>>>0)/(d>>>0)|0;l=p-B(d,u)|0;r=i+4|0;j:{if(!l&(r|0)==(g|0)){break j}b=(g|0)==(r|0)?1:1.5;r=d>>>1|0;z=l>>>0<r>>>0?.5:(r|0)==(l|0)?b:1.5;b=u&1?9007199254740994:9007199254740992;if(!(w[C|0]!=45|F)){z=-z;b=-b}l=p-l|0;v[i>>2]=l;if(b+z==b){break j}d=d+l|0;v[i>>2]=d;if(d>>>0>=1e9){while(1){v[i>>2]=0;i=i-4|0;if(i>>>0<k>>>0){k=k-4|0;v[k>>2]=0}d=v[i>>2]+1|0;v[i>>2]=d;if(d>>>0>999999999){continue}break}}h=B(q-k>>2,9);d=10;l=v[k>>2];if(l>>>0<10){break j}while(1){h=h+1|0;d=B(d,10);if(l>>>0>=d>>>0){continue}break}}d=i+4|0;g=d>>>0<g>>>0?d:g}while(1){l=g;d=g>>>0<=k>>>0;if(!d){g=l-4|0;if(!v[g>>2]){continue}}break}k:{if((s|0)!=103){s=e&8;break k}g=n?n:1;i=(g|0)>(h|0)&(h|0)>-5;n=(i?h^-1:-1)+g|0;f=(i?-1:-2)+f|0;s=e&8;if(s){break k}g=-9;l:{if(d){break l}p=v[l-4>>2];if(!p){break l}d=10;g=0;if((p>>>0)%10|0){break l}while(1){i=g;g=g+1|0;d=B(d,10);if(!((p>>>0)%(d>>>0)|0)){continue}break}g=i^-1}d=B(l-q>>2,9);if((f&-33)==70){s=0;d=(d+g|0)-9|0;d=(d|0)>0?d:0;n=(d|0)>(n|0)?n:d;break k}s=0;d=((d+h|0)+g|0)-9|0;d=(d|0)>0?d:0;n=(d|0)>(n|0)?n:d}p=(n|s)!=0;d=a;x=c;u=f&-33;if((u|0)==70){f=(h|0)>0?h:0}else{g=h>>31;g=Gm(g+h^g,0,y);if((y-g|0)<=1){while(1){g=g-1|0;t[g|0]=48;if((y-g|0)<2){continue}break}}E=g-2|0;t[E|0]=f;t[g-1|0]=(h|0)<0?45:43;f=y-E|0}i=(f+(p+(n+A|0)|0)|0)+1|0;Lf(d,32,x,i,e);Re(a,C,A);Lf(a,48,c,i,e^65536);m:{n:{o:{if((u|0)==70){f=m+16|0;d=f|8;f=f|9;k=k>>>0>q>>>0?q:k;h=k;while(1){g=Gm(v[h>>2],0,f);p:{if((h|0)!=(k|0)){if(m+16>>>0>=g>>>0){break p}while(1){g=g-1|0;t[g|0]=48;if(m+16>>>0<g>>>0){continue}break}break p}if((f|0)!=(g|0)){break p}t[m+24|0]=48;g=d}Re(a,g,f-g|0);h=h+4|0;if(q>>>0>=h>>>0){continue}break}g=0;if(!p){break n}Re(a,12869,1);if((n|0)<=0|h>>>0>=l>>>0){break o}while(1){g=Gm(v[h>>2],0,f);if(g>>>0>m+16>>>0){while(1){g=g-1|0;t[g|0]=48;if(m+16>>>0<g>>>0){continue}break}}Re(a,g,(n|0)<9?n:9);g=n-9|0;h=h+4|0;if(l>>>0<=h>>>0){break n}d=(n|0)>9;n=g;if(d){continue}break}break n}q:{if((n|0)<0){break q}q=k>>>0<l>>>0?l:k+4|0;d=m+16|0;f=d|9;d=d|8;h=k;while(1){g=Gm(v[h>>2],0,f);if((f|0)==(g|0)){t[m+24|0]=48;g=d}r:{if((h|0)!=(k|0)){if(m+16>>>0>=g>>>0){break r}while(1){g=g-1|0;t[g|0]=48;if(m+16>>>0<g>>>0){continue}break}break r}Re(a,g,1);g=g+1|0;if(!(n|s)){break r}Re(a,12869,1)}l=g;g=f-g|0;Re(a,l,(g|0)<(n|0)?g:n);n=n-g|0;h=h+4|0;if(q>>>0<=h>>>0){break q}if((n|0)>=0){continue}break}}Lf(a,48,n+18|0,18,0);Re(a,E,y-E|0);break m}g=n}Lf(a,48,g+9|0,9,0)}break b}n=(f<<26>>31&9)+C|0;s:{if(d>>>0>11){break s}g=12-d|0;z=8;while(1){z=z*16;g=g-1|0;if(g){continue}break}if(w[n|0]==45){b=-(z+(-b-z));break s}b=b+z-z}h=v[m+44>>2];g=h>>31;g=Gm(g^g+h,0,y);if((y|0)==(g|0)){t[m+15|0]=48;g=m+15|0}q=A|2;l=f&32;h=v[m+44>>2];k=g-2|0;t[k|0]=f+15;t[g-1|0]=(h|0)<0?45:43;i=e&8;h=m+16|0;while(1){f=h;u=l;if(D(b)<2147483648){g=~~b}else{g=-2147483648}t[h|0]=u|w[g+49040|0];b=(b-+(g|0))*16;h=f+1|0;if(!(!(i?1:(d|0)>0|b!=0)|(h-(m+16|0)|0)!=1)){t[f+1|0]=46;h=f+2|0}if(b!=0){continue}break}f=m+16|0;d=!d|((h-m|0)-18|0)>=(d|0)?(y-(f+k|0)|0)+h|0:((d+y|0)-k|0)+2|0;i=d+q|0;Lf(a,32,c,i,e);Re(a,n,q);Lf(a,48,c,i,e^65536);g=f;f=h-f|0;Re(a,g,f);g=d;d=y-k|0;Lf(a,48,g-(d+f|0)|0,0,0);Re(a,k,d)}Lf(a,32,c,i,e^8192);jb=m+560|0;return((c|0)>(i|0)?c:i)|0}function tia(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;d=jb-224|0;jb=d;Ic(b);a:{b:{c:{d:{e:{f:{if(!Ot(b,d+208|0)){break f}if(!_P(d+208|0)){break f}h=Vh(d+192|0);i=bd(d+176|0);Qb(d+112|0,0,64);v[113382]=0;f=Q(851,b|0,d+104|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break c}g:{if(!f){break g}f=d+104|4;g=w[f|0]|w[f+1|0]<<8|(w[f+2|0]<<16|w[f+3|0]<<24);g=(g<<8&16711680|g<<24|(g>>>8&65280|g>>>24))-4|0;g=g<<24|g<<8&16711680|(g>>>8&65280|g>>>24);t[f|0]=g;t[f+1|0]=g>>>8;t[f+2|0]=g>>>16;t[f+3|0]=g>>>24;g=0;h:{i:{j:{while(1){e=w[f|0]|w[f+1|0]<<8|(w[f+2|0]<<16|w[f+3|0]<<24);e=(e<<8&16711680|e<<24|(e>>>8&65280|e>>>24))-8|0;e=e<<24|e<<8&16711680|(e>>>8&65280|e>>>24);t[f|0]=e;t[f+1|0]=e>>>8;t[f+2|0]=e>>>16;t[f+3|0]=e>>>24;k:{if(c){break k}e=d+104|0;if((w[e|0]|w[e+1|0]<<8|(w[e+2|0]<<16|w[e+3|0]<<24))!=1413764176){break k}g=1;break g}e=w[f|0]|w[f+1|0]<<8|(w[f+2|0]<<16|w[f+3|0]<<24);v[113382]=0;U(307,d+24|0,b|0,e<<8&16711680|e<<24|(e>>>8&65280|e>>>24));e=v[113382];v[113382]=0;l:{m:{n:{o:{p:{if((e|0)!=1){v[113382]=0;e=T(303,d+24|0)|0;j=v[113382];v[113382]=0;if((j|0)==1){break o}if(e){break p}Bb(d+24|0);break l}a=P()|0;O()|0;break a}e=d+104|0;e=w[e|0]|w[e+1|0]<<8|(w[e+2|0]<<16|w[e+3|0]<<24);e=e<<24|e<<8&16711680|(e>>>8&65280|e>>>24);if((e|0)<=1347699795){if((e|0)==1129139796){break n}if((e|0)!=1229866575){break m}v[113382]=0;k=Q(852,d+24|0,d+112|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break o}break m}if((e|0)!=1347699796){if((e|0)!=1447383635){break m}v[113382]=0;Q(304,d+24|0,4)|0;e=v[113382];v[113382]=0;if((e|0)==1){break o}v[113382]=0;e=Q(853,d+24|0,9624)|0;j=v[113382];v[113382]=0;if((j|0)==1){break o}if(!e){break m}e=w[f|0]|w[f+1|0]<<8|(w[f+2|0]<<16|w[f+3|0]<<24);if((e<<24|e<<8&16711680|(e>>>8&65280|e>>>24))>>>0<7){break m}e=w[f|0]|w[f+1|0]<<8|(w[f+2|0]<<16|w[f+3|0]<<24);v[113382]=0;aa(854,d+24|0,i|0,2,(e<<8&16711680|e<<24|(e>>>8&65280|e>>>24))-6|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break o}break m}v[113382]=0;g=W(855,a|0,d+24|0,c|0)|0;e=v[113382];v[113382]=0;if((e|0)!=1){break m}}a=P()|0;O()|0;Bb(d+24|0);break a}ZP(h,d+24|0)}Bb(d+24|0);v[113382]=0;e=Q(851,b|0,d+104|0)|0;j=v[113382];v[113382]=0;if((j|0)==1){break j}if(e){continue}}break}if(Sc(i)){v[113382]=0;b=Q(2,d+24|0,10558)|0;c=v[113382];v[113382]=0;if((c|0)==1){break i}Gb(i,b);yb(b)}if(!(g&k&1)){break h}b=d+154|0;b=w[b|0]|w[b+1|0]<<8;v[113382]=0;c=b&1;W(439,a+1074312|0,5,!c|0)|0;b=v[113382];v[113382]=0;q:{r:{s:{if((b|0)!=1){b=d+150|0;if(w[b|0]|w[b+1|0]<<8){u[d+24>>1]=64;b=w[b|0]|w[b+1|0]<<8;v[113382]=0;u[d+88>>1]=b<<8|b>>>8;b=Q(438,d+24|0,d+88|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break s}v[a+480228>>2]=x[b>>1]}b=d+152|0;if(!(!(w[b|0]|w[b+1|0]<<8)|!c)){b=w[b|0]|w[b+1|0]<<8;v[a+480204>>2]=B((b<<8|b>>>8)&65535,1e4)}if(w[d+112|0]){v[113382]=0;U(355,d+88|0,2,d+112|0);b=v[113382];v[113382]=0;if((b|0)==1){break r}v[113382]=0;R(356,d+24|0,d+88|0);b=v[113382];v[113382]=0;if((b|0)==1){break r}b=d+24|0;Gb(a+1304400|0,b);yb(b)}b=x[d+158>>1];u[d+86>>1]=b;u[d+22>>1]=b;if(!zp(d+22|0,1,12)){break h}b=x[d+156>>1];u[d+84>>1]=b;u[d+20>>1]=b;if(!zp(d+20|0,1,31)){break h}b=x[d+162>>1];u[d+82>>1]=b;u[d+18>>1]=b;if(!zp(d+18|0,0,23)){break h}b=x[d+164>>1];u[d+80>>1]=b;u[d+16>>1]=b;if(!zp(d+16|0,0,59)){break h}b=x[d+166>>1];u[d+78>>1]=b;u[d+14>>1]=b;if(zp(d+14|0,0,59)){break q}break h}a=P()|0;O()|0;break a}a=P()|0;O()|0;break a}a=P()|0;O()|0;break a}b=Vp(d+24|0);c=d+160|0;c=w[c|0]|w[c+1|0]<<8;v[b+20>>2]=(c<<8|c>>>8)&65535;c=d+158|0;c=w[c|0]|w[c+1|0]<<8;v[b+16>>2]=((c<<8|c>>>8)&65535)-1;c=d+156|0;c=w[c|0]|w[c+1|0]<<8;v[b+12>>2]=(c<<8|c>>>8)&65535;c=d+162|0;c=w[c|0]|w[c+1|0]<<8;v[b+8>>2]=(c<<8|c>>>8)&65535;c=d+164|0;c=w[c|0]|w[c+1|0]<<8;v[b+4>>2]=(c<<8|c>>>8)&65535;c=d+166|0;c=w[c|0]|w[c+1|0]<<8;v[b>>2]=(c<<8|c>>>8)&65535;v[113382]=0;R(624,a+1304500|0,b|0);b=v[113382];v[113382]=0;if((b|0)!=1){break h}a=P()|0;O()|0;break a}a=P()|0;O()|0;break a}a=P()|0;O()|0;break a}if(g&1){v[113382]=0;b=T(303,h|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break c}if(b){b=Xb(d+24|0);v[113382]=0;W(442,h|0,b|0,32)|0;c=v[113382];v[113382]=0;if((c|0)==1){break b}if(Jt(b,9726)){v[113382]=0;U(13,d+88|0,2,b|0);c=v[113382];v[113382]=0;if((c|0)==1){break b}c=d+88|0;Gb(a+1304412|0,c);yb(c)}v[113382]=0;c=T(856,h|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break b}if(!c){v[113382]=0;c=T(296,h|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break b}v[113382]=0;ea(510,a+1304424|0,h|0,c|0,40,0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break b}}yb(b)}v[113382]=0;b=Q(2,d+88|0,13459)|0;c=v[113382];v[113382]=0;if((c|0)==1){break e}v[113382]=0;U(684,d+24|0,b|0,i|0);c=v[113382];v[113382]=0;if((c|0)==1){break d}c=d+24|0;Gb(a+1304460|0,c);yb(c);yb(b)}v[a+480208>>2]=v[a+480208>>2]|2097152;v[113382]=0;a=a+1074312|0;W(439,a|0,84,1)|0;b=v[113382];v[113382]=0;if((b|0)==1){break c}v[113382]=0;W(439,a|0,83,1)|0;b=v[113382];v[113382]=0;if((b|0)==1){break c}v[113382]=0;Q(440,a|0,85)|0;a=v[113382];v[113382]=0;if((a|0)==1){break c}}yb(i);Bb(h)}jb=d+224|0;return g&1}a=P()|0;O()|0;break a}a=P()|0;O()|0;yb(b);break a}a=P()|0;O()|0;break a}a=P()|0;O()|0;yb(b)}yb(i);Bb(h);S(a|0);L()}function xia(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,y=0,z=0;e=jb-1824|0;jb=e;Ic(b);h=jb-16|0;jb=h;i=h+8|0;j=e+1224|0;TP(i,j);l=Hb(i);d=b;i=mc(d,$b(h,i));if((l|0)==(i|0)){_b(d,Hb(h+8|0))}jb=h+16|0;d=(i|0)==(l|0);if(!d){UP(j)}a:{if(!d){break a}if(!bQ(e+1224|0)){break a}if(!uz(b,16,0)){break a}v[e+1216>>2]=v[e+1240>>2];d=v[e+1228>>2];v[e+1200>>2]=v[e+1224>>2];v[e+1204>>2]=d;d=e+1232|0;g=v[d+4>>2];v[e+1208>>2]=v[d>>2];v[e+1212>>2]=g;Id(a,1);d=a+1074312|0;ig(d,83);Nb(d,84,1);Nb(d,85,1);u[a+480188>>1]=4;v[e+1196>>2]=0;u[a+480190>>1]=15;Nc(b,20);l=a+480188|0;g=1;i=1;while(1){h=B(g,104)+a|0;j=h+484380|0;d=((g<<5)+a|0)+946304|0;wz(b,e+16|0,j,d,1);n=v[j>>2];b:{if(!w[ec(d,0)|0]){break b}c:{if(md(d,12871,3)){if(md(d,12875,3)){break c}}if(w[ec(d,5)|0]==58){break b}}i=0}d=w[e+44|0]|w[e+45|0]<<8;if(((d<<8|d>>>8)&65535)>>>0>=2){d=w[e+42|0]|w[e+43|0]<<8;v[h+484384>>2]=(d<<8|d>>>8)&65535;d=w[e+42|0]|w[e+43|0]<<8;k=(d<<8|d>>>8)&65535;d=w[e+44|0]|w[e+45|0]<<8;v[h+484388>>2]=k+(((d<<8|d>>>8)&65535)<<1);kn(j)}d=w[e+38|0]|w[e+39|0]<<8;d:{if(((d<<8|d>>>8)&65535)>>>0<=4999){d=w[e+42|0]|w[e+43|0]<<8;if(((d<<8|d>>>8)&65535)>>>0<1e4){break d}}v[e+1064>>2]=5;y=e,z=v[yf(e+1196|0,e+1064|0)>>2],v[y+1196>>2]=z}f=f+n|0;g=g+1|0;if((g|0)!=16){continue}break}h=e+1064|0;d=h;vz(b,d);o=a+484360|0;En(Vb(o),d|2,128,65535,65535);g=0;n=gQ(b,Vb(o),w[d|0],f,l,0,1);d=d|1;if(!(w[d|0]|w[h|0])&n>>>0<2){break a}if($e(b)+65536>>>0<(n<<10)+f>>>0){break a}if(!c){g=1;break a}if(!w[d|0]){t[d|0]=120}if(!md(e+1200|0,10606,6)){t[d|0]=120}v[a+480204>>2]=125e4;e:{if(w[d|0]==120){break e}f=a;q=145364549.18032786/+(240-w[d|0]|0);f:{if(q<4294967296&q>=0){d=~~q>>>0;break f}d=0}v[f+480204>>2]=d;if(v[e+1196>>2]>=2){v[e+16>>2]=i&1?4:5;y=e,z=v[yf(e+1196|0,e+16|0)>>2],v[y+1196>>2]=z;break e}v[e+16>>2]=i&1?1:2;y=e,z=v[yf(e+1196|0,e+16|0)>>2],v[y+1196>>2]=z}v[a+480260>>2]=452;v[a+480264>>2]=3424;v[a+480228>>2]=64;v[a+480208>>2]=v[a+480208>>2]|2097152;d=e+1048|0;Dn(d,3,e+1200|0);f=e+16|0;Ec(f,d);Gb(a+1304400|0,f);yb(f);h=0;mj(a,0);r=v[b+8>>2];u[e+1046>>1]=0;g:{h:{if(!n){break h}s=i&1;i=0;while(1){y=e,z=rz(ac(Vb(o)),bc(Vb(o)),e+1046|0),v[y+16>>2]=z;y=e,z=bc(Vb(o)),v[y+1048>>2]=z;f=e+16|0;d=Jb(f,e+1048|0);aQ(b,f);if(d){h=qz(e+16|0,0)+h|0;if(h>>>0>512){break g}}j=0;f=0;l=0;while(1){g=0;while(1){d=f;m=Xe($P(e+16|0,j),g);p=w[ec(m,2)|0]&15;k=w[ec(m,3)|0];f=0;i:{if(!(d&255)|(w[m|0]|w[m+1|0]<<8|(w[m+2|0]<<16|w[m+3|0]<<24))){break i}f=d+1|0;if((f&255)>>>0<33){break i}v[e+1196>>2]=6}j:{k:{l:{switch(p-1|0){case 0:case 1:d=v[e+1196>>2];if((d|0)==1&k>>>0>=32){break k}m=(p|0)!=1;if(!(m|!k|k>>>0>2)){v[e+1048>>2]=2;y=e,z=v[yf(e+1196|0,e+1048|0)>>2],v[y+1196>>2]=z;break j}if(m|(k|0)!=55&(k|0)!=71){break j}if((d|0)<=2){break k}break j;case 10:v[e+1196>>2]=6;break j;case 11:case 12:case 13:v[e+1048>>2]=2;y=e,z=v[yf(e+1196|0,e+1048|0)>>2],v[y+1196>>2]=z;if((p|0)!=13){break j}l=((j|k)!=0)+l|0;f=1;break j;case 14:break l;default:break j}}v[e+1048>>2]=3;y=e,z=v[yf(e+1196|0,e+1048|0)>>2],v[y+1196>>2]=z;break j}v[e+1196>>2]=s}g=g+1|0;if((g|0)!=4){continue}break}j=j+1|0;if((j|0)!=64){continue}break}if((l-1&255)>>>0<2){v[e+1196>>2]=6}i=(l&255)+i|0;f=x[e+1046>>1]+1|0;u[e+1046>>1]=f;if(n>>>0>(f&65535)>>>0){continue}break}if(v[e+1196>>2]!=6|n+32>>>0>=i>>>0){break h}v[e+1196>>2]=5}Nc(b,r);o=c&1;if(o){dg(a+484344|0,n)}if(n){m=a+484344|0;i=0;while(1){aQ(b,e+16|0);m:{if(!o){break m}if(!Og(m,i&65535,64)){break m}v[e+1048>>2]=0;l=0;while(1){p=Bf(Zb(m,i),l,0);h=0;while(1){f=Xe($P(e+16|0,l),h);f=w[f|0]|w[f+1|0]<<8|(w[f+2|0]<<16|w[f+3|0]<<24);v[e+8>>2]=f;v[e+12>>2]=f;d=p+B(h,6)|0;mt(e+8|0,d);n:{o:{p:{f=w[d+5|0];if(f){j=d+3|0;k=(e+1048|0)+h|0;g=w[d+3|0];if((g|0)!=14){break p}t[k|0]=0;g=14;break o}t[(e+1048|0)+h|0]=0;g=w[d+3|0];if(!g){break n}j=d+3|0;break o}k=w[k|0];if(!k){break o}if(k>>>0>=16){t[d+2|0]=3;t[d+4|0]=k>>>4;break o}t[d+2|0]=4;t[d+4|0]=k}q:{r:{s:{t:{u:{switch(g-12|0){case 1:k=v[e+1196>>2];if((k|0)==6){break r}g=10;t[j|0]=10;break s;case 0:f=f&127;t[d+5|0]=f;g=12;break t;case 2:if(f>>>0<=1&v[e+1196>>2]>3){break q}g=10;t[j|0]=10;t[(e+1048|0)+h|0]=f;break t;case 3:break u;default:break t}}g=15;f=f&15;t[d+5|0]=f}k=v[e+1196>>2]}if((k|0)>1){break q}v:{w:{x:{switch(g|0){case 0:if(f>>>0>2){break w}break;case 2:break v;case 1:break w;default:break x}}t[j|0]=0;break n}t[j|0]=1;break n}g=f&15;if(g){t[j|0]=2;t[d+5|0]=g;break n}if(f>>>0<16){break n}t[j|0]=3;t[d+5|0]=f>>>4;break n}t[d+5|0]=0}vj(d)}h=h+1|0;if((h|0)!=4){continue}break}l=l+1|0;if((l|0)!=64){continue}break}}i=i+1|0;if((n|0)!=(i|0)){continue}break}}f=v[e+1196>>2];if(f>>>0>=7){f=17540}else{f=v[(f<<2)+72536>>2]}d=e+16|0;g=Ub(d,4578);Gb(a+1304436|0,g);yb(g);d=Ub(d,6836);Gb(a+1304448|0,d);yb(d);Kc(a+1304460|0,f);v[a+1304496>>2]=2;g=1;if(!(c&2)){break a}h=1;while(1){c=B(h,104)+a|0;f=c+484384|0;_b(b,v[f>>2]);d=v[f>>2];v[f>>2]=0;f=c+484380|0;v[f>>2]=v[f>>2]-d;c=c+484388|0;v[c>>2]=v[c>>2]-d;c=e+16|0;Yc(c,8,1,1,0);zg(c,f,b);h=h+1|0;if((h|0)!=16){continue}break}break a}g=0}jb=e+1824|0;return g|0}function XH(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;e=jb-448|0;jb=e;a:{if(nj(b)){break a}f=w[gk(b)|0];if((f|0)==33){d=1}else{if((f|0)!=63){break a}d=0}rk(e+184|0,b,v[b+4>>2]-1|0);f=v[e+188>>2];v[b>>2]=v[e+184>>2];v[b+4>>2]=f}f=e+184|0;Ad(f);g=v[e+184>>2];Ad(e+416|0);h=fk(g,v[e+420>>2],b);Ad(f);f=v[b>>2];g=v[b+4>>2];b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{if((h|0)==v[e+188>>2]){v[e+440>>2]=f;v[e+444>>2]=g;a=qc(e+432|0,17540);f=v[e+444>>2];v[e+16>>2]=v[e+440>>2];v[e+20>>2]=f;f=v[a+4>>2];v[e+8>>2]=v[a>>2];v[e+12>>2]=f;if(Hc(e+16|0,e+8|0)){a=ba(8)|0;v[113382]=0;c=Q(2111,e+416|0,c|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){v[113382]=0;U(2088,e+184|0,13642,c|0);b=v[113382];v[113382]=0;if((b|0)==1){break i}nc(a,e+184|0);v[113382]=0;U(1978,a|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break b}b=P()|0;O()|0;yb(e+184|0);yb(c);break c}b=P()|0;O()|0;break d}if(!d){break k}d=ba(8)|0;v[113382]=0;f=Q(2111,e+384|0,b|0)|0;a=v[113382];v[113382]=0;l:{m:{n:{o:{p:{q:{r:{s:{if((a|0)!=1){v[113382]=0;U(2088,e+400|0,13678,f|0);a=v[113382];v[113382]=0;if((a|0)==1){break s}v[113382]=0;U(2106,e+416|0,e+400|0,13652);b=v[113382];v[113382]=0;a=1;if((b|0)==1){break r}v[113382]=0;c=Q(2111,e+368|0,c|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break q}v[113382]=0;U(137,e+184|0,e+416|0,c|0);b=v[113382];v[113382]=0;a=1;if((b|0)==1){break p}nc(d,e+184|0);v[113382]=0;U(1978,d|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break b}b=P()|0;O()|0;yb(e+184|0);a=0;break o}b=P()|0;O()|0;break l}b=P()|0;O()|0;yb(f);break l}b=P()|0;O()|0;break m}b=P()|0;a=1;O()|0;break n}b=P()|0;O()|0}yb(c)}yb(e+416|0)}yb(e+400|0);yb(f);if(!a){break c}}ca(d|0);break c}v[e+360>>2]=f;v[e+364>>2]=g;d=qc(e+352|0,17540);f=v[e+364>>2];v[e+176>>2]=v[e+360>>2];v[e+180>>2]=f;f=v[d+4>>2];v[e+168>>2]=v[d>>2];v[e+172>>2]=f;if(Hc(e+176|0,e+168|0)){a=ba(8)|0;v[113382]=0;c=Q(2111,e+416|0,c|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){v[113382]=0;U(2088,e+184|0,13642,c|0);b=v[113382];v[113382]=0;if((b|0)==1){break h}nc(a,e+184|0);v[113382]=0;U(1978,a|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break b}b=P()|0;O()|0;yb(e+184|0);yb(c);break c}b=P()|0;O()|0;break e}d=v[b+4>>2];v[e+344>>2]=v[b>>2];v[e+348>>2]=d;d=qc(e+336|0,8322);f=v[e+348>>2];v[e+160>>2]=v[e+344>>2];v[e+164>>2]=f;f=v[d+4>>2];v[e+152>>2]=v[d>>2];v[e+156>>2]=f;if(Hc(e+160|0,e+152|0)){b=v[c+4>>2];d=v[c>>2];v[e+328>>2]=d;v[e+332>>2]=b;f=qc(e+320|0,2087);g=v[e+332>>2];v[e+64>>2]=v[e+328>>2];v[e+68>>2]=g;g=v[f+4>>2];v[e+56>>2]=v[f>>2];v[e+60>>2]=g;if(Hc(e- -64|0,e+56|0)){v[a+52>>2]=0;break k}v[e+312>>2]=d;v[e+316>>2]=b;f=qc(e+304|0,7319);g=v[e+316>>2];v[e+48>>2]=v[e+312>>2];v[e+52>>2]=g;g=v[f+4>>2];v[e+40>>2]=v[f>>2];v[e+44>>2]=g;if(Hc(e+48|0,e+40|0)){v[a+52>>2]=1;break k}v[e+296>>2]=d;v[e+300>>2]=b;b=qc(e+288|0,5230);d=v[e+300>>2];v[e+32>>2]=v[e+296>>2];v[e+36>>2]=d;d=v[b+4>>2];v[e+24>>2]=v[b>>2];v[e+28>>2]=d;if(Hc(e+32|0,e+24|0)){v[a+52>>2]=2;break k}a=ba(8)|0;v[113382]=0;c=Q(2111,e+416|0,c|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){v[113382]=0;U(2088,e+184|0,10312,c|0);b=v[113382];v[113382]=0;if((b|0)==1){break g}nc(a,e+184|0);v[113382]=0;U(1978,a|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break b}b=P()|0;O()|0;yb(e+184|0);yb(c);break c}b=P()|0;O()|0;break f}d=v[b+4>>2];v[e+280>>2]=v[b>>2];v[e+284>>2]=d;b=qc(e+272|0,7556);d=v[e+284>>2];v[e+144>>2]=v[e+280>>2];v[e+148>>2]=d;d=v[b+4>>2];v[e+136>>2]=v[b>>2];v[e+140>>2]=d;if(!Hc(e+144|0,e+136|0)){break k}d=v[c+4>>2];c=v[c>>2];v[e+264>>2]=c;v[e+268>>2]=d;b=qc(e+256|0,11790);f=v[e+268>>2];v[e+128>>2]=v[e+264>>2];v[e+132>>2]=f;f=v[b+4>>2];v[e+120>>2]=v[b>>2];v[e+124>>2]=f;b=0;t:{if(Hc(e+128|0,e+120|0)){break t}v[e+248>>2]=c;v[e+252>>2]=d;b=qc(e+240|0,11795);f=v[e+252>>2];v[e+112>>2]=v[e+248>>2];v[e+116>>2]=f;f=v[b+4>>2];v[e+104>>2]=v[b>>2];v[e+108>>2]=f;b=1;if(Hc(e+112|0,e+104|0)){break t}v[e+232>>2]=c;v[e+236>>2]=d;b=qc(e+224|0,8581);f=v[e+236>>2];v[e+96>>2]=v[e+232>>2];v[e+100>>2]=f;f=v[b+4>>2];v[e+88>>2]=v[b>>2];v[e+92>>2]=f;b=2;if(Hc(e+96|0,e+88|0)){break t}v[e+216>>2]=c;v[e+220>>2]=d;b=qc(e+208|0,5294);c=v[e+220>>2];v[e+80>>2]=v[e+216>>2];v[e+84>>2]=c;c=v[b+4>>2];v[e+72>>2]=v[b>>2];v[e+76>>2]=c;b=3;if(Hc(e+80|0,e+72|0)){break t}a=ba(8)|0;v[113382]=0;c=Q(121,e+184|0,7592)|0;b=v[113382];v[113382]=0;if((b|0)==1){break j}nc(a,c);v[113382]=0;U(1978,a|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break b}b=P()|0;O()|0;yb(c);break c}v[a+56>>2]=b;b=a+24|0;if(!v[v[b>>2]+24668>>2]){break k}c=v[b>>2];d=c+24664|0;f=v[d+4>>2];v[e+200>>2]=v[d>>2];v[e+204>>2]=f;d=c+24656|0;f=v[d+4>>2];v[e+192>>2]=v[d>>2];v[e+196>>2]=f;d=v[c+24652>>2];v[e+184>>2]=v[c+24648>>2];v[e+188>>2]=d;i=e,j=FH(v[a+56>>2]),v[i+204>>2]=j;if(!cx(e+184|0,v[b>>2]+24648|0)){break k}Tx(v[b>>2],e+184|0)}jb=e+448|0;return}b=P()|0;O()|0;ca(a|0);break c}b=P()|0;O()|0;yb(c);break d}b=P()|0;O()|0;yb(c);break e}b=P()|0;O()|0;yb(c)}ca(a|0);break c}ca(a|0);break c}ca(a|0)}S(b|0)}L()}function yw(a,b,c,d,e,f,g){var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,x=0,y=0,z=0,C=0,D=0;h=jb-80|0;jb=h;v[h+76>>2]=b;z=h+55|0;x=h+56|0;b=0;a:{b:while(1){c:{if((p|0)<0){break c}if((2147483647-p|0)<(b|0)){v[113305]=61;p=-1;break c}p=b+p|0}d:{e:{f:{l=v[h+76>>2];b=l;j=w[b|0];if(j){while(1){g:{j=j&255;h:{if(!j){j=b;break h}if((j|0)!=37){break g}j=b;while(1){if(w[b+1|0]!=37){break h}i=b+2|0;v[h+76>>2]=i;j=j+1|0;m=w[b+2|0];b=i;if((m|0)==37){continue}break}}b=j-l|0;if(a){Re(a,l,b)}if(b){continue b}q=-1;j=1;i=h;r=!eh(t[v[h+76>>2]+1|0]);b=v[h+76>>2];if(!(r|w[b+2|0]!=36)){q=t[b+1|0]-48|0;y=1;j=3}b=j+b|0;v[i+76>>2]=b;s=0;k=t[b|0];i=k-32|0;i:{if(i>>>0>31){j=b;break i}j=b;i=1<<i;if(!(i&75913)){break i}while(1){j=b+1|0;v[h+76>>2]=j;s=i|s;k=t[b+1|0];i=k-32|0;if(i>>>0>=32){break i}b=j;i=1<<i;if(i&75913){continue}break}}j:{if((k|0)==42){i=h;k:{l:{if(!eh(t[j+1|0])){break l}b=v[h+76>>2];if(w[b+2|0]!=36){break l}v[((t[b+1|0]<<2)+e|0)-192>>2]=10;n=v[((t[b+1|0]<<3)+d|0)-384>>2];y=1;b=b+3|0;break k}if(y){break f}y=0;n=0;if(a){b=v[c>>2];v[c>>2]=b+4;n=v[b>>2]}b=v[h+76>>2]+1|0}v[i+76>>2]=b;if((n|0)>=0){break j}n=0-n|0;s=s|8192;break j}n=tG(h+76|0);if((n|0)<0){break f}b=v[h+76>>2]}m=-1;m:{if(w[b|0]!=46){break m}if(w[b+1|0]==42){n:{if(!eh(t[b+2|0])){break n}b=v[h+76>>2];if(w[b+3|0]!=36){break n}v[((t[b+2|0]<<2)+e|0)-192>>2]=10;m=v[((t[b+2|0]<<3)+d|0)-384>>2];b=b+4|0;v[h+76>>2]=b;break m}if(y){break f}if(a){b=v[c>>2];v[c>>2]=b+4;m=v[b>>2]}else{m=0}b=v[h+76>>2]+2|0;v[h+76>>2]=b;break m}v[h+76>>2]=b+1;m=tG(h+76|0);b=v[h+76>>2]}j=0;while(1){r=j;o=-1;if(t[b|0]-65>>>0>57){break a}k=b+1|0;v[h+76>>2]=k;j=t[b|0];b=k;j=w[(j+B(r,58)|0)+48511|0];if(j-1>>>0<8){continue}break}o:{p:{if((j|0)!=19){if(!j){break a}if((q|0)>=0){v[(q<<2)+e>>2]=j;b=(q<<3)+d|0;j=v[b+4>>2];v[h+64>>2]=v[b>>2];v[h+68>>2]=j;break p}if(!a){break d}sG(h- -64|0,j,c,g);k=v[h+76>>2];break o}if((q|0)>=0){break a}}b=0;if(!a){continue b}}i=s&-65537;j=s&8192?i:s;o=0;q=1772;s=x;q:{r:{s:{t:{u:{v:{w:{x:{y:{z:{A:{B:{C:{D:{E:{F:{b=t[k-1|0];b=r?(b&15)==3?b&-33:b:b;switch(b-88|0){case 11:break q;case 9:case 13:case 14:case 15:break r;case 27:break w;case 12:case 17:break z;case 23:break A;case 0:case 32:break B;case 24:break C;case 22:break D;case 29:break E;case 1:case 2:case 3:case 4:case 5:case 6:case 7:case 8:case 10:case 16:case 18:case 19:case 20:case 21:case 25:case 26:case 28:case 30:case 31:break e;default:break F}}G:{switch(b-65|0){case 0:case 4:case 5:case 6:break r;case 2:break u;case 1:case 3:break e;default:break G}}if((b|0)==83){break v}break e}k=v[h+64>>2];i=v[h+68>>2];q=1772;break y}b=0;H:{switch(r&255){case 0:v[v[h+64>>2]>>2]=p;continue b;case 1:v[v[h+64>>2]>>2]=p;continue b;case 2:j=v[h+64>>2];v[j>>2]=p;v[j+4>>2]=p>>31;continue b;case 3:u[v[h+64>>2]>>1]=p;continue b;case 4:t[v[h+64>>2]]=p;continue b;case 6:v[v[h+64>>2]>>2]=p;continue b;case 7:break H;default:continue b}}j=v[h+64>>2];v[j>>2]=p;v[j+4>>2]=p>>31;continue b}m=m>>>0>8?m:8;j=j|8;b=120}l=x;C=b&32;r=v[h+68>>2];i=r;k=v[h+64>>2];if(i|k){while(1){l=l-1|0;t[l|0]=C|w[(k&15)+49040|0];D=!i&k>>>0>15|(i|0)!=0;r=i;i=i>>>4|0;k=(r&15)<<28|k>>>4;if(D){continue}break}}if(!(j&8)|!(v[h+64>>2]|v[h+68>>2])){break x}q=(b>>>4|0)+1772|0;o=2;break x}b=x;l=v[h+68>>2];i=l;k=v[h+64>>2];if(i|k){while(1){b=b-1|0;t[b|0]=k&7|48;r=!i&k>>>0>7|(i|0)!=0;l=i;i=i>>>3|0;k=(l&7)<<29|k>>>3;if(r){continue}break}}l=b;if(!(j&8)){break x}b=x-l|0;m=(b|0)<(m|0)?m:b+1|0;break x}b=v[h+68>>2];i=b;k=v[h+64>>2];if((b|0)<0){i=0-(i+((k|0)!=0)|0)|0;k=0-k|0;v[h+64>>2]=k;v[h+68>>2]=i;o=1;q=1772;break y}if(j&2048){o=1;q=1773;break y}o=j&1;q=o?1774:1772}l=Gm(k,i,x)}j=(m|0)>=0?j&-65537:j;b=v[h+68>>2];i=b;k=v[h+64>>2];if(!((k|0)!=0|(b|0)!=0|m)){m=0;l=x;break e}b=!(i|k)+(x-l|0)|0;m=(b|0)<(m|0)?m:b;break e}b=v[h+64>>2];l=b?b:13104;b=Dr(l,0,m);s=b?b:m+l|0;j=i;m=b?b-l|0:m;break e}if(m){b=v[h+64>>2];break t}b=0;Lf(a,32,n,0,j);break s}v[h+12>>2]=0;v[h+8>>2]=v[h+64>>2];b=h+8|0;v[h+64>>2]=b;m=-1}i=b;b=0;I:{while(1){l=v[i>>2];if(!l){break I}l=gG(h+4|0,l);k=(l|0)<0;if(!(k|l>>>0>m-b>>>0)){i=i+4|0;b=b+l|0;if(m>>>0>b>>>0){continue}break I}break}o=-1;if(k){break a}}Lf(a,32,n,b,j);if(!b){b=0;break s}i=0;k=v[h+64>>2];while(1){l=v[k>>2];if(!l){break s}l=gG(h+4|0,l);i=l+i|0;if((i|0)>(b|0)){break s}Re(a,h+4|0,l);k=k+4|0;if(b>>>0>i>>>0){continue}break}}Lf(a,32,n,b,j^8192);b=(b|0)<(n|0)?n:b;continue b}b=nb[f|0](a,A[h+64>>3],n,m,j,b)|0;continue b}t[h+55|0]=v[h+64>>2];m=1;l=z;j=i;break e}i=b+1|0;v[h+76>>2]=i;j=w[b+1|0];b=i;continue}}o=p;if(a){break a}if(!y){break d}b=1;while(1){a=v[(b<<2)+e>>2];if(a){sG((b<<3)+d|0,a,c,g);o=1;b=b+1|0;if((b|0)!=10){continue}break a}break}o=1;if(b>>>0>=10){break a}while(1){if(v[(b<<2)+e>>2]){break f}b=b+1|0;if((b|0)!=10){continue}break}break a}o=-1;break a}k=s-l|0;m=(k|0)>(m|0)?k:m;i=m+o|0;b=(i|0)>(n|0)?i:n;Lf(a,32,b,i,j);Re(a,q,o);Lf(a,48,b,i,j^65536);Lf(a,48,m,k,0);Re(a,l,k);Lf(a,32,b,i,j^8192);continue}break}o=0}jb=h+80|0;return o}function PG(a,b,c,d,e,f){var g=0,h=C(0),i=C(0),j=0,k=C(0),l=0,m=C(0),n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,A=C(0),D=0,E=C(0),F=C(0),G=C(0),H=0,I=C(0),J=C(0),K=C(0),L=C(0),M=C(0),N=C(0),O=0,P=0,Q=0,R=0;if((d|0)>0){while(1){y=B(v,2304)+b|0;x=0;s=jb-128|0;p=c;if((p|0)>0){while(1){n=y+(x<<2)|0;o=0;l=s;j=l;while(1){i=z[B(31-o|0,72)+n>>2];w=B(o,72)+n|0;h=z[w>>2];m=C(i+h);k=z[w+1152>>2];A=z[B(15-o|0,72)+n>>2];E=C(k+A);z[j>>2]=m+E;w=B(o,12)+46096|0;i=C(z[w+4>>2]*C(h-i));h=C(z[w>>2]*C(A-k));z[j+64>>2]=i+h;k=z[w+8>>2];z[j+32>>2]=k*C(m-E);z[j+96>>2]=C(i-h)*k;j=j+4|0;o=o+1|0;if((o|0)!=8){continue}break}o=0;while(1){m=z[l+28>>2];k=z[l>>2];i=C(m+k);A=z[l+16>>2];E=z[l+12>>2];h=C(A+E);F=C(i+h);G=z[l+24>>2];I=z[l+4>>2];J=C(G+I);K=z[l+20>>2];L=z[l+8>>2];M=C(K+L);N=C(J+M);z[l>>2]=F+N;z[l+16>>2]=C(F-N)*C(.7071067690849304);i=C(i-h);h=C(C(i+C(J-M))*C(.7071067690849304));z[l+24>>2]=C(i-h)*C(1.3065630197525024);z[l+8>>2]=C(h+i)*C(.5411961078643799);h=C(I-G);F=C(L-K);G=C(C(h+F)*C(.7071067690849304));i=C(k-m);m=C(G+i);h=C(i+h);k=C(C(C(E-A)+F)+C(h*C(-.1989123672246933)));h=C(C(k*C(.3826834261417389))+h);z[l+28>>2]=C(m-h)*C(2.562915563583374);z[l+4>>2]=C(h+m)*C(.509795606136322);h=C(k+C(h*C(-.1989123672246933)));i=C(i-G);z[l+20>>2]=C(h+i)*C(.8999761939048767);z[l+12>>2]=C(i-h)*C(.601344883441925);l=l+32|0;o=o+1|0;if((o|0)!=4){continue}break}o=0;i=z[s+32>>2];h=z[s+96>>2];k=z[s+64>>2];while(1){l=n;z[l>>2]=z[s+(o<<2)>>2];o=o+1|0;n=s+(o<<2)|0;m=z[n+96>>2];A=C(m+h);z[l+72>>2]=A+k;h=z[n+32>>2];z[l+144>>2]=h+i;k=z[n- -64>>2];z[l+216>>2]=A+k;n=l+288|0;i=h;h=m;if((o|0)!=7){continue}break}z[l+288>>2]=z[s+28>>2];i=z[s+124>>2];z[l+360>>2]=i+z[s+92>>2];h=z[s+60>>2];z[l+504>>2]=i;z[l+432>>2]=h;x=x+1|0;if((p|0)!=(x|0)){continue}break}}v=v+1|0;if((v|0)!=(d|0)){continue}break}}H=lc(f,a,3840);if((c|0)>0){P=d<<5;v=0;while(1){n=jb-32|0;jb=n;o=(v<<8)+H|0;x=(v<<2)+b|0;z[o+4080>>2]=z[x+1152>>2];l=d;f=l-1|0;w=x+B(f,2304)|0;z[o+4084>>2]=z[w+1152>>2];z[o+4088>>2]=z[x>>2];z[o+4092>>2]=z[w>>2];z[o+4336>>2]=z[x+1156>>2];z[o+4340>>2]=z[w+1156>>2];z[o+4344>>2]=z[x+4>>2];z[o+4348>>2]=z[w+4>>2];y=(B(v,P)<<1)+e|0;D=y+(f<<1)|0;Hr(D,l,o+244|0);f=l<<6;Hr(f+D|0,l,o+500|0);Hr(y,l,o+240|0);Hr(f+y|0,l,o+496|0);p=46192;O=o+3840|0;f=14;while(1){s=f;q=f<<4;j=q+O|0;g=B(31-f|0,72);m=z[g+x>>2];z[j>>2]=m;z[j+4>>2]=z[g+w>>2];g=g|4;z[j+8>>2]=z[g+x>>2];z[j+12>>2]=z[g+w>>2];g=B(f,72);r=g+76|0;z[j+256>>2]=z[r+x>>2];z[j+260>>2]=z[r+w>>2];g=g+72|0;z[j-248>>2]=z[g+x>>2];z[j-244>>2]=z[g+w>>2];i=z[p>>2];q=o+q|0;k=z[q>>2];h=z[p+4>>2];z[n+16>>2]=C(m*i)-C(k*h);z[n>>2]=C(k*i)+C(m*h);r=f<<2;f=1;while(1){g=f<<2;m=z[g+j>>2];k=z[g+q>>2];z[g+(n+16|0)>>2]=C(m*i)-C(k*h);z[g+n>>2]=C(k*i)+C(m*h);f=f+1|0;if((f|0)!=4){continue}break}j=(r<<2)+O|0;q=j-3584|0;r=j-256|0;i=z[p+12>>2];h=z[p+8>>2];f=0;while(1){g=f<<2;t=g+n|0;m=z[g+q>>2];k=z[g+r>>2];z[t>>2]=C(C(m*h)+C(k*i))+z[t>>2];g=g+(n+16|0)|0;z[g>>2]=C(C(m*i)-C(k*h))+z[g>>2];f=f+1|0;if((f|0)!=4){continue}break}q=j-3328|0;r=j-512|0;i=z[p+20>>2];h=z[p+16>>2];f=0;while(1){g=f<<2;t=g+n|0;m=z[g+q>>2];k=z[g+r>>2];z[t>>2]=C(C(m*h)+C(k*i))+z[t>>2];g=g+(n+16|0)|0;z[g>>2]=C(C(k*h)-C(m*i))+z[g>>2];f=f+1|0;if((f|0)!=4){continue}break}q=j-3072|0;r=j-768|0;i=z[p+28>>2];h=z[p+24>>2];f=0;while(1){g=f<<2;t=g+n|0;m=z[g+q>>2];k=z[g+r>>2];z[t>>2]=C(C(m*h)+C(k*i))+z[t>>2];g=g+(n+16|0)|0;z[g>>2]=C(C(m*i)-C(k*h))+z[g>>2];f=f+1|0;if((f|0)!=4){continue}break}q=j-2816|0;r=j-1024|0;i=z[p+36>>2];h=z[p+32>>2];f=0;while(1){g=f<<2;t=g+n|0;m=z[g+q>>2];k=z[g+r>>2];z[t>>2]=C(C(m*h)+C(k*i))+z[t>>2];g=g+(n+16|0)|0;z[g>>2]=C(C(k*h)-C(m*i))+z[g>>2];f=f+1|0;if((f|0)!=4){continue}break}q=j-2560|0;r=j-1280|0;i=z[p+44>>2];h=z[p+40>>2];f=0;while(1){g=f<<2;t=g+n|0;m=z[g+q>>2];k=z[g+r>>2];z[t>>2]=C(C(m*h)+C(k*i))+z[t>>2];g=g+(n+16|0)|0;z[g>>2]=C(C(m*i)-C(k*h))+z[g>>2];f=f+1|0;if((f|0)!=4){continue}break}q=j-2304|0;r=j-1536|0;i=z[p+52>>2];h=z[p+48>>2];f=0;while(1){g=f<<2;t=g+n|0;m=z[g+q>>2];k=z[g+r>>2];z[t>>2]=C(C(m*h)+C(k*i))+z[t>>2];g=g+(n+16|0)|0;z[g>>2]=C(C(k*h)-C(m*i))+z[g>>2];f=f+1|0;if((f|0)!=4){continue}break}g=j-2048|0;q=j-1792|0;i=z[p+60>>2];h=z[p+56>>2];f=0;while(1){j=f<<2;r=j+n|0;m=z[g+j>>2];k=z[j+q>>2];z[r>>2]=C(C(m*h)+C(k*i))+z[r>>2];j=j+(n+16|0)|0;z[j>>2]=C(C(m*i)-C(k*h))+z[j>>2];f=f+1|0;if((f|0)!=4){continue}break}f=B(l,15-s|0)<<1;Q=f+D|0,R=ji(z[n+20>>2]),u[Q>>1]=R;j=B(l,s+17|0)<<1;Q=j+D|0,R=ji(z[n+4>>2]),u[Q>>1]=R;Q=f+y|0,R=ji(z[n+16>>2]),u[Q>>1]=R;Q=j+y|0,R=ji(z[n>>2]),u[Q>>1]=R;f=B(l,47-s|0)<<1;Q=f+D|0,R=ji(z[n+28>>2]),u[Q>>1]=R;j=B(l,s+49|0)<<1;Q=j+D|0,R=ji(z[n+12>>2]),u[Q>>1]=R;Q=f+y|0,R=ji(z[n+24>>2]),u[Q>>1]=R;Q=j+y|0,R=ji(z[n+8>>2]),u[Q>>1]=R;f=s-1|0;p=p- -64|0;if(s){continue}break}jb=n+32|0;v=v+2|0;if((v|0)<(c|0)){continue}break}}b=c<<6;a:{if((d|0)==1){v=0;while(1){z[(v<<2)+a>>2]=z[(b+v<<2)+H>>2];c=v>>>0<958;v=v+2|0;if(c){continue}break}break a}lc(a,(b<<2)+H|0,3840)}}function cha(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,y=0,z=0,A=0,C=0;d=jb-768|0;jb=d;Ic(b);f=jb-16|0;jb=f;g=f+8|0;i=d+160|0;TO(g,i);h=Hb(g);e=b;g=mc(e,$b(f,g));if((h|0)==(g|0)){_b(e,Hb(f+8|0))}jb=f+16|0;e=(g|0)==(h|0);if(!e){UO(i)}a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{if(!e){break n}if(!WO(d+160|0)){break n}if(!Rb(b,dd(VO(d+160|0),mb))){break n}if(!c){n=1;break n}Id(a,262144);g=d+104|0;Nt(g,2,d+160|0);e=d+24|0;Ec(e,g);Gb(a+1304400|0,e);yb(e);f=Ub(e,4591);Gb(a+1304436|0,f);yb(f);e=Ub(e,6213);Gb(a+1304448|0,e);yb(e);f=Ub(d+144|0,11053);v[113382]=0;R(189,g|0,f|0);e=v[113382];v[113382]=0;if((e|0)==1){break c}t[d+8|0]=w[d+190|0];e=w[d+189|0];v[113382]=0;t[d+127|0]=e;R(956,d+128|0,d+127|0);e=v[113382];v[113382]=0;if((e|0)==1){break e}e=0;v[113382]=0;X(407,d+24|0,d+104|0,d+8|0,d+128|0);g=v[113382];v[113382]=0;if((g|0)==1){break f}g=d+24|0;Gb(a+1304460|0,g);yb(g);yb(d+128|0);i=d+104|0;Ib(i);yb(f);v[a+480208>>2]=12;v[a+1304496>>2]=4;u[a+480188>>1]=w[d+198|0]|w[d+199|0]<<8;u[d+24>>1]=w[d+194|0]|w[d+195|0]<<8;u[d+104>>1]=3999;A=a,C=x[Af(g,i)>>1],u[A+480190>>1]=C;hA(Vb(a+484360|0),d+256|0,w[d+192|0]|w[d+193|0]<<8,255,254);if(x[a+480188>>1]){while(1){f=(e<<5)+a|0;Dg(f+480280|0);u[f+480284>>1]=(w[(d+e|0)+224|0]<<4|4)&244;e=e+1|0;if(e>>>0<x[a+480188>>1]){continue}break}}td(d+104|0,b,B(w[d+194|0]|w[d+195|0]<<8,80));if(x[a+480190>>1]){g=c&2;i=d+72|0;e=0;while(1){v[113382]=0;Q(957,d+104|0,d+24|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break m}v[113382]=0;U(540,d+8|0,2,i|0);f=v[113382];v[113382]=0;o:{p:{q:{if((f|0)==1){break q}v[113382]=0;R(356,d+128|0,d+8|0);f=v[113382];v[113382]=0;if((f|0)==1){break q}v[113382]=0;e=e+1|0;Q(335,((e<<5)+a|0)+946304|0,d+128|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break p}f=d+128|0;yb(f);v[113382]=0;h=f;f=(B(e,104)+a|0)+484380|0;U(958,h|0,d+24|0,f|0);h=v[113382];v[113382]=0;r:{if((h|0)==1){break r}if(!g|!v[f>>2]){break o}h=w[d+42|0]|w[d+43|0]<<8|(w[d+44|0]<<16|w[d+45|0]<<24);v[113382]=0;h=Q(226,b|0,h|0)|0;j=v[113382];v[113382]=0;if((j|0)==1){break r}if(!h){break o}v[113382]=0;W(362,d+128|0,f|0,b|0)|0;f=v[113382];v[113382]=0;if((f|0)!=1){break o}}a=P()|0;O()|0;break g}a=P()|0;O()|0;break g}a=P()|0;O()|0;yb(d+128|0);break g}if(x[a+480190>>1]>e>>>0){continue}break}}n=1;s:{if(!(c&1)){break s}c=w[d+196|0]|w[d+197|0]<<8;g=0;v[113382]=0;k=a+484344|0;R(363,k|0,c|0);c=v[113382];v[113382]=0;if((c|0)==1){break l}if(!(w[d+196|0]|w[d+197|0]<<8)){break s}c=d+24|0;o=c|4;p=c|2;q=c|5;r=c|3;s=c|1;while(1){v[113382]=0;c=W(364,k|0,g&65535,64)|0;e=v[113382];v[113382]=0;if((e|0)==1){break k}t:{if(!c){break t}c=(g<<1)+d|0;e=c+512|0;if(!(w[e|0]|w[e+1|0]<<8)){break t}c=w[c+512|0]|w[c+513|0]<<8;v[113382]=0;c=Q(226,b|0,c<<4)|0;e=v[113382];v[113382]=0;if((e|0)==1){break k}if(!c){break t}l=0;c=Zb(k,g);v[113382]=0;m=W(432,c|0,0,0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break h}while(1){v[113382]=0;c=Q(228,b|0,1)|0;e=v[113382];v[113382]=0;u:{v:{w:{if((e|0)!=1){if(!c){break t}v[113382]=0;i=T(409,b|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break w}if(i){break v}l=l+1|0;m=B(x[a+480188>>1],6)+m|0;break u}a=P()|0;O()|0;break g}a=P()|0;O()|0;break g}u[d+28>>1]=0;v[d+24>>2]=0;c=i&31;e=B(c,6)+m|0;y=Oh(d+24|0);f=c>>>0<x[a+480188>>1];x:{y:{z:{A:{B:{C:{D:{if(!(i&32)){break D}v[113382]=0;R(433,d+128|0,b|0);c=v[113382];v[113382]=0;if((c|0)==1){break C}c=d+128|0;h=Zc(c);j=f?e:d+24|0;c=w[c|0];t[j|0]=c;t[(f?e+1|0:s)|0]=w[h|0];E:{if(c){if((c|0)==254){break E}if(c>>>0<121){break D}}c=0}t[j|0]=c}if(!(i&64)){break x}v[113382]=0;R(433,d+128|0,b|0);c=v[113382];v[113382]=0;if((c|0)==1){break j}c=d+128|0;z=Zc(c);h=f?e+3|0:r;c=w[c|0];t[h|0]=c;j=f?e+5|0:q;t[j|0]=w[z|0];if(c>>>0>15){break B}v[113382]=0;Z(537,(f?e:y)|0);c=v[113382];v[113382]=0;if((c|0)!=1){break A}a=P()|0;O()|0;break g}a=P()|0;O()|0;break g}if(c>>>0>23){break y}c=w[c+24135|0];t[h|0]=c;break z}c=w[h|0]}c=c&255;if((c|0)!=23){if((c|0)!=9){break x}t[h|0]=20;c=w[j|0];v[113382]=0;t[d+8|0]=c>>>3;t[d+127|0]=1;c=Q(410,d+8|0,d+127|0)|0;h=v[113382];v[113382]=0;if((h|0)!=1){t[j|0]=w[c|0]-1&15|128;break x}a=P()|0;O()|0;break g}v[113382]=0;t[d+8|0]=64;c=Q(415,j|0,d+8|0)|0;h=v[113382];v[113382]=0;if((h|0)!=1){t[j|0]=w[c|0]<<1;break x}a=P()|0;O()|0;break g}t[h|0]=0}if(!(i&128)){break u}t[(f?e+2|0:p)|0]=1;v[113382]=0;c=T(409,b|0)|0;i=v[113382];v[113382]=0;if((i|0)==1){break i}t[(f?e+4|0:o)|0]=c}if(l>>>0<64){continue}break}}g=g+1|0;if(g>>>0<(w[d+196|0]|w[d+197|0]<<8)>>>0){continue}break}}Bb(d+104|0)}jb=d+768|0;return n|0}a=P()|0;O()|0;break g}a=P()|0;O()|0;break g}a=P()|0;O()|0;break g}a=P()|0;O()|0;break g}a=P()|0;O()|0;break g}a=P()|0;O()|0}Bb(d+104|0);break a}a=P()|0;O()|0;yb(d+128|0);break d}a=P()|0;O()|0}Ib(d+104|0);break b}a=P()|0;O()|0}yb(f)}S(a|0);L()}function UT(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=jb-128|0;jb=e;Ic(b);a:{if(!fB(b,7772)){break a}if(!nu(b,e+112|0)){break a}if(!hB(e+112|0)){break a}if(!Rb(b,dd(gB(e+112|0),mb))){break a}if(!_b(b,w[e+121|0]|w[e+122|0]<<8)){break a}b:{if(!c){break b}Id(a,4096);v[a+480208>>2]=12;d=e+112|0;u[a+480188>>1]=(w[d|2]&31)+1;f=d|3;u[a+480190>>1]=w[f|0];mj(a,1);d=e+56|0;i=Ub(d,4764);Gb(a+1304436|0,i);yb(i);d=Ub(d,3356);Gb(a+1304448|0,d);yb(d);d=Ub(e+80|0,11107);v[113382]=0;R(189,e+96|0,d|0);i=v[113382];v[113382]=0;c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{if((i|0)!=1){v[113382]=0;i=e+112|0;X(382,e+56|0,e+96|0,i|1,i|0);i=v[113382];v[113382]=0;if((i|0)==1){break o}i=e+56|0;Gb(a+1304460|0,i);yb(i);i=e+96|0;Ib(i);yb(d);v[a+1304496>>2]=4;f=w[f|0];d=jb-16|0;jb=d;v[i>>2]=0;v[i+4>>2]=0;v[d+12>>2]=0;Uc(i+8|0,d+12|0,d+8|0);if(f){kq(i,f);dC(i,f,0)}jb=d+16|0;if(x[a+480190>>1]){f=1;d=1;while(1){v[113382]=0;Q(383,b|0,e+56|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break k}v[113382]=0;R(384,e+56|0,(B(f,104)+a|0)+484380|0);h=v[113382];v[113382]=0;if((h|0)==1){break k}h=w[e+72|0];j=e+40|0;_d(j,i,f-1|0);ce(j,(h&3)!=0);d=d+1|0;f=d&65535;if(f>>>0<=x[a+480190>>1]){continue}break}}v[113382]=0;W(385,b|0,a+1304400|0,-1)|0;f=v[113382];v[113382]=0;d=1;if((f|0)!=1){if(x[a+480190>>1]){while(1){v[113382]=0;W(386,b|0,(((d&65535)<<5)+a|0)+946304|0,-1)|0;f=v[113382];v[113382]=0;if((f|0)==1){break m}d=d+1|0;if(x[a+480190>>1]>=(d&65535)>>>0){continue}break}}if(x[a+480188>>1]){d=0;while(1){v[113382]=0;f=(d<<5)+a|0;Z(387,f+480280|0);h=v[113382];v[113382]=0;if((h|0)==1){break e}v[113382]=0;W(388,b|0,f+480289|0,-1)|0;f=v[113382];v[113382]=0;if((f|0)==1){break e}d=d+1|0;if(d>>>0<x[a+480188>>1]){continue}break}}f=e+112|4;h=w[f|0]|w[f+1|0]<<8;d=0;v[113382]=0;j=a+484344|0;R(363,j|0,h|0);h=v[113382];v[113382]=0;if((h|0)!=1){break l}}b=P()|0;O()|0;break d}b=P()|0;O()|0;break n}b=P()|0;O()|0;Ib(e+96|0)}yb(d);break c}b=P()|0;O()|0;break d}if(w[f|0]|w[f+1|0]<<8){while(1){v[113382]=0;W(389,b|0,e+56|0,-1)|0;h=v[113382];v[113382]=0;p:{q:{if((h|0)==1){break q}v[113382]=0;h=W(364,j|0,d&65535,64)|0;g=v[113382];v[113382]=0;if((g|0)==1){break q}if(!h){break p}h=Zb(j,d);v[113382]=0;Q(390,h|0,e+56|0)|0;h=v[113382];v[113382]=0;if((h|0)!=1){break p}}b=P()|0;O()|0;break d}d=d+1|0;if(d>>>0<(w[f|0]|w[f+1|0]<<8)>>>0){continue}break}}v[113382]=0;g=T(323,b|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break f}r:{if(!g){break r}v[113382]=0;d=Q(228,b|0,g|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break f}if(!d){break r}h=tq(e+56|0);v[113382]=0;W(391,b|0,h|0,g|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break h}d=Xb(e+40|0);v[113382]=0;R(111,d|0,g|0);g=v[113382];v[113382]=0;if((g|0)==1){break i}l=e,m=ac(h),v[l>>2]=m;l=e,m=bc(h),v[l+32>>2]=m;if(Jb(e,e+32|0)){while(1){s:{g=w[v[e>>2]];if(g&128){l=e,m=tf(d),v[l+16>>2]=m;Hd(e+24|0,e+16|0);v[113382]=0;aa(392,d|0,v[e+24>>2],g&127,32)|0;g=v[113382];v[113382]=0;if((g|0)!=1){break s}break i}v[113382]=0;R(110,d|0,g<<24>>24);g=v[113382];v[113382]=0;if((g|0)!=1){break s}break i}xg(e);if(Jb(e,e+32|0)){continue}break}}v[113382]=0;X(393,e|0,4,5,d|0);g=v[113382];v[113382]=0;if((g|0)==1){break i}Gb(d,e);yb(e);g=Tb(d);v[113382]=0;g=T(394,g|0)|0;k=v[113382];v[113382]=0;if((k|0)==1){break i}k=Db(d);v[113382]=0;ea(395,a+1304424|0,g|0,k|0,76,0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break i}yb(d);$d(h)}h=Vb(a+484360|0);d=e+112|6;g=w[d|0]|w[d+1|0]<<8;d=0;v[113382]=0;ea(396,h|0,b|0,g|0,65535,65535)|0;h=v[113382];v[113382]=0;if((h|0)==1){break f}t:{u:{v:{w:{if(!(w[f|0]|w[f+1|0]<<8)){break w}h=c&1;while(1){v[113382]=0;g=Q(228,b|0,4)|0;k=v[113382];v[113382]=0;x:{if((k|0)!=1){if(g){break x}break w}b=P()|0;O()|0;break d}v[113382]=0;g=T(397,b|0)|0;k=v[113382];v[113382]=0;if((k|0)==1){break u}v[113382]=0;U(307,e+56|0,b|0,g|0);g=v[113382];v[113382]=0;if((g|0)==1){break t}y:{if(!h){break y}v[113382]=0;g=Q(398,j|0,d&65535)|0;k=v[113382];v[113382]=0;if((k|0)==1){break v}if(!g){break y}g=Zb(j,d);v[113382]=0;U(399,g|0,0,e+56|0);g=v[113382];v[113382]=0;if((g|0)==1){break v}}Bb(e+56|0);d=d+1|0;if(d>>>0<(w[f|0]|w[f+1|0]<<8)>>>0){continue}break}}if(!(!(c&2)|!x[a+480190>>1])){f=1;d=1;while(1){c=B(f,104)+a|0;h=x[c+484414>>1];j=e+56|0;_d(j,i,f-1|0);f=Yc(e+40|0,h&1?16:8,1,0,Cb(j)?6:0);v[113382]=0;W(362,f|0,c+484380|0,b|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break j}d=d+1|0;f=d&65535;if(f>>>0<=x[a+480190>>1]){continue}break}}ee(i);break b}b=P()|0;O()|0;Bb(e+56|0);break d}b=P()|0;O()|0;break d}b=P()|0;O()|0;break d}b=P()|0;O()|0;break d}b=P()|0;O()|0;break d}b=P()|0;O()|0;yb(d);break g}b=P()|0;O()|0}$d(h);break d}b=P()|0;O()|0;break d}b=P()|0;O()|0}ee(i)}S(b|0);L()}f=1}jb=e+128|0;return f|0}function Tha(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=jb-80|0;jb=e;Ic(b);a:{b:{c:{d:{e:{if(!EP(b,10053)){break e}g=Pp(e- -64|0);h=Pp(e+48|0);l=jt(e+32|0);v[113382]=0;R(403,a|0,32768);d=v[113382];v[113382]=0;if((d|0)==1){break b}v[113382]=0;d=Q(2,e+8|0,4443)|0;i=v[113382];v[113382]=0;if((i|0)==1){break c}Gb(a+1304436|0,d);yb(d);v[113382]=0;d=Q(2,e+8|0,2480)|0;i=v[113382];v[113382]=0;if((i|0)==1){break d}Gb(a+1304448|0,d);yb(d);v[a+1304496>>2]=2;j=a+484360|0;i=e+24|4;while(1){v[113382]=0;d=Q(228,b|0,8)|0;f=v[113382];v[113382]=0;f:{g:{h:{i:{j:{if((f|0)!=1){k:{l:{m:{n:{o:{if(!d){break o}v[113382]=0;d=Q(889,b|0,e+24|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break n}if(!d){break o}d=i;d=w[d|0]|w[d+1|0]<<8|(w[d+2|0]<<16|w[d+3|0]<<24);v[113382]=0;U(307,e+8|0,b|0,d<<8&16711680|d<<24|(d>>>8&65280|d>>>24));d=v[113382];v[113382]=0;if((d|0)==1){break m}v[113382]=0;d=T(303,e+8|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break g}if(d){break l}Bb(e+8|0)}if(x[a+480188>>1]){break k}d=0;break h}a=P()|0;O()|0;break a}a=P()|0;O()|0;break a}p:{q:{r:{s:{t:{d=e+24|0;d=w[d|0]|w[d+1|0]<<8|(w[d+2|0]<<16|w[d+3|0]<<24);d=d<<24|d<<8&16711680|(d>>>8&65280|d>>>24);if((d|0)<=1396788559){if((d|0)<=1346522947){if((d|0)==1129140036){break t}if((d|0)!=1346458708){break q}d=Vb(j);v[113382]=0;f=T(225,e+8|0)|0;k=v[113382];v[113382]=0;if((k|0)==1){break g}v[113382]=0;ea(544,d|0,e+8|0,f|0,255,254)|0;d=v[113382];v[113382]=0;if((d|0)!=1){break f}break g}if((d|0)==1346522948){break r}if((d|0)!=1347175758){break q}v[113382]=0;d=T(225,e+8|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break g}if(d>>>0<2){break f}v[113382]=0;m=T(445,e+8|0)|0;d=v[113382];v[113382]=0;if((d|0)!=1){break f}break g}if((d|0)<=1397507405){if((d|0)==1396788560){break s}if((d|0)!=1396854596){break q}if(jd(h)>>>0>3998){break f}v[113382]=0;d=T(225,e+8|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break g}if(!d){break f}v[113382]=0;R(563,h|0,e+8|0);d=v[113382];v[113382]=0;if((d|0)==1){break g}break f}if((d|0)==1397507406){break f}if((d|0)!=1397769541){break q}v[113382]=0;d=T(225,e+8|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break g}if(d>>>0<2){break f}v[113382]=0;d=T(445,e+8|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break g}o=a,p=Ed(d,1,255),v[o+480196>>2]=p;break f}if(x[a+480188>>1]){break f}v[113382]=0;d=T(225,e+8|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break g}f=0;if(d>>>0<8){break f}while(1){v[113382]=0;k=T(409,e+8|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break g}v[113382]=0;n=T(409,e+8|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break g}d=x[a+480188>>1];if(k|n){v[113382]=0;Z(387,((d<<5)+a|0)+480280|0);d=v[113382];v[113382]=0;if((d|0)==1){break g}k=x[a+480188>>1];d=k+1|0;u[a+480188>>1]=d;u[((k<<5)+a|0)+480284>>1]=f-1>>>0<2?192:64}v[113382]=0;Z(387,(((d&65535)<<5)+a|0)+480280|0);d=v[113382];v[113382]=0;if((d|0)==1){break g}d=x[a+480188>>1];u[a+480188>>1]=d+1;u[((d<<5)+a|0)+480284>>1]=f-1>>>0<2?192:64;f=f+1|0;if((f|0)!=4){continue}break}if(c){break f}d=1;break p}if(x[a+480190>>1]){break f}v[113382]=0;U(890,e+8|0,l|0,a|0);d=v[113382];v[113382]=0;if((d|0)!=1){break f}break g}if(jd(g)>>>0>255){break f}v[113382]=0;R(563,g|0,e+8|0);d=v[113382];v[113382]=0;if((d|0)!=1){break f}break g}d=e+24|0;if(!((w[d|0]|w[d+1|0]<<8|(w[d+2|0]<<16|w[d+3|0]<<24))&-2139062144)){break f}d=0}Bb(e+8|0);break h}v[a+480200>>2]=256;v[a+480204>>2]=125e4;v[a+480260>>2]=452;v[a+480264>>2]=3424;v[a+480228>>2]=48;v[a+480232>>2]=48;b=Vb(j);v[113382]=0;R(891,b|0,m&65535);b=v[113382];v[113382]=0;if((b|0)==1){break b}u:{if(!(c&1)){break u}d=0;b=jd(g);v[113382]=0;R(363,a+484344|0,b&65535);b=v[113382];v[113382]=0;if((b|0)==1){break b}if(!jd(g)){break u}b=0;while(1){d=sc(g,d);v[113382]=0;U(892,d|0,b&65535,a|0);d=v[113382];v[113382]=0;if((d|0)==1){break j}b=b+1|0;d=b&65535;if(jd(g)>>>0>d>>>0){continue}break}}f=1;if(x[a+480190>>1]<2){break i}i=c&2;b=0;v:{while(1){if(!i|jd(h)>>>0<=b>>>0){break i}w:{c=(B(f,104)+a|0)+484380|0;if(v[c>>2]){d=sc(h,b);v[113382]=0;d=T(225,d|0)|0;j=v[113382];v[113382]=0;if((j|0)==1){break w}tc(c,d);d=e+8|0;_d(d,l,f-1|0);d=Yc(e+24|0,8,1,1,Cb(d)?10:0);j=sc(h,b);v[113382]=0;W(362,d|0,c|0,j|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break v}b=b+1|0}d=1;f=f+1|0;if(f>>>0<x[a+480190>>1]){continue}break h}break}a=P()|0;O()|0;break a}a=P()|0;O()|0;break a}a=P()|0;O()|0;break a}a=P()|0;O()|0;break a}d=1}ee(l);cd(h);cd(g);break e}a=P()|0;O()|0;Bb(e+8|0);break a}Bb(e+8|0);continue}}jb=e+80|0;return d|0}a=P()|0;O()|0;break a}a=P()|0;O()|0;break a}a=P()|0;O()|0}ee(l);cd(h);cd(g);S(a|0);L()}function pd(a,b,c,d,e,f,g,h,i){var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;l=jb-96|0;jb=l;j=i&65535;k=j;w=h;t=h<<15|g>>>17;o=(e^i)&-2147483648;m=e&65535;n=m;p=d;D=m;m=0;A=(j&131071)<<15|h>>>17;B=i>>>16&32767;M=e>>>16&32767;a:{b:{if(B-1>>>0<32766&M-1>>>0<=32765){break b}C=e&2147483647;q=C;j=d;if(!(!j&(q|0)==2147418112?!(b|c):q>>>0<2147418112)){z=d;o=e|32768;break a}C=i&2147483647;e=C;d=h;if(!(!h&(e|0)==2147418112?!(f|g):e>>>0<2147418112)){z=h;o=i|32768;b=f;c=g;break a}if(!(b|j|(q^2147418112|c))){if(!(d|f|(e|g))){o=2147450880;b=0;c=0;break a}o=o|2147418112;b=0;c=0;break a}if(!(d|f|(e^2147418112|g))){d=b|j;e=c|q;b=0;c=0;if(!(d|e)){o=2147450880;break a}o=o|2147418112;break a}if(!(b|j|(c|q))){b=0;c=0;break a}if(!(d|f|(e|g))){b=0;c=0;break a}if((q|0)==65535|q>>>0<65535){i=b;d=!(n|p);h=d<<6;j=E(d?b:p)+32|0;b=E(d?c:n);b=h+((b|0)==32?j:b)|0;ef(l+80|0,i,c,p,n,b-15|0);x=16-b|0;p=v[l+88>>2];D=v[l+92>>2];c=v[l+84>>2];b=v[l+80>>2]}if(e>>>0>65535){break b}d=!(k|w);e=d<<6;h=E(d?f:w)+32|0;d=E(d?g:k);d=e+((d|0)==32?h:d)|0;ef(l- -64|0,f,g,w,k,d-15|0);x=(x-d|0)+16|0;f=v[l+76>>2];d=f;i=v[l+72>>2];e=i;e=e<<15;h=v[l+68>>2];g=h;f=v[l+64>>2];t=h>>>17|e;A=(d&131071)<<15|i>>>17}h=f;u=h<<15&-32768;e=0;r=c;i=0;q=qma(u,e,c,i);c=mb;F=c;d=c;s=(g&131071)<<15|h>>>17;c=b;f=qma(s,0,b,0);b=f+q|0;j=mb+d|0;k=b;b=b>>>0<f>>>0?j+1|0:j;h=0;g=qma(c,G,u,e);f=h+g|0;d=k;j=d+mb|0;j=f>>>0<g>>>0?j+1|0:j;g=j;I=(d|0)==(j|0)&h>>>0>f>>>0|d>>>0>j>>>0;n=p;N=qma(u,e,n,0);J=mb;j=qma(r,i,s,y);d=j+N|0;h=mb+J|0;O=d;w=qma(t,0,c,G);p=d+w|0;d=d>>>0<j>>>0?h+1|0:h;j=d+mb|0;C=p;j=p>>>0<w>>>0?j+1|0:j;w=j;p=j;j=(b|0)==(F|0)&k>>>0<q>>>0|b>>>0<F>>>0;k=b;b=b+C|0;h=j+p|0;F=b;h=b>>>0<k>>>0?h+1|0:h;p=h;j=u;H=D|65536;u=m;P=qma(j,e,H,m);K=mb;m=qma(n,Q,s,y);e=m+P|0;j=mb+K|0;j=e>>>0<m>>>0?j+1|0:j;R=e;k=qma(r,i,t,S);e=e+k|0;m=j;j=j+mb|0;j=e>>>0<k>>>0?j+1|0:j;L=e;A=A&2147483647|-2147483648;e=qma(A,0,c,G);c=L+e|0;q=j;j=j+mb|0;G=c;e=c>>>0<e>>>0?j+1|0:j;j=I;c=0;b=c+b|0;h=h+G|0;h=b>>>0<c>>>0?h+1|0:h;I=b;c=b;b=j+b|0;D=h;j=h;j=b>>>0<c>>>0?j+1|0:j;c=j;x=((B+M|0)+x|0)-16383|0;B=qma(n,Q,t,S);h=mb;s=qma(s,y,H,u);k=s+B|0;j=mb+h|0;j=k>>>0<s>>>0?j+1|0:j;s=k;k=j;y=(h|0)==(j|0)&s>>>0<B>>>0|h>>>0>j>>>0;i=qma(A,T,r,i);h=i+s|0;j=mb+j|0;j=h>>>0<i>>>0?j+1|0:j;i=h;h=j;r=(k|0)==(j|0)&i>>>0<s>>>0|j>>>0<k>>>0;k=y+r|0;j=0;j=k>>>0<r>>>0?1:j;r=qma(A,T,H,u);k=r+k|0;j=mb+j|0;y=k;k=k>>>0<r>>>0?j+1|0:j;s=i;r=h;B=y;i=(d|0)==(w|0)&C>>>0<O>>>0|d>>>0>w>>>0;d=i+((d|0)==(J|0)&N>>>0>O>>>0|d>>>0<J>>>0)|0;j=0;j=d>>>0<i>>>0?1:j;i=d;d=s+d|0;h=h+j|0;h=d>>>0<i>>>0?h+1|0:h;y=d;i=h;h=(h|0)==(r|0)&d>>>0<s>>>0|h>>>0<r>>>0;d=B+h|0;j=k;r=d;k=d>>>0<h>>>0?j+1|0:j;n=qma(A,T,n,Q);h=mb;t=qma(t,S,H,u);d=t+n|0;j=mb+h|0;j=d>>>0<t>>>0?j+1|0:j;t=d;u=d;d=j;j=(h|0)==(j|0)&n>>>0>u>>>0|h>>>0>j>>>0;n=d+r|0;h=j+k|0;h=n>>>0<d>>>0?h+1|0:h;k=h;u=n;n=0;d=n+y|0;j=i+t|0;j=d>>>0<n>>>0?j+1|0:j;h=j;n=(i|0)==(j|0)&d>>>0<y>>>0|i>>>0>j>>>0;i=u+n|0;j=k;t=i;i=i>>>0<n>>>0?j+1|0:j;n=d;k=h;h=(m|0)==(K|0)&P>>>0>R>>>0|m>>>0<K>>>0;m=(m|0)==(q|0)&R>>>0>L>>>0|m>>>0>q>>>0;h=h+m|0;h=h+((e|0)==(q|0)&G>>>0<L>>>0|e>>>0<q>>>0)|0;j=h;d=e+d|0;h=j+k|0;h=d>>>0<e>>>0?h+1|0:h;e=d;j=d;d=h;m=(h|0)==(k|0)&j>>>0<n>>>0|h>>>0<k>>>0;h=m+t|0;j=i;j=h>>>0<m>>>0?j+1|0:j;i=j;k=e;m=d;n=h;e=(p|0)==(D|0)&F>>>0>I>>>0|p>>>0>D>>>0;d=e+((p|0)==(w|0)&C>>>0>F>>>0|p>>>0<w>>>0)|0;j=0;j=d>>>0<e>>>0?1:j;e=d;d=k+d|0;h=j+m|0;h=d>>>0<e>>>0?h+1|0:h;j=d;e=h;m=(h|0)==(m|0)&j>>>0<k>>>0|h>>>0<m>>>0;h=n+m|0;j=i;j=h>>>0<m>>>0?j+1|0:j;i=j;c:{if(j&65536){x=x+1|0;break c}p=g>>>31|0;m=0;j=i<<1|h>>>31;h=h<<1|e>>>31;i=j;j=e<<1|d>>>31;d=d<<1|c>>>31;e=j;j=g<<1|f>>>31;f=f<<1;g=j;j=c<<1|b>>>31;b=b<<1|p;c=j|m}if((x|0)>=32767){o=o|2147418112;b=0;c=0;break a}d:{if((x|0)<=0){j=1-x|0;if(j>>>0>=128){b=0;c=0;break a}m=x+127|0;ef(l+48|0,f,g,b,c,m);ef(l+32|0,d,e,h,i,m);kl(l+16|0,f,g,b,c,j);kl(l,d,e,h,i,j);f=(v[l+48>>2]|v[l+56>>2])!=0|(v[l+52>>2]|v[l+60>>2])!=0|(v[l+32>>2]|v[l+16>>2]);g=v[l+36>>2]|v[l+20>>2];b=v[l+40>>2]|v[l+24>>2];c=v[l+44>>2]|v[l+28>>2];d=v[l>>2];e=v[l+4>>2];i=v[l+12>>2];h=v[l+8>>2];break d}i=i&65535|x<<16}z=h|z;o=i|o;if(!(!b&(c|0)==-2147483648?!(f|g):(c|0)>0|(c|0)>=0)){h=e;b=d+1|0;h=b?h:h+1|0;c=h;e=(e|0)==(h|0)&d>>>0>b>>>0|e>>>0>h>>>0;d=e+z|0;h=o;z=d;o=d>>>0<e>>>0?h+1|0:h;break a}if(b|f|(c^-2147483648|g)){b=d;c=e;break a}h=o;c=d&1;b=c+d|0;j=e;j=b>>>0<c>>>0?j+1|0:j;c=j;e=(e|0)==(j|0)&d>>>0>b>>>0|e>>>0>j>>>0;d=e+z|0;z=d;o=d>>>0<e>>>0?h+1|0:h}v[a>>2]=b;v[a+4>>2]=c;v[a+8>>2]=z;v[a+12>>2]=o;jb=l+96|0}function gga(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;f=jb+-64|0;jb=f;a:{if(!Rb(c,8)){break a}_b(c,4);while(1){m=Tz(c);if(m){break a}o=jb-288|0;jb=o;h=dN(o);g=jb-368|0;jb=g;e=g+80|0;dN(e);i=lc(h,e,282);e=0;h=c;if(sh(c,9642)){mg(h,4);k=af(g- -64|0,h);v[113382]=0;j=Q(1165,k|0,i|0)|0;l=v[113382];v[113382]=0;b:{c:{d:{e:{if((l|0)==1){break e}if(!j){break b}j=w[i+26|0];v[113382]=0;j=Q(228,k|0,j|0)|0;l=v[113382];v[113382]=0;if((l|0)==1){break e}if(!j){break b}if(!w[i+26|0]){j=0;break d}j=0;while(1){f:{v[113382]=0;l=T(341,k|0)|0;n=v[113382];v[113382]=0;if((n|0)==1){break f}t[(e+i|0)+27|0]=l;j=j+l|0;e=e+1|0;if(e>>>0<w[i+26|0]){continue}break d}break}e=P()|0;O()|0;break c}e=P()|0;O()|0;break c}e=0;v[113382]=0;l=j&65535;j=Q(228,k|0,l|0)|0;n=v[113382];v[113382]=0;g:{if((n|0)==1){break g}if(!j){break b}v[113382]=0;Q(304,k|0,l|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break g}mg(k,eN(i));v[113382]=0;j=T(1166,g+56|0)|0;e=v[113382];v[113382]=0;h:{if((e|0)!=1){e=g+80|0;cN(e);v[113382]=0;Q(1167,k|0,e|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break h}v[113382]=0;u[g+102>>1]=0;u[g+104>>1]=0;W(1168,j|0,g+80|0,g+107|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break h}e=w[i+26|0];v[113382]=0;Q(304,k|0,e|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break h}e=w[i+26|0];v[113382]=0;n=i+27|0;W(1168,j|0,n|0,e+n|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break h}v[113382]=0;U(307,g+40|0,k|0,l|0);e=v[113382];v[113382]=0;i:{j:{k:{if((e|0)!=1){v[113382]=0;R(821,g+16|0,g+40|0);e=v[113382];v[113382]=0;if((e|0)==1){break k}v[113382]=0;R(1170,g+8|0,g+16|0);e=v[113382];v[113382]=0;if((e|0)==1){break j}v[113382]=0;Q(1171,j|0,g+8|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break j}Cc(g+16|0);Bb(g+40|0);e=0;v[113382]=0;j=T(1172,j|0)|0;l=v[113382];v[113382]=0;if((l|0)==1){break h}if((j|0)!=(w[i+22|0]|w[i+23|0]<<8|(w[i+24|0]<<16|w[i+25|0]<<24))){break b}e=eN(i);v[113382]=0;Q(304,h|0,e|0)|0;h=v[113382];v[113382]=0;e=1;if((h|0)!=1){break b}break g}e=P()|0;O()|0;break c}e=P()|0;O()|0;break i}e=P()|0;O()|0;Cc(g+16|0)}Bb(g+40|0);break c}e=P()|0;O()|0;break c}e=P()|0;O()|0;break c}e=P()|0;O()|0}Bb(k);S(e|0);L()}Bb(k)}jb=g+368|0;jb=o+288|0;if(e){continue}break}}t[d|0]=w[d|0]!=0|m;Ic(c);l:{m:{n:{o:{p:{q:{if(m){d=Df(c);h=f+48|0;td(h,c,$e(c));u[a+34>>1]=x[a+34>>1]&65534|w[b|0]>15;b=x[a+34>>1]&-65|(w[b+1|0]!=1)<<6;u[a+34>>1]=b;v[a>>2]=d>>>(b&1)>>>(b>>>6&1);v[113382]=0;v[f+44>>2]=0;v[f+40>>2]=0;R(821,f+16|0,h|0);b=v[113382];v[113382]=0;if((b|0)==1){break q}v[113382]=0;c=T(426,f+16|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){d=v[f+16>>2];v[113382]=0;b=T(818,c|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break n}v[113382]=0;h=T(819,d|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break n}v[113382]=0;b=ea(820,b|0,h|0,f+44|0,f+40|0,0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break n}v[113382]=0;Q(304,f+48|0,v[f+44>>2])|0;h=v[113382];v[113382]=0;if((h|0)==1){break n}if(!b){break o}h=v[f+44>>2];v[113382]=0;T(422,a|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break n}m=d-h|0;h=c+h|0;c=v[f+40>>2];d=0;while(1){r:{if(c){if(!m|(c|0)!=1){break p}if(y[a>>2]>d>>>0){break r}break p}if(y[a>>2]<=d>>>0){break p}}if(!Be(a)){break p}v[113382]=0;v[f+12>>2]=0;v[f+8>>2]=0;c=T(818,h|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break n}v[113382]=0;g=T(819,m|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break n}v[113382]=0;c=ka(822,b|0,c|0,g|0,f+12|0,f+4|0,f+8|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break n}v[113382]=0;v[f+44>>2]=c;Q(304,f+48|0,c|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break n}c=v[a>>2];v[113382]=0;g=v[f+44>>2];c=T(823,c-d|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break n}Si(f+8|0,c);s:{if(v[f+8>>2]<=0){break s}if(v[f+12>>2]!=(te(a)|0)){break s}c=0;if(v[f+12>>2]<=0){break s}while(1){t:{if(t[a+34|0]&1){e=v[a+20>>2];i=te(a);k=v[v[f+4>>2]+(c<<2)>>2];v[113382]=0;fa(824,e+(B(d,i)<<1)|0,k|0,v[f+12>>2],v[f+8>>2],c|0);e=v[113382];v[113382]=0;if((e|0)!=1){break t}break n}e=v[a+20>>2];i=te(a);k=v[v[f+4>>2]+(c<<2)>>2];v[113382]=0;fa(825,e+B(d,i)|0,k|0,v[f+12>>2],v[f+8>>2],c|0);e=v[113382];v[113382]=0;if((e|0)==1){break n}}c=c+1|0;if((c|0)<v[f+12>>2]){continue}break}}v[113382]=0;e=v[f+8>>2];c=T(826,b|0)|0;i=v[113382];v[113382]=0;if((i|0)==1){break n}m=m-g|0;h=g+h|0;v[f+40>>2]=c;d=d+e|0;continue}}break n}zg(b,a,c);c=1;break l}c=P()|0;O()|0;break m}v[113382]=0;Z(827,b|0);a=v[113382];v[113382]=0;if((a|0)!=1){break o}break n}c=(b|0)!=0;Cc(f+16|0);Bb(f+48|0);break l}c=P()|0;O()|0;Cc(f+16|0)}Bb(f+48|0);S(c|0);L()}jb=f- -64|0;return c|0}function sga(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,y=0,z=0,A=0;g=jb-208|0;jb=g;Ic(b);a:{b:{c:{d:{e:{if(!gA(b,g+160|0)){break e}if(!yO(g+160|0)){break e}if(!c){i=1;break e}if(!Rb(b,dd(xO(g+160|0),mb))){break e}Id(a,128);e=g+144|0;Cg(e,2,g+175|0);d=g+72|0;Ec(d,e);Gb(a+1304400|0,d);yb(d);h=Ub(d,4741);Gb(a+1304436|0,h);yb(h);h=Ub(d,2476);Gb(a+1304448|0,h);yb(h);e=Ub(e,13471);v[113382]=0;U(991,d|0,e|0,v[(w[g+174|0]<<2)+72380>>2]);d=v[113382];v[113382]=0;i=1;if((d|0)==1){break b}d=g+72|0;Gb(a+1304460|0,d);yb(d);yb(e);v[a+480208>>2]=12;v[a+1304496>>2]=4;Vy(a+1304424|0,b,w[g+207|0]<<5,32,0);z=a,A=le(b),u[z+480190>>1]=A;if(x[a+480190>>1]){j=1;while(1){f:{if(w[g+174|0]>=52){vA(b,g+72|0);break f}e=jb-16|0;jb=e;v[e+12>>2]=64;v[e>>2]=66;d=b;h=v[Lb(e+12|0,e)>>2];if(!Rb(d,h)){h=$e(d)}f=g+72|0;Qt(e,f);kg(d,v[e>>2],h);Qt(e,f);Qb(v[e>>2]+h|0,0,66-h|0);_b(d,v[e+12>>2]);jb=e+16|0;d=w[g+134|0]|w[g+135|0]<<8;t[g+136|0]=d;t[g+137|0]=d>>>8;t[g+134|0]=171;t[g+135|0]=32}h=jb-32|0;jb=h;e=(B(i,104)+a|0)+484380|0;sd(e,0);k=g+72|0;d=k;Jk(h,2,d+32|0);f=h+16|0;Ec(f,h);v[113382]=0;Q(336,e+43|0,f|0)|0;f=v[113382];v[113382]=0;g:{if((f|0)!=1){yb(h+16|0);h:{if((w[d+56|0]|w[d+57|0]<<8|(w[d+58|0]<<16|w[d+59|0]<<24))>>>0<=(w[d+52|0]|w[d+53|0]<<8|(w[d+54|0]<<16|w[d+55|0]<<24))>>>0){break h}v[e>>2]=(w[d+56|0]|w[d+57|0]<<8|(w[d+58|0]<<16|w[d+59|0]<<24))-(w[d+52|0]|w[d+53|0]<<8|(w[d+54|0]<<16|w[d+55|0]<<24));v[e+12>>2]=w[d+44|0]|w[d+45|0]<<8|(w[d+46|0]<<16|w[d+47|0]<<24);v[h+16>>2]=w[d+48|0]|w[d+49|0]<<8|(w[d+50|0]<<16|w[d+51|0]<<24);z=e,A=v[Lb(h+16|0,e)>>2],v[z+16>>2]=A;u[e+30>>1]=w[d+60|0];v[e+24>>2]=w[d+62|0]|w[d+63|0]<<8;f=d- -64|0;if(w[f|0]|w[f+1|0]<<8){Ys(e,+((w[f|0]|w[f+1|0]<<8)<<16>>16)*25431315104166665e-22)}if(w[d+61|0]&8){u[e+34>>1]=x[e+34>>1]|8}if(w[d+61|0]&16){u[e+34>>1]=x[e+34>>1]|16}if(!(w[d+61|0]&4)){break h}u[e+34>>1]=x[e+34>>1]|1;v[e+12>>2]=v[e+12>>2]>>>1;v[e+16>>2]=v[e+16>>2]>>>1}jb=h+32|0;break g}a=P()|0;O()|0;yb(h+16|0);S(a|0);L()}d=g+56|0;Cg(d,2,k);e=g+144|0;Ec(e,d);v[113382]=0;Q(335,((i<<5)+a|0)+946304|0,e|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break c}yb(g+144|0);j=j+1|0;i=j&65535;if(i>>>0<=x[a+480190>>1]){continue}break}}Qp(Vb(a+484360|0),b,256,255,254);i=0;d=le(b);if(d>>>0>=127){break e}u[a+480188>>1]=d+1;d=le(b);r=d+1|0;if(x[a+480188>>1]){while(1){e=(i<<5)+a|0;Dg(e+480280|0);h=e+480284|0;i:{if(w[g+174|0]>=51){e=(le(b)<<4|8)&248;break i}e=i&1?192:64}u[h>>1]=e;i=i+1|0;if(i>>>0<x[a+480188>>1]){continue}break}}m=a+484344|0;dg(m,r);i=0;j=0;while(1){e=j&65535;if(!Og(m,e,64)){break e}j=j+1|0;if(d>>>0>e>>>0){continue}break}if(x[a+480188>>1]){while(1){h=Oh(g+72|0);n=0;while(1){if(Rb(b,5)){j=0;i=Bf(Zb(m,n),0,p&65535);while(1){l=w[g+174|0];f=jb-16|0;jb=f;q=1;s=64-j|0;e=b;k=le(e);if((k|0)==252){q=le(e);k=le(e)}d=h;t[d|0]=(k-1&255)>>>0<60?k+36|0:0;k=f+8|0;Ul(k,e);e=Zc(k);o=Cf(k);y=Ph(k);t[d+1|0]=w[k|0];t[f+7|0]=w[e|0]&15;t[f+6|0]=w[e|0]>>>4;t[f+5|0]=w[o|0];t[f+4|0]=w[y|0];wO(f+7|0,f+5|0,l);wO(f+6|0,f+4|0,l);k=w[f+7|0];l=(k|0)!=10;e=w[f+6|0];j:{if(!(l|(e|0)!=10)){t[f+7|0]=0;z=f,A=Qk((w[f+4|0]|w[f+5|0]<<8)>>>6|0),t[z+5|0]=A;break j}k:{l:{m:{if(!l){z=f,A=Qk(w[f+5|0]<<2),t[z+5|0]=A;break m}if((e|0)==10){z=f,A=Qk(w[f+4|0]<<2),t[z+4|0]=A;break j}if((e|0)!=(k|0)){break m}e=0;t[f+6|0]=0;break l}if((e|0)==13){break k}}if((k|0)==13|e){break j}}Rg(f+7|0,f+6|0);Rg(f+5|0,f+4|0)}e=f+6|0;k=f+4|0;l=f+7|0;o=f+5|0;Cx(e,k,l,o);Bx(f,l,o,e,k);t[d+2|0]=w[f+7|0];t[d+4|0]=w[f+5|0];t[d+3|0]=w[f+6|0];t[d+5|0]=w[f+4|0];jb=f+16|0;e=j+q|0;j=e>>>0>64?s:q;if(j){while(1){d=v[g+72>>2];t[i|0]=d;t[i+1|0]=d>>>8;t[i+2|0]=d>>>16;t[i+3|0]=d>>>24;d=x[g+76>>1];t[i+4|0]=d;t[i+5|0]=d>>>8;i=B(x[a+480188>>1],6)+i|0;j=j-1|0;if(j){continue}break}d=e>>>0<64;j=d?e:64;if(d){continue}}break}n=n+1|0;if((r|0)!=(n|0)){continue}}break}p=p+1|0;if(x[a+480188>>1]>(p&65535)>>>0){continue}break}}e=x[a+480188>>1];d=g+8|0;h=jt(d);t[d+16|0]=0;u[d+14>>1]=0;u[d+12>>1]=e;v[113382]=0;U(993,h|0,e|0,0);e=v[113382];v[113382]=0;if((e|0)==1){a=P()|0;O()|0;ee(h);S(a|0);L()}v[113382]=0;U(992,g+32|0,m|0,d|0);e=v[113382];v[113382]=0;i=1;if((e|0)==1){break d}ee(g+32|0);ee(d);if(!(c&2)|!x[a+480190>>1]){break e}j=1;while(1){c=B(j&65535,104)+a|0;zg(Yc(g+72|0,u[c+484414>>1]&1?16:8,1,0,0),c+484380|0,b);j=j+1|0;if(x[a+480190>>1]>=(j&65535)>>>0){continue}break}}jb=g+208|0;return i|0}i=P()|0;O()|0;ee(d);break a}i=P()|0;O()|0;yb(g+144|0);break a}i=P()|0;O()|0;yb(e)}S(i|0);L()}function Rga(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=jb-192|0;jb=d;Ic(b);a:{if(!gA(b,d+144|0)){break a}if(!KO(d+144|0)){break a}if(!Rb(b,dd(JO(d+144|0),mb))){break a}b:{if(!c){break b}Id(a,256);h=d+16|0;Dn(h,2,d+144|0);g=d+48|0;Ec(g,h);Gb(a+1304400|0,g);yb(g);e=Ub(g,11334);Gb(a+1304436|0,e);yb(e);e=Ub(g,6208);Gb(a+1304448|0,e);yb(e);g=Ub(d+128|0,11131);v[113382]=0;R(189,h|0,g|0);e=v[113382];v[113382]=0;c:{d:{e:{f:{g:{h:{i:{if((e|0)!=1){v[113382]=0;R(406,d+112|0,d+175|0);e=v[113382];v[113382]=0;if((e|0)==1){break i}v[113382]=0;X(407,d+48|0,d+16|0,d+174|0,d+112|0);e=v[113382];v[113382]=0;if((e|0)==1){break h}e=d+48|0;Gb(a+1304460|0,e);yb(e);yb(d+112|0);Ib(d+16|0);yb(g);v[a+1304496>>2]=4;v[a+480260>>2]=64;v[a+480264>>2]=32767;v[a+480188>>2]=2031620;f=w[d+176|0];if(w[d+175|0]<=20){e=((f&255)>>>0)/10|0;f=e<<4|f-B(e,10)}h=(f&255?f:96)&255;e=mM(h);v[a+480196>>2]=h>>>4;v[a+480204>>2]=e;if(w[d+175|0]>10){break e}break d}f=P()|0;O()|0;break f}f=P()|0;O()|0;break g}f=P()|0;O()|0;yb(d+112|0)}Ib(d+16|0)}yb(g);break c}t[d+48|0]=64;p=a,q=w[pc(d+178|0,d+48|0)|0]<<2,v[p+480200>>2]=q}f=0;while(1){e=(f<<5)+a|0;Dg(e+480280|0);u[e+480284>>1]=f&1?64:192;f=f+1|0;if((f|0)!=4){continue}break}f=1;j:{k:{while(1){kt(b,d+16|0);if(w[d+28|0]!=46?w[d+28|0]:0){break k}j=jb-32|0;jb=j;i=(B(f,104)+a|0)+484380|0;sd(i,0);l=d+16|0;g=l;Jk(j,2,g);e=j+16|0;Ec(e,j);v[113382]=0;Q(336,i+43|0,e|0)|0;e=v[113382];v[113382]=0;l:{m:{if((e|0)!=1){h=j+16|0;yb(h);e=g+24|0;v[i+24>>2]=w[e|0]|w[e+1|0]<<8;t[j+16|0]=w[g+22|0];t[j|0]=64;p=i,q=w[pc(h,j)|0]<<2,u[p+30>>1]=q;e=g+16|0;v[i>>2]=w[e|0]|w[e+1|0]<<8;e=g+18|0;v[i+4>>2]=w[e|0]|w[e+1|0]<<8;e=g+20|0;g=w[e|0]|w[e+1|0]<<8;v[i+8>>2]=g;h=v[i>>2];if(h>>>0>1){break m}v[i>>2]=0;break l}a=P()|0;O()|0;yb(j+16|0);S(a|0);L()}e=v[i+4>>2];if((g|0)==65535|h>>>0<=e>>>0|e>>>0>=g>>>0){break l}u[i+34>>1]=2;p=i,q=v[Lb(i+8|0,i)>>2],v[p+8>>2]=q}jb=j+32|0;Jk(d,2,l);e=d+112|0;Ec(e,d);v[113382]=0;Q(335,((f<<5)+a|0)+946304|0,e|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break j}yb(d+112|0);u[((f<<1)+d|0)+46>>1]=w[d+30|0]|w[d+31|0]<<8;f=f+1|0;if((f|0)!=32){continue}break}e=a+484360|0;Qp(Vb(e),b,w[d+175|0]?128:64,65535,65535);e=Vb(e);p=d,q=ac(e),v[p+16>>2]=q;p=d,q=bc(e),v[p+112>>2]=q;if(Jb(d+16|0,d+112|0)){while(1){e=v[d+16>>2];h=x[e>>1];n:{if(!((h|0)!=255&(h|0)!=99)){u[e>>1]=65535;break n}if(h>>>0>63){break k}}e=d+16|0;re(e);if(Jb(e,d+112|0)){continue}break}}l=c&1;if(l){dg(a+484344|0,w[d+177|0])}if(w[d+177|0]){o=a+484344|0;while(1){o:{p:{if(l){if(Og(o,m&65535,64)){break p}}f=0;while(1){if((le(b)+5&255)>>>0>=3){_b(b,3)}f=f+1|0;if((f|0)!=256){continue}break}break o}p=d,q=ac(Zb(o,m)),v[p+112>>2]=q;v[d>>2]=63;k=65535;n=0;while(1){f=0;while(1){h=f;g=0;f=0;i=0;j=0;q:{r:{s:{t:{u:{v:{e=le(b);switch(e-251|0){case 1:break q;case 0:break t;case 2:break v;default:break u}}t[v[d+112>>2]]=254;break q}g=d+16|0;iq(g,b);f=w[ec(g,0)|0];i=w[ec(g,1)|0];j=w[ec(g,2)|0];g=254;if((e|0)==254){break s}g=e;if(e>>>0>95){break r}}g=(B(g>>>4|0,12)+(g&15)|0)+37|0}e=g;t[v[d+112>>2]]=e}t[v[d+112>>2]+1|0]=(f&248)>>>3;if(w[v[d+112>>2]+1|0]>=32){t[v[d+112>>2]+1|0]=0}e=i>>>1&120|f&7;if(e>>>0<=64){t[v[d+112>>2]+2|0]=1;t[v[d+112>>2]+4|0]=e}t[v[d+112>>2]+3|0]=w[(i&15)+24160|0];t[v[d+112>>2]+5|0]=j;w:{switch(w[v[d+112>>2]+3|0]-11|0){case 0:g=v[d+112>>2];e=w[g+5|0];if(w[v[d+112>>2]+5|0]&15){t[g+5|0]=e&15;break q}t[g+5|0]=e&240;break q;case 3:e=w[v[d+112>>2]+5|0];t[v[d+112>>2]+5|0]=B(e&240,10)|e&15;x:{if((k|0)!=65535){if(w[v[d+112>>2]+5|0]){break x}t[v[d+112>>2]+3|0]=12;t[v[d+112>>2]+5|0]=k}k=65535}tc(d,n);break q;case 1:k=w[v[d+112>>2]+5|0];v[d>>2]=63;t[v[d+112>>2]+3|0]=0;break q;case 5:if(w[d+175|0]<=20){e=w[v[d+112>>2]+5|0];t[v[d+112>>2]+5|0]=(e>>>0)%10|(e>>>0)/10<<4}if(w[v[d+112>>2]+5|0]){break q}t[v[d+112>>2]+3|0]=0;break q;case 7:break q;default:break w}}if(w[v[d+112>>2]+5|0]){break q}t[v[d+112>>2]+3|0]=0}Bj(d+112|0);f=h+1|0;if((h&65535)>>>0<3){continue}break}n=n+1|0;if((n|0)!=64){continue}break}if((k|0)==65535){break o}sl(Zb(o,m),Cn(Me(Ln(d+16|0,12,k&255),v[d>>2])))}m=m+1|0;if(m>>>0<w[d+177|0]){continue}break}}f=1;if(!(c&2)){break a}h=Yc(d+16|0,8,1,0,0);while(1){c=B(f,104)+a|0;e=c+484380|0;y:{if(!v[e>>2]|!x[c+484410>>1]){break y}c=x[((f<<1)+d|0)+46>>1];if(c>>>0<4){break y}if(!Nc(b,c<<4)){break y}zg(h,e,b)}f=f+1|0;if((f|0)!=32){continue}break}break b}f=0;break a}f=P()|0;O()|0;yb(d+112|0)}S(f|0);L()}f=1}jb=d+192|0;return f|0}function wT(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=jb-3040|0;jb=f;Ic(b);h=jb-16|0;jb=h;j=h+8|0;g=f+1080|0;KA(j,g);k=Hb(j);e=b;j=mc(e,$b(h,j));if((k|0)==(j|0)){_b(e,Hb(h+8|0))}jb=h+16|0;e=(j|0)==(k|0);if(!e){LA(g)}a:{if(!e){break a}if(!PA(f+1080|0)){break a}if(!c){d=1;break a}if(!Rb(b,dd(1024,0))){break a}OA(b,f+560|0);OA(b,f+48|0);while(1){e=i<<2;h=e+(f+560|0)|0;if((w[h|0]|w[h+1|0]<<8|(w[h+2|0]<<16|w[h+3|0]<<24))>>>0>16777215){break a}e=e+(f+48|0)|0;g=w[e+1|0]<<8;j=w[e+2|0]<<16|w[e+3|0]<<24;if((w[e|0]|g|j)>>>0<3|(j|(g|w[e|0]))>>>0>4096){break a}if(!NA(b,((w[h|0]|w[h+1|0]<<8|(w[h+2|0]<<16|w[h+3|0]<<24))+(w[e|0]|w[e+1|0]<<8|(w[e+2|0]<<16|w[e+3|0]<<24))|0)+2978|0)){break a}i=i+1|0;if((i|0)!=128){continue}break}Id(a,2);vi(a);d=f+16|0;e=Ub(d,9794);Gb(a+1304436|0,e);yb(e);e=Ub(d,10451);Gb(a+1304448|0,e);yb(e);d=Ub(d,11735);Gb(a+1304460|0,d);yb(d);v[a+1304496>>2]=4;d=w[f+1080|0];v[a+480204>>2]=143e4;v[a+480196>>2]=d;j=a+484360|0;Ne(Vb(j),w[f+1081|0]);v[a+480188>>2]=4194317;Nb(a+1074312|0,95,1);v[a+480208>>2]=v[a+480208>>2]|16777216;d=0;while(1){u[((d<<5)+a|0)+480284>>1]=d&1?192:64;d=d+1|0;if((d|0)!=4){continue}break}d=0;b:{c:{d:{e:{while(1){e=d+1|0;i=B(e,104)+a|0;h=i+484380|0;sd(h,2);g=f+32|0;uh(g,1,(B(d,13)+f|0)+1082|0);k=f+16|0;Ec(k,g);v[113382]=0;Q(335,((e<<5)+a|0)+946304|0,k|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break e}yb(f+16|0);g=h;d=(f+1080|0)+(d<<4)|0;h=d+422|0;v[g>>2]=w[h|0]|w[h+1|0]<<8|(w[h+2|0]<<16|w[h+3|0]<<24);if((w[d+430|0]|w[d+431|0]<<8|(w[d+432|0]<<16|w[d+433|0]<<24))>>>0<=(w[d+422|0]|w[d+423|0]<<8|(w[d+424|0]<<16|w[d+425|0]<<24))>>>0){v[i+484384>>2]=w[d+426|0]|w[d+427|0]<<8|(w[d+428|0]<<16|w[d+429|0]<<24);d=w[d+430|0]|w[d+431|0]<<8|(w[d+432|0]<<16|w[d+433|0]<<24);u[i+484414>>1]=2;v[i+484388>>2]=d}v[i+484404>>2]=8287;d=e;if((d|0)!=32){continue}break}i=0;while(1){d=i+33|0;h=(B(d,104)+a|0)+484380|0;sd(h,2);e=f+32|0;uh(e,1,(B(i,13)+f|0)+2010|0);g=f+16|0;Ec(g,e);v[113382]=0;Q(335,((d<<5)+a|0)+946304|0,g|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break d}d=f+16|0;yb(d);v[f+24>>2]=0;v[f+16>>2]=0;v[f+20>>2]=0;e=(f+1080|0)+B(i,11)|0;g=w[e+1347|0];o=ec(d,0),p=g,t[o|0]=p;g=w[e+1352|0];o=ec(d,1),p=g,t[o|0]=p;g=w[e+1348|0];o=ec(d,2),p=g,t[o|0]=p;g=w[e+1353|0];o=ec(d,3),p=g,t[o|0]=p;g=w[e+1349|0];o=ec(d,4),p=g,t[o|0]=p;g=w[e+1354|0];o=ec(d,5),p=g,t[o|0]=p;g=w[e+1350|0];o=ec(d,6),p=g,t[o|0]=p;g=w[e+1355|0];o=ec(d,7),p=g,t[o|0]=p;g=w[e+1351|0];o=ec(d,8),p=g,t[o|0]=p;g=w[e+1356|0];o=ec(d,9),p=g,t[o|0]=p;e=w[e+1346|0];o=ec(d,10),p=e,t[o|0]=p;v[f+8>>2]=v[f+24>>2];d=v[f+20>>2];v[f>>2]=v[f+16>>2];v[f+4>>2]=d;rp(h,1,f);i=i+1|0;if((i|0)!=32){continue}break}fq(Vb(j),f+2778|0,256,255,65535);g=a+484344|0;dg(g,128);n=c&1;i=0;f:{while(1){e=i<<2;d=e+(f+560|0)|0;Nc(b,(w[d|0]|w[d+1|0]<<8|(w[d+2|0]<<16|w[d+3|0]<<24))+2978|0);d=e+(f+48|0)|0;td(f+16|0,b,w[d|0]|w[d+1|0]<<8|(w[d+2|0]<<16|w[d+3|0]<<24));g:{if(!n){break g}v[113382]=0;d=W(364,g|0,i&65535,64)|0;e=v[113382];v[113382]=0;if((e|0)==1){break c}if(!d){break g}d=0;h=Zb(g,i);while(1){v[113382]=0;e=Q(228,f+16|0,1)|0;j=v[113382];v[113382]=0;h:{i:{if((j|0)!=1){if(!e){break g}v[113382]=0;e=T(409,f+16|0)|0;j=v[113382];v[113382]=0;if((j|0)==1){break c}if(e>>>0>12){break i}v[113382]=0;j=W(432,h|0,d|0,e|0)|0;k=v[113382];v[113382]=0;if((k|0)==1){break c}v[113382]=0;R(433,f+32|0,f+16|0);k=v[113382];v[113382]=0;if((k|0)==1){break c}k=f+32|0;l=Zc(k);m=w[k|0];e=e>>>0>3;t[j|0]=((m&15)+(e?13:37)|0)+B(m>>>4&7,12);t[j+1|0]=((w[l|0]>>>4|0)+(e?33:1)|0)+(w[k|0]>>>3&16);MA(j,w[l|0],e);break h}break c}j=e-32|0;if((j&255)>>>0<=12){v[113382]=0;j=W(432,h|0,d|0,j&65535)|0;k=v[113382];v[113382]=0;if((k|0)==1){break c}v[113382]=0;k=T(409,f+16|0)|0;l=v[113382];v[113382]=0;if((l|0)==1){break c}MA(j,k,e>>>0>35);break h}if((e|0)!=64){if((e|0)!=96){break f}if(!d){break g}v[113382]=0;d=W(432,h|0,d-1|0,0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break c}t[d+3|0]=14;break g}v[113382]=0;e=T(409,f+16|0)|0;j=v[113382];v[113382]=0;if((j|0)==1){break c}d=d+e|0}if(d>>>0<64){continue}break}}Bb(f+16|0);i=i+1|0;if((i|0)!=128){continue}break}d=1;if(!(c&2)){break a}i=1;while(1){zg(Yc(f+16|0,8,1,0,1),(B(i,104)+a|0)+484380|0,b);i=i+1|0;if((i|0)!=33){continue}break}break a}Bb(f+16|0);d=0;break a}d=P()|0;O()|0;yb(f+16|0);break b}d=P()|0;O()|0;yb(f+16|0);break b}d=P()|0;O()|0;Bb(f+16|0)}S(d|0);L()}jb=f+3040|0;return d|0}function _H(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=jb-416|0;jb=e;t[e+415|0]=c;a:{if(nj(b)){break a}f=w[gk(b)|0];if((f|0)==33){d=1}else{if((f|0)!=63){break a}d=0}rk(e+160|0,b,v[b+4>>2]-1|0);f=v[e+164>>2];v[b>>2]=v[e+160>>2];v[b+4>>2]=f}f=e+160|0;Ad(f);g=v[e+160>>2];Ad(e+376|0);h=fk(g,v[e+380>>2],b);Ad(f);f=v[b>>2];g=v[b+4>>2];b:{c:{d:{e:{f:{g:{h:{if((h|0)==v[e+164>>2]){v[e+400>>2]=f;v[e+404>>2]=g;a=qc(e+392|0,17540);c=v[e+404>>2];v[e+8>>2]=v[e+400>>2];v[e+12>>2]=c;c=v[a+4>>2];v[e>>2]=v[a>>2];v[e+4>>2]=c;if(Hc(e+8|0,e)){a=ba(8)|0;v[113382]=0;R(2110,e+376|0,e+415|0);b=v[113382];v[113382]=0;if((b|0)!=1){v[113382]=0;U(2088,e+160|0,13642,e+376|0);b=v[113382];v[113382]=0;if((b|0)==1){break g}nc(a,e+160|0);v[113382]=0;U(1978,a|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break b}b=P()|0;O()|0;yb(e+160|0);yb(e+376|0);break c}b=P()|0;O()|0;break d}if(!d){break h}a=ba(8)|0;v[113382]=0;d=Q(2111,e+344|0,b|0)|0;b=v[113382];v[113382]=0;i:{j:{k:{l:{m:{n:{o:{p:{if((b|0)!=1){v[113382]=0;U(2088,e+360|0,13678,d|0);b=v[113382];v[113382]=0;if((b|0)==1){break p}v[113382]=0;U(2106,e+376|0,e+360|0,13652);b=v[113382];v[113382]=0;c=1;if((b|0)==1){break o}v[113382]=0;R(2110,e+328|0,e+415|0);b=v[113382];v[113382]=0;if((b|0)==1){break n}v[113382]=0;U(137,e+160|0,e+376|0,e+328|0);b=v[113382];v[113382]=0;if((b|0)==1){break m}nc(a,e+160|0);v[113382]=0;U(1978,a|0,78672,1986);b=v[113382];v[113382]=0;if((b|0)!=1){break b}b=P()|0;O()|0;yb(e+160|0);c=0;break l}b=P()|0;O()|0;break i}b=P()|0;O()|0;yb(d);break i}b=P()|0;O()|0;break j}b=P()|0;O()|0;break k}b=P()|0;O()|0}yb(e+328|0)}yb(e+376|0)}yb(e+360|0);yb(d);if(!c){break c}}ca(a|0);break c}v[e+320>>2]=f;v[e+324>>2]=g;d=qc(e+312|0,17540);f=v[e+324>>2];v[e+152>>2]=v[e+320>>2];v[e+156>>2]=f;f=v[d+4>>2];v[e+144>>2]=v[d>>2];v[e+148>>2]=f;if(Hc(e+152|0,e+144|0)){a=ba(8)|0;v[113382]=0;R(2110,e+376|0,e+415|0);b=v[113382];v[113382]=0;if((b|0)!=1){v[113382]=0;U(2088,e+160|0,13642,e+376|0);b=v[113382];v[113382]=0;if((b|0)==1){break f}nc(a,e+160|0);v[113382]=0;U(1978,a|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break b}b=P()|0;O()|0;yb(e+160|0);yb(e+376|0);break c}b=P()|0;O()|0;break e}d=v[b+4>>2];v[e+304>>2]=v[b>>2];v[e+308>>2]=d;d=qc(e+296|0,3674);f=v[e+308>>2];v[e+136>>2]=v[e+304>>2];v[e+140>>2]=f;f=v[d+4>>2];v[e+128>>2]=v[d>>2];v[e+132>>2]=f;q:{if(!Hc(e+136|0,e+128|0)){d=v[b+4>>2];v[e+288>>2]=v[b>>2];v[e+292>>2]=d;d=qc(e+280|0,3656);f=v[e+292>>2];v[e+120>>2]=v[e+288>>2];v[e+124>>2]=f;f=v[d+4>>2];v[e+112>>2]=v[d>>2];v[e+116>>2]=f;if(!Hc(e+120|0,e+112|0)){break q}}t[a+60|0]=c;break h}d=v[b+4>>2];v[e+272>>2]=v[b>>2];v[e+276>>2]=d;d=qc(e+264|0,3240);f=v[e+276>>2];v[e+104>>2]=v[e+272>>2];v[e+108>>2]=f;f=v[d+4>>2];v[e+96>>2]=v[d>>2];v[e+100>>2]=f;r:{if(!Hc(e+104|0,e+96|0)){d=v[b+4>>2];v[e+256>>2]=v[b>>2];v[e+260>>2]=d;d=qc(e+248|0,3221);f=v[e+260>>2];v[e+88>>2]=v[e+256>>2];v[e+92>>2]=f;f=v[d+4>>2];v[e+80>>2]=v[d>>2];v[e+84>>2]=f;if(!Hc(e+88|0,e+80|0)){break r}}t[a+61|0]=c;break h}d=v[b+4>>2];v[e+240>>2]=v[b>>2];v[e+244>>2]=d;d=qc(e+232|0,3324);f=v[e+244>>2];v[e+72>>2]=v[e+240>>2];v[e+76>>2]=f;f=v[d+4>>2];v[e+64>>2]=v[d>>2];v[e+68>>2]=f;if(Hc(e+72|0,e- -64|0)){t[a+62|0]=c;break h}d=v[b+4>>2];v[e+224>>2]=v[b>>2];v[e+228>>2]=d;d=qc(e+216|0,2484);f=v[e+228>>2];v[e+56>>2]=v[e+224>>2];v[e+60>>2]=f;f=v[d+4>>2];v[e+48>>2]=v[d>>2];v[e+52>>2]=f;if(Hc(e+56|0,e+48|0)){t[a+63|0]=c;break h}d=v[b+4>>2];v[e+208>>2]=v[b>>2];v[e+212>>2]=d;d=qc(e+200|0,3723);f=v[e+212>>2];v[e+40>>2]=v[e+208>>2];v[e+44>>2]=f;f=v[d+4>>2];v[e+32>>2]=v[d>>2];v[e+36>>2]=f;if(Hc(e+40|0,e+32|0)){t[a+64|0]=c;break h}d=v[b+4>>2];v[e+192>>2]=v[b>>2];v[e+196>>2]=d;b=qc(e+184|0,9389);d=v[e+196>>2];v[e+24>>2]=v[e+192>>2];v[e+28>>2]=d;d=v[b+4>>2];v[e+16>>2]=v[b>>2];v[e+20>>2]=d;if(!Hc(e+24|0,e+16|0)){break h}d=a+24|0;b=v[d>>2];f=b+24664|0;g=v[f+4>>2];v[e+176>>2]=v[f>>2];v[e+180>>2]=g;f=b+24656|0;g=v[f+4>>2];v[e+168>>2]=v[f>>2];v[e+172>>2]=g;f=v[b+24652>>2];v[e+160>>2]=v[b+24648>>2];v[e+164>>2]=f;b=e;if(c){a=FH(v[a+56>>2])}else{a=0}v[b+180>>2]=a;if(!cx(e+160|0,v[d>>2]+24648|0)){break h}Tx(v[d>>2],e+160|0)}jb=e+416|0;return}b=P()|0;O()|0;yb(e+376|0);break d}b=P()|0;O()|0;yb(e+376|0)}ca(a|0);break c}ca(a|0)}S(b|0)}L()}function hL(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;h=jb-16|0;jb=h;a:{b:{if(!Xd(c)|(!d|v[b+480180>>2]!=16777216)|x[b+480192>>1]<d>>>0){break b}d=v[((d<<2)+b|0)+900380>>2];if(!d){break b}d=v[d+44>>2];if(!d){break b}u[h+14>>1]=c-61;b=jb-80|0;jb=b;e=u[d+28>>1];f=h+14|0;c=u[f>>1];g=d+4|0;Kb(g);c:{d:{if((c|0)>=(e|0)){if((c|0)<=(x[d+28>>1]+Kb(g)<<16)-65536>>16){break d}}bd(a);break c}e:{e=u[d+30>>1];if(!e){c=d+52|0;m=b,n=ux(c,f),v[m+56>>2]=n;m=b,n=Ii(c),v[m+40>>2]=n;if(!Hi(b+56|0,b+40|0)){break e}zf(a,lh(b+56|0)+4|0);break c}c=b;g=u[f>>1];f:{if((g|0)>=0){e=(g|0)%(e|0)|0;break f}e=e+((g^-1)%(e|0)^-1)|0}u[c+78>>1]=e;c=bd(a);v[113382]=0;a=d+52|0;e=Q(1568,a|0,b+78|0)|0;g=v[113382];v[113382]=0;g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{v:{w:{if((g|0)==1){break w}v[b+72>>2]=e;a=Ii(a);v[113382]=0;v[b+56>>2]=a;a=Q(1569,b+72|0,b+56|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break h}if(a){v[113382]=0;a=T(1570,b+72|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break w}v[113382]=0;Q(207,c|0,a+4|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break w}a=u[d+30>>1];d=u[f>>1];x:{if((d|0)>=0){a=(d|0)/(a|0)|0;break x}a=((d+1|0)/(a|0)|0)-1|0}v[113382]=0;v[b+40>>2]=a+5;R(204,b+56|0,b+40|0);a=v[113382];v[113382]=0;y:{if((a|0)!=1){v[113382]=0;Q(162,c|0,b+56|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break y}yb(b+56|0);break c}a=P()|0;O()|0;break g}a=P()|0;O()|0;yb(b+56|0);break g}if(u[d+30>>1]>26){break t}v[113382]=0;e=W(763,b+40|0,1,(w[b+78|0]<<24)+1090519040>>24)|0;a=v[113382];v[113382]=0;if((a|0)==1){break v}v[113382]=0;U(13,b+56|0,0,e|0);a=v[113382];v[113382]=0;if((a|0)==1){break u}a=b+56|0;Gb(c,a);yb(a);yb(e);v[113382]=0;Q(205,c|0,10335)|0;a=v[113382];v[113382]=0;if((a|0)!=1){break s}}a=P()|0;O()|0;break g}a=P()|0;O()|0;break g}a=P()|0;O()|0;yb(e);break g}v[113382]=0;v[b+36>>2]=u[b+78>>1]%16;R(1571,b+40|0,b+36|0);a=v[113382];v[113382]=0;if((a|0)==1){break r}v[113382]=0;v[b+20>>2]=(u[b+78>>1]/16<<16>>16)%16;R(1571,b+24|0,b+20|0);a=v[113382];v[113382]=0;if((a|0)==1){break q}v[113382]=0;U(3,b+56|0,b+40|0,b+24|0);a=v[113382];v[113382]=0;if((a|0)==1){break p}a=b+56|0;Gb(c,a);yb(a);yb(b+24|0);yb(b+40|0);if(u[b+78>>1]<256){break s}v[113382]=0;U(9,b+8|0,0,c|0);a=v[113382];v[113382]=0;if((a|0)==1){break n}v[113382]=0;R(1572,b+40|0,b+8|0);a=v[113382];v[113382]=0;if((a|0)==1){break m}v[113382]=0;U(13,b+56|0,0,b+40|0);a=v[113382];v[113382]=0;if((a|0)==1){break l}a=b+56|0;Gb(c,a);yb(a);yb(b+40|0);yb(b+8|0)}a=u[d+30>>1];d=u[f>>1];if((d|0)<0){break j}a=(d|0)/(a|0)|0;break i}a=P()|0;O()|0;break g}a=P()|0;O()|0;break o}a=P()|0;O()|0;yb(b+24|0)}yb(b+40|0);break g}a=P()|0;O()|0;break g}a=P()|0;O()|0;break k}a=P()|0;O()|0;yb(b+40|0)}yb(b+8|0);break g}a=((d+1|0)/(a|0)|0)-1|0}v[113382]=0;v[b+40>>2]=a+5;R(204,b+56|0,b+40|0);a=v[113382];v[113382]=0;z:{if((a|0)!=1){v[113382]=0;Q(162,c|0,b+56|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break z}yb(b+56|0);break c}a=P()|0;O()|0;break g}a=P()|0;O()|0;yb(b+56|0);break g}a=P()|0;O()|0}yb(c);S(a|0);L()}j=jb-16|0;jb=j;c=a;a=jb-16|0;jb=a;d=a;e=jb-144|0;jb=e;g=li(e+8|0);i=v[v[g>>2]-12>>2];v[113382]=0;k=da(123)|0;l=v[113382];v[113382]=0;A:{B:{if((l|0)==1){break B}v[113382]=0;U(124,e|0,i+(e+8|0)|0,k|0);i=v[113382];v[113382]=0;if((i|0)==1){break B}Ob(e);v[113382]=0;R(130,g|0,f|0);f=v[113382];v[113382]=0;if((f|0)==1){break B}v[113382]=0;R(126,d|0,g|0);d=v[113382];v[113382]=0;if((d|0)==1){break B}Td(g);jb=e+144|0;break A}a=P()|0;O()|0;Td(g);S(a|0);L()}v[113382]=0;U(13,c|0,0,a|0);c=v[113382];v[113382]=0;C:{if((c|0)!=1){yb(a);jb=a+16|0;break C}b=P()|0;O()|0;yb(a);S(b|0);L()}jb=j+16|0}jb=b+80|0;break a}f=v[b>>2];b=jb-32|0;jb=b;D:{if(iL(c)){v[b+16>>2]=v[6488];d=v[6485];v[b>>2]=v[6484];v[b+4>>2]=d;d=v[6487];v[b+8>>2]=v[6486];v[b+12>>2]=d;Ub(a,(b+(c<<2)|0)-1004|0);break D}if(Xd(c)){d=bd(b);v[113382]=0;e=c-1|0;c=(e<<16>>16)/12|0;f=Q(1401,d|0,f+(e-B(c,12)<<16>>16<<2)|0)|0;e=v[113382];v[113382]=0;E:{if((e|0)==1){break E}v[113382]=0;c=W(1402,f|0,1,c+48&65535)|0;f=v[113382];v[113382]=0;if((f|0)==1){break E}v[113382]=0;Q(4,a|0,c|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break E}yb(d);break D}a=P()|0;O()|0;yb(d);S(a|0);L()}if(!c){Ub(a,12863);break D}Ub(a,10306)}jb=b+32|0}jb=h+16|0}function Vha(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=jb-256|0;jb=f;Ic(b);a:{if(!vA(b,f+184|0)){break a}if(!GP(f+184|0)){break a}if(!Rb(b,dd(FP(f+184|0),mb))){break a}b:{if(!c){break b}Id(a,16);Dn(f,2,f+184|4);e=f+16|0;Ec(e,f);Gb(a+1304400|0,e);yb(e);u[a+480190>>1]=w[f+214|0];u[a+480188>>1]=w[f+217|0];d=Ub(e,4653);Gb(a+1304436|0,d);yb(d);e=Ub(e,6217);Gb(a+1304448|0,e);yb(e);d=Ub(f+168|0,11071);v[113382]=0;R(189,f|0,d|0);e=v[113382];v[113382]=0;c:{d:{e:{f:{g:{h:{i:{if((e|0)!=1){e=f+184|3;v[f+152>>2]=w[e|0]>>>4;e=w[e|0];v[113382]=0;v[f+164>>2]=e&15;X(497,f+16|0,f|0,f+152|0,f+164|0);e=v[113382];v[113382]=0;if((e|0)==1){break i}e=f+16|0;Gb(a+1304460|0,e);yb(e);Ib(f);yb(d);v[a+1304496>>2]=4;if(x[a+480190>>1]){e=1;h=1;while(1){j=f+16|0;IB(b,j);i=jb-16|0;jb=i;g=(B(e,104)+a|0)+484380|0;sd(g,0);d=j;u[i+14>>1]=w[d+35|0]<<2;u[i+12>>1]=256;p=g,q=x[Af(i+14|0,i+12|0)>>1],u[p+30>>1]=q;j:{if((w[d+22|0]|w[d+23|0]<<8|(w[d+24|0]<<16|w[d+25|0]<<24))>>>0<3){break j}v[g>>2]=w[d+22|0]|w[d+23|0]<<8|(w[d+24|0]<<16|w[d+25|0]<<24);v[g+4>>2]=w[d+26|0]|w[d+27|0]<<8|(w[d+28|0]<<16|w[d+29|0]<<24);v[i+8>>2]=w[d+30|0]|w[d+31|0]<<8|(w[d+32|0]<<16|w[d+33|0]<<24);v[i+4>>2]=1;p=g,q=v[Vc(i+8|0,i+4|0)>>2]-1|0,v[p+8>>2]=q;tc(g+8|0,v[g>>2]);k:{if(y[g+8>>2]<=v[g+4>>2]+4>>>0){v[g+4>>2]=0;v[g+8>>2]=0;break k}u[g+34>>1]=x[g+34>>1]|2}t[g+37|0]=w[d+34|0];p=g,q=_s(0,t[d+34|0]<<4),v[p+24>>2]=q;if(!(t[d+36|0]&1)){break j}u[g+34>>1]=x[g+34>>1]|1;v[g>>2]=v[g>>2]>>>1;v[g+4>>2]=v[g+4>>2]>>>1;v[g+8>>2]=v[g+8>>2]>>>1}jb=i+16|0;d=f+152|0;Vl(d,2,j);Ec(f,d);v[113382]=0;Q(335,((e<<5)+a|0)+946304|0,f|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break e}yb(f);h=h+1|0;e=h&65535;if(e>>>0<=x[a+480190>>1]){continue}break}}if(x[a+480188>>1]){e=0;while(1){d=(e<<5)+a|0;Dg(d+480280|0);u[d+480284>>1]=(w[(e+f|0)+218|0]<<4|8)&248;e=e+1|0;if(e>>>0<x[a+480188>>1]){continue}break}}g=f+16|0;d=g;j=jb-16|0;jb=j;e=b;l:{if(Rb(e,128)){h=j+8|0;mR(h,d);zd(e,h);break l}e=jb-16|0;jb=e;h=jb-16|0;jb=h;i=d+128|0;while(1){jf(d);d=d+1|0;if((i|0)!=(d|0)){continue}break}jb=h+16|0;jb=e+16|0}jb=j+16|0;PB(Vb(a+484360|0),g,w[f+211|0]+1|0);if(w[f+216|0]){break g}i=64;break f}e=P()|0;O()|0;break h}e=P()|0;O()|0;Ib(f)}yb(d);break c}i=w[f+216|0]}td(f,b,B(w[f+208|0]|w[f+209|0]<<8,192));m:{n:{if(!(c&1)){break n}e=w[f+210|0];v[113382]=0;m=a+484344|0;R(363,m|0,e+1|0);e=v[113382];v[113382]=0;if((e|0)==1){break d}while(1){v[113382]=0;d=W(364,m|0,k&65535,i|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break m}e=0;if(!d){break n}while(1){v[113382]=0;d=T(323,b|0)|0;j=v[113382];v[113382]=0;if((j|0)==1){break d}n=e;o:{if(!d|d>>>0>(w[f+208|0]|w[f+209|0]<<8)>>>0){break o}e=n&65535;if(e>>>0>=x[a+480188>>1]){break o}v[113382]=0;Q(226,f|0,B(d,192)-192|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break d}d=Zb(m,k);v[113382]=0;e=W(432,d|0,0,e|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break d}o=0;if(!i){break o}while(1){v[113382]=0;R(770,f+152|0,f|0);d=v[113382];v[113382]=0;if((d|0)==1){break d}d=f+152|0;g=d;h=Zc(d);l=Cf(d);j=e;d=w[d|0];if(d>>>0>=4){t[e|0]=(d>>>2|0)+37;d=w[g|0]}t[j+1|0]=d<<4&48|w[h|0]>>>4;d=w[l|0];j=0;g=0;p:{q:{r:{s:{t:{u:{h=w[h|0]&15;switch(h-8|0){case 0:break r;case 6:break t;case 2:break u;default:break s}}d=(d&240?-16:15)&d;h=10;break q}h=14;l=(d+16&240)>>>4|0;if(l>>>0>8){break q}if(1<<l&435){break r}break q}j=h;g=d}d=g;h=j;if(!((d|h)&255)){break p}}t[e+5|0]=d;t[e+3|0]=h;v[113382]=0;Z(537,e|0);d=v[113382];v[113382]=0;if((d|0)!=1){break p}break d}e=B(x[a+480188>>1],6)+e|0;o=o+1|0;if((o|0)!=(i|0)){continue}break}}e=n+1|0;if((n&65535)>>>0<31){continue}break}e=w[f+210|0]>k>>>0;k=k+1|0;if(e){continue}break}}if(w[f+212|0]|w[f+213|0]<<8){e=w[f+212|0]|w[f+213|0]<<8;v[113382]=0;ea(510,a+1304424|0,b|0,e|0,39,1)|0;e=v[113382];v[113382]=0;if((e|0)==1){break d}}if(!(!(c&2)|!x[a+480190>>1])){d=1;while(1){c=B(d&65535,104)+a|0;e=Yc(f+152|0,u[c+484414>>1]&1?16:8,1,0,1);v[113382]=0;W(362,e|0,c+484380|0,b|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break d}d=d+1|0;if(x[a+480190>>1]>=(d&65535)>>>0){continue}break}}v[a+480260>>2]=64;v[a+480264>>2]=32767;Bb(f);break b}break d}e=P()|0;O()|0;yb(f);break c}e=P()|0;O()|0;Bb(f)}S(e|0);L()}e=1}jb=f+256|0;return e|0}function wla(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=jb-336|0;jb=d;Ic(b);a:{if(!Ot(b,d+320|0)){break a}if(!AS(d+320|0)){break a}if(v[d+320>>2]==1179472708){_b(b,4)}if(!Hf(b,d+312|0)|v[d+312>>2]!=1196314451){break a}if(!c){e=1;break a}i=d+312|4;f=i;_A(b,d+120|0,w[f|0]|w[f+1|0]<<8|(w[f+2|0]<<16|w[f+3|0]<<24));if((w[d+156|0]|w[d+157|0]<<8)>>>0>128|(w[d+162|0]|w[d+163|0]<<8)>>>0>16|((w[d+160|0]|w[d+161|0]<<8)>>>0>256|(w[d+154|0]|w[d+155|0]<<8)>>>0>128)){break a}Id(a,8192);e=d+40|0;f=Ub(e,2868);Gb(a+1304436|0,f);yb(f);f=Ub(e,6229);Gb(a+1304448|0,f);yb(f);v[a+1304496>>2]=4;f=d+104|0;Nt(f,2,d+120|0);Ec(e,f);Gb(a+1304400|0,e);yb(e);u[d+40>>1]=w[d+162|0]|w[d+163|0]<<8;u[d+104>>1]=1;p=a,q=x[Ri(e,f)>>1],u[p+480188>>1]=q;v[a+480196>>2]=w[d+166|0];v[a+480204>>2]=B(w[d+167|0],1e4);t[d+40|0]=w[d+164|0];t[d+104|0]=64;e=w[pc(e,f)|0];v[a+480200>>2]=e<<2;if(!e){v[a+480200>>2]=256}e=a;b:{if(w[d+165|0]==128){v[d+40>>2]=256/x[a+480188>>1];v[d+104>>2]=128;f=v[Lb(d+40|0,d+104|0)>>2];break b}f=w[d+165|0]&127}v[e+480228>>2]=f;e=0;while(1){f=(e<<5)+a|0;Dg(f+480280|0);g=d+e|0;if(w[g+168|0]<=128){u[f+480284>>1]=w[g+168|0]<<1}e=e+1|0;if((e|0)!=16){continue}break}e=a+484360|0;En(Vb(e),d+184|0,w[d+156|0]|w[d+157|0]<<8,255,254);if((w[d+154|0]|w[d+155|0]<<8)>>>0<(w[d+156|0]|w[d+157|0]<<8)>>>0){Ne(Vb(e),w[d+154|0]|w[d+155|0]<<8)}e=1;if(!Hf(b,d+312|0)){break a}m=c&2;j=a+484344|0;n=c&1;o=d+76|0;while(1){c=i;td(d+104|0,b,w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24));c:{d:{e:{if(!(!n|v[d+312>>2]!=1414807888)){v[113382]=0;l=k&65535;c=W(364,j|0,l|0,64)|0;e=v[113382];v[113382]=0;if((e|0)==1){break e}if(!c){break c}v[113382]=0;Q(304,d+104|0,2)|0;c=v[113382];v[113382]=0;if((c|0)==1){break e}oh(d+40|0);f=0;f:{while(1){v[113382]=0;c=Q(228,d+104|0,1)|0;e=v[113382];v[113382]=0;g:{h:{if((e|0)!=1){if(!(c&f>>>0<64)){break f}v[113382]=0;e=T(409,d+104|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break h}if(e){break g}f=f+1|0;continue}b=P()|0;O()|0;break d}b=P()|0;O()|0;break d}c=d+40|0;i:{j:{k:{g=e&15;l:{if(g>>>0<x[a+480188>>1]){c=Zb(j,l);v[113382]=0;c=W(432,c|0,f|0,g|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break l}}m:{if(!(e&128)){break m}v[113382]=0;g=T(409,d+104|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break k}if(!g){break m}t[c|0]=g>>>0<109?g+12|0:g}if(!(e&64)){break i}v[113382]=0;g=T(409,d+104|0)|0;h=v[113382];v[113382]=0;if((h|0)!=1){break j}}b=P()|0;O()|0;break d}b=P()|0;O()|0;break d}t[c+1|0]=g}n:{o:{p:{q:{r:{s:{t:{u:{if(e&32){t[c+2|0]=1;v[113382]=0;g=T(409,d+104|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break u}v[113382]=0;t[d+24|0]=g;t[d+8|0]=64;g=Q(415,d+24|0,d+8|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break t}t[c+4|0]=w[g|0]}if(!(e&16)){continue}v[113382]=0;R(433,d+24|0,d+104|0);e=v[113382];v[113382]=0;if((e|0)==1){break s}e=d+24|0;g=e;h=Zc(e);e=w[e|0];switch(e-17|0){case 2:break q;case 0:case 1:break r;default:break p}}b=P()|0;O()|0;break d}b=P()|0;O()|0;break d}b=P()|0;O()|0;break d}e=e&15;break o}t[g|0]=33;t[h|0]=145;e=w[g|0];break n}if(e>>>0<17){break n}e=(e&240)==32?9:-1}t[g|0]=e}t[c+3|0]=e;t[c+5|0]=w[h|0];v[113382]=0;Z(537,c|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}b=P()|0;O()|0;break d}k=k+1|0;break c}if(v[d+312>>2]!=1414745673){break c}if(!An(a)){break c}c=x[a+480190>>1]+1|0;u[a+480190>>1]=c;v[113382]=0;Q(538,d+104|0,d+40|0)|0;e=v[113382];v[113382]=0;v:{w:{x:{if((e|0)==1){break x}v[113382]=0;c=(B(c&65535,104)+a|0)+484380|0;R(539,d+40|0,c|0);e=v[113382];v[113382]=0;if((e|0)==1){break x}v[113382]=0;U(540,d+8|0,2,o|0);e=v[113382];v[113382]=0;if((e|0)==1){break w}v[113382]=0;R(356,d+24|0,d+8|0);e=v[113382];v[113382]=0;if((e|0)==1){break w}e=x[a+480190>>1];v[113382]=0;Q(335,((e<<5)+a|0)+946304|0,d+24|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break v}yb(d+24|0);if(!m){break c}v[113382]=0;R(541,d+24|0,d+40|0);e=v[113382];v[113382]=0;if((e|0)!=1){v[113382]=0;W(362,d+24|0,c|0,d+104|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){break c}}b=P()|0;O()|0;break d}b=P()|0;O()|0;break d}b=P()|0;O()|0;break d}b=P()|0;O()|0;yb(d+24|0);break d}b=P()|0;O()|0}Bb(d+104|0);S(b|0);L()}Bb(d+104|0);e=1;if(Hf(b,d+312|0)){continue}break}}jb=d+336|0;return e|0}
function k9(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;e=jb-144|0;jb=e;d=-1;a:{b:{c:{if(!Mt(v[v[b>>2]-12>>2]+b|0)){b=cl(e+40|0,b);v[113382]=0;d=Q(645,e+24|0,9907)|0;f=v[113382];v[113382]=0;d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{v:{w:{x:{y:{z:{A:{B:{C:{D:{E:{F:{if((f|0)!=1){v[113382]=0;v[e+16>>2]=83886084;v[e+20>>2]=0;U(646,b|0,d|0,e+16|0);f=v[113382];v[113382]=0;if((f|0)==1){break F}Ib(d);v[113382]=0;t[e+15|0]=0;d=Q(645,e+24|0,10434)|0;f=v[113382];v[113382]=0;if((f|0)==1){break E}v[113382]=0;W(647,b|0,e+15|0,d|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break D}Ib(d);v[113382]=0;f=w[e+15|0];d=Q(645,e+24|0,11955)|0;g=v[113382];v[113382]=0;if((g|0)==1){break C}v[113382]=0;f=f?0:c;X(1574,b|0,a+40|0,d|0,f|0);c=v[113382];v[113382]=0;if((c|0)==1){break B}Ib(d);v[113382]=0;u[e+12>>1]=65535;c=Q(645,e+24|0,11717)|0;d=v[113382];v[113382]=0;if((d|0)==1){break A}v[113382]=0;W(1147,b|0,e+12|0,c|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break z}Ib(c);v[113382]=0;u[e+10>>1]=0;c=Q(645,e+24|0,11349)|0;d=v[113382];v[113382]=0;if((d|0)==1){break y}v[113382]=0;W(1147,b|0,e+10|0,c|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break x}Ib(c);u[a>>1]=x[e+10>>1];v[113382]=0;c=Q(645,e+24|0,10850)|0;d=v[113382];v[113382]=0;if((d|0)==1){break w}v[113382]=0;X(1575,b|0,a+52|0,c|0,f|0);d=v[113382];v[113382]=0;if((d|0)==1){break v}Ib(c);v[113382]=0;c=Q(645,e+24|0,10674)|0;d=v[113382];v[113382]=0;if((d|0)==1){break u}v[113382]=0;W(1539,b|0,a+36|0,c|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break t}Ib(c);v[113382]=0;c=Q(645,e+24|0,11719)|0;d=v[113382];v[113382]=0;if((d|0)==1){break s}v[113382]=0;f=a+4|0;aa(1576,b|0,f|0,c|0,1577)|0;d=v[113382];v[113382]=0;if((d|0)==1){break r}Ib(c);v[113382]=0;c=Q(645,e+24|0,11351)|0;d=v[113382];v[113382]=0;if((d|0)==1){break q}v[113382]=0;g=a+28|0;W(1578,b|0,g|0,c|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break p}Ib(c);v[113382]=0;c=Q(645,e+24|0,10951)|0;d=v[113382];v[113382]=0;if((d|0)==1){break o}v[113382]=0;W(1578,b|0,a+30|0,c|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break n}Ib(c);v[113382]=0;c=Q(645,e+24|0,10698)|0;d=v[113382];v[113382]=0;if((d|0)==1){break m}v[113382]=0;W(1579,b|0,a+32|0,c|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break l}Ib(c);v[113382]=0;u[e+8>>1]=0;c=Q(645,e+24|0,10641)|0;d=v[113382];v[113382]=0;if((d|0)==1){break c}v[113382]=0;W(1147,b|0,e+8|0,c|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break k}Ib(c);d=-1;if(v[b>>2]&1073741824|(x[g>>1]+300&65535)>>>0>=601){break d}c=x[a>>1];if(c>>>0>3|(c|0)==2|u[a+30>>1]<0){break d}c=v[a+36>>2];v[113382]=0;c=T(823,c|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break j}v[113382]=0;v[e+24>>2]=c;v[e+16>>2]=0;c=W(1204,e+24|0,e+16|0,36120)|0;h=v[113382];v[113382]=0;if((h|0)==1){break i}v[a+36>>2]=v[c>>2];if(Kb(f)>>>0>32767){break d}switch(x[a>>1]-1|0){case 0:break g;case 2:break h;default:break f}}a=P()|0;O()|0;break a}a=P()|0;O()|0;Ib(d);break a}a=P()|0;O()|0;break a}a=P()|0;O()|0;Ib(d);break a}a=P()|0;O()|0;break a}a=P()|0;O()|0;Ib(d);break a}a=P()|0;O()|0;break a}a=P()|0;O()|0;Ib(c);break a}a=P()|0;O()|0;break a}a=P()|0;O()|0;Ib(c);break a}a=P()|0;O()|0;break a}a=P()|0;O()|0;Ib(c);break a}a=P()|0;O()|0;break a}a=P()|0;O()|0;Ib(c);break a}a=P()|0;O()|0;break a}a=P()|0;O()|0;Ib(c);break a}a=P()|0;O()|0;break a}a=P()|0;O()|0;Ib(c);break a}a=P()|0;O()|0;break a}a=P()|0;O()|0;Ib(c);break a}a=P()|0;O()|0;break a}a=P()|0;O()|0;Ib(c);break a}a=P()|0;O()|0;Ib(c);break a}a=P()|0;O()|0;break a}a=P()|0;O()|0;break a}if(u[e+8>>1]<=0){break d}u[e+6>>1]=x[a+30>>1];z[e+24>>2]=z[a+32>>2];c=x[a+28>>1];v[113382]=0;u[e+16>>1]=c;u[e+18>>1]=(c+x[e+8>>1]|0)-1;a=aa(1580,a|0,e+6|0,e+24|0,e+16|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){if(a){break e}break d}a=P()|0;O()|0;break a}if(u[e+8>>1]<=0){break d}z[e+24>>2]=z[a+32>>2];c=x[a+28>>1];v[113382]=0;u[e+16>>1]=c;u[e+18>>1]=(c+x[e+8>>1]|0)-1;a=ea(1581,a|0,f|0,e+24|0,e+16|0,g|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){if(a){break e}break d}a=P()|0;O()|0;break a}v[113382]=0;Z(1582,a|0);a=v[113382];v[113382]=0;if((a|0)==1){break b}}d=1}Bg(b)}jb=e+144|0;return d|0}a=P()|0;O()|0;break a}a=P()|0;O()|0}Bg(b);S(a|0);L()}function Yka(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;l=jb-704|0;jb=l;a:{b:{if(d>>>0<=511){d=0;a=jb-16|0;jb=a;k=jb-16|0;jb=k;e=a+8|0;g=l+24|0;fc(e,g,554);jb=k+16|0;k=Hb(e);e=mc(b,$b(a,e));if((k|0)==(e|0)){_b(b,Hb(a+8|0))}jb=a+16|0;a=(e|0)==(k|0);if(!a){b=jb-16|0;jb=b;Qb(g,0,554);jb=b+16|0}if(!a){break b}b=jb-32|0;jb=b;c:{d:{a=l+24|0;e:{if((w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24))!=1229999433){break e}Ju(b,3,a+32|0);d=b+16|0;Ec(d,b);v[113382]=0;Q(335,c+492|0,d|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break d}d=b+16|0;yb(d);uh(b,1,a+4|0);Ec(d,b);v[113382]=0;Q(335,c+524|0,d|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break d}yb(b+16|0);d=w[a+24|0]|w[a+25|0]<<8;v[c+4>>2]=64;v[c+8>>2]=128;v[c>>2]=d<<6;t[c+16|0]=w[a+26|0];t[c+17|0]=w[a+27|0];e=c+108|0;k=c+236|0;while(1){g=a+(h<<1)|0;d=w[g- -64|0];g=w[g+65|0];o=_c(k,h),p=g,u[o>>1]=p;o=ec(e,h),p=(d>>>0<120?d:h)+1|0,t[o|0]=p;h=h+1|0;if((h|0)!=120){continue}break}t[c+60|0]=w[c+60|0]&254|t[a+17|0]&1;t[c+60|0]=w[c+60|0]&253|w[a+17|0]&2;t[c+60|0]=w[c+60|0]&251|w[a+17|0]&4;k=c+61|0;t[k|0]=w[a+18|0];g=c+62|0;t[g|0]=w[a+19|0];j=c+63|0;t[j|0]=w[a+20|0];i=c- -64|0;t[i|0]=w[a+21|0];d=c+48|0;Fg(d,25);h=0;while(1){f:{f=h<<1;e=w[(f+a|0)+504|0];o=Pb(d,h),p=e,u[o>>1]=p;if((e|0)==255){Fg(d,h);break f}e=w[(a+(f|1)|0)+504|0];o=Pb(d,h),p=e,t[o+2|0]=p;h=h+1|0;if((h|0)!=25){continue}}break}a=w[th(k,g)|0];if(Kb(d)>>>0<=a>>>0){t[c+60|0]=w[c+60|0]&253}a=w[th(j,i)|0];if(Kb(d)>>>0>a>>>0){break e}t[c+60|0]=w[c+60|0]&251}jb=b+32|0;break c}a=P()|0;O()|0;yb(b+16|0);S(a|0);L()}d=554;break b}k=v[b+8>>2];h=l+24|0;i=h;g=jb-16|0;jb=g;v[g+12>>2]=674;v[g>>2]=674;d=b;j=v[Lb(g+12|0,g)>>2];if(!Rb(d,j)){j=$e(d)}yR(g,i);kg(d,v[g>>2],j);yR(g,i);Qb(v[g>>2]+j|0,0,674-j|0);_b(d,v[g+12>>2]);jb=g+16|0;g=b;j=c;d=c;n=v[a+480180>>2];i=jb-32|0;jb=i;g:{h:{a=h;if((w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24))==1229999433){Ju(i,3,a+32|0);f=i+16|0;Ec(f,i);v[113382]=0;Q(335,d+492|0,f|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break h}f=i+16|0;yb(f);uh(i,1,a+4|0);Ec(f,i);v[113382]=0;Q(335,d+524|0,f|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break h}f=i+16|0;yb(f);v[d>>2]=(w[a+20|0]|w[a+21|0]<<8)<<5;v[d+4>>2]=w[a+24|0]>>>1;tc(d+4|0,64);m=w[a+25|0]&127;v[d+8>>2]=m>>>0>64?128:m<<2;t[d+15|0]=w[d+15|0]&254|((w[a+25|0]^-1)&128)>>>7;t[i+16|0]=w[a+26|0];t[i|0]=100;o=d,p=w[pc(f,i)|0],t[o+20|0]=p;t[i+16|0]=w[a+27|0];t[i|0]=64;o=d,p=w[pc(f,i)|0],t[o+19|0]=p;t[d+16|0]=w[a+17|0];t[d+17|0]=w[a+18|0];t[d+18|0]=w[a+19|0];t[d+26|0]=w[a+22|0];t[d+27|0]=w[a+23|0];Hu(d,w[a+58|0]&127,w[a+58|0]>>>7|0);Gu(d,w[a+59|0]&127,w[a+59|0]>>>7|0);i:{j:{k:{f=w[a+28|0]|w[a+29|0]<<8;if(!((f|0)==514|(f|0)==529|(w[a+28|0]|w[a+29|0]<<8)==544)){if((w[a+28|0]|w[a+29|0]<<8)!=532){break k}}if(w[a+61|0]==255){break k}if(w[a+61|0]<=128){t[d+30|0]=w[a+61|0]}e=w[a+62|0]|w[a+63|0]<<8;if(e>>>0<129){break j}break i}if(t[a+61|0]>=0){t[d+30|0]=w[a+61|0]+1}e=t[a+62|0]>=0?w[a+62|0]+1|0:e;if(t[a+63|0]<0){break j}e=(w[a+63|0]<<7)+e|0}u[d+28>>1]=e}e=t[a+60|0];t[d+31|0]=e;if((e|0)<0){t[d+31|0]=0;t[d+34|0]=e^128}e=0;f=n&16777216?240:25;Lu(a+304|0,d+48|0,0,f);Lu(a+386|0,d+68|0,32,f);Lu(a+468|0,d+88|0,32,f);t[d+100|0]=w[d+100|0]&239|w[a+468|0]>>>3&16;f=d+108|0;n=d+236|0;while(1){m=a+(e<<1)|0;d=w[m- -64|0];m=w[m+65|0];o=_c(n,e),p=m,u[o>>1]=p;o=ec(f,e),p=(d>>>0<120?d:e)+1|0,t[o|0]=p;e=e+1|0;if((e|0)!=120){continue}break}e=554}jb=i+32|0;a=e;break g}a=P()|0;O()|0;yb(i+16|0);S(a|0);L()}if(a){d=w[h+550|0]|w[h+551|0]<<8|(w[h+552|0]<<16|w[h+553|0]<<24);if(!((d|0)!=1481920589&(d|0)!=1297110104)){d=j+236|0;a=0;while(1){e=w[(a+h|0)+554|0];j=_c(d,a);u[j>>1]=x[j>>1]|e<<8;a=a+1|0;if((a|0)!=120){continue}break}a=674}}else{a=0}d=a;Nc(g,k+d|0);if(!sh(b,9937)){break b}a=l+8|0;td(a,b,Df(b));v[113382]=0;b=T(225,a|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break a}v[113382]=0;a=Q(580,l+8|0,9741)|0;e=v[113382];v[113382]=0;if((e|0)==1){break a}if(a){v[113382]=0;a=T(409,l+8|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break a}t[c+34|0]=a>>>0>250?0:a}d=(b+d|0)+8|0;Bb(l+8|0)}jb=l+704|0;return d|0}a=P()|0;O()|0;Bb(l+8|0);S(a|0);L()}function IH(a,b,c,d,e,f){var g=0,h=0,i=0,j=0;g=jb-48|0;jb=g;a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{if(Qr(c)){h=b+24|0;if(jg(v[h>>2]+484344|0,c&65535)){break j}}c=a;a=Xb(g+32|0);b=Xb(g+16|0);ki(c,a,b);yb(b);yb(a);break i}b=Zb(v[h>>2]+484344|0,c);if(!(v[b+12>>2]>(d|0)&(d|0)>=0)){c=a;a=Xb(g+32|0);b=Xb(g+16|0);ki(c,a,b);yb(b);yb(a);break i}if(!(x[v[h>>2]+480188>>1]>e>>>0&(e|0)>=0)){c=a;a=Xb(g+32|0);b=Xb(g+16|0);ki(c,a,b);yb(b);yb(a);break i}if(f>>>0>=6){c=a;a=Xb(g+32|0);b=Xb(g+16|0);ki(c,a,b);yb(b);yb(a);break i}b=Bf(b,d,e&65535);k:{switch(f-1|0){default:l:{m:{n:{if(!Wf(b)){if(!os(b)){break n}}c=g+16|0;hL(c,v[h>>2],w[b|0],w[b+1|0]);v[113382]=0;U(9,g+32|0,0,c|0);c=v[113382];v[113382]=0;d=1;if((c|0)!=1){break m}c=P()|0;O()|0;break b}d=0;v[113382]=0;Q(121,g+32|0,12863)|0;c=v[113382];v[113382]=0;if((c|0)==1){break l}}v[113382]=0;c=T(516,b|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break c}o:{if(c){v[113382]=0;Q(121,g|0,6061)|0;b=v[113382];v[113382]=0;if((b|0)==1){break c}break o}if(os(b)){v[113382]=0;Q(121,g|0,6366)|0;b=v[113382];v[113382]=0;if((b|0)!=1){break o}break c}v[113382]=0;Q(121,g|0,12863)|0;b=v[113382];v[113382]=0;if((b|0)==1){break c}}b=a;a=g+32|0;ki(b,a,g);yb(g);yb(a);if(!d){break i}yb(g+16|0);break i}c=P()|0;O()|0;break a;case 0:c=b+1|0;p:{if(w[b+1|0]){pt(g+32|0,c);break p}Ub(g+32|0,12868)}q:{if(w[c|0]){v[113382]=0;Q(121,g+16|0,6848)|0;b=v[113382];v[113382]=0;if((b|0)!=1){break q}break d}v[113382]=0;Q(121,g+16|0,12868)|0;b=v[113382];v[113382]=0;if((b|0)==1){break d}}c=a;a=g+32|0;b=g+16|0;ki(c,a,b);yb(b);yb(a);break i;case 1:r:{if(bn(b)){Ub(g+32|0,13825);break r}if(w[b+2|0]){Fj(g+32|0,1,nK(v[v[h>>2]+8>>2],w[b+2|0]));break r}Ub(g+32|0,13825)}v[113382]=0;c=T(1304,b|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break e}s:{if(c){v[113382]=0;Q(121,g+16|0,13825)|0;b=v[113382];v[113382]=0;if((b|0)==1){break e}break s}if(w[b+2|0]){v[113382]=0;Q(121,g+16|0,1991)|0;b=v[113382];v[113382]=0;if((b|0)!=1){break s}break e}v[113382]=0;Q(121,g+16|0,13825)|0;b=v[113382];v[113382]=0;if((b|0)==1){break e}}c=a;a=g+32|0;b=g+16|0;ki(c,a,b);yb(b);yb(a);break i;case 3:t:{if(bn(b)){i=g,j=sy(b)&255,v[i>>2]=j;Cz(g+32|0,g);break t}if(w[b+2|0]){pt(g+32|0,b+4|0);break t}Ub(g+32|0,12868)}v[113382]=0;c=T(1304,b|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break f}u:{if(c){v[113382]=0;Q(121,g+16|0,1975)|0;b=v[113382];v[113382]=0;if((b|0)==1){break f}break u}if(w[b+2|0]){v[113382]=0;Q(121,g+16|0,1975)|0;b=v[113382];v[113382]=0;if((b|0)!=1){break u}break f}v[113382]=0;Q(121,g+16|0,12868)|0;b=v[113382];v[113382]=0;if((b|0)==1){break f}}c=a;a=g+32|0;b=g+16|0;ki(c,a,b);yb(b);yb(a);break i;case 2:v:{if(bn(b)){i=g,j=(Gs(b)&3840)!=0,t[i|0]=j;c=jb-32|0;jb=c;t[c+16|0]=44;v[c+8>>2]=-1;v[c+12>>2]=0;v[c>>2]=1058;v[c+4>>2]=1;d=jb-16|0;jb=d;v[d+12>>2]=w[g|0];ax(g+32|0,d+12|0,c);jb=d+16|0;jb=c+32|0;break v}if(w[b+3|0]){Fj(g+32|0,1,mK(v[v[h>>2]+8>>2],w[b+3|0]));break v}Ub(g+32|0,12869)}v[113382]=0;c=T(1304,b|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break g}w:{if(c){v[113382]=0;Q(121,g+16|0,8285)|0;b=v[113382];v[113382]=0;if((b|0)==1){break g}break w}if(w[b+3|0]){v[113382]=0;Q(121,g+16|0,8285)|0;b=v[113382];v[113382]=0;if((b|0)!=1){break w}break g}v[113382]=0;Q(121,g+16|0,12869)|0;b=v[113382];v[113382]=0;if((b|0)==1){break g}}c=a;a=g+32|0;b=g+16|0;ki(c,a,b);yb(b);yb(a);break i;case 4:break k}}x:{if(bn(b)){i=g,j=Gs(b)&255,v[i>>2]=j;Cz(g+32|0,g);break x}if(w[b+3|0]){pt(g+32|0,b+5|0);break x}Ub(g+32|0,12868)}v[113382]=0;c=T(1304,b|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break h}y:{if(c){v[113382]=0;Q(121,g+16|0,7114)|0;b=v[113382];v[113382]=0;if((b|0)==1){break h}break y}if(w[b+3|0]){v[113382]=0;Q(121,g+16|0,7114)|0;b=v[113382];v[113382]=0;if((b|0)!=1){break y}break h}v[113382]=0;Q(121,g+16|0,12868)|0;b=v[113382];v[113382]=0;if((b|0)==1){break h}}c=a;a=g+32|0;b=g+16|0;ki(c,a,b);yb(b);yb(a)}jb=g+48|0;return}c=P()|0;O()|0;yb(g+32|0);break a}c=P()|0;O()|0;yb(g+32|0);break a}c=P()|0;O()|0;yb(g+32|0);break a}c=P()|0;O()|0;yb(g+32|0);break a}c=P()|0;O()|0;yb(g+32|0);break a}c=P()|0;O()|0;yb(g+32|0);if(!d){break a}}yb(g+16|0)}S(c|0);L()}function Uca(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=jb-11360|0;jb=g;Ic(c);a:{b:{if(!Rb(c,4)){break b}c:{while(1){d:{j=g+16|0;d=j;i=jb-16|0;jb=i;f=c;e:{if(Rb(c,3)){h=i+8|0;vu(h,d);zd(f,h);break e}f=jb-16|0;jb=f;h=jb-16|0;jb=h;k=d+3|0;while(1){jf(d);d=d+1|0;if((k|0)!=(d|0)){continue}break}jb=h+16|0;jb=f+16|0}jb=i+16|0;f:{if(!md(j,10703,3)){d=g+4648|0;i=jb-16|0;jb=i;f=c;g:{if(Rb(c,7)){j=i+8|0;eu(j,d);zd(f,j);break g}f=jb-16|0;jb=f;j=jb-16|0;jb=j;h=d+7|0;while(1){jf(d);d=d+1|0;if((h|0)!=(d|0)){continue}break}jb=j+16|0;jb=f+16|0}jb=i+16|0;h=3;d=0;while(1){f=w[(g+4648|0)+h|0];if(f&128){break c}d=f|d<<7;h=h+1|0;if((h|0)!=7){continue}break}_b(c,d);break f}h:{if(md(g+16|0,10083,3)){break h}if(!fQ(c,9552)){break h}_b(c,Df(c)+16|0);break f}if(!md(g+16|0,25884,3)){break f}if(!md(g+16|0,25888,3)){break f}if(w[g+16|0]){break d}mg(c,2)}if(Rb(c,4)){continue}break b}break}if(iO(g+16|0)){break b}}h=0;break a}Ic(c);d=g+11336|0;$z(d,c);h=v[d>>2];v[113382]=0;c=T(426,d|0)|0;d=v[113382];v[113382]=0;i:{j:{if((d|0)!=1){v[113382]=0;c=T(818,c|0)|0;d=v[113382];v[113382]=0;if((d|0)!=1){break j}}h=P()|0;O()|0;break i}d=jb-16|0;jb=d;k=g+11320|0;v[k>>2]=0;v[k+4>>2]=0;v[113382]=0;v[d+12>>2]=0;W(322,k+8|0,d+12|0,d+8|0)|0;f=v[113382];v[113382]=0;k:{if((f|0)!=1){jb=d+16|0;break k}V(0)|0;O()|0;Ab();L()}d=g+4648|0;Qb(d,0,6668);v[113382]=0;Z(1202,d|0);d=v[113382];v[113382]=0;l:{m:{n:{if((d|0)!=1){d=g+4640|0;v[d>>2]=0;v[d+4>>2]=0;d=g+4632|0;v[d>>2]=0;v[d+4>>2]=0;v[g+4624>>2]=0;v[g+4628>>2]=0;f=0;d=0;o:{p:{q:{while(1){v[113382]=0;i=qg(416,h,l);j=v[113382];v[113382]=0;if((j|0)==1){break o}v[113382]=0;m=ea(1203,g+4648|0,c|0,i|0,g+16|0,g+4624|0)|0;i=v[113382];v[113382]=0;if((i|0)==1){break o}if((m|0)<0){break m}i=v[g+4624>>2];if((i|0)<0|(i?0:m)|!(i|m)){break m}r:{if(i){j=v[g+4636>>2];if((j|0)!=(f|0)?f:0){break m}i=v[g+4632>>2];if((i|0)!=(d|0)?d:0){break m}if((j|0)<=0|i-1>>>0>1){break n}v[113382]=0;v[g+8>>2]=0;d=qg(416,h,l);f=v[113382];v[113382]=0;if((f|0)==1){break r}v[113382]=0;v[g+4>>2]=d;d=W(1204,g+4624|0,g+8|0,g+4|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break r}d=v[d>>2];v[113382]=0;v[g+8>>2]=0;f=qg(416,h,l);n=v[113382];v[113382]=0;if((n|0)==1){break q}v[113382]=0;v[g+4>>2]=f;f=W(1204,g+4624|0,g+8|0,g+4|0)|0;n=v[113382];v[113382]=0;if((n|0)==1){break q}c=c+d|0;d=h;f=v[f>>2];h=d-f|0;l=l-((f>>31)+(d>>>0<f>>>0)|0)|0;if(m){o=g,p=bc(k),v[o+8>>2]=p;Hd(g,g+8|0);v[113382]=0;d=g+16|0;aa(1205,k|0,v[g>>2],d|0,d+(B(i,m)<<1)|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break p}}f=j;d=i}if((oc(k)>>>0)/(d>>>0)>>>0>268435456){break m}if(!!h&(l|0)>=0|(l|0)>0){continue}break m}break}h=P()|0;O()|0;break l}h=P()|0;O()|0;break l}h=V(66740)|0;if((O()|0)!=(ga(66740)|0)){break l}_(h|0)|0;v[113382]=0;Y(20);c=v[113382];v[113382]=0;f=j;d=i;if((c|0)!=1){break m}h=P()|0;O()|0;break l}h=P()|0;O()|0;break l}h=P()|0;O()|0;break l}f=j;d=i}h=0;s:{t:{u:{v:{w:{if(!f|!d){break w}if(id(k)){break w}if((oc(k)>>>0)/(d>>>0)>>>0>268435456){break w}v[113382]=0;Q(1206,a|0,b|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break s}if(!e){v[113382]=0;c=Q(121,g+16|0,17540)|0;i=v[113382];v[113382]=0;if((i|0)==1){break v}v[113382]=0;Q(335,((b<<5)+a|0)+946304|0,c|0)|0;i=v[113382];v[113382]=0;if((i|0)==1){break u}yb(c);v[113382]=0;c=B(b,104)+a|0;R(453,c+484380|0,0);i=v[113382];v[113382]=0;if((i|0)==1){break s}v[c+484404>>2]=f}f=B(b,104)+a|0;c=f+484380|0;o=c,p=(oc(k)>>>0)/(d>>>0)|0,v[o>>2]=p;i=f+484414|0;f=x[i>>1];u[i>>1]=(d|0)==2?f|65:f&65470|1;v[113382]=0;T(422,c|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break s}if(Be(c)){d=ac(k);f=bc(k);b=v[(B(b,104)+a|0)+484400>>2];v[113382]=0;W(1207,d|0,f|0,b|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break s}}if(!e){b=v[a+480180>>2];v[113382]=0;U(1208,c|0,32,b|0);b=v[113382];v[113382]=0;if((b|0)==1){break t}v[113382]=0;U(1209,c|0,a|0,0);a=v[113382];v[113382]=0;if((a|0)==1){break s}}h=Be(c)}sC(k);Cc(g+11336|0);break a}h=P()|0;O()|0;break l}h=P()|0;O()|0;yb(c);break l}h=P()|0;O()|0;break l}h=P()|0;O()|0}sC(k)}Cc(g+11336|0);S(h|0);L()}jb=g+11360|0;return h|0}function iM(a,b,c,d,e){var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,y=0,z=0;i=jb-16|0;jb=i;a:{if(!Xd(d&255)){break a}j=(B(b,896)+a|0)+1074984|0;b:{if(!(e?1:!(v[a+480180>>2]&17825824)|!x[a+480192>>1])){break b}if(oj(j)){break b}c=B(b,896)+a|0;d=c+1075060|0;if(!v[d>>2]){break a}c=v[c+1075072>>2];if(c&1024){break a}e=B(b,896)+a|0;f=e+1075004|0;e=e+1075008|0;if(!(v[f>>2]|v[e>>2])){break a}c:{if(!(c&512)){break c}c=a+1304392|0;if(!qd(c)){break c}yi(v[c>>2],b,0);break a}c=oy(a,b);if((c|0)==65535){break a}m=B(c,896);c=a+1074984|0;a=m+c|0;As(a,j);t[a+851|0]=0;t[a+827|0]=0;u[a+808>>1]=b+1;v[a+88>>2]=v[a+88>>2]&-918529;it(a+810|0);v[a+696>>2]=0;v[a+88>>2]=v[a+88>>2]|2101248;v[d>>2]=0;v[j>>2]=0;v[j+4>>2]=0;a=c+B(b,896)|0;v[a+92>>2]=0;v[a+96>>2]=0;v[f>>2]=0;v[e>>2]=0;break a}e=B(b,896)+a|0;n=v[e+1075088>>2];c=x[a+480192>>1]<c>>>0?0:c;h=v[(c?((c<<2)+a|0)+900380|0:e+1075640|0)>>2];d:{if(!h){break d}g=d-1|0;c=x[_c(h+236|0,g)>>1];k=i+8|0;f=a+1074312|0;Fb(k,f,104);e:{if(Cb(k)){Fb(i,f,34);if(Cb(i)){break e}}d=w[ec(h+108|0,g)|0]}if((c-1&65535)>>>0<=3998){n=(B(c,104)+a|0)+484380|0;break d}c=i+8|0;Fb(c,f,43);if(!Cb(c)){break d}if(!zi(h)){break a}}if(w[e+1075073|0]&4){break a}e=a+1304392|0;k=a+1074312|0;if(b>>>0<256){q=b+1|0;c=b;while(1){f:{if((b|0)!=(c|0)&x[a+480188>>1]>c>>>0){break f}f=B(c,896)+a|0;if(x[f+1075792>>1]!=(q|0)&(b|0)!=(c|0)){break f}p=f+1075640|0;g=v[p>>2];if(!g){break f}l=f+1074984|0;g:{h:{i:{j:{k:{l:{m:{switch(w[g+17|0]-1|0){case 0:if(!d){break f}m=w[f+1075803|0]==(d|0)&(g|0)==(h|0);o=m;if(!h){break l}if(m){break i}break f;case 1:if(!n|v[f+1075088>>2]!=(n|0)){break f}if((g|0)==(h|0)){break g}g=i+8|0;Fb(g,k,104);if(!Cb(g)){break g}break f;case 3:break k;case 2:break m;default:break f}}if(h){break j}o=(g|0)==(h|0)}if(o){break g}break f}if(!h){break f}m=w[h+34|0];if(!m){break f}if((m|0)==w[g+34|0]){break h}break f}if((g|0)!=(h|0)){break f}}if(!w[h+34|0]){break g}}if(!w[f+1075803|0]|w[g+18|0]>2){break g}g=i+8|0;Fb(g,k,34);yl(a,c&65535,$N(l,Cb(g))+255|0,0);t[f+1075806|0]=0}n:{o:{switch(w[v[p>>2]+18|0]){case 0:$m(a,l);v[f+1075672>>2]=0;if(!(w[f+1075073|0]&2)){break n}if(!qd(e)){break n}yi(v[e>>2],c&65535,1);break n;case 1:$m(a,l);if(!(w[f+1075073|0]&2)){break n}if(!qd(e)){break n}uk(v[e>>2],c&65535);break n;case 2:break o;default:break n}}l=f+1075072|0;g=v[l>>2];v[l>>2]=g|4096;if(!(g&512)){break n}if(!qd(e)){break n}g=i+8|0;Fb(g,k,105);if(Cb(g)){break n}uk(v[e>>2],c&65535)}if(v[f+1075672>>2]){break f}v[f+1075680>>2]=0;f=f+1075072|0;v[f>>2]=v[f>>2]|2101248}c=c+1|0;if((c&65535)!=256){continue}break}}d=0;c=0;p:{if(!oj(j)){break p}c=0;if(!Xd(w[(B(b,896)+a|0)+1075803|0])){break p}f=xl(a,b,2,1);c=0;if((f-1&255)>>>0>249){break p}d=v[(B(f,160)+a|0)+906140>>2];if(!d){d=0;c=0;break p}c=i+8|0;Fb(c,k,34);c=(s=d,y=$N(j,Cb(c)),z=b,r=v[v[d>>2]+96>>2],nb[r](s|0,y|0,z|0)|0)}if(!(r=1,z=Kh(j),y=c,y?r:z)){break a}h=oy(a,b);if((h|0)==65535){break a}g=B(h,896)+a|0;f=g+1075072|0;n=g+1074984|0;q:{if(!(w[g+1075073|0]&2)){break q}if(!qd(e)){break q}yi(v[e>>2],h,1)}As(n,j);v[f>>2]=v[f>>2]&-917505;t[g+1075835|0]=0;l=x[a+480188>>1];t[g+1075811|0]=0;u[g+1075792>>1]=b>>>0<l>>>0?b+1|0:0;r:{if(!(c&(d|0)!=0)){break r}c=w[(B(b,896)+a|0)+1075804|0];if(c>>>0>3|(c|0)==1){break r}yl(a,b,255,0);t[(B(b,896)+a|0)+1075806|0]=0}s:{t:{switch(w[(B(b,896)+a|0)+1075804|0]){case 2:$m(a,n);if(!(w[f+1|0]&2)){break s}if(!qd(e)){break s}uk(v[e>>2],b);c=i+8|0;Fb(c,k,105);if(!Cb(c)){break s}Iy(v[e>>2],b,h);break s;case 0:v[(B(h,896)+a|0)+1075680>>2]=0;c=v[f>>2];v[f>>2]=c|4096;if(!(c&512)){break s}if(!qd(e)){break s}yi(v[e>>2],b,1);break s;case 3:c=v[f>>2];v[f>>2]=c|4096;if(!(c&512)){break s}if(!qd(e)){break s}c=i+8|0;Fb(c,k,105);d=Cb(c);c=v[e>>2];if(d){Iy(c,b,h);break s}uk(c,b);break s;case 1:break t;default:break s}}if(!(w[f+1|0]&2)){break s}if(!qd(e)){break s}Iy(v[e>>2],b,h)}if(!v[(B(h,896)+a|0)+1075672>>2]){v[(B(h,896)+a|0)+1075680>>2]=0;v[f>>2]=v[f>>2]|2101248}a=B(b,896)+a|0;v[a+1075060>>2]=0;v[j>>2]=0;v[j+4>>2]=0;a=a+1075076|0;v[a>>2]=0;v[a+4>>2]=0}jb=i+16|0}function uI(a,b,c,d,e,f,g,h,i){var j=0,k=0,l=0,m=0,n=0,o=0;m=jb-48|0;jb=m;v[m+44>>2]=0;if(i?1:d|g|h){k=g?m+44|0:0;a:{if(!k){break a}j=v[k>>2];if(!j){break a}Wb(j);v[k>>2]=0}v[113382]=0;Y(81);j=v[113382];v[113382]=0;b:{c:{if((j|0)==1){l=ab(66740,78556,78568,78672,66896,67e3,66948,66840,66828,67144,67112,67080,67068,66716,0)|0;d:{e:{n=O()|0;if((n|0)==(ga(66740)|0)){j=_(l|0)|0;v[113382]=0;R(2077,k|0,j|0);k=v[113382];v[113382]=0;j=277;if((k|0)==1){break e}break b}if((ga(78556)|0)==(n|0)){j=_(l|0)|0;v[113382]=0;R(2077,k|0,j|0);k=v[113382];v[113382]=0;j=358;if((k|0)!=1){break b}j=P()|0;O()|0;v[113382]=0;Y(20);a=v[113382];v[113382]=0;if((a|0)!=1){break c}break d}if((ga(78568)|0)==(n|0)){j=_(l|0)|0;v[113382]=0;R(2077,k|0,j|0);k=v[113382];v[113382]=0;j=359;if((k|0)!=1){break b}j=P()|0;O()|0;v[113382]=0;Y(20);a=v[113382];v[113382]=0;if((a|0)!=1){break c}break d}if((ga(78672)|0)==(n|0)){j=_(l|0)|0;v[113382]=0;R(2077,k|0,j|0);k=v[113382];v[113382]=0;j=357;if((k|0)!=1){break b}j=P()|0;O()|0;v[113382]=0;Y(20);a=v[113382];v[113382]=0;if((a|0)!=1){break c}break d}if((ga(66896)|0)==(n|0)){j=_(l|0)|0;v[113382]=0;R(2077,k|0,j|0);k=v[113382];v[113382]=0;j=300;if((k|0)!=1){break b}j=P()|0;O()|0;v[113382]=0;Y(20);a=v[113382];v[113382]=0;if((a|0)!=1){break c}break d}if((ga(67e3)|0)==(n|0)){j=_(l|0)|0;v[113382]=0;R(2077,k|0,j|0);k=v[113382];v[113382]=0;j=299;if((k|0)!=1){break b}j=P()|0;O()|0;v[113382]=0;Y(20);a=v[113382];v[113382]=0;if((a|0)!=1){break c}break d}if((ga(66948)|0)==(n|0)){j=_(l|0)|0;v[113382]=0;R(2077,k|0,j|0);k=v[113382];v[113382]=0;j=298;if((k|0)!=1){break b}j=P()|0;O()|0;v[113382]=0;Y(20);a=v[113382];v[113382]=0;if((a|0)!=1){break c}break d}if((ga(66840)|0)==(n|0)){j=_(l|0)|0;v[113382]=0;R(2077,k|0,j|0);k=v[113382];v[113382]=0;j=297;if((k|0)!=1){break b}j=P()|0;O()|0;v[113382]=0;Y(20);a=v[113382];v[113382]=0;if((a|0)!=1){break c}break d}if((ga(66828)|0)==(n|0)){j=_(l|0)|0;v[113382]=0;R(2077,k|0,j|0);k=v[113382];v[113382]=0;j=296;if((k|0)!=1){break b}j=P()|0;O()|0;v[113382]=0;Y(20);a=v[113382];v[113382]=0;if((a|0)!=1){break c}break d}if((ga(67144)|0)==(n|0)){j=_(l|0)|0;v[113382]=0;R(2077,k|0,j|0);k=v[113382];v[113382]=0;j=289;if((k|0)!=1){break b}j=P()|0;O()|0;v[113382]=0;Y(20);a=v[113382];v[113382]=0;if((a|0)!=1){break c}break d}if((ga(67112)|0)==(n|0)){j=_(l|0)|0;v[113382]=0;R(2077,k|0,j|0);k=v[113382];v[113382]=0;j=288;if((k|0)!=1){break b}j=P()|0;O()|0;v[113382]=0;Y(20);a=v[113382];v[113382]=0;if((a|0)!=1){break c}break d}if((ga(67080)|0)==(n|0)){j=_(l|0)|0;v[113382]=0;R(2077,k|0,j|0);k=v[113382];v[113382]=0;j=287;if((k|0)!=1){break b}j=P()|0;O()|0;v[113382]=0;Y(20);a=v[113382];v[113382]=0;if((a|0)!=1){break c}break d}if((ga(67068)|0)==(n|0)){j=_(l|0)|0;v[113382]=0;R(2077,k|0,j|0);k=v[113382];v[113382]=0;j=286;if((k|0)!=1){break b}j=P()|0;O()|0;v[113382]=0;Y(20);a=v[113382];v[113382]=0;if((a|0)!=1){break c}break d}o=ga(66716)|0;j=257;l=_(l|0)|0;if((n|0)!=(o|0)){break b}v[113382]=0;R(2077,k|0,l|0);k=v[113382];v[113382]=0;j=267;if((k|0)!=1){break b}j=P()|0;O()|0;v[113382]=0;Y(20);a=v[113382];v[113382]=0;if((a|0)==1){break d}break c}j=P()|0;O()|0;v[113382]=0;Y(20);a=v[113382];v[113382]=0;if((a|0)!=1){break c}}V(0)|0;O()|0;Ab()}L()}S(j|0);L()}$()}l=!g;if(d){k=nb[d|0](j,e)|0}else{k=3}if(!(l|!(k&2))){v[g+16>>2]=j;l=v[m+44>>2];f:{if(l){l=Ud(l);break f}l=Ud(17540)}v[g+20>>2]=l}if(h){v[h>>2]=j}if(i){g=v[m+44>>2];g:{if(g){g=Ud(g);break g}g=Ud(17540)}v[i>>2]=g}g=v[m+44>>2];if(g){Wb(g);v[m+44>>2]=0}h:{if(!(k&1)){break h}v[113382]=0;R(1959,m+32|0,a|0);g=v[113382];v[113382]=0;i:{j:{if((g|0)!=1){k:{if(f){v[113382]=0;R(1960,f|0,m+32|0);g=v[113382];v[113382]=0;if((g|0)!=1){break k}break j}g=Tb(m+32|0);if(b){v[113382]=0;R(b|0,g|0,c|0);g=v[113382];v[113382]=0;if((g|0)==1){break j}break k}Zr(g,m)}yb(m+32|0);break h}g=V(0)|0;O()|0;break i}g=V(0)|0;O()|0;yb(m+32|0)}_(g|0)|0;v[m+28>>2]=f;v[m+24>>2]=e;v[m+20>>2]=d;v[m+16>>2]=c;v[m+12>>2]=b;v[m+4>>2]=252;v[m>>2]=5198;v[m+8>>2]=a?a:17540;a=v[12140];vG(a,13856,m);Er(a);$()}jb=m+48|0}function d9(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=C(0),l=0,m=0;d=jb-128|0;jb=d;h=-1;a:{b:{c:{d:{if(!Jf(v[v[b>>2]-12>>2]+b|0)){break d}pf(d+112|0,b);e=v[d+120>>2];f=v[d+124>>2];i=d+104|0;em(i);Oj(b,i,8);if((w[d+104|0]|w[d+105|0]<<8|(w[d+106|0]<<16|w[d+107|0]<<24))!=1414681667|(w[d+108|0]|w[d+109|0]<<8|(w[d+110|0]<<16|w[d+111|0]<<24))!=776101705){a=Qg(d+88|0,e,f);c=v[a+12>>2];v[d+16>>2]=v[a+8>>2];v[d+20>>2]=c;c=v[a+4>>2];v[d+8>>2]=v[a>>2];v[d+12>>2]=c;aj(b,d+8|0);break d}u[d+86>>1]=0;wf(b,d+86|0);if((x[d+86>>1]&65534)!=2){break d}e=d+78|0;em(e);Oj(b,e,8);if((w[d+78|0]|w[d+79|0]<<8|(w[d+80|0]<<16|w[d+81|0]<<24))!=1933333571|(w[d+82|0]|w[d+83|0]<<8|(w[d+84|0]<<16|w[d+85|0]<<24))!=1111389030){break d}u[d+76>>1]=0;wf(b,d+76|0);e=x[d+76>>1];if((e-3&65535)>>>0>1){break d}e:{f:{g:{h:{i:{j:{k:{if(e>>>0<=3){e=Xb(d+112|0);v[113382]=0;f=W(685,b|0,e|0,65535)|0;i=v[113382];v[113382]=0;if((i|0)==1){break b}if(!f){break j}v[113382]=0;U(13,d- -64|0,c|0,e|0);f=v[113382];v[113382]=0;if((f|0)!=1){break k}break b}e=Xb(d+112|0);v[113382]=0;f=W(687,b|0,e|0,255)|0;i=v[113382];v[113382]=0;if((i|0)==1){break c}if(!f){break i}v[113382]=0;U(13,d- -64|0,c|0,e|0);f=v[113382];v[113382]=0;if((f|0)==1){break c}}f=d- -64|0;Gb(a+40|0,f);yb(f);yb(e);u[d+62>>1]=0;wf(b,d+62|0);u[d+60>>1]=0;wf(b,d+60|0);u[a>>1]=x[d+60>>1];u[d+58>>1]=0;l:{if(u[d+76>>1]<=3){v[d+112>>2]=0;Fi(b,d+112|0);e=v[d+112>>2];if(e>>>0>65535){break d}e=sA(e);u[d+58>>1]=e;break l}wf(b,d+58|0);e=x[d+58>>1]}m:{n:{o:{p:{if(e&65535){i=a+52|0;f=0;while(1){e=Xb(d+112|0);v[113382]=0;u[d+40>>1]=0;Q(1585,b|0,d+40|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break g}q:{if(u[d+76>>1]<=3){v[113382]=0;g=W(685,b|0,e|0,65535)|0;j=v[113382];v[113382]=0;if((j|0)==1){break g}if(g){break q}break e}v[113382]=0;g=W(687,b|0,e|0,255)|0;j=v[113382];v[113382]=0;if((j|0)==1){break g}if(!g){break e}}v[113382]=0;U(13,d- -64|0,c|0,e|0);g=v[113382];v[113382]=0;if((g|0)==1){break p}v[113382]=0;g=Q(1586,i|0,d+40|0)|0;j=v[113382];v[113382]=0;if((j|0)==1){break o}j=g;g=d- -64|0;Gb(j,g);yb(g);yb(e);f=f+1|0;if(x[d+58>>1]>(f&65535)>>>0){continue}break}}c=d- -64|0;em(c);Oj(b,c,8);if((w[d+64|0]|w[d+65|0]<<8|(w[d+66|0]<<16|w[d+67|0]<<24))!=1933333571|(w[d+68|0]|w[d+69|0]<<8|(w[d+70|0]<<16|w[d+71|0]<<24))!=1161720678){break d}c=x[a>>1];if(c>>>0>3|(c|0)==2){break d}c=a+4|0;if(u[d+86>>1]>2){break n}if(NJ(b,c)){break m}break d}b=P()|0;O()|0;break f}b=P()|0;O()|0;yb(d- -64|0);break f}if(!MJ(b,c)){break d}}c=a+16|0;r:{if(u[d+86>>1]<=2){if(NJ(b,c)){break r}break d}if(!MJ(b,c)){break d}}l=a,m=Kb(a+16|0),v[l+36>>2]=m;u[d+56>>1]=0;wf(b,d+56|0);c=x[d+56>>1];u[a+28>>1]=c;if((c+200&65535)>>>0>400){break d}u[d+54>>1]=0;wf(b,d+54|0);c=u[d+54>>1];u[a+30>>1]=c;if((c|0)<0){break d}v[d+48>>2]=0;No(b,d+48|0);k=z[d+48>>2];z[a+32>>2]=k;if(k<C(0)){break d}c=d+40|0;em(c);Oj(b,c,8);if((w[d+40|0]|w[d+41|0]<<8|(w[d+42|0]<<16|w[d+43|0]<<24))!=1414681667|(w[d+44|0]|w[d+45|0]<<8|(w[d+46|0]<<16|w[d+47|0]<<24))!=776298313){break d}c=a+4|0;if(Kb(c)>>>0>32767){break d}b=x[a>>1];if(!(b?u[a+30>>1]>0&z[a+32>>2]>C(0):1)){break d}s:{switch(b-1|0){case 0:case 2:if(Kb(c)>>>0<u[a+30>>1]>>>0){break d}break;default:break s}}b=0;e=v[a+36>>2];if(e){b=e-1|0;v[a+36>>2]=b}l=d,m=ot(b),v[l+112>>2]=m;v[d+32>>2]=0;l=a,m=v[Ok(d+112|0,d+32|0,36120)>>2],v[l+36>>2]=m;Oo(a);h=1;if(x[a>>1]!=3){break d}if((TJ(Kb(c))|0)<(u[a+30>>1]-u[a+28>>1]|0)){break d}e=kk(d+112|0);h=0;if(u[a+30>>1]>0){while(1){b=Pb(c,h-u[a+28>>1]|0);v[113382]=0;R(1587,e|0,b|0);b=v[113382];v[113382]=0;if((b|0)==1){break h}h=h+1|0;if((h|0)<u[a+30>>1]){continue}break}}b=x[a+28>>1];u[d+32>>1]=b;c=Kb(c);v[113382]=0;u[d+34>>1]=(b+c|0)-1;u[d+30>>1]=0;ea(1581,a|0,e|0,a+32|0,d+32|0,d+30|0)|0;a=v[113382];v[113382]=0;h=1;if((a|0)!=1){fg(e);break d}break h}yb(e);break d}yb(e);break d}b=P()|0;O()|0;fg(e);break a}b=P()|0;O()|0}yb(e);break a}yb(e)}jb=d+128|0;return h|0}b=P()|0;O()|0;yb(e);break a}b=P()|0;O()|0;yb(e)}S(b|0);L()}function pG(a,b,c,d,e){var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,w=0,x=0,y=0,z=0;h=jb-560|0;jb=h;g=c;c=(c-3|0)/24|0;s=(c|0)>0?c:0;l=g+B(s,-24)|0;n=v[(e<<2)+49072>>2];j=d-1|0;if((n+j|0)>=0){g=d+n|0;c=s-j|0;while(1){A[(h+320|0)+(i<<3)>>3]=(c|0)<0?0:+v[(c<<2)+49088>>2];c=c+1|0;i=i+1|0;if((g|0)!=(i|0)){continue}break}}q=l-24|0;i=(n|0)>0?n:0;g=0;while(1){f=0;if((d|0)>0){k=g+j|0;c=0;while(1){f=f+A[(c<<3)+a>>3]*A[(h+320|0)+(k-c<<3)>>3];c=c+1|0;if((d|0)!=(c|0)){continue}break}}A[(g<<3)+h>>3]=f;c=(g|0)==(i|0);g=g+1|0;if(!c){continue}break}y=47-l|0;t=48-l|0;z=l-25|0;g=n;a:{while(1){f=A[(g<<3)+h>>3];c=0;i=g;o=(g|0)<=0;if(!o){while(1){k=(h+480|0)+(c<<2)|0;m=f;f=f*5.960464477539063e-8;b:{if(D(f)<2147483648){j=~~f;break b}j=-2147483648}f=+(j|0);m=m+f*-16777216;c:{if(D(m)<2147483648){j=~~m;break c}j=-2147483648}v[k>>2]=j;i=i-1|0;f=A[(i<<3)+h>>3]+f;c=c+1|0;if((g|0)!=(c|0)){continue}break}}f=Zh(f,q);f=f+H(f*.125)*-8;d:{if(D(f)<2147483648){k=~~f;break d}k=-2147483648}f=f-+(k|0);e:{f:{g:{u=(q|0)<=0;h:{if(!u){i=(g<<2)+h|0;j=v[i+476>>2];c=j>>t;r=i;i=j-(c<<t)|0;v[r+476>>2]=i;k=c+k|0;j=i>>y;break h}if(q){break g}j=v[((g<<2)+h|0)+476>>2]>>23}if((j|0)<=0){break e}break f}j=2;if(f>=.5){break f}j=0;break e}c=0;i=0;if(!o){while(1){r=(h+480|0)+(c<<2)|0;o=v[r>>2];w=16777215;i:{j:{if(i){break j}w=16777216;if(o){break j}i=0;break i}v[r>>2]=w-o;i=1}c=c+1|0;if((g|0)!=(c|0)){continue}break}}k:{if(u){break k}c=8388607;l:{switch(z|0){case 1:c=4194303;break;case 0:break l;default:break k}}o=(g<<2)+h|0;v[o+476>>2]=v[o+476>>2]&c}k=k+1|0;if((j|0)!=2){break e}f=1-f;j=2;if(!i){break e}f=f-Zh(1,q)}if(f==0){i=0;c=g;m:{if((c|0)<=(n|0)){break m}while(1){c=c-1|0;i=v[(h+480|0)+(c<<2)>>2]|i;if((c|0)>(n|0)){continue}break}if(!i){break m}l=q;while(1){l=l-24|0;g=g-1|0;if(!v[(h+480|0)+(g<<2)>>2]){continue}break}break a}c=1;while(1){i=c;c=c+1|0;if(!v[(h+480|0)+(n-i<<2)>>2]){continue}break}i=g+i|0;while(1){j=d+g|0;g=g+1|0;A[(h+320|0)+(j<<3)>>3]=v[(s+g<<2)+49088>>2];c=0;f=0;if((d|0)>0){while(1){f=f+A[(c<<3)+a>>3]*A[(h+320|0)+(j-c<<3)>>3];c=c+1|0;if((d|0)!=(c|0)){continue}break}}A[(g<<3)+h>>3]=f;if((g|0)<(i|0)){continue}break}g=i;continue}break}f=Zh(f,24-l|0);n:{if(f>=16777216){d=(h+480|0)+(g<<2)|0;m=f;f=f*5.960464477539063e-8;o:{if(D(f)<2147483648){c=~~f;break o}c=-2147483648}f=m+ +(c|0)*-16777216;p:{if(D(f)<2147483648){a=~~f;break p}a=-2147483648}v[d>>2]=a;g=g+1|0;break n}if(D(f)<2147483648){c=~~f}else{c=-2147483648}l=q}v[(h+480|0)+(g<<2)>>2]=c}f=Zh(1,l);q:{if((g|0)<0){break q}d=g;while(1){a=d;A[(d<<3)+h>>3]=f*+v[(h+480|0)+(d<<2)>>2];d=d-1|0;f=f*5.960464477539063e-8;if(a){continue}break}if((g|0)<0){break q}c=g;while(1){a=c;d=g-c|0;f=0;c=0;while(1){r:{f=f+A[(c<<3)+51856>>3]*A[(a+c<<3)+h>>3];if((c|0)>=(n|0)){break r}i=c>>>0<d>>>0;c=c+1|0;if(i){continue}}break}A[(h+160|0)+(d<<3)>>3]=f;c=a-1|0;if((a|0)>0){continue}break}}s:{t:{u:{switch(e|0){case 3:v:{if((g|0)<=0){break v}f=A[(h+160|0)+(g<<3)>>3];c=g;while(1){m=f;d=h+160|0;a=c-1|0;e=d+(a<<3)|0;x=A[e>>3];f=x+f;A[d+(c<<3)>>3]=m+(x-f);A[e>>3]=f;d=c>>>0>1;c=a;if(d){continue}break}if((g|0)<2){break v}f=A[(h+160|0)+(g<<3)>>3];c=g;while(1){m=f;d=h+160|0;a=c-1|0;e=d+(a<<3)|0;p=A[e>>3];f=p+f;A[d+(c<<3)>>3]=m+(p-f);A[e>>3]=f;d=c>>>0>2;c=a;if(d){continue}break}p=0;if((g|0)<=1){break v}while(1){p=p+A[(h+160|0)+(g<<3)>>3];a=(g|0)>2;g=g-1|0;if(a){continue}break}}f=A[h+160>>3];if(j){break t}A[b>>3]=f;f=A[h+168>>3];A[b+16>>3]=p;A[b+8>>3]=f;break s;case 0:f=0;if((g|0)>=0){while(1){a=g;g=g-1|0;f=f+A[(h+160|0)+(a<<3)>>3];if(a){continue}break}}A[b>>3]=j?-f:f;break s;case 1:case 2:break u;default:break s}}f=0;if((g|0)>=0){d=g;while(1){a=d;d=d-1|0;f=f+A[(h+160|0)+(a<<3)>>3];if(a){continue}break}}A[b>>3]=j?-f:f;f=A[h+160>>3]-f;c=1;if((g|0)>0){while(1){f=f+A[(h+160|0)+(c<<3)>>3];a=(c|0)!=(g|0);c=c+1|0;if(a){continue}break}}A[b+8>>3]=j?-f:f;break s}A[b>>3]=-f;f=A[h+168>>3];A[b+16>>3]=-p;A[b+8>>3]=-f}jb=h+560|0;return k&7}function HZ(){var a=0,b=0,c=0,d=0,e=0;Gd(455352);v[113838]=59496;v[113382]=0;b=Q(2397,455360,30)|0;a=v[113382];v[113382]=0;a:{b:{c:{d:{e:{if((a|0)!=1){v[113382]=0;c=Q(121,455504,10140)|0;a=v[113382];v[113382]=0;if((a|0)==1){break e}Kb(b);RE(b);ng(b);Gd(455040);v[113760]=60820;v[113382]=0;R(2398,455352,455040);a=v[113382];v[113382]=0;if((a|0)==1){break d}Gd(455048);v[113762]=60852;v[113382]=0;R(2399,455352,455048);a=v[113382];v[113382]=0;if((a|0)==1){break d}Gd(455056);t[455068]=0;v[113766]=0;v[113764]=59516;d=455064,e=qo(),v[d>>2]=e;v[113382]=0;R(2400,455352,455056);a=v[113382];v[113382]=0;if((a|0)==1){break d}Gd(455072);v[113768]=6e4;v[113382]=0;R(2401,455352,455072);a=v[113382];v[113382]=0;if((a|0)==1){break d}Gd(455080);v[113770]=60148;v[113382]=0;R(2402,455352,455080);a=v[113382];v[113382]=0;if((a|0)==1){break d}v[113382]=0;Y(2403);a=v[113382];v[113382]=0;if((a|0)==1){break d}v[113382]=0;R(2404,455352,455088);a=v[113382];v[113382]=0;if((a|0)==1){break d}Gd(455104);v[113776]=60296;v[113382]=0;R(2405,455352,455104);a=v[113382];v[113382]=0;if((a|0)==1){break d}Gd(455112);v[113778]=60412;v[113382]=0;R(2406,455352,455112);a=v[113382];v[113382]=0;if((a|0)==1){break d}Gd(455120);u[227564]=11310;v[113780]=59616;Xb(455132);v[113382]=0;R(2407,455352,455120);a=v[113382];v[113382]=0;if((a|0)==1){break d}Gd(455144);v[113788]=46;v[113789]=44;v[113786]=59656;Xb(455160);v[113382]=0;R(2408,455352,455144);a=v[113382];v[113382]=0;if((a|0)==1){break d}Gd(455176);v[113794]=60884;v[113382]=0;R(2409,455352,455176);a=v[113382];v[113382]=0;if((a|0)==1){break d}Gd(455184);v[113796]=61128;v[113382]=0;R(2410,455352,455184);a=v[113382];v[113382]=0;if((a|0)==1){break d}Gd(455192);v[113798]=61340;v[113382]=0;R(2411,455352,455192);a=v[113382];v[113382]=0;if((a|0)==1){break d}Gd(455200);v[113800]=61572;v[113382]=0;R(2412,455352,455200);a=v[113382];v[113382]=0;if((a|0)==1){break d}v[113382]=0;QE();a=v[113382];v[113382]=0;if((a|0)==1){break d}v[113382]=0;R(2414,455352,455208);a=v[113382];v[113382]=0;if((a|0)==1){break d}Gd(455216);v[113804]=62704;v[113382]=0;R(2415,455352,455216);a=v[113382];v[113382]=0;if((a|0)==1){break d}Gd(455224);v[113806]=62820;v[113382]=0;R(2416,455352,455224);a=v[113382];v[113382]=0;if((a|0)==1){break d}Gd(455232);v[113808]=62936;v[113382]=0;R(2417,455352,455232);a=v[113382];v[113382]=0;if((a|0)==1){break d}v[113382]=0;PE();a=v[113382];v[113382]=0;if((a|0)==1){break d}v[113382]=0;R(2419,455352,455240);a=v[113382];v[113382]=0;if((a|0)==1){break d}v[113382]=0;OE();a=v[113382];v[113382]=0;if((a|0)==1){break d}v[113382]=0;R(2421,455352,455248);a=v[113382];v[113382]=0;if((a|0)==1){break d}v[113382]=0;NE();a=v[113382];v[113382]=0;if((a|0)==1){break d}v[113382]=0;R(2423,455352,455256);a=v[113382];v[113382]=0;if((a|0)==1){break d}v[113382]=0;ME();a=v[113382];v[113382]=0;if((a|0)==1){break d}v[113382]=0;R(2425,455352,455264);a=v[113382];v[113382]=0;if((a|0)==1){break d}Gd(455272);v[113820]=64800;v[113818]=61772;v[113820]=61820;v[113382]=0;R(2426,455352,455272);a=v[113382];v[113382]=0;if((a|0)==1){break d}Gd(455288);v[113824]=64836;v[113822]=62036;v[113824]=62084;v[113382]=0;R(2427,455352,455288);a=v[113382];v[113382]=0;if((a|0)==1){break d}v[113382]=0;Y(2428);a=v[113382];v[113382]=0;if((a|0)==1){break d}v[113382]=0;R(2429,455352,455304);a=v[113382];v[113382]=0;if((a|0)==1){break d}v[113382]=0;Y(2430);a=v[113382];v[113382]=0;if((a|0)==1){break d}v[113382]=0;R(2431,455352,455320);a=v[113382];v[113382]=0;if((a|0)==1){break d}v[113382]=0;LE();a=v[113382];v[113382]=0;if((a|0)==1){break d}v[113382]=0;R(2433,455352,455336);a=v[113382];v[113382]=0;if((a|0)==1){break d}Gd(455344);v[113836]=63828;v[113382]=0;R(2434,455352,455344);a=v[113382];v[113382]=0;if((a|0)==1){break d}break a}a=P()|0;O()|0;break b}a=P()|0;O()|0;break c}a=P()|0;O()|0;yb(c)}UE(b)}S(a|0);L()}v[113435]=455352;return 453740}function Zia(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,x=0,z=0,A=0,B=0,C=0,D=0;e=jb-48|0;jb=e;a:{b:{c:{d:{if(!c){break d}C=e,D=le(a),t[C+32|0]=D;g=e+32|0;i=b;e:{if(y[i+4>>2]<y[zb(i)>>2]){h=jb-16|0;jb=h;d=Li(h,i,1);f=zb(i);i=v[d+4>>2];v[113382]=0;U(843,f|0,i|0,g|0);i=v[113382];v[113382]=0;if((i|0)!=1){v[d+4>>2]=v[d+4>>2]+1;Mb(d);jb=h+16|0;break e}a=P()|0;O()|0;Mb(d);break a}d=jb-32|0;jb=d;h=zb(i);k=ph(d+8|0,Ki(i,wc(i)+1|0),wc(i),h);f=v[k+8>>2];v[113382]=0;U(843,h|0,f|0,g|0);f=v[113382];v[113382]=0;f:{g:{if((f|0)==1){break g}v[k+8>>2]=v[k+8>>2]+1;v[113382]=0;R(330,i|0,k|0);i=v[113382];v[113382]=0;if((i|0)==1){break g}Tg(k);jb=d+32|0;break f}a=P()|0;O()|0;Tg(k);break a}}i=c-1|0;if(!i){break c}while(1){h:{i:{c=j<<1;j=c&254;j:{if(!j){if(!Je(a,e+32|0)){break d}c=w[e+32|0]<<1|1;j=c&255;if(c>>>0>255){break j}break i}if((c&65535)>>>0<256){break i}}g=1;while(1){k:{l:{m:{c=j<<1&254;n:{if(c){d=j>>>0>127}else{if(!Je(a,e+32|0)){break n}f=w[e+32|0]<<1|1;c=f&255;d=f>>>0>255}g=d|g<<1;j=c<<1&254;if(j){break l}if(Je(a,e+32|0)){break m}}j=0;break k}c=w[e+32|0]<<1|1;j=c&255;if(c>>>0>255){continue}break k}if(c>>>0>127){continue}}break}o:{if((g|0)<=2){f=0;g=g-2|0;break o}c=Je(a,e+32|0);if(!c){break d}c=c?(w[e+32|0]|g<<8)-768|0:p;f=((c|0)>1279?2:1)+((c|0)>31999)|0;p=c^-1;g=0}c=j<<1&254;if(c){d=j>>>0>127}else{if(!Je(a,e+32|0)){break d}h=w[e+32|0]<<1|1;c=h&255;d=h>>>0>255}h=i;j=c<<1&254;if(j){c=c>>>0>127}else{if(!Je(a,e+32|0)){break d}c=w[e+32|0]<<1|1;j=c&255;c=c>>>0>255}c=c|(g<<2|(d?2:0));if(!c){g=1;while(1){p:{q:{r:{c=j<<1&254;s:{if(c){d=j>>>0>127}else{if(!Je(a,e+32|0)){break s}d=w[e+32|0]<<1|1;c=d&255;d=d>>>0>255}g=d|g<<1;j=c<<1&254;if(j){break q}if(Je(a,e+32|0)){break r}}j=0;break p}c=w[e+32|0]<<1|1;j=c&255;if(c>>>0>255){continue}break p}if(c>>>0>127){continue}}break}c=g+2|0}g=h;h=c+f|0;d=0;if(g>>>0<h>>>0|(h|0)<=0|(p|0)>=0){break b}d=0;if((0-wc(b)|0)>(p|0)){break b}C=e,D=bc(b),v[C+32>>2]=D;Hd(e+40|0,e+32|0);t[e+24|0]=0;z=e+24|0;o=z;n=jb-32|0;jb=n;v[n+24>>2]=v[e+40>>2];d=b;c=v[d>>2];C=n,D=ac(d),v[C>>2]=D;l=dm(n+24|0,n)+c|0;t:{u:{c=h;v:{if(!c){break v}g=v[zb(d)>>2];m=v[d+4>>2];if(c>>>0<=g-m>>>0){f=c;g=m-l|0;if(g>>>0<c>>>0){Sp(d,c-g|0,o);f=g;if(!f){break v}}u=jb-16|0;jb=u;B=d;k=m;g=l;A=v[d+4>>2];q=g+(A-(c+g|0)|0)|0;r=Li(u,d,k-q|0);w:{x:{if(k>>>0>q>>>0){s=v[r+4>>2];m=q;while(1){x=zb(B);v[113382]=0;U(843,x|0,s|0,m|0);x=v[113382];v[113382]=0;if((x|0)==1){break x}s=s+1|0;v[r+4>>2]=s;m=m+1|0;if(k>>>0>m>>>0){continue}break}}Mb(r);Gp(g,q,A);jb=u+16|0;break w}a=P()|0;O()|0;Mb(r);break a}Qh(l,f,o+(l>>>0<=o>>>0?o>>>0<y[d+4>>2]?c:0:0)|0);break v}f=zb(d);f=ph(n,Ki(d,wc(d)+c|0),l-v[d>>2]|0,f);v[113382]=0;U(665,f|0,c|0,o|0);c=v[113382];v[113382]=0;if((c|0)==1){break u}v[113382]=0;l=W(838,d|0,f|0,l|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break u}Tg(f)}Pg(l);jb=n+32|0;break t}a=P()|0;O()|0;Tg(f);break a}C=e,D=bc(b),v[C+16>>2]=D;C=e,D=Az(e+16|0,h),v[C+24>>2]=D;C=e,D=ff(z,p),v[C+32>>2]=D;C=e,D=bc(b),v[C+16>>2]=D;C=e,D=Az(e+16|0,h),v[C+24>>2]=D;c=h;while(1){C=e,D=Nw(e+32|0),v[C+16>>2]=D;f=w[v[e+16>>2]];C=e,D=Nw(e+24|0),v[C+8>>2]=D;t[v[e+8>>2]]=f;f=c>>>0>1;c=c-1|0;if(f){continue}break}i=i-h|0;break h}if(!Je(a,e+32|0)){break d}g=e+32|0;c=b;y:{if(v[c+4>>2]!=v[zb(c)>>2]){h=jb-16|0;jb=h;d=Li(h,c,1);f=zb(c);c=v[d+4>>2];v[113382]=0;U(534,f|0,c|0,g|0);c=v[113382];v[113382]=0;if((c|0)!=1){v[d+4>>2]=v[d+4>>2]+1;Mb(d);jb=h+16|0;break y}a=P()|0;O()|0;Mb(d);break a}d=jb-32|0;jb=d;h=zb(c);k=ph(d+8|0,Ki(c,wc(c)+1|0),wc(c),h);f=v[k+8>>2];v[113382]=0;U(534,h|0,f|0,g|0);f=v[113382];v[113382]=0;z:{A:{if((f|0)==1){break A}v[k+8>>2]=v[k+8>>2]+1;v[113382]=0;R(330,c|0,k|0);c=v[113382];v[113382]=0;if((c|0)==1){break A}Tg(k);jb=d+32|0;break z}a=P()|0;O()|0;Tg(k);break a}}i=i-1|0}if(i){continue}break}break c}d=0;break b}d=1}jb=e+48|0;return d|0}S(a|0);L()}function iba(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;v[a+24588>>2]=0;v[a+24592>>2]=0;v[a+4>>2]=0;v[a>>2]=26016;v[a+8>>2]=v[18623];c=a+24596|0;v[c>>2]=0;v[c+4>>2]=0;up(a+24604|0);AL(a+24648|0,0);c=a+393352|0;v[c>>2]=8;v[c+4>>2]=0;u[c+4128>>1]=0;d=c+4120|0;v[d>>2]=0;v[d+4>>2]=0;d=c+4112|0;v[d>>2]=0;v[d+4>>2]=0;v[c+4104>>2]=0;v[c+4108>>2]=0;Qb(c+4132|0,0,40);dO(c+8|0,1024);Qb(c+4172|0,0,49824);Qb(c+53996|0,0,32832);v[a+480224>>2]=0;u[a+480212>>1]=0;v[a+480204>>2]=0;v[a+480208>>2]=0;v[a+480180>>2]=0;v[a+480184>>2]=0;c=a+480186|0;u[c>>1]=0;u[c+2>>1]=0;u[c+4>>1]=0;u[c+6>>1]=0;v[a+480240>>2]=65536;v[a+480244>>2]=65536;l=fy(a+480248|0);v[a+480272>>2]=0;c=a+484344|0;b=a+480280|0;a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{while(1){v[113382]=0;d=T(1352,b|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break m}b=d+32|0;if((c|0)!=(b|0)){continue}break}c=jb-16|0;jb=c;f=a+484344|0;d=f;v[d>>2]=0;v[d+4>>2]=0;v[113382]=0;v[c+12>>2]=0;W(1404,d+8|0,c+12|0,c+8|0)|0;d=v[113382];v[113382]=0;n:{if((d|0)!=1){jb=c+16|0;break n}break a}v[f+12>>2]=a;v[113382]=0;m=Q(1353,a+484360|0,a|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break l}c=a+900380|0;b=a+484380|0;while(1){v[113382]=0;d=Q(976,b|0,0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break k}b=d+104|0;if((c|0)!=(b|0)){continue}break}v[113382]=0;T(1354,a+901404|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break j}g=a+946300|0;h=a+906300|0;c=0;while(1){v[113382]=0;d=(B(c,160)+a|0)+906300|0;T(1355,d|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break i}c=c+1|0;if((c|0)!=250){continue}break}v[a+946300>>2]=0;c=a+1074304|0;i=a+946304|0;b=i;while(1){v[113382]=0;d=T(1126,b|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break h}b=d+32|0;if((c|0)!=(b|0)){continue}break}v[a+1074304>>2]=0;v[a+1074308>>2]=0;ey(a+1074312|0);v[113382]=0;c=da(1356)|0;d=v[113382];v[113382]=0;if((d|0)==1){break g}v[113382]=0;c=T(1357,c|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break g}v[a+1074328>>2]=c;v[113382]=0;T(1358,a+1074332|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break g}v[113382]=0;T(1359,a+1074376|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break g}v[113382]=0;n=W(1296,a+1304360|0,a|0,255)|0;c=v[113382];v[113382]=0;if((c|0)==1){break g}d=jb-16|0;jb=d;v[113382]=0;v[d+12>>2]=0;c=a+1304392|0;W(1362,c|0,d+12|0,d+8|0)|0;b=v[113382];v[113382]=0;o:{if((b|0)!=1){jb=d+16|0;break o}break a}d=c;b=jb-16|0;jb=b;v[113382]=0;v[b+12>>2]=0;c=a+1304396|0;W(1363,c|0,b+12|0,b+8|0)|0;e=v[113382];v[113382]=0;p:{if((e|0)!=1){jb=b+16|0;break p}break a}o=Xb(a+1304400|0);p=bd(a+1304412|0);j=a+1304424|0;Xb(j);q=yL(a+1304436|0);b=jb-16|0;jb=b;k=a+1304500|0;e=k;v[e>>2]=0;v[e+4>>2]=0;v[113382]=0;v[b+12>>2]=0;W(1364,e+8|0,b+12|0,b+8|0)|0;e=v[113382];v[113382]=0;q:{if((e|0)!=1){jb=b+16|0;break q}break a}t[a+1304512|0]=0;b=a+1304520|0;v[b>>2]=0;v[b+4>>2]=0;v[b+32>>2]=0;v[b+36>>2]=1072693248;v[b+24>>2]=0;v[b+28>>2]=0;v[b+16>>2]=0;v[b+20>>2]=0;v[b+8>>2]=0;v[b+12>>2]=0;v[a+1304560>>2]=0;Zo(a+12|0);vp(a+8204|0);vp(a+12300|0);b=a+1074408|0;v[b>>2]=4;v[b+4>>2]=16;v[a+480216>>2]=4;v[a+480220>>2]=16;xL(a+900380|0);v[113382]=0;Z(1360,i|0);b=v[113382];v[113382]=0;if((b|0)==1){break f}v[113382]=0;b=T(1361,12)|0;e=v[113382];v[113382]=0;if((e|0)==1){break f}v[b>>2]=0;v[b+4>>2]=0;v[b+8>>2]=0;c=jb-16|0;jb=c;v[b>>2]=0;v[b+4>>2]=0;v[113382]=0;v[c+12>>2]=0;W(1405,b+8|0,c+12|0,c+8|0)|0;d=v[113382];v[113382]=0;r:{if((d|0)!=1){jb=c+16|0;break r}break a}v[a+4>>2]=b;return a|0}b=P()|0;O()|0;break b}b=P()|0;O()|0;break c}b=P()|0;O()|0;break d}b=P()|0;O()|0;break d}b=P()|0;O()|0;if(!c){break d}while(1){d=Ym(d-160|0);if((h|0)!=(d|0)){continue}break}break d}b=P()|0;O()|0;break e}b=P()|0;O()|0;break e}b=P()|0;O()|0;dy(k);vs(q);yb(j);yb(p);yb(o);us(c);ts(d);cp(n)}while(1){g=Ym(g-160|0);if((h|0)!=(g|0)){continue}break}}Ws(m)}cy(f)}ze(l);S(b|0);L()}V(0)|0;O()|0;Ab();L()}function S_(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0;h=jb+-64|0;jb=h;v[h+56>>2]=b;v[e>>2]=0;Ac(h,d);v[113382]=0;i=T(2339,h|0)|0;j=v[113382];v[113382]=0;a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{v:{w:{x:{y:{z:{A:{if((j|0)!=1){Ob(h);switch(g-65|0){case 54:break j;case 19:break k;case 18:break l;case 17:break m;case 49:break n;case 47:break o;case 45:case 51:break p;case 12:break q;case 44:break r;case 41:break s;case 8:break t;case 7:break u;case 5:break v;case 3:break w;case 35:case 36:break x;case 34:break y;case 1:case 33:case 39:break z;case 0:case 32:break A;case 2:case 4:case 6:case 9:case 10:case 11:case 13:case 14:case 15:case 16:case 20:case 21:case 22:case 25:case 26:case 27:case 28:case 29:case 30:case 31:case 37:case 38:case 40:case 42:case 43:case 46:case 48:case 50:case 52:case 53:break d;case 24:break f;case 56:break g;case 23:break h;case 55:break i;default:break e}}a=P()|0;O()|0;Ob(h);S(a|0);L()}lF(a,f+24|0,h+56|0,c,e,i);break b}kF(a,f+16|0,h+56|0,c,e,i);break b}g=a;a=nb[v[v[a+8>>2]+12>>2]](a+8|0)|0;k=h,l=dj(g,b,c,d,e,f,Tb(a),Tb(a)+(Db(a)<<2)|0),v[k+56>>2]=l;break b}a=e;b=ai(h+56|0,c,a,i,2);c=v[a>>2];B:{if(!(c&4|(b|0)<=0|(b|0)>31)){v[f+12>>2]=b;break B}v[a>>2]=c|4}break b}g=v[14835];v[h+24>>2]=v[14834];v[h+28>>2]=g;g=v[14833];v[h+16>>2]=v[14832];v[h+20>>2]=g;g=v[14831];v[h+8>>2]=v[14830];v[h+12>>2]=g;g=v[14829];v[h>>2]=v[14828];v[h+4>>2]=g;k=h,l=dj(a,b,c,d,e,f,h,h+32|0),v[k+56>>2]=l;break b}g=v[14843];v[h+24>>2]=v[14842];v[h+28>>2]=g;g=v[14841];v[h+16>>2]=v[14840];v[h+20>>2]=g;g=v[14839];v[h+8>>2]=v[14838];v[h+12>>2]=g;g=v[14837];v[h>>2]=v[14836];v[h+4>>2]=g;k=h,l=dj(a,b,c,d,e,f,h,h+32|0),v[k+56>>2]=l;break b}a=e;b=ai(h+56|0,c,a,i,2);c=v[a>>2];C:{if(!(c&4|(b|0)>23)){v[f+8>>2]=b;break C}v[a>>2]=c|4}break b}a=e;b=ai(h+56|0,c,a,i,2);c=v[a>>2];D:{if(!(c&4|(b|0)<=0|(b|0)>12)){v[f+8>>2]=b;break D}v[a>>2]=c|4}break b}a=e;b=ai(h+56|0,c,a,i,3);c=v[a>>2];E:{if(!(c&4|(b|0)>365)){v[f+28>>2]=b;break E}v[a>>2]=c|4}break b}a=e;b=ai(h+56|0,c,a,i,2);c=v[a>>2];F:{if(!(c&4|(b|0)>12)){v[f+16>>2]=b-1;break F}v[a>>2]=c|4}break b}a=e;b=ai(h+56|0,c,a,i,2);c=v[a>>2];G:{if(!(c&4|(b|0)>59)){v[f+4>>2]=b;break G}v[a>>2]=c|4}break b}a=h+56|0;b=jb-16|0;jb=b;v[b+8>>2]=c;while(1){H:{if(!qr(a,b+8|0)){break H}if(!Xj(i,8192,el(a))){break H}Cm(a);continue}break}if(ak(a,b+8|0)){v[e>>2]=v[e>>2]|2}jb=b+16|0;break b}b=h+56|0;a=nb[v[v[a+8>>2]+8>>2]](a+8|0)|0;I:{if((Db(a)|0)==(0-Db(a+12|0)|0)){v[e>>2]=v[e>>2]|4;break I}a=rr(b,c,a,a+24|0,i,e,0)-a|0;b=v[f+8>>2];if(!(a|(b|0)!=12)){v[f+8>>2]=0;break I}if(!((a|0)!=12|(b|0)>11)){v[f+8>>2]=b+12}}break b}g=lc(h,59376,44);k=g,l=dj(a,b,c,d,e,f,g,g+44|0),v[k+56>>2]=l;break b}v[h+16>>2]=v[14860];g=v[14859];v[h+8>>2]=v[14858];v[h+12>>2]=g;g=v[14857];v[h>>2]=v[14856];v[h+4>>2]=g;k=h,l=dj(a,b,c,d,e,f,h,h+20|0),v[k+56>>2]=l;break b}a=e;b=ai(h+56|0,c,a,i,2);c=v[a>>2];J:{if(!(c&4|(b|0)>60)){v[f>>2]=b;break J}v[a>>2]=c|4}break b}g=v[14871];v[h+24>>2]=v[14870];v[h+28>>2]=g;g=v[14869];v[h+16>>2]=v[14868];v[h+20>>2]=g;g=v[14867];v[h+8>>2]=v[14866];v[h+12>>2]=g;g=v[14865];v[h>>2]=v[14864];v[h+4>>2]=g;k=h,l=dj(a,b,c,d,e,f,h,h+32|0),v[k+56>>2]=l;break b}a=e;b=ai(h+56|0,c,a,i,1);c=v[a>>2];K:{if(!(c&4|(b|0)>6)){v[f+24>>2]=b;break K}v[a>>2]=c|4}break b}a=nb[v[v[a>>2]+20>>2]](a,b,c,d,e,f)|0;break a}g=a;a=nb[v[v[a+8>>2]+24>>2]](a+8|0)|0;k=h,l=dj(g,b,c,d,e,f,Tb(a),Tb(a)+(Db(a)<<2)|0),v[k+56>>2]=l;break b}jF(f+20|0,h+56|0,c,e,i);break b}a=ai(h+56|0,c,e,i,4);if(!(w[e|0]&4)){v[f+20>>2]=a-1900}break b}if((g|0)==37){break c}}v[e>>2]=v[e>>2]|4;break b}a=jb-16|0;jb=a;v[a+8>>2]=c;b=6;c=h+56|0;L:{M:{if(ak(c,a+8|0)){break M}b=4;if((xm(i,el(c))|0)!=37){break M}b=2;if(!ak(Cm(c),a+8|0)){break L}}v[e>>2]=v[e>>2]|b}jb=a+16|0}a=v[h+56>>2]}jb=h- -64|0;return a|0}function ela(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,z=0;g=jb-976|0;jb=g;Ic(b);f=jb-16|0;jb=f;h=f+8|0;i=g+872|0;nS(h,i);j=Hb(h);d=b;h=mc(d,$b(f,h));if((j|0)==(h|0)){_b(d,Hb(f+8|0))}jb=f+16|0;d=(h|0)==(j|0);if(!d){oS(i)}a:{if(!d){break a}if(!rS(g+872|0)){break a}if(!Rb(b,dd(qS(g+872|0),mb))){break a}b:{if(!c){break b}Id(a,512);v[a+480228>>2]=32;u[a+480188>>1]=16;v[a+480196>>2]=w[g+947|0];v[a+480200>>2]=256;v[a+480204>>2]=8e5;d=g+96|0;f=Ub(d,4498);Gb(a+1304436|0,f);yb(f);f=Ub(d,5086);Gb(a+1304448|0,f);yb(f);v[a+1304496>>2]=4;f=g+24|0;pS(f,2,g+872|4);Ec(d,f);Gb(a+1304400|0,d);yb(d);while(1){d=(e<<5)+a|0;f=d+480280|0;Dg(f);h=f;f=(g+872|0)+e|0;v[h>>2]=!w[f+50|0]<<10;u[d+480284>>1]=(w[f+76|0]<<4|8)&248;e=e+1|0;if((e|0)!=16){continue}break}if(w[g+968|0]|w[g+969|0]<<8){Vy(a+1304424|0,b,w[g+968|0]|w[g+969|0]<<8,132,0)}e=0;f=jb-16|0;jb=f;d=jb-16|0;jb=d;h=f+8|0;i=g+96|0;fc(h,i,771);jb=d+16|0;j=Hb(h);d=b;h=mc(d,$b(f,h));if((j|0)==(h|0)){_b(d,Hb(f+8|0))}jb=f+16|0;d=(h|0)==(j|0);if(!d){f=jb-16|0;jb=f;Qb(i,0,771);jb=f+16|0}if(!d){break a}d=a+484360|0;hA(Vb(d),g+96|0,w[g+353|0],255,254);Ne(Vb(d),w[g+354|0]);Nc(b,w[g+919|0]|w[g+920|0]<<8);h=a+484344|0;o=c&1;c:{d:{while(1){d=(k<<1)+g|0;if(w[d+355|0]|w[d+356|0]<<8){td(g+24|0,b,w[d+355|0]|w[d+356|0]<<8);d=w[d+355|0]|w[d+356|0]<<8;f=(d-2|0)/64|0;e:{if(!o){break e}v[113382]=0;e=W(364,h|0,k&65535,f|0)|0;i=v[113382];v[113382]=0;if((i|0)==1){break d}if(!e){break e}v[113382]=0;i=T(409,g+24|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break d}v[113382]=0;Q(304,g+24|0,1)|0;e=v[113382];v[113382]=0;if((e|0)==1){break d}if(d>>>0>=66){p=f>>>0>1?f:1;j=0;while(1){d=Zb(h,k);v[113382]=0;q=Q(458,d|0,j|0)|0;d=v[113382];v[113382]=0;l=0;if((d|0)==1){break d}while(1){v[113382]=0;R(557,g+80|0,g+24|0);d=v[113382];v[113382]=0;f:{g:{h:{if((d|0)!=1){d=q+B(l,6)|0;e=g+80|0;r=Zc(e);n=Cf(e);m=Ph(e);e=w[e|0];if((e-1&255)>>>0>71){break h}t[d|0]=e+36;t[d+1|0]=w[r|0]+1;break g}break d}if(!(w[d|0]|w[n|0])){break f}}t[d+2|0]=1;s=d,z=(Ed(w[n|0],1,16)<<2)-4|0,t[s+4|0]=z}e=w[m|0]&15;t[d+5|0]=e;i:{j:{switch((w[m|0]>>>4|0)-3|0){case 0:t[d+5|0]=e<<2;break i;case 1:t[d+5|0]=(6/(e+1>>>0)|0)+1;break i;case 3:case 4:t[d+5|0]=e<<3;break i;case 7:t[d+4|0]=(e<<2)+4;t[d+2|0]=1;break i;case 8:t[d+5|0]=e|128;break i;case 9:break j;default:break i}}t[d+5|0]=(6/(e+1>>>0)|0)+1|13}t[d+3|0]=w[(w[m|0]>>>4|0)+23648|0];l=l+1|0;if((l|0)!=16){continue}break}j=j+1|0;if((p|0)!=(j|0)){continue}break}}d=Zb(h,k);v[113382]=0;e=W(459,g+80|0,14,0)|0;j=v[113382];v[113382]=0;if((j|0)==1){break d}e=Rh(Me(e,i?f-2>>>0>i>>>0?i+1|0:-1:-1));v[113382]=0;Q(460,d|0,e|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break d}}Bb(g+24|0)}k=k+1|0;if((k|0)!=256){continue}break}e=1;if(!(c&2)){break a}jT(b,g+72|0);e=0;while(1){k:{l:{if(!(w[g+72+(e>>>3)|0]>>>(e&7)&1)){e=e+1|0;break l}if(!gA(b,g+24|0)){break b}e=e+1|0;u[a+480190>>1]=e;c=g+8|0;Cg(c,1,g+24|0);d=g+80|0;Ec(d,c);c=x[a+480190>>1];v[113382]=0;Q(335,((c<<5)+a|0)+946304|0,d|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break k}k=g+80|0;yb(k);f=(B(e,104)+a|0)+484380|0;c=f;sd(f,0);d=g+24|0;h=d;v[f>>2]=w[d+32|0]|w[d+33|0]<<8|(w[d+34|0]<<16|w[d+35|0]<<24);v[f+4>>2]=w[d+38|0]|w[d+39|0]<<8|(w[d+40|0]<<16|w[d+41|0]<<24);i=w[d+42|0]|w[d+43|0]<<8|(w[d+44|0]<<16|w[d+45|0]<<24);v[f+24>>2]=16726;v[f+8>>2]=i;u[f+30>>1]=w[d+37|0]<<4;if(t[d+46|0]&1){v[c>>2]=v[c>>2]>>>1;v[c+4>>2]=v[c+4>>2]>>>1;v[c+8>>2]=v[c+8>>2]>>>1}if(!(!(w[h+47|0]&8)|y[c+8>>2]<=y[c+4>>2])){u[c+34>>1]=x[c+34>>1]|2}Yc(k,t[d+46|0]&1?16:8,1,0,0);zg(k,f,b)}if((e|0)!=64){continue}break b}break}e=P()|0;O()|0;yb(g+80|0);break c}e=P()|0;O()|0;Bb(g+24|0)}S(e|0);L()}e=1}jb=g+976|0;return e|0}function je(a,b){var c=C(0),d=0,e=0,f=C(0),g=0,h=0,i=C(0),k=0,m=C(0),n=C(0),o=0,r=0,s=C(0),t=C(0),u=C(0);i=C(1);a:{b:{c:{k=(p(b),j(2));d=k&2147483647;d:{if(!d){break d}h=(p(a),j(2));if((h|0)==1065353216){break d}e=h&2147483647;c=C(a+b);if(!(d>>>0<2139095041&e>>>0<=2139095040)){break a}e:{f:{if((h|0)>=0){break f}o=2;if(d>>>0>1266679807){break e}if(d>>>0<1065353216){break f}g=150-(d>>>23|0)|0;r=d>>>g|0;o=0;if((d|0)!=r<<g){break e}o=2-(r&1)|0;break e}o=0}g=o;g:{if((d|0)!=1065353216){if((d|0)!=2139095040){break g}if((e|0)==1065353216){break d}c=(k|0)>=0?b:C(0);if(e>>>0>=1065353217){break a}c=(k|0)>=0?C(0):C(-b);break a}c=(k|0)>=0?a:C(C(1)/a);break a}c=C(a*a);if((k|0)==1073741824){break a}c=C(K(a));if(!((k|0)!=1056964608|(h|0)<0)){break a}f=C(D(a));if(!(e?(h&1073741823)!=1065353216:0)){i=(k|0)<0?C(C(1)/f):f;if((h|0)>=0){break d}if(!(g|e-1065353216)){a=C(i-i);c=C(a/a);break a}c=(g|0)==1?C(-i):i;break a}h:{if((h|0)>=0){break h}i:{switch(g|0){case 0:a=C(a-a);c=C(a/a);break a;case 1:break i;default:break h}}i=C(-1)}j:{if(d>>>0>=1291845633){c=(k|0)<0?C(C(i*C(1.0000000150474662e30))*C(1.0000000150474662e30)):C(C(i*C(1.0000000031710769e-30))*C(1.0000000031710769e-30));if(e>>>0<=1065353207){break a}c=(k|0)>0?C(C(i*C(1.0000000150474662e30))*C(1.0000000150474662e30)):C(C(i*C(1.0000000031710769e-30))*C(1.0000000031710769e-30));if(e>>>0>=1065353224){break a}a=C(f+C(-1));c=C(C(a*C(7052607543300837e-21))+C(C(C(a*a)*C(C(.5)-C(a*C(C(a*C(-.25))+C(.3333333432674408)))))*C(-1.4426950216293335)));f=c;a=C(a*C(1.44268798828125));c=(l(2,(p(C(c+a)),j(2))&-4096),q());f=C(f-C(c-a));break j}d=e>>>0<8388608;e=d?(p(C(f*C(16777216))),j(2)):e;h=e&8388607;g=h|1065353216;d=(e>>23)+(d?-151:-127)|0;e=0;k:{if(h>>>0<1885298){break k}if(h>>>0<6140887){e=1;break k}g=h|1056964608;d=d+1|0}h=e<<2;a=z[h+51920>>2];n=(l(2,g),q());m=C(C(1)/C(a+n));s=C(n-a);f=C(s*m);c=(l(2,(p(f),j(2))&-4096),q());t=C(c*c);u=m;m=(l(2,((g>>>1&536866816)+(e<<21)|0)+541065216|0),q());n=C(u*C(C(s-C(m*c))-C(C(n-C(m-a))*c)));a=C(f*f);m=C(C(n*C(f+c))+C(C(a*a)*C(C(a*C(C(a*C(C(a*C(C(a*C(C(a*C(.20697501301765442))+C(.23066075146198273)))+C(.2727281153202057)))+C(.3333333432674408)))+C(.4285714328289032)))+C(.6000000238418579))));a=(l(2,(p(C(C(t+C(3))+m)),j(2))&-4096),q());f=C(C(n*a)+C(f*C(m-C(C(a+C(-3))-t))));c=C(c*a);a=(l(2,(p(C(f+c)),j(2))&-4096),q());n=z[h+51936>>2];f=C(z[h+51928>>2]+C(C(C(f-C(a-c))*C(.9617967009544373))+C(a*C(-.00011736857413779944))));a=C(a*C(.9619140625));m=C(d|0);c=(l(2,(p(C(C(n+C(f+a))+m)),j(2))&-4096),q());f=C(f-C(C(C(c-m)-n)-a))}n=(l(2,k&-4096),q());a=C(c*n);b=C(C(f*b)+C(C(b-n)*c));c=C(a+b);g=(p(c),j(2));if((g|0)>=1124073473){break c}e=1124073472;l:{m:{if((g|0)==1124073472){if(!(C(b+C(4.299566569443414e-8))>C(c-a))){break m}break c}e=g&2147483647;if(!(!(b<=C(c-a))|(g|0)!=-1021968384)|e>>>0>=1125515265){break b}d=0;if(e>>>0<1056964609){break l}}k=(8388608>>>(e>>>23|0)-126|0)+g|0;e=k>>>23&255;d=(k&8388607|8388608)>>>150-e|0;d=(g|0)<0?0-d|0:d;a=C(a-(l(2,k&-8388608>>e-127),q()));g=(p(C(b+a)),j(2))}c=(l(2,g&-32768),q());f=C(c*C(.693145751953125));c=C(C(c*C(14286065379565116e-22))+C(C(b-C(c-a))*C(.6931471824645996)));a=C(f+c);b=C(a*a);b=C(a-C(b*C(C(b*C(C(b*C(C(b*C(C(b*C(4.138136944220605e-8))+C(-16533901998627698e-22)))+C(661375597701408e-19)))+C(-.0027777778450399637)))+C(.1666666716337204))));m=C(C(a*b)/C(b+C(-2)));b=C(c-C(a-f));a=C(C(a-C(m-C(b+C(a*b))))+C(1));g=(p(a),j(2))+(d<<23)|0;n:{if((g|0)<=8388607){a=lG(a,d);break n}a=(l(2,g),q())}i=C(i*a)}c=i;break a}c=C(C(i*C(1.0000000150474662e30))*C(1.0000000150474662e30));break a}c=C(C(i*C(1.0000000031710769e-30))*C(1.0000000031710769e-30))}return c}function Y_(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0;h=jb-32|0;jb=h;v[h+24>>2]=b;v[e>>2]=0;i=h+8|0;Ac(i,d);v[113382]=0;i=T(21,i|0)|0;j=v[113382];v[113382]=0;a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{v:{w:{x:{y:{z:{A:{if((j|0)!=1){Ob(h+8|0);switch(g-65|0){case 54:break j;case 19:break k;case 18:break l;case 17:break m;case 49:break n;case 47:break o;case 45:case 51:break p;case 12:break q;case 44:break r;case 41:break s;case 8:break t;case 7:break u;case 5:break v;case 3:break w;case 35:case 36:break x;case 34:break y;case 1:case 33:case 39:break z;case 0:case 32:break A;case 2:case 4:case 6:case 9:case 10:case 11:case 13:case 14:case 15:case 16:case 20:case 21:case 22:case 25:case 26:case 27:case 28:case 29:case 30:case 31:case 37:case 38:case 40:case 42:case 43:case 46:case 48:case 50:case 52:case 53:break d;case 24:break f;case 56:break g;case 23:break h;case 55:break i;default:break e}}a=P()|0;O()|0;Ob(h+8|0);S(a|0);L()}pF(a,f+24|0,h+24|0,c,e,i);break b}oF(a,f+16|0,h+24|0,c,e,i);break b}g=a;a=nb[v[v[a+8>>2]+12>>2]](a+8|0)|0;k=h,l=ej(g,b,c,d,e,f,Tb(a),Tb(a)+Db(a)|0),v[k+24>>2]=l;break b}a=e;b=bi(h+24|0,c,a,i,2);c=v[a>>2];B:{if(!(c&4|(b|0)<=0|(b|0)>31)){v[f+12>>2]=b;break B}v[a>>2]=c|4}break b}v[h+8>>2]=623865125;v[h+12>>2]=2032480100;k=h,l=ej(a,b,c,d,e,f,h+8|0,h+16|0),v[k+24>>2]=l;break b}v[h+8>>2]=623728933;v[h+12>>2]=1680158061;k=h,l=ej(a,b,c,d,e,f,h+8|0,h+16|0),v[k+24>>2]=l;break b}a=e;b=bi(h+24|0,c,a,i,2);c=v[a>>2];C:{if(!(c&4|(b|0)>23)){v[f+8>>2]=b;break C}v[a>>2]=c|4}break b}a=e;b=bi(h+24|0,c,a,i,2);c=v[a>>2];D:{if(!(c&4|(b|0)<=0|(b|0)>12)){v[f+8>>2]=b;break D}v[a>>2]=c|4}break b}a=e;b=bi(h+24|0,c,a,i,3);c=v[a>>2];E:{if(!(c&4|(b|0)>365)){v[f+28>>2]=b;break E}v[a>>2]=c|4}break b}a=e;b=bi(h+24|0,c,a,i,2);c=v[a>>2];F:{if(!(c&4|(b|0)>12)){v[f+16>>2]=b-1;break F}v[a>>2]=c|4}break b}a=e;b=bi(h+24|0,c,a,i,2);c=v[a>>2];G:{if(!(c&4|(b|0)>59)){v[f+4>>2]=b;break G}v[a>>2]=c|4}break b}a=h+24|0;b=jb-16|0;jb=b;v[b+8>>2]=c;while(1){H:{if(!wo(a,b+8|0)){break H}if(!Lg(i,8192,ck(a))){break H}fl(a);continue}break}if(gj(a,b+8|0)){v[e>>2]=v[e>>2]|2}jb=b+16|0;break b}b=h+24|0;a=nb[v[v[a+8>>2]+8>>2]](a+8|0)|0;I:{if((Db(a)|0)==(0-Db(a+12|0)|0)){v[e>>2]=v[e>>2]|4;break I}a=vr(b,c,a,a+24|0,i,e,0)-a|0;b=v[f+8>>2];if(!(a|(b|0)!=12)){v[f+8>>2]=0;break I}if(!((a|0)!=12|(b|0)>11)){v[f+8>>2]=b+12}}break b}g=w[59300]|w[59301]<<8|(w[59302]<<16|w[59303]<<24);t[h+15|0]=g;t[h+16|0]=g>>>8;t[h+17|0]=g>>>16;t[h+18|0]=g>>>24;g=w[59297]|w[59298]<<8|(w[59299]<<16|w[59300]<<24);v[h+8>>2]=w[59293]|w[59294]<<8|(w[59295]<<16|w[59296]<<24);v[h+12>>2]=g;k=h,l=ej(a,b,c,d,e,f,h+8|0,h+19|0),v[k+24>>2]=l;break b}t[h+12|0]=w[59308];v[h+8>>2]=w[59304]|w[59305]<<8|(w[59306]<<16|w[59307]<<24);k=h,l=ej(a,b,c,d,e,f,h+8|0,h+13|0),v[k+24>>2]=l;break b}a=e;b=bi(h+24|0,c,a,i,2);c=v[a>>2];J:{if(!(c&4|(b|0)>60)){v[f>>2]=b;break J}v[a>>2]=c|4}break b}v[h+8>>2]=624576549;v[h+12>>2]=1394948685;k=h,l=ej(a,b,c,d,e,f,h+8|0,h+16|0),v[k+24>>2]=l;break b}a=e;b=bi(h+24|0,c,a,i,1);c=v[a>>2];K:{if(!(c&4|(b|0)>6)){v[f+24>>2]=b;break K}v[a>>2]=c|4}break b}a=nb[v[v[a>>2]+20>>2]](a,b,c,d,e,f)|0;break a}g=a;a=nb[v[v[a+8>>2]+24>>2]](a+8|0)|0;k=h,l=ej(g,b,c,d,e,f,Tb(a),Tb(a)+Db(a)|0),v[k+24>>2]=l;break b}nF(f+20|0,h+24|0,c,e,i);break b}a=bi(h+24|0,c,e,i,4);if(!(w[e|0]&4)){v[f+20>>2]=a-1900}break b}if((g|0)==37){break c}}v[e>>2]=v[e>>2]|4;break b}a=jb-16|0;jb=a;v[a+8>>2]=c;b=6;c=h+24|0;L:{M:{if(gj(c,a+8|0)){break M}b=4;if((ym(i,ck(c))|0)!=37){break M}b=2;if(!gj(fl(c),a+8|0)){break L}}v[e>>2]=v[e>>2]|b}jb=a+16|0}a=v[h+24>>2]}jb=h+32|0;return a|0}function YH(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;var e=0,f=0,g=0,h=0;e=jb-256|0;jb=e;A[e+248>>3]=c;a:{if(nj(b)){break a}f=w[gk(b)|0];if((f|0)==33){d=1}else{if((f|0)!=63){break a}d=0}rk(e+216|0,b,v[b+4>>2]-1|0);f=v[e+220>>2];v[b>>2]=v[e+216>>2];v[b+4>>2]=f}f=e+216|0;Ad(f);g=v[e+216>>2];Ad(e+200|0);h=fk(g,v[e+204>>2],b);Ad(f);f=v[b>>2];g=v[b+4>>2];b:{c:{d:{e:{f:{g:{h:{i:{if((h|0)==v[e+220>>2]){v[e+240>>2]=f;v[e+244>>2]=g;a=qc(e+232|0,17540);f=v[e+244>>2];v[e+16>>2]=v[e+240>>2];v[e+20>>2]=f;f=v[a+4>>2];v[e+8>>2]=v[a>>2];v[e+12>>2]=f;if(Hc(e+16|0,e+8|0)){a=ba(8)|0;v[113382]=0;R(2113,e+200|0,e+248|0);b=v[113382];v[113382]=0;if((b|0)!=1){v[113382]=0;U(2088,e+216|0,13642,e+200|0);b=v[113382];v[113382]=0;if((b|0)==1){break g}nc(a,e+216|0);v[113382]=0;U(1978,a|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break b}b=P()|0;O()|0;yb(e+216|0);yb(e+200|0);break c}b=P()|0;O()|0;break d}if(!d){break i}d=ba(8)|0;v[113382]=0;f=Q(2111,e+168|0,b|0)|0;a=v[113382];v[113382]=0;j:{k:{l:{m:{n:{o:{p:{q:{if((a|0)!=1){v[113382]=0;U(2088,e+184|0,13678,f|0);a=v[113382];v[113382]=0;if((a|0)==1){break q}v[113382]=0;U(2106,e+200|0,e+184|0,13652);b=v[113382];v[113382]=0;a=1;if((b|0)==1){break p}v[113382]=0;R(2113,e+152|0,e+248|0);a=v[113382];v[113382]=0;if((a|0)==1){break o}v[113382]=0;U(137,e+216|0,e+200|0,e+152|0);b=v[113382];v[113382]=0;a=1;if((b|0)==1){break n}nc(d,e+216|0);v[113382]=0;U(1978,d|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break b}b=P()|0;O()|0;yb(e+216|0);a=0;break m}b=P()|0;O()|0;break j}b=P()|0;O()|0;yb(f);break j}b=P()|0;O()|0;break k}b=P()|0;a=1;O()|0;break l}b=P()|0;O()|0}yb(e+152|0)}yb(e+200|0)}yb(e+184|0);yb(f);if(!a){break c}}ca(d|0);break c}v[e+144>>2]=f;v[e+148>>2]=g;d=qc(e+136|0,17540);f=v[e+148>>2];v[e+80>>2]=v[e+144>>2];v[e+84>>2]=f;f=v[d+4>>2];v[e+72>>2]=v[d>>2];v[e+76>>2]=f;if(Hc(e+80|0,e+72|0)){a=ba(8)|0;v[113382]=0;R(2113,e+200|0,e+248|0);b=v[113382];v[113382]=0;if((b|0)!=1){v[113382]=0;U(2088,e+216|0,13642,e+200|0);b=v[113382];v[113382]=0;if((b|0)==1){break f}nc(a,e+216|0);v[113382]=0;U(1978,a|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break b}b=P()|0;O()|0;yb(e+216|0);yb(e+200|0);break c}b=P()|0;O()|0;break e}d=v[b+4>>2];v[e+128>>2]=v[b>>2];v[e+132>>2]=d;d=qc(e+120|0,3991);f=v[e+132>>2];v[e+64>>2]=v[e+128>>2];v[e+68>>2]=f;f=v[d+4>>2];v[e+56>>2]=v[d>>2];v[e+60>>2]=f;if(Hc(e- -64|0,e+56|0)){if(!w[a+28|0]){break i}if(!(!(c<=0)&c<=4)){a=ba(8)|0;v[113382]=0;d=Q(121,e+216|0,4086)|0;b=v[113382];v[113382]=0;if((b|0)==1){break h}nc(a,d);v[113382]=0;U(1978,a|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break b}b=P()|0;O()|0;yb(d);break c}b=zk(65536/c);a=a+24|0;v[v[a>>2]+480244>>2]=b;Wo(v[a>>2]);break i}d=v[b+4>>2];v[e+112>>2]=v[b>>2];v[e+116>>2]=d;d=qc(e+104|0,4043);f=v[e+116>>2];v[e+48>>2]=v[e+112>>2];v[e+52>>2]=f;f=v[d+4>>2];v[e+40>>2]=v[d>>2];v[e+44>>2]=f;if(Hc(e+48|0,e+40|0)){if(!w[a+28|0]){break i}if(!(!(c<=0)&c<=4)){a=ba(8)|0;v[113382]=0;d=Q(121,e+216|0,4107)|0;b=v[113382];v[113382]=0;if((b|0)!=1){nc(a,d);v[113382]=0;U(1978,a|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break b}b=P()|0;O()|0;yb(d);break c}b=P()|0;O()|0;ca(a|0);break c}b=zk(c*65536);a=a+24|0;v[v[a>>2]+480240>>2]=b;Wo(v[a>>2]);break i}d=v[b+4>>2];v[e+96>>2]=v[b>>2];v[e+100>>2]=d;b=qc(e+88|0,4061);d=v[e+100>>2];v[e+32>>2]=v[e+96>>2];v[e+36>>2]=d;d=v[b+4>>2];v[e+24>>2]=v[b>>2];v[e+28>>2]=d;if(!Hc(e+32|0,e+24|0)){break i}b=jn(c*65536);v[v[a+24>>2]+480236>>2]=b}jb=e+256|0;return}b=P()|0;O()|0;ca(a|0);break c}b=P()|0;O()|0;yb(e+200|0);break d}b=P()|0;O()|0;yb(e+200|0)}ca(a|0);break c}ca(a|0)}S(b|0)}L()}function bM(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;h=jb-16|0;jb=h;e=c&15;f=B(b,896)+a|0;d=f+1074984|0;a:{b:{switch((c&240)-16>>>4|0){case 0:a=f+1075072|0;v[a>>2]=v[a>>2]&-1048577|((e|0)!=0)<<20;break a;case 1:if(!(w[a+480209|0]&16)){break a}if(v[a+480180>>2]==33554432){c=B(b,896)+a|0;d=c+1075684|0;if(!v[d>>2]){break a}c=v[c+1075088>>2];if(!c){break a}f=B(b,896)+a|0;e=x[B(e,24)+26256>>1];b=v[c+24>>2];g=qma(b,b>>31,1712,0);c=(e>>>1|0)+g|0;b=mb;b=zc(rma(c,c>>>0<g>>>0?b+1|0:b,e,0),mb);v[f+1075688>>2]=b;k=d,l=eg(a,w[f+1075803|0],0,b),v[k>>2]=l;break a}if(v[a+480180>>2]!=64){b=B(b,896)+a|0;c=e<<28>>24;v[b+1075752>>2]=c;e=x[(e<<1)+26688>>1];v[b+1075688>>2]=e;d=b+1075684|0;if(!v[d>>2]){break a}k=d,l=eg(a,w[b+1075803|0],c,e),v[k>>2]=l;break a}a=B(b,896)+a|0;b=v[a+1075088>>2];if(!b){break a}v[a+1075688>>2]=v[b+24>>2]+B(e,80);break a;case 2:if(v[a+480180>>2]==2){t[(B(b,896)+a|0)+1075826|0]=c&3;break a}d=h+8|0;Fb(d,a+1074312|0,21);if(Cb(d)){t[(B(b,896)+a|0)+1075826|0]=e>>>0<4?e:0;break a}t[(B(b,896)+a|0)+1075826|0]=c&7;break a;case 3:if(v[a+480180>>2]==2){t[(B(b,896)+a|0)+1075829|0]=c&3;break a}d=h+8|0;Fb(d,a+1074312|0,21);if(Cb(d)){t[(B(b,896)+a|0)+1075829|0]=e>>>0<4?e:0;break a}t[(B(b,896)+a|0)+1075829|0]=c&7;break a;case 4:d=h+8|0;Fb(d,a+1074312|0,21);if(Cb(d)){a=B(b,896)+a|0;t[a+1075825|0]=0;t[a+1075832|0]=e>>>0<4?e:0;break a}t[(B(b,896)+a|0)+1075832|0]=c&7;break a;case 5:if(v[a+1074392>>2]|!(w[a+480209|0]&16)){break a}a=a+1074400|0;v[a>>2]=v[a>>2]+e;break a;case 6:if(!(w[a+480209|0]&16)){break a}if(e>>>0<=2){e=x[a+480188>>1];if(e>>>0>255){break a}d=a+1304392|0;i=b+1|0;j=(c&15)-1|0;while(1){c=B(e,896)+a|0;c:{if((i|0)!=x[c+1075792>>1]){break c}d:{e:{switch(j|0){case 0:$m(a,c+1074984|0);if(!(w[c+1075073|0]&2)){break d}if(!qd(d)){break d}uk(v[d>>2],e&65535);break d;case 1:g=c+1075072|0;f=v[g>>2];v[g>>2]=f|4096;if(!(f&512)){break d}if(!qd(d)){break d}uk(v[d>>2],e&65535);break d;default:break e}}v[c+1075680>>2]=0;g=c+1075072|0;f=v[g>>2];v[g>>2]=f|4096;if(!(f&512)){break d}if(!qd(d)){break d}yi(v[d>>2],e&65535,1)}f=v[c+1075640>>2];if(!f){break c}g=w[f+34|0];if(!g){break c}g=v[(B(g,160)+a|0)+906140>>2];if(!g){break c}nb[v[v[g>>2]+88>>2]](g,f,w[c+1075803|0]+255|0,0,b)}e=e+1|0;if((e&65535)!=256){continue}break}break a}ZN(d,e,a);break a;case 7:if(!(w[a+480209|0]&16)){break a}Al(a,d,e,4);break a;case 8:b=v[a+480208>>2];f:{if(!(b&4096)){break f}g:{switch(e&15){case 0:v[d+88>>2]=v[d+88>>2]&-257;break f;case 1:v[d+692>>2]=128;v[d+88>>2]=v[d+88>>2]|256;break f;case 8:v[d+88>>2]=v[d+88>>2]&-25165825|16777216;break f;case 9:v[d+88>>2]=v[d+88>>2]&-25165825|8388608;break f;case 10:v[a+480208>>2]=b&-16385;break f;case 11:v[a+480208>>2]=b|16384;break f;case 12:v[a+480208>>2]=b&-8193;break f;case 13:v[a+480208>>2]=b|8192;break f;case 14:v[d+88>>2]=v[d+88>>2]&-129;break f;case 15:break g;default:break f}}h:{if(!v[d+76>>2]|(v[d>>2]|v[d+4>>2])){break h}if(!(k=Wf(d+810|0),l=1,m=w[d+88|0]&2,m?k:l)){break h}a=d;b=v[a+76>>2]-1|0;v[a>>2]=-1;v[a+4>>2]=b}v[d+88>>2]=v[d+88>>2]|128}break a;case 9:if(!(w[a+480209|0]&16)){break a}c=B(b,896)+a|0;t[c+1075840|0]=e;f=h+8|0;Fb(f,a+1074312|0,35);if(Cb(f)){break a}if(!Wf(c+1075794|0)){break a}b=v[(B(b,896)+a|0)+1075060>>2];a=e<<16;if(b>>>0<=a>>>0){break a}v[d+4>>2]=a;break a;case 11:i:{if(e){break i}e=1;if(v[a+480180>>2]&16777248){break i}e=0;if(v[a+480180>>2]==2){break a}}d=h+8|0;Fb(d,a+1074312|0,30);c=a;if(Cb(d)){a=1}else{a=v[a+480180>>2]==2}my(c,b,e,a);break a;case 14:break b;default:break a}}if(v[a+480180>>2]==2){break a}t[(B(b,896)+a|0)+1075848|0]=e}jb=h+16|0}function k2(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=jb-352|0;jb=d;a:{if(nj(b)){break a}e=w[gk(b)|0];if((e|0)==33){c=1}else{if((e|0)!=63){break a}c=0}rk(d+320|0,b,v[b+4>>2]-1|0);e=v[d+324>>2];v[b>>2]=v[d+320>>2];v[b+4>>2]=e}f=d+320|0;Ad(f);e=v[d+320>>2];Ad(d+304|0);e=fk(e,v[d+308>>2],b);Ad(f);b:{c:{d:{e:{f:{g:{if((e|0)==v[d+324>>2]){a=v[b+4>>2];v[d+344>>2]=v[b>>2];v[d+348>>2]=a;a=qc(d+336|0,17540);e=v[d+348>>2];v[d+8>>2]=v[d+344>>2];v[d+12>>2]=e;e=v[a+4>>2];v[d>>2]=v[a>>2];v[d+4>>2]=e;if(Hc(d+8|0,d)){a=ba(8)|0;v[113382]=0;c=Q(121,d+320|0,6570)|0;b=v[113382];v[113382]=0;if((b|0)==1){break f}nc(a,c);v[113382]=0;U(1978,a|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break b}b=P()|0;O()|0;yb(c);break c}e=0;if(!c){break g}a=ba(8)|0;v[113382]=0;c=Q(2111,d+304|0,b|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){v[113382]=0;U(2088,d+320|0,13678,c|0);b=v[113382];v[113382]=0;if((b|0)==1){break e}nc(a,d+320|0);v[113382]=0;U(1978,a|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break b}b=P()|0;O()|0;yb(d+320|0);yb(c);break c}b=P()|0;O()|0;break d}if(v[e+4>>2]){a=ba(8)|0;v[113382]=0;c=Q(121,d+320|0,7618)|0;b=v[113382];v[113382]=0;if((b|0)!=1){nc(a,c);v[113382]=0;U(1978,a|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break b}b=P()|0;O()|0;yb(c);break c}b=P()|0;O()|0;ca(a|0);break c}c=v[b+4>>2];v[d+296>>2]=v[b>>2];v[d+300>>2]=c;c=qc(d+288|0,17540);e=v[d+300>>2];v[d+152>>2]=v[d+296>>2];v[d+156>>2]=e;e=v[c+4>>2];v[d+144>>2]=v[c>>2];v[d+148>>2]=e;if(Hc(d+152|0,d+144|0)){a=ba(8)|0;v[113382]=0;c=Q(121,d+320|0,6570)|0;b=v[113382];v[113382]=0;if((b|0)!=1){nc(a,c);v[113382]=0;U(1978,a|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break b}b=P()|0;O()|0;yb(c);break c}b=P()|0;O()|0;ca(a|0);break c}c=v[b+4>>2];v[d+280>>2]=v[b>>2];v[d+284>>2]=c;c=qc(d+272|0,3674);e=v[d+284>>2];v[d+136>>2]=v[d+280>>2];v[d+140>>2]=e;e=v[c+4>>2];v[d+128>>2]=v[c>>2];v[d+132>>2]=e;h:{if(!Hc(d+136|0,d+128|0)){c=v[b+4>>2];v[d+264>>2]=v[b>>2];v[d+268>>2]=c;c=qc(d+256|0,3656);e=v[d+268>>2];v[d+120>>2]=v[d+264>>2];v[d+124>>2]=e;e=v[c+4>>2];v[d+112>>2]=v[c>>2];v[d+116>>2]=e;if(!Hc(d+120|0,d+112|0)){break h}}e=w[a+60|0]!=0;break g}c=v[b+4>>2];v[d+248>>2]=v[b>>2];v[d+252>>2]=c;c=qc(d+240|0,3240);e=v[d+252>>2];v[d+104>>2]=v[d+248>>2];v[d+108>>2]=e;e=v[c+4>>2];v[d+96>>2]=v[c>>2];v[d+100>>2]=e;i:{if(!Hc(d+104|0,d+96|0)){c=v[b+4>>2];v[d+232>>2]=v[b>>2];v[d+236>>2]=c;c=qc(d+224|0,3221);e=v[d+236>>2];v[d+88>>2]=v[d+232>>2];v[d+92>>2]=e;e=v[c+4>>2];v[d+80>>2]=v[c>>2];v[d+84>>2]=e;if(!Hc(d+88|0,d+80|0)){break i}}e=w[a+61|0]!=0;break g}c=v[b+4>>2];v[d+216>>2]=v[b>>2];v[d+220>>2]=c;c=qc(d+208|0,3324);e=v[d+220>>2];v[d+72>>2]=v[d+216>>2];v[d+76>>2]=e;e=v[c+4>>2];v[d+64>>2]=v[c>>2];v[d+68>>2]=e;if(Hc(d+72|0,d- -64|0)){e=w[a+62|0]!=0;break g}c=v[b+4>>2];v[d+200>>2]=v[b>>2];v[d+204>>2]=c;c=qc(d+192|0,2484);e=v[d+204>>2];v[d+56>>2]=v[d+200>>2];v[d+60>>2]=e;e=v[c+4>>2];v[d+48>>2]=v[c>>2];v[d+52>>2]=e;if(Hc(d+56|0,d+48|0)){e=w[a+63|0]!=0;break g}c=v[b+4>>2];v[d+184>>2]=v[b>>2];v[d+188>>2]=c;c=qc(d+176|0,3723);e=v[d+188>>2];v[d+40>>2]=v[d+184>>2];v[d+44>>2]=e;e=v[c+4>>2];v[d+32>>2]=v[c>>2];v[d+36>>2]=e;if(Hc(d+40|0,d+32|0)){e=w[a+64|0]!=0;break g}c=v[b+4>>2];v[d+168>>2]=v[b>>2];v[d+172>>2]=c;b=qc(d+160|0,9389);c=v[d+172>>2];v[d+24>>2]=v[d+168>>2];v[d+28>>2]=c;c=v[b+4>>2];v[d+16>>2]=v[b>>2];v[d+20>>2]=c;e=0;if(!Hc(d+24|0,d+16|0)){break g}e=v[v[a+24>>2]+24668>>2]!=0}jb=d+352|0;return e|0}b=P()|0;O()|0;ca(a|0);break c}b=P()|0;O()|0;yb(c)}ca(a|0)}S(b|0)}L()}function vka(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;e=jb-272|0;jb=e;d=e+24|0;f=d;g=jb-48|0;jb=g;h=g+24|0;$z(h,b);v[113382]=0;R(666,g+8|0,h|0);b=v[113382];v[113382]=0;a:{b:{if((b|0)==1){break b}v[113382]=0;R(667,g+16|0,g+8|0);b=v[113382];v[113382]=0;if((b|0)==1){break b}b=g+16|0;h=v[b>>2];b=v[b+4>>2];v[113382]=0;W(668,f|0,h|0,b|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break b}Cc(g+24|0);jb=g+48|0;break a}a=P()|0;O()|0;Cc(g+24|0);S(a|0);L()}v[113382]=0;g=W(635,e+128|0,d|0,8)|0;b=v[113382];v[113382]=0;c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{v:{w:{x:{y:{z:{A:{B:{if((b|0)!=1){yb(e+24|0);if(c>>>0<2189){break i}v[113382]=0;b=Q(644,e+24|0,g|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break e}v[113382]=0;c=Q(645,e+8|0,6212)|0;d=v[113382];v[113382]=0;if((d|0)==1){break B}v[113382]=0;v[e>>2]=19469312;v[e+4>>2]=0;U(646,b|0,c|0,e|0);d=v[113382];v[113382]=0;if((d|0)==1){break A}Ib(c);v[113382]=0;t[e|0]=0;c=Q(645,e+8|0,7073)|0;d=v[113382];v[113382]=0;if((d|0)==1){break k}d=0;v[113382]=0;W(647,b|0,e|0,c|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break z}Ib(c);if(!w[e|0]){v[113382]=0;d=T(648,a|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break y}}f=v[a+4>>2];v[113382]=0;c=Q(645,e+8|0,11955)|0;h=v[113382];v[113382]=0;if((h|0)==1){break x}v[113382]=0;X(649,b|0,f|0,c|0,d|0);f=v[113382];v[113382]=0;if((f|0)==1){break w}Ib(c);v[113382]=0;c=Q(645,e+8|0,11717)|0;f=v[113382];v[113382]=0;if((f|0)==1){break v}v[113382]=0;X(650,b|0,a|0,c|0,d|0);d=v[113382];v[113382]=0;if((d|0)==1){break u}Ib(c);v[113382]=0;c=Q(645,e+8|0,11349)|0;d=v[113382];v[113382]=0;if((d|0)==1){break t}v[113382]=0;d=a+484360|0;aa(651,b|0,d|0,c|0,652)|0;f=v[113382];v[113382]=0;if((f|0)==1){break s}Ib(c);v[113382]=0;c=Q(645,e+8|0,23862)|0;f=v[113382];v[113382]=0;if((f|0)==1){break r}v[113382]=0;aa(653,b|0,a+484344|0,c|0,654)|0;f=v[113382];v[113382]=0;if((f|0)==1){break q}Ib(c);v[113382]=0;f=T(648,a|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break p}v[113382]=0;c=Q(645,e+8|0,23868)|0;h=v[113382];v[113382]=0;if((h|0)==1){break o}v[113382]=0;X(655,b|0,d|0,c|0,f|0);d=v[113382];v[113382]=0;if((d|0)==1){break n}Ib(c);if(v[b>>2]&1073741824){v[113382]=0;c=Q(2,e+8|0,12318)|0;d=v[113382];v[113382]=0;if((d|0)==1){break m}v[113382]=0;U(608,a|0,1,c|0);a=v[113382];v[113382]=0;if((a|0)==1){break l}yb(c)}Bg(b);break h}a=P()|0;O()|0;yb(e+24|0);break c}a=P()|0;O()|0;break j}a=P()|0;O()|0;Ib(c);break j}a=P()|0;O()|0;Ib(c);break j}a=P()|0;O()|0;break j}a=P()|0;O()|0;break j}a=P()|0;O()|0;Ib(c);break j}a=P()|0;O()|0;break j}a=P()|0;O()|0;Ib(c);break j}a=P()|0;O()|0;break j}a=P()|0;O()|0;Ib(c);break j}a=P()|0;O()|0;break j}a=P()|0;O()|0;Ib(c);break j}a=P()|0;O()|0;break j}a=P()|0;O()|0;break j}a=P()|0;O()|0;Ib(c);break j}a=P()|0;O()|0;break j}a=P()|0;O()|0;yb(c);break j}a=P()|0;O()|0}Bg(b);break d}b=bd(e+24|0);d=v[a+4>>2];v[113382]=0;f=T(648,a|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break g}v[113382]=0;d=aa(656,d|0,g|0,b|0,f|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break g}C:{if((d|0)!=1){v[113382]=0;c=Q(2,e+8|0,12624)|0;d=v[113382];v[113382]=0;D:{if((d|0)!=1){v[113382]=0;U(608,a|0,1,c|0);a=v[113382];v[113382]=0;if((a|0)==1){break D}yb(c);break C}a=P()|0;O()|0;break f}a=P()|0;O()|0;yb(c);break f}v[113382]=0;d=T(648,a|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break g}v[113382]=0;X(657,g|0,a|0,d|0,c>>>0<2188|0);a=v[113382];v[113382]=0;if((a|0)==1){break g}}yb(b)}Mf(g);jb=e+272|0;return}a=P()|0;O()|0}yb(b);break d}a=P()|0;O()|0}Mf(g)}S(a|0);L()}function qU(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=jb-576|0;jb=g;Ic(b);f=jb-16|0;jb=f;e=f+8|0;j=g+72|0;MB(e,j);h=Hb(e);d=b;e=mc(d,$b(f,e));if((h|0)==(e|0)){_b(d,Hb(f+8|0))}jb=f+16|0;d=(e|0)==(h|0);if(!d){NB(j)}a:{if(!d){break a}if(!SB(g+72|0)){break a}b:{if(!c){break b}if(!Rb(b,dd(RB(g+72|0),mb))){break a}Id(a,64);v[a+480260>>2]=112;v[a+480264>>2]=13696;v[a+480204>>2]=78e4;v[a+480196>>2]=4;u[a+480188>>1]=8;d=g+40|0;f=Ub(d,10348);Gb(a+1304436|0,f);yb(f);d=Ub(d,10381);Gb(a+1304448|0,d);yb(d);Kc(a+1304460|0,x[g+72>>1]==26217?10348:10376);v[a+1304496>>2]=4;d=w[g+182|0];u[a+480190>>1]=d;c:{d:{e:{if(d){f=1;j=1;while(1){h=jb-16|0;jb=h;d=jb-16|0;jb=d;i=h+8|0;e=g+40|0;fc(i,e,25);jb=d+16|0;k=Hb(i);d=b;i=mc(d,$b(h,i));if((k|0)==(i|0)){_b(d,Hb(h+8|0))}jb=h+16|0;if((i|0)!=(k|0)){d=jb-16|0;jb=d;t[e|0]=0;t[e+1|0]=0;t[e+2|0]=0;t[e+3|0]=0;t[e+4|0]=0;t[e+5|0]=0;t[e+6|0]=0;t[e+7|0]=0;t[e+24|0]=0;t[e+16|0]=0;t[e+17|0]=0;t[e+18|0]=0;t[e+19|0]=0;t[e+20|0]=0;t[e+21|0]=0;t[e+22|0]=0;t[e+23|0]=0;t[e+8|0]=0;t[e+9|0]=0;t[e+10|0]=0;t[e+11|0]=0;t[e+12|0]=0;t[e+13|0]=0;t[e+14|0]=0;t[e+15|0]=0;jb=d+16|0}if((w[g+53|0]|w[g+54|0]<<8|(w[g+55|0]<<16|w[g+56|0]<<24))>>>0>67108863){break a}e=(B(f,104)+a|0)+484380|0;sd(e,0);v[e+24>>2]=8363;h=g+40|0;d=h;v[e>>2]=w[d+13|0]|w[d+14|0]<<8|(w[d+15|0]<<16|w[d+16|0]<<24);v[e+4>>2]=w[d+17|0]|w[d+18|0]<<8|(w[d+19|0]<<16|w[d+20|0]<<24);d=w[d+21|0]|w[d+22|0]<<8|(w[d+23|0]<<16|w[d+24|0]<<24);d=d>>>0>y[e>>2]?v[e+4>>2]?d:0:d;v[e+8>>2]=d;if(d){u[e+34>>1]=2;kn(e)}d=g+8|0;uh(d,2,h);e=g+24|0;Ec(e,d);v[113382]=0;Q(335,((f<<5)+a|0)+946304|0,e|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break e}yb(g+24|0);j=j+1|0;f=j&65535;if(f>>>0<=x[a+480190>>1]){continue}break}}f=g+24|0;e=g+72|2;QB(f,3,e,36);d=g+40|0;Ec(d,f);Gb(a+1304400|0,d);yb(d);f=0;hO(a+1304424|0,Eb(e),108,36,0);d=a+484360|0;PB(Vb(d),g+185|0,128);if(x[rc(Vb(d),w[g+184|0])>>1]<w[g+183|0]){break d}break c}a=P()|0;O()|0;yb(g+24|0);S(a|0);L()}Ne(Vb(d),w[g+184|0])}while(1){d=(f<<5)+a|0;Dg(d+480280|0);u[d+480284>>1]=f&1?208:48;f=f+1|0;if((f|0)!=8){continue}break}h=a+484344|0;dg(h,w[g+183|0]);m=1;if(w[g+183|0]){n=c&1;e=0;while(1){f:{g:{if(n){if(Og(h,e&65535,64)){break g}}_b(b,1536);break f}v[g+24>>2]=-1;v[g+28>>2]=-1;k=0;while(1){f=Mn(Zb(h,e),k);j=0;while(1){i=g+40|0;iq(i,b);d=Zc(i);o=Cf(i);l=w[d|0];d=w[i|0];if(d>>>0<=253){t[f|0]=(d>>>2|0)+37;t[f+1|0]=(d<<4&48|l>>>4)+1;t[(g+24|0)+j|0]=255;d=w[i|0]}if((d|0)!=255){t[f+2|0]=1;t[f+4|0]=(((l&15)<<6|8)>>>0)/15}i=(g+24|0)+j|0;h:{i:{d=w[o|0];j:{if((d|0)!=255){t[i|0]=d;if(d&15|(d|0)==48){break j}break i}d=w[i|0];if((d|0)==255){break h}}l=d&15;t[f+5|0]=l;k:{if(d<<24>>24<0){break k}d=d>>>4|0;t[f+3|0]=w[d+23448|0];l:{switch(d-3|0){case 0:t[f+5|0]=l|32;break i;case 1:t[f+5|0]=B(l,17);break h;case 2:break i;case 3:break l;default:break h}}m:{switch(l|0){case 0:t[f+5|0]=79;break h;case 1:break m;default:break k}}t[f+5|0]=244;break h}t[f+3|0]=0;break h}t[i|0]=255}f=f+6|0;j=j+1|0;if((j|0)!=8){continue}break}k=k+1|0;if((k|0)!=64){continue}break}d=(g+72|0)+e|0;f=d;if(w[d+369|0]<63){sl(Zb(h,e),Rh(Me(Ln(g+40|0,14,0),w[f+369|0])))}sl(Zb(h,e),Rh(Ln(g+40|0,16,w[d+241|0])))}e=e+1|0;if(e>>>0<w[g+183|0]){continue}break}}if(!(c&2)){break a}f=1;c=Yc(g+40|0,8,1,0,1);if(!x[a+480190>>1]){break b}while(1){zg(c,(B(f&65535,104)+a|0)+484380|0,b);f=f+1|0;if(x[a+480190>>1]>=(f&65535)>>>0){continue}break}}m=1}jb=g+576|0;return m|0}function PR(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;f=jb-144|0;jb=f;i=jb-16|0;jb=i;j=i+8|0;e=jb-16|0;jb=e;v[113382]=0;k=f+128|0;h=k;T(689,h+4|0)|0;g=v[113382];v[113382]=0;a:{b:{c:{if((g|0)!=1){v[113382]=0;v[e+12>>2]=0;W(690,h+8|0,e+12|0,j|0)|0;j=v[113382];v[113382]=0;if((j|0)!=1){break c}break b}break b}m=h,n=jc(h),v[m>>2]=n;jb=e+16|0;break a}V(0)|0;O()|0;Ab();L()}jb=i+16|0;d:{e:{f:{if(d){v[113382]=0;U(674,a|0,k|0,c|0);c=v[113382];v[113382]=0;if((c|0)!=1){break f}break e}v[113382]=0;U(675,a|0,k|0,c|0);c=v[113382];v[113382]=0;if((c|0)==1){break e}}h=bw(f+112|0);if(x[b+480192>>1]){c=1;j=1;while(1){v[113382]=0;u[f+110>>1]=0;Q(676,a|0,f+110|0)|0;d=v[113382];v[113382]=0;g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{v:{w:{x:{y:{z:{A:{B:{C:{D:{E:{if((d|0)!=1){v[113382]=0;d=Q(677,k|0,f+110|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break j}v[f+104>>2]=d;i=((c<<2)+b|0)+900380|0;if(!v[i>>2]){break g}c=Ii(k);v[113382]=0;v[f+88>>2]=c;c=Q(678,f+104|0,f+88|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break E}if(!c){break k}v[113382]=0;c=T(679,f+104|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break D}v[113382]=0;c=Q(4,f+88|0,c+4|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break D}v[113382]=0;d=Q(2,f+72|0,12879)|0;e=v[113382];v[113382]=0;if((e|0)==1){break m}e=Kp(c,d);yb(d);if(e){break v}d=v[b+4>>2];v[113382]=0;d=Q(680,d|0,c|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break B}v[v[i>>2]+44>>2]=d;if(!v[v[i>>2]+44>>2]){break C}break h}b=P()|0;O()|0;break i}b=P()|0;O()|0;break i}b=P()|0;O()|0;break i}v[113382]=0;d=Q(2,f+72|0,9420)|0;e=v[113382];v[113382]=0;if((e|0)==1){break A}F:{G:{if(Kp(c,d)){yb(d);break G}v[113382]=0;e=Q(2,f+56|0,9631)|0;g=v[113382];v[113382]=0;if((g|0)==1){break z}g=Kp(c,e);yb(e);yb(d);if(!g){break F}}v[113382]=0;d=T(681,c|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break y}v[f+72>>2]=d;d=v[b+4>>2];Jp(f+48|0,f+72|0);v[113382]=0;d=Q(682,d|0,v[f+48>>2])|0;e=v[113382];v[113382]=0;if((e|0)==1){break x}gg(f+72|0);if(d){break h}}g=ac(h);l=bc(h);d=c;e=jb-16|0;jb=e;v[e>>2]=l;v[e+8>>2]=g;H:{if(!Jb(e+8|0,e)){break H}while(1){if(Kp(v[e+8>>2],d)){break H}g=e+8|0;vn(g);if(Jb(g,e)){continue}break}}jb=e+16|0;v[f+72>>2]=v[e+8>>2];m=f,n=bc(h),v[m+56>>2]=n;if(!ks(f+72|0,f+56|0)){break v}v[113382]=0;R(683,h|0,c|0);d=v[113382];v[113382]=0;if((d|0)!=1){break w}}b=P()|0;O()|0;break l}b=P()|0;O()|0;break l}b=P()|0;O()|0;yb(d);break l}b=P()|0;O()|0;break l}b=P()|0;O()|0;gg(f+72|0);break l}v[113382]=0;d=Q(2,f+16|0,13383)|0;e=v[113382];v[113382]=0;if((e|0)==1){break u}v[113382]=0;U(684,f+32|0,d|0,c|0);e=v[113382];v[113382]=0;if((e|0)==1){break t}v[113382]=0;e=Q(2,f|0,12367)|0;g=v[113382];v[113382]=0;if((g|0)==1){break s}v[113382]=0;U(3,f+56|0,f+32|0,e|0);g=v[113382];v[113382]=0;if((g|0)==1){break r}g=Sy(f+72|0,f+56|0);v[113382]=0;R(586,b|0,g|0);g=v[113382];v[113382]=0;if((g|0)==1){break q}yb(f+72|0);yb(f+56|0);yb(e);yb(f+32|0);yb(d)}v[v[i>>2]+44>>2]=0;break h}b=P()|0;O()|0;break l}b=P()|0;O()|0;break n}b=P()|0;O()|0;break o}b=P()|0;O()|0;break p}b=P()|0;O()|0;yb(f+72|0);yb(f+56|0)}yb(e)}yb(f+32|0)}yb(d);break l}b=P()|0;O()|0}yb(c);break i}if(!v[i>>2]){break g}v[v[i>>2]+44>>2]=0;break g}b=P()|0;O()|0}gl(h);break d}yb(c)}j=j+1|0;c=j&65535;if(c>>>0<=x[b+480192>>1]){continue}break}}gl(h);JR(k);jb=f+144|0;return}b=P()|0;O()|0}JR(k);S(b|0);L()}function bg(a,b,c,d,e,f,g,h,i){var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;k=jb-112|0;jb=k;l=h;o=i&2147483647;n=c-!b|0;j=b-1|0;p=(j|0)==-1&(n|0)==-1;r=d;q=(c|0)==(n|0)&b>>>0>j>>>0|c>>>0>n>>>0;m=d+q|0;n=e&2147483647;j=n;j=m>>>0<q>>>0?j+1|0:j;q=m-1|0;a:{b:{j=j-!m|0;if(!((q|0)==-1&(j|0)==2147418111?p:j>>>0>2147418111)){j=f;m=g-!j|0;j=j-1|0;p=(j|0)!=-1|(m|0)!=-1;q=(g|0)==(m|0)&f>>>0>j>>>0|g>>>0>m>>>0;m=q+l|0;j=o;j=m>>>0<q>>>0?j+1|0:j;q=m;m=m-1|0;j=j-!q|0;if((m|0)==-1&(j|0)==2147418111?p:(j|0)==2147418111&(m|0)!=-1|j>>>0<2147418111){break b}}if(!(!r&(n|0)==2147418112?!(b|c):n>>>0<2147418112)){h=d;i=e|32768;f=b;g=c;break a}if(!(!l&(o|0)==2147418112?!(f|g):o>>>0<2147418112)){i=i|32768;break a}if(!(b|r|(n^2147418112|c))){j=d;d=!(b^f|d^h|(c^g|e^i^-2147483648));h=d?0:j;i=d?2147450880:e;f=d?0:b;g=d?0:c;break a}if(!(f|l|(o^2147418112|g))){break a}if(!(b|r|(c|n))){if(f|l|(g|o)){break a}f=b&f;g=c&g;h=d&h;i=e&i;break a}if(f|l|(g|o)){break b}f=b;g=c;h=d;i=e;break a}j=(n|0)==(o|0);p=j&(l|0)==(r|0)?(c|0)==(g|0)&b>>>0<f>>>0|c>>>0<g>>>0:j&l>>>0>r>>>0|n>>>0<o>>>0;j=p;m=j?f:b;o=j?g:c;l=j?i:e;r=l;n=j?h:d;j=l&65535;i=p?e:i;e=i;h=p?d:h;q=i>>>16&32767;l=l>>>16&32767;if(!l){d=!(j|n);i=d<<6;l=E(d?m:n)+32|0;d=E(d?o:j);d=i+((d|0)==32?l:d)|0;ef(k+96|0,m,o,n,j,d-15|0);n=v[k+104>>2];m=v[k+96>>2];o=v[k+100>>2];l=16-d|0;j=v[k+108>>2]}f=p?b:f;g=p?c:g;i=e&65535;if(!q){b=!(h|i);c=b<<6;d=E(b?f:h)+32|0;b=E(b?g:i);b=c+((b|0)==32?d:b)|0;ef(k+80|0,f,g,h,i,b-15|0);q=16-b|0;h=v[k+88>>2];i=v[k+92>>2];g=v[k+84>>2];f=v[k+80>>2]}b=h;c=i<<3|b>>>29;h=b<<3|g>>>29;i=c|524288;b=n;d=j<<3|b>>>29;n=b<<3|o>>>29;p=d;s=e^r;b=f;j=g<<3|b>>>29;b=b<<3;c=j;d=l-q|0;e=b;c:{if(!d){break c}if(d>>>0>127){h=0;i=0;j=0;e=1;break c}ef(k- -64|0,b,c,h,i,128-d|0);kl(k+48|0,b,c,h,i,d);h=v[k+56>>2];i=v[k+60>>2];j=v[k+52>>2];e=v[k+48>>2]|((v[k+64>>2]|v[k+72>>2])!=0|(v[k+68>>2]|v[k+76>>2])!=0)}f=j;d=n;p=p|524288;b=m;j=o<<3|b>>>29;c=b<<3;d:{if((s|0)<0){o=e;b=c-e|0;n=h;m=d-h|0;e=(f|0)==(j|0)&c>>>0<e>>>0|f>>>0>j>>>0;h=m-e|0;c=j-((c>>>0<o>>>0)+f|0)|0;i=(p-((d>>>0<n>>>0)+i|0)|0)-(e>>>0>m>>>0)|0;if(!(b|h|(c|i))){f=0;g=0;h=0;i=0;break a}if(i>>>0>524287){break d}f=b;d=!(h|i);e=d<<6;g=E(d?b:h)+32|0;b=E(d?c:i);b=e+((b|0)==32?g:b)|0;b=b-12|0;ef(k+32|0,f,c,h,i,b);l=l-b|0;h=v[k+40>>2];i=v[k+44>>2];b=v[k+32>>2];c=v[k+36>>2];break d}b=c;g=b+e|0;c=f+j|0;c=b>>>0>g>>>0?c+1|0:c;b=g;g=(c|0)==(f|0)&e>>>0>b>>>0|c>>>0<f>>>0;e=d;f=d+h|0;d=i+p|0;d=e>>>0>f>>>0?d+1|0:d;e=g+f|0;h=e;i=e>>>0<f>>>0?d+1|0:d;if(!(i&1048576)){break d}b=b&1|((c&1)<<31|b>>>1);e=h;c=e<<31|c>>>1;l=l+1|0;h=(i&1)<<31|e>>>1;i=i>>>1|0}o=0;r=r&-2147483648;if((l|0)>=32767){h=o;i=r|2147418112;f=0;g=0;break a}e=0;e:{if((l|0)>0){e=l;break e}ef(k+16|0,b,c,h,i,l+127|0);kl(k,b,c,h,i,1-l|0);b=v[k>>2]|((v[k+16>>2]|v[k+24>>2])!=0|(v[k+20>>2]|v[k+28>>2])!=0);c=v[k+4>>2];h=v[k+8>>2];i=v[k+12>>2]}j=(c&7)<<29|b>>>3;l=b&7;b=j+(l>>>0>4)|0;d=h<<29|c>>>3;c=b>>>0<j>>>0?d+1|0:d;f=b;g=c;b=(d|0)==(c|0)&b>>>0<j>>>0|c>>>0<d>>>0;d=o|((i&7)<<29|h>>>3);b=b+d|0;j=r|(i>>>3&65535|e<<16);h=b;i=b>>>0<d>>>0?j+1|0:j;f:{if((l|0)==4){j=i;c=0;d=g+c|0;e=f&1;b=f+e|0;d=b>>>0<f>>>0?d+1|0:d;f=b;g=d;c=(c|0)==(d|0)&b>>>0<e>>>0|c>>>0>d>>>0;b=c+h|0;h=b;i=b>>>0<c>>>0?j+1|0:j;break f}if(!l){break a}}}v[a>>2]=f;v[a+4>>2]=g;v[a+8>>2]=h;v[a+12>>2]=i;jb=k+112|0}function Yla(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=jb-720|0;jb=e;Ic(b);g=jb-16|0;jb=g;i=g+8|0;h=e+104|0;YS(i,h);j=Hb(i);f=b;i=mc(f,$b(g,i));if((j|0)==(i|0)){_b(f,Hb(g+8|0))}jb=g+16|0;f=(i|0)==(j|0);if(!f){ZS(h)}a:{if(!f){break a}if(!aT(e+104|0)){break a}b:{if(!c){break b}Id(a,67108864);vi(a);d=w[e+129|0];u[a+480190>>1]=31;u[a+480188>>1]=d;v[a+480228>>2]=256/(d>>>0);d=Ub(e,4453);Gb(a+1304436|0,d);yb(d);d=Ub(e,6851);Gb(a+1304448|0,d);yb(d);f=Ub(e+88|0,11034);v[113382]=0;R(189,e- -64|0,f|0);d=v[113382];v[113382]=0;c:{d:{if((d|0)!=1){v[e+84>>2]=w[e+128|0]>>>4;d=w[e+128|0];v[113382]=0;v[e+80>>2]=d&15;X(497,e|0,e- -64|0,e+84|0,e+80|0);d=v[113382];v[113382]=0;if((d|0)!=1){Gb(a+1304460|0,e);yb(e);Ib(e- -64|0);yb(f);v[a+1304496>>2]=2;En(Vb(a+484360|0),e+152|0,w[e+151|0]+1|0,65535,65535);f=0;while(1){d=f+1|0;i=B(d,104)+a|0;j=i+484380|0;sd(j,1);g=(e+104|0)+(f<<2)|0;h=w[g+176|0]|w[g+177|0]<<8|(w[g+178|0]<<16|w[g+179|0]<<24);v[j>>2]=h<<24|h<<8&16711680|(h>>>8&65280|h>>>24);h=w[g+300|0]|w[g+301|0]<<8|(w[g+302|0]<<16|w[g+303|0]<<24);k=h<<24|h<<8&16711680|(h>>>8&65280|h>>>24);v[i+484384>>2]=k;h=w[g+424|0]|w[g+425|0]<<8|(w[g+426|0]<<16|w[g+427|0]<<24);v[i+484388>>2]=k+(h<<24|h<<8&16711680|(h>>>8&65280|h>>>24));if(w[g+424|0]|w[g+425|0]<<8|(w[g+426|0]<<16|w[g+427|0]<<24)){g=i+484414|0;u[g>>1]=x[g>>1]|2}kn(j);f=(e+104|0)+f|0;t[e|0]=w[f+548|0];t[e+64|0]=64;o=i+484410|0,p=w[pc(e,e- -64|0)|0]<<2,u[o>>1]=p;t[i+484417|0]=w[f+579|0]<<4;f=d;if((d|0)!=31){continue}break}bu(b,a+1304400|0,32);d=1;while(1){_S(b,((d<<5)+a|0)+946304|0,30);d=d+1|0;if((d|0)!=32){continue}break}k=c&1;if(k){dg(a+484344|0,w[e+150|0]+1|0)}j=a+484344|0;d=0;e:{while(1){i=Vh(e- -64|0);f:{if(w[e+130|0]){v[113382]=0;f=T(445,b|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break e}v[113382]=0;U(307,e|0,b|0,f|0);break f}f=x[a+480188>>1];v[113382]=0;U(307,e|0,b|0,f<<8)}f=v[113382];v[113382]=0;if((f|0)==1){break e}g=d;Qd(i,e);Bb(e);g:{if(!k){break g}v[113382]=0;d=W(364,j|0,g&65535,64)|0;f=v[113382];v[113382]=0;if((f|0)==1){break e}if(!d){break g}if(!w[e+130|0]){d=0;if(!x[a+480188>>1]){break g}while(1){f=0;while(1){h=Zb(j,g);v[113382]=0;h=W(432,h|0,f|0,d&65535)|0;l=v[113382];v[113382]=0;if((l|0)==1){break e}v[113382]=0;R(498,i|0,h|0);h=v[113382];v[113382]=0;if((h|0)==1){break e}f=f+1|0;if((f|0)!=64){continue}break}d=d+1|0;if(x[a+480188>>1]>(d&65535)>>>0){continue}break}break g}h=0;v[113382]=0;Q(499,i|0,e|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break e}while(1){d=Zb(j,g);v[113382]=0;l=Q(458,d|0,h|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break e}if(x[a+480188>>1]){m=e+h|0;d=128;f=0;while(1){h:{if(!(w[m|0]&d)){break h}v[113382]=0;R(498,i|0,l+B(f,6)|0);n=v[113382];v[113382]=0;if((n|0)!=1){break h}break e}d=d>>>1|0;f=f+1|0;if(f>>>0<x[a+480188>>1]){continue}break}}h=h+1|0;if((h|0)!=64){continue}break}}Bb(i);d=g+1|0;if(g>>>0<w[e+150|0]){continue}break}d=1;if(!(c&2)){break a}c=Yc(e,8,1,1,0);while(1){zg(c,(B(d,104)+a|0)+484380|0,b);d=d+1|0;if((d|0)!=32){continue}break}break b}d=P()|0;O()|0;Bb(i);break c}d=P()|0;O()|0;Ib(e- -64|0);break d}d=P()|0;O()|0}yb(f)}S(d|0);L()}d=1}jb=e+720|0;return d|0}function Z8(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=jb-176|0;jb=e;pf(e+160|0,b);m=a;l=c;g=d;h=jb-48|0;jb=h;v[h+44>>2]=0;f=b;Fi(f,h+44|0);a:{b:{c:{if(v[h+44>>2]!=(Ej(10029)|0)){break c}v[h+40>>2]=0;Fi(f,h+40|0);j=-1;i=v[h+40>>2];if(i-1>>>0>1){break c}d:{e:{f:{if(i>>>0<=1){i=Xb(h+24|0);v[113382]=0;k=W(685,f|0,i|0,256)|0;n=v[113382];v[113382]=0;if((n|0)==1){break b}if(!k){break e}v[113382]=0;U(13,h+8|0,g|0,i|0);k=v[113382];v[113382]=0;if((k|0)!=1){break f}break b}i=Xb(h+24|0);v[113382]=0;k=W(687,f|0,i|0,255)|0;n=v[113382];v[113382]=0;if((n|0)==1){break b}if(!k){break d}v[113382]=0;U(13,h+8|0,g|0,i|0);k=v[113382];v[113382]=0;if((k|0)==1){break b}}k=l;l=h+8|0;Gb(k,l);yb(l);yb(i);i=0;u[h+8>>1]=0;wf(f,l);v[h+24>>2]=0;Fi(f,h+24|0);l=v[h+24>>2];if(l>>>0>50){break c}if(l){while(1){if(!HJ(m,f,g)){break c}i=i+1|0;if(i>>>0<y[h+24>>2]){continue}break}}v[h+24>>2]=0;Fi(f,h+24|0);j=v[h+24>>2]==(Ej(10067)|0)?1:-1;break c}yb(i);break c}yb(i)}jb=h+48|0;f=j;break a}a=P()|0;O()|0;yb(i);S(a|0);L()}g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{if(!f){zn(v[v[b>>2]-12>>2]+b|0,0);f=v[e+172>>2];v[e+8>>2]=v[e+168>>2];v[e+12>>2]=f;f=v[e+164>>2];v[e>>2]=v[e+160>>2];v[e+4>>2]=f;aj(b,e);b=cl(e+56|0,b);v[113382]=0;f=Q(645,e+40|0,10136)|0;g=v[113382];v[113382]=0;if((g|0)==1){break h}v[113382]=0;v[e+32>>2]=3;v[e+36>>2]=0;U(646,b|0,f|0,e+32|0);g=v[113382];v[113382]=0;if((g|0)==1){break i}Ib(f);v[113382]=0;t[e+31|0]=0;f=Q(645,e+40|0,10434)|0;g=v[113382];v[113382]=0;if((g|0)==1){break j}v[113382]=0;W(647,b|0,e+31|0,f|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break k}Ib(f);v[113382]=0;f=w[e+31|0];g=T(1594,b|0)|0;j=v[113382];v[113382]=0;if((j|0)==1){break l}v[113382]=0;j=T(1595,b|0)|0;m=v[113382];v[113382]=0;if((m|0)==1){break m}v[e+32>>2]=j;v[e+24>>2]=g;if(Jb(e+24|0,e+32|0)){f=f?0:d;while(1){v[113382]=0;u[e+22>>1]=65535;d=Q(645,e+40|0,11955)|0;g=v[113382];v[113382]=0;if((g|0)==1){break p}v[113382]=0;g=W(1596,b|0,e+24|0,d|0)|0;j=v[113382];v[113382]=0;if((j|0)==1){break o}Ib(d);s:{if(!g){v[113382]=0;X(1597,b|0,e+24|0,c|0,f|0);d=v[113382];v[113382]=0;if((d|0)==1){break n}break s}v[113382]=0;d=Q(645,e+40|0,11717)|0;g=v[113382];v[113382]=0;t:{u:{if((g|0)!=1){v[113382]=0;g=W(1596,b|0,e+24|0,d|0)|0;j=v[113382];v[113382]=0;if((j|0)==1){break u}Ib(d);if(g){break t}v[113382]=0;W(1598,b|0,e+24|0,e+22|0)|0;d=v[113382];v[113382]=0;if((d|0)!=1){break s}break n}a=P()|0;O()|0;break g}a=P()|0;O()|0;Ib(d);break g}v[113382]=0;d=Q(645,e+40|0,11349)|0;g=v[113382];v[113382]=0;if((g|0)==1){break r}v[113382]=0;g=W(1596,b|0,e+24|0,d|0)|0;j=v[113382];v[113382]=0;if((j|0)==1){break q}Ib(d);if(g){break s}v[113382]=0;X(1599,b|0,e+24|0,a|0,f|0);d=v[113382];v[113382]=0;if((d|0)==1){break n}}d=e+24|0;Xf(d);if(Jb(d,e+32|0)){continue}break}}a=v[b>>2];Bg(b);f=a&1073741824?-1:1}jb=e+176|0;return f|0}a=P()|0;O()|0;break g}a=P()|0;O()|0;Ib(d);break g}a=P()|0;O()|0;break g}a=P()|0;O()|0;Ib(d);break g}a=P()|0;O()|0;break g}a=P()|0;O()|0;break g}a=P()|0;O()|0;break g}a=P()|0;O()|0;Ib(f);break g}a=P()|0;O()|0;break g}a=P()|0;O()|0;Ib(f);break g}a=P()|0;O()|0}Bg(b);S(a|0);L()}function KI(a){var b=0,c=C(0),d=C(0),e=0,f=C(0),g=C(0),h=0,i=C(0),j=0,k=0,l=0,m=C(0),n=C(0),o=0,p=C(0),q=0,r=C(0),s=C(0),u=0,w=0,x=C(0);k=jb-16|0;jb=k;u=a,w=Ai(C(z[a+4256>>2]*C(3))),v[u+4264>>2]=w;u=a,x=C(Ue(v[a+16>>2])>>>((v[a+4264>>2]>>>1^-1)&1)>>>0),z[u+4268>>2]=x;z[a+4272>>2]=C(z[a+4244>>2]*C(100))*C(.0061803399585187435);u=k,x=je(C(10),C(C(JI(a)+C(C(z[a+4228>>2]*C(11e3))+C(-1e4)))*C(.0005000000237487257))),z[u+12>>2]=x;v[k+8>>2]=1065353216;u=a,x=C(z[pl(k+12|0,k+8|0)>>2]*C(.7609999775886536)),z[u+4280>>2]=x;e=a;d=je(C(10),C(C(C(z[a+4212>>2]*C(1e4))+C(-1e4))*C(.0010000000474974513)));if(d!=C(1)){c=Ao(C(C(II(a)*C(6.2831854820251465))/z[a+4268>>2]));i=C(d+d);f=C(d*d);d=C(d*C(8));c=dn(C(C(C(C(c*i)+C(-2))+C(K(C(C(C(f*C(-4))+d)+C(C(C(C(f*C(4))*c)-d)*c)))))/C(i+C(-2))),C(0),C(1))}else{c=C(0)}z[e+4276>>2]=c;j=jb-16|0;jb=j;e=a;d=z[a+4268>>2];c=C(z[a+4232>>2]*C(.30000001192092896));z[j+12>>2]=z[a+4240>>2]*C(.10000000149011612);v[j+8>>2]=1000593162;b=a;i=z[nx(j+12|0,j+8|0)>>2];f=C(d*C(C(c+C(.007000000216066837))+i));a:{if(C(D(f))<C(2147483648)){h=~~f;break a}h=-2147483648}v[b+4352>>2]=h;b=1;while(1){l=((B(b&1,24)+e|0)+(b<<1&-4)|0)+4352|0;f=C(C(C(z[(b<<2)+36496>>2]*i)+c)*d);b:{if(C(D(f))<C(2147483648)){h=~~f;break b}h=-2147483648}v[l>>2]=h;b=b+1|0;if((b|0)!=12){continue}break}z[j+12>>2]=C(C(z[e+4248>>2]*C(100))*C(.009091000072658062))+C(.09091000258922577);v[j+8>>2]=1065353216;c=C(z[pl(j+12|0,j+8|0)>>2]*d);i=C(c*C(.07500000298023224));c=C(c*C(.06700000166893005));b=0;while(1){h=(b<<2)+e|0;q=h+4316|0;o=b+o|0;f=je(C(.9300000071525574),C(o|0));g=C(i*f);c:{if(C(D(g))<C(2147483648)){l=~~g;break c}l=-2147483648}v[q>>2]=l;l=h+4292|0;f=C(c*f);d:{if(C(D(f))<C(2147483648)){h=~~f;break d}h=-2147483648}v[l>>2]=h;b=b+1|0;if((b|0)!=6){continue}break}h=e+4348|0;c=C(d*C(.0035299998708069324));e:{if(C(D(c))<C(2147483648)){b=~~c;break e}b=-2147483648}v[h>>2]=b;h=e+4344|0;c=C(d*C(.0032500000670552254));f:{if(C(D(c))<C(2147483648)){b=~~c;break f}b=-2147483648}v[h>>2]=b;h=e+4340|0;d=C(d*C(.009999999776482582));g:{if(C(D(d))<C(2147483648)){b=~~d;break g}b=-2147483648}v[h>>2]=b;b=0;while(1){LI((B(b,24)+e|0)+4504|0,v[((b<<2)+e|0)+4292>>2]);b=b+1|0;if(b>>>0<15){continue}break}jb=j+16|0;b=jb-16|0;jb=b;c=Ng(a,5);f=Ng(a,11);d=C(c*Ng(a,4));i=C(C(d*C(.03999999910593033))+C(c*C(.02250000089406967)));c=C(f*Ng(a,10));f=C(C(c*C(.03999999910593033))+C(f*C(.02250000089406967)));if(t[a+4264|0]&1){g=Ng(e,3);m=Ng(e,9);g=C(g*d);d=C(Ng(e,2)*g);i=C(C(C(g*C(.12250000238418579))+i)+C(d*C(.1444000005722046)));g=C(m*c);c=C(Ng(e,8)*g);f=C(C(C(g*C(.12250000238418579))+f)+C(c*C(.1444000005722046)))}Ng(e,12);g=z[e+4496>>2];m=Ng(e,1);n=Ng(e,7);r=Ng(e,0);s=Ng(e,6);u=b,x=je(C(10),C(C(JI(e)+C(C(z[e+4236>>2]*C(12e3))+C(-1e4)))*C(.0005000000237487257))),z[u+12>>2]=x;v[b+8>>2]=1065353216;p=z[pl(b+12|0,b+8|0)>>2];g=C(g*g);c=C(n*C(g*c));n=C(s*c);d=C(m*C(g*d));g=C(r*d);m=C(C(C(n+g)*C(-.5))+C(1));z[e+4284>>2]=p*C(K(C(m/C(C(C(g+c)*C(.1444000005722046))+i))));z[e+4288>>2]=p*C(K(C(m/C(C(C(n+d)*C(.1444000005722046))+f))));jb=b+16|0;t[a+5046|0]=0;jb=k+16|0}function Wb(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;a:{if(!a){break a}d=a-8|0;b=v[a-4>>2];a=b&-8;f=d+a|0;b:{if(b&1){break b}if(!(b&3)){break a}b=v[d>>2];d=d-b|0;if(d>>>0<y[114683]){break a}a=a+b|0;if(v[114684]!=(d|0)){if(b>>>0<=255){e=v[d+8>>2];b=b>>>3|0;c=v[d+12>>2];if((c|0)==(e|0)){i=458716,j=v[114679]&uma(-2,b),v[i>>2]=j;break b}v[e+12>>2]=c;v[c+8>>2]=e;break b}h=v[d+24>>2];b=v[d+12>>2];c:{if((d|0)!=(b|0)){c=v[d+8>>2];v[c+12>>2]=b;v[b+8>>2]=c;break c}d:{e=d+20|0;c=v[e>>2];if(c){break d}e=d+16|0;c=v[e>>2];if(c){break d}b=0;break c}while(1){g=e;b=c;e=b+20|0;c=v[e>>2];if(c){continue}e=b+16|0;c=v[b+16>>2];if(c){continue}break}v[g>>2]=0}if(!h){break b}e=v[d+28>>2];c=(e<<2)+459020|0;e:{if(v[c>>2]==(d|0)){v[c>>2]=b;if(b){break e}i=458720,j=v[114680]&uma(-2,e),v[i>>2]=j;break b}v[h+(v[h+16>>2]==(d|0)?16:20)>>2]=b;if(!b){break b}}v[b+24>>2]=h;c=v[d+16>>2];if(c){v[b+16>>2]=c;v[c+24>>2]=b}c=v[d+20>>2];if(!c){break b}v[b+20>>2]=c;v[c+24>>2]=b;break b}b=v[f+4>>2];if((b&3)!=3){break b}v[114681]=a;v[f+4>>2]=b&-2;v[d+4>>2]=a|1;v[a+d>>2]=a;return}if(d>>>0>=f>>>0){break a}b=v[f+4>>2];if(!(b&1)){break a}f:{if(!(b&2)){if(v[114685]==(f|0)){v[114685]=d;a=v[114682]+a|0;v[114682]=a;v[d+4>>2]=a|1;if(v[114684]!=(d|0)){break a}v[114681]=0;v[114684]=0;return}if(v[114684]==(f|0)){v[114684]=d;a=v[114681]+a|0;v[114681]=a;v[d+4>>2]=a|1;v[a+d>>2]=a;return}a=(b&-8)+a|0;g:{if(b>>>0<=255){e=v[f+8>>2];b=b>>>3|0;c=v[f+12>>2];if((c|0)==(e|0)){i=458716,j=v[114679]&uma(-2,b),v[i>>2]=j;break g}v[e+12>>2]=c;v[c+8>>2]=e;break g}h=v[f+24>>2];b=v[f+12>>2];h:{if((f|0)!=(b|0)){c=v[f+8>>2];v[c+12>>2]=b;v[b+8>>2]=c;break h}i:{e=f+20|0;c=v[e>>2];if(c){break i}e=f+16|0;c=v[e>>2];if(c){break i}b=0;break h}while(1){g=e;b=c;e=b+20|0;c=v[e>>2];if(c){continue}e=b+16|0;c=v[b+16>>2];if(c){continue}break}v[g>>2]=0}if(!h){break g}e=v[f+28>>2];c=(e<<2)+459020|0;j:{if(v[c>>2]==(f|0)){v[c>>2]=b;if(b){break j}i=458720,j=v[114680]&uma(-2,e),v[i>>2]=j;break g}v[h+(v[h+16>>2]==(f|0)?16:20)>>2]=b;if(!b){break g}}v[b+24>>2]=h;c=v[f+16>>2];if(c){v[b+16>>2]=c;v[c+24>>2]=b}c=v[f+20>>2];if(!c){break g}v[b+20>>2]=c;v[c+24>>2]=b}v[d+4>>2]=a|1;v[a+d>>2]=a;if(v[114684]!=(d|0)){break f}v[114681]=a;return}v[f+4>>2]=b&-2;v[d+4>>2]=a|1;v[a+d>>2]=a}if(a>>>0<=255){a=a>>>3|0;b=(a<<3)+458756|0;c=v[114679];a=1<<a;k:{if(!(c&a)){v[114679]=a|c;a=b;break k}a=v[b+8>>2]}v[b+8>>2]=d;v[a+12>>2]=d;v[d+12>>2]=b;v[d+8>>2]=a;return}e=31;v[d+16>>2]=0;v[d+20>>2]=0;if(a>>>0<=16777215){b=a>>>8|0;g=b+1048320>>>16&8;b=b<<g;e=b+520192>>>16&4;b=b<<e;c=b+245760>>>16&2;b=(b<<c>>>15|0)-(c|(e|g))|0;e=(b<<1|a>>>b+21&1)+28|0}v[d+28>>2]=e;g=(e<<2)+459020|0;l:{m:{c=v[114680];b=1<<e;n:{if(!(c&b)){v[114680]=b|c;v[g>>2]=d;v[d+24>>2]=g;break n}e=a<<((e|0)==31?0:25-(e>>>1|0)|0);b=v[g>>2];while(1){c=b;if((v[b+4>>2]&-8)==(a|0)){break m}b=e>>>29|0;e=e<<1;g=c+(b&4)|0;b=v[g+16>>2];if(b){continue}break}v[g+16>>2]=d;v[d+24>>2]=c}v[d+12>>2]=d;v[d+8>>2]=d;break l}a=v[c+8>>2];v[a+12>>2]=d;v[c+8>>2]=d;v[d+24>>2]=0;v[d+12>>2]=c;v[d+8>>2]=a}a=v[114687]-1|0;v[114687]=a?a:-1}}function GK(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;a:{b:{if(b){g=a+327720|0;b=jb-400|0;jb=b;_M(b+384|0,8);v[113382]=0;ra(1174,b+368|0,9);h=v[113382];v[113382]=0;c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{if((h|0)!=1){v[113382]=0;h=Q(1175,b+352|0,14)|0;d=v[113382];v[113382]=0;if((d|0)==1){break n}v[113382]=0;R(1176,b+384|0,h|0);d=v[113382];v[113382]=0;if((d|0)==1){break m}v[113382]=0;R(1176,b+368|0,h|0);d=v[113382];v[113382]=0;if((d|0)==1){break m}ZM(b+280|0,4900);ZM(b+208|0,32e3);WM(b+136|0,8377175819504598e-21,16754351639009197e-21,8377175819504598e-21,-1.991112714669597,.9911462233728751);v[113382]=0;d=Q(1177,b+104|0,b+384|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break l}Qs(b+120|0,b+280|0,d);Qf(d);v[113382]=0;d=Q(1177,b+72|0,b+368|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break k}Qs(b+88|0,b+208|0,d);Qf(d);v[113382]=0;d=Q(1177,b+40|0,b+120|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break j}Qs(b+56|0,b+136|0,d);Qf(d);v[113382]=0;f=Q(1177,b+8|0,b+88|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break i}d=b+24|0;Qs(d,b+136|0,f);Qf(f);f=b+120|0;mp(f);j=b+56|0;mp(j);k=b+88|0;mp(k);mp(d);m=b+368|0;mp(m);lp(f,xi(g,0));lp(j,xi(g,1));lp(k,xi(g,2));lp(d,xi(g,3));lp(m,xi(g,4));Qf(d);Qf(j);Qf(k);Qf(f);kp(h);Qf(m);Qf(b+384|0);jb=b+400|0;break c}a=P()|0;O()|0;break d}a=P()|0;O()|0;break e}a=P()|0;O()|0;break f}a=P()|0;O()|0;break f}a=P()|0;O()|0;break g}a=P()|0;O()|0;break h}a=P()|0;O()|0;Qf(b+56|0)}Qf(b+88|0)}Qf(b+120|0)}kp(h)}Qf(b+368|0)}Qf(b+384|0);S(a|0);L()}Kx(a+131112|0,9.6377,.97);Kx(a+196648|0,8.5,.5);Kx(a+262184|0,2.7625,.425);Jx(a+368680|0,a);break b}if(Jx(a+368680|0,a)){break a}}f=a+24|0;p=A[a+8>>3];g=w[a+16|0];d=jb+-64|0;jb=d;while(1){q=+(l-4096|0)*.0001220703125;n=0;b=0;while(1){i=p;h=g;c=1;j=d+(b<<3)|0;e=+(b|0)-q;o=e+-3.5;if(!(D(o)<1e-8)){o:{p:{switch(h|0){case 0:c=.5-we(e*.8975979010256552)*.5;break o;case 1:c=we(e*.8975979010256552)*-.46+.54;break o;case 2:c=e*.8975979010256552;e=we(c+c);c=we(c)*-.5+.42+e*.08;break o;case 3:c=e*.8975979010256552;e=we(c+c);c=we(c)*-.49364+.44959+e*.05677;break o;case 4:c=e*.8975979010256552;e=we(c+c);c=we(c)*-.49755+.42323+e*.07922;break o;case 5:c=e*.8975979010256552;e=we(c+c);c=we(c)*-.48829+.35875+e*.14128+we(c*3)*-.01168;break o;case 6:c=e*.8975979010256552;e=we(c+c);c=we(c)*-.49703+.40217+e*.09392+we(c*3)*-.00183;break o;case 7:break p;default:break o}}c=e*.8975979010256552;e=we(c+c);c=we(c)*-.49804+.40243+e*.09831+we(c*3)*-.00122}e=o*3.141592653589793;i=gi(e*i)/e}i=i*c;A[j>>3]=i;n=i+n;b=b+1|0;if((b|0)!=8){continue}break}i=1/n;j=l<<3;b=0;while(1){k=f+(b+j<<1)|0;c=G(F(H(A[d+(b<<3)>>3]*32768*i+.5),32768),-32768);q:{if(D(c)<2147483648){h=~~c;break q}h=-2147483648}u[k>>1]=h;b=b+1|0;if((b|0)!=8){continue}break}l=l+1|0;if((l|0)!=8193){continue}break}jb=d- -64|0;g=v[a+20>>2];b=a+368696|0;v[b>>2]=v[a+16>>2];v[b+4>>2]=g;g=v[a+12>>2];b=a+368688|0;v[b>>2]=v[a+8>>2];v[b+4>>2]=g;b=v[a+4>>2];v[a+368680>>2]=v[a>>2];v[a+368684>>2]=b}}function ky(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,z=0,A=0,C=0,D=0;h=jb-16|0;jb=h;j=B(b,896)+a|0;m=j+1075782|0;i=x[m>>1];e=h+8|0;k=a+1074312|0;Fb(e,k,23);g=c&15;a:{b:{c:{if(Cb(e)){if(!(v[a+1074392>>2]|!w[(B(b,896)+a|0)+1075794|0])){u[m>>1]=g;e=0;break c}e=x[m>>1];if(e){f=e-1|0;u[m>>1]=f;e=0;if(f&65535){break c}}u[m>>1]=g;e=1;break c}e=h+8|0;Fb(e,k,52);f=c&256;if(!(!Cb(e)|!f)){d:{if(!(w[a+480209|0]&16)){break d}e=B(b,896)+a|0;if(w[e+1075795|0]){i=dS(e+1075794|0)?1:i}if(w[e+1075796|0]!=1){break d}if(w[(B(b,896)+a|0)+1075798|0]){break b}}e=0;if(i<<16>>16<(g|0)){break c}if(w[a+480209|0]&16){if(Wf((B(b,896)+a|0)+1075794|0)){break c}}i=0;e=1;break c}if(v[a+480180>>2]&16777250){e=!(i&65535?(i<<16>>16)%((g?g:1)|0)|0:1);i=i+1|0;break c}if(v[a+480180>>2]==1){f=y[a+1074392>>2]%y[a+1074416>>2]|0;if(!f){if(Wf((B(b,896)+a|0)+1075794|0)){break a}}e=0;e=g?!((f>>>0)%(g>>>0)|0):e;break c}if(v[a+480180>>2]==16){e=v[a+1074392>>2]==(g|0)&(g|0)!=0;break c}e:{f:{g:{h:{i:{if(f){e=B(b,896)+a|0;if(w[e+1075796|0]==1){g=(w[e+1075799|0]>15)+g|0}g=g?g:1;break i}if(w[a+480209|0]&16){break f}g=g?g:1;if(v[a+1074416>>2]){break h}}e=0;break g}e=!(y[a+1074392>>2]%(g>>>0)|0)}i=i+1|0;break e}e=0;i=v[a+480180>>2]&1048580?0:i}if(!(!(w[(B(b,896)+a|0)+1075794|0]|!f?v[a+1074392>>2]:1)|i<<16>>16<(g|0))){e=1}g=h+8|0;Fb(g,k,52);if(!Cb(g)|c){break c}e=!v[a+1074392>>2]}g=j+1074984|0;j=(B(b,896)+a|0)+1075060|0;j:{if(v[j>>2]){break j}f=h+8|0;Fb(f,k,38);if(!Cb(f)){break j}if(!oj(g)){break a}}f=h+8|0;Fb(f,k,106);if(A=0,C=Cb(f),D=v[(B(b,896)+a|0)+1075680>>2],D?A:C){break a}if(e){e=B(b,896)+a|0;p=e+1075672|0;v[h+4>>2]=v[p>>2];f=c>>>4&15;if(f){l=h+8|0;Fb(l,k,52);k:{if(A=Cb(l),C=0,D=w[(B(b,896)+a|0)+1075796|0]==1,D?A:C){break k}l=t[f+27104|0];if(l){v[h+4>>2]=(B(l,v[h+4>>2])|0)/16;break k}v[h+4>>2]=v[h+4>>2]+(t[f+27120|0]<<2)}Yd(h+4|0,0,256);f=(B(b,896)+a|0)+1075072|0;v[f>>2]=v[f>>2]|2097152}q=e+1075684|0;l=v[q>>2];e=w[e+1075808|0];l:{if(!v[j>>2]|(e-1&255)>>>0>119){break l}if(!(!(w[(B(b,896)+a|0)+1075073|0]&2)|v[a+480180>>2]!=2)){f=h+8|0;Fb(f,k,108);if(!Cb(f)){break l}}iM(a,b,0,e,1)}f=0;m:{if(!(v[a+480180>>2]&1048580)){break m}j=w[(B(b,896)+a|0)+1075795|0];f=(c|0)<256;if(!j|(c|0)>255){break m}gp(a,g,j,0,0,1);f=1}j=B(b,896)+a|0;n=j+1075644|0;s=v[n>>2];v[n>>2]=0;o=j+1075072|0;z=v[o>>2];r=h+8|0;Fb(r,k,23);Es(a,g,e,Cb(r),f,0,b);if(!w[j+1075795|0]){v[n>>2]=s}if(!(!(z&4096)|v[a+480180>>2]!=4)){v[o>>2]=v[o>>2]|4096}f=j+1075794|0;v[p>>2]=v[h+4>>2];if(x[a+480192>>1]){t[f|0]=e;NK(a,b)}if(!(!(v[a+480180>>2]&16777248)|(w[f|0]|!l))){v[q>>2]=l}e=v[a+480180>>2];f=h+8|0;Fb(f,k,23);if(Cb(f)){v[g>>2]=0;v[g+4>>2]=0}f=v[(B(b,896)+a|0)+1075088>>2];if(!(!f|(d|0)<=0|(d|0)>10)){n:{if((d|0)==1){b=v[(B(b,896)+a|0)+1075648>>2];break n}j=(B(b,896)+a|0)+1075648|0;b=v[(f+(d<<2)|0)+60>>2];v[j>>2]=b}fp(a,g,b)}i=e&16777250?i:0}a=h+8|0;Fb(a,k,52);b=Cb(a);Fb(a,k,23);if(Cb(a)){break a}i=(b&(c&256)>>>8)+i|0}u[m>>1]=i}jb=h+16|0}function EI(a){var b=C(0),c=C(0),d=0,e=C(0),f=0,g=C(0),h=0,i=C(0),k=C(0),m=C(0),n=C(0),o=C(0),r=C(0),s=0,t=C(0);zM(a+4208|0,z[a+4272>>2]);c=C(C(z[a+4208>>2]*C(15920))+C(80));d=Ue(v[a+16>>2]);o=je(C(10),C(C(C(z[a+4216>>2]*C(30))+C(-15))*C(.02500000037252903)));b=C(C(c*C(6.2831854820251465))/C(d>>>0));c=qG(b);r=Ao(b);s=a;t=c;k=C(C(C(b*C(.02888113260269165))*C(C(z[a+4212>>2]*C(35))+C(1)))/c);i=(l(2,(p(k),j(2))&-2147483648|1056964608),q());h=(p(k),j(2))&2147483647;c=(l(2,h),q());a:{if(h>>>0<=1118925334){b:{c:{d:{e:{f:{g:{f=(p(c),j(2));d=f&2147483647;if(d>>>0>=1100331076){if(d>>>0>2139095040){break c}b=C(-1);if((f|0)<0){break b}if(!(c>C(88.7216796875))){break g}b=C(c*C(1.7014118346046923e38));break b}if(d>>>0<1051816473){break e}if(d>>>0>1065686417){break g}if((f|0)>=0){d=1;e=C(905800061445916e-20);b=C(c+C(-.6931381225585938));break f}d=-1;e=C(-905800061445916e-20);b=C(c+C(.6931381225585938));break f}b=C(C(c*C(1.4426950216293335))+(l(2,(p(c),j(2))&-2147483648|1056964608),q()));h:{if(C(D(b))<C(2147483648)){d=~~b;break h}d=-2147483648}b=C(d|0);e=C(b*C(905800061445916e-20));b=C(c+C(b*C(-.6931381225585938)))}c=b;c=C(c-e);e=C(C(b-c)-e);break d}if(d>>>0<855638016){break c}d=0}m=C(c*C(.5));g=C(c*m);b=C(C(g*C(C(g*C(.0015807170420885086))+C(-.03333321213722229)))+C(1));n=b;b=C(C(3)-C(m*b));m=C(g*C(C(n-b)/C(C(6)-C(c*b))));b=C(c-C(C(c*m)-g));if(!d){break b}e=C(C(C(c*C(m-e))-e)-g);i:{switch(d+1|0){case 0:b=C(C(C(c-e)*C(.5))+C(-.5));break b;case 2:b=C(C(e-C(c+C(.5)))*C(-2));if(c<C(-.25)){break b}c=C(c-e);b=C(C(c+c)+C(1));break b;default:break i}}f=d<<23;b=(l(2,f+1065353216|0),q());if(d>>>0>=57){c=C(C(c-e)+C(1));b=C(((d|0)==128?C(C(c+c)*C(1.7014118346046923e38)):C(c*b))+C(-1));break b}g=(l(2,1065353216-f|0),q());c=C((d>>>0<=22?C(C(C(1)-g)+C(c-e)):C(C(c-C(e+g))+C(1)))*b)}b=c}if(h>>>0<=1065353215){if(h>>>0<964689920){break a}k=C(i*C(C(b+b)-C(C(b*b)/C(b+C(1)))));break a}k=C(i*C(b+C(b/C(b+C(1)))));break a}g=C(i+i);i=C(0);c=C(c+C(-162.88958740234375));h=(p(c),j(2));f=h>>>31|0;j:{k:{l:{m:{n:{n=c;o:{p:{d=h&2147483647;q:{if(d>>>0>=1118743632){b=c;if(d>>>0>2139095040){break j}b=C(c*C(1.7014118346046923e38));if(!((h|0)<0|d>>>0<1118925336)){break j}if(d>>>0<=1120924084|(h|0)>=0){break q}break l}if(d>>>0<1051816473){break n}if(d>>>0<1065686419){break p}}c=C(C(c*C(1.4426950216293335))+z[(f<<2)+51944>>2]);if(C(D(c))<C(2147483648)){d=~~c;break o}d=-2147483648;break o}d=!f-f|0}b=C(d|0);c=C(n+C(b*C(-.693145751953125)));i=C(b*C(1428606765330187e-21));b=C(c-i);break m}if(d>>>0<=956301312){break k}d=0;b=c}n=c;e=C(b*b);c=C(b-C(e*C(C(e*C(-.0027667332906275988))+C(.16666625440120697))));e=C(C(n+C(C(C(b*c)/C(C(2)-c))-i))+C(1));if(!d){break l}e=lG(e,d)}b=e;break j}b=C(c+C(1))}k=C(g*C(C(b*C(1.661534994731145e35))*C(1.661534994731145e35)))}b=C(t*k);e=C(b/o);c=C(e+C(1));z[s+4236>>2]=C(C(1)-e)/c;e=C(C(r*C(-2))/c);z[a+4232>>2]=e;b=C(b*o);z[a+4228>>2]=C(C(1)-b)/c;z[a+4224>>2]=e;z[a+4220>>2]=C(b+C(1))/c}function D3(a,b,c){a=a|0;b=+b;c=c|0;var d=0,e=0,f=0,g=0;d=jb-144|0;jb=d;v[d+136>>2]=c;a:{b:{c:{d:{if(!(b<.8)){v[113382]=0;c=da(2127)|0;e=v[113382];v[113382]=0;e:{f:{g:{if((e|0)!=1){v[d+64>>2]=c;c=v[d+136>>2];v[113382]=0;c=T(2128,c|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break f}v[d+48>>2]=c;Mm(v[d- -64>>2],v[d+48>>2]);c=v[d- -64>>2];a=af(d+120|0,a);v[113382]=0;e=v[a+12>>2];v[d+40>>2]=v[a+8>>2];v[d+44>>2]=e;e=v[a+4>>2];v[d+32>>2]=v[a>>2];v[d+36>>2]=e;a=W(2114,c|0,d+32|0,15)|0;c=v[113382];v[113382]=0;if((c|0)==1){break g}if(a){a=v[d- -64>>2];v[113382]=0;T(1365,a|0)|0;a=v[113382];v[113382]=0;f=1;if((a|0)==1){break g}}ad(d+48|0);Gh(d- -64|0);break c}c=V(0)|0;O()|0;break d}c=V(0)|0;O()|0;ad(d+48|0);break e}c=V(0)|0;O()|0}Gh(d- -64|0);break d}if(!(b<.6)){v[113382]=0;c=da(2127)|0;e=v[113382];v[113382]=0;h:{i:{j:{if((e|0)!=1){v[d+64>>2]=c;c=v[d+136>>2];v[113382]=0;c=T(2128,c|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break i}v[d+48>>2]=c;Mm(v[d- -64>>2],v[d+48>>2]);c=v[d- -64>>2];a=af(d+104|0,a);v[113382]=0;e=v[a+12>>2];v[d+24>>2]=v[a+8>>2];v[d+28>>2]=e;e=v[a+4>>2];v[d+16>>2]=v[a>>2];v[d+20>>2]=e;a=W(2114,c|0,d+16|0,2)|0;c=v[113382];v[113382]=0;if((c|0)==1){break j}if(a){a=v[d- -64>>2];v[113382]=0;T(1365,a|0)|0;a=v[113382];v[113382]=0;f=.8;if((a|0)==1){break j}}ad(d+48|0);Gh(d- -64|0);break c}c=V(0)|0;O()|0;break d}c=V(0)|0;O()|0;ad(d+48|0);break h}c=V(0)|0;O()|0}Gh(d- -64|0);break d}f=.2;if(!(b<.2)){v[113382]=0;c=da(2127)|0;e=v[113382];v[113382]=0;k:{l:{m:{if((e|0)!=1){v[d+64>>2]=c;c=v[d+136>>2];v[113382]=0;c=T(2128,c|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break l}v[d+48>>2]=c;Mm(v[d- -64>>2],v[d+48>>2]);c=v[d- -64>>2];a=af(d+88|0,a);v[113382]=0;e=v[a+12>>2];v[d+8>>2]=v[a+8>>2];v[d+12>>2]=e;e=v[a+4>>2];v[d>>2]=v[a>>2];v[d+4>>2]=e;a=W(2114,c|0,d|0,0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break m}f=0;if(a){a=v[d- -64>>2];v[113382]=0;T(1365,a|0)|0;a=v[113382];v[113382]=0;f=.6;if((a|0)==1){break m}}ad(d+48|0);Gh(d- -64|0);break c}c=V(0)|0;O()|0;break d}c=V(0)|0;O()|0;ad(d+48|0);break k}c=V(0)|0;O()|0}Gh(d- -64|0);break d}if(b<.1){break c}v[113382]=0;U(817,d- -64|0,a|0,2048);c=v[113382];v[113382]=0;n:{o:{p:{if((c|0)!=1){v[113382]=0;c=T(426,d- -64|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break o}e=v[d- -64>>2];v[113382]=0;a=T(225,a|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break o}v[113382]=0;a=BD(2129,3,0,c,e,a,0);c=v[113382];v[113382]=0;if((c|0)==1){break o}a=a+1|0;if(a>>>0>=3){break p}f=A[(a<<3)+37784>>3];Cc(d- -64|0);break c}c=V(0)|0;O()|0;break d}a=ba(8)|0;v[113382]=0;e=Q(121,d+48|0,17540)|0;c=v[113382];v[113382]=0;if((c|0)!=1){nc(a,e);v[113382]=0;U(1978,a|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break b}c=V(0)|0;O()|0;yb(e);break n}c=V(0)|0;O()|0;ca(a|0);break n}c=V(0)|0;O()|0}Cc(d- -64|0)}_(c|0)|0;v[113382]=0;Y(20);a=v[113382];v[113382]=0;f=0;if((a|0)==1){break a}}ad(d+136|0);jb=d+144|0;return+f}L()}a=P()|0;O()|0;ad(d+136|0);S(a|0);L()}function MU(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=jb-32|0;jb=e;v[e+28>>2]=b;if((d|0)<=0){a=0}else{v[e+8>>2]=d;v[e+16>>2]=214748364;r=e,s=B(v[Lb(e+28|0,e+16|0)>>2],20),v[r+20>>2]=s;Nv(c,v[Lb(e+8|0,e+20|0)>>2]);v[e+8>>2]=a;v[e+12>>2]=v[e+28>>2];a=0;while(1){a:{b=e+8|0;f=Gg(b,a);i=Gg(b,a+4|0);o=Gg(b,a+5|0);r=e,s=Gg(b,a+6|0)<<8|Gg(b,a+7|0),v[r+24>>2]=s;b=o|i<<8;p=a+8|0;b:{c:{d:{e:{switch(f|0){case 0:f:{if((b|0)<=(d|0)){i=0;o=0;if(b){break f}break b}b=ba(8)|0;v[113382]=0;T(318,b|0)|0;a=v[113382];v[113382]=0;if((a|0)!=1){break d}break c}while(1){r=e,s=Gg(e+8|0,i+p|0),t[r+20|0]=s;po(c,e+20|0);i=i+1|0;if((b|0)!=(i|0)){continue}break};i=b;o=b;break b;case 1:break e;default:break a}}Si(e+24|0,d);i=v[e+24>>2];m=Gg(e+8|0,a+10|0);t[e+20|0]=m;po(c,e+20|0);f=v[e+24>>2];v[e+24>>2]=f-1;o=b+3&65532;if((f|0)<2){break b}h=a+11|0;k=0;n=0;j=0;b=0;while(1){a=Zf(h,b,1,e+8|0);g:{h:{i:{j:{k:{if((j|0)<=7){if(a){f=b;break h}b=b+1|0;k=8;break k}f=b+1|0;l:{if(!a){if(!Zf(h,f,1,e+8|0)){break h}f=2;m:{n:{a=b+2|0;if(!Zf(h,a,1,e+8|0)){break n}f=3;a=b+3|0;if(!Zf(h,a,1,e+8|0)){break n}f=Zf(h,a,3,e+8|0);b=b+6|0;break m}b=a+1|0}a=4;o:{p:{q:{f=((k<<3)+f|0)-17|0;r:{if((f|0)<0){a=ba(8)|0;v[113382]=0;T(318,a|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){break q}break r}if(f>>>0<56){break o}a=ba(8)|0;v[113382]=0;T(318,a|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){break p}}b=P()|0;O()|0;ca(a|0);S(b|0);L()}ha(a|0,72452,235);L()}ha(a|0,72452,235);L()}k=w[f+23392|0];if((k|0)!=8){break j}break l}a=4;b=f;if((k|0)!=8){break j}}k=8;a=1;if((n|0)>19){break j}}a=0;break i}n=n+8|0}g=v[e+24>>2];s:{if((g|0)<=0){break s}while(1){f=e+8|0;l=(b|0)/8|0;g=l+h|0;q=Gg(f,g);m=m-((Gg(f,g+1|0)<<8|q<<16|Gg(f,g+2|0))<<(b-(l<<3)|0)+8>>32-k)|0;t[e+20|0]=m;po(c,e+20|0);f=v[e+24>>2];g=f-1|0;v[e+24>>2]=g;b=b+k|0;if(!a){break s}a=a-1|0;if((f|0)>1){continue}break}}j=(j|0)==31?31:j+1|0;break g}t:{u:{v:{a=f+1|0;if(!Zf(h,a,1,e+8|0)){f=2;break v}a=f+2|0;if(!Zf(h,a,1,e+8|0)){f=4;break v}a=f+3|0;if(!Zf(h,a,1,e+8|0)){f=6;break v}a=f+5|0;if(!Zf(h,f+4|0,1,e+8|0)){b=f+8|0;a=Zf(h,a,3,e+8|0)+8|0;break t}b=f+10|0;f=16;a=Zf(h,a,5,e+8|0);break u}b=a+2|0;a=Zf(h,a+1|0,1,e+8|0)}a=a+f|0}w:{if(Zf(h,b,1,e+8|0)){f=-256;g=12;break w}b=b+1|0;g=Zf(h,b,1,e+8|0);f=g?-4352:0;g=g?14:8}b=b+1|0;l=Zf(h,b,g,e+8|0);if((a|0)>=3){j=j-((a|0)!=3)|0;j=((j|0)>1?j:1)-1|0}f=wc(c)+((l^-1)+f|0)|0;if(f>>>0<wc(c)>>>0){b=b+g|0;g=v[e+24>>2];if((a|0)<=0|(g|0)<=0){break g}while(1){m=w[uc(c,f)|0];t[e+20|0]=m;po(c,e+20|0);l=v[e+24>>2];g=l-1|0;v[e+24>>2]=g;if(a>>>0<2){break g}f=f+1|0;a=a-1|0;if((l|0)>1){continue}break}break g}b=ba(8)|0;v[113382]=0;T(318,b|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break c}ha(b|0,72452,235);L()}n=n-(n>>3)|0;if((g|0)>0){continue}break}break b}ha(b|0,72452,235);L()}a=P()|0;O()|0;ca(b|0);S(a|0);L()}a=o+p|0;d=d-i|0;if((d|0)>0){continue}}break}a=id(c)^1}jb=e+32|0;return a|0}function Pq(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;f=a+b|0;c=v[a+4>>2];a:{b:{if(c&1){break b}if(!(c&3)){break a}c=v[a>>2];b=c+b|0;c:{a=a-c|0;if((a|0)!=v[114684]){if(c>>>0<=255){e=v[a+8>>2];c=c>>>3|0;d=v[a+12>>2];if((d|0)!=(e|0)){break c}i=458716,j=v[114679]&uma(-2,c),v[i>>2]=j;break b}h=v[a+24>>2];c=v[a+12>>2];d:{if((c|0)!=(a|0)){d=v[a+8>>2];v[d+12>>2]=c;v[c+8>>2]=d;break d}e:{e=a+20|0;d=v[e>>2];if(d){break e}e=a+16|0;d=v[e>>2];if(d){break e}c=0;break d}while(1){g=e;c=d;e=c+20|0;d=v[e>>2];if(d){continue}e=c+16|0;d=v[c+16>>2];if(d){continue}break}v[g>>2]=0}if(!h){break b}e=v[a+28>>2];d=(e<<2)+459020|0;f:{if(v[d>>2]==(a|0)){v[d>>2]=c;if(c){break f}i=458720,j=v[114680]&uma(-2,e),v[i>>2]=j;break b}v[h+(v[h+16>>2]==(a|0)?16:20)>>2]=c;if(!c){break b}}v[c+24>>2]=h;d=v[a+16>>2];if(d){v[c+16>>2]=d;v[d+24>>2]=c}d=v[a+20>>2];if(!d){break b}v[c+20>>2]=d;v[d+24>>2]=c;break b}c=v[f+4>>2];if((c&3)!=3){break b}v[114681]=b;v[f+4>>2]=c&-2;v[a+4>>2]=b|1;v[f>>2]=b;return}v[e+12>>2]=d;v[d+8>>2]=e}c=v[f+4>>2];g:{if(!(c&2)){if(v[114685]==(f|0)){v[114685]=a;b=v[114682]+b|0;v[114682]=b;v[a+4>>2]=b|1;if(v[114684]!=(a|0)){break a}v[114681]=0;v[114684]=0;return}if(v[114684]==(f|0)){v[114684]=a;b=v[114681]+b|0;v[114681]=b;v[a+4>>2]=b|1;v[a+b>>2]=b;return}b=(c&-8)+b|0;h:{if(c>>>0<=255){e=v[f+8>>2];c=c>>>3|0;d=v[f+12>>2];if((d|0)==(e|0)){i=458716,j=v[114679]&uma(-2,c),v[i>>2]=j;break h}v[e+12>>2]=d;v[d+8>>2]=e;break h}h=v[f+24>>2];c=v[f+12>>2];i:{if((f|0)!=(c|0)){d=v[f+8>>2];v[d+12>>2]=c;v[c+8>>2]=d;break i}j:{d=f+20|0;e=v[d>>2];if(e){break j}d=f+16|0;e=v[d>>2];if(e){break j}c=0;break i}while(1){g=d;c=e;d=c+20|0;e=v[d>>2];if(e){continue}d=c+16|0;e=v[c+16>>2];if(e){continue}break}v[g>>2]=0}if(!h){break h}e=v[f+28>>2];d=(e<<2)+459020|0;k:{if(v[d>>2]==(f|0)){v[d>>2]=c;if(c){break k}i=458720,j=v[114680]&uma(-2,e),v[i>>2]=j;break h}v[h+(v[h+16>>2]==(f|0)?16:20)>>2]=c;if(!c){break h}}v[c+24>>2]=h;d=v[f+16>>2];if(d){v[c+16>>2]=d;v[d+24>>2]=c}d=v[f+20>>2];if(!d){break h}v[c+20>>2]=d;v[d+24>>2]=c}v[a+4>>2]=b|1;v[a+b>>2]=b;if(v[114684]!=(a|0)){break g}v[114681]=b;return}v[f+4>>2]=c&-2;v[a+4>>2]=b|1;v[a+b>>2]=b}if(b>>>0<=255){b=b>>>3|0;c=(b<<3)+458756|0;d=v[114679];b=1<<b;l:{if(!(d&b)){v[114679]=b|d;b=c;break l}b=v[c+8>>2]}v[c+8>>2]=a;v[b+12>>2]=a;v[a+12>>2]=c;v[a+8>>2]=b;return}e=31;v[a+16>>2]=0;v[a+20>>2]=0;if(b>>>0<=16777215){c=b>>>8|0;g=c+1048320>>>16&8;c=c<<g;e=c+520192>>>16&4;c=c<<e;d=c+245760>>>16&2;c=(c<<d>>>15|0)-(d|(e|g))|0;e=(c<<1|b>>>c+21&1)+28|0}v[a+28>>2]=e;g=(e<<2)+459020|0;m:{d=v[114680];c=1<<e;n:{if(!(d&c)){v[114680]=c|d;v[g>>2]=a;v[a+24>>2]=g;break n}e=b<<((e|0)==31?0:25-(e>>>1|0)|0);c=v[g>>2];while(1){d=c;if((v[c+4>>2]&-8)==(b|0)){break m}c=e>>>29|0;e=e<<1;g=d+(c&4)|0;c=v[g+16>>2];if(c){continue}break}v[g+16>>2]=a;v[a+24>>2]=d}v[a+12>>2]=a;v[a+8>>2]=a;return}b=v[d+8>>2];v[b+12>>2]=a;v[d+8>>2]=a;v[a+24>>2]=0;v[a+12>>2]=d;v[a+8>>2]=b}}function gD(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;a=jb-144|0;jb=a;a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{v:{w:{x:{y:{z:{A:{B:{C:{D:{E:{if(v[17936]>=(c|0)){Tu(a+96|0,c);v[113382]=0;c=Q(2,a+80|0,13778)|0;d=v[113382];v[113382]=0;if((d|0)==1){break E}v[113382]=0;U(3,a+112|0,a+96|0,c|0);d=v[113382];v[113382]=0;if((d|0)==1){break D}v[113382]=0;d=Q(4,a+48|0,e|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break C}v[113382]=0;e=Q(2,a+32|0,15520)|0;f=v[113382];v[113382]=0;if((f|0)==1){break B}v[113382]=0;U(5,a- -64|0,d|0,e|0);f=v[113382];v[113382]=0;if((f|0)==1){break A}v[113382]=0;U(3,a+128|0,a+112|0,a- -64|0);f=v[113382];v[113382]=0;if((f|0)==1){break z}yb(a- -64|0);yb(e);yb(d);yb(a+112|0);yb(c);yb(a+96|0);c=v[b>>2]?v[b>>2]:17540;v[113382]=0;U(6,a+112|0,1,c|0);c=v[113382];v[113382]=0;if((c|0)==1){break t}c=v[b+4>>2]?v[b+4>>2]:17540;v[113382]=0;U(6,a+96|0,1,c|0);c=v[113382];v[113382]=0;if((c|0)==1){break s}b=v[b+8>>2];v[113382]=0;v[a+64>>2]=b;R(7,a+80|0,a- -64|0);b=v[113382];v[113382]=0;if((b|0)==1){break r}v[113382]=0;b=Q(8,458104,13657)|0;c=v[113382];v[113382]=0;if((c|0)==1){break q}v[113382]=0;U(9,a- -64|0,0,a+112|0);c=v[113382];v[113382]=0;if((c|0)==1){break p}v[113382]=0;b=Q(10,b|0,a- -64|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break o}v[113382]=0;b=Q(8,b|0,13381)|0;c=v[113382];v[113382]=0;if((c|0)==1){break o}v[113382]=0;U(9,a+32|0,0,a+80|0);c=v[113382];v[113382]=0;if((c|0)==1){break n}v[113382]=0;b=Q(10,b|0,a+32|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break m}v[113382]=0;b=Q(8,b|0,13378)|0;c=v[113382];v[113382]=0;if((c|0)==1){break m}v[113382]=0;b=Q(8,b|0,13778)|0;c=v[113382];v[113382]=0;if((c|0)==1){break m}v[113382]=0;U(9,a+16|0,0,a+128|0);c=v[113382];v[113382]=0;if((c|0)==1){break l}v[113382]=0;b=Q(10,b|0,a+16|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break k}v[113382]=0;b=Q(8,b|0,9446)|0;c=v[113382];v[113382]=0;if((c|0)==1){break k}v[113382]=0;U(9,a|0,0,a+96|0);c=v[113382];v[113382]=0;if((c|0)==1){break j}v[113382]=0;b=Q(10,b|0,a|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break i}v[113382]=0;b=Q(8,b|0,9444)|0;c=v[113382];v[113382]=0;if((c|0)==1){break i}v[113382]=0;Q(11,b|0,12)|0;b=v[113382];v[113382]=0;if((b|0)==1){break i}yb(a);yb(a+16|0);yb(a+32|0);yb(a- -64|0);yb(a+80|0);yb(a+96|0);yb(a+112|0);yb(a+128|0)}jb=a+144|0;return}b=P()|0;O()|0;break u}b=P()|0;O()|0;break v}b=P()|0;O()|0;break w}b=P()|0;O()|0;break x}b=P()|0;O()|0;break y}b=P()|0;O()|0;yb(a- -64|0)}yb(e)}yb(d)}yb(a+112|0)}yb(c)}yb(a+96|0);break a}b=P()|0;O()|0;break b}b=P()|0;O()|0;break c}b=P()|0;O()|0;break d}b=P()|0;O()|0;break e}b=P()|0;O()|0;break e}b=P()|0;O()|0;break f}b=P()|0;O()|0;break f}b=P()|0;O()|0;break g}b=P()|0;O()|0;break g}b=P()|0;O()|0;break h}b=P()|0;O()|0;break h}b=P()|0;O()|0;yb(a)}yb(a+16|0)}yb(a+32|0)}yb(a- -64|0)}yb(a+80|0)}yb(a+96|0)}yb(a+112|0)}yb(a+128|0)}S(b|0);L()}function YK(a,b){var c=0,d=0,e=0,f=0,g=0,h=C(0),i=0,j=0,k=C(0),l=0,m=0,n=0,o=0,p=C(0),q=0,r=0,s=C(0),t=0,w=0,A=C(0),E=0;if(b){Vo(a);c=a+24596|0;v[c>>2]=0;v[c+4>>2]=0;v[a+24588>>2]=0;v[a+24592>>2]=0;jL(a)}XK(a+24648|0);t=v[a+24620>>2];g=jb-144|0;jb=g;f=a+393352|0;c=v[f+4>>2];if(c>>>0>=29){v[f+4>>2]=0;c=0}j=B(c,44)+77280|0;if(!(b?0:(j|0)==v[f+4112>>2])){v[f+4112>>2]=j;s=C(t>>>0);h=s;c=g+8|0;d=v[j+24>>2];v[c>>2]=d;e=v[j+16>>2];v[c+4>>2]=e;v[c+8>>2]=v[j+4>>2];m=(d|0)>(e|0)?d:e;if((m|0)<=-601){l=e;e=m+600|0;v[c+4>>2]=l-e;v[c>>2]=d-e}e=c;k=C(z[j+36>>2]*C(79.30999755859375));a:{if(C(D(k))<C(2147483648)){d=~~k;break a}d=-2147483648}v[e+16>>2]=d- -8192;d=c;k=C(C(z[j+32>>2]*C(117.9612045288086))+C(4915.05029296875));b:{if(C(D(k))<C(2147483648)){e=~~k;break b}e=-2147483648}v[d+20>>2]=(e|0)<32512?e:32512;m=0;k=z[j+8>>2];e=c;p=C(C(F(z[j+20>>2],C(.10000000149011612)))*h);c:{if(C(D(p))<C(2147483648)){d=~~p;break c}d=-2147483648}i=(d|0)<96;o=i?96:d;n=o-7500|0;n=o>>>0<n>>>0?0:n;p=C(z[j+28>>2]*h);d:{if(C(D(p))<C(2147483648)){l=~~p;break d}l=-2147483648}d=n+(l+(i?d-96|0:0)|0)|0;i=(d|0)<128;l=e;e=i?128:d;n=e>>>0<3800?e:3800;v[l+24>>2]=n;q=i?d-128|0:0;l=c;h=C(k*h);e:{if(C(D(h))<C(2147483648)){i=~~h;break e}i=-2147483648}d=e-3800|0;i=(i+q|0)+(d>>>0>e>>>0?0:d)|0;v[l+32>>2]=i;o=o>>>0<7500?o:7500;while(1){e=B(m,12);d=e+c|0;e=e+36624|0;u[d+42>>1]=x[e+10>>1];u[d+36>>1]=x[e+4>>1];q=x[e+6>>1]|x[e+8>>1]<<16;u[d+38>>1]=q;u[d+40>>1]=q>>>16;v[d+44>>2]=o+((B(v[e>>2],n)+50|0)/100|0);m=m+1|0;if((m|0)!=8){continue}break}e=c;h=C(i|0);k=C(je(C(.0010000000474974513),(i|0)<4721?C(1):C(C(4720)/h))*C(32768));f:{if(C(D(k))<C(2147483648)){d=~~k;break f}d=-2147483648}v[e+12>>2]=d;h=C(z[j+12>>2]*h);w=c,A=je(C(.0010000000474974513),h>C(4720)?C(C(4720)/h):C(1)),z[w+28>>2]=A;v[f+4124>>2]=v[g+40>>2];c=wI(xI(v[g+16>>2]),s);u[f+4190>>1]=c;u[f+4188>>1]=c;c=x[g+24>>1]<<1;u[f+4198>>1]=c;u[f+4196>>1]=c;while(1){c=(r<<4)+f|0;d=(g+8|0)+B(r,12)|0;e=v[d+44>>2];v[c+4204>>2]=e;v[c+4208>>2]=e;u[c+4212>>1]=x[d+36>>1];u[c+4214>>1]=x[d+42>>1];u[c+4216>>1]=x[d+40>>1];u[c+4218>>1]=x[d+38>>1];r=r+1|0;if((r|0)!=8){continue}break}v[f+53996>>2]=v[g+32>>2];e=f+4184|0;c=v[g+12>>2];if((c|0)>-9e3){c=vI(c)}else{c=0}v[e>>2]=c;e=f+54052|0;c=v[g+8>>2];if((c|0)>=-8999){c=vI(c)}else{c=0}v[e>>2]=c;c=v[g+28>>2];d=f+54036|0;v[d>>2]=268464128;v[d+4>>2]=1879052288;c=c>>>0<32512?c:32512;u[f+54010>>1]=c;u[f+54008>>1]=c;u[f+54006>>1]=c;u[f+54004>>1]=c;v[g+4>>2]=v[g+20>>2];Yd(g+4|0,0,32752);c=x[g+4>>1];u[f+54018>>1]=c;d=f+54014|0;u[d>>1]=0;u[d+2>>1]=0;u[f+54012>>1]=c;h=z[g+36>>2];w=g,E=wI(C(h*h),s),v[w>>2]=E;Yd(g,256,32512);c=x[g>>1];u[f+54026>>1]=c;d=f+54022|0;u[d>>1]=0;u[d+2>>1]=0;u[f+54020>>1]=c}if(b){v[f+4120>>2]=0;zI(f)}b=B(t,5);if(b>>>0>y[f+4124>>2]){v[f+4124>>2]=b}jb=g+144|0;b=a+1304392|0;if(qd(b)){jN(v[b>>2],v[a+24620>>2])}}function Qca(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=jb-48|0;jb=d;a:{b:{c:{d:{j=a+24|0;e:{if(qd(j)){break e}i=a+4|0;m=Db(i);a=jb-48|0;jb=a;g=a+40|0;b=g;v[b>>2]=-1;v[b+4>>2]=-1;f:{if(t[80352]&1){break f}if(!vd(80352)){break f}v[113382]=0;T(108,80348)|0;b=v[113382];v[113382]=0;if((b|0)!=1){ud(80352);break f}a=P()|0;O()|0;ne(80352);S(a|0);L()}v[113382]=0;b=zD(2832);c=v[113382];v[113382]=0;if((c|0)==1){break a}v[a+8>>2]=b;v[a+12>>2]=mb;b=v[a+12>>2];v[a+16>>2]=v[a+8>>2];v[a+20>>2]=b;c=jb-16|0;jb=c;b=jb-16|0;jb=b;h=a+16|0;f=h;n=b,o=qma(v[f>>2],v[f+4>>2],1e3,0),v[n>>2]=o;v[b+4>>2]=mb;f=pk(b+8|0,b);e=v[f+4>>2];jb=b+16|0;jb=c+16|0;v[a+24>>2]=v[f>>2];v[a+28>>2]=e;f=a+24|0;c=f;b=v[c+4>>2];c=v[c>>2];k=c<<8&16711680|c<<24;l=c>>>8|0;c=c>>>24|0;e=(l|(b&255)<<24)&-16777216|(c|(b&16777215)<<8)&16711680|(b>>>8&65280|b>>>24);t[a+32|0]=e;t[a+33|0]=e>>>8;t[a+34|0]=e>>>16;t[a+35|0]=e>>>24;b=(l|b<<24)&65280|(c|b<<8)&255|k;t[a+36|0]=b;t[a+37|0]=b>>>8;t[a+38|0]=b>>>16;t[a+39|0]=b>>>24;b=v[a+36>>2];v[a+24>>2]=v[a+32>>2];v[a+28>>2]=b;oM(g,f,zb(f));v[113382]=0;b=zD(2833);c=v[113382];v[113382]=0;if((c|0)==1){break a}v[a+8>>2]=b;v[a+12>>2]=mb;b=v[a+12>>2];v[a+16>>2]=v[a+8>>2];v[a+20>>2]=b;c=jb-16|0;jb=c;b=jb-16|0;jb=b;e=v[h+4>>2];v[b>>2]=v[h>>2];v[b+4>>2]=e;e=pk(b+8|0,b);h=v[e+4>>2];jb=b+16|0;jb=c+16|0;v[a+24>>2]=v[e>>2];v[a+28>>2]=h;b=v[f>>2];h=b<<8&16711680|b<<24;e=b>>>8|0;c=v[f+4>>2];k=(e|c<<24)&65280;b=b>>>24|0;e=(e|(c&255)<<24)&-16777216|(b|(c&16777215)<<8)&16711680|(c>>>8&65280|c>>>24);t[a+32|0]=e;t[a+33|0]=e>>>8;t[a+34|0]=e>>>16;t[a+35|0]=e>>>24;b=(b|c<<8)&255|k|h;t[a+36|0]=b;t[a+37|0]=b>>>8;t[a+38|0]=b>>>16;t[a+39|0]=b>>>24;b=v[a+36>>2];v[a+24>>2]=v[a+32>>2];v[a+28>>2]=b;oM(g,f,zb(f));c=v[g>>2];g=v[g+4>>2];jb=a+48|0;if(m){b=en(d+32|0);v[113382]=0;v[d+16>>2]=g;R(86,b|0,d+16|0);a=v[113382];v[113382]=0;g:{h:{i:{if((a|0)!=1){v[113382]=0;v[d+16>>2]=c;R(86,b|0,d+16|0);a=v[113382];v[113382]=0;if((a|0)==1){break i}if(Db(i)){a=0;while(1){c=w[kc(i,a)|0];v[113382]=0;v[d+16>>2]=c;R(86,b|0,d+16|0);c=v[113382];v[113382]=0;if((c|0)==1){break c}a=a+1|0;if(Db(i)>>>0>a>>>0){continue}break}}a=ac(b);c=bc(b);v[113382]=0;c=W(87,d+16|0,a|0,c|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break h}v[113382]=0;a=T(88,c|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break g}v[d+8>>2]=a;a=d+8|0;Fs(j,a);vf(a);ze(c);ze(b);break e}a=P()|0;O()|0;break b}a=P()|0;O()|0;break b}a=P()|0;O()|0;break b}a=P()|0;O()|0;ze(c);break b}mb=c;v[d+16>>2]=g;v[d+20>>2]=mb;b=d+32|0;a=en(b);v[113382]=0;U(93,b|0,d+16|0,d+24|0);c=v[113382];v[113382]=0;if((c|0)==1){b=P()|0;O()|0;ze(a);S(b|0);L()}v[113382]=0;a=T(88,b|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break d}v[d+8>>2]=a;a=d+8|0;Fs(j,a);vf(a);ze(b)}jb=d+48|0;return}a=P()|0;O()|0;break b}a=P()|0;O()|0}ze(b);S(a|0);L()}V(0)|0;O()|0;Ab();L()}function I3(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=jb-176|0;jb=d;h=d+160|0;WH(h);v[h>>2]=78824;f=jb-16|0;jb=f;e=h+4|0;v[e>>2]=0;v[e+4>>2]=0;v[113382]=0;v[f+12>>2]=0;W(2168,e+8|0,f+12|0,f+8|0)|0;e=v[113382];v[113382]=0;a:{if((e|0)!=1){jb=f+16|0;break a}V(0)|0;O()|0;Ab();L()}f=a+24|0;Mm(v[f>>2],h);e=w[a+62|0];g=w[a+61|0];j=w[a+60|0];k=v[f>>2];b=af(d+144|0,b);v[113382]=0;i=v[b+12>>2];v[d+8>>2]=v[b+8>>2];v[d+12>>2]=i;i=v[b+4>>2];v[d>>2]=v[b>>2];v[d+4>>2]=i;b=j?13:15;b=g?b&14:b;b=W(2114,k|0,d|0,(e?b&3:b)|0)|0;e=v[113382];v[113382]=0;b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{if((e|0)==1){break s}if(!b){b=ba(8)|0;v[113382]=0;c=Q(121,d+128|0,8008)|0;a=v[113382];v[113382]=0;if((a|0)!=1){nc(b,c);v[113382]=0;U(1978,b|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break b}a=P()|0;O()|0;yb(c);break c}a=P()|0;O()|0;ca(b|0);break c}if(!w[a+63|0]){v[113382]=0;R(2115,a|0,a+36|0);b=v[113382];v[113382]=0;if((b|0)==1){break s}}t[a+28|0]=1;Mm(v[f>>2],v[a+4>>2]);v[113382]=0;R(2116,d+128|0,h|0);b=v[113382];v[113382]=0;if((b|0)==1){break r}b=d+128|0;l=d,m=ac(b),v[l+120>>2]=m;l=d,m=bc(b),v[l+112>>2]=m;if(Jb(d+120|0,d+112|0)){f=a+68|0;while(1){b=v[d+120>>2];e=v[b>>2];v[113382]=0;g=e;e=b+4|0;U(2117,a|0,g|0,e|0);g=v[113382];v[113382]=0;if((g|0)==1){break f}b=v[b>>2];v[113382]=0;R(2118,d+48|0,b|0);b=v[113382];v[113382]=0;if((b|0)==1){break g}v[113382]=0;U(9,d- -64|0,0,d+48|0);b=v[113382];v[113382]=0;if((b|0)==1){break i}v[113382]=0;b=Q(121,d+32|0,13778)|0;g=v[113382];v[113382]=0;if((g|0)==1){break k}v[113382]=0;U(137,d+80|0,d- -64|0,b|0);g=v[113382];v[113382]=0;if((g|0)==1){break m}v[113382]=0;U(765,d+96|0,d+80|0,e|0);e=v[113382];v[113382]=0;if((e|0)==1){break o}v[113382]=0;R(1502,f|0,d+96|0);e=v[113382];v[113382]=0;if((e|0)==1){break p}yb(d+96|0);yb(d+80|0);yb(b);yb(d- -64|0);yb(d+48|0);b=d+120|0;Xf(b);if(Jb(b,d+112|0)){continue}break}}l=d,m=rn(c),v[l+96>>2]=m;l=d,m=Ii(c),v[l+80>>2]=m;t:{while(1){v[113382]=0;b=Q(2119,d+96|0,d+80|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break e}if(!b){break q}v[113382]=0;c=T(2120,d+96|0)|0;b=v[113382];v[113382]=0;u:{if((b|0)==1){break u}v[113382]=0;b=Q(120,d+16|0,c|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break u}v[113382]=0;X(2050,a|0,b|0,c+12|0,0);c=v[113382];v[113382]=0;if((c|0)==1){break t}yb(b);v[113382]=0;T(2121,d+96|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){continue}break e}break}a=P()|0;O()|0;break d}a=P()|0;O()|0;yb(b);break d}a=P()|0;O()|0;break c}a=P()|0;O()|0;break c}$w(d+128|0);Vr(h);jb=d+176|0;return}a=P()|0;O()|0;yb(d+96|0);break n}a=P()|0;O()|0}yb(d+80|0);break l}a=P()|0;O()|0}yb(b);break j}a=P()|0;O()|0}yb(d- -64|0);break h}a=P()|0;O()|0}yb(d+48|0);break d}a=P()|0;O()|0;break d}a=P()|0;O()|0;break d}a=P()|0;O()|0}$w(d+128|0)}Vr(h);S(a|0)}L()}function ZH(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;f=jb-224|0;jb=f;v[f+216>>2]=c;v[f+220>>2]=d;a:{if(nj(b)){break a}g=w[gk(b)|0];if((g|0)==33){e=1}else{if((g|0)!=63){break a}e=0}rk(f+184|0,b,v[b+4>>2]-1|0);g=v[f+188>>2];v[b>>2]=v[f+184>>2];v[b+4>>2]=g}g=f+184|0;Ad(g);h=v[f+184>>2];Ad(f+168|0);i=fk(h,v[f+172>>2],b);Ad(g);g=v[b>>2];h=v[b+4>>2];b:{c:{d:{e:{f:{g:{h:{if((i|0)==v[f+188>>2]){v[f+208>>2]=g;v[f+212>>2]=h;a=qc(f+200|0,17540);c=v[f+212>>2];v[f+16>>2]=v[f+208>>2];v[f+20>>2]=c;c=v[a+4>>2];v[f+8>>2]=v[a>>2];v[f+12>>2]=c;if(Hc(f+16|0,f+8|0)){a=ba(8)|0;v[113382]=0;R(2112,f+168|0,f+216|0);b=v[113382];v[113382]=0;if((b|0)!=1){v[113382]=0;U(2088,f+184|0,13642,f+168|0);b=v[113382];v[113382]=0;if((b|0)==1){break g}nc(a,f+184|0);v[113382]=0;U(1978,a|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break b}b=P()|0;O()|0;yb(f+184|0);yb(f+168|0);break c}b=P()|0;O()|0;break d}if(!e){break h}c=ba(8)|0;v[113382]=0;d=Q(2111,f+136|0,b|0)|0;a=v[113382];v[113382]=0;i:{j:{k:{l:{m:{n:{o:{p:{if((a|0)!=1){v[113382]=0;U(2088,f+152|0,13678,d|0);a=v[113382];v[113382]=0;if((a|0)==1){break p}v[113382]=0;U(2106,f+168|0,f+152|0,13652);b=v[113382];v[113382]=0;a=1;if((b|0)==1){break o}v[113382]=0;R(2112,f+120|0,f+216|0);a=v[113382];v[113382]=0;if((a|0)==1){break n}v[113382]=0;U(137,f+184|0,f+168|0,f+120|0);b=v[113382];v[113382]=0;a=1;if((b|0)==1){break m}nc(c,f+184|0);v[113382]=0;U(1978,c|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break b}b=P()|0;O()|0;yb(f+184|0);a=0;break l}b=P()|0;O()|0;break i}b=P()|0;O()|0;yb(d);break i}b=P()|0;O()|0;break j}b=P()|0;a=1;O()|0;break k}b=P()|0;O()|0}yb(f+120|0)}yb(f+168|0)}yb(f+152|0);yb(d);if(!a){break c}}ca(c|0);break c}v[f+112>>2]=g;v[f+116>>2]=h;e=qc(f+104|0,17540);g=v[f+116>>2];v[f+64>>2]=v[f+112>>2];v[f+68>>2]=g;g=v[e+4>>2];v[f+56>>2]=v[e>>2];v[f+60>>2]=g;if(Hc(f- -64|0,f+56|0)){a=ba(8)|0;v[113382]=0;R(2112,f+168|0,f+216|0);b=v[113382];v[113382]=0;if((b|0)!=1){v[113382]=0;U(2088,f+184|0,13642,f+168|0);b=v[113382];v[113382]=0;if((b|0)==1){break f}nc(a,f+184|0);v[113382]=0;U(1978,a|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break b}b=P()|0;O()|0;yb(f+184|0);yb(f+168|0);break c}b=P()|0;O()|0;break e}e=v[b+4>>2];v[f+96>>2]=v[b>>2];v[f+100>>2]=e;e=qc(f+88|0,7e3);g=v[f+100>>2];v[f+48>>2]=v[f+96>>2];v[f+52>>2]=g;g=v[e+4>>2];v[f+40>>2]=v[e>>2];v[f+44>>2]=g;if(Hc(f+48|0,f+40|0)){NH(a,zc(c,d));break h}e=v[b+4>>2];v[f+80>>2]=v[b>>2];v[f+84>>2]=e;b=qc(f+72|0,4872);e=v[f+84>>2];v[f+32>>2]=v[f+80>>2];v[f+36>>2]=e;e=v[b+4>>2];v[f+24>>2]=v[b>>2];v[f+28>>2]=e;if(!Hc(f+32|0,f+24|0)){break h}b=zc(c,d);v[v[a+32>>2]+40>>2]=b>>>0>3?1:b}jb=f+224|0;return}b=P()|0;O()|0;yb(f+168|0);break d}b=P()|0;O()|0;yb(f+168|0)}ca(a|0);break c}ca(a|0)}S(b|0)}L()}function tv(a){var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=jb-96|0;jb=d;a:{b:{c:{if(k=1,l=wd(a,11),m=v[a+4>>2],m?k:l){e=v[a+28>>2];c=d;f=v[a+12>>2];g=v[a+64>>2];b=g+v[a+8>>2]|0;f=Qg(c+80|0,b,b>>>0<g>>>0?f+1|0:f);b=v[f+12>>2];v[c+32>>2]=v[f+8>>2];v[c+36>>2]=b;c=v[f+4>>2];v[d+24>>2]=v[f>>2];v[d+28>>2]=c;aj(e,d+24|0);c=v[a+28>>2];if(Mt(v[v[c>>2]-12>>2]+c|0)){Kg(a,1073741826);break a}b=v[a+92>>2];f=a+44|0;c=f;e=jd(c);d:{if(b>>>0>e>>>0){g=jb-32|0;jb=g;e:{e=b-e|0;f:{if(e>>>0<=v[zb(c)>>2]-v[c+4>>2]>>4>>>0){h=jb-16|0;jb=h;g:{b=om(h,c,e);e=v[b+4>>2];j=v[b+8>>2];if((e|0)!=(j|0)){while(1){i=zb(c);v[113382]=0;R(186,i|0,e|0);i=v[113382];v[113382]=0;if((i|0)==1){break g}e=e+16|0;v[b+4>>2]=e;if((e|0)!=(j|0)){continue}break}}Mb(b);jb=h+16|0;break f}a=P()|0;O()|0;Mb(b);S(a|0);L()}b=zb(c);b=Mq(g+8|0,Nq(c,jd(c)+e|0),jd(c),b);v[113382]=0;R(181,b|0,e|0);e=v[113382];v[113382]=0;if((e|0)==1){break e}v[113382]=0;R(182,c|0,b|0);c=v[113382];v[113382]=0;if((c|0)==1){break e}xD(b)}jb=g+32|0;break d}a=P()|0;O()|0;xD(b);S(a|0);L()}if(b>>>0<e>>>0){b=v[c>>2]+(b<<4)|0;jd(c);wD(c,b);vD(c)}}e=a+32|0;Nv(e,v[a+92>>2]<<2);if(v[a+92>>2]){c=0;while(1){b=v[a+28>>2];if(Mt(v[v[b>>2]-12>>2]+b|0)){Kg(a,1073741828);break a}b=x[a+16>>1];u[d+78>>1]=b;if((b|0)==65535){xv(v[a+28>>2],d+78|0)}k=d,l=wc(e),v[k+72>>2]=l;h:{if(!x[d+78>>1]){b=0;break h}b=x[d+78>>1];g=v[d+72>>2];if(b>>>0>-1-g>>>0){break h}pv(e,b+g|0);Oj(v[a+28>>2],uc(e,v[d+72>>2]),x[d+78>>1]);b=x[d+78>>1]}k=sc(f,c),l=b,u[k+12>>1]=l;b=v[d+72>>2];k=sc(f,c),l=b,v[k>>2]=l;if(wd(a,6)){Mj(v[a+28>>2],d+56|0);if(y[d+60>>2]>2147483647){break c}b=v[d+56>>2];k=sc(f,c),l=b,v[k+4>>2]=l}b=v[a+4>>2];i:{if(b){k=sc(f,c),l=b,v[k+8>>2]=l;break i}if(!wd(a,7)){break i}Mj(v[a+28>>2],d+56|0);if(y[d+60>>2]>2147483647){break b}b=v[d+56>>2];k=sc(f,c),l=b,v[k+8>>2]=l}j:{if(v[sc(f,c)+8>>2]==-1){break j}if(wd(a,6)){break j}if(c){b=c-1|0;b=v[sc(f,b)+4>>2]+v[sc(f,b)+8>>2]|0}else{b=0}k=sc(f,c),l=b,v[k+4>>2]=l}if(wd(a,8)){u[d+56>>1]=0;xv(v[a+28>>2],d+56|0);b=wd(a,9);_k(v[a+28>>2],x[d+56>>1]<<b,-1)}c=c+1|0;if(c>>>0<y[a+92>>2]){continue}break}}pf(d+56|0,v[a+28>>2]);c=v[d+68>>2];v[a+72>>2]=v[d+64>>2];v[a+76>>2]=c}Nj(a,4,1);e=v[a+76>>2];g=v[a+88>>2];b=g+v[a+8>>2]|0;f=v[a+12>>2];f=b>>>0<g>>>0?f+1|0:f;c=b;b=(g|0)==v[a+64>>2];g=b?v[a+72>>2]:c;v[a+80>>2]=g;c=b?e:f;v[a+84>>2]=c;f=v[a+28>>2];c=Qg(d+40|0,g,c);b=v[c+12>>2];v[d+16>>2]=v[c+8>>2];v[d+20>>2]=b;b=v[c+4>>2];v[d+8>>2]=v[c>>2];v[d+12>>2]=b;aj(f,d+8|0);if(wd(a,6)){break a}if(!(k=1,l=wd(a,7),m=v[a+4>>2],m?k:l)|!v[a+92>>2]){break a}f=a+44|0;c=v[a+80>>2];b=v[a+8>>2];b=c-b|0;c=0;while(1){e=sc(f,c);v[e+4>>2]=b+v[e+4>>2];c=c+1|0;if(c>>>0<y[a+92>>2]){continue}break}break a}Kg(a,1073741829);break a}Kg(a,1073741829)}jb=d+96|0}function G9(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=jb-48|0;jb=c;if(qh(b)){h=mk(b);j=v[b+12>>2];f=c+32|0;e=cA(f);a:{d=h;if(!d){break a}v[113382]=0;R(642,f|0,d|0);g=v[113382];v[113382]=0;if((g|0)!=1){v[113382]=0;R(1536,f|0,d|0);d=v[113382];v[113382]=0;if((d|0)!=1){break a}}a=P()|0;O()|0;Ft(e);S(a|0);L()}b:{if(!j){break b}while(1){d=v[v[a>>2]-12>>2];v[113382]=0;d=T(1542,a+d|0)|0;e=v[113382];v[113382]=0;c:{if((e|0)!=1){d:{if(!d){break b}v[113382]=0;t[c+31|0]=0;Q(1543,a|0,c+31|0)|0;d=v[113382];v[113382]=0;e:{if((d|0)!=1){d=t[c+31|0];if(d){break e}i=i+1|0;break c}break d}t[c+30|0]=0;f:{if((d|0)>=0){break f}v[113382]=0;Q(1543,a|0,c+30|0)|0;e=v[113382];v[113382]=0;if((e|0)!=1){break f}break d}t[c+29|0]=0;oh(c+16|0);g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{v:{w:{x:{y:{z:{A:{d=d&127;d=(d?d-1|0:0)&65535;k=d>>>0>=h>>>0;B:{C:{if(!k){v[113382]=0;g=W(432,b|0,i|0,d|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break d}if(t[c+30|0]&1){break C}break z}g=c+16|0;e=w[c+30|0];if(!(e&1)){break B}}v[113382]=0;Q(1543,a|0,c+29|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break d}if(d>>>0<h>>>0){break A}e=w[c+30|0]}if(e&2){break y}break x}e=w[c+29|0];l=Lc(f,d),m=e,t[l|0]=m}l=g,m=w[Lc(f,d)|0],t[l|0]=m;if(!(w[c+30|0]&2)){break v}}v[113382]=0;Q(1543,a|0,c+29|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break d}if(d>>>0<h>>>0){break w}e=w[c+30|0]}if(e&4){break u}break t}e=w[c+29|0];l=Lc(f,d),m=e,t[l+1|0]=m}l=g,m=w[Lc(f,d)+1|0],t[l+1|0]=m;if(!(w[c+30|0]&4)){break r}}v[113382]=0;Q(1543,a|0,c+29|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break d}if(d>>>0<h>>>0){break s}e=w[c+30|0]}if(e&8){break q}break p}e=w[c+29|0];l=Lc(f,d),m=e,t[l+2|0]=m}l=g,m=w[Lc(f,d)+2|0],t[l+2|0]=m;if(!(w[c+30|0]&8)){break n}}v[113382]=0;Q(1543,a|0,c+29|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break d}if(d>>>0<h>>>0){break o}e=w[c+30|0]}if(e&16){break m}break l}e=w[c+29|0];l=Lc(f,d),m=e,t[l+4|0]=m}l=g,m=w[Lc(f,d)+4|0],t[l+4|0]=m;if(!(w[c+30|0]&16)){break j}}v[113382]=0;Q(1543,a|0,c+29|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break d}if(d>>>0<h>>>0){break k}e=w[c+30|0]}if(e&32){break i}break g}e=w[c+29|0];l=Lc(f,d),m=e,t[l+3|0]=m}l=g,m=w[Lc(f,d)+3|0],t[l+3|0]=m;if(!(w[c+30|0]&32)){break h}}v[113382]=0;Q(1543,a|0,c+29|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break d}if(k){break g}e=w[c+29|0];l=Lc(f,d),m=e,t[l+5|0]=m}l=g,m=w[Lc(f,d)+5|0],t[l+5|0]=m}if(!(w[c+30|0]&64)){break c}v[113382]=0;Q(1543,a|0,c+15|0)|0;d=v[113382];v[113382]=0;if((d|0)!=1){d=w[c+15|0];v[113382]=0;W(1544,a|0,d|0,-1)|0;d=v[113382];v[113382]=0;if((d|0)!=1){break c}}}}a=P()|0;O()|0;Ml(f);S(a|0);L()}if(i>>>0<j>>>0){continue}break}}Ml(f)}jb=c+48|0}function tba(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,y=0,z=0,A=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;g=jb-32|0;jb=g;r=a+4|0;p=v[r>>2];m=a+20|0;A=v[Qc(m,b)+16>>2];a:{if(A+1>>>0<2){break a}h=(B(b,896)+p|0)+608|0;if(!Kh(h)){if(!w[Qc(m,b)+20|0]){break a}}i=B(b,896)+p|0;if(!v[i+712>>2]){break a}j=v[i+696>>2]&2;f=v[(j?i+692|0:i+684|0)>>2];s=v[i+692>>2];u=v[i+688>>2];e=g+24|0;Fb(e,v[a>>2]+1074312|0,31);D=Cb(e);E=i+1356|0;k=w[E|0];F=i+616|0;e=Pu(F,c);y=mb;n=y;v[g+24>>2]=e;v[g+28>>2]=n;if(w[i+696|0]&128){v[g+24>>2]=0-e;v[g+28>>2]=0-(((e|0)!=0)+n|0)}e=0;I=e;n=f;G=j?e:0;e=u;q=j?e:0;l=s-e|0;s=l<<1;e=B(b,896)+p|0;H=e;y=e+1308|0;o=e+1480|0;u=(k&17)!=1;b:{while(1){c:{if(d>>>0>z>>>0){f=(w[E|0]&17)==1;break c}t[o|0]=w[o|0]&254;k=Bf(Zb(v[a>>2]+484344|0,x[v[r>>2]+60>>1]),v[v[r>>2]+48>>2],b);j=w[k+3|0];if(w[k+2|0]==11){f=g+16|0;ry(f,v[a>>2],k,0);e=jc(f);Zm(v[a>>2],h,v[f>>2]);f=1;if(w[e|0]){break c}}f=1;d:{switch(j-4|0){case 0:Zm(v[a>>2],h,w[k+5|0]);break c;case 2:break d;default:break c}}Zm(v[a>>2],h,0)}v[g+12>>2]=v[y>>2];if(D){qs(v[a>>2],h)}if(!u){TK(v[a>>2],h,g+12|0);f=1}if(!D){qs(v[a>>2],h)}v[g+8>>2]=0;VK(h,g+8|0);e:{f:{if(w[i+697|0]&2){break f}g:{if(!f){if(!w[Qc(m,b)+20|0]){break g}}if(w[o|0]&12){_N(h,C(1),0,v[a>>2]);e=w[o|0];t[o|0]=(e&8?-9:-5)&e}J=H,K=Sx(v[a>>2],h,v[g+12>>2],0),v[J+616>>2]=K;v[H+620>>2]=mb;J=Qc(m,b),K=0,t[J+20|0]=K;e=Pu(F,c);j=mb;f=j;v[g+24>>2]=e;v[g+28>>2]=f;if(!(w[i+696|0]&128)){break g}v[g+24>>2]=0-e;v[g+28>>2]=0-(((e|0)!=0)+f|0)}Sb(h,g+24|0);k=v[h>>2];e=v[h+4>>2];if(k>>>0<I>>>0&(e|0)<=(n|0)|(e|0)<(n|0)){if((e|0)>=(q|0)&k>>>0>=G>>>0|(e|0)>(q|0)){break f}f=v[g+28>>2];if((f|0)>0|(f|0)>=0){break f}}f=v[i+696>>2];if(!(f&2)){break e}if(f&4){if(k>>>0<G>>>0&(e|0)<=(q|0)|(e|0)<(q|0)){f=v[i+688>>2]<<1;v[g+16>>2]=0;v[g+20>>2]=f;J=h,K=pg(g+16|0,h),v[J>>2]=K;v[h+4>>2]=mb;v[i+696>>2]=v[i+696>>2]^128;f=v[g+24>>2];e=0-(v[g+28>>2]+((f|0)!=0)|0)|0;v[g+24>>2]=0-f;v[g+28>>2]=e;e=v[h+4>>2]}j=v[i+688>>2];f=g+16|0;Fb(f,v[a>>2]+1074312|0,33);f=(e-j>>>0)%(s-Cb(f)>>>0)|0;e=f>>>0<l>>>0;h:{if(!e){v[h+4>>2]=v[i+692>>2]+(l-f|0);f=v[i+696>>2];if(!(e^(f&128)>>>7)){break h}break f}v[h+4>>2]=f+v[i+688>>2];f=v[i+696>>2];if(e^(f&128)>>>7){break f}}v[i+696>>2]=f^128;f=v[g+24>>2];e=0-(v[g+28>>2]+((f|0)!=0)|0)|0;v[g+24>>2]=0-f;v[g+28>>2]=e;break f}f=e;j=v[i+692>>2];if(e>>>0>=j+l>>>0){f=j+((f-j>>>0)%(l>>>0)|0)|0}while(1){e=f;f=e-l|0;if(e>>>0>=j>>>0){continue}break}v[h>>2]=k;v[h+4>>2]=e}z=z+1|0;if((A|0)!=(z|0)){continue}break b}break}aO(h);v[(B(b,896)+p|0)+1316>>2]=0}J=Qc(m,b),K=0,v[J+16>>2]=K}jb=g+32|0}function g2(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=jb-192|0;jb=d;a:{if(nj(b)){break a}e=w[gk(b)|0];if((e|0)==33){c=1}else{if((e|0)!=63){break a}c=0}rk(d+160|0,b,v[b+4>>2]-1|0);e=v[d+164>>2];v[b>>2]=v[d+160>>2];v[b+4>>2]=e}g=d+160|0;Ad(g);e=v[d+160>>2];Ad(d+144|0);e=fk(e,v[d+148>>2],b);Ad(g);b:{c:{d:{e:{f:{g:{if((e|0)==v[d+164>>2]){a=v[b+4>>2];v[d+184>>2]=v[b>>2];v[d+188>>2]=a;a=qc(d+176|0,17540);e=v[d+188>>2];v[d+8>>2]=v[d+184>>2];v[d+12>>2]=e;e=v[a+4>>2];v[d>>2]=v[a>>2];v[d+4>>2]=e;if(Hc(d+8|0,d)){a=ba(8)|0;v[113382]=0;c=Q(121,d+160|0,6570)|0;b=v[113382];v[113382]=0;if((b|0)==1){break f}nc(a,c);v[113382]=0;U(1978,a|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break b}b=P()|0;O()|0;yb(c);break c}f=0;if(!c){break g}a=ba(8)|0;v[113382]=0;c=Q(2111,d+144|0,b|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){v[113382]=0;U(2088,d+160|0,13678,c|0);b=v[113382];v[113382]=0;if((b|0)==1){break e}nc(a,d+160|0);v[113382]=0;U(1978,a|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break b}b=P()|0;O()|0;yb(d+160|0);yb(c);break c}b=P()|0;O()|0;break d}if(v[e+4>>2]!=2){a=ba(8)|0;v[113382]=0;c=Q(121,d+160|0,7618)|0;b=v[113382];v[113382]=0;if((b|0)!=1){nc(a,c);v[113382]=0;U(1978,a|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break b}b=P()|0;O()|0;yb(c);break c}b=P()|0;O()|0;ca(a|0);break c}c=v[b+4>>2];v[d+136>>2]=v[b>>2];v[d+140>>2]=c;c=qc(d+128|0,17540);e=v[d+140>>2];v[d+72>>2]=v[d+136>>2];v[d+76>>2]=e;e=v[c+4>>2];v[d+64>>2]=v[c>>2];v[d+68>>2]=e;if(Hc(d+72|0,d- -64|0)){a=ba(8)|0;v[113382]=0;c=Q(121,d+160|0,6570)|0;b=v[113382];v[113382]=0;if((b|0)!=1){nc(a,c);v[113382]=0;U(1978,a|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break b}b=P()|0;O()|0;yb(c);break c}b=P()|0;O()|0;ca(a|0);break c}c=v[b+4>>2];v[d+120>>2]=v[b>>2];v[d+124>>2]=c;c=qc(d+112|0,3991);e=v[d+124>>2];v[d+56>>2]=v[d+120>>2];v[d+60>>2]=e;e=v[c+4>>2];v[d+48>>2]=v[c>>2];v[d+52>>2]=e;if(Hc(d+56|0,d+48|0)){f=1;if(!w[a+28|0]){break g}f=65536/+y[v[a+24>>2]+480244>>2];break g}c=v[b+4>>2];v[d+104>>2]=v[b>>2];v[d+108>>2]=c;c=qc(d+96|0,4043);e=v[d+108>>2];v[d+40>>2]=v[d+104>>2];v[d+44>>2]=e;e=v[c+4>>2];v[d+32>>2]=v[c>>2];v[d+36>>2]=e;if(Hc(d+40|0,d+32|0)){f=1;if(!w[a+28|0]){break g}f=+y[v[a+24>>2]+480240>>2]*152587890625e-16;break g}c=v[b+4>>2];v[d+88>>2]=v[b>>2];v[d+92>>2]=c;b=qc(d+80|0,4061);c=v[d+92>>2];v[d+24>>2]=v[d+88>>2];v[d+28>>2]=c;c=v[b+4>>2];v[d+16>>2]=v[b>>2];v[d+20>>2]=c;f=0;if(!Hc(d+24|0,d+16|0)){break g}f=+y[v[a+24>>2]+480236>>2]*152587890625e-16}jb=d+192|0;return+f}b=P()|0;O()|0;ca(a|0);break c}b=P()|0;O()|0;yb(c)}ca(a|0)}S(b|0)}L()}function K3(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=jb-128|0;jb=e;a:{if(Sc(b)){break a}f=w[aI(b)|0];if((f|0)==33){d=1}else{if((f|0)!=63){break a}d=0}f=e+112|0;tr(f,b,0,Db(b)-1|0);Gb(b,f);yb(f)}g=e+112|0;Ad(g);f=v[e+112>>2];Ad(e+96|0);f=$H(f,v[e+100>>2],b);Ad(g);b:{c:{d:{e:{f:{if((f|0)==v[e+116>>2]){if(Pd(b,17540)){a=ba(8)|0;v[113382]=0;U(2105,e+112|0,13642,c|0);b=v[113382];v[113382]=0;if((b|0)==1){break e}nc(a,e+112|0);v[113382]=0;U(1978,a|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break c}b=P()|0;O()|0;yb(e+112|0);break d}if(!d){break f}a=ba(8)|0;v[113382]=0;U(2105,e+80|0,13678,b|0);b=v[113382];v[113382]=0;g:{h:{i:{j:{if((b|0)!=1){v[113382]=0;U(2106,e+96|0,e+80|0,13652);b=v[113382];v[113382]=0;if((b|0)==1){break j}v[113382]=0;U(765,e+112|0,e+96|0,c|0);b=v[113382];v[113382]=0;c=1;if((b|0)==1){break i}nc(a,e+112|0);v[113382]=0;U(1978,a|0,78672,1986);b=v[113382];v[113382]=0;if((b|0)!=1){break c}b=P()|0;O()|0;yb(e+112|0);c=0;break h}b=P()|0;O()|0;break g}b=P()|0;O()|0;yb(e+80|0);break g}b=P()|0;O()|0}yb(e+96|0);yb(e+80|0);if(!c){break d}}ca(a|0);break d}k:{switch(v[f+4>>2]){case 0:Hh(e+72|0,b);b=(JG(c)|0)!=0;c=v[e+76>>2];v[e>>2]=v[e+72>>2];v[e+4>>2]=c;_H(a,e,b,d);break f;case 1:Hh(e- -64|0,b);b=jb-160|0;jb=b;c=Im(b+16|0,c,8);f=v[v[c>>2]-12>>2];v[113382]=0;g=da(123)|0;h=v[113382];v[113382]=0;l:{if((h|0)==1){break b}v[113382]=0;U(124,b+8|0,f+(b+16|0)|0,g|0);f=v[113382];v[113382]=0;if((f|0)==1){break b}Ob(b+8|0);v[113382]=0;f=Q(155,c|0,b|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break b}g=v[v[f>>2]-12>>2];v[113382]=0;f=T(151,f+g|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break b}g=v[b>>2];h=v[b+4>>2];Mf(c);jb=b+160|0;b=f?0:g;c=f?0:h;break l}f=v[e+68>>2];v[e+8>>2]=v[e+64>>2];v[e+12>>2]=f;ZH(a,e+8|0,b,c,d);break f;case 2:Hh(e+56|0,b);b=jb-160|0;jb=b;c=Im(b+16|0,c,8);f=v[v[c>>2]-12>>2];v[113382]=0;g=da(123)|0;h=v[113382];v[113382]=0;m:{if((h|0)==1){break b}v[113382]=0;U(124,b+8|0,f+(b+16|0)|0,g|0);f=v[113382];v[113382]=0;if((f|0)==1){break b}Ob(b+8|0);v[113382]=0;f=Q(156,c|0,b|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break b}g=v[v[f>>2]-12>>2];v[113382]=0;f=T(151,f+g|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break b}i=A[b>>3];Mf(c);jb=b+160|0;i=f?0:i;break m}b=v[e+60>>2];v[e+16>>2]=v[e+56>>2];v[e+20>>2]=b;YH(a,e+16|0,i,d);break f;case 3:break k;default:break f}}Hh(e+48|0,b);Hh(e+40|0,c);b=v[e+52>>2];v[e+32>>2]=v[e+48>>2];v[e+36>>2]=b;b=v[e+44>>2];v[e+24>>2]=v[e+40>>2];v[e+28>>2]=b;XH(a,e+32|0,e+24|0,d)}jb=e+128|0;return}b=P()|0;O()|0;ca(a|0)}S(b|0)}L()}a=P()|0;O()|0;Mf(c);S(a|0);L()}function eja(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;f=jb-16|0;jb=f;a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{s:{t:{u:{v:{w:{x:{y:{z:{g=w[a+3|0];switch(g-4|0){case 23:break j;case 22:break k;case 21:break l;case 20:break m;case 18:break n;case 17:break o;case 16:break p;case 14:break q;case 13:break r;case 12:break s;case 11:break t;case 10:break u;case 9:break v;case 8:break w;case 5:break x;case 4:break y;case 0:break z;case 42:break c;case 37:break d;case 28:break e;case 27:break f;case 26:break g;case 25:break h;case 24:break i;default:break b}}t[a+3|0]=5;t[f+15|0]=w[a+5|0]>>>3;t[f+14|0]=15;b=w[pc(f+15|0,f+14|0)|0];t[f+13|0]=w[a+5|0]<<1&30;t[f+12|0]=15;h=a,i=w[pc(f+13|0,f+12|0)|0]|b<<4,t[h+5|0]=i;break a}t[a+3|0]=0;break a}if((w[a+5|0]-1&255)>>>0<=19){t[a+3|0]=16;break a}t[a+3|0]=0;break a}t[a+3|0]=13;b=w[a+5|0];A:{if(!e){if(b>>>0>152){break A}t[a+5|0]=B((b&240)>>>4|0,10)+(b&15);break a}t[a+5|0]=(b&127)+1>>>1;break a}t[a+3|0]=0;break a}t[a+3|0]=11;break a}t[a+3|0]=0;break a}e=w[a+5|0];if(!e){t[a+3|0]=14;break a}if(e>>>0<=240){t[a+3|0]=17;if(e>>>0<=2){t[a+5|0]=112;break a}h=a,i=tt(+(RQ(e,b,c,d)>>>0)*1e-4),t[h+5|0]=i;break a}t[a+3|0]=0;break a}t[a+3|0]=31;t[a+5|0]=w[a+5|0]|128;break a}t[a+3|0]=19;t[f+11|0]=15;h=a,i=w[pc(a+5|0,f+11|0)|0]|16,t[h+5|0]=i;break a}t[a+3|0]=19;t[f+10|0]=15;h=a,i=w[pc(a+5|0,f+10|0)|0]|32,t[h+5|0]=i;break a}t[a+3|0]=5;t[f+9|0]=(w[a+5|0]>>>4|0)+1;t[f+8|0]=15;b=pc(f+9|0,f+8|0);t[a+5|0]=w[a+5|0]&15|w[b|0]<<4;break a}t[a+3|0]=19;t[a+5|0]=w[a+5|0]&15|80;break a}t[a+3|0]=19;t[f+7|0]=15;h=a,i=w[pc(a+5|0,f+7|0)|0]|96,t[h+5|0]=i;break a}t[a+3|0]=19;t[f+6|0]=15;h=a,i=w[pc(a+5|0,f+6|0)|0]|192,t[h+5|0]=i;break a}t[a+3|0]=10;break a}t[a+3|0]=19;t[f+5|0]=15;h=a,i=w[pc(a+5|0,f+5|0)|0]|160,t[h+5|0]=i;break a}t[a+3|0]=19;t[f+4|0]=15;h=a,i=w[pc(a+5|0,f+4|0)|0]|176,t[h+5|0]=i;break a}b=(w[a+5|0]<<24)-16777216>>24;if((b|0)>=0){t[a+5|0]=b;t[a+3|0]=31;break a}t[a+3|0]=0;break a}t[a+3|0]=14;break a}t[a+3|0]=19;t[f+3|0]=15;h=a,i=w[pc(a+5|0,f+3|0)|0]|224,t[h+5|0]=i;break a}b=w[a+5|0];if(b&240){t[a+3|0]=19;t[a+5|0]=b>>>4|208;break a}if(b&15){t[a+3|0]=19;t[a+5|0]=b|144;break a}t[a+3|0]=0;break a}if(!(w[a+5|0]|w[a+4|0])){t[a+5|0]=159;t[a+3|0]=20;break a}t[a+3|0]=0;break a}b=w[a+4|0];if(b){t[a+3|0]=41;h=a,i=Qk(dd(((w[a+5|0]<<8&65280)>>>0)/(b>>>0)|0,0)),t[h+5|0]=i;break a}t[a+3|0]=0;break a}b=w[a+5|0];if((b-17&255)>>>0>=223){t[a+3|0]=9;h=a,i=Hk(((b^128)<<3)-896|0),t[h+5|0]=i;break a}t[a+3|0]=0;break a}if(g>>>0<=15){vj(a);break a}t[a+3|0]=0}jb=f+16|0}function via(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,x=0;f=jb-560|0;jb=f;a:{if(!Nc(b,1464)){break a}if(!wn(b,f+556|0)){break a}Id(a,1);d=a+1074312|0;ig(d,83);Nb(d,84,1);Nb(d,85,1);b:{if(Vd(f+556|0,24098)){d=f+32|0;e=Ub(d,4718);Gb(a+1304436|0,e);yb(e);e=Ub(d,10497);Gb(a+1304448|0,e);yb(e);d=Ub(d,10562);Gb(a+1304460|0,d);break b}if(!Vd(f+556|0,11763)){break a}d=f+32|0;e=Ub(d,4860);Gb(a+1304436|0,e);yb(e);e=Ub(d,8250);Gb(a+1304448|0,e);yb(e);d=Ub(d,11413);Gb(a+1304460|0,d)}yb(d);v[a+1304496>>2]=2;d=0;Nc(b,0);dA(b,a+1304400|0,20);u[a+480190>>1]=31;e=1;while(1){d=wz(b,f+32|0,(B(e,104)+a|0)+484380|0,((e<<5)+a|0)+946304|0,1)+d|0;e=e+1|0;if((e|0)!=32){continue}break}if(d>>>0>40){break a}j=f+552|0;tu(j,b);m=Zc(j);if(w[j|0]>128){break a}e=f+32|0;g=e;h=jb-16|0;jb=h;d=b;c:{if(Rb(d,512)){i=h+8|0;du(i,g);zd(d,i);break c}SP(g)}jb=h+16|0;d=f+544|0;g=w[m|0];d:{while(1){if(g>>>0>=w[e|0]){e=e+1|0;if((d|0)!=(e|0)){continue}break d}break}break a}o=1;if(!c){break a}v[a+480260>>2]=56;v[a+480264>>2]=13696;v[a+480204>>2]=125e4;v[a+480196>>2]=6;u[a+480192>>1]=0;u[a+480188>>1]=4;v[a+480228>>2]=64;v[a+480208>>2]=v[a+480208>>2]|18874368;mj(a,0);n=a+484360|0;lg(Vb(n),w[j|0]);u[f+30>>1]=0;i=a+484344|0;dg(i,w[j|0]);if(w[j|0]){g=0;while(1){s=rc(Vb(n),g),x=g,u[s>>1]=x;if(Og(i,g&65535,64)){p=g<<2;h=0;while(1){Nc(b,(w[f+32+(h+p)|0]<<8)+1468|0);e=Bf(Zb(i,g),0,h&65535);d=0;while(1){nt(b,e);e:{f:{l=w[e+3|0];g:{if((l|0)!=14){if(!l){if(w[e+5|0]){break f}break g}if((l-5&255)>>>0<5){break g}break f}if(w[e+5|0]<=15){break f}}t[e+3|0]=0;break e}vj(e)}e=e+24|0;d=d+1|0;if((d|0)!=64){continue}break}h=h+1|0;if((h|0)!=4){continue}break}s=f,x=ac(Zb(i,g)),v[s+24>>2]=x;h=0;while(1){d=0;while(1){e=d;d=w[v[f+24>>2]+3|0];h:{if((d|0)!=16&(d|0)!=17){break h}t[v[f+24>>2]+3|0]=16;k=0;if(w[v[f+24>>2]+5|0]<16){break h}d=w[v[f+24>>2]+5|0];if(!((d&15)==(d>>>4|0)|!(d&15))){d=w[v[f+24>>2]+5|0];q=d>>>4|0;r=d&15;k=1}d=v[f+24>>2];t[d+5|0]=w[d+5|0]>>>4}Bj(f+24|0);d=e+1|0;if((e&65535)>>>0<3){continue}break}t[f+31|0]=r;t[f+30|0]=q;d=k&255;if(d){sl(Zb(i,g),Me(Ln(f+8|0,16,w[(d+f|0)+29|0]),h));d=k+1|0;k=(d&255)==3?1:d}else{k=0}h=h+1|0;if((h|0)!=64){continue}break}}g=g+1|0;if(g>>>0<w[j|0]){continue}break}}if(!(c&2)){break a}Nc(b,(w[m|0]<<8)+1468|0);e=1;while(1){c=(B(e,104)+a|0)+484380|0;if(v[c>>2]){zg(Yc(f+8|0,8,1,0,0),c,b)}e=e+1|0;if((e|0)!=32){continue}break}}jb=f+560|0;return o|0}function lU(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;f=jb-384|0;jb=f;Ic(b);e=jb-16|0;jb=e;h=e+8|0;g=f+344|0;vB(h,g);i=Hb(h);d=b;h=mc(d,$b(e,h));if((i|0)==(h|0)){_b(d,Hb(e+8|0))}jb=e+16|0;d=(i|0)==(h|0);if(!d){wB(g)}a:{b:{if(!d){break b}if(!KB(f+344|0)){break b}if(!Rb(b,dd(JB(f+344|0),mb))){break b}c:{if(!c){break c}Id(a,2097152);vi(a);j=1;mj(a,1);u[a+480188>>1]=8;v[a+480196>>2]=w[f+376|0];v[a+480204>>2]=B(w[f+377|0],1e4);u[a+480190>>1]=w[f+378|0];if(w[f+381|0]<w[f+380|0]){Ne(Vb(a+484360|0),w[f+381|0])}d=f+80|0;e=Ub(d,2848);Gb(a+1304436|0,e);yb(e);e=Ub(d,7109);Gb(a+1304448|0,e);yb(e);v[a+1304496>>2]=4;uu(b,d);fq(Vb(a+484360|0),d,w[f+380|0],65535,65535);if(x[a+480190>>1]){k=1;while(1){h=f+40|0;IB(b,h);l=jb-16|0;jb=l;i=(B(j,104)+a|0)+484380|0;sd(i,0);d=h;t[i+37|0]=w[d+22|0]<<4;t[l+15|0]=w[d+23|0];t[l+14|0]=64;m=i,n=w[pc(l+15|0,l+14|0)|0]<<2,u[m+30>>1]=n;t[i+36|0]=w[d+24|0];e=d+25|0;v[i>>2]=w[e|0]|w[e+1|0]<<8|(w[e+2|0]<<16|w[e+3|0]<<24);g=d+33|0;d:{if((w[g|0]|w[g+1|0]<<8|(w[g+2|0]<<16|w[g+3|0]<<24))>>>0<3){break d}d=d+29|0;if((w[d|0]|w[d+1|0]<<8|(w[d+2|0]<<16|w[d+3|0]<<24))+(w[g|0]|w[g+1|0]<<8|(w[g+2|0]<<16|w[g+3|0]<<24))>>>0>(w[e|0]|w[e+1|0]<<8|(w[e+2|0]<<16|w[e+3|0]<<24))>>>0){break d}u[i+34>>1]=x[i+34>>1]|2;v[i+4>>2]=w[d|0]|w[d+1|0]<<8|(w[d+2|0]<<16|w[d+3|0]<<24);v[i+8>>2]=(w[d|0]|w[d+1|0]<<8|(w[d+2|0]<<16|w[d+3|0]<<24))+(w[g|0]|w[g+1|0]<<8|(w[g+2|0]<<16|w[g+3|0]<<24))}jb=l+16|0;d=f+8|0;Vl(d,2,h);e=f+24|0;Ec(e,d);v[113382]=0;Q(335,((j<<5)+a|0)+946304|0,e|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break a}yb(f+24|0);k=k+1|0;j=k&65535;if(j>>>0<=x[a+480190>>1]){continue}break}}_b(b,B(64-w[f+378|0]|0,37));h=a+484344|0;dg(h,w[f+379|0]);if(w[f+379|0]){g=c&1;k=0;while(1){e:{f:{if(g){if(Og(h,k&65535,64)){break f}}_b(b,2048);break e}d=Zb(h,k);m=f,n=ac(d),v[m+40>>2]=n;m=f,n=bc(d),v[m+24>>2]=n;if(!Jb(f+40|0,f+24|0)){break e}while(1){d=v[f+40>>2];e=f+8|0;Ul(e,b);j=Zc(e);i=Cf(e);l=Ph(e);e=w[e|0];if((e-1&255)>>>0<=106){t[d|0]=e+13}t[d+1|0]=w[j|0];t[d+3|0]=w[i|0];t[d+5|0]=w[l|0];vj(d);d=f+40|0;Bj(d);if(Jb(d,f+24|0)){continue}break}}k=k+1|0;if(k>>>0<w[f+379|0]){continue}break}}if(!(c&2)){break c}j=1;c=Yc(f+40|0,8,1,0,0);if(!x[a+480190>>1]){break c}while(1){zg(c,(B(j&65535,104)+a|0)+484380|0,b);j=j+1|0;if(x[a+480190>>1]>=(j&65535)>>>0){continue}break}}j=1}jb=f+384|0;return j|0}a=P()|0;O()|0;yb(f+24|0);S(a|0);L()}function mG(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,k=0,m=0;g=jb-48|0;jb=g;o(+a);d=j(1)|0;f=j(0)|0;a:{b:{e=d;d=e;h=e&2147483647;c:{if(h>>>0<=1074752122){if((d&1048575)==598523){break c}if(h>>>0<=1073928572){if((e|0)>0|(e|0)>=0){a=a+-1.5707963267341256;c=a+-6.077100506506192e-11;A[b>>3]=c;A[b+8>>3]=a-c+-6.077100506506192e-11;d=1;break a}a=a+1.5707963267341256;c=a+6.077100506506192e-11;A[b>>3]=c;A[b+8>>3]=a-c+6.077100506506192e-11;d=-1;break a}if((e|0)>0|(e|0)>=0){a=a+-3.1415926534682512;c=a+-1.2154201013012384e-10;A[b>>3]=c;A[b+8>>3]=a-c+-1.2154201013012384e-10;d=2;break a}a=a+3.1415926534682512;c=a+1.2154201013012384e-10;A[b>>3]=c;A[b+8>>3]=a-c+1.2154201013012384e-10;d=-2;break a}if(h>>>0<=1075594811){if(h>>>0<=1075183036){if((h|0)==1074977148){break c}if((e|0)>0|(e|0)>=0){a=a+-4.712388980202377;c=a+-1.8231301519518578e-10;A[b>>3]=c;A[b+8>>3]=a-c+-1.8231301519518578e-10;d=3;break a}a=a+4.712388980202377;c=a+1.8231301519518578e-10;A[b>>3]=c;A[b+8>>3]=a-c+1.8231301519518578e-10;d=-3;break a}if((h|0)==1075388923){break c}if((e|0)>0|(e|0)>=0){a=a+-6.2831853069365025;c=a+-2.430840202602477e-10;A[b>>3]=c;A[b+8>>3]=a-c+-2.430840202602477e-10;d=4;break a}a=a+6.2831853069365025;c=a+2.430840202602477e-10;A[b>>3]=c;A[b+8>>3]=a-c+2.430840202602477e-10;d=-4;break a}if(h>>>0>1094263290){break b}}k=a*.6366197723675814+6755399441055744+-6755399441055744;c=a+k*-1.5707963267341256;i=k*6.077100506506192e-11;a=c-i;A[b>>3]=a;o(+a);d=j(1)|0;j(0)|0;e=h>>>20|0;f=(e-(d>>>20&2047)|0)<17;if(D(k)<2147483648){d=~~k}else{d=-2147483648}d:{if(f){break d}i=c;a=k*6.077100506303966e-11;c=c-a;i=k*2.0222662487959506e-21-(i-c-a);a=c-i;A[b>>3]=a;f=e;o(+a);e=j(1)|0;j(0)|0;if((f-(e>>>20&2047)|0)<50){break d}i=c;a=k*2.0222662487111665e-21;c=c-a;i=k*8.4784276603689e-32-(i-c-a);a=c-i;A[b>>3]=a}A[b+8>>3]=c-a-i;break a}if(h>>>0>=2146435072){a=a-a;A[b>>3]=a;A[b+8>>3]=a;d=0;break a}l(0,f|0);l(1,e&1048575|1096810496);a=+n();d=0;f=1;while(1){m=(g+16|0)+(d<<3)|0;if(D(a)<2147483648){d=~~a}else{d=-2147483648}c=+(d|0);A[m>>3]=c;a=(a-c)*16777216;d=1;m=f&1;f=0;if(m){continue}break}A[g+32>>3]=a;e:{if(a!=0){d=2;break e}f=1;while(1){d=f;f=d-1|0;if(A[(g+16|0)+(d<<3)>>3]==0){continue}break}}d=pG(g+16|0,g,(h>>>20|0)-1046|0,d+1|0,1);a=A[g>>3];if((e|0)<0){A[b>>3]=-a;A[b+8>>3]=-A[g+8>>3];d=0-d|0;break a}A[b>>3]=a;A[b+8>>3]=A[g+8>>3]}jb=g+48|0;return d}function e$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;k=jb-16|0;jb=k;m=Yv(g);o=Xv(g);vg(k,o);v[f>>2]=d;a:{b:{c:{i=a;g=w[i|0];switch(g-43|0){case 0:case 2:break c;default:break b}}v[113382]=0;g=Q(2366,m|0,g<<24>>24)|0;i=v[113382];v[113382]=0;if((i|0)==1){break a}i=v[f>>2];v[f>>2]=i+4;v[i>>2]=g;i=a+1|0}d:{g=i;if(!((c-g|0)<=1|w[g|0]!=48|(w[g+1|0]|32)!=120)){v[113382]=0;g=Q(2366,m|0,48)|0;h=v[113382];v[113382]=0;if((h|0)==1){break a}h=v[f>>2];v[f>>2]=h+4;v[h>>2]=g;g=t[i+1|0];v[113382]=0;g=Q(2366,m|0,g|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break a}h=v[f>>2];v[f>>2]=h+4;v[h>>2]=g;i=i+2|0;g=i;while(1){if(c>>>0<=g>>>0){break d}h=t[g|0];v[113382]=0;j=da(2335)|0;l=v[113382];v[113382]=0;e:{if((l|0)==1){break e}v[113382]=0;h=iw(h,j);j=v[113382];v[113382]=0;if((j|0)==1){break e}if(!h){break d}g=g+1|0;continue}break}break a}while(1){if(c>>>0<=g>>>0){break d}h=t[g|0];v[113382]=0;da(2335)|0;j=v[113382];v[113382]=0;if((j|0)==1){break a}v[113382]=0;h=eh(h);j=v[113382];v[113382]=0;if((j|0)==1){break a}if(!h){break d}g=g+1|0;continue}}f:{if(Sc(k)){h=v[f>>2];v[113382]=0;aa(2353,m|0,i|0,g|0,h|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break a}v[f>>2]=v[f>>2]+(g-i<<2);break f}l=0;v[113382]=0;Zj(i,g);h=v[113382];v[113382]=0;if((h|0)==1){break a}v[113382]=0;q=T(2350,o|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break a}j=0;h=i;while(1){if(g>>>0<=h>>>0){h=v[f>>2];v[113382]=0;uo((i-a<<2)+d|0,h);i=v[113382];v[113382]=0;if((i|0)!=1){break f}break a}g:{if(t[kc(k,j)|0]<=0){break g}if(t[kc(k,j)|0]!=(l|0)){break g}l=v[f>>2];v[f>>2]=l+4;v[l>>2]=q;j=(Db(k)-1>>>0>j>>>0)+j|0;l=0}p=t[h|0];v[113382]=0;p=Q(2366,m|0,p|0)|0;n=v[113382];v[113382]=0;if((n|0)!=1){n=v[f>>2];v[f>>2]=n+4;v[n>>2]=p;h=h+1|0;l=l+1|0;continue}break}break a}h:{while(1){if(c>>>0>g>>>0){i=w[g|0];if((i|0)==46){v[113382]=0;i=T(2354,o|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break a}j=v[f>>2];h=j+4|0;v[f>>2]=h;v[j>>2]=i;g=g+1|0;break h}v[113382]=0;i=Q(2366,m|0,i<<24>>24)|0;h=v[113382];v[113382]=0;if((h|0)==1){break a}h=v[f>>2];v[f>>2]=h+4;v[h>>2]=i;g=g+1|0;continue}break}h=v[f>>2]}v[113382]=0;aa(2353,m|0,g|0,c|0,h|0)|0;i=v[113382];v[113382]=0;if((i|0)==1){break a}i=f;f=v[f>>2]+(c-g<<2)|0;v[i>>2]=f;v[e>>2]=(b|0)==(c|0)?f:(b-a<<2)+d|0;yb(k);jb=k+16|0;return}a=P()|0;O()|0;yb(k);S(a|0);L()}function aaa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;h=jb-16|0;jb=h;v[113382]=0;e=T(856,a|0)|0;g=v[113382];v[113382]=0;if((g|0)!=1){a:{b:{if(e){break b}v[113382]=0;e=T(409,a|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break a}i=Ed(e+1|0,1,1024);v[113382]=0;k=d+484344|0;e=W(364,k|0,b|0,i|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break a}if(!e){break b}d=x[d+480188>>1];if(!d|!i){break b}l=d-1|0;while(1){v[113382]=0;d=Q(228,a|0,1)|0;e=v[113382];v[113382]=0;c:{d:{if((e|0)!=1){if(!d){break b}v[113382]=0;g=T(409,a|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break a}if(g){break d}j=j+1|0;break c}break a}d=Zb(k,b);v[113382]=0;u[h+14>>1]=g&31;u[h+12>>1]=l;e=Q(438,h+14|0,h+12|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break a}e=x[e>>1];v[113382]=0;d=W(432,d|0,j|0,e|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break a}if(!(g&224)){break c}e:{if(!(g&128)){break e}v[113382]=0;e=T(409,a|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break a}t[d+5|0]=e;v[113382]=0;e=T(409,a|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break a}f:{if(e>>>0>=26){break f}e=w[e+35968|0];t[d+3|0]=e;g:{switch(e-1|0){case 0:if(!w[d+5|0]){break f}break e;case 12:if(w[d+2|0]){break e}t[d+2|0]=1;e=Ed(w[d+5|0],0,64);t[d+5|0]=0;t[d+3|0]=0;t[d+4|0]=e;break e;case 5:case 6:case 10:case 23:case 28:e=w[d+5|0]&240;if(!e){break e}t[d+5|0]=e;break e;case 8:e=w[d+5|0];if(e>>>0<=128){v[113382]=0;e=T(849,e<<1)|0;f=v[113382];v[113382]=0;if((f|0)==1){break a}t[d+5|0]=e;break e}if((e|0)!=164){break e}t[d+5|0]=145;t[d+3|0]=20;break e;case 13:e=w[d+5|0];t[d+5|0]=B(e>>>4|0,10)+(e&15);break e;case 18:v[113382]=0;Z(576,d|0);e=v[113382];v[113382]=0;if((e|0)!=1){break e}break a;case 16:if(w[d+5|0]>31){break e}t[d+3|0]=16;break e;case 27:break g;default:break e}}m=d;e=w[d+5|0];f=e&240;h:{if((f|0)==16){f=2}else{if((f|0)!=32){break h}f=3}t[m+3|0]=f}t[d+5|0]=e&15|224;break e}t[d+3|0]=0}i:{if(!(g&64)){break i}v[113382]=0;R(433,h+8|0,a|0);e=v[113382];v[113382]=0;if((e|0)==1){break a}e=h+8|0;f=Zc(e);t[d+1|0]=w[e|0];e=w[f|0];t[d|0]=e;f=255;if((e|0)!=128){f=253;if(e>>>0<129){break i}}t[d|0]=f}if(!(g&32)){break c}t[d+2|0]=1;v[113382]=0;e=T(409,a|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break a}t[d+4|0]=e;if(!c){break c}t[d+4|0]=(e<<6>>>0)/127}if(j>>>0<i>>>0){continue}break}}Bb(a);jb=h+16|0;return}}b=P()|0;O()|0;Bb(a);S(b|0);L()}function CP(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=jb-80|0;jb=e;a:{if(v[b+4>>2]==v[d+4>>2]){f=v[b+4>>2];v[e+72>>2]=v[b>>2];v[e+76>>2]=f;b=v[c+4>>2];v[e+64>>2]=v[c>>2];v[e+68>>2]=b;f=Dd(e+56|0,d);b=v[e+76>>2];v[e+8>>2]=v[e+72>>2];v[e+12>>2]=b;b=v[e+68>>2];v[e>>2]=v[e+64>>2];v[e+4>>2]=b;b=jb-16|0;jb=b;d=Ci(e,e+8|0);v[b+12>>2]=d;b:{if((d|0)<=0){break b}c=v[e+12>>2];c:{if(!c){c=v[f>>2];break c}g=32-c|0;v[b+8>>2]=g;c=v[Zd(b+8|0,b+12|0)>>2];v[b+12>>2]=v[b+12>>2]-c;d=v[f>>2];g=-1<<v[e+12>>2]&-1>>>g-c;h=v[e+8>>2];v[d>>2]=v[d>>2]&(g^-1)|g&v[h>>2];c=c+v[f+4>>2]|0;v[f+4>>2]=c&31;c=d+(c>>>3&536870908)|0;v[f>>2]=c;v[e+8>>2]=h+4;d=v[b+12>>2]}h=c;d=(d|0)/32|0;c=d<<2;_i(h,v[e+8>>2],c);d=v[b+12>>2]-(d<<5)|0;v[b+12>>2]=d;g=c+v[f>>2]|0;v[f>>2]=g;if((d|0)<=0){break b}c=c+v[e+8>>2]|0;v[e+8>>2]=c;d=-1>>>32-d|0;v[g>>2]=v[g>>2]&(d^-1)|d&v[c>>2];v[f+4>>2]=v[b+12>>2]}Dd(a,f);jb=b+16|0;break a}f=v[b+4>>2];v[e+48>>2]=v[b>>2];v[e+52>>2]=f;b=v[c+4>>2];v[e+40>>2]=v[c>>2];v[e+44>>2]=b;g=Dd(e+32|0,d);b=v[e+52>>2];v[e+24>>2]=v[e+48>>2];v[e+28>>2]=b;b=v[e+44>>2];v[e+16>>2]=v[e+40>>2];v[e+20>>2]=b;f=jb-16|0;jb=f;d=Ci(e+16|0,e+24|0);v[f+12>>2]=d;d:{if((d|0)<=0){break d}b=v[e+28>>2];e:{if(!b){c=v[g+4>>2];break e}c=32-b|0;v[f+8>>2]=c;d=f+8|0;b=v[Zd(d,f+12|0)>>2];v[f+12>>2]=v[f+12>>2]-b;h=v[g+4>>2];j=v[v[e+24>>2]>>2];k=v[e+28>>2];v[f+8>>2]=b;h=32-h|0;v[f+4>>2]=h;l=Lb(d,f+4|0);i=v[g>>2];j=j&(-1<<k&-1>>>c-b);c=v[g+4>>2];d=v[e+28>>2];k=h;h=v[l>>2];v[i>>2]=(c>>>0>d>>>0?j<<c-d:j>>>d-c|0)|v[i>>2]&(-1<<c&-1>>>k-h^-1);k=c+h|0;c=k&31;v[g+4>>2]=c;i=i+(k>>>3&536870908)|0;v[g>>2]=i;b=b-h|0;if((b|0)>0){v[i>>2]=v[i>>2]&(-1>>>32-b^-1)|j>>>d+h;v[g+4>>2]=b;c=b}v[e+24>>2]=v[e+24>>2]+4;d=v[f+12>>2]}i=32-c|0;if((d|0)>=32){k=-1<<c;l=k^-1;h=v[e+24>>2];b=v[g>>2];j=v[b>>2];while(1){d=v[h>>2];v[b>>2]=j&l|d<<c;j=k&v[b+4>>2]|d>>>i;v[b+4>>2]=j;m=v[f+12>>2];d=m-32|0;v[f+12>>2]=d;h=h+4|0;b=b+4|0;if((m|0)>63){continue}break}v[e+24>>2]=h;v[g>>2]=b}if((d|0)<=0){break d}j=v[v[e+24>>2]>>2];v[f+8>>2]=i;b=Zd(f+12|0,f+8|0);c=v[g>>2];h=v[g+4>>2];b=v[b>>2];k=v[c>>2]&(-1<<h&-1>>>i-b^-1);i=j&-1>>>32-d;v[c>>2]=k|i<<h;d=b+h|0;v[g+4>>2]=d&31;c=c+(d>>>3&536870908)|0;v[g>>2]=c;d=v[f+12>>2]-b|0;v[f+12>>2]=d;if((d|0)<=0){break d}v[c>>2]=v[c>>2]&(-1>>>32-d^-1)|i>>>b;v[g+4>>2]=v[f+12>>2]}Dd(a,g);jb=f+16|0}jb=e+80|0}function lX(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;d=jb-336|0;jb=d;e=jb-16|0;jb=e;v[a>>2]=0;f=a+32|0;Nv(f,32);t[e+15|0]=0;po(f,e+15|0);jb=e+16|0;e=v[a+28>>2];a:{if(!Jf(v[v[e>>2]-12>>2]+e|0)){Kg(a,1073741825);break a}e=d- -64|0;pf(e,v[a+28>>2]);f=v[e+12>>2];v[a+8>>2]=v[e+8>>2];v[a+12>>2]=f;f=Oc(e,3);g=v[a+28>>2];h=d+24|0;i=h;e=0;if(v[f>>2]){while(1){zh(g,e+i|0);e=e+1|0;if(e>>>0<y[f>>2]){continue}break}}if(md(h,22880,3)){Kg(a,1073741827);break a}t[d+335|0]=0;zh(v[a+28>>2],d+335|0);e=d- -64|0;TD(e);h=b;i=d+24|0;f=w[d+335|0];if(f){Oj(v[a+28>>2],d- -64|0,f);b=w[d+335|0]}else{b=0}b=qm(i,e,b);e=Cv(h,b);Ib(b);if(!e){Kg(a,1073741830)}if(w[a+3|0]&64){break a}zh(v[a+28>>2],d+63|0);e=w[d+63|0];b=e&3;u[a+16>>1]=(b|0)==3?4:b;if(_h(e,6)){Nj(a,9,1)}v[d+56>>2]=0;HD(v[a+28>>2],d+56|0);b=v[d+56>>2];t[d+55|0]=0;if(b>>>0>=2){zh(v[a+28>>2],d+63|0);f=w[d+63|0];if(!f){zh(v[a+28>>2],d+55|0);f=w[d+63|0]}_k(v[a+28>>2],b+(f?-1:-2)|0,-1)}v[d+40>>2]=0;v[d+44>>2]=0;b:{if(!_h(e,4)){break b}Mj(v[a+28>>2],d+40|0);b=v[d+44>>2];f=v[d+40>>2];v[a+56>>2]=f;v[a+60>>2]=b;g=v[c+4>>2];if((g|0)==(b|0)&y[c>>2]>=f>>>0|b>>>0<g>>>0){break b}Kg(a,536871424)}if(_h(e,5)){zh(v[a+28>>2],d+63|0);_k(v[a+28>>2],w[d+63|0],-1)}c:{if(!_h(w[d+55|0],0)){break c}zh(v[a+28>>2],d+63|0);b=w[d+63|0];b=b&1?-1:b>>>1|0;u[a+16>>1]=b;if(b){break c}Kg(a,536871168)}v[a+4>>2]=0;b=1;if(_h(w[d+55|0],1)){HD(v[a+28>>2],a+4|0)}Nj(a,6,_h(e,2));Nj(a,7,_h(e,3));Nj(a,5,x[a+16>>1]!=0);Nj(a,8,_h(e,7));d:{if(wd(a,5)){break d}if(wd(a,6)){break d}if(wd(a,7)){break d}b=wd(a,8)}Nj(a,11,b);wd(a,11);b=w[d+55|0];if(_h(b,2)){u[d+24>>1]=0;xv(v[a+28>>2],d+24|0);_k(v[a+28>>2],B(x[d+24>>1],wd(a,9)?2:1),-1);b=w[d+55|0]}if(_h(b,3)){_k(v[a+28>>2],5,-1)}Mj(v[a+28>>2],d+40|0);c=v[d+44>>2];b=v[d+40>>2];if(!c&b>>>0>=16001|c){Kg(a,1073741831);break a}v[a+92>>2]=b;if(!b){Kg(a,536871040)}e:{if(!wd(a,11)){break e}Mj(v[a+28>>2],d+40|0);b=v[d+44>>2];if((b|0)==2147483647|b>>>0<2147483647){break e}Kg(a,1073741829);break a}b=d+8|0;pf(b,v[a+28>>2]);hE(d+24|0,b,v[a+8>>2],v[a+12>>2]);b=v[d+36>>2];e=v[d+32>>2];if(!(!b&((b|0)>0|(b|0)>=0))){Kg(a,1073741832);break a}v[a+88>>2]=e;j=a,k=v[(wd(a,11)?d+40|0:a+88|0)>>2],v[j+64>>2]=k;if(!wd(a,11)){c=v[a+12>>2];e=v[a+88>>2];f=e+v[a+8>>2]|0;c=f>>>0<e>>>0?c+1|0:c;v[a+72>>2]=f;v[a+76>>2]=c}Nj(a,10,1)}jb=d+336|0}function o$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;k=jb-16|0;jb=k;m=yu(g);o=cw(g);vg(k,o);v[f>>2]=d;a:{b:{c:{i=a;g=w[i|0];switch(g-43|0){case 0:case 2:break c;default:break b}}v[113382]=0;g=Q(22,m|0,g<<24>>24)|0;i=v[113382];v[113382]=0;if((i|0)==1){break a}i=v[f>>2];v[f>>2]=i+1;t[i|0]=g;i=a+1|0}d:{g=i;if(!((c-g|0)<=1|w[g|0]!=48|(w[g+1|0]|32)!=120)){v[113382]=0;g=Q(22,m|0,48)|0;h=v[113382];v[113382]=0;if((h|0)==1){break a}h=v[f>>2];v[f>>2]=h+1;t[h|0]=g;g=t[i+1|0];v[113382]=0;g=Q(22,m|0,g|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break a}h=v[f>>2];v[f>>2]=h+1;t[h|0]=g;i=i+2|0;g=i;while(1){if(c>>>0<=g>>>0){break d}h=t[g|0];v[113382]=0;j=da(2335)|0;l=v[113382];v[113382]=0;e:{if((l|0)==1){break e}v[113382]=0;h=iw(h,j);j=v[113382];v[113382]=0;if((j|0)==1){break e}if(!h){break d}g=g+1|0;continue}break}break a}while(1){if(c>>>0<=g>>>0){break d}h=t[g|0];v[113382]=0;da(2335)|0;j=v[113382];v[113382]=0;if((j|0)==1){break a}v[113382]=0;h=eh(h);j=v[113382];v[113382]=0;if((j|0)==1){break a}if(!h){break d}g=g+1|0;continue}}f:{if(Sc(k)){h=v[f>>2];v[113382]=0;aa(2330,m|0,i|0,g|0,h|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break a}v[f>>2]=v[f>>2]+(g-i|0);break f}l=0;v[113382]=0;Zj(i,g);h=v[113382];v[113382]=0;if((h|0)==1){break a}v[113382]=0;q=T(2321,o|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break a}j=0;h=i;while(1){if(g>>>0<=h>>>0){h=v[f>>2];v[113382]=0;Zj((i-a|0)+d|0,h);i=v[113382];v[113382]=0;if((i|0)!=1){break f}break a}g:{if(t[kc(k,j)|0]<=0){break g}if(t[kc(k,j)|0]!=(l|0)){break g}l=v[f>>2];v[f>>2]=l+1;t[l|0]=q;j=(Db(k)-1>>>0>j>>>0)+j|0;l=0}p=t[h|0];v[113382]=0;p=Q(22,m|0,p|0)|0;n=v[113382];v[113382]=0;if((n|0)!=1){n=v[f>>2];v[f>>2]=n+1;t[n|0]=p;h=h+1|0;l=l+1|0;continue}break}break a}while(1){h:{if(c>>>0>g>>>0){i=w[g|0];if((i|0)!=46){break h}v[113382]=0;i=T(2331,o|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break a}h=v[f>>2];v[f>>2]=h+1;t[h|0]=i;g=g+1|0}i=v[f>>2];v[113382]=0;aa(2330,m|0,g|0,c|0,i|0)|0;i=v[113382];v[113382]=0;if((i|0)==1){break a}i=f;f=v[f>>2]+(c-g|0)|0;v[i>>2]=f;v[e>>2]=(b|0)==(c|0)?f:(b-a|0)+d|0;yb(k);jb=k+16|0;return}v[113382]=0;i=Q(22,m|0,i<<24>>24)|0;h=v[113382];v[113382]=0;if((h|0)==1){break a}h=v[f>>2];v[f>>2]=h+1;t[h|0]=i;g=g+1|0;continue}}a=P()|0;O()|0;yb(k);S(a|0);L()}function g4(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;a=Xb(a);v[113382]=0;Y(81);c=v[113382];v[113382]=0;a:{b:{if((c|0)==1){c=$a(78672,66740,66716,0)|0;d=O()|0;c:{d:{e:{if((ga(78672)|0)==(d|0)){c=_(c|0)|0;v[113382]=0;Q(1964,a|0,b|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break e}v[113382]=0;Q(1964,a|0,13778)|0;b=v[113382];v[113382]=0;if((b|0)==1){break e}v[113382]=0;Q(1964,a|0,13754)|0;b=v[113382];v[113382]=0;if((b|0)==1){break e}b=nb[v[v[c>>2]+8>>2]](c)|0;v[113382]=0;Q(1964,a|0,(b?b:17540)|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break e}v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){break b}b=P()|0;O()|0;break a}f:{if((ga(66740)|0)==(d|0)){c=_(c|0)|0;v[113382]=0;Q(1964,a|0,b|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break f}v[113382]=0;Q(1964,a|0,13778)|0;b=v[113382];v[113382]=0;if((b|0)==1){break f}v[113382]=0;Q(1964,a|0,13729)|0;b=v[113382];v[113382]=0;if((b|0)==1){break f}b=nb[v[v[c>>2]+8>>2]](c)|0;v[113382]=0;Q(1964,a|0,(b?b:17540)|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break f}v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){break b}b=P()|0;O()|0;break a}e=ga(66716)|0;c=_(c|0)|0;g:{if((d|0)==(e|0)){v[113382]=0;Q(1964,a|0,b|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break g}v[113382]=0;Q(1964,a|0,13778)|0;b=v[113382];v[113382]=0;if((b|0)==1){break g}v[113382]=0;Q(1964,a|0,13745)|0;b=v[113382];v[113382]=0;if((b|0)==1){break g}b=nb[v[v[c>>2]+8>>2]](c)|0;v[113382]=0;Q(1964,a|0,(b?b:17540)|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break g}v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){break b}b=P()|0;O()|0;break a}v[113382]=0;Q(1964,a|0,b|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break d}v[113382]=0;Q(1964,a|0,13778)|0;b=v[113382];v[113382]=0;if((b|0)==1){break d}v[113382]=0;Q(1964,a|0,9703)|0;b=v[113382];v[113382]=0;if((b|0)==1){break d}v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){break b}b=P()|0;O()|0;break a}b=P()|0;O()|0;v[113382]=0;Y(20);c=v[113382];v[113382]=0;if((c|0)!=1){break a}break c}b=P()|0;O()|0;v[113382]=0;Y(20);c=v[113382];v[113382]=0;if((c|0)!=1){break a}break c}b=P()|0;O()|0;v[113382]=0;Y(20);c=v[113382];v[113382]=0;if((c|0)==1){break c}break a}b=P()|0;O()|0;v[113382]=0;Y(20);c=v[113382];v[113382]=0;if((c|0)!=1){break a}}V(0)|0;O()|0;Ab()}L()}return}yb(a);S(b|0);L()}function i2(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=jb-160|0;jb=d;a:{if(nj(b)){break a}e=w[gk(b)|0];if((e|0)==33){c=1}else{if((e|0)!=63){break a}c=0}rk(d+128|0,b,v[b+4>>2]-1|0);e=v[d+132>>2];v[b>>2]=v[d+128>>2];v[b+4>>2]=e}f=d+128|0;Ad(f);e=v[d+128>>2];Ad(d+112|0);e=fk(e,v[d+116>>2],b);Ad(f);b:{c:{d:{e:{f:{g:{if((e|0)==v[d+132>>2]){a=v[b+4>>2];v[d+152>>2]=v[b>>2];v[d+156>>2]=a;a=qc(d+144|0,17540);e=v[d+156>>2];v[d+8>>2]=v[d+152>>2];v[d+12>>2]=e;e=v[a+4>>2];v[d>>2]=v[a>>2];v[d+4>>2]=e;if(Hc(d+8|0,d)){a=ba(8)|0;v[113382]=0;c=Q(121,d+128|0,6570)|0;b=v[113382];v[113382]=0;if((b|0)==1){break f}nc(a,c);v[113382]=0;U(1978,a|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break b}b=P()|0;O()|0;yb(c);break c}e=0;f=0;if(!c){break g}a=ba(8)|0;v[113382]=0;c=Q(2111,d+112|0,b|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){v[113382]=0;U(2088,d+128|0,13678,c|0);b=v[113382];v[113382]=0;if((b|0)==1){break e}nc(a,d+128|0);v[113382]=0;U(1978,a|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break b}b=P()|0;O()|0;yb(d+128|0);yb(c);break c}b=P()|0;O()|0;break d}if(v[e+4>>2]!=1){a=ba(8)|0;v[113382]=0;c=Q(121,d+128|0,7618)|0;b=v[113382];v[113382]=0;if((b|0)!=1){nc(a,c);v[113382]=0;U(1978,a|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break b}b=P()|0;O()|0;yb(c);break c}b=P()|0;O()|0;ca(a|0);break c}c=v[b+4>>2];v[d+104>>2]=v[b>>2];v[d+108>>2]=c;c=qc(d+96|0,17540);e=v[d+108>>2];v[d+56>>2]=v[d+104>>2];v[d+60>>2]=e;e=v[c+4>>2];v[d+48>>2]=v[c>>2];v[d+52>>2]=e;if(Hc(d+56|0,d+48|0)){a=ba(8)|0;v[113382]=0;c=Q(121,d+128|0,6570)|0;b=v[113382];v[113382]=0;if((b|0)!=1){nc(a,c);v[113382]=0;U(1978,a|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break b}b=P()|0;O()|0;yb(c);break c}b=P()|0;O()|0;ca(a|0);break c}c=v[b+4>>2];v[d+88>>2]=v[b>>2];v[d+92>>2]=c;c=qc(d+80|0,7e3);e=v[d+92>>2];v[d+40>>2]=v[d+88>>2];v[d+44>>2]=e;e=v[c+4>>2];v[d+32>>2]=v[c>>2];v[d+36>>2]=e;if(Hc(d+40|0,d+32|0)){a=v[a+8>>2];e=a;f=a>>31;break g}c=v[b+4>>2];v[d+72>>2]=v[b>>2];v[d+76>>2]=c;b=qc(d- -64|0,4872);c=v[d+76>>2];v[d+24>>2]=v[d+72>>2];v[d+28>>2]=c;c=v[b+4>>2];v[d+16>>2]=v[b>>2];v[d+20>>2]=c;e=0;f=0;if(!Hc(d+24|0,d+16|0)){break g}a=v[v[a+32>>2]+40>>2];e=a;f=a>>31}jb=d+160|0;mb=f;return e|0}b=P()|0;O()|0;ca(a|0);break c}b=P()|0;O()|0;yb(c)}ca(a|0)}S(b|0)}L()}function MM(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;f=jb-96|0;jb=f;t[f+95|0]=d;d=0;m=jp(a);n=rj(m);u[b>>1]=0;a:{if(n){while(1){o=x[rc(m,d&65535)>>1];b:{if(!jg(v[a+24>>2]+484344|0,o)){break b}d=x[b>>1];if(xc(a)>>>0<=d>>>0){v[c>>2]=0;a=1;break a}l=od(a,x[b>>1]);uj(f+72|0,l);xk(f- -64|0,l);d=v[f+76>>2];v[f+32>>2]=v[f+72>>2];v[f+36>>2]=d;d=v[f+68>>2];v[f+24>>2]=v[f+64>>2];v[f+28>>2]=d;k=f+80|0;e=f+32|0;h=f+24|0;d=jb-32|0;jb=d;c:{if(w[f+95|0]){g=v[e+4>>2];v[d+24>>2]=v[e>>2];v[d+28>>2]=g;e=Ci(h,e);h=v[d+28>>2];v[d+8>>2]=v[d+24>>2];v[d+12>>2]=h;h=jb-16|0;jb=h;v[h+12>>2]=e;i=d+8|0;g=v[i+4>>2];d:{if(g){v[h+8>>2]=32-g;e=Lb(h+8|0,h+12|0);j=v[i>>2];e=v[e>>2];g=v[j>>2]&(-1<<g&-1>>>v[h+8>>2]-e);if(g){$c(k,j,pma(g));break d}g=v[h+12>>2];if((g|0)==(e|0)){FM(k,i,e);break d}e=g-e|0;v[h+12>>2]=e;v[i>>2]=j+4}if(e>>>0>=32){g=v[i>>2];while(1){j=v[g>>2];if(j){$c(k,g,pma(j));break d}g=g+4|0;v[i>>2]=g;e=e-32|0;v[h+12>>2]=e;if(e>>>0>31){continue}break}}e:{if(!e){g=v[i>>2];break e}g=v[i>>2];i=v[g>>2]&-1>>>32-e;if(!i){break e}$c(k,g,pma(i));break d}$c(k,g,e)}jb=h+16|0;break c}g=v[e+4>>2];v[d+16>>2]=v[e>>2];v[d+20>>2]=g;e=Ci(h,e);h=v[d+20>>2];v[d>>2]=v[d+16>>2];v[d+4>>2]=h;g=jb-16|0;jb=g;v[g+12>>2]=e;h=d;i=v[h+4>>2];f:{if(i){v[g+8>>2]=32-i;e=v[Lb(g+8|0,g+12|0)>>2];j=-1<<i&-1>>>v[g+8>>2]-e;i=v[h>>2];j=j&(v[i>>2]^-1);if(j){$c(k,i,pma(j));break f}j=v[g+12>>2];if((j|0)==(e|0)){FM(k,h,e);break f}e=j-e|0;v[g+12>>2]=e;v[h>>2]=i+4}if(e>>>0>=32){i=v[h>>2];while(1){j=v[i>>2];if((j|0)!=-1){$c(k,i,pma(j^-1));break f}i=i+4|0;v[h>>2]=i;e=e-32|0;v[g+12>>2]=e;if(e>>>0>31){continue}break}}g:{if(!e){i=v[h>>2];break g}i=v[h>>2];h=(v[i>>2]^-1)&-1>>>32-e;if(!h){break g}$c(k,i,pma(h));break f}$c(k,i,e)}jb=g+16|0}jb=d+32|0;d=c;h:{if(w[f+95|0]){h=f+56|0;xk(h,l);e=0;if(LM(f+80|0,h)){break h}if(w[f+95|0]){break b}}e=f+56|0;xk(e,l);if(LM(f+80|0,e)^1){uj(f+48|0,l);a=v[f+84>>2];b=v[f+80>>2];v[f+40>>2]=b;v[f+44>>2]=a;c=v[f+52>>2];v[f+16>>2]=v[f+48>>2];v[f+20>>2]=c;v[f+8>>2]=b;v[f+12>>2]=a;e=$O(f+16|0,f+8|0);break h}if(y[l+4>>2]>=y[Zb(v[a+24>>2]+484344|0,o)+12>>2]){break b}e=v[l+4>>2]}v[d>>2]=e;a=1;break a}d=x[b>>1]+1|0;u[b>>1]=d;if((d&65535)>>>0<n>>>0){continue}break}}u[b>>1]=65535;v[c>>2]=-1;a=0}jb=f+96|0;return a|0}function Oha(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;l=jb-48|0;jb=l;f=v[a+4>>2];e=Dd(l+40|0,b);j=Dd(l+32|0,c);d=jb-16|0;jb=d;e=BP(Dd(d+8|0,e),Dd(d,j));jb=d+16|0;d=e+v[a+4>>2]|0;v[a+4>>2]=d;if(!((d-1^f-1)>>>0<32?f:0)){v[v[a>>2]+((d>>>0<33?0:d-1>>>5|0)<<2)>>2]=0}d=Dd(l+24|0,b);g=Dd(l+16|0,c);c=l+8|0;Pn(c,a,f);b=l;j=jb-48|0;jb=j;a:{if(v[d+4>>2]==v[c+4>>2]){d=Dd(j+40|0,d);e=Dd(j+32|0,g);f=Dd(j+24|0,c);a=jb-16|0;jb=a;c=Ci(e,d);v[a+12>>2]=c;b:{if((c|0)<=0){break b}e=v[d+4>>2];if(e){g=32-e|0;v[a+8>>2]=g;c=v[Zd(a+8|0,a+12|0)>>2];v[a+12>>2]=v[a+12>>2]-c;e=v[f>>2];g=-1<<v[d+4>>2]&-1>>>g-c;v[e>>2]=v[e>>2]&(g^-1)|g&v[v[d>>2]>>2];c=c+v[f+4>>2]|0;v[f+4>>2]=c&31;v[f>>2]=e+(c>>>3&536870908);v[d>>2]=v[d>>2]+4;c=v[a+12>>2]}e=(c|0)/32|0;c=e<<2;_i(v[f>>2],v[d>>2],c);e=v[a+12>>2]-(e<<5)|0;v[a+12>>2]=e;v[f>>2]=c+v[f>>2];if((e|0)<=0){break b}c=c+v[d>>2]|0;v[d>>2]=c;d=v[f>>2];i=d;n=v[d>>2];d=-1>>>32-e|0;v[i>>2]=n&(d^-1)|d&v[c>>2];v[f+4>>2]=v[a+12>>2]}Dd(b,f);jb=a+16|0;break a}e=Dd(j+16|0,d);a=Dd(j+8|0,g);d=Dd(j,c);f=jb-16|0;jb=f;a=Ci(a,e);v[f+12>>2]=a;c:{if((a|0)<=0){break c}c=v[e+4>>2];d:{if(!c){c=v[d+4>>2];break d}c=32-c|0;v[f+8>>2]=c;g=f+8|0;a=v[Zd(g,f+12|0)>>2];v[f+12>>2]=v[f+12>>2]-a;h=v[d+4>>2];k=v[v[e>>2]>>2];i=v[e+4>>2];v[f+8>>2]=a;m=32-h|0;v[f+4>>2]=m;n=Lb(g,f+4|0);h=v[d>>2];k=k&(-1<<i&-1>>>c-a);c=v[d+4>>2];g=v[e+4>>2];i=c>>>0>g>>>0?k<<c-g:k>>>g-c|0;g=v[n>>2];v[h>>2]=i|v[h>>2]&(-1<<c&-1>>>m-g^-1);i=c+g|0;c=i&31;v[d+4>>2]=c;h=h+(i>>>3&536870908)|0;v[d>>2]=h;a=a-g|0;if((a|0)>0){v[h>>2]=v[h>>2]&(-1>>>32-a^-1)|k>>>g+v[e+4>>2];v[d+4>>2]=a;c=a}v[e>>2]=v[e>>2]+4;a=v[f+12>>2]}g=32-c|0;if((a|0)>=32){k=-1<<c;i=k^-1;h=v[e>>2];while(1){a=v[d>>2];h=v[h>>2];v[a>>2]=i&v[a>>2]|h<<c;v[d>>2]=a+4;v[a+4>>2]=k&v[a+4>>2]|h>>>g;m=v[f+12>>2];a=m-32|0;v[f+12>>2]=a;h=v[e>>2]+4|0;v[e>>2]=h;if((m|0)>63){continue}break}}if((a|0)<=0){break c}k=v[v[e>>2]>>2];v[f+8>>2]=g;c=Zd(f+12|0,f+8|0);e=v[d>>2];h=v[d+4>>2];c=v[c>>2];i=v[e>>2]&(-1<<h&-1>>>g-c^-1);g=k&-1>>>32-a;v[e>>2]=i|g<<h;a=c+h|0;v[d+4>>2]=a&31;a=e+(a>>>3&536870908)|0;v[d>>2]=a;e=v[f+12>>2]-c|0;v[f+12>>2]=e;if((e|0)<=0){break c}v[a>>2]=v[a>>2]&(-1>>>32-e^-1)|g>>>c;v[d+4>>2]=v[f+12>>2]}Dd(b,d);jb=f+16|0}jb=j+48|0;jb=l+48|0}function e2(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=jb-160|0;jb=e;a:{if(nj(c)){break a}f=w[gk(c)|0];if((f|0)==33){d=1}else{if((f|0)!=63){break a}d=0}rk(e+128|0,c,v[c+4>>2]-1|0);f=v[e+132>>2];v[c>>2]=v[e+128>>2];v[c+4>>2]=f}f=e+128|0;Ad(f);g=v[e+128>>2];Ad(e+112|0);h=fk(g,v[e+116>>2],c);Ad(f);f=v[c>>2];g=v[c+4>>2];b:{c:{d:{e:{f:{g:{if((h|0)==v[e+132>>2]){v[e+152>>2]=f;v[e+156>>2]=g;b=qc(e+144|0,17540);f=v[e+156>>2];v[e+8>>2]=v[e+152>>2];v[e+12>>2]=f;f=v[b+4>>2];v[e>>2]=v[b>>2];v[e+4>>2]=f;if(Hc(e+8|0,e)){a=ba(8)|0;v[113382]=0;b=Q(121,e+128|0,6570)|0;c=v[113382];v[113382]=0;if((c|0)==1){break f}nc(a,b);v[113382]=0;U(1978,a|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break b}c=P()|0;O()|0;yb(b);break c}if(d){a=ba(8)|0;v[113382]=0;b=Q(2111,e+112|0,c|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){v[113382]=0;U(2088,e+128|0,13678,b|0);c=v[113382];v[113382]=0;if((c|0)==1){break e}nc(a,e+128|0);v[113382]=0;U(1978,a|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break b}c=P()|0;O()|0;yb(e+128|0);yb(b);break c}c=P()|0;O()|0;break d}Xb(a);break g}v[e+104>>2]=f;v[e+108>>2]=g;d=qc(e+96|0,17540);f=v[e+108>>2];v[e+56>>2]=v[e+104>>2];v[e+60>>2]=f;f=v[d+4>>2];v[e+48>>2]=v[d>>2];v[e+52>>2]=f;if(Hc(e+56|0,e+48|0)){a=ba(8)|0;v[113382]=0;b=Q(121,e+128|0,6570)|0;c=v[113382];v[113382]=0;if((c|0)!=1){nc(a,b);v[113382]=0;U(1978,a|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break b}c=P()|0;O()|0;yb(b);break c}c=P()|0;O()|0;ca(a|0);break c}d=v[c+4>>2];v[e+88>>2]=v[c>>2];v[e+92>>2]=d;d=qc(e+80|0,8322);f=v[e+92>>2];v[e+40>>2]=v[e+88>>2];v[e+44>>2]=f;f=v[d+4>>2];v[e+32>>2]=v[d>>2];v[e+36>>2]=f;if(Hc(e+40|0,e+32|0)){h:{switch(v[b+52>>2]){case 0:Ub(a,2087);break g;case 1:Ub(a,7319);break g;case 2:Ub(a,5230);break g;default:break h}}Xb(a);break g}d=v[c+4>>2];v[e+72>>2]=v[c>>2];v[e+76>>2]=d;c=qc(e- -64|0,7556);d=v[e+76>>2];v[e+24>>2]=v[e+72>>2];v[e+28>>2]=d;d=v[c+4>>2];v[e+16>>2]=v[c>>2];v[e+20>>2]=d;if(Hc(e+24|0,e+16|0)){i:{switch(v[b+56>>2]){case 0:Ub(a,11790);break g;case 1:Ub(a,11795);break g;case 2:Ub(a,8581);break g;case 3:Ub(a,5294);break g;default:break i}}Xb(a);break g}Xb(a)}jb=e+160|0;return}c=P()|0;O()|0;ca(a|0);break c}c=P()|0;O()|0;yb(b)}ca(a|0)}S(c|0)}L()}function Cda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;h=jb-32|0;jb=h;v[h+24>>2]=d;k=Lj(a,c);pf(h,v[a+28>>2]);d=v[h+12>>2];v[h+16>>2]=v[h+8>>2];v[h+20>>2]=d;a:{if(!k){if(wd(a,5)){break a}}f=v[h+24>>2];d=jb-160|0;jb=d;i=cl(d+56|0,v[a+28>>2]);v[113382]=0;g=Q(645,d+40|0,24496)|0;e=v[113382];v[113382]=0;b:{c:{d:{e:{if((e|0)!=1){v[113382]=0;v[d+24>>2]=19469312;v[d+28>>2]=0;U(646,i|0,g|0,d+24|0);e=v[113382];v[113382]=0;if((e|0)==1){break e}Ib(g);if(!(v[i>>2]&1073741824)){break d}break b}a=P()|0;O()|0;break c}a=P()|0;O()|0;Ib(g);break c}v[113382]=0;t[d+39|0]=0;g=Q(645,d+40|0,1991)|0;e=v[113382];v[113382]=0;f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{if((e|0)!=1){v[113382]=0;W(647,i|0,d+39|0,g|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break q}Ib(g);g=Xb(d+40|0);v[113382]=0;e=Q(645,d+24|0,6187)|0;j=v[113382];v[113382]=0;if((j|0)==1){break p}v[113382]=0;W(1146,i|0,g|0,e|0)|0;j=v[113382];v[113382]=0;if((j|0)==1){break o}Ib(e);v[113382]=0;U(13,d+24|0,(w[d+39|0]?0:f)|0,g|0);e=v[113382];v[113382]=0;if((e|0)==1){break n}v[113382]=0;R(447,b|0,d+24|0);e=v[113382];v[113382]=0;if((e|0)==1){break m}e=d+24|0;yb(e);v[113382]=0;u[d+22>>1]=0;e=Q(645,e|0,6834)|0;f=v[113382];v[113382]=0;if((f|0)==1){break g}v[113382]=0;W(1147,i|0,d+22|0,e|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break l}Ib(e);sg(d+22|0,x[v[18619]+12>>1]);v[113382]=0;e=Q(645,d+24|0,9418)|0;f=v[113382];v[113382]=0;if((f|0)==1){break k}f=v[Oc(d+16|0,x[d+22>>1])>>2];v[113382]=0;aa(1148,i|0,b|0,e|0,f|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break j}Ib(e);v[113382]=0;u[d+14>>1]=65535;e=Q(645,d+24|0,5138)|0;f=v[113382];v[113382]=0;if((f|0)==1){break i}v[113382]=0;f=W(1147,i|0,d+14|0,e|0)|0;j=v[113382];v[113382]=0;if((j|0)==1){break h}j=x[d+22>>1];l=x[d+14>>1];Ib(e);if(!((f|0)==1|j>>>0<=l>>>0)){Ne(b,x[d+14>>1])}yb(g);break b}a=P()|0;O()|0;break c}a=P()|0;O()|0;Ib(g);break c}a=P()|0;O()|0;break f}a=P()|0;O()|0;Ib(e);break f}a=P()|0;O()|0;break f}a=P()|0;O()|0;yb(d+24|0);break f}a=P()|0;O()|0;Ib(e);break f}a=P()|0;O()|0;break f}a=P()|0;O()|0;Ib(e);break f}a=P()|0;O()|0;break f}a=P()|0;O()|0;Ib(e);break f}a=P()|0;O()|0}yb(g)}Bg(i);S(a|0);L()}Bg(i);jb=d+160|0}$i(a,k,c,h+16|0);jb=h+32|0}function Q9(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=jb-1136|0;jb=e;Ic(b);g=jb-16|0;jb=g;f=g+8|0;i=e+1112|0;pK(f,i);j=Hb(f);d=b;f=mc(d,$b(g,f));if((j|0)==(f|0)){_b(d,Hb(g+8|0))}jb=g+16|0;d=(f|0)==(j|0);if(!d){qK(i)}a:{if(!d){break a}if(!uK(e+1112|0)){break a}d=e+1120|0;if((w[d|0]|w[d+1|0]<<8|(w[d+2|0]<<16|w[d+3|0]<<24))!=(Kj(b)|0)){break a}f=e+1128|0;if((w[f|0]|w[f+1|0]<<8|(w[f+2|0]<<16|w[f+3|0]<<24))!=($e(b)|0)){break a}if(!c){h=1;break a}d=e+1056|0;Qb(d,0,56);i=-2;b:{if(!d){break b}v[d+44>>2]=0;v[d+48>>2]=0;v[d+52>>2]=0;v[d+20>>2]=0;v[d+24>>2]=0;v[d+8>>2]=0;g=v[d+32>>2];if(!g){v[d+32>>2]=2266;g=2266}if(!v[d+36>>2]){v[d+36>>2]=2267}g=nb[g|0](v[d+40>>2],1,43784)|0;i=-4;if(!g){break b}v[d+28>>2]=g;v[g+43780>>2]=1;v[g+10992>>2]=0;v[g+10996>>2]=0;v[g>>2]=0;v[g+11008>>2]=15;v[g+11e3>>2]=1;v[g+11004>>2]=0;i=0}if(i){break a}d=w[f|0]|w[f+1|0]<<8|(w[f+2|0]<<16|w[f+3|0]<<24);v[e+1052>>2]=d;h=e+1132|0;h=w[h|0]|w[h+1|0]<<8|(w[h+2|0]<<16|w[h+3|0]<<24);f=(h|0)!=0;g=YR(e+1040|0,h);c:{d:{e:{f:{if(!d|!h){break f}while(1){v[113382]=0;v[e+12>>2]=1024;d=Q(297,e+12|0,e+1052|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break e}d=v[d>>2];v[113382]=0;W(231,b|0,e+16|0,d|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break d}v[113382]=0;k=W(1524,k|0,e+16|0,d|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break d}v[e+1072>>2]=h;v[e+1060>>2]=d;v[e+1056>>2]=e+16;f=v[g>>2];v[113382]=0;v[e+1068>>2]=f+l;m=Q(1525,e+1056|0,0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break d}i=v[e+1052>>2]-d|0;v[e+1052>>2]=i;d=v[e+1072>>2];f=(d|0)!=0;if(!i|!d){break f}l=(h+l|0)-d|0;h=d;if((m|0)!=1){continue}break}}v[113382]=0;T(1526,e+1056|0)|0;b=v[113382];v[113382]=0;g:{h:{if((b|0)!=1){h=0;b=e+1124|0;if(!((w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24))!=(k|0)|f|(m|0)!=1)){v[113382]=0;R(795,e|0,g|0);b=v[113382];v[113382]=0;if((b|0)==1){break h}v[113382]=0;b=W(796,e+16|0,e|0,0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break h}v[113382]=0;h=W(1465,a|0,b|0,c|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break g}Bb(b)}$d(g);break a}a=P()|0;O()|0;break c}a=P()|0;O()|0;break c}a=P()|0;O()|0;Bb(b);break c}a=P()|0;O()|0;break c}a=P()|0;O()|0}$d(g);S(a|0);L()}jb=e+1136|0;return h|0}function tka(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=C(0);c=jb-80|0;jb=c;e=jb-16|0;jb=e;f=e+8|0;g=b+16|0;mR(f,g);h=Hb(f);d=a;f=mc(d,$b(e,f));if((h|0)==(f|0)){_b(d,Hb(e+8|0))}jb=e+16|0;if((f|0)!=(h|0)){d=jb-16|0;jb=d;Qb(g,0,128);jb=d+16|0}MR(b+48|0);t[b+143|0]=0;v[b+152>>2]=-2147483648;v[b+156>>2]=-2147483648;d=c- -64|0;td(d,a,Df(a));v[113382]=0;d=T(296,d|0)|0;e=v[113382];v[113382]=0;a:{b:{if((e|0)==1){break b}v[113382]=0;e=b+4|0;R(469,e|0,d|0);d=v[113382];v[113382]=0;if((d|0)==1){break b}v[113382]=0;R(660,c+56|0,e|0);d=v[113382];v[113382]=0;if((d|0)==1){break b}v[113382]=0;Q(661,c- -64|0,c+56|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break b}v[113382]=0;d=T(397,a|0)|0;e=v[113382];v[113382]=0;c:{if((e|0)==1){break c}v[113382]=0;U(307,c+40|0,a|0,d|0);a=v[113382];v[113382]=0;if((a|0)==1){break c}v[113382]=0;a=T(303,c+40|0)|0;d=v[113382];v[113382]=0;d:{if((d|0)!=1){e:{f:{if(!a){break f}while(1){g:{v[113382]=0;a=Q(228,c+40|0,5)|0;d=v[113382];v[113382]=0;if((d|0)==1){break e}if(!a){break f}v[113382]=0;Q(662,c+40|0,c+36|0)|0;a=v[113382];v[113382]=0;h:{if((a|0)!=1){a=4;d=w[c+36|0]|w[c+37|0]<<8|(w[c+38|0]<<16|w[c+39|0]<<24);if((d|0)==1414682436|(d|0)==1196380752){break h}v[113382]=0;a=T(397,c+40|0)|0;d=v[113382];v[113382]=0;if((d|0)!=1){break h}a=P()|0;O()|0;break d}a=P()|0;O()|0;break d}v[113382]=0;U(307,c+16|0,c+40|0,a|0);a=v[113382];v[113382]=0;i:{j:{k:{if((a|0)!=1){if((w[c+36|0]|w[c+37|0]<<8|(w[c+38|0]<<16|w[c+39|0]<<24))!=1414682436){break k}v[113382]=0;i=C(Ca(663,c+16|0));a=v[113382];v[113382]=0;if((a|0)==1){break g}v[113382]=0;z[c+12>>2]=i;v[c+8>>2]=0;v[c+4>>2]=1065353216;a=W(664,c+12|0,c+8|0,c+4|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break g}d=v[a>>2];z[b+144>>2]=z[a>>2];if(d+8388608&2130706432){break j}v[b+144>>2]=0;break j}a=P()|0;O()|0;break d}if((w[c+36|0]|w[c+37|0]<<8|(w[c+38|0]<<16|w[c+39|0]<<24))!=1196380752){break j}v[113382]=0;a=T(397,c+16|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break i}v[b+148>>2]=a}Bb(c+16|0);continue}}break}a=P()|0;O()|0;Bb(c+16|0);break d}Bb(c+40|0);Bb(c- -64|0);jb=c+80|0;return}a=P()|0;O()|0;break d}a=P()|0;O()|0}Bb(c+40|0);break a}a=P()|0;O()|0;break a}a=P()|0;O()|0}Bb(c- -64|0);S(a|0);L()}function E4(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0;j=jb-80|0;jb=j;a:{b:{c:{k=lo(1,32);d:{e:{if(!k){a=ba(4)|0;Zk(a);v[113382]=0;U(1978,a|0,66740,1977);a=v[113382];v[113382]=0;if((a|0)!=1){break a}i=V(0)|0;O()|0;break e}v[k+12>>2]=f;v[k+8>>2]=e;v[k+4>>2]=d;v[k>>2]=c?c:1966;d=Ns(j- -64|0);f:{g:{if(!i){break g}c=v[i>>2];if(!c){break g}while(1){h:{e=v[i+4>>2];if(e){v[113382]=0;c=Q(121,j+48|0,c|0)|0;f=v[113382];v[113382]=0;i:{if((f|0)!=1){v[113382]=0;f=Q(1979,d|0,c|0)|0;l=v[113382];v[113382]=0;if((l|0)==1){break i}v[113382]=0;Q(444,f|0,e|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break i}break h}i=V(0)|0;O()|0;break f}i=V(0)|0;O()|0;yb(c);break f}v[113382]=0;c=Q(121,j+48|0,c|0)|0;e=v[113382];v[113382]=0;j:{if((e|0)!=1){v[113382]=0;Q(1980,d|0,c|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break j}break h}i=V(0)|0;O()|0;break f}i=V(0)|0;O()|0;yb(c);break f}yb(c);c=v[i+8>>2];i=i+8|0;if(c){continue}break}}c=v[a+8>>2];e=v[a+4>>2];f=v[a>>2];v[113382]=0;a=T(1361,96)|0;i=v[113382];v[113382]=0;k:{l:{m:{if((i|0)!=1){v[113382]=0;v[j+44>>2]=c;v[j+40>>2]=e;v[j+36>>2]=f;v[j+32>>2]=b;b=Q(1981,k|0,k+4|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break m}v[j+48>>2]=b;b=v[Jo(j+24|0,j+48|0)>>2];v[113382]=0;c=v[j+44>>2];v[j+16>>2]=v[j+40>>2];v[j+20>>2]=c;c=v[j+36>>2];v[j+8>>2]=v[j+32>>2];v[j+12>>2]=c;aa(2055,a|0,j+8|0,b|0,d|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break l}v[k+28>>2]=a;ad(j+48|0);a=v[k+28>>2];v[k+24>>2]=a?a+8|0:0;sk(d);break d}i=V(0)|0;O()|0;break f}i=V(0)|0;O()|0;break k}i=V(0)|0;O()|0;ad(j+48|0)}Wb(a)}sk(d);_(i|0)|0;v[113382]=0;X(1958,7374,k|0,g|0,h|0);a=v[113382];v[113382]=0;if((a|0)!=1){v[113382]=0;Y(20);a=v[113382];v[113382]=0;if((a|0)!=1){a=v[k+28>>2];if(a){nb[v[v[a>>2]+4>>2]](a)}v[k+24>>2]=0;v[k+28>>2]=0;a=v[k+20>>2];if(a){Wb(a);v[k+20>>2]=0}Wb(k);k=0;break d}i=V(0)|0;O()|0;break e}i=V(0)|0;O()|0;v[113382]=0;Y(20);a=v[113382];v[113382]=0;if((a|0)==1){break b}}_(i|0)|0;k=0;v[113382]=0;X(1958,7374,0,g|0,h|0);a=v[113382];v[113382]=0;if((a|0)==1){break c}$()}jb=j+80|0;return k|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)==1){break b}S(a|0);L()}V(0)|0;O()|0;Ab()}L()}function JT(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,x=0,z=0,A=0,C=0,D=0,E=0,F=0,G=0;e=jb-32|0;jb=e;j=Oh(e+24|0);if(v[a+12>>2]){q=b^1;r=j+3|0;s=j+5|0;x=j+4|0;z=j+2|0;A=j+1|0;d=e+16|0;C=d|5;D=d|3;while(1){E=Mn(a,n);while(1){a:{if(!Rb(c,1)){break a}k=le(c);if((k|0)==255){break a}h=k&31;d=mk(a)>>>0>h>>>0;h=B(h,6)+E|0;if(k&64){l=1}else{f=le(c);i=f<<24>>24;g=255;f=f&127;b:{c:{if((f|0)==1){break c}g=f-1|0;if(((g&255)>>>0>120|q)!=1){break c}if((f-12&255)>>>0>96|b){break b}g=f+13|0}t[(d?h:e+24|0)|0]=g}F=d?h+1|0:A,G=le(c),t[F|0]=G;l=(i|0)<0}if(l){p=d?h:j;f=d?h+3|0:r;g=d?h+5|0:s;o=d?h+4|0:x;m=d?h+2|0:z;h=d?h:e+24|0;while(1){d=h;v[e+16>>2]=w[d|0]|w[d+1|0]<<8|(w[d+2|0]<<16|w[d+3|0]<<24);u[e+20>>1]=w[d+4|0]|w[d+5|0]<<8;d=le(c);l=d&128;i=d&63;d:{if(d&64){t[m|0]=1;t[o|0]=i;break d}d=le(c);t[g|0]=d;e:{f:{if(i>>>0<=15){t[f|0]=i;vj(p);g:{h:{i:{d=w[f|0];switch(d-9|0){case 1:case 2:case 3:break e;case 4:break h;case 0:break i;default:break g}}t[f|0]=9;t[g|0]=B(w[g|0]&15,17);break e}t[f|0]=0;t[m|0]=1;v[e+12>>2]=w[g|0]+1>>>1;v[e+8>>2]=64;F=o,G=v[Zd(e+12|0,e+8|0)>>2],t[F|0]=G;break e}if((d|0)!=19){break e}if(w[g|0]==128){break f}lK(p);break e}if(i>>>0>44){break e}i=i-16|0;t[f|0]=w[i+23520|0];j:{switch(i|0){case 0:if(d>>>0>1){break f}t[g|0]=d|158;break e;case 1:case 2:t[e+12|0]=15;F=g,G=w[pc(e+12|0,g)|0]|224,t[F|0]=G;break e;case 5:case 6:v[e+12>>2]=16;v[e+8>>2]=d+1;F=g,G=v[Zd(e+12|0,e+8|0)>>2]/2|240,t[F|0]=G;break e;case 14:k:{l:{m:{n:{o:{i=d>>>4|0;switch(i-1|0){case 1:break m;case 0:break n;default:break o}}switch(i-10|0){case 1:break k;case 0:break l;default:break f}}t[f|0]=2;t[g|0]=d|240;break e}t[f|0]=3;t[g|0]=d|240;break e}t[f|0]=11;t[g|0]=(d<<3&120)+8|15;break e}t[f|0]=11;t[g|0]=(d&15)+1>>>1|240;break e;case 12:break j;default:break e}}v[e+12>>2]=d+1>>>1;v[e+8>>2]=64;F=g,G=v[Zd(e+12|0,e+8|0)>>2],t[F|0]=G;break e}t[f|0]=0}Cx(f,g,D,C);if(Vm(w[e+19|0])>>>0<=Vm(w[f|0])>>>0){break d}p:{if(w[m|0]){break p}if(!Dx(f,g,1)){break p}t[m|0]=w[f|0];t[o|0]=w[g|0]}t[f|0]=w[e+19|0];t[g|0]=w[e+21|0]}if(l){continue}break}}if(!(k&128)){continue}}break}n=n+1|0;if(n>>>0<y[a+12>>2]){continue}break}}jb=e+32|0}function hx(a){a=a|0;var b=0,c=0,d=C(0),e=0;Qb(a+4960|0,0,76);t[a+5044|0]=0;v[a+5036>>2]=0;v[a+5040>>2]=0;b=v[a+4292>>2];d=z[a+4268>>2];v[113382]=0;e=a+4504|0;if(d<C(4294967296)&d>=C(0)){c=~~d>>>0}else{c=0}fa(1885,e|0,67,5,c|0,b|0);b=v[113382];v[113382]=0;a:{if((b|0)==1){break a}b=v[a+4296>>2];v[113382]=0;fa(1885,a+4528|0,62,5,c|0,b|0);b=v[113382];v[113382]=0;if((b|0)==1){break a}b=v[a+4300>>2];v[113382]=0;fa(1885,a+4552|0,53,5,c|0,b|0);b=v[113382];v[113382]=0;if((b|0)==1){break a}b=v[a+4304>>2];v[113382]=0;fa(1885,a+4576|0,43,5,c|0,b|0);b=v[113382];v[113382]=0;if((b|0)==1){break a}b=v[a+4308>>2];v[113382]=0;fa(1885,a+4600|0,32,5,c|0,b|0);b=v[113382];v[113382]=0;if((b|0)==1){break a}b=v[a+4312>>2];v[113382]=0;fa(1885,a+4624|0,22,5,c|0,b|0);b=v[113382];v[113382]=0;if((b|0)==1){break a}b=v[a+4316>>2];v[113382]=0;fa(1885,a+4648|0,75,5,c|0,b|0);b=v[113382];v[113382]=0;if((b|0)==1){break a}b=v[a+4320>>2];v[113382]=0;fa(1885,a+4672|0,69,5,c|0,b|0);b=v[113382];v[113382]=0;if((b|0)==1){break a}b=v[a+4324>>2];v[113382]=0;fa(1885,a+4696|0,60,5,c|0,b|0);b=v[113382];v[113382]=0;if((b|0)==1){break a}b=v[a+4328>>2];v[113382]=0;fa(1885,a+4720|0,48,5,c|0,b|0);b=v[113382];v[113382]=0;if((b|0)==1){break a}b=v[a+4332>>2];v[113382]=0;fa(1885,a+4744|0,36,5,c|0,b|0);b=v[113382];v[113382]=0;if((b|0)==1){break a}b=v[a+4336>>2];v[113382]=0;fa(1885,a+4768|0,25,5,c|0,b|0);b=v[113382];v[113382]=0;if((b|0)==1){break a}v[113382]=0;fa(1885,a+4792|0,0,0,0,0);b=v[113382];v[113382]=0;if((b|0)==1){break a}b=v[a+4344>>2];v[113382]=0;fa(1885,a+4816|0,3,0,c|0,b|0);b=v[113382];v[113382]=0;if((b|0)==1){break a}b=v[a+4348>>2];v[113382]=0;fa(1885,a+4840|0,3,0,c|0,b|0);b=v[113382];v[113382]=0;if((b|0)==1){break a}v[113382]=0;fa(1885,a+4864|0,407,1,c|0,0);b=v[113382];v[113382]=0;if((b|0)==1){break a}v[113382]=0;fa(1885,a+4888|0,400,1,c|0,0);b=v[113382];v[113382]=0;if((b|0)==1){break a}v[113382]=0;fa(1885,a+4912|0,10,0,c|0,-1);b=v[113382];v[113382]=0;if((b|0)==1){break a}v[113382]=0;fa(1885,a+4936|0,10,0,c|0,-1);c=v[113382];v[113382]=0;if((c|0)==1){break a}t[a+5045|0]=1;return}c=V(66740)|0;if((O()|0)==(ga(66740)|0)){_(c|0)|0;t[a+5045|0]=0;$();return}S(c|0);L()}function cea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0;e=jb-80|0;jb=e;t=v[a+16>>2];h=Uf(e+48|0);v[h+8>>2]=a+112;v[h+16>>2]=v[a+128>>2];x=h,y=Pf(b+327720|0,v[b+20>>2],(v[a+88>>2]&16384)>>>14|0),v[x+12>>2]=y;b=v[h+16>>2];if(b){x=h,y=Tf(a+8|0,b),v[x>>2]=y;v[h+4>>2]=mb}f=v[a+44>>2];v[e+32>>2]=f;m=v[a+48>>2];v[e+36>>2]=m;k=v[a+52>>2];v[e+40>>2]=k;l=v[a+56>>2];v[e+44>>2]=l;n=v[a+40>>2];o=v[a+36>>2];i=v[a+4>>2];g=v[a>>2];v[e+24>>2]=g;v[e+28>>2]=i;b=v[a+12>>2];v[e+16>>2]=v[a+8>>2];v[e+20>>2]=b;a:{if(d){while(1){b=0;f=b;j=g;v[e+72>>2]=g;v[e+76>>2]=b;i=((((i&2147483647)<<1|g>>>31)&2147483646)<<1)+t|0;b:{b=v[h+16>>2];if((b|0)<=0){break b}while(1){g=(f&2147483647)<<1|j>>>31;yd(v[h+8>>2],(u[(g<<1|2)+i>>1]+u[i+((g&2147483646)<<1)>>1]|0)/8<<16>>16);xd(v[h+8>>2],4);Sb(e+72|0,h);if((b|0)<2){break b}b=b-1|0;j=v[e+72>>2];f=v[e+76>>2];continue}}b=v[h+8>>2];Sb(b,b+8|0);b=v[h+8>>2];g=v[b+4>>2];if(g){f=b;b=(v[e+76>>2]&2147483647)<<1|v[e+72>>2]>>>31;yd(f,(u[(b<<1|2)+i>>1]+u[i+((b&2147483646)<<1)>>1]|0)/8<<16>>16);xd(v[h+8>>2],g);b=v[h+8>>2];g=v[b>>2];v[b>>2]=g;v[b+4>>2]=0}d=d-1|0;f=Of(b,v[h+12>>2]);v[e+12>>2]=f;v[e+8>>2]=f;j=0;m=1;while(1){k=v[a+60>>2];l=k;i=(e+32|0)+(j<<3)|0;p=v[i>>2];b=Yb(p,-16777216,16776704);s=v[a+64>>2];g=Yb(v[i+4>>2],-16777216,16776704);q=v[a+68>>2];w=q;q=q>>31;v[i+4>>2]=p;p=v[a+72>>2];r=k>>31;k=f<<8;f=k;f=qma(l,r,f,f>>31);l=mb;r=(e+8|0)+(j<<2)|0;j=qma(s,s>>31,b,b>>31);f=j+f|0;b=mb+l|0;b=f>>>0<j>>>0?b+1|0:b;l=f;f=qma(w,q,g,g>>31);g=l+f|0;b=mb+b|0;b=g>>>0<f>>>0?b+1|0:b;g=g+8388608|0;b=g>>>0<8388608?b+1|0:b;b=(b&16777215)<<8|g>>>24;v[r>>2]=(b|0)/256;v[i>>2]=b-(k&p);if(m){j=1;m=0;f=v[e+12>>2];continue}break}b=v[a+32>>2];o=v[a+28>>2]+o|0;j=o>>12;v[c>>2]=v[c>>2]+B(j,v[e+8>>2]);n=b+n|0;b=n>>12;v[c+4>>2]=v[c+4>>2]+B(b,v[e+12>>2]);Sb(e+24|0,e+16|0);if(d){c=c+8|0;g=v[e+24>>2];i=v[e+28>>2];continue}break}g=v[e+24>>2];i=v[e+28>>2];l=v[e+44>>2];k=v[e+40>>2];m=v[e+36>>2];f=v[e+32>>2];break a}b=n>>12;j=o>>12}v[a+40>>2]=n;v[a+20>>2]=j;v[a+36>>2]=o;v[a+56>>2]=l;v[a+52>>2]=k;v[a+48>>2]=m;v[a+44>>2]=f;v[a+24>>2]=b;v[a>>2]=g;v[a+4>>2]=i;jb=e+80|0}function tH(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=jb-48|0;jb=f;v[f+40>>2]=c;v[f+44>>2]=b;v[f+36>>2]=d;j=v[a+8>>2];v[f+28>>2]=f+36;v[f+24>>2]=f+40;b=v[f+28>>2];v[f+8>>2]=v[f+24>>2];v[f+12>>2]=b;v[f+16>>2]=a;v[f+20>>2]=f+44;b=v[f+20>>2];v[f>>2]=v[f+16>>2];v[f+4>>2]=b;c=f;a:{b:{switch(v[j+40>>2]){case 0:d=jb-80|0;jb=d;e=v[c>>2];i=v[e+4>>2];b=v[e+24>>2];v[d+40>>2]=v[e+20>>2];v[d+44>>2]=b;k=v[e+16>>2];b=d;v[b+32>>2]=v[e+12>>2];v[b+36>>2]=k;Fh(b- -64|0,b+32|0,i);e=ie(b+48|0,v[v[c+4>>2]>>2],v[v[c+8>>2]>>2],v[v[c+12>>2]>>2]);k=v[v[c+12>>2]>>2];g=v[v[c+8>>2]>>2];c=v[b+76>>2];v[b+24>>2]=v[b+72>>2];v[b+28>>2]=c;c=v[b+68>>2];v[b+16>>2]=v[b+64>>2];v[b+20>>2]=c;v[b+8>>2]=v[e+8>>2];c=v[e+4>>2];v[b>>2]=v[e>>2];v[b+4>>2]=c;n=b+16|0;c=jb-16|0;jb=c;if(k){while(1){i=0;if(g){while(1){h=A[fh(b,i,l)>>3];ec(j,i);A[c+8>>3]=h;Vf(c+8|0,-1,1);h=A[c+8>>3]*32768;A[c+8>>3]=h;h=Md(h);c:{if(D(h)<2147483648){m=~~h;break c}m=-2147483648}e=Rc(m);q=Lm(n,i,l),r=e,u[q>>1]=r;i=i+1|0;if((g|0)!=(i|0)){continue}break}}l=l+1|0;if((k|0)!=(l|0)){continue}break}}jb=c+16|0;jb=d+80|0;break a;case 2:Vw(c,zb(j));break a;case 3:j=Xg(j);d=jb-80|0;jb=d;e=v[c>>2];l=v[e+4>>2];b=v[e+24>>2];v[d+40>>2]=v[e+20>>2];v[d+44>>2]=b;k=v[e+16>>2];b=d;v[b+32>>2]=v[e+12>>2];v[b+36>>2]=k;Fh(b- -64|0,b+32|0,l);e=ie(b+48|0,v[v[c+4>>2]>>2],v[v[c+8>>2]>>2],v[v[c+12>>2]>>2]);l=v[v[c+12>>2]>>2];k=v[v[c+8>>2]>>2];c=v[b+76>>2];v[b+24>>2]=v[b+72>>2];v[b+28>>2]=c;c=v[b+68>>2];v[b+16>>2]=v[b+64>>2];v[b+20>>2]=c;v[b+8>>2]=v[e+8>>2];c=v[e+4>>2];v[b>>2]=v[e>>2];v[b+4>>2]=c;n=b+16|0;c=jb-16|0;jb=c;if(l){o=j+16|0;while(1){e=0;if(k){while(1){h=Md(A[fh(b,e,i)>>3]*134217728);g=Xe(j,e);m=g;g=sj(h)+(v[g>>2]>>1)|0;p=g;g=Kr(o)+g&-4096;v[m>>2]=p-g;A[c+8>>3]=+(g|0)*7.450580596923828e-9;Vf(c+8|0,-1,1);h=A[c+8>>3]*32768;A[c+8>>3]=h;h=Md(h);d:{if(D(h)<2147483648){g=~~h;break d}g=-2147483648}g=Rc(g);q=Lm(n,e,i),r=g,u[q>>1]=r;e=e+1|0;if((k|0)!=(e|0)){continue}break}}i=i+1|0;if((l|0)!=(i|0)){continue}break}}jb=c+16|0;jb=d+80|0;break a;case 1:Vw(c,zb(j));break a;default:break b}}Vw(c,zb(j))}v[a+4>>2]=v[a+4>>2]+v[f+36>>2];jb=f+48|0}function oI(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0;j=jb-80|0;jb=j;a:{b:{c:{d:{e:{f:{k=lo(1,28);if(!k){a=ba(4)|0;Zk(a);v[113382]=0;U(1978,a|0,66740,1977);a=v[113382];v[113382]=0;if((a|0)!=1){break a}break f}v[k+12>>2]=f;v[k+8>>2]=e;v[k+4>>2]=d;v[k>>2]=c?c:1966;d=Ns(j- -64|0);g:{h:{if(!i){break h}c=v[i>>2];if(!c){break h}while(1){i:{e=v[i+4>>2];if(e){v[113382]=0;c=Q(121,j+48|0,c|0)|0;f=v[113382];v[113382]=0;j:{if((f|0)!=1){v[113382]=0;f=Q(1979,d|0,c|0)|0;l=v[113382];v[113382]=0;if((l|0)==1){break j}v[113382]=0;Q(444,f|0,e|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break j}break i}i=V(0)|0;O()|0;break g}i=V(0)|0;O()|0;yb(c);break g}v[113382]=0;c=Q(121,j+48|0,c|0)|0;e=v[113382];v[113382]=0;k:{if((e|0)!=1){v[113382]=0;Q(1980,d|0,c|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break k}break i}i=V(0)|0;O()|0;break g}i=V(0)|0;O()|0;yb(c);break g}yb(c);c=v[i+8>>2];i=i+8|0;if(c){continue}break}}c=v[a+8>>2];e=v[a+4>>2];f=v[a>>2];v[113382]=0;a=T(1361,80)|0;i=v[113382];v[113382]=0;l:{m:{n:{if((i|0)!=1){v[113382]=0;v[j+44>>2]=c;v[j+40>>2]=e;v[j+36>>2]=f;v[j+32>>2]=b;b=Q(1981,k|0,k+4|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break n}v[j+48>>2]=b;b=v[Jo(j+24|0,j+48|0)>>2];v[113382]=0;c=v[j+44>>2];v[j+16>>2]=v[j+40>>2];v[j+20>>2]=c;c=v[j+36>>2];v[j+8>>2]=v[j+32>>2];v[j+12>>2]=c;aa(1982,a|0,j+8|0,b|0,d|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break m}v[k+24>>2]=a;ad(j+48|0);sk(d);c=k;break d}i=V(0)|0;O()|0;break g}i=V(0)|0;O()|0;break l}i=V(0)|0;O()|0;ad(j+48|0)}Wb(a)}sk(d);_(i|0)|0;v[113382]=0;X(1958,10928,k|0,g|0,h|0);a=v[113382];v[113382]=0;if((a|0)!=1){v[113382]=0;Y(20);a=v[113382];v[113382]=0;if((a|0)==1){break f}a=v[k+24>>2];if(a){Wb(Tr(a))}c=0;v[k+24>>2]=0;a=v[k+20>>2];if(a){Wb(a);v[k+20>>2]=0}Wb(k);break d}i=V(0)|0;O()|0;v[113382]=0;Y(20);a=v[113382];v[113382]=0;if((a|0)!=1){break e}break b}i=V(0)|0;O()|0}_(i|0)|0;c=0;v[113382]=0;X(1958,10928,0,g|0,h|0);a=v[113382];v[113382]=0;if((a|0)==1){break c}$()}jb=j+80|0;return c|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)==1){break b}S(a|0);L()}V(0)|0;O()|0;Ab()}L()}function DD(a,b,c,d,e,f,g,h,i){var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;j=jb-128|0;jb=j;a:{b:{c:{if(!il(f,g,h,i,0,0,0,0)){break c}m=f;n=g;l=h;o=i&65535;k=i>>>16&32767;d:{e:{if((k|0)!=32767){p=4;if(k){break e}m=l|m|(n|o)?3:2;break d}p=!(l|m|(n|o))}m=p}if(!m){break c}r=e>>>16|0;o=r&32767;if((o|0)!=32767){break b}}pd(j+16|0,b,c,d,e,f,g,h,i);e=v[j+16>>2];d=v[j+20>>2];c=v[j+24>>2];b=v[j+28>>2];WF(j,e,d,c,b,e,d,c,b);d=v[j+8>>2];e=v[j+12>>2];h=v[j>>2];i=v[j+4>>2];break a}l=o<<16;p=d;q=l|e&65535;m=q;n=h;q=i>>>16&32767;k=i&65535|q<<16;if((il(b,c,p,m,f,g,h,k)|0)<=0){if(il(b,c,p,m,f,g,n,k)){h=b;i=c;break a}pd(j+112|0,b,c,d,e,0,0,0,0);d=v[j+120>>2];e=v[j+124>>2];h=v[j+112>>2];i=v[j+116>>2];break a}if(o){i=c;h=b}else{pd(j+96|0,b,c,p,m,0,0,0,1081540608);h=v[j+108>>2];m=h;p=v[j+104>>2];o=(h>>>16|0)-120|0;i=v[j+100>>2];h=v[j+96>>2]}if(!q){pd(j+80|0,f,g,n,k,0,0,0,1081540608);f=v[j+92>>2];k=f;n=v[j+88>>2];q=(k>>>16|0)-120|0;g=v[j+84>>2];f=v[j+80>>2]}s=k&65535|65536;m=m&65535|65536;if((o|0)>(q|0)){while(1){k=p;l=n;t=k-l|0;l=m-((k>>>0<l>>>0)+s|0)|0;k=(g|0)==(i|0)&f>>>0>h>>>0|g>>>0>i>>>0;l=l-(k>>>0>t>>>0)|0;k=t-k|0;f:{if((l|0)>0|(l|0)>=0){m=h;h=h-f|0;i=i-((f>>>0>m>>>0)+g|0)|0;if(!(h|k|(i|l))){pd(j+32|0,b,c,d,e,0,0,0,0);d=v[j+40>>2];e=v[j+44>>2];h=v[j+32>>2];i=v[j+36>>2];break a}l=l<<1|k>>>31;p=k<<1|i>>>31;break f}l=m<<1|p>>>31;p=p<<1|i>>>31}m=l;l=i<<1|h>>>31;h=h<<1;i=l;o=o-1|0;if((q|0)<(o|0)){continue}break}o=q}l=p;q=l-n|0;n=m-((l>>>0<n>>>0)+s|0)|0;l=(g|0)==(i|0)&f>>>0>h>>>0|g>>>0>i>>>0;k=n-(l>>>0>q>>>0)|0;n=q-l|0;g:{if((k|0)<0){n=p;k=m;break g}p=h;h=h-f|0;i=i-((f>>>0>p>>>0)+g|0)|0;if(h|n|(i|k)){break g}pd(j+48|0,b,c,d,e,0,0,0,0);d=v[j+56>>2];e=v[j+60>>2];h=v[j+48>>2];i=v[j+52>>2];break a}if((k|0)==65535|k>>>0<65535){while(1){b=i>>>31|0;o=o-1|0;m=i<<1|h>>>31;h=h<<1;i=m;c=b;b=n;k=k<<1|b>>>31;n=c|b<<1;if(k>>>0<65536){continue}break}}b=r&32768;if((o|0)<=0){pd(j- -64|0,h,i,n,k&65535|(b|o+120)<<16,0,0,0,1065811968);d=v[j+72>>2];e=v[j+76>>2];h=v[j+64>>2];i=v[j+68>>2];break a}d=n;e=k&65535|(b|o)<<16}v[a>>2]=h;v[a+4>>2]=i;v[a+8>>2]=d;v[a+12>>2]=e;jb=j+128|0}function SK(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0,k=0;h=jb-16|0;jb=h;a:{b:{c:{f=B(b,896)+a|0;if(w[f+1075074|0]&2){e=v[a+480180>>2];d:{e:{f:{if(v[a+480208>>2]&4096){if(!(e&16777248)){break f}if(v[a+480180>>2]==64){break e}if(v[a+480208>>2]&4){break d}break c}if((e|0)!=64){break c}break e}if(v[a+480180>>2]!=64){break d}}a=B(b,896)+a|0;b=a+1075823|0;d=w[b|0];if(d&1){v[c>>2]=v[c>>2]+B(w[a+1075828|0],167)}t[b|0]=d+1;break a}break b}if(!(w[f+1075654|0]&2)){break a}a=jy(a,b);if(!a){break a}nb[v[v[a>>2]+84>>2]](a,0,0,b);break a}e=h+8|0;Fb(e,a+1074312|0,21);k=1;if(!Cb(e)){break b}e=B(b,896)+a|0;g=e+1075823|0;t[g|0]=w[g|0]+(w[e+1075827|0]<<2)}g=B(b,896)+a|0;j=g+1075826|0;i=g+1075823|0;e=Rx(a,w[j|0],w[i|0]);g:{if(tj(f+1074984|0)){z[d>>2]=C(C(B(w[g+1075828|0],e)|0)*C(6510417279059766e-21))+z[d>>2];c=g+1075856|0;d=w[c|0];t[c|0]=d&243|8;if(v[a+1074416>>2]!=(v[a+1074392>>2]+1|0)){break g}t[c|0]=d|12;break g}if((v[a+480208>>2]&2101248)==2101248|(w[a+480209|0]&16?v[a+480180>>2]&67633152:0)){break a}e=v[a+480180>>2]&5?(w[j|0]&3)==1?0-e|0:e:e;d=h+8|0;f=a+1074312|0;Fb(d,f,21);d=Cb(d);g=v[a+480208>>2];h:{if(d){d=g&4;e=d?e:0-e|0;d=d?5:6;break h}d=5;i:{if(g&131072){break i}d=8;if(v[a+480180>>2]==1024){break i}d=7;if(v[a+480180>>2]&524304|(w[a+480208|0]&4?0:v[a+480180>>2]&16777248)){break i}d=6}g=h+8|0;Fb(g,f,80);if(!Cb(g)){break h}d=w[(B(b,896)+a|0)+1075797|0]==26?d+2|0:d}d=(B(w[(B(b,896)+a|0)+1075828|0],e)|0)/(1<<d)|0;g=0-d|0;j:{if(!(w[a+480208|0]&16)|v[a+480180>>2]==4){break j}e=v[c>>2];k:{if((d|0)<0){d=iy(a,g>>>2|0);d=zc(rma(qma(d,d>>31,e,e>>31),mb,65536,0),mb);e=v[c>>2];d=d-e|0;f=g&3;if(!f){break j}f=TL(a,f);break k}f=d&3;d=hy(a,d>>>2|0);d=zc(rma(qma(d,d>>31,e,e>>31),mb,65536,0),mb);e=v[c>>2];d=d-e|0;if(!f){break j}f=SL(a,f)}d=(zc(rma(qma(f,f>>31,e,e>>31),mb,65536,0),mb)+d|0)-v[c>>2]|0}v[c>>2]=v[c>>2]+d;c=jy(a,b);if(!c){break g}d=c;g=g<<16>>16;e=v[(B(b,896)+a|0)+1075640>>2];if(e){f=w[e+33|0]}else{f=2}nb[v[v[c>>2]+84>>2]](d,g,f<<24>>24,b)}if(!k){break a}c=h+8|0;Fb(c,a+1074312|0,21);if(Cb(c)){break a}t[i|0]=w[i|0]+w[(B(b,896)+a|0)+1075827|0]}jb=h+16|0}function dea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,w=0,x=0,y=0;e=jb-80|0;jb=e;u=v[a+16>>2];h=Uf(e+48|0);v[h+8>>2]=a+112;v[h+16>>2]=v[a+128>>2];x=h,y=Pf(b+327720|0,v[b+20>>2],(v[a+88>>2]&16384)>>>14|0),v[x+12>>2]=y;b=v[h+16>>2];if(b){x=h,y=Tf(a+8|0,b),v[x>>2]=y;v[h+4>>2]=mb}f=v[a+44>>2];v[e+32>>2]=f;m=v[a+48>>2];v[e+36>>2]=m;k=v[a+52>>2];v[e+40>>2]=k;l=v[a+56>>2];v[e+44>>2]=l;n=v[a+40>>2];o=v[a+36>>2];i=v[a+4>>2];g=v[a>>2];v[e+24>>2]=g;v[e+28>>2]=i;b=v[a+12>>2];v[e+16>>2]=v[a+8>>2];v[e+20>>2]=b;a:{if(d){while(1){b=0;f=b;j=g;v[e+72>>2]=g;v[e+76>>2]=b;i=(((i&2147483647)<<1|g>>>31)&-2)+u|0;b:{b=v[h+16>>2];if((b|0)<=0){break b}while(1){g=(f&2147483647)<<1|j>>>31;yd(v[h+8>>2],t[(g|1)+i|0]+t[i+(g&-2)|0]<<5);xd(v[h+8>>2],4);Sb(e+72|0,h);if((b|0)<2){break b}b=b-1|0;j=v[e+72>>2];f=v[e+76>>2];continue}}b=v[h+8>>2];Sb(b,b+8|0);b=v[h+8>>2];g=v[b+4>>2];if(g){f=b;b=(v[e+76>>2]&2147483647)<<1|v[e+72>>2]>>>31;yd(f,t[(b|1)+i|0]+t[i+(b&-2)|0]<<5);xd(v[h+8>>2],g);b=v[h+8>>2];g=v[b>>2];v[b>>2]=g;v[b+4>>2]=0}d=d-1|0;f=Of(b,v[h+12>>2]);v[e+12>>2]=f;v[e+8>>2]=f;j=0;m=1;while(1){k=v[a+60>>2];l=k;i=(e+32|0)+(j<<3)|0;p=v[i>>2];b=Yb(p,-16777216,16776704);s=v[a+64>>2];g=Yb(v[i+4>>2],-16777216,16776704);q=v[a+68>>2];w=q;q=q>>31;v[i+4>>2]=p;p=v[a+72>>2];r=k>>31;k=f<<8;f=k;f=qma(l,r,f,f>>31);l=mb;r=(e+8|0)+(j<<2)|0;j=qma(s,s>>31,b,b>>31);f=j+f|0;b=mb+l|0;b=f>>>0<j>>>0?b+1|0:b;l=f;f=qma(w,q,g,g>>31);g=l+f|0;b=mb+b|0;b=g>>>0<f>>>0?b+1|0:b;g=g+8388608|0;b=g>>>0<8388608?b+1|0:b;b=(b&16777215)<<8|g>>>24;v[r>>2]=(b|0)/256;v[i>>2]=b-(k&p);if(m){j=1;m=0;f=v[e+12>>2];continue}break}b=v[a+32>>2];o=v[a+28>>2]+o|0;j=o>>12;v[c>>2]=v[c>>2]+B(j,v[e+8>>2]);n=b+n|0;b=n>>12;v[c+4>>2]=v[c+4>>2]+B(b,v[e+12>>2]);Sb(e+24|0,e+16|0);if(d){c=c+8|0;g=v[e+24>>2];i=v[e+28>>2];continue}break}g=v[e+24>>2];i=v[e+28>>2];l=v[e+44>>2];k=v[e+40>>2];m=v[e+36>>2];f=v[e+32>>2];break a}b=n>>12;j=o>>12}v[a+40>>2]=n;v[a+20>>2]=j;v[a+36>>2]=o;v[a+56>>2]=l;v[a+52>>2]=k;v[a+48>>2]=m;v[a+44>>2]=f;v[a+24>>2]=b;v[a>>2]=g;v[a+4>>2]=i;jb=e+80|0}function Zm(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;g=jb-16|0;jb=g;v[b+88>>2]=v[b+88>>2]|524288;a:{b:{if(!(v[a+480208>>2]&8)){f=g+8|0;Fb(f,a+1074312|0,15);if(Cb(f)){break b}}if(v[a+480180>>2]!=268435456){break a}}c=c?c:w[b+831|0];t[b+832|0]=c;t[b+831|0]=c}if(c){v[b+776>>2]=c}c:{if(tj(b)){c=v[b+776>>2];if(!c){break c}e=v[a+1074392>>2];d=v[b+708>>2];if(!(!((c|0)<0&(d|0)>0)&((c|0)<=0|(d|0)>=0))){c=0-c|0;v[b+776>>2]=c}i=v[b+880>>2];h=b;j=(+(e>>>0)+1)*+(c|0)/+y[a+1074416>>2];d:{if(D(j)<2147483648){a=~~j;break d}a=-2147483648}v[h+880>>2]=a;if(w[b+90|0]&16){a=B(v[v[v[b+656>>2]+44>>2]+36>>2]+1|0,a);v[b+880>>2]=a}a=a-(e?i:0)|0;c=a>>31;f=d>>31;if((f+d^f)>>>0<=(c^a+c)>>>0){if(!d){break c}v[b+708>>2]=0;v[b+876>>2]=d+v[b+876>>2];t[b+872|0]=w[b+872|0]|8;break c}v[b+708>>2]=d-a;v[b+876>>2]=a+v[b+876>>2];t[b+872|0]=w[b+872|0]|8;break c}e=1;e:{if(!(t[b+872|0]&1)|v[a+480180>>2]&524352){break e}if(v[a+1074416>>2]==1){c=g+8|0;Fb(c,a+1074312|0,6);if(Cb(c)){break e}}e=0;if(v[a+480180>>2]!=8){break e}e=(w[a+480208|0]&2)>>>1|0}f=v[b+776>>2];i=v[a+480180>>2];k=w[b+872|0];l=v[a+480180>>2];c=v[b+700>>2];f:{if(!c){d=v[b+708>>2];c=0;break f}d=v[b+708>>2];if(!d){break f}h=e;e=(i|0)==268435456&(f|0)>239;if(!(e?k&1:h)){break f}f=e?f-240|0:f;e=(l|0)==64?B(f,10):f;h=b;g:{h:{i:{j:{k:{if((c|0)<(d|0)){if(w[a+480208|0]&16){if(v[a+480180>>2]!=4){break k}c=v[b+700>>2]}e=e<<2;break h}if((c|0)<=(d|0)){break f}if(w[a+480208|0]&16){if(v[a+480180>>2]!=4){break j}c=v[b+700>>2]}e=0-(e<<2)|0;break i}c=v[((e>>>0<255?e:255)<<2)+30544>>2];e=c;d=c>>31;c=v[b+700>>2];d=qma(e,d,c,c>>31)+32768|0;c=mb;e=zc(rma(d,d>>>0<32768?c+1|0:c,65536,0),mb);c=v[b+700>>2];d=e-c|0;e=(d|0)>1?d:1;break h}c=v[((e>>>0<255?e:255)<<2)+31568>>2];e=c;d=c>>31;c=v[b+700>>2];d=qma(e,d,c,c>>31)+32768|0;c=mb;e=zc(rma(d,d>>>0<32768?c+1|0:c,65536,0),mb);c=v[b+700>>2];d=e-c|0;e=(d|0)<-1?d:-1}d=v[b+708>>2];c=c+e|0;c=(c|0)<(d|0)?d:c;break g}d=v[b+708>>2];c=c+e|0;c=(c|0)>(d|0)?d:c}v[h+700>>2]=c}if((c|0)!=(d|0)){break c}c=g+8|0;Fb(c,a+1074312|0,25);if(!Cb(c)&v[a+480180>>2]!=1){break c}v[b+708>>2]=0}jb=g+16|0}function Kea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0;g=jb-48|0;jb=g;a:{b:{c:{f=v[a+12>>2];i=v[a+8>>2];d:{if((f|0)<=1&i>>>0<=805306368|(f|0)<=0){if((f|0)>=-2&i>>>0>=3489660928|(f|0)>-2){break c}if((f|0)==-2&i>>>0>2147483647|f>>>0>4294967294){break d}break b}if((f|0)==1&i>>>0>2147483648|f>>>0>1){break b}}b=b+196648|0;break a}b=b+131112|0;break a}b=b+262184|0}t=b;w=v[a+16>>2];h=v[a+44>>2];v[g+32>>2]=h;m=v[a+48>>2];v[g+36>>2]=m;k=v[a+52>>2];v[g+40>>2]=k;l=v[a+56>>2];v[g+44>>2]=l;o=v[a+40>>2];p=v[a+36>>2];e=v[a+4>>2];j=v[a>>2];v[g+24>>2]=j;v[g+28>>2]=e;v[g+16>>2]=i;v[g+20>>2]=f;e:{if(d){while(1){m=1;b=((((e&2147483647)<<1|j>>>31)&2147483646)<<1)+w|0;e=(j>>>16&65520)+t|0;j=u[e+14>>1];i=u[e+12>>1];l=u[e+10>>1];q=u[e+8>>1];x=u[e+6>>1];n=u[e+4>>1];r=u[e+2>>1];s=u[e>>1];h=0;k=1;f=0;while(1){e=f<<1;v[(g+8|0)+(f<<2)>>2]=(((((((B(u[b+(e|-8)>>1],r)+B(u[b+(e|-12)>>1],s)|0)+B(u[b+(e|-4)>>1],n)|0)+B(u[b+e>>1],x)|0)+B(u[b+(e|4)>>1],q)|0)+B(u[b+(e|8)>>1],l)|0)+B(i,u[b+(e|12)>>1])|0)+B(j,u[b+(e|16)>>1])|0)/32768;e=k&1;k=0;f=1;if(e){continue}break}while(1){k=(g+8|0)+(h<<2)|0;j=v[k>>2];i=v[a+60>>2];e=(g+32|0)+(h<<3)|0;h=v[e>>2];b=Yb(h,-16777216,16776704);q=v[a+64>>2];f=Yb(v[e+4>>2],-16777216,16776704);n=v[a+68>>2];r=n;n=n>>31;v[e+4>>2]=h;s=v[a+72>>2];j=j<<8;h=j;h=qma(i,i>>31,h,h>>31);i=mb;l=k;k=qma(q,q>>31,b,b>>31);h=k+h|0;b=mb+i|0;b=h>>>0<k>>>0?b+1|0:b;i=h;h=qma(r,n,f,f>>31);f=i+h|0;b=mb+b|0;b=f>>>0<h>>>0?b+1|0:b;f=f+8388608|0;b=f>>>0<8388608?b+1|0:b;b=(b&16777215)<<8|f>>>24;v[l>>2]=(b|0)/256;v[e>>2]=b-(j&s);h=1;b=m&1;m=0;if(b){continue}break}b=v[a+32>>2];p=v[a+28>>2]+p|0;f=p>>12;v[c>>2]=v[c>>2]+B(f,v[g+8>>2]);o=b+o|0;b=o>>12;v[c+4>>2]=v[c+4>>2]+B(b,v[g+12>>2]);Sb(g+24|0,g+16|0);d=d-1|0;if(d){c=c+8|0;j=v[g+24>>2];e=v[g+28>>2];continue}break}j=v[g+24>>2];e=v[g+28>>2];l=v[g+44>>2];k=v[g+40>>2];m=v[g+36>>2];h=v[g+32>>2];break e}b=o>>12;f=p>>12}v[a+40>>2]=o;v[a+20>>2]=f;v[a+36>>2]=p;v[a+56>>2]=l;v[a+52>>2]=k;v[a+48>>2]=m;v[a+44>>2]=h;v[a+24>>2]=b;v[a>>2]=j;v[a+4>>2]=e;jb=g+48|0}function y_(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=jb-1072|0;jb=j;v[j+16>>2]=f;v[j+20>>2]=g;v[j+24>>2]=h;v[j+28>>2]=i;a=j+960|0;v[j+956>>2]=a;k=pw(a,100,7117,j+16|0);v[j+48>>2]=2310;a=j+48|0;n=Ld(j+536|0,0,a);v[j+48>>2]=2310;l=Ld(j+528|0,0,a);m=j+544|0;a:{b:{c:{if(k>>>0>=100){v[113382]=0;a=da(2335)|0;k=v[113382];v[113382]=0;if((k|0)==1){break b}v[j>>2]=f;v[j+4>>2]=g;v[113382]=0;v[j+8>>2]=h;v[j+12>>2]=i;k=aa(2358,j+956|0,a|0,7117,j|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break b}if((k|0)==-1){v[113382]=0;Y(2311);a=v[113382];v[113382]=0;if((a|0)!=1){break c}break b}ve(n,v[j+956>>2]);ve(l,kd(k<<2));if(qj(l)){v[113382]=0;Y(2311);a=v[113382];v[113382]=0;if((a|0)==1){break b}break c}m=v[l>>2]}v[113382]=0;Ac(j+520|0,d);a=v[113382];v[113382]=0;d:{e:{f:{g:{h:{i:{j:{if((a|0)!=1){v[113382]=0;p=T(2339,j+520|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break j}v[113382]=0;a=v[j+956>>2];aa(2353,p|0,a|0,a+k|0,m|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break j}o=(k|0)>0?w[v[j+956>>2]]==45:o;h=Xb(j+488|0);f=sf(j+472|0);g=sf(j+456|0);v[113382]=0;na(2394,c|0,o|0,j+520|0,j+512|0,j+508|0,j+504|0,h|0,f|0,g|0,j+452|0);a=v[113382];v[113382]=0;if((a|0)==1){break i}v[j+36>>2]=2310;i=Ld(j+40|0,0,j+36|0);c=j+48|0;a=v[j+452>>2];k:{if((a|0)<(k|0)){a=(((Db(g)+(k-a<<1)|0)+Db(f)|0)+v[j+452>>2]|0)+1|0;break k}a=((Db(g)+Db(f)|0)+v[j+452>>2]|0)+2|0}if(a>>>0<101){break h}ve(i,kd(a<<2));c=v[i>>2];if(c){break h}v[113382]=0;Y(2311);a=v[113382];v[113382]=0;if((a|0)!=1){break c}break g}k=P()|0;O()|0;break a}k=P()|0;O()|0;break e}k=P()|0;O()|0;break f}a=v[d+4>>2];v[113382]=0;sa(2395,c|0,j+36|0,j+32|0,a|0,m|0,(k<<2)+m|0,p|0,o|0,j+512|0,v[j+508>>2],v[j+504>>2],h|0,f|0,g|0,v[j+452>>2]);a=v[113382];v[113382]=0;if((a|0)!=1){v[113382]=0;a=ka(2370,b|0,c|0,v[j+36>>2],v[j+32>>2],d|0,e|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){break d}}}k=P()|0;O()|0;Gc(i)}Jc(g);Jc(f);yb(h)}Ob(j+520|0);break a}Gc(i);Jc(g);Jc(f);yb(h);Ob(j+520|0);Gc(l);Gc(n);jb=j+1072|0;return a|0}L()}k=P()|0;O()|0}Gc(l);Gc(n);S(k|0);L()}function sl(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;h=jb-16|0;jb=h;a:{b:{if(id(a)|y[a+12>>2]<=y[b+4>>2]){break b}c=x[b+8>>1]>=mk(a)>>>0;g=x[b+8>>1];if(c&(g|0)!=65535){break b}f=g;if((f&65535)==65535){g=mk(a)-1|0;f=0}d=Bf(a,v[b+4>>2],f&65535);i=w[b+12|0];k=i&4;c:{d:{if(i&2){break d}l=g&65535;if(l>>>0<(f&65535)>>>0){break d}j=w[b+10|0];e=f;c=d;while(1){e:{if(!k){if((j|0)!=w[c+3|0]){break e}break c}if((j|0)==w[c+2|0]){break c}}c=c+6|0;e=e+1|0;if((e&65535)>>>0<=l>>>0){continue}break}}j=g&65535;if(j>>>0>=(f&65535)>>>0){e=f;c=d;while(1){f:{if(!k){if(w[c+3|0]){break f}t[c+3|0]=w[b+10|0];t[c+5|0]=w[b+11|0];break c}if(w[c+2|0]){break f}t[c+2|0]=w[b+10|0];t[c+4|0]=w[b+11|0];break c}c=c+6|0;e=e+1|0;if(j>>>0>=(e&65535)>>>0){continue}break}}g:{if(!(i&1)){break g}i=v[Um(a)+480180>>2]&2;e=w[b+12|0];h:{if(e&4){break h}g=g&65535;if(g>>>0<(f&65535)>>>0){break h}while(1){i:{j:{switch(w[d+3|0]-9|0){case 4:if(!oK(v[Um(a)+8>>2],1)){break i}c=1;t[d+2|0]=1;t[d+4|0]=w[d+5|0];t[d+3|0]=w[b+10|0];t[d+5|0]=w[b+11|0];break a;case 0:break j;default:break i}}c=d;k:{if(i){e=w[d+5|0];if(e>>>0>128){break i}t[d+2|0]=2;t[d+3|0]=w[b+10|0];a=1;break k}t[d+2|0]=2;t[d+3|0]=w[b+10|0];e=w[d+5|0];a=2}t[c+4|0]=a+e>>>a;t[d+5|0]=w[b+11|0];break c}d=d+6|0;f=f+1|0;if(g>>>0>=(f&65535)>>>0){continue}break}e=w[b+12|0]}l:{if(e&4){c=w[b+11|0];d=13;m:{switch(w[b+10|0]-1|0){case 1:c=Qk(B(i?2:4,c));e=w[b+12|0];d=9;break;case 0:break m;default:break l}}t[b+11|0]=c;t[b+10|0]=d;e=e&254;t[b+12|0]=e;break l}f=w[b+11|0];t[h+14|0]=f;d=b;c=w[b+10|0];n:{o:{if(!(!i|(c|0)!=9)){if(f>>>0>128){break n}c=2;f=(f&254)>>>1|0;break o}t[h+15|0]=c;if(!Dx(h+15|0,h+14|0,1)){break n}c=w[h+15|0];if(!c){break n}e=w[b+12|0];f=w[h+14|0]}t[d+11|0]=f;t[b+10|0]=c;t[b+12|0]=e&254}e=w[b+12|0]}c=1;if(e&1){break g}t[b+12|0]=e^4;if(sl(a,b)){break a}}d=v[b>>2];p:{if((d|0)==1){if(y[a+12>>2]>v[b+4>>2]+1>>>0){v[b+4>>2]=v[b+4>>2]+1;break p}d=v[b>>2]}if((d|0)!=2){break b}c=0;d=v[b+4>>2];if(!d){break a}v[b+4>>2]=d-1}t[b+12|0]=w[b+12|0]|1;c=sl(a,b);break a}c=1;break a}c=0}jb=h+16|0;return c|0}function C_(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=jb-464|0;jb=j;v[j+16>>2]=f;v[j+20>>2]=g;v[j+24>>2]=h;v[j+28>>2]=i;a=j+352|0;v[j+348>>2]=a;k=pw(a,100,7117,j+16|0);v[j+48>>2]=2310;a=j+48|0;n=Ld(j+232|0,0,a);v[j+48>>2]=2310;l=Ld(j+224|0,0,a);m=j+240|0;a:{b:{c:{if(k>>>0>=100){v[113382]=0;a=da(2335)|0;k=v[113382];v[113382]=0;if((k|0)==1){break b}v[j>>2]=f;v[j+4>>2]=g;v[113382]=0;v[j+8>>2]=h;v[j+12>>2]=i;k=aa(2358,j+348|0,a|0,7117,j|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break b}if((k|0)==-1){v[113382]=0;Y(2311);a=v[113382];v[113382]=0;if((a|0)!=1){break c}break b}ve(n,v[j+348>>2]);ve(l,kd(k));if(qj(l)){v[113382]=0;Y(2311);a=v[113382];v[113382]=0;if((a|0)==1){break b}break c}m=v[l>>2]}v[113382]=0;Ac(j+216|0,d);a=v[113382];v[113382]=0;d:{e:{f:{g:{h:{i:{j:{if((a|0)!=1){v[113382]=0;p=T(21,j+216|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break j}v[113382]=0;a=v[j+348>>2];aa(2330,p|0,a|0,a+k|0,m|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break j}o=(k|0)>0?w[v[j+348>>2]]==45:o;h=Xb(j+192|0);f=Xb(j+176|0);g=Xb(j+160|0);v[113382]=0;na(2392,c|0,o|0,j+216|0,j+208|0,j+207|0,j+206|0,h|0,f|0,g|0,j+156|0);a=v[113382];v[113382]=0;if((a|0)==1){break i}v[j+36>>2]=2310;i=Ld(j+40|0,0,j+36|0);c=j+48|0;a=v[j+156>>2];k:{if((a|0)<(k|0)){a=(((Db(g)+(k-a<<1)|0)+Db(f)|0)+v[j+156>>2]|0)+1|0;break k}a=((Db(g)+Db(f)|0)+v[j+156>>2]|0)+2|0}if(a>>>0<101){break h}ve(i,kd(a));c=v[i>>2];if(c){break h}v[113382]=0;Y(2311);a=v[113382];v[113382]=0;if((a|0)!=1){break c}break g}k=P()|0;O()|0;break a}k=P()|0;O()|0;break e}k=P()|0;O()|0;break f}a=v[d+4>>2];v[113382]=0;sa(2393,c|0,j+36|0,j+32|0,a|0,m|0,k+m|0,p|0,o|0,j+208|0,t[j+207|0],t[j+206|0],h|0,f|0,g|0,v[j+156>>2]);a=v[113382];v[113382]=0;if((a|0)!=1){v[113382]=0;a=ka(17,b|0,c|0,v[j+36>>2],v[j+32>>2],d|0,e|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){break d}}}k=P()|0;O()|0;Gc(i)}yb(g);yb(f);yb(h)}Ob(j+216|0);break a}Gc(i);yb(g);yb(f);yb(h);Ob(j+216|0);Gc(l);Gc(n);jb=j+464|0;return a|0}L()}k=P()|0;O()|0}Gc(l);Gc(n);S(k|0);L()}function QN(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,z=0,A=0;a:{if(!Be(a)){break a}kn(a);if(c){c=b;o=jb-16|0;jb=o;g=a;if(Be(a)){s=c+1304360|0;d=c+1074984|0;c=x[g+34>>1];m=c&4;z=c&2;i=c&16;A=c&8;h=v[g+8>>2];p=v[g+4>>2];f=v[g+16>>2];q=v[g+12>>2];while(1){b:{if((g|0)!=v[d+104>>2]){break b}e=v[d+76>>2];if(!e){break b}j=d;c:{d:{e:{f:{n=v[g>>2];if(!A|(f>>>0<=q>>>0|f>>>0>n>>>0)){break f}l=v[d+88>>2];if(l&2048){break f}v[d+84>>2]=f;v[d+80>>2]=q;e=f;c=i;break e}if(!z|(h>>>0<=p>>>0|h>>>0>n>>>0)){break d}v[d+84>>2]=h;v[d+80>>2]=p;l=v[d+88>>2];e=h;c=m}v[j+76>>2]=e;k=l|2;r=d+88|0;l=(c|0)!=0;c=1;break c}r=d+88|0;k=v[d+88>>2]&-3;l=0;c=0}k=k&-5|(c?l?4:0:0);v[d+88>>2]=k;if(y[d+4>>2]>e>>>0){k=k&-129;v[d+88>>2]=k;j=v[d+80>>2];v[d>>2]=0;v[d+4>>2]=j}if(!l){v[r>>2]=k&-129}if(c){break b}v[d+76>>2]=n}d=d+896|0;if((s|0)!=(d|0)){continue}break}}jb=o+16|0}if((uq(a)|0)==2){d=0;g=jb+-64|0;jb=g;e=te(a);m=e<<6;h=v[a+20>>2];f=h+(B(e,v[a>>2])<<1)|0;while(1){if(e){i=B(d,e);j=B(e,d^-1);c=0;while(1){u[f+(c+i<<1)>>1]=x[f+(c-e<<1)>>1];u[h+(c+j<<1)>>1]=x[h+(c<<1)>>1];c=c+1|0;if((e|0)!=(c|0)){continue}break}}d=d+1|0;if((d|0)!=16){continue}break}d=f+(e<<5)|0;c=x[a+34>>1];if(c&2){i=v[a+8>>2];f=v[a+4>>2];j=g+32|0;Fb(j,b+1074312|0,33);PN(g+40|0,d,h+(B(e,f)<<1)|0,i-f|0,e,(c&4)>>>2|0,Cb(j));c=x[a+34>>1]}if(c&8){f=v[a+16>>2];a=v[a+12>>2];i=g+32|0;Fb(i,b+1074312|0,33);PN(g+8|0,d+(m<<1)|0,h+(B(a,e)<<1)|0,f-a|0,e,(c&16)>>>4|0,Cb(i))}jb=g- -64|0;return}if((uq(a)|0)!=1){break a}d=0;g=jb+-64|0;jb=g;e=te(a);m=e<<6;h=v[a+20>>2];f=h+B(e,v[a>>2])|0;while(1){if(e){i=B(d,e);j=B(e,d^-1);c=0;while(1){t[f+(c+i|0)|0]=w[f+(c-e|0)|0];t[h+(c+j|0)|0]=w[c+h|0];c=c+1|0;if((e|0)!=(c|0)){continue}break}}d=d+1|0;if((d|0)!=16){continue}break}d=f+(e<<4)|0;c=x[a+34>>1];if(c&2){i=v[a+8>>2];f=v[a+4>>2];j=g+32|0;Fb(j,b+1074312|0,33);ON(g+40|0,d,h+B(e,f)|0,i-f|0,e,(c&4)>>>2|0,Cb(j));c=x[a+34>>1]}if(c&8){f=v[a+16>>2];a=v[a+12>>2];i=g+32|0;Fb(i,b+1074312|0,33);ON(g+8|0,d+m|0,h+B(a,e)|0,f-a|0,e,(c&16)>>>4|0,Cb(i))}jb=g- -64|0}}function Lea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,w=0,x=0,y=0;e=jb-48|0;jb=e;a:{b:{c:{f=v[a+12>>2];i=v[a+8>>2];d:{if((f|0)<=1&i>>>0<=805306368|(f|0)<=0){if((f|0)>=-2&i>>>0>=3489660928|(f|0)>-2){break c}if((f|0)==-2&i>>>0>2147483647|f>>>0>4294967294){break d}break b}if((f|0)==1&i>>>0>2147483648|f>>>0>1){break b}}b=b+196648|0;break a}b=b+131112|0;break a}b=b+262184|0}w=b;x=v[a+16>>2];g=v[a+44>>2];v[e+32>>2]=g;m=v[a+48>>2];v[e+36>>2]=m;k=v[a+52>>2];v[e+40>>2]=k;l=v[a+56>>2];v[e+44>>2]=l;o=v[a+40>>2];p=v[a+36>>2];h=v[a+4>>2];j=v[a>>2];v[e+24>>2]=j;v[e+28>>2]=h;v[e+16>>2]=i;v[e+20>>2]=f;e:{if(d){while(1){h=(((h&2147483647)<<1|j>>>31)&-2)+x|0;b=(j>>>16&65520)+w|0;f=u[b+14>>1];j=u[b+12>>1];i=u[b+10>>1];l=u[b+8>>1];q=u[b+6>>1];y=u[b+4>>1];n=u[b+2>>1];r=u[b>>1];g=0;m=1;k=1;b=0;while(1){v[(e+8|0)+(b<<2)>>2]=(((((((B(t[h+(b|-4)|0],n)+B(t[h+(b|-6)|0],r)|0)+B(t[h+(b|-2)|0],y)|0)+B(t[b+h|0],q)|0)+B(t[h+(b|2)|0],l)|0)+B(t[h+(b|4)|0],i)|0)+B(j,t[h+(b|6)|0])|0)+B(f,t[h+(b|8)|0])<<8)/32768;s=k&1;k=0;b=1;if(s){continue}break}while(1){k=(e+8|0)+(g<<2)|0;j=v[k>>2];i=v[a+60>>2];h=(e+32|0)+(g<<3)|0;g=v[h>>2];b=Yb(g,-16777216,16776704);q=v[a+64>>2];f=Yb(v[h+4>>2],-16777216,16776704);n=v[a+68>>2];r=n;n=n>>31;v[h+4>>2]=g;s=v[a+72>>2];j=j<<8;g=j;g=qma(i,i>>31,g,g>>31);i=mb;l=k;k=qma(q,q>>31,b,b>>31);g=k+g|0;b=mb+i|0;b=g>>>0<k>>>0?b+1|0:b;i=g;g=qma(r,n,f,f>>31);f=i+g|0;b=mb+b|0;b=f>>>0<g>>>0?b+1|0:b;f=f+8388608|0;b=f>>>0<8388608?b+1|0:b;b=(b&16777215)<<8|f>>>24;v[l>>2]=(b|0)/256;v[h>>2]=b-(j&s);g=1;b=m&1;m=0;if(b){continue}break}b=v[a+32>>2];p=v[a+28>>2]+p|0;f=p>>12;v[c>>2]=v[c>>2]+B(f,v[e+8>>2]);o=b+o|0;b=o>>12;v[c+4>>2]=v[c+4>>2]+B(b,v[e+12>>2]);Sb(e+24|0,e+16|0);d=d-1|0;if(d){c=c+8|0;j=v[e+24>>2];h=v[e+28>>2];continue}break}j=v[e+24>>2];h=v[e+28>>2];l=v[e+44>>2];k=v[e+40>>2];m=v[e+36>>2];g=v[e+32>>2];break e}b=o>>12;f=p>>12}v[a+40>>2]=o;v[a+20>>2]=f;v[a+36>>2]=p;v[a+56>>2]=l;v[a+52>>2]=k;v[a+48>>2]=m;v[a+44>>2]=g;v[a+24>>2]=b;v[a>>2]=j;v[a+4>>2]=h;jb=e+48|0}function kga(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;d=jb+-64|0;jb=d;u[d+62>>1]=c;sg(d+62|0,32);f=Sl(a);v[113382]=0;R(757,f|0,x[d+62>>1]);a=v[113382];v[113382]=0;a:{if((a|0)!=1){b:{c:{if(!x[d+62>>1]){break c}while(1){a=x[b+480190>>1]+1|0;u[d+60>>1]=a;d:{e:{if((a&65535)>>>0<4e3){break e}u[d+24>>1]=1;f:{if(!x[b+480190>>1]){break f}while(1){g:{if(Be(yp(b,x[d+24>>1]))){break g}j=d,k=rz(ac(f),bc(f),d+24|0),v[j+48>>2]=k;j=d,k=bc(f),v[j+40>>2]=k;if(!ks(d+48|0,d+40|0)){break g}u[d+60>>1]=x[d+24>>1];a=1;if(!x[b+480192>>1]){break f}while(1){c=v[(((a&65535)<<2)+b|0)+900380>>2];h:{if(!c){break h}c=c+236|0;e=bt(c);if((c|0)==(e|0)){break h}while(1){if(x[c>>1]==x[d+60>>1]){u[c>>1]=0}c=c+2|0;if((e|0)!=(c|0)){continue}break}}a=a+1|0;if(x[b+480192>>1]>=(a&65535)>>>0){continue}break}break f}a=x[d+24>>1]+1|0;u[d+24>>1]=a;if(x[b+480190>>1]>=(a&65535)>>>0){continue}break}}if(x[d+60>>1]<4e3){break e}a=jt(d+48|0);v[113382]=0;c=Q(1014,b|0,a|0)|0;e=v[113382];v[113382]=0;i:{j:{if((e|0)==1){break j}k:{if(c){v[113382]=0;Q(1015,b|0,a|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break j}e=1;if(!x[b+480192>>1]){break k}while(1){c=v[(((e&65535)<<2)+b|0)+900380>>2];l:{if(!c){break l}c=c+236|0;g=bt(c);if((c|0)==(g|0)){break l}while(1){m:{if(y[a+4>>2]<=x[c>>1]){break m}h=d+40|0;_d(h,a,x[c>>1]);if(Cb(h)){break m}u[c>>1]=0}c=c+2|0;if((g|0)!=(c|0)){continue}break}}e=e+1|0;if(x[b+480192>>1]>=(e&65535)>>>0){continue}break}break k}ee(a);break c}c=d+24|0;uj(c,a);v[113382]=0;U(1016,d+32|0,c|0,1);c=v[113382];v[113382]=0;if((c|0)!=1){c=d+16|0;xk(c,a);v[113382]=0;t[d+15|0]=0;X(1017,d+40|0,d+32|0,c|0,d+15|0);c=v[113382];v[113382]=0;if((c|0)!=1){break i}}}c=P()|0;O()|0;ee(a);break a}uj(d,a);j=d,k=Ci(d+40|0,d),u[j+60>>1]=k;ee(a);if(x[d+60>>1]>=4e3){break d}}v[113382]=0;R(419,f|0,d+60|0);a=v[113382];v[113382]=0;if((a|0)==1){break b}if(x[b+480190>>1]>=x[d+60>>1]){break d}u[b+480190>>1]=x[d+60>>1]}i=i+1|0;if(x[d+62>>1]>(i&65535)>>>0){continue}break}}jb=d- -64|0;return}c=P()|0;O()|0;break a}c=P()|0;O()|0}nf(f);S(c|0);L()}function oH(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=jb-48|0;jb=e;v[e+40>>2]=c;v[e+44>>2]=b;v[e+36>>2]=d;d=v[a+8>>2];v[e+28>>2]=e+36;v[e+24>>2]=e+40;b=v[e+28>>2];v[e+8>>2]=v[e+24>>2];v[e+12>>2]=b;v[e+16>>2]=a;v[e+20>>2]=e+44;b=v[e+20>>2];v[e>>2]=v[e+16>>2];v[e+4>>2]=b;c=e;a:{b:{switch(v[d+40>>2]){case 0:b=jb-80|0;jb=b;f=v[c>>2];h=v[f+4>>2];v[b+40>>2]=v[f+20>>2];j=v[f+16>>2];v[b+32>>2]=v[f+12>>2];v[b+36>>2]=j;Km(b- -64|0,b+32|0,h);f=ie(b+48|0,v[v[c+4>>2]>>2],v[v[c+8>>2]>>2],v[v[c+12>>2]>>2]);j=v[v[c+12>>2]>>2];l=v[v[c+8>>2]>>2];v[b+24>>2]=v[b+72>>2];c=v[b+68>>2];v[b+16>>2]=v[b+64>>2];v[b+20>>2]=c;v[b+8>>2]=v[f+8>>2];c=v[f+4>>2];v[b>>2]=v[f>>2];v[b+4>>2]=c;m=b+16|0;c=b;h=jb-16|0;jb=h;if(j){while(1){f=0;if(l){while(1){i=A[fh(c,f,k)>>3];ec(d,f);A[h+8>>3]=i;Vf(h+8|0,-1,1);i=A[h+8>>3]*32768;A[h+8>>3]=i;i=Md(i);c:{if(D(i)<2147483648){g=~~i;break c}g=-2147483648}g=Rc(g);q=Jm(m,f,k),r=g,u[q>>1]=r;f=f+1|0;if((l|0)!=(f|0)){continue}break}}k=k+1|0;if((j|0)!=(k|0)){continue}break}}jb=h+16|0;jb=b+80|0;break a;case 2:Rw(c,zb(d));break a;case 3:k=Xg(d);b=jb-80|0;jb=b;d=v[c>>2];h=v[d+4>>2];v[b+40>>2]=v[d+20>>2];j=v[d+16>>2];v[b+32>>2]=v[d+12>>2];v[b+36>>2]=j;Km(b- -64|0,b+32|0,h);d=ie(b+48|0,v[v[c+4>>2]>>2],v[v[c+8>>2]>>2],v[v[c+12>>2]>>2]);j=v[v[c+12>>2]>>2];l=v[v[c+8>>2]>>2];v[b+24>>2]=v[b+72>>2];c=v[b+68>>2];v[b+16>>2]=v[b+64>>2];v[b+20>>2]=c;v[b+8>>2]=v[d+8>>2];c=v[d+4>>2];v[b>>2]=v[d>>2];v[b+4>>2]=c;m=b+16|0;c=b;d=jb-16|0;jb=d;if(j){n=k+16|0;while(1){h=0;if(l){while(1){i=Md(A[fh(c,h,f)>>3]*134217728);g=Xe(k,h);o=g;g=sj(i)+(v[g>>2]>>1)|0;p=g;g=Kr(n)+g&-4096;v[o>>2]=p-g;A[d+8>>3]=+(g|0)*7.450580596923828e-9;Vf(d+8|0,-1,1);i=A[d+8>>3]*32768;A[d+8>>3]=i;i=Md(i);d:{if(D(i)<2147483648){g=~~i;break d}g=-2147483648}g=Rc(g);q=Jm(m,h,f),r=g,u[q>>1]=r;h=h+1|0;if((l|0)!=(h|0)){continue}break}}f=f+1|0;if((j|0)!=(f|0)){continue}break}}jb=d+16|0;jb=b+80|0;break a;case 1:Rw(c,zb(d));break a;default:break b}}Rw(c,zb(d))}v[a+4>>2]=v[a+4>>2]+v[e+36>>2];jb=e+48|0}function gea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0;e=jb-80|0;jb=e;q=v[a+16>>2];i=Uf(e+48|0);v[i+8>>2]=a+112;v[i+16>>2]=v[a+128>>2];x=i,y=Pf(b+327720|0,v[b+20>>2],(v[a+88>>2]&16384)>>>14|0),v[x+12>>2]=y;b=v[i+16>>2];if(b){x=i,y=Tf(a+8|0,b),v[x>>2]=y;v[i+4>>2]=mb}b=v[a+44>>2];v[e+32>>2]=b;g=v[a+48>>2];v[e+36>>2]=g;h=v[a+52>>2];v[e+40>>2]=h;l=v[a+56>>2];v[e+44>>2]=l;r=v[a+24>>2];s=v[a+20>>2];j=v[a+4>>2];f=v[a>>2];v[e+24>>2]=f;v[e+28>>2]=j;k=v[a+12>>2];v[e+16>>2]=v[a+8>>2];v[e+20>>2]=k;if(d){while(1){b=0;g=b;h=f;v[e+72>>2]=f;v[e+76>>2]=b;j=((((j&2147483647)<<1|f>>>31)&2147483646)<<1)+q|0;a:{b=v[i+16>>2];if((b|0)<=0){break a}while(1){f=(g&2147483647)<<1|h>>>31;yd(v[i+8>>2],(u[(f<<1|2)+j>>1]+u[j+((f&2147483646)<<1)>>1]|0)/8<<16>>16);xd(v[i+8>>2],4);Sb(e+72|0,i);if((b|0)<2){break a}b=b-1|0;h=v[e+72>>2];g=v[e+76>>2];continue}}b=v[i+8>>2];Sb(b,b+8|0);b=v[i+8>>2];f=v[b+4>>2];if(f){k=b;b=(v[e+76>>2]&2147483647)<<1|v[e+72>>2]>>>31;yd(k,(u[(b<<1|2)+j>>1]+u[j+((b&2147483646)<<1)>>1]|0)/8<<16>>16);xd(v[i+8>>2],f);b=v[i+8>>2];f=v[b>>2];v[b>>2]=f;v[b+4>>2]=0}d=d-1|0;h=Of(b,v[i+12>>2]);v[e+12>>2]=h;v[e+8>>2]=h;g=0;l=1;while(1){k=v[a+60>>2];o=k;j=(e+32|0)+(g<<3)|0;m=v[j>>2];b=Yb(m,-16777216,16776704);p=v[a+64>>2];f=Yb(v[j+4>>2],-16777216,16776704);n=v[a+68>>2];t=n;n=n>>31;v[j+4>>2]=m;m=v[a+72>>2];k=k>>31;h=h<<8;k=qma(o,k,h,h>>31);o=mb;w=(e+8|0)+(g<<2)|0;g=k;k=qma(p,p>>31,b,b>>31);g=g+k|0;b=mb+o|0;b=g>>>0<k>>>0?b+1|0:b;k=g;g=qma(t,n,f,f>>31);f=k+g|0;b=mb+b|0;b=f>>>0<g>>>0?b+1|0:b;f=f+8388608|0;b=f>>>0<8388608?b+1|0:b;b=(b&16777215)<<8|f>>>24;v[w>>2]=(b|0)/256;v[j>>2]=b-(h&m);if(l){g=1;l=0;h=v[e+12>>2];continue}break}v[c>>2]=v[c>>2]+B(v[e+8>>2],s);v[c+4>>2]=v[c+4>>2]+B(v[e+12>>2],r);Sb(e+24|0,e+16|0);if(d){c=c+8|0;f=v[e+24>>2];j=v[e+28>>2];continue}break}f=v[e+24>>2];j=v[e+28>>2];l=v[e+44>>2];h=v[e+40>>2];g=v[e+36>>2];b=v[e+32>>2]}v[a+56>>2]=l;v[a+52>>2]=h;v[a+48>>2]=g;v[a+44>>2]=b;v[a>>2]=f;v[a+4>>2]=j;jb=e+80|0}function gw(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=v[b>>2];a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{if(!d){break l}g=v[d>>2];if(!g){break l}if(!a){d=c;break j}v[d>>2]=0;d=c;break k}m:{if(!v[v[113364]>>2]){if(!a){break m}if(!c){break a}g=c;while(1){d=t[e|0];if(d){v[a>>2]=d&57343;a=a+4|0;e=e+1|0;g=g-1|0;if(g){continue}break a}break}v[a>>2]=0;v[b>>2]=0;return c-g|0}d=c;if(!a){break i}break g}return cf(e)|0}f=1;break g}f=0;break h}f=1}while(1){if(!f){f=w[e|0]>>>3|0;if((f-16|f+(g>>26))>>>0>7){break f}h=e+1|0;f=h;n:{if(!(g&33554432)){break n}if((w[h|0]&192)!=128){e=e-1|0;break d}h=e+2|0;f=h;if(!(g&524288)){break n}if((w[h|0]&192)!=128){e=e-1|0;break d}f=e+3|0}e=f;d=d-1|0;f=1;continue}while(1){g=w[e|0];o:{if(e&3|g-1>>>0>126){break o}g=v[e>>2];if((g|g-16843009)&-2139062144){break o}while(1){d=d-4|0;g=v[e+4>>2];f=e+4|0;e=f;if(!((g-16843009|g)&-2139062144)){continue}break}e=f}f=g&255;if(f-1>>>0<=126){d=d-1|0;e=e+1|0;continue}break}f=f-194|0;if(f>>>0>50){break e}e=e+1|0;g=v[(f<<2)+54992>>2];f=0;continue}}while(1){if(!f){if(!d){break a}while(1){p:{f=w[e|0];h=f-1|0;q:{r:{if(h>>>0>126){g=f;break r}if(e&3|d>>>0<5){break q}s:{while(1){g=v[e>>2];if((g|g-16843009)&-2139062144){break s}v[a>>2]=g&255;v[a+4>>2]=w[e+1|0];v[a+8>>2]=w[e+2|0];v[a+12>>2]=w[e+3|0];a=a+16|0;e=e+4|0;d=d-4|0;if(d>>>0>4){continue}break}g=w[e|0]}f=g&255;h=f-1|0}if(h>>>0>126){break p}}v[a>>2]=f;a=a+4|0;e=e+1|0;d=d-1|0;if(d){continue}break a}break}f=f-194|0;if(f>>>0>50){break e}e=e+1|0;g=v[(f<<2)+54992>>2];f=1;continue}h=w[e|0];f=h>>>3|0;if((f-16|f+(g>>26))>>>0>7){break f}t:{u:{i=e+1|0;f=h-128|g<<6;h=i;v:{if((f|0)>=0){break v}h=w[i|0]-128|0;if(h>>>0>63){break u}i=e+2|0;f=h|f<<6;h=i;if((f|0)>=0){break v}h=w[i|0]-128|0;if(h>>>0>63){break u}f=h|f<<6;h=e+3|0}e=h;v[a>>2]=f;d=d-1|0;a=a+4|0;break t}v[113305]=25;e=e-1|0;break c}f=0;continue}}e=e-1|0;if(g){break d}g=w[e|0]}if(g&255){break d}if(a){v[a>>2]=0;v[b>>2]=0}return c-d|0}v[113305]=25;if(!a){break b}}v[b>>2]=e}return-1}v[b>>2]=e;return c|0}function D4(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0;k=jb-48|0;jb=k;a:{b:{c:{j=lo(1,32);d:{e:{if(!j){a=ba(4)|0;Zk(a);v[113382]=0;U(1978,a|0,66740,1977);a=v[113382];v[113382]=0;if((a|0)!=1){break a}i=V(0)|0;O()|0;break e}v[j+12>>2]=f;v[j+8>>2]=e;v[j+4>>2]=d;v[j>>2]=c?c:1966;d=Ns(k+32|0);f:{g:{if(!i){break g}c=v[i>>2];if(!c){break g}while(1){h:{e=v[i+4>>2];if(e){v[113382]=0;c=Q(121,k+16|0,c|0)|0;f=v[113382];v[113382]=0;i:{if((f|0)!=1){v[113382]=0;f=Q(1979,d|0,c|0)|0;l=v[113382];v[113382]=0;if((l|0)==1){break i}v[113382]=0;Q(444,f|0,e|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break i}break h}i=V(0)|0;O()|0;break f}i=V(0)|0;O()|0;yb(c);break f}v[113382]=0;c=Q(121,k+16|0,c|0)|0;e=v[113382];v[113382]=0;j:{if((e|0)!=1){v[113382]=0;Q(1980,d|0,c|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break j}break h}i=V(0)|0;O()|0;break f}i=V(0)|0;O()|0;yb(c);break f}yb(c);c=v[i+8>>2];i=i+8|0;if(c){continue}break}}v[113382]=0;c=T(1361,96)|0;e=v[113382];v[113382]=0;k:{l:{m:{if((e|0)!=1){v[113382]=0;e=Q(1981,j|0,j+4|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break m}v[k+16>>2]=e;e=v[Jo(k+8|0,k+16|0)>>2];v[113382]=0;ea(2056,c|0,a|0,b|0,e|0,d|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break l}v[j+28>>2]=c;ad(k+16|0);a=v[j+28>>2];v[j+24>>2]=a?a+8|0:0;sk(d);break d}i=V(0)|0;O()|0;break f}i=V(0)|0;O()|0;break k}i=V(0)|0;O()|0;ad(k+16|0)}Wb(c)}sk(d);_(i|0)|0;v[113382]=0;X(1958,1480,j|0,g|0,h|0);a=v[113382];v[113382]=0;if((a|0)!=1){v[113382]=0;Y(20);a=v[113382];v[113382]=0;if((a|0)!=1){a=v[j+28>>2];if(a){nb[v[v[a>>2]+4>>2]](a)}v[j+24>>2]=0;v[j+28>>2]=0;a=v[j+20>>2];if(a){Wb(a);v[j+20>>2]=0}Wb(j);j=0;break d}i=V(0)|0;O()|0;break e}i=V(0)|0;O()|0;v[113382]=0;Y(20);a=v[113382];v[113382]=0;if((a|0)==1){break b}}_(i|0)|0;j=0;v[113382]=0;X(1958,1480,0,g|0,h|0);a=v[113382];v[113382]=0;if((a|0)==1){break c}$()}jb=k+48|0;return j|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)==1){break b}S(a|0);L()}V(0)|0;O()|0;Ab()}L()}function saa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,w=0,x=0,y=0;c=jb-208|0;jb=c;i=1;h=v[a+12>>2];k=1<<h;m=2;g=h;if(g>>>0>=2){f=k;while(1){l=f>>>2|0;if(f>>>0>=4){w=B(i,3);x=i<<1;y=l>>>0>1?l:1;g=0;while(1){e=c+192|0;AK(e,sc(a,g<<1));f=c+176|0;AK(f,sc(a,g));Jh(c+160|0,f,e);f=g<<m;u=i+f|0;if(f>>>0<u>>>0){while(1){d=sc(b,f);e=v[d+12>>2];v[c+152>>2]=v[d+8>>2];v[c+156>>2]=e;e=v[d+4>>2];v[c+144>>2]=v[d>>2];v[c+148>>2]=e;n=f+i|0;d=sc(b,n);e=v[d+12>>2];v[c+136>>2]=v[d+8>>2];v[c+140>>2]=e;e=v[d+4>>2];v[c+128>>2]=v[d>>2];v[c+132>>2]=e;o=f+x|0;d=sc(b,o);e=v[d+12>>2];v[c+120>>2]=v[d+8>>2];v[c+124>>2]=e;e=v[d+4>>2];v[c+112>>2]=v[d>>2];v[c+116>>2]=e;p=f+w|0;d=sc(b,p);e=v[d+12>>2];v[c+104>>2]=v[d+8>>2];v[c+108>>2]=e;e=v[d+4>>2];v[c+96>>2]=v[d>>2];v[c+100>>2]=e;q=c+80|0;d=c+144|0;e=c+128|0;ok(q,d,e);r=c- -64|0;ui(r,d,e);s=c+48|0;d=c+112|0;e=c+96|0;ok(s,d,e);j=c+16|0;ui(j,d,e);t=c+32|0;Jh(t,35168,j);ok(j,q,s);d=sc(b,f);e=v[c+28>>2];v[d+8>>2]=v[c+24>>2];v[d+12>>2]=e;e=v[c+20>>2];v[d>>2]=v[c+16>>2];v[d+4>>2]=e;ok(c,r,t);Jh(j,c+192|0,c);n=sc(b,n);d=n;e=v[c+28>>2];v[d+8>>2]=v[c+24>>2];v[d+12>>2]=e;e=v[c+20>>2];v[d>>2]=v[c+16>>2];v[d+4>>2]=e;ui(c,q,s);Jh(j,c+176|0,c);o=sc(b,o);d=o;e=v[c+28>>2];v[d+8>>2]=v[c+24>>2];v[d+12>>2]=e;e=v[c+20>>2];v[d>>2]=v[c+16>>2];v[d+4>>2]=e;ui(c,r,t);Jh(j,c+160|0,c);p=sc(b,p);d=p;e=v[c+28>>2];v[d+8>>2]=v[c+24>>2];v[d+12>>2]=e;e=v[c+20>>2];v[d>>2]=v[c+16>>2];v[d+4>>2]=e;f=f+1|0;if((u|0)!=(f|0)){continue}break}}g=g+1|0;if((y|0)!=(g|0)){continue}break}g=v[a+12>>2]}i=i<<2;f=l;m=m+2|0;if(m>>>0<=g>>>0){continue}break}}if(!(!(g&1)|!h)){e=k>>>1|0;l=e>>>0>1?e:1;f=0;while(1){k=e+f|0;h=sc(b,k);a=v[h+12>>2];v[c+200>>2]=v[h+8>>2];v[c+204>>2]=a;a=v[h+4>>2];v[c+192>>2]=v[h>>2];v[c+196>>2]=a;h=c+192|0;ui(c+176|0,sc(b,f),h);g=sc(b,k);a=v[c+188>>2];v[g+8>>2]=v[c+184>>2];v[g+12>>2]=a;a=v[c+180>>2];v[g>>2]=v[c+176>>2];v[g+4>>2]=a;Gx(sc(b,f),h);f=f+1|0;if((l|0)!=(f|0)){continue}break}}jb=c+208|0}function r3(a,b){a=a|0;b=b|0;var c=C(0),d=0,e=C(0),f=C(0),g=0,h=0,i=C(0),k=C(0),m=C(0),n=C(0),o=0;d=jb-16|0;jb=d;a:{b:{c:{d:{switch(b-1|0){case 0:c=z[a+48>>2];a=v[a+48>>2];e:{f:{g:{if(!(a>>>0>=8388608&(a|0)>=0)){f=C(C(-1)/C(c*c));if(!(a&2147483647)){break e}f=C(C(c-c)/C(0));if((a|0)<0){break e}a=(p(C(c*C(33554432))),j(2));b=-152;break g}if(a>>>0>2139095039){break f}b=-127;c=C(0);if((a|0)==1065353216){break f}}a=a+4913933|0;n=C((a>>>23|0)+b|0);c=C((l(2,(a&8388607)+1060439283|0),q())+C(-1));i=C(c*C(c*C(.5)));k=C(c/C(c+C(2)));e=C(k*k);m=C(e*e);f=c;c=(l(2,(p(C(c-i)),j(2))&-4096),q());e=C(C(C(f-c)-i)+C(k*C(i+C(C(e*C(C(m*C(.2849878668785095))+C(.6666666269302368)))+C(m*C(C(m*C(.24279078841209412))+C(.40000972151756287)))))));c=C(C(n*C(.3010292053222656))+C(C(c*C(.434326171875))+C(C(e*C(.434326171875))+C(C(n*C(7.903415166765626e-7))+C(C(e+c)*C(-3168997136526741e-20))))))}f=c}e=C(f*C(2e3));if(!(C(D(e))<C(2147483648))){break c}a=~~e;break b;case 1:a=(B(v[v[a+24>>2]+24604>>2],100)|0)/128|0;break b;case 2:b=jb-16|0;jb=b;h:{i:{j:{k:{a=w[v[a+24>>2]+24648|0];if(a>>>0>=6){d=ba(8)|0;v[113382]=0;b=Q(121,b|0,1613)|0;a=v[113382];v[113382]=0;if((a|0)==1){break k}nc(d,b);v[113382]=0;U(1978,d|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break i}a=P()|0;O()|0;yb(b);break j}jb=b+16|0;a=v[(a<<24>>24<<2)+37808>>2];break h}a=P()|0;O()|0;ca(d|0)}S(a|0)}L()}break b;case 3:v[d>>2]=0;g=jb-80|0;jb=g;a=v[a+24>>2]+24604|0;v[g+40>>2]=v[a+32>>2];v[g>>2]=v[a+36>>2];b=g+40|0;h=v[yf(b,g)>>2];o=d;l:{if(v[a+32>>2]==v[up(b)+32>>2]){b=-1;if(v[a+36>>2]==v[up(g)+36>>2]){break l}}b=0;if((h|0)<=0){break l}b=(h+500>>>0)/1e3|0}v[o>>2]=b;jb=g+80|0;a=v[d>>2];break b;default:break d}}h=ba(8)|0;v[113382]=0;b=Q(121,d|0,6473)|0;a=v[113382];v[113382]=0;m:{if((a|0)!=1){nc(h,b);v[113382]=0;U(1978,h|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break a}a=P()|0;O()|0;yb(b);break m}a=P()|0;O()|0;ca(h|0)}S(a|0);L()}a=-2147483648}jb=d+16|0;return a|0}L()}function Pea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0;f=jb-48|0;jb=f;a:{b:{c:{e=v[a+12>>2];h=v[a+8>>2];d:{if((e|0)<=1&h>>>0<=805306368|(e|0)<=0){if((e|0)>=-2&h>>>0>=3489660928|(e|0)>-2){break c}if((e|0)==-2&h>>>0>2147483647|e>>>0>4294967294){break d}break b}if((e|0)==1&h>>>0>2147483648|e>>>0>1){break b}}b=b+196648|0;break a}b=b+131112|0;break a}b=b+262184|0}r=b;s=v[a+16>>2];b=v[a+44>>2];v[f+32>>2]=b;i=v[a+48>>2];v[f+36>>2]=i;k=v[a+52>>2];v[f+40>>2]=k;l=v[a+56>>2];v[f+44>>2]=l;t=v[a+24>>2];w=v[a+20>>2];g=v[a+4>>2];j=v[a>>2];v[f+24>>2]=j;v[f+28>>2]=g;v[f+16>>2]=h;v[f+20>>2]=e;if(d){while(1){l=1;e=((((g&2147483647)<<1|j>>>31)&2147483646)<<1)+s|0;b=(j>>>16&65520)+r|0;j=u[b+14>>1];h=u[b+12>>1];n=u[b+10>>1];o=u[b+8>>1];p=u[b+6>>1];m=u[b+4>>1];q=u[b+2>>1];x=u[b>>1];k=0;b=1;i=0;while(1){g=i<<1;v[(f+8|0)+(i<<2)>>2]=(((((((B(u[e+(g|-8)>>1],q)+B(u[e+(g|-12)>>1],x)|0)+B(u[e+(g|-4)>>1],m)|0)+B(u[e+g>>1],p)|0)+B(u[e+(g|4)>>1],o)|0)+B(u[e+(g|8)>>1],n)|0)+B(u[e+(g|12)>>1],h)|0)+B(j,u[e+(g|16)>>1])|0)/32768;g=b;b=0;i=1;if(g){continue}break}while(1){i=(f+8|0)+(k<<2)|0;j=v[i>>2];h=v[a+60>>2];n=h;g=(f+32|0)+(k<<3)|0;k=v[g>>2];b=Yb(k,-16777216,16776704);o=v[a+64>>2];e=Yb(v[g+4>>2],-16777216,16776704);m=v[a+68>>2];q=m;m=m>>31;v[g+4>>2]=k;k=v[a+72>>2];p=h>>31;j=j<<8;h=j;h=qma(n,p,h,h>>31);n=mb;p=i;i=h;h=qma(o,o>>31,b,b>>31);i=i+h|0;b=mb+n|0;b=h>>>0>i>>>0?b+1|0:b;h=i;i=qma(q,m,e,e>>31);e=h+i|0;b=mb+b|0;b=e>>>0<i>>>0?b+1|0:b;e=e+8388608|0;b=e>>>0<8388608?b+1|0:b;b=(b&16777215)<<8|e>>>24;v[p>>2]=(b|0)/256;v[g>>2]=b-(j&k);k=1;b=l&1;l=0;if(b){continue}break}v[c>>2]=v[c>>2]+B(v[f+8>>2],w);v[c+4>>2]=v[c+4>>2]+B(v[f+12>>2],t);Sb(f+24|0,f+16|0);d=d-1|0;if(d){c=c+8|0;j=v[f+24>>2];g=v[f+28>>2];continue}break}j=v[f+24>>2];g=v[f+28>>2];l=v[f+44>>2];k=v[f+40>>2];i=v[f+36>>2];b=v[f+32>>2]}v[a+56>>2]=l;v[a+52>>2]=k;v[a+48>>2]=i;v[a+44>>2]=b;v[a>>2]=j;v[a+4>>2]=g;jb=f+48|0}function hea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,w=0,x=0,y=0;e=jb-80|0;jb=e;q=v[a+16>>2];i=Uf(e+48|0);v[i+8>>2]=a+112;v[i+16>>2]=v[a+128>>2];x=i,y=Pf(b+327720|0,v[b+20>>2],(v[a+88>>2]&16384)>>>14|0),v[x+12>>2]=y;b=v[i+16>>2];if(b){x=i,y=Tf(a+8|0,b),v[x>>2]=y;v[i+4>>2]=mb}b=v[a+44>>2];v[e+32>>2]=b;g=v[a+48>>2];v[e+36>>2]=g;h=v[a+52>>2];v[e+40>>2]=h;l=v[a+56>>2];v[e+44>>2]=l;r=v[a+24>>2];s=v[a+20>>2];j=v[a+4>>2];f=v[a>>2];v[e+24>>2]=f;v[e+28>>2]=j;k=v[a+12>>2];v[e+16>>2]=v[a+8>>2];v[e+20>>2]=k;if(d){while(1){b=0;g=b;h=f;v[e+72>>2]=f;v[e+76>>2]=b;j=(((j&2147483647)<<1|f>>>31)&-2)+q|0;a:{b=v[i+16>>2];if((b|0)<=0){break a}while(1){f=(g&2147483647)<<1|h>>>31;yd(v[i+8>>2],t[(f|1)+j|0]+t[j+(f&-2)|0]<<5);xd(v[i+8>>2],4);Sb(e+72|0,i);if((b|0)<2){break a}b=b-1|0;h=v[e+72>>2];g=v[e+76>>2];continue}}b=v[i+8>>2];Sb(b,b+8|0);b=v[i+8>>2];f=v[b+4>>2];if(f){k=b;b=(v[e+76>>2]&2147483647)<<1|v[e+72>>2]>>>31;yd(k,t[(b|1)+j|0]+t[j+(b&-2)|0]<<5);xd(v[i+8>>2],f);b=v[i+8>>2];f=v[b>>2];v[b>>2]=f;v[b+4>>2]=0}d=d-1|0;h=Of(b,v[i+12>>2]);v[e+12>>2]=h;v[e+8>>2]=h;g=0;l=1;while(1){k=v[a+60>>2];o=k;j=(e+32|0)+(g<<3)|0;m=v[j>>2];b=Yb(m,-16777216,16776704);p=v[a+64>>2];f=Yb(v[j+4>>2],-16777216,16776704);n=v[a+68>>2];u=n;n=n>>31;v[j+4>>2]=m;m=v[a+72>>2];k=k>>31;h=h<<8;k=qma(o,k,h,h>>31);o=mb;w=(e+8|0)+(g<<2)|0;g=k;k=qma(p,p>>31,b,b>>31);g=g+k|0;b=mb+o|0;b=g>>>0<k>>>0?b+1|0:b;k=g;g=qma(u,n,f,f>>31);f=k+g|0;b=mb+b|0;b=f>>>0<g>>>0?b+1|0:b;f=f+8388608|0;b=f>>>0<8388608?b+1|0:b;b=(b&16777215)<<8|f>>>24;v[w>>2]=(b|0)/256;v[j>>2]=b-(h&m);if(l){g=1;l=0;h=v[e+12>>2];continue}break}v[c>>2]=v[c>>2]+B(v[e+8>>2],s);v[c+4>>2]=v[c+4>>2]+B(v[e+12>>2],r);Sb(e+24|0,e+16|0);if(d){c=c+8|0;f=v[e+24>>2];j=v[e+28>>2];continue}break}f=v[e+24>>2];j=v[e+28>>2];l=v[e+44>>2];h=v[e+40>>2];g=v[e+36>>2];b=v[e+32>>2]}v[a+56>>2]=l;v[a+52>>2]=h;v[a+48>>2]=g;v[a+44>>2]=b;v[a>>2]=f;v[a+4>>2]=j;jb=e+80|0}function B8(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;a:{b:{switch(b|0){case 0:e=jb-16|0;jb=e;f=Xb(a);c:{d:{if(Db(c)){while(1){a=v[ij(c,i)>>2];e:{if(a>>>0>=2097152){v[113382]=0;R(110,f|0,63);a=v[113382];v[113382]=0;if((a|0)!=1){break e}break d}d=0;f:{g:{while(1){h=a&63;t[(e+10|0)+d|0]=h;if(a>>>0<64){break g}a=a>>>6|0;d=d+1|0;if((d|0)!=6){continue}break}b=7;d=6;break f}h:{if(!d){v[113382]=0;R(110,f|0,t[e+10|0]);break h}b=d+1|0;if((b|0)!=2){break f}d=1;b=2;if((h|0)!=1){break f}v[113382]=0;R(110,f|0,t[e+10|0]|64)}a=v[113382];v[113382]=0;if((a|0)!=1){break e}break d}d=(-1<<b^-1)<<7-d;h=b+e|0;a=b;while(1){i:{if((a|0)==(b|0)){g=w[h+9|0];v[113382]=0;R(110,f|0,(d|g)<<24>>24);g=v[113382];v[113382]=0;if((g|0)==1){break d}a=a-1|0;break i}v[113382]=0;a=a-1|0;R(110,f|0,t[a+(e+10|0)|0]|-128);g=v[113382];v[113382]=0;if((g|0)==1){break d}}if(a){continue}break}}i=i+1|0;if(Db(c)>>>0>i>>>0){continue}break}}jb=e+16|0;break c}a=P()|0;O()|0;yb(f);S(a|0);L()}return;case 1:b=0;a=Xb(a);d=Db(c);v[113382]=0;R(111,a|0,d|0);d=v[113382];v[113382]=0;j:{if((d|0)!=1){k:{if(Db(c)){while(1){d=v[ij(c,b)>>2];l:{if(d>>>0<=127){v[113382]=0;R(110,a|0,d<<24>>24);d=v[113382];v[113382]=0;if((d|0)!=1){break l}break k}v[113382]=0;R(110,a|0,63);d=v[113382];v[113382]=0;if((d|0)==1){break k}}b=b+1|0;if(Db(c)>>>0>b>>>0){continue}break}}break j}}break a}return;case 2:b=0;a=Xb(a);d=Db(c);v[113382]=0;R(111,a|0,d|0);d=v[113382];v[113382]=0;m:{if((d|0)!=1){n:{if(Db(c)){while(1){d=v[ij(c,b)>>2];o:{if(d>>>0<=255){v[113382]=0;R(110,a|0,d<<24>>24);d=v[113382];v[113382]=0;if((d|0)!=1){break o}break n}v[113382]=0;R(110,a|0,63);d=v[113382];v[113382]=0;if((d|0)==1){break n}}b=b+1|0;if(Db(c)>>>0>b>>>0){continue}break}}break m}}break a}return;case 3:Mo(a,c,17760);return;case 4:Mo(a,c,18784);return;case 5:Mo(a,c,19808);return;case 6:Mo(a,c,20832);return;case 7:Mo(a,c,21856);return;default:break b}}Xb(a);return}b=P()|0;O()|0;yb(a);S(b|0);L()}function nI(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0;k=jb-48|0;jb=k;a:{b:{c:{d:{e:{f:{j=lo(1,28);if(!j){a=ba(4)|0;Zk(a);v[113382]=0;U(1978,a|0,66740,1977);a=v[113382];v[113382]=0;if((a|0)!=1){break a}break f}v[j+12>>2]=f;v[j+8>>2]=e;v[j+4>>2]=d;v[j>>2]=c?c:1966;d=Ns(k+32|0);g:{h:{if(!i){break h}c=v[i>>2];if(!c){break h}while(1){i:{e=v[i+4>>2];if(e){v[113382]=0;c=Q(121,k+16|0,c|0)|0;f=v[113382];v[113382]=0;j:{if((f|0)!=1){v[113382]=0;f=Q(1979,d|0,c|0)|0;l=v[113382];v[113382]=0;if((l|0)==1){break j}v[113382]=0;Q(444,f|0,e|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break j}break i}i=V(0)|0;O()|0;break g}i=V(0)|0;O()|0;yb(c);break g}v[113382]=0;c=Q(121,k+16|0,c|0)|0;e=v[113382];v[113382]=0;k:{if((e|0)!=1){v[113382]=0;Q(1980,d|0,c|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break k}break i}i=V(0)|0;O()|0;break g}i=V(0)|0;O()|0;yb(c);break g}yb(c);c=v[i+8>>2];i=i+8|0;if(c){continue}break}}v[113382]=0;c=T(1361,80)|0;e=v[113382];v[113382]=0;l:{m:{n:{if((e|0)!=1){v[113382]=0;e=Q(1981,j|0,j+4|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break n}v[k+16>>2]=e;e=v[Jo(k+8|0,k+16|0)>>2];v[113382]=0;ea(1983,c|0,a|0,b|0,e|0,d|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break m}v[j+24>>2]=c;ad(k+16|0);sk(d);c=j;break d}i=V(0)|0;O()|0;break g}i=V(0)|0;O()|0;break l}i=V(0)|0;O()|0;ad(k+16|0)}Wb(c)}sk(d);_(i|0)|0;v[113382]=0;X(1958,10884,j|0,g|0,h|0);a=v[113382];v[113382]=0;if((a|0)!=1){v[113382]=0;Y(20);a=v[113382];v[113382]=0;if((a|0)==1){break f}a=v[j+24>>2];if(a){Wb(Tr(a))}c=0;v[j+24>>2]=0;a=v[j+20>>2];if(a){Wb(a);v[j+20>>2]=0}Wb(j);break d}i=V(0)|0;O()|0;v[113382]=0;Y(20);a=v[113382];v[113382]=0;if((a|0)!=1){break e}break b}i=V(0)|0;O()|0}_(i|0)|0;c=0;v[113382]=0;X(1958,10884,0,g|0,h|0);a=v[113382];v[113382]=0;if((a|0)==1){break c}$()}jb=k+48|0;return c|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)==1){break b}S(a|0);L()}V(0)|0;O()|0;Ab()}L()}function Qq(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;if(!a){return kd(b)}if(b>>>0>=4294967232){v[113305]=48;return 0}g=b>>>0<11?16:b+11&-8;f=a-8|0;j=v[f+4>>2];e=j&-8;a:{if(!(j&3)){if(g>>>0<256){break a}if(e>>>0>=g+4>>>0){c=f;if(e-g>>>0<=v[114799]<<1>>>0){break a}}c=0;break a}h=e+f|0;b:{if(e>>>0>=g>>>0){d=e-g|0;if(d>>>0<16){break b}v[f+4>>2]=j&1|g|2;c=f+g|0;v[c+4>>2]=d|3;v[h+4>>2]=v[h+4>>2]|1;Pq(c,d);break b}if(v[114685]==(h|0)){e=e+v[114682]|0;if(e>>>0<=g>>>0){break a}v[f+4>>2]=j&1|g|2;d=f+g|0;c=e-g|0;v[d+4>>2]=c|1;v[114682]=c;v[114685]=d;break b}if(v[114684]==(h|0)){d=e+v[114681]|0;if(d>>>0<g>>>0){break a}c=d-g|0;c:{if(c>>>0>=16){v[f+4>>2]=j&1|g|2;e=f+g|0;v[e+4>>2]=c|1;d=d+f|0;v[d>>2]=c;v[d+4>>2]=v[d+4>>2]&-2;break c}v[f+4>>2]=d|j&1|2;c=d+f|0;v[c+4>>2]=v[c+4>>2]|1;c=0;e=0}v[114684]=e;v[114681]=c;break b}d=v[h+4>>2];if(d&2){break a}k=e+(d&-8)|0;if(k>>>0<g>>>0){break a}m=k-g|0;d:{if(d>>>0<=255){e=v[h+8>>2];c=d>>>3|0;d=v[h+12>>2];if((d|0)==(e|0)){n=458716,o=v[114679]&uma(-2,c),v[n>>2]=o;break d}v[e+12>>2]=d;v[d+8>>2]=e;break d}l=v[h+24>>2];i=v[h+12>>2];e:{if((i|0)!=(h|0)){c=v[h+8>>2];v[c+12>>2]=i;v[i+8>>2]=c;break e}f:{e=h+20|0;c=v[e>>2];if(c){break f}e=h+16|0;c=v[e>>2];if(c){break f}i=0;break e}while(1){d=e;i=c;e=c+20|0;c=v[e>>2];if(c){continue}e=i+16|0;c=v[i+16>>2];if(c){continue}break}v[d>>2]=0}if(!l){break d}d=v[h+28>>2];c=(d<<2)+459020|0;g:{if(v[c>>2]==(h|0)){v[c>>2]=i;if(i){break g}n=458720,o=v[114680]&uma(-2,d),v[n>>2]=o;break d}v[(v[l+16>>2]==(h|0)?16:20)+l>>2]=i;if(!i){break d}}v[i+24>>2]=l;c=v[h+16>>2];if(c){v[i+16>>2]=c;v[c+24>>2]=i}c=v[h+20>>2];if(!c){break d}v[i+20>>2]=c;v[c+24>>2]=i}if(m>>>0<=15){v[f+4>>2]=j&1|k|2;c=f+k|0;v[c+4>>2]=v[c+4>>2]|1;break b}v[f+4>>2]=j&1|g|2;d=f+g|0;v[d+4>>2]=m|3;c=f+k|0;v[c+4>>2]=v[c+4>>2]|1;Pq(d,m)}c=f}if(c){return c+8|0}f=kd(b);if(!f){return 0}c=v[a-4>>2];c=(c&3?-4:-8)+(c&-8)|0;lc(f,a,b>>>0>c>>>0?c:b);Wb(a);return f}function Qea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,w=0,x=0,y=0;f=jb-48|0;jb=f;a:{b:{c:{e=v[a+12>>2];g=v[a+8>>2];d:{if((e|0)<=1&g>>>0<=805306368|(e|0)<=0){if((e|0)>=-2&g>>>0>=3489660928|(e|0)>-2){break c}if((e|0)==-2&g>>>0>2147483647|e>>>0>4294967294){break d}break b}if((e|0)==1&g>>>0>2147483648|e>>>0>1){break b}}b=b+196648|0;break a}b=b+131112|0;break a}b=b+262184|0}r=b;s=v[a+16>>2];b=v[a+44>>2];v[f+32>>2]=b;k=v[a+48>>2];v[f+36>>2]=k;j=v[a+52>>2];v[f+40>>2]=j;l=v[a+56>>2];v[f+44>>2]=l;w=v[a+24>>2];x=v[a+20>>2];h=v[a+4>>2];i=v[a>>2];v[f+24>>2]=i;v[f+28>>2]=h;v[f+16>>2]=g;v[f+20>>2]=e;if(d){while(1){e=(((h&2147483647)<<1|i>>>31)&-2)+s|0;b=(i>>>16&65520)+r|0;i=u[b+14>>1];g=u[b+12>>1];n=u[b+10>>1];o=u[b+8>>1];p=u[b+6>>1];m=u[b+4>>1];q=u[b+2>>1];y=u[b>>1];j=0;l=1;k=1;b=0;while(1){v[(f+8|0)+(b<<2)>>2]=(((((((B(t[e+(b|-4)|0],q)+B(t[e+(b|-6)|0],y)|0)+B(t[e+(b|-2)|0],m)|0)+B(t[b+e|0],p)|0)+B(t[e+(b|2)|0],o)|0)+B(t[e+(b|4)|0],n)|0)+B(t[e+(b|6)|0],g)|0)+B(i,t[e+(b|8)|0])<<8)/32768;h=k;k=0;b=1;if(h){continue}break}while(1){e=(f+8|0)+(j<<2)|0;i=v[e>>2];g=v[a+60>>2];n=g;k=(f+32|0)+(j<<3)|0;j=v[k>>2];b=Yb(j,-16777216,16776704);o=v[a+64>>2];h=Yb(v[k+4>>2],-16777216,16776704);m=v[a+68>>2];q=m;m=m>>31;v[k+4>>2]=j;j=v[a+72>>2];p=g>>31;i=i<<8;g=i;g=qma(n,p,g,g>>31);n=mb;p=e;e=g;g=qma(o,o>>31,b,b>>31);e=e+g|0;b=mb+n|0;b=e>>>0<g>>>0?b+1|0:b;g=e;e=qma(q,m,h,h>>31);h=g+e|0;b=mb+b|0;b=e>>>0>h>>>0?b+1|0:b;h=h+8388608|0;b=h>>>0<8388608?b+1|0:b;b=(b&16777215)<<8|h>>>24;v[p>>2]=(b|0)/256;v[k>>2]=b-(i&j);j=1;b=l&1;l=0;if(b){continue}break}v[c>>2]=v[c>>2]+B(v[f+8>>2],x);v[c+4>>2]=v[c+4>>2]+B(v[f+12>>2],w);Sb(f+24|0,f+16|0);d=d-1|0;if(d){c=c+8|0;i=v[f+24>>2];h=v[f+28>>2];continue}break}i=v[f+24>>2];h=v[f+28>>2];l=v[f+44>>2];j=v[f+40>>2];k=v[f+36>>2];b=v[f+32>>2]}v[a+56>>2]=l;v[a+52>>2]=j;v[a+48>>2]=k;v[a+44>>2]=b;v[a>>2]=i;v[a+4>>2]=h;jb=f+48|0}function pi(a,b,c,d,e,f){var g=0,h=0,i=0,j=C(0),k=C(0),l=0,m=0,n=C(0),o=C(0),p=0;if(!(nb[v[v[a>>2]+132>>2]](a)|0)){g=w[v[a+20>>2]+25|0]}j=z[v[a+20>>2]+144>>2];k=C(1);if(!(nb[v[v[a>>2]+132>>2]](a)|0)){k=z[v[a+20>>2]+144>>2]}j=C(C(1)-j);a:{if((nb[v[v[a>>2]+148>>2]](a)|0)<=0){break a}if(!fJ(v[a+20>>2])){break a}j=C(C(j+j)+C(-1));k=C(-j)}n=z[a+4196>>2];k=C(n*k);j=C(n*j);l=a+44|0;m=Jd(l,0);l=Jd(l,1);b:{c:{switch(g|0){case 4:if(!f){break b}while(1){g=i<<2;h=g+b|0;p=h;k=C(z[g+m>>2]+z[h>>2]);h=c+g|0;z[p>>2]=C(k-C(z[g+l>>2]+C(k+z[h>>2])))+C(z[d+g>>2]*j);z[h>>2]=C(z[e+g>>2]*j)-k;i=i+1|0;if((i|0)!=(f|0)){continue}break};break b;case 3:if(!f){break b}while(1){g=i<<2;h=g+b|0;z[h>>2]=C(C(z[g+m>>2]*j)-z[d+g>>2])+z[h>>2];h=c+g|0;z[h>>2]=C(C(z[g+l>>2]*j)-z[e+g>>2])+z[h>>2];i=i+1|0;if((i|0)!=(f|0)){continue}break};break b;case 2:if(!f){break b}while(1){g=i<<2;h=g+b|0;z[h>>2]=C(z[h>>2]+z[d+g>>2])-C(z[g+m>>2]*k);h=c+g|0;z[h>>2]=C(z[h>>2]+z[e+g>>2])-C(z[g+l>>2]*k);i=i+1|0;if((i|0)!=(f|0)){continue}break};break b;case 1:if(!f){break b}while(1){g=i<<2;h=g+b|0;z[h>>2]=C(z[h>>2]+z[g+m>>2])-C(z[d+g>>2]*j);h=c+g|0;z[h>>2]=C(z[h>>2]+z[g+l>>2])-C(z[e+g>>2]*j);i=i+1|0;if((i|0)!=(f|0)){continue}break};break b;case 0:if(!f){break b}while(1){g=i<<2;h=g+b|0;z[h>>2]=C(C(z[g+m>>2]*k)+C(z[d+g>>2]*j))+z[h>>2];h=c+g|0;z[h>>2]=C(C(z[g+l>>2]*k)+C(z[e+g>>2]*j))+z[h>>2];i=i+1|0;if((i|0)!=(f|0)){continue}break};break b;case 5:break c;default:break b}}g=fJ(v[a+20>>2]);if(!f){break b}j=g?C(j*C(.5)):j;k=g?C(k*C(.5)):k;while(1){g=i<<2;h=g+b|0;n=C(z[d+g>>2]-z[g+m>>2]);o=C(z[g+l>>2]-z[e+g>>2]);z[h>>2]=C(z[h>>2]+C(n*j))+C(o*k);g=c+g|0;z[g>>2]=C(C(o*j)+C(n*k))+z[g>>2];i=i+1|0;if((i|0)!=(f|0)){continue}break}}d:{if(!((w[v[a+20>>2]+24|0]&4)>>>2|0)){break d}if(nb[v[v[a>>2]+132>>2]](a)|!f){break d}e=0;while(1){a=e<<2;d=a+b|0;z[d>>2]=z[d>>2]+z[a+m>>2];d=a+c|0;z[d>>2]=z[d>>2]+z[a+l>>2];e=e+1|0;if((f|0)!=(e|0)){continue}break}}}function uH(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=jb-48|0;jb=f;v[f+40>>2]=c;v[f+44>>2]=b;v[f+36>>2]=d;e=v[a+8>>2];v[f+28>>2]=f+36;v[f+24>>2]=f+40;b=v[f+28>>2];v[f+8>>2]=v[f+24>>2];v[f+12>>2]=b;v[f+16>>2]=a;v[f+20>>2]=f+44;b=v[f+20>>2];v[f>>2]=v[f+16>>2];v[f+4>>2]=b;c=f;a:{b:{switch(v[e+40>>2]){case 0:b=jb-80|0;jb=b;d=v[c>>2];h=v[d+4>>2];g=v[d+24>>2];v[b+40>>2]=v[d+20>>2];v[b+44>>2]=g;g=v[d+16>>2];v[b+32>>2]=v[d+12>>2];v[b+36>>2]=g;Fh(b- -64|0,b+32|0,h);d=ie(b+48|0,v[v[c+4>>2]>>2],v[v[c+8>>2]>>2],v[v[c+12>>2]>>2]);h=v[v[c+12>>2]>>2];g=v[v[c+8>>2]>>2];c=v[b+76>>2];v[b+24>>2]=v[b+72>>2];v[b+28>>2]=c;c=v[b+68>>2];v[b+16>>2]=v[b+64>>2];v[b+20>>2]=c;v[b+8>>2]=v[d+8>>2];c=v[d+4>>2];v[b>>2]=v[d>>2];v[b+4>>2]=c;k=b+16|0;c=b;if(h){while(1){d=0;if(g){while(1){i=v[Sf(c,d,j)>>2];ec(e,d);i=i-2147481600>>>12|0;i=i>>>0>491520?i:491520;o=Lm(k,d,j),p=i>>>0<557055?i:557055,u[o>>1]=p;d=d+1|0;if((g|0)!=(d|0)){continue}break}}j=j+1|0;if((h|0)!=(j|0)){continue}break}}jb=b+80|0;break a;case 2:Ww(c,zb(e));break a;case 3:j=Xg(e);d=jb-80|0;jb=d;e=v[c>>2];g=v[e+4>>2];b=v[e+24>>2];v[d+40>>2]=v[e+20>>2];v[d+44>>2]=b;k=v[e+16>>2];b=d;v[b+32>>2]=v[e+12>>2];v[b+36>>2]=k;Fh(b- -64|0,b+32|0,g);e=ie(b+48|0,v[v[c+4>>2]>>2],v[v[c+8>>2]>>2],v[v[c+12>>2]>>2]);g=v[v[c+12>>2]>>2];k=v[v[c+8>>2]>>2];c=v[b+76>>2];v[b+24>>2]=v[b+72>>2];v[b+28>>2]=c;c=v[b+68>>2];v[b+16>>2]=v[b+64>>2];v[b+20>>2]=c;v[b+8>>2]=v[e+8>>2];c=v[e+4>>2];v[b>>2]=v[e>>2];v[b+4>>2]=c;i=b+16|0;if(g){m=j+16|0;while(1){c=0;if(k){while(1){e=v[Sf(b,c,h)>>2];l=Xe(j,c);e=e+(v[l>>2]>>1)|0;n=e;e=Kr(m)+e&-4096;v[l>>2]=n-e;e=e-2147481600>>>12|0;e=e>>>0>491520?e:491520;o=Lm(i,c,h),p=e>>>0<557055?e:557055,u[o>>1]=p;c=c+1|0;if((k|0)!=(c|0)){continue}break}}h=h+1|0;if((g|0)!=(h|0)){continue}break}}jb=d+80|0;break a;case 1:Ww(c,zb(e));break a;default:break b}}Ww(c,zb(e))}v[a+4>>2]=v[a+4>>2]+v[f+36>>2];jb=f+48|0}function x6(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=C(0),f=C(0),g=0,h=0,i=0,j=0,k=C(0),l=0,m=0,n=0,o=0,p=C(0),q=0,r=0,s=0,t=C(0),u=0,w=0,x=0,y=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=C(0),K=C(0),L=C(0),M=C(0),N=C(0),O=C(0);m=a+44|0;if(vh(m)){A=Jd(m,0);B=Jd(m,1);D=ed(m,0);E=ed(m,1);q=v[a+4296>>2];o=v[a+4300>>2];if(d){j=a+4304|0;i=q+1|0;u=i+v[a+4272>>2]&4095;l=j+(u<<4)|0;w=i+v[a+4276>>2]&4095;g=((w<<4)+j|0)+4|0;x=i+v[a+4280>>2]&4095;n=((x<<4)+j|0)+8|0;y=i+v[a+4284>>2]&4095;h=((y<<4)+j|0)+12|0;r=v[a+4288>>2]+o|0;s=v[a+4292>>2]+o|0;G=a+69840|0;H=a+78032|0;F=d;while(1){u=u-1&4095;i=(u<<4)+j|0;e=z[i>>2];r=r&1023;I=(r<<3)+G|0;p=z[I+4>>2];J=z[h>>2];K=z[n>>2];L=z[g>>2];M=z[l>>2];N=z[B>>2];O=z[A>>2];t=z[a+4232>>2];w=w-1&4095;l=(w<<4)+j|0;k=z[l+4>>2];f=C(C(t*z[I>>2])+C(k*C(.6180340051651001)));h=o<<3;g=h+G|0;z[g+4>>2]=k-C(f*C(.6180340051651001));k=e;e=C(C(p*t)-C(e*C(.6180340051651001)));z[g>>2]=k+C(e*C(.6180340051651001));z[i>>2]=f;z[l+4>>2]=e;s=s&1023;g=(s<<3)+H|0;p=z[g+4>>2];x=x-1&4095;n=(x<<4)+j|0;f=z[n+8>>2];t=z[a+4236>>2];e=C(t*z[g>>2]);y=y-1&4095;g=(y<<4)+j|0;k=z[g+12>>2];e=C(e+C(k*C(.6180340051651001)));h=h+H|0;z[h+4>>2]=k-C(e*C(.6180340051651001));k=f;f=C(C(p*t)-C(f*C(.6180340051651001)));z[h>>2]=k+C(f*C(.6180340051651001));z[n+8>>2]=e;z[g+12>>2]=f;f=C(z[i>>2]+e);e=C(O+C(1.0000000031710769e-30));z[D>>2]=f+C(z[a+4224>>2]*e);f=C(N+C(1.0000000031710769e-30));z[E>>2]=C(C(z[a+4224>>2]*f)+z[l+4>>2])+z[g+12>>2];h=(q<<4)+j|0;p=z[a+4228>>2];e=C(p*e);z[h>>2]=C(C(z[a+4240>>2]*z[i>>2])+e)+C(M*z[a+4244>>2]);f=C(p*f);z[h+4>>2]=C(C(z[a+4248>>2]*z[l+4>>2])+f)+C(L*z[a+4252>>2]);z[h+8>>2]=C(C(z[a+4256>>2]*z[n+8>>2])-f)+C(K*z[a+4260>>2]);z[h+12>>2]=C(C(z[a+4264>>2]*z[g+12>>2])+e)+C(J*z[a+4268>>2]);h=g+12|0;n=n+8|0;g=l+4|0;E=E+4|0;D=D+4|0;B=B+4|0;A=A+4|0;s=s-1|0;r=r-1|0;o=o-1&1023;q=q-1&4095;l=i;F=F-1|0;if(F){continue}break}}v[a+4300>>2]=o;v[a+4296>>2]=q;pi(a,b,c,ed(m,0),ed(m,1),d)}}function IJ(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;h=jb-16|0;jb=h;i=Oc(h+8|0,b);wt(i);if(v[a>>2]==(b|0)){v[a>>2]=v[i>>2]}d=zb(a);v[d>>2]=v[d>>2]-1;d=v[jc(a)>>2];a:{b:{e=v[b>>2];c:{if(!e){a=b;break c}if(!v[b+4>>2]){a=b;break b}a=b;g=v[a+4>>2];d:{if(!g){if(!Ag(a)){while(1){a=v[a+8>>2];if(!Ag(a)){continue}break}}a=v[a+8>>2];break d}a=FQ(g)}e=v[a>>2];if(e){break b}}e=v[a+4>>2];if(e){break b}e=0;g=1;break a}v[e+8>>2]=v[a+8>>2];g=0}e:{f:{if(Ag(a)){v[v[a+8>>2]>>2]=e;if((a|0)==(d|0)){d=e;c=0;break e}c=v[a+8>>2]+4|0;break f}v[v[a+8>>2]+4>>2]=e;c=v[a+8>>2]}c=v[c>>2]}j=!w[a+12|0];if((a|0)!=(b|0)){v[a+8>>2]=v[b+8>>2];g:{if(Ag(b)){f=v[a+8>>2];break g}f=v[a+8>>2]+4|0}v[f>>2]=a;f=v[b>>2];v[a>>2]=f;tn(f,a);f=v[b+4>>2];v[a+4>>2]=f;if(f){tn(f,a)}t[a+12|0]=w[b+12|0];d=(b|0)==(d|0)?a:d}if(!(j|!d)){h:{if(g){while(1){a=Ag(c);b=w[c+12|0];i:{j:{if(!a){if(!b){t[c+12|0]=1;t[v[c+8>>2]+12|0]=0;Ip(v[c+8>>2]);a=v[c>>2];d=(a|0)==(d|0)?c:d;c=v[a+4>>2]}b=v[c>>2];k:{l:{m:{if(!(w[b+12|0]?0:b)){a=v[c+4>>2];if(w[a+12|0]?0:a){break m}t[c+12|0]=0;n:{a=v[c+8>>2];if((a|0)!=(d|0)){if(w[a+12|0]){break n}}else{a=d}t[a+12|0]=1;break h}if(!Ag(a)){break j}a=v[a+8>>2]+4|0;break i}a=v[c+4>>2];if(!a){break l}}if(!w[a+12|0]){break k}}t[b+12|0]=1;t[c+12|0]=0;Hp(c);c=v[c+8>>2]}t[c+12|0]=w[v[c+8>>2]+12|0];t[v[c+8>>2]+12|0]=1;t[v[c+4>>2]+12|0]=1;Ip(v[c+8>>2]);break h}if(!b){t[c+12|0]=1;t[v[c+8>>2]+12|0]=0;Hp(v[c+8>>2]);a=v[c+4>>2];d=(a|0)==(d|0)?c:d;c=v[a>>2]}b=v[c>>2];o:{if(w[b+12|0]?0:b){break o}a=v[c+4>>2];if(!(w[a+12|0]?0:a)){t[c+12|0]=0;a=v[c+8>>2];if(!((a|0)!=(d|0)?w[a+12|0]:0)){t[a+12|0]=1;break h}if(Ag(a)){a=v[a+8>>2]+4|0;break i}a=v[a+8>>2];break i}if(b){if(!w[b+12|0]){break o}a=v[c+4>>2]}t[a+12|0]=1;t[c+12|0]=0;Ip(c);c=v[c+8>>2]}t[c+12|0]=w[v[c+8>>2]+12|0];t[v[c+8>>2]+12|0]=1;t[v[c>>2]+12|0]=1;Hp(v[c+8>>2]);break h}a=v[a+8>>2]}c=v[a>>2];continue}}t[e+12|0]=1}}jb=h+16|0;return v[i>>2]}function l2(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=jb-96|0;jb=e;a:{if(Sc(c)){break a}f=w[aI(c)|0];if((f|0)==33){d=1}else{if((f|0)!=63){break a}d=0}f=e+80|0;tr(f,c,0,Db(c)-1|0);Gb(c,f);yb(f)}f=e+80|0;Ad(f);g=v[e+80>>2];Ad(e+72|0);g=$H(g,v[e+76>>2],c);Ad(f);b:{c:{d:{e:{f:{if((g|0)==v[e+84>>2]){if(Pd(c,17540)){a=ba(8)|0;v[113382]=0;b=Q(121,e+80|0,6570)|0;c=v[113382];v[113382]=0;if((c|0)==1){break d}nc(a,b);v[113382]=0;U(1978,a|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break b}c=P()|0;O()|0;yb(b);break c}if(!d){break f}a=ba(8)|0;v[113382]=0;U(2105,e+80|0,13678,c|0);b=v[113382];v[113382]=0;if((b|0)!=1){nc(a,e+80|0);v[113382]=0;U(1978,a|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break b}c=P()|0;O()|0;yb(e+80|0);break c}c=P()|0;O()|0;ca(a|0);break c}f=Xb(e+80|0);g:{h:{i:{j:{switch(v[g+4>>2]){case 0:Hh(e- -64|0,c);v[113382]=0;c=v[e+68>>2];v[e+8>>2]=v[e+64>>2];v[e+12>>2]=c;b=W(2046,b|0,e+8|0,d|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){v[113382]=0;t[e+72|0]=b;R(2110,a|0,e+72|0);a=v[113382];v[113382]=0;if((a|0)!=1){break g}}break i;case 1:Hh(e+56|0,c);v[113382]=0;c=v[e+60>>2];v[e+16>>2]=v[e+56>>2];v[e+20>>2]=c;b=AD(b,e+16|0,d);c=mb;d=v[113382];v[113382]=0;if((d|0)!=1){v[113382]=0;v[e+72>>2]=b;v[e+76>>2]=c;R(2112,a|0,e+72|0);a=v[113382];v[113382]=0;if((a|0)!=1){break g}}break i;case 2:Hh(e+48|0,c);v[113382]=0;c=v[e+52>>2];v[e+24>>2]=v[e+48>>2];v[e+28>>2]=c;h=+oa(2048,b|0,e+24|0,d|0);b=v[113382];v[113382]=0;if((b|0)!=1){v[113382]=0;A[e+72>>3]=h;R(2113,a|0,e+72|0);a=v[113382];v[113382]=0;if((a|0)!=1){break g}}break i;case 3:break j;default:break h}}Hh(e+40|0,c);v[113382]=0;c=v[e+44>>2];v[e+32>>2]=v[e+40>>2];v[e+36>>2]=c;X(2049,a|0,b|0,e+32|0,d|0);a=v[113382];v[113382]=0;if((a|0)!=1){break g}}c=P()|0;O()|0;yb(f);break c}rd(a,f)}yb(f);break e}Xb(a)}jb=e+96|0;return}c=P()|0;O()|0;ca(a|0)}S(c|0)}L()}function tea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0;g=jb-48|0;jb=g;x=v[a+16>>2];j=v[a+44>>2];v[g+32>>2]=j;m=v[a+48>>2];v[g+36>>2]=m;i=v[a+52>>2];v[g+40>>2]=i;h=v[a+56>>2];v[g+44>>2]=h;p=v[a+40>>2];q=v[a+36>>2];e=v[a+4>>2];k=v[a>>2];v[g+24>>2]=k;v[g+28>>2]=e;f=v[a+12>>2];v[g+16>>2]=v[a+8>>2];v[g+20>>2]=f;a:{if(d){while(1){m=1;e=((((e&2147483647)<<1|k>>>31)&2147483646)<<1)+x|0;f=(((k>>>16|0)+4&131064)<<1)+b|0;k=u[f+38>>1];h=u[f+36>>1];l=u[f+34>>1];n=u[f+32>>1];r=u[f+30>>1];s=u[f+28>>1];o=u[f+26>>1];t=u[f+24>>1];j=0;i=1;f=0;while(1){w=(g+8|0)+(f<<2)|0;f=f<<1;v[w>>2]=(((((B(u[e+(f|8)>>1],l)+B(u[e+(f|4)>>1],n)|0)+B(h,u[e+(f|12)>>1])|0)+B(k,u[e+(f|16)>>1])|0)/2|0)+((((B(u[e+(f|-8)>>1],o)+B(u[e+(f|-12)>>1],t)|0)+B(u[e+(f|-4)>>1],s)|0)+B(u[e+f>>1],r)|0)/2|0)|0)/16384;w=i&1;i=0;f=1;if(w){continue}break}while(1){i=(g+8|0)+(j<<2)|0;k=v[i>>2];h=v[a+60>>2];l=h;f=(g+32|0)+(j<<3)|0;n=v[f>>2];e=Yb(n,-16777216,16776704);r=v[a+64>>2];j=Yb(v[f+4>>2],-16777216,16776704);o=v[a+68>>2];t=o;o=o>>31;v[f+4>>2]=n;n=v[a+72>>2];s=h>>31;k=k<<8;h=k;h=qma(l,s,h,h>>31);l=mb;s=i;i=h;h=qma(r,r>>31,e,e>>31);i=i+h|0;e=mb+l|0;e=i>>>0<h>>>0?e+1|0:e;h=i;i=qma(t,o,j,j>>31);j=h+i|0;e=mb+e|0;e=j>>>0<i>>>0?e+1|0:e;j=j+8388608|0;e=j>>>0<8388608?e+1|0:e;e=(e&16777215)<<8|j>>>24;v[s>>2]=(e|0)/256;v[f>>2]=e-(k&n);j=1;e=m&1;m=0;if(e){continue}break}e=v[a+32>>2];q=v[a+28>>2]+q|0;f=q>>12;v[c>>2]=v[c>>2]+B(f,v[g+8>>2]);p=e+p|0;l=p>>12;v[c+4>>2]=v[c+4>>2]+B(l,v[g+12>>2]);Sb(g+24|0,g+16|0);d=d-1|0;if(d){c=c+8|0;k=v[g+24>>2];e=v[g+28>>2];continue}break}k=v[g+24>>2];e=v[g+28>>2];h=v[g+44>>2];i=v[g+40>>2];m=v[g+36>>2];j=v[g+32>>2];break a}l=p>>12;f=q>>12}v[a+40>>2]=p;v[a+20>>2]=f;v[a+36>>2]=q;v[a+56>>2]=h;v[a+52>>2]=i;v[a+48>>2]=m;v[a+44>>2]=j;v[a+24>>2]=l;v[a>>2]=k;v[a+4>>2]=e;jb=g+48|0}function taa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;c=jb-208|0;jb=c;g=1;d=v[a+12>>2];i=1<<d;if(d&1){j=i>>>1|0;e=j>>>0>1?j:1;d=0;while(1){k=d+j|0;g=sc(b,k);m=v[g+12>>2];v[c+200>>2]=v[g+8>>2];v[c+204>>2]=m;m=v[g+4>>2];v[c+192>>2]=v[g>>2];v[c+196>>2]=m;m=c+192|0;ui(c+176|0,sc(b,d),m);g=sc(b,k);h=v[c+188>>2];v[g+8>>2]=v[c+184>>2];v[g+12>>2]=h;k=v[c+180>>2];v[g>>2]=v[c+176>>2];v[g+4>>2]=k;Gx(sc(b,d),m);d=d+1|0;if((e|0)!=(d|0)){continue}break}d=v[a+12>>2];g=2;i=i>>>3|0}else{i=i>>>2|0}k=d&-2;if(k){while(1){if(g){t=B(i,3);u=i<<1;j=0;while(1){d=sc(a,j<<1);e=v[d+12>>2];v[c+200>>2]=v[d+8>>2];v[c+204>>2]=e;e=v[d+4>>2];v[c+192>>2]=v[d>>2];v[c+196>>2]=e;d=sc(a,j);e=v[d+12>>2];v[c+184>>2]=v[d+8>>2];v[c+188>>2]=e;e=v[d+4>>2];v[c+176>>2]=v[d>>2];v[c+180>>2]=e;Jh(c+160|0,c+176|0,c+192|0);d=j<<k;m=i+d|0;if(d>>>0<m>>>0){while(1){e=sc(b,d);h=v[e+12>>2];v[c+152>>2]=v[e+8>>2];v[c+156>>2]=h;h=v[e+4>>2];v[c+144>>2]=v[e>>2];v[c+148>>2]=h;h=c+128|0;q=d+i|0;Jh(h,c+192|0,sc(b,q));e=c+112|0;r=d+u|0;Jh(e,c+176|0,sc(b,r));f=c+96|0;s=d+t|0;Jh(f,c+160|0,sc(b,s));n=c+80|0;l=c+144|0;ok(n,l,e);o=c- -64|0;ui(o,l,e);l=c+48|0;ok(l,h,f);e=c+16|0;fn(e,-A[4396],-A[4397]);ui(c,h,f);h=c+32|0;Jh(h,e,c);ok(e,n,l);f=sc(b,d);p=v[c+28>>2];v[f+8>>2]=v[c+24>>2];v[f+12>>2]=p;p=v[c+20>>2];v[f>>2]=v[c+16>>2];v[f+4>>2]=p;ui(e,n,l);f=sc(b,q);l=v[c+28>>2];v[f+8>>2]=v[c+24>>2];v[f+12>>2]=l;n=v[c+20>>2];v[f>>2]=v[c+16>>2];v[f+4>>2]=n;ok(e,o,h);f=sc(b,r);l=v[c+28>>2];v[f+8>>2]=v[c+24>>2];v[f+12>>2]=l;n=v[c+20>>2];v[f>>2]=v[c+16>>2];v[f+4>>2]=n;ui(e,o,h);e=sc(b,s);f=v[c+28>>2];v[e+8>>2]=v[c+24>>2];v[e+12>>2]=f;h=v[c+20>>2];v[e>>2]=v[c+16>>2];v[e+4>>2]=h;d=d+1|0;if((m|0)!=(d|0)){continue}break}}j=j+1|0;if((j|0)!=(g|0)){continue}break}}i=i>>>2|0;g=g<<2;k=k-2|0;if(k){continue}break}}jb=c+208|0}function nia(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;f=jb-16|0;jb=f;t[a|0]=0;d=w[b|0];if(d){t[a|0]=d>>>0>96?-1:d+12|0}t[a+1|0]=w[b+1|0];d=a;c=w[b+2|0];e=c-16|0;a:{b:{if((e&255)>>>0<=128){t[a+2|0]=1;c=(e&254)>>>1|0;break b}c:{switch((c+96&240)>>>4|0){case 0:t[a+2|0]=4;c=c&15;break b;case 1:t[a+2|0]=3;c=c&15;break b;case 2:t[a+2|0]=6;c=c&15;break b;case 3:break c;default:break a}}t[a+2|0]=5;c=c&15}t[d+4|0]=c}e=w[b+4|0];c=w[b+5|0];d=w[b+6|0];d:{if(!(d?1:e|c)){break d}e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{p:{q:{r:{if(e>>>0<=28){switch(e|0){case 16:break j;case 15:break k;case 12:break l;case 8:break m;case 4:break n;case 3:break o;case 2:break p;case 1:break q;case 0:break r;default:break d}}s:{switch(e-29|0){case 7:break f;case 5:break g;case 3:break h;case 0:break i;case 1:case 2:case 4:case 6:break d;default:break s}}if((e|0)==128){break e}if((e|0)!=157){break d}t[a+2|0]=15;t[a+3|0]=20;t[a+4|0]=d>>>3;t[f+15|0]=15;h=a,i=w[pc(b+5|0,f+15|0)|0]|208,t[h+5|0]=i;break d}t[a+5|0]=c;t[a+3|0]=d;vj(a);g=w[b+6|0]==15;break d}t[a+3|0]=2;h=a,i=Hk(d<<4|(c&240)>>>4),t[h+5|0]=i;break d}t[a+3|0]=3;h=a,i=Hk(d<<4|(c&240)>>>4),t[h+5|0]=i;break d}t[a+3|0]=4;h=a,i=Hk(d<<4|(c&240)>>>4),t[h+5|0]=i;break d}t[a+3|0]=5;t[a+5|0]=d&240|(c&240)>>>4;break d}if(c){t[a+5|0]=c;t[a+3|0]=9;break d}if((d-1&255)>>>0>1){break d}t[a+5|0]=145;t[a+3|0]=20;break d}t[a+3|0]=13;t[a+5|0]=d>>>1;break d}if(d){t[a+5|0]=d;t[a+3|0]=17;break d}t[a+3|0]=16;t[a+5|0]=c&15;break d}t[a+5|0]=c;t[a+3|0]=d;dz(a,1);g=(w[a+3|0]&254)==16;break d}t[a+5|0]=c;t[a+3|0]=18;break d}t[a+3|0]=31;t[a+5|0]=d>>>1;break d}t[a+3|0]=31;t[a+5|0]=d>>>1&120;break d}t[a+5|0]=159;t[a+3|0]=20;break d}t[a+3|0]=21;t[a+5|0]=d>>>2}b=w[b+3|0];t:{if(!b){break t}if(!w[a+3|0]){t[a+5|0]=b;t[a+3|0]=9;break t}if(w[a+2|0]){break t}t[a+2|0]=2;t[a+4|0]=b>>>2}jb=f+16|0;return g|0}function qH(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=jb-48|0;jb=e;v[e+40>>2]=c;v[e+44>>2]=b;v[e+36>>2]=d;d=v[a+8>>2];v[e+28>>2]=e+36;v[e+24>>2]=e+40;b=v[e+28>>2];v[e+8>>2]=v[e+24>>2];v[e+12>>2]=b;v[e+16>>2]=a;v[e+20>>2]=e+44;b=v[e+20>>2];v[e>>2]=v[e+16>>2];v[e+4>>2]=b;c=e;a:{b:{switch(v[d+40>>2]){case 0:b=jb-80|0;jb=b;f=v[c>>2];h=v[f+4>>2];v[b+40>>2]=v[f+20>>2];i=v[f+16>>2];v[b+32>>2]=v[f+12>>2];v[b+36>>2]=i;Km(b- -64|0,b+32|0,h);f=ie(b+48|0,v[v[c+4>>2]>>2],v[v[c+8>>2]>>2],v[v[c+12>>2]>>2]);h=v[v[c+12>>2]>>2];i=v[v[c+8>>2]>>2];v[b+24>>2]=v[b+72>>2];c=v[b+68>>2];v[b+16>>2]=v[b+64>>2];v[b+20>>2]=c;v[b+8>>2]=v[f+8>>2];c=v[f+4>>2];v[b>>2]=v[f>>2];v[b+4>>2]=c;g=b+16|0;c=b;if(h){while(1){f=0;if(i){while(1){j=v[Sf(c,f,k)>>2];ec(d,f);j=j-2147481600>>>12|0;j=j>>>0>491520?j:491520;o=Jm(g,f,k),p=j>>>0<557055?j:557055,u[o>>1]=p;f=f+1|0;if((i|0)!=(f|0)){continue}break}}k=k+1|0;if((h|0)!=(k|0)){continue}break}}jb=b+80|0;break a;case 2:Sw(c,zb(d));break a;case 3:k=Xg(d);b=jb-80|0;jb=b;d=v[c>>2];h=v[d+4>>2];v[b+40>>2]=v[d+20>>2];i=v[d+16>>2];v[b+32>>2]=v[d+12>>2];v[b+36>>2]=i;Km(b- -64|0,b+32|0,h);d=ie(b+48|0,v[v[c+4>>2]>>2],v[v[c+8>>2]>>2],v[v[c+12>>2]>>2]);h=v[v[c+12>>2]>>2];i=v[v[c+8>>2]>>2];v[b+24>>2]=v[b+72>>2];c=v[b+68>>2];v[b+16>>2]=v[b+64>>2];v[b+20>>2]=c;v[b+8>>2]=v[d+8>>2];c=v[d+4>>2];v[b>>2]=v[d>>2];v[b+4>>2]=c;j=b+16|0;c=b;if(h){m=k+16|0;while(1){d=0;if(i){while(1){g=v[Sf(c,d,f)>>2];l=Xe(k,d);g=g+(v[l>>2]>>1)|0;n=g;g=Kr(m)+g&-4096;v[l>>2]=n-g;g=g-2147481600>>>12|0;g=g>>>0>491520?g:491520;o=Jm(j,d,f),p=g>>>0<557055?g:557055,u[o>>1]=p;d=d+1|0;if((i|0)!=(d|0)){continue}break}}f=f+1|0;if((h|0)!=(f|0)){continue}break}}jb=b+80|0;break a;case 1:Sw(c,zb(d));break a;default:break b}}Sw(c,zb(d))}v[a+4>>2]=v[a+4>>2]+v[e+36>>2];jb=e+48|0}function uea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,w=0,x=0,y=0;g=jb-48|0;jb=g;x=v[a+16>>2];j=v[a+44>>2];v[g+32>>2]=j;m=v[a+48>>2];v[g+36>>2]=m;i=v[a+52>>2];v[g+40>>2]=i;h=v[a+56>>2];v[g+44>>2]=h;p=v[a+40>>2];q=v[a+36>>2];e=v[a+4>>2];k=v[a>>2];v[g+24>>2]=k;v[g+28>>2]=e;f=v[a+12>>2];v[g+16>>2]=v[a+8>>2];v[g+20>>2]=f;a:{if(d){while(1){e=(((e&2147483647)<<1|k>>>31)&-2)+x|0;m=1;f=(((k>>>16|0)+4&131064)<<1)+b|0;k=u[f+38>>1];h=u[f+36>>1];l=u[f+34>>1];n=u[f+32>>1];r=u[f+30>>1];s=u[f+28>>1];o=u[f+26>>1];w=u[f+24>>1];j=0;i=1;f=0;while(1){v[(g+8|0)+(f<<2)>>2]=(((((B(t[e+(f|4)|0],l)+B(t[e+(f|2)|0],n)|0)+B(h,t[e+(f|6)|0])|0)+B(k,t[e+(f|8)|0])<<8)/2|0)+((((B(t[e+(f|-4)|0],o)+B(t[e+(f|-6)|0],w)|0)+B(t[e+(f|-2)|0],s)|0)+B(t[e+f|0],r)<<8)/2|0)|0)/16384;y=i&1;i=0;f=1;if(y){continue}break}while(1){i=(g+8|0)+(j<<2)|0;k=v[i>>2];h=v[a+60>>2];l=h;f=(g+32|0)+(j<<3)|0;n=v[f>>2];e=Yb(n,-16777216,16776704);r=v[a+64>>2];j=Yb(v[f+4>>2],-16777216,16776704);o=v[a+68>>2];w=o;o=o>>31;v[f+4>>2]=n;n=v[a+72>>2];s=h>>31;k=k<<8;h=k;h=qma(l,s,h,h>>31);l=mb;s=i;i=h;h=qma(r,r>>31,e,e>>31);i=i+h|0;e=mb+l|0;e=i>>>0<h>>>0?e+1|0:e;h=i;i=qma(w,o,j,j>>31);j=h+i|0;e=mb+e|0;e=j>>>0<i>>>0?e+1|0:e;j=j+8388608|0;e=j>>>0<8388608?e+1|0:e;e=(e&16777215)<<8|j>>>24;v[s>>2]=(e|0)/256;v[f>>2]=e-(k&n);j=1;e=m&1;m=0;if(e){continue}break}e=v[a+32>>2];q=v[a+28>>2]+q|0;l=q>>12;v[c>>2]=v[c>>2]+B(l,v[g+8>>2]);p=e+p|0;f=p>>12;v[c+4>>2]=v[c+4>>2]+B(f,v[g+12>>2]);Sb(g+24|0,g+16|0);d=d-1|0;if(d){c=c+8|0;k=v[g+24>>2];e=v[g+28>>2];continue}break}k=v[g+24>>2];e=v[g+28>>2];h=v[g+44>>2];i=v[g+40>>2];m=v[g+36>>2];j=v[g+32>>2];break a}f=p>>12;l=q>>12}v[a+40>>2]=p;v[a+20>>2]=l;v[a+36>>2]=q;v[a+56>>2]=h;v[a+52>>2]=i;v[a+48>>2]=m;v[a+44>>2]=j;v[a+24>>2]=f;v[a>>2]=k;v[a+4>>2]=e;jb=g+48|0}function d$(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;i=jb-432|0;jb=i;v[i+424>>2]=37;v[i+428>>2]=0;m=or(i+424|1,9820,v[c+4>>2]);v[i+380>>2]=i+384;a=ge();a:{if(m){k=v[c+8>>2];j=i- -64|0;v[j>>2]=g;v[j+4>>2]=h;v[i+56>>2]=e;v[i+60>>2]=f;v[i+48>>2]=k;a=df(i+384|0,30,a,i+424|0,i+48|0);break a}v[i+80>>2]=e;v[i+84>>2]=f;v[i+88>>2]=g;v[i+92>>2]=h;a=df(i+384|0,30,a,i+424|0,i+80|0)}v[i+128>>2]=2310;k=Ld(i+368|0,0,i+128|0);l=i+384|0;j=l;b:{c:{d:{if((a|0)>=30){e:{if(m){v[113382]=0;a=da(2335)|0;j=v[113382];v[113382]=0;if((j|0)==1){break c}j=v[c+8>>2];v[i+16>>2]=g;v[i+20>>2]=h;v[i>>2]=j;v[113382]=0;v[i+8>>2]=e;v[i+12>>2]=f;a=aa(2358,i+380|0,a|0,i+424|0,i|0)|0;e=v[113382];v[113382]=0;if((e|0)!=1){break e}break c}v[113382]=0;a=da(2335)|0;j=v[113382];v[113382]=0;if((j|0)==1){break c}v[i+32>>2]=e;v[i+36>>2]=f;v[113382]=0;v[i+40>>2]=g;v[i+44>>2]=h;a=aa(2358,i+380|0,a|0,i+424|0,i+32|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break c}}if((a|0)==-1){v[113382]=0;Y(2311);a=v[113382];v[113382]=0;if((a|0)==1){break c}break d}ve(k,v[i+380>>2]);j=v[i+380>>2]}f=a+j|0;g=ug(j,f,c);v[i+116>>2]=2310;e=Ld(i+120|0,0,i+116|0);f:{g:{if(v[i+380>>2]==(i+384|0)){a=i+128|0;break g}a=kd(a<<3);if(!a){v[113382]=0;Y(2311);a=v[113382];v[113382]=0;if((a|0)!=1){break d}c=P()|0;O()|0;break f}ve(e,a);l=v[i+380>>2]}v[113382]=0;Ac(i+104|0,c);h=v[113382];v[113382]=0;h:{i:{if((h|0)!=1){v[113382]=0;ja(2369,l|0,g|0,f|0,a|0,i+116|0,i+112|0,i+104|0);f=v[113382];v[113382]=0;if((f|0)==1){break i}Ob(i+104|0);v[113382]=0;a=ka(2370,b|0,a|0,v[i+116>>2],v[i+112>>2],c|0,d|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break h}Gc(e);Gc(k);jb=i+432|0;return a|0}c=P()|0;O()|0;break f}c=P()|0;O()|0;Ob(i+104|0);break f}c=P()|0;O()|0}Gc(e);break b}L()}c=P()|0;O()|0}Gc(k);S(c|0);L()}function n$(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;i=jb-256|0;jb=i;v[i+248>>2]=37;v[i+252>>2]=0;m=or(i+248|1,9820,v[c+4>>2]);v[i+204>>2]=i+208;a=ge();a:{if(m){k=v[c+8>>2];j=i- -64|0;v[j>>2]=g;v[j+4>>2]=h;v[i+56>>2]=e;v[i+60>>2]=f;v[i+48>>2]=k;a=df(i+208|0,30,a,i+248|0,i+48|0);break a}v[i+80>>2]=e;v[i+84>>2]=f;v[i+88>>2]=g;v[i+92>>2]=h;a=df(i+208|0,30,a,i+248|0,i+80|0)}v[i+128>>2]=2310;k=Ld(i+192|0,0,i+128|0);l=i+208|0;j=l;b:{c:{d:{if((a|0)>=30){e:{if(m){v[113382]=0;a=da(2335)|0;j=v[113382];v[113382]=0;if((j|0)==1){break c}j=v[c+8>>2];v[i+16>>2]=g;v[i+20>>2]=h;v[i>>2]=j;v[113382]=0;v[i+8>>2]=e;v[i+12>>2]=f;a=aa(2358,i+204|0,a|0,i+248|0,i|0)|0;e=v[113382];v[113382]=0;if((e|0)!=1){break e}break c}v[113382]=0;a=da(2335)|0;j=v[113382];v[113382]=0;if((j|0)==1){break c}v[i+32>>2]=e;v[i+36>>2]=f;v[113382]=0;v[i+40>>2]=g;v[i+44>>2]=h;a=aa(2358,i+204|0,a|0,i+248|0,i+32|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break c}}if((a|0)==-1){v[113382]=0;Y(2311);a=v[113382];v[113382]=0;if((a|0)==1){break c}break d}ve(k,v[i+204>>2]);j=v[i+204>>2]}f=a+j|0;g=ug(j,f,c);v[i+116>>2]=2310;e=Ld(i+120|0,0,i+116|0);f:{g:{if(v[i+204>>2]==(i+208|0)){a=i+128|0;break g}a=kd(a<<1);if(!a){v[113382]=0;Y(2311);a=v[113382];v[113382]=0;if((a|0)!=1){break d}c=P()|0;O()|0;break f}ve(e,a);l=v[i+204>>2]}v[113382]=0;Ac(i+104|0,c);h=v[113382];v[113382]=0;h:{i:{if((h|0)!=1){v[113382]=0;ja(2359,l|0,g|0,f|0,a|0,i+116|0,i+112|0,i+104|0);f=v[113382];v[113382]=0;if((f|0)==1){break i}Ob(i+104|0);v[113382]=0;a=ka(17,b|0,a|0,v[i+116>>2],v[i+112>>2],c|0,d|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break h}Gc(e);Gc(k);jb=i+256|0;return a|0}c=P()|0;O()|0;break f}c=P()|0;O()|0;Ob(i+104|0);break f}c=P()|0;O()|0}Gc(e);break b}L()}c=P()|0;O()|0}Gc(k);S(c|0);L()}function L7(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=C(0),f=C(0),g=0,h=C(0),i=0,j=0,k=0,l=C(0),m=C(0),n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,w=0,x=C(0),y=0,A=C(0),B=0,E=0,F=0,G=0,H=C(0);a:{if(!v[a+4276>>2]){break a}i=a+44|0;if(!vh(i)){break a}p=Jd(i,0);q=Jd(i,1);r=ed(i,0);s=ed(i,1);y=nb[v[v[a>>2]+188>>2]](a)|0;e=C(nb[v[v[a>>2]+196>>2]](a));x=C(nb[v[v[a>>2]+184>>2]](a));t=nb[v[v[a>>2]+208>>2]](a)|0;if(d){j=a+4260|0;A=C(e*C(.009999999776482582));B=t&1;k=v[a+4256>>2];n=v[a+4272>>2];E=t>>>0>1;u=d;while(1){h=z[p>>2];l=z[q>>2];g=Rm(a,k+n|0);k=Rm(a,n);e=z[Pb(j,g)>>2];G=Pb(j,k),H=C(C(A*e)+C(C(l+h)*C(.5))),z[G>>2]=H;b:{if(y){f=z[a+4244>>2];e=C(z[a+4236>>2]+f);z[a+4236>>2]=e;f=C(f+z[a+4240>>2]);z[a+4240>>2]=f;if(!(e<=C(1))){e=C(e+C(-2));z[a+4236>>2]=e}if(!(f<=C(1))){z[a+4240>>2]=f+C(-2)}e=C(D(e));e=C(C(e+e)+C(-1));f=C(D(z[a+4240>>2]));f=C(C(f+f)+C(-1));break b}f=z[a+4244>>2];m=z[a+4240>>2];e=C(C(f*m)+z[a+4236>>2]);z[a+4236>>2]=e;f=C(m-C(e*f));z[a+4240>>2]=f}m=z[Pb(j,Rm(a,v[a+4280>>2]+v[a+4272>>2]|0))>>2];G=r,H=C(C(C(C(m-h)+C(C(C(z[Pb(j,Rm(a,v[a+4284>>2]+v[a+4272>>2]|0))>>2]-m)*C(.000244140625))*C(v[a+4280>>2]&4095)))*x)+h),z[G>>2]=H;h=z[Pb(j,Rm(a,v[a+4288>>2]+v[a+4272>>2]|0))>>2];G=s,H=C(C(C(C(h-l)+C(C(C(z[Pb(j,Rm(a,v[a+4292>>2]+v[a+4272>>2]|0))>>2]-h)*C(.000244140625))*C(v[a+4288>>2]&4095)))*x)+l),z[G>>2]=H;g=v[a+4272>>2];n=(((g|0)>0?0:v[a+4276>>2]<<12)+g|0)-4096|0;v[a+4272>>2]=n;w=a;k=v[a+4256>>2];o=k;h=z[a+4248>>2];l=C(h*(B?f:e));c:{if(C(D(l))<C(2147483648)){g=~~l;break c}g=-2147483648}o=o+(E?g:0-g|0)|0;v[w+4288>>2]=o;F=t>>>0<4;q=q+4|0;p=p+4|0;w=a;e=C(h*e);d:{if(C(D(e))<C(2147483648)){g=~~e;break d}g=-2147483648}g=(F?g:0-g|0)+k|0;v[w+4280>>2]=g;v[a+4292>>2]=o+4096;v[a+4284>>2]=g+4096;s=s+4|0;r=r+4|0;u=u-1|0;if(u){continue}break}}pi(a,b,c,ed(i,0),ed(i,1),d)}}function Wda(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;f=jb-32|0;jb=f;d=b&5;a:{if(!(c&5)){if(!d){break a}j=a,k=_s(t[a+36|0],t[a+37|0]),v[j+24>>2]=k;u[a+36>>1]=0;if((b|0)!=1){break a}e=qma(v[a+24>>2],0,8272,0)+4181|0;d=mb;j=a,k=dd(tma(e,e>>>0<4181?d+1|0:d,8363,0),mb),v[j+24>>2]=k;break a}if(d){break a}if((c|0)==1){e=qma(v[a+24>>2],0,8363,0)+4136|0;d=mb;j=a,k=dd(tma(e,e>>>0<4136?d+1|0:d,8272,0),mb),v[j+24>>2]=k}e=jb-16|0;jb=e;g=e+8|0;h=g;d=jb-16|0;jb=d;i=v[a+24>>2];b:{if(!i){t[h|0]=0;t[h+1|0]=0;break b}kG(d+8|0,Yb(jn(Bo(+(i>>>0)*.00011957431543704412)*2215.9795828054475),-16384,16383),128);t[d+7|0]=v[d+8>>2];t[d+6|0]=v[d+12>>2];Oy(h,d+7|0,d+6|0)}jb=d+16|0;Oc(e,a+36|0);d=e+4|0;Oc(d,a+37|0);LN(e,g);LN(d,g+1|0);jb=e+16|0}if(c&3){u[a+38>>1]=0;u[a+40>>1]=0;t[a+36|0]=0;u[a+34>>1]=x[a+34>>1]&65499}if(c&7){u[a+32>>1]=64;d=x[a+34>>1];if(d&8){e=v[a+16>>2];v[a+4>>2]=v[a+12>>2];v[a+8>>2]=e;d=d&16?d|6:d&65529|2}v[a+12>>2]=0;v[a+16>>2]=0;u[a+34>>1]=d&65511}c:{d:{e:{if(c&4){d=x[a+34>>1];if(!(d&32)){u[a+28>>1]=128;u[a+34>>1]=d|32}We(a+40|0,15);We(a+41|0,63);if(c&16777248?b&4:0){break e}if(!(b&16777248)){break c}if(w[a+41|0]){break d}break c}if(!(b&4)|!(c&16777248)){break c}if(w[a+41|0]){break d}break c}if(!w[a+41|0]){break c}}e=w[a+40|0];if(!e){break c}b=a;d=w[a+39|0];if(d){g=Qk(dd(((e<<8|d>>>1)>>>0)/(d>>>0)|0,0))}else{g=255}t[b+39|0]=g}f:{g:{if((c|0)!=4){if((c|0)==16777216){break f}if((c|0)!=32|w[a+38|0]!=2){break g}t[a+38|0]=3;break g}if(w[a+38|0]!=4){break g}t[a+38|0]=0}u[a+34>>1]=x[a+34>>1]&49151}h:{if(!(!(w[a+35|0]&2)|c&16777218)){v[f+24>>2]=0;v[f+8>>2]=0;v[f+16>>2]=0;v[f+20>>2]=0;v[f>>2]=0;v[f+4>>2]=0;rp(a,0,f);break h}if(!(w[a+35|0]&2)|(c|0)!=2){break h}a=a+68|0;b=ec(a,8);t[b|0]=w[b|0]&3;a=ec(a,9);t[a|0]=w[a|0]&3}jb=f+32|0}function rH(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=C(0);f=jb-48|0;jb=f;v[f+40>>2]=c;v[f+44>>2]=b;v[f+36>>2]=d;h=v[a+8>>2];v[f+28>>2]=f+36;v[f+24>>2]=f+40;b=v[f+28>>2];v[f+8>>2]=v[f+24>>2];v[f+12>>2]=b;v[f+16>>2]=a;v[f+20>>2]=f+44;b=v[f+20>>2];v[f>>2]=v[f+16>>2];v[f+4>>2]=b;c=f;a:{b:{switch(v[h+40>>2]){case 0:d=jb-80|0;jb=d;e=v[c>>2];g=v[e+4>>2];b=v[e+24>>2];v[d+40>>2]=v[e+20>>2];v[d+44>>2]=b;j=v[e+16>>2];b=d;v[b+32>>2]=v[e+12>>2];v[b+36>>2]=j;Fh(b- -64|0,b+32|0,g);e=ie(b+48|0,v[v[c+4>>2]>>2],v[v[c+8>>2]>>2],v[v[c+12>>2]>>2]);j=v[v[c+12>>2]>>2];c=v[v[c+8>>2]>>2];g=v[b+76>>2];v[b+24>>2]=v[b+72>>2];v[b+28>>2]=g;g=v[b+68>>2];v[b+16>>2]=v[b+64>>2];v[b+20>>2]=g;v[b+8>>2]=v[e+8>>2];g=v[e+4>>2];v[b>>2]=v[e>>2];v[b+4>>2]=g;e=b+16|0;if(j){while(1){g=0;if(c){while(1){k=A[fh(b,g,i)>>3];ec(h,g);m=nn(e,g,i),n=C(k),z[m>>2]=n;g=g+1|0;if((c|0)!=(g|0)){continue}break}}i=i+1|0;if((j|0)!=(i|0)){continue}break}}jb=d+80|0;break a;case 2:Tw(c,zb(h));break a;case 3:j=Xg(h);d=jb-80|0;jb=d;e=v[c>>2];h=v[e+4>>2];b=v[e+24>>2];v[d+40>>2]=v[e+20>>2];v[d+44>>2]=b;i=v[e+16>>2];b=d;v[b+32>>2]=v[e+12>>2];v[b+36>>2]=i;Fh(b- -64|0,b+32|0,h);e=ie(b+48|0,v[v[c+4>>2]>>2],v[v[c+8>>2]>>2],v[v[c+12>>2]>>2]);h=v[v[c+12>>2]>>2];i=v[v[c+8>>2]>>2];c=v[b+76>>2];v[b+24>>2]=v[b+72>>2];v[b+28>>2]=c;c=v[b+68>>2];v[b+16>>2]=v[b+64>>2];v[b+20>>2]=c;v[b+8>>2]=v[e+8>>2];c=v[e+4>>2];v[b>>2]=v[e>>2];v[b+4>>2]=c;e=b+16|0;if(h){while(1){c=0;if(i){while(1){k=A[fh(b,c,g)>>3];Xe(j,c);l=sj(Md(k*134217728));m=nn(e,c,g),n=C(+(l|0)*7.450580596923828e-9),z[m>>2]=n;c=c+1|0;if((i|0)!=(c|0)){continue}break}}g=g+1|0;if((h|0)!=(g|0)){continue}break}}jb=d+80|0;break a;case 1:Tw(c,zb(h));break a;default:break b}}Tw(c,zb(h))}v[a+4>>2]=v[a+4>>2]+v[f+36>>2];jb=f+48|0}function rs(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;h=jb-160|0;jb=h;a:{b:{c:{d:{e:{f:{g:{h:{if(!c){break h}f=v[c+4>>2];if(!f&y[c>>2]>=rh(b)>>>0|f){break h}b=ba(8)|0;v[113382]=0;Q(184,b|0,17540)|0;a=v[113382];v[113382]=0;if((a|0)!=1){break g}a=P()|0;O()|0;ca(b|0);break a}if(!v[b>>2]){b=ba(8)|0;v[113382]=0;Q(1366,b|0,17540)|0;a=v[113382];v[113382]=0;if((a|0)!=1){break f}a=P()|0;O()|0;ca(b|0);break a}f=Yh(h+128|0,b);d=jb-16|0;jb=d;g=d+8|0;jo(g,Yh(d,f));e=jb-16|0;jb=e;i=Yh(e+8|0,g);g=jb-16|0;jb=g;f=h+136|0;_C(f,Dd(g+8|0,i));jb=g+16|0;jb=e+16|0;v[f+16>>2]=0;v[f+12>>2]=0;jb=d+16|0;i:{j:{if(a&2){d=Xo(h+104|0,f);v[113382]=0;j=Q(1367,d|0,c|0)|0;e=v[113382];v[113382]=0;d=1;if((e|0)==1){break i}if((j|0)==1){break j}e=Xo(h+80|0,f);v[113382]=0;e=Q(1368,e|0,c|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break e}k=(e|0)==1;if(k){break j}g=Xo(h+56|0,f);v[113382]=0;g=Q(1369,g|0,c|0)|0;i=v[113382];v[113382]=0;if((i|0)==1){break d}l=(g|0)==1;if(l){break j}i=Xo(h+32|0,f);v[113382]=0;i=Q(1370,i|0,c|0)|0;m=v[113382];v[113382]=0;if((m|0)==1){break c}if((i|0)==1){break j}d=(j|0)==-1?-1:0;d=k?d:(e|0)==-1?-1:d;j=(i|0)==-1?-1:l?d:(g|0)==-1?-1:d}if(a&1){a=72976;while(1){d=v[a>>2];if(d){e=Xo(h+8|0,f);v[113382]=0;e=Q(d|0,e|0,c|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break b}d=1;if((e|0)==1){break j}j=(e|0)==-1?-1:j}a=a+12|0;if((a|0)!=73432){continue}break}}if(c){d=0;if((j|0)!=-1){break j}a=v[c+4>>2];c=v[c>>2];v[113382]=0;a=qg(402,c,a);c=v[113382];v[113382]=0;if((c|0)!=1){d=rh(b)>>>0<a>>>0?-1:0;break j}a=P()|0;O()|0;break a}d=0;if((j|0)!=-1){break j}d=rh(b)>>>0>2047?1:-1}jb=h+160|0;return d}a=P()|0;O()|0;break a}ha(b|0,67e3,24);L()}ha(b|0,66896,24);L()}a=P()|0;O()|0;break a}a=P()|0;O()|0;break a}a=P()|0;O()|0;break a}a=P()|0;O()|0}S(a|0);L()}function z2(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;e=jb-32|0;jb=e;g=ih(a);a=b+24|0;f=Vb(v[a>>2]+484360|0);v[113382]=0;i=T(2160,f|0)|0;f=v[113382];v[113382]=0;a:{b:{c:{if((f|0)==1){break c}v[113382]=0;R(1500,g|0,i|0);f=v[113382];v[113382]=0;if((f|0)==1){break c}d:{e:{if(i){f=0;while(1){c=x[rc(Vb(v[a>>2]+484360|0),f)>>1];d=v[a>>2];v[113382]=0;d=Q(879,d+484344|0,c|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break b}f:{if(d){c=Zb(v[a>>2]+484344|0,x[rc(Vb(v[a>>2]+484360|0),f)>>1]);v[113382]=0;R(2158,e|0,c|0);c=v[113382];v[113382]=0;g:{h:{i:{if((c|0)!=1){v[113382]=0;U(2152,e+16|0,b|0,e|0);c=v[113382];v[113382]=0;if((c|0)==1){break i}v[113382]=0;R(1502,g|0,e+16|0);c=v[113382];v[113382]=0;if((c|0)==1){break h}yb(e+16|0);yb(e);break f}a=P()|0;O()|0;break a}a=P()|0;O()|0;break g}a=P()|0;O()|0;yb(e+16|0)}yb(e);break a}v[113382]=0;d=da(926)|0;h=v[113382];v[113382]=0;if((h|0)==1){break b}if((c|0)==(d|0)){v[113382]=0;c=Q(121,e+16|0,5264)|0;d=v[113382];v[113382]=0;j:{if((d|0)!=1){v[113382]=0;R(1502,g|0,c|0);d=v[113382];v[113382]=0;if((d|0)==1){break j}yb(c);break f}a=P()|0;O()|0;break a}a=P()|0;O()|0;yb(c);break a}v[113382]=0;d=da(925)|0;h=v[113382];v[113382]=0;if((h|0)==1){break b}if((c|0)==(d|0)){v[113382]=0;c=Q(121,e+16|0,5226)|0;d=v[113382];v[113382]=0;k:{if((d|0)!=1){v[113382]=0;R(1502,g|0,c|0);d=v[113382];v[113382]=0;if((d|0)==1){break k}yb(c);break f}a=P()|0;O()|0;break a}a=P()|0;O()|0;yb(c);break a}v[113382]=0;c=Q(121,e+16|0,10306)|0;d=v[113382];v[113382]=0;if((d|0)==1){break e}v[113382]=0;R(1502,g|0,c|0);d=v[113382];v[113382]=0;if((d|0)==1){break d}yb(c)}f=f+1|0;if((i|0)!=(f|0)){continue}break}}jb=e+32|0;return}a=P()|0;O()|0;break a}a=P()|0;O()|0;yb(c);break a}a=P()|0;O()|0;break a}a=P()|0;O()|0}gd(g);S(a|0);L()}function Rf(a,b,c,d,e){var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;i=v[a+8>>2]+(B(x[a+14>>1],(w[a+80|0]?c:0)+b|0)>>>1|0)|0;v[a+8>>2]=i;j=w[a+79|0]?x[v[a>>2]+3836>>1]:j;g=x[a+20>>1];l=x[a+22>>1];m=x[a+70>>1];a:{b:{c:{d:{switch(v[a+16>>2]){case 1:b=x[v[a>>2]+3832>>1];c=x[a+26>>1]?x[a+48>>1]>>>x[v[a+52>>2]+((b>>>x[a+44>>1]&7)<<1)>>1]|0:0;h=b;b=x[a+46>>1];f=g+(b?h&b?0:c:c)|0;u[a+20>>1]=f;c=2;b=x[a+28>>1];if((b|0)<=f<<16>>16){break c}break b;case 2:if(w[a+78|0]){break b}case 3:c=0;b=x[v[a>>2]+3832>>1];f=x[a+30>>1]?x[a+60>>1]>>>x[v[a+64>>2]+((b>>>x[a+56>>1]&7)<<1)>>1]|0:0;h=b;b=x[a+58>>1];b=g+(b?h&b?0:f:f)|0;u[a+20>>1]=b;if(b<<16>>16<511){break b}v[a+16>>2]=-1;u[a+20>>1]=511;v[a+72>>2]=0;break a;default:c=0;v[a+72>>2]=0;break a;case 0:break d}}c=1;b=0;f=x[v[a>>2]+3832>>1];h=x[a+24>>1]?B((g^-1)<<16>>16,x[a+36>>1]>>>x[v[a+40>>2]+((f>>>x[a+32>>1]&7)<<1)>>1]|0)>>>3|0:0;k=x[a+34>>1];f=g+(k?f&k?0:h:h)|0;u[a+20>>1]=f;if(f<<16>>16>0){break b}}v[a+16>>2]=c;u[a+20>>1]=b}g=((g+l|0)+m|0)+j<<3;if(e){d=(u[a+74>>1]+u[a+72>>1]>>e)+d|0}d=(i>>>10|0)+d|0;c=d&255;b=d&65535;e:{f:{switch(x[a+12>>1]){case 0:d=(b&512)>>>9|0;b=x[((b&256?c^255:c)<<1)+25088>>1];break e;case 1:d=0;b=x[((b&512?0:b&256?c^255:c)<<1)+25088>>1];break e;case 2:d=0;b=x[((b&256?c^255:c)<<1)+25088>>1];break e;case 3:d=0;b=x[((b&256?0:c)<<1)+25088>>1];break e;case 4:e=0;d=0;if(!(b&512)){e=(c<<1^b<<24>>31)&254;d=(b&256)>>>8|0}b=x[(e<<1)+25088>>1];break e;case 5:d=0;if(b&512){b=0}else{c=c<<1&254;b=b&128?c^255:c}b=x[(b<<1)+25088>>1];break e;case 6:d=(d&512)>>>9|0;b=0;break e;default:break f}}c=d<<3&4088;d=(b&512)>>>9|0;b=d?c^4088:c}u[a+74>>1]=x[a+72>>1];e=a;a=b+g|0;a=(a&65535)>>>0<8191?a:8191;c=0-d^x[((a&255)<<1)+24576>>1]+1024>>>((a&65280)>>>8)<<1;u[e+72>>1]=c}return c<<16>>16}function d1(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;e=jb-16|0;jb=e;g=-2;a:{if(!a){break a}c=v[a+28>>2];if(!c){break a}f=(b|0)==1?2:b;if(f>>>0>4|!(1<<f&21)){break a}h=v[c+11e3>>2];k=v[a+4>>2];v[c+11e3>>2]=0;b:{if(v[c+43780>>2]<0){break b}b=v[c+11004>>2];if((f|0)!=4?b:0){break a}i=v[c+11008>>2]>0?9:8;v[c+11004>>2]=b|(f|0)==4;b=(f|0)!=4;if(!(b|!h)){v[e+12>>2]=v[a+4>>2];v[e+8>>2]=v[a+16>>2];b=v[a+12>>2];h=TG(c,v[a>>2],e+12|0,b,b,e+8|0,i|4);v[c+43780>>2]=h;b=v[e+12>>2];v[a>>2]=b+v[a>>2];v[a+4>>2]=v[a+4>>2]-b;v[a+8>>2]=b+v[a+8>>2];v[a+48>>2]=v[c+28>>2];b=v[e+8>>2];v[a+12>>2]=b+v[a+12>>2];v[a+16>>2]=v[a+16>>2]-b;v[a+20>>2]=b+v[a+20>>2];g=-3;if((h|0)<0){break a}if(!h){g=1;break a}v[c+43780>>2]=-1;g=-5;break a}h=v[c+10996>>2];if(!h){i=b?i|2:i;j=c+11012|0;d=v[c+10992>>2];h=(f|0)!=4;while(1){b=v[a+4>>2];v[e+8>>2]=32768-d;v[e+12>>2]=b;f=TG(c,v[a>>2],e+12|0,j,d+j|0,e+8|0,i);v[c+43780>>2]=f;b=v[e+12>>2];v[a>>2]=b+v[a>>2];v[a+4>>2]=v[a+4>>2]-b;v[a+8>>2]=b+v[a+8>>2];v[a+48>>2]=v[c+28>>2];d=v[e+8>>2];v[c+10996>>2]=d;b=v[a+16>>2];d=b>>>0>d>>>0?d:b;lc(v[a+12>>2],v[c+10992>>2]+j|0,d);v[a+12>>2]=d+v[a+12>>2];v[a+16>>2]=v[a+16>>2]-d;v[a+20>>2]=d+v[a+20>>2];b=v[c+10996>>2]-d|0;v[c+10996>>2]=b;d=d+v[c+10992>>2]&32767;v[c+10992>>2]=d;if((f|0)<0){break b}g=-5;if(k?0:(f|0)==1){break a}if(!h){if(!f){g=b?-5:1;break a}if(v[a+16>>2]){continue}break a}if(f){g=0;if(!v[a+4>>2]|!v[a+16>>2]){break a}if(!b){continue}break a}break}g=!b;break a}b=v[a+16>>2];b=b>>>0>h>>>0?h:b;lc(v[a+12>>2],(v[c+10992>>2]+c|0)+11012|0,b);v[a+12>>2]=b+v[a+12>>2];v[a+16>>2]=v[a+16>>2]-b;v[a+20>>2]=b+v[a+20>>2];a=v[c+10996>>2]-b|0;v[c+10996>>2]=a;v[c+10992>>2]=b+v[c+10992>>2]&32767;g=0;if(v[c+43780>>2]){break a}g=!a;break a}g=-3}jb=e+16|0;return g|0}function H9(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;c=jb-144|0;jb=c;e=cl(c+40|0,a);v[113382]=0;d=Q(645,c+24|0,36107)|0;a=v[113382];v[113382]=0;a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{if((a|0)!=1){v[113382]=0;v[c>>2]=19469312;v[c+4>>2]=0;U(646,e|0,d|0,c|0);a=v[113382];v[113382]=0;if((a|0)==1){break n}Ib(d);if(v[e>>2]&1073741824){break e}v[113382]=0;d=Q(645,c+24|0,9352)|0;a=v[113382];v[113382]=0;if((a|0)==1){break m}v[113382]=0;aa(1537,e|0,b|0,d|0,1538)|0;a=v[113382];v[113382]=0;if((a|0)==1){break l}Ib(d);v[113382]=0;v[c+20>>2]=0;v[c+16>>2]=0;d=Q(645,c+24|0,12760)|0;a=v[113382];v[113382]=0;if((a|0)==1){break k}v[113382]=0;W(1539,e|0,c+20|0,d|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break j}Ib(d);v[113382]=0;d=Q(645,c+24|0,12750)|0;a=v[113382];v[113382]=0;if((a|0)==1){break i}v[113382]=0;W(1539,e|0,c+16|0,d|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break h}Ib(d);a=b;d=v[c+16>>2];f=v[c+20>>2];o:{if(!f){break o}if(d>>>0<f>>>0|f>>>0>y[v[Um(a)+8>>2]+40>>2]){break o}if(d>>>0>y[v[Um(a)+8>>2]+40>>2]){break o}v[a+20>>2]=d;v[a+16>>2]=f}d=fy(c+24|0);v[113382]=0;f=Q(645,c|0,10039)|0;a=v[113382];v[113382]=0;if((a|0)==1){break d}v[113382]=0;aa(1540,e|0,d|0,f|0,636)|0;a=v[113382];v[113382]=0;if((a|0)==1){break g}Ib(f);if(id(d)){break f}a=v[b+16>>2];v[113382]=0;U(1379,d|0,a|0,16777216);a=v[113382];v[113382]=0;if((a|0)!=1){break f}break c}a=P()|0;O()|0;break a}a=P()|0;O()|0;Ib(d);break a}a=P()|0;O()|0;break a}a=P()|0;O()|0;Ib(d);break a}a=P()|0;O()|0;break a}a=P()|0;O()|0;Ib(d);break a}a=P()|0;O()|0;break a}a=P()|0;O()|0;Ib(d);break a}a=P()|0;O()|0;Ib(f);break b}v[113382]=0;R(1541,b|0,d|0);a=v[113382];v[113382]=0;if((a|0)==1){break c}ze(d)}Bg(e);jb=c+144|0;return}a=P()|0;O()|0;break b}a=P()|0;O()|0}ze(d)}Bg(e);S(a|0);L()}function mga(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;e=jb-32|0;jb=e;j=c+484344|0;dg(j,w[b+70|0]|w[b+71|0]<<8);a:{if(w[b+70|0]|w[b+71|0]<<8){while(1){f=v[a+8>>2];g=Df(a);_b(a,1);b:{if((w[b+58|0]|w[b+59|0]<<8)==258){c=le(a)+1|0;break b}c=og(a)}d=og(a);Nc(a,f+g|0);td(e+16|0,a,d);v[113382]=0;c=W(364,j|0,i&65535,(c?c>>>0<1024?c:1024:64)|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break a}c:{if(!c|!d){break c}c=Zb(j,i);k=e,l=ac(c),v[k+8>>2]=l;k=e,l=bc(c),v[k>>2]=l;if(!Jb(e+8|0,e)){break c}while(1){d=v[e+8>>2];v[113382]=0;c=T(409,e+16|0)|0;f=v[113382];v[113382]=0;d:{e:{f:{if((f|0)!=1){if(!(c&128)){break f}if(c&1){v[113382]=0;f=T(409,e+16|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break a}t[d|0]=f}if(c&2){break e}break d}break a}t[d|0]=c;c=255}v[113382]=0;f=T(409,e+16|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break a}t[d+1|0]=f}f=0;if(c&4){v[113382]=0;f=T(409,e+16|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break a}}if(c&8){v[113382]=0;g=T(409,e+16|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break a}t[d+3|0]=g}if(c&16){v[113382]=0;c=T(409,e+16|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break a}t[d+5|0]=c}c=d;g:{h:{g=w[d|0];if(!g){break h}h=255;if((g|0)==97){break g}if(g>>>0>96){break h}h=g+12|0;break g}h=0}t[c|0]=h;i:{if(w[d+5|0]|w[d+3|0]){v[113382]=0;Z(537,d|0);c=v[113382];v[113382]=0;if((c|0)!=1){break i}break a}t[d+3|0]=0}if(w[d+1|0]==255){t[d+1|0]=0}c=f-16|0;j:{if((c&255)>>>0<=64){t[d+4|0]=c;t[d+2|0]=1;break j}if(f>>>0<96){break j}c=f&15;t[d+4|0]=c;f=f-96>>4;t[d+2|0]=w[f+24223|0];if((f|0)!=6){break j}t[d+4|0]=c<<2}c=e+8|0;Bj(c);if(Jb(c,e)){continue}break}}Bb(e+16|0);i=i+1|0;if(i>>>0<(w[b+70|0]|w[b+71|0]<<8)>>>0){continue}break}}jb=e+32|0;return}a=P()|0;O()|0;Bb(e+16|0);S(a|0);L()}function jka(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;g=jb-32|0;jb=g;v[g+24>>2]=d;i=Lj(a,c);pf(g,v[a+28>>2]);d=v[g+12>>2];v[g+16>>2]=v[g+8>>2];v[g+20>>2]=d;a:{if(!i){if(wd(a,5)){break a}}j=v[g+24>>2];d=jb-160|0;jb=d;h=cl(d+56|0,v[a+28>>2]);v[113382]=0;f=Q(645,d+8|0,24503)|0;e=v[113382];v[113382]=0;b:{c:{d:{e:{if((e|0)!=1){v[113382]=0;v[d+48>>2]=19469312;v[d+52>>2]=0;U(646,h|0,f|0,d+48|0);e=v[113382];v[113382]=0;if((e|0)==1){break e}Ib(f);if(!(v[h>>2]&1073741824)){break d}break b}e=P()|0;O()|0;break c}e=P()|0;O()|0;Ib(f);break c}v[113382]=0;t[d+48|0]=0;t[d+47|0]=0;f=Q(645,d+8|0,6187)|0;e=v[113382];v[113382]=0;f:{if((e|0)!=1){v[113382]=0;W(1151,h|0,d+48|0,f|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break f}Ib(f);if(!w[d+48|0]){break b}We(d+48|0,50);v[113382]=0;f=Q(645,d+8|0,9233)|0;e=v[113382];v[113382]=0;g:{h:{i:{j:{if((e|0)!=1){v[113382]=0;W(1151,h|0,d+47|0,f|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break j}Ib(f);f=Mh(b);e=w[d+48|0];if(f>>>0<e>>>0){f=Ny(d+8|0,v[b+12>>2]);v[113382]=0;U(1152,b|0,e|0,f|0);e=v[113382];v[113382]=0;if((e|0)==1){break i}El(f)}e=0;f=x[Di(b,0)+28>>1];t[d+7|0]=0;if(w[d+48|0]){while(1){Ne(Di(b,e&255),f);e=Di(b,w[d+7|0]);v[113382]=0;R(1153,d+8|0,d+7|0);k=v[113382];v[113382]=0;if((k|0)==1){break h}v[113382]=0;X(1154,h|0,e|0,d+8|0,j|0);e=v[113382];v[113382]=0;if((e|0)==1){break g}Ib(d+8|0);e=w[d+7|0]+1|0;t[d+7|0]=e;if(w[d+48|0]>(e&255)>>>0){continue}break}}e=w[d+47|0];f=Mh(b);t[b+16|0]=e>>>0<f>>>0?w[d+47|0]:0;break b}e=P()|0;O()|0;break c}e=P()|0;O()|0;Ib(f);break c}e=P()|0;O()|0;El(f);break c}e=P()|0;O()|0;break c}e=P()|0;O()|0;Ib(d+8|0);break c}e=P()|0;O()|0;break c}e=P()|0;O()|0;Ib(f)}Bg(h);S(e|0);L()}Bg(h);jb=d+160|0}$i(a,i,c,g+16|0);jb=g+32|0}function kO(a){a=a|0;var b=0,c=0,d=0;Qb(a,0,288);c=a+288|0;Xy(c);d=a+800|0;vp(d);t[a+2|0]=w[10082];b=w[10080]|w[10081]<<8;t[a|0]=b;t[a+1|0]=b>>>8;t[a+34|0]=w[10141];b=w[10139]|w[10140]<<8;t[a+32|0]=b;t[a+33|0]=b>>>8;b=w[1985]|w[1986]<<8|(w[1987]<<16|w[1988]<<24);t[a+99|0]=b;t[a+100|0]=b>>>8;t[a+101|0]=b>>>16;t[a+102|0]=b>>>24;b=w[1982]|w[1983]<<8|(w[1984]<<16|w[1985]<<24);t[a+96|0]=b;t[a+97|0]=b>>>8;t[a+98|0]=b>>>16;t[a+99|0]=b>>>24;b=w[11855]|w[11856]<<8|(w[11857]<<16|w[11858]<<24);t[a+128|0]=b;t[a+129|0]=b>>>8;t[a+130|0]=b>>>16;t[a+131|0]=b>>>24;b=w[11858]|w[11859]<<8|(w[11860]<<16|w[11861]<<24);t[a+131|0]=b;t[a+132|0]=b>>>8;t[a+133|0]=b>>>16;t[a+134|0]=b>>>24;t[a+260|0]=w[5293];b=w[5289]|w[5290]<<8|(w[5291]<<16|w[5292]<<24);t[a+256|0]=b;t[a+257|0]=b>>>8;t[a+258|0]=b>>>16;t[a+259|0]=b>>>24;a=jb-80|0;jb=a;v[a+76>>2]=0;b=Ub(a- -64|0,1439);v[113382]=0;R(473,a+48|0,c|0);c=v[113382];v[113382]=0;a:{b:{c:{d:{if((c|0)==1){break d}v[113382]=0;Q(431,a+48|0,b|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break d}yb(b);break c}a=P()|0;O()|0;yb(b);break b}jb=a+80|0;break a}S(a|0);L()}b=0;a=jb+-64|0;jb=a;e:{f:{g:{h:{i:{j:{while(1){v[a+60>>2]=b;v[a+60>>2]=b<<3;BA(a+32|0,b>>>0<16?11591:17540);v[113382]=0;R(471,a+16|0,a+60|0);c=v[113382];v[113382]=0;if((c|0)==1){break j}v[113382]=0;U(472,a+48|0,a+32|0,a+16|0);c=v[113382];v[113382]=0;if((c|0)==1){break i}v[113382]=0;R(473,a+8|0,(b<<5)+d|0);c=v[113382];v[113382]=0;if((c|0)==1){break h}v[113382]=0;Q(431,a+8|0,a+48|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break h}yb(a+48|0);yb(a+16|0);Ib(a+32|0);b=b+1|0;if((b|0)!=128){continue}break}jb=a- -64|0;break e}b=P()|0;O()|0;break f}b=P()|0;O()|0;break g}b=P()|0;O()|0;yb(a+48|0)}yb(a+16|0)}Ib(a+32|0);S(b|0);L()}}function vr(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;i=jb-128|0;jb=i;v[i+120>>2]=b;k=Ps(c,d);v[i+4>>2]=2310;m=Ld(i+8|0,0,i+4|0);j=i+16|0;a:{b:{if(k>>>0>=101){j=kd(k);if(!j){v[113382]=0;Y(2311);a=v[113382];v[113382]=0;if((a|0)!=1){break a}b=P()|0;O()|0;break b}ve(m,j)}h=j;b=c;while(1){if((b|0)==(d|0)){c:{d:{e:while(1){f:{v[113382]=0;h=Q(2312,a|0,i+120|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break f}if(!(h&(k|0)!=0)){v[113382]=0;b=Q(2313,a|0,i+120|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break c}if(!b){break d}v[f>>2]=v[f>>2]|2;break d}v[113382]=0;n=T(2314,a|0)|0;b=v[113382];v[113382]=0;g:{if((b|0)!=1){if(g){break g}v[113382]=0;n=Q(2315,e|0,n|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){break g}}b=P()|0;O()|0;break b}o=q+1|0;r=0;h=j;b=c;while(1){if((b|0)==(d|0)){q=o;if(!r){continue e}v[113382]=0;T(2316,a|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){h=j;b=c;if(k+l>>>0<2){continue e}while(1){if((b|0)==(d|0)){continue e}h:{if(w[h|0]!=2){break h}if((Db(b)|0)==(o|0)){break h}t[h|0]=0;l=l-1|0}h=h+1|0;b=b+12|0;continue}}b=P()|0;O()|0;break b}i:{if(w[h|0]!=1){break i}p=t[kc(b,q)|0];j:{if(g){break j}v[113382]=0;p=Q(2315,e|0,p<<24>>24)|0;s=v[113382];v[113382]=0;if((s|0)!=1){break j}b=P()|0;O()|0;break b}k:{if((n&255)==(p&255)){r=1;if((Db(b)|0)!=(o|0)){break i}t[h|0]=2;l=l+1|0;break k}t[h|0]=0}k=k-1|0}h=h+1|0;b=b+12|0;continue}}break}b=P()|0;O()|0;break b}l:{m:{while(1){if((c|0)==(d|0)){break m}if(w[j|0]!=2){j=j+1|0;c=c+12|0;continue}break}d=c;break l}v[f>>2]=v[f>>2]|4}Gc(m);jb=i+128|0;return d|0}b=P()|0;O()|0}else{n:{if(!Sc(b)){t[h|0]=1;break n}t[h|0]=2;l=l+1|0;k=k-1|0}h=h+1|0;b=b+12|0;continue}break}}Gc(m);S(b|0)}L()}
function y$(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;a=jb-352|0;jb=a;v[a+336>>2]=c;v[a+344>>2]=b;h=Xb(a+208|0);v[113382]=0;Ac(a+16|0,d);b=v[113382];v[113382]=0;a:{b:{c:{d:{if((b|0)!=1){v[113382]=0;b=T(2339,a+16|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break d}v[113382]=0;aa(2353,b|0,59248,59274,a+224|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break d}Ob(a+16|0);c=Xb(a+192|0);b=Fc(c);v[113382]=0;R(1589,c|0,b|0);b=v[113382];v[113382]=0;if((b|0)==1){break b}b=kc(c,0);v[a+188>>2]=b;v[a+12>>2]=a+16;v[a+8>>2]=0;while(1){e:{v[113382]=0;d=Q(2344,a+344|0,a+336|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break e}if(!d){break c}if(v[a+188>>2]==(Db(c)+b|0)){d=Db(c);b=Db(c);v[113382]=0;R(1589,c|0,b<<1);b=v[113382];v[113382]=0;if((b|0)==1){break b}b=Fc(c);v[113382]=0;R(1589,c|0,b|0);b=v[113382];v[113382]=0;if((b|0)==1){break b}b=kc(c,0);v[a+188>>2]=d+b}v[113382]=0;d=T(2346,a+344|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break e}v[113382]=0;d=$j(d,16,b,a+188|0,a+8|0,0,h,a+16|0,a+12|0,a+224|0);g=v[113382];v[113382]=0;if((g|0)==1){break e}if(d){break c}v[113382]=0;T(2348,a+344|0)|0;d=v[113382];v[113382]=0;if((d|0)!=1){continue}}break}break b}b=P()|0;O()|0;break a}b=P()|0;O()|0;Ob(a+16|0);break a}v[113382]=0;R(1589,c|0,v[a+188>>2]-b|0);b=v[113382];v[113382]=0;f:{if((b|0)==1){break f}b=Tb(c);v[113382]=0;d=da(2335)|0;g=v[113382];v[113382]=0;if((g|0)==1){break f}v[a>>2]=f;v[113382]=0;b=aa(2336,b|0,d|0,5286,a|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break f}if((b|0)!=1){v[e>>2]=4}v[113382]=0;b=Q(2345,a+344|0,a+336|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break f}if(b){v[e>>2]=v[e>>2]|2}b=v[a+344>>2];yb(c);yb(h);jb=a+352|0;return b|0}}b=P()|0;O()|0;yb(c)}yb(h);S(b|0);L()}function M$(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;a=jb-272|0;jb=a;v[a+256>>2]=c;v[a+264>>2]=b;h=Xb(a+208|0);v[113382]=0;Ac(a+16|0,d);b=v[113382];v[113382]=0;a:{b:{c:{d:{if((b|0)!=1){v[113382]=0;b=T(21,a+16|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break d}v[113382]=0;aa(2330,b|0,59248,59274,a+224|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break d}Ob(a+16|0);c=Xb(a+192|0);b=Fc(c);v[113382]=0;R(1589,c|0,b|0);b=v[113382];v[113382]=0;if((b|0)==1){break b}b=kc(c,0);v[a+188>>2]=b;v[a+12>>2]=a+16;v[a+8>>2]=0;while(1){e:{v[113382]=0;d=Q(2312,a+264|0,a+256|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break e}if(!d){break c}if(v[a+188>>2]==(Db(c)+b|0)){d=Db(c);b=Db(c);v[113382]=0;R(1589,c|0,b<<1);b=v[113382];v[113382]=0;if((b|0)==1){break b}b=Fc(c);v[113382]=0;R(1589,c|0,b|0);b=v[113382];v[113382]=0;if((b|0)==1){break b}b=kc(c,0);v[a+188>>2]=d+b}v[113382]=0;d=T(2314,a+264|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break e}v[113382]=0;d=bk(d,16,b,a+188|0,a+8|0,0,h,a+16|0,a+12|0,a+224|0);g=v[113382];v[113382]=0;if((g|0)==1){break e}if(d){break c}v[113382]=0;T(2316,a+264|0)|0;d=v[113382];v[113382]=0;if((d|0)!=1){continue}}break}break b}b=P()|0;O()|0;break a}b=P()|0;O()|0;Ob(a+16|0);break a}v[113382]=0;R(1589,c|0,v[a+188>>2]-b|0);b=v[113382];v[113382]=0;f:{if((b|0)==1){break f}b=Tb(c);v[113382]=0;d=da(2335)|0;g=v[113382];v[113382]=0;if((g|0)==1){break f}v[a>>2]=f;v[113382]=0;b=aa(2336,b|0,d|0,5286,a|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break f}if((b|0)!=1){v[e>>2]=4}v[113382]=0;b=Q(2313,a+264|0,a+256|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break f}if(b){v[e>>2]=v[e>>2]|2}b=v[a+264>>2];yb(c);yb(h);jb=a+272|0;return b|0}}b=P()|0;O()|0;yb(c)}yb(h);S(b|0);L()}function I_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0;a=jb-624|0;jb=a;v[a+608>>2]=c;v[a+616>>2]=b;v[a+16>>2]=2373;b=Ld(a+200|0,a+208|0,a+16|0);v[113382]=0;Ac(a+192|0,e);h=v[113382];v[113382]=0;a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{if((h|0)!=1){v[113382]=0;h=T(2339,a+192|0)|0;i=v[113382];v[113382]=0;if((i|0)==1){break j}t[a+191|0]=0;e=v[e+4>>2];v[113382]=0;c=ta(2384,a+616|0,c|0,d|0,a+192|0,e|0,f|0,a+191|0,h|0,b|0,a+196|0,a+608|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break e}if(!c){break f}c=w[10344]|w[10345]<<8|(w[10346]<<16|w[10347]<<24);t[a+183|0]=c;t[a+184|0]=c>>>8;t[a+185|0]=c>>>16;t[a+186|0]=c>>>24;c=w[10341]|w[10342]<<8|(w[10343]<<16|w[10344]<<24);v[a+176>>2]=w[10337]|w[10338]<<8|(w[10339]<<16|w[10340]<<24);v[a+180>>2]=c;v[113382]=0;aa(2353,h|0,a+176|0,a+186|0,a+128|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break i}v[a+4>>2]=2310;d=Ld(a+8|0,0,a+4|0);c=a+16|0;if((v[a+196>>2]-v[b>>2]|0)<393){break g}ve(d,kd((v[a+196>>2]-v[b>>2]>>2)+2|0));if(v[d>>2]){break h}v[113382]=0;Y(2311);c=v[113382];v[113382]=0;if((c|0)==1){break d}break a}e=P()|0;O()|0;break b}e=P()|0;O()|0;break c}e=P()|0;O()|0;break c}c=v[d>>2]}if(w[a+191|0]){t[c|0]=45;c=c+1|0}e=v[b>>2];while(1){if(y[a+196>>2]<=e>>>0){t[c|0]=0;v[a>>2]=g;if((OF(a+16|0,a)|0)!=1){v[113382]=0;Z(2375,4274);c=v[113382];v[113382]=0;if((c|0)!=1){break a}break d}Gc(d)}else{h=a+128|0;j=c,k=w[(a+176|0)+(Vv(h,h+40|0,e)-h>>2)|0],t[j|0]=k;c=c+1|0;e=e+4|0;continue}break}}v[113382]=0;c=Q(2345,a+616|0,a+608|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break e}if(c){v[f>>2]=v[f>>2]|2}c=v[a+616>>2];Ob(a+192|0);Gc(b);jb=a+624|0;return c|0}e=P()|0;O()|0;break c}e=P()|0;O()|0;Gc(d)}Ob(a+192|0)}Gc(b);S(e|0);L()}L()}function rr(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;i=jb-128|0;jb=i;v[i+120>>2]=b;k=Ps(c,d);v[i+4>>2]=2310;m=Ld(i+8|0,0,i+4|0);j=i+16|0;a:{b:{if(k>>>0>=101){j=kd(k);if(!j){v[113382]=0;Y(2311);a=v[113382];v[113382]=0;if((a|0)!=1){break a}b=P()|0;O()|0;break b}ve(m,j)}h=j;b=c;while(1){if((b|0)==(d|0)){c:{d:{e:while(1){f:{v[113382]=0;h=Q(2344,a|0,i+120|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break f}if(!(h&(k|0)!=0)){v[113382]=0;b=Q(2345,a|0,i+120|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break c}if(!b){break d}v[f>>2]=v[f>>2]|2;break d}v[113382]=0;n=T(2346,a|0)|0;b=v[113382];v[113382]=0;g:{if((b|0)!=1){if(g){break g}v[113382]=0;n=Q(2347,e|0,n|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){break g}}b=P()|0;O()|0;break b}o=q+1|0;r=0;h=j;b=c;while(1){if((b|0)==(d|0)){q=o;if(!r){continue e}v[113382]=0;T(2348,a|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){h=j;b=c;if(k+l>>>0<2){continue e}while(1){if((b|0)==(d|0)){continue e}h:{if(w[h|0]!=2){break h}if((Db(b)|0)==(o|0)){break h}t[h|0]=0;l=l-1|0}h=h+1|0;b=b+12|0;continue}}b=P()|0;O()|0;break b}i:{if(w[h|0]!=1){break i}p=v[ij(b,q)>>2];j:{if(g){break j}v[113382]=0;p=Q(2347,e|0,p|0)|0;s=v[113382];v[113382]=0;if((s|0)!=1){break j}b=P()|0;O()|0;break b}k:{if((n|0)==(p|0)){r=1;if((Db(b)|0)!=(o|0)){break i}t[h|0]=2;l=l+1|0;break k}t[h|0]=0}k=k-1|0}h=h+1|0;b=b+12|0;continue}}break}b=P()|0;O()|0;break b}l:{m:{while(1){if((c|0)==(d|0)){break m}if(w[j|0]!=2){j=j+1|0;c=c+12|0;continue}break}d=c;break l}v[f>>2]=v[f>>2]|4}Gc(m);jb=i+128|0;return d|0}b=P()|0;O()|0}else{n:{if(!Sc(b)){t[h|0]=1;break n}t[h|0]=2;l=l+1|0;k=k-1|0}h=h+1|0;b=b+12|0;continue}break}}Gc(m);S(b|0)}L()}function xea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0;f=jb-48|0;jb=f;s=v[a+16>>2];e=v[a+44>>2];v[f+32>>2]=e;i=v[a+48>>2];v[f+36>>2]=i;l=v[a+52>>2];v[f+40>>2]=l;m=v[a+56>>2];v[f+44>>2]=m;t=v[a+24>>2];w=v[a+20>>2];g=v[a+4>>2];j=v[a>>2];v[f+24>>2]=j;v[f+28>>2]=g;h=v[a+12>>2];v[f+16>>2]=v[a+8>>2];v[f+20>>2]=h;if(d){while(1){m=1;h=((((g&2147483647)<<1|j>>>31)&2147483646)<<1)+s|0;e=(((j>>>16|0)+4&131064)<<1)+b|0;j=u[e+38>>1];k=u[e+36>>1];o=u[e+34>>1];p=u[e+32>>1];q=u[e+30>>1];n=u[e+28>>1];r=u[e+26>>1];x=u[e+24>>1];l=0;e=1;i=0;while(1){g=i<<1;v[(f+8|0)+(i<<2)>>2]=(((((B(u[h+(g|8)>>1],o)+B(u[h+(g|4)>>1],p)|0)+B(u[h+(g|12)>>1],k)|0)+B(j,u[h+(g|16)>>1])|0)/2|0)+((((B(u[h+(g|-8)>>1],r)+B(u[h+(g|-12)>>1],x)|0)+B(u[h+(g|-4)>>1],n)|0)+B(u[h+g>>1],q)|0)/2|0)|0)/16384;g=e;e=0;i=1;if(g){continue}break}while(1){i=(f+8|0)+(l<<2)|0;j=v[i>>2];k=v[a+60>>2];o=k;g=(f+32|0)+(l<<3)|0;l=v[g>>2];e=Yb(l,-16777216,16776704);p=v[a+64>>2];h=Yb(v[g+4>>2],-16777216,16776704);n=v[a+68>>2];r=n;n=n>>31;v[g+4>>2]=l;l=v[a+72>>2];k=k>>31;j=j<<8;k=qma(o,k,j,j>>31);o=mb;q=i;i=k;k=qma(p,p>>31,e,e>>31);i=i+k|0;e=mb+o|0;e=i>>>0<k>>>0?e+1|0:e;k=i;i=qma(r,n,h,h>>31);h=k+i|0;e=mb+e|0;e=h>>>0<i>>>0?e+1|0:e;h=h+8388608|0;e=h>>>0<8388608?e+1|0:e;e=(e&16777215)<<8|h>>>24;v[q>>2]=(e|0)/256;v[g>>2]=e-(j&l);l=1;e=m&1;m=0;if(e){continue}break}v[c>>2]=v[c>>2]+B(v[f+8>>2],w);v[c+4>>2]=v[c+4>>2]+B(v[f+12>>2],t);Sb(f+24|0,f+16|0);d=d-1|0;if(d){c=c+8|0;j=v[f+24>>2];g=v[f+28>>2];continue}break}j=v[f+24>>2];g=v[f+28>>2];m=v[f+44>>2];l=v[f+40>>2];i=v[f+36>>2];e=v[f+32>>2]}v[a+56>>2]=m;v[a+52>>2]=l;v[a+48>>2]=i;v[a+44>>2]=e;v[a>>2]=j;v[a+4>>2]=g;jb=f+48|0}function P_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0;a=jb-288|0;jb=a;v[a+272>>2]=c;v[a+280>>2]=b;v[a+16>>2]=2373;b=Ld(a+152|0,a+160|0,a+16|0);v[113382]=0;Ac(a+144|0,e);h=v[113382];v[113382]=0;a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{if((h|0)!=1){v[113382]=0;h=T(21,a+144|0)|0;i=v[113382];v[113382]=0;if((i|0)==1){break j}t[a+143|0]=0;e=v[e+4>>2];v[113382]=0;c=ta(2374,a+280|0,c|0,d|0,a+144|0,e|0,f|0,a+143|0,h|0,b|0,a+148|0,a+260|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break e}if(!c){break f}c=w[10344]|w[10345]<<8|(w[10346]<<16|w[10347]<<24);t[a+135|0]=c;t[a+136|0]=c>>>8;t[a+137|0]=c>>>16;t[a+138|0]=c>>>24;c=w[10341]|w[10342]<<8|(w[10343]<<16|w[10344]<<24);v[a+128>>2]=w[10337]|w[10338]<<8|(w[10339]<<16|w[10340]<<24);v[a+132>>2]=c;v[113382]=0;aa(2330,h|0,a+128|0,a+138|0,a+118|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break i}v[a+4>>2]=2310;d=Ld(a+8|0,0,a+4|0);c=a+16|0;if((v[a+148>>2]-v[b>>2]|0)<99){break g}ve(d,kd((v[a+148>>2]-v[b>>2]|0)+2|0));if(v[d>>2]){break h}v[113382]=0;Y(2311);c=v[113382];v[113382]=0;if((c|0)==1){break d}break a}e=P()|0;O()|0;break b}e=P()|0;O()|0;break c}e=P()|0;O()|0;break c}c=v[d>>2]}if(w[a+143|0]){t[c|0]=45;c=c+1|0}e=v[b>>2];while(1){if(y[a+148>>2]<=e>>>0){t[c|0]=0;v[a>>2]=g;if((OF(a+16|0,a)|0)!=1){v[113382]=0;Z(2375,4274);c=v[113382];v[113382]=0;if((c|0)!=1){break a}break d}Gc(d)}else{h=a+118|0;j=c,k=w[((Qm(h,h+10|0,e)-a|0)+a|0)+10|0],t[j|0]=k;c=c+1|0;e=e+1|0;continue}break}}v[113382]=0;c=Q(2313,a+280|0,a+272|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break e}if(c){v[f>>2]=v[f>>2]|2}c=v[a+280>>2];Ob(a+144|0);Gc(b);jb=a+288|0;return c|0}e=P()|0;O()|0;break c}e=P()|0;O()|0;Gc(d)}Ob(a+144|0)}Gc(b);S(e|0);L()}L()}function ip(a,b,c,d){var e=0,f=C(0),g=C(0),h=C(0),i=0,j=0,k=C(0),l=0,m=0,n=0,o=0,p=0;e=jb-16|0;jb=e;v[e+12>>2]=u[b+792>>1]+w[b+857|0];v[e+8>>2]=u[b+794>>1]+(w[b+858|0]&127);Yd(e+12|0,0,127);Yd(e+8|0,0,127);m=a+1074312|0;Fb(e,m,1);j=Cb(e);i=v[e+12>>2];if(!j){u[b+792>>1]=0;t[b+857|0]=i;j=v[e+8>>2];u[b+794>>1]=0;t[b+858|0]=j}Fb(e,m,36);i=B(i,d+256|0);n=(i|0)/256|0;j=Cb(e);l=v[e+8>>2];a:{if(!(l|!j|(i|0)<65024)){n=-1;a=b+810|0;if(!Wf(a)){break a}if(Is(a)|x[b+808>>1]|(v[b>>2]|v[b+4>>2])){break a}a=v[b+88>>2];if(a&8192){break a}v[b+88>>2]=a&-32769;break a}v[b+88>>2]=v[b+88>>2]|32768;f=je(C(10),C(C(0-l|0)*C(.00937500037252903)));i=jb-16|0;jb=i;h=C(B(v[e+12>>2],d+256|0)>>>0);l=i;d=a;b:{if(v[a+480180>>2]!=33554432){g=C(110);k=C(C(h/(w[d+480209|0]&128?C(10240):C(12288)))+C(.25));break b}g=C(125);k=C(h*C(9227362170349807e-20))}o=l,p=Lh(C(je(C(2),k)*g)),v[o+12>>2]=p;Yd(i+12|0,120,2e4);j=v[i+12>>2];d=v[d+24620>>2];jb=i+16|0;Fb(e,m,36);h=C(C(((d|0)<j<<1?d>>>1|0:j)>>>0)*C(6.2831854820251465));c:{if(!(!Cb(e)|v[a+480208>>2]&32768)){g=C(C(y[a+24620>>2])/h);h=C(C(f+C(-1))+C(g*f));z[e>>2]=h;f=C(g*g);break c}g=C(h/C(y[a+24620>>2]));f=C(f+f);z[e>>2]=g*C(C(1)-f);zM(e,C(2));h=C(C(f-z[e>>2])/g);z[e>>2]=h;f=C(C(1)/C(g*g))}g=C(C(h+f)+C(1));h=C(C(C(f+f)+h)/g);k=C(C(16777216)/g);f=C(C(-f)/g);d:{if(w[b+865|0]==1){o=b,p=Lh(C(C(16777216)-k)),v[o+60>>2]=p;o=b,p=Lh(C(h*C(16777216))),v[o+64>>2]=p;o=b,p=Lh(C(f*C(16777216))),v[o+68>>2]=p;a=-1;break d}o=b,p=Lh(k),v[o+60>>2]=p;o=b,p=Lh(C(h*C(16777216))),v[o+64>>2]=p;o=b,p=Lh(C(f*C(16777216))),v[o+68>>2]=p;a=0;if(v[b+60>>2]){break d}v[b+60>>2]=1}v[b+72>>2]=a;if(!c){break a}v[b+44>>2]=0;v[b+48>>2]=0;v[b+52>>2]=0;v[b+56>>2]=0}jb=e+16|0;return n}function Nea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,w=0,x=0,y=0,z=0,A=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;g=jb-16|0;jb=g;a:{b:{c:{f=v[a+12>>2];h=v[a+8>>2];d:{if((f|0)<=1&h>>>0<=805306368|(f|0)<=0){if((f|0)>=-2&h>>>0>=3489660928|(f|0)>-2){break c}if((f|0)==-2&h>>>0>2147483647|f>>>0>4294967294){break d}break b}if((f|0)==1&h>>>0>2147483648|f>>>0>1){break b}}o=b+196648|0;break a}o=b+131112|0;break a}o=b+262184|0}q=v[a+16>>2];j=v[a+48>>2];k=v[a+40>>2];l=v[a+36>>2];m=v[a+44>>2];e=v[a+4>>2];i=v[a>>2];v[g+8>>2]=i;v[g+12>>2]=e;v[g>>2]=h;v[g+4>>2]=f;e:{if(d){while(1){b=e+q|0;f=t[b+4|0];e=(i>>>16&65520)+o|0;i=u[e+14>>1];h=t[b+3|0];r=u[e+12>>1];s=t[b+2|0];w=u[e+10>>1];x=t[b+1|0];y=u[e+8>>1];z=t[b|0];A=u[e+6>>1];C=t[b-1|0];D=u[e+4>>1];E=t[b-2|0];F=u[e+2>>1];G=t[b-3|0];H=u[e>>1];b=v[a+60>>2];I=b;J=b>>31;b=Yb(m,-16777216,16776704);n=v[a+64>>2];e=Yb(j,-16777216,16776704);K=v[a+72>>2];L=v[a+32>>2];M=v[c>>2];b=qma(n,n>>31,b,b>>31);n=mb;j=b;b=v[a+68>>2];p=qma(b,b>>31,e,e>>31);e=j+p|0;b=mb+n|0;b=e>>>0<p>>>0?b+1|0:b;j=e;i=(((((((B(E,F)+B(G,H)|0)+B(C,D)|0)+B(z,A)|0)+B(x,y)|0)+B(s,w)|0)+B(h,r)|0)+B(f,i)<<8)/32768<<8;e=i;f=qma(I,J,e,e>>31);e=j+f|0;b=mb+b|0;b=e>>>0<f>>>0?b+1|0:b;e=e+8388608|0;b=e>>>0<8388608?b+1|0:b;e=(b&16777215)<<8|e>>>24;b=(e|0)/256|0;l=v[a+28>>2]+l|0;f=l>>12;v[c>>2]=B(b,f)+M;k=k+L|0;h=k>>12;v[c+4>>2]=v[c+4>>2]+B(b,h);b=e-(i&K)|0;Sb(g+8|0,g);d=d-1|0;if(d){c=c+8|0;i=v[g+8>>2];e=v[g+12>>2];j=m;m=b;continue}break}i=v[g+8>>2];e=v[g+12>>2];j=m;break e}h=k>>12;f=l>>12;b=m}v[a+40>>2]=k;v[a+20>>2]=f;v[a+36>>2]=l;v[a+48>>2]=j;v[a+44>>2]=b;v[a+24>>2]=h;v[a>>2]=i;v[a+4>>2]=e;jb=g+16|0}function Mea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;h=jb-16|0;jb=h;a:{b:{c:{f=v[a+12>>2];i=v[a+8>>2];d:{if((f|0)<=1&i>>>0<=805306368|(f|0)<=0){if((f|0)>=-2&i>>>0>=3489660928|(f|0)>-2){break c}if((f|0)==-2&i>>>0>2147483647|f>>>0>4294967294){break d}break b}if((f|0)==1&i>>>0>2147483648|f>>>0>1){break b}}p=b+196648|0;break a}p=b+131112|0;break a}p=b+262184|0}r=v[a+16>>2];j=v[a+48>>2];k=v[a+40>>2];l=v[a+36>>2];m=v[a+44>>2];e=v[a+4>>2];g=v[a>>2];v[h+8>>2]=g;v[h+12>>2]=e;v[h>>2]=i;v[h+4>>2]=f;e:{if(d){while(1){b=(g>>>16&65520)+p|0;f=u[b>>1];e=(e<<1)+r|0;g=u[e-6>>1];i=u[b+2>>1];n=u[e-4>>1];s=u[b+4>>1];t=u[e-2>>1];w=u[b+6>>1];x=u[e>>1];y=u[b+8>>1];z=u[e+2>>1];A=u[b+10>>1];C=u[e+4>>1];D=u[b+12>>1];E=u[e+6>>1];F=u[b+14>>1];G=u[e+8>>1];q=v[a+60>>2];b=Yb(m,-16777216,16776704);o=v[a+64>>2];e=Yb(j,-16777216,16776704);H=v[a+72>>2];I=v[a+32>>2];J=v[c>>2];b=qma(o,o>>31,b,b>>31);o=mb;j=b;n=(((((((B(i,n)+B(f,g)|0)+B(s,t)|0)+B(w,x)|0)+B(y,z)|0)+B(A,C)|0)+B(D,E)|0)+B(F,G)|0)/32768<<8;b=n;f=qma(q,q>>31,b,b>>31);g=j+f|0;b=mb+o|0;b=f>>>0>g>>>0?b+1|0:b;j=g;g=v[a+68>>2];g=qma(g,g>>31,e,e>>31);e=j+g|0;b=mb+b|0;b=e>>>0<g>>>0?b+1|0:b;e=e+8388608|0;b=e>>>0<8388608?b+1|0:b;e=(b&16777215)<<8|e>>>24;b=(e|0)/256|0;l=v[a+28>>2]+l|0;f=l>>12;v[c>>2]=B(b,f)+J;k=k+I|0;i=k>>12;v[c+4>>2]=v[c+4>>2]+B(b,i);b=e-(n&H)|0;Sb(h+8|0,h);d=d-1|0;if(d){c=c+8|0;g=v[h+8>>2];e=v[h+12>>2];j=m;m=b;continue}break}g=v[h+8>>2];e=v[h+12>>2];j=m;break e}i=k>>12;f=l>>12;b=m}v[a+40>>2]=k;v[a+20>>2]=f;v[a+36>>2]=l;v[a+48>>2]=j;v[a+44>>2]=b;v[a+24>>2]=i;v[a>>2]=g;v[a+4>>2]=e;jb=h+16|0}function yea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,w=0,x=0,y=0;f=jb-48|0;jb=f;s=v[a+16>>2];g=v[a+44>>2];v[f+32>>2]=g;e=v[a+48>>2];v[f+36>>2]=e;k=v[a+52>>2];v[f+40>>2]=k;m=v[a+56>>2];v[f+44>>2]=m;w=v[a+24>>2];x=v[a+20>>2];l=v[a+4>>2];i=v[a>>2];v[f+24>>2]=i;v[f+28>>2]=l;h=v[a+12>>2];v[f+16>>2]=v[a+8>>2];v[f+20>>2]=h;if(d){while(1){h=(((l&2147483647)<<1|i>>>31)&-2)+s|0;m=1;e=(((i>>>16|0)+4&131064)<<1)+b|0;i=u[e+38>>1];j=u[e+36>>1];o=u[e+34>>1];p=u[e+32>>1];q=u[e+30>>1];n=u[e+28>>1];r=u[e+26>>1];y=u[e+24>>1];k=0;e=1;g=0;while(1){v[(f+8|0)+(g<<2)>>2]=(((((B(t[h+(g|4)|0],o)+B(t[h+(g|2)|0],p)|0)+B(t[h+(g|6)|0],j)|0)+B(i,t[h+(g|8)|0])<<8)/2|0)+((((B(t[h+(g|-4)|0],r)+B(t[h+(g|-6)|0],y)|0)+B(t[h+(g|-2)|0],n)|0)+B(t[g+h|0],q)<<8)/2|0)|0)/16384;l=e;e=0;g=1;if(l){continue}break}while(1){h=(f+8|0)+(k<<2)|0;i=v[h>>2];j=v[a+60>>2];o=j;l=(f+32|0)+(k<<3)|0;k=v[l>>2];e=Yb(k,-16777216,16776704);p=v[a+64>>2];g=Yb(v[l+4>>2],-16777216,16776704);n=v[a+68>>2];r=n;n=n>>31;v[l+4>>2]=k;k=v[a+72>>2];j=j>>31;i=i<<8;j=qma(o,j,i,i>>31);o=mb;q=h;h=j;j=qma(p,p>>31,e,e>>31);h=h+j|0;e=mb+o|0;e=h>>>0<j>>>0?e+1|0:e;j=h;h=qma(r,n,g,g>>31);g=j+h|0;e=mb+e|0;e=g>>>0<h>>>0?e+1|0:e;g=g+8388608|0;e=g>>>0<8388608?e+1|0:e;e=(e&16777215)<<8|g>>>24;v[q>>2]=(e|0)/256;v[l>>2]=e-(i&k);k=1;e=m&1;m=0;if(e){continue}break}v[c>>2]=v[c>>2]+B(v[f+8>>2],x);v[c+4>>2]=v[c+4>>2]+B(v[f+12>>2],w);Sb(f+24|0,f+16|0);d=d-1|0;if(d){c=c+8|0;i=v[f+24>>2];l=v[f+28>>2];continue}break}i=v[f+24>>2];l=v[f+28>>2];m=v[f+44>>2];k=v[f+40>>2];g=v[f+32>>2];e=v[f+36>>2]}v[a+56>>2]=m;v[a+52>>2]=k;v[a+48>>2]=e;v[a+44>>2]=g;v[a>>2]=i;v[a+4>>2]=l;jb=f+48|0}function mH(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=C(0);e=jb-48|0;jb=e;v[e+40>>2]=c;v[e+44>>2]=b;v[e+36>>2]=d;d=v[a+8>>2];v[e+28>>2]=e+36;v[e+24>>2]=e+40;b=v[e+28>>2];v[e+8>>2]=v[e+24>>2];v[e+12>>2]=b;v[e+16>>2]=a;v[e+20>>2]=e+44;b=v[e+20>>2];v[e>>2]=v[e+16>>2];v[e+4>>2]=b;c=e;a:{b:{switch(v[d+40>>2]){case 0:b=jb-80|0;jb=b;f=v[c>>2];g=v[f+4>>2];v[b+40>>2]=v[f+20>>2];i=v[f+16>>2];v[b+32>>2]=v[f+12>>2];v[b+36>>2]=i;Fo(b- -64|0,b+32|0,g);f=ie(b+48|0,v[v[c+4>>2]>>2],v[v[c+8>>2]>>2],v[v[c+12>>2]>>2]);g=v[v[c+12>>2]>>2];i=v[v[c+8>>2]>>2];v[b+24>>2]=v[b+72>>2];c=v[b+68>>2];v[b+16>>2]=v[b+64>>2];v[b+20>>2]=c;v[b+8>>2]=v[f+8>>2];c=v[f+4>>2];v[b>>2]=v[f>>2];v[b+4>>2]=c;j=b+16|0;c=b;if(g){while(1){f=0;if(i){while(1){k=A[fh(c,f,h)>>3];ec(d,f);m=Sf(j,f,h),n=C(k),z[m>>2]=n;f=f+1|0;if((i|0)!=(f|0)){continue}break}}h=h+1|0;if((g|0)!=(h|0)){continue}break}}jb=b+80|0;break a;case 2:Qw(c,zb(d));break a;case 3:i=Xg(d);b=jb-80|0;jb=b;d=v[c>>2];h=v[d+4>>2];v[b+40>>2]=v[d+20>>2];g=v[d+16>>2];v[b+32>>2]=v[d+12>>2];v[b+36>>2]=g;Fo(b- -64|0,b+32|0,h);d=ie(b+48|0,v[v[c+4>>2]>>2],v[v[c+8>>2]>>2],v[v[c+12>>2]>>2]);h=v[v[c+12>>2]>>2];g=v[v[c+8>>2]>>2];v[b+24>>2]=v[b+72>>2];c=v[b+68>>2];v[b+16>>2]=v[b+64>>2];v[b+20>>2]=c;v[b+8>>2]=v[d+8>>2];c=v[d+4>>2];v[b>>2]=v[d>>2];v[b+4>>2]=c;j=b+16|0;c=b;if(h){while(1){d=0;if(g){while(1){k=A[fh(c,d,f)>>3];Xe(i,d);l=sj(Md(k*134217728));m=Sf(j,d,f),n=C(+(l|0)*7.450580596923828e-9),z[m>>2]=n;d=d+1|0;if((g|0)!=(d|0)){continue}break}}f=f+1|0;if((h|0)!=(f|0)){continue}break}}jb=b+80|0;break a;case 1:Qw(c,zb(d));break a;default:break b}}Qw(c,zb(d))}v[a+4>>2]=v[a+4>>2]+v[e+36>>2];jb=e+48|0}function $ea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;b=jb-48|0;jb=b;s=v[a+16>>2];h=v[a+44>>2];v[b+32>>2]=h;l=v[a+48>>2];v[b+36>>2]=l;i=v[a+52>>2];v[b+40>>2]=i;g=v[a+56>>2];v[b+44>>2]=g;o=v[a+40>>2];p=v[a+36>>2];e=v[a+4>>2];j=v[a>>2];v[b+24>>2]=j;v[b+28>>2]=e;f=v[a+12>>2];v[b+16>>2]=v[a+8>>2];v[b+20>>2]=f;a:{if(d){while(1){l=1;e=((((e&2147483647)<<1|j>>>31)&2147483646)<<1)+s|0;h=(j>>>21&2040)+33120|0;j=u[h+6>>1];g=u[h+4>>1];k=u[h+2>>1];m=u[h>>1];h=0;i=1;f=0;while(1){n=(b+8|0)+(f<<2)|0;f=f<<1;v[n>>2]=(((B(u[f+e>>1],k)+B(u[e+(f|-4)>>1],m)|0)+B(g,u[e+(f|4)>>1])|0)+B(j,u[e+(f|8)>>1])|0)/16384;q=i&1;i=0;f=1;if(q){continue}break}while(1){i=(b+8|0)+(h<<2)|0;j=v[i>>2];g=v[a+60>>2];k=g;h=(b+32|0)+(h<<3)|0;m=v[h>>2];e=Yb(m,-16777216,16776704);q=v[a+64>>2];f=Yb(v[h+4>>2],-16777216,16776704);n=v[a+68>>2];t=n;n=n>>31;v[h+4>>2]=m;m=v[a+72>>2];r=g>>31;j=j<<8;g=j;g=qma(k,r,g,g>>31);k=mb;r=i;i=g;g=qma(q,q>>31,e,e>>31);i=i+g|0;e=mb+k|0;e=i>>>0<g>>>0?e+1|0:e;g=i;i=qma(t,n,f,f>>31);f=g+i|0;e=mb+e|0;e=f>>>0<i>>>0?e+1|0:e;f=f+8388608|0;e=f>>>0<8388608?e+1|0:e;e=(e&16777215)<<8|f>>>24;v[r>>2]=(e|0)/256;v[h>>2]=e-(j&m);h=1;e=l&1;l=0;if(e){continue}break}e=v[a+32>>2];p=v[a+28>>2]+p|0;f=p>>12;v[c>>2]=v[c>>2]+B(f,v[b+8>>2]);o=e+o|0;k=o>>12;v[c+4>>2]=v[c+4>>2]+B(k,v[b+12>>2]);Sb(b+24|0,b+16|0);d=d-1|0;if(d){c=c+8|0;j=v[b+24>>2];e=v[b+28>>2];continue}break}j=v[b+24>>2];e=v[b+28>>2];g=v[b+44>>2];i=v[b+40>>2];l=v[b+36>>2];h=v[b+32>>2];break a}k=o>>12;f=p>>12}v[a+40>>2]=o;v[a+20>>2]=f;v[a+36>>2]=p;v[a+56>>2]=g;v[a+52>>2]=i;v[a+48>>2]=l;v[a+44>>2]=h;v[a+24>>2]=k;v[a>>2]=j;v[a+4>>2]=e;jb=b+48|0}function D2(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;c=jb+-64|0;jb=c;f=ih(a);a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{if(mi(b)){Ho(c+56|0);break n}v[113382]=0;R(2156,c+40|0,b|0);a=v[113382];v[113382]=0;if((a|0)==1){break m}v[113382]=0;a=T(2142,c+40|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break l}v[c+56>>2]=a;qf(c+40|0)}if(mi(b)){a=b+36|0}else{a=v[c+56>>2]}e=Cd(a);v[113382]=0;R(1500,f|0,e|0);e=v[113382];v[113382]=0;if((e|0)==1){break k}h=c,i=ac(a),v[h+32>>2]=i;h=c,i=bc(a),v[h+24>>2]=i;if(Jb(c+32|0,c+24|0)){a=b+24|0;while(1){e=v[c+32>>2];b=Di(v[a>>2]+484360|0,w[e+16|0]);v[113382]=0;R(2157,c+8|0,b|0);d=v[113382];v[113382]=0;if((d|0)==1){break j}v[113382]=0;U(9,c+40|0,0,c+8|0);d=v[113382];v[113382]=0;if((d|0)==1){break i}v[113382]=0;R(1502,f|0,c+40|0);d=v[113382];v[113382]=0;if((d|0)==1){break h}yb(c+40|0);yb(c+8|0);o:{if(!Sc(JH(f))){break o}d=w[e+12|0];v[113382]=0;d=Q(509,b|0,d|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break c}if(!d){break o}d=v[a>>2];v[113382]=0;d=T(648,d|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break f}b=Zb(v[a>>2]+484344|0,x[rc(b,v[e+12>>2])>>1]);v[113382]=0;R(2158,c+8|0,b|0);b=v[113382];v[113382]=0;if((b|0)==1){break e}v[113382]=0;X(393,c+40|0,0,d|0,c+8|0);b=v[113382];v[113382]=0;if((b|0)==1){break d}b=c+40|0;Gb(JH(f),b);yb(b);yb(c+8|0)}b=c+32|0;Kk(b);if(Jb(b,c+24|0)){continue}break}}hk(c+56|0);jb=c- -64|0;return}b=P()|0;O()|0;break a}b=P()|0;O()|0;qf(c+40|0);break a}b=P()|0;O()|0;break b}b=P()|0;O()|0;break b}b=P()|0;O()|0;break g}b=P()|0;O()|0;yb(c+40|0)}yb(c+8|0);break b}b=P()|0;O()|0;break b}b=P()|0;O()|0;break b}b=P()|0;O()|0;yb(c+8|0);break b}b=P()|0;O()|0}hk(c+56|0)}gd(f);S(b|0);L()}function Dx(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0;f=jb-16|0;jb=f;e=1;a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{d=w[a|0];switch(d|0){case 0:break a;case 3:break j;case 2:break k;case 13:break l;case 5:break b;case 9:break d;case 11:break e;case 20:break f;case 1:case 6:case 7:case 8:case 10:case 12:case 14:case 15:case 16:case 17:case 18:case 19:break g;case 4:break i;default:break h}}t[a|0]=1;t[f+15|0]=64;h=b,i=w[pc(b,f+15|0)|0],t[h|0]=i;break a}d=w[b|0];if(!c){e=0;if(d&3|d>>>0>223){break a}}t[b|0]=(d&252)>>>2;t[a|0]=12;e=1;break a}d=w[b|0];if(!c){e=0;if(d&3|d>>>0>223){break a}}t[b|0]=(d&252)>>>2;t[a|0]=13;e=1;break a}g=w[b|0];if(g>>>0<240){d=0;while(1){e=w[d+26064|0];m:{n:{if(c){if(e>>>0>=g>>>0){break n}break m}if((e|0)!=(g|0)){break m}}t[a|0]=11;t[b|0]=d;e=1;break a}e=0;d=d+1|0;if((d|0)!=10){continue}break}break a}t[a|0]=11;t[b|0]=9;break a}if((d|0)==26){break c}}e=0;break a}e=0;o:{p:{q:{d=w[b|0]>>>4|0;switch(d|0){case 3:case 4:case 5:case 6:case 7:break a;case 8:break o;case 0:case 1:case 2:break p;default:break q}}if((d|0)!=15){break a}}if(!c){break a}t[b|0]=0;t[a|0]=0;e=1;break a}t[a|0]=2;t[b|0]=w[b|0]<<2&60|2;e=1;break a}e=0;c=w[b|0];if(!c){break a}d=c&15;if(!d){t[b|0]=c>>>4;t[a|0]=3;e=1;break a}g=c&240;if(!g){t[a|0]=4;e=1;break a}if((d|0)==15){t[b|0]=c>>>4;t[a|0]=5;e=1;break a}if((g|0)!=240){break a}t[b|0]=d;t[a|0]=6;e=1;break a}c=b;b=w[b|0];t[c|0]=(b|0)==255?64:b>>>2|0;t[a|0]=2;break a}r:{if(c){t[b|0]=0;break r}e=0;if(w[b|0]){break a}}t[a|0]=8;e=1;break a}s:{if(c){t[f+14|0]=w[b|0]&15;t[f+13|0]=9;d=w[pc(f+14|0,f+13|0)|0];break s}e=0;d=w[b|0];if((d&14)>>>0>9|d&240){break a}}t[b|0]=d&15;t[a|0]=8;e=1}jb=f+16|0;return e}function Ry(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=jb-32|0;jb=f;d=c&4;a:{if(!(b&4)){if(!d){break a}t[a+15|0]=w[a+16|0];b=w[a+12|0];t[a+12|0]=b&247;d=!(b&2);b=w[a+14|0];if(d|b>>>0<=w[a+13|0]){break a}if(Kb(a)>>>0<=b>>>0){break a}while(1){d=Bc(a,b);u[d>>1]=x[d>>1]+1;b=b+1|0;if(Kb(a)>>>0>b>>>0){continue}break}break a}if(d){break a}b=w[a+14|0];b:{if(b>>>0>=w[a+15|0]){break b}d=w[a+12|0];if(!(d&2)){break b}t[a+12|0]=d&251}if(!(w[a+12|0]&2)|b>>>0<=w[a+13|0]){break a}if(Kb(a)>>>0<=b>>>0){break a}d=x[Bc(a,w[a+14|0])>>1];e=Bc(a,w[a+14|0]-1|0);b=w[a+14|0];if(x[e>>1]<(d-1|0)){b=x[Bc(a,b)>>1]-1&65535;d=tp(a,b,64,64);q=f,r=ac(a),v[q+8>>2]=r;q=f,r=sp(f+8|0,w[a+14|0]),v[q+16>>2]=r;e=Hd(f+24|0,f+16|0);h=Fp(f,b,d&255);g=jb-32|0;jb=g;v[g+24>>2]=v[e>>2];b=a;d=v[a>>2];q=g,r=ac(a),v[q>>2]=r;d=d+(ut(g+24|0,g)<<2)|0;c:{d:{if(y[a+4>>2]<y[zb(a)>>2]){i=v[b+4>>2];if((i|0)!=(d|0)){break d}aR(b,h);break c}e=zb(b);e=Qn(g,ye(b,Kb(b)+1|0),d-v[b>>2]>>2,e);v[113382]=0;R(1123,e|0,h|0);l=v[113382];v[113382]=0;e:{if((l|0)==1){break e}v[113382]=0;d=W(1124,b|0,e|0,d|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break e}Th(e);break c}a=P()|0;O()|0;Th(e);S(a|0);L()}m=jb-16|0;jb=m;l=d;o=b;p=v[b+4>>2];b=(p-(d+4|0)|0)+d|0;j=oe(m,o,i-b>>2);f:{g:{if(b>>>0<i>>>0){k=v[j+4>>2];e=b;while(1){n=zb(o);v[113382]=0;U(730,n|0,k|0,e|0);n=v[113382];v[113382]=0;if((n|0)==1){break g}k=k+4|0;v[j+4>>2]=k;e=e+4|0;if(i>>>0>e>>>0){continue}break}}Mb(j);Gp(l,b,p);jb=m+16|0;break f}a=P()|0;O()|0;Mb(j);S(a|0);L()}u[d>>1]=x[h>>1];t[d+2|0]=w[h+2|0]}Pg(d);jb=g+32|0;break a}t[a+14|0]=b-1}if((c|0)!=16777216){t[a+17|0]=255}jb=f+32|0}function wba(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;k=jb-32|0;jb=k;b=a+8|0;ws(b,Ke(b));m=zb(b),n=0,v[m>>2]=n;m=b,n=jc(b),v[m>>2]=n;m=jc(b),n=0,v[m>>2]=n;v[a+32>>2]=0;v[a+36>>2]=0;e=a+4|0;v[v[e>>2]>>2]=0;v[v[e>>2]+40>>2]=v[v[a>>2]+480196>>2];v[v[e>>2]+44>>2]=v[v[a>>2]+480204>>2];v[v[e>>2]+68>>2]=v[v[a>>2]+480200>>2];c=x[v[a>>2]+480188>>1];b=k;v[b+24>>2]=0;v[b+28>>2]=0;v[b+16>>2]=0;v[b+20>>2]=0;v[b+8>>2]=0;v[b+12>>2]=0;i=b+8|0;b=i;v[b>>2]=0;v[b+4>>2]=0;t[b+21|0]=255;t[b+13|0]=0;t[b+14|0]=0;t[b+15|0]=0;t[b+16|0]=0;t[b+17|0]=0;t[b+18|0]=0;t[b+19|0]=0;t[b+20|0]=0;v[b+8>>2]=0;v[b+12>>2]=0;g=jb-16|0;jb=g;v[g+12>>2]=c;d=a+20|0;a:{if(Ye(d)>>>0>=c>>>0){m=g,n=Cd(d),v[m+8>>2]=n;c=v[d>>2];b=i;h=v[Lb(g+12|0,g+8|0)>>2];if(h){while(1){f=v[b+4>>2];v[c>>2]=v[b>>2];v[c+4>>2]=f;f=x[b+18>>1]|x[b+20>>1]<<16;l=x[b+14>>1]|x[b+16>>1]<<16;u[c+14>>1]=l;u[c+16>>1]=l>>>16;u[c+18>>1]=f;u[c+20>>1]=f>>>16;f=v[b+12>>2];v[c+8>>2]=v[b+8>>2];v[c+12>>2]=f;c=c+24|0;h=h-1|0;if(h){continue}break}}b=v[g+12>>2];c=v[g+8>>2];if(b>>>0>c>>>0){JL(d,b-c|0,i);break a}b=v[d>>2]+B(b,24)|0;Cd(d);LL(d,b);xp(d);break a}b=d;if(v[b>>2]){Cd(b);ML(b);xp(b);_o(zb(b),v[b>>2],Ye(b));m=zb(b),n=0,v[m>>2]=n;v[b>>2]=0;v[b+4>>2]=0}h=Lk(d,c);if(cT(d)>>>0<h>>>0){ld();L()}f=HL(zb(b),h);v[b>>2]=f;v[b+4>>2]=f;m=zb(b),n=B(h,24)+f|0,v[m>>2]=n;Yt(b,0);JL(d,c,i)}jb=g+16|0;if(x[v[a>>2]+480188>>1]){while(1){b=B(j,896);mn((b+v[e>>2]|0)+608|0,7,v[a>>2],j&65535,1024);t[(b+v[e>>2]|0)+1445|0]=0;t[(b+v[e>>2]|0)+1444|0]=0;t[(b+v[e>>2]|0)+1429|0]=0;t[(b+v[e>>2]|0)+1432|0]=0;t[(b+v[e>>2]|0)+1427|0]=0;j=j+1|0;if(j>>>0<x[v[a>>2]+480188>>1]){continue}break}}jb=k+32|0}function afa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,w=0;b=jb-48|0;jb=b;s=v[a+16>>2];i=v[a+44>>2];v[b+32>>2]=i;l=v[a+48>>2];v[b+36>>2]=l;h=v[a+52>>2];v[b+40>>2]=h;g=v[a+56>>2];v[b+44>>2]=g;n=v[a+40>>2];o=v[a+36>>2];e=v[a+4>>2];j=v[a>>2];v[b+24>>2]=j;v[b+28>>2]=e;f=v[a+12>>2];v[b+16>>2]=v[a+8>>2];v[b+20>>2]=f;a:{if(d){while(1){e=(((e&2147483647)<<1|j>>>31)&-2)+s|0;f=(j>>>21&2040)+33120|0;j=u[f+6>>1];g=u[f+4>>1];k=u[f+2>>1];m=u[f>>1];i=0;l=1;h=1;f=0;while(1){v[(b+8|0)+(f<<2)>>2]=(((B(t[e+f|0],k)+B(t[e+(f|-2)|0],m)|0)+B(g,t[e+(f|2)|0])|0)+B(j,t[e+(f|4)|0])<<8)/16384;p=h&1;h=0;f=1;if(p){continue}break}while(1){h=(b+8|0)+(i<<2)|0;j=v[h>>2];g=v[a+60>>2];k=g;f=(b+32|0)+(i<<3)|0;m=v[f>>2];e=Yb(m,-16777216,16776704);p=v[a+64>>2];i=Yb(v[f+4>>2],-16777216,16776704);q=v[a+68>>2];w=q;q=q>>31;v[f+4>>2]=m;m=v[a+72>>2];r=g>>31;j=j<<8;g=j;g=qma(k,r,g,g>>31);k=mb;r=h;h=g;g=qma(p,p>>31,e,e>>31);h=h+g|0;e=mb+k|0;e=h>>>0<g>>>0?e+1|0:e;g=h;h=qma(w,q,i,i>>31);i=g+h|0;e=mb+e|0;e=i>>>0<h>>>0?e+1|0:e;i=i+8388608|0;e=i>>>0<8388608?e+1|0:e;e=(e&16777215)<<8|i>>>24;v[r>>2]=(e|0)/256;v[f>>2]=e-(j&m);i=1;e=l&1;l=0;if(e){continue}break}e=v[a+32>>2];o=v[a+28>>2]+o|0;k=o>>12;v[c>>2]=v[c>>2]+B(k,v[b+8>>2]);n=e+n|0;f=n>>12;v[c+4>>2]=v[c+4>>2]+B(f,v[b+12>>2]);Sb(b+24|0,b+16|0);d=d-1|0;if(d){c=c+8|0;j=v[b+24>>2];e=v[b+28>>2];continue}break}j=v[b+24>>2];e=v[b+28>>2];g=v[b+44>>2];h=v[b+40>>2];l=v[b+36>>2];i=v[b+32>>2];break a}f=n>>12;k=o>>12}v[a+40>>2]=n;v[a+20>>2]=k;v[a+36>>2]=o;v[a+56>>2]=g;v[a+52>>2]=h;v[a+48>>2]=l;v[a+44>>2]=i;v[a+24>>2]=f;v[a>>2]=j;v[a+4>>2]=e;jb=b+48|0}function z$(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0;a=jb-384|0;jb=a;v[a+368>>2]=c;v[a+376>>2]=b;Wv(a+216|0,d,a+240|0,a+236|0,a+232|0);d=Xb(a+200|0);b=Fc(d);v[113382]=0;R(1589,d|0,b|0);b=v[113382];v[113382]=0;a:{b:{c:{if((b|0)!=1){c=kc(d,0);v[a+196>>2]=c;v[a+28>>2]=a+32;v[a+24>>2]=0;t[a+23|0]=1;t[a+22|0]=69;while(1){d:{v[113382]=0;b=Q(2344,a+376|0,a+368|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break d}if(!b){break c}if(v[a+196>>2]==(Db(d)+c|0)){b=Db(d);c=Db(d);v[113382]=0;R(1589,d|0,c<<1);c=v[113382];v[113382]=0;if((c|0)==1){break b}c=Fc(d);v[113382]=0;R(1589,d|0,c|0);c=v[113382];v[113382]=0;if((c|0)==1){break b}c=kc(d,0);v[a+196>>2]=b+c}v[113382]=0;b=T(2346,a+376|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break d}v[113382]=0;b=pr(b,a+23|0,a+22|0,c,a+196|0,v[a+236>>2],v[a+232>>2],a+216|0,a+32|0,a+28|0,a+24|0,a+240|0);g=v[113382];v[113382]=0;if((g|0)==1){break d}if(b){break c}v[113382]=0;T(2348,a+376|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){continue}}break}break b}break b}e:{if(!Db(a+216|0)|!w[a+23|0]){break e}b=v[a+28>>2];if((b-(a+32|0)|0)>159){break e}v[a+28>>2]=b+4;v[b>>2]=v[a+24>>2]}v[113382]=0;X(2333,a|0,c|0,v[a+196>>2],e|0);b=v[113382];v[113382]=0;f:{if((b|0)==1){break f}b=v[a+8>>2];c=v[a+12>>2];g=v[a+4>>2];v[f>>2]=v[a>>2];v[f+4>>2]=g;v[f+8>>2]=b;v[f+12>>2]=c;v[113382]=0;De(a+216|0,a+32|0,v[a+28>>2],e);b=v[113382];v[113382]=0;if((b|0)==1){break f}v[113382]=0;b=Q(2345,a+376|0,a+368|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break f}if(b){v[e>>2]=v[e>>2]|2}b=v[a+376>>2];yb(d);yb(a+216|0);jb=a+384|0;break a}}b=P()|0;O()|0;yb(d);yb(a+216|0);S(b|0);L()}return b|0}function O$(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0;a=jb-288|0;jb=a;v[a+272>>2]=c;v[a+280>>2]=b;_v(a+224|0,d,a+240|0,a+239|0,a+238|0);d=Xb(a+208|0);b=Fc(d);v[113382]=0;R(1589,d|0,b|0);b=v[113382];v[113382]=0;a:{b:{c:{if((b|0)!=1){c=kc(d,0);v[a+204>>2]=c;v[a+28>>2]=a+32;v[a+24>>2]=0;t[a+23|0]=1;t[a+22|0]=69;while(1){d:{v[113382]=0;b=Q(2312,a+280|0,a+272|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break d}if(!b){break c}if(v[a+204>>2]==(Db(d)+c|0)){b=Db(d);c=Db(d);v[113382]=0;R(1589,d|0,c<<1);c=v[113382];v[113382]=0;if((c|0)==1){break b}c=Fc(d);v[113382]=0;R(1589,d|0,c|0);c=v[113382];v[113382]=0;if((c|0)==1){break b}c=kc(d,0);v[a+204>>2]=b+c}v[113382]=0;b=T(2314,a+280|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break d}v[113382]=0;b=sr(b,a+23|0,a+22|0,c,a+204|0,t[a+239|0],t[a+238|0],a+224|0,a+32|0,a+28|0,a+24|0,a+240|0);g=v[113382];v[113382]=0;if((g|0)==1){break d}if(b){break c}v[113382]=0;T(2316,a+280|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){continue}}break}break b}break b}e:{if(!Db(a+224|0)|!w[a+23|0]){break e}b=v[a+28>>2];if((b-(a+32|0)|0)>159){break e}v[a+28>>2]=b+4;v[b>>2]=v[a+24>>2]}v[113382]=0;X(2333,a|0,c|0,v[a+204>>2],e|0);b=v[113382];v[113382]=0;f:{if((b|0)==1){break f}b=v[a+8>>2];c=v[a+12>>2];g=v[a+4>>2];v[f>>2]=v[a>>2];v[f+4>>2]=g;v[f+8>>2]=b;v[f+12>>2]=c;v[113382]=0;De(a+224|0,a+32|0,v[a+28>>2],e);b=v[113382];v[113382]=0;if((b|0)==1){break f}v[113382]=0;b=Q(2313,a+280|0,a+272|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break f}if(b){v[e>>2]=v[e>>2]|2}b=v[a+280>>2];yb(d);yb(a+224|0);jb=a+288|0;break a}}b=P()|0;O()|0;yb(d);yb(a+224|0);S(b|0);L()}return b|0}function eea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=jb-48|0;jb=g;o=v[a+16>>2];h=Uf(g+16|0);v[h+8>>2]=a+112;v[h+16>>2]=v[a+128>>2];s=h,t=Pf(b+327720|0,v[b+20>>2],(v[a+88>>2]&16384)>>>14|0),v[s+12>>2]=t;b=v[h+16>>2];if(b){s=h,t=Tf(a+8|0,b),v[s>>2]=t;v[h+4>>2]=mb}k=v[a+48>>2];l=v[a+40>>2];m=v[a+36>>2];n=v[a+44>>2];f=v[a+4>>2];e=v[a>>2];v[g+8>>2]=e;v[g+12>>2]=f;b=v[a+12>>2];v[g>>2]=v[a+8>>2];v[g+4>>2]=b;a:{if(d){while(1){b=0;i=b;v[g+40>>2]=e;v[g+44>>2]=b;f=(f<<1)+o|0;b:{b=v[h+16>>2];if((b|0)<=0){break b}while(1){yd(v[h+8>>2],u[(i<<1)+f>>1]/4<<16>>16);xd(v[h+8>>2],4);Sb(g+40|0,h);if((b|0)<2){break b}b=b-1|0;i=v[g+44>>2];continue}}d=d-1|0;b=v[h+8>>2];Sb(b,b+8|0);b=v[h+8>>2];e=v[b+4>>2];if(e){yd(b,u[f+(v[g+44>>2]<<1)>>1]/4<<16>>16);xd(v[h+8>>2],e);b=v[h+8>>2];e=v[b>>2];v[b>>2]=e;v[b+4>>2]=0}e=Of(b,v[h+12>>2]);i=v[a+60>>2];b=Yb(n,-16777216,16776704);j=v[a+64>>2];f=Yb(k,-16777216,16776704);p=v[a+72>>2];q=v[a+32>>2];r=v[c>>2];k=e<<8;e=k;e=qma(i,i>>31,e,e>>31);i=mb;j=qma(j,j>>31,b,b>>31);e=j+e|0;b=mb+i|0;b=e>>>0<j>>>0?b+1|0:b;i=e;e=v[a+68>>2];e=qma(e,e>>31,f,f>>31);f=i+e|0;b=mb+b|0;b=f>>>0<e>>>0?b+1|0:b;f=f+8388608|0;b=f>>>0<8388608?b+1|0:b;f=(b&16777215)<<8|f>>>24;b=(f|0)/256|0;m=v[a+28>>2]+m|0;i=m>>12;v[c>>2]=B(b,i)+r;l=l+q|0;j=l>>12;v[c+4>>2]=v[c+4>>2]+B(b,j);b=f-(p&k)|0;Sb(g+8|0,g);if(d){c=c+8|0;e=v[g+8>>2];f=v[g+12>>2];k=n;n=b;continue}break}e=v[g+8>>2];f=v[g+12>>2];k=n;break a}j=l>>12;i=m>>12;b=n}v[a+40>>2]=l;v[a+20>>2]=i;v[a+36>>2]=m;v[a+48>>2]=k;v[a+44>>2]=b;v[a+24>>2]=j;v[a>>2]=e;v[a+4>>2]=f;jb=g+48|0}function Xka(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=jb-96|0;jb=d;b=b&4095;u[d+94>>1]=b;a:{b:{c:{d:{e:{f:{g:{if(b>>>0>=81){e=((b|0)==4095?c:b-80|0)+734016|0;c=qma(e,e>>31,1e4,0)+14780|0;b=mb;b=rma(c,c>>>0<14780?b+1|0:b,3652425,0);c=(((((b|0)/-4|0)+e|0)+B(b,-365)|0)+((b|0)/100|0)|0)+((b|0)/-400|0)|0;if((c|0)<0){b=b-1|0;c=(((e+((b|0)/-4|0)|0)+B(b,-365)|0)+((b|0)/100|0)|0)+((b|0)/-400|0)|0}e=Ub(d- -64|0,10812);v[113382]=0;R(189,d+80|0,e|0);f=v[113382];v[113382]=0;h=(B(c,100)+52|0)/3060|0;h:{i:{j:{k:{l:{m:{n:{o:{if((f|0)!=1){v[113382]=0;g=b;b=h+2|0;f=(b|0)/12|0;v[d+44>>2]=g+f;R(161,d+48|0,d+44|0);g=v[113382];v[113382]=0;if((g|0)==1){break o}v[113382]=0;v[d+28>>2]=(b-B(f,12)|0)+1;R(163,d+32|0,d+28|0);b=v[113382];v[113382]=0;if((b|0)==1){break n}v[113382]=0;v[d+12>>2]=(((B(h,306)+5|0)/-10|0)+c|0)+1;R(163,d+16|0,d+12|0);b=v[113382];v[113382]=0;if((b|0)==1){break m}v[113382]=0;fa(581,a|0,d+80|0,d+48|0,d+32|0,d+16|0);a=v[113382];v[113382]=0;if((a|0)==1){break l}yb(d+16|0);yb(d+32|0);yb(d+48|0);Ib(d+80|0);yb(e);break g}b=P()|0;O()|0;break h}b=P()|0;O()|0;break i}b=P()|0;O()|0;break j}b=P()|0;O()|0;break k}b=P()|0;O()|0;yb(d+16|0)}yb(d+32|0)}yb(d+48|0)}Ib(d+80|0)}yb(e);break a}c=Ub(d,11638);v[113382]=0;R(189,d+80|0,c|0);b=v[113382];v[113382]=0;if((b|0)==1){break f}v[113382]=0;R(582,d+48|0,d+94|0);b=v[113382];v[113382]=0;if((b|0)==1){break e}v[113382]=0;U(217,a|0,d+80|0,d+48|0);a=v[113382];v[113382]=0;if((a|0)==1){break d}yb(d+48|0);Ib(d+80|0);yb(c)}jb=d+96|0;return}b=P()|0;O()|0;break b}b=P()|0;O()|0;break c}b=P()|0;O()|0;yb(d+48|0)}Ib(d+80|0)}yb(c)}S(b|0);L()}function f$(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var f=0,g=0,h=0,i=0,j=0,k=0,l=0;f=jb-384|0;jb=f;v[f+376>>2]=37;v[f+380>>2]=0;h=or(f+376|1,17540,v[c+4>>2]);v[f+332>>2]=f+336;a=ge();a:{if(h){i=v[c+8>>2];A[f+40>>3]=e;v[f+32>>2]=i;a=df(f+336|0,30,a,f+376|0,f+32|0);break a}A[f+48>>3]=e;a=df(f+336|0,30,a,f+376|0,f+48|0)}v[f+80>>2]=2310;i=Ld(f+320|0,0,f+80|0);j=f+336|0;g=j;b:{c:{d:{if((a|0)>=30){e:{if(h){v[113382]=0;a=da(2335)|0;g=v[113382];v[113382]=0;if((g|0)==1){break c}v[f>>2]=v[c+8>>2];v[113382]=0;A[f+8>>3]=e;a=aa(2358,f+332|0,a|0,f+376|0,f|0)|0;g=v[113382];v[113382]=0;if((g|0)!=1){break e}break c}v[113382]=0;a=da(2335)|0;g=v[113382];v[113382]=0;if((g|0)==1){break c}A[f+16>>3]=e;v[113382]=0;a=aa(2358,f+332|0,a|0,f+376|0,f+16|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break c}}if((a|0)==-1){v[113382]=0;Y(2311);a=v[113382];v[113382]=0;if((a|0)==1){break c}break d}ve(i,v[f+332>>2]);g=v[f+332>>2]}h=a+g|0;k=ug(g,h,c);v[f+68>>2]=2310;g=Ld(f+72|0,0,f+68|0);f:{g:{if(v[f+332>>2]==(f+336|0)){a=f+80|0;break g}a=kd(a<<3);if(!a){v[113382]=0;Y(2311);a=v[113382];v[113382]=0;if((a|0)!=1){break d}c=P()|0;O()|0;break f}ve(g,a);j=v[f+332>>2]}v[113382]=0;Ac(f+56|0,c);l=v[113382];v[113382]=0;h:{i:{if((l|0)!=1){v[113382]=0;ja(2369,j|0,k|0,h|0,a|0,f+68|0,f- -64|0,f+56|0);h=v[113382];v[113382]=0;if((h|0)==1){break i}Ob(f+56|0);v[113382]=0;a=ka(2370,b|0,a|0,v[f+68>>2],v[f+64>>2],c|0,d|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break h}Gc(g);Gc(i);jb=f+384|0;return a|0}c=P()|0;O()|0;break f}c=P()|0;O()|0;Ob(f+56|0);break f}c=P()|0;O()|0}Gc(g);break b}L()}c=P()|0;O()|0}Gc(i);S(c|0);L()}function sD(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=jb-128|0;jb=c;a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{b=v[b>>2];l:{if(!b){Ub(a,5715);break l}if(!(b&65535)){e=Ub(c+96|0,11259);v[113382]=0;R(189,c+112|0,e|0);d=v[113382];v[113382]=0;m:{n:{o:{p:{q:{r:{if((d|0)!=1){v[113382]=0;v[c+24>>2]=b>>>24;R(190,c+80|0,c+24|0);d=v[113382];v[113382]=0;if((d|0)==1){break r}v[113382]=0;v[c+8>>2]=b>>>16&255;R(191,c- -64|0,c+8|0);b=v[113382];v[113382]=0;if((b|0)==1){break q}v[113382]=0;X(192,a|0,c+112|0,c+80|0,c- -64|0);a=v[113382];v[113382]=0;if((a|0)==1){break p}yb(c- -64|0);yb(c+80|0);Ib(c+112|0);yb(e);break l}b=P()|0;O()|0;break m}b=P()|0;O()|0;break n}b=P()|0;O()|0;break o}b=P()|0;O()|0;yb(c- -64|0)}yb(c+80|0)}Ib(c+112|0)}break a}e=Ub(c+48|0,10664);v[113382]=0;R(189,c+112|0,e|0);d=v[113382];v[113382]=0;if((d|0)==1){break k}v[113382]=0;v[c+44>>2]=b>>>24;R(190,c+80|0,c+44|0);d=v[113382];v[113382]=0;if((d|0)==1){break j}v[113382]=0;v[c+40>>2]=b>>>16&255;R(191,c- -64|0,c+40|0);d=v[113382];v[113382]=0;if((d|0)==1){break i}v[113382]=0;v[c+20>>2]=b>>>8&255;R(191,c+24|0,c+20|0);d=v[113382];v[113382]=0;if((d|0)==1){break h}v[113382]=0;v[c+4>>2]=b&255;R(191,c+8|0,c+4|0);b=v[113382];v[113382]=0;if((b|0)==1){break g}v[113382]=0;ma(193,a|0,c+112|0,c+80|0,c- -64|0,c+24|0,c+8|0);a=v[113382];v[113382]=0;if((a|0)==1){break f}yb(c+8|0);yb(c+24|0);yb(c- -64|0);yb(c+80|0);Ib(c+112|0);yb(e)}jb=c+128|0;return}b=P()|0;O()|0;break a}b=P()|0;O()|0;break b}b=P()|0;O()|0;break c}b=P()|0;O()|0;break d}b=P()|0;O()|0;break e}b=P()|0;O()|0;yb(c+8|0)}yb(c+24|0)}yb(c- -64|0)}yb(c+80|0)}Ib(c+112|0)}yb(e);S(b|0);L()}function q$(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var f=0,g=0,h=0,i=0,j=0,k=0,l=0;f=jb-208|0;jb=f;v[f+200>>2]=37;v[f+204>>2]=0;h=or(f+200|1,17540,v[c+4>>2]);v[f+156>>2]=f+160;a=ge();a:{if(h){i=v[c+8>>2];A[f+40>>3]=e;v[f+32>>2]=i;a=df(f+160|0,30,a,f+200|0,f+32|0);break a}A[f+48>>3]=e;a=df(f+160|0,30,a,f+200|0,f+48|0)}v[f+80>>2]=2310;i=Ld(f+144|0,0,f+80|0);j=f+160|0;g=j;b:{c:{d:{if((a|0)>=30){e:{if(h){v[113382]=0;a=da(2335)|0;g=v[113382];v[113382]=0;if((g|0)==1){break c}v[f>>2]=v[c+8>>2];v[113382]=0;A[f+8>>3]=e;a=aa(2358,f+156|0,a|0,f+200|0,f|0)|0;g=v[113382];v[113382]=0;if((g|0)!=1){break e}break c}v[113382]=0;a=da(2335)|0;g=v[113382];v[113382]=0;if((g|0)==1){break c}A[f+16>>3]=e;v[113382]=0;a=aa(2358,f+156|0,a|0,f+200|0,f+16|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break c}}if((a|0)==-1){v[113382]=0;Y(2311);a=v[113382];v[113382]=0;if((a|0)==1){break c}break d}ve(i,v[f+156>>2]);g=v[f+156>>2]}h=a+g|0;k=ug(g,h,c);v[f+68>>2]=2310;g=Ld(f+72|0,0,f+68|0);f:{g:{if(v[f+156>>2]==(f+160|0)){a=f+80|0;break g}a=kd(a<<1);if(!a){v[113382]=0;Y(2311);a=v[113382];v[113382]=0;if((a|0)!=1){break d}c=P()|0;O()|0;break f}ve(g,a);j=v[f+156>>2]}v[113382]=0;Ac(f+56|0,c);l=v[113382];v[113382]=0;h:{i:{if((l|0)!=1){v[113382]=0;ja(2359,j|0,k|0,h|0,a|0,f+68|0,f- -64|0,f+56|0);h=v[113382];v[113382]=0;if((h|0)==1){break i}Ob(f+56|0);v[113382]=0;a=ka(17,b|0,a|0,v[f+68>>2],v[f+64>>2],c|0,d|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break h}Gc(g);Gc(i);jb=f+208|0;return a|0}c=P()|0;O()|0;break f}c=P()|0;O()|0;Ob(f+56|0);break f}c=P()|0;O()|0}Gc(g);break b}L()}c=P()|0;O()|0}Gc(i);S(c|0);L()}function Rha(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=jb-16|0;jb=e;a:{if(!Rb(a,2)){Og(c+484344|0,b,64);break a}j=c+484344|0;h=Ed(Zp(a),1,1024);if(!Og(j,b,h)|!h){break a}k=x[c+480188>>1];while(1){m=Mn(Zb(j,b),i);g=0;if(k){while(1){d=e+8|0;Ul(d,a);n=Zc(d);o=Cf(d);c=B(g,6)+m|0;f=w[Ph(d)|0];t[c+5|0]=f;l=0;d=w[d|0];if((d-1&255)>>>0<=35){t[c|0]=d+48;l=w[n|0]+1|0}d=c+5|0;t[c+1|0]=l;b:{c:{d:{switch(w[o|0]){case 1:t[c+3|0]=2;t[d|0]=f&15;break b;case 2:t[c+3|0]=3;t[d|0]=f&15;break b;case 12:if(!f){break b}t[c+3|0]=1;break b;case 13:if(!f){break b}t[c+3|0]=36;t[e+7|0]=15;p=d,q=w[pc(e+7|0,d)|0]|16,t[p|0]=q;break b;case 30:if(!f){break b}t[c+3|0]=35;t[e+6|0]=15;p=d,q=w[pc(e+6|0,d)|0]|16,t[p|0]=q;break b;case 21:if(!f){break b}t[c+3|0]=36;t[e+5|0]=15;p=d,q=w[pc(e+5|0,d)|0]|80,t[p|0]=q;break b;case 17:if(!f){break b}t[c+3|0]=35;t[e+4|0]=15;p=d,q=w[pc(e+4|0,d)|0]|80,t[p|0]=q;break b;case 15:t[c+3|0]=19;t[d|0]=(f|0)!=0;break b;case 25:t[c+3|0]=12;break b;case 27:it(c);t[c|0]=255;break b;case 28:t[c+3|0]=16;break b;case 31:t[c+3|0]=11;e:{f:{g:{switch(f>>>4|0){case 4:if((f|0)==64){break f}t[d|0]=f&15;break b;case 5:t[d|0]=f<<4;break b;case 6:t[e+3|0]=f&15;t[e+2|0]=14;p=d,q=w[pc(e+3|0,e+2|0)|0]|240,t[p|0]=q;break b;case 0:case 1:case 2:case 3:break f;case 7:break g;default:break e}}t[e+1|0]=f&15;t[e|0]=14;p=d,q=w[pc(e+1|0,e)|0]<<4|15,t[p|0]=q;break b}t[c+4|0]=f;t[c+2|0]=1}t[c+3|0]=0;break c;case 0:break c;default:break d}}t[c+3|0]=0}t[d|0]=0}g=g+1|0;if((k|0)!=(g|0)){continue}break}}i=i+1|0;if((i|0)!=(h|0)){continue}break}}jb=e+16|0}function RI(a){var b=C(0),c=0,d=0,e=0,f=0,g=0,h=C(0),i=C(0),k=0,l=C(0);d=jb-16|0;jb=d;k=d,l=C(jx(z[a+4216>>2])/C(Ue(v[a+16>>2])>>>0)),z[k+12>>2]=l;v[d+8>>2]=1056964608;b=C(K(C(C(Ao(C(z[pl(d+12|0,d+8|0)>>2]*C(6.2831854820251465)))*C(.4000000059604645))+C(.6000000238418579))));z[a+4236>>2]=b;z[a+4240>>2]=K(C(C(1)-C(b*b)));f=a;b=C(C(z[a+4212>>2]*C(29))+C(2));a:{if(b<C(4294967296)&b>=C(0)){c=~~b>>>0;break a}c=0}t[f+4272|0]=c;f=a;e=2;b:{if(c>>>0<4){break b}e=3;if(c>>>0<8){break b}e=c>>>0<16?4:5}t[f+4273|0]=e;h=je(C(10),C(C(C(z[a+4208>>2]*C(60))+C(-60))*C(.05000000074505806)));k=d,l=C(jx(z[a+4220>>2])/C(Ue(v[a+16>>2])>>>0)),z[k+12>>2]=l;v[d+8>>2]=1056964608;i=z[pl(d+12|0,d+8|0)>>2];k=d,l=C(jx(z[a+4224>>2])/C(Ue(v[a+16>>2])>>>0)),z[k+12>>2]=l;v[d+8>>2]=1056964608;b=C(z[pl(d+12|0,d+8|0)>>2]*C(3.1415927410125732));e=jb-16|0;jb=e;f=(p(b),j(2));c=f&2147483647;c:{if(c>>>0<=1061752794){if(c>>>0<964689920){break c}b=Fm(+b,0);break c}if(c>>>0<=1081824209){g=+b;if(c>>>0<=1075235811){b=Fm(((f|0)>=0?-1.5707963267948966:1.5707963267948966)+g,1);break c}b=Fm(((f|0)>=0?-3.141592653589793:3.141592653589793)+g,0);break c}if(c>>>0<=1088565717){g=+b;if(c>>>0<=1085271519){b=Fm(((f|0)>=0?-4.71238898038469:4.71238898038469)+g,1);break c}b=Fm(((f|0)>=0?-6.283185307179586:6.283185307179586)+g,0);break c}if(c>>>0>=2139095040){b=C(b-b);break c}c=vw(b,e+8|0);b=Fm(A[e+8>>3],c&1)}jb=e+16|0;z[a+4268>>2]=C(C(1)-b)/C(b+C(1));b=Ao(C(i*C(6.2831854820251465)));z[a+4264>>2]=-b;h=C(h*C(K(C(C(1)-C(b*b)))));b=z[a+4268>>2];z[a+4260>>2]=C(h*C(K(C(C(1)-C(b*b)))))*z[(w[a+4272|0]<<2)+36272>>2];jb=d+16|0}function jh(a,b,c){var d=0,e=0,f=0,g=0,h=0;g=jb-16|0;jb=g;a:{if((b|0)==189){t[a+3843|0]=c>>>7;t[a+3844|0]=c>>>6&1;break a}d=b&224;if(!d){if((b|0)!=8){if((b|0)!=260){break a}d=1;b=0;while(1){e=B(b>>>0<3?b:b+6|0,44)+a|0;f=e+148|0;e=e+16|0;h=c&d;b:{if(h){gn(e,f);break b}gn(e,0)}t[f+40|0]=!h;d=d<<1&510;b=b+1|0;if((b|0)!=6){continue}break}break a}t[a+3842|0]=c>>>6&1;b=0;while(1){Ky((B(b,44)+a|0)+16|0);b=b+1|0;if((b|0)!=18){continue}break}break a}if((d-160&65535)>>>0<=32){d=b&15;if(d>>>0>8){break a}d=(B(b&256?d+9|0:d,44)+a|0)+16|0;v[g+8>>2]=d;f=v[d+36>>2];v[g+12>>2]=f;a=1;e=f?2:1;c:{b=b&240;if((b|0)!=160){if((b|0)==192){break c}if((b|0)!=176){break a}a=c&32;qN(d,a>>>5|0);h=c>>>2&7;oN(d,h);c=c&3;nN(d,c);if(!f){break a}b=1;d=(a|0)!=0;while(1){a=v[(g+8|0)+(b<<2)>>2];qN(a,d);oN(a,h);nN(a,c);b=b+1|0;if((e|0)!=(b|0)){continue}break}break a}mN(d,c);if(!f){break a}while(1){mN(v[(g+8|0)+(a<<2)>>2],c);a=a+1|0;if((e|0)!=(a|0)){continue}break}break a}t[d+42|0]=(c&32)>>>5;t[d+41|0]=(c&16)>>>4;a=c>>>1&7;u[d+30>>1]=a?9-a|0:0;u[d+32>>1]=c&1;break a}if((d|0)!=224&d>>>0>=129|-4144960>>>b&1){break a}e=a;a=t[(b&31)+25680|0];a=(e+B(b&256?a+18|0:a,84)|0)+808|0;d:{switch(d-32>>>5|0){case 0:t[a+79|0]=c>>>7;t[a+80|0]=(c&64)>>>6;t[a+78|0]=(c&32)>>>5;t[a+77|0]=(c&16)>>>4;hn(a);u[a+14>>1]=x[((c&15)<<1)+25712>>1];break a;case 1:u[a+68>>1]=w[(c>>>6|0)+17537|0];lN(a);u[a+22>>1]=(c&63)<<2;break a;case 2:u[a+24>>1]=c>>>4;hn(a);u[a+26>>1]=c&15;hn(a);break a;case 3:b=c>>>4|0;u[a+28>>1]=b>>>0<15?b<<4:496;u[a+30>>1]=c&15;hn(a);break a;case 6:break d;default:break a}}u[a+12>>1]=c&7}jb=g+16|0}function Wca(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;e=jb-48|0;jb=e;sd(b,2);d=e+16|0;Jk(d,2,a+1|0);f=e+32|0;Ec(f,d);v[113382]=0;Q(336,b+43|0,f|0)|0;d=v[113382];v[113382]=0;if((d|0)!=1){yb(e+32|0);a:{if(!(w[a|0]?w[a|0]!=1:0)){if(w[a|0]==1){d=a+16|0;v[b>>2]=w[d|0]|w[d+1|0]<<8|(w[d+2|0]<<16|w[d+3|0]<<24);d=a+20|0;v[e+32>>2]=w[d|0]|w[d+1|0]<<8|(w[d+2|0]<<16|w[d+3|0]<<24);v[e+16>>2]=v[b>>2]-1;f=e+32|0;h=b,i=v[Lb(f,e+16|0)>>2],v[h+4>>2]=i;d=a+24|0;v[e+32>>2]=w[d|0]|w[d+1|0]<<8|(w[d+2|0]<<16|w[d+3|0]<<24);h=b,i=v[Lb(f,b)>>2],v[h+8>>2]=i;u[b+34>>1]=x[b+34>>1]&65533|w[a+31|0]<<1&2}d=v[b+8>>2];if(d>>>0>=2&d>>>0>y[b+4>>2]){break a}u[b+34>>1]=0;v[b+4>>2]=0;v[b+8>>2]=0;break a}if(w[a|0]!=2){break a}f=e+16|0;xh(f,a+16|0);d=e+32|0;g=v[f>>2];g=w[g|0]|w[g+1|0]<<8|(w[g+2|0]<<16|w[g+3|0]<<24);t[d|0]=g;t[d+1|0]=g>>>8;t[d+2|0]=g>>>16;t[d+3|0]=g>>>24;xh(f,a+20|0);g=v[e+16>>2];g=w[g|0]|w[g+1|0]<<8|(w[g+2|0]<<16|w[g+3|0]<<24);t[d+4|0]=g;t[d+5|0]=g>>>8;t[d+6|0]=g>>>16;t[d+7|0]=g>>>24;xh(f,a+24|0);f=v[e+16>>2];f=w[f|0]|w[f+1|0]<<8|(w[f+2|0]<<16|w[f+3|0]<<24);t[d+8|0]=f;t[d+9|0]=f>>>8;t[d+10|0]=f>>>16;t[d+11|0]=f>>>24;v[e+8>>2]=v[e+40>>2];d=v[e+36>>2];v[e>>2]=v[e+32>>2];v[e+4>>2]=d;rp(b,1,e)}t[e+32|0]=w[a+28|0];t[e+16|0]=64;h=b,i=w[pc(e+32|0,e+16|0)|0]<<2,u[h+30>>1]=i;d=a+32|0;d=w[d|0]|w[d+1|0]<<8|(w[d+2|0]<<16|w[d+3|0]<<24);v[b+24>>2]=d;b=b+24|0;b:{if(!c){break b}if(w[a|0]==2){d=x[b>>1];v[b>>2]=d;break b}tc(b,65535);d=v[b>>2]}c:{d:{if(!d){a=8363;break d}a=1024;if(d>>>0>1023){break c}}v[b>>2]=a}jb=e+48|0;return}a=P()|0;O()|0;yb(e+32|0);S(a|0);L()}function gI(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=C(0);d=jb-48|0;jb=d;a:{b:{c:{d:{e:{switch(b-1|0){case 1:b=(c<<7)/100|0;a=a+24|0;if((b|0)==v[v[a>>2]+24604>>2]){break d}c=d+8|0;lc(c,v[a>>2]+24604|0,40);v[d+8>>2]=b;Ux(v[a>>2],c);break d;case 2:f=a+24|0;a=v[f>>2];b=a+24664|0;e=v[b+4>>2];v[d+24>>2]=v[b>>2];v[d+28>>2]=e;b=a+24656|0;e=v[b+4>>2];v[d+16>>2]=v[b>>2];v[d+20>>2]=e;b=v[a+24652>>2];v[d+8>>2]=v[a+24648>>2];v[d+12>>2]=b;e=d;g=jb-16|0;jb=g;b=3;f:{g:{h:{a=c;if(!a|(a|0)>7){break h}b=2;if((a|0)>2){break h}b=1;if((a|0)==2){break h}b=0;if((a|0)>0){break h}b=ba(8)|0;v[113382]=0;c=Q(121,g|0,6856)|0;a=v[113382];v[113382]=0;i:{if((a|0)!=1){nc(b,c);v[113382]=0;U(1978,b|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break g}a=P()|0;O()|0;yb(c);break i}a=P()|0;O()|0;ca(b|0)}S(a|0);L()}jb=g+16|0;break f}L()}t[e+8|0]=b;if(!cx(d+8|0,v[f>>2]+24648|0)){break d}Tx(v[f>>2],d+8|0);break d;case 3:b=d+8|0;a=a+24|0;lc(b,v[a>>2]+24604|0,40);e=jb-48|0;jb=e;j:{if((c|0)==-1){ul(b,v[up(e+8|0)+32>>2]);gn(b,v[up(e+8|0)+36>>2]);break j}if((c|0)<=0){ul(b,0);gn(b,0);break j}c=B(c,1e3);ul(b,c);gn(b,c)}jb=e+48|0;if(v[v[a>>2]+24636>>2]==v[d+40>>2]&v[v[a>>2]+24640>>2]==v[d+44>>2]){break d}Ux(v[a>>2],d+8|0);break d;default:b=ba(8)|0;v[113382]=0;c=Q(121,d+8|0,6473)|0;a=v[113382];v[113382]=0;if((a|0)==1){break c}nc(b,c);v[113382]=0;U(1978,b|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break a}a=P()|0;O()|0;yb(c);break b;case 0:break e}}h=a,i=je(C(10),C(C(c|0)*C(.0005000000237487257))),z[h+48>>2]=i}jb=d+48|0;return}a=P()|0;O()|0;ca(b|0)}S(a|0)}L()}function fea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0;g=jb-48|0;jb=g;o=v[a+16>>2];h=Uf(g+16|0);v[h+8>>2]=a+112;v[h+16>>2]=v[a+128>>2];s=h,u=Pf(b+327720|0,v[b+20>>2],(v[a+88>>2]&16384)>>>14|0),v[s+12>>2]=u;b=v[h+16>>2];if(b){s=h,u=Tf(a+8|0,b),v[s>>2]=u;v[h+4>>2]=mb}k=v[a+48>>2];l=v[a+40>>2];m=v[a+36>>2];n=v[a+44>>2];f=v[a+4>>2];e=v[a>>2];v[g+8>>2]=e;v[g+12>>2]=f;b=v[a+12>>2];v[g>>2]=v[a+8>>2];v[g+4>>2]=b;a:{if(d){while(1){b=0;i=b;v[g+40>>2]=e;v[g+44>>2]=b;f=f+o|0;b:{b=v[h+16>>2];if((b|0)<=0){break b}while(1){yd(v[h+8>>2],t[f+i|0]<<6);xd(v[h+8>>2],4);Sb(g+40|0,h);if((b|0)<2){break b}b=b-1|0;i=v[g+44>>2];continue}}d=d-1|0;b=v[h+8>>2];Sb(b,b+8|0);b=v[h+8>>2];e=v[b+4>>2];if(e){yd(b,t[f+v[g+44>>2]|0]<<6);xd(v[h+8>>2],e);b=v[h+8>>2];e=v[b>>2];v[b>>2]=e;v[b+4>>2]=0}e=Of(b,v[h+12>>2]);i=v[a+60>>2];b=Yb(n,-16777216,16776704);j=v[a+64>>2];f=Yb(k,-16777216,16776704);p=v[a+72>>2];q=v[a+32>>2];r=v[c>>2];k=e<<8;e=k;e=qma(i,i>>31,e,e>>31);i=mb;j=qma(j,j>>31,b,b>>31);e=j+e|0;b=mb+i|0;b=e>>>0<j>>>0?b+1|0:b;i=e;e=v[a+68>>2];e=qma(e,e>>31,f,f>>31);f=i+e|0;b=mb+b|0;b=f>>>0<e>>>0?b+1|0:b;f=f+8388608|0;b=f>>>0<8388608?b+1|0:b;f=(b&16777215)<<8|f>>>24;b=(f|0)/256|0;m=v[a+28>>2]+m|0;i=m>>12;v[c>>2]=B(b,i)+r;l=l+q|0;j=l>>12;v[c+4>>2]=v[c+4>>2]+B(b,j);b=f-(p&k)|0;Sb(g+8|0,g);if(d){c=c+8|0;e=v[g+8>>2];f=v[g+12>>2];k=n;n=b;continue}break}e=v[g+8>>2];f=v[g+12>>2];k=n;break a}j=l>>12;i=m>>12;b=n}v[a+40>>2]=l;v[a+20>>2]=i;v[a+36>>2]=m;v[a+48>>2]=k;v[a+44>>2]=b;v[a+24>>2]=j;v[a>>2]=e;v[a+4>>2]=f;jb=g+48|0}function S7(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;i=jb-16|0;jb=i;h=b+1304396|0;if(!qd(h)){d=i;f=jb-16|0;jb=f;e=Pe(12);v[113382]=0;g=T(1721,e|0)|0;c=v[113382];v[113382]=0;a:{if((c|0)!=1){c=jb-16|0;jb=c;v[113382]=0;v[c+12>>2]=g;e=f+8|0;W(1727,e|0,c+12|0,c+8|0)|0;g=v[113382];v[113382]=0;b:{if((g|0)!=1){jb=c+16|0;break b}V(0)|0;O()|0;Ab();L()}jb=f+16|0;e=v[e>>2];break a}a=P()|0;O()|0;Wb(e);S(a|0);L()}v[d+8>>2]=e;d=i+8|0;uL(h,ke(d));us(d)}d=v[h>>2];h=0;c=jb-80|0;jb=c;e=Ub(c+48|0,oL(a));v[113382]=0;R(1572,c- -64|0,e|0);f=v[113382];v[113382]=0;c:{d:{e:{f:{if((f|0)!=1){yb(e);k=c,l=ac(d),v[k+40>>2]=l;k=c,l=bc(d),v[k+32>>2]=l;if(Jb(c+40|0,c+32|0)){e=0;while(1){d=0;f=v[c+40>>2];if(v[v[f>>2]+32>>2]==(w[a+16|0]|w[a+17|0]<<8|(w[a+18|0]<<16|w[a+19|0]<<24))){d=v[v[f>>2]+36>>2]==(w[a+20|0]|w[a+21|0]<<8|(w[a+22|0]<<16|w[a+23|0]<<24))}g=v[f>>2];v[113382]=0;R(1722,c|0,g+8|0);g=v[113382];v[113382]=0;g:{h:{i:{j:{if((g|0)!=1){v[113382]=0;R(1572,c+16|0,c|0);g=v[113382];v[113382]=0;if((g|0)==1){break j}j=c+16|0;g=uf(j,c- -64|0);yb(j);yb(c);if((d&g)!=1){break h}h=v[f>>2];e=3;break g}d=P()|0;O()|0;break i}d=P()|0;O()|0;yb(c)}e=c- -64|0;break d}if((e|0)<2&d){h=v[f>>2];e=2;break g}d=g&(e|0)<=0;h=d?v[f>>2]:h;e=d?1:e}d=c+40|0;Ie(d);if(Jb(d,c+32|0)){continue}break}break f}d=0;break e}d=P()|0;O()|0;break d}d=0;if(!h){break e}e=v[h+4>>2];if(!e){break e}v[113382]=0;a=W(e|0,h|0,b|0,a|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){d=(a|0)!=0;break e}d=P()|0;e=c- -64|0;O()|0;break d}yb(c- -64|0);jb=c+80|0;break c}yb(e);S(d|0);L()}jb=i+16|0;return d|0}function pfa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;b=jb-48|0;jb=b;s=v[a+16>>2];l=v[a+44>>2];v[b+32>>2]=l;f=v[a+48>>2];v[b+36>>2]=f;j=v[a+52>>2];v[b+40>>2]=j;k=v[a+56>>2];v[b+44>>2]=k;m=v[a+40>>2];n=v[a+36>>2];e=v[a+4>>2];i=v[a>>2];v[b+24>>2]=i;v[b+28>>2]=e;g=v[a+12>>2];v[b+16>>2]=v[a+8>>2];v[b+20>>2]=g;a:{if(d){while(1){f=i>>>18|0;l=1;e=((((e&2147483647)<<1|i>>>31)&2147483646)<<1)+s|0;g=0;j=1;h=0;while(1){k=h<<1;i=u[k+e>>1];v[(b+8|0)+(h<<2)>>2]=i+((B(f,u[e+(k|4)>>1]-i|0)|0)/16384|0);i=j&1;j=0;h=1;if(i){continue}break}while(1){h=(b+8|0)+(g<<2)|0;j=v[h>>2];f=v[a+60>>2];k=f;i=(b+32|0)+(g<<3)|0;o=v[i>>2];e=Yb(o,-16777216,16776704);r=v[a+64>>2];g=Yb(v[i+4>>2],-16777216,16776704);p=v[a+68>>2];t=p;p=p>>31;v[i+4>>2]=o;o=v[a+72>>2];q=f>>31;j=j<<8;f=j;f=qma(k,q,f,f>>31);k=mb;q=h;h=f;f=qma(r,r>>31,e,e>>31);h=h+f|0;e=mb+k|0;e=h>>>0<f>>>0?e+1|0:e;f=h;h=qma(t,p,g,g>>31);g=f+h|0;e=mb+e|0;e=g>>>0<h>>>0?e+1|0:e;g=g+8388608|0;e=g>>>0<8388608?e+1|0:e;e=(e&16777215)<<8|g>>>24;v[q>>2]=(e|0)/256;v[i>>2]=e-(j&o);g=1;e=l&1;l=0;if(e){continue}break}e=v[a+32>>2];n=v[a+28>>2]+n|0;h=n>>12;v[c>>2]=v[c>>2]+B(h,v[b+8>>2]);m=e+m|0;g=m>>12;v[c+4>>2]=v[c+4>>2]+B(g,v[b+12>>2]);Sb(b+24|0,b+16|0);d=d-1|0;if(d){c=c+8|0;i=v[b+24>>2];e=v[b+28>>2];continue}break}i=v[b+24>>2];e=v[b+28>>2];k=v[b+44>>2];j=v[b+40>>2];f=v[b+36>>2];l=v[b+32>>2];break a}g=m>>12;h=n>>12}v[a+40>>2]=m;v[a+20>>2]=h;v[a+36>>2]=n;v[a+56>>2]=k;v[a+52>>2]=j;v[a+48>>2]=f;v[a+44>>2]=l;v[a+24>>2]=g;v[a>>2]=i;v[a+4>>2]=e;jb=b+48|0}function Rea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;h=jb-16|0;jb=h;a:{b:{c:{g=v[a+12>>2];j=v[a+8>>2];d:{if((g|0)<=1&j>>>0<=805306368|(g|0)<=0){if((g|0)>=-2&j>>>0>=3489660928|(g|0)>-2){break c}if((g|0)==-2&j>>>0>2147483647|g>>>0>4294967294){break d}break b}if((g|0)==1&j>>>0>2147483648|g>>>0>1){break b}}m=b+196648|0;break a}m=b+131112|0;break a}m=b+262184|0}p=v[a+16>>2];f=v[a+48>>2];q=v[a+24>>2];r=v[a+20>>2];k=v[a+44>>2];e=v[a+4>>2];i=v[a>>2];v[h+8>>2]=i;v[h+12>>2]=e;v[h>>2]=j;v[h+4>>2]=g;e:{if(!d){b=k;k=f;break e}while(1){b=(i>>>16&65520)+m|0;g=u[b>>1];e=(e<<1)+p|0;i=u[e-6>>1];j=u[b+2>>1];s=u[e-4>>1];t=u[b+4>>1];w=u[e-2>>1];x=u[b+6>>1];y=u[e>>1];z=u[b+8>>1];A=u[e+2>>1];C=u[b+10>>1];D=u[e+4>>1];E=u[b+12>>1];F=u[e+6>>1];G=u[b+14>>1];e=u[e+8>>1];o=v[a+60>>2];b=Yb(k,-16777216,16776704);l=v[a+64>>2];f=Yb(f,-16777216,16776704);H=v[a+72>>2];I=v[c>>2];b=qma(l,l>>31,b,b>>31);l=mb;n=b;i=(((((((B(j,s)+B(g,i)|0)+B(t,w)|0)+B(x,y)|0)+B(z,A)|0)+B(C,D)|0)+B(E,F)|0)+B(e,G)|0)/32768<<8;b=i;g=qma(o,o>>31,b,b>>31);e=n+g|0;b=mb+l|0;b=e>>>0<g>>>0?b+1|0:b;n=e;e=v[a+68>>2];e=qma(e,e>>31,f,f>>31);f=n+e|0;b=mb+b|0;b=e>>>0>f>>>0?b+1|0:b;f=f+8388608|0;b=f>>>0<8388608?b+1|0:b;b=(b&16777215)<<8|f>>>24;f=(b|0)/256|0;v[c>>2]=B(f,r)+I;v[c+4>>2]=v[c+4>>2]+B(f,q);b=b-(i&H)|0;Sb(h+8|0,h);d=d-1|0;if(d){c=c+8|0;i=v[h+8>>2];e=v[h+12>>2];f=k;k=b;continue}break}i=v[h+8>>2];e=v[h+12>>2]}v[a+48>>2]=k;v[a+44>>2]=b;v[a>>2]=i;v[a+4>>2]=e;jb=h+16|0}function Sea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,w=0,x=0,y=0,z=0,A=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;h=jb-16|0;jb=h;a:{b:{c:{g=v[a+12>>2];i=v[a+8>>2];d:{if((g|0)<=1&i>>>0<=805306368|(g|0)<=0){if((g|0)>=-2&i>>>0>=3489660928|(g|0)>-2){break c}if((g|0)==-2&i>>>0>2147483647|g>>>0>4294967294){break d}break b}if((g|0)==1&i>>>0>2147483648|g>>>0>1){break b}}m=b+196648|0;break a}m=b+131112|0;break a}m=b+262184|0}o=v[a+16>>2];f=v[a+48>>2];p=v[a+24>>2];q=v[a+20>>2];k=v[a+44>>2];e=v[a+4>>2];j=v[a>>2];v[h+8>>2]=j;v[h+12>>2]=e;v[h>>2]=i;v[h+4>>2]=g;e:{if(!d){b=k;k=f;break e}while(1){b=e+o|0;g=t[b+4|0];e=(j>>>16&65520)+m|0;j=u[e+14>>1];i=t[b+3|0];r=u[e+12>>1];s=t[b+2|0];w=u[e+10>>1];x=t[b+1|0];y=u[e+8>>1];z=t[b|0];A=u[e+6>>1];C=t[b-1|0];D=u[e+4>>1];E=t[b-2|0];F=u[e+2>>1];G=t[b-3|0];e=u[e>>1];b=v[a+60>>2];H=b;I=b>>31;b=Yb(k,-16777216,16776704);l=v[a+64>>2];f=Yb(f,-16777216,16776704);J=v[a+72>>2];K=v[c>>2];b=qma(l,l>>31,b,b>>31);l=mb;L=b;b=v[a+68>>2];n=qma(b,b>>31,f,f>>31);f=L+n|0;b=mb+l|0;b=f>>>0<n>>>0?b+1|0:b;e=(((((((B(E,F)+B(e,G)|0)+B(C,D)|0)+B(z,A)|0)+B(x,y)|0)+B(s,w)|0)+B(i,r)|0)+B(g,j)<<8)/32768<<8;g=qma(H,I,e,e>>31);f=f+g|0;b=mb+b|0;b=f>>>0<g>>>0?b+1|0:b;f=f+8388608|0;b=f>>>0<8388608?b+1|0:b;b=(b&16777215)<<8|f>>>24;f=(b|0)/256|0;v[c>>2]=B(f,q)+K;v[c+4>>2]=v[c+4>>2]+B(f,p);b=b-(e&J)|0;Sb(h+8|0,h);d=d-1|0;if(d){c=c+8|0;j=v[h+8>>2];e=v[h+12>>2];f=k;k=b;continue}break}j=v[h+8>>2];e=v[h+12>>2]}v[a+48>>2]=k;v[a+44>>2]=b;v[a>>2]=j;v[a+4>>2]=e;jb=h+16|0}function B$(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=C(0);a=jb-368|0;jb=a;v[a+352>>2]=c;v[a+360>>2]=b;Wv(a+200|0,d,a+224|0,a+220|0,a+216|0);d=Xb(a+184|0);b=Fc(d);v[113382]=0;R(1589,d|0,b|0);b=v[113382];v[113382]=0;a:{b:{c:{if((b|0)!=1){c=kc(d,0);v[a+180>>2]=c;v[a+12>>2]=a+16;v[a+8>>2]=0;t[a+7|0]=1;t[a+6|0]=69;while(1){d:{v[113382]=0;b=Q(2344,a+360|0,a+352|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break d}if(!b){break c}if(v[a+180>>2]==(Db(d)+c|0)){b=Db(d);c=Db(d);v[113382]=0;R(1589,d|0,c<<1);c=v[113382];v[113382]=0;if((c|0)==1){break b}c=Fc(d);v[113382]=0;R(1589,d|0,c|0);c=v[113382];v[113382]=0;if((c|0)==1){break b}c=kc(d,0);v[a+180>>2]=b+c}v[113382]=0;b=T(2346,a+360|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break d}v[113382]=0;b=pr(b,a+7|0,a+6|0,c,a+180|0,v[a+220>>2],v[a+216>>2],a+200|0,a+16|0,a+12|0,a+8|0,a+224|0);g=v[113382];v[113382]=0;if((g|0)==1){break d}if(b){break c}v[113382]=0;T(2348,a+360|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){continue}}break}break b}break b}e:{if(!Db(a+200|0)|!w[a+7|0]){break e}b=v[a+12>>2];if((b-(a+16|0)|0)>159){break e}v[a+12>>2]=b+4;v[b>>2]=v[a+8>>2]}v[113382]=0;h=C(wa(2329,c|0,v[a+180>>2],e|0));b=v[113382];v[113382]=0;f:{if((b|0)==1){break f}z[f>>2]=h;v[113382]=0;De(a+200|0,a+16|0,v[a+12>>2],e);b=v[113382];v[113382]=0;if((b|0)==1){break f}v[113382]=0;b=Q(2345,a+360|0,a+352|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break f}if(b){v[e>>2]=v[e>>2]|2}b=v[a+360>>2];yb(d);yb(a+200|0);jb=a+368|0;break a}}b=P()|0;O()|0;yb(d);yb(a+200|0);S(b|0);L()}return b|0}function S$(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=C(0);a=jb-272|0;jb=a;v[a+256>>2]=c;v[a+264>>2]=b;_v(a+208|0,d,a+224|0,a+223|0,a+222|0);d=Xb(a+192|0);b=Fc(d);v[113382]=0;R(1589,d|0,b|0);b=v[113382];v[113382]=0;a:{b:{c:{if((b|0)!=1){c=kc(d,0);v[a+188>>2]=c;v[a+12>>2]=a+16;v[a+8>>2]=0;t[a+7|0]=1;t[a+6|0]=69;while(1){d:{v[113382]=0;b=Q(2312,a+264|0,a+256|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break d}if(!b){break c}if(v[a+188>>2]==(Db(d)+c|0)){b=Db(d);c=Db(d);v[113382]=0;R(1589,d|0,c<<1);c=v[113382];v[113382]=0;if((c|0)==1){break b}c=Fc(d);v[113382]=0;R(1589,d|0,c|0);c=v[113382];v[113382]=0;if((c|0)==1){break b}c=kc(d,0);v[a+188>>2]=b+c}v[113382]=0;b=T(2314,a+264|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break d}v[113382]=0;b=sr(b,a+7|0,a+6|0,c,a+188|0,t[a+223|0],t[a+222|0],a+208|0,a+16|0,a+12|0,a+8|0,a+224|0);g=v[113382];v[113382]=0;if((g|0)==1){break d}if(b){break c}v[113382]=0;T(2316,a+264|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){continue}}break}break b}break b}e:{if(!Db(a+208|0)|!w[a+7|0]){break e}b=v[a+12>>2];if((b-(a+16|0)|0)>159){break e}v[a+12>>2]=b+4;v[b>>2]=v[a+8>>2]}v[113382]=0;h=C(wa(2329,c|0,v[a+188>>2],e|0));b=v[113382];v[113382]=0;f:{if((b|0)==1){break f}z[f>>2]=h;v[113382]=0;De(a+208|0,a+16|0,v[a+12>>2],e);b=v[113382];v[113382]=0;if((b|0)==1){break f}v[113382]=0;b=Q(2313,a+264|0,a+256|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break f}if(b){v[e>>2]=v[e>>2]|2}b=v[a+264>>2];yb(d);yb(a+208|0);jb=a+272|0;break a}}b=P()|0;O()|0;yb(d);yb(a+208|0);S(b|0);L()}return b|0}function LF(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;i=jb-272|0;jb=i;f=v[b>>2];v[i+12>>2]=f;l=a?d:256;d=a?a:i+16|0;e=0;a:{b:{c:{if(!f|!l){break c}h=c>>>0>=l>>>0;if(!(h|c>>>0>32)){break b}while(1){h=h?l:c;c=c-h|0;m=0;n=jb-16|0;jb=n;d:{e:{f:{g:{g=d;if(g){if(h>>>0>=4){break g}f=h;break f}h=0;g=v[i+12>>2];f=v[g>>2];if(!f){break d}while(1){k=1;if(f>>>0>=128){m=-1;k=dk(n+12|0,f,0);if((k|0)==-1){break d}}f=v[g+4>>2];g=g+4|0;h=h+k|0;m=h;if(f){continue}break}break d}k=v[i+12>>2];f=h;while(1){j=v[k>>2];h:{if(j-1>>>0>=127){if(!j){t[g|0]=0;v[i+12>>2]=0;break e}m=-1;j=dk(g,j,0);if((j|0)==-1){break d}f=f-j|0;g=g+j|0;break h}t[g|0]=j;f=f-1|0;k=v[i+12>>2];g=g+1|0}k=k+4|0;v[i+12>>2]=k;if(f>>>0>3){continue}break}}if(f){k=v[i+12>>2];while(1){j=v[k>>2];i:{if(j-1>>>0>=127){if(!j){t[g|0]=0;v[i+12>>2]=0;break e}m=-1;j=dk(n+12|0,j,0);if((j|0)==-1){break d}if(f>>>0<j>>>0){break e}dk(g,v[k>>2],0);f=f-j|0;g=g+j|0;break i}t[g|0]=j;f=f-1|0;k=v[i+12>>2];g=g+1|0}k=k+4|0;v[i+12>>2]=k;if(f){continue}break}}m=h;break d}m=h-f|0}jb=n+16|0;if((m|0)==-1){l=0;f=v[i+12>>2];e=-1;break c}h=(i+16|0)==(d|0)?0:m;d=h+d|0;e=e+m|0;f=v[i+12>>2];l=l-h|0;if(!f|!l){break c}h=c>>>0>=l>>>0;if(h|c>>>0>=33){continue}break}break b}if(!f){break a}}if(!l|!c){break a}h=e;while(1){j:{g=dk(d,v[f>>2],0);k:{if(g+1>>>0<=1){e=-1;if(g){break a}v[i+12>>2]=0;break k}f=v[i+12>>2]+4|0;v[i+12>>2]=f;h=g+h|0;l=l-g|0;if(l){break j}}e=h;break a}d=d+g|0;e=h;c=c-1|0;if(c){continue}break}}if(a){v[b>>2]=v[i+12>>2]}jb=i+272|0;return e|0}function A$(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;a=jb-368|0;jb=a;v[a+352>>2]=c;v[a+360>>2]=b;Wv(a+200|0,d,a+224|0,a+220|0,a+216|0);d=Xb(a+184|0);b=Fc(d);v[113382]=0;R(1589,d|0,b|0);b=v[113382];v[113382]=0;a:{b:{c:{if((b|0)!=1){c=kc(d,0);v[a+180>>2]=c;v[a+12>>2]=a+16;v[a+8>>2]=0;t[a+7|0]=1;t[a+6|0]=69;while(1){d:{v[113382]=0;b=Q(2344,a+360|0,a+352|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break d}if(!b){break c}if(v[a+180>>2]==(Db(d)+c|0)){b=Db(d);c=Db(d);v[113382]=0;R(1589,d|0,c<<1);c=v[113382];v[113382]=0;if((c|0)==1){break b}c=Fc(d);v[113382]=0;R(1589,d|0,c|0);c=v[113382];v[113382]=0;if((c|0)==1){break b}c=kc(d,0);v[a+180>>2]=b+c}v[113382]=0;b=T(2346,a+360|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break d}v[113382]=0;b=pr(b,a+7|0,a+6|0,c,a+180|0,v[a+220>>2],v[a+216>>2],a+200|0,a+16|0,a+12|0,a+8|0,a+224|0);g=v[113382];v[113382]=0;if((g|0)==1){break d}if(b){break c}v[113382]=0;T(2348,a+360|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){continue}}break}break b}break b}e:{if(!Db(a+200|0)|!w[a+7|0]){break e}b=v[a+12>>2];if((b-(a+16|0)|0)>159){break e}v[a+12>>2]=b+4;v[b>>2]=v[a+8>>2]}v[113382]=0;h=+oa(2332,c|0,v[a+180>>2],e|0);b=v[113382];v[113382]=0;f:{if((b|0)==1){break f}A[f>>3]=h;v[113382]=0;De(a+200|0,a+16|0,v[a+12>>2],e);b=v[113382];v[113382]=0;if((b|0)==1){break f}v[113382]=0;b=Q(2345,a+360|0,a+352|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break f}if(b){v[e>>2]=v[e>>2]|2}b=v[a+360>>2];yb(d);yb(a+200|0);jb=a+368|0;break a}}b=P()|0;O()|0;yb(d);yb(a+200|0);S(b|0);L()}return b|0}function qfa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0;b=jb-48|0;jb=b;q=v[a+16>>2];j=v[a+44>>2];v[b+32>>2]=j;l=v[a+48>>2];v[b+36>>2]=l;i=v[a+52>>2];v[b+40>>2]=i;k=v[a+56>>2];v[b+44>>2]=k;m=v[a+40>>2];n=v[a+36>>2];e=v[a+4>>2];h=v[a>>2];v[b+24>>2]=h;v[b+28>>2]=e;g=v[a+12>>2];v[b+16>>2]=v[a+8>>2];v[b+20>>2]=g;a:{if(d){while(1){j=h>>>10&4194048;e=(((e&2147483647)<<1|h>>>31)&-2)+q|0;f=0;l=1;i=1;g=0;while(1){h=t[e+g|0];v[(b+8|0)+(g<<2)>>2]=((B(j,t[e+(g|2)|0]-h|0)|0)/16384|0)+(h<<8);h=i&1;i=0;g=1;if(h){continue}break}while(1){i=(b+8|0)+(f<<2)|0;j=v[i>>2];k=v[a+60>>2];h=(b+32|0)+(f<<3)|0;f=v[h>>2];e=Yb(f,-16777216,16776704);p=v[a+64>>2];g=Yb(v[h+4>>2],-16777216,16776704);o=v[a+68>>2];r=o;o=o>>31;v[h+4>>2]=f;s=v[a+72>>2];j=j<<8;f=j;f=qma(k,k>>31,f,f>>31);k=mb;u=i;i=qma(p,p>>31,e,e>>31);f=i+f|0;e=mb+k|0;e=f>>>0<i>>>0?e+1|0:e;i=f;f=qma(r,o,g,g>>31);g=i+f|0;e=mb+e|0;e=g>>>0<f>>>0?e+1|0:e;g=g+8388608|0;e=g>>>0<8388608?e+1|0:e;e=(e&16777215)<<8|g>>>24;v[u>>2]=(e|0)/256;v[h>>2]=e-(j&s);f=1;e=l&1;l=0;if(e){continue}break}e=v[a+32>>2];n=v[a+28>>2]+n|0;f=n>>12;v[c>>2]=v[c>>2]+B(f,v[b+8>>2]);m=e+m|0;g=m>>12;v[c+4>>2]=v[c+4>>2]+B(g,v[b+12>>2]);Sb(b+24|0,b+16|0);d=d-1|0;if(d){c=c+8|0;h=v[b+24>>2];e=v[b+28>>2];continue}break}h=v[b+24>>2];e=v[b+28>>2];k=v[b+44>>2];i=v[b+40>>2];l=v[b+36>>2];j=v[b+32>>2];break a}g=m>>12;f=n>>12}v[a+40>>2]=m;v[a+20>>2]=f;v[a+36>>2]=n;v[a+56>>2]=k;v[a+52>>2]=i;v[a+48>>2]=l;v[a+44>>2]=j;v[a+24>>2]=g;v[a>>2]=h;v[a+4>>2]=e;jb=b+48|0}function Q$(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;a=jb-272|0;jb=a;v[a+256>>2]=c;v[a+264>>2]=b;_v(a+208|0,d,a+224|0,a+223|0,a+222|0);d=Xb(a+192|0);b=Fc(d);v[113382]=0;R(1589,d|0,b|0);b=v[113382];v[113382]=0;a:{b:{c:{if((b|0)!=1){c=kc(d,0);v[a+188>>2]=c;v[a+12>>2]=a+16;v[a+8>>2]=0;t[a+7|0]=1;t[a+6|0]=69;while(1){d:{v[113382]=0;b=Q(2312,a+264|0,a+256|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break d}if(!b){break c}if(v[a+188>>2]==(Db(d)+c|0)){b=Db(d);c=Db(d);v[113382]=0;R(1589,d|0,c<<1);c=v[113382];v[113382]=0;if((c|0)==1){break b}c=Fc(d);v[113382]=0;R(1589,d|0,c|0);c=v[113382];v[113382]=0;if((c|0)==1){break b}c=kc(d,0);v[a+188>>2]=b+c}v[113382]=0;b=T(2314,a+264|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break d}v[113382]=0;b=sr(b,a+7|0,a+6|0,c,a+188|0,t[a+223|0],t[a+222|0],a+208|0,a+16|0,a+12|0,a+8|0,a+224|0);g=v[113382];v[113382]=0;if((g|0)==1){break d}if(b){break c}v[113382]=0;T(2316,a+264|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){continue}}break}break b}break b}e:{if(!Db(a+208|0)|!w[a+7|0]){break e}b=v[a+12>>2];if((b-(a+16|0)|0)>159){break e}v[a+12>>2]=b+4;v[b>>2]=v[a+8>>2]}v[113382]=0;h=+oa(2332,c|0,v[a+188>>2],e|0);b=v[113382];v[113382]=0;f:{if((b|0)==1){break f}A[f>>3]=h;v[113382]=0;De(a+208|0,a+16|0,v[a+12>>2],e);b=v[113382];v[113382]=0;if((b|0)==1){break f}v[113382]=0;b=Q(2313,a+264|0,a+256|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break f}if(b){v[e>>2]=v[e>>2]|2}b=v[a+264>>2];yb(d);yb(a+208|0);jb=a+272|0;break a}}b=P()|0;O()|0;yb(d);yb(a+208|0);S(b|0);L()}return b|0}function RJ(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=jb-16|0;jb=h;a:{if((b|0)==(c|0)){break a}v[h+12>>2]=-1953789045;OJ(b,c,h+12|0);d=c-b>>2;v[h+8>>2]=d;n=Kb(a);g=n+1|0;v[h+4>>2]=g;k=v[Vc(h+4|0,h+8|0)>>2];j=v[((v[h+8>>2]<<2)+b|0)-4>>2];c=d;e=c;f=11;b:{if(c>>>0>622){break b}f=7;if(d>>>0>67){break b}f=5;if(d>>>0>38){break b}f=3;if(d>>>0>6){break b}f=d-1>>>1|0}l=e-f>>>1|0;c=(l<<2)+b|0;e=B(js(j^(v[c>>2]^v[b>>2])),1664525);v[c>>2]=e+v[c>>2];o=l+f|0;c=(o<<2)+b|0;d=c;f=v[c>>2];c=e+n|0;v[d>>2]=f+c;v[b>>2]=c;if(n){m=v[h+8>>2];c=1;while(1){e=c-1|0;d=((c+l>>>0)%(m>>>0)<<2)+b|0;f=(c>>>0)%(m>>>0)|0;i=(f<<2)+b|0;p=B(js(v[((e>>>0)%(m>>>0)<<2)+b>>2]^(v[d>>2]^v[i>>2])),1664525);v[d>>2]=p+v[d>>2];d=Pb(a,e);m=v[h+8>>2];e=((c+o>>>0)%(m>>>0)<<2)+b|0;j=e;q=v[e>>2];e=v[d>>2]+(f+p|0)|0;v[j>>2]=q+e;v[i>>2]=e;c=c+1|0;if(n>>>0>=c>>>0){continue}break}}c=v[h+8>>2];if(g>>>0<k>>>0){while(1){a=((g+l>>>0)%(c>>>0)<<2)+b|0;d=(g>>>0)%(c>>>0)|0;e=(d<<2)+b|0;i=B(js(v[((g-1>>>0)%(c>>>0)<<2)+b>>2]^(v[a>>2]^v[e>>2])),1664525);v[a>>2]=i+v[a>>2];c=v[h+8>>2];a=((g+o>>>0)%(c>>>0)<<2)+b|0;f=a;j=v[a>>2];a=d+i|0;v[f>>2]=j+a;v[e>>2]=a;g=g+1|0;if((k|0)!=(g|0)){continue}break}}if(c+k>>>0<=k>>>0){break a}g=k;while(1){a=((g+l>>>0)%(c>>>0)<<2)+b|0;d=(g>>>0)%(c>>>0)|0;e=(d<<2)+b|0;i=B(js(v[((g-1>>>0)%(c>>>0)<<2)+b>>2]+(v[a>>2]+v[e>>2]|0)|0),1566083941);v[a>>2]=i^v[a>>2];c=v[h+8>>2];a=((g+o>>>0)%(c>>>0)<<2)+b|0;f=a;j=v[a>>2];a=i-d|0;v[f>>2]=j^a;v[e>>2]=a;g=g+1|0;if(g>>>0<c+k>>>0){continue}break}}jb=h+16|0}function ax(a,b,c){var d=0,e=0,f=0,g=0,h=0;d=jb-208|0;jb=d;a:{b:{c:{if(w[c|0]&2){if(v[b>>2]==-2147483648){e=Fj(d+48|0,1,45);b=v[b>>2];v[113382]=0;v[d+188>>2]=b;U(136,d+192|0,d+188|0,c|0);b=v[113382];v[113382]=0;d:{e:{if((b|0)!=1){v[113382]=0;U(137,a|0,e|0,d+192|0);a=v[113382];v[113382]=0;if((a|0)==1){break e}yb(d+192|0);yb(e);break b}c=P()|0;O()|0;break d}c=P()|0;O()|0;yb(d+192|0)}yb(e);break a}e=v[b>>2];if((e|0)>=0){break c}e=Fj(d+48|0,1,45);b=v[b>>2];v[113382]=0;v[d+188>>2]=0-b;U(136,d+192|0,d+188|0,c|0);b=v[113382];v[113382]=0;f:{g:{if((b|0)!=1){v[113382]=0;U(137,a|0,e|0,d+192|0);a=v[113382];v[113382]=0;if((a|0)==1){break g}yb(d+192|0);yb(e);break b}c=P()|0;O()|0;break f}c=P()|0;O()|0;yb(d+192|0)}yb(e);break a}e=li(d+48|0);f=v[v[e>>2]-12>>2];v[113382]=0;g=da(123)|0;h=v[113382];v[113382]=0;h:{i:{j:{k:{l:{if((h|0)==1){break l}v[113382]=0;U(124,d+40|0,f+(d+48|0)|0,g|0);f=v[113382];v[113382]=0;if((f|0)==1){break l}Ob(d+40|0);v[113382]=0;R(138,e|0,c|0);f=v[113382];v[113382]=0;if((f|0)==1){break l}v[113382]=0;R(125,e|0,b|0);b=v[113382];v[113382]=0;if((b|0)==1){break l}v[113382]=0;R(126,d+8|0,e|0);b=v[113382];v[113382]=0;if((b|0)==1){break l}v[113382]=0;U(139,d+24|0,d+8|0,c|0);b=v[113382];v[113382]=0;if((b|0)==1){break k}v[113382]=0;U(140,a|0,d+24|0,c|0);a=v[113382];v[113382]=0;if((a|0)==1){break j}yb(d+24|0);yb(d+8|0);Td(e);break b}c=P()|0;O()|0;break h}c=P()|0;O()|0;break i}c=P()|0;O()|0;yb(d+24|0)}yb(d+8|0)}Td(e);break a}v[d+48>>2]=e;Wr(a,d+48|0,c)}jb=d+208|0;return}S(c|0);L()}function dfa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0;e=jb-48|0;jb=e;p=v[a+16>>2];b=v[a+44>>2];v[e+32>>2]=b;h=v[a+48>>2];v[e+36>>2]=h;f=v[a+52>>2];v[e+40>>2]=f;l=v[a+56>>2];v[e+44>>2]=l;q=v[a+24>>2];r=v[a+20>>2];g=v[a+4>>2];i=v[a>>2];v[e+24>>2]=i;v[e+28>>2]=g;j=v[a+12>>2];v[e+16>>2]=v[a+8>>2];v[e+20>>2]=j;if(d){while(1){l=1;j=((((g&2147483647)<<1|i>>>31)&2147483646)<<1)+p|0;b=(i>>>21&2040)+33120|0;i=u[b+6>>1];k=u[b+4>>1];o=u[b+2>>1];m=u[b>>1];f=0;b=1;h=0;while(1){g=h<<1;v[(e+8|0)+(h<<2)>>2]=(((B(u[g+j>>1],o)+B(u[j+(g|-4)>>1],m)|0)+B(u[j+(g|4)>>1],k)|0)+B(i,u[j+(g|8)>>1])|0)/16384;g=b;b=0;h=1;if(g){continue}break}while(1){i=(e+8|0)+(f<<2)|0;j=v[i>>2];k=v[a+60>>2];g=(e+32|0)+(f<<3)|0;f=v[g>>2];b=Yb(f,-16777216,16776704);m=v[a+64>>2];h=Yb(v[g+4>>2],-16777216,16776704);n=v[a+68>>2];s=n;n=n>>31;v[g+4>>2]=f;t=v[a+72>>2];j=j<<8;f=j;f=qma(k,k>>31,f,f>>31);k=mb;w=i;i=qma(m,m>>31,b,b>>31);f=i+f|0;b=mb+k|0;b=f>>>0<i>>>0?b+1|0:b;o=f;f=qma(s,n,h,h>>31);h=o+f|0;b=mb+b|0;b=f>>>0>h>>>0?b+1|0:b;h=h+8388608|0;b=h>>>0<8388608?b+1|0:b;b=(b&16777215)<<8|h>>>24;v[w>>2]=(b|0)/256;v[g>>2]=b-(j&t);f=1;b=l&1;l=0;if(b){continue}break}v[c>>2]=v[c>>2]+B(v[e+8>>2],r);v[c+4>>2]=v[c+4>>2]+B(v[e+12>>2],q);Sb(e+24|0,e+16|0);d=d-1|0;if(d){c=c+8|0;i=v[e+24>>2];g=v[e+28>>2];continue}break}i=v[e+24>>2];g=v[e+28>>2];l=v[e+44>>2];f=v[e+40>>2];h=v[e+36>>2];b=v[e+32>>2]}v[a+56>>2]=l;v[a+52>>2]=f;v[a+48>>2]=h;v[a+44>>2]=b;v[a>>2]=i;v[a+4>>2]=g;jb=e+48|0}function w_(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,u=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;u=jb-16|0;jb=u;v[c>>2]=a;z=d&512;A=h<<2;while(1){if((y|0)==4){if(Db(n)>>>0>1){C=u,D=Bd(n),v[C+8>>2]=D;C=c,D=wj(sp(u+8|0,1),Yj(n),v[c>>2]),v[C>>2]=D}d=d&176;if((d|0)!=16){if((d|0)==32){a=v[c>>2]}v[b>>2]=a}jb=u+16|0}else{a:{b:{switch(t[i+y|0]){case 0:v[b>>2]=v[c>>2];break a;case 1:v[b>>2]=v[c>>2];p=nr(g,32);h=v[c>>2];v[c>>2]=h+4;v[h>>2]=p;break a;case 3:if(Sc(n)){break a}p=v[ij(n,0)>>2];h=v[c>>2];v[c>>2]=h+4;v[h>>2]=p;break a;case 2:if(Sc(m)|!z){break a}C=c,D=wj(Bd(m),Yj(m),v[c>>2]),v[C>>2]=D;break a;case 4:break b;default:break a}}B=v[c>>2];e=e+A|0;h=e;while(1){c:{if(f>>>0<=h>>>0){break c}if(!Xj(g,2048,v[h>>2])){break c}h=h+4|0;continue}break}p=o;if((p|0)>0){while(1){if(!(!p|e>>>0>=h>>>0)){h=h-4|0;r=v[h>>2];q=v[c>>2];v[c>>2]=q+4;v[q>>2]=r;p=p-1|0;continue}break}if(p){x=nr(g,48)}else{x=0}q=v[c>>2];while(1){r=q+4|0;if((p|0)>0){v[q>>2]=x;p=p-1|0;q=r;continue}break}v[c>>2]=r;v[q>>2]=j}d:{if((e|0)==(h|0)){q=nr(g,48);p=v[c>>2];h=p+4|0;v[c>>2]=h;v[p>>2]=q;break d}if(Sc(l)){r=-1}else{r=t[kc(l,0)|0]}p=0;s=0;while(1){if((e|0)!=(h|0)){e:{if((p|0)!=(r|0)){q=p;break e}q=v[c>>2];v[c>>2]=q+4;v[q>>2]=k;q=0;s=s+1|0;if(Db(l)>>>0<=s>>>0){r=p;break e}if(w[kc(l,s)|0]==127){r=-1;break e}r=t[kc(l,s)|0]}h=h-4|0;x=v[h>>2];p=v[c>>2];v[c>>2]=p+4;v[p>>2]=x;p=q+1|0;continue}break}h=v[c>>2]}uo(B,h)}y=y+1|0;continue}break}}function H$(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0;a=jb-352|0;jb=a;v[a+336>>2]=c;v[a+344>>2]=b;b=ah(d);h=Bm(d,a+224|0);Am(a+208|0,d,a+332|0);d=Xb(a+192|0);c=Fc(d);v[113382]=0;R(1589,d|0,c|0);c=v[113382];v[113382]=0;a:{b:{c:{if((c|0)!=1){c=kc(d,0);v[a+188>>2]=c;v[a+12>>2]=a+16;v[a+8>>2]=0;while(1){d:{v[113382]=0;g=Q(2344,a+344|0,a+336|0)|0;i=v[113382];v[113382]=0;if((i|0)==1){break d}if(!g){break c}if(v[a+188>>2]==(Db(d)+c|0)){g=Db(d);c=Db(d);v[113382]=0;R(1589,d|0,c<<1);c=v[113382];v[113382]=0;if((c|0)==1){break b}c=Fc(d);v[113382]=0;R(1589,d|0,c|0);c=v[113382];v[113382]=0;if((c|0)==1){break b}c=kc(d,0);v[a+188>>2]=g+c}v[113382]=0;g=T(2346,a+344|0)|0;i=v[113382];v[113382]=0;if((i|0)==1){break d}v[113382]=0;g=$j(g,b,c,a+188|0,a+8|0,v[a+332>>2],a+208|0,a+16|0,a+12|0,h);i=v[113382];v[113382]=0;if((i|0)==1){break d}if(g){break c}v[113382]=0;T(2348,a+344|0)|0;g=v[113382];v[113382]=0;if((g|0)!=1){continue}}break}break b}break b}e:{if(!Db(a+208|0)){break e}h=v[a+12>>2];if((h-(a+16|0)|0)>159){break e}v[a+12>>2]=h+4;v[h>>2]=v[a+8>>2]}v[113382]=0;b=ko(2323,c,v[a+188>>2],e,b);c=mb;h=v[113382];v[113382]=0;f:{if((h|0)==1){break f}v[f>>2]=b;v[f+4>>2]=c;v[113382]=0;De(a+208|0,a+16|0,v[a+12>>2],e);b=v[113382];v[113382]=0;if((b|0)==1){break f}v[113382]=0;b=Q(2345,a+344|0,a+336|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break f}if(b){v[e>>2]=v[e>>2]|2}b=v[a+344>>2];yb(d);yb(a+208|0);jb=a+352|0;break a}}b=P()|0;O()|0;yb(d);yb(a+208|0);S(b|0);L()}return b|0}function C$(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0;a=jb-352|0;jb=a;v[a+336>>2]=c;v[a+344>>2]=b;b=ah(d);h=Bm(d,a+224|0);Am(a+208|0,d,a+332|0);d=Xb(a+192|0);c=Fc(d);v[113382]=0;R(1589,d|0,c|0);c=v[113382];v[113382]=0;a:{b:{c:{if((c|0)!=1){c=kc(d,0);v[a+188>>2]=c;v[a+12>>2]=a+16;v[a+8>>2]=0;while(1){d:{v[113382]=0;g=Q(2344,a+344|0,a+336|0)|0;i=v[113382];v[113382]=0;if((i|0)==1){break d}if(!g){break c}if(v[a+188>>2]==(Db(d)+c|0)){g=Db(d);c=Db(d);v[113382]=0;R(1589,d|0,c<<1);c=v[113382];v[113382]=0;if((c|0)==1){break b}c=Fc(d);v[113382]=0;R(1589,d|0,c|0);c=v[113382];v[113382]=0;if((c|0)==1){break b}c=kc(d,0);v[a+188>>2]=g+c}v[113382]=0;g=T(2346,a+344|0)|0;i=v[113382];v[113382]=0;if((i|0)==1){break d}v[113382]=0;g=$j(g,b,c,a+188|0,a+8|0,v[a+332>>2],a+208|0,a+16|0,a+12|0,h);i=v[113382];v[113382]=0;if((i|0)==1){break d}if(g){break c}v[113382]=0;T(2348,a+344|0)|0;g=v[113382];v[113382]=0;if((g|0)!=1){continue}}break}break b}break b}e:{if(!Db(a+208|0)){break e}h=v[a+12>>2];if((h-(a+16|0)|0)>159){break e}v[a+12>>2]=h+4;v[h>>2]=v[a+8>>2]}v[113382]=0;b=ko(2327,c,v[a+188>>2],e,b);c=mb;h=v[113382];v[113382]=0;f:{if((h|0)==1){break f}v[f>>2]=b;v[f+4>>2]=c;v[113382]=0;De(a+208|0,a+16|0,v[a+12>>2],e);b=v[113382];v[113382]=0;if((b|0)==1){break f}v[113382]=0;b=Q(2345,a+344|0,a+336|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break f}if(b){v[e>>2]=v[e>>2]|2}b=v[a+344>>2];yb(d);yb(a+208|0);jb=a+352|0;break a}}b=P()|0;O()|0;yb(d);yb(a+208|0);S(b|0);L()}return b|0}function Uda(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;c=jb+-64|0;jb=c;u[c+62>>1]=b;f=rj(a);b=f;e=c+48|0;g=ru(e);a:{if(!b){break a}v[113382]=0;R(882,e|0,b|0);h=v[113382];v[113382]=0;if((h|0)!=1){v[113382]=0;R(1137,e|0,b|0);b=v[113382];v[113382]=0;if((b|0)!=1){break a}}a=P()|0;O()|0;dq(g);S(a|0);L()}b:{c:{if(!f){break c}b=0;while(1){i=rc(e,b),j=b-d|0,u[i>>1]=j;v[113382]=0;g=Q(1134,a|0,b|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break b}d=(x[g>>1]==x[c+62>>1])+d|0;b=b+1|0;if((f|0)!=(b|0)){continue}break}if(!(d&65535)){break c}b=ac(a);d=bc(a);v[113382]=0;b=W(1135,b|0,d|0,c+62|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break b}v[c+32>>2]=b;b=Hd(c+40|0,c+32|0);i=c,j=bc(a),v[i+16>>2]=j;d=v[Hd(c+24|0,c+16|0)>>2];b=v[b>>2];v[113382]=0;W(1136,a|0,b|0,d|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break b}i=c,j=ac(a),v[i+32>>2]=j;i=c,j=bc(a),v[i+16>>2]=j;if(Jb(c+32|0,c+16|0)){while(1){b=x[v[c+32>>2]>>1];d=v[a+24>>2];v[113382]=0;d=Q(398,d+484344|0,b|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break b}d:{if(!d){break d}b=Zb(v[a+24>>2]+484344|0,b);i=c,j=ac(b),v[i+8>>2]=j;i=c,j=bc(b),v[i>>2]=j;if(!Jb(c+8|0,c)){break d}while(1){b=v[c+8>>2];e:{if(w[b+3|0]!=12){break e}d=w[b+5|0];if(oc(e)>>>0<=d>>>0){break e}i=b,j=w[rc(e,w[b+5|0])|0],t[i+5|0]=j}b=c+8|0;Bj(b);if(Jb(b,c)){continue}break}}b=c+32|0;re(b);if(Jb(b,c+16|0)){continue}break}}b=x[a+28>>1];if(oc(e)>>>0<=b>>>0){break c}i=a,j=x[rc(e,x[a+28>>1])>>1],u[i+28>>1]=j}nf(e);jb=c- -64|0;return}a=P()|0;O()|0;nf(e);S(a|0);L()}function Saa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;d=jb-48|0;jb=d;c=x[a+480190>>1];t[d+32|0]=0;PM(b,c+1|0,d+32|0);if(x[a+480192>>1]){g=tq(d+32|0);c=a+484344|0;k=d,l=ac(c),v[k+24>>2]=l;k=d,l=bc(c),v[k+16>>2]=l;if(Jb(d+24|0,d+16|0)){while(1){a:{i=v[d+24>>2];if(!qh(i)){break a}c=x[a+480188>>1];v[113382]=0;t[d|0]=0;U(1392,g|0,c|0,d|0);c=v[113382];v[113382]=0;if((c|0)!=1){b:{k=d,l=ac(i),v[k+8>>2]=l;j=0;if(!v[i+12>>2]){break a}while(1){f=0;c:{if(!x[a+480188>>1]){break c}while(1){d:{c=v[d+8>>2];v[113382]=0;c=T(516,c|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break d}e:{if(!c){break e}c=w[v[d+8>>2]+1|0];if(!c){c=w[uc(g,f)|0]}e=c&255;if(e){f:{if(e>>>0>256){break f}e=v[((w[v[d+8>>2]+1|0]<<2)+a|0)+900380>>2];if(!e){break f}e=x[_c(e+236|0,w[v[d+8>>2]]-1|0)>>1];if(e>>>0>x[a+480190>>1]){break f}_d(d,b,e);ce(d,1)}k=uc(g,f),l=c,t[k|0]=l;break e}c=x[a+480192>>1];if(!c){break e}e=c;while(1){h=v[((c<<2)+a|0)+900380>>2];g:{if(!h){break g}h=x[_c(h+236|0,w[v[d+8>>2]]-1|0)>>1];if(h>>>0>x[a+480190>>1]){break g}_d(d,b,h);ce(d,1)}c=c-1|0;e=e-1|0;if(e&65535){continue}break}}Bj(d+8|0);f=f+1|0;if(f>>>0<x[a+480188>>1]){continue}break c}break}break b}j=j+1|0;if(j>>>0<y[i+12>>2]){continue}break}break a}}a=P()|0;O()|0;$d(g);S(a|0);L()}c=d+24|0;Cy(c);if(Jb(c,d+16|0)){continue}break}}c=x[a+480190>>1];h:{if(!c){f=0;break h}f=0;e=c;while(1){_d(d,b,c);if(!Cb(d)){f=Be((B(c,104)+a|0)+484380|0)+f|0}c=c-1|0;e=e-1|0;if(e&65535){continue}break}}$d(g)}jb=d+48|0;return f&65535}function I$(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0;a=jb-352|0;jb=a;v[a+336>>2]=c;v[a+344>>2]=b;b=ah(d);h=Bm(d,a+224|0);Am(a+208|0,d,a+332|0);d=Xb(a+192|0);c=Fc(d);v[113382]=0;R(1589,d|0,c|0);c=v[113382];v[113382]=0;a:{b:{c:{if((c|0)!=1){c=kc(d,0);v[a+188>>2]=c;v[a+12>>2]=a+16;v[a+8>>2]=0;while(1){d:{v[113382]=0;g=Q(2344,a+344|0,a+336|0)|0;i=v[113382];v[113382]=0;if((i|0)==1){break d}if(!g){break c}if(v[a+188>>2]==(Db(d)+c|0)){g=Db(d);c=Db(d);v[113382]=0;R(1589,d|0,c<<1);c=v[113382];v[113382]=0;if((c|0)==1){break b}c=Fc(d);v[113382]=0;R(1589,d|0,c|0);c=v[113382];v[113382]=0;if((c|0)==1){break b}c=kc(d,0);v[a+188>>2]=g+c}v[113382]=0;g=T(2346,a+344|0)|0;i=v[113382];v[113382]=0;if((i|0)==1){break d}v[113382]=0;g=$j(g,b,c,a+188|0,a+8|0,v[a+332>>2],a+208|0,a+16|0,a+12|0,h);i=v[113382];v[113382]=0;if((i|0)==1){break d}if(g){break c}v[113382]=0;T(2348,a+344|0)|0;g=v[113382];v[113382]=0;if((g|0)!=1){continue}}break}break b}break b}e:{if(!Db(a+208|0)){break e}h=v[a+12>>2];if((h-(a+16|0)|0)>159){break e}v[a+12>>2]=h+4;v[h>>2]=v[a+8>>2]}v[113382]=0;b=aa(2319,c|0,v[a+188>>2],e|0,b|0)|0;c=v[113382];v[113382]=0;f:{if((c|0)==1){break f}v[f>>2]=b;v[113382]=0;De(a+208|0,a+16|0,v[a+12>>2],e);b=v[113382];v[113382]=0;if((b|0)==1){break f}v[113382]=0;b=Q(2345,a+344|0,a+336|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break f}if(b){v[e>>2]=v[e>>2]|2}b=v[a+344>>2];yb(d);yb(a+208|0);jb=a+352|0;break a}}b=P()|0;O()|0;yb(d);yb(a+208|0);S(b|0);L()}return b|0}function F$(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0;a=jb-352|0;jb=a;v[a+336>>2]=c;v[a+344>>2]=b;b=ah(d);h=Bm(d,a+224|0);Am(a+208|0,d,a+332|0);d=Xb(a+192|0);c=Fc(d);v[113382]=0;R(1589,d|0,c|0);c=v[113382];v[113382]=0;a:{b:{c:{if((c|0)!=1){c=kc(d,0);v[a+188>>2]=c;v[a+12>>2]=a+16;v[a+8>>2]=0;while(1){d:{v[113382]=0;g=Q(2344,a+344|0,a+336|0)|0;i=v[113382];v[113382]=0;if((i|0)==1){break d}if(!g){break c}if(v[a+188>>2]==(Db(d)+c|0)){g=Db(d);c=Db(d);v[113382]=0;R(1589,d|0,c<<1);c=v[113382];v[113382]=0;if((c|0)==1){break b}c=Fc(d);v[113382]=0;R(1589,d|0,c|0);c=v[113382];v[113382]=0;if((c|0)==1){break b}c=kc(d,0);v[a+188>>2]=g+c}v[113382]=0;g=T(2346,a+344|0)|0;i=v[113382];v[113382]=0;if((i|0)==1){break d}v[113382]=0;g=$j(g,b,c,a+188|0,a+8|0,v[a+332>>2],a+208|0,a+16|0,a+12|0,h);i=v[113382];v[113382]=0;if((i|0)==1){break d}if(g){break c}v[113382]=0;T(2348,a+344|0)|0;g=v[113382];v[113382]=0;if((g|0)!=1){continue}}break}break b}break b}e:{if(!Db(a+208|0)){break e}h=v[a+12>>2];if((h-(a+16|0)|0)>159){break e}v[a+12>>2]=h+4;v[h>>2]=v[a+8>>2]}v[113382]=0;b=aa(2324,c|0,v[a+188>>2],e|0,b|0)|0;c=v[113382];v[113382]=0;f:{if((c|0)==1){break f}u[f>>1]=b;v[113382]=0;De(a+208|0,a+16|0,v[a+12>>2],e);b=v[113382];v[113382]=0;if((b|0)==1){break f}v[113382]=0;b=Q(2345,a+344|0,a+336|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break f}if(b){v[e>>2]=v[e>>2]|2}b=v[a+344>>2];yb(d);yb(a+208|0);jb=a+352|0;break a}}b=P()|0;O()|0;yb(d);yb(a+208|0);S(b|0);L()}return b|0}function E$(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0;a=jb-352|0;jb=a;v[a+336>>2]=c;v[a+344>>2]=b;b=ah(d);h=Bm(d,a+224|0);Am(a+208|0,d,a+332|0);d=Xb(a+192|0);c=Fc(d);v[113382]=0;R(1589,d|0,c|0);c=v[113382];v[113382]=0;a:{b:{c:{if((c|0)!=1){c=kc(d,0);v[a+188>>2]=c;v[a+12>>2]=a+16;v[a+8>>2]=0;while(1){d:{v[113382]=0;g=Q(2344,a+344|0,a+336|0)|0;i=v[113382];v[113382]=0;if((i|0)==1){break d}if(!g){break c}if(v[a+188>>2]==(Db(d)+c|0)){g=Db(d);c=Db(d);v[113382]=0;R(1589,d|0,c<<1);c=v[113382];v[113382]=0;if((c|0)==1){break b}c=Fc(d);v[113382]=0;R(1589,d|0,c|0);c=v[113382];v[113382]=0;if((c|0)==1){break b}c=kc(d,0);v[a+188>>2]=g+c}v[113382]=0;g=T(2346,a+344|0)|0;i=v[113382];v[113382]=0;if((i|0)==1){break d}v[113382]=0;g=$j(g,b,c,a+188|0,a+8|0,v[a+332>>2],a+208|0,a+16|0,a+12|0,h);i=v[113382];v[113382]=0;if((i|0)==1){break d}if(g){break c}v[113382]=0;T(2348,a+344|0)|0;g=v[113382];v[113382]=0;if((g|0)!=1){continue}}break}break b}break b}e:{if(!Db(a+208|0)){break e}h=v[a+12>>2];if((h-(a+16|0)|0)>159){break e}v[a+12>>2]=h+4;v[h>>2]=v[a+8>>2]}v[113382]=0;b=aa(2325,c|0,v[a+188>>2],e|0,b|0)|0;c=v[113382];v[113382]=0;f:{if((c|0)==1){break f}v[f>>2]=b;v[113382]=0;De(a+208|0,a+16|0,v[a+12>>2],e);b=v[113382];v[113382]=0;if((b|0)==1){break f}v[113382]=0;b=Q(2345,a+344|0,a+336|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break f}if(b){v[e>>2]=v[e>>2]|2}b=v[a+344>>2];yb(d);yb(a+208|0);jb=a+352|0;break a}}b=P()|0;O()|0;yb(d);yb(a+208|0);S(b|0);L()}return b|0}function D$(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0;a=jb-352|0;jb=a;v[a+336>>2]=c;v[a+344>>2]=b;b=ah(d);h=Bm(d,a+224|0);Am(a+208|0,d,a+332|0);d=Xb(a+192|0);c=Fc(d);v[113382]=0;R(1589,d|0,c|0);c=v[113382];v[113382]=0;a:{b:{c:{if((c|0)!=1){c=kc(d,0);v[a+188>>2]=c;v[a+12>>2]=a+16;v[a+8>>2]=0;while(1){d:{v[113382]=0;g=Q(2344,a+344|0,a+336|0)|0;i=v[113382];v[113382]=0;if((i|0)==1){break d}if(!g){break c}if(v[a+188>>2]==(Db(d)+c|0)){g=Db(d);c=Db(d);v[113382]=0;R(1589,d|0,c<<1);c=v[113382];v[113382]=0;if((c|0)==1){break b}c=Fc(d);v[113382]=0;R(1589,d|0,c|0);c=v[113382];v[113382]=0;if((c|0)==1){break b}c=kc(d,0);v[a+188>>2]=g+c}v[113382]=0;g=T(2346,a+344|0)|0;i=v[113382];v[113382]=0;if((i|0)==1){break d}v[113382]=0;g=$j(g,b,c,a+188|0,a+8|0,v[a+332>>2],a+208|0,a+16|0,a+12|0,h);i=v[113382];v[113382]=0;if((i|0)==1){break d}if(g){break c}v[113382]=0;T(2348,a+344|0)|0;g=v[113382];v[113382]=0;if((g|0)!=1){continue}}break}break b}break b}e:{if(!Db(a+208|0)){break e}h=v[a+12>>2];if((h-(a+16|0)|0)>159){break e}v[a+12>>2]=h+4;v[h>>2]=v[a+8>>2]}v[113382]=0;b=aa(2326,c|0,v[a+188>>2],e|0,b|0)|0;c=v[113382];v[113382]=0;f:{if((c|0)==1){break f}v[f>>2]=b;v[113382]=0;De(a+208|0,a+16|0,v[a+12>>2],e);b=v[113382];v[113382]=0;if((b|0)==1){break f}v[113382]=0;b=Q(2345,a+344|0,a+336|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break f}if(b){v[e>>2]=v[e>>2]|2}b=v[a+344>>2];yb(d);yb(a+208|0);jb=a+352|0;break a}}b=P()|0;O()|0;yb(d);yb(a+208|0);S(b|0);L()}return b|0}function iea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=jb-48|0;jb=f;m=v[a+16>>2];h=Uf(f+16|0);v[h+8>>2]=a+112;v[h+16>>2]=v[a+128>>2];s=h,t=Pf(b+327720|0,v[b+20>>2],(v[a+88>>2]&16384)>>>14|0),v[s+12>>2]=t;b=v[h+16>>2];if(b){s=h,t=Tf(a+8|0,b),v[s>>2]=t;v[h+4>>2]=mb}i=v[a+48>>2];n=v[a+24>>2];o=v[a+20>>2];k=v[a+44>>2];e=v[a+4>>2];g=v[a>>2];v[f+8>>2]=g;v[f+12>>2]=e;b=v[a+12>>2];v[f>>2]=v[a+8>>2];v[f+4>>2]=b;a:{if(!d){b=k;k=i;break a}while(1){b=0;j=b;v[f+40>>2]=g;v[f+44>>2]=b;e=(e<<1)+m|0;b:{b=v[h+16>>2];if((b|0)<=0){break b}while(1){yd(v[h+8>>2],u[(j<<1)+e>>1]/4<<16>>16);xd(v[h+8>>2],4);Sb(f+40|0,h);if((b|0)<2){break b}b=b-1|0;j=v[f+44>>2];continue}}d=d-1|0;b=v[h+8>>2];Sb(b,b+8|0);b=v[h+8>>2];g=v[b+4>>2];if(g){yd(b,u[e+(v[f+44>>2]<<1)>>1]/4<<16>>16);xd(v[h+8>>2],g);b=v[h+8>>2];g=v[b>>2];v[b>>2]=g;v[b+4>>2]=0}e=Of(b,v[h+12>>2]);g=v[a+60>>2];j=g;b=Yb(k,-16777216,16776704);l=v[a+64>>2];i=Yb(i,-16777216,16776704);p=v[a+72>>2];q=v[c>>2];r=g>>31;g=e<<8;e=g;e=qma(j,r,e,e>>31);j=mb;l=qma(l,l>>31,b,b>>31);e=l+e|0;b=mb+j|0;b=e>>>0<l>>>0?b+1|0:b;j=e;e=v[a+68>>2];e=qma(e,e>>31,i,i>>31);i=j+e|0;b=mb+b|0;b=e>>>0>i>>>0?b+1|0:b;i=i+8388608|0;b=i>>>0<8388608?b+1|0:b;b=(b&16777215)<<8|i>>>24;i=(b|0)/256|0;v[c>>2]=B(i,o)+q;v[c+4>>2]=v[c+4>>2]+B(i,n);b=b-(g&p)|0;Sb(f+8|0,f);if(d){c=c+8|0;g=v[f+8>>2];e=v[f+12>>2];i=k;k=b;continue}break}g=v[f+8>>2];e=v[f+12>>2]}v[a+48>>2]=k;v[a+44>>2]=b;v[a>>2]=g;v[a+4>>2]=e;jb=f+48|0}function efa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,w=0,x=0;e=jb-48|0;jb=e;p=v[a+16>>2];g=v[a+44>>2];v[e+32>>2]=g;b=v[a+48>>2];v[e+36>>2]=b;f=v[a+52>>2];v[e+40>>2]=f;l=v[a+56>>2];v[e+44>>2]=l;q=v[a+24>>2];r=v[a+20>>2];i=v[a+4>>2];h=v[a>>2];v[e+24>>2]=h;v[e+28>>2]=i;j=v[a+12>>2];v[e+16>>2]=v[a+8>>2];v[e+20>>2]=j;if(d){while(1){j=(((i&2147483647)<<1|h>>>31)&-2)+p|0;b=(h>>>21&2040)+33120|0;h=u[b+6>>1];k=u[b+4>>1];o=u[b+2>>1];m=u[b>>1];f=0;l=1;b=1;g=0;while(1){v[(e+8|0)+(g<<2)>>2]=(((B(t[g+j|0],o)+B(t[j+(g|-2)|0],m)|0)+B(t[j+(g|2)|0],k)|0)+B(h,t[j+(g|4)|0])<<8)/16384;i=b;b=0;g=1;if(i){continue}break}while(1){h=(e+8|0)+(f<<2)|0;j=v[h>>2];k=v[a+60>>2];i=(e+32|0)+(f<<3)|0;f=v[i>>2];b=Yb(f,-16777216,16776704);m=v[a+64>>2];g=Yb(v[i+4>>2],-16777216,16776704);n=v[a+68>>2];s=n;n=n>>31;v[i+4>>2]=f;w=v[a+72>>2];j=j<<8;f=j;f=qma(k,k>>31,f,f>>31);k=mb;x=h;h=qma(m,m>>31,b,b>>31);f=h+f|0;b=mb+k|0;b=f>>>0<h>>>0?b+1|0:b;o=f;f=qma(s,n,g,g>>31);g=o+f|0;b=mb+b|0;b=g>>>0<f>>>0?b+1|0:b;g=g+8388608|0;b=g>>>0<8388608?b+1|0:b;b=(b&16777215)<<8|g>>>24;v[x>>2]=(b|0)/256;v[i>>2]=b-(j&w);f=1;b=l&1;l=0;if(b){continue}break}v[c>>2]=v[c>>2]+B(v[e+8>>2],r);v[c+4>>2]=v[c+4>>2]+B(v[e+12>>2],q);Sb(e+24|0,e+16|0);d=d-1|0;if(d){c=c+8|0;h=v[e+24>>2];i=v[e+28>>2];continue}break}h=v[e+24>>2];i=v[e+28>>2];l=v[e+44>>2];f=v[e+40>>2];g=v[e+32>>2];b=v[e+36>>2]}v[a+56>>2]=l;v[a+52>>2]=f;v[a+48>>2]=b;v[a+44>>2]=g;v[a>>2]=h;v[a+4>>2]=i;jb=e+48|0}function _$(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;a=jb-272|0;jb=a;v[a+256>>2]=c;v[a+264>>2]=b;b=ah(d);Dm(a+208|0,d,a+255|0);d=Xb(a+192|0);c=Fc(d);v[113382]=0;R(1589,d|0,c|0);c=v[113382];v[113382]=0;a:{b:{c:{if((c|0)!=1){c=kc(d,0);v[a+188>>2]=c;v[a+12>>2]=a+16;v[a+8>>2]=0;while(1){d:{v[113382]=0;g=Q(2312,a+264|0,a+256|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break d}if(!g){break c}if(v[a+188>>2]==(Db(d)+c|0)){g=Db(d);c=Db(d);v[113382]=0;R(1589,d|0,c<<1);c=v[113382];v[113382]=0;if((c|0)==1){break b}c=Fc(d);v[113382]=0;R(1589,d|0,c|0);c=v[113382];v[113382]=0;if((c|0)==1){break b}c=kc(d,0);v[a+188>>2]=g+c}v[113382]=0;g=T(2314,a+264|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break d}v[113382]=0;g=bk(g,b,c,a+188|0,a+8|0,t[a+255|0],a+208|0,a+16|0,a+12|0,59248);h=v[113382];v[113382]=0;if((h|0)==1){break d}if(g){break c}v[113382]=0;T(2316,a+264|0)|0;g=v[113382];v[113382]=0;if((g|0)!=1){continue}}break}break b}break b}e:{if(!Db(a+208|0)){break e}g=v[a+12>>2];if((g-(a+16|0)|0)>159){break e}v[a+12>>2]=g+4;v[g>>2]=v[a+8>>2]}v[113382]=0;b=ko(2323,c,v[a+188>>2],e,b);c=mb;g=v[113382];v[113382]=0;f:{if((g|0)==1){break f}v[f>>2]=b;v[f+4>>2]=c;v[113382]=0;De(a+208|0,a+16|0,v[a+12>>2],e);b=v[113382];v[113382]=0;if((b|0)==1){break f}v[113382]=0;b=Q(2313,a+264|0,a+256|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break f}if(b){v[e>>2]=v[e>>2]|2}b=v[a+264>>2];yb(d);yb(a+208|0);jb=a+272|0;break a}}b=P()|0;O()|0;yb(d);yb(a+208|0);S(b|0);L()}return b|0}function U$(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;a=jb-272|0;jb=a;v[a+256>>2]=c;v[a+264>>2]=b;b=ah(d);Dm(a+208|0,d,a+255|0);d=Xb(a+192|0);c=Fc(d);v[113382]=0;R(1589,d|0,c|0);c=v[113382];v[113382]=0;a:{b:{c:{if((c|0)!=1){c=kc(d,0);v[a+188>>2]=c;v[a+12>>2]=a+16;v[a+8>>2]=0;while(1){d:{v[113382]=0;g=Q(2312,a+264|0,a+256|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break d}if(!g){break c}if(v[a+188>>2]==(Db(d)+c|0)){g=Db(d);c=Db(d);v[113382]=0;R(1589,d|0,c<<1);c=v[113382];v[113382]=0;if((c|0)==1){break b}c=Fc(d);v[113382]=0;R(1589,d|0,c|0);c=v[113382];v[113382]=0;if((c|0)==1){break b}c=kc(d,0);v[a+188>>2]=g+c}v[113382]=0;g=T(2314,a+264|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break d}v[113382]=0;g=bk(g,b,c,a+188|0,a+8|0,t[a+255|0],a+208|0,a+16|0,a+12|0,59248);h=v[113382];v[113382]=0;if((h|0)==1){break d}if(g){break c}v[113382]=0;T(2316,a+264|0)|0;g=v[113382];v[113382]=0;if((g|0)!=1){continue}}break}break b}break b}e:{if(!Db(a+208|0)){break e}g=v[a+12>>2];if((g-(a+16|0)|0)>159){break e}v[a+12>>2]=g+4;v[g>>2]=v[a+8>>2]}v[113382]=0;b=ko(2327,c,v[a+188>>2],e,b);c=mb;g=v[113382];v[113382]=0;f:{if((g|0)==1){break f}v[f>>2]=b;v[f+4>>2]=c;v[113382]=0;De(a+208|0,a+16|0,v[a+12>>2],e);b=v[113382];v[113382]=0;if((b|0)==1){break f}v[113382]=0;b=Q(2313,a+264|0,a+256|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break f}if(b){v[e>>2]=v[e>>2]|2}b=v[a+264>>2];yb(d);yb(a+208|0);jb=a+272|0;break a}}b=P()|0;O()|0;yb(d);yb(a+208|0);S(b|0);L()}return b|0}function ay(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=89;h=92;i=91;j=85;k=84;l=83;m=5;n=107;o=106;p=96;c=88;q=82;r=80;s=78;t=79;u=77;v=57;w=47;d=10;e=8;x=7;a=ey(a);a:{b:{c:{d:{switch(b-1|0){default:c=(b|0)==16777216;if(!c&(b|0)!=32){break c}Nb(a,0,1);Nb(a,7,1);Nb(a,8,1);Nb(a,9,1);Nb(a,10,1);Nb(a,11,1);Nb(a,12,1);Nb(a,13,1);Nb(a,14,1);Nb(a,15,1);Nb(a,16,1);Nb(a,17,1);Nb(a,18,1);Nb(a,19,1);Nb(a,20,1);Nb(a,21,1);Nb(a,22,1);Nb(a,23,1);Nb(a,24,1);Nb(a,25,1);Nb(a,26,1);Nb(a,27,1);Nb(a,28,1);Nb(a,29,1);Nb(a,30,1);Nb(a,31,1);Nb(a,32,1);Nb(a,33,1);Nb(a,34,1);Nb(a,35,1);Nb(a,36,1);Nb(a,37,1);Nb(a,38,1);Nb(a,39,1);Nb(a,40,1);Nb(a,41,1);Nb(a,42,1);Nb(a,43,1);Nb(a,44,1);Nb(a,45,1);Nb(a,46,1);Nb(a,47,1);Nb(a,48,1);Nb(a,103,1);Nb(a,50,1);Nb(a,87,1);Nb(a,88,1);Nb(a,100,1);Nb(a,102,1);Nb(a,104,1);if(!c){break a}d=105;e=99;break b;case 3:Nb(a,0,1);Nb(a,4,1);Nb(a,8,1);Nb(a,9,1);Nb(a,10,1);Nb(a,17,1);Nb(a,40,1);Nb(a,51,1);Nb(a,52,1);Nb(a,53,1);Nb(a,54,1);Nb(a,55,1);Nb(a,56,1);Nb(a,57,1);Nb(a,58,1);Nb(a,59,1);Nb(a,60,1);Nb(a,61,1);Nb(a,62,1);Nb(a,63,1);Nb(a,64,1);Nb(a,65,1);Nb(a,66,1);Nb(a,67,1);Nb(a,68,1);n=98;o=93;p=90;c=89;q=88;r=86;s=76;t=75;u=74;v=73;w=72;d=71;e=70;f=69;case 1:Nb(a,f,1);Nb(a,e,1);Nb(a,d,1);Nb(a,w,1);Nb(a,v,1);Nb(a,u,1);m=t;l=s;k=r;j=q;i=c;h=p;c=o;g=n;break;case 2:break c;case 0:break d}}Nb(a,m,1);Nb(a,l,1);Nb(a,k,1);Nb(a,j,1);f=i;x=h;e=c;d=g}Nb(a,f,1);Nb(a,x,1)}Nb(a,e,1);Nb(a,d,1)}}function a0(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;a=jb-272|0;jb=a;v[a+256>>2]=c;v[a+264>>2]=b;b=ah(d);Dm(a+208|0,d,a+255|0);d=Xb(a+192|0);c=Fc(d);v[113382]=0;R(1589,d|0,c|0);c=v[113382];v[113382]=0;a:{b:{c:{if((c|0)!=1){c=kc(d,0);v[a+188>>2]=c;v[a+12>>2]=a+16;v[a+8>>2]=0;while(1){d:{v[113382]=0;g=Q(2312,a+264|0,a+256|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break d}if(!g){break c}if(v[a+188>>2]==(Db(d)+c|0)){g=Db(d);c=Db(d);v[113382]=0;R(1589,d|0,c<<1);c=v[113382];v[113382]=0;if((c|0)==1){break b}c=Fc(d);v[113382]=0;R(1589,d|0,c|0);c=v[113382];v[113382]=0;if((c|0)==1){break b}c=kc(d,0);v[a+188>>2]=g+c}v[113382]=0;g=T(2314,a+264|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break d}v[113382]=0;g=bk(g,b,c,a+188|0,a+8|0,t[a+255|0],a+208|0,a+16|0,a+12|0,59248);h=v[113382];v[113382]=0;if((h|0)==1){break d}if(g){break c}v[113382]=0;T(2316,a+264|0)|0;g=v[113382];v[113382]=0;if((g|0)!=1){continue}}break}break b}break b}e:{if(!Db(a+208|0)){break e}g=v[a+12>>2];if((g-(a+16|0)|0)>159){break e}v[a+12>>2]=g+4;v[g>>2]=v[a+8>>2]}v[113382]=0;b=aa(2319,c|0,v[a+188>>2],e|0,b|0)|0;c=v[113382];v[113382]=0;f:{if((c|0)==1){break f}v[f>>2]=b;v[113382]=0;De(a+208|0,a+16|0,v[a+12>>2],e);b=v[113382];v[113382]=0;if((b|0)==1){break f}v[113382]=0;b=Q(2313,a+264|0,a+256|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break f}if(b){v[e>>2]=v[e>>2]|2}b=v[a+264>>2];yb(d);yb(a+208|0);jb=a+272|0;break a}}b=P()|0;O()|0;yb(d);yb(a+208|0);S(b|0);L()}return b|0}function Y$(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;a=jb-272|0;jb=a;v[a+256>>2]=c;v[a+264>>2]=b;b=ah(d);Dm(a+208|0,d,a+255|0);d=Xb(a+192|0);c=Fc(d);v[113382]=0;R(1589,d|0,c|0);c=v[113382];v[113382]=0;a:{b:{c:{if((c|0)!=1){c=kc(d,0);v[a+188>>2]=c;v[a+12>>2]=a+16;v[a+8>>2]=0;while(1){d:{v[113382]=0;g=Q(2312,a+264|0,a+256|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break d}if(!g){break c}if(v[a+188>>2]==(Db(d)+c|0)){g=Db(d);c=Db(d);v[113382]=0;R(1589,d|0,c<<1);c=v[113382];v[113382]=0;if((c|0)==1){break b}c=Fc(d);v[113382]=0;R(1589,d|0,c|0);c=v[113382];v[113382]=0;if((c|0)==1){break b}c=kc(d,0);v[a+188>>2]=g+c}v[113382]=0;g=T(2314,a+264|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break d}v[113382]=0;g=bk(g,b,c,a+188|0,a+8|0,t[a+255|0],a+208|0,a+16|0,a+12|0,59248);h=v[113382];v[113382]=0;if((h|0)==1){break d}if(g){break c}v[113382]=0;T(2316,a+264|0)|0;g=v[113382];v[113382]=0;if((g|0)!=1){continue}}break}break b}break b}e:{if(!Db(a+208|0)){break e}g=v[a+12>>2];if((g-(a+16|0)|0)>159){break e}v[a+12>>2]=g+4;v[g>>2]=v[a+8>>2]}v[113382]=0;b=aa(2324,c|0,v[a+188>>2],e|0,b|0)|0;c=v[113382];v[113382]=0;f:{if((c|0)==1){break f}u[f>>1]=b;v[113382]=0;De(a+208|0,a+16|0,v[a+12>>2],e);b=v[113382];v[113382]=0;if((b|0)==1){break f}v[113382]=0;b=Q(2313,a+264|0,a+256|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break f}if(b){v[e>>2]=v[e>>2]|2}b=v[a+264>>2];yb(d);yb(a+208|0);jb=a+272|0;break a}}b=P()|0;O()|0;yb(d);yb(a+208|0);S(b|0);L()}return b|0}function W$(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;a=jb-272|0;jb=a;v[a+256>>2]=c;v[a+264>>2]=b;b=ah(d);Dm(a+208|0,d,a+255|0);d=Xb(a+192|0);c=Fc(d);v[113382]=0;R(1589,d|0,c|0);c=v[113382];v[113382]=0;a:{b:{c:{if((c|0)!=1){c=kc(d,0);v[a+188>>2]=c;v[a+12>>2]=a+16;v[a+8>>2]=0;while(1){d:{v[113382]=0;g=Q(2312,a+264|0,a+256|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break d}if(!g){break c}if(v[a+188>>2]==(Db(d)+c|0)){g=Db(d);c=Db(d);v[113382]=0;R(1589,d|0,c<<1);c=v[113382];v[113382]=0;if((c|0)==1){break b}c=Fc(d);v[113382]=0;R(1589,d|0,c|0);c=v[113382];v[113382]=0;if((c|0)==1){break b}c=kc(d,0);v[a+188>>2]=g+c}v[113382]=0;g=T(2314,a+264|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break d}v[113382]=0;g=bk(g,b,c,a+188|0,a+8|0,t[a+255|0],a+208|0,a+16|0,a+12|0,59248);h=v[113382];v[113382]=0;if((h|0)==1){break d}if(g){break c}v[113382]=0;T(2316,a+264|0)|0;g=v[113382];v[113382]=0;if((g|0)!=1){continue}}break}break b}break b}e:{if(!Db(a+208|0)){break e}g=v[a+12>>2];if((g-(a+16|0)|0)>159){break e}v[a+12>>2]=g+4;v[g>>2]=v[a+8>>2]}v[113382]=0;b=aa(2325,c|0,v[a+188>>2],e|0,b|0)|0;c=v[113382];v[113382]=0;f:{if((c|0)==1){break f}v[f>>2]=b;v[113382]=0;De(a+208|0,a+16|0,v[a+12>>2],e);b=v[113382];v[113382]=0;if((b|0)==1){break f}v[113382]=0;b=Q(2313,a+264|0,a+256|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break f}if(b){v[e>>2]=v[e>>2]|2}b=v[a+264>>2];yb(d);yb(a+208|0);jb=a+272|0;break a}}b=P()|0;O()|0;yb(d);yb(a+208|0);S(b|0);L()}return b|0}function V$(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;a=jb-272|0;jb=a;v[a+256>>2]=c;v[a+264>>2]=b;b=ah(d);Dm(a+208|0,d,a+255|0);d=Xb(a+192|0);c=Fc(d);v[113382]=0;R(1589,d|0,c|0);c=v[113382];v[113382]=0;a:{b:{c:{if((c|0)!=1){c=kc(d,0);v[a+188>>2]=c;v[a+12>>2]=a+16;v[a+8>>2]=0;while(1){d:{v[113382]=0;g=Q(2312,a+264|0,a+256|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break d}if(!g){break c}if(v[a+188>>2]==(Db(d)+c|0)){g=Db(d);c=Db(d);v[113382]=0;R(1589,d|0,c<<1);c=v[113382];v[113382]=0;if((c|0)==1){break b}c=Fc(d);v[113382]=0;R(1589,d|0,c|0);c=v[113382];v[113382]=0;if((c|0)==1){break b}c=kc(d,0);v[a+188>>2]=g+c}v[113382]=0;g=T(2314,a+264|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break d}v[113382]=0;g=bk(g,b,c,a+188|0,a+8|0,t[a+255|0],a+208|0,a+16|0,a+12|0,59248);h=v[113382];v[113382]=0;if((h|0)==1){break d}if(g){break c}v[113382]=0;T(2316,a+264|0)|0;g=v[113382];v[113382]=0;if((g|0)!=1){continue}}break}break b}break b}e:{if(!Db(a+208|0)){break e}g=v[a+12>>2];if((g-(a+16|0)|0)>159){break e}v[a+12>>2]=g+4;v[g>>2]=v[a+8>>2]}v[113382]=0;b=aa(2326,c|0,v[a+188>>2],e|0,b|0)|0;c=v[113382];v[113382]=0;f:{if((c|0)==1){break f}v[f>>2]=b;v[113382]=0;De(a+208|0,a+16|0,v[a+12>>2],e);b=v[113382];v[113382]=0;if((b|0)==1){break f}v[113382]=0;b=Q(2313,a+264|0,a+256|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break f}if(b){v[e>>2]=v[e>>2]|2}b=v[a+264>>2];yb(d);yb(a+208|0);jb=a+272|0;break a}}b=P()|0;O()|0;yb(d);yb(a+208|0);S(b|0);L()}return b|0}function A_(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,u=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;x=jb-16|0;jb=x;v[c>>2]=a;A=d&512;while(1){if((y|0)==4){if(Db(n)>>>0>1){C=x,D=Bd(n),v[C+8>>2]=D;C=c,D=wj(ff(x+8|0,1),tf(n),v[c>>2]),v[C>>2]=D}d=d&176;if((d|0)!=16){if((d|0)==32){a=v[c>>2]}v[b>>2]=a}jb=x+16|0;return}a:{b:{switch(t[i+y|0]){case 0:v[b>>2]=v[c>>2];break a;case 1:v[b>>2]=v[c>>2];q=Pk(g,32);p=v[c>>2];v[c>>2]=p+1;t[p|0]=q;break a;case 3:if(Sc(n)){break a}q=w[kc(n,0)|0];p=v[c>>2];v[c>>2]=p+1;t[p|0]=q;break a;case 2:if(Sc(m)|!A){break a}C=c,D=wj(Bd(m),tf(m),v[c>>2]),v[C>>2]=D;break a;case 4:break b;default:break a}}B=v[c>>2];e=e+h|0;r=e;while(1){c:{if(f>>>0<=r>>>0){break c}if(!Lg(g,2048,t[r|0])){break c}r=r+1|0;continue}break}q=o;if((q|0)>0){while(1){if(!(!q|e>>>0>=r>>>0)){r=r-1|0;p=w[r|0];s=v[c>>2];v[c>>2]=s+1;t[s|0]=p;q=q-1|0;continue}break}if(q){p=Pk(g,48)}else{p=0}while(1){s=v[c>>2];v[c>>2]=s+1;if((q|0)>0){t[s|0]=p;q=q-1|0;continue}break}t[s|0]=j}d:{if((e|0)==(r|0)){q=Pk(g,48);p=v[c>>2];v[c>>2]=p+1;t[p|0]=q;break d}if(Sc(l)){p=-1}else{p=t[kc(l,0)|0]}q=0;u=0;while(1){if((e|0)==(r|0)){break d}e:{if((q|0)!=(p|0)){s=q;break e}p=v[c>>2];v[c>>2]=p+1;t[p|0]=k;s=0;u=u+1|0;if(Db(l)>>>0<=u>>>0){p=q;break e}if(w[kc(l,u)|0]==127){p=-1;break e}p=t[kc(l,u)|0]}r=r-1|0;q=w[r|0];z=v[c>>2];v[c>>2]=z+1;t[z|0]=q;q=s+1|0;continue}}Zj(B,v[c>>2])}y=y+1|0;continue}}function YY(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;a=jb-16|0;jb=a;v[a+12>>2]=c;v[a+8>>2]=f;v[a+12>>2]=c;v[a+8>>2]=f;a:{b:{c:{while(1){d:{f=v[a+12>>2];if(f>>>0>=d>>>0){break d}j=v[a+8>>2];if(j>>>0>=g>>>0){break d}b=2;c=w[f|0];if(c>>>0>1114111){break b}m=a;e:{if(c<<24>>24>=0){u[j>>1]=c;b=f+1|0;break e}if(c>>>0<194){break b}if(c>>>0<=223){if((d-f|0)<2){break c}i=w[f+1|0];if((i&192)!=128){break a}c=i&63|c<<6&1984;if(c>>>0>1114111){break a}u[j>>1]=c;b=f+2|0;break e}if(c>>>0<=239){if((d-f|0)<3){break c}k=w[f+2|0];i=w[f+1|0];f:{g:{if((c|0)!=237){if((c|0)!=224){break g}if((i&224)==160){break f}break a}if((i&224)==128){break f}break a}if((i&192)!=128){break a}}if((k&192)!=128){break a}c=k&63|((i&63)<<6|c<<12);if((c&65535)>>>0>1114111){break a}u[j>>1]=c;b=f+3|0;break e}if(c>>>0>244){break b}b=1;if((d-f|0)<4){break a}k=w[f+3|0];i=w[f+2|0];f=w[f+1|0];h:{i:{switch(c-240|0){case 0:if((f+112&255)>>>0>=48){break b}break h;case 4:if((f&240)!=128){break b}break h;default:break i}}if((f&192)!=128){break b}}if((i&192)!=128|(k&192)!=128){break b}if((g-j|0)<4){break a}b=2;k=k&63;l=i<<6;c=c&7;if((k|(l&4032|(f<<12&258048|c<<18)))>>>0>1114111){break a}b=f<<2;u[j>>1]=(i>>>4&3|(b&192|c<<8|b&60))+16320|55296;v[a+8>>2]=j+2;u[j+2>>1]=k|l&960|56320;b=v[a+12>>2]+4|0}v[m+12>>2]=b;v[a+8>>2]=v[a+8>>2]+2;continue}break}b=d>>>0>f>>>0;break a}b=1;break a}b=2}v[e>>2]=v[a+12>>2];v[h>>2]=v[a+8>>2];jb=a+16|0;return b|0}function vea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;h=jb-16|0;jb=h;f=v[a+48>>2];l=v[a+40>>2];m=v[a+36>>2];n=v[a+44>>2];q=v[a+16>>2];e=v[a+4>>2];i=v[a>>2];v[h+8>>2]=i;v[h+12>>2]=e;g=v[a+12>>2];v[h>>2]=v[a+8>>2];v[h+4>>2]=g;a:{if(d){while(1){g=(e<<1)+q|0;j=u[g-6>>1];e=(((i>>>16|0)+4&131064)<<1)+b|0;i=u[e+24>>1];o=u[g-4>>1];r=u[e+26>>1];s=u[g-2>>1];t=u[e+28>>1];w=u[g>>1];x=u[e+30>>1];y=u[g+2>>1];z=u[e+32>>1];A=u[g+4>>1];C=u[e+34>>1];D=u[g+6>>1];E=u[e+36>>1];F=u[g+8>>1];G=u[e+38>>1];g=v[a+60>>2];H=g;I=g>>31;e=Yb(n,-16777216,16776704);k=v[a+64>>2];f=Yb(f,-16777216,16776704);J=v[a+72>>2];K=v[a+32>>2];g=c;L=v[g>>2];e=qma(k,k>>31,e,e>>31);k=mb;M=e;e=v[a+68>>2];p=qma(e,e>>31,f,f>>31);e=M+p|0;f=mb+k|0;f=e>>>0<p>>>0?f+1|0:f;k=e;i=(((((B(A,C)+B(y,z)|0)+B(D,E)|0)+B(F,G)|0)/2|0)+((((B(o,r)+B(i,j)|0)+B(s,t)|0)+B(w,x)|0)/2|0)|0)/16384<<8;e=i;j=qma(H,I,e,e>>31);e=k+j|0;f=mb+f|0;f=e>>>0<j>>>0?f+1|0:f;e=e+8388608|0;f=e>>>0<8388608?f+1|0:f;e=(f&16777215)<<8|e>>>24;f=(e|0)/256|0;m=v[a+28>>2]+m|0;j=m>>12;v[g>>2]=B(f,j)+L;l=l+K|0;o=l>>12;v[g+4>>2]=v[g+4>>2]+B(f,o);g=e-(i&J)|0;Sb(h+8|0,h);d=d-1|0;if(d){c=c+8|0;i=v[h+8>>2];e=v[h+12>>2];f=n;n=g;continue}break}i=v[h+8>>2];e=v[h+12>>2];f=n;break a}o=l>>12;j=m>>12;g=n}v[a+40>>2]=l;v[a+20>>2]=j;v[a+36>>2]=m;v[a+48>>2]=f;v[a+44>>2]=g;v[a+24>>2]=o;v[a>>2]=i;v[a+4>>2]=e;jb=h+16|0}function jea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0;f=jb-48|0;jb=f;m=v[a+16>>2];h=Uf(f+16|0);v[h+8>>2]=a+112;v[h+16>>2]=v[a+128>>2];s=h,u=Pf(b+327720|0,v[b+20>>2],(v[a+88>>2]&16384)>>>14|0),v[s+12>>2]=u;b=v[h+16>>2];if(b){s=h,u=Tf(a+8|0,b),v[s>>2]=u;v[h+4>>2]=mb}i=v[a+48>>2];n=v[a+24>>2];o=v[a+20>>2];k=v[a+44>>2];e=v[a+4>>2];g=v[a>>2];v[f+8>>2]=g;v[f+12>>2]=e;b=v[a+12>>2];v[f>>2]=v[a+8>>2];v[f+4>>2]=b;a:{if(!d){b=k;k=i;break a}while(1){b=0;j=b;v[f+40>>2]=g;v[f+44>>2]=b;e=e+m|0;b:{b=v[h+16>>2];if((b|0)<=0){break b}while(1){yd(v[h+8>>2],t[e+j|0]<<6);xd(v[h+8>>2],4);Sb(f+40|0,h);if((b|0)<2){break b}b=b-1|0;j=v[f+44>>2];continue}}d=d-1|0;b=v[h+8>>2];Sb(b,b+8|0);b=v[h+8>>2];g=v[b+4>>2];if(g){yd(b,t[e+v[f+44>>2]|0]<<6);xd(v[h+8>>2],g);b=v[h+8>>2];g=v[b>>2];v[b>>2]=g;v[b+4>>2]=0}e=Of(b,v[h+12>>2]);g=v[a+60>>2];j=g;b=Yb(k,-16777216,16776704);l=v[a+64>>2];i=Yb(i,-16777216,16776704);p=v[a+72>>2];q=v[c>>2];r=g>>31;g=e<<8;e=g;e=qma(j,r,e,e>>31);j=mb;l=qma(l,l>>31,b,b>>31);e=l+e|0;b=mb+j|0;b=e>>>0<l>>>0?b+1|0:b;j=e;e=v[a+68>>2];e=qma(e,e>>31,i,i>>31);i=j+e|0;b=mb+b|0;b=e>>>0>i>>>0?b+1|0:b;i=i+8388608|0;b=i>>>0<8388608?b+1|0:b;b=(b&16777215)<<8|i>>>24;i=(b|0)/256|0;v[c>>2]=B(i,o)+q;v[c+4>>2]=v[c+4>>2]+B(i,n);b=b-(g&p)|0;Sb(f+8|0,f);if(d){c=c+8|0;g=v[f+8>>2];e=v[f+12>>2];i=k;k=b;continue}break}g=v[f+8>>2];e=v[f+12>>2]}v[a+48>>2]=k;v[a+44>>2]=b;v[a>>2]=g;v[a+4>>2]=e;jb=f+48|0}function WI(a){var b=C(0),c=0,d=C(0),e=0,f=C(0),g=0,h=C(0),i=C(0),k=C(0),m=0,n=C(0),o=0,r=C(0);e=jb-16|0;jb=e;c=Ue(v[a+16>>2]);o=a,r=je(C(10),C(C(C(z[a+4208>>2]*C(120))+C(-60))*C(.05000000074505806))),z[o+4232>>2]=r;f=C(C(c>>>0)*C(.0010000000474974513));o=a,r=je(C(10),C(C(-1)/C(C(C(z[a+4212>>2]*C(499.989990234375))+C(.009999999776482582))*f))),z[o+4236>>2]=r;o=a,r=je(C(10),C(C(-1)/C(C(C(z[a+4216>>2]*C(2950))+C(50))*f))),z[o+4240>>2]=r;v[e+12>>2]=1325400064;g=e;b=C(je(C(10),C(C(C(z[a+4220>>2]*C(60))+C(-60))*C(.05000000074505806)))*C(2147483648));c=(p(b),j(2));a:{b:{c:{if(!(c>>>0>=8388608&(c|0)>=0)){d=C(C(-1)/C(b*b));if(!(c&2147483647)){break a}d=C(C(b-b)/C(0));if((c|0)<0){break a}c=(p(C(b*C(33554432))),j(2));m=-152;break c}if(c>>>0>2139095039){break b}m=-127;b=C(0);if((c|0)==1065353216){break b}}c=c+4913933|0;n=C((c>>>23|0)+m|0);b=C((l(2,(c&8388607)+1060439283|0),q())+C(-1));h=C(b/C(b+C(2)));i=C(h*h);k=C(i*i);d=b;b=C(b*C(b*C(.5)));b=C(C(n*C(.6931381225585938))+C(d+C(C(C(n*C(905800061445916e-20))+C(h*C(b+C(C(i*C(C(k*C(.2849878668785095))+C(.6666666269302368)))+C(k*C(C(k*C(.24279078841209412))+C(.40000972151756287)))))))-b)))}d=b}z[g+8>>2]=C(d*C(96817624))+C(67108864);o=a,r=C(z[pl(e+12|0,e+8|0)>>2]*C(4.656612873077393e-10)),z[o+4244>>2]=r;z[a+4248>>2]=C(C(-1)/C(C(z[a+4224>>2]*C(99))+C(1)))+C(1);g=a;b=C(C(C(z[a+4228>>2]*C(4))*f)+C(2));d:{if(C(D(b))<C(2147483648)){a=~~b;break d}a=-2147483648}v[g+4252>>2]=a;jb=e+16|0}function wea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,w=0,x=0,y=0,z=0,A=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;h=jb-16|0;jb=h;f=v[a+48>>2];l=v[a+40>>2];m=v[a+36>>2];n=v[a+44>>2];q=v[a+16>>2];e=v[a+4>>2];i=v[a>>2];v[h+8>>2]=i;v[h+12>>2]=e;g=v[a+12>>2];v[h>>2]=v[a+8>>2];v[h+4>>2]=g;a:{if(d){while(1){g=e+q|0;j=t[g-3|0];e=(((i>>>16|0)+4&131064)<<1)+b|0;i=u[e+24>>1];o=t[g-2|0];r=u[e+26>>1];s=t[g-1|0];w=u[e+28>>1];x=t[g|0];y=u[e+30>>1];z=t[g+1|0];A=u[e+32>>1];C=t[g+2|0];D=u[e+34>>1];E=t[g+3|0];F=u[e+36>>1];G=t[g+4|0];H=u[e+38>>1];g=v[a+60>>2];I=g;J=g>>31;e=Yb(n,-16777216,16776704);k=v[a+64>>2];f=Yb(f,-16777216,16776704);K=v[a+72>>2];L=v[a+32>>2];g=c;M=v[g>>2];e=qma(k,k>>31,e,e>>31);k=mb;N=e;e=v[a+68>>2];p=qma(e,e>>31,f,f>>31);e=N+p|0;f=mb+k|0;f=e>>>0<p>>>0?f+1|0:f;k=e;i=(((((B(C,D)+B(z,A)|0)+B(E,F)|0)+B(G,H)<<8)/2|0)+((((B(o,r)+B(i,j)|0)+B(s,w)|0)+B(x,y)<<8)/2|0)|0)/16384<<8;e=i;j=qma(I,J,e,e>>31);e=k+j|0;f=mb+f|0;f=e>>>0<j>>>0?f+1|0:f;e=e+8388608|0;f=e>>>0<8388608?f+1|0:f;e=(f&16777215)<<8|e>>>24;f=(e|0)/256|0;m=v[a+28>>2]+m|0;j=m>>12;v[g>>2]=B(f,j)+M;l=l+L|0;o=l>>12;v[g+4>>2]=v[g+4>>2]+B(f,o);g=e-(i&K)|0;Sb(h+8|0,h);d=d-1|0;if(d){c=c+8|0;i=v[h+8>>2];e=v[h+12>>2];f=n;n=g;continue}break}i=v[h+8>>2];e=v[h+12>>2];f=n;break a}o=l>>12;j=m>>12;g=n}v[a+40>>2]=l;v[a+20>>2]=j;v[a+36>>2]=m;v[a+48>>2]=f;v[a+44>>2]=g;v[a+24>>2]=o;v[a>>2]=i;v[a+4>>2]=e;jb=h+16|0}function _T(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;g=jb-32|0;jb=g;Ic(c);a:{if(!Rb(c,3)){break a}while(1){e=g+24|0;iq(e,c);f=Zc(e);i=Cf(e);if(y[a+12>>2]<=w[e|0]){break a}h=Bf(a,w[e|0],b);e=w[f|0];b:{if(e>>>0<=126){if(!(e|w[i|0])){t[h|0]=254;break b}t[h|0]=e+1;if(w[i|0]==255){break b}t[h+2|0]=1;t[h+4|0]=w[i|0];break b}c:{switch(e-127|0){case 1:t[h+1|0]=w[i|0]+1;break b;case 0:break b;default:break c}}d=t[i|0];t[g+23|0]=d;i=0;e=e&127;if(e>>>0<=23){i=w[e+23488|0]}e=g;d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{j=w[f|0];switch((j&127)-2|0){case 21:break h;case 18:break i;case 17:break j;case 16:case 20:break k;case 15:break l;case 2:break m;case 1:break n;case 0:case 8:case 9:break o;default:break e}}if((d|0)>=0){break g}f=0-d&15;break f}t[g+16|0]=64;d=w[pc(g+23|0,g+16|0)|0];if(w[h+2|0]>1){break e}t[h+4|0]=d;t[h+2|0]=1;break b}f=3;if((d|0)>=0){break d}f=0-d&127;break f}if(!d){break b}f=0-d|-16;if((d|0)<0){break f}f=d<<4|15;break f}if(!d){break b}e=(d|0)>=0;if(!e){d=0-d&15;t[g+23|0]=d;j=w[f|0]}f=e?3:2;d=((j|0)==22?-32:-16)|d;t[g+23|0]=d;break d}f=d&15|-48;break f}f=d&15|-64;break f}f=164;if((d|0)==100){break f}v[g+16>>2]=d- -64;v[g+12>>2]=0;v[g+8>>2]=128;d=v[Ok(g+16|0,g+12|0,g+8|0)>>2];if(!w[h+3|0]){break e}p:{switch(w[h+2|0]){case 0:case 2:break p;default:break b}}t[h+2|0]=2;t[h+4|0]=(d&254)>>>1;break b}f=d<<4}d=f;t[e+23|0]=d}f=i;if(!i){break b}}t[h+5|0]=d;t[h+3|0]=f}if(Rb(c,3)){continue}break}}jb=g+32|0}function Ffa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;b=jb-48|0;jb=b;s=v[a+16>>2];j=v[a+44>>2];v[b+32>>2]=j;l=v[a+48>>2];v[b+36>>2]=l;g=v[a+52>>2];v[b+40>>2]=g;h=v[a+56>>2];v[b+44>>2]=h;m=v[a+40>>2];n=v[a+36>>2];e=v[a+4>>2];i=v[a>>2];v[b+24>>2]=i;v[b+28>>2]=e;f=v[a+12>>2];v[b+16>>2]=v[a+8>>2];v[b+20>>2]=f;a:{if(d){while(1){e=((((e&2147483647)<<1|i>>>31)&2147483646)<<1)+s|0;h=u[e>>1];v[b+8>>2]=h;v[b+12>>2]=u[e+2>>1];f=0;l=1;while(1){g=v[a+60>>2];k=g;i=(b+32|0)+(f<<3)|0;o=v[i>>2];e=Yb(o,-16777216,16776704);r=v[a+64>>2];j=Yb(v[i+4>>2],-16777216,16776704);p=v[a+68>>2];t=p;p=p>>31;v[i+4>>2]=o;o=v[a+72>>2];q=g>>31;h=h<<8;g=h;g=qma(k,q,g,g>>31);k=mb;q=(b+8|0)+(f<<2)|0;f=g;g=qma(r,r>>31,e,e>>31);f=f+g|0;e=mb+k|0;e=f>>>0<g>>>0?e+1|0:e;j=qma(t,p,j,j>>31);f=j+f|0;e=mb+e|0;e=f>>>0<j>>>0?e+1|0:e;f=f+8388608|0;e=f>>>0<8388608?e+1|0:e;e=(e&16777215)<<8|f>>>24;v[q>>2]=(e|0)/256;v[i>>2]=e-(h&o);if(l){f=1;l=0;h=v[b+12>>2];continue}break}e=v[a+32>>2];n=v[a+28>>2]+n|0;f=n>>12;v[c>>2]=v[c>>2]+B(f,v[b+8>>2]);m=e+m|0;k=m>>12;v[c+4>>2]=v[c+4>>2]+B(k,v[b+12>>2]);Sb(b+24|0,b+16|0);d=d-1|0;if(d){c=c+8|0;i=v[b+24>>2];e=v[b+28>>2];continue}break}i=v[b+24>>2];e=v[b+28>>2];h=v[b+44>>2];g=v[b+40>>2];l=v[b+36>>2];j=v[b+32>>2];break a}k=m>>12;f=n>>12}v[a+40>>2]=m;v[a+20>>2]=f;v[a+36>>2]=n;v[a+56>>2]=h;v[a+52>>2]=g;v[a+48>>2]=l;v[a+44>>2]=j;v[a+24>>2]=k;v[a>>2]=i;v[a+4>>2]=e;jb=b+48|0}function VG(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;g=jb-16|0;jb=g;a:{b:{c:{f=a+8|0;d:{if(ol(f)){f=ol(f);break d}f=Rr(f)}if(!((f|0)>(b|0)&(b|0)>=0)){b=ba(8)|0;v[113382]=0;c=Q(121,g|0,2427)|0;a=v[113382];v[113382]=0;if((a|0)==1){break c}nc(b,c);v[113382]=0;U(1978,b|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break a}a=P()|0;O()|0;yb(c);break b}if(c>>>0>=120){b=ba(8)|0;v[113382]=0;c=Q(121,g|0,7352)|0;a=v[113382];v[113382]=0;if((a|0)!=1){nc(b,c);v[113382]=0;U(1978,b|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break a}a=P()|0;O()|0;yb(c);break b}a=P()|0;O()|0;ca(b|0);break b}h=a+32|0;a=oy(v[h>>2],65535);a=(a|0)==65535?255:a;u[g>>1]=a;a=v[h>>2]+B(a,896)|0;f=a+1074984|0;mn(f,7,v[h>>2],65535,1024);c=c+1|0;t[a+1075808|0]=c;t[a+1075805|0]=c;u[a+1075792>>1]=0;zl(f);gp(v[h>>2],f,b+1|0,0,1,1);v[a+1075680>>2]=65536;Es(v[h>>2],f,c,0,1,1,65535);l=a+1075676|0,m=jn(ty(e*128,-128,128)+128),v[l>>2]=m;l=a+1075672|0,m=jn(ty(d*256,0,256)),v[l>>2]=m;a=v[h>>2]+1074466|0;i=a;f=(x[v[h>>2]+480212>>1]<<1)+a|0;j=f;k=g;c=g;b=f;e:{if((b|0)==(a|0)){break e}c=x[c>>1];while(1){if((c|0)==x[a>>1]){break e}a=a+2|0;if((b|0)!=(a|0)){continue}break}a=b}b=a;f:{if((j|0)==(a|0)){break f}c=b+2|0;if((f|0)==(c|0)){break f}while(1){if(x[c>>1]!=x[k>>1]){u[b>>1]=x[c>>1];b=b+2|0}c=c+2|0;if((f|0)!=(c|0)){continue}break}}a=zy(i,b);u[v[h>>2]+480212>>1]=a;jb=g+16|0;return x[g>>1]}a=P()|0;O()|0;ca(b|0)}S(a|0)}L()}function Sia(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;e=jb-16|0;jb=e;a:{if((c|0)!=4){g=b+236|0;h=b+108|0;while(1){f=(d<<2)+a|0;i=w[f+4|0];j=ec(h,d),k=i+1|0,t[j|0]=k;f=f+6|0;f=w[f|0]|w[f+1|0]<<8;j=_c(g,d),k=f+1|0,u[j>>1]=k;d=d+1|0;if((d|0)!=120){continue}break}break a}g=b+236|0;while(1){h=((d<<2)+a|0)+6|0;h=w[h|0]|w[h+1|0]<<8;j=_c(g,d+12|0),k=h+1|0,u[j>>1]=k;d=d+1|0;if((d|0)!=96){continue}break}}yz(a+484|0,b+48|0,0);yz(a+590|0,b+68|0,0);yz(a+696|0,b+88|0,5);d=a+806|0;v[b>>2]=w[d|0]|w[d+1|0]<<8;d=a+808|0;g=w[d|0];b:{if(t[d|0]<0){t[b+34|0]=g-127;break b}if(!(!(t[a|0]&1)|g>>>0>16)){t[b+31|0]=w[d|0]+1;break b}if(!w[d|0]|w[d|0]>16){break b}t[b+31|0]=w[d|0]+1}if(w[b+31|0]){c:{d:{if((c|0)==4){d=a+810|0;break d}d=a+809|0;if(t[d|0]>=0){u[b+28>>1]=w[d|0]+1}d=a+810|0;if(t[d|0]<0){break c}}t[b+30|0]=w[d|0]+1}t[b+33|0]=w[a+811|0]}if((c|0)==32){t[e+15|0]=w[a+812|0];t[e+14|0]=128;j=b,k=w[pc(e+15|0,e+14|0)|0]>>>1|0,v[j+4>>2]=k}c=a+813|0;if((w[c|0]|w[c+1|0]<<8)>>>0<=256){v[b+8>>2]=w[c|0]|w[c+1|0]<<8;t[b+15|0]=w[b+15|0]|1}t[b+16|0]=w[a+815|0];t[b+26|0]=w[a+816|0];t[b+27|0]=w[a+817|0];t[b+17|0]=w[a+818|0];t[b+18|0]=w[a+819|0];c=a+820|0;u[e+12>>1]=w[c|0]|w[c+1|0]<<8;u[e+10>>1]=100;j=b,k=w[Af(e+12|0,e+10|0)|0],t[j+20|0]=k;c=a+822|0;u[e+8>>1]=w[c|0]|w[c+1|0]<<8;u[e+6>>1]=256;j=b,k=x[Af(e+8|0,e+6|0)>>1]>>>2|0,t[j+19|0]=k;c=a+824|0;Hu(b,w[c|0]&127,w[c|0]>>>7|0);a=a+825|0;Gu(b,w[a|0]&127,w[a|0]>>>7|0);jb=e+16|0}function nda(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;d=jb-48|0;jb=d;e=YM(d+32|0,1<<v[b+12>>2]);if(Ig(a)){while(1){g=A[Vk(a,c)>>3];XM(sc(e,c),g);c=c+1|0;if(Ig(a)>>>0>c>>>0){continue}break}}v[113382]=0;R(1179,b|0,e|0);c=v[113382];v[113382]=0;a:{if((c|0)==1){break a}h=d,i=ac(e),v[h>>2]=i;h=d,i=bc(e),v[h+24>>2]=i;b:{if(Jb(d,d+24|0)){while(1){c=v[d>>2];v[113382]=0;g=+la(1180,c|0);f=v[113382];v[113382]=0;if((f|0)==1){break b}XM(c,Bo(g));Xf(d);if(Jb(d,d+24|0)){continue}break}}v[113382]=0;R(1181,b|0,e|0);c=v[113382];v[113382]=0;if((c|0)==1){break a}v[113382]=0;Z(1182,e|0);c=v[113382];v[113382]=0;if((c|0)==1){break a}if(jd(e)>>>0>3){c=1;while(1){Gy(sc(e,c),2);Gy(sc(e,(jd(e)>>>1|0)+c|0),0);c=c+1|0;if(c>>>0<jd(e)>>>1>>>0){continue}break}}v[113382]=0;R(1179,b|0,e|0);c=v[113382];v[113382]=0;if((c|0)==1){break a}h=d,i=ac(e),v[h+24>>2]=i;h=d,i=bc(e),v[h+16>>2]=i;if(Jb(d+24|0,d+16|0)){while(1){c=v[d+24>>2];v[113382]=0;R(1183,d|0,c|0);f=v[113382];v[113382]=0;if((f|0)==1){break b}f=v[d+4>>2];v[c>>2]=v[d>>2];v[c+4>>2]=f;f=v[d+12>>2];v[c+8>>2]=v[d+8>>2];v[c+12>>2]=f;c=d+24|0;Xf(c);if(Jb(c,d+16|0)){continue}break}}v[113382]=0;R(1181,b|0,e|0);b=v[113382];v[113382]=0;if((b|0)==1){break a}v[113382]=0;Z(1182,e|0);b=v[113382];v[113382]=0;if((b|0)==1){break a}if(Ig(a)){c=0;while(1){g=A[sc(e,c)>>3];h=Vk(a,c),j=g,A[h>>3]=j;c=c+1|0;if(Ig(a)>>>0>c>>>0){continue}break}}kp(e);jb=d+48|0;return}}a=P()|0;O()|0;kp(e);S(a|0);L()}function VU(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=jb-48|0;jb=g;Ic(b);Gq(a);a:{if(!Hf(b,g+40|0)){break a}if(!DC(g+40|0)){break a}if(!c){i=1;break a}if(!Rb(b,4)){break a}kv(a);o=g,p=jv(),v[o+24>>2]=p;c=g+24|0;iv(Wg(a)+28|0,c);Fq(c);j=v[Wg(a)+28>>2];c=Kj(b);if(c&1){break a}d=c-4|0;Nc(b,d);c=le(b);c=le(b)<<8|c<<16|le(b);if(!c){break a}v[113382]=0;R(295,j|0,c|0);f=v[113382];v[113382]=0;i=1;if((f|0)==1){a=V(66740)|0;if((O()|0)==(ga(66740)|0)){_(a|0)|0;$();i=0;break a}S(a|0);L()}Nc(b,4);f=CC(b);k=Eb(v[j>>2]);e=jb-32|0;jb=e;t[e+24|0]=w[f|0];t[e+25|0]=w[f+1|0];t[e+26|0]=w[f+2|0];t[e+27|0]=w[f+3|0];b=BC(e+8|0);d=d+f|0;v[b+12>>2]=d-4;v[b+8>>2]=f;Ti(b,w[d-1|0]);f=c;b:{if(!c){break b}while(1){if(!Ti(b,1)){v[e+4>>2]=1;while(1){d=Ti(b,2);v[e+4>>2]=d+v[e+4>>2];if((d|0)==3){continue}break}tc(e+4|0,c);d=0;if(v[e+4>>2]){while(1){c=c-1|0;o=k+c|0,p=Ti(b,8),t[o|0]=p;d=d+1|0;if(d>>>0<y[e+4>>2]){continue}break}}if(!c){break b}}d=Ti(b,2);v[e+4>>2]=d+2;c:{if((d|0)==3){d=b;if(Ti(b,1)){h=w[ec(e+24|0,3)|0]}else{h=7}l=Ti(d,h);while(1){d=Ti(b,3);v[e+4>>2]=d+v[e+4>>2];if((d|0)==7){continue}break}break c}l=Ti(b,w[ec(e+24|0,d)|0])}tc(e+4|0,c);h=0;m=v[e+4>>2];if(m){while(1){d=0;n=c+l|0;if(f>>>0>n>>>0){d=w[k+n|0]}c=c-1|0;t[k+c|0]=d;h=h+1|0;if((m|0)!=(h|0)){continue}break}}if(c){continue}break}}jb=e+32|0;b=g+8|0;Vi(b,j);c=g+16|0;ev(c,b);b=fo(g+24|0,c,0);Qd(Wg(a)+12|0,b);Bb(b)}jb=g+48|0;return i|0}function NK(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=jb-16|0;jb=c;d=B(b,896)+a|0;a:{if(v[d+1075072>>2]&134218752){break a}if(!oj(d+1074984|0)){break a}h=v[(B(b,896)+a|0)+1075640>>2];if(w[h+15|0]&2){break a}d=xl(a,b,2,1);if((d-1&255)>>>0>249){break a}g=v[(B(d,160)+a|0)+906140>>2];if(!g){break a}e=B(b,896)+a|0;d=w[e+1075794|0];b:{if(w[e+1075796|0]==1){t[c+8|0]=64;f=w[pc(e+1075798|0,c+8|0)|0];break b}f=255;if(w[e+1075797|0]!=13){break b}t[c+8|0]=64;f=w[pc((B(b,896)+a|0)+1075799|0,c+8|0)|0]}e=c+8|0;j=a+1074312|0;Fb(e,j,2);if(Cb(e)){if(d){e=a;f=b;if(Xd(d)){d=w[ec(h+108|0,d-1|0)|0]}yl(e,f,d,x[(B(b,896)+a|0)+1075672>>1]);break a}if((f|0)==255){break a}nb[v[v[g>>2]+76>>2]](g,39,f,b);break a}k=v[h+4>>2];if(d){e=w[h+35|0]?k<<2:v[(B(b,896)+a|0)+1075672>>2];i=u[(B(b,896)+a|0)+1075772>>1];l=c+8|0;Fb(l,j,28);m=c,n=(Cb(l)?i<<2:i)+e|0,v[m+4>>2]=n;Yd(c+4|0,0,256);e=d;i=b;if(Xd(d)){e=w[ec(h+108|0,d-1|0)|0]}yl(a,i,e&255,x[c+4>>1])}e=w[h+35|0];a=c+8|0;Fb(a,j,101);i=(f|0)!=255;if(Cb(a)){a=(d|0)!=0}else{a=Xd(d)}if(!(a?0:i)&(!a|(e|0)!=1)){break a}c:{switch(w[h+36|0]){case 1:if((f|0)!=255){gJ(g,f<<1);break a}gJ(g,k<<1);break a;case 0:break c;default:break a}}if((f|0)!=255){t[c+8|0]=127;t[c+4|0]=f<<1;n=g,o=7,p=w[pc(c+8|0,c+4|0)|0],q=b,m=v[v[g>>2]+76>>2],nb[m](n|0,o|0,p|0,q|0);break a}v[c+8>>2]=127;v[c+4>>2]=k<<1;q=g,p=7,o=w[Lb(c+8|0,c+4|0)|0],n=b,m=v[v[g>>2]+76>>2],nb[m](q|0,p|0,o|0,n|0)}jb=c+16|0}function Gfa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0;b=jb-48|0;jb=b;s=v[a+16>>2];j=v[a+44>>2];v[b+32>>2]=j;l=v[a+48>>2];v[b+36>>2]=l;g=v[a+52>>2];v[b+40>>2]=g;h=v[a+56>>2];v[b+44>>2]=h;m=v[a+40>>2];n=v[a+36>>2];e=v[a+4>>2];i=v[a>>2];v[b+24>>2]=i;v[b+28>>2]=e;f=v[a+12>>2];v[b+16>>2]=v[a+8>>2];v[b+20>>2]=f;a:{if(d){while(1){e=(((e&2147483647)<<1|i>>>31)&-2)+s|0;h=t[e|0]<<8;v[b+8>>2]=h;v[b+12>>2]=t[e+1|0]<<8;f=0;l=1;while(1){g=v[a+60>>2];k=g;i=(b+32|0)+(f<<3)|0;o=v[i>>2];e=Yb(o,-16777216,16776704);r=v[a+64>>2];j=Yb(v[i+4>>2],-16777216,16776704);p=v[a+68>>2];u=p;p=p>>31;v[i+4>>2]=o;o=v[a+72>>2];q=g>>31;h=h<<8;g=h;g=qma(k,q,g,g>>31);k=mb;q=(b+8|0)+(f<<2)|0;f=g;g=qma(r,r>>31,e,e>>31);f=f+g|0;e=mb+k|0;e=f>>>0<g>>>0?e+1|0:e;j=qma(u,p,j,j>>31);f=j+f|0;e=mb+e|0;e=f>>>0<j>>>0?e+1|0:e;f=f+8388608|0;e=f>>>0<8388608?e+1|0:e;e=(e&16777215)<<8|f>>>24;v[q>>2]=(e|0)/256;v[i>>2]=e-(h&o);if(l){f=1;l=0;h=v[b+12>>2];continue}break}e=v[a+32>>2];n=v[a+28>>2]+n|0;f=n>>12;v[c>>2]=v[c>>2]+B(f,v[b+8>>2]);m=e+m|0;k=m>>12;v[c+4>>2]=v[c+4>>2]+B(k,v[b+12>>2]);Sb(b+24|0,b+16|0);d=d-1|0;if(d){c=c+8|0;i=v[b+24>>2];e=v[b+28>>2];continue}break}i=v[b+24>>2];e=v[b+28>>2];h=v[b+44>>2];g=v[b+40>>2];l=v[b+36>>2];j=v[b+32>>2];break a}k=m>>12;f=n>>12}v[a+40>>2]=m;v[a+20>>2]=f;v[a+36>>2]=n;v[a+56>>2]=h;v[a+52>>2]=g;v[a+48>>2]=l;v[a+44>>2]=j;v[a+24>>2]=k;v[a>>2]=i;v[a+4>>2]=e;jb=b+48|0}function _2(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;b=jb-176|0;jb=b;d=Ub(b+8|0,7634);v[113382]=0;Q(121,b+20|0,7031)|0;e=v[113382];v[113382]=0;c=1;a:{b:{if((e|0)==1){break b}v[113382]=0;Q(121,b+32|0,7464)|0;c=v[113382];v[113382]=0;if((c|0)==1){c=2;break b}v[113382]=0;Q(121,b+44|0,7023)|0;c=v[113382];v[113382]=0;if((c|0)==1){c=3;break b}v[113382]=0;Q(121,b+56|0,4517)|0;c=v[113382];v[113382]=0;if((c|0)==1){c=4;break b}v[113382]=0;Q(121,b+68|0,7008)|0;c=v[113382];v[113382]=0;if((c|0)==1){c=5;break b}v[113382]=0;Q(121,b+80|0,4583)|0;c=v[113382];v[113382]=0;if((c|0)==1){c=6;break b}v[113382]=0;Q(121,b+92|0,2106)|0;c=v[113382];v[113382]=0;if((c|0)==1){c=7;break b}v[113382]=0;Q(121,b+104|0,8002)|0;c=v[113382];v[113382]=0;if((c|0)==1){c=8;break b}v[113382]=0;Q(121,b+116|0,7407)|0;c=v[113382];v[113382]=0;if((c|0)==1){c=9;break b}v[113382]=0;Q(121,b+128|0,8193)|0;c=v[113382];v[113382]=0;if((c|0)==1){c=10;break b}v[113382]=0;Q(121,b+140|0,1958)|0;c=v[113382];v[113382]=0;if((c|0)==1){c=11;break b}v[113382]=0;Q(121,b+152|0,3559)|0;c=v[113382];v[113382]=0;if((c|0)==1){c=12;break b}v[113382]=0;v[b+172>>2]=13;v[b+168>>2]=d;c=v[b+172>>2];v[b>>2]=v[b+168>>2];v[b+4>>2]=c;Q(2146,a|0,b|0)|0;a=v[113382];v[113382]=0;if((a|0)!=1){c=b+164|0;while(1){c=yb(c-12|0);if((d|0)!=(c|0)){continue}break}jb=b+176|0;return}c=b+164|0;break a}c=(b+8|0)+B(c,12)|0}a=P()|0;O()|0;while(1){c=yb(c-12|0);if((d|0)!=(c|0)){continue}break}S(a|0);L()}function IG(a){var b=0,c=0,d=0,e=0;Sd(a,v[a+20>>2]);if(v[a+24>>2]>0){while(1){Sd(a,v[v[a+28>>2]+(b<<2)>>2]);b=b+1|0;if((b|0)<v[a+24>>2]){continue}break}}Sd(a,v[a+28>>2]);a:{b=v[a+396>>2];if(!b|v[a+264>>2]<=0){break a}while(1){c=B(e,24)+b|0;b=v[c+16>>2];if(b){d=a;if(v[(v[a+124>>2]+B(w[c+13|0],2096)|0)+4>>2]>0){Sd(a,v[b>>2]);b=1;if(v[(v[a+124>>2]+B(w[c+13|0],2096)|0)+4>>2]>=2){while(1){Sd(a,v[v[c+16>>2]+(b<<2)>>2]);b=b+1|0;if((b|0)<v[(v[a+124>>2]+B(w[c+13|0],2096)|0)+4>>2]){continue}break}}b=v[c+16>>2]}Sd(d,b)}Sd(a,v[c+20>>2]);e=e+1|0;if((e|0)>=v[a+264>>2]){break a}b=v[a+396>>2];continue}}b=v[a+124>>2];if(b){d=a;if(v[a+120>>2]>0){c=0;while(1){b=B(c,2096)+b|0;Sd(a,v[b+8>>2]);Sd(a,v[b+28>>2]);Sd(a,v[b+32>>2]);Sd(a,v[b+2084>>2]);b=v[b+2088>>2];Sd(a,b?b-4|0:0);c=c+1|0;if((c|0)<v[a+120>>2]){b=v[a+124>>2];continue}break}b=v[a+124>>2]}Sd(d,b)}Sd(a,v[a+260>>2]);Sd(a,v[a+396>>2]);d=v[a+404>>2];if(d){b=1;c=a;if(v[a+400>>2]>0){Sd(a,v[d+4>>2]);if(v[a+400>>2]>=2){while(1){Sd(a,v[(v[a+404>>2]+B(b,40)|0)+4>>2]);b=b+1|0;if((b|0)<v[a+400>>2]){continue}break}}d=v[a+404>>2]}Sd(c,d)}c=1;b:{if(v[a+4>>2]<=0){break b}b=0;while(1){d=(b<<2)+a|0;Sd(a,v[d+800>>2]);Sd(a,v[d+928>>2]);Sd(a,v[d+996>>2]);if(b>>>0>14){break b}b=b+1|0;if((b|0)<v[a+4>>2]){continue}break}}b=0;while(1){b=(b<<2)+a|0;Sd(a,v[b+1068>>2]);Sd(a,v[b+1076>>2]);Sd(a,v[b+1084>>2]);Sd(a,v[b+1092>>2]);Sd(a,v[b+1100>>2]);b=1;d=c&1;c=0;if(d){continue}break}}function tfa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0;e=jb-48|0;jb=e;o=v[a+16>>2];f=v[a+44>>2];v[e+32>>2]=f;h=v[a+48>>2];v[e+36>>2]=h;l=v[a+52>>2];v[e+40>>2]=l;i=v[a+56>>2];v[e+44>>2]=i;p=v[a+24>>2];q=v[a+20>>2];b=v[a+4>>2];g=v[a>>2];v[e+24>>2]=g;v[e+28>>2]=b;j=v[a+12>>2];v[e+16>>2]=v[a+8>>2];v[e+20>>2]=j;r=a;if(d){while(1){j=g>>>18|0;l=1;i=((((b&2147483647)<<1|g>>>31)&2147483646)<<1)+o|0;f=0;b=1;h=0;while(1){k=h<<1;g=u[k+i>>1];v[(e+8|0)+(h<<2)>>2]=g+((B(j,u[i+(k|4)>>1]-g|0)|0)/16384|0);g=b;b=0;h=1;if(g){continue}break}while(1){h=(e+8|0)+(f<<2)|0;j=v[h>>2];k=v[a+60>>2];g=(e+32|0)+(f<<3)|0;f=v[g>>2];b=Yb(f,-16777216,16776704);n=v[a+64>>2];i=Yb(v[g+4>>2],-16777216,16776704);m=v[a+68>>2];s=m;m=m>>31;v[g+4>>2]=f;t=v[a+72>>2];j=j<<8;f=j;f=qma(k,k>>31,f,f>>31);k=mb;w=h;h=qma(n,n>>31,b,b>>31);f=h+f|0;b=mb+k|0;b=f>>>0<h>>>0?b+1|0:b;h=f;f=qma(s,m,i,i>>31);i=h+f|0;b=mb+b|0;b=f>>>0>i>>>0?b+1|0:b;i=i+8388608|0;b=i>>>0<8388608?b+1|0:b;b=(b&16777215)<<8|i>>>24;v[w>>2]=(b|0)/256;v[g>>2]=b-(j&t);f=1;b=l&1;l=0;if(b){continue}break}v[c>>2]=v[c>>2]+B(v[e+8>>2],q);v[c+4>>2]=v[c+4>>2]+B(v[e+12>>2],p);Sb(e+24|0,e+16|0);d=d-1|0;if(d){c=c+8|0;g=v[e+24>>2];b=v[e+28>>2];continue}break}g=v[e+24>>2];b=v[e+28>>2];l=v[e+40>>2];h=v[e+36>>2];f=v[e+32>>2];i=v[e+44>>2]}v[r+56>>2]=i;v[a+52>>2]=l;v[a+48>>2]=h;v[a+44>>2]=f;v[a>>2]=g;v[a+4>>2]=b;jb=e+48|0}function mX(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;c=v[16561];b=jb-16|0;jb=b;d=er(458276);v[114579]=458332;v[114577]=c;v[114569]=66260;t[458328]=0;v[114581]=-1;e=b+8|0;_q(e,d);f=v[v[114569]+8>>2];v[113382]=0;R(f|0,458276,e|0);e=v[113382];v[113382]=0;a:{if((e|0)!=1){Ob(b+8|0);jb=b+16|0;break a}a=P()|0;O()|0;Ob(b+8|0);$k(d);S(a|0);L()}b=Sr(457600);v[114398]=65004;v[b>>2]=65024;v[114399]=0;v[113382]=0;R(2798,b|0,458276);d=v[113382];v[113382]=0;b:{if((d|0)==1){break b}b=jb-16|0;jb=b;d=kE(458340);v[114595]=458396;v[114593]=c;v[114585]=66360;t[458392]=0;v[114597]=-1;c=b+8|0;_q(c,d);e=v[v[114585]+8>>2];v[113382]=0;R(e|0,458340,c|0);c=v[113382];v[113382]=0;c:{if((c|0)!=1){Ob(b+8|0);jb=b+16|0;break c}a=P()|0;O()|0;Ob(b+8|0);mo(d);S(a|0);L()}b=XD(457688);v[114420]=65052;v[b>>2]=65072;v[114421]=0;v[113382]=0;R(2799,b|0,458340);c=v[113382];v[113382]=0;if((c|0)==1){break b}b=v[16562];_D(458404,b,458452);Fv(457768,458404);ZD(458460,b,458508);Ev(457852,458460);b=v[12140];_D(458516,b,458564);Fv(457936,458516);Fv(458104,v[(v[v[114484]-12>>2]+457936|0)+24>>2]);ZD(458572,b,458620);Ev(458020,458572);Ev(458188,v[(v[v[114505]-12>>2]+458020|0)+24>>2]);Vq(v[v[114398]-12>>2]+457592|0,457768);Vq(v[v[114420]-12>>2]+457680|0,457852);YD(v[v[114484]-12>>2]+457936|0);YD(v[v[114505]-12>>2]+458020|0);Vq(v[v[114484]-12>>2]+457936|0,457768);Vq(v[v[114505]-12>>2]+458020|0,457852);return a|0}a=P()|0;O()|0;_g(b);S(a|0);L()}function j$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;k=jb-16|0;jb=k;l=Yv(g);g=Xv(g);vg(k,g);a:{b:{if(Sc(k)){v[113382]=0;aa(2353,l|0,a|0,c|0,d|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break b}g=(c-a<<2)+d|0;v[f>>2]=g;break a}v[f>>2]=d;c:{d:{j=a;h=w[j|0];switch(h-43|0){case 0:case 2:break d;default:break c}}v[113382]=0;j=Q(2366,l|0,h<<24>>24)|0;h=v[113382];v[113382]=0;if((h|0)==1){break b}h=v[f>>2];v[f>>2]=h+4;v[h>>2]=j;j=a+1|0}if(!(w[j|0]!=48|(c-j|0)<2|(w[j+1|0]|32)!=120)){v[113382]=0;h=Q(2366,l|0,48)|0;i=v[113382];v[113382]=0;if((i|0)==1){break b}i=v[f>>2];v[f>>2]=i+4;v[i>>2]=h;h=t[j+1|0];v[113382]=0;h=Q(2366,l|0,h|0)|0;i=v[113382];v[113382]=0;if((i|0)==1){break b}i=v[f>>2];v[f>>2]=i+4;v[i>>2]=h;j=j+2|0}i=0;v[113382]=0;Zj(j,c);h=v[113382];v[113382]=0;if((h|0)==1){break b}v[113382]=0;o=T(2350,g|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break b}h=0;g=j;while(1){e:{if(c>>>0<=g>>>0){g=v[f>>2];v[113382]=0;uo((j-a<<2)+d|0,g);g=v[113382];v[113382]=0;if((g|0)==1){break e}g=v[f>>2];break a}f:{if(!w[kc(k,h)|0]){break f}if(t[kc(k,h)|0]!=(i|0)){break f}i=v[f>>2];v[f>>2]=i+4;v[i>>2]=o;h=(Db(k)-1>>>0>h>>>0)+h|0;i=0}n=t[g|0];v[113382]=0;n=Q(2366,l|0,n|0)|0;m=v[113382];v[113382]=0;if((m|0)!=1){m=v[f>>2];v[f>>2]=m+4;v[m>>2]=n;g=g+1|0;i=i+1|0;continue}}break}}a=P()|0;O()|0;yb(k);S(a|0);L()}v[e>>2]=(b|0)==(c|0)?g:(b-a<<2)+d|0;yb(k);jb=k+16|0}function ufa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0;e=jb-48|0;jb=e;q=v[a+16>>2];f=v[a+44>>2];v[e+32>>2]=f;i=v[a+48>>2];v[e+36>>2]=i;b=v[a+52>>2];v[e+40>>2]=b;l=v[a+56>>2];v[e+44>>2]=l;r=v[a+24>>2];s=v[a+20>>2];h=v[a+4>>2];g=v[a>>2];v[e+24>>2]=g;v[e+28>>2]=h;k=v[a+12>>2];v[e+16>>2]=v[a+8>>2];v[e+20>>2]=k;if(d){while(1){k=g>>>10&4194048;g=(((h&2147483647)<<1|g>>>31)&-2)+q|0;i=0;l=1;b=1;f=0;while(1){h=t[g+f|0];v[(e+8|0)+(f<<2)>>2]=((B(k,t[g+(f|2)|0]-h|0)|0)/16384|0)+(h<<8);h=b;b=0;f=1;if(h){continue}break}while(1){f=(e+8|0)+(i<<2)|0;k=v[f>>2];j=v[a+60>>2];n=j;h=(e+32|0)+(i<<3)|0;i=v[h>>2];b=Yb(i,-16777216,16776704);p=v[a+64>>2];g=Yb(v[h+4>>2],-16777216,16776704);m=v[a+68>>2];u=m;m=m>>31;v[h+4>>2]=i;i=v[a+72>>2];o=j>>31;k=k<<8;j=k;j=qma(n,o,j,j>>31);n=mb;o=f;f=j;j=qma(p,p>>31,b,b>>31);f=f+j|0;b=mb+n|0;b=f>>>0<j>>>0?b+1|0:b;j=f;f=qma(u,m,g,g>>31);g=j+f|0;b=mb+b|0;b=g>>>0<f>>>0?b+1|0:b;g=g+8388608|0;b=g>>>0<8388608?b+1|0:b;b=(b&16777215)<<8|g>>>24;v[o>>2]=(b|0)/256;v[h>>2]=b-(i&k);i=1;b=l&1;l=0;if(b){continue}break}v[c>>2]=v[c>>2]+B(v[e+8>>2],s);v[c+4>>2]=v[c+4>>2]+B(v[e+12>>2],r);Sb(e+24|0,e+16|0);d=d-1|0;if(d){c=c+8|0;g=v[e+24>>2];h=v[e+28>>2];continue}break}g=v[e+24>>2];h=v[e+28>>2];l=v[e+44>>2];i=v[e+36>>2];f=v[e+32>>2];b=v[e+40>>2]}v[a+56>>2]=l;v[a+52>>2]=b;v[a+48>>2]=i;v[a+44>>2]=f;v[a>>2]=g;v[a+4>>2]=h;jb=e+48|0}function xja(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=jb-32|0;jb=h;v[h+28>>2]=d;a:{if(w[a+8|0]){d=a+12|0;r=h,s=wc(d)-c|0,v[r+24>>2]=s;e=h+24|0;a=v[Lb(e,h+28|0)>>2];r=h,s=ac(d),v[r+24>>2]=s;e=ff(e,c);r=h,s=ac(d),v[r+8>>2]=s;r=h,s=ff(h+8|0,c),v[r+16>>2]=s;wj(e,ff(h+16|0,a),b);break a}e=jb-32|0;jb=e;v[e+28>>2]=d;b:{c:{if(w[a+24|0]){if(!d){break b}m=a+40|0;break c}n=nb[v[v[a>>2]+44>>2]](a,b,c,d)|0;break b}while(1){j=e;o=c;l=m;i=0;k=jb-16|0;jb=k;f=a;p=f+40|0;g=f+232|0;q=c-(c&4095)|0;d:{while(1){e:{d=v[Xe(g,i)>>2];if(!w[Gi(p,d)+8|0]){break e}if(v[Gi(p,d)>>2]!=(q|0)){break e}r=k,s=v[Xe(g,i)>>2],v[r+8>>2]=s;f=i<<2;Gp(g,f+g|0,(g+f|0)+4|0);f=v[k+8>>2];r=Xe(g,0),s=f,v[r>>2]=s;break d}i=i+1|0;if((i|0)!=16){continue}break}r=k,s=v[Xe(g,15)>>2],v[r+8>>2]=s;Gp(g,g+60|0,g- -64|0);i=k+8|0;d=v[i>>2];r=Xe(g,0),s=d,v[r>>2]=s;d=v[Xe(g,0)>>2];g=Gi(p,d);v[g>>2]=q;Vz(i,f,d);r=g,s=nb[v[v[f>>2]+44>>2]](f,v[i>>2],q,4096)|0,v[r+4>>2]=s;t[g+8|0]=1}jb=k+16|0;f=j;j=o-v[Gi(l,d)>>2]|0;v[f+8>>2]=4096-j;r=e,s=v[Lb(e+8|0,e+28|0)>>2],v[r+24>>2]=s;f=e;if(j>>>0<y[Gi(m,d)+4>>2]){l=v[Gi(m,d)+4>>2]-j|0}else{l=0}v[f+20>>2]=l;f=v[Lb(e+24|0,e+20|0)>>2];Vz(e+8|0,a,d);o=v[e+8>>2];Vz(e,a,d);kf(j+o|0,f+(j+v[e>>2]|0)|0,b);d=v[e+28>>2]-f|0;v[e+28>>2]=d;n=f+n|0;if(f>>>0<y[e+24>>2]){break b}c=c+f|0;b=b+f|0;if(d){continue}break}}jb=e+32|0;a=n}jb=h+32|0;return a|0}function u$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;k=jb-16|0;jb=k;l=yu(g);g=cw(g);vg(k,g);a:{b:{if(Sc(k)){v[113382]=0;aa(2330,l|0,a|0,c|0,d|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break b}g=(c-a|0)+d|0;v[f>>2]=g;break a}v[f>>2]=d;c:{d:{j=a;h=w[j|0];switch(h-43|0){case 0:case 2:break d;default:break c}}v[113382]=0;j=Q(22,l|0,h<<24>>24)|0;h=v[113382];v[113382]=0;if((h|0)==1){break b}h=v[f>>2];v[f>>2]=h+1;t[h|0]=j;j=a+1|0}if(!(w[j|0]!=48|(c-j|0)<2|(w[j+1|0]|32)!=120)){v[113382]=0;h=Q(22,l|0,48)|0;i=v[113382];v[113382]=0;if((i|0)==1){break b}i=v[f>>2];v[f>>2]=i+1;t[i|0]=h;h=t[j+1|0];v[113382]=0;h=Q(22,l|0,h|0)|0;i=v[113382];v[113382]=0;if((i|0)==1){break b}i=v[f>>2];v[f>>2]=i+1;t[i|0]=h;j=j+2|0}i=0;v[113382]=0;Zj(j,c);h=v[113382];v[113382]=0;if((h|0)==1){break b}v[113382]=0;o=T(2321,g|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break b}h=0;g=j;while(1){e:{if(c>>>0<=g>>>0){g=v[f>>2];v[113382]=0;Zj((j-a|0)+d|0,g);g=v[113382];v[113382]=0;if((g|0)==1){break e}g=v[f>>2];break a}f:{if(!w[kc(k,h)|0]){break f}if(t[kc(k,h)|0]!=(i|0)){break f}i=v[f>>2];v[f>>2]=i+1;t[i|0]=o;h=(Db(k)-1>>>0>h>>>0)+h|0;i=0}n=t[g|0];v[113382]=0;n=Q(22,l|0,n|0)|0;m=v[113382];v[113382]=0;if((m|0)!=1){m=v[f>>2];v[f>>2]=m+1;t[m|0]=n;g=g+1|0;i=i+1|0;continue}}break}}a=P()|0;O()|0;yb(k);S(a|0);L()}v[e>>2]=(b|0)==(c|0)?g:(b-a|0)+d|0;yb(k);jb=k+16|0}function ZY(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0;a=jb-16|0;jb=a;v[a+12>>2]=c;v[a+8>>2]=f;v[a+12>>2]=c;v[a+8>>2]=f;c=v[a+12>>2];a:{b:{while(1){if(c>>>0>=d>>>0){f=0;break a}f=2;b=x[c>>1];if(b>>>0>1114111){break a}c:{d:{if(b>>>0<=127){f=1;c=v[a+8>>2];if((g-c|0)<=0){break a}v[a+8>>2]=c+1;t[c|0]=b;break d}if(b>>>0<=2047){c=v[a+8>>2];if((g-c|0)<2){break b}v[a+8>>2]=c+1;t[c|0]=b>>>6|192;c=v[a+8>>2];v[a+8>>2]=c+1;t[c|0]=b&63|128;break d}if(b>>>0<=55295){c=v[a+8>>2];if((g-c|0)<3){break b}v[a+8>>2]=c+1;t[c|0]=b>>>12|224;c=v[a+8>>2];v[a+8>>2]=c+1;t[c|0]=b>>>6&63|128;c=v[a+8>>2];v[a+8>>2]=c+1;t[c|0]=b&63|128;break d}if(b>>>0<=56319){f=1;if((d-c|0)<4){break a}i=x[c+2>>1];if((i&64512)!=56320){break c}if((g-v[a+8>>2]|0)<4){break a}f=b&960;if((i&1023|(b<<10&64512|f<<10))+65536>>>0>1114111){break c}v[a+12>>2]=c+2;c=v[a+8>>2];v[a+8>>2]=c+1;j=c;c=(f>>>6|0)+1|0;t[j|0]=c>>>2|240;f=v[a+8>>2];v[a+8>>2]=f+1;t[f|0]=c<<4&48|b>>>2&15|128;c=v[a+8>>2];v[a+8>>2]=c+1;t[c|0]=i>>>6&15|b<<4&48|128;b=v[a+8>>2];v[a+8>>2]=b+1;t[b|0]=i&63|128;break d}if(b>>>0<57344){break a}c=v[a+8>>2];if((g-c|0)<3){break b}v[a+8>>2]=c+1;t[c|0]=b>>>12|224;c=v[a+8>>2];v[a+8>>2]=c+1;t[c|0]=b>>>6&63|128;c=v[a+8>>2];v[a+8>>2]=c+1;t[c|0]=b&63|128}c=v[a+12>>2]+2|0;v[a+12>>2]=c;continue}break}f=2;break a}f=1}v[e>>2]=v[a+12>>2];v[h>>2]=v[a+8>>2];jb=a+16|0;return f|0}function Hy(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;a:{i=255;b:{c:{e=a;f=e+58|0;d=b;b=w[ec(f,d)|0];if((b|0)==255){break c}if(t[ec(f,d)|0]>=0){break b}g=e+22|0;b=b&127;if(x[_c(g,b)>>1]!=65535){if((d|0)!=x[_c(g,b)>>1]){break c}}k=_c(g,b),l=d,u[k>>1]=l;k=ec(f,d),l=b,t[k|0]=l;break b}j=e+4|0;h=e+22|0;b=0;g=255;while(1){if(x[_c(h,b)>>1]==65535){k=_c(h,b),l=d,u[k>>1]=l;k=ec(f,d),l=b,t[k|0]=l;break b}if(!(w[ec(j,b)|0]&32)){i=t[ec(f,x[_c(h,b)>>1])|0]>=0?i:b;g=b}b=b+1|0;if((b|0)!=18){continue}break}if((g&255)!=255){b=(i&255)==255?g:i;g=b&255;k=ec(f,x[_c(h,g)>>1]),l=255,t[k|0]=l;k=_c(h,g),l=d,u[k>>1]=l;k=ec(f,d),l=b,t[k|0]=l}b=vk(e,d)}g=b&255;if((g|0)==255){break a}b=0;if(qj(a)){break a}e=Gi(a+314|0,g);d=w[c+8|0]|w[c+9|0]<<8|(w[c+10|0]<<16|w[c+11|0]<<24);t[e+8|0]=d;t[e+9|0]=d>>>8;t[e+10|0]=d>>>16;t[e+11|0]=d>>>24;d=w[c+4|0]|w[c+5|0]<<8|(w[c+6|0]<<16|w[c+7|0]<<24);f=w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24);t[e|0]=f;t[e+1|0]=f>>>8;t[e+2|0]=f>>>16;t[e+3|0]=f>>>24;t[e+4|0]=d;t[e+5|0]=d>>>8;t[e+6|0]=d>>>16;t[e+7|0]=d>>>24;f=gN(g);h=f+3|0;d=1;while(1){e=d;d=d?f:h;jh(v[a>>2],(d|32)&65535,w[ec(c,b)|0]);jh(v[a>>2],(d|64)&65535,w[ec(c,b|2)|0]);jh(v[a>>2],(d|96)&65535,w[ec(c,b|4)|0]);jh(v[a>>2],(d|128)&65535,w[ec(c,b|6)|0]);jh(v[a>>2],(d|224)&65535,w[ec(c,b|8)|0]);d=0;b=1;if(e){continue}break}jh(v[a>>2],Ss(g)|192,w[ec(c,10)|0])}}function W6(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=C(0),o=C(0),p=0,q=0,r=C(0),s=0;g=jb-16|0;jb=g;m=a+44|0;if(vh(m)){j=Jd(m,0);k=Jd(m,1);h=ed(m,0);i=ed(m,1);r=z[a+4212>>2];v[g+12>>2]=d;if(d){e=v[a+4224>>2];while(1){s=a;f=v[a+4220>>2];a:{if(f>>>0>e>>>0){v[g+8>>2]=f-e;f=v[Lb(g+12|0,g+8|0)>>2];b:{if(!(r<C(1))){e=0;if(!f){break b}while(1){z[h>>2]=z[j>>2];z[i>>2]=z[k>>2];i=i+4|0;k=k+4|0;h=h+4|0;j=j+4|0;e=e+1|0;if((f|0)!=(e|0)){continue}break}break b}e=v[a+4224>>2];l=f+e|0;if(e>>>0>=l>>>0){break b}o=C(C(1)/C(y[a+4220>>2]));while(1){n=C(C(e>>>0)*o);z[h>>2]=n*z[j>>2];z[i>>2]=n*z[k>>2];i=i+4|0;k=k+4|0;h=h+4|0;j=j+4|0;e=e+1|0;if((l|0)!=(e|0)){continue}break}}l=v[g+12>>2]-f|0;v[g+12>>2]=l;e=f+v[a+4224>>2]|0;break a}v[g+4>>2]=v[a+4216>>2]-e;f=v[Lb(g+12|0,g+4|0)>>2];c:{d:{e:{if(!(r<C(1))){e=0;if(f){break e}break d}p=v[a+4216>>2];q=v[a+4224>>2];e=p-q|0;l=e-f|0;if(e>>>0<=l>>>0){break c}o=C(C(1)/C(y[a+4220>>2]));while(1){n=C(C(e>>>0)*o);z[h>>2]=n*z[j>>2];z[i>>2]=n*z[k>>2];i=i+4|0;k=k+4|0;h=h+4|0;j=j+4|0;e=e-1|0;if(l>>>0<e>>>0){continue}break}break c}while(1){v[h>>2]=0;v[i>>2]=0;i=i+4|0;h=h+4|0;e=e+1|0;if((f|0)!=(e|0)){continue}break}}e=f<<2;k=e+k|0;j=e+j|0;p=v[a+4216>>2];q=v[a+4224>>2]}l=v[g+12>>2]-f|0;v[g+12>>2]=l;e=f+q|0;e=e>>>0<p>>>0?e:0}v[s+4224>>2]=e;if(l){continue}break}}pi(a,b,c,ed(m,0),ed(m,1),d)}jb=g+16|0}function DG(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=C(0),j=0,k=0,l=0,m=C(0),n=0,o=0,p=0,q=0,r=0,s=0,t=C(0);d=(b<<2)+a|0;g=d+1068|0;l=c<<1&-4;r=g,s=Nd(a,l),v[r>>2]=s;j=d+1076|0;r=j,s=Nd(a,l),v[r>>2]=s;k=Nd(a,c&-4);v[d+1084>>2]=k;a:{g=v[g>>2];if(!g){break a}j=v[j>>2];if(!j|!k){break a}d=c;b:{if((d|0)<4){break b}m=C(d|0);i=C(C(1)/m);q=d>>>2|0;while(1){n=e<<2;f=+C(C(C(h<<2)*C(3.1415927410125732))*i);r=n+g|0,t=C(we(f)),z[r>>2]=t;o=e|1;p=o<<2;r=p+g|0,t=C(-C(gi(f))),z[r>>2]=t;f=+C(C(C(o|0)*C(1.5707963705062866))*i);r=j+n|0,t=C(C(we(f))*C(.5)),z[r>>2]=t;r=j+p|0,t=C(C(gi(f))*C(.5)),z[r>>2]=t;e=e+2|0;h=h+1|0;if((q|0)!=(h|0)){continue}break}if((d|0)<8){break b}d=d>>3;d=(d|0)>1?d:1;i=C(C(1)/m);e=0;h=0;while(1){g=e|1;f=+C(C(C(g<<1)*C(3.1415927410125732))*i);r=k+(e<<2)|0,t=C(we(f)),z[r>>2]=t;r=k+(g<<2)|0,t=C(-C(gi(f))),z[r>>2]=t;e=e+2|0;h=h+1|0;if((d|0)!=(h|0)){continue}break}}e=(b<<2)+a|0;d=Nd(a,l);v[e+1092>>2]=d;if(!d){break a}b=c;if((b|0)>=2){b=b>>1;h=(b|0)>1?b:1;f=1/+(b|0);b=0;while(1){i=C(gi((+(b|0)*1.5707963705062866+.7853981852531433)*f));r=d+(b<<2)|0,t=C(gi(+C(i*i)*1.5707963705062866)),z[r>>2]=t;b=b+1|0;if((h|0)!=(b|0)){continue}break}}b=Nd(a,c>>2&-2);v[e+1100>>2]=b;if(!b){break a}a=c;d=nl(a);if((a|0)>=8){c=36-d|0;d=a>>>3|0;a=0;while(1){r=b+(a<<1)|0,s=ll(a)>>>c<<2,u[r>>1]=s;a=a+1|0;if((d|0)!=(a|0)){continue}break}}return 1}cc(a,3);return 0}function Px(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;g=jb-16|0;jb=g;i=RK(b,c);a:{if(!v[b+656>>2]|!(t[i|0]&1)){break a}f=v[i+4>>2];e=g+8|0;j=a+1074312|0;Fb(e,j,31);e=Cb(e);d=zu(v[b+656>>2],c);if(id(d)){break a}f=f+(e^1)|0;e=g+8|0;Fb(e,j,31);h=Cb(e);e=w[d+12|0];b:{c:{if(!h){d:{if(!(e&2)){break d}e=x[Pb(d,w[d+14|0])>>1]+!(v[a+480180>>2]&1048580)|0;if(!(!(w[b+89|0]&8)|(!(w[d+12|0]&4)|w[d+14|0]!=w[d+16|0]))){h=g+8|0;Fb(h,j,70);k=Cb(h)}if((e|0)!=(f|0)|k){break d}f=x[Pb(d,w[d+13|0])>>1]}if(!(!(w[d+12|0]&4)|w[b+89|0]&8)){if((x[Pb(d,w[d+16|0])>>1]+1|0)!=(f|0)){break b}f=x[Pb(d,w[d+15|0])>>1];a=g+8|0;Fb(a,j,93);if(!Cb(a)|(c|0)!=1|v[b+88>>2]&2048){break b}t[i|0]=w[i|0]&254;break b}if(x[pj(d)>>1]>=f>>>0){break b}k=1;f=x[pj(d)>>1];break c}e:{f:{if(!(!(e&4)|w[b+669|0]&8)){if(v[i+8>>2]==-1){break f}e=g+8|0;Fb(e,j,97);if(Cb(e)){break f}e=w[d+12|0]}if(e&2){e=x[Pb(d,w[d+13|0])>>1];h=x[Pb(d,w[d+14|0])>>1]+1|0;break e}e=x[pj(d)>>1];k=f>>>0>e>>>0;h=e;break e}e=x[Pb(d,w[d+15|0])>>1];h=x[Pb(d,w[d+16|0])>>1]+1|0}f=f>>>0<h>>>0?f:e}if(!k|c){break b}if(!(!(v[a+480180>>2]&16777248)&(!(w[b+89|0]&8)|v[a+480180>>2]==16384))){v[b+88>>2]=v[b+88>>2]|4096}if(w[pj(d)+2|0]|!(v[a+480180>>2]&16777248?1:x[b+808>>1])){break b}v[b+696>>2]=0;v[b+720>>2]=0;v[b+680>>2]=0;v[b+88>>2]=v[b+88>>2]|4096}a=g+8|0;Fb(a,j,31);l=i,m=Cb(a)+f|0,v[l+4>>2]=m}jb=g+16|0}function Dja(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=Ak(a);if(c>>>0<b>>>0){k=jb-32|0;jb=k;a:{b:{i=b-c|0;c:{if(i>>>0<=(v[zb(a)>>2]-v[a+4>>2]|0)/33>>>0){c=jb-16|0;jb=c;b=a;d=c;v[c>>2]=a;a=v[a+4>>2];v[c+4>>2]=a;v[c+8>>2]=a+B(i,33);d:{a=v[c+4>>2];j=v[c+8>>2];if((a|0)!=(j|0)){while(1){e=zb(b);v[113382]=0;R(728,e|0,a|0);e=v[113382];v[113382]=0;if((e|0)==1){break d}a=a+33|0;v[d+4>>2]=a;if((a|0)!=(j|0)){continue}break}}Mb(d);jb=c+16|0;break c}a=P()|0;O()|0;Mb(d);S(a|0);L()}j=zb(a);f=k+8|0;d=Ak(a)+i|0;g=jb-16|0;jb=g;v[g+12>>2]=d;h=jb-16|0;jb=h;b=a;zb(a);v[h+12>>2]=130150524;v[113382]=0;v[h+8>>2]=2147483647;e=Q(33,h+12|0,h+8|0)|0;c=v[113382];v[113382]=0;e:{if((c|0)!=1){jb=h+16|0;c=v[e>>2];break e}V(0)|0;O()|0;Ab();L()}f:{if(c>>>0>=d>>>0){b=Kl(b);if(b>>>0<c>>>1>>>0){v[g+8>>2]=b<<1;c=v[Vc(g+8|0,g+12|0)>>2]}jb=g+16|0;break f}ld();L()}d=Ak(a);b=0;e=jb-16|0;jb=e;v[e+12>>2]=0;Le(f+12|0,j);if(c){b=c;if(c>>>0>130150524){fe(7217);L()}b=be(B(b,33),1)}v[f>>2]=b;d=B(d,33)+b|0;v[f+8>>2]=d;v[f+4>>2]=d;l=gc(f),m=B(c,33)+b|0,v[l>>2]=m;jb=e+16|0;v[113382]=0;R(726,f|0,i|0);b=v[113382];v[113382]=0;if((b|0)==1){break b}v[113382]=0;R(727,a|0,f|0);a=v[113382];v[113382]=0;if((a|0)==1){break b}gR(f)}jb=k+32|0;break a}a=P()|0;O()|0;gR(f);S(a|0);L()}return}if(b>>>0<c>>>0){b=v[a>>2]+B(b,33)|0;Ak(a);fR(a,b);Kl(a);Ak(a)}}function nT(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=jb-144|0;jb=h;v[113382]=0;k=T(445,a|0)|0;e=v[113382];v[113382]=0;if((e|0)!=1){a:{if(k){e=h+8|0;o=e|4;p=e|6;q=e|5;j=e|2;l=e|3;while(1){v[113382]=0;Q(476,a|0,h+8|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break a}e=h+8|0;e=w[e|0]|w[e+1|0]<<8;b:{if(!e){break b}e=(e<<8|e>>>8)&65535;if(e>>>0>x[c+480192>>1]){break b}e=v[((e<<2)+c|0)+900380>>2];if(!e){break b}v[113382]=0;e=Q(340,e|0,b|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break a}c:{if(!w[l|0]){break c}if(t[j|0]&1){t[e+12|0]=w[e+12|0]|1}if(w[j|0]&2){t[e+12|0]=w[e+12|0]|4}if(!(w[j|0]&4)){break c}t[e+12|0]=w[e+12|0]|2}f=w[l|0];v[113382]=0;t[h+4|0]=f;t[h+7|0]=31;f=Q(415,h+4|0,h+7|0)|0;i=v[113382];v[113382]=0;if((i|0)==1){break a}f=w[f|0];v[113382]=0;i=f+1&255;R(477,e|0,i|0);f=v[113382];v[113382]=0;if((f|0)==1){break a}t[e+13|0]=w[q|0];t[e+14|0]=w[p|0];f=w[o|0];t[e+15|0]=f;t[e+16|0]=f;f=0;if(!i){break b}while(1){m=(h+8|0)+(f<<2)|0;g=m+8|0;g=w[g|0]|w[g+1|0]<<8;r=Pb(e,f),s=g<<8|g>>>8,u[r>>1]=s;g=m+10|0;g=w[g|0]|w[g+1|0]<<8;g=g<<8|g>>>8;u[h+4>>1]=d?(g&65535)+128>>>2|0:g;sg(h+4|0,64);g=w[h+4|0];r=Pb(e,f),s=g,t[r+2|0]=s;f=f+1|0;if((i|0)!=(f|0)){continue}break}}n=n+1|0;if((n&65535)>>>0<k>>>0){continue}break}}Bb(a);jb=h+144|0;return}}b=P()|0;O()|0;Bb(a);S(b|0);L()}function Tea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=jb-32|0;jb=g;a:{b:{c:{e=v[a+12>>2];h=v[a+8>>2];d:{if((e|0)<=1&h>>>0<=805306368|(e|0)<=0){if((e|0)>=-2&h>>>0>=3489660928|(e|0)>-2){break c}if((e|0)==-2&h>>>0>2147483647|e>>>0>4294967294){break d}break b}if((e|0)==1&h>>>0>2147483648|e>>>0>1){break b}}l=b+196648|0;break a}l=b+131112|0;break a}l=b+262184|0}m=v[a+16>>2];j=v[a+40>>2];k=v[a+36>>2];f=v[a+4>>2];i=v[a>>2];v[g+24>>2]=i;v[g+28>>2]=f;v[g+16>>2]=h;v[g+20>>2]=e;e:{if(d){while(1){e=((((f&2147483647)<<1|i>>>31)&2147483646)<<1)+m|0;b=(i>>>16&65520)+l|0;i=u[b+14>>1];n=u[b+12>>1];o=u[b+10>>1];p=u[b+8>>1];q=u[b+6>>1];r=u[b+4>>1];s=u[b+2>>1];t=u[b>>1];h=0;b=1;while(1){f=h<<1;v[(g+8|0)+(h<<2)>>2]=(((((((B(u[(f|-8)+e>>1],s)+B(u[(f|-12)+e>>1],t)|0)+B(u[(f|-4)+e>>1],r)|0)+B(u[e+f>>1],q)|0)+B(u[(f|4)+e>>1],p)|0)+B(u[(f|8)+e>>1],o)|0)+B(u[(f|12)+e>>1],n)|0)+B(u[(f|16)+e>>1],i)|0)/32768;f=b;b=0;h=1;if(f){continue}break}b=v[a+32>>2];k=v[a+28>>2]+k|0;h=k>>12;v[c>>2]=v[c>>2]+B(h,v[g+8>>2]);j=b+j|0;b=j>>12;v[c+4>>2]=v[c+4>>2]+B(b,v[g+12>>2]);Sb(g+24|0,g+16|0);d=d-1|0;if(d){c=c+8|0;i=v[g+24>>2];f=v[g+28>>2];continue}break}i=v[g+24>>2];f=v[g+28>>2];break e}b=j>>12;h=k>>12}v[a+40>>2]=j;v[a+20>>2]=h;v[a+36>>2]=k;v[a+24>>2]=b;v[a>>2]=i;v[a+4>>2]=f;jb=g+32|0}function lea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=jb-48|0;jb=e;l=v[a+16>>2];g=Uf(e+16|0);v[g+8>>2]=a+112;v[g+16>>2]=v[a+128>>2];n=g,o=Pf(b+327720|0,v[b+20>>2],(v[a+88>>2]&16384)>>>14|0),v[n+12>>2]=o;b=v[g+16>>2];if(b){n=g,o=Tf(a+8|0,b),v[n>>2]=o;v[g+4>>2]=mb}j=v[a+40>>2];k=v[a+36>>2];b=v[a+4>>2];h=v[a>>2];v[e+8>>2]=h;v[e+12>>2]=b;f=v[a+12>>2];v[e>>2]=v[a+8>>2];v[e+4>>2]=f;a:{if(d){while(1){f=0;i=h;v[e+40>>2]=h;v[e+44>>2]=m;h=((((b&2147483647)<<1|h>>>31)&2147483646)<<1)+l|0;b:{b=v[g+16>>2];if((b|0)<=0){break b}while(1){f=(f&2147483647)<<1|i>>>31;yd(v[g+8>>2],(u[(f<<1|2)+h>>1]+u[h+((f&2147483646)<<1)>>1]|0)/8<<16>>16);xd(v[g+8>>2],4);Sb(e+40|0,g);if((b|0)<2){break b}b=b-1|0;i=v[e+40>>2];f=v[e+44>>2];continue}}d=d-1|0;b=v[g+8>>2];Sb(b,b+8|0);b=v[g+8>>2];f=v[b+4>>2];if(f){i=b;b=(v[e+44>>2]&2147483647)<<1|v[e+40>>2]>>>31;yd(i,(u[(b<<1|2)+h>>1]+u[h+((b&2147483646)<<1)>>1]|0)/8<<16>>16);xd(v[g+8>>2],f);b=v[g+8>>2];f=v[b>>2];v[b>>2]=f;v[b+4>>2]=0}b=Of(b,v[g+12>>2]);h=v[a+32>>2];k=v[a+28>>2]+k|0;f=k>>12;v[c>>2]=v[c>>2]+B(b,f);j=h+j|0;i=j>>12;v[c+4>>2]=v[c+4>>2]+B(b,i);Sb(e+8|0,e);if(d){c=c+8|0;h=v[e+8>>2];b=v[e+12>>2];continue}break}h=v[e+8>>2];b=v[e+12>>2];break a}i=j>>12;f=k>>12}v[a+40>>2]=j;v[a+20>>2]=f;v[a+36>>2]=k;v[a+24>>2]=i;v[a>>2]=h;v[a+4>>2]=b;jb=e+48|0}function CU(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=jb-32|0;jb=d;a:{if((w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24))==1397771593){sd(b,32);uh(d,1,a+4|0);c=d+16|0;Ec(c,d);v[113382]=0;Q(336,b+43|0,c|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break a}yb(d+16|0);u[b+30>>1]=w[a+19|0]<<2;sg(b+30|0,256);u[b+32>>1]=w[a+17|0];sg(b+32|0,64);c=a+47|0;u[b+28>>1]=(w[c|0]&127)<<2;sg(b+28|0,256);if(t[c|0]<0){u[b+34>>1]=x[b+34>>1]|32}c=a+18|0;if(w[c|0]&16){u[b+34>>1]=x[b+34>>1]|2}if(w[c|0]&32){u[b+34>>1]=x[b+34>>1]|8}if(w[c|0]&64){u[b+34>>1]=x[b+34>>1]|4}if(t[c|0]<0){u[b+34>>1]=x[b+34>>1]|16}c=a+60|0;c=w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24);c=c?c:8363;v[b+24>>2]=c>>>0>256?c:256;c=a+48|0;v[b>>2]=w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24);c=a+52|0;v[b+4>>2]=w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24);c=a+56|0;v[b+8>>2]=w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24);c=a- -64|0;v[b+12>>2]=w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24);c=a+68|0;v[b+16>>2]=w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24);kn(b);t[b+38|0]=w[(w[a+79|0]&7)+33104|0];t[b+41|0]=w[a+76|0];t[b+40|0]=w[a+77|0]&127;t[b+39|0]=w[a+78|0];c=512;e=a+46|0;b:{if(w[e|0]!=64){c=16384;if(w[e|0]!=128){break b}}u[b+34>>1]=x[b+34>>1]|c}a=a+72|0;c=w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24)}jb=d+32|0;return c|0}a=P()|0;O()|0;yb(d+16|0);S(a|0);L()}function R7(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0;c=jb+-64|0;jb=c;e=jb-16|0;jb=e;v[a>>2]=0;v[a+4>>2]=0;v[113382]=0;v[e+12>>2]=0;W(1730,a+8|0,e+12|0,e+8|0)|0;b=v[113382];v[113382]=0;a:{if((b|0)!=1){jb=e+16|0;break a}V(0)|0;O()|0;Ab();L()}v[113382]=0;e=a;R(1723,e|0,11);b=v[113382];v[113382]=0;b:{if((b|0)!=1){b=75120;c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{while(1){d=Jg(44);if(d){h=v[b>>2];g=v[b+4>>2];v[113382]=0;g=Q(121,c+32|0,g|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break l}v[113382]=0;R(1724,c+48|0,g|0);f=v[113382];v[113382]=0;if((f|0)==1){break k}f=v[b+8>>2];v[113382]=0;f=Q(121,c|0,f|0)|0;i=v[113382];v[113382]=0;if((i|0)==1){break j}v[113382]=0;R(1724,c+16|0,f|0);i=v[113382];v[113382]=0;if((i|0)==1){break i}v[113382]=0;ea(1725,d|0,h|0,1,c+48|0,c+16|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break h}Ib(c+16|0);yb(f);Ib(c+48|0);yb(g);v[113382]=0;v[c+60>>2]=d;R(1726,e|0,c+60|0);d=v[113382];v[113382]=0;if((d|0)==1){break c}d=v[c+60>>2];v[d+32>>2]=v[b+12>>2];v[d+36>>2]=v[b+16>>2];t[d+40|0]=w[b+20|0];t[d+41|0]=w[d+41|0]&253|w[b+21|0]<<1}b=b+24|0;if((b|0)!=75384){continue}break}jb=c- -64|0;return a|0}b=P()|0;O()|0;break d}b=P()|0;O()|0;break e}b=P()|0;O()|0;break f}b=P()|0;O()|0;break g}b=P()|0;O()|0;Ib(c+16|0)}yb(f)}Ib(c+48|0)}yb(g)}Wb(d);break b}b=P()|0;O()|0;break b}b=P()|0;O()|0}mx(e);S(b|0);L()}function zea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;h=jb-16|0;jb=h;f=v[a+48>>2];m=v[a+24>>2];n=v[a+20>>2];k=v[a+44>>2];o=v[a+16>>2];g=v[a+4>>2];i=v[a>>2];v[h+8>>2]=i;v[h+12>>2]=g;e=v[a+12>>2];v[h>>2]=v[a+8>>2];v[h+4>>2]=e;a:{if(!d){e=k;k=f;break a}while(1){e=(g<<1)+o|0;p=u[e-6>>1];g=(((i>>>16|0)+4&131064)<<1)+b|0;i=u[g+24>>1];q=u[e-4>>1];r=u[g+26>>1];s=u[e-2>>1];t=u[g+28>>1];w=u[e>>1];x=u[g+30>>1];y=u[e+2>>1];z=u[g+32>>1];A=u[e+4>>1];C=u[g+34>>1];D=u[e+6>>1];E=u[g+36>>1];F=u[e+8>>1];g=u[g+38>>1];e=v[a+60>>2];G=e;H=e>>31;e=Yb(k,-16777216,16776704);j=v[a+64>>2];f=Yb(f,-16777216,16776704);I=v[a+72>>2];J=v[c>>2];e=qma(j,j>>31,e,e>>31);j=mb;K=e;e=v[a+68>>2];l=qma(e,e>>31,f,f>>31);e=K+l|0;f=mb+j|0;f=e>>>0<l>>>0?f+1|0:f;j=e;g=(((((B(A,C)+B(y,z)|0)+B(D,E)|0)+B(g,F)|0)/2|0)+((((B(q,r)+B(i,p)|0)+B(s,t)|0)+B(w,x)|0)/2|0)|0)/16384<<8;e=g;i=qma(G,H,e,e>>31);e=j+i|0;f=mb+f|0;f=e>>>0<i>>>0?f+1|0:f;e=e+8388608|0;f=e>>>0<8388608?f+1|0:f;f=(f&16777215)<<8|e>>>24;e=(f|0)/256|0;v[c>>2]=B(e,n)+J;v[c+4>>2]=v[c+4>>2]+B(e,m);e=f-(g&I)|0;Sb(h+8|0,h);d=d-1|0;if(d){c=c+8|0;i=v[h+8>>2];g=v[h+12>>2];f=k;k=e;continue}break}i=v[h+8>>2];g=v[h+12>>2]}v[a+48>>2]=k;v[a+44>>2]=e;v[a>>2]=i;v[a+4>>2]=g;jb=h+16|0}function v_(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;a=jb-496|0;jb=a;g=a+488|0;Ac(g,d);v[113382]=0;m=T(2339,g|0)|0;g=v[113382];v[113382]=0;a:{b:{c:{d:{e:{f:{g:{if((g|0)!=1){if(Db(f)){g=v[ij(f,0)>>2];v[113382]=0;h=Q(2366,m|0,45)|0;i=v[113382];v[113382]=0;if((i|0)==1){break g}n=(g|0)==(h|0)}j=Xb(a+456|0);h=sf(a+440|0);i=sf(a+424|0);v[113382]=0;na(2394,c|0,n|0,a+488|0,a+480|0,a+476|0,a+472|0,j|0,h|0,i|0,a+420|0);c=v[113382];v[113382]=0;if((c|0)==1){break f}v[a+4>>2]=2310;k=Ld(a+8|0,0,a+4|0);c=a+16|0;h:{if((Db(f)|0)>v[a+420>>2]){g=Db(f);l=v[a+420>>2];g=(((Db(i)+(g-l<<1)|0)+Db(h)|0)+v[a+420>>2]|0)+1|0;break h}g=((Db(i)+Db(h)|0)+v[a+420>>2]|0)+2|0}if(g>>>0<101){break e}ve(k,kd(g<<2));c=v[k>>2];if(c){break e}v[113382]=0;Y(2311);b=v[113382];v[113382]=0;if((b|0)==1){break d}L()}f=P()|0;O()|0;break b}f=P()|0;O()|0;break b}f=P()|0;O()|0;break c}g=v[d+4>>2];l=Tb(f);o=Tb(f);f=Db(f);v[113382]=0;sa(2395,c|0,a+4|0,a|0,g|0,l|0,(f<<2)+o|0,m|0,n|0,a+480|0,v[a+476>>2],v[a+472>>2],j|0,h|0,i|0,v[a+420>>2]);f=v[113382];v[113382]=0;if((f|0)!=1){v[113382]=0;b=ka(2370,b|0,c|0,v[a+4>>2],v[a>>2],d|0,e|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){break a}}}f=P()|0;O()|0;Gc(k)}Jc(i);Jc(h);yb(j)}Ob(a+488|0);S(f|0);L()}Gc(k);Jc(i);Jc(h);yb(j);Ob(a+488|0);jb=a+496|0;return b|0}function Aea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,w=0,x=0,y=0,z=0,A=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;h=jb-16|0;jb=h;f=v[a+48>>2];m=v[a+24>>2];n=v[a+20>>2];k=v[a+44>>2];o=v[a+16>>2];g=v[a+4>>2];i=v[a>>2];v[h+8>>2]=i;v[h+12>>2]=g;e=v[a+12>>2];v[h>>2]=v[a+8>>2];v[h+4>>2]=e;a:{if(!d){e=k;k=f;break a}while(1){e=g+o|0;p=t[e-3|0];g=(((i>>>16|0)+4&131064)<<1)+b|0;i=u[g+24>>1];q=t[e-2|0];r=u[g+26>>1];s=t[e-1|0];w=u[g+28>>1];x=t[e|0];y=u[g+30>>1];z=t[e+1|0];A=u[g+32>>1];C=t[e+2|0];D=u[g+34>>1];E=t[e+3|0];F=u[g+36>>1];G=t[e+4|0];g=u[g+38>>1];e=v[a+60>>2];H=e;I=e>>31;e=Yb(k,-16777216,16776704);j=v[a+64>>2];f=Yb(f,-16777216,16776704);J=v[a+72>>2];K=v[c>>2];e=qma(j,j>>31,e,e>>31);j=mb;L=e;e=v[a+68>>2];l=qma(e,e>>31,f,f>>31);e=L+l|0;f=mb+j|0;f=e>>>0<l>>>0?f+1|0:f;j=e;g=(((((B(C,D)+B(z,A)|0)+B(E,F)|0)+B(g,G)<<8)/2|0)+((((B(q,r)+B(i,p)|0)+B(s,w)|0)+B(x,y)<<8)/2|0)|0)/16384<<8;e=g;i=qma(H,I,e,e>>31);e=j+i|0;f=mb+f|0;f=e>>>0<i>>>0?f+1|0:f;e=e+8388608|0;f=e>>>0<8388608?f+1|0:f;f=(f&16777215)<<8|e>>>24;e=(f|0)/256|0;v[c>>2]=B(e,n)+K;v[c+4>>2]=v[c+4>>2]+B(e,m);e=f-(g&J)|0;Sb(h+8|0,h);d=d-1|0;if(d){c=c+8|0;i=v[h+8>>2];g=v[h+12>>2];f=k;k=e;continue}break}i=v[h+8>>2];g=v[h+12>>2]}v[a+48>>2]=k;v[a+44>>2]=e;v[a>>2]=i;v[a+4>>2]=g;jb=h+16|0}function Jfa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;b=jb-48|0;jb=b;q=v[a+16>>2];j=v[a+44>>2];v[b+32>>2]=j;f=v[a+48>>2];v[b+36>>2]=f;h=v[a+52>>2];v[b+40>>2]=h;k=v[a+56>>2];v[b+44>>2]=k;r=v[a+24>>2];s=v[a+20>>2];e=v[a+4>>2];i=v[a>>2];v[b+24>>2]=i;v[b+28>>2]=e;g=v[a+12>>2];v[b+16>>2]=v[a+8>>2];v[b+20>>2]=g;if(d){while(1){e=((((e&2147483647)<<1|i>>>31)&2147483646)<<1)+q|0;h=u[e>>1];v[b+8>>2]=h;v[b+12>>2]=u[e+2>>1];f=0;k=1;while(1){g=v[a+60>>2];n=g;i=(b+32|0)+(f<<3)|0;l=v[i>>2];e=Yb(l,-16777216,16776704);p=v[a+64>>2];j=Yb(v[i+4>>2],-16777216,16776704);m=v[a+68>>2];t=m;m=m>>31;v[i+4>>2]=l;l=v[a+72>>2];o=g>>31;h=h<<8;g=h;g=qma(n,o,g,g>>31);n=mb;o=(b+8|0)+(f<<2)|0;f=g;g=qma(p,p>>31,e,e>>31);f=f+g|0;e=mb+n|0;e=f>>>0<g>>>0?e+1|0:e;j=qma(t,m,j,j>>31);f=j+f|0;e=mb+e|0;e=f>>>0<j>>>0?e+1|0:e;f=f+8388608|0;e=f>>>0<8388608?e+1|0:e;e=(e&16777215)<<8|f>>>24;v[o>>2]=(e|0)/256;v[i>>2]=e-(h&l);if(k){f=1;k=0;h=v[b+12>>2];continue}break}v[c>>2]=v[c>>2]+B(v[b+8>>2],s);v[c+4>>2]=v[c+4>>2]+B(v[b+12>>2],r);Sb(b+24|0,b+16|0);d=d-1|0;if(d){c=c+8|0;i=v[b+24>>2];e=v[b+28>>2];continue}break}i=v[b+24>>2];k=v[b+44>>2];h=v[b+40>>2];j=v[b+32>>2];f=v[b+36>>2];e=v[b+28>>2]}v[a+56>>2]=k;v[a+52>>2]=h;v[a+48>>2]=f;v[a+44>>2]=j;v[a>>2]=i;v[a+4>>2]=e;jb=b+48|0}function z_(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;a=jb-192|0;jb=a;g=a+184|0;Ac(g,d);v[113382]=0;m=T(21,g|0)|0;g=v[113382];v[113382]=0;a:{b:{c:{d:{e:{f:{g:{if((g|0)!=1){if(Db(f)){g=w[kc(f,0)|0];v[113382]=0;h=Q(22,m|0,45)|0;i=v[113382];v[113382]=0;if((i|0)==1){break g}n=(g|0)==(h&255)}j=Xb(a+160|0);h=Xb(a+144|0);i=Xb(a+128|0);v[113382]=0;na(2392,c|0,n|0,a+184|0,a+176|0,a+175|0,a+174|0,j|0,h|0,i|0,a+124|0);c=v[113382];v[113382]=0;if((c|0)==1){break f}v[a+4>>2]=2310;k=Ld(a+8|0,0,a+4|0);c=a+16|0;h:{if((Db(f)|0)>v[a+124>>2]){g=Db(f);l=v[a+124>>2];g=(((Db(i)+(g-l<<1)|0)+Db(h)|0)+v[a+124>>2]|0)+1|0;break h}g=((Db(i)+Db(h)|0)+v[a+124>>2]|0)+2|0}if(g>>>0<101){break e}ve(k,kd(g));c=v[k>>2];if(c){break e}v[113382]=0;Y(2311);b=v[113382];v[113382]=0;if((b|0)==1){break d}L()}f=P()|0;O()|0;break b}f=P()|0;O()|0;break b}f=P()|0;O()|0;break c}g=v[d+4>>2];l=Tb(f);o=Tb(f);f=Db(f);v[113382]=0;sa(2393,c|0,a+4|0,a|0,g|0,l|0,f+o|0,m|0,n|0,a+176|0,t[a+175|0],t[a+174|0],j|0,h|0,i|0,v[a+124>>2]);f=v[113382];v[113382]=0;if((f|0)!=1){v[113382]=0;b=ka(17,b|0,c|0,v[a+4>>2],v[a>>2],d|0,e|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){break a}}}f=P()|0;O()|0;Gc(k)}yb(i);yb(h);yb(j)}Ob(a+184|0);S(f|0);L()}Gc(k);yb(i);yb(h);yb(j);Ob(a+184|0);jb=a+192|0;return b|0}function Uea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,w=0;f=jb-32|0;jb=f;a:{b:{c:{e=v[a+12>>2];g=v[a+8>>2];d:{if((e|0)<=1&g>>>0<=805306368|(e|0)<=0){if((e|0)>=-2&g>>>0>=3489660928|(e|0)>-2){break c}if((e|0)==-2&g>>>0>2147483647|e>>>0>4294967294){break d}break b}if((e|0)==1&g>>>0>2147483648|e>>>0>1){break b}}l=b+196648|0;break a}l=b+131112|0;break a}l=b+262184|0}m=v[a+16>>2];j=v[a+40>>2];k=v[a+36>>2];i=v[a+4>>2];h=v[a>>2];v[f+24>>2]=h;v[f+28>>2]=i;v[f+16>>2]=g;v[f+20>>2]=e;e:{if(d){while(1){g=(((i&2147483647)<<1|h>>>31)&-2)+m|0;b=(h>>>16&65520)+l|0;h=u[b+14>>1];n=u[b+12>>1];o=u[b+10>>1];p=u[b+8>>1];q=u[b+6>>1];r=u[b+4>>1];s=u[b+2>>1];w=u[b>>1];b=0;e=1;while(1){v[(f+8|0)+(b<<2)>>2]=(((((((B(t[(b|-4)+g|0],s)+B(t[(b|-6)+g|0],w)|0)+B(t[(b|-2)+g|0],r)|0)+B(t[b+g|0],q)|0)+B(t[(b|2)+g|0],p)|0)+B(t[(b|4)+g|0],o)|0)+B(t[(b|6)+g|0],n)|0)+B(t[(b|8)+g|0],h)<<8)/32768;i=e;e=0;b=1;if(i){continue}break}b=v[a+32>>2];k=v[a+28>>2]+k|0;e=k>>12;v[c>>2]=v[c>>2]+B(e,v[f+8>>2]);j=b+j|0;b=j>>12;v[c+4>>2]=v[c+4>>2]+B(b,v[f+12>>2]);Sb(f+24|0,f+16|0);d=d-1|0;if(d){c=c+8|0;h=v[f+24>>2];i=v[f+28>>2];continue}break}h=v[f+24>>2];i=v[f+28>>2];break e}b=j>>12;e=k>>12}v[a+40>>2]=j;v[a+20>>2]=e;v[a+36>>2]=k;v[a+24>>2]=b;v[a>>2]=h;v[a+4>>2]=i;jb=f+32|0}function Kfa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0;b=jb-48|0;jb=b;q=v[a+16>>2];j=v[a+44>>2];v[b+32>>2]=j;f=v[a+48>>2];v[b+36>>2]=f;h=v[a+52>>2];v[b+40>>2]=h;k=v[a+56>>2];v[b+44>>2]=k;r=v[a+24>>2];s=v[a+20>>2];e=v[a+4>>2];i=v[a>>2];v[b+24>>2]=i;v[b+28>>2]=e;g=v[a+12>>2];v[b+16>>2]=v[a+8>>2];v[b+20>>2]=g;if(d){while(1){e=(((e&2147483647)<<1|i>>>31)&-2)+q|0;h=t[e|0]<<8;v[b+8>>2]=h;v[b+12>>2]=t[e+1|0]<<8;f=0;k=1;while(1){g=v[a+60>>2];n=g;i=(b+32|0)+(f<<3)|0;l=v[i>>2];e=Yb(l,-16777216,16776704);p=v[a+64>>2];j=Yb(v[i+4>>2],-16777216,16776704);m=v[a+68>>2];u=m;m=m>>31;v[i+4>>2]=l;l=v[a+72>>2];o=g>>31;h=h<<8;g=h;g=qma(n,o,g,g>>31);n=mb;o=(b+8|0)+(f<<2)|0;f=g;g=qma(p,p>>31,e,e>>31);f=f+g|0;e=mb+n|0;e=f>>>0<g>>>0?e+1|0:e;j=qma(u,m,j,j>>31);f=j+f|0;e=mb+e|0;e=f>>>0<j>>>0?e+1|0:e;f=f+8388608|0;e=f>>>0<8388608?e+1|0:e;e=(e&16777215)<<8|f>>>24;v[o>>2]=(e|0)/256;v[i>>2]=e-(h&l);if(k){f=1;k=0;h=v[b+12>>2];continue}break}v[c>>2]=v[c>>2]+B(v[b+8>>2],s);v[c+4>>2]=v[c+4>>2]+B(v[b+12>>2],r);Sb(b+24|0,b+16|0);d=d-1|0;if(d){c=c+8|0;i=v[b+24>>2];e=v[b+28>>2];continue}break}i=v[b+24>>2];k=v[b+44>>2];h=v[b+40>>2];j=v[b+32>>2];f=v[b+36>>2];e=v[b+28>>2]}v[a+56>>2]=k;v[a+52>>2]=h;v[a+48>>2]=f;v[a+44>>2]=j;v[a>>2]=i;v[a+4>>2]=e;jb=b+48|0}function E_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;a=jb-448|0;jb=a;v[a+432>>2]=c;v[a+440>>2]=b;v[a+20>>2]=2373;h=Ld(a+24|0,a+32|0,a+20|0);v[113382]=0;Ac(a+16|0,e);b=v[113382];v[113382]=0;a:{b:{c:{d:{if((b|0)!=1){v[113382]=0;i=T(2339,a+16|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break b}t[a+15|0]=0;b=v[e+4>>2];v[113382]=0;b=ta(2384,a+440|0,c|0,d|0,a+16|0,b|0,f|0,a+15|0,i|0,h|0,a+20|0,a+432|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break b}if(!b){break c}c=jb-16|0;jb=c;b=g;e:{if(he(b)){d=v[b>>2];v[c+12>>2]=0;Te(d,c+12|0);ae(b,0);break e}v[c+8>>2]=0;Te(b,c+8|0);Ce(b,0)}jb=c+16|0;if(!w[a+15|0]){break d}v[113382]=0;b=Q(2366,i|0,45)|0;c=v[113382];v[113382]=0;if((c|0)==1){break b}v[113382]=0;R(112,g|0,b|0);b=v[113382];v[113382]=0;if((b|0)!=1){break d}break b}e=P()|0;O()|0;break a}v[113382]=0;b=Q(2366,i|0,48)|0;c=v[113382];v[113382]=0;if((c|0)==1){break b}e=v[h>>2];c=v[a+20>>2];d=c-4|0;while(1){if(!((b|0)!=v[e>>2]|d>>>0<=e>>>0)){e=e+4|0;continue}break}v[113382]=0;W(2390,g|0,e|0,c|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){break c}break b}v[113382]=0;b=Q(2345,a+440|0,a+432|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break b}if(b){v[f>>2]=v[f>>2]|2}b=v[a+440>>2];Ob(a+16|0);Gc(h);jb=a+448|0;return b|0}e=P()|0;O()|0;Ob(a+16|0)}Gc(h);S(e|0);L()}function eg(a,b,c,d){var e=0,f=0,g=0,h=0;f=jb-16|0;jb=f;v[f+12>>2]=d;e=b-1|0;g=0;a:{if(e>>>0>249){break a}h=Op(a);g=v[a+480180>>2];if(!h){if(g&17408){a=((e&255)>>>0)/12|0;g=x[((e-B(a,12)&255)<<1)+26656>>1]<<4>>>a|0;break a}if(!d){v[f+12>>2]=8363;d=8363}if(!(!(w[a+480208|0]&16)&v[a+480180>>2]!=64)){Fb(f,a+1074312|0,7);if(!(!Cb(f)&v[a+480180>>2]!=64)){a=((e&255)>>>0)/12|0;b=qma(v[(e-B(a,12)<<6&960)+30544>>2]<<a,0,d,0);a=mb;c=a>>>21|0;g=dd((a&2097151)<<11|b>>>21,c);break a}a=((e&255)>>>0)/12|0;g=x[((e-B(a,12)&255)<<1)+26656>>1]<<5>>>a|0;break a}a=((e&255)>>>0)/12|0;tc(f+12|0,-1>>>a|0);g=dd(tma(qma(x[((e-B(a,12)&255)<<1)+26656>>1],0,267616,0),mb,v[f+12>>2]<<a,0),mb);break a}if(g&20){d=e>>>0>12;if(v[a+480180>>2]==16){b=c<<4}else{Fb(f,a+1074312|0,76);b=Cb(f)?c&-8:c}c=d?e:12;if(w[a+480208|0]&16){a=(((b|0)/-2|0)-(c<<6)|0)+8448|0;g=(a|0)>1?a:1;break a}c=c-12|0;a=((c&255)>>>0)/12|0;d=((b|0)/16|0)+(c-B(a,12)<<3&248)|0;v[f>>2]=d+8;Yd(f,0,103);c=b;b=b>>31;c=(c+b^b)&15;b=d+(b|1)|0;b=(b|0)>-8?b:-8;g=B(c,x[((((b|0)<95?b:95)<<1)+27136|0)+16>>1])+B(x[(v[f>>2]<<1)+27136>>1],16-c|0)<<1>>>a|0;break a}a=c&255;if(!(!(e>>>0<24|a>>>0>15)&e>>>0<108)){b=B(a>>>4|0,12);a=((e&255)>>>0)/12|0;g=x[(b+(e-B(a,12)&255)<<1)+26256>>1]<<5>>>a|0;break a}g=x[(b<<1)+26030>>1]<<2}jb=f+16|0;return g}function tk(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;f=jb-32|0;jb=f;k=jp(a);g=rj(k);c=g;d=a;e=xc(d);a:{if(c>>>0>e>>>0){h=jb-32|0;jb=h;b:{e=c-e|0;c:{if(e>>>0<=(v[zb(d)>>2]-v[d+4>>2]|0)/12>>>0){i=jb-16|0;jb=i;d:{c=dl(i,d,e);e=v[c+4>>2];l=v[c+8>>2];if((e|0)!=(l|0)){while(1){j=zb(d);v[113382]=0;R(1201,j|0,e|0);j=v[113382];v[113382]=0;if((j|0)==1){break d}e=e+12|0;v[c+4>>2]=e;if((e|0)!=(l|0)){continue}break}}Mb(c);jb=i+16|0;break c}a=P()|0;O()|0;Mb(c);S(a|0);L()}c=zb(d);c=Wj(h+8|0,wm(d,xc(d)+e|0),xc(d),c);v[113382]=0;R(1198,c|0,e|0);e=v[113382];v[113382]=0;if((e|0)==1){break b}v[113382]=0;R(1199,d|0,c|0);d=v[113382];v[113382]=0;if((d|0)==1){break b}GM(c)}jb=h+32|0;break a}a=P()|0;O()|0;GM(c);S(a|0);L()}if(c>>>0<e>>>0){c=v[d>>2]+B(c,12)|0;xc(d);HM(d,c);dt(d)}}e:{if(!b){break e}d=a+12|0;Os(d);if(nd(d)>>>0>1023){break e}v[f+28>>2]=0;c=v[a+24>>2]+484344|0;m=f,n=ac(c),v[m+24>>2]=n;m=f,n=bc(c),v[m+16>>2]=n;if(Jb(f+24|0,f+16|0)){while(1){c=f+24|0;v[f+12>>2]=v[v[c>>2]+12>>2];m=f,n=v[Vc(f+28|0,f+12|0)>>2],v[m+28>>2]=n;Cy(c);if(Jb(c,f+16|0)){continue}break}c=v[f+28>>2]}else{c=0}QM(d,c)}if(g){d=0;while(1){c=od(a,d);e=By(a,x[rc(k,d)>>1]);f:{if(b){t[f+28|0]=0;PM(c,e,f+28|0);break f}lz(c,e,0)}d=d+1|0;if((g|0)!=(d|0)){continue}break}}jb=f+32|0}function VY(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;a=jb-16|0;jb=a;v[a+12>>2]=c;v[a+8>>2]=f;v[a+12>>2]=c;v[a+8>>2]=f;a:{b:{while(1){c:{i=v[a+12>>2];if(i>>>0>=d>>>0){break c}m=v[a+8>>2];if(m>>>0>=g>>>0){break c}c=t[i|0];b=c&255;d:{if((c|0)>=0){if(b>>>0<=1114111){f=1;break d}c=2;break a}c=2;if(b>>>0<194){break a}if(b>>>0<=223){if((d-i|0)<2){break b}j=w[i+1|0];if((j&192)!=128){break a}f=2;b=j&63|b<<6&1984;if(b>>>0<=1114111){break d}break a}if(b>>>0<=239){if((d-i|0)<3){break b}j=w[i+2|0];k=w[i+1|0];e:{f:{if((b|0)!=237){if((b|0)!=224){break f}if((k&224)==160){break e}break a}if((k&224)==128){break e}break a}if((k&192)!=128){break a}}if((j&192)!=128){break a}f=3;b=j&63|(b<<12&61440|(k&63)<<6);if(b>>>0<=1114111){break d}break a}if(b>>>0>244){break a}if((d-i|0)<4){break b}k=w[i+3|0];j=w[i+2|0];l=w[i+1|0];g:{h:{switch(b-240|0){case 0:if((l+112&255)>>>0<48){break g}break a;case 4:if((l&240)==128){break g}break a;default:break h}}if((l&192)!=128){break a}}if((j&192)!=128|(k&192)!=128){break a}f=4;b=k&63|(j<<6&4032|(b<<18&1835008|(l&63)<<12));if(b>>>0>1114111){break a}}v[m>>2]=b;v[a+12>>2]=f+i;v[a+8>>2]=v[a+8>>2]+4;continue}break}c=d>>>0>i>>>0;break a}c=1}v[e>>2]=v[a+12>>2];v[h>>2]=v[a+8>>2];jb=a+16|0;return c|0}function N9(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=jb-32|0;jb=h;v[h+24>>2]=b;b=v[a>>2];q=h,r=ac(a),v[q>>2]=r;b=b+B(ms(h+24|0,h),6)|0;a:{b:{if(!c){break b}f=v[zb(a)>>2];g=v[a+4>>2];if((f-g|0)/6>>>0>=c>>>0){f=c;i=g-b|0;e=(i|0)/6|0;if(e>>>0<c>>>0){bA(a,c-e|0,d);f=e;if(!i){break b}}l=jb-16|0;jb=l;o=a;p=g;e=b;n=v[a+4>>2];i=e+B((n-(B(c,6)+e|0)|0)/6|0,6)|0;j=Tp(l,a,(g-i|0)/6|0);c:{d:{if(g>>>0>i>>>0){k=v[j+4>>2];g=i;while(1){m=zb(o);v[113382]=0;U(1534,m|0,k|0,g|0);m=v[113382];v[113382]=0;if((m|0)==1){break d}k=k+6|0;v[j+4>>2]=k;g=g+6|0;if(p>>>0>g>>>0){continue}break}}Mb(j);g=i-e|0;if(g){_i(n+B((g|0)/-6|0,6)|0,e,g)}jb=l+16|0;break c}a=P()|0;O()|0;Mb(j);S(a|0);L()}a=B(b>>>0<=d>>>0?y[a+4>>2]>d>>>0?c:0:0,6)+d|0;if(f){while(1){c=w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24);t[e|0]=c;t[e+1|0]=c>>>8;t[e+2|0]=c>>>16;t[e+3|0]=c>>>24;c=w[a+4|0]|w[a+5|0]<<8;t[e+4|0]=c;t[e+5|0]=c>>>8;e=e+6|0;f=f-1|0;if(f){continue}break}}break b}f=zb(a);f=qR(h,Rz(a,hg(a)+c|0),(b-v[a>>2]|0)/6|0,f);v[113382]=0;U(671,f|0,c|0,d|0);c=v[113382];v[113382]=0;if((c|0)==1){break a}v[113382]=0;b=W(1533,a|0,f|0,b|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break a}yt(f)}a=Pg(b);jb=h+32|0;return a|0}a=P()|0;O()|0;yt(f);S(a|0);L()}function oma(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{g=b;if(g){e=c;if(!e){break j}f=d;if(!f){break i}f=E(f)-E(g)|0;if(f>>>0<=31){break h}break b}if((d|0)==1|d>>>0>1){break b}b=(a>>>0)/(c>>>0)|0;kb=a-B(b,c)|0;lb=0;mb=0;return b}e=d;if(!a){break g}if(!e){break f}f=e-1|0;if(f&e){break f}kb=a;lb=f&g;a=g>>>pma(e)|0;mb=0;return a}f=e-1|0;if(!(f&e)){break e}j=(E(e)+33|0)-E(g)|0;h=0-j|0;break c}j=f+1|0;h=63-f|0;break c}kb=0;a=(g>>>0)/(e>>>0)|0;lb=g-B(a,e)|0;mb=0;return a}f=E(e)-E(g)|0;if(f>>>0<31){break d}break b}kb=a&f;lb=0;if((e|0)==1){break a}c=a;a=pma(e);d=a&31;if((a&63)>>>0>=32){f=0;a=b>>>d|0}else{f=b>>>d|0;a=((1<<d)-1&b)<<32-d|c>>>d}mb=f;return a}j=f+1|0;h=63-f|0}e=b;g=a;f=j&63;i=f&31;if((f&63)>>>0>=32){f=0;l=e>>>i|0}else{f=e>>>i|0;l=((1<<i)-1&e)<<32-i|g>>>i}a=h&63;h=a&31;if((a&63)>>>0>=32){e=g<<h;a=0}else{e=(1<<h)-1&g>>>32-h|b<<h;a=g<<h}b=e;if(j){g=d-1|0;e=c-1|0;g=(e|0)!=-1?g+1|0:g;h=e;while(1){e=l;f=f<<1|e>>>31;e=e<<1;k=f;f=b>>>31|e;m=k;e=k;k=f;i=g-((f>>>0>h>>>0)+e|0)|0;f=i>>31;e=f;i=e;f=c&e;l=k-f|0;f=m-((d&e)+(f>>>0>k>>>0)|0)|0;e=b<<1|a>>>31;a=n|a<<1;b=e|o;e=0;m=e;k=i&1;n=k;j=j-1|0;if(j){continue}break}}kb=l;lb=f;e=b<<1|a>>>31;a=k|a<<1;mb=e|m;return a}kb=a;lb=b;a=0;b=0}mb=b;return a}function mea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=jb-48|0;jb=e;l=v[a+16>>2];g=Uf(e+16|0);v[g+8>>2]=a+112;v[g+16>>2]=v[a+128>>2];n=g,o=Pf(b+327720|0,v[b+20>>2],(v[a+88>>2]&16384)>>>14|0),v[n+12>>2]=o;b=v[g+16>>2];if(b){n=g,o=Tf(a+8|0,b),v[n>>2]=o;v[g+4>>2]=mb}j=v[a+40>>2];k=v[a+36>>2];b=v[a+4>>2];h=v[a>>2];v[e+8>>2]=h;v[e+12>>2]=b;f=v[a+12>>2];v[e>>2]=v[a+8>>2];v[e+4>>2]=f;a:{if(d){while(1){f=0;i=h;v[e+40>>2]=h;v[e+44>>2]=m;h=(((b&2147483647)<<1|h>>>31)&-2)+l|0;b:{b=v[g+16>>2];if((b|0)<=0){break b}while(1){f=(f&2147483647)<<1|i>>>31;yd(v[g+8>>2],t[(f|1)+h|0]+t[h+(f&-2)|0]<<5);xd(v[g+8>>2],4);Sb(e+40|0,g);if((b|0)<2){break b}b=b-1|0;i=v[e+40>>2];f=v[e+44>>2];continue}}d=d-1|0;b=v[g+8>>2];Sb(b,b+8|0);b=v[g+8>>2];f=v[b+4>>2];if(f){i=b;b=(v[e+44>>2]&2147483647)<<1|v[e+40>>2]>>>31;yd(i,t[(b|1)+h|0]+t[h+(b&-2)|0]<<5);xd(v[g+8>>2],f);b=v[g+8>>2];f=v[b>>2];v[b>>2]=f;v[b+4>>2]=0}b=Of(b,v[g+12>>2]);h=v[a+32>>2];k=v[a+28>>2]+k|0;f=k>>12;v[c>>2]=v[c>>2]+B(b,f);j=h+j|0;i=j>>12;v[c+4>>2]=v[c+4>>2]+B(b,i);Sb(e+8|0,e);if(d){c=c+8|0;h=v[e+8>>2];b=v[e+12>>2];continue}break}h=v[e+8>>2];b=v[e+12>>2];break a}i=j>>12;f=k>>12}v[a+40>>2]=j;v[a+20>>2]=f;v[a+36>>2]=k;v[a+24>>2]=i;v[a>>2]=h;v[a+4>>2]=b;jb=e+48|0}function v9(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;c=jb-144|0;jb=c;e=cl(c+40|0,a);v[113382]=0;d=Q(645,c+24|0,36112)|0;a=v[113382];v[113382]=0;a:{b:{c:{d:{if((a|0)!=1){v[113382]=0;v[c+16>>2]=19469312;v[c+20>>2]=0;U(646,e|0,d|0,c+16|0);a=v[113382];v[113382]=0;if((a|0)==1){break d}Ib(d);if(!(v[e>>2]&1073741824)){break c}break a}a=P()|0;O()|0;break b}a=P()|0;O()|0;Ib(d);break b}a=Ae(b);v[113382]=0;u[c+16>>1]=a;u[c+14>>1]=65535;d=Q(645,c+24|0,6193)|0;a=v[113382];v[113382]=0;e:{if((a|0)!=1){v[113382]=0;a=W(1147,e|0,c+14|0,d|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break e}Ib(d);if((a|0)!=1){u[c+16>>1]=x[c+14>>1]}sg(c+16|0,x[v[18619]+10>>1]);f:{if(x[c+16>>1]<=Ae(b)>>>0){break f}v[113382]=0;R(363,b|0,x[c+16>>1]);a=v[113382];v[113382]=0;if((a|0)!=1){break f}a=P()|0;O()|0;break b}a=0;u[c+12>>1]=0;if(!x[c+16>>1]){break a}g:{while(1){h:{a=Zb(b,a&65535);v[113382]=0;R(1554,c+24|0,c+12|0);d=v[113382];v[113382]=0;if((d|0)==1){break h}v[113382]=0;aa(1537,e|0,a|0,c+24|0,1555)|0;a=v[113382];v[113382]=0;if((a|0)==1){break g}Ib(c+24|0);a=x[c+12>>1]+1|0;u[c+12>>1]=a;if(x[c+16>>1]>(a&65535)>>>0){continue}break a}break}a=P()|0;O()|0;break b}a=P()|0;O()|0;Ib(c+24|0);break b}a=P()|0;O()|0;break b}a=P()|0;O()|0;Ib(d)}Bg(e);S(a|0);L()}Bg(e);jb=c+144|0}function KU(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;g=jb-1072|0;jb=g;e=Vh(g+16|0);h=lm(a,e);Bb(e);v[a+1060>>2]=0;v[a+1064>>2]=0;v[a+1056>>2]=c;e=a+1068|0;v[e>>2]=0;v[e+4>>2]=0;e=0;v[a+1076>>2]=0;t[a+1080|0]=d;a:{b:{if(te(c)){i=a+1060|0;while(1){v[a+1060>>2]=0;v[a+1064>>2]=0;c:{if(!v[c>>2]){break c}while(1){v[113382]=0;d=Q(228,b|0,2)|0;f=v[113382];v[113382]=0;d:{e:{f:{g:{if((f|0)!=1){if(!d){break c}v[113382]=0;d=T(323,b|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break g}if(!d){break d}v[113382]=0;U(307,g|0,b|0,d|0);d=v[113382];v[113382]=0;if((d|0)==1){break f}d=g+16|0;f=lm(d,g);Qd(h,f);lc(h+16|0,f+16|0,1040);Bb(d);Bb(g);v[a+1072>>2]=0;v[a+1076>>2]=0;f=uq(v[a+1056>>2]);d=v[a+1056>>2];if(f>>>0>=2){d=v[d+20>>2];v[113382]=0;R(324,a|0,d+(e<<1)|0);d=v[113382];v[113382]=0;if((d|0)!=1){break d}break e}d=v[d+20>>2];v[113382]=0;R(325,a|0,d+e|0);d=v[113382];v[113382]=0;if((d|0)==1){break e}break d}d=P()|0;O()|0;break a}d=P()|0;O()|0;break a}d=P()|0;O()|0;break a}d=V(72108)|0;if((O()|0)!=(ga(72108)|0)){break a}_(d|0)|0;v[113382]=0;Y(20);d=v[113382];v[113382]=0;if((d|0)==1){break b}}if(y[i>>2]<y[c>>2]){continue}break}}e=e+1|0;if(te(v[a+1056>>2])>>>0>e>>>0){continue}break}}jb=g+1072|0;return a|0}d=P()|0;O()|0}Bb(a);S(d|0);L()}function ow(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,x=0;r=a;j=jb-1040|0;jb=j;s=v[113305];a:{b:{c:{a=j+16|0;m=a;e=b;g=v[113364];d:{e:{while(1){if((e|0)!=w[d+52288|0]){c=87;d=d+1|0;if((d|0)!=87){continue}break e}break}c=d;if(c){break e}e=52384;break d}d=52384;while(1){h=w[d|0];e=d+1|0;d=e;if(h){continue}d=e;c=c-1|0;if(c){continue}break}}c=v[g+20>>2];if(c){k=v[c+4>>2];d=e;f=v[c>>2];i=v[f>>2]+1794895138|0;l=hl(v[f+8>>2],i);g=hl(v[f+12>>2],i);h=hl(v[f+16>>2],i);f:{if(k>>>2>>>0<=l>>>0){break f}c=k-(l<<2)|0;if((g|h)&3|(c>>>0<=g>>>0|c>>>0<=h>>>0)){break f}u=h>>>2|0;x=g>>>2|0;while(1){n=l>>>1|0;g=n+o|0;h=g<<1;c=(h+x<<2)+f|0;p=hl(v[c>>2],i);c=hl(v[c+4>>2],i);if(c>>>0>=k>>>0|k-c>>>0<=p>>>0|w[(c+p|0)+f|0]){break f}c=fi(d,c+f|0);if(!c){d=(h+u<<2)+f|0;c=hl(v[d>>2],i);d=hl(v[d+4>>2],i);if(d>>>0>=k>>>0|c>>>0>=k-d>>>0){break f}q=w[(c+d|0)+f|0]?0:d+f|0;break f}if((l|0)==1){break f}c=(c|0)<0;l=c?n:l-n|0;o=c?o:g;continue}}}d=q?q:e;e=cf(d);g:{if(e>>>0>=1024){lc(m,d,1023);t[m+1023|0]=0;e=68;break g}lc(m,d,e+1|0);e=0}switch(e+1|0){case 1:break a;case 0:break c;default:break b}}e=v[113305]}a=17540;if((e|0)==28){break a}xa();L()}if(!w[a|0]){v[j>>2]=b;a=j+16|0;pw(a,1024,9030,j)}v[113305]=s;Ub(r,a);jb=j+1040|0}function p9(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=C(0),k=C(0),l=0,m=0,n=C(0);h=jb-16|0;jb=h;a:{if(u[d>>1]>u[d+2>>1]){break a}if(!Kb(b)){break a}g=u[e>>1];if((g|0)<u[d>>1]){break a}i=u[d+2>>1];if((i|0)<(g|0)){break a}if((Kb(b)-1&65535)>>>0>(i-g&65535)>>>0|y[a+36>>2]>65535){break a}b:{if(!Kb(b)){break b}while(1){if(!(z[Pb(b,f)>>2]<C(0))){f=f+1|0;if(Kb(b)>>>0>f>>>0){continue}break b}break}f=0;break a}f=0;if(z[c>>2]<=C(0)){break a}u[a>>1]=1;u[a+28>>1]=x[d>>1];l=a,m=TJ(Kb(b)),u[l+30>>1]=m;z[a+32>>2]=D(z[c>>2]);g=a+4|0;ql(g,(u[d+2>>1]-u[d>>1]|0)+1|0);c=ac(b);f=bc(b);l=h,m=ac(g),v[l+8>>2]=m;i=sp(h+8|0,u[e>>1]-u[d>>1]|0);b=jb-16|0;jb=b;Oc(b+8|0,Jz(Jl(c),Jl(f),Jl(i)));jb=b+16|0;b=u[e>>1];f=u[a+28>>1];c:{if((b|0)<=(f|0)){c=b;break c}while(1){b=b-1|0;j=z[Pb(g,u[a+30>>1]+(b-f|0)|0)>>2];k=z[a+32>>2];l=Pb(g,b-u[a+28>>1]|0),n=C(j/k),z[l>>2]=n;c=u[e>>1];f=u[a+28>>1];if((f|0)>=(b|0)){break c}if((c|0)!=-32768){continue}break}}f=u[a+30>>1];b=f+c|0;d:{if((b|0)>u[d+2>>1]|(32767-f|0)<(c|0)){break d}while(1){j=z[a+32>>2];k=z[Pb(g,b-(u[a+28>>1]+f|0)|0)>>2];l=Pb(g,b-u[a+28>>1]|0),n=C(k*j),z[l>>2]=n;if(u[d+2>>1]<=(b|0)){break d}b=b+1|0;f=u[a+30>>1];if(u[e>>1]<=(32767-f|0)){continue}break}}Oo(a);f=1}jb=h+16|0;return f|0}function $ka(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;c=jb-16|0;jb=c;a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{b=w[a+3|0];switch(b-14|0){case 2:case 3:case 4:case 5:break b;case 8:break f;case 6:case 7:break g;case 1:break h;case 0:break i;default:break j}}switch(b-31|0){case 2:break d;case 0:break e;default:break b}}k:{l:{b=w[a+5|0];if((b|0)!=240){if((b|0)==15){break l}if(b){break k}t[a+3|0]=11;break a}t[a+5|0]=239;break c}t[a+5|0]=254;break c}if(b>>>0>=16){t[a+5|0]=b|15;break c}t[a+5|0]=b|240;break c}t[c+15|0]=w[a+5|0]>>>4;t[c+14|0]=15;e=a,f=w[pc(c+15|0,c+14|0)|0]|32,t[e+5|0]=f;break c}b=w[a+5|0];if(b>>>0>=16){t[a+5|0]=b>>>4|240;break c}t[a+5|0]=b|224;break c}t[a+5|0]=((w[a+5|0]^-1)&254)>>>1;break c}e=a,f=Hk(w[a+5|0]<<1),t[e+5|0]=f;break c}b=32;m:{n:{o:{p:{q:{r:{s:{t:{d=w[a+5|0];switch(d>>>4|0){case 3:break m;case 5:break n;case 14:break o;case 12:case 13:break p;case 11:break q;case 10:break r;case 8:break s;case 0:break c;default:break t}}t[a+3|0]=0;break c}b=64;break m}b=176;break m}b=224;break m}if(d){break c}t[a+3|0]=0;break c}t[a+5|0]=119;break c}b=48}t[a+5|0]=d&15|b}b=w[a+3|0]}if(b>>>0>=36){t[a+3|0]=0;break a}t[a+3|0]=w[b+23824|0];if(w[a+2|0]|(b|0)!=12){break a}t[a+2|0]=1;t[a+3|0]=0;b=w[a+5|0];t[a+5|0]=0;t[a+4|0]=b}jb=c+16|0}function Ika(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;c=jb-32|0;jb=c;a:{if(!Rb(b,9)){break a}h=a+484344|0;i=a+480280|0;while(1){wn(b,c+28|0);d=Df(b);b:{e=w[c+28|0]|w[c+29|0]<<8|(w[c+30|0]<<16|w[c+31|0]<<24);c:{if((e|0)==1229999433|(e|0)==1397771593){break c}e=w[c+28|0]|w[c+29|0]<<8|(w[c+30|0]<<16|w[c+31|0]<<24);if((e|0)==1297110104|(e|0)==1297110099){break c}if(Rb(b,d)){break b}}mg(b,8);break a}td(c+8|0,b,d);d=i;d:{e:{f:{if((w[c+28|0]|w[c+29|0]<<8|(w[c+30|0]<<16|w[c+31|0]<<24))==1481001027){while(1){v[113382]=0;e=T(397,c+8|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break f}t[d+8|0]=e;d=d+32|0;if((h|0)!=(d|0)){continue}break d}}if(w[c+28|0]!=70){break e}e=w[c+29|0];g=(e|0)==88;g:{if(!g){if((e-48&255)>>>0>9){break e}d=t[c+30|0];if((d|0)>47){break g}break e}d=t[c+30|0];if((d|0)<48){break e}}if((d&255)>>>0>57){break e}f=t[c+31|0];if((f|0)<48|(f|0)>57){break e}d=(f+(g?-16:B(e,100)+48|0)|0)+B(d,10)&255;if(d>>>0>249){break d}v[113382]=0;R(628,c+8|0,(B(d,160)+a|0)+906300|0);d=v[113382];v[113382]=0;if((d|0)!=1){break d}}a=P()|0;O()|0;Bb(c+8|0);S(a|0);L()}if((w[c+28|0]|w[c+29|0]<<8|(w[c+30|0]<<16|w[c+31|0]<<24))!=1430540109){break d}v[a+1074308>>2]=0;j=1}Bb(c+8|0);if(Rb(b,9)){continue}break}}jb=c+32|0;return j|0}function GF(a,b,c,d,e){var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0;k=jb-16|0;jb=k;a:{b:{c:{if((c|0)<=36){g=w[a|0];if(g){break c}f=a;break b}v[113305]=28;d=0;e=0;break a}f=a;d:{while(1){if(!jl(g<<24>>24)){break d}g=w[f+1|0];h=f+1|0;f=h;if(g){continue}break}f=h;break b}e:{g=w[f|0];switch(g-43|0){case 0:case 2:break e;default:break b}}m=(g|0)==45?-1:0;f=f+1|0}f:{if(!(c&-17|w[f|0]!=48)){o=1;if((w[f+1|0]&223)==88){f=f+2|0;l=16;break f}f=f+1|0;l=c?c:8;break f}l=c?c:10}p=l;q=l>>31;c=0;while(1){g:{g=-48;h=t[f|0];h:{if((h-48&255)>>>0<10){break h}g=-87;if((h-97&255)>>>0<26){break h}g=-55;if((h-65&255)>>>0>25){break g}}h=g+h|0;if((h|0)>=(l|0)){break g}Qe(k,p,q,0,0,j,i,0,0);g=1;i:{if(v[k+8>>2]|v[k+12>>2]){break i}r=qma(j,i,p,q);n=mb;s=h>>31;u=s^-1;if((n|0)==(u|0)&(h^-1)>>>0<r>>>0|n>>>0>u>>>0){break i}i=n+s|0;g=h+r|0;i=g>>>0<h>>>0?i+1|0:i;j=g;o=1;g=c}f=f+1|0;c=g;continue}break}if(b){v[b>>2]=o?f:a}j:{k:{if(c){v[113305]=68;a=d&1;m=a?0:m;j=d;i=e;break k}if((e|0)==(i|0)&d>>>0>j>>>0|e>>>0>i>>>0){break j}a=d&1}if(!(a|m)){v[113305]=68;a=d;d=a-1|0;e=e-!a|0;break a}if((e|0)==(i|0)&d>>>0>=j>>>0|e>>>0>i>>>0){break j}v[113305]=68;break a}a=m;b=a^j;d=b-a|0;c=a>>31;e=(c^i)-((a>>>0>b>>>0)+c|0)|0}jb=k+16|0;mb=e;return d}function X7(a){a=a|0;var b=0,c=0,d=0,e=0,f=C(0),g=0,h=0;c=jb-32|0;jb=c;a:{b=v[a+20>>2];b:{if(!b){break b}v[b+148>>2]=-1;g=c,h=nb[v[v[a>>2]+40>>2]](a)|0,v[g+16>>2]=h;v[c+8>>2]=1073741822;e=v[Zd(c+16|0,c+8|0)>>2];b=e<<2;if(!b){break b}d=v[a+20>>2];v[113382]=0;R(469,d+4|0,b+4|0);b=v[113382];v[113382]=0;c:{d:{e:{f:{if((b|0)!=1){b=v[a+20>>2];v[113382]=0;R(660,c+8|0,b+4|0);b=v[113382];v[113382]=0;if((b|0)==1){break d}v[113382]=0;v[c>>2]=0;v[c+4>>2]=0;U(1708,c+16|0,c+8|0,c|0);b=v[113382];v[113382]=0;if((b|0)==1){break f}v[113382]=0;Q(1709,c+16|0,0)|0;b=v[113382];v[113382]=0;g:{if((b|0)==1){break g}d=v[v[a>>2]+176>>2];b=0;v[113382]=0;R(d|0,a|0,-1);d=v[113382];v[113382]=0;if((d|0)==1){break g}if((e|0)>0){while(1){d=v[v[a>>2]+48>>2];v[113382]=0;f=C(pa(d|0,a|0,b|0));d=v[113382];v[113382]=0;if((d|0)==1){break e}v[113382]=0;z[c+8>>2]=f;Q(1710,c+16|0,c+8|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break e}b=b+1|0;if((e|0)!=(b|0)){continue}break}}b=v[v[a>>2]+180>>2];v[113382]=0;Z(b|0,a|0);b=v[113382];v[113382]=0;if((b|0)!=1){break b}}b=V(66740)|0;break c}b=V(66740)|0;break c}b=V(66740)|0;break c}b=V(66740)|0;break c}b=V(66740)|0}if((O()|0)!=(ga(66740)|0)){break a}_(b|0)|0;Js(v[a+20>>2]+4|0);$()}jb=c+32|0;return}S(b|0);L()}function rja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=jb-432|0;jb=d;Ic(b);Lz(b,d+376|0,d+296|0,d+8|0);l=d,m=Hk(w[d+408|0]|w[d+409|0]<<8|(w[d+410|0]<<16|w[d+411|0]<<24)?w[d+427|0]+1|0:1),t[l+4|0]=m;g=w[pc(24016,d+4|0)|0];t[d+7|0]=g;u[d+4>>1]=4;a:{b:{if(!g){break b}while(1){e=w[d+8|0]|w[d+9|0]<<8;c:{d:{if(w[d+291|0]>63){break d}f=(e<<8|e>>>8)<<16>>16;if((f|0)<0){break d}if(e){e=f&65535;j=e>>>0>1?e:1;f=0;while(1){e=w[d+392|0]|w[d+393|0]<<8|(w[d+394|0]<<16|w[d+395|0]<<24);e:{if(!Nc(b,(e<<24|e<<8&16711680|(e>>>8&65280|e>>>24))+(f<<2)|0)){break e}if(!Nc(b,au(b))){break e}e=d;f:{if(!c){i=le(b);break f}i=Zp(b)}u[e+2>>1]=i;l=d,m=x[Ri(d+4|0,d+2|0)>>1],u[l+4>>1]=m}f=f+1|0;if((j|0)!=(f|0)){continue}break}}e=w[d+296|0]|w[d+297|0]<<8|(w[d+298|0]<<16|w[d+299|0]<<24);if((e<<24|e<<8&16711680|(e>>>8&65280|e>>>24))>>>0>k>>>0){e=w[d+296|0]|w[d+297|0]<<8|(w[d+298|0]<<16|w[d+299|0]<<24);if(Nc(b,e<<24|e<<8&16711680|(e>>>8&65280|e>>>24))){break c}}t[d+7|0]=h+1;break b}ZB(a);break a}e=d+296|0;f=w[e|0]|w[e+1|0]<<8|(w[e+2|0]<<16|w[e+3|0]<<24);Lz(b,d+376|0,e,d+8|0);k=f<<8&16711680|f<<24|(f>>>8&65280|f>>>24);h=h+1|0;if((h&255)>>>0<g>>>0){continue}break}}u[a>>1]=x[d+4>>1];t[a+2|0]=w[d+7|0]}jb=d+432|0}function BT(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;i=jb-32|0;jb=i;t[i+12|0]=0;l=ZA(i+16|0,d,i+12|0);h=v[l>>2];v[i+12>>2]=d;f=d;a:{if(!b|!f){break a}while(1){n=i;g=b-1|0;f=w[a|0];b:{c:{if(!(!g|(f|0)!=(e&255))){f=w[a+1|0];v[113382]=0;v[i+8>>2]=f;f=Q(33,i+8|0,i+12|0)|0;g=v[113382];v[113382]=0;d:{if((g|0)!=1){k=a+2|0;g=b-2|0;if(!g){break d}j=v[f>>2];if(!(j&255)){break d}g=w[k|0];while(1){t[h|0]=g;f=v[i+12>>2]-1|0;v[i+12>>2]=f;h=h+1|0;j=j-1|0;if(j&255){continue}break}g=b-3|0;k=a+3|0;break b}a=P()|0;O()|0;sq(l);S(a|0);L()}t[h|0]=e;f=v[i+12>>2]-1|0;break c}k=a+1|0;t[h|0]=f;f=v[i+12>>2]-1|0}v[n+12>>2]=f;h=h+1|0}if(!g){break a}a=k;b=g;if(f){continue}break}}k=v[l>>2];e=d-f|0;e:{if(!e){break e}h=128;g=0;while(1){b=w[k|0];j=0;f=0;while(1){a=c+g|0;t[a|0]=w[a|0]|(B(b&h,257)&65535)>>>(f-j&7);a=g+1|0;g=a>>>0<d>>>0?a:0;f=(a>>>0>=d>>>0)+f|0;h=(h<<8|h)>>>1&255;a=j&65535;j=j+1|0;if(a>>>0<7){continue}break}h=(h<<8|h)>>>f&255;k=k+1|0;m=m+1|0;if((m|0)!=(e|0)){continue}break}if(!e){break e}j=0;while(1){d=c;f=d;g=j<<24>>24;b=t[d|0];d=128;f:{if((b|0)==-128){break f}a=b;d=a;if((a|0)>=0){break f}d=0-(b&127)|0}j=g-(d&255)|0;t[f|0]=j;c=c+1|0;e=e-1|0;if(e){continue}break}}sq(l);jb=i+32|0}function lL(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;e=jb-16|0;jb=e;a:{b:{d=a+484360|0;if(oc(Vb(d))>>>0<=b>>>0){break b}if(pp(Vb(d),b)){break b}while(1){b=b+1|0;c=b&65535;if(oc(Vb(d))>>>0<=c>>>0){break a}if(!pp(Vb(d),b&65535)){continue}break}break a}c=b}if(oc(Vb(d))>>>0>c>>>0){d=a+1074312|0;g=a+1304360|0;c=a+1074984|0;while(1){t[c+819|0]=0;v[c+700>>2]=0;t[c+861|0]=0;t[c+827|0]=0;v[c+708>>2]=0;t[c+841|0]=0;v[c+804>>2]=0;t[c+839|0]=0;t[c+840|0]=0;f=e+8|0;Fb(f,d,23);if(Cb(f)){u[c+798>>1]=0;u[c+800>>1]=1}t[c+859|0]=0;c=c+896|0;if((g|0)!=(c|0)){continue}break}kL(a);c:{if(!(b&65535)){b=a;c=0;while(1){mn((b+B(c,896)|0)+1074984|0,7,b,c&65535,1024);c=c+1|0;if((c|0)!=256){continue}break}tk(b+1304360|0,1);v[b+1074444>>2]=v[b+480200>>2];v[b+1074416>>2]=v[b+480196>>2];v[b+1074420>>2]=v[b+480204>>2];v[b+480208>>2]=v[b+480208>>2]&-769;qy(b+1074376|0);u[b+1074440>>1]=0;v[b+1074392>>2]=-2;c=b+1074428|0;v[c>>2]=0;v[c+4>>2]=0;c=b+1074396|0;v[c>>2]=0;v[c+4>>2]=0;v[b+1074376>>2]=0;v[b+1074380>>2]=0;break c}u[a+1074440>>1]=b;u[a+1074436>>1]=0;b=a+1074424|0;v[b>>2]=0;v[b+4>>2]=0;v[a+1074392>>2]=-2;v[a+1074432>>2]=0;b=a+1074396|0;v[b>>2]=0;v[b+4>>2]=0;v[a+1074380>>2]=0}v[a+480208>>2]=v[a+480208>>2]&-769}jb=e+16|0}function pla(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;f=jb-16|0;jb=f;sd(b,32);e=a+4|0;e=w[e|0]|w[e+1|0]<<8|(w[e+2|0]<<16|w[e+3|0]<<24);v[b>>2]=e<<24|e<<8&16711680|(e>>>8&65280|e>>>24);e=a+10|0;e=w[e|0]|w[e+1|0]<<8|(w[e+2|0]<<16|w[e+3|0]<<24);e=e<<24|e<<8&16711680|(e>>>8&65280|e>>>24);v[b+4>>2]=e;g=e;e=a+14|0;e=w[e|0]|w[e+1|0]<<8|(w[e+2|0]<<16|w[e+3|0]<<24);v[b+8>>2]=g+(e<<24|e<<8&16711680|(e>>>8&65280|e>>>24));e=b;if(c?d:1){c=a+46|0;c=w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24);c=c<<24|c<<8&16711680|(c>>>8&65280|c>>>24)}v[e+24>>2]=c;c=w[a+8|0]<<28>>24;a:{if((d|0)!=841887798){break a}d=a+42|0;e=w[d+1|0]<<8;if(!(w[d|0]|e)|(e|w[d|0])==12288){break a}e=c;c=w[d|0]|w[d+1|0]<<8;c=(e-(((c<<8|c>>>8)&65535)<<7)|0)+6144|0}Ys(b,+(c|0)*.0006510416666666666);t[f+15|0]=w[a+9|0];t[f+14|0]=64;h=b,i=w[pc(f+15|0,f+14|0)|0]<<2,u[h+30>>1]=i;if(t[a+40|0]&1){u[b+34>>1]=x[b+34>>1]|64;v[b>>2]=v[b>>2]>>>1;v[b+4>>2]=v[b+4>>2]>>>1;v[b+8>>2]=v[b+8>>2]>>>1}b:{if(w[a+41|0]<=8){a=v[b+4>>2];c=v[b+8>>2];break b}u[b+34>>1]=x[b+34>>1]|1;v[b>>2]=v[b>>2]>>>1;a=v[b+4>>2]>>>1|0;v[b+4>>2]=a;c=v[b+8>>2]>>>1|0;v[b+8>>2]=c}c:{if(a+1>>>0<c>>>0){u[b+34>>1]=x[b+34>>1]|2;break c}v[b+4>>2]=0;v[b+8>>2]=0}jb=f+16|0}function dia(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;k=jb-16|0;jb=k;e=b;f=Ig(e);d=c;a:{if(f>>>0<d>>>0){l=jb-32|0;jb=l;b:{c:{i=d-f|0;d:{if(i>>>0<=v[zb(e)>>2]-v[e+4>>2]>>3>>>0){g=jb-16|0;jb=g;e:{d=zq(g,e,i);f=v[d+4>>2];h=v[d+8>>2];if((f|0)!=(h|0)){while(1){i=zb(e);v[113382]=0;R(888,i|0,f|0);i=v[113382];v[113382]=0;if((i|0)==1){break e}f=f+8|0;v[d+4>>2]=f;if((f|0)!=(h|0)){continue}break}}Mb(d);jb=g+16|0;break d}a=P()|0;O()|0;Mb(d);S(a|0);L()}m=zb(e);g=l+8|0;j=Ig(e)+i|0;h=jb-16|0;jb=h;v[h+12>>2]=j;f=e;f:{d=Yu(e);if(j>>>0<=d>>>0){f=Ui(f);if(f>>>0<d>>>1>>>0){v[h+8>>2]=f<<1;d=v[Vc(h+8|0,h+12|0)>>2]}jb=h+16|0;break f}ld();L()}j=Ig(e);f=0;h=jb-16|0;jb=h;v[h+12>>2]=0;Le(g+12|0,m);if(d){f=MC(v[g+16>>2],d)}v[g>>2]=f;j=(j<<3)+f|0;v[g+8>>2]=j;v[g+4>>2]=j;n=gc(g),o=(d<<3)+f|0,v[n>>2]=o;jb=h+16|0;v[113382]=0;R(886,g|0,i|0);d=v[113382];v[113382]=0;if((d|0)==1){break c}v[113382]=0;R(887,e|0,g|0);e=v[113382];v[113382]=0;if((e|0)==1){break c}HP(g)}jb=l+32|0;break b}a=P()|0;O()|0;HP(g);S(a|0);L()}break a}if(d>>>0<f>>>0){d=v[e>>2]+(d<<3)|0;Ig(e);IP(e,d);Ui(e);Ig(e)}}c=Rb(a,c<<3);if(c){e=jb-16|0;jb=e;d=k+8|0;fc(d,v[b>>2],Ig(b)<<3);jb=e+16|0;zd(a,d)}jb=k+16|0;return c|0}function cfa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,w=0,x=0,y=0,z=0,A=0;h=jb-16|0;jb=h;f=v[a+48>>2];l=v[a+40>>2];m=v[a+36>>2];b=v[a+44>>2];p=v[a+16>>2];e=v[a+4>>2];i=v[a>>2];v[h+8>>2]=i;v[h+12>>2]=e;g=v[a+12>>2];v[h>>2]=v[a+8>>2];v[h+4>>2]=g;a:{if(d){while(1){g=e+p|0;j=t[g+2|0];n=t[g+1|0];q=t[g|0];r=t[g-1|0];g=v[a+60>>2];s=g;w=g>>31;e=Yb(b,-16777216,16776704);k=v[a+64>>2];f=Yb(f,-16777216,16776704);x=v[a+72>>2];y=v[a+32>>2];g=c;z=v[g>>2];e=qma(k,k>>31,e,e>>31);k=mb;A=e;e=v[a+68>>2];o=qma(e,e>>31,f,f>>31);e=A+o|0;f=mb+k|0;f=e>>>0<o>>>0?f+1|0:f;k=e;e=(i>>>21&2040)+33120|0;i=(((B(q,u[e+2>>1])+B(r,u[e>>1])|0)+B(n,u[e+4>>1])|0)+B(j,u[e+6>>1])<<8)/16384<<8;e=i;j=qma(s,w,e,e>>31);e=k+j|0;f=mb+f|0;f=e>>>0<j>>>0?f+1|0:f;e=e+8388608|0;f=e>>>0<8388608?f+1|0:f;e=(f&16777215)<<8|e>>>24;f=(e|0)/256|0;m=v[a+28>>2]+m|0;j=m>>12;v[g>>2]=B(f,j)+z;l=l+y|0;n=l>>12;v[g+4>>2]=v[g+4>>2]+B(f,n);g=e-(i&x)|0;Sb(h+8|0,h);d=d-1|0;if(d){c=c+8|0;i=v[h+8>>2];e=v[h+12>>2];f=b;b=g;continue}break}i=v[h+8>>2];e=v[h+12>>2];f=b;break a}n=l>>12;j=m>>12;g=b}v[a+40>>2]=l;v[a+20>>2]=j;v[a+36>>2]=m;v[a+48>>2]=f;v[a+44>>2]=g;v[a+24>>2]=n;v[a>>2]=i;v[a+4>>2]=e;jb=h+16|0}function mma(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=jb-32|0;jb=f;v[f+24>>2]=b;b=v[a>>2];o=f,p=ac(a),v[o>>2]=p;b=b+(Yp(f+24|0,f)<<1)|0;a:{b:{if(y[a+4>>2]<y[zb(a)>>2]){g=v[a+4>>2];if((g|0)!=(b|0)){break b}e=jb-16|0;jb=e;d=Uh(e,a,1);a=zb(a);h=v[d+4>>2];v[113382]=0;U(484,a|0,h|0,c|0);a=v[113382];v[113382]=0;c:{if((a|0)!=1){v[d+4>>2]=v[d+4>>2]+2;Mb(d);jb=e+16|0;break c}a=P()|0;O()|0;Mb(d);S(a|0);L()}break a}d=zb(a);d=bq(f,Qi(a,oc(a)+1|0),b-v[a>>2]>>1,d);v[113382]=0;R(478,d|0,c|0);c=v[113382];v[113382]=0;d:{if((c|0)==1){break d}v[113382]=0;b=W(479,a|0,d|0,b|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break d}_t(d);break a}a=P()|0;O()|0;_t(d);S(a|0);L()}l=jb-16|0;jb=l;n=a;h=b;i=v[a+4>>2];d=(i-(b+2|0)|0)+b|0;j=Uh(l,a,g-d>>1);e:{f:{if(d>>>0<g>>>0){k=v[j+4>>2];e=d;while(1){m=zb(n);v[113382]=0;U(486,m|0,k|0,e|0);m=v[113382];v[113382]=0;if((m|0)==1){break f}k=k+2|0;v[j+4>>2]=k;e=e+2|0;if(e>>>0<g>>>0){continue}break}}Mb(j);if((d|0)!=(h|0)){while(1){i=i-2|0;d=d-2|0;bT(i,d);if((d|0)!=(h|0)){continue}break}}jb=l+16|0;break e}a=P()|0;O()|0;Mb(j);S(a|0);L()}a=((b>>>0<=c>>>0&y[a+4>>2]>c>>>0)<<1)+c|0;t[b|0]=w[a|0];t[b+1|0]=w[a+1|0]}a=Pg(b);jb=f+32|0;return a|0}function Yo(a){var b=0,c=0,d=0,e=0,f=0,g=0;c=jb-16|0;jb=c;a:{b:{c:{d:{e:{f:{g:{h:{b=v[a+480180>>2];i:{if((b|0)<=2047){if((b|0)<=31){switch(b-1|0){case 2:case 4:case 5:case 6:break d;case 7:break g;case 0:case 1:case 3:break i;default:break e}}if((b|0)<=255){if((b|0)==32){break i}if((b|0)==64){break b}break d}if((b|0)==256|(b|0)==512){break b}break d}d=1;if((b|0)<=4194303){if((b|0)<=65535){if((b|0)==2048){break b}if((b|0)!=8192){break d}break b}if((b|0)==65536){break c}if((b|0)!=2097152){break d}break a}if((b|0)>67108863){break h}if((b|0)==4194304){break f}if((b|0)!=16777216){break d}}d=v[a+480180>>2];break a}if((b|0)==67108864|(b|0)==134217728){break a}if((b|0)!=536870912){break d}break a}d=4;if(x[a+480192>>1]){break a}a=a+484344|0;f=c,g=ac(a),v[f+8>>2]=g;f=c,g=bc(a),v[f>>2]=g;d=1;if(!Jb(c+8|0,c)){break a}while(1){a=v[c+8>>2];if(!(!qh(a)|v[a+12>>2]==64)){d=4;break a}a=c+8|0;Cy(a);if(Jb(a,c)){continue}break}break a}d=32;if(x[a+480188>>1]>16){break a}if(!x[a+480188>>1]){break b}b=0;while(1){e=(b<<5)+a|0;if(t[e+480281|0]&1|x[e+480286>>1]!=64){break a}b=b+1|0;if(b>>>0<x[a+480188>>1]){continue}break}break b}if((b|0)==16){break b}}d=32;break a}d=16777216;break a}d=2}jb=c+16|0;return d}function fZ(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0;j=jb-16|0;jb=j;i=c;while(1){a:{if((d|0)==(i|0)){i=d;break a}if(!v[i>>2]){break a}i=i+4|0;continue}break}v[h>>2]=f;v[e>>2]=c;while(1){b:{c:{if(!((c|0)==(d|0)|(f|0)==(g|0))){k=v[b+4>>2];v[j+8>>2]=v[b>>2];v[j+12>>2]=k;m=1;l=jb-16|0;jb=l;v[l+12>>2]=v[a+8>>2];n=Bh(l+8|0,l+12|0);v[113382]=0;k=LF(f,e,i-c>>2,g-f|0,b);o=v[113382];v[113382]=0;d:{if((o|0)!=1){Ge(n);jb=l+16|0;break d}a=P()|0;O()|0;Ge(n);S(a|0);L()}e:{f:{g:{h:{switch(k+1|0){case 0:v[h>>2]=f;while(1){i:{if(v[e>>2]==(c|0)){break i}b=Pv(f,v[c>>2],j+8|0,v[a+8>>2]);if((b|0)==-1){break i}f=b+v[h>>2]|0;v[h>>2]=f;c=c+4|0;continue}break};v[e>>2]=c;break g;case 1:break c;default:break h}}f=k+v[h>>2]|0;v[h>>2]=f;if((f|0)==(g|0)){break e}if((d|0)==(i|0)){c=v[e>>2];i=d;continue}i=Pv(j+4|0,0,b,v[a+8>>2]);if((i|0)!=-1){break f}}m=2;break c}c=j+4|0;if(g-v[h>>2]>>>0<i>>>0){break c}while(1){if(i){f=w[c|0];k=v[h>>2];v[h>>2]=k+1;t[k|0]=f;i=i-1|0;c=c+1|0;continue}break}c=v[e>>2]+4|0;v[e>>2]=c;i=c;while(1){if((d|0)==(i|0)){i=d;break b}if(!v[i>>2]){break b}i=i+4|0;continue}}c=v[e>>2]}m=(c|0)!=(d|0)}jb=j+16|0;return m|0}f=v[h>>2];continue}}function bfa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0;h=jb-16|0;jb=h;e=v[a+48>>2];l=v[a+40>>2];m=v[a+36>>2];b=v[a+44>>2];p=v[a+16>>2];f=v[a+4>>2];k=v[a>>2];v[h+8>>2]=k;v[h+12>>2]=f;g=v[a+12>>2];v[h>>2]=v[a+8>>2];v[h+4>>2]=g;a:{if(d){while(1){g=(f<<1)+p|0;i=u[g>>1];q=u[g-2>>1];r=u[g+2>>1];s=u[g+4>>1];o=v[a+60>>2];f=Yb(b,-16777216,16776704);n=v[a+64>>2];j=Yb(e,-16777216,16776704);t=v[a+72>>2];w=v[a+32>>2];g=c;x=v[g>>2];e=qma(n,n>>31,f,f>>31);n=mb;f=e;e=(k>>>21&2040)+33120|0;k=(((B(i,u[e+2>>1])+B(q,u[e>>1])|0)+B(r,u[e+4>>1])|0)+B(s,u[e+6>>1])|0)/16384<<8;e=k;i=qma(o,o>>31,e,e>>31);f=f+i|0;e=mb+n|0;e=f>>>0<i>>>0?e+1|0:e;i=f;f=v[a+68>>2];j=qma(f,f>>31,j,j>>31);f=i+j|0;e=mb+e|0;e=f>>>0<j>>>0?e+1|0:e;f=f+8388608|0;e=f>>>0<8388608?e+1|0:e;f=(e&16777215)<<8|f>>>24;e=(f|0)/256|0;m=v[a+28>>2]+m|0;j=m>>12;v[g>>2]=B(e,j)+x;l=l+w|0;i=l>>12;v[g+4>>2]=v[g+4>>2]+B(e,i);g=f-(k&t)|0;Sb(h+8|0,h);d=d-1|0;if(d){c=c+8|0;k=v[h+8>>2];f=v[h+12>>2];e=b;b=g;continue}break}k=v[h+8>>2];f=v[h+12>>2];e=b;break a}i=l>>12;j=m>>12;g=b}v[a+40>>2]=l;v[a+20>>2]=j;v[a+36>>2]=m;v[a+48>>2]=e;v[a+44>>2]=g;v[a+24>>2]=i;v[a>>2]=k;v[a+4>>2]=f;jb=h+16|0}function Xea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=jb-32|0;jb=g;a:{b:{c:{e=v[a+12>>2];h=v[a+8>>2];d:{if((e|0)<=1&h>>>0<=805306368|(e|0)<=0){if((e|0)>=-2&h>>>0>=3489660928|(e|0)>-2){break c}if((e|0)==-2&h>>>0>2147483647|e>>>0>4294967294){break d}break b}if((e|0)==1&h>>>0>2147483648|e>>>0>1){break b}}i=b+196648|0;break a}i=b+131112|0;break a}i=b+262184|0}j=v[a+16>>2];k=v[a+24>>2];l=v[a+20>>2];b=v[a+4>>2];f=v[a>>2];v[g+24>>2]=f;v[g+28>>2]=b;v[g+16>>2]=h;v[g+20>>2]=e;if(d){while(1){e=((((b&2147483647)<<1|f>>>31)&2147483646)<<1)+j|0;b=(f>>>16&65520)+i|0;m=u[b+14>>1];n=u[b+12>>1];o=u[b+10>>1];p=u[b+8>>1];q=u[b+6>>1];r=u[b+4>>1];s=u[b+2>>1];t=u[b>>1];h=0;b=1;while(1){f=h<<1;v[(g+8|0)+(h<<2)>>2]=(((((((B(u[(f|-8)+e>>1],s)+B(u[(f|-12)+e>>1],t)|0)+B(u[(f|-4)+e>>1],r)|0)+B(u[e+f>>1],q)|0)+B(u[(f|4)+e>>1],p)|0)+B(u[(f|8)+e>>1],o)|0)+B(u[(f|12)+e>>1],n)|0)+B(u[(f|16)+e>>1],m)|0)/32768;f=b;b=0;h=1;if(f){continue}break}v[c>>2]=v[c>>2]+B(v[g+8>>2],l);v[c+4>>2]=v[c+4>>2]+B(v[g+12>>2],k);Sb(g+24|0,g+16|0);d=d-1|0;if(d){c=c+8|0;f=v[g+24>>2];b=v[g+28>>2];continue}break}f=v[g+24>>2];b=v[g+28>>2]}v[a>>2]=f;v[a+4>>2]=b;jb=g+32|0}function pea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=jb-48|0;jb=e;j=v[a+16>>2];f=Uf(e+16|0);v[f+8>>2]=a+112;v[f+16>>2]=v[a+128>>2];n=f,o=Pf(b+327720|0,v[b+20>>2],(v[a+88>>2]&16384)>>>14|0),v[n+12>>2]=o;b=v[f+16>>2];if(b){n=f,o=Tf(a+8|0,b),v[n>>2]=o;v[f+4>>2]=mb}k=v[a+24>>2];l=v[a+20>>2];b=v[a+4>>2];g=v[a>>2];v[e+8>>2]=g;v[e+12>>2]=b;h=v[a+12>>2];v[e>>2]=v[a+8>>2];v[e+4>>2]=h;if(d){while(1){h=0;i=g;v[e+40>>2]=g;v[e+44>>2]=m;g=((((b&2147483647)<<1|g>>>31)&2147483646)<<1)+j|0;a:{b=v[f+16>>2];if((b|0)<=0){break a}while(1){h=(h&2147483647)<<1|i>>>31;yd(v[f+8>>2],(u[(h<<1|2)+g>>1]+u[g+((h&2147483646)<<1)>>1]|0)/8<<16>>16);xd(v[f+8>>2],4);Sb(e+40|0,f);if((b|0)<2){break a}b=b-1|0;i=v[e+40>>2];h=v[e+44>>2];continue}}d=d-1|0;b=v[f+8>>2];Sb(b,b+8|0);b=v[f+8>>2];h=v[b+4>>2];if(h){i=b;b=(v[e+44>>2]&2147483647)<<1|v[e+40>>2]>>>31;yd(i,(u[(b<<1|2)+g>>1]+u[g+((b&2147483646)<<1)>>1]|0)/8<<16>>16);xd(v[f+8>>2],h);b=v[f+8>>2];h=v[b>>2];v[b>>2]=h;v[b+4>>2]=0}b=Of(b,v[f+12>>2]);v[c>>2]=v[c>>2]+B(b,l);v[c+4>>2]=v[c+4>>2]+B(b,k);Sb(e+8|0,e);if(d){c=c+8|0;g=v[e+8>>2];b=v[e+12>>2];continue}break}g=v[e+8>>2];b=v[e+12>>2]}v[a>>2]=g;v[a+4>>2]=b;jb=e+48|0}function hR(a,b){var c=0,d=0,e=0,f=0;c=jb-16|0;jb=c;d=w[a|0];a:{if(d>>>0>21){break a}t[a|0]=w[d+23888|0];b:{switch(d-8|0){case 0:t[b|0]=w[b|0]<<1;break a;case 4:t[b|0]=w[b|0]+1>>>1;break a;case 5:a=w[b|0];t[b|0]=B(a>>>4|0,10)+(a&15);break a;case 6:c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{d=w[b|0];switch((d>>>4|0)-1|0){case 11:case 12:case 13:break a;case 9:break e;case 8:break f;case 6:break g;case 5:break h;case 3:break i;case 1:break j;case 0:break k;case 14:break c;case 10:break d;default:break l}}t[a|0]=0;break a}t[a|0]=29;t[c+15|0]=w[b|0]&15;t[c+14|0]=14;e=b,f=w[pc(c+15|0,c+14|0)|0]<<4|15,t[e|0]=f;break a}t[a|0]=29;t[c+13|0]=w[b|0]&15;t[c+12|0]=14;e=b,f=w[pc(c+13|0,c+12|0)|0]|240,t[e|0]=f;break a}t[b|0]=d&15|48;break a}t[b|0]=d&15|176;break a}t[b|0]=d&15|64;break a}t[a|0]=15;t[b|0]=w[b|0]&15;break a}t[a|0]=24;t[b|0]=(w[b|0]<<3&120)+8&240;break a}t[a|0]=24;t[b|0]=(w[b|0]&15)+1>>>1;break a}t[a|0]=10;break a;case 8:a=w[b|0];if(a>>>0<=223){t[b|0]=a>>>0>63?-16:a<<2&240;break a}if(a>>>0<=239){t[b|0]=a<<2&48|15;break a}t[b|0]=a<<4|15;break a;case 9:break b;default:break a}}a=w[b|0];if(a>>>0<=223){t[b|0]=a>>>0>63?15:a>>>2|0;break a}if(a>>>0>239){break a}t[b|0]=a>>>2&3|240}jb=c+16|0}function cga(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;g=jb-16|0;jb=g;a:{if(w[d|0]){e=Dd(g+8|0,b);b=Ci(c,b);d=jb-16|0;jb=d;v[d+12>>2]=b;c=v[e+4>>2];b:{if(c){v[d+8>>2]=32-c;b=Lb(d+8|0,d+12|0);c=v[e>>2];b=v[b>>2];f=v[c>>2]&(-1<<v[e+4>>2]&-1>>>v[d+8>>2]-b);if(f){$c(a,c,pma(f));break b}f=v[d+12>>2];if((f|0)==(b|0)){_y(a,e,b);break b}b=f-b|0;v[d+12>>2]=b;v[e>>2]=c+4}if(b>>>0>=32){c=v[e>>2];while(1){f=v[c>>2];if(f){$c(a,c,pma(f));break b}c=c+4|0;v[e>>2]=c;b=b-32|0;v[d+12>>2]=b;if(b>>>0>31){continue}break}}c:{if(!b){c=v[e>>2];break c}c=v[e>>2];e=v[c>>2]&-1>>>32-b;if(!e){break c}$c(a,c,pma(e));break b}$c(a,c,b)}break a}e=Dd(g,b);b=Ci(c,b);d=jb-16|0;jb=d;v[d+12>>2]=b;c=v[e+4>>2];d:{if(c){v[d+8>>2]=32-c;b=v[Lb(d+8|0,d+12|0)>>2];c=v[e>>2];f=-1<<v[e+4>>2]&-1>>>v[d+8>>2]-b&(v[c>>2]^-1);if(f){$c(a,c,pma(f));break d}f=v[d+12>>2];if((f|0)==(b|0)){_y(a,e,b);break d}b=f-b|0;v[d+12>>2]=b;v[e>>2]=c+4}if(b>>>0>=32){c=v[e>>2];while(1){f=v[c>>2];if((f|0)!=-1){$c(a,c,pma(f^-1));break d}c=c+4|0;v[e>>2]=c;b=b-32|0;v[d+12>>2]=b;if(b>>>0>31){continue}break}}e:{if(!b){c=v[e>>2];break e}c=v[e>>2];e=(v[c>>2]^-1)&-1>>>32-b;if(!e){break e}$c(a,c,pma(e));break d}$c(a,c,b)}}jb=d+16|0;jb=g+16|0}function v3(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;b=jb-2144|0;jb=b;Qb(b+96|0,0,2048);a:{b:{c:{f=v[c+4>>2];if(!f){a=ba(8)|0;v[113382]=0;b=Q(121,b+80|0,6541)|0;c=v[113382];v[113382]=0;if((c|0)==1){break c}nc(a,b);v[113382]=0;U(1978,a|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break a}c=P()|0;O()|0;yb(b);break b}g=v[c>>2];d=v[c+12>>2];e=v[c+8>>2];v[b+72>>2]=e;v[b+76>>2]=d;c=v[b+76>>2];v[b+24>>2]=v[b+72>>2];v[b+28>>2]=c;v[b+68>>2]=f;v[b+64>>2]=g;c=v[b+68>>2];v[b+16>>2]=v[b+64>>2];v[b+20>>2]=c;c=b;i=b;h=DP(b+16|0);if(h){v[b+48>>2]=e;v[b+52>>2]=d;d=v[b+52>>2];v[b+8>>2]=v[b+48>>2];v[b+12>>2]=d;v[b+44>>2]=f;v[b+40>>2]=g;d=v[b+44>>2];v[b>>2]=v[b+40>>2];v[b+4>>2]=d;d=AP(b)}else{d=0}v[i+56>>2]=d;v[c+60>>2]=0;c=0;d=2048;while(1){d:{e=nb[f|0](g,(b+96|0)+c|0,d)|0;c=e+c|0;if(!e){break d}d=d-e|0;if(d){continue}}break}a=rs(a,Ll(b+32|0,Eb(b+96|0),c),h?b+56|0:0);if(a+1>>>0>=3){a=ba(8)|0;v[113382]=0;b=Q(121,b+80|0,4331)|0;c=v[113382];v[113382]=0;if((c|0)!=1){nc(a,b);v[113382]=0;U(1978,a|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break a}c=P()|0;O()|0;yb(b);break b}c=P()|0;O()|0;ca(a|0);break b}jb=b+2144|0;return a|0}c=P()|0;O()|0;ca(a|0)}S(c|0)}L()}function Id(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=jb+-64|0;jb=d;v[a+480180>>2]=b;b=Yo(a);rL(d,b);e=v[d+12>>2];c=a+1074320|0;v[c>>2]=v[d+8>>2];v[c+4>>2]=e;c=v[d+4>>2];v[a+1074312>>2]=v[d>>2];v[a+1074316>>2]=c;ss(a+8|0,b);c=x[a+480192>>1];if(c){b=1;while(1){e=(((b&65535)<<2)+a|0)+900380|0;f=v[e>>2];if(f){Wb(vt(f));c=x[a+480192>>1]}v[e>>2]=0;b=b+1|0;if((b&65535)>>>0<=c>>>0){continue}break}}v[a+480184>>2]=0;v[a+480188>>2]=0;v[a+480236>>2]=65536;v[a+480228>>2]=48;v[a+480232>>2]=48;t[a+480268|0]=5;v[a+480260>>2]=16;v[a+480264>>2]=32767;v[a+480204>>2]=125e4;v[a+480208>>2]=0;v[a+480196>>2]=6;v[a+480200>>2]=256;v[a+1074304>>2]=0;v[a+1074308>>2]=0;u[a+480192>>1]=0;by(a,4);e=jb+-64|0;jb=e;b=a+484344|0;eK(b);f=mf(b);c=yx(e+8|0,b);v[113382]=0;U(1547,b|0,f|0,c|0);b=v[113382];v[113382]=0;a:{if((b|0)!=1){vl(c);jb=e- -64|0;break a}a=P()|0;O()|0;vl(c);S(a|0);L()}EN(a+484360|0);Ee(a+1304400|0);Ee(a+1304412|0);Ee(a+1304424|0);c=a+1304436|0;d=Qb(d,0,64);b=yL(d);Gb(c,b);Gb(c+12|0,b+12|0);Gb(c+24|0,b+24|0);Gb(c+36|0,b+36|0);Gb(c+48|0,b+48|0);v[c+60>>2]=v[b+60>>2];vs(b);uA(a+1304500|0);Os(a+480248|0);if(v[a+480180>>2]&738230281){v[a+480208>>2]=v[a+480208>>2]|8388608}jb=d- -64|0}function $2(a,b){a=a|0;b=+b;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;e=jb-80|0;jb=e;a:{b:{c:{if(mi(a)){Ho(e+72|0);break c}c=e+32|0;Nm(c,a);v[113382]=0;c=T(2142,c|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break b}v[e+72>>2]=c;qf(e+32|0)}if(mi(a)){c=a+36|0}else{c=v[e+72>>2]}d=v[a+8>>2];d:{if((d|0)==-1){d=Vt(c);e:{if(!Cd(c)){break e}while(1){if(!(A[Qc(c,f)>>3]+h<=b)){d=Qc(c,f);break e}h=A[d>>3]+h;f=f+1|0;if(Cd(c)>>>0>f>>>0){continue}break}}b=b-h;break d}d=Qc(c,d)}f=a+24|0;c=v[f>>2];g=x[d+12>>1];v[113382]=0;R(2145,c|0,g|0);c=v[113382];v[113382]=0;if((c|0)!=1){f:{g=v[f>>2];i=w[a+64|0];c=fI(dQ(e+32|0,b),w[d+16|0],x[d+12>>1],v[d+8>>2]);v[113382]=0;d=v[c+12>>2];v[e+16>>2]=v[c+8>>2];v[e+20>>2]=d;d=v[c+20>>2];v[e+24>>2]=v[c+16>>2];v[e+28>>2]=d;d=v[c+4>>2];v[e+8>>2]=v[c>>2];v[e+12>>2]=d;X(2098,e+56|0,g|0,(i?7:1)|0,e+8|0);c=v[113382];v[113382]=0;if((c|0)==1){break f}g=e+56|0;c=Wg(g);d=t[c+26|0]&1;i=v[(d?c+8|0:c+12|0)>>2];d=x[(d?c+20|0:c+22|0)>>1];b=A[c>>3];Il(g);u[v[f>>2]+1074438>>1]=d;u[v[f>>2]+1074440>>1]=d;v[v[f>>2]+1074428>>2]=i;v[v[f>>2]+1074392>>2]=-2;b=b+h;A[a+16>>3]=b;hk(e+72|0);jb=e+80|0;return+b}}f=P()|0;O()|0;hk(e+72|0);break a}f=P()|0;O()|0;qf(e+32|0)}S(f|0);L()}function Jba(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,x=0;h=jb-16|0;jb=h;s=h,t=B(v[a>>2],te(a)),v[s+4>>2]=t;tc(h+4|0,c>>>3|0);c=Eb(b);j=A[e+8>>3];i=v[h+4>>2];a:{if(!i){break a}e=i;while(1){k=0;f=c;m=w[f+4|0]|w[f+5|0]<<8|(w[f+6|0]<<16|w[f+7|0]<<24);g=w[f|0]|w[f+1|0]<<8|(w[f+2|0]<<16|w[f+3|0]<<24);q=g<<24|g<<8&16711680;o=k;k=m<<24|g>>>8;f=m<<8|g>>>24;o=o|0;k=k&65280|f&255|q;f=m;l(0,((f&255)<<24|g>>>8)&-16777216|((f&16777215)<<8|g>>>24)&16711680|(f>>>8&65280|f>>>24)|o);l(1,k&2147483647);j=G(+n(),j);c=c+8|0;e=e-1|0;if(e){continue}break}if(!i|j==0){break a}r=1/j;c=v[a+20>>2];while(1){e=b;a=w[e+4|0]|w[e+5|0]<<8|(w[e+6|0]<<16|w[e+7|0]<<24);g=w[e|0]|w[e+1|0]<<8|(w[e+2|0]<<16|w[e+3|0]<<24);f=g<<24;q=0;m=g<<8&16711680|f;o=a<<24|g>>>8;f=a<<8|g>>>24;e=a;l(0,((e&255)<<24|g>>>8)&-16777216|((e&16777215)<<8|g>>>24)&16711680|(e>>>8&65280|e>>>24)|q);l(1,m|(o&65280|f&255));s=h,x=+n()*r,A[s+8>>3]=x;Vf(h+8|0,-1,1);p=A[h+8>>3]*32768;A[h+8>>3]=p;a=c;p=Md(p);b:{if(D(p)<2147483648){e=~~p;break b}e=-2147483648}s=a,t=Rc(e),u[s>>1]=t;b=b+8|0;c=c+2|0;i=i-1|0;if(i){continue}break}}if(d){A[d>>3]=j}jb=h+16|0;return v[h+4>>2]<<3}function Nja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=b&63;if(Ak(c)>>>0>d>>>0){g=jR(c,d);h=jb-16|0;jb=h;c=a;t[c+12|0]=0;cR(c);f=jb-32|0;jb=f;a:{b:{d=c;if(nd(d)>>>0<15){e=zb(d);e=Qn(f+8|0,15,Kb(d),e);v[113382]=0;R(334,d|0,e|0);d=v[113382];v[113382]=0;if((d|0)==1){break b}Th(e)}jb=f+32|0;break a}a=P()|0;O()|0;Th(e);S(a|0);L()}d=w[g+1|0];c:{if(!d){break c}f=0-d|0;while(1){t[h+7|0]=64;f=(f<<16>>16)+d|0;j=Fp(h+8|0,f&65535,w[pc(((i<<1)+g|0)+2|0,h+7|0)|0]);d=c;d:{if(y[d+4>>2]<y[zb(d)>>2]){aR(d,j);break d}k=jb-32|0;jb=k;e=d;l=zb(d);d=Qn(k+8|0,ye(d,Kb(d)+1|0),Kb(d),l);m=v[d+8>>2];v[113382]=0;U(730,l|0,m|0,j|0);j=v[113382];v[113382]=0;e:{f:{if((j|0)==1){break f}v[d+8>>2]=v[d+8>>2]+4;v[113382]=0;R(334,e|0,d|0);e=v[113382];v[113382]=0;if((e|0)==1){break f}Th(d);jb=k+32|0;break e}a=P()|0;O()|0;Th(d);S(a|0);L()}}i=i+1|0;if((i|0)==15){break c}d=w[((i<<1)+g|0)+1|0];if(d){continue}break}}d=w[g+32|0];t[c+14|0]=d>>>4;t[c+13|0]=d&15;d=w[g+31|0];e=d&15;t[c+15|0]=e;t[c+16|0]=e;if(d&16){t[c+12|0]=w[c+12|0]|4}if(d&32){t[c+12|0]=w[c+12|0]|2}jb=h+16|0}g:{if(b<<24>>24>=0){c=w[a+12|0]&-2;a=a+12|0;break g}b=id(a);c=w[a+12|0]&-2|b^1;a=a+12|0}t[a|0]=c}function Yea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,w=0;e=jb-32|0;jb=e;a:{b:{c:{g=v[a+12>>2];f=v[a+8>>2];d:{if((g|0)<=1&f>>>0<=805306368|(g|0)<=0){if((g|0)>=-2&f>>>0>=3489660928|(g|0)>-2){break c}if((g|0)==-2&f>>>0>2147483647|g>>>0>4294967294){break d}break b}if((g|0)==1&f>>>0>2147483648|g>>>0>1){break b}}i=b+196648|0;break a}i=b+131112|0;break a}i=b+262184|0}j=v[a+16>>2];k=v[a+24>>2];l=v[a+20>>2];b=v[a+4>>2];h=v[a>>2];v[e+24>>2]=h;v[e+28>>2]=b;v[e+16>>2]=f;v[e+20>>2]=g;g=a;if(d){while(1){f=(((b&2147483647)<<1|h>>>31)&-2)+j|0;a=(h>>>16&65520)+i|0;m=u[a+14>>1];n=u[a+12>>1];o=u[a+10>>1];p=u[a+8>>1];q=u[a+6>>1];r=u[a+4>>1];s=u[a+2>>1];w=u[a>>1];b=0;a=1;while(1){v[(e+8|0)+(b<<2)>>2]=(((((((B(t[(b|-4)+f|0],s)+B(t[(b|-6)+f|0],w)|0)+B(t[(b|-2)+f|0],r)|0)+B(t[b+f|0],q)|0)+B(t[(b|2)+f|0],p)|0)+B(t[(b|4)+f|0],o)|0)+B(t[(b|6)+f|0],n)|0)+B(t[(b|8)+f|0],m)<<8)/32768;h=a;a=0;b=1;if(h){continue}break}v[c>>2]=v[c>>2]+B(v[e+8>>2],l);v[c+4>>2]=v[c+4>>2]+B(v[e+12>>2],k);Sb(e+24|0,e+16|0);d=d-1|0;if(d){c=c+8|0;h=v[e+24>>2];b=v[e+28>>2];continue}break}h=v[e+24>>2];b=v[e+28>>2]}v[g>>2]=h;v[g+4>>2]=b;jb=e+32|0}function K_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;a=jb-160|0;jb=a;v[a+144>>2]=c;v[a+152>>2]=b;v[a+20>>2]=2373;b=Ld(a+24|0,a+32|0,a+20|0);v[113382]=0;Ac(a+16|0,e);h=v[113382];v[113382]=0;a:{b:{c:{d:{if((h|0)!=1){v[113382]=0;h=T(21,a+16|0)|0;i=v[113382];v[113382]=0;if((i|0)==1){break b}t[a+15|0]=0;e=v[e+4>>2];v[113382]=0;c=ta(2374,a+152|0,c|0,d|0,a+16|0,e|0,f|0,a+15|0,h|0,b|0,a+20|0,a+132|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break b}if(!c){break c}Ee(g);if(!w[a+15|0]){break d}v[113382]=0;c=Q(22,h|0,45)|0;d=v[113382];v[113382]=0;if((d|0)==1){break b}v[113382]=0;R(110,g|0,c|0);c=v[113382];v[113382]=0;if((c|0)!=1){break d}break b}e=P()|0;O()|0;break a}v[113382]=0;c=Q(22,h|0,48)|0;d=v[113382];v[113382]=0;if((d|0)==1){break b}e=v[b>>2];d=v[a+20>>2];h=d-1|0;c=c&255;while(1){if(!((c|0)!=w[e|0]|e>>>0>=h>>>0)){e=e+1|0;continue}break}v[113382]=0;W(2382,g|0,e|0,d|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){break c}break b}v[113382]=0;c=Q(2313,a+152|0,a+144|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break b}if(c){v[f>>2]=v[f>>2]|2}c=v[a+152>>2];Ob(a+16|0);Gc(b);jb=a+160|0;return c|0}e=P()|0;O()|0;Ob(a+16|0)}Gc(b);S(e|0);L()}function iQ(a,b){var c=0,d=0,e=0;d=b;a:{b:{c:{d:{if(Vd(a,12755)){break d}if(Vd(a,13427)){break d}if(Vd(a,9602)){break d}if(Vd(a,9689)){break d}if(!Vd(a,10107)){break c}}v[b>>2]=8034;a=4;break b}e:{f:{if(Vd(a,13422)){break f}if(Vd(a,9607)){break f}if(!Vd(a,12745)){break e}}t[b+10|0]=1;v[b>>2]=4679;a=4;break b}g:{if(!Vd(a,10142)){if(!Vd(a,10147)){break g}}v[b>>2]=4443;a=8;break b}h:{if(!Vd(a,11356)){if(!Vd(a,11361)){break h}}v[b>>2]=13131;a=t[a+2|0]-48|0;break b}i:{if(!Vd(a,24088)){if(!Vd(a,24093)){break i}}v[b+4>>2]=1;v[b>>2]=12937;a=w[a|0]==56?8:4;break b}if(!(md(a,11724,3)|(w[a+3|0]-52&255)>>>0>4)){v[b>>2]=4797;a=t[a+3|0]-48|0;break b}j:{if(md(a,9627,3)){if(md(a,9746,3)){break j}}if((w[a+3|0]-52&255)>>>0>5){break j}t[b+13|0]=1;t[b+11|0]=1;v[b>>2]=4542;a=t[a+3|0]-48|0;break b}k:{if((w[a|0]-49&255)>>>0>8){break k}c=a;if(!md(a+1|0,9754,3)){t[b+12|0]=1;v[b>>2]=4829;a=t[a|0]-48|0;break b}e=(w[c+1|0]-48&255)>>>0>9;c=w[a+2|0]|w[a+3|0]<<8;if(e|(c|0)!=18499&(c|0)!=20035){break k}t[b+12|0]=1;v[b>>2]=4829;a=(t[a+1|0]+B(t[a|0],10)|0)-528|0;break b}c=0;if(md(a,9449,3)|(w[a+3|0]-52&255)>>>0>5){break a}v[b>>2]=4706;a=t[a+3|0]-48|0}u[d+8>>1]=a;c=1}return c}function Qia(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=jb-16|0;jb=e;sd(b,0);f=w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24);a:{if(c&34){if(d){v[b+24>>2]=f;break a}g=b,h=zk(Yg(+(f+1408|0)*.0006510416666666666)*8363),v[g+24>>2]=h;break a}t[b+37|0]=(c|0)==16?f:f^128;t[b+36|0]=w[a+4|0]}t[e+15|0]=w[a+5|0];t[e+14|0]=64;g=b,h=w[pc(e+15|0,e+14|0)|0]<<2,u[g+30>>1]=h;d=a+6|0;if((w[d|0]|w[d+1|0]<<8)>>>0<=256){u[b+28>>1]=w[d|0]|w[d+1|0]<<8;u[b+34>>1]=x[b+34>>1]|32}d=a+8|0;v[b>>2]=w[d|0]|w[d+1|0]<<8|(w[d+2|0]<<16|w[d+3|0]<<24);d=a+12|0;v[b+4>>2]=w[d|0]|w[d+1|0]<<8|(w[d+2|0]<<16|w[d+3|0]<<24);d=a+16|0;v[b+8>>2]=w[d|0]|w[d+1|0]<<8|(w[d+2|0]<<16|w[d+3|0]<<24);d=a+20|0;if(w[d|0]&16){u[b+34>>1]=x[b+34>>1]|2}if(w[d|0]&32){u[b+34>>1]=x[b+34>>1]|4}if(t[d+1|0]&1){u[b+34>>1]=x[b+34>>1]|8}if(w[d+1|0]&2){u[b+34>>1]=x[b+34>>1]|16}t[b+38|0]=w[(w[a+22|0]&7)+33104|0];t[b+39|0]=w[a+23|0];t[b+40|0]=w[a+24|0];t[b+41|0]=w[a+25|0];if((c|0)==32){t[e+13|0]=w[a+26|0];t[e+12|0]=64;g=b,h=w[pc(e+13|0,e+12|0)|0],u[g+32>>1]=h}c=a+27|0;v[b+12>>2]=w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24);a=a+31|0;v[b+16>>2]=w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24);jb=e+16|0}function vda(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=a+808|0;c=a+16|0;while(1){v[c+16>>2]=0;v[c+20>>2]=0;v[c+36>>2]=0;t[c+42|0]=1;u[c+40>>1]=257;v[c+24>>2]=0;v[c+28>>2]=0;u[c+32>>1]=0;c=c+44|0;if((d|0)!=(c|0)){continue}break}d=a+3832|0;c=a+808|0;while(1){v[c>>2]=0;v[c+4>>2]=0;v[c+68>>2]=0;v[c+72>>2]=0;v[c+24>>2]=0;v[c+28>>2]=0;u[c+20>>1]=511;v[c+16>>2]=-1;u[c+14>>1]=1;u[c+6>>1]=0;u[c+8>>1]=0;u[c+10>>1]=0;u[c+12>>1]=0;t[c+73|0]=0;t[c+74|0]=0;t[c+75|0]=0;t[c+76|0]=0;t[c+77|0]=0;t[c+78|0]=0;t[c+79|0]=0;t[c+80|0]=0;c=c+84|0;if((d|0)!=(c|0)){continue}break}c=a;v[c+3832>>2]=0;v[c+3836>>2]=0;d=c+3837|0;t[d|0]=0;t[d+1|0]=0;t[d+2|0]=0;t[d+3|0]=0;t[d+4|0]=0;t[d+5|0]=0;t[d+6|0]=0;t[d+7|0]=0;while(1){Oe((c+B(f,84)|0)+808|0,c);f=f+1|0;if((f|0)!=36){continue}break}while(1){v[(c+B(e,44)|0)+32>>2]=c;e=e+1|0;if((e|0)!=18){continue}break}e=0;while(1){d=v[(e<<2)+25600>>2];f=(c+B(e,44)|0)+16|0;a:{if(!(!(1<<e&3591)|e>>>0>11)){d=c+B(d,84)|0;sN(f,d+808|0,d+1060|0,d+1312|0,d+1564|0);break a}d=c+B(d,84)|0;sN(f,d+808|0,d+1060|0,0,0)}e=e+1|0;if((e|0)!=18){continue}break}e=0;while(1){hn((c+B(e,84)|0)+808|0);e=e+1|0;if((e|0)!=36){continue}break}rN(c,b);return a|0}function fp(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;e=jb-16|0;jb=e;d=e+8|0;f=a+1074312|0;Fb(d,f,96);d=Cb(d);v[b+660>>2]=(d?0:v[b+660>>2])+c;a:{if(!(w[b+88|0]&2)|(!(v[a+480180>>2]&18)|y[b+84>>2]>c>>>0)){break a}d=v[b+84>>2];if(!d){break a}g=c;c=v[b+80>>2];c=((g-c>>>0)%(d-c>>>0)|0)+c|0}c=c>>>(v[b+88>>2]&1&v[a+480180>>2]==16384)|0;b:{if(Wf(b+810|0)){d=v[b+656>>2];if(d){d=x[_c(d+236|0,w[b+810|0]-1|0)>>1];if(!d|d>>>0>x[a+480190>>1]){break b}}if(w[a+480210|0]&32){d=c;c=v[b+660>>2];v[b+660>>2]=d+c}v[b>>2]=0;v[b+4>>2]=c;if((!(w[b+88|0]&2)|y[b+84>>2]>c>>>0)&y[b+76>>2]>c>>>0){break b}c=e+8|0;Fb(c,f,57);if(!(!Cb(c)&v[a+480180>>2]!=16)){v[b+700>>2]=0;v[b+88>>2]=v[b+88>>2]|2097152;break b}if(!(v[a+480180>>2]&1048581)){c=e+8|0;Fb(c,f,27);if(Cb(c)){if(w[a+480208|0]&4){d=v[b+76>>2];v[b>>2]=0;v[b+4>>2]=d;break b}v[b>>2]=0;v[b+4>>2]=0;break b}d=v[b+80>>2];v[b>>2]=0;v[b+4>>2]=d;if(!(w[a+480208|0]&4)){break b}a=v[b+76>>2];if(a>>>0<5){break b}v[b>>2]=0;v[b+4>>2]=a-2;break b}if(!(w[b+88|0]&2)|v[a+480180>>2]!=1){break b}a=v[b+80>>2];v[b>>2]=0;v[b+4>>2]=a;break b}if(!(v[a+480180>>2]&268582928)|y[b+76>>2]<=c>>>0){break b}v[b>>2]=0;v[b+4>>2]=c}jb=e+16|0}function Nm(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;c=jb-80|0;jb=c;g=bx(a);e=b+24|0;a:{b:{if(Mh(v[e>>2]+484360|0)){if(Mh(v[e>>2]+484360|0)){a=0;while(1){f=v[e>>2];b=fI(eQ(c+40|0,1),a&255,0,0);v[113382]=0;d=v[b+12>>2];v[c+8>>2]=v[b+8>>2];v[c+12>>2]=d;d=v[b+20>>2];v[c+16>>2]=v[b+16>>2];v[c+20>>2]=d;d=v[b+4>>2];v[c>>2]=v[b>>2];v[c+4>>2]=d;X(2098,c- -64|0,f|0,0,c|0);b=v[113382];v[113382]=0;c:{d:{if((b|0)!=1){b=c- -64|0;i=c,j=ac(b),v[i+32>>2]=j;i=c,j=bc(b),v[i+24>>2]=j;if(Jb(c+32|0,c+24|0)){break d}break c}a=P()|0;O()|0;break b}while(1){e:{b=v[c+32>>2];f=x[b+24>>1];h=A[b>>3];d=v[b+16>>2];b=c+40|0;v[b+16>>2]=a;v[b+12>>2]=f;v[b+8>>2]=d;A[b>>3]=h;v[113382]=0;R(2099,g|0,b|0);b=v[113382];v[113382]=0;if((b|0)==1){break e}b=c+32|0;My(b);if(Jb(b,c+24|0)){continue}break c}break}a=P()|0;O()|0;Il(c- -64|0);break b}Il(c- -64|0);a=a+1|0;if(Mh(v[e>>2]+484360|0)>>>0>a>>>0){continue}break}}jb=c+80|0;return}b=ba(8)|0;v[113382]=0;c=Q(121,c+40|0,3534)|0;a=v[113382];v[113382]=0;if((a|0)!=1){nc(b,c);v[113382]=0;U(1978,b|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break a}a=P()|0;O()|0;yb(c);break b}a=P()|0;O()|0;ca(b|0)}qf(g);S(a|0)}L()}function J4(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;a:{c=u[b>>1];b=jb-32|0;jb=b;v[113382]=0;g=Q(15,b+24|0,a|0)|0;d=v[113382];v[113382]=0;b:{c:{d:{if((d|0)!=1){e:{if(!w[g|0]){break e}d=v[v[a>>2]-12>>2];i=v[(d+a|0)+4>>2];v[113382]=0;Ac(b+16|0,a+d|0);d=v[113382];v[113382]=0;f:{g:{h:{if((d|0)!=1){v[113382]=0;d=T(2723,b+16|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break h}Ob(b+16|0);e=Tk(b+8|0,a);f=v[v[a>>2]-12>>2];v[113382]=0;f=a+f|0;j=T(16,f|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break g}e=v[e>>2];v[113382]=0;k=d;d=c&65535;h=c;c=i&74;c=ea(2724,k|0,e|0,f|0,j|0,((c|0)==64?d:(c|0)==8?d:h)|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break g}v[b+16>>2]=c;if(!Rk(b+16|0)){break e}c=v[v[a>>2]-12>>2];v[113382]=0;R(18,a+c|0,5);c=v[113382];v[113382]=0;if((c|0)!=1){break e}c=V(0)|0;O()|0;break f}c=V(0)|0;O()|0;break f}c=V(0)|0;O()|0;Ob(b+16|0);break f}c=V(0)|0;O()|0}Kf(g);break d}Kf(g);break c}c=V(0)|0;O()|0}_(c|0)|0;c=v[v[a>>2]-12>>2];v[113382]=0;Z(19,a+c|0);a=v[113382];v[113382]=0;if((a|0)==1){break b}$()}jb=b+32|0;break a}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}}function UF(a,b){var c=0,d=0,e=0,f=0,g=0;a:{b:{c:{c=v[a+4>>2];d:{if(c>>>0<y[a+104>>2]){v[a+4>>2]=c+1;c=w[c|0];break d}c=Xc(a)}switch(c-43|0){case 0:case 2:break b;default:break c}}b=c-48|0;break a}f=(c|0)==45;g=!b;b=v[a+4>>2];e:{if(b>>>0<y[a+104>>2]){v[a+4>>2]=b+1;c=w[b|0];break e}c=Xc(a)}b=c-48|0;if(!(g|b>>>0<10|!v[a+104>>2])){v[a+4>>2]=v[a+4>>2]-1}}f:{if(b>>>0<10){while(1){d=(B(d,10)+c|0)-48|0;e=(d|0)<214748364;b=v[a+4>>2];g:{if(b>>>0<y[a+104>>2]){v[a+4>>2]=b+1;c=w[b|0];break g}c=Xc(a)}b=c-48|0;if(e&b>>>0<=9){continue}break}e=d;d=d>>31;h:{if(b>>>0>=10){break h}while(1){e=qma(e,d,10,0);c=e+c|0;b=mb;b=c>>>0<e>>>0?b+1|0:b;e=c-48|0;d=b-(c>>>0<48)|0;b=v[a+4>>2];i:{if(b>>>0<y[a+104>>2]){v[a+4>>2]=b+1;c=w[b|0];break i}c=Xc(a)}b=c-48|0;if(b>>>0>9){break h}if(e>>>0<2061584302&(d|0)<=21474836|(d|0)<21474836){continue}break}}if(b>>>0<10){while(1){b=v[a+4>>2];j:{if(b>>>0<y[a+104>>2]){v[a+4>>2]=b+1;b=w[b|0];break j}b=Xc(a)}if(b-48>>>0<10){continue}break}}if(v[a+104>>2]){v[a+4>>2]=v[a+4>>2]-1}a=e;e=f?0-a|0:a;d=f?0-(((a|0)!=0)+d|0)|0:d;break f}d=-2147483648;if(!v[a+104>>2]){break f}v[a+4>>2]=v[a+4>>2]-1;mb=-2147483648;return 0}mb=d;return e}function uha(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;if(v[a+4>>2]!=v[zb(a)>>2]){h=jb-16|0;jb=h;c=h;v[c>>2]=a;d=v[a+4>>2];v[c+4>>2]=d;v[c+8>>2]=d+56;a=zb(a);d=v[c+4>>2];v[113382]=0;U(940,a|0,d|0,b|0);a=v[113382];v[113382]=0;a:{if((a|0)!=1){v[c+4>>2]=v[c+4>>2]+56;Mb(c);jb=h+16|0;break a}a=P()|0;O()|0;Mb(c);S(a|0);L()}return}i=jb-32|0;jb=i;h=a;j=zb(a);e=i+8|0;c=wk(a)+1|0;f=jb-16|0;jb=f;v[f+12>>2]=c;d=c;c=jb-16|0;jb=c;g=a;zb(a);v[c+12>>2]=76695844;v[113382]=0;v[c+8>>2]=2147483647;k=Q(33,c+12|0,c+8|0)|0;l=v[113382];v[113382]=0;b:{if((l|0)!=1){jb=c+16|0;c=v[k>>2];break b}V(0)|0;O()|0;Ab();L()}c:{if(c>>>0>=d>>>0){d=pn(g);if(d>>>0<c>>>1>>>0){v[f+8>>2]=d<<1;c=v[Vc(f+8|0,f+12|0)>>2]}jb=f+16|0;break c}ld();L()}g=wk(a);a=0;d=jb-16|0;jb=d;v[d+12>>2]=0;Le(e+12|0,j);if(c){a=_O(c)}v[e>>2]=a;g=B(g,56)+a|0;v[e+8>>2]=g;v[e+4>>2]=g;m=gc(e),n=B(c,56)+a|0,v[m>>2]=n;jb=d+16|0;a=v[e+8>>2];v[113382]=0;U(940,j|0,a|0,b|0);a=v[113382];v[113382]=0;d:{e:{if((a|0)==1){break e}v[e+8>>2]=v[e+8>>2]+56;v[113382]=0;R(941,h|0,e|0);a=v[113382];v[113382]=0;if((a|0)==1){break e}eP(e);jb=i+32|0;break d}a=P()|0;O()|0;eP(e);S(a|0);L()}}function EW(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0;if(rg(a,v[b+8>>2],e)){rv(b,c,d);return}a:{if(rg(a,v[b>>2],e)){if(!(v[b+16>>2]!=(c|0)&v[b+20>>2]!=(c|0))){if((d|0)!=1){break a}v[b+32>>2]=1;return}v[b+32>>2]=d;if(v[b+44>>2]!=4){f=a+16|0;i=f+(v[a+12>>2]<<3)|0;j=b;b:{c:{while(1){d:{if(f>>>0>=i>>>0){break d}u[b+52>>1]=0;qv(f,b,c,c,1,e);if(w[b+54|0]){break d}e:{if(!w[b+53|0]){break e}if(w[b+52|0]){d=1;if(v[b+24>>2]==1){break c}h=1;g=1;if(w[a+8|0]&2){break e}break c}h=1;d=g;if(!(t[a+8|0]&1)){break c}}f=f+8|0;continue}break}d=g;a=4;if(!h){break b}}a=3}v[j+44>>2]=a;if(d&1){break a}}v[b+20>>2]=c;v[b+40>>2]=v[b+40>>2]+1;if(v[b+36>>2]!=1|v[b+24>>2]!=2){break a}t[b+54|0]=1;return}g=v[a+12>>2];f=a+16|0;Rq(f,b,c,d,e);if((g|0)<2){break a}g=f+(g<<3)|0;f=a+24|0;a=v[a+8>>2];if(!(!(a&2)&v[b+36>>2]!=1)){while(1){if(w[b+54|0]){break a}Rq(f,b,c,d,e);f=f+8|0;if(g>>>0>f>>>0){continue}break}break a}if(!(a&1)){while(1){if(w[b+54|0]|v[b+36>>2]==1){break a}Rq(f,b,c,d,e);f=f+8|0;if(g>>>0>f>>>0){continue}break a}}while(1){if(w[b+54|0]|v[b+36>>2]==1&v[b+24>>2]==1){break a}Rq(f,b,c,d,e);f=f+8|0;if(g>>>0>f>>>0){continue}break}}}function eZ(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0;j=jb-16|0;jb=j;i=c;while(1){a:{if((d|0)==(i|0)){i=d;break a}if(!w[i|0]){break a}i=i+1|0;continue}break}v[h>>2]=f;v[e>>2]=c;while(1){b:{c:{d:{if((c|0)==(d|0)|(f|0)==(g|0)){break d}l=v[b+4>>2];v[j+8>>2]=v[b>>2];v[j+12>>2]=l;k=jb-16|0;jb=k;v[k+12>>2]=v[a+8>>2];m=Bh(k+8|0,k+12|0);v[113382]=0;l=KF(f,e,i-c|0,g-f>>2,b);n=v[113382];v[113382]=0;e:{if((n|0)!=1){Ge(m);jb=k+16|0;break e}a=P()|0;O()|0;Ge(m);S(a|0);L()}f:{g:{h:{i:{if((l|0)==-1){while(1){j:{v[h>>2]=f;if(v[e>>2]==(c|0)){break j}g=1;k:{l:{m:{b=DE(f,c,i-c|0,j+8|0,v[a+8>>2]);switch(b+2|0){case 2:break k;case 1:break m;case 0:break g;default:break l}}v[e>>2]=c;break i}g=b}c=c+g|0;f=v[h>>2]+4|0;continue}break}v[e>>2]=c;break d}f=v[h>>2]+(l<<2)|0;v[h>>2]=f;if((f|0)==(g|0)){break f}c=v[e>>2];if((d|0)==(i|0)){i=d;continue}if(!DE(f,c,1,b,v[a+8>>2])){break h}}a=2;break c}v[h>>2]=v[h>>2]+4;c=v[e>>2]+1|0;v[e>>2]=c;i=c;while(1){if((d|0)==(i|0)){i=d;break b}if(!w[i|0]){break b}i=i+1|0;continue}}v[e>>2]=c;a=1;break c}c=v[e>>2]}a=(c|0)!=(d|0)}jb=j+16|0;return a|0}f=v[h>>2];continue}}function sH(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=C(0);e=jb-48|0;jb=e;v[e+40>>2]=c;v[e+44>>2]=b;v[e+36>>2]=d;b=v[a+8>>2];v[e+28>>2]=e+36;v[e+24>>2]=e+40;c=v[e+28>>2];v[e+8>>2]=v[e+24>>2];v[e+12>>2]=c;v[e+16>>2]=a;v[e+20>>2]=e+44;c=v[e+20>>2];v[e>>2]=v[e+16>>2];v[e+4>>2]=c;c=e;a:{b:{switch(v[b+40>>2]){case 0:Jr(c,b);break a;case 2:Jr(c,zb(b));break a;case 3:i=Xg(b);b=jb-80|0;jb=b;d=v[c>>2];g=v[d+4>>2];f=v[d+24>>2];v[b+40>>2]=v[d+20>>2];v[b+44>>2]=f;f=v[d+16>>2];v[b+32>>2]=v[d+12>>2];v[b+36>>2]=f;Fh(b- -64|0,b+32|0,g);d=ie(b+48|0,v[v[c+4>>2]>>2],v[v[c+8>>2]>>2],v[v[c+12>>2]>>2]);g=v[v[c+12>>2]>>2];f=v[v[c+8>>2]>>2];c=v[b+76>>2];v[b+24>>2]=v[b+72>>2];v[b+28>>2]=c;c=v[b+68>>2];v[b+16>>2]=v[b+64>>2];v[b+20>>2]=c;v[b+8>>2]=v[d+8>>2];c=v[d+4>>2];v[b>>2]=v[d>>2];v[b+4>>2]=c;j=b+16|0;c=b;if(g){while(1){d=0;if(f){while(1){k=v[Sf(c,d,h)>>2];Xe(i,d);l=nn(j,d,h),m=C(C(k|0)*C(7.450580596923828e-9)),z[l>>2]=m;d=d+1|0;if((f|0)!=(d|0)){continue}break}}h=h+1|0;if((g|0)!=(h|0)){continue}break}}jb=b+80|0;break a;case 1:Jr(c,zb(b));break a;default:break b}}Jr(c,zb(b))}v[a+4>>2]=v[a+4>>2]+v[e+36>>2];jb=e+48|0}function J8(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=of(a);if(c>>>0<b>>>0){f=jb-32|0;jb=f;a:{b:{e=b-c|0;c:{if(e>>>0<=v[zb(a)>>2]-v[a+4>>2]>>11>>>0){c=jb-16|0;jb=c;g=a;b=c;v[b>>2]=a;a=v[a+4>>2];v[b+4>>2]=a;v[b+8>>2]=a+(e<<11);d:{a=v[b+4>>2];d=v[b+8>>2];if((a|0)!=(d|0)){while(1){e=zb(g);v[113382]=0;R(1620,e|0,a|0);e=v[113382];v[113382]=0;if((e|0)==1){break d}a=a+2048|0;v[b+4>>2]=a;if((a|0)!=(d|0)){continue}break}}Mb(b);jb=c+16|0;break c}a=P()|0;O()|0;Mb(b);S(a|0);L()}h=zb(a);i=f+8|0;b=of(a)+e|0;d=jb-16|0;jb=d;v[d+12>>2]=b;c=b;b=jb-16|0;jb=b;g=a;zb(a);v[b+12>>2]=2097151;v[113382]=0;v[b+8>>2]=2147483647;j=Q(33,b+12|0,b+8|0)|0;k=v[113382];v[113382]=0;e:{if((k|0)!=1){jb=b+16|0;b=v[j>>2];break e}V(0)|0;O()|0;Ab();L()}f:{if(b>>>0>=c>>>0){c=jk(g);if(c>>>0<b>>>1>>>0){v[d+8>>2]=c<<1;b=v[Vc(d+8|0,d+12|0)>>2]}jb=d+16|0;break f}ld();L()}b=wJ(i,b,of(a),h);v[113382]=0;R(1618,b|0,e|0);c=v[113382];v[113382]=0;if((c|0)==1){break b}v[113382]=0;R(1614,a|0,b|0);a=v[113382];v[113382]=0;if((a|0)==1){break b}fs(b)}jb=f+32|0;break a}a=P()|0;O()|0;fs(b);S(a|0);L()}return}if(b>>>0<c>>>0){b=v[a>>2]+(b<<11)|0;of(a);uJ(a,b);xJ(a)}}function nea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=jb-48|0;jb=e;l=v[a+16>>2];f=Uf(e+16|0);v[f+8>>2]=a+112;v[f+16>>2]=v[a+128>>2];m=f,n=Pf(b+327720|0,v[b+20>>2],(v[a+88>>2]&16384)>>>14|0),v[m+12>>2]=n;b=v[f+16>>2];if(b){m=f,n=Tf(a+8|0,b),v[m>>2]=n;v[f+4>>2]=mb}i=v[a+40>>2];j=v[a+36>>2];b=v[a+4>>2];h=v[a>>2];v[e+8>>2]=h;v[e+12>>2]=b;g=v[a+12>>2];v[e>>2]=v[a+8>>2];v[e+4>>2]=g;a:{if(d){while(1){k=0;g=k;v[e+40>>2]=h;v[e+44>>2]=g;h=(b<<1)+l|0;b:{b=v[f+16>>2];if((b|0)<=0){break b}while(1){yd(v[f+8>>2],u[(g<<1)+h>>1]/4<<16>>16);xd(v[f+8>>2],4);Sb(e+40|0,f);if((b|0)<2){break b}b=b-1|0;g=v[e+44>>2];continue}}d=d-1|0;b=v[f+8>>2];Sb(b,b+8|0);b=v[f+8>>2];g=v[b+4>>2];if(g){yd(b,u[h+(v[e+44>>2]<<1)>>1]/4<<16>>16);xd(v[f+8>>2],g);b=v[f+8>>2];g=v[b>>2];v[b>>2]=g;v[b+4>>2]=0}b=Of(b,v[f+12>>2]);h=v[a+32>>2];j=v[a+28>>2]+j|0;g=j>>12;v[c>>2]=v[c>>2]+B(b,g);i=h+i|0;k=i>>12;v[c+4>>2]=v[c+4>>2]+B(b,k);Sb(e+8|0,e);if(d){c=c+8|0;h=v[e+8>>2];b=v[e+12>>2];continue}break}h=v[e+8>>2];b=v[e+12>>2];break a}k=i>>12;g=j>>12}v[a+40>>2]=i;v[a+20>>2]=g;v[a+36>>2]=j;v[a+24>>2]=k;v[a>>2]=h;v[a+4>>2]=b;jb=e+48|0}function n8(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;h=jb-16|0;jb=h;if(!w[a+4242|0]){px(a);a:{if(!w[a+4240|0]){break a}e=mL(v[a+16>>2]);if(e==A[a+4288>>3]){break a}A[a+4288>>3]=e;cs(a)}g=a+4256|0;b:{if(w[a+4244|0]){if(!(A[g>>3]<=1)){A[g>>3]=1}break b}i=(v[a+4232>>2]&-2)!=4;e=A[g>>3];c:{if(D(e)<2147483648){f=~~e;break c}f=-2147483648}if(!(i|(f|0)<=0)){ox(a);e=A[a+4256>>3]}A[g>>3]=e-+(f|0)}e=0;d:{e:{switch(v[a+4232>>2]){case 0:e=gi(A[a+4256>>3]*6.283185307179586);break d;case 1:e=D(A[a+4256>>3]+-.5)*-4+1;break d;case 2:e=A[a+4256>>3];e=e+e+-1;break d;case 3:e=A[a+4256>>3]<.5?-1:1;break d;case 4:e=A[a+4272>>3];break d;case 5:break e;default:break d}}e=A[a+4256>>3];j=e*e*e*((e*6+-15)*e+10);e=A[a+4272>>3];e=j*(A[a+4280>>3]-e)+e}A[h+8>>3]=(w[a+4241|0]?-e:e)*+z[a+4220>>2]+ +z[a+4224>>2];Vf(h+8|0,0,1);f=kj(a);f:{if(!f){break f}g=v[a+4236>>2];if(w[a+4243|0]){l=f,m=g>>>8&15|176|(g&127)<<8|tt(A[h+8>>3]*127)<<16,k=v[v[f>>2]+68>>2],nb[k](l|0,m|0)|0;break f}nb[v[v[f>>2]+44>>2]](f,g,C(A[h+8>>3]))}A[a+4256>>3]=A[a+4256>>3]+A[a+4264>>3]*+(d>>>0)}f=a;a=a+44|0;pi(f,b,c,Jd(a,0),Jd(a,1),d);jb=h+16|0}function _k(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;f=jb-16|0;jb=f;v[a+4>>2]=0;if(w[cj(f+8|0,a,1)|0]){a:{b:{c:{if((b|0)==2147483647){while(1){b=v[v[a>>2]-12>>2];v[113382]=0;b=v[(a+b|0)+24>>2];d=v[113382];v[113382]=0;if((d|0)==1){break c}v[113382]=0;b=T(2715,b|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break c}if(se(b,-1)){break b}v[a+4>>2]=v[a+4>>2]+1;if(!se(b,c)){continue}break}d=0;break a}if(v[a+4>>2]>=(b|0)){break a}while(1){d:{d=v[v[a>>2]-12>>2];v[113382]=0;d=v[(a+d|0)+24>>2];e=v[113382];v[113382]=0;if((e|0)==1){break d}v[113382]=0;e=T(2715,d|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break d}if(se(e,-1)){break b}v[a+4>>2]=v[a+4>>2]+1;d=0;if(se(e,c)){break a}if(v[a+4>>2]<(b|0)){continue}break a}break}}b=V(0)|0;O()|0;_(b|0)|0;bj(v[v[a>>2]-12>>2]+a|0,1);b=v[v[a>>2]-12>>2];v[113382]=0;b=v[(a+b|0)+20>>2];c=v[113382];v[113382]=0;e:{f:{g:{if((c|0)!=1){if(!(b&1)){break g}v[113382]=0;Y(81);a=v[113382];v[113382]=0;if((a|0)!=1){break e}}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)==1){break f}S(a|0);L()}$();d=1;break a}V(0)|0;O()|0;Ab()}L()}d=2}Eg(v[v[a>>2]-12>>2]+a|0,d)}jb=f+16|0;return a|0}function qea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=jb-48|0;jb=e;j=v[a+16>>2];f=Uf(e+16|0);v[f+8>>2]=a+112;v[f+16>>2]=v[a+128>>2];n=f,o=Pf(b+327720|0,v[b+20>>2],(v[a+88>>2]&16384)>>>14|0),v[n+12>>2]=o;b=v[f+16>>2];if(b){n=f,o=Tf(a+8|0,b),v[n>>2]=o;v[f+4>>2]=mb}k=v[a+24>>2];l=v[a+20>>2];b=v[a+4>>2];g=v[a>>2];v[e+8>>2]=g;v[e+12>>2]=b;h=v[a+12>>2];v[e>>2]=v[a+8>>2];v[e+4>>2]=h;if(d){while(1){h=0;i=g;v[e+40>>2]=g;v[e+44>>2]=m;g=(((b&2147483647)<<1|g>>>31)&-2)+j|0;a:{b=v[f+16>>2];if((b|0)<=0){break a}while(1){h=(h&2147483647)<<1|i>>>31;yd(v[f+8>>2],t[(h|1)+g|0]+t[g+(h&-2)|0]<<5);xd(v[f+8>>2],4);Sb(e+40|0,f);if((b|0)<2){break a}b=b-1|0;i=v[e+40>>2];h=v[e+44>>2];continue}}d=d-1|0;b=v[f+8>>2];Sb(b,b+8|0);b=v[f+8>>2];h=v[b+4>>2];if(h){i=b;b=(v[e+44>>2]&2147483647)<<1|v[e+40>>2]>>>31;yd(i,t[(b|1)+g|0]+t[g+(b&-2)|0]<<5);xd(v[f+8>>2],h);b=v[f+8>>2];h=v[b>>2];v[b>>2]=h;v[b+4>>2]=0}b=Of(b,v[f+12>>2]);v[c>>2]=v[c>>2]+B(b,l);v[c+4>>2]=v[c+4>>2]+B(b,k);Sb(e+8|0,e);if(d){c=c+8|0;g=v[e+8>>2];b=v[e+12>>2];continue}break}g=v[e+8>>2];b=v[e+12>>2]}v[a>>2]=g;v[a+4>>2]=b;jb=e+48|0}function sfa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,w=0,x=0;i=jb-16|0;jb=i;e=v[a+48>>2];l=v[a+40>>2];m=v[a+36>>2];b=v[a+44>>2];p=v[a+16>>2];f=v[a+4>>2];j=v[a>>2];v[i+8>>2]=j;v[i+12>>2]=f;h=v[a+12>>2];v[i>>2]=v[a+8>>2];v[i+4>>2]=h;a:{if(d){while(1){h=f+p|0;n=t[h+1|0];f=t[h|0];h=v[a+60>>2];q=h;r=h>>31;g=Yb(b,-16777216,16776704);k=v[a+64>>2];e=Yb(e,-16777216,16776704);s=v[a+72>>2];u=v[a+32>>2];h=c;w=v[h>>2];g=qma(k,k>>31,g,g>>31);k=mb;x=g;g=v[a+68>>2];o=qma(g,g>>31,e,e>>31);g=x+o|0;e=mb+k|0;e=g>>>0<o>>>0?e+1|0:e;k=g;j=((B(n-f|0,j>>>10&4194048)|0)/16384|0)+(f<<8)<<8;f=j;g=qma(q,r,f,f>>31);f=k+g|0;e=mb+e|0;e=f>>>0<g>>>0?e+1|0:e;f=f+8388608|0;e=f>>>0<8388608?e+1|0:e;f=(e&16777215)<<8|f>>>24;e=(f|0)/256|0;m=v[a+28>>2]+m|0;g=m>>12;v[h>>2]=B(e,g)+w;l=l+u|0;n=l>>12;v[h+4>>2]=v[h+4>>2]+B(e,n);h=f-(j&s)|0;Sb(i+8|0,i);d=d-1|0;if(d){c=c+8|0;j=v[i+8>>2];f=v[i+12>>2];e=b;b=h;continue}break}j=v[i+8>>2];f=v[i+12>>2];e=b;break a}n=l>>12;g=m>>12;h=b}v[a+40>>2]=l;v[a+20>>2]=g;v[a+36>>2]=m;v[a+48>>2]=e;v[a+44>>2]=h;v[a+24>>2]=n;v[a>>2]=j;v[a+4>>2]=f;jb=i+16|0}function Sba(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;f=jb-16|0;jb=f;v[f+8>>2]=c>>>4;v[f+4>>2]=v[a>>2];d=v[Lb(f+8|0,f+4|0)>>2];b=Eb(b);if(d){a=v[a+20>>2];c=d;while(1){e=b;g=w[e+4|0]|w[e+5|0]<<8|(w[e+6|0]<<16|w[e+7|0]<<24);h=w[e|0]|w[e+1|0]<<8|(w[e+2|0]<<16|w[e+3|0]<<24);e=g;j=h<<8&16711680|h<<24;k=e<<24|h>>>8;g=e<<8|h>>>24;j=k&65280|g&255|j;v[f+8>>2]=((e&255)<<24|h>>>8)&-16777216|((e&16777215)<<8|h>>>24)&16711680|(e>>>8&65280|e>>>24)|l;v[f+12>>2]=j;Vf(f+8|0,-1,1);i=A[f+8>>3]*32768;A[f+8>>3]=i;e=a;i=Md(i);a:{if(D(i)<2147483648){g=~~i;break a}g=-2147483648}m=e,n=Rc(g),u[m>>1]=n;e=b;g=w[e+12|0]|w[e+13|0]<<8|(w[e+14|0]<<16|w[e+15|0]<<24);h=w[e+8|0]|w[e+9|0]<<8|(w[e+10|0]<<16|w[e+11|0]<<24);e=g;j=h<<8&16711680|h<<24;k=e<<24|h>>>8;g=e<<8|h>>>24;j=k&65280|g&255|j;v[f+8>>2]=((e&255)<<24|h>>>8)&-16777216|((e&16777215)<<8|h>>>24)&16711680|(e>>>8&65280|e>>>24)|l;v[f+12>>2]=j;Vf(f+8|0,-1,1);i=A[f+8>>3]*32768;A[f+8>>3]=i;e=a;i=Md(i);b:{if(D(i)<2147483648){g=~~i;break b}g=-2147483648}m=e,n=Rc(g),u[m+2>>1]=n;a=a+4|0;b=b+16|0;c=c-1|0;if(c){continue}break}}jb=f+16|0;return d<<4}function Oo(a){a=a|0;var b=0,c=0,d=0,e=0,f=C(0),g=0,h=C(0),i=0,j=0,k=0,l=C(0);c=v[a+36>>2];if(!c){ti(a+16|0);return}a:{b:{c:{switch(x[a>>1]){case 3:d=a+16|0;if(c>>>0>=1001){ti(d);return}ql(d,c);c=x[a+28>>1];b=a+4|0;Kb(b);f=rl(a,(c<<16)+65536>>16);c=u[a+28>>1];Kb(b);b=1;f=je(C(f/rl(a,c)),C(C(1)/C(v[a+36>>2]+1>>>0)));if(!v[a+36>>2]){break b}while(1){h=je(f,C(b>>>0));k=Pb(d,b-1|0),l=h,z[k>>2]=l;b=b+1|0;if(b>>>0<=y[a+36>>2]){continue}break};break b;case 1:d=a+16|0;g=x[a+30>>1];if(g>>>0>1e3/(c>>>0)>>>0){ti(d);return}ql(d,B(c,g));c=u[a+28>>1];Kb(a+4|0);b=x[a+30>>1];if((c|0)>=0){c=(c|0)%(b|0)|0}else{c=((c^-1)%(b|0)^-1)+b|0}if(!g){break b}while(1){b=b&65535;e=c+i<<16>>16;d:{if((e|0)>=0){b=(e|0)%(b|0)|0;break d}b=b+((e^-1)%(b|0)^-1)|0}e=1;b=b<<16;j=b>>16;f=je(C(rl(a,b+65536>>16)/rl(a,j)),C(C(1)/C(v[a+36>>2]+1>>>0)));b=1;if(v[a+36>>2]){while(1){h=je(f,C((b&65535)>>>0));k=Pb(d,(B(v[a+36>>2],j)+e|0)-1|0),l=h,z[k>>2]=l;b=b+1|0;e=b&65535;if(e>>>0<=y[a+36>>2]){continue}break}}i=i+1|0;if(g>>>0<=(i&65535)>>>0){break b}b=x[a+30>>1];continue};case 0:break a;default:break c}}ti(a+16|0);v[a+36>>2]=0}return}ti(a+16|0)}function rfa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0;i=jb-16|0;jb=i;e=v[a+48>>2];l=v[a+40>>2];m=v[a+36>>2];b=v[a+44>>2];p=v[a+16>>2];f=v[a+4>>2];j=v[a>>2];v[i+8>>2]=j;v[i+12>>2]=f;h=v[a+12>>2];v[i>>2]=v[a+8>>2];v[i+4>>2]=h;a:{if(d){while(1){h=(f<<1)+p|0;n=u[h+2>>1];f=u[h>>1];h=v[a+60>>2];q=h;r=h>>31;g=Yb(b,-16777216,16776704);k=v[a+64>>2];e=Yb(e,-16777216,16776704);s=v[a+72>>2];t=v[a+32>>2];h=c;w=v[h>>2];g=qma(k,k>>31,g,g>>31);k=mb;x=g;g=v[a+68>>2];o=qma(g,g>>31,e,e>>31);g=x+o|0;e=mb+k|0;e=g>>>0<o>>>0?e+1|0:e;k=g;j=f+((B(n-f|0,j>>>18|0)|0)/16384|0)<<8;f=j;g=qma(q,r,f,f>>31);f=k+g|0;e=mb+e|0;e=f>>>0<g>>>0?e+1|0:e;f=f+8388608|0;e=f>>>0<8388608?e+1|0:e;f=(e&16777215)<<8|f>>>24;e=(f|0)/256|0;m=v[a+28>>2]+m|0;g=m>>12;v[h>>2]=B(e,g)+w;l=l+t|0;n=l>>12;v[h+4>>2]=v[h+4>>2]+B(e,n);h=f-(j&s)|0;Sb(i+8|0,i);d=d-1|0;if(d){c=c+8|0;j=v[i+8>>2];f=v[i+12>>2];e=b;b=h;continue}break}j=v[i+8>>2];f=v[i+12>>2];e=b;break a}n=l>>12;g=m>>12;h=b}v[a+40>>2]=l;v[a+20>>2]=g;v[a+36>>2]=m;v[a+48>>2]=e;v[a+44>>2]=h;v[a+24>>2]=n;v[a>>2]=j;v[a+4>>2]=f;jb=i+16|0}function y7(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=C(0),f=0,g=C(0),h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=C(0),r=0,s=0,t=0,u=C(0);a:{if(!v[a+4272>>2]){break a}i=a+44|0;if(!vh(i)){break a}k=Jd(i,0);l=Jd(i,1);m=ed(i,0);n=ed(i,1);if(d){j=a+4256|0;f=v[a+4268>>2];o=d;while(1){e=z[l>>2];g=z[k>>2];t=Pb(j,f<<1),u=g,z[t>>2]=u;t=Pb(j,v[a+4268>>2]<<1|1),u=e,z[t>>2]=u;e=C(D(SI(C(C(C(D(g))+C(D(e)))*C(536870912)),31,5)));g=z[a+4276>>2];e=C(e*C(4.656612873077393e-10));e=C(C(z[(g>e?4240:4236)+a>>2]*C(g-e))+e);z[a+4276>>2]=e;p=m;q=C(z[a+4232>>2]*C(4.656612873077393e-10));g=z[a+4244>>2];e=C(C(C(z[a+4248>>2]*C(2147483648))*C(g-C(G(e,g))))+C(2147483392));b:{if(e<C(4294967296)&e>=C(0)){f=~~e>>>0;break b}f=0}h=f<<5;r=h;s=h|-2147483648;h=f>>>0<67108864;e=C(q*C((h?r:s)>>>(h?31:32-(f>>>26|0)|0)>>>0));f=v[a+4272>>2];f=(((f+(v[a+4252>>2]+(v[a+4268>>2]<<12)|0)|0)-1|0)/4096|0)%(f|0)<<1;t=p,u=C(e*z[Pb(j,f)>>2]),z[t>>2]=u;t=n,u=C(e*z[Pb(j,f|1)>>2]),z[t>>2]=u;h=v[a+4268>>2];f=h-1|0;v[a+4268>>2]=f;if(!h){f=v[a+4272>>2]+f|0;v[a+4268>>2]=f}n=n+4|0;m=m+4|0;l=l+4|0;k=k+4|0;o=o-1|0;if(o){continue}break}}pi(a,b,c,ed(i,0),ed(i,1),d)}}function Sha(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=jb+-64|0;jb=e;o=e,p=$e(a)>>>5|0,u[o+32>>1]=p;u[e+16>>1]=3999;o=c,p=x[Af(e+32|0,e+16|0)>>1],u[o+480190>>1]=p;lz(b,x[c+480190>>1],0);a:{if(x[c+480190>>1]){h=e+62|0;k=e+58|0;l=e+56|0;n=e+52|0;m=e+60|0;i=1;j=1;while(1){f=yp(c,j&65535);d=e+32|0;kt(a,d);sd(f,0);Dn(e,2,d);d=e+16|0;Ec(d,e);v[113382]=0;Q(335,((i<<5)+c|0)+946304|0,d|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break a}d=e+16|0;yb(d);u[f+32>>1]=64;v[f+24>>2]=8287;g=w[m|0]|w[m+1|0]<<8;u[e+16>>1]=g<<8|g>>>8;u[e>>1]=64;o=f,p=x[Af(d,e)>>1]<<2,u[o+30>>1]=p;d=n;d=(w[d|0]|w[d+1|0]<<8|(w[d+2|0]<<16|w[d+3|0]<<24))&-16777217;v[f>>2]=d<<24|d<<8&16711680|(d>>>8&65280|d>>>24);d=w[l|0]|w[l+1|0]<<8;g=w[k|0]|w[k+1|0]<<8;g=(g<<8|g>>>8)&65535;b:{if(g>>>0<2){break b}d=(d<<8|d>>>8)&65535;g=d+g<<1;if(g>>>0>y[f>>2]){break b}v[f+16>>2]=g;v[f+12>>2]=d<<1;u[f+34>>1]=x[f+34>>1]|8}d=w[h|0]|w[h+1|0]<<8?(w[h|0]|w[h+1|0]<<8)==512:1;f=e+16|0;_d(f,b,i-1|0);ce(f,d);j=j+1|0;i=j&65535;if(i>>>0<=x[c+480190>>1]){continue}break}}jb=e- -64|0;return}a=P()|0;O()|0;yb(e+16|0);S(a|0);L()}function Vaa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;g=jb+-64|0;jb=g;e=g;h=e+16|0;while(1){l=(i<<2)+h|0;f=0;c=0;j=jb-16|0;jb=j;d=b;Oc(j+8|0,d);a:{b:{c:{d:{e:{if(qd(d+16|0)){while(1){f:{k=v[d+16>>2];v[113382]=0;k=T(98,k|0)|0;m=v[113382];v[113382]=0;if((m|0)==1){break f}f=f|k;c=c+32|0;if(c>>>0<32){continue}break e}break}c=V(66716)|0;if((O()|0)!=(ga(66716)|0)){break b}_(c|0)|0;t[d+20|0]=0;v[113382]=0;Z(82,d|0);c=v[113382];v[113382]=0;if((c|0)==1){break d}v[113382]=0;Y(20);c=v[113382];v[113382]=0;if((c|0)!=1){break e}c=P()|0;O()|0;break b}t[d+20|0]=0}if(!w[d+20|0]){d=v[d+24>>2];v[113382]=0;d=T(99,d|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break c}f=d^f}jb=j+16|0;break a}c=P()|0;O()|0;v[113382]=0;Y(20);a=v[113382];v[113382]=0;if((a|0)!=1){break b}V(0)|0;O()|0;Ab();L()}c=P()|0;O()|0}S(c|0);L()}v[l>>2]=f;i=i+1|0;if((i|0)!=12){continue}break}b=en(e);v[113382]=0;U(109,e|0,h|0,h+48|0);d=v[113382];v[113382]=0;g:{if((d|0)==1){break g}v[113382]=0;b=e;W(106,a|0,e|0,0)|0;a=v[113382];v[113382]=0;h:{if((a|0)!=1){ze(b);jb=g- -64|0;break h}break g}return}a=P()|0;O()|0;ze(b);S(a|0);L()}function lc(a,b,c){var d=0,e=0,f=0;if(c>>>0>=512){Ra(a|0,b|0,c|0)|0;return a}e=a+c|0;a:{if(!((a^b)&3)){b:{if(!(a&3)){c=a;break b}if(!c){c=a;break b}c=a;while(1){t[c|0]=w[b|0];b=b+1|0;c=c+1|0;if(!(c&3)){break b}if(c>>>0<e>>>0){continue}break}}d=e&-4;c:{if(d>>>0<64){break c}f=d+-64|0;if(f>>>0<c>>>0){break c}while(1){v[c>>2]=v[b>>2];v[c+4>>2]=v[b+4>>2];v[c+8>>2]=v[b+8>>2];v[c+12>>2]=v[b+12>>2];v[c+16>>2]=v[b+16>>2];v[c+20>>2]=v[b+20>>2];v[c+24>>2]=v[b+24>>2];v[c+28>>2]=v[b+28>>2];v[c+32>>2]=v[b+32>>2];v[c+36>>2]=v[b+36>>2];v[c+40>>2]=v[b+40>>2];v[c+44>>2]=v[b+44>>2];v[c+48>>2]=v[b+48>>2];v[c+52>>2]=v[b+52>>2];v[c+56>>2]=v[b+56>>2];v[c+60>>2]=v[b+60>>2];b=b- -64|0;c=c- -64|0;if(f>>>0>=c>>>0){continue}break}}if(c>>>0>=d>>>0){break a}while(1){v[c>>2]=v[b>>2];b=b+4|0;c=c+4|0;if(d>>>0>c>>>0){continue}break}break a}if(e>>>0<4){c=a;break a}d=e-4|0;if(d>>>0<a>>>0){c=a;break a}c=a;while(1){t[c|0]=w[b|0];t[c+1|0]=w[b+1|0];t[c+2|0]=w[b+2|0];t[c+3|0]=w[b+3|0];b=b+4|0;c=c+4|0;if(d>>>0>=c>>>0){continue}break}}if(c>>>0<e>>>0){while(1){t[c|0]=w[b|0];b=b+1|0;c=c+1|0;if((e|0)!=(c|0)){continue}break}}return a}function oea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=jb-48|0;jb=e;l=v[a+16>>2];f=Uf(e+16|0);v[f+8>>2]=a+112;v[f+16>>2]=v[a+128>>2];m=f,n=Pf(b+327720|0,v[b+20>>2],(v[a+88>>2]&16384)>>>14|0),v[m+12>>2]=n;b=v[f+16>>2];if(b){m=f,n=Tf(a+8|0,b),v[m>>2]=n;v[f+4>>2]=mb}i=v[a+40>>2];j=v[a+36>>2];b=v[a+4>>2];h=v[a>>2];v[e+8>>2]=h;v[e+12>>2]=b;g=v[a+12>>2];v[e>>2]=v[a+8>>2];v[e+4>>2]=g;a:{if(d){while(1){k=0;g=k;v[e+40>>2]=h;v[e+44>>2]=g;h=b+l|0;b:{b=v[f+16>>2];if((b|0)<=0){break b}while(1){yd(v[f+8>>2],t[h+g|0]<<6);xd(v[f+8>>2],4);Sb(e+40|0,f);if((b|0)<2){break b}b=b-1|0;g=v[e+44>>2];continue}}d=d-1|0;b=v[f+8>>2];Sb(b,b+8|0);b=v[f+8>>2];g=v[b+4>>2];if(g){yd(b,t[h+v[e+44>>2]|0]<<6);xd(v[f+8>>2],g);b=v[f+8>>2];g=v[b>>2];v[b>>2]=g;v[b+4>>2]=0}b=Of(b,v[f+12>>2]);h=v[a+32>>2];j=v[a+28>>2]+j|0;g=j>>12;v[c>>2]=v[c>>2]+B(b,g);i=h+i|0;k=i>>12;v[c+4>>2]=v[c+4>>2]+B(b,k);Sb(e+8|0,e);if(d){c=c+8|0;h=v[e+8>>2];b=v[e+12>>2];continue}break}h=v[e+8>>2];b=v[e+12>>2];break a}k=i>>12;g=j>>12}v[a+40>>2]=i;v[a+20>>2]=g;v[a+36>>2]=j;v[a+24>>2]=k;v[a>>2]=h;v[a+4>>2]=b;jb=e+48|0}function Fla(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;f=jb-2608|0;jb=f;d=f+8|0;lm(d,a);v[d+1056>>2]=0;v[d+1060>>2]=0;Qb(d+1064|0,0,1536);v[113382]=0;Z(528,d|0);a=v[113382];v[113382]=0;a:{b:{c:{d:{e:{f:{g:{if((a|0)!=1){if(!(u[d+1064>>1]<0|u[d+1066>>1]<0)){if(!c){break d}while(1){v[113382]=0;j=Q(230,d|0,1)|0;a=v[113382];v[113382]=0;if((a|0)==1){break f}a=0;while(1){v[113382]=0;e=Q(230,d|0,1)|0;k=v[113382];v[113382]=0;if((k|0)==1){break g}a=u[(B(a,6)+d|0)+(e?1066:1064)>>1];h:{if((a|0)>255){break h}e=B(a,6)+d|0;g=w[e+1068|0];if(u[e+1064>>1]<0){break h}if(u[e+1066>>1]>=0){continue}}break}g=(j?-1:0)^g;i=(i&255)+(g&255)|0;t[b+h|0]=i;h=h+1|0;if((h|0)!=(c|0)){continue}break}break d}v[113382]=0;a=T(529,d|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){break c}}b=V(72108)|0;break e}b=V(72108)|0;break e}b=V(72108)|0}if((O()|0)!=(ga(72108)|0)){break a}_(b|0)|0;v[113382]=0;Y(20);a=v[113382];v[113382]=0;if((a|0)==1){break b}}v[113382]=0;a=T(529,d|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){break c}b=P()|0;O()|0;break a}Bb(d);jb=f+2608|0;return a|0}b=P()|0;O()|0}Bb(d);S(b|0);L()}function be(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;if(nD(b)){j=b>>>0>4?b:4;b=a?a:1;a:{while(1){h=jb-16|0;jb=h;v[h+12>>2]=0;e=b;a=j;b:{c:{if((a|0)==8){a=kd(e);break c}if(a&3|a>>>0<4){break b}c=a>>>2|0;if(c-1&c|e>>>0>-64-a>>>0){break b}c=16;a=a>>>0>16?a:16;d=a>>>0>16?a:16;d:{if(!(d-1&d)){a=d;break d}while(1){a=c;c=a<<1;if(a>>>0<d>>>0){continue}break}}e:{if(e>>>0>=-64-a>>>0){v[113305]=48;c=0;break e}i=e>>>0<11?16:e+11&-8;f=kd((i+a|0)+12|0);c=0;if(!f){break e}c=f-8|0;f:{if(!(f&a-1)){a=c;break f}e=f-4|0;d=v[e>>2];g=a;a=((a+f|0)-1&0-a)-8|0;a=(a-c>>>0>15?0:g)+a|0;g=a-c|0;f=(d&-8)-g|0;if(!(d&3)){c=v[c>>2];v[a+4>>2]=f;v[a>>2]=c+g;break f}v[a+4>>2]=f|v[a+4>>2]&1|2;d=a+f|0;v[d+4>>2]=v[d+4>>2]|1;v[e>>2]=g|v[e>>2]&1|2;d=c+g|0;v[d+4>>2]=v[d+4>>2]|1;Pq(c,g)}d=v[a+4>>2];g:{if(!(d&3)){break g}c=d&-8;if(c>>>0<=i+16>>>0){break g}v[a+4>>2]=i|d&1|2;e=a+i|0;d=c-i|0;v[e+4>>2]=d|3;c=a+c|0;v[c+4>>2]=v[c+4>>2]|1;Pq(e,d)}c=a+8|0}a=c}if(!a){break b}v[h+12>>2]=a}jb=h+16|0;a=v[h+12>>2];if(a){break a}a=v[114678];if(a){nb[a|0]();continue}break}a=ba(4)|0;Zk(a);ha(a|0,66740,1977);L()}return a}return Pe(a)}function Z3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;a:{g=v[b>>2];b=v[b+4>>2];c=jb-32|0;jb=c;v[113382]=0;h=Q(15,c+24|0,a|0)|0;d=v[113382];v[113382]=0;b:{c:{d:{if((d|0)!=1){e:{if(!w[h|0]){break e}d=v[v[a>>2]-12>>2];v[113382]=0;Ac(c+16|0,a+d|0);d=v[113382];v[113382]=0;f:{g:{h:{if((d|0)!=1){v[113382]=0;d=T(2723,c+16|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break h}Ob(c+16|0);e=Tk(c+8|0,a);f=v[v[a>>2]-12>>2];v[113382]=0;f=a+f|0;i=T(16,f|0)|0;j=v[113382];v[113382]=0;if((j|0)==1){break g}e=v[e>>2];v[113382]=0;b=Ga(2726,d|0,e|0,f|0,i|0,g|0,b|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break g}v[c+16>>2]=b;if(!Rk(c+16|0)){break e}b=v[v[a>>2]-12>>2];v[113382]=0;R(18,a+b|0,5);b=v[113382];v[113382]=0;if((b|0)!=1){break e}b=V(0)|0;O()|0;break f}b=V(0)|0;O()|0;break f}b=V(0)|0;O()|0;Ob(c+16|0);break f}b=V(0)|0;O()|0}Kf(h);break d}Kf(h);break c}b=V(0)|0;O()|0}_(b|0)|0;b=v[v[a>>2]-12>>2];v[113382]=0;Z(19,a+b|0);a=v[113382];v[113382]=0;if((a|0)==1){break b}$()}jb=c+32|0;break a}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}}function Bea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=jb-32|0;jb=f;k=v[a+40>>2];l=v[a+36>>2];m=v[a+16>>2];e=v[a+4>>2];g=e;h=v[a>>2];v[f+24>>2]=h;v[f+28>>2]=e;e=v[a+12>>2];v[f+16>>2]=v[a+8>>2];v[f+20>>2]=e;a:{if(d){while(1){i=((((g&2147483647)<<1|h>>>31)&2147483646)<<1)+m|0;e=(((h>>>16|0)+4&131064)<<1)+b|0;h=u[e+38>>1];n=u[e+36>>1];o=u[e+34>>1];p=u[e+32>>1];q=u[e+30>>1];r=u[e+28>>1];s=u[e+26>>1];t=u[e+24>>1];j=0;e=1;while(1){g=j<<1;v[(f+8|0)+(j<<2)>>2]=(((((B(u[(g|8)+i>>1],o)+B(u[(g|4)+i>>1],p)|0)+B(u[(g|12)+i>>1],n)|0)+B(u[(g|16)+i>>1],h)|0)/2|0)+((((B(u[(g|-8)+i>>1],s)+B(u[(g|-12)+i>>1],t)|0)+B(u[(g|-4)+i>>1],r)|0)+B(u[g+i>>1],q)|0)/2|0)|0)/16384;g=e;e=0;j=1;if(g){continue}break}e=v[a+32>>2];l=v[a+28>>2]+l|0;j=l>>12;v[c>>2]=v[c>>2]+B(j,v[f+8>>2]);k=e+k|0;e=k>>12;v[c+4>>2]=v[c+4>>2]+B(e,v[f+12>>2]);Sb(f+24|0,f+16|0);d=d-1|0;if(d){c=c+8|0;h=v[f+24>>2];g=v[f+28>>2];continue}break}h=v[f+24>>2];g=v[f+28>>2];break a}e=k>>12;j=l>>12}v[a+40>>2]=k;v[a+20>>2]=j;v[a+36>>2]=l;v[a+24>>2]=e;v[a>>2]=h;v[a+4>>2]=g;jb=f+32|0}function nH(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=C(0);e=jb-48|0;jb=e;v[e+40>>2]=c;v[e+44>>2]=b;v[e+36>>2]=d;b=v[a+8>>2];v[e+28>>2]=e+36;v[e+24>>2]=e+40;c=v[e+28>>2];v[e+8>>2]=v[e+24>>2];v[e+12>>2]=c;v[e+16>>2]=a;v[e+20>>2]=e+44;c=v[e+20>>2];v[e>>2]=v[e+16>>2];v[e+4>>2]=c;c=e;a:{b:{switch(v[b+40>>2]){case 0:Ir(c,b);break a;case 2:Ir(c,zb(b));break a;case 3:i=Xg(b);b=jb-80|0;jb=b;d=v[c>>2];f=v[d+4>>2];v[b+40>>2]=v[d+20>>2];g=v[d+16>>2];v[b+32>>2]=v[d+12>>2];v[b+36>>2]=g;Fo(b- -64|0,b+32|0,f);d=ie(b+48|0,v[v[c+4>>2]>>2],v[v[c+8>>2]>>2],v[v[c+12>>2]>>2]);f=v[v[c+12>>2]>>2];g=v[v[c+8>>2]>>2];v[b+24>>2]=v[b+72>>2];c=v[b+68>>2];v[b+16>>2]=v[b+64>>2];v[b+20>>2]=c;v[b+8>>2]=v[d+8>>2];c=v[d+4>>2];v[b>>2]=v[d>>2];v[b+4>>2]=c;j=b+16|0;c=b;if(f){while(1){d=0;if(g){while(1){k=v[Sf(c,d,h)>>2];Xe(i,d);l=Sf(j,d,h),m=C(C(k|0)*C(7.450580596923828e-9)),z[l>>2]=m;d=d+1|0;if((g|0)!=(d|0)){continue}break}}h=h+1|0;if((f|0)!=(h|0)){continue}break}}jb=b+80|0;break a;case 1:Ir(c,zb(b));break a;default:break b}}Ir(c,zb(b))}v[a+4>>2]=v[a+4>>2]+v[e+36>>2];jb=e+48|0}function Vea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;g=jb-16|0;jb=g;a:{b:{c:{e=v[a+12>>2];h=v[a+8>>2];d:{if((e|0)<=1&h>>>0<=805306368|(e|0)<=0){if((e|0)>=-2&h>>>0>=3489660928|(e|0)>-2){break c}if((e|0)==-2&h>>>0>2147483647|e>>>0>4294967294){break d}break b}if((e|0)==1&h>>>0>2147483648|e>>>0>1){break b}}l=b+196648|0;break a}l=b+131112|0;break a}l=b+262184|0}m=v[a+16>>2];i=v[a+40>>2];j=v[a+36>>2];f=v[a+4>>2];k=v[a>>2];v[g+8>>2]=k;v[g+12>>2]=f;v[g>>2]=h;v[g+4>>2]=e;e:{if(d){while(1){h=v[a+32>>2];j=v[a+28>>2]+j|0;b=j>>12;e=(f<<1)+m|0;f=(k>>>16&65520)+l|0;f=(((((((B(u[e-4>>1],u[f+2>>1])+B(u[e-6>>1],u[f>>1])|0)+B(u[e-2>>1],u[f+4>>1])|0)+B(u[e>>1],u[f+6>>1])|0)+B(u[e+2>>1],u[f+8>>1])|0)+B(u[e+4>>1],u[f+10>>1])|0)+B(u[e+6>>1],u[f+12>>1])|0)+B(u[e+8>>1],u[f+14>>1])|0)/32768|0;v[c>>2]=v[c>>2]+B(b,f);i=h+i|0;h=i>>12;v[c+4>>2]=v[c+4>>2]+B(f,h);Sb(g+8|0,g);d=d-1|0;if(d){c=c+8|0;k=v[g+8>>2];f=v[g+12>>2];continue}break}k=v[g+8>>2];f=v[g+12>>2];break e}h=i>>12;b=j>>12}v[a+40>>2]=i;v[a+20>>2]=b;v[a+36>>2]=j;v[a+24>>2]=h;v[a>>2]=k;v[a+4>>2]=f;jb=g+16|0}function O9(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;e=jb+-64|0;jb=e;g=Um(a);a:{if(b-1>>>0>1023){break a}f=v[a+12>>2];if((f|0)==(b|0)){break a}if(c){c=v[g+8>>2];if(y[c+40>>2]<b>>>0|y[c+36>>2]>b>>>0){break a}f=v[a+12>>2]}f=B(mk(a),b>>>0>f>>>0?b-f|0:f-b|0);b:{c:{if(y[a+12>>2]<b>>>0){c=e;d:{if(d){d=bc(a);break d}d=ac(a)}v[c+48>>2]=d;c=Hd(e+56|0,e+48|0);d=e+40|0;oh(d);c=v[c>>2];v[113382]=0;aa(1531,a|0,c|0,f|0,d|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){break b}a=V(66740)|0;break c}if(d){i=e,j=bc(a),v[i+48>>2]=j;i=e,j=jK(e+48|0,0-f|0),v[i+40>>2]=j;c=Hd(e+32|0,e+40|0);i=e,j=bc(a),v[i+16>>2]=j;d=v[Hd(e+24|0,e+16|0)>>2];c=v[c>>2];v[113382]=0;W(1532,a|0,c|0,d|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){break b}a=V(66740)|0;break c}i=e,j=ac(a),v[i+40>>2]=j;c=Hd(e+8|0,e+40|0);i=e,j=ac(a),v[i+16>>2]=j;i=e,j=jK(e+16|0,f),v[i+48>>2]=j;d=v[Hd(e,e+48|0)>>2];c=v[c>>2];v[113382]=0;W(1532,a|0,c|0,d|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){break b}a=V(66740)|0}if((O()|0)==(ga(66740)|0)){_(a|0)|0;$();break a}S(a|0);L()}v[a+12>>2]=b;h=1}jb=e- -64|0;return h|0}function BG(a,b,c,d,e,f,g,h){var i=0,j=0,k=0,l=0,m=0,n=C(0),o=0,p=0;a:{if(w[b+21|0]){l=v[f>>2];j=v[e>>2];o=1;b:{if((h|0)>0){p=B(d,g);m=v[b>>2];while(1){if(v[a+1396>>2]<=9){ek(a)}k=v[a+1392>>2];g=u[(((k&1023)<<1)+b|0)+36>>1];c:{if((g|0)>=0){i=k;k=w[g+v[b+8>>2]|0];v[a+1392>>2]=i>>>k;i=v[a+1396>>2]-k|0;k=(i|0)<0;v[a+1396>>2]=k?0:i;g=k?-1:g;break c}g=ml(a,b)}if((g|0)>=v[b+2092>>2]?w[b+23|0]:0){break a}if((g|0)<0){if(!w[a+1376|0]){o=0;if(v[a+1384>>2]){break b}}cc(a,21);return 0}k=B(d,l);m=((k+m|0)+j|0)>(p|0)?(p-k|0)+j|0:m;k=B(g,v[b>>2]);d:{if(w[b+22|0]){g=0;n=C(0);if((m|0)<=0){break d}while(1){n=C(z[v[b+28>>2]+(g+k<<2)>>2]+n);i=v[(j<<2)+c>>2];if(i){i=i+(l<<2)|0;z[i>>2]=z[i>>2]+n}j=j+1|0;i=(j|0)==(d|0);j=i?0:j;l=i+l|0;g=g+1|0;if((m|0)!=(g|0)){continue}break}break d}g=0;if((m|0)<=0){break d}while(1){i=v[(j<<2)+c>>2];if(i){i=i+(l<<2)|0;z[i>>2]=z[i>>2]+z[v[b+28>>2]+(g+k<<2)>>2]}j=j+1|0;i=(j|0)==(d|0);j=i?0:j;l=i+l|0;g=g+1|0;if((m|0)!=(g|0)){continue}break}}h=h-m|0;if((h|0)>0){continue}break}}v[e>>2]=j;v[f>>2]=l}return o}cc(a,21);return 0}ia(3764,9203,1887,2880);L()}function pQ(a,b,c,d,e){var f=0,g=0;f=jb-16|0;jb=f;g=x[c>>1];a:{if(w[d|0]<=4){while(1){d=g<<1;u[c>>1]=d;t[b|0]=(d&65534)>>>0>255;d=w[c|0];u[c>>1]=d;if(!d){if(!Je(a,f+15|0)){break a}d=w[f+15|0];u[c>>1]=d<<1|1;t[b|0]=d>>>7;u[c>>1]=w[c|0]}u[e>>1]=t[b|0]+(x[e>>1]<<1);d=x[c>>1]<<1;u[c>>1]=d;t[b|0]=(d&65534)>>>0>255;d=w[c|0];u[c>>1]=d;if(!d){if(!Je(a,f+14|0)){break a}d=w[f+14|0];u[c>>1]=d<<1|1;t[b|0]=d>>>7;u[c>>1]=w[c|0]}u[e>>1]=t[b|0]+(x[e>>1]<<1);d=x[c>>1]<<1;u[c>>1]=d;t[b|0]=(d&65534)>>>0>255;g=w[c|0];u[c>>1]=g;if(!g){if(!Je(a,f+13|0)){break a}d=w[f+13|0];u[c>>1]=d<<1|1;t[b|0]=d>>>7;g=w[c|0];u[c>>1]=g;if(w[b|0]){continue}break a}if(w[b|0]){continue}break a}}while(1){d=g<<1;u[c>>1]=d;t[b|0]=(d&65534)>>>0>255;d=w[c|0];u[c>>1]=d;if(!d){if(!Je(a,f+12|0)){break a}d=w[f+12|0];u[c>>1]=d<<1|1;t[b|0]=d>>>7;u[c>>1]=w[c|0]}u[e>>1]=t[b|0]+(x[e>>1]<<1);d=x[c>>1]<<1;u[c>>1]=d;t[b|0]=(d&65534)>>>0>255;g=w[c|0];u[c>>1]=g;if(!g){if(!Je(a,f+11|0)){break a}d=w[f+11|0];u[c>>1]=d<<1|1;t[b|0]=d>>>7;g=w[c|0];u[c>>1]=g;if(w[b|0]){continue}break a}if(w[b|0]){continue}break}}jb=f+16|0}function Wea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;f=jb-16|0;jb=f;a:{b:{c:{e=v[a+12>>2];g=v[a+8>>2];d:{if((e|0)<=1&g>>>0<=805306368|(e|0)<=0){if((e|0)>=-2&g>>>0>=3489660928|(e|0)>-2){break c}if((e|0)==-2&g>>>0>2147483647|e>>>0>4294967294){break d}break b}if((e|0)==1&g>>>0>2147483648|e>>>0>1){break b}}l=b+196648|0;break a}l=b+131112|0;break a}l=b+262184|0}m=v[a+16>>2];i=v[a+40>>2];j=v[a+36>>2];b=v[a+4>>2];k=v[a>>2];v[f+8>>2]=k;v[f+12>>2]=b;v[f>>2]=g;v[f+4>>2]=e;e:{if(d){while(1){g=v[a+32>>2];j=v[a+28>>2]+j|0;e=j>>12;h=b+m|0;b=(k>>>16&65520)+l|0;b=(((((((B(t[h-2|0],u[b+2>>1])+B(t[h-3|0],u[b>>1])|0)+B(t[h-1|0],u[b+4>>1])|0)+B(t[h|0],u[b+6>>1])|0)+B(t[h+1|0],u[b+8>>1])|0)+B(t[h+2|0],u[b+10>>1])|0)+B(t[h+3|0],u[b+12>>1])|0)+B(t[h+4|0],u[b+14>>1])<<8)/32768|0;v[c>>2]=v[c>>2]+B(e,b);i=g+i|0;g=i>>12;v[c+4>>2]=v[c+4>>2]+B(b,g);Sb(f+8|0,f);d=d-1|0;if(d){c=c+8|0;k=v[f+8>>2];b=v[f+12>>2];continue}break}k=v[f+8>>2];b=v[f+12>>2];break e}g=i>>12;e=j>>12}v[a+40>>2]=i;v[a+20>>2]=e;v[a+36>>2]=j;v[a+24>>2]=g;v[a>>2]=k;v[a+4>>2]=b;jb=f+16|0}function y5(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;a:{c=v[b>>2];b=jb-32|0;jb=b;v[113382]=0;g=Q(15,b+24|0,a|0)|0;d=v[113382];v[113382]=0;b:{c:{d:{if((d|0)!=1){e:{if(!w[g|0]){break e}d=v[v[a>>2]-12>>2];v[113382]=0;Ac(b+16|0,a+d|0);d=v[113382];v[113382]=0;f:{g:{h:{if((d|0)!=1){v[113382]=0;d=T(2723,b+16|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break h}Ob(b+16|0);e=Tk(b+8|0,a);f=v[v[a>>2]-12>>2];v[113382]=0;f=a+f|0;h=T(16,f|0)|0;i=v[113382];v[113382]=0;if((i|0)==1){break g}e=v[e>>2];v[113382]=0;c=ea(2724,d|0,e|0,f|0,h|0,c|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break g}v[b+16>>2]=c;if(!Rk(b+16|0)){break e}c=v[v[a>>2]-12>>2];v[113382]=0;R(18,a+c|0,5);c=v[113382];v[113382]=0;if((c|0)!=1){break e}c=V(0)|0;O()|0;break f}c=V(0)|0;O()|0;break f}c=V(0)|0;O()|0;Ob(b+16|0);break f}c=V(0)|0;O()|0}Kf(g);break d}Kf(g);break c}c=V(0)|0;O()|0}_(c|0)|0;c=v[v[a>>2]-12>>2];v[113382]=0;Z(19,a+c|0);a=v[113382];v[113382]=0;if((a|0)==1){break b}$()}jb=b+32|0;break a}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}}function R3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;a:{g=A[b>>3];b=jb-32|0;jb=b;v[113382]=0;f=Q(15,b+24|0,a|0)|0;c=v[113382];v[113382]=0;b:{c:{d:{if((c|0)!=1){e:{if(!w[f|0]){break e}c=v[v[a>>2]-12>>2];v[113382]=0;Ac(b+16|0,a+c|0);c=v[113382];v[113382]=0;f:{g:{h:{if((c|0)!=1){v[113382]=0;c=T(2723,b+16|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break h}Ob(b+16|0);d=Tk(b+8|0,a);e=v[v[a>>2]-12>>2];v[113382]=0;e=a+e|0;h=T(16,e|0)|0;i=v[113382];v[113382]=0;if((i|0)==1){break g}d=v[d>>2];v[113382]=0;c=Va(2727,c|0,d|0,e|0,h|0,+g)|0;d=v[113382];v[113382]=0;if((d|0)==1){break g}v[b+16>>2]=c;if(!Rk(b+16|0)){break e}c=v[v[a>>2]-12>>2];v[113382]=0;R(18,a+c|0,5);c=v[113382];v[113382]=0;if((c|0)!=1){break e}c=V(0)|0;O()|0;break f}c=V(0)|0;O()|0;break f}c=V(0)|0;O()|0;Ob(b+16|0);break f}c=V(0)|0;O()|0}Kf(f);break d}Kf(f);break c}c=V(0)|0;O()|0}_(c|0)|0;c=v[v[a>>2]-12>>2];v[113382]=0;Z(19,a+c|0);a=v[113382];v[113382]=0;if((a|0)==1){break b}$()}jb=b+32|0;break a}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}}function gfa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,w=0,x=0,y=0;g=jb-16|0;jb=g;f=v[a+48>>2];l=v[a+24>>2];m=v[a+20>>2];b=v[a+44>>2];n=v[a+16>>2];h=v[a+4>>2];i=v[a>>2];v[g+8>>2]=i;v[g+12>>2]=h;e=v[a+12>>2];v[g>>2]=v[a+8>>2];v[g+4>>2]=e;a:{if(!d){e=b;b=f;break a}while(1){e=h+n|0;h=t[e+2|0];o=t[e+1|0];p=t[e|0];q=t[e-1|0];e=v[a+60>>2];r=e;s=e>>31;e=Yb(b,-16777216,16776704);j=v[a+64>>2];f=Yb(f,-16777216,16776704);w=v[a+72>>2];x=v[c>>2];e=qma(j,j>>31,e,e>>31);j=mb;y=e;e=v[a+68>>2];k=qma(e,e>>31,f,f>>31);e=y+k|0;f=mb+j|0;f=e>>>0<k>>>0?f+1|0:f;j=e;e=(i>>>21&2040)+33120|0;h=(((B(u[e+2>>1],p)+B(q,u[e>>1])|0)+B(u[e+4>>1],o)|0)+B(h,u[e+6>>1])<<8)/16384<<8;e=h;i=qma(r,s,e,e>>31);e=j+i|0;f=mb+f|0;f=e>>>0<i>>>0?f+1|0:f;e=e+8388608|0;f=e>>>0<8388608?f+1|0:f;f=(f&16777215)<<8|e>>>24;e=(f|0)/256|0;v[c>>2]=B(e,m)+x;v[c+4>>2]=v[c+4>>2]+B(e,l);e=f-(h&w)|0;Sb(g+8|0,g);d=d-1|0;if(d){c=c+8|0;i=v[g+8>>2];h=v[g+12>>2];f=b;b=e;continue}break}i=v[g+8>>2];h=v[g+12>>2]}v[a+48>>2]=b;v[a+44>>2]=e;v[a>>2]=i;v[a+4>>2]=h;jb=g+16|0}function PA(a){var b=0,c=0,d=0,e=0,f=0,g=0,h=0;a:{if((w[a|0]-1&255)>>>0>14){break a}b=a+1954|0;d=a+1698|0;while(1){if(t[d|0]<-1){break a}d=d+1|0;if((b|0)!=(d|0)){continue}break}d=0;while(1){b:{h=0;f=B(d,13)+a|0;if(w[f+14|0]){break b}e=(d<<4)+a|0;b=e+418|0;if(w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24)){break b}c=e+422|0;if(w[f+942|0]|(w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24))>>>0>1048575){break b}b=B(d,11)+a|0;f=b+1346|0;if(w[f|0]>15|w[b+1351|0]>3|w[b+1356|0]>3){break b}c:{if(!(w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24))){break c}b=e+430|0;if((w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24))>>>0>1048574){break c}if((w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24))>>>0>(w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24))>>>0){break b}e=e+426|0;if((w[e|0]|w[e+1|0]<<8|(w[e+2|0]<<16|w[e+3|0]<<24))>>>0>(w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24))>>>0){break b}}h=1;b=1;d:{if(g){break d}e:{if(w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24)){break e}if(md(f,23549,11)){break e}b=0;break d}b=1}g=b;d=d+1|0;if((d|0)!=32){continue}}break}g=g&h}return g}function mn(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;f=jb-16|0;jb=f;if(b&2){t[a+861|0]=0;v[a+708>>2]=0;v[a+656>>2]=0;v[a+104>>2]=0;t[a+819|0]=0;v[a+804>>2]=0;v[a+824>>2]=0;v[a+696>>2]=0;v[a+668>>2]=0;v[a+88>>2]=v[a+88>>2]|6144;g=f+8|0;Fb(g,c+1074312|0,23);if(Cb(g)){u[a+798>>1]=0;u[a+800>>1]=1}t[a+866|0]=0;t[a+859|0]=0;t[a+871|0]=255;v[a+660>>2]=0;t[a+872|0]=w[a+872|0]&252;it(a+810|0)}if(b&4){v[a+84>>2]=0;v[a+76>>2]=0;v[a+80>>2]=0;v[a+700>>2]=0;v[a+656>>2]=0;v[a+104>>2]=0;v[a+92>>2]=0;v[a+96>>2]=0;v[a>>2]=0;v[a+4>>2]=0;t[a+865|0]=0;t[a+858|0]=0;v[a+688>>2]=0;v[a+672>>2]=0;v[a+676>>2]=0;u[a+840>>1]=0;t[a+839|0]=0;u[a+856>>1]=32512;u[a+862>>1]=0;v[a+20>>2]=0;v[a+24>>2]=0;v[a+8>>2]=0;v[a+12>>2]=0;v[a+28>>2]=0;v[a+32>>2]=0;v[a+876>>2]=0;v[a+880>>2]=0;t[a+872|0]=w[a+872|0]&243}if(b&1){a:{if(d>>>0<=126){b=(d<<5)+c|0;c=v[b+480280>>2];v[a+88>>2]=c;v[a+692>>2]=x[b+480284>>1];v[a+760>>2]=x[b+480286>>1];if(!(c&1024)){break a}v[a+88>>2]=c&-1025|e;break a}v[a+760>>2]=64;v[a+692>>2]=128;v[a+88>>2]=0}u[a+796>>1]=0;t[a+817|0]=0;t[a+818|0]=0}jb=f+16|0}function ffa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=jb-16|0;jb=g;f=v[a+48>>2];m=v[a+24>>2];n=v[a+20>>2];b=v[a+44>>2];o=v[a+16>>2];h=v[a+4>>2];i=v[a>>2];v[g+8>>2]=i;v[g+12>>2]=h;e=v[a+12>>2];v[g>>2]=v[a+8>>2];v[g+4>>2]=e;a:{if(!d){e=b;b=f;break a}while(1){e=(h<<1)+o|0;j=u[e>>1];p=u[e-2>>1];q=u[e+2>>1];r=u[e+4>>1];l=v[a+60>>2];e=Yb(b,-16777216,16776704);k=v[a+64>>2];h=Yb(f,-16777216,16776704);s=v[a+72>>2];f=v[c>>2];e=qma(k,k>>31,e,e>>31);k=mb;t=f;f=(i>>>21&2040)+33120|0;i=(((B(j,u[f+2>>1])+B(u[f>>1],p)|0)+B(u[f+4>>1],q)|0)+B(r,u[f+6>>1])|0)/16384<<8;f=i;j=qma(l,l>>31,f,f>>31);e=j+e|0;f=mb+k|0;f=e>>>0<j>>>0?f+1|0:f;j=e;e=v[a+68>>2];h=qma(e,e>>31,h,h>>31);e=j+h|0;f=mb+f|0;f=e>>>0<h>>>0?f+1|0:f;e=e+8388608|0;f=e>>>0<8388608?f+1|0:f;f=(f&16777215)<<8|e>>>24;e=(f|0)/256|0;v[c>>2]=t+B(e,n);v[c+4>>2]=v[c+4>>2]+B(e,m);e=f-(i&s)|0;Sb(g+8|0,g);d=d-1|0;if(d){c=c+8|0;i=v[g+8>>2];h=v[g+12>>2];f=b;b=e;continue}break}i=v[g+8>>2];h=v[g+12>>2]}v[a+48>>2]=b;v[a+44>>2]=e;v[a>>2]=i;v[a+4>>2]=h;jb=g+16|0}function b6(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=jb-32|0;jb=g;o=g,p=DM(b),v[o+16>>2]=p;j=g+24|0;l=j;m=g+16|0;n=g+8|0;d=jb-32|0;jb=d;c=b;e=a;b=Ke(e);f=jc(e);a:{b:{if(b){c:{while(1){d:{h=b+16|0;e:{if(Ms(zb(e),c,h)){if(!v[b>>2]){break b}f=b;break e}if(!Ms(zb(e),h,c)){break c}f=b+4|0;if(!v[b+4>>2]){break d}b=f;f=b}b=v[b>>2];continue}break}v[d+28>>2]=b;b=f;break a}v[d+28>>2]=b;b=f;break a}b=jc(e)}v[d+28>>2]=b}f=b;b=v[b>>2];t[d+27|0]=0;if(!b){h=jb-16|0;jb=h;k=jc(a);b=be(40,4);i=Dk(h+8|0,k);c=jb-16|0;jb=c;v[c+12>>2]=b;v[113382]=0;e=d+8|0;b=e;W(1221,b|0,c+12|0,i|0)|0;i=v[113382];v[113382]=0;f:{if((i|0)!=1){jb=c+16|0;break f}V(0)|0;O()|0;Ab();L()}c=v[b>>2];v[113382]=0;c=T(1220,c+16|0)|0;i=v[113382];v[113382]=0;g:{h:{if((i|0)==1){break h}v[113382]=0;fa(2078,k|0,c|0,36836,m|0,n|0);c=v[113382];v[113382]=0;if((c|0)==1){break h}o=jc(b),p=1,t[o+4|0]=p;jb=h+16|0;break g}a=P()|0;O()|0;CM(b);S(a|0);L()}Ek(a,v[d+28>>2],f,v[e>>2]);b=ke(e);t[d+27|0]=1;CM(e)}Ei(l,Oc(d+8|0,b),d+27|0);jb=d+32|0;a=lh(j);jb=g+32|0;return a+12|0}function Fd(a){var b=0,c=0,d=0,e=0,f=0;c=jb-32|0;jb=c;v[c+12>>2]=0;v[c+8>>2]=2438;d=v[c+12>>2];v[c>>2]=v[c+8>>2];v[c+4>>2]=d;d=v[c+4>>2];b=c+16|0;v[b+4>>2]=v[c>>2];v[b+8>>2]=d;v[b>>2]=a;e=jb-16|0;jb=e;d=a;if(v[a>>2]!=-1){f=e+8|0;Oc(f,b);Oc(e,f);b=e;while(1){if(v[d>>2]==1){continue}break}a:{b:{c:{if(!v[d>>2]){Oe(d,1);v[113382]=0;f=v[113382];v[113382]=0;d:{if((f|0)==1){break d}v[113382]=0;Z(2446,b|0);b=v[113382];v[113382]=0;if((b|0)==1){break d}v[113382]=0;b=v[113382];v[113382]=0;if((b|0)==1){break d}v[d>>2]=-1;v[113382]=0;b=v[113382];v[113382]=0;if((b|0)==1){break d}v[113382]=0;b=v[113382];v[113382]=0;if((b|0)!=1){break a}}a=V(0)|0;O()|0;_(a|0)|0;v[113382]=0;a=v[113382];v[113382]=0;e:{if((a|0)==1){break e}Oe(d,0);v[113382]=0;a=v[113382];v[113382]=0;if((a|0)==1){break e}v[113382]=0;a=v[113382];v[113382]=0;if((a|0)==1){break e}v[113382]=0;Y(81);a=v[113382];v[113382]=0;if((a|0)!=1){break b}}a=P()|0;O()|0;v[113382]=0;Y(20);d=v[113382];v[113382]=0;if((d|0)==1){break c}S(a|0);L()}break a}V(0)|0;O()|0;Ab()}L()}}jb=e+16|0;jb=c+32|0;return v[a+4>>2]-1|0}function uba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=jb-32|0;jb=g;o=g,p=DM(b),v[o+16>>2]=p;k=g+24|0;l=k;m=g+16|0;n=g+8|0;d=jb-32|0;jb=d;c=b;e=a;b=Ke(e);f=jc(e);a:{b:{if(b){c:{while(1){d:{zb(e);h=b+14|0;e:{if(DL(c,h)){if(!v[b>>2]){break b}f=b;break e}zb(e);if(!DL(h,c)){break c}f=b+4|0;if(!v[b+4>>2]){break d}b=f;f=b}b=v[b>>2];continue}break}v[d+28>>2]=b;b=f;break a}v[d+28>>2]=b;b=f;break a}b=jc(e)}v[d+28>>2]=b}f=b;b=v[b>>2];t[d+27|0]=0;if(!b){h=jb-16|0;jb=h;j=jc(a);b=Ez(j,1);i=Dk(h+8|0,j);c=jb-16|0;jb=c;v[c+12>>2]=b;v[113382]=0;e=d+8|0;b=e;W(1348,b|0,c+12|0,i|0)|0;i=v[113382];v[113382]=0;f:{if((i|0)!=1){jb=c+16|0;break f}V(0)|0;O()|0;Ab();L()}c=v[b>>2];v[113382]=0;c=T(1345,c+14|0)|0;i=v[113382];v[113382]=0;g:{h:{if((i|0)==1){break h}v[113382]=0;fa(1347,j|0,c|0,25920,m|0,n|0);c=v[113382];v[113382]=0;if((c|0)==1){break h}o=jc(b),p=1,t[o+4|0]=p;jb=h+16|0;break g}a=P()|0;O()|0;EL(b);S(a|0);L()}Ek(a,v[d+28>>2],f,v[e>>2]);b=ke(e);t[d+27|0]=1;EL(e)}Ei(l,Oc(d+8|0,b),d+27|0);jb=d+32|0;a=xt(k);jb=g+32|0;return a+4|0}function sba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=jb-32|0;jb=g;o=g,p=Ct(b),v[o+16>>2]=p;k=g+24|0;l=k;m=g+16|0;n=g+8|0;d=jb-32|0;jb=d;c=b;e=a;b=Ke(e);f=jc(e);a:{b:{if(b){c:{while(1){d:{zb(e);h=b+16|0;e:{if(BL(c,h)){if(!v[b>>2]){break b}f=b;break e}zb(e);if(!BL(h,c)){break c}f=b+4|0;if(!v[b+4>>2]){break d}b=f;f=b}b=v[b>>2];continue}break}v[d+28>>2]=b;b=f;break a}v[d+28>>2]=b;b=f;break a}b=jc(e)}v[d+28>>2]=b}f=b;b=v[b>>2];t[d+27|0]=0;if(!b){h=jb-16|0;jb=h;j=jc(a);b=FL(j,1);i=Dk(h+8|0,j);c=jb-16|0;jb=c;v[c+12>>2]=b;v[113382]=0;e=d+8|0;b=e;W(1351,b|0,c+12|0,i|0)|0;i=v[113382];v[113382]=0;f:{if((i|0)!=1){jb=c+16|0;break f}V(0)|0;O()|0;Ab();L()}c=v[b>>2];v[113382]=0;c=T(1349,c+16|0)|0;i=v[113382];v[113382]=0;g:{h:{if((i|0)==1){break h}v[113382]=0;fa(1350,j|0,c|0,25920,m|0,n|0);c=v[113382];v[113382]=0;if((c|0)==1){break h}o=jc(b),p=1,t[o+4|0]=p;jb=h+16|0;break g}a=P()|0;O()|0;CL(b);S(a|0);L()}Ek(a,v[d+28>>2],f,v[e>>2]);b=ke(e);t[d+27|0]=1;CL(e)}Ei(l,Oc(d+8|0,b),d+27|0);jb=d+32|0;a=lh(k);jb=g+32|0;return a+8|0}function _N(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0,k=C(0),l=0,m=0,n=0;j=jb-16|0;jb=j;if(tj(a)){f=w[(Xd(w[a+819|0])?a+819|0:a+821|0)|0];e=j+8|0;Fb(e,d+1074312|0,34);if(!(!Cb(e)|!f|f>>>0>120)){f=w[ec(v[a+656>>2]+108|0,f-1|0)|0]}d=a;k=C(C(v[a+704>>2]<<4)*b);e=(c+f<<16)-3997696>>16;c=v[v[a+656>>2]+44>>2];h=v[c+36>>2];a=v[a+876>>2]+v[a+768>>2]|0;a:{if(!(a?h:0)){b=rl(c,a+e<<16>>16);break a}g=h+1|0;b:{if((a|0)>=0){f=a;a=(a|0)/(g|0)|0;f=f-B(g,a)|0;break b}f=h-((a^-1)%(g|0)|0)|0;a=((a+1|0)/(g|0)|0)-1|0}l=u[c+28>>1];i=c+4|0;Kb(i);b=C(1);e=a+e<<16>>16;c:{if((e|0)<(l|0)){break c}if((e|0)>(x[c+28>>1]+Kb(i)<<16)-65536>>16){break c}if(!f){b=z[Pb(i,e-u[c+28>>1]|0)>>2];break a}a=x[c>>1];d:{if((a|0)==3){a=c+16|0;if(Kb(a)){b=z[Pb(a,f-1|0)>>2];break d}a=x[c>>1]}e:{if((a&65535)!=1){break e}a=c+16|0;if(!Kb(a)){break e}g=x[c+30>>1];if((e|0)>=0){g=(e|0)%(g|0)|0}else{g=g+((e^-1)%(g|0)^-1)|0}b=z[Pb(a,(B(h,g<<16>>16)+f|0)-1|0)>>2];break d}b=je(C(rl(c,(e<<16)+65536>>16)/rl(c,e)),C(C(f|0)/C(g|0)))}b=C(z[Pb(i,e-u[c+28>>1]|0)>>2]*b)}}m=d,n=Ai(C(k*b)),v[m+700>>2]=n}jb=j+16|0}function Cea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,w=0;f=jb-32|0;jb=f;k=v[a+40>>2];l=v[a+36>>2];m=v[a+16>>2];e=v[a+4>>2];h=e;i=v[a>>2];v[f+24>>2]=i;v[f+28>>2]=e;e=v[a+12>>2];v[f+16>>2]=v[a+8>>2];v[f+20>>2]=e;a:{if(d){while(1){j=(((h&2147483647)<<1|i>>>31)&-2)+m|0;e=(((i>>>16|0)+4&131064)<<1)+b|0;i=u[e+38>>1];n=u[e+36>>1];o=u[e+34>>1];p=u[e+32>>1];q=u[e+30>>1];r=u[e+28>>1];s=u[e+26>>1];w=u[e+24>>1];g=0;e=1;while(1){v[(f+8|0)+(g<<2)>>2]=(((((B(t[(g|4)+j|0],o)+B(t[(g|2)+j|0],p)|0)+B(t[(g|6)+j|0],n)|0)+B(t[(g|8)+j|0],i)<<8)/2|0)+((((B(t[(g|-4)+j|0],s)+B(t[(g|-6)+j|0],w)|0)+B(t[(g|-2)+j|0],r)|0)+B(t[g+j|0],q)<<8)/2|0)|0)/16384;h=e;e=0;g=1;if(h){continue}break}h=v[a+32>>2];l=v[a+28>>2]+l|0;e=l>>12;v[c>>2]=v[c>>2]+B(e,v[f+8>>2]);k=h+k|0;g=k>>12;v[c+4>>2]=v[c+4>>2]+B(g,v[f+12>>2]);Sb(f+24|0,f+16|0);d=d-1|0;if(d){c=c+8|0;i=v[f+24>>2];h=v[f+28>>2];continue}break}i=v[f+24>>2];h=v[f+28>>2];break a}g=k>>12;e=l>>12}v[a+40>>2]=k;v[a+20>>2]=e;v[a+36>>2]=l;v[a+24>>2]=g;v[a>>2]=i;v[a+4>>2]=h;jb=f+32|0}function QJ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=jb-32|0;jb=g;o=g,p=Ct(b),v[o+16>>2]=p;k=g+24|0;l=k;m=g+16|0;n=g+8|0;d=jb-32|0;jb=d;c=b;e=a;b=Ke(e);f=jc(e);a:{b:{if(b){c:{while(1){d:{h=b+16|0;e:{if(is(zb(e),c,h)){if(!v[b>>2]){break b}f=b;break e}if(!is(zb(e),h,c)){break c}f=b+4|0;if(!v[b+4>>2]){break d}b=f;f=b}b=v[b>>2];continue}break}v[d+28>>2]=b;b=f;break a}v[d+28>>2]=b;b=f;break a}b=jc(e)}v[d+28>>2]=b}f=b;b=v[b>>2];t[d+27|0]=0;if(!b){h=jb-16|0;jb=h;j=jc(a);b=Zn(j,1);i=Dk(h+8|0,j);c=jb-16|0;jb=c;v[c+12>>2]=b;v[113382]=0;e=d+8|0;b=e;W(1593,b|0,c+12|0,i|0)|0;i=v[113382];v[113382]=0;f:{if((i|0)!=1){jb=c+16|0;break f}V(0)|0;O()|0;Ab();L()}c=v[b>>2];v[113382]=0;c=T(695,c+16|0)|0;i=v[113382];v[113382]=0;g:{h:{if((i|0)==1){break h}v[113382]=0;fa(1592,j|0,c|0,36124,m|0,n|0);c=v[113382];v[113382]=0;if((c|0)==1){break h}o=jc(b),p=1,t[o+4|0]=p;jb=h+16|0;break g}a=P()|0;O()|0;JJ(b);S(a|0);L()}Ek(a,v[d+28>>2],f,v[e>>2]);b=ke(e);t[d+27|0]=1;JJ(e)}Ei(l,Oc(d+8|0,b),d+27|0);jb=d+32|0;a=lh(k);jb=g+32|0;return a+4|0}function gja(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=jb-32|0;jb=g;o=g,p=Ct(b),v[o+16>>2]=p;k=g+24|0;l=k;m=g+16|0;n=g+8|0;d=jb-32|0;jb=d;c=b;e=a;b=Ke(e);f=jc(e);a:{b:{if(b){c:{while(1){d:{h=b+14|0;e:{if(un(zb(e),c,h)){if(!v[b>>2]){break b}f=b;break e}if(!un(zb(e),h,c)){break c}f=b+4|0;if(!v[b+4>>2]){break d}b=f;f=b}b=v[b>>2];continue}break}v[d+28>>2]=b;b=f;break a}v[d+28>>2]=b;b=f;break a}b=jc(e)}v[d+28>>2]=b}f=b;b=v[b>>2];t[d+27|0]=0;if(!b){h=jb-16|0;jb=h;j=jc(a);b=Ez(j,1);i=Dk(h+8|0,j);c=jb-16|0;jb=c;v[c+12>>2]=b;v[113382]=0;e=d+8|0;b=e;W(792,b|0,c+12|0,i|0)|0;i=v[113382];v[113382]=0;f:{if((i|0)!=1){jb=c+16|0;break f}V(0)|0;O()|0;Ab();L()}c=v[b>>2];v[113382]=0;c=T(786,c+14|0)|0;i=v[113382];v[113382]=0;g:{h:{if((i|0)==1){break h}v[113382]=0;fa(791,j|0,c|0,24027,m|0,n|0);c=v[113382];v[113382]=0;if((c|0)==1){break h}o=jc(b),p=1,t[o+4|0]=p;jb=h+16|0;break g}a=P()|0;O()|0;BQ(b);S(a|0);L()}Ek(a,v[d+28>>2],f,v[e>>2]);b=ke(e);t[d+27|0]=1;BQ(e)}Ei(l,Oc(d+8|0,b),d+27|0);jb=d+32|0;a=xt(k);jb=g+32|0;return a+2|0}function bka(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=jb-32|0;jb=g;o=g,p=Ct(b),v[o+16>>2]=p;k=g+24|0;l=k;m=g+16|0;n=g+8|0;d=jb-32|0;jb=d;c=b;e=a;b=Ke(e);f=jc(e);a:{b:{if(b){c:{while(1){d:{h=b+16|0;e:{if(un(zb(e),c,h)){if(!v[b>>2]){break b}f=b;break e}if(!un(zb(e),h,c)){break c}f=b+4|0;if(!v[b+4>>2]){break d}b=f;f=b}b=v[b>>2];continue}break}v[d+28>>2]=b;b=f;break a}v[d+28>>2]=b;b=f;break a}b=jc(e)}v[d+28>>2]=b}f=b;b=v[b>>2];t[d+27|0]=0;if(!b){h=jb-16|0;jb=h;j=jc(a);b=Zn(j,1);i=Dk(h+8|0,j);c=jb-16|0;jb=c;v[c+12>>2]=b;v[113382]=0;e=d+8|0;b=e;W(694,b|0,c+12|0,i|0)|0;i=v[113382];v[113382]=0;f:{if((i|0)!=1){jb=c+16|0;break f}V(0)|0;O()|0;Ab();L()}c=v[b>>2];v[113382]=0;c=T(692,c+16|0)|0;i=v[113382];v[113382]=0;g:{h:{if((i|0)==1){break h}v[113382]=0;fa(693,j|0,c|0,23876,m|0,n|0);c=v[113382];v[113382]=0;if((c|0)==1){break h}o=jc(b),p=1,t[o+4|0]=p;jb=h+16|0;break g}a=P()|0;O()|0;HR(b);S(a|0);L()}Ek(a,v[d+28>>2],f,v[e>>2]);b=ke(e);t[d+27|0]=1;HR(e)}Ei(l,Oc(d+8|0,b),d+27|0);jb=d+32|0;a=lh(k);jb=g+32|0;return a+4|0}function wz(a,b,c,d,e){var f=0,g=0,h=0,i=0,j=0,k=0,l=0;h=jb-32|0;jb=h;cQ(a,b);i=jb-16|0;jb=i;sd(c,1);a=b+22|0;a=w[a|0]|w[a+1|0]<<8;v[c>>2]=((a<<8|a>>>8)&65535)<<1;t[c+37|0]=w[b+24|0]<<4;t[i+15|0]=w[b+25|0];t[i+14|0]=64;k=c,l=w[pc(i+15|0,i+14|0)|0]<<2,u[k+30>>1]=l;a=b+26|0;a=w[a|0]|w[a+1|0]<<8;j=(a<<8|a>>>8)&65535;a=j<<1;f=b+28|0;f=w[f|0]|w[f+1|0]<<8;g=(f<<8|f>>>8)&65535;f=g<<1;a:{if(g>>>0<=1){g=v[c>>2];break a}g=v[c>>2];a=a+f>>>0<=g>>>0?a:g>>>0<f+j>>>0?a:j}b:{c:{switch(g|0){case 2:v[c>>2]=0;break b;case 0:break b;default:break c}}v[c+4>>2]=a;f=a+f|0;v[c+8>>2]=f;if(a>>>0>=g>>>0){a=g-1|0;v[c+4>>2]=a}if(!(!(f>>>0<4|a>>>0>f>>>0)&f-a>>>0>3)){v[c+4>>2]=0;v[c+8>>2]=0;f=0;a=0}if(!(f>>>0>8|a|(!e|f>>>0>=g>>>0))){v[c+8>>2]=0;break b}if(a>>>0>=f>>>0){break b}u[c+34>>1]=x[c+34>>1]|2}jb=i+16|0;Vl(h,3,b);a=h+16|0;Ec(a,h);v[113382]=0;Q(335,d|0,a|0)|0;a=v[113382];v[113382]=0;if((a|0)!=1){a=d+32|0;yb(h+16|0);while(1){if((w[d|0]-1&255)>>>0<=30){t[d|0]=32}d=d+1|0;if((a|0)!=(d|0)){continue}break}a=xz(b);jb=h+32|0;return a}a=P()|0;O()|0;yb(h+16|0);S(a|0);L()}function mJ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=C(0);c=jb+-64|0;jb=c;d=fo(c+48|0,Dd(c+40|0,b),0);v[113382]=0;b=T(296,d|0)|0;e=v[113382];v[113382]=0;a:{if((e|0)==1){break a}v[113382]=0;b=W(1671,d|0,c|0,b|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break a}b:{if(!b|v[c>>2]!=542066252){break b}b=c|4;if(w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24)){break b}b=c+8|0;f=a,g=dn((l(2,w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24)),q()),C(0),C(1)),z[f+4220>>2]=g;b=c+12|0;f=a,g=dn((l(2,w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24)),q()),C(0),C(1)),z[f+4224>>2]=g;b=c+16|0;f=a,g=dn((l(2,w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24)),q()),C(0),C(1)),z[f+4228>>2]=g;b=c+20|0;if((w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24))>>>0<=5){v[a+4232>>2]=w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24)}b=c+24|0;v[a+4236>>2]=w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24);t[a+4240|0]=w[c+28|0]!=0;t[a+4241|0]=w[c+29|0]!=0;t[a+4242|0]=w[c+30|0]!=0;t[a+4243|0]=w[c+31|0]!=0;t[a+4244|0]=w[c+32|0]!=0;ds(a)}Bb(d);jb=c- -64|0;return}a=P()|0;O()|0;Bb(d);S(a|0);L()}function Vka(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;d=jb-32|0;jb=d;t[d+16|0]=44;v[d+8>>2]=-1;v[d+12>>2]=0;v[d>>2]=1042;v[d+4>>2]=2;h=a;g=d;a=jb-16|0;jb=a;i=a;c=jb-176|0;jb=c;e=li(c+40|0);f=v[v[e>>2]-12>>2];v[113382]=0;j=da(123)|0;k=v[113382];v[113382]=0;a:{b:{c:{d:{e:{f:{if((k|0)==1){break f}v[113382]=0;U(124,c+32|0,(c+40|0)+f|0,j|0);f=v[113382];v[113382]=0;if((f|0)==1){break f}Ob(c+32|0);v[113382]=0;R(147,e|0,g|0);f=v[113382];v[113382]=0;if((f|0)==1){break f}v[113382]=0;R(131,e|0,b|0);b=v[113382];v[113382]=0;if((b|0)==1){break f}v[113382]=0;R(126,c|0,e|0);b=v[113382];v[113382]=0;if((b|0)==1){break f}v[113382]=0;U(139,c+16|0,c|0,g|0);b=v[113382];v[113382]=0;if((b|0)==1){break e}v[113382]=0;U(140,i|0,c+16|0,g|0);b=v[113382];v[113382]=0;if((b|0)==1){break d}yb(c+16|0);yb(c);Td(e);jb=c+176|0;break a}a=P()|0;O()|0;break b}a=P()|0;O()|0;break c}a=P()|0;O()|0;yb(c+16|0)}yb(c)}Td(e);S(a|0);L()}v[113382]=0;U(13,h|0,0,a|0);b=v[113382];v[113382]=0;g:{if((b|0)!=1){yb(a);jb=a+16|0;break g}b=P()|0;O()|0;yb(a);S(b|0);L()}jb=d+32|0}function o0(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=jb-32|0;jb=d;a=bw(a);a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{if((ur(b,c,0)|0)!=-1){while(1){f=ur(b,c,e);v[113382]=0;X(169,d|0,b|0,e|0,f-e|0);f=v[113382];v[113382]=0;if((f|0)==1){break j}v[113382]=0;R(170,d+16|0,d|0);f=v[113382];v[113382]=0;if((f|0)==1){break i}v[113382]=0;R(171,a|0,d+16|0);f=v[113382];v[113382]=0;if((f|0)==1){break h}yb(d+16|0);yb(d);e=ur(b,c,e)+Db(c)|0;if((ur(b,c,e)|0)!=-1){continue}break}}k:{if(id(a)){v[113382]=0;X(169,d+16|0,b|0,e|0,-1);c=v[113382];v[113382]=0;if((c|0)==1){break f}c=d+16|0;f=Db(c);yb(c);if(!f){break k}}v[113382]=0;X(169,d|0,b|0,e|0,-1);b=v[113382];v[113382]=0;if((b|0)==1){break e}v[113382]=0;R(170,d+16|0,d|0);b=v[113382];v[113382]=0;if((b|0)==1){break d}v[113382]=0;R(171,a|0,d+16|0);b=v[113382];v[113382]=0;if((b|0)==1){break c}yb(d+16|0);yb(d)}jb=d+32|0;return}e=P()|0;O()|0;break a}e=P()|0;O()|0;break g}e=P()|0;O()|0;yb(d+16|0)}yb(d);break a}e=P()|0;O()|0;break a}e=P()|0;O()|0;break a}e=P()|0;O()|0;break b}e=P()|0;O()|0;yb(d+16|0)}yb(d)}gl(a);S(e|0);L()}function Ex(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;f=jb-16|0;jb=f;e=a+2|0;if(!(w[e|0]==255|!w[e|0])){v[f+12>>2]=w[e|0]+1;v[f+8>>2]=10;Fg(b,v[Zd(f+12|0,f+8|0)>>2]);e=w[a+3|0];t[b+15|0]=e;t[b+16|0]=e;t[b+13|0]=w[a+4|0];t[b+14|0]=w[a+5|0];g=511;e=0;a:{b:{switch(c-1|0){case 1:e=4096;g=128;break a;case 0:break b;default:break a}}e=32768;g=1024}if(Kb(b)){i=g>>>1|e;while(1){h=(d<<2)+a|0;c=h+6|0;c=w[c|0]|w[c+1|0]<<8;j=Pb(b,d),k=c>>>4|0,u[j>>1]=k;c:{d:{if(!d){e=0;c=0;break d}c=d-1|0;if(x[Pb(b,d)>>1]>=x[Pb(b,c)>>1]){break c}e=d;c=x[Pb(b,c)>>1]+1|0}j=Pb(b,e),k=c,u[j>>1]=k}c=h+8|0;v[f+12>>2]=(i+((w[c|0]|w[c+1|0]<<8)<<16>>16)|0)/(g|0);v[f+8>>2]=0;v[f+4>>2]=64;c=v[Ok(f+12|0,f+8|0,f+4|0)>>2];j=Pb(b,d),k=c,t[j+2|0]=k;d=d+1|0;if(Kb(b)>>>0>d>>>0){continue}break}}t[b+12|0]=w[b+12|0]&254|t[a|0]&1;c=b;if(w[a|0]&2){d=w[b+15|0];e=Kb(b);d=w[b+12|0]&-5|(e>>>0>=d>>>0)<<2}else{d=w[b+12|0]&-5}t[c+12|0]=d;c=b;e:{f:{if(w[a|0]&4){a=w[b+13|0];if(a>>>0<=w[b+14|0]){break f}}a=w[b+12|0]&-3;break e}d=Kb(b);a=w[b+12|0]&-3|(a>>>0<=d>>>0)<<1}t[c+12|0]=a}jb=f+16|0}function Jv(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0;c=jb-32|0;jb=c;v[113382]=0;g=Q(15,c+24|0,a|0)|0;d=v[113382];v[113382]=0;a:{b:{c:{if((d|0)!=1){d:{if(!w[g|0]){break d}d=v[v[a>>2]-12>>2];v[113382]=0;Ac(c+16|0,a+d|0);d=v[113382];v[113382]=0;e:{f:{g:{if((d|0)!=1){v[113382]=0;d=T(2723,c+16|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break g}Ob(c+16|0);e=Tk(c+8|0,a);f=v[v[a>>2]-12>>2];v[113382]=0;f=a+f|0;h=T(16,f|0)|0;i=v[113382];v[113382]=0;if((i|0)==1){break f}e=v[e>>2];v[113382]=0;b=ea(2725,d|0,e|0,f|0,h|0,b|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break f}v[c+16>>2]=b;if(!Rk(c+16|0)){break d}b=v[v[a>>2]-12>>2];v[113382]=0;R(18,a+b|0,5);b=v[113382];v[113382]=0;if((b|0)!=1){break d}b=V(0)|0;O()|0;break e}b=V(0)|0;O()|0;break e}b=V(0)|0;O()|0;Ob(c+16|0);break e}b=V(0)|0;O()|0}Kf(g);break c}Kf(g);break b}b=V(0)|0;O()|0}_(b|0)|0;b=v[v[a>>2]-12>>2];v[113382]=0;Z(19,a+b|0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$()}jb=c+32|0;return}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function _w(a,b,c,d,e,f){var g=0,h=0,i=0,j=C(0);g=jb-96|0;jb=g;h=a+24|0;Vo(v[h>>2]);t[v[h>>2]+1304512|0]=v[a+52>>2]!=0;v[g+92>>2]=f;v[g+88>>2]=e;v[g+84>>2]=d;v[g+80>>2]=c;c=g+80|0;c=UH(g+32|0,c,VH(c),b);e=v[a+32>>2];j=z[a+48>>2];d=v[c+12>>2];v[g+8>>2]=v[c+8>>2];v[g+12>>2]=d;d=v[c+4>>2];v[g>>2]=v[c>>2];v[g+4>>2]=d;c=jb-16|0;jb=c;d=v[g+12>>2];v[c+8>>2]=v[g+8>>2];v[c+12>>2]=d;d=v[g+4>>2];v[c>>2]=v[g>>2];v[c+4>>2]=d;f=g+48|0;d=f;Nr(d);v[d+8>>2]=e;v[d+4>>2]=0;v[d>>2]=79120;e=v[c+4>>2];v[d+12>>2]=v[c>>2];v[d+16>>2]=e;e=v[c+12>>2];v[d+20>>2]=v[c+8>>2];v[d+24>>2]=e;z[d+28>>2]=j;v[d>>2]=79064;jb=c+16|0;a:{b:{if(!b){break b}while(1){c=v[h>>2];v[g+24>>2]=b;v[g+28>>2]=0;v[113382]=0;v[g+16>>2]=134217727;v[g+20>>2]=0;d=Q(2122,g+24|0,g+16|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break a}d=v[d>>2];v[113382]=0;c=W(2123,c|0,d|0,f|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break a}i=c+i|0;if(!c){break b}b=b-c|0;if(b){continue}break}}if(!(v[a+52>>2]!=1|i)){a=v[h>>2];v[a+480208>>2]=v[a+480208>>2]&-513}jb=g+96|0;return i}a=P()|0;O()|0;S(a|0);L()}function Zw(a,b,c,d,e,f){var g=0,h=0,i=0,j=C(0);g=jb-96|0;jb=g;h=a+24|0;Vo(v[h>>2]);t[v[h>>2]+1304512|0]=v[a+52>>2]!=0;v[g+92>>2]=f;v[g+88>>2]=e;v[g+84>>2]=d;v[g+80>>2]=c;c=g+80|0;c=UH(g+32|0,c,VH(c),b);e=v[a+32>>2];j=z[a+48>>2];d=v[c+12>>2];v[g+8>>2]=v[c+8>>2];v[g+12>>2]=d;d=v[c+4>>2];v[g>>2]=v[c>>2];v[g+4>>2]=d;c=jb-16|0;jb=c;d=v[g+12>>2];v[c+8>>2]=v[g+8>>2];v[c+12>>2]=d;d=v[g+4>>2];v[c>>2]=v[g>>2];v[c+4>>2]=d;f=g+48|0;d=f;Nr(d);v[d+8>>2]=e;v[d+4>>2]=0;v[d>>2]=79216;e=v[c+4>>2];v[d+12>>2]=v[c>>2];v[d+16>>2]=e;e=v[c+12>>2];v[d+20>>2]=v[c+8>>2];v[d+24>>2]=e;z[d+28>>2]=j;v[d>>2]=79168;jb=c+16|0;a:{b:{if(!b){break b}while(1){c=v[h>>2];v[g+24>>2]=b;v[g+28>>2]=0;v[113382]=0;v[g+16>>2]=134217727;v[g+20>>2]=0;d=Q(2122,g+24|0,g+16|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break a}d=v[d>>2];v[113382]=0;c=W(2123,c|0,d|0,f|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break a}i=c+i|0;if(!c){break b}b=b-c|0;if(b){continue}break}}if(!(v[a+52>>2]!=1|i)){a=v[h>>2];v[a+480208>>2]=v[a+480208>>2]&-513}jb=g+96|0;return i}a=P()|0;O()|0;S(a|0);L()}function Ec(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;a:{c=v[b>>2];f=jb-48|0;jb=f;e=v[b+4>>2];d=w[b+8|0];e=e-(((d|0)==1|(d|0)==4)&(e|0)!=0)|0;b=Xb(a);b:{c:{d:{e:{f:{g:{h:{if((d-1&255)>>>0<=1){t[f+32|0]=0;a=Qm(c,c+e|0,f+32|0);v[113382]=0;W(119,b|0,c|0,a|0)|0;a=v[113382];v[113382]=0;if((a|0)!=1){break h}a=P()|0;O()|0;break b}if((d-3&255)>>>0>1){break h}v[113382]=0;W(119,b|0,c|0,c+e|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break g}c=Bd(b);d=tf(b);e=Bd(b);a=jb-32|0;jb=a;v[a+16>>2]=d;v[a+24>>2]=c;v[a+8>>2]=e;if(Jb(a+24|0,a+16|0)){while(1){d=a+8|0;c=a+24|0;e=t[v[c>>2]];t[v[d>>2]]=e?e:32;xg(c);xg(d);if(Jb(c,a+16|0)){continue}break}}jb=a+32|0;v[113382]=0;c=Q(120,f+16|0,b|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break f}v[113382]=0;d=Q(121,f|0,13825)|0;a=v[113382];v[113382]=0;if((a|0)==1){break e}v[113382]=0;U(122,f+32|0,c|0,d|0);a=v[113382];v[113382]=0;if((a|0)==1){break d}a=f+32|0;Gb(b,a);yb(a);yb(d);yb(c)}jb=f+48|0;break a}a=P()|0;O()|0;break b}a=P()|0;O()|0;break b}a=P()|0;O()|0;break c}a=P()|0;O()|0;yb(d)}yb(c)}yb(b);S(a|0);L()}}function bda(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0;f=jb-16|0;jb=f;g=Xb(a+4|0);c=jb-16|0;jb=c;v[113382]=0;v[c+12>>2]=0;e=a+16|0;W(83,e|0,c+12|0,c+8|0)|0;b=v[113382];v[113382]=0;a:{b:{if((b|0)!=1){jb=c+16|0;break b}break a}c=e;t[a+20|0]=0;b=jb-16|0;jb=b;v[113382]=0;v[b+12>>2]=0;e=a+24|0;W(84,e|0,b+12|0,b+8|0)|0;d=v[113382];v[113382]=0;c:{if((d|0)!=1){jb=b+16|0;break c}break a}v[113382]=0;b=da(80)|0;d=v[113382];v[113382]=0;d:{e:{f:{if((d|0)!=1){v[f+8>>2]=b;b=f+8|0;vy(c,ke(b));vf(b);t[a+20|0]=0;b=0;break f}b=Ea(66740,66716)|0;d=O()|0;if((ga(66740)|0)==(d|0)){_(b|0)|0;v[113382]=0;Y(81);a=v[113382];v[113382]=0;if((a|0)==1){b=P()|0;O()|0;v[113382]=0;Y(20);a=v[113382];v[113382]=0;if((a|0)!=1){break e}V(0)|0;O()|0;Ab()}L()}if((ga(66716)|0)!=(d|0)){break e}_(b|0)|0;t[a+20|0]=0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)==1){b=P()|0;O()|0;break e}b=w[a+20|0]}if(b&255){break d}v[113382]=0;Z(82,a|0);b=v[113382];v[113382]=0;if((b|0)!=1){break d}b=P()|0;O()|0}vf(e);vf(c);yb(g);S(b|0);L()}jb=f+16|0;return a|0}V(0)|0;O()|0;Ab();L()}function AG(a,b,c,d,e){var f=C(0),g=C(0),h=0,i=C(0),j=C(0),k=0;if(!(a&3)){if((a|0)>=4){k=a>>>2|0;a=(c<<2)+b|0;d=a+(d<<2)|0;while(1){b=d-4|0;g=z[b>>2];i=z[d>>2];j=z[a>>2];z[a>>2]=i+j;c=a-4|0;f=z[c>>2];z[c>>2]=z[b>>2]+f;i=C(j-i);f=C(f-g);z[d>>2]=C(z[e>>2]*i)-C(z[e+4>>2]*f);z[b>>2]=C(z[e+4>>2]*i)+C(z[e>>2]*f);b=d-12|0;i=z[b>>2];c=a-8|0;f=z[c>>2];h=c;c=d-8|0;j=z[c>>2];z[h>>2]=j+f;h=a-12|0;g=z[h>>2];z[h>>2]=z[b>>2]+g;f=C(f-j);g=C(g-i);z[c>>2]=C(z[e+32>>2]*f)-C(z[e+36>>2]*g);z[b>>2]=C(z[e+36>>2]*f)+C(z[e+32>>2]*g);b=d-20|0;i=z[b>>2];c=a-16|0;f=z[c>>2];h=c;c=d-16|0;j=z[c>>2];z[h>>2]=j+f;h=a-20|0;g=z[h>>2];z[h>>2]=z[b>>2]+g;f=C(f-j);g=C(g-i);z[c>>2]=C(z[e+64>>2]*f)-C(z[e+68>>2]*g);z[b>>2]=C(z[e+68>>2]*f)+C(z[e+64>>2]*g);b=d-28|0;i=z[b>>2];c=a-24|0;f=z[c>>2];h=c;c=d-24|0;j=z[c>>2];z[h>>2]=j+f;h=a-28|0;g=z[h>>2];z[h>>2]=z[b>>2]+g;f=C(f-j);g=C(g-i);z[c>>2]=C(z[e+96>>2]*f)-C(z[e+100>>2]*g);z[b>>2]=C(z[e+100>>2]*f)+C(z[e+96>>2]*g);d=d-32|0;a=a-32|0;e=e+128|0;b=k>>>0>1;k=k-1|0;if(b){continue}break}}return}ia(11944,9203,2423,5235);L()}function Vga(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;g=jb-144|0;jb=g;cz(a);a:{b:{if(!Ef(a,64)){break b}c:{d:{e:{if(!yk(a,60)){break e}if(!QO(a,10057)){break e}b=15;break d}cz(a);if(!Ef(a,128)){break b}b=0;d=1;if(!yk(a,124)){break d}e=31;if(QO(a,11366)){break c}}e=b;if(d){break a}}cz(a);b=0;while(1){c=0;d=jb-16|0;jb=d;if(NO(a,d+8|0)){c=d+8|0;c=w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24);c=c<<24|c<<8&16711680|(c>>>8&65280|c>>>24)}jb=d+16|0;if(c>>>0>131072){break a}b=b+1|0;if((b&65535)>>>0<e>>>0){continue}break}Tc(a,4);if(!Ef(a,2)){break b}d=0;h=jb-16|0;jb=h;c=jb-16|0;jb=c;f=c+8|0;Sk(f,h+8|0);b=a;j=Hb(f);f=hd(a,$b(c,f));if((j|0)==(f|0)){Tc(b,Hb(c+8|0))}jb=c+16|0;jb=h+16|0;if((f|0)==(j|0)){b=h+8|0;b=w[b|0]|w[b+1|0]<<8;d=b<<8|b>>>8}if((d&65535)>>>0<178){break a}i=-1;b=B(e,30);if(!Ef(a,b)){break a}Tc(a,b);b=jb-16|0;jb=b;e=b+8|0;d=g+8|0;VP(e,d);c=Hb(e);e=hd(a,$b(b,e));if((c|0)==(e|0)){Tc(a,Hb(b+8|0))}jb=b+16|0;a=(c|0)==(e|0);if(!a){WP(d)}if(!a){break a}i=PO(g+8|0);break a}i=-1}jb=g+144|0;return i|0}function gL(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=jb-16|0;jb=d;a:{b:{switch(v[a+480224>>2]-1|0){default:c=v[a+24620>>2];v[d+12>>2]=1;v[d+8>>2]=v[b+44>>2]<<1;c=qma(c,c>>31,5e4,0);f=mb;b=v[Vc(d+12|0,d+8|0)>>2];c=zc(rma(c,f,b,b>>31),mb);break a;case 0:c=v[a+24620>>2];v[d+12>>2]=1;v[d+8>>2]=v[b+44>>2];c=qma(c,c>>31,1e4,0);f=mb;b=v[Vc(d+12|0,d+8|0)>>2];c=zc(rma(c,f,b,b>>31),mb);break a;case 1:break b}}e=+y[a+24620>>2]*60/(+y[b+44>>2]*1e-4*(+(qma(v[b+32>>2],0,v[b+40>>2],0)>>>0)+ +(mb>>>0)*4294967296));c:{d:{c=a+484344|0;if(!jg(c,x[b+60>>1])){break d}if(!(id(Zb(c,x[b+60>>1])+24|0)^1)){break d}c=Zb(c,x[b+60>>1])+24|0;break c}c=a+480248|0}if(!id(c)){e=e*5.960464477539063e-8*+y[Pb(c,y[b+48>>2]%(Kb(c)>>>0)|0)>>2]}e:{if(D(e)<2147483648){c=~~e;break e}c=-2147483648}e=e-+(c>>>0)+A[b+8>>3];A[b+8>>3]=e;if(!(e<1)){A[b+8>>3]=e+-1;c=c+1|0;break a}if(A[a+1074384>>3]>-1){break a}A[b+8>>3]=e+1;c=c-1|0}b=qma(v[a+480244>>2],0,c,0)+32768|0;a=mb;a=b>>>0<32768?a+1|0:a;a=dd((a&65535)<<16|b>>>16,a>>>16|0);jb=d+16|0;return(a?a:1)|0}function J$(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0;g=jb-32|0;jb=g;v[g+24>>2]=b;a:{b:{if(!(v[d+4>>2]&1)){v[g>>2]=-1;b=nb[v[v[a>>2]+16>>2]](a,b,c,d,e,g)|0;v[g+24>>2]=b;c:{switch(v[g>>2]){case 1:t[f|0]=1;break a;case 0:break b;default:break c}}t[f|0]=1;v[e>>2]=4;break a}Ac(g,d);v[113382]=0;b=T(2339,g|0)|0;a=v[113382];v[113382]=0;d:{e:{f:{g:{if((a|0)!=1){Ob(g);Ac(g,d);v[113382]=0;a=T(2340,g|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break g}Ob(g);v[113382]=0;R(2341,g|0,a|0);d=v[113382];v[113382]=0;if((d|0)==1){b=P()|0;O()|0;break d}v[113382]=0;R(2342,g|12,a|0);a=v[113382];v[113382]=0;if((a|0)==1){break f}v[113382]=0;d=g+24|0;a=ua(2343,d|0,c|0,g|0,d|0,b|0,e|0,1)|0;b=v[113382];v[113382]=0;if((b|0)==1){break e}t[f|0]=(a|0)==(g|0);b=v[g+24>>2];while(1){d=Jc(d-12|0);if((g|0)!=(d|0)){continue}break}break a}b=P()|0;O()|0;Ob(g);break d}b=P()|0;O()|0;Ob(g);break d}b=P()|0;O()|0;Jc(g);break d}b=P()|0;O()|0;while(1){d=Jc(d-12|0);if((g|0)!=(d|0)){continue}break}}S(b|0);L()}t[f|0]=0}jb=g+32|0;return b|0}function Hfa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=jb-16|0;jb=h;e=v[a+48>>2];l=v[a+40>>2];m=v[a+36>>2];b=v[a+44>>2];o=v[a+16>>2];f=v[a+4>>2];i=v[a>>2];v[h+8>>2]=i;v[h+12>>2]=f;j=v[a+12>>2];v[h>>2]=v[a+8>>2];v[h+4>>2]=j;a:{if(d){while(1){k=u[(f<<1)+o>>1];g=v[a+60>>2];f=Yb(b,-16777216,16776704);n=v[a+64>>2];i=Yb(e,-16777216,16776704);p=v[a+72>>2];q=v[a+32>>2];r=v[c>>2];j=k<<8;e=j;e=qma(g,g>>31,e,e>>31);k=mb;g=qma(n,n>>31,f,f>>31);f=g+e|0;e=mb+k|0;e=f>>>0<g>>>0?e+1|0:e;g=f;f=v[a+68>>2];i=qma(f,f>>31,i,i>>31);f=g+i|0;e=mb+e|0;e=f>>>0<i>>>0?e+1|0:e;f=f+8388608|0;e=f>>>0<8388608?e+1|0:e;f=(e&16777215)<<8|f>>>24;e=(f|0)/256|0;m=v[a+28>>2]+m|0;k=m>>12;v[c>>2]=B(e,k)+r;l=l+q|0;g=l>>12;v[c+4>>2]=v[c+4>>2]+B(e,g);j=f-(j&p)|0;Sb(h+8|0,h);d=d-1|0;if(d){c=c+8|0;f=v[h+12>>2];e=b;b=j;continue}break}i=v[h+8>>2];f=v[h+12>>2];e=b;break a}g=l>>12;k=m>>12;j=b}v[a+40>>2]=l;v[a+20>>2]=k;v[a+36>>2]=m;v[a+48>>2]=e;v[a+44>>2]=j;v[a+24>>2]=g;v[a>>2]=i;v[a+4>>2]=f;jb=h+16|0}function b0(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0;g=jb-32|0;jb=g;v[g+24>>2]=b;a:{b:{if(!(v[d+4>>2]&1)){v[g>>2]=-1;b=nb[v[v[a>>2]+16>>2]](a,b,c,d,e,g)|0;v[g+24>>2]=b;c:{switch(v[g>>2]){case 1:t[f|0]=1;break a;case 0:break b;default:break c}}t[f|0]=1;v[e>>2]=4;break a}Ac(g,d);v[113382]=0;b=T(21,g|0)|0;a=v[113382];v[113382]=0;d:{e:{f:{g:{if((a|0)!=1){Ob(g);Ac(g,d);v[113382]=0;a=T(2306,g|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break g}Ob(g);v[113382]=0;R(2307,g|0,a|0);d=v[113382];v[113382]=0;if((d|0)==1){b=P()|0;O()|0;break d}v[113382]=0;R(2308,g|12,a|0);a=v[113382];v[113382]=0;if((a|0)==1){break f}v[113382]=0;d=g+24|0;a=ua(2309,d|0,c|0,g|0,d|0,b|0,e|0,1)|0;b=v[113382];v[113382]=0;if((b|0)==1){break e}t[f|0]=(a|0)==(g|0);b=v[g+24>>2];while(1){d=yb(d-12|0);if((g|0)!=(d|0)){continue}break}break a}b=P()|0;O()|0;Ob(g);break d}b=P()|0;O()|0;Ob(g);break d}b=P()|0;O()|0;yb(g);break d}b=P()|0;O()|0;while(1){d=yb(d-12|0);if((g|0)!=(d|0)){continue}break}}S(b|0);L()}t[f|0]=0}jb=g+32|0;return b|0}function Ifa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=jb-16|0;jb=h;e=v[a+48>>2];l=v[a+40>>2];m=v[a+36>>2];b=v[a+44>>2];o=v[a+16>>2];f=v[a+4>>2];i=v[a>>2];v[h+8>>2]=i;v[h+12>>2]=f;j=v[a+12>>2];v[h>>2]=v[a+8>>2];v[h+4>>2]=j;a:{if(d){while(1){k=t[f+o|0];g=v[a+60>>2];f=Yb(b,-16777216,16776704);n=v[a+64>>2];i=Yb(e,-16777216,16776704);p=v[a+72>>2];q=v[a+32>>2];r=v[c>>2];j=k<<16;e=j;e=qma(g,g>>31,e,e>>31);k=mb;g=qma(n,n>>31,f,f>>31);f=g+e|0;e=mb+k|0;e=f>>>0<g>>>0?e+1|0:e;g=f;f=v[a+68>>2];i=qma(f,f>>31,i,i>>31);f=g+i|0;e=mb+e|0;e=f>>>0<i>>>0?e+1|0:e;f=f+8388608|0;e=f>>>0<8388608?e+1|0:e;f=(e&16777215)<<8|f>>>24;e=(f|0)/256|0;m=v[a+28>>2]+m|0;k=m>>12;v[c>>2]=B(e,k)+r;l=l+q|0;g=l>>12;v[c+4>>2]=v[c+4>>2]+B(e,g);j=f-(j&p)|0;Sb(h+8|0,h);d=d-1|0;if(d){c=c+8|0;f=v[h+12>>2];e=b;b=j;continue}break}i=v[h+8>>2];f=v[h+12>>2];e=b;break a}g=l>>12;k=m>>12;j=b}v[a+40>>2]=l;v[a+20>>2]=k;v[a+36>>2]=m;v[a+48>>2]=e;v[a+44>>2]=j;v[a+24>>2]=g;v[a>>2]=i;v[a+4>>2]=f;jb=h+16|0}function UY(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0;a=c;while(1){a:{if(e>>>0<=i>>>0|a>>>0>=d>>>0){break a}g=t[a|0];b=g&255;b:{if((g|0)>=0){g=1;if(b>>>0<=1114111){break b}break a}if(b>>>0<194){break a}if(b>>>0<=223){if((d-a|0)<2){break a}f=w[a+1|0];if((f&192)!=128){break a}g=2;if((f&63|b<<6&1984)>>>0<=1114111){break b}break a}c:{d:{if(b>>>0<=239){if((d-a|0)<3){break a}h=w[a+2|0];f=w[a+1|0];if((b|0)==237){break d}if((b|0)==224){if((f&224)==160){break c}break a}if((f&192)!=128){break a}break c}if((d-a|0)<4|b>>>0>244){break a}h=w[a+3|0];j=w[a+2|0];f=w[a+1|0];e:{f:{switch(b-240|0){case 0:if((f+112&255)>>>0<48){break e}break a;case 4:if((f&240)==128){break e}break a;default:break f}}if((f&192)!=128){break a}}if((j&192)!=128|(h&192)!=128){break a}g=4;if((h&63|(j<<6&4032|(b<<18&1835008|(f&63)<<12)))>>>0>1114111){break a}break b}if((f&224)!=128){break a}}if((h&192)!=128){break a}g=3;if((h&63|(b<<12&61440|(f&63)<<6))>>>0>1114111){break a}}i=i+1|0;a=a+g|0;continue}break}return a-c|0}function sw(a,b,c,d){var e=0,f=0,g=0,h=0,i=0;g=jb-32|0;jb=g;e=d&2147483647;h=e;f=e-1006698496|0;e=e-1140785152|0;i=c;a:{if((f|0)==(e|0)&c>>>0>c>>>0|e>>>0>f>>>0){e=d<<4|c>>>28;c=c<<4|b>>>28;b=b&268435455;h=b;if((b|0)==134217728&(a|0)!=0|b>>>0>134217728){e=e+1073741824|0;a=c+1|0;e=a?e:e+1|0;f=a;break a}f=c;e=e+1073741824|0;if(a|h^134217728){break a}b=c&1;a=b+f|0;e=a>>>0<b>>>0?e+1|0:e;f=a;break a}if(!(!i&(h|0)==2147418112?!(a|b):h>>>0<2147418112)){f=c;c=d<<4|c>>>28;f=f<<4|b>>>28;e=c&524287|2146959360;break a}f=0;e=2146435072;if(h>>>0>1140785151){break a}e=0;h=h>>>16|0;if(h>>>0<15249){break a}e=d&65535|65536;ef(g+16|0,a,b,c,e,h-15233|0);kl(g,a,b,c,e,15361-h|0);e=v[g+4>>2];h=e;a=v[g+8>>2];c=v[g+12>>2]<<4|a>>>28;f=a<<4|e>>>28;e=c;a=h&268435455;c=a;b=v[g>>2]|((v[g+16>>2]|v[g+24>>2])!=0|(v[g+20>>2]|v[g+28>>2])!=0);if((a|0)==134217728&(b|0)!=0|a>>>0>134217728){a=f+1|0;e=a?e:e+1|0;f=a;break a}if(b|c^134217728){break a}a=f+(f&1)|0;e=a>>>0<f>>>0?e+1|0:e;f=a}jb=g+32|0;l(0,f|0);l(1,d&-2147483648|e);return+n()}function Tca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;f=jb-32|0;jb=f;v[f+24>>2]=b;b=v[a>>2];n=f,o=ac(a),v[n>>2]=o;b=b+(Yp(f+24|0,f)<<1)|0;a:{g=zy(c,d);b:{if((g|0)<=0){break b}e=v[zb(a)>>2];h=v[a+4>>2];if((g|0)<=e-h>>1){v[f>>2]=d;e=h-b|0;i=e>>1;if((i|0)<(g|0)){v[f>>2]=c;v[f>>2]=v[f>>2]+(i<<1);vN(a,v[f>>2],d,g-i|0);if((e|0)<=0){break b}}k=jb-16|0;jb=k;m=h;i=b;e=a;l=v[a+4>>2];a=(l-((g<<1)+b|0)|0)+b|0;j=Uh(k,e,h-a>>1);c:{d:{if(a>>>0<h>>>0){g=v[j+4>>2];d=a;while(1){h=zb(e);v[113382]=0;U(1212,h|0,g|0,d|0);h=v[113382];v[113382]=0;if((h|0)==1){break d}g=g+2|0;v[j+4>>2]=g;d=d+2|0;if(m>>>0>d>>>0){continue}break}}Mb(j);Gp(i,a,l);jb=k+16|0;break c}a=P()|0;O()|0;Mb(j);S(a|0);L()}kf(c,v[f>>2],b);break b}e=zb(a);e=Sn(f,Qi(a,oc(a)+g|0),b-v[a>>2]>>1,e);v[113382]=0;U(1210,e|0,c|0,d|0);c=v[113382];v[113382]=0;if((c|0)==1){break a}v[113382]=0;b=W(1211,a|0,e|0,b|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break a}kC(e)}a=Pg(b);jb=f+32|0;return a|0}a=P()|0;O()|0;kC(e);S(a|0);L()}function NH(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;d=jb-32|0;jb=d;a:{b:{c:{d:{e:{f:{g:{if(mi(a)){Ho(d+24|0);break g}c=d+8|0;Nm(c,a);v[113382]=0;c=T(2142,c|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break f}v[d+24>>2]=c;qf(d+8|0)}if(mi(a)){c=a+36|0}else{c=v[d+24>>2]}if((b|0)==-1){f=4194304;e=0;break d}if((b|0)>=0){e=b;if((Cd(c)|0)>(b|0)){break d}}b=ba(8)|0;v[113382]=0;c=Q(121,d+8|0,6992)|0;a=v[113382];v[113382]=0;if((a|0)==1){break e}nc(b,c);v[113382]=0;U(1978,b|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break a}a=P()|0;O()|0;yb(c);break c}a=P()|0;O()|0;qf(d+8|0);break b}a=P()|0;O()|0;ca(b|0);break c}v[a+8>>2]=b;b=a+24|0;g=v[b>>2];v[g+480208>>2]=v[g+480208>>2]&-4194305|f;b=v[b>>2];f=w[Qc(c,e)+16|0];v[113382]=0;R(449,b+484360|0,f|0);b=v[113382];v[113382]=0;h:{if((b|0)==1){break h}b=v[Qc(c,e)+12>>2];c=v[Qc(c,e)+8>>2];v[113382]=0;+oa(1994,a|0,b|0,c|0);b=v[113382];v[113382]=0;if((b|0)==1){break h}v[a+16>>2]=0;v[a+20>>2]=0;hk(d+24|0);jb=d+32|0;return}a=P()|0;O()|0}hk(d+24|0)}S(a|0)}L()}function pr(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0;m=jb-16|0;jb=m;v[m+12>>2]=a;a:{b:{if((a|0)==(f|0)){if(!w[b|0]){break b}a=0;t[b|0]=0;b=v[e>>2];v[e>>2]=b+1;t[b|0]=46;if(!Db(h)){break a}b=v[j>>2];if((b-i|0)>159){break a}c=v[k>>2];v[j>>2]=b+4;v[b>>2]=c;break a}c:{if((a|0)!=(g|0)){break c}if(!Db(h)){break c}if(!w[b|0]){break b}a=0;b=v[j>>2];if((b-i|0)>159){break a}a=v[k>>2];v[j>>2]=b+4;v[b>>2]=a;a=0;v[k>>2]=0;break a}a=-1;f=Vv(l,l+128|0,m+12|0)-l|0;if((f|0)>124){break a}g=w[(f>>2)+59248|0];d:{e:{a=f&-5;if((a|0)!=88){if((a|0)!=96){break e}b=v[e>>2];if((b|0)!=(d|0)){a=-1;if((w[b-1|0]&95)!=(w[c|0]&127)){break a}}v[e>>2]=b+1;t[b|0]=g;a=0;break a}t[c|0]=80;break d}a=t[c|0];if((a|0)!=(g&95)){break d}t[c|0]=a|128;if(!w[b|0]){break d}t[b|0]=0;if(!Db(h)){break d}a=v[j>>2];if((a-i|0)>159){break d}b=v[k>>2];v[j>>2]=a+4;v[a>>2]=b}a=v[e>>2];v[e>>2]=a+1;t[a|0]=g;a=0;if((f|0)>84){break a}v[k>>2]=v[k>>2]+1;break a}a=-1}jb=m+16|0;return a|0}function Co(a,b,c,d,e,f){var g=C(0),h=C(0),i=0,j=C(0),k=C(0),l=0;if((a|0)>=4){l=a>>>2|0;a=(c<<2)+b|0;d=a+(d<<2)|0;b=f<<2;while(1){c=d-4|0;h=z[c>>2];j=z[d>>2];k=z[a>>2];z[a>>2]=j+k;f=a-4|0;g=z[f>>2];z[f>>2]=z[c>>2]+g;j=C(k-j);g=C(g-h);z[d>>2]=C(z[e>>2]*j)-C(z[e+4>>2]*g);z[c>>2]=C(z[e+4>>2]*j)+C(z[e>>2]*g);f=d-12|0;j=z[f>>2];c=a-8|0;g=z[c>>2];i=c;c=d-8|0;k=z[c>>2];z[i>>2]=k+g;i=a-12|0;h=z[i>>2];z[i>>2]=z[f>>2]+h;i=c;c=b+e|0;g=C(g-k);h=C(h-j);z[i>>2]=C(z[c>>2]*g)-C(z[c+4>>2]*h);z[f>>2]=C(z[c+4>>2]*g)+C(z[c>>2]*h);e=d-20|0;j=z[e>>2];f=a-16|0;g=z[f>>2];i=f;f=d-16|0;k=z[f>>2];z[i>>2]=k+g;i=a-20|0;h=z[i>>2];z[i>>2]=z[e>>2]+h;c=b+c|0;g=C(g-k);h=C(h-j);z[f>>2]=C(z[c>>2]*g)-C(z[c+4>>2]*h);z[e>>2]=C(z[c+4>>2]*g)+C(z[c>>2]*h);e=d-28|0;j=z[e>>2];f=a-24|0;g=z[f>>2];i=f;f=d-24|0;k=z[f>>2];z[i>>2]=k+g;i=a-28|0;h=z[i>>2];z[i>>2]=z[e>>2]+h;c=b+c|0;g=C(g-k);h=C(h-j);z[f>>2]=C(z[c>>2]*g)-C(z[c+4>>2]*h);z[e>>2]=C(z[c+4>>2]*g)+C(z[c>>2]*h);e=b+c|0;d=d-32|0;a=a-32|0;c=l>>>0>1;l=l-1|0;if(c){continue}break}}}function XY(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;a=c;while(1){a:{if(e>>>0<=g>>>0|a>>>0>=d>>>0){break a}b=w[a|0];if(b>>>0>1114111){break a}f=a+1|0;b:{if(b<<24>>24>=0){break b}if(b>>>0<194){break a}if(b>>>0<=223){if((d-a|0)<2){break a}f=w[a+1|0];if((f&192)!=128|(f&63|b<<6&1984)>>>0>1114111){break a}f=a+2|0;break b}c:{d:{if(b>>>0<=239){if((d-a|0)<3){break a}h=w[a+2|0];f=w[a+1|0];if((b|0)==237){break d}if((b|0)==224){if((f&224)==160){break c}break a}if((f&192)!=128){break a}break c}if((d-a|0)<4|b>>>0>244|e-g>>>0<2){break a}h=w[a+3|0];i=w[a+2|0];f=w[a+1|0];e:{f:{switch(b-240|0){case 0:if((f+112&255)>>>0<48){break e}break a;case 4:if((f&240)==128){break e}break a;default:break f}}if((f&192)!=128){break a}}if((i&192)!=128|(h&192)!=128|(h&63|(i<<6&4032|(b<<18&1835008|(f&63)<<12)))>>>0>1114111){break a}g=g+1|0;f=a+4|0;break b}if((f&224)!=128){break a}}if((h&192)!=128|(h&63|(b<<12&61440|(f&63)<<6))>>>0>1114111){break a}f=a+3|0}a=f;g=g+1|0;continue}break}return a-c|0}function rea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=jb-48|0;jb=e;i=v[a+16>>2];f=Uf(e+16|0);v[f+8>>2]=a+112;v[f+16>>2]=v[a+128>>2];m=f,n=Pf(b+327720|0,v[b+20>>2],(v[a+88>>2]&16384)>>>14|0),v[m+12>>2]=n;b=v[f+16>>2];if(b){m=f,n=Tf(a+8|0,b),v[m>>2]=n;v[f+4>>2]=mb}j=v[a+24>>2];k=v[a+20>>2];b=v[a+4>>2];h=v[a>>2];v[e+8>>2]=h;v[e+12>>2]=b;g=v[a+12>>2];v[e>>2]=v[a+8>>2];v[e+4>>2]=g;if(d){while(1){g=0;v[e+40>>2]=h;v[e+44>>2]=l;h=(b<<1)+i|0;a:{b=v[f+16>>2];if((b|0)<=0){break a}while(1){yd(v[f+8>>2],u[(g<<1)+h>>1]/4<<16>>16);xd(v[f+8>>2],4);Sb(e+40|0,f);if((b|0)<2){break a}b=b-1|0;g=v[e+44>>2];continue}}d=d-1|0;b=v[f+8>>2];Sb(b,b+8|0);b=v[f+8>>2];g=v[b+4>>2];if(g){yd(b,u[h+(v[e+44>>2]<<1)>>1]/4<<16>>16);xd(v[f+8>>2],g);b=v[f+8>>2];g=v[b>>2];v[b>>2]=g;v[b+4>>2]=0}b=Of(b,v[f+12>>2]);v[c>>2]=v[c>>2]+B(b,k);v[c+4>>2]=v[c+4>>2]+B(b,j);Sb(e+8|0,e);if(d){c=c+8|0;h=v[e+8>>2];b=v[e+12>>2];continue}break}h=v[e+8>>2];b=v[e+12>>2]}v[a>>2]=h;v[a+4>>2]=b;jb=e+48|0}function fL(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;e=jb-560|0;jb=e;u[e+558>>1]=b;a:{b:{if((b-1&65535)>>>0>254){break b}d=((b<<2)+a|0)+900380|0;f=v[d>>2];c:{if(f){c=WN(e,c);d=v[c+4>>2];b=f;v[b>>2]=v[c>>2];v[b+4>>2]=d;d=w[c+11|0]|w[c+12|0]<<8|(w[c+13|0]<<16|w[c+14|0]<<24);g=w[c+7|0]|w[c+8|0]<<8|(w[c+9|0]<<16|w[c+10|0]<<24);t[b+7|0]=g;t[b+8|0]=g>>>8;t[b+9|0]=g>>>16;t[b+10|0]=g>>>24;t[b+11|0]=d;t[b+12|0]=d>>>8;t[b+13|0]=d>>>16;t[b+14|0]=d>>>24;t[b+15|0]=w[c+15|0];d=v[c+44>>2];v[b+40>>2]=v[c+40>>2];v[b+44>>2]=d;d=v[c+36>>2];v[b+32>>2]=v[c+32>>2];v[b+36>>2]=d;d=v[c+28>>2];v[b+24>>2]=v[c+24>>2];v[b+28>>2]=d;d=v[c+20>>2];v[b+16>>2]=v[c+16>>2];v[b+20>>2]=d;Xx(b+48|0,c+48|0);Xx(b+68|0,c+68|0);Xx(b+88|0,c+88|0);lc(b+108|0,c+108|0,448);vt(c);break c}b=Jg(556);if(!b){f=0;v[d>>2]=0;break b}v[113382]=0;f=Q(1403,b|0,c|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break a}v[d>>2]=b}h=a,i=x[Ri(a+480192|0,e+558|0)>>1],u[h+480192>>1]=i}jb=e+560|0;return f|0}a=P()|0;O()|0;Wb(b);S(a|0);L()}function JV(a){a=a|0;var b=0,c=0,d=0,e=0;c=jb+-64|0;jb=c;a=bd(a);v[113382]=0;b=da(198)|0;d=v[113382];v[113382]=0;a:{b:{if((d|0)==1){break b}c:{d:{if(!b){break d}v[113382]=0;d=Q(2,c+32|0,5137)|0;b=v[113382];v[113382]=0;if((b|0)==1){break c}v[113382]=0;b=da(198)|0;e=v[113382];v[113382]=0;e:{f:{g:{h:{if((e|0)==1){break h}v[113382]=0;v[c+12>>2]=b;R(204,c+16|0,c+12|0);b=v[113382];v[113382]=0;if((b|0)==1){break h}v[113382]=0;U(3,c+48|0,d|0,c+16|0);b=v[113382];v[113382]=0;if((b|0)==1){break g}b=c+48|0;Gb(a,b);yb(b);yb(c+16|0);yb(d);v[113382]=0;b=da(200)|0;d=v[113382];v[113382]=0;if((d|0)==1){break b}if(!b){break e}v[113382]=0;Q(205,a|0,13430)|0;b=v[113382];v[113382]=0;if((b|0)!=1){break e}break b}b=P()|0;O()|0;break f}b=P()|0;O()|0;yb(c+16|0)}yb(d);break a}v[113382]=0;b=da(199)|0;d=v[113382];v[113382]=0;if((d|0)==1){break b}if(!b){break d}v[113382]=0;Q(205,a|0,12899)|0;b=v[113382];v[113382]=0;if((b|0)==1){break b}}jb=c- -64|0;return}b=P()|0;O()|0;break a}b=P()|0;O()|0}yb(a);S(b|0);L()}function sr(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0;m=jb-16|0;jb=m;t[m+15|0]=a;a:{b:{if((a|0)==(f|0)){if(!w[b|0]){break b}a=0;t[b|0]=0;b=v[e>>2];v[e>>2]=b+1;t[b|0]=46;if(!Db(h)){break a}b=v[j>>2];if((b-i|0)>159){break a}c=v[k>>2];v[j>>2]=b+4;v[b>>2]=c;break a}c:{if((a|0)!=(g|0)){break c}if(!Db(h)){break c}if(!w[b|0]){break b}a=0;b=v[j>>2];if((b-i|0)>159){break a}a=v[k>>2];v[j>>2]=b+4;v[b>>2]=a;a=0;v[k>>2]=0;break a}a=-1;f=Qm(l,l+32|0,m+15|0)-l|0;if((f|0)>31){break a}g=w[f+59248|0];d:{e:{switch((f&-2)-22|0){case 2:b=v[e>>2];if((b|0)!=(d|0)&(w[b-1|0]&95)!=(w[c|0]&127)){break a}v[e>>2]=b+1;t[b|0]=g;a=0;break a;case 0:t[c|0]=80;break d;default:break e}}a=t[c|0];if((a|0)!=(g&95)){break d}t[c|0]=a|128;if(!w[b|0]){break d}t[b|0]=0;if(!Db(h)){break d}a=v[j>>2];if((a-i|0)>159){break d}b=v[k>>2];v[j>>2]=a+4;v[a>>2]=b}a=v[e>>2];v[e>>2]=a+1;t[a|0]=g;a=0;if((f|0)>21){break a}v[k>>2]=v[k>>2]+1;break a}a=-1}jb=m+16|0;return a|0}function paa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;e=jb-32|0;jb=e;f=Xb(e+16|0);a:{b:{c:{if(c>>>0<=63){break c}v[113382]=0;c=T(305,b|0)|0;d=v[113382];v[113382]=0;d:{if((d|0)!=1){v[e+12>>2]=c;if((c|0)>0){break d}v[113382]=0;Q(121,a|0,17540)|0;a=v[113382];v[113382]=0;if((a|0)!=1){break b}}break a}v[113382]=0;c=T(296,b|0)|0;d=v[113382];v[113382]=0;e:{if((d|0)==1){break e}v[113382]=0;c=T(819,c|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break e}v[113382]=0;v[e+8>>2]=c;c=Q(420,e+12|0,e+8|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break e}c=v[c>>2];v[113382]=0;R(111,f|0,c|0);c=v[113382];v[113382]=0;if((c|0)!=1){break c}}break a}f:{while(1){g:{v[113382]=0;c=T(409,b|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break g}if(!c){break f}v[113382]=0;W(1499,f|0,1,((c-65&255)>>>0<26?c+32|0:c)<<24>>24)|0;c=v[113382];v[113382]=0;if((c|0)!=1){continue}}break}break a}v[113382]=0;Q(304,b|0,4)|0;b=v[113382];v[113382]=0;if((b|0)==1){break a}rd(a,f)}yb(f);jb=e+32|0;return}a=P()|0;O()|0;yb(f);S(a|0);L()}function Maa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0;d=jb-32|0;jb=d;e=d;b=jb-32|0;jb=b;z[b+16>>2]=2;u[b+22>>1]=12;v[b+12>>2]=15;c=Pe(64);v[113382]=0;f=T(1395,c|0)|0;g=v[113382];v[113382]=0;a:{b:{c:{if((g|0)!=1){c=Zx(b+8|0,f);f=v[c>>2];v[113382]=0;R(1396,f|0,a|0);a=v[113382];v[113382]=0;if((a|0)==1){break c}a=v[c>>2];v[113382]=0;a=W(1397,a|0,b+22|0,b+16|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break c}d:{if(!a){Yx(b+24|0);break d}a=v[c>>2];v[113382]=0;R(1398,a|0,b+12|0);a=v[113382];v[113382]=0;if((a|0)==1){break c}Jp(b+24|0,c)}gg(c);jb=b+32|0;a=v[b+24>>2];break a}a=P()|0;O()|0;Wb(c);break b}a=P()|0;O()|0;gg(c)}S(a|0);L()}v[e+24>>2]=a;a=0;e:{f:{g:{while(1){b=v[d+24>>2];v[113382]=0;u[d+22>>1]=a;e=Q(2,d+8|0,(a<<2)+26016|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break g}v[113382]=0;U(1394,b|0,d+22|0,e|0);b=v[113382];v[113382]=0;if((b|0)==1){break f}yb(e);a=a+1|0;if((a|0)!=12){continue}break}jb=d+32|0;return v[d+24>>2]}a=P()|0;O()|0;break e}a=P()|0;O()|0;yb(e)}gg(d+24|0);S(a|0);L()}function dM(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0;h=jb-16|0;jb=h;f=B(b,896)+a|0;a:{if(c){e=h+8|0;Fb(e,a+1074312|0,90);if(!Cb(e)){t[(B(b,896)+a|0)+1075815|0]=c}t[(B(b,896)+a|0)+1075816|0]=c;break a}c=w[f+1075816|0]}e=f+1074984|0;g=c&255;j=0-g|0;i=d?i:!(v[a+480180>>2]&204473357);_L(a,b,j,i);b:{c:{if(v[a+480180>>2]!=16777216){break c}f=v[(B(b,896)+a|0)+1075640>>2];if(!f|!v[f+44>>2]){break c}b=c&255;if(!(b>>>0<240|d)){ZL(a,e,240-g|0);break b}if(!(b>>>0<224|d)){YL(e,224-g|0);break b}XL(e,j);break b}if(v[a+480180>>2]==268435456){v[(B(b,896)+a|0)+1075692>>2]=65535}if((c&255)>>>0>223&i){d:{d=g&15;if(!d){break d}c=c&240;if((c|0)!=224){if((c|0)!=240){break d}UL(a,e,d);break b}if(v[a+480180>>2]==524288){break d}aM(a,e,d);break b}if(v[a+480180>>2]!=524288){break b}}e:{if(!(t[(B(b,896)+a|0)+1075856|0]&1)){break e}if(v[a+1074416>>2]==1){b=h+8|0;Fb(b,a+1074312|0,6);if(Cb(b)){break e}}if(v[a+480180>>2]&32832){break e}if(!(v[a+480208>>2]&2)|v[a+480180>>2]!=8){break b}}VL(a,e,g<<2)}jb=h+16|0}function wfa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0;h=jb-16|0;jb=h;f=v[a+48>>2];m=v[a+24>>2];n=v[a+20>>2];b=v[a+44>>2];o=v[a+16>>2];g=v[a+4>>2];i=v[a>>2];v[h+8>>2]=i;v[h+12>>2]=g;e=v[a+12>>2];v[h>>2]=v[a+8>>2];v[h+4>>2]=e;a:{if(!d){e=b;b=f;break a}while(1){e=g+o|0;p=t[e+1|0];e=t[e|0];g=v[a+60>>2];q=g;r=g>>31;g=Yb(b,-16777216,16776704);j=v[a+64>>2];f=Yb(f,-16777216,16776704);s=v[a+72>>2];u=v[c>>2];g=qma(j,j>>31,g,g>>31);j=mb;k=g;g=v[a+68>>2];l=qma(g,g>>31,f,f>>31);g=k+l|0;f=mb+j|0;f=g>>>0<l>>>0?f+1|0:f;k=g;g=((B(p-e|0,i>>>10&4194048)|0)/16384|0)+(e<<8)<<8;e=g;i=qma(q,r,e,e>>31);e=k+i|0;f=mb+f|0;f=e>>>0<i>>>0?f+1|0:f;e=e+8388608|0;f=e>>>0<8388608?f+1|0:f;f=(f&16777215)<<8|e>>>24;e=(f|0)/256|0;v[c>>2]=B(e,n)+u;v[c+4>>2]=v[c+4>>2]+B(e,m);e=f-(g&s)|0;Sb(h+8|0,h);d=d-1|0;if(d){c=c+8|0;i=v[h+8>>2];g=v[h+12>>2];f=b;b=e;continue}break}i=v[h+8>>2];g=v[h+12>>2]}v[a+48>>2]=b;v[a+44>>2]=e;v[a>>2]=i;v[a+4>>2]=g;jb=h+16|0}function jG(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0;d=jb-208|0;jb=d;v[d+8>>2]=1;v[d+12>>2]=0;h=b<<2;a:{if(!h){break a}v[d+16>>2]=4;v[d+20>>2]=4;b=4;e=4;g=2;while(1){f=b;b=(e+4|0)+b|0;v[(d+16|0)+(g<<2)>>2]=b;g=g+1|0;e=f;if(b>>>0<h>>>0){continue}break}f=(a+h|0)-4|0;b:{if(f>>>0<=a>>>0){g=0;b=1;f=0;break b}g=1;b=1;while(1){c:{if((g&3)==3){tw(a,c,b,d+16|0);Cr(d+8|0,2);b=b+2|0;break c}e=b-1|0;d:{if(y[(d+16|0)+(e<<2)>>2]>=f-a>>>0){Br(a,c,d+8|0,b,0,d+16|0);break d}tw(a,c,b,d+16|0)}if((b|0)==1){Ar(d+8|0,1);b=0;break c}Ar(d+8|0,e);b=1}e=v[d+8>>2];g=e|1;v[d+8>>2]=g;a=a+4|0;if(f>>>0>a>>>0){continue}break}g=e>>>0>1;f=v[d+12>>2]!=0}Br(a,c,d+8|0,b,0,d+16|0);if(!(f?1:(b|0)!=1|g)){break a}while(1){e:{if((b|0)<=1){e=d+8|0;f=iG(e);Cr(e,f);g=v[d+8>>2];b=b+f|0;break e}e=d+8|0;Ar(e,2);v[d+8>>2]=v[d+8>>2]^7;Cr(e,1);i=a-4|0;h=d+16|0;f=b-2|0;Br(i-v[h+(f<<2)>>2]|0,c,e,b-1|0,1,h);Ar(e,1);g=v[d+8>>2]|1;v[d+8>>2]=g;Br(i,c,e,f,1,h);b=f}a=a-4|0;if(v[d+12>>2]|(g|0)!=1|(b|0)!=1){continue}break}}jb=d+208|0}function vfa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=jb-16|0;jb=h;f=v[a+48>>2];m=v[a+24>>2];n=v[a+20>>2];b=v[a+44>>2];o=v[a+16>>2];g=v[a+4>>2];i=v[a>>2];v[h+8>>2]=i;v[h+12>>2]=g;e=v[a+12>>2];v[h>>2]=v[a+8>>2];v[h+4>>2]=e;a:{if(!d){e=b;b=f;break a}while(1){e=(g<<1)+o|0;p=u[e+2>>1];e=u[e>>1];g=v[a+60>>2];q=g;r=g>>31;g=Yb(b,-16777216,16776704);j=v[a+64>>2];f=Yb(f,-16777216,16776704);s=v[a+72>>2];t=v[c>>2];g=qma(j,j>>31,g,g>>31);j=mb;k=g;g=v[a+68>>2];l=qma(g,g>>31,f,f>>31);g=k+l|0;f=mb+j|0;f=g>>>0<l>>>0?f+1|0:f;k=g;g=e+((B(p-e|0,i>>>18|0)|0)/16384|0)<<8;e=g;i=qma(q,r,e,e>>31);e=k+i|0;f=mb+f|0;f=e>>>0<i>>>0?f+1|0:f;e=e+8388608|0;f=e>>>0<8388608?f+1|0:f;f=(f&16777215)<<8|e>>>24;e=(f|0)/256|0;v[c>>2]=B(e,n)+t;v[c+4>>2]=v[c+4>>2]+B(e,m);e=f-(g&s)|0;Sb(h+8|0,h);d=d-1|0;if(d){c=c+8|0;i=v[h+8>>2];g=v[h+12>>2];f=b;b=e;continue}break}i=v[h+8>>2];g=v[h+12>>2]}v[a+48>>2]=b;v[a+44>>2]=e;v[a>>2]=i;v[a+4>>2]=g;jb=h+16|0}function eM(a,b,c,d){var e=0,f=0,g=0,h=0,i=0;h=jb-16|0;jb=h;g=B(b,896)+a|0;a:{if(c){e=h+8|0;Fb(e,a+1074312|0,90);if(!Cb(e)){t[(B(b,896)+a|0)+1075816|0]=c}t[(B(b,896)+a|0)+1075815|0]=c;break a}c=w[g+1075815|0]}e=g+1074984|0;f=c&255;i=d?i:!(v[a+480180>>2]&204473357);_L(a,b,f,i);b:{c:{if(v[a+480180>>2]!=16777216){break c}g=v[(B(b,896)+a|0)+1075640>>2];if(!g|!v[g+44>>2]){break c}b=c&255;if(!(b>>>0<240|d)){ZL(a,e,f-240|0);break b}if(!(b>>>0<224|d)){YL(e,f-224|0);break b}XL(e,f);break b}if(v[a+480180>>2]==268435456){v[(B(b,896)+a|0)+1075692>>2]=1}if((c&255)>>>0>223&i){d:{d=f&15;if(!d){break d}c=c&240;if((c|0)!=224){if((c|0)!=240){break d}WL(a,e,d);break b}if(v[a+480180>>2]==524288){break d}$L(a,e,d);break b}if(v[a+480180>>2]!=524288){break b}}e:{if(!(t[(B(b,896)+a|0)+1075856|0]&1)){break e}if(v[a+1074416>>2]==1){b=h+8|0;Fb(b,a+1074312|0,6);if(Cb(b)){break e}}if(v[a+480180>>2]&32832){break e}if(!(v[a+480208>>2]&2)|v[a+480180>>2]!=8){break b}}VL(a,e,0-(f<<2)|0)}jb=h+16|0}function L3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=jb-32|0;jb=c;j=c,k=dI(),v[j+24>>2]=k;e=c+24|0;bI(a+24|0,ke(e));Gh(e);u[a+28>>1]=0;g=c;d=qL();h=jb-16|0;jb=h;f=Pe(44);v[113382]=0;i=Q(2104,f|0,d|0)|0;d=v[113382];v[113382]=0;a:{if((d|0)!=1){d=jb-16|0;jb=d;v[113382]=0;v[d+12>>2]=i;f=h+8|0;W(2108,f|0,d+12|0,d+8|0)|0;i=v[113382];v[113382]=0;b:{if((i|0)!=1){jb=d+16|0;break b}V(0)|0;O()|0;Ab();L()}jb=h+16|0;f=v[f>>2];break a}a=P()|0;O()|0;Wb(f);S(a|0);L()}v[g+24>>2]=f;Fs(a+32|0,e);vf(e);j=c,k=cI(v[a>>2]),v[j+24>>2]=k;pI(a+4|0,ke(e));ad(e);Mm(v[a+24>>2],v[a+4>>2]);v[a+60>>2]=0;v[a+48>>2]=1065353216;v[a+52>>2]=0;v[a+16>>2]=0;v[a+20>>2]=0;v[a+8>>2]=0;t[a- -64|0]=0;j=c,k=rn(b),v[j+24>>2]=k;j=c,k=Ii(b),v[j+16>>2]=k;c:{if(Hi(e,c+16|0)){while(1){g=lh(c+24|0);b=zf(c,g);v[113382]=0;X(2050,a|0,b|0,g+12|0,0);g=v[113382];v[113382]=0;if((g|0)==1){break c}yb(b);b=c+24|0;Ep(b);if(Hi(b,c+16|0)){continue}break}}jb=c+32|0;return}a=P()|0;O()|0;yb(b);S(a|0);L()}function jaa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;f=jb-32|0;jb=f;g=jb-16|0;jb=g;d=b;c=a+33|0;v[d>>2]=w[c+206|0]|w[c+207|0]<<8;yK(c,d+48|0,w[c+192|0],w[c+200|0],w[c+194|0],w[c+195|0],w[c+196|0],0);yK(c,d+68|0,w[c+193|0],w[c+201|0],w[c+197|0],w[c+198|0],w[c+199|0],1);h=d+236|0;while(1){j=w[c+e|0];k=_c(h,e+12|0),l=j,u[k>>1]=l;e=e+1|0;if((e|0)!=96){continue}break}if(w[c+208|0]){t[d+31|0]=w[c+209|0]+1;e=1;h=w[d+31|0];a:{if(h){e=16;if(h>>>0<=16){break a}}t[d+31|0]=e}u[g+14>>1]=w[c+210|0]|w[c+211|0]<<8;u[g+12>>1]=127;k=d,l=w[Af(g+14|0,g+12|0)|0]+1|0,t[k+30|0]=l}t[d+33|0]=w[c+212|0];jb=g+16|0;c=b+236|0;while(1){d=0;e=a+i|0;if(w[e+33|0]<(w[a+27|0]|w[a+28|0]<<8)>>>0){d=w[e+33|0]}k=_c(c,i+12|0),l=d,u[k>>1]=l;i=i+1|0;if((i|0)!=96){continue}break}Vl(f,3,a+4|0);d=f+16|0;Ec(d,f);v[113382]=0;Q(335,b+492|0,d|0)|0;d=v[113382];v[113382]=0;if((d|0)!=1){yb(f+16|0);if(!w[a+241|0]){t[b+30|0]=w[a+26|0]}jb=f+32|0;return}a=P()|0;O()|0;yb(f+16|0);S(a|0);L()}function U9(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;e=jb-16|0;jb=e;sd(c,0);d=a+36|0;u[e+14>>1]=w[d|0]|w[d+1|0]<<8;u[e+12>>1]=32767;f=c,g=(x[Af(e+14|0,e+12|0)>>1]<<8>>>0)/32767|0,u[f+28>>1]=g;d=a+38|0;u[e+10>>1]=w[d|0]|w[d+1|0]<<8;u[e+8>>1]=32767;f=c,g=(x[Af(e+10|0,e+8|0)>>1]<<8>>>0)/32767|0,u[f+30>>1]=g;u[c+32>>1]=64;d=a+44|0;v[c>>2]=w[d|0]|w[d+1|0]<<8|(w[d+2|0]<<16|w[d+3|0]<<24);d=a+48|0;v[c+4>>2]=w[d|0]|w[d+1|0]<<8|(w[d+2|0]<<16|w[d+3|0]<<24);d=a+52|0;v[c+8>>2]=w[d|0]|w[d+1|0]<<8|(w[d+2|0]<<16|w[d+3|0]<<24);d=a+56|0;v[c+24>>2]=w[d|0]|w[d+1|0]<<8|(w[d+2|0]<<16|w[d+3|0]<<24);d=b+166|0;if(w[d|0]<=4){t[c+38|0]=w[w[d|0]+35994|0]}t[c+39|0]=w[b+167|0];d=b+171|0;t[c+41|0]=(w[d|0]|w[d+1|0]<<8)>>>4;b=b+169|0;b=(w[b|0]|w[b+1|0]<<8)>>>2|0;t[c+40|0]=b;if(w[c+41|0]|b&255){t[c+39|0]=w[c+39|0]^-1}a=a+40|0;if(w[a|0]&4){u[c+34>>1]=x[c+34>>1]|1}if(w[a|0]&8){u[c+34>>1]=x[c+34>>1]|2}if(w[a|0]&16){u[c+34>>1]=x[c+34>>1]|4}if(w[a|0]&32){u[c+34>>1]=x[c+34>>1]|32}jb=e+16|0}function NU(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=jb-80|0;jb=d;Ic(b);Gq(a);a:{if(!Ru(b,d+40|0)){break a}if(!wC(d+40|0)){break a}b:{if(!c){break b}c=d+40|4;f=w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24);if(!Rb(b,(f<<24|f<<8&16711680|(f>>>8&65280|f>>>24))-28|0)){break a}kv(a);g=d,h=jv(),v[g+24>>2]=h;e=d+24|0;iv(Wg(a)+28|0,e);Fq(e);f=v[Wg(a)+28>>2];v[113382]=0;e=T(316,b|0)|0;b=v[113382];v[113382]=0;c:{if((b|0)==1){break c}c=w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24);b=w[d+52|0]|w[d+53|0]<<8|(w[d+54|0]<<16|w[d+55|0]<<24);v[113382]=0;c=aa(317,e|0,(c<<8&16711680|c<<24|(c>>>8&65280|c>>>24))-28|0,f|0,b<<8&16711680|b<<24|(b>>>8&65280|b>>>24))|0;b=v[113382];v[113382]=0;if((b|0)==1){break c}e=0;if(!c){break a}c=d+8|0;Vi(c,f);b=d+16|0;ev(b,c);b=fo(d+24|0,b,0);Qd(Wg(a)+12|0,b);Bb(b);break b}b=Ea(66740,72452)|0;a=O()|0;d:{if((ga(66740)|0)==(a|0)){break d}if((ga(72452)|0)==(a|0)){break d}S(b|0);L()}_(b|0)|0;$();e=0;break a}e=1}jb=d+80|0;return e|0}function dj(a,b,c,d,e,f,g,h){var i=0,j=0,k=0,l=0,m=0;i=jb-32|0;jb=i;v[i+16>>2]=c;v[i+24>>2]=b;b=i+8|0;Ac(b,d);v[113382]=0;j=T(2339,b|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){Ob(i+8|0);v[e>>2]=0;c=0;a:{while(1){if((g|0)==(h|0)|c){break a}b:{if(ak(i+24|0,i+16|0)){break b}c:{if((xm(j,v[g>>2])|0)==37){c=g+4|0;if((h|0)==(c|0)){break b}k=0;b=xm(j,v[c>>2]);d:{if(!((b|0)==69|(b&255)==48)){c=g;break d}if((g+8|0)==(h|0)){break b}k=b;b=xm(j,v[g+8>>2])}l=i,m=nb[v[v[a>>2]+36>>2]](a,v[i+24>>2],v[i+16>>2],d,e,f,b,k)|0,v[l+24>>2]=m;g=c+8|0;break c}if(Xj(j,8192,v[g>>2])){while(1){e:{g=g+4|0;if((h|0)==(g|0)){g=h;break e}if(Xj(j,8192,v[g>>2])){continue}}break}while(1){if(!qr(i+24|0,i+16|0)){break c}if(!Xj(j,8192,el(i+24|0))){break c}Cm(i+24|0);continue}}if((Pk(j,el(i+24|0))|0)==(Pk(j,v[g>>2])|0)){g=g+4|0;Cm(i+24|0);break c}v[e>>2]=4}c=v[e>>2];continue}break}v[e>>2]=4}if(ak(i+24|0,i+16|0)){v[e>>2]=v[e>>2]|2}jb=i+32|0;return v[i+24>>2]}a=P()|0;O()|0;Ob(i+8|0);S(a|0);L()}function Lj(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;d=jb-80|0;jb=d;c=v[a+28>>2];zn(v[v[c>>2]-12>>2]+c|0,0);if(!wd(a,4)){tv(a)}a:{if(!v[a+4>>2]){break a}if(wd(a,6)){break a}if(wd(a,7)){break a}g=v[a+28>>2];h=v[a+84>>2];f=B(v[a+20>>2],v[a+4>>2]);e=f+v[a+80>>2]|0;e=Qg(d- -64|0,e,e>>>0<f>>>0?h+1|0:h);f=v[e+12>>2];v[d+24>>2]=v[e+8>>2];v[d+28>>2]=f;c=v[e+4>>2];v[d+16>>2]=v[e>>2];v[d+20>>2]=c;aj(g,d+16|0)}c=0;b:{if(!wd(a,5)){break b}h=0;i=a+44|0;e=jd(i);c=0;if(!e){break b}g=a+32|0;while(1){c:{j=(v[a+96>>2]+h>>>0)%(e>>>0)|0;if(y[sc(i,j)>>2]>=wc(g)>>>0){break c}f=qm(d+48|0,uc(g,v[sc(i,j)>>2]),x[sc(i,j)+12>>1]);c=Cv(b,f);Ib(f);if(!c){break c}v[a+96>>2]=(j+1>>>0)%(e>>>0);if(v[sc(i,j)+4>>2]){f=v[a+28>>2];c=v[a+12>>2];b=v[a+8>>2];a=v[sc(i,j)+4>>2];g=b+a|0;c=Qg(d+32|0,g,a>>>0>g>>>0?c+1|0:c);a=v[c+12>>2];v[d+8>>2]=v[c+8>>2];v[d+12>>2]=a;a=v[c+4>>2];v[d>>2]=v[c>>2];v[d+4>>2]=a;aj(f,d)}c=sc(i,j);break b}h=h+1|0;if((e|0)!=(h|0)){continue}break}c=0}jb=d+80|0;return c}function sea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=jb-48|0;jb=e;i=v[a+16>>2];f=Uf(e+16|0);v[f+8>>2]=a+112;v[f+16>>2]=v[a+128>>2];m=f,n=Pf(b+327720|0,v[b+20>>2],(v[a+88>>2]&16384)>>>14|0),v[m+12>>2]=n;b=v[f+16>>2];if(b){m=f,n=Tf(a+8|0,b),v[m>>2]=n;v[f+4>>2]=mb}j=v[a+24>>2];k=v[a+20>>2];b=v[a+4>>2];h=v[a>>2];v[e+8>>2]=h;v[e+12>>2]=b;g=v[a+12>>2];v[e>>2]=v[a+8>>2];v[e+4>>2]=g;if(d){while(1){g=0;v[e+40>>2]=h;v[e+44>>2]=l;h=b+i|0;a:{b=v[f+16>>2];if((b|0)<=0){break a}while(1){yd(v[f+8>>2],t[h+g|0]<<6);xd(v[f+8>>2],4);Sb(e+40|0,f);if((b|0)<2){break a}b=b-1|0;g=v[e+44>>2];continue}}d=d-1|0;b=v[f+8>>2];Sb(b,b+8|0);b=v[f+8>>2];g=v[b+4>>2];if(g){yd(b,t[h+v[e+44>>2]|0]<<6);xd(v[f+8>>2],g);b=v[f+8>>2];g=v[b>>2];v[b>>2]=g;v[b+4>>2]=0}b=Of(b,v[f+12>>2]);v[c>>2]=v[c>>2]+B(b,k);v[c+4>>2]=v[c+4>>2]+B(b,j);Sb(e+8|0,e);if(d){c=c+8|0;h=v[e+8>>2];b=v[e+12>>2];continue}break}h=v[e+8>>2];b=v[e+12>>2]}v[a>>2]=h;v[a+4>>2]=b;jb=e+48|0}function LX(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;c=jb-32|0;jb=c;v[c+28>>2]=0;a:{b:{c:{if(w[cj(c+24|0,a,0)|0]){d=v[v[a>>2]-12>>2];v[113382]=0;Ac(c+16|0,a+d|0);d=v[113382];v[113382]=0;d:{e:{f:{g:{h:{if((d|0)!=1){v[113382]=0;d=T(2708,c+16|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break h}e=tm(c+8|0,a);f=Ik(c);g=v[v[a>>2]-12>>2];f=v[f>>2];e=v[e>>2];v[113382]=0;ka(2711,d|0,e|0,f|0,a+g|0,c+28|0,c+20|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break h}Ob(c+16|0);break f}b=V(0)|0;O()|0;break g}b=V(0)|0;O()|0;Ob(c+16|0)}_(b|0)|0;b=v[c+28>>2]|1;v[c+28>>2]=b;bj(v[v[a>>2]-12>>2]+a|0,b);b=v[v[a>>2]-12>>2];v[113382]=0;b=v[(a+b|0)+20>>2];d=v[113382];v[113382]=0;if((d|0)!=1){if(!(b&1)){break e}v[113382]=0;Y(81);a=v[113382];v[113382]=0;if((a|0)!=1){break b}}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)==1){break c}S(a|0);L()}d=v[c+20>>2];v[b>>2]=d;break d}$()}Eg(v[v[a>>2]-12>>2]+a|0,v[c+28>>2])}jb=c+32|0;break a}V(0)|0;O()|0;Ab()}L()}return a|0}function dz(a,b){a=a|0;b=b|0;a:{b:{switch((w[a+3|0]|64)+-64|0){case 0:t[a+3|0]=w[a+5|0]?42:0;return;case 1:t[a+3|0]=16;return;case 2:t[a+3|0]=12;return;case 3:t[a+3|0]=14;if(b){break a}b=a;a=w[a+5|0];t[b+5|0]=B(a>>>4|0,10)+(a&15);return;case 4:t[a+3|0]=11;return;case 5:t[a+3|0]=3;return;case 6:t[a+3|0]=2;return;case 7:t[a+3|0]=4;return;case 8:t[a+3|0]=5;return;case 9:t[a+3|0]=18;return;case 10:t[a+3|0]=1;return;case 11:t[a+3|0]=7;return;case 12:t[a+3|0]=6;return;case 13:t[a+3|0]=21;return;case 14:t[a+3|0]=22;return;case 15:t[a+3|0]=10;return;case 16:t[a+3|0]=29;return;case 17:t[a+3|0]=15;return;case 18:t[a+3|0]=8;return;case 19:t[a+3|0]=20;return;case 20:t[a+3|0]=17;return;case 21:t[a+3|0]=26;return;case 22:t[a+3|0]=23;return;case 23:t[a+3|0]=24;return;case 24:t[a+3|0]=9;return;case 25:t[a+3|0]=27;return;case 26:t[a+3|0]=31;return;case 28:t[a+3|0]=b?32:31;return;case 29:t[a+3|0]=33;return;case 27:t[a+3|0]=34;return;default:break b}}t[a+3|0]=0}}function Wfa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;g=jb-48|0;jb=g;u[a>>1]=0;u[a+2>>1]=0;u[a+4>>1]=0;c=g+44|0;wn(b,c);a:{if(!iO(c)){break a}d=w[g+46|0];f=w[g+47|0];e=w[g+45|0];t[a+4|0]=1;h=e>>>3&3;c=(h|0)!=3;i=e>>>1&3;e=i^3;f=f>>>0<192;u[a+2>>1]=x[(B(c,6)+24456|0)+(e<<1)>>1]<<f;e=B(B(w[e+(B(c,3)+24233|0)|0],x[((B(c,90)+24240|0)+B(e,30)|0)+(d>>>3&30)>>1]),1e3);d=d>>>1|0;d=B(((e>>>0)/x[(B(h,6)+24432|0)+(d&6)>>1]|0)+(d&1)|0,(i|0)==3?4:1);u[a>>1]=d;e=w[f+((c<<1)+24468|0)|0];if(e+8>>>0>(d&65535)>>>0){break a}c=g;d=jb-16|0;jb=d;v[d+12>>2]=e+4;v[d>>2]=36;f=v[Lb(d+12|0,d)>>2];if(!Rb(b,f)){f=$e(b)}vq(d,c);kg(b,v[d>>2],f);vq(d,c);Qb(v[d>>2]+f|0,0,36-f|0);_b(b,v[d+12>>2]);jb=d+16|0;b=2;if(e>>>0>2){while(1){if(w[b+g|0]){break a}b=b+1|0;if((e|0)!=(b|0)){continue}break}}b=a;c=e+g|0;if((w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24))==1868983881){c=1}else{c=(w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24))==1735289176}t[b+5|0]=c}jb=g+48|0;return a|0}function Gea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=jb-32|0;jb=f;j=v[a+24>>2];k=v[a+20>>2];l=v[a+16>>2];i=v[a+4>>2];e=i;g=v[a>>2];v[f+24>>2]=g;v[f+28>>2]=e;i=v[a+12>>2];v[f+16>>2]=v[a+8>>2];v[f+20>>2]=i;i=a;if(d){while(1){h=((((e&2147483647)<<1|g>>>31)&2147483646)<<1)+l|0;a=(((g>>>16|0)+4&131064)<<1)+b|0;m=u[a+38>>1];n=u[a+36>>1];o=u[a+34>>1];p=u[a+32>>1];q=u[a+30>>1];r=u[a+28>>1];s=u[a+26>>1];t=u[a+24>>1];g=0;a=1;while(1){e=g<<1;v[(f+8|0)+(g<<2)>>2]=(((((B(u[(e|8)+h>>1],o)+B(u[(e|4)+h>>1],p)|0)+B(u[(e|12)+h>>1],n)|0)+B(u[(e|16)+h>>1],m)|0)/2|0)+((((B(u[(e|-8)+h>>1],s)+B(u[(e|-12)+h>>1],t)|0)+B(u[(e|-4)+h>>1],r)|0)+B(u[e+h>>1],q)|0)/2|0)|0)/16384;e=a;a=0;g=1;if(e){continue}break}v[c>>2]=v[c>>2]+B(v[f+8>>2],k);v[c+4>>2]=v[c+4>>2]+B(v[f+12>>2],j);Sb(f+24|0,f+16|0);d=d-1|0;if(d){c=c+8|0;g=v[f+24>>2];e=v[f+28>>2];continue}break}g=v[f+24>>2];e=v[f+28>>2]}v[i>>2]=g;v[i+4>>2]=e;jb=f+32|0}function ej(a,b,c,d,e,f,g,h){var i=0,j=0,k=0,l=0,m=0;i=jb-32|0;jb=i;v[i+16>>2]=c;v[i+24>>2]=b;b=i+8|0;Ac(b,d);v[113382]=0;j=T(21,b|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){Ob(i+8|0);v[e>>2]=0;c=0;a:{while(1){if((g|0)==(h|0)|c){break a}b:{if(gj(i+24|0,i+16|0)){break b}c:{if((ym(j,t[g|0])|0)==37){c=g+1|0;if((h|0)==(c|0)){break b}k=0;b=ym(j,t[c|0]);d:{if(!((b|0)==69|(b&255)==48)){c=g;break d}if((g+2|0)==(h|0)){break b}k=b;b=ym(j,t[g+2|0])}l=i,m=nb[v[v[a>>2]+36>>2]](a,v[i+24>>2],v[i+16>>2],d,e,f,b,k)|0,v[l+24>>2]=m;g=c+2|0;break c}if(Lg(j,8192,t[g|0])){while(1){e:{g=g+1|0;if((h|0)==(g|0)){g=h;break e}if(Lg(j,8192,t[g|0])){continue}}break}while(1){if(!wo(i+24|0,i+16|0)){break c}if(!Lg(j,8192,ck(i+24|0))){break c}fl(i+24|0);continue}}if((aw(j,ck(i+24|0))|0)==(aw(j,t[g|0])|0)){g=g+1|0;fl(i+24|0);break c}v[e>>2]=4}c=v[e>>2];continue}break}v[e>>2]=4}if(gj(i+24|0,i+16|0)){v[e>>2]=v[e>>2]|2}jb=i+32|0;return v[i+24>>2]}a=P()|0;O()|0;Ob(i+8|0);S(a|0);L()}function bI(a,b){var c=0,d=0,e=0,f=0,g=0;c=v[a>>2];v[a>>2]=b;if(c){v[113382]=0;b=c;T(1365,b|0)|0;a=v[113382];v[113382]=0;a:{if((a|0)!=1){c=v[b+4>>2];if(c){a=c;Ve(a);if(v[a>>2]){f=a;g=v[a>>2];d=v[a+4>>2];b:{while(1){if((d|0)==(g|0)){break b}e=zb(f);v[113382]=0;d=d-4|0;R(1407,e|0,d|0);e=v[113382];v[113382]=0;if((e|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}v[f+4>>2]=g;Se(zb(a),v[a>>2],nd(a))}Wb(c)}v[b+4>>2]=0;dy(b+1304500|0);vs(b+1304436|0);yb(b+1304424|0);yb(b+1304412|0);yb(b+1304400|0);us(b+1304396|0);ts(b+1304392|0);cp(b+1304360|0);a=b+946300|0;c=b+906300|0;while(1){a=Ym(a-160|0);if((c|0)!=(a|0)){continue}break}Ws(b+484360|0);cy(b+484344|0);ze(b+480248|0);break a}V(0)|0;O()|0;dy(b+1304500|0);vs(b+1304436|0);yb(b+1304424|0);yb(b+1304412|0);yb(b+1304400|0);us(b+1304396|0);ts(b+1304392|0);cp(b+1304360|0);a=b+946300|0;c=b+906300|0;while(1){a=Ym(a-160|0);if((c|0)!=(a|0)){continue}break}Ws(b+484360|0);cy(b+484344|0);ze(b+480248|0);Ab();L()}Wb(b)}}function wO(a,b,c){var d=0;d=w[a|0]&15;t[a|0]=w[d+24176|0];a:{b:{c:{switch(d|0){case 0:if(c>>>0>50?w[b|0]:0){break b}t[a|0]=0;return;case 5:d=w[b|0];if(!((d&15)!=2&(d&240)!=32)){t[a|0]=20;t[b|0]=159;return}d:{if((d&15)!=12){if((d&240)!=192){break b}if(c>>>0>50){break d}break b}if(c>>>0<51){break b}}t[a|0]=25;t[b|0]=0;return;case 7:if(c>>>0>51){break b}t[a|0]=0;return;case 10:a=w[b|0]&240;if(!a){break b}t[b|0]=a;return;case 11:t[b|0]=B(w[b|0]&15,17);return;case 12:t[b|0]=w[b|0]>>>2;return;case 13:a=w[b|0];t[b|0]=B(a>>>4|0,10)+(a&15);return;case 14:e:{switch((w[b|0]>>>4|0)-1|0){case 0:t[a|0]=2;break a;case 1:t[a|0]=3;break a;case 7:if(c>>>0<52){break b}t[a|0]=20;t[b|0]=w[b|0]&15|96;return;case 8:t[a|0]=15;t[b|0]=w[b|0]&15;return;case 9:t[a|0]=11;t[b|0]=w[b|0]<<4|15;return;case 10:t[a|0]=11;break a;case 11:case 12:break e;default:break b}}t[a|0]=20;return;case 15:break c;default:break b}}if(w[b|0]<48){break b}t[a|0]=17}return}t[b|0]=w[b|0]|240}function WY(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;a=jb-16|0;jb=a;v[a+12>>2]=c;v[a+8>>2]=f;v[a+12>>2]=c;v[a+8>>2]=f;b=v[a+12>>2];a:{while(1){if(b>>>0>=d>>>0){c=0;break a}c=2;b=v[b>>2];if((b&-2048)==55296|b>>>0>1114111){break a}b:{c:{if(b>>>0<=127){c=1;f=v[a+8>>2];if((g-f|0)<=0){break a}v[a+8>>2]=f+1;t[f|0]=b;break c}if(b>>>0<=2047){c=v[a+8>>2];if((g-c|0)<2){break b}v[a+8>>2]=c+1;t[c|0]=b>>>6|192;c=v[a+8>>2];v[a+8>>2]=c+1;t[c|0]=b&63|128;break c}c=v[a+8>>2];f=g-c|0;if(b>>>0<=65535){if((f|0)<3){break b}v[a+8>>2]=c+1;t[c|0]=b>>>12|224;c=v[a+8>>2];v[a+8>>2]=c+1;t[c|0]=b>>>6&63|128;c=v[a+8>>2];v[a+8>>2]=c+1;t[c|0]=b&63|128;break c}if((f|0)<4){break b}v[a+8>>2]=c+1;t[c|0]=b>>>18|240;c=v[a+8>>2];v[a+8>>2]=c+1;t[c|0]=b>>>12&63|128;c=v[a+8>>2];v[a+8>>2]=c+1;t[c|0]=b>>>6&63|128;c=v[a+8>>2];v[a+8>>2]=c+1;t[c|0]=b&63|128}b=v[a+12>>2]+4|0;v[a+12>>2]=b;continue}break}c=1}v[e>>2]=v[a+12>>2];v[h>>2]=v[a+8>>2];jb=a+16|0;return c|0}function vj(a){a=a|0;var b=0;a:{b:{switch(w[a+3|0]){case 0:if(!w[a+5|0]){break a}t[a+3|0]=1;return;case 1:t[a+3|0]=2;return;case 2:t[a+3|0]=3;return;case 3:t[a+3|0]=4;return;case 4:t[a+3|0]=5;return;case 5:t[a+3|0]=6;return;case 6:t[a+3|0]=7;return;case 7:t[a+3|0]=8;return;case 8:t[a+3|0]=9;return;case 9:t[a+3|0]=10;return;case 10:t[a+3|0]=11;return;case 11:t[a+3|0]=12;return;case 12:t[a+3|0]=13;return;case 13:t[a+3|0]=14;b=a;a=w[a+5|0];t[b+5|0]=B(a>>>4|0,10)+(a&15);return;case 14:t[a+3|0]=19;return;case 15:if(w[a+5|0]<=31){t[a+3|0]=16;return}t[a+3|0]=17;return;case 16:t[a+3|0]=23;return;case 17:t[a+3|0]=24;return;case 20:t[a+3|0]=25;return;case 21:t[a+3|0]=30;return;case 25:t[a+3|0]=29;return;case 27:t[a+3|0]=15;return;case 29:t[a+3|0]=18;return;case 32:t[a+3|0]=42;return;case 33:t[a+3|0]=28;return;case 34:t[a+3|0]=27;return;case 35:t[a+3|0]=31;return;case 36:t[a+3|0]=32;return;case 38:t[a+3|0]=34;return;default:break b}}t[a+3|0]=0}}function Mia(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=jb-16|0;jb=e;t[e+15|0]=8;u[e+12>>1]=0;v[e+8>>2]=0;if(d){k=B(c,d);c=0;while(1){if((k|0)>0){h=(j<<1)+b|0;m=h+(k<<1)|0;while(1){n=c;u[e+6>>1]=0;pQ(a,e+14|0,e+12|0,e+15|0,e+6|0);a:{b:{g=w[e+15|0];if(!g){break b}c=x[e+12>>1];while(1){f=c<<1;c=f&254;u[e+12>>1]=c;f=(f&65534)>>>0>255;t[e+14|0]=f;if(!c){if(!Je(a,e+5|0)){break b}c=w[e+5|0];f=c>>>7|0;t[e+14|0]=f;c=c<<1&254|1;u[e+12>>1]=c}i=x[e+6>>1]<<1|f;u[e+6>>1]=i;g=g-1|0;if(g&255){continue}break}break a}i=x[e+6>>1]}c=1;g=i&65535;c:{if(g>>>0<4){break c}f=15;while(1){c=f;l=c&255;if(g>>>l&1){break c}f=c-1|0;if(l>>>0>1){continue}break}}t[e+15|0]=(w[e+15|0]+c&254)>>>1;c=i&1;t[e+14|0]=c;f=c-1^(i&65534)>>>1;c=f+x[e+8>>1]|0;u[e+6>>1]=c;u[h>>1]=c;v[e+8>>2]=((f>>1)-(n<<16>>16)|0)+(c<<16>>16<<1);Yd(e+8|0,-32768,32767);h=(d<<1)+h|0;if(m>>>0>h>>>0){continue}break}}j=j+1|0;if((j|0)!=(d|0)){continue}break}}jb=e+16|0}function Zea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;f=jb-16|0;jb=f;a:{b:{c:{g=v[a+12>>2];h=v[a+8>>2];d:{if((g|0)<=1&h>>>0<=805306368|(g|0)<=0){if((g|0)>=-2&h>>>0>=3489660928|(g|0)>-2){break c}if((g|0)==-2&h>>>0>2147483647|g>>>0>4294967294){break d}break b}if((g|0)==1&h>>>0>2147483648|g>>>0>1){break b}}i=b+196648|0;break a}i=b+131112|0;break a}i=b+262184|0}j=v[a+16>>2];k=v[a+24>>2];l=v[a+20>>2];b=v[a+4>>2];e=v[a>>2];v[f+8>>2]=e;v[f+12>>2]=b;v[f>>2]=h;v[f+4>>2]=g;if(d){while(1){b=(b<<1)+j|0;e=(e>>>16&65520)+i|0;b=(((((((B(u[b-4>>1],u[e+2>>1])+B(u[b-6>>1],u[e>>1])|0)+B(u[b-2>>1],u[e+4>>1])|0)+B(u[b>>1],u[e+6>>1])|0)+B(u[b+2>>1],u[e+8>>1])|0)+B(u[b+4>>1],u[e+10>>1])|0)+B(u[b+6>>1],u[e+12>>1])|0)+B(u[b+8>>1],u[e+14>>1])|0)/32768|0;v[c>>2]=v[c>>2]+B(b,l);v[c+4>>2]=v[c+4>>2]+B(b,k);Sb(f+8|0,f);d=d-1|0;if(d){c=c+8|0;e=v[f+8>>2];b=v[f+12>>2];continue}break}e=v[f+8>>2];b=v[f+12>>2]}v[a>>2]=e;v[a+4>>2]=b;jb=f+16|0}function Vfa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;h=Eb(b);a:{b:{c:{d:{e:{while(1){b=c;if(!c){break e}c=b-1|0;if(!w[h+c|0]){continue}break}if((d|0)==4){c=0;while(1){f:{g:{h:{d=c+h|0;i=w[d|0];switch(i-10|0){case 0:break g;case 3:break h;default:break f}}e=e+1|0;break f}f=f+1|0}g=c?(w[d-1|0]==13&(i|0)==10)+g|0:g;c=c+1|0;if((c|0)!=(b|0)){continue}break}break d}f=(d|0)==2;break b}b=0;if((d|0)==4){break d}f=(d|0)==2;break c}i:{if((e|0)==(f|0)){d=2;if((e|0)==(g|0)){break i}}if(e){d=0;if(!f){break i}}d=e?3:f?1:3}f=(d|0)==2;if(b){break b}}b=0;g=1;e=0;break a}g=0;c=0;e=0;while(1){e=e+1|0;c=((w[c+h|0]==13&f)+c|0)+1|0;if(c>>>0<b>>>0){continue}break}}Ee(a);Uq(a,e);if(!g){g=(d|0)==1?32:13;d=d&-3?13:32;c=0;while(1){j:{k:{l:{m:{e=t[c+h|0];switch(e-10|0){case 1:case 2:break j;case 0:break k;case 3:break l;default:break m}}if(e){break j}e=32;break j}c=c+f|0;e=g;break j}e=d}Tl(a,e);c=c+1|0;if(c>>>0<b>>>0){continue}break}}return 1}function XQ(a){var b=0,c=0,d=0,e=0;b=jb-48|0;jb=b;c=w[a+8|0]|w[a+9|0]<<8|(w[a+10|0]<<16|w[a+11|0]<<24);v[b+8>>2]=(c<<24|c<<8&16711680|(c>>>8&65280|c>>>24))+788;v[b+12>>2]=0;c=w[a+16|0]|w[a+17|0]<<8|(w[a+18|0]<<16|w[a+19|0]<<24);v[b+16>>2]=c<<24|c<<8&16711680|(c>>>8&65280|c>>>24);v[b+20>>2]=0;c=b;e=b;if(w[a+24|0]|w[a+25|0]<<8|(w[a+26|0]<<16|w[a+27|0]<<24)){d=w[a+24|0]|w[a+25|0]<<8|(w[a+26|0]<<16|w[a+27|0]<<24);d=d<<24|d<<8&16711680|(d>>>8&65280|d>>>24)}else{d=52}v[e+24>>2]=d;v[c+28>>2]=0;c=w[a+32|0]|w[a+33|0]<<8|(w[a+34|0]<<16|w[a+35|0]<<24);v[b+44>>2]=4;v[b+40>>2]=b+8;a=v[b+44>>2];v[b>>2]=v[b+40>>2];v[b+4>>2]=a;v[b+32>>2]=(c<<8&16711680|c<<24|(c>>>8&65280|c>>>24))+80;v[b+36>>2]=0;c=jb-16|0;jb=c;a=v[b>>2];d=v[b>>2]+(v[b+4>>2]<<3)|0;a:{if((a|0)==(d|0)){break a}e=a+8|0;if((d|0)==(e|0)){break a}while(1){a=Eu(a,e)?e:a;e=e+8|0;if((d|0)!=(e|0)){continue}break}}jb=c+16|0;jb=b+48|0;b=v[a>>2];c=b-52|0;mb=v[a+4>>2]-(b>>>0<52)|0;return c}function WN(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;t[a+15|0]=0;t[a+16|0]=0;t[a+17|0]=0;t[a+18|0]=0;t[a+19|0]=0;t[a+20|0]=0;t[a+21|0]=0;t[a+22|0]=0;t[a+14|0]=5;u[a+12>>1]=0;v[a+8>>2]=128;v[a>>2]=256;v[a+4>>2]=64;v[a+28>>2]=0;t[a+27|0]=60;v[a+40>>2]=0;v[a+44>>2]=0;t[a+33|0]=2;t[a+34|0]=0;t[a+35|0]=0;t[a+36|0]=2;t[a+23|0]=0;t[a+24|0]=0;t[a+25|0]=255;t[a+26|0]=0;t[a+32|0]=0;d=Py(a+48|0);e=Py(a+68|0);f=Py(a+88|0);v[113382]=0;T(1126,a+492|0)|0;c=v[113382];v[113382]=0;a:{if((c|0)==1){break a}v[113382]=0;T(1126,a+524|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break a}v[113382]=0;U(871,a|0,0,0);c=v[113382];v[113382]=0;if((c|0)==1){break a}v[113382]=0;U(872,a|0,0,0);c=v[113382];v[113382]=0;if((c|0)==1){break a}v[a+40>>2]=0;v[a+44>>2]=0;v[113382]=0;R(740,a|0,b|0);b=v[113382];v[113382]=0;if((b|0)==1){break a}d=a+108|0;b=0;while(1){c=ec(d,b);b=b+1|0;t[c|0]=b;if(b>>>0<128){continue}break}return a|0}a=P()|0;O()|0;qn(f);qn(e);qn(d);S(a|0);L()}function _ea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;f=jb-16|0;jb=f;a:{b:{c:{g=v[a+12>>2];h=v[a+8>>2];d:{if((g|0)<=1&h>>>0<=805306368|(g|0)<=0){if((g|0)>=-2&h>>>0>=3489660928|(g|0)>-2){break c}if((g|0)==-2&h>>>0>2147483647|g>>>0>4294967294){break d}break b}if((g|0)==1&h>>>0>2147483648|g>>>0>1){break b}}i=b+196648|0;break a}i=b+131112|0;break a}i=b+262184|0}j=v[a+16>>2];k=v[a+24>>2];l=v[a+20>>2];b=v[a+4>>2];e=v[a>>2];v[f+8>>2]=e;v[f+12>>2]=b;v[f>>2]=h;v[f+4>>2]=g;if(d){while(1){b=b+j|0;e=(e>>>16&65520)+i|0;b=(((((((B(t[b-2|0],u[e+2>>1])+B(t[b-3|0],u[e>>1])|0)+B(t[b-1|0],u[e+4>>1])|0)+B(t[b|0],u[e+6>>1])|0)+B(t[b+1|0],u[e+8>>1])|0)+B(t[b+2|0],u[e+10>>1])|0)+B(t[b+3|0],u[e+12>>1])|0)+B(t[b+4|0],u[e+14>>1])<<8)/32768|0;v[c>>2]=v[c>>2]+B(b,l);v[c+4>>2]=v[c+4>>2]+B(b,k);Sb(f+8|0,f);d=d-1|0;if(d){c=c+8|0;e=v[f+8>>2];b=v[f+12>>2];continue}break}e=v[f+8>>2];b=v[f+12>>2]}v[a>>2]=e;v[a+4>>2]=b;jb=f+16|0}function E7(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;a:{e=jb-16|0;jb=e;f=bd(a);b:{if(Db(b)){while(1){c=v[ij(b,i)>>2];c:{if(c>>>0>=2097152){v[113382]=0;R(118,f|0,63);a=v[113382];v[113382]=0;if((a|0)!=1){break c}break b}d=0;d:{e:{while(1){h=c&63;t[(e+10|0)+d|0]=h;if(c>>>0<64){break e}c=c>>>6|0;d=d+1|0;if((d|0)!=6){continue}break}a=7;d=6;break d}f:{if(!d){v[113382]=0;R(118,f|0,t[e+10|0]);break f}a=d+1|0;if((a|0)!=2){break d}d=1;a=2;if((h|0)!=1){break d}v[113382]=0;R(118,f|0,t[e+10|0]|64)}a=v[113382];v[113382]=0;if((a|0)!=1){break c}break b}d=(-1<<a^-1)<<7-d;h=a+e|0;c=a;while(1){g:{if((a|0)==(c|0)){g=w[h+9|0];v[113382]=0;R(118,f|0,(d|g)<<24>>24);g=v[113382];v[113382]=0;if((g|0)==1){break b}c=c-1|0;break g}v[113382]=0;c=c-1|0;R(118,f|0,t[c+(e+10|0)|0]|-128);g=v[113382];v[113382]=0;if((g|0)==1){break b}}if(c){continue}break}}i=i+1|0;if(Db(b)>>>0>i>>>0){continue}break}}jb=e+16|0;break a}a=P()|0;O()|0;yb(f);S(a|0);L()}}function cJ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=C(0);b=jb-32|0;jb=b;e=v[a+20>>2];a:{if(!e){break a}if(wc(e+4|0)>>>0<4){break a}c=b+8|0;Vi(c,v[a+20>>2]+4|0);d=jb-16|0;jb=d;e=d+8|0;KJ(e,$b(d,c));c=b+16|0;bv(c,e);v[c+12>>2]=0;v[c+8>>2]=0;jb=d+16|0;e=c;v[113382]=0;d=T(397,c|0)|0;c=v[113382];v[113382]=0;b:{if((c|0)!=1){if(d){break b}c=v[v[a>>2]+40>>2];v[113382]=0;f=T(c|0,a|0)|0;c=v[113382];v[113382]=0;c:{if((c|0)==1){break c}if(wc(v[a+20>>2]+4|0)-4>>>0<f<<2>>>0){break b}c=v[v[a>>2]+168>>2];d=0;v[113382]=0;R(c|0,a|0,-1);c=v[113382];v[113382]=0;if((c|0)==1){break c}if(f){while(1){v[113382]=0;g=C(Ca(663,e|0));c=v[113382];v[113382]=0;if((c|0)==1){break c}c=v[v[a>>2]+44>>2];v[113382]=0;Aa(c|0,a|0,d|0,C(g));c=v[113382];v[113382]=0;if((c|0)==1){break c}d=d+1|0;if((f|0)!=(d|0)){continue}break}}c=v[v[a>>2]+172>>2];v[113382]=0;Z(c|0,a|0);a=v[113382];v[113382]=0;if((a|0)!=1){break b}}}a=P()|0;O()|0;Bb(e);S(a|0);L()}Bb(e)}jb=b+32|0}function HG(a){var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0;c=v[a+32>>2];b=v[a+1380>>2];a:{b:{if((b|0)==-1){h=1;b=-1;break b}d=v[a+1116>>2];c:{if((d|0)<=(b|0)){break c}while(1){e=w[(a+b|0)+1120|0];c=e+c|0;if((e|0)!=255){break c}b=b+1|0;if((d|0)!=(b|0)){continue}break}b=d}if(y[a+40>>2]<c>>>0){cc(a,1);break a}b=(b|0)==(d|0)?-1:b}d:{while(1){if((b|0)!=-1){return 1}g=v[a+40>>2];if(g>>>0<=c+26>>>0){cc(a,1);break a}if((w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24))!=(w[79712]|w[79713]<<8|(w[79714]<<16|w[79715]<<24))){cc(a,21);break a}if(w[c+4|0]){cc(a,21);break a}e:{if(h){if(!v[a+992>>2]|!(t[c+5|0]&1)){break e}cc(a,21);break a}if(t[c+5|0]&1){break e}cc(a,21);break a}d=c+27|0;e=w[c+26|0];c=d+e|0;if(g>>>0<c>>>0){break d}h=0;b=0;f=0;f:{if(!e){break f}while(1){i=w[b+d|0];c=i+c|0;f=b;if((i|0)!=255){break f}b=b+1|0;if((e|0)!=(b|0)){continue}break}f=e}d=f;b=(d|0)==(e|0)?-1:d;if(c>>>0<=g>>>0){continue}break}cc(a,1);break a}cc(a,1)}return 0}function Hea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,w=0;f=jb-32|0;jb=f;j=v[a+24>>2];k=v[a+20>>2];l=v[a+16>>2];h=v[a+4>>2];i=h;e=v[a>>2];v[f+24>>2]=e;v[f+28>>2]=h;h=v[a+12>>2];v[f+16>>2]=v[a+8>>2];v[f+20>>2]=h;h=a;if(d){while(1){g=(((i&2147483647)<<1|e>>>31)&-2)+l|0;a=(((e>>>16|0)+4&131064)<<1)+b|0;m=u[a+38>>1];n=u[a+36>>1];o=u[a+34>>1];p=u[a+32>>1];q=u[a+30>>1];r=u[a+28>>1];s=u[a+26>>1];w=u[a+24>>1];e=0;a=1;while(1){v[(f+8|0)+(e<<2)>>2]=(((((B(t[(e|4)+g|0],o)+B(t[(e|2)+g|0],p)|0)+B(t[(e|6)+g|0],n)|0)+B(t[(e|8)+g|0],m)<<8)/2|0)+((((B(t[(e|-4)+g|0],s)+B(t[(e|-6)+g|0],w)|0)+B(t[(e|-2)+g|0],r)|0)+B(t[e+g|0],q)<<8)/2|0)|0)/16384;i=a;a=0;e=1;if(i){continue}break}v[c>>2]=v[c>>2]+B(v[f+8>>2],k);v[c+4>>2]=v[c+4>>2]+B(v[f+12>>2],j);Sb(f+24|0,f+16|0);d=d-1|0;if(d){c=c+8|0;e=v[f+24>>2];i=v[f+28>>2];continue}break}e=v[f+24>>2];i=v[f+28>>2]}v[h>>2]=e;v[h+4>>2]=i;jb=f+32|0}function NX(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;c=jb-32|0;jb=c;v[c+28>>2]=0;a:{b:{c:{if(w[cj(c+24|0,a,0)|0]){d=v[v[a>>2]-12>>2];v[113382]=0;Ac(c+16|0,a+d|0);d=v[113382];v[113382]=0;d:{e:{f:{if((d|0)!=1){v[113382]=0;d=T(2708,c+16|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break f}e=tm(c+8|0,a);f=Ik(c);g=v[v[a>>2]-12>>2];f=v[f>>2];e=v[e>>2];v[113382]=0;ka(2709,d|0,e|0,f|0,a+g|0,c+28|0,b|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break f}Ob(c+16|0);break d}b=V(0)|0;O()|0;break e}b=V(0)|0;O()|0;Ob(c+16|0)}_(b|0)|0;b=v[c+28>>2]|1;v[c+28>>2]=b;bj(v[v[a>>2]-12>>2]+a|0,b);b=v[v[a>>2]-12>>2];v[113382]=0;b=v[(a+b|0)+20>>2];d=v[113382];v[113382]=0;g:{if((d|0)!=1){if(!(b&1)){break g}v[113382]=0;Y(81);a=v[113382];v[113382]=0;if((a|0)!=1){break b}}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)==1){break c}S(a|0);L()}$()}Eg(v[v[a>>2]-12>>2]+a|0,v[c+28>>2])}jb=c+32|0;break a}V(0)|0;O()|0;Ab()}L()}return a|0}function KX(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;c=jb-32|0;jb=c;v[c+28>>2]=0;a:{b:{c:{if(w[cj(c+24|0,a,0)|0]){d=v[v[a>>2]-12>>2];v[113382]=0;Ac(c+16|0,a+d|0);d=v[113382];v[113382]=0;d:{e:{f:{if((d|0)!=1){v[113382]=0;d=T(2708,c+16|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break f}e=tm(c+8|0,a);f=Ik(c);g=v[v[a>>2]-12>>2];f=v[f>>2];e=v[e>>2];v[113382]=0;ka(2712,d|0,e|0,f|0,a+g|0,c+28|0,b|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break f}Ob(c+16|0);break d}b=V(0)|0;O()|0;break e}b=V(0)|0;O()|0;Ob(c+16|0)}_(b|0)|0;b=v[c+28>>2]|1;v[c+28>>2]=b;bj(v[v[a>>2]-12>>2]+a|0,b);b=v[v[a>>2]-12>>2];v[113382]=0;b=v[(a+b|0)+20>>2];d=v[113382];v[113382]=0;g:{if((d|0)!=1){if(!(b&1)){break g}v[113382]=0;Y(81);a=v[113382];v[113382]=0;if((a|0)!=1){break b}}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)==1){break c}S(a|0);L()}$()}Eg(v[v[a>>2]-12>>2]+a|0,v[c+28>>2])}jb=c+32|0;break a}V(0)|0;O()|0;Ab()}L()}return a|0}function IX(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;c=jb-32|0;jb=c;v[c+28>>2]=0;a:{b:{c:{if(w[cj(c+24|0,a,0)|0]){d=v[v[a>>2]-12>>2];v[113382]=0;Ac(c+16|0,a+d|0);d=v[113382];v[113382]=0;d:{e:{f:{if((d|0)!=1){v[113382]=0;d=T(2708,c+16|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break f}e=tm(c+8|0,a);f=Ik(c);g=v[v[a>>2]-12>>2];f=v[f>>2];e=v[e>>2];v[113382]=0;ka(2713,d|0,e|0,f|0,a+g|0,c+28|0,b|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break f}Ob(c+16|0);break d}b=V(0)|0;O()|0;break e}b=V(0)|0;O()|0;Ob(c+16|0)}_(b|0)|0;b=v[c+28>>2]|1;v[c+28>>2]=b;bj(v[v[a>>2]-12>>2]+a|0,b);b=v[v[a>>2]-12>>2];v[113382]=0;b=v[(a+b|0)+20>>2];d=v[113382];v[113382]=0;g:{if((d|0)!=1){if(!(b&1)){break g}v[113382]=0;Y(81);a=v[113382];v[113382]=0;if((a|0)!=1){break b}}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)==1){break c}S(a|0);L()}$()}Eg(v[v[a>>2]-12>>2]+a|0,v[c+28>>2])}jb=c+32|0;break a}V(0)|0;O()|0;Ab()}L()}return a|0}function HX(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;c=jb-32|0;jb=c;v[c+28>>2]=0;a:{b:{c:{if(w[cj(c+24|0,a,0)|0]){d=v[v[a>>2]-12>>2];v[113382]=0;Ac(c+16|0,a+d|0);d=v[113382];v[113382]=0;d:{e:{f:{if((d|0)!=1){v[113382]=0;d=T(2708,c+16|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break f}e=tm(c+8|0,a);f=Ik(c);g=v[v[a>>2]-12>>2];f=v[f>>2];e=v[e>>2];v[113382]=0;ka(2714,d|0,e|0,f|0,a+g|0,c+28|0,b|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break f}Ob(c+16|0);break d}b=V(0)|0;O()|0;break e}b=V(0)|0;O()|0;Ob(c+16|0)}_(b|0)|0;b=v[c+28>>2]|1;v[c+28>>2]=b;bj(v[v[a>>2]-12>>2]+a|0,b);b=v[v[a>>2]-12>>2];v[113382]=0;b=v[(a+b|0)+20>>2];d=v[113382];v[113382]=0;g:{if((d|0)!=1){if(!(b&1)){break g}v[113382]=0;Y(81);a=v[113382];v[113382]=0;if((a|0)!=1){break b}}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)==1){break c}S(a|0);L()}$()}Eg(v[v[a>>2]-12>>2]+a|0,v[c+28>>2])}jb=c+32|0;break a}V(0)|0;O()|0;Ab()}L()}return a|0}function Lia(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=jb-16|0;jb=e;t[e+15|0]=4;u[e+12>>1]=0;v[e+8>>2]=0;if(d){k=B(c,d);m=(k|0)<=0;c=0;while(1){if(!m){h=b+j|0;n=k+h|0;while(1){o=c;t[e+7|0]=0;nQ(a,e+14|0,e+12|0,e+7|0);a:{b:{g=w[e+15|0];if(!g){break b}c=x[e+12>>1];while(1){f=c<<1;c=f&254;u[e+12>>1]=c;f=(f&65534)>>>0>255;t[e+14|0]=f;if(!c){if(!Je(a,e+6|0)){break b}c=w[e+6|0];f=c>>>7|0;t[e+14|0]=f;c=c<<1&254|1;u[e+12>>1]=c}i=w[e+7|0]<<1|f;t[e+7|0]=i;g=g-1|0;if(g&255){continue}break}break a}i=w[e+7|0]}c=1;g=i&255;c:{if(g>>>0<4){break c}f=7;while(1){c=f;l=c&255;if(g>>>l&1){break c}f=c-1|0;if(l>>>0>1){continue}break}}t[e+15|0]=(w[e+15|0]+c&254)>>>1;c=i&1;t[e+14|0]=c;f=c-1^(i&254)>>>1;c=f+w[e+8|0]|0;t[e+7|0]=c;t[h|0]=c;v[e+8>>2]=((f>>1)-(o<<24>>24)|0)+(c<<24>>24<<1);Yd(e+8|0,-128,127);h=d+h|0;if(n>>>0>h>>>0){continue}break}}j=j+1|0;if((j|0)!=(d|0)){continue}break}}jb=e+16|0}function waa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=jb-16|0;jb=h;j=h+8|0;m=j;n=c;e=jb-32|0;jb=e;k=b;d=b;b=Ke(b);f=jc(d);a:{b:{if(b){c:{while(1){d:{g=b+16|0;e:{if(CK(zb(d),c,g)){if(!v[b>>2]){break b}f=b;break e}if(!CK(zb(d),g,c)){break c}f=b+4|0;if(!v[b+4>>2]){break d}b=f;f=b}b=v[b>>2];continue}break}v[e+28>>2]=b;b=f;break a}v[e+28>>2]=b;b=f;break a}b=jc(d)}v[e+28>>2]=b}c=b;b=v[b>>2];t[e+27|0]=0;if(!b){g=jb-16|0;jb=g;l=jc(k);b=be(28,4);i=Dk(g+8|0,l);d=jb-16|0;jb=d;v[d+12>>2]=b;v[113382]=0;f=e+8|0;b=f;W(1495,b|0,d+12|0,i|0)|0;i=v[113382];v[113382]=0;f:{if((i|0)!=1){jb=d+16|0;break f}V(0)|0;O()|0;Ab();L()}d=v[b>>2]+16|0;v[113382]=0;U(1494,l|0,d|0,n|0);d=v[113382];v[113382]=0;g:{if((d|0)!=1){o=jc(b),p=1,t[o+4|0]=p;jb=g+16|0;break g}a=P()|0;O()|0;BK(b);S(a|0);L()}Ek(k,v[e+28>>2],c,v[f>>2]);b=ke(f);t[e+27|0]=1;BK(f)}Ei(m,Oc(e+8|0,b),e+27|0);jb=e+32|0;TN(a,j);jb=h+16|0}function Oda(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;f=jb-16|0;jb=f;v[f+12>>2]=b;a:{if(wh(a)>>>0>=b>>>0){n=f,o=ue(a),v[n+8>>2]=o;b=v[a>>2];d=c;k=v[Lb(f+12|0,f+8|0)>>2];if(k){while(1){g=d;if((d|0)!=(b|0)){i=ac(g);l=bc(g);h=jb-16|0;jb=h;j=xA(i,l);e=b;b:{if(j>>>0<=Yf(e)>>>0){if(oc(e)>>>0<j>>>0){v[h+8>>2]=i;m=oc(e);v[h+8>>2]=v[h+8>>2]+(m<<1);wj(i,v[h+8>>2],v[e>>2]);KN(e,v[h+8>>2],l,j-oc(e)|0);break b}Kn(e,wj(i,l,v[e>>2]));break b}JN(e);mz(e,Qi(e,j));KN(e,i,l,j)}jb=h+16|0;Xi(b+12|0,g+12|0);u[b+28>>1]=x[g+28>>1]}b=b+32|0;k=k-1|0;if(k){continue}break}}b=v[f+12>>2];d=v[f+8>>2];if(b>>>0>d>>>0){Ly(a,b-d|0,c);break a}CN(a,v[a>>2]+(b<<5)|0);break a}d=a;if(v[d>>2]){ue(d);yN(d);dv(d);Ug(zb(d),v[d>>2],wh(d));n=zb(d),o=0,v[n>>2]=o;v[d>>2]=0;v[d+4>>2]=0}e=hm(a,b);if(PC(a)>>>0<e>>>0){ld();L()}g=Zn(zb(d),e);v[d>>2]=g;v[d+4>>2]=g;n=zb(d),o=g+(e<<5)|0,v[n>>2]=o;Bq(d,0);Ly(a,b,c)}jb=f+16|0}function $da(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=jb-16|0;jb=h;k=h+8|0;m=k;n=c;e=jb-32|0;jb=e;l=b;d=b;b=Ke(b);f=jc(d);a:{b:{if(b){c:{while(1){d:{g=b+14|0;e:{if(Un(zb(d),c,g)){if(!v[b>>2]){break b}f=b;break e}if(!Un(zb(d),g,c)){break c}f=b+4|0;if(!v[b+4>>2]){break d}b=f;f=b}b=v[b>>2];continue}break}v[e+28>>2]=b;b=f;break a}v[e+28>>2]=b;b=f;break a}b=jc(d)}v[e+28>>2]=b}c=b;b=v[b>>2];t[e+27|0]=0;if(!b){g=jb-16|0;jb=g;i=jc(l);b=Lq(i,1);j=Dk(g+8|0,i);d=jb-16|0;jb=d;v[d+12>>2]=b;v[113382]=0;f=e+8|0;b=f;W(1132,b|0,d+12|0,j|0)|0;j=v[113382];v[113382]=0;f:{if((j|0)!=1){jb=d+16|0;break f}V(0)|0;O()|0;Ab();L()}d=v[b>>2]+14|0;v[113382]=0;U(1131,i|0,d|0,n|0);d=v[113382];v[113382]=0;g:{if((d|0)!=1){o=jc(b),p=1,t[o+4|0]=p;jb=g+16|0;break g}a=P()|0;O()|0;SN(b);S(a|0);L()}Ek(l,v[e+28>>2],c,v[f>>2]);b=ke(f);t[e+27|0]=1;SN(f)}Ei(m,Oc(e+8|0,b),e+27|0);jb=e+32|0;TN(a,k);jb=h+16|0}function TF(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0;h=jb-32|0;jb=h;f=d&2147483647;g=f;e=f-1065418752|0;i=f-1082064896|0;f=c;a:{if((e|0)==(i|0)&f>>>0<f>>>0|e>>>0<i>>>0){g=(d&33554431)<<7|c>>>25;f=0;j=f;i=c&33554431;if(!(!f&(i|0)==16777216?!(a|b):!f&i>>>0<16777216)){e=g+1073741825|0;break a}e=g+1073741824|0;if(i^16777216|a|(b|j)){break a}e=(g&1)+e|0;break a}if(!(!f&(g|0)==2147418112?!(a|b):g>>>0<2147418112)){e=((d&33554431)<<7|c>>>25)&4194303|2143289344;break a}e=2139095040;if(g>>>0>1082064895){break a}e=0;f=g>>>16|0;if(f>>>0<16145){break a}g=c;e=d&65535|65536;ef(h+16|0,a,b,g,e,f-16129|0);kl(h,a,b,g,e,16257-f|0);b=v[h+8>>2];e=(v[h+12>>2]&33554431)<<7|b>>>25;g=v[h+4>>2];f=g;a=0;i=a;j=v[h>>2]|((v[h+16>>2]|v[h+24>>2])!=0|(v[h+20>>2]|v[h+28>>2])!=0);b=b&33554431;if(!(!a&(b|0)==16777216?!(f|j):!a&b>>>0<16777216)){e=e+1|0;break a}if(b^16777216|j|(f|i)){break a}e=(e&1)+e|0}jb=h+32|0;return l(2,d&-2147483648|e),q()}function Vw(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=jb-80|0;jb=c;d=v[a>>2];e=v[d+4>>2];g=v[d+24>>2];v[c+40>>2]=v[d+20>>2];v[c+44>>2]=g;g=v[d+16>>2];v[c+32>>2]=v[d+12>>2];v[c+36>>2]=g;Fh(c- -64|0,c+32|0,e);d=ie(c+48|0,v[v[a+4>>2]>>2],v[v[a+8>>2]>>2],v[v[a+12>>2]>>2]);g=v[v[a+12>>2]>>2];j=v[v[a+8>>2]>>2];a=v[c+76>>2];v[c+24>>2]=v[c+72>>2];v[c+28>>2]=a;a=v[c+68>>2];v[c+16>>2]=v[c+64>>2];v[c+20>>2]=a;v[c+8>>2]=v[d+8>>2];a=v[d+4>>2];v[c>>2]=v[d>>2];v[c+4>>2]=a;k=c+16|0;a=c;d=jb-16|0;jb=d;if(g){l=b+4|0;while(1){e=0;if(j){while(1){f=A[fh(a,e,h)>>3];ec(b,e);m=d,n=+(sj(Md(f*134217728))-1024+((Lr(l)^-2147483648)>>>21)|0)*7.450580596923828e-9,A[m+8>>3]=n;Vf(d+8|0,-1,1);f=A[d+8>>3]*32768;A[d+8>>3]=f;f=Md(f);a:{if(D(f)<2147483648){i=~~f;break a}i=-2147483648}i=Rc(i);m=Lm(k,e,h),o=i,u[m>>1]=o;e=e+1|0;if((j|0)!=(e|0)){continue}break}}h=h+1|0;if((g|0)!=(h|0)){continue}break}}jb=d+16|0;jb=c+80|0}function z3(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=jb+-64|0;jb=e;d=v[b+12>>2];v[e+24>>2]=v[b+8>>2];v[e+28>>2]=d;d=v[b+4>>2];v[e+16>>2]=v[b>>2];v[e+20>>2]=d;k=DP(e+16|0);a:{if(k){h=jb-16|0;jb=h;i=e+40|0;j=i;f=jb-16|0;jb=f;g=jb-16|0;jb=g;d=f;v[d+4>>2]=1;l=d,m=be(324,4),v[l+8>>2]=m;jb=g+16|0;g=v[d+8>>2];v[113382]=0;Q(2169,g|0,b|0)|0;b=v[113382];v[113382]=0;b:{if((b|0)!=1){b=eo(d);co(j,gc(b),b);EH(d);jb=f+16|0;break b}a=P()|0;O()|0;EH(d);S(a|0);L()}break a}h=jb-16|0;jb=h;i=e+32|0;j=i;f=jb-16|0;jb=f;g=jb-16|0;jb=g;d=f;v[d+4>>2]=1;l=d,m=_O(1),v[l+8>>2]=m;jb=g+16|0;g=v[d+8>>2];v[113382]=0;Q(2170,g|0,b|0)|0;b=v[113382];v[113382]=0;c:{if((b|0)!=1){b=eo(d);co(j,gc(b),b);BH(d);jb=f+16|0;break c}a=P()|0;O()|0;BH(d);S(a|0);L()}}jb=h+16|0;b=e+48|0;IC(b,i);d=im(e+56|0,b);f=v[d+4>>2];v[e+8>>2]=v[d>>2];v[e+12>>2]=f;JC(a,e+8|0,c);Bb(b);d:{if(!k){Bb(e+32|0);break d}Bb(e+40|0)}jb=e- -64|0}function BJ(a,b,c){var d=0;a:{b:{switch(b|0){case 0:oJ(a,c);return;case 1:b=0;a=sf(a);d=Db(c);v[113382]=0;R(113,a|0,d|0);d=v[113382];v[113382]=0;c:{if((d|0)!=1){d:{if(Db(c)){while(1){d=t[kc(c,b)|0];e:{if((d|0)>=0){v[113382]=0;R(112,a|0,d&255);d=v[113382];v[113382]=0;if((d|0)!=1){break e}break d}v[113382]=0;R(112,a|0,65533);d=v[113382];v[113382]=0;if((d|0)==1){break d}}b=b+1|0;if(Db(c)>>>0>b>>>0){continue}break}}break c}}break a}return;case 2:b=0;a=sf(a);d=Db(c);v[113382]=0;R(113,a|0,d|0);d=v[113382];v[113382]=0;f:{if((d|0)!=1){g:{if(Db(c)){while(1){d=w[kc(c,b)|0];v[113382]=0;R(112,a|0,d|0);d=v[113382];v[113382]=0;if((d|0)==1){break g}b=b+1|0;if(Db(c)>>>0>b>>>0){continue}break}}break f}}break a}return;case 3:Lo(a,c,17760);return;case 4:Lo(a,c,18784);return;case 5:Lo(a,c,19808);return;case 6:Lo(a,c,20832);return;case 7:Lo(a,c,21856);return;default:break b}}sf(a);return}b=P()|0;O()|0;Jc(a);S(b|0);L()}function kla(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;d=jb-80|0;jb=d;Ee(b);a:{b:{if(Rb(a,1)){c:{d:{e:{f:{g:{h:{while(1){v[113382]=0;e=W(564,a|0,d+16|0,64)|0;f=v[113382];v[113382]=0;if((f|0)==1){break e}v[d+8>>2]=e;e=Db(b);v[113382]=0;v[d+4>>2]=c-e;e=Q(33,d+8|0,d+4|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break h}e=v[e>>2];if(!e){break c}t[d+8|0]=0;f=d+16|0;g=f+e|0;h=d+8|0;e=Qm(f,g,h);i=d,j=tf(b),v[i+8>>2]=j;Hd(d,h);v[113382]=0;aa(565,b|0,v[d>>2],f|0,e|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break g}v[113382]=0;Q(304,a|0,e-(d+16|0)|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break f}if(e>>>0>=g>>>0){continue}break}v[113382]=0;Q(304,a|0,1)|0;a=v[113382];v[113382]=0;if((a|0)!=1){break c}a=V(66740)|0;break d}a=V(66740)|0;break d}a=V(66740)|0;break d}a=V(66740)|0;break d}a=V(66740)|0}if((O()|0)!=(ga(66740)|0)){break b}_(a|0)|0;$()}e=(Db(b)|0)!=0}jb=d+80|0;break a}S(a|0);L()}return e|0}function Lfa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=jb-16|0;jb=h;e=v[a+48>>2];n=v[a+24>>2];o=v[a+20>>2];b=v[a+44>>2];p=v[a+16>>2];i=v[a+4>>2];j=v[a>>2];v[h+8>>2]=j;v[h+12>>2]=i;f=v[a+12>>2];v[h>>2]=v[a+8>>2];v[h+4>>2]=f;a:{if(!d){f=b;b=e;break a}while(1){j=u[(i<<1)+p>>1];g=v[a+60>>2];k=g;f=Yb(b,-16777216,16776704);m=v[a+64>>2];i=Yb(e,-16777216,16776704);q=v[a+72>>2];e=v[c>>2];l=g>>31;j=j<<8;g=j;g=qma(k,l,g,g>>31);k=mb;l=e;e=g;g=qma(m,m>>31,f,f>>31);f=e+g|0;e=mb+k|0;e=f>>>0<g>>>0?e+1|0:e;g=f;f=v[a+68>>2];i=qma(f,f>>31,i,i>>31);f=g+i|0;e=mb+e|0;e=f>>>0<i>>>0?e+1|0:e;f=f+8388608|0;e=f>>>0<8388608?e+1|0:e;e=(e&16777215)<<8|f>>>24;f=(e|0)/256|0;v[c>>2]=l+B(f,o);v[c+4>>2]=v[c+4>>2]+B(f,n);f=e-(j&q)|0;Sb(h+8|0,h);d=d-1|0;if(d){c=c+8|0;i=v[h+12>>2];e=b;b=f;continue}break}j=v[h+8>>2];i=v[h+12>>2]}v[a+48>>2]=b;v[a+44>>2]=f;v[a>>2]=j;v[a+4>>2]=i;jb=h+16|0}function Fga(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;j=jb-112|0;jb=j;a:{b:{if(!Be(a)){break b}if(xc(b)>>>0<2){break b}f=az(j+8|0,a);v[f+20>>2]=0;v[f>>2]=0;c:{d=xc(b);if(d){d:{while(1){c=od(b,g);e=v[a>>2];h=v[c>>2];if(e>>>0<=h>>>0){break d}c=v[c+4>>2];if(c>>>0>e-h>>>0){break d}e=v[f>>2];if(e>>>0>268435456-c>>>0){break d}v[f>>2]=c+e;g=g+1|0;if((d|0)!=(g|0)){continue}break}g=d}if(!qp(f)){break b}if(!g){break c}d=0;c=0;while(1){e=od(b,d);h=v[f+20>>2];v[113382]=0;h=T(423,h|0)|0;i=v[113382];v[113382]=0;if((i|0)==1){break a}i=v[a+20>>2];v[113382]=0;i=T(423,i|0)|0;k=v[113382];v[113382]=0;if((k|0)==1){break a}lc(c+h|0,i+v[e>>2]|0,v[e+4>>2]);v[e>>2]=c;if(!(!d|d>>>0>9)){v[((d<<2)+f|0)- -64>>2]=c}c=v[e+4>>2]+c|0;d=d+1|0;if((g|0)!=(d|0)){continue}break}break c}if(qp(f)){break c}break b}ln(a);az(a,f);v[a+4>>2]=0;v[a+8>>2]=v[a>>2];u[a+34>>1]=x[a+34>>1]|2}jb=j+112|0;return}V(0)|0;O()|0;Ab();L()}function i7(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=C(0),m=0,n=0,o=0,p=0,q=C(0),r=C(0),s=C(0),t=0,u=0,x=0,y=0,A=0,B=C(0);f=jb-16|0;jb=f;a:{if(!v[a+4240>>2]){break a}g=a+44|0;if(!vh(g)){break a}s=z[a+4220>>2];y=f,A=Jd(g,0),v[y+8>>2]=A;y=f,A=Jd(g,1),v[y+12>>2]=A;y=f,A=ed(g,0),v[y>>2]=A;y=f,A=ed(g,1),v[y+4>>2]=A;if(d){m=a+4208|0;j=d;while(1){h=0;i=1;k=0;while(1){n=(w[a+4264|0]?1-k|0:h)&255;t=v[((n<<2)+a|0)+4248>>2];u=v[a+4240>>2];x=v[a+4244>>2];o=h<<2;p=o+(f+8|0)|0;e=v[p>>2];v[p>>2]=e+4;l=z[e>>2];e=x-t|0;q=z[Pb(m,n+((e>>31&u)+e<<1)|0)>>2];r=C(C(z[a+4224>>2]*q)+C(l*z[a+4260>>2]));y=Pb(m,v[a+4244>>2]<<1|h),B=C(D(r))<C(1.0000000195414814e-24)?C(0):r,z[y>>2]=B;h=f+o|0;e=v[h>>2];v[h>>2]=e+4;z[e>>2]=l+C(C(q-l)*s);k=k+1|0;e=i;i=0;h=1;if(e){continue}break}i=v[a+4244>>2]+1|0;v[a+4244>>2]=(i|0)==v[a+4240>>2]?0:i;j=j-1|0;if(j){continue}break}}pi(a,b,c,ed(g,0),ed(g,1),d)}jb=f+16|0}function aj(a,b){var c=0,d=0,e=0,f=0;c=jb+-64|0;jb=c;d=v[v[a>>2]-12>>2]+a|0;e=v[d+16>>2]&-3;zn(d,e);a:{b:{if(w[cj(c+56|0,a,1)|0]){d=v[v[a>>2]-12>>2];v[113382]=0;d=v[(a+d|0)+24>>2];f=v[113382];v[113382]=0;c:{d:{if((f|0)==1){break d}v[113382]=0;f=v[b+12>>2];v[c+16>>2]=v[b+8>>2];v[c+20>>2]=f;f=v[b+4>>2];v[c+8>>2]=v[b>>2];v[c+12>>2]=f;X(2718,c+40|0,d|0,c+8|0,8);b=v[113382];v[113382]=0;if((b|0)==1){break d}b=Qg(c+24|0,-1,-1);v[113382]=0;b=jS(c+40|0,b);d=v[113382];v[113382]=0;if((d|0)==1){break d}b=b?e|4:e;break c}b=V(0)|0;O()|0;_(b|0)|0;b=e|1;bj(v[v[a>>2]-12>>2]+a|0,b);e=v[v[a>>2]-12>>2];v[113382]=0;e=v[(a+e|0)+20>>2];d=v[113382];v[113382]=0;e:{if((d|0)!=1){if(!(e&1)){break e}v[113382]=0;Y(81);a=v[113382];v[113382]=0;if((a|0)!=1){break a}}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)==1){break b}S(a|0);L()}$()}Eg(v[v[a>>2]-12>>2]+a|0,b)}jb=c- -64|0;return}V(0)|0;O()|0;Ab()}L()}function Mfa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=jb-16|0;jb=h;e=v[a+48>>2];n=v[a+24>>2];o=v[a+20>>2];b=v[a+44>>2];p=v[a+16>>2];i=v[a+4>>2];j=v[a>>2];v[h+8>>2]=j;v[h+12>>2]=i;f=v[a+12>>2];v[h>>2]=v[a+8>>2];v[h+4>>2]=f;a:{if(!d){f=b;b=e;break a}while(1){j=t[i+p|0];g=v[a+60>>2];k=g;f=Yb(b,-16777216,16776704);m=v[a+64>>2];i=Yb(e,-16777216,16776704);q=v[a+72>>2];e=v[c>>2];l=g>>31;j=j<<16;g=j;g=qma(k,l,g,g>>31);k=mb;l=e;e=g;g=qma(m,m>>31,f,f>>31);f=e+g|0;e=mb+k|0;e=f>>>0<g>>>0?e+1|0:e;g=f;f=v[a+68>>2];i=qma(f,f>>31,i,i>>31);f=g+i|0;e=mb+e|0;e=f>>>0<i>>>0?e+1|0:e;f=f+8388608|0;e=f>>>0<8388608?e+1|0:e;e=(e&16777215)<<8|f>>>24;f=(e|0)/256|0;v[c>>2]=l+B(f,o);v[c+4>>2]=v[c+4>>2]+B(f,n);f=e-(j&q)|0;Sb(h+8|0,h);d=d-1|0;if(d){c=c+8|0;i=v[h+12>>2];e=b;b=f;continue}break}j=v[h+8>>2];i=v[h+12>>2]}v[a+48>>2]=b;v[a+44>>2]=f;v[a>>2]=j;v[a+4>>2]=i;jb=h+16|0}function H8(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=C(0),h=0,i=0,j=0,k=0,l=0,m=0,n=C(0),o=C(0),p=C(0),q=C(0),r=C(0),s=C(0),t=C(0),u=C(0),w=0,x=C(0);if(v[a+4220>>2]){f=a+44|0;i=Jd(f,0);j=Jd(f,1);k=ed(f,0);l=ed(f,1);if(d){h=a+4208|0;e=v[a+4224>>2];m=d;while(1){n=z[j>>2];o=z[i>>2];e=e-v[a+4228>>2]|0;e=(v[a+4220>>2]&e>>31)+e<<1;p=z[Pb(h,e)>>2];e=Pb(h,e|1);r=z[a+4248>>2];s=z[a+4256>>2];t=z[a+4252>>2];u=z[a+4244>>2];q=z[e>>2];g=C(C(C(C(n*r)+C(o*s))+C(p*t))+C(u*q));w=Pb(h,v[a+4224>>2]<<1),x=C(D(g))<C(1.0000000195414814e-24)?C(0):g,z[w>>2]=x;g=C(C(C(C(r*o)+C(s*n))+C(t*q))+C(u*p));w=Pb(h,v[a+4224>>2]<<1|1),x=C(D(g))<C(1.0000000195414814e-24)?C(0):g,z[w>>2]=x;e=v[a+4224>>2]+1|0;e=(e|0)==v[a+4220>>2]?0:e;v[a+4224>>2]=e;z[k>>2]=C(p*z[a+4236>>2])+C(o*z[a+4240>>2]);z[l>>2]=C(q*z[a+4236>>2])+C(n*z[a+4240>>2]);l=l+4|0;k=k+4|0;j=j+4|0;i=i+4|0;m=m-1|0;if(m){continue}break}}pi(a,b,c,ed(f,0),ed(f,1),d)}}function TH(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=C(0);e=jb-80|0;jb=e;g=a+24|0;Vo(v[g>>2]);t[v[g>>2]+1304512|0]=v[a+52>>2]!=0;c=ie(e+32|0,d,c,b);f=v[a+32>>2];j=z[a+48>>2];v[e+8>>2]=v[c+8>>2];d=v[c+4>>2];v[e>>2]=v[c>>2];v[e+4>>2]=d;d=jb-16|0;jb=d;v[d+8>>2]=v[e+8>>2];c=v[e+4>>2];v[d>>2]=v[e>>2];v[d+4>>2]=c;i=e+48|0;c=i;Nr(c);v[c+8>>2]=f;v[c+4>>2]=0;v[c>>2]=79288;f=v[d+4>>2];v[c+12>>2]=v[d>>2];v[c+16>>2]=f;v[c+20>>2]=v[d+8>>2];z[c+24>>2]=j;v[c>>2]=79240;jb=d+16|0;a:{b:{if(!b){break b}while(1){c=v[g>>2];v[e+24>>2]=b;v[e+28>>2]=0;v[113382]=0;v[e+16>>2]=134217727;v[e+20>>2]=0;d=Q(2122,e+24|0,e+16|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break a}d=v[d>>2];v[113382]=0;c=W(2123,c|0,d|0,i|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break a}h=c+h|0;if(!c){break b}b=b-c|0;if(b){continue}break}}if(!(v[a+52>>2]!=1|h)){a=v[g>>2];v[a+480208>>2]=v[a+480208>>2]&-513}jb=e+80|0;return h}a=P()|0;O()|0;S(a|0);L()}function SH(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=C(0);e=jb-80|0;jb=e;g=a+24|0;Vo(v[g>>2]);t[v[g>>2]+1304512|0]=v[a+52>>2]!=0;c=ie(e+32|0,d,c,b);f=v[a+32>>2];j=z[a+48>>2];v[e+8>>2]=v[c+8>>2];d=v[c+4>>2];v[e>>2]=v[c>>2];v[e+4>>2]=d;d=jb-16|0;jb=d;v[d+8>>2]=v[e+8>>2];c=v[e+4>>2];v[d>>2]=v[e>>2];v[d+4>>2]=c;i=e+48|0;c=i;Nr(c);v[c+8>>2]=f;v[c+4>>2]=0;v[c>>2]=79360;f=v[d+4>>2];v[c+12>>2]=v[d>>2];v[c+16>>2]=f;v[c+20>>2]=v[d+8>>2];z[c+24>>2]=j;v[c>>2]=79312;jb=d+16|0;a:{b:{if(!b){break b}while(1){c=v[g>>2];v[e+24>>2]=b;v[e+28>>2]=0;v[113382]=0;v[e+16>>2]=134217727;v[e+20>>2]=0;d=Q(2122,e+24|0,e+16|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break a}d=v[d>>2];v[113382]=0;c=W(2123,c|0,d|0,i|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break a}h=c+h|0;if(!c){break b}b=b-c|0;if(b){continue}break}}if(!(v[a+52>>2]!=1|h)){a=v[g>>2];v[a+480208>>2]=v[a+480208>>2]&-513}jb=e+80|0;return h}a=P()|0;O()|0;S(a|0);L()}function yK(a,b,c,d,e,f,g,h){var i=0,j=0,k=0,l=0,m=0,n=0;k=jb-16|0;jb=k;t[k+15|0]=c;t[k+14|0]=12;Fg(b,w[pc(k+15|0,k+14|0)|0]);if(Kb(b)){c=0;while(1){a:{b:{c:{switch(h|0){case 0:i=(c<<2)+a|0;j=i+96|0;j=w[j|0]|w[j+1|0]<<8;m=Pb(b,c),n=j,u[m>>1]=n;i=i+98|0;break b;case 1:break c;default:break a}}i=(c<<2)+a|0;j=i+144|0;j=w[j|0]|w[j+1|0]<<8;m=Pb(b,c),n=j,u[m>>1]=n;i=i+146|0}i=w[i|0];m=Pb(b,c),n=i,t[m+2|0]=n}d:{if(!c){break d}i=c-1|0;if(x[Pb(b,c)>>1]>=x[Pb(b,i)>>1]){break d}if(x[Pb(b,c)>>1]>255){break d}j=w[Pb(b,i)+1|0];l=Pb(b,c);u[l>>1]=x[l>>1]|j<<8;if(x[Pb(b,c)>>1]>=x[Pb(b,i)>>1]){break d}i=Pb(b,c);u[i>>1]=x[i>>1]+256}c=c+1|0;if(Kb(b)>>>0>c>>>0){continue}break}}t[b+12|0]=0;e:{if(!(d&1)){break e}if(id(b)){break e}t[b+12|0]=w[b+12|0]|1}if(e>>>0<=11){if(d&2){t[b+12|0]=w[b+12|0]|4}t[b+15|0]=e;t[b+16|0]=e}if(!(g>>>0>11|f>>>0>g>>>0)){if(d&4){t[b+12|0]=w[b+12|0]|2}t[b+14|0]=g;t[b+13|0]=f}jb=k+16|0}function A4(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;v[113382]=0;Z(2057,a|0);e=v[113382];v[113382]=0;a:{b:{c:{d:{e:{if((e|0)==1){break e}v[113382]=0;Z(2010,b|0);e=v[113382];v[113382]=0;if((e|0)==1){break e}e=0;v[113382]=0;Z(2058,c|0);f=v[113382];v[113382]=0;if((f|0)==1){break e}a=Qb(c,0,d);if(!w[b|0]){break b}if(fi(b,3490)|(d|0)!=8){break d}v[a+4>>2]=2059;v[a>>2]=2060;break c}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,8254,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();return 0}if(fi(b,7285)|(d|0)!=64){break b}v[a+60>>2]=2061;v[a+56>>2]=2062;v[a+52>>2]=2063;v[a+48>>2]=2064;v[a+44>>2]=2065;v[a+40>>2]=2066;v[a+36>>2]=2067;v[a+32>>2]=2068;v[a+28>>2]=2069;v[a+24>>2]=2070;v[a+20>>2]=2071;v[a+16>>2]=2072;v[a+12>>2]=2073;v[a+8>>2]=2074;v[a+4>>2]=2075;v[a>>2]=2076}e=1}return e|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function pga(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;f=jb-16|0;jb=f;v[f>>2]=c;v[f+8>>2]=b;if(Jb(f+8|0,f)){while(1){b=d;h=jb-16|0;jb=h;i=f+8|0;c=v[i>>2];if(!(w[c+3|0]!=4|w[c+5|0])){e=h+8|0;_d(e,b,x[b+14>>1]);ce(e,0);t[c+3|0]=0}e=w[c+2|0];if(!(w[c+4|0]|(e|0)!=11)){g=h+8|0;_d(g,b,x[b+14>>1]);ce(g,0);t[c+2|0]=0;e=0}a:{b:{c:{if(!w[c|0]){e=h+8|0;_d(e,b,x[b+14>>1]);if(Cb(e)){break c}e=w[c+2|0]}g=w[c+3|0];j=h+8|0;_d(j,b,x[b+14>>1]);ce(j,(g|0)==4|(e|0)==11);e=w[c+3|0];break b}e=w[c+3|0];g=w[c+2|0];if(!(e|(g|0)==11)){t[c+5|0]=0;t[c+3|0]=4;break a}if(g|(e|0)==4){break b}t[c+4|0]=0;t[c+2|0]=11}d:{if(!(!w[b+16|0]|e)){t[c+5|0]=125;t[c+3|0]=17;break d}e:{switch(e-16|0){case 1:break d;case 0:break e;default:break a}}if(w[c+5|0]){break a}t[c+5|0]=6;t[b+16|0]=1;break a}t[b+16|0]=0}u[b+14>>1]=(x[b+14>>1]+1>>>0)%x[b+12>>1];jb=h+16|0;Bj(i);if(Jb(i,f)){continue}break}}uO(a,d);jb=f+16|0}function VD(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;c=jb-32|0;jb=c;a:{if(w[a+52|0]){d=v[a+48>>2];if(!b){break a}t[a+52|0]=0;v[a+48>>2]=-1;break a}v[c+24>>2]=1;e=v[yf(c+24|0,a+44|0)>>2];f=(e|0)>0?e:0;b:{while(1){if((d|0)!=(f|0)){g=Wq(v[a+32>>2]);if((g|0)==-1){break b}t[(c+24|0)+d|0]=g;d=d+1|0;continue}break}c:{if(w[a+53|0]){t[c+23|0]=w[c+24|0];break c}g=c+24|0;while(1){d:{d=v[a+40>>2];i=v[d>>2];j=v[d+4>>2];h=c+24|0;f=h+e|0;e:{switch(cE(v[a+36>>2],d,h,f,c+16|0,c+23|0,g,c+12|0)-1|0){case 0:break e;case 1:break b;case 2:break d;default:break c}}d=v[a+40>>2];v[d>>2]=i;v[d+4>>2]=j;if((e|0)==8){break b}d=Wq(v[a+32>>2]);if((d|0)==-1){break b}t[f|0]=d;e=e+1|0;continue}break}t[c+23|0]=w[c+24|0]}f:{if(!b){while(1){if((e|0)<=0){break f}e=e-1|0;if((Xq(Hg(t[e+(c+24|0)|0]),v[a+32>>2])|0)!=-1){continue}break b}}k=a,l=Hg(t[c+23|0]),v[k+48>>2]=l}d=Hg(t[c+23|0]);break a}d=-1}jb=c+32|0;return d}function UU(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;b=jb-48|0;jb=b;c=-1;a:{if(!AC(a,b+8|0)){break a}c=0;if(!zK(b+8|0)){break a}d=b+8|0;i=cf(9120);if(i){m=v[a+12>>2];if(yk(a,w[d+16|0]|w[d+17|0]<<8|(w[d+18|0]<<16|w[d+19|0]<<24))){b:{if(!(w[d+12|0]|w[d+13|0]<<8|(w[d+14|0]<<16|w[d+15|0]<<24))){break b}while(1){if(!Ef(a,4)){break b}c:{if((w[d+4|0]|w[d+5|0]<<8)>>>0>=64){c=a;g=lu(a);e=g&63;d:{if(!(g&64)){break d}f=6;while(1){h=lu(c);e=(h&127)<<f|e;if(!(h&128)){break d}h=f>>>0<25;f=f+7|0;if(h){continue}break}}if(((g&128?0-e|0:e)|0)<=0){break c}}e=0;f=1;while(1){c=lu(a);if(c){h=Ko(c<<24>>24);k=e>>>0>=i>>>0;g=k&f;c=g;e:{if(k){break e}c=g;if(!(f&1)){break e}c=w[e+9120|0]==(h&255)}f=c;e=e+1|0;continue}break}Tc(a,4);j=(e|0)==(i|0)?f?1:j:j}l=l+1|0;if(l>>>0<(w[d+12|0]|w[d+13|0]<<8|(w[d+14|0]<<16|w[d+15|0]<<24))>>>0){continue}break}}e=j&1}yk(a,m)}c=e}a=c;jb=b+48|0;return a|0}function oJ(a,b){var c=0,d=0,e=0,f=0,g=0;d=jb-16|0;jb=d;e=sf(a);f=d,g=Bd(b),v[f+8>>2]=g;f=d,g=tf(b),v[f>>2]=g;a:{b:{if(!Jb(d+8|0,d)){break b}a=0;b=0;while(1){c=w[v[d+8>>2]];c:{if(!a){if(!(c&128)){a=0;v[113382]=0;R(112,e|0,c|0);c=v[113382];v[113382]=0;if((c|0)!=1){break c}break a}if((c&224)==192){b=c&31;a=1;break c}if((c&240)==224){b=c&15;a=2;break c}if((c&248)==240){b=c&7;a=3;break c}b=0;v[113382]=0;R(112,e|0,65533);c=v[113382];v[113382]=0;a=0;if((c|0)==1){break a}break c}if((c&192)!=128){v[113382]=0;R(112,e|0,65533);a=v[113382];v[113382]=0;if((a|0)==1){break a}b=c&63;a=-1;break c}c=c&63|b<<6;a=a-1|0;if(a){b=c;break c}b=0;v[113382]=0;R(112,e|0,c|0);c=v[113382];v[113382]=0;a=0;if((c|0)==1){break a}}c=d+8|0;xg(c);if(Jb(c,d)){continue}break}if(!a){break b}v[113382]=0;R(112,e|0,65533);a=v[113382];v[113382]=0;if((a|0)!=1){break b}break a}jb=d+16|0;return}a=P()|0;O()|0;Jc(e);S(a|0);L()}function hfa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=jb-32|0;jb=e;i=v[a+40>>2];j=v[a+36>>2];l=v[a+16>>2];b=v[a+4>>2];f=b;g=v[a>>2];v[e+24>>2]=g;v[e+28>>2]=b;b=v[a+12>>2];v[e+16>>2]=v[a+8>>2];v[e+20>>2]=b;a:{if(d){while(1){k=((((f&2147483647)<<1|g>>>31)&2147483646)<<1)+l|0;b=(g>>>21&2040)+33120|0;g=u[b+6>>1];m=u[b+4>>1];n=u[b+2>>1];o=u[b>>1];h=0;b=1;while(1){f=h<<1;v[(e+8|0)+(h<<2)>>2]=(((B(u[f+k>>1],n)+B(u[(f|-4)+k>>1],o)|0)+B(u[(f|4)+k>>1],m)|0)+B(u[(f|8)+k>>1],g)|0)/16384;f=b;b=0;h=1;if(f){continue}break}b=v[a+32>>2];j=v[a+28>>2]+j|0;h=j>>12;v[c>>2]=v[c>>2]+B(h,v[e+8>>2]);i=b+i|0;b=i>>12;v[c+4>>2]=v[c+4>>2]+B(b,v[e+12>>2]);Sb(e+24|0,e+16|0);d=d-1|0;if(d){c=c+8|0;g=v[e+24>>2];f=v[e+28>>2];continue}break}g=v[e+24>>2];f=v[e+28>>2];break a}b=i>>12;h=j>>12}v[a+40>>2]=i;v[a+20>>2]=h;v[a+36>>2]=j;v[a+24>>2]=b;v[a>>2]=g;v[a+4>>2]=f;jb=e+32|0}function v5(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;c=jb-48|0;jb=c;v[113382]=0;Z(1984,a|0);b=v[113382];v[113382]=0;a:{b:{c:{if((b|0)!=1){d=Xb(c+32|0);b=v[a+24>>2];v[113382]=0;R(2009,c+16|0,b|0);b=v[113382];v[113382]=0;d:{if((b|0)!=1){b=c+16|0;e=c,f=ac(b),v[e+8>>2]=f;e=c,f=bc(b),v[e>>2]=f;if(!Jb(c+8|0,c)){break b}while(1){e:{b=v[c+8>>2];v[113382]=0;Q(1214,d|0,b|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break e}b=c+8|0;vn(b);e=c,f=bc(c+16|0),v[e>>2]=f;if(!Jb(b,c)){break b}v[113382]=0;Q(1964,d|0,10310)|0;b=v[113382];v[113382]=0;if((b|0)!=1){continue}}break}b=V(0)|0;O()|0;gd(c+16|0);break d}b=V(0)|0;O()|0}yb(d);break c}b=V(0)|0;O()|0}_(b|0)|0;b=0;v[113382]=0;X(1958,2920,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)!=1){$();break a}a=P()|0;O()|0;v[113382]=0;Y(20);c=v[113382];v[113382]=0;if((c|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}b=Ud(Tb(d));gd(c+16|0);yb(d)}jb=c+48|0;return b|0}function O4(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;c=jb-48|0;jb=c;v[113382]=0;Z(1984,a|0);b=v[113382];v[113382]=0;a:{b:{c:{if((b|0)!=1){d=Xb(c+32|0);b=v[a+24>>2];v[113382]=0;R(2044,c+16|0,b|0);b=v[113382];v[113382]=0;d:{if((b|0)!=1){b=c+16|0;e=c,f=ac(b),v[e+8>>2]=f;e=c,f=bc(b),v[e>>2]=f;if(!Jb(c+8|0,c)){break b}while(1){e:{b=v[c+8>>2];v[113382]=0;Q(1214,d|0,b|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break e}b=c+8|0;vn(b);e=c,f=bc(c+16|0),v[e>>2]=f;if(!Jb(b,c)){break b}v[113382]=0;Q(1964,d|0,10310)|0;b=v[113382];v[113382]=0;if((b|0)!=1){continue}}break}b=V(0)|0;O()|0;gd(c+16|0);break d}b=V(0)|0;O()|0}yb(d);break c}b=V(0)|0;O()|0}_(b|0)|0;b=0;v[113382]=0;X(1958,3360,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)!=1){$();break a}a=P()|0;O()|0;v[113382]=0;Y(20);c=v[113382];v[113382]=0;if((c|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}b=Ud(Tb(d));gd(c+16|0);yb(d)}jb=c+48|0;return b|0}function Pba(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;h=jb-16|0;jb=h;n=h,o=B(v[a>>2],te(a)),v[n+12>>2]=o;tc(h+12|0,c>>>2|0);c=Eb(b);i=v[e+4>>2];f=v[h+12>>2];a:{if(!f){g=i;break a}while(1){e=Eb(w[c|0]);e=e|Eb(w[c+1|0])<<8|Eb(w[c+2|0])<<16|Eb(w[c+3|0])<<24;b:{if((e|0)<0){g=-2147483648;if((e|0)==-2147483648){break b}e=0-e|0}g=e>>>0>i>>>0?e:i}c=c+4|0;i=g;f=f-1|0;if(f){continue}break}}c:{if(!g){break c}e=v[h+12>>2];if(!e){break c}k=g-1|0;l=g>>>1|0;i=g;c=v[a+20>>2];while(1){a=Eb(w[b|0]);m=c;a=a|Eb(w[b+1|0])<<8|Eb(w[b+2|0])<<16|Eb(w[b+3|0])<<24;j=a>>31;f=a;a=j<<31|a>>>1;f=l|f<<31;d:{if((a|0)>0|(a|0)>=0){a=tma(f,a,i,0);f=mb;break d}j=k;f=tma(j-f|0,0-((f>>>0>j>>>0)+a|0)|0,i,0);a=0-f|0;f=0-(mb+((f|0)!=0)|0)|0}n=m,o=zc(a,f)>>>16|0,u[n>>1]=o;b=b+4|0;c=c+2|0;e=e-1|0;if(e){continue}break}}if(d){v[d>>2]=g}jb=h+16|0;return v[h+12>>2]<<2}function Oba(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;h=jb-16|0;jb=h;n=h,o=B(v[a>>2],te(a)),v[n+12>>2]=o;tc(h+12|0,c>>>2|0);c=Eb(b);i=v[e+4>>2];f=v[h+12>>2];a:{if(!f){g=i;break a}while(1){e=Eb(w[c+3|0]);e=e|Eb(w[c+2|0])<<8|Eb(w[c+1|0])<<16|Eb(w[c|0])<<24;b:{if((e|0)<0){g=-2147483648;if((e|0)==-2147483648){break b}e=0-e|0}g=e>>>0>i>>>0?e:i}c=c+4|0;i=g;f=f-1|0;if(f){continue}break}}c:{if(!g){break c}e=v[h+12>>2];if(!e){break c}k=g-1|0;l=g>>>1|0;i=g;c=v[a+20>>2];while(1){a=Eb(w[b+3|0]);m=c;a=a|Eb(w[b+2|0])<<8|Eb(w[b+1|0])<<16|Eb(w[b|0])<<24;j=a>>31;f=a;a=j<<31|a>>>1;f=l|f<<31;d:{if((a|0)>0|(a|0)>=0){a=tma(f,a,i,0);f=mb;break d}j=k;f=tma(j-f|0,0-((f>>>0>j>>>0)+a|0)|0,i,0);a=0-f|0;f=0-(mb+((f|0)!=0)|0)|0}n=m,o=zc(a,f)>>>16|0,u[n>>1]=o;b=b+4|0;c=c+2|0;e=e-1|0;if(e){continue}break}}if(d){v[d>>2]=g}jb=h+16|0;return v[h+12>>2]<<2}function UV(){var a=0,b=0,c=0,d=0;c=jb-32|0;jb=c;a:{a=Ub(c+16|0,10486);if(!Db(a)){break a}b:{if(($f(a,10335)|0)!=-1){b=$f(a,10335);v[113382]=0;X(202,c|0,a|0,b+1|0,-1);b=v[113382];v[113382]=0;if((b|0)==1){break b}Gb(a,c);yb(c)}if(($f(a,12897)|0)!=-1){b=$f(a,12897);v[113382]=0;X(202,c|0,a|0,b+1|0,-1);b=v[113382];v[113382]=0;if((b|0)==1){break b}Gb(a,c);yb(c)}if(($f(a,9813)|0)!=-1){b=$f(a,9813);v[113382]=0;X(202,c|0,a|0,0,b|0);b=v[113382];v[113382]=0;if((b|0)==1){break b}Gb(a,c);yb(c)}if(($f(a,9701)|0)!=-1){b=$f(a,9701);v[113382]=0;X(202,c|0,a|0,0,b|0);b=v[113382];v[113382]=0;if((b|0)==1){break b}Gb(a,c);yb(c)}if(($f(a,9744)|0)!=-1){b=$f(a,9744);v[113382]=0;X(202,c|0,a|0,0,b|0);b=v[113382];v[113382]=0;if((b|0)==1){break b}Gb(a,c);yb(c)}v[113382]=0;b=T(203,a|0)|0;d=v[113382];v[113382]=0;if((d|0)!=1){break a}}c=P()|0;O()|0;yb(a);S(c|0);L()}yb(a);jb=c+32|0;return b|0}function GZ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=Kb(a);if(c>>>0<b>>>0){h=jb-32|0;jb=h;a:{b:{f=b-c|0;c:{if(f>>>0<=v[zb(a)>>2]-v[a+4>>2]>>2>>>0){Tv(a,f);break c}i=bl(a);e=h+8|0;g=Kb(a)+f|0;d=jb-16|0;jb=d;v[d+12>>2]=g;b=a;d:{c=vE(a);if(g>>>0<=c>>>0){b=nd(b);if(b>>>0<c>>>1>>>0){v[d+8>>2]=b<<1;c=v[Vc(d+8|0,d+12|0)>>2]}jb=d+16|0;break d}ld();L()}g=Kb(a);b=0;d=jb-16|0;jb=d;v[d+12>>2]=0;Le(e+12|0,i);if(c){b=uE(v[e+16>>2],c)}v[e>>2]=b;g=(g<<2)+b|0;v[e+8>>2]=g;v[e+4>>2]=g;j=gc(e),k=(c<<2)+b|0,v[j>>2]=k;jb=d+16|0;d=jb-16|0;jb=d;b=e;c=Sh(d,b+8|0,f);f=v[c>>2];while(1){if(v[c+4>>2]!=(f|0)){Yy(v[b+16>>2],v[c>>2]);f=v[c>>2]+4|0;v[c>>2]=f;continue}break}yc(c);jb=d+16|0;v[113382]=0;R(2442,a|0,e|0);a=v[113382];v[113382]=0;if((a|0)==1){break b}rE(e)}jb=h+32|0;break a}a=P()|0;O()|0;rE(e);S(a|0);L()}return}if(b>>>0<c>>>0){b=v[a>>2]+(b<<2)|0;Kb(a);sE(a,b);ng(a)}}function SD(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;c=jb-32|0;jb=c;a:{if(w[a+52|0]){d=v[a+48>>2];if(!b){break a}t[a+52|0]=0;v[a+48>>2]=-1;break a}v[c+24>>2]=1;e=v[yf(c+24|0,a+44|0)>>2];f=(e|0)>0?e:0;b:{while(1){if((d|0)!=(f|0)){g=Wq(v[a+32>>2]);if((g|0)==-1){break b}t[(c+24|0)+d|0]=g;d=d+1|0;continue}break}c:{if(w[a+53|0]){v[c+20>>2]=t[c+24|0];break c}g=c+24|0;while(1){d:{d=v[a+40>>2];i=v[d>>2];j=v[d+4>>2];h=c+24|0;f=h+e|0;e:{switch(cE(v[a+36>>2],d,h,f,c+16|0,c+20|0,g,c+12|0)-1|0){case 0:break e;case 1:break b;case 2:break d;default:break c}}d=v[a+40>>2];v[d>>2]=i;v[d+4>>2]=j;if((e|0)==8){break b}d=Wq(v[a+32>>2]);if((d|0)==-1){break b}t[f|0]=d;e=e+1|0;continue}break}v[c+20>>2]=t[c+24|0]}f:{if(!b){while(1){if((e|0)<=0){break f}e=e-1|0;if((Xq(t[e+(c+24|0)|0],v[a+32>>2])|0)!=-1){continue}break b}}v[a+48>>2]=v[c+20>>2]}d=v[c+20>>2];break a}d=-1}jb=c+32|0;return d}function ml(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;ek(a);a:{b:{c:{g=v[b+32>>2];d:{if(!g){d=v[b+2084>>2];if(d){break d}break b}f=v[b+4>>2];if((f|0)<9){break c}d=v[b+2084>>2];if(!d){break c}}h=v[a+1392>>2];j=ll(h);e=v[b+2092>>2];if((e|0)>=2){while(1){f=e>>>1|0;i=f+c|0;g=j>>>0<y[(i<<2)+d>>2];c=g?c:i;e=g?f:e-f|0;if((e|0)>1){continue}break}}e=a;d=v[a+1396>>2];c=w[b+23|0]?c:v[v[b+2088>>2]+(c<<2)>>2];b=w[c+v[b+8>>2]|0];e:{if((d|0)<(b|0)){c=-1;a=0;break e}v[a+1392>>2]=h>>>b;a=d-b|0}v[e+1396>>2]=a;return c}if(w[b+23|0]){break a}if((f|0)>0){d=v[b+8>>2];while(1){f:{e=w[c+d|0];if((e|0)==255){break f}h=v[a+1392>>2];if(v[g+(c<<2)>>2]!=(h&(-1<<e^-1))){break f}d=v[a+1396>>2];if((d|0)>=(e|0)){v[a+1392>>2]=h>>>e;v[a+1396>>2]=d-w[v[b+8>>2]+c|0];return c}v[a+1396>>2]=0;break b}c=c+1|0;if((f|0)!=(c|0)){continue}break}}cc(a,21);v[a+1396>>2]=0}return-1}ia(7412,9203,1705,1931);L()}function jw(a){var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;h=cf(a);a:{if(!v[113388]|!w[a|0]){break a}c=a;b:{if(c&3){while(1){b=w[c|0];if(!b|(b|0)==61){break b}c=c+1|0;if(c&3){continue}break}}b=v[c>>2];c:{if((b^-1)&b-16843009&-2139062144){break c}while(1){b=b^1027423549;if((b^-1)&b-16843009&-2139062144){break c}b=v[c+4>>2];c=c+4|0;if(!(b-16843009&(b^-1)&-2139062144)){continue}break}}while(1){b=c;e=w[c|0];if(e){c=b+1|0;if((e|0)!=61){continue}}break}c=b}if(w[c|0]==61?c:0){break a}d=v[v[113388]>>2];if(!d){break a}d:{while(1){i=v[113388];c=a;e=0;g=h;b=0;e:{if(!g){break e}b=w[c|0];f:{if(!b){break f}while(1){g:{j=w[d|0];if(!j){break g}g=g-1|0;if(!g|(b|0)!=(j|0)){break g}d=d+1|0;b=w[c+1|0];c=c+1|0;if(b){continue}break f}break}e=b}b=(e&255)-w[d|0]|0}if(!b){c=v[(f<<2)+i>>2]+h|0;if(w[c|0]==61){break d}}f=f+1|0;d=v[(f<<2)+i>>2];if(d){continue}break}return 0}f=c+1|0}return f}function i9(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;e=jb-32|0;jb=e;v[e+24>>2]=d;j=Lj(a,c);pf(e,v[a+28>>2]);d=v[e+12>>2];v[e+16>>2]=v[e+8>>2];v[e+20>>2]=d;a:{if(!j){if(wd(a,5)){break a}}l=v[e+24>>2];d=jb-48|0;jb=d;h=v[a+28>>2];Mj(h,d+40|0);f=v[d+44>>2];if(!f&y[d+40>>2]>256|f){v[d+40>>2]=256;v[d+44>>2]=0}b:{c:{d:{e:{f:{if(v[d+40>>2]|v[d+44>>2]){while(1){wf(h,d+38|0);f=Xb(d+24|0);v[113382]=0;W(687,h|0,f|0,255)|0;g=v[113382];v[113382]=0;if((g|0)==1){break f}v[113382]=0;U(13,d+8|0,l|0,f|0);g=v[113382];v[113382]=0;if((g|0)==1){break e}v[113382]=0;g=Q(1586,b|0,d+38|0)|0;i=v[113382];v[113382]=0;if((i|0)==1){break d}i=g;g=d+8|0;Gb(i,g);yb(g);yb(f);f=v[d+44>>2];k=k+1|0;if(!f&k>>>0<y[d+40>>2]|f){continue}break}}jb=d+48|0;break b}a=P()|0;O()|0;break c}a=P()|0;O()|0;break c}a=P()|0;O()|0;yb(d+8|0)}yb(f);S(a|0);L()}}$i(a,j,c,e+16|0);jb=e+32|0}function ifa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=jb-32|0;jb=e;i=v[a+40>>2];j=v[a+36>>2];l=v[a+16>>2];b=v[a+4>>2];g=b;h=v[a>>2];v[e+24>>2]=h;v[e+28>>2]=b;b=v[a+12>>2];v[e+16>>2]=v[a+8>>2];v[e+20>>2]=b;a:{if(d){while(1){k=(((g&2147483647)<<1|h>>>31)&-2)+l|0;b=(h>>>21&2040)+33120|0;h=u[b+6>>1];m=u[b+4>>1];n=u[b+2>>1];o=u[b>>1];f=0;b=1;while(1){v[(e+8|0)+(f<<2)>>2]=(((B(t[f+k|0],n)+B(t[(f|-2)+k|0],o)|0)+B(t[(f|2)+k|0],m)|0)+B(t[(f|4)+k|0],h)<<8)/16384;g=b;b=0;f=1;if(g){continue}break}g=v[a+32>>2];j=v[a+28>>2]+j|0;b=j>>12;v[c>>2]=v[c>>2]+B(b,v[e+8>>2]);i=g+i|0;f=i>>12;v[c+4>>2]=v[c+4>>2]+B(f,v[e+12>>2]);Sb(e+24|0,e+16|0);d=d-1|0;if(d){c=c+8|0;h=v[e+24>>2];g=v[e+28>>2];continue}break}h=v[e+24>>2];g=v[e+28>>2];break a}f=i>>12;b=j>>12}v[a+40>>2]=i;v[a+20>>2]=b;v[a+36>>2]=j;v[a+24>>2]=f;v[a>>2]=h;v[a+4>>2]=g;jb=e+32|0}function Bba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;v[a>>2]=b;d=jb-16|0;jb=d;b=rM(Pe(229984),b+1074376|0);c=jb-16|0;jb=c;v[113382]=0;v[c+12>>2]=b;b=d+8|0;W(1340,b|0,c+12|0,c+8|0)|0;e=v[113382];v[113382]=0;a:{b:{if((e|0)!=1){jb=c+16|0;break b}break a}jb=d+16|0;v[a+4>>2]=v[b>>2];d=jb-16|0;jb=d;e=d+8|0;b=jb-16|0;jb=b;v[113382]=0;f=a+8|0;c=f;T(1341,c+4|0)|0;g=v[113382];v[113382]=0;c:{if((g|0)!=1){v[113382]=0;v[b+12>>2]=0;W(1342,c+8|0,b+12|0,e|0)|0;e=v[113382];v[113382]=0;if((e|0)!=1){break c}break a}break a}h=c,i=jc(c),v[h>>2]=i;jb=b+16|0;jb=d+16|0;b=jb-16|0;jb=b;c=a+20|0;v[c>>2]=0;v[c+4>>2]=0;v[113382]=0;v[b+12>>2]=0;W(1343,c+8|0,b+12|0,b+8|0)|0;d=v[113382];v[113382]=0;d:{if((d|0)!=1){jb=b+16|0;break d}break a}v[113382]=0;Z(1303,a|0);b=v[113382];v[113382]=0;if((b|0)!=1){return a|0}b=P()|0;O()|0;pM(c);NL(f);vf(a+4|0);S(b|0);L()}V(0)|0;O()|0;Ab();L()}function Oia(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=jb-16|0;jb=e;t[e+15|0]=8;t[e+14|0]=0;u[e+12>>1]=0;if(d){l=B(c,d);while(1){if((l|0)>0){h=(j<<1)+b|0;n=h+(l<<1)|0;while(1){u[e+10>>1]=0;pQ(a,e+14|0,e+12|0,e+15|0,e+10|0);a:{b:{g=w[e+15|0];if(!g){break b}c=x[e+12>>1];while(1){f=c<<1;c=f&254;u[e+12>>1]=c;f=(f&65534)>>>0>255;t[e+14|0]=f;if(!c){if(!Je(a,e+9|0)){break b}c=w[e+9|0];f=c>>>7|0;t[e+14|0]=f;c=c<<1&254|1;u[e+12>>1]=c}i=x[e+10>>1]<<1|f;u[e+10>>1]=i;g=g-1|0;if(g&255){continue}break}break a}i=x[e+10>>1]}c=1;g=i&65535;c:{if(g>>>0<4){break c}f=15;while(1){c=f;m=c&255;if(g>>>m&1){break c}f=c-1|0;if(m>>>0>1){continue}break}}t[e+15|0]=(w[e+15|0]+c&254)>>>1;c=i&1;t[e+14|0]=c;k=(c-1^(i&65534)>>>1)+k|0;u[e+10>>1]=k;u[h>>1]=k;h=(d<<1)+h|0;if(n>>>0>h>>>0){continue}break}}j=j+1|0;if((j|0)!=(d|0)){continue}break}}jb=e+16|0}function oy(a,b){var c=0,d=0,e=0,f=0,g=0;d=x[a+480188>>1];a:{if(d>>>0<=255){f=a+1304392|0;while(1){e=B(d,896)+a|0;c=e+1075060|0;b:{if(v[c>>2]){break b}if(!oj(e+1074984|0)){break a}if(v[c>>2]){break b}if(w[e+1075073|0]&24){break a}}if(w[e+1075073|0]&2){if(!qd(f)){break a}if(!jM(v[f>>2],d&65535)){break a}}d=d+1|0;if((d&65535)!=256){continue}break}}g=8388608;if(b>>>0<=255){b=B(b,896)+a|0;if(!v[b+1075680>>2]){d=65535;if(v[b+1075060>>2]){break a}}g=v[b+1075672>>2]|v[b+1075664>>2]<<9}d=65535;b=x[a+480188>>1];if(b>>>0>255){break a}e=0;while(1){c=B(b,896)+a|0;if(!(v[c+1075680>>2]?0:v[c+1075060>>2])){f=(v[c+1075672>>2]|v[c+1075664>>2]<<9)>>>(v[c+1075072>>2]>>>1&1)|0;c:{d:{if(f>>>0<g>>>0){c=v[c+1075712>>2];break d}if((f|0)!=(g|0)){break c}c=v[c+1075712>>2];if(e>>>0>=c>>>0){break c}}g=f;d=b;e=c}b=b+1|0;if((b&65535)!=256){continue}break a}break}d=b}return d&65535}function Rw(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=jb-80|0;jb=c;d=v[a>>2];e=v[d+4>>2];v[c+40>>2]=v[d+20>>2];g=v[d+16>>2];v[c+32>>2]=v[d+12>>2];v[c+36>>2]=g;Km(c- -64|0,c+32|0,e);d=ie(c+48|0,v[v[a+4>>2]>>2],v[v[a+8>>2]>>2],v[v[a+12>>2]>>2]);g=v[v[a+12>>2]>>2];j=v[v[a+8>>2]>>2];v[c+24>>2]=v[c+72>>2];a=v[c+68>>2];v[c+16>>2]=v[c+64>>2];v[c+20>>2]=a;v[c+8>>2]=v[d+8>>2];a=v[d+4>>2];v[c>>2]=v[d>>2];v[c+4>>2]=a;k=c+16|0;a=c;d=jb-16|0;jb=d;if(g){l=b+4|0;while(1){e=0;if(j){while(1){f=A[fh(a,e,h)>>3];ec(b,e);m=d,n=+(sj(Md(f*134217728))-1024+((Lr(l)^-2147483648)>>>21)|0)*7.450580596923828e-9,A[m+8>>3]=n;Vf(d+8|0,-1,1);f=A[d+8>>3]*32768;A[d+8>>3]=f;f=Md(f);a:{if(D(f)<2147483648){i=~~f;break a}i=-2147483648}i=Rc(i);m=Jm(k,e,h),o=i,u[m>>1]=o;e=e+1|0;if((j|0)!=(e|0)){continue}break}}h=h+1|0;if((g|0)!=(h|0)){continue}break}}jb=d+16|0;jb=c+80|0}function br(a){a=a|0;var b=0,c=0,d=0,e=0;d=jb-16|0;jb=d;c=v[v[a>>2]-12>>2];v[113382]=0;c=v[(a+c|0)+24>>2];b=v[113382];v[113382]=0;a:{b:{c:{d:{e:{if((b|0)!=1){if(!c){break b}v[113382]=0;c=Q(15,d+8|0,a|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break d}if(!w[c|0]){break e}b=v[v[a>>2]-12>>2];v[113382]=0;b=v[(a+b|0)+24>>2];e=v[113382];v[113382]=0;f:{if((e|0)==1){break f}v[113382]=0;b=T(2707,b|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break f}if((b|0)!=-1){break e}b=v[v[a>>2]-12>>2];v[113382]=0;R(18,a+b|0,1);b=v[113382];v[113382]=0;if((b|0)!=1){break e}}b=V(0)|0;O()|0;Kf(c);break c}b=V(0)|0;O()|0;break c}Kf(c);break b}b=V(0)|0;O()|0}_(b|0)|0;c=v[v[a>>2]-12>>2];v[113382]=0;Z(19,a+c|0);c=v[113382];v[113382]=0;if((c|0)==1){break a}$()}jb=d+16|0;return a|0}a=P()|0;O()|0;v[113382]=0;Y(20);c=v[113382];v[113382]=0;if((c|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function Rba(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;h=jb-16|0;jb=h;n=h,o=B(v[a>>2],te(a)),v[n+12>>2]=o;tc(h+12|0,(c>>>0)/3|0);c=Eb(b);i=v[e+4>>2];f=v[h+12>>2];a:{if(!f){g=i;break a}while(1){e=Eb(w[c|0]);e=Eb(w[c+1|0])<<16|e<<8|Eb(w[c+2|0])<<24;b:{if((e|0)<0){g=-2147483648;if((e|0)==-2147483648){break b}e=0-e|0}g=e>>>0>i>>>0?e:i}c=c+3|0;i=g;f=f-1|0;if(f){continue}break}}c:{if(!g){break c}e=v[h+12>>2];if(!e){break c}k=g-1|0;l=g>>>1|0;i=g;c=v[a+20>>2];while(1){a=Eb(w[b|0]);m=c;a=Eb(w[b+1|0])<<16|a<<8|Eb(w[b+2|0])<<24;j=a>>31;f=a;a=j<<31|a>>>1;f=l|f<<31;d:{if((a|0)>0|(a|0)>=0){a=tma(f,a,i,0);f=mb;break d}j=k;f=tma(j-f|0,0-((f>>>0>j>>>0)+a|0)|0,i,0);a=0-f|0;f=0-(mb+((f|0)!=0)|0)|0}n=m,o=zc(a,f)>>>16|0,u[n>>1]=o;b=b+3|0;c=c+2|0;e=e-1|0;if(e){continue}break}}if(d){v[d>>2]=g}jb=h+16|0;return B(v[h+12>>2],3)|0}function Qba(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;h=jb-16|0;jb=h;n=h,o=B(v[a>>2],te(a)),v[n+12>>2]=o;tc(h+12|0,(c>>>0)/3|0);c=Eb(b);i=v[e+4>>2];f=v[h+12>>2];a:{if(!f){g=i;break a}while(1){e=Eb(w[c+2|0]);e=Eb(w[c+1|0])<<16|e<<8|Eb(w[c|0])<<24;b:{if((e|0)<0){g=-2147483648;if((e|0)==-2147483648){break b}e=0-e|0}g=e>>>0>i>>>0?e:i}c=c+3|0;i=g;f=f-1|0;if(f){continue}break}}c:{if(!g){break c}e=v[h+12>>2];if(!e){break c}k=g-1|0;l=g>>>1|0;i=g;c=v[a+20>>2];while(1){a=Eb(w[b+2|0]);m=c;a=Eb(w[b+1|0])<<16|a<<8|Eb(w[b|0])<<24;j=a>>31;f=a;a=j<<31|a>>>1;f=l|f<<31;d:{if((a|0)>0|(a|0)>=0){a=tma(f,a,i,0);f=mb;break d}j=k;f=tma(j-f|0,0-((f>>>0>j>>>0)+a|0)|0,i,0);a=0-f|0;f=0-(mb+((f|0)!=0)|0)|0}n=m,o=zc(a,f)>>>16|0,u[n>>1]=o;b=b+3|0;c=c+2|0;e=e-1|0;if(e){continue}break}}if(d){v[d>>2]=g}jb=h+16|0;return B(v[h+12>>2],3)|0}function I4(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;e=jb-32|0;jb=e;v[113382]=0;Z(1984,a|0);d=v[113382];v[113382]=0;a:{b:{c:{d:{e:{f:{g:{if((d|0)==1){break g}v[113382]=0;Z(2010,b|0);d=v[113382];v[113382]=0;if((d|0)==1){break g}v[113382]=0;Z(2010,c|0);d=v[113382];v[113382]=0;if((d|0)==1){break g}d=v[a+24>>2];v[113382]=0;b=Q(121,e+16|0,b|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break g}v[113382]=0;c=Q(121,e|0,c|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break f}v[113382]=0;X(2050,d|0,b|0,c|0,1);d=v[113382];v[113382]=0;if((d|0)==1){break e}yb(c);yb(b);b=1;break b}d=V(0)|0;O()|0;break c}d=V(0)|0;O()|0;break d}d=V(0)|0;O()|0;yb(c)}yb(b)}_(d|0)|0;b=0;v[113382]=0;X(1958,2763,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$()}jb=e+32|0;return b|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function u3(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=jb+-64|0;jb=e;v[e+56>>2]=c;h=Io(a,e+56|0);i=RH(a+4|0);j=QH(a+24|0);k=PH(a+32|0);l=bx(a+36|0);v[a+56>>2]=3;m=ih(a+68|0);v[113382]=0;R(2133,a|0,d|0);c=v[113382];v[113382]=0;a:{b:{c:{d:{if((c|0)!=1){c=v[b>>2];f=v[b+4>>2];g=v[b+12>>2];b=v[b+8>>2];v[e+16>>2]=b;v[e+20>>2]=g;v[113382]=0;v[e+32>>2]=b;v[e+36>>2]=g;v[e+24>>2]=c;v[e+28>>2]=f;v[e+8>>2]=c;v[e+12>>2]=f;U(2130,e+40|0,e+8|0,0);b=v[113382];v[113382]=0;if((b|0)==1){break d}v[113382]=0;U(2134,a|0,e+40|0,d|0);b=v[113382];v[113382]=0;if((b|0)==1){break c}Bb(e+40|0);v[113382]=0;Z(2135,a|0);b=v[113382];v[113382]=0;if((b|0)==1){break b}ad(e+56|0);jb=e- -64|0;return a|0}a=P()|0;O()|0;break a}a=P()|0;O()|0;break a}a=P()|0;O()|0;Bb(e+40|0);break a}a=P()|0;O()|0}gd(m);qf(l);vf(k);Gh(j);ad(i);ad(h);ad(e+56|0);S(a|0);L()}function a5(a,b){a=a|0;b=b|0;var c=0,d=0;d=jb-16|0;jb=d;v[113382]=0;Z(1984,a|0);c=v[113382];v[113382]=0;a:{b:{c:{d:{e:{f:{g:{h:{i:{if((c|0)!=1){c=v[a+24>>2];v[113382]=0;R(2030,d|0,c|0);c=v[113382];v[113382]=0;if((c|0)==1){break i}if(xc(d)>>>0<2147483647){break h}c=ba(8)|0;v[113382]=0;Q(2031,c|0,3641)|0;b=v[113382];v[113382]=0;if((b|0)==1){break g}v[113382]=0;U(1978,c|0,67068,235);b=v[113382];v[113382]=0;if((b|0)!=1){break b}b=V(0)|0;O()|0;break f}b=V(0)|0;O()|0;break e}b=V(0)|0;O()|0;break e}a=17540;j:{if((b|0)<0){break j}a=17540;if((xc(d)|0)<=(b|0)){break j}a=Tb(od(d,b))}b=Ud(a);gd(d);break d}b=V(0)|0;O()|0;ca(c|0)}gd(d)}_(b|0)|0;b=0;v[113382]=0;X(1958,7909,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break c}$()}jb=d+16|0;return b|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){break a}V(0)|0;O()|0;Ab()}L()}S(a|0);L()}function _4(a,b){a=a|0;b=b|0;var c=0,d=0;d=jb-16|0;jb=d;v[113382]=0;Z(1984,a|0);c=v[113382];v[113382]=0;a:{b:{c:{d:{e:{f:{g:{h:{i:{if((c|0)!=1){c=v[a+24>>2];v[113382]=0;R(2033,d|0,c|0);c=v[113382];v[113382]=0;if((c|0)==1){break i}if(xc(d)>>>0<2147483647){break h}c=ba(8)|0;v[113382]=0;Q(2031,c|0,3641)|0;b=v[113382];v[113382]=0;if((b|0)==1){break g}v[113382]=0;U(1978,c|0,67068,235);b=v[113382];v[113382]=0;if((b|0)!=1){break b}b=V(0)|0;O()|0;break f}b=V(0)|0;O()|0;break e}b=V(0)|0;O()|0;break e}a=17540;j:{if((b|0)<0){break j}a=17540;if((xc(d)|0)<=(b|0)){break j}a=Tb(od(d,b))}b=Ud(a);gd(d);break d}b=V(0)|0;O()|0;ca(c|0)}gd(d)}_(b|0)|0;b=0;v[113382]=0;X(1958,7815,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break c}$()}jb=d+16|0;return b|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){break a}V(0)|0;O()|0;Ab()}L()}S(a|0);L()}function Z4(a,b){a=a|0;b=b|0;var c=0,d=0;d=jb-16|0;jb=d;v[113382]=0;Z(1984,a|0);c=v[113382];v[113382]=0;a:{b:{c:{d:{e:{f:{g:{h:{i:{if((c|0)!=1){c=v[a+24>>2];v[113382]=0;R(2034,d|0,c|0);c=v[113382];v[113382]=0;if((c|0)==1){break i}if(xc(d)>>>0<2147483647){break h}c=ba(8)|0;v[113382]=0;Q(2031,c|0,3641)|0;b=v[113382];v[113382]=0;if((b|0)==1){break g}v[113382]=0;U(1978,c|0,67068,235);b=v[113382];v[113382]=0;if((b|0)!=1){break b}b=V(0)|0;O()|0;break f}b=V(0)|0;O()|0;break e}b=V(0)|0;O()|0;break e}a=17540;j:{if((b|0)<0){break j}a=17540;if((xc(d)|0)<=(b|0)){break j}a=Tb(od(d,b))}b=Ud(a);gd(d);break d}b=V(0)|0;O()|0;ca(c|0)}gd(d)}_(b|0)|0;b=0;v[113382]=0;X(1958,7845,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break c}$()}jb=d+16|0;return b|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){break a}V(0)|0;O()|0;Ab()}L()}S(a|0);L()}function Y4(a,b){a=a|0;b=b|0;var c=0,d=0;d=jb-16|0;jb=d;v[113382]=0;Z(1984,a|0);c=v[113382];v[113382]=0;a:{b:{c:{d:{e:{f:{g:{h:{i:{if((c|0)!=1){c=v[a+24>>2];v[113382]=0;R(2035,d|0,c|0);c=v[113382];v[113382]=0;if((c|0)==1){break i}if(xc(d)>>>0<2147483647){break h}c=ba(8)|0;v[113382]=0;Q(2031,c|0,3641)|0;b=v[113382];v[113382]=0;if((b|0)==1){break g}v[113382]=0;U(1978,c|0,67068,235);b=v[113382];v[113382]=0;if((b|0)!=1){break b}b=V(0)|0;O()|0;break f}b=V(0)|0;O()|0;break e}b=V(0)|0;O()|0;break e}a=17540;j:{if((b|0)<0){break j}a=17540;if((xc(d)|0)<=(b|0)){break j}a=Tb(od(d,b))}b=Ud(a);gd(d);break d}b=V(0)|0;O()|0;ca(c|0)}gd(d)}_(b|0)|0;b=0;v[113382]=0;X(1958,7780,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break c}$()}jb=d+16|0;return b|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){break a}V(0)|0;O()|0;Ab()}L()}S(a|0);L()}function X4(a,b){a=a|0;b=b|0;var c=0,d=0;d=jb-16|0;jb=d;v[113382]=0;Z(1984,a|0);c=v[113382];v[113382]=0;a:{b:{c:{d:{e:{f:{g:{h:{i:{if((c|0)!=1){c=v[a+24>>2];v[113382]=0;R(2036,d|0,c|0);c=v[113382];v[113382]=0;if((c|0)==1){break i}if(xc(d)>>>0<2147483647){break h}c=ba(8)|0;v[113382]=0;Q(2031,c|0,3641)|0;b=v[113382];v[113382]=0;if((b|0)==1){break g}v[113382]=0;U(1978,c|0,67068,235);b=v[113382];v[113382]=0;if((b|0)!=1){break b}b=V(0)|0;O()|0;break f}b=V(0)|0;O()|0;break e}b=V(0)|0;O()|0;break e}a=17540;j:{if((b|0)<0){break j}a=17540;if((xc(d)|0)<=(b|0)){break j}a=Tb(od(d,b))}b=Ud(a);gd(d);break d}b=V(0)|0;O()|0;ca(c|0)}gd(d)}_(b|0)|0;b=0;v[113382]=0;X(1958,7941,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break c}$()}jb=d+16|0;return b|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){break a}V(0)|0;O()|0;Ab()}L()}S(a|0);L()}function $4(a,b){a=a|0;b=b|0;var c=0,d=0;d=jb-16|0;jb=d;v[113382]=0;Z(1984,a|0);c=v[113382];v[113382]=0;a:{b:{c:{d:{e:{f:{g:{h:{i:{if((c|0)!=1){c=v[a+24>>2];v[113382]=0;R(2032,d|0,c|0);c=v[113382];v[113382]=0;if((c|0)==1){break i}if(xc(d)>>>0<2147483647){break h}c=ba(8)|0;v[113382]=0;Q(2031,c|0,3641)|0;b=v[113382];v[113382]=0;if((b|0)==1){break g}v[113382]=0;U(1978,c|0,67068,235);b=v[113382];v[113382]=0;if((b|0)!=1){break b}b=V(0)|0;O()|0;break f}b=V(0)|0;O()|0;break e}b=V(0)|0;O()|0;break e}a=17540;j:{if((b|0)<0){break j}a=17540;if((xc(d)|0)<=(b|0)){break j}a=Tb(od(d,b))}b=Ud(a);gd(d);break d}b=V(0)|0;O()|0;ca(c|0)}gd(d)}_(b|0)|0;b=0;v[113382]=0;X(1958,7877,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break c}$()}jb=d+16|0;return b|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){break a}V(0)|0;O()|0;Ab()}L()}S(a|0);L()}function WL(a,b,c){var d=0,e=0,f=0;e=jb-16|0;jb=e;a:{if(v[a+480180>>2]==4){d=w[b+833|0];if(c){t[b+833|0]=d&15|c<<4;break a}c=(d&240)>>>4|0;break a}if(v[a+480180>>2]!=1048576){break a}if(c){t[b+833|0]=c;break a}c=w[b+833|0]}b:{if(!(t[b+872|0]&1)){break b}d=v[b+700>>2];if(!d|!(c&255)){break b}c:{if(!(w[a+480208|0]&16)){break c}d=v[b+700>>2];if(v[a+480180>>2]==4){break c}c=iy(a,c&15);f=qma(c,c>>31,d,d>>31)+32768|0;c=mb;c=zc(rma(f,f>>>0<32768?c+1|0:c,65536,0),mb);v[b+700>>2]=c;if((c|0)!=(d|0)){break b}c=e+8|0;a=a+1074312|0;Fb(c,a,7);if(!(!Cb(c)|v[b+700>>2]==2147483647)){v[b+700>>2]=v[b+700>>2]+1;break b}c=e+8|0;Fb(c,a,7);if(Cb(c)){break b}a=v[b+700>>2];if((a|0)<2){break b}v[b+700>>2]=a-1;break b}c=d-((c&255)<<2)|0;v[b+700>>2]=c;if((c|0)>0){break b}v[b+700>>2]=1;if(v[a+480180>>2]!=2){break b}v[b+696>>2]=0;v[b+88>>2]=v[b+88>>2]|2101248}jb=e+16|0}function OL(a,b,c,d){var e=0,f=0;e=jb-16|0;jb=e;v[e+12>>2]=b;f=0;a:{if(!b){break a}if(v[a+480180>>2]&20){c=a+1074312|0;Fb(e,c,73);b=Cb(e)?b&65535:b;if(w[a+480208|0]&16){Fb(e,c,73);a=Cb(e)?14-((9983-b>>>0)/768|0)&31:((b>>>0)/768|0)+2|0;f=v[((b>>>0)%768<<2)+27344>>2]<<6>>>a|0;break a}if(!b){v[e+12>>2]=1;b=1}f=229079296/(b>>>0)|0;break a}f=227001280/(b>>>0)|0;if(Op(a)){break a}f=(b+c<<4)-133808|0;if(v[a+480180>>2]==64){break a}b=v[a+480180>>2];tc(e+12|0,16777215);if(b&17408){f=dd(tma(qma(c?c:8363,0,3506176,0),mb,(v[e+12>>2]<<8)+d|0,0),mb);break a}if(w[a+480208|0]&16){Fb(e,a+1074312|0,7);if(Cb(e)){c=d>>31;b=d;a=v[e+12>>2];d=a>>>24|0;f=a<<8;b=b+f|0;a=c+d|0;a=b>>>0<f>>>0?a+1|0:a;f=(a&15)<<28|b>>>4;break a}f=dd(tma(qma(c?c:8363,0,7012352,0),mb,(v[e+12>>2]<<8)+d|0,0),mb);break a}f=dd(tma(-1485242368,13,(v[e+12>>2]<<8)+d|0,0),mb)}jb=e+16|0;return f}function bQ(a){var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;b=a;d=b+20|0;while(1){f=c;c=t[b|0];c=f+((c&255)!=0&(c|0)<32)|0;b=b+1|0;if((d|0)!=(b|0)){continue}break}a:{if(c>>>0>5){break a}while(1){b=0;d=B(g,30)+a|0;e=d+20|0;j=e+22|0;while(1){f=b;b=t[e|0];b=f+((b&255)!=0&(b|0)<32)|0;e=e+1|0;if((j|0)!=(e|0)){continue}break}c=b+c|0;if(w[d+44|0]|(c>>>0>48|w[d+45|0]>64)){break a}b=w[d+42|0]|w[d+43|0]<<8;if(((b<<8|b>>>8)&65535)>>>0>32768){break a}b=w[d+42|0]|w[d+43|0]<<8;h=((b<<8|b>>>8)&65535)+h|0;i=w[d+45|0]|i;g=g+1|0;if((g|0)!=15){continue}break}if(!h|!(i&255)|w[a+470|0]>128|w[a+471|0]>220){break a}e=jb-16|0;jb=e;b=a+472|0;d=b+128|0;b:{if((b|0)==(d|0)){break b}c=b+1|0;if((d|0)==(c|0)){break b}while(1){b=w[b|0]<w[c|0]?c:b;c=c+1|0;if((d|0)!=(c|0)){continue}break}}jb=e+16|0;b=w[b|0];if(b>>>0>63|!(b|w[a+470|0]?1:w[a+471|0])){break a}k=1}return k}function Eea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;g=jb-16|0;jb=g;i=v[a+40>>2];j=v[a+36>>2];l=v[a+16>>2];h=v[a+4>>2];e=h;f=v[a>>2];v[g+8>>2]=f;v[g+12>>2]=e;h=v[a+12>>2];v[g>>2]=v[a+8>>2];v[g+4>>2]=h;a:{if(d){while(1){k=v[a+32>>2];j=v[a+28>>2]+j|0;h=j>>12;e=(e<<1)+l|0;f=(((f>>>16|0)+4&131064)<<1)+b|0;e=(((((B(u[e+4>>1],u[f+34>>1])+B(u[e+2>>1],u[f+32>>1])|0)+B(u[e+6>>1],u[f+36>>1])|0)+B(u[e+8>>1],u[f+38>>1])|0)/2|0)+((((B(u[e-4>>1],u[f+26>>1])+B(u[e-6>>1],u[f+24>>1])|0)+B(u[e-2>>1],u[f+28>>1])|0)+B(u[e>>1],u[f+30>>1])|0)/2|0)|0)/16384|0;v[c>>2]=v[c>>2]+B(h,e);i=i+k|0;k=i>>12;v[c+4>>2]=v[c+4>>2]+B(e,k);Sb(g+8|0,g);d=d-1|0;if(d){c=c+8|0;f=v[g+8>>2];e=v[g+12>>2];continue}break}f=v[g+8>>2];e=v[g+12>>2];break a}k=i>>12;h=j>>12}v[a+40>>2]=i;v[a+20>>2]=h;v[a+36>>2]=j;v[a+24>>2]=k;v[a>>2]=f;v[a+4>>2]=e;jb=g+16|0}function Nia(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=jb-16|0;jb=e;t[e+15|0]=4;t[e+14|0]=0;u[e+12>>1]=0;if(d){l=B(c,d);n=(l|0)<=0;while(1){if(!n){h=b+j|0;o=l+h|0;while(1){t[e+11|0]=0;nQ(a,e+14|0,e+12|0,e+11|0);a:{b:{g=w[e+15|0];if(!g){break b}c=x[e+12>>1];while(1){f=c<<1;c=f&254;u[e+12>>1]=c;f=(f&65534)>>>0>255;t[e+14|0]=f;if(!c){if(!Je(a,e+10|0)){break b}c=w[e+10|0];f=c>>>7|0;t[e+14|0]=f;c=c<<1&254|1;u[e+12>>1]=c}i=w[e+11|0]<<1|f;t[e+11|0]=i;g=g-1|0;if(g&255){continue}break}break a}i=w[e+11|0]}c=1;g=i&255;c:{if(g>>>0<4){break c}f=7;while(1){c=f;m=c&255;if(g>>>m&1){break c}f=c-1|0;if(m>>>0>1){continue}break}}t[e+15|0]=(w[e+15|0]+c&254)>>>1;c=i&1;t[e+14|0]=c;k=(c-1^(i&254)>>>1)+k|0;t[e+11|0]=k;t[h|0]=k;h=d+h|0;if(o>>>0>h>>>0){continue}break}}j=j+1|0;if((j|0)!=(d|0)){continue}break}}jb=e+16|0}function mF(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0,j=0;d=jb-32|0;jb=d;v[113382]=0;g=Q(15,d+24|0,a|0)|0;e=v[113382];v[113382]=0;a:{b:{c:{if((e|0)!=1){d:{e:{if(!w[g|0]){break e}e=Tk(d+8|0,a);f=v[v[a>>2]-12>>2];h=v[(f+a|0)+4>>2];v[113382]=0;f=a+f|0;i=T(16,f|0)|0;j=v[113382];v[113382]=0;if((j|0)==1){break d}e=v[e>>2];v[113382]=0;c=b+c|0;b=ka(17,e|0,b|0,((h&176)==32?c:b)|0,c|0,f|0,i|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break d}v[d+16>>2]=b;if(!Rk(d+16|0)){break e}b=v[v[a>>2]-12>>2];v[113382]=0;R(18,a+b|0,5);b=v[113382];v[113382]=0;if((b|0)!=1){break e}break d}Kf(g);break b}b=V(0)|0;O()|0;Kf(g);break c}b=V(0)|0;O()|0}_(b|0)|0;b=v[v[a>>2]-12>>2];v[113382]=0;Z(19,a+b|0);b=v[113382];v[113382]=0;if((b|0)==1){break a}$()}jb=d+32|0;return a}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)==1){V(0)|0;O()|0;Ab();L()}S(a|0);L()}function jq(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;f=jb-16|0;jb=f;a:{if(!b){break a}if(c){c=Dd(f+8|0,a);a=jb-16|0;jb=a;v[a+12>>2]=b;d=v[c+4>>2];b:{if(!d){d=v[c>>2];break b}v[a+8>>2]=32-d;b=Lb(a+8|0,a+12|0);d=v[c>>2];b=v[b>>2];v[d>>2]=v[d>>2]|-1<<v[c+4>>2]&-1>>>v[a+8>>2]-b;b=v[a+12>>2]-b|0;v[a+12>>2]=b;d=d+4|0;v[c>>2]=d}e=d;d=b>>>5<<2;Qb(e,255,d);b=v[a+12>>2]-(b&-32)|0;v[a+12>>2]=b;if(b){e=c;c=d+v[c>>2]|0;v[e>>2]=c;v[c>>2]=v[c>>2]|-1>>>32-b}jb=a+16|0;break a}c=Dd(f,a);a=jb-16|0;jb=a;v[a+12>>2]=b;d=v[c+4>>2];c:{if(!d){d=v[c>>2];break c}v[a+8>>2]=32-d;b=Lb(a+8|0,a+12|0);d=v[c>>2];b=v[b>>2];v[d>>2]=v[d>>2]&(-1<<v[c+4>>2]&-1>>>v[a+8>>2]-b^-1);b=v[a+12>>2]-b|0;v[a+12>>2]=b;d=d+4|0;v[c>>2]=d}e=d;d=b>>>5<<2;Qb(e,0,d);b=v[a+12>>2]-(b&-32)|0;v[a+12>>2]=b;if(b){e=c;c=d+v[c>>2]|0;v[e>>2]=c;v[c>>2]=v[c>>2]&(-1>>>32-b^-1)}jb=a+16|0}jb=f+16|0}function MG(a,b,c,d){var e=0,f=0,g=0,h=C(0),i=0,j=C(0),k=0,l=C(0),m=C(0),n=C(0),o=0;e=jb-96|0;jb=e;if((d|0)>0){while(1){z[e+48>>2]=-z[a>>2];z[e>>2]=z[a+68>>2];f=0;while(1){g=(e+48|0)+(f<<3)|0;i=(f<<4)+a|0;j=z[i+8>>2];h=z[i+4>>2];z[g+4>>2]=j+h;k=f<<1;z[(8-k<<2)+e>>2]=h-j;j=z[i+16>>2];h=z[i+12>>2];z[(7-k<<2)+e>>2]=j-h;z[g+8>>2]=-C(h+j);f=f+1|0;if((f|0)!=4){continue}break}LG(e+48|0);LG(e);z[e+4>>2]=-z[e+4>>2];z[e+12>>2]=-z[e+12>>2];z[e+20>>2]=-z[e+20>>2];z[e+28>>2]=-z[e+28>>2];i=0;while(1){f=i<<2;g=f+b|0;j=z[g>>2];k=g;h=z[f+45984>>2];l=z[f+(e+48|0)>>2];m=z[e+f>>2];g=f+36|0;n=z[g+45984>>2];z[k>>2]=C(h*l)-C(m*n);k=a+f|0;f=c+f|0;g=c+g|0;h=C(C(h*m)+C(n*l));z[k>>2]=C(j*z[f>>2])-C(z[g>>2]*h);z[(17-i<<2)+a>>2]=C(z[f>>2]*h)+C(j*z[g>>2]);i=i+1|0;if((i|0)!=9){continue}break}b=b+36|0;a=a+72|0;o=o+1|0;if((o|0)!=(d|0)){continue}break}}jb=e+96|0}function Eka(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;e=jb-48|0;jb=e;i=e+24|0;f=jb-144|0;jb=f;g=li(f+8|0);h=v[v[g>>2]-12>>2];v[113382]=0;j=da(123)|0;k=v[113382];v[113382]=0;a:{b:{if((k|0)==1){break b}v[113382]=0;U(124,f|0,h+(f+8|0)|0,j|0);h=v[113382];v[113382]=0;if((h|0)==1){break b}Ob(f);v[113382]=0;R(133,g|0,c|0);c=v[113382];v[113382]=0;if((c|0)==1){break b}v[113382]=0;R(126,i|0,g|0);c=v[113382];v[113382]=0;if((c|0)==1){break b}Td(g);jb=f+144|0;break a}a=P()|0;O()|0;Td(g);S(a|0);L()}v[113382]=0;U(629,e+36|0,e+8|0,d|0);c=v[113382];v[113382]=0;c:{d:{if((c|0)!=1){v[113382]=0;R(630,e|0,e+24|0);c=v[113382];v[113382]=0;if((c|0)==1){break d}v[113382]=0;U(481,a|0,b|0,e|0);a=v[113382];v[113382]=0;if((a|0)==1){break d}hf(e+24|0);jb=e+48|0;return}c=P()|0;O()|0;yb(e+24|0);break c}c=P()|0;O()|0;hf(e+24|0)}S(c|0);L()}function xw(a){var b=0,c=0,d=0,e=0,f=0,g=0;o(+a);e=j(1)|0;j(0)|0;b=e;e=b>>>31|0;a:{b:{c:{d:{d=a;e:{f:{b=b&2147483647;g:{if(b>>>0>=1082532651){o(+a);b=j(1)|0;b=b&2147483647;if((b|0)==2146435072&(j(0)|0)!=0|b>>>0>2146435072){return a}if(a>709.782712893384){return a*8.98846567431158e307}if(!(a<-708.3964185322641)|!(a<-745.1332191019411)){break g}break b}if(b>>>0<1071001155){break d}if(b>>>0<1072734898){break f}}a=a*1.4426950408889634+A[(e<<3)+49056>>3];if(D(a)<2147483648){b=~~a;break e}b=-2147483648;break e}b=!e-e|0}c=+(b|0);a=d+c*-.6931471803691238;f=c*1.9082149292705877e-10;d=a-f;break c}if(b>>>0<=1043333120){break a}b=0;d=a}c=d;g=a;c=c*c;a=d-c*(c*(c*(c*(c*4.1381367970572385e-8+-16533902205465252e-22)+6613756321437934e-20)+-.0027777777777015593)+.16666666666666602);c=g+(d*a/(2-a)-f)+1;if(!b){break b}c=Zh(c,b)}return c}return a+1}function lz(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=jb-80|0;jb=d;a:{b:{e=v[a+4>>2];if(e>>>0<b>>>0){h=Uf(d+72|0);f=b-e|0;b=ht(a);if(!(f>>>0>b>>>0|e>>>0>b-f>>>0)){xk(d+56|0,a);b=v[d+60>>2];v[d+72>>2]=v[d+56>>2];v[d+76>>2]=b;v[a+4>>2]=v[a+4>>2]+f;break b}zb(a);b=kz(d+56|0);e=v[a+4>>2];v[113382]=0;e=Q(894,a|0,e+f|0)|0;g=v[113382];v[113382]=0;c:{if((g|0)==1){break c}v[113382]=0;R(895,b|0,e|0);e=v[113382];v[113382]=0;if((e|0)==1){break c}v[b+4>>2]=v[a+4>>2]+f;uj(d+40|0,a);xk(d+32|0,a);e=d+24|0;uj(e,b);v[113382]=0;g=v[d+44>>2];v[d+8>>2]=v[d+40>>2];v[d+12>>2]=g;g=v[d+36>>2];v[d>>2]=v[d+32>>2];v[d+4>>2]=g;X(896,d+48|0,d+8|0,d|0,e|0);e=v[113382];v[113382]=0;if((e|0)==1){break c}e=v[d+52>>2];v[d+72>>2]=v[d+48>>2];v[d+76>>2]=e;jz(a,b);ee(b);break b}a=P()|0;O()|0;ee(b);S(a|0);L()}v[a+4>>2]=b;break a}jq(Dd(d+16|0,h),f,c)}jb=d+80|0}function rI(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=jb+-64|0;jb=j;v[j+60>>2]=e;e=v[a+4>>2];k=v[a>>2];a=v[a+8>>2];v[113382]=0;v[j+40>>2]=b;v[j+52>>2]=a;v[j+44>>2]=k;v[j+48>>2]=e;v[j+20>>2]=d?d:1966;a=Q(1967,j+20|0,j+60|0)|0;b=v[113382];v[113382]=0;a:{b:{c:{d:{if((b|0)!=1){v[j+24>>2]=a;a=v[Jo(j+32|0,j+24|0)>>2];v[113382]=0;b=v[j+52>>2];v[j+8>>2]=v[j+48>>2];v[j+12>>2]=b;b=v[j+44>>2];v[j>>2]=v[j+40>>2];v[j+4>>2]=b;c=+za(1968,j|0,+c,a|0);a=v[113382];v[113382]=0;if((a|0)==1){break d}ad(j+24|0);break b}a=V(0)|0;O()|0;break c}a=V(0)|0;O()|0;ad(j+24|0)}_(a|0)|0;v[113382]=0;ja(1969,10852,d|0,v[j+60>>2],f|0,g|0,h|0,i|0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();c=0}jb=j- -64|0;return+c}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function bma(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;f=Xb(a);h=Db(b);v[113382]=0;R(487,f|0,h|0);a=v[113382];v[113382]=0;if((a|0)!=1){a:{if(h){while(1){a=d+1|0;e=w[kc(b,d)|0];b:{c:{if((a|0)==(h|0)|(e|0)!=37){break c}e=w[kc(b,a)|0];g=e-49|0;if((g&255)>>>0<=8){d=v[c+4>>2];e=v[c>>2];v[113382]=0;d=Q(496,e|0,d|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){V(0)|0;O()|0;Ab();L()}if(d>>>0<=g>>>0){d=a;break b}v[113382]=0;d=Q(488,c|0,g|0)|0;e=v[113382];v[113382]=0;if((e|0)!=1){v[113382]=0;Q(489,f|0,d|0)|0;e=v[113382];v[113382]=0;d=a;if((e|0)!=1){break b}}break a}if((e|0)==37){d=a;e=37;break c}v[113382]=0;W(490,f|0,1,37)|0;g=v[113382];v[113382]=0;d=a;if((g|0)==1){break a}}v[113382]=0;W(490,f|0,1,e<<24>>24)|0;a=v[113382];v[113382]=0;if((a|0)==1){break a}}d=d+1|0;if((h|0)!=(d|0)){continue}break}}return}}a=P()|0;O()|0;yb(f);S(a|0);L()}function Y7(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=C(0);c=jb-4112|0;jb=c;i=nb[v[v[a>>2]+112>>2]](a)|0;if(!i){nb[v[v[a>>2]+116>>2]](a)}v[c+12>>2]=0;f=jb-16|0;jb=f;h=a+44|0;if(of(h)){while(1){e=bm(h,d);g=bm(h,d);v[f+12>>2]=0;g=(g+2048|0)-e>>2;if((g|0)>0){while(1){z[e>>2]=z[f+12>>2];e=e+4|0;j=g>>>0>1;g=g-1|0;if(j){continue}break}}d=d+1|0;if(of(h)>>>0>d>>>0){continue}break}}jb=f+16|0;if(b){f=c+2064|0;while(1){v[c+8>>2]=b;tc(c+8|0,512);d=c+16|0;vp(d);nb[v[v[a>>2]+60>>2]](a,d,f,v[c+8>>2]);e=0;d=0;if(v[c+8>>2]){while(1){e=(c+16|0)+(d<<2)|0;z[c+4>>2]=D(z[e>>2]);k=c,l=z[nx(c+12|0,c+4|0)>>2],z[k+12>>2]=l;z[c+4>>2]=D(z[e+2048>>2]);k=c,l=z[nx(c+12|0,c+4|0)>>2],z[k+12>>2]=l;e=v[c+8>>2];d=d+1|0;if(e>>>0>d>>>0){continue}break}}b=b-e|0;if(b){continue}break}}if(!i){nb[v[v[a>>2]+120>>2]](a)}jb=c+4112|0;return C(z[c+12>>2])}function y2(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;d=jb-32|0;jb=d;e=ih(a);f=b+24|0;a=v[f>>2];v[113382]=0;a=T(2161,a+484344|0)|0;c=v[113382];v[113382]=0;a:{b:{c:{if((c|0)==1){break c}v[113382]=0;R(1500,e|0,a|0);a=v[113382];v[113382]=0;if((a|0)==1){break c}a=0;d:{e:{f:{g:{while(1){c=v[f>>2];v[113382]=0;c=T(2161,c+484344|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break b}if(a>>>0>=c>>>0){break d}c=Zb(v[f>>2]+484344|0,a);v[113382]=0;R(2158,d|0,c|0);c=v[113382];v[113382]=0;if((c|0)!=1){v[113382]=0;U(2152,d+16|0,b|0,d|0);c=v[113382];v[113382]=0;if((c|0)==1){break g}v[113382]=0;R(1502,e|0,d+16|0);c=v[113382];v[113382]=0;if((c|0)==1){break f}a=a+1|0;yb(d+16|0);yb(d);continue}break}a=P()|0;O()|0;break a}a=P()|0;O()|0;break e}a=P()|0;O()|0;yb(d+16|0)}yb(d);break a}jb=d+32|0;return}a=P()|0;O()|0;break a}a=P()|0;O()|0}gd(e);S(a|0);L()}function rL(a,b){var c=0;c=jb-16|0;jb=c;a=ey(a);a:{b:{c:{switch(b-1|0){default:if((b|0)!=16777216){break b}Nb(a,7,1);Nb(a,9,1);Nb(a,10,1);Nb(a,13,1);Nb(a,15,1);Nb(a,16,1);Nb(a,17,1);Nb(a,18,1);Nb(a,20,1);Nb(a,21,1);Nb(a,24,1);Nb(a,25,1);Nb(a,26,1);Nb(a,28,1);Nb(a,30,1);Nb(a,31,1);Nb(a,33,1);Nb(a,34,1);Nb(a,39,1);Nb(a,41,1);Nb(a,44,1);Nb(a,46,1);Nb(a,45,1);Nb(a,47,1);Nb(a,48,1);Nb(a,50,1);Nb(a,99,1);Nb(a,102,1);Nb(a,104,1);Nb(a,105,1);break a;case 1:ay(c,2);b=v[c+12>>2];v[a+8>>2]=v[c+8>>2];v[a+12>>2]=b;b=v[c+4>>2];v[a>>2]=v[c>>2];v[a+4>>2]=b;ig(a,107);break a;case 3:ay(c,4);b=v[c+12>>2];v[a+8>>2]=v[c+8>>2];v[a+12>>2]=b;b=v[c+4>>2];v[a>>2]=v[c>>2];v[a+4>>2]=b;ig(a,4);break a;case 2:break b;case 0:break c}}Nb(a,88,1);break a}ay(c,b);b=v[c+12>>2];v[a+8>>2]=v[c+8>>2];v[a+12>>2]=b;b=v[c+4>>2];v[a>>2]=v[c>>2];v[a+4>>2]=b}jb=c+16|0}function qja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;g=jb-16|0;jb=g;d=b;f=Kb(d);e=c;a:{if(f>>>0<e>>>0){h=jb-32|0;jb=h;b:{c:{f=e-f|0;d:{if(f>>>0<=v[zb(d)>>2]-v[d+4>>2]>>2>>>0){i=jb-16|0;jb=i;e:{e=oe(i,d,f);f=v[e+4>>2];k=v[e+8>>2];if((f|0)!=(k|0)){while(1){j=zb(d);v[113382]=0;R(785,j|0,f|0);j=v[113382];v[113382]=0;if((j|0)==1){break e}f=f+4|0;v[e+4>>2]=f;if((f|0)!=(k|0)){continue}break}}Mb(e);jb=i+16|0;break d}a=P()|0;O()|0;Mb(e);S(a|0);L()}e=zb(d);e=At(h+8|0,ye(d,Kb(d)+f|0),Kb(d),e);v[113382]=0;R(783,e|0,f|0);f=v[113382];v[113382]=0;if((f|0)==1){break c}v[113382]=0;R(784,d|0,e|0);d=v[113382];v[113382]=0;if((d|0)==1){break c}JQ(e)}jb=h+32|0;break b}a=P()|0;O()|0;JQ(e);S(a|0);L()}break a}if(e>>>0<f>>>0){e=v[d>>2]+(e<<2)|0;Kb(d);KQ(d,e);ng(d)}}c=Rb(a,c<<2);if(c){d=g+8|0;Wz(d,b);zd(a,d)}jb=g+16|0;return c|0}function jja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;g=jb-16|0;jb=g;d=b;f=oc(d);e=c;a:{if(f>>>0<e>>>0){h=jb-32|0;jb=h;b:{c:{f=e-f|0;d:{if(f>>>0<=v[zb(d)>>2]-v[d+4>>2]>>1>>>0){i=jb-16|0;jb=i;e:{e=Uh(i,d,f);f=v[e+4>>2];k=v[e+8>>2];if((f|0)!=(k|0)){while(1){j=zb(d);v[113382]=0;R(790,j|0,f|0);j=v[113382];v[113382]=0;if((j|0)==1){break e}f=f+2|0;v[e+4>>2]=f;if((f|0)!=(k|0)){continue}break}}Mb(e);jb=i+16|0;break d}a=P()|0;O()|0;Mb(e);S(a|0);L()}e=zb(d);e=bq(h+8|0,Qi(d,oc(d)+f|0),oc(d),e);v[113382]=0;R(788,e|0,f|0);f=v[113382];v[113382]=0;if((f|0)==1){break c}v[113382]=0;R(789,d|0,e|0);d=v[113382];v[113382]=0;if((d|0)==1){break c}CQ(e)}jb=h+32|0;break b}a=P()|0;O()|0;CQ(e);S(a|0);L()}break a}if(e>>>0<f>>>0){e=v[d>>2]+(e<<1)|0;oc(d);DQ(d,e);Jn(d)}}c=Rb(a,c<<1);if(c){d=g+8|0;nB(d,b);zd(a,d)}jb=g+16|0;return c|0}function Mka(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;g=jb-16|0;jb=g;d=b;f=Kb(d);e=c;a:{if(f>>>0<e>>>0){h=jb-32|0;jb=h;b:{c:{f=e-f|0;d:{if(f>>>0<=v[zb(d)>>2]-v[d+4>>2]>>2>>>0){i=jb-16|0;jb=i;e:{e=oe(i,d,f);f=v[e+4>>2];k=v[e+8>>2];if((f|0)!=(k|0)){while(1){j=zb(d);v[113382]=0;R(701,j|0,f|0);j=v[113382];v[113382]=0;if((j|0)==1){break e}f=f+4|0;v[e+4>>2]=f;if((f|0)!=(k|0)){continue}break}}Mb(e);jb=i+16|0;break d}a=P()|0;O()|0;Mb(e);S(a|0);L()}e=zb(d);e=At(h+8|0,ye(d,Kb(d)+f|0),Kb(d),e);v[113382]=0;R(699,e|0,f|0);f=v[113382];v[113382]=0;if((f|0)==1){break c}v[113382]=0;R(700,d|0,e|0);d=v[113382];v[113382]=0;if((d|0)==1){break c}uR(e)}jb=h+32|0;break b}a=P()|0;O()|0;uR(e);S(a|0);L()}break a}if(e>>>0<f>>>0){e=v[d>>2]+(e<<2)|0;Kb(d);vR(d,e);ng(d)}}c=Rb(a,c<<2);if(c){d=g+8|0;Wz(d,b);zd(a,d)}jb=g+16|0;return c|0}function bU(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;g=jb-16|0;jb=g;d=b;f=oc(d);e=c;a:{if(f>>>0<e>>>0){h=jb-32|0;jb=h;b:{c:{f=e-f|0;d:{if(f>>>0<=v[zb(d)>>2]-v[d+4>>2]>>1>>>0){i=jb-16|0;jb=i;e:{e=Uh(i,d,f);f=v[e+4>>2];k=v[e+8>>2];if((f|0)!=(k|0)){while(1){j=zb(d);v[113382]=0;R(380,j|0,f|0);j=v[113382];v[113382]=0;if((j|0)==1){break e}f=f+2|0;v[e+4>>2]=f;if((f|0)!=(k|0)){continue}break}}Mb(e);jb=i+16|0;break d}a=P()|0;O()|0;Mb(e);S(a|0);L()}e=zb(d);e=bq(h+8|0,Qi(d,oc(d)+f|0),oc(d),e);v[113382]=0;R(378,e|0,f|0);f=v[113382];v[113382]=0;if((f|0)==1){break c}v[113382]=0;R(379,d|0,e|0);d=v[113382];v[113382]=0;if((d|0)==1){break c}mB(e)}jb=h+32|0;break b}a=P()|0;O()|0;mB(e);S(a|0);L()}break a}if(e>>>0<f>>>0){e=v[d>>2]+(e<<1)|0;oc(d);oB(d,e);Jn(d)}}c=Rb(a,c<<1);if(c){d=g+8|0;nB(d,b);zd(a,d)}jb=g+16|0;return c|0}function Fea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;g=jb-16|0;jb=g;i=v[a+40>>2];j=v[a+36>>2];l=v[a+16>>2];h=v[a+4>>2];e=h;f=v[a>>2];v[g+8>>2]=f;v[g+12>>2]=e;h=v[a+12>>2];v[g>>2]=v[a+8>>2];v[g+4>>2]=h;a:{if(d){while(1){k=v[a+32>>2];j=v[a+28>>2]+j|0;h=j>>12;e=e+l|0;f=(((f>>>16|0)+4&131064)<<1)+b|0;e=(((((B(t[e+2|0],u[f+34>>1])+B(t[e+1|0],u[f+32>>1])|0)+B(t[e+3|0],u[f+36>>1])|0)+B(t[e+4|0],u[f+38>>1])<<8)/2|0)+((((B(t[e-2|0],u[f+26>>1])+B(t[e-3|0],u[f+24>>1])|0)+B(t[e-1|0],u[f+28>>1])|0)+B(t[e|0],u[f+30>>1])<<8)/2|0)|0)/16384|0;v[c>>2]=v[c>>2]+B(h,e);i=i+k|0;k=i>>12;v[c+4>>2]=v[c+4>>2]+B(e,k);Sb(g+8|0,g);d=d-1|0;if(d){c=c+8|0;f=v[g+8>>2];e=v[g+12>>2];continue}break}f=v[g+8>>2];e=v[g+12>>2];break a}k=i>>12;h=j>>12}v[a+40>>2]=i;v[a+20>>2]=h;v[a+36>>2]=j;v[a+24>>2]=k;v[a>>2]=f;v[a+4>>2]=e;jb=g+16|0}function E6(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=C(0),m=0,n=C(0),o=C(0),p=C(0),q=C(0),r=C(0),s=C(0),t=C(0),u=C(0),w=C(0);i=jb-16|0;jb=i;j=a+44|0;if(vh(j)){h=Jd(j,0);v[i+8>>2]=h;k=Jd(j,1);v[i+12>>2]=k;e=ed(j,0);v[i>>2]=e;f=ed(j,1);v[i+4>>2]=f;a:{if(z[a+4216>>2]!=C(.5)){if(!d){break a}h=d;while(1){f=0;k=1;while(1){f=f<<2;e=f+(i+8|0)|0;g=v[e>>2];v[e>>2]=g+4;e=a+f|0;m=e+4248|0;p=z[m>>2];l=z[g>>2];q=z[a+4228>>2];r=z[a+4224>>2];s=z[a+4220>>2];t=z[a+4236>>2];u=z[a+4232>>2];g=e+4240|0;n=z[g>>2];z[m>>2]=n;z[g>>2]=l;g=e+4264|0;w=z[g>>2];e=e+4256|0;o=z[e>>2];z[g>>2]=o;l=C(C(C(C(n*r)+C(s*l))+C(p*q))-C(C(w*t)+C(o*u)));z[e>>2]=l;f=f+i|0;e=v[f>>2];v[f>>2]=e+4;z[e>>2]=l;e=k;k=0;f=1;if(e){continue}break}h=h-1|0;if(h){continue}break}break a}g=h;h=d<<2;lc(e,g,h);lc(f,k,h)}pi(a,b,c,ed(j,0),ed(j,1),d)}jb=i+16|0}function Yda(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;f=bd(a);h=Db(b);v[113382]=0;R(73,f|0,h|0);a=v[113382];v[113382]=0;if((a|0)!=1){a:{if(h){while(1){a=d+1|0;e=w[kc(b,d)|0];b:{c:{if((a|0)==(h|0)|(e|0)!=37){break c}e=w[kc(b,a)|0];g=e-49|0;if((g&255)>>>0<=8){d=v[c+4>>2];e=v[c>>2];v[113382]=0;d=Q(79,e|0,d|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){V(0)|0;O()|0;Ab();L()}if(d>>>0<=g>>>0){d=a;break b}v[113382]=0;d=Q(74,c|0,g|0)|0;e=v[113382];v[113382]=0;if((e|0)!=1){v[113382]=0;Q(75,f|0,d|0)|0;e=v[113382];v[113382]=0;d=a;if((e|0)!=1){break b}}break a}if((e|0)==37){d=a;e=37;break c}v[113382]=0;W(76,f|0,1,37)|0;g=v[113382];v[113382]=0;d=a;if((g|0)==1){break a}}v[113382]=0;W(76,f|0,1,e<<24>>24)|0;a=v[113382];v[113382]=0;if((a|0)==1){break a}}d=d+1|0;if((h|0)!=(d|0)){continue}break}}return}}a=P()|0;O()|0;yb(f);S(a|0);L()}function Wo(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0;c=jb-16|0;jb=c;a:{b:{switch(v[a+480224>>2]-1|0){default:b=v[a+24620>>2];d=b>>31;v[c+8>>2]=1;v[c>>2]=v[a+1074420>>2]<<1;d=qma(b,d,5e4,0);e=mb;b=v[Vc(c+8|0,c)>>2];b=zc(rma(d,e,b,b>>31),mb);v[a+1074404>>2]=b;break a;case 1:b=v[a+24620>>2];v[c+8>>2]=1;v[c+12>>2]=0;g=c,h=qma(v[a+1074420>>2],0,qma(v[a+1074408>>2],0,v[a+1074416>>2],0),mb),v[g>>2]=h;v[c+4>>2]=mb;d=jb-16|0;jb=d;e=c+8|0;f=Eu(e,c);jb=d+16|0;d=qma(b,0,6e5,0);b=f?c:e;b=tma(d,mb,v[b>>2],v[b+4>>2]);v[a+1074404>>2]=b;break a;case 0:break b}}b=v[a+24620>>2];d=b>>31;v[c+8>>2]=1;v[c>>2]=v[a+1074420>>2];d=qma(b,d,1e4,0);e=mb;b=v[Vc(c+8|0,c)>>2];b=zc(rma(d,e,b,b>>31),mb);v[a+1074404>>2]=b}d=a+1074404|0;a=v[a+480244>>2];b=qma(a,a>>31,b,b>>31)+32768|0;a=mb;a=zc(rma(b,b>>>0<32768?a+1|0:a,65536,0),mb);v[d>>2]=a?a:1;jb=c+16|0}function N$(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;i=jb-32|0;jb=i;a:{b:{c:{if((b|0)!=(c|0)){j=v[113305];v[113305]=0;g=jb-16|0;jb=g;ge();e=jb-16|0;jb=e;f=jb-16|0;jb=f;dw(f,b,i+28|0,2);k=v[f>>2];h=v[f+4>>2];b=v[f+12>>2];v[e+8>>2]=v[f+8>>2];v[e+12>>2]=b;v[e>>2]=k;v[e+4>>2]=h;jb=f+16|0;h=v[e>>2];f=v[e+4>>2];b=v[e+12>>2];v[g+8>>2]=v[e+8>>2];v[g+12>>2]=b;v[g>>2]=h;v[g+4>>2]=f;jb=e+16|0;h=v[g>>2];f=v[g+4>>2];e=v[g+12>>2];b=i;v[b+16>>2]=v[g+8>>2];v[b+20>>2]=e;v[b+8>>2]=h;v[b+12>>2]=f;jb=g+16|0;h=v[b+16>>2];f=v[b+20>>2];g=v[b+8>>2];e=v[b+12>>2];b=v[113305];if(!b){break c}if(v[i+28>>2]!=(c|0)){break b}l=g;m=e;n=h;o=f;if((b|0)!=68){break a}break b}v[d>>2]=4;break a}v[113305]=j;if(v[i+28>>2]==(c|0)){break a}}v[d>>2]=4;g=l;e=m;h=n;f=o}v[a>>2]=g;v[a+4>>2]=e;v[a+8>>2]=h;v[a+12>>2]=f;jb=i+32|0}function CA(a,b){var c=0,d=0;d=w[a|0];if(d>>>0>=36){t[a|0]=0;return}c=w[d+23584|0];t[a|0]=c;a:{b:{c:{d:{e:{f:{if(c>>>0<=16){if(c-6>>>0>=2){if((c|0)==1){break f}if((c|0)!=11){break a}}c=w[b|0];a=c&240;if(!a|(a|0)==240|(c&15)==15){break a}t[b|0]=a;return}switch(c-17|0){case 1:case 3:case 4:case 5:break a;case 0:break c;case 2:break d;case 6:break e;default:break b}}if(w[b|0]){break a}t[a|0]=0;return}a=w[b|0];if(a>>>0<=64){t[b|0]=a<<1;return}t[b|0]=128;return}g:{h:{i:{j:{c=w[b|0];switch((c&240)-48>>>4|0){case 4:break g;case 2:break h;case 1:break i;case 0:break j;default:break a}}t[a|0]=20;t[b|0]=159;return}t[a|0]=20;t[b|0]=192;return}if(c&14){break a}t[a|0]=21;t[b|0]=(w[b|0]!=80)<<6;return}t[a|0]=20;t[b|0]=w[b|0]&15|160;return}if(w[b|0]>31){break a}t[a|0]=16;return}if((c|0)!=31){break a}t[b|0]=(d<<5|w[b|0]<<24>>>27)^128}}function s3(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0;f=jb-32|0;jb=f;v[f+24>>2]=d;d=Io(a,f+24|0);h=RH(a+4|0);i=QH(a+24|0);j=PH(a+32|0);k=bx(a+36|0);v[a+56>>2]=3;l=ih(a+68|0);v[113382]=0;R(2133,a|0,e|0);g=v[113382];v[113382]=0;a:{b:{c:{d:{if((g|0)!=1){v[113382]=0;b=T(2139,b|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break d}v[113382]=0;U(2140,f|0,b|0,c|0);b=v[113382];v[113382]=0;if((b|0)==1){break d}v[113382]=0;U(2141,f+8|0,f|0,0);b=v[113382];v[113382]=0;if((b|0)==1){break d}v[113382]=0;U(2134,a|0,f+8|0,e|0);b=v[113382];v[113382]=0;if((b|0)==1){break c}Bb(f+8|0);v[113382]=0;Z(2135,a|0);b=v[113382];v[113382]=0;if((b|0)!=1){break a}}a=P()|0;O()|0;break b}a=P()|0;O()|0;break b}a=P()|0;O()|0;Bb(f+8|0)}gd(l);qf(k);vf(j);Gh(i);ad(h);ad(d);ad(f+24|0);S(a|0);L()}ad(f+24|0);jb=f+32|0;return a|0}function K8(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;a:{b:{if((of(a)|0)==(b|0)){if((of(a+12|0)|0)==(c|0)){break b}}v[113382]=0;R(1611,a|0,b|0);d=v[113382];v[113382]=0;c:{d:{if((d|0)==1){break d}v[113382]=0;e=a+12|0;R(1611,e|0,c|0);d=v[113382];v[113382]=0;if((d|0)==1){break d}v[113382]=0;f=a+24|0;R(1612,f|0,b|0);d=v[113382];v[113382]=0;if((d|0)==1){break d}v[113382]=0;g=a+36|0;R(1612,g|0,c|0);d=v[113382];v[113382]=0;if((d|0)==1){break d}if(b){d=0;while(1){h=bm(a,d);i=Pb(f,d),j=h,v[i>>2]=j;d=d+1|0;if((d|0)!=(b|0)){continue}break}}if(c){break c}return 1}b=V(66740)|0;if((O()|0)!=(ga(66740)|0)){break a}_(b|0)|0;EJ(a);DJ(a);b=a+12|0;EJ(b);DJ(b);b=a+24|0;CJ(b);AJ(b);a=a+36|0;CJ(a);AJ(a);$();return 0}a=0;while(1){b=bm(e,a);i=Pb(g,a),j=b,v[i>>2]=j;a=a+1|0;if((c|0)!=(a|0)){continue}break}}return 1}S(b|0);L()}function cP(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;c=jb-48|0;jb=c;v[a>>2]=0;v[a+4>>2]=0;v[c+44>>2]=0;zb(b);Uc(a+8|0,c+44|0,c+40|0);if(v[b+4>>2]){kq(a,v[b+4>>2]);uj(c+32|0,b);xk(c+24|0,b);b=v[c+36>>2];v[c+16>>2]=v[c+32>>2];v[c+20>>2]=b;b=v[c+28>>2];v[c+8>>2]=v[c+24>>2];v[c+12>>2]=b;b=jb-80|0;jb=b;e=a;f=v[a+4>>2];d=v[c+20>>2];i=d;g=v[c+16>>2];v[b+72>>2]=g;v[b+76>>2]=d;d=v[c+12>>2];j=d;h=v[c+8>>2];v[b+64>>2]=h;v[b+68>>2]=d;v[b+24>>2]=g;v[b+28>>2]=i;v[b+16>>2]=h;v[b+20>>2]=d;d=$O(b+24|0,b+16|0)+v[a+4>>2]|0;v[a+4>>2]=d;if(!((d-1^f-1)>>>0<32?f:0)){v[v[e>>2]+((d>>>0<33?0:d-1>>>5|0)<<2)>>2]=0}v[b+48>>2]=h;v[b+52>>2]=j;v[b+56>>2]=g;v[b+60>>2]=i;d=b+40|0;Pn(d,e,f);e=v[b+60>>2];v[b+8>>2]=v[b+56>>2];v[b+12>>2]=e;e=v[b+52>>2];v[b>>2]=v[b+48>>2];v[b+4>>2]=e;CP(b+32|0,b+8|0,b,d);jb=b+80|0}jb=c+48|0;return a|0}function KF(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0;h=jb-1040|0;jb=h;i=v[b>>2];v[h+12>>2]=i;g=a?d:256;j=a?a:h+16|0;d=0;a:{b:{c:{if(!i|!g){break c}f=c>>>2|0;k=g>>>0<=f>>>0;if(f>>>0<g>>>0&c>>>0<=131){break b}while(1){f=k?g:f;c=c-f|0;f=gw(j,h+12|0,f,e);if((f|0)==-1){g=0;i=v[h+12>>2];d=-1;break c}i=(h+16|0)==(j|0)?0:f;g=g-i|0;j=(i<<2)+j|0;d=d+f|0;i=v[h+12>>2];if(!i|!g){break c}f=c>>>2|0;k=g>>>0<=f>>>0;if(c>>>0>131|f>>>0>=g>>>0){continue}break}break b}if(!i){break a}}if(!g|!c){break a}f=d;while(1){d:{d=xo(j,i,c,e);e:{if(d+2>>>0<=2){f:{switch(d+1|0){case 1:v[h+12>>2]=0;break e;case 0:break a;default:break f}}v[e>>2]=0;break e}i=v[h+12>>2]+d|0;v[h+12>>2]=i;f=f+1|0;g=g-1|0;if(g){break d}}d=f;break a}j=j+4|0;c=c-d|0;d=f;if(c){continue}break}}if(a){v[b>>2]=v[h+12>>2]}jb=h+1040|0;return d|0}function _ga(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=jb-32|0;jb=d;sd(c,2);t[d+16|0]=w[b+13|0];t[d|0]=64;e=d+16|0;g=c,h=w[pc(e,d)|0]<<2,u[g+30>>1]=h;f=b+14|0;v[c+24>>2]=(w[f|0]|w[f+1|0]<<8)<<1;Jk(d,2,b+1|0);Ec(e,d);v[113382]=0;Q(336,c+43|0,e|0)|0;e=v[113382];v[113382]=0;if((e|0)!=1){yb(d+16|0);e=Yc(a,8,1,0,2);a:{if((w[b|0]&3)!=1){break a}a=b+22|0;v[c>>2]=w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24);a=b+26|0;v[c+4>>2]=w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24);a=b+30|0;a=w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24);v[c+8>>2]=a;if(a>>>0>y[c+4>>2]){v[c+8>>2]=a-1}if(w[b|0]&4){u[c+34>>1]=x[c+34>>1]|2}if(w[b|0]&8){u[c+34>>1]=x[c+34>>1]|4}if(!(w[b|0]&16)){break a}mA(e);Zl(e,9);v[c>>2]=v[c>>2]>>>1;v[c+4>>2]=v[c+4>>2]>>>1;v[c+8>>2]=v[c+8>>2]>>>1}jb=d+32|0;return}a=P()|0;O()|0;yb(d+16|0);S(a|0);L()}function CT(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=jb-16|0;jb=d;sd(b,0);v[b>>2]=w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24);c=aq(a+4|0,a);v[b+4>>2]=w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24);c=aq(a+8|0,a);v[b+8>>2]=w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24);c=a+15|0;v[b+24>>2]=(w[c|0]|w[c+1|0]<<8)<<1;if(!(w[c|0]|w[c+1|0]<<8)){v[b+24>>2]=16726}c=a+14|0;e=b,f=(B(_s(t[a+17|0],w[c|0]<<28>>24),v[b+24>>2])>>>0)/8363|0,v[e+24>>2]=f;t[d+15|0]=w[a+18|0];t[d+14|0]=127;e=b,f=(((w[pc(d+15|0,d+14|0)|0]<<8|64)&65344)>>>0)/127|0,u[e+30>>1]=f;if(w[c|0]>=16){c=w[c|0];u[b+34>>1]=32;u[b+28>>1]=c&240}a=a+19|0;if(w[a|0]&4){u[b+34>>1]=x[b+34>>1]|1}a:{if(!(w[a|0]&8)|y[b+4>>2]>=y[b+8>>2]){break a}u[b+34>>1]=x[b+34>>1]|2;if(w[a|0]&16){u[b+34>>1]=x[b+34>>1]|4}if(!(w[a|0]&64)){break a}u[b+34>>1]=x[b+34>>1]|128}jb=d+16|0}function HJ(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;d=jb-16|0;jb=d;a:{if(Kb(a)>>>0>511){break a}if(!Jf(v[v[b>>2]-12>>2]+b|0)){break a}h=d;g=b;i=c;f=jb-16|0;jb=f;e=Pe(64);v[113382]=0;j=T(1395,e|0)|0;k=v[113382];v[113382]=0;b:{c:{if((k|0)!=1){e=Zx(f,j);j=v[e>>2];v[113382]=0;g=W(1603,j|0,g|0,i|0)|0;i=v[113382];v[113382]=0;d:{e:{if((i|0)!=1){if((g|0)==1){break e}Yx(f+8|0);break d}a=P()|0;O()|0;gg(e);break c}Jp(f+8|0,e)}gg(e);jb=f+16|0;g=v[f+8>>2];break b}a=P()|0;O()|0;Wb(e)}S(a|0);L()}v[h+8>>2]=g;f:{g:{if(!qd(d+8|0)){v[113382]=0;b=Q(1601,b|0,c|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break g}v[d>>2]=b;KR(d+8|0,ke(d));gg(d)}h=0;if(!qd(d+8|0)){break f}b=d+8|0;h=v[b>>2];v[113382]=0;R(1602,a|0,b|0);a=v[113382];v[113382]=0;if((a|0)!=1){break f}}a=P()|0;O()|0;gg(d+8|0);S(a|0);L()}gg(d+8|0)}jb=d+16|0;return h}function Mba(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=C(0),i=C(0),j=C(0),k=0,m=0;f=jb-16|0;jb=f;k=f,m=B(v[a>>2],te(a)),v[k+8>>2]=m;tc(f+8|0,c>>>2|0);c=Eb(b);h=z[e+4>>2];e=v[f+8>>2];if(e){while(1){g=w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24);h=C(G(C(D((l(2,g<<24|g<<8&16711680|(g>>>8&65280|g>>>24)),q()))),h));c=c+4|0;e=e-1|0;if(e){continue}break}}c=h==C(0);a:{if(c){break a}e=v[f+8>>2];if(!e){break a}j=c?C(1):C(C(1)/h);c=v[a+20>>2];while(1){a=w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24);z[f+12>>2]=j*(l(2,a<<24|a<<8&16711680|(a>>>8&65280|a>>>24)),q());Wd(f+12|0,C(-1));i=C(z[f+12>>2]*C(32768));z[f+12>>2]=i;a=c;i=de(i);b:{if(C(D(i))<C(2147483648)){g=~~i;break b}g=-2147483648}k=a,m=Rc(g),u[k>>1]=m;b=b+4|0;c=c+2|0;e=e-1|0;if(e){continue}break}}if(d){z[d>>2]=h}jb=f+16|0;return v[f+8>>2]<<2}function iaa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=jb-16|0;jb=d;sd(b,4);u[b+30>>1]=w[a+12|0]<<2;sg(b+30|0,256);c=w[a+15|0];u[b+34>>1]=32;u[b+28>>1]=c;t[b+37|0]=w[a+13|0];t[b+36|0]=w[a+16|0];v[b>>2]=w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24);c=a+4|0;e=w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24);v[b+4>>2]=e;c=a+8|0;v[b+8>>2]=e+(w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24));a=a+14|0;if(w[a|0]&16){v[b>>2]=v[b>>2]>>>1;v[b+4>>2]=v[b+4>>2]>>>1;v[b+8>>2]=v[b+8>>2]>>>1}if(w[a|0]&32){v[b>>2]=v[b>>2]>>>1;v[b+4>>2]=v[b+4>>2]>>>1;v[b+8>>2]=v[b+8>>2]>>>1}a:{if(!(w[a|0]&3)|y[b+8>>2]<=y[b+4>>2]){break a}u[b+34>>1]=x[b+34>>1]|2;if(!(w[a|0]&2)){break a}u[b+34>>1]=x[b+34>>1]|4}a=Ub(d,17540);v[113382]=0;Q(336,b+43|0,a|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){yb(a);jb=d+16|0;return}b=P()|0;O()|0;yb(a);S(b|0);L()}function Lda(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;c=jb+-64|0;jb=c;wf(a,c+62|0);a:{b:{c:{d:{e:{f:{g:{e=v[18619];if(x[c+62>>1]>x[e+12>>1]){f=v[b+12>>2];d=c+16|0;BA(d,12765);v[113382]=0;X(1145,c+32|0,d|0,c+62|0,e+12|0);d=v[113382];v[113382]=0;if((d|0)==1){break g}v[113382]=0;d=Q(611,c+48|0,c+32|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break f}v[113382]=0;R(586,f|0,d|0);f=v[113382];v[113382]=0;if((f|0)==1){break e}yb(d);yb(c+32|0);Ib(c+16|0);u[c+62>>1]=x[e+12>>1]}lg(Di(b,0),x[c+62>>1]);b=Di(b,0);h=c,i=ac(b),v[h+48>>2]=i;h=c,i=bc(b),v[h+16>>2]=i;if(Jb(c+48|0,c+16|0)){break b}break a}b=P()|0;O()|0;break c}b=P()|0;O()|0;break d}b=P()|0;O()|0;yb(d)}yb(c+32|0)}Ib(c+16|0);S(b|0);L()}while(1){b=c+48|0;d=v[b>>2];wf(a,c+14|0);u[d>>1]=x[c+14>>1];re(b);if(Jb(b,c+16|0)){continue}break}}jb=c- -64|0}function Kba(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,o=0,p=0;f=jb-16|0;jb=f;m=f,o=B(v[a>>2],te(a)),v[m+4>>2]=o;tc(f+4|0,c>>>3|0);c=Eb(b);h=A[e+8>>3];g=v[f+4>>2];a:{if(!g){break a}e=g;while(1){j=(w[c+4|0]|w[c+5|0]<<8|(w[c+6|0]<<16|w[c+7|0]<<24))&2147483647;l(0,w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24));l(1,j|0);h=G(+n(),h);c=c+8|0;e=e-1|0;if(e){continue}break}if(!g|h==0){break a}k=1/h;c=v[a+20>>2];while(1){a=b;e=w[a+4|0]|w[a+5|0]<<8|(w[a+6|0]<<16|w[a+7|0]<<24);l(0,w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24));l(1,e|0);m=f,p=+n()*k,A[m+8>>3]=p;Vf(f+8|0,-1,1);i=A[f+8>>3]*32768;A[f+8>>3]=i;a=c;i=Md(i);b:{if(D(i)<2147483648){e=~~i;break b}e=-2147483648}m=a,o=Rc(e),u[m>>1]=o;b=b+8|0;c=c+2|0;g=g-1|0;if(g){continue}break}}if(d){A[d>>3]=h}jb=f+16|0;return v[f+4>>2]<<3}function d3(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;d=jb+-64|0;jb=d;a:{b:{if((b|0)>=0){e=a+24|0;if(rj(Vb(v[e>>2]+484360|0))>>>0>b>>>0){break b}}a=a+16|0;break a}f=x[rc(Vb(v[e>>2]+484360|0),b)>>1];c:{if(!In(v[e>>2]+484344|0,f)){break c}if((c|0)>=0){g=c;if((c|0)<v[Zb(v[e>>2]+484344|0,f)+12>>2]){break c}}a=a+16|0;break a}u[v[e>>2]+1074438>>1]=b;c=b&65535;lL(v[e>>2],c);v[v[e>>2]+1074428>>2]=g;v[v[e>>2]+1074392>>2]=-2;e=v[e>>2];f=w[a+64|0];b=d+24|0;t[b+6|0]=255;v[b+16>>2]=0;u[b+4>>1]=0;v[b>>2]=0;if(!((c|0)==65535|(g|0)==-1)){v[b+8>>2]=g;v[b+16>>2]=2;u[b+12>>1]=c}c=v[b+20>>2];v[d+16>>2]=v[b+16>>2];v[d+20>>2]=c;c=v[b+12>>2];v[d+8>>2]=v[b+8>>2];v[d+12>>2]=c;c=v[b+4>>2];v[d>>2]=v[b>>2];v[d+4>>2]=c;b=d+48|0;Hs(b,e,f?7:1,d);h=a,i=A[Wg(b)>>3],A[h+16>>3]=i;Il(b);a=a+16|0}jb=d- -64|0;return+A[a>>3]}function QF(a,b){var c=0,d=0,e=0;a:{if(w[b|0]){break a}b=jw(9815);if(w[b|0]?b:0){break a}b=jw(B(a,12)+55296|0);if(w[b|0]?b:0){break a}b=jw(10062);if(w[b|0]?b:0){break a}b=10443}b:{while(1){e=w[b+c|0];if(!(!e|(e|0)==47)){e=15;c=c+1|0;if((c|0)!=15){continue}break b}break}e=c}d=10443;c:{d:{c=w[b|0];e:{f:{if(!(w[b+e|0]|(c|0)==46)){d=b;if((c|0)!=67){break f}}if(!w[d+1|0]){break e}}if(!fi(d,10443)){break e}if(fi(d,9515)){break d}}if(!a){c=55220;if(w[d+1|0]==46){break c}}return 0}c=v[113391];if(c){while(1){if(!fi(d,c+8|0)){break c}c=v[c+24>>2];if(c){continue}break}}c=v[113391];if(c){while(1){if(!fi(d,c+8|0)){return c}c=v[c+24>>2];if(c){continue}break}}c=kd(28);g:{if(!c){c=0;break g}b=v[13806];v[c>>2]=v[13805];v[c+4>>2]=b;b=c+8|0;lc(b,d,e);t[b+e|0]=0;v[c+24>>2]=v[113391];v[113391]=c}c=a|c?c:55220}return c}function NT(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;e=jb-16|0;jb=e;v[e+12>>2]=c;c=0;if(_f(a,e+8|0)){v[e+4>>2]=w[e+8|0];g=v[Lb(e+4|0,e+12|0)>>2];c=jb+-64|0;jb=c;d=c+40|0;Ze(d,a,g);a=v[d>>2];v[113382]=0;d=T(426,d|0)|0;f=v[113382];v[113382]=0;a:{b:{c:{d:{if((f|0)==1){break d}v[113382]=0;d=T(427,d|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break d}v[113382]=0;X(428,c+8|0,3,d|0,a|0);d=v[113382];v[113382]=0;if((d|0)==1){break d}v[113382]=0;R(356,c+24|0,c+8|0);d=v[113382];v[113382]=0;if((d|0)==1){break d}v[113382]=0;R(430,c|0,b|0);b=v[113382];v[113382]=0;if((b|0)==1){break c}v[113382]=0;Q(431,c|0,c+24|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break c}yb(c+24|0);Cc(c+40|0);jb=c- -64|0;c=!g|(a|0)!=0;break a}a=P()|0;O()|0;break b}a=P()|0;O()|0;yb(c+24|0)}Cc(c+40|0);S(a|0);L()}}jb=e+16|0;return c|0}function Eba(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=C(0),g=0,h=0,i=C(0),j=0,k=0;e=jb-16|0;jb=e;v[e+12>>2]=c>>>3;v[e+8>>2]=v[a>>2];h=v[Lb(e+12|0,e+8|0)>>2];i=z[d>>2];b=Eb(b);if(h){a=v[a+20>>2];c=h;while(1){d=w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24);z[e+12>>2]=i*(l(2,d<<24|d<<8&16711680|(d>>>8&65280|d>>>24)),q());Wd(e+12|0,C(-1));f=C(z[e+12>>2]*C(32768));z[e+12>>2]=f;d=a;f=de(f);a:{if(C(D(f))<C(2147483648)){g=~~f;break a}g=-2147483648}j=d,k=Rc(g),u[j>>1]=k;d=w[b+4|0]|w[b+5|0]<<8|(w[b+6|0]<<16|w[b+7|0]<<24);z[e+12>>2]=i*(l(2,d<<24|d<<8&16711680|(d>>>8&65280|d>>>24)),q());Wd(e+12|0,C(-1));f=C(z[e+12>>2]*C(32768));z[e+12>>2]=f;d=a;f=de(f);b:{if(C(D(f))<C(2147483648)){g=~~f;break b}g=-2147483648}j=d,k=Rc(g),u[j+2>>1]=k;a=a+4|0;b=b+8|0;c=c-1|0;if(c){continue}break}}jb=e+16|0;return h<<3}function Wr(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=jb-176|0;jb=d;e=li(d+40|0);f=v[v[e>>2]-12>>2];v[113382]=0;g=da(123)|0;h=v[113382];v[113382]=0;a:{b:{c:{d:{e:{if((h|0)==1){break e}v[113382]=0;U(124,d+32|0,f+(d+40|0)|0,g|0);f=v[113382];v[113382]=0;if((f|0)==1){break e}Ob(d+32|0);v[113382]=0;R(141,e|0,c|0);f=v[113382];v[113382]=0;if((f|0)==1){break e}v[113382]=0;R(132,e|0,b|0);b=v[113382];v[113382]=0;if((b|0)==1){break e}v[113382]=0;R(126,d|0,e|0);b=v[113382];v[113382]=0;if((b|0)==1){break e}v[113382]=0;U(139,d+16|0,d|0,c|0);b=v[113382];v[113382]=0;if((b|0)==1){break d}v[113382]=0;U(140,a|0,d+16|0,c|0);a=v[113382];v[113382]=0;if((a|0)==1){break c}yb(d+16|0);yb(d);Td(e);jb=d+176|0;return}c=P()|0;O()|0;break a}c=P()|0;O()|0;break b}c=P()|0;O()|0;yb(d+16|0)}yb(d)}Td(e);S(c|0);L()}function Ija(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0;g=jb-16|0;jb=g;t[g+14|0]=d;t[g+15|0]=c;t[g+13|0]=e;t[g+12|0]=f;if((d-1&255)>>>0<=5){t[g+14|0]=d+15}hR(g+15|0,g+13|0);hR(g+14|0,g+12|0);a:{if(w[g+15|0]==10){t[g+13|0]=w[g+13|0]&15?-1:w[g+12|0];if(w[g+14|0]!=10){break a}t[g+14|0]=0;break a}if(w[g+14|0]!=10){break a}t[g+12|0]=w[g+12|0]&15?-1:0}if(b){t[a+2|0]=1;t[a+4|0]=b+2>>>2}Cx(g+15|0,g+13|0,g+14|0,g+12|0);c=w[g+15|0];b:{if(!c){break b}d=w[g+14|0];if(!d){t[g+14|0]=c;t[g+12|0]=w[g+13|0];t[g+15|0]=0;break b}if(!((c|0)==20|(c|0)!=(d|0))){t[g+15|0]=0;break b}if(!b){Bx(g+8|0,g+15|0,g+13|0,g+14|0,g+12|0);t[a+2|0]=w[g+15|0];t[a+4|0]=w[g+13|0];break b}if(Vm(c)>>>0<=Vm(w[g+14|0])>>>0){break b}Rg(g+15|0,g+14|0);Rg(g+13|0,g+12|0)}t[a+3|0]=w[g+14|0];t[a+5|0]=w[g+12|0];jb=g+16|0}function VL(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0;e=jb-16|0;jb=e;a:{if(!v[b+700>>2]){break a}f=v[a+480180>>2]==64?B(c,-20):c;b:{if(!(!(w[a+480208|0]&16)|v[a+480180>>2]==4)){g=v[b+700>>2];c=f>>31;v[e+12>>2]=(c+f^c)>>>2;tc(e+12|0,255);d=v[e+12>>2];c:{if(!d){break c}h=b;c=v[b+700>>2];i=c;c=c>>31;d:{if((f|0)<0){d=iy(a,d);break d}d=hy(a,d)}d=qma(i,c,d,d>>31)+32768|0;c=mb;c=zc(rma(d,d>>>0<32768?c+1|0:c,65536,0),mb);v[h+700>>2]=c;if((c|0)!=(g|0)){break c}Fb(e,a+1074312|0,7);g=Cb(e);d=v[b+700>>2];c=b;e:{if((g|0)==(f>>>31|0)){if((d|0)==2147483647){break c}d=v[b+700>>2]+1|0;break e}if((d|0)<2){break c}d=d-1|0}v[c+700>>2]=d}c=v[b+700>>2];break b}c=f+v[b+700>>2]|0;v[b+700>>2]=c}if((c|0)>0){break a}v[b+700>>2]=1;if(v[a+480180>>2]!=2){break a}v[b+696>>2]=0;v[b+88>>2]=v[b+88>>2]|2101248}jb=e+16|0}function ni(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0;f=jb-48|0;jb=f;d=a+24|0;g=v[v[d>>2]+24620>>2];a:{if(!((g|0)!=(b|0)|v[v[d>>2]+24624>>2]!=(c|0))){if(w[a+29|0]){break a}YK(v[d>>2],1);break a}e=f+8|0;lc(e,v[d>>2]+24604|0,40);h=v[e+32>>2];i=v[e+36>>2];v[f+28>>2]=c;v[f+24>>2]=b;ul(e,h);gn(e,i);Ux(v[d>>2],e);if((b|0)==(g|0)){break a}b=v[d>>2];e=b+946300|0;c=b+906300|0;while(1){b=v[c>>2];b:{if(!b){break b}if(!(nb[v[v[b>>2]+112>>2]](b)|0)){break b}nb[v[v[b>>2]+104>>2]](b,0);nb[v[v[b>>2]+92>>2]](b);nb[v[v[b>>2]+120>>2]](b)}c=c+160|0;if((e|0)!=(c|0)){continue}break}b=v[d>>2];d=b+946300|0;c=b+906300|0;while(1){b=v[c>>2];c:{if(!b){break c}if(nb[v[v[b>>2]+112>>2]](b)|0){break c}nb[v[v[b>>2]+104>>2]](b,1);nb[v[v[b>>2]+116>>2]](b)}c=c+160|0;if((d|0)!=(c|0)){continue}break}}t[a+29|0]=1;jb=f+48|0}function xfa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=jb-32|0;jb=e;i=v[a+40>>2];j=v[a+36>>2];l=v[a+16>>2];b=v[a+4>>2];g=b;f=v[a>>2];v[e+24>>2]=f;v[e+28>>2]=b;b=v[a+12>>2];v[e+16>>2]=v[a+8>>2];v[e+20>>2]=b;a:{if(d){while(1){m=f>>>18|0;g=((((g&2147483647)<<1|f>>>31)&2147483646)<<1)+l|0;h=0;b=1;while(1){k=h<<1;f=u[k+g>>1];v[(e+8|0)+(h<<2)>>2]=f+((B(u[(k|4)+g>>1]-f|0,m)|0)/16384|0);f=b;b=0;h=1;if(f){continue}break}f=v[a+32>>2];j=v[a+28>>2]+j|0;b=j>>12;v[c>>2]=v[c>>2]+B(b,v[e+8>>2]);i=f+i|0;h=i>>12;v[c+4>>2]=v[c+4>>2]+B(h,v[e+12>>2]);Sb(e+24|0,e+16|0);d=d-1|0;if(d){c=c+8|0;f=v[e+24>>2];g=v[e+28>>2];continue}break}f=v[e+24>>2];g=v[e+28>>2];break a}h=i>>12;b=j>>12}v[a+40>>2]=i;v[a+20>>2]=b;v[a+36>>2]=j;v[a+24>>2]=h;v[a>>2]=f;v[a+4>>2]=g;jb=e+32|0}function K9(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;f=jb-32|0;jb=f;c=mk(a);if(b){c=B(b,c);a:{b:{if(v[a+12>>2]!=(b|0)){break b}if((hg(a)|0)!=(c|0)){break b}b=jb-16|0;jb=b;c=ac(a);d=bc(a);oh(b+8|0);a=jb-16|0;jb=a;v[a>>2]=d;v[a+8>>2]=c;d=ms(a,a+8|0);g=jb-16|0;jb=g;v[g+8>>2]=c;if((d|0)>0){while(1){h=g+8|0;c=v[h>>2];e=w[b+8|0]|w[b+9|0]<<8|(w[b+10|0]<<16|w[b+11|0]<<24);t[c|0]=e;t[c+1|0]=e>>>8;t[c+2|0]=e>>>16;t[c+3|0]=e>>>24;e=w[b+12|0]|w[b+13|0]<<8;t[c+4|0]=e;t[c+5|0]=e>>>8;c=d>>>0>1;Bj(h);d=d-1|0;if(c){continue}break}}jb=g+16|0;jb=a+16|0;jb=b+16|0;break a}d=f+8|0;oh(d);c=XR(f+16|0,c,d);fK(a);Fl(a,c);v[a>>2]=v[c>>2];v[a+4>>2]=v[c+4>>2];d=v[zb(c)>>2];i=zb(a),j=d,v[i>>2]=j;i=zb(c),j=0,v[i>>2]=j;v[c>>2]=0;v[c+4>>2]=0;Ml(c);v[a+12>>2]=b}a=1}else{a=0}jb=f+32|0;return a|0}function cv(a,b,c,d){var e=0,f=0,g=0,h=0;e=jb-48|0;jb=e;v[e+44>>2]=d;a:{f=v[b>>2];b:{if(!(nb[v[v[f>>2]+40>>2]](f,c,d)|0)){Vh(a);break b}Uk(e+24|0,b);v[113382]=0;b=T(241,b|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break a}d=v[v[b>>2]+24>>2];v[113382]=0;b=T(d|0,b|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break a}v[113382]=0;v[e+20>>2]=b-c;b=Q(33,e+44|0,e+20|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break a}g=v[b>>2];b=v[e+28>>2];v[e+8>>2]=v[e+24>>2];v[e+12>>2]=b;b=jb-16|0;jb=b;d=e+8|0;f=Uk(b+8|0,d);v[113382]=0;h=v[f+4>>2];v[b>>2]=v[f>>2];v[b+4>>2]=h;X(249,e+32|0,b|0,c|0,g|0);c=v[113382];v[113382]=0;c:{if((c|0)!=1){Bb(d);jb=b+16|0;break c}a=P()|0;O()|0;Bb(d);S(a|0);L()}b=v[e+36>>2];v[e>>2]=v[e+32>>2];v[e+4>>2]=b;JC(a,e,0)}jb=e+48|0;return}a=P()|0;O()|0;Bb(e+24|0);S(a|0);L()}function OH(a,b,c){var d=0,e=0,f=0,g=0,h=0;d=jb-176|0;jb=d;e=li(d+40|0);f=v[v[e>>2]-12>>2];v[113382]=0;g=da(123)|0;h=v[113382];v[113382]=0;a:{b:{c:{d:{e:{if((h|0)==1){break e}v[113382]=0;U(124,d+32|0,f+(d+40|0)|0,g|0);f=v[113382];v[113382]=0;if((f|0)==1){break e}Ob(d+32|0);v[113382]=0;R(146,e|0,c|0);f=v[113382];v[113382]=0;if((f|0)==1){break e}v[113382]=0;R(129,e|0,b|0);b=v[113382];v[113382]=0;if((b|0)==1){break e}v[113382]=0;R(126,d|0,e|0);b=v[113382];v[113382]=0;if((b|0)==1){break e}v[113382]=0;U(139,d+16|0,d|0,c|0);b=v[113382];v[113382]=0;if((b|0)==1){break d}v[113382]=0;U(140,a|0,d+16|0,c|0);a=v[113382];v[113382]=0;if((a|0)==1){break c}yb(d+16|0);yb(d);Td(e);jb=d+176|0;return}c=P()|0;O()|0;break a}c=P()|0;O()|0;break b}c=P()|0;O()|0;yb(d+16|0)}yb(d)}Td(e);S(c|0);L()}function Iq(a,b){a=a|0;b=b|0;var c=0,d=0;d=jb-16|0;jb=d;a=bd(a);a:{b:{c:{switch(b|0){case 0:v[113382]=0;b=Q(2,d|0,12010)|0;c=v[113382];v[113382]=0;if((c|0)==1){break a}Gb(a,b);yb(b);break b;case 1:v[113382]=0;b=Q(2,d|0,12035)|0;c=v[113382];v[113382]=0;if((c|0)!=1){Gb(a,b);yb(b);break b}break a;case 2:v[113382]=0;b=Q(2,d|0,11983)|0;c=v[113382];v[113382]=0;if((c|0)!=1){Gb(a,b);yb(b);break b}break a;case 3:v[113382]=0;b=Q(2,d|0,11957)|0;c=v[113382];v[113382]=0;if((c|0)!=1){Gb(a,b);yb(b);break b}break a;case 4:v[113382]=0;b=Q(2,d|0,8996)|0;c=v[113382];v[113382]=0;if((c|0)!=1){Gb(a,b);yb(b);break b}break a;case 5:break c;default:break b}}v[113382]=0;b=Q(2,d|0,3460)|0;c=v[113382];v[113382]=0;if((c|0)==1){break a}Gb(a,b);yb(b)}jb=d+16|0;return}b=P()|0;O()|0;yb(a);S(b|0);L()}function lda(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,k=0,m=0,p=0;b=A[a+8>>3];d=jb-32|0;jb=d;o(+A[a>>3]);a=j(1)|0;e=j(0)|0;o(+b);f=j(1)|0;i=j(0)|0;f=f&2147483647;c=f;g=a&2147483647;k=(c|0)==(g|0)&e>>>0<i>>>0|c>>>0>g>>>0;a=k?e:i;c=k?g:c;k=c;l(0,a|0);l(1,c|0);b=+n();c=c>>>20|0;a:{if((c|0)==2047){break a}p=e;e=(f|0)==(g|0)&e>>>0>i>>>0|f>>>0<g>>>0;l(0,(e?p:i)|0);e=e?g:f;l(1,e|0);h=+n();f=!(a|k);a=e>>>20|0;if(!(f|(a|0)==2047)){if((a-c|0)>=65){b=h+b;break a}b:{if(a>>>0>=1534){b=b*1.90109156629516e-211;h=h*1.90109156629516e-211;m=5.260135901548374e210;break b}m=1;if(c>>>0>572){break b}b=b*5.260135901548374e210;h=h*5.260135901548374e210;m=1.90109156629516e-211}rG(d+24|0,d+16|0,h);rG(d+8|0,d,b);b=m*K(A[d>>3]+A[d+16>>3]+A[d+8>>3]+A[d+24>>3]);break a}b=h}jb=d+32|0;return+b}function Mga(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;e=jb-16|0;jb=e;c=w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24);v[b>>2]=c<<24|c<<8&16711680|(c>>>8&65280|c>>>24);t[e+15|0]=w[a+4|0];t[e+14|0]=64;f=b,g=w[pc(e+15|0,e+14|0)|0]<<2,u[f+30>>1]=g;c=a+6|0;d=w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24);v[b+4>>2]=d<<24|d<<8&16711680|(d>>>8&65280|d>>>24);a=a+10|0;a=w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24);d=a<<24|a<<8&16711680|(a>>>8&65280|a>>>24);a=w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24);a=d+(a<<8&16711680|a<<24|(a>>>8&65280|a>>>24))|0;v[b+8>>2]=a;d=v[b+4>>2];c=v[b>>2];if(d>>>0>=c>>>0){d=c-1|0;v[b+4>>2]=d}if(a>>>0>c>>>0){v[b+8>>2]=c;a=c}a:{if(a>>>0<d>>>0){v[b+4>>2]=0;v[b+8>>2]=0;break a}if(a>>>0<=d>>>0){break a}v[b+68>>2]=d;u[b+34>>1]=x[b+34>>1]|2}jb=e+16|0}function n6(){var a=0,b=0,c=0,d=0,e=0;b=jb-48|0;jb=b;c=Xb(b+32|0);v[113382]=0;Z(1963,b+16|0);a=v[113382];v[113382]=0;a:{b:{c:{d:{if((a|0)!=1){a=b+16|0;d=b,e=ac(a),v[d+8>>2]=e;d=b,e=bc(a),v[d>>2]=e;if(!Jb(b+8|0,b)){break c}while(1){e:{a=v[b+8>>2];v[113382]=0;Q(1214,c|0,a|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break e}a=b+8|0;vn(a);d=b,e=bc(b+16|0),v[d>>2]=e;if(!Jb(a,b)){break c}v[113382]=0;Q(1964,c|0,10310)|0;a=v[113382];v[113382]=0;if((a|0)!=1){continue}}break}a=V(0)|0;O()|0;gd(b+16|0);break d}a=V(0)|0;O()|0}yb(c);_(a|0)|0;a=0;v[113382]=0;X(1958,3291,0,0,0);c=v[113382];v[113382]=0;if((c|0)==1){break a}$();break b}a=Ud(Tb(c));gd(b+16|0);yb(c)}jb=b+48|0;return a|0}b=P()|0;O()|0;v[113382]=0;Y(20);c=v[113382];v[113382]=0;if((c|0)!=1){S(b|0);L()}V(0)|0;O()|0;Ab();L()}function eba(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0;e=jb-16|0;jb=e;f=jb-16|0;jb=f;g=a+128e3|0;while(1){d=jb-32|0;jb=d;VN(d);b=v[d+28>>2];c=v[d+24>>2];t[a+24|0]=c;t[a+25|0]=c>>>8;t[a+26|0]=c>>>16;t[a+27|0]=c>>>24;t[a+28|0]=b;t[a+29|0]=b>>>8;t[a+30|0]=b>>>16;t[a+31|0]=b>>>24;b=v[d+20>>2];c=v[d+16>>2];t[a+16|0]=c;t[a+17|0]=c>>>8;t[a+18|0]=c>>>16;t[a+19|0]=c>>>24;t[a+20|0]=b;t[a+21|0]=b>>>8;t[a+22|0]=b>>>16;t[a+23|0]=b>>>24;b=v[d+12>>2];c=v[d+8>>2];t[a+8|0]=c;t[a+9|0]=c>>>8;t[a+10|0]=c>>>16;t[a+11|0]=c>>>24;t[a+12|0]=b;t[a+13|0]=b>>>8;t[a+14|0]=b>>>16;t[a+15|0]=b>>>24;b=v[d+4>>2];c=v[d>>2];t[a|0]=c;t[a+1|0]=c>>>8;t[a+2|0]=c>>>16;t[a+3|0]=c>>>24;t[a+4|0]=b;t[a+5|0]=b>>>8;t[a+6|0]=b>>>16;t[a+7|0]=b>>>24;jb=d+32|0;a=a+32|0;if((g|0)!=(a|0)){continue}break}jb=f+16|0;jb=e+16|0}function W2(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;e=jb-32|0;jb=e;i=Xb(a);a=Xb(e+16|0);a:{b:{c:{d:{g=b+24|0;if(!x[v[g>>2]+480192>>1]){break d}b=0;f=1;while(1){c=v[g>>2];v[113382]=0;c=Q(2150,c|0,f&65535)|0;d=v[113382];v[113382]=0;if((d|0)==1){break c}v[113382]=0;c=Q(121,e|0,c|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break c}d=Sc(c);v[113382]=0;Q(1214,a|0,c|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break b}v[113382]=0;Q(1964,a|0,17517)|0;h=v[113382];v[113382]=0;if((h|0)==1){break b}b=d^1|b;yb(c);f=f+1|0;if(x[v[g>>2]+480192>>1]>=(f&65535)>>>0){continue}break}if(!(b&1)){break d}v[113382]=0;Q(404,i|0,a|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){break d}b=P()|0;O()|0;break a}yb(a);jb=e+32|0;return}b=P()|0;O()|0;break a}b=P()|0;O()|0;yb(c)}yb(a);yb(i);S(b|0);L()}function V2(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;e=jb-32|0;jb=e;i=Xb(a);a=Xb(e+16|0);a:{b:{c:{d:{g=b+24|0;if(!x[v[g>>2]+480190>>1]){break d}b=0;f=1;while(1){c=v[g>>2];v[113382]=0;c=Q(2151,c|0,f&65535)|0;d=v[113382];v[113382]=0;if((d|0)==1){break c}v[113382]=0;c=Q(121,e|0,c|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break c}d=Sc(c);v[113382]=0;Q(1214,a|0,c|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break b}v[113382]=0;Q(1964,a|0,17517)|0;h=v[113382];v[113382]=0;if((h|0)==1){break b}b=d^1|b;yb(c);f=f+1|0;if(x[v[g>>2]+480190>>1]>=(f&65535)>>>0){continue}break}if(!(b&1)){break d}v[113382]=0;Q(404,i|0,a|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){break d}b=P()|0;O()|0;break a}yb(a);jb=e+32|0;return}b=P()|0;O()|0;break a}b=P()|0;O()|0;yb(c)}yb(a);yb(i);S(b|0);L()}function bk(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;k=jb-16|0;jb=k;t[k+15|0]=a;a:{b:{c:{if(v[d>>2]!=(c|0)){break c}l=43;m=a&255;if((m|0)!=w[j+24|0]){l=45;if(w[j+25|0]!=(m|0)){break c}}v[d>>2]=c+1;t[c|0]=l;break b}if(!(!Db(g)|(a|0)!=(f|0))){a=0;b=v[i>>2];if((b-h|0)>159){break a}a=v[e>>2];v[i>>2]=b+4;v[b>>2]=a;break b}a=-1;f=Qm(j,j+26|0,k+15|0)-j|0;if((f|0)>23){break a}d:{e:{switch(b-8|0){case 0:case 2:if((b|0)>(f|0)){break d}break a;case 1:break d;default:break e}}if((b|0)!=16|(f|0)<22){break d}b=v[d>>2];if((b|0)==(c|0)|(b-c|0)>2|w[b-1|0]!=48){break a}a=0;v[e>>2]=0;v[d>>2]=b+1;t[b|0]=w[f+59248|0];break a}a=v[d>>2];v[d>>2]=a+1;t[a|0]=w[f+59248|0];v[e>>2]=v[e>>2]+1;a=0;break a}a=0;v[e>>2]=0}jb=k+16|0;return a|0}function Kf(a){var b=0,c=0;b=v[a+4>>2];c=v[v[b>>2]-12>>2];v[113382]=0;b=v[(b+c|0)+24>>2];c=v[113382];v[113382]=0;a:{if((c|0)==1){break a}b:{if(!b){break b}b=v[a+4>>2];c=v[v[b>>2]-12>>2];v[113382]=0;b=Jf(b+c|0);c=v[113382];v[113382]=0;if((c|0)==1){break a}if(!b){break b}b=v[a+4>>2];if(!(v[(v[v[b>>2]-12>>2]+b|0)+4>>2]&8192)){break b}if(GD()){break b}b=v[a+4>>2];c=v[v[b>>2]-12>>2];v[113382]=0;b=v[(b+c|0)+24>>2];c=v[113382];v[113382]=0;c:{if((c|0)==1){break c}v[113382]=0;b=T(2707,b|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break c}if((b|0)!=-1){break b}a=v[a+4>>2];b=v[v[a>>2]-12>>2];v[113382]=0;R(18,a+b|0,1);a=v[113382];v[113382]=0;if((a|0)!=1){break b}}a=V(0)|0;O()|0;_(a|0)|0;v[113382]=0;Y(20);a=v[113382];v[113382]=0;if((a|0)==1){break a}}return}V(0)|0;O()|0;Ab();L()}function $j(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0;k=jb-16|0;jb=k;v[k+12>>2]=a;a:{b:{c:{if(v[d>>2]!=(c|0)){break c}l=43;if(v[j+96>>2]!=(a|0)){l=45;if(v[j+100>>2]!=(a|0)){break c}}v[d>>2]=c+1;t[c|0]=l;break b}if(!(!Db(g)|(a|0)!=(f|0))){a=0;b=v[i>>2];if((b-h|0)>159){break a}a=v[e>>2];v[i>>2]=b+4;v[b>>2]=a;break b}a=-1;g=Vv(j,j+104|0,k+12|0)-j|0;if((g|0)>92){break a}f=g>>2;d:{e:{switch(b-8|0){case 0:case 2:if((b|0)>(f|0)){break d}break a;case 1:break d;default:break e}}if((b|0)!=16|(g|0)<88){break d}b=v[d>>2];if((b|0)==(c|0)|(b-c|0)>2|w[b-1|0]!=48){break a}a=0;v[e>>2]=0;v[d>>2]=b+1;t[b|0]=w[f+59248|0];break a}a=v[d>>2];v[d>>2]=a+1;t[a|0]=w[f+59248|0];v[e>>2]=v[e>>2]+1;a=0;break a}a=0;v[e>>2]=0}jb=k+16|0;return a|0}function Ao(a){var b=C(0),c=0,d=0,e=0,f=0;c=jb-16|0;jb=c;e=(p(a),j(2));d=e&2147483647;a:{if(d>>>0<=1061752794){b=C(1);if(d>>>0<964689920){break a}b=Dh(+a);break a}if(d>>>0<=1081824209){f=+a;if(d>>>0>=1075235812){b=C(-Dh(((e|0)>=0?-3.141592653589793:3.141592653589793)+f));break a}if((e|0)<0){b=Eh(f+1.5707963267948966);break a}b=Eh(1.5707963267948966-f);break a}if(d>>>0<=1088565717){if(d>>>0>=1085271520){b=Dh(((e|0)>=0?-6.283185307179586:6.283185307179586)+ +a);break a}if((e|0)<0){b=Eh(-4.71238898038469-+a);break a}b=Eh(+a+-4.71238898038469);break a}b=C(a-a);if(d>>>0>=2139095040){break a}b:{switch(vw(a,c+8|0)&3){case 0:b=Dh(A[c+8>>3]);break a;case 1:b=Eh(-A[c+8>>3]);break a;case 2:b=C(-Dh(A[c+8>>3]));break a;default:break b}}b=Eh(A[c+8>>3])}a=b;jb=c+16|0;return a}function q7(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=C(0),j=0,k=0,l=0,m=0,n=C(0),o=C(0),p=0,q=0,r=0,s=0;g=jb-16|0;jb=g;j=a+44|0;if(vh(j)){r=g,s=Jd(j,0),v[r+8>>2]=s;r=g,s=Jd(j,1),v[r+12>>2]=s;r=g,s=ed(j,0),v[r>>2]=s;r=g,s=ed(j,1),v[r+4>>2]=s;if(d){p=w[a+4273|0];q=w[a+4272|0];k=d;while(1){e=0;l=1;while(1){h=e<<2;f=h+(g+8|0)|0;e=v[f>>2];v[f>>2]=e+4;f=a+h|0;m=f+4228|0;i=C(C(z[a+4236>>2]*z[m>>2])+C(z[a+4240>>2]*z[e>>2]));z[m>>2]=i;i=C(z[a+4260>>2]*SI(C(i*C(1073741824)),q,p));e=f+4244|0;n=z[a+4264>>2];f=f+4252|0;o=z[f>>2];i=C(i-C(C(z[a+4268>>2]*z[e>>2])+C(n*o)));z[f>>2]=i;z[e>>2]=o+C(i*n);e=g+h|0;h=v[e>>2];v[e>>2]=h+4;z[h>>2]=i*C(9.313225746154785e-10);h=l;l=0;e=1;if(h){continue}break}k=k-1|0;if(k){continue}break}}pi(a,b,c,ed(j,0),ed(j,1),d)}jb=g+16|0}function yfa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;e=jb-32|0;jb=e;i=v[a+40>>2];j=v[a+36>>2];k=v[a+16>>2];b=v[a+4>>2];h=b;f=v[a>>2];v[e+24>>2]=f;v[e+28>>2]=b;b=v[a+12>>2];v[e+16>>2]=v[a+8>>2];v[e+20>>2]=b;a:{if(d){while(1){l=f>>>10&4194048;h=(((h&2147483647)<<1|f>>>31)&-2)+k|0;g=0;b=1;while(1){f=t[h+g|0];v[(e+8|0)+(g<<2)>>2]=((B(t[(g|2)+h|0]-f|0,l)|0)/16384|0)+(f<<8);f=b;b=0;g=1;if(f){continue}break}f=v[a+32>>2];j=v[a+28>>2]+j|0;b=j>>12;v[c>>2]=v[c>>2]+B(b,v[e+8>>2]);i=f+i|0;g=i>>12;v[c+4>>2]=v[c+4>>2]+B(g,v[e+12>>2]);Sb(e+24|0,e+16|0);d=d-1|0;if(d){c=c+8|0;f=v[e+24>>2];h=v[e+28>>2];continue}break}f=v[e+24>>2];h=v[e+28>>2];break a}g=i>>12;b=j>>12}v[a+40>>2]=i;v[a+20>>2]=b;v[a+36>>2]=j;v[a+24>>2]=g;v[a>>2]=f;v[a+4>>2]=h;jb=e+32|0}function Ww(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;c=jb-80|0;jb=c;d=v[a>>2];g=v[d+4>>2];f=v[d+24>>2];v[c+40>>2]=v[d+20>>2];v[c+44>>2]=f;f=v[d+16>>2];v[c+32>>2]=v[d+12>>2];v[c+36>>2]=f;Fh(c- -64|0,c+32|0,g);d=ie(c+48|0,v[v[a+4>>2]>>2],v[v[a+8>>2]>>2],v[v[a+12>>2]>>2]);g=v[v[a+12>>2]>>2];f=v[v[a+8>>2]>>2];a=v[c+76>>2];v[c+24>>2]=v[c+72>>2];v[c+28>>2]=a;a=v[c+68>>2];v[c+16>>2]=v[c+64>>2];v[c+20>>2]=a;v[c+8>>2]=v[d+8>>2];a=v[d+4>>2];v[c>>2]=v[d>>2];v[c+4>>2]=a;i=c+16|0;a=c;if(g){j=b+4|0;while(1){d=0;if(f){while(1){e=v[Sf(a,d,h)>>2];ec(b,d);e=(e+((Lr(j)^-2147483648)>>>21|0)|0)-2147482624>>>12|0;e=e>>>0>491520?e:491520;k=Lm(i,d,h),l=e>>>0<557055?e:557055,u[k>>1]=l;d=d+1|0;if((f|0)!=(d|0)){continue}break}}h=h+1|0;if((g|0)!=(h|0)){continue}break}}jb=c+80|0}function Tba(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;e=jb-16|0;jb=e;v[e+8>>2]=c>>>4;v[e+4>>2]=v[a>>2];d=v[Lb(e+8|0,e+4|0)>>2];b=Eb(b);if(d){a=v[a+20>>2];c=d;while(1){g=w[b+4|0]|w[b+5|0]<<8|(w[b+6|0]<<16|w[b+7|0]<<24);v[e+8>>2]=w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24);v[e+12>>2]=g;Vf(e+8|0,-1,1);f=A[e+8>>3]*32768;A[e+8>>3]=f;g=a;f=Md(f);a:{if(D(f)<2147483648){h=~~f;break a}h=-2147483648}i=g,j=Rc(h),u[i>>1]=j;g=w[b+12|0]|w[b+13|0]<<8|(w[b+14|0]<<16|w[b+15|0]<<24);v[e+8>>2]=w[b+8|0]|w[b+9|0]<<8|(w[b+10|0]<<16|w[b+11|0]<<24);v[e+12>>2]=g;Vf(e+8|0,-1,1);f=A[e+8>>3]*32768;A[e+8>>3]=f;g=a;f=Md(f);b:{if(D(f)<2147483648){h=~~f;break b}h=-2147483648}i=g,j=Rc(h),u[i+2>>1]=j;a=a+4|0;b=b+16|0;c=c-1|0;if(c){continue}break}}jb=e+16|0;return d<<4}function vaa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;c=jb-80|0;jb=c;g=YM(a,1<<b-1);v[a+12>>2]=b;e=1<<b;h=e>>>2|0;a:{if(b>>>0>=2){i=1/+(e>>>0);b=h;e=1;while(1){v[113382]=0;A[c+40>>3]=+(b>>>0)*-6.283185307179586*i;U(1497,c+48|0,35168,c+40|0);d=v[113382];v[113382]=0;if((d|0)==1){break a}v[113382]=0;R(1183,c- -64|0,c+48|0);d=v[113382];v[113382]=0;if((d|0)==1){break a}d=sc(g,e);f=v[c+76>>2];v[d+8>>2]=v[c+72>>2];v[d+12>>2]=f;f=v[c+68>>2];v[d>>2]=v[c+64>>2];v[d+4>>2]=f;e=e<<1;d=b>>>0<2;b=b>>>1|0;if(!d){continue}break}}b=fn(c+24|0,1,0);v[113382]=0;e=v[b+12>>2];v[c+16>>2]=v[b+8>>2];v[c+20>>2]=e;e=v[b+4>>2];v[c+8>>2]=v[b>>2];v[c+12>>2]=e;X(1498,a|0,0,h|0,c+8|0);b=v[113382];v[113382]=0;if((b|0)==1){break a}jb=c+80|0;return a|0}a=P()|0;O()|0;kp(g);S(a|0);L()}function O6(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;d=qi(a,b,c,d);v[a+4260>>2]=0;v[a>>2]=76672;c=a+4960|0;e=a+4504|0;b=e;while(1){kk(b);b=b+24|0;if((c|0)!=(b|0)){continue}break}t[a+5046|0]=1;u[a+5044>>1]=0;v[a+4208>>2]=1063675494;v[a+4212>>2]=1065185444;v[a+4256>>2]=1059760811;b=a+4248|0;v[b>>2]=1065353216;v[b+4>>2]=1048525618;b=a+4240|0;v[b>>2]=1038174126;v[b+4>>2]=1065353216;b=a+4232|0;v[b>>2]=1047457519;v[b+4>>2]=1062836634;b=a+4224|0;v[b>>2]=1053079357;v[b+4>>2]=1059859440;b=a+4216|0;v[b>>2]=0;v[b+4>>2]=1032805417;v[113382]=0;W(1609,a+44|0,2,2)|0;b=v[113382];v[113382]=0;a:{if((b|0)!=1){v[113382]=0;Z(1610,d|0);b=v[113382];v[113382]=0;if((b|0)!=1){break a}}a=P()|0;O()|0;while(1){c=c-24|0;fg(c);if((c|0)!=(e|0)){continue}break}rf(d);S(a|0);L()}return a|0}function pf(a,b){var c=0,d=0,e=0;d=jb-32|0;jb=d;a=Qg(a,-1,-1);a:{b:{if(w[cj(d+24|0,b,1)|0]){c=v[v[b>>2]-12>>2];v[113382]=0;c=v[(b+c|0)+24>>2];e=v[113382];v[113382]=0;c:{d:{if((e|0)==1){break d}v[113382]=0;Qa(2717,d+8|0,c|0,0,0,1,8);c=v[113382];v[113382]=0;if((c|0)==1){break d}c=v[d+12>>2];v[a>>2]=v[d+8>>2];v[a+4>>2]=c;c=v[d+20>>2];v[a+8>>2]=v[d+16>>2];v[a+12>>2]=c;a=0;break c}a=V(0)|0;O()|0;_(a|0)|0;bj(v[v[b>>2]-12>>2]+b|0,1);a=v[v[b>>2]-12>>2];v[113382]=0;a=v[(a+b|0)+20>>2];c=v[113382];v[113382]=0;e:{if((c|0)!=1){if(!(a&1)){break e}v[113382]=0;Y(81);a=v[113382];v[113382]=0;if((a|0)!=1){break a}}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)==1){break b}S(a|0);L()}$();a=1}Eg(v[v[b>>2]-12>>2]+b|0,a)}jb=d+32|0;return}V(0)|0;O()|0;Ab()}L()}function TK(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;e=jb-16|0;jb=e;g=-1;a:{if(!Qx(a,b,2)){break a}i=v[b+656>>2];d=e+8|0;f=a+1074312|0;Fb(d,f,31);b:{if(Cb(d)){d=v[b+752>>2];if(d){break b}break a}d=v[b+752>>2]}h=e+8|0;Fb(h,f,31);f=d-Cb(h)|0;d=v[a+480180>>2];d=(d|0)==4096?64:(d|0)==16384?192:512;d=tp(i+88|0,f,d,v[a+480180>>2]==4096?255:64)-(d>>>1|0)|0;if(w[b+748|0]&16){g=ip(a,b,!(v[b+88>>2]&32768),d);break a}if(tj(b)){if((d|0)==v[b+768>>2]){break a}v[b+768>>2]=d;t[b+872|0]=w[b+872|0]|8;break a}b=ap(a);v[e+8>>2]=d;f=c;c:{if((d|0)<0){v[e+8>>2]=0-d;Si(e+8|0,255);a=(v[e+8>>2]<<2)+(b?31568:30544)|0;break c}Si(e+8|0,255);a=(v[e+8>>2]<<2)+(b?30544:31568)|0}a=v[a>>2];b=a;d=a>>31;a=v[c>>2];j=f,k=zc(rma(qma(b,d,a,a>>31),mb,65536,0),mb),v[j>>2]=k}jb=e+16|0;return g}function xba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;if(v[a+4>>2]!=v[zb(a)>>2]){c=jb-16|0;jb=c;d=_n(c,a,1);a=zb(a);e=v[d+4>>2];v[113382]=0;U(1336,a|0,e|0,b|0);a=v[113382];v[113382]=0;a:{if((a|0)!=1){v[d+4>>2]=v[d+4>>2]+32;Mb(d);jb=c+16|0;break a}a=P()|0;O()|0;Mb(d);S(a|0);L()}return}g=jb-32|0;jb=g;d=a;i=zb(a);c=hm(a,ue(a)+1|0);f=ue(a);e=jb-16|0;jb=e;v[e+12>>2]=0;a=g+8|0;Le(a+12|0,i);if(c){h=FL(v[a+16>>2],c)}v[a>>2]=h;f=(f<<5)+h|0;v[a+8>>2]=f;v[a+4>>2]=f;j=gc(a),k=(c<<5)+h|0,v[j>>2]=k;jb=e+16|0;c=v[a+8>>2];v[113382]=0;U(1336,i|0,c|0,b|0);b=v[113382];v[113382]=0;b:{c:{if((b|0)==1){break c}v[a+8>>2]=v[a+8>>2]+32;v[113382]=0;R(1337,d|0,a|0);b=v[113382];v[113382]=0;if((b|0)==1){break c}GL(a);jb=g+32|0;break b}b=P()|0;O()|0;GL(a);S(b|0);L()}}function N3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;if(y[a+4>>2]<y[zb(a)>>2]){c=jb-16|0;jb=c;d=Mk(c,a,1);a=zb(a);e=v[d+4>>2];v[113382]=0;U(2101,a|0,e|0,b|0);a=v[113382];v[113382]=0;a:{if((a|0)!=1){v[d+4>>2]=v[d+4>>2]+24;Mb(d);jb=c+16|0;break a}a=P()|0;O()|0;Mb(d);S(a|0);L()}return}g=jb-32|0;jb=g;d=a;i=zb(a);c=Lk(a,Cd(a)+1|0);f=Cd(a);e=jb-16|0;jb=e;v[e+12>>2]=0;a=g+8|0;Le(a+12|0,i);if(c){h=HL(v[a+16>>2],c)}v[a>>2]=h;f=B(f,24)+h|0;v[a+8>>2]=f;v[a+4>>2]=f;j=gc(a),k=B(c,24)+h|0,v[j>>2]=k;jb=e+16|0;c=v[a+8>>2];v[113382]=0;U(2101,i|0,c|0,b|0);b=v[113382];v[113382]=0;b:{c:{if((b|0)==1){break c}v[a+8>>2]=v[a+8>>2]+24;v[113382]=0;R(2102,d|0,a|0);b=v[113382];v[113382]=0;if((b|0)==1){break c}wH(a);jb=g+32|0;break b}b=P()|0;O()|0;wH(a);S(b|0);L()}}function LG(a){var b=C(0),c=C(0),d=C(0),e=C(0),f=C(0),g=C(0),h=C(0),i=C(0),j=C(0),k=C(0),l=C(0),m=C(0),n=C(0),o=C(0);b=z[a+32>>2];c=z[a+8>>2];e=z[a+16>>2];f=C(C(b-c)+e);i=z[a>>2];j=z[a+24>>2];k=C(i-j);z[a+16>>2]=f+k;d=z[a+4>>2];g=z[a+20>>2];h=z[a+28>>2];l=C(C(d-C(g+h))*C(.8660253882408142));k=C(k-C(f*C(.5)));z[a+4>>2]=l+k;m=C(C(g+d)*C(.9848077297210693));f=C(z[a+12>>2]*C(.8660253882408142));n=C(C(h+d)*C(-.6427876353263855));o=C(C(m-f)+n);d=C(i+C(j*C(.5)));i=C(C(b+c)*C(.7660444378852844));b=C(C(e-b)*C(.1736481785774231));j=C(C(d-i)+b);z[a+12>>2]=o+j;z[a+20>>2]=j-o;z[a+28>>2]=k-l;g=C(C(g-h)*C(.3420201539993286));h=C(g-C(f+m));c=C(C(e+c)*C(.9396926164627075));b=C(C(d+c)-b);z[a+32>>2]=h+b;e=C(C(g+f)+n);c=C(C(d-c)+i);z[a+24>>2]=e+c;z[a+8>>2]=c-e;z[a>>2]=b-h}function qG(a){var b=0,c=0,d=0,e=0;b=jb-16|0;jb=b;e=(p(a),j(2));c=e&2147483647;a:{if(c>>>0<=1061752794){if(c>>>0<964689920){break a}a=Eh(+a);break a}if(c>>>0<=1081824209){d=+a;if(c>>>0<=1075235811){if((e|0)<0){a=C(-Dh(d+1.5707963267948966));break a}a=Dh(d+-1.5707963267948966);break a}a=Eh(-(((e|0)>=0?-3.141592653589793:3.141592653589793)+d));break a}if(c>>>0<=1088565717){d=+a;if(c>>>0<=1085271519){if((e|0)<0){a=Dh(d+4.71238898038469);break a}a=C(-Dh(d+-4.71238898038469));break a}a=Eh(((e|0)>=0?-6.283185307179586:6.283185307179586)+d);break a}if(c>>>0>=2139095040){a=C(a-a);break a}b:{switch(vw(a,b+8|0)&3){case 0:a=Eh(A[b+8>>3]);break a;case 1:a=Dh(A[b+8>>3]);break a;case 2:a=Eh(-A[b+8>>3]);break a;default:break b}}a=C(-Dh(A[b+8>>3]))}jb=b+16|0;return a}function x2(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;d=jb-32|0;jb=d;g=ih(a);f=b+24|0;a=x[v[f>>2]+480192>>1];v[113382]=0;R(1500,g|0,a|0);c=v[113382];v[113382]=0;a=1;a:{if((c|0)!=1){b:{c:{d:{e:{if(x[v[f>>2]+480192>>1]){while(1){c=v[f>>2];v[113382]=0;c=Q(2150,c|0,a&65535)|0;e=v[113382];v[113382]=0;if((e|0)==1){break e}v[113382]=0;c=Q(121,d|0,c|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break e}v[113382]=0;U(2152,d+16|0,b|0,c|0);e=v[113382];v[113382]=0;if((e|0)==1){break d}v[113382]=0;R(1502,g|0,d+16|0);e=v[113382];v[113382]=0;if((e|0)==1){break c}yb(d+16|0);yb(c);a=a+1|0;if(x[v[f>>2]+480192>>1]>=(a&65535)>>>0){continue}break}}jb=d+32|0;return}a=P()|0;O()|0;break a}a=P()|0;O()|0;break b}a=P()|0;O()|0;yb(d+16|0)}yb(c);break a}a=P()|0;O()|0}gd(g);S(a|0);L()}function w2(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;d=jb-32|0;jb=d;g=ih(a);f=b+24|0;a=x[v[f>>2]+480190>>1];v[113382]=0;R(1500,g|0,a|0);c=v[113382];v[113382]=0;a=1;a:{if((c|0)!=1){b:{c:{d:{e:{if(x[v[f>>2]+480190>>1]){while(1){c=v[f>>2];v[113382]=0;c=Q(2151,c|0,a&65535)|0;e=v[113382];v[113382]=0;if((e|0)==1){break e}v[113382]=0;c=Q(121,d|0,c|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break e}v[113382]=0;U(2152,d+16|0,b|0,c|0);e=v[113382];v[113382]=0;if((e|0)==1){break d}v[113382]=0;R(1502,g|0,d+16|0);e=v[113382];v[113382]=0;if((e|0)==1){break c}yb(d+16|0);yb(c);a=a+1|0;if(x[v[f>>2]+480190>>1]>=(a&65535)>>>0){continue}break}}jb=d+32|0;return}a=P()|0;O()|0;break a}a=P()|0;O()|0;break b}a=P()|0;O()|0;yb(d+16|0)}yb(c);break a}a=P()|0;O()|0}gd(g);S(a|0);L()}function $m(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0;e=v[b+88>>2];c=e|2048;v[b+88>>2]=c;f=v[b+656>>2];if(!(!f|t[b+724|0]&1)){c=e|6144;v[b+88>>2]=c}a:{if(!v[b+76>>2]){break a}b:{if(!(c&8)){break b}d=v[b+104>>2];if(!d|e&2048){break b}e=x[d+34>>1];if(e&2){v[b+88>>2]=(e&4?c|4:c&-135)|2;c=v[d>>2];v[b+76>>2]=c;e=v[d+4>>2];v[b+80>>2]=e;d=v[d+8>>2];v[b+84>>2]=d;if(c>>>0>d>>>0){v[b+76>>2]=d;g=d}else{g=c}c=v[b+4>>2];if(g>>>0>=c>>>0){break b}v[b>>2]=0;v[b+4>>2]=((c-e>>>0)%(d-e>>>0)|0)+e;break b}v[b+88>>2]=c&-135;v[b+76>>2]=v[d>>2]}if(!f){break a}if(!(!(v[a+480180>>2]&1064964?1:w[f+60|0]&2)|!v[f>>2])){v[b+88>>2]=v[b+88>>2]|4096}if(w[f+65|0]==255|v[b+732>>2]!=-1){break a}a=f+48|0;h=b,i=tp(a,v[b+728>>2],256,64),v[h+732>>2]=i;h=b,i=x[Pb(a,w[f+65|0])>>1],v[h+728>>2]=i}}function x_(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;k=jb-16|0;jb=k;a:{if(a){a=ZE(c);b:{if(b){Tj(k,a);b=v[k>>2];t[d|0]=b;t[d+1|0]=b>>>8;t[d+2|0]=b>>>16;t[d+3|0]=b>>>24;Sj(k,a);break b}ir(k,a);b=v[k>>2];t[d|0]=b;t[d+1|0]=b>>>8;t[d+2|0]=b>>>16;t[d+3|0]=b>>>24;ch(k,a)}$h(i,k);Jc(k);l=e,m=di(a),v[l>>2]=m;l=f,m=ci(a),v[l>>2]=m;vg(k,a);Gb(g,k);yb(k);dh(k,a);$h(h,k);Jc(k);a=Rj(a);break a}a=YE(c);c:{if(b){Tj(k,a);b=v[k>>2];t[d|0]=b;t[d+1|0]=b>>>8;t[d+2|0]=b>>>16;t[d+3|0]=b>>>24;Sj(k,a);break c}ir(k,a);b=v[k>>2];t[d|0]=b;t[d+1|0]=b>>>8;t[d+2|0]=b>>>16;t[d+3|0]=b>>>24;ch(k,a)}$h(i,k);Jc(k);l=e,m=di(a),v[l>>2]=m;l=f,m=ci(a),v[l>>2]=m;vg(k,a);Gb(g,k);yb(k);dh(k,a);$h(h,k);Jc(k);a=Rj(a)}v[j>>2]=a;jb=k+16|0}function lfa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=jb-32|0;jb=e;i=v[a+24>>2];j=v[a+20>>2];k=v[a+16>>2];g=v[a+4>>2];b=g;f=v[a>>2];v[e+24>>2]=f;v[e+28>>2]=b;g=v[a+12>>2];v[e+16>>2]=v[a+8>>2];v[e+20>>2]=g;if(d){while(1){g=((((b&2147483647)<<1|f>>>31)&2147483646)<<1)+k|0;b=(f>>>21&2040)+33120|0;l=u[b+6>>1];m=u[b+4>>1];n=u[b+2>>1];o=u[b>>1];h=0;b=1;while(1){f=h<<1;v[(e+8|0)+(h<<2)>>2]=(((B(u[f+g>>1],n)+B(u[(f|-4)+g>>1],o)|0)+B(u[(f|4)+g>>1],m)|0)+B(u[(f|8)+g>>1],l)|0)/16384;f=b;b=0;h=1;if(f){continue}break}v[c>>2]=v[c>>2]+B(v[e+8>>2],j);v[c+4>>2]=v[c+4>>2]+B(v[e+12>>2],i);Sb(e+24|0,e+16|0);d=d-1|0;if(d){c=c+8|0;f=v[e+24>>2];b=v[e+28>>2];continue}break}f=v[e+24>>2];b=v[e+28>>2]}v[a>>2]=f;v[a+4>>2]=b;jb=e+32|0}function Wba(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=C(0),h=0,i=0,j=0;e=jb-16|0;jb=e;v[e+12>>2]=c>>>3;v[e+8>>2]=v[a>>2];d=v[Lb(e+12|0,e+8|0)>>2];b=Eb(b);if(d){a=v[a+20>>2];c=d;while(1){f=w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24);v[e+12>>2]=f<<24|f<<8&16711680|(f>>>8&65280|f>>>24);Wd(e+12|0,C(-1));g=C(z[e+12>>2]*C(32768));z[e+12>>2]=g;f=a;g=de(g);a:{if(C(D(g))<C(2147483648)){h=~~g;break a}h=-2147483648}i=f,j=Rc(h),u[i>>1]=j;f=w[b+4|0]|w[b+5|0]<<8|(w[b+6|0]<<16|w[b+7|0]<<24);v[e+12>>2]=f<<24|f<<8&16711680|(f>>>8&65280|f>>>24);Wd(e+12|0,C(-1));g=C(z[e+12>>2]*C(32768));z[e+12>>2]=g;f=a;g=de(g);b:{if(C(D(g))<C(2147483648)){h=~~g;break b}h=-2147483648}i=f,j=Rc(h),u[i+2>>1]=j;a=a+4|0;b=b+8|0;c=c-1|0;if(c){continue}break}}jb=e+16|0;return d<<3}function Lu(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0,k=0;f=jb-16|0;jb=f;t[f+15|0]=d;t[b+12|0]=w[a|0]&15|w[b+12|0]&240;g=a+1|0;d=f+15|0;Fg(b,w[pc(g,d)|0]);e=w[pc(a+2|0,d)|0];t[b+13|0]=e;j=b,k=Ed(w[a+3|0],e,w[f+15|0]),t[j+14|0]=k;d=w[pc(a+4|0,d)|0];t[b+15|0]=d;j=b,k=Ed(w[a+5|0],d,w[f+15|0]),t[j+16|0]=k;t[f+14|0]=25;if(w[pc(f+14|0,g)|0]){d=0;while(1){e=B(d,3)+a|0;h=Yb(w[e+6|0]+c<<24>>24,0,64);j=Pb(b,d),k=h,t[j+2|0]=k;e=e+7|0;e=w[e|0]|w[e+1|0]<<8;j=Pb(b,d),k=e,u[j>>1]=k;a:{if(!d){break a}e=d-1|0;if(x[Pb(b,d)>>1]>=x[Pb(b,e)>>1]){break a}if(x[Pb(b,d)>>1]>255){break a}h=w[Pb(b,e)+1|0];i=Pb(b,d);u[i>>1]=x[i>>1]|h<<8;if(x[Pb(b,d)>>1]>=x[Pb(b,e)>>1]){break a}e=Pb(b,d);u[e>>1]=x[e>>1]+256}t[f+14|0]=25;d=d+1|0;if(d>>>0<w[pc(f+14|0,g)|0]){continue}break}}jb=f+16|0}function YQ(a){var b=0,c=0,d=0;a:{if(md(a,10124,3)){break a}b=a+3|0;if(w[b|0]<48|w[b|0]>51){break a}b=a+8|0;c=w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24);if((c<<24|c<<8&16711680|(c>>>8&65280|c>>>24))>>>0<52){break a}b=w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24);if((b<<24|b<<8&16711680|(b>>>8&65280|b>>>24))>>>0>4294966507){break a}b=a+16|0;b=w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24);if((b<<24|b<<8&16711680|(b>>>8&65280|b>>>24))>>>0<52){break a}b=a+24|0;if(w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24)){b=w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24);if((b<<24|b<<8&16711680|(b>>>8&65280|b>>>24))>>>0<52){break a}}a=a+32|0;a=w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24);d=(a<<24|a<<8&16711680|(a>>>8&65280|a>>>24))>>>0<4294967216}return d}function B_(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;k=jb-16|0;jb=k;a:{if(a){a=cF(c);b:{if(b){Tj(k,a);b=v[k>>2];t[d|0]=b;t[d+1|0]=b>>>8;t[d+2|0]=b>>>16;t[d+3|0]=b>>>24;Sj(k,a);break b}ir(k,a);b=v[k>>2];t[d|0]=b;t[d+1|0]=b>>>8;t[d+2|0]=b>>>16;t[d+3|0]=b>>>24;ch(k,a)}Gb(i,k);yb(k);l=e,m=di(a),t[l|0]=m;l=f,m=ci(a),t[l|0]=m;vg(k,a);Gb(g,k);yb(k);dh(k,a);Gb(h,k);yb(k);a=Rj(a);break a}a=bF(c);c:{if(b){Tj(k,a);b=v[k>>2];t[d|0]=b;t[d+1|0]=b>>>8;t[d+2|0]=b>>>16;t[d+3|0]=b>>>24;Sj(k,a);break c}ir(k,a);b=v[k>>2];t[d|0]=b;t[d+1|0]=b>>>8;t[d+2|0]=b>>>16;t[d+3|0]=b>>>24;ch(k,a)}Gb(i,k);yb(k);l=e,m=di(a),t[l|0]=m;l=f,m=ci(a),t[l|0]=m;vg(k,a);Gb(g,k);yb(k);dh(k,a);Gb(h,k);yb(k);a=Rj(a)}v[j>>2]=a;jb=k+16|0}function Z9(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;sd(c,0);u[c+28>>1]=w[a+36|0]<<2;d=w[a+37|0];u[c+32>>1]=64;u[c+30>>1]=d<<2;d=a+40|0;v[c>>2]=w[d|0]|w[d+1|0]<<8|(w[d+2|0]<<16|w[d+3|0]<<24);d=a+44|0;v[c+4>>2]=w[d|0]|w[d+1|0]<<8|(w[d+2|0]<<16|w[d+3|0]<<24);d=a+48|0;v[c+8>>2]=w[d|0]|w[d+1|0]<<8|(w[d+2|0]<<16|w[d+3|0]<<24);d=a+52|0;v[c+24>>2]=w[d|0]|w[d+1|0]<<8|(w[d+2|0]<<16|w[d+3|0]<<24);d=b+151|0;if(w[d|0]<5){t[c+38|0]=w[w[d|0]+35994|0]}t[c+39|0]=w[b+152|0];d=b+156|0;t[c+41|0]=(w[d|0]|w[d+1|0]<<8)>>>4;b=b+154|0;b=(w[b|0]|w[b+1|0]<<8)>>>2|0;t[c+40|0]=b;if(w[c+41|0]|b&255){t[c+39|0]=w[c+39|0]^-1}a=a+38|0;if(w[a|0]&4){u[c+34>>1]=x[c+34>>1]|1}if(w[a|0]&8){u[c+34>>1]=x[c+34>>1]|2}if(w[a|0]&16){u[c+34>>1]=x[c+34>>1]|4}if(w[a|0]&32){u[c+34>>1]=x[c+34>>1]|32}}function UL(a,b,c){var d=0,e=0,f=0;e=jb-16|0;jb=e;a:{if(v[a+480180>>2]==4){d=w[b+833|0];if(c){t[b+833|0]=d&240|c&15;break a}c=d&15;break a}if(v[a+480180>>2]!=1048576){break a}if(c){t[b+833|0]=c;break a}c=w[b+833|0]}b:{if(!(t[b+872|0]&1)){break b}d=v[b+700>>2];if(!d|!(c&255)){break b}c:{if(!(w[a+480208|0]&16)){break c}d=v[b+700>>2];if(v[a+480180>>2]==4){break c}c=hy(a,c&15);f=qma(c,c>>31,d,d>>31)+32768|0;c=mb;c=zc(rma(f,f>>>0<32768?c+1|0:c,65536,0),mb);v[b+700>>2]=c;if((c|0)!=(d|0)){break b}c=e+8|0;a=a+1074312|0;Fb(c,a,7);if(!(Cb(c)|v[b+700>>2]==2147483647)){v[b+700>>2]=v[b+700>>2]+1;break b}c=e+8|0;Fb(c,a,7);if(!Cb(c)){break b}a=v[b+700>>2];if((a|0)<2){break b}v[b+700>>2]=a-1;break b}a=((c&255)<<2)+d|0;v[b+700>>2]=(a|0)<65535?a:65535}jb=e+16|0}function CI(a){var b=0,c=0,d=0,e=0,f=0,g=C(0),h=0,i=0,j=0,k=0,l=0,m=0,n=C(0);c=Ue(v[a+16>>2]);g=C(C(z[a+4220>>2]*C(.9980000257492065))+C(.0010000000474974513));d=-9965.784284662086/+C(C(C(z[a+4216>>2]*C(2999.9990234375))+C(.0010000000474974513))*C(c>>>0));m=a,n=C(Yg(d*+y[a+4288>>2])),z[m+4232>>2]=n;m=a+4236|0,n=C(Yg(d*+y[a+4292>>2])),z[m>>2]=n;l=d*(1/+g+-1);c=0;h=a+4272|0;i=a+4232|0;while(1){j=v[(c<<2)+h>>2];e=c<<1&-4;f=Yg(l*+(j+v[(e+h|0)+16>>2]>>>0));b=Yg(d*+(j>>>0));g=z[e+i>>2];e=(c<<3)+i|0;f=f*.5;z[e+12>>2]=b*(.5-f);z[e+8>>2]=b*(f+.5);b=b*+g;b=(((b+1)*b+1)*b+1)*b+1;k=b*b+k;c=c+1|0;if((c|0)!=4){continue}break}d=Yg(+BI(z[a+4208>>2])*.16609640474436813);b=Yg(+BI(z[a+4212>>2])*.33219280948873625);z[a+4228>>2]=d*4*K(b)/K(k);z[a+4224>>2]=d*K(1-b)}function Q1(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=jb-80|0;jb=d;e=v[a+4>>2];Tu(d+16|0,b);v[113382]=0;a=Q(2,d|0,13778)|0;b=v[113382];v[113382]=0;a:{b:{c:{d:{e:{f:{g:{h:{if((b|0)!=1){v[113382]=0;U(3,d+32|0,d+16|0,a|0);b=v[113382];v[113382]=0;if((b|0)==1){break h}v[113382]=0;U(684,d+48|0,d+32|0,c|0);b=v[113382];v[113382]=0;if((b|0)==1){break g}v[113382]=0;U(9,d- -64|0,0,d+48|0);b=v[113382];v[113382]=0;if((b|0)==1){break f}b=v[v[e>>2]+8>>2];v[113382]=0;R(b|0,e|0,d- -64|0);b=v[113382];v[113382]=0;if((b|0)==1){break e}yb(d- -64|0);yb(d+48|0);yb(d+32|0);yb(a);yb(d+16|0);jb=d+80|0;return}b=P()|0;O()|0;break a}b=P()|0;O()|0;break b}b=P()|0;O()|0;break c}b=P()|0;O()|0;break d}b=P()|0;O()|0;yb(d- -64|0)}yb(d+48|0)}yb(d+32|0)}yb(a)}yb(d+16|0);S(b|0);L()}function lK(a){a=a|0;var b=0;a:{b:{c:{if(w[a+3|0]!=19){break c}t[a+3|0]=20;d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{o:{b=w[a+5|0];switch(b>>>4|0){case 6:break j;case 5:break k;case 4:break l;case 3:break m;case 2:break n;case 1:break o;case 0:break b;case 13:break d;case 12:break e;case 11:break f;case 10:break g;case 9:break h;case 7:break i;default:break c}}t[a+3|0]=2;break a}t[a+3|0]=3;break a}t[a+5|0]=b&15|16;return}t[a+5|0]=b&3|48;return}t[a+5|0]=b&15|32;return}t[a+5|0]=b&15|176;return}t[a+5|0]=b&3|64;return}t[a+3|0]=15;t[a+5|0]=b&15;return}if(b&15){t[a+3|0]=11;t[a+5|0]=b<<4|15;return}break b}if(b&15){t[a+3|0]=11;break a}break b}if((b|0)!=192){break c}t[a|0]=254;break b}if((b|0)!=208){break c}t[a+3|0]=0}return}t[a+3|0]=0;return}t[a+5|0]=b|240}function ema(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;f=jb-48|0;jb=f;a:{b:{if(v[a+8>>2]!=v[gc(a)>>2]){break b}g=a+8|0;h=a+4|0;c=v[a+4>>2];e=v[a>>2];if(c>>>0>e>>>0){i=((c-e>>1)+1|0)/-2<<1;e=i+c|0;d=g;g=v[d>>2];if((g|0)!=(c|0)){while(1){bT(e,c);e=e+2|0;c=c+2|0;if((g|0)!=(c|0)){continue}break}}v[d>>2]=e;v[h>>2]=i+v[h>>2];break b}j=f,k=v[gc(a)>>2]-v[a>>2]|0,v[j+24>>2]=k;v[f+44>>2]=1;c=f+24|0;d=v[Vc(c,f+44|0)>>2];d=bq(c,d,d>>>2|0,v[a+16>>2]);c=Oc(f+16|0,v[a+4>>2]);e=v[Oc(f+8|0,v[a+8>>2])>>2];c=v[c>>2];v[113382]=0;U(485,d|0,c|0,e|0);c=v[113382];v[113382]=0;if((c|0)==1){break a}dc(a,d);dc(h,d+4|0);dc(g,d+8|0);dc(gc(a),gc(d));_t(d)}Xt(v[a+16>>2],v[a+8>>2],b);v[a+8>>2]=v[a+8>>2]+2;jb=f+48|0;return}a=P()|0;O()|0;_t(d);S(a|0);L()}function lha(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;d=jb-32|0;jb=d;sd(b,0);uh(d,1,a);c=d+16|0;Ec(c,d);v[113382]=0;Q(336,b+43|0,c|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){e=d+16|0;yb(e);c=a+48|0;v[b>>2]=w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24);c=a+52|0;v[b+4>>2]=w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24);c=a+56|0;v[b+8>>2]=w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24);c=a+62|0;v[b+24>>2]=w[c|0]|w[c+1|0]<<8;Ys(b,+((w[a+60|0]^8)-120|0)*.005208333333333333);t[d+16|0]=w[a+61|0];t[d|0]=64;f=b,g=w[pc(e,d)|0]<<2,u[f+30>>1]=g;u[b+34>>1]=0;a=a+47|0;if(w[a|0]&4){u[b+34>>1]=x[b+34>>1]|1;v[b>>2]=v[b>>2]>>>1}if(w[a|0]&32){u[b+34>>1]=x[b+34>>1]|4}if(t[a|0]<0){u[b+34>>1]=x[b+34>>1]|2}jb=d+32|0;return}a=P()|0;O()|0;yb(d+16|0);S(a|0);L()}function _M(a,b){a=a|0;b=+b;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;g=ps(b);d=jb-16|0;jb=d;e=a;f=a;v[a>>2]=0;v[a+4>>2]=0;v[113382]=0;v[d+12>>2]=0;W(1190,a+8|0,d+12|0,d+8|0)|0;h=v[113382];v[113382]=0;a:{if((h|0)!=1){jb=d+16|0;break a}V(0)|0;O()|0;Ab();L()}v[113382]=0;R(1184,a|0,2048);a=v[113382];v[113382]=0;b:{if((a|0)!=1){v[113382]=0;R(1186,e|0,2048);a=v[113382];v[113382]=0;if((a|0)!=1){break b}}a=P()|0;O()|0;Dy(f);S(a|0);L()}a=0;c:{while(1){c=1;if((a|0)!=1024){v[113382]=0;c=+(a-1024|0);i=+hb(1178,+(K(c*c*-9.5367431640625e-7+1)*b));f=v[113382];v[113382]=0;if((f|0)==1){break c}c=c*.0372006759294457;c=i*gi(c)/(c*g)}j=Vk(e,a),k=c*.011841342921061943,A[j>>3]=k;a=a+1|0;if((a|0)!=2048){continue}break}return}a=P()|0;O()|0;Qf(e);S(a|0);L()}function JK(a,b){var c=C(0),d=C(0),e=C(0);a:{b:{c:{switch(b|0){case 0:To(a,C(1));So(a,C(3.725290298461914e-9));Ro(a,C(268435456));Qo(a,0);break b;case 1:To(a,C(32));So(a,C(4.656612873077393e-10));Ro(a,C(2147483648));Qo(a,0);break b;case 2:To(a,C(2));So(a,C(7.450580596923828e-9));Ro(a,C(134217728));Qo(a,1);break b;default:To(a,C(1));So(a,C(7.450580596923828e-9));Ro(a,C(134217728));Qo(a,1);Nx(a,0);ul(a,1);Mx(a,1);d=C(256);c=C(128);e=C(128);b=0;break a;case 4:case 5:break c}}To(a,C(.75));So(a,C(7.450580596923828e-9));Ro(a,C(134217728));Qo(a,1);Nx(a,0);b=(b|0)==4;ul(a,b?2:3);Mx(a,1);d=C(256);c=b?C(256):C(192);e=c;b=1;break a}Nx(a,1);ul(a,0);Mx(a,0);d=C(128);e=C(100);c=C(256);b=4}z[a+16>>2]=c;z[a+20>>2]=e;z[a+24>>2]=d;v[a+28>>2]=b}function uX(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0;if(y[b+24>>2]>y[b+44>>2]){v[b+44>>2]=v[b+24>>2]}k=-1;l=-1;h=f&24;a:{if(!h|(h|0)==24&(e|0)==1){break a}h=v[b+44>>2];if(h){g=h-Tb(b+32|0)|0;m=g;g=g>>31}b:{c:{switch(e|0){case 1:if(f&8){e=v[b+12>>2]-v[b+8>>2]|0;i=e;j=e>>31;break b}e=v[b+24>>2]-v[b+20>>2]|0;i=e;j=e>>31;break b;case 0:break b;case 2:break c;default:break a}}i=m;j=g}d=d+j|0;c=c+i|0;d=i>>>0>c>>>0?d+1|0:d;e=c;c=d;if((g|0)<=(d|0)&e>>>0>m>>>0|(d|0)>(g|0)|(d|0)<0){break a}d=f&8;d:{if(!(c|e)){break d}if(v[b+12>>2]?0:d){break a}if(!(f&16)){break d}if(!v[b+24>>2]){break a}}if(d){sm(b,v[b+8>>2],e+v[b+8>>2]|0,v[b+44>>2])}if(f&16){Iv(b,v[b+20>>2],v[b+28>>2]);$q(b,e)}k=e;l=c}Qg(a,k,l)}function Bo(a){var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,k=0,m=0;o(+a);d=j(1)|0;f=j(0)|0;a:{b:{c:{b=d;d=b;if(!(b>>>0>=1048576&((b|0)>0|(b|0)>=0))){if(!(b&2147483647|f)){return-1/(a*a)}if((b|0)>0|(b|0)>=0){break c}return(a-a)/0}if(d>>>0>2146435071){break a}b=1072693248;g=-1023;if((d|0)!=1072693248){b=d;break b}if(f){break b}return 0}o(+(a*0x40000000000000));b=j(1)|0;f=j(0)|0;g=-1077}b=b+614242|0;e=+((b>>>20|0)+g|0);l(0,f|0);l(1,(b&1048575)+1072079006|0);a=+n()+-1;c=a/(a+2);h=e*.6931471803691238;i=a;k=e*1.9082149292705877e-10;m=c;e=a*(a*.5);c=c*c;a=c*c;a=h+(i+(k+m*(e+(a*(a*(a*.15313837699209373+.22222198432149784)+.3999999999940942)+c*(a*(a*(a*.14798198605116586+.1818357216161805)+.2857142874366239)+.6666666666666735)))-e))}return a}function F4(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=jb-32|0;jb=d;v[113382]=0;Z(1984,a|0);e=v[113382];v[113382]=0;a:{b:{c:{if((e|0)==1){break c}v[113382]=0;Z(2010,b|0);e=v[113382];v[113382]=0;if((e|0)==1){break c}v[113382]=0;Z(2010,c|0);f=v[113382];v[113382]=0;e=1;if((f|0)==1){break c}f=v[a+24>>2];b=qc(d+24|0,b);c=qc(d+16|0,c);v[113382]=0;g=v[b+4>>2];v[d+8>>2]=v[b>>2];v[d+12>>2]=g;b=v[c+4>>2];v[d>>2]=v[c>>2];v[d+4>>2]=b;X(2054,f|0,d+8|0,d|0,1);b=v[113382];v[113382]=0;if((b|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,1993,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();e=0}jb=d+32|0;return e|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function mfa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=jb-32|0;jb=e;i=v[a+24>>2];j=v[a+20>>2];k=v[a+16>>2];b=v[a+4>>2];f=v[a>>2];v[e+24>>2]=f;v[e+28>>2]=b;g=v[a+12>>2];v[e+16>>2]=v[a+8>>2];v[e+20>>2]=g;if(d){while(1){h=(((b&2147483647)<<1|f>>>31)&-2)+k|0;b=(f>>>21&2040)+33120|0;l=u[b+6>>1];m=u[b+4>>1];n=u[b+2>>1];o=u[b>>1];g=0;b=1;while(1){v[(e+8|0)+(g<<2)>>2]=(((B(t[g+h|0],n)+B(t[(g|-2)+h|0],o)|0)+B(t[(g|2)+h|0],m)|0)+B(t[(g|4)+h|0],l)<<8)/16384;f=b;b=0;g=1;if(f){continue}break}v[c>>2]=v[c>>2]+B(v[e+8>>2],j);v[c+4>>2]=v[c+4>>2]+B(v[e+12>>2],i);Sb(e+24|0,e+16|0);d=d-1|0;if(d){c=c+8|0;f=v[e+24>>2];b=v[e+28>>2];continue}break}f=v[e+24>>2];b=v[e+28>>2]}v[a>>2]=f;v[a+4>>2]=b;jb=e+32|0}function XV(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0;g=jb-96|0;jb=g;Bi(g+48|0,g+40|0,c);v[113382]=0;U(194,g+60|0,g+32|0,d|0);d=v[113382];v[113382]=0;c=1;a:{b:{c:{d:{e:{if((d|0)!=1){v[113382]=0;U(194,g+72|0,g+24|0,e|0);c=v[113382];v[113382]=0;if((c|0)==1){break e}v[113382]=0;U(194,g+84|0,g+16|0,f|0);c=v[113382];v[113382]=0;if((c|0)==1){break d}v[113382]=0;R(195,g+8|0,g+48|0);c=v[113382];v[113382]=0;if((c|0)==1){break b}v[113382]=0;U(72,a|0,b|0,g+8|0);a=v[113382];v[113382]=0;if((a|0)==1){break b}rD(g+48|0);jb=g+96|0;return}d=P()|0;O()|0;break c}d=P()|0;c=2;O()|0;break c}d=P()|0;O()|0;c=3}c=(g+48|0)+B(c,12)|0;while(1){c=yb(c-12|0);if((c|0)!=(g+48|0)){continue}break}break a}d=P()|0;O()|0;rD(g+48|0)}S(d|0);L()}function Lka(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;c=Ni(a);if(c>>>0<b>>>0){d=jb-32|0;jb=d;a:{b:{c=b-c|0;c:{if(c>>>0<=(v[zb(a)>>2]-v[a+4>>2]|0)/48>>>0){e=jb-16|0;jb=e;d:{b=GS(e,a,c);c=v[b+4>>2];g=v[b+8>>2];if((c|0)!=(g|0)){while(1){f=zb(a);v[113382]=0;R(702,f|0,c|0);f=v[113382];v[113382]=0;if((f|0)==1){break d}c=c+48|0;v[b+4>>2]=c;if((c|0)!=(g|0)){continue}break}}Mb(b);jb=e+16|0;break c}a=P()|0;O()|0;Mb(b);S(a|0);L()}b=zb(a);b=ES(d+8|0,FS(a,Ni(a)+c|0),Ni(a),b);v[113382]=0;R(659,b|0,c|0);c=v[113382];v[113382]=0;if((c|0)==1){break b}v[113382]=0;R(521,a|0,b|0);a=v[113382];v[113382]=0;if((a|0)==1){break b}Pt(b)}jb=d+32|0;break a}a=P()|0;O()|0;Pt(b);S(a|0);L()}return}if(b>>>0<c>>>0){b=v[a>>2]+B(b,48)|0;Ni(a);HS(a,b);SS(a)}}function Lga(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;c=xc(a);if(c>>>0<b>>>0){d=jb-32|0;jb=d;a:{b:{c=b-c|0;c:{if(c>>>0<=(v[zb(a)>>2]-v[a+4>>2]|0)/12>>>0){e=jb-16|0;jb=e;d:{b=dl(e,a,c);c=v[b+4>>2];g=v[b+8>>2];if((c|0)!=(g|0)){while(1){f=zb(a);v[113382]=0;R(988,f|0,c|0);f=v[113382];v[113382]=0;if((f|0)==1){break d}c=c+12|0;v[b+4>>2]=c;if((c|0)!=(g|0)){continue}break}}Mb(b);jb=e+16|0;break c}a=P()|0;O()|0;Mb(b);S(a|0);L()}b=zb(a);b=Wj(d+8|0,wm(a,xc(a)+c|0),xc(a),b);v[113382]=0;R(983,b|0,c|0);c=v[113382];v[113382]=0;if((c|0)==1){break b}v[113382]=0;R(984,a|0,b|0);a=v[113382];v[113382]=0;if((a|0)==1){break b}AO(b)}jb=d+32|0;break a}a=P()|0;O()|0;AO(b);S(a|0);L()}return}if(b>>>0<c>>>0){b=v[a>>2]+B(b,12)|0;xc(a);BO(a,b);dt(a)}}function sS(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;e=jb-32|0;jb=e;v[e+24>>2]=b;k=e,l=Bd(a),v[k+8>>2]=l;g=dm(e+24|0,e+8|0);b=Pi(c,d);a:{b:{if(!b){break b}if(iA(c,Tb(a),Tb(a)+Db(a)|0)){b=oi(e+8|0,c,d);c=v[e+24>>2];d=Tb(b);g=Tb(b);h=Db(b);v[113382]=0;c=aa(572,a|0,c|0,d|0,g+h|0)|0;a=v[113382];v[113382]=0;if((a|0)!=1){yb(b);break a}a=P()|0;O()|0;yb(b);S(a|0);L()}h=Db(a);f=Fc(a);c:{if(b>>>0<=f-h>>>0){f=Tb(a);i=h-g|0;if(!i){break c}j=g+f|0;am(b+j|0,j,i);break c}Rl(a,f,(b+h|0)-f|0,h,g,0,b);f=v[a>>2]}b=b+h|0;Vg(a,b);t[e+8|0]=0;Rd(b+f|0,e+8|0);if((c|0)==(d|0)){break b}b=g+f|0;while(1){Rd(b,c);b=b+1|0;c=c+1|0;if((d|0)!=(c|0)){continue}break}}k=e,l=Bd(a),v[k+8>>2]=l;c=ff(e+8|0,g)}jb=e+32|0;return c|0}function _G(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;f=jb-16|0;jb=f;a:{b:{c:{d:{if((b|0)>=0){if((Go(a+8|0)|0)>(b|0)){break d}}b=ba(8)|0;v[113382]=0;c=Q(121,f|0,6794)|0;a=v[113382];v[113382]=0;if((a|0)==1){break c}nc(b,c);v[113382]=0;U(1978,b|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break a}a=P()|0;O()|0;yb(c);break b}d=a+32|0;a=(v[d>>2]+(b<<5)|0)+480280|0;c=c?134218752:0;v[a>>2]=c|v[a>>2]&-134218753;a=(v[d>>2]+B(b,896)|0)+1075072|0;v[a>>2]=c|v[a>>2]&-134218753;a=x[v[d>>2]+480188>>1];if(a>>>0<=255){b=b+1|0;while(1){e=B(a,896);if((b|0)==x[(e+v[d>>2]|0)+1075792>>1]){e=(e+v[d>>2]|0)+1075072|0;v[e>>2]=c|v[e>>2]&-134218753}a=a+1|0;if((a&65535)!=256){continue}break}}jb=f+16|0;return}a=P()|0;O()|0;ca(b|0)}S(a|0)}L()}function RW(){var a=0,b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;b=jb-48|0;jb=b;if(va(0,b+32|0)|0){wr(v[113305],8668);L()}d=Tq(b+16|0,b+32|0);v[b+4>>2]=v[b+36>>2]/1e3;g=Tq(b+8|0,b+4|0);e=jb-32|0;jb=e;c=jb-16|0;jb=c;h=jb-16|0;jb=h;a=jb-16|0;jb=a;i=a,j=qma(v[d>>2],v[d+4>>2],1e6,0),v[i>>2]=j;v[a+4>>2]=mb;d=pk(a+8|0,a);f=v[d+4>>2];d=v[d>>2];jb=a+16|0;jb=h+16|0;v[c+8>>2]=d;v[c+12>>2]=f;a=v[c+12>>2];v[e+8>>2]=v[c+8>>2];v[e+12>>2]=a;jb=c+16|0;f=v[e+8>>2];d=v[e+12>>2];a=v[g+4>>2];v[e>>2]=v[g>>2];v[e+4>>2]=a;a=e;d=v[a+4>>2]+d|0;c=v[a>>2];f=f+c|0;v[a+16>>2]=f;v[a+20>>2]=c>>>0>f>>>0?d+1|0:d;a=pk(a+24|0,a+16|0);c=v[a+4>>2];a=v[a>>2];jb=e+32|0;v[b+24>>2]=a;v[b+28>>2]=c;a=pk(b+40|0,b+24|0);c=v[a+4>>2];a=v[a>>2];jb=b+48|0;mb=c;return a|0}function Nba(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=C(0),h=C(0),i=0,j=C(0),k=0,m=0;f=jb-16|0;jb=f;k=f,m=B(v[a>>2],te(a)),v[k+8>>2]=m;tc(f+8|0,c>>>2|0);c=Eb(b);g=z[e+4>>2];e=v[f+8>>2];if(e){while(1){g=C(G(C(D((l(2,w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24)),q()))),g));c=c+4|0;e=e-1|0;if(e){continue}break}}c=g==C(0);a:{if(c){break a}e=v[f+8>>2];if(!e){break a}j=c?C(1):C(C(1)/g);c=v[a+20>>2];while(1){z[f+12>>2]=j*(l(2,w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24)),q());Wd(f+12|0,C(-1));h=C(z[f+12>>2]*C(32768));z[f+12>>2]=h;a=c;h=de(h);b:{if(C(D(h))<C(2147483648)){i=~~h;break b}i=-2147483648}k=a,m=Rc(i),u[k>>1]=m;b=b+4|0;c=c+2|0;e=e-1|0;if(e){continue}break}}if(d){z[d>>2]=g}jb=f+16|0;return v[f+8>>2]<<2}function I8(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;c=Kb(a);if(c>>>0<b>>>0){d=jb-32|0;jb=d;a:{b:{c=b-c|0;c:{if(c>>>0<=v[zb(a)>>2]-v[a+4>>2]>>2>>>0){e=jb-16|0;jb=e;d:{b=oe(e,a,c);c=v[b+4>>2];g=v[b+8>>2];if((c|0)!=(g|0)){while(1){f=zb(a);v[113382]=0;R(1622,f|0,c|0);f=v[113382];v[113382]=0;if((f|0)==1){break d}c=c+4|0;v[b+4>>2]=c;if((c|0)!=(g|0)){continue}break}}Mb(b);jb=e+16|0;break c}a=P()|0;O()|0;Mb(b);S(a|0);L()}b=zb(a);b=Nf(d+8|0,ye(a,Kb(a)+c|0),Kb(a),b);v[113382]=0;R(1619,b|0,c|0);c=v[113382];v[113382]=0;if((c|0)==1){break b}v[113382]=0;R(1616,a|0,b|0);a=v[113382];v[113382]=0;if((a|0)==1){break b}es(b)}jb=d+32|0;break a}a=P()|0;O()|0;es(b);S(a|0);L()}return}if(b>>>0<c>>>0){b=v[a>>2]+(b<<2)|0;Kb(a);rJ(a,b);ng(a)}}function ika(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=jb-32|0;jb=d;v[d+28>>2]=0;Fi(a,d+28|0);a:{b:{e=v[d+28>>2];c:{if(e>>>0>500){break c}d:{e:{f:{if(e){while(1){e=Xb(d+16|0);v[113382]=0;u[d+14>>1]=0;f=W(685,a|0,e|0,255)|0;g=v[113382];v[113382]=0;if((g|0)==1){break b}if(!f){break d}v[113382]=0;Q(676,a|0,d+14|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break b}v[113382]=0;U(13,d|0,c|0,e|0);f=v[113382];v[113382]=0;if((f|0)==1){break f}v[113382]=0;f=Q(686,b|0,d+14|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break e}Gb(f,d);yb(d);yb(e);h=h+1|0;if(h>>>0<y[d+28>>2]){continue}break}}Jf(v[v[a>>2]-12>>2]+a|0);break c}a=P()|0;O()|0;break a}a=P()|0;O()|0;yb(d);break a}yb(e)}jb=d+32|0;return}a=P()|0;O()|0}yb(e);S(a|0);L()}function hka(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=jb-32|0;jb=d;u[d+30>>1]=0;wf(a,d+30|0);a:{b:{e=x[d+30>>1];c:{if(e>>>0>500){break c}d:{e:{f:{if(e){while(1){e=Xb(d+16|0);v[113382]=0;u[d+14>>1]=0;f=W(687,a|0,e|0,255)|0;g=v[113382];v[113382]=0;if((g|0)==1){break b}if(!f){break d}v[113382]=0;Q(676,a|0,d+14|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break b}v[113382]=0;U(13,d|0,c|0,e|0);f=v[113382];v[113382]=0;if((f|0)==1){break f}v[113382]=0;f=Q(686,b|0,d+14|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break e}Gb(f,d);yb(d);yb(e);h=h+1|0;if(h>>>0<x[d+30>>1]){continue}break}}Jf(v[v[a>>2]-12>>2]+a|0);break c}a=P()|0;O()|0;break a}a=P()|0;O()|0;yb(d);break a}yb(e)}jb=d+32|0;return}a=P()|0;O()|0}yb(e);S(a|0);L()}function Paa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;d=jb-32|0;jb=d;a:{b:{c:{d:{e:{if(nj(b)){break e}u[d+8>>1]=x[a+480190>>1];u[d+24>>1]=v[b+4>>2]-1;c=x[Af(d+8|0,d+24|0)>>1];if(!c){break e}g=c;while(1){e=d+8|0;_d(e,b,c);if(!Cb(e)){v[113382]=0;f=Q(1393,a|0,c&65535)|0;e=v[113382];v[113382]=0;if((e|0)==1){break b}if(f){v[113382]=0;f=Q(121,d+8|0,17540)|0;e=v[113382];v[113382]=0;if((e|0)==1){break d}v[113382]=0;Q(335,((c<<5)+a|0)+946304|0,f|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break c}yb(f);h=h+1|0}if(!(x[a+480190>>1]!=(c|0)|c>>>0<2)){u[a+480190>>1]=x[a+480190>>1]-1}}c=c-1|0;g=g-1|0;if(g&65535){continue}break}}jb=d+32|0;return h&65535}c=P()|0;O()|0;break a}c=P()|0;O()|0;yb(f);break a}c=P()|0;O()|0}S(c|0);L()}function sK(a,b,c,d,e,f,g){var h=0,i=0,j=0;h=jb-16|0;jb=h;t[h+15|0]=b;t[h+14|0]=10;Fg(g,w[pc(h+15|0,h+14|0)|0]);t[g+15|0]=c;t[g+16|0]=c;t[g+14|0]=e;t[g+13|0]=d;if(Kb(g)){c=0;while(1){b=B(c,3)+f|0;d=w[b|0]|w[b+1|0]<<8;i=Pb(g,c),j=d>>>4|0,u[i>>1]=j;a:{b:{if(!c){e=0;d=0;break b}d=c-1|0;if(x[Pb(g,c)>>1]>=x[Pb(g,d)>>1]){break a}e=c;d=x[Pb(g,d)>>1]+1|0}i=Pb(g,e),j=d,u[i>>1]=j}b=Ed(w[b+2|0],0,64);i=Pb(g,c),j=b,t[i+2|0]=j;c=c+1|0;if(Kb(g)>>>0>c>>>0){continue}break}}b=w[g+12|0]&-2|a&1;t[g+12|0]=b;c=g;if(a&2){b=w[g+15|0];d=Kb(g);b=w[g+12|0]&-5|(b>>>0<=d>>>0)<<2}else{b=b&251}t[c+12|0]=b;c=g;c:{d:{if(a&4){a=w[g+13|0];if(a>>>0<=w[g+14|0]){break d}}a=b&253;break c}b=Kb(g);a=w[g+12|0]&-3|(a>>>0<=b>>>0)<<1}t[c+12|0]=a;jb=h+16|0}function _i(a,b,c){var d=0,e=0;a:{if((a|0)==(b|0)){break a}e=a+c|0;if(b-e>>>0<=0-(c<<1)>>>0){lc(a,b,c);return}d=(a^b)&3;b:{c:{if(a>>>0<b>>>0){if(d){break b}if(!(a&3)){break c}while(1){if(!c){break a}t[a|0]=w[b|0];b=b+1|0;c=c-1|0;a=a+1|0;if(a&3){continue}break}break c}d:{if(d){break d}if(e&3){while(1){if(!c){break a}c=c-1|0;d=c+a|0;t[d|0]=w[b+c|0];if(d&3){continue}break}}if(c>>>0<=3){break d}while(1){c=c-4|0;v[c+a>>2]=v[b+c>>2];if(c>>>0>3){continue}break}}if(!c){break a}while(1){c=c-1|0;t[c+a|0]=w[b+c|0];if(c){continue}break}break a}if(c>>>0<=3){break b}while(1){v[a>>2]=v[b>>2];b=b+4|0;a=a+4|0;c=c-4|0;if(c>>>0>3){continue}break}}if(!c){break a}while(1){t[a|0]=w[b|0];a=a+1|0;b=b+1|0;c=c-1|0;if(c){continue}break}}}function YF(a,b,c,d,e,f){var g=0;g=jb-80|0;jb=g;a:{if((f|0)>=16384){pd(g+32|0,b,c,d,e,0,0,0,2147352576);d=v[g+40>>2];e=v[g+44>>2];b=v[g+32>>2];c=v[g+36>>2];if(f>>>0<32767){f=f-16383|0;break a}pd(g+16|0,b,c,d,e,0,0,0,2147352576);f=(f>>>0<49149?f:49149)-32766|0;d=v[g+24>>2];e=v[g+28>>2];b=v[g+16>>2];c=v[g+20>>2];break a}if((f|0)>-16383){break a}pd(g- -64|0,b,c,d,e,0,0,0,65536);d=v[g+72>>2];e=v[g+76>>2];b=v[g+64>>2];c=v[g+68>>2];if(f>>>0>4294934531){f=f+16382|0;break a}pd(g+48|0,b,c,d,e,0,0,0,65536);f=(f>>>0>4294918150?f:-49146)+32764|0;d=v[g+56>>2];e=v[g+60>>2];b=v[g+48>>2];c=v[g+52>>2]}pd(g,b,c,d,e,0,0,0,f+16383<<16);b=v[g+12>>2];v[a+8>>2]=v[g+8>>2];v[a+12>>2]=b;b=v[g+4>>2];v[a>>2]=v[g>>2];v[a+4>>2]=b;jb=g+80|0}function Sw(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;c=jb-80|0;jb=c;d=v[a>>2];f=v[d+4>>2];v[c+40>>2]=v[d+20>>2];g=v[d+16>>2];v[c+32>>2]=v[d+12>>2];v[c+36>>2]=g;Km(c- -64|0,c+32|0,f);d=ie(c+48|0,v[v[a+4>>2]>>2],v[v[a+8>>2]>>2],v[v[a+12>>2]>>2]);f=v[v[a+12>>2]>>2];g=v[v[a+8>>2]>>2];v[c+24>>2]=v[c+72>>2];a=v[c+68>>2];v[c+16>>2]=v[c+64>>2];v[c+20>>2]=a;v[c+8>>2]=v[d+8>>2];a=v[d+4>>2];v[c>>2]=v[d>>2];v[c+4>>2]=a;i=c+16|0;a=c;if(f){j=b+4|0;while(1){d=0;if(g){while(1){e=v[Sf(a,d,h)>>2];ec(b,d);e=(e+((Lr(j)^-2147483648)>>>21|0)|0)-2147482624>>>12|0;e=e>>>0>491520?e:491520;k=Jm(i,d,h),l=e>>>0<557055?e:557055,u[k>>1]=l;d=d+1|0;if((g|0)!=(d|0)){continue}break}}h=h+1|0;if((f|0)!=(h|0)){continue}break}}jb=c+80|0}function Tw(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=C(0);c=jb-80|0;jb=c;d=v[a>>2];f=v[d+4>>2];e=v[d+24>>2];v[c+40>>2]=v[d+20>>2];v[c+44>>2]=e;e=v[d+16>>2];v[c+32>>2]=v[d+12>>2];v[c+36>>2]=e;Fh(c- -64|0,c+32|0,f);d=ie(c+48|0,v[v[a+4>>2]>>2],v[v[a+8>>2]>>2],v[v[a+12>>2]>>2]);f=v[v[a+12>>2]>>2];e=v[v[a+8>>2]>>2];a=v[c+76>>2];v[c+24>>2]=v[c+72>>2];v[c+28>>2]=a;a=v[c+68>>2];v[c+16>>2]=v[c+64>>2];v[c+20>>2]=a;v[c+8>>2]=v[d+8>>2];a=v[d+4>>2];v[c>>2]=v[d>>2];v[c+4>>2]=a;h=c+16|0;a=c;if(f){while(1){d=0;if(e){while(1){i=A[fh(a,d,g)>>3];ec(b,d);j=sj(Md(i*134217728));k=nn(h,d,g),l=C(+(j|0)*7.450580596923828e-9),z[k>>2]=l;d=d+1|0;if((e|0)!=(d|0)){continue}break}}g=g+1|0;if((f|0)!=(g|0)){continue}break}}jb=c+80|0}function pv(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;c=wc(a);if(c>>>0<b>>>0){d=jb-32|0;jb=d;a:{b:{c=b-c|0;c:{if(c>>>0<=v[zb(a)>>2]-v[a+4>>2]>>>0){e=jb-16|0;jb=e;d:{b=Li(e,a,c);c=v[b+4>>2];g=v[b+8>>2];if((c|0)!=(g|0)){while(1){f=zb(a);v[113382]=0;R(188,f|0,c|0);f=v[113382];v[113382]=0;if((f|0)==1){break d}c=c+1|0;v[b+4>>2]=c;if((c|0)!=(g|0)){continue}break}}Mb(b);jb=e+16|0;break c}a=P()|0;O()|0;Mb(b);S(a|0);L()}b=zb(a);b=ph(d+8|0,Ki(a,wc(a)+c|0),wc(a),b);v[113382]=0;R(183,b|0,c|0);c=v[113382];v[113382]=0;if((c|0)==1){break b}v[113382]=0;R(179,a|0,b|0);a=v[113382];v[113382]=0;if((a|0)==1){break b}vm(b)}jb=d+32|0;break a}a=P()|0;O()|0;vm(b);S(a|0);L()}return}if(b>>>0<c>>>0){b=v[a>>2]+b|0;wc(a);tD(a,b);wp(a)}}function Fba(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=C(0),g=0,h=0,i=C(0),j=0,k=0;e=jb-16|0;jb=e;v[e+12>>2]=c>>>3;v[e+8>>2]=v[a>>2];c=v[Lb(e+12|0,e+8|0)>>2];i=z[d>>2];b=Eb(b);if(c){a=v[a+20>>2];d=c;while(1){z[e+12>>2]=i*(l(2,w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24)),q());Wd(e+12|0,C(-1));f=C(z[e+12>>2]*C(32768));z[e+12>>2]=f;h=a;f=de(f);a:{if(C(D(f))<C(2147483648)){g=~~f;break a}g=-2147483648}j=h,k=Rc(g),u[j>>1]=k;z[e+12>>2]=i*(l(2,w[b+4|0]|w[b+5|0]<<8|(w[b+6|0]<<16|w[b+7|0]<<24)),q());Wd(e+12|0,C(-1));f=C(z[e+12>>2]*C(32768));z[e+12>>2]=f;h=a;f=de(f);b:{if(C(D(f))<C(2147483648)){g=~~f;break b}g=-2147483648}j=h,k=Rc(g),u[j+2>>1]=k;a=a+4|0;b=b+8|0;d=d-1|0;if(d){continue}break}}jb=e+16|0;return c<<3}function Qb(a,b,c){var d=0,e=0,f=0;a:{if(!c){break a}f=a+c|0;t[f-1|0]=b;t[a|0]=b;if(c>>>0<3){break a}t[f-2|0]=b;t[a+1|0]=b;t[f-3|0]=b;t[a+2|0]=b;if(c>>>0<7){break a}t[f-4|0]=b;t[a+3|0]=b;if(c>>>0<9){break a}f=0-a&3;e=f+a|0;d=B(b&255,16843009);v[e>>2]=d;b=c-f&-4;c=b+e|0;v[c-4>>2]=d;if(b>>>0<9){break a}v[e+8>>2]=d;v[e+4>>2]=d;v[c-8>>2]=d;v[c-12>>2]=d;if(b>>>0<25){break a}v[e+24>>2]=d;v[e+20>>2]=d;v[e+16>>2]=d;v[e+12>>2]=d;v[c-16>>2]=d;v[c-20>>2]=d;v[c-24>>2]=d;v[c-28>>2]=d;c=b;b=e&4|24;c=c-b|0;if(c>>>0<32){break a}d=qma(d,0,1,1);f=mb;b=b+e|0;while(1){v[b+24>>2]=d;e=f;v[b+28>>2]=e;v[b+16>>2]=d;v[b+20>>2]=e;v[b+8>>2]=d;v[b+12>>2]=e;v[b>>2]=d;v[b+4>>2]=e;b=b+32|0;c=c-32|0;if(c>>>0>31){continue}break}}return a}function U0(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;d=jb-32|0;jb=d;e=v[a+28>>2];v[d+16>>2]=e;f=v[a+20>>2];v[d+28>>2]=c;v[d+24>>2]=b;b=f-e|0;v[d+20>>2]=b;e=b+c|0;j=2;a:{b:{b=d+16|0;c:{if(!zr(ya(v[a+60>>2],b|0,2,d+12|0)|0)){while(1){f=v[d+12>>2];if((f|0)==(e|0)){break c}if((f|0)<0){break b}g=v[b+4>>2];h=g>>>0<f>>>0;i=(h<<3)+b|0;g=f-(h?g:0)|0;v[i>>2]=g+v[i>>2];i=(h?12:4)+b|0;v[i>>2]=v[i>>2]-g;e=e-f|0;b=h?b+8|0:b;j=j-h|0;if(!zr(ya(v[a+60>>2],b|0,j|0,d+12|0)|0)){continue}break}}if((e|0)!=-1){break b}}b=v[a+44>>2];v[a+28>>2]=b;v[a+20>>2]=b;v[a+16>>2]=b+v[a+48>>2];a=c;break a}v[a+28>>2]=0;v[a+16>>2]=0;v[a+20>>2]=0;v[a>>2]=v[a>>2]|32;a=0;if((j|0)==2){break a}a=c-v[b+4>>2]|0}jb=d+32|0;return a|0}function N4(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=jb-32|0;jb=d;v[113382]=0;Z(1984,a|0);c=v[113382];v[113382]=0;a:{b:{c:{d:{e:{f:{if((c|0)==1){break f}v[113382]=0;Z(2010,b|0);c=v[113382];v[113382]=0;if((c|0)==1){break f}e=v[a+24>>2];v[113382]=0;c=Q(121,d|0,b|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break e}v[113382]=0;X(2045,d+16|0,e|0,c|0,1);b=v[113382];v[113382]=0;if((b|0)==1){break d}a=d+16|0;b=Ud(Tb(a));yb(a);yb(c);break b}b=V(0)|0;O()|0;break c}b=V(0)|0;O()|0;break c}b=V(0)|0;O()|0;yb(c)}_(b|0)|0;b=0;v[113382]=0;X(1958,2786,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$()}jb=d+32|0;return b|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function u5(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=jb-32|0;jb=d;v[113382]=0;Z(1984,a|0);c=v[113382];v[113382]=0;a:{b:{c:{d:{e:{f:{if((c|0)==1){break f}v[113382]=0;Z(2010,b|0);c=v[113382];v[113382]=0;if((c|0)==1){break f}e=v[a+24>>2];v[113382]=0;c=Q(121,d|0,b|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break e}v[113382]=0;U(2011,d+16|0,e|0,c|0);b=v[113382];v[113382]=0;if((b|0)==1){break d}a=d+16|0;b=Ud(Tb(a));yb(a);yb(c);break b}b=V(0)|0;O()|0;break c}b=V(0)|0;O()|0;break c}b=V(0)|0;O()|0;yb(c)}_(b|0)|0;b=0;v[113382]=0;X(1958,9312,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$()}jb=d+32|0;return b|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function Oj(a,b,c){var d=0,e=0,f=0;e=jb-16|0;jb=e;v[a+4>>2]=0;a:{b:{d=4;c:{if(!w[cj(e+8|0,a,1)|0]){break c}d=v[v[a>>2]-12>>2];v[113382]=0;d=v[(a+d|0)+24>>2];f=v[113382];v[113382]=0;d:{if((f|0)==1){break d}v[113382]=0;b=W(2716,d|0,b|0,c|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break d}v[a+4>>2]=b;d=(b|0)==(c|0)?0:6;break c}b=V(0)|0;O()|0;_(b|0)|0;bj(v[v[a>>2]-12>>2]+a|0,1);b=v[v[a>>2]-12>>2];v[113382]=0;b=v[(a+b|0)+20>>2];c=v[113382];v[113382]=0;e:{if((c|0)!=1){if(!(b&1)){break e}v[113382]=0;Y(81);a=v[113382];v[113382]=0;if((a|0)!=1){break a}}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)==1){break b}S(a|0);L()}$();d=1}Eg(v[v[a>>2]-12>>2]+a|0,d);jb=e+16|0;return}V(0)|0;O()|0;Ab()}L()}function E3(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;f=jb-16|0;jb=f;c=v[a+4>>2];d=f;a=v[a>>2];v[d>>2]=a;v[d+4>>2]=c;v[d+8>>2]=a;v[d+12>>2]=c;a=jb+-64|0;jb=a;a:{if(!v[d+4>>2]){break a}c=73440;b:{while(1){b=v[d+4>>2];v[a+56>>2]=v[d>>2];v[a+60>>2]=b;b=qc(a+48|0,v[c+8>>2]);e=v[a+60>>2];v[a+24>>2]=v[a+56>>2];v[a+28>>2]=e;e=v[b+4>>2];v[a+16>>2]=v[b>>2];v[a+20>>2]=e;if(IK(a+24|0,a+16|0)){break b}c=c+12|0;if((c|0)!=73956){continue}break}c=73968;while(1){b=v[d+4>>2];v[a+40>>2]=v[d>>2];v[a+44>>2]=b;b=qc(a+32|0,v[c+8>>2]);e=v[a+44>>2];v[a+8>>2]=v[a+40>>2];v[a+12>>2]=e;e=v[b+4>>2];v[a>>2]=v[b>>2];v[a+4>>2]=e;b=IK(a+8|0,a);if(b){break a}c=c+12|0;if((c|0)!=74016){continue}break}break a}b=1}jb=a- -64|0;jb=f+16|0;return b|0}function an(a,b,c){var d=0,e=0,f=0,g=0,h=0;a:{if(c){t[b+829|0]=c;break a}c=w[b+829|0]}d=v[a+480180>>2]&202376205?(c&240?-16:15)&c:c;c=v[b+688>>2];b:{if(v[a+480180>>2]&69206029){break b}e=d&240;f=d&15;if((f|0)==15){if(e){ep(a,b,(d&240)>>>4|0,0);return}if(!(t[b+872|0]&1)){break b}c=w[a+480208|0]&2?c:c-60|0;break b}if((e|0)!=240){break b}if(f){dp(a,b,f,0);return}if(!(t[b+872|0]&1)){break b}c=w[a+480208|0]&2?c:c+60|0}c:{if(!(!(t[b+872|0]&1)|w[a+480208|0]&2)&(v[a+1074416>>2]!=1|v[a+480180>>2]!=524288)){break c}e=d&255;d=d&15;d:{if(d){if(e&240?v[a+480180>>2]&16777248:0){break d}c=c-(d<<2)|0;break d}c=(e>>>2&60)+c|0}if(v[a+480180>>2]!=1){break c}v[b+88>>2]=v[b+88>>2]|2097152}g=b,h=Yb(c,0,256),v[g+688>>2]=h}function OM(a,b,c){var d=0,e=0,f=0,g=0;e=jb-16|0;jb=e;v[e+12>>2]=c;if(x[a+28>>1]!=(b|0)){Os(a+12|0);u[a+28>>1]=b}c=a+12|0;if(id(c)){QM(c,By(a,x[rc(jp(a),b)>>1]))}f=e+12|0;a:{if(v[c+4>>2]!=v[zb(c)>>2]){b=jb-16|0;jb=b;a=oe(b,c,1);c=zb(c);d=v[a+4>>2];v[113382]=0;U(372,c|0,d|0,f|0);c=v[113382];v[113382]=0;if((c|0)!=1){v[a+4>>2]=v[a+4>>2]+4;Mb(a);jb=b+16|0;break a}b=P()|0;O()|0;Mb(a);S(b|0);L()}d=jb-32|0;jb=d;a=c;g=zb(a);b=Nf(d+8|0,ye(a,Kb(a)+1|0),Kb(a),g);c=v[b+8>>2];v[113382]=0;U(372,g|0,c|0,f|0);c=v[113382];v[113382]=0;b:{c:{if((c|0)==1){break c}v[b+8>>2]=v[b+8>>2]+4;v[113382]=0;R(96,a|0,b|0);a=v[113382];v[113382]=0;if((a|0)==1){break c}nk(b);jb=d+32|0;break b}a=P()|0;O()|0;nk(b);S(a|0);L()}}jb=e+16|0}function Iea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;g=jb-16|0;jb=g;i=v[a+24>>2];j=v[a+20>>2];k=v[a+16>>2];h=v[a+4>>2];e=h;f=v[a>>2];v[g+8>>2]=f;v[g+12>>2]=e;h=v[a+12>>2];v[g>>2]=v[a+8>>2];v[g+4>>2]=h;if(d){while(1){e=(e<<1)+k|0;f=(((f>>>16|0)+4&131064)<<1)+b|0;e=(((((B(u[e+4>>1],u[f+34>>1])+B(u[e+2>>1],u[f+32>>1])|0)+B(u[e+6>>1],u[f+36>>1])|0)+B(u[e+8>>1],u[f+38>>1])|0)/2|0)+((((B(u[e-4>>1],u[f+26>>1])+B(u[e-6>>1],u[f+24>>1])|0)+B(u[e-2>>1],u[f+28>>1])|0)+B(u[e>>1],u[f+30>>1])|0)/2|0)|0)/16384|0;v[c>>2]=v[c>>2]+B(e,j);v[c+4>>2]=v[c+4>>2]+B(e,i);Sb(g+8|0,g);d=d-1|0;if(d){c=c+8|0;f=v[g+8>>2];e=v[g+12>>2];continue}break}f=v[g+8>>2];e=v[g+12>>2]}v[a>>2]=f;v[a+4>>2]=e;jb=g+16|0}function Uba(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=jb-16|0;jb=g;v[g+8>>2]=c>>>3;v[g+4>>2]=v[a>>2];d=v[Lb(g+8|0,g+4|0)>>2];b=Eb(b);if(d){a=v[a+20>>2];c=d;while(1){k=0;e=b;h=w[e+4|0]|w[e+5|0]<<8|(w[e+6|0]<<16|w[e+7|0]<<24);i=w[e|0]|w[e+1|0]<<8|(w[e+2|0]<<16|w[e+3|0]<<24);f=h<<24|i>>>8;e=0;l=f&65280;f=e;e=h<<8|i>>>24;f=f|k;k=e&255|l|(i<<24|i<<8&16711680);e=g;v[e+8>>2]=((h&255)<<24|i>>>8)&-16777216|((h&16777215)<<8|i>>>24)&16711680|(h>>>8&65280|h>>>24)|f;v[e+12>>2]=k;Vf(e+8|0,-1,1);j=A[e+8>>3]*32768;A[e+8>>3]=j;e=a;j=Md(j);a:{if(D(j)<2147483648){f=~~j;break a}f=-2147483648}m=e,n=Rc(f),u[m>>1]=n;a=a+2|0;b=b+8|0;c=c-1|0;if(c){continue}break}}jb=g+16|0;return d<<3}function Fg(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;c=Kb(a);if(c>>>0<b>>>0){d=jb-32|0;jb=d;a:{b:{c=b-c|0;c:{if(c>>>0<=v[zb(a)>>2]-v[a+4>>2]>>2>>>0){e=jb-16|0;jb=e;d:{b=oe(e,a,c);c=v[b+4>>2];g=v[b+8>>2];if((c|0)!=(g|0)){while(1){f=zb(a);v[113382]=0;R(337,f|0,c|0);f=v[113382];v[113382]=0;if((f|0)==1){break d}c=c+4|0;v[b+4>>2]=c;if((c|0)!=(g|0)){continue}break}}Mb(b);jb=e+16|0;break c}a=P()|0;O()|0;Mb(b);S(a|0);L()}b=zb(a);b=Qn(d+8|0,ye(a,Kb(a)+c|0),Kb(a),b);v[113382]=0;R(333,b|0,c|0);c=v[113382];v[113382]=0;if((c|0)==1){break b}v[113382]=0;R(334,a|0,b|0);a=v[113382];v[113382]=0;if((a|0)==1){break b}Th(b)}jb=d+32|0;break a}a=P()|0;O()|0;Th(b);S(a|0);L()}return}if(b>>>0<c>>>0){Ku(a,v[a>>2]+(b<<2)|0)}}function QW(){var a=0,b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;d=jb-48|0;jb=d;if(va(1,d+32|0)|0){wr(v[113305],8705);L()}a=d+32|0;b=Tq(d+16|0,a);g=Tq(d+8|0,a|4);e=jb-32|0;jb=e;c=jb-16|0;jb=c;h=jb-16|0;jb=h;a=jb-16|0;jb=a;i=a,j=qma(v[b>>2],v[b+4>>2],1e9,0),v[i>>2]=j;v[a+4>>2]=mb;b=pk(a+8|0,a);f=v[b+4>>2];b=v[b>>2];jb=a+16|0;jb=h+16|0;v[c+8>>2]=b;v[c+12>>2]=f;a=v[c+12>>2];b=e+8|0;v[b>>2]=v[c+8>>2];v[b+4>>2]=a;jb=c+16|0;f=v[b>>2];b=v[b+4>>2];a=v[g+4>>2];v[e>>2]=v[g>>2];v[e+4>>2]=a;a=e;b=v[a+4>>2]+b|0;c=v[a>>2];f=f+c|0;v[a+16>>2]=f;v[a+20>>2]=c>>>0>f>>>0?b+1|0:b;a=pk(a+24|0,a+16|0);c=v[a+4>>2];a=v[a>>2];jb=e+32|0;v[d+24>>2]=a;v[d+28>>2]=c;a=pk(d+40|0,d+24|0);c=v[a+4>>2];a=v[a>>2];jb=d+48|0;mb=c;return a|0}function sG(a,b,c,d){a:{if(b>>>0>20){break a}b:{switch(b-9|0){case 0:b=v[c>>2];v[c>>2]=b+4;v[a>>2]=v[b>>2];return;case 1:b=v[c>>2];v[c>>2]=b+4;b=v[b>>2];v[a>>2]=b;v[a+4>>2]=b>>31;return;case 2:b=v[c>>2];v[c>>2]=b+4;v[a>>2]=v[b>>2];v[a+4>>2]=0;return;case 3:b=v[c>>2]+7&-8;v[c>>2]=b+8;c=v[b+4>>2];v[a>>2]=v[b>>2];v[a+4>>2]=c;return;case 4:b=v[c>>2];v[c>>2]=b+4;b=u[b>>1];v[a>>2]=b;v[a+4>>2]=b>>31;return;case 5:b=v[c>>2];v[c>>2]=b+4;v[a>>2]=x[b>>1];v[a+4>>2]=0;return;case 6:b=v[c>>2];v[c>>2]=b+4;b=t[b|0];v[a>>2]=b;v[a+4>>2]=b>>31;return;case 7:b=v[c>>2];v[c>>2]=b+4;v[a>>2]=w[b|0];v[a+4>>2]=0;return;case 8:b=v[c>>2]+7&-8;v[c>>2]=b+8;A[a>>3]=A[b>>3];return;case 9:break b;default:break a}}nb[d|0](a,c)}}function yz(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0;g=jb-16|0;jb=g;if(t[a|0]&1){t[b+12|0]=w[b+12|0]|1}if(w[a|0]&2){t[b+12|0]=w[b+12|0]|4}if(w[a|0]&4){t[b+12|0]=w[b+12|0]|2}if(w[a|0]&16){t[b+12|0]=w[b+12|0]|16}if(w[a|0]&32){t[b+12|0]=w[b+12|0]|8}t[g+15|0]=w[a+1|0];t[g+14|0]=25;Fg(b,w[pc(g+15|0,g+14|0)|0]);t[b+15|0]=w[a+2|0];t[b+16|0]=w[a+3|0];t[b+13|0]=w[a+4|0];t[b+14|0]=w[a+5|0];if(Kb(b)){while(1){f=(d<<2)+a|0;e=f+6|0;e=w[e|0]|w[e+1|0]<<8;h=Pb(b,d),i=e,u[h>>1]=i;a:{if(!d){break a}e=d-1|0;if(x[Pb(b,d)>>1]>=x[Pb(b,e)>>1]){break a}e=x[Pb(b,e)>>1];h=Pb(b,d),i=e+1|0,u[h>>1]=i}f=f+8|0;f=Yb((w[f|0]|w[f+1|0]<<8)<<16>>16>>c,0,64);h=Pb(b,d),i=f,t[h+2|0]=i;d=d+1|0;if(Kb(b)>>>0>d>>>0){continue}break}}jb=g+16|0}function jfa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;b=jb-16|0;jb=b;h=v[a+40>>2];i=v[a+36>>2];k=v[a+16>>2];g=v[a+4>>2];e=g;f=v[a>>2];v[b+8>>2]=f;v[b+12>>2]=e;g=v[a+12>>2];v[b>>2]=v[a+8>>2];v[b+4>>2]=g;a:{if(d){while(1){j=v[a+32>>2];i=v[a+28>>2]+i|0;g=i>>12;e=(e<<1)+k|0;f=(f>>>21&2040)+33120|0;e=(((B(u[e>>1],u[f+2>>1])+B(u[e-2>>1],u[f>>1])|0)+B(u[e+2>>1],u[f+4>>1])|0)+B(u[e+4>>1],u[f+6>>1])|0)/16384|0;v[c>>2]=v[c>>2]+B(g,e);h=h+j|0;j=h>>12;v[c+4>>2]=v[c+4>>2]+B(e,j);Sb(b+8|0,b);d=d-1|0;if(d){c=c+8|0;f=v[b+8>>2];e=v[b+12>>2];continue}break}f=v[b+8>>2];e=v[b+12>>2];break a}j=h>>12;g=i>>12}v[a+40>>2]=h;v[a+20>>2]=g;v[a+36>>2]=i;v[a+24>>2]=j;v[a>>2]=f;v[a+4>>2]=e;jb=b+16|0}function gE(a){a=a|0;var b=0,c=0,d=0,e=0;d=jb-16|0;jb=d;a:{b:{if(!v[(v[v[a>>2]-12>>2]+a|0)+24>>2]){break b}v[113382]=0;c=Q(2720,d+8|0,a|0)|0;b=v[113382];v[113382]=0;c:{if((b|0)!=1){d:{if(!w[c|0]){break d}b=v[(v[v[a>>2]-12>>2]+a|0)+24>>2];v[113382]=0;b=T(2721,b|0)|0;e=v[113382];v[113382]=0;if((e|0)!=1){if((b|0)!=-1){break d}b=v[v[a>>2]-12>>2];v[113382]=0;R(2722,a+b|0,1);b=v[113382];v[113382]=0;if((b|0)!=1){break d}}b=V(0)|0;O()|0;fE(c);break c}fE(c);break b}b=V(0)|0;O()|0}_(b|0)|0;c=v[v[a>>2]-12>>2];v[113382]=0;Z(19,a+c|0);c=v[113382];v[113382]=0;if((c|0)==1){break a}$()}jb=d+16|0;return a|0}a=P()|0;O()|0;v[113382]=0;Y(20);c=v[113382];v[113382]=0;if((c|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function cU(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;e=jb-32|0;jb=e;sd(b,0);uh(e,1,a+33|0);d=e+16|0;Ec(d,e);v[113382]=0;Q(336,b+43|0,d|0)|0;d=v[113382];v[113382]=0;if((d|0)!=1){f=e+16|0;yb(f);d=a+50|0;v[b>>2]=w[d|0]|w[d+1|0]<<8|(w[d+2|0]<<16|w[d+3|0]<<24);d=a+54|0;v[b+24>>2]=w[d|0]|w[d+1|0]<<8;t[e+16|0]=w[a+56|0];t[e|0]=64;g=b,h=w[pc(f,e)|0]<<2,u[g+30>>1]=h;d=a+57|0;v[b+4>>2]=w[d|0]|w[d+1|0]<<8|(w[d+2|0]<<16|w[d+3|0]<<24);d=a+61|0;v[b+8>>2]=w[d|0]|w[d+1|0]<<8|(w[d+2|0]<<16|w[d+3|0]<<24);if(!(!c|!v[b+4>>2])){v[b+8>>2]=v[b>>2]}a:{if(!w[a|0]){break a}a=v[b+8>>2];if(a>>>0<=v[b+4>>2]+2>>>0|a>>>0>y[b>>2]){break a}u[b+34>>1]=x[b+34>>1]|2}jb=e+32|0;return}a=P()|0;O()|0;yb(e+16|0);S(a|0);L()}function j6(a){a=a|0;var b=0;b=4290;a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{m:{n:{if((a|0)<=276){if(!a){break n}if((a|0)==257){break m}if((a|0)!=267){break a}b=13485;break a}switch(a-277|0){case 1:case 2:case 3:case 4:case 5:case 6:case 7:case 8:case 13:case 14:case 15:case 16:case 17:case 18:break a;case 10:break j;case 9:break k;case 0:break l;case 23:break c;case 22:break d;case 21:break e;case 20:break f;case 19:break g;case 12:break h;case 11:break i;default:break b}}b=17540;break a}b=4323;break a}b=1518;break a}b=4346;break a}b=4360;break a}b=1874;break a}b=1894;break a}b=4372;break a}b=4304;break a}b=8824;break a}b=8141;break a}b=2446;break a}if((a|0)!=357){break a}b=4257}return Ud(b)|0}function ql(a,b){var c=0,d=0,e=0,f=0,g=0;c=Kb(a);if(c>>>0<b>>>0){d=jb-32|0;jb=d;a:{b:{c=b-c|0;c:{if(c>>>0<=v[zb(a)>>2]-v[a+4>>2]>>2>>>0){e=jb-16|0;jb=e;d:{b=oe(e,a,c);c=v[b+4>>2];g=v[b+8>>2];if((c|0)!=(g|0)){while(1){f=zb(a);v[113382]=0;R(1591,f|0,c|0);f=v[113382];v[113382]=0;if((f|0)==1){break d}c=c+4|0;v[b+4>>2]=c;if((c|0)!=(g|0)){continue}break}}Mb(b);jb=e+16|0;break c}a=P()|0;O()|0;Mb(b);S(a|0);L()}b=zb(a);b=Nf(d+8|0,ye(a,Kb(a)+c|0),Kb(a),b);v[113382]=0;R(1567,b|0,c|0);c=v[113382];v[113382]=0;if((c|0)==1){break b}v[113382]=0;R(1566,a|0,b|0);a=v[113382];v[113382]=0;if((a|0)==1){break b}Tm(b)}jb=d+32|0;break a}a=P()|0;O()|0;Tm(b);S(a|0);L()}return}if(b>>>0<c>>>0){vx(a,v[a>>2]+(b<<2)|0)}}function nJ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;c=jb-48|0;jb=c;v[c+8>>2]=542066252;e=c+8|0;d=e|4;t[d|0]=0;t[d+1|0]=0;t[d+2|0]=0;t[d+3|0]=0;d=v[b+4220>>2];t[c+16|0]=d;t[c+17|0]=d>>>8;t[c+18|0]=d>>>16;t[c+19|0]=d>>>24;d=v[b+4224>>2];t[c+20|0]=d;t[c+21|0]=d>>>8;t[c+22|0]=d>>>16;t[c+23|0]=d>>>24;d=v[b+4228>>2];t[c+24|0]=d;t[c+25|0]=d>>>8;t[c+26|0]=d>>>16;t[c+27|0]=d>>>24;d=v[b+4232>>2];t[c+28|0]=d;t[c+29|0]=d>>>8;t[c+30|0]=d>>>16;t[c+31|0]=d>>>24;d=v[b+4236>>2];t[c+32|0]=d;t[c+33|0]=d>>>8;t[c+34|0]=d>>>16;t[c+35|0]=d>>>24;t[c+36|0]=w[b+4240|0];t[c+37|0]=w[b+4241|0];t[c+38|0]=w[b+4242|0];t[c+39|0]=w[b+4243|0];t[c+40|0]=w[b+4244|0];b=b+4208|0;Gk(b,33);lc(v[b>>2],e,33);Vi(c,b);Dd(a,c);jb=c+48|0}function r9(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;eL(a);zb(a);i=b+4|0;g=i;f=v[a+4>>2];j=v[a>>2];if((f|0)!=(j|0)){c=v[g>>2];while(1){d=c-52|0;f=f-52|0;c=f;e=XJ(d,zb(c));v[d>>2]=v[c>>2];v[d+4>>2]=v[c+4>>2];h=v[zb(c)>>2];l=zb(e),m=h,v[l>>2]=m;l=zb(c),m=0,v[l>>2]=m;v[c>>2]=0;v[c+4>>2]=0;v[d+20>>2]=v[c+20>>2];e=v[c+16>>2];v[d+12>>2]=v[c+12>>2];v[d+16>>2]=e;e=c+24|0;h=WJ(d+24|0,zb(e));v[d+24>>2]=v[e>>2];v[d+28>>2]=v[e+4>>2];k=v[zb(e)>>2];l=zb(h),m=k,v[l>>2]=m;l=zb(e),m=0,v[l>>2]=m;v[e>>2]=0;v[e+4>>2]=0;rd(d+36|0,c+36|0);v[d+48>>2]=v[c+48>>2];c=v[g>>2]-52|0;v[g>>2]=c;if((f|0)!=(j|0)){continue}break}}dc(a,i);dc(a+4|0,b+8|0);dc(zb(a),gc(b));v[b>>2]=v[b+4>>2];YJ(a,mf(a))}function Jea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;g=jb-16|0;jb=g;i=v[a+24>>2];j=v[a+20>>2];k=v[a+16>>2];h=v[a+4>>2];e=h;f=v[a>>2];v[g+8>>2]=f;v[g+12>>2]=e;h=v[a+12>>2];v[g>>2]=v[a+8>>2];v[g+4>>2]=h;if(d){while(1){e=e+k|0;f=(((f>>>16|0)+4&131064)<<1)+b|0;e=(((((B(t[e+2|0],u[f+34>>1])+B(t[e+1|0],u[f+32>>1])|0)+B(t[e+3|0],u[f+36>>1])|0)+B(t[e+4|0],u[f+38>>1])<<8)/2|0)+((((B(t[e-2|0],u[f+26>>1])+B(t[e-3|0],u[f+24>>1])|0)+B(t[e-1|0],u[f+28>>1])|0)+B(t[e|0],u[f+30>>1])<<8)/2|0)|0)/16384|0;v[c>>2]=v[c>>2]+B(e,j);v[c+4>>2]=v[c+4>>2]+B(e,i);Sb(g+8|0,g);d=d-1|0;if(d){c=c+8|0;f=v[g+8>>2];e=v[g+12>>2];continue}break}f=v[g+8>>2];e=v[g+12>>2]}v[a>>2]=f;v[a+4>>2]=e;jb=g+16|0}function Hja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=jb+-64|0;jb=d;e=d+40|0;Ze(e,a,c);a=v[e>>2];v[113382]=0;e=T(426,e|0)|0;f=v[113382];v[113382]=0;a:{b:{c:{d:{if((f|0)==1){break d}v[113382]=0;e=T(427,e|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break d}v[113382]=0;X(428,d+8|0,3,e|0,a|0);e=v[113382];v[113382]=0;if((e|0)==1){break d}v[113382]=0;R(356,d+24|0,d+8|0);e=v[113382];v[113382]=0;if((e|0)==1){break d}v[113382]=0;R(725,d|0,b|0);b=v[113382];v[113382]=0;if((b|0)==1){break c}v[113382]=0;Q(431,d|0,d+24|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break c}yb(d+24|0);Cc(d+40|0);jb=d- -64|0;a=!c|(a|0)!=0;break a}a=P()|0;O()|0;break b}a=P()|0;O()|0;yb(d+24|0)}Cc(d+40|0);S(a|0);L()}return a|0}function vX(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=jb-16|0;jb=e;a:{b:{if(!se(b,-1)){f=v[a+12>>2];g=v[a+8>>2];if(v[a+24>>2]==v[a+28>>2]){c=-1;if(!(w[a+48|0]&16)){break a}h=v[a+24>>2];i=v[a+20>>2];j=v[a+44>>2];k=v[a+20>>2];v[113382]=0;c=a+32|0;R(110,c|0,0);d=v[113382];v[113382]=0;if((d|0)==1){break b}d=Fc(c);v[113382]=0;R(1589,c|0,d|0);d=v[113382];v[113382]=0;if((d|0)==1){break b}d=Tb(c);Iv(a,d,Db(c)+d|0);$q(a,h-i|0);v[a+44>>2]=v[a+20>>2]+(j-k|0)}v[e+12>>2]=v[a+24>>2]+1;l=a,m=v[Vc(e+12|0,a+44|0)>>2],v[l+44>>2]=m;if(w[a+48|0]&8){c=Tb(a+32|0);sm(a,c,c+(f-g|0)|0,v[a+44>>2])}c=uF(a,um(b));break a}c=Zq(b);break a}a=V(0)|0;O()|0;_(a|0)|0;$();c=-1}jb=e+16|0;return c|0}function rT(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=jb+-64|0;jb=d;e=d+40|0;Ze(e,a,c);a=v[e>>2];v[113382]=0;e=T(426,e|0)|0;f=v[113382];v[113382]=0;a:{b:{c:{d:{if((f|0)==1){break d}v[113382]=0;e=T(427,e|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break d}v[113382]=0;X(428,d+8|0,2,e|0,a|0);e=v[113382];v[113382]=0;if((e|0)==1){break d}v[113382]=0;R(356,d+24|0,d+8|0);e=v[113382];v[113382]=0;if((e|0)==1){break d}v[113382]=0;R(482,d|0,b|0);b=v[113382];v[113382]=0;if((b|0)==1){break c}v[113382]=0;Q(431,d|0,d+24|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break c}yb(d+24|0);Cc(d+40|0);jb=d- -64|0;a=!c|(a|0)!=0;break a}a=P()|0;O()|0;break b}a=P()|0;O()|0;yb(d+24|0)}Cc(d+40|0);S(a|0);L()}return a|0}function RR(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=jb+-64|0;jb=d;e=d+40|0;Ze(e,a,c);a=v[e>>2];v[113382]=0;e=T(426,e|0)|0;f=v[113382];v[113382]=0;a:{b:{c:{d:{if((f|0)==1){break d}v[113382]=0;e=T(427,e|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break d}v[113382]=0;X(428,d+8|0,2,e|0,a|0);e=v[113382];v[113382]=0;if((e|0)==1){break d}v[113382]=0;R(356,d+24|0,d+8|0);e=v[113382];v[113382]=0;if((e|0)==1){break d}v[113382]=0;R(473,d|0,b|0);b=v[113382];v[113382]=0;if((b|0)==1){break c}v[113382]=0;Q(431,d|0,d+24|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break c}yb(d+24|0);Cc(d+40|0);jb=d- -64|0;a=!c|(a|0)!=0;break a}a=P()|0;O()|0;break b}a=P()|0;O()|0;yb(d+24|0)}Cc(d+40|0);S(a|0);L()}return a|0}function RT(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;d=jb-16|0;jb=d;sd(b,0);v[b>>2]=w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24);c=aq(a+4|0,a);v[b+4>>2]=w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24);c=aq(a+8|0,a);v[b+8>>2]=w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24);t[d+15|0]=127;t[d+14|0]=w[a+15|0];f=b,g=(((w[pc(d+15|0,d+14|0)|0]<<8|64)&65344)>>>0)/127|0,u[f+30>>1]=g;e=a+12|0;if(w[e|0]>=16){c=w[e|0];u[b+34>>1]=32;u[b+28>>1]=c&240}c=a+13|0;v[b+24>>2]=(w[c|0]|w[c+1|0]<<8)<<1;if(!(w[c|0]|w[c+1|0]<<8)){v[b+24>>2]=16726}f=b,g=(B(_s(0,w[e|0]<<28>>24),v[b+24>>2])>>>0)/8363|0,v[f+24>>2]=g;if(y[b+4>>2]<y[b+8>>2]){u[b+34>>1]=x[b+34>>1]|2}if(w[a+16|0]&132){u[b+34>>1]=x[b+34>>1]|1}jb=d+16|0}function kfa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;e=jb-16|0;jb=e;h=v[a+40>>2];i=v[a+36>>2];k=v[a+16>>2];g=v[a+4>>2];b=g;f=v[a>>2];v[e+8>>2]=f;v[e+12>>2]=b;g=v[a+12>>2];v[e>>2]=v[a+8>>2];v[e+4>>2]=g;a:{if(d){while(1){j=v[a+32>>2];i=v[a+28>>2]+i|0;g=i>>12;b=b+k|0;f=(f>>>21&2040)+33120|0;b=(((B(t[b|0],u[f+2>>1])+B(t[b-1|0],u[f>>1])|0)+B(t[b+1|0],u[f+4>>1])|0)+B(t[b+2|0],u[f+6>>1])<<8)/16384|0;v[c>>2]=v[c>>2]+B(g,b);h=h+j|0;j=h>>12;v[c+4>>2]=v[c+4>>2]+B(b,j);Sb(e+8|0,e);d=d-1|0;if(d){c=c+8|0;f=v[e+8>>2];b=v[e+12>>2];continue}break}f=v[e+8>>2];b=v[e+12>>2];break a}j=h>>12;g=i>>12}v[a+40>>2]=h;v[a+20>>2]=g;v[a+36>>2]=i;v[a+24>>2]=j;v[a>>2]=f;v[a+4>>2]=b;jb=e+16|0}function qJ(a,b,c){a=a|0;b=b|0;c=C(c);var d=0,e=0,f=0,g=0;d=jb-16|0;jb=d;z[d+12>>2]=c;px(a);Wd(d+12|0,C(0));a:{b:{switch(b|0){case 0:z[a+4220>>2]=z[d+12>>2];break a;case 1:z[a+4224>>2]=z[d+12>>2];break a;case 2:z[a+4228>>2]=z[d+12>>2];ds(a);break a;case 3:t[a+4240|0]=z[d+12>>2]>=C(.5);ds(a);break a;case 4:b=jb-16|0;jb=b;f=b,g=Lh(C(z[d+12>>2]*C(32))),v[f+12>>2]=g;v[b+8>>2]=0;v[b+4>>2]=5;e=v[Ok(b+12|0,b+8|0,b+4|0)>>2];jb=b+16|0;v[a+4232>>2]=e;break a;case 5:t[a+4241|0]=z[d+12>>2]>=C(.5);break a;case 6:t[a+4242|0]=z[d+12>>2]>=C(.5);break a;case 7:t[a+4244|0]=z[d+12>>2]>=C(.5);break a;case 8:break b;default:break a}}b=a;c=z[d+12>>2];if(c==C(0)){ox(a);c=z[d+12>>2]}A[b+4256>>3]=c}jb=d+16|0}function n2(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;b=jb-32|0;jb=b;e=ih(a);Ad(b+24|0);v[113382]=0;a=Q(2167,v[b+24>>2],v[b+28>>2])|0;c=v[113382];v[113382]=0;a:{b:{if((c|0)==1){break b}v[113382]=0;R(1500,e|0,a|0);a=v[113382];v[113382]=0;if((a|0)==1){break b}a=0;c:{while(1){v[113382]=0;c=Q(2167,v[b+24>>2],v[b+28>>2])|0;d=v[113382];v[113382]=0;d:{if((d|0)!=1){if((a|0)<(c|0)){break d}jb=b+32|0;return}a=P()|0;O()|0;break a}c=v[v[b+24>>2]+(a<<3)>>2];v[113382]=0;c=Q(121,b+8|0,c|0)|0;d=v[113382];v[113382]=0;if((d|0)!=1){v[113382]=0;R(1502,e|0,c|0);d=v[113382];v[113382]=0;if((d|0)==1){break c}yb(c);a=a+1|0;continue}break}a=P()|0;O()|0;break a}a=P()|0;O()|0;yb(c);break a}a=P()|0;O()|0}gd(e);S(a|0);L()}function Jr(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=C(0);c=jb-80|0;jb=c;d=v[a>>2];f=v[d+4>>2];e=v[d+24>>2];v[c+40>>2]=v[d+20>>2];v[c+44>>2]=e;e=v[d+16>>2];v[c+32>>2]=v[d+12>>2];v[c+36>>2]=e;Fh(c- -64|0,c+32|0,f);d=ie(c+48|0,v[v[a+4>>2]>>2],v[v[a+8>>2]>>2],v[v[a+12>>2]>>2]);f=v[v[a+12>>2]>>2];e=v[v[a+8>>2]>>2];a=v[c+76>>2];v[c+24>>2]=v[c+72>>2];v[c+28>>2]=a;a=v[c+68>>2];v[c+16>>2]=v[c+64>>2];v[c+20>>2]=a;v[c+8>>2]=v[d+8>>2];a=v[d+4>>2];v[c>>2]=v[d>>2];v[c+4>>2]=a;h=c+16|0;a=c;if(f){while(1){d=0;if(e){while(1){i=v[Sf(a,d,g)>>2];ec(b,d);j=nn(h,d,g),k=C(C(i|0)*C(7.450580596923828e-9)),z[j>>2]=k;d=d+1|0;if((e|0)!=(d|0)){continue}break}}g=g+1|0;if((f|0)!=(g|0)){continue}break}}jb=c+80|0}function rka(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;c=jb-48|0;jb=c;f=c+24|0;d=f;g=Oi(d+8|0);v[113382]=0;e=T(296,b|0)|0;h=v[113382];v[113382]=0;a:{b:{if((h|0)==1){break b}v[113382]=0;U(429,d|0,b|0,e|0);e=v[113382];v[113382]=0;if((e|0)==1){break b}d=v[d>>2];v[113382]=0;Q(304,b|0,d|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){break a}}a=P()|0;O()|0;Sg(g);S(a|0);L()}v[113382]=0;R(666,c+8|0,f|0);b=v[113382];v[113382]=0;c:{if((b|0)==1){break c}v[113382]=0;R(667,c+16|0,c+8|0);b=v[113382];v[113382]=0;if((b|0)==1){break c}b=v[c+16>>2];d=v[c+20>>2];v[113382]=0;W(668,a|0,b|0,d|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break c}Cc(c+24|0);jb=c+48|0;return}a=P()|0;O()|0;Cc(c+24|0);S(a|0);L()}function ly(a,b,c,d){var e=0,f=0;e=jb-16|0;jb=e;a:{if(!d){break a}if(c){t[b+835|0]=c;break a}c=w[b+835|0]}d=v[a+480180>>2]&1048580;c=d?(c&240?-16:15)&c:c;b:{c:{d:{e:{if(!d){d=c&240;c=c&15;if((c|0)==15){if(!d){d=0;break e}if(!(w[a+480209|0]&16)){break b}c=0-(d>>>2|0)|0;break d}f=!c;if(!c|(d|0)!=240){break e}if(!(w[a+480209|0]&16)){break b}c=c<<2;break c}if(w[a+480209|0]&16){break b}d=e+8|0;Fb(d,a+1074312|0,56);a=c&240;a=a?a>>>2|0:0-(c<<2&60)|0;c=a;if(!Cb(d)){break d}c=(a|0)/4<<24>>24;break d}if(w[a+480209|0]&16){break b}if(!f){c=c<<2;if(!(v[a+480180>>2]&16777248)|!d){break c}break b}c=0-(d>>>2|0)|0}if(!c){break b}}a=Yb(v[b+692>>2]+c|0,0,256);u[b+796>>1]=0;v[b+692>>2]=a}jb=e+16|0}function LJ(a,b,c){var d=0,e=0,f=0,g=0,h=0;f=jb-48|0;jb=f;e=Xb(f+32|0);v[113382]=0;Q(1588,a|0,f+24|0)|0;d=v[113382];v[113382]=0;a:{b:{if((d|0)!=1){g=v[f+28>>2];d=v[f+24>>2];Ee(e);v[113382]=0;g=!g&d>>>0<255?d:255;R(1589,e|0,g|0);d=v[113382];v[113382]=0;if((d|0)==1){break a}if(g){d=0;while(1){h=kc(e,d);v[113382]=0;Q(1590,a|0,h|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break a}d=d+1|0;if((g|0)!=(d|0)){continue}break}}if((ND(e)|0)!=-1){a=ND(e);v[113382]=0;R(1589,e|0,a|0);a=v[113382];v[113382]=0;if((a|0)==1){break a}}v[113382]=0;U(13,f+8|0,c|0,e|0);a=v[113382];v[113382]=0;if((a|0)!=1){break b}break a}break a}a=f+8|0;Gb(b,a);yb(a);yb(e);jb=f+48|0;return}a=P()|0;O()|0;yb(e);S(a|0);L()}function wia(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;d=jb-528|0;jb=d;c=-1;a:{if(!Ef(a,1468)){break a}yk(a,1464);b=d+524|0;kQ(a,b);if(!Vd(b,24098)){c=0;if(!Vd(d+524|0,11763)){break a}}yk(a,20);b=1;while(1){c=-1;if(!hQ(a,d)){break a}e=xz(d)+e|0;c=b&65535;b=b+1|0;if(c>>>0<31){continue}break}c=0;if(e>>>0>40){break a}e=d+520|0;f=e;c=jb-16|0;jb=c;b=a;b:{if(Ef(b,2)){g=c+8|0;Sk(g,f);oz(b,g);break b}t[c+7|0]=0;rB(f,c+7|0)}jb=c+16|0;f=Zc(e);c=0;if(w[e|0]>128){break a}b=d;c=jb-16|0;jb=c;c:{if(Ef(a,512)){e=c+8|0;du(e,b);oz(a,e);break c}SP(b)}jb=c+16|0;a=d+512|0;c=w[f|0];d:{while(1){if(c>>>0<w[b|0]){break d}b=b+1|0;if((a|0)!=(b|0)){continue}break}c=1;break a}c=0}jb=d+528|0;return c|0}
function kea(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;f=zE(v[v[a>>2]-12>>2]+a|0,10);e=jb-16|0;jb=e;v[113382]=0;c=a;d=Q(15,e+8|0,c|0)|0;b=v[113382];v[113382]=0;a:{b:{c:{d:{if((b|0)!=1){e:{if(!w[d|0]){break e}b=Tk(e,c);v[113382]=0;Q(2355,b|0,f|0)|0;f=v[113382];v[113382]=0;if((f|0)!=1){if(!Rk(b)){break e}b=v[v[c>>2]-12>>2];v[113382]=0;R(18,b+c|0,1);b=v[113382];v[113382]=0;if((b|0)!=1){break e}}b=V(0)|0;O()|0;Kf(d);break d}Kf(d);break c}b=V(0)|0;O()|0}_(b|0)|0;d=v[v[c>>2]-12>>2];v[113382]=0;Z(19,c+d|0);c=v[113382];v[113382]=0;if((c|0)==1){break b}$()}jb=e+16|0;break a}a=P()|0;O()|0;v[113382]=0;Y(20);c=v[113382];v[113382]=0;if((c|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}br(a);return a|0}function Iha(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;e=jb-16|0;jb=e;c=b;d=v[c+12>>2];v[e+8>>2]=v[c+8>>2];v[e+12>>2]=d;d=v[c+4>>2];v[e>>2]=v[c>>2];v[e+4>>2]=d;d=AP(e);c=a;Mp(c);t[c+8|0]=0;v[c+4>>2]=d;v[c>>2]=71776;d=Oi(c+12|0);t[c+24|0]=0;v[113382]=0;Q(35,c+28|0,0)|0;f=v[113382];v[113382]=0;a:{if((f|0)!=1){d=c+40|0;f=d+192|0;while(1){v[d>>2]=0;v[d+4>>2]=0;t[d+8|0]=0;d=d+12|0;if((f|0)!=(d|0)){continue}break}if(w[c+24|0]){c=c+232|0;d=0;while(1){g=Xe(c,d),h=d,v[g>>2]=h;d=d+1|0;if((d|0)!=16){continue}break}}break a}a=P()|0;O()|0;Sg(d);S(a|0);L()}v[a>>2]=71892;c=v[b+4>>2];v[a+296>>2]=v[b>>2];v[a+300>>2]=c;c=v[b+12>>2];v[a+304>>2]=v[b+8>>2];v[a+308>>2]=c;jb=e+16|0;return a|0}function q9(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=jb-16|0;jb=c;u[a>>1]=0;e=kk(a+4|0);h=kk(a+16|0);v[a+36>>2]=0;j=bd(a+40|0);f=jb-16|0;jb=f;g=f+8|0;b=jb-16|0;jb=b;v[113382]=0;i=a+52|0;d=i;T(1563,d+4|0)|0;k=v[113382];v[113382]=0;a:{b:{c:{if((k|0)!=1){v[113382]=0;v[b+12>>2]=0;W(1564,d+8|0,b+12|0,g|0)|0;g=v[113382];v[113382]=0;if((g|0)!=1){break c}break b}break b}l=d,m=jc(d),v[l>>2]=m;jb=b+16|0;break a}V(0)|0;O()|0;Ab();L()}jb=f+16|0;ti(e);u[a+28>>1]=65472;v[113382]=0;v[c+12>>2]=1065353216;U(1561,e|0,128,c+12|0);b=v[113382];v[113382]=0;if((b|0)!=1){v[a+32>>2]=0;u[a+30>>1]=0;ti(h);jb=c+16|0;return a|0}a=P()|0;O()|0;ER(i);yb(j);fg(h);fg(e);S(a|0);L()}
function SJ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=C(0),i=C(0),j=0,k=C(0);f=jb-16|0;jb=f;if(!(!x[b>>1]|u[d>>1]>u[d+2>>1]|(!(z[c>>2]>C(0))|(u[d+2>>1]-u[d>>1]|0)>32766))){u[a>>1]=3;g=a+4|0;ti(g);u[a+28>>1]=65472;v[f+12>>2]=1065353216;UJ(g,128,f+12|0);v[a+32>>2]=0;u[a+30>>1]=0;ti(a+16|0);u[a+28>>1]=x[d>>1];e=jb-16|0;jb=e;u[e+14>>1]=x[b>>1];u[e+12>>1]=32767;b=u[Af(e+14|0,e+12|0)>>1];jb=e+16|0;u[a+30>>1]=b;h=C(D(z[c>>2]));z[a+32>>2]=h;h=je(h,C(C(1)/C(u[a+30>>1])));e=1;ql(g,(u[d+2>>1]-u[d>>1]|0)+1|0);b=u[d>>1];if((b|0)<=u[d+2>>1]){while(1){i=je(h,C(b|0));j=Pb(g,b-u[a+28>>1]|0),k=i,z[j>>2]=k;c=u[d+2>>1]>(b|0);b=b+1|0;if(c){continue}break}}Oo(a)}jb=f+16|0;return e|0}function Mo(a,b,c){var d=0,e=0,f=0;d=Xb(a);a=Db(b);v[113382]=0;R(111,d|0,a|0);a=v[113382];v[113382]=0;if((a|0)!=1){a:{if(Db(b)){while(1){f=v[ij(b,e)>>2];a=32;b:{c:{while(1){if(v[(a<<2)+c>>2]!=(f|0)){a=a+1|0;if(a>>>0<256){continue}break c}break}v[113382]=0;R(110,d|0,a<<24>>24);a=v[113382];v[113382]=0;if((a|0)!=1){break b}break a}a=0;while(1){d:{if(v[(a<<2)+c>>2]==(f|0)){v[113382]=0;R(110,d|0,a<<24>>24);a=v[113382];v[113382]=0;if((a|0)!=1){break b}break a}if(a>>>0>30){break d}a=a+1|0;if(a>>>0<256){continue}}break}v[113382]=0;R(110,d|0,63);a=v[113382];v[113382]=0;if((a|0)!=1){break b}break a}e=e+1|0;if(Db(b)>>>0>e>>>0){continue}break}}return}}a=P()|0;O()|0;yb(d);S(a|0);L()}function xo(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;h=jb-16|0;jb=h;f=d?d:453548;d=v[f>>2];a:{b:{c:{if(!b){if(d){break c}break a}e=-2;if(!c){break a}i=a?a:h+12|0;d:{if(d){a=c;break d}a=w[b|0];d=a<<24>>24;if((d|0)>=0){v[i>>2]=a;e=(d|0)!=0;break a}a=t[b|0];if(!v[v[113364]>>2]){v[i>>2]=a&57343;e=1;break a}a=(a&255)-194|0;if(a>>>0>50){break c}d=v[(a<<2)+54992>>2];a=c-1|0;if(!a){break b}b=b+1|0}g=w[b|0];j=g>>>3|0;if((j-16|(d>>26)+j)>>>0>7){break c}while(1){a=a-1|0;d=g-128|d<<6;if((d|0)>=0){v[f>>2]=0;v[i>>2]=d;e=c-a|0;break a}if(!a){break b}b=b+1|0;g=w[b|0];if((g&192)==128){continue}break}}v[f>>2]=0;v[113305]=25;e=-1;break a}v[f>>2]=d}jb=h+16|0;return e|0}function Xba(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=C(0),g=0,h=0,i=0,j=0;e=jb-16|0;jb=e;v[e+12>>2]=c>>>3;v[e+8>>2]=v[a>>2];d=v[Lb(e+12|0,e+8|0)>>2];b=Eb(b);if(d){a=v[a+20>>2];c=d;while(1){v[e+12>>2]=w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24);Wd(e+12|0,C(-1));f=C(z[e+12>>2]*C(32768));z[e+12>>2]=f;h=a;f=de(f);a:{if(C(D(f))<C(2147483648)){g=~~f;break a}g=-2147483648}i=h,j=Rc(g),u[i>>1]=j;v[e+12>>2]=w[b+4|0]|w[b+5|0]<<8|(w[b+6|0]<<16|w[b+7|0]<<24);Wd(e+12|0,C(-1));f=C(z[e+12>>2]*C(32768));z[e+12>>2]=f;h=a;f=de(f);b:{if(C(D(f))<C(2147483648)){g=~~f;break b}g=-2147483648}i=h,j=Rc(g),u[i+2>>1]=j;a=a+4|0;b=b+8|0;c=c-1|0;if(c){continue}break}}jb=e+16|0;return d<<3}function aH(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0;d=jb-16|0;jb=d;a:{b:{c:{d:{if((b|0)>=0){if((Go(a+8|0)|0)>(b|0)){break d}}a=ba(8)|0;v[113382]=0;d=Q(121,d|0,6794)|0;b=v[113382];v[113382]=0;if((b|0)==1){break c}nc(a,d);v[113382]=0;U(1978,a|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break a}b=P()|0;O()|0;yb(d);break b}if(!(!(c<0)&c<=1)){a=ba(8)|0;v[113382]=0;d=Q(121,d|0,7750)|0;b=v[113382];v[113382]=0;if((b|0)!=1){nc(a,d);v[113382]=0;U(1978,a|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break a}b=P()|0;O()|0;yb(d);break b}b=P()|0;O()|0;ca(a|0);break b}e=jn(c*64);v[(v[a+32>>2]+B(b,896)|0)+1075744>>2]=e;jb=d+16|0;return}b=P()|0;O()|0;ca(a|0)}S(b|0)}L()}function bea(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;e=jb-48|0;jb=e;a:{b:{if(v[a+8>>2]!=v[gc(a)>>2]){break b}g=a+8|0;h=a+4|0;c=v[a+4>>2];d=v[a>>2];if(c>>>0>d>>>0){f=c;c=((c-d>>2)+1|0)/-2<<2;i=g,j=kf(f,v[g>>2],f+c|0),v[i>>2]=j;v[h>>2]=c+v[h>>2];break b}i=e,j=v[gc(a)>>2]-v[a>>2]>>1,v[i+24>>2]=j;v[e+44>>2]=1;d=e+24|0;c=v[Vc(d,e+44|0)>>2];c=Qn(d,c,c>>>2|0,v[a+16>>2]);d=Oc(e+16|0,v[a+4>>2]);f=v[Oc(e+8|0,v[a+8>>2])>>2];d=v[d>>2];v[113382]=0;U(1125,c|0,d|0,f|0);d=v[113382];v[113382]=0;if((d|0)==1){break a}dc(a,c);dc(h,c+4|0);dc(g,c+8|0);dc(gc(a),gc(c));Th(c)}Nz(v[a+16>>2],v[a+8>>2],b);v[a+8>>2]=v[a+8>>2]+4;jb=e+48|0;return}a=P()|0;O()|0;Th(c);S(a|0);L()}function ria(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=jb-80|0;jb=e;Ee(b);f=e+56|0;Ze(f,a,d);a=v[f>>2];v[113382]=0;f=T(426,f|0)|0;g=v[113382];v[113382]=0;a:{b:{c:{d:{if((g|0)==1){break d}v[113382]=0;f=T(427,f|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break d}v[113382]=0;X(428,e+8|0,2,f|0,a|0);f=v[113382];v[113382]=0;if((f|0)==1){break d}v[113382]=0;R(356,e+24|0,e+8|0);f=v[113382];v[113382]=0;if((f|0)==1){break d}v[113382]=0;U(13,e+40|0,c|0,e+24|0);c=v[113382];v[113382]=0;if((c|0)==1){break c}c=b;b=e+40|0;Gb(c,b);yb(b);yb(e+24|0);Cc(e+56|0);jb=e+80|0;a=!d|(a|0)!=0;break a}a=P()|0;O()|0;break b}a=P()|0;O()|0;yb(e+24|0)}Cc(e+56|0);S(a|0);L()}return a|0}function o8(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;b=qi(a,b,c,d);v[a>>2]=74708;c=Oi(a+4208|0);d=a+4288|0;v[d>>2]=0;v[d+4>>2]=0;v[a+4280>>2]=0;v[a+4284>>2]=0;v[113382]=0;d=da(1356)|0;e=v[113382];v[113382]=0;a:{if((e|0)==1){break a}v[113382]=0;d=T(1357,d|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break a}v[a+4228>>2]=1049926264;v[a+4232>>2]=0;v[a+4220>>2]=1056964608;v[a+4224>>2]=1056964608;v[a+4296>>2]=d;t[a+4244|0]=0;v[a+4236>>2]=2147483647;v[a+4240>>2]=0;ds(a);cs(a);v[113382]=0;W(1609,a+44|0,2,2)|0;d=v[113382];v[113382]=0;if((d|0)==1){break a}v[113382]=0;Z(1610,b|0);d=v[113382];v[113382]=0;if((d|0)==1){break a}return a|0}a=P()|0;O()|0;Sg(c);rf(b);S(a|0);L()}function aQ(a,b){var c=0,d=0,e=0;c=jb-32|0;jb=c;a:{if(Rb(a,1024)){d=c+24|0;pz(d,b);zd(a,d);break a}v[c+16>>2]=0;v[c+20>>2]=0;v[c+8>>2]=0;v[c+12>>2]=0;a=64;while(1){d=w[c+12|0]|w[c+13|0]<<8|(w[c+14|0]<<16|w[c+15|0]<<24);e=w[c+8|0]|w[c+9|0]<<8|(w[c+10|0]<<16|w[c+11|0]<<24);t[b|0]=e;t[b+1|0]=e>>>8;t[b+2|0]=e>>>16;t[b+3|0]=e>>>24;t[b+4|0]=d;t[b+5|0]=d>>>8;t[b+6|0]=d>>>16;t[b+7|0]=d>>>24;d=w[c+20|0]|w[c+21|0]<<8|(w[c+22|0]<<16|w[c+23|0]<<24);e=w[c+16|0]|w[c+17|0]<<8|(w[c+18|0]<<16|w[c+19|0]<<24);t[b+8|0]=e;t[b+9|0]=e>>>8;t[b+10|0]=e>>>16;t[b+11|0]=e>>>24;t[b+12|0]=d;t[b+13|0]=d>>>8;t[b+14|0]=d>>>16;t[b+15|0]=d>>>24;b=b+16|0;a=a-1|0;if(a){continue}break}}jb=c+32|0}function Hia(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=jb-80|0;jb=e;Ee(b);f=e+56|0;Ze(f,a,d);a=v[f>>2];v[113382]=0;f=T(426,f|0)|0;g=v[113382];v[113382]=0;a:{b:{c:{d:{if((g|0)==1){break d}v[113382]=0;f=T(427,f|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break d}v[113382]=0;X(428,e+8|0,3,f|0,a|0);f=v[113382];v[113382]=0;if((f|0)==1){break d}v[113382]=0;R(356,e+24|0,e+8|0);f=v[113382];v[113382]=0;if((f|0)==1){break d}v[113382]=0;U(13,e+40|0,c|0,e+24|0);c=v[113382];v[113382]=0;if((c|0)==1){break c}c=b;b=e+40|0;Gb(c,b);yb(b);yb(e+24|0);Cc(e+56|0);jb=e+80|0;a=!d|(a|0)!=0;break a}a=P()|0;O()|0;break b}a=P()|0;O()|0;yb(e+24|0)}Cc(e+56|0);S(a|0);L()}return a|0}function Qw(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=C(0);c=jb-80|0;jb=c;d=v[a>>2];e=v[d+4>>2];v[c+40>>2]=v[d+20>>2];f=v[d+16>>2];v[c+32>>2]=v[d+12>>2];v[c+36>>2]=f;Fo(c- -64|0,c+32|0,e);d=ie(c+48|0,v[v[a+4>>2]>>2],v[v[a+8>>2]>>2],v[v[a+12>>2]>>2]);e=v[v[a+12>>2]>>2];f=v[v[a+8>>2]>>2];v[c+24>>2]=v[c+72>>2];a=v[c+68>>2];v[c+16>>2]=v[c+64>>2];v[c+20>>2]=a;v[c+8>>2]=v[d+8>>2];a=v[d+4>>2];v[c>>2]=v[d>>2];v[c+4>>2]=a;h=c+16|0;a=c;if(e){while(1){d=0;if(f){while(1){i=A[fh(a,d,g)>>3];ec(b,d);j=sj(Md(i*134217728));k=Sf(h,d,g),l=C(+(j|0)*7.450580596923828e-9),z[k>>2]=l;d=d+1|0;if((f|0)!=(d|0)){continue}break}}g=g+1|0;if((e|0)!=(g|0)){continue}break}}jb=c+80|0}function u9(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;a:{e=jb-16|0;jb=e;d=c;zb(c);a=b;h=XJ(b,e+8|0);b:{f=hg(c);if(!f){break b}v[113382]=0;R(642,a|0,f|0);g=v[113382];v[113382]=0;if((g|0)!=1){g=v[d+4>>2];d=v[d>>2];v[113382]=0;X(1557,a|0,d|0,g|0,f|0);d=v[113382];v[113382]=0;if((d|0)!=1){break b}}a=P()|0;O()|0;Ft(h);S(a|0);L()}jb=e+16|0;v[b+20>>2]=v[c+20>>2];d=v[c+16>>2];v[b+12>>2]=v[c+12>>2];v[b+16>>2]=d;v[113382]=0;d=Q(1556,b+24|0,c+24|0)|0;e=v[113382];v[113382]=0;c:{d:{if((e|0)!=1){v[113382]=0;Q(120,b+36|0,c+36|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break d}v[b+48>>2]=v[c+48>>2];break a}b=P()|0;O()|0;break c}b=P()|0;O()|0;ze(d)}Ml(a);S(b|0);L()}}function _x(a){var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=jb-16|0;jb=c;if(!id(a)){m=c,n=ac(a),v[m+8>>2]=n;m=c,n=bc(a),v[m>>2]=n;if(Jb(c+8|0,c)){while(1){d=c+8|0;b=v[d>>2];Vn(b,4194304,67108864);g=v[b>>2];f=g+f|0;b=h;b=f>>>0<g>>>0?b+1|0:b;h=b;Ie(d);if(Jb(d,c)){continue}break}}b=Kb(a);g=Kb(a);m=c,n=ac(a),v[m+8>>2]=n;m=c,n=bc(a),v[m>>2]=n;b=tma(f,h,b,0);d=mb;f=g<<24;h=0;if(Jb(c+8|0,c)){g=b;d=((d&1)<<31|b>>>1)&2147483647;while(1){i=c+8|0;b=v[i>>2];j=b;e=v[b>>2];b=e>>>8|0;e=d+(e<<24)|0;b=b+k|0;b=dd(tma(e,d>>>0>e>>>0?b+1|0:b,g,l),mb);v[j>>2]=b;e=f;f=e-b|0;h=h-(b>>>0>e>>>0)|0;Ie(i);if(Jb(i,c)){continue}break}}a=Bc(a,0);v[a>>2]=f+v[a>>2]}jb=c+16|0}function IK(a,b){var c=0,d=0,e=0,f=0,g=0;f=jb-32|0;jb=f;if(v[a+4>>2]==v[b+4>>2]){c=v[a+4>>2];g=v[a>>2];v[f+24>>2]=g;v[f+28>>2]=c;d=v[b+4>>2];a=f;b=v[b>>2];v[a+16>>2]=b;v[a+20>>2]=d;v[a+8>>2]=g;v[a+12>>2]=c;v[a>>2]=b;v[a+4>>2]=d;c=jb-16|0;jb=c;d=a+8|0;v[c+12>>2]=v[d+4>>2];b=a;v[c+8>>2]=v[a+4>>2];a:{b:{if(!v[Lb(c+12|0,c+8|0)>>2]){break b}while(1){a=Ko(t[uc(d,e)|0]);g=Ko(t[uc(b,e)|0]);if((a|0)!=(g|0)){a=(a&255)>>>0<(g&255)>>>0?-1:1;break a}if(a){v[c+12>>2]=v[d+4>>2];v[c+8>>2]=v[b+4>>2];e=e+1|0;if(e>>>0>=y[Lb(c+12|0,c+8|0)>>2]){break b}continue}break}a=0;break a}a=0;if(v[d+4>>2]==v[b+4>>2]){break a}a=y[d+4>>2]<y[b+4>>2]?-1:1}jb=c+16|0;e=!a}jb=f+32|0;return e}function Ek(a,b,c,d){var e=0;v[d+8>>2]=b;v[d>>2]=0;v[d+4>>2]=0;v[c>>2]=d;if(v[v[a>>2]>>2]){v[a>>2]=v[v[a>>2]>>2]}d=v[jc(a)>>2];b=v[c>>2];c=(d|0)==(b|0);t[b+12|0]=c;a:{if(c){break a}while(1){if(w[v[b+8>>2]+12|0]){break a}e=Ag(v[b+8>>2]);c=v[b+8>>2];b:{if(e){c=v[v[c+8>>2]+4>>2];if(!(!c|w[c+12|0])){break b}if(!Ag(b)){b=v[b+8>>2];Ip(b)}b=v[b+8>>2];t[b+12|0]=1;b=v[b+8>>2];t[b+12|0]=0;Hp(b);break a}c=v[v[c+8>>2]>>2];if(!(!c|w[c+12|0])){break b}if(Ag(b)){b=v[b+8>>2];Hp(b)}b=v[b+8>>2];t[b+12|0]=1;b=v[b+8>>2];t[b+12|0]=0;Ip(b);break a}b=v[b+8>>2];t[b+12|0]=1;b=v[b+8>>2];t[b+12|0]=(b|0)==(d|0);t[c+12|0]=1;if((b|0)!=(d|0)){continue}break}}a=zb(a);v[a>>2]=v[a>>2]+1}function U8(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=jb+-64|0;jb=d;e=v[a+28>>2];zn(v[v[e>>2]-12>>2]+e|0,0);if(v[v[b>>2]+4>>2]){h=v[a+28>>2];f=v[a+12>>2];e=v[v[b>>2]+4>>2];g=e+v[a+8>>2]|0;f=Qg(d+48|0,g,g>>>0<e>>>0?f+1|0:f);g=v[f+12>>2];v[d+16>>2]=v[f+8>>2];v[d+20>>2]=g;e=v[f+4>>2];v[d+8>>2]=v[f>>2];v[d+12>>2]=e;aj(h,d+8|0)}e=d+24|0;pf(e,v[a+28>>2]);f=v[e+12>>2];v[d+40>>2]=v[e+8>>2];v[d+44>>2]=f;nb[1150](v[a+28>>2],c,v[v[b>>2]+8>>2]);c=v[b>>2];b=qm(e,uc(a+32|0,v[v[b>>2]>>2]),x[v[b>>2]+12>>1]);v[113382]=0;a=aa(1600,a|0,c|0,b|0,d+40|0)|0;c=v[113382];v[113382]=0;a:{if((c|0)!=1){Ib(b);jb=d- -64|0;break a}a=P()|0;O()|0;Ib(b);S(a|0);L()}return a|0}function RV(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=jb-32|0;jb=c;a:{b:{c:{d:{if(i=Sc(b),j=1,k=v[b+12>>2],k?i:j){bd(a);break d}e=jb-16|0;jb=e;f=_F(c+16|0,e+8|0);d=Db(b);g=cf(10152);h=Tb(b);v[113382]=0;X(165,f|0,h|0,d|0,d+g|0);d=v[113382];v[113382]=0;e:{if((d|0)!=1){v[113382]=0;W(166,f|0,10152,g|0)|0;d=v[113382];v[113382]=0;if((d|0)!=1){break e}}a=P()|0;O()|0;yb(f);S(a|0);L()}jb=e+16|0;v[113382]=0;R(204,c|0,b+12|0);b=v[113382];v[113382]=0;if((b|0)==1){break c}v[113382]=0;U(3,a|0,c+16|0,c|0);a=v[113382];v[113382]=0;if((a|0)==1){break b}yb(c);yb(c+16|0)}jb=c+32|0;return}b=P()|0;O()|0;break a}b=P()|0;O()|0;yb(c)}yb(c+16|0);S(b|0);L()}function tha(a,b){a=a|0;b=b|0;var c=0,d=0;d=jb-32|0;jb=d;sd(b,0);jP(d,a+1|0);c=d+16|0;Ec(c,d);v[113382]=0;Q(336,b+43|0,c|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){yb(d+16|0);c=a+73|0;v[b+24>>2]=w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24);c=a+54|0;v[b>>2]=w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24);c=a+58|0;v[b+4>>2]=w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24);c=a+62|0;if(w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24)){v[b+8>>2]=(w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24))+1}u[b+30>>1]=(w[a+68|0]<<1)+2;u[b+34>>1]=x[b+34>>1]&65533|w[a|0]>>>6&2;tc(b+8|0,v[b>>2]);tc(b+4|0,v[b+8>>2]);jb=d+32|0;return}a=P()|0;O()|0;yb(d+16|0);S(a|0);L()}function kP(a,b){var c=0,d=0,e=0;a:{c=jb+-64|0;jb=c;d=c+40|0;Ze(d,a,4);a=v[d>>2];v[113382]=0;d=T(426,d|0)|0;e=v[113382];v[113382]=0;b:{c:{d:{if((e|0)==1){break d}v[113382]=0;d=T(427,d|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break d}v[113382]=0;X(428,c+8|0,3,d|0,a|0);a=v[113382];v[113382]=0;if((a|0)==1){break d}v[113382]=0;R(356,c+24|0,c+8|0);a=v[113382];v[113382]=0;if((a|0)==1){break d}v[113382]=0;R(948,c|0,b|0);a=v[113382];v[113382]=0;if((a|0)==1){break c}v[113382]=0;Q(431,c|0,c+24|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break c}yb(c+24|0);Cc(c+40|0);jb=c- -64|0;break a}a=P()|0;O()|0;break b}a=P()|0;O()|0;yb(c+24|0)}Cc(c+40|0);S(a|0);L()}}function Ng(a,b){var c=C(0),d=C(0),e=C(0),f=C(0),g=C(0);d=z[a+4268>>2];f=II(a);c=C(C(z[a+4224>>2]*C(1.899999976158142))+C(.10000000149011612));e=je(C(10),C(C(C(v[((b<<2)+a|0)+4292>>2])*C(-3))/C(z[a+4268>>2]*C(C(z[a+4220>>2]*C(19.899999618530273))+C(.10000000149011612)))));c=C(C(je(e,C(C(2)-C(C(2)/c)))+C(-1))/C(C(1)-Ao(c>C(1)?C(3.1415927410125732):C(C(f*C(6.2831854820251465))/d))));a:{if(c==C(0)){break a}f=C(c+c);d=C(C(-2)-f);c=C(K(C(C(d*d)+C(C(c*c)*C(-4)))));g=C(C(c-d)/f);if(C(D(g))<=C(1)){break a}g=C(C(-C(c+d))/f)}b=(b<<3)+a|0;z[b+4404>>2]=g;z[b+4400>>2]=e;c=z[a+4272>>2];c=C(c*c);d=C(C(1)-c);e=C(e*e);return C(C(C(C(d*d)*e)/C(C(1)-C(c*e)))+c)}function Bfa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=jb-32|0;jb=e;j=v[a+24>>2];k=v[a+20>>2];l=v[a+16>>2];g=v[a+4>>2];f=g;b=v[a>>2];v[e+24>>2]=b;v[e+28>>2]=f;g=v[a+12>>2];v[e+16>>2]=v[a+8>>2];v[e+20>>2]=g;if(d){while(1){m=b>>>18|0;h=((((f&2147483647)<<1|b>>>31)&2147483646)<<1)+l|0;g=0;b=1;while(1){i=g<<1;f=u[i+h>>1];v[(e+8|0)+(g<<2)>>2]=f+((B(u[(i|4)+h>>1]-f|0,m)|0)/16384|0);f=b;b=0;g=1;if(f){continue}break}v[c>>2]=v[c>>2]+B(v[e+8>>2],k);v[c+4>>2]=v[c+4>>2]+B(v[e+12>>2],j);Sb(e+24|0,e+16|0);d=d-1|0;if(d){c=c+8|0;b=v[e+24>>2];f=v[e+28>>2];continue}break}b=v[e+24>>2];f=v[e+28>>2]}v[a>>2]=b;v[a+4>>2]=f;jb=e+32|0}function z9(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;d=mf(a);if(d>>>0<b>>>0){g=jb-32|0;jb=g;a:{b:{e=b-d|0;c:{if(e>>>0<=(v[zb(a)>>2]-v[a+4>>2]|0)/52>>>0){xx(a,e,c);break c}f=zb(a);h=cK(a,mf(a)+e|0);j=mf(a);d=0;i=jb-16|0;jb=i;v[i+12>>2]=0;b=g+8|0;Le(b+12|0,f);if(h){d=ZJ(v[b+16>>2],h)}v[b>>2]=d;f=B(j,52)+d|0;v[b+8>>2]=f;v[b+4>>2]=f;k=gc(b),l=B(h,52)+d|0,v[k>>2]=l;jb=i+16|0;v[113382]=0;U(1552,b|0,e|0,c|0);c=v[113382];v[113382]=0;if((c|0)==1){break b}v[113382]=0;R(1553,a|0,b|0);a=v[113382];v[113382]=0;if((a|0)==1){break b}VJ(b)}jb=g+32|0;break a}a=P()|0;O()|0;VJ(b);S(a|0);L()}return}if(b>>>0<d>>>0){dK(a,v[a>>2]+B(b,52)|0)}}function ZN(a,b,c){a=a|0;b=b|0;c=c|0;a:{b:{c:{d:{e:{f:{g:{h:{i:{j:{k:{l:{b=b&15;switch(b-3|0){case 2:break j;case 1:break k;case 0:break l;case 10:case 11:break b;case 9:break c;case 8:break d;case 7:break e;case 6:break f;case 5:break g;case 4:break h;case 3:break i;default:break a}}t[a+820|0]=0;return}t[a+820|0]=1;return}t[a+820|0]=2;return}t[a+820|0]=3;return}t[a+724|0]=w[a+724|0]&254;return}t[a+724|0]=w[a+724|0]|1;return}t[a+736|0]=w[a+736|0]&254;return}t[a+736|0]=w[a+736|0]|1;return}t[a+748|0]=w[a+748|0]&254;return}t[a+748|0]=w[a+748|0]|1;return}if(v[c+480180>>2]!=16777216){break a}c=a;a=w[a+748|0];t[c+748|0]=(b|0)==13?a&238|1:a|17}}function n0(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;e=jb-32|0;jb=e;a:{if(PF(c)){while(1){if(a>>>d&1){i=(d<<2)+c|0,j=QF(d,b),v[i>>2]=j}d=d+1|0;if((d|0)!=6){continue}break}break a}while(1){h=(e+8|0)+(d<<2)|0;f=1<<d&a;if(f|!c){f=QF(d,f?b:17540)}else{f=v[(d<<2)+c>>2]}v[h>>2]=f;g=((f|0)!=0)+g|0;d=d+1|0;if((d|0)!=6){continue}break}c=55248;b:{c:{switch(g|0){case 0:break a;case 1:break c;default:break b}}if(v[e+8>>2]!=55220){break b}c=55272;break a}c=kd(24);if(!c){break a}a=v[e+12>>2];v[c>>2]=v[e+8>>2];v[c+4>>2]=a;a=v[e+28>>2];v[c+16>>2]=v[e+24>>2];v[c+20>>2]=a;a=v[e+20>>2];v[c+8>>2]=v[e+16>>2];v[c+12>>2]=a}jb=e+32|0;return c|0}function Q_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0;h=jb-416|0;jb=h;d=h+416|0;v[h+12>>2]=d;c=jb-144|0;jb=c;v[c+28>>2]=c+132;i=c+32|0;iF(a+8|0,i,c+28|0,e,f,g);v[c+16>>2]=0;v[c+20>>2]=0;v[c+12>>2]=i;e=h+16|0;i=e;j=GQ(e,v[h+12>>2]);f=jb-16|0;jb=f;v[f+12>>2]=v[a+8>>2];g=Bh(f+8|0,f+12|0);v[113382]=0;a=gw(e,c+12|0,j,c+16|0);j=v[113382];v[113382]=0;a:{if((j|0)!=1){Ge(g);jb=f+16|0;break a}a=P()|0;O()|0;Ge(g);S(a|0);L()}if((a|0)==-1){mr(8547);L()}v[h+12>>2]=i+(a<<2);jb=c+144|0;c=v[h+12>>2];a=jb-16|0;jb=a;v[a+8>>2]=b;while(1){if((c|0)!=(e|0)){sF(a+8|0,v[e>>2]);e=e+4|0;continue}break}jb=a+16|0;jb=d;return v[a+8>>2]}function zaa(a,b){a=a|0;b=b|0;var c=0,d=0;b=73440;c=jb-16|0;jb=c;v[a>>2]=0;v[a+4>>2]=0;v[113382]=0;v[c+12>>2]=0;W(1486,a+8|0,c+12|0,c+8|0)|0;d=v[113382];v[113382]=0;a:{if((d|0)!=1){jb=c+16|0;break a}V(0)|0;O()|0;Ab();L()}b:{while(1){c:{if(!id(a)){if(!fi(v[b+8>>2],v[pj(a)>>2])){break c}}v[113382]=0;R(1485,a|0,b+8|0);c=v[113382];v[113382]=0;if((c|0)!=1){break c}break b}b=b+12|0;if((b|0)!=73956){continue}break}b=73968;while(1){d:{if(!id(a)){if(!fi(v[b+8>>2],v[pj(a)>>2])){break d}}v[113382]=0;R(1485,a|0,b+8|0);c=v[113382];v[113382]=0;if((c|0)!=1){break d}break b}b=b+12|0;if((b|0)!=74016){continue}break}return}b=P()|0;O()|0;Lx(a);S(b|0);L()}function Xc(a){var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;a:{d=v[a+112>>2];c=v[a+116>>2];b:{if(d|c){e=v[a+124>>2];if((c|0)<=(e|0)&d>>>0<=y[a+120>>2]|(c|0)<(e|0)){break b}}i=mw(a);if((i|0)>=0){break a}}v[a+104>>2]=0;return-1}e=a;b=v[a+116>>2];f=b;c=v[a+8>>2];d=c;g=v[a+112>>2];c:{if(!(b|g)){break c}d=c;h=v[a+120>>2]^-1;g=h+g|0;b=(v[a+124>>2]^-1)+f|0;b=g>>>0<h>>>0?b+1|0:b;h=v[a+4>>2];f=c-h|0;j=f;f=f>>31;if((f|0)<=(b|0)&g>>>0>=j>>>0|(b|0)>(f|0)){break c}d=g+h|0}v[e+104>>2]=d;e=v[a+4>>2];if(c){d=a;b=(c-e|0)+1|0;c=b+v[a+120>>2]|0;a=v[a+124>>2]+(b>>31)|0;v[d+120>>2]=c;v[d+124>>2]=c>>>0<b>>>0?a+1|0:a}a=e-1|0;if(w[a|0]!=(i|0)){t[a|0]=i}return i}function Ir(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=C(0);c=jb-80|0;jb=c;d=v[a>>2];e=v[d+4>>2];v[c+40>>2]=v[d+20>>2];f=v[d+16>>2];v[c+32>>2]=v[d+12>>2];v[c+36>>2]=f;Fo(c- -64|0,c+32|0,e);d=ie(c+48|0,v[v[a+4>>2]>>2],v[v[a+8>>2]>>2],v[v[a+12>>2]>>2]);e=v[v[a+12>>2]>>2];f=v[v[a+8>>2]>>2];v[c+24>>2]=v[c+72>>2];a=v[c+68>>2];v[c+16>>2]=v[c+64>>2];v[c+20>>2]=a;v[c+8>>2]=v[d+8>>2];a=v[d+4>>2];v[c>>2]=v[d>>2];v[c+4>>2]=a;h=c+16|0;a=c;if(e){while(1){d=0;if(f){while(1){i=v[Sf(a,d,g)>>2];ec(b,d);j=Sf(h,d,g),k=C(C(i|0)*C(7.450580596923828e-9)),z[j>>2]=k;d=d+1|0;if((f|0)!=(d|0)){continue}break}}g=g+1|0;if((e|0)!=(g|0)){continue}break}}jb=c+80|0}function V8(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=jb+-64|0;jb=e;v[e+56>>2]=d;d=v[a+28>>2];zn(v[v[d>>2]-12>>2]+d|0,0);if(v[v[b>>2]+4>>2]){h=v[a+28>>2];f=v[a+12>>2];g=v[v[b>>2]+4>>2];d=g+v[a+8>>2]|0;f=Qg(e+40|0,d,d>>>0<g>>>0?f+1|0:f);d=v[f+12>>2];v[e+8>>2]=v[f+8>>2];v[e+12>>2]=d;d=v[f+4>>2];v[e>>2]=v[f>>2];v[e+4>>2]=d;aj(h,e)}d=e+16|0;pf(d,v[a+28>>2]);f=v[d+12>>2];v[e+32>>2]=v[d+8>>2];v[e+36>>2]=f;LJ(v[a+28>>2],c,v[e+56>>2]);c=v[b>>2];b=qm(d,uc(a+32|0,v[v[b>>2]>>2]),x[v[b>>2]+12>>1]);v[113382]=0;aa(1600,a|0,c|0,b|0,e+32|0)|0;a=v[113382];v[113382]=0;if((a|0)!=1){Ib(b);jb=e- -64|0;return}a=P()|0;O()|0;Ib(b);S(a|0);L()}function T8(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=jb+-64|0;jb=e;v[e+56>>2]=d;d=v[a+28>>2];zn(v[v[d>>2]-12>>2]+d|0,0);if(v[v[b>>2]+4>>2]){h=v[a+28>>2];f=v[a+12>>2];g=v[v[b>>2]+4>>2];d=g+v[a+8>>2]|0;f=Qg(e+40|0,d,d>>>0<g>>>0?f+1|0:f);d=v[f+12>>2];v[e+8>>2]=v[f+8>>2];v[e+12>>2]=d;d=v[f+4>>2];v[e>>2]=v[f>>2];v[e+4>>2]=d;aj(h,e)}d=e+16|0;pf(d,v[a+28>>2]);f=v[d+12>>2];v[e+32>>2]=v[d+8>>2];v[e+36>>2]=f;HJ(c,v[a+28>>2],v[e+56>>2]);c=v[b>>2];b=qm(d,uc(a+32|0,v[v[b>>2]>>2]),x[v[b>>2]+12>>1]);v[113382]=0;aa(1600,a|0,c|0,b|0,e+32|0)|0;a=v[113382];v[113382]=0;if((a|0)!=1){Ib(b);jb=e- -64|0;return}a=P()|0;O()|0;Ib(b);S(a|0);L()}function hp(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;f=jb-16|0;jb=f;if(e){t[e|0]=0}i=a+484344|0;a:{if(!jg(i,b)){break a}d=Bf(Zb(i,b),c,d);g=w[d+5|0];b:{c:{d:{h=w[d+3|0];switch(h-10|0){case 2:case 4:case 7:break c;case 0:break d;default:break a}}v[f+12>>2]=2;j=0;break b}v[f+12>>2]=1;j=0;if((h|0)!=17){break b}j=v[a+480180>>2]==4}l=f,m=v[Zb(i,b)+12>>2]+(c^-1)|0,v[l+8>>2]=m;a=v[Lb(f+8|0,f+12|0)>>2];if(!a){break a}while(1){k=B(mk(Zb(i,b)),6);c=k+d|0;if(w[c+3|0]!=34){break a}h=g<<8;g=j?g>>>0<256?h+-8192|0:h:h;d=w[(d+k|0)+5|0];a=a-1|0;if(e){t[e|0]=1}g=d|g;d=c;if(a){continue}break}}jb=f+16|0;return g|0}function vla(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;d=jb-32|0;jb=d;sd(b,0);uh(d,1,a);c=d+16|0;Ec(c,d);v[113382]=0;Q(336,b+43|0,c|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){e=d+16|0;yb(e);c=a+32|0;v[b+24>>2]=w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24);c=a+13|0;u[b+34>>1]=x[b+34>>1]&65533|(w[c|0]|w[c+1|0]<<8)<<1&2;c=a+16|0;v[b>>2]=w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24);c=a+20|0;v[b+4>>2]=w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24);c=a+24|0;v[b+8>>2]=w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24);t[d+16|0]=w[a+15|0];t[d|0]=64;f=b,g=w[pc(e,d)|0]<<2,u[f+30>>1]=g;jb=d+32|0;return}a=P()|0;O()|0;yb(d+16|0);S(a|0);L()}function qi(a,b,c,d){var e=0,f=0,g=0;v[a+20>>2]=d;v[a+16>>2]=c;v[a+12>>2]=b;v[a+4>>2]=0;v[a+8>>2]=0;v[a>>2]=74912;c=a+24|0;v[c>>2]=0;v[c+4>>2]=0;v[c+16>>2]=0;v[c+8>>2]=0;v[c+12>>2]=0;b=a+44|0;e=jJ(b);f=jJ(b+12|0);g=iJ(b+24|0);d=iJ(b+36|0);v[113382]=0;W(1609,b|0,2,0)|0;b=v[113382];v[113382]=0;if((b|0)==1){a=P()|0;O()|0;bs(d);bs(g);as(f);as(e);S(a|0);L()}v[a+4196>>2]=1065353216;v[a+4200>>2]=0;b=0;u[a+4204>>1]=0;e=v[a+16>>2];v[e+946300>>2]=v[e+946300>>2]+1;v[c>>2]=a+99&-8;f=v[a+20>>2];if((f|0)!=(e+906300|0)){g=a+4200|0;while(1){c=b+1|0;if((f|0)!=((e+B(c,160)|0)+906300|0)){d=b>>>0<248;b=c;if(d){continue}}break}t[g|0]=c}return a}function Cfa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;e=jb-32|0;jb=e;i=v[a+24>>2];j=v[a+20>>2];k=v[a+16>>2];b=v[a+4>>2];f=v[a>>2];v[e+24>>2]=f;v[e+28>>2]=b;g=v[a+12>>2];v[e+16>>2]=v[a+8>>2];v[e+20>>2]=g;if(d){while(1){l=f>>>10&4194048;h=(((b&2147483647)<<1|f>>>31)&-2)+k|0;g=0;b=1;while(1){f=t[g+h|0];v[(e+8|0)+(g<<2)>>2]=((B(t[(g|2)+h|0]-f|0,l)|0)/16384|0)+(f<<8);f=b;b=0;g=1;if(f){continue}break}v[c>>2]=v[c>>2]+B(v[e+8>>2],j);v[c+4>>2]=v[c+4>>2]+B(v[e+12>>2],i);Sb(e+24|0,e+16|0);d=d-1|0;if(d){c=c+8|0;f=v[e+24>>2];b=v[e+28>>2];continue}break}f=v[e+24>>2];b=v[e+28>>2]}v[a>>2]=f;v[a+4>>2]=b;jb=e+32|0}function Afa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;b=jb-16|0;jb=b;g=v[a+40>>2];h=v[a+36>>2];l=v[a+16>>2];f=v[a+4>>2];e=f;i=v[a>>2];v[b+8>>2]=i;v[b+12>>2]=e;f=v[a+12>>2];v[b>>2]=v[a+8>>2];v[b+4>>2]=f;a:{if(d){while(1){j=v[a+32>>2];k=e+l|0;e=t[k|0];h=v[a+28>>2]+h|0;f=h>>12;e=((B(t[k+1|0]-e|0,i>>>10&4194048)|0)/16384|0)+(e<<8)|0;v[c>>2]=v[c>>2]+B(f,e);g=g+j|0;j=g>>12;v[c+4>>2]=v[c+4>>2]+B(e,j);Sb(b+8|0,b);d=d-1|0;if(d){c=c+8|0;i=v[b+8>>2];e=v[b+12>>2];continue}break}i=v[b+8>>2];e=v[b+12>>2];break a}j=g>>12;f=h>>12}v[a+40>>2]=g;v[a+20>>2]=f;v[a+36>>2]=h;v[a+24>>2]=j;v[a>>2]=i;v[a+4>>2]=e;jb=b+16|0}function YG(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;e=jb-16|0;jb=e;a:{b:{c:{d=a+8|0;d:{if(!ol(d)){if((b|0)<0|(Rr(d)|0)<=(b|0)){break d}a=yp(v[a+32>>2],b+1&65535);u[a+34>>1]=x[a+34>>1]&64511|(c?1024:0);break b}d=ol(d);if((b|0)<0){break d}if((b|0)<(d|0)){break c}}a=ba(8)|0;v[113382]=0;c=Q(121,e|0,2427)|0;b=v[113382];v[113382]=0;e:{if((b|0)!=1){nc(a,c);v[113382]=0;U(1978,a|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break a}b=P()|0;O()|0;yb(c);break e}b=P()|0;O()|0;ca(a|0)}S(b|0);L()}b=b+1<<2;a=a+32|0;if(!v[(b+v[a>>2]|0)+900380>>2]){break b}a=v[(b+v[a>>2]|0)+900380>>2];t[a+15|0]=w[a+15|0]&253|(c?2:0)}jb=e+16|0;return}L()}function l$(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=jb-48|0;jb=f;v[f+40>>2]=b;a:{if(!(v[c+4>>2]&1)){c=nb[v[v[a>>2]+24>>2]](a,b,c,d,e)|0;break a}a=f+24|0;Ac(a,c);v[113382]=0;a=T(2340,a|0)|0;b=v[113382];v[113382]=0;b:{if((b|0)!=1){Ob(f+24|0);c:{if(e){dh(f+24|0,a);break c}ch(f+24|0,a)}g=f,h=Bd(f+24|0),v[g+16>>2]=h;while(1){g=f,h=Yj(f+24|0),v[g+8>>2]=h;if(!Jb(f+16|0,f+8|0)){c=v[f+40>>2];Jc(f+24|0);break a}a=v[v[f+16>>2]>>2];v[113382]=0;Q(2364,f+40|0,a|0)|0;a=v[113382];v[113382]=0;if((a|0)!=1){Ie(f+16|0);continue}break}c=P()|0;O()|0;Jc(f+24|0);break b}c=P()|0;O()|0;Ob(f+24|0)}S(c|0);L()}jb=f+48|0;return c|0}function cba(a){a=a|0;var b=0,c=0,d=0;c=a+1304360|0;b=a+1074984|0;while(1){v[b+104>>2]=0;v[b+656>>2]=0;v[b+76>>2]=0;v[b+16>>2]=0;b=b+896|0;if((c|0)!=(b|0)){continue}break}eK(a+484344|0);Ee(a+1304400|0);Ee(a+1304412|0);Ee(a+1304424|0);uA(a+1304500|0);c=a+900380|0;b=a+484380|0;while(1){ln(b);b=b+104|0;if((c|0)!=(b|0)){continue}break}c=a+901404|0;b=a+900380|0;while(1){d=v[b>>2];if(d){Wb(vt(d))}v[b>>2]=0;b=b+4|0;if((c|0)!=(b|0)){continue}break}c=a+946300|0;b=a+906300|0;while(1){bJ(b);b=b+160|0;if((c|0)!=(b|0)){continue}break}v[a+480180>>2]=0;v[a+480184>>2]=0;a=a+480186|0;u[a>>1]=0;u[a+2>>1]=0;u[a+4>>1]=0;u[a+6>>1]=0;return 1}function zfa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;b=jb-16|0;jb=b;g=v[a+40>>2];h=v[a+36>>2];l=v[a+16>>2];f=v[a+4>>2];e=f;i=v[a>>2];v[b+8>>2]=i;v[b+12>>2]=e;f=v[a+12>>2];v[b>>2]=v[a+8>>2];v[b+4>>2]=f;a:{if(d){while(1){j=v[a+32>>2];k=(e<<1)+l|0;e=u[k>>1];h=v[a+28>>2]+h|0;f=h>>12;e=e+((B(u[k+2>>1]-e|0,i>>>18|0)|0)/16384|0)|0;v[c>>2]=v[c>>2]+B(f,e);g=g+j|0;j=g>>12;v[c+4>>2]=v[c+4>>2]+B(e,j);Sb(b+8|0,b);d=d-1|0;if(d){c=c+8|0;i=v[b+8>>2];e=v[b+12>>2];continue}break}i=v[b+8>>2];e=v[b+12>>2];break a}j=g>>12;f=h>>12}v[a+40>>2]=g;v[a+20>>2]=f;v[a+36>>2]=h;v[a+24>>2]=j;v[a>>2]=i;v[a+4>>2]=e;jb=b+16|0}function sW(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0;l=jb-32|0;jb=l;n=v[c>>2];m=v[c+8>>2];k=l;c=v[c+4>>2];v[k+8>>2]=c;v[k+12>>2]=m;v[113382]=0;v[k+24>>2]=c;v[k+28>>2]=m;v[k+20>>2]=n;v[k+16>>2]=d;c=v[k+20>>2];v[k>>2]=v[k+16>>2];v[k+4>>2]=c;a=Ka(1976,a|0,b|0,k|0)|0;b=v[113382];v[113382]=0;a:{b:{if((b|0)==1){a=V(0)|0;O()|0;_(a|0)|0;v[113382]=0;ja(1969,6503,e|0,f|0,g|0,h|0,i|0,j|0);a=v[113382];v[113382]=0;if((a|0)==1){break b}$();a=-255}jb=l+32|0;break a}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}return a|0}function x$(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=jb-48|0;jb=f;v[f+40>>2]=b;a:{if(!(v[c+4>>2]&1)){c=nb[v[v[a>>2]+24>>2]](a,b,c,d,e)|0;break a}a=f+24|0;Ac(a,c);v[113382]=0;a=T(2306,a|0)|0;b=v[113382];v[113382]=0;b:{if((b|0)!=1){Ob(f+24|0);c:{if(e){dh(f+24|0,a);break c}ch(f+24|0,a)}g=f,h=Bd(f+24|0),v[g+16>>2]=h;while(1){g=f,h=tf(f+24|0),v[g+8>>2]=h;if(!Jb(f+16|0,f+8|0)){c=v[f+40>>2];yb(f+24|0);break a}a=t[v[f+16>>2]];v[113382]=0;Q(2355,f+40|0,a|0)|0;a=v[113382];v[113382]=0;if((a|0)!=1){xg(f+16|0);continue}break}c=P()|0;O()|0;yb(f+24|0);break b}c=P()|0;O()|0;Ob(f+24|0)}S(c|0);L()}jb=f+48|0;return c|0}function eU(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;d=jb-32|0;jb=d;sd(b,0);uh(d,1,a+33|0);c=d+16|0;Ec(c,d);v[113382]=0;Q(336,b+43|0,c|0)|0;c=v[113382];v[113382]=0;a:{b:{if((c|0)!=1){c=d+16|0;yb(c);e=a+50|0;v[b>>2]=w[e|0]|w[e+1|0]<<8;e=a+52|0;v[b+24>>2]=w[e|0]|w[e+1|0]<<8;t[d+16|0]=w[a+54|0];t[d|0]=64;f=b,g=w[pc(c,d)|0]<<2,u[f+30>>1]=g;c=a+55|0;v[b+4>>2]=w[c|0]|w[c+1|0]<<8;c=a+57|0;c=w[c|0]|w[c+1|0]<<8;v[b+8>>2]=c;if((c|0)!=65535){break b}v[b+4>>2]=0;v[b+8>>2]=0;break a}a=P()|0;O()|0;yb(d+16|0);S(a|0);L()}if(!w[a|0]){break a}a=v[b+8>>2];if(a>>>0<=v[b+4>>2]+2>>>0|a>>>0>y[b>>2]){break a}u[b+34>>1]=x[b+34>>1]|2}jb=d+32|0}function Sja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;e=jb-32|0;jb=e;d=jb-16|0;jb=d;v[a>>2]=0;v[a+4>>2]=0;v[113382]=0;v[d+12>>2]=0;W(734,a+8|0,d+12|0,d+8|0)|0;f=v[113382];v[113382]=0;a:{if((f|0)!=1){jb=d+16|0;break a}V(0)|0;O()|0;Ab();L()}d=a;b:{c:{d:{e:{while(1){v[113382]=0;a=Q(228,b|0,6)|0;f=v[113382];v[113382]=0;if((f|0)==1){break c}if(!a){break d}v[113382]=0;U(719,e+8|0,b|0,c|0);a=v[113382];v[113382]=0;if((a|0)!=1){v[113382]=0;R(720,d|0,e+8|0);a=v[113382];v[113382]=0;if((a|0)==1){break e}lf(e+8|0);continue}break}a=P()|0;O()|0;break b}a=P()|0;O()|0;lf(e+8|0);break b}jb=e+32|0;return}a=P()|0;O()|0}Pz(d);S(a|0);L()}
function Nga(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=jb+-64|0;jb=d;e=d+40|0;Ze(e,a,c);a=v[e>>2];v[113382]=0;e=T(426,e|0)|0;f=v[113382];v[113382]=0;a:{b:{c:{d:{if((f|0)==1){break d}v[113382]=0;e=T(427,e|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break d}v[113382]=0;X(428,d+8|0,2,e|0,a|0);e=v[113382];v[113382]=0;if((e|0)==1){break d}v[113382]=0;R(356,d+24|0,d+8|0);e=v[113382];v[113382]=0;if((e|0)==1){break d}v[113382]=0;Q(336,b|0,d+24|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break c}yb(d+24|0);Cc(d+40|0);jb=d- -64|0;a=!c|(a|0)!=0;break a}a=P()|0;O()|0;break b}a=P()|0;O()|0;yb(d+24|0)}Cc(d+40|0);S(a|0);L()}return a|0}function Jla(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=jb+-64|0;jb=d;e=d+40|0;Ze(e,a,c);a=v[e>>2];v[113382]=0;e=T(426,e|0)|0;f=v[113382];v[113382]=0;a:{b:{c:{d:{if((f|0)==1){break d}v[113382]=0;e=T(427,e|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break d}v[113382]=0;X(428,d+8|0,3,e|0,a|0);e=v[113382];v[113382]=0;if((e|0)==1){break d}v[113382]=0;R(356,d+24|0,d+8|0);e=v[113382];v[113382]=0;if((e|0)==1){break d}v[113382]=0;Q(336,b|0,d+24|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break c}yb(d+24|0);Cc(d+40|0);jb=d- -64|0;a=!c|(a|0)!=0;break a}a=P()|0;O()|0;break b}a=P()|0;O()|0;yb(d+24|0)}Cc(d+40|0);S(a|0);L()}return a|0}function Jka(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=jb+-64|0;jb=d;e=d+40|0;Ze(e,a,c);a=v[e>>2];v[113382]=0;e=T(426,e|0)|0;f=v[113382];v[113382]=0;a:{b:{c:{d:{if((f|0)==1){break d}v[113382]=0;e=T(427,e|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break d}v[113382]=0;X(428,d+8|0,2,e|0,a|0);e=v[113382];v[113382]=0;if((e|0)==1){break d}v[113382]=0;R(356,d+24|0,d+8|0);e=v[113382];v[113382]=0;if((e|0)==1){break d}v[113382]=0;Q(344,b|0,d+24|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break c}yb(d+24|0);Cc(d+40|0);jb=d- -64|0;a=!c|(a|0)!=0;break a}a=P()|0;O()|0;break b}a=P()|0;O()|0;yb(d+24|0)}Cc(d+40|0);S(a|0);L()}return a|0}function EV(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;e=jb-48|0;jb=e;f=Tb(b);g=Db(b);i=Tb(c);j=Db(c);h=-1;a:{if(!g){break a}d=f;g=g+d|0;while(1){if(Xn(i,j,d)){d=d+1|0;if((g|0)!=(d|0)){continue}break a}break}h=d-f|0}b:{c:{if((h|0)!=-1){k=e,l=Bd(b),v[k+32>>2]=l;c=Hd(e+40|0,e+32|0);k=e,l=Bd(b),v[k+8>>2]=l;k=e,l=ff(e+8|0,h),v[k+16>>2]=l;d=Hd(e+24|0,e+16|0);ix(b,v[c>>2],v[d>>2]);break c}if(!Db(b)){break c}f=Tb(b);h=Db(b);g=Tb(c);d=-1;i=Db(c);if(i){c=f+h|0;d:{while(1){if((c|0)==(f|0)){break d}c=c-1|0;if(!Xn(g,i,c)){continue}break}d=c-f|0}}if((Db(b)-1|0)!=(d|0)){break c}bd(a);break b}rd(a,b)}jb=e+48|0}function uG(a,b,c,d,e){var f=0,g=0,h=0,i=0;f=jb-208|0;jb=f;v[f+204>>2]=c;c=f+160|0;Qb(c,0,40);v[f+200>>2]=v[f+204>>2];a:{if((yw(0,b,f+200|0,f+80|0,c,d,e)|0)<0){b=-1;break a}h=v[a+76>>2]>=0;c=v[a>>2];if(t[a+74|0]<=0){v[a>>2]=c&-33}i=c&32;b:{if(v[a+48>>2]){b=yw(a,b,f+200|0,f+80|0,f+160|0,d,e);break b}v[a+48>>2]=80;g=f+80|0;v[a+16>>2]=g;v[a+28>>2]=f;v[a+20>>2]=f;c=v[a+44>>2];v[a+44>>2]=f;d=yw(a,b,f+200|0,g,f+160|0,d,e);b=d;if(!c){break b}nb[v[a+36>>2]](a,0,0)|0;v[a+48>>2]=0;v[a+44>>2]=c;v[a+28>>2]=0;v[a+16>>2]=0;b=v[a+20>>2];v[a+20>>2]=0;b=b?d:-1}c=a;a=v[a>>2];v[c>>2]=a|i;b=a&32?-1:b;if(!h){break a}}jb=f+208|0;return b}function rla(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;e=jb-32|0;jb=e;d=jb-16|0;jb=d;v[a>>2]=0;v[a+4>>2]=0;v[113382]=0;v[d+12>>2]=0;W(569,a+8|0,d+12|0,d+8|0)|0;f=v[113382];v[113382]=0;a:{if((f|0)!=1){jb=d+16|0;break a}V(0)|0;O()|0;Ab();L()}d=a;b:{c:{d:{e:{while(1){v[113382]=0;a=Q(228,b|0,8)|0;f=v[113382];v[113382]=0;if((f|0)==1){break c}if(!a){break d}v[113382]=0;U(561,e+8|0,b|0,c|0);a=v[113382];v[113382]=0;if((a|0)!=1){v[113382]=0;R(562,d|0,e+8|0);a=v[113382];v[113382]=0;if((a|0)==1){break e}lf(e+8|0);continue}break}a=P()|0;O()|0;break b}a=P()|0;O()|0;lf(e+8|0);break b}jb=e+32|0;return}a=P()|0;O()|0}kA(d);S(a|0);L()}function cj(a,b,c){var d=0,e=0,f=0,g=0,h=0;d=jb-32|0;jb=d;t[a|0]=0;f=Jf(v[v[b>>2]-12>>2]+b|0);e=v[v[b>>2]-12>>2]+b|0;a:{b:{if(f){if(v[e+72>>2]){br(v[(v[v[b>>2]-12>>2]+b|0)+72>>2])}c:{if(!(v[(v[v[b>>2]-12>>2]+b|0)+4>>2]&4096)|c){break c}c=d+24|0;Ac(c,v[v[b>>2]-12>>2]+b|0);v[113382]=0;f=T(21,c|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break a}Ob(d+24|0);c=tm(d+16|0,b);e=Ik(d+8|0);while(1){d:{if(!wo(c,e)){break d}if(!Lg(f,8192,ck(c))){break d}fl(c);continue}break}if(!gj(c,e)){break c}Eg(v[v[b>>2]-12>>2]+b|0,6)}g=a,h=Jf(v[v[b>>2]-12>>2]+b|0),t[g|0]=h;break b}Eg(e,4)}jb=d+32|0;return a}a=P()|0;O()|0;Ob(d+24|0);S(a|0);L()}function _S(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=jb+-64|0;jb=d;e=d+40|0;Ze(e,a,c);a=v[e>>2];v[113382]=0;e=T(426,e|0)|0;f=v[113382];v[113382]=0;a:{b:{c:{d:{if((f|0)==1){break d}v[113382]=0;e=T(427,e|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break d}v[113382]=0;X(428,d+8|0,2,e|0,a|0);e=v[113382];v[113382]=0;if((e|0)==1){break d}v[113382]=0;R(356,d+24|0,d+8|0);e=v[113382];v[113382]=0;if((e|0)==1){break d}v[113382]=0;Q(335,b|0,d+24|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break c}yb(d+24|0);Cc(d+40|0);jb=d- -64|0;a=!c|(a|0)!=0;break a}a=P()|0;O()|0;break b}a=P()|0;O()|0;yb(d+24|0)}Cc(d+40|0);S(a|0);L()}return a|0}function Nfa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;b=jb-16|0;jb=b;h=v[a+40>>2];i=v[a+36>>2];k=v[a+16>>2];e=v[a+4>>2];f=e;g=v[a>>2];v[b+8>>2]=g;v[b+12>>2]=e;e=v[a+12>>2];v[b>>2]=v[a+8>>2];v[b+4>>2]=e;a:{if(d){while(1){f=((((f&2147483647)<<1|g>>>31)&2147483646)<<1)+k|0;g=u[f+2>>1];j=v[a+32>>2];i=v[a+28>>2]+i|0;e=i>>12;v[c>>2]=v[c>>2]+B(e,u[f>>1]);h=h+j|0;j=h>>12;v[c+4>>2]=v[c+4>>2]+B(g,j);Sb(b+8|0,b);d=d-1|0;if(d){c=c+8|0;g=v[b+8>>2];f=v[b+12>>2];continue}break}g=v[b+8>>2];f=v[b+12>>2];break a}j=h>>12;e=i>>12}v[a+40>>2]=h;v[a+20>>2]=e;v[a+36>>2]=i;v[a+24>>2]=j;v[a>>2]=g;v[a+4>>2]=f;jb=b+16|0}function K4(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=jb-32|0;jb=c;v[113382]=0;Z(1984,a|0);d=v[113382];v[113382]=0;a:{b:{c:{if((d|0)==1){break c}v[113382]=0;Z(2010,b|0);d=v[113382];v[113382]=0;if((d|0)==1){break c}d=v[a+24>>2];b=qc(c+8|0,b);v[113382]=0;e=v[b+4>>2];v[c>>2]=v[b>>2];v[c+4>>2]=e;X(2049,c+16|0,d|0,c|0,1);b=v[113382];v[113382]=0;if((b|0)==1){break c}a=c+16|0;b=Ud(Tb(a));yb(a);break b}b=V(0)|0;O()|0;_(b|0)|0;b=0;v[113382]=0;X(1958,2021,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$()}jb=c+32|0;return b|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function tT(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;e=jb-32|0;jb=e;d=jb-16|0;jb=d;v[a>>2]=0;v[a+4>>2]=0;v[113382]=0;v[d+12>>2]=0;W(494,a+8|0,d+12|0,d+8|0)|0;f=v[113382];v[113382]=0;a:{if((f|0)!=1){jb=d+16|0;break a}V(0)|0;O()|0;Ab();L()}d=a;b:{c:{d:{e:{while(1){v[113382]=0;a=Q(228,b|0,8)|0;f=v[113382];v[113382]=0;if((f|0)==1){break c}if(!a){break d}v[113382]=0;U(474,e+8|0,b|0,c|0);a=v[113382];v[113382]=0;if((a|0)!=1){v[113382]=0;R(475,d|0,e+8|0);a=v[113382];v[113382]=0;if((a|0)==1){break e}lf(e+8|0);continue}break}a=P()|0;O()|0;break b}a=P()|0;O()|0;lf(e+8|0);break b}jb=e+32|0;return}a=P()|0;O()|0}AA(d);S(a|0);L()}function qW(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=jb-16|0;jb=e;v[113382]=0;Z(1984,a|0);f=v[113382];v[113382]=0;a:{b:{c:{d:{if((f|0)==1){break d}v[113382]=0;Z(2010,b|0);f=v[113382];v[113382]=0;if((f|0)==1){break d}f=v[a+24>>2];b=qc(e+8|0,b);v[113382]=0;g=v[b+4>>2];v[e>>2]=v[b>>2];v[e+4>>2]=g;Ia(2052,f|0,e|0,c|0,d|0,1);c=v[113382];v[113382]=0;b=1;if((c|0)!=1){break c}}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,4887,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break b}$();b=0}jb=e+16|0;break a}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}return b|0}function UN(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;d=jb-16|0;jb=d;f=jb-16|0;jb=f;g=f+8|0;c=jb-16|0;jb=c;v[113382]=0;e=a;T(1128,a+4|0)|0;a=v[113382];v[113382]=0;a:{b:{c:{if((a|0)!=1){v[113382]=0;v[c+12>>2]=0;W(1129,e+8|0,c+12|0,g|0)|0;a=v[113382];v[113382]=0;if((a|0)!=1){break c}break b}break b}h=e,i=jc(e),v[h>>2]=i;jb=c+16|0;break a}V(0)|0;O()|0;Ab();L()}jb=f+16|0;a=b+236|0;b=bt(a);d:{if((a|0)!=(b|0)){while(1){c=x[a>>1];u[d+14>>1]=c;if(c){v[113382]=0;U(1127,d|0,e|0,d+14|0);c=v[113382];v[113382]=0;if((c|0)==1){break d}}a=a+2|0;if((b|0)!=(a|0)){continue}break}}jb=d+16|0;return}a=P()|0;O()|0;Dp(e);S(a|0);L()}function tp(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0,k=0;f=jb-16|0;jb=f;g=Kb(a)-1|0;a:{if((Kb(a)|0)==1){break a}while(1){if(x[Bc(a,e)>>1]>=(b|0)){g=e;break a}e=e+1|0;if(e>>>0<Kb(a)-1>>>0){continue}break}}h=x[Bc(a,g)>>1];v[f+12>>2]=0;b:{if((b|0)>=(h|0)){j=f,k=(w[Bc(a,g)+2|0]<<16)/(d|0)|0,v[j+12>>2]=k;break b}e=0;if(g){e=g-1|0;i=(w[Bc(a,e)+2|0]<<16)/(d|0)|0;v[f+12>>2]=i;e=x[Bc(a,e)>>1]}if((b|0)<=(e|0)|e>>>0>=h>>>0){break b}a=((w[Bc(a,g)+2|0]<<16)/(d|0)|0)-i|0;d=a;g=a>>31;a=b-e|0;b=qma(d,g,a,a>>31);a=h-e|0;j=f,k=zc(rma(b,mb,a,a>>31),mb)+i|0,v[j+12>>2]=k}Yd(f+12|0,0,65536);jb=f+16|0;return(B(v[f+12>>2],c)+32768|0)/65536|0}function PS(a,b,c,d,e){var f=0,g=0,h=0,i=0,j=0,k=0;a:{if(!d){break a}i=w[e|0];if(!i|!b){break a}g=d-6|0;j=35>>>g&(g&255)>>>0<6;h=B(c,-6);k=(d-2&255)>>>0>2;while(1){g=a+h|0;f=w[g+3|0];b:{if(!((f-2&255)>>>0>2|k)){c=1;if(w[(a+h|0)+5|0]<224){break b}break a}c=(d|0)==(f|0);if(!(1<<f&2240)|(!j|f>>>0>11)){break b}c=1}c:{if(k){break c}f=a+h|0;if((w[f+2|0]-11&255)>>>0>2){break c}if(w[f+4|0]){break a}}d:{if(!j){break d}f=a+h|0;if((w[f+2|0]-3&255)>>>0>3){break d}if(w[f+4|0]){break a}}e:{if(!c){break e}c=i;a=w[(a+h|0)+5|0];if(a?(c|0)!=(a|0):0){break a}if((a|0)!=(c|0)){break e}t[e|0]=0;return}a=g;b=b-1|0;if(b){continue}break}}}function $L(a,b,c){var d=0,e=0;a:{if(v[a+480180>>2]==4){d=w[b+834|0];if(c){t[b+834|0]=d&15|c<<4;break a}c=(d&240)>>>4|0;break a}if(v[a+480180>>2]!=1048576){break a}if(c){t[b+833|0]=c;break a}c=w[b+833|0]}b:{if(!(t[b+872|0]&1)){break b}d=v[b+700>>2];if(!d|!(c&255)){break b}c:{if(!(w[a+480208|0]&16)){break c}d=v[b+700>>2];if(v[a+480180>>2]==4){break c}e=b;a=TL(a,c&15);b=qma(a,a>>31,d,d>>31)+32768|0;a=mb;a=zc(rma(b,b>>>0<32768?a+1|0:a,65536,0),mb);v[e+700>>2]=((a|0)==(d|0))+a;return}c=d-(c&255)|0;v[b+700>>2]=c;if((c|0)>0){break b}v[b+700>>2]=1;if(v[a+480180>>2]!=2){break b}v[b+696>>2]=0;v[b+88>>2]=v[b+88>>2]|2101248}}function JF(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=jb-16|0;jb=d;jb=d+16|0;e=0;a:{if(!b){break a}b:{if(!c){break b}a=a?a:d+12|0;d=w[b|0];e=d<<24>>24;if((e|0)>=0){v[a>>2]=d;e=(e|0)!=0;break a}d=t[b|0];if(!v[v[113364]>>2]){v[a>>2]=d&57343;e=1;break a}d=(d&255)-194|0;if(d>>>0>50){break b}d=v[(d<<2)+54992>>2];if(d<<B(c,6)-6<0&c>>>0<=3){break b}c=w[b+1|0];e=c>>>3|0;if((e-16|e+(d>>26))>>>0>7){break b}c=c-128|d<<6;if((c|0)>=0){v[a>>2]=c;e=2;break a}d=w[b+2|0]-128|0;if(d>>>0>63){break b}c=d|c<<6;if((c|0)>=0){v[a>>2]=c;e=3;break a}b=w[b+3|0]-128|0;if(b>>>0>63){break b}v[a>>2]=b|c<<6;e=4;break a}v[113305]=25;e=-1}return e|0}function il(a,b,c,d,e,f,g,h){var i=0,j=0,k=0,l=0,m=0,n=0,o=0;k=1;j=d&2147483647;n=j;i=(j|0)==2147418112;l=c;a:{if(i&!c?a|b:i&(c|0)!=0|j>>>0>2147418112){break a}i=h&2147483647;o=i;m=(i|0)==2147418112;j=g;if(m&!g?e|f:m&(g|0)!=0|i>>>0>2147418112){break a}if(!(a|e|(j|l)|(b|f|(n|o)))){return 0}l=d&h;if((l|0)>0|(l|0)>=0){k=-1;if((c|0)==(g|0)&(d|0)==(h|0)?(b|0)==(f|0)&a>>>0<e>>>0|b>>>0<f>>>0:c>>>0<g>>>0&(d|0)<=(h|0)|(d|0)<(h|0)){break a}return(a^e|c^g)!=0|(b^f|d^h)!=0}k=-1;if((c|0)==(g|0)&(d|0)==(h|0)?(b|0)==(f|0)&a>>>0>e>>>0|b>>>0>f>>>0:c>>>0>g>>>0&(d|0)>=(h|0)|(d|0)>(h|0)){break a}k=(a^e|c^g)!=0|(b^f|d^h)!=0}return k}function gQ(a,b,c,d,e,f,g){var h=0,i=0,j=0,k=0,l=0,m=0,n=0;while(1){m=x[rc(b,l)>>1];n=m+1|0;i=(h&65535)>>>0>m>>>0|m>>>0>127;j=i?j:c>>>0>l>>>0?n:j;k=(k&65535)>>>0>m>>>0?k:n;h=i?h:n;l=l+1|0;if((l|0)!=128){continue}break}lg(b,c);i=v[a+8>>2];a:{b:{c:{if(!f){break c}c=h&65535;if((i+((c<<11)+f|0)|0)!=(Kj(a)&-2)){break c}Nc(a,i+(c<<10)|0);if(!uz(a,16,1)){break b}u[e>>1]=8;break b}if(!g|(h&65535)==(j&65535)){break a}Nc(a,i+((j&65535)<<10)|0);h=uz(a,64,1)?h:j}Nc(a,i)}c=k&65535;d:{if(c>>>0>(h&65535)>>>0){if(((d+i|0)+(B(c,x[e>>1])<<8)|0)==(Kj(a)|0)){break d}}if(c>>>0>=255){tz(b,254,65534);tz(b,255,65535)}k=h}return k&65535}function GN(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;a:{b=jb-16|0;jb=b;g=b;d=jb-144|0;jb=d;e=li(d+8|0);f=v[v[e>>2]-12>>2];v[113382]=0;h=da(123)|0;i=v[113382];v[113382]=0;b:{c:{if((i|0)==1){break c}v[113382]=0;U(124,d|0,f+(d+8|0)|0,h|0);f=v[113382];v[113382]=0;if((f|0)==1){break c}Ob(d);v[113382]=0;R(132,e|0,c|0);c=v[113382];v[113382]=0;if((c|0)==1){break c}v[113382]=0;R(126,g|0,e|0);c=v[113382];v[113382]=0;if((c|0)==1){break c}Td(e);jb=d+144|0;break b}a=P()|0;O()|0;Td(e);S(a|0);L()}v[113382]=0;U(13,a|0,0,b|0);a=v[113382];v[113382]=0;if((a|0)!=1){yb(b);jb=b+16|0;break a}a=P()|0;O()|0;yb(b);S(a|0);L()}}function Ofa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;b=jb-16|0;jb=b;h=v[a+40>>2];i=v[a+36>>2];k=v[a+16>>2];e=v[a+4>>2];f=e;g=v[a>>2];v[b+8>>2]=g;v[b+12>>2]=e;e=v[a+12>>2];v[b>>2]=v[a+8>>2];v[b+4>>2]=e;a:{if(d){while(1){f=(((f&2147483647)<<1|g>>>31)&-2)+k|0;g=t[f+1|0];j=v[a+32>>2];i=v[a+28>>2]+i|0;e=i>>12;v[c>>2]=v[c>>2]+(B(e,t[f|0])<<8);h=h+j|0;j=h>>12;v[c+4>>2]=v[c+4>>2]+(B(g,j)<<8);Sb(b+8|0,b);d=d-1|0;if(d){c=c+8|0;g=v[b+8>>2];f=v[b+12>>2];continue}break}g=v[b+8>>2];f=v[b+12>>2];break a}j=h>>12;e=i>>12}v[a+40>>2]=h;v[a+20>>2]=e;v[a+36>>2]=i;v[a+24>>2]=j;v[a>>2]=g;v[a+4>>2]=f;jb=b+16|0}function Xga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;f=jb-80|0;jb=f;Bi(f+40|0,f+32|0,c);v[113382]=0;U(210,f+52|0,f+24|0,d|0);d=v[113382];v[113382]=0;c=1;a:{b:{c:{d:{if((d|0)!=1){v[113382]=0;U(194,f- -64|0,f+16|0,e|0);c=v[113382];v[113382]=0;if((c|0)==1){break d}v[113382]=0;R(211,f+8|0,f+40|0);c=v[113382];v[113382]=0;if((c|0)==1){break b}v[113382]=0;U(72,a|0,b|0,f+8|0);a=v[113382];v[113382]=0;if((a|0)==1){break b}mm(f+40|0);jb=f+80|0;return}d=P()|0;O()|0;break c}d=P()|0;O()|0;c=2}c=(f+40|0)+B(c,12)|0;while(1){c=yb(c-12|0);if((c|0)!=(f+40|0)){continue}break}break a}d=P()|0;O()|0;mm(f+40|0)}S(d|0);L()}function Wka(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;f=jb-80|0;jb=f;Bi(f+40|0,f+32|0,c);v[113382]=0;U(194,f+52|0,f+24|0,d|0);d=v[113382];v[113382]=0;c=1;a:{b:{c:{d:{if((d|0)!=1){v[113382]=0;U(194,f- -64|0,f+16|0,e|0);c=v[113382];v[113382]=0;if((c|0)==1){break d}v[113382]=0;R(211,f+8|0,f+40|0);c=v[113382];v[113382]=0;if((c|0)==1){break b}v[113382]=0;U(72,a|0,b|0,f+8|0);a=v[113382];v[113382]=0;if((a|0)==1){break b}mm(f+40|0);jb=f+80|0;return}d=P()|0;O()|0;break c}d=P()|0;O()|0;c=2}c=(f+40|0)+B(c,12)|0;while(1){c=yb(c-12|0);if((c|0)!=(f+40|0)){continue}break}break a}d=P()|0;O()|0;mm(f+40|0)}S(d|0);L()}function Rla(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;a:{if(y[a+4>>2]<y[zb(a)>>2]){d=jb-16|0;jb=d;e=Mk(d,a,1);f=zb(a);g=v[e+4>>2];v[113382]=0;X(522,f|0,g|0,b|0,c|0);b=v[113382];v[113382]=0;if((b|0)!=1){v[e+4>>2]=v[e+4>>2]+24;Mb(e);jb=d+16|0;break a}a=P()|0;O()|0;Mb(e);S(a|0);L()}f=jb-32|0;jb=f;e=a;g=zb(a);d=Fn(f+8|0,Lk(a,Cd(a)+1|0),Cd(a),g);h=v[d+8>>2];v[113382]=0;X(522,g|0,h|0,b|0,c|0);b=v[113382];v[113382]=0;b:{c:{if((b|0)==1){break c}v[d+8>>2]=v[d+8>>2]+24;v[113382]=0;R(523,e|0,d|0);b=v[113382];v[113382]=0;if((b|0)==1){break c}BS(d);jb=f+32|0;break b}a=P()|0;O()|0;BS(d);S(a|0);L()}}return Vt(a)|0}function Gaa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;g=jb-32|0;jb=g;a:{if(x[a+480192>>1]<b>>>0){break a}h=v[((b<<2)+a|0)+900380>>2];if(!h){break a}b=g+16|0;UN(b,h);i=g,j=NQ(b),v[i+8>>2]=j;i=g,j=yj(b),v[i>>2]=j;while(1){b:{v[113382]=0;b=Q(749,g+8|0,g|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break b}if(!b){Dp(g+16|0);break a}v[113382]=0;b=T(750,g+8|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break b}b=x[b>>1];if(b>>>0<=x[a+480190>>1]){b=B(b,104)+a|0;t[b+484421|0]=f;t[b+484418|0]=c;t[b+484420|0]=e;t[b+484419|0]=d}wt(g+8|0);continue}break}a=P()|0;O()|0;Dp(g+16|0);S(a|0);L()}jb=g+32|0}function MV(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;f=jb-80|0;jb=f;nm(f+40|0,f+32|0,c);v[113382]=0;U(210,f+52|0,f+24|0,d|0);d=v[113382];v[113382]=0;c=1;a:{b:{c:{d:{if((d|0)!=1){v[113382]=0;U(210,f- -64|0,f+16|0,e|0);c=v[113382];v[113382]=0;if((c|0)==1){break d}v[113382]=0;R(211,f+8|0,f+40|0);c=v[113382];v[113382]=0;if((c|0)==1){break b}v[113382]=0;U(72,a|0,b|0,f+8|0);a=v[113382];v[113382]=0;if((a|0)==1){break b}mm(f+40|0);jb=f+80|0;return}d=P()|0;O()|0;break c}d=P()|0;O()|0;c=2}c=(f+40|0)+B(c,12)|0;while(1){c=yb(c-12|0);if((c|0)!=(f+40|0)){continue}break}break a}d=P()|0;O()|0;mm(f+40|0)}S(d|0);L()}function fA(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0;e=jb-16|0;jb=e;d=(c<<3)+a|0;f=w[d+356|0];t[b+12|0]=w[b+12|0]&248|f&1|f<<1&4|f>>>1&2;Fg(b,Ed(w[d+352|0],2,16));t[b+13|0]=w[d+354|0];t[b+14|0]=w[d+355|0];d=w[d+353|0];t[b+15|0]=d;t[b+16|0]=d;d=0;u[e+14>>1]=0;if(Kb(b)){f=((c|0)!=0)<<1;a=(c<<6)+a|0;while(1){c=a+(d<<2)|0;g=c+160|0;u[e+12>>1]=w[g|0]|w[g+1|0]<<8;g=x[Ri(e+14|0,e+12|0)>>1];u[e+14>>1]=g;h=Pb(b,d),i=g,u[h>>1]=i;u[e+14>>1]=x[e+14>>1]+1;c=c+162|0;v[e+8>>2]=(w[c|0]|w[c+1|0]<<8)>>>f;v[e+4>>2]=64;c=v[Zd(e+8|0,e+4|0)>>2];h=Pb(b,d),i=c,t[h+2|0]=i;d=d+1|0;if(Kb(b)>>>0>d>>>0){continue}break}}Ry(b,4,32);jb=e+16|0}function _da(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;tc(a,65536);tc(a+4|0,64);tc(a+8|0,256);sg(a+28|0,16384);We(a+30|0,128);We(a+31|0,17);if(w[a+16|0]>=4){t[a+16|0]=0}if(w[a+17|0]>=5){t[a+17|0]=0}if(w[a+18|0]>=3){t[a+18|0]=0}We(a+19|0,64);We(a+20|0,100);c=-32;d=t[a+26|0];a:{if((d|0)>=-32){c=32;if((d|0)<=32){break a}}t[a+26|0]=c}We(a+23|0,64);We(a+24|0,64);Qy(a+48|0,64);Qy(a+68|0,64);Qy(a+88|0,(b|0)==4096?255:64);c=a+108|0;b=0;while(1){b:{if(w[ec(c,b)|0]){if(w[ec(c,b)|0]<121){break b}}e=ec(c,b),f=b+1|0,t[e|0]=f}b=b+1|0;if(b>>>0<128){continue}break}if(!Nn(w[a+14|0])){t[a+14|0]=5}if(w[a+34|0]>=251){t[a+34|0]=0}}function Og(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;e=jb+-64|0;jb=e;a:{b:{if(c-1>>>0>1023){break b}if(jg(a,b)){break b}c:{d:{if(mf(a)>>>0<=b>>>0){d=yx(e+8|0,a);v[113382]=0;U(1549,a|0,b+1|0,d|0);f=v[113382];v[113382]=0;if((f|0)==1){break d}vl(d)}d=Fe(a,b);v[113382]=0;Q(1550,d|0,c|0)|0;c=v[113382];v[113382]=0;e:{if((c|0)!=1){c=Fe(a,b);v[c+16>>2]=0;v[c+20>>2]=0;c=Fe(a,b);v[113382]=0;Q(1551,c|0,17540)|0;c=v[113382];v[113382]=0;if((c|0)!=1){break e}}a=V(66740)|0;b=O()|0;break c}g=qh(Fe(a,b));break b}a=V(66740)|0;b=O()|0;vl(d)}if((ga(66740)|0)!=(b|0)){break a}_(a|0)|0;$()}jb=e- -64|0;return g|0}S(a|0);L()}function rW(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=jb-16|0;jb=d;v[113382]=0;Z(1984,a|0);c=v[113382];v[113382]=0;a:{b:{c:{d:{if((c|0)==1){break d}v[113382]=0;Z(2010,b|0);c=v[113382];v[113382]=0;if((c|0)==1){break d}c=v[a+24>>2];e=qc(d+8|0,b);v[113382]=0;b=v[e+4>>2];v[d>>2]=v[e>>2];v[d+4>>2]=b;b=AD(c,d,1);e=v[113382];v[113382]=0;c=mb;if((e|0)!=1){break c}}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,4918,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break b}$();b=0;c=0}jb=d+16|0;a=c;break a}b=P()|0;O()|0;v[113382]=0;Y(20);a=v[113382];v[113382]=0;if((a|0)!=1){S(b|0);L()}V(0)|0;O()|0;Ab();L()}qa(a|0);return b|0}function wga(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;fj(a);zb(a);j=b+4|0;h=j;e=v[a+4>>2];k=v[a>>2];if((e|0)!=(k|0)){f=v[h>>2];while(1){e=e-12|0;d=e;i=zb(d);g=jb-16|0;jb=g;c=f-12|0;f=c;v[c>>2]=0;v[c+4>>2]=0;v[g+12>>2]=0;v[113382]=0;W(990,c+8|0,g+12|0,i|0)|0;i=v[113382];v[113382]=0;a:{if((i|0)!=1){jb=g+16|0;break a}V(0)|0;O()|0;Ab();L()}v[c>>2]=v[d>>2];v[c+4>>2]=v[d+4>>2];c=v[zb(d)>>2];l=zb(f),m=c,v[l>>2]=m;l=zb(d),m=0,v[l>>2]=m;v[d>>2]=0;v[d+4>>2]=0;f=v[h>>2]-12|0;v[h>>2]=f;if((e|0)!=(k|0)){continue}break}}dc(a,j);dc(a+4|0,b+8|0);dc(zb(a),gc(b));v[b>>2]=v[b+4>>2];to(a,xc(a))}function Wv(a,b,c,d,e){var f=0,g=0;f=jb-16|0;jb=f;g=f+8|0;Ac(g,b);v[113382]=0;b=T(2339,g|0)|0;g=v[113382];v[113382]=0;a:{if((g|0)==1){break a}v[113382]=0;aa(2353,b|0,59248,59280,c|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break a}v[113382]=0;b=T(2340,f+8|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break a}v[113382]=0;c=T(2354,b|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break a}v[d>>2]=c;v[113382]=0;c=T(2350,b|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break a}v[e>>2]=c;v[113382]=0;R(2351,a|0,b|0);a=v[113382];v[113382]=0;if((a|0)==1){break a}Ob(f+8|0);jb=f+16|0;return}a=P()|0;O()|0;Ob(f+8|0);S(a|0);L()}function H4(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=jb-16|0;jb=d;v[113382]=0;Z(1984,a|0);e=v[113382];v[113382]=0;a:{b:{c:{if((e|0)==1){break c}v[113382]=0;Z(2010,b|0);e=v[113382];v[113382]=0;if((e|0)==1){break c}e=v[a+24>>2];b=qc(d+8|0,b);v[113382]=0;f=v[b+4>>2];v[d>>2]=v[b>>2];v[d+4>>2]=f;X(2051,e|0,d|0,(c|0)!=0|0,1);c=v[113382];v[113382]=0;b=1;if((c|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,6098,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();b=0}jb=d+16|0;return b|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function a6(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=jb-32|0;jb=d;e=jb-16|0;jb=e;c=a;k=c;f=b;g=Ke(c);h=jc(c);i=jb-16|0;jb=i;if(g){while(1){j=Ms(zb(k),g+16|0,f);h=j?h:g;g=v[(j?4:0)+g>>2];if(g){continue}break}}f=v[Oc(i+8|0,h)>>2];jb=i+16|0;v[e+8>>2]=f;l=e,m=yj(c),v[l>>2]=m;a:{b:{if(!Jb(e+8|0,e)){break b}if(Ms(zb(c),b,lh(e+8|0))){break b}b=v[e+8>>2];break a}b=yj(c)}jb=e+16|0;v[d+24>>2]=b;l=d,m=yj(a),v[l+16>>2]=m;b=0;if(!ks(d+24|0,d+16|0)){c=v[Oc(d+8|0,v[d+24>>2])>>2];b=jb-16|0;jb=b;v[b+8>>2]=c;c=b+8|0;f=v[c>>2];IJ(a,f);jc(a);Cl(lh(c));xy(f);jb=b+16|0;b=1}jb=d+32|0;return b|0}function G_(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;k=jb-16|0;jb=k;a:{if(a){a=ZE(b);Tj(k,a);b=v[k>>2];t[c|0]=b;t[c+1|0]=b>>>8;t[c+2|0]=b>>>16;t[c+3|0]=b>>>24;Sj(k,a);$h(i,k);Jc(k);ch(k,a);$h(h,k);Jc(k);l=d,m=di(a),v[l>>2]=m;l=e,m=ci(a),v[l>>2]=m;vg(k,a);Gb(f,k);yb(k);dh(k,a);$h(g,k);Jc(k);a=Rj(a);break a}a=YE(b);Tj(k,a);b=v[k>>2];t[c|0]=b;t[c+1|0]=b>>>8;t[c+2|0]=b>>>16;t[c+3|0]=b>>>24;Sj(k,a);$h(i,k);Jc(k);ch(k,a);$h(h,k);Jc(k);l=d,m=di(a),v[l>>2]=m;l=e,m=ci(a),v[l>>2]=m;vg(k,a);Gb(f,k);yb(k);dh(k,a);$h(g,k);Jc(k);a=Rj(a)}v[j>>2]=a;jb=k+16|0}function CG(a){var b=0,c=0,d=0,e=0,f=0,g=0;if(xe(a)){cc(a,31);return 0}f=a,g=xe(a),t[f+1375|0]=g;d=ii(a);b=ii(a);ii(a);f=a,g=ii(a),v[f+1112>>2]=g;ii(a);c=xe(a);v[a+1116>>2]=c;if(!Ew(a,a+1120|0,c)){cc(a,10);return 0}v[a+1404>>2]=-2;a:{if((d|0)==-1&(b|0)==-1){break a}b=v[a+1116>>2];while(1){if((b|0)<=0){break a}b=b-1|0;if(w[(b+a|0)+1120|0]==255){continue}break}v[a+1408>>2]=d;v[a+1404>>2]=b}if(w[a+1377|0]){e=v[a+1116>>2];if((e|0)<=0){b=27}else{c=0;b=0;while(1){c=w[(a+b|0)+1120|0]+c|0;b=b+1|0;if((e|0)!=(b|0)){continue}break}b=c+27|0}v[a- -64>>2]=d;v[a+60>>2]=v[a+56>>2]+(b+e|0)}v[a+1380>>2]=0;return 1}function hn(a){var b=0,c=0,d=0;b=(x[a+24>>1]<<2)+(x[v[a+4>>2]+28>>1]>>>(!w[a+77|0]<<1)|0)|0;v[a+40>>2]=((b&3)<<4)+24512;c=b>>>2|0;b=b>>>0<48;d=b?12-c|0:0;u[a+32>>1]=d;u[a+36>>1]=b?1:1<<c-12;u[a+34>>1]=-1<<d^-1;if(x[a+24>>1]==15){u[a+36>>1]=4095}b=(x[a+26>>1]<<2)+(x[v[a+4>>2]+28>>1]>>>(!w[a+77|0]<<1)|0)|0;v[a+52>>2]=((b&3)<<4)+24512;c=b>>>2|0;b=b>>>0<48;d=b?12-c|0:0;u[a+44>>1]=d;u[a+48>>1]=b?1:1<<c-12;u[a+46>>1]=-1<<d^-1;b=(x[a+30>>1]<<2)+(x[v[a+4>>2]+28>>1]>>>(!w[a+77|0]<<1)|0)|0;v[a+64>>2]=((b&3)<<4)+24512;c=b>>>2|0;b=b>>>0<48;d=b?12-c|0:0;u[a+56>>1]=d;u[a+60>>1]=b?1:1<<c-12;u[a+58>>1]=-1<<d^-1}function _v(a,b,c,d,e){var f=0,g=0;f=jb-16|0;jb=f;g=f+8|0;Ac(g,b);v[113382]=0;b=T(21,g|0)|0;g=v[113382];v[113382]=0;a:{if((g|0)==1){break a}v[113382]=0;aa(2330,b|0,59248,59280,c|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break a}v[113382]=0;b=T(2306,f+8|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break a}v[113382]=0;c=T(2331,b|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break a}t[d|0]=c;v[113382]=0;c=T(2321,b|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break a}t[e|0]=c;v[113382]=0;R(2322,a|0,b|0);a=v[113382];v[113382]=0;if((a|0)==1){break a}Ob(f+8|0);jb=f+16|0;return}a=P()|0;O()|0;Ob(f+8|0);S(a|0);L()}function N_(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;k=jb-16|0;jb=k;a:{if(a){a=cF(b);Tj(k,a);b=v[k>>2];t[c|0]=b;t[c+1|0]=b>>>8;t[c+2|0]=b>>>16;t[c+3|0]=b>>>24;Sj(k,a);Gb(i,k);yb(k);ch(k,a);Gb(h,k);yb(k);l=d,m=di(a),t[l|0]=m;l=e,m=ci(a),t[l|0]=m;vg(k,a);Gb(f,k);yb(k);dh(k,a);Gb(g,k);yb(k);a=Rj(a);break a}a=bF(b);Tj(k,a);b=v[k>>2];t[c|0]=b;t[c+1|0]=b>>>8;t[c+2|0]=b>>>16;t[c+3|0]=b>>>24;Sj(k,a);Gb(i,k);yb(k);ch(k,a);Gb(h,k);yb(k);l=d,m=di(a),t[l|0]=m;l=e,m=ci(a),t[l|0]=m;vg(k,a);Gb(f,k);yb(k);dh(k,a);Gb(g,k);yb(k);a=Rj(a)}v[j>>2]=a;jb=k+16|0}function Hr(a,b,c){var d=0,e=0;d=a,e=ji(C(C(C(C(C(C(C(C(C(z[c+3328>>2]+z[c+256>>2])*C(213))+C(C(z[c+3584>>2]-z[c>>2])*C(29)))+C(C(z[c+3072>>2]-z[c+512>>2])*C(459)))+C(C(z[c+2816>>2]+z[c+768>>2])*C(2037)))+C(C(z[c+2560>>2]-z[c+1024>>2])*C(5153)))+C(C(z[c+2304>>2]+z[c+1280>>2])*C(6574)))+C(C(z[c+2048>>2]-z[c+1536>>2])*C(37489)))+C(z[c+1792>>2]*C(75038)))),u[d>>1]=e;d=(b<<5)+a|0,e=ji(C(C(C(C(C(C(C(C(z[c+3080>>2]*C(1567))+C(z[c+3592>>2]*C(104)))+C(z[c+2568>>2]*C(9727)))+C(z[c+2056>>2]*C(64019)))+C(z[c+1544>>2]*C(-9975)))+C(z[c+1032>>2]*C(-45)))+C(z[c+520>>2]*C(146)))+C(z[c+8>>2]*C(-5)))),u[d>>1]=e}function eI(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0;c=jb-16|0;jb=c;g=c;d=jb-144|0;jb=d;e=li(d+8|0);h=v[v[e>>2]-12>>2];v[113382]=0;i=da(123)|0;f=v[113382];v[113382]=0;a:{b:{if((f|0)==1){break b}v[113382]=0;U(124,d|0,(d+8|0)+h|0,i|0);f=v[113382];v[113382]=0;if((f|0)==1){break b}Ob(d);v[113382]=0;R(129,e|0,b|0);b=v[113382];v[113382]=0;if((b|0)==1){break b}v[113382]=0;R(126,g|0,e|0);b=v[113382];v[113382]=0;if((b|0)==1){break b}Td(e);jb=d+144|0;break a}a=P()|0;O()|0;Td(e);S(a|0);L()}v[113382]=0;U(13,a|0,0,c|0);a=v[113382];v[113382]=0;if((a|0)!=1){yb(c);jb=c+16|0;return}a=P()|0;O()|0;yb(c);S(a|0);L()}function G$(a){a=a|0;var b=0,c=0,d=0,e=0;c=jb-160|0;jb=c;a=Im(c+16|0,a,8);d=v[v[a>>2]-12>>2];v[113382]=0;b=da(123)|0;e=v[113382];v[113382]=0;a:{b:{if((e|0)==1){break b}v[113382]=0;U(124,c+8|0,d+(c+16|0)|0,b|0);d=v[113382];v[113382]=0;if((d|0)==1){break b}Ob(c+8|0);v[113382]=0;d=Q(157,a|0,143)|0;b=v[113382];v[113382]=0;if((b|0)==1){break b}v[113382]=0;d=Q(158,d|0,c+4|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break b}b=v[v[d>>2]-12>>2];v[113382]=0;d=T(151,b+d|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break b}b=v[c+4>>2];Mf(a);jb=c+160|0;a=d?0:b;break a}c=P()|0;O()|0;Mf(a);S(c|0);L()}return a|0}function G4(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,f=0;e=jb-16|0;jb=e;v[113382]=0;Z(1984,a|0);d=v[113382];v[113382]=0;a:{b:{c:{if((d|0)==1){break c}v[113382]=0;Z(2010,b|0);d=v[113382];v[113382]=0;if((d|0)==1){break c}d=v[a+24>>2];b=qc(e+8|0,b);v[113382]=0;f=v[b+4>>2];v[e>>2]=v[b>>2];v[e+4>>2]=f;eb(2053,d|0,e|0,+c,1);d=v[113382];v[113382]=0;b=1;if((d|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,2353,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();b=0}jb=e+16|0;return b|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function WG(a,b){a=a|0;b=b|0;var c=0,d=0;d=jb-16|0;jb=d;a:{b:{c:{c=a+8|0;d:{if(!ol(c)){if((b|0)<0|(Rr(c)|0)<=(b|0)){break d}c=(w[yp(v[a+32>>2],b+1&65535)+35|0]&4)>>>2|0;break b}c=ol(c);if((b|0)<0){break d}if((b|0)<(c|0)){break c}}a=ba(8)|0;v[113382]=0;c=Q(121,d|0,2427)|0;b=v[113382];v[113382]=0;e:{if((b|0)!=1){nc(a,c);v[113382]=0;U(1978,a|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break a}b=P()|0;O()|0;yb(c);break e}b=P()|0;O()|0;ca(a|0)}S(b|0);L()}b=b+1<<2;a=a+32|0;c=1;if(!v[(b+v[a>>2]|0)+900380>>2]){break b}c=(w[v[(b+v[a>>2]|0)+900380>>2]+15|0]&2)>>>1|0}jb=d+16|0;return c|0}L()}function dJ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;g=jb-16|0;jb=g;e=g+8|0;xh(e,b);f=jb-16|0;jb=f;c=f+8|0;jo(c,Yh(f,e));e=jb-16|0;jb=e;d=v[a+8>>2];b=v[a+12>>2];a:{if((b|0)<0){break a}if(!b&Hb(a)>>>0<d>>>0|b){break a}d=Hb(a);h=v[a+8>>2];i=0-((d>>>0<h>>>0)+v[a+12>>2]|0)|0;b=e;v[b+8>>2]=d-h;v[b+12>>2]=i;k=b,l=rh(c),v[k>>2]=l;v[b+4>>2]=0;b=Dz(b+8|0,b);b=EQ(v[b>>2],v[b+4>>2]);if((b|0)!=(rh(c)|0)){break a}kf(v[c>>2],v[c>>2]+b|0,Eb(v[a>>2]+v[a+8>>2]|0));c=a;d=b+v[a+8>>2]|0;a=v[a+12>>2];v[c+8>>2]=d;v[c+12>>2]=b>>>0>d>>>0?a+1|0:a;j=1}jb=e+16|0;jb=f+16|0;jb=g+16|0;return j|0}function hO(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;f=jb-16|0;jb=f;v[f+8>>2]=e;v[f+12>>2]=d;a:{if(!d){break a}Ee(a);Uq(a,c);if(!c){break a}e=0;while(1){j=c-g|0;v[f+4>>2]=j;h=v[Lb(f+12|0,f+4|0)>>2];$n(a,Eb(b)+g|0,h);Rs(a,1,13);i=e+h|0;if(i>>>0>e>>>0){while(1){b:{c:{d:{k=t[MD(a,e)|0];switch(k-10|0){case 1:case 2:break b;case 0:case 3:break c;default:break d}}if(k){break b}}l=MD(a,e),m=32,t[l|0]=m}e=e+1|0;if((i|0)!=(e|0)){continue}break}}v[f+4>>2]=j-h;e=i+1|0;g=v[Lb(f+8|0,f+4|0)>>2]+(h+g|0)|0;if(g>>>0<c>>>0){continue}break}}jb=f+16|0;return(d|0)!=0|0}function Mda(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;if(y[a+4>>2]<y[zb(a)>>2]){c=jb-16|0;jb=c;d=_n(c,a,1);a=zb(a);e=v[d+4>>2];v[113382]=0;U(1143,a|0,e|0,b|0);a=v[113382];v[113382]=0;a:{if((a|0)!=1){v[d+4>>2]=v[d+4>>2]+32;Mb(d);jb=c+16|0;break a}a=P()|0;O()|0;Mb(d);S(a|0);L()}return}c=jb-32|0;jb=c;d=a;e=zb(a);a=Dq(c+8|0,hm(a,ue(a)+1|0),ue(a),e);f=v[a+8>>2];v[113382]=0;U(1143,e|0,f|0,b|0);b=v[113382];v[113382]=0;b:{c:{if((b|0)==1){break c}v[a+8>>2]=v[a+8>>2]+32;v[113382]=0;R(1144,d|0,a|0);b=v[113382];v[113382]=0;if((b|0)==1){break c}Ts(a);jb=c+32|0;break b}b=P()|0;O()|0;Ts(a);S(b|0);L()}}function Al(a,b,c,d){var e=0,f=0,g=0;e=jb-16|0;jb=e;f=e+8|0;g=a+1074312|0;Fb(f,g,84);a:{if(Cb(f)){break a}b:{if(v[a+480208>>2]&16384){break b}if((d|0)!=8){f=e+8|0;Fb(f,g,10);if(!Cb(f)){break b}}v[b+88>>2]=v[b+88>>2]&-257}c:{d:{e:{switch(d-4|0){case 0:c=((c<<8|8)>>>0)/15|0;break d;case 2:c=(c>>>0<64?c:64)<<2;break d;default:break e}}if(!(v[a+480180>>2]&2107410)){break d}if(c>>>0<=128){c=c<<1;break d}if((c|0)!=164){break c}v[b+88>>2]=v[b+88>>2]|256;c=128}v[b+692>>2]=c}u[b+796>>1]=0;v[b+88>>2]=v[b+88>>2]|2097152;a=e+8|0;Fb(a,g,10);if(!Cb(a)){break a}t[b+851|0]=0;u[b+790>>1]=0}jb=e+16|0}function xaa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;if(v[a+4>>2]!=v[zb(a)>>2]){c=jb-16|0;jb=c;d=oe(c,a,1);a=zb(a);e=v[d+4>>2];v[113382]=0;U(1487,a|0,e|0,b|0);a=v[113382];v[113382]=0;a:{if((a|0)!=1){v[d+4>>2]=v[d+4>>2]+4;Mb(d);jb=c+16|0;break a}a=P()|0;O()|0;Mb(d);S(a|0);L()}return}c=jb-32|0;jb=c;d=a;e=zb(a);a=Nf(c+8|0,ye(a,Kb(a)+1|0),Kb(a),e);f=v[a+8>>2];v[113382]=0;U(1487,e|0,f|0,b|0);b=v[113382];v[113382]=0;b:{c:{if((b|0)==1){break c}v[a+8>>2]=v[a+8>>2]+4;v[113382]=0;R(1488,d|0,a|0);b=v[113382];v[113382]=0;if((b|0)==1){break c}EK(a);jb=c+32|0;break b}b=P()|0;O()|0;EK(a);S(b|0);L()}}function T3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;if(y[a+4>>2]<y[zb(a)>>2]){c=jb-16|0;jb=c;d=om(c,a,1);a=zb(a);e=v[d+4>>2];v[113382]=0;U(2096,a|0,e|0,b|0);a=v[113382];v[113382]=0;a:{if((a|0)!=1){v[d+4>>2]=v[d+4>>2]+16;Mb(d);jb=c+16|0;break a}a=P()|0;O()|0;Mb(d);S(a|0);L()}return}c=jb-32|0;jb=c;d=a;e=zb(a);a=Mq(c+8|0,Nq(a,jd(a)+1|0),jd(a),e);f=v[a+8>>2];v[113382]=0;U(2096,e|0,f|0,b|0);b=v[113382];v[113382]=0;b:{c:{if((b|0)==1){break c}v[a+8>>2]=v[a+8>>2]+16;v[113382]=0;R(2097,d|0,a|0);b=v[113382];v[113382]=0;if((b|0)==1){break c}yH(a);jb=c+32|0;break b}b=P()|0;O()|0;yH(a);S(b|0);L()}}function S9(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;if(y[a+4>>2]<y[zb(a)>>2]){c=jb-16|0;jb=c;d=Mk(c,a,1);a=zb(a);e=v[d+4>>2];v[113382]=0;U(1529,a|0,e|0,b|0);a=v[113382];v[113382]=0;a:{if((a|0)!=1){v[d+4>>2]=v[d+4>>2]+24;Mb(d);jb=c+16|0;break a}a=P()|0;O()|0;Mb(d);S(a|0);L()}return}c=jb-32|0;jb=c;d=a;e=zb(a);a=Fn(c+8|0,Lk(a,Cd(a)+1|0),Cd(a),e);f=v[a+8>>2];v[113382]=0;U(1529,e|0,f|0,b|0);b=v[113382];v[113382]=0;b:{c:{if((b|0)==1){break c}v[a+8>>2]=v[a+8>>2]+24;v[113382]=0;R(1530,d|0,a|0);b=v[113382];v[113382]=0;if((b|0)==1){break c}rK(a);jb=c+32|0;break b}b=P()|0;O()|0;rK(a);S(b|0);L()}}function L4(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=jb-16|0;jb=c;v[113382]=0;Z(1984,a|0);d=v[113382];v[113382]=0;a:{b:{c:{if((d|0)==1){break c}v[113382]=0;Z(2010,b|0);d=v[113382];v[113382]=0;if((d|0)==1){break c}d=v[a+24>>2];b=qc(c+8|0,b);v[113382]=0;f=v[b+4>>2];v[c>>2]=v[b>>2];v[c+4>>2]=f;e=+oa(2048,d|0,c|0,1);b=v[113382];v[113382]=0;if((b|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,2390,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();e=0}jb=c+16|0;return+e}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function EM(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;if(y[a+4>>2]<y[zb(a)>>2]){c=jb-16|0;jb=c;d=dl(c,a,1);a=zb(a);e=v[d+4>>2];v[113382]=0;U(1218,a|0,e|0,b|0);a=v[113382];v[113382]=0;a:{if((a|0)!=1){v[d+4>>2]=v[d+4>>2]+12;Mb(d);jb=c+16|0;break a}a=P()|0;O()|0;Mb(d);S(a|0);L()}return}c=jb-32|0;jb=c;d=a;e=zb(a);a=Wj(c+8|0,wm(a,xc(a)+1|0),xc(a),e);f=v[a+8>>2];v[113382]=0;U(1218,e|0,f|0,b|0);b=v[113382];v[113382]=0;b:{c:{if((b|0)==1){break c}v[a+8>>2]=v[a+8>>2]+12;v[113382]=0;R(1219,d|0,a|0);b=v[113382];v[113382]=0;if((b|0)==1){break c}Ls(a);jb=c+32|0;break b}b=P()|0;O()|0;Ls(a);S(b|0);L()}}function ila(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;if(v[a+4>>2]!=v[zb(a)>>2]){c=jb-16|0;jb=c;d=om(c,a,1);a=zb(a);e=v[d+4>>2];v[113382]=0;U(570,a|0,e|0,b|0);a=v[113382];v[113382]=0;a:{if((a|0)!=1){v[d+4>>2]=v[d+4>>2]+16;Mb(d);jb=c+16|0;break a}a=P()|0;O()|0;Mb(d);S(a|0);L()}return}c=jb-32|0;jb=c;d=a;e=zb(a);a=Mq(c+8|0,Nq(a,jd(a)+1|0),jd(a),e);f=v[a+8>>2];v[113382]=0;U(570,e|0,f|0,b|0);b=v[113382];v[113382]=0;b:{c:{if((b|0)==1){break c}v[a+8>>2]=v[a+8>>2]+16;v[113382]=0;R(571,d|0,a|0);b=v[113382];v[113382]=0;if((b|0)==1){break c}Kt(a);jb=c+32|0;break b}b=P()|0;O()|0;Kt(a);S(b|0);L()}}function hga(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;if(y[a+4>>2]<y[zb(a)>>2]){c=jb-16|0;jb=c;d=oe(c,a,1);a=zb(a);e=v[d+4>>2];v[113382]=0;U(1021,a|0,e|0,b|0);a=v[113382];v[113382]=0;a:{if((a|0)!=1){v[d+4>>2]=v[d+4>>2]+4;Mb(d);jb=c+16|0;break a}a=P()|0;O()|0;Mb(d);S(a|0);L()}return}c=jb-32|0;jb=c;d=a;e=zb(a);a=At(c+8|0,ye(a,Kb(a)+1|0),Kb(a),e);f=v[a+8>>2];v[113382]=0;U(1021,e|0,f|0,b|0);b=v[113382];v[113382]=0;b:{c:{if((b|0)==1){break c}v[a+8>>2]=v[a+8>>2]+4;v[113382]=0;R(1022,d|0,a|0);b=v[113382];v[113382]=0;if((b|0)==1){break c}nO(a);jb=c+32|0;break b}b=P()|0;O()|0;nO(a);S(b|0);L()}}function fka(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;if(v[a+4>>2]!=v[zb(a)>>2]){c=jb-16|0;jb=c;d=dl(c,a,1);a=zb(a);e=v[d+4>>2];v[113382]=0;U(691,a|0,e|0,b|0);a=v[113382];v[113382]=0;a:{if((a|0)!=1){v[d+4>>2]=v[d+4>>2]+12;Mb(d);jb=c+16|0;break a}a=P()|0;O()|0;Mb(d);S(a|0);L()}return}c=jb-32|0;jb=c;d=a;e=zb(a);a=Wj(c+8|0,wm(a,xc(a)+1|0),xc(a),e);f=v[a+8>>2];v[113382]=0;U(691,e|0,f|0,b|0);b=v[113382];v[113382]=0;b:{c:{if((b|0)==1){break c}v[a+8>>2]=v[a+8>>2]+12;v[113382]=0;R(175,d|0,a|0);b=v[113382];v[113382]=0;if((b|0)==1){break c}jr(a);jb=c+32|0;break b}b=P()|0;O()|0;jr(a);S(b|0);L()}}function c9(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;if(v[a+4>>2]!=v[zb(a)>>2]){c=jb-16|0;jb=c;d=oe(c,a,1);a=zb(a);e=v[d+4>>2];v[113382]=0;U(1573,a|0,e|0,b|0);a=v[113382];v[113382]=0;a:{if((a|0)!=1){v[d+4>>2]=v[d+4>>2]+4;Mb(d);jb=c+16|0;break a}a=P()|0;O()|0;Mb(d);S(a|0);L()}return}c=jb-32|0;jb=c;d=a;e=zb(a);a=Nf(c+8|0,ye(a,Kb(a)+1|0),Kb(a),e);f=v[a+8>>2];v[113382]=0;U(1573,e|0,f|0,b|0);b=v[113382];v[113382]=0;b:{c:{if((b|0)==1){break c}v[a+8>>2]=v[a+8>>2]+4;v[113382]=0;R(1566,d|0,a|0);b=v[113382];v[113382]=0;if((b|0)==1){break c}Tm(a);jb=c+32|0;break b}b=P()|0;O()|0;Tm(a);S(b|0);L()}}function Waa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;if(y[a+4>>2]<y[zb(a)>>2]){c=jb-16|0;jb=c;d=oe(c,a,1);a=zb(a);e=v[d+4>>2];v[113382]=0;U(1389,a|0,e|0,b|0);a=v[113382];v[113382]=0;a:{if((a|0)!=1){v[d+4>>2]=v[d+4>>2]+4;Mb(d);jb=c+16|0;break a}a=P()|0;O()|0;Mb(d);S(a|0);L()}return}c=jb-32|0;jb=c;d=a;e=zb(a);a=Nf(c+8|0,ye(a,Kb(a)+1|0),Kb(a),e);f=v[a+8>>2];v[113382]=0;U(1389,e|0,f|0,b|0);b=v[113382];v[113382]=0;b:{c:{if((b|0)==1){break c}v[a+8>>2]=v[a+8>>2]+4;v[113382]=0;R(1390,d|0,a|0);b=v[113382];v[113382]=0;if((b|0)==1){break c}_K(a);jb=c+32|0;break b}b=P()|0;O()|0;_K(a);S(b|0);L()}}function SA(a,b,c){var d=0,e=0,f=0;d=jb+-64|0;jb=d;e=d+40|0;Ze(e,a,c);a=v[e>>2];v[113382]=0;e=T(426,e|0)|0;f=v[113382];v[113382]=0;a:{b:{c:{if((f|0)==1){break c}v[113382]=0;e=T(427,e|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break c}v[113382]=0;X(428,d+8|0,3,e|0,a|0);e=v[113382];v[113382]=0;if((e|0)==1){break c}v[113382]=0;R(356,d+24|0,d+8|0);e=v[113382];v[113382]=0;if((e|0)==1){break c}v[113382]=0;Q(335,b|0,d+24|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break b}yb(d+24|0);Cc(d+40|0);jb=d- -64|0;return!c|(a|0)!=0}a=P()|0;O()|0;break a}a=P()|0;O()|0;yb(d+24|0)}Cc(d+40|0);S(a|0);L()}function RA(a,b,c){var d=0,e=0,f=0;d=jb+-64|0;jb=d;e=d+40|0;Ze(e,a,c);a=v[e>>2];v[113382]=0;e=T(426,e|0)|0;f=v[113382];v[113382]=0;a:{b:{c:{if((f|0)==1){break c}v[113382]=0;e=T(427,e|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break c}v[113382]=0;X(428,d+8|0,3,e|0,a|0);e=v[113382];v[113382]=0;if((e|0)==1){break c}v[113382]=0;R(356,d+24|0,d+8|0);e=v[113382];v[113382]=0;if((e|0)==1){break c}v[113382]=0;Q(344,b|0,d+24|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break b}yb(d+24|0);Cc(d+40|0);jb=d- -64|0;return!c|(a|0)!=0}a=P()|0;O()|0;break a}a=P()|0;O()|0;yb(d+24|0)}Cc(d+40|0);S(a|0);L()}function N7(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;if(v[a+4>>2]!=v[zb(a)>>2]){c=jb-16|0;jb=c;d=oe(c,a,1);a=zb(a);e=v[d+4>>2];v[113382]=0;U(1731,a|0,e|0,b|0);a=v[113382];v[113382]=0;a:{if((a|0)!=1){v[d+4>>2]=v[d+4>>2]+4;Mb(d);jb=c+16|0;break a}a=P()|0;O()|0;Mb(d);S(a|0);L()}return}c=jb-32|0;jb=c;d=a;e=zb(a);a=Nf(c+8|0,ye(a,Kb(a)+1|0),Kb(a),e);f=v[a+8>>2];v[113382]=0;U(1731,e|0,f|0,b|0);b=v[113382];v[113382]=0;b:{c:{if((b|0)==1){break c}v[a+8>>2]=v[a+8>>2]+4;v[113382]=0;R(1728,d|0,a|0);b=v[113382];v[113382]=0;if((b|0)==1){break c}$r(a);jb=c+32|0;break b}b=P()|0;O()|0;$r(a);S(b|0);L()}}function Jga(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;if(v[a+4>>2]!=v[zb(a)>>2]){c=jb-16|0;jb=c;d=dl(c,a,1);a=zb(a);e=v[d+4>>2];v[113382]=0;U(985,a|0,e|0,b|0);a=v[113382];v[113382]=0;a:{if((a|0)!=1){v[d+4>>2]=v[d+4>>2]+12;Mb(d);jb=c+16|0;break a}a=P()|0;O()|0;Mb(d);S(a|0);L()}return}c=jb-32|0;jb=c;d=a;e=zb(a);a=Wj(c+8|0,wm(a,xc(a)+1|0),xc(a),e);f=v[a+8>>2];v[113382]=0;U(985,e|0,f|0,b|0);b=v[113382];v[113382]=0;b:{c:{if((b|0)==1){break c}v[a+8>>2]=v[a+8>>2]+12;v[113382]=0;R(979,d|0,a|0);b=v[113382];v[113382]=0;if((b|0)==1){break c}ct(a);jb=c+32|0;break b}b=P()|0;O()|0;ct(a);S(b|0);L()}}function pha(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;if(y[a+4>>2]<y[zb(a)>>2]){c=jb-16|0;jb=c;d=Mk(c,a,1);a=zb(a);e=v[d+4>>2];v[113382]=0;U(949,a|0,e|0,b|0);a=v[113382];v[113382]=0;a:{if((a|0)!=1){v[d+4>>2]=v[d+4>>2]+24;Mb(d);jb=c+16|0;break a}a=P()|0;O()|0;Mb(d);S(a|0);L()}return}c=jb-32|0;jb=c;d=a;e=zb(a);a=Fn(c+8|0,Lk(a,Cd(a)+1|0),Cd(a),e);f=v[a+8>>2];v[113382]=0;U(949,e|0,f|0,b|0);b=v[113382];v[113382]=0;b:{c:{if((b|0)==1){break c}v[a+8>>2]=v[a+8>>2]+24;v[113382]=0;R(950,d|0,a|0);b=v[113382];v[113382]=0;if((b|0)==1){break c}fP(a);jb=c+32|0;break b}b=P()|0;O()|0;fP(a);S(b|0);L()}}function jla(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;if(y[a+4>>2]<y[zb(a)>>2]){c=jb-16|0;jb=c;d=Mk(c,a,1);a=zb(a);e=v[d+4>>2];v[113382]=0;U(567,a|0,e|0,b|0);a=v[113382];v[113382]=0;a:{if((a|0)!=1){v[d+4>>2]=v[d+4>>2]+24;Mb(d);jb=c+16|0;break a}a=P()|0;O()|0;Mb(d);S(a|0);L()}return}c=jb-32|0;jb=c;d=a;e=zb(a);a=Fn(c+8|0,Lk(a,Cd(a)+1|0),Cd(a),e);f=v[a+8>>2];v[113382]=0;U(567,e|0,f|0,b|0);b=v[113382];v[113382]=0;b:{c:{if((b|0)==1){break c}v[a+8>>2]=v[a+8>>2]+24;v[113382]=0;R(568,d|0,a|0);b=v[113382];v[113382]=0;if((b|0)==1){break c}tS(a);jb=c+32|0;break b}b=P()|0;O()|0;tS(a);S(b|0);L()}}function gma(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;if(y[a+4>>2]<y[zb(a)>>2]){c=jb-16|0;jb=c;d=Mk(c,a,1);a=zb(a);e=v[d+4>>2];v[113382]=0;U(492,a|0,e|0,b|0);a=v[113382];v[113382]=0;a:{if((a|0)!=1){v[d+4>>2]=v[d+4>>2]+24;Mb(d);jb=c+16|0;break a}a=P()|0;O()|0;Mb(d);S(a|0);L()}return}c=jb-32|0;jb=c;d=a;e=zb(a);a=Fn(c+8|0,Lk(a,Cd(a)+1|0),Cd(a),e);f=v[a+8>>2];v[113382]=0;U(492,e|0,f|0,b|0);b=v[113382];v[113382]=0;b:{c:{if((b|0)==1){break c}v[a+8>>2]=v[a+8>>2]+24;v[113382]=0;R(493,d|0,a|0);b=v[113382];v[113382]=0;if((b|0)==1){break c}dT(a);jb=c+32|0;break b}b=P()|0;O()|0;dT(a);S(b|0);L()}}function VS(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;if(v[a+4>>2]!=v[zb(a)>>2]){c=jb-16|0;jb=c;d=GS(c,a,1);a=zb(a);e=v[d+4>>2];v[113382]=0;U(520,a|0,e|0,b|0);a=v[113382];v[113382]=0;a:{if((a|0)!=1){v[d+4>>2]=v[d+4>>2]+48;Mb(d);jb=c+16|0;break a}a=P()|0;O()|0;Mb(d);S(a|0);L()}return}c=jb-32|0;jb=c;d=a;e=zb(a);a=ES(c+8|0,FS(a,Ni(a)+1|0),Ni(a),e);f=v[a+8>>2];v[113382]=0;U(520,e|0,f|0,b|0);b=v[113382];v[113382]=0;b:{c:{if((b|0)==1){break c}v[a+8>>2]=v[a+8>>2]+48;v[113382]=0;R(521,d|0,a|0);b=v[113382];v[113382]=0;if((b|0)==1){break c}Pt(a);jb=c+32|0;break b}b=P()|0;O()|0;Pt(a);S(b|0);L()}}function R8(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;if(y[a+4>>2]<y[zb(a)>>2]){c=jb-16|0;jb=c;d=oe(c,a,1);a=zb(a);e=v[d+4>>2];v[113382]=0;U(1605,a|0,e|0,b|0);a=v[113382];v[113382]=0;a:{if((a|0)!=1){v[d+4>>2]=v[d+4>>2]+4;Mb(d);jb=c+16|0;break a}a=P()|0;O()|0;Mb(d);S(a|0);L()}return}c=jb-32|0;jb=c;d=a;e=zb(a);a=Nf(c+8|0,ye(a,Kb(a)+1|0),Kb(a),e);f=v[a+8>>2];v[113382]=0;U(1605,e|0,f|0,b|0);b=v[113382];v[113382]=0;b:{c:{if((b|0)==1){break c}v[a+8>>2]=v[a+8>>2]+4;v[113382]=0;R(1606,d|0,a|0);b=v[113382];v[113382]=0;if((b|0)==1){break c}FJ(a);jb=c+32|0;break b}b=P()|0;O()|0;FJ(a);S(b|0);L()}}function M4(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=jb-16|0;jb=d;v[113382]=0;Z(1984,a|0);c=v[113382];v[113382]=0;a:{b:{c:{if((c|0)==1){break c}v[113382]=0;Z(2010,b|0);c=v[113382];v[113382]=0;if((c|0)==1){break c}c=v[a+24>>2];b=qc(d+8|0,b);v[113382]=0;e=v[b+4>>2];v[d>>2]=v[b>>2];v[d+4>>2]=e;b=W(2046,c|0,d|0,1)|0;c=v[113382];v[113382]=0;if((c|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,6129,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();b=0}jb=d+16|0;return b|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function Eja(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;if(y[a+4>>2]<y[zb(a)>>2]){c=jb-16|0;jb=c;d=Mk(c,a,1);a=zb(a);e=v[d+4>>2];v[113382]=0;U(732,a|0,e|0,b|0);a=v[113382];v[113382]=0;a:{if((a|0)!=1){v[d+4>>2]=v[d+4>>2]+24;Mb(d);jb=c+16|0;break a}a=P()|0;O()|0;Mb(d);S(a|0);L()}return}c=jb-32|0;jb=c;d=a;e=zb(a);a=Fn(c+8|0,Lk(a,Cd(a)+1|0),Cd(a),e);f=v[a+8>>2];v[113382]=0;U(732,e|0,f|0,b|0);b=v[113382];v[113382]=0;b:{c:{if((b|0)==1){break c}v[a+8>>2]=v[a+8>>2]+24;v[113382]=0;R(733,d|0,a|0);b=v[113382];v[113382]=0;if((b|0)==1){break c}_Q(a);jb=c+32|0;break b}b=P()|0;O()|0;_Q(a);S(b|0);L()}}function PU(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;if(y[a+4>>2]<y[zb(a)>>2]){c=jb-16|0;jb=c;d=_n(c,a,1);a=zb(a);e=v[d+4>>2];v[113382]=0;U(313,a|0,e|0,b|0);a=v[113382];v[113382]=0;a:{if((a|0)!=1){v[d+4>>2]=v[d+4>>2]+32;Mb(d);jb=c+16|0;break a}a=P()|0;O()|0;Mb(d);S(a|0);L()}return}c=jb-32|0;jb=c;d=a;e=zb(a);a=Dq(c+8|0,hm(a,ue(a)+1|0),ue(a),e);f=v[a+8>>2];v[113382]=0;U(313,e|0,f|0,b|0);b=v[113382];v[113382]=0;b:{c:{if((b|0)==1){break c}v[a+8>>2]=v[a+8>>2]+32;v[113382]=0;R(237,d|0,a|0);b=v[113382];v[113382]=0;if((b|0)==1){break c}Cq(a);jb=c+32|0;break b}b=P()|0;O()|0;Cq(a);S(b|0);L()}}function L$(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;if(y[a+4>>2]<y[zb(a)>>2]){c=jb-16|0;jb=c;d=dl(c,a,1);a=zb(a);e=v[d+4>>2];v[113382]=0;U(174,a|0,e|0,b|0);a=v[113382];v[113382]=0;a:{if((a|0)!=1){v[d+4>>2]=v[d+4>>2]+12;Mb(d);jb=c+16|0;break a}a=P()|0;O()|0;Mb(d);S(a|0);L()}return}c=jb-32|0;jb=c;d=a;e=zb(a);a=Wj(c+8|0,wm(a,xc(a)+1|0),xc(a),e);f=v[a+8>>2];v[113382]=0;U(174,e|0,f|0,b|0);b=v[113382];v[113382]=0;b:{c:{if((b|0)==1){break c}v[a+8>>2]=v[a+8>>2]+12;v[113382]=0;R(175,d|0,a|0);b=v[113382];v[113382]=0;if((b|0)==1){break c}jr(a);jb=c+32|0;break b}b=P()|0;O()|0;jr(a);S(b|0);L()}}function aB(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;if(v[a+4>>2]!=v[zb(a)>>2]){c=jb-16|0;jb=c;d=Uh(c,a,1);a=zb(a);e=v[d+4>>2];v[113382]=0;U(347,a|0,e|0,b|0);a=v[113382];v[113382]=0;a:{if((a|0)!=1){v[d+4>>2]=v[d+4>>2]+2;Mb(d);jb=c+16|0;break a}a=P()|0;O()|0;Mb(d);S(a|0);L()}return}c=jb-32|0;jb=c;d=a;e=zb(a);a=Sn(c+8|0,Qi(a,oc(a)+1|0),oc(a),e);f=v[a+8>>2];v[113382]=0;U(347,e|0,f|0,b|0);b=v[113382];v[113382]=0;b:{c:{if((b|0)==1){break c}v[a+8>>2]=v[a+8>>2]+2;v[113382]=0;R(346,d|0,a|0);b=v[113382];v[113382]=0;if((b|0)==1){break c}Cj(a);jb=c+32|0;break b}b=P()|0;O()|0;Cj(a);S(b|0);L()}}function _9(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;e=jb-32|0;jb=e;Nt(e,2,a+2|0);d=e+16|0;Ec(d,e);v[113382]=0;Q(335,b+492|0,d|0)|0;d=v[113382];v[113382]=0;if((d|0)!=1){yb(e+16|0);d=b+236|0;c=c+1|0;while(1){g=w[(a+f|0)+31|0];h=_c(d,f),i=c+g|0,u[h>>1]=i;f=f+1|0;if(f>>>0<120){continue}break}v[b>>2]=(w[a+223|0]|w[a+224|0]<<8)<<5;a=a+158|0;c=a+1|0;f=a+2|0;d=a+3|0;g=a+4|0;sK(w[a|0]&15,w[c|0]&15,w[f|0]&15,w[d|0]&15,w[g|0]&15,a+5|0,b+48|0);sK(w[a|0]>>>4|0,w[c|0]>>>4|0,w[f|0]>>>4|0,w[d|0]>>>4|0,w[g|0]>>>4|0,a+35|0,b+68|0);jb=e+32|0;return}a=P()|0;O()|0;yb(e+16|0);S(a|0);L()}function RU(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;if(v[a+4>>2]!=v[zb(a)>>2]){c=jb-16|0;jb=c;d=oe(c,a,1);a=zb(a);e=v[d+4>>2];v[113382]=0;U(312,a|0,e|0,b|0);a=v[113382];v[113382]=0;a:{if((a|0)!=1){v[d+4>>2]=v[d+4>>2]+4;Mb(d);jb=c+16|0;break a}a=P()|0;O()|0;Mb(d);S(a|0);L()}return}c=jb-32|0;jb=c;d=a;e=zb(a);a=Nf(c+8|0,ye(a,Kb(a)+1|0),Kb(a),e);f=v[a+8>>2];v[113382]=0;U(312,e|0,f|0,b|0);b=v[113382];v[113382]=0;b:{c:{if((b|0)==1){break c}v[a+8>>2]=v[a+8>>2]+4;v[113382]=0;R(309,d|0,a|0);b=v[113382];v[113382]=0;if((b|0)==1){break c}wq(a);jb=c+32|0;break b}b=P()|0;O()|0;wq(a);S(b|0);L()}}function Kla(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;sd(b,0);v[b>>2]=w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24);c=a+4|0;v[b+12>>2]=w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24);c=a+8|0;v[b+16>>2]=w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24);c=a+12|0;c=w[c|0]|w[c+1|0]<<8;u[b+32>>1]=64;v[b+24>>2]=c;e=b;c=a+14|0;if(w[c|0]){d=w[c|0]+1|0}else{d=256}u[e+30>>1]=d;u[b+34>>1]=x[b+34>>1]&32767|!w[c|0]<<15;a=a+15|0;if(!(!(t[a|0]&1)|y[b+16>>2]<=y[b+12>>2])){u[b+34>>1]=x[b+34>>1]|8}if(w[a|0]&2){u[b+34>>1]=x[b+34>>1]|1;v[b>>2]=v[b>>2]>>>1;v[b+12>>2]=v[b+12>>2]>>>1;v[b+16>>2]=v[b+16>>2]>>>1}}function BW(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0;if(rg(a,v[b+8>>2],f)){sv(b,c,d,e);return}h=w[b+53|0];g=v[a+12>>2];t[b+53|0]=0;i=w[b+52|0];t[b+52|0]=0;j=a+16|0;qv(j,b,c,d,e,f);k=w[b+53|0];h=h|k;l=w[b+52|0];i=i|l;a:{if((g|0)<2){break a}j=j+(g<<3)|0;g=a+24|0;while(1){if(w[b+54|0]){break a}b:{if(l){if(v[b+24>>2]==1){break a}if(w[a+8|0]&2){break b}break a}if(!k){break b}if(!(t[a+8|0]&1)){break a}}u[b+52>>1]=0;qv(g,b,c,d,e,f);k=w[b+53|0];h=k|h;l=w[b+52|0];i=l|i;g=g+8|0;if(j>>>0>g>>>0){continue}break}}t[b+53|0]=(h&255)!=0;t[b+52|0]=(i&255)!=0}function uy(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;if(y[a+4>>2]<y[zb(a)>>2]){c=jb-16|0;jb=c;d=oe(c,a,1);a=zb(a);e=v[d+4>>2];v[113382]=0;U(95,a|0,e|0,b|0);a=v[113382];v[113382]=0;a:{if((a|0)!=1){v[d+4>>2]=v[d+4>>2]+4;Mb(d);jb=c+16|0;break a}a=P()|0;O()|0;Mb(d);S(a|0);L()}return}c=jb-32|0;jb=c;d=a;e=zb(a);a=Nf(c+8|0,ye(a,Kb(a)+1|0),Kb(a),e);f=v[a+8>>2];v[113382]=0;U(95,e|0,f|0,b|0);b=v[113382];v[113382]=0;b:{c:{if((b|0)==1){break c}v[a+8>>2]=v[a+8>>2]+4;v[113382]=0;R(96,d|0,a|0);b=v[113382];v[113382]=0;if((b|0)==1){break c}nk(a);jb=c+32|0;break b}b=P()|0;O()|0;nk(a);S(b|0);L()}}function LT(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;g=jb-16|0;jb=g;d=b;f=wc(d);e=c;a:{if(f>>>0<e>>>0){h=jb-32|0;jb=h;b:{c:{f=e-f|0;d:{if(f>>>0<=v[zb(d)>>2]-v[d+4>>2]>>>0){lC(d,f);break d}e=zb(d);e=ph(h+8|0,Ki(d,wc(d)+f|0),wc(d),e);v[113382]=0;R(329,e|0,f|0);f=v[113382];v[113382]=0;if((f|0)==1){break c}v[113382]=0;R(330,d|0,e|0);d=v[113382];v[113382]=0;if((d|0)==1){break c}Tg(e)}jb=h+32|0;break b}a=P()|0;O()|0;Tg(e);S(a|0);L()}break a}if(e>>>0<f>>>0){Mu(d,e+v[d>>2]|0)}}c=Rb(a,c);if(c){d=jb-16|0;jb=d;e=g+8|0;fc(e,v[b>>2],wc(b));jb=d+16|0;zd(a,e)}jb=g+16|0;return c|0}function uC(a,b){var c=0,d=0,e=0,f=0,g=0,h=0;e=jb-16|0;jb=e;c=v[b+16>>2];v[a+4>>2]=0;v[a>>2]=c;a:{if(!c){break a}d=b+80|0;f=a;c=v[b+84>>2];if(c>>>0<=15){c=v[d>>2]}else{v[e+12>>2]=c-16;c=v[Vc(d,e+12|0)>>2]}v[f+8>>2]=c;if(!(w[b+88|0]&2)|!w[b+816|0]){break a}b:{c:{d:{if(!((w[v[b+104>>2]+34|0]&8)>>>3&(v[b+88>>2]&2050)==2)){c=v[b+104>>2];break d}c=v[b+104>>2];if(v[b+80>>2]!=v[c+12>>2]){break d}d=v[b+84>>2];if((d|0)==v[c+16>>2]){break c}}b=v[b+84>>2];if((b|0)!=v[c+8>>2]){break a}b=(v[c>>2]-b|0)+48|0;break b}b=(v[c>>2]-d|0)+112|0}g=a,h=v[a>>2]+B(Wn(c),b)|0,v[g+4>>2]=h}jb=e+16|0}function gX(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;c=jb-32|0;jb=c;e=se(b,-1);d=w[a+52|0];a:{if(e){if(d){break a}b=v[a+48>>2];f=a,g=se(b,-1)^1,t[f+52|0]=g;break a}b:{if(!d){break b}f=c,g=um(v[a+48>>2]),t[f+19|0]=g;c:{d:{e:{d=c+20|0;switch(Yq(v[a+36>>2],v[a+40>>2],c+19|0,d,c+12|0,c+24|0,c+32|0,d)-1|0){case 0:case 1:break c;case 2:break e;default:break d}}d=v[a+48>>2];v[c+20>>2]=c+25;t[c+24|0]=d}while(1){d=v[c+20>>2];if(d>>>0<=c+24>>>0){break b}d=d-1|0;v[c+20>>2]=d;if((Xq(t[d|0],v[a+32>>2])|0)!=-1){continue}break}}b=-1;break a}t[a+52|0]=1;v[a+48>>2]=b}jb=c+32|0;return b|0}function fE(a){var b=0,c=0;a:{b=v[a+4>>2];b:{if(!v[(v[v[b>>2]-12>>2]+b|0)+24>>2]){break b}b=v[a+4>>2];if(!Jf(v[v[b>>2]-12>>2]+b|0)){break b}b=v[a+4>>2];if(!(v[(v[v[b>>2]-12>>2]+b|0)+4>>2]&8192)){break b}if(GD()){break b}b=v[a+4>>2];b=v[(v[v[b>>2]-12>>2]+b|0)+24>>2];v[113382]=0;b=T(2721,b|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){if((b|0)!=-1){break b}a=v[a+4>>2];b=v[v[a>>2]-12>>2];v[113382]=0;R(2722,a+b|0,1);a=v[113382];v[113382]=0;if((a|0)!=1){break b}}a=V(0)|0;O()|0;_(a|0)|0;v[113382]=0;Y(20);a=v[113382];v[113382]=0;if((a|0)==1){break a}}return}V(0)|0;O()|0;Ab();L()}function A9(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;e=jb-16|0;jb=e;v[e+12>>2]=b;a:{if(lj(a)>>>0>=b>>>0){h=e,i=mf(a),v[h+8>>2]=i;d=v[a>>2];b=c;f=v[Lb(e+12|0,e+8|0)>>2];if(f){while(1){hK(d,b);d=d+52|0;f=f-1|0;if(f){continue}break}}b=v[e+12>>2];d=v[e+8>>2];if(b>>>0>d>>>0){xx(a,b-d|0,c);break a}dK(a,v[a>>2]+B(b,52)|0);break a}d=a;if(v[d>>2]){mf(d);dL(d);$J(d);Vx(zb(d),v[d>>2],lj(d));h=zb(d),i=0,v[h>>2]=i;v[d>>2]=0;v[d+4>>2]=0}f=cK(a,b);if(_J(a)>>>0<f>>>0){ld();L()}g=ZJ(zb(d),f);v[d>>2]=g;v[d+4>>2]=g;h=zb(d),i=B(f,52)+g|0,v[h>>2]=i;YJ(d,0);xx(a,b,c)}jb=e+16|0}function kt(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=jb-16|0;jb=c;d=c+8|0;KP(d,b);e=Hb(d);d=mc(a,$b(c,d));if((e|0)==(d|0)){_b(a,Hb(c+8|0))}jb=c+16|0;a=(d|0)==(e|0);if(!a){c=jb-16|0;jb=c;t[b|0]=0;t[b+1|0]=0;t[b+2|0]=0;t[b+3|0]=0;t[b+4|0]=0;t[b+5|0]=0;t[b+6|0]=0;t[b+7|0]=0;t[b+24|0]=0;t[b+25|0]=0;t[b+26|0]=0;t[b+27|0]=0;t[b+28|0]=0;t[b+29|0]=0;t[b+30|0]=0;t[b+31|0]=0;t[b+16|0]=0;t[b+17|0]=0;t[b+18|0]=0;t[b+19|0]=0;t[b+20|0]=0;t[b+21|0]=0;t[b+22|0]=0;t[b+23|0]=0;t[b+8|0]=0;t[b+9|0]=0;t[b+10|0]=0;t[b+11|0]=0;t[b+12|0]=0;t[b+13|0]=0;t[b+14|0]=0;t[b+15|0]=0;jb=c+16|0}return a|0}function Gw(a,b,c){var d=0,e=0,f=0,g=C(0),h=C(0),i=C(0),j=C(0),k=C(0),l=C(0),m=C(0),n=0;d=jb-32|0;jb=d;KG(C(-z[a>>2]),C(z[a+12>>2]+z[a+24>>2]),C(z[a+36>>2]+z[a+48>>2]),d+20|0);KG(z[a+60>>2],C(z[a+48>>2]-z[a+36>>2]),C(z[a+24>>2]-z[a+12>>2]),d+8|0);z[d+12>>2]=-z[d+12>>2];a=0;while(1){e=a<<2;f=e+c|0;h=z[f>>2];n=f;f=e+46064|0;g=z[f>>2];i=z[e+(d+20|0)>>2];j=z[e+(d+8|0)>>2];k=z[f+12>>2];z[n>>2]=C(g*i)-C(j*k);f=b+e|0;l=z[(0-a<<2)+46072>>2];e=5-a<<2;m=z[e+46064>>2];g=C(C(g*j)+C(k*i));z[f>>2]=C(h*l)-C(m*g);z[b+e>>2]=C(m*h)+C(g*l);a=a+1|0;if((a|0)!=3){continue}break}jb=d+32|0}function po(a,b){var c=0,d=0,e=0,f=0;if(y[a+4>>2]<y[zb(a)>>2]){c=jb-16|0;jb=c;d=Li(c,a,1);a=zb(a);e=v[d+4>>2];v[113382]=0;U(180,a|0,e|0,b|0);a=v[113382];v[113382]=0;a:{if((a|0)!=1){v[d+4>>2]=v[d+4>>2]+1;Mb(d);jb=c+16|0;break a}a=P()|0;O()|0;Mb(d);S(a|0);L()}return}c=jb-32|0;jb=c;d=a;e=zb(a);a=ph(c+8|0,Ki(a,wc(a)+1|0),wc(a),e);f=v[a+8>>2];v[113382]=0;U(180,e|0,f|0,b|0);b=v[113382];v[113382]=0;b:{c:{if((b|0)==1){break c}v[a+8>>2]=v[a+8>>2]+1;v[113382]=0;R(179,d|0,a|0);b=v[113382];v[113382]=0;if((b|0)==1){break c}vm(a);jb=c+32|0;break b}b=P()|0;O()|0;vm(a);S(b|0);L()}}function Jj(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;a:{c=v[a+28>>2];if((c|0)>=(b|0)){e=v[a+24>>2];break a}i=a+32|0;f=v[a+20>>2];d=v[a+16>>2];g=c;while(1){b:{if(d>>>0>=f>>>0){f=gv(a,i,1024);v[a+16>>2]=0;v[a+20>>2]=f;if(!f){break b}d=0;g=v[a+28>>2]}h=d+1|0;v[a+16>>2]=h;d=w[(a+d|0)+32|0];c=g+8|0;v[a+28>>2]=c;e=v[a+24>>2]|d<<g;v[a+24>>2]=e;d=h;g=c;if((c|0)<(b|0)){continue}break a}break}a=ba(8)|0;v[113382]=0;T(234,a|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){b=P()|0;O()|0;ca(a|0);S(b|0);L()}ha(a|0,72108,235);L()}v[a+28>>2]=c-b;v[a+24>>2]=e>>>b;return(-1<<b^-1)&e}function B2(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=jb-32|0;jb=c;f=ih(a);a:{b:{c:{d:{e:{e=b+24|0;if(x[v[e>>2]+480188>>1]){a=0;while(1){d=v[e>>2];v[113382]=0;R(2159,c|0,(d+(a<<5)|0)+480289|0);d=v[113382];v[113382]=0;if((d|0)==1){break e}v[113382]=0;U(2152,c+16|0,b|0,c|0);d=v[113382];v[113382]=0;if((d|0)==1){break d}v[113382]=0;R(1502,f|0,c+16|0);d=v[113382];v[113382]=0;if((d|0)==1){break c}yb(c+16|0);yb(c);a=a+1|0;if(a>>>0<x[v[e>>2]+480188>>1]){continue}break}}jb=c+32|0;return}a=P()|0;O()|0;break a}a=P()|0;O()|0;break b}a=P()|0;O()|0;yb(c+16|0)}yb(c)}gd(f);S(a|0);L()}function uca(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;e=jb-16|0;jb=e;v[e+12>>2]=c;v[e+8>>2]=v[a>>2]<<1;c=e+8|0;d=v[Lb(c,e+12|0)>>2];v[e+8>>2]=v[a>>2]<<1;v[e+4>>2]=v[e+12>>2]-d;g=d>>>1|0;h=v[Lb(c,e+4|0)>>2];c=Eb(b);if(d>>>0>=2){f=v[a+20>>2];d=g;while(1){j=f,k=(Eb(w[c|0])|Eb(w[c+1|0])<<8)^32768,u[j>>1]=k;f=f+4|0;c=c+2|0;d=d-1|0;if(d){continue}break}}i=h>>>1|0;b=Eb(b);if(h>>>0>=2){f=v[a+20>>2]+2|0;c=b+(v[a>>2]<<1)|0;d=i;while(1){j=f,k=(Eb(w[c|0])|Eb(w[c+1|0])<<8)^32768,u[j>>1]=k;f=f+4|0;c=c+2|0;d=d-1|0;if(d){continue}break}}jb=e+16|0;return g+i<<1}function tca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;f=jb-16|0;jb=f;v[f+12>>2]=c;v[f+8>>2]=v[a>>2]<<1;c=f+8|0;e=v[Lb(c,f+12|0)>>2];v[f+8>>2]=v[a>>2]<<1;v[f+4>>2]=v[f+12>>2]-e;i=e>>>1|0;j=v[Lb(c,f+4|0)>>2];c=Eb(b);if(e>>>0>=2){g=v[a+20>>2];e=i;h=d;while(1){h=(Eb(w[c|0])+h|0)+(Eb(w[c+1|0])<<8)|0;u[g>>1]=h;g=g+4|0;c=c+2|0;e=e-1|0;if(e){continue}break}}h=j>>>1|0;b=Eb(b);if(j>>>0>=2){g=v[a+20>>2]+2|0;c=b+(v[a>>2]<<1)|0;e=h;while(1){d=(Eb(w[c|0])+d|0)+(Eb(w[c+1|0])<<8)|0;u[g>>1]=d;g=g+4|0;c=c+2|0;e=e-1|0;if(e){continue}break}}jb=f+16|0;return h+i<<1}function rca(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;e=jb-16|0;jb=e;v[e+12>>2]=c;v[e+8>>2]=v[a>>2]<<1;c=e+8|0;d=v[Lb(c,e+12|0)>>2];v[e+8>>2]=v[a>>2]<<1;v[e+4>>2]=v[e+12>>2]-d;g=d>>>1|0;h=v[Lb(c,e+4|0)>>2];c=Eb(b);if(d>>>0>=2){f=v[a+20>>2];d=g;while(1){j=f,k=(Eb(w[c+1|0])|Eb(w[c|0])<<8)^32768,u[j>>1]=k;f=f+4|0;c=c+2|0;d=d-1|0;if(d){continue}break}}i=h>>>1|0;b=Eb(b);if(h>>>0>=2){f=v[a+20>>2]+2|0;c=b+(v[a>>2]<<1)|0;d=i;while(1){j=f,k=(Eb(w[c+1|0])|Eb(w[c|0])<<8)^32768,u[j>>1]=k;f=f+4|0;c=c+2|0;d=d-1|0;if(d){continue}break}}jb=e+16|0;return g+i<<1}function qca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;f=jb-16|0;jb=f;v[f+12>>2]=c;v[f+8>>2]=v[a>>2]<<1;c=f+8|0;e=v[Lb(c,f+12|0)>>2];v[f+8>>2]=v[a>>2]<<1;v[f+4>>2]=v[f+12>>2]-e;i=e>>>1|0;j=v[Lb(c,f+4|0)>>2];c=Eb(b);if(e>>>0>=2){g=v[a+20>>2];e=i;h=d;while(1){h=(Eb(w[c+1|0])+h|0)+(Eb(w[c|0])<<8)|0;u[g>>1]=h;g=g+4|0;c=c+2|0;e=e-1|0;if(e){continue}break}}h=j>>>1|0;b=Eb(b);if(j>>>0>=2){g=v[a+20>>2]+2|0;c=b+(v[a>>2]<<1)|0;e=h;while(1){d=(Eb(w[c+1|0])+d|0)+(Eb(w[c|0])<<8)|0;u[g>>1]=d;g=g+4|0;c=c+2|0;e=e-1|0;if(e){continue}break}}jb=f+16|0;return h+i<<1}function Lha(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;g=jb-16|0;jb=g;d=b;f=Kb(d);e=c;a:{if(f>>>0<e>>>0){h=jb-32|0;jb=h;b:{c:{f=e-f|0;d:{if(f>>>0<=v[zb(d)>>2]-v[d+4>>2]>>2>>>0){vP(d,f);break d}e=zb(d);e=At(h+8|0,ye(d,Kb(d)+f|0),Kb(d),e);v[113382]=0;R(913,e|0,f|0);f=v[113382];v[113382]=0;if((f|0)==1){break c}v[113382]=0;R(914,d|0,e|0);d=v[113382];v[113382]=0;if((d|0)==1){break c}qP(e)}jb=h+32|0;break b}a=P()|0;O()|0;qP(e);S(a|0);L()}break a}if(e>>>0<f>>>0){e=v[d>>2]+(e<<2)|0;Kb(d);rP(d,e);ng(d)}}c=Rb(a,c<<2);if(c){d=g+8|0;Wz(d,b);zd(a,d)}jb=g+16|0;return c|0}function $W(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;c=jb-32|0;jb=c;a:{b:{c:{if(se(b,-1)){break c}i=c,j=um(b),t[i+23|0]=j;if(w[a+44|0]){if((Zi(c+23|0,1,1,v[a+32>>2])|0)!=1){break b}break c}f=c+24|0;v[c+16>>2]=f;h=c+32|0;d=c+23|0;while(1){e=Yq(v[a+36>>2],v[a+40>>2],d,f,c+12|0,c+24|0,h,c+16|0);if(v[c+12>>2]==(d|0)){break b}if((e|0)==3){if((Zi(d,1,1,v[a+32>>2])|0)==1){break c}break b}if(e>>>0>1){break b}g=c+24|0;d=v[c+16>>2]-g|0;if((Zi(g,1,d,v[a+32>>2])|0)!=(d|0)){break b}d=v[c+12>>2];if((e|0)==1){continue}break}}a=Zq(b);break a}a=-1}jb=c+32|0;return a|0}function rha(a,b){a=a|0;b=b|0;var c=0,d=0;d=jb-32|0;jb=d;sd(b,0);jP(d,a+1|0);c=d+16|0;Ec(c,d);v[113382]=0;Q(336,b+43|0,c|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){yb(d+16|0);c=a+78|0;v[b+24>>2]=w[c|0]|w[c+1|0]<<8;c=a+58|0;v[b>>2]=w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24);c=a+62|0;v[b+4>>2]=w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24);c=a+66|0;v[b+8>>2]=w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24);u[b+30>>1]=(w[a+73|0]<<1)+2;u[b+34>>1]=x[b+34>>1]&65533|w[a|0]>>>6&2;tc(b+8|0,v[b>>2]);tc(b+4|0,v[b+8>>2]);jb=d+32|0;return}a=P()|0;O()|0;yb(d+16|0);S(a|0);L()}function Oja(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;e=jb-48|0;jb=e;v[113382]=0;c=Q(228,a|0,1)|0;d=v[113382];v[113382]=0;a:{if((d|0)==1){break a}b:{c:{if(!c){break c}v[113382]=0;R(721,b|0,64);c=v[113382];v[113382]=0;if((c|0)==1){break a}v[113382]=0;c=T(409,a|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break b}if(!c){break c}while(1){v[113382]=0;d=Q(722,a|0,e+8|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break b}c=c-1|0;d:{if(!d){break d}d=w[e+8|0];if(d>>>0>63){break d}lc(jR(b,d),e+8|0,33)}if(c&255){continue}break}}Bb(a);jb=e+48|0;return}}b=P()|0;O()|0;Bb(a);S(b|0);L()}function kv(a){var b=0,c=0,d=0,e=0,f=0;a:{if(y[a+4>>2]<y[zb(a)>>2]){b=jb-16|0;jb=b;c=_n(b,a,1);d=zb(a);e=v[c+4>>2];v[113382]=0;R(236,d|0,e|0);d=v[113382];v[113382]=0;if((d|0)!=1){v[c+4>>2]=v[c+4>>2]+32;Mb(c);jb=b+16|0;break a}a=P()|0;O()|0;Mb(c);S(a|0);L()}d=jb-32|0;jb=d;c=a;e=zb(a);b=Dq(d+8|0,hm(a,ue(a)+1|0),ue(a),e);f=v[b+8>>2];v[113382]=0;R(236,e|0,f|0);e=v[113382];v[113382]=0;b:{c:{if((e|0)==1){break c}v[b+8>>2]=v[b+8>>2]+32;v[113382]=0;R(237,c|0,b|0);c=v[113382];v[113382]=0;if((c|0)==1){break c}Cq(b);jb=d+32|0;break b}a=P()|0;O()|0;Cq(b);S(a|0);L()}}Wg(a)}function cX(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;c=jb-32|0;jb=c;e=se(b,-1);d=w[a+52|0];a:{if(e){if(d){break a}b=v[a+48>>2];f=a,g=se(b,-1)^1,t[f+52|0]=g;break a}b:{if(!d){break b}v[c+16>>2]=v[a+48>>2];c:{d:{e:{d=c+20|0;switch(Yq(v[a+36>>2],v[a+40>>2],c+16|0,d,c+12|0,c+24|0,c+32|0,d)-1|0){case 0:case 1:break c;case 2:break e;default:break d}}d=v[a+48>>2];v[c+20>>2]=c+25;t[c+24|0]=d}while(1){d=v[c+20>>2];if(d>>>0<=c+24>>>0){break b}d=d-1|0;v[c+20>>2]=d;if((Xq(t[d|0],v[a+32>>2])|0)!=-1){continue}break}}b=-1;break a}t[a+52|0]=1;v[a+48>>2]=b}jb=c+32|0;return b|0}function Gda(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;c=jb-16|0;jb=c;v[c+12>>2]=0;GE(a,c+12|0,1);d=v[c+12>>2];e=d>>>2&3;t[c+11|0]=e;if(e){t[c+4|0]=3;d=w[pc(c+4|0,c+11|0)|0];t[c+4|0]=0;t[c|0]=0;t[c+10|0]=0;a:{if(!d){break a}zh(a,c+4|0);if((d|0)==1){break a}zh(a,c);if(d>>>0<3){break a}zh(a,c+10|0);f=w[c+10|0]<<24}d=w[c+12|0]|w[c+4|0]<<8|w[c|0]<<16|f;v[c+12>>2]=d}v[c+4>>2]=d>>>4;v[c>>2]=1e6;fr(b,v[Lb(c+4|0,c)>>2]);if(Db(b)){d=0;while(1){Oj(a,kc(b,d),1);d=d+1|0;if(Db(b)>>>0>d>>>0){continue}break}}b=(v[c+12>>2]>>>4|0)-Db(b)|0;v[c+12>>2]=b;if(b){_k(a,b,-1)}jb=c+16|0}function ov(a,b,c){var d=0,e=0,f=0,g=0;g=b;d=v[c+16>>2];a:{if(!d){d=c;e=w[d+74|0];t[d+74|0]=e-1|e;e=v[d>>2];b:{if(e&8){v[d>>2]=e|32;d=-1;break b}v[d+4>>2]=0;v[d+8>>2]=0;e=v[d+44>>2];v[d+28>>2]=e;v[d+20>>2]=e;v[d+16>>2]=e+v[d+48>>2];d=0}if(d){break a}d=v[c+16>>2]}f=g;g=v[c+20>>2];if(f>>>0>d-g>>>0){return nb[v[c+36>>2]](c,a,b)|0}c:{if(t[c+75|0]<0){d=0;break c}f=b;while(1){d=f;if(!d){d=0;break c}f=d-1|0;if(w[f+a|0]!=10){continue}break}f=nb[v[c+36>>2]](c,a,d)|0;if(f>>>0<d>>>0){break a}a=a+d|0;b=b-d|0;g=v[c+20>>2]}lc(g,a,b);v[c+20>>2]=v[c+20>>2]+b;f=b+d|0}return f}function nfa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;b=jb-16|0;jb=b;h=v[a+24>>2];i=v[a+20>>2];j=v[a+16>>2];g=v[a+4>>2];e=g;f=v[a>>2];v[b+8>>2]=f;v[b+12>>2]=e;g=v[a+12>>2];v[b>>2]=v[a+8>>2];v[b+4>>2]=g;if(d){while(1){e=(e<<1)+j|0;f=(f>>>21&2040)+33120|0;e=(((B(u[e>>1],u[f+2>>1])+B(u[e-2>>1],u[f>>1])|0)+B(u[e+2>>1],u[f+4>>1])|0)+B(u[e+4>>1],u[f+6>>1])|0)/16384|0;v[c>>2]=v[c>>2]+B(e,i);v[c+4>>2]=v[c+4>>2]+B(e,h);Sb(b+8|0,b);d=d-1|0;if(d){c=c+8|0;f=v[b+8>>2];e=v[b+12>>2];continue}break}f=v[b+8>>2];e=v[b+12>>2]}v[a>>2]=f;v[a+4>>2]=e;jb=b+16|0}function Br(a,b,c,d,e,f){var g=0,h=0,i=0,j=0;h=jb-240|0;jb=h;g=v[c>>2];v[h+232>>2]=g;c=v[c+4>>2];v[h>>2]=a;v[h+236>>2]=c;a:{b:{c:{d:{if((g|0)!=1){g=a;i=1;break d}g=a;i=1;if(c){break d}c=a;break c}while(1){c=g-v[(d<<2)+f>>2]|0;if((nb[b|0](c,a)|0)<=0){c=g;break c}e:{if(!((d|0)<2|e)){e=v[((d<<2)+f|0)-8>>2];j=g-4|0;if((nb[b|0](j,c)|0)>=0){break e}if((nb[b|0](j-e|0,c)|0)>=0){break e}}v[(i<<2)+h>>2]=c;g=h+232|0;e=iG(g);Cr(g,e);i=i+1|0;d=d+e|0;e=0;g=c;if(v[h+236>>2]|v[h+232>>2]!=1){continue}break b}break}c=g;break b}if(e){break a}}hG(h,i);tw(c,b,d,f)}jb=h+240|0}function xda(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;a:{d=jb-16|0;jb=d;v[d+12>>2]=b;if(b>>>0<=4294967279){i=d,j=Db(a),v[i+8>>2]=j;e=Wi(v[Vc(d+12|0,d+8|0)>>2]);if((e|0)!=(Fc(a)|0)){b:{f=Fc(a);g=Db(a);c:{if((e|0)==10){h=1;b=a;c=v[a>>2];break c}c=e+1|0;b=a;d:{if(e>>>0>f>>>0){b=Zg(b,c);break d}v[113382]=0;b=Q(30,b|0,c|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){break d}a=V(0)|0;O()|0;_(a|0)|0;$();break b}h=he(a);c=Tb(a)}ag(b,c,Db(a)+1|0);if(h){cg(a,c,f+1|0)}e:{if((e|0)!=10){Gf(a,e+1|0);ae(a,g);Oe(a,b);break e}Ce(a,g)}}}jb=d+16|0;break a}If();L()}}function Pfa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;b=jb-16|0;jb=b;g=v[a+40>>2];h=v[a+36>>2];k=v[a+16>>2];e=v[a+4>>2];f=e;j=v[a>>2];v[b+8>>2]=j;v[b+12>>2]=e;e=v[a+12>>2];v[b>>2]=v[a+8>>2];v[b+4>>2]=e;a:{if(d){while(1){i=v[a+32>>2];f=u[(f<<1)+k>>1];h=v[a+28>>2]+h|0;e=h>>12;v[c>>2]=v[c>>2]+B(f,e);g=g+i|0;i=g>>12;v[c+4>>2]=v[c+4>>2]+B(f,i);Sb(b+8|0,b);d=d-1|0;if(d){c=c+8|0;f=v[b+12>>2];continue}break}j=v[b+8>>2];f=v[b+12>>2];break a}i=g>>12;e=h>>12}v[a+40>>2]=g;v[a+20>>2]=e;v[a+36>>2]=h;v[a+24>>2]=i;v[a>>2]=j;v[a+4>>2]=f;jb=b+16|0}function ofa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;b=jb-16|0;jb=b;h=v[a+24>>2];i=v[a+20>>2];j=v[a+16>>2];g=v[a+4>>2];e=g;f=v[a>>2];v[b+8>>2]=f;v[b+12>>2]=e;g=v[a+12>>2];v[b>>2]=v[a+8>>2];v[b+4>>2]=g;if(d){while(1){e=e+j|0;f=(f>>>21&2040)+33120|0;e=(((B(t[e|0],u[f+2>>1])+B(t[e-1|0],u[f>>1])|0)+B(t[e+1|0],u[f+4>>1])|0)+B(t[e+2|0],u[f+6>>1])<<8)/16384|0;v[c>>2]=v[c>>2]+B(e,i);v[c+4>>2]=v[c+4>>2]+B(e,h);Sb(b+8|0,b);d=d-1|0;if(d){c=c+8|0;f=v[b+8>>2];e=v[b+12>>2];continue}break}f=v[b+8>>2];e=v[b+12>>2]}v[a>>2]=f;v[a+4>>2]=e;jb=b+16|0}function Qfa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;b=jb-16|0;jb=b;g=v[a+40>>2];h=v[a+36>>2];k=v[a+16>>2];e=v[a+4>>2];f=e;j=v[a>>2];v[b+8>>2]=j;v[b+12>>2]=e;e=v[a+12>>2];v[b>>2]=v[a+8>>2];v[b+4>>2]=e;a:{if(d){while(1){i=v[a+32>>2];f=t[f+k|0]<<8;h=v[a+28>>2]+h|0;e=h>>12;v[c>>2]=v[c>>2]+B(f,e);g=g+i|0;i=g>>12;v[c+4>>2]=v[c+4>>2]+B(f,i);Sb(b+8|0,b);d=d-1|0;if(d){c=c+8|0;f=v[b+12>>2];continue}break}j=v[b+8>>2];f=v[b+12>>2];break a}i=g>>12;e=h>>12}v[a+40>>2]=g;v[a+20>>2]=e;v[a+36>>2]=h;v[a+24>>2]=i;v[a>>2]=j;v[a+4>>2]=f;jb=b+16|0}function AY(){var a=0;a:{if(t[454960]&1){break a}if(!vd(454960)){break a}a=454672;while(1){a=sf(a)+12|0;if((a|0)!=454960){continue}break}ud(454960)}Wc(454672,64248);Wc(454684,64280);Wc(454696,64316);Wc(454708,64340);Wc(454720,64364);Wc(454732,64380);Wc(454744,64400);Wc(454756,64420);Wc(454768,64448);Wc(454780,64488);Wc(454792,64520);Wc(454804,64556);Wc(454816,64592);Wc(454828,64608);Wc(454840,64624);Wc(454852,64640);Wc(454864,64364);Wc(454876,64656);Wc(454888,64672);Wc(454900,64688);Wc(454912,64704);Wc(454924,64720);Wc(454936,64736);Wc(454948,64752)}function vca(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;e=jb-16|0;jb=e;v[e+12>>2]=c;v[e+8>>2]=v[a>>2]<<1;c=e+8|0;d=v[Lb(c,e+12|0)>>2];v[e+8>>2]=v[a>>2]<<1;v[e+4>>2]=v[e+12>>2]-d;g=d>>>1|0;h=v[Lb(c,e+4|0)>>2];c=Eb(b);if(d>>>0>=2){f=v[a+20>>2];d=g;while(1){j=f,k=Eb(w[c|0])|Eb(w[c+1|0])<<8,u[j>>1]=k;f=f+4|0;c=c+2|0;d=d-1|0;if(d){continue}break}}i=h>>>1|0;b=Eb(b);if(h>>>0>=2){f=v[a+20>>2]+2|0;c=b+(v[a>>2]<<1)|0;d=i;while(1){j=f,k=Eb(w[c|0])|Eb(w[c+1|0])<<8,u[j>>1]=k;f=f+4|0;c=c+2|0;d=d-1|0;if(d){continue}break}}jb=e+16|0;return g+i<<1}function sca(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;e=jb-16|0;jb=e;v[e+12>>2]=c;v[e+8>>2]=v[a>>2]<<1;c=e+8|0;d=v[Lb(c,e+12|0)>>2];v[e+8>>2]=v[a>>2]<<1;v[e+4>>2]=v[e+12>>2]-d;g=d>>>1|0;h=v[Lb(c,e+4|0)>>2];c=Eb(b);if(d>>>0>=2){f=v[a+20>>2];d=g;while(1){j=f,k=Eb(w[c+1|0])|Eb(w[c|0])<<8,u[j>>1]=k;f=f+4|0;c=c+2|0;d=d-1|0;if(d){continue}break}}i=h>>>1|0;b=Eb(b);if(h>>>0>=2){f=v[a+20>>2]+2|0;c=b+(v[a>>2]<<1)|0;d=i;while(1){j=f,k=Eb(w[c+1|0])|Eb(w[c|0])<<8,u[j>>1]=k;f=f+4|0;c=c+2|0;d=d-1|0;if(d){continue}break}}jb=e+16|0;return g+i<<1}function Yg(a){var b=0,c=0,d=0,e=0;a:{o(+a);b=j(1)|0;j(0)|0;d=b;b=b&2147483647;b:{if(b>>>0>=1083174912){if(!((d|0)<0|b>>>0<1083179008)){return a*8.98846567431158e307}if(b>>>0>=2146435072){return-1/a}if(!(a<=-1075)){break a}c=0;if((d|0)<0){break b}break a}if(b>>>0>1016070143){break a}c=a+1}return c}e=a+26388279066624;o(+e);j(1)|0;b=(j(0)|0)+128|0;d=b<<4&4080;c=A[d+67648>>3];a=a-(e+-26388279066624)-A[d+67656>>3];return Zh(c+c*a*(a*(a*(a*(a*.0013333559164630223+.009618129842126066)+.0555041086648214)+.2402265069591)+.6931471805599453),(b&-256)/256|0)}function Uq(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;d=jb-16|0;jb=d;v[d+12>>2]=b;if(b>>>0<=4294967279){i=d,j=Db(a),v[i+8>>2]=j;e=Wi(v[Vc(d+12|0,d+8|0)>>2]);if((e|0)!=(Fc(a)|0)){a:{f=Fc(a);g=Db(a);b:{if((e|0)==10){h=1;b=a;c=v[a>>2];break b}c=e+1|0;b=a;c:{if(e>>>0>f>>>0){b=Zg(b,c);break c}v[113382]=0;b=Q(30,b|0,c|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){break c}a=V(0)|0;O()|0;_(a|0)|0;$();break a}h=he(a);c=Tb(a)}ag(b,c,Db(a)+1|0);if(h){cg(a,c,f+1|0)}d:{if((e|0)!=10){Gf(a,e+1|0);ae(a,g);Oe(a,b);break d}Ce(a,g)}}}jb=d+16|0;return}If();L()}function WW(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;d=jb-16|0;jb=d;v[d+12>>2]=b;if(b>>>0<=1073741807){i=d,j=Db(a),v[i+8>>2]=j;e=al(v[Vc(d+12|0,d+8|0)>>2]);if((e|0)!=(oo(a)|0)){a:{f=1;g=oo(a);h=Db(a);b:{if((e|0)==1){b=a;c=v[a>>2];break b}c=e+1|0;b=a;c:{if(e>>>0>g>>>0){b=Qj(b,c);break c}v[113382]=0;b=Q(2826,b|0,c|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){break c}a=V(0)|0;O()|0;_(a|0)|0;$();break a}f=he(a);c=Tb(a)}yh(b,c,Db(a)+1|0);if(f){no(c,g+1|0)}d:{if((e|0)!=1){Gf(a,e+1|0);ae(a,h);Oe(a,b);break d}Ce(a,h)}}}jb=d+16|0;return}If();L()}function UK(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;e=jb-16|0;jb=e;a:{if(w[b+813|0]!=27){a=t[b+851|0];break a}c=e+8|0;f=a+1074312|0;Fb(c,f,21);d=Cb(c);g=a;a=w[b+841|0];a=Rx(g,w[b+848|0],d?a:a+16>>>2|0);Fb(c,f,45);b:{if(!(!Cb(c)|w[b+848|0]!=3)){g=b;d=w[b+841|0];c:{if(!(!d|d>>>0>=w[b+849|0])){a=w[b+852|0];c=d+1|0;break c}t[b+852|0]=a;c=1}t[g+841|0]=c;a=a<<24>>24;break b}t[b+841|0]=w[b+841|0]+w[b+849|0]}c=e+8|0;Fb(c,f,47);if(!Cb(c)){break a}t[b+851|0]=a}if(a){h=b,i=Yb(v[b+684>>2]+((B(w[b+850|0],a)+2|0)/8|0)|0,0,256),v[h+684>>2]=i}jb=e+16|0}function e3(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0;e=jb-16|0;jb=e;b=Pe(12);c=b;f=zb(a);d=jb-16|0;jb=d;v[b>>2]=0;v[b+4>>2]=0;v[d+12>>2]=0;v[113382]=0;W(2176,b+8|0,d+12|0,f|0)|0;f=v[113382];v[113382]=0;a:{b:{if((f|0)!=1){jb=d+16|0;break b}break a}v[b>>2]=v[a>>2];v[b+4>>2]=v[a+4>>2];d=v[zb(a)>>2];g=zb(c),h=d,v[g>>2]=h;g=zb(a),h=0,v[g>>2]=h;v[a>>2]=0;v[a+4>>2]=0;c=jb-16|0;jb=c;v[113382]=0;v[c+12>>2]=b;a=e+8|0;W(2144,a|0,c+12|0,c+8|0)|0;b=v[113382];v[113382]=0;c:{if((b|0)!=1){jb=c+16|0;break c}break a}jb=e+16|0;return v[a>>2]}V(0)|0;O()|0;Ab();L()}function YW(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;c=jb-32|0;jb=c;a:{b:{c:{if(se(b,-1)){break c}v[c+20>>2]=b;if(w[a+44|0]){if((Zi(c+20|0,4,1,v[a+32>>2])|0)!=1){break b}break c}f=c+24|0;v[c+16>>2]=f;h=c+32|0;d=c+20|0;while(1){e=Yq(v[a+36>>2],v[a+40>>2],d,f,c+12|0,c+24|0,h,c+16|0);if(v[c+12>>2]==(d|0)){break b}if((e|0)==3){if((Zi(d,1,1,v[a+32>>2])|0)==1){break c}break b}if(e>>>0>1){break b}g=c+24|0;d=v[c+16>>2]-g|0;if((Zi(g,1,d,v[a+32>>2])|0)!=(d|0)){break b}d=v[c+12>>2];if((e|0)==1){continue}break}}a=Zq(b);break a}a=-1}jb=c+32|0;return a|0}function lg(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=jb-16|0;jb=d;u[d+12>>1]=65535;u[d+14>>1]=b;f=d+12|0;b=x[Af(23456,d+14|0)>>1];c=oc(a);a:{if(b>>>0>c>>>0){e=jb-32|0;jb=e;b:{c:{c=b-c|0;d:{if(c>>>0<=v[zb(a)>>2]-v[a+4>>2]>>1>>>0){gq(a,c,f);break d}b=zb(a);b=Sn(e+8|0,Qi(a,oc(a)+c|0),oc(a),b);v[113382]=0;U(345,b|0,c|0,f|0);c=v[113382];v[113382]=0;if((c|0)==1){break c}v[113382]=0;R(346,a|0,b|0);a=v[113382];v[113382]=0;if((a|0)==1){break c}Cj(b)}jb=e+32|0;break b}a=P()|0;O()|0;Cj(b);S(a|0);L()}break a}if(b>>>0<c>>>0){Kn(a,v[a>>2]+(b<<1)|0)}}jb=d+16|0}function ei(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,k=0;f=jb-16|0;jb=f;o(+b);h=j(1)|0;e=j(0)|0;g=h&2147483647;c=g;d=e;g=c+-1048576|0;a:{if((g|0)==2145386495|g>>>0<2145386495){i=d<<28;e=c>>>4|0;c=(c&15)<<28|d>>>4;d=e+1006632960|0;break a}if((c|0)==2146435072|c>>>0>2146435072){i=e<<28;c=h;e=c>>>4|0;c=(c&15)<<28|d>>>4;d=e|2147418112;break a}if(!(c|d)){c=0;d=0;break a}g=c;c=c?E(c):E(e)+32|0;ef(f,d,g,0,0,c+49|0);k=v[f>>2];i=v[f+4>>2];e=15372-c<<16;c=v[f+8>>2];d=e|v[f+12>>2]^65536}v[a>>2]=k;v[a+4>>2]=i;v[a+8>>2]=c;v[a+12>>2]=h&-2147483648|d;jb=f+16|0}function hC(a,b){var c=0,d=0,e=0,f=0,g=0,h=0;f=w[a+8|0];g=v[a>>2];a=v[a+4>>2];d=Tb(b);b=Db(b);c=jb-16|0;jb=c;v[c+8>>2]=b;v[c+12>>2]=a;e=v[Lb(c+12|0,c+8|0)>>2];a:{b:{if(!e){a=g;break b}b=e;a=g;while(1){h=w[d|0];t[a|0]=h;if(!h){break a}d=d+1|0;a=a+1|0;b=b-1|0;if(b){continue}break}}b=0}c:{if((f-1&255)>>>0<=1){d=v[c+12>>2];t[c+7|0]=0;Yr(a,((a+d|0)-e|0)+b|0,c+7|0);break c}if((f-3&255)>>>0>1){break c}d=v[c+12>>2];t[c+6|0]=32;Yr(a,((a+d|0)-e|0)+b|0,c+6|0)}d:{switch(f-1|0){case 0:case 3:t[(v[c+12>>2]+g|0)-1|0]=0;break;default:break d}}jb=c+16|0}function k$(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;a=jb-32|0;jb=a;u[a+28>>1]=w[59285]|w[59286]<<8;v[a+24>>2]=w[59281]|w[59282]<<8|(w[59283]<<16|w[59284]<<24);g=a+24|0;_j(g|1,6834,1,v[c+4>>2]);i=v[c+4>>2];f=a-16|0;jb=f;h=ge();v[a>>2]=e;e=i>>>9&1;g=df(f,e+13|0,h,g,a)+f|0;i=ug(f,g,c);e=f-((e<<3)+107&112)|0;jb=e;h=a+8|0;Ac(h,c);v[113382]=0;ja(2365,f|0,i|0,g|0,e|0,a+20|0,a+16|0,h|0);f=v[113382];v[113382]=0;if((f|0)!=1){Ob(a+8|0);b=zm(b,e,v[a+20>>2],v[a+16>>2],c,d);jb=a+32|0;return b|0}b=P()|0;O()|0;Ob(a+8|0);S(b|0);L()}function JU(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=jb-16|0;jb=d;v[d+12>>2]=v[v[a+1056>>2]>>2]-v[a+1060>>2];v[d+8>>2]=16384;e=v[Lb(d+12|0,d+8|0)>>2];v[a+1068>>2]=e;c=17;v[d+4>>2]=17;a:{if(!e){break a}while(1){f=1<<c-1;e=Jj(a,c);b:{c:{d:{if((c|0)<=6){if((e|0)!=(f|0)){break d}qq(d+4|0,Jj(a,4));break b}if(c>>>0>16){break c}c=f-8|0;if((c|0)>(e|0)|(e|0)>(f+7|0)){break d}qq(d+4|0,e-c|0);break b}pC(a,e,f,b);break b}c=e&(f^-1);if(e&f){v[d+4>>2]=c+1;break b}pC(a,c,0,b)}if(!v[a+1068>>2]){break a}c=v[d+4>>2];if((c|0)<18){continue}break}}jb=d+16|0}function IU(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=jb-16|0;jb=d;v[d+12>>2]=v[v[a+1056>>2]>>2]-v[a+1060>>2];v[d+8>>2]=32768;e=v[Lb(d+12|0,d+8|0)>>2];v[a+1068>>2]=e;c=9;v[d+4>>2]=9;a:{if(!e){break a}while(1){f=1<<c-1;e=Jj(a,c);b:{c:{d:{if((c|0)<=6){if((e|0)!=(f|0)){break d}qq(d+4|0,Jj(a,3));break b}if(c>>>0>8){break c}c=f-4|0;if((c|0)>(e|0)|(e|0)>(f+3|0)){break d}qq(d+4|0,e-c|0);break b}oC(a,e,f,b);break b}c=e&(f^-1);if(e&f){v[d+4>>2]=c+1;break b}oC(a,c,0,b)}if(!v[a+1068>>2]){break a}c=v[d+4>>2];if((c|0)<10){continue}break}}jb=d+16|0}function o6(a){a=a|0;var b=0,c=0,d=0;b=jb-32|0;jb=b;a:{b:{if(!a){a=Ud(17540);break b}v[113382]=0;c=Q(121,b|0,a|0)|0;a=v[113382];v[113382]=0;c:{d:{if((a|0)!=1){v[113382]=0;R(1962,b+16|0,c|0);a=v[113382];v[113382]=0;if((a|0)==1){break d}d=b+16|0;a=Ud(Tb(d));yb(d);yb(c);break b}a=V(0)|0;O()|0;break c}a=V(0)|0;O()|0;yb(c)}_(a|0)|0;a=0;v[113382]=0;X(1958,7041,0,0,0);c=v[113382];v[113382]=0;if((c|0)==1){break a}$()}jb=b+32|0;return a|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function eaa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=jb-32|0;jb=e;f=Fx(a);a:{b:{c:{d:{while(1){v[113382]=0;a=Q(228,b|0,8)|0;g=v[113382];v[113382]=0;if((g|0)==1){break b}if(a){v[113382]=0;U(1522,e+8|0,b|0,c|0);a=v[113382];v[113382]=0;if((a|0)==1){break d}v[113382]=0;R(1523,f|0,e+8|0);a=v[113382];v[113382]=0;if((a|0)==1){break c}lf(e+8|0);a=Vt(f);if((w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24))!=(d|0)){continue}}break}jb=e+32|0;return}a=P()|0;O()|0;break a}a=P()|0;O()|0;lf(e+8|0);break a}a=P()|0;O()|0}tl(f);S(a|0);L()}function Fja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;e=jb-32|0;jb=e;g=e+8|0;h=g;d=b;i=d;if(ZQ(d,e+24|0)){f=e+26|0;f=w[f|0]|w[f+1|0]<<8|(w[f+2|0]<<16|w[f+3|0]<<24)}td(h,i,f);d=w[e+24|0]|w[e+25|0]<<8|(w[e+26|0]<<16|w[e+27|0]<<24);t[a|0]=d;t[a+1|0]=d>>>8;t[a+2|0]=d>>>16;t[a+3|0]=d>>>24;d=w[e+28|0]|w[e+29|0]<<8;t[a+4|0]=d;t[a+5|0]=d>>>8;fm(a+8|0,g);Bb(g);a:{if(!c){break a}d=(f>>>0)%(c>>>0)|0;if(!d){break a}v[113382]=0;Q(304,b|0,c-d|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){break a}b=P()|0;O()|0;lf(a);S(b|0);L()}jb=e+32|0}function Gba(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=C(0),g=0,h=0,i=C(0),j=0,k=0;e=jb-16|0;jb=e;v[e+8>>2]=c>>>2;v[e+4>>2]=v[a>>2];g=v[Lb(e+8|0,e+4|0)>>2];i=z[d>>2];b=Eb(b);if(g){d=v[a+20>>2];c=g;while(1){a=w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24);z[e+12>>2]=i*(l(2,a<<24|a<<8&16711680|(a>>>8&65280|a>>>24)),q());Wd(e+12|0,C(-1));f=C(z[e+12>>2]*C(32768));z[e+12>>2]=f;a=d;f=de(f);a:{if(C(D(f))<C(2147483648)){h=~~f;break a}h=-2147483648}j=a,k=Rc(h),u[j>>1]=k;d=d+2|0;b=b+4|0;c=c-1|0;if(c){continue}break}}jb=e+16|0;return g<<2}function Mj(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=jb-16|0;jb=d;v[b>>2]=0;v[b+4>>2]=0;t[d+15|0]=0;i=$g(a,d+15|0);h=w[d+15|0];v[b>>2]=(h&252)>>>2;v[b+4>>2]=0;c=h&3;if(c){c=-1<<c;l=(c>>>0<4294967294?c:-2)^-1;while(1){t[d+15|0]=0;m=$g(a,d+15|0);c=b;f=v[c>>2];n=v[c+4>>2];j=w[d+15|0];e=g;g=k+1|0;e=g?e:e+1|0;k=g;g=e;h=c;o=c;p=f;c=(k<<3)-2|0;f=c&31;if((c&63)>>>0>=32){e=j<<f;c=0}else{e=(1<<f)-1&j>>>32-f;c=j<<f}v[o>>2]=p|c;v[h+4>>2]=e|n;i=i&m;if((k|0)!=(l|0)|g){continue}break}}jb=d+16|0;return i|0}function Dha(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=jb-32|0;jb=e;f=iz(a);a:{b:{c:{d:{while(1){v[113382]=0;a=Q(228,b|0,8)|0;g=v[113382];v[113382]=0;if((g|0)==1){break b}if(a){v[113382]=0;U(935,e+8|0,b|0,c|0);a=v[113382];v[113382]=0;if((a|0)==1){break d}v[113382]=0;R(936,f|0,e+8|0);a=v[113382];v[113382]=0;if((a|0)==1){break c}lf(e+8|0);a=Vt(f);if((w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24))!=(d|0)){continue}}break}jb=e+32|0;return}a=P()|0;O()|0;break a}a=P()|0;O()|0;lf(e+8|0);break a}a=P()|0;O()|0}Hl(f);S(a|0);L()}function DT(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=jb-208|0;jb=d;ku(c,a);_A(c,d+16|0,B(w[a+4|0],3));a:{if(w[a+4|0]<2){break a}t[d+12|0]=64;Fg(b,w[pc(a+4|0,d+12|0)|0]);t[b+13|0]=w[a+2|0];t[b+14|0]=w[a+3|0];a=w[a+1|0];t[b+15|0]=a;t[b+16|0]=a;if(!Kb(b)){break a}a=0;while(1){if(a){c=x[Pb(b,a-1|0)>>1];v[d+12>>2]=1;e=(d+16|0)+B(a,3)|0;v[d+8>>2]=(t[e+1|0]&1)<<8|w[e|0];e=x[yf(d+12|0,d+8|0)>>1];f=Pb(b,a),g=c+e|0,u[f>>1]=g}c=w[((d+16|0)+B(a,3)|0)+2|0];f=Pb(b,a),g=c,t[f+2|0]=g;a=a+1|0;if(Kb(b)>>>0>a>>>0){continue}break}}jb=d+208|0}function Qs(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0;d=jb-16|0;jb=d;v[b+40>>2]=0;v[b+44>>2]=0;e=b- -64|0;v[e>>2]=0;v[e+4>>2]=0;v[b+56>>2]=0;v[b+60>>2]=0;v[b+48>>2]=0;v[b+52>>2]=0;while(1){VM(b,A[Vk(c,0)>>3]);f=f+1|0;if((f|0)!=1e4){continue}break}g=d,h=ac(c),v[g+8>>2]=h;g=d,h=bc(c),v[g>>2]=h;if(Jb(d+8|0,d)){while(1){e=d+8|0;f=v[e>>2];g=f,i=VM(b,A[f>>3]),A[g>>3]=i;Fy(e);if(Jb(e,d)){continue}break}}b=UM(a,zb(c));v[a>>2]=v[c>>2];v[a+4>>2]=v[c+4>>2];a=v[zb(c)>>2];g=zb(b),h=a,v[g>>2]=h;g=zb(c),h=0,v[g>>2]=h;v[c>>2]=0;v[c+4>>2]=0;jb=d+16|0}function iha(a){a=a|0;var b=0,c=0,d=0,e=0;b=jb-160|0;jb=b;a=Im(b+16|0,a,8);d=v[v[a>>2]-12>>2];v[113382]=0;c=da(123)|0;e=v[113382];v[113382]=0;a:{b:{if((e|0)==1){break b}v[113382]=0;U(124,b+8|0,d+(b+16|0)|0,c|0);d=v[113382];v[113382]=0;if((d|0)==1){break b}Ob(b+8|0);v[113382]=0;d=Q(154,a|0,b+6|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break b}c=v[v[d>>2]-12>>2];v[113382]=0;d=T(151,c+d|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break b}c=x[b+6>>1];Mf(a);jb=b+160|0;a=(d?0:c)&65535;break a}b=P()|0;O()|0;Mf(a);S(b|0);L()}return a|0}function Qda(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=jb-16|0;jb=c;f=x[Dj(a,b)>>1];a:{if(!pp(a,b)){break a}d=v[a+24>>2]+484360|0;j=c,k=ac(d),v[j+8>>2]=k;j=c,k=bc(d),v[j>>2]=k;if(!Jb(c+8|0,c)){break a}h=f&65535;while(1){b:{g=v[c+8>>2];i=Wt(g);if(i){e=0;while(1){if(!((b|0)==(e|0)&(a|0)==(g|0)|x[rc(g,e)>>1]!=(h|0))){d=bK(v[a+24>>2]+484344|0,h,0);if((d|0)!=65535){break b}}e=e+1|0;if((i|0)!=(e|0)){continue}break}}d=c+8|0;My(d);if(Jb(d,c)){continue}break a}break}j=Dj(a,b),k=d,u[j>>1]=k;f=d}jb=c+16|0;return f&65535}function Q4(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=jb-16|0;jb=g;v[113382]=0;Z(1984,a|0);h=v[113382];v[113382]=0;a:{b:{if((h|0)!=1){c:{h=v[a+24>>2];v[113382]=0;ja(2042,g|0,h|0,b|0,c|0,d|0,e|0,(f|0)!=0|0);b=v[113382];v[113382]=0;if((b|0)==1){break c}b=Ud(Tb(g));yb(g);break b}}b=V(0)|0;O()|0;_(b|0)|0;b=0;v[113382]=0;X(1958,6752,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$()}jb=g+16|0;return b|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function P4(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=jb-16|0;jb=g;v[113382]=0;Z(1984,a|0);h=v[113382];v[113382]=0;a:{b:{if((h|0)!=1){c:{h=v[a+24>>2];v[113382]=0;ja(2043,g|0,h|0,b|0,c|0,d|0,e|0,(f|0)!=0|0);b=v[113382];v[113382]=0;if((b|0)==1){break c}b=Ud(Tb(g));yb(g);break b}}b=V(0)|0;O()|0;_(b|0)|0;b=0;v[113382]=0;X(1958,6707,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$()}jb=g+16|0;return b|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function DY(){var a=0;a:{if(t[454656]&1){break a}if(!vd(454656)){break a}a=454368;while(1){a=Xb(a)+12|0;if((a|0)!=454656){continue}break}ud(454656)}Kc(454368,1541);Kc(454380,1532);Kc(454392,6901);Kc(454404,6678);Kc(454416,1751);Kc(454428,7650);Kc(454440,1608);Kc(454452,2095);Kc(454464,5060);Kc(454476,5043);Kc(454488,5051);Kc(454500,5070);Kc(454512,6166);Kc(454524,9268);Kc(454536,5133);Kc(454548,3946);Kc(454560,1751);Kc(454572,5727);Kc(454584,6566);Kc(454596,6913);Kc(454608,5273);Kc(454620,2817);Kc(454632,1978);Kc(454644,9177)}function wv(a,b,c){var d=0,e=0,f=0;d=jb+-64|0;jb=d;f=v[a>>2];e=v[f-4>>2];f=v[f-8>>2];v[d+20>>2]=0;v[d+16>>2]=b;v[d+12>>2]=a;v[d+8>>2]=c;b=0;Qb(d+24|0,0,39);a=a+f|0;a:{if(rg(e,c,0)){v[d+56>>2]=1;nb[v[v[e>>2]+20>>2]](e,d+8|0,a,a,1,0);b=v[d+32>>2]==1?a:0;break a}nb[v[v[e>>2]+24>>2]](e,d+8|0,a,1,0);b:{switch(v[d+44>>2]){case 0:b=v[d+48>>2]==1?v[d+36>>2]==1?v[d+40>>2]==1?v[d+28>>2]:0:0:0;break a;case 1:break b;default:break a}}if(v[d+32>>2]!=1){if(v[d+48>>2]|v[d+36>>2]!=1|v[d+40>>2]!=1){break a}}b=v[d+24>>2]}jb=d- -64|0;return b}function eia(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=jb-16|0;jb=c;e=jb-16|0;jb=e;d=c+8|0;fc(d,b,26);jb=e+16|0;e=Hb(d);d=mc(a,$b(c,d));if((e|0)==(d|0)){_b(a,Hb(c+8|0))}jb=c+16|0;a=(d|0)==(e|0);if(!a){c=jb-16|0;jb=c;t[b|0]=0;t[b+1|0]=0;t[b+2|0]=0;t[b+3|0]=0;t[b+4|0]=0;t[b+5|0]=0;t[b+6|0]=0;t[b+7|0]=0;t[b+24|0]=0;t[b+25|0]=0;t[b+16|0]=0;t[b+17|0]=0;t[b+18|0]=0;t[b+19|0]=0;t[b+20|0]=0;t[b+21|0]=0;t[b+22|0]=0;t[b+23|0]=0;t[b+8|0]=0;t[b+9|0]=0;t[b+10|0]=0;t[b+11|0]=0;t[b+12|0]=0;t[b+13|0]=0;t[b+14|0]=0;t[b+15|0]=0;jb=c+16|0}return a|0}function cM(a,b,c){var d=0,e=0,f=0;d=jb-16|0;jb=d;a:{if(b){t[c|0]=b;break a}b=w[c|0]}b=v[a+480180>>2]&1048580?(b&240?-16:15)&b:b;c=b&240;e=b&255;b=b&15;b:{c:{d:{if(!(!c|(b|0)!=15)){if(!(w[a+480209|0]&16)){break b}b=e>>>3&30;break d}f=v[a+480208>>2]&4096;if(!(!b|(c|0)!=240)){if(!f){break b}b=0-(b<<1)|0;break c}if(f){break b}if(c){if(b?v[a+480180>>2]&59314208:0){break b}b=e>>>3&30;break d}b=0-(b<<1)|0}if(!b){break b}}c=a+1074444|0;v[d+12>>2]=v[c>>2]+(b<<!(v[a+480180>>2]&59314208));Yd(d+12|0,0,256);v[c>>2]=v[d+12>>2]}jb=d+16|0}function Gka(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;f=jb-16|0;jb=f;a:{if(Tz(a)){v[b>>2]=0;a=0;break a}g=kg(a,f,16);d=Eb(w[f|0]);c=d&127;v[b>>2]=c;if(c){while(1){h=h+1|0;e=c>>>0>1;c=c>>>1|0;if(e){continue}break}}e=d<<24>>24;d=(e|0)<0;c=1;b:{if(g>>>0<2|(e|0)>=0){break b}while(1){d=Eb(w[c+f|0]);v[b>>2]=d&127|v[b>>2]<<7;h=h+7|0;e=d<<24>>24;d=(e|0)<0;c=c+1|0;if((g|0)==(c|0)){_b(a,g);g=kg(a,f,16);c=0}if(c>>>0>=g>>>0){break b}if((e|0)<0){continue}break}}_b(a,c);if(h>>>0>=33){v[b>>2]=-1;a=0;break a}a=!d}jb=f+16|0;return a|0}function v$(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;a=jb-32|0;jb=a;u[a+28>>1]=w[59285]|w[59286]<<8;v[a+24>>2]=w[59281]|w[59282]<<8|(w[59283]<<16|w[59284]<<24);g=a+24|0;_j(g|1,6834,1,v[c+4>>2]);i=v[c+4>>2];f=a-16|0;jb=f;h=ge();v[a>>2]=e;g=df(f,(i>>>9&1)+13|0,h,g,a)+f|0;i=ug(f,g,c);e=f-32|0;jb=e;h=a+8|0;Ac(h,c);v[113382]=0;ja(2356,f|0,i|0,g|0,e|0,a+20|0,a+16|0,h|0);f=v[113382];v[113382]=0;if((f|0)!=1){Ob(a+8|0);b=_l(b,e,v[a+20>>2],v[a+16>>2],c,d);jb=a+32|0;return b|0}b=P()|0;O()|0;Ob(a+8|0);S(b|0);L()}function tda(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=jb-16|0;jb=c;d=c+8|0;$M(d,b);e=Hb(d);d=mc(a,$b(c,d));if((e|0)==(d|0)){_b(a,Hb(c+8|0))}jb=c+16|0;a=(d|0)==(e|0);if(!a){c=jb-16|0;jb=c;t[b|0]=0;t[b+1|0]=0;t[b+2|0]=0;t[b+3|0]=0;t[b+4|0]=0;t[b+5|0]=0;t[b+6|0]=0;t[b+7|0]=0;t[b+23|0]=0;t[b+24|0]=0;t[b+25|0]=0;t[b+26|0]=0;t[b+16|0]=0;t[b+17|0]=0;t[b+18|0]=0;t[b+19|0]=0;t[b+20|0]=0;t[b+21|0]=0;t[b+22|0]=0;t[b+23|0]=0;t[b+8|0]=0;t[b+9|0]=0;t[b+10|0]=0;t[b+11|0]=0;t[b+12|0]=0;t[b+13|0]=0;t[b+14|0]=0;t[b+15|0]=0;jb=c+16|0}return a|0}function aM(a,b,c){var d=0,e=0;a:{if(v[a+480180>>2]==4){d=w[b+834|0];if(c){t[b+834|0]=d&240|c&15;break a}c=d&15;break a}if(v[a+480180>>2]!=1048576){break a}if(c){t[b+833|0]=c;break a}c=w[b+833|0]}b:{if(!(t[b+872|0]&1)){break b}d=v[b+700>>2];if(!d|!(c&255)){break b}e=b;c:{d:{if(!(w[a+480208|0]&16)){break d}d=v[b+700>>2];if(v[a+480180>>2]==4){break d}a=SL(a,c&15);b=qma(a,a>>31,d,d>>31)+32768|0;a=mb;a=zc(rma(b,b>>>0<32768?a+1|0:a,65536,0),mb);a=a-((a|0)==(d|0))|0;break c}a=(c&255)+d|0;a=(a|0)<65535?a:65535}v[e+700>>2]=a}}function W9(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;d=jb-32|0;jb=d;Cg(d,2,a+6|0);e=d+16|0;Ec(e,d);v[113382]=0;Q(335,b+492|0,e|0)|0;e=v[113382];v[113382]=0;if((e|0)!=1){e=b+236|0;yb(d+16|0);g=c+1|0;c=0;while(1){h=w[(a+f|0)+38|0];i=_c(e,f),j=g+h|0,u[i>>1]=j;c=c+1|0;f=c&255;if(f>>>0<128){continue}break}c=a+226|0;v[b>>2]=(w[c|0]|w[c+1|0]<<8)<<5;Ex(a+180|0,b+48|0,0);Ex(a+228|0,b+88|0,2);Ex(a+276|0,b+68|0,1);a=a+324|0;if(!(w[a|0]|w[a+1|0]<<8)){Qb(e,0,256)}jb=d+32|0;return}a=P()|0;O()|0;yb(d+16|0);S(a|0);L()}function A3(a,b,c){a=a|0;b=+b;c=c|0;var d=0,e=0,f=0;d=jb+-64|0;jb=d;v[d+56>>2]=c;c=v[a>>2];e=v[a+4>>2];f=v[a+12>>2];a=v[a+8>>2];v[d+8>>2]=a;v[d+12>>2]=f;v[113382]=0;v[d+32>>2]=a;v[d+36>>2]=f;v[d+24>>2]=c;v[d+28>>2]=e;v[d>>2]=c;v[d+4>>2]=e;U(2130,d+40|0,d|0,0);a=v[113382];v[113382]=0;a:{b:{if((a|0)!=1){a=v[Io(d+16|0,d+56|0)>>2];v[113382]=0;b=+za(2131,d+40|0,+b,a|0);a=v[113382];v[113382]=0;if((a|0)==1){break b}Bb(d+40|0);ad(d+56|0);jb=d- -64|0;return+b}a=P()|0;O()|0;break a}a=P()|0;O()|0;Bb(d+40|0)}ad(d+56|0);S(a|0);L()}function Xi(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;if((a|0)!=(b|0)){if(!he(a)){if(!he(b)){v[a+8>>2]=v[b+8>>2];d=v[b+4>>2];v[a>>2]=v[b>>2];v[a+4>>2]=d;return a|0}e=Tb(b);b=Db(b);d=jb-16|0;jb=d;a:{if(b>>>0<=10){Ce(a,b);ag(a,e,b);t[d+15|0]=0;Rd(a+b|0,d+15|0);break a}c=w[a+11|0];Yn(a,10,b-10|0,c,0,c,b,e)}jb=d+16|0;return a|0}e=Tb(b);b=Db(b);d=jb-16|0;jb=d;c=hj(a);b:{if(c>>>0>b>>>0){c=v[a>>2];ae(a,b);ag(c,e,b);t[d+15|0]=0;Rd(b+c|0,d+15|0);break b}f=c-1|0;g=(b-c|0)+1|0;c=v[a+4>>2];Yn(a,f,g,c,0,c,b,e)}jb=d+16|0}return a|0}function s$(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;a=jb-32|0;jb=a;u[a+28>>1]=w[59285]|w[59286]<<8;v[a+24>>2]=w[59281]|w[59282]<<8|(w[59283]<<16|w[59284]<<24);g=a+24|0;_j(g|1,6834,0,v[c+4>>2]);i=v[c+4>>2];f=a-16|0;jb=f;h=ge();v[a>>2]=e;g=df(f,i>>>9&1|12,h,g,a)+f|0;i=ug(f,g,c);e=f-32|0;jb=e;h=a+8|0;Ac(h,c);v[113382]=0;ja(2356,f|0,i|0,g|0,e|0,a+20|0,a+16|0,h|0);f=v[113382];v[113382]=0;if((f|0)!=1){Ob(a+8|0);b=_l(b,e,v[a+20>>2],v[a+16>>2],c,d);jb=a+32|0;return b|0}b=P()|0;O()|0;Ob(a+8|0);S(b|0);L()}function h$(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;a=jb-32|0;jb=a;u[a+28>>1]=w[59285]|w[59286]<<8;v[a+24>>2]=w[59281]|w[59282]<<8|(w[59283]<<16|w[59284]<<24);g=a+24|0;_j(g|1,6834,0,v[c+4>>2]);i=v[c+4>>2];f=a-16|0;jb=f;h=ge();v[a>>2]=e;g=df(f,i>>>9&1|12,h,g,a)+f|0;i=ug(f,g,c);e=f-96|0;jb=e;h=a+8|0;Ac(h,c);v[113382]=0;ja(2365,f|0,i|0,g|0,e|0,a+20|0,a+16|0,h|0);f=v[113382];v[113382]=0;if((f|0)!=1){Ob(a+8|0);b=zm(b,e,v[a+20>>2],v[a+16>>2],c,d);jb=a+32|0;return b|0}b=P()|0;O()|0;Ob(a+8|0);S(b|0);L()}function pL(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;e=jb-16|0;jb=e;v[e+12>>2]=c;g=e+12|0;c=a;d=Kb(c);a:{if(d>>>0<b>>>0){f=jb-32|0;jb=f;b:{d=b-d|0;c:{if(d>>>0<=v[zb(c)>>2]-v[c+4>>2]>>2>>>0){DB(c,d,g);break c}b=zb(c);b=Nf(f+8|0,ye(c,Kb(c)+d|0),Kb(c),b);v[113382]=0;U(1408,b|0,d|0,g|0);d=v[113382];v[113382]=0;if((d|0)==1){break b}v[113382]=0;R(96,c|0,b|0);c=v[113382];v[113382]=0;if((c|0)==1){break b}nk(b)}jb=f+32|0;break a}a=P()|0;O()|0;nk(b);S(a|0);L()}if(b>>>0<d>>>0){aL(c,v[c>>2]+(b<<2)|0)}}_x(a);jb=e+16|0}function zU(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;fG(b);a:{if(!(w[a|0]|w[a+1|0]<<8)){c=a+2|0;if(!(w[c|0]|w[c+1|0]<<8)){break a}}v[b+20>>2]=((w[a|0]|w[a+1|0]<<8)>>>9|0)+80;d=b,e=Yb((w[a|0]|w[a+1|0]<<8)>>>5&15,1,12)-1|0,v[d+16>>2]=e;d=b,e=Yb((w[a|0]|w[a+1|0]<<8)&31,1,31),v[d+12>>2]=e;c=a+2|0;d=b,e=Yb((w[c|0]|w[c+1|0]<<8)>>>11|0,0,23),v[d+8>>2]=e;d=b,e=Yb((w[c|0]|w[c+1|0]<<8)>>>5&63,0,59),v[d+4>>2]=e;d=b,e=Yb((w[c|0]|w[c+1|0]<<8)<<1&62,0,59),v[d>>2]=e}a=a+4|0;v[b+44>>2]=w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24)}function Oga(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=jb-32|0;jb=d;e=jb-16|0;jb=e;c=w[c|0]|w[c+1|0]<<8;u[e+14>>1]=c<<8|c>>>8;c=jb-16|0;jb=c;kI(c,e+14|0);v[113382]=0;f=d+16|0;U(13,f|0,0,c|0);g=v[113382];v[113382]=0;a:{if((g|0)!=1){yb(c);jb=c+16|0;break a}a=P()|0;O()|0;yb(c);S(a|0);L()}jb=e+16|0;v[113382]=0;R(71,d|0,f|0);c=v[113382];v[113382]=0;b:{if((c|0)==1){break b}v[113382]=0;U(72,a|0,b|0,d|0);a=v[113382];v[113382]=0;if((a|0)==1){break b}Ib(d+16|0);jb=d+32|0;return}a=P()|0;O()|0;Ib(d+16|0);S(a|0);L()}function M1(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=C(0),i=0,j=0,k=0;e=jb-16|0;jb=e;j=v[a+4>>2];sH(a,b,c,d);h=z[a+28>>2];b=v[a+24>>2];v[e+8>>2]=v[a+20>>2];v[e+12>>2]=b;b=v[a+16>>2];v[e>>2]=v[a+12>>2];v[e+4>>2]=b;a=jb-16|0;jb=a;b=v[e+12>>2];v[a+8>>2]=v[e+8>>2];v[a+12>>2]=b;b=v[e+4>>2];v[a>>2]=v[e>>2];v[a+4>>2]=b;b=a;if(!(!d|h==C(1))){while(1){if(c){k=g+j|0;f=0;while(1){i=nn(b,f,k);z[i>>2]=z[i>>2]*h;f=f+1|0;if((f|0)!=(c|0)){continue}break}}g=g+1|0;if((g|0)!=(d|0)){continue}break}}jb=a+16|0;jb=e+16|0}function S4(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;f=jb-16|0;jb=f;v[113382]=0;Z(1984,a|0);g=v[113382];v[113382]=0;a:{b:{if((g|0)!=1){c:{g=v[a+24>>2];v[113382]=0;ma(2040,f|0,g|0,b|0,c|0,d|0,e|0);b=v[113382];v[113382]=0;if((b|0)==1){break c}b=Ud(Tb(f));yb(f);break b}}b=V(0)|0;O()|0;_(b|0)|0;b=0;v[113382]=0;X(1958,8434,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$()}jb=f+16|0;return b|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function R4(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;f=jb-16|0;jb=f;v[113382]=0;Z(1984,a|0);g=v[113382];v[113382]=0;a:{b:{if((g|0)!=1){c:{g=v[a+24>>2];v[113382]=0;ma(2041,f|0,g|0,b|0,c|0,d|0,e|0);b=v[113382];v[113382]=0;if((b|0)==1){break c}b=Ud(Tb(f));yb(f);break b}}b=V(0)|0;O()|0;_(b|0)|0;b=0;v[113382]=0;X(1958,8334,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$()}jb=f+16|0;return b|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function DW(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;if(rg(a,v[b+8>>2],e)){rv(b,c,d);return}a:{if(rg(a,v[b>>2],e)){if(!(v[b+16>>2]!=(c|0)&v[b+20>>2]!=(c|0))){if((d|0)!=1){break a}v[b+32>>2]=1;return}v[b+32>>2]=d;b:{if(v[b+44>>2]==4){break b}u[b+52>>1]=0;a=v[a+8>>2];nb[v[v[a>>2]+20>>2]](a,b,c,c,1,e);if(w[b+53|0]){v[b+44>>2]=3;if(!w[b+52|0]){break b}break a}v[b+44>>2]=4}v[b+20>>2]=c;v[b+40>>2]=v[b+40>>2]+1;if(v[b+36>>2]!=1|v[b+24>>2]!=2){break a}t[b+54|0]=1;return}a=v[a+8>>2];nb[v[v[a>>2]+24>>2]](a,b,c,d,e)}}function Qy(a,b){var c=0,d=0,e=0,f=0,g=0;c=jb-16|0;jb=c;a:{if(id(a)){break a}u[v[a>>2]>>1]=0;We(v[a>>2]+2|0,b);f=c,g=ac(a),v[f>>2]=g;f=c,g=sp(c,1),v[f+8>>2]=g;f=c,g=bc(a),v[f>>2]=g;if(!Jb(c+8|0,c)){break a}while(1){d=c+8|0;e=v[d>>2];f=c,g=XN(d,1),v[f>>2]=g;e=x[Ri(e,v[c>>2])>>1];u[v[d>>2]>>1]=e;We(v[c+8>>2]+2|0,b);Ie(d);f=c,g=bc(a),v[f>>2]=g;if(Jb(d,c)){continue}break}}We(a+14|0,Kb(a)-1&255);We(a+13|0,w[a+14|0]);We(a+16|0,Kb(a)-1&255);We(a+15|0,w[a+16|0]);if(w[a+17|0]!=255){We(a+17|0,Kb(a)-1&255)}jb=c+16|0}function kl(a,b,c,d,e,f){var g=0,h=0,i=0,j=0;a:{if(f&64){c=f+-64|0;b=c&31;if((c&63)>>>0>=32){c=0;b=e>>>b|0}else{c=e>>>b|0;b=((1<<b)-1&e)<<32-b|d>>>b}d=0;e=0;break a}if(!f){break a}h=e;i=d;j=64-f|0;g=j&31;if((j&63)>>>0>=32){h=i<<g;j=0}else{h=(1<<g)-1&i>>>32-g|h<<g;j=i<<g}i=b;g=f;b=g&31;if((g&63)>>>0>=32){g=0;b=c>>>b|0}else{g=c>>>b|0;b=((1<<b)-1&c)<<32-b|i>>>b}b=j|b;c=g|h;g=d;d=f&31;if((f&63)>>>0>=32){h=0;d=e>>>d|0}else{h=e>>>d|0;d=((1<<d)-1&e)<<32-d|g>>>d}e=h}v[a>>2]=b;v[a+4>>2]=c;v[a+8>>2]=d;v[a+12>>2]=e}function yaa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0;while(1){c=g&255;b=0;d=0;while(1){b=c&1|b<<1;c=(c&254)>>>1|0;d=d+1|0;if((d|0)!=8){continue}break}b=(b&255)<<24;f=0;c=0;while(1){e=f;d=b<<1|e>>>31;e=e<<1;b=(b|0)>0|(b|0)>=0;f=b?e:e^-1798752855;b=b?d:d^-1382821323;c=c+1|0;if((c|0)!=8){continue}break}h=0;d=0;c=0;while(1){e=h;d=d<<1|e>>>31;h=f&1|e<<1;e=b;b=b>>>1|0;f=(e&1)<<31|f>>>1;c=c+1|0;if((c|0)!=64){continue}break}b=(g<<3)+80368|0;v[b>>2]=h;v[b+4>>2]=d;g=g+1|0;if((g|0)!=256){continue}break}return a|0}function Pca(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;e=jb-16|0;jb=e;f=Xb(a);a:{b:{c:{if(xc(b)){a=0;while(1){d:{if(!a){break d}v[113382]=0;Q(1214,f|0,c|0)|0;d=v[113382];v[113382]=0;if((d|0)!=1){break d}a=P()|0;O()|0;break a}d=od(b,a);v[113382]=0;R(1215,e|0,d|0);d=v[113382];v[113382]=0;if((d|0)==1){break c}v[113382]=0;Q(1214,f|0,e|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break b}yb(e);a=a+1|0;if(xc(b)>>>0>a>>>0){continue}break}}jb=e+16|0;return}a=P()|0;O()|0;break a}a=P()|0;O()|0;yb(e)}yb(f);S(a|0);L()}function Ega(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;a:{b:{if(!Be(a)){break b}f=v[a>>2];if(f>>>0<=c>>>0|f-c>>>0<d>>>0){break b}ln(b);az(b,a);v[b+20>>2]=0;v[b>>2]=d;if(!qp(b)){break b}if(v[a>>2]!=(d|0)){Qb(b+68|0,0,36)}f=v[b+20>>2];v[113382]=0;f=T(423,f|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break a}a=v[a+20>>2];v[113382]=0;a=T(423,a|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break a}lc(f,a+c|0,d);v[b+8>>2]=e?d:0;v[b+4>>2]=0;u[b+34>>1]=x[b+34>>1]&65533|(e?2:0)}return}V(0)|0;O()|0;Ab();L()}function Rx(a,b,c){var d=0,e=0;e=jb-16|0;jb=e;d=e+8|0;Fb(d,a+1074312|0,21);a:{if(Cb(d)){c=c&255;b:{switch((b&3)-1|0){default:d=t[c+26848|0];break a;case 0:d=64-(c+1>>>1|0)|0;break a;case 1:d=(c>>>0<128)<<6;break a;case 2:break b}}d=PK(_m(a))+-64|0;break a}d=t[(c>>>1&31)+25968|0];if(v[a+480180>>2]&67633152){break a}a=c&63;c:{switch((b&3)-1|0){default:d=t[a+26720|0];break a;case 0:d=(a>>>0<32?0:255)-(a<<2)|0;break a;case 1:d=a>>>0<32?127:-127;break a;case 2:break c}}d=t[a+26784|0]}a=d;jb=e+16|0;return a}function Vba(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;e=jb-16|0;jb=e;v[e+8>>2]=c>>>3;v[e+4>>2]=v[a>>2];d=v[Lb(e+8|0,e+4|0)>>2];b=Eb(b);if(d){a=v[a+20>>2];c=d;while(1){g=w[b+4|0]|w[b+5|0]<<8|(w[b+6|0]<<16|w[b+7|0]<<24);v[e+8>>2]=w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24);v[e+12>>2]=g;Vf(e+8|0,-1,1);f=A[e+8>>3]*32768;A[e+8>>3]=f;g=a;f=Md(f);a:{if(D(f)<2147483648){h=~~f;break a}h=-2147483648}i=g,j=Rc(h),u[i>>1]=j;a=a+2|0;b=b+8|0;c=c-1|0;if(c){continue}break}}jb=e+16|0;return d<<3}function f3(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0;b=jb-32|0;jb=b;a:{b:{if(mi(a)){Ho(b+24|0);break b}c=b+8|0;Nm(c,a);v[113382]=0;c=T(2142,c|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break a}v[b+24>>2]=c;qf(b+8|0)}if(mi(a)){c=a+36|0}else{c=v[b+24>>2]}a=v[a+8>>2];c:{if((a|0)==-1){f=b,g=ac(c),v[f+8>>2]=g;f=b,g=bc(c),v[f>>2]=g;if(!Jb(b+8|0,b)){break c}while(1){a=b+8|0;d=A[v[a>>2]>>3]+d;Kk(a);if(Jb(a,b)){continue}break}break c}d=A[Qc(c,a)>>3]}hk(b+24|0);jb=b+32|0;return+d}a=P()|0;O()|0;qf(b+8|0);S(a|0);L()}function Yba(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=C(0),h=0,i=0,j=0;e=jb-16|0;jb=e;v[e+8>>2]=c>>>2;v[e+4>>2]=v[a>>2];d=v[Lb(e+8|0,e+4|0)>>2];b=Eb(b);if(d){c=v[a+20>>2];a=d;while(1){f=w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24);v[e+12>>2]=f<<24|f<<8&16711680|(f>>>8&65280|f>>>24);Wd(e+12|0,C(-1));g=C(z[e+12>>2]*C(32768));z[e+12>>2]=g;f=c;g=de(g);a:{if(C(D(g))<C(2147483648)){h=~~g;break a}h=-2147483648}i=f,j=Rc(h),u[i>>1]=j;c=c+2|0;b=b+4|0;a=a-1|0;if(a){continue}break}}jb=e+16|0;return d<<2}function Ox(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0;h=jb-16|0;jb=h;a:{if((c|0)<2){break a}j=c-2>>>1|0;f=d-a|0;if((j|0)<f>>1){break a}g=f+1|0;e=(g<<1)+a|0;f=f+2|0;if((f|0)<(c|0)){i=Uo(b,x[e>>1],x[e+2>>1]);e=i?e+2|0:e;g=i?f:g}if(Uo(b,x[e>>1],x[d>>1])){break a}u[h+14>>1]=x[d>>1];while(1){b:{f=e;u[d>>1]=x[e>>1];if((g|0)>(j|0)){break b}d=g<<1;g=d|1;e=(g<<1)+a|0;d=d+2|0;if((d|0)<(c|0)){i=Uo(b,x[e>>1],x[e+2>>1]);e=i?e+2|0:e;g=i?d:g}d=f;if(!Uo(b,x[e>>1],x[h+14>>1])){continue}}break}u[f>>1]=x[h+14>>1]}jb=h+16|0}function m9(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;d=jb-16|0;jb=d;g=d;e=u[b>>1];f=e;b=u[a+30>>1];a:{if(!b){break a}if((e|0)>=0){f=(e|0)%(b|0)|0;break a}f=b+((e^-1)%(b|0)^-1)|0}u[g+14>>1]=f;b:{if(!Sc(c)){Xi(QJ(a+52|0,d+14|0),c);break b}h=a+52|0;i=d,j=ux(h,d+14|0),v[i+8>>2]=j;i=d,j=Ii(h),v[i>>2]=j;if(!Hi(d+8|0,d)){break b}e=jb-16|0;jb=e;a=v[Oc(e,v[d+8>>2])>>2];f=jb-16|0;jb=f;v[f+8>>2]=a;g=f+8|0;c=v[g>>2];b=IJ(h,c);a=jc(h);Bk(lh(g));Ug(a,c,1);jb=f+16|0;Oc(e+8|0,b);jb=e+16|0}jb=d+16|0}function NN(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=b?33:32;c=w[a+16|0];k=c?-1:1;l=c?1:-1;e=v[a+8>>2]-1|0;m=c?e-(w[a+17|0]!=0&(e|0)!=0)|0:0;n=c?0:e;f=v[a+12>>2];h=v[a>>2]+B(f,62)|0;d=b?1:-1;o=B(f,d)<<1;c=e;while(1){if((f|0)>0){g=B(c,f);p=v[a+4>>2];b=0;while(1){u[(b<<1)+h>>1]=x[p+(b+g<<1)>>1];b=b+1|0;if((f|0)!=(b|0)){continue}break}}h=h+o|0;a:{if((c|0)==(e|0)){b=m;g=k;if((d|0)>0){break a}}b=c+d|0;c=!c&(d|0)<0;b=c?n:b;g=c?l:d}d=g;c=b;i=i+1|0;if((j|0)!=(i|0)){continue}break}}function K5(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;v[113382]=0;Z(1984,a|0);d=v[113382];v[113382]=0;a:{if((d|0)==1){break a}v[113382]=0;Z(1995,c|0);d=v[113382];v[113382]=0;if((d|0)==1){break a}d=v[a+24>>2];v[113382]=0;b=Q(1996,d|0,b|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break a}v[c>>2]=b;return 1}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,6441,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)!=1){$();return 0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function HV(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;e=jb-16|0;jb=e;f=bd(a);a:{b:{c:{if(xc(b)){a=0;while(1){d:{if(!a){break d}v[113382]=0;Q(162,f|0,c|0)|0;d=v[113382];v[113382]=0;if((d|0)!=1){break d}a=P()|0;O()|0;break a}d=od(b,a);v[113382]=0;R(222,e|0,d|0);d=v[113382];v[113382]=0;if((d|0)==1){break c}v[113382]=0;Q(162,f|0,e|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break b}yb(e);a=a+1|0;if(xc(b)>>>0>a>>>0){continue}break}}jb=e+16|0;return}a=P()|0;O()|0;break a}a=P()|0;O()|0;yb(e)}yb(f);S(a|0);L()}function MN(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;k=b?33:32;f=v[a+8>>2];c=f-1|0;d=v[a+12>>2];g=v[a>>2]+B(d,31)|0;h=b?1:-1;e=h;while(1){b=0;if((d|0)>0){while(1){t[b+g|0]=w[v[a+4>>2]+(B(c,d)+b|0)|0];b=b+1|0;d=v[a+12>>2];if((b|0)<(d|0)){continue}break}f=v[a+8>>2]}b=B(d,h);i=f-1|0;a:{if(!((i|0)!=(c|0)|(e|0)<=0)){if(!w[a+16|0]){e=1;c=0;break a}e=-1;c=c-(w[a+17|0]!=0&(c|0)!=0)|0;break a}if(!((e|0)>=0|c)){c=w[a+16|0];e=c?1:-1;c=c?0:i;break a}c=c+e|0}g=b+g|0;j=j+1|0;if((k|0)!=(j|0)){continue}break}}function rp(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=x[a+34>>1];if(!b){b=a;if(d&512){RN(a);d=x[a+34>>1]}u[b+34>>1]=d&65023;return}v[a>>2]=4;u[a+34>>1]=d&64958|512;qp(a);b=w[c+8|0]|w[c+9|0]<<8|(w[c+10|0]<<16|w[c+11|0]<<24);t[a+76|0]=b;t[a+77|0]=b>>>8;t[a+78|0]=b>>>16;t[a+79|0]=b>>>24;b=w[c+4|0]|w[c+5|0]<<8|(w[c+6|0]<<16|w[c+7|0]<<24);c=w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24);t[a+68|0]=c;t[a+69|0]=c>>>8;t[a+70|0]=c>>>16;t[a+71|0]=c>>>24;t[a+72|0]=b;t[a+73|0]=b>>>8;t[a+74|0]=b>>>16;t[a+75|0]=b>>>24}function c$(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;a=jb-208|0;jb=a;u[a+204>>1]=w[59291]|w[59292]<<8;v[a+200>>2]=w[59287]|w[59288]<<8|(w[59289]<<16|w[59290]<<24);f=ge();v[a>>2]=e;g=a+176|0;i=df(g,20,f,a+200|0,a);e=i+g|0;g=ug(g,e,c);f=a+8|0;Ac(f,c);v[113382]=0;f=T(2339,f|0)|0;h=v[113382];v[113382]=0;if((h|0)!=1){Ob(a+8|0);h=f;f=a+16|0;zF(h,a+176|0,e,f);h=b;b=f+(i<<2)|0;b=zm(h,f,(e|0)==(g|0)?b:((g-a<<2)+a|0)-688|0,b,c,d);jb=a+208|0;return b|0}b=P()|0;O()|0;Ob(a+8|0);S(b|0);L()}function JG(a){var b=0,c=0,d=0,e=0;b=jb-160|0;jb=b;a=Im(b+16|0,a,8);d=v[v[a>>2]-12>>2];v[113382]=0;c=da(123)|0;e=v[113382];v[113382]=0;a:{if((e|0)==1){break a}v[113382]=0;U(124,b+8|0,d+(b+16|0)|0,c|0);d=v[113382];v[113382]=0;if((d|0)==1){break a}Ob(b+8|0);v[113382]=0;d=Q(150,a|0,b+4|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break a}c=v[v[d>>2]-12>>2];v[113382]=0;d=T(151,c+d|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break a}c=v[b+4>>2];Mf(a);jb=b+160|0;return d?0:c}b=P()|0;O()|0;Mf(a);S(b|0);L()}function Ur(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;d=jb-32|0;jb=d;f=a;c=v[b>>2];e=v[b+4>>2]?c&24576?c:c&-12289|8192:c;b=v[b+8>>2];c=(b|0)!=-1?e:c;a:{if(c&1){e=142}else{if(!(c&2)){break a}e=143}Uw(f,e)}b:{if(c&4096){break b}if(c&8192){g=d,h=Pg(4),v[g+24>>2]=h;pH(a,d+24|0);break b}if(!(c&16384)){break b}g=d,h=Pg(256),v[g+16>>2]=h;pH(a,d+16|0)}f=a;c:{if(c&16){c=144}else{if(!(c&32)){break c}c=145}Uw(f,c)}if((b|0)!=-1){g=d,h=Pg(b),v[g+8>>2]=h;v[(v[v[a>>2]-12>>2]+a|0)+8>>2]=v[d+8>>2]}jb=d+32|0}function ef(a,b,c,d,e,f){var g=0,h=0,i=0,j=0;a:{if(f&64){d=b;e=f+-64|0;b=e&31;if((e&63)>>>0>=32){e=d<<b;d=0}else{e=(1<<b)-1&d>>>32-b|c<<b;d=d<<b}b=0;c=0;break a}if(!f){break a}g=d;i=f;d=f&31;if((f&63)>>>0>=32){h=g<<d;j=0}else{h=(1<<d)-1&g>>>32-d|e<<d;j=g<<d}d=c;g=b;f=64-f|0;e=f&31;if((f&63)>>>0>=32){f=0;d=d>>>e|0}else{f=d>>>e|0;d=((1<<e)-1&d)<<32-e|g>>>e}d=j|d;e=f|h;f=b;b=i&31;if((i&63)>>>0>=32){h=f<<b;b=0}else{h=(1<<b)-1&f>>>32-b|c<<b;b=f<<b}c=h}v[a>>2]=b;v[a+4>>2]=c;v[a+8>>2]=d;v[a+12>>2]=e}function _ba(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=jb-16|0;jb=e;v[e+12>>2]=c>>>4;v[e+8>>2]=v[a>>2];d=v[Lb(e+12|0,e+8|0)>>2];b=Eb(b);if(d){a=v[a+20>>2];c=d;while(1){Eb(w[b+7|0]);Eb(w[b+6|0]);Eb(w[b+5|0]);Eb(w[b+4|0]);Eb(w[b+3|0]);Eb(w[b+2|0]);f=a,g=Eb(w[b+1|0])|Eb(w[b|0])<<8,u[f>>1]=g;Eb(w[b+15|0]);Eb(w[b+14|0]);Eb(w[b+13|0]);Eb(w[b+12|0]);Eb(w[b+11|0]);Eb(w[b+10|0]);f=a,g=Eb(w[b+9|0])|Eb(w[b+8|0])<<8,u[f+2>>1]=g;a=a+4|0;b=b+16|0;c=c-1|0;if(c){continue}break}}jb=e+16|0;return d<<4}function _L(a,b,c,d){var e=0,f=0;e=jb-16|0;jb=e;a:{b:{c:{if(!d){break c}d=c>>31;d=d+c^d;if(d>>>0<224){break c}f=e+8|0;Fb(f,a+1074312|0,3);if(Cb(f)){break c}if(!(t[(B(b,896)+a|0)+1075856|0]&1)){break a}c=B((c>>31)+((c|0)>0)|0,d&15);c=d>>>0>239?c<<2:c;break b}if(t[(B(b,896)+a|0)+1075856|0]&1){d=e+8|0;Fb(d,a+1074312|0,3);if(!Cb(d)){break a}}c=c<<2}if(!c){break a}d=jy(a,b);if(!d){break a}f=d;a=v[(B(b,896)+a|0)+1075640>>2];if(a){a=w[a+33|0]}else{a=13}nb[v[v[d>>2]+80>>2]](f,c,a<<24>>24,b)}jb=e+16|0}function Nka(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;f=jb-32|0;jb=f;v[f+28>>2]=c;g=Rb(b,c<<2);a:{if(!g){break a}tc(f+28|0,65535);lg(a,x[f+28>>1]);h=f,i=ac(a),v[h+16>>2]=i;h=f,i=bc(a),v[h+8>>2]=i;if(!Jb(f+16|0,f+8|0)){break a}while(1){a=v[f+16>>2];c=f+24|0;Gt(b,c);c=w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24);u[a>>1]=c;c=c&65535;b:{if((c|0)==(d|0)){c=65535}else{if((c|0)!=(e|0)){break b}c=65534}u[a>>1]=c}a=f+16|0;re(a);if(Jb(a,f+8|0)){continue}break}}jb=f+32|0;return g|0}function $ba(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=jb-16|0;jb=e;v[e+12>>2]=c>>>4;v[e+8>>2]=v[a>>2];d=v[Lb(e+12|0,e+8|0)>>2];b=Eb(b);if(d){a=v[a+20>>2];c=d;while(1){Eb(w[b|0]);Eb(w[b+1|0]);Eb(w[b+2|0]);Eb(w[b+3|0]);Eb(w[b+4|0]);Eb(w[b+5|0]);f=a,g=Eb(w[b+6|0])|Eb(w[b+7|0])<<8,u[f>>1]=g;Eb(w[b+8|0]);Eb(w[b+9|0]);Eb(w[b+10|0]);Eb(w[b+11|0]);Eb(w[b+12|0]);Eb(w[b+13|0]);f=a,g=Eb(w[b+14|0])|Eb(w[b+15|0])<<8,u[f+2>>1]=g;a=a+4|0;b=b+16|0;c=c-1|0;if(c){continue}break}}jb=e+16|0;return d<<4}function zda(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;a:{e=jb-16|0;jb=e;d=c;zb(d);a=b;h=wN(b,e+8|0);b:{f=oc(d);if(!f){break b}v[113382]=0;R(882,a|0,f|0);g=v[113382];v[113382]=0;if((g|0)!=1){g=v[d+4>>2];d=v[d>>2];v[113382]=0;X(1159,a|0,d|0,g|0,f|0);d=v[113382];v[113382]=0;if((d|0)!=1){break b}}a=P()|0;O()|0;dq(h);S(a|0);L()}jb=e+16|0;v[113382]=0;Q(4,b+12|0,c+12|0)|0;d=v[113382];v[113382]=0;if((d|0)!=1){v[b+24>>2]=v[c+24>>2];u[b+28>>1]=x[c+28>>1];break a}b=P()|0;O()|0;nf(a);S(b|0);L()}}function i$(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;a=jb-32|0;jb=a;v[a+24>>2]=37;v[a+28>>2]=0;h=a+24|0;_j(h|1,6675,1,v[c+4>>2]);i=v[c+4>>2];g=a-32|0;jb=g;j=ge();v[a>>2]=e;v[a+4>>2]=f;e=i>>>9&1;f=df(g,e+23|0,j,h,a)+g|0;h=ug(g,f,c);e=g-((e<<3)+187&240)|0;jb=e;i=a+8|0;Ac(i,c);v[113382]=0;ja(2365,g|0,h|0,f|0,e|0,a+20|0,a+16|0,i|0);f=v[113382];v[113382]=0;if((f|0)!=1){Ob(a+8|0);b=zm(b,e,v[a+20>>2],v[a+16>>2],c,d);jb=a+32|0;return b|0}b=P()|0;O()|0;Ob(a+8|0);S(b|0);L()}function g$(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;a=jb-32|0;jb=a;v[a+24>>2]=37;v[a+28>>2]=0;h=a+24|0;_j(h|1,6675,0,v[c+4>>2]);i=v[c+4>>2];g=a-32|0;jb=g;j=ge();v[a>>2]=e;v[a+4>>2]=f;e=i>>>9&1;f=df(g,e+23|0,j,h,a)+g|0;h=ug(g,f,c);e=g-((e<<3)+187&240)|0;jb=e;i=a+8|0;Ac(i,c);v[113382]=0;ja(2365,g|0,h|0,f|0,e|0,a+20|0,a+16|0,i|0);f=v[113382];v[113382]=0;if((f|0)!=1){Ob(a+8|0);b=zm(b,e,v[a+20>>2],v[a+16>>2],c,d);jb=a+32|0;return b|0}b=P()|0;O()|0;Ob(a+8|0);S(b|0);L()}function Ow(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=jb-32|0;jb=e;v[e+24>>2]=b;m=e,n=Bd(a),v[m+16>>2]=n;j=dm(e+24|0,e+16|0);h=j;i=jb-16|0;jb=i;a:{b=a;g=Db(b);if(g>>>0>=h>>>0){if(c){f=Fc(b);b:{if(f-g>>>0>=c>>>0){f=Tb(b);k=g-h|0;if(!k){break b}l=f+h|0;am(l+c|0,l,k);break b}Rl(b,f,(c+g|0)-f|0,g,h,0,c);f=v[b>>2]}Ey(f+h|0,c,d);d=b;b=c+g|0;Vg(d,b);t[i+15|0]=0;Rd(b+f|0,i+15|0)}jb=i+16|0;break a}pm();L()}m=e,n=Bd(a),v[m+8>>2]=n;a=ff(e+8|0,j);jb=e+32|0;return a|0}function D_(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;f=jb-16|0;jb=f;d=Db(a);e=oo(a);g=rt(b,c);a:{if(!g){break a}if(iA(b,Tb(a),Tb(a)+(Db(a)<<2)|0)){d=jb-16|0;jb=d;EF(f,b,c);jb=d+16|0;b=f;c=Tb(b);d=Db(b);v[113382]=0;W(2391,a|0,c|0,d|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){Jc(b);break a}a=P()|0;O()|0;Jc(b);S(a|0);L()}if(e-d>>>0<g>>>0){KD(a,e,(d+g|0)-e|0,d,d)}e=Tb(a)+(d<<2)|0;while(1){if((b|0)!=(c|0)){Te(e,b);b=b+4|0;e=e+4|0;continue}break}v[f>>2]=0;Te(e,f);Vg(a,d+g|0)}jb=f+16|0;return a|0}function T$(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=jb-16|0;jb=e;a:{b:{c:{if((a|0)!=(b|0)){d:{e:{f=w[a|0];if((f|0)!=45){break e}a=a+1|0;if((b|0)!=(a|0)){break e}break d}h=v[113305];v[113305]=0;a=ew(a,e+12|0,d,ge());d=mb;g=v[113305];f:{if(g){if(v[e+12>>2]!=(b|0)){break f}if((g|0)==68){break c}break b}v[113305]=h;if(v[e+12>>2]==(b|0)){break b}}}}v[c>>2]=4;a=0;b=0;break a}v[c>>2]=4;a=-1;b=-1;break a}b=a;c=(f|0)==45;a=c?0-a|0:a;b=c?0-(d+((b|0)!=0)|0)|0:d}jb=e+16|0;mb=b;return a|0}function jN(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;d=jb-16|0;jb=d;v[d+12>>2]=b;a:{if(qj(a)){g=d;e=jb-16|0;jb=e;c=Pe(3848);b=v[d+12>>2];v[113382]=0;f=Q(1163,c|0,b|0)|0;b=v[113382];v[113382]=0;b:{if((b|0)!=1){c=jb-16|0;jb=c;v[113382]=0;v[c+12>>2]=f;b=e+8|0;W(1164,b|0,c+12|0,c+8|0)|0;f=v[113382];v[113382]=0;c:{if((f|0)!=1){jb=c+16|0;break c}V(0)|0;O()|0;Ab();L()}jb=e+16|0;b=v[b>>2];break b}a=P()|0;O()|0;Wb(c);S(a|0);L()}v[g+8>>2]=b;b=d+8|0;Fs(a,b);vf(b);break a}rN(v[a>>2],b)}hN(a);jb=d+16|0}function h2(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;f=jb-16|0;jb=f;c=jb-144|0;jb=c;d=li(c+8|0);e=v[v[d>>2]-12>>2];v[113382]=0;g=da(123)|0;h=v[113382];v[113382]=0;a:{b:{if((h|0)==1){break b}v[113382]=0;U(124,c|0,e+(c+8|0)|0,g|0);e=v[113382];v[113382]=0;if((e|0)==1){break b}Ob(c);v[113382]=0;R(134,d|0,b|0);b=v[113382];v[113382]=0;if((b|0)==1){break b}v[113382]=0;R(126,a|0,d|0);a=v[113382];v[113382]=0;if((a|0)==1){break b}Td(d);jb=c+144|0;break a}a=P()|0;O()|0;Td(d);S(a|0);L()}jb=f+16|0}function gT(a,b,c){var d=0,e=0,f=0;e=jb+-64|0;jb=e;Ee(b);d=e+40|0;Ze(d,a,c);a=v[d>>2];v[113382]=0;d=T(426,d|0)|0;f=v[113382];v[113382]=0;a:{if((f|0)==1){break a}v[113382]=0;d=T(427,d|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break a}v[113382]=0;X(428,e+8|0,2,d|0,a|0);d=v[113382];v[113382]=0;if((d|0)==1){break a}v[113382]=0;R(356,e+24|0,e+8|0);d=v[113382];v[113382]=0;if((d|0)==1){break a}d=b;b=e+24|0;Gb(d,b);yb(b);Cc(e+40|0);jb=e- -64|0;return!c|(a|0)!=0}a=P()|0;O()|0;Cc(e+40|0);S(a|0);L()}function f2(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;f=jb-16|0;jb=f;c=jb-144|0;jb=c;d=li(c+8|0);e=v[v[d>>2]-12>>2];v[113382]=0;g=da(123)|0;h=v[113382];v[113382]=0;a:{b:{if((h|0)==1){break b}v[113382]=0;U(124,c|0,e+(c+8|0)|0,g|0);e=v[113382];v[113382]=0;if((e|0)==1){break b}Ob(c);v[113382]=0;R(135,d|0,b|0);b=v[113382];v[113382]=0;if((b|0)==1){break b}v[113382]=0;R(126,a|0,d|0);a=v[113382];v[113382]=0;if((a|0)==1){break b}Td(d);jb=c+144|0;break a}a=P()|0;O()|0;Td(d);S(a|0);L()}jb=f+16|0}function VA(a,b,c){var d=0,e=0,f=0;e=jb+-64|0;jb=e;Ee(b);d=e+40|0;Ze(d,a,c);a=v[d>>2];v[113382]=0;d=T(426,d|0)|0;f=v[113382];v[113382]=0;a:{if((f|0)==1){break a}v[113382]=0;d=T(427,d|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break a}v[113382]=0;X(428,e+8|0,3,d|0,a|0);d=v[113382];v[113382]=0;if((d|0)==1){break a}v[113382]=0;R(356,e+24|0,e+8|0);d=v[113382];v[113382]=0;if((d|0)==1){break a}d=b;b=e+24|0;Gb(d,b);yb(b);Cc(e+40|0);jb=e- -64|0;return!c|(a|0)!=0}a=P()|0;O()|0;Cc(e+40|0);S(a|0);L()}function WV(a){a=a|0;var b=0,c=0,d=0,e=0;b=jb-32|0;jb=b;c=Ub(b,12869);v[113382]=0;U(196,b+16|0,a|0,c|0);a=v[113382];v[113382]=0;a:{b:{c:{if((a|0)!=1){yb(c);if(xc(b+16|0)){break c}a=0;break a}d=P()|0;O()|0;yb(c);break b}a=0;while(1){d:{c=od(b+16|0,d);v[113382]=0;c=T(197,c|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break d}a=(c&255)<<24-(d<<3)|a;c=xc(b+16|0);if(d>>>0>2){break a}d=d+1|0;if(c>>>0>d>>>0){continue}break a}break}d=P()|0;O()|0;gl(b+16|0)}S(d|0);L()}gl(b+16|0);jb=b+32|0;return a|0}function vw(a,b){var c=0,d=0,e=0,f=0,g=0,h=0;e=jb-16|0;jb=e;f=(p(a),j(2));c=f&2147483647;a:{if(c>>>0<=1305022426){g=+a;d=g*.6366197723675814+6755399441055744+-6755399441055744;A[b>>3]=g+d*-1.5707963109016418+d*-1.5893254773528196e-8;if(D(d)<2147483648){c=~~d;break a}c=-2147483648;break a}if(c>>>0>=2139095040){A[b>>3]=C(a-a);c=0;break a}h=c;c=(c>>>23|0)-150|0;A[e+8>>3]=(l(2,h-(c<<23)|0),q());c=pG(e+8|0,e,c,1,0);d=A[e>>3];if((f|0)<0){A[b>>3]=-d;c=0-c|0;break a}A[b>>3]=d}jb=e+16|0;return c}function Hba(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=C(0),g=0,h=C(0),i=0,j=0,k=0;e=jb-16|0;jb=e;v[e+8>>2]=c>>>2;v[e+4>>2]=v[a>>2];c=v[Lb(e+8|0,e+4|0)>>2];h=z[d>>2];b=Eb(b);if(c){a=v[a+20>>2];d=c;while(1){z[e+12>>2]=h*(l(2,w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24)),q());Wd(e+12|0,C(-1));f=C(z[e+12>>2]*C(32768));z[e+12>>2]=f;i=a;f=de(f);a:{if(C(D(f))<C(2147483648)){g=~~f;break a}g=-2147483648}j=i,k=Rc(g),u[j>>1]=k;a=a+2|0;b=b+4|0;d=d-1|0;if(d){continue}break}}jb=e+16|0;return c<<2}function Efa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;b=jb-16|0;jb=b;h=v[a+24>>2];i=v[a+20>>2];j=v[a+16>>2];f=v[a+4>>2];e=f;g=v[a>>2];v[b+8>>2]=g;v[b+12>>2]=e;f=v[a+12>>2];v[b>>2]=v[a+8>>2];v[b+4>>2]=f;if(d){while(1){f=e+j|0;e=t[f|0];e=((B(t[f+1|0]-e|0,g>>>10&4194048)|0)/16384|0)+(e<<8)|0;v[c>>2]=v[c>>2]+B(e,i);v[c+4>>2]=v[c+4>>2]+B(e,h);Sb(b+8|0,b);d=d-1|0;if(d){c=c+8|0;g=v[b+8>>2];e=v[b+12>>2];continue}break}g=v[b+8>>2];e=v[b+12>>2]}v[a>>2]=g;v[a+4>>2]=e;jb=b+16|0}function zm(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;i=jb-16|0;jb=i;a:{b:{if(!a){break b}h=v[e+12>>2];g=c-b|0;if((g|0)>0){g=g>>2;if((Yl(a,b,g)|0)!=(g|0)){break b}}b=d-b>>2;b=(b|0)<(h|0)?h-b|0:0;if((b|0)>0){f=qF(i,b,f);h=Tb(f);v[113382]=0;h=W(2368,a|0,h|0,b|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break a}Jc(f);if((b|0)!=(h|0)){break b}}b=d-c|0;if((b|0)>0){b=b>>2;if((Yl(a,c,b)|0)!=(b|0)){break b}}cz(e);j=a}jb=i+16|0;return j|0}a=P()|0;O()|0;Jc(f);S(a|0);L()}function m$(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;a=jb-96|0;jb=a;u[a+92>>1]=w[59291]|w[59292]<<8;v[a+88>>2]=w[59287]|w[59288]<<8|(w[59289]<<16|w[59290]<<24);f=ge();v[a>>2]=e;g=a- -64|0;i=df(g,20,f,a+88|0,a);e=i+g|0;g=ug(g,e,c);f=a+8|0;Ac(f,c);v[113382]=0;f=T(21,f|0)|0;h=v[113382];v[113382]=0;if((h|0)!=1){Ob(a+8|0);h=f;f=a+16|0;CF(h,a- -64|0,e,f);h=b;b=f+i|0;b=_l(h,f,(e|0)==(g|0)?b:((g-a|0)+a|0)-48|0,b,c,d);jb=a+96|0;return b|0}b=P()|0;O()|0;Ob(a+8|0);S(b|0);L()}function W3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;f=jb-16|0;jb=f;d=b+4|0;zb(d);c=jb-16|0;jb=c;b=a;v[a>>2]=0;v[a+4>>2]=0;v[c+12>>2]=0;v[113382]=0;W(2093,a+8|0,c+12|0,f+8|0)|0;e=v[113382];v[113382]=0;a:{if((e|0)!=1){jb=c+16|0;break a}V(0)|0;O()|0;Ab();L()}b:{c=jd(d);if(!c){break b}v[113382]=0;R(2091,a|0,c|0);e=v[113382];v[113382]=0;if((e|0)!=1){e=v[d+4>>2];d=v[d>>2];v[113382]=0;X(2092,a|0,d|0,e|0,c|0);a=v[113382];v[113382]=0;if((a|0)!=1){break b}}a=P()|0;O()|0;hI(b);S(a|0);L()}jb=f+16|0}function Qp(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0;f=jb-32|0;jb=f;v[f+28>>2]=c;g=Rb(b,c);a:{if(!g){break a}tc(f+28|0,65535);lg(a,x[f+28>>1]);i=f,j=ac(a),v[i+16>>2]=j;i=f,j=bc(a),v[i+8>>2]=j;if(!Jb(f+16|0,f+8|0)){break a}while(1){a=v[f+16>>2];c=f+27|0;if(!_f(b,c)){h=jb-16|0;jb=h;jf(c);jb=h+16|0}c=w[f+27|0];u[a>>1]=c;b:{if((c|0)==(d|0)){c=65535}else{if((c|0)!=(e|0)){break b}c=65534}u[a>>1]=c}a=f+16|0;re(a);if(Jb(a,f+8|0)){continue}break}}jb=f+32|0;return g|0}function Dfa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;b=jb-16|0;jb=b;h=v[a+24>>2];i=v[a+20>>2];j=v[a+16>>2];f=v[a+4>>2];e=f;g=v[a>>2];v[b+8>>2]=g;v[b+12>>2]=e;f=v[a+12>>2];v[b>>2]=v[a+8>>2];v[b+4>>2]=f;if(d){while(1){f=(e<<1)+j|0;e=u[f>>1];e=e+((B(u[f+2>>1]-e|0,g>>>18|0)|0)/16384|0)|0;v[c>>2]=v[c>>2]+B(e,i);v[c+4>>2]=v[c+4>>2]+B(e,h);Sb(b+8|0,b);d=d-1|0;if(d){c=c+8|0;g=v[b+8>>2];e=v[b+12>>2];continue}break}g=v[b+8>>2];e=v[b+12>>2]}v[a>>2]=g;v[a+4>>2]=e;jb=b+16|0}function X$(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=jb-16|0;jb=e;a:{b:{c:{d:{if((a|0)!=(b|0)){e:{f:{f=w[a|0];if((f|0)!=45){break f}a=a+1|0;if((b|0)!=(a|0)){break f}break e}h=v[113305];v[113305]=0;a=ew(a,e+12|0,d,ge());d=mb;g=v[113305];g:{if(g){if(v[e+12>>2]!=(b|0)){break g}if((g|0)==68){break c}break d}v[113305]=h;if(v[e+12>>2]==(b|0)){break d}}}}v[c>>2]=4;a=0;break a}if(!d&a>>>0<=65535){break b}}v[c>>2]=4;a=65535;break a}a=(f|0)==45?0-a|0:a}jb=e+16|0;return a&65535}function $$(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=jb-16|0;jb=e;a:{b:{c:{if((a|0)!=(b|0)){g=v[113305];v[113305]=0;a=FF(a,e+12|0,d,ge());d=mb;f=v[113305];d:{if(f){if(v[e+12>>2]!=(b|0)){break d}if((f|0)==68){break b}break c}v[113305]=g;if(v[e+12>>2]==(b|0)){break c}}}v[c>>2]=4;b=0;break a}if((d|0)<0&a>>>0<2147483648|(d|0)<-1|(a>>>0>2147483647&(d|0)>=0|(d|0)>0)){break b}b=a;break a}v[c>>2]=4;b=2147483647;if(!!a&(d|0)>=0|(d|0)>0){break a}b=-2147483648}jb=e+16|0;return b|0}function Rfa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;b=jb-16|0;jb=b;g=v[a+24>>2];h=v[a+20>>2];i=v[a+16>>2];e=v[a+4>>2];f=v[a>>2];v[b+8>>2]=f;v[b+12>>2]=e;j=v[a+12>>2];v[b>>2]=v[a+8>>2];v[b+4>>2]=j;if(d){while(1){e=((((e&2147483647)<<1|f>>>31)&2147483646)<<1)+i|0;f=u[e+2>>1];v[c>>2]=v[c>>2]+B(u[e>>1],h);v[c+4>>2]=v[c+4>>2]+B(f,g);Sb(b+8|0,b);d=d-1|0;if(d){c=c+8|0;f=v[b+8>>2];e=v[b+12>>2];continue}break}f=v[b+8>>2];e=v[b+12>>2]}v[a>>2]=f;v[a+4>>2]=e;jb=b+16|0}function pT(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;f=jb-32|0;jb=f;v[f+28>>2]=c;g=Rb(b,c<<1);a:{if(!g){break a}tc(f+28|0,65535);lg(a,x[f+28>>1]);h=f,i=ac(a),v[h+16>>2]=i;h=f,i=bc(a),v[h+8>>2]=i;if(!Jb(f+16|0,f+8|0)){break a}while(1){a=v[f+16>>2];c=f+24|0;mu(b,c);c=w[c|0]|w[c+1|0]<<8;c=c<<8|c>>>8;u[a>>1]=c;c=c&65535;b:{if((c|0)==(d|0)){c=65535}else{if((c|0)!=(e|0)){break b}c=65534}u[a>>1]=c}a=f+16|0;re(a);if(Jb(a,f+8|0)){continue}break}}jb=f+32|0;return g|0}function D1(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=jb-48|0;jb=e;v[e+40>>2]=c;c=v[b+12>>2];v[e+32>>2]=v[b+8>>2];v[e+36>>2]=c;c=v[b+4>>2];v[e+24>>2]=v[b>>2];v[e+28>>2]=c;b=v[Io(e+16|0,e+40|0)>>2];v[113382]=0;c=v[e+36>>2];v[e+8>>2]=v[e+32>>2];v[e+12>>2]=c;c=v[e+28>>2];v[e>>2]=v[e+24>>2];v[e+4>>2]=c;aa(1982,a+8|0,e|0,b|0,d|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){lH(a);b=kH(a+88|0);v[a>>2]=79384;v[b>>2]=79472;ad(e+40|0);jb=e+48|0;return a|0}a=P()|0;O()|0;ad(e+40|0);S(a|0);L()}function t$(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;a=jb-32|0;jb=a;v[a+24>>2]=37;v[a+28>>2]=0;h=a+24|0;_j(h|1,6675,1,v[c+4>>2]);i=v[c+4>>2];g=a-32|0;jb=g;j=ge();v[a>>2]=e;v[a+4>>2]=f;f=df(g,(i>>>9&1)+23|0,j,h,a)+g|0;h=ug(g,f,c);e=g-48|0;jb=e;i=a+8|0;Ac(i,c);v[113382]=0;ja(2356,g|0,h|0,f|0,e|0,a+20|0,a+16|0,i|0);f=v[113382];v[113382]=0;if((f|0)!=1){Ob(a+8|0);b=_l(b,e,v[a+20>>2],v[a+16>>2],c,d);jb=a+32|0;return b|0}b=P()|0;O()|0;Ob(a+8|0);S(b|0);L()}function r$(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;a=jb-32|0;jb=a;v[a+24>>2]=37;v[a+28>>2]=0;h=a+24|0;_j(h|1,6675,0,v[c+4>>2]);i=v[c+4>>2];g=a-32|0;jb=g;j=ge();v[a>>2]=e;v[a+4>>2]=f;f=df(g,(i>>>9&1)+23|0,j,h,a)+g|0;h=ug(g,f,c);e=g-48|0;jb=e;i=a+8|0;Ac(i,c);v[113382]=0;ja(2356,g|0,h|0,f|0,e|0,a+20|0,a+16|0,i|0);f=v[113382];v[113382]=0;if((f|0)!=1){Ob(a+8|0);b=_l(b,e,v[a+20>>2],v[a+16>>2],c,d);jb=a+32|0;return b|0}b=P()|0;O()|0;Ob(a+8|0);S(b|0);L()}function fM(a,b){var c=0,d=0,e=0;a:{b:{if(!w[b+866|0]|v[a+480180>>2]!=1){break b}d=v[b+104>>2];if(!d){break b}if(!Be(d)|(x[d+34>>1]&3)!=2){break b}c=w[b+867|0]+w[(w[b+866|0]&15)+26640|0]|0;t[b+867|0]=c;if(c<<24>>24>=0){break b}t[b+867|0]=0;c=v[b+784>>2]+1|0;v[b+784>>2]=c>>>0<v[d+8>>2]-v[d+4>>2]>>>0?c:0;c=v[d+20>>2];v[113382]=0;c=T(423,c|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break a}b=Eb(c)+(v[b+784>>2]+v[d+4>>2]|0)|0;t[b|0]=w[b|0]^-1;QN(d,a,0)}return}V(0)|0;O()|0;Ab();L()}function Gca(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;d=jb-16|0;jb=d;v[d+12>>2]=c;v[d+8>>2]=v[a>>2];c=d+8|0;g=v[Lb(c,d+12|0)>>2];v[d+8>>2]=v[a>>2];v[d+4>>2]=v[d+12>>2]-g;h=v[Lb(c,d+4|0)>>2];c=Eb(b);if(g){e=v[a+20>>2];f=g;while(1){i=e,j=Eb(w[c|0])^128,t[i|0]=j;e=e+2|0;c=c+1|0;f=f-1|0;if(f){continue}break}}b=Eb(b);if(h){c=b+v[a>>2]|0;e=v[a+20>>2]+1|0;f=h;while(1){i=e,j=Eb(w[c|0])^128,t[i|0]=j;e=e+2|0;c=c+1|0;f=f-1|0;if(f){continue}break}}jb=d+16|0;return g+h|0}function Fca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;e=jb-16|0;jb=e;v[e+12>>2]=c;v[e+8>>2]=v[a>>2];c=e+8|0;h=v[Lb(c,e+12|0)>>2];v[e+8>>2]=v[a>>2];v[e+4>>2]=v[e+12>>2]-h;i=v[Lb(c,e+4|0)>>2];c=Eb(b);if(h){f=v[a+20>>2];g=h;j=d;while(1){j=Eb(w[c|0])+j|0;t[f|0]=j;f=f+2|0;c=c+1|0;g=g-1|0;if(g){continue}break}}b=Eb(b);if(i){c=b+v[a>>2]|0;f=v[a+20>>2]+1|0;g=i;while(1){d=Eb(w[c|0])+d|0;t[f|0]=d;f=f+2|0;c=c+1|0;g=g-1|0;if(g){continue}break}}jb=e+16|0;return h+i|0}function E5(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;v[113382]=0;Z(1984,a|0);h=v[113382];v[113382]=0;a:{b:{if((h|0)!=1){h=v[a+24>>2];v[113382]=0;b=ua(2001,h|0,b|0,c|0,d|0,e|0,f|0,g|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,8971,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();b=0}return b|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function B5(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;v[113382]=0;Z(1984,a|0);h=v[113382];v[113382]=0;a:{b:{if((h|0)!=1){h=v[a+24>>2];v[113382]=0;b=ua(2004,h|0,b|0,c|0,d|0,e|0,f|0,g|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,8903,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();b=0}return b|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function Sfa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;b=jb-16|0;jb=b;g=v[a+24>>2];h=v[a+20>>2];i=v[a+16>>2];e=v[a+4>>2];f=v[a>>2];v[b+8>>2]=f;v[b+12>>2]=e;j=v[a+12>>2];v[b>>2]=v[a+8>>2];v[b+4>>2]=j;if(d){while(1){e=(((e&2147483647)<<1|f>>>31)&-2)+i|0;f=t[e+1|0];v[c>>2]=v[c>>2]+(B(t[e|0],h)<<8);v[c+4>>2]=v[c+4>>2]+(B(f,g)<<8);Sb(b+8|0,b);d=d-1|0;if(d){c=c+8|0;f=v[b+8>>2];e=v[b+12>>2];continue}break}f=v[b+8>>2];e=v[b+12>>2]}v[a>>2]=f;v[a+4>>2]=e;jb=b+16|0}function tF(a){var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;g=v[a+104>>2];e=(g<<3)+a|0;c=((g+7>>>0)%12<<3)+a|0;f=v[c>>2];c=v[c+4>>2];h=v[a+96>>2];i=v[a+100>>2];a:{if(!(h|i)){b=v[e+4>>2];d=v[e>>2];j=(b|0)==(c|0)&d>>>0>f>>>0|c>>>0<b>>>0;break a}b=v[e+4>>2];d=v[e>>2];j=!(c|f)|((b|0)==(c|0)&d>>>0>=f>>>0|c>>>0<b>>>0)}b=b+i|0;d=h+d|0;b=d>>>0<h>>>0?b+1|0:b;v[e>>2]=f-d;v[e+4>>2]=c-(b+(f>>>0<d>>>0)|0)&65535;v[a+104>>2]=(g+1>>>0)%12;v[a+96>>2]=j;v[a+100>>2]=0;mb=v[e+4>>2];return v[e>>2]}function J_(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;f=jb-32|0;jb=f;d=Db(a);e=Fc(a);g=Pi(b,c);a:{if(!g){break a}if(iA(b,Tb(a),Tb(a)+Db(a)|0)){b=oi(f+16|0,b,c);c=Tb(b);d=Db(b);v[113382]=0;W(2383,a|0,c|0,d|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){yb(b);break a}a=P()|0;O()|0;yb(b);S(a|0);L()}if(e-d>>>0<g>>>0){Rl(a,e,(d+g|0)-e|0,d,d,0,0)}e=Tb(a)+d|0;while(1){if((b|0)!=(c|0)){Rd(e,b);b=b+1|0;e=e+1|0;continue}break}t[f+15|0]=0;Rd(e,f+15|0);Vg(a,d+g|0)}jb=f+32|0;return a|0}function yia(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;g=jb-608|0;jb=g;c=jb-16|0;jb=c;d=c+8|0;e=g+8|0;TP(d,e);f=Hb(d);b=a;d=hd(a,$b(c,d));if((f|0)==(d|0)){Tc(b,Hb(c+8|0))}jb=c+16|0;c=(d|0)==(f|0);if(!c){UP(e)}b=-1;a:{if(!c){break a}b=0;if(!bQ(g+8|0)){break a}b=-1;if(!Ef(a,1024)){break a}b=0;d=jb-1024|0;jb=d;c=jb-16|0;jb=c;e=c+8|0;pz(e,d);f=Hb(e);e=hd(a,$b(c,e));if((f|0)==(e|0)){Tc(a,Hb(c+8|0))}jb=c+16|0;if((e|0)==(f|0)){b=qz(d,0)>>>0<17}jb=d+1024|0}jb=g+608|0;return b|0}function w4(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;var f=0,g=0;v[113382]=0;Z(2057,a|0);f=v[113382];v[113382]=0;a:{b:{if((f|0)!=1){f=v[a+28>>2];g=v[v[f>>2]+72>>2];v[113382]=0;b=bb(g|0,f|0,b|0,c|0,+d,+e)|0;c=v[113382];v[113382]=0;if((c|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,7332,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();b=-1}return b|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function ix(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;f=jb-32|0;jb=f;v[f+16>>2]=c;v[f+24>>2]=b;k=f,l=Bd(a),v[k+8>>2]=l;b=f+24|0;h=f+8|0;i=dm(b,h);e=i;b=dm(f+16|0,b);a:{if(Db(a)>>>0>=e>>>0){if((b|0)==-1){vC(a,e);break a}d=jb-16|0;jb=d;v[d+12>>2]=b;if(b){c=Db(a);j=Tb(a);g=c-e|0;v[d+8>>2]=g;b=v[Lb(d+12|0,d+8|0)>>2];v[d+12>>2]=b;g=g-b|0;if(g){e=e+j|0;am(e,b+e|0,g);b=v[d+12>>2]}e=a;a=c-b|0;Vg(e,a);t[d+7|0]=0;Rd(a+j|0,d+7|0)}jb=d+16|0;break a}pm();L()}ff(h,i);jb=f+32|0}function _l(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;i=jb-16|0;jb=i;a:{b:{if(!a){break b}g=v[e+12>>2];h=c-b|0;if((h|0)>0){if((Yl(a,b,h)|0)!=(h|0)){break b}}b=d-b|0;b=(b|0)<(g|0)?g-b|0:0;if((b|0)>0){f=Fj(i,b,f);g=Tb(f);v[113382]=0;g=W(28,a|0,g|0,b|0)|0;h=v[113382];v[113382]=0;if((h|0)==1){break a}yb(f);if((b|0)!=(g|0)){break b}}b=d-c|0;if((b|0)>0){if((Yl(a,c,b)|0)!=(b|0)){break b}}cz(e);j=a}jb=i+16|0;return j|0}a=P()|0;O()|0;yb(f);S(a|0);L()}function cl(a,b){a=a|0;b=b|0;var c=0;v[a>>2]=0;v[a+4>>2]=0;v[a+20>>2]=0;u[a+16>>1]=65535;v[a+8>>2]=0;v[a+12>>2]=0;v[a+24>>2]=11;v[a+28>>2]=b;AE(a+32|0);b=jb-16|0;jb=b;c=a+44|0;v[c>>2]=0;v[c+4>>2]=0;v[113382]=0;v[b+12>>2]=0;W(178,c+8|0,b+12|0,b+8|0)|0;c=v[113382];v[113382]=0;a:{if((c|0)!=1){jb=b+16|0;break a}V(0)|0;O()|0;Ab();L()}v[a+72>>2]=0;v[a+76>>2]=0;v[a+64>>2]=0;v[a+56>>2]=0;v[a+60>>2]=0;v[a+80>>2]=0;v[a+84>>2]=0;v[a+88>>2]=0;v[a+92>>2]=0;v[a+96>>2]=0;return a|0}function Oaa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;c=jb-32|0;jb=c;a:{if((b-1&65535)>>>0>3998){break a}f=1;e=(B(b,104)+a|0)+484380|0;if(!Be(e)){break a}g=a+1304360|0;d=a+1074984|0;while(1){if(v[d+104>>2]==(e|0)){v[d+76>>2]=0;v[d>>2]=0;v[d+4>>2]=0;v[d+16>>2]=0}d=d+896|0;if((g|0)!=(d|0)){continue}break}ln(e);v[e>>2]=0;a=(B(b,104)+a|0)+484414|0;u[a>>1]=x[a>>1]&65470;v[c+24>>2]=0;v[c+8>>2]=0;v[c+16>>2]=0;v[c+20>>2]=0;v[c>>2]=0;v[c+4>>2]=0;rp(e,0,c)}jb=c+32|0;return f|0}function Dr(a,b,c){var d=0,e=0;d=(c|0)!=0;a:{b:{c:{if(!(a&3)|!c){break c}e=b&255;while(1){if((e|0)==w[a|0]){break b}c=c-1|0;d=(c|0)!=0;a=a+1|0;if(!(a&3)){break c}if(c){continue}break}}if(!d){break a}}d:{if(w[a|0]==(b&255)|c>>>0<4){break d}d=B(b&255,16843009);while(1){e=d^v[a>>2];if((e^-1)&e-16843009&-2139062144){break d}a=a+4|0;c=c-4|0;if(c>>>0>3){continue}break}}if(!c){break a}b=b&255;while(1){if((b|0)==w[a|0]){return a}a=a+1|0;c=c-1|0;if(c){continue}break}}return 0}function Hca(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;d=jb-16|0;jb=d;v[d+12>>2]=c;v[d+8>>2]=v[a>>2];c=d+8|0;g=v[Lb(c,d+12|0)>>2];v[d+8>>2]=v[a>>2];v[d+4>>2]=v[d+12>>2]-g;h=v[Lb(c,d+4|0)>>2];c=Eb(b);if(g){e=v[a+20>>2];f=g;while(1){i=e,j=cn(w[c|0]),t[i|0]=j;e=e+2|0;c=c+1|0;f=f-1|0;if(f){continue}break}}b=Eb(b);if(h){c=b+v[a>>2]|0;e=v[a+20>>2]+1|0;f=h;while(1){i=e,j=cn(w[c|0]),t[i|0]=j;e=e+2|0;c=c+1|0;f=f-1|0;if(f){continue}break}}jb=d+16|0;return g+h|0}function nQ(a,b,c,d){var e=0,f=0;f=jb-16|0;jb=f;e=x[c>>1];while(1){a:{e=e<<1;u[c>>1]=e;t[b|0]=(e&65534)>>>0>255;e=w[c|0];u[c>>1]=e;if(!e){if(!Je(a,f+15|0)){break a}e=w[f+15|0];u[c>>1]=e<<1|1;t[b|0]=e>>>7;u[c>>1]=w[c|0]}t[d|0]=w[b|0]+(w[d|0]<<1);e=x[c>>1]<<1;u[c>>1]=e;t[b|0]=(e&65534)>>>0>255;e=w[c|0];u[c>>1]=e;if(!e){if(!Je(a,f+14|0)){break a}e=w[f+14|0];u[c>>1]=e<<1|1;t[b|0]=e>>>7;e=w[c|0];u[c>>1]=e;if(w[b|0]){continue}break a}if(w[b|0]){continue}}break}jb=f+16|0}function Yaa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0;c=jb-16|0;jb=c;f=a+1304392|0;if(!qd(f)){g=c;d=jb-16|0;jb=d;b=Pe(532);a=v[a+24620>>2];v[113382]=0;a=Q(1387,b|0,a|0)|0;e=v[113382];v[113382]=0;a:{if((e|0)!=1){b=jb-16|0;jb=b;v[113382]=0;v[b+12>>2]=a;a=d+8|0;W(1391,a|0,b+12|0,b+8|0)|0;e=v[113382];v[113382]=0;b:{if((e|0)!=1){jb=b+16|0;break b}V(0)|0;O()|0;Ab();L()}jb=d+16|0;a=v[a>>2];break a}a=P()|0;O()|0;Wb(b);S(a|0);L()}v[g+8>>2]=a;a=c+8|0;tL(f,ke(a));ts(a)}jb=c+16|0}function LD(a,b,c,d,e,f,g,h){var i=0,j=0,k=0,l=0;i=jb-16|0;jb=i;if((b^-1)+1073741807>>>0>=c>>>0){j=Tb(a);l=a;a:{if(b>>>0<536870887){v[i+8>>2]=b<<1;v[i+12>>2]=b+c;c=al(v[Vc(i+12|0,i+8|0)>>2]);break a}c=1073741806}k=c+1|0;c=Qj(l,k);if(e){yh(c,j,e)}if(g){yh(c+(e<<2)|0,h,g)}d=d-(e+f|0)|0;if(d){h=e<<2;yh((h+c|0)+(g<<2)|0,(h+j|0)+(f<<2)|0,d)}b=b+1|0;if((b|0)!=2){no(j,b)}Oe(a,c);Gf(a,k);b=a;a=d+(e+g|0)|0;ae(b,a);v[i+4>>2]=0;Te(c+(a<<2)|0,i+4|0);jb=i+16|0;return}If();L()}function z4(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;v[113382]=0;Z(2057,a|0);e=v[113382];v[113382]=0;a:{b:{if((e|0)!=1){e=v[a+28>>2];f=v[v[e>>2]+12>>2];v[113382]=0;b=aa(f|0,e|0,b|0,c|0,d|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,7477,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();b=-1}return b|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function j7(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;b=qi(a,b,c,d);v[a>>2]=76032;d=kk(a+4208|0);v[a+4240>>2]=0;v[a+4244>>2]=0;c=Ue(c);v[a+4260>>2]=0;v[a+4256>>2]=c;v[a+4236>>2]=0;c=a+4228|0;v[c>>2]=1048576e3;v[c+4>>2]=1048576e3;v[a+4220>>2]=1056964608;v[a+4224>>2]=1056964608;v[113382]=0;W(1609,a+44|0,2,2)|0;c=v[113382];v[113382]=0;a:{if((c|0)==1){break a}v[113382]=0;Z(1610,b|0);c=v[113382];v[113382]=0;if((c|0)==1){break a}return a|0}a=P()|0;O()|0;fg(d);rf(b);S(a|0);L()}function Qe(a,b,c,d,e,f,g,h,i){var j=0,k=0,l=0,m=0;h=qma(b,c,h,i);i=mb;j=h;h=qma(d,e,f,g);e=j+h|0;d=mb+i|0;i=e;h=e>>>0<h>>>0?d+1|0:d;j=g;e=0;g=e;k=i;l=c;d=0;i=qma(j,e,c,d);e=k+i|0;c=mb+h|0;k=e;e=e>>>0<i>>>0?c+1|0:c;h=f;c=0;i=b;f=qma(h,c,i,0);b=mb;d=qma(h,c,l,d);b=b+d|0;c=mb;c=b>>>0<d>>>0?c+1|0:c;h=c;c=c+k|0;d=c>>>0<h>>>0?e+1|0:e;h=c;c=d;d=qma(i,m,j,g)+b|0;e=mb;e=b>>>0>d>>>0?e+1|0:e;b=h;h=e;e=b+e|0;v[a+8>>2]=e;v[a+12>>2]=e>>>0<h>>>0?c+1|0:c;v[a>>2]=f;v[a+4>>2]=d}function DF(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=jb-16|0;jb=e;a:{b:{c:{d:{if((a|0)!=(b|0)){e:{f:{f=w[a|0];if((f|0)!=45){break f}a=a+1|0;if((b|0)!=(a|0)){break f}break e}h=v[113305];v[113305]=0;a=ew(a,e+12|0,d,ge());d=mb;g=v[113305];g:{if(g){if(v[e+12>>2]!=(b|0)){break g}if((g|0)==68){break c}break d}v[113305]=h;if(v[e+12>>2]==(b|0)){break d}}}}v[c>>2]=4;a=0;break a}if(!d){break b}}v[c>>2]=4;a=-1;break a}a=(f|0)==45?0-a|0:a}jb=e+16|0;return a|0}function y4(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;v[113382]=0;Z(2057,a|0);e=v[113382];v[113382]=0;a:{b:{if((e|0)!=1){e=v[a+28>>2];f=v[v[e>>2]+8>>2];v[113382]=0;b=aa(f|0,e|0,b|0,c|0,d|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,7513,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();b=-1}return b|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function dk(a,b,c){a=a|0;b=b|0;c=c|0;a:{if(a){if(b>>>0<=127){break a}b:{if(!v[v[113364]>>2]){if((b&-128)==57216){break a}break b}if(b>>>0<=2047){t[a+1|0]=b&63|128;t[a|0]=b>>>6|192;return 2}if(!((b&-8192)!=57344&b>>>0>=55296)){t[a+2|0]=b&63|128;t[a|0]=b>>>12|224;t[a+1|0]=b>>>6&63|128;return 3}if(b-65536>>>0<=1048575){t[a+3|0]=b&63|128;t[a|0]=b>>>18|240;t[a+2|0]=b>>>6&63|128;t[a+1|0]=b>>>12&63|128;return 4}}v[113305]=25;a=-1}else{a=1}return a|0}t[a|0]=b;return 1}function u4(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;v[113382]=0;Z(2057,a|0);d=v[113382];v[113382]=0;e=1;a:{b:{if((d|0)!=1){d=v[a+28>>2];f=v[v[d>>2]+64>>2];v[113382]=0;U(f|0,d|0,b|0,(c|0)!=0|0);b=v[113382];v[113382]=0;if((b|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,2989,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();e=0}return e|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function s4(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;v[113382]=0;Z(2057,a|0);d=v[113382];v[113382]=0;e=1;a:{b:{if((d|0)!=1){d=v[a+28>>2];f=v[v[d>>2]+56>>2];v[113382]=0;U(f|0,d|0,b|0,(c|0)!=0|0);b=v[113382];v[113382]=0;if((b|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,3043,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();e=0}return e|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function PJ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;e=jb-16|0;jb=e;v[e+12>>2]=b;a:{if(nd(a)>>>0>=b>>>0){g=e,h=Kb(a),v[g+8>>2]=h;d=v[a>>2];b=c;f=v[Lb(e+12|0,e+8|0)>>2];if(f){while(1){z[d>>2]=z[b>>2];d=d+4|0;f=f-1|0;if(f){continue}break}}b=v[e+12>>2];d=v[e+8>>2];if(b>>>0>d>>>0){tx(a,b-d|0,c);break a}vx(a,v[a>>2]+(b<<2)|0);break a}d=a;if(v[d>>2]){ti(d);Se(zb(d),v[d>>2],nd(d));g=zb(d),h=0,v[g>>2]=h;v[d>>2]=0;v[d+4>>2]=0}qu(a,ye(a,b));tx(a,b,c)}jb=e+16|0}function rj(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;b=jb-48|0;jb=b;if(!id(a)){IN(b+32|0,a);HN(b+24|0,a);c=v[b+36>>2];v[b+16>>2]=v[b+32>>2];v[b+20>>2]=c;c=v[b+28>>2];v[b+8>>2]=v[b+24>>2];v[b+12>>2]=c;c=b+16|0;e=b+8|0;a:{if(!Xs(c,e)){break a}while(1){d=jb-16|0;jb=d;v[d+8>>2]=v[c+4>>2];f=zN(d+8|0);jb=d+16|0;if(x[v[f>>2]>>1]!=65535){break a}zN(c+4|0);if(Xs(c,e)){continue}break}}d=v[c+4>>2];v[b+40>>2]=v[c>>2];v[b+44>>2]=d;c=xA(ac(a),v[b+44>>2])}jb=b+48|0;return c&65535}function ic(a,b){var c=0,d=0,e=0;a:{b:{c=v[a+1396>>2];if((c|0)>=0){if((b|0)>(c|0)){if((b|0)>24){return ic(a,24)+(ic(a,b-24|0)<<24)|0}if(!c){v[a+1392>>2]=0}while(1){d=Gr(a);if((d|0)==-1){break b}e=v[a+1396>>2];c=e+8|0;v[a+1396>>2]=c;v[a+1392>>2]=v[a+1392>>2]+(d<<e);if((b|0)>(c|0)){continue}break}}if((b|0)>(c|0)){break a}v[a+1396>>2]=c-b;c=a;a=v[a+1392>>2];v[c+1392>>2]=a>>>b;a=a&(-1<<b^-1)}else{a=0}return a}v[a+1396>>2]=-1;return 0}ia(6170,9203,1632,3155);L()}function eha(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;iP(a);zb(a);h=b+4|0;f=h;e=v[a+4>>2];i=v[a>>2];if((e|0)!=(i|0)){c=v[f>>2];while(1){c=c-56|0;e=e-56|0;d=e;ZO(c,d);ZO(c+12|0,d+12|0);ez(c+24|0,d+24|0);u[c+52>>1]=x[d+52>>1];g=v[d+48>>2];v[c+44>>2]=v[d+44>>2];v[c+48>>2]=g;g=v[d+40>>2];v[c+36>>2]=v[d+36>>2];v[c+40>>2]=g;c=v[f>>2]-56|0;v[f>>2]=c;if((d|0)!=(i|0)){continue}break}}dc(a,h);dc(a+4|0,b+8|0);dc(zb(a),gc(b));v[b>>2]=v[b+4>>2];wk(a);pn(a);pn(a)}function Zba(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=C(0),g=0,h=0,i=0,j=0;e=jb-16|0;jb=e;v[e+8>>2]=c>>>2;v[e+4>>2]=v[a>>2];d=v[Lb(e+8|0,e+4|0)>>2];b=Eb(b);if(d){a=v[a+20>>2];c=d;while(1){v[e+12>>2]=w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24);Wd(e+12|0,C(-1));f=C(z[e+12>>2]*C(32768));z[e+12>>2]=f;h=a;f=de(f);a:{if(C(D(f))<C(2147483648)){g=~~f;break a}g=-2147483648}i=h,j=Rc(g),u[i>>1]=j;a=a+2|0;b=b+4|0;c=c-1|0;if(c){continue}break}}jb=e+16|0;return d<<2}function I1(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=C(0),i=0,j=0,k=0;e=jb-16|0;jb=e;j=v[a+4>>2];nH(a,b,c,d);h=z[a+24>>2];v[e+8>>2]=v[a+20>>2];b=v[a+16>>2];v[e>>2]=v[a+12>>2];v[e+4>>2]=b;a=jb-16|0;jb=a;v[a+8>>2]=v[e+8>>2];b=v[e+4>>2];v[a>>2]=v[e>>2];v[a+4>>2]=b;b=a;if(!(!d|h==C(1))){while(1){if(c){k=g+j|0;f=0;while(1){i=Sf(b,f,k);z[i>>2]=z[i>>2]*h;f=f+1|0;if((f|0)!=(c|0)){continue}break}}g=g+1|0;if((g|0)!=(d|0)){continue}break}}jb=a+16|0;jb=e+16|0}function yka(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=hg(a);if(d>>>0<b>>>0){e=jb-32|0;jb=e;a:{b:{d=b-d|0;c:{if(d>>>0<=(v[zb(a)>>2]-v[a+4>>2]|0)/6>>>0){bA(a,d,c);break c}b=zb(a);b=qR(e+8|0,Rz(a,hg(a)+d|0),hg(a),b);v[113382]=0;U(671,b|0,d|0,c|0);c=v[113382];v[113382]=0;if((c|0)==1){break b}v[113382]=0;R(672,a|0,b|0);a=v[113382];v[113382]=0;if((a|0)==1){break b}yt(b)}jb=e+32|0;break a}a=P()|0;O()|0;yt(b);S(a|0);L()}return}if(b>>>0<d>>>0){aA(a,v[a>>2]+B(b,6)|0)}}function daa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=jb-32|0;jb=d;e=Fx(a);a:{b:{c:{d:{while(1){v[113382]=0;a=Q(228,b|0,8)|0;f=v[113382];v[113382]=0;if((f|0)==1){break b}if(!a){break c}v[113382]=0;U(1522,d+8|0,b|0,c|0);a=v[113382];v[113382]=0;if((a|0)!=1){v[113382]=0;R(1523,e|0,d+8|0);a=v[113382];v[113382]=0;if((a|0)==1){break d}lf(d+8|0);continue}break}a=P()|0;O()|0;break a}a=P()|0;O()|0;lf(d+8|0);break a}jb=d+32|0;return}a=P()|0;O()|0}tl(e);S(a|0);L()}function aJ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;b=qi(a,b,c,d);v[a>>2]=75392;c=kk(a+4260|0);v[a+4232>>2]=1061997773;d=a+4224|0;v[d>>2]=1061158912;v[d+4>>2]=1059082943;d=a+4216|0;v[d>>2]=1038174126;v[d+4>>2]=1065353216;v[a+4208>>2]=1056964608;v[a+4212>>2]=1036831949;v[113382]=0;W(1609,a+44|0,2,2)|0;d=v[113382];v[113382]=0;a:{if((d|0)==1){break a}v[113382]=0;Z(1610,b|0);d=v[113382];v[113382]=0;if((d|0)==1){break a}return a|0}a=P()|0;O()|0;fg(c);rf(b);S(a|0);L()}function Mja(a,b){a=a|0;b=b|0;var c=0,d=0;c=jd(a);if(c>>>0<b>>>0){d=jb-32|0;jb=d;a:{b:{c=b-c|0;c:{if(c>>>0<=v[zb(a)>>2]-v[a+4>>2]>>4>>>0){AB(a,c);break c}b=zb(a);b=Mq(d+8|0,Nq(a,jd(a)+c|0),jd(a),b);v[113382]=0;R(724,b|0,c|0);c=v[113382];v[113382]=0;if((c|0)==1){break b}v[113382]=0;R(571,a|0,b|0);a=v[113382];v[113382]=0;if((a|0)==1){break b}Kt(b)}jb=d+32|0;break a}a=P()|0;O()|0;Kt(b);S(a|0);L()}return}if(b>>>0<c>>>0){b=v[a>>2]+(b<<4)|0;jd(a);kB(a,b);vD(a)}}function Hc(a,b){var c=0,d=0,e=0,f=0;d=jb-16|0;jb=d;if(v[a+4>>2]==v[b+4>>2]){c=v[b+4>>2];b=v[b>>2];v[d>>2]=b;v[d+4>>2]=c;v[d+8>>2]=b;v[d+12>>2]=c;e=jb-16|0;jb=e;v[e+12>>2]=v[a+4>>2];b=d;c=v[b+4>>2];v[113382]=0;v[e+8>>2]=c;c=Q(33,e+12|0,e+8|0)|0;f=v[113382];v[113382]=0;a:{if((f|0)!=1){c=Sm(v[a>>2],v[b>>2],v[c>>2]);b:{if(c){break b}c=0;if(v[a+4>>2]==v[b+4>>2]){break b}c=y[a+4>>2]<y[b+4>>2]?-1:1}jb=e+16|0;break a}V(0)|0;O()|0;Ab();L()}c=!c}jb=d+16|0;return c}function Eda(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=ue(a);if(d>>>0<b>>>0){e=jb-32|0;jb=e;a:{b:{d=b-d|0;c:{if(d>>>0<=v[zb(a)>>2]-v[a+4>>2]>>5>>>0){Ly(a,d,c);break c}b=zb(a);b=Dq(e+8|0,hm(a,ue(a)+d|0),ue(a),b);v[113382]=0;U(1157,b|0,d|0,c|0);c=v[113382];v[113382]=0;if((c|0)==1){break b}v[113382]=0;R(1144,a|0,b|0);a=v[113382];v[113382]=0;if((a|0)==1){break b}Ts(b)}jb=e+32|0;break a}a=P()|0;O()|0;Ts(b);S(a|0);L()}return}if(b>>>0<d>>>0){CN(a,v[a>>2]+(b<<5)|0)}}function WO(a){var b=0,c=0,d=0;a:{if((w[a+44|0]|w[a+45|0]<<8|(w[a+46|0]<<16|w[a+47|0]<<24))!=1179472976|w[a+28|0]!=26|w[a+30|0]>2){break a}b=a+40|0;if(w[b|0]|w[b+1|0]<<8){break a}b=a+38|0;c=w[b+1|0]<<8;if(!(w[b|0]|c)|(c|w[b|0])>>>0>32){break a}b=a+32|0;c=w[b+1|0]<<8;if(!(w[b|0]|c)|(c|w[b|0])>>>0>256){break a}b=a+34|0;c=w[b+1|0]<<8;if(!(w[b|0]|c)|(c|w[b|0])>>>0>255){break a}a=a+36|0;if(!(w[a|0]|w[a+1|0]<<8)){break a}d=(w[a|0]|w[a+1|0]<<8)>>>0<129}return d}function UJ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=Kb(a);if(d>>>0<b>>>0){e=jb-32|0;jb=e;a:{b:{d=b-d|0;c:{if(d>>>0<=v[zb(a)>>2]-v[a+4>>2]>>2>>>0){tx(a,d,c);break c}b=zb(a);b=Nf(e+8|0,ye(a,Kb(a)+d|0),Kb(a),b);v[113382]=0;U(1565,b|0,d|0,c|0);c=v[113382];v[113382]=0;if((c|0)==1){break b}v[113382]=0;R(1566,a|0,b|0);a=v[113382];v[113382]=0;if((a|0)==1){break b}Tm(b)}jb=e+32|0;break a}a=P()|0;O()|0;Tm(b);S(a|0);L()}return}if(b>>>0<d>>>0){vx(a,v[a>>2]+(b<<2)|0)}}function Ola(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=jb-16|0;jb=c;d=a;e=a;v[a>>2]=0;v[a+4>>2]=0;v[113382]=0;v[c+12>>2]=0;W(531,a+8|0,c+12|0,c+8|0)|0;f=v[113382];v[113382]=0;a:{if((f|0)!=1){jb=c+16|0;break a}V(0)|0;O()|0;Ab();L()}b:{if(!b){break b}v[113382]=0;R(524,d|0,b|0);c=v[113382];v[113382]=0;if((c|0)!=1){v[113382]=0;R(525,d|0,b|0);b=v[113382];v[113382]=0;if((b|0)!=1){break b}}a=P()|0;O()|0;LS(e);S(a|0);L()}t[a+16|0]=6;v[a+12>>2]=2015363072;return a|0}function KT(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;f=jb-32|0;jb=f;v[f+28>>2]=c;g=Rb(b,c<<1);a:{if(!g){break a}tc(f+28|0,65535);lg(a,x[f+28>>1]);h=f,i=ac(a),v[h+16>>2]=i;h=f,i=bc(a),v[h+8>>2]=i;if(!Jb(f+16|0,f+8|0)){break a}while(1){a=v[f+16>>2];c=f+24|0;mu(b,c);c=w[c|0]|w[c+1|0]<<8;u[a>>1]=c;b:{if((c|0)==(d|0)){c=65535}else{if((c|0)!=(e|0)){break b}c=65534}u[a>>1]=c}a=f+16|0;re(a);if(Jb(a,f+8|0)){continue}break}}jb=f+32|0;return g|0}function uW(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0;v[113382]=0;m=a;a=0;a=BD(1974,m|a,b,c,d,a|e,f);b=v[113382];v[113382]=0;a:{b:{if((b|0)==1){a=V(0)|0;O()|0;_(a|0)|0;v[113382]=0;ja(1969,5017,g|0,h|0,i|0,j|0,k|0,l|0);a=v[113382];v[113382]=0;if((a|0)==1){break b}$();a=-255}break a}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}return a|0}function ZR(a,b){a=a|0;b=b|0;var c=0,d=0;d=w[a+3|0];a:{if(d>>>0>18){break a}d=1<<d;b:{if(!(d&126991)){if(d&396800){break b}break a}if(!w[a|0]){break a}}c:{d:{e:{switch(w[a+3|0]){case 10:case 17:case 18:c=8;break d;case 0:case 1:case 2:case 3:case 12:case 13:case 14:case 15:case 16:c=w[a|0];if(!(c&7)){break d}case 11:c=b+1>>>1|0;b=(w[a+3|0]==11)<<4;break c;case 9:break e;default:break d}}c=16}c=B(c>>>3|0,b);b=(w[a+3|0]==11)<<4}c=b+B(TR(a),c)|0}return c|0}function Cha(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=jb-32|0;jb=d;e=iz(a);a:{b:{c:{d:{while(1){v[113382]=0;a=Q(228,b|0,8)|0;f=v[113382];v[113382]=0;if((f|0)==1){break b}if(!a){break c}v[113382]=0;U(935,d+8|0,b|0,c|0);a=v[113382];v[113382]=0;if((a|0)!=1){v[113382]=0;R(936,e|0,d+8|0);a=v[113382];v[113382]=0;if((a|0)==1){break d}lf(d+8|0);continue}break}a=P()|0;O()|0;break a}a=P()|0;O()|0;lf(d+8|0);break a}jb=d+32|0;return}a=P()|0;O()|0}Hl(e);S(a|0);L()}function hv(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=jb-16|0;jb=c;e=jb-16|0;jb=e;d=c+8|0;fc(d,b,20);jb=e+16|0;e=Hb(d);d=mc(a,$b(c,d));if((e|0)==(d|0)){_b(a,Hb(c+8|0))}jb=c+16|0;a=(d|0)==(e|0);if(!a){c=jb-16|0;jb=c;t[b|0]=0;t[b+1|0]=0;t[b+2|0]=0;t[b+3|0]=0;t[b+4|0]=0;t[b+5|0]=0;t[b+6|0]=0;t[b+7|0]=0;t[b+16|0]=0;t[b+17|0]=0;t[b+18|0]=0;t[b+19|0]=0;t[b+8|0]=0;t[b+9|0]=0;t[b+10|0]=0;t[b+11|0]=0;t[b+12|0]=0;t[b+13|0]=0;t[b+14|0]=0;t[b+15|0]=0;jb=c+16|0}return a|0}function q4(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,f=0;v[113382]=0;Z(2057,a|0);d=v[113382];v[113382]=0;e=1;a:{b:{if((d|0)!=1){d=v[a+28>>2];f=v[v[d>>2]+48>>2];v[113382]=0;db(f|0,d|0,b|0,+c);b=v[113382];v[113382]=0;if((b|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,7676,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();e=0}return e|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function T4(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;v[113382]=0;Z(1984,a|0);f=v[113382];v[113382]=0;a:{b:{if((f|0)!=1){f=v[a+24>>2];v[113382]=0;b=ea(2039,f|0,b|0,c|0,d|0,e|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,8387,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();b=0}return b|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function MS(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0;a:{b=v[a+1060>>2];if((b|0)>255){break a}while(1){f=(B(b,6)+a|0)+1068|0,g=Jj(a,7),t[f|0]=g;d=Jj(a,1);e=Jj(a,1);c=v[a+1056>>2];if((c|0)>255){break a}b=v[a+1060>>2]+1|0;v[a+1056>>2]=b;v[a+1060>>2]=b;b:{if(d){u[(B(c,6)+a|0)+1064>>1]=b;MS(a);b=v[a+1060>>2];break b}u[(B(c,6)+a|0)+1064>>1]=65535}v[a+1056>>2]=b;if(e){u[(B(c,6)+a|0)+1066>>1]=b;if((b|0)<=255){continue}break a}break}u[(B(c,6)+a|0)+1066>>1]=65535}}function C5(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;v[113382]=0;Z(1984,a|0);f=v[113382];v[113382]=0;a:{b:{if((f|0)!=1){f=v[a+24>>2];v[113382]=0;b=ea(2003,f|0,b|0,c|0,d|0,e|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,5591,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();b=0}return b|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function F5(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;v[113382]=0;Z(1984,a|0);f=v[113382];v[113382]=0;a:{b:{if((f|0)!=1){f=v[a+24>>2];v[113382]=0;b=ea(2e3,f|0,b|0,c|0,d|0,e|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,5663,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();b=0}return b|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function hK(a,b){var c=0,d=0,e=0,f=0,g=0,h=0;c=a;d=b;if((c|0)!=(d|0)){e=jb-16|0;jb=e;g=v[d+4>>2];d=v[d>>2];f=(g-d|0)/6|0;a:{if(f>>>0<=Mi(c)>>>0){if(hg(c)>>>0<f>>>0){v[e+12>>2]=d;h=hg(c);v[e+12>>2]=v[e+12>>2]+B(h,6);Ax(d,v[e+12>>2],v[c>>2]);zx(c,v[e+12>>2],g,f-hg(c)|0);break a}aA(c,Ax(d,g,v[c>>2]));break a}fK(c);qA(c,Rz(c,f));zx(c,d,g,f)}jb=e+16|0}v[a+12>>2]=v[b+12>>2];v[a+16>>2]=v[b+16>>2];v[a+20>>2]=v[b+20>>2];gK(a+24|0,b+24|0);Xi(a+36|0,b+36|0)}function TM(a,b){var c=0,d=0,e=0,f=0;u[a+24>>1]=0;v[a+20>>2]=0;v[a>>2]=0;v[a+4>>2]=0;v[a+8>>2]=0;v[a+12>>2]=0;e=a;d=3546895/+(b>>>0);c=d*.25;a:{if(D(c)<2147483648){b=~~c;break a}b=-2147483648}v[e+16>>2]=b;c=(d-+(b<<2))*4294967296;b:{if(D(c)<0x8000000000000000){f=~~c>>>0;b=D(c)>=1?~~(c>0?F(H(c*2.3283064365386963e-10),4294967295):I((c-+(~~c>>>0>>>0))*2.3283064365386963e-10))>>>0:0;break b}b=-2147483648}v[a>>2]=0;v[a+4>>2]=0;v[a+8>>2]=f;v[a+12>>2]=b}function Cka(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=wc(a);if(d>>>0<b>>>0){e=jb-32|0;jb=e;a:{b:{d=b-d|0;c:{if(d>>>0<=v[zb(a)>>2]-v[a+4>>2]>>>0){Sp(a,d,c);break c}b=zb(a);b=ph(e+8|0,Ki(a,wc(a)+d|0),wc(a),b);v[113382]=0;U(665,b|0,d|0,c|0);c=v[113382];v[113382]=0;if((c|0)==1){break b}v[113382]=0;R(330,a|0,b|0);a=v[113382];v[113382]=0;if((a|0)==1){break b}Tg(b)}jb=e+32|0;break a}a=P()|0;O()|0;Tg(b);S(a|0);L()}return}if(b>>>0<d>>>0){Mu(a,v[a>>2]+b|0)}}function lT(){var a=0,b=0;a=jb-16|0;jb=a;a:{if(Za(a+12|0,a+8|0)|0){break a}b=kd((v[a+12>>2]<<2)+4|0);v[113388]=b;if(!b){break a}b=kd(v[a+8>>2]);if(b){v[v[113388]+(v[a+12>>2]<<2)>>2]=0;if(!(Ya(v[113388],b|0)|0)){break a}}v[113388]=0}jb=a+16|0;b:{if(t[458632]&1){break b}if(!vd(458632)){break b}v[113382]=0;T(2796,458628)|0;a=v[113382];v[113382]=0;if((a|0)!=1){ud(458632);break b}a=P()|0;O()|0;ne(458632);S(a|0);L()}FK();v[113364]=453264;v[113331]=42}function kI(a,b){var c=0,d=0,e=0,f=0,g=0;c=jb-144|0;jb=c;d=li(c+8|0);e=v[v[d>>2]-12>>2];v[113382]=0;f=da(123)|0;g=v[113382];v[113382]=0;a:{if((g|0)==1){break a}v[113382]=0;U(124,c|0,e+(c+8|0)|0,f|0);e=v[113382];v[113382]=0;if((e|0)==1){break a}Ob(c);v[113382]=0;R(131,d|0,b|0);b=v[113382];v[113382]=0;if((b|0)==1){break a}v[113382]=0;R(126,a|0,d|0);a=v[113382];v[113382]=0;if((a|0)==1){break a}Td(d);jb=c+144|0;return}a=P()|0;O()|0;Td(d);S(a|0);L()}function gx(a,b){var c=0,d=0,e=0,f=0,g=0;c=jb-144|0;jb=c;d=li(c+8|0);e=v[v[d>>2]-12>>2];v[113382]=0;f=da(123)|0;g=v[113382];v[113382]=0;a:{if((g|0)==1){break a}v[113382]=0;U(124,c|0,e+(c+8|0)|0,f|0);e=v[113382];v[113382]=0;if((e|0)==1){break a}Ob(c);v[113382]=0;R(125,d|0,b|0);b=v[113382];v[113382]=0;if((b|0)==1){break a}v[113382]=0;R(126,a|0,d|0);a=v[113382];v[113382]=0;if((a|0)==1){break a}Td(d);jb=c+144|0;return}a=P()|0;O()|0;Td(d);S(a|0);L()}function fS(a){var b=0,c=0,d=0;a:{if((w[a+60|0]|w[a+61|0]<<8|(w[a+62|0]<<16|w[a+63|0]<<24))!=808537417){break a}b=a+32|0;if((w[b|0]|w[b+1|0]<<8)>>>0>256){break a}b=a+36|0;if(w[a+49|0]<32|(w[b|0]|w[b+1|0]<<8)>>>0>255|w[a+50|0]>64){break a}b=a+51|0;if(w[b|0]<4|t[b|0]<0){break a}d=a+576|0;a=a- -64|0;b=0;while(1){c=0;b:{switch(w[a+15|0]){case 0:case 1:b=1;break;case 2:break b;default:break a}}c=b;a=a+16|0;if((d|0)!=(a|0)){continue}break}}return c&1}function Hx(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;f=jb-48|0;jb=f;a:{if(!c){c=sc(a,b);a=v[d+12>>2];v[c+8>>2]=v[d+8>>2];v[c+12>>2]=a;a=v[d+4>>2];v[c>>2]=v[d>>2];v[c+4>>2]=a;break a}e=v[d+12>>2];v[f+24>>2]=v[d+8>>2];v[f+28>>2]=e;g=v[d+4>>2];e=f;v[e+16>>2]=v[d>>2];v[e+20>>2]=g;g=c>>>1|0;Hx(a,b,g,e+16|0);Jh(e+32|0,d,sc(a,c));d=v[e+44>>2];v[e+8>>2]=v[e+40>>2];v[e+12>>2]=d;d=v[e+36>>2];v[e>>2]=v[e+32>>2];v[e+4>>2]=d;Hx(a,b|c,g,e)}jb=f+48|0}function lw(a,b,c,d,e){var f=0,g=0,h=0,i=0,j=0,k=0;i=-1;f=d&2147483647;k=f;g=(f|0)==2147418112;h=c;a:{if(g&!c?a|b:g&(c|0)!=0|f>>>0>2147418112){break a}f=e&2147483647;g=f;j=(f|0)==2147418112;if(j?0:j&0|f>>>0>2147418112){break a}if(!(a|h|(g|k|b))){return 0}h=d&e;if((h|0)>0|(h|0)>=0){if(!c&(d|0)==(e|0)?0:(d|0)<(e|0)){break a}return(a|c)!=0|(d^e|b)!=0}if(!c&(d|0)==(e|0)?a|b:(c|0)!=0&(d|0)>=(e|0)|(d|0)>(e|0)){break a}i=(a|c)!=0|(d^e|b)!=0}return i}function J5(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=jb-16|0;jb=d;Ac(a,b);v[113382]=0;U(127,d+8|0,b|0,c|0);e=v[113382];v[113382]=0;a:{if((e|0)==1){break a}Ob(d+8|0);v[113382]=0;e=T(27,b|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break a}if(e){v[113382]=0;b=T(27,b|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break a}v[113382]=0;U(128,d|0,b|0,c|0);b=v[113382];v[113382]=0;if((b|0)==1){break a}Ob(d)}jb=d+16|0;return}b=P()|0;O()|0;Ob(a);S(b|0);L()}function x4(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;v[113382]=0;Z(2057,a|0);c=v[113382];v[113382]=0;d=1;a:{b:{if((c|0)!=1){c=v[a+28>>2];e=v[v[c>>2]+76>>2];v[113382]=0;R(e|0,c|0,b|0);b=v[113382];v[113382]=0;if((b|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,7342,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();d=0}return d|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function i4(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;v[113382]=0;Z(2057,a|0);c=v[113382];v[113382]=0;d=1;a:{b:{if((c|0)!=1){c=v[a+28>>2];e=v[v[c>>2]+20>>2];v[113382]=0;R(e|0,c|0,b|0);b=v[113382];v[113382]=0;if((b|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,5322,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();d=0}return d|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function h4(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;v[113382]=0;Z(2057,a|0);c=v[113382];v[113382]=0;d=1;a:{b:{if((c|0)!=1){c=v[a+28>>2];e=v[v[c>>2]+16>>2];v[113382]=0;R(e|0,c|0,b|0);b=v[113382];v[113382]=0;if((b|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,8773,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();d=0}return d|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function z5(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;v[113382]=0;Z(1984,a|0);e=v[113382];v[113382]=0;a:{b:{if((e|0)!=1){e=v[a+24>>2];v[113382]=0;b=aa(2006,e|0,b|0,c|0,d|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,8934,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();b=0}return b|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function x5(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;v[113382]=0;Z(1984,a|0);e=v[113382];v[113382]=0;a:{b:{if((e|0)!=1){e=v[a+24>>2];v[113382]=0;b=aa(2007,e|0,b|0,c|0,d|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,5546,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();b=0}return b|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function w5(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;v[113382]=0;Z(1984,a|0);e=v[113382];v[113382]=0;a:{b:{if((e|0)!=1){e=v[a+24>>2];v[113382]=0;b=aa(2008,e|0,b|0,c|0,d|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,8860,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();b=0}return b|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function n4(a,b){a=a|0;b=+b;var c=0,d=0,e=0;v[113382]=0;Z(2057,a|0);c=v[113382];v[113382]=0;d=1;a:{b:{if((c|0)!=1){c=v[a+28>>2];e=v[v[c>>2]+40>>2];v[113382]=0;ra(e|0,c|0,+b);c=v[113382];v[113382]=0;if((c|0)!=1){break b}}d=V(0)|0;O()|0;_(d|0)|0;v[113382]=0;X(1958,7714,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();d=0}return d|0}a=P()|0;O()|0;v[113382]=0;Y(20);d=v[113382];v[113382]=0;if((d|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function n3(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;h=jb-16|0;jb=h;a:{b:{c:{if(g?!f|(!d|!e):1){b=ba(8)|0;v[113382]=0;c=Q(121,h|0,4474)|0;a=v[113382];v[113382]=0;if((a|0)==1){break c}nc(b,c);v[113382]=0;U(1978,b|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break a}a=P()|0;O()|0;yb(c);break b}ni(a,b,4);c=_w(a,c,d,e,f,g);A[a+16>>3]=+(c>>>0)/+(b|0)+A[a+16>>3];jb=h+16|0;return c|0}a=P()|0;O()|0;ca(b|0)}S(a|0)}L()}function l4(a,b){a=a|0;b=+b;var c=0,d=0,e=0;v[113382]=0;Z(2057,a|0);c=v[113382];v[113382]=0;d=1;a:{b:{if((c|0)!=1){c=v[a+28>>2];e=v[v[c>>2]+32>>2];v[113382]=0;ra(e|0,c|0,+b);c=v[113382];v[113382]=0;if((c|0)!=1){break b}}d=V(0)|0;O()|0;_(d|0)|0;v[113382]=0;X(1958,4009,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();d=0}return d|0}a=P()|0;O()|0;v[113382]=0;Y(20);d=v[113382];v[113382]=0;if((d|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function k3(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;h=jb-16|0;jb=h;a:{b:{c:{if(g?!f|(!d|!e):1){b=ba(8)|0;v[113382]=0;c=Q(121,h|0,4474)|0;a=v[113382];v[113382]=0;if((a|0)==1){break c}nc(b,c);v[113382]=0;U(1978,b|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break a}a=P()|0;O()|0;yb(c);break b}ni(a,b,4);c=Zw(a,c,d,e,f,g);A[a+16>>3]=+(c>>>0)/+(b|0)+A[a+16>>3];jb=h+16|0;return c|0}a=P()|0;O()|0;ca(b|0)}S(a|0)}L()}function j4(a,b){a=a|0;b=+b;var c=0,d=0,e=0;v[113382]=0;Z(2057,a|0);c=v[113382];v[113382]=0;d=1;a:{b:{if((c|0)!=1){c=v[a+28>>2];e=v[v[c>>2]+24>>2];v[113382]=0;ra(e|0,c|0,+b);c=v[113382];v[113382]=0;if((c|0)!=1){break b}}d=V(0)|0;O()|0;_(d|0)|0;v[113382]=0;X(1958,3957,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();d=0}return d|0}a=P()|0;O()|0;v[113382]=0;Y(20);d=v[113382];v[113382]=0;if((d|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function gka(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=jb-16|0;jb=e;j=e+8|0;c=jb-16|0;jb=c;f=a;k=b;d=Ke(a);g=jc(a);h=jb-16|0;jb=h;if(d){while(1){i=un(zb(f),d+16|0,k);g=i?g:d;d=v[(i?4:0)+d>>2];if(d){continue}break}}f=v[Oc(h+8|0,g)>>2];jb=h+16|0;v[c+8>>2]=f;l=c,m=yj(a),v[l>>2]=m;a:{b:{if(!Jb(c+8|0,c)){break b}if(un(zb(a),b,lh(c+8|0))){break b}a=v[c+8>>2];break a}a=yj(a)}jb=c+16|0;a=v[Oc(j,a)>>2];jb=e+16|0;return a|0}function G5(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;v[113382]=0;Z(1984,a|0);e=v[113382];v[113382]=0;a:{b:{if((e|0)!=1){e=v[a+24>>2];v[113382]=0;b=aa(1999,e|0,b|0,c|0,d|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,5461,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();b=0}return b|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function EB(a,b){a=a|0;b=b|0;var c=0,d=0;c=oc(a);if(c>>>0<b>>>0){d=jb-32|0;jb=d;a:{b:{c=b-c|0;c:{if(c>>>0<=v[zb(a)>>2]-v[a+4>>2]>>1>>>0){pB(a,c);break c}b=zb(a);b=Sn(d+8|0,Qi(a,oc(a)+c|0),oc(a),b);v[113382]=0;R(371,b|0,c|0);c=v[113382];v[113382]=0;if((c|0)==1){break b}v[113382]=0;R(346,a|0,b|0);a=v[113382];v[113382]=0;if((a|0)==1){break b}Cj(b)}jb=d+32|0;break a}a=P()|0;O()|0;Cj(b);S(a|0);L()}return}if(b>>>0<c>>>0){Kn(a,v[a>>2]+(b<<1)|0)}}function D5(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;v[113382]=0;Z(1984,a|0);e=v[113382];v[113382]=0;a:{b:{if((e|0)!=1){e=v[a+24>>2];v[113382]=0;b=aa(2002,e|0,b|0,c|0,d|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,5430,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();b=0}return b|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function A5(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;v[113382]=0;Z(1984,a|0);e=v[113382];v[113382]=0;a:{b:{if((e|0)!=1){e=v[a+24>>2];v[113382]=0;b=aa(2005,e|0,b|0,c|0,d|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,5624,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();b=0}return b|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function ux(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=jb-16|0;jb=e;j=e+8|0;c=jb-16|0;jb=c;f=a;k=b;d=Ke(a);g=jc(a);h=jb-16|0;jb=h;if(d){while(1){i=is(zb(f),d+16|0,k);g=i?g:d;d=v[(i?4:0)+d>>2];if(d){continue}break}}f=v[Oc(h+8|0,g)>>2];jb=h+16|0;v[c+8>>2]=f;l=c,m=yj(a),v[l>>2]=m;a:{b:{if(!Jb(c+8|0,c)){break b}if(is(zb(a),b,lh(c+8|0))){break b}a=v[c+8>>2];break a}a=yj(a)}jb=c+16|0;a=v[Oc(j,a)>>2];jb=e+16|0;return a|0}function r4(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;v[113382]=0;Z(2057,a|0);c=v[113382];v[113382]=0;a:{b:{if((c|0)!=1){c=v[a+28>>2];e=v[v[c>>2]+52>>2];v[113382]=0;d=+cb(e|0,c|0,b|0);b=v[113382];v[113382]=0;if((b|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,7695,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();d=0}return+d}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function PV(a,b){a=a|0;b=b|0;var c=0;a=bd(a);a:{if(w[b+16|0]){v[113382]=0;Q(205,a|0,1452)|0;c=v[113382];v[113382]=0;if((c|0)==1){break a}}if(w[b+17|0]){v[113382]=0;Q(205,a|0,8509)|0;c=v[113382];v[113382]=0;if((c|0)==1){break a}}if(Sc(a)){v[113382]=0;Q(205,a|0,6160)|0;c=v[113382];v[113382]=0;if((c|0)==1){break a}}if(w[b+18|0]){v[113382]=0;Q(205,a|0,7092)|0;b=v[113382];v[113382]=0;if((b|0)==1){break a}}return}b=P()|0;O()|0;yb(a);S(b|0);L()}function DJ(a){var b=0,c=0,d=0,e=0;c=jb-32|0;jb=c;a:{b:{if(jk(a)>>>0<=of(a)>>>0){break b}b=zb(a);d=of(a);e=of(a);v[113382]=0;b=aa(1613,c+8|0,d|0,e|0,b|0)|0;d=v[113382];v[113382]=0;c:{d:{if((d|0)!=1){v[113382]=0;R(1614,a|0,b|0);a=v[113382];v[113382]=0;if((a|0)==1){break d}fs(b);break b}a=V(0)|0;O()|0;break c}a=V(0)|0;O()|0;fs(b)}_(a|0)|0;v[113382]=0;Y(20);a=v[113382];v[113382]=0;if((a|0)==1){break a}}jb=c+32|0;return}V(0)|0;O()|0;Ab();L()}function AJ(a){var b=0,c=0,d=0,e=0;c=jb-32|0;jb=c;a:{b:{if(nd(a)>>>0<=Kb(a)>>>0){break b}b=zb(a);d=Kb(a);e=Kb(a);v[113382]=0;b=aa(1615,c+8|0,d|0,e|0,b|0)|0;d=v[113382];v[113382]=0;c:{d:{if((d|0)!=1){v[113382]=0;R(1616,a|0,b|0);a=v[113382];v[113382]=0;if((a|0)==1){break d}es(b);break b}a=V(0)|0;O()|0;break c}a=V(0)|0;O()|0;es(b)}_(a|0)|0;v[113382]=0;Y(20);a=v[113382];v[113382]=0;if((a|0)==1){break a}}jb=c+32|0;return}V(0)|0;O()|0;Ab();L()}function v4(a,b){a=a|0;b=b|0;var c=0,d=0;v[113382]=0;Z(2057,a|0);c=v[113382];v[113382]=0;a:{b:{if((c|0)!=1){c=v[a+28>>2];d=v[v[c>>2]+68>>2];v[113382]=0;b=Q(d|0,c|0,b|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,3016,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();b=-1}return b|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function t4(a,b){a=a|0;b=b|0;var c=0,d=0;v[113382]=0;Z(2057,a|0);c=v[113382];v[113382]=0;a:{b:{if((c|0)!=1){c=v[a+28>>2];d=v[v[c>>2]+60>>2];v[113382]=0;b=Q(d|0,c|0,b|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,3067,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();b=-1}return b|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function gf(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0;e=jb-16|0;jb=e;g=Xm(a);f=e;i=e;a:{if(b){j=v[b+4>>2];h=v[b>>2];break a}h=Xm(a)}v[i+8>>2]=h;v[f+12>>2]=j;f=v[a+12>>2];a=1;b:{if(!b){break b}a=c+f|0;d=c>>>0>a>>>0?d+1|0:d;b=a;v[e>>2]=2048;v[e+4>>2]=0;a=Fu(e+8|0,e);c=v[a>>2];a=v[a+4>>2];c:{if(!a&c>>>0>g>>>0|a){a=-1;if(!d&b>>>0<=g>>>0){break c}break b}a=0;c=v[e+12>>2];if((c|0)==(d|0)&b>>>0>y[e+8>>2]|c>>>0<d>>>0){break b}}a=1}jb=e+16|0;return a}function gO(a,b){var c=0,d=0,e=0,f=0;c=jb-16|0;jb=c;a=Xb(a);d=Db(b);v[113382]=0;R(111,a|0,d|0);d=v[113382];v[113382]=0;if((d|0)!=1){a:{e=c,f=Bd(b),v[e+8>>2]=f;e=c,f=tf(b),v[e>>2]=f;if(Jb(c+8|0,c)){while(1){b=w[v[c+8>>2]];b:{if((b|0)==13){v[113382]=0;R(110,a|0,10);break b}v[113382]=0;R(110,a|0,b<<24>>24)}b=v[113382];v[113382]=0;if((b|0)==1){break a}b=c+8|0;xg(b);if(Jb(b,c)){continue}break}}jb=c+16|0;return}}b=P()|0;O()|0;yb(a);S(b|0);L()}function Xl(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=jb-32|0;jb=d;v[d+24>>2]=0;v[d+28>>2]=0;v[d+16>>2]=0;v[d+20>>2]=0;v[d+12>>2]=c;a:{if(c){while(1){v[d+8>>2]=16;e=0;f=v[Lb(d+8|0,d+12|0)>>2];h=v[a>>2];if((f|0)!=((j=h,k=Eb(d+16|0),l=v[a+8>>2]+g|0,m=f,i=v[v[h>>2]+28>>2],nb[i](j|0,k|0,l|0,m|0)|0)|0)){break a}if(md(d+16|0,b+g|0,f)){break a}e=v[d+12>>2]-f|0;v[d+12>>2]=e;g=f+g|0;if(e){continue}break}}_b(a,c);e=1}jb=d+32|0;return e}function $Y(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0;while(1){a:{if((c|0)==(d|0)|e>>>0<=h>>>0){break a}g=1;f=jb-16|0;jb=f;v[f+12>>2]=v[a+8>>2];i=Bh(f+8|0,f+12|0);v[113382]=0;j=HF(c,d-c|0,b);l=v[113382];v[113382]=0;b:{if((l|0)!=1){Ge(i);jb=f+16|0;break b}a=P()|0;O()|0;Ge(i);S(a|0);L()}c:{switch(j+2|0){default:g=j;break;case 0:case 1:break a;case 2:break c}}h=h+1|0;k=g+k|0;c=c+g|0;continue}break}return k|0}function _X(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=jb-32|0;jb=d;v[d+16>>2]=b;e=v[a+48>>2];v[d+20>>2]=c-((e|0)!=0);f=v[a+44>>2];v[d+28>>2]=e;v[d+24>>2]=f;e=-1;a:{b:{if(!zr(Ua(v[a+60>>2],d+16|0,2,d+12|0)|0)){e=v[d+12>>2];if((e|0)>0){break b}}v[a>>2]=v[a>>2]|e&48^16;break a}g=v[d+20>>2];if(g>>>0>=e>>>0){break a}f=v[a+44>>2];v[a+4>>2]=f;v[a+8>>2]=f+(e-g|0);if(v[a+48>>2]){v[a+4>>2]=f+1;t[(b+c|0)-1|0]=w[f|0]}e=c}jb=d+32|0;return e|0}function Ud(a){var b=0,c=0,d=0;d=lo(cf(a)+1|0,1);if(d){a:{c=d;b:{if((c^a)&3){break b}if(a&3){while(1){b=w[a|0];t[c|0]=b;if(!b){break a}c=c+1|0;a=a+1|0;if(a&3){continue}break}}b=v[a>>2];if((b^-1)&b-16843009&-2139062144){break b}while(1){v[c>>2]=b;b=v[a+4>>2];c=c+4|0;a=a+4|0;if(!(b-16843009&(b^-1)&-2139062144)){continue}break}}b=w[a|0];t[c|0]=b;if(!b){break a}while(1){b=w[a+1|0];t[c+1|0]=b;c=c+1|0;a=a+1|0;if(b){continue}break}}}return d}function q3(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;d=jb-32|0;jb=d;f=v[c+12>>2];a:{if(!f){break a}g=t[c+16|0];e=Db(b);if(!e){break a}h=e-1|0;c=0;while(1){b:{if(!c|(c>>>0)%(f>>>0)){break b}if((c|0)==(h|0)){if(w[kc(b,0)|0]==43){break b}if(w[kc(b,0)|0]==45){break b}}i=d,j=Bd(b),v[i+8>>2]=j;i=d,j=ff(d+8|0,e-c|0),v[i+16>>2]=j;Hd(d+24|0,d+16|0);Ow(b,v[d+24>>2],1,g)}c=c+1|0;if((e|0)!=(c|0)){continue}break}}rd(a,b);jb=d+32|0}function GR(a){var b=0,c=0,d=0,e=0;c=jb-32|0;jb=c;a:{b:{if(xf(a)>>>0<=wc(a)>>>0){break b}b=zb(a);d=wc(a);e=wc(a);v[113382]=0;b=aa(39,c+8|0,d|0,e|0,b|0)|0;d=v[113382];v[113382]=0;c:{d:{if((d|0)!=1){v[113382]=0;R(40,a|0,b|0);a=v[113382];v[113382]=0;if((a|0)==1){break d}_p(b);break b}a=V(0)|0;O()|0;break c}a=V(0)|0;O()|0;_p(b)}_(a|0)|0;v[113382]=0;Y(20);a=v[113382];v[113382]=0;if((a|0)==1){break a}}jb=c+32|0;return}V(0)|0;O()|0;Ab();L()}function CV(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;b=jb-32|0;jb=b;c=jb-16|0;jb=c;d=c+8|0;f=b+16|0;WC(d,f);e=a;g=Hb(d);d=hd(a,$b(c,d));if((g|0)==(d|0)){Tc(e,Hb(c+8|0))}jb=c+16|0;c=(d|0)==(g|0);if(!c){XC(f)}e=-1;a:{if(!c){break a}e=0;if(!kD(b+16|0)){break a}c=jb-16|0;jb=c;e=b;d=c+8|0;UC(d,b);f=Hb(d);d=hd(a,$b(c,d));if((f|0)==(d|0)){Tc(a,Hb(c+8|0))}jb=c+16|0;a=(d|0)==(f|0);if(!a){VC(e)}e=-1;if(!a){break a}e=jD(b)}jb=b+32|0;return e|0}function Bha(a){a=a|0;var b=0,c=0,d=0,e=0;b=jb-16|0;jb=b;t[b+15|0]=128;d=Ut(a,127,b+15|0);v[113382]=0;t[b+14|0]=64;e=W(847,a+12|0,127,b+14|0)|0;c=v[113382];v[113382]=0;a:{b:{if((c|0)!=1){v[113382]=0;t[b+13|0]=0;W(937,a+24|0,127,b+13|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break b}v[a+36>>2]=-1;v[a+40>>2]=108855296;v[a+44>>2]=0;v[a+48>>2]=0;u[a+52>>1]=0;jb=b+16|0;return a|0}a=P()|0;O()|0;break a}a=P()|0;O()|0;$d(e)}$d(d);S(a|0);L()}function z7(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;b=qi(a,b,c,d);v[a>>2]=75624;c=kk(a+4256|0);d=a+4224|0;v[d>>2]=1017370378;v[d+4>>2]=1065353216;d=a+4216|0;v[d>>2]=1028670828;v[d+4>>2]=1059760811;v[a+4208>>2]=1056964608;v[a+4212>>2]=1017370378;v[113382]=0;W(1609,a+44|0,2,2)|0;d=v[113382];v[113382]=0;a:{if((d|0)==1){break a}v[113382]=0;Z(1610,b|0);d=v[113382];v[113382]=0;if((d|0)==1){break a}return a|0}a=P()|0;O()|0;fg(c);rf(b);S(a|0);L()}function Sx(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=jb-16|0;jb=e;f=e;a:{if(!tj(b)){c=OL(a,c,v[b+704>>2],d);break a}c=v[b+700>>2]}v[f+12>>2]=c;b=v[b+656>>2];b:{if(!b){break b}f=v[b+40>>2];if(!f){break b}d=(f|0)/2|0;b=v[a+1074420>>2];b=qma(b,b>>31,c,c>>31);c=d+b|0;d=mb+(d>>31)|0;g=e,h=zc(rma(c,b>>>0>c>>>0?d+1|0:d,f,f>>31),mb),v[g+12>>2]=h}tc(e+12|0,2147483647);a=rma(0,v[e+12>>2],v[a+24620>>2]<<4,0);jb=e+16|0;return a|0}function Lja(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=jb-16|0;jb=c;e=jb-16|0;jb=e;d=c+8|0;fc(d,b,18);jb=e+16|0;e=Hb(d);d=mc(a,$b(c,d));if((e|0)==(d|0)){_b(a,Hb(c+8|0))}jb=c+16|0;a=(d|0)==(e|0);if(!a){c=jb-16|0;jb=c;t[b|0]=0;t[b+1|0]=0;t[b+2|0]=0;t[b+3|0]=0;t[b+4|0]=0;t[b+5|0]=0;t[b+6|0]=0;t[b+7|0]=0;t[b+16|0]=0;t[b+17|0]=0;t[b+8|0]=0;t[b+9|0]=0;t[b+10|0]=0;t[b+11|0]=0;t[b+12|0]=0;t[b+13|0]=0;t[b+14|0]=0;t[b+15|0]=0;jb=c+16|0}return a|0}function H5(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;v[113382]=0;Z(1984,a|0);d=v[113382];v[113382]=0;e=1;a:{b:{if((d|0)!=1){d=v[a+24>>2];v[113382]=0;U(1998,d|0,b|0,c|0);b=v[113382];v[113382]=0;if((b|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,6409,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();e=0}return e|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function Xw(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;a:{if(!Qr(b)){break a}a=a+24|0;if(!jg(v[a>>2]+484344|0,b&65535)){break a}b=Zb(v[a>>2]+484344|0,b);if((d|0)<0|v[b+12>>2]<=(c|0)|(c|0)<0|(x[v[a>>2]+480188>>1]<=d>>>0|e>>>0>5)){break a}b=Bf(b,c,d&65535);b:{c:{switch(e-1|0){case 0:b=b+1|0;break b;case 1:b=b+2|0;break b;case 2:b=b+3|0;break b;case 3:b=b+4|0;break b;case 4:break c;default:break b}}b=b+5|0}f=w[b|0]}return f|0}function Iia(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=C(0),i=0;g=jb-16|0;jb=g;if(d){a=a+e|0;e=0;while(1){z[g+12>>2]=z[b>>2];Wd(g+12|0,C(-1));h=C(z[g+12>>2]*C(128));z[g+12>>2]=h;h=de(h);a:{if(C(D(h))<C(2147483648)){i=~~h;break a}i=-2147483648}f=jb-16|0;jb=f;v[f+12>>2]=i;v[f+8>>2]=-128;v[f+4>>2]=127;i=t[yf(f+8|0,Zd(f+12|0,f+4|0))|0];jb=f+16|0;t[a|0]=i;a=a+c|0;b=b+4|0;e=e+1|0;if((e|0)!=(d|0)){continue}break}}jb=g+16|0}function Gk(a,b){a=a|0;b=b|0;var c=0,d=0;c=wc(a);if(c>>>0<b>>>0){d=jb-32|0;jb=d;a:{b:{c=b-c|0;c:{if(c>>>0<=v[zb(a)>>2]-v[a+4>>2]>>>0){NR(a,c);break c}b=zb(a);b=ph(d+8|0,Ki(a,wc(a)+c|0),wc(a),b);v[113382]=0;R(41,b|0,c|0);c=v[113382];v[113382]=0;if((c|0)==1){break b}v[113382]=0;R(40,a|0,b|0);a=v[113382];v[113382]=0;if((a|0)==1){break b}_p(b)}jb=d+32|0;break a}a=P()|0;O()|0;_p(b);S(a|0);L()}return}if(b>>>0<c>>>0){DR(a,v[a>>2]+b|0)}}function Xda(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;e=jb-32|0;jb=e;v[e+24>>2]=b;d=jb-16|0;jb=d;v[d>>2]=c;v[d+8>>2]=b;b=ut(d,d+8|0);jb=d+16|0;a:{b=Sh(e+8|0,a+8|0,b);if(v[b>>2]!=v[b+4>>2]){while(1){c=v[a+16>>2];d=v[b>>2];f=v[e+24>>2];v[113382]=0;U(730,c|0,d|0,f|0);c=v[113382];v[113382]=0;if((c|0)==1){break a}v[b>>2]=v[b>>2]+4;Ie(e+24|0);if(v[b>>2]!=v[b+4>>2]){continue}break}}yc(b);jb=e+32|0;return}a=P()|0;O()|0;yc(b);S(a|0);L()}function Rja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=jb-16|0;jb=d;v[d+12>>2]=c;e=ac(b);f=bc(b);c=jb-32|0;jb=c;v[c+16>>2]=f;v[c+24>>2]=e;v[c+8>>2]=d+12;a:{if(!Jb(c+24|0,c+16|0)){break a}while(1){e=v[c+24>>2];if(v[v[c+8>>2]>>2]==(w[e|0]|w[e+1|0]<<8)){break a}e=c+24|0;Kk(e);if(Jb(e,c+16|0)){continue}break}}jb=c+32|0;v[d+8>>2]=v[c+24>>2];g=d,h=bc(b),v[g>>2]=h;b:{if(Jb(d+8|0,d)){af(a,zb(v[d+8>>2]));break b}Vh(a)}jb=d+16|0}function L5(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;v[113382]=0;Z(1984,a|0);d=v[113382];v[113382]=0;a:{b:{if((d|0)!=1){d=v[a+24>>2];v[113382]=0;e=+oa(1994,d|0,b|0,c|0);b=v[113382];v[113382]=0;if((b|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,1836,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();e=0}return+e}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function l5(a,b){a=a|0;b=b|0;var c=0,d=C(0);v[113382]=0;Z(1984,a|0);c=v[113382];v[113382]=0;a:{b:{if((c|0)!=1){c=v[a+24>>2];v[113382]=0;d=C(pa(2019,c|0,b|0));b=v[113382];v[113382]=0;if((b|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,5387,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();d=C(0)}return C(d)}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function k5(a,b){a=a|0;b=b|0;var c=0,d=C(0);v[113382]=0;Z(1984,a|0);c=v[113382];v[113382]=0;a:{b:{if((c|0)!=1){c=v[a+24>>2];v[113382]=0;d=C(pa(2020,c|0,b|0));b=v[113382];v[113382]=0;if((b|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,2616,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();d=C(0)}return C(d)}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function j5(a,b){a=a|0;b=b|0;var c=0,d=C(0);v[113382]=0;Z(1984,a|0);c=v[113382];v[113382]=0;a:{b:{if((c|0)!=1){c=v[a+24>>2];v[113382]=0;d=C(pa(2021,c|0,b|0));b=v[113382];v[113382]=0;if((b|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,2523,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();d=C(0)}return C(d)}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function i5(a,b){a=a|0;b=b|0;var c=0,d=C(0);v[113382]=0;Z(1984,a|0);c=v[113382];v[113382]=0;a:{b:{if((c|0)!=1){c=v[a+24>>2];v[113382]=0;d=C(pa(2022,c|0,b|0));b=v[113382];v[113382]=0;if((b|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,2659,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();d=C(0)}return C(d)}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function h5(a,b){a=a|0;b=b|0;var c=0,d=C(0);v[113382]=0;Z(1984,a|0);c=v[113382];v[113382]=0;a:{b:{if((c|0)!=1){c=v[a+24>>2];v[113382]=0;d=C(pa(2023,c|0,b|0));b=v[113382];v[113382]=0;if((b|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,2567,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();d=C(0)}return C(d)}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function u6(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0;t[a+4202|0]=1;b=Ai(C(C(Ue(v[a+16>>2])>>>0)*C(.04500000178813934)));c=Ai(C(C(b>>>0)*C(1.1892070770263672)));d=Ai(C(C(c>>>0)*C(1.1892070770263672)));g=Ai(C(C(d>>>0)*C(1.1892070770263672)));e=Ai(C(C(b+d>>>0)*C(.11546666920185089)));f=Ai(C(C(c+g>>>0)*C(.11546666920185089)));v[a+4292>>2]=f;v[a+4288>>2]=e;v[a+4276>>2]=d-e;v[a+4272>>2]=b-e;v[a+4284>>2]=g-f;v[a+4280>>2]=c-f;CI(a);AI(a)}function p4(a){a=a|0;var b=0,c=0,d=0;v[113382]=0;Z(2057,a|0);b=v[113382];v[113382]=0;a:{b:{if((b|0)!=1){b=v[a+28>>2];d=v[v[b>>2]+44>>2];v[113382]=0;c=+la(d|0,b|0);b=v[113382];v[113382]=0;if((b|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,7732,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();c=0}return+c}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function mt(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;d=(w[ec(a,0)|0]&15)<<8|w[ec(a,1)|0];a:{if(!d|(d|0)==4095){break a}e=108;while(1){f=x[(c<<1)+26080>>1];if(f>>>0<=d>>>0){if(!(!c|(d|0)==(f|0)|(x[(c<<1)+26078>>1]-d|0)>=(d-f|0))){e=c+24|0;break a}e=c+25|0;break a}c=c+1|0;if(c>>>0<84){continue}break}}t[b|0]=e;c=w[ec(a,2)|0];g=b,h=w[ec(a,0)|0]&16|c>>>4,t[g+1|0]=h;g=b,h=w[ec(a,2)|0]&15,t[g+3|0]=h;g=b,h=w[ec(a,3)|0],t[g+5|0]=h}function m4(a){a=a|0;var b=0,c=0,d=0;v[113382]=0;Z(2057,a|0);b=v[113382];v[113382]=0;a:{b:{if((b|0)!=1){b=v[a+28>>2];d=v[v[b>>2]+36>>2];v[113382]=0;c=+la(d|0,b|0);b=v[113382];v[113382]=0;if((b|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,4026,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();c=0}return+c}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function k4(a){a=a|0;var b=0,c=0,d=0;v[113382]=0;Z(2057,a|0);b=v[113382];v[113382]=0;a:{b:{if((b|0)!=1){b=v[a+28>>2];d=v[v[b>>2]+28>>2];v[113382]=0;c=+la(d|0,b|0);b=v[113382];v[113382]=0;if((b|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,3974,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();c=0}return+c}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function Yn(a,b,c,d,e,f,g,h){var i=0,j=0,k=0,l=0;i=jb-16|0;jb=i;if((b^-1)-17>>>0>=c>>>0){j=Tb(a);l=a;a:{if(b>>>0<2147483623){v[i+8>>2]=b<<1;v[i+12>>2]=b+c;c=Wi(v[Vc(i+12|0,i+8|0)>>2]);break a}c=-18}k=c+1|0;c=Zg(l,k);if(e){ag(c,j,e)}if(g){ag(c+e|0,h,g)}d=d-(e+f|0)|0;if(d){ag((c+e|0)+g|0,(e+j|0)+f|0,d)}b=b+1|0;if((b|0)!=11){cg(a,j,b)}Oe(a,c);Gf(a,k);b=a;a=d+(e+g|0)|0;ae(b,a);t[i+7|0]=0;Rd(a+c|0,i+7|0);jb=i+16|0;return}If();L()}function M8(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;b=qi(a,b,c,d);v[a>>2]=74504;d=kk(a+4208|0);v[a+4220>>2]=0;v[a+4224>>2]=0;e=a,f=Ue(c),v[e+4232>>2]=f;v[113382]=0;Z(1608,a+4260|0);c=v[113382];v[113382]=0;a:{if((c|0)==1){break a}v[113382]=0;W(1609,a+44|0,2,2)|0;c=v[113382];v[113382]=0;if((c|0)==1){break a}v[113382]=0;Z(1610,b|0);c=v[113382];v[113382]=0;if((c|0)==1){break a}return a|0}a=P()|0;O()|0;fg(d);rf(b);S(a|0);L()}function tW(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;v[113382]=0;a=La(1975,a|0,b|0,c|0,d|0)|0;b=v[113382];v[113382]=0;a:{b:{if((b|0)==1){a=V(0)|0;O()|0;_(a|0)|0;v[113382]=0;ja(1969,7127,e|0,f|0,g|0,h|0,i|0,j|0);a=v[113382];v[113382]=0;if((a|0)==1){break b}$();a=-255}break a}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}return a|0}function gu(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;d=jb-32|0;jb=d;v[d+24>>2]=0;v[d+28>>2]=0;v[d+16>>2]=0;v[d+20>>2]=0;v[d+12>>2]=c;a:{if(c){while(1){v[d+8>>2]=16;e=0;f=v[Lb(d+8|0,d+12|0)>>2];if((f|0)!=((i=a,j=Eb(d+16|0),k=v[a+12>>2]+g|0,l=f,h=v[v[a>>2]+28>>2],nb[h](i|0,j|0,k|0,l|0)|0)|0)){break a}if(md(d+16|0,b+g|0,f)){break a}e=v[d+12>>2]-f|0;v[d+12>>2]=e;g=f+g|0;if(e){continue}break}}Tc(a,c);e=1}jb=d+32|0;return e}function ZA(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=jb-16|0;jb=d;e=a;v[a>>2]=0;v[a+4>>2]=0;v[113382]=0;v[d+12>>2]=0;W(320,a+8|0,d+12|0,d+8|0)|0;f=v[113382];v[113382]=0;a:{if((f|0)!=1){jb=d+16|0;break a}V(0)|0;O()|0;Ab();L()}b:{if(!b){break b}v[113382]=0;R(424,a|0,b|0);d=v[113382];v[113382]=0;if((d|0)!=1){v[113382]=0;U(425,a|0,b|0,c|0);b=v[113382];v[113382]=0;if((b|0)!=1){break b}}a=P()|0;O()|0;rC(e);S(a|0);L()}return a|0}function m6(a){a=a|0;var b=0,c=0;b=jb-16|0;jb=b;a:{b:{if(!a){break b}a=qc(b+8|0,a);v[113382]=0;c=v[a+4>>2];v[b>>2]=v[a>>2];v[b+4>>2]=c;a=T(1965,b|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){break a}a=V(0)|0;O()|0;_(a|0)|0;v[113382]=0;X(1958,8516,0,0,0);a=v[113382];v[113382]=0;if((a|0)!=1){$();break b}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}a=0}jb=b+16|0;return a|0}function qga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;g=jb-48|0;jb=g;a:{b:{if(c>>>0>d>>>0){break b}if(Ae(b)>>>0<=d>>>0){break b}while(1){f=c&65535;if(qh(Fe(b,f))){h=ac(Fe(b,f));i=bc(Fe(b,f));f=vO(g,e);v[113382]=0;X(995,g+24|0,h|0,i|0,f|0);h=v[113382];v[113382]=0;if((h|0)==1){break a}ee(g+24|0);ee(f)}c=c+1|0;if((c&65535)>>>0<=d>>>0){continue}break}}uO(a,e);jb=g+48|0;return}a=P()|0;O()|0;ee(f);S(a|0);L()}function uL(a,b){var c=0,d=0,e=0,f=0,g=0;c=v[a>>2];v[a>>2]=b;if(c){a=jb-16|0;jb=a;f=a,g=ac(c),v[f+8>>2]=g;f=a,g=bc(c),v[f>>2]=g;if(Jb(a+8|0,a)){while(1){e=v[a+8>>2];a:{while(1){b=v[e>>2];d=v[b>>2];if(!d){break a}b=v[v[d>>2]+8>>2];v[113382]=0;Z(b|0,d|0);b=v[113382];v[113382]=0;if((b|0)!=1){continue}break}V(0)|0;O()|0;mx(c);Ab();L()}Ib(b+20|0);Ib(b+8|0);Wb(b);b=a+8|0;Ie(b);if(Jb(b,a)){continue}break}}mx(c);jb=a+16|0;Wb(c)}}function XX(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;e=jb-16|0;jb=e;while(1){a:{if((c|0)<=(f|0)){break a}d=v[a+16>>2];g=v[a+12>>2];b:{if(d>>>0>g>>>0){v[e+12>>2]=2147483647;v[e+8>>2]=d-g;v[e+4>>2]=c-f;d=v[Zd(e+12|0,Zd(e+8|0,e+4|0))>>2];ag(b,v[a+12>>2],d);v[a+12>>2]=v[a+12>>2]+d;break b}d=nb[v[v[a>>2]+40>>2]](a)|0;if((d|0)==-1){break a}h=b,i=um(d),t[h|0]=i;d=1}b=b+d|0;f=d+f|0;continue}break}jb=e+16|0;return f|0}function TX(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;e=jb-16|0;jb=e;while(1){a:{if((c|0)<=(g|0)){break a}d=v[a+12>>2];f=v[a+16>>2];b:{if(d>>>0<f>>>0){v[e+12>>2]=2147483647;v[e+8>>2]=f-d>>2;v[e+4>>2]=c-g;d=v[Zd(e+12|0,Zd(e+8|0,e+4|0))>>2];yh(b,v[a+12>>2],d);f=d<<2;v[a+12>>2]=f+v[a+12>>2];b=b+f|0;break b}d=nb[v[v[a>>2]+40>>2]](a)|0;if((d|0)==-1){break a}v[b>>2]=d;d=1;b=b+4|0}g=d+g|0;continue}break}jb=e+16|0;return g|0}function uK(a){var b=0,c=0,d=0,e=0;a:{if((w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24))!=1163089229){break a}b=a+4|0;c=w[b+1|0]<<8;d=w[b+2|0]<<16|w[b+3|0]<<24;if((w[b|0]|c|d)!=-1346458146&(d|(c|w[b|0]))!=-1095062050){break a}b=a+16|0;if(!(w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24))){break a}a=a+8|0;e=((w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24))+24|0)==(w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24))}return e}function sd(a,b){a=a|0;b=b|0;var c=0,d=0;d=jb-16|0;jb=d;ln(a);v[a+16>>2]=0;v[a+8>>2]=0;v[a+12>>2]=0;v[a>>2]=0;v[a+4>>2]=0;u[a+32>>1]=64;v[a+24>>2]=8363;v[a+28>>2]=16777344;v[a+36>>2]=0;t[a+39|0]=0;t[a+40|0]=0;t[a+41|0]=0;t[a+42|0]=0;c=x[a+34>>1]&-25151;u[a+34>>1]=(b|0)==4?c|32:c;b=Ub(d,17540);v[113382]=0;Q(336,a+43|0,b|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){yb(b);RN(a);jb=d+16|0;return}a=P()|0;O()|0;yb(b);S(a|0);L()}function qp(a){a=a|0;var b=0,c=0,d=0,e=0;ln(a);b=v[a>>2];c=Wn(a);if(b-1>>>0<=268435455){b=b+208|0;qma(c,0,b,0);c=mb?0:B(b,c)}else{c=0}a:{if(!c){break a}v[113382]=0;b=T(2791,c|0)|0;d=v[113382];v[113382]=0;b:{c:{if((d|0)==1){b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;Y(20);d=v[113382];v[113382]=0;b=0;if((d|0)==1){break c}}break b}V(0)|0;O()|0;Ab();L()}if(!b){break a}e=Qb(b,0,c)- -64|0}v[a+20>>2]=e;if(!e){return 0}return zj(a)|0}function yG(a){var b=C(0),c=0,d=C(0),e=C(0),f=C(0),g=C(0),h=0,i=C(0),j=0,k=0,l=C(0),m=C(0),n=C(0),o=C(0),p=0;j=a-24|0;b=z[j>>2];c=a-8|0;d=z[c>>2];e=C(b+d);k=a-16|0;f=z[k>>2];l=z[a>>2];g=C(f+l);z[a>>2]=e+g;z[c>>2]=g-e;c=a-28|0;g=z[c>>2];h=a-12|0;m=z[h>>2];e=C(g+m);p=h;h=a-20|0;i=z[h>>2];a=a-4|0;n=z[a>>2];o=C(i+n);z[p>>2]=o-e;i=C(n-i);b=C(d-b);z[c>>2]=i+b;d=C(m-g);f=C(l-f);z[k>>2]=d+f;z[j>>2]=f-d;z[a>>2]=o+e;z[h>>2]=i-b}function S5(a,b){a=a|0;b=b|0;var c=0,d=0;v[113382]=0;Z(1984,a|0);c=v[113382];v[113382]=0;d=1;a:{b:{if((c|0)!=1){c=v[a+24>>2];v[113382]=0;R(1987,c|0,b|0);b=v[113382];v[113382]=0;if((b|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,6926,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();d=0}return d|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function Q5(a,b){a=a|0;b=b|0;var c=0,d=0;v[113382]=0;Z(1984,a|0);c=v[113382];v[113382]=0;d=1;a:{b:{if((c|0)!=1){c=v[a+24>>2];v[113382]=0;R(1989,c|0,b|0);b=v[113382];v[113382]=0;if((b|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,2270,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();d=0}return d|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function o3(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;f=jb-16|0;jb=f;a:{b:{c:{if(!(e?d:0)){b=ba(8)|0;v[113382]=0;c=Q(121,f|0,4474)|0;a=v[113382];v[113382]=0;if((a|0)==1){break c}nc(b,c);v[113382]=0;U(1978,b|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break a}a=P()|0;O()|0;yb(c);break b}ni(a,b,2);c=_w(a,c,d,e,0,0);A[a+16>>3]=+(c>>>0)/+(b|0)+A[a+16>>3];jb=f+16|0;return c|0}a=P()|0;O()|0;ca(b|0)}S(a|0)}L()}function mja(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;d=v[b>>2];f=vS(b);c=jb-16|0;jb=c;e=rt(d,f);a:{if(e>>>0<=nd(a)>>>0){if(Kb(a)>>>0<e>>>0){v[c+12>>2]=d;IQ(c+12|0,Kb(a));kf(d,v[c+12>>2],v[a>>2]);Cp(a,v[c+12>>2],f,e-Kb(a)|0);break a}Ku(a,kf(d,f,v[a>>2]));break a}HQ(a);b=a;g=ye(a,e);if(g>>>0>ns(a)>>>0){ld();L()}h=_B(zb(b),g);v[b>>2]=h;v[b+4>>2]=h;i=zb(b),j=(g<<2)+h|0,v[i>>2]=j;lk(b,0);Cp(a,d,f,e)}jb=c+16|0}function l3(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;f=jb-16|0;jb=f;a:{b:{c:{if(!(e?d:0)){b=ba(8)|0;v[113382]=0;c=Q(121,f|0,4474)|0;a=v[113382];v[113382]=0;if((a|0)==1){break c}nc(b,c);v[113382]=0;U(1978,b|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break a}a=P()|0;O()|0;yb(c);break b}ni(a,b,2);c=Zw(a,c,d,e,0,0);A[a+16>>3]=+(c>>>0)/+(b|0)+A[a+16>>3];jb=f+16|0;return c|0}a=P()|0;O()|0;ca(b|0)}S(a|0)}L()}function ST(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=jb-16|0;jb=c;e=jb-16|0;jb=e;d=c+8|0;fc(d,b,17);jb=e+16|0;e=Hb(d);d=mc(a,$b(c,d));if((e|0)==(d|0)){_b(a,Hb(c+8|0))}jb=c+16|0;a=(d|0)==(e|0);if(!a){c=jb-16|0;jb=c;t[b|0]=0;t[b+1|0]=0;t[b+2|0]=0;t[b+3|0]=0;t[b+4|0]=0;t[b+5|0]=0;t[b+6|0]=0;t[b+7|0]=0;t[b+16|0]=0;t[b+8|0]=0;t[b+9|0]=0;t[b+10|0]=0;t[b+11|0]=0;t[b+12|0]=0;t[b+13|0]=0;t[b+14|0]=0;t[b+15|0]=0;jb=c+16|0}return a|0}function Rda(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;e=jb-16|0;jb=e;u[e+12>>1]=c;u[e+14>>1]=b;sg(e+14|0,x[v[v[a+24>>2]+8>>2]+12>>1]);c=e+12|0;b=jb-16|0;jb=b;d=x[e+14>>1];v[b+12>>2]=d;a:{if(Yf(a)>>>0>=d>>>0){g=b,h=oc(a),v[g+8>>2]=h;Iz(v[a>>2],v[Lb(b+12|0,b+8|0)>>2],c);f=v[b+8>>2];d=v[b+12>>2];if(f>>>0<d>>>0){gq(a,d-f|0,c);break a}Kn(a,v[a>>2]+(d<<1)|0);break a}JN(a);mz(a,Qi(a,d));gq(a,d,c)}jb=b+16|0;jb=e+16|0}function IT(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;f=jb-16|0;jb=f;a:{b:{if(!Ef(a,7)){break b}c=0;if(!iB(a,13827)){break a}if(!Ef(a,1)){break b}c=-1;if(!Tc(a,lu(a))){break a}d=jb-16|0;jb=d;e=d+8|0;g=f+8|0;eu(e,g);c=a;h=Hb(e);e=hd(a,$b(d,e));if((h|0)==(e|0)){Tc(c,Hb(d+8|0))}jb=d+16|0;d=(e|0)==(h|0);if(!d){QA(g)}c=-1;if(!d){break a}c=0;if(!dB(f+8|0)){break a}c=gf(a,b,cB(f+8|0),mb);break a}c=-1}jb=f+16|0;return c|0}function YP(a){var b=0;b=jb-16|0;jb=b;t[a|0]=0;t[a+1|0]=0;t[a+2|0]=0;t[a+3|0]=0;t[a+4|0]=0;t[a+5|0]=0;t[a+6|0]=0;t[a+7|0]=0;t[a+22|0]=0;t[a+23|0]=0;t[a+24|0]=0;t[a+25|0]=0;t[a+26|0]=0;t[a+27|0]=0;t[a+28|0]=0;t[a+29|0]=0;t[a+16|0]=0;t[a+17|0]=0;t[a+18|0]=0;t[a+19|0]=0;t[a+20|0]=0;t[a+21|0]=0;t[a+22|0]=0;t[a+23|0]=0;t[a+8|0]=0;t[a+9|0]=0;t[a+10|0]=0;t[a+11|0]=0;t[a+12|0]=0;t[a+13|0]=0;t[a+14|0]=0;t[a+15|0]=0;jb=b+16|0}function Lo(a,b,c){var d=0,e=0;a=sf(a);d=Db(b);v[113382]=0;R(113,a|0,d|0);d=v[113382];v[113382]=0;if((d|0)!=1){a:{if(Db(b)){while(1){d=w[kc(b,e)|0];b:{if(d>>>0<256){d=v[(d<<2)+c>>2];v[113382]=0;R(112,a|0,d|0);d=v[113382];v[113382]=0;if((d|0)!=1){break b}break a}v[113382]=0;R(112,a|0,65533);d=v[113382];v[113382]=0;if((d|0)==1){break a}}e=e+1|0;if(Db(b)>>>0>e>>>0){continue}break}}return}}b=P()|0;O()|0;Jc(a);S(b|0);L()}function wC(a){var b=0,c=0;a:{if((w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24))!=1179340888|(w[a+8|0]|w[a+9|0]<<8|(w[a+10|0]<<16|w[a+11|0]<<24))!=1213419859){break a}b=a+4|0;if(!(w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24))){break a}a=a+12|0;if(!(w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24))){break a}a=w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24);c=(a<<24|a<<8&16711680|(a>>>8&65280|a>>>24))>>>0>27}return c}function Tfa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;b=jb-16|0;jb=b;g=v[a+24>>2];h=v[a+20>>2];i=v[a+16>>2];e=v[a+4>>2];f=v[a>>2];v[b+8>>2]=f;v[b+12>>2]=e;j=v[a+12>>2];v[b>>2]=v[a+8>>2];v[b+4>>2]=j;if(d){while(1){e=u[(e<<1)+i>>1];v[c>>2]=v[c>>2]+B(e,h);v[c+4>>2]=v[c+4>>2]+B(e,g);Sb(b+8|0,b);d=d-1|0;if(d){c=c+8|0;e=v[b+12>>2];continue}break}f=v[b+8>>2];e=v[b+12>>2]}v[a>>2]=f;v[a+4>>2]=e;jb=b+16|0}function LR(a,b){var c=0,d=0,e=0,f=0;a:{b:{if(!b){break b}if(!Rb(a,b)){break b}if(b>>>0<=3){c=jb-16|0;jb=c;c:{if(!b){break c}if(!Rb(a,b)){break c}while(1){t[c+11|0]=0;d:{if(b>>>0>d>>>0){_f(a,c+11|0);e=t[c+11|0];f=e>>>31|0;break d}e=0-f|0}t[(c+12|0)+d|0]=e;d=d+1|0;if((d|0)!=4){continue}break}v[c+4>>2]=v[c+12>>2];d=w[c+4|0]|w[c+5|0]<<8|(w[c+6|0]<<16|w[c+7|0]<<24)}jb=c+16|0;a=d;break a}c=Df(a);_b(a,b-4|0)}a=c}return a}function W4(a,b){a=a|0;b=b|0;var c=0;v[113382]=0;Z(1984,a|0);c=v[113382];v[113382]=0;a:{b:{if((c|0)!=1){c=v[a+24>>2];v[113382]=0;b=Q(2037,c|0,b|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,5766,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();b=0}return b|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function V4(a,b){a=a|0;b=b|0;var c=0;v[113382]=0;Z(1984,a|0);c=v[113382];v[113382]=0;a:{b:{if((c|0)!=1){c=v[a+24>>2];v[113382]=0;b=Q(2038,c|0,b|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,2953,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();b=0}return b|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function by(a,b){a=a|0;b=b|0;var c=C(0),d=0,e=0,f=0;v[a+1074372>>2]=b;JK(a+1074332|0,b);e=a+946300|0;a=a+906300|0;while(1){b=v[a>>2];if(b){c=C(1);d=v[b+20>>2];if(d){c=C(C(w[d+26|0])*C(.10000000149011612))}c=c<C(.10000000149011612)?C(1):c;d=b;if(nb[v[v[b>>2]+132>>2]](b)|0){f=hJ(v[b+16>>2]);b=v[b+16>>2];c=C(C(c*C(y[b+480232>>2]))/C(z[f+8>>2]*z[hJ(b)+20>>2]))}z[d+4196>>2]=c}a=a+160|0;if((e|0)!=(a|0)){continue}break}}function Uia(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=jb-16|0;jb=c;d=a;v[a>>2]=0;v[a+4>>2]=0;v[113382]=0;v[c+12>>2]=0;W(839,a+8|0,c+12|0,c+8|0)|0;e=v[113382];v[113382]=0;a:{if((e|0)!=1){jb=c+16|0;break a}V(0)|0;O()|0;Ab();L()}b:{if(!b){break b}v[113382]=0;R(834,a|0,b|0);c=v[113382];v[113382]=0;if((c|0)!=1){v[113382]=0;R(835,a|0,b|0);b=v[113382];v[113382]=0;if((b|0)!=1){break b}}a=P()|0;O()|0;rQ(d);S(a|0);L()}return a|0}function Ria(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=jb-16|0;jb=c;d=a;v[a>>2]=0;v[a+4>>2]=0;v[113382]=0;v[c+12>>2]=0;W(841,a+8|0,c+12|0,c+8|0)|0;e=v[113382];v[113382]=0;a:{if((e|0)!=1){jb=c+16|0;break a}V(0)|0;O()|0;Ab();L()}b:{if(!b){break b}v[113382]=0;R(836,a|0,b|0);c=v[113382];v[113382]=0;if((c|0)!=1){v[113382]=0;R(837,a|0,b|0);b=v[113382];v[113382]=0;if((b|0)!=1){break b}}a=P()|0;O()|0;qQ(d);S(a|0);L()}return a|0}function Wia(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=jb-48|0;jb=e;Bi(e+24|0,e+16|0,c);v[113382]=0;U(833,e+36|0,e+8|0,d|0);c=v[113382];v[113382]=0;a:{b:{if((c|0)!=1){v[113382]=0;R(630,e|0,e+24|0);c=v[113382];v[113382]=0;if((c|0)==1){break b}v[113382]=0;U(481,a|0,b|0,e|0);a=v[113382];v[113382]=0;if((a|0)==1){break b}hf(e+24|0);jb=e+48|0;return}c=P()|0;O()|0;yb(e+24|0);break a}c=P()|0;O()|0;hf(e+24|0)}S(c|0);L()}function Ufa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;b=jb-16|0;jb=b;g=v[a+24>>2];h=v[a+20>>2];i=v[a+16>>2];e=v[a+4>>2];f=v[a>>2];v[b+8>>2]=f;v[b+12>>2]=e;j=v[a+12>>2];v[b>>2]=v[a+8>>2];v[b+4>>2]=j;if(d){while(1){e=t[e+i|0]<<8;v[c>>2]=v[c>>2]+B(e,h);v[c+4>>2]=v[c+4>>2]+B(e,g);Sb(b+8|0,b);d=d-1|0;if(d){c=c+8|0;e=v[b+12>>2];continue}break}f=v[b+8>>2];e=v[b+12>>2]}v[a>>2]=f;v[a+4>>2]=e;jb=b+16|0}function Kda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=jb-48|0;jb=e;eA(e+24|0,e+16|0,c);v[113382]=0;U(629,e+36|0,e+8|0,d|0);c=v[113382];v[113382]=0;a:{b:{if((c|0)!=1){v[113382]=0;R(630,e|0,e+24|0);c=v[113382];v[113382]=0;if((c|0)==1){break b}v[113382]=0;U(481,a|0,b|0,e|0);a=v[113382];v[113382]=0;if((a|0)==1){break b}hf(e+24|0);jb=e+48|0;return}c=P()|0;O()|0;yb(e+24|0);break a}c=P()|0;O()|0;hf(e+24|0)}S(c|0);L()}function HA(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=jb-16|0;jb=d;v[d+12>>2]=c;e=ac(b);f=bc(b);c=jb-32|0;jb=c;v[c+16>>2]=f;v[c+24>>2]=e;v[c+8>>2]=d+12;a:{if(!Jb(c+24|0,c+16|0)){break a}while(1){if((Ej(v[c+24>>2])|0)==v[v[c+8>>2]>>2]){break a}e=c+24|0;Kk(e);if(Jb(e,c+16|0)){continue}break}}jb=c+32|0;v[d+8>>2]=v[c+24>>2];g=d,h=bc(b),v[g>>2]=h;b:{if(Jb(d+8|0,d)){af(a,zb(v[d+8>>2]));break b}Vh(a)}jb=d+16|0}function C4(a){a=a|0;var b=0;v[113382]=0;Z(2057,a|0);b=v[113382];v[113382]=0;if((b|0)!=1){v[a+24>>2]=0;b=v[a+28>>2];if(b){nb[v[v[b>>2]+4>>2]](b)}v[a+28>>2]=0;b=v[a+20>>2];if(b){Wb(b);v[a+20>>2]=0}Wb(a);return}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,1558,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)!=1){$();return}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function bv(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;e=jb-16|0;jb=e;c=Yh(e+8|0,b);f=jb-16|0;jb=f;g=f+8|0;j=g;i=jb-16|0;jb=i;h=jb-16|0;jb=h;d=jb-16|0;jb=d;b=h;v[b+4>>2]=1;k=b,l=$C(1),v[k+8>>2]=l;jb=d+16|0;d=v[b+8>>2];v[113382]=0;Q(242,d|0,c|0)|0;c=v[113382];v[113382]=0;a:{if((c|0)!=1){c=eo(b);co(j,gc(c),c);aD(b);jb=h+16|0;break a}a=P()|0;O()|0;aD(b);S(a|0);L()}jb=i+16|0;im(a,g);Bb(g);jb=f+16|0;jb=e+16|0}function Xla(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=jb-48|0;jb=e;nm(e+24|0,e+16|0,c);v[113382]=0;U(210,e+36|0,e+8|0,d|0);c=v[113382];v[113382]=0;a:{b:{if((c|0)!=1){v[113382]=0;R(78,e|0,e+24|0);c=v[113382];v[113382]=0;if((c|0)==1){break b}v[113382]=0;U(72,a|0,b|0,e|0);a=v[113382];v[113382]=0;if((a|0)==1){break b}hf(e+24|0);jb=e+48|0;return}c=P()|0;O()|0;yb(e+24|0);break a}c=P()|0;O()|0;hf(e+24|0)}S(c|0);L()}function N5(a,b){a=a|0;b=+b;var c=0;v[113382]=0;Z(1984,a|0);c=v[113382];v[113382]=0;a:{b:{if((c|0)!=1){c=v[a+24>>2];v[113382]=0;b=+fb(1992,c|0,+b);c=v[113382];v[113382]=0;if((c|0)!=1){break b}}c=V(0)|0;O()|0;_(c|0)|0;v[113382]=0;X(1958,3818,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();b=0}return+b}a=P()|0;O()|0;v[113382]=0;Y(20);c=v[113382];v[113382]=0;if((c|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function Fka(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=jb-48|0;jb=e;nm(e+24|0,e+16|0,c);v[113382]=0;U(194,e+36|0,e+8|0,d|0);c=v[113382];v[113382]=0;a:{b:{if((c|0)!=1){v[113382]=0;R(78,e|0,e+24|0);c=v[113382];v[113382]=0;if((c|0)==1){break b}v[113382]=0;U(72,a|0,b|0,e|0);a=v[113382];v[113382]=0;if((a|0)==1){break b}hf(e+24|0);jb=e+48|0;return}c=P()|0;O()|0;yb(e+24|0);break a}c=P()|0;O()|0;hf(e+24|0)}S(c|0);L()}function lka(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=jb-32|0;jb=e;v[e+24>>2]=d;g=Lj(a,c);pf(e,v[a+28>>2]);d=v[e+12>>2];v[e+16>>2]=v[e+8>>2];v[e+20>>2]=d;a:{if(!g){if(wd(a,5)){break a}}h=v[a+28>>2];i=v[e+24>>2];f=jb-16|0;jb=f;d=bd(f);v[113382]=0;aa(656,b|0,h|0,d|0,i|0)|0;b=v[113382];v[113382]=0;b:{if((b|0)!=1){yb(d);jb=f+16|0;break b}a=P()|0;O()|0;yb(d);S(a|0);L()}}$i(a,g,c,e+16|0);jb=e+32|0}function hT(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;e=jb-32|0;jb=e;f=e+8|0;g=f;h=b;if(zA(b,e+24|0)){d=e+28|0;d=w[d|0]|w[d+1|0]<<8|(w[d+2|0]<<16|w[d+3|0]<<24);d=d<<24|d<<8&16711680|(d>>>8&65280|d>>>24)}td(g,h,d);a=yA(a,e+24|0,f);Bb(f);a:{if(!c){break a}d=(d>>>0)%(c>>>0)|0;if(!d){break a}v[113382]=0;Q(304,b|0,c-d|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){break a}b=P()|0;O()|0;lf(a);S(b|0);L()}jb=e+32|0}function ZV(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=jb-48|0;jb=e;Bi(e+24|0,e+16|0,c);v[113382]=0;U(194,e+36|0,e+8|0,d|0);c=v[113382];v[113382]=0;a:{b:{if((c|0)!=1){v[113382]=0;R(78,e|0,e+24|0);c=v[113382];v[113382]=0;if((c|0)==1){break b}v[113382]=0;U(72,a|0,b|0,e|0);a=v[113382];v[113382]=0;if((a|0)==1){break b}hf(e+24|0);jb=e+48|0;return}c=P()|0;O()|0;yb(e+24|0);break a}c=P()|0;O()|0;hf(e+24|0)}S(c|0);L()}function Vda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=jb-48|0;jb=e;GN(e+24|0,e+16|0,c);v[113382]=0;U(77,e+36|0,e+8|0,d|0);c=v[113382];v[113382]=0;a:{b:{if((c|0)!=1){v[113382]=0;R(78,e|0,e+24|0);c=v[113382];v[113382]=0;if((c|0)==1){break b}v[113382]=0;U(72,a|0,b|0,e|0);a=v[113382];v[113382]=0;if((a|0)==1){break b}hf(e+24|0);jb=e+48|0;return}c=P()|0;O()|0;yb(e+24|0);break a}c=P()|0;O()|0;hf(e+24|0)}S(c|0);L()}function TT(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=jb-48|0;jb=e;su(e+24|0,e+16|0,c);v[113382]=0;U(400,e+36|0,e+8|0,d|0);c=v[113382];v[113382]=0;a:{b:{if((c|0)!=1){v[113382]=0;R(78,e|0,e+24|0);c=v[113382];v[113382]=0;if((c|0)==1){break b}v[113382]=0;U(72,a|0,b|0,e|0);a=v[113382];v[113382]=0;if((a|0)==1){break b}hf(e+24|0);jb=e+48|0;return}c=P()|0;O()|0;yb(e+24|0);break a}c=P()|0;O()|0;hf(e+24|0)}S(c|0);L()}function Bw(a){var b=0,c=0,d=0;a:{b:{if(!v[a+1384>>2]){b=v[a+1380>>2];if((b|0)==-1){v[a+1388>>2]=v[a+1116>>2]-1;if(!Fr(a)){v[a+1384>>2]=1;return 0}if(!(t[a+1375|0]&1)){break b}b=v[a+1380>>2]}d=b+1|0;v[a+1380>>2]=d;c=w[(a+b|0)+1120|0];if((c|0)!=255){v[a+1388>>2]=b;v[a+1384>>2]=1}if(v[a+1116>>2]<=(d|0)){v[a+1380>>2]=-1}if(w[a+1376|0]){break a}t[a+1376|0]=c}return c}cc(a,32);return 0}ia(11905,9203,1564,2463);L()}function R$(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=C(0),g=0,h=C(0);e=jb-16|0;jb=e;a:{b:{c:{if((a|0)!=(b|0)){g=v[113305];v[113305]=0;ge();d=jb-16|0;jb=d;dw(d,a,e+12|0,0);f=TF(v[d>>2],v[d+4>>2],v[d+8>>2],v[d+12>>2]);jb=d+16|0;a=v[113305];if(!a){break c}if(v[e+12>>2]!=(b|0)){break b}h=f;if((a|0)!=68){break a}break b}v[c>>2]=4;break a}v[113305]=g;if(v[e+12>>2]==(b|0)){break a}}v[c>>2]=4;f=h}jb=e+16|0;return C(f)}function $G(a,b){a=a|0;b=b|0;var c=0;c=jb-16|0;jb=c;a:{b:{c:{d:{if((b|0)>=0){if((Go(a+8|0)|0)>(b|0)){break d}}a=ba(8)|0;v[113382]=0;c=Q(121,c|0,6794)|0;b=v[113382];v[113382]=0;if((b|0)==1){break c}nc(a,c);v[113382]=0;U(1978,a|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break a}b=P()|0;O()|0;yb(c);break b}jb=c+16|0;return+(+v[(v[a+32>>2]+B(b,896)|0)+1075744>>2]*.015625)}b=P()|0;O()|0;ca(a|0)}S(b|0)}L()}function R5(a){a=a|0;var b=0,c=0;v[113382]=0;Z(1984,a|0);b=v[113382];v[113382]=0;a:{b:{if((b|0)!=1){b=v[a+24>>2];v[113382]=0;b=T(1988,b|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,6956,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();b=-1}return b|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function y3(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;b=jb-32|0;jb=b;v[b+24>>2]=e;v[b+28>>2]=f;a:{a=rs(a,Ll(b+16|0,Eb(c),d),b+24|0);if(a+1>>>0>=3){a=ba(8)|0;v[113382]=0;b=Q(121,b|0,4331)|0;c=v[113382];v[113382]=0;b:{if((c|0)!=1){nc(a,b);v[113382]=0;U(1978,a|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break a}c=P()|0;O()|0;yb(b);break b}c=P()|0;O()|0;ca(a|0)}S(c|0);L()}jb=b+32|0;return a|0}L()}function s5(a){a=a|0;var b=0,c=0;v[113382]=0;Z(1984,a|0);b=v[113382];v[113382]=0;a:{b:{if((b|0)!=1){b=v[a+24>>2];v[113382]=0;b=T(2013,b|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,8791,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();b=0}return b|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function r5(a){a=a|0;var b=0,c=0;v[113382]=0;Z(1984,a|0);b=v[113382];v[113382]=0;a:{b:{if((b|0)!=1){b=v[a+24>>2];v[113382]=0;b=T(2014,b|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,5340,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();b=0}return b|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function q5(a){a=a|0;var b=0,c=0;v[113382]=0;Z(1984,a|0);b=v[113382];v[113382]=0;a:{b:{if((b|0)!=1){b=v[a+24>>2];v[113382]=0;b=T(2015,b|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,4970,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();b=0}return b|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function p5(a){a=a|0;var b=0,c=0;v[113382]=0;Z(1984,a|0);b=v[113382];v[113382]=0;a:{b:{if((b|0)!=1){b=v[a+24>>2];v[113382]=0;b=T(2016,b|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,5731,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();b=0}return b|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function o5(a){a=a|0;var b=0,c=0;v[113382]=0;Z(1984,a|0);b=v[113382];v[113382]=0;a:{b:{if((b|0)!=1){b=v[a+24>>2];v[113382]=0;b=T(2017,b|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,1805,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();b=0}return b|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function m5(a){a=a|0;var b=0,c=0;v[113382]=0;Z(1984,a|0);b=v[113382];v[113382]=0;a:{b:{if((b|0)!=1){b=v[a+24>>2];v[113382]=0;b=T(2018,b|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,3416,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();b=0}return b|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function g5(a){a=a|0;var b=0,c=0;v[113382]=0;Z(1984,a|0);b=v[113382];v[113382]=0;a:{b:{if((b|0)!=1){b=v[a+24>>2];v[113382]=0;b=T(2024,b|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,3502,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();b=0}return b|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function f5(a){a=a|0;var b=0,c=0;v[113382]=0;Z(1984,a|0);b=v[113382];v[113382]=0;a:{b:{if((b|0)!=1){b=v[a+24>>2];v[113382]=0;b=T(2025,b|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,3384,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();b=0}return b|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function e5(a){a=a|0;var b=0,c=0;v[113382]=0;Z(1984,a|0);b=v[113382];v[113382]=0;a:{b:{if((b|0)!=1){b=v[a+24>>2];v[113382]=0;b=T(2026,b|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,3191,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();b=0}return b|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function d5(a){a=a|0;var b=0,c=0;v[113382]=0;Z(1984,a|0);b=v[113382];v[113382]=0;a:{b:{if((b|0)!=1){b=v[a+24>>2];v[113382]=0;b=T(2027,b|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,3259,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();b=0}return b|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function c5(a){a=a|0;var b=0,c=0;v[113382]=0;Z(1984,a|0);b=v[113382];v[113382]=0;a:{b:{if((b|0)!=1){b=v[a+24>>2];v[113382]=0;b=T(2028,b|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,3112,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();b=0}return b|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function b5(a){a=a|0;var b=0,c=0;v[113382]=0;Z(1984,a|0);b=v[113382];v[113382]=0;a:{b:{if((b|0)!=1){b=v[a+24>>2];v[113382]=0;b=T(2029,b|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,3692,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();b=0}return b|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function P5(a){a=a|0;var b=0,c=0;v[113382]=0;Z(1984,a|0);b=v[113382];v[113382]=0;a:{b:{if((b|0)!=1){b=v[a+24>>2];v[113382]=0;b=T(1990,b|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,2302,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();b=0}return b|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function ola(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=jb-16|0;jb=c;e=jb-16|0;jb=e;d=c+8|0;fc(d,b,15);jb=e+16|0;e=Hb(d);d=mc(a,$b(c,d));if((e|0)==(d|0)){_b(a,Hb(c+8|0))}jb=c+16|0;a=(d|0)==(e|0);if(!a){c=jb-16|0;jb=c;t[b|0]=0;t[b+1|0]=0;t[b+2|0]=0;t[b+3|0]=0;t[b+4|0]=0;t[b+5|0]=0;t[b+6|0]=0;t[b+7|0]=0;t[b+7|0]=0;t[b+8|0]=0;t[b+9|0]=0;t[b+10|0]=0;t[b+11|0]=0;t[b+12|0]=0;t[b+13|0]=0;t[b+14|0]=0;jb=c+16|0}return a|0}function fha(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;a:{d=dP(b,c);v[113382]=0;e=Q(952,b+12|0,c+12|0)|0;a=v[113382];v[113382]=0;b:{c:{if((a|0)!=1){v[113382]=0;Q(953,b+24|0,c+24|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break c}a=v[c+40>>2];v[b+36>>2]=v[c+36>>2];v[b+40>>2]=a;u[b+52>>1]=x[c+52>>1];a=v[c+48>>2];v[b+44>>2]=v[c+44>>2];v[b+48>>2]=a;break a}a=P()|0;O()|0;break b}a=P()|0;O()|0;$d(e)}$d(d);S(a|0);L()}}function ZG(a,b){a=a|0;b=b|0;var c=0;c=jb-16|0;jb=c;a:{b:{c:{d:{if((b|0)>=0){if((Go(a+8|0)|0)>(b|0)){break d}}a=ba(8)|0;v[113382]=0;c=Q(121,c|0,6794)|0;b=v[113382];v[113382]=0;if((b|0)==1){break c}nc(a,c);v[113382]=0;U(1978,a|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break a}b=P()|0;O()|0;yb(c);break b}jb=c+16|0;return(w[(v[a+32>>2]+B(b,896)|0)+1075073|0]&4)>>>2|0}b=P()|0;O()|0;ca(a|0)}S(b|0)}L()}function Vh(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;d=jb-16|0;jb=d;g=jb-16|0;jb=g;e=d+8|0;h=e;f=jb-16|0;jb=f;b=jb-16|0;jb=b;c=f;v[c+4>>2]=1;i=c,j=Lq(c,1),v[i+8>>2]=j;jb=b+16|0;b=v[c+8>>2];v[113382]=0;T(246,b|0)|0;b=v[113382];v[113382]=0;a:{if((b|0)!=1){b=eo(c);co(h,gc(b),b);SC(c);jb=f+16|0;break a}a=P()|0;O()|0;SC(c);S(a|0);L()}jb=g+16|0;im(a,e);Bb(e);jb=d+16|0;v[a+8>>2]=0;v[a+12>>2]=0;return a|0}function VX(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;e=jb-16|0;jb=e;while(1){a:{if((c|0)<=(f|0)){break a}d=v[a+28>>2];g=v[a+24>>2];if(d>>>0<=g>>>0){if(((i=a,j=Hg(t[b|0]),h=v[v[a>>2]+52>>2],nb[h](i|0,j|0)|0)|0)==-1){break a}f=f+1|0;b=b+1|0}else{v[e+12>>2]=d-g;v[e+8>>2]=c-f;d=v[Zd(e+12|0,e+8|0)>>2];ag(v[a+24>>2],b,d);v[a+24>>2]=d+v[a+24>>2];f=f+d|0;b=b+d|0}continue}break}jb=e+16|0;return f|0}function Kq(a){var b=0,c=0;yn(a,1,10707);v[113382]=0;b=da(198)|0;c=v[113382];v[113382]=0;a:{if((c|0)==1){break a}v[a+12>>2]=b;v[113382]=0;b=da(199)|0;c=v[113382];v[113382]=0;if((c|0)==1){break a}t[a+16|0]=b;v[113382]=0;b=da(200)|0;c=v[113382];v[113382]=0;if((c|0)==1){break a}t[a+18|0]=0;t[a+17|0]=b;v[113382]=0;Z(201,a+20|0);b=v[113382];v[113382]=0;if((b|0)==1){break a}return}b=P()|0;O()|0;yb(a);S(b|0);L()}function t5(a){a=a|0;var b=0,c=0;v[113382]=0;Z(1984,a|0);b=v[113382];v[113382]=0;a:{b:{if((b|0)!=1){b=v[a+24>>2];v[113382]=0;c=+la(2012,b|0);b=v[113382];v[113382]=0;if((b|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,6237,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();c=0}return+c}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function O5(a){a=a|0;var b=0,c=0;v[113382]=0;Z(1984,a|0);b=v[113382];v[113382]=0;a:{b:{if((b|0)!=1){b=v[a+24>>2];v[113382]=0;c=+la(1991,b|0);b=v[113382];v[113382]=0;if((b|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,3890,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();c=0}return+c}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function M5(a){a=a|0;var b=0,c=0;v[113382]=0;Z(1984,a|0);b=v[113382];v[113382]=0;a:{b:{if((b|0)!=1){b=v[a+24>>2];v[113382]=0;c=+la(1993,b|0);b=v[113382];v[113382]=0;if((b|0)!=1){break b}}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,3854,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();c=0}return+c}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function p3(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=jb-16|0;jb=e;a:{b:{c:{if(!d){b=ba(8)|0;v[113382]=0;c=Q(121,e|0,4474)|0;a=v[113382];v[113382]=0;if((a|0)==1){break c}nc(b,c);v[113382]=0;U(1978,b|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break a}a=P()|0;O()|0;yb(c);break b}ni(a,b,1);c=_w(a,c,d,0,0,0);A[a+16>>3]=+(c>>>0)/+(b|0)+A[a+16>>3];jb=e+16|0;return c|0}a=P()|0;O()|0;ca(b|0)}S(a|0)}L()}function m3(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=jb-16|0;jb=e;a:{b:{c:{if(!d){b=ba(8)|0;v[113382]=0;c=Q(121,e|0,4474)|0;a=v[113382];v[113382]=0;if((a|0)==1){break c}nc(b,c);v[113382]=0;U(1978,b|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break a}a=P()|0;O()|0;yb(c);break b}ni(a,b,1);c=Zw(a,c,d,0,0,0);A[a+16>>3]=+(c>>>0)/+(b|0)+A[a+16>>3];jb=e+16|0;return c|0}a=P()|0;O()|0;ca(b|0)}S(a|0)}L()}function fba(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;d=jb-896|0;jb=d;b=Qb(a,0,66);v[b+72>>2]=0;v[b+76>>2]=0;v[b+68>>2]=256;u[b+66>>1]=65535;v[b+80>>2]=0;v[b+84>>2]=0;t[b+88|0]=1;e=b+229984|0;c=b+608|0;a=c;while(1){a=vL(a)+896|0;if((e|0)!=(a|0)){continue}break}d=Qb(d,0,896);e=vL(d);a=c;c=((a+229376|0)-a|0)/896|0;if((c|0)>0){while(1){As(a,e);a=a+896|0;f=c>>>0>1;c=c-1|0;if(f){continue}break}}jb=d+896|0;return b|0}function FT(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=jb-48|0;jb=e;$A(e+24|0,c);v[113382]=0;U(194,e+36|0,e+8|0,d|0);c=v[113382];v[113382]=0;a:{b:{if((c|0)!=1){v[113382]=0;R(78,e|0,e+24|0);c=v[113382];v[113382]=0;if((c|0)==1){break b}v[113382]=0;U(72,a|0,b|0,e|0);a=v[113382];v[113382]=0;if((a|0)==1){break b}hf(e+24|0);jb=e+48|0;return}c=P()|0;O()|0;yb(e+24|0);break a}c=P()|0;O()|0;hf(e+24|0)}S(c|0);L()}
function Z$(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=jb-16|0;jb=e;a:{b:{if((a|0)!=(b|0)){g=v[113305];v[113305]=0;d=FF(a,e+12|0,d,ge());a=mb;f=v[113305];c:{if(f){if(v[e+12>>2]!=(b|0)){break c}if((f|0)==68){break b}break a}v[113305]=g;if(v[e+12>>2]==(b|0)){break a}}}v[c>>2]=4;d=0;a=0;break a}v[c>>2]=4;if(!!d&(a|0)>=0|(a|0)>0){d=-1;a=2147483647;break a}d=0;a=-2147483648}jb=e+16|0;mb=a;return d|0}function C3(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;b=jb-32|0;jb=b;v[b+24>>2]=e;v[b+28>>2]=f;a:{a=rs(a,Ll(b+16|0,c,d),b+24|0);if(a+1>>>0>=3){a=ba(8)|0;v[113382]=0;b=Q(121,b|0,4331)|0;c=v[113382];v[113382]=0;b:{if((c|0)!=1){nc(a,b);v[113382]=0;U(1978,a|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break a}c=P()|0;O()|0;yb(b);break b}c=P()|0;O()|0;ca(a|0)}S(c|0);L()}jb=b+32|0;return a|0}L()}function s_(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=jb-16|0;jb=c;d=a;v[a>>2]=0;v[a+4>>2]=0;v[c+12>>2]=0;v[113382]=0;wE(a+8|0,c+12|0,c+8|0);e=v[113382];v[113382]=0;a:{if((e|0)!=1){jb=c+16|0;break a}V(0)|0;O()|0;Ab();L()}b:{if(!b){break b}v[113382]=0;R(2435,a|0,b|0);c=v[113382];v[113382]=0;if((c|0)!=1){v[113382]=0;Tv(a,b);b=v[113382];v[113382]=0;if((b|0)!=1){break b}}a=P()|0;O()|0;TE(d);S(a|0);L()}return a|0}function YM(a,b){var c=0,d=0,e=0;c=jb-16|0;jb=c;d=a;v[a>>2]=0;v[a+4>>2]=0;v[113382]=0;v[c+12>>2]=0;W(1193,a+8|0,c+12|0,c+8|0)|0;e=v[113382];v[113382]=0;a:{if((e|0)!=1){jb=c+16|0;break a}V(0)|0;O()|0;Ab();L()}b:{if(!b){break b}v[113382]=0;R(1187,a|0,b|0);c=v[113382];v[113382]=0;if((c|0)!=1){v[113382]=0;R(1188,a|0,b|0);b=v[113382];v[113382]=0;if((b|0)!=1){break b}}a=P()|0;O()|0;SM(d);S(a|0);L()}return a}function we(a){var b=0,c=0,d=0;b=jb-16|0;jb=b;o(+a);d=j(1)|0;j(0)|0;d=d&2147483647;a:{if(d>>>0<=1072243195){c=1;if(d>>>0<1044816030){break a}c=zo(a,0);break a}c=a-a;if(d>>>0>=2146435072){break a}b:{switch(mG(a,b)&3){case 0:c=zo(A[b>>3],A[b+8>>3]);break a;case 1:c=-yo(A[b>>3],A[b+8>>3],1);break a;case 2:c=-zo(A[b>>3],A[b+8>>3]);break a;default:break b}}c=yo(A[b>>3],A[b+8>>3],1)}a=c;jb=b+16|0;return a}function j3(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=jb-16|0;jb=e;a:{b:{c:{if(!d){b=ba(8)|0;v[113382]=0;c=Q(121,e|0,4474)|0;a=v[113382];v[113382]=0;if((a|0)==1){break c}nc(b,c);v[113382]=0;U(1978,b|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break a}a=P()|0;O()|0;yb(c);break b}ni(a,b,2);c=TH(a,c,2,d);A[a+16>>3]=+(c>>>0)/+(b|0)+A[a+16>>3];jb=e+16|0;return c|0}a=P()|0;O()|0;ca(b|0)}S(a|0)}L()}function i3(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=jb-16|0;jb=e;a:{b:{c:{if(!d){b=ba(8)|0;v[113382]=0;c=Q(121,e|0,4474)|0;a=v[113382];v[113382]=0;if((a|0)==1){break c}nc(b,c);v[113382]=0;U(1978,b|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break a}a=P()|0;O()|0;yb(c);break b}ni(a,b,4);c=TH(a,c,4,d);A[a+16>>3]=+(c>>>0)/+(b|0)+A[a+16>>3];jb=e+16|0;return c|0}a=P()|0;O()|0;ca(b|0)}S(a|0)}L()}function h3(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=jb-16|0;jb=e;a:{b:{c:{if(!d){b=ba(8)|0;v[113382]=0;c=Q(121,e|0,4474)|0;a=v[113382];v[113382]=0;if((a|0)==1){break c}nc(b,c);v[113382]=0;U(1978,b|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break a}a=P()|0;O()|0;yb(c);break b}ni(a,b,2);c=SH(a,c,2,d);A[a+16>>3]=+(c>>>0)/+(b|0)+A[a+16>>3];jb=e+16|0;return c|0}a=P()|0;O()|0;ca(b|0)}S(a|0)}L()}function g3(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=jb-16|0;jb=e;a:{b:{c:{if(!d){b=ba(8)|0;v[113382]=0;c=Q(121,e|0,4474)|0;a=v[113382];v[113382]=0;if((a|0)==1){break c}nc(b,c);v[113382]=0;U(1978,b|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break a}a=P()|0;O()|0;yb(c);break b}ni(a,b,4);c=SH(a,c,4,d);A[a+16>>3]=+(c>>>0)/+(b|0)+A[a+16>>3];jb=e+16|0;return c|0}a=P()|0;O()|0;ca(b|0)}S(a|0)}L()}function P$(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;e=jb-16|0;jb=e;a:{b:{c:{if((a|0)!=(b|0)){g=v[113305];v[113305]=0;ge();d=jb-16|0;jb=d;dw(d,a,e+12|0,1);f=sw(v[d>>2],v[d+4>>2],v[d+8>>2],v[d+12>>2]);jb=d+16|0;a=v[113305];if(!a){break c}if(v[e+12>>2]!=(b|0)){break b}h=f;if((a|0)!=68){break a}break b}v[c>>2]=4;break a}v[113305]=g;if(v[e+12>>2]==(b|0)){break a}}v[c>>2]=4;f=h}jb=e+16|0;return+f}function zG(a,b){var c=0,d=0,e=0;if(!w[b+21|0]){cc(a,21);return-1}if(v[a+1396>>2]<=9){ek(a)}c=v[a+1392>>2];e=u[(((c&1023)<<1)+b|0)+36>>1];a:{if((e|0)>=0){d=c;c=w[e+v[b+8>>2]|0];v[a+1392>>2]=d>>>c;c=v[a+1396>>2]-c|0;d=(c|0)<0;v[a+1396>>2]=d?0:c;c=d?-1:e;break a}c=ml(a,b)}if(!((c|0)>=v[b+2092>>2]?w[b+23|0]:0)){if(!(!(v[a+1384>>2]?w[a+1376|0]:1)|(c|0)>=0)){cc(a,21)}return c}ia(3778,9203,1793,2236);L()}function gK(a,b){var c=0,d=0,e=0,f=0,g=0,h=0;if((a|0)!=(b|0)){c=jb-16|0;jb=c;d=v[b>>2];f=v[b+4>>2];e=rt(d,f);a:{if(e>>>0<=nd(a)>>>0){if(Kb(a)>>>0<e>>>0){v[c+12>>2]=d;IQ(c+12|0,Kb(a));kf(d,v[c+12>>2],v[a>>2]);Cp(a,v[c+12>>2],f,e-Kb(a)|0);break a}aL(a,kf(d,f,v[a>>2]));break a}b=a;if(v[a>>2]){Os(b);Se(zb(b),v[b>>2],nd(b));g=zb(b),h=0,v[g>>2]=h;v[b>>2]=0;v[b+4>>2]=0}qu(a,ye(a,e));Cp(a,d,f,e)}jb=c+16|0}}function SB(a){var b=0,c=0,d=0,e=0,f=0;a:{b:{if((w[a|0]|w[a+1|0]<<8)!=26217){if((w[a|0]|w[a+1|0]<<8)!=20042){break a}if(w[a+110|0]<=64){break b}break a}if(w[a+110|0]>64){break a}}if(t[a+112|0]<0|w[a+111|0]>128){break a}while(1){e=0;d=a+c|0;b=t[d+113|0];f=(b|0)>=0;if(!f&(b&255)>>>0<254){break a}b=w[d+241|0];if(!b&f|b>>>0>15|w[d+369|0]>=64){break a}e=1;c=c+1|0;if((c|0)!=128){continue}break}}return e}function qL(){var a=0,b=0;a=jb-240|0;jb=a;a:{b:{if(t[80344]&1){break b}if(!vd(80344)){break b}v[113382]=0;da(102)|0;b=v[113382];v[113382]=0;if((b|0)==1){break a}v[113382]=0;R(103,a+120|0,80192);b=v[113382];v[113382]=0;if((b|0)==1){break a}v[113382]=0;Q(104,80224,lc(a,a+120|0,120)|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break a}ud(80344)}jb=a+240|0;return 80224}a=P()|0;O()|0;ne(80344);S(a|0);L()}function hs(a){var b=0,c=0,d=0;b=w[a+4266|0];z[a+4236>>2]=C(b>>>0)*C(.00390625);v[a+4228>>2]=(B(v[a+4232>>2],w[a+4264|0])+250>>>0)/500;z[a+4240>>2]=C(256-b|0)*C(.00390625);c=w[a+4267|0];b=w[a+4265|0];z[a+4244>>2]=C(B(c,b)|0)*C(152587890625e-16);d=c|-256;z[a+4256>>2]=C(B(d,b|-256)|0)*C(152587890625e-16);z[a+4252>>2]=C(B(b,d)|0)*C(152587890625e-16);z[a+4248>>2]=C(B(256-b|0,c)|0)*C(152587890625e-16)}function Vy(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=jb-32|0;jb=f;v[f+8>>2]=c;g=f,h=$e(b),v[g+28>>2]=h;c=f+8|0;Ze(c,b,v[Lb(c,f+28|0)>>2]);v[113382]=0;b=T(426,c|0)|0;c=v[113382];v[113382]=0;a:{if((c|0)==1){break a}c=v[f+8>>2];v[113382]=0;a=ea(395,a|0,b|0,c|0,d|0,e|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break a}Cc(f+8|0);jb=f+32|0;return a|0}a=P()|0;O()|0;Cc(f+8|0);S(a|0);L()}function oP(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=jb-16|0;jb=d;e=Pp(a);f=d,g=ac(b),v[f+8>>2]=g;f=d,g=bc(b),v[f>>2]=g;a:{if(Jb(d+8|0,d)){while(1){a=v[d+8>>2];if((w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24))==(c|0)){a=zb(a);v[113382]=0;R(563,e|0,a|0);a=v[113382];v[113382]=0;if((a|0)==1){break a}}a=d+8|0;Kk(a);if(Jb(a,d)){continue}break}}jb=d+16|0;return}a=P()|0;O()|0;cd(e);S(a|0);L()}function mq(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0;c=jb-16|0;jb=c;d=v[a+4>>2];e=v[a>>2];t[c+12|0]=0;f=e;d=d+e|0;e=c+12|0;Yr(f,d,e);d=Tb(b);g=Tb(b);h=c,i=Db(b),v[h+12>>2]=i;v[c+8>>2]=v[a+4>>2]-1;f=d;d=c+8|0;kf(f,v[Lb(e,d)>>2]+g|0,v[a>>2]);g=v[a>>2];h=c,i=Db(b),v[h+12>>2]=i;v[c+8>>2]=v[a+4>>2]-1;b=v[Lb(e,d)>>2];e=v[a+4>>2];d=v[a>>2];t[c+7|0]=0;Yr(b+g|0,d+e|0,c+7|0);jb=c+16|0;return a|0}function RP(a){var b=0,c=0,d=0;a:{if((w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24))!=808604749){break a}b=a+8|0;c=w[b+1|0]<<8;if((w[b|0]|c)>>>0<512|(c|w[b|0])>>>0>767){break a}b=a+112|0;c=w[b+1|0]<<8;if(!(w[b|0]|c)|(c|w[b|0])>>>0>64){break a}b=a+106|0;if((w[b|0]|w[b+1|0]<<8)>>>0>256){break a}b=a+122|0;if((w[b|0]|w[b+1|0]<<8)>>>0>255){break a}a=a+124|0;d=(w[a|0]|w[a+1|0]<<8)>>>0<4e3}return d}function Qaa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;e=jb-16|0;jb=e;v[e+12>>2]=b;a:{if(xf(a)>>>0>=b>>>0){f=e,g=wc(a),v[f+8>>2]=g;Qh(v[a>>2],v[Lb(e+12|0,e+8|0)>>2],c);b=v[e+12>>2];d=v[e+8>>2];if(b>>>0>d>>>0){Sp(a,b-d|0,c);break a}Mu(a,b+v[a>>2]|0);break a}d=a;if(v[d>>2]){wc(d);nC(d);wp(d);cg(zb(d),v[d>>2],xf(d));f=zb(d),g=0,v[f>>2]=g;v[d>>2]=0;v[d+4>>2]=0}Lp(a,Ki(a,b));Sp(a,b,c)}jb=e+16|0}function gH(a,b){a=a|0;b=+b;var c=0,d=0;c=jb-16|0;jb=c;a:{b:{c:{if(!(!(b<=0)&b<=4)){d=ba(8)|0;v[113382]=0;c=Q(121,c|0,4086)|0;a=v[113382];v[113382]=0;if((a|0)==1){break c}nc(d,c);v[113382]=0;U(1978,d|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break a}a=P()|0;O()|0;yb(c);break b}d=zk(65536/b);a=a+32|0;v[v[a>>2]+480244>>2]=d;Wo(v[a>>2]);jb=c+16|0;return}a=P()|0;O()|0;ca(d|0)}S(a|0)}L()}function eH(a,b){a=a|0;b=+b;var c=0,d=0;c=jb-16|0;jb=c;a:{b:{c:{if(!(!(b<=0)&b<=4)){d=ba(8)|0;v[113382]=0;c=Q(121,c|0,4107)|0;a=v[113382];v[113382]=0;if((a|0)==1){break c}nc(d,c);v[113382]=0;U(1978,d|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break a}a=P()|0;O()|0;yb(c);break b}d=zk(b*65536);a=a+32|0;v[v[a>>2]+480240>>2]=d;Wo(v[a>>2]);jb=c+16|0;return}a=P()|0;O()|0;ca(d|0)}S(a|0)}L()}function Kx(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;d=F(c,.999);c=d*32768;h=d*3.141592653589793;i=ps(b);while(1){j=a;k=c;e=((f<<12^-1)&28672)+(f>>>3|0)|0;if((e|0)!=16384){g=+(e-16384|0);d=g*.000244140625;g=ps(K(g*-152587890625e-16*d+1)*b);d=h*d;d=g*gi(d)/(d*i)}else{d=1}d=H(k*d+.5);a:{if(D(d)<2147483648){e=~~d;break a}e=-2147483648}u[j>>1]=e;a=a+2|0;f=f+1|0;if((f|0)!=32768){continue}break}}function gi(a){var b=0,c=0;b=jb-16|0;jb=b;o(+a);c=j(1)|0;j(0)|0;c=c&2147483647;a:{if(c>>>0<=1072243195){if(c>>>0<1045430272){break a}a=yo(a,0,0);break a}if(c>>>0>=2146435072){a=a-a;break a}b:{switch(mG(a,b)&3){case 0:a=yo(A[b>>3],A[b+8>>3],1);break a;case 1:a=zo(A[b>>3],A[b+8>>3]);break a;case 2:a=-yo(A[b>>3],A[b+8>>3],1);break a;default:break b}}a=-zo(A[b>>3],A[b+8>>3])}jb=b+16|0;return a}function yX(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=a+32|0;Xi(c,b);v[a+44>>2]=0;b=v[a+48>>2];if(b&8){d=a,e=Tb(c)+Db(c)|0,v[d+44>>2]=e;sm(a,Tb(c),Tb(c),v[a+44>>2]);b=v[a+48>>2]}a:{if(!(b&16)){break a}b=Db(c);d=a,e=b+Tb(c)|0,v[d+44>>2]=e;fr(c,Fc(c));Iv(a,Tb(c),Tb(c)+Db(c)|0);if(!(w[a+48|0]&3)){break a}while(1){if((b|0)<0){$q(a,2147483647);b=b-2147483647|0;continue}break}if(!b){break a}$q(a,b)}}function _5(a){a=a|0;var b=0;v[113382]=0;Z(1984,a|0);b=v[113382];v[113382]=0;if((b|0)!=1){b=v[a+24>>2];if(b){Wb(Tr(b))}v[a+24>>2]=0;b=v[a+20>>2];if(b){Wb(b);v[a+20>>2]=0}Wb(a);return}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,1585,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)!=1){$();return}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function Lz(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;WQ(a,b);e=b+8|0;e=w[e|0]|w[e+1|0]<<8|(w[e+2|0]<<16|w[e+3|0]<<24);Nc(a,(e<<24|e<<8&16711680|(e>>>8&65280|e>>>24))+504|0);VQ(a,d);a:{b=b+32|0;if(!(w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24))){break a}b=w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24);if(!Nc(a,b<<24|b<<8&16711680|(b>>>8&65280|b>>>24))){break a}xn(a,c);return}Qb(c,0,80)}function aG(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=jb-32|0;jb=d;c=Ub(d,c);v[113382]=0;U(2293,d+16|0,b|0,c|0);e=v[113382];v[113382]=0;a:{b:{if((e|0)!=1){v[113382]=0;Q(2294,a|0,d+16|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break b}yb(d+16|0);yb(c);v[a>>2]=54416;c=v[b+4>>2];v[a+8>>2]=v[b>>2];v[a+12>>2]=c;jb=d+32|0;return a|0}a=P()|0;O()|0;break a}a=P()|0;O()|0;yb(d+16|0)}yb(c);S(a|0);L()}function r7(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;b=qi(a,b,c,d);v[a+4224>>2]=1049951732;c=a+4216|0;v[c>>2]=1065353216;v[c+4>>2]=1049951732;v[a+4208>>2]=1060320051;v[a+4212>>2]=1041865114;v[a>>2]=75828;v[113382]=0;W(1609,a+44|0,2,2)|0;c=v[113382];v[113382]=0;a:{if((c|0)==1){break a}v[113382]=0;Z(1610,b|0);c=v[113382];v[113382]=0;if((c|0)==1){break a}return a|0}a=P()|0;O()|0;rf(b);S(a|0);L()}function UG(a,b){a=a|0;b=b|0;var c=0;c=jb-16|0;jb=c;a:{b:{c:{if(b>>>0>=256){a=ba(8)|0;v[113382]=0;c=Q(121,c|0,6794)|0;b=v[113382];v[113382]=0;if((b|0)==1){break c}nc(a,c);v[113382]=0;U(1978,a|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break a}b=P()|0;O()|0;yb(c);break b}a=v[a+32>>2]+B(b,896)|0;v[a+1075e3>>2]=0;v[a+1075060>>2]=0;jb=c+16|0;return}b=P()|0;O()|0;ca(a|0)}S(b|0)}L()}function wda(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;e=jb-16|0;jb=e;d=e;v[d>>2]=v[a+8>>2];f=v[a+8>>2];v[d+8>>2]=a+8;v[d+4>>2]=f+(b<<5);a:{if(v[d>>2]!=v[d+4>>2]){while(1){f=v[a+16>>2];b=v[d>>2];v[113382]=0;U(1141,f|0,b|0,c|0);b=v[113382];v[113382]=0;if((b|0)==1){break a}b=v[d>>2]+32|0;v[d>>2]=b;if((b|0)!=v[d+4>>2]){continue}break}}yc(d);jb=e+16|0;return}a=P()|0;O()|0;yc(d);S(a|0);L()}function s9(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;e=jb-16|0;jb=e;d=e;v[d>>2]=v[a+8>>2];f=v[a+8>>2];v[d+8>>2]=a+8;v[d+4>>2]=f+B(b,52);a:{if(v[d>>2]!=v[d+4>>2]){while(1){f=v[a+16>>2];b=v[d>>2];v[113382]=0;U(1548,f|0,b|0,c|0);b=v[113382];v[113382]=0;if((b|0)==1){break a}b=v[d>>2]+52|0;v[d>>2]=b;if((b|0)!=v[d+4>>2]){continue}break}}yc(d);jb=e+16|0;return}a=P()|0;O()|0;yc(d);S(a|0);L()}function lx(a){var b=C(0),c=C(0),d=0,e=C(0),f=0;b=C(Ue(v[a+16>>2])>>>0);c=C(C(nb[v[v[a>>2]+200>>2]](a))*b);d=a,e=C(C(c*C(2.0480000972747803))*C(nb[v[v[a>>2]+192>>2]](a))),z[d+4248>>2]=e;d=a,f=Lh(C(C(c*C(4.0960001945495605))+C(8192))),v[d+4256>>2]=f;c=C(nb[v[v[a>>2]+204>>2]](a));z[a+4252>>2]=c;b=C(c/b);if(!(nb[v[v[a>>2]+188>>2]](a)|0)){b=qG(C(b*C(3.1415927410125732)))}z[a+4244>>2]=b+b}function dca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=jb-16|0;jb=e;v[e+12>>2]=c>>>3;v[e+8>>2]=v[a>>2];d=v[Lb(e+12|0,e+8|0)>>2];b=Eb(b);if(d){a=v[a+20>>2];c=d;while(1){Eb(w[b|0]);Eb(w[b+1|0]);f=a,g=Eb(w[b+2|0])|Eb(w[b+3|0])<<8,u[f>>1]=g;Eb(w[b+4|0]);Eb(w[b+5|0]);f=a,g=Eb(w[b+6|0])|Eb(w[b+7|0])<<8,u[f+2>>1]=g;a=a+4|0;b=b+8|0;c=c-1|0;if(c){continue}break}}jb=e+16|0;return d<<3}function cca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=jb-16|0;jb=e;v[e+12>>2]=c>>>3;v[e+8>>2]=v[a>>2];d=v[Lb(e+12|0,e+8|0)>>2];b=Eb(b);if(d){a=v[a+20>>2];c=d;while(1){Eb(w[b+3|0]);Eb(w[b+2|0]);f=a,g=Eb(w[b+1|0])|Eb(w[b|0])<<8,u[f>>1]=g;Eb(w[b+7|0]);Eb(w[b+6|0]);f=a,g=Eb(w[b+5|0])|Eb(w[b+4|0])<<8,u[f+2>>1]=g;a=a+4|0;b=b+8|0;c=c-1|0;if(c){continue}break}}jb=e+16|0;return d<<3}function G8(a){a=a|0;var b=0,c=0;b=v[a+20>>2];v[b+148>>2]=-1;v[113382]=0;R(469,b+4|0,8);b=v[113382];v[113382]=0;if((b|0)!=1){c=v[v[a+20>>2]+4>>2];b=v[a+4264>>2];a=v[a+4260>>2];t[c|0]=a;t[c+1|0]=a>>>8;t[c+2|0]=a>>>16;t[c+3|0]=a>>>24;t[c+4|0]=b;t[c+5|0]=b>>>8;t[c+6|0]=b>>>16;t[c+7|0]=b>>>24;return}b=V(66740)|0;if((O()|0)==(ga(66740)|0)){_(b|0)|0;Js(v[a+20>>2]+4|0);$();return}S(b|0);L()}function cG(a,b){var c=0,d=0;b=!v[a+24>>2]|b;v[a+16>>2]=b;if(b&v[a+20>>2]){c=jb-16|0;jb=c;b=ba(16)|0;a=jb-16|0;jb=a;a:{if(t[453536]&1){break a}if(!vd(453536)){break a}ud(453536)}$c(a+8|0,1,79872);d=v[a+12>>2];c=c+8|0;v[c>>2]=v[a+8>>2];v[c+4>>2]=d;jb=a+16|0;v[113382]=0;W(2277,b|0,5117,c|0)|0;a=v[113382];v[113382]=0;if((a|0)!=1){ha(b|0,52080,2278);L()}a=P()|0;O()|0;ca(b|0);S(a|0);L()}}function U5(a,b){a=a|0;b=b|0;var c=0;v[113382]=0;Z(1984,a|0);c=v[113382];v[113382]=0;a:{b:{if((c|0)!=1){v[a+16>>2]=b;b=v[a+20>>2];if(!b){break b}Wb(b);v[a+20>>2]=0;return}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,2146,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$()}return}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function GY(){var a=0;a:{if(t[454360]&1){break a}if(!vd(454360)){break a}a=454192;while(1){a=sf(a)+12|0;if((a|0)!=454360){continue}break}ud(454360)}Wc(454192,63908);Wc(454204,63936);Wc(454216,63964);Wc(454228,63996);Wc(454240,64036);Wc(454252,64072);Wc(454264,64100);Wc(454276,64136);Wc(454288,64152);Wc(454300,64168);Wc(454312,64184);Wc(454324,64200);Wc(454336,64216);Wc(454348,64232)}function Xja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;e=jb-16|0;jb=e;d=e;v[d>>2]=v[a+8>>2];f=v[a+8>>2];v[d+8>>2]=a+8;v[d+4>>2]=f+B(b,6);a:{if(v[d>>2]!=v[d+4>>2]){while(1){f=v[a+16>>2];b=v[d>>2];v[113382]=0;U(670,f|0,b|0,c|0);b=v[113382];v[113382]=0;if((b|0)==1){break a}b=v[d>>2]+6|0;v[d>>2]=b;if((b|0)!=v[d+4>>2]){continue}break}}yc(d);jb=e+16|0;return}a=P()|0;O()|0;yc(d);S(a|0);L()}function RX(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=jb-16|0;jb=d;while(1){a:{if((c|0)<=(e|0)){break a}f=v[a+24>>2];g=v[a+28>>2];if(f>>>0>=g>>>0){if((nb[v[v[a>>2]+52>>2]](a,v[b>>2])|0)==-1){break a}e=e+1|0;b=b+4|0}else{v[d+12>>2]=g-f>>2;v[d+8>>2]=c-e;f=v[Zd(d+12|0,d+8|0)>>2];yh(v[a+24>>2],b,f);g=f<<2;v[a+24>>2]=g+v[a+24>>2];e=e+f|0;b=b+g|0}continue}break}jb=d+16|0;return e|0}function qF(a,b,c){var d=0,e=0,f=0,g=0,h=0;h=jb-16|0;jb=h;e=jb-16|0;jb=e;d=a;a:{if(b>>>0<=1073741807){b:{if(b>>>0<=1){Ce(d,b);f=d;break b}g=al(b)+1|0;f=Qj(d,g);Oe(d,f);Gf(d,g);ae(d,b)}g=f;c:{d:{d=b;if(d){v[113382]=0;PD(g,c,d);c=v[113382];v[113382]=0;if((c|0)==1){break d}}break c}V(0)|0;O()|0;Ab();L()}v[e+12>>2]=0;Te((b<<2)+f|0,e+12|0);jb=e+16|0;break a}If();L()}jb=h+16|0;return a}function cda(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=jb-16|0;jb=d;v[a>>2]=0;v[a+4>>2]=0;v[113382]=0;v[d+12>>2]=0;W(1197,a+8|0,d+12|0,d+8|0)|0;e=v[113382];v[113382]=0;a:{if((e|0)!=1){jb=d+16|0;break a}V(0)|0;O()|0;Ab();L()}d=en(a+12|0);t[a+30|0]=c;u[a+28>>1]=0;v[a+24>>2]=b;v[113382]=0;R(1196,a|0,1);b=v[113382];v[113382]=0;if((b|0)!=1){return a|0}b=P()|0;O()|0;ze(d);RM(a);S(b|0);L()}function Wy(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=jb-32|0;jb=e;v[e+8>>2]=c;f=e,g=$e(b),v[f+28>>2]=g;c=e+8|0;Ze(c,b,v[Lb(c,e+28|0)>>2]);v[113382]=0;b=T(426,c|0)|0;c=v[113382];v[113382]=0;a:{if((c|0)==1){break a}c=v[e+8>>2];v[113382]=0;aa(1026,a|0,b|0,c|0,d|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break a}Cc(e+8|0);jb=e+32|0;return 1}a=P()|0;O()|0;Cc(e+8|0);S(a|0);L()}function S8(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=jb-16|0;jb=d;c=Pe(64);v[113382]=0;e=T(1395,c|0)|0;f=v[113382];v[113382]=0;a:{if((f|0)!=1){c=Zx(d,e);e=v[c>>2];v[113382]=0;a=W(1604,e|0,a|0,b|0)|0;b=v[113382];v[113382]=0;b:{c:{if((b|0)!=1){if((a|0)==1){break c}Yx(d+8|0);break b}a=P()|0;O()|0;gg(c);break a}Jp(d+8|0,c)}gg(c);jb=d+16|0;return v[d+8>>2]}a=P()|0;O()|0;Wb(c)}S(a|0);L()}function PM(a,b,c){var d=0,e=0,f=0,g=0;d=jb-32|0;jb=d;v[a+4>>2]=0;a:{if(b){b:{if(ht(a)>>>0>=b>>>0){v[a+4>>2]=b;break b}zb(a);e=kz(d+16|0);v[113382]=0;f=Q(894,a|0,b|0)|0;g=v[113382];v[113382]=0;if((g|0)==1){break a}v[113382]=0;R(895,e|0,f|0);f=v[113382];v[113382]=0;if((f|0)==1){break a}v[e+4>>2]=b;jz(a,e);ee(e)}uj(d,a);jq(d,b,w[c|0])}jb=d+32|0;return}a=P()|0;O()|0;ee(e);S(a|0);L()}function Lla(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=jb-16|0;jb=c;d=c+8|0;sB(d,b);e=Hb(d);d=mc(a,$b(c,d));if((e|0)==(d|0)){_b(a,Hb(c+8|0))}jb=c+16|0;a=(d|0)==(e|0);if(!a){c=jb-16|0;jb=c;t[b|0]=0;t[b+1|0]=0;t[b+2|0]=0;t[b+3|0]=0;t[b+4|0]=0;t[b+5|0]=0;t[b+6|0]=0;t[b+7|0]=0;t[b+8|0]=0;t[b+9|0]=0;t[b+10|0]=0;t[b+11|0]=0;t[b+12|0]=0;t[b+13|0]=0;t[b+14|0]=0;t[b+15|0]=0;jb=c+16|0}return a|0}function xha(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=jb-16|0;jb=c;kP(a,c+11|0);if((w[c+11|0]|w[c+12|0]<<8|(w[c+13|0]<<16|w[c+14|0]<<24))==1414807888){kP(a,c+11|0);t[b|0]=1;a=0}else{a=1}b=jb-16|0;jb=b;a:{b:{a=(c+11|0)+a|0;if(a){a=Ub(b,a);v[113382]=0;d=T(939,a|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break b}yb(a)}jb=b+16|0;break a}b=P()|0;O()|0;yb(a);S(b|0);L()}jb=c+16|0;return d|0}function g1(a,b,c){a=a|0;b=b|0;c=c|0;a=a^-1;if(c>>>0>3){while(1){a=v[((w[b|0]^a&255)<<2)+37952>>2]^a>>>8;a=a>>>8^v[((w[b+1|0]^a&255)<<2)+37952>>2];a=a>>>8^v[((w[b+2|0]^a&255)<<2)+37952>>2];a=a>>>8^v[((w[b+3|0]^a&255)<<2)+37952>>2];b=b+4|0;c=c-4|0;if(c>>>0>3){continue}break}}if(c){while(1){a=v[((w[b|0]^a&255)<<2)+37952>>2]^a>>>8;b=b+1|0;c=c-1|0;if(c){continue}break}}return a^-1}function Bx(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=jb-16|0;jb=f;a:{while(1){h=g&255;if(Dx(b,c,h>>>0>1)){t[f+15|0]=0;t[f+14|0]=0;Oy(a,f+15|0,f+14|0);break a}Rg(b,d);Rg(c,e);g=g+1|0;if(h>>>0<3){continue}break}if(Vm(w[b|0])>>>0>Vm(w[d|0])>>>0){Rg(b,d);Rg(c,e)}t[f+11|0]=w[b|0];Oy(f+12|0,f+11|0,c);t[b|0]=0;t[c|0]=0;b=x[f+12>>1];t[a|0]=b;t[a+1|0]=b>>>8}jb=f+16|0}function yS(a){var b=0,c=0,d=0;a:{if((w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24))!=777268804){break a}b=a+4|0;c=w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24);if((c<<24|c<<8&16711680|(c>>>8&65280|c>>>24))>>>0<14){break a}b=w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24);if((b<<24|b<<8&16711680|(b>>>8&65280|b>>>24))>>>0>256){break a}a=a+8|0;d=!(w[a|0]|w[a+1|0]<<8)}return d}function rF(a,b,c,d,e){var f=0,g=0,h=0,i=0;if(b>>>0>=d>>>0){if(!e){return d}d=a+d|0;h=a+b|0;b=h;f=jb-16|0;jb=f;e=(c+e|0)-c|0;a:{if(!e){b=d;break a}g=b-d|0;if((g|0)<(e|0)){break a}t[f+15|0]=w[c|0];i=1-e|0;while(1){d=Xn(d,g+i|0,f+15|0);if(!d){break a}if(!Sm(d,c,e)){b=d;break a}d=d+1|0;g=b-d|0;if((g|0)>=(e|0)){continue}break}}jb=f+16|0;a=(b|0)==(h|0)?-1:b-a|0}else{a=-1}return a}function T5(a){a=a|0;var b=0;v[113382]=0;Z(1984,a|0);b=v[113382];v[113382]=0;a:{b:{if((b|0)!=1){v[a+16>>2]=0;b=v[a+20>>2];if(!b){break b}Wb(b);v[a+20>>2]=0;return}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,5090,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$()}return}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function s8(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=jb-16|0;jb=d;c=d;v[c>>2]=v[a+8>>2];e=v[a+8>>2];v[c+8>>2]=a+8;v[c+4>>2]=e+(b<<11);a:{if(v[c>>2]!=v[c+4>>2]){while(1){e=v[a+16>>2];b=v[c>>2];v[113382]=0;R(1620,e|0,b|0);b=v[113382];v[113382]=0;if((b|0)==1){break a}b=v[c>>2]+2048|0;v[c>>2]=b;if((b|0)!=v[c+4>>2]){continue}break}}yc(c);jb=d+16|0;return}a=P()|0;O()|0;yc(c);S(a|0);L()}function R9(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;d=jb-32|0;jb=d;f=-1;e=jb-16|0;jb=e;c=e+8|0;g=d+8|0;pK(c,g);h=Hb(c);c=hd(a,$b(e,c));if((h|0)==(c|0)){Tc(a,Hb(e+8|0))}jb=e+16|0;a=(c|0)==(h|0);if(!a){qK(g)}a:{if(!a){break a}f=0;if(!uK(d+8|0)){break a}if(b){a=d+16|0;if(v[b>>2]!=(w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24))|v[b+4>>2]){break a}}f=1}jb=d+32|0;return f|0}function $la(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=jb-32|0;jb=d;v[d+24>>2]=b;a:{b=$l(d+8|0,a+8|0,xA(b,c));if(v[b>>2]!=v[b+4>>2]){while(1){c=v[a+16>>2];e=v[b>>2];f=v[d+24>>2];v[113382]=0;U(486,c|0,e|0,f|0);c=v[113382];v[113382]=0;if((c|0)==1){break a}v[b>>2]=v[b>>2]+2;re(d+24|0);if(v[b>>2]!=v[b+4>>2]){continue}break}}yc(b);jb=d+32|0;return}a=P()|0;O()|0;yc(b);S(a|0);L()}function cH(a,b){a=a|0;b=+b;var c=0,d=0;c=jb-16|0;jb=c;a:{b:{c:{if(!(!(b<0)&b<=1)){d=ba(8)|0;v[113382]=0;c=Q(121,c|0,7750)|0;a=v[113382];v[113382]=0;if((a|0)==1){break c}nc(d,c);v[113382]=0;U(1978,d|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break a}a=P()|0;O()|0;yb(c);break b}d=zk(b*256);v[v[a+32>>2]+1074444>>2]=d;jb=c+16|0;return}a=P()|0;O()|0;ca(d|0)}S(a|0)}L()}function _ja(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=jb-16|0;jb=d;c=d;v[c>>2]=v[a+8>>2];e=v[a+8>>2];v[c+8>>2]=a+8;v[c+4>>2]=e+B(b,48);a:{if(v[c>>2]!=v[c+4>>2]){while(1){e=v[a+16>>2];b=v[c>>2];v[113382]=0;R(702,e|0,b|0);b=v[113382];v[113382]=0;if((b|0)==1){break a}b=v[c>>2]+48|0;v[c>>2]=b;if((b|0)!=v[c+4>>2]){continue}break}}yc(c);jb=d+16|0;return}a=P()|0;O()|0;yc(c);S(a|0);L()}function V5(a){a=a|0;var b=0;v[113382]=0;Z(1984,a|0);b=v[113382];v[113382]=0;a:{b:{if((b|0)!=1){a=v[a+20>>2];if(!a){break b}return Ud(a)|0}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,8163,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();return 0}return Ud(17540)|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function Aja(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=jb-16|0;jb=d;c=d;v[c>>2]=v[a+8>>2];e=v[a+8>>2];v[c+8>>2]=a+8;v[c+4>>2]=e+B(b,33);a:{if(v[c>>2]!=v[c+4>>2]){while(1){e=v[a+16>>2];b=v[c>>2];v[113382]=0;R(728,e|0,b|0);b=v[113382];v[113382]=0;if((b|0)==1){break a}b=v[c>>2]+33|0;v[c>>2]=b;if((b|0)!=v[c+4>>2]){continue}break}}yc(c);jb=d+16|0;return}a=P()|0;O()|0;yc(c);S(a|0);L()}function m8(a,b){a=a|0;b=b|0;var c=C(0);a:{switch(b|0){case 0:return C(z[a+4220>>2]);case 1:return C(z[a+4224>>2]);case 2:return C(z[a+4228>>2]);case 3:return C(w[a+4240|0]?C(1):C(0));case 4:return C(C(C(v[a+4232>>2])*C(.03125)));case 5:return C(w[a+4241|0]?C(1):C(0));case 6:return C(w[a+4242|0]?C(1):C(0));case 7:c=w[a+4244|0]?C(1):C(0);break;default:break a}}return C(c)}function _ha(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=jb-16|0;jb=d;c=d;v[c>>2]=v[a+8>>2];e=v[a+8>>2];v[c+8>>2]=a+8;v[c+4>>2]=e+(b<<3);a:{if(v[c>>2]!=v[c+4>>2]){while(1){e=v[a+16>>2];b=v[c>>2];v[113382]=0;R(888,e|0,b|0);b=v[113382];v[113382]=0;if((b|0)==1){break a}b=v[c>>2]+8|0;v[c>>2]=b;if((b|0)!=v[c+4>>2]){continue}break}}yc(c);jb=d+16|0;return}a=P()|0;O()|0;yc(c);S(a|0);L()}function my(a,b,c,d){a:{if(v[a+1074392>>2]!=(c|0)){break a}b:{if(d){c=B(b,896)+a|0;v[c+1075680>>2]=0;d=c+1074992|0;v[d>>2]=0;v[d+4>>2]=0;d=c+1075072|0;c=v[d>>2]|4096;v[d>>2]=c;break b}c=B(b,896)+a|0;v[c+1075672>>2]=0;c=v[c+1075072>>2]}d=B(b,896)+a|0;v[d+1075072>>2]=c|2097152;yl(a,b,255,0);if(!(w[d+1075073|0]&2)){break a}a=a+1304392|0;if(!qd(a)){break a}yi(v[a>>2],b,0)}}function JY(){var a=0;a:{if(t[454184]&1){break a}if(!vd(454184)){break a}a=454016;while(1){a=Xb(a)+12|0;if((a|0)!=454184){continue}break}ud(454184)}Kc(454016,1730);Kc(454028,1737);Kc(454040,1703);Kc(454052,1711);Kc(454064,1694);Kc(454076,1744);Kc(454088,1721);Kc(454100,5723);Kc(454112,6057);Kc(454124,7328);Kc(454136,8856);Kc(454148,1989);Kc(454160,6844);Kc(454172,2916)}function lG(a,b){a:{if((b|0)>=128){a=C(a*C(1.7014118346046923e38));if(b>>>0<255){b=b-127|0;break a}a=C(a*C(1.7014118346046923e38));b=(b>>>0<381?b:381)-254|0;break a}if((b|0)>-127){break a}a=C(a*C(1.1754943508222875e-38));if(b>>>0>4294967043){b=b+126|0;break a}a=C(a*C(1.1754943508222875e-38));b=(b>>>0>4294966918?b:-378)+252|0}return C(a*(l(2,(b<<23)+1065353216|0),q()))}function Vja(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=jb-16|0;jb=d;c=-1;a:{if(!Ij(a,d+8|0)){break a}c=d+8|0;b:{if((w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24))!=(Ej(5152)|0)){break b}c=c+4|0;if((w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24))>>>0>259){break b}e=(w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24))>>>0>255}c=0;if(!e){break a}c=gf(a,b,36,0)}jb=d+16|0;return c|0}function Jia(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=C(0),h=0,i=0,j=0,k=0;f=jb-16|0;jb=f;if(d){a=(e<<1)+a|0;e=0;c=c<<1;while(1){z[f+12>>2]=z[b>>2];Wd(f+12|0,C(-1));g=C(z[f+12>>2]*C(32768));z[f+12>>2]=g;i=a;g=de(g);a:{if(C(D(g))<C(2147483648)){h=~~g;break a}h=-2147483648}j=i,k=Rc(h),u[j>>1]=k;b=b+4|0;a=a+c|0;e=e+1|0;if((e|0)!=(d|0)){continue}break}}jb=f+16|0}function mp(a){var b=0,c=0,d=0,e=0,f=0,g=0,h=0;c=jb-16|0;jb=c;e=ac(a);f=bc(a);b=jb-16|0;jb=b;v[b>>2]=f;v[b+8>>2]=e;if(Jb(b+8|0,b)){while(1){e=b+8|0;d=A[v[e>>2]>>3]+d;Fy(e);if(Jb(e,b)){continue}break}}jb=b+16|0;g=c,h=ac(a),v[g+8>>2]=h;g=c,h=bc(a),v[g>>2]=h;if(Jb(c+8|0,c)){d=-d;while(1){a=c+8|0;b=v[a>>2];d=A[b>>3]+d;A[b>>3]=d;Fy(a);if(Jb(a,c)){continue}break}}jb=c+16|0}function qI(a,b){a=a|0;b=b|0;var c=0,d=0;d=jb-16|0;jb=d;c=Pe(12);a=v[a>>2];b=v[b>>2];v[113382]=0;a=W(1970,c|0,a|0,b|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){b=jb-16|0;jb=b;v[113382]=0;v[b+12>>2]=a;a=d+8|0;W(1972,a|0,b+12|0,b+8|0)|0;c=v[113382];v[113382]=0;a:{if((c|0)!=1){jb=b+16|0;break a}V(0)|0;O()|0;Ab();L()}jb=d+16|0;return v[a>>2]}a=P()|0;O()|0;Wb(c);S(a|0);L()}function hca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=jb-16|0;jb=e;v[e+12>>2]=(c>>>0)/6;v[e+8>>2]=v[a>>2];d=v[Lb(e+12|0,e+8|0)>>2];b=Eb(b);if(d){a=v[a+20>>2];c=d;while(1){Eb(w[b|0]);f=a,g=Eb(w[b+1|0])|Eb(w[b+2|0])<<8,u[f>>1]=g;Eb(w[b+3|0]);f=a,g=Eb(w[b+4|0])|Eb(w[b+5|0])<<8,u[f+2>>1]=g;a=a+4|0;b=b+6|0;c=c-1|0;if(c){continue}break}}jb=e+16|0;return B(d,6)|0}function gca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=jb-16|0;jb=e;v[e+12>>2]=(c>>>0)/6;v[e+8>>2]=v[a>>2];d=v[Lb(e+12|0,e+8|0)>>2];b=Eb(b);if(d){a=v[a+20>>2];c=d;while(1){Eb(w[b+2|0]);f=a,g=Eb(w[b+1|0])|Eb(w[b|0])<<8,u[f>>1]=g;Eb(w[b+5|0]);f=a,g=Eb(w[b+4|0])|Eb(w[b+3|0])<<8,u[f+2>>1]=g;a=a+4|0;b=b+6|0;c=c-1|0;if(c){continue}break}}jb=e+16|0;return B(d,6)|0}function fk(a,b,c){var d=0,e=0,f=0,g=0,h=0;e=jb-16|0;jb=e;v[e+8>>2]=c;a:{if((a|0)==(b|0)){break a}while(1){c=jb-32|0;jb=c;f=qc(c+24|0,v[a>>2]);d=v[e+8>>2];g=v[d+4>>2];d=v[d>>2];v[c+16>>2]=d;v[c+20>>2]=g;h=v[f+4>>2];v[c+8>>2]=v[f>>2];v[c+12>>2]=h;v[c>>2]=d;v[c+4>>2]=g;f=Hc(c+8|0,c);jb=c+32|0;if(f){break a}a=a+8|0;if((b|0)!=(a|0)){continue}break}a=b}jb=e+16|0;return a}function NJ(a,b){var c=0,d=0,e=0,f=C(0),g=0,h=C(0);c=jb-16|0;jb=c;e=0;a:{if(!Jf(v[v[a>>2]-12>>2]+a|0)){break a}v[c+12>>2]=0;Fi(a,c+12|0);d=v[c+12>>2];e=0;if(d>>>0>65535){break a}ql(b,d);if(v[c+12>>2]){d=0;while(1){v[c+8>>2]=0;No(a,c+8|0);f=z[c+8>>2];g=Pb(b,d),h=f,z[g>>2]=h;d=d+1|0;if(d>>>0<y[c+12>>2]){continue}break}}e=Jf(v[v[a>>2]-12>>2]+a|0)}d=e;jb=c+16|0;return d}function MJ(a,b){var c=0,d=0,e=0,f=C(0),g=0,h=C(0);c=jb-16|0;jb=c;e=0;a:{if(!Jf(v[v[a>>2]-12>>2]+a|0)){break a}u[c+14>>1]=0;wf(a,c+14|0);d=x[c+14>>1];e=0;if(d>>>0>65535){break a}ql(b,d);if(x[c+14>>1]){d=0;while(1){v[c+8>>2]=0;No(a,c+8|0);f=z[c+8>>2];g=Pb(b,d),h=f,z[g>>2]=h;d=d+1|0;if(d>>>0<x[c+14>>1]){continue}break}}e=Jf(v[v[a>>2]-12>>2]+a|0)}a=e;jb=c+16|0;return a}function FS(a,b){var c=0,d=0,e=0,f=0;c=jb-16|0;jb=c;v[c+12>>2]=b;d=b;b=jb-16|0;jb=b;zb(a);v[b+12>>2]=89478485;v[113382]=0;v[b+8>>2]=2147483647;e=Q(33,b+12|0,b+8|0)|0;f=v[113382];v[113382]=0;a:{if((f|0)!=1){jb=b+16|0;b=v[e>>2];break a}V(0)|0;O()|0;Ab();L()}if(b>>>0>=d>>>0){a=Nl(a);if(a>>>0<b>>>1>>>0){v[c+8>>2]=a<<1;b=v[Vc(c+8|0,c+12|0)>>2]}jb=c+16|0;return b}ld();L()}function nl(a){if((a|0)>=0){if(a>>>0<=16383){if(a>>>0<=15){return t[a+47504|0]}if(a>>>0<=511){return t[(a>>>5|0)+47504|0]+5|0}return t[(a>>>10|0)+47504|0]+10|0}if(a>>>0<=16777215){if(a>>>0<=524287){return t[(a>>>15|0)+47504|0]+15|0}return t[(a>>>20|0)+47504|0]+20|0}if(a>>>0<=536870911){return t[(a>>>25|0)+47504|0]+25|0}a=t[(a>>>30|0)+47504|0]+30|0}else{a=0}return a}function Bga(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;c=jb-16|0;jb=c;v[c+12>>2]=477218588;v[113382]=0;v[c+8>>2]=2147483647;d=Q(33,c+12|0,c+8|0)|0;e=v[113382];v[113382]=0;a:{if((e|0)!=1){jb=c+16|0;c=v[d>>2];break a}V(0)|0;O()|0;Ab();L()}if(b>>>0>c>>>0){ld();L()}c=b;if(c>>>0>=477218589){fe(7217);L()}c=be(B(c,9),1);v[a>>2]=c;v[a+4>>2]=c;f=zb(a),g=c+B(b,9)|0,v[f>>2]=g}function or(a,b,c){var d=0,e=0;if(c&2048){t[a|0]=43;a=a+1|0}if(c&1024){t[a|0]=35;a=a+1|0}d=c&260;if((d|0)!=260){t[a|0]=46;t[a+1|0]=42;a=a+2|0}c=c&16384;while(1){e=w[b|0];if(e){t[a|0]=e;a=a+1|0;b=b+1|0;continue}break}a:{b:{if((d|0)!=256){if((d|0)!=4){break b}b=c?70:102;break a}b=c?69:101;break a}b=c?65:97;if((d|0)==260){break a}b=c?71:103}t[a|0]=b;return(d|0)!=260}function hH(a,b){a=a|0;b=b|0;var c=0;c=jb-16|0;jb=c;a:{b:{c:{if(b-32>>>0>=481){a=ba(8)|0;v[113382]=0;c=Q(121,c|0,5373)|0;b=v[113382];v[113382]=0;if((b|0)==1){break c}nc(a,c);v[113382]=0;U(1978,a|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break a}b=P()|0;O()|0;yb(c);break b}v[v[a+32>>2]+1074420>>2]=B(b,1e4);jb=c+16|0;return}b=P()|0;O()|0;ca(a|0)}S(b|0)}L()}function dF(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;e=jb-16|0;jb=e;f=v[jc(a)>>2];d=v[c>>2]-v[a>>2]|0;a:{if(d>>>0<2147483647){d=d<<1;break a}d=-1}d=d?d:4;h=v[b>>2];i=v[a>>2];g=Qq((f|0)==2373?0:v[a>>2],d);if(g){if((f|0)!=2373){ke(a)}v[e+4>>2]=2310;f=Ld(e+8|0,g,e+4|0);aF(a,f);Gc(f);v[b>>2]=v[a>>2]+(h-i|0);v[c>>2]=v[a>>2]+(d&-4);jb=e+16|0;return}Gv();L()}function bca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=jb-16|0;jb=e;v[e+12>>2]=c>>>3;v[e+8>>2]=v[a>>2];d=v[Lb(e+12|0,e+8|0)>>2];b=Eb(b);if(d){a=v[a+20>>2];c=d;while(1){Eb(w[b|0]);Eb(w[b+1|0]);Eb(w[b+2|0]);Eb(w[b+3|0]);Eb(w[b+4|0]);Eb(w[b+5|0]);f=a,g=Eb(w[b+6|0])|Eb(w[b+7|0])<<8,u[f>>1]=g;a=a+2|0;b=b+8|0;c=c-1|0;if(c){continue}break}}jb=e+16|0;return d<<3}function aca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=jb-16|0;jb=e;v[e+12>>2]=c>>>3;v[e+8>>2]=v[a>>2];d=v[Lb(e+12|0,e+8|0)>>2];b=Eb(b);if(d){a=v[a+20>>2];c=d;while(1){Eb(w[b+7|0]);Eb(w[b+6|0]);Eb(w[b+5|0]);Eb(w[b+4|0]);Eb(w[b+3|0]);Eb(w[b+2|0]);f=a,g=Eb(w[b+1|0])|Eb(w[b|0])<<8,u[f>>1]=g;a=a+2|0;b=b+8|0;c=c-1|0;if(c){continue}break}}jb=e+16|0;return d<<3}function w3(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;b=jb-32|0;jb=b;a:{a=rs(a,Ll(b+24|0,Eb(c),d),0);if(a+1>>>0>=3){a=ba(8)|0;v[113382]=0;b=Q(121,b+8|0,4331)|0;c=v[113382];v[113382]=0;b:{if((c|0)!=1){nc(a,b);v[113382]=0;U(1978,a|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break a}c=P()|0;O()|0;yb(b);break b}c=P()|0;O()|0;ca(a|0)}S(c|0);L()}jb=b+32|0;return a|0}L()}function Dia(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;e=jb-16|0;jb=e;c=e;v[c>>2]=a;d=v[a+4>>2];v[c+4>>2]=d;v[c+8>>2]=d+B(b,20);a:{b=v[c+4>>2];f=v[c+8>>2];if((b|0)!=(f|0)){while(1){d=zb(a);v[113382]=0;R(842,d|0,b|0);d=v[113382];v[113382]=0;if((d|0)==1){break a}b=b+20|0;v[c+4>>2]=b;if((b|0)!=(f|0)){continue}break}}Mb(c);jb=e+16|0;return}a=P()|0;O()|0;Mb(c);S(a|0);L()}function hP(a){var b=0,c=0,d=0;a:{if((w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24))!=-28486832|w[a+63|0]!=26|(w[a+66|0]|w[a+65|0]!=16&w[a+65|0]!=1)){break a}if(w[a- -64|0]&3){break a}b=a+78|0;if((w[b|0]|w[b+1|0]<<8)>>>0>127){break a}a=a+80|0;if((w[a|0]|w[a+1|0]<<8)>>>0>127){break a}c=jb-16|0;jb=c;d=xB(b,a);jb=c+16|0;a=d?a:b;c=(w[a|0]|w[a+1|0]<<8)!=0}return c}function $H(a,b,c){var d=0,e=0,f=0;d=jb-16|0;jb=d;v[d+8>>2]=c;a:{if((a|0)==(b|0)){break a}while(1){c=v[d+8>>2];b:{c:{e=v[a>>2];f=cf(e);if((f|0)==(Db(c)|0)){v[113382]=0;c=ea(310,c|0,0,-1,e|0,f|0)|0;e=v[113382];v[113382]=0;if((e|0)==1){break c}c=!c}else{c=0}break b}V(0)|0;O()|0;Ab();L()}if(c){break a}a=a+8|0;if((b|0)!=(a|0)){continue}break}a=b}jb=d+16|0;return a}function ep(a,b,c,d){a:{if(v[a+480180>>2]==4){if(c){t[b+830|0]=w[b+830|0]&15|c<<4;break a}c=w[b+830|0]>>>4|0;break a}if(d){if(c){t[b+854|0]=c;break a}c=w[b+854|0];break a}if(c){t[b+830|0]=c;break a}c=w[b+830|0]}b:{if(!(t[b+872|0]&1)){break b}c=v[b+688>>2]+((c&255)<<2)|0;v[b+688>>2]=(c|0)<256?c:256;if(!(v[a+480180>>2]&1)){break b}v[b+88>>2]=v[b+88>>2]|2097152}}function L_(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;e=jb-16|0;jb=e;f=v[jc(a)>>2];d=v[c>>2]-v[a>>2]|0;a:{if(d>>>0<2147483647){d=d<<1;break a}d=-1}d=d?d:1;h=v[b>>2];i=v[a>>2];g=Qq((f|0)==2373?0:v[a>>2],d);if(g){if((f|0)!=2373){ke(a)}v[e+4>>2]=2310;f=Ld(e+8|0,g,e+4|0);aF(a,f);Gc(f);v[b>>2]=v[a>>2]+(h-i|0);v[c>>2]=d+v[a>>2];jb=e+16|0;return}Gv();L()}function F6(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;b=qi(a,b,c,d);v[a+4272>>2]=1065353216;v[a+4216>>2]=1056964608;v[a+4208>>2]=1056880300;v[a+4212>>2]=1050733080;v[a>>2]=76876;v[113382]=0;W(1609,a+44|0,2,2)|0;c=v[113382];v[113382]=0;a:{if((c|0)==1){break a}v[113382]=0;Z(1610,b|0);c=v[113382];v[113382]=0;if((c|0)==1){break a}return a|0}a=P()|0;O()|0;rf(b);S(a|0);L()}function iH(a,b){a=a|0;b=b|0;var c=0;c=jb-16|0;jb=c;a:{b:{c:{if(b-1>>>0>=65535){a=ba(8)|0;v[113382]=0;c=Q(121,c|0,2334)|0;b=v[113382];v[113382]=0;if((b|0)==1){break c}nc(a,c);v[113382]=0;U(1978,a|0,78672,1986);a=v[113382];v[113382]=0;if((a|0)!=1){break a}b=P()|0;O()|0;yb(c);break b}v[v[a+32>>2]+1074416>>2]=b;jb=c+16|0;return}b=P()|0;O()|0;ca(a|0)}S(b|0)}L()}function Am(a,b,c){var d=0,e=0,f=0;e=jb-16|0;jb=e;d=e+8|0;Ac(d,b);v[113382]=0;b=T(2340,d|0)|0;d=v[113382];v[113382]=0;a:{if((d|0)==1){break a}v[113382]=0;d=T(2350,b|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break a}v[c>>2]=d;v[113382]=0;R(2351,a|0,b|0);a=v[113382];v[113382]=0;if((a|0)==1){break a}Ob(e+8|0);jb=e+16|0;return}a=P()|0;O()|0;Ob(e+8|0);S(a|0);L()}function Dm(a,b,c){var d=0,e=0,f=0;e=jb-16|0;jb=e;d=e+8|0;Ac(d,b);v[113382]=0;b=T(2306,d|0)|0;d=v[113382];v[113382]=0;a:{if((d|0)==1){break a}v[113382]=0;d=T(2321,b|0)|0;f=v[113382];v[113382]=0;if((f|0)==1){break a}t[c|0]=d;v[113382]=0;R(2322,a|0,b|0);a=v[113382];v[113382]=0;if((a|0)==1){break a}Ob(e+8|0);jb=e+16|0;return}a=P()|0;O()|0;Ob(e+8|0);S(a|0);L()}function xx(a,b,c){var d=0,e=0,f=0,g=0;f=jb-16|0;jb=f;d=f;v[d>>2]=a;e=v[a+4>>2];v[d+4>>2]=e;v[d+8>>2]=e+B(b,52);a:{b=v[d+4>>2];g=v[d+8>>2];if((b|0)!=(g|0)){while(1){e=zb(a);v[113382]=0;U(1548,e|0,b|0,c|0);e=v[113382];v[113382]=0;if((e|0)==1){break a}b=b+52|0;v[d+4>>2]=b;if((b|0)!=(g|0)){continue}break}}Mb(d);jb=f+16|0;return}a=P()|0;O()|0;Mb(d);S(a|0);L()}function X5(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;v[113382]=0;Z(1984,a|0);d=v[113382];v[113382]=0;if((d|0)!=1){v[a+16>>2]=0;v[a+12>>2]=c;v[a+8>>2]=b;return}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,9062,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)!=1){$();return}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function SM(a){var b=0,c=0,d=0,e=0;a:{if(v[a>>2]){e=v[a>>2];b=a;c=v[a+4>>2];b:{while(1){if((c|0)==(e|0)){break b}d=zb(b);v[113382]=0;c=c-16|0;R(1195,d|0,c|0);d=v[113382];v[113382]=0;if((d|0)!=1){continue}break}break a}v[b+4>>2]=e;zb(a);b=v[a>>2];a=Wh(a);v[113382]=0;U(25,b|0,a<<4,8);a=v[113382];v[113382]=0;if((a|0)==1){break a}}return}V(0)|0;O()|0;Ab();L()}function WK(a,b){var c=0,d=0;a:{if(x[a+480188>>1]<=b>>>0){break a}b:{c:{c=B(b,896)+a|0;d=w[c+1075797|0];switch(d-31|0){case 1:break b;case 0:break c;default:break a}}if(!(w[a+480209|0]&16)){break a}}c=t[c+1075799|0];if((c|0)>=0){QL(a,b,(d|0)==32,((w[(B(b,896)+a|0)+1075848|0]<<5)+a|0)+901692|0,c&255);return}QL(a,b,(d|0)==32,(((c&127)<<5)+a|0)+902204|0,0)}}function Ns(a){var b=0,c=0,d=0,e=0,f=0,g=0,h=0;d=jb-16|0;jb=d;e=d+8|0;b=jb-16|0;jb=b;v[113382]=0;c=a;T(1216,c+4|0)|0;f=v[113382];v[113382]=0;a:{b:{c:{if((f|0)!=1){v[113382]=0;v[b+12>>2]=0;W(1217,c+8|0,b+12|0,e|0)|0;e=v[113382];v[113382]=0;if((e|0)!=1){break c}break b}break b}g=c,h=jc(c),v[g>>2]=h;jb=b+16|0;break a}V(0)|0;O()|0;Ab();L()}jb=d+16|0;return a}function Dy(a){var b=0,c=0,d=0,e=0;a:{if(v[a>>2]){e=v[a>>2];b=a;c=v[a+4>>2];b:{while(1){if((c|0)==(e|0)){break b}d=zb(b);v[113382]=0;c=c-8|0;R(1192,d|0,c|0);d=v[113382];v[113382]=0;if((d|0)!=1){continue}break}break a}v[b+4>>2]=e;zb(a);b=v[a>>2];a=Ui(a);v[113382]=0;U(25,b|0,a<<3,8);a=v[113382];v[113382]=0;if((a|0)==1){break a}}return}V(0)|0;O()|0;Ab();L()}function bi(a,b,c,d,e){var f=0,g=0,h=0;f=jb-16|0;jb=f;v[f+8>>2]=b;b=0;g=6;a:{b:{if(gj(a,f+8|0)){break b}g=4;h=ck(a);if(!Lg(d,2048,h)){break b}b=ym(d,h);while(1){c:{fl(a);b=b-48|0;if(!wo(a,f+8|0)|(e|0)<2){break c}g=ck(a);if(!Lg(d,2048,g)){break a}e=e-1|0;b=ym(d,g)+B(b,10)|0;continue}break}g=2;if(!gj(a,f+8|0)){break a}}v[c>>2]=v[c>>2]|g}jb=f+16|0;return b}function ai(a,b,c,d,e){var f=0,g=0,h=0;f=jb-16|0;jb=f;v[f+8>>2]=b;b=0;g=6;a:{b:{if(ak(a,f+8|0)){break b}g=4;h=el(a);if(!Xj(d,2048,h)){break b}b=xm(d,h);while(1){c:{Cm(a);b=b-48|0;if(!qr(a,f+8|0)|(e|0)<2){break c}g=el(a);if(!Xj(d,2048,g)){break a}e=e-1|0;b=xm(d,g)+B(b,10)|0;continue}break}g=2;if(!ak(a,f+8|0)){break a}}v[c>>2]=v[c>>2]|g}jb=f+16|0;return b}function y6(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;b=qi(a,b,c,d);c=a+4216|0;v[c>>2]=1051372203;v[c+4>>2]=0;v[a+4208>>2]=1065353216;v[a+4212>>2]=1065353216;v[a>>2]=77080;v[113382]=0;W(1609,a+44|0,2,2)|0;c=v[113382];v[113382]=0;a:{if((c|0)==1){break a}v[113382]=0;Z(1610,b|0);c=v[113382];v[113382]=0;if((c|0)==1){break a}return a|0}a=P()|0;O()|0;rf(b);S(a|0);L()}function mla(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=jb-16|0;jb=d;a=Pp(a);e=d,f=ac(b),v[e+8>>2]=f;e=d,f=bc(b),v[e>>2]=f;a:{if(Jb(d+8|0,d)){while(1){b=v[d+8>>2];if((Ej(b)|0)==(c|0)){b=zb(b);v[113382]=0;R(563,a|0,b|0);b=v[113382];v[113382]=0;if((b|0)==1){break a}}b=d+8|0;Kk(b);if(Jb(b,d)){continue}break}}jb=d+16|0;return}b=P()|0;O()|0;cd(a);S(b|0);L()}function kX(a){a=a|0;a:{v[113382]=0;T(2802,457768)|0;a=v[113382];v[113382]=0;b:{if((a|0)==1){break b}v[113382]=0;T(2803,457852)|0;a=v[113382];v[113382]=0;if((a|0)==1){break b}v[113382]=0;T(2802,458104)|0;a=v[113382];v[113382]=0;if((a|0)==1){break b}v[113382]=0;T(2803,458188)|0;a=v[113382];v[113382]=0;if((a|0)==1){break b}break a}V(0)|0;O()|0;Ab();L()}}function Cx(a,b,c,d){var e=0,f=0;a:{e=w[a|0];f=w[c|0];b:{if(!(w[d|0]|((e|0)!=11|(f-5&255)>>>0>1))){t[a|0]=(f|0)==5?7:6;break b}if((f|0)==11){if(w[b|0]|(e-5&255)>>>0>1){break a}t[a|0]=(e|0)==5?7:6;t[b|0]=w[d|0];break b}if(!((e|0)!=10|(f|0)!=20|w[d|0]!=159)){t[a|0]=39;break b}if(w[b|0]!=159|(f|0)!=10|(e|0)!=20){break a}t[a|0]=39;t[b|0]=w[d|0]}t[c|0]=0}}function gB(a){var b=0,c=0,d=0,e=0,f=0;b=a+9|0;d=w[b|0]|w[b+1|0]<<8;c=qma(w[a+3|0],0,18,0);d=d+c|0;b=mb;b=c>>>0>d>>>0?b+1|0:b;c=d;d=b;f=c;b=a+6|0;c=w[b|0]|w[b+1|0]<<8;b=c>>>31|0;e=c<<1;c=f+e|0;b=b+d|0;b=c>>>0<e>>>0?b+1|0:b;d=b;a=a+4|0;a=w[a|0]|w[a+1|0]<<8;b=a>>>30|0;e=a<<2;c=e+c|0;a=b+d|0;a=c>>>0<e>>>0?a+1|0:a;b=c+3|0;a=b>>>0<3?a+1|0:a;mb=a;return b}function Sda(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=jb-32|0;jb=d;v[d+16>>2]=b;e=d,f=rz(a,b,c),v[e+24>>2]=f;a:{if(!Jb(d+24|0,d+16|0)){break a}v[d+8>>2]=v[d+24>>2];if(!Jb(re(d+8|0),d+16|0)){break a}while(1){if(x[v[d+8>>2]>>1]!=x[c>>1]){a=d+24|0;u[v[a>>2]>>1]=x[v[d+8>>2]>>1];re(a)}if(Jb(re(d+8|0),d+16|0)){continue}break}}jb=d+32|0;return v[d+24>>2]}function G3(a){a=a|0;var b=0,c=0,d=0,e=0;c=jb-32|0;jb=c;a=ih(a);v[113382]=0;R(2125,c+16|0,0);b=v[113382];v[113382]=0;a:{b:{if((b|0)!=1){b=c+16|0;d=ac(b);b=bc(b);e=v[Oc(c+8|0,a)>>2];v[113382]=0;W(2126,d|0,b|0,e|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break b}Lx(c+16|0);jb=c+32|0;return}b=P()|0;O()|0;break a}b=P()|0;O()|0;Lx(c+16|0)}gd(a);S(b|0);L()}function nca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=jb-16|0;jb=e;v[e+12>>2]=c>>>2;v[e+8>>2]=v[a>>2];f=v[Lb(e+12|0,e+8|0)>>2];b=Eb(b);if(f){a=v[a+20>>2];c=f;g=d;while(1){g=(Eb(w[b|0])+g|0)+(Eb(w[b+1|0])<<8)|0;u[a>>1]=g;d=(Eb(w[b+2|0])+d|0)+(Eb(w[b+3|0])<<8)|0;u[a+2>>1]=d;a=a+4|0;b=b+4|0;c=c-1|0;if(c){continue}break}}jb=e+16|0;return f<<2}function kca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=jb-16|0;jb=e;v[e+12>>2]=c>>>2;v[e+8>>2]=v[a>>2];f=v[Lb(e+12|0,e+8|0)>>2];b=Eb(b);if(f){a=v[a+20>>2];c=f;g=d;while(1){g=(Eb(w[b+1|0])+g|0)+(Eb(w[b|0])<<8)|0;u[a>>1]=g;d=(Eb(w[b+3|0])+d|0)+(Eb(w[b+2|0])<<8)|0;u[a+2>>1]=d;a=a+4|0;b=b+4|0;c=c-1|0;if(c){continue}break}}jb=e+16|0;return f<<2}function hV(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;h=jb-16|0;jb=h;g=jb-16|0;jb=g;f=jb-16|0;jb=f;e=g;v[e+4>>2]=1;i=e,j=Zn(e,1),v[i+8>>2]=j;jb=f+16|0;f=v[e+8>>2];v[113382]=0;aa(251,f|0,b|0,c|0,d|0)|0;b=v[113382];v[113382]=0;a:{if((b|0)!=1){b=a;a=eo(e);co(b,gc(a),a);HC(e);jb=g+16|0;break a}a=P()|0;O()|0;HC(e);S(a|0);L()}jb=h+16|0}function fia(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;f=jb-16|0;jb=f;v[f+12>>2]=d;sz(a,c,d);d=0;e=v[a+16>>2];if(e>>>0>c>>>0){v[f+8>>2]=e-c;d=v[Lb(f+8|0,f+12|0)>>2];e=jb-32|0;jb=e;a=a+4|0;h=e,i=ac(a),v[h+24>>2]=i;g=ff(e+24|0,c);h=e,i=ac(a),v[h+8>>2]=i;h=e,i=ff(e+8|0,c),v[h+16>>2]=i;wj(g,ff(e+16|0,d),b);jb=e+32|0}jb=f+16|0;return d|0}function Zh(a,b){a:{if((b|0)>=1024){a=a*8.98846567431158e307;if(b>>>0<2047){b=b-1023|0;break a}a=a*8.98846567431158e307;b=(b>>>0<3069?b:3069)-2046|0;break a}if((b|0)>-1023){break a}a=a*2.2250738585072014e-308;if(b>>>0>4294965251){b=b+1022|0;break a}a=a*2.2250738585072014e-308;b=(b>>>0>4294964230?b:-3066)+2044|0}l(0,0);l(1,b+1023<<20);return a*+n()}function Rl(a,b,c,d,e,f,g){var h=0,i=0,j=0,k=0;h=jb-16|0;jb=h;if(-17-b>>>0>=c>>>0){i=Tb(a);k=a;a:{if(b>>>0<2147483623){v[h+8>>2]=b<<1;v[h+12>>2]=b+c;c=Wi(v[Vc(h+12|0,h+8|0)>>2]);break a}c=-18}j=c+1|0;c=Zg(k,j);if(e){ag(c,i,e)}d=d-(e+f|0)|0;if(d){ag((c+e|0)+g|0,(e+i|0)+f|0,d)}b=b+1|0;if((b|0)!=11){cg(a,i,b)}Oe(a,c);Gf(a,j);jb=h+16|0;return}If();L()}function sz(a,b,c){var d=0,e=0,f=0,g=0,h=0,i=0,j=0;a:{if(w[a+20|0]){break a}d=b;b=-1-b|0;b=d+(b>>>0<c>>>0?b:c)|0;if(b>>>0<=y[a+16>>2]){break a}b=zz(b,4096);xQ(a,b-v[a+16>>2]|0);e=a,f=(h=a,i=uc(a+4|0,v[a+16>>2]),j=b-v[a+16>>2]|0,g=v[v[a>>2]+48>>2],nb[g](h|0,i|0,j|0)|0)+v[a+16>>2]|0,v[e+16>>2]=f;if(!(nb[v[v[a>>2]+44>>2]](a)|0)){break a}t[a+20|0]=1}}function nma(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=jb-48|0;jb=d;a:{b:{e=RL(b,c);if((e|0)!=-1){f=d,g=Bd(b),v[f+16>>2]=g;f=d,g=ff(d+16|0,e),v[f+24>>2]=g;f=d,g=ff(d+24|0,1),v[f+32>>2]=g;c=Hd(d+40|0,d+32|0);f=d,g=tf(b),v[f>>2]=g;e=Hd(d+8|0,d);ix(b,v[c>>2],v[e>>2]);break b}if(!Db(b)){break b}if(lI(b,c)){break b}bd(a);break a}rd(a,b)}jb=d+48|0}function Y5(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;v[113382]=0;Z(1984,a|0);d=v[113382];v[113382]=0;if((d|0)!=1){v[a+4>>2]=c;v[a>>2]=b?b:1966;return}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,9092,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)!=1){$();return}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function XW(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=jb-16|0;jb=f;v[f+8>>2]=e;v[f+12>>2]=c;c=Db(a);if(!((e|0)==-1|c>>>0<b>>>0)){v[f>>2]=c-b;g=f,h=v[Lb(f+12|0,f)>>2],v[g+4>>2]=h;b=Sm(Tb(a)+b|0,d,v[Lb(f+4|0,f+8|0)>>2]);a:{if(b){break a}b=-1;a=v[f+4>>2];c=v[f+8>>2];if(a>>>0<c>>>0){break a}b=a>>>0>c>>>0}jb=f+16|0;return b|0}pm();L()}function Sca(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;e=jb-16|0;jb=e;a:{c=$l(e,a+8|0,zy(b,c));if(v[c>>2]!=v[c+4>>2]){while(1){d=v[a+16>>2];f=v[c>>2];v[113382]=0;U(1213,d|0,f|0,b|0);d=v[113382];v[113382]=0;if((d|0)==1){break a}d=v[c>>2]+2|0;v[c>>2]=d;b=b+2|0;if((d|0)!=v[c+4>>2]){continue}break}}yc(c);jb=e+16|0;return}a=P()|0;O()|0;yc(c);S(a|0);L()}function Kd(a,b,c){var d=0,e=0,f=0,g=0;e=jb-16|0;jb=e;km(b);d=jb-16|0;jb=d;v[d+12>>2]=b;b=e+8|0;Te(b,d+12|0);jb=d+16|0;a:{a=a+8|0;if(Kb(a)>>>0<=c>>>0){v[113382]=0;R(2439,a|0,c+1|0);d=v[113382];v[113382]=0;if((d|0)==1){break a}}if(v[Pb(a,c)>>2]){jm(v[Pb(a,c)>>2])}d=ke(b);f=Pb(a,c),g=d,v[f>>2]=g;JE(b);jb=e+16|0;return}a=P()|0;O()|0;JE(b);S(a|0);L()}function IO(a){var b=0,c=0;a:{if((w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24))!=860902483){break a}b=a+4|0;b=w[b|0]|w[b+1|0]<<8;if(((b<<8|b>>>8)&65535)>>>0>2|w[a+6|0]>128){break a}b=a+200|0;b=w[b|0]|w[b+1|0]<<8;if(((b<<8|b>>>8)&65535)>>>0>3999){break a}b=a+140|0;if(!(w[b|0]|w[b+1|0]<<8)){break a}a=a+148|0;c=(w[a|0]|w[a+1|0]<<8)==12800}return c}function Hda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=jb-32|0;jb=e;v[e+24>>2]=d;d=Lj(a,c);pf(e,v[a+28>>2]);f=v[e+12>>2];v[e+16>>2]=v[e+8>>2];v[e+20>>2]=f;a:{if(!d){if(wd(a,5)){break a}}f=v[a+28>>2];EB(b,v[e+24>>2]);if(v[e+24>>2]){while(1){tN(f,rc(b,g));g=g+1|0;if(g>>>0<y[e+24>>2]){continue}break}}}a=$i(a,d,c,e+16|0);jb=e+32|0;return a|0}function AP(a){var b=0,c=0,d=0,e=0,f=0,g=0;a:{b=v[a>>2];b:{if(!b){break b}c=v[a+8>>2];if(!c){break b}a=v[a+12>>2];if(!a){break b}e=nb[a|0](b)|0;d=mb;f=d;if((d|0)<0){break b}if((nb[c|0](b,0,0,0)|0)<0){break a}if((nb[c|0](b,0,0,2)|0)<0){break a}d=nb[a|0](b)|0;a=mb;nb[c|0](b,e,f,0)|0;if((a|0)<0){break b}g=EQ(d,a)}return g}nb[c|0](b,e,f,0)|0;return 0}function l6(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=jb-48|0;jb=d;a:{b:{e=RL(b,c);if((e|0)!=-1){f=d,g=Bd(b),v[f+16>>2]=g;f=d,g=ff(d+16|0,e),v[f+24>>2]=g;f=d,g=ff(d+24|0,1),v[f+32>>2]=g;c=Hd(d+40|0,d+32|0);f=d,g=tf(b),v[f>>2]=g;e=Hd(d+8|0,d);ix(b,v[c>>2],v[e>>2]);break b}if(!Db(b)){break b}if(lI(b,c)){break b}Xb(a);break a}rd(a,b)}jb=d+48|0}function dp(a,b,c,d){a:{if(v[a+480180>>2]==4){d=w[b+830|0];if(c){t[b+830|0]=d&240|c;break a}c=d&15;break a}if(d){if(c){t[b+854|0]=c;break a}c=w[b+854|0];break a}if(c){t[b+830|0]=c;break a}c=w[b+830|0]}b:{if(!(t[b+872|0]&1)){break b}c=v[b+688>>2]-((c&255)<<2)|0;v[b+688>>2]=(c|0)>0?c:0;if(!(v[a+480180>>2]&1)){break b}v[b+88>>2]=v[b+88>>2]|2097152}}function F8(a,b){a=a|0;b=b|0;var c=0;a:{b:{if((wc(v[a+20>>2]+4|0)|0)!=8){break b}c=v[v[a+20>>2]+4>>2];if((w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24))!=1869112133){break b}b=v[v[a+20>>2]+4>>2];c=w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24);b=w[b+4|0]|w[b+5|0]<<8|(w[b+6|0]<<16|w[b+7|0]<<24);v[a+4260>>2]=c;v[a+4264>>2]=b;break a}cJ(a,b)}hs(a)}function zf(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;e=jb-16|0;jb=e;c=a;a:{if(!he(b)){v[c+8>>2]=v[b+8>>2];d=v[b+4>>2];v[c>>2]=v[b>>2];v[c+4>>2]=d;break a}g=v[b>>2];b:{c:{d=v[b+4>>2];d:{if(d>>>0<=10){b=c;Ce(c,d);break d}if(d>>>0>4294967279){break c}f=Wi(d)+1|0;b=Zg(c,f);Oe(c,b);Gf(c,f);ae(c,d)}ag(b,g,d+1|0);break b}If();L()}}jb=e+16|0;return a|0}function oca(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=jb-16|0;jb=d;v[d+12>>2]=c>>>2;v[d+8>>2]=v[a>>2];e=v[Lb(d+12|0,d+8|0)>>2];b=Eb(b);if(e){a=v[a+20>>2];c=e;while(1){f=a,g=(Eb(w[b|0])|Eb(w[b+1|0])<<8)^32768,u[f>>1]=g;f=a,g=(Eb(w[b+2|0])|Eb(w[b+3|0])<<8)^32768,u[f+2>>1]=g;a=a+4|0;b=b+4|0;c=c-1|0;if(c){continue}break}}jb=d+16|0;return e<<2}function lca(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=jb-16|0;jb=d;v[d+12>>2]=c>>>2;v[d+8>>2]=v[a>>2];e=v[Lb(d+12|0,d+8|0)>>2];b=Eb(b);if(e){a=v[a+20>>2];c=e;while(1){f=a,g=(Eb(w[b+1|0])|Eb(w[b|0])<<8)^32768,u[f>>1]=g;f=a,g=(Eb(w[b+3|0])|Eb(w[b+2|0])<<8)^32768,u[f+2>>1]=g;a=a+4|0;b=b+4|0;c=c-1|0;if(c){continue}break}}jb=d+16|0;return e<<2}function Tl(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=jb-16|0;jb=d;t[d+15|0]=b;a:{b:{c:{d:{if(he(a)){c=hj(a)-1|0;e=v[a+4>>2];if((c|0)==(e|0)){break d}break b}e=10;c=10;b=w[a+11|0];if((b|0)!=10){break c}}Rl(a,c,1,c,c,0,0);b=e;if(he(a)){break b}}c=a;Ce(a,b+1|0);break a}c=v[a>>2];ae(a,e+1|0);b=e}a=b+c|0;Rd(a,d+15|0);t[d+14|0]=0;Rd(a+1|0,d+14|0);jb=d+16|0}function Eia(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;c=jb-16|0;jb=c;zb(a);v[c+12>>2]=214748364;v[113382]=0;v[c+8>>2]=2147483647;d=Q(33,c+12|0,c+8|0)|0;e=v[113382];v[113382]=0;a:{if((e|0)!=1){jb=c+16|0;c=v[d>>2];break a}V(0)|0;O()|0;Ab();L()}if(b>>>0>c>>>0){ld();L()}c=Ez(zb(a),b);v[a>>2]=c;v[a+4>>2]=c;f=zb(a),g=c+B(b,20)|0,v[f>>2]=g;Ap(a);Ap(a)}function sv(a,b,c,d){t[a+53|0]=1;a:{if(v[a+4>>2]!=(c|0)){break a}t[a+52|0]=1;c=v[a+16>>2];b:{if(!c){v[a+36>>2]=1;v[a+24>>2]=d;v[a+16>>2]=b;if(v[a+48>>2]!=1){break a}if((d|0)==1){break b}break a}if((b|0)==(c|0)){c=v[a+24>>2];if((c|0)==2){v[a+24>>2]=d;c=d}if(v[a+48>>2]!=1){break a}if((c|0)==1){break b}break a}v[a+36>>2]=v[a+36>>2]+1}t[a+54|0]=1}}function VT(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;d=jb-16|0;jb=d;c=-1;a:{if(!Ef(a,7)){break a}c=0;if(!iB(a,7772)){break a}f=jb-16|0;jb=f;c=d;e=f+8|0;WA(e,d);g=a;h=Hb(e);e=hd(a,$b(f,e));if((h|0)==(e|0)){Tc(g,Hb(f+8|0))}jb=f+16|0;g=(e|0)==(h|0);if(!g){XA(c)}c=-1;if(!g){break a}c=0;if(!hB(d)){break a}c=gf(a,b,gB(d),mb)}jb=d+16|0;return c|0}function Pha(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=jb-48|0;jb=c;a:{if(ht(a)>>>0<b>>>0){zb(a);d=kz(c+32|0);v[113382]=0;R(898,d|0,b|0);b=v[113382];v[113382]=0;if((b|0)==1){break a}b=c+16|0;uj(b,a);e=c+8|0;xk(e,a);v[113382]=0;U(899,d|0,b|0,e|0);b=v[113382];v[113382]=0;if((b|0)==1){break a}jz(a,d);ee(d)}jb=c+48|0;return}a=P()|0;O()|0;ee(d);S(a|0);L()}function yr(a,b,c,d){var e=0,f=0;e=jb-160|0;jb=e;lc(e+8|0,54192,144);a:{b:{if((b|0)<=0){if(b){break b}b=1;a=e+159|0}v[e+52>>2]=a;v[e+28>>2]=a;f=-2-a|0;b=b>>>0>f>>>0?f:b;v[e+56>>2]=b;a=a+b|0;v[e+36>>2]=a;v[e+24>>2]=a;a=uG(e+8|0,c,d,2273,2274);if(!b){break a}b=v[e+28>>2];t[b-((b|0)==v[e+24>>2])|0]=0;break a}v[113305]=61;a=-1}jb=e+160|0;return a}function UW(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=jb-16|0;jb=d;v[d+12>>2]=b;a:{b:{c:{d:{if(he(a)){c=hj(a)-1|0;e=v[a+4>>2];if((c|0)==(e|0)){break d}break b}e=1;c=1;b=w[a+11|0];if((b|0)!=1){break c}}KD(a,c,1,c,c);b=e;if(he(a)){break b}}c=a;Ce(a,b+1|0);break a}c=v[a>>2];ae(a,e+1|0);b=e}a=(b<<2)+c|0;Te(a,d+12|0);v[d+8>>2]=0;Te(a+4|0,d+8|0);jb=d+16|0}function KO(a){var b=0,c=0;a:{if(w[a+29|0]!=2){break a}b=w[a+28|0];if((b|0)!=26&(b|0)!=2|w[a+30|0]!=2){break a}b=w[a+31|0];if(b>>>0>21|!(1<<b&3146753)|w[a+33|0]>64){break a}b=w[a+34|0];if(b>>>0>=65&(b|0)!=88){break a}b=a+28|0;a=a+20|0;while(1){c=w[a|0]-32|0;if((c&255)>>>0<=94){a=a+1|0;if((b|0)!=(a|0)){continue}}break}c=(c&255)>>>0<95}return c}function KD(a,b,c,d,e){var f=0,g=0,h=0,i=0;f=jb-16|0;jb=f;if(1073741807-b>>>0>=c>>>0){g=Tb(a);i=a;a:{if(b>>>0<536870887){v[f+8>>2]=b<<1;v[f+12>>2]=b+c;c=al(v[Vc(f+12|0,f+8|0)>>2]);break a}c=1073741806}h=c+1|0;c=Qj(i,h);if(e){yh(c,g,e)}d=d-e|0;if(d){e=e<<2;yh(e+c|0,e+g|0,d)}b=b+1|0;if((b|0)!=2){no(g,b)}Oe(a,c);Gf(a,h);jb=f+16|0;return}If();L()}function vba(a){a=a|0;var b=0,c=0,d=0;c=jb-16|0;jb=c;b=Pe(2500);v[113382]=0;a=W(92,b|0,a|0,0)|0;d=v[113382];v[113382]=0;if((d|0)!=1){b=jb-16|0;jb=b;v[113382]=0;v[b+12>>2]=a;a=c+8|0;W(97,a|0,b+12|0,b+8|0)|0;d=v[113382];v[113382]=0;a:{if((d|0)!=1){jb=b+16|0;break a}V(0)|0;O()|0;Ab();L()}jb=c+16|0;return v[a>>2]}a=P()|0;O()|0;Wb(b);S(a|0);L()}function RQ(a,b,c,d){var e=0,f=0,g=0;e=jb-16|0;jb=e;v[e+12>>2]=a;f=+(B(a,d)>>>0)*2500;a:{if(!(!c|b)){break a}b:{if(!(!b|!a)){tc(e+12|0,10);a=w[v[e+12>>2]+24016|0];v[e+12>>2]=a;break b}if(a-1>>>0>9){break b}f=7338401.379310345/+(a>>>0);break a}f=+(a>>>0)*37878.78787878787}g=f;c:{if(f<4294967296&f>=0){a=~~g>>>0;break c}a=0}jb=e+16|0;return a}function FP(a){var b=0,c=0,d=0,e=0,f=0;b=a+28|0;e=w[b|0]|w[b+1|0]<<8;b=qma(w[a+30|0],0,37,0);c=mb;d=b;b=a+24|0;b=qma(w[b|0]|w[b+1|0]<<8,0,192,0);d=d+b|0;c=mb+c|0;c=b>>>0>d>>>0?c+1|0:c;b=c;f=e;e=d;a=w[a+26|0];c=a>>>26|0;d=a<<6;e=e+d|0;a=b+c|0;a=d>>>0>e>>>0?a+1|0:a;b=e;c=f+b|0;a=b>>>0>c>>>0?a+1|0:a;b=c+192|0;a=b>>>0<192?a+1|0:a;mb=a;return b}function F3(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=Jl(a);e=Jl(b);a=jb-32|0;jb=a;v[a+24>>2]=c;a:{b:{if((d|0)!=(e|0)){while(1){b=Ub(a+8|0,v[d>>2]);v[113382]=0;Q(2175,a+24|0,b|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break b}yb(b);d=d+4|0;if((e|0)!=(d|0)){continue}break}c=v[a+24>>2]}jb=a+32|0;break a}a=P()|0;O()|0;yb(b);S(a|0);L()}return c|0}function Pda(a,b){a=a|0;b=b|0;var c=0,d=0;c=jb-16|0;jb=c;v[a>>2]=0;v[a+4>>2]=0;v[113382]=0;v[c+12>>2]=0;W(1140,a+8|0,c+12|0,c+8|0)|0;d=v[113382];v[113382]=0;a:{if((d|0)!=1){jb=c+16|0;break a}V(0)|0;O()|0;Ab();L()}t[a+16|0]=0;v[a+12>>2]=b;v[113382]=0;Z(1138,a|0);b=v[113382];v[113382]=0;if((b|0)!=1){return a|0}b=P()|0;O()|0;Ws(a);S(b|0);L()}function wX(a,b){a=a|0;b=b|0;var c=0;if(y[a+24>>2]>y[a+44>>2]){v[a+44>>2]=v[a+24>>2]}a:{if(y[a+8>>2]>=y[a+12>>2]){break a}if(se(b,-1)){sm(a,v[a+8>>2],v[a+12>>2]-1|0,v[a+44>>2]);return Zq(b)|0}if(!(w[a+48|0]&16)){if(!se(um(b),t[v[a+12>>2]-1|0])){break a}}sm(a,v[a+8>>2],v[a+12>>2]-1|0,v[a+44>>2]);c=um(b);t[v[a+12>>2]]=c;return b|0}return-1}function hA(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0;f=jb-16|0;jb=f;v[f+12>>2]=c;c=f+12|0;tc(c,256);tc(c,65535);h=x[f+12>>1];lg(a,h);if(h){c=0;while(1){g=w[b+c|0];a:{if((g|0)==(d|0)){g=65535;break a}if((e|0)!=(g|0)){break a}g=65534}i=Dj(a,c),j=g,u[i>>1]=j;c=c+1|0;if((h|0)!=(c|0)){continue}break}}jb=f+16|0;return 1}function IW(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;e=jb+-64|0;jb=e;d=1;a:{if(rg(a,b,0)){break a}d=0;if(!b){break a}b=wv(b,67260,67308);d=0;if(!b){break a}d=e+8|0;Qb(d|4,0,52);v[e+56>>2]=1;v[e+20>>2]=-1;v[e+16>>2]=a;v[e+8>>2]=b;nb[v[v[b>>2]+28>>2]](b,d,v[c>>2],1);a=v[e+32>>2];if((a|0)==1){v[c>>2]=v[e+24>>2]}d=(a|0)==1}jb=e- -64|0;return d|0}function t_(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;d=jb-16|0;jb=d;b=a;a:{if(!he(f)){v[b+8>>2]=v[f+8>>2];a=v[f+4>>2];v[b>>2]=v[f>>2];v[b+4>>2]=a;break a}e=v[f>>2];b:{c:{c=v[f+4>>2];d:{if(c>>>0<=1){Ce(a,c);break d}if(c>>>0>1073741807){break c}f=al(c)+1|0;b=Qj(a,f);Oe(a,b);Gf(a,f);ae(a,c)}yh(b,e,c+1|0);break b}If();L()}}jb=d+16|0}function dI(){var a=0,b=0,c=0,d=0;c=jb-16|0;jb=c;b=Pe(1304568);v[113382]=0;d=T(2103,b|0)|0;a=v[113382];v[113382]=0;if((a|0)!=1){a=jb-16|0;jb=a;v[113382]=0;v[a+12>>2]=d;b=c+8|0;W(2107,b|0,a+12|0,a+8|0)|0;d=v[113382];v[113382]=0;a:{if((d|0)!=1){jb=a+16|0;break a}V(0)|0;O()|0;Ab();L()}jb=c+16|0;return v[b>>2]}a=P()|0;O()|0;Wb(b);S(a|0);L()}function cN(a){t[a|0]=0;t[a+1|0]=0;t[a+2|0]=0;t[a+3|0]=0;t[a+4|0]=0;t[a+5|0]=0;t[a+6|0]=0;t[a+7|0]=0;t[a+23|0]=0;t[a+24|0]=0;t[a+25|0]=0;t[a+26|0]=0;t[a+16|0]=0;t[a+17|0]=0;t[a+18|0]=0;t[a+19|0]=0;t[a+20|0]=0;t[a+21|0]=0;t[a+22|0]=0;t[a+23|0]=0;t[a+8|0]=0;t[a+9|0]=0;t[a+10|0]=0;t[a+11|0]=0;t[a+12|0]=0;t[a+13|0]=0;t[a+14|0]=0;t[a+15|0]=0}function t9(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;c=jb-16|0;jb=c;zb(b);f=a;g=WJ(a,c+8|0);a:{d=Kb(b);if(!d){break a}v[113382]=0;R(366,f|0,d|0);e=v[113382];v[113382]=0;if((e|0)!=1){e=v[b+4>>2];b=v[b>>2];v[113382]=0;X(1559,f|0,b|0,e|0,d|0);b=v[113382];v[113382]=0;if((b|0)!=1){break a}}a=P()|0;O()|0;xs(g);S(a|0);L()}jb=c+16|0;return a|0}function lI(a,b){var c=0,d=0,e=0,f=0,g=0;e=Tb(a);c=Db(a);a=Tb(b);b=Db(b);if(!b|!c){a=-1}else{f=a+b|0;b=e;g=c+b|0;d=g;a:{if((b|0)==(d|0)){break a}while(1){c=a;if((c|0)!=(f|0)){while(1){if(nb[26](t[b|0],t[c|0])|0){break a}c=c+1|0;if((f|0)!=(c|0)){continue}break}}b=b+1|0;if((d|0)!=(b|0)){continue}break}b=d}a=(b|0)==(g|0)?-1:b-e|0}return a}function dma(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;Gj(a);i=v[b+4>>2];f=b+4|0;nh(zb(a),v[a>>2],c,f);j=zb(a);g=b+8|0;d=g;h=v[a+4>>2];if((h|0)!=(c|0)){e=v[d>>2];while(1){Xt(j,e,c);e=v[d>>2]+2|0;v[d>>2]=e;c=c+2|0;if((h|0)!=(c|0)){continue}break}}dc(a,f);dc(a+4|0,g);dc(zb(a),gc(b));v[b>>2]=v[b+4>>2];pq(a,oc(a));return i|0}function aea(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;Ve(a);i=v[b+4>>2];f=b+4|0;nh(zb(a),v[a>>2],c,f);j=zb(a);g=b+8|0;d=g;h=v[a+4>>2];if((h|0)!=(c|0)){e=v[d>>2];while(1){Nz(j,e,c);e=v[d>>2]+4|0;v[d>>2]=e;c=c+4|0;if((h|0)!=(c|0)){continue}break}}dc(a,f);dc(a+4|0,g);dc(zb(a),gc(b));v[b>>2]=v[b+4>>2];lk(a,Kb(a));return i|0}function Rca(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;Gj(a);i=v[b+4>>2];f=b+4|0;nh(zb(a),v[a>>2],c,f);j=zb(a);g=b+8|0;d=g;h=v[a+4>>2];if((h|0)!=(c|0)){e=v[d>>2];while(1){Wl(j,e,c);e=v[d>>2]+2|0;v[d>>2]=e;c=c+2|0;if((h|0)!=(c|0)){continue}break}}dc(a,f);dc(a+4|0,g);dc(zb(a),gc(b));v[b>>2]=v[b+4>>2];pq(a,oc(a));return i|0}function RD(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0;b=jb-16|0;jb=b;e=b+16|0;a:{while(1){d=v[a+36>>2];c=b+8|0;f=nb[v[v[d>>2]+20>>2]](d,v[a+40>>2],c,e,b+4|0)|0;d=-1;g=c;c=v[b+4>>2]-c|0;if((Zi(g,1,c,v[a+32>>2])|0)!=(c|0)){break a}b:{switch(f-1|0){case 1:break a;case 0:continue;default:break b}}break}d=Er(v[a+32>>2])?-1:0}jb=b+16|0;return d|0}function Cia(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;Pl(a);i=v[b+4>>2];f=b+4|0;nh(zb(a),v[a>>2],c,f);j=zb(a);g=b+8|0;d=g;h=v[a+4>>2];if((h|0)!=(c|0)){e=v[d>>2];while(1){io(j,e,c);e=v[d>>2]+1|0;v[d>>2]=e;c=c+1|0;if((h|0)!=(c|0)){continue}break}}dc(a,f);dc(a+4|0,g);dc(zb(a),gc(b));v[b>>2]=v[b+4>>2];rA(a,wc(a));return i|0}function ry(a,b,c,d){var e=0,f=0;e=jb-16|0;jb=e;a:{if(v[b+480180>>2]&64671904){b=w[c+4|0];t[e|0]=0;v[a>>2]=w[(b&15)+26064|0];t[a+4|0]=w[e|0];break a}t[e+15|0]=0;f=w[c+4|0];if(!(w[c+3|0]!=4|v[b+480180>>2]!=4)){t[e+15|0]=1;f=f<<1}Fb(e,b+1074312|0,66);if(!(!Cb(e)|!d)){v[e>>2]=0;Ei(a,e,e+15|0);break a}v[e>>2]=f<<4;Ei(a,e,e+15|0)}jb=e+16|0}function L9(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;Rt(a);i=v[b+4>>2];f=b+4|0;oR(zb(a),v[a>>2],c,f);j=zb(a);g=b+8|0;d=g;h=v[a+4>>2];if((h|0)!=(c|0)){e=v[d>>2];while(1){Sz(j,e,c);e=v[d>>2]+6|0;v[d>>2]=e;c=c+6|0;if((h|0)!=(c|0)){continue}break}}dc(a,f);dc(a+4|0,g);dc(zb(a),gc(b));v[b>>2]=v[b+4>>2];pA(a,hg(a));return i|0}function Z2(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=BM(a);a:{if(!v[b+4>>2]){break a}c=v[b+4>>2];v[113382]=0;R(2147,a|0,c|0);c=v[113382];v[113382]=0;if((c|0)!=1){c=v[b>>2];e=v[b>>2];f=B(v[b+4>>2],12);b=v[b+4>>2];v[113382]=0;X(2148,a|0,c|0,e+f|0,b|0);b=v[113382];v[113382]=0;if((b|0)!=1){break a}}a=P()|0;O()|0;yC(d);S(a|0);L()}return a|0}function rf(a){a=a|0;var b=0,c=0;v[a>>2]=74912;b=v[a+12>>2];if(v[b>>2]==(a|0)){v[b>>2]=v[a+4>>2]}b=v[a+20>>2];if(b){v[b>>2]=0;v[a+20>>2]=0}b=v[a+4>>2];if(b){v[b+8>>2]=v[a+8>>2]}c=v[a+8>>2];if(c){v[c+4>>2]=b}v[a+4>>2]=0;v[a+8>>2]=0;b=v[a+16>>2];v[b+946300>>2]=v[b+946300>>2]-1;b=a+44|0;bs(b+36|0);bs(b+24|0);as(b+12|0);as(b);return a|0}function De(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;a:{if(!Db(a)|(c-b|0)<5){break a}uo(b,c);e=c-4|0;c=Tb(a);f=c+Db(a)|0;b:{while(1){c:{a=t[c|0];if(b>>>0>=e>>>0){break c}if(!((a|0)<=0|(a|0)>=127)&v[b>>2]!=t[c|0]){break b}b=b+4|0;c=((f-c|0)>1)+c|0;continue}break}if((a|0)<=0|(a|0)>=127|t[c|0]>>>0>v[e>>2]-1>>>0){break a}}v[d>>2]=4}}function b9(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;e=jb-16|0;jb=e;a:{b=Sh(e,a+8|0,b);if(v[b>>2]!=v[b+4>>2]){while(1){d=v[a+16>>2];f=v[b>>2];v[113382]=0;U(1573,d|0,f|0,c|0);d=v[113382];v[113382]=0;if((d|0)==1){break a}d=v[b>>2]+4|0;v[b>>2]=d;if((d|0)!=v[b+4>>2]){continue}break}}yc(b);jb=e+16|0;return}a=P()|0;O()|0;yc(b);S(a|0);L()}function Yja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;e=jb-16|0;jb=e;a:{b=at(e,a+8|0,b);if(v[b>>2]!=v[b+4>>2]){while(1){d=v[a+16>>2];f=v[b>>2];v[113382]=0;U(534,d|0,f|0,c|0);d=v[113382];v[113382]=0;if((d|0)==1){break a}d=v[b>>2]+1|0;v[b>>2]=d;if((d|0)!=v[b+4>>2]){continue}break}}yc(b);jb=e+16|0;return}a=P()|0;O()|0;yc(b);S(a|0);L()}function Caa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;e=jb-16|0;jb=e;a:{b=Sh(e,a+8|0,b);if(v[b>>2]!=v[b+4>>2]){while(1){d=v[a+16>>2];f=v[b>>2];v[113382]=0;U(372,d|0,f|0,c|0);d=v[113382];v[113382]=0;if((d|0)==1){break a}d=v[b>>2]+4|0;v[b>>2]=d;if((d|0)!=v[b+4>>2]){continue}break}}yc(b);jb=e+16|0;return}a=P()|0;O()|0;yc(b);S(a|0);L()}function nU(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;e=jb-16|0;jb=e;a:{b=$l(e,a+8|0,b);if(v[b>>2]!=v[b+4>>2]){while(1){d=v[a+16>>2];f=v[b>>2];v[113382]=0;U(347,d|0,f|0,c|0);d=v[113382];v[113382]=0;if((d|0)==1){break a}d=v[b>>2]+2|0;v[b>>2]=d;if((d|0)!=v[b+4>>2]){continue}break}}yc(b);jb=e+16|0;return}a=P()|0;O()|0;yc(b);S(a|0);L()}function mda(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=jb-16|0;jb=c;zb(b);f=UM(a,c+8|0);a:{d=Ig(b);if(!d){break a}v[113382]=0;R(1184,a|0,d|0);e=v[113382];v[113382]=0;if((e|0)!=1){e=v[b+4>>2];b=v[b>>2];v[113382]=0;X(1185,a|0,b|0,e|0,d|0);b=v[113382];v[113382]=0;if((b|0)!=1){break a}}a=P()|0;O()|0;Dy(f);S(a|0);L()}jb=c+16|0;return a|0}function kS(a){var b=0;a:{if((w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24))!=-28490681|w[a+68|0]!=13|(w[a+69|0]!=10|w[a+70|0]!=26)){break a}if(w[a+76|0]|((w[a+71|0]|w[a+72|0]<<8|(w[a+73|0]<<16|w[a+74|0]<<24))!=1397116231|w[a+75|0]!=1)){break a}a=a+116|0;if((w[a|0]|w[a+1|0]<<8)>>>0>=10){break a}b=(w[a|0]|w[a+1|0]<<8)!=0}return b}function pca(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=jb-16|0;jb=d;v[d+12>>2]=c>>>2;v[d+8>>2]=v[a>>2];e=v[Lb(d+12|0,d+8|0)>>2];b=Eb(b);if(e){a=v[a+20>>2];c=e;while(1){f=a,g=Eb(w[b|0])|Eb(w[b+1|0])<<8,u[f>>1]=g;f=a,g=Eb(w[b+2|0])|Eb(w[b+3|0])<<8,u[f+2>>1]=g;a=a+4|0;b=b+4|0;c=c-1|0;if(c){continue}break}}jb=d+16|0;return e<<2}function mca(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=jb-16|0;jb=d;v[d+12>>2]=c>>>2;v[d+8>>2]=v[a>>2];e=v[Lb(d+12|0,d+8|0)>>2];b=Eb(b);if(e){a=v[a+20>>2];c=e;while(1){f=a,g=Eb(w[b+1|0])|Eb(w[b|0])<<8,u[f>>1]=g;f=a,g=Eb(w[b+3|0])|Eb(w[b+2|0])<<8,u[f+2>>1]=g;a=a+4|0;b=b+4|0;c=c-1|0;if(c){continue}break}}jb=d+16|0;return e<<2}function VI(a){a=a|0;var b=0,c=0;c=jb-16|0;jb=c;b=(Ue(v[a+16>>2])|0)/5|0;b=zc(b,b>>31);v[a+4272>>2]=b;v[113382]=0;v[c+12>>2]=0;U(1617,a+4256|0,b<<1,c+12|0);b=v[113382];v[113382]=0;a:{if((b|0)==1){b=V(66740)|0;if((O()|0)!=(ga(66740)|0)){break a}_(b|0)|0;v[a+4272>>2]=0;$()}v[a+4276>>2]=0;v[a+4268>>2]=0;jb=c+16|0;return}S(b|0);L()}function Aga(a,b){a=a|0;b=b|0;var c=0,d=0;d=jb-16|0;jb=d;c=d;v[c>>2]=a;a=v[a+4>>2];v[c+4>>2]=a;v[c+8>>2]=a+B(b,9);a=v[c+4>>2];b=v[c+8>>2];if((a|0)!=(b|0)){while(1){t[a|0]=0;t[a+1|0]=0;t[a+2|0]=0;t[a+3|0]=0;t[a+4|0]=0;t[a+5|0]=0;t[a+6|0]=0;t[a+7|0]=0;t[a+8|0]=0;a=a+9|0;v[c+4>>2]=a;if((a|0)!=(b|0)){continue}break}}Mb(c);jb=d+16|0}function $ca(){var a=0,b=0,c=0,d=0;c=jb-16|0;jb=c;b=Pe(1);v[113382]=0;d=T(85,b|0)|0;a=v[113382];v[113382]=0;if((a|0)!=1){a=jb-16|0;jb=a;v[113382]=0;v[a+12>>2]=d;b=c+8|0;W(90,b|0,a+12|0,a+8|0)|0;d=v[113382];v[113382]=0;a:{if((d|0)!=1){jb=a+16|0;break a}V(0)|0;O()|0;Ab();L()}jb=c+16|0;return v[b>>2]}a=P()|0;O()|0;Wb(b);S(a|0);L()}function dP(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=jb-16|0;jb=c;zb(b);f=bP(a,c+8|0);a:{d=wc(b);if(!d){break a}v[113382]=0;R(526,a|0,d|0);e=v[113382];v[113382]=0;if((e|0)!=1){e=v[b+4>>2];b=v[b>>2];v[113382]=0;X(954,a|0,b|0,e|0,d|0);b=v[113382];v[113382]=0;if((b|0)!=1){break a}}a=P()|0;O()|0;rq(f);S(a|0);L()}jb=c+16|0;return a|0}function cka(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=jb-16|0;jb=d;Ee(b);v[d+12>>2]=0;a:{if(!Fi(a,d+12|0)){break a}f=c;c=v[d+12>>2];if(f>>>0<c>>>0){break a}if(!c){e=1;break a}c=0;while(1){b:{t[d+11|0]=0;if(!$g(a,d+11|0)){break b}Tl(b,t[d+11|0]);e=1;c=c+1|0;if((c|0)!=v[d+12>>2]){continue}break a}break}e=0}jb=d+16|0;return e|0}function PI(a){var b=C(0),c=0,d=C(0),e=0;b=z[a+4224>>2];z[a+4260>>2]=K(C(C(1)-C(b*b)));t[a+4264|0]=z[a+4236>>2]>C(.5);c=a;d=C(v[a+4256>>2]<<1>>>0);b=C(z[a+4228>>2]*d);a:{if(b<C(4294967296)&b>=C(0)){e=~~b>>>0;break a}e=0}v[c+4248>>2]=e;c=a+4252|0;b=C(z[a+4232>>2]*d);b:{if(b<C(4294967296)&b>=C(0)){a=~~b>>>0;break b}a=0}v[c>>2]=a}function gq(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;e=jb-16|0;jb=e;a:{d=Uh(e,a,b);b=v[d+4>>2];g=v[d+8>>2];if((b|0)!=(g|0)){while(1){f=zb(a);v[113382]=0;U(347,f|0,b|0,c|0);f=v[113382];v[113382]=0;if((f|0)==1){break a}b=b+2|0;v[d+4>>2]=b;if((b|0)!=(g|0)){continue}break}}Mb(d);jb=e+16|0;return}a=P()|0;O()|0;Mb(d);S(a|0);L()}function bA(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;e=jb-16|0;jb=e;a:{d=Tp(e,a,b);b=v[d+4>>2];g=v[d+8>>2];if((b|0)!=(g|0)){while(1){f=zb(a);v[113382]=0;U(670,f|0,b|0,c|0);f=v[113382];v[113382]=0;if((f|0)==1){break a}b=b+6|0;v[d+4>>2]=b;if((b|0)!=(g|0)){continue}break}}Mb(d);jb=e+16|0;return}a=P()|0;O()|0;Mb(d);S(a|0);L()}function aka(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=jb-16|0;jb=d;Ee(b);t[d+15|0]=0;a:{if(!$g(a,d+15|0)){break a}f=c;c=w[d+15|0];if(f>>>0<c>>>0){break a}if(!c){e=1;break a}c=0;while(1){b:{t[d+14|0]=0;if(!$g(a,d+14|0)){break b}Tl(b,t[d+14|0]);e=1;c=c+1|0;if(w[d+15|0]!=(c&255)){continue}break a}break}e=0}jb=d+16|0;return e|0}function Sp(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;e=jb-16|0;jb=e;a:{d=Li(e,a,b);b=v[d+4>>2];g=v[d+8>>2];if((b|0)!=(g|0)){while(1){f=zb(a);v[113382]=0;U(534,f|0,b|0,c|0);f=v[113382];v[113382]=0;if((f|0)==1){break a}b=b+1|0;v[d+4>>2]=b;if((b|0)!=(g|0)){continue}break}}Mb(d);jb=e+16|0;return}a=P()|0;O()|0;Mb(d);S(a|0);L()}function GU(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;e=jb-16|0;jb=e;a:{d=Li(e,a,b);b=v[d+4>>2];g=v[d+8>>2];if((b|0)!=(g|0)){while(1){f=zb(a);v[113382]=0;U(332,f|0,b|0,c|0);f=v[113382];v[113382]=0;if((f|0)==1){break a}b=b+1|0;v[d+4>>2]=b;if((b|0)!=(g|0)){continue}break}}Mb(d);jb=e+16|0;return}a=P()|0;O()|0;Mb(d);S(a|0);L()}function DB(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;e=jb-16|0;jb=e;a:{d=oe(e,a,b);b=v[d+4>>2];g=v[d+8>>2];if((b|0)!=(g|0)){while(1){f=zb(a);v[113382]=0;U(372,f|0,b|0,c|0);f=v[113382];v[113382]=0;if((f|0)==1){break a}b=b+4|0;v[d+4>>2]=b;if((b|0)!=(g|0)){continue}break}}Mb(d);jb=e+16|0;return}a=P()|0;O()|0;Mb(d);S(a|0);L()}function AU(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=b+18|0;b=b+46|0;a=Yc(a,w[d|0]&2?16:8,1,0,(w[b|0]^-1)&1);if(!(!(w[d|0]&4)|c>>>0<532)){aC(a)}a:{b:{if(w[d|0]&8){b=w[b|0]&4?5:4;break b}if(!(w[d|0]&2|w[b|0]!=255)){b=11;break b}if(w[b|0]&2){t[a+2|0]=1}if(w[b|0]&4){Zl(a,2)}if(!(w[b|0]&8)){break a}b=9;if(!(w[d|0]&2)){break a}}Zl(a,b)}}function tw(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0;g=jb-240|0;jb=g;v[g>>2]=a;h=1;a:{if((c|0)<2){break a}e=a;while(1){e=e-4|0;i=c-2|0;f=e-v[(i<<2)+d>>2]|0;if((nb[b|0](a,f)|0)>=0){if((nb[b|0](a,e)|0)>=0){break a}}j=f;f=(nb[b|0](f,e)|0)>=0;e=f?j:e;v[(h<<2)+g>>2]=e;h=h+1|0;c=f?c-1|0:i;if((c|0)>1){continue}break}}hG(g,h);jb=g+240|0}function Im(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=Sr(a+60|0);v[a>>2]=66072;v[d>>2]=66092;v[113382]=0;e=a+8|0;W(152,a|0,66104,e|0)|0;f=v[113382];v[113382]=0;if((f|0)!=1){a:{v[a>>2]=66072;v[d>>2]=66092;v[113382]=0;W(153,e|0,b|0,c|8)|0;b=v[113382];v[113382]=0;if((b|0)==1){break a}return a|0}}a=P()|0;O()|0;_g(d);S(a|0);L()}function FV(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=jb-32|0;jb=d;b=zf(d,b);v[113382]=0;U(223,d+16|0,b|0,c|0);e=v[113382];v[113382]=0;a:{b:{if((e|0)!=1){v[113382]=0;U(5,a|0,d+16|0,c|0);a=v[113382];v[113382]=0;if((a|0)==1){break b}yb(d+16|0);yb(b);jb=d+32|0;return}a=P()|0;O()|0;break a}a=P()|0;O()|0;yb(d+16|0)}yb(b);S(a|0);L()}function lP(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=jb-32|0;jb=d;f=d+8|0;g=f;h=b;if(zA(b,d+24|0)){e=hz(d+24|0)}td(g,h,e);a=yA(a,d+24|0,f);Bb(f);a:{if(!c){break a}e=(e>>>0)%(c>>>0)|0;if(!e){break a}v[113382]=0;Q(304,b|0,c-e|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){break a}b=P()|0;O()|0;lf(a);S(b|0);L()}jb=d+32|0}function hG(a,b){var c=0,d=0,e=0,f=0,g=0,h=0;d=4;e=jb-256|0;jb=e;a:{if((b|0)<2){break a}h=(b<<2)+a|0;v[h>>2]=e;c=e;while(1){f=d>>>0<256?d:256;lc(c,v[a>>2],f);c=0;while(1){g=(c<<2)+a|0;c=c+1|0;lc(v[g>>2],v[(c<<2)+a>>2],f);v[g>>2]=v[g>>2]+f;if((b|0)!=(c|0)){continue}break}d=d-f|0;if(!d){break a}c=v[h>>2];continue}}jb=e+256|0}function Gha(a,b){a=a|0;b=b|0;var c=0;b=jb-32|0;jb=b;c=-1;a:{if(!nA(a,b+16|0)){break a}c=0;if(!pP(b+16|0)){break a}c=-1;if(!Ij(a,b+8|0)){break a}a=b+8|4;c=0;if(!(w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24))){break a}a=b+8|0;a=w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24);c=(a&2139062143)==(a|0)}a=c;jb=b+32|0;return a|0}function x3(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=jb-16|0;jb=d;a:{if(!(w[c+1|0]&4)){break a}c=v[c+4>>2];g=d,h=Bd(b),v[g+8>>2]=h;b:{if(!Db(b)){break b}if(w[kc(b,0)|0]!=43){if(w[kc(b,0)|0]!=45){break b}}Nw(d+8|0);c=c+1|0}if(Db(b)>>>0>=c>>>0){break a}e=Hd(d,d+8|0);f=Db(b);Ow(b,v[e>>2],c-f|0,48)}rd(a,b);jb=d+16|0}function uS(a){var b=0;b=jb-16|0;jb=b;t[a|0]=0;t[a+1|0]=0;t[a+2|0]=0;t[a+3|0]=0;t[a+4|0]=0;t[a+5|0]=0;t[a+6|0]=0;t[a+7|0]=0;t[a+14|0]=0;t[a+15|0]=0;t[a+16|0]=0;t[a+17|0]=0;t[a+18|0]=0;t[a+19|0]=0;t[a+20|0]=0;t[a+21|0]=0;t[a+8|0]=0;t[a+9|0]=0;t[a+10|0]=0;t[a+11|0]=0;t[a+12|0]=0;t[a+13|0]=0;t[a+14|0]=0;t[a+15|0]=0;jb=b+16|0}function qK(a){var b=0;b=jb-16|0;jb=b;t[a|0]=0;t[a+1|0]=0;t[a+2|0]=0;t[a+3|0]=0;t[a+4|0]=0;t[a+5|0]=0;t[a+6|0]=0;t[a+7|0]=0;t[a+16|0]=0;t[a+17|0]=0;t[a+18|0]=0;t[a+19|0]=0;t[a+20|0]=0;t[a+21|0]=0;t[a+22|0]=0;t[a+23|0]=0;t[a+8|0]=0;t[a+9|0]=0;t[a+10|0]=0;t[a+11|0]=0;t[a+12|0]=0;t[a+13|0]=0;t[a+14|0]=0;t[a+15|0]=0;jb=b+16|0}function Zca(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=jb-16|0;jb=d;a:{b=zO(d,a+8|0,b);if(v[b>>2]!=v[b+4>>2]){while(1){c=v[a+16>>2];e=v[b>>2];v[113382]=0;R(1201,c|0,e|0);c=v[113382];v[113382]=0;if((c|0)==1){break a}c=v[b>>2]+12|0;v[b>>2]=c;if((c|0)!=v[b+4>>2]){continue}break}}yc(b);jb=d+16|0;return}a=P()|0;O()|0;yc(b);S(a|0);L()}function xga(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=jb-16|0;jb=d;a:{b=zO(d,a+8|0,b);if(v[b>>2]!=v[b+4>>2]){while(1){c=v[a+16>>2];e=v[b>>2];v[113382]=0;R(988,c|0,e|0);c=v[113382];v[113382]=0;if((c|0)==1){break a}c=v[b>>2]+12|0;v[b>>2]=c;if((c|0)!=v[b+4>>2]){continue}break}}yc(b);jb=d+16|0;return}a=P()|0;O()|0;yc(b);S(a|0);L()}function vja(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=jb-16|0;jb=d;a:{b=uD(d,a+8|0,b);if(v[b>>2]!=v[b+4>>2]){while(1){c=v[a+16>>2];e=v[b>>2];v[113382]=0;R(375,c|0,e|0);c=v[113382];v[113382]=0;if((c|0)==1){break a}c=v[b>>2]+16|0;v[b>>2]=c;if((c|0)!=v[b+4>>2]){continue}break}}yc(b);jb=d+16|0;return}a=P()|0;O()|0;yc(b);S(a|0);L()}function q8(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=jb-16|0;jb=d;a:{b=Sh(d,a+8|0,b);if(v[b>>2]!=v[b+4>>2]){while(1){c=v[a+16>>2];e=v[b>>2];v[113382]=0;R(1622,c|0,e|0);c=v[113382];v[113382]=0;if((c|0)==1){break a}c=v[b>>2]+4|0;v[b>>2]=c;if((c|0)!=v[b+4>>2]){continue}break}}yc(b);jb=d+16|0;return}a=P()|0;O()|0;yc(b);S(a|0);L()}function dja(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=jb-16|0;jb=d;a:{b=Sh(d,a+8|0,b);if(v[b>>2]!=v[b+4>>2]){while(1){c=v[a+16>>2];e=v[b>>2];v[113382]=0;R(785,c|0,e|0);c=v[113382];v[113382]=0;if((c|0)==1){break a}c=v[b>>2]+4|0;v[b>>2]=c;if((c|0)!=v[b+4>>2]){continue}break}}yc(b);jb=d+16|0;return}a=P()|0;O()|0;yc(b);S(a|0);L()}function dW(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=jb-16|0;jb=d;a:{b=uD(d,a+8|0,b);if(v[b>>2]!=v[b+4>>2]){while(1){c=v[a+16>>2];e=v[b>>2];v[113382]=0;R(186,c|0,e|0);c=v[113382];v[113382]=0;if((c|0)==1){break a}c=v[b>>2]+16|0;v[b>>2]=c;if((c|0)!=v[b+4>>2]){continue}break}}yc(b);jb=d+16|0;return}a=P()|0;O()|0;yc(b);S(a|0);L()}function cja(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=jb-16|0;jb=d;a:{b=$l(d,a+8|0,b);if(v[b>>2]!=v[b+4>>2]){while(1){c=v[a+16>>2];e=v[b>>2];v[113382]=0;R(790,c|0,e|0);c=v[113382];v[113382]=0;if((c|0)==1){break a}c=v[b>>2]+2|0;v[b>>2]=c;if((c|0)!=v[b+4>>2]){continue}break}}yc(b);jb=d+16|0;return}a=P()|0;O()|0;yc(b);S(a|0);L()}function Hha(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=jb-16|0;jb=d;a:{b=Sh(d,a+8|0,b);if(v[b>>2]!=v[b+4>>2]){while(1){c=v[a+16>>2];e=v[b>>2];v[113382]=0;R(911,c|0,e|0);c=v[113382];v[113382]=0;if((c|0)==1){break a}c=v[b>>2]+4|0;v[b>>2]=c;if((c|0)!=v[b+4>>2]){continue}break}}yc(b);jb=d+16|0;return}a=P()|0;O()|0;yc(b);S(a|0);L()}function $ja(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=jb-16|0;jb=d;a:{b=Sh(d,a+8|0,b);if(v[b>>2]!=v[b+4>>2]){while(1){c=v[a+16>>2];e=v[b>>2];v[113382]=0;R(701,c|0,e|0);c=v[113382];v[113382]=0;if((c|0)==1){break a}c=v[b>>2]+4|0;v[b>>2]=c;if((c|0)!=v[b+4>>2]){continue}break}}yc(b);jb=d+16|0;return}a=P()|0;O()|0;yc(b);S(a|0);L()}function $8(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=jb-16|0;jb=d;a:{b=Sh(d,a+8|0,b);if(v[b>>2]!=v[b+4>>2]){while(1){c=v[a+16>>2];e=v[b>>2];v[113382]=0;R(1591,c|0,e|0);c=v[113382];v[113382]=0;if((c|0)==1){break a}c=v[b>>2]+4|0;v[b>>2]=c;if((c|0)!=v[b+4>>2]){continue}break}}yc(b);jb=d+16|0;return}a=P()|0;O()|0;yc(b);S(a|0);L()}function zs(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;f=jb-16|0;jb=f;if(b){e=f+8|0;Fb(e,a+1074312|0,73);k=Cb(e)?c- -64|0:c;i=ap(a);l=i^1;c=120;g=1;while(1){e=c>>>1|0;j=e+g|0;h=eg(a,j,k,d);a:{if(!((h>>>0<=b>>>0|i)==1&((h|0)!=0&l|b>>>0<=h>>>0))){g=j+1|0;c=(e^-1)+c|0;break a}c=e}if(c){continue}break}}jb=f+16|0;return g}function wU(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=jb-16|0;jb=d;a:{b=Sh(d,a+8|0,b);if(v[b>>2]!=v[b+4>>2]){while(1){c=v[a+16>>2];e=v[b>>2];v[113382]=0;R(337,c|0,e|0);c=v[113382];v[113382]=0;if((c|0)==1){break a}c=v[b>>2]+4|0;v[b>>2]=c;if((c|0)!=v[b+4>>2]){continue}break}}yc(b);jb=d+16|0;return}a=P()|0;O()|0;yc(b);S(a|0);L()}function nha(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;if(w[a+40|0]){e=0}else{d=v[a+28>>2];if(!d){t[a+40|0]=1;return 0}a:{if(!c){break a}d=nb[d|0](v[a+24>>2],b,c)|0;if(d){while(1){e=d+e|0;f=e>>>0<d>>>0?f+1|0:f;c=c-d|0;if(!c){break a}b=b+d|0;d=nb[v[a+28>>2]](v[a+24>>2],b,c)|0;if(d){continue}break}}t[a+40|0]=1}}return e|0}function h9(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=C(0),f=0,g=0,h=C(0);c=jb-32|0;jb=c;Mj(a,c+24|0);f=c,g=dd(v[c+24>>2],v[c+28>>2]),v[f+16>>2]=g;v[c+12>>2]=256;ql(b,v[Lb(c+16|0,c+12|0)>>2]);if(Kb(b)){while(1){v[c+16>>2]=0;No(a,c+16|0);e=z[c+16>>2];f=Pb(b,d),h=e,z[f>>2]=h;d=d+1|0;if(Kb(b)>>>0>d>>>0){continue}break}}jb=c+32|0}function ega(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=jb-16|0;jb=d;a:{b=at(d,a+8|0,b);if(v[b>>2]!=v[b+4>>2]){while(1){c=v[a+16>>2];e=v[b>>2];v[113382]=0;R(38,c|0,e|0);c=v[113382];v[113382]=0;if((c|0)==1){break a}c=v[b>>2]+1|0;v[b>>2]=c;if((c|0)!=v[b+4>>2]){continue}break}}yc(b);jb=d+16|0;return}a=P()|0;O()|0;yc(b);S(a|0);L()}function aW(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=jb-16|0;jb=d;a:{b=at(d,a+8|0,b);if(v[b>>2]!=v[b+4>>2]){while(1){c=v[a+16>>2];e=v[b>>2];v[113382]=0;R(188,c|0,e|0);c=v[113382];v[113382]=0;if((c|0)==1){break a}c=v[b>>2]+1|0;v[b>>2]=c;if((c|0)!=v[b+4>>2]){continue}break}}yc(b);jb=d+16|0;return}a=P()|0;O()|0;yc(b);S(a|0);L()}function ZT(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=jb-16|0;jb=d;a:{b=$l(d,a+8|0,b);if(v[b>>2]!=v[b+4>>2]){while(1){c=v[a+16>>2];e=v[b>>2];v[113382]=0;R(376,c|0,e|0);c=v[113382];v[113382]=0;if((c|0)==1){break a}c=v[b>>2]+2|0;v[b>>2]=c;if((c|0)!=v[b+4>>2]){continue}break}}yc(b);jb=d+16|0;return}a=P()|0;O()|0;yc(b);S(a|0);L()}function XT(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=jb-16|0;jb=d;a:{b=$l(d,a+8|0,b);if(v[b>>2]!=v[b+4>>2]){while(1){c=v[a+16>>2];e=v[b>>2];v[113382]=0;R(380,c|0,e|0);c=v[113382];v[113382]=0;if((c|0)==1){break a}c=v[b>>2]+2|0;v[b>>2]=c;if((c|0)!=v[b+4>>2]){continue}break}}yc(b);jb=d+16|0;return}a=P()|0;O()|0;yc(b);S(a|0);L()}function HU(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=jb-16|0;jb=d;a:{b=at(d,a+8|0,b);if(v[b>>2]!=v[b+4>>2]){while(1){c=v[a+16>>2];e=v[b>>2];v[113382]=0;R(331,c|0,e|0);c=v[113382];v[113382]=0;if((c|0)==1){break a}c=v[b>>2]+1|0;v[b>>2]=c;if((c|0)!=v[b+4>>2]){continue}break}}yc(b);jb=d+16|0;return}a=P()|0;O()|0;yc(b);S(a|0);L()}function Xx(a,b){var c=0,d=0,e=0;HQ(a);Fl(a,b);v[a>>2]=v[b>>2];v[a+4>>2]=v[b+4>>2];c=v[zb(b)>>2];d=zb(a),e=c,v[d>>2]=e;d=zb(b),e=0,v[d>>2]=e;v[b>>2]=0;v[b+4>>2]=0;t[a+12|0]=w[b+12|0];c=w[b+13|0]|w[b+14|0]<<8|(w[b+15|0]<<16|w[b+16|0]<<24);t[a+13|0]=c;t[a+14|0]=c>>>8;t[a+15|0]=c>>>16;t[a+16|0]=c>>>24;t[a+17|0]=w[b+17|0]}function NM(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;f=jb-16|0;jb=f;a:{if(oc(jp(a))>>>0<=b>>>0){break a}b:{c:{if(xc(a)>>>0>b>>>0){if(y[od(a,b)+4>>2]>c>>>0){break c}}if(!d){break a}Ay(a,b,c,1);break b}e=f+8|0;_d(e,od(a,b),c);e=Cb(e);if(e|!d){break a}d=f+8|0;_d(d,od(a,b),c);ce(d,1);OM(a,b,c)}e=0}jb=f+16|0;return e|0}function H7(a){a=a|0;var b=0,c=0;c=jb-16|0;jb=c;b=Ue(v[a+16>>2]);b=zc(rma(qma(b,b>>31,3840,0),mb,1e3,0),mb);v[a+4276>>2]=b;v[113382]=0;v[c+12>>2]=0;U(1617,a+4260|0,b|0,c+12|0);b=v[113382];v[113382]=0;a:{if((b|0)==1){b=V(66740)|0;if((O()|0)!=(ga(66740)|0)){break a}_(b|0)|0;v[a+4276>>2]=0;$()}jb=c+16|0;return}S(b|0);L()}function DP(a){var b=0,c=0,d=0,e=0,f=0,g=0;b=v[a>>2];a:{if(!b){break a}c=v[a+8>>2];if(!c){break a}d=v[a+12>>2];if(!d){break a}e=nb[d|0](b)|0;a=mb;f=a;if((a|0)<0){break a}a=0;b:{if((nb[c|0](b,0,0,0)|0)<0){break b}a=0;if((nb[c|0](b,0,0,2)|0)<0){break b}nb[d|0](b)|0;a=mb;a=(a|0)>0|(a|0)>=0}g=a;nb[c|0](b,e,f,0)|0}return g}function eda(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=jb-16|0;jb=d;a:{c=om(d,a,b);b=v[c+4>>2];f=v[c+8>>2];if((b|0)!=(f|0)){while(1){e=zb(a);v[113382]=0;R(1194,e|0,b|0);e=v[113382];v[113382]=0;if((e|0)==1){break a}b=b+16|0;v[c+4>>2]=b;if((b|0)!=(f|0)){continue}break}}Mb(c);jb=d+16|0;return}a=P()|0;O()|0;Mb(c);S(a|0);L()}function Wc(a,b){var c=0,d=0,e=0,f=0,g=0;d=b;b=NF(b);e=jb-16|0;jb=e;c=oo(a);a:{if(c>>>0>=b>>>0){f=Tb(a);g=f;c=b;b:{c:{if(b){v[113382]=0;QD(g,d,c);d=v[113382];v[113382]=0;if((d|0)==1){break c}}break b}V(0)|0;O()|0;Ab();L()}v[e+12>>2]=0;Te((b<<2)+f|0,e+12|0);Vg(a,b);break a}f=a;a=Db(a);LD(f,c,b-c|0,a,0,a,b,d)}jb=e+16|0}function UB(a,b){var c=0,d=0,e=0,f=0;c=jb-16|0;jb=c;a:{if(!b){break a}if(!Rb(a,b)){break a}while(1){t[c+11|0]=0;f=(c+12|0)+d|0;if(b>>>0>d>>>0){_f(a,c+11|0);e=w[c+11|0]}else{e=0}t[f|0]=e;d=d+1|0;if((d|0)!=4){continue}break}v[c+4>>2]=v[c+12>>2];a=c+4|0;d=w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24)}jb=c+16|0;return d}function CW(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;if(rg(a,v[b+8>>2],e)){rv(b,c,d);return}a:{if(!rg(a,v[b>>2],e)){break a}if(!(v[b+16>>2]!=(c|0)&v[b+20>>2]!=(c|0))){if((d|0)!=1){break a}v[b+32>>2]=1;return}v[b+20>>2]=c;v[b+32>>2]=d;v[b+40>>2]=v[b+40>>2]+1;if(!(v[b+36>>2]!=1|v[b+24>>2]!=2)){t[b+54|0]=1}v[b+44>>2]=4}}function zK(a){var b=0,c=0;a:{if((w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24))!=-1641380927){break a}b=a+12|0;if(!(w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24))){break a}b=a+20|0;if(!(w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24))){break a}a=a+28|0;c=(w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24))!=0}return c}function zI(a){var b=0;v[a+4116>>2]=0;v[a+4132>>2]=0;v[a+4136>>2]=0;u[a+4128>>1]=0;v[a+4104>>2]=0;v[a+4108>>2]=0;b=a+4140|0;v[b>>2]=0;v[b+4>>2]=0;b=a+4148|0;v[b>>2]=0;v[b+4>>2]=0;yI(a+4164|0);yI(a+4156|0);Zo(a+54060|0);Zo(a+62252|0);Zo(a+70444|0);Zo(a+78636|0);Qb(a+4332|0,0,32768);Xy(a+37100|0);Qb(a+37612|0,0,16384)}function hda(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=jb-16|0;jb=d;a:{c=zq(d,a,b);b=v[c+4>>2];f=v[c+8>>2];if((b|0)!=(f|0)){while(1){e=zb(a);v[113382]=0;R(1191,e|0,b|0);e=v[113382];v[113382]=0;if((e|0)==1){break a}b=b+8|0;v[c+4>>2]=b;if((b|0)!=(f|0)){continue}break}}Mb(c);jb=d+16|0;return}a=P()|0;O()|0;Mb(c);S(a|0);L()}function bga(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=jb-16|0;jb=d;a:{c=oe(d,a,b);b=v[c+4>>2];f=v[c+8>>2];if((b|0)!=(f|0)){while(1){e=zb(a);v[113382]=0;R(1020,e|0,b|0);e=v[113382];v[113382]=0;if((e|0)==1){break a}b=b+4|0;v[c+4>>2]=b;if((b|0)!=(f|0)){continue}break}}Mb(c);jb=d+16|0;return}a=P()|0;O()|0;Mb(c);S(a|0);L()}function uda(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=jb-16|0;jb=c;v[113382]=0;v[c+12>>2]=0;d=a;W(1162,a|0,c+12|0,c+8|0)|0;e=v[113382];v[113382]=0;a:{if((e|0)!=1){jb=c+16|0;break a}V(0)|0;O()|0;Ab();L()}t[a+530|0]=0;v[113382]=0;R(1161,a|0,b|0);b=v[113382];v[113382]=0;if((b|0)!=1){return a|0}a=P()|0;O()|0;vf(d);S(a|0);L()}function dw(a,b,c,d){var e=0,f=0,g=0,h=0;e=jb-160|0;jb=e;f=e+16|0;Qb(f,0,144);v[e+92>>2]=-1;v[e+60>>2]=b;v[e+24>>2]=-1;v[e+20>>2]=b;Ch(f,0,0);VF(e,f,d,1);d=v[e+8>>2];f=v[e+12>>2];g=v[e>>2];h=v[e+4>>2];if(c){v[c>>2]=((v[e+20>>2]+v[e+136>>2]|0)-v[e+24>>2]|0)+b}v[a>>2]=g;v[a+4>>2]=h;v[a+8>>2]=d;v[a+12>>2]=f;jb=e+160|0}function W5(a){a=a|0;var b=0;v[113382]=0;Z(1984,a|0);b=v[113382];v[113382]=0;if((b|0)!=1){return v[a+16>>2]}b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,2176,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)!=1){$();return-1}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function Fia(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=jb-16|0;jb=d;a:{c=oe(d,a,b);b=v[c+4>>2];f=v[c+8>>2];if((b|0)!=(f|0)){while(1){e=zb(a);v[113382]=0;R(840,e|0,b|0);e=v[113382];v[113382]=0;if((e|0)==1){break a}b=b+4|0;v[c+4>>2]=b;if((b|0)!=(f|0)){continue}break}}Mb(c);jb=d+16|0;return}a=P()|0;O()|0;Mb(c);S(a|0);L()}function Dla(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=jb-16|0;jb=d;a:{c=Tp(d,a,b);b=v[c+4>>2];f=v[c+8>>2];if((b|0)!=(f|0)){while(1){e=zb(a);v[113382]=0;R(532,e|0,b|0);e=v[113382];v[113382]=0;if((e|0)==1){break a}b=b+6|0;v[c+4>>2]=b;if((b|0)!=(f|0)){continue}break}}Mb(c);jb=d+16|0;return}a=P()|0;O()|0;Mb(c);S(a|0);L()}function C9(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=jb-16|0;jb=d;a:{c=Tp(d,a,b);b=v[c+4>>2];f=v[c+8>>2];if((b|0)!=(f|0)){while(1){e=zb(a);v[113382]=0;R(1546,e|0,b|0);e=v[113382];v[113382]=0;if((e|0)==1){break a}b=b+6|0;v[c+4>>2]=b;if((b|0)!=(f|0)){continue}break}}Mb(c);jb=d+16|0;return}a=P()|0;O()|0;Mb(c);S(a|0);L()}function AB(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=jb-16|0;jb=d;a:{c=om(d,a,b);b=v[c+4>>2];f=v[c+8>>2];if((b|0)!=(f|0)){while(1){e=zb(a);v[113382]=0;R(375,e|0,b|0);e=v[113382];v[113382]=0;if((e|0)==1){break a}b=b+16|0;v[c+4>>2]=b;if((b|0)!=(f|0)){continue}break}}Mb(c);jb=d+16|0;return}a=P()|0;O()|0;Mb(c);S(a|0);L()}function xV(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=jb-16|0;jb=d;a:{c=zq(d,a,b);b=v[c+4>>2];f=v[c+8>>2];if((b|0)!=(f|0)){while(1){e=zb(a);v[113382]=0;R(240,e|0,b|0);e=v[113382];v[113382]=0;if((e|0)==1){break a}b=b+8|0;v[c+4>>2]=b;if((b|0)!=(f|0)){continue}break}}Mb(c);jb=d+16|0;return}a=P()|0;O()|0;Mb(c);S(a|0);L()}function vP(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=jb-16|0;jb=d;a:{c=oe(d,a,b);b=v[c+4>>2];f=v[c+8>>2];if((b|0)!=(f|0)){while(1){e=zb(a);v[113382]=0;R(911,e|0,b|0);e=v[113382];v[113382]=0;if((e|0)==1){break a}b=b+4|0;v[c+4>>2]=b;if((b|0)!=(f|0)){continue}break}}Mb(c);jb=d+16|0;return}a=P()|0;O()|0;Mb(c);S(a|0);L()}function pB(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=jb-16|0;jb=d;a:{c=Uh(d,a,b);b=v[c+4>>2];f=v[c+8>>2];if((b|0)!=(f|0)){while(1){e=zb(a);v[113382]=0;R(376,e|0,b|0);e=v[113382];v[113382]=0;if((e|0)==1){break a}b=b+2|0;v[c+4>>2]=b;if((b|0)!=(f|0)){continue}break}}Mb(c);jb=d+16|0;return}a=P()|0;O()|0;Mb(c);S(a|0);L()}function on(a,b,c,d){var e=0,f=0,g=0;a:{e=v[c>>2];f=v[d>>2];if(e|f){if(!b){break a}while(1){v[c>>2]=e-(((-2147483648-e>>>31|0)-1&255)+e>>8);v[d>>2]=v[d>>2]-(((-2147483648-f>>>31|0)-1&255)+f>>8);e=(g<<3)+a|0;v[e>>2]=v[c>>2];v[e+4>>2]=v[d>>2];g=g+1|0;if((g|0)==(b|0)){break a}f=v[d>>2];e=v[c>>2];continue}}dO(a,b<<1)}}function lC(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=jb-16|0;jb=d;a:{c=Li(d,a,b);b=v[c+4>>2];f=v[c+8>>2];if((b|0)!=(f|0)){while(1){e=zb(a);v[113382]=0;R(331,e|0,b|0);e=v[113382];v[113382]=0;if((e|0)==1){break a}b=b+1|0;v[c+4>>2]=b;if((b|0)!=(f|0)){continue}break}}Mb(c);jb=d+16|0;return}a=P()|0;O()|0;Mb(c);S(a|0);L()}function B4(a){a=a|0;var b=0;v[113382]=0;Z(2057,a|0);b=v[113382];v[113382]=0;a:{if((b|0)==1){b=V(0)|0;O()|0;_(b|0)|0;v[113382]=0;X(1958,7972,a|0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();a=0}return a|0}a=P()|0;O()|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;if((b|0)!=1){S(a|0);L()}V(0)|0;O()|0;Ab();L()}function NR(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=jb-16|0;jb=d;a:{c=Li(d,a,b);b=v[c+4>>2];f=v[c+8>>2];if((b|0)!=(f|0)){while(1){e=zb(a);v[113382]=0;R(38,e|0,b|0);e=v[113382];v[113382]=0;if((e|0)==1){break a}b=b+1|0;v[c+4>>2]=b;if((b|0)!=(f|0)){continue}break}}Mb(c);jb=d+16|0;return}a=P()|0;O()|0;Mb(c);S(a|0);L()}function fca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=jb-16|0;jb=e;v[e+12>>2]=c>>>2;v[e+8>>2]=v[a>>2];d=v[Lb(e+12|0,e+8|0)>>2];b=Eb(b);if(d){a=v[a+20>>2];c=d;while(1){Eb(w[b|0]);Eb(w[b+1|0]);f=a,g=Eb(w[b+2|0])|Eb(w[b+3|0])<<8,u[f>>1]=g;a=a+2|0;b=b+4|0;c=c-1|0;if(c){continue}break}}jb=e+16|0;return d<<2}function eca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=jb-16|0;jb=e;v[e+12>>2]=c>>>2;v[e+8>>2]=v[a>>2];d=v[Lb(e+12|0,e+8|0)>>2];b=Eb(b);if(d){a=v[a+20>>2];c=d;while(1){Eb(w[b+3|0]);Eb(w[b+2|0]);f=a,g=Eb(w[b+1|0])|Eb(w[b|0])<<8,u[f>>1]=g;a=a+2|0;b=b+4|0;c=c-1|0;if(c){continue}break}}jb=e+16|0;return d<<2}function ds(a){var b=0,c=0,d=0,e=0;b=Yg(+z[a+4228>>2]*8)*.25+-.25;A[a+4248>>3]=b;if(w[a+4240|0]){e=a;if(b<=45e-5){b=0}else{b=Bo(b)*1.4426950408889634;d=H(b);b=b-d;c=0;a:{if(b<.2075187496394219){break a}c=.4150374992788438;if(b<.5){break a}c=b<.792481250360578?.5849625007211562:1}b=Yg(c+d)*.5}A[e+4248>>3]=b}cs(a)}function Iga(a,b){a=a|0;b=b|0;var c=0,d=0;c=jb-16|0;jb=c;v[a>>2]=0;v[a+4>>2]=0;v[c+12>>2]=0;$t(a+8|0);jb=c+16|0;c=a;a:{if(!b){break a}v[113382]=0;R(980,a|0,b|0);d=v[113382];v[113382]=0;if((d|0)!=1){v[113382]=0;R(981,a|0,b|0);b=v[113382];v[113382]=0;if((b|0)!=1){break a}}a=P()|0;O()|0;bz(c);S(a|0);L()}return a|0}function r6(){var a=0,b=0;v[113382]=0;a=da(1957)|0;b=v[113382];v[113382]=0;a:{if((b|0)==1){a=V(0)|0;O()|0;_(a|0)|0;v[113382]=0;X(1958,5962,0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();a=0}return a|0}b=P()|0;O()|0;v[113382]=0;Y(20);a=v[113382];v[113382]=0;if((a|0)!=1){S(b|0);L()}V(0)|0;O()|0;Ab();L()}function p6(){var a=0,b=0;v[113382]=0;a=da(1961)|0;b=v[113382];v[113382]=0;a:{if((b|0)==1){a=V(0)|0;O()|0;_(a|0)|0;v[113382]=0;X(1958,5990,0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();a=0}return a|0}b=P()|0;O()|0;v[113382]=0;Y(20);a=v[113382];v[113382]=0;if((a|0)!=1){S(b|0);L()}V(0)|0;O()|0;Ab();L()}function d6(){var a=0,b=0;v[113382]=0;a=da(1973)|0;b=v[113382];v[113382]=0;a:{if((b|0)==1){a=V(0)|0;O()|0;_(a|0)|0;v[113382]=0;X(1958,7170,0,0,0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$();a=0}return a|0}b=P()|0;O()|0;v[113382]=0;Y(20);a=v[113382];v[113382]=0;if((a|0)!=1){S(b|0);L()}V(0)|0;O()|0;Ab();L()}function Wla(a,b){a=a|0;b=b|0;var c=0;nt(a,b);vj(b);a=w[b+3|0];a:{if((a|0)!=9){if((a|0)!=19){break a}a=w[b+5|0];c=a&240;if((c|0)!=128){if((c|0)!=64){if((c|0)!=48|a>>>0>49){break a}t[b+5|0]=159;t[b+3|0]=20;return}if((a|0)!=64){break a}t[b+3|0]=0;t[b|0]=254;return}t[b+3|0]=20;t[b+5|0]=a&15|160;return}t[b+3|0]=0}}function Uha(a,b){a=a|0;b=b|0;var c=0;b=jb-16|0;jb=b;c=-1;a:{if(!Ef(a,8)){break a}c=0;if(!gu(a,10053,8)){break a}c=-1;if(!Ij(a,b+8|0)){break a}a=b+8|4;c=0;if(!(w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24))){break a}c=!((w[b+8|0]|w[b+9|0]<<8|(w[b+10|0]<<16|w[b+11|0]<<24))&-2139062144)}a=c;jb=b+16|0;return a|0}function Ly(a,b,c){var d=0,e=0,f=0,g=0;e=jb-16|0;jb=e;a:{d=_n(e,a,b);b=v[d+4>>2];g=v[d+8>>2];if((b|0)!=(g|0)){while(1){f=zb(a);v[113382]=0;U(1141,f|0,b|0,c|0);f=v[113382];v[113382]=0;if((f|0)==1){break a}b=b+32|0;v[d+4>>2]=b;if((b|0)!=(g|0)){continue}break}}Mb(d);jb=e+16|0;return}a=P()|0;O()|0;Mb(d);S(a|0);L()}function JL(a,b,c){var d=0,e=0,f=0,g=0;e=jb-16|0;jb=e;a:{d=Mk(e,a,b);b=v[d+4>>2];g=v[d+8>>2];if((b|0)!=(g|0)){while(1){f=zb(a);v[113382]=0;U(1346,f|0,b|0,c|0);f=v[113382];v[113382]=0;if((f|0)==1){break a}b=b+24|0;v[d+4>>2]=b;if((b|0)!=(g|0)){continue}break}}Mb(d);jb=e+16|0;return}a=P()|0;O()|0;Mb(d);S(a|0);L()}function BN(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a:{switch(c+1|0){case 0:case 3:tN(a,b);return;default:break a}}d=jb-16|0;jb=d;v[d+12>>2]=c;u[d+10>>1]=0;v[d+4>>2]=2;Xk(a,d+10|0,v[Lb(d+12|0,d+4|0)>>2]);a=mb;if((a|0)>0|(a|0)>=0){v[d+4>>2]=2;Lb(d+12|0,d+4|0)}u[d+4>>1]=x[d+10>>1];u[b>>1]=w[d+4|0]|w[d+5|0]<<8;jb=d+16|0}function zJ(a){a=a|0;var b=0,c=0;c=jb-16|0;jb=c;b=v[a+4232>>2];b=(b>>>1)+(b>>>6)|0;v[a+4220>>2]=b;v[113382]=0;v[c+12>>2]=0;U(1617,a+4208|0,b<<1,c+12|0);b=v[113382];v[113382]=0;a:{if((b|0)==1){b=V(66740)|0;if((O()|0)!=(ga(66740)|0)){break a}_(b|0)|0;v[a+4220>>2]=0;$()}v[a+4224>>2]=0;jb=c+16|0;return}S(b|0);L()}function z0(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=jb-16|0;jb=d;a=_F(a,d+8|0);e=Db(b);f=Db(c);b=Tb(b);v[113382]=0;X(165,a|0,b|0,e|0,e+f|0);b=v[113382];v[113382]=0;a:{if((b|0)!=1){b=Tb(c);v[113382]=0;W(166,a|0,b|0,f|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){break a}}b=P()|0;O()|0;yb(a);S(b|0);L()}jb=d+16|0}function tx(a,b,c){var d=0,e=0,f=0,g=0;e=jb-16|0;jb=e;a:{d=oe(e,a,b);b=v[d+4>>2];g=v[d+8>>2];if((b|0)!=(g|0)){while(1){f=zb(a);v[113382]=0;U(1573,f|0,b|0,c|0);f=v[113382];v[113382]=0;if((f|0)==1){break a}b=b+4|0;v[d+4>>2]=b;if((b|0)!=(g|0)){continue}break}}Mb(d);jb=e+16|0;return}a=P()|0;O()|0;Mb(d);S(a|0);L()}function G2(a){a=a|0;var b=0,c=0,d=0;b=jb-32|0;jb=b;a:{b:{if(mi(a)){Ho(b+24|0);break b}c=b+8|0;Nm(c,a);v[113382]=0;c=T(2142,c|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break a}v[b+24>>2]=c;qf(b+8|0)}if(mi(a)){a=a+36|0}else{a=v[b+24>>2]}a=Cd(a);hk(b+24|0);jb=b+32|0;return a|0}a=P()|0;O()|0;qf(b+8|0);S(a|0);L()}function jca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=jb-16|0;jb=e;v[e+12>>2]=(c>>>0)/3;v[e+8>>2]=v[a>>2];d=v[Lb(e+12|0,e+8|0)>>2];b=Eb(b);if(d){a=v[a+20>>2];c=d;while(1){Eb(w[b|0]);f=a,g=Eb(w[b+1|0])|Eb(w[b+2|0])<<8,u[f>>1]=g;a=a+2|0;b=b+3|0;c=c-1|0;if(c){continue}break}}jb=e+16|0;return B(d,3)|0}
function X_(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=jb-32|0;jb=g;h=v[14871];v[g+24>>2]=v[14870];v[g+28>>2]=h;h=v[14869];v[g+16>>2]=v[14868];v[g+20>>2]=h;h=v[14867];v[g+8>>2]=v[14866];v[g+12>>2]=h;h=v[14865];v[g>>2]=v[14864];v[g+4>>2]=h;h=a;a=g+32|0;b=dj(h,b,c,d,e,f,g,a);jb=a;return b|0}function M3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=jb-16|0;jb=c;Nm(c,a);a=b;if(v[a>>2]){Cd(a);xH(a);xp(a);_o(zb(a),v[a>>2],Ye(a));d=zb(a),e=0,v[d>>2]=e;v[a>>2]=0;v[a+4>>2]=0}Fl(b,c);v[b>>2]=v[c>>2];v[b+4>>2]=v[c+4>>2];a=v[zb(c)>>2];d=zb(b),e=a,v[d>>2]=e;d=zb(c),e=0,v[d>>2]=e;v[c>>2]=0;v[c+4>>2]=0;qf(c);jb=c+16|0}function ica(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=jb-16|0;jb=e;v[e+12>>2]=(c>>>0)/3;v[e+8>>2]=v[a>>2];d=v[Lb(e+12|0,e+8|0)>>2];b=Eb(b);if(d){a=v[a+20>>2];c=d;while(1){Eb(w[b+2|0]);f=a,g=Eb(w[b+1|0])|Eb(w[b|0])<<8,u[f>>1]=g;a=a+2|0;b=b+3|0;c=c-1|0;if(c){continue}break}}jb=e+16|0;return B(d,3)|0}function O8(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;c=a;d=jb-96|0;jb=d;RJ(b,d,d+96|0);b=0;while(1){e=b<<3;f=e+c|0;g=d+e|0;e=v[g+4>>2];v[f>>2]=v[g>>2];v[f+4>>2]=e&65535;b=b+1|0;if((b|0)!=12){continue}break}v[c+104>>2]=0;v[c+96>>2]=!(v[c+88>>2]|v[c+92>>2]);v[c+100>>2]=0;jb=d+96|0;v[a+112>>2]=0;return a|0}function tja(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;f=jb+-64|0;jb=f;c=jb-16|0;jb=c;e=c+8|0;g=f+8|0;LQ(e,g);h=Hb(e);d=a;e=hd(d,$b(c,e));if((h|0)==(e|0)){Tc(d,Hb(c+8|0))}jb=c+16|0;c=(e|0)==(h|0);if(!c){MQ(g)}d=-1;a:{if(!c){break a}d=0;if(!YQ(f+8|0)){break a}d=gf(a,b,XQ(f+8|0),mb)}jb=f- -64|0;return d|0}function fla(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;f=jb-112|0;jb=f;c=jb-16|0;jb=c;e=c+8|0;g=f+8|0;nS(e,g);h=Hb(e);d=a;e=hd(d,$b(c,e));if((h|0)==(e|0)){Tc(d,Hb(c+8|0))}jb=c+16|0;c=(e|0)==(h|0);if(!c){oS(g)}d=-1;a:{if(!c){break a}d=0;if(!rS(f+8|0)){break a}d=gf(a,b,qS(f+8|0),mb)}jb=f+112|0;return d|0}function wg(a,b){var c=0,d=0,e=0,f=0,g=0,h=0;d=jb-16|0;jb=d;g=a;h=a;a:{if(!b){b=0;break a}c=b>>31;e=c+b^c;c=E(e);ef(d,e,0,0,0,c+81|0);e=0+v[d+8>>2]|0;c=(v[d+12>>2]^65536)+(16414-c<<16)|0;c=e>>>0<f>>>0?c+1|0:c;f=b&-2147483648|c;c=v[d+4>>2];b=v[d>>2]}v[h>>2]=b;v[g+4>>2]=c;v[a+8>>2]=e;v[a+12>>2]=f;jb=d+16|0}function rU(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;f=jb-512|0;jb=f;c=jb-16|0;jb=c;e=c+8|0;g=f+8|0;MB(e,g);h=Hb(e);d=a;e=hd(d,$b(c,e));if((h|0)==(e|0)){Tc(d,Hb(c+8|0))}jb=c+16|0;c=(e|0)==(h|0);if(!c){NB(g)}d=-1;a:{if(!c){break a}d=0;if(!SB(f+8|0)){break a}d=gf(a,b,RB(f+8|0),mb)}jb=f+512|0;return d|0}function dZ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;f=jb-16|0;jb=f;v[e>>2]=c;a=Pv(f+12|0,0,b,v[a+8>>2]);c=2;a:{if(a+1>>>0<2){break a}b=a-1|0;c=1;if(b>>>0>d-v[e>>2]>>>0){break a}c=f+12|0;while(1){if(b){a=w[c|0];d=v[e>>2];v[e>>2]=d+1;t[d|0]=a;b=b-1|0;c=c+1|0;continue}break}c=0}jb=f+16|0;return c|0}function Aia(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=jb+-64|0;jb=d;b=-1;a:{if(!Ef(a,1084)){break a}yk(a,1080);e=d+60|0;kQ(a,e);c=e;e=jQ(d+40|0);b=0;if(!iQ(c,e)){break a}yk(a,20);b=1;while(1){c=d+8|0;hQ(a,c);f=xz(c)+f|0;c=b&65535;b=b+1|0;if(c>>>0<31){continue}break}b=y[e+4>>2]>=f>>>0}jb=d- -64|0;return b|0}function JD(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=jb-16|0;jb=d;a=ww(a,d+8|0);e=cf(b);f=Db(c);v[113382]=0;X(2827,a|0,b|0,e|0,e+f|0);b=v[113382];v[113382]=0;a:{if((b|0)!=1){b=Tb(c);v[113382]=0;W(2383,a|0,b|0,f|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){break a}}b=P()|0;O()|0;yb(a);S(b|0);L()}jb=d+16|0}function Dca(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=jb-16|0;jb=d;v[d+12>>2]=c>>>1;v[d+8>>2]=v[a>>2];e=v[Lb(d+12|0,d+8|0)>>2];b=Eb(b);if(e){a=v[a+20>>2];c=e;while(1){f=a,g=Eb(w[b|0])^128,t[f|0]=g;f=a,g=Eb(w[b+1|0])^128,t[f+1|0]=g;a=a+2|0;b=b+2|0;c=c-1|0;if(c){continue}break}}jb=d+16|0;return e<<1}function Cca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=jb-16|0;jb=e;v[e+12>>2]=c>>>1;v[e+8>>2]=v[a>>2];f=v[Lb(e+12|0,e+8|0)>>2];b=Eb(b);if(f){a=v[a+20>>2];c=f;g=d;while(1){g=Eb(w[b|0])+g|0;t[a|0]=g;d=Eb(w[b+1|0])+d|0;t[a+1|0]=d;a=a+2|0;b=b+2|0;c=c-1|0;if(c){continue}break}}jb=e+16|0;return f<<1}function xQ(a,b){var c=0,d=0,e=0,f=0,g=0;d=jb-16|0;jb=d;c=a+4|0;a:{if(wc(c)>>>0>=v[a+16>>2]+b>>>0){break a}if(!wc(c)){Gk(c,zz(v[a+16>>2]+b|0,65536));break a}f=d,g=wc(c),v[f+12>>2]=g;e=oQ(d+12|0);a=v[a+16>>2]+b|0;if(e>>>0<a>>>0){Gk(c,zz(a,65536));break a}f=d,g=wc(c),v[f+8>>2]=g;Gk(c,oQ(d+8|0))}jb=d+16|0}function mU(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;f=jb-48|0;jb=f;c=jb-16|0;jb=c;e=c+8|0;g=f+8|0;vB(e,g);h=Hb(e);d=a;e=hd(d,$b(c,e));if((h|0)==(e|0)){Tc(d,Hb(c+8|0))}jb=c+16|0;c=(e|0)==(h|0);if(!c){wB(g)}d=-1;a:{if(!c){break a}d=0;if(!KB(f+8|0)){break a}d=gf(a,b,JB(f+8|0),mb)}jb=f+48|0;return d|0}function X6(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;b=qi(a,b,c,d);v[a+4208>>2]=1017370378;v[a+4212>>2]=0;v[a>>2]=76468;v[113382]=0;W(1609,a+44|0,2,2)|0;c=v[113382];v[113382]=0;a:{if((c|0)==1){break a}v[113382]=0;Z(1610,b|0);c=v[113382];v[113382]=0;if((c|0)==1){break a}return a|0}a=P()|0;O()|0;rf(b);S(a|0);L()}function hma(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=jb-32|0;jb=d;e=d+16|0;Bi(e,d+8|0,c);v[113382]=0;R(480,d|0,e|0);c=v[113382];v[113382]=0;a:{if((c|0)==1){break a}v[113382]=0;U(481,a|0,b|0,d|0);a=v[113382];v[113382]=0;if((a|0)==1){break a}Ib(d+16|0);jb=d+32|0;return}a=P()|0;O()|0;Ib(d+16|0);S(a|0);L()}function ZL(a,b,c){var d=0,e=0,f=0,g=0,h=0;e=v[a+1074416>>2];a=v[a+1074392>>2];t[b+872|0]=w[b+872|0]|8;g=b;d=a?w[b+833|0]:0;h=(c|0)>=0?0-d|0:d;f=(+(a>>>0)+1)*+(c|0)/+(e>>>0);a:{if(D(f)<2147483648){d=~~f;break a}d=-2147483648}v[g+876>>2]=h+(d+v[b+876>>2]|0);c=(a+1|0)==(e|0)?c:d;a=c>>31;t[b+833|0]=a^a+c}function Ov(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;f=jb-16|0;jb=f;h=b;c=NF(b);d=jb-16|0;jb=d;b=a;a:{if(c>>>0<=1073741807){b:{if(c>>>0<=1){Ce(b,c);e=b;break b}g=al(c)+1|0;e=Qj(b,g);Oe(b,e);Gf(b,g);ae(b,c)}yh(e,h,c);v[d+12>>2]=0;Te((c<<2)+e|0,d+12|0);jb=d+16|0;break a}If();L()}jb=f+16|0;return a|0}function FI(a,b,c){var d=0,e=0,f=0,g=0;f=jb-16|0;jb=f;e=Pi(b,c);if(e>>>0<=4294967279){a:{if(e>>>0<=10){Ce(a,e);d=a;break a}g=Wi(e)+1|0;d=Zg(a,g);Oe(a,d);Gf(a,g);ae(a,e)}if((b|0)!=(c|0)){while(1){Rd(d,b);d=d+1|0;b=b+1|0;if((c|0)!=(b|0)){continue}break}}t[f+15|0]=0;Rd(d,f+15|0);jb=f+16|0;return}If();L()}function C1(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;f=jb-16|0;jb=f;v[f+8>>2]=d;d=v[Io(f,f+8|0)>>2];v[113382]=0;ea(1983,a+8|0,b|0,c|0,d|0,e|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){lH(a);b=kH(a+88|0);v[a>>2]=79384;v[b>>2]=79472;ad(f+8|0);jb=f+16|0;return a|0}a=P()|0;O()|0;ad(f+8|0);S(a|0);L()}function Aka(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=jb-32|0;jb=d;e=d+16|0;eA(e,d+8|0,c);v[113382]=0;R(480,d|0,e|0);c=v[113382];v[113382]=0;a:{if((c|0)==1){break a}v[113382]=0;U(481,a|0,b|0,d|0);a=v[113382];v[113382]=0;if((a|0)==1){break a}Ib(d+16|0);jb=d+32|0;return}a=P()|0;O()|0;Ib(d+16|0);S(a|0);L()}function xT(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;f=jb-1968|0;jb=f;c=jb-16|0;jb=c;e=c+8|0;g=f+8|0;KA(e,g);h=Hb(e);d=a;e=hd(d,$b(c,e));if((h|0)==(e|0)){Tc(d,Hb(c+8|0))}jb=c+16|0;c=(e|0)==(h|0);if(!c){LA(g)}d=-1;a:{if(!c){break a}d=0;if(!PA(f+8|0)){break a}d=gf(a,b,1024,0)}jb=f+1968|0;return d|0}function w9(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=jb-48|0;jb=c;d=c+40|0;b=x[b>>1];t[d|0]=b;t[d+1|0]=b>>>8;b=c+16|0;Sk(b,d);b=Eb(v[b>>2]);e=c+8|0;Sk(e,d);b=oi(c+24|0,b,Eb(v[e>>2]+2|0));v[113382]=0;Q(1156,a|0,b|0)|0;a=v[113382];v[113382]=0;if((a|0)!=1){yb(b);jb=c+48|0;return}a=P()|0;O()|0;yb(b);S(a|0);L()}function tz(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=jb-16|0;jb=d;u[d+14>>1]=b;u[d+12>>1]=c;if((b|0)!=(c|0)){b=ac(a);c=bc(a);a=jb-16|0;jb=a;v[a>>2]=c;v[a+8>>2]=b;if(Jb(a+8|0,a)){while(1){if(x[v[a+8>>2]>>1]==x[d+14>>1]){u[v[a+8>>2]>>1]=x[d+12>>1]}b=a+8|0;re(b);if(Jb(b,a)){continue}break}}jb=a+16|0}jb=d+16|0}function $i(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;c=jb-48|0;jb=c;a:{if(!b){b=1;if(wd(a,5)){break a}b=$D(c+32|0);e=v[a+8>>2];f=v[d>>2];v[b+4>>2]=f-e;pf(c,v[a+28>>2]);e=c+16|0;hE(e,c,v[d>>2],v[d+4>>2]);v[b+8>>2]=v[e+8>>2]}v[a>>2]=v[a>>2]|134217728;v[a+20>>2]=v[a+20>>2]+1;b=0}jb=c+48|0;return b|0}function fq(a,b,c,d,e){var f=0,g=0,h=0,i=0,j=0;f=jb-16|0;jb=f;v[f+12>>2]=c;c=f+12|0;tc(c,256);tc(c,65535);h=x[f+12>>1];lg(a,h);if(h){c=0;while(1){g=w[b+c|0];a:{if((g|0)==(d|0)){g=65535;break a}if((e|0)!=(g|0)){break a}g=65534}i=Dj(a,c),j=g,u[i>>1]=j;c=c+1|0;if((h|0)!=(c|0)){continue}break}}jb=f+16|0}function VJ(a){var b=0,c=0,d=0,e=0;b=a;e=v[a+4>>2];a:{while(1){if(v[b+8>>2]==(e|0)){break a}c=v[b+16>>2];d=v[b+8>>2]-52|0;v[b+8>>2]=d;v[113382]=0;R(1406,c|0,d|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}if(v[a>>2]){Vx(v[a+16>>2],v[a>>2],(v[gc(a)>>2]-v[a>>2]|0)/52|0)}}function En(a,b,c,d,e){var f=0,g=0,h=0,i=0,j=0;f=jb-16|0;jb=f;v[f+12>>2]=c;c=f+12|0;tc(c,128);tc(c,65535);h=x[f+12>>1];lg(a,h);if(h){c=0;while(1){g=w[b+c|0];a:{if((g|0)==(d|0)){g=65535;break a}if((e|0)!=(g|0)){break a}g=65534}i=Dj(a,c),j=g,u[i>>1]=j;c=c+1|0;if((h|0)!=(c|0)){continue}break}}jb=f+16|0}function Dea(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=jb-32|0;jb=d;e=d+16|0;Bi(e,d+8|0,c);v[113382]=0;R(71,d|0,e|0);c=v[113382];v[113382]=0;a:{if((c|0)==1){break a}v[113382]=0;U(72,a|0,b|0,d|0);a=v[113382];v[113382]=0;if((a|0)==1){break a}Ib(d+16|0);jb=d+32|0;return}a=P()|0;O()|0;Ib(d+16|0);S(a|0);L()}function iU(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=jb-32|0;jb=d;e=d+16|0;su(e,d+8|0,c);v[113382]=0;R(71,d|0,e|0);c=v[113382];v[113382]=0;a:{if((c|0)==1){break a}v[113382]=0;U(72,a|0,b|0,d|0);a=v[113382];v[113382]=0;if((a|0)==1){break a}Ib(d+16|0);jb=d+32|0;return}a=P()|0;O()|0;Ib(d+16|0);S(a|0);L()}function gR(a){var b=0,c=0,d=0,e=0;b=a;e=v[a+4>>2];a:{while(1){if(v[b+8>>2]==(e|0)){break a}c=v[b+16>>2];d=v[b+8>>2]-33|0;v[b+8>>2]=d;v[113382]=0;R(729,c|0,d|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}if(v[a>>2]){eR(v[a+16>>2],v[a>>2],(v[gc(a)>>2]-v[a>>2]|0)/33|0)}}function eP(a){var b=0,c=0,d=0,e=0;b=a;e=v[a+4>>2];a:{while(1){if(v[b+8>>2]==(e|0)){break a}c=v[b+16>>2];d=v[b+8>>2]-56|0;v[b+8>>2]=d;v[113382]=0;R(951,c|0,d|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}if(v[a>>2]){et(v[a+16>>2],v[a>>2],(v[gc(a)>>2]-v[a>>2]|0)/56|0)}}function Pt(a){var b=0,c=0,d=0,e=0;b=a;e=v[a+4>>2];a:{while(1){if(v[b+8>>2]==(e|0)){break a}c=v[b+16>>2];d=v[b+8>>2]-48|0;v[b+8>>2]=d;v[113382]=0;R(536,c|0,d|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}if(v[a>>2]){CS(v[a+16>>2],v[a>>2],(v[gc(a)>>2]-v[a>>2]|0)/48|0)}}function Oca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=jb-16|0;jb=e;v[e+12>>2]=c>>>1;v[e+8>>2]=v[a>>2];f=v[Lb(e+12|0,e+8|0)>>2];b=Eb(b);if(f){a=v[a+20>>2];c=f;while(1){g=Eb(w[b|0])+d|0;d=g+Eb(w[b+1|0])|0;u[a>>1]=d<<8|g&255;a=a+2|0;b=b+2|0;c=c-1|0;if(c){continue}break}}jb=e+16|0;return f<<1}function OR(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a:{switch(c+1|0){case 0:case 2:zh(a,b);return;default:break a}}d=jb-32|0;jb=d;v[d+28>>2]=c;t[d+27|0]=0;v[d+20>>2]=1;Xk(a,d+27|0,v[Lb(d+28|0,d+20|0)>>2]);a=mb;if((a|0)>0|(a|0)>=0){v[d+16>>2]=1;Lb(d+28|0,d+16|0)}t[d+8|0]=w[d+27|0];t[b|0]=w[d+8|0];jb=d+32|0}function OD(a,b,c){var d=0,e=0,f=0,g=0,h=0;g=jb-16|0;jb=g;d=Db(a);f=Fc(a);a:{if(f-d>>>0>=c>>>0){if(!c){break a}e=Tb(a);h=e;f=d;if(d){am(c+e|0,e,f);b=(b>>>0>=e>>>0?d+e>>>0>b>>>0?c:0:0)+b|0}am(h,b,c);b=c+d|0;Vg(a,b);t[g+15|0]=0;Rd(b+e|0,g+15|0);break a}Yn(a,f,(c+d|0)-f|0,d,0,0,c,b)}jb=g+16|0;return a}function IV(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=jb-32|0;jb=d;e=d+16|0;nm(e,d+8|0,c);v[113382]=0;R(71,d|0,e|0);c=v[113382];v[113382]=0;a:{if((c|0)==1){break a}v[113382]=0;U(72,a|0,b|0,d|0);a=v[113382];v[113382]=0;if((a|0)==1){break a}Ib(d+16|0);jb=d+32|0;return}a=P()|0;O()|0;Ib(d+16|0);S(a|0);L()}function Bm(a,b){var c=0,d=0;c=jb-16|0;jb=c;d=c+8|0;Ac(d,a);v[113382]=0;a=T(2339,d|0)|0;d=v[113382];v[113382]=0;a:{b:{if((d|0)==1){break b}v[113382]=0;aa(2353,a|0,59248,59274,b|0)|0;a=v[113382];v[113382]=0;if((a|0)==1){break b}Ob(c+8|0);jb=c+16|0;break a}a=P()|0;O()|0;Ob(c+8|0);S(a|0);L()}return b}function yt(a){var b=0,c=0,d=0,e=0;b=a;e=v[a+4>>2];a:{while(1){if(v[b+8>>2]==(e|0)){break a}c=v[b+16>>2];d=v[b+8>>2]-6|0;v[b+8>>2]=d;v[113382]=0;R(697,c|0,d|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}if(v[a>>2]){St(v[a+16>>2],v[a>>2],(v[gc(a)>>2]-v[a>>2]|0)/6|0)}}function kba(a){a=a|0;var b=0,c=0,d=0;b=v[a+2496>>2];c=(b+1>>>0)%624|0;d=v[(c<<2)+a>>2];b=B(d&1,-1727483681)^(v[((b+397>>>0)%624<<2)+a>>2]^(d&2147483647|v[(b<<2)+a>>2]&-2147483648)>>>1);v[(v[a+2496>>2]<<2)+a>>2]=b;v[a+2496>>2]=c;a=b^b>>>11;a=a<<7&-1658038656^a;a=a<<15&-272236544^a;return a>>>18^a}function fs(a){var b=0,c=0,d=0,e=0;b=a;e=v[a+4>>2];a:{while(1){if(v[b+8>>2]==(e|0)){break a}c=v[b+16>>2];d=v[b+8>>2]-2048|0;v[b+8>>2]=d;v[113382]=0;R(1621,c|0,d|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}if(v[a>>2]){sJ(v[a+16>>2],v[a>>2],v[gc(a)>>2]-v[a>>2]>>11)}}function li(a){var b=0,c=0,d=0;c=Sr(a+56|0);v[a>>2]=65892;v[c>>2]=65912;v[113382]=0;b=a+4|0;W(148,a|0,65924,b|0)|0;d=v[113382];v[113382]=0;if((d|0)!=1){a:{v[a>>2]=65892;v[c>>2]=65912;v[113382]=0;Q(149,b|0,16)|0;b=v[113382];v[113382]=0;if((b|0)==1){break a}return a}}a=P()|0;O()|0;_g(c);S(a|0);L()}function kia(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=jb-32|0;jb=d;e=d+16|0;NP(e,c);v[113382]=0;R(480,d|0,e|0);c=v[113382];v[113382]=0;a:{if((c|0)==1){break a}v[113382]=0;U(481,a|0,b|0,d|0);a=v[113382];v[113382]=0;if((a|0)==1){break a}Ib(d+16|0);jb=d+32|0;return}a=P()|0;O()|0;Ib(d+16|0);S(a|0);L()}function TC(a){a=a|0;var b=0,c=0;b=bd(a);v[113382]=0;T(244,a+12|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){b=jb-16|0;jb=b;v[113382]=0;v[b+12>>2]=0;W(245,a+28|0,b+12|0,b+8|0)|0;c=v[113382];v[113382]=0;a:{if((c|0)!=1){jb=b+16|0;break a}V(0)|0;O()|0;Ab();L()}return a|0}a=P()|0;O()|0;yb(b);S(a|0);L()}function Eca(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=jb-16|0;jb=d;v[d+12>>2]=c>>>1;v[d+8>>2]=v[a>>2];e=v[Lb(d+12|0,d+8|0)>>2];b=Eb(b);if(e){a=v[a+20>>2];c=e;while(1){f=a,g=cn(w[b|0]),t[f|0]=g;f=a,g=cn(w[b+1|0]),t[f+1|0]=g;a=a+2|0;b=b+2|0;c=c-1|0;if(c){continue}break}}jb=d+16|0;return e<<1}function md(a,b,c){var d=0,e=0;a:{b:{if(c>>>0>=4){if((a|b)&3){break b}while(1){if(v[a>>2]!=v[b>>2]){break b}b=b+4|0;a=a+4|0;c=c-4|0;if(c>>>0>3){continue}break}}if(!c){break a}}while(1){d=w[a|0];e=w[b|0];if((d|0)==(e|0)){b=b+1|0;a=a+1|0;c=c-1|0;if(c){continue}break a}break}return d-e|0}return 0}function lM(a,b,c,d){var e=0,f=0;f=jb-16|0;jb=f;e=-2147483648;e=!c|!(t[c+15|0]&1)?e:v[c+8>>2];a:{b:{if(!(!d|!(w[d+34|0]&32))){e=x[d+28>>1];break b}if((e|0)==-2147483648){break a}}$s(b,e,a);c=f+8|0;Fb(c,a+1074312|0,10);if(!Cb(c)|v[a+480208>>2]&16384){break a}v[b+88>>2]=v[b+88>>2]&-257}jb=f+16|0}function dha(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;d=jb-608|0;jb=d;f=jb-16|0;jb=f;c=d;e=f+8|0;TO(e,d);h=Hb(e);g=a;e=hd(g,$b(f,e));if((h|0)==(e|0)){Tc(g,Hb(f+8|0))}jb=f+16|0;g=(e|0)==(h|0);if(!g){UO(c)}c=-1;a:{if(!g){break a}c=0;if(!WO(d)){break a}c=gf(a,b,VO(d),mb)}jb=d+608|0;return c|0}function de(a){var b=C(0),c=C(0),d=0,e=0;d=(p(a),j(2));e=d>>>23&255;if(e>>>0<=149){if(e>>>0<=125){return C(a*C(0))}a=(d|0)>=0?a:C(-a);b=C(C(C(a+C(8388608))+C(-8388608))-a);a:{if(b>C(.5)){c=C(C(a+b)+C(-1));break a}a=C(a+b);c=a;if(!(b<=C(-.5))){break a}c=C(a+C(1))}a=c;a=(d|0)>=0?a:C(-a)}return a}function bla(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;d=jb-576|0;jb=d;f=jb-16|0;jb=f;c=d;e=f+8|0;bS(e,d);h=Hb(e);g=a;e=hd(g,$b(f,e));if((h|0)==(e|0)){Tc(g,Hb(f+8|0))}jb=f+16|0;g=(e|0)==(h|0);if(!g){cS(c)}c=-1;a:{if(!g){break a}c=0;if(!fS(d)){break a}c=gf(a,b,eS(d),mb)}jb=d+576|0;return c|0}function Tka(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;d=jb-192|0;jb=d;f=jb-16|0;jb=f;c=d;e=f+8|0;$p(e,d);h=Hb(e);g=a;e=hd(g,$b(f,e));if((h|0)==(e|0)){Tc(g,Hb(f+8|0))}jb=f+16|0;g=(e|0)==(h|0);if(!g){xR(c)}c=-1;a:{if(!g){break a}c=0;if(!aS(d)){break a}c=gf(a,b,$R(d),mb)}jb=d+192|0;return c|0}function Sla(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=jb-32|0;jb=d;e=d+16|0;$A(e,c);v[113382]=0;R(71,d|0,e|0);c=v[113382];v[113382]=0;a:{if((c|0)==1){break a}v[113382]=0;U(72,a|0,b|0,d|0);a=v[113382];v[113382]=0;if((a|0)==1){break a}Ib(d+16|0);jb=d+32|0;return}a=P()|0;O()|0;Ib(d+16|0);S(a|0);L()}function yda(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;gm(a);h=zb(a);f=b+4|0;d=f;c=v[a+4>>2];g=v[a>>2];if((c|0)!=(g|0)){e=v[d>>2];while(1){c=c-32|0;uN(h,e-32|0,c);e=v[d>>2]-32|0;v[d>>2]=e;if((c|0)!=(g|0)){continue}break}}dc(a,f);dc(a+4|0,b+8|0);dc(zb(a),gc(b));v[b>>2]=v[b+4>>2];Bq(a,ue(a))}function wja(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;Nh(a);h=zb(a);f=b+4|0;d=f;c=v[a+4>>2];g=v[a>>2];if((c|0)!=(g|0)){e=v[d>>2];while(1){c=c-24|0;$Q(h,e-24|0,c);e=v[d>>2]-24|0;v[d>>2]=e;if((c|0)!=(g|0)){continue}break}}dc(a,f);dc(a+4|0,b+8|0);dc(zb(a),gc(b));v[b>>2]=v[b+4>>2];Yt(a,Cd(a))}function TB(a,b){var c=0,d=0,e=0,f=0;c=jb-16|0;jb=c;a:{if(!b){break a}if(!Rb(a,b)){break a}f=1;while(1){t[c+13|0]=0;e=(c+14|0)+d|0;if(b>>>0>d>>>0){_f(a,c+13|0);d=w[c+13|0]}else{d=0}t[e|0]=d;d=1;e=f;f=0;if(e){continue}break}u[c+10>>1]=x[c+14>>1];a=c+10|0;d=w[a|0]|w[a+1|0]<<8}jb=c+16|0;return d}function OI(a){a=a|0;var b=0,c=0;c=jb-16|0;jb=c;b=v[a+4256>>2];v[a+4240>>2]=b<<1;v[113382]=0;v[c+12>>2]=0;U(1617,a+4208|0,b<<2,c+12|0);b=v[113382];v[113382]=0;a:{if((b|0)==1){b=V(66740)|0;if((O()|0)!=(ga(66740)|0)){break a}_(b|0)|0;v[a+4240>>2]=0;$()}v[a+4244>>2]=0;jb=c+16|0;return}S(b|0);L()}function Ay(a,b,c,d){var e=0,f=0;f=jb-16|0;jb=f;e=jp(a);a:{if(oc(e)>>>0<=b>>>0){break a}if(By(a,x[rc(e,b)>>1])>>>0<=c>>>0){break a}b:{if(xc(a)>>>0>b>>>0){if(y[od(a,b)+4>>2]>c>>>0){break b}}tk(a,0);if(xc(a)>>>0<=b>>>0){break a}}e=f+8|0;_d(e,od(a,b),c);ce(e,d);if(!d){break a}OM(a,b,c)}jb=f+16|0}function s6(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;e=jb-16|0;jb=e;f=Pi(b,c);d=Fc(a);if(f>>>0>d>>>0){g=d;h=f-d|0;d=Db(a);Rl(a,g,h,d,0,d,0)}d=Tb(a);if((b|0)!=(c|0)){while(1){Rd(d,b);d=d+1|0;b=b+1|0;if((c|0)!=(b|0)){continue}break}}t[e+15|0]=0;Rd(d,e+15|0);Vg(a,f);jb=e+16|0;return a|0}function oga(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;d=jb-80|0;jb=d;f=jb-16|0;jb=f;c=d;e=f+8|0;rR(e,d);h=Hb(e);g=a;e=hd(g,$b(f,e));if((h|0)==(e|0)){Tc(g,Hb(f+8|0))}jb=f+16|0;g=(e|0)==(h|0);if(!g){sR(c)}c=-1;a:{if(!g){break a}c=0;if(!tO(d)){break a}c=gf(a,b,sO(d),mb)}jb=d+80|0;return c|0}function mV(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;gm(a);h=zb(a);f=b+4|0;d=f;c=v[a+4>>2];g=v[a>>2];if((c|0)!=(g|0)){e=v[d>>2];while(1){c=c-32|0;OC(h,e-32|0,c);e=v[d>>2]-32|0;v[d>>2]=e;if((c|0)!=(g|0)){continue}break}}dc(a,f);dc(a+4|0,b+8|0);dc(zb(a),gc(b));v[b>>2]=v[b+4>>2];Bq(a,ue(a))}function lO(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=jb-16|0;jb=c;d=v[b+4>>2];v[c+8>>2]=v[b>>2];v[c+12>>2]=d;e=c,f=Db(a),v[e+4>>2]=f;v[c>>2]=v[c+12>>2];a=Sm(Tb(a),v[c+8>>2],v[Lb(c+4|0,c)>>2]);a:{if(a){break a}a=-1;b=v[c>>2];d=v[c+4>>2];if(b>>>0>d>>>0){break a}a=b>>>0<d>>>0}jb=c+16|0;return a|0}function fF(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;fj(a);h=zb(a);f=b+4|0;d=f;c=v[a+4>>2];g=v[a>>2];if((c|0)!=(g|0)){e=v[d>>2];while(1){c=c-12|0;Uv(h,e-12|0,c);e=v[d>>2]-12|0;v[d>>2]=e;if((c|0)!=(g|0)){continue}break}}dc(a,f);dc(a+4|0,b+8|0);dc(zb(a),gc(b));v[b>>2]=v[b+4>>2];to(a,xc(a))}function Y1(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=jb-32|0;jb=c;bo(a);v[a>>2]=78992;e=gc(a);v[113382]=0;d=v[b+12>>2];v[c+16>>2]=v[b+8>>2];v[c+20>>2]=d;d=v[b+4>>2];v[c+8>>2]=v[b>>2];v[c+12>>2]=d;Q(2172,e|0,c+8|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){jb=c+32|0;return a|0}a=P()|0;O()|0;S(a|0);L()}function Wp(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;Nh(a);h=zb(a);f=b+4|0;d=f;c=v[a+4>>2];g=v[a>>2];if((c|0)!=(g|0)){e=v[d>>2];while(1){c=c-24|0;Xp(h,e-24|0,c);e=v[d>>2]-24|0;v[d>>2]=e;if((c|0)!=(g|0)){continue}break}}dc(a,f);dc(a+4|0,b+8|0);dc(zb(a),gc(b));v[b>>2]=v[b+4>>2];Yt(a,Cd(a))}function S1(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;Wk(a);h=zb(a);f=b+4|0;d=f;c=v[a+4>>2];g=v[a>>2];if((c|0)!=(g|0)){e=v[d>>2];while(1){c=c-16|0;zH(h,e-16|0,c);e=v[d>>2]-16|0;v[d>>2]=e;if((c|0)!=(g|0)){continue}break}}dc(a,f);dc(a+4|0,b+8|0);dc(zb(a),gc(b));v[b>>2]=v[b+4>>2];ho(a,jd(a))}function PB(a,b,c){var d=0,e=0,f=0,g=0,h=0;d=jb-16|0;jb=d;v[d+12>>2]=c;c=d+12|0;tc(c,128);tc(c,65535);f=x[d+12>>1];lg(a,f);if(f){c=0;while(1){e=w[b+c|0];a:{if((e|0)==255){e=65535;break a}if((e|0)!=254){break a}e=65534}g=Dj(a,c),h=e,u[g>>1]=h;c=c+1|0;if((f|0)!=(c|0)){continue}break}}jb=d+16|0}function HP(a){var b=0,c=0,d=0,e=0;b=a;e=v[a+4>>2];a:{while(1){if(v[b+8>>2]==(e|0)){break a}c=v[b+16>>2];d=v[b+8>>2]-8|0;v[b+8>>2]=d;v[113382]=0;R(885,c|0,d|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}if(v[a>>2]){Wu(v[a+16>>2],v[a>>2],v[gc(a)>>2]-v[a>>2]>>3)}}function Bja(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;b=a;if(!w[b+8|0]){if(w[b+24|0]){t[b+24|0]=0;d=b+40|0;while(1){e=Gi(d,c),f=0,t[e+8|0]=f;c=c+1|0;if((c|0)!=16){continue}break}c=b+28|0;Gk(c,0);GR(c)}c=b+12|0;Gk(c,v[b+4>>2]);nb[v[v[b>>2]+44>>2]](b,v[c>>2],0,v[b+4>>2])|0;t[b+8|0]=1}return v[a+12>>2]}function $K(a,b,c){var d=0,e=0,f=0,g=0;d=jb-16|0;jb=d;e=Pi(b,c);a:{if(e>>>0<=xf(a)>>>0){if(wc(a)>>>0<e>>>0){v[d+12>>2]=b;f=d,g=wc(a)+v[d+12>>2]|0,v[f+12>>2]=g;kf(b,v[d+12>>2],v[a>>2]);fz(a,v[d+12>>2],c,e-wc(a)|0);break a}DR(a,kf(b,c,v[a>>2]));break a}AM(a);Lp(a,Ki(a,e));fz(a,b,c,e)}jb=d+16|0}function $1(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=jb-32|0;jb=c;bo(a);v[a>>2]=78952;e=gc(a);v[113382]=0;d=v[b+12>>2];v[c+16>>2]=v[b+8>>2];v[c+20>>2]=d;d=v[b+4>>2];v[c+8>>2]=v[b>>2];v[c+12>>2]=d;Q(2171,e|0,c+8|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){jb=c+32|0;return a|0}a=P()|0;O()|0;S(a|0);L()}function xca(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=jb-16|0;jb=d;v[d+12>>2]=c>>>1;v[d+8>>2]=v[a>>2];e=v[Lb(d+12|0,d+8|0)>>2];b=Eb(b);if(e){a=v[a+20>>2];c=e;while(1){f=a,g=(Eb(w[b+1|0])|Eb(w[b|0])<<8)^32768,u[f>>1]=g;a=a+2|0;b=b+2|0;c=c-1|0;if(c){continue}break}}jb=d+16|0;return e<<1}function pia(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;e=jb-128|0;jb=e;f=jb-16|0;jb=f;c=e;d=f+8|0;LP(d,e);h=Hb(d);g=a;d=hd(g,$b(f,d));if((h|0)==(d|0)){Tc(g,Hb(f+8|0))}jb=f+16|0;g=(d|0)==(h|0);if(!g){MP(c)}c=-1;a:{if(!g){break a}c=0;if(!RP(e)){break a}c=gf(a,b,256,0)}jb=e+128|0;return c|0}function _D(a,b,c){var d=0,e=0,f=0,g=0,h=0;d=jb-16|0;jb=d;e=er(a);v[a+32>>2]=b;v[a>>2]=66460;b=d+8|0;_q(b,e);v[113382]=0;b=T(2800,b|0)|0;f=v[113382];v[113382]=0;if((f|0)!=1){Ob(d+8|0);v[a+40>>2]=c;v[a+36>>2]=b;g=a,h=rm(b),t[g+44|0]=h;jb=d+16|0;return}a=P()|0;O()|0;Ob(d+8|0);$k(e);S(a|0);L()}function ZD(a,b,c){var d=0,e=0,f=0,g=0,h=0;d=jb-16|0;jb=d;e=kE(a);v[a+32>>2]=b;v[a>>2]=66564;b=d+8|0;_q(b,e);v[113382]=0;b=T(2801,b|0)|0;f=v[113382];v[113382]=0;if((f|0)!=1){Ob(d+8|0);v[a+40>>2]=c;v[a+36>>2]=b;g=a,h=rm(b),t[g+44|0]=h;jb=d+16|0;return}a=P()|0;O()|0;Ob(d+8|0);mo(e);S(a|0);L()}function Aca(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=jb-16|0;jb=d;v[d+12>>2]=c>>>1;v[d+8>>2]=v[a>>2];e=v[Lb(d+12|0,d+8|0)>>2];b=Eb(b);if(e){a=v[a+20>>2];c=e;while(1){f=a,g=(Eb(w[b|0])|Eb(w[b+1|0])<<8)^32768,u[f>>1]=g;a=a+2|0;b=b+2|0;c=c-1|0;if(c){continue}break}}jb=d+16|0;return e<<1}function lQ(a){var b=0,c=0,d=0,e=0,f=0,g=0,h=0;if(!w[a+20|0]){if(!(nb[v[v[a>>2]+44>>2]](a)|0)){b=a+4|0;while(1){xQ(a,65536);c=a,d=(f=a,g=uc(b,v[a+16>>2]),h=65536,e=v[v[a>>2]+48>>2],nb[e](f|0,g|0,h|0)|0)+v[a+16>>2]|0,v[c+16>>2]=d;if(!(nb[v[v[a>>2]+44>>2]](a)|0)){continue}break}}t[a+20|0]=1}}function SI(a,b,c){var d=0,e=0,f=0;if(C(D(a))<C(0x8000000000000000)){d=~~a>>>0}else{d=0}f=d&-2147483648;e=f?0-d|0:d;a:{if(!((e|0)<0|(b|0)<=0)){while(1){d=b-1|0;e=e<<1;if(b>>>0<2){break a}b=d;if((e|0)>=0){continue}break a}}d=b}b=(e>>>31|0)+d<<31-c|(e&2147483647)>>>c;return C((f?b^-1|f:b)|0)}function zca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=jb-16|0;jb=e;v[e+12>>2]=c>>>1;v[e+8>>2]=v[a>>2];f=v[Lb(e+12|0,e+8|0)>>2];b=Eb(b);if(f){a=v[a+20>>2];c=f;while(1){d=(Eb(w[b|0])+d|0)+(Eb(w[b+1|0])<<8)|0;u[a>>1]=d;a=a+2|0;b=b+2|0;c=c-1|0;if(c){continue}break}}jb=e+16|0;return f<<1}function wca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=jb-16|0;jb=e;v[e+12>>2]=c>>>1;v[e+8>>2]=v[a>>2];f=v[Lb(e+12|0,e+8|0)>>2];b=Eb(b);if(f){a=v[a+20>>2];c=f;while(1){d=(Eb(w[b+1|0])+d|0)+(Eb(w[b|0])<<8)|0;u[a>>1]=d;a=a+2|0;b=b+2|0;c=c-1|0;if(c){continue}break}}jb=e+16|0;return f<<1}function RS(a,b,c){var d=0;d=jb-32|0;jb=d;v[d+16>>2]=b;v[d+24>>2]=a;v[d+8>>2]=c;a:{if(!Jb(d+24|0,d+16|0)){break a}while(1){a=v[d+24>>2];if(v[v[d+8>>2]>>2]==(w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24))){break a}a=d+24|0;Kk(a);if(Jb(a,d+16|0)){continue}break}}jb=d+32|0;return v[d+24>>2]}function P8(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;Ve(a);h=zb(a);f=b+4|0;d=f;c=v[a+4>>2];g=v[a>>2];if((c|0)!=(g|0)){e=v[d>>2];while(1){c=c-4|0;GJ(h,e-4|0,c);e=v[d>>2]-4|0;v[d>>2]=e;if((c|0)!=(g|0)){continue}break}}dc(a,f);dc(a+4|0,b+8|0);dc(zb(a),gc(b));v[b>>2]=v[b+4>>2];lk(a,Kb(a))}function cZ(a){a=a|0;var b=0,c=0;b=v[a+8>>2];v[113382]=0;b=aa(2454,0,0,4,b|0)|0;c=v[113382];v[113382]=0;a:{if((c|0)==1){break a}if(b){a=-1}else{a=v[a+8>>2];if(!a){return 1}v[113382]=0;a=T(2455,a|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break a}a=(a|0)==1}return a|0}V(0)|0;O()|0;Ab();L()}function ZU(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;e=jb-16|0;jb=e;v[e+12>>2]=d;d=0;if(y[a+16>>2]>c>>>0){d=v[a+4>>2];f=v[a+12>>2];v[e+8>>2]=v[a+16>>2]-c;d=(h=d,i=b,j=c+f|0,k=v[Lb(e+12|0,e+8|0)>>2],g=v[v[d>>2]+28>>2],nb[g](h|0,i|0,j|0,k|0)|0)}jb=e+16|0;return d|0}function Em(a,b){var c=0,d=0,e=0,f=0,g=0,h=0;c=jb-16|0;jb=c;g=a;h=a;a:{if(!b){b=0;e=0;break a}d=b;b=E(b);ef(c,d,0,0,0,b+81|0);d=0+v[c+8>>2]|0;b=(v[c+12>>2]^65536)+(16414-b<<16)|0;b=d>>>0<f>>>0?b+1|0:b;f=d;d=b;b=v[c+4>>2];e=v[c>>2]}v[h>>2]=e;v[g+4>>2]=b;v[a+8>>2]=f;v[a+12>>2]=d;jb=c+16|0}function Md(a){var b=0,c=0,d=0,e=0;o(+a);c=j(1)|0;j(0)|0;b=c;c=b>>>20&2047;if(c>>>0<=1074){if(c>>>0<=1021){return a*0}a=(b|0)>0|(b|0)>=0?a:-a;d=a+4503599627370496+-4503599627370496-a;a:{if(d>.5){e=a+d+-1;break a}a=a+d;e=a;if(!(d<=-.5)){break a}e=a+1}a=e;a=(b|0)>0|(b|0)>=0?a:-a}return a}function gla(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;Wk(a);zb(a);f=b+4|0;d=f;c=v[a+4>>2];g=v[a>>2];if((c|0)!=(g|0)){e=v[d>>2];while(1){c=c-16|0;fm(e-16|0,c);e=v[d>>2]-16|0;v[d>>2]=e;if((c|0)!=(g|0)){continue}break}}dc(a,f);dc(a+4|0,b+8|0);dc(zb(a),gc(b));v[b>>2]=v[b+4>>2];ho(a,jd(a))}function Yca(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;fj(a);zb(a);f=b+4|0;d=f;c=v[a+4>>2];g=v[a>>2];if((c|0)!=(g|0)){e=v[d>>2];while(1){c=c-12|0;ez(e-12|0,c);e=v[d>>2]-12|0;v[d>>2]=e;if((c|0)!=(g|0)){continue}break}}dc(a,f);dc(a+4|0,b+8|0);dc(zb(a),gc(b));v[b>>2]=v[b+4>>2];to(a,xc(a))}function OU(a,b){a=a|0;b=b|0;var c=0,d=0;c=jb-48|0;jb=c;d=-1;a:{if(!AC(a,c+8|0)){break a}d=0;if(!wC(c+8|0)){break a}if(b){a=c+12|0;a=w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24);if(!v[b+4>>2]&y[b>>2]<(a<<24|a<<8&16711680|(a>>>8&65280|a>>>24))-8>>>0){break a}}d=1}jb=c+48|0;return d|0}function Gla(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=jb-16|0;jb=d;t[d+15|0]=1;t[d+14|0]=a>>>2;a=w[th(d+15|0,d+14|0)|0];e=a>>>0<15|b>>>0<2;if(!e){t[d+13|0]=1;t[d+12|0]=(((a+b|0)-2&65535)>>>0)/((b-1&65535)>>>0);a=w[th(d+13|0,d+12|0)|0]}jb=d+16|0;return(c?a<<4|(e?15:0):a&15|(e?-16:0))&255}function r0(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=jb-16|0;jb=d;a:{if(v[b>>2]){if(!Sc(c)){lv(c,13778)}e=v[b+4>>2];nb[v[v[e>>2]+24>>2]](d,e,v[b>>2]);v[113382]=0;Q(1214,c|0,d|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break a}yb(d)}rd(a,c);jb=d+16|0;return}a=P()|0;O()|0;yb(d);S(a|0);L()}function mh(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;f=jb-32|0;jb=f;g=Lj(a,c);e=f+8|0;pf(e,v[a+28>>2]);h=v[e+12>>2];v[f+24>>2]=v[e+8>>2];v[f+28>>2]=h;a:{b:{if(!g){e=-1;if(!wd(a,5)){break b}break a}e=v[g+8>>2]}nb[d|0](v[a+28>>2],b,e)}a=$i(a,g,c,f+24|0);jb=f+32|0;return a|0}function kK(a,b){a=a|0;b=b|0;var c=0,d=0;a:{b:{a=a-12|0;c:{if(a>>>0>28){break c}d=1<<a;c=1;if(d&270014517){break a}if(d&65792){break b}if((a|0)!=7){break c}b=b&240;c=1;if(!b|(b|0)==96|(b|0)==224){break a}}return 0}b=(b&240)-96|0;c=0;if(b>>>0>=144){break a}c=297>>>(b>>>4)&1}return c|0}function EF(a,b,c){var d=0,e=0,f=0,g=0;f=jb-16|0;jb=f;e=rt(b,c);if(e>>>0<=1073741807){a:{if(e>>>0<=1){Ce(a,e);d=a;break a}g=al(e)+1|0;d=Qj(a,g);Oe(a,d);Gf(a,g);ae(a,e)}while(1){if((b|0)!=(c|0)){Te(d,b);d=d+4|0;b=b+4|0;continue}break}v[f+12>>2]=0;Te(d,f+12|0);jb=f+16|0;return}If();L()}function yca(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=jb-16|0;jb=d;v[d+12>>2]=c>>>1;v[d+8>>2]=v[a>>2];e=v[Lb(d+12|0,d+8|0)>>2];b=Eb(b);if(e){a=v[a+20>>2];c=e;while(1){f=a,g=Eb(w[b+1|0])|Eb(w[b|0])<<8,u[f>>1]=g;a=a+2|0;b=b+2|0;c=c-1|0;if(c){continue}break}}jb=d+16|0;return e<<1}function R_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;c=jb-128|0;jb=c;v[c+12>>2]=c+116;d=a+8|0;a=c+16|0;iF(d,a,c+12|0,e,f,g);e=v[c+12>>2];d=jb-16|0;jb=d;v[d+8>>2]=b;while(1){if((a|0)!=(e|0)){vF(d+8|0,t[a|0]);a=a+1|0;continue}break}jb=d+16|0;jb=c+128|0;return v[d+8>>2]}function Bca(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=jb-16|0;jb=d;v[d+12>>2]=c>>>1;v[d+8>>2]=v[a>>2];e=v[Lb(d+12|0,d+8|0)>>2];b=Eb(b);if(e){a=v[a+20>>2];c=e;while(1){f=a,g=Eb(w[b|0])|Eb(w[b+1|0])<<8,u[f>>1]=g;a=a+2|0;b=b+2|0;c=c-1|0;if(c){continue}break}}jb=d+16|0;return e<<1}function cf(a){var b=0,c=0,d=0;b=a;a:{if(b&3){while(1){if(!w[b|0]){break a}b=b+1|0;if(b&3){continue}break}}while(1){c=b;b=b+4|0;d=v[c>>2];if(!((d^-1)&d-16843009&-2139062144)){continue}break}if(!(d&255)){return c-a|0}while(1){d=w[c+1|0];b=c+1|0;c=b;if(d){continue}break}}return b-a|0}function Dda(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=jb-48|0;jb=c;d=c+40|0;t[d|0]=w[b|0];b=c+16|0;xq(b,d);b=Eb(v[b>>2]);e=c+8|0;xq(e,d);b=oi(c+24|0,b,Eb(v[e>>2]+1|0));v[113382]=0;Q(1156,a|0,b|0)|0;a=v[113382];v[113382]=0;if((a|0)!=1){yb(b);jb=c+48|0;return}a=P()|0;O()|0;yb(b);S(a|0);L()}function U3(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=jb-48|0;jb=d;v[d+44>>2]=b;b=d+8|0;jj(b,0,c);c=d+24|0;v[c>>2]=v[d+44>>2];rd(c+4|0,b);v[113382]=0;R(2095,a+4|0,c|0);a=v[113382];v[113382]=0;if((a|0)!=1){Bk(d+24|0);yb(d+8|0);jb=d+48|0;return}a=P()|0;O()|0;Bk(d+24|0);yb(d+8|0);S(a|0);L()}function ET(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;e=jb-16|0;jb=e;f=Rb(a,120);a:{if(f){c=jb-16|0;jb=c;d=e+8|0;fc(d,b,120);jb=c+16|0;zd(a,d);break a}a=jb-16|0;jb=a;c=jb-16|0;jb=c;d=b+120|0;while(1){jf(b);b=b+1|0;if((d|0)!=(b|0)){continue}break}jb=c+16|0;jb=a+16|0}jb=e+16|0;return f|0}function $R(a){var b=0,c=0,d=0,e=0;b=a+32|0;d=w[b|0]|w[b+1|0]<<8;b=a+38|0;e=w[b|0]|w[b+1|0]<<8;b=a+34|0;a=a+36|0;c=w[a|0]|w[a+1|0]<<8;b=(w[b|0]|w[b+1|0]<<8)+c|0;a=0;a=b>>>0<c>>>0?1:a;c=b;b=e+b|0;a=b>>>0<c>>>0?a+1|0:a;a=a<<2|b>>>30;c=b<<2;b=d+c|0;a=b>>>0<c>>>0?a+1|0:a;mb=a;return b}function aU(a,b){a=a|0;b=b|0;var c=0;c=jb-32|0;jb=c;v[c+16>>2]=b;v[c+24>>2]=a;a:{if(!Jb(c+24|0,c+16|0)){break a}v[c>>2]=v[c+24>>2];if(!Jb(re(c),c+16|0)){break a}while(1){if(xB(v[c+24>>2],v[c>>2])){v[c+24>>2]=v[c>>2]}if(Jb(re(c),c+16|0)){continue}break}}jb=c+32|0;return v[c+24>>2]}function Q8(a,b){a=a|0;b=b|0;var c=0,d=0;c=jb-16|0;jb=c;v[c+8>>2]=b;b=0;a:{if(Kb(a)>>>0>511){break a}if(!qd(c+8|0)){break a}d=c+8|0;b=v[d>>2];v[113382]=0;R(1602,a|0,d|0);a=v[113382];v[113382]=0;if((a|0)!=1){break a}a=P()|0;O()|0;gg(c+8|0);S(a|0);L()}gg(c+8|0);jb=c+16|0;return b|0}function Ti(a,b){var c=0,d=0,e=0,f=0,g=0;if(b){g=v[a+8>>2];c=v[a>>2];while(1){a:{if(c){d=v[a+4>>2];break a}v[a>>2]=8;c=g;d=v[a+12>>2];if((c|0)!=(d|0)){c=d-1|0;v[a+12>>2]=c}d=w[c|0];c=8}c=c-1|0;v[a>>2]=c;v[a+4>>2]=d>>>1;e=d&1|e<<1;f=f+1|0;if((f|0)!=(b|0)){continue}break}}return e}function Xq(a,b){var c=0,d=0;c=-1;a:{if((a|0)==-1){break a}d=v[b+76>>2]>=0;b:{c:{c=v[b+4>>2];d:{if(!c){$F(b);c=v[b+4>>2];if(!c){break d}}if(v[b+44>>2]-8>>>0<c>>>0){break c}}c=-1;if(d){break b}break a}c=c-1|0;v[b+4>>2]=c;t[c|0]=a;v[b>>2]=v[b>>2]&-17;c=a;if(!d){break a}}}return c}function Od(a,b){var c=0,d=0,e=0,f=0;c=v[a+4>>2];d=c+b|0;v[a+4>>2]=d;if((d|0)<=v[a+8>>2]){d=v[a>>2]+(c>>3)|0;a=c&7;c=w[d|0]&255>>>a;a=a+b|0;a:{if((a|0)<9){b=a;break a}while(1){b=a-8|0;e=c<<b|e;f=a>>>0>16;c=w[d+1|0];a=b;d=d+1|0;if(f){continue}break}}a=c>>>8-b|e}else{a=0}return a}function O7(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;v[a+4>>2]=b;v[a>>2]=0;b=Vs(a+8|0,e);v[113382]=0;Q(1729,a+20|0,d|0)|0;d=v[113382];v[113382]=0;if((d|0)!=1){v[a+32>>2]=0;v[a+36>>2]=0;t[a+42|0]=0;t[a+40|0]=0;t[a+41|0]=w[a+41|0]&240|c|8;return a|0}a=P()|0;O()|0;Ib(b);S(a|0);L()}function Fha(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;if(!v[a+300>>2]){return 0}if(!(!d|(nb[v[a+304>>2]](v[a+296>>2],c,0,0)|0)<0)){while(1){a:{c=nb[v[a+300>>2]](v[a+296>>2],b,d)|0;e=c+e|0;f=c>>>0>e>>>0?f+1|0:f;if(!c){break a}b=b+c|0;d=d-c|0;if(d){continue}}break}}return e|0}function yl(a,b,c,d){var e=0,f=0;a:{f=v[(B(b,896)+a|0)+1075640>>2];if(!f){break a}if(!zi(f)){break a}e=w[f+34|0];if((e-1&255)>>>0>249){break a}e=v[(B(e,160)+a|0)+906140>>2];if(!e){break a}nb[v[v[e>>2]+88>>2]](e,f,c,d,b);if(c>>>0>250){break a}u[(B(b,896)+a|0)+1075846>>1]=65535}}function yH(a){var b=0,c=0,d=0,e=0;b=a;e=v[a+4>>2];a:{while(1){if(v[b+8>>2]==(e|0)){break a}c=v[b+16>>2];d=v[b+8>>2]-16|0;v[b+8>>2]=d;v[113382]=0;R(2173,c|0,d|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}if(v[a>>2]){Xh(v[a+16>>2],v[a>>2],mv(a))}}function wH(a){var b=0,c=0,d=0,e=0;b=a;e=v[a+4>>2];a:{while(1){if(v[b+8>>2]==(e|0)){break a}c=v[b+16>>2];d=v[b+8>>2]-24|0;v[b+8>>2]=d;v[113382]=0;R(2174,c|0,d|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}if(v[a>>2]){_o(v[a+16>>2],v[a>>2],Ol(a))}}function rK(a){var b=0,c=0,d=0,e=0;b=a;e=v[a+4>>2];a:{while(1){if(v[b+8>>2]==(e|0)){break a}c=v[b+16>>2];d=v[b+8>>2]-24|0;v[b+8>>2]=d;v[113382]=0;R(1528,c|0,d|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}if(v[a>>2]){Ff(v[a+16>>2],v[a>>2],Ol(a))}}function Ts(a){var b=0,c=0,d=0,e=0;b=a;e=v[a+4>>2];a:{while(1){if(v[b+8>>2]==(e|0)){break a}c=v[b+16>>2];d=v[b+8>>2]-32|0;v[b+8>>2]=d;v[113382]=0;R(1158,c|0,d|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}if(v[a>>2]){Ug(v[a+16>>2],v[a>>2],Zu(a))}}function GM(a){var b=0,c=0,d=0,e=0;b=a;e=v[a+4>>2];a:{while(1){if(v[b+8>>2]==(e|0)){break a}c=v[b+16>>2];d=v[b+8>>2]-12|0;v[b+8>>2]=d;v[113382]=0;R(1200,c|0,d|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}if(v[a>>2]){Ah(v[a+16>>2],v[a>>2],so(a))}}function xD(a){var b=0,c=0,d=0,e=0;b=a;e=v[a+4>>2];a:{while(1){if(v[b+8>>2]==(e|0)){break a}c=v[b+16>>2];d=v[b+8>>2]-16|0;v[b+8>>2]=d;v[113382]=0;R(187,c|0,d|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}if(v[a>>2]){Xh(v[a+16>>2],v[a>>2],mv(a))}}function tS(a){var b=0,c=0,d=0,e=0;b=a;e=v[a+4>>2];a:{while(1){if(v[b+8>>2]==(e|0)){break a}c=v[b+16>>2];d=v[b+8>>2]-24|0;v[b+8>>2]=d;v[113382]=0;R(566,c|0,d|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}if(v[a>>2]){Ff(v[a+16>>2],v[a>>2],Ol(a))}}function nO(a){var b=0,c=0,d=0,e=0;b=a;e=v[a+4>>2];a:{while(1){if(v[b+8>>2]==(e|0)){break a}c=v[b+16>>2];d=v[b+8>>2]-4|0;v[b+8>>2]=d;v[113382]=0;R(1023,c|0,d|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}if(v[a>>2]){xj(v[a+16>>2],v[a>>2],yg(a))}}function jr(a){var b=0,c=0,d=0,e=0;b=a;e=v[a+4>>2];a:{while(1){if(v[b+8>>2]==(e|0)){break a}c=v[b+16>>2];d=v[b+8>>2]-12|0;v[b+8>>2]=d;v[113382]=0;R(176,c|0,d|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}if(v[a>>2]){Ah(v[a+16>>2],v[a>>2],so(a))}}function fP(a){var b=0,c=0,d=0,e=0;b=a;e=v[a+4>>2];a:{while(1){if(v[b+8>>2]==(e|0)){break a}c=v[b+16>>2];d=v[b+8>>2]-24|0;v[b+8>>2]=d;v[113382]=0;R(947,c|0,d|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}if(v[a>>2]){Ff(v[a+16>>2],v[a>>2],Ol(a))}}function es(a){var b=0,c=0,d=0,e=0;b=a;e=v[a+4>>2];a:{while(1){if(v[b+8>>2]==(e|0)){break a}c=v[b+16>>2];d=v[b+8>>2]-4|0;v[b+8>>2]=d;v[113382]=0;R(1623,c|0,d|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}if(v[a>>2]){Se(v[a+16>>2],v[a>>2],yg(a))}}function dT(a){var b=0,c=0,d=0,e=0;b=a;e=v[a+4>>2];a:{while(1){if(v[b+8>>2]==(e|0)){break a}c=v[b+16>>2];d=v[b+8>>2]-24|0;v[b+8>>2]=d;v[113382]=0;R(491,c|0,d|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}if(v[a>>2]){Ff(v[a+16>>2],v[a>>2],Ol(a))}}function ct(a){var b=0,c=0,d=0,e=0;b=a;e=v[a+4>>2];a:{while(1){if(v[b+8>>2]==(e|0)){break a}c=v[b+16>>2];d=v[b+8>>2]-12|0;v[b+8>>2]=d;v[113382]=0;R(987,c|0,d|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}if(v[a>>2]){Ah(v[a+16>>2],v[a>>2],so(a))}}function _Q(a){var b=0,c=0,d=0,e=0;b=a;e=v[a+4>>2];a:{while(1){if(v[b+8>>2]==(e|0)){break a}c=v[b+16>>2];d=v[b+8>>2]-24|0;v[b+8>>2]=d;v[113382]=0;R(731,c|0,d|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}if(v[a>>2]){Ff(v[a+16>>2],v[a>>2],Ol(a))}}function _K(a){var b=0,c=0,d=0,e=0;b=a;e=v[a+4>>2];a:{while(1){if(v[b+8>>2]==(e|0)){break a}c=v[b+16>>2];d=v[b+8>>2]-4|0;v[b+8>>2]=d;v[113382]=0;R(1409,c|0,d|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}if(v[a>>2]){Se(v[a+16>>2],v[a>>2],yg(a))}}function Ls(a){var b=0,c=0,d=0,e=0;b=a;e=v[a+4>>2];a:{while(1){if(v[b+8>>2]==(e|0)){break a}c=v[b+16>>2];d=v[b+8>>2]-12|0;v[b+8>>2]=d;v[113382]=0;R(314,c|0,d|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}if(v[a>>2]){Ah(v[a+16>>2],v[a>>2],so(a))}}function Kt(a){var b=0,c=0,d=0,e=0;b=a;e=v[a+4>>2];a:{while(1){if(v[b+8>>2]==(e|0)){break a}c=v[b+16>>2];d=v[b+8>>2]-16|0;v[b+8>>2]=d;v[113382]=0;R(381,c|0,d|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}if(v[a>>2]){Xh(v[a+16>>2],v[a>>2],mv(a))}}function GL(a){var b=0,c=0,d=0,e=0;b=a;e=v[a+4>>2];a:{while(1){if(v[b+8>>2]==(e|0)){break a}c=v[b+16>>2];d=v[b+8>>2]-32|0;v[b+8>>2]=d;v[113382]=0;R(857,c|0,d|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}if(v[a>>2]){lt(v[a+16>>2],v[a>>2],Zu(a))}}function FJ(a){var b=0,c=0,d=0,e=0;b=a;e=v[a+4>>2];a:{while(1){if(v[b+8>>2]==(e|0)){break a}c=v[b+16>>2];d=v[b+8>>2]-4|0;v[b+8>>2]=d;v[113382]=0;R(1407,c|0,d|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}if(v[a>>2]){Se(v[a+16>>2],v[a>>2],yg(a))}}function EK(a){var b=0,c=0,d=0,e=0;b=a;e=v[a+4>>2];a:{while(1){if(v[b+8>>2]==(e|0)){break a}c=v[b+16>>2];d=v[b+8>>2]-4|0;v[b+8>>2]=d;v[113382]=0;R(1493,c|0,d|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}if(v[a>>2]){Se(v[a+16>>2],v[a>>2],yg(a))}}function Cq(a){var b=0,c=0,d=0,e=0;b=a;e=v[a+4>>2];a:{while(1){if(v[b+8>>2]==(e|0)){break a}c=v[b+16>>2];d=v[b+8>>2]-32|0;v[b+8>>2]=d;v[113382]=0;R(243,c|0,d|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}if(v[a>>2]){Ug(v[a+16>>2],v[a>>2],Zu(a))}}function BS(a){var b=0,c=0,d=0,e=0;b=a;e=v[a+4>>2];a:{while(1){if(v[b+8>>2]==(e|0)){break a}c=v[b+16>>2];d=v[b+8>>2]-24|0;v[b+8>>2]=d;v[113382]=0;R(535,c|0,d|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}if(v[a>>2]){Ff(v[a+16>>2],v[a>>2],Ol(a))}}function AO(a){var b=0,c=0,d=0,e=0;b=a;e=v[a+4>>2];a:{while(1){if(v[b+8>>2]==(e|0)){break a}c=v[b+16>>2];d=v[b+8>>2]-12|0;v[b+8>>2]=d;v[113382]=0;R(986,c|0,d|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}if(v[a>>2]){Ah(v[a+16>>2],v[a>>2],so(a))}}function $r(a){var b=0,c=0,d=0,e=0;b=a;e=v[a+4>>2];a:{while(1){if(v[b+8>>2]==(e|0)){break a}c=v[b+16>>2];d=v[b+8>>2]-4|0;v[b+8>>2]=d;v[113382]=0;R(1732,c|0,d|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}if(v[a>>2]){Se(v[a+16>>2],v[a>>2],yg(a))}}function wq(a){var b=0,c=0,d=0,e=0;b=a;e=v[a+4>>2];a:{while(1){if(v[b+8>>2]==(e|0)){break a}c=v[b+16>>2];d=v[b+8>>2]-4|0;v[b+8>>2]=d;v[113382]=0;R(315,c|0,d|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}if(v[a>>2]){Se(v[a+16>>2],v[a>>2],yg(a))}}function vm(a){var b=0,c=0,d=0,e=0;b=a;e=v[a+4>>2];a:{while(1){if(v[b+8>>2]==(e|0)){break a}c=v[b+16>>2];d=v[b+8>>2]-1|0;v[b+8>>2]=d;v[113382]=0;R(185,c|0,d|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}if(v[a>>2]){cg(v[a+16>>2],v[a>>2],oA(a))}}function uR(a){var b=0,c=0,d=0,e=0;b=a;e=v[a+4>>2];a:{while(1){if(v[b+8>>2]==(e|0)){break a}c=v[b+16>>2];d=v[b+8>>2]-4|0;v[b+8>>2]=d;v[113382]=0;R(698,c|0,d|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}if(v[a>>2]){xj(v[a+16>>2],v[a>>2],yg(a))}}function qP(a){var b=0,c=0,d=0,e=0;b=a;e=v[a+4>>2];a:{while(1){if(v[b+8>>2]==(e|0)){break a}c=v[b+16>>2];d=v[b+8>>2]-4|0;v[b+8>>2]=d;v[113382]=0;R(912,c|0,d|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}if(v[a>>2]){xj(v[a+16>>2],v[a>>2],yg(a))}}function nk(a){var b=0,c=0,d=0,e=0;b=a;e=v[a+4>>2];a:{while(1){if(v[b+8>>2]==(e|0)){break a}c=v[b+16>>2];d=v[b+8>>2]-4|0;v[b+8>>2]=d;v[113382]=0;R(107,c|0,d|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}if(v[a>>2]){Se(v[a+16>>2],v[a>>2],yg(a))}}function mB(a){var b=0,c=0,d=0,e=0;b=a;e=v[a+4>>2];a:{while(1){if(v[b+8>>2]==(e|0)){break a}c=v[b+16>>2];d=v[b+8>>2]-2|0;v[b+8>>2]=d;v[113382]=0;R(377,c|0,d|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}if(v[a>>2]){Ql(v[a+16>>2],v[a>>2],Rn(a))}}function kC(a){var b=0,c=0,d=0,e=0;b=a;e=v[a+4>>2];a:{while(1){if(v[b+8>>2]==(e|0)){break a}c=v[b+16>>2];d=v[b+8>>2]-2|0;v[b+8>>2]=d;v[113382]=0;R(328,c|0,d|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}if(v[a>>2]){Tn(v[a+16>>2],v[a>>2],Rn(a))}}function _t(a){var b=0,c=0,d=0,e=0;b=a;e=v[a+4>>2];a:{while(1){if(v[b+8>>2]==(e|0)){break a}c=v[b+16>>2];d=v[b+8>>2]-2|0;v[b+8>>2]=d;v[113382]=0;R(495,c|0,d|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}if(v[a>>2]){Ql(v[a+16>>2],v[a>>2],Rn(a))}}function Tm(a){var b=0,c=0,d=0,e=0;b=a;e=v[a+4>>2];a:{while(1){if(v[b+8>>2]==(e|0)){break a}c=v[b+16>>2];d=v[b+8>>2]-4|0;v[b+8>>2]=d;v[113382]=0;R(696,c|0,d|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}if(v[a>>2]){Se(v[a+16>>2],v[a>>2],yg(a))}}function Th(a){var b=0,c=0,d=0,e=0;b=a;e=v[a+4>>2];a:{while(1){if(v[b+8>>2]==(e|0)){break a}c=v[b+16>>2];d=v[b+8>>2]-4|0;v[b+8>>2]=d;v[113382]=0;R(338,c|0,d|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}if(v[a>>2]){Du(v[a+16>>2],v[a>>2],yg(a))}}function Tg(a){var b=0,c=0,d=0,e=0;b=a;e=v[a+4>>2];a:{while(1){if(v[b+8>>2]==(e|0)){break a}c=v[b+16>>2];d=v[b+8>>2]-1|0;v[b+8>>2]=d;v[113382]=0;R(327,c|0,d|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}if(v[a>>2]){cg(v[a+16>>2],v[a>>2],oA(a))}}function JQ(a){var b=0,c=0,d=0,e=0;b=a;e=v[a+4>>2];a:{while(1){if(v[b+8>>2]==(e|0)){break a}c=v[b+16>>2];d=v[b+8>>2]-4|0;v[b+8>>2]=d;v[113382]=0;R(782,c|0,d|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}if(v[a>>2]){xj(v[a+16>>2],v[a>>2],yg(a))}}function Ica(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=jb-16|0;jb=d;v[d+12>>2]=c;v[d+8>>2]=v[a>>2];e=v[Lb(d+12|0,d+8|0)>>2];b=Eb(b);if(e){a=v[a+20>>2];c=e;while(1){f=a,g=Yb(cn(w[b|0]),-64,63)<<1,t[f|0]=g;a=a+1|0;b=b+1|0;c=c-1|0;if(c){continue}break}}jb=d+16|0;return e|0}function Cj(a){var b=0,c=0,d=0,e=0;b=a;e=v[a+4>>2];a:{while(1){if(v[b+8>>2]==(e|0)){break a}c=v[b+16>>2];d=v[b+8>>2]-2|0;v[b+8>>2]=d;v[113382]=0;R(348,c|0,d|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}if(v[a>>2]){Tn(v[a+16>>2],v[a>>2],Rn(a))}}function CQ(a){var b=0,c=0,d=0,e=0;b=a;e=v[a+4>>2];a:{while(1){if(v[b+8>>2]==(e|0)){break a}c=v[b+16>>2];d=v[b+8>>2]-2|0;v[b+8>>2]=d;v[113382]=0;R(787,c|0,d|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}if(v[a>>2]){Ql(v[a+16>>2],v[a>>2],Rn(a))}}function zT(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;v[a>>2]=0;v[a+4>>2]=0;if(!Rb(b,c)){c=$e(b)}v[a>>2]=c;d=v[b>>2];if(nb[v[v[d>>2]+16>>2]](d)|0){c=a;a=v[b>>2];e=c,f=(nb[v[v[a>>2]+20>>2]](a)|0)+v[b+8>>2]|0,v[e+4>>2]=f;return}d=a+8|0;Gk(d,v[a>>2]);if(!id(d)){kg(b,uc(d,0),c)}}function pC(a,b,c,d){var e=0,f=0;b=v[a+1072>>2]+((b&c?0-(c<<1)|0:0)+b|0)|0;v[a+1072>>2]=b;c=b+v[a+1076>>2]|0;v[a+1076>>2]=c;u[(v[a+1064>>2]<<1)+d>>1]=w[a+1080|0]?c:b;v[a+1060>>2]=v[a+1060>>2]+1;e=a,f=te(v[a+1056>>2])+v[a+1064>>2]|0,v[e+1064>>2]=f;v[a+1068>>2]=v[a+1068>>2]-1}function gV(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=jb-32|0;jb=e;bo(a);v[a>>2]=72356;f=gc(a);b=Uk(e+16|0,b);c=v[c>>2];d=v[d>>2];g=v[b+4>>2];v[e+8>>2]=v[b>>2];v[e+12>>2]=g;Mp(f);v[f>>2]=72396;b=e+8|0;Uk(f+4|0,b);v[f+16>>2]=d;v[f+12>>2]=c;Bb(b);jb=e+32|0;return a|0}function aS(a){var b=0,c=0;a:{if((w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24))!=1297108297){b=0;if((w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24))!=778924148){break a}}c=a+34|0;b=0;if((w[c|0]|w[c+1|0]<<8)>>>0>255){break a}a=a+36|0;b=(w[a|0]|w[a+1|0]<<8)>>>0<4e3}return b}function _p(a){var b=0,c=0,d=0,e=0;b=a;e=v[a+4>>2];a:{while(1){if(v[b+8>>2]==(e|0)){break a}c=v[b+16>>2];d=v[b+8>>2]-1|0;v[b+8>>2]=d;v[113382]=0;R(32,c|0,d|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}if(v[a>>2]){cg(v[a+16>>2],v[a>>2],oA(a))}}function m7(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=Bd(b);f=tf(b);e=Bd(b);c=jb-32|0;jb=c;v[c+16>>2]=f;v[c+24>>2]=d;v[c+8>>2]=e;if(Jb(c+24|0,c+16|0)){while(1){d=c+24|0;f=nb[117](t[v[d>>2]])|0;e=c+8|0;t[v[e>>2]]=f;xg(d);xg(e);if(Jb(d,c+16|0)){continue}break}}jb=c+32|0;rd(a,b)}function eJ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;a:{e=jb-16|0;jb=e;b:{c:{if((b|0)==(c|0)){b=a;a=Tb(d);oi(b,a,Db(d)+a|0);break c}BJ(e,c,d);v[113382]=0;U(115,a|0,b|0,e|0);a=v[113382];v[113382]=0;if((a|0)==1){break b}Jc(e)}jb=e+16|0;break a}a=P()|0;O()|0;Jc(e);S(a|0);L()}}function zE(a,b){var c=0,d=0;c=jb-16|0;jb=c;d=c+8|0;Ac(d,a);v[113382]=0;a=T(21,d|0)|0;d=v[113382];v[113382]=0;a:{if((d|0)==1){break a}v[113382]=0;a=Q(22,a|0,b|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break a}Ob(c+8|0);jb=c+16|0;return a}a=P()|0;O()|0;Ob(c+8|0);S(a|0);L()}function iV(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=jb-32|0;jb=e;v[113382]=0;v[e+24>>2]=d;v[e+28>>2]=c;X(250,e+8|0,b|0,e+28|0,e+24|0);c=v[113382];v[113382]=0;if((c|0)!=1){c=e+16|0;d=e+8|0;IC(c,d);im(a,c);Bb(c);Bb(d);Bb(b);jb=e+32|0;return}a=P()|0;O()|0;Bb(b);S(a|0);L()}function b7(a,b,c){a=a|0;b=b|0;c=C(c);var d=0;d=jb-16|0;jb=d;z[d+12>>2]=c;if((b|0)<=6){Wd(d+12|0,C(0));c=z[d+12>>2];a:{if(!((b|0)!=1|c>=C(1))){v[d+12>>2]=0;c=C(0);break a}if((b|0)!=4){break a}c=C(de(C(c*C(4)))*C(.25));z[d+12>>2]=c}z[((b<<2)+a|0)+4208>>2]=c;lx(a)}jb=d+16|0}function J7(a,b,c){a=a|0;b=b|0;c=C(c);var d=0;d=jb-16|0;jb=d;z[d+12>>2]=c;if((b|0)<=6){Wd(d+12|0,C(0));c=z[d+12>>2];a:{if(!((b|0)!=3|c>=C(1))){v[d+12>>2]=0;c=C(0);break a}if((b|0)!=4){break a}c=C(de(C(c*C(4)))*C(.25));z[d+12>>2]=c}z[((b<<2)+a|0)+4208>>2]=c;lx(a)}jb=d+16|0}function h0(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;h=(e-d|0)+b|0;a:{while(1){if((d|0)!=(e|0)){a=-1;if((b|0)==(c|0)){break a}f=t[b|0];g=t[d|0];if((f|0)<(g|0)){break a}if((f|0)>(g|0)){return 1}else{d=d+1|0;b=b+1|0;continue}}break}a=(c|0)!=(h|0)}return a|0}function cI(a){a=a|0;var b=0,c=0,d=0;d=jb-16|0;jb=d;b=Pe(8);WH(b);v[b+4>>2]=a;v[b>>2]=79032;c=jb-16|0;jb=c;v[113382]=0;v[c+12>>2]=b;a=d+8|0;W(2109,a|0,c+12|0,c+8|0)|0;b=v[113382];v[113382]=0;a:{if((b|0)!=1){jb=c+16|0;break a}V(0)|0;O()|0;Ab();L()}jb=d+16|0;return v[a>>2]}function ada(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=a;if(v[c>>2]){xc(c);IM(c);dt(c);Ah(zb(c),v[c>>2],tg(c));d=zb(c),e=0,v[d>>2]=e;v[c>>2]=0;v[c+4>>2]=0}Fl(a,b);v[a>>2]=v[b>>2];v[a+4>>2]=v[b+4>>2];c=v[zb(b)>>2];d=zb(a),e=c,v[d>>2]=e;d=zb(b),e=0,v[d>>2]=e;v[b>>2]=0;v[b+4>>2]=0}function Ila(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=jb-16|0;jb=d;e=0;a:{if(!a){break a}b:{c:{if(a>>>0<=15){if(b>>>0<2|c){break c}break b}if(b>>>0>1){break b}}e=a|-16;break a}t[d+15|0]=1;t[d+14|0]=(a>>>0)/((b-1&255)>>>0);e=w[th(d+15|0,d+14|0)|0]}a=e;jb=d+16|0;return a&255}function Gm(a,b,c){var d=0,e=0,f=0;a:{if(!b){d=a;break a}while(1){d=tma(a,b,10,0);e=mb;f=e;e=qma(d,e,10,0);c=c-1|0;t[c|0]=a-e|48;e=b>>>0>9;a=d;b=f;if(e){continue}break}}if(d){while(1){c=c-1|0;a=(d>>>0)/10|0;t[c|0]=d-B(a,10)|48;b=d>>>0>9;d=a;if(b){continue}break}}return c}function zw(a){var b=0,c=0;a:{if(y[a+20>>2]<=y[a+28>>2]){break a}nb[v[a+36>>2]](a,0,0)|0;if(v[a+20>>2]){break a}return-1}b=v[a+4>>2];c=v[a+8>>2];if(b>>>0<c>>>0){b=b-c|0;nb[v[a+40>>2]](a,b,b>>31,1)|0}v[a+28>>2]=0;v[a+16>>2]=0;v[a+20>>2]=0;v[a+4>>2]=0;v[a+8>>2]=0;return 0}function nL(a){var b=0,c=0,d=0,e=0;Ve(a);if(v[a>>2]){d=a;e=v[a>>2];b=v[a+4>>2];a:{while(1){if((b|0)==(e|0)){break a}c=zb(d);v[113382]=0;b=b-4|0;R(1409,c|0,b|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}v[d+4>>2]=e;Se(zb(a),v[a>>2],nd(a))}}function mx(a){var b=0,c=0,d=0,e=0;Ve(a);if(v[a>>2]){d=a;e=v[a>>2];b=v[a+4>>2];a:{while(1){if((b|0)==(e|0)){break a}c=zb(d);v[113382]=0;b=b-4|0;R(1732,c|0,b|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}v[d+4>>2]=e;Se(zb(a),v[a>>2],nd(a))}}function mP(a){var b=0,c=0,d=0,e=0;iP(a);if(v[a>>2]){d=a;e=v[a>>2];b=v[a+4>>2];a:{while(1){if((b|0)==(e|0)){break a}c=zb(d);v[113382]=0;b=b-56|0;R(951,c|0,b|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}v[d+4>>2]=e;et(zb(a),v[a>>2],pn(a))}}function kA(a){var b=0,c=0,d=0,e=0;Nh(a);if(v[a>>2]){d=a;e=v[a>>2];b=v[a+4>>2];a:{while(1){if((b|0)==(e|0)){break a}c=zb(d);v[113382]=0;b=b-24|0;R(566,c|0,b|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}v[d+4>>2]=e;Ff(zb(a),v[a>>2],Ye(a))}}function gl(a){var b=0,c=0,d=0,e=0;fj(a);if(v[a>>2]){d=a;e=v[a>>2];b=v[a+4>>2];a:{while(1){if((b|0)==(e|0)){break a}c=zb(d);v[113382]=0;b=b-12|0;R(176,c|0,b|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}v[d+4>>2]=e;Ah(zb(a),v[a>>2],tg(a))}}function US(a){var b=0,c=0,d=0,e=0;Nh(a);if(v[a>>2]){d=a;e=v[a>>2];b=v[a+4>>2];a:{while(1){if((b|0)==(e|0)){break a}c=zb(d);v[113382]=0;b=b-24|0;R(535,c|0,b|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}v[d+4>>2]=e;Ff(zb(a),v[a>>2],Ye(a))}}function Pz(a){var b=0,c=0,d=0,e=0;Nh(a);if(v[a>>2]){d=a;e=v[a>>2];b=v[a+4>>2];a:{while(1){if((b|0)==(e|0)){break a}c=zb(d);v[113382]=0;b=b-24|0;R(731,c|0,b|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}v[d+4>>2]=e;Ff(zb(a),v[a>>2],Ye(a))}}function Lx(a){var b=0,c=0,d=0,e=0;Ve(a);if(v[a>>2]){d=a;e=v[a>>2];b=v[a+4>>2];a:{while(1){if((b|0)==(e|0)){break a}c=zb(d);v[113382]=0;b=b-4|0;R(1493,c|0,b|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}v[d+4>>2]=e;Se(zb(a),v[a>>2],nd(a))}}function Il(a){var b=0,c=0,d=0,e=0;gm(a);if(v[a>>2]){d=a;e=v[a>>2];b=v[a+4>>2];a:{while(1){if((b|0)==(e|0)){break a}c=zb(d);v[113382]=0;b=b-32|0;R(857,c|0,b|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}v[d+4>>2]=e;lt(zb(a),v[a>>2],wh(a))}}function AA(a){var b=0,c=0,d=0,e=0;Nh(a);if(v[a>>2]){d=a;e=v[a>>2];b=v[a+4>>2];a:{while(1){if((b|0)==(e|0)){break a}c=zb(d);v[113382]=0;b=b-24|0;R(491,c|0,b|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}v[d+4>>2]=e;Ff(zb(a),v[a>>2],Ye(a))}}function zC(a){var b=0,c=0,d=0,e=0;Ve(a);if(v[a>>2]){d=a;e=v[a>>2];b=v[a+4>>2];a:{while(1){if((b|0)==(e|0)){break a}c=zb(d);v[113382]=0;b=b-4|0;R(315,c|0,b|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}v[d+4>>2]=e;Se(zb(a),v[a>>2],nd(a))}}function wx(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;a:{if(!mf(a)){break a}while(1){if(!qh(Fe(a,e))){break a}d=d+1|0;e=d&65535;if(mf(a)>>>0>e>>>0){continue}break}}b:{if(c){c=65535;if(x[v[v[a+12>>2]+8>>2]+10>>1]<=(d&65535)>>>0){break b}}c=Og(a,d&65535,b)?d:-1}return c&65535}function sC(a){var b=0,c=0,d=0,e=0;Gj(a);if(v[a>>2]){d=a;e=v[a>>2];b=v[a+4>>2];a:{while(1){if((b|0)==(e|0)){break a}c=zb(d);v[113382]=0;b=b-2|0;R(328,c|0,b|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}v[d+4>>2]=e;Tn(zb(a),v[a>>2],Yf(a))}}function zL(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;b=jb-16|0;jb=b;c=b+8|0;e=c;d=jb-16|0;jb=d;Oc(d+8|0,a+116|0);v[113382]=0;a=Pa(168,a|0)|0;O()|0;a=a|0;f=v[113382];v[113382]=0;a:{if((f|0)!=1){jb=d+16|0;break a}a=P()|0;O()|0;S(a|0);L()}v[e>>2]=a;bp(c);jb=b+16|0;return v[c>>2]}function uf(a,b){var c=0,d=0,e=0,f=0;c=Db(a);a:{if((c|0)!=(Db(b)|0)){break a}d=Tb(a);b=Tb(b);b:{if(!he(a)){if(c){break b}return 1}return!Sm(d,b,c)}while(1){a=w[b|0];e=w[d|0];f=(a|0)==(e|0);if((a|0)!=(e|0)){break a}b=b+1|0;d=d+1|0;c=c-1|0;if(c){continue}break}}return f}function oC(a,b,c,d){var e=0,f=0;b=v[a+1072>>2]+((b&c?0-(c<<1)|0:0)+b|0)|0;v[a+1072>>2]=b;c=b+v[a+1076>>2]|0;v[a+1076>>2]=c;t[v[a+1064>>2]+d|0]=w[a+1080|0]?c:b;v[a+1060>>2]=v[a+1060>>2]+1;e=a,f=te(v[a+1056>>2])+v[a+1064>>2]|0,v[e+1064>>2]=f;v[a+1068>>2]=v[a+1068>>2]-1}function yo(a,b,c){var d=0,e=0,f=0;d=a*a;f=d*(d*d)*(d*1.58969099521155e-10+-2.5050760253406863e-8)+(d*(d*27557313707070068e-22+-.0001984126982985795)+.00833333333332249);e=d*a;if(!c){return e*(d*f+-.16666666666666632)+a}return a-(d*(b*.5-e*f)-b+e*.16666666666666632)}function aX(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;a:{if(!w[a+44|0]){c=(c|0)>0?c:0;while(1){if((c|0)==(d|0)){break a}if(((f=a,g=Hg(t[b|0]),e=v[v[a>>2]+52>>2],nb[e](f|0,g|0)|0)|0)==-1){return d|0}else{b=b+1|0;d=d+1|0;continue}}}c=Zi(b,1,c,v[a+32>>2])}return c|0}function hI(a){var b=0,c=0,d=0,e=0;if(v[a>>2]){d=v[a>>2];e=a;b=v[a+4>>2];a:{while(1){if((b|0)==(d|0)){break a}c=zb(e);v[113382]=0;b=b-16|0;R(2173,c|0,b|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}v[e+4>>2]=d;Xh(zb(a),v[a>>2],Wh(a))}}function Lca(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=jb-16|0;jb=d;v[d+12>>2]=c;v[d+8>>2]=v[a>>2];e=v[Lb(d+12|0,d+8|0)>>2];b=Eb(b);if(e){a=v[a+20>>2];c=e;while(1){f=a,g=Eb(w[b|0])^128,t[f|0]=g;a=a+1|0;b=b+1|0;c=c-1|0;if(c){continue}break}}jb=d+16|0;return e|0}function yC(a){var b=0,c=0,d=0,e=0;if(v[a>>2]){d=v[a>>2];e=a;b=v[a+4>>2];a:{while(1){if((b|0)==(d|0)){break a}c=zb(e);v[113382]=0;b=b-12|0;R(314,c|0,b|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}v[e+4>>2]=d;Ah(zb(a),v[a>>2],tg(a))}}function qQ(a){var b=0,c=0,d=0,e=0;if(v[a>>2]){d=v[a>>2];e=a;b=v[a+4>>2];a:{while(1){if((b|0)==(d|0)){break a}c=zb(e);v[113382]=0;b=b-20|0;R(846,c|0,b|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}v[e+4>>2]=d;Bp(zb(a),v[a>>2],Ap(a))}}function oQ(a){var b=0,c=0,d=0,e=0;c=jb-16|0;jb=c;v[c+12>>2]=-1;b=jb-16|0;jb=b;d=2;e=v[a>>2];if((e|0)!=1){v[b+12>>2]=e>>>1;v[b+8>>2]=-1-v[a>>2];d=Lb(b+12|0,b+8|0);v[b+12>>2]=v[a>>2]+v[d>>2];v[b+8>>2]=v[c+12>>2];d=v[Lb(b+12|0,b+8|0)>>2]}jb=b+16|0;jb=c+16|0;return d}function L2(a,b){a=a|0;b=b|0;var c=C(0),d=C(0);a:{if((b|0)<0){break a}a=a+24|0;if(x[v[a>>2]+480188>>1]<=b>>>0){break a}b=B(b,896);c=C(C(w[(b+v[a>>2]|0)+1075847|0])*C(.0078125));d=C(c*c);c=C(C(w[(b+v[a>>2]|0)+1075846|0])*C(.0078125));c=C(K(C(d+C(c*c))))}return C(c)}function rQ(a){var b=0,c=0,d=0,e=0;if(v[a>>2]){d=v[a>>2];e=a;b=v[a+4>>2];a:{while(1){if((b|0)==(d|0)){break a}c=zb(e);v[113382]=0;b=b-4|0;R(845,c|0,b|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}v[e+4>>2]=d;xj(zb(a),v[a>>2],nd(a))}}function rC(a){var b=0,c=0,d=0,e=0;if(v[a>>2]){d=v[a>>2];e=a;b=v[a+4>>2];a:{while(1){if((b|0)==(d|0)){break a}c=zb(e);v[113382]=0;b=b-1|0;R(326,c|0,b|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}v[e+4>>2]=d;cg(zb(a),v[a>>2],xf(a))}}function mj(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if(b?1:v[a+480180>>2]&1){e=v[a+24616>>2]&524288;b=0;while(1){c=(b<<5)+a|0;u[c+480286>>1]=64;d=c+480280|0;v[d>>2]=v[d>>2]&-257;d=c+480284|0;c=(b&3)-1>>>0<2;u[d>>1]=e?c<<8:c?192:64;b=b+1|0;if((b|0)!=127){continue}break}}}function dD(a){var b=0,c=0,d=0,e=0;if(v[a>>2]){d=v[a>>2];e=a;b=v[a+4>>2];a:{while(1){if((b|0)==(d|0)){break a}c=zb(e);v[113382]=0;b=b-8|0;R(248,c|0,b|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}v[e+4>>2]=d;Wu(zb(a),v[a>>2],Ui(a))}}function LS(a){var b=0,c=0,d=0,e=0;if(v[a>>2]){d=v[a>>2];e=a;b=v[a+4>>2];a:{while(1){if((b|0)==(d|0)){break a}c=zb(e);v[113382]=0;b=b-6|0;R(533,c|0,b|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}v[e+4>>2]=d;St(zb(a),v[a>>2],Mi(a))}}function wr(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=jb-16|0;jb=c;d=ba(16)|0;bG();a=$c(c+8|0,a,79880);v[113382]=0;e=v[a+4>>2];v[c>>2]=v[a>>2];v[c+4>>2]=e;W(2295,d|0,c|0,b|0)|0;a=v[113382];v[113382]=0;if((a|0)!=1){ha(d|0,54452,2296);L()}a=P()|0;O()|0;ca(d|0);S(a|0);L()}function wJ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=jb-16|0;jb=e;v[e+12>>2]=0;Le(a+12|0,d);if(b){d=b;if(b>>>0>2097151){fe(7217);L()}f=be(d<<11,4)}v[a>>2]=f;c=(c<<11)+f|0;v[a+8>>2]=c;v[a+4>>2]=c;g=gc(a),h=(b<<11)+f|0,v[g>>2]=h;jb=e+16|0;return a|0}function VE(a){a=a|0;var b=0,c=0,d=0;v[a>>2]=59568;b=v[a+8>>2];v[113382]=0;c=da(2335)|0;d=v[113382];v[113382]=0;a:{if((d|0)!=1){if((b|0)==(c|0)){break a}b=v[a+8>>2];v[113382]=0;hw(b);b=v[113382];v[113382]=0;if((b|0)!=1){break a}}V(0)|0;O()|0;Ab();L()}return a|0}function Nda(a){a=a|0;var b=0,c=0,d=0;c=jb-32|0;jb=c;b=255;a:{if(Mh(a)>>>0<=49){b=Ny(c,v[a+12>>2]);v[113382]=0;R(1142,a|0,b|0);d=v[113382];v[113382]=0;if((d|0)==1){break a}El(b);op(a,Mh(a)-1&255);b=Mh(a)-1|0}jb=c+32|0;return b&255}a=P()|0;O()|0;El(b);S(a|0);L()}function Mca(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=jb-16|0;jb=d;v[d+12>>2]=c;v[d+8>>2]=v[a>>2];e=v[Lb(d+12|0,d+8|0)>>2];b=Eb(b);if(e){a=v[a+20>>2];c=e;while(1){f=a,g=cn(w[b|0]),t[f|0]=g;a=a+1|0;b=b+1|0;c=c-1|0;if(c){continue}break}}jb=d+16|0;return e|0}function Jca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=jb-16|0;jb=e;v[e+12>>2]=c;v[e+8>>2]=v[a>>2];f=v[Lb(e+12|0,e+8|0)>>2];b=Eb(b);if(f){a=v[a+20>>2];c=f;while(1){d=Eb(w[b|0])+d|0;t[a|0]=d;a=a+1|0;b=b+1|0;c=c-1|0;if(c){continue}break}}jb=e+16|0;return f|0}function GE(a,b,c){var d=0;d=jb-16|0;jb=d;v[d+12>>2]=c;v[d+8>>2]=0;v[d+4>>2]=4;Xk(a,d+8|0,v[Lb(d+12|0,d+4|0)>>2]);a=mb;if((a|0)>0|(a|0)>=0){v[d+4>>2]=4;Lb(d+12|0,d+4|0)}v[d+4>>2]=v[d+8>>2];a=d+4|0;v[b>>2]=w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24);jb=d+16|0}function ek(a){var b=0,c=0;a:{b=v[a+1396>>2];if((b|0)>24){break a}if(!b){v[a+1392>>2]=0}while(1){if(w[a+1376|0]?0:v[a+1384>>2]){break a}c=Gr(a);if((c|0)==-1){break a}b=v[a+1396>>2];v[a+1396>>2]=b+8;v[a+1392>>2]=v[a+1392>>2]+(c<<b);if((b|0)<17){continue}break}}}function HD(a,b){var c=0,d=0,e=0,f=0,g=0;c=jb-16|0;jb=c;v[b>>2]=0;t[c+15|0]=0;f=$g(a,c+15|0);d=w[c+15|0];v[b>>2]=d>>>2;d=d&3;if(d){while(1){t[c+15|0]=0;g=$g(a,c+15|0);e=e+1|0;v[b>>2]=v[b>>2]|w[c+15|0]<<(e<<3)-2;f=f&g;if((d|0)!=(e|0)){continue}break}}jb=c+16|0}function jia(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=ru(a);a:{if(!b){break a}v[113382]=0;R(882,a|0,b|0);e=v[113382];v[113382]=0;if((e|0)!=1){v[113382]=0;U(883,a|0,b|0,c|0);b=v[113382];v[113382]=0;if((b|0)!=1){break a}}a=P()|0;O()|0;dq(d);S(a|0);L()}return a|0}function Mv(a){a=a|0;var b=0,c=0,d=0;b=v[a+8>>2];v[113382]=0;c=da(2335)|0;d=v[113382];v[113382]=0;a:{b:{if((d|0)==1){break b}if((b|0)!=(c|0)){b=v[a+8>>2];v[113382]=0;hw(b);b=v[113382];v[113382]=0;if((b|0)==1){break b}}break a}V(0)|0;O()|0;Ab();L()}return a|0}function FW(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;if(rg(a,v[b+8>>2],0)){vv(b,c,d);return}e=v[a+12>>2];f=a+16|0;ED(f,b,c,d);a:{if((e|0)<2){break a}e=(e<<3)+f|0;a=a+24|0;while(1){ED(a,b,c,d);if(w[b+54|0]){break a}a=a+8|0;if(e>>>0>a>>>0){continue}break}}}function vH(a,b,c,d){var e=0,f=0,g=0,h=0,i=0;a:{e=Lh(C(d*C(65536)));if((e|0)==65536){break a}f=B(b,c);if(!f){break a}c=e;e=e>>31;b=0;while(1){g=v[a>>2];h=a,i=zc(rma(qma(g,g>>31,c,e),mb,65536,0),mb),v[h>>2]=i;a=a+4|0;b=b+1|0;if((f|0)!=(b|0)){continue}break}}}function gU(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=py(a);a:{if(!b){break a}v[113382]=0;R(366,a|0,b|0);e=v[113382];v[113382]=0;if((e|0)!=1){v[113382]=0;U(367,a|0,b|0,c|0);b=v[113382];v[113382]=0;if((b|0)!=1){break a}}a=P()|0;O()|0;xs(d);S(a|0);L()}return a|0}function XR(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=cA(a);a:{if(!b){break a}v[113382]=0;R(642,a|0,b|0);e=v[113382];v[113382]=0;if((e|0)!=1){v[113382]=0;U(643,a|0,b|0,c|0);b=v[113382];v[113382]=0;if((b|0)!=1){break a}}a=P()|0;O()|0;Ft(d);S(a|0);L()}return a|0}function V_(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0;g=jb-16|0;jb=g;v[g+8>>2]=b;Ac(g,d);v[113382]=0;b=T(2339,g|0)|0;d=v[113382];v[113382]=0;if((d|0)!=1){Ob(g);lF(a,f+24|0,g+8|0,c,e,b);jb=g+16|0;return v[g+8>>2]}a=P()|0;O()|0;Ob(g);S(a|0);L()}function VW(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;f=jb-16|0;jb=f;d=oo(a);e=Db(a);a:{if(d-e>>>0>=c>>>0){if(!c){break a}d=Tb(a);yh(d+(e<<2)|0,b,c);b=c+e|0;Vg(a,b);v[f+12>>2]=0;Te(d+(b<<2)|0,f+12|0);break a}LD(a,d,(c+e|0)-d|0,e,e,0,c,b)}jb=f+16|0;return a|0}function Ut(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=Nu(a);a:{if(!b){break a}v[113382]=0;R(526,a|0,b|0);e=v[113382];v[113382]=0;if((e|0)!=1){v[113382]=0;U(527,a|0,b|0,c|0);b=v[113382];v[113382]=0;if((b|0)!=1){break a}}a=P()|0;O()|0;rq(d);S(a|0);L()}return a|0}function U_(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0;g=jb-16|0;jb=g;v[g+8>>2]=b;Ac(g,d);v[113382]=0;b=T(2339,g|0)|0;d=v[113382];v[113382]=0;if((d|0)!=1){Ob(g);kF(a,f+16|0,g+8|0,c,e,b);jb=g+16|0;return v[g+8>>2]}a=P()|0;O()|0;Ob(g);S(a|0);L()}function S0(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=jb-16|0;jb=d;e=er(a);v[a>>2]=65192;f=ww(a+32|0,d+8|0);v[a+48>>2]=c;v[a+44>>2]=0;v[113382]=0;R(159,a|0,b|0);b=v[113382];v[113382]=0;if((b|0)!=1){jb=d+16|0;return a|0}a=P()|0;O()|0;yb(f);$k(e);S(a|0);L()}function oba(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=jb-2496|0;jb=c;RJ(b,c,c+2496|0);b=lc(a,c,2496);v[b+2496>>2]=0;a:{if(v[b>>2]<0){break a}d=1;while(1){if(v[b+(d<<2)>>2]){break a}d=d+1|0;if((d|0)!=624){continue}break}v[b>>2]=-2147483648}jb=c+2496|0;return a|0}function np(a,b,c,d){var e=0,f=0,g=0,h=0;a:{e=vk(a,b);if((e|0)==255){break a}if(qj(a)){break a}b=Gi(a+314|0,e);e=gN(e);if(f=1,g=t[ec(b,10)|0]&1,h=d,h?f:g){jh(v[a>>2],e- -64&65535,fN(c,w[ec(b,2)|0]))}if(d){break a}jh(v[a>>2],e+67&65535,fN(c,w[ec(b,3)|0]))}}function e0(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;a:{while(1){if((d|0)!=(e|0)){a=-1;if((b|0)==(c|0)){break a}f=v[b>>2];g=v[d>>2];if((f|0)<(g|0)){break a}if((f|0)>(g|0)){return 1}else{d=d+4|0;b=b+4|0;continue}}break}a=(b|0)!=(c|0)}return a|0}function c7(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;aJ(a,b,c,d);v[a+4232>>2]=1056964608;b=a+4224|0;v[b>>2]=1056964608;v[b+4>>2]=1048406533;b=a+4216|0;v[b>>2]=1020054733;v[b+4>>2]=1065353216;v[a+4208>>2]=1056964608;v[a+4212>>2]=1065353216;v[a>>2]=76236;return a|0}function __(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0;g=jb-16|0;jb=g;v[g+8>>2]=b;Ac(g,d);v[113382]=0;b=T(21,g|0)|0;d=v[113382];v[113382]=0;if((d|0)!=1){Ob(g);oF(a,f+16|0,g+8|0,c,e,b);jb=g+16|0;return v[g+8>>2]}a=P()|0;O()|0;Ob(g);S(a|0);L()}function Tda(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=jb-32|0;jb=d;v[d+16>>2]=c;v[d+24>>2]=b;b=v[a>>2];e=d,f=ac(a),v[e+8>>2]=f;c=d+24|0;b=b+(Yp(c,d+8|0)<<1)|0;if(Jb(c,d+16|0)){Kn(a,kf(b+(Yp(d+16|0,d+24|0)<<1)|0,v[a+4>>2],b))}a=Pg(b);jb=d+32|0;return a|0}function Kr(a){var b=0,c=0,d=0,e=0;b=jb-16|0;jb=b;v[b+12>>2]=12;v[b+8>>2]=32;if(v[Lb(b+12|0,b+8|0)>>2]){while(1){e=bp(a);v[b+8>>2]=32;c=c<<15^e;d=d+15|0;if(d>>>0<y[Lb(b+12|0,b+8|0)>>2]){continue}break}}jb=b+16|0;a=v[b+12>>2];return(a>>>0>31?-1:-1<<a^-1)&c}function Kaa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=jb-16|0;jb=d;e=jb-16|0;jb=e;ZK(d,b,c<<24>>24);jb=e+16|0;b=d;c=Tb(d);e=Db(d);v[113382]=0;W(166,a|0,c|0,e|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){yb(b);jb=d+16|0;return a|0}a=P()|0;O()|0;yb(b);S(a|0);L()}function $_(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0;g=jb-16|0;jb=g;v[g+8>>2]=b;Ac(g,d);v[113382]=0;b=T(21,g|0)|0;d=v[113382];v[113382]=0;if((d|0)!=1){Ob(g);pF(a,f+24|0,g+8|0,c,e,b);jb=g+16|0;return v[g+8>>2]}a=P()|0;O()|0;Ob(g);S(a|0);L()}function oG(a,b){var c=0,d=0,e=0;o(+a);c=j(1)|0;d=j(0)|0;e=c;c=c>>>20&2047;if((c|0)!=2047){if(!c){c=b;if(a==0){b=0}else{a=oG(a*0x10000000000000000,b);b=v[b>>2]+-64|0}v[c>>2]=b;return a}v[b>>2]=c-1022;l(0,d|0);l(1,e&-2146435073|1071644672);a=+n()}return a}function M9(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=jb-32|0;jb=d;v[d+16>>2]=c;v[d+24>>2]=b;b=v[a>>2];e=d,f=ac(a),v[e+8>>2]=f;c=d+24|0;b=b+B(ms(c,d+8|0),6)|0;if(Jb(c,d+16|0)){aA(a,Ax(b+B(ms(d+16|0,d+24|0),6)|0,v[a+4>>2],b))}a=Pg(b);jb=d+32|0;return a|0}function qla(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=jb-16|0;jb=d;e=Rb(a,64);a:{if(e){c=d+8|0;wA(c,b);zd(a,c);break a}a=jb-16|0;jb=a;c=jb-16|0;jb=c;f=b- -64|0;while(1){ou(b);b=b+2|0;if((f|0)!=(b|0)){continue}break}jb=c+16|0;jb=a+16|0}jb=d+16|0;return e|0}function jj(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a:{d=jb-16|0;jb=d;b:{c:{if(!b){b=a;a=Tb(c);oi(b,a,Db(c)+a|0);break c}oJ(d,c);v[113382]=0;U(115,a|0,b|0,d|0);a=v[113382];v[113382]=0;if((a|0)==1){break b}Jc(d)}jb=d+16|0;break a}a=P()|0;O()|0;Jc(d);S(a|0);L()}}function Vla(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=jb-16|0;jb=d;e=Rb(a,64);a:{if(e){c=d+8|0;wA(c,b);zd(a,c);break a}a=jb-16|0;jb=a;c=jb-16|0;jb=c;f=b- -64|0;while(1){jf(b);b=b+1|0;if((f|0)!=(b|0)){continue}break}jb=c+16|0;jb=a+16|0}jb=d+16|0;return e|0}function Qx(a,b,c){var d=0,e=0,f=0,g=0;e=jb-16|0;jb=e;f=v[b+656>>2];d=0;a:{if(!f){break a}f=zu(f,c);d=e+8|0;g=a+1074312|0;Fb(d,g,31);a=0;if(!Cb(d)){Fb(e,g,93);a=Cb(e)^1}if(!(t[OK(b,c)|0]&1)){d=0;if(!(t[f+12|0]&1)|a){break a}}d=id(f)^1}jb=e+16|0;return d}function raa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;b=jb-16|0;jb=b;c=jd(a);e=b,f=ac(a),v[e+8>>2]=f;e=b,f=bc(a),v[e>>2]=f;if(Jb(b+8|0,b)){d=+(c>>>0);while(1){c=b+8|0;a=v[c>>2];A[a>>3]=A[a>>3]/d;A[a+8>>3]=A[a+8>>3]/d;Xf(c);if(Jb(c,b)){continue}break}}jb=b+16|0}function cB(a){var b=0,c=0,d=0,e=0;b=a+5|0;b=w[b|0]|w[b+1|0]<<8;c=b+w[a+2|0]|0;d=b>>>0>c>>>0?1:d;b=c;c=b<<1;b=d<<1|b>>>31;e=c;a=a+3|0;a=w[a|0]|w[a+1|0]<<8;d=a>>>30|0;c=a<<2;e=e+c|0;a=b+d|0;a=c>>>0>e>>>0?a+1|0:a;b=e+47|0;a=b>>>0<47?a+1|0:a;mb=a;return b}function rda(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=jb-16|0;jb=d;e=Rb(a,27);a:{if(e){c=d+8|0;$M(c,b);zd(a,c);break a}a=jb-16|0;jb=a;c=jb-16|0;jb=c;f=b+27|0;while(1){jf(b);b=b+1|0;if((f|0)!=(b|0)){continue}break}jb=c+16|0;jb=a+16|0}jb=d+16|0;return e|0}function gM(a,b,c){var d=0,e=0;d=v[(B(b,896)+a|0)+1075072>>2];a:{if(!(!(d&134218752)|(c|0)!=1)|d&67108864){break a}if(x[a+480188>>1]<=b>>>0){c=x[(B(b,896)+a|0)+1075792>>1];b=c?c-1|0:b}b=b&65535;if(b>>>0>126){break a}e=w[((b<<5)+a|0)+480288|0]}return e}function e9(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;if(!((c|0)!=4&(c|0)!=-1)){c=jb-16|0;jb=c;v[c+8>>2]=0;No(a,c+8|0);z[b>>2]=z[c+8>>2];jb=c+16|0;return}d=jb-16|0;jb=d;v[d+12>>2]=0;v[d+8>>2]=c;v[d+4>>2]=4;Xk(a,d+12|0,v[Lb(d+8|0,d+4|0)>>2]);v[b>>2]=0;jb=d+16|0}function _r(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a:{d=jb-16|0;jb=d;b:{c:{if(!b){b=a;a=Tb(c);oi(b,a,Db(c)+a|0);break c}BJ(d,b,c);v[113382]=0;R(116,a|0,d|0);a=v[113382];v[113382]=0;if((a|0)==1){break b}Jc(d)}jb=d+16|0;break a}a=P()|0;O()|0;Jc(d);S(a|0);L()}}function FB(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=jb-16|0;jb=d;e=Rb(a,16);a:{if(e){c=d+8|0;sB(c,b);zd(a,c);break a}a=jb-16|0;jb=a;c=jb-16|0;jb=c;f=b+16|0;while(1){jf(b);b=b+1|0;if((f|0)!=(b|0)){continue}break}jb=c+16|0;jb=a+16|0}jb=d+16|0;return e|0}function $z(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;a:{c=Oi(a+8|0);v[113382]=0;d=T(296,b|0)|0;e=v[113382];v[113382]=0;b:{if((e|0)==1){break b}v[113382]=0;U(429,a|0,b|0,d|0);a=v[113382];v[113382]=0;if((a|0)==1){break b}break a}a=P()|0;O()|0;Sg(c);S(a|0);L()}}function $F(a){var b=0,c=0;b=w[a+74|0];t[a+74|0]=b-1|b;if(y[a+20>>2]>y[a+28>>2]){nb[v[a+36>>2]](a,0,0)|0}v[a+28>>2]=0;v[a+16>>2]=0;v[a+20>>2]=0;b=v[a>>2];if(b&4){v[a>>2]=b|32;return-1}c=v[a+44>>2]+v[a+48>>2]|0;v[a+8>>2]=c;v[a+4>>2]=c;return b<<27>>31}function xl(a,b,c,d){var e=0;a:{if(b>>>0>255){break a}b:{switch(c|0){case 2:e=hM(a,b,d);if((e-1&255)>>>0<250){break a}case 0:return gM(a,b,d);case 3:e=gM(a,b,d);if((e-1&255)>>>0<250){break a}break;case 1:break b;default:break a}}e=hM(a,b,d)}return e}function aia(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=jb-16|0;jb=d;e=Rb(a,6);a:{if(e){c=d+8|0;jA(c,b);zd(a,c);break a}a=jb-16|0;jb=a;c=jb-16|0;jb=c;f=b+6|0;while(1){jf(b);b=b+1|0;if((f|0)!=(b|0)){continue}break}jb=c+16|0;jb=a+16|0}jb=d+16|0;return e|0}function Via(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=jb-16|0;jb=d;e=Rb(a,2);a:{if(e){c=d+8|0;Sk(c,b);zd(a,c);break a}a=jb-16|0;jb=a;c=jb-16|0;jb=c;f=b+2|0;while(1){jf(b);b=b+1|0;if((f|0)!=(b|0)){continue}break}jb=c+16|0;jb=a+16|0}jb=d+16|0;return e|0}function Tr(a){var b=0,c=0;b=a+24|0;c=v[b>>2];v[113382]=0;T(1365,c|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){gd(a+68|0);qf(a+36|0);vf(a+32|0);Gh(b);ad(a+4|0);ad(a);return a}V(0)|0;O()|0;gd(a+68|0);qf(a+36|0);vf(a+32|0);Gh(b);ad(a+4|0);ad(a);Ab();L()}function qz(a,b){var c=0,d=0,e=0,f=0;c=a;d=a+1024|0;if((d|0)!=(a|0)){f=b?224:240;while(1){a=c;b=a+16|0;if((a|0)!=(b|0)){while(1){e=((f&w[ec(a,0)|0])!=0)+e|0;a=a+4|0;if((b|0)!=(a|0)){continue}break}}c=c+16|0;if((d|0)!=(c|0)){continue}break}}return e}function oha(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;b=jb-160|0;jb=b;e=-1;d=jb-16|0;jb=d;c=d+8|0;f=b+8|0;XO(c,f);g=Hb(c);c=hd(a,$b(d,c));if((g|0)==(c|0)){Tc(a,Hb(d+8|0))}jb=d+16|0;a=(c|0)==(g|0);if(!a){YO(f)}if(a){e=hP(b+8|0)}jb=b+160|0;return e|0}function jT(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;d=jb-16|0;jb=d;e=Rb(a,8);a:{if(e){c=d+8|0;Uu(c,b);zd(a,c);break a}a=jb-16|0;jb=a;c=jb-16|0;jb=c;f=b+8|0;while(1){jf(b);b=b+1|0;if((f|0)!=(b|0)){continue}break}jb=c+16|0;jb=a+16|0}jb=d+16|0;return e|0}function Zla(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;b=jb-624|0;jb=b;e=-1;d=jb-16|0;jb=d;c=d+8|0;f=b+8|0;YS(c,f);g=Hb(c);c=hd(a,$b(d,c));if((g|0)==(c|0)){Tc(a,Hb(d+8|0))}jb=d+16|0;a=(c|0)==(g|0);if(!a){ZS(f)}if(a){e=aT(b+8|0)}jb=b+624|0;return e|0}function kka(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=jb-32|0;jb=e;v[e+24>>2]=d;d=Lj(a,c);pf(e,v[a+28>>2]);f=v[e+12>>2];v[e+16>>2]=v[e+8>>2];v[e+20>>2]=f;a:{if(!d){if(wd(a,5)){break a}}PR(v[a+28>>2],b,v[e+24>>2],0)}$i(a,d,c,e+16|0);jb=e+32|0}function jga(a,b){a=a|0;b=b|0;var c=0,d=0;c=py(a);a:{if(!b){break a}v[113382]=0;R(366,a|0,b|0);d=v[113382];v[113382]=0;if((d|0)!=1){v[113382]=0;R(1018,a|0,b|0);b=v[113382];v[113382]=0;if((b|0)!=1){break a}}a=P()|0;O()|0;xs(c);S(a|0);L()}return a|0}function T_(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;a=jb-16|0;jb=a;v[a+8>>2]=b;Ac(a,d);v[113382]=0;b=T(2339,a|0)|0;d=v[113382];v[113382]=0;if((d|0)!=1){Ob(a);jF(f+20|0,a+8|0,c,e,b);jb=a+16|0;return v[a+8>>2]}b=P()|0;O()|0;Ob(a);S(b|0);L()}function tla(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;b=jb-32|0;jb=b;e=-1;d=jb-16|0;jb=d;c=d+8|0;f=b+8|0;Lt(c,f);g=Hb(c);c=hd(a,$b(d,c));if((g|0)==(c|0)){Tc(a,Hb(d+8|0))}jb=d+16|0;a=(c|0)==(g|0);if(!a){uS(f)}if(a){e=yS(b+8|0)}jb=b+32|0;return e|0}function oM(a,b,c){var d=0,e=0,f=0,g=0;if((b|0)!=(c|0)){while(1){d=Eb(w[b|0]);e=v[a+4>>2];g=e>>>8|0;f=v[a>>2];e=(e&255)<<24|f>>>8;d=(((d^f)&255)<<3)+80368|0;f=v[d>>2];d=v[d+4>>2]^g;v[a>>2]=e^f;v[a+4>>2]=d;b=b+1|0;if((c|0)!=(b|0)){continue}break}}}function _j(a,b,c,d){var e=0;if(d&2048){t[a|0]=43;a=a+1|0}if(d&512){t[a|0]=35;a=a+1|0}while(1){e=w[b|0];if(e){t[a|0]=e;a=a+1|0;b=b+1|0;continue}break}e=d&74;b=111;a:{if((e|0)==64){break a}b=d&16384?88:120;if((e|0)==8){break a}b=c?100:117}t[a|0]=b}function Uja(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;b=jb-16|0;jb=b;e=-1;d=jb-16|0;jb=d;c=d+8|0;f=b+8|0;hu(c,f);g=Hb(c);c=hd(a,$b(d,c));if((g|0)==(c|0)){Tc(a,Hb(d+8|0))}jb=d+16|0;a=(c|0)==(g|0);if(!a){YA(f)}if(a){e=kR(b+8|0)}jb=b+16|0;return e|0}function $n(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;f=jb-16|0;jb=f;d=Fc(a);e=Db(a);a:{if(d-e>>>0>=c>>>0){if(!c){break a}d=Tb(a);ag(d+e|0,b,c);b=c+e|0;Vg(a,b);t[f+15|0]=0;Rd(b+d|0,f+15|0);break a}Yn(a,d,(c+e|0)-d|0,e,e,0,c,b)}jb=f+16|0;return a|0}function sM(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=jb-16|0;jb=a;d=v[b+104>>2];if(!(!d|!v[b+76>>2])){v[b+88>>2]=v[b+88>>2]&-131|128;d=v[d>>2];v[b+76>>2]=d;v[a+12>>2]=c<<8;v[a+8>>2]=d-1;c=d+(v[Lb(a+12|0,a+8|0)>>2]^-1)|0;v[b>>2]=0;v[b+4>>2]=c}jb=a+16|0}function rba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;e=jb-16|0;jb=e;if(!(!a|!b)){g=Bs(a);f=jb-16|0;jb=f;d=Bs(a);a=d;c=Bs(b);if(c){while(1){a=c;c=(d>>>0)%(a>>>0)|0;d=a;if(c){continue}break}}jb=f+16|0;c=B(Bs(b),(g|0)/(a|0)|0)}jb=e+16|0;return c|0}function Z_(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;a=jb-16|0;jb=a;v[a+8>>2]=b;Ac(a,d);v[113382]=0;b=T(21,a|0)|0;d=v[113382];v[113382]=0;if((d|0)!=1){Ob(a);nF(f+20|0,a+8|0,c,e,b);jb=a+16|0;return v[a+8>>2]}b=P()|0;O()|0;Ob(a);S(b|0);L()}function YR(a,b){a=a|0;b=b|0;var c=0,d=0;c=Nu(a);a:{if(!b){break a}v[113382]=0;R(526,a|0,b|0);d=v[113382];v[113382]=0;if((d|0)!=1){v[113382]=0;R(631,a|0,b|0);b=v[113382];v[113382]=0;if((b|0)!=1){break a}}a=P()|0;O()|0;rq(c);S(a|0);L()}return a|0}function $T(a,b){a=a|0;b=b|0;var c=0,d=0;c=CB(a);a:{if(!b){break a}v[113382]=0;R(368,a|0,b|0);d=v[113382];v[113382]=0;if((d|0)!=1){v[113382]=0;R(369,a|0,b|0);b=v[113382];v[113382]=0;if((b|0)!=1){break a}}a=P()|0;O()|0;zB(c);S(a|0);L()}return a|0}function uka(a,b){a=a|0;b=b|0;var c=0,d=0;c=eB(a);a:{if(!b){break a}v[113382]=0;R(36,a|0,b|0);d=v[113382];v[113382]=0;if((d|0)!=1){v[113382]=0;R(37,a|0,b|0);b=v[113382];v[113382]=0;if((b|0)!=1){break a}}a=P()|0;O()|0;IA(c);S(a|0);L()}return a|0}function uN(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;a=wN(b,zb(c));v[b>>2]=v[c>>2];v[b+4>>2]=v[c+4>>2];d=v[zb(c)>>2];e=zb(a),f=d,v[e>>2]=f;e=zb(c),f=0,v[e>>2]=f;v[c>>2]=0;v[c+4>>2]=0;rd(b+12|0,c+12|0);u[b+28>>1]=x[c+28>>1];v[b+24>>2]=v[c+24>>2]}function p$(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=jb-16|0;jb=e;v[e+12>>2]=b;v[e+8>>2]=d;b=Bh(e,e+12|0);v[113382]=0;a=W(2361,a|0,c|0,v[e+8>>2])|0;c=v[113382];v[113382]=0;if((c|0)!=1){Ge(b);jb=e+16|0;return a|0}a=P()|0;O()|0;Ge(b);S(a|0);L()}function j9(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=jb-32|0;jb=e;v[e+24>>2]=d;d=Lj(a,c);pf(e,v[a+28>>2]);f=v[e+12>>2];v[e+16>>2]=v[e+8>>2];v[e+20>>2]=f;a:{if(!d){if(wd(a,5)){break a}}LJ(v[a+28>>2],b,v[e+24>>2])}$i(a,d,c,e+16|0);jb=e+32|0}function bia(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=jb-16|0;jb=c;e=jb-16|0;jb=e;d=c+8|0;fc(d,b,1030);jb=e+16|0;e=Hb(d);d=mc(a,$b(c,d));if((e|0)==(d|0)){_b(a,Hb(c+8|0))}jb=c+16|0;a=(d|0)==(e|0);if(!a){c=jb-16|0;jb=c;Qb(b,0,1030);jb=c+16|0}return a|0}function Ze(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=Oi(a+8|0);v[113382]=0;U(429,a|0,b|0,c|0);c=v[113382];v[113382]=0;a:{if((c|0)!=1){a=v[a>>2];v[113382]=0;Q(304,b|0,a|0)|0;a=v[113382];v[113382]=0;if((a|0)!=1){break a}}a=P()|0;O()|0;Sg(d);S(a|0);L()}}function Xfa(a){a=a|0;var b=0,c=0,d=0,e=0;c=jO(a);if((c|0)!=(a|0)){while(1){b=0;e=a;MR(a);a:{while(1){d=b+e|0;if(w[d|0]){b=b+1|0;if((b|0)!=32){continue}break a}break}if(b>>>0>31){break a}Qb(d,0,32-b|0)}a=a+32|0;if((c|0)!=(a|0)){continue}break}}}function VK(a,b){var c=0,d=0,e=0;a:{if(!(w[a+89|0]&16)){break a}c=v[a+656>>2];if(!c){break a}d=b;c=v[c>>2];b:{if(c){e=a;a=v[a+696>>2]-(c<<1)|0;a=(a|0)>0?a:0;v[e+696>>2]=a;a=(B(a,v[b>>2])|0)/65536|0;break b}if(v[a+696>>2]){break a}a=0}v[d>>2]=a}}function xla(a,b){a=a|0;b=b|0;var c=0;b=jb-32|0;jb=b;c=-1;a:{if(!nA(a,b+16|0)){break a}c=0;if(!AS(b+16|0)){break a}if(v[b+16>>2]==1179472708){c=-1;if(!Tc(a,4)){break a}}c=-1;if(!Ij(a,b+8|0)){break a}c=v[b+8>>2]==1196314451}jb=b+32|0;return c|0}function hN(a){a=a|0;var b=0,c=0,d=0;b=jb-16|0;jb=b;if(w[a+530|0]){while(1){d=c&65535;yi(a,d,1);c=c+1|0;if(d>>>0<255){continue}break}t[a+530|0]=0}t[b+15|0]=0;Qh(a+4|0,18,b+15|0);Iz(a+22|0,18,25882);t[b+14|0]=255;Qh(a+58|0,256,b+14|0);jb=b+16|0}function ge(){var a=0,b=0;a:{b:{if(t[453736]&1){break b}if(!vd(453736)){break b}v[113382]=0;a=W(2337,2147483647,10140,0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break a}v[113433]=a;ud(453736)}return v[113433]}a=P()|0;O()|0;ne(453736);S(a|0);L()}function OC(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;rd(b,c);fm(b+12|0,c+12|0);a=jb-16|0;jb=a;c=c+28|0;d=a,e=ke(c),v[d+12>>2]=e;v[113382]=0;W(247,b+28|0,a+12|0,c|0)|0;b=v[113382];v[113382]=0;a:{if((b|0)!=1){jb=a+16|0;break a}V(0)|0;O()|0;Ab();L()}}function zo(a,b){var c=0,d=0,e=0,f=0;c=a*a;d=c*.5;e=1-d;f=1-e-d;d=c*c;return e+(f+(c*(c*(c*(c*2480158728947673e-20+-.001388888888887411)+.0416666666666666)+d*d*(c*(c*-1.1359647557788195e-11+2.087572321298175e-9)+-2.7557314351390663e-7))-a*b))}function lia(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=jb-16|0;jb=c;e=jb-16|0;jb=e;d=c+8|0;fc(d,b,274);jb=e+16|0;e=Hb(d);d=mc(a,$b(c,d));if((e|0)==(d|0)){_b(a,Hb(c+8|0))}jb=c+16|0;a=(d|0)==(e|0);if(!a){c=jb-16|0;jb=c;Qb(b,0,274);jb=c+16|0}return a|0}function hia(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=jb-16|0;jb=c;e=jb-16|0;jb=e;d=c+8|0;fc(d,b,106);jb=e+16|0;e=Hb(d);d=mc(a,$b(c,d));if((e|0)==(d|0)){_b(a,Hb(c+8|0))}jb=c+16|0;a=(d|0)==(e|0);if(!a){c=jb-16|0;jb=c;Qb(b,0,106);jb=c+16|0}return a|0}function fma(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=jb-16|0;jb=c;e=jb-16|0;jb=e;d=c+8|0;fc(d,b,136);jb=e+16|0;e=Hb(d);d=mc(a,$b(c,d));if((e|0)==(d|0)){_b(a,Hb(c+8|0))}jb=c+16|0;a=(d|0)==(e|0);if(!a){c=jb-16|0;jb=c;Qb(b,0,136);jb=c+16|0}return a|0}function Xia(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=jb-16|0;jb=c;e=jb-16|0;jb=e;d=c+8|0;fc(d,b,422);jb=e+16|0;e=Hb(d);d=mc(a,$b(c,d));if((e|0)==(d|0)){_b(a,Hb(c+8|0))}jb=c+16|0;a=(d|0)==(e|0);if(!a){c=jb-16|0;jb=c;Qb(b,0,422);jb=c+16|0}return a|0}function Tia(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=jb-16|0;jb=c;e=jb-16|0;jb=e;d=c+8|0;fc(d,b,826);jb=e+16|0;e=Hb(d);d=mc(a,$b(c,d));if((e|0)==(d|0)){_b(a,Hb(c+8|0))}jb=c+16|0;a=(d|0)==(e|0);if(!a){c=jb-16|0;jb=c;Qb(b,0,826);jb=c+16|0}return a|0}function ls(a,b,c){var d=0,e=0;d=jb-32|0;jb=d;a:{e=!b|!c;if(!e){b=Ub(d,b);v[113382]=0;U(1535,d+16|0,b|0,c|0);c=v[113382];v[113382]=0;if((c|0)==1){break a}c=a+36|0;a=d+16|0;Gb(c,a);yb(a);yb(b)}jb=d+32|0;return!e}a=P()|0;O()|0;yb(b);S(a|0);L()}function XF(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=jb-16|0;jb=e;if(d>>>0<=4294967279){a:{if(d>>>0<=10){Ce(a,c);d=a;break a}f=Wi(d)+1|0;d=Zg(a,f);Oe(a,d);Gf(a,f);ae(a,c)}ag(d,b,c);t[e+15|0]=0;Rd(c+d|0,e+15|0);jb=e+16|0;return}If();L()}function X9(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=jb-16|0;jb=c;e=jb-16|0;jb=e;d=c+8|0;fc(d,b,326);jb=e+16|0;e=Hb(d);d=mc(a,$b(c,d));if((e|0)==(d|0)){_b(a,Hb(c+8|0))}jb=c+16|0;a=(d|0)==(e|0);if(!a){c=jb-16|0;jb=c;Qb(b,0,326);jb=c+16|0}return a|0}function VQ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=jb-16|0;jb=c;e=jb-16|0;jb=e;d=c+8|0;fc(d,b,284);jb=e+16|0;e=Hb(d);d=mc(a,$b(c,d));if((e|0)==(d|0)){_b(a,Hb(c+8|0))}jb=c+16|0;a=(d|0)==(e|0);if(!a){c=jb-16|0;jb=c;Qb(b,0,284);jb=c+16|0}return a|0}function $9(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=jb-16|0;jb=c;e=jb-16|0;jb=e;d=c+8|0;fc(d,b,225);jb=e+16|0;e=Hb(d);d=mc(a,$b(c,d));if((e|0)==(d|0)){_b(a,Hb(c+8|0))}jb=c+16|0;a=(d|0)==(e|0);if(!a){c=jb-16|0;jb=c;Qb(b,0,225);jb=c+16|0}return a|0}function yM(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=jb-16|0;jb=d;a:{if(!c){break a}v[b+40>>2]=c;if(v[a+480180>>2]!=256){break a}v[d+12>>2]=c>>>4;v[d+8>>2]=1;e=b,f=v[Vc(d+12|0,d+8|0)>>2],v[e+40>>2]=f;e=b,f=mM(c&255),v[e+44>>2]=f}jb=d+16|0}function nla(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=jb-16|0;jb=c;e=jb-16|0;jb=e;d=c+8|0;fc(d,b,34);jb=e+16|0;e=Hb(d);d=mc(a,$b(c,d));if((e|0)==(d|0)){_b(a,Hb(c+8|0))}jb=c+16|0;a=(d|0)==(e|0);if(!a){c=jb-16|0;jb=c;Qb(b,0,34);jb=c+16|0}return a|0}function jv(){var a=0,b=0,c=0,d=0;c=jb-16|0;jb=c;b=AE(Pe(12));a=jb-16|0;jb=a;v[113382]=0;v[a+12>>2]=b;b=c+8|0;W(238,b|0,a+12|0,a+8|0)|0;d=v[113382];v[113382]=0;a:{if((d|0)!=1){jb=a+16|0;break a}V(0)|0;O()|0;Ab();L()}jb=c+16|0;return v[b>>2]}function ija(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=jb-16|0;jb=c;e=jb-16|0;jb=e;d=c+8|0;fc(d,b,42);jb=e+16|0;e=Hb(d);d=mc(a,$b(c,d));if((e|0)==(d|0)){_b(a,Hb(c+8|0))}jb=c+16|0;a=(d|0)==(e|0);if(!a){c=jb-16|0;jb=c;Qb(b,0,42);jb=c+16|0}return a|0}function gia(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=jb-16|0;jb=c;e=jb-16|0;jb=e;d=c+8|0;fc(d,b,72);jb=e+16|0;e=Hb(d);d=mc(a,$b(c,d));if((e|0)==(d|0)){_b(a,Hb(c+8|0))}jb=c+16|0;a=(d|0)==(e|0);if(!a){c=jb-16|0;jb=c;Qb(b,0,72);jb=c+16|0}return a|0}function dla(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;b=jb-160|0;jb=b;e=-1;d=jb-16|0;jb=d;g=b;c=d+8|0;gS(c,b);f=Hb(c);c=hd(a,$b(d,c));if((f|0)==(c|0)){Tc(a,Hb(d+8|0))}jb=d+16|0;a=(c|0)==(f|0);if(!a){hS(g)}if(a){e=kS(b)}jb=b+160|0;return e|0}function caa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=jb-16|0;jb=c;e=jb-16|0;jb=e;d=c+8|0;fc(d,b,73);jb=e+16|0;e=Hb(d);d=mc(a,$b(c,d));if((e|0)==(d|0)){_b(a,Hb(c+8|0))}jb=c+16|0;a=(d|0)==(e|0);if(!a){c=jb-16|0;jb=c;Qb(b,0,73);jb=c+16|0}return a|0}function Zaa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;b=(b-a|0)/160|0;if((b|0)>0){while(1){f=a;d=c;v[a>>2]=v[d>>2];e=a+4|0;if((e|0)!=(d+4|0)){$K(e,v[d+4>>2],v[d+8>>2])}lc(f+16|0,d+16|0,144);a=a+160|0;d=b>>>0>1;b=b-1|0;if(d){continue}break}}}function Qja(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=jb-16|0;jb=c;e=jb-16|0;jb=e;d=c+8|0;fc(d,b,91);jb=e+16|0;e=Hb(d);d=mc(a,$b(c,d));if((e|0)==(d|0)){_b(a,Hb(c+8|0))}jb=c+16|0;a=(d|0)==(e|0);if(!a){c=jb-16|0;jb=c;Qb(b,0,91);jb=c+16|0}return a|0}function Qga(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;b=jb-208|0;jb=b;e=-1;d=jb-16|0;jb=d;g=b;c=d+8|0;CO(c,b);f=Hb(c);c=hd(a,$b(d,c));if((f|0)==(c|0)){Tc(a,Hb(d+8|0))}jb=d+16|0;a=(c|0)==(f|0);if(!a){DO(g)}if(a){e=IO(b)}jb=b+208|0;return e|0}function Kha(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=jb-16|0;jb=c;e=jb-16|0;jb=e;d=c+8|0;fc(d,b,71);jb=e+16|0;e=Hb(d);d=mc(a,$b(c,d));if((e|0)==(d|0)){_b(a,Hb(c+8|0))}jb=c+16|0;a=(d|0)==(e|0);if(!a){c=jb-16|0;jb=c;Qb(b,0,71);jb=c+16|0}return a|0}function fU(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=jb-16|0;jb=c;e=jb-16|0;jb=e;d=c+8|0;fc(d,b,59);jb=e+16|0;e=Hb(d);d=mc(a,$b(c,d));if((e|0)==(d|0)){_b(a,Hb(c+8|0))}jb=c+16|0;a=(d|0)==(e|0);if(!a){c=jb-16|0;jb=c;Qb(b,0,59);jb=c+16|0}return a|0}function V9(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=jb-16|0;jb=c;e=jb-16|0;jb=e;d=c+8|0;fc(d,b,60);jb=e+16|0;e=Hb(d);d=mc(a,$b(c,d));if((e|0)==(d|0)){_b(a,Hb(c+8|0))}jb=c+16|0;a=(d|0)==(e|0);if(!a){c=jb-16|0;jb=c;Qb(b,0,60);jb=c+16|0}return a|0}function FA(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=jb-16|0;jb=c;e=jb-16|0;jb=e;d=c+8|0;fc(d,b,50);jb=e+16|0;e=Hb(d);d=mc(a,$b(c,d));if((e|0)==(d|0)){_b(a,Hb(c+8|0))}jb=c+16|0;a=(d|0)==(e|0);if(!a){c=jb-16|0;jb=c;Qb(b,0,50);jb=c+16|0}return a|0}function ES(a,b,c,d){var e=0,f=0,g=0,h=0;e=jb-16|0;jb=e;v[e+12>>2]=0;Le(a+12|0,d);if(b){d=b;if(b>>>0>89478485){fe(7217);L()}f=be(B(d,48),4)}v[a>>2]=f;c=B(c,48)+f|0;v[a+8>>2]=c;v[a+4>>2]=c;g=gc(a),h=B(b,48)+f|0,v[g>>2]=h;jb=e+16|0;return a}function n5(a,b){a=a|0;b=b|0;var c=0,d=0;c=jb-32|0;jb=c;b=b+4|0;d=v[b+48>>2];a:{if(d&16){if(y[b+24>>2]>y[b+44>>2]){v[b+44>>2]=v[b+24>>2]}oi(a,v[b+20>>2],v[b+44>>2]);break a}if(d&8){oi(a,v[b+8>>2],v[b+16>>2]);break a}ww(a,c+8|0)}jb=c+32|0}function kU(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;b=jb-48|0;jb=b;e=-1;d=jb-16|0;jb=d;g=b;c=d+8|0;tB(c,b);f=Hb(c);c=hd(a,$b(d,c));if((f|0)==(c|0)){Tc(a,Hb(d+8|0))}jb=d+16|0;a=(c|0)==(f|0);if(!a){uB(g)}if(a){e=HB(b)}jb=b+48|0;return e|0}function QD(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a:{if(a-b>>2>>>0<c>>>0){while(1){c=c-1|0;d=c<<2;v[d+a>>2]=v[b+d>>2];if(c){continue}break a}}if(!c){break a}d=a;while(1){v[d>>2]=v[b>>2];d=d+4|0;b=b+4|0;c=c-1|0;if(c){continue}break}}return a|0}function oaa(a,b){a=a|0;b=b|0;var c=0,d=0;c=jb-32|0;jb=c;a:{if(tg(a)>>>0<b>>>0){d=zb(a);b=Wj(c+8|0,b,xc(a),d);v[113382]=0;R(1219,a|0,b|0);a=v[113382];v[113382]=0;if((a|0)==1){break a}Ls(b)}jb=c+32|0;return}a=P()|0;O()|0;Ls(b);S(a|0);L()}function lp(a,b){var c=0,d=0,e=0,f=0,g=0,h=0;f=1/(A[v[a+4>>2]-8>>3]-A[v[a>>2]>>3]);while(1){d=-Md(A[Vk(a,c)>>3]*131072*f);a:{if(D(d)<2147483648){e=~~d;break a}e=-2147483648}g=Xe(b,c),h=e,v[g>>2]=h;c=c+1|0;if((c|0)!=2048){continue}break}}function Py(a){var b=0,c=0;b=jb-16|0;jb=b;v[a>>2]=0;v[a+4>>2]=0;v[113382]=0;v[b+12>>2]=0;W(1130,a+8|0,b+12|0,b+8|0)|0;c=v[113382];v[113382]=0;a:{if((c|0)!=1){jb=b+16|0;break a}V(0)|0;O()|0;Ab();L()}v[a+12>>2]=0;u[a+16>>1]=65280;return a}function hja(a,b){a=a|0;b=b|0;var c=0,d=0;c=jb-32|0;jb=c;a:{if(Yf(a)>>>0<b>>>0){d=zb(a);b=Sn(c+8|0,b,oc(a),d);v[113382]=0;R(346,a|0,b|0);a=v[113382];v[113382]=0;if((a|0)==1){break a}Cj(b)}jb=c+32|0;return}a=P()|0;O()|0;Cj(b);S(a|0);L()}function bq(a,b,c,d){var e=0,f=0,g=0,h=0;e=jb-16|0;jb=e;v[e+12>>2]=0;Le(a+12|0,d);if(b){d=b;if(b>>>0>2147483647){fe(7217);L()}f=be(d<<1,1)}v[a>>2]=f;c=(c<<1)+f|0;v[a+8>>2]=c;v[a+4>>2]=c;g=gc(a),h=(b<<1)+f|0,v[g>>2]=h;jb=e+16|0;return a}function _ia(a,b){a=a|0;b=b|0;var c=0,d=0;c=jb-32|0;jb=c;a:{if(xf(a)>>>0<b>>>0){d=zb(a);b=ph(c+8|0,b,wc(a),d);v[113382]=0;R(330,a|0,b|0);a=v[113382];v[113382]=0;if((a|0)==1){break a}Tg(b)}jb=c+32|0;return}a=P()|0;O()|0;Tg(b);S(a|0);L()}function Q7(a,b){a=a|0;b=b|0;var c=0,d=0;c=jb-32|0;jb=c;a:{if(nd(a)>>>0<b>>>0){d=zb(a);b=Nf(c+8|0,b,Kb(a),d);v[113382]=0;R(1728,a|0,b|0);a=v[113382];v[113382]=0;if((a|0)==1){break a}$r(b)}jb=c+32|0;return}a=P()|0;O()|0;$r(b);S(a|0);L()}function Kga(a,b){a=a|0;b=b|0;var c=0,d=0;c=jb-32|0;jb=c;a:{if(tg(a)>>>0<b>>>0){d=zb(a);b=Wj(c+8|0,b,xc(a),d);v[113382]=0;R(979,a|0,b|0);a=v[113382];v[113382]=0;if((a|0)==1){break a}ct(b)}jb=c+32|0;return}a=P()|0;O()|0;ct(b);S(a|0);L()}function Yia(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=jb-16|0;jb=d;b=uQ(d,b);e=jb-16|0;jb=e;b=uQ(e,b);f=jb-16|0;jb=f;g=d+8|0;Oq(g,v[b>>2],v[b>>2]+mQ(b)|0);jb=f+16|0;jb=e+16|0;bv(a,g);v[a+12>>2]=c;v[a+8>>2]=0;jb=d+16|0;return a|0}function SU(a,b){a=a|0;b=b|0;var c=0,d=0;c=jb-32|0;jb=c;a:{if(nd(a)>>>0<b>>>0){d=zb(a);b=Nf(c+8|0,b,Kb(a),d);v[113382]=0;R(309,a|0,b|0);a=v[113382];v[113382]=0;if((a|0)==1){break a}wq(b)}jb=c+32|0;return}a=P()|0;O()|0;wq(b);S(a|0);L()}function zla(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;DS(a);zb(a);c=b+4|0;e=v[a>>2];d=v[a+4>>2]-e|0;f=v[c>>2]+B((d|0)/-48|0,48)|0;v[c>>2]=f;if((d|0)>0){lc(f,e,d)}dc(a,c);dc(a+4|0,b+8|0);dc(zb(a),gc(b));v[b>>2]=v[b+4>>2];Ni(a);Nl(a);Nl(a)}function zja(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;iR(a);zb(a);c=b+4|0;e=v[a>>2];d=v[a+4>>2]-e|0;f=v[c>>2]+B((d|0)/-33|0,33)|0;v[c>>2]=f;if((d|0)>0){lc(f,e,d)}dc(a,c);dc(a+4|0,b+8|0);dc(zb(a),gc(b));v[b>>2]=v[b+4>>2];Ak(a);Kl(a);Kl(a)}function xX(a){a=a|0;if(y[a+24>>2]>y[a+44>>2]){v[a+44>>2]=v[a+24>>2]}a:{if(!(w[a+48|0]&8)){break a}if(y[a+16>>2]<y[a+44>>2]){sm(a,v[a+8>>2],v[a+12>>2],v[a+44>>2])}if(y[a+12>>2]>=y[a+16>>2]){break a}return Hg(t[v[a+12>>2]])|0}return-1}function go(a,b){var c=0,d=0;c=b+4|0;c=w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24);b=w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24);a:{if(b>>>0>=wc(a)>>>0){break a}if(wc(a)>>>0<c>>>0){break a}d=(c|0)!=0&c>>>0<=wc(a)-b>>>0}return d}function _8(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=jb-16|0;jb=d;c=0;a:{if(!Kb(a)){break a}while(1){zf(d,v[Pb(a,e)>>2]+40|0);c=Kp(d,b);yb(d);if(c){c=v[Pb(a,e)>>2];break a}e=e+1|0;if(Kb(a)>>>0>e>>>0){continue}break}c=0}jb=d+16|0;return c|0}function MK(a,b,c){var d=0,e=0,f=0,g=0,h=0;if(b){g=c;h=c>>31;c=0;while(1){d=v[a>>2];e=v[a+4>>2];f=(d+e|0)/2|0;d=d-e|0;d=zc(rma(qma(d,d>>31,g,h),mb,256,0),mb);v[a+4>>2]=f-d;v[a>>2]=d+f;a=a+8|0;c=c+1|0;if((c|0)!=(b|0)){continue}break}}}function L6(a,b,c){a=a|0;b=b|0;c=C(c);var d=0;d=jb-16|0;jb=d;z[d+12>>2]=c;if((b|0)<=12){Wd(d+12|0,C(0));c=z[d+12>>2];if((b|0)==12){c=C(de(C(c*C(3)))*C(.3333333432674408));z[d+12>>2]=c}z[((b<<2)+a|0)+4208>>2]=c;t[a+5046|0]=1}jb=d+16|0}function I7(a){a=a|0;var b=0;nb[v[v[a>>2]+124>>2]](a);lx(a);v[a+4236>>2]=0;t[a+4202|0]=1;b=nb[v[v[a>>2]+188>>2]](a)|0;v[a+4272>>2]=0;z[a+4240>>2]=b?C(.5):C(1);b=v[a+4256>>2];v[a+4292>>2]=b;v[a+4288>>2]=b;v[a+4284>>2]=b;v[a+4280>>2]=b}function ug(a,b,c){c=v[c+4>>2]&176;if((c|0)==32){return b}a:{if((c|0)!=16){break a}b:{c:{c=w[a|0];switch(c-43|0){case 0:case 2:break c;default:break b}}return a+1|0}if((c|0)!=48|(b-a|0)<2|(w[a+1|0]|32)!=120){break a}a=a+2|0}return a}function Pla(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=jb-16|0;jb=c;d=c+8|0;vu(d,b);e=Hb(d);d=mc(a,$b(c,d));if((e|0)==(d|0)){_b(a,Hb(c+8|0))}jb=c+16|0;a=(d|0)==(e|0);if(!a){c=jb-16|0;jb=c;t[b|0]=0;t[b+1|0]=0;t[b+2|0]=0;jb=c+16|0}return a|0}function ZW(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a:{if(!w[a+44|0]){c=(c|0)>0?c:0;while(1){if((c|0)==(d|0)){break a}if((nb[v[v[a>>2]+52>>2]](a,v[b>>2])|0)==-1){return d|0}else{b=b+4|0;d=d+1|0;continue}}}c=Zi(b,4,c,v[a+32>>2])}return c|0}function Qka(a,b){a=a|0;b=b|0;var c=0;c=jb-32|0;jb=c;a:{if(b){Ub(c,b);break a}Xb(c)}v[113382]=0;R(627,c+16|0,c|0);b=v[113382];v[113382]=0;if((b|0)!=1){b=c+16|0;rd(a,b);yb(b);yb(c);jb=c+32|0;return a|0}a=P()|0;O()|0;yb(c);S(a|0);L()}function xd(a,b){var c=0,d=0,e=0,f=0,g=0;c=x[a+20>>1];if(c){d=x[a+22>>1];g=c+d|0;c=d;while(1){e=((c&127)<<2)+a|0;f=x[e+28>>1]+b|0;u[e+28>>1]=f;if((f&65535)>>>0>=2048){u[a+20>>1]=c-d;return}c=c+1|0;if((g|0)!=(c|0)){continue}break}}}function Of(a,b){var c=0,d=0,e=0,f=0;c=x[a+24>>1]<<17;e=x[a+20>>1];if(e){d=x[a+22>>1];e=e+d|0;while(1){f=c;c=((d&127)<<2)+a|0;c=f-B(v[Xe(b,x[c+28>>1])>>2],u[c+26>>1])|0;d=d+1|0;if((e|0)!=(d|0)){continue}break}}return(c|0)/32768|0}function Nf(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=jb-16|0;jb=e;v[e+12>>2]=0;Le(a+12|0,d);if(b){f=Po(v[a+16>>2],b)}v[a>>2]=f;c=(c<<2)+f|0;v[a+8>>2]=c;v[a+4>>2]=c;g=gc(a),h=(b<<2)+f|0,v[g>>2]=h;jb=e+16|0;return a|0}function AL(a,b){a=a|0;b=b|0;wL(a);wL(a+368680|0);if(b){GK(a,1);return a|0}FK();kf(214576,280112,a+131112|0);kf(280112,345648,a+196648|0);kf(345648,411184,a+262184|0);kf(83488,214576,a+24|0);lc(a+327720|0,411184,40960);return a|0}function vd(a){var b=0,c=0,d=0;c=jb-16|0;jb=c;a=Av(c,a);d=jb-16|0;jb=d;if(!w[v[Oc(d+8|0,v[a+4>>2])>>2]]){a:{b:{a=v[a+8>>2];b=w[a|0];if((b|0)!=1){if(b&2){break b}t[a|0]=2;a=1}else{a=0}break a}L()}b=a}jb=d+16|0;jb=c+16|0;return b}function oD(){var a=0,b=0,c=0;b=jb-16|0;jb=b;a=Ub(b,10486);a:{if(!Db(a)){break a}c=1;if(($f(a,10335)|0)!=-1){break a}if(($f(a,12897)|0)!=-1){break a}if(($f(a,9701)|0)!=-1){break a}c=($f(a,9744)|0)!=-1}yb(a);jb=b+16|0;return c|0}function Kc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;d=cf(b);e=jb-16|0;jb=e;c=Fc(a);a:{if(c>>>0>=d>>>0){c=Tb(a);am(c,b,d);t[e+15|0]=0;Rd(d+c|0,e+15|0);Vg(a,d);break a}f=c;g=d-c|0;c=Db(a);Yn(a,f,g,c,0,c,d,b)}jb=e+16|0;return a|0}function Cga(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;fj(a);zb(a);c=b+4|0;e=v[a>>2];d=v[a+4>>2]-e|0;f=v[c>>2]+B((d|0)/-12|0,12)|0;v[c>>2]=f;if((d|0)>0){lc(f,e,d)}dc(a,c);dc(a+4|0,b+8|0);dc(zb(a),gc(b));v[b>>2]=v[b+4>>2];to(a,xc(a))}function $O(a,b){var c=0,d=0,e=0,f=0;c=jb-32|0;jb=c;d=v[a+4>>2];e=v[a>>2];v[c+24>>2]=e;v[c+28>>2]=d;f=v[b+4>>2];a=v[b>>2];v[c+16>>2]=a;v[c+20>>2]=f;v[c+8>>2]=e;v[c+12>>2]=d;v[c>>2]=a;v[c+4>>2]=f;a=BP(c+8|0,c);jb=c+32|0;return a}function $E(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=jb-32|0;jb=d;v[d+16>>2]=b;v[d+24>>2]=a;v[d+8>>2]=c;while(1){a=Jb(d+24|0,d+16|0);if(!(!a|v[v[d+24>>2]>>2]!=v[v[d+8>>2]>>2])){Ie(d+24|0);Ie(d+8|0);continue}break}jb=d+32|0;return a^1}function R1(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;Nh(a);zb(a);c=b+4|0;e=v[a>>2];d=v[a+4>>2]-e|0;f=v[c>>2]+B((d|0)/-24|0,24)|0;v[c>>2]=f;if((d|0)>0){lc(f,e,d)}dc(a,c);dc(a+4|0,b+8|0);dc(zb(a),gc(b));v[b>>2]=v[b+4>>2];Yt(a,Cd(a))}function fga(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=jb-16|0;jb=d;v[d+12>>2]=c;v[d>>2]=4896;c=v[Lb(d+12|0,d)>>2];if(!Rb(a,c)){c=$e(a)}Uz(d,b);kg(a,v[d>>2],c);Uz(d,b);Qb(v[d>>2]+c|0,0,4896-c|0);_b(a,v[d+12>>2]);jb=d+16|0;return c|0}function VC(a){var b=0;b=jb-16|0;jb=b;t[a|0]=0;t[a+1|0]=0;t[a+2|0]=0;t[a+3|0]=0;t[a+4|0]=0;t[a+5|0]=0;t[a+6|0]=0;t[a+7|0]=0;t[a+6|0]=0;t[a+7|0]=0;t[a+8|0]=0;t[a+9|0]=0;t[a+10|0]=0;t[a+11|0]=0;t[a+12|0]=0;t[a+13|0]=0;jb=b+16|0}function Rs(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;f=jb-16|0;jb=f;if(b){e=Fc(a);d=Db(a);g=d+b|0;if(e-d>>>0<b>>>0){Rl(a,e,g-e|0,d,d,0,0)}e=d;d=Tb(a);Ey(e+d|0,b,c);Vg(a,g);t[f+15|0]=0;Rd(d+g|0,f+15|0)}jb=f+16|0;return a|0}function PK(a){var b=0,c=0,d=0;b=jb-16|0;jb=b;v[b+12>>2]=7;v[b+8>>2]=32;if(v[Lb(b+12|0,b+8|0)>>2]){while(1){d=bp(a);v[b+12>>2]=7;v[b+8>>2]=32;c=c+15|0;if(c>>>0<y[Lb(b+12|0,b+8|0)>>2]){continue}break}c=d&127}jb=b+16|0;return c}function I2(a,b){a=a|0;b=b|0;var c=C(0);a:{if((b|0)<0){break a}a=a+24|0;if(x[v[a>>2]+480188>>1]<=b>>>0){break a}b=B(b,896);if(!(t[(b+v[a>>2]|0)+1075073|0]&1)){break a}c=C(C(w[(b+v[a>>2]|0)+1075846|0])*C(.0078125))}return C(c)}function H2(a,b){a=a|0;b=b|0;var c=C(0);a:{if((b|0)<0){break a}a=a+24|0;if(x[v[a>>2]+480188>>1]<=b>>>0){break a}b=B(b,896);if(!(t[(b+v[a>>2]|0)+1075073|0]&1)){break a}c=C(C(w[(b+v[a>>2]|0)+1075847|0])*C(.0078125))}return C(c)}function KE(){var a=0;a:{b:{if(t[453748]&1){break b}if(!vd(453748)){break b}v[113382]=0;da(2441)|0;a=v[113382];v[113382]=0;if((a|0)==1){break a}v[113436]=453740;ud(453748)}return v[113436]}a=P()|0;O()|0;ne(453748);S(a|0);L()}function DZ(){var a=0;a:{b:{if(t[453760]&1){break b}if(!vd(453760)){break b}v[113382]=0;da(2444)|0;a=v[113382];v[113382]=0;if((a|0)==1){break a}v[113439]=453752;ud(453760)}return v[113439]}a=P()|0;O()|0;ne(453760);S(a|0);L()}function ss(a,b){var c=0;c=74476;a:{b:{c:{switch(b-2|0){default:if((b|0)==16777216){break a}if((b|0)!=32){break b}c=74492;break a;case 2:c=74488;break a;case 1:break b;case 0:break c}}c=74484;break a}c=74480}v[a>>2]=v[c>>2]}function m0(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=jb-16|0;jb=d;v[d+12>>2]=c;v[d+8>>2]=c;e=-1;c=yr(0,0,b,c);a:{if((c|0)<0){break a}f=a;c=c+1|0;a=kd(c);v[f>>2]=a;if(!a){break a}e=yr(a,c,b,v[d+12>>2])}jb=d+16|0;return e|0}function lga(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=jb-16|0;jb=d;v[d+12>>2]=c;v[d>>2]=263;c=v[Lb(d+12|0,d)>>2];if(!Rb(a,c)){c=$e(a)}oO(d,b);kg(a,v[d>>2],c);oO(d,b);Qb(v[d>>2]+c|0,0,263-c|0);_b(a,v[d+12>>2]);jb=d+16|0;return c|0}function aR(a,b){var c=0,d=0,e=0;d=jb-16|0;jb=d;c=oe(d,a,1);a=zb(a);e=v[c+4>>2];v[113382]=0;U(730,a|0,e|0,b|0);a=v[113382];v[113382]=0;if((a|0)!=1){v[c+4>>2]=v[c+4>>2]+4;Mb(c);jb=d+16|0;return}a=P()|0;O()|0;Mb(c);S(a|0);L()}function H3(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=jb-16|0;jb=d;e=d+8|0;v[e>>2]=78928;v[e>>2]=78884;v[113382]=0;a=aa(2124,a|0,b|0,c|0,e|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){jb=d+16|0;return a|0}a=P()|0;O()|0;S(a|0);L()}function AS(a){if(!((w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24))!=1179011410|(w[a+8|0]|w[a+9|0]<<8|(w[a+10|0]<<16|w[a+11|0]<<24))!=1179472708)){return 1}return(w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24))==1179472708}function Nv(a,b){var c=0,d=0;c=jb-32|0;jb=c;a:{if(xf(a)>>>0<b>>>0){d=zb(a);b=ph(c+8|0,b,wc(a),d);v[113382]=0;R(179,a|0,b|0);a=v[113382];v[113382]=0;if((a|0)==1){break a}vm(b)}jb=c+32|0;return}a=P()|0;O()|0;vm(b);S(a|0);L()}function K2(a,b){a=a|0;b=b|0;var c=C(0);a:{if((b|0)<0){break a}a=a+24|0;if(x[v[a>>2]+480188>>1]<=b>>>0){break a}b=B(b,896);if(t[(b+v[a>>2]|0)+1075073|0]&1){break a}c=C(C(w[(b+v[a>>2]|0)+1075846|0])*C(.0078125))}return C(c)}function Jaa(a,b){a=a|0;b=b|0;var c=0,d=0;c=jb-16|0;jb=c;v[a+480180>>2]=b;rL(c,Yo(a));d=v[c+12>>2];b=a+1074320|0;v[b>>2]=v[c+8>>2];v[b+4>>2]=d;b=v[c+4>>2];v[a+1074312>>2]=v[c>>2];v[a+1074316>>2]=b;ss(a+8|0,Yo(a));jb=c+16|0}function J2(a,b){a=a|0;b=b|0;var c=C(0);a:{if((b|0)<0){break a}a=a+24|0;if(x[v[a>>2]+480188>>1]<=b>>>0){break a}b=B(b,896);if(t[(b+v[a>>2]|0)+1075073|0]&1){break a}c=C(C(w[(b+v[a>>2]|0)+1075847|0])*C(.0078125))}return C(c)}function Haa(a,b){a=a|0;b=b|0;var c=0;c=65535;a:{if(x[v[a+8>>2]+58>>1]<b>>>0){break a}while(1){if(!v[(((b&65535)<<2)+a|0)+900380>>2]){c=b;break a}b=b+1|0;if(x[v[a+8>>2]+58>>1]>=(b&65535)>>>0){continue}break}}return c&65535}function Dg(a){a=a|0;var b=0,c=0;b=jb-16|0;jb=b;t[a+8|0]=0;v[a>>2]=0;v[a+4>>2]=4194432;c=Ub(b,17540);v[113382]=0;Q(344,a+9|0,c|0)|0;a=v[113382];v[113382]=0;if((a|0)!=1){yb(c);jb=b+16|0;return}a=P()|0;O()|0;yb(c);S(a|0);L()}function rga(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=jb-32|0;jb=d;e=Ae(b);c=vO(d+8|0,c);v[113382]=0;fa(994,a|0,b|0,0,e-1&65535,c|0);a=v[113382];v[113382]=0;if((a|0)!=1){ee(c);jb=d+32|0;return}a=P()|0;O()|0;ee(c);S(a|0);L()}function nja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=jb-16|0;jb=d;v[d+12>>2]=c;v[d>>2]=22;c=v[Lb(d+12|0,d)>>2];if(!Rb(a,c)){c=$e(a)}Lt(d,b);kg(a,v[d>>2],c);Lt(d,b);Qb(v[d>>2]+c|0,0,22-c|0);_b(a,v[d+12>>2]);jb=d+16|0;return c|0}function kja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=jb-16|0;jb=d;v[d+12>>2]=c;v[d>>2]=40;c=v[Lb(d+12|0,d)>>2];if(!Rb(a,c)){c=$e(a)}Hz(d,b);kg(a,v[d>>2],c);Hz(d,b);Qb(v[d>>2]+c|0,0,40-c|0);_b(a,v[d+12>>2]);jb=d+16|0;return c|0}function eF(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=jb-32|0;jb=d;v[d+16>>2]=b;v[d+24>>2]=a;v[d+8>>2]=c;while(1){a=Jb(d+24|0,d+16|0);if(!(!a|w[v[d+24>>2]]!=w[v[d+8>>2]])){xg(d+24|0);xg(d+8|0);continue}break}jb=d+32|0;return a^1}function QM(a,b){var c=0,d=0;c=jb-32|0;jb=c;a:{if(nd(a)>>>0<b>>>0){d=zb(a);b=Nf(c+8|0,b,Kb(a),d);v[113382]=0;R(96,a|0,b|0);a=v[113382];v[113382]=0;if((a|0)==1){break a}nk(b)}jb=c+32|0;return}a=P()|0;O()|0;nk(b);S(a|0);L()}function OA(a,b){var c=0,d=0,e=0;d=jb-16|0;jb=d;a:{if(Rb(a,512)){c=d+8|0;du(c,b);zd(a,c);break a}a=jb-16|0;jb=a;c=jb-16|0;jb=c;e=b+512|0;while(1){cu(b);b=b+4|0;if((e|0)!=(b|0)){continue}break}jb=c+16|0;jb=a+16|0}jb=d+16|0}function yha(a,b){a=a|0;b=b|0;var c=0;Mp(a);v[a>>2]=71832;Oi(a+4|0);t[a+20|0]=0;v[a+16>>2]=0;v[a>>2]=71948;c=v[b+4>>2];v[a+24>>2]=v[b>>2];v[a+28>>2]=c;c=v[b+12>>2];v[a+32>>2]=v[b+8>>2];v[a+36>>2]=c;t[a+40|0]=0;return a|0}function yY(a){a=a|0;a:{b:{if(t[453868]&1){break b}if(!vd(453868)){break b}v[113382]=0;Y(2467);a=v[113382];v[113382]=0;if((a|0)==1){break a}v[113466]=454976;ud(453868)}return v[113466]}a=P()|0;O()|0;ne(453868);S(a|0);L()}function xH(a){var b=0,c=0,d=0;d=v[a>>2];b=v[a+4>>2];a:{while(1){if((b|0)==(d|0)){break a}c=zb(a);v[113382]=0;b=b-24|0;R(2174,c|0,b|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}v[a+4>>2]=d}function vY(a){a=a|0;a:{b:{if(t[453876]&1){break b}if(!vd(453876)){break b}v[113382]=0;Y(2469);a=v[113382];v[113382]=0;if((a|0)==1){break a}v[113468]=455008;ud(453876)}return v[113468]}a=P()|0;O()|0;ne(453876);S(a|0);L()}function tK(a){var b=0,c=0,d=0;d=v[a>>2];b=v[a+4>>2];a:{while(1){if((b|0)==(d|0)){break a}c=zb(a);v[113382]=0;b=b-24|0;R(1528,c|0,b|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}v[a+4>>2]=d}function dU(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=jb-16|0;jb=d;v[d+12>>2]=c;v[d>>2]=65;c=v[Lb(d+12|0,d)>>2];if(!Rb(a,c)){c=$e(a)}pu(d,b);kg(a,v[d>>2],c);pu(d,b);Qb(v[d>>2]+c|0,0,65-c|0);_b(a,v[d+12>>2]);jb=d+16|0;return c|0}function a8(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=jb-16|0;jb=d;v[d+12>>2]=c;v[d>>2]=33;c=v[Lb(d+12|0,d)>>2];if(!Rb(a,c)){c=$e(a)}Oz(d,b);kg(a,v[d>>2],c);Oz(d,b);Qb(v[d>>2]+c|0,0,33-c|0);_b(a,v[d+12>>2]);jb=d+16|0;return c|0}function KY(a){a=a|0;a:{b:{if(t[453836]&1){break b}if(!vd(453836)){break b}v[113382]=0;Y(2459);a=v[113382];v[113382]=0;if((a|0)==1){break a}v[113458]=454016;ud(453836)}return v[113458]}a=P()|0;O()|0;ne(453836);S(a|0);L()}function HY(a){a=a|0;a:{b:{if(t[453844]&1){break b}if(!vd(453844)){break b}v[113382]=0;Y(2461);a=v[113382];v[113382]=0;if((a|0)==1){break a}v[113460]=454192;ud(453844)}return v[113460]}a=P()|0;O()|0;ne(453844);S(a|0);L()}function EY(a){a=a|0;a:{b:{if(t[453852]&1){break b}if(!vd(453852)){break b}v[113382]=0;Y(2463);a=v[113382];v[113382]=0;if((a|0)==1){break a}v[113462]=454368;ud(453852)}return v[113462]}a=P()|0;O()|0;ne(453852);S(a|0);L()}function BY(a){a=a|0;a:{b:{if(t[453860]&1){break b}if(!vd(453860)){break b}v[113382]=0;Y(2465);a=v[113382];v[113382]=0;if((a|0)==1){break a}v[113464]=454672;ud(453860)}return v[113464]}a=P()|0;O()|0;ne(453860);S(a|0);L()}function wS(a){a=a|0;var b=0,c=0,d=0;b=v[a>>2];c=vS(a);d=jb-16|0;jb=d;a:{if((b|0)==(c|0)){break a}a=b+4|0;if((c|0)==(a|0)){break a}while(1){b=Su(a,b)?a:b;a=a+4|0;if((c|0)!=(a|0)){continue}break}}jb=d+16|0;return v[b>>2]}function sO(a){var b=0,c=0,d=0;b=a- -64|0;d=w[b|0]|w[b+1|0]<<8;b=a+70|0;a=a+72|0;c=w[a|0]|w[a+1|0]<<8;a=(w[b|0]|w[b+1|0]<<8)+c|0;b=0;b=a>>>0<c>>>0?1:b;c=a;a=b<<2|a>>>30;c=c<<2;b=d+c|0;a=b>>>0<c>>>0?a+1|0:a;mb=a;return b}function qO(a){var b=0,c=0,d=0;d=v[a>>2];b=v[a+4>>2];a:{while(1){if((b|0)==(d|0)){break a}c=zb(a);v[113382]=0;b=b-4|0;R(1023,c|0,b|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}v[a+4>>2]=d}function ph(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=jb-16|0;jb=e;v[e+12>>2]=0;Le(a+12|0,d);if(b){f=Zg(v[a+16>>2],b)}v[a>>2]=f;c=c+f|0;v[a+8>>2]=c;v[a+4>>2]=c;g=gc(a),h=b+f|0,v[g>>2]=h;jb=e+16|0;return a|0}function nba(a,b,c){a=a|0;b=b|0;c=c|0;a=v[c+4>>2];v[b>>2]=v[c>>2];v[b+4>>2]=a;a=v[c+28>>2];v[b+24>>2]=v[c+24>>2];v[b+28>>2]=a;a=v[c+20>>2];v[b+16>>2]=v[c+16>>2];v[b+20>>2]=a;a=v[c+12>>2];v[b+8>>2]=v[c+8>>2];v[b+12>>2]=a}function jy(a,b){var c=0,d=0;c=B(b,896)+a|0;a:{if(v[c+1075072>>2]&134218752){break a}if(!oj(c+1074984|0)){break a}b=w[v[(B(b,896)+a|0)+1075640>>2]+34|0];if((b+5&255)>>>0<6){break a}d=v[(B(b,160)+a|0)+906140>>2]}return d}function gP(a){var b=0,c=0,d=0;d=v[a>>2];b=v[a+4>>2];a:{while(1){if((b|0)==(d|0)){break a}c=zb(a);v[113382]=0;b=b-24|0;R(947,c|0,b|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}v[a+4>>2]=d}function fD(a){var b=0,c=0,d=0;d=v[a>>2];b=v[a+4>>2];a:{while(1){if((b|0)==(d|0)){break a}c=zb(a);v[113382]=0;b=b-32|0;R(243,c|0,b|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}v[a+4>>2]=d}function aY(a,b){a=a|0;b=b|0;var c=0;c=jb-16|0;jb=c;a:{if(Jt(b,6353)){JD(c,13504,b);a=Tb(c);v[113382]=0;R(2705,44,a|0);a=v[113382];v[113382]=0;if((a|0)!=1){break a}a=P()|0;O()|0;yb(c);S(a|0);L()}jb=c+16|0;return a|0}L()}function ZK(a,b,c){var d=0,e=0,f=0;d=jb-16|0;jb=d;if(b>>>0<=4294967279){a:{if(b>>>0<=10){Ce(a,b);e=a;break a}f=Wi(b)+1|0;e=Zg(a,f);Oe(a,e);Gf(a,f);ae(a,b)}Ey(e,b,c);t[d+15|0]=0;Rd(b+e|0,d+15|0);jb=d+16|0;return}If();L()}function OO(a,b,c){var d=0;d=jb-16|0;jb=d;t[d+15|0]=a;a=0;if(!(c>>>0<25|b>>>0<25|(b>>>0>108|b>>>0>=c>>>0)|c>>>0>108)){t[d+14|0]=(x[(b<<1)+26030>>1]-x[(c<<1)+26030>>1]|0)/5;a=w[pc(d+15|0,d+14|0)|0]}jb=d+16|0;return a&255}function Ks(a,b,c){var d=0,e=0,f=0;d=jb-16|0;jb=d;if(c>>>0<=4294967279){a:{if(c>>>0<=10){Ce(a,c);e=a;break a}f=Wi(c)+1|0;e=Zg(a,f);Oe(a,e);Gf(a,f);ae(a,c)}ag(e,b,c);t[d+15|0]=0;Rd(c+e|0,d+15|0);jb=d+16|0;return}If();L()}function EO(a){var b=0,c=0,d=0;d=v[a>>2];b=v[a+4>>2];a:{while(1){if((b|0)==(d|0)){break a}c=zb(a);v[113382]=0;b=b-12|0;R(987,c|0,b|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}v[a+4>>2]=d}function fT(a){var b=0,c=0,d=0;d=v[a>>2];b=v[a+4>>2];a:{while(1){if((b|0)==(d|0)){break a}c=zb(a);v[113382]=0;b=b-2|0;R(495,c|0,b|0);c=v[113382];v[113382]=0;if((c|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}v[a+4>>2]=d}function bZ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=jb-16|0;jb=e;v[e+12>>2]=d;d=Bh(e+8|0,e+12|0);v[113382]=0;a=JF(a,b,c);b=v[113382];v[113382]=0;if((b|0)!=1){Ge(d);jb=e+16|0;return a|0}a=P()|0;O()|0;Ge(d);S(a|0);L()}function JJ(a){var b=0,c=0,d=0;b=v[a>>2];v[a>>2]=0;if(b){a:{b:{a=jc(a);if(w[a+4|0]){v[113382]=0;c=T(695,b+16|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break b}Bk(c)}if(b){Ug(v[a>>2],b,1)}break a}V(0)|0;O()|0;Ab();L()}}}function HR(a){var b=0,c=0,d=0;b=v[a>>2];v[a>>2]=0;if(b){a:{b:{a=jc(a);if(w[a+4|0]){v[113382]=0;c=T(692,b+16|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break b}Bk(c)}if(b){Ug(v[a>>2],b,1)}break a}V(0)|0;O()|0;Ab();L()}}}function Gr(a){var b=0;a:{b=w[a+1376|0];b:{if(!b){b=-1;if(v[a+1384>>2]){break b}if(!Bw(a)){break b}b=w[a+1376|0];if(!b){break a}}t[a+1376|0]=b-1;v[a+1400>>2]=v[a+1400>>2]+1;b=xe(a)}return b}ia(11862,9203,1578,1915);L()}function Dba(a,b){a=a|0;b=+b;var c=0,d=0,e=0;c=jb-16|0;jb=c;d=c,e=(v[a+480208>>2]&32768?28.85390081777927:34.624680981335125)*(Bo(b)+-4.8737671609324025),A[d+8>>3]=e;Vf(c+8|0,0,127);a=tt(A[c+8>>3]);jb=c+16|0;return a|0}function AQ(a){var b=0,c=0;a:{if(md(a,10694,3)){break a}b=a+4|0;if((w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24))>>>0<423|(w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24))>>>0>2147483646){break a}c=w[a+3|0]<6}return c}function $s(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=jb-16|0;jb=d;e=d+8|0;Fb(e,c+1074312|0,102);a:{if(!Cb(e)){break a}c=x[a+692>>1]+1|0;u[a+796>>1]=c;if(!(t[a+89|0]&1)){break a}u[a+796>>1]=c|32768}v[a+692>>2]=b;jb=d+16|0}function sda(a){a=a|0;var b=0;v[a>>2]=0;a:{if(t[82420]&1){break a}if(!vd(82420)){break a}v[113382]=0;T(1173,82416)|0;b=v[113382];v[113382]=0;if((b|0)!=1){ud(82420);break a}a=P()|0;O()|0;ne(82420);S(a|0);L()}return a|0}function kN(a,b){a:{if(w[a+76|0]==(b|0)){break a}t[a+76|0]=b;if(b){b=0;if(x[a+24>>1]==15){u[a+20>>1]=0;b=1}v[a+8>>2]=0;v[a+16>>2]=b;return}b:{switch(v[a+16>>2]+1|0){case 0:case 4:break a;default:break b}}v[a+16>>2]=3}}function RO(a){var b=0,c=0,d=0;b=a+32|0;d=w[b|0]|w[b+1|0]<<8;b=a+34|0;a=a+36|0;c=w[a|0]|w[a+1|0]<<8;a=(w[b|0]|w[b+1|0]<<8)+c|0;b=0;b=a>>>0<c>>>0?1:b;c=a;a=b<<1|a>>>31;c=c<<1;b=d+c|0;a=b>>>0<c>>>0?a+1|0:a;mb=a;return b}function Hga(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;u[a+34>>1]=0;d=jb-16|0;jb=d;e=jb-16|0;jb=e;c=a+43|0;f=c+22|0;while(1){jf(c);c=c+1|0;if((f|0)!=(c|0)){continue}break}jb=e+16|0;jb=d+16|0;v[a+20>>2]=0;sd(a,b);return a|0}function uz(a,b,c){var d=0,e=0,f=0,g=0,h=0;f=jb-1024|0;jb=f;e=jb-16|0;jb=e;d=e+8|0;pz(d,f);g=Hb(d);d=mc(a,$b(e,d));if((g|0)==(d|0)){_b(a,Hb(e+8|0))}jb=e+16|0;if((d|0)==(g|0)){h=qz(f,c)>>>0<=b>>>0}jb=f+1024|0;return h}function qma(a,b,c,d){var e=0,f=0,g=0,h=0,i=0,j=0;e=c>>>16|0;f=a>>>16|0;j=B(e,f);g=c&65535;h=a&65535;i=B(g,h);f=(i>>>16|0)+B(f,g)|0;e=(f&65535)+B(e,h)|0;mb=(B(b,c)+j|0)+B(a,d)+(f>>>16)+(e>>>16)|0;return i&65535|e<<16}function kn(a){a=a|0;tc(a+16|0,v[a>>2]);tc(a+8|0,v[a>>2]);if(y[a+12>>2]>=y[a+16>>2]){v[a+12>>2]=0;v[a+16>>2]=0;u[a+34>>1]=x[a+34>>1]&65511}if(y[a+4>>2]>=y[a+8>>2]){v[a+4>>2]=0;v[a+8>>2]=0;u[a+34>>1]=x[a+34>>1]&65529}}function jD(a){var b=0,c=0;b=a+2|0;a:{if(!(w[b|0]|w[b+1|0]<<8)){break a}a=a+4|0;if(!(w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24))){break a}c=(w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24))>>>0<2147483649}return c}function X2(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=jb-16|0;jb=e;d=dl(e,a,d);a=zb(a);v[113382]=0;X(2149,a|0,b|0,c|0,d+4|0);a=v[113382];v[113382]=0;if((a|0)!=1){Mb(d);jb=e+16|0;return}a=P()|0;O()|0;Mb(d);S(a|0);L()}function V3(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=jb-16|0;jb=e;d=om(e,a,d);a=zb(a);v[113382]=0;X(2094,a|0,b|0,c|0,d+4|0);a=v[113382];v[113382]=0;if((a|0)!=1){Mb(d);jb=e+16|0;return}a=P()|0;O()|0;Mb(d);S(a|0);L()}function qY(a){a=a|0;a:{b:{if(t[453908]&1){break b}if(!vd(453908)){break b}v[113382]=0;Q(2472,453896,59732)|0;a=v[113382];v[113382]=0;if((a|0)==1){break a}ud(453908)}return 453896}a=P()|0;O()|0;ne(453908);S(a|0);L()}function mY(a){a=a|0;a:{b:{if(t[453940]&1){break b}if(!vd(453940)){break b}v[113382]=0;Q(2472,453928,59768)|0;a=v[113382];v[113382]=0;if((a|0)==1){break a}ud(453940)}return 453928}a=P()|0;O()|0;ne(453940);S(a|0);L()}function iY(a){a=a|0;a:{b:{if(t[453972]&1){break b}if(!vd(453972)){break b}v[113382]=0;Q(2472,453960,59804)|0;a=v[113382];v[113382]=0;if((a|0)==1){break a}ud(453972)}return 453960}a=P()|0;O()|0;ne(453972);S(a|0);L()}function eY(a){a=a|0;a:{b:{if(t[454004]&1){break b}if(!vd(454004)){break b}v[113382]=0;Q(2472,453992,59888)|0;a=v[113382];v[113382]=0;if((a|0)==1){break a}ud(454004)}return 453992}a=P()|0;O()|0;ne(454004);S(a|0);L()}function Cw(a){var b=0;a:{b:{while(1){if(v[a+1380>>2]!=-1){break b}b=0;if(!Fr(a)){break a}if(!(t[a+1375|0]&1)){continue}break}cc(a,32);return 0}v[a+1396>>2]=0;v[a+1400>>2]=0;v[a+1384>>2]=0;t[a+1376|0]=0;b=1}return b}function oda(a){a=a|0;var b=0,c=0,d=0,e=0;while(1){d=0;c=(b&255)<<24;while(1){e=c<<1;c=(c|0)>=0?e:e^79764919;d=d+1|0;if((d|0)!=8){continue}break}v[(b<<2)+82432>>2]=c;b=b+1|0;if((b|0)!=256){continue}break}return a|0}function VM(a,b){var c=0,d=0,e=0,f=0;e=A[a+48>>3];c=A[a+40>>3];A[a+48>>3]=c;f=A[a+64>>3];d=A[a+56>>3];A[a+64>>3]=d;A[a+40>>3]=b;b=c*A[a+8>>3]+A[a>>3]*b+e*A[a+16>>3]-(f*A[a+32>>3]+d*A[a+24>>3]);A[a+56>>3]=b;return b}function Kka(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=jb-16|0;jb=c;d=c+8|0;Uz(d,b);e=Hb(d);d=mc(a,$b(c,d));if((e|0)==(d|0)){_b(a,Hb(c+8|0))}jb=c+16|0;a=(d|0)==(e|0);if(!a){c=jb-16|0;jb=c;Qb(b,0,4896);jb=c+16|0}return a|0}function sY(a){a=a|0;a:{b:{if(t[453892]&1){break b}if(!vd(453892)){break b}v[113382]=0;Q(121,453880,1755)|0;a=v[113382];v[113382]=0;if((a|0)==1){break a}ud(453892)}return 453880}a=P()|0;O()|0;ne(453892);S(a|0);L()}function pba(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=jb-32|0;jb=d;v[d+24>>2]=c;v[d+16>>2]=b;if(Jb(d+16|0,d+24|0)){while(1){b=d+16|0;v[d+12>>2]=v[v[b>>2]>>2];uy(a,d+12|0);Ie(b);if(Jb(b,d+24|0)){continue}break}}jb=d+32|0}function oY(a){a=a|0;a:{b:{if(t[453924]&1){break b}if(!vd(453924)){break b}v[113382]=0;Q(121,453912,9694)|0;a=v[113382];v[113382]=0;if((a|0)==1){break a}ud(453924)}return 453912}a=P()|0;O()|0;ne(453924);S(a|0);L()}function kY(a){a=a|0;a:{b:{if(t[453956]&1){break b}if(!vd(453956)){break b}v[113382]=0;Q(121,453944,9494)|0;a=v[113382];v[113382]=0;if((a|0)==1){break a}ud(453956)}return 453944}a=P()|0;O()|0;ne(453956);S(a|0);L()}function gY(a){a=a|0;a:{b:{if(t[453988]&1){break b}if(!vd(453988)){break b}v[113382]=0;Q(121,453976,5277)|0;a=v[113382];v[113382]=0;if((a|0)==1){break a}ud(453988)}return 453976}a=P()|0;O()|0;ne(453988);S(a|0);L()}function Jg(a){var b=0;v[113382]=0;a=T(1361,a|0)|0;b=v[113382];v[113382]=0;a:{if((b|0)==1){a=V(0)|0;O()|0;_(a|0)|0;v[113382]=0;Y(20);b=v[113382];v[113382]=0;a=0;if((b|0)==1){break a}}return a}V(0)|0;O()|0;Ab();L()}function Fm(a,b){var c=0,d=0,e=0;c=a*a;d=c*a;e=d*(c*.13339200271297674+.3333313950307914)+a;a=c*c;a=e+d*a*(c*.024528318116654728+.05338123784456704+a*(c*.009465647849436732+.002974357433599673));return C(b?-1/a:a)}function wM(a,b,c){var d=0,e=0;d=jb-16|0;jb=d;e=c&15;if(e){t[b+844|0]=e}c=c&240;if(c){t[b+843|0]=c>>>4}v[b+88>>2]=v[b+88>>2]|131072;c=d+8|0;Fb(c,a+1074312|0,80);if(!(!Cb(c)|!e)){t[b+844|0]=w[b+844|0]<<2}jb=d+16|0}function sF(a,b){a=a|0;b=b|0;var c=0,d=0;c=v[a>>2];a:{if(!c){break a}d=v[c+24>>2];b:{if((d|0)==v[c+28>>2]){b=nb[v[v[c>>2]+52>>2]](c,b)|0;break b}v[c+24>>2]=d+4;v[d>>2]=b}if(!se(b,-1)){break a}v[a>>2]=0}return a|0}function ju(a,b,c){var d=0;a=a+3|0;a=(w[a|0]|w[a+1|0]<<8)>>>B(c,3)|0;d=a>>>2&1|w[b+12|0]&-8;t[b+12|0]=d|a<<1&6;if(!(!(a>>>9-(c<<1)&1)|(a&3)!=1)){a=w[b+13|0]|w[b+14|0]<<8;t[b+15|0]=a;t[b+16|0]=a>>>8;t[b+12|0]=d|4}}function iga(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=jb-16|0;jb=c;d=c+8|0;Hz(d,b);e=Hb(d);d=mc(a,$b(c,d));if((e|0)==(d|0)){_b(a,Hb(c+8|0))}jb=c+16|0;a=(d|0)==(e|0);if(!a){c=jb-16|0;jb=c;Qb(b,0,40);jb=c+16|0}return a|0}function IB(a,b){var c=0,d=0,e=0;d=jb-16|0;jb=d;e=jb-16|0;jb=e;c=d+8|0;fc(c,b,37);jb=e+16|0;e=Hb(c);c=mc(a,$b(d,c));if((e|0)==(c|0)){_b(a,Hb(d+8|0))}jb=d+16|0;if((c|0)!=(e|0)){a=jb-16|0;jb=a;Qb(b,0,37);jb=a+16|0}}function yn(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=jb-16|0;jb=d;a:{if(c){Ub(d,c);break a}Xb(d)}v[113382]=0;U(13,a|0,b|0,d|0);a=v[113382];v[113382]=0;if((a|0)!=1){yb(d);jb=d+16|0;return}a=P()|0;O()|0;yb(d);S(a|0);L()}function rma(a,b,c,d){var e=0,f=0,g=0;f=(b^d)>>31;e=b>>31;a=a^e;g=a-e|0;a=(b^e)-((a>>>0<e>>>0)+e|0)|0;e=d>>31;b=c^e;a=tma(g,a,b-e|0,(e^d)-((e>>>0>b>>>0)+e|0)|0)^f;b=a-f|0;mb=(f^mb)-((a>>>0<f>>>0)+f|0)|0;return b}function hU(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=jb-16|0;jb=c;d=c+8|0;pu(d,b);e=Hb(d);d=mc(a,$b(c,d));if((e|0)==(d|0)){_b(a,Hb(c+8|0))}jb=c+16|0;a=(d|0)==(e|0);if(!a){c=jb-16|0;jb=c;Qb(b,0,65);jb=c+16|0}return a|0}function Ux(a,b){var c=0;c=v[b+24>>2];c=c?c:1;v[a+24628>>2]=c>>>0<512?c:512;a:{if(!(v[b+16>>2]!=v[a+24620>>2]|v[b+20>>2]!=v[a+24624>>2])){c=0;if(v[b+12>>2]==v[a+24616>>2]){break a}}c=1}lc(a+24604|0,b,40);YK(a,c)}function Rp(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=jb-16|0;jb=c;d=c+8|0;wA(d,b);e=Hb(d);d=mc(a,$b(c,d));if((e|0)==(d|0)){_b(a,Hb(c+8|0))}jb=c+16|0;a=(d|0)==(e|0);if(!a){c=jb-16|0;jb=c;Qb(b,0,64);jb=c+16|0}return a|0}function uJ(a,b){var c=0,d=0;c=v[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=zb(a);v[113382]=0;c=c-2048|0;R(1621,d|0,c|0);d=v[113382];v[113382]=0;if((d|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}v[a+4>>2]=b}function rV(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=jb-16|0;jb=e;v[e+12>>2]=d;d=0;f=v[a+8>>2];if(f>>>0>c>>>0){v[e+8>>2]=f-c;d=Lb(e+8|0,e+12|0);a=v[a+4>>2]+c|0;d=v[d>>2];kf(a,a+d|0,b)}jb=e+16|0;return d|0}function qw(a){a=a|0;var b=0;v[a>>2]=52016;v[113382]=0;R(2276,a|0,0);b=v[113382];v[113382]=0;if((b|0)!=1){Ob(a+28|0);Wb(v[a+32>>2]);Wb(v[a+36>>2]);Wb(v[a+48>>2]);Wb(v[a+60>>2]);return a|0}V(0)|0;O()|0;Ab();L()}function ns(a){var b=0,c=0;b=jb-16|0;jb=b;zb(a);v[b+12>>2]=1073741823;v[113382]=0;v[b+8>>2]=2147483647;a=Q(33,b+12|0,b+8|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){jb=b+16|0;return v[a>>2]}V(0)|0;O()|0;Ab();L()}function jC(a){var b=0,c=0;b=jb-16|0;jb=b;zb(a);v[b+12>>2]=2147483647;v[113382]=0;v[b+8>>2]=2147483647;a=Q(33,b+12|0,b+8|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){jb=b+16|0;return v[a>>2]}V(0)|0;O()|0;Ab();L()}function bba(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=jb-32|0;jb=d;a=v[a+1304560>>2];a:{if(a){nb[v[v[a>>2]+8>>2]](a,b,c);break a}if(v[17936]<(b|0)){break a}a=d+8|0;sL(a,5177,6917,132);gD(d+24|0,a,b,9259,c)}jb=d+32|0}function Tx(a,b){var c=0,d=0;c=v[b+4>>2];v[a+24648>>2]=v[b>>2];v[a+24652>>2]=c;d=v[b+20>>2];c=a+24664|0;v[c>>2]=v[b+16>>2];v[c+4>>2]=d;d=v[b+12>>2];c=a+24656|0;v[c>>2]=v[b+8>>2];v[c+4>>2]=d;XK(a+24648|0);jL(a)}function xN(a,b){var c=0,d=0;c=v[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=zb(a);v[113382]=0;c=c-32|0;R(1158,d|0,c|0);d=v[113382];v[113382]=0;if((d|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}v[a+4>>2]=b}function vv(a,b,c){var d=0;d=v[a+16>>2];if(!d){v[a+36>>2]=1;v[a+24>>2]=c;v[a+16>>2]=b;return}a:{if((b|0)==(d|0)){if(v[a+24>>2]!=2){break a}v[a+24>>2]=c;return}t[a+54|0]=1;v[a+24>>2]=2;v[a+36>>2]=v[a+36>>2]+1}}function nv(a){var b=0,c=0;b=jb-16|0;jb=b;zb(a);v[b+12>>2]=268435455;v[113382]=0;v[b+8>>2]=2147483647;a=Q(33,b+12|0,b+8|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){jb=b+16|0;return v[a>>2]}V(0)|0;O()|0;Ab();L()}function cT(a){var b=0,c=0;b=jb-16|0;jb=b;zb(a);v[b+12>>2]=178956970;v[113382]=0;v[b+8>>2]=2147483647;a=Q(33,b+12|0,b+8|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){jb=b+16|0;return v[a>>2]}V(0)|0;O()|0;Ab();L()}function cL(a,b){var c=0,d=0;c=v[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=zb(a);v[113382]=0;c=c-52|0;R(1406,d|0,c|0);d=v[113382];v[113382]=0;if((d|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}v[a+4>>2]=b}function _E(a){var b=0,c=0;b=jb-16|0;jb=b;zb(a);v[b+12>>2]=357913941;v[113382]=0;v[b+8>>2]=2147483647;a=Q(33,b+12|0,b+8|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){jb=b+16|0;return v[a>>2]}V(0)|0;O()|0;Ab();L()}function Yu(a){var b=0,c=0;b=jb-16|0;jb=b;zb(a);v[b+12>>2]=536870911;v[113382]=0;v[b+8>>2]=2147483647;a=Q(33,b+12|0,b+8|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){jb=b+16|0;return v[a>>2]}V(0)|0;O()|0;Ab();L()}function Uka(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=jb-16|0;jb=e;g=v[v[b>>2]+20>>2];f=v[c+12>>2];v[e+8>>2]=v[c+8>>2];v[e+12>>2]=f;f=v[c+4>>2];v[e>>2]=v[c>>2];v[e+4>>2]=f;nb[g|0](a,b,e,d);jb=e+16|0}function PC(a){var b=0,c=0;b=jb-16|0;jb=b;zb(a);v[b+12>>2]=134217727;v[113382]=0;v[b+8>>2]=2147483647;a=Q(33,b+12|0,b+8|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){jb=b+16|0;return v[a>>2]}V(0)|0;O()|0;Ab();L()}function LL(a,b){var c=0,d=0;c=v[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=zb(a);v[113382]=0;c=c-24|0;R(1344,d|0,c|0);d=v[113382];v[113382]=0;if((d|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}v[a+4>>2]=b}function KS(a){var b=0,c=0;b=jb-16|0;jb=b;zb(a);v[b+12>>2]=715827882;v[113382]=0;v[b+8>>2]=2147483647;a=Q(33,b+12|0,b+8|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){jb=b+16|0;return v[a>>2]}V(0)|0;O()|0;Ab();L()}function HM(a,b){var c=0,d=0;c=v[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=zb(a);v[113382]=0;c=c-12|0;R(1200,d|0,c|0);d=v[113382];v[113382]=0;if((d|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}v[a+4>>2]=b}function EL(a){var b=0,c=0;b=v[a>>2];v[a>>2]=0;if(b){a:{b:{a=jc(a);if(w[a+4|0]){v[113382]=0;T(1345,b+14|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break b}}if(b){Bp(v[a>>2],b,1)}break a}V(0)|0;O()|0;Ab();L()}}}function CL(a){var b=0,c=0;b=v[a>>2];v[a>>2]=0;if(b){a:{b:{a=jc(a);if(w[a+4|0]){v[113382]=0;T(1349,b+16|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break b}}if(b){lt(v[a>>2],b,1)}break a}V(0)|0;O()|0;Ab();L()}}}function wD(a,b){var c=0,d=0;c=v[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=zb(a);v[113382]=0;c=c-16|0;R(187,d|0,c|0);d=v[113382];v[113382]=0;if((d|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}v[a+4>>2]=b}function rJ(a,b){var c=0,d=0;c=v[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=zb(a);v[113382]=0;c=c-4|0;R(1623,d|0,c|0);d=v[113382];v[113382]=0;if((d|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}v[a+4>>2]=b}function kD(a){var b=0;b=a;if((w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24))==1129474426&(w[b+4|0]|w[b+5|0]<<8|(w[b+6|0]<<16|w[b+7|0]<<24))==1634291279){a=a+8|0;a=(w[a|0]|w[a+1|0]<<8)==14}else{a=0}return a}function kB(a,b){var c=0,d=0;c=v[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=zb(a);v[113382]=0;c=c-16|0;R(381,d|0,c|0);d=v[113382];v[113382]=0;if((d|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}v[a+4>>2]=b}function fR(a,b){var c=0,d=0;c=v[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=zb(a);v[113382]=0;c=c-33|0;R(729,d|0,c|0);d=v[113382];v[113382]=0;if((d|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}v[a+4>>2]=b}function _J(a){var b=0,c=0;b=jb-16|0;jb=b;zb(a);v[b+12>>2]=82595524;v[113382]=0;v[b+8>>2]=2147483647;a=Q(33,b+12|0,b+8|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){jb=b+16|0;return v[a>>2]}V(0)|0;O()|0;Ab();L()}function HS(a,b){var c=0,d=0;c=v[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=zb(a);v[113382]=0;c=c-48|0;R(536,d|0,c|0);d=v[113382];v[113382]=0;if((d|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}v[a+4>>2]=b}function Cja(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=jb-16|0;jb=c;d=c+8|0;Oz(d,b);e=Hb(d);d=mc(a,$b(c,d));if((e|0)==(d|0)){_b(a,Hb(c+8|0))}jb=c+16|0;a=(d|0)==(e|0);if(!a){c=jb-16|0;jb=c;dR(b);jb=c+16|0}return a|0}function Bda(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=jb-16|0;jb=e;v[e>>2]=c;v[e+8>>2]=b;if(Jb(e+8|0,e)){while(1){b=e+8|0;Wl(a,v[d>>2],v[b>>2]);re(b);v[d>>2]=v[d>>2]+2;if(Jb(b,e)){continue}break}}jb=e+16|0}function BQ(a){var b=0,c=0;b=v[a>>2];v[a>>2]=0;if(b){a:{b:{a=jc(a);if(w[a+4|0]){v[113382]=0;T(786,b+14|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break b}}if(b){Bp(v[a>>2],b,1)}break a}V(0)|0;O()|0;Ab();L()}}}function BO(a,b){var c=0,d=0;c=v[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=zb(a);v[113382]=0;c=c-12|0;R(986,d|0,c|0);d=v[113382];v[113382]=0;if((d|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}v[a+4>>2]=b}function zR(a,b){var c=0,d=0;c=v[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=zb(a);v[113382]=0;c=c-6|0;R(697,d|0,c|0);d=v[113382];v[113382]=0;if((d|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}v[a+4>>2]=b}function vR(a,b){var c=0,d=0;c=v[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=zb(a);v[113382]=0;c=c-4|0;R(698,d|0,c|0);d=v[113382];v[113382]=0;if((d|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}v[a+4>>2]=b}function tD(a,b){var c=0,d=0;c=v[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=zb(a);v[113382]=0;c=c-1|0;R(185,d|0,c|0);d=v[113382];v[113382]=0;if((d|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}v[a+4>>2]=b}function tA(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=jb-16|0;jb=d;v[d+12>>2]=c;e=d,f=RS(ac(b),bc(b),d+12|0),v[e+8>>2]=f;e=d,f=bc(b),v[e>>2]=f;a:{if(Jb(d+8|0,d)){af(a,zb(v[d+8>>2]));break a}Vh(a)}jb=d+16|0}function rz(a,b,c){var d=0;d=jb-16|0;jb=d;v[d>>2]=b;v[d+8>>2]=a;a:{if(!Jb(d+8|0,d)){break a}while(1){if(x[v[d+8>>2]>>1]==x[c>>1]){break a}a=d+8|0;re(a);if(Jb(a,d)){continue}break}}jb=d+16|0;return v[d+8>>2]}function rP(a,b){var c=0,d=0;c=v[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=zb(a);v[113382]=0;c=c-4|0;R(912,d|0,c|0);d=v[113382];v[113382]=0;if((d|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}v[a+4>>2]=b}function oB(a,b){var c=0,d=0;c=v[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=zb(a);v[113382]=0;c=c-2|0;R(377,d|0,c|0);d=v[113382];v[113382]=0;if((d|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}v[a+4>>2]=b}function maa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=b,h=Ih(a),v[g>>2]=h;Ih(a);if(f>>>0>=60){_b(a,4)}g=e,h=Ih(a),v[g>>2]=h;_b(a,4);b=Ih(a);v[d>>2]=b;if((b|0)>0){g=c,h=Ih(a),v[g>>2]=h}}function mC(a,b){var c=0,d=0;c=v[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=zb(a);v[113382]=0;c=c-1|0;R(327,d|0,c|0);d=v[113382];v[113382]=0;if((d|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}v[a+4>>2]=b}function kk(a){var b=0,c=0;b=jb-16|0;jb=b;v[a>>2]=0;v[a+4>>2]=0;v[113382]=0;v[b+12>>2]=0;W(1562,a+8|0,b+12|0,b+8|0)|0;c=v[113382];v[113382]=0;a:{if((c|0)!=1){jb=b+16|0;break a}V(0)|0;O()|0;Ab();L()}return a}function jL(a){var b=0,c=0;b=jb-544|0;jb=b;if(!(!(w[a+480210|0]&128)|!v[a+24668>>2])){TM(b,Ue(a));c=a+1304360|0;a=a+1074984|0;while(1){lc(a+112|0,b,538);a=a+896|0;if((c|0)!=(a|0)){continue}break}}jb=b+544|0}function jJ(a){var b=0,c=0;b=jb-16|0;jb=b;v[a>>2]=0;v[a+4>>2]=0;v[113382]=0;v[b+12>>2]=0;W(1711,a+8|0,b+12|0,b+8|0)|0;c=v[113382];v[113382]=0;a:{if((c|0)!=1){jb=b+16|0;break a}V(0)|0;O()|0;Ab();L()}return a}function iJ(a){var b=0,c=0;b=jb-16|0;jb=b;v[a>>2]=0;v[a+4>>2]=0;v[113382]=0;v[b+12>>2]=0;W(1712,a+8|0,b+12|0,b+8|0)|0;c=v[113382];v[113382]=0;a:{if((c|0)!=1){jb=b+16|0;break a}V(0)|0;O()|0;Ab();L()}return a}function bx(a){var b=0,c=0;b=jb-16|0;jb=b;v[a>>2]=0;v[a+4>>2]=0;v[113382]=0;v[b+12>>2]=0;W(2100,a+8|0,b+12|0,b+8|0)|0;c=v[113382];v[113382]=0;a:{if((c|0)!=1){jb=b+16|0;break a}V(0)|0;O()|0;Ab();L()}return a}function Q6(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;f=jb-16|0;jb=f;b=zc(rma(qma(d,d>>31,b,b>>31),mb,1e3,0),mb);v[a+16>>2]=0;v[a+12>>2]=b+c;LI(a,e);b=v[a+12>>2];v[f+12>>2]=0;PJ(a,b,f+12|0);jb=f+16|0}function LB(a,b){var c=0,d=0;c=v[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=zb(a);v[113382]=0;c=c-2|0;R(348,d|0,c|0);d=v[113382];v[113382]=0;if((d|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}v[a+4>>2]=b}function KQ(a,b){var c=0,d=0;c=v[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=zb(a);v[113382]=0;c=c-4|0;R(782,d|0,c|0);d=v[113382];v[113382]=0;if((d|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}v[a+4>>2]=b}function KK(a,b){var c=0,d=0;c=v[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=zb(a);v[113382]=0;c=c-4|0;R(107,d|0,c|0);d=v[113382];v[113382]=0;if((d|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}v[a+4>>2]=b}function IP(a,b){var c=0,d=0;c=v[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=zb(a);v[113382]=0;c=c-8|0;R(885,d|0,c|0);d=v[113382];v[113382]=0;if((d|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}v[a+4>>2]=b}function Hla(a,b){a=a|0;b=b|0;var c=0;c=jb-16|0;jb=c;v[c+12>>2]=1;v[c+8>>2]=a>>>4;b=Yb(128/(B(v[yf(c+12|0,c+8|0)>>2],b)|0)|0,1,15);t[c+7|0]=1;t[c+6|0]=a&15;a=w[th(c+7|0,c+6|0)|0];jb=c+16|0;return a|b<<4&240}function Fx(a){var b=0,c=0;b=jb-16|0;jb=b;v[a>>2]=0;v[a+4>>2]=0;v[113382]=0;v[b+12>>2]=0;W(1527,a+8|0,b+12|0,b+8|0)|0;c=v[113382];v[113382]=0;a:{if((c|0)!=1){jb=b+16|0;break a}V(0)|0;O()|0;Ab();L()}return a}function Er(a){var b=0;if(a){if(v[a+76>>2]<0){return zw(a)}return zw(a)}if(v[20044]){b=Er(v[20044])}a=v[113302];if(a){while(1){if(y[a+20>>2]>y[a+28>>2]){b=zw(a)|b}a=v[a+56>>2];if(a){continue}break}}return b}function DQ(a,b){var c=0,d=0;c=v[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=zb(a);v[113382]=0;c=c-2|0;R(787,d|0,c|0);d=v[113382];v[113382]=0;if((d|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}v[a+4>>2]=b}function BR(a,b){var c=0,d=0;c=v[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=zb(a);v[113382]=0;c=c-4|0;R(696,d|0,c|0);d=v[113382];v[113382]=0;if((d|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}v[a+4>>2]=b}function $B(a,b){var c=0,d=0;c=v[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=zb(a);v[113382]=0;c=c-4|0;R(338,d|0,c|0);d=v[113382];v[113382]=0;if((d|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}v[a+4>>2]=b}function vE(a){var b=0,c=0;b=jb-16|0;jb=b;bl(a);v[b+12>>2]=1073741823;v[113382]=0;v[b+8>>2]=2147483647;a=Lb(b+12|0,b+8|0);c=v[113382];v[113382]=0;if((c|0)!=1){jb=b+16|0;return v[a>>2]}V(0)|0;O()|0;Ab();L()}function iz(a){var b=0,c=0;b=jb-16|0;jb=b;v[a>>2]=0;v[a+4>>2]=0;v[113382]=0;v[b+12>>2]=0;W(946,a+8|0,b+12|0,b+8|0)|0;c=v[113382];v[113382]=0;a:{if((c|0)!=1){jb=b+16|0;break a}V(0)|0;O()|0;Ab();L()}return a}function iF(a,b,c,d,e,f){var g=0,h=0,i=0;g=jb-16|0;jb=g;t[g+15|0]=0;t[g+14|0]=f;t[g+13|0]=e;t[g+12|0]=37;if(f){Rg(g+13|0,g+14|0)}h=c,i=(Xa(b|0,GA(b,v[c>>2])|0,g+12|0,d|0,v[a>>2])|0)+b|0,v[h>>2]=i;jb=g+16|0}function eq(a){var b=0,c=0;b=jb-16|0;jb=b;v[a>>2]=0;v[a+4>>2]=0;v[113382]=0;v[b+12>>2]=0;W(373,a+8|0,b+12|0,b+8|0)|0;c=v[113382];v[113382]=0;a:{if((c|0)!=1){jb=b+16|0;break a}V(0)|0;O()|0;Ab();L()}return a}function bw(a){var b=0,c=0;b=jb-16|0;jb=b;v[a>>2]=0;v[a+4>>2]=0;v[113382]=0;v[b+12>>2]=0;W(173,a+8|0,b+12|0,b+8|0)|0;c=v[113382];v[113382]=0;a:{if((c|0)!=1){jb=b+16|0;break a}V(0)|0;O()|0;Ab();L()}return a}function Wj(a,b,c,d){var e=0,f=0,g=0,h=0;e=jb-16|0;jb=e;v[e+12>>2]=0;Le(a+12|0,d);if(b){f=XE(v[a+16>>2],b)}v[a>>2]=f;c=B(c,12)+f|0;v[a+8>>2]=c;v[a+4>>2]=c;g=gc(a),h=B(b,12)+f|0,v[g>>2]=h;jb=e+16|0;return a}function Qz(a){var b=0,c=0;b=jb-16|0;jb=b;v[a>>2]=0;v[a+4>>2]=0;v[113382]=0;v[b+12>>2]=0;W(723,a+8|0,b+12|0,b+8|0)|0;c=v[113382];v[113382]=0;a:{if((c|0)!=1){jb=b+16|0;break a}V(0)|0;O()|0;Ab();L()}return a}function Np(a){var b=0,c=0;b=jb-16|0;jb=b;v[a>>2]=0;v[a+4>>2]=0;v[113382]=0;v[b+12>>2]=0;W(658,a+8|0,b+12|0,b+8|0)|0;c=v[113382];v[113382]=0;a:{if((c|0)!=1){jb=b+16|0;break a}V(0)|0;O()|0;Ab();L()}return a}function AE(a){var b=0,c=0;b=jb-16|0;jb=b;v[a>>2]=0;v[a+4>>2]=0;v[113382]=0;v[b+12>>2]=0;W(177,a+8|0,b+12|0,b+8|0)|0;c=v[113382];v[113382]=0;a:{if((c|0)!=1){jb=b+16|0;break a}V(0)|0;O()|0;Ab();L()}return a}function $S(a,b){var c=0,d=0;c=v[a+4>>2];a:{while(1){if((b|0)==(c|0)){break a}d=zb(a);v[113382]=0;c=c-1|0;R(32,d|0,c|0);d=v[113382];v[113382]=0;if((d|0)!=1){continue}break}V(0)|0;O()|0;Ab();L()}v[a+4>>2]=b}function dba(){var a=0;a:{b:{if(t[80220]&1){break b}if(!vd(80220)){break b}v[113382]=0;T(100,80192)|0;a=v[113382];v[113382]=0;if((a|0)==1){break a}ud(80220)}return 80192}a=P()|0;O()|0;ne(80220);S(a|0);L()}function Q3(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=jb-16|0;jb=d;a=v[a+24>>2];_r(d,0,c);v[113382]=0;U(608,a|0,b|0,d|0);a=v[113382];v[113382]=0;if((a|0)!=1){yb(d);jb=d+16|0;return}a=P()|0;O()|0;yb(d);S(a|0);L()}function Ky(a){var b=0,c=0,d=0;b=x[a+20>>1];u[a+28>>1]=x[a+22>>1]<<1|(w[v[a+16>>2]+3842|0]?b>>>9|0:b>>>8&1);b=0;while(1){c=(b<<2)+a|0;d=v[c>>2];if(d){hn(d);lN(v[c>>2])}b=b+1|0;if((b|0)!=4){continue}break}}function FK(){var a=0;a:{b:{if(t[452168]&1){break b}if(!vd(452168)){break b}v[113382]=0;Q(1492,83464,1)|0;a=v[113382];v[113382]=0;if((a|0)==1){break a}ud(452168)}return}a=P()|0;O()|0;ne(452168);S(a|0);L()}function As(a,b){a=lc(a,b,88);v[a+88>>2]=v[b+88>>2];lc(a+92|0,b+92|0,576);v[a+668>>2]=v[b+668>>2];lc(a+672|0,b+672|0,52);ny(a+724|0,b+724|0);ny(a+736|0,b+736|0);ny(a+748|0,b+748|0);lc(a+760|0,b+760|0,135)}function zc(a,b){a=a|0;b=b|0;var c=0;c=jb-32|0;jb=c;v[c+24>>2]=a;v[c+28>>2]=b;v[c+16>>2]=-2147483648;v[c+20>>2]=-1;v[c+8>>2]=2147483647;v[c+12>>2]=0;a=zQ(c+16|0,Dz(c+24|0,c+8|0));jb=c+32|0;return v[a>>2]}function qda(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=a;d=ac(b);e=bc(b);b=jb-16|0;jb=b;v[b+8>>2]=e;v[b>>2]=d;if(Jb(b,b+8|0)){while(1){aN(c,w[v[b>>2]]);xg(b);if(Jb(b,b+8|0)){continue}break}}jb=b+16|0;return a|0}function qR(a,b,c,d){var e=0,f=0,g=0,h=0;e=jb-16|0;jb=e;v[e+12>>2]=0;Le(a+12|0,d);if(b){f=JS(v[a+16>>2],b)}v[a>>2]=f;c=B(c,6)+f|0;v[a+8>>2]=c;v[a+4>>2]=c;g=gc(a),h=B(b,6)+f|0,v[g>>2]=h;jb=e+16|0;return a}function Sn(a,b,c,d){var e=0,f=0,g=0,h=0;e=jb-16|0;jb=e;v[e+12>>2]=0;Le(a+12|0,d);if(b){f=iC(v[a+16>>2],b)}v[a>>2]=f;c=(c<<1)+f|0;v[a+8>>2]=c;v[a+4>>2]=c;g=gc(a),h=(b<<1)+f|0,v[g>>2]=h;jb=e+16|0;return a}function Qn(a,b,c,d){var e=0,f=0,g=0,h=0;e=jb-16|0;jb=e;v[e+12>>2]=0;Le(a+12|0,d);if(b){f=_B(v[a+16>>2],b)}v[a>>2]=f;c=(c<<2)+f|0;v[a+8>>2]=c;v[a+4>>2]=c;g=gc(a),h=(b<<2)+f|0,v[g>>2]=h;jb=e+16|0;return a}function Mq(a,b,c,d){var e=0,f=0,g=0,h=0;e=jb-16|0;jb=e;v[e+12>>2]=0;Le(a+12|0,d);if(b){f=Lq(v[a+16>>2],b)}v[a>>2]=f;c=(c<<4)+f|0;v[a+8>>2]=c;v[a+4>>2]=c;g=gc(a),h=(b<<4)+f|0,v[g>>2]=h;jb=e+16|0;return a}function Lf(a,b,c,d,e){var f=0;f=jb-256|0;jb=f;if(!(e&73728|(c|0)<=(d|0))){c=c-d|0;d=c>>>0<256;Qb(f,b&255,d?c:256);if(!d){while(1){Re(a,f,256);c=c-256|0;if(c>>>0>255){continue}break}}Re(a,f,c)}jb=f+256|0}function Dq(a,b,c,d){var e=0,f=0,g=0,h=0;e=jb-16|0;jb=e;v[e+12>>2]=0;Le(a+12|0,d);if(b){f=Zn(v[a+16>>2],b)}v[a>>2]=f;c=(c<<5)+f|0;v[a+8>>2]=c;v[a+4>>2]=c;g=gc(a),h=(b<<5)+f|0,v[g>>2]=h;jb=e+16|0;return a}function At(a,b,c,d){var e=0,f=0,g=0,h=0;e=jb-16|0;jb=e;v[e+12>>2]=0;Le(a+12|0,d);if(b){f=tR(v[a+16>>2],b)}v[a>>2]=f;c=(c<<2)+f|0;v[a+8>>2]=c;v[a+4>>2]=c;g=gc(a),h=(b<<2)+f|0,v[g>>2]=h;jb=e+16|0;return a}function eK(a){var b=0,c=0,d=0;if(mf(a)){while(1){b=a;d=c&65535;if(mf(b)>>>0>d>>>0){b=Fe(b,d);v[b+20>>2]=0;v[b+12>>2]=0;v[b+16>>2]=0;iK(b);Ee(b+36|0)}c=c+1|0;if(mf(a)>>>0>(c&65535)>>>0){continue}break}}}function Nd(a,b){var c=0,d=0,e=0;b=b+7&-8;v[a+8>>2]=b+v[a+8>>2];d=v[a+80>>2];a:{if(d){c=b;b=v[a+88>>2];e=c+b|0;c=0;if((e|0)>v[a+92>>2]){break a}v[a+88>>2]=e;return b+d|0}if(!b){return 0}c=kd(b)}return c}function xS(a){var b=0,c=0;b=jb-16|0;jb=b;zb(a);v[b+12>>2]=-1;v[113382]=0;v[b+8>>2]=2147483647;a=Q(33,b+12|0,b+8|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){jb=b+16|0;return v[a>>2]}V(0)|0;O()|0;Ab();L()}function P1(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=jb-16|0;jb=e;vH(b,c,d,z[a+28>>2]);uH(a,b,c,d);b=v[a+24>>2];v[e+8>>2]=v[a+20>>2];v[e+12>>2]=b;b=v[a+16>>2];v[e>>2]=v[a+12>>2];v[e+4>>2]=b;jb=e+16|0}function CM(a){var b=0,c=0;b=v[a>>2];v[a>>2]=0;if(b){a:{b:{if(w[jc(a)+4|0]){v[113382]=0;a=T(1220,b+16|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break b}Cl(a)}if(b){xy(b)}break a}V(0)|0;O()|0;Ab();L()}}}function vga(a,b){a=a|0;b=b|0;a:{a=jb-16|0;jb=a;v[b>>2]=0;v[b+4>>2]=0;v[113382]=0;v[a+12>>2]=0;W(989,b+8|0,a+12|0,a+8|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){jb=a+16|0;break a}V(0)|0;O()|0;Ab();L()}}function eS(a){var b=0,c=0;b=a+36|0;c=qma(w[b|0]|w[b+1|0]<<8,0,384,0);a=a+34|0;b=w[a|0]|w[a+1|0]<<8;a=b>>>30|0;b=b<<2;c=c+b|0;a=a+mb|0;a=b>>>0>c>>>0?a+1|0:a;b=c+256|0;a=b>>>0<256?a+1|0:a;mb=a;return b}function xP(a){var b=0,c=0,d=0,e=0;mb=0;d=w[a+4|0];e=w[a+92|0];c=w[a+93|0];b=a+94|0;b=c+(w[b|0]|w[b+1|0]<<8)|0;a=0;a=b>>>0<c>>>0?1:a;c=b;b=e+b|0;a=b>>>0<c>>>0?a+1|0:a;c=b<<2;b=d+c|0;b=b-96|0;return b}function lu(a){var b=0,c=0,d=0,e=0;d=jb-16|0;jb=d;c=jb-16|0;jb=c;b=c+8|0;xq(b,d+15|0);e=Hb(b);b=hd(a,$b(c,b));if((e|0)==(b|0)){Tc(a,Hb(c+8|0))}jb=c+16|0;jb=d+16|0;return((b|0)==(e|0)?w[d+15|0]:0)&255}function Qha(a,b){a=a|0;b=b|0;var c=0,d=0;c=jb-16|0;jb=c;d=YB(a);if(d>>>0>=b>>>0){a=ht(a);if(a>>>0<d>>>1>>>0){v[c+12>>2]=a<<1;v[c+8>>2]=b+31&-32;d=v[Vc(c+12|0,c+8|0)>>2]}jb=c+16|0;return d|0}ld();L()}function EN(a){a=a|0;var b=0,c=0;b=jb-32|0;jb=b;t[a+16|0]=0;c=Ny(b,v[a+12>>2]);v[113382]=0;U(1139,a|0,1,c|0);a=v[113382];v[113382]=0;if((a|0)!=1){El(c);jb=b+32|0;return}a=P()|0;O()|0;El(c);S(a|0);L()}function zd(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;c=jb-16|0;jb=c;d=v[a>>2];b=(f=d,g=v[a+8>>2],h=$b(c+8|0,b),e=v[v[d>>2]+32>>2],nb[e](f|0,g|0,h|0)|0);v[a+8>>2]=b+v[a+8>>2];jb=c+16|0;return b|0}function kL(a){var b=0,c=0;c=a+946300|0;a=a+906300|0;while(1){b=v[a>>2];a:{if(!b){break a}if(!(nb[v[v[b>>2]+112>>2]](b)|0)){break a}nb[v[v[b>>2]+92>>2]](b)}a=a+160|0;if((c|0)!=(a|0)){continue}break}}function SO(a){var b=0,c=0;a:{if((w[a+44|0]|w[a+45|0]<<8|(w[a+46|0]<<16|w[a+47|0]<<24))!=1297236819|w[a+29|0]!=16){break a}a=a+42|0;b=w[a+1|0]<<8;if((w[a|0]|b)!=1&(b|w[a|0])!=2){break a}c=1}return c}function Faa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=jb-16|0;jb=c;wf(a,c+14|0);pL(b,x[c+14>>1],16777216);if(x[c+14>>1]){while(1){Fi(a,Pb(b,d));d=d+1|0;if(d>>>0<x[c+14>>1]){continue}break}}_x(b);jb=c+16|0}function aZ(a){a=a|0;var b=0,c=0,d=0;b=jb-16|0;jb=b;v[b+12>>2]=a;a=Bh(b+8|0,b+12|0);v[113382]=0;c=IF();d=v[113382];v[113382]=0;if((d|0)!=1){Ge(a);jb=b+16|0;return c|0}b=P()|0;O()|0;Ge(a);S(b|0);L()}function Gg(a,b){a:{if(y[a+4>>2]<=b>>>0){a=ba(8)|0;v[113382]=0;T(318,a|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){break a}b=P()|0;O()|0;ca(a|0);S(b|0);L()}return w[v[a>>2]+b|0]}ha(a|0,72452,235);L()}function Ch(a,b,c){var d=0,e=0,f=0,g=0;v[a+112>>2]=b;v[a+116>>2]=c;d=v[a+8>>2];g=v[a+4>>2];e=d-g|0;f=e>>31;v[a+120>>2]=e;v[a+124>>2]=f;v[a+104>>2]=b|c?b>>>0<e>>>0&(c|0)<=(f|0)|(c|0)<(f|0)?b+g|0:d:d}function WM(a,b,c,d,e,f){v[a+40>>2]=0;v[a+44>>2]=0;A[a+32>>3]=f;A[a+24>>3]=e;A[a+16>>3]=d;A[a+8>>3]=c;A[a>>3]=b;v[a+48>>2]=0;v[a+52>>2]=0;v[a+56>>2]=0;v[a+60>>2]=0;a=a- -64|0;v[a>>2]=0;v[a+4>>2]=0}function DE(a,b,c,d,e){var f=0;f=jb-16|0;jb=f;v[f+12>>2]=e;e=Bh(f+8|0,f+12|0);v[113382]=0;a=xo(a,b,c,d);b=v[113382];v[113382]=0;if((b|0)!=1){Ge(e);jb=f+16|0;return a}a=P()|0;O()|0;Ge(e);S(a|0);L()}function ji(a){var b=0;b=32767;a:{if(a>=C(32766.5)){break a}b=32768;if(a<=C(-32767.5)){break a}a=C(a+C(.5));b:{if(C(D(a))<C(2147483648)){b=~~a;break b}b=-2147483648}b=b+(b>>15)|0}return b<<16>>16}function hM(a,b,c){var d=0,e=0;d=v[(B(b,896)+a|0)+1075640>>2];a:{if(!d){break a}b:{if((c|0)!=1){break b}a=v[(B(b,896)+a|0)+1075088>>2];if(!a){break b}if(w[a+35|0]&4){break a}}e=w[d+34|0]}return e}function dg(a,b){a=a|0;b=b|0;var c=0,d=0;c=jb+-64|0;jb=c;d=yx(c+8|0,a);v[113382]=0;U(1549,a|0,b|0,d|0);a=v[113382];v[113382]=0;if((a|0)!=1){vl(d);jb=c- -64|0;return}a=P()|0;O()|0;vl(d);S(a|0);L()}function Zz(a,b){var c=0,d=0;a:{if(b){Zz(a,v[b>>2]);Zz(a,v[b+4>>2]);a=jc(a);v[113382]=0;c=T(695,b+16|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break a}Bk(c);Ug(a,b,1)}return}V(0)|0;O()|0;Ab();L()}function Xz(a,b){var c=0,d=0;a:{if(b){Xz(a,v[b>>2]);Xz(a,v[b+4>>2]);a=jc(a);v[113382]=0;c=T(692,b+16|0)|0;d=v[113382];v[113382]=0;if((d|0)==1){break a}Bk(c);Ug(a,b,1)}return}V(0)|0;O()|0;Ab();L()}function Wq(a){var b=0;if(v[a+76>>2]<0){b=v[a+4>>2];if(b>>>0<y[a+8>>2]){v[a+4>>2]=b+1;return w[b|0]}return mw(a)}b=v[a+4>>2];a:{if(b>>>0<y[a+8>>2]){v[a+4>>2]=b+1;a=w[b|0];break a}a=mw(a)}return a}function BM(a){var b=0,c=0;b=jb-16|0;jb=b;v[a>>2]=0;v[a+4>>2]=0;v[113382]=0;v[b+12>>2]=0;W(1222,a+8|0,b+12|0,b+8|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){jb=b+16|0;return a}V(0)|0;O()|0;Ab();L()}function yd(a,b){var c=0;if(x[a+24>>1]!=(b&65535)){u[a+22>>1]=x[a+22>>1]-1&127;if(x[a+20>>1]<128){u[a+20>>1]=x[a+20>>1]+1}c=(x[a+22>>1]<<2)+a|0;u[c+28>>1]=0;u[c+26>>1]=b-x[a+24>>1];u[a+24>>1]=b}}function ru(a){var b=0,c=0;b=jb-16|0;jb=b;v[a>>2]=0;v[a+4>>2]=0;v[113382]=0;v[b+12>>2]=0;W(370,a+8|0,b+12|0,b+8|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){jb=b+16|0;return a}V(0)|0;O()|0;Ab();L()}function kz(a){var b=0,c=0;b=jb-16|0;jb=b;v[a>>2]=0;v[a+4>>2]=0;v[b+12>>2]=0;v[113382]=0;W(897,a+8|0,b+12|0,b+8|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){jb=b+16|0;return a}V(0)|0;O()|0;Ab();L()}function jt(a){var b=0,c=0;b=jb-16|0;jb=b;v[a>>2]=0;v[a+4>>2]=0;v[113382]=0;v[b+12>>2]=0;W(893,a+8|0,b+12|0,b+8|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){jb=b+16|0;return a}V(0)|0;O()|0;Ab();L()}function cA(a){var b=0,c=0;b=jb-16|0;jb=b;v[a>>2]=0;v[a+4>>2]=0;v[113382]=0;v[b+12>>2]=0;W(669,a+8|0,b+12|0,b+8|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){jb=b+16|0;return a}V(0)|0;O()|0;Ab();L()}function S3(a,b){a=a|0;b=b|0;var c=0;c=jb-16|0;jb=c;a=v[a+24>>2];_r(c,0,b);v[113382]=0;U(608,a|0,1,c|0);a=v[113382];v[113382]=0;if((a|0)!=1){yb(c);jb=c+16|0;return}a=P()|0;O()|0;yb(c);S(a|0);L()}function Nu(a){var b=0,c=0;b=jb-16|0;jb=b;v[a>>2]=0;v[a+4>>2]=0;v[113382]=0;v[b+12>>2]=0;W(321,a+8|0,b+12|0,b+8|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){jb=b+16|0;return a}V(0)|0;O()|0;Ab();L()}function Fn(a,b,c,d){var e=0,f=0,g=0,h=0;e=jb-16|0;jb=e;v[e+12>>2]=0;Le(a+12|0,d);if(b){f=$C(b)}v[a>>2]=f;c=B(c,24)+f|0;v[a+8>>2]=c;v[a+4>>2]=c;g=gc(a),h=B(b,24)+f|0,v[g>>2]=h;jb=e+16|0;return a}function DC(a){var b=0;if(!((w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24))!=808603728|(w[a+4|0]-9&255)>>>0>6|((w[a+5|0]-9&255)>>>0>6|(w[a+6|0]-9&255)>>>0>6))){b=(w[a+7|0]-9&255)>>>0<7}return b}function CB(a){var b=0,c=0;b=jb-16|0;jb=b;v[a>>2]=0;v[a+4>>2]=0;v[113382]=0;v[b+12>>2]=0;W(374,a+8|0,b+12|0,b+8|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){jb=b+16|0;return a}V(0)|0;O()|0;Ab();L()}function py(a){var b=0,c=0;b=jb-16|0;jb=b;v[a>>2]=0;v[a+4>>2]=0;v[113382]=0;v[b+12>>2]=0;W(94,a+8|0,b+12|0,b+8|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){jb=b+16|0;return a}V(0)|0;O()|0;Ab();L()}function eB(a){var b=0,c=0;b=jb-16|0;jb=b;v[a>>2]=0;v[a+4>>2]=0;v[113382]=0;v[b+12>>2]=0;W(31,a+8|0,b+12|0,b+8|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){jb=b+16|0;return a}V(0)|0;O()|0;Ab();L()}function _A(a,b,c){var d=0;d=jb-16|0;jb=d;v[d+12>>2]=c;v[d>>2]=192;c=v[Lb(d+12|0,d)>>2];if(!Rb(a,c)){c=$e(a)}$p(d,b);kg(a,v[d>>2],c);$p(d,b);Qb(v[d>>2]+c|0,0,192-c|0);_b(a,v[d+12>>2]);jb=d+16|0}function O2(a){a=a|0;var b=0;a=a+24|0;b=LH(v[a>>2]);if(rj(Vb(v[a>>2]+484360|0))>>>0<=b>>>0){return x[v[a>>2]+1074436>>1]}b=x[rc(Vb(v[a>>2]+484360|0),b)>>1];return(In(v[a>>2]+484344|0,b)?b:-1)|0}function z6(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=Jg(86224);if(!d){return 0}v[113382]=0;a=aa(1934,d|0,a|0,b|0,c|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){return a|0}a=P()|0;O()|0;Wb(d);S(a|0);L()}function ox(a){var b=0,c=0,d=0,e=0;A[a+4272>>3]=A[a+4280>>3];c=a;d=a+4296|0;a=0;while(1){a=bp(d)^a<<15;e=b>>>0<17;b=b+15|0;if(e){continue}break}A[c+4280>>3]=C(C(a|0)*C(-4.656612873077393e-10))}function W8(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=jb-16|0;jb=d;e=1;a=a+32|0;if(y[v[b>>2]>>2]<wc(a)>>>0){a=qm(d,uc(a,v[v[b>>2]>>2]),x[v[b>>2]+12>>1]);b=Cv(c,a);Ib(a);e=b^1}jb=d+16|0;return e|0}function Pv(a,b,c,d){var e=0;e=jb-16|0;jb=e;v[e+12>>2]=d;d=Bh(e+8|0,e+12|0);v[113382]=0;a=dk(a,b,c);b=v[113382];v[113382]=0;if((b|0)!=1){Ge(d);jb=e+16|0;return a}a=P()|0;O()|0;Ge(d);S(a|0);L()}function KN(a,b,c,d){var e=0;e=jb-16|0;jb=e;d=Uh(e,a,d);a=zb(a);v[113382]=0;X(1133,a|0,b|0,c|0,d+4|0);a=v[113382];v[113382]=0;if((a|0)!=1){Mb(d);jb=e+16|0;return}a=P()|0;O()|0;Mb(d);S(a|0);L()}function wN(a,b){var c=0;c=jb-16|0;jb=c;v[a>>2]=0;v[a+4>>2]=0;v[c+12>>2]=0;v[113382]=0;W(1160,a+8|0,c+12|0,b|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){jb=c+16|0;return a}V(0)|0;O()|0;Ab();L()}function s7(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=Jg(4276);if(!d){return 0}v[113382]=0;a=aa(1801,d|0,a|0,b|0,c|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){return a|0}a=P()|0;O()|0;Wb(d);S(a|0);L()}function p8(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=Jg(4304);if(!d){return 0}v[113382]=0;a=aa(1670,d|0,a|0,b|0,c|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){return a|0}a=P()|0;O()|0;Wb(d);S(a|0);L()}function k7(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=Jg(4268);if(!d){return 0}v[113382]=0;a=aa(1824,d|0,a|0,b|0,c|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){return a|0}a=P()|0;O()|0;Wb(d);S(a|0);L()}function jda(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if(Yu(a)>>>0<b>>>0){ld();L()}zb(a);c=b;if(c>>>0>536870911){fe(7217);L()}c=be(c<<3,8);v[a>>2]=c;v[a+4>>2]=c;d=zb(a),e=c+(b<<3)|0,v[d>>2]=e;Xu(a,0)}function g7(a,b,c){a=a|0;b=b|0;c=C(c);var d=0;d=jb-16|0;jb=d;z[d+12>>2]=c;if((b|0)<=4){Wd(d+12|0,C(0));c=z[d+12>>2];if((b|0)==4){c=de(c);z[d+12>>2]=c}z[((b<<2)+a|0)+4220>>2]=c;PI(a)}jb=d+16|0}function fda(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if(nv(a)>>>0<b>>>0){ld();L()}zb(a);c=b;if(c>>>0>268435455){fe(7217);L()}c=be(c<<4,8);v[a>>2]=c;v[a+4>>2]=c;d=zb(a),e=c+(b<<4)|0,v[d>>2]=e;ho(a,0)}function dC(a,b,c){var d=0,e=0,f=0;f=jb-16|0;jb=f;e=v[a+4>>2];d=e+b|0;v[a+4>>2]=d;if(!((d-1^e-1)>>>0<32?e:0)){v[v[a>>2]+((d>>>0<33?0:d-1>>>5|0)<<2)>>2]=0}d=f+8|0;Pn(d,a,e);jq(d,b,c);jb=f+16|0}function d7(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=Jg(4296);if(!d){return 0}v[113382]=0;a=aa(1848,d|0,a|0,b|0,c|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){return a|0}a=P()|0;O()|0;Wb(d);S(a|0);L()}function bh(a,b){var c=0,d=0;a=v[a>>2];b=Fd(b);c=b;d=a+8|0;if(Kb(d)>>>0>b>>>0){c=v[Pb(d,c)>>2]!=0}else{c=0}if(!c){a=ba(4)|0;Pm(a);v[a>>2]=67164;ha(a|0,67212,2443);L()}return v[Pb(a+8|0,b)>>2]}function Y6(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=Jg(4228);if(!d){return 0}v[113382]=0;a=aa(1861,d|0,a|0,b|0,c|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){return a|0}a=P()|0;O()|0;Wb(d);S(a|0);L()}function XJ(a,b){var c=0;c=jb-16|0;jb=c;v[a>>2]=0;v[a+4>>2]=0;v[c+12>>2]=0;v[113382]=0;W(1558,a+8|0,c+12|0,b|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){jb=c+16|0;return a}V(0)|0;O()|0;Ab();L()}function WJ(a,b){var c=0;c=jb-16|0;jb=c;v[a>>2]=0;v[a+4>>2]=0;v[c+12>>2]=0;v[113382]=0;W(1560,a+8|0,c+12|0,b|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){jb=c+16|0;return a}V(0)|0;O()|0;Ab();L()}function UM(a,b){var c=0;c=jb-16|0;jb=c;v[a>>2]=0;v[a+4>>2]=0;v[c+12>>2]=0;v[113382]=0;W(1189,a+8|0,c+12|0,b|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){jb=c+16|0;return a}V(0)|0;O()|0;Ab();L()}function U6(a,b,c){a=a|0;b=b|0;c=C(c);var d=0;d=jb-16|0;jb=d;z[d+12>>2]=c;if((b|0)<=1){Wd(d+12|0,C(0));c=z[d+12>>2];if((b|0)==1){c=de(c);z[d+12>>2]=c}z[((b<<2)+a|0)+4208>>2]=c;MI(a)}jb=d+16|0}function P6(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=Jg(5048);if(!d){return 0}v[113382]=0;a=aa(1884,d|0,a|0,b|0,c|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){return a|0}a=P()|0;O()|0;Wb(d);S(a|0);L()}function NG(a,b){var c=0,d=0,e=0,f=C(0),g=C(0),h=0;if((b|0)>0){h=a+2304|0;while(1){c=d<<2;e=c+a|0;c=c+h|0;f=z[c>>2];g=z[e>>2];z[e>>2]=f+g;z[c>>2]=g-f;d=d+1|0;if((d|0)!=(b|0)){continue}break}}}function N8(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=Jg(4268);if(!d){return 0}v[113382]=0;a=aa(1607,d|0,a|0,b|0,c|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){return a|0}a=P()|0;O()|0;Wb(d);S(a|0);L()}function M7(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=Jg(4296);if(!d){return 0}v[113382]=0;a=aa(1744,d|0,a|0,b|0,c|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){return a|0}a=P()|0;O()|0;Wb(d);S(a|0);L()}function Ih(a){var b=0,c=0,d=0,e=0;e=le(a);b=e&63;a:{if(!(e&64)){break a}c=6;while(1){d=le(a);b=(d&127)<<c|b;if(!(d&128)){break a}d=c>>>0<25;c=c+7|0;if(d){continue}break}}return e&128?0-b|0:b}function G6(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=Jg(4276);if(!d){return 0}v[113382]=0;a=aa(1911,d|0,a|0,b|0,c|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){return a|0}a=P()|0;O()|0;Wb(d);S(a|0);L()}function A7(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=Jg(4280);if(!d){return 0}v[113382]=0;a=aa(1777,d|0,a|0,b|0,c|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){return a|0}a=P()|0;O()|0;Wb(d);S(a|0);L()}function lma(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;b=b-a>>2;if((b|0)>0){while(1){d=v[c>>2];t[a|0]=d;t[a+1|0]=d>>>8;t[a+2|0]=d>>>16;t[a+3|0]=d>>>24;a=a+4|0;d=b>>>0>1;b=b-1|0;if(d){continue}break}}}function hba(a){a=a|0;var b=0,c=0,d=0,e=0;v[a>>2]=0;c=jb-16|0;jb=c;d=jb-16|0;jb=d;b=a+9|0;e=b+20|0;while(1){jf(b);b=b+1|0;if((e|0)!=(b|0)){continue}break}jb=d+16|0;jb=c+16|0;Dg(a);return a|0}function bP(a,b){var c=0;c=jb-16|0;jb=c;v[a>>2]=0;v[a+4>>2]=0;v[c+12>>2]=0;v[113382]=0;W(955,a+8|0,c+12|0,b|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){jb=c+16|0;return a}V(0)|0;O()|0;Ab();L()}function Tv(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=jb-16|0;jb=d;c=oe(d,a,b);b=v[c+4>>2];e=v[c+8>>2];while(1){if((b|0)==(e|0)){Mb(c);jb=d+16|0}else{Yy(bl(a),b);b=b+4|0;v[c+4>>2]=b;continue}break}}function Sz(a,b,c){a=a|0;b=b|0;c=c|0;a=w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24);t[b|0]=a;t[b+1|0]=a>>>8;t[b+2|0]=a>>>16;t[b+3|0]=a>>>24;a=w[c+4|0]|w[c+5|0]<<8;t[b+4|0]=a;t[b+5|0]=a>>>8}function Kca(a){a=a|0;var b=0,c=0,d=0;b=jb-16|0;jb=b;c=Ub(b,6353);v[113382]=0;a=Q(89,a|0,c|0)|0;d=v[113382];v[113382]=0;if((d|0)!=1){yb(c);jb=b+16|0;return a|0}a=P()|0;O()|0;yb(c);S(a|0);L()}function Fi(a,b){var c=0,d=0;c=jb-16|0;jb=c;v[c+12>>2]=0;a=Xk(a,c+12|0,4);v[c+8>>2]=v[c+12>>2];d=b;b=c+8|0;v[d>>2]=w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24);jb=c+16|0;return!mb&(a|0)==4}function hE(a,b,c,d){var e=0;e=v[b+4>>2];v[a>>2]=v[b>>2];v[a+4>>2]=e;e=v[b+12>>2];v[a+8>>2]=v[b+8>>2];v[a+12>>2]=e;b=v[a+8>>2];d=v[a+12>>2]-(d+(b>>>0<c>>>0)|0)|0;v[a+8>>2]=b-c;v[a+12>>2]=d}function gaa(a,b){a=a|0;b=b|0;var c=0;b=jb-16|0;jb=b;c=-1;a:{if(!Ij(a,b+8|0)){break a}c=0;if(!xK(b+8|0)){break a}c=b;a=NO(a,b);if(!a){wR(c)}c=-1;if(!a){break a}c=wK(b)}jb=b+16|0;return c|0}function SF(a,b,c,d){a:{if(!a){break a}b:{switch(b+2|0){case 0:t[a|0]=c;return;case 1:u[a>>1]=c;return;case 2:case 3:v[a>>2]=c;return;case 5:break b;default:break a}}v[a>>2]=c;v[a+4>>2]=d}}function z8(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=v[b>>2];a:{if((rh(b)|0)!=8){break a}d=c;if((w[d|0]|w[d+1|0]<<8|(w[d+2|0]<<16|w[d+3|0]<<24))!=1869112133){break a}lc(a+4260|0,c,rh(b));hs(a)}}function xZ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a:{while(1){if((c|0)==(d|0)){break a}b:{if(y[c>>2]>127){break b}if(!(x[qo()+(v[c>>2]<<1)>>1]&b)){break b}c=c+4|0;continue}break}d=c}return d|0}function x8(a,b,c){a=a|0;b=b|0;c=C(c);var d=0,e=0,f=C(0);d=jb-16|0;jb=d;e=d,f=C(C(nb[v[v[a>>2]+48>>2]](a,b))+c),z[e+12>>2]=f;Wd(d+12|0,C(0));nb[v[v[a>>2]+44>>2]](a,b,z[d+12>>2]);jb=d+16|0}function uw(a,b,c){b=(b+9|0)%12|0;a=((b<<24>>24)/-10<<24>>24)+a|0;return(((((((a|0)/4|0)+c|0)+B(a,365)|0)+((a|0)/-100|0)|0)+((a|0)/400|0)|0)+((B(b,20054016)+327680>>16)/10<<16>>16)|0)-1|0}function kw(a,b,c,d,e,f,g,h,i){var j=0;j=jb-16|0;jb=j;bg(j,b,c,d,e,f,g,h,i^-2147483648);d=v[j>>2];c=v[j+4>>2];b=v[j+12>>2];v[a+8>>2]=v[j+8>>2];v[a+12>>2]=b;v[a>>2]=d;v[a+4>>2]=c;jb=j+16|0}function Pd(a,b){var c=0;a:{c=cf(b);if((c|0)==(Db(a)|0)){v[113382]=0;a=ea(310,a|0,0,-1,b|0,c|0)|0;b=v[113382];v[113382]=0;if((b|0)==1){break a}a=!a}else{a=0}return a}V(0)|0;O()|0;Ab();L()}function Jo(a,b){var c=0,d=0,e=0;c=jb-16|0;jb=c;d=c,e=ke(b),v[d+12>>2]=e;v[113382]=0;W(1971,a|0,c+12|0,b|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){jb=c+16|0;return a}V(0)|0;O()|0;Ab();L()}function Io(a,b){var c=0,d=0,e=0;c=jb-16|0;jb=c;d=c,e=ke(b),v[d+12>>2]=e;v[113382]=0;W(2132,a|0,c+12|0,b|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){jb=c+16|0;return a}V(0)|0;O()|0;Ab();L()}function zZ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;while(1){if((b|0)!=(c|0)){a=d;if(y[b>>2]<=127){e=x[qo()+(v[b>>2]<<1)>>1]}else{e=0}u[a>>1]=e;d=d+2|0;b=b+4|0;continue}break}return c|0}function yy(a,b){var c=0;a:{if(b){yy(a,v[b>>2]);yy(a,v[b+4>>2]);jc(a);v[113382]=0;a=T(1220,b+16|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break a}Cl(a);xy(b)}return}V(0)|0;O()|0;Ab();L()}function xz(a){var b=0,c=0;c=(w[a+24|0]>15)+(w[a+25|0]>64)|0;b=a+26|0;b=w[b|0]|w[b+1|0]<<8;a=a+22|0;a=w[a|0]|w[a+1|0]<<8;return c+(((b<<8|b>>>8)&65535)>>>0>((a<<8|a>>>8)&65535)<<1>>>0)|0}function vi(a){a=a|0;var b=0,c=0,d=0,e=0;while(1){c=a;e=d&65535;b=e;if(b>>>0<=126){Dg(((b<<5)+c|0)+480280|0);mn((B(b,896)+c|0)+1074984|0,7,c,b,1024)}d=d+1|0;if(e>>>0<126){continue}break}}function mO(a){var b=0,c=0;a:{b:{c=a&240;if((c|0)!=192){if((c|0)==240){break b}b=3;if((c|0)!=208){break a}}b=2;break a}a=a+15&255;b=1;if(a>>>0>2){break a}b=131842>>>(a<<3)|0}return b&255}function Lh(a){var b=0;a=de(a);b=2147483647;a:{if(!(a<C(2147483648))){break a}b=-2147483648;if(!(a>C(-2147483648))){break a}b=~~a;if(C(D(a))<C(2147483648)){break a}b=-2147483648}return b}function rl(a,b){var c=0,d=C(0),e=0;e=u[a+28>>1];c=a+4|0;Kb(c);d=C(1);a:{if((b|0)<(e|0)){break a}if((x[a+28>>1]+Kb(c)<<16)-65536>>16<(b|0)){break a}d=z[Pb(c,b-u[a+28>>1]|0)>>2]}return d}function p0(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;e=v[a+84>>2];d=c+256|0;f=Dr(e,0,d);d=f?f-e|0:d;c=c>>>0>d>>>0?d:c;lc(b,e,c);b=e+d|0;v[a+84>>2]=b;v[a+8>>2]=b;v[a+4>>2]=c+e;return c|0}function fi(a,b){var c=0,d=0;c=w[a|0];d=w[b|0];a:{if(!c|(d|0)!=(c|0)){break a}while(1){d=w[b+1|0];c=w[a+1|0];if(!c){break a}b=b+1|0;a=a+1|0;if((c|0)==(d|0)){continue}break}}return c-d|0}function Ms(a,b,c){var d=0;a=jb-16|0;jb=a;d=a+8|0;Hh(d,c);v[113382]=0;b=Q(1024,b|0,d|0)|0;c=v[113382];v[113382]=0;a:{if((c|0)!=1){jb=a+16|0;break a}V(0)|0;O()|0;Ab();L()}return b>>>31|0}function CK(a,b,c){var d=0;a=jb-16|0;jb=a;d=a+8|0;Hh(d,c);v[113382]=0;b=Q(1496,b|0,d|0)|0;c=v[113382];v[113382]=0;a:{if((c|0)!=1){jb=a+16|0;break a}V(0)|0;O()|0;Ab();L()}return b>>>31|0}function ws(a,b){var c=0;a:{if(b){ws(a,v[b>>2]);ws(a,v[b+4>>2]);a=jc(a);v[113382]=0;T(1345,b+14|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break a}Bp(a,b,1)}return}V(0)|0;O()|0;Ab();L()}function wI(a,b){var c=0,d=0,e=0;if(a>C(.9999989867210388)){d=0}else{a=C(a*a);e=+a;c=we(31415.926535897932/+b);d=jn((32768-(K((1-c)*+C(a+a)+(c*c-1)*+C(a*a))+c*e)*32768)/(1-e))}return d}function w$(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;d=a;b=v[a+112>>2];if((b|0)>=11){e=a;b=378;while(1){tF(e);c=f-!b|0;b=b-1|0;f=c;if(b|c){continue}break}b=0}v[d+112>>2]=b+1;a=tF(a);return a|0}function lja(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=jb-16|0;jb=c;v[c+8>>2]=b;d=c,e=ac(a),v[d>>2]=e;b=ut(c+8|0,c);b=v[a>>2]+(b<<2)|0;Ku(a,kf(b+4|0,v[a+4>>2],b));a=Pg(b);jb=c+16|0;return a|0}function gy(a,b){var c=0;a:{if(b){gy(a,v[b>>2]);gy(a,v[b+4>>2]);a=jc(a);v[113382]=0;T(1349,b+16|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break a}lt(a,b,1)}return}V(0)|0;O()|0;Ab();L()}function c6(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;f=jb-16|0;jb=f;v[f+8>>2]=v[a+8>>2];g=v[a+4>>2];v[f>>2]=v[a>>2];v[f+4>>2]=g;a=oI(f,b,c,d,0,0,0,0,e);jb=f+16|0;return a|0}function b$(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=jb-16|0;jb=g;v[g+8>>2]=624576549;v[g+12>>2]=1394948685;h=a;a=g+16|0;b=ej(h,b,c,d,e,f,g+8|0,a);jb=a;return b|0}function Vca(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a:{if(w[b+30|0]!=4){break a}d=b+31|0;if(w[d|0]&4|w[d|0]&2){break a}Yc(a,8,1,0,11);return}d=a;a=b+31|0;Yc(d,w[a|0]&4?16:8,w[a|0]&2|1,0,c^1)}function Jp(a,b){var c=0,d=0,e=0;c=jb-16|0;jb=c;d=c,e=ke(b),v[d+12>>2]=e;v[113382]=0;W(688,a|0,c+12|0,b|0)|0;a=v[113382];v[113382]=0;if((a|0)!=1){jb=c+16|0;return}V(0)|0;O()|0;Ab();L()}function nm(a,b,c){a=a|0;b=b|0;c=c|0;a:{b=jb-16|0;jb=b;gx(b,c);v[113382]=0;U(13,a|0,0,b|0);a=v[113382];v[113382]=0;if((a|0)!=1){yb(b);jb=b+16|0;break a}a=P()|0;O()|0;yb(b);S(a|0);L()}}function gv(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;d=v[a>>2];b=(f=d,g=Eb(b),h=v[a+8>>2],i=c,e=v[v[d>>2]+28>>2],nb[e](f|0,g|0,h|0,i|0)|0);v[a+8>>2]=b+v[a+8>>2];return b|0}function J3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;$c(a+12|0,0,0);c=a+20|0;d=c+16|0;while(1){c=Ik(c)+4|0;if((d|0)!=(c|0)){continue}break}e=a,f=zL(b),v[e+36>>2]=f;v[a+40>>2]=1;return a|0}function Fz(a,b){var c=0;a:{if(b){Fz(a,v[b>>2]);Fz(a,v[b+4>>2]);a=jc(a);v[113382]=0;T(786,b+14|0)|0;c=v[113382];v[113382]=0;if((c|0)==1){break a}Bp(a,b,1)}return}V(0)|0;O()|0;Ab();L()}function mI(a){a=a|0;var b=0;a:{if(!a){a=ba(8)|0;v[113382]=0;T(1985,a|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){break a}b=P()|0;O()|0;ca(a|0);S(b|0);L()}return}ha(a|0,78556,1986);L()}function fx(a){a=a|0;var b=0;a:{if(!a){a=ba(8)|0;v[113382]=0;T(1997,a|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){break a}b=P()|0;O()|0;ca(a|0);S(b|0);L()}return}ha(a|0,78568,1986);L()}function bz(a){var b=0;if(v[a>>2]){ae(a,v[a>>2]);b=v[a>>2];a=(v[zb(a)>>2]-v[a>>2]|0)/9|0;v[113382]=0;U(25,b|0,B(a,9)|0,1);a=v[113382];v[113382]=0;if((a|0)==1){V(0)|0;O()|0;Ab();L()}}}function ye(a,b){var c=0,d=0;c=jb-16|0;jb=c;v[c+12>>2]=b;d=b;b=ns(a);if(d>>>0<=b>>>0){a=nd(a);if(a>>>0<b>>>1>>>0){v[c+8>>2]=a<<1;b=v[Vc(c+8|0,c+12|0)>>2]}jb=c+16|0;return b}ld();L()}function xn(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=jb-16|0;jb=d;c=d+8|0;rR(c,b);e=Hb(c);c=mc(a,$b(d,c));if((e|0)==(c|0)){_b(a,Hb(d+8|0))}jb=d+16|0;a=(c|0)==(e|0);if(!a){sR(b)}return a|0}function wm(a,b){var c=0,d=0;c=jb-16|0;jb=c;v[c+12>>2]=b;d=b;b=_E(a);if(d>>>0<=b>>>0){a=tg(a);if(a>>>0<b>>>1>>>0){v[c+8>>2]=a<<1;b=v[Vc(c+8|0,c+12|0)>>2]}jb=c+16|0;return b}ld();L()}function uY(){var a=0;a:{if(t[455032]&1){break a}if(!vd(455032)){break a}a=455008;while(1){a=sf(a)+12|0;if((a|0)!=455032){continue}break}ud(455032)}Wc(455008,64768);Wc(455020,64780)}function sI(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;var f=0,g=0;f=jb-16|0;jb=f;v[f+8>>2]=v[a+8>>2];g=v[a+4>>2];v[f>>2]=v[a>>2];v[f+4>>2]=g;c=rI(f,b,c,d,e,0,0,0,0);jb=f+16|0;return+c}function nu(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=jb-16|0;jb=d;c=d+8|0;WA(c,b);e=Hb(c);c=mc(a,$b(d,c));if((e|0)==(c|0)){_b(a,Hb(d+8|0))}jb=d+16|0;a=(c|0)==(e|0);if(!a){XA(b)}return a|0}function ku(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=jb-16|0;jb=d;c=d+8|0;hu(c,b);e=Hb(c);c=mc(a,$b(d,c));if((e|0)==(c|0)){_b(a,Hb(d+8|0))}jb=d+16|0;a=(c|0)==(e|0);if(!a){YA(b)}return a|0}function iD(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=jb-16|0;jb=d;c=d+8|0;WC(c,b);e=Hb(c);c=mc(a,$b(d,c));if((e|0)==(c|0)){_b(a,Hb(d+8|0))}jb=d+16|0;a=(c|0)==(e|0);if(!a){XC(b)}return a|0}function hm(a,b){var c=0,d=0;c=jb-16|0;jb=c;v[c+12>>2]=b;d=b;b=PC(a);if(d>>>0<=b>>>0){a=wh(a);if(a>>>0<b>>>1>>>0){v[c+8>>2]=a<<1;b=v[Vc(c+8|0,c+12|0)>>2]}jb=c+16|0;return b}ld();L()}function hD(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=jb-16|0;jb=d;c=d+8|0;UC(c,b);e=Hb(c);c=mc(a,$b(d,c));if((e|0)==(c|0)){_b(a,Hb(d+8|0))}jb=d+16|0;a=(c|0)==(e|0);if(!a){VC(b)}return a|0}function gt(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=jb-16|0;jb=d;c=d+8|0;sP(c,b);e=Hb(c);c=mc(a,$b(d,c));if((e|0)==(c|0)){_b(a,Hb(d+8|0))}jb=d+16|0;a=(c|0)==(e|0);if(!a){tP(b)}return a|0}function cK(a,b){var c=0,d=0;c=jb-16|0;jb=c;v[c+12>>2]=b;d=b;b=_J(a);if(d>>>0<=b>>>0){a=lj(a);if(a>>>0<b>>>1>>>0){v[c+8>>2]=a<<1;b=v[Vc(c+8|0,c+12|0)>>2]}jb=c+16|0;return b}ld();L()}function bB(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=jb-16|0;jb=d;c=d+8|0;eu(c,b);e=Hb(c);c=mc(a,$b(d,c));if((e|0)==(c|0)){_b(a,Hb(d+8|0))}jb=d+16|0;a=(c|0)==(e|0);if(!a){QA(b)}return a|0}function Wga(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=jb-16|0;jb=d;v[d+12>>2]=c;c=0;a=nb[v[v[a>>2]+24>>2]](a)|0;if(a>>>0>b>>>0){v[d+8>>2]=a-b;c=v[Lb(d+12|0,d+8|0)>>2]}jb=d+16|0;return c|0}function Rz(a,b){var c=0,d=0;c=jb-16|0;jb=c;v[c+12>>2]=b;d=b;b=KS(a);if(d>>>0<=b>>>0){a=Mi(a);if(a>>>0<b>>>1>>>0){v[c+8>>2]=a<<1;b=v[Vc(c+8|0,c+12|0)>>2]}jb=c+16|0;return b}ld();L()}function Ru(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=jb-16|0;jb=d;c=d+8|0;vq(c,b);e=Hb(c);c=mc(a,$b(d,c));if((e|0)==(c|0)){_b(a,Hb(d+8|0))}jb=d+16|0;a=(c|0)==(e|0);if(!a){xC(b)}return a|0}function Qi(a,b){var c=0,d=0;c=jb-16|0;jb=c;v[c+12>>2]=b;d=b;b=jC(a);if(d>>>0<=b>>>0){a=Yf(a);if(a>>>0<b>>>1>>>0){v[c+8>>2]=a<<1;b=v[Vc(c+8|0,c+12|0)>>2]}jb=c+16|0;return b}ld();L()}function Ot(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=jb-16|0;jb=d;c=d+8|0;lA(c,b);e=Hb(c);c=mc(a,$b(d,c));if((e|0)==(c|0)){_b(a,Hb(d+8|0))}jb=d+16|0;a=(c|0)==(e|0);if(!a){zS(b)}return a|0}function Nq(a,b){var c=0,d=0;c=jb-16|0;jb=c;v[c+12>>2]=b;d=b;b=nv(a);if(d>>>0<=b>>>0){a=Wh(a);if(a>>>0<b>>>1>>>0){v[c+8>>2]=a<<1;b=v[Vc(c+8|0,c+12|0)>>2]}jb=c+16|0;return b}ld();L()}function Lk(a,b){var c=0,d=0;c=jb-16|0;jb=c;v[c+12>>2]=b;d=b;b=cT(a);if(d>>>0<=b>>>0){a=Ye(a);if(a>>>0<b>>>1>>>0){v[c+8>>2]=a<<1;b=v[Vc(c+8|0,c+12|0)>>2]}jb=c+16|0;return b}ld();L()}function Ki(a,b){var c=0,d=0;c=jb-16|0;jb=c;v[c+12>>2]=b;d=b;b=xS(a);if(d>>>0<=b>>>0){a=xf(a);if(a>>>0<b>>>1>>>0){v[c+8>>2]=a<<1;b=v[Vc(c+8|0,c+12|0)>>2]}jb=c+16|0;return b}ld();L()}function Iaa(a){a=a|0;var b=0;b=1;a=v[a+480180>>2];a:{b:{if((a|0)<=16383){if((a|0)==4|(a|0)!=32){break b}break a}if((a|0)==16384){break b}if((a|0)==16777216){break a}}b=2}return b|0}function GB(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=jb-16|0;jb=d;c=d+8|0;tB(c,b);e=Hb(c);c=mc(a,$b(d,c));if((e|0)==(c|0)){_b(a,Hb(d+8|0))}jb=d+16|0;a=(c|0)==(e|0);if(!a){uB(b)}return a|0}function zka(a,b){a=a|0;b=b|0;var c=0;c=jb-32|0;jb=c;v[c+24>>2]=0;v[c+28>>2]=0;v[c+16>>2]=0;v[c+20>>2]=0;v[c+8>>2]=0;v[c+12>>2]=0;v[c>>2]=0;v[c+4>>2]=0;RR(b,c,32);QR(a,c);jb=c+32|0}function wK(a){var b=0;a:{if((w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24))!=1179012417){b=0;if((w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24))!=538987841){break a}}b=1}return b}function tr(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=jb-16|0;jb=e;v[e+12>>2]=d;d=Db(b);if(d>>>0<c>>>0){pm();L()}b=Tb(b);v[e+4>>2]=d-c;Ks(a,b+c|0,v[Lb(e+12|0,e+4|0)>>2]);jb=e+16|0}function au(a){a=a|0;var b=0,c=0;b=jb-16|0;jb=b;if(Aq(a,b+8|0)){a=w[b+8|0]|w[b+9|0]<<8|(w[b+10|0]<<16|w[b+11|0]<<24);c=a<<24|a<<8&16711680|(a>>>8&65280|a>>>24)}jb=b+16|0;return c|0}function V1(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;if((b|0)!=(c|0)){a=v[d>>2];while(1){v[a>>2]=v[b>>2];zf(a+4|0,b+4|0);a=v[d>>2]+16|0;v[d>>2]=a;b=b+16|0;if((c|0)!=(b|0)){continue}break}}}function Pka(a,b){a=a|0;b=b|0;var c=0;c=jb-16|0;jb=c;Us(c,b);v[113382]=0;U(608,a|0,4,c|0);a=v[113382];v[113382]=0;if((a|0)!=1){yb(c);jb=c+16|0;return}a=P()|0;O()|0;yb(c);S(a|0);L()}function zS(a){var b=0;b=jb-16|0;jb=b;t[a|0]=0;t[a+1|0]=0;t[a+2|0]=0;t[a+3|0]=0;t[a+4|0]=0;t[a+5|0]=0;t[a+6|0]=0;t[a+7|0]=0;t[a+8|0]=0;t[a+9|0]=0;t[a+10|0]=0;t[a+11|0]=0;jb=b+16|0}function i0(a){a=a|0;var b=0,c=0;b=jb-16|0;jb=b;jj(b,0,a);v[113382]=0;a=T(172,b|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){yb(b);jb=b+16|0;return a|0}a=P()|0;O()|0;yb(b);S(a|0);L()}function oz(a,b){var c=0,d=0,e=0,f=0,g=0,h=0,i=0;c=jb-16|0;jb=c;d=a,e=(g=a,h=v[a+12>>2],i=$b(c+8|0,b),f=v[v[a>>2]+32>>2],nb[f](g|0,h|0,i|0)|0)+v[a+12>>2]|0,v[d+12>>2]=e;jb=c+16|0}function XA(a){var b=0;b=jb-16|0;jb=b;t[a|0]=0;t[a+1|0]=0;t[a+2|0]=0;t[a+3|0]=0;t[a+4|0]=0;t[a+5|0]=0;t[a+6|0]=0;t[a+7|0]=0;t[a+7|0]=0;t[a+8|0]=0;t[a+9|0]=0;t[a+10|0]=0;jb=b+16|0}function yZ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;while(1){a:{if((c|0)!=(d|0)){if(y[c>>2]>127){break a}if(!(x[qo()+(v[c>>2]<<1)>>1]&b)){break a}}else{c=d}return c|0}c=c+4|0;continue}}function Yk(a){var b=0,c=0;b=v[20046];c=a+3&-4;a=b+c|0;a:{if(a>>>0<=b>>>0?c:0){break a}if(a>>>0>ob()<<16>>>0){if(!(Sa(a|0)|0)){break a}}v[20046]=a;return b}v[113305]=48;return-1}function I0(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=jb-16|0;jb=d;e=v[c+4>>2];c=v[c>>2];v[d>>2]=c;v[d+4>>2]=e;v[d+8>>2]=c;v[d+12>>2]=e;aG(a,d,b);v[a>>2]=51996;jb=d+16|0;return a|0}function $N(a,b){var c=0;c=w[a+822|0];a:{if(c){break a}c=Hk(w[a+819|0]-v[a+772>>2]|0);if(!b|(!v[a+656>>2]|!c|c>>>0>=129)){break a}c=w[ec(v[a+656>>2]+108|0,c-1|0)|0]}return c&255}function zx(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=jb-16|0;jb=e;d=Tp(e,a,d);zb(a);a=c-b|0;if((a|0)>0){lc(v[d+4>>2],b,a);v[d+4>>2]=v[d+4>>2]+B((a>>>0)/6|0,6)}Mb(d);jb=e+16|0}function yP(a){var b=0,c=0;a:{if((w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24))!=441273424|w[a+5|0]!=16){break a}b=a+54|0;if(!w[b|0]|w[b|0]>32){break a}c=w[a+4|0]>95}return c}function y0(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=jb-16|0;jb=d;e=d+8|0;nb[v[v[a>>2]+12>>2]](e,a,b);if(se(v[e+4>>2],v[c+4>>2])){a=v[e>>2]==v[c>>2]}else{a=0}jb=d+16|0;return a|0}function xv(a,b){var c=0,d=0;c=jb-16|0;jb=c;u[b>>1]=0;t[c+15|0]=0;$g(a,c+15|0);d=w[c+15|0];u[b>>1]=d>>>1;if(d&1){t[c+15|0]=0;$g(a,c+15|0);u[b>>1]=x[b>>1]|w[c+15|0]<<7}jb=c+16|0}function wf(a,b){a=a|0;b=b|0;var c=0,d=0;c=jb-16|0;jb=c;u[c+14>>1]=0;a=Xk(a,c+14|0,2);u[c+12>>1]=x[c+14>>1];d=b;b=c+12|0;u[d>>1]=w[b|0]|w[b+1|0]<<8;jb=c+16|0;return!mb&(a|0)==2}function rS(a){var b=0;a:{if((w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24))!=-28163770){break a}if(md(a+44|0,13835,3)){break a}a=a+47|0;b=(w[a|0]|w[a+1|0]<<8)>>>0>97}return b}function Wha(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=jb-16|0;jb=d;v[d+12>>2]=c;sz(a,b,c);c=0;a=v[a+16>>2];if(a>>>0>b>>>0){v[d+8>>2]=a-b;c=v[Lb(d+8|0,d+12|0)>>2]}jb=d+16|0;return c|0}function Gb(a,b){var c=0,d=0;c=jb-16|0;jb=c;if(he(a)){cg(a,v[a>>2],hj(a))}v[a+8>>2]=v[b+8>>2];d=v[b+4>>2];v[a>>2]=v[b>>2];v[a+4>>2]=d;Ce(b,0);t[c+15|0]=0;Rd(b,c+15|0);jb=c+16|0}function xr(a,b,c){var d=0;a:{d=jb-16|0;jb=d;ax(d,b,c);v[113382]=0;U(13,a|0,0,d|0);a=v[113382];v[113382]=0;if((a|0)!=1){yb(d);jb=d+16|0;break a}a=P()|0;O()|0;yb(d);S(a|0);L()}}function xY(){var a=0;a:{if(t[455e3]&1){break a}if(!vd(455e3)){break a}a=454976;while(1){a=Xb(a)+12|0;if((a|0)!=455e3){continue}break}ud(455e3)}Kc(454976,9812);Kc(454988,9791)}function iu(a,b,c){var d=0;a:{d=jb-16|0;jb=d;OH(d,b,c);v[113382]=0;U(13,a|0,0,d|0);a=v[113382];v[113382]=0;if((a|0)!=1){yb(d);jb=d+16|0;break a}a=P()|0;O()|0;yb(d);S(a|0);L()}}function bK(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=65535;a:{if(!jg(a,b)){break a}c=wx(a,v[Fe(a,b)+12>>2],c);d=65535;if((c|0)==65535){break a}b=Fe(a,b);hK(Fe(a,c),b);d=c}return d|0}function K1(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=jb-16|0;jb=e;vH(b,c,d,z[a+24>>2]);qH(a,b,c,d);v[e+8>>2]=v[a+20>>2];b=v[a+16>>2];v[e>>2]=v[a+12>>2];v[e+4>>2]=b;jb=e+16|0}function $v(a,b,c){var d=0;a:{d=jb-16|0;jb=d;Wr(d,b,c);v[113382]=0;U(13,a|0,0,d|0);a=v[113382];v[113382]=0;if((a|0)!=1){yb(d);jb=d+16|0;break a}a=P()|0;O()|0;yb(d);S(a|0);L()}}function $h(a,b){var c=0,d=0;c=jb-16|0;jb=c;if(he(a)){no(v[a>>2],hj(a))}v[a+8>>2]=v[b+8>>2];d=v[b+4>>2];v[a>>2]=v[b>>2];v[a+4>>2]=d;Ce(b,0);v[c+12>>2]=0;Te(b,c+12|0);jb=c+16|0}function o9(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=jb-16|0;jb=d;e=x[a+28>>1];u[d+8>>1]=e;f=d,g=(Kb(a+4|0)+e|0)-1|0,u[f+10>>1]=g;a=SJ(a,b,c,d+8|0);jb=d+16|0;return a|0}function B6(a){a=a|0;var b=0,c=C(0);t[a+4202|0]=1;b=a,c=dn(C(C(C(Ue(v[a+16>>2])>>>0)*C(20938023226335645e-21))+C(-.005025125574320555)),C(0),C(1)),z[b+4272>>2]=c;EI(a);DI(a)}function qD(a){var b=0;a:{if(!(y[a>>2]<=18285140|y[a>>2]>=18350592)){b=1;if(v[a>>2]!=18350080){break a}}a=v[a>>2];b=0;if(a>>>0<=18350592){break a}b=(a|0)!=(a&-256)}return b}function jha(a,b){a=a|0;b=b|0;var c=0,d=0;c=1;d=a;a=b+47|0;b=Yc(d,w[a|0]&4?16:8,1,0,0);a:{b:{if(w[a|0]&8){break b}c=2;if(w[a|0]&16){break b}if(w[a|0]&127){break a}}Zl(b,c)}}function EQ(a,b){var c=0;c=jb-32|0;jb=c;v[c+24>>2]=a;v[c+28>>2]=b;v[c+16>>2]=0;v[c+20>>2]=0;v[c+8>>2]=-1;v[c+12>>2]=0;a=zQ(c+16|0,Dz(c+24|0,c+8|0));jb=c+32|0;return v[a>>2]}function lba(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;a=jb-16|0;jb=a;v[a+8>>2]=v[d>>2];c=v[a+8>>2];c=x[c>>1]|x[c+2>>1]<<16;u[b+4>>1]=0;u[b>>1]=c;u[b+2>>1]=c>>>16;jb=a+16|0}function baa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=jb-16|0;jb=c;v[c+12>>2]=b;d=c,e=RS(ac(a),bc(a),c+12|0),v[d+8>>2]=e;d=c,e=bc(a),v[d>>2]=e;a=Jb(c+8|0,c);jb=c+16|0;return a|0}function RH(a){var b=0,c=0;b=jb-16|0;jb=b;v[113382]=0;v[b+12>>2]=0;W(2136,a|0,b+12|0,b+8|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){jb=b+16|0;return a}V(0)|0;O()|0;Ab();L()}function QH(a){var b=0,c=0;b=jb-16|0;jb=b;v[113382]=0;v[b+12>>2]=0;W(2137,a|0,b+12|0,b+8|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){jb=b+16|0;return a}V(0)|0;O()|0;Ab();L()}function PH(a){var b=0,c=0;b=jb-16|0;jb=b;v[113382]=0;v[b+12>>2]=0;W(2138,a|0,b+12|0,b+8|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){jb=b+16|0;return a}V(0)|0;O()|0;Ab();L()}function Ip(a){var b=0,c=0;c=v[a+4>>2];b=v[c>>2];v[a+4>>2]=b;if(b){tn(b,a)}v[c+8>>2]=v[a+8>>2];a:{if(Ag(a)){b=v[a+8>>2];break a}b=v[a+8>>2]+4|0}v[b>>2]=c;v[c>>2]=a;tn(a,c)}function IE(a){a=a|0;var b=0,c=0;v[a>>2]=59496;b=a+8|0;while(1){if(Kb(b)>>>0>c>>>0){if(v[Pb(b,c)>>2]){jm(v[Pb(b,c)>>2])}c=c+1|0;continue}break}yb(a+152|0);UE(b);return a|0}function Hp(a){var b=0,c=0;c=v[a>>2];b=v[c+4>>2];v[a>>2]=b;if(b){tn(b,a)}v[c+8>>2]=v[a+8>>2];a:{if(Ag(a)){b=v[a+8>>2];break a}b=v[a+8>>2]+4|0}v[b>>2]=c;v[c+4>>2]=a;tn(a,c)}function lo(a,b){var c=0,d=0,e=0;c=0;a:{if(!a){break a}d=qma(a,0,b,0);e=mb;c=d;if((a|b)>>>0<65536){break a}c=e?-1:d}b=c;a=kd(b);if(!(!a|!(w[a-4|0]&3))){Qb(a,0,b)}return a}function aha(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=nb[v[v[a>>2]+24>>2]](a)|0;a:{if((a|0)==(b|0)){d=1;if(!c){break a}}d=0;if(a>>>0<=b>>>0){break a}d=a-b>>>0>=c>>>0}return d|0}function QX(a,b){a=a|0;b=b|0;v[a+4>>2]=b;t[a|0]=0;if(Jf(v[v[b>>2]-12>>2]+b|0)){if(v[(v[v[b>>2]-12>>2]+b|0)+72>>2]){br(v[(v[v[b>>2]-12>>2]+b|0)+72>>2])}t[a|0]=1}return a|0}function IL(a,b,c){a=a|0;b=b|0;c=c|0;a=v[c+4>>2];v[b>>2]=v[c>>2];v[b+4>>2]=a;a=v[c+20>>2];v[b+16>>2]=v[c+16>>2];v[b+20>>2]=a;a=v[c+12>>2];v[b+8>>2]=v[c+8>>2];v[b+12>>2]=a}function HB(a){var b=0,c=0;a:{if(md(a,10076,3)){break a}b=a+3|0;if(w[b|0]<=7&w[b|0]!=1|w[b|0]>14){break a}a=a+40|0;if(!(w[a|0]<33?w[a|0]:0)&w[b|0]>8){break a}c=1}return c}function EX(a,b){a=a|0;b=b|0;v[a+4>>2]=b;t[a|0]=0;if(Jf(v[v[b>>2]-12>>2]+b|0)){if(v[(v[v[b>>2]-12>>2]+b|0)+72>>2]){gE(v[(v[v[b>>2]-12>>2]+b|0)+72>>2])}t[a|0]=1}return a|0}function E0(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=a;a=b+28|0;d=ro(d,a);HE(a,c);v[113382]=0;R(2276,b|0,1);a=v[113382];v[113382]=0;if((a|0)==1){a=P()|0;O()|0;Ob(d);S(a|0);L()}}function yA(a,b,c){var d=0;d=w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24);b=w[b+4|0]|w[b+5|0]<<8|(w[b+6|0]<<16|w[b+7|0]<<24);v[a>>2]=d;v[a+4>>2]=b;fm(a+8|0,c);return a}function vZ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;while(1){if((b|0)!=(c|0)){d=b;a=v[b>>2];if(a>>>0<=127){a=v[hr()+(v[b>>2]<<2)>>2]}v[d>>2]=a;b=b+4|0;continue}break}return c|0}function tZ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;while(1){if((b|0)!=(c|0)){d=b;a=v[b>>2];if(a>>>0<=127){a=v[gr()+(v[b>>2]<<2)>>2]}v[d>>2]=a;b=b+4|0;continue}break}return c|0}function ll(a){a=a<<8&16711680|a<<24|(a>>>8&65280|a>>>24);a=a>>>4&252645135|(a&252645135)<<4;a=a>>>2&858993459|(a&858993459)<<2;return a>>>1&1431655765|(a&1431655765)<<1}function Zx(a,b){var c=0;c=jb-16|0;jb=c;v[113382]=0;v[c+12>>2]=b;W(1399,a|0,c+12|0,c+8|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){jb=c+16|0;return a}V(0)|0;O()|0;Ab();L()}function RL(a,b){var c=0,d=0,e=0;c=Tb(a);a=Db(a);d=Tb(b);e=Db(b);a=a+c|0;b=-1;a:{while(1){if((a|0)==(c|0)){break a}a=a-1|0;if(Xn(d,e,a)){continue}break}b=a-c|0}return b}function Kia(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a:{d=Oi(a+8|0);v[113382]=0;U(429,a|0,b|0,c|0);a=v[113382];v[113382]=0;if((a|0)!=1){break a}a=P()|0;O()|0;Sg(d);S(a|0);L()}}function KL(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=jb-16|0;jb=d;if((b|0)!=(c|0)){while(1){v[d+12>>2]=v[b>>2];uy(a,d+12|0);b=b+4|0;if((c|0)!=(b|0)){continue}break}}jb=d+16|0}function zP(a,b){var c=0,d=0,e=0;d=jb-16|0;jb=d;c=d+8|0;sP(c,b);e=Hb(c);c=hd(a,$b(d,c));if((e|0)==(c|0)){Tc(a,Hb(d+8|0))}jb=d+16|0;a=(c|0)==(e|0);if(!a){tP(b)}return a}function vz(a,b){var c=0,d=0,e=0;d=jb-16|0;jb=d;c=d+8|0;VP(c,b);e=Hb(c);c=mc(a,$b(d,c));if((e|0)==(c|0)){_b(a,Hb(d+8|0))}jb=d+16|0;a=(c|0)==(e|0);if(!a){WP(b)}return a}function ve(a,b){var c=0;c=v[a>>2];v[a>>2]=b;a:{if(!c){break a}a=v[jc(a)>>2];v[113382]=0;Z(a|0,c|0);a=v[113382];v[113382]=0;if((a|0)!=1){break a}V(0)|0;O()|0;Ab();L()}}function vA(a,b){var c=0,d=0,e=0;d=jb-16|0;jb=d;c=d+8|0;Qt(c,b);e=Hb(c);c=mc(a,$b(d,c));if((e|0)==(c|0)){_b(a,Hb(d+8|0))}jb=d+16|0;a=(c|0)==(e|0);if(!a){IS(b)}return a}function v2(a,b){a=a|0;b=b|0;var c=0;c=-1;a:{if((b|0)<0){break a}a=a+24|0;if(rj(Vb(v[a>>2]+484360|0))>>>0<=b>>>0){break a}c=x[rc(Vb(v[a>>2]+484360|0),b)>>1]}return c|0}function nA(a,b){var c=0,d=0,e=0;d=jb-16|0;jb=d;c=d+8|0;lA(c,b);e=Hb(c);c=hd(a,$b(d,c));if((e|0)==(c|0)){Tc(a,Hb(d+8|0))}jb=d+16|0;a=(c|0)==(e|0);if(!a){zS(b)}return a}function iia(a,b){a=a|0;b=b|0;var c=0;a:{if(a>>>0>=515){a=Df(b);Df(b);break a}a=og(b);og(b)}if(a){while(1){if(a&1){_b(b,260)}c=a>>>0>1;a=a>>>1|0;if(c){continue}break}}}function hQ(a,b){var c=0,d=0,e=0;d=jb-16|0;jb=d;c=d+8|0;XP(c,b);e=Hb(c);c=hd(a,$b(d,c));if((e|0)==(c|0)){Tc(a,Hb(d+8|0))}jb=d+16|0;a=(c|0)==(e|0);if(!a){YP(b)}return a}function gA(a,b){var c=0,d=0,e=0;d=jb-16|0;jb=d;c=d+8|0;lS(c,b);e=Hb(c);c=mc(a,$b(d,c));if((e|0)==(c|0)){_b(a,Hb(d+8|0))}jb=d+16|0;a=(c|0)==(e|0);if(!a){mS(b)}return a}function ap(a){var b=0,c=0,d=0;b=jb-16|0;jb=b;a:{if(!(v[a+480208>>2]&16)){break a}c=b+8|0;Fb(c,a+1074312|0,7);if(!Cb(c)){break a}d=v[a+480180>>2]!=4}jb=b+16|0;return d}function XS(a,b){var c=0,d=0,e=0;d=jb-16|0;jb=d;c=d+8|0;Qt(c,b);e=Hb(c);c=hd(a,$b(d,c));if((e|0)==(c|0)){Tc(a,Hb(d+8|0))}jb=d+16|0;a=(c|0)==(e|0);if(!a){IS(b)}return a}function WQ(a,b){var c=0,d=0,e=0;d=jb-16|0;jb=d;c=d+8|0;LQ(c,b);e=Hb(c);c=mc(a,$b(d,c));if((e|0)==(c|0)){_b(a,Hb(d+8|0))}jb=d+16|0;a=(c|0)==(e|0);if(!a){MQ(b)}return a}function OG(a){var b=0,c=0;a:{if(w[a|0]!=255){break a}b=w[a+1|0];if((b&240)!=240&(b&254)!=226|!(b&6)){break a}a=w[a+2|0];if((a&240)==240){break a}c=(a&12)!=12}return c}function Naa(a,b){a=a|0;b=b|0;var c=0;c=jb-16|0;jb=c;v[113382]=0;a=Q(1393,a|0,b|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){jb=c+16|0;return a|0}a=P()|0;O()|0;S(a|0);L()}function MO(a,b){var c=0,d=0,e=0;d=jb-16|0;jb=d;c=d+8|0;lS(c,b);e=Hb(c);c=hd(a,$b(d,c));if((e|0)==(c|0)){Tc(a,Hb(d+8|0))}jb=d+16|0;a=(c|0)==(e|0);if(!a){mS(b)}return a}function Ij(a,b){var c=0,d=0,e=0;d=jb-16|0;jb=d;c=d+8|0;Uu(c,b);e=Hb(c);c=hd(a,$b(d,c));if((e|0)==(c|0)){Tc(a,Hb(d+8|0))}jb=d+16|0;a=(c|0)==(e|0);if(!a){KC(b)}return a}function Fv(a,b){var c=0;c=Sr(a+4|0);v[a>>2]=65100;v[c>>2]=65120;v[113382]=0;R(2798,c|0,b|0);a=v[113382];v[113382]=0;if((a|0)!=1){return}a=P()|0;O()|0;_g(c);S(a|0);L()}function Fr(a){var b=0,c=0;b=a;a:{if((xe(b)|0)!=79){break a}if((xe(b)|0)!=103){break a}if((xe(b)|0)!=103){break a}c=(xe(b)|0)==83}if(!c){cc(a,30);return 0}return CG(a)}function Ev(a,b){var c=0;c=XD(a+4|0);v[a>>2]=65148;v[c>>2]=65168;v[113382]=0;R(2799,c|0,b|0);a=v[113382];v[113382]=0;if((a|0)!=1){return}a=P()|0;O()|0;_g(c);S(a|0);L()}function DU(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=jb-16|0;jb=d;v[a>>2]=0;v[a+4>>2]=0;v[d+12>>2]=0;Uc(a+8|0,d+12|0,d+8|0);if(b){kq(a,b);dC(a,b,w[c|0])}jb=d+16|0;return a|0}function AC(a,b){var c=0,d=0,e=0;d=jb-16|0;jb=d;c=d+8|0;vq(c,b);e=Hb(c);c=hd(a,$b(d,c));if((e|0)==(c|0)){Tc(a,Hb(d+8|0))}jb=d+16|0;a=(c|0)==(e|0);if(!a){xC(b)}return a}function ui(a,b,c){var d=0;d=v[b+4>>2];v[a>>2]=v[b>>2];v[a+4>>2]=d;d=v[b+12>>2];v[a+8>>2]=v[b+8>>2];v[a+12>>2]=d;A[a>>3]=A[a>>3]-A[c>>3];A[a+8>>3]=A[a+8>>3]-A[c+8>>3]}function l9(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=jb-16|0;jb=c;d=c,e=ot(v[b>>2]),v[d+12>>2]=e;v[c+8>>2]=0;d=a,e=v[Ok(c+12|0,c+8|0,36120)>>2],v[d+36>>2]=e;Oo(a);jb=c+16|0}function ED(a,b,c,d){var e=0,f=0,g=0;f=v[a+4>>2];e=0;a:{if(!c){break a}g=f>>8;e=g;if(!(f&1)){break a}e=uv(v[c>>2],g)}a=v[a>>2];nb[v[v[a>>2]+28>>2]](a,b,c+e|0,f&2?d:2)}function E1(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;if((b|0)!=(c|0)){e=v[d>>2];while(1){Yz(a,e,b);e=v[d>>2]+12|0;v[d>>2]=e;b=b+12|0;if((c|0)!=(b|0)){continue}break}}}function q6(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;if(b){f=v[b+24>>2];g=v[b+8>>2];h=v[b+4>>2];i=v[b>>2];e=v[b+12>>2]}else{e=0}uI(a,i,h,g,e,f,b,c,d)}function mT(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=jb-16|0;jb=d;v[d+12>>2]=c;c=0;if(_f(a,d+8|0)){v[d+4>>2]=w[d+8|0];c=gT(a,b,v[Lb(d+4|0,d+12|0)>>2])}jb=d+16|0;return c|0}function j8(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=jb-16|0;jb=c;a=kj(a);if(a){a=(e=a,f=Yh(c+8|0,b),d=v[v[a>>2]+72>>2],nb[d](e|0,f|0)|0)}else{a=1}jb=c+16|0;return a|0}function aq(a,b){var c=0;c=jb-16|0;jb=c;jb=c+16|0;return(w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24))>>>0<(w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24))>>>0?b:a}function Yx(a){var b=0;b=jb-16|0;jb=b;v[113382]=0;v[b+12>>2]=0;W(1400,a|0,b+12|0,b+8|0)|0;a=v[113382];v[113382]=0;if((a|0)!=1){jb=b+16|0;return}V(0)|0;O()|0;Ab();L()}function XU(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=jb-16|0;jb=d;v[d+12>>2]=c;c=0;a=v[a+16>>2];if(a>>>0>b>>>0){v[d+8>>2]=a-b;c=v[Lb(d+12|0,d+8|0)>>2]}jb=d+16|0;return c|0}function QT(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=jb-16|0;jb=d;v[d+12>>2]=c;c=0;if(_f(a,d+8|0)){v[d+4>>2]=w[d+8|0];c=VA(a,b,v[Lb(d+4|0,d+12|0)>>2])}jb=d+16|0;return c|0}function PT(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=jb-16|0;jb=d;v[d+12>>2]=c;c=0;if(_f(a,d+8|0)){v[d+4>>2]=w[d+8|0];c=SA(a,b,v[Lb(d+4|0,d+12|0)>>2])}jb=d+16|0;return c|0}function OT(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=jb-16|0;jb=d;v[d+12>>2]=c;c=0;if(_f(a,d+8|0)){v[d+4>>2]=w[d+8|0];c=RA(a,b,v[Lb(d+4|0,d+12|0)>>2])}jb=d+16|0;return c|0}function Ho(a){var b=0;b=jb-16|0;jb=b;v[113382]=0;v[b+12>>2]=0;W(2143,a|0,b+12|0,b+8|0)|0;a=v[113382];v[113382]=0;if((a|0)!=1){jb=b+16|0;return}V(0)|0;O()|0;Ab();L()}function $ha(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;sz(a,b,c);a=v[a+16>>2];a:{if((a|0)==(b|0)){d=1;if(!c){break a}}d=0;if(a>>>0<=b>>>0){break a}d=a-b>>>0>=c>>>0}return d|0}function pV(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=jb-16|0;jb=d;v[d+12>>2]=c;c=0;a=v[a+8>>2];if(a>>>0>b>>>0){v[d+8>>2]=a-b;c=v[Lb(d+12|0,d+8|0)>>2]}jb=d+16|0;return c|0}function pP(a){if(!((w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24))!=541938512|(w[a+8|0]|w[a+9|0]<<8|(w[a+10|0]<<16|w[a+11|0]<<24))!=1162627398)){return 1}return 0}function nZ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;while(1){if((b|0)!=(c|0)){d=b;a=t[b|0];if((a|0)>=0){a=v[hr()+(t[b|0]<<2)>>2]}t[d|0]=a;b=b+1|0;continue}break}return c|0}function lZ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;while(1){if((b|0)!=(c|0)){d=b;a=t[b|0];if((a|0)>=0){a=v[gr()+(t[b|0]<<2)>>2]}t[d|0]=a;b=b+1|0;continue}break}return c|0}function iO(a){var b=0,c=0;a:{if(w[a|0]!=255){break a}b=w[a+1|0];if((b&224)!=224|(b&24)==8|!(b&6)){break a}a=w[a+2|0];if((a&12)==12){break a}c=(a&240)!=240}return c}function V7(a,b){a=a|0;b=b|0;var c=0,d=0;d=jb-16|0;jb=d;v[d+12>>2]=0;c=d+12|0;t[c|0]=b;t[c+1|0]=b>>>8;t[c+2|0]=b>>>16;t[c+3|0]=b>>>24;a=dJ(a,c);jb=d+16|0;return a|0}function T0(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=jb-16|0;jb=e;a=zr(Ha(v[a+60>>2],b|0,c|0,d&255,e+8|0)|0);jb=e+16|0;mb=a?-1:v[e+12>>2];return(a?-1:v[e+8>>2])|0}function Ht(a){var b=0,c=0;b=jb-16|0;jb=b;c=b+8|0;$c(c,a,0);v[113382]=0;U(632,c|0,110,0);a=v[113382];v[113382]=0;if((a|0)!=1){jb=b+16|0;return}V(0)|0;O()|0;Ab();L()}function uF(a,b){var c=0,d=0,e=0,f=0;c=v[a+24>>2];if((c|0)==v[a+28>>2]){return e=a,f=Hg(b),d=v[v[a>>2]+52>>2],nb[d](e|0,f|0)|0}v[a+24>>2]=c+1;t[c|0]=b;return Hg(b)}function m_(){var a=0,b=0;a:{Gd(455088);v[113772]=59568;v[113382]=0;a=da(2335)|0;b=v[113382];v[113382]=0;if((b|0)!=1){v[113774]=a;break a}a=P()|0;O()|0;S(a|0);L()}}function Zda(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;a=a+108|0;c=a+128|0;if((a|0)!=(c|0)){while(1){d=a,e=Up(w[a|0]+b|0),t[d|0]=e;a=a+1|0;if((c|0)!=(a|0)){continue}break}}}function Pe(a){a=a|0;var b=0;a=a?a:1;a:{while(1){b=kd(a);if(b){break a}b=v[114678];if(b){nb[b|0]();continue}break}a=ba(4)|0;Zk(a);ha(a|0,66740,1977);L()}return b|0}function vL(a){v[a>>2]=0;v[a+4>>2]=0;v[a+88>>2]=0;v[a+8>>2]=0;v[a+12>>2]=0;TM(a+112|0,48e3);v[a+668>>2]=0;Wx(a+724|0);Wx(a+736|0);Wx(a+748|0);Oh(a+810|0);return a}function mc(a,b){var c=0,d=0,e=0,f=0,g=0,h=0;c=jb-16|0;jb=c;d=v[a>>2];a=(f=d,g=v[a+8>>2],h=$b(c+8|0,b),e=v[v[d>>2]+32>>2],nb[e](f|0,g|0,h|0)|0);jb=c+16|0;return a}function ev(a,b){var c=0,d=0,e=0;c=jb-16|0;jb=c;v[c>>2]=v[b>>2];d=c,e=v[b>>2]+EC(b)|0,v[d+4>>2]=e;b=jb-16|0;jb=b;Oq(a,v[c>>2],v[c>>2]+EC(c)|0);jb=b+16|0;jb=c+16|0}function _b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=Rb(a,b);if(c){v[a+8>>2]=v[a+8>>2]+b;return c|0}b=a;a=v[a>>2];d=b,e=nb[v[v[a>>2]+24>>2]](a)|0,v[d+8>>2]=e;return c|0}function ZO(a,b){var c=0,d=0,e=0;c=bP(a,zb(b));v[a>>2]=v[b>>2];v[a+4>>2]=v[b+4>>2];a=v[zb(b)>>2];d=zb(c),e=a,v[d>>2]=e;d=zb(b),e=0,v[d>>2]=e;v[b>>2]=0;v[b+4>>2]=0}function Pr(a,b){a=a|0;b=b|0;v[a+20>>2]=0;v[a+24>>2]=b;v[a+12>>2]=0;v[a+4>>2]=4098;v[a+8>>2]=6;v[a+16>>2]=!b;Qb(a+32|0,0,40);Rv(a+28|0);v[a+72>>2]=0;v[a+76>>2]=-1}function Lba(a){a=C(a);var b=0;a=de(a);b=65535;a:{if(!(a<C(65535))){break a}b=0;if(!(a>C(0))){break a}b=~~a>>>0;if(a<C(4294967296)&a>=C(0)){break a}b=0}return b|0}function Cba(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=en(a);v[113382]=0;U(91,a|0,b|0,c|0);b=v[113382];v[113382]=0;if((b|0)!=1){return a|0}a=P()|0;O()|0;ze(d);S(a|0);L()}function yW(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=jb-16|0;jb=d;v[d+12>>2]=v[c>>2];a=nb[v[v[a>>2]+16>>2]](a,b,d+12|0)|0;if(a){v[c>>2]=v[d+12>>2]}jb=d+16|0;return a|0}function up(a){v[a+8>>2]=0;v[a+12>>2]=0;v[a>>2]=128;v[a+4>>2]=256;v[a+32>>2]=363;v[a+36>>2]=952;v[a+16>>2]=48e3;v[a+20>>2]=2;v[a+24>>2]=128;v[a+28>>2]=0;return a}function SW(a,b){a=a|0;b=b|0;Pm(a);v[a>>2]=66780;b=Tb(b);v[113382]=0;Q(2831,a+4|0,b|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){return a|0}a=P()|0;O()|0;S(a|0);L()}function Mr(a,b,c,d){var e=0;a:{if(d==C(1)){break a}c=B(b,c);if(!c){break a}e=+d;b=0;while(1){A[a>>3]=A[a>>3]*e;a=a+8|0;b=b+1|0;if((c|0)!=(b|0)){continue}break}}}function sf(a){var b=0,c=0;b=jb-16|0;jb=b;v[113382]=0;W(114,a|0,b+8|0,b|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){Om(a);jb=b+16|0;return a}V(0)|0;O()|0;Ab();L()}function mr(a){a=a|0;var b=0;b=ba(8)|0;v[113382]=0;Q(2031,b|0,a|0)|0;a=v[113382];v[113382]=0;if((a|0)!=1){ha(b|0,67068,235);L()}a=P()|0;O()|0;ca(b|0);S(a|0);L()}function Yha(a,b){a=a|0;b=b|0;var c=0,d=0;d=jb-80|0;jb=d;c=-1;a:{if(!XS(a,d+8|0)){break a}c=0;if(!GP(d+8|0)){break a}c=gf(a,b,FP(d+8|0),mb)}jb=d+80|0;return c|0}function wt(a){var b=0,c=0;c=a;a=v[a>>2];b=v[a+4>>2];a:{if(!b){if(!Ag(a)){while(1){a=v[a+8>>2];if(!Ag(a)){continue}break}}a=v[a+8>>2];break a}a=FQ(b)}v[c>>2]=a}function s0(a,b,c){a=a|0;b=b|0;c=c|0;b=c;a:{if((c|0)>=257){bG();c=79880;break a}b:{if(t[453540]&1){break b}if(!vd(453540)){break b}ud(453540)}c=79876}$c(a,b,c)}function gJ(a,b){var c=0;c=jb-16|0;jb=c;v[c+12>>2]=b;v[c+8>>2]=127;b=Lb(c+12|0,c+8|0);z[v[a+20>>2]+144>>2]=C(C(y[b>>2])*C(-.007874015718698502))+C(1);jb=c+16|0}function Xb(a){var b=0,c=0;b=jb-16|0;jb=b;v[113382]=0;W(14,a|0,b+8|0,b|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){Om(a);jb=b+16|0;return a}V(0)|0;O()|0;Ab();L()}function Ln(a,b,c){a=a|0;b=b|0;c=c|0;t[a+11|0]=c;t[a+10|0]=b;t[a+12|0]=w[a+12|0]&251;u[a+8>>1]=65535;v[a>>2]=0;v[a+4>>2]=0;t[a+12|0]=w[a+12|0]&252|1;return a|0}function Ld(a,b,c){var d=0;d=jb-16|0;jb=d;v[d+12>>2]=b;v[113382]=0;vo(a,d+12|0,c);b=v[113382];v[113382]=0;if((b|0)!=1){jb=d+16|0;return a}V(0)|0;O()|0;Ab();L()}function Hka(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=jb-16|0;jb=c;d=Rb(a,12);a:{if(d){e=c+8|0;lA(e,b);zd(a,e);break a}t[c+7|0]=0;Qh(b,12,c+7|0)}jb=c+16|0;return d|0}function ww(a,b){var c=0;c=jb-16|0;jb=c;v[113382]=0;W(160,a|0,c+8|0,b|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){Om(a);jb=c+16|0;return a}V(0)|0;O()|0;Ab();L()}function vC(a,b){var c=0,d=0;c=jb-16|0;jb=c;a:{if(he(a)){d=v[a>>2];t[c+15|0]=0;Rd(b+d|0,c+15|0);ae(a,b);break a}t[c+14|0]=0;Rd(a+b|0,c+14|0);Ce(a,b)}jb=c+16|0}function q2(a,b,c){a=a|0;b=b|0;c=c|0;a:{b=zf(a,b);v[113382]=0;Q(120,a+12|0,c|0)|0;a=v[113382];v[113382]=0;if((a|0)!=1){break a}a=P()|0;O()|0;yb(b);S(a|0);L()}}function pO(a,b){var c=0;c=v[a+4>>2];a:{if((b|0)>=0){b=b+c|0;v[a>>2]=v[a>>2]+(b>>>3&536870908);break a}b=b+c|0;v[a>>2]=v[a>>2]+((b-31|0)/32<<2)}v[a+4>>2]=b&31}function bd(a){var b=0,c=0;b=jb-16|0;jb=b;v[113382]=0;W(1,a|0,b+8|0,b|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){Om(a);jb=b+16|0;return a}V(0)|0;O()|0;Ab();L()}function _F(a,b){var c=0;c=jb-16|0;jb=c;v[113382]=0;W(167,a|0,c+8|0,b|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){Om(a);jb=c+16|0;return a}V(0)|0;O()|0;Ab();L()}function c0(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=0;while(1){if((b|0)!=(c|0)){a=v[b>>2]+(a<<4)|0;d=a&-268435456;a=(d|d>>>24)^a;b=b+4|0;continue}break}return a|0}function DI(a){a=a|0;var b=0;v[a+4240>>2]=0;v[a+4244>>2]=0;b=a+4264|0;v[b>>2]=0;v[b+4>>2]=0;b=a+4256|0;v[b>>2]=0;v[b+4>>2]=0;a=a+4248|0;v[a>>2]=0;v[a+4>>2]=0}function Cla(a,b){a=a|0;b=b|0;t[b|0]=0;t[b+1|0]=0;t[b+2|0]=0;t[b+3|0]=0;t[b+4|0]=0;t[b+5|0]=0;t[b+4|0]=6;t[b+5|0]=0;t[b|0]=0;t[b+1|0]=0;t[b+2|0]=8;t[b+3|0]=4}function t8(a,b){a=a|0;b=b|0;var c=0;tJ(a);c=b+4|0;nh(zb(a),v[a>>2],v[a+4>>2],c);dc(a,c);dc(a+4|0,b+8|0);dc(zb(a),gc(b));v[b>>2]=v[b+4>>2];of(a);jk(a);jk(a)}function kg(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0;d=v[a>>2];return(f=d,g=Eb(b),h=v[a+8>>2],i=c,e=v[v[d>>2]+28>>2],nb[e](f|0,g|0,h|0,i|0)|0)|0}function fd(a,b){var c=0,d=0;c=jb-16|0;jb=c;a:{if(!b){break a}if(!Rb(a,b)){break a}t[c+15|0]=0;_f(a,c+15|0);t[c+8|0]=w[c+15|0];d=w[c+8|0]}jb=c+16|0;return d}function f0(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=0;while(1){if((b|0)!=(c|0)){a=t[b|0]+(a<<4)|0;d=a&-268435456;a=(d|d>>>24)^a;b=b+1|0;continue}break}return a|0}function W_(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0;g=a;a=nb[v[v[a+8>>2]+20>>2]](a+8|0)|0;return dj(g,b,c,d,e,f,Tb(a),Tb(a)+(Db(a)<<2)|0)|0}function VB(a,b){var c=0,d=0;c=jb-16|0;jb=c;a:{if(!b){break a}if(!Rb(a,b)){break a}t[c+15|0]=0;_f(a,c+15|0);t[c+8|0]=w[c+15|0];d=t[c+8|0]}jb=c+16|0;return d}function XC(a){var b=0;b=jb-16|0;jb=b;t[a|0]=0;t[a+1|0]=0;t[a+2|0]=0;t[a+3|0]=0;t[a+4|0]=0;t[a+5|0]=0;t[a+6|0]=0;t[a+7|0]=0;t[a+8|0]=0;t[a+9|0]=0;jb=b+16|0}function Ty(a,b,c,d,e){var f=0;if(d){while(1){z[b>>2]=C(v[a>>2])*e;z[c>>2]=C(v[a+4>>2])*e;c=c+4|0;a=a+8|0;b=b+4|0;f=f+1|0;if((f|0)!=(d|0)){continue}break}}}function Hu(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=jb-16|0;jb=d;t[d+15|0]=b;t[d+14|0]=127;e=a,f=w[pc(d+15|0,d+14|0)|0]|(c?-128:0),t[e+21|0]=f;jb=d+16|0}function Gu(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=jb-16|0;jb=d;t[d+15|0]=b;t[d+14|0]=127;e=a,f=w[pc(d+15|0,d+14|0)|0]|(c?-128:0),t[e+22|0]=f;jb=d+16|0}function xM(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a:{if(d>>>0>=64){d=-1;if(v[a+480180>>2]&2){break a}}v[b+56>>2]=0;d=hp(a,x[b+60>>1],v[b+48>>2],c,0)}return d|0}function uk(a,b){var c=0,d=0;a:{b=vk(a,b);if((b|0)==255){break a}if(qj(a)){break a}c=a+4|0;d=ec(c,b);t[d|0]=w[d|0]&223;jh(v[a>>2],Ss(b)|176,w[ec(c,b)|0])}}function u2(a,b){a=a|0;b=b|0;var c=0;a:{if(!Qr(b)){break a}a=a+24|0;if(!jg(v[a>>2]+484344|0,b&65535)){break a}c=v[Zb(v[a>>2]+484344|0,b)+12>>2]}return c|0}function pja(a,b){a=a|0;b=b|0;var c=0;a=ZQ(a,b);if(!a){c=jb-16|0;jb=c;t[b|0]=0;t[b+1|0]=0;t[b+2|0]=0;t[b+3|0]=0;t[b+4|0]=0;t[b+5|0]=0;jb=c+16|0}return a|0}function cQ(a,b){var c=0,d=0,e=0;d=jb-16|0;jb=d;c=d+8|0;XP(c,b);e=Hb(c);c=mc(a,$b(d,c));if((e|0)==(c|0)){_b(a,Hb(d+8|0))}jb=d+16|0;if((c|0)!=(e|0)){YP(b)}}function _Y(a){a=a|0;var b=0;a=v[a+8>>2];if(!a){return 1}v[113382]=0;a=T(2455,a|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){return a|0}V(0)|0;O()|0;Ab();L()}function YU(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=v[a+16>>2];a:{if((a|0)==(b|0)){d=1;if(!c){break a}}d=0;if(a>>>0<=b>>>0){break a}d=a-b>>>0>=c>>>0}return d|0}function K$(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=jb-16|0;jb=e;v[e+12>>2]=b;v[e+8>>2]=d;b=Bh(e,e+12|0);a=RF(a,c,v[e+8>>2]);Ge(b);jb=e+16|0;return a|0}function Eh(a){var b=0,c=0;b=a*a;c=b*a;return C(c*(b*b)*(b*2718311493989822e-21+-.00019839334836096632)+(c*(b*.008333329385889463+-.16666666641626524)+a))}function Ai(a){var b=0;a=de(a);b=-1;a:{if(!(a<C(4294967296))){break a}b=0;if(!(a>C(0))){break a}b=~~a>>>0;if(a<C(4294967296)&a>=C(0)){break a}b=0}return b}function wl(a){var b=0,c=0,d=0;b=jb-16|0;jb=b;c=v[a+1074400>>2];d=v[a+1074416>>2];v[b+12>>2]=1;a=v[Vc(a+1074396|0,b+12|0)>>2];jb=b+16|0;return B(a,c+d|0)}function w7(a,b,c){a=a|0;b=b|0;c=C(c);var d=0;d=jb-16|0;jb=d;z[d+12>>2]=c;if((b|0)<=5){Wd(d+12|0,C(0));z[((b<<2)+a|0)+4208>>2]=z[d+12>>2];WI(a)}jb=d+16|0}function v6(a,b,c){a=a|0;b=b|0;c=C(c);var d=0;d=jb-16|0;jb=d;z[d+12>>2]=c;if((b|0)<=3){Wd(d+12|0,C(0));z[((b<<2)+a|0)+4208>>2]=z[d+12>>2];CI(a)}jb=d+16|0}function qV(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=v[a+8>>2];a:{if((a|0)==(b|0)){d=1;if(!c){break a}}d=0;if(a>>>0<=b>>>0){break a}d=a-b>>>0>=c>>>0}return d|0}function o7(a,b,c){a=a|0;b=b|0;c=C(c);var d=0;d=jb-16|0;jb=d;z[d+12>>2]=c;if((b|0)<=4){Wd(d+12|0,C(0));z[((b<<2)+a|0)+4208>>2]=z[d+12>>2];RI(a)}jb=d+16|0}function c8(a){a=a|0;var b=0,c=0;b=jb-16|0;jb=b;c=b+8|0;nJ(c,a,0);if(rh(c)){a=v[a+20>>2];v[a+148>>2]=-1;c=a+4|0;a=b+8|0;$K(c,v[a>>2],v[a+4>>2])}jb=b+16|0}function Xo(a,b){var c=0;v[a>>2]=72064;v[a>>2]=72188;c=v[b+8>>2];v[a+4>>2]=v[b+4>>2];v[a+8>>2]=c;c=v[b+16>>2];v[a+12>>2]=v[b+12>>2];v[a+16>>2]=c;return a}function Pf(a,b,c){a:{switch(b-1|0){case 0:if(c){return xi(a,1)}return xi(a,0);case 1:if(c){return xi(a,3)}return xi(a,2);default:break a}}return xi(a,4)}function Lr(a){var b=0,c=0,d=0;b=uma(v[a>>2],1)^270549120;c=v[a+4>>2];d=(b+(c<<2)|0)+2019860093|0;v[a>>2]=d;b=a;a=B(uma(d,16),5)+c|0;v[b+4>>2]=a;return a}function ID(a,b){a=a|0;b=b|0;Pm(a);v[a>>2]=66780;v[113382]=0;Q(2831,a+4|0,b|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){return a|0}a=P()|0;O()|0;S(a|0);L()}function Hw(a,b){var c=0;while(1){c=(b|0)<120?b:120;a=C(C(z[((c&3)<<2)+40624>>2]*a)*C(1073741824>>>(c>>2)|0));b=b-c|0;if((b|0)>0){continue}break}return a}function C6(a,b,c){a=a|0;b=b|0;c=C(c);var d=0;d=jb-16|0;jb=d;z[d+12>>2]=c;if((b|0)<=2){Wd(d+12|0,C(0));z[((b<<2)+a|0)+4208>>2]=z[d+12>>2];EI(a)}jb=d+16|0}function zp(a,b,c){var d=0;d=b;b=w[a|0]|w[a+1|0]<<8;if((d|0)<=((b<<8|b>>>8)&65535)){a=w[a|0]|w[a+1|0]<<8;a=((a<<8|a>>>8)&65535)<=(c|0)}else{a=0}return a}function tm(a,b){var c=0;c=v[v[b>>2]-12>>2];v[113382]=0;b=v[(b+c|0)+24>>2];c=v[113382];v[113382]=0;if((c|0)!=1){v[a>>2]=b;return a}V(0)|0;O()|0;Ab();L()}function tG(a){var b=0,c=0,d=0;if(eh(t[v[a>>2]])){while(1){b=v[a>>2];d=t[b|0];v[a>>2]=b+1;c=(B(c,10)+d|0)-48|0;if(eh(t[b+1|0])){continue}break}}return c}function Hm(a,b){var c=0,d=0;b=b+7&-8;d=v[a+80>>2];a:{if(d){b=v[a+92>>2]-b|0;c=0;if((b|0)<v[a+88>>2]){break a}v[a+92>>2]=b;return b+d|0}c=kd(b)}return c}function rE(a){var b=0,c=0;b=a;c=v[a+4>>2];while(1){if(v[b+8>>2]!=(c|0)){v[b+8>>2]=v[b+8>>2]-4;continue}break}if(v[a>>2]){tE(v[a+16>>2],v[a>>2],yg(a))}}function qZ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;while(1){if((b|0)!=(c|0)){a=v[b>>2];t[e|0]=a>>>0<128?a:d;e=e+1|0;b=b+4|0;continue}break}return c|0}function mba(a,b){a=a|0;b=b|0;var c=0;gm(a);c=b+4|0;nh(zb(a),v[a>>2],v[a+4>>2],c);dc(a,c);dc(a+4|0,b+8|0);dc(zb(a),gc(b));v[b>>2]=v[b+4>>2];Bq(a,ue(a))}function jX(a,b){a=a|0;b=b|0;var c=0,d=0;b=Hv(b);v[a+36>>2]=b;c=a,d=Xm(b),v[c+44>>2]=d;c=a,d=rm(v[a+36>>2]),t[c+53|0]=d;if(v[a+44>>2]>=9){mr(2049);L()}}function fe(a){var b=0;b=ba(8)|0;v[113382]=0;Q(23,b|0,a|0)|0;a=v[113382];v[113382]=0;if((a|0)!=1){ha(b|0,66948,24);L()}a=P()|0;O()|0;ca(b|0);S(a|0);L()}function fX(a,b){a=a|0;b=b|0;var c=0,d=0;b=Dv(b);v[a+36>>2]=b;c=a,d=Xm(b),v[c+44>>2]=d;c=a,d=rm(v[a+36>>2]),t[c+53|0]=d;if(v[a+44>>2]>=9){mr(2049);L()}}function eN(a){var b=0,c=0,d=0;b=a+26|0;c=w[b|0]+27|0;if(w[b|0]){while(1){c=w[(a+d|0)+27|0]+c|0;d=d+1|0;if(d>>>0<w[b|0]){continue}break}}return c&65535}function a$(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0;g=a;a=nb[v[v[a+8>>2]+20>>2]](a+8|0)|0;return ej(g,b,c,d,e,f,Tb(a),Tb(a)+Db(a)|0)|0}function Zi(a,b,c,d){var e=0,f=0;e=B(b,c);f=e;a:{if(v[d+76>>2]<0){a=ov(a,e,d);break a}a=ov(a,e,d)}if((f|0)==(a|0)){return b?c:0}return(a>>>0)/(b>>>0)|0}function Zha(a,b){a=a|0;b=b|0;var c=0;Eq(a);c=b+4|0;nh(zb(a),v[a>>2],v[a+4>>2],c);dc(a,c);dc(a+4|0,b+8|0);dc(zb(a),gc(b));v[b>>2]=v[b+4>>2];Xu(a,Ig(a))}function Yi(a){var b=0;b=ba(8)|0;v[113382]=0;Q(184,b|0,a|0)|0;a=v[113382];v[113382]=0;if((a|0)!=1){ha(b|0,67e3,24);L()}a=P()|0;O()|0;ca(b|0);S(a|0);L()}function Wja(a,b){a=a|0;b=b|0;var c=0;Rt(a);c=b+4|0;oR(zb(a),v[a>>2],v[a+4>>2],c);dc(a,c);dc(a+4|0,b+8|0);dc(zb(a),gc(b));v[b>>2]=v[b+4>>2];pA(a,hg(a))}function PZ(){var a=0;a:{Gd(455304);v[113382]=0;T(2440,455312)|0;a=v[113382];v[113382]=0;if((a|0)!=1){v[113826]=62272;break a}a=P()|0;O()|0;S(a|0);L()}}function Nc(a,b){a=a|0;b=b|0;var c=0,d=0;a:{if(y[a+8>>2]<b>>>0){d=v[a>>2];c=0;if(nb[v[v[d>>2]+24>>2]](d)>>>0<b>>>0){break a}}v[a+8>>2]=b;c=1}return c|0}function NZ(){var a=0;a:{Gd(455320);v[113382]=0;T(2440,455328)|0;a=v[113382];v[113382]=0;if((a|0)!=1){v[113830]=62428;break a}a=P()|0;O()|0;S(a|0);L()}}function wu(a,b){a=a|0;b=b|0;var c=0;Gj(a);c=b+4|0;nh(zb(a),v[a>>2],v[a+4>>2],c);dc(a,c);dc(a+4|0,b+8|0);dc(zb(a),gc(b));v[b>>2]=v[b+4>>2];pq(a,oc(a))}function ud(a){var b=0,c=0,d=0,e=0;b=jb-16|0;jb=b;a=Av(b,a);c=jb-16|0;jb=c;d=v[Oc(c+8|0,v[a+4>>2])>>2],e=1,t[d|0]=e;t[v[a+8>>2]]=1;jb=c+16|0;jb=b+16|0}function o2(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;h=jb-32|0;jb=h;i=h+8|0;HH(i,b,c,d,e,f,g);rd(a,h+20|0);Cl(i);jb=h+32|0}function hh(a,b){a=a|0;b=b|0;var c=0;Ve(a);c=b+4|0;nh(zb(a),v[a>>2],v[a+4>>2],c);dc(a,c);dc(a+4|0,b+8|0);dc(zb(a),gc(b));v[b>>2]=v[b+4>>2];lk(a,Kb(a))}function fu(a,b){a=a|0;b=b|0;var c=0;Pl(a);c=b+4|0;nh(zb(a),v[a>>2],v[a+4>>2],c);dc(a,c);dc(a+4|0,b+8|0);dc(zb(a),gc(b));v[b>>2]=v[b+4>>2];rA(a,wc(a))}function cW(a,b){a=a|0;b=b|0;var c=0;Wk(a);c=b+4|0;nh(zb(a),v[a>>2],v[a+4>>2],c);dc(a,c);dc(a+4|0,b+8|0);dc(zb(a),gc(b));v[b>>2]=v[b+4>>2];ho(a,jd(a))}function bY(a,b){a=a|0;b=b|0;var c=0;Ve(a);c=b+4|0;nh(bl(a),v[a>>2],v[a+4>>2],c);dc(a,c);dc(a+4|0,b+8|0);dc(zb(a),gc(b));v[b>>2]=v[b+4>>2];lk(a,Kb(a))}function Fh(a,b,c){v[b+12>>2]=v[b+12>>2]+c;v[b+8>>2]=v[b+8>>2]-c;c=v[b+4>>2];v[a>>2]=v[b>>2];v[a+4>>2]=c;c=v[b+12>>2];v[a+8>>2]=v[b+8>>2];v[a+12>>2]=c}function mL(a){if(v[a+480224>>2]==2){return+y[a+1074420>>2]*1e-4}return+y[a+24620>>2]*60/(+y[a+1074404>>2]*+(B(v[a+1074408>>2],v[a+1074416>>2])>>>0))}function kq(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if(YB(a)>>>0<b>>>0){ld();L()}b=(b-1>>>5|0)+1|0;c=Po(zb(a),b);v[a+4>>2]=0;v[a>>2]=c;d=zb(a),e=b,v[d>>2]=e}function iZ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;while(1){if((b|0)!=(c|0)){a=t[b|0];t[e|0]=(a|0)>=0?a:d;e=e+1|0;b=b+1|0;continue}break}return c|0}function hd(a,b){var c=0,d=0,e=0,f=0,g=0;c=jb-16|0;jb=c;a=(e=a,f=v[a+12>>2],g=$b(c+8|0,b),d=v[v[a>>2]+32>>2],nb[d](e|0,f|0,g|0)|0);jb=c+16|0;return a}function b2(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;if(c){e=d<<2;a=0;while(1){if(d){Qb(v[(a<<2)+b>>2],0,e)}a=a+1|0;if((c|0)!=(a|0)){continue}break}}}function a2(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;if(c){e=d<<3;a=0;while(1){if(d){Qb(v[(a<<2)+b>>2],0,e)}a=a+1|0;if((c|0)!=(a|0)){continue}break}}}function Y2(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if(_E(a)>>>0<b>>>0){ld();L()}c=XE(zb(a),b);v[a>>2]=c;v[a+4>>2]=c;d=zb(a),e=B(b,12)+c|0,v[d>>2]=e;to(a,0)}function Tk(a,b){var c=0;c=v[v[b>>2]-12>>2];v[113382]=0;b=T(27,b+c|0)|0;c=v[113382];v[113382]=0;if((c|0)!=1){v[a>>2]=b;return a}V(0)|0;O()|0;Ab();L()}function TW(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=cf(b);d=Pe(c+13|0);v[d+8>>2]=0;v[d+4>>2]=c;v[d>>2]=c;e=a,f=lc(d+12|0,b,c+1|0),v[e>>2]=f;return a|0}function yV(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if(Yu(a)>>>0<b>>>0){ld();L()}c=MC(zb(a),b);v[a>>2]=c;v[a+4>>2]=c;d=zb(a),e=(b<<3)+c|0,v[d>>2]=e;Xu(a,0)}function tga(a,b){a=a|0;b=b|0;var c=0,d=0;d=jb-48|0;jb=d;c=-1;a:{if(!MO(a,d)){break a}c=0;if(!yO(d)){break a}c=gf(a,b,xO(d),mb)}jb=d+48|0;return c|0}function sQ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if(ns(a)>>>0<b>>>0){ld();L()}c=tR(zb(a),b);v[a>>2]=c;v[a+4>>2]=c;d=zb(a),e=(b<<2)+c|0,v[d>>2]=e;lk(a,0)}function qu(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if(ns(a)>>>0<b>>>0){ld();L()}c=Po(zb(a),b);v[a>>2]=c;v[a+4>>2]=c;d=zb(a),e=(b<<2)+c|0,v[d>>2]=e;lk(a,0)}function qA(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if(KS(a)>>>0<b>>>0){ld();L()}c=JS(zb(a),b);v[a>>2]=c;v[a+4>>2]=c;d=zb(a),e=B(b,6)+c|0,v[d>>2]=e;pA(a,0)}function mz(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if(jC(a)>>>0<b>>>0){ld();L()}c=iC(zb(a),b);v[a>>2]=c;v[a+4>>2]=c;d=zb(a),e=(b<<1)+c|0,v[d>>2]=e;pq(a,0)}function Zga(a,b){a=a|0;b=b|0;var c=0,d=0;d=jb-96|0;jb=d;c=-1;a:{if(!zP(a,d)){break a}c=0;if(!SO(d)){break a}c=gf(a,b,RO(d),mb)}jb=d+96|0;return c|0}function Sga(a,b){a=a|0;b=b|0;var c=0,d=0;d=jb-48|0;jb=d;c=-1;a:{if(!MO(a,d)){break a}c=0;if(!KO(d)){break a}c=gf(a,b,JO(d),mb)}jb=d+48|0;return c|0}function PL(a){var b=0;a=de(a);b=255;a:{if(!(a<C(255))){break a}b=0;if(!(a>C(0))){break a}b=~~a>>>0;if(a<C(4294967296)&a>=C(0)){break a}b=0}return b}function Nha(a,b){a=a|0;b=b|0;var c=0,d=0;d=jb-96|0;jb=d;c=-1;a:{if(!zP(a,d)){break a}c=0;if(!yP(d)){break a}c=gf(a,b,xP(d),mb)}jb=d+96|0;return c|0}function Km(a,b,c){var d=0;d=v[b+4>>2];v[b+8>>2]=v[b+8>>2]-c;v[b>>2]=v[b>>2]+(B(c,d)<<1);c=v[b+4>>2];v[a>>2]=v[b>>2];v[a+4>>2]=c;v[a+8>>2]=v[b+8>>2]}function Iba(a){a=+a;var b=0;a=Md(a);b=65535;a:{if(!(a<65535)){break a}b=0;if(!(a>0)){break a}b=~~a>>>0;if(a<4294967296&a>=0){break a}b=0}return b|0}function IZ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if(vE(a)>>>0<b>>>0){ld();L()}c=uE(bl(a),b);v[a>>2]=c;v[a+4>>2]=c;d=zb(a),e=(b<<2)+c|0,v[d>>2]=e;lk(a,0)}function Fo(a,b,c){var d=0;d=v[b+4>>2];v[b+8>>2]=v[b+8>>2]-c;v[b>>2]=v[b>>2]+(B(c,d)<<2);c=v[b+4>>2];v[a>>2]=v[b>>2];v[a+4>>2]=c;v[a+8>>2]=v[b+8>>2]}function Ee(a){var b=0,c=0;b=jb-16|0;jb=b;a:{if(he(a)){c=v[a>>2];t[b+15|0]=0;Rd(c,b+15|0);ae(a,0);break a}t[b+14|0]=0;Rd(a,b+14|0);Ce(a,0)}jb=b+16|0}function BB(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if(nv(a)>>>0<b>>>0){ld();L()}c=Lq(zb(a),b);v[a>>2]=c;v[a+4>>2]=c;d=zb(a),e=(b<<4)+c|0,v[d>>2]=e;ho(a,0)}function Rv(a){var b=0,c=0;v[113382]=0;c=da(2445)|0;b=v[113382];v[113382]=0;if((b|0)!=1){b=a;a=v[c>>2];v[b>>2]=a;km(a);return}V(0)|0;O()|0;Ab();L()}function AW(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;if(rg(a,v[b+8>>2],f)){sv(b,c,d,e);return}a=v[a+8>>2];nb[v[v[a>>2]+20>>2]](a,b,c,d,e,f)}function sma(a,b,c){var d=0;d=b>>31;a=a^d;oma(a-d|0,(b^d)-((a>>>0<d>>>0)+d|0)|0,c,0);mb=lb;a=d^kb;b=a-d|0;mb=(d^mb)-((a>>>0<d>>>0)+d|0)|0;return b}function rw(a,b){var c=0,d=0;c=b&1?a:1;if(b+1>>>0>=3){d=b;while(1){a=a*a;d=(d|0)/2|0;c=d&1?a*c:c;if(d+1>>>0>2){continue}break}}return(b|0)<0?1/c:c}function haa(a,b){a=a|0;b=b|0;var c=0;if(!(w[b+14|0]&48|w[b+17|0]!=173)){Yc(a,8,1,0,11);return}c=a;a=b+14|0;Yc(c,w[a|0]&16?16:8,w[a|0]&32?3:1,0,2)}function d2(a,b){a=a|0;b=b|0;var c=0,d=0;c=jb-32|0;jb=c;d=v[b+4>>2];v[c+8>>2]=v[b>>2];v[c+12>>2]=d;Ks(a,v[c+8>>2],v[c+12>>2]);jb=c+32|0;return a|0}function _P(a){return(w[a+8|0]|w[a+9|0]<<8|(w[a+10|0]<<16|w[a+11|0]<<24))==1279545165&(w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24))==1297239878}function Tga(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=jb-16|0;jb=c;d=jb-16|0;jb=d;e=d+8|0;nq(e,a);lq(c,e);jb=d+16|0;a=uf(c,b);yb(c);jb=c+16|0;return a|0}function No(a,b){var c=0,d=0,e=0,f=0;c=jb-16|0;jb=c;e=c+8|0;xh(e,b);d=jb-16|0;jb=d;f=d+8|0;KJ(f,$b(d,e));_R(a,f);jb=d+16|0;xh(c,b);Hb(c);jb=c+16|0}function Iy(a,b,c){var d=0,e=0,f=0;d=vk(a,b);if((d|0)!=255){e=_c(a+22|0,d),f=c,u[e>>1]=f;a=a+58|0;e=ec(a,b),f=255,t[e|0]=f;e=ec(a,c),f=d,t[e|0]=f}}function G0(a,b){a=a|0;b=b|0;var c=0,d=0;c=v[a+40>>2];while(1){if(c){c=c-1|0;d=c<<2;nb[v[v[a+32>>2]+d>>2]](b,a,v[d+v[a+36>>2]>>2]);continue}break}}function uaa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=v[b+4>>2];v[a>>2]=v[b>>2];v[a+4>>2]=d;d=v[b+12>>2];v[a+8>>2]=v[b+8>>2];v[a+12>>2]=d;Gy(a,A[c>>3])}function rM(a,b){var c=0,d=0;c=lc(a,b,602);a=0;while(1){d=B(a,896);As((d+c|0)+608|0,(b+d|0)+608|0);a=a+1|0;if((a|0)!=256){continue}break}return c}function p2(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;h=jb-32|0;jb=h;i=h+8|0;HH(i,b,c,d,e,f,g);rd(a,i);Cl(i);jb=h+32|0}function oq(a,b){var c=0,d=0;d=jb-16|0;jb=d;c=d+8|0;Sk(c,b);b=Hb(c);c=mc(a,$b(d,c));if((b|0)==(c|0)){_b(a,Hb(d+8|0))}jb=d+16|0;return(b|0)==(c|0)}function _f(a,b){var c=0,d=0;d=jb-16|0;jb=d;c=d+8|0;xq(c,b);b=Hb(c);c=mc(a,$b(d,c));if((b|0)==(c|0)){_b(a,Hb(d+8|0))}jb=d+16|0;return(b|0)==(c|0)}function ZQ(a,b){var c=0,d=0;d=jb-16|0;jb=d;c=d+8|0;jA(c,b);b=Hb(c);c=mc(a,$b(d,c));if((b|0)==(c|0)){_b(a,Hb(d+8|0))}jb=d+16|0;return(b|0)==(c|0)}function Vu(a,b){var c=0,d=0;d=jb-16|0;jb=d;c=d+8|0;Uu(c,b);b=Hb(c);c=mc(a,$b(d,c));if((b|0)==(c|0)){_b(a,Hb(d+8|0))}jb=d+16|0;return(b|0)==(c|0)}function TD(a){var b=0,c=0,d=0;b=jb-16|0;jb=b;c=jb-16|0;jb=c;d=a+256|0;while(1){jf(a);a=a+1|0;if((d|0)!=(a|0)){continue}break}jb=c+16|0;jb=b+16|0}function SP(a){var b=0,c=0,d=0;b=jb-16|0;jb=b;c=jb-16|0;jb=c;d=a+512|0;while(1){jf(a);a=a+1|0;if((d|0)!=(a|0)){continue}break}jb=c+16|0;jb=b+16|0}function NO(a,b){var c=0,d=0;d=jb-16|0;jb=d;c=d+8|0;xh(c,b);b=Hb(c);c=hd(a,$b(d,c));if((b|0)==(c|0)){Tc(a,Hb(d+8|0))}jb=d+16|0;return(b|0)==(c|0)}function MI(a){var b=0;b=(Ue(v[a+16>>2])>>>0)/(Ai(C(z[a+4208>>2]*C(999)))+1>>>0)|0;b=b>>>0>2?b:2;v[a+4216>>2]=b;v[a+4220>>2]=b>>>1;tc(a+4224|0,b)}function Aq(a,b){var c=0,d=0;d=jb-16|0;jb=d;c=d+8|0;xh(c,b);b=Hb(c);c=mc(a,$b(d,c));if((b|0)==(c|0)){_b(a,Hb(d+8|0))}jb=d+16|0;return(b|0)==(c|0)}function mw(a){var b=0,c=0;b=jb-16|0;jb=b;c=-1;a:{if($F(a)){break a}if((nb[v[a+32>>2]](a,b+15|0,1)|0)!=1){break a}c=w[b+15|0]}jb=b+16|0;return c}function jba(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;a=jb-16|0;jb=a;v[a+8>>2]=v[d>>2];f=A[v[a+8>>2]>>3];v[b+8>>2]=0;A[b>>3]=f;jb=a+16|0}function JP(a){var b=0,c=0,d=0;b=jb-16|0;jb=b;c=jb-16|0;jb=c;d=a+32|0;while(1){jf(a);a=a+1|0;if((d|0)!=(a|0)){continue}break}jb=c+16|0;jb=b+16|0}function Eo(a,b){var c=0;a:{if(!OG(b)|(w[b+1|0]^w[a+1|0])>>>0>1){break a}b=w[b+2|0];a=w[a+2|0];if((b^a)&12){break a}c=b>>>0<16^a>>>0>15}return c}function Ab(){var a=0;a=v[20045];v[113382]=0;Y(a|0);a=v[113382];v[113382]=0;if((a|0)!=1){v[113382]=0;L()}a=V(0)|0;O()|0;_(a|0)|0;v[113382]=0;L()}function $g(a,b){a=a|0;b=b|0;var c=0;c=jb-16|0;jb=c;t[c+15|0]=0;a=Xk(a,c+15|0,1);t[c+8|0]=w[c+15|0];t[b|0]=w[c+8|0];jb=c+16|0;return!mb&(a|0)==1}function ula(a,b){a=a|0;b=b|0;var c=0;a=Yc(a,8,1,0,1);c=2;b=b+13|0;a:{if(!(w[b|0]&64)){c=0;if(!(w[b|0]&2)){break a}}Zl(a,c)}if(w[b|0]&4){mA(a)}}function tt(a){a=+a;var b=0;a=Md(a);b=255;a:{if(!(a<255)){break a}b=0;if(!(a>0)){break a}b=~~a>>>0;if(a<4294967296&a>=0){break a}b=0}return b|0}function nR(a){var b=0,c=0,d=0;b=jb-16|0;jb=b;c=jb-16|0;jb=c;d=a+4|0;while(1){jf(a);a=a+1|0;if((d|0)!=(a|0)){continue}break}jb=c+16|0;jb=b+16|0}function mQ(a){var b=0;b=v[a+4>>2];a=v[a>>2];v[113382]=0;a=Q(844,a|0,b|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){return a}V(0)|0;O()|0;Ab();L()}function jp(a){var b=0,c=0,d=0;c=w[a+30|0];d=Mh(v[a+24>>2]+484360|0);b=v[a+24>>2]+484360|0;if(c>>>0>=d>>>0){return Vb(b)}return Di(b,w[a+30|0])}function W0(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=v[b>>2];v[a>>2]=d;v[v[d-12>>2]+a>>2]=v[b+4>>2];v[a+4>>2]=0;Pr(v[v[a>>2]-12>>2]+a|0,c);return a|0}function Qm(a,b,c){a:{if((a|0)==(b|0)){break a}c=w[c|0];while(1){if((c|0)==w[a|0]){break a}a=a+1|0;if((b|0)!=(a|0)){continue}break}a=b}return a}function Qla(a){a=a|0;var b=0,c=0,d=0;b=jb-16|0;jb=b;u[b+14>>1]=1;c=b,d=Wt(a),u[c+12>>1]=d;a=x[Ri(b+14|0,b+12|0)>>1];jb=b+16|0;return a-1&65535}function Lp(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if(xS(a)>>>0<b>>>0){ld();L()}c=Zg(zb(a),b);v[a>>2]=c;v[a+4>>2]=c;d=zb(a),e=b+c|0,v[d>>2]=e;rA(a,0)}function EC(a){var b=0;b=v[a+4>>2];a=v[a>>2];v[113382]=0;a=Q(252,a|0,b|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){return a}V(0)|0;O()|0;Ab();L()}function zk(a){var b=0;a=Md(a);b=-1;a:{if(!(a<4294967295)){break a}b=0;if(!(a>0)){break a}b=~~a>>>0;if(a<4294967296&a>=0){break a}b=0}return b}function xG(a,b,c,d,e,f){var g=0,h=0;g=v[a+32>>2];if(!w[a+23|0]){v[(c<<2)+g>>2]=b;return}h=g;g=d<<2;v[h+g>>2]=b;t[v[a+8>>2]+d|0]=e;v[f+g>>2]=c}function rh(a){var b=0;b=v[a+4>>2];a=v[a>>2];v[113382]=0;a=Q(29,a|0,b|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){return a}V(0)|0;O()|0;Ab();L()}function aga(a,b,c){a=a|0;b=b|0;c=c|0;a=w[c|0]|w[c+1|0]<<8|(w[c+2|0]<<16|w[c+3|0]<<24);t[b|0]=a;t[b+1|0]=a>>>8;t[b+2|0]=a>>>16;t[b+3|0]=a>>>24}function Hb(a){var b=0;b=v[a+4>>2];a=v[a>>2];v[113382]=0;a=Q(34,a|0,b|0)|0;b=v[113382];v[113382]=0;if((b|0)!=1){return a}V(0)|0;O()|0;Ab();L()}function uu(a,b){var c=0,d=0,e=0;c=jb-16|0;jb=c;a:{if(Rb(a,256)){d=jb-16|0;jb=d;e=c+8|0;fc(e,b,256);jb=d+16|0;zd(a,e);break a}TD(b)}jb=c+16|0}function GP(a){var b=0;a:{if(md(a,9780,3)|w[a+3|0]>31|(t[a+27|0]<0|w[a+32|0]>64)){break a}a=a+33|0;if(w[a|0]>32){break a}b=w[a|0]!=0}return b}function B0(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;e=v[a+20>>2];d=v[a+16>>2]-e|0;d=c>>>0<d>>>0?c:d;lc(e,b,d);v[a+20>>2]=d+v[a+20>>2];return c|0}function r2(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=jb-32|0;jb=g;h=g+8|0;IH(h,b,c,d,e,f);rd(a,g+20|0);Cl(h);jb=g+32|0}function lq(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=jb-16|0;jb=c;e=v[b+4>>2];d=v[b>>2];t[c+15|0]=0;d=Qm(d,d+e|0,c+15|0);oi(a,v[b>>2],d);jb=c+16|0}function aP(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;return(e=a,f=v[c>>2],g=b,h=Hb(c),d=v[v[a>>2]+28>>2],nb[d](e|0,f|0,g|0,h|0)|0)|0}function RB(a){var b=0,c=0;c=qma(w[a+111|0],0,1536,0);b=mb;a=qma(w[a+110|0],0,25,0);c=c+a|0;b=mb+b|0;b=a>>>0>c>>>0?b+1|0:b;a=c;mb=b;return a}function DL(a,b){var c=0,d=0,e=0;d=w[a|0];e=w[b|0];c=1;a:{if(d>>>0<e>>>0){break a}c=0;if(d>>>0>e>>>0){break a}c=x[a+2>>1]<x[b+2>>1]}return c}function sj(a){if(!(a<2147483647)){return 2147483647}if(!(a>-2147483648)){return-2147483648}if(D(a)<2147483648){return~~a}return-2147483648}function qba(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=jb-16|0;jb=d;if(b>>>0>=250){Yi(8130);L()}e=d+8|0;Fb(e,a,b);ce(e,c);jb=d+16|0;return a|0}function cs(a){var b=0;b=A[a+4248>>3]/+(Ue(v[a+16>>2])>>>0);A[a+4264>>3]=b;if(w[a+4240|0]){A[a+4264>>3]=b*.016666666666666666*A[a+4288>>3]}}function zba(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=jb-16|0;jb=d;if(b>>>0>=16){Yi(8130);L()}e=d+8|0;Pj(e,a,b);ce(e,c);jb=d+16|0;return a|0}function lla(a,b){a=a|0;b=b|0;var c=0,d=0;c=jb-16|0;jb=c;a:{if(Rb(b,6)){d=c+8|0;jA(d,a);zd(b,d);break a}t[c+7|0]=0;Qh(a,6,c+7|0)}jb=c+16|0}function hZ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;a=jb-16|0;jb=a;v[a+12>>2]=e;v[a+8>>2]=d-c;b=Lb(a+12|0,a+8|0);jb=a+16|0;return v[b>>2]}function dd(a,b){a=a|0;b=b|0;var c=0;c=jb-16|0;jb=c;v[c+8>>2]=a;v[c+12>>2]=b;v[c>>2]=-1;v[c+4>>2]=0;a=Fu(c+8|0,c);jb=c+16|0;return v[a>>2]}function Y8(a){a=a|0;var b=0,c=0,d=0;b=jb-16|0;jb=b;if(!wd(a,4)){tv(a)}c=b,d=ac(a+44|0),v[c>>2]=d;a=v[Hd(b+8|0,b)>>2];jb=b+16|0;return a|0}function X8(a){a=a|0;var b=0,c=0,d=0;b=jb-16|0;jb=b;if(!wd(a,4)){tv(a)}c=b,d=bc(a+44|0),v[c>>2]=d;a=v[Hd(b+8|0,b)>>2];jb=b+16|0;return a|0}function QP(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=jb-16|0;jb=c;d=Rb(a,32);a:{if(d){e=c+8|0;KP(e,b);zd(a,e);break a}JP(b)}jb=c+16|0;return d|0}function Nb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=jb-16|0;jb=d;if(b>>>0>=110){Yi(8130);L()}e=d+8|0;Fb(e,a,b);ce(e,c);jb=d+16|0;return a|0}function Jha(a,b){a=a|0;b=b|0;var c=0,d=0;c=jb-16|0;jb=c;a:{if(Rb(b,5)){d=c+8|0;hu(d,a);zd(b,d);break a}t[c+7|0]=0;Qh(a,5,c+7|0)}jb=c+16|0}function Aba(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=jb-16|0;jb=d;if(b>>>0>=43){Yi(8130);L()}e=d+8|0;Fb(e,a,b);ce(e,c);jb=d+16|0;return a|0}function yi(a,b,c){a=a|0;b=b|0;c=c|0;a:{if((vk(a,b)|0)==255){break a}uk(a,b);np(a,b,0,0);if(!c){break a}a=ec(a+58|0,b);t[a|0]=w[a|0]|128}}function wn(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=jb-16|0;jb=c;d=Rb(a,4);a:{if(d){e=c+8|0;xh(e,b);zd(a,e);break a}nR(b)}jb=c+16|0;return d|0}function mM(a){a=50-(B(w[(a>>>4|0)+25904|0],a&15)>>>4|0)|0;a=a>>>0>23863?65536:23863/(a>>>0)|0;return zc((a+119315e4>>>0)/(a<<1>>>0)|0,0)}function iq(a,b){a=a|0;b=b|0;var c=0,d=0;c=jb-16|0;jb=c;a:{if(Rb(b,3)){d=c+8|0;vu(d,a);zd(b,d);break a}t[c+7|0]=0;Qh(a,3,c+7|0)}jb=c+16|0}function Ul(a,b){a=a|0;b=b|0;var c=0,d=0;c=jb-16|0;jb=c;a:{if(Rb(b,4)){d=c+8|0;xh(d,a);zd(b,d);break a}t[c+7|0]=0;Qh(a,4,c+7|0)}jb=c+16|0}function Rc(a){var b=0;b=jb-16|0;jb=b;v[b+12>>2]=a;v[b+8>>2]=-32768;v[b+4>>2]=32767;a=u[yf(b+8|0,Zd(b+12|0,b+4|0))>>1];jb=b+16|0;return a}function Hk(a){a=a|0;var b=0;b=jb-16|0;jb=b;v[b+12>>2]=a;v[b+8>>2]=0;v[b+4>>2]=255;a=w[yf(b+8|0,Zd(b+12|0,b+4|0))|0];jb=b+16|0;return a|0}function Dh(a){var b=0;a=a*a;b=a*a;return C(a*-.499999997251031+1+b*.04166662332373906+a*b*(a*2439044879627741e-20+-.001388676377460993))}function Bv(a,b){Pm(a);v[a>>2]=66760;v[113382]=0;Q(2831,a+4|0,b|0)|0;a=v[113382];v[113382]=0;if((a|0)!=1){return}a=P()|0;O()|0;S(a|0);L()}function xI(a){var b=0,c=C(0);if(!a){return C(1)}if((a|0)>=-99999){b=+(a|0)*.0016609640474436812;c=C(Yg(b-J(b+.5)))}else{c=C(0)}return c}function wka(a,b){a=a|0;b=b|0;var c=0;c=jb-32|0;jb=c;t[c+16|0]=44;v[c+8>>2]=-1;v[c+12>>2]=0;v[c>>2]=1042;v[c+4>>2]=2;xr(a,b,c);jb=c+32|0}function ima(a,b){a=a|0;b=b|0;var c=0;c=jb-32|0;jb=c;t[c+16|0]=44;v[c+8>>2]=-1;v[c+12>>2]=0;v[c>>2]=1058;v[c+4>>2]=2;Wr(a,b,c);jb=c+32|0}function bja(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;a=jb-16|0;jb=a;v[a+8>>2]=v[d>>2];c=x[v[a+8>>2]>>1];u[b+2>>1]=0;u[b>>1]=c;jb=a+16|0}function Qd(a,b){var c=0,d=0;c=jb-16|0;jb=c;d=im(c+8|0,b);bD(d,a);Bb(d);jb=c+16|0;c=v[b+12>>2];v[a+8>>2]=v[b+8>>2];v[a+12>>2]=c;return a}function MF(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;if(c){d=a;while(1){v[d>>2]=v[b>>2];d=d+4|0;b=b+4|0;c=c-1|0;if(c){continue}break}}return a|0}function GV(a,b,c){a=a|0;b=b|0;c=c|0;if(nD(c)){v[113382]=0;Wb(a);a=v[113382];v[113382]=0;if((a|0)==1){V(0)|0;O()|0;Ab();L()}return}Wb(a)}function BZ(a){a=a|0;var b=0,c=0,d=0;b=v[v[a>>2]>>2];c=v[b+8>>2];a=v[b+4>>2];b=v[b>>2]+(c>>1)|0;d=b;if(c&1){a=v[a+v[b>>2]>>2]}nb[a|0](d)}function $ga(a,b){a=a|0;b=b|0;var c=0;c=jb-32|0;jb=c;t[c+16|0]=44;v[c+8>>2]=-1;v[c+12>>2]=0;v[c>>2]=1042;v[c+4>>2]=2;iu(a,b,c);jb=c+32|0}function $fa(a,b){a=a|0;b=b|0;var c=0;c=jb-32|0;jb=c;t[c+16|0]=44;v[c+8>>2]=-1;v[c+12>>2]=0;v[c>>2]=1058;v[c+4>>2]=3;tQ(a,b,c);jb=c+32|0}function tu(a,b){a=a|0;b=b|0;var c=0,d=0;c=jb-16|0;jb=c;a:{if(Rb(b,2)){d=c+8|0;Sk(d,a);zd(b,d);break a}t[c+7|0]=0;rB(a,c+7|0)}jb=c+16|0}function s2(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=jb-32|0;jb=g;h=g+8|0;IH(h,b,c,d,e,f);rd(a,h);Cl(h);jb=g+32|0}function pt(a,b){a=a|0;b=b|0;var c=0;c=jb-32|0;jb=c;t[c+16|0]=44;v[c+8>>2]=-1;v[c+12>>2]=0;v[c>>2]=1058;v[c+4>>2]=2;OH(a,b,c);jb=c+32|0}function n9(a,b){a=a|0;b=b|0;var c=0;c=jb-32|0;jb=c;t[c+16|0]=44;v[c+8>>2]=-1;v[c+12>>2]=0;v[c>>2]=1058;v[c+4>>2]=1;xr(a,b,c);jb=c+32|0}function mD(a){a=a|0;var b=0;a=bd(a);v[113382]=0;Q(208,a|0,9652)|0;b=v[113382];v[113382]=0;if((b|0)==1){b=P()|0;O()|0;yb(a);S(b|0);L()}}function _V(a,b){a=a|0;b=b|0;var c=0;c=jb-32|0;jb=c;t[c+16|0]=44;v[c+8>>2]=-1;v[c+12>>2]=0;v[c>>2]=1058;v[c+4>>2]=2;$v(a,b,c);jb=c+32|0}function Vd(a,b){a=a|0;b=b|0;return(w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24))==(w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24))|0}function Tc(a,b){var c=0,d=0,e=0;c=Ef(a,b);if(c){v[a+12>>2]=v[a+12>>2]+b;return c}d=a,e=nb[v[v[a>>2]+24>>2]](a)|0,v[d+12>>2]=e;return c}function Q0(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=b;b=v[b>>2]+7&-8;v[c>>2]=b+16;d=a,e=sw(v[b>>2],v[b+4>>2],v[b+8>>2],v[b+12>>2]),A[d>>3]=e}function M0(a,b){a=a|0;b=b|0;var c=0;c=jb-32|0;jb=c;t[c+16|0]=44;v[c+8>>2]=-1;v[c+12>>2]=0;v[c>>2]=1025;v[c+4>>2]=4;xr(a,b,c);jb=c+32|0}function Hj(a){var b=0;b=a+28|0;a=b;if((w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24))>>>0>=128){a=w[b|0]^-128}else{a=255}return a&255}function Gia(a,b){a=a|0;b=b|0;var c=0;c=jb-32|0;jb=c;t[c+16|0]=44;v[c+8>>2]=-1;v[c+12>>2]=0;v[c>>2]=257;v[c+4>>2]=0;$v(a,b,c);jb=c+32|0}function GT(a,b){a=a|0;b=b|0;var c=0;c=jb-32|0;jb=c;t[c+16|0]=44;v[c+8>>2]=-1;v[c+12>>2]=0;v[c>>2]=1025;v[c+4>>2]=2;iu(a,b,c);jb=c+32|0}function F0(a,b){a=a|0;b=b|0;var c=0;c=jb-32|0;jb=c;t[c+16|0]=44;v[c+8>>2]=-1;v[c+12>>2]=0;v[c>>2]=1025;v[c+4>>2]=2;xr(a,b,c);jb=c+32|0}function Cz(a,b){a=a|0;b=b|0;var c=0;c=jb-32|0;jb=c;t[c+16|0]=44;v[c+8>>2]=-1;v[c+12>>2]=0;v[c>>2]=1058;v[c+4>>2]=2;tQ(a,b,c);jb=c+32|0}function sT(a,b){a=a|0;b=b|0;var c=0;c=jb-32|0;jb=c;t[c+16|0]=44;v[c+8>>2]=-1;v[c+12>>2]=0;v[c>>2]=274;v[c+4>>2]=0;iu(a,b,c);jb=c+32|0}function Cr(a,b){var c=0,d=0;a:{if(b>>>0<=31){d=v[a+4>>2];c=a;break a}b=b-32|0;c=a+4|0}c=v[c>>2];v[a+4>>2]=d>>>b;v[a>>2]=d<<32-b|c>>>b}function $V(a,b){a=a|0;b=b|0;var c=0;c=jb-32|0;jb=c;t[c+16|0]=44;v[c+8>>2]=-1;v[c+12>>2]=0;v[c>>2]=290;v[c+4>>2]=0;$v(a,b,c);jb=c+32|0}function wG(a,b){a:{if(w[a+23|0]){a=1;if((b|0)!=255){break a}ia(10087,9203,1180,2220);L()}if((b|0)==255){return 0}a=b>>>0>10}return a}function qv(a,b,c,d,e,f){var g=0,h=0;g=v[a+4>>2];h=g>>8;if(g&1){h=uv(v[d>>2],h)}a=v[a>>2];nb[v[v[a>>2]+20>>2]](a,b,c,d+h|0,g&2?e:2,f)}function nV(a,b){a=a|0;b=b|0;v[b>>2]=0;v[b+4>>2]=0;v[b+24>>2]=0;v[b+28>>2]=0;v[b+16>>2]=0;v[b+20>>2]=0;v[b+8>>2]=0;v[b+12>>2]=0;TC(b)}function f8(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;if(!(!Xd(c&255)|!d)){qJ(a,8,C(0))}a=kj(a);if(a){nb[v[v[a>>2]+88>>2]](a,b,c,d,e)}}function QA(a){var b=0;b=jb-16|0;jb=b;t[a|0]=0;t[a+1|0]=0;t[a+2|0]=0;t[a+3|0]=0;t[a+3|0]=0;t[a+4|0]=0;t[a+5|0]=0;t[a+6|0]=0;jb=b+16|0}function ND(a){var b=0,c=0,d=0;c=Tb(a);b=Db(a);a=jb-16|0;jb=a;t[a+15|0]=0;d=-1;if(b){b=Xn(c,b,a+15|0);d=b?b-c|0:-1}jb=a+16|0;return d}function Df(a){var b=0,c=0;b=jb-16|0;jb=b;if(Aq(a,b+8|0)){a=b+8|0;c=w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24)}jb=b+16|0;return c}function df(a,b,c,d,e){var f=0;f=jb-16|0;jb=f;v[f+12>>2]=c;v[f+8>>2]=e;c=Bh(f,f+12|0);a=yr(a,b,d,v[f+8>>2]);Ge(c);jb=f+16|0;return a}function Zv(a){a=a|0;var b=0;b=v[a+12>>2];if((b|0)==v[a+16>>2]){return nb[v[v[a>>2]+40>>2]](a)|0}v[a+12>>2]=b+1;return Hg(t[b|0])|0}function OV(){var a=0,b=0;a=jb-16|0;jb=a;v[a+8>>2]=19469312;a:{if(qD(a+8|0)){break a}if(pD()){break a}b=oD()^1}jb=a+16|0;return b|0}function C2(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=v[b>>2];v[a>>2]=d;v[v[d-12>>2]+a>>2]=v[b+4>>2];Pr(v[v[a>>2]-12>>2]+a|0,c);return a|0}function Ar(a,b){var c=0,d=0;a:{if(b>>>0<=31){d=v[a>>2];c=a+4|0;break a}b=b-32|0;c=a}c=v[c>>2];v[a>>2]=d<<b;v[a+4>>2]=c<<b|d>>>32-b}function y8(a){a=a|0;a=jb-16|0;jb=a;v[a+12>>2]=1869112133;jb=a+16|0;a=a+12|0;return w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24)}function jo(a,b){a=a|0;b=b|0;var c=0,d=0;c=jb-16|0;jb=c;b=Yh(c,b);d=jb-16|0;jb=d;Oq(a,v[b>>2],v[b>>2]+rh(b)|0);jb=d+16|0;jb=c+16|0}function ig(a,b){a=a|0;b=b|0;var c=0,d=0;c=jb-16|0;jb=c;if(b>>>0>=110){Yi(8095);L()}d=c+8|0;Fb(d,a,b);ce(d,0);jb=c+16|0;return a|0}function yU(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;return(c=uma(0-uma(b^1230262859,25)|0,4)^1247037516,d=b,e=(a&4088)>>>0>=520,e?c:d)|0}function Rq(a,b,c,d,e){var f=0,g=0;f=v[a+4>>2];g=f>>8;if(f&1){g=uv(v[c>>2],g)}a=v[a>>2];nb[v[v[a>>2]+24>>2]](a,b,c+g|0,f&2?d:2,e)}function IR(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;a=jb-16|0;jb=a;v[a+8>>2]=v[d>>2];u[b>>1]=x[v[a+8>>2]>>1];bd(b+4|0);jb=a+16|0}function ez(a,b){var c=0,d=0;v[a>>2]=v[b>>2];v[a+4>>2]=v[b+4>>2];v[a+8>>2]=v[b+8>>2];v[b>>2]=0;v[b+4>>2]=0;c=zb(b),d=0,v[c>>2]=d}function y1(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=Xw(a+8|0,b,c,d,2);if(a>>>0<16){a=w[a+36048|0]}else{a=0}return(a>>>0<5?a+1|0:0)|0}function sZ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;while(1){if((b|0)!=(c|0)){v[d>>2]=t[b|0];d=d+4|0;b=b+1|0;continue}break}return c|0}function oF(a,b,c,d,e,f){a=nb[v[v[a+8>>2]+4>>2]](a+8|0)|0;a=vr(c,d,a,a+288|0,f,e,0)-a|0;if((a|0)<=287){v[b>>2]=((a|0)/12|0)%12}}function kj(a){var b=0,c=0;b=Hj(v[a+20>>2]);if(!(b>>>0>249|w[a+4200|0]>=b>>>0)){c=v[(v[a+16>>2]+B(b,160)|0)+906300>>2]}return c}function kF(a,b,c,d,e,f){a=nb[v[v[a+8>>2]+4>>2]](a+8|0)|0;a=rr(c,d,a,a+288|0,f,e,0)-a|0;if((a|0)<=287){v[b>>2]=((a|0)/12|0)%12}}function cO(a){var b=0;b=v[a+16>>2];a=v[a+32>>2];b=qma(b,b>>31,a,a>>31)+5e5|0;a=mb;return zc(rma(b,b>>>0<5e5?a+1|0:a,1e6,0),mb)}function bO(a){var b=0;b=v[a+16>>2];a=v[a+36>>2];b=qma(b,b>>31,a,a>>31)+5e5|0;a=mb;return zc(rma(b,b>>>0<5e5?a+1|0:a,1e6,0),mb)}function bN(a,b,c){a=a|0;b=b|0;c=c|0;if((b|0)!=(c|0)){while(1){aN(a,w[b|0]);b=b+1|0;if((c|0)!=(b|0)){continue}break}}return a|0}function ZP(a,b){var c=0,d=0;c=jb-16|0;jb=c;d=Uk(c+8|0,b);bD(d,a);Bb(d);jb=c+16|0;c=v[b+12>>2];v[a+8>>2]=v[b+8>>2];v[a+12>>2]=c}function HI(a){a=a|0;var b=0,c=0;b=a+4960|0;c=a+4504|0;while(1){b=b-24|0;fg(b);if((b|0)!=(c|0)){continue}break}rf(a);return a|0}function Ew(a,b,c){var d=0;d=v[a+32>>2];if(y[a+40>>2]<d+c>>>0){v[a+96>>2]=1;return 0}lc(b,d,c);v[a+32>>2]=v[a+32>>2]+c;return 1}function Bb(a){var b=0;a=v[a+4>>2];if(a){if(jm(a)){a:{b=a+8|0;if(v[b>>2]){if((av(b)|0)!=-1){break a}}nb[v[v[a>>2]+16>>2]](a)}}}}function x1(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=Xw(a+8|0,b,c,d,3);if(a>>>0<43){a=w[a+36e3|0]}else{a=0}return(a>>>0<5?a+1|0:0)|0}function sN(a,b,c,d,e){v[a+12>>2]=e;v[a+8>>2]=d;v[a+4>>2]=c;v[a>>2]=b;if(b){ae(b,a)}if(c){ae(c,a)}if(d){ae(d,a)}if(e){ae(e,a)}}function kZ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;while(1){if((b|0)!=(c|0)){t[d|0]=w[b|0];d=d+1|0;b=b+1|0;continue}break}return c|0}function Ge(a){a:{a=v[a>>2];if(a){v[113382]=0;fw(a);a=v[113382];v[113382]=0;if((a|0)==1){break a}}return}V(0)|0;O()|0;Ab();L()}function yk(a,b){var c=0;a:{if(y[a+12>>2]<b>>>0){c=0;if(nb[v[v[a>>2]+24>>2]](a)>>>0<b>>>0){break a}}v[a+12>>2]=b;c=1}return c}function uo(a,b){a=a|0;b=b|0;a:{if((a|0)==(b|0)){break a}while(1){b=b-4|0;if(b>>>0<=a>>>0){break a}dc(a,b);a=a+4|0;continue}}}function rk(a,b,c){var d=0;d=jb-16|0;jb=d;v[d+12>>2]=c;c=v[b>>2];v[d+8>>2]=v[b+4>>2];$c(a,c,v[Lb(d+12|0,d+8|0)>>2]);jb=d+16|0}function pD(){var a=0,b=0,c=0;a=jb-16|0;jb=a;b=Ub(a,10486);if(Db(b)){c=($f(b,9813)|0)!=-1}else{c=0}yb(b);jb=a+16|0;return c|0}function iy(a,b){var c=0,d=0;c=jb-16|0;jb=c;d=c+8|0;Fb(d,a+1074312|0,7);a=Cb(d);jb=c+16|0;return v[(b<<2)+(a?30544:31568)>>2]}function hy(a,b){var c=0,d=0;c=jb-16|0;jb=c;d=c+8|0;Fb(d,a+1074312|0,7);a=Cb(d);jb=c+16|0;return v[(b<<2)+(a?31568:30544)>>2]}function gba(a){a=a|0;v[a>>2]=0;Oi(a+4|0);v[a+152>>2]=0;v[a+156>>2]=0;v[a+144>>2]=0;v[a+148>>2]=0;Qb(a+16|0,0,128);return a|0}function Zj(a,b){a=a|0;b=b|0;a:{if((a|0)==(b|0)){break a}while(1){b=b-1|0;if(b>>>0<=a>>>0){break a}Rg(a,b);a=a+1|0;continue}}}function WX(a){a=a|0;var b=0;if((nb[v[v[a>>2]+36>>2]](a)|0)==-1){return-1}b=a;a=v[a+12>>2];v[b+12>>2]=a+1;return Hg(t[a|0])|0}function TL(a,b){var c=0,d=0;c=jb-16|0;jb=c;d=c+8|0;Fb(d,a+1074312|0,7);a=Cb(d);jb=c+16|0;return v[(b<<2)+(a?30416:30480)>>2]}function SL(a,b){var c=0,d=0;c=jb-16|0;jb=c;d=c+8|0;Fb(d,a+1074312|0,7);a=Cb(d);jb=c+16|0;return v[(b<<2)+(a?30480:30416)>>2]}function GW(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;if(rg(a,v[b+8>>2],0)){vv(b,c,d);return}a=v[a+8>>2];nb[v[v[a>>2]+28>>2]](a,b,c,d)}function yh(a,b,c){a:{if(c){v[113382]=0;MF(a,b,c);a=v[113382];v[113382]=0;if((a|0)==1){break a}}return}V(0)|0;O()|0;Ab();L()}function xK(a){var b=0;b=a;if((w[b|0]|w[b+1|0]<<8|(w[b+2|0]<<16|w[b+3|0]<<24))==1179011410){a=hz(a)>>>0>80}else{a=0}return a}function pF(a,b,c,d,e,f){a=nb[v[v[a+8>>2]>>2]](a+8|0)|0;a=vr(c,d,a,a+168|0,f,e,0)-a|0;if((a|0)<=167){v[b>>2]=((a|0)/12|0)%7}}function lF(a,b,c,d,e,f){a=nb[v[v[a+8>>2]>>2]](a+8|0)|0;a=rr(c,d,a,a+168|0,f,e,0)-a|0;if((a|0)<=167){v[b>>2]=((a|0)/12|0)%7}}function kE(a){v[a>>2]=64936;Rv(a+4|0);v[a+24>>2]=0;v[a+28>>2]=0;v[a+16>>2]=0;v[a+20>>2]=0;v[a+8>>2]=0;v[a+12>>2]=0;return a}function er(a){v[a>>2]=64872;Rv(a+4|0);v[a+24>>2]=0;v[a+28>>2]=0;v[a+16>>2]=0;v[a+20>>2]=0;v[a+8>>2]=0;v[a+12>>2]=0;return a}function c1(a){a=a|0;var b=0;if(!a){return-2}b=v[a+28>>2];if(!b){return 0}nb[v[a+36>>2]](v[a+40>>2],b);v[a+28>>2]=0;return 0}function Zp(a){a=a|0;var b=0,c=0;b=jb-16|0;jb=b;if(oq(a,b+8|0)){a=w[b+8|0]|w[b+9|0]<<8;c=a<<8|a>>>8}jb=b+16|0;return c&65535}function Zf(a,b,c,d){var e=0;a=((b|0)/8|0)+a|0;e=Gg(d,a);return((Gg(d,a+1|0)<<8|e<<16|Gg(d,a+2|0))<<(b&7)&16777215)>>>24-c|0}function Sb(a,b){var c=0,d=0,e=0;c=a;d=v[b>>2];e=d+v[a>>2]|0;a=v[a+4>>2]+v[b+4>>2]|0;v[c>>2]=e;v[c+4>>2]=e>>>0<d>>>0?a+1|0:a}function JO(a){var b=0,c=0;b=w[a+33|0];c=b>>>24|0;a=w[a+31|0]?1120:1056;b=a+(b<<8)|0;c=a>>>0>b>>>0?c+1|0:c;a=b;mb=c;return a}function uE(a,b){var c=0;c=jb-16|0;jb=c;a:{if(!(w[a+120|0]|b>>>0>30)){t[a+120|0]=1;break a}a=Po(c+8|0,b)}jb=c+16|0;return a}function ps(a){a=+a;var b=0,c=0,d=0;d=a*a;a=0;b=1;c=1;while(1){a=a+2;c=d*c/(a*a);b=c+b;if(b*1e-7<c){continue}break}return+b}function ot(a){a=a|0;var b=0;b=jb-16|0;jb=b;v[b+12>>2]=a;v[b+8>>2]=2147483647;a=v[Lb(b+12|0,b+8|0)>>2];jb=b+16|0;return a|0}function et(a,b,c){a:{v[113382]=0;U(25,b|0,B(c,56)|0,4);a=v[113382];v[113382]=0;if((a|0)!=1){break a}V(0)|0;O()|0;Ab();L()}}function eR(a,b,c){a:{v[113382]=0;U(25,b|0,B(c,33)|0,1);a=v[113382];v[113382]=0;if((a|0)!=1){break a}V(0)|0;O()|0;Ab();L()}}function aK(a){a=a|0;var b=0,c=0;b=Ae(a);while(1){c=b;if(c&65535){b=c-1|0;if(!jg(a,b&65535)){continue}}break}return c&65535}function _o(a,b,c){a:{v[113382]=0;U(25,b|0,B(c,24)|0,8);a=v[113382];v[113382]=0;if((a|0)!=1){break a}V(0)|0;O()|0;Ab();L()}}function Vx(a,b,c){a:{v[113382]=0;U(25,b|0,B(c,52)|0,4);a=v[113382];v[113382]=0;if((a|0)!=1){break a}V(0)|0;O()|0;Ab();L()}}function On(a,b){var c=0;a:{if(!b){break a}if(!Rb(a,b)){break a}if(b>>>0<=3){c=UB(a,b);break a}c=Df(a);_b(a,b-4|0)}return c}function Ff(a,b,c){a:{v[113382]=0;U(25,b|0,B(c,24)|0,4);a=v[113382];v[113382]=0;if((a|0)!=1){break a}V(0)|0;O()|0;Ab();L()}}function CS(a,b,c){a:{v[113382]=0;U(25,b|0,B(c,48)|0,4);a=v[113382];v[113382]=0;if((a|0)!=1){break a}V(0)|0;O()|0;Ab();L()}}function Bu(a,b){var c=0;a:{if(!b){break a}if(!Rb(a,b)){break a}if(b>>>0<=1){c=TB(a,1);break a}c=og(a);_b(a,b-2|0)}return c}function Bp(a,b,c){a:{v[113382]=0;U(25,b|0,B(c,20)|0,4);a=v[113382];v[113382]=0;if((a|0)!=1){break a}V(0)|0;O()|0;Ab();L()}}function Ah(a,b,c){a:{v[113382]=0;U(25,b|0,B(c,12)|0,4);a=v[113382];v[113382]=0;if((a|0)!=1){break a}V(0)|0;O()|0;Ab();L()}}function nz(a){v[a>>2]=0;v[a+4>>2]=0;v[a+24>>2]=0;v[a+28>>2]=0;v[a+16>>2]=0;v[a+20>>2]=0;v[a+8>>2]=0;v[a+12>>2]=0;return a}function c4(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;a=jb-16|0;jb=a;v[a+8>>2]=v[d>>2];rd(b,v[a+8>>2]);Xb(b+12|0);jb=a+16|0}function aO(a){a=a|0;v[a+700>>2]=0;u[a+862>>1]=0;v[a+688>>2]=0;v[a>>2]=0;v[a+4>>2]=0;v[a+8>>2]=0;v[a+12>>2]=0;v[a+16>>2]=0}function St(a,b,c){a:{v[113382]=0;U(25,b|0,B(c,6)|0,1);a=v[113382];v[113382]=0;if((a|0)!=1){break a}V(0)|0;O()|0;Ab();L()}}function PD(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;if(c){d=a;while(1){v[d>>2]=b;d=d+4|0;c=c-1|0;if(c){continue}break}}return a|0}function Jx(a,b){var c=0;if(!(w[a|0]!=w[b|0]|A[a+8>>3]!=A[b+8>>3]|w[a+16|0]!=w[b+16|0])){c=v[a+20>>2]==v[b+20>>2]}return c}function DH(a,b){a:{v[113382]=0;U(25,a|0,B(b,324)|0,4);a=v[113382];v[113382]=0;if((a|0)!=1){break a}V(0)|0;O()|0;Ab();L()}}function j2(a,b){a=a|0;b=b|0;var c=0,d=0;d=jb-16|0;jb=d;c=jb-16|0;jb=c;v[c+12>>2]=w[b|0];gx(a,c+12|0);jb=c+16|0;jb=d+16|0}function Yd(a,b,c){var d=0;a:{if((b|0)>(c|0)){break a}d=v[a>>2];if((d|0)>=(b|0)){b=c;if((d|0)<=(b|0)){break a}}v[a>>2]=b}}function Vv(a,b,c){c=v[c>>2];while(1){a:{if((a|0)!=(b|0)){if((c|0)!=v[a>>2]){break a}}else{a=b}return a}a=a+4|0;continue}}function Vn(a,b,c){var d=0;a:{if(b>>>0>c>>>0){break a}d=v[a>>2];if(d>>>0>=b>>>0){b=c;if(d>>>0<=b>>>0){break a}}v[a>>2]=b}}function OJ(a,b,c){var d=0;b=b-a>>2;if((b|0)>0){while(1){v[a>>2]=v[c>>2];a=a+4|0;d=b>>>0>1;b=b-1|0;if(d){continue}break}}}function wF(a){var b=0;b=v[a+12>>2];if((b|0)==v[a+16>>2]){return nb[v[v[a>>2]+40>>2]](a)|0}v[a+12>>2]=b+4;return v[b>>2]}function ok(a,b,c){var d=0;d=v[b+4>>2];v[a>>2]=v[b>>2];v[a+4>>2]=d;d=v[b+12>>2];v[a+8>>2]=v[b+8>>2];v[a+12>>2]=d;Gx(a,c)}function SX(a){a=a|0;var b=0;if((nb[v[v[a>>2]+36>>2]](a)|0)==-1){return-1}b=a;a=v[a+12>>2];v[b+12>>2]=a+4;return v[a>>2]}function PN(a,b,c,d,e,f,g){t[a+17|0]=g;t[a+16|0]=f;v[a+12>>2]=e;v[a+8>>2]=d;v[a+4>>2]=c;v[a>>2]=b;if(d){NN(a,1);NN(a,0)}}function ON(a,b,c,d,e,f,g){t[a+17|0]=g;t[a+16|0]=f;v[a+12>>2]=e;v[a+8>>2]=d;v[a+4>>2]=c;v[a>>2]=b;if(d){MN(a,1);MN(a,0)}}function FU(a){a=a|0;var b=0;a:{if(!se(-1,v[a+76>>2])){a=v[a+76>>2];break a}b=a;a=zE(a,32);v[b+76>>2]=a}return a<<24>>24}function sJ(a,b,c){a:{v[113382]=0;U(25,b|0,c<<11,4);a=v[113382];v[113382]=0;if((a|0)!=1){break a}V(0)|0;O()|0;Ab();L()}}function fo(a,b,c){var d=0,e=0;d=jb-16|0;jb=d;e=d+8|0;jo(e,Yh(d,b));bv(a,e);v[a+12>>2]=c;v[a+8>>2]=0;jb=d+16|0;return a}function Taa(a,b){a=a|0;b=b|0;if(b>>>0>255){return 17540}a=v[((b<<2)+a|0)+900380>>2];if(!a){return 17540}return a+492|0}function Ad(a){var b=0;b=jb-16|0;jb=b;v[b+12>>2]=78704;v[b+8>>2]=78808;v[a>>2]=v[b+12>>2];v[a+4>>2]=v[b+8>>2];jb=b+16|0}function xj(a,b,c){a:{v[113382]=0;U(25,b|0,c<<2,1);a=v[113382];v[113382]=0;if((a|0)!=1){break a}V(0)|0;O()|0;Ab();L()}}function xe(a){var b=0;b=v[a+32>>2];a:{if(b>>>0>=y[a+40>>2]){v[a+96>>2]=1;a=0;break a}v[a+32>>2]=b+1;a=w[b|0]}return a}function tO(a){var b=0,c=0,d=0;b=a+68|0;c=w[b+1|0]<<8;if(!(!(w[b|0]|c)|(c|w[b|0])>>>0>127)){d=!md(a,13692,17)}return d}function sA(a){a=a|0;var b=0;b=jb-16|0;jb=b;v[b+12>>2]=a;v[b+8>>2]=65535;a=x[Lb(b+12|0,b+8|0)>>1];jb=b+16|0;return a|0}function mW(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;h=b;b=0;return nb[a|0](h|b,c,d,e,b|f,g)|0}function lt(a,b,c){a:{v[113382]=0;U(25,b|0,c<<5,8);a=v[113382];v[113382]=0;if((a|0)!=1){break a}V(0)|0;O()|0;Ab();L()}}function aT(a){var b=0,c=0;a:{if(md(a,23620,20)){break a}b=a+25|0;if(!w[b|0]|w[b|0]>8){break a}c=t[a+47|0]>=0}return c}function Yr(a,b,c){var d=0;b=b-a|0;if((b|0)>0){while(1){t[a|0]=w[c|0];a=a+1|0;d=b>>>0>1;b=b-1|0;if(d){continue}break}}}function Xh(a,b,c){a:{v[113382]=0;U(25,b|0,c<<4,4);a=v[113382];v[113382]=0;if((a|0)!=1){break a}V(0)|0;O()|0;Ab();L()}}function Wu(a,b,c){a:{v[113382]=0;U(25,b|0,c<<3,1);a=v[113382];v[113382]=0;if((a|0)!=1){break a}V(0)|0;O()|0;Ab();L()}}function Ug(a,b,c){a:{v[113382]=0;U(25,b|0,c<<5,4);a=v[113382];v[113382]=0;if((a|0)!=1){break a}V(0)|0;O()|0;Ab();L()}}function Tn(a,b,c){a:{v[113382]=0;U(25,b|0,c<<1,2);a=v[113382];v[113382]=0;if((a|0)!=1){break a}V(0)|0;O()|0;Ab();L()}}function Se(a,b,c){a:{v[113382]=0;U(25,b|0,c<<2,4);a=v[113382];v[113382]=0;if((a|0)!=1){break a}V(0)|0;O()|0;Ab();L()}}function Ql(a,b,c){a:{v[113382]=0;U(25,b|0,c<<1,1);a=v[113382];v[113382]=0;if((a|0)!=1){break a}V(0)|0;O()|0;Ab();L()}}function Pia(a){a=a|0;var b=0,c=0;b=jb-16|0;jb=b;if(oq(a,b+8|0)){c=(w[b+8|0]|w[b+9|0]<<8)<<16>>16}jb=b+16|0;return c|0}function KJ(a,b){var c=0,d=0;c=jb-16|0;jb=c;b=$b(c,b);d=jb-16|0;jb=d;Oq(a,v[b>>2],v[b>>2]+Hb(b)|0);jb=d+16|0;jb=c+16|0}function Du(a,b,c){a:{v[113382]=0;U(25,b|0,c<<2,2);a=v[113382];v[113382]=0;if((a|0)!=1){break a}V(0)|0;O()|0;Ab();L()}}function nc(a,b){var c=0;Pm(a);v[a+4>>2]=0;v[a>>2]=78660;c=a;a=kd(Db(b)+1|0);v[c+4>>2]=a;if(a){lc(a,Tb(b),Db(b)+1|0)}}function cg(a,b,c){a:{v[113382]=0;U(25,b|0,c|0,1);a=v[113382];v[113382]=0;if((a|0)!=1){break a}V(0)|0;O()|0;Ab();L()}}function TA(a,b){a=a|0;b=b|0;var c=0;c=v[b+4>>2];if(c){fc(a,c,v[b>>2]);return}b=b+8|0;if(!id(b)){Vi(a,b);return}Uf(a)}function PQ(a){a=a|0;var b=0;b=jb-16|0;jb=b;u[b+14>>1]=a;u[b+12>>1]=255;a=w[Af(b+14|0,b+12|0)|0];jb=b+16|0;return a|0}function Nj(a,b,c){var d=0,e=0;e=a+24|0;a=jb-16|0;jb=a;if(b>>>0>=12){Yi(8130);L()}d=a+8|0;Pj(d,e,b);ce(d,c);jb=a+16|0}function vk(a,b){a=a+58|0;if(t[ec(a,b)|0]<0){return 255}if(w[ec(a,b)|0]!=255){a=w[ec(a,b)|0]&127}else{a=255}return a}function lV(a){a=a|0;var b=0,c=0;b=jb-16|0;jb=b;bo(a);v[a>>2]=72252;c=gc(a);Mp(c);v[c>>2]=72292;jb=b+16|0;return a|0}function ida(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=jb-16|0;jb=e;d=zq(e,a,d);qt(zb(a),b,c,d+4|0);Mb(d);jb=e+16|0}function vN(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=jb-16|0;jb=e;d=Uh(e,a,d);qt(zb(a),b,c,d+4|0);Mb(d);jb=e+16|0}function fz(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=jb-16|0;jb=e;d=Li(e,a,d);qt(zb(a),b,c,d+4|0);Mb(d);jb=e+16|0}function ZF(a,b,c,d,e,f,g,h,i){v[a>>2]=b;v[a+4>>2]=c;v[a+8>>2]=d;v[a+12>>2]=e&65535|(i>>>16&32768|e>>>16&32767)<<16}function Qk(a){a=a|0;var b=0;b=jb-16|0;jb=b;v[b+12>>2]=a;v[b+8>>2]=255;a=w[Lb(b+12|0,b+8|0)|0];jb=b+16|0;return a|0}function Cp(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=jb-16|0;jb=e;d=oe(e,a,d);qt(zb(a),b,c,d+4|0);Mb(d);jb=e+16|0}function iT(a,b,c,d,e){t[a+4|0]=b;t[a|0]=69;t[a+1|0]=99;t[a+2|0]=104;t[a+3|0]=111;t[a+7|0]=e;t[a+6|0]=d;t[a+5|0]=c}function _7(a){a=a|0;var b=0,c=0;v[v[a+20>>2]>>2]=a;c=v[a+12>>2];b=v[c>>2];v[a+4>>2]=b;if(b){v[b+8>>2]=a}v[c>>2]=a}function vM(a,b){var c=0;c=b&15;if(c){t[a+847|0]=c<<2}b=b&240;if(b){t[a+846|0]=b>>>4}v[a+88>>2]=v[a+88>>2]|262144}function vF(a,b){a=a|0;b=b|0;var c=0;c=v[a>>2];a:{if(!c){break a}if(!se(uF(c,b),-1)){break a}v[a>>2]=0}return a|0}function qk(a,b){var c=0;c=b&15;if(c){t[a+844|0]=c<<2}b=b&240;if(b){t[a+843|0]=b>>>4}v[a+88>>2]=v[a+88>>2]|131072}function kaa(a,b){a=a|0;b=b|0;t[b+38|0]=w[a+202|0];t[b+39|0]=w[a+203|0];t[b+40|0]=w[a+204|0];t[b+41|0]=w[a+205|0]}function fK(a){var b=0,c=0;if(v[a>>2]){iK(a);St(zb(a),v[a>>2],Mi(a));b=zb(a),c=0,v[b>>2]=c;v[a>>2]=0;v[a+4>>2]=0}}function QI(a){a=a|0;v[a+4244>>2]=0;v[a+4248>>2]=0;v[a+4228>>2]=0;v[a+4232>>2]=0;a=a+4252|0;v[a>>2]=0;v[a+4>>2]=0}function JN(a){var b=0,c=0;if(v[a>>2]){Hn(a);Tn(zb(a),v[a>>2],Yf(a));b=zb(a),c=0,v[b>>2]=c;v[a>>2]=0;v[a+4>>2]=0}}function HQ(a){var b=0,c=0;if(v[a>>2]){cR(a);Du(zb(a),v[a>>2],nd(a));b=zb(a),c=0,v[b>>2]=c;v[a>>2]=0;v[a+4>>2]=0}}function D8(a,b,c){a=a|0;b=b|0;c=C(c);var d=0,e=0;if((b|0)<=3){d=(a+b|0)+4264|0,e=PL(C(c*C(255))),t[d|0]=e;hs(a)}}function AM(a){var b=0,c=0;if(v[a>>2]){Js(a);cg(zb(a),v[a>>2],xf(a));b=zb(a),c=0,v[b>>2]=c;v[a>>2]=0;v[a+4>>2]=0}}function rG(a,b,c){var d=0,e=0,f=0;e=c*c;A[a>>3]=e;f=c;d=c*134217729;c=d+(c-d);d=f-c;A[b>>3]=d*d+(c*c-e+(c+c)*d)}function xE(a,b){v[113382]=0;U(25,a|0,b<<2,4);a=v[113382];v[113382]=0;if((a|0)!=1){return}V(0)|0;O()|0;Ab();L()}function sp(a,b){var c=0;c=jb-16|0;jb=c;v[c+8>>2]=v[a>>2];v[c+8>>2]=v[c+8>>2]+(b<<2);jb=c+16|0;return v[c+8>>2]}function bX(a,b){a=a|0;b=b|0;var c=0,d=0;nb[v[v[a>>2]+24>>2]](a)|0;b=Hv(b);v[a+36>>2]=b;c=a,d=rm(b),t[c+44|0]=d}function ah(a){a:{a=v[a+4>>2]&74;if(a){if((a|0)==64){return 8}if((a|0)!=8){break a}return 16}return 0}return 10}function _W(a,b){a=a|0;b=b|0;var c=0,d=0;nb[v[v[a>>2]+24>>2]](a)|0;b=Dv(b);v[a+36>>2]=b;c=a,d=rm(b),t[c+44|0]=d}function VH(a){var b=0;a:{while(1){if(!v[(b<<2)+a>>2]){break a}b=b+1|0;if((b|0)!=4){continue}break}b=4}return b}function Is(a){var b=0;b=1;a:{switch(w[a+3|0]-4|0){default:b=w[a+2|0]==11;break;case 0:case 2:break a}}return b}function Ej(a){a=w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24);return a<<24|a<<8&16711680|(a>>>8&65280|a>>>24)}function BA(a,b){a=a|0;b=b|0;var c=0;c=jb-16|0;jb=c;v[c+12>>2]=b;b=a;a=Ub(c,v[c+12>>2]);Sy(b,a);yb(a);jb=c+16|0}function vV(a,b){a=a|0;b=b|0;var c=0;c=jb-16|0;jb=c;bo(a);v[a>>2]=72148;_C(gc(a),Yh(c,b));jb=c+16|0;return a|0}function rg(a,b,c){if(!c){return v[a+4>>2]==v[b+4>>2]}if((a|0)==(b|0)){return 1}return!fi(v[a+4>>2],v[b+4>>2])}function ce(a,b){var c=0;c=v[a+4>>2];if(b){a=v[a>>2];v[a>>2]=v[a>>2]|c;return}a=v[a>>2];v[a>>2]=v[a>>2]&(c^-1)}function Xs(a,b){var c=0;c=jb-16|0;jb=c;v[c+8>>2]=v[a+4>>2];v[c>>2]=v[b+4>>2];a=Jb(c+8|0,c);jb=c+16|0;return a}function Tt(a,b){var c=0;c=jb-16|0;jb=c;v[c+12>>2]=(B(a,b)>>>0)/255;Yd(c+12|0,0,15);jb=c+16|0;return w[c+12|0]}function TJ(a){var b=0;b=jb-16|0;jb=b;v[b+12>>2]=a;v[b+8>>2]=32767;a=u[Lb(b+12|0,b+8|0)>>1];jb=b+16|0;return a}function f4(a,b){a=a|0;b=b|0;if(a){b=nb[v[v[b>>2]+8>>2]](b)|0;a:{if(b){b=Ud(b);break a}b=Ud(17540)}v[a>>2]=b}}function dQ(a,b){t[a+6|0]=255;v[a+16>>2]=0;u[a+4>>1]=0;v[a>>2]=0;if(!(b<0)){A[a+8>>3]=b;v[a+16>>2]=3}return a}function Z5(a){a=a|0;var b=0,c=0;b=jb-16|0;jb=b;c=Ub(b,8490);nc(a,c);yb(c);v[a>>2]=78620;jb=b+16|0;return a|0}function Wd(a,b){var c=C(0);a:{if(b>C(1)){break a}c=z[a>>2];if(!(c<b)){b=C(1);if(c<=C(1)){break a}}z[a>>2]=b}}function Vm(a){var b=0;while(1){if(w[b+36064|0]==(a|0)){return b}b=b+1|0;if(b>>>0<43){continue}break}return 0}function Td(a){a=a|0;var b=0;b=v[16480];v[a>>2]=b;v[v[b-12>>2]+a>>2]=v[16483];Or(a+4|0);_g(a+56|0);return a|0}function OK(a,b){a:{switch(b-1|0){default:return a+724|0;case 0:return a+736|0;case 1:break a}}return a+748|0}function Mf(a){a=a|0;var b=0;b=v[16525];v[a>>2]=b;v[v[b-12>>2]+a>>2]=v[16528];Or(a+8|0);_g(a+60|0);return a|0}function I5(a){a=a|0;var b=0,c=0;b=jb-16|0;jb=b;c=Ub(b,4465);nc(a,c);yb(c);v[a>>2]=78640;jb=b+16|0;return a|0}function qo(){var a=0;v[113382]=0;a=v[113382];v[113382]=0;if((a|0)!=1){return v[13842]}V(0)|0;O()|0;Ab();L()}function pp(a,b){a=a|0;b=b|0;if(oc(a)>>>0>b>>>0){a=jg(v[a+24>>2]+484344|0,x[Dj(a,b)>>1])}else{a=0}return a|0}function nF(a,b,c,d,e){b=bi(b,c,d,e,4);if(!(w[d|0]&4)){v[a>>2]=((b|0)<69?b+2e3|0:(b|0)<100?b+1900|0:b)-1900}}function jF(a,b,c,d,e){b=ai(b,c,d,e,4);if(!(w[d|0]&4)){v[a>>2]=((b|0)<69?b+2e3|0:(b|0)<100?b+1900|0:b)-1900}}function hr(){var a=0;v[113382]=0;a=v[113382];v[113382]=0;if((a|0)!=1){return v[14036]}V(0)|0;O()|0;Ab();L()}function gr(){var a=0;v[113382]=0;a=v[113382];v[113382]=0;if((a|0)!=1){return v[14424]}V(0)|0;O()|0;Ab();L()}function dka(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=jb-16|0;jb=d;if(!Bt(a,b)){b=Bt(c,a)?c:a}jb=d+16|0;return b|0}function SQ(a,b){a=a|0;b=b|0;var c=0;c=jb-16|0;jb=c;u[c+14>>1]=b;if((Wt(a)|0)!=65535){aB(a,c+14|0)}jb=c+16|0}function AF(a){var b=0;b=v[a+12>>2];if((b|0)==v[a+16>>2]){return nb[v[v[a>>2]+36>>2]](a)|0}return Hg(t[b|0])}function xy(a){v[113382]=0;U(25,a|0,40,4);a=v[113382];v[113382]=0;if((a|0)!=1){return}V(0)|0;O()|0;Ab();L()}function gh(a,b){var c=0;c=a;b=v[a+16>>2]+b|0;a=v[a+12>>2];b=(b|0)%(a|0)|0;return z[Bc(c,(b>>31&a)+b|0)>>2]}function Ok(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=jb-16|0;jb=d;if(!cq(a,b)){b=cq(c,a)?c:a}jb=d+16|0;return b|0}function KG(a,b,c,d){z[d+4>>2]=c+a;a=C(a+C(c*C(-.5)));b=C(b*C(.8660253882408142));z[d+8>>2]=a-b;z[d>>2]=a+b}function DK(a){v[113382]=0;U(25,a|0,28,4);a=v[113382];v[113382]=0;if((a|0)!=1){return}V(0)|0;O()|0;Ab();L()}function zu(a,b){a:{switch(b-1|0){default:return a+48|0;case 0:return a+68|0;case 1:break a}}return a+88|0}function kQ(a,b){var c=0,d=0;c=jb-16|0;jb=c;a:{if(Ef(a,4)){d=c+8|0;xh(d,b);oz(a,d);break a}nR(b)}jb=c+16|0}function ff(a,b){var c=0;c=jb-16|0;jb=c;v[c+8>>2]=v[a>>2];v[c+8>>2]=v[c+8>>2]+b;jb=c+16|0;return v[c+8>>2]}function bp(a){var b=0,c=0,d=0;b=a;a=v[a>>2];c=b,d=Eb(B(a,214013)+2531011|0),v[c>>2]=d;return a>>>16&32767}function aja(a,b){a=a|0;b=b|0;var c=0;b=jb-16|0;jb=b;c=-1;if(Ij(a,b+8|0)){c=AQ(b+8|0)}jb=b+16|0;return c|0}function Ula(a,b){a=a|0;b=b|0;var c=0;b=jb-80|0;jb=b;c=-1;if(XS(a,b+8|0)){c=WS(b+8|0)}jb=b+80|0;return c|0}function SG(a){var b=0;b=v[(w[a+2|0]&12)+39524>>2];a=w[a+1|0];return b>>>((a>>>3^-1)&1)>>>((a>>>4^-1)&1)|0}function Kw(a,b){var c=0;c=(B(B(Iw(a),Jw(a)),125)>>>0)/(SG(a)>>>0)|0;a=(w[a+1|0]&6)==6?c&-4:c;return a?a:b}function yx(a,b){cA(a);v[a+20>>2]=0;v[a+12>>2]=0;v[a+16>>2]=0;fy(a+24|0);Xb(a+36|0);v[a+48>>2]=b;return a}function xF(a){var b=0;b=v[a+12>>2];if((b|0)==v[a+16>>2]){return nb[v[v[a>>2]+36>>2]](a)|0}return v[b>>2]}function vT(a,b){a=a|0;b=b|0;var c=0;b=jb-16|0;jb=b;c=-1;if(Ij(a,b+8|0)){c=JA(b+8|0)}jb=b+16|0;return c|0}function t3(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=jb-16|0;jb=d;e=d+8|0;jo(e,Yh(d,b));fo(a,e,c);jb=d+16|0}function og(a){var b=0,c=0;b=jb-16|0;jb=b;if(oq(a,b+8|0)){a=b+8|0;c=w[a|0]|w[a+1|0]<<8}jb=b+16|0;return c}function nt(a,b){a=a|0;b=b|0;var c=0;c=jb-16|0;jb=c;Ul(c+8|0,a);v[c+4>>2]=v[c+8>>2];mt(c+4|0,b);jb=c+16|0}function WU(a,b){a=a|0;b=b|0;var c=0;b=jb-16|0;jb=b;c=-1;if(Ij(a,b+8|0)){c=DC(b+8|0)}jb=b+16|0;return c|0}function WS(a){return(w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24))==1179468868&(w[a+4|0]-1&255)>>>0<10}function EE(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;v[e>>2]=c;v[h>>2]=f;return 3}function $X(a){a=a|0;a=jb-16|0;jb=a;if(Wa(a+12|0,4)|0){wr(v[113305],8636);L()}jb=a+16|0;return v[a+12>>2]}function pg(a,b){var c=0,d=0;c=v[a>>2];d=v[b>>2];mb=v[a+4>>2]-(v[b+4>>2]+(c>>>0<d>>>0)|0)|0;return c-d|0}function lN(a){u[a+70>>1]=w[((x[v[a+4>>2]+22>>1]<<4|x[v[a+4>>2]+20>>1]>>>6)&65535)+25744|0]>>>x[a+68>>1]}function fw(a){a=a|0;var b=0;b=v[113364];if(a){v[113364]=(a|0)==-1?453264:a}return((b|0)==453264?-1:b)|0}function Jh(a,b,c){var d=0,e=0,f=0,g=0;d=A[c>>3];e=A[b>>3];f=A[c+8>>3];g=A[b+8>>3];fn(a,d*e-f*g,e*f+d*g)}function sE(a,b){var c=0;c=v[a+4>>2];while(1){if((b|0)!=(c|0)){bl(a);c=c-4|0;continue}break}v[a+4>>2]=b}function dc(a,b){var c=0;c=jb-16|0;jb=c;v[c+12>>2]=v[a>>2];v[a>>2]=v[b>>2];v[b>>2]=v[c+12>>2];jb=c+16|0}function co(a,b,c){var d=0;d=jb-16|0;jb=d;a=Uf(a);v[a+4>>2]=c;v[a>>2]=b;v[d+4>>2]=b;v[d>>2]=b;jb=d+16|0}function OX(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return nb[v[v[a>>2]+16>>2]](a,b,c,d,e,f)|0}function MX(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return nb[v[v[a>>2]+24>>2]](a,b,c,d,e,f)|0}function LK(a,b){var c=0;c=jb-16|0;jb=c;u[c+14>>1]=x[a>>1];u[a>>1]=x[b>>1];u[b>>1]=x[c+14>>1];jb=c+16|0}function JX(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return nb[v[v[a>>2]+28>>2]](a,b,c,d,e,f)|0}function GX(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return nb[v[v[a>>2]+44>>2]](a,b,c,d,e,f)|0}function AX(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return nb[v[v[a>>2]+20>>2]](a,b,c,d,e,f)|0}function RN(a){var b=0,c=0;while(1){c=(b<<2)+a|0;b=b+1|0;v[c+68>>2]=b<<11;if((b|0)!=9){continue}break}}function BK(a){var b=0;b=v[a>>2];v[a>>2]=0;if(b){a=jc(a);if(w[a+4|0]){Sv(v[a>>2],b+16|0)}if(b){DK(b)}}}function Jw(a){var b=0;b=w[a+1|0];return w[(B(b>>>1&3,15)+B(b>>>3&1,45)+(w[a+2|0]>>>4)|0)+39521|0]<<1}function By(a,b){if(jg(v[a+24>>2]+484344|0,b)){a=v[Zb(v[a+24>>2]+484344|0,b)+12>>2]}else{a=1}return a}function tE(a,b,c){var d=0;d=jb-16|0;jb=d;a:{if((a|0)==(b|0)){t[a+120|0]=0;break a}xE(b,c)}jb=d+16|0}function oU(a,b){a=a|0;b=b|0;var c=0,d=0;c=jb-16|0;jb=c;d=c+8|0;OB(d,a);mq(d,b);jb=c+16|0;return a|0}function em(a){t[a|0]=0;t[a+1|0]=0;t[a+2|0]=0;t[a+3|0]=0;t[a+4|0]=0;t[a+5|0]=0;t[a+6|0]=0;t[a+7|0]=0}function YA(a){var b=0;b=jb-16|0;jb=b;t[a|0]=0;t[a+1|0]=0;t[a+2|0]=0;t[a+3|0]=0;t[a+4|0]=0;jb=b+16|0}function KR(a,b){var c=0;c=v[a>>2];v[a>>2]=b;if(c){ER(c+52|0);yb(c+40|0);fg(c+16|0);fg(c+4|0);Wb(c)}}function EU(a,b){a=a|0;b=b|0;var c=0,d=0;c=jb-16|0;jb=c;d=c+8|0;nq(d,a);mq(d,b);jb=c+16|0;return a|0}function BU(a,b){a=a|0;b=b|0;var c=0,d=0;c=jb-16|0;jb=c;d=c+8|0;bC(d,a);mq(d,b);jb=c+16|0;return a|0}function rd(a,b){var c=0;c=v[b+4>>2];v[a>>2]=v[b>>2];v[a+4>>2]=c;v[a+8>>2]=v[b+8>>2];Om(b);return a}function fO(a,b){var c=0,d=0;c=v[a+4>>2];d=v[b+4>>2];return(c|0)<=(d|0)&y[b>>2]>y[a>>2]|(c|0)<(d|0)}function Vf(a,b,c){var d=0;a:{if(b>c){break a}d=A[a>>3];if(!(d<b)){b=c;if(d<=b){break a}}A[a>>3]=b}}function Eu(a,b){var c=0,d=0;c=v[a+4>>2];d=v[b+4>>2];return(c|0)==(d|0)&y[b>>2]>y[a>>2]|c>>>0<d>>>0}function E8(a,b){a=a|0;b=b|0;return C((b|0)<=3?C(C(w[(a+b|0)+4264|0])*C(.003921568859368563)):C(0))}function uia(a,b){a=a|0;b=b|0;var c=0;b=jb-16|0;jb=b;c=-1;if(nA(a,b)){c=_P(b)}jb=b+16|0;return c|0}function oja(a,b){a=a|0;b=b|0;var c=0;c=jb-16|0;jb=c;u[c+14>>1]=b;Iz(a+236|0,128,c+14|0);jb=c+16|0}function hW(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return nb[a|0](b,c,d,e,f,g)|0}function d4(a,b){a=a|0;b=b|0;var c=0;c=v[a+4>>2];b=Tb(b);if(c){nb[c|0](b,v[a+8>>2]);return}Zr(b,a)}function Bg(a){var b=0;b=a+44|0;Wk(b);if(v[b>>2]){wD(b,v[b>>2]);Xh(zb(b),v[b>>2],Wh(b))}NC(a+32|0)}function B9(a,b){a=a|0;b=b|0;t[b|0]=0;t[b+1|0]=0;t[b+2|0]=0;t[b+3|0]=0;t[b+4|0]=0;t[b+5|0]=0;Oh(b)}function Au(a){a=a|0;var b=0;b=jb-16|0;jb=b;a=_f(a,b+15|0);jb=b+16|0;return(a?w[b+15|0]:0)<<24>>24}function AZ(a,b,c){a=a|0;b=b|0;c=c|0;if(c>>>0<=127){a=(x[qo()+(c<<1)>>1]&b)!=0}else{a=0}return a|0}function xka(a,b){a=a|0;b=b|0;var c=0;c=jb-16|0;jb=c;cC(c,a);a=uf(c,b);yb(c);jb=c+16|0;return a|0}function uga(a,b,c){a=a|0;b=b|0;c=c|0;a=v[c+4>>2];v[b>>2]=v[c>>2];v[b+4>>2]=a;v[b+8>>2]=v[c+8>>2]}function kda(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=A[b+8>>3];d=xw(A[b>>3]);e=gi(c);fn(a,d*we(c),d*e)}function d8(a,b,c){a=a|0;b=b|0;c=c|0;a=kj(a);if(!a){return 0}return nb[v[v[a>>2]+96>>2]](a,b,c)|0}function bJ(a){a=a|0;var b=0;b=v[a>>2];if(b){nb[v[v[b>>2]+8>>2]](b);v[a>>2]=0}a=a+4|0;Js(a);GR(a)}function S2(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;nb[v[v[b>>2]+8>>2]](b,c);d=a;a=b+4|0;ro(d,a);HE(a,c)}function Ri(a,b){a=a|0;b=b|0;var c=0,d=0;c=jb-16|0;jb=c;d=Un(c+8|0,a,b);jb=c+16|0;return(d?b:a)|0}function Rg(a,b){var c=0;c=jb-16|0;jb=c;t[c+15|0]=w[a|0];t[a|0]=w[b|0];t[b|0]=w[c+15|0];jb=c+16|0}function JB(a){var b=0;b=w[a+35|0];a=b>>>21|0;b=(b<<11)+2624|0;a=b>>>0<2624?a+1|0:a;mb=a;return b}function Ck(a,b,c){a=a|0;b=b|0;c=c|0;Te(a,b);b=v[c+4>>2];v[a+4>>2]=v[c>>2];v[a+8>>2]=b;return a|0}function Af(a,b){a=a|0;b=b|0;var c=0,d=0;c=jb-16|0;jb=c;d=Un(c+8|0,b,a);jb=c+16|0;return(d?b:a)|0}function t2(a,b){a=a|0;b=b|0;er(a);v[a>>2]=65192;Xb(a+32|0);v[a+48>>2]=b;v[a+44>>2]=0;return a|0}function jK(a,b){var c=0;c=jb-16|0;jb=c;v[c+8>>2]=v[a>>2];WR(c+8|0,b);jb=c+16|0;return v[c+8>>2]}function Xk(a,b,c){var d=0,e=0;d=jb-16|0;jb=d;e=d+8|0;fc(e,Eb(b),c);a=_R(a,e);jb=d+16|0;return a}function zW(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;if(rg(a,v[b+8>>2],f)){sv(b,c,d,e)}}function uU(a){a=a|0;var b=0,c=0;b=jb-16|0;jb=b;if(_f(a,b+8|0)){c=w[b+8|0]}jb=b+16|0;return c|0}function sX(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;nb[v[v[b>>2]+16>>2]](a,b,v[c+8>>2],v[c+12>>2],0,d)}function naa(a,b){a=a|0;b=b|0;Ih(a);Ih(a);a:{if(b>>>0>=60){_b(a,4);break a}Ih(a)}return Ih(a)|0}function mu(a,b){a=a|0;b=b|0;var c=0;a=oq(a,b);if(!a){c=jb-16|0;jb=c;ou(b);jb=c+16|0}return a|0}function eka(a){a=a|0;var b=0;b=jb-16|0;jb=b;a=Aq(a,b+8|0);jb=b+16|0;return C(a?z[b+8>>2]:C(0))}function _ka(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;nb[v[v[b>>2]+16>>2]](a,b,c,d,e,f)}function Uo(a,b,c){a=v[a>>2]+1074984|0;return v[(a+B(b,896)|0)+680>>2]>v[(a+B(c,896)|0)+680>>2]}function PP(a){var b=0,c=0;b=1;c=v[a>>2];a:{if((c|0)>0){b=120;if(c>>>0<121){break a}}v[a>>2]=b}}function FG(a){var b=0;b=+((a&2097151)>>>0);return C(Zh(+C((a|0)>=0?b:-b),(a>>>21&1023)-788|0))}function Dka(a,b){a=a|0;b=b|0;var c=0;c=jb-16|0;jb=c;UR(c,b);rd(a,c);yb(c);jb=c+16|0;return a|0}function xO(a){var b=0;b=w[a+47|0];a=b>>>27|0;b=(b<<5)+259|0;a=b>>>0<259?a+1|0:a;mb=a;return b}function xA(a,b){var c=0;c=jb-16|0;jb=c;v[c>>2]=b;v[c+8>>2]=a;a=Yp(c,c+8|0);jb=c+16|0;return a}function fr(a,b){a=a|0;b=b|0;var c=0;a:{c=Db(a);if(c>>>0<b>>>0){Rs(a,b-c|0,0);break a}vC(a,b)}}function f7(a){a=a|0;var b=0,c=0;t[a+4202|0]=1;b=a,c=Ue(v[a+16>>2]),v[b+4256>>2]=c;PI(a);OI(a)}function b8(a,b){a=a|0;b=b|0;b=jb-16|0;jb=b;Vi(b,v[a+20>>2]+4|0);mJ(a,Dd(b+8|0,b),0);jb=b+16|0}function Zr(a,b){a=a|0;b=b|0;b=jb-16|0;jb=b;v[b>>2]=a;a=v[12140];vG(a,13843,b);Er(a);jb=b+16|0}function Ys(a,b){a=a|0;b=+b;var c=0,d=0,e=0;c=v[a+24>>2];d=a,e=zk(Yg(b)*+(c>>>0)),v[d+24>>2]=e}function QS(a,b){return(Yb((B(a>>>4|0,b)>>>0)/15|0,1,15)<<4|Yb((B(a&15,b)>>>0)/15|0,1,15))&255}function Oea(a,b){a=a|0;b=b|0;var c=0,d=0;c=jb-16|0;jb=c;d=a;a=rd(c,b);Sy(d,a);yb(a);jb=c+16|0}function C8(a){a=a|0;var b=0,c=0;t[a+4202|0]=1;b=a,c=Ue(v[a+16>>2]),v[b+4232>>2]=c;hs(a);zJ(a)}function zO(a,b,c){var d=0;v[a>>2]=v[b>>2];d=v[b>>2];v[a+8>>2]=b;v[a+4>>2]=B(c,12)+d;return a}function x0(a,b,c){a=a|0;b=b|0;c=c|0;if(se(a,v[b+4>>2])){a=v[b>>2]==(c|0)}else{a=0}return a|0}function wd(a,b){var c=0,d=0;c=jb-16|0;jb=c;d=c+8|0;Pj(d,a+24|0,b);a=Cb(d);jb=c+16|0;return a}function nW(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;a=nb[a|0](b,c,d,e)|0;qa(mb|0);return a|0}function kR(a){return(w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24))==1279544644&w[a+4|0]<32}function Yj(a){var b=0;b=jb-16|0;jb=b;a=v[Oc(b+8|0,Tb(a)+(Db(a)<<2)|0)>>2];jb=b+16|0;return a}function CX(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return nb[v[v[a>>2]+16>>2]](a,b,c,d,e)|0}function BX(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return nb[v[v[a>>2]+24>>2]](a,b,c,d,e)|0}function zX(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;return nb[v[v[a>>2]+32>>2]](a,b,c,d,e)|0}function uD(a,b,c){var d=0;v[a>>2]=v[b>>2];d=v[b>>2];v[a+8>>2]=b;v[a+4>>2]=(c<<4)+d;return a}function Xp(a,b,c){a=a|0;b=b|0;c=c|0;a=v[c+4>>2];v[b>>2]=v[c>>2];v[b+4>>2]=a;fm(b+8|0,c+8|0)}function Sh(a,b,c){var d=0;v[a>>2]=v[b>>2];d=v[b>>2];v[a+8>>2]=b;v[a+4>>2]=(c<<2)+d;return a}function NF(a){var b=0,c=0;c=a;while(1){b=c;c=b+4|0;if(v[b>>2]){continue}break}return b-a>>2}function FE(a){a=a|0;var b=0;v[a>>2]=59516;b=v[a+8>>2];if(!(!b|!w[a+12|0])){Wb(b)}return a|0}function Bia(a,b){a=a|0;b=b|0;var c=0;a=jb-16|0;jb=a;c=b;b=Vh(a);yQ(c,b,0,0);Bb(b);jb=a+16|0}function $o(a,b,c){a=wl(a)-v[a+1074392>>2]|0;if(a>>>0>=2){c=C(C(C(c-b)/C(a>>>0))+b)}return c}function $l(a,b,c){var d=0;v[a>>2]=v[b>>2];d=v[b>>2];v[a+8>>2]=b;v[a+4>>2]=(c<<1)+d;return a}function yf(a,b){a=a|0;b=b|0;var c=0,d=0;c=jb-16|0;jb=c;d=cq(a,b);jb=c+16|0;return(d?b:a)|0}function wL(a){v[a+20>>2]=0;t[a+16|0]=7;v[a+8>>2]=1889785610;v[a+12>>2]=1072630333;t[a|0]=3}function th(a,b){a=a|0;b=b|0;var c=0,d=0;c=jb-16|0;jb=c;d=CD(a,b);jb=c+16|0;return(d?b:a)|0}function su(a,b,c){a=a|0;b=b|0;c=c|0;b=jb-16|0;jb=b;t[b+15|0]=w[c|0];eI(a,b+15|0);jb=b+16|0}function qy(a){var b=0;v[a+72>>2]=0;v[a+76>>2]=0;b=v[a+68>>2];v[a+80>>2]=b;v[a+84>>2]=b<<12}function pc(a,b){a=a|0;b=b|0;var c=0,d=0;c=jb-16|0;jb=c;d=CD(b,a);jb=c+16|0;return(d?b:a)|0}function kma(a,b){a=a|0;b=b|0;var c=0;c=jb-16|0;jb=c;Cg(c,1,a);hC(c,b);jb=c+16|0;return a|0}function jma(a,b){a=a|0;b=b|0;var c=0;c=jb-16|0;jb=c;Zt(c,1,a);hC(c,b);jb=c+16|0;return a|0}function e6(a,b,c){a=a|0;b=b|0;c=c|0;dx(a);v[a+8>>2]=c;v[a+4>>2]=b;v[a>>2]=78588;return a|0}function dga(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=jb-16|0;jb=d;Ks(a,b,c);jb=d+16|0;return a|0}function cia(a){a=a|0;var b=0;b=jb-16|0;jb=b;a=Vu(a,b+8|0);jb=b+16|0;return+(a?A[b+8>>3]:0)}function Zd(a,b){a=a|0;b=b|0;var c=0,d=0;c=jb-16|0;jb=c;d=cq(b,a);jb=c+16|0;return(d?b:a)|0}function Vc(a,b){a=a|0;b=b|0;var c=0,d=0;c=jb-16|0;jb=c;d=Su(a,b);jb=c+16|0;return(d?b:a)|0}function Rb(a,b){a=a|0;b=b|0;var c=0;c=v[a>>2];return nb[v[v[c>>2]+36>>2]](c,v[a+8>>2],b)|0}function NC(a){var b=0;Pl(a);b=a;if(v[b>>2]){tD(b,v[b>>2]);cg(zb(b),v[b>>2],xf(b))}return a}function Lb(a,b){a=a|0;b=b|0;var c=0,d=0;c=jb-16|0;jb=c;d=Su(b,a);jb=c+16|0;return(d?b:a)|0}function Kp(a,b){var c=0;c=Db(a);if((c|0)==(Db(b)|0)){a=Sm(Tb(a),Tb(b),c)}else{a=1}return!a}function JA(a){return(w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24))==810369604&w[a+4|0]<4}function Fu(a,b){a=a|0;b=b|0;var c=0,d=0;c=jb-16|0;jb=c;d=Eu(b,a);jb=c+16|0;return(d?b:a)|0}function CC(a){a=a|0;var b=0;b=v[a>>2];return Eb((nb[v[v[b>>2]+20>>2]](b)|0)+v[a+8>>2]|0)|0}function qE(a){var b=0;b=v[a>>2];if(b){if(!se(AF(b),-1)){return!v[a>>2]}v[a>>2]=0}return 1}function pE(a){var b=0;b=v[a>>2];if(b){if(!se(xF(b),-1)){return!v[a>>2]}v[a>>2]=0}return 1}function oi(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=jb-16|0;jb=d;FI(a,b,c);jb=d+16|0;return a|0}function f6(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;uI(a,b,c,d,e,0,0,f,g)}function _C(a,b){var c=0,d=0;Mp(a);v[a>>2]=72188;v[a+4>>2]=v[b>>2];c=a,d=rh(b),v[c+8>>2]=d}function Wi(a){var b=0;if(a>>>0>=11){b=a+16&-16;a=b-1|0;a=(a|0)==11?b:a}else{a=10}return a}function Vi(a,b){a=a|0;b=b|0;var c=0,d=0;v[a>>2]=v[b>>2];c=a,d=v[b>>2]+wc(b)|0,v[c+4>>2]=d}function LI(a,b){var c=0;c=v[a+12>>2];if((c|0)>0){v[a+20>>2]=(v[a+16>>2]+(b+c|0)|0)%(c|0)}}function Fj(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=jb-16|0;jb=d;ZK(a,b,c);jb=d+16|0;return a|0}function uma(a,b){var c=0,d=0;c=b&31;d=(-1>>>c&a)<<c;c=a;a=0-b&31;return d|(c&-1<<a)>>>a}
function pw(a,b,c,d){var e=0;e=jb-16|0;jb=e;v[e+12>>2]=d;a=yr(a,b,c,d);jb=e+16|0;return a}function pJ(a){a=a|0;var b=0;b=A[a+4264>>3]*+y[v[a+16>>2]+1074376>>2];A[a+4256>>3]=b-J(b)}function oR(a,b,c,d){a=c-b|0;c=v[d>>2]+B((a|0)/-6|0,6)|0;v[d>>2]=c;if((a|0)>0){lc(c,b,a)}}function kG(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=(b|0)/(c|0)|0;v[a>>2]=d;v[a+4>>2]=b-B(c,d)}function i8(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=kj(a);if(a){nb[v[v[a>>2]+76>>2]](a,b,c,d)}}function h8(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=kj(a);if(a){nb[v[v[a>>2]+80>>2]](a,b,c,d)}}function gW(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;nb[a|0](b,c,d,e,f,g)}function g8(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=kj(a);if(a){nb[v[v[a>>2]+84>>2]](a,b,c,d)}}function ex(a){a=a|0;var b=0;v[a>>2]=78660;b=v[a+4>>2];if(b){Wb(b);v[a+4>>2]=0}return a|0}function Y9(a,b){a=a|0;b=b|0;var c=0;c=a;a=b+38|0;Yc(c,(w[a|0]|w[a+1|0]<<8)&4?16:8,1,0,0)}function Tu(a,b){a=a|0;b=b|0;b=b-1|0;if(b>>>0>4){b=5707}else{b=v[(b<<2)+71748>>2]}Ub(a,b)}function T9(a,b){a=a|0;b=b|0;var c=0;c=a;a=b+40|0;Yc(c,(w[a|0]|w[a+1|0]<<8)&4?16:8,1,0,0)}function A2(a,b){a=a|0;b=b|0;var c=0,d=0;c=jb-16|0;jb=c;d=c+8|0;OB(d,b);lq(a,d);jb=c+16|0}function tf(a){var b=0;b=jb-16|0;jb=b;a=v[Oc(b+8|0,Tb(a)+Db(a)|0)>>2];jb=b+16|0;return a}function le(a){var b=0;b=jb-16|0;jb=b;a=_f(a,b+15|0);jb=b+16|0;return(a?w[b+15|0]:0)&255}function J0(a,b,c){a=a|0;b=b|0;c=c|0;if(!((c|0)==1|(c|0)>256)){ow(a,c);return}Ub(a,4186)}function Iz(a,b,c){if(b){while(1){u[a>>1]=x[c>>1];a=a+2|0;b=b-1|0;if(b){continue}break}}}function AT(a){a=a|0;var b=0,c=0;b=jb-16|0;jb=b;c=b+8|0;UA(c,a);jb=b+16|0;return v[c>>2]}function $Q(a,b,c){a=a|0;b=b|0;c=c|0;v[b>>2]=v[c>>2];u[b+4>>1]=x[c+4>>1];fm(b+8|0,c+8|0)}function uQ(a,b){var c=0,d=0;v[a>>2]=v[b>>2];c=a,d=v[b>>2]+mQ(b)|0,v[c+4>>2]=d;return a}function k8(a,b){a=a|0;b=b|0;a=kj(a);if(!a){return 1}return nb[v[v[a>>2]+68>>2]](a,b)|0}function jm(a){var b=0;b=av(a+4|0);if((b|0)==-1){nb[v[v[a>>2]+8>>2]](a)}return(b|0)==-1}function iG(a){var b=0;b=pma(v[a>>2]-1|0);if(!b){a=pma(v[a+4>>2]);b=a?a+32|0:0}return b}function at(a,b,c){var d=0;v[a>>2]=v[b>>2];d=v[b>>2];v[a+8>>2]=b;v[a+4>>2]=c+d;return a}function af(a,b){var c=0;Uk(a,b);c=v[b+12>>2];v[a+8>>2]=v[b+8>>2];v[a+12>>2]=c;return a}function aN(a,b){var c=0;b=Eb(b);c=a;a=v[a>>2];v[c>>2]=a<<8^v[((b^a>>>24)<<2)+82432>>2]}function Yh(a,b){var c=0,d=0;v[a>>2]=v[b>>2];c=a,d=v[b>>2]+rh(b)|0,v[c+4>>2]=d;return a}function YL(a,b){var c=0;c=w[a+872|0];if(c&1){t[a+872|0]=c|8;v[a+876>>2]=v[a+876>>2]+b}}function W7(a,b,c){a=a|0;b=b|0;c=c|0;Dd(a,b);b=v[c+4>>2];v[a+8>>2]=v[c>>2];v[a+12>>2]=b}function Oh(a){t[a|0]=0;t[a+1|0]=0;t[a+2|0]=0;t[a+3|0]=0;t[a+4|0]=0;t[a+5|0]=0;return a}function Nz(a,b,c){a=a|0;b=b|0;c=c|0;a=x[c>>1]|x[c+2>>1]<<16;u[b>>1]=a;u[b+2>>1]=a>>>16}function D9(a,b,c){a=a|0;b=b|0;c=c|0;if(!((c|0)!=4&(c|0)!=-1)){Fi(a,b);return}GE(a,b,c)}function $b(a,b){var c=0,d=0;v[a>>2]=v[b>>2];c=a,d=v[b>>2]+Hb(b)|0,v[c+4>>2]=d;return a}function $U(a){a=a|0;var b=0;b=v[a+4>>2];return(nb[v[v[b>>2]+20>>2]](b)|0)+v[a+12>>2]|0}function yL(a){bd(a);bd(a+12|0);bd(a+24|0);bd(a+36|0);bd(a+48|0);v[a+60>>2]=0;return a}function rD(a){var b=0;b=a+48|0;while(1){b=yb(b-12|0);if((b|0)!=(a|0)){continue}break}}function ne(a){var b=0,c=0,d=0;b=jb-16|0;jb=b;c=v[Av(b,a)+8>>2],d=0,t[c|0]=d;jb=b+16|0}function mm(a){var b=0;b=a+36|0;while(1){b=yb(b-12|0);if((b|0)!=(a|0)){continue}break}}function hf(a){var b=0;b=a+24|0;while(1){b=yb(b-12|0);if((b|0)!=(a|0)){continue}break}}function fN(a,b){return(a>>>0<=62?63-(B((b^-1)&63,(a?a+1|0:0)&255)>>>6|0)|b&192:b)&255}function Ub(a,b){a=a|0;b=b|0;var c=0;c=jb-16|0;jb=c;Ks(a,b,cf(b));jb=c+16|0;return a|0}function Qh(a,b,c){if(b){while(1){t[a|0]=w[c|0];a=a+1|0;b=b-1|0;if(b){continue}break}}}function OF(a,b){var c=0;c=jb-16|0;jb=c;v[c+12>>2]=b;a=RF(a,7123,b);jb=c+16|0;return a}function MA(a,b,c){t[a+2|0]=1;b=b&15;if(c){b=w[b+23568|0]}else{b=(b<<2)+4|0}t[a+4|0]=b}function HO(a){var b=0;b=44325e5/+(a>>>0);if(b<4294967296&b>=0){return~~b>>>0}return 0}function zY(a){a=a|0;a=454960;while(1){a=Jc(a-12|0);if((a|0)!=454672){continue}break}}function tY(a){a=a|0;a=455032;while(1){a=Jc(a-12|0);if((a|0)!=455008){continue}break}}function qs(a,b){if(!(t[b+872|0]&1&v[a+480180>>2]==8)){Px(a,b,0);Px(a,b,1);Px(a,b,2)}}function ft(a,b){a:{if(b){break a}if(a>>>0<=3){a=a|-16;break a}a=a>>>2|0}return a&255}function al(a){var b=0;if(a>>>0>=2){b=a+4&-4;a=b-1|0;a=(a|0)==2?b:a}else{a=1}return a}function X0(a,b){a=a|0;b=b|0;a=x[a>>1];b=x[b>>1];return(a>>>0<b>>>0?-1:a>>>0>b>>>0)|0}function V0(a,b){a=a|0;b=b|0;a=v[a>>2];b=v[b>>2];return(a>>>0<b>>>0?-1:a>>>0>b>>>0)|0}function M_(a,b,c){a=a|0;b=b|0;c=c|0;c=Zv(v[b>>2])<<24;v[a+4>>2]=v[b>>2];t[a|0]=c>>24}function IY(a){a=a|0;a=454184;while(1){a=yb(a-12|0);if((a|0)!=454016){continue}break}}function FY(a){a=a|0;a=454360;while(1){a=Jc(a-12|0);if((a|0)!=454192){continue}break}}function CY(a){a=a|0;a=454656;while(1){a=yb(a-12|0);if((a|0)!=454368){continue}break}}function wY(a){a=a|0;a=455e3;while(1){a=yb(a-12|0);if((a|0)!=454976){continue}break}}function oh(a){t[a|0]=0;t[a+1|0]=0;t[a+2|0]=0;t[a+3|0]=0;t[a+4|0]=0;t[a+5|0]=0;Oh(a)}function oZ(a,b){a=a|0;b=b|0;if((b|0)>=0){b=v[hr()+((b&255)<<2)>>2]}return b<<24>>24}function mZ(a,b){a=a|0;b=b|0;if((b|0)>=0){b=v[gr()+((b&255)<<2)>>2]}return b<<24>>24}function $e(a){a=a|0;var b=0;b=v[a>>2];return(nb[v[v[b>>2]+24>>2]](b)|0)-v[a+8>>2]|0}function zF(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return nb[v[v[a>>2]+48>>2]](a,b,c,d)|0}function qf(a){var b=0;Nh(a);b=a;if(v[b>>2]){xH(b);_o(zb(b),v[b>>2],Ye(b))}return a}function jW(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=nb[a|0](b,c,d)|0;qa(mb|0);return a|0}function im(a,b){v[a>>2]=v[b>>2];v[a+4>>2]=v[b+4>>2];v[b>>2]=0;v[b+4>>2]=0;return a}function CF(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return nb[v[v[a>>2]+32>>2]](a,b,c,d)|0}function $5(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return nI(a,b,c,d,0,0,0,0,e)|0}function uM(a,b){var c=0;c=b&15;if(c){t[a+850|0]=c}b=b&240;if(b){t[a+849|0]=b>>>4}}function ny(a,b){var c=0;t[a|0]=w[b|0];c=v[b+8>>2];v[a+4>>2]=v[b+4>>2];v[a+8>>2]=c}function NQ(a){var b=0;b=jb-16|0;jb=b;a=v[Oc(b+8|0,v[a>>2])>>2];jb=b+16|0;return a}function GG(a,b){b=v[a+32>>2]+b|0;v[a+32>>2]=b;if(b>>>0>=y[a+40>>2]){v[a+96>>2]=1}}function Dj(a,b){a=a|0;b=b|0;if(oc(a)>>>0<=b>>>0){eG();L()}return v[a>>2]+(b<<1)|0}function Ct(a){var b=0,c=0;b=jb-16|0;jb=b;c=b+8|0;FR(c,a);jb=b+16|0;return v[c>>2]}function dl(a,b,c){v[a>>2]=b;b=v[b+4>>2];v[a+4>>2]=b;v[a+8>>2]=b+B(c,12);return a}function az(a,b){a=lc(a,b,34);u[a+34>>1]=x[b+34>>1];lc(a+36|0,b+36|0,68);return a}function Xt(a,b,c){a=a|0;b=b|0;c=c|0;a=w[c|0]|w[c+1|0]<<8;t[b|0]=a;t[b+1|0]=a>>>8}function Mk(a,b,c){v[a>>2]=b;b=v[b+4>>2];v[a+4>>2]=b;v[a+8>>2]=b+B(c,24);return a}function IC(a,b){var c=0;v[a>>2]=v[b>>2];c=a;a=v[b+4>>2];v[c+4>>2]=a;if(a){km(a)}}function GS(a,b,c){v[a>>2]=b;b=v[b+4>>2];v[a+4>>2]=b;v[a+8>>2]=b+B(c,48);return a}function zq(a,b,c){v[a>>2]=b;b=v[b+4>>2];v[a+4>>2]=b;v[a+8>>2]=b+(c<<3);return a}function yj(a){var b=0;b=jb-16|0;jb=b;a=v[Oc(b+8|0,jc(a))>>2];jb=b+16|0;return a}function rn(a){var b=0;b=jb-16|0;jb=b;a=v[Oc(b+8|0,NQ(a))>>2];jb=b+16|0;return a}function om(a,b,c){v[a>>2]=b;b=v[b+4>>2];v[a+4>>2]=b;v[a+8>>2]=b+(c<<4);return a}function oe(a,b,c){v[a>>2]=b;b=v[b+4>>2];v[a+4>>2]=b;v[a+8>>2]=b+(c<<2);return a}function _n(a,b,c){v[a>>2]=b;b=v[b+4>>2];v[a+4>>2]=b;v[a+8>>2]=b+(c<<5);return a}function Uh(a,b,c){v[a>>2]=b;b=v[b+4>>2];v[a+4>>2]=b;v[a+8>>2]=b+(c<<1);return a}function Tp(a,b,c){v[a>>2]=b;b=v[b+4>>2];v[a+4>>2]=b;v[a+8>>2]=b+B(c,6);return a}function SN(a){var b=0;b=v[a>>2];v[a>>2]=0;if(b){a=jc(a);if(b){Xh(v[a>>2],b,1)}}}function Ii(a){var b=0;b=jb-16|0;jb=b;a=v[Oc(b+8|0,yj(a))>>2];jb=b+16|0;return a}function Bd(a){var b=0;b=jb-16|0;jb=b;a=v[Oc(b+8|0,Tb(a))>>2];jb=b+16|0;return a}function yO(a){if((w[a+14|0]-49&255)>>>0<=3){a=md(a,11768,14)}else{a=1}return!a}function jS(a,b){a=a|0;b=b|0;return v[b+8>>2]==v[a+8>>2]&v[a+12>>2]==v[b+12>>2]}function iW(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;nb[a|0](b,c,d,e,f)}function d0(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;b=jb-16|0;jb=b;EF(a,c,d);jb=b+16|0}function yga(a,b){a=a|0;b=b|0;fj(b);if(v[b>>2]){EO(b);Ah(zb(b),v[b>>2],tg(b))}}function vG(a,b,c){var d=0;d=jb-16|0;jb=d;v[d+12>>2]=c;uG(a,b,c,0,0);jb=d+16|0}function lW(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return nb[a|0](b,c,d,e)|0}function it(a){t[a|0]=0;t[a+1|0]=0;t[a+2|0]=0;t[a+3|0]=0;t[a+4|0]=0;t[a+5|0]=0}function i1(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;return VG(a-88|0,b,c,d,e)|0}function fm(a,b){var c=0;im(a,b);c=v[b+12>>2];v[a+8>>2]=v[b+8>>2];v[a+12>>2]=c}function _s(a,b){return zk(Yg((+(a|0)*128+ +(b|0))*.0006510416666666666)*8363)}function v0(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)>=257){Ub(a,4222);return}ow(a,c)}function t0(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)>=257){Ub(a,4152);return}ow(a,c)}function hi(a,b,c){if(v[a+80>>2]){v[a+92>>2]=v[a+92>>2]+(c+7&-8);return}Wb(b)}function cC(a,b){var c=0,d=0;c=jb-16|0;jb=c;d=c+8|0;bC(d,b);lq(a,d);jb=c+16|0}function Uk(a,b){v[a>>2]=v[b>>2];b=v[b+4>>2];v[a+4>>2]=b;if(b){km(b)}return a}function Uaa(a,b){a=a|0;b=b|0;return(b>>>0<4e3?((b<<5)+a|0)+946304|0:17540)|0}function N1(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Mr(b,c,d,z[a+28>>2]);tH(a,b,c,d)}function M6(a,b){a=a|0;b=b|0;return C((b|0)<=12?z[((b<<2)+a|0)+4208>>2]:C(0))}function L1(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Mr(b,c,d,z[a+28>>2]);rH(a,b,c,d)}function J1(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Mr(b,c,d,z[a+24>>2]);oH(a,b,c,d)}function HW(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;if(rg(a,v[b+8>>2],0)){vv(b,c,d)}}function H1(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Mr(b,c,d,z[a+24>>2]);mH(a,b,c,d)}function zQ(a,b){var c=0,d=0;c=jb-16|0;jb=c;d=fO(a,b);jb=c+16|0;return d?b:a}function x7(a,b){a=a|0;b=b|0;return C((b|0)<=5?z[((b<<2)+a|0)+4208>>2]:C(0))}function w6(a,b){a=a|0;b=b|0;return C((b|0)<=3?z[((b<<2)+a|0)+4208>>2]:C(0))}function td(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=v[b+8>>2];_b(b,c);cv(a,b,d,c)}function pl(a,b){var c=0,d=0;c=jb-16|0;jb=c;d=Bt(b,a);jb=c+16|0;return d?b:a}function p7(a,b){a=a|0;b=b|0;return C((b|0)<=4?z[((b<<2)+a|0)+4208>>2]:C(0))}function nx(a,b){var c=0,d=0;c=jb-16|0;jb=c;d=Bt(a,b);jb=c+16|0;return d?b:a}function hz(a){a=a+4|0;return w[a|0]|w[a+1|0]<<8|(w[a+2|0]<<16|w[a+3|0]<<24)}function h7(a,b){a=a|0;b=b|0;return C((b|0)<=4?z[((b<<2)+a|0)+4220>>2]:C(0))}function bG(){a:{if(t[453544]&1){break a}if(!vd(453544)){break a}ud(453544)}}function aF(a,b){var c=0,d=0;ve(a,ke(b));b=v[jc(b)>>2];c=jc(a),d=b,v[c>>2]=d}function V6(a,b){a=a|0;b=b|0;return C((b|0)<=1?z[((b<<2)+a|0)+4208>>2]:C(0))}function UH(a,b,c,d){v[a+12>>2]=0;v[a+8>>2]=d;v[a+4>>2]=c;v[a>>2]=b;return a}function Pg(a){var b=0;b=jb-16|0;jb=b;a=v[Oc(b+8|0,a)>>2];jb=b+16|0;return a}function K7(a,b){a=a|0;b=b|0;return C((b|0)<=6?z[((b<<2)+a|0)+4208>>2]:C(0))}function Jl(a){var b=0;b=jb-16|0;jb=b;v[b+8>>2]=a;jb=b+16|0;return v[b+8>>2]}function Ix(a,b){if(b){Ix(a,v[b>>2]);Ix(a,v[b+4>>2]);Sv(jc(a),b+16|0);DK(b)}}function Dz(a,b){var c=0,d=0;c=jb-16|0;jb=c;d=fO(b,a);jb=c+16|0;return d?b:a}function DM(a){var b=0;b=jb-16|0;jb=b;FR(b+8|0,a);jb=b+16|0;return v[b+8>>2]}function D6(a,b){a=a|0;b=b|0;return C((b|0)<=2?z[((b<<2)+a|0)+4208>>2]:C(0))}function vO(a,b){cP(a,b);t[a+16|0]=w[b+16|0];v[a+12>>2]=v[b+12>>2];return a}function qt(a,b,c,d){a=c-b|0;if((a|0)>0){lc(v[d>>2],b,a);v[d>>2]=v[d>>2]+a}}function nh(a,b,c,d){a=c-b|0;c=v[d>>2]-a|0;v[d>>2]=c;if((a|0)>0){lc(c,b,a)}}function nK(a,b){a=a|0;b=b|0;return(b>>>0<=15?t[v[a+88>>2]+b|0]:63)<<24>>24}function mK(a,b){a=a|0;b=b|0;return(b>>>0<=42?t[v[a+84>>2]+b|0]:63)<<24>>24}function lD(a,b){a=a|0;b=b|0;var c=0;c=jb-16|0;jb=c;Bi(a,c+8|0,b);jb=c+16|0}function cE(a,b,c,d,e,f,g,h){return nb[v[v[a>>2]+16>>2]](a,b,c,d,e,f,g,h)|0}function Yq(a,b,c,d,e,f,g,h){return nb[v[v[a>>2]+12>>2]](a,b,c,d,e,f,g,h)|0}function QV(a,b){a=a|0;b=b|0;var c=0;c=jb-16|0;jb=c;nm(a,c+8|0,b);jb=c+16|0}function NA(a,b){a=a|0;b=b|0;a=v[a>>2];return nb[v[v[a>>2]+36>>2]](a,0,b)|0}function Li(a,b,c){v[a>>2]=b;b=v[b+4>>2];v[a+4>>2]=b;v[a+8>>2]=b+c;return a}function FQ(a){var b=0;while(1){b=a;a=v[a>>2];if(a){continue}break}return b}function wZ(a,b){a=a|0;b=b|0;if(b>>>0<=127){b=v[hr()+(b<<2)>>2]}return b|0}function uZ(a,b){a=a|0;b=b|0;if(b>>>0<=127){b=v[gr()+(b<<2)>>2]}return b|0}function pI(a,b){var c=0;c=v[a>>2];v[a>>2]=b;if(c){nb[v[v[c>>2]+4>>2]](c)}}function mg(a,b){var c=0;c=a;a=v[a+8>>2];b=a-b|0;v[c+8>>2]=a>>>0<b>>>0?0:b}function jg(a,b){a=a|0;b=b|0;if(In(a,b)){a=qh(Fe(a,b))}else{a=0}return a|0}function Rm(a,b){a=v[a+4276>>2];return(((a<<12&b>>31)+b|0)/4096|0)%(a|0)|0}function Qg(a,b,c){v[a+8>>2]=b;v[a+12>>2]=c;v[a>>2]=0;v[a+4>>2]=0;return a}function FM(a,b,c){var d=0;d=v[b+4>>2];v[a>>2]=v[b>>2];v[a+4>>2]=d;pO(a,c)}function Av(a,b){v[a+12>>2]=0;v[a+4>>2]=b;v[a>>2]=b;v[a+8>>2]=b+1;return a}function tV(a){a=a|0;var b=0;b=jb-16|0;jb=b;gc(a);Ff(b+8|0,a,1);jb=b+16|0}function ska(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=c,e=On(a,b),v[d>>2]=e}function pka(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=c,e=Bu(a,b),u[d>>1]=e}function pk(a,b){var c=0;c=v[b+4>>2];v[a>>2]=v[b>>2];v[a+4>>2]=c;return a}function jV(a){a=a|0;var b=0;b=jb-16|0;jb=b;gc(a);Xh(b+8|0,a,1);jb=b+16|0}function eV(a){a=a|0;var b=0;b=jb-16|0;jb=b;gc(a);Ug(b+8|0,a,1);jb=b+16|0}function eQ(a,b){t[a+6|0]=255;v[a+16>>2]=b;u[a+4>>1]=0;v[a>>2]=0;return a}function Yl(a,b,c){a=a|0;b=b|0;c=c|0;return nb[v[v[a>>2]+48>>2]](a,b,c)|0}function Yc(a,b,c,d,e){t[a+3|0]=e;t[a+2|0]=d;t[a+1|0]=c;t[a|0]=b;return a}function Xj(a,b,c){a=a|0;b=b|0;c=c|0;return nb[v[v[a>>2]+12>>2]](a,b,c)|0}function W1(a){a=a|0;var b=0;b=jb-16|0;jb=b;gc(a);et(b+8|0,a,1);jb=b+16|0}function FX(a,b,c){a=a|0;b=b|0;c=c|0;return nb[v[v[a>>2]+32>>2]](a,b,c)|0}function xB(a,b){return(w[a|0]|w[a+1|0]<<8)>>>0<(w[b|0]|w[b+1|0]<<8)>>>0}function qka(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=c,e=LR(a,b),t[d|0]=e}function nE(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Qg(a,-1,-1)}function nB(a,b){var c=0;c=jb-16|0;jb=c;fc(a,v[b>>2],oc(b)<<1);jb=c+16|0}function Z7(a,b){a=a|0;b=b|0;a=v[a+20>>2]+24|0;t[a|0]=w[a|0]&253|(b?2:0)}function Wz(a,b){var c=0;c=jb-16|0;jb=c;fc(a,v[b>>2],Kb(b)<<2);jb=c+16|0}function SR(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=c,e=LR(a,b),v[d>>2]=e}function I9(a,b,c){a=a|0;b=b|0;c=c|0;if(Db(b)>>>0>c>>>0){fr(b,c)}rd(a,b)}function sn(a){iR(a);if(v[a>>2]){fR(a,v[a>>2]);eR(zb(a),v[a>>2],Kl(a))}}function rN(a,b){v[a+4>>2]=0;v[a+8>>2]=0;v[a>>2]=b?b:49716;v[a+12>>2]=0}function qc(a,b){var c=0,d=0;v[a>>2]=b;c=a,d=cf(b),v[c+4>>2]=d;return a}function jQ(a){v[a+8>>2]=0;v[a>>2]=0;v[a+4>>2]=40;u[a+12>>1]=0;return a}function gN(a){if(a>>>0<=8){return w[a+25872|0]}return w[a+25863|0]|256}function dH(a){a=a|0;return+(+y[v[a+32>>2]+480240>>2]*152587890625e-16)}function Uw(a,b){a=a|0;b=b|0;nb[b|0](v[v[a>>2]-12>>2]+a|0)|0;return a|0}function Qv(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;v[e>>2]=c;return 3}function OQ(a){Ve(a);if(v[a>>2]){KQ(a,v[a>>2]);xj(zb(a),v[a>>2],nd(a))}}function OP(a){Eq(a);if(v[a>>2]){IP(a,v[a>>2]);Wu(zb(a),v[a>>2],Ui(a))}}function Kz(a){Gj(a);if(v[a>>2]){DQ(a,v[a>>2]);Ql(zb(a),v[a>>2],Yf(a))}}function Ji(a){Ve(a);if(v[a>>2]){vR(a,v[a>>2]);xj(zb(a),v[a>>2],nd(a))}}function FO(a){fj(a);if(v[a>>2]){BO(a,v[a>>2]);Ah(zb(a),v[a>>2],tg(a))}}function Aw(a){return((Mg(a)+(Mg(a)<<8)|0)+(Mg(a)<<16)|0)+(Mg(a)<<24)|0}function Aj(a){Gj(a);if(v[a>>2]){oB(a,v[a>>2]);Ql(zb(a),v[a>>2],Yf(a))}}function $D(a){u[a+12>>1]=0;v[a+8>>2]=-1;v[a>>2]=0;v[a+4>>2]=0;return a}function rv(a,b,c){if(!(v[a+28>>2]==1|v[a+4>>2]!=(b|0))){v[a+28>>2]=c}}function _R(a,b){Oj(a,Eb(v[b>>2]),Hb(b));a=v[a+4>>2];mb=a>>31;return a}function XE(a,b){if(b>>>0>357913941){fe(7217);L()}return be(B(b,12),4)}function Uj(a,b){a=a|0;b=b|0;t[a|0]=2;t[a+1|0]=3;t[a+2|0]=0;t[a+3|0]=4}function HL(a,b){if(b>>>0>178956970){fe(7217);L()}return be(B(b,24),8)}function Gx(a,b){A[a>>3]=A[b>>3]+A[a>>3];A[a+8>>3]=A[b+8>>3]+A[a+8>>3]}function Ez(a,b){if(b>>>0>214748364){fe(7217);L()}return be(B(b,20),4)}function C0(a){a=a|0;v[a+16>>2]=v[a+16>>2]|1;if(t[a+20|0]&1){Da();L()}}function Bc(a,b){if(Kb(a)>>>0<=b>>>0){eG();L()}return v[a>>2]+(b<<2)|0}function BC(a){v[a>>2]=0;v[a+4>>2]=0;v[a+8>>2]=0;v[a+12>>2]=0;return a}function xW(a){a=a|0;if(!a){return 0}return(wv(a,67260,67404)|0)!=0|0}function ZJ(a,b){if(b>>>0>82595524){fe(7217);L()}return be(B(b,52),4)}function Xr(a,b){a=a|0;b=b|0;var c=0;c=jb-16|0;jb=c;NP(a,b);jb=c+16|0}function Lg(a,b,c){return(x[v[a+8>>2]+((c&255)<<1)>>1]&b)!=0&(c|0)>=0}function KV(a,b){a=a|0;b=b|0;var c=0;c=jb-16|0;jb=c;sD(a,b);jb=c+16|0}function JS(a,b){if(b>>>0>715827882){fe(7217);L()}return be(B(b,6),1)}function Ci(a,b){return(v[a+4>>2]-v[b+4>>2]|0)+(v[a>>2]-v[b>>2]<<3)|0}function zH(a,b,c){a=a|0;b=b|0;c=c|0;v[b>>2]=v[c>>2];rd(b+4|0,c+4|0)}function u_(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;zf(a,f)}function tR(a,b){if(b>>>0>1073741823){fe(7217);L()}return be(b<<2,1)}function ko(a,b,c,d,e){b=Na(a|0,b|0,c|0,d|0,e|0)|0;mb=O()|0;return b}function kW(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return nb[a|0](b,c,d)|0}function jz(a,b){dc(a,b);dc(a+4|0,b+4|0);dc(zb(a),zb(b));zb(a);zb(b)}function iC(a,b){if(b>>>0>2147483647){fe(7217);L()}return be(b<<1,2)}function hl(a,b){return b?a<<8&16711680|a<<24|(a>>>8&65280|a>>>24):a}function _B(a,b){if(b>>>0>1073741823){fe(7217);L()}return be(b<<2,2)}function Po(a,b){if(b>>>0>1073741823){fe(7217);L()}return be(b<<2,4)}function Ny(a,b){Sl(a);bd(a+12|0);u[a+28>>1]=0;v[a+24>>2]=b;return a}function L0(a,b){a=a|0;b=b|0;if(!v[113382]){v[113383]=b;v[113382]=a}}function CZ(a){a=a|0;var b=0;b=v[113441]+1|0;v[113441]=b;v[a+4>>2]=b}function Ax(a,b,c){b=b-a|0;if(b){_i(c,a,b)}return B((b|0)/6|0,6)+c|0}function $C(a){if(a>>>0>178956970){fe(7217);L()}return be(B(a,24),4)}function vo(a,b,c){a=a|0;b=b|0;c=c|0;Te(a,b);Te(a+4|0,c);return a|0}function sL(a,b,c,d){v[a+12>>2]=0;v[a+8>>2]=d;v[a+4>>2]=c;v[a>>2]=b}function oK(a,b){a=a|0;b=b|0;return w[v[a+88>>2]+b|0]!=63&b>>>0<=15}function _O(a){if(a>>>0>76695844){fe(7217);L()}return be(B(a,56),4)}function Zn(a,b){if(b>>>0>134217727){fe(7217);L()}return be(b<<5,4)}function Z1(a){a=a|0;var b=0;b=jb-16|0;jb=b;gc(a);DH(a,1);jb=b+16|0}function P9(a,b){a=a|0;b=b|0;return w[v[a+84>>2]+b|0]!=63&b>>>0<=42}function MC(a,b){if(b>>>0>536870911){fe(7217);L()}return be(b<<3,1)}function Lq(a,b){if(b>>>0>268435455){fe(7217);L()}return be(b<<4,4)}function LO(a){a=a|0;v[a>>2]=71776;Sg(a+28|0);Sg(a+12|0);return a|0}function Gz(a,b){if(b){Gz(a,v[b>>2]);Gz(a,v[b+4>>2]);Xh(jc(a),b,1)}}function FL(a,b){if(b>>>0>134217727){fe(7217);L()}return be(b<<5,8)}function BD(a,b,c,d,e,f,g){return Ma(a|0,b|0,c|0,d|0,e|0,f|0,g|0)|0}function $0(a){a=a|0;var b=0;b=v[a+100>>2];v[a+100>>2]=0;return b|0}function wE(a,b,c){a=a|0;b=b|0;c=c|0;$t(a);t[a+128|0]=0;return a|0}function uO(a,b){ez(a,b);t[a+16|0]=w[b+16|0];v[a+12>>2]=v[b+12>>2]}function rZ(a,b,c){a=a|0;b=b|0;c=c|0;return(b>>>0<128?b:c)<<24>>24}function nn(a,b,c){return v[v[a>>2]+(b<<2)>>2]+(v[a+12>>2]+c<<2)|0}function ln(a){var b=0;b=v[a+20>>2];if(b){Wb(b+-64|0)}v[a+20>>2]=0}function XL(a,b){v[a+876>>2]=v[a+876>>2]+b;t[a+872|0]=w[a+872|0]|8}function Lm(a,b,c){return v[v[a>>2]+(b<<2)>>2]+(v[a+12>>2]+c<<1)|0}function HF(a,b,c){a=a|0;b=b|0;c=c|0;return xo(0,a,b,c?c:453568)|0}function Ela(a){a=a|0;return v[a+16>>2]+(v[a+8>>2]-v[a+20>>2]|0)|0}function Bf(a,b,c){a=a|0;b=b|0;c=c|0;return Lc(a,B(mk(a),b)+c|0)|0}function zB(a){if(v[a>>2]){kB(a,v[a>>2]);Xh(zb(a),v[a>>2],Wh(a))}}function uP(a){if(v[a>>2]){rP(a,v[a>>2]);xj(zb(a),v[a>>2],nd(a))}}function tj(a){a=v[a+656>>2];if(!a){return 0}return v[a+44>>2]!=0}function qS(a){mb=0;a=a+47|0;a=(w[a|0]|w[a+1|0]<<8)-98|0;return a}function bV(a){a=a|0;a=v[a+4>>2];return nb[v[v[a>>2]+12>>2]](a)|0}function bH(a){a=a|0;return+(+v[v[a+32>>2]+1074444>>2]*.00390625)}function aV(a){a=a|0;a=v[a+4>>2];return nb[v[v[a>>2]+16>>2]](a)|0}function VO(a){a=a+34|0;a=qma(w[a|0]|w[a+1|0]<<8,0,80,0);return a}function Iw(a){a=w[a+1|0];return(a&6)==6?384:1152>>>((a&14)==2)|0}function Bh(a,b){var c=0,d=0;c=a,d=fw(v[b>>2]),v[c>>2]=d;return a}function vs(a){yb(a+48|0);yb(a+36|0);yb(a+24|0);yb(a+12|0);yb(a)}function pda(a,b){a=a|0;b=b|0;bN(a,v[b>>2],v[b+4>>2]);return a|0}function kx(a){a=a|0;v[a>>2]=75392;fg(a+4260|0);rf(a);return a|0}function cn(a){var b=0;b=jb-16|0;jb=b;jb=b+16|0;return a<<24>>24}function cY(a){a=a|0;var b=0,c=0;b=a,c=ge(),v[b>>2]=c;return a|0}function cV(a){a=a|0;a=v[a+4>>2];return nb[v[v[a>>2]+8>>2]](a)|0}function Eb(a){a=a|0;var b=0;b=jb-16|0;jb=b;jb=b+16|0;return a|0}function yQ(a,b,c,d){af(a,b);u[a+18>>1]=d;u[a+16>>1]=c;return a}function wj(a,b,c){a=a|0;b=b|0;c=c|0;return Jz(Jl(a),Jl(b),c)|0}function tl(a){Nh(a);if(v[a>>2]){tK(a);Ff(zb(a),v[a>>2],Ye(a))}}function tL(a,b){var c=0;c=v[a>>2];v[a>>2]=b;if(c){vf(c);Wb(c)}}function rO(a){Ve(a);if(v[a>>2]){qO(a);xj(zb(a),v[a>>2],nd(a))}}function qn(a){Ve(a);if(v[a>>2]){bR(a);Du(zb(a),v[a>>2],nd(a))}}function pW(a,b){a=a|0;b=b|0;a=nb[a|0](b)|0;qa(mb|0);return a|0}function pM(a){Nh(a);if(v[a>>2]){ML(a);_o(zb(a),v[a>>2],Ye(a))}}function nr(a,b){a=a|0;b=b|0;return nb[v[v[a>>2]+44>>2]](a,b)|0}function kT(a){Gj(a);if(v[a>>2]){fT(a);Ql(zb(a),v[a>>2],Yf(a))}}function iw(a,b){a=a|0;b=b|0;return(eh(a)|0)!=0|(a|32)-97>>>0<6}function ie(a,b,c,d){v[a+8>>2]=d;v[a+4>>2]=c;v[a>>2]=b;return a}function g6(a,b){a=a|0;b=b|0;if(!b){return 3}v[b>>2]=a;return 0}function fg(a){Ve(a);if(v[a>>2]){CR(a);Se(zb(a),v[a>>2],nd(a))}}function dy(a){DS(a);if(v[a>>2]){TS(a);CS(zb(a),v[a>>2],Nl(a))}}function cy(a){eL(a);if(v[a>>2]){dL(a);Vx(zb(a),v[a>>2],lj(a))}}function bs(a){Ve(a);if(v[a>>2]){vJ(a);Se(zb(a),v[a>>2],nd(a))}}function aw(a,b){a=a|0;b=b|0;return nb[v[v[a>>2]+12>>2]](a,b)|0}function as(a){tJ(a);if(v[a>>2]){yJ(a);sJ(zb(a),v[a>>2],jk(a))}}function ZM(a,b){b=1/(564505.8718779281/b+1);WM(a,b,0,0,b+-1,0)}function ZI(a){a=a|0;return C(C(C(z[a+4228>>2]*C(198))+C(-99)))}function Ws(a){gm(a);if(v[a>>2]){yN(a);Ug(zb(a),v[a>>2],wh(a))}}function RM(a){fj(a);if(v[a>>2]){IM(a);Ah(zb(a),v[a>>2],tg(a))}}function Pk(a,b){a=a|0;b=b|0;return nb[v[v[a>>2]+28>>2]](a,b)|0}function Ko(a){a=a|0;return((a-65&255)>>>0<26?a+32|0:a)<<24>>24}function Kj(a){a=a|0;a=v[a>>2];return nb[v[v[a>>2]+24>>2]](a)|0}function Hl(a){Nh(a);if(v[a>>2]){gP(a);Ff(zb(a),v[a>>2],Ye(a))}}function $x(a){gm(a);if(v[a>>2]){fD(a);Ug(zb(a),v[a>>2],wh(a))}}function qq(a,b){var c=0;c=b+1|0;v[a>>2]=v[a>>2]>(c|0)?c:b+2|0}function pz(a,b){var c=0;c=jb-16|0;jb=c;fc(a,b,1024);jb=c+16|0}function iS(a){a=a|0;a=w[a|0];return Xd(a)^1|(a-49&255)>>>0<36}function fI(a,b,c,d){u[a+4>>1]=c;t[a+6|0]=b;v[a>>2]=d;return a}function Uz(a,b){var c=0;c=jb-16|0;jb=c;fc(a,b,4896);jb=c+16|0}function Qu(a){a=a|0;a=v[a>>2];return nb[v[v[a>>2]+8>>2]](a)|0}function Or(a){a=a|0;v[a>>2]=65192;yb(a+32|0);$k(a);return a|0}function KA(a,b){var c=0;c=jb-16|0;jb=c;fc(a,b,1954);jb=c+16|0}function Hf(a,b){a=a|0;b=b|0;a=Vu(a,b);if(!a){KC(b)}return a|0}function Gt(a,b){a=a|0;b=b|0;a=Aq(a,b);if(!a){wR(b)}return a|0}function F_(a,b,c){a=a|0;b=b|0;c=c|0;$c(a,wF(v[b>>2]),v[b>>2])}function Ef(a,b){return nb[v[v[a>>2]+36>>2]](a,v[a+12>>2],b)|0}function $aa(a,b){a=a|0;b=b|0;Bv(a,b);v[a>>2]=66860;return a|0}function zz(a,b){a=(a+b|0)-1|0;return a-((a>>>0)%(b>>>0)|0)|0}function yR(a,b){var c=0;c=jb-16|0;jb=c;fc(a,b,674);jb=c+16|0}function op(a,b){a=a|0;b=b|0;if(ue(a)>>>0>b>>>0){t[a+16|0]=b}}function oO(a,b){var c=0;c=jb-16|0;jb=c;fc(a,b,263);jb=c+16|0}function mR(a,b){var c=0;c=jb-16|0;jb=c;fc(a,b,128);jb=c+16|0}function gS(a,b){var c=0;c=jb-16|0;jb=c;fc(a,b,157);jb=c+16|0}function fja(a,b,c){a=a|0;b=b|0;c=c|0;rd(a,OD(c,Tb(b),Db(b)))}function eW(a,b){a=a|0;b=b|0;Bv(a,b);v[a>>2]=66968;return a|0}function eD(a,b){var c=0;c=v[a>>2];v[a>>2]=b;if(c){Wb(NC(c))}}function du(a,b){var c=0;c=jb-16|0;jb=c;fc(a,b,512);jb=c+16|0}function bS(a,b){var c=0;c=jb-16|0;jb=c;fc(a,b,576);jb=c+16|0}function YV(a,b){a=a|0;b=b|0;Bv(a,b);v[a>>2]=66916;return a|0}function YS(a,b){var c=0;c=jb-16|0;jb=c;fc(a,b,610);jb=c+16|0}function XO(a,b){var c=0;c=jb-16|0;jb=c;fc(a,b,146);jb=c+16|0}function VP(a,b){var c=0;c=jb-16|0;jb=c;fc(a,b,130);jb=c+16|0}function Tq(a,b){b=v[b>>2];v[a>>2]=b;v[a+4>>2]=b>>31;return a}function TP(a,b){var c=0;c=jb-16|0;jb=c;fc(a,b,600);jb=c+16|0}function TO(a,b){var c=0;c=jb-16|0;jb=c;fc(a,b,608);jb=c+16|0}function P3(a,b,c){a=a|0;b=b|0;c=c|0;eJ(a,0,_z(v[b+24>>2]),c)}function MD(a,b){if(Db(a)>>>0<=b>>>0){pm();L()}return kc(a,b)}function MB(a,b){var c=0;c=jb-16|0;jb=c;fc(a,b,497);jb=c+16|0}function LP(a,b){var c=0;c=jb-16|0;jb=c;fc(a,b,126);jb=c+16|0}function LM(a,b){return v[a>>2]==v[b>>2]&v[a+4>>2]==v[b+4>>2]}function Jda(a,b,c){a=a|0;b=b|0;c=c|0;return mh(a,b,c,1149)|0}function Ida(a,b,c){a=a|0;b=b|0;c=c|0;return mh(a,b,c,1150)|0}function Fda(a,b,c){a=a|0;b=b|0;c=c|0;return mh(a,b,c,1155)|0}function Dd(a,b){v[a>>2]=v[b>>2];v[a+4>>2]=v[b+4>>2];return a}function CO(a,b){var c=0;c=jb-16|0;jb=c;fc(a,b,204);jb=c+16|0}function AD(a,b,c){b=Ja(2047,a|0,b|0,c|0)|0;mb=O()|0;return b}function $p(a,b){var c=0;c=jb-16|0;jb=c;fc(a,b,192);jb=c+16|0}function wA(a,b){var c=0;c=jb-16|0;jb=c;fc(a,b,64);jb=c+16|0}function vq(a,b){var c=0;c=jb-16|0;jb=c;fc(a,b,36);jb=c+16|0}function vB(a,b){var c=0;c=jb-16|0;jb=c;fc(a,b,38);jb=c+16|0}function tB(a,b){var c=0;c=jb-16|0;jb=c;fc(a,b,41);jb=c+16|0}function sP(a,b){var c=0;c=jb-16|0;jb=c;fc(a,b,96);jb=c+16|0}function sB(a,b){var c=0;c=jb-16|0;jb=c;fc(a,b,16);jb=c+16|0}function rR(a,b){var c=0;c=jb-16|0;jb=c;fc(a,b,80);jb=c+16|0}function px(a){a=a|0;v[a+32>>2]=0;v[a+28>>2]=v[a+28>>2]&-7|2}function pu(a,b){var c=0;c=jb-16|0;jb=c;fc(a,b,65);jb=c+16|0}function pK(a,b){var c=0;c=jb-16|0;jb=c;fc(a,b,24);jb=c+16|0}function nka(a,b,c){a=a|0;b=b|0;c=c|0;return mh(a,b,c,673)|0}function nS(a,b){var c=0;c=jb-16|0;jb=c;fc(a,b,98);jb=c+16|0}function lS(a,b){var c=0;c=jb-16|0;jb=c;fc(a,b,48);jb=c+16|0}function lA(a,b){var c=0;c=jb-16|0;jb=c;fc(a,b,12);jb=c+16|0}function g9(a,b,c){a=a|0;b=b|0;c=c|0;return mh(a,b,c,1583)|0}function fH(a){a=a|0;return+(65536/+y[v[a+32>>2]+480244>>2])}function f9(a,b,c){a=a|0;b=b|0;c=c|0;return mh(a,b,c,1584)|0}function Xn(a,b,c){if(!b){return 0}return Dr(a,Hg(t[c|0]),b)}function XP(a,b){var c=0;c=jb-16|0;jb=c;fc(a,b,30);jb=c+16|0}function WC(a,b){var c=0;c=jb-16|0;jb=c;fc(a,b,10);jb=c+16|0}function WA(a,b){var c=0;c=jb-16|0;jb=c;fc(a,b,11);jb=c+16|0}function UC(a,b){var c=0;c=jb-16|0;jb=c;fc(a,b,14);jb=c+16|0}function Qt(a,b){var c=0;c=jb-16|0;jb=c;fc(a,b,66);jb=c+16|0}function Pc(a){return(a|0)<-32768?-32768:(a|0)>32767?32767:a}function Oz(a,b){var c=0;c=jb-16|0;jb=c;fc(a,b,33);jb=c+16|0}function Lt(a,b){var c=0;c=jb-16|0;jb=c;fc(a,b,22);jb=c+16|0}function LQ(a,b){var c=0;c=jb-16|0;jb=c;fc(a,b,52);jb=c+16|0}function LA(a){var b=0;b=jb-16|0;jb=b;Qb(a,0,1954);jb=b+16|0}function KP(a,b){var c=0;c=jb-16|0;jb=c;fc(a,b,32);jb=c+16|0}function Hz(a,b){var c=0;c=jb-16|0;jb=c;fc(a,b,40);jb=c+16|0}function Gv(){var a=0;a=ba(4)|0;Zk(a);ha(a|0,66740,1977);L()}function F9(a,b,c){a=a|0;b=b|0;c=c|0;return mh(a,b,c,1545)|0}function $M(a,b){var c=0;c=jb-16|0;jb=c;fc(a,b,27);jb=c+16|0}function xq(a,b){var c=0;c=jb-16|0;jb=c;fc(a,b,1);jb=c+16|0}function xh(a,b){var c=0;c=jb-16|0;jb=c;fc(a,b,4);jb=c+16|0}function xR(a){var b=0;b=jb-16|0;jb=b;Qb(a,0,192);jb=b+16|0}function vu(a,b){var c=0;c=jb-16|0;jb=c;fc(a,b,3);jb=c+16|0}function jZ(a,b,c){a=a|0;b=b|0;c=c|0;return((b|0)>=0?b:c)|0}function jA(a,b){var c=0;c=jb-16|0;jb=c;fc(a,b,6);jb=c+16|0}function hu(a,b){var c=0;c=jb-16|0;jb=c;fc(a,b,5);jb=c+16|0}function hk(a){var b=0;b=v[a>>2];v[a>>2]=0;if(b){Wb(qf(b))}}function hS(a){var b=0;b=jb-16|0;jb=b;Qb(a,0,157);jb=b+16|0}function eu(a,b){var c=0;c=jb-16|0;jb=c;fc(a,b,7);jb=c+16|0}function e8(a){a=a|0;a=kj(a);if(a){nb[v[v[a>>2]+92>>2]](a)}}function cS(a){var b=0;b=jb-16|0;jb=b;Qb(a,0,576);jb=b+16|0}function av(a){var b=0;b=a;a=v[a>>2]-1|0;v[b>>2]=a;return a}function aD(a){var b=0;b=v[a+8>>2];if(b){Ff(a,b,v[a+4>>2])}}function ZS(a){var b=0;b=jb-16|0;jb=b;Qb(a,0,610);jb=b+16|0}function YO(a){var b=0;b=jb-16|0;jb=b;Qb(a,0,146);jb=b+16|0}function WP(a){var b=0;b=jb-16|0;jb=b;Qb(a,0,130);jb=b+16|0}function Uu(a,b){var c=0;c=jb-16|0;jb=c;fc(a,b,8);jb=c+16|0}function UP(a){var b=0;b=jb-16|0;jb=b;Qb(a,0,600);jb=b+16|0}function UO(a){var b=0;b=jb-16|0;jb=b;Qb(a,0,608);jb=b+16|0}function Sk(a,b){var c=0;c=jb-16|0;jb=c;fc(a,b,2);jb=c+16|0}function SC(a){var b=0;b=v[a+8>>2];if(b){Xh(a,b,v[a+4>>2])}}function NB(a){var b=0;b=jb-16|0;jb=b;Qb(a,0,497);jb=b+16|0}function MP(a){var b=0;b=jb-16|0;jb=b;Qb(a,0,126);jb=b+16|0}function HC(a){var b=0;b=v[a+8>>2];if(b){Ug(a,b,v[a+4>>2])}}function DO(a){var b=0;b=jb-16|0;jb=b;Qb(a,0,204);jb=b+16|0}function BH(a){var b=0;b=v[a+8>>2];if(b){et(a,b,v[a+4>>2])}}function xC(a){var b=0;b=jb-16|0;jb=b;Qb(a,0,36);jb=b+16|0}function wB(a){var b=0;b=jb-16|0;jb=b;Qb(a,0,38);jb=b+16|0}function uB(a){var b=0;b=jb-16|0;jb=b;Qb(a,0,41);jb=b+16|0}function tP(a){var b=0;b=jb-16|0;jb=b;Qb(a,0,96);jb=b+16|0}function sm(a,b,c,d){v[a+16>>2]=d;v[a+12>>2]=c;v[a+8>>2]=b}function sR(a){var b=0;b=jb-16|0;jb=b;Qb(a,0,80);jb=b+16|0}function oW(a,b,c){a=a|0;b=b|0;c=c|0;return nb[a|0](b,c)|0}function oS(a){var b=0;b=jb-16|0;jb=b;Qb(a,0,98);jb=b+16|0}function nX(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;mb=0;return 0}function mS(a){var b=0;b=jb-16|0;jb=b;Qb(a,0,48);jb=b+16|0}function Tf(a,b){a=rma(v[a>>2],v[a+4>>2],b,b>>31);return a}function Q2(a){a=a|0;return y[v[a+24>>2]+1074420>>2]/1e4|0}function O3(a){a=a|0;gI(a,2,100);op(v[a+24>>2]+484360|0,0)}function MQ(a){var b=0;b=jb-16|0;jb=b;Qb(a,0,52);jb=b+16|0}function IS(a){var b=0;b=jb-16|0;jb=b;Qb(a,0,66);jb=b+16|0}function Db(a){if(he(a)){return v[a+4>>2]}return w[a+11|0]}function xs(a){if(v[a>>2]){bL(a);Se(zb(a),v[a>>2],nd(a))}}function vy(a,b){var c=0;c=v[a>>2];v[a>>2]=b;if(c){Wb(c)}}function rq(a){if(v[a>>2]){nC(a);cg(zb(a),v[a>>2],xf(a))}}function oj(a){a=v[a+656>>2];if(!a){return 0}return zi(a)}function fh(a,b,c){return v[a>>2]+(B(v[a+4>>2],c)+b<<3)|0}function ee(a){if(v[a>>2]){Se(zb(a),v[a>>2],v[zb(a)>>2])}}function dq(a){if(v[a>>2]){qB(a);Tn(zb(a),v[a>>2],Yf(a))}}function _d(a,b,c){$c(a,v[b>>2]+(c>>>3&536870908)|0,1<<c)}function TE(a){if(v[a>>2]){RE(a);tE(bl(a),v[a>>2],nd(a))}}function Sf(a,b,c){return v[a>>2]+(B(v[a+4>>2],c)+b<<2)|0}function Pn(a,b,c){$c(a,v[b>>2]+(c>>>3&536870908)|0,c&31)}function Jm(a,b,c){return v[a>>2]+(B(v[a+4>>2],c)+b<<1)|0}function JC(a,b,c){Uk(a,b);v[a+12>>2]=c;v[a+8>>2]=0;Bb(b)}function Iv(a,b,c){v[a+28>>2]=c;v[a+20>>2]=b;v[a+24>>2]=b}function IA(a){if(v[a>>2]){eT(a);cg(zb(a),v[a>>2],xf(a))}}function Fw(a,b){return v[((a>>>24^b)<<2)+452176>>2]^a<<8}function Ft(a){if(v[a>>2]){AR(a);St(zb(a),v[a>>2],Mi(a))}}function F2(a){a=a|0;return rj(Vb(v[a+24>>2]+484360|0))|0}function EH(a){var b=0;b=v[a+8>>2];if(b){DH(b,v[a+4>>2])}}function EG(a){while(1){if((Gr(a)|0)!=-1){continue}break}}function zV(a,b,c){a=a|0;b=b|0;c=c|0;cv(a,b,v[b+8>>2],c)}function wV(a){a=a|0;cD(a,4949);v[a>>2]=72128;return a|0}function vt(a){qn(a+88|0);qn(a+68|0);qn(a+48|0);return a}function oka(a,b){a=a|0;b=b|0;Ub(a,b?b:17540);return a|0}function mE(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Qg(a,-1,-1)}function ii(a){return xe(a)|xe(a)<<8|xe(a)<<16|xe(a)<<24}function f1(a,b,c){a=a|0;b=b|0;c=c|0;return kd(B(b,c))|0}function dS(a){a=a|0;if(!w[a|0]){return 1}return Wf(a)|0}function cu(a){t[a|0]=0;t[a+1|0]=0;t[a+2|0]=0;t[a+3|0]=0}function cm(a,b,c){a=rma(v[a>>2],v[a+4>>2],b,c);return a}function bha(a,b){a=a|0;b=b|0;return mF(a,Tb(b),Db(b))|0}function X3(a,b,c){a=a|0;b=b|0;c=c|0;rd(a,OD(c,b,cf(b)))}function QU(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;cv(a,b,c,d)}function QB(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;_e(a,c,d,b)}function Pja(a,b,c){a=a|0;b=b|0;c=c|0;return RA(a,b,c)|0}function Oka(a,b,c){a=a|0;b=b|0;c=c|0;return Dr(a,b,c)|0}function Mla(a,b,c){a=a|0;b=b|0;c=c|0;return SA(a,b,c)|0}function LU(a){a=a|0;cD(a,9340);v[a>>2]=72472;return a|0}function HE(a,b){km(v[b>>2]);jm(v[a>>2]);v[a>>2]=v[b>>2]}function Gy(a,b){A[a>>3]=A[a>>3]*b;A[a+8>>3]=A[a+8>>3]*b}function FD(a){a=v[a>>2]-12|0;if((av(a+8|0)|0)<0){Wb(a)}}function CE(a){a=a|0;v[a>>2]=59616;yb(a+12|0);return a|0}function BE(a){a=a|0;v[a>>2]=59656;yb(a+16|0);return a|0}function zv(a){a=a|0;v[a>>2]=66760;FD(a+4|0);return a|0}function yla(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;yA(b,c,d)}function yba(a,b){a=a|0;b=b|0;return y[a+12>>2]>b>>>0|0}function ur(a,b,c){return rF(Tb(a),Db(a),Tb(b),c,Db(b))}function mo(a){a=a|0;v[a>>2]=64936;Ob(a+4|0);return a|0}function iN(a,b,c){a=a|0;b=b|0;c=c|0;return Rs(a,b,c)|0}function eo(a){var b=0;b=v[a+8>>2];v[a+8>>2]=0;return b}function dA(a,b,c){a=a|0;b=b|0;c=c|0;return VA(a,b,c)|0}function bu(a,b,c){a=a|0;b=b|0;c=c|0;return gT(a,b,c)|0}function Vr(a){a=a|0;v[a>>2]=78824;$w(a+4|0);return a|0}function Uc(a,b,c){a=a|0;b=b|0;c=c|0;Te(a,b);return a|0}function T6(a){a=a|0;MI(a);t[a+4202|0]=1;v[a+4224>>2]=0}function Sq(a){a=a|0;v[a>>2]=66780;FD(a+4|0);return a|0}function QG(a,b,c){v[a+4>>2]=0;v[a>>2]=b;v[a+8>>2]=c<<3}function PF(a){return(a|0)!=0&(a|0)!=55248&(a|0)!=55272}function Jz(a,b,c){b=b-a|0;if(b){_i(c,a,b)}return b+c|0}function JI(a){return C(C(z[a+4208>>2]*C(1e4))+C(-1e4))}function JE(a){var b=0;b=v[a>>2];v[a>>2]=0;if(b){jm(b)}}function II(a){return C(C(z[a+4252>>2]*C(19980))+C(20))}function GO(a){a=a|0;v[a>>2]=71832;Sg(a+4|0);return a|0}function Fc(a){if(he(a)){a=hj(a)-1|0}else{a=10}return a}function FF(a,b,c,d){a=GF(a,b,c,0,-2147483648);return a}function FC(a){a=a|0;v[a>>2]=72396;Bb(a+4|0);return a|0}function Ed(a,b,c){return a>>>0<b>>>0?b:a>>>0>c>>>0?c:a}function $k(a){a=a|0;v[a>>2]=64872;Ob(a+4|0);return a|0}function vg(a,b){a=a|0;b=b|0;nb[v[v[b>>2]+20>>2]](a,b)}function rX(a){a=a|0;return Td(v[v[a>>2]-12>>2]+a|0)|0}function pX(a){a=a|0;return Mf(v[v[a>>2]-12>>2]+a|0)|0}function oo(a){if(he(a)){a=hj(a)-1|0}else{a=1}return a}function mN(a,b){u[a+20>>1]=x[a+20>>1]&768|b&255;Jy(a)}function jE(a){a=a|0;return cr(v[v[a>>2]-12>>2]+a|0)|0}function g0(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;oi(a,c,d)}function fW(a){a=a|0;a=nb[a|0]()|0;qa(mb|0);return a|0}function eE(a){a=a|0;return ar(v[v[a>>2]-12>>2]+a|0)|0}function dh(a,b){a=a|0;b=b|0;nb[v[v[b>>2]+24>>2]](a,b)}function ch(a,b){a=a|0;b=b|0;nb[v[v[b>>2]+28>>2]](a,b)}function c3(a,b){a=a|0;b=b|0;v[v[a+24>>2]+480272>>2]=b}function bj(a,b){v[a+16>>2]=!v[a+24>>2]|(v[a+16>>2]|b)}function Yb(a,b,c){return(a|0)<(b|0)?b:(a|0)>(c|0)?c:a}function XI(a){a=a|0;return Ai(C(z[a+4224>>2]*C(4)))|0}function Pu(a,b){a=qma(v[a>>2],v[a+4>>2],b,0);return a}function Mg(a){var b=0;b=Gr(a);v[a+1396>>2]=0;return b}function Do(a){return w[a+2|0]&2?(w[a+1|0]&6)==6?4:1:0}function ym(a,b){return nb[v[v[a>>2]+36>>2]](a,b,0)|0}function yb(a){if(he(a)){cg(a,v[a>>2],hj(a))}return a}function xm(a,b){return nb[v[v[a>>2]+52>>2]](a,b,0)|0}function wR(a){var b=0;b=jb-16|0;jb=b;cu(a);jb=b+16|0}function vc(a,b,c){a=a|0;b=b|0;c=c|0;$t(a);return a|0}function di(a){a=a|0;return nb[v[v[a>>2]+12>>2]](a)|0}function cma(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0}function ci(a){a=a|0;return nb[v[v[a>>2]+16>>2]](a)|0}function _e(a,b,c,d){t[a+8|0]=d;v[a+4>>2]=c;v[a>>2]=b}function YN(a,b){a=a|0;b=b|0;v[a>>2]=b;v[a+4>>2]=b+12}function Xm(a){a=a|0;return nb[v[v[a>>2]+24>>2]](a)|0}function VV(a,b){a=a|0;b=b|0;v[a>>2]=b;v[a+4>>2]=b+48}function QC(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function LV(a,b){a=a|0;b=b|0;v[a>>2]=b;v[a+4>>2]=b+36}function KC(a){var b=0;b=jb-16|0;jb=b;em(a);jb=b+16|0}function In(a,b){a=a|0;b=b|0;return Ae(a)>>>0>b>>>0|0}function F1(a,b){a=a|0;b=b|0;EM(v[a>>2],b);return a|0}function E2(a){a=a|0;return aK(v[a+24>>2]+484344|0)|0}function DN(a,b){a=a|0;b=b|0;v[a>>2]=b;v[a+4>>2]=b+24}function Aaa(a){a=a|0;z[a+12>>2]=1;JK(a,4);return a|0}function A8(a,b,c){a=a|0;b=b|0;c=c|0;Ll(a,b+4260|0,8)}function pma(a){if(a){return 31-E(a-1^a)|0}return 32}function l8(a){a=a|0;t[a+4202|0]=1;cs(a);ox(a);pJ(a)}function a9(a,b,c){a=a|0;b=b|0;c=c|0;z[b>>2]=z[c>>2]}function Zka(a){a=a|0;return kK(w[a+3|0],w[a+5|0])|0}function YI(a){a=a|0;return C(C(z[a+4216>>2]*C(10)))}function Xha(a,b){a=a|0;b=b|0;return mF(a,b,cf(b))|0}function Wm(a,b,c){a=a|0;b=b|0;c=c|0;v[b>>2]=v[c>>2]}function Wl(a,b,c){a=a|0;b=b|0;c=c|0;u[b>>1]=x[c>>1]}function R2(a){a=a|0;return v[v[a+24>>2]+1074416>>2]}function N2(a){a=a|0;return v[v[a+24>>2]+1074424>>2]}function B7(a){a=a|0;return C(C(z[a+4232>>2]*C(20)))}function zr(a){if(!a){return 0}v[113305]=a;return-1}function sy(a){a=a|0;return Ds(w[a+2|0],w[a+4|0])|0}function ro(a,b){b=v[b>>2];v[a>>2]=b;km(b);return a}function ol(a){a=a|0;return x[v[a+24>>2]+480192>>1]}function m1(a,b,c){a=a|0;b=b|0;c=c|0;_G(a-88|0,b,c)}function lm(a,b){af(a,b);Qb(a+16|0,0,1040);return a}function lJ(a){a=a|0;Sg(a+4208|0);rf(a);return a|0}
function ke(a){var b=0;b=v[a>>2];v[a>>2]=0;return b}function k1(a,b,c){a=a|0;b=b|0;c=c|0;YG(a-88|0,b,c)}function gda(a,b){a=a|0;b=b|0;v[b>>2]=0;v[b+4>>2]=0}function b3(a){a=a|0;return v[v[a+24>>2]+480272>>2]}function ao(a){a=a|0;a=gc(a);nb[v[v[a>>2]>>2]](a)|0}function aba(a){a=a|0;vf(80216);vf(80208);yb(80196)}function a4(a){a=a|0;a=v[a+4>>2];return(a?a:1518)|0}function Z6(a){a=a|0;return C(C(z[a+4232>>2]*C(4)))}function XM(a,b){v[a+8>>2]=0;v[a+12>>2]=0;A[a>>3]=b}function Uy(a,b){a=a|0;b=b|0;return $n(a,b,cf(b))|0}function Sm(a,b,c){if(!c){return 0}return md(a,b,c)}function Rr(a){a=a|0;return x[v[a+24>>2]+480190>>1]}function M2(a){a=a|0;return x[v[a+24>>2]+480214>>1]}function Ll(a,b,c){v[a>>2]=b;v[a+4>>2]=b+c;return a}function Jc(a){if(he(a)){no(v[a>>2],hj(a))}return a}function Gs(a){a=a|0;return Ds(w[a+3|0],w[a+5|0])|0}function Go(a){a=a|0;return x[v[a+24>>2]+480188>>1]}function Fb(a,b,c){$c(a,(c>>>3&536870908)+b|0,1<<c)}function E9(a,b){a=a|0;b=b|0;a=a+24|0;gK(a,b);_x(a)}function zl(a){wi(a+724|0);wi(a+736|0);wi(a+748|0)}function tM(a){return v[a+16>>2]!=(0-v[a+20>>2]|0)}function sx(a){a=a|0;fg(a+4208|0);rf(a);return a|0}function sha(a,b,c){a=a|0;b=b|0;c=c|0;_e(a,c,33,b)}function o1(a,b,c){a=a|0;b=b|0;c=+c;aH(a-88|0,b,c)}function l1(a,b){a=a|0;b=b|0;return ZG(a-88|0,b)|0}function kha(a,b,c){a=a|0;b=b|0;c=c|0;_e(a,c,24,b)}function j1(a,b){a=a|0;b=b|0;return WG(a-88|0,b)|0}function io(a,b,c){a=a|0;b=b|0;c=c|0;t[b|0]=w[c|0]}function iA(a,b,c){return a>>>0<c>>>0&a>>>0>=b>>>0}function hq(a,b,c){a=a|0;b=b|0;c=c|0;rd(a,AN(b,c))}function eO(a,b,c){a=a|0;b=b|0;c=c|0;rd(a,Uy(b,c))}function _y(a,b,c){a=a|0;b=b|0;c=c|0;pO(Dd(a,b),c)}function XG(a,b){RG(a,74);v[a+4>>2]=v[a+4>>2]|b&74}function Vz(a,b,c){Ll(a,v[b+28>>2]+(c<<12)|0,4096)}function Up(a){a=(a|0)<120?a:120;return(a|0)>1?a:1}function UI(a){a=a|0;fg(a+4256|0);rf(a);return a|0}function Raa(a,b){a=a|0;b=b|0;return lc(a,b,116)|0}function Op(a){return(v[a+480180>>2]&740327453)!=0}function Jja(a,b,c){a=a|0;b=b|0;c=c|0;_e(a,c,16,b)}function J9(a,b){a=a|0;b=b|0;Xi(a+36|0,b);return 1}function Ei(a,b,c){v[a>>2]=v[b>>2];t[a+4|0]=w[c|0]}function tg(a){return(v[zb(a)>>2]-v[a>>2]|0)/12|0}function so(a){return(v[gc(a)>>2]-v[a>>2]|0)/12|0}function se(a,b){a=a|0;b=b|0;return(a|0)==(b|0)|0}function pn(a){return(v[zb(a)>>2]-v[a>>2]|0)/56|0}function pS(a,b,c){a=a|0;b=b|0;c=c|0;_e(a,c,40,b)}function pH(a,b){Mw(v[v[a>>2]-12>>2]+a|0,v[b>>2])}function nG(a,b,c){v[a>>2]=b;v[a+4>>2]=c;return a}function lj(a){return(v[zb(a)>>2]-v[a>>2]|0)/52|0}function gG(a,b){if(!a){return 0}return dk(a,b,0)}function fn(a,b,c){A[a+8>>3]=c;A[a>>3]=b;return a}function Zt(a,b,c){a=a|0;b=b|0;c=c|0;_e(a,c,64,b)}function Zfa(a,b){a=a|0;b=b|0;return nb[b|0](a)|0}function Ye(a){return(v[zb(a)>>2]-v[a>>2]|0)/24|0}function Vl(a,b,c){a=a|0;b=b|0;c=c|0;_e(a,c,22,b)}function Vg(a,b){if(he(a)){ae(a,b);return}Ce(a,b)}function Ol(a){return(v[gc(a)>>2]-v[a>>2]|0)/24|0}function Nt(a,b,c){a=a|0;b=b|0;c=c|0;_e(a,c,28,b)}function Nl(a){return(v[zb(a)>>2]-v[a>>2]|0)/48|0}function Kl(a){return(v[zb(a)>>2]-v[a>>2]|0)/33|0}function KB(a){return!md(a,23458,25)&w[a+34|0]<65}function Ju(a,b,c){a=a|0;b=b|0;c=c|0;_e(a,c,26,b)}function Jk(a,b,c){a=a|0;b=b|0;c=c|0;_e(a,c,12,b)}function Gja(a,b){a=a|0;b=b|0;return ls(a,b,17)|0}function EA(a,b,c){a=a|0;b=b|0;c=c|0;_e(a,c,30,b)}function Dn(a,b,c){a=a|0;b=b|0;c=c|0;_e(a,c,20,b)}function Cg(a,b,c){a=a|0;b=b|0;c=c|0;_e(a,c,32,b)}function Cb(a){return(v[a+4>>2]&v[v[a>>2]>>2])!=0}function Ap(a){return(v[zb(a)>>2]-v[a>>2]|0)/20|0}function Aha(a,b,c){a=a|0;b=b|0;c=c|0;_e(a,c,9,b)}function $f(a,b){return rF(Tb(a),Db(a),b,0,cf(b))}function $c(a,b,c){v[a+4>>2]=c;v[a>>2]=b;return a}function vh(a){return(of(a)|0)!=(0-of(a+12|0)|0)}function sia(a,b){a=a|0;b=b|0;return Xl(a,b,2)|0}function n1(a,b){a=a|0;b=b|0;return+$G(a-88|0,b)}function bT(a,b){t[a|0]=w[b|0];t[a+1|0]=w[b+1|0]}function Wx(a){v[a+4>>2]=0;v[a+8>>2]=-1;t[a|0]=0}function Tb(a){if(he(a)){return v[a>>2]}return a}function TN(a,b){Oc(a,v[b>>2]);t[a+4|0]=w[b+4|0]}function Rka(a,b){a=a|0;b=b|0;return Xl(a,b,3)|0}function QR(a,b){a=a|0;b=b|0;return ls(a,b,32)|0}function Oy(a,b,c){t[a|0]=w[b|0];t[a+1|0]=w[c|0]}function Om(a){v[a>>2]=0;v[a+4>>2]=0;v[a+8>>2]=0}function Mi(a){return(v[zb(a)>>2]-v[a>>2]|0)/6|0}function MT(a,b){a=a|0;b=b|0;return ls(a,b,11)|0}function Kh(a){return v[a+8>>2]!=0|v[a+12>>2]!=0}function Jy(a){v[a+24>>2]=x[a+20>>1]<<x[a+22>>1]}function Fp(a,b,c){t[a+2|0]=c;u[a>>1]=b;return a}function Ala(a,b,c){a=a|0;b=b|0;c=c|0;lc(b,c,48)}function y9(a,b){a=a|0;b=b|0;return ls(a,b,1)|0}function xc(a){return(v[a+4>>2]-v[a>>2]|0)/12|0}function wk(a){return(v[a+4>>2]-v[a>>2]|0)/56|0}function tU(a,b){a=a|0;b=b|0;Tl(a,b);return a|0}function sh(a,b){a=a|0;b=b|0;return Xl(a,b,4)|0}function rm(a){return nb[v[v[a>>2]+28>>2]](a)|0}function r_(a,b){a=a|0;b=b|0;Kd(a,b,Fd(453572))}function q_(a,b){a=a|0;b=b|0;Kd(a,b,Fd(453580))}function p_(a,b){a=a|0;b=b|0;Kd(a,b,Fd(453776))}function o_(a,b){a=a|0;b=b|0;Kd(a,b,Fd(453768))}function n_(a,b){a=a|0;b=b|0;Kd(a,b,Fd(453784))}function mf(a){return(v[a+4>>2]-v[a>>2]|0)/52|0}function l_(a,b){a=a|0;b=b|0;Kd(a,b,Fd(453792))}function k_(a,b){a=a|0;b=b|0;Kd(a,b,Fd(453800))}function j_(a,b){a=a|0;b=b|0;Kd(a,b,Fd(453808))}function i_(a,b){a=a|0;b=b|0;Kd(a,b,Fd(453816))}function h_(a,b){a=a|0;b=b|0;Kd(a,b,Fd(453824))}function g_(a,b){a=a|0;b=b|0;Kd(a,b,Fd(453588))}function f_(a,b){a=a|0;b=b|0;Kd(a,b,Fd(453596))}function ew(a,b,c,d){a=GF(a,b,c,-1,-1);return a}function e_(a,b){a=a|0;b=b|0;Kd(a,b,Fd(453604))}function d_(a,b){a=a|0;b=b|0;Kd(a,b,Fd(453612))}function ck(a){a=a|0;return AF(v[a>>2])<<24>>24}function b_(a,b){a=a|0;b=b|0;Kd(a,b,Fd(453652))}function a_(a,b){a=a|0;b=b|0;Kd(a,b,Fd(453660))}function _Z(a,b){a=a|0;b=b|0;Kd(a,b,Fd(453676))}function YZ(a,b){a=a|0;b=b|0;Kd(a,b,Fd(453684))}function WZ(a,b){a=a|0;b=b|0;Kd(a,b,Fd(453692))}function Vs(a,b){a=a|0;b=b|0;zf(a,b);return a|0}function UZ(a,b){a=a|0;b=b|0;Kd(a,b,Fd(453700))}function SZ(a,b){a=a|0;b=b|0;Kd(a,b,Fd(453708))}function Rj(a){return nb[v[v[a>>2]+36>>2]](a)|0}function RZ(a,b){a=a|0;b=b|0;Kd(a,b,Fd(453620))}function QZ(a,b){a=a|0;b=b|0;Kd(a,b,Fd(453628))}function Ps(a,b){a=a|0;b=b|0;return(b-a|0)/12|0}function OZ(a,b){a=a|0;b=b|0;Kd(a,b,Fd(453636))}function Nw(a){var b=0;b=v[a>>2];xg(a);return b}function Ni(a){return(v[a+4>>2]-v[a>>2]|0)/48|0}function Mn(a,b){a=a|0;b=b|0;return Bf(a,b,0)|0}function MZ(a,b){a=a|0;b=b|0;Kd(a,b,Fd(453644))}function KZ(a,b){a=a|0;b=b|0;Kd(a,b,Fd(453716))}function JZ(a,b){a=a|0;b=b|0;Kd(a,b,Fd(453724))}function Gp(a,b,c){b=b-a|0;if(b){_i(c-b|0,a,b)}}function Eg(a,b){a=a|0;b=b|0;cG(a,v[a+16>>2]|b)}function EP(a,b){a=a|0;b=b|0;return Xl(a,b,8)|0}function Dl(a,b,c){a=a|0;b=b|0;c=c|0;return a|0}function D7(a){a=a|0;return z[a+4220>>2]<C(1)|0}function Cd(a){return(v[a+4>>2]-v[a>>2]|0)/24|0}function Ak(a){return(v[a+4>>2]-v[a>>2]|0)/33|0}function $Z(a,b){a=a|0;b=b|0;Kd(a,b,Fd(453668))}function $6(a){a=a|0;return z[a+4212>>2]<C(1)|0}function yp(a,b){return(B(b,104)+a|0)+484380|0}function vS(a){return v[a>>2]+(v[a+4>>2]<<2)|0}function v7(a){a=a|0;t[a+4202|0]=1;VI(a);WI(a)}function qN(a,b){kN(v[a>>2],b);kN(v[a+4>>2],b)}function n7(a){a=a|0;t[a+4202|0]=1;RI(a);QI(a)}function ms(a,b){return(v[a>>2]-v[b>>2]|0)/6|0}function hg(a){return(v[a+4>>2]-v[a>>2]|0)/6|0}function gk(a){return(v[a+4>>2]+v[a>>2]|0)-1|0}function fc(a,b,c){a=a|0;b=b|0;c=c|0;Ll(a,b,c)}function dN(a){cN(a);Qb(a+27|0,0,255);return a}function bo(a){ZC(a);v[a+8>>2]=0;v[a>>2]=52200}function TR(a){a=a|0;return(w[a+1|0]==1?1:2)|0}function Ss(a){return(a>>>0<9?a:a-9|256)&65535}function Re(a,b,c){if(!(w[a|0]&32)){ov(b,c,a)}}function K6(a){a=a|0;KI(a);hx(a);t[a+4202|0]=1}function Dk(a,b){t[a+4|0]=0;v[a>>2]=b;return a}function Be(a){return v[a+20>>2]!=0&v[a>>2]!=0}function A0(a,b,c){a=a|0;b=b|0;c=c|0;$c(a,c,b)}function zi(a){return(w[a+31|0]-1&255)>>>0<17}function zM(a,b){if(!(z[a>>2]<=b)){z[a>>2]=b}}function zA(a,b){a=a|0;b=b|0;return Vu(a,b)|0}function wo(a,b){a=a|0;b=b|0;return BF(a,b)^1}function tma(a,b,c,d){a=oma(a,b,c,d);return a}function tc(a,b){if(y[a>>2]>b>>>0){v[a>>2]=b}}function sg(a,b){if(x[a>>1]>b>>>0){u[a>>1]=b}}function qr(a,b){a=a|0;b=b|0;return yF(a,b)^1}function qX(a){a=a|0;bE(v[v[a>>2]-12>>2]+a|0)}function qM(a){pM(a+20|0);NL(a+8|0);vf(a+4|0)}function pN(a,b){a=a|0;b=b|0;return od(a,b)|0}function oX(a){a=a|0;aE(v[v[a>>2]-12>>2]+a|0)}function mia(a){a=a|0;lQ(a);return v[a+16>>2]}function lv(a,b){a=a|0;b=b|0;return Uy(a,b)|0}function lR(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function jk(a){return v[zb(a)>>2]-v[a>>2]>>11}function iE(a){a=a|0;Lv(v[v[a>>2]-12>>2]+a|0)}function hla(a,b,c){a=a|0;b=b|0;c=c|0;af(b,c)}function gj(a,b){a=a|0;b=b|0;return BF(a,b)|0}function dx(a){a=a|0;v[a>>2]=78692;return a|0}function dE(a){a=a|0;Kv(v[v[a>>2]-12>>2]+a|0)}function ak(a,b){a=a|0;b=b|0;return yF(a,b)|0}function Zs(a,b){a=a|0;b=b|0;return AN(a,b)|0}function Zg(a,b){a=a|0;b=b|0;return be(b,1)|0}function Yfa(a){a=a|0;Xy(a+288|0);vp(a+800|0)}function YC(a){a=a|0;v[a>>2]=72148;return a|0}function XB(a,b){a=a|0;b=b|0;return zu(a,b)|0}function WE(a,b,c){a=a|0;b=b|0;c=c|0;return-1}function Uf(a){v[a>>2]=0;v[a+4>>2]=0;return a}function Si(a,b){if(v[a>>2]>(b|0)){v[a>>2]=b}}function RC(a){a=a|0;v[a>>2]=72252;return a|0}function Qj(a,b){a=a|0;b=b|0;return Po(a,b)|0}function Pi(a,b){a=a|0;b=b|0;return GA(a,b)|0}function OS(a){t[a+12|0]=w[a+12|0]|2;return a}function Jb(a,b){a=a|0;b=b|0;return ks(a,b)^1}function Hi(a,b){a=a|0;b=b|0;return Jb(a,b)|0}function GC(a){a=a|0;v[a>>2]=72356;return a|0}function CH(a){a=a|0;v[a>>2]=78952;return a|0}function AH(a){a=a|0;v[a>>2]=78992;return a|0}function zD(a){a=Fa(a|0)|0;mb=O()|0;return a}function yg(a){return v[gc(a)>>2]-v[a>>2]>>2}function wh(a){return v[zb(a)>>2]-v[a>>2]>>5}function qx(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0}function qia(a){a=a|0;lQ(a);return v[a+4>>2]}function nd(a){return v[zb(a)>>2]-v[a>>2]>>2}function mv(a){return v[gc(a)>>2]-v[a>>2]>>4}function jx(a){return C(C(a*C(7900))+C(100))}function eA(a,b,c){a=a|0;b=b|0;c=c|0;kI(a,c)}function Zu(a){return v[gc(a)>>2]-v[a>>2]>>5}function Zja(a,b){a=a|0;b=b|0;Vp(Qb(b,0,48))}function Yz(a,b,c){a=a|0;b=b|0;c=c|0;zf(b,c)}function Yf(a){return v[zb(a)>>2]-v[a>>2]>>1}function Wh(a){return v[zb(a)>>2]-v[a>>2]>>4}function Uv(a,b,c){a=a|0;b=b|0;c=c|0;rd(b,c)}function Ui(a){return v[zb(a)>>2]-v[a>>2]>>3}function Rn(a){return v[gc(a)>>2]-v[a>>2]>>1}function P2(a){a=a|0;return LH(v[a+24>>2])|0}function P0(a){a=a|0;return _a(v[a+60>>2])|0}function GJ(a,b,c){a=a|0;b=b|0;c=c|0;Jp(b,c)}function Bi(a,b,c){a=a|0;b=b|0;c=c|0;Us(a,c)}function Ag(a){return v[v[a+8>>2]>>2]==(a|0)}function xf(a){return v[zb(a)>>2]-v[a>>2]|0}function vI(a){return Lh(C(xI(a)*C(32768)))}function si(a,b){a=a|0;b=b|0;return C(C(0))}function qg(a,b,c){return Oa(a|0,b|0,c|0)|0}function of(a){return v[a+4>>2]-v[a>>2]>>11}function oN(a,b){u[a+22>>1]=b&7;Jy(a);Ky(a)}function oA(a){return v[gc(a)>>2]-v[a>>2]|0}function iL(a){return a>>>0<=255&a>>>0>=251}function fl(a){a=a|0;Zv(v[a>>2]);return a|0}function _I(a){a=a|0;return C(z[a+4208>>2])}function _6(a){a=a|0;return C(z[a+4220>>2])}function XD(a){GH(a);v[a>>2]=65328;return a}function We(a,b){if(w[a|0]>b>>>0){t[a|0]=b}}function T2(a){a=a|0;return+mL(v[a+24>>2])}
function Sr(a){GH(a);v[a>>2]=65256;return a}function RG(a,b){v[a+4>>2]=v[a+4>>2]&(b^-1)}function N0(a,b){a=a|0;b=b|0;return eh(a)|0}function IF(){return(v[v[113364]>>2]?4:1)|0}function G1(a){a=a|0;RG(a,16384);return a|0}function EZ(){ro(453752,KE());return 453752}function Cm(a){a=a|0;wF(v[a>>2]);return a|0}function C7(a){a=a|0;return C(z[a+4212>>2])}function A1(a){a=a|0;Mw(a,16384);return a|0}function $I(a){a=a|0;nb[v[v[a>>2]+4>>2]](a)}function yu(a){a=a|0;return bh(a,453776)|0}function w8(a,b){a=a|0;b=b|0;t[a+4201|0]=b}function vl(a){yb(a+36|0);ze(a+24|0);Ml(a)}function ut(a,b){return v[a>>2]-v[b>>2]>>2}function ue(a){return v[a+4>>2]-v[a>>2]>>5}function sV(a){a=a|0;return v[a+4>>2]!=0|0}function oc(a){return v[a+4>>2]-v[a>>2]>>1}function o4(a,b){a=a|0;b=b|0;Jv(a,x[b>>1])}function nN(a,b){t[a+21|0]=b&3;Jy(a);Ky(a)}function m2(a,b){a=a|0;b=b|0;return b-a>>3}function jd(a){return v[a+4>>2]-v[a>>2]>>4}function jI(a,b){a=a|0;b=b|0;Jv(a,v[b>>2])}function ir(a,b){nb[v[v[b>>2]+40>>2]](a,b)}function hj(a){return v[a+8>>2]&2147483647}function gz(a){ee(a+24|0);$d(a+12|0);$d(a)}function dB(a){return w[a+1|0]==2&w[a|0]<3}function cw(a){a=a|0;return bh(a,453816)|0}function _u(a){Fq(a+28|0);Bb(a+12|0);yb(a)}function Yv(a){a=a|0;return bh(a,453768)|0}function Yp(a,b){return v[a>>2]-v[b>>2]>>1}function Xv(a){a=a|0;return bh(a,453824)|0}function U7(a,b,c){a=a|0;b=b|0;c=c|0;Uf(a)}function Tj(a,b){nb[v[v[b>>2]+44>>2]](a,b)}function Sj(a,b){nb[v[v[b>>2]+32>>2]](a,b)}function Qr(a){return(a|0)<=65535&(a|0)>=0}function PX(a){a=a|0;return bh(a,453588)|0}function Laa(a,b){a=a|0;b=b|0;Xi(a+40|0,b)}function Kb(a){return v[a+4>>2]-v[a>>2]>>2}function Ig(a){return v[a+4>>2]-v[a>>2]>>3}function Hv(a){a=a|0;return bh(a,453784)|0}function Dv(a){a=a|0;return bh(a,453792)|0}function DX(a){a=a|0;return bh(a,453604)|0}function BI(a){return C(C(a*C(96))+C(-96))}function zN(a){v[a>>2]=v[a>>2]-2;return a}function x9(a,b){a=a|0;b=b|0;zf(a,b+36|0)}function wc(a){return v[a+4>>2]-v[a>>2]|0}function w1(a,b){a=a|0;b=b|0;iH(a-88|0,b)}function v1(a,b){a=a|0;b=b|0;hH(a-88|0,b)}function tC(a){return(w[a+24|0]&16)>>>4|0}function re(a){v[a>>2]=v[a>>2]+2;return a}function r8(a,b){a=a|0;b=b|0;Qb(b,0,2048)}function qm(a,b,c){oi(a,b,b+c|0);return a}function qT(a,b){a=a|0;b=b|0;Xi(a+12|0,b)}function od(a,b){return v[a>>2]+B(b,12)|0}function jR(a,b){return v[a>>2]+B(b,33)|0}function is(a,b,c){return u[b>>1]<u[c>>1]}function h1(a,b){a=a|0;b=b|0;UG(a-88|0,b)}function el(a){a=a|0;return xF(v[a>>2])|0}function dn(a,b,c){return a<b?b:C(F(a,c))}function dm(a,b){return v[a>>2]-v[b>>2]|0}function cr(a){a=a|0;_g(a+8|0);return a|0}function bm(a,b){return v[a>>2]+(b<<11)|0}function ar(a){a=a|0;_g(a+4|0);return a|0}function a1(a){a=a|0;if(a){IG(a);Sd(a,a)}}function Un(a,b,c){return x[b>>1]<x[c>>1]}function Um(a){return v[v[a+48>>2]+12>>2]}function U4(a,b){a=a|0;b=b|0;Jv(a,w[b|0])}function Qc(a,b){return v[a>>2]+B(b,24)|0}function Pw(a){a=a|0;Tr(a+8|0);return a|0}function PY(a,b){a=a|0;b=b|0;zf(a,b+16|0)}function KH(a,b){a=a|0;b=b|0;zf(a,b+12|0)}function JM(a){v[a>>2]=v[a>>2]-4;return a}function Hd(a,b){v[a>>2]=v[b>>2];return a}function Gl(a,b){return v[a>>2]+B(b,56)|0}function Fe(a,b){return v[a>>2]+B(b,52)|0}function Bz(a,b){return v[a>>2]+B(b,20)|0}function An(a){return x[a+480190>>1]<3999}function Ac(a,b){a=a|0;b=b|0;ro(a,b+28|0)}function AN(a,b){return $n(a,Tb(b),Db(b))}function AK(a,b){fn(a,A[b>>3],-A[b+8>>3])}function AI(a){a=a|0;Qb(a+4296|0,0,81928)}function zha(a,b){a=a|0;b=b|0;$c(a,b,10)}function xu(a,b){return v[a>>2]+(b<<5)|0}function xt(a){a=a|0;return v[a>>2]+14|0}function uja(a,b){a=a|0;b=b|0;$c(a,b,17)}function u1(a,b){a=a|0;b=+b;gH(a-88|0,b)}function sc(a,b){return v[a>>2]+(b<<4)|0}function s1(a,b){a=a|0;b=+b;eH(a-88|0,b)}function rc(a,b){return v[a>>2]+(b<<1)|0}function q1(a,b){a=a|0;b=+b;cH(a-88|0,b)}function mk(a){return x[Um(a)+480188>>1]}function ks(a,b){return v[a>>2]==v[b>>2]}function jl(a){return(a|0)==32|a-9>>>0<5}function id(a){return v[a>>2]==v[a+4>>2]}function fJ(a){return(w[a+24|0]&8)>>>3|0}function bn(a){a=a|0;return nM(w[a|0])|0}function bD(a,b){dc(a,b);dc(a+4|0,b+4|0)}function ama(a,b){a=a|0;b=b|0;$c(a,b,44)}function aI(a){return(Tb(a)+Db(a)|0)-1|0}function ZC(a){v[a+4>>2]=0;v[a>>2]=52144}function Wn(a){return B(uq(a),te(a))&255}function Wf(a){a=a|0;return Xd(w[a|0])|0}function Vk(a,b){return v[a>>2]+(b<<3)|0}function QE(){Gd(455208);v[113802]=62556}function Pb(a,b){return v[a>>2]+(b<<2)|0}function PE(){Gd(455240);v[113810]=63052}function OE(){Gd(455248);v[113812]=63216}function NY(a,b){a=a|0;b=b|0;Ov(a,59688)}function NE(){Gd(455256);v[113814]=63380}function Mb(a){v[v[a>>2]+4>>2]=v[a+4>>2]}function ME(){Gd(455264);v[113816]=63544}function Lc(a,b){return v[a>>2]+B(b,6)|0}function LY(a,b){a=a|0;b=b|0;Ov(a,59708)}function LE(){Gd(455336);v[113834]=63708}function L8(a){a=a|0;iT(a,80,150,80,255)}function Jf(a){a=a|0;return!v[a+16>>2]|0}function I6(a){a=a|0;return v[a+4260>>2]}function Gf(a,b){v[a+8>>2]=b|-2147483648}function B1(a){a=a|0;return Pw(a-88|0)|0}function $q(a,b){v[a+24>>2]=v[a+24>>2]+b}function yT(a,b){a=a|0;b=b|0;$c(a,b,11)}function yB(a,b){a=a|0;b=b|0;return b|0}function wi(a){v[a+4>>2]=0;v[a+8>>2]=-1}function v8(a){a=a|0;return w[a+4201|0]}function u8(a){a=a|0;return w[a+4202|0]}function nq(a,b){a=a|0;b=b|0;$c(a,b,32)}function ki(a,b,c){rd(a,b);rd(a+12|0,c)}function k6(a){a=a|0;return(a|0)==277|0}function jM(a,b){return(vk(a,b)|0)!=255}function hha(a,b){a=a|0;b=b|0;$c(a,b,5)}function hF(a,b){a=a|0;b=b|0;Fj(a,1,45)}function gF(a,b){a=a|0;b=b|0;qF(a,1,45)}function dda(a,b){a=a|0;b=b|0;fn(b,0,0)}function cq(a,b){return v[a>>2]<v[b>>2]}function Wt(a){a=a|0;return sA(oc(a))|0}function WR(a,b){v[a>>2]=v[a>>2]+B(b,6)}function T1(a){a=a|0;XG(a,2);return a|0}function Su(a,b){return y[a>>2]<y[b>>2]}function Sd(a,b){if(!v[a+80>>2]){Wb(b)}}function OY(a,b){a=a|0;b=b|0;Ub(a,7314)}function O1(a){a=a|0;XG(a,8);return a|0}function MY(a,b){a=a|0;b=b|0;Ub(a,7431)}function IQ(a,b){v[a>>2]=v[a>>2]+(b<<2)}function Ey(a,b,c){if(b){Qb(a,Hg(c),b)}}function Bt(a,b){return z[a>>2]<z[b>>2]}function BL(a,b){return A[a>>3]<A[b>>3]}function zj(a){return B(v[a>>2],Wn(a))}function ys(a){a=a|0;return 2147483647}function yc(a){v[v[a+8>>2]>>2]=v[a>>2]}function xU(a){a=a|0;return v[a+12>>2]}function ty(a,b,c){return a<b?b:F(a,c)}function te(a){return w[a+34|0]&64?2:1}function t6(a){a=a|0;return-2013527448}function t1(a){a=a|0;return+fH(a-88|0)}function r1(a){a=a|0;return+dH(a-88|0)}function qha(a){a=a|0;return w[a+40|0]}function pU(a){a=a|0;return v[a+24>>2]}function p1(a){a=a|0;return+bH(a-88|0)}function ij(a,b){return Tb(a)+(b<<2)|0}function cD(a,b){ID(a,b);v[a>>2]=67020}function a3(a){a=a|0;return+A[a+16>>3]}function _fa(a){a=a|0;kO(a);return a|0}function _U(a){a=a|0;return v[a+16>>2]}function ZX(a){a=a|0;return v[a+20>>2]}function YT(a,b){a=a|0;b=b|0;u[b>>1]=0}function YB(a){zb(a);return 2147483647}function Xd(a){return(a-1&255)>>>0<120}function UR(a,b){a=a|0;b=b|0;_r(a,0,b)}function Mw(a,b){v[a+4>>2]=v[a+4>>2]|b}function FN(a,b){v[a+4>>2]=b;v[a>>2]=b}function FH(a){return a?(a|0)==2?3:2:1}function yF(a,b){return pE(a)^pE(b)^1}function uq(a){return t[a+34|0]&1?2:1}function u7(a){a=a|0;return-285139079}function tI(a,b){a=a|0;b=b|0;return 0}function rx(a,b){a=a|0;b=b|0;return 1}function nw(a){a=a|0;Sq(a);return a|0}function l7(a){a=a|0;return-284078960}function kH(a){v[a>>2]=79640;return a}function iX(a){a=a|0;return VD(a,0)|0}function i6(a,b){a=a|0;b=b|0;return 3}function hw(a){a=a|0;if(PF(a)){Wb(a)}}function he(a){return w[a+11|0]>>>7|0}function hX(a){a=a|0;return VD(a,1)|0}function h6(a,b){a=a|0;b=b|0;return 2}function eX(a){a=a|0;return SD(a,0)|0}function eC(a){return w[a+22|0]>>>7|0}function e7(a){a=a|0;return-281111764}function dr(a,b){a=a|0;b=b|0;return-1}function dX(a){a=a|0;return SD(a,1)|0}function dG(a){a=a|0;nw(a);return a|0}function a7(a){a=a|0;return-271958638}function _z(a){return v[a+1304496>>2]}function _la(a,b){a=a|0;b=b|0;Uq(a,b)}function _g(a){a=a|0;qw(a);return a|0}function Vb(a){return xu(a,w[a+16|0])}function VN(a){a=a|0;JP(a);return a|0}function Tz(a){a=a|0;return Rb(a,1)^1}function S6(a){a=a|0;return-620920304}function Mz(a){a=a|0;return v[a+8>>2]}function Mt(a){return(w[a+16|0]&5)!=0}function Me(a,b){v[a+4>>2]=b;return a}function LH(a){return x[a+1074438>>1]}function Kja(a){a=a|0;return w[a+8|0]}function J6(a){a=a|0;return-275227023}function Iu(a){return w[a+21|0]>>>7|0}function Fk(a){a=a|0;It(a);return a|0}function F7(a){a=a|0;return-270114148}function Ep(a){a=a|0;wt(a);return a|0}function Dt(a){a=a|0;return v[a+4>>2]}function CD(a,b){return w[a|0]<w[b|0]}function Bn(a,b){u[a+8>>1]=b;return a}function BF(a,b){return qE(a)^qE(b)^1}function A6(a){a=a|0;return 302837129}function $7(a){a=a|0;return 542066252}function yI(a){v[a>>2]=0;v[a+4>>2]=0}function vx(a,b){Kb(a);BR(a,b);ng(a)}function qaa(a){a=a|0;return Ih(a)|0}function nP(a){return v[a+4>>2]-56|0}function nM(a){return(a+5&255)>>>0<2}function mka(a){a=a|0;return _z(a)|0}function km(a){v[a+4>>2]=v[a+4>>2]+1}function ht(a){return v[zb(a)>>2]<<5}function ed(a,b){return bm(a+12|0,b)}function dK(a,b){mf(a);cL(a,b);$J(a)}function aL(a,b){Kb(a);KK(a,b);ng(a)}function aA(a,b){hg(a);zR(a,b);pR(a)}function Zy(a,b){a=a|0;b=b|0;Yy(a,b)}function Wg(a){return v[a+4>>2]-32|0}function Vt(a){return v[a+4>>2]-24|0}function Us(a,b){a=a|0;b=b|0;zf(a,b)}function UA(a,b){a=a|0;b=b|0;TA(a,b)}function T7(a,b,c){a=a|0;b=b|0;c=c|0}function SE(a,b){a=a|0;b=b|0;Sv(a,b)}function RY(a){a=a|0;return t[a+8|0]}function QY(a){a=a|0;return t[a+9|0]}function P7(a,b){a=a|0;b=b|0;Vs(a,b)}function Nca(a){a=a|0;return Kj(a)|0}function Mu(a,b){wc(a);mC(a,b);wp(a)}function MH(a){return v[a+4>>2]-48|0}function Ku(a,b){Kb(a);$B(a,b);ng(a)}function Kn(a,b){oc(a);LB(a,b);Jn(a)}function JH(a){return v[a+4>>2]-12|0}function DR(a,b){wc(a);$S(a,b);wp(a)}function CN(a,b){ue(a);xN(a,b);dv(a)}function Bs(a){return(a|0)<0?0-a|0:a}function yq(a){a=a|0;return le(a)|0}function yja(a,b){a=a|0;b=b|0;dR(b)}function yD(a){a=a|0;return v[a>>2]}function un(a,b,c){return Un(a,b,c)}function uc(a,b){return v[a>>2]+b|0}function qC(a){a=a|0;return og(a)|0}function pj(a){return v[a+4>>2]-4|0}function oT(a){a=a|0;return Qu(a)|0}function kf(a,b,c){return Jz(a,b,c)}function gha(a,b){a=a|0;b=b|0;gz(b)}function gC(a){return w[a+21|0]&127}function fC(a){return w[a+22|0]&127}function cF(a){return bh(a,453660)}
function bc(a){return Pg(v[a+4>>2])}function am(a,b,c){if(c){_i(a,b,c)}}function ag(a,b,c){if(c){lc(a,b,c)}}function _ca(a,b){a=a|0;b=b|0;ee(b)}function ZB(a){t[a+2|0]=0;u[a>>1]=0}function Y0(a){a=a|0;return Mt(a)|0}function Xca(a,b){a=a|0;b=b|0;jt(b)}function XN(a,b){return sp(a,0-b|0)}function Ue(a){return v[a+24620>>2]}function SV(a){a=a|0;return JG(a)|0}function R6(a){a=a|0;v[a+4224>>2]=0}function QQ(a){a=a|0;return xt(a)|0}function Oc(a,b){v[a>>2]=b;return a}function NV(a){a=a|0;return Pe(a)|0}function Gi(a,b){return B(b,12)+a|0}function Et(a){a=a|0;return lh(a)|0}function Eaa(a,b){a=a|0;b=b|0;vl(b)}function Dw(a){return!md(a,79716,6)}function Daa(a,b){a=a|0;b=b|0;gg(b)}function Cs(a){return bp(a)<<24>>24}function Az(a,b){return ff(a,0-b|0)}function Ada(a,b){a=a|0;b=b|0;El(b)}function AV(a){a=a|0;return Df(a)|0}function zt(a,b){a=a|0;b=b|0;cu(b)}function xk(a,b){Pn(a,b,v[b+4>>2])}function xi(a,b){return(b<<13)+a|0}function vU(a,b){a=a|0;b=b|0;ZB(b)}function ri(a){a=a|0;t[a+4202|0]=0}function ou(a){t[a|0]=0;t[a+1|0]=0}function oV(a,b){a=a|0;b=b|0;_u(b)}function mi(a){return id(a+36|0)^1}function lh(a){return v[a>>2]+16|0}function lB(a,b){a=a|0;b=b|0;ou(b)}function kr(a,b){a=a|0;b=b|0;sf(a)}function jB(a,b){a=a|0;b=b|0;Bb(b)}function e1(a,b){a=a|0;b=b|0;Wb(b)}function bW(a,b){a=a|0;b=b|0;$D(b)}function bF(a){return bh(a,453652)}function Zq(a){return se(a,-1)?0:a}function Zk(a){Pm(a);v[a>>2]=66668}function ZE(a){return bh(a,453676)}function YE(a){return bh(a,453668)}function WT(a,b){a=a|0;b=b|0;Vh(b)}function Vj(a,b){a=a|0;b=b|0;Xb(a)}function U1(a,b){a=a|0;b=b|0;Bk(b)}function Mm(a,b){v[a+1304560>>2]=b}function Lw(a){a=a|0;t[a+6152|0]=0}function Le(a,b){$t(a);Oc(a+4|0,b)}function LN(a,b){t[v[a>>2]]=w[b|0]}function LC(a,b){a=a|0;b=b|0;em(b)}function Kg(a,b){v[a>>2]=v[a>>2]|b}function Hh(a,b){$c(a,Tb(b),Db(b))}function Gn(a,b){a=a|0;b=b|0;lf(b)}function Gd(a){ZC(a);v[a>>2]=59944}function $y(a,b){a=a|0;b=b|0;jf(b)}function zga(a){a=a|0;GO(a);Wb(a)}function vn(a){v[a>>2]=v[a>>2]+12}function vha(a){a=a|0;SQ(a,65535)}function uv(a,b){return v[a+b>>2]}function kc(a,b){return Tb(a)+b|0}function iB(a,b){return gu(a,b,7)}function hJ(a){return a+1074332|0}function hB(a){return w[a+1|0]==1}function fQ(a,b){return Xl(a,b,5)}function fB(a,b){return Xl(a,b,7)}function eh(a){return a-48>>>0<10}function cx(a,b){return Jx(a,b)^1}function ac(a){return Pg(v[a>>2])}function _m(a){return a+1074328|0}function _c(a,b){return(b<<1)+a|0}function Yw(a){return a+1304500|0}function Ym(a){Sg(a+4|0);return a}function Xf(a){v[a>>2]=v[a>>2]+16}function Xe(a,b){return(b<<2)+a|0}function Xaa(a){a=a|0;lg(a,rj(a))}function TV(a){a=a|0;yn(a,1,9453)}function Sy(a,b){rd(a,b);return a}function Rh(a){v[a>>2]=1;return a}function QO(a,b){return gu(a,b,4)}function Ou(a){return t[a+24|0]&1}function Nk(a,b){af(a,b);return a}function My(a){v[a>>2]=v[a>>2]+32}function Kk(a){v[a>>2]=v[a>>2]+24}function Ke(a){return v[jc(a)>>2]}function Jt(a,b){return Pd(a,b)^1}function Ik(a){v[a>>2]=0;return a}function Dga(a){a=a|0;LO(a);Wb(a)}function Cy(a){v[a>>2]=v[a>>2]+52}function Cn(a){v[a>>2]=2;return a}function Bl(a){u[a>>1]=0;return a}function Ae(a){return mf(a)&65535}function $P(a,b){return(b<<4)+a|0}function yv(a){a=a|0;zv(a);Wb(a)}function xg(a){v[a>>2]=v[a>>2]+1}function wy(a){t[a|0]=0;return a}function wQ(a){Ap(a);Ap(a);qQ(a)}function w0(a){a=a|0;return 9161}function uA(a){Ni(a);TS(a);SS(a)}function u0(a){a=a|0;return 6374}function ti(a){Kb(a);CR(a);ng(a)}function tJ(a){jk(a);of(a);jk(a)}function qd(a){return v[a>>2]!=0}function os(a){return iL(w[a|0])}function ik(a){a=a|0;rf(a);Wb(a)}function iR(a){Kl(a);Ak(a);Kl(a)}function iP(a){pn(a);wk(a);pn(a)}function iK(a){hg(a);AR(a);pR(a)}function iI(a){a=a|0;ex(a);Wb(a)}function gm(a){wh(a);ue(a);wh(a)}function fj(a){tg(a);xc(a);tg(a)}function eL(a){lj(a);mf(a);lj(a)}function e4(a){a=a|0;dx(a);Wb(a)}function cR(a){Kb(a);bR(a);ng(a)}function Wk(a){Wh(a);jd(a);Wh(a)}function WD(a){a=a|0;$k(a);Wb(a)}function Vp(a){return Qb(a,0,48)}function Ve(a){nd(a);Kb(a);nd(a)}function UD(a){a=a|0;mo(a);Wb(a)}function Te(a,b){v[a>>2]=v[b>>2]}function TQ(a,b){lc(a,b+4|0,256)}function Rt(a){Mi(a);hg(a);Mi(a)}function Pl(a){xf(a);wc(a);xf(a)}function PW(a,b){a=a|0;b=b|0;L()}function PO(a){return w[a|0]<129}function Os(a){Kb(a);bL(a);ng(a)}function Nh(a){Ye(a);Cd(a);Ye(a)}function NW(a){a=a|0;return 5810}function NI(a){a=a|0;kx(a);Wb(a)}function MW(a){a=a|0;return 9047}function K0(a){a=a|0;return 6494}function Js(a){wc(a);eT(a);wp(a)}function JW(a){a=a|0;return 2206}function Ie(a){v[a>>2]=v[a>>2]+4}function Hn(a){oc(a);qB(a);Jn(a)}function Gq(a){ue(a);fD(a);dv(a)}function Gj(a){Yf(a);oc(a);Yf(a)}function Fy(a){v[a>>2]=v[a>>2]+8}function Eq(a){Ui(a);Ig(a);Ui(a)}function EJ(a){of(a);yJ(a);xJ(a)}function DS(a){Nl(a);Ni(a);Nl(a)}function DA(a){oc(a);fT(a);Jn(a)}function CJ(a){Kb(a);vJ(a);ng(a)}function Bj(a){v[a>>2]=v[a>>2]+6}function $u(a){a=a|0;Sq(a);Wb(a)}function z1(a){a=a|0;jH(a-88|0)}function um(a){return a<<24>>24}function uh(a,b,c){_e(a,c,13,b)}function rt(a,b){return GQ(a,b)}function rY(a){a=a|0;yb(453880)}function pY(a){a=a|0;Jc(453896)}function nj(a){return!v[a+4>>2]}function nY(a){a=a|0;yb(453912)}function me(a){a=a|0;return a|0}function lr(a){a=a|0;return 127}function lY(a){a=a|0;Jc(453928)}function jn(a){return sj(Md(a))}function jY(a){a=a|0;yb(453944)}function hY(a){a=a|0;Jc(453960)}function fY(a){a=a|0;yb(453976)}function dY(a){a=a|0;Jc(453992)}function cp(a){ze(a+12|0);RM(a)}function bf(a){yb(a+20|0);yb(a)}function _h(a,b){return a>>>b&1}function Zb(a,b){return Fe(a,b)}function WB(a,b){return TB(a,b)}function Vo(a){u[a+480214>>1]=0}function RK(a,b){return OK(a,b)}function Pj(a,b,c){$c(a,b,1<<c)}function Mh(a){return ue(a)&255}function Je(a,b){return _f(a,b)}function Jd(a,b){return bm(a,b)}function Gga(a){a=a|0;return 9}
function El(a){yb(a+12|0);nf(a)}function Di(a,b){return xu(a,b)}function Cv(a,b){return uf(a,b)}function Cu(a,b){return UB(a,b)}function Cl(a){yb(a+12|0);yb(a)}function BP(a,b){return Ci(b,a)}function zy(a,b){return b-a>>1}function yE(a){a=a|0;Wb(Mv(a))}function uV(a){a=a|0;Wb(YC(a))}function tX(a){a=a|0;Wb(Or(a))}function q0(a){a=a|0;Wb(nw(a))}function pZ(a){a=a|0;Wb(FE(a))}function oE(a){a=a|0;Wb(_g(a))}function kV(a){a=a|0;Wb(RC(a))}function kJ(a){a=a|0;Wb(lJ(a))}function js(a){return a>>>27^a}function jO(a){return a+4896|0}function jH(a){a=a|0;Wb(Pw(a))}function gs(a){a=a|0;Wb(sx(a))}function gZ(a){a=a|0;Wb(VE(a))}function fV(a){a=a|0;Wb(GC(a))}function dV(a){a=a|0;Wb(FC(a))}function cc(a,b){v[a+100>>2]=b}function c2(a){a=a|0;Wb(Vr(a))}function bE(a){a=a|0;Wb(Td(a))}function b4(a){a=a|0;Wb(ex(a))}function aE(a){a=a|0;Wb(Mf(a))}function _1(a){a=a|0;Wb(CH(a))}function YX(a){a=a|0;Wb($k(a))}function X1(a){a=a|0;Wb(AH(a))}function VR(a){return a+2466|0}function UX(a){a=a|0;Wb(mo(a))}function TY(a){a=a|0;Wb(CE(a))}function TI(a){a=a|0;Wb(UI(a))}function SY(a){a=a|0;Wb(BE(a))}function Rd(a,b){t[a|0]=w[b|0]}function QK(a,b,c){Ay(a,b,c,1)}function Lv(a){a=a|0;Wb(cr(a))}function LW(a){a=a|0;Wb(zv(a))}function Kv(a){a=a|0;Wb(ar(a))}function KW(a){a=a|0;Wb(Sq(a))}function H6(a){a=a|0;return 13}function H0(a){a=a|0;Wb(dG(a))}function GQ(a,b){return b-a>>2}function GI(a){a=a|0;Wb(HI(a))}function GD(){return(Ta()|0)>0}function G7(a){a=a|0;Wb(kx(a))}function FZ(a){a=a|0;Wb(IE(a))}function Ds(a,b){return a<<8|b}function D0(a){a=a|0;Wb(qw(a))}function vK(a){a=a|0;return 5}function ul(a,b){v[a+32>>2]=b}function tq(a){Nu(a);return a}function t7(a){a=a|0;return 6}function qj(a){return qd(a)^1}function qh(a){return id(a)^1}function qe(a){a=a|0;return 1}function pe(a){a=a|0;return 2}function nD(a){return a>>>0>8}function lE(a){a=a|0;return-1}function ih(a){BM(a);return a}function hc(a){a=a|0;return 0}function gn(a,b){v[a+36>>2]=b}function fy(a){en(a);return a}function ey(a){BC(a);return a}function en(a){py(a);return a}function ec(a,b){return a+b|0}function dO(a,b){Qb(a,0,b<<2)}function bt(a){return a+256|0}function _3(){return 19469312}function Vq(a,b){v[a+72>>2]=b}function UQ(a){a=a|0;return 7}function Sl(a){ru(a);return a}function Rk(a){return!v[a>>2]}function Pp(a){CB(a);return a}function Oi(a){eB(a);return a}function Nn(a){return a>>>0<5}function Ne(a,b){u[a+28>>1]=b}function It(a){Ik(a);return a}function Hq(a){a=a|0;return 4}function GA(a,b){return b-a|0}function DV(a){a=a|0;return 3}function yN(a){xN(a,v[a>>2])}function yJ(a){uJ(a,v[a>>2])}function vJ(a){rJ(a,v[a>>2])}function to(a,b){tg(a);tg(a)}function tn(a,b){v[a+8>>2]=b}function tQ(a,b,c){ax(a,b,c)}function rA(a,b){xf(a);xf(a)}function qB(a){LB(a,v[a>>2])}function pq(a,b){Yf(a);Yf(a)}function pA(a,b){Mi(a);Mi(a)}function oL(a){return a+80|0}function nC(a){mC(a,v[a>>2])}function lk(a,b){nd(a);nd(a)}function lH(a){v[a>>2]=79616}function jP(a,b){_e(a,b,8,2)}function iv(a,b){eD(a,ke(b))}function ho(a,b){Wh(a);Wh(a)}function gc(a){return a+12|0}function eT(a){$S(a,v[a>>2])}function dL(a){cL(a,v[a>>2])}function bl(a){return a+16|0}function bR(a){$B(a,v[a>>2])}function bL(a){KK(a,v[a>>2])}function ae(a,b){v[a+4>>2]=b}function _q(a,b){ro(a,b+4|0)}function Yt(a,b){Ye(a);Ye(a)}function YJ(a,b){lj(a);lj(a)}function Xu(a,b){Ui(a);Ui(a)}function Xg(a){return a+20|0}function WH(a){v[a>>2]=78864}function To(a,b){z[a+8>>2]=b}function TS(a){HS(a,v[a>>2])}function Ro(a,b){z[a+4>>2]=b}function RE(a){sE(a,v[a>>2])}function Qo(a,b){t[a+36|0]=b}function Pm(a){v[a>>2]=66688}function Oq(a,b,c){$c(a,b,c)}function Nx(a,b){t[a+37|0]=b}function Nr(a){v[a>>2]=79144}function Mx(a,b){t[a+38|0]=b}function Mp(a){v[a>>2]=72064}function ML(a){LL(a,v[a>>2])}function IN(a,b){FN(a,bc(b))}function IM(a){HM(a,v[a>>2])}function HN(a,b){FN(a,ac(b))}function GH(a){v[a>>2]=52016}function Fs(a,b){vy(a,ke(b))}function Fl(a,b){zb(b);zb(a)}function Dc(a,b){a=a|0;b=b|0}function Ce(a,b){t[a+11|0]=b}function CR(a){BR(a,v[a>>2])}function Bq(a,b){wh(a);wh(a)}function AR(a){zR(a,v[a>>2])}function zb(a){return a+8|0}function xL(a){Qb(a,0,1024)}function wha(){return 65534}function vp(a){Qb(a,0,4096)}function jc(a){return a+4|0}function cz(a){v[a+12>>2]=0}function bC(a,b){$c(a,b,22)}function Zo(a){Qb(a,0,8192)}function Zl(a,b){t[a+3|0]=b}function Zc(a){return a+1|0}function Sc(a){return!Db(a)}function Ph(a){return a+3|0}function OB(a,b){$c(a,b,20)}function O0(){return 453220}function Hg(a){return a&255}function Cf(a){return a+2|0}function Bla(){return 65535}function $3(){return 327693}function ze(a){Ve(a);xs(a)}function xp(a){Ye(a);Cd(a)}function xJ(a){jk(a);of(a)}function wp(a){xf(a);wc(a)}function wP(a){Ve(a);uP(a)}function vQ(a){Ve(a);rQ(a)}function vD(a){Wh(a);jd(a)}function uj(a,b){Pn(a,b,0)}function st(a){Fz(a,Ke(a))}function sq(a){Pl(a);rC(a)}function sk(a){yy(a,Ke(a))}function rB(a,b){Qh(a,2,b)}function pm(){Yi(7060);L()}function pR(a){Mi(a);hg(a)}function ng(a){nd(a);Kb(a)}function nf(a){Gj(a);dq(a)}function ld(){fe(3950);L()}function l0(){return 55368}function kp(a){Wk(a);SM(a)}function kM(a){gy(a,Ke(a))}function k0(){return 56144}function j0(){return 57696}function gd(a){fj(a);yC(a)}function fv(a){Eq(a);dD(a)}function eG(){Yi(3950);L()}function dv(a){wh(a);ue(a)}function dt(a){tg(a);xc(a)}function cd(a){Wk(a);zB(a)}function Yy(a,b){v[b>>2]=0}function Xy(a){Qb(a,0,512)}function UE(a){Ve(a);TE(a)}function So(a,b){z[a>>2]=b}function Sg(a){Pl(a);IA(a)}function SS(a){Nl(a);Ni(a)}function Qf(a){Eq(a);Dy(a)}function Oe(a,b){v[a>>2]=b}function Ob(a){jm(v[a>>2])}function NS(a){Rt(a);LS(a)}function NL(a){ws(a,Ke(a))}function Ml(a){Rt(a);Ft(a)}function Mc(a){a=a|0;Wb(a)}function MR(a){t[a+31|0]=0}function Jq(a){a=a|0;Kq(a)}function Jn(a){Yf(a);oc(a)}function JR(a){Xz(a,Ke(a))}function If(){fe(7060);L()}function Ic(a){v[a+8>>2]=0}function HK(a){Ix(a,Ke(a))}function ER(a){Zz(a,Ke(a))}function Dp(a){Gz(a,Ke(a))}function $w(a){Wk(a);hI(a)}function $d(a){Pl(a);rq(a)}function $J(a){lj(a);mf(a)}function wW(){return jb|0}function vW(a){a=a|0;jb=a}function fG(a){Qb(a,0,44)}function dR(a){Qb(a,0,33)}function aC(a){t[a+1|0]=3}function YD(a){Mw(a,8192)}function B3(){return 2048}function zn(a,b){cG(a,b)}function zh(a,b){$g(a,b)}function tN(a,b){wf(a,b)}function no(a,b){xE(a,b)}function mA(a){t[a|0]=16}function lf(a){Bb(a+8|0)}function kh(a){a=a|0;L()}function NP(a,b){gx(a,b)}function KM(a,b){HN(a,b)}function FR(a,b){Oc(a,b)}function Cc(a){Sg(a+8|0)}function Bk(a){yb(a+4|0)}function $t(a){v[a>>2]=0}function $A(a,b){eI(a,b)}function jf(a){t[a|0]=0}function vf(a){vy(a,0)}function us(a){uL(a,0)}function ts(a){tL(a,0)}function gg(a){KR(a,0)}function ad(a){pI(a,0)}function XK(a){GK(a,0)}function Sv(a,b){yb(b)}function Gh(a){bI(a,0)}function Gc(a){ve(a,0)}function Fq(a){eD(a,0)}function Ib(a){yb(a)}function He(a){a=a|0}function c_(){QE()}function ZZ(){PE()}function XZ(){OE()}function VZ(){NE()}function TZ(){ME()}function LZ(){LE()}function OW(){L()}
// EMSCRIPTEN_END_FUNCS
e=w;var nb=c([null,Dl,Ub,hq,zf,nma,yn,Gia,Xha,jj,bha,Zfa,kea,_r,Dl,QX,FU,_l,Eg,C0,$,yu,Pk,YV,zv,GV,se,pU,Yl,Pi,Zg,vc,Dc,Lb,Pi,uka,Lp,NR,$y,ph,fu,ega,LO,kh,qe,qe,Kja,Bja,Dt,xja,aP,aha,Wga,OW,GO,kh,qe,hc,qe,qia,mia,fia,$ha,Wha,Dga,Fha,zga,qha,nha,me,kh,YN,Yda,xda,pN,Zs,iN,GN,DN,Ps,$ca,Da,Qca,Uc,Uc,Kca,uy,Cba,vba,aY,Uc,pba,oba,KL,vc,Wm,hh,Uc,$X,kba,bda,aba,dba,Vaa,Raa,He,O8,Dc,yaa,KL,Tl,Uq,UW,WW,Dl,B8,E7,Ko,Tl,s6,zf,Ub,l6,KE,J5,y5,n5,E0,S2,U4,J4,o4,jI,jI,Z3,R3,Wr,hq,Ur,x3,q3,Ur,T1,O1,G1,A1,Ur,Ur,C2,t2,LX,Y0,W0,S0,NX,IX,HX,Uw,KX,yX,Dl,M0,Zs,F0,z0,XF,$n,Dl,w$,tr,Us,L$,G$,vc,Uv,fF,SE,vc,vc,fu,io,dW,cW,aW,eW,Dc,bW,Dc,$y,Oea,$V,_V,ZV,XV,Bi,VV,o0,i0,UV,pD,oD,TV,tr,SV,QV,lv,Jq,Xi,Kc,MV,nm,LV,KV,OV,JV,IV,RV,Dea,PV,mD,HV,FV,lD,EV,Hf,Kj,Nc,gv,Rb,zV,Jj,gv,yV,xV,wV,Sq,nV,mV,Uc,vc,LC,yD,vV,oV,Vh,Uc,lV,Uc,Dc,iV,hV,gV,Pi,$u,Dt,YC,uV,ao,tI,tV,Mc,sV,qe,qe,Dt,Mz,rV,aP,qV,pV,RC,kV,ao,jV,Mc,hc,qe,qe,hc,hc,QC,GC,fV,ao,eV,FC,dV,cV,bV,aV,$U,_U,ZU,YU,XU,pv,$e,Lb,SU,naa,RU,maa,QU,Qu,_b,qaa,TC,td,PU,hh,XW,vc,Wm,OC,SE,Dc,CC,MU,LU,$u,vc,vc,vc,qC,JU,IU,Dc,Dc,Dc,HU,fu,$y,io,wU,hh,EU,BU,vU,Dc,qC,XB,uU,Au,tU,oU,nU,wu,Wl,Dc,iU,EB,hU,gU,fU,eU,Cg,Ec,dU,cU,bU,aU,$T,zg,dg,Og,_T,qu,DB,BB,AB,vc,ZT,Wm,vc,vc,WT,YT,Dc,XT,wu,lB,jB,TT,ST,RT,QT,PT,Dg,OT,NT,MT,LT,Ow,eJ,Eb,hO,KT,AV,jg,JT,su,bB,dd,Id,Xi,mj,GT,FT,Ri,yq,th,fL,ET,DT,ku,pc,zc,hv,CT,aB,Zd,nu,qp,Eb,Lp,GU,AT,Eb,QB,zT,yT,mq,Bf,tu,tT,HA,iD,vi,Af,Nb,ig,sT,bu,rT,Kc,Zp,Nda,qT,pT,op,oT,FA,EA,sd,nT,au,mT,J9,Mn,Ln,sl,Bx,kK,mma,jT,bJ,lma,kma,jma,Gk,BA,ima,hma,nq,hT,gma,fma,Fg,ema,dma,YN,bma,ama,vc,Xt,$la,Xt,_la,pN,Zs,iN,Gn,Xp,Wp,vc,Dc,Ps,Xla,Wla,Vla,Sla,zA,Rla,tA,Qla,Pla,Ola,Wt,Nla,pp,Vy,Mla,Lla,Kla,Jla,yf,Wf,Ila,Hla,Gla,Ala,zla,yla,Wp,qA,Dla,Lp,Sp,MS,Ela,vc,vc,Cla,Dc,io,Gn,Dc,vj,Rp,vla,Nt,ula,rla,HA,Qp,qla,Ot,Wy,FA,pla,Vl,ola,nla,wS,mla,lla,kG,Ul,mt,kla,Vda,hT,jla,ila,kg,sS,Gn,Xp,Wp,vc,hla,gla,sS,iS,oK,P9,lK,dS,$ka,Zka,sh,Wka,Vka,Jaa,Rka,Qka,Pka,Oka,Ju,Nka,Mka,Lka,Hf,zU,Kka,Xfa,Yfa,Jka,Ika,Yka,xn,CU,Hka,rp,AU,ZR,Gka,Fka,bba,Vc,Eka,Dka,YR,Cka,sU,Bka,Aka,zka,XR,yka,dz,xka,wka,yU,VS,Xka,vka,UR,tka,eA,DN,lC,jq,ska,rka,Im,Faa,qka,pka,SR,SR,dA,qA,bA,cl,oka,lX,nka,mka,lka,kka,mh,Lda,mh,v9,jka,Z8,PR,vc,_ja,Vi,zd,wn,eka,dka,Yja,UA,jo,oi,vc,Sz,Xja,Wja,OR,ika,hka,wf,gka,Hi,Et,_8,Maa,Q8,fka,hq,cka,bka,aka,Uc,Fk,Uc,Yz,me,IR,Ck,me,Dc,Dc,Dc,$ja,hh,zt,Zja,Sja,Rja,Qja,Dn,Pja,Oja,hD,Nja,dd,Qk,Mja,Lja,Jja,Ija,Hja,Gja,Fja,Eja,Dja,Cja,vc,vja,uja,Aja,zja,yja,Dc,Nz,Gn,$Q,wja,vc,VQ,xn,rja,qja,pja,oja,Zda,Hf,nja,mja,lja,kja,pS,UN,Jb,xt,Lz,hA,Au,jja,ija,SQ,hja,nq,lq,Gt,sA,gja,Fj,fja,hq,Hf,mu,Hf,Ru,iq,eja,Hi,QQ,Qda,wx,PQ,Ep,vc,Fk,Uc,vc,Dc,dja,hh,zt,me,Dc,cja,wu,lB,bja,Ck,_ia,Zia,Vi,Yia,Xia,Cz,pt,Wia,Via,Uia,Tia,Sia,Ria,GB,Qia,Pia,Eb,Oia,Nia,Mia,Lia,Wfa,Uca,QC,Kia,Eb,ot,Z0,$z,_0,ot,Jia,Iia,$0,a1,Gaa,Hia,RR,QR,Ry,Bi,sQ,Fia,Eia,Dia,Cia,vc,zt,vc,Bia,io,Pi,Dc,jB,Ut,nt,Hk,oi,Hf,Rp,sia,ria,zia,Tz,Dc,nia,bB,ZA,lia,Haa,kia,jia,bK,wn,iia,QP,hia,gia,Hu,Gu,kt,Dba,eia,dia,Ys,cia,In,bia,aia,mz,gq,vc,Dc,_ha,Zha,LC,Hf,Sha,lg,Rha,Uc,Qha,Pha,CP,Uc,kq,Oha,Lha,Kha,Jk,kn,kt,Vc,Jha,O9,sQ,vP,vc,zt,Dc,Hha,hh,Dha,Cha,tA,EP,oP,nu,Bha,Aha,zha,xha,Bla,wha,vha,uha,gt,tha,sha,gt,rha,NA,lP,pha,DU,vc,iha,fha,eha,Rp,lha,kha,jha,vc,Gn,hha,Xp,Wp,gha,dP,cP,fz,vc,$ga,xn,_ga,Xga,kO,QP,xn,Wca,Vca,Tga,Oga,Nga,_S,hv,Mga,Lga,Kga,Jga,Iga,tt,Hga,Fga,Ega,Cga,Bga,Aga,vc,xga,wga,uga,yga,Dc,vga,vc,vc,eO,rga,lz,qga,pga,Rda,mga,lga,jaa,kga,jga,iga,haa,hga,iaa,kaa,gga,fga,dga,WV,sD,Uda,tz,Saa,Paa,_y,cga,bga,vc,Zy,aga,hh,Dc,lO,$fa,Vfa,Ufa,Tfa,Sfa,Rfa,Qfa,Pfa,Ofa,Nfa,Mfa,Lfa,Kfa,Jfa,Ifa,Hfa,Gfa,Ffa,Efa,Dfa,Cfa,Bfa,Afa,zfa,yfa,xfa,wfa,vfa,ufa,tfa,sfa,rfa,qfa,pfa,ofa,nfa,mfa,lfa,kfa,jfa,ifa,hfa,gfa,ffa,efa,dfa,cfa,bfa,afa,$ea,_ea,Zea,Yea,Xea,Wea,Vea,Uea,Tea,Sea,Rea,Qea,Pea,Nea,Mea,Lea,Kea,Jea,Iea,Hea,Gea,Fea,Eea,Cea,Bea,Aea,zea,yea,xea,wea,vea,uea,tea,sea,rea,qea,pea,oea,nea,mea,lea,jea,iea,hea,gea,fea,eea,dea,cea,bea,aea,Xda,VN,$da,Fk,Uc,vc,Wl,Ck,Bda,Dj,Sda,Tda,pB,EN,Oda,vc,zda,Mda,uN,yda,Kda,Jda,Ida,Hda,Gda,BN,Fda,Eda,Dda,Cda,OR,Vs,wda,Ada,vN,vc,jN,Uc,vda,Uc,tda,sda,rda,bN,qda,TA,pda,yD,oda,_M,vaa,nda,mda,ps,taa,lda,saa,raa,kda,jda,ida,hda,fda,eda,vc,vc,gda,Dc,vc,dda,Dc,tk,vc,Zca,Yca,_ca,Xca,Lw,b1,Ok,Tca,Naa,wj,Wda,QN,Sca,Rca,Wl,Wl,Zs,lD,Fk,Uc,Uv,fF,me,Ck,vc,TR,Vd,FB,KU,Ze,BT,Oca,Nca,Eb,Fla,Mca,Lca,Jca,Ica,Hca,Gca,Fca,Eca,Dca,Cca,Bca,Aca,zca,yca,xca,wca,vca,uca,tca,sca,rca,qca,pca,oca,nca,mca,lca,kca,jca,ica,hca,gca,fca,eca,dca,cca,bca,aca,$ba,_ba,Zba,Yba,Xba,Wba,Vba,Uba,Tba,Sba,Rba,Qba,Pba,Oba,Nba,Mba,Lba,Kba,Jba,Iba,Hba,Gba,Fba,Eba,Bba,cda,Aba,zba,yba,NM,MM,xba,wba,bn,Gs,sy,uba,yM,$s,hp,xM,UK,gL,Sx,gp,Es,fp,tba,sM,ZN,aO,sba,rba,Hi,Et,Ep,hN,Hy,yi,Hi,QQ,qba,Ep,ada,vc,nba,mba,Fk,Uc,Uc,Fk,Uc,vc,Dc,me,IL,lba,Ck,me,jba,Ck,hba,Pda,_fa,gba,qL,zL,Aaa,fba,eba,Pe,Uc,Uc,vc,cba,$aa,CV,WU,UU,OU,Zaa,NU,VU,BV,TU,mn,Yaa,_da,pL,Wo,Xaa,S7,Waa,by,laa,vc,uda,vc,Wm,hh,Uc,Qaa,Oaa,m9,q9,Laa,o9,l9,Uc,Uc,Uy,Kaa,WN,vc,vc,Eaa,Daa,Caa,Dc,oga,nga,Tka,Ska,Zga,Yga,Sga,Rga,tja,sja,Yha,Vha,Uja,Tja,vT,uT,fla,ela,VT,UT,IT,HT,Uha,Tha,dha,cha,tga,sga,Ula,Tla,xla,wla,mU,lU,kU,jU,Gha,Eha,oha,mha,pia,oia,Vja,lR,dla,cla,bla,ala,Zla,Yla,tla,sla,Nha,Mha,gaa,faa,R9,Q9,uia,tia,Vga,Uga,Qga,Pga,Aia,wia,via,rU,qU,xT,wT,aja,$ia,yia,xia,xaa,vc,Wm,hh,waa,Fk,Uc,AL,Dc,Yz,Ck,lO,uaa,Hx,Rs,oaa,paa,EM,eaa,daa,tA,caa,Zt,baa,oP,aaa,$9,_9,Rp,Z9,Y9,Hf,X9,W9,V9,U9,T9,lP,S9,g1,d1,c1,vc,Gn,Xp,Wp,N9,M9,L9,Sz,I9,C9,mh,G9,F9,mh,E9,Jf,$g,_k,D9,B9,A9,u9,z9,K9,y9,s9,r9,w9,H9,t9,zx,vc,Cp,vc,UJ,vc,Fk,Uc,b9,hh,$8,ux,Hi,Et,n9,m7,a9,j9,i9,mh,h9,g9,f9,SJ,p9,Oo,BN,e9,wf,QJ,c9,Mj,fr,$g,Zy,IR,Ck,Y8,X8,W8,V8,U8,T8,$i,S8,R8,d9,k9,GJ,P8,M8,L8,K8,_7,J8,I8,wJ,t8,Nf,hh,PJ,s8,q8,r8,Dc,Zy,Dc,sx,gs,gs,y8,hc,He,hc,hc,hc,Dc,Hq,D8,E8,G8,F8,H8,si,rx,rx,qx,qx,qx,cma,He,lR,x8,w8,v8,u8,C8,ri,zJ,Z7,hc,hc,qe,px,pe,pe,qe,A8,z8,Dc,He,Dc,He,o8,a8,lJ,kJ,kJ,$7,hc,He,hc,hc,hc,Dc,Gga,qJ,m8,c8,b8,n8,si,k8,j8,i8,h8,g8,f8,e8,d8,l8,ri,pJ,hc,hc,qe,pe,pe,qe,nJ,mJ,W7,V7,dJ,vc,vc,rf,kh,X7,cJ,Y7,hc,U7,T7,R7,Us,Q7,P7,O7,N7,Uc,hh,Vs,vc,Wm,Dc,M7,A7,s7,k7,d7,Y6,P6,G6,z6,N8,p8,aJ,kx,G7,$I,F7,hc,He,hc,hc,hc,Dc,UQ,J7,K7,L7,si,I7,ri,H7,hc,hc,qe,pe,pe,Dc,He,_I,D7,C7,ZI,B7,YI,XI,z7,UI,TI,TI,u7,hc,He,hc,hc,hc,Dc,t7,w7,x7,y7,si,v7,ri,VI,hc,hc,qe,pe,pe,r7,ik,ik,l7,hc,He,hc,hc,hc,Dc,vK,o7,p7,q7,si,n7,ri,QI,hc,hc,qe,pe,pe,j7,sx,gs,gs,e7,hc,He,hc,hc,hc,Dc,vK,g7,h7,i7,si,f7,ri,OI,hc,hc,qe,pe,pe,c7,NI,NI,a7,UQ,b7,_I,$6,_6,ZI,Z6,YI,XI,X6,ik,ik,S6,hc,He,hc,hc,hc,Dc,pe,U6,V6,W6,si,T6,ri,R6,hc,hc,qe,pe,pe,O6,Q6,HI,GI,GI,J6,hc,He,hc,hc,I6,Dc,H6,L6,M6,N6,si,K6,ri,hx,hc,hc,qe,pe,pe,Dc,He,F6,ik,ik,A6,hc,He,hc,hc,hc,Dc,DV,C6,D6,E6,si,B6,ri,DI,hc,hc,qe,pe,pe,y6,ik,ik,t6,hc,He,hc,hc,hc,Dc,Hq,v6,w6,x6,si,u6,ri,AI,hc,hc,qe,pe,pe,$3,q6,g4,S3,_3,Y3,G3,lv,E3,Zr,qI,A3,f6,e6,Uc,Uc,B3,y3,w3,v3,me,ha,b6,a6,qI,u3,s3,mI,Z5,ex,NH,Mz,c3,b3,f3,$2,a3,d3,fx,r3,I5,gI,p3,o3,n3,m3,l3,k3,j3,i3,h3,g3,_2,fx,U2,T2,R2,Q2,P2,O2,N2,M2,L2,K2,J2,I2,H2,G2,Go,F2,E2,ol,Rr,D2,ID,B2,z2,y2,x2,w2,v2,u2,Xw,s2,r2,p2,o2,n2,l2,k2,i2,g2,e2,K3,_H,ZH,YH,XH,D1,C1,mI,fx,z4,y4,x4,w4,v4,u4,t4,s4,r4,q4,p4,n4,m4,l4,k4,j4,i4,h4,f4,c4,dx,e4,d4,iI,a4,iI,b4,gD,Xr,X3,Pca,Iq,BB,V3,vc,V1,T3,zH,S1,Hs,N3,vc,IL,R1,iba,J3,JD,eO,Uc,Uc,Uc,j2,d2,h2,f2,_aa,M3,W3,Q3,Tu,Hi,Et,Ep,Fu,H3,Baa,zaa,F3,dI,cI,C3,z3,D3,Uc,L3,I3,O3,Uc,Uc,Uc,Eb,fc,t3,e3,Uc,Uc,lL,Z2,Y2,X2,E1,Taa,Uaa,P3,Iaa,W2,V2,Nm,KH,x9,A2,rj,aK,q2,Bf,hL,nK,mK,m2,vc,$1,Y1,Iha,yha,U1,Dc,F1,vc,kh,Vr,c2,U3,me,kh,me,Mc,b2,a2,kh,CH,_1,ao,Z1,AH,X1,ao,W1,Mc,Q1,me,Mc,P1,N1,Mc,uH,tH,kh,Mc,M1,L1,Mc,sH,rH,Mc,K1,J1,Mc,qH,oH,Mc,I1,H1,Mc,nH,mH,Pw,jH,y1,x1,iH,hH,gH,fH,eH,dH,cH,bH,aH,$G,_G,ZG,YG,WG,VG,UG,B1,z1,w1,v1,u1,t1,s1,r1,q1,p1,o1,n1,m1,l1,k1,j1,i1,h1,me,kh,me,kh,f1,e1,X0,V0,P0,U0,T0,R0,Q0,He,G0,I0,dG,me,Mc,K0,A0,y0,x0,J0,H0,qw,D0,me,kh,kh,B0,r0,SW,aG,nw,Mc,w0,v0,Mc,u0,s0,t0,q0,p0,cw,dh,ch,vr,Wb,Gv,wo,gj,ck,aw,fl,vo,bk,$$,De,ci,vg,Z$,X$,DF,DF,T$,sr,R$,CF,di,P$,N$,Ac,ge,K$,n0,fw,Yv,Xv,dh,ch,rr,qr,ak,el,Pk,Cm,$j,ci,vg,pr,zF,di,vF,u$,Zj,p$,o$,vo,m0,iw,N0,sF,j$,nr,uo,Yl,e$,zm,vo,gw,He,O_,mr,N_,M_,eF,L_,dF,vo,J_,$n,H_,G_,Xj,F_,$E,dF,D_,VW,B_,A_,x_,w_,hw,s_,r_,q_,p_,o_,n_,m_,l_,k_,j_,i_,h_,g_,f_,e_,d_,c_,b_,a_,$Z,_Z,ZZ,YZ,XZ,WZ,VZ,UZ,TZ,SZ,RZ,QZ,PZ,OZ,NZ,MZ,LZ,KZ,JZ,IZ,Tv,wE,CZ,GZ,cY,HZ,bY,me,EZ,DZ,BZ,l0,k0,j0,LF,dk,KF,xo,bZ,aZ,JF,IF,HF,JY,IY,GY,FY,DY,CY,AY,zY,xY,wY,uY,tY,rY,Ov,pY,nY,lY,jY,hY,fY,dY,IE,FZ,$I,FE,pZ,oZ,nZ,mZ,lZ,yB,kZ,jZ,iZ,VE,gZ,fZ,eZ,dZ,cZ,hc,$Y,_Y,CE,TY,RY,QY,KH,OY,MY,BE,SY,Mz,xU,PY,NY,LY,me,Mc,Mc,AZ,zZ,yZ,xZ,wZ,vZ,uZ,tZ,yB,sZ,rZ,qZ,Mc,EE,EE,Qv,qe,qe,hZ,qe,Mc,ZY,YY,Qv,hc,hc,XY,Hq,Mc,WY,VY,Qv,hc,hc,UY,Hq,me,Mc,h0,g0,f0,me,Mc,e0,d0,c0,Mc,b0,a0,_$,Y$,W$,V$,U$,S$,Q$,O$,M$,Mc,J$,I$,H$,F$,E$,D$,C$,B$,A$,z$,y$,Mc,x$,v$,t$,s$,r$,q$,n$,m$,Mc,l$,k$,i$,h$,g$,f$,d$,c$,me,Mc,pe,b$,a$,$_,__,Z_,Y_,KY,EY,yY,kY,gY,sY,oY,me,Mc,pe,X_,W_,V_,U_,T_,S_,HY,BY,vY,iY,eY,qY,mY,Mv,yE,R_,Mv,yE,Q_,Mc,lr,lr,Vj,Vj,Vj,hF,hc,Uj,Uj,Mc,lr,lr,Vj,Vj,Vj,hF,hc,Uj,Uj,Mc,ys,ys,Vj,kr,kr,gF,hc,Uj,Uj,Mc,ys,ys,Vj,kr,kr,gF,hc,Uj,Uj,Mc,P_,K_,Mc,I_,E_,Mc,C_,z_,Mc,y_,v_,Mc,WE,u_,Dc,Mc,WE,t_,Dc,wr,MF,Xm,PX,MX,ZX,OX,JX,AX,GX,Zv,FX,_ka,Uka,jS,EX,Xm,Eg,DX,CX,BX,AX,zX,$k,YX,Dc,Dl,nE,mE,hc,hc,XX,lE,WX,dr,VX,dr,mo,UX,Dc,Dl,nE,mE,hc,hc,TX,lE,SX,dr,RX,dr,cr,Lv,jE,iE,cr,Lv,jE,iE,ar,Kv,eE,dE,ar,Kv,eE,dE,Or,tX,uX,sX,xX,wX,vX,_g,oE,_g,oE,Td,bE,rX,qX,Mf,aE,pX,oX,NV,Mc,_X,hc,nX,mX,kX,Pr,Pr,Hv,Dv,br,gE,WD,jX,iX,hX,gX,UD,fX,eX,dX,cX,WD,bX,RD,aX,$W,UD,_W,RD,ZW,YW,QD,PD,Qj,XF,hc,hc,hc,TW,RW,QW,xa,PW,Mc,MW,Mc,NW,LW,Dt,KW,yv,yv,yv,$u,Mc,JW,me,Mc,He,He,IW,zW,CW,HW,Mc,AW,DW,GW,Mc,BW,EW,FW]);function ob(){return s.byteLength/65536|0}function tb(ub){ub=ub|0;var pb=ob()|0;var qb=pb+ub|0;if(pb<qb&&qb<65536){var rb=new ArrayBuffer(B(qb,65536));var sb=new Int8Array(rb);sb.set(t);t=new Int8Array(rb);u=new Int16Array(rb);v=new Int32Array(rb);w=new Uint8Array(rb);x=new Uint16Array(rb);y=new Uint32Array(rb);z=new Float32Array(rb);A=new Float64Array(rb);s=rb;r.buffer=s;e=w}return pb}return{"ya":lT,"za":nb,"Aa":r6,"Ba":p6,"Ca":Mc,"Da":Wb,"Ea":o6,"Fa":n6,"Ga":m6,"Ha":Zr,"Ia":Dc,"Ja":k6,"Ka":j6,"La":i6,"Ma":rx,"Na":h6,"Oa":tI,"Pa":g6,"Qa":me,"Ra":sI,"Sa":rI,"Ta":sI,"Ua":d6,"Va":uW,"Wa":tW,"Xa":sW,"Ya":c6,"Za":oI,"_a":$5,"$a":nI,"ab":_5,"bb":Y5,"cb":X5,"db":W5,"eb":V5,"fb":U5,"gb":T5,"hb":S5,"ib":R5,"jb":Q5,"kb":P5,"lb":O5,"mb":N5,"nb":M5,"ob":L5,"pb":K5,"qb":H5,"rb":G5,"sb":F5,"tb":E5,"ub":D5,"vb":C5,"wb":B5,"xb":A5,"yb":z5,"zb":x5,"Ab":w5,"Bb":v5,"Cb":u5,"Db":t5,"Eb":s5,"Fb":r5,"Gb":q5,"Hb":p5,"Ib":o5,"Jb":m5,"Kb":l5,"Lb":k5,"Mb":j5,"Nb":i5,"Ob":h5,"Pb":g5,"Qb":f5,"Rb":e5,"Sb":d5,"Tb":c5,"Ub":b5,"Vb":a5,"Wb":$4,"Xb":_4,"Yb":Z4,"Zb":Y4,"_b":X4,"$b":W4,"ac":V4,"bc":T4,"cc":S4,"dc":R4,"ec":Q4,"fc":P4,"gc":O4,"hc":N4,"ic":M4,"jc":rW,"kc":L4,"lc":K4,"mc":I4,"nc":H4,"oc":qW,"pc":G4,"qc":F4,"rc":E4,"sc":D4,"tc":C4,"uc":B4,"vc":A4,"wc":kd,"xc":O0,"yc":wW,"zc":vW,"Ac":L0,"Bc":yW,"Cc":xW,"Dc":pW,"Ec":oW,"Fc":nW,"Gc":mW,"Hc":lW,"Ic":kW,"Jc":jW,"Kc":iW,"Lc":hW,"Mc":gW,"Nc":fW}}return vb(xb)}
// EMSCRIPTEN_END_ASM




)(asmLibraryArg);
  },

  instantiate: /** @suppress{checkTypes} */ function(binary, info) {
    return {
      then: function(ok) {
        var module = new WebAssembly.Module(binary);
        ok({
          'instance': new WebAssembly.Instance(module)
        });
        // Emulate a simple WebAssembly.instantiate(..).then(()=>{}).catch(()=>{}) syntax.
        return { catch: function() {} };
      }
    };
  },

  RuntimeError: Error
};

// We don't need to actually download a wasm binary, mark it as present but empty.
wasmBinary = [];


